/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],te=function(x){for(var e=[],I=0,L=x.length;I<L;I++)e[I]=ee[x[I]];return e};define(ee[127],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(k,f){const u=Math.pow(10,f);return Math.round(k*u)/u}class L{constructor(f,u,p,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=I(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.RGBA=L;class s{constructor(f,u,p,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,u),0),3),this.l=I(Math.max(Math.min(1,p),0),3),this.a=I(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,p=f.g/255,y=f.b/255,b=f.a,d=Math.max(u,p,y),E=Math.min(u,p,y);let v=0,r=0;const g=(E+d)/2,h=d-E;if(h>0){switch(r=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),d){case u:v=(p-y)/h+(p<y?6:0);break;case p:v=(y-u)/h+2;break;case y:v=(u-p)/h+4;break}v*=60,v=Math.round(v)}return new s(v,r,g,b)}static i(f,u,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?f+(u-f)*6*p:p<1/2?u:p<2/3?f+(u-f)*(2/3-p)*6:f}static toRGBA(f){const u=f.h/360,{s:p,l:y,a:b}=f;let d,E,v;if(p===0)d=E=v=y;else{const r=y<.5?y*(1+p):y+p-y*p,g=2*y-r;d=s.i(g,r,u+1/3),E=s.i(g,r,u),v=s.i(g,r,u-1/3)}return new L(Math.round(d*255),Math.round(E*255),Math.round(v*255),b)}}e.HSLA=s;class A{constructor(f,u,p,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=I(Math.max(Math.min(1,u),0),3),this.v=I(Math.max(Math.min(1,p),0),3),this.a=I(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,p=f.g/255,y=f.b/255,b=Math.max(u,p,y),d=Math.min(u,p,y),E=b-d,v=b===0?0:E/b;let r;return E===0?r=0:b===u?r=((p-y)/E%6+6)%6:b===p?r=(y-u)/E+2:r=(u-p)/E+4,new A(Math.round(r*60),v,b,f.a)}static toRGBA(f){const{h:u,s:p,v:y,a:b}=f,d=y*p,E=d*(1-Math.abs(u/60%2-1)),v=y-d;let[r,g,h]=[0,0,0];return u<60?(r=d,g=E):u<120?(r=E,g=d):u<180?(g=d,h=E):u<240?(g=E,h=d):u<300?(r=E,h=d):u<=360&&(r=d,h=E),r=Math.round((r+v)*255),g=Math.round((g+v)*255),h=Math.round((h+v)*255),new L(r,g,h,b)}}e.HSVA=A;class R{static fromHex(f){return R.Format.CSS.parseHex(f)||R.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof L)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof A)this.j=f,this.rgba=A.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&L.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&A.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=R.k(this.rgba.r),u=R.k(this.rgba.g),p=R.k(this.rgba.b),y=.2126*f+.7152*u+.0722*p;return I(y,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u>p?(u+.05)/(p+.05):(p+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u>p}isDarkerThan(f){const u=this.getRelativeLuminance(),p=f.getRelativeLuminance();return u<p}lighten(f){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:p,b:y,a:b}=this.rgba;return new R(new L(u,p,y,b*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,p=this.rgba.a,y=u.a,b=p+y*(1-p);if(b<1e-6)return R.transparent;const d=this.rgba.r*p/b+u.r*y*(1-p)/b,E=this.rgba.g*p/b+u.g*y*(1-p)/b,v=this.rgba.b*p/b+u.b*y*(1-p)/b;return new R(new L(d,E,v,b))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:p,b:y,a:b}=this.rgba;return new R(new L(f.rgba.r-b*(f.rgba.r-u),f.rgba.g-b*(f.rgba.g-p),f.rgba.b-b*(f.rgba.b-y),1))}flatten(...f){const u=f.reduceRight((p,y)=>R.o(y,p));return R.o(this,u)}static o(f,u){const p=1-f.rgba.a;return new R(new L(p*u.rgba.r+f.rgba.a*f.rgba.r,p*u.rgba.g+f.rgba.a*f.rgba.g,p*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(f,u,p){if(f.isLighterThan(u))return f;p=p||.5;const y=f.getRelativeLuminance(),b=u.getRelativeLuminance();return p=p*(b-y)/b,f.lighten(p)}static getDarkerColor(f,u,p){if(f.isDarkerThan(u))return f;p=p||.5;const y=f.getRelativeLuminance(),b=u.getRelativeLuminance();return p=p*(y-b)/y,f.darken(p)}}R.white=new R(new L(255,255,255,1)),R.black=new R(new L(0,0,0,1)),R.red=new R(new L(255,0,0,1)),R.blue=new R(new L(0,0,255,1)),R.green=new R(new L(0,255,0,1)),R.cyan=new R(new L(0,255,255,1)),R.lightgrey=new R(new L(211,211,211,1)),R.transparent=new R(new L(0,0,0,0)),e.Color=R,function(k){let f;(function(u){let p;(function(y){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}y.formatRGB=b;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=d;function E(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}y.formatHSL=E;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function r(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}`}y.formatHex=g;function h(t,l=!1){return l&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}${r(Math.round(t.rgba.a*255))}`}y.formatHexA=h;function S(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}y.format=S;function w(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),a=16*C(t.charCodeAt(5))+C(t.charCodeAt(6));return new k(new L(i,n,a,1))}if(l===9){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),a=16*C(t.charCodeAt(5))+C(t.charCodeAt(6)),c=16*C(t.charCodeAt(7))+C(t.charCodeAt(8));return new k(new L(i,n,a,c/255))}if(l===4){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),a=C(t.charCodeAt(3));return new k(new L(16*i+i,16*n+n,16*a+a))}if(l===5){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),a=C(t.charCodeAt(3)),c=C(t.charCodeAt(4));return new k(new L(16*i+i,16*n+n,16*a+a,(16*c+c)/255))}return null}y.parseHex=w;function C(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=u.CSS||(u.CSS={}))})(f=k.Format||(k.Format={}))}(R=e.Color||(e.Color={})),e.Color=R}),define(ee[55],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(R){return(k,f,u)=>{let p=null,y=null;if(typeof u.value=="function"?(p="value",y=u.value):typeof u.get=="function"&&(p="get",y=u.get),!y)throw new Error("not supported");u[p]=R(y,f)}}function L(R,k,f){let u=null,p=null;if(typeof f.value=="function"?(u="value",p=f.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",p=f.get),!p)throw new Error("not supported");const y=`$memoize$${k}`;f[u]=function(...b){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,b)}),this[y]}}e.memoize=L;function s(R,k,f){return I((u,p)=>{const y=`$debounce$${p}`,b=`$debounce$result$${p}`;return function(...d){this[b]||(this[b]=f?f():void 0),clearTimeout(this[y]),k&&(this[b]=k(this[b],...d),d=[this[b]]),this[y]=setTimeout(()=>{u.apply(this,d),this[b]=f?f():void 0},R)}})}e.debounce=s;function A(R,k,f){return I((u,p)=>{const y=`$throttle$timer$${p}`,b=`$throttle$result$${p}`,d=`$throttle$lastRun$${p}`,E=`$throttle$pending$${p}`;return function(...v){if(this[b]||(this[b]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),k&&(this[b]=k(this[b],...v)),this[E])return;const r=this[d]+R;r<=Date.now()?(this[d]=Date.now(),u.apply(this,[this[b]]),this[b]=f?f():void 0):(this[E]=!0,this[y]=setTimeout(()=>{this[E]=!1,this[d]=Date.now(),u.apply(this,[this[b]]),this[b]=f?f():void 0},r-Date.now()))}})}e.throttle=A}),define(ee[13],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?w.isErrorNoTelemetry(l)?new w(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(i=>{i(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}e.ErrorHandler=I,e.errorHandler=new I;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function s(t){if(!t||typeof t!="object")return!1;const l=t;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=s;function A(t){u(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function R(t){u(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function k(t){if(t instanceof Error){const{name:l,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:l,message:i,stack:n,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const f="Canceled";function u(t){return t instanceof p?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=u;class p extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=p;function y(){const t=new Error(f);return t.name=t.message,t}e.canceled=y;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function E(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function v(t){const l=new Error(`${t} has been disposed`);return l.name="DISPOSED",l}e.disposed=v;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class g extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}e.NotImplementedError=g;class h extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}e.NotSupportedError=h;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class w extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof w)return l;const i=new w;return i.message=l.message,i.stack=l.stack,i}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class C extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(ee[22],te([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(B,z=0){return B[B.length-(1+z)]}e.tail=L;function s(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=s;function A(B,z,G=(re,he)=>re===he){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let re=0,he=B.length;re<he;re++)if(!G(B[re],z[re]))return!1;return!0}e.equals=A;function R(B,z){const G=B.length-1;z<G&&(B[z]=B[G]),B.pop()}e.removeFastWithoutKeepingOrder=R;function k(B,z,G){return f(B.length,re=>G(B[re],z))}e.binarySearch=k;function f(B,z){let G=0,re=B-1;for(;G<=re;){const he=(G+re)/2|0,be=z(he);if(be<0)G=he+1;else if(be>0)re=he-1;else return he}return-(G+1)}e.binarySearch2=f;function u(B,z){let G=0,re=B.length;if(re===0)return 0;for(;G<re;){const he=Math.floor((G+re)/2);z(B[he])?re=he:G=he+1}return G}e.findFirstInSorted=u;function p(B,z,G){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const re=z[Math.floor(z.length*Math.random())],he=[],be=[],ke=[];for(const Le of z){const Oe=G(Le,re);Oe<0?he.push(Le):Oe>0?be.push(Le):ke.push(Le)}return B<he.length?p(B,he,G):B<he.length+ke.length?ke[0]:p(B-(he.length+ke.length),be,G)}e.quickSelect=p;function y(B,z){const G=[];let re;for(const he of B.slice(0).sort(z))!re||z(re[0],he)!==0?(re=[he],G.push(re)):re.push(he);return G}e.groupBy=y;function b(B,z,G){const re=[];function he(Le,Oe,Fe){if(Oe===0&&Fe.length===0)return;const me=re[re.length-1];me&&me.start+me.deleteCount===Le?(me.deleteCount+=Oe,me.toInsert.push(...Fe)):re.push({start:Le,deleteCount:Oe,toInsert:Fe})}let be=0,ke=0;for(;;){if(be===B.length){he(be,0,z.slice(ke));break}if(ke===z.length){he(be,B.length-be,[]);break}const Le=B[be],Oe=z[ke],Fe=G(Le,Oe);Fe===0?(be+=1,ke+=1):Fe<0?(he(be,1,[]),be+=1):Fe>0&&(he(be,0,[Oe]),ke+=1)}return re}e.sortedDiff=b;function d(B,z,G){const re=b(B,z,G),he=[],be=[];for(const ke of re)he.push(...B.slice(ke.start,ke.start+ke.deleteCount)),be.push(...ke.toInsert);return{removed:he,added:be}}e.delta=d;function E(B,z,G){if(G===0)return[];const re=B.slice(0,G).sort(z);return r(B,z,re,G,B.length),re}e.top=E;function v(B,z,G,re,he){return G===0?Promise.resolve([]):new Promise((be,ke)=>{(async()=>{const Le=B.length,Oe=B.slice(0,G).sort(z);for(let Fe=G,me=Math.min(G+re,Le);Fe<Le;Fe=me,me=Math.min(me+re,Le)){if(Fe>G&&await new Promise(pe=>setTimeout(pe)),he&&he.isCancellationRequested)throw new I.CancellationError;r(B,z,Oe,Fe,me)}return Oe})().then(be,ke)})}e.topAsync=v;function r(B,z,G,re,he){for(const be=G.length;re<he;re++){const ke=B[re];if(z(ke,G[be-1])<0){G.pop();const Le=u(G,Oe=>z(ke,Oe)<0);G.splice(Le,0,ke)}}}function g(B){return B.filter(z=>!!z)}e.coalesce=g;function h(B){let z=0;for(let G=0;G<B.length;G++)B[G]&&(B[z]=B[G],z+=1);B.length=z}e.coalesceInPlace=h;function S(B,z,G){B.splice(G,0,B.splice(z,1)[0])}e.move=S;function w(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=w;function C(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=C;function t(B,z=G=>G){const G=new Set;return B.filter(re=>{const he=z(re);return G.has(he)?!1:(G.add(he),!0)})}e.distinct=t;function l(B){const z=new Set;return G=>{const re=B(G);return z.has(re)?!1:(z.add(re),!0)}}e.uniqueFilter=l;function i(B,z){const G=n(B,z);if(G!==-1)return B[G]}e.findLast=i;function n(B,z){for(let G=B.length-1;G>=0;G--){const re=B[G];if(z(re))return G}return-1}e.lastIndex=n;function a(B,z){return B.length>0?B[0]:z}e.firstOrDefault=a;function c(B,z){return B.length>0?B[B.length-1]:z}e.lastOrDefault=c;function o(B,z,G=(re,he)=>re===he){let re=0;for(let he=0,be=Math.min(B.length,z.length);he<be&&G(B[he],z[he]);he++)re++;return re}e.commonPrefixLength=o;function m(B){return[].concat(...B)}e.flatten=m;function D(B,z){let G=typeof z=="number"?B:0;typeof z=="number"?G=B:(G=0,z=B);const re=[];if(G<=z)for(let he=G;he<z;he++)re.push(he);else for(let he=G;he>z;he--)re.push(he);return re}e.range=D;function M(B,z,G){return B.reduce((re,he)=>(re[z(he)]=G?G(he):he,re),Object.create(null))}e.index=M;function T(B,z){return B.push(z),()=>N(B,z)}e.insert=T;function N(B,z){const G=B.indexOf(z);if(G>-1)return B.splice(G,1),z}e.remove=N;function $(B,z,G){const re=B.slice(0,z),he=B.slice(z);return re.concat(G,he)}e.arrayInsert=$;function q(B,z){let G;if(typeof z=="number"){let re=z;G=()=>{const he=Math.sin(re++)*179426549;return he-Math.floor(he)}}else G=Math.random;for(let re=B.length-1;re>0;re-=1){const he=Math.floor(G()*(re+1)),be=B[re];B[re]=B[he],B[he]=be}}e.shuffle=q;function ie(B,z){const G=B.indexOf(z);G>-1&&(B.splice(G,1),B.unshift(z))}e.pushToStart=ie;function oe(B,z){const G=B.indexOf(z);G>-1&&(B.splice(G,1),B.push(z))}e.pushToEnd=oe;function ae(B,z){for(const G of z)B.push(G)}e.pushMany=ae;function de(B,z){return Array.isArray(B)?B.map(z):z(B)}e.mapArrayOrNot=de;function ce(B){return Array.isArray(B)?B:[B]}e.asArray=ce;function X(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=X;function J(B,z){for(const G of B){const re=z(G);if(re!==void 0)return re}}e.mapFind=J;function H(B,z,G){const re=V(B,z),he=B.length,be=G.length;B.length=he+be;for(let ke=he-1;ke>=re;ke--)B[ke+be]=B[ke];for(let ke=0;ke<be;ke++)B[ke+re]=G[ke]}e.insertInto=H;function W(B,z,G,re){const he=V(B,z),be=B.splice(he,G);return H(B,he,re),be}e.splice=W;function V(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var Y;(function(B){function z(he){return he<0}B.isLessThan=z;function G(he){return he>0}B.isGreaterThan=G;function re(he){return he===0}B.isNeitherLessOrGreaterThan=re,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function ne(B,z){return(G,re)=>z(B(G),B(re))}e.compareBy=ne;function se(...B){return(z,G)=>{for(const re of B){const he=re(z,G);if(!Y.isNeitherLessOrGreaterThan(he))return he}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const _=(B,z)=>B-z;e.numberComparator=_;function O(B,z){if(B.length===0)return;let G=B[0];for(let re=1;re<B.length;re++){const he=B[re];z(he,G)>0&&(G=he)}return G}e.findMaxBy=O;function P(B,z){if(B.length===0)return;let G=B[0];for(let re=1;re<B.length;re++){const he=B[re];z(he,G)>=0&&(G=he)}return G}e.findLastMaxBy=P;function F(B,z){return O(B,(G,re)=>-z(G,re))}e.findMinBy=F;class U{constructor(z){this.f=z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(z){let G=this.c;for(;G<this.f.length&&z(this.f[G]);)G++;const re=G===this.c?null:this.f.slice(this.c,G);return this.c=G,re}takeFromEndWhile(z){let G=this.d;for(;G>=0&&z(this.f[G]);)G--;const re=G===this.d?null:this.f.slice(G+1,this.d+1);return this.d=G,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const z=this.f[this.c];return this.c++,z}removeLast(){const z=this.f[this.d];return this.d--,z}takeCount(z){const G=this.f.slice(this.c,this.c+z);return this.c+=z,G}}e.ArrayQueue=U;class j{constructor(z){this.iterate=z}forEach(z){this.iterate(G=>(z(G),!0))}toArray(){const z=[];return this.iterate(G=>(z.push(G),!0)),z}filter(z){return new j(G=>this.iterate(re=>z(re)?G(re):!0))}map(z){return new j(G=>this.iterate(re=>G(z(re))))}some(z){let G=!1;return this.iterate(re=>(G=z(re),!G)),G}findFirst(z){let G;return this.iterate(re=>z(re)?(G=re,!1):!0),G}findLast(z){let G;return this.iterate(re=>(z(re)&&(G=re),!0)),G}findLastMaxBy(z){let G,re=!0;return this.iterate(he=>((re||Y.isGreaterThan(z(he,G)))&&(re=!1,G=he),!0)),G}}j.empty=new j(B=>{}),e.CallbackIterable=j}),define(ee[128],te([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=L;function s(f,u="Unreachable"){throw new Error(u)}e.assertNever=s;function A(f){if(!f)throw new I.BugIndicatingError("Assertion Failed")}e.assert=A;function R(f){if(!f()){debugger;f(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function k(f,u){let p=0;for(;p<f.length-1;){const y=f[p],b=f[p+1];if(!u(y,b))return!1;p++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(L){const s=this;let A=!1,R;return function(){return A||(A=!0,R=L.apply(s,arguments)),R}}e.once=I}),define(ee[71],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function s(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}L.is=s;const A=Object.freeze([]);function R(){return A}L.empty=R;function*k(w){yield w}L.single=k;function f(w){return s(w)?w:k(w)}L.wrap=f;function u(w){return w||A}L.from=u;function p(w){return!w||w[Symbol.iterator]().next().done===!0}L.isEmpty=p;function y(w){return w[Symbol.iterator]().next().value}L.first=y;function b(w,C){for(const t of w)if(C(t))return!0;return!1}L.some=b;function d(w,C){for(const t of w)if(C(t))return t}L.find=d;function*E(w,C){for(const t of w)C(t)&&(yield t)}L.filter=E;function*v(w,C){let t=0;for(const l of w)yield C(l,t++)}L.map=v;function*r(...w){for(const C of w)for(const t of C)yield t}L.concat=r;function g(w,C,t){let l=t;for(const i of w)l=C(l,i);return l}L.reduce=g;function*h(w,C,t=w.length){for(C<0&&(C+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);C<t;C++)yield w[C]}L.slice=h;function S(w,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,w];const l=w[Symbol.iterator]();for(let i=0;i<C;i++){const n=l.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return l}}]}L.consume=S})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(t,l=!1){let i=0;const n=t.length;let a="",c=0,o=16,m=0;function D(oe){let ae=0,de=0;for(;ae<oe;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)de=de*16+ce-48;else if(ce>=65&&ce<=70)de=de*16+ce-65+10;else if(ce>=97&&ce<=102)de=de*16+ce-97+10;else break;i++,ae++}return ae<oe&&(de=-1),de}function M(oe){i=oe,a="",c=0,o=16,m=0}function T(){const oe=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return m=3,t.substring(oe,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else m=3;return t.substring(oe,ae)}function N(){let oe="",ae=i;for(;;){if(i>=n){oe+=t.substring(ae,i),m=2;break}const de=t.charCodeAt(i);if(de===34){oe+=t.substring(ae,i),i++;break}if(de===92){if(oe+=t.substring(ae,i),i++,i>=n){m=2;break}switch(t.charCodeAt(i++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const X=D(4);X>=0?oe+=String.fromCharCode(X):m=4;break}default:m=5}ae=i;continue}if(de>=0&&de<=31)if(f(de)){oe+=t.substring(ae,i),m=2;break}else m=6;i++}return oe}function $(){if(a="",m=0,c=i,i>=n)return c=n,o=17;let oe=t.charCodeAt(i);if(k(oe)){do i++,a+=String.fromCharCode(oe),oe=t.charCodeAt(i);while(k(oe));return o=15}if(f(oe))return i++,a+=String.fromCharCode(oe),oe===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),o=14;switch(oe){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,a=N(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!f(t.charCodeAt(i));)i++;return a=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const de=n-1;let ce=!1;for(;i<de;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,m=1),a=t.substring(ae,i),o=13}return a+=String.fromCharCode(oe),i++,o=16}case 45:if(a+=String.fromCharCode(oe),i++,i===n||!u(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),o=11;default:for(;i<n&&q(oe);)i++,oe=t.charCodeAt(i);if(c!==i){switch(a=t.substring(c,i),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(oe),i++,o=16}}function q(oe){if(k(oe)||f(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let oe;do oe=$();while(oe>=12&&oe<=15);return oe}return{setPosition:M,getPosition:()=>i,scan:l?ie:$,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>m}}e.createScanner=R;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function y(t,l){const i=[],n=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function m(D,M,T,N){c.value=D,c.offset=M,c.length=T,c.type=N,c.colonOffset=void 0,a=c}try{S(t,{onObjectBegin:(D,M)=>{if(l<=D)throw n;a=void 0,o=l>D,i.push("")},onObjectProperty:(D,M,T)=>{if(l<M||(m(D,M,T,"property"),i[i.length-1]=D,l<=M+T))throw n},onObjectEnd:(D,M)=>{if(l<=D)throw n;a=void 0,i.pop()},onArrayBegin:(D,M)=>{if(l<=D)throw n;a=void 0,i.push(0)},onArrayEnd:(D,M)=>{if(l<=D)throw n;a=void 0,i.pop()},onLiteralValue:(D,M,T)=>{if(l<M||(m(D,M,T,C(D)),l<=M+T))throw n},onSeparator:(D,M,T)=>{if(l<=M)throw n;if(D===":"&&a&&a.type==="property")a.colonOffset=M,o=!1,a=void 0;else if(D===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(o=!0,i[i.length-1]=""),a=void 0}}})}catch(D){if(D!==n)throw D}return{path:i,previousNode:a,isAtPropertyKey:o,matches:D=>{let M=0;for(let T=0;M<D.length&&T<i.length;T++)if(D[M]===i[T]||D[M]==="*")M++;else if(D[M]!=="**")return!1;return M===D.length}}}e.getLocation=y;function b(t,l=[],i=A.DEFAULT){let n=null,a=[];const c=[];function o(D){Array.isArray(a)?a.push(D):n!==null&&(a[n]=D)}return S(t,{onObjectBegin:()=>{const D={};o(D),c.push(a),a=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const D=[];o(D),c.push(a),a=D,n=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:o,onError:(D,M,T)=>{l.push({error:D,offset:M,length:T})}},i),a[0]}e.parse=b;function d(t,l=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function c(D){return n.children.push(D),D}S(t,{onObjectBegin:D=>{n=c({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,M,T)=>{n=c({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:M,length:T,parent:n})},onObjectEnd:(D,M)=>{n.length=D+M-n.offset,n=n.parent,a(D+M)},onArrayBegin:(D,M)=>{n=c({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,M)=>{n.length=D+M-n.offset,n=n.parent,a(D+M)},onLiteralValue:(D,M,T)=>{c({type:C(D),offset:M,length:T,parent:n,value:D}),a(M+T)},onSeparator:(D,M,T)=>{n.type==="property"&&(D===":"?n.colonOffset=M:D===","&&a(M))},onError:(D,M,T)=>{l.push({error:D,offset:M,length:T})}},i);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=d;function E(t,l){if(!t)return;let i=t;for(const n of l)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===n){i=c.children[1],a=!0;break}if(!a)return}else{const a=n;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=E;function v(t){if(!t.parent||!t.parent.children)return[];const l=v(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;l.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&l.push(i)}return l}e.getNodePath=v;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const l=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(l[i.children[0].value]=r(n))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function g(t,l,i=!1){return l>=t.offset&&l<t.offset+t.length||i&&l===t.offset+t.length}e.contains=g;function h(t,l,i=!1){if(g(t,l,i)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=l;a++){const c=h(n[a],l,i);if(c)return c}return t}}e.findNodeAtOffset=h;function S(t,l,i=A.DEFAULT){const n=R(t,!1);function a(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(ne){return ne?se=>ne(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=a(l.onObjectBegin),m=c(l.onObjectProperty),D=a(l.onObjectEnd),M=a(l.onArrayBegin),T=a(l.onArrayEnd),N=c(l.onLiteralValue),$=c(l.onSeparator),q=a(l.onComment),ie=c(l.onError),oe=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function de(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:oe||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ne){case 12:case 13:oe?ce(10):q();break;case 16:ce(1);break;case 15:case 14:break;default:return ne}}}function ce(ne,se=[],_=[]){if(ie(ne),se.length+_.length>0){let O=n.getToken();for(;O!==17;){if(se.indexOf(O)!==-1){de();break}else if(_.indexOf(O)!==-1)break;O=de()}}}function X(ne){const se=n.getTokenValue();return ne?N(se):m(se),de(),!0}function J(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(ce(2),ne=0)}catch{ce(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return de(),!0}function H(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(X(!1),n.getToken()===6?($(":"),de(),Y()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function W(){o(),de();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),$(","),de(),n.getToken()===2&&ae)break}else ne&&ce(6,[],[]);H()||ce(4,[],[2,5]),ne=!0}return D(),n.getToken()!==2?ce(7,[2],[]):de(),!0}function V(){M(),de();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),$(","),de(),n.getToken()===4&&ae)break}else ne&&ce(6,[],[]);Y()||ce(4,[],[4,5]),ne=!0}return T(),n.getToken()!==4?ce(8,[4],[]):de(),!0}function Y(){switch(n.getToken()){case 3:return V();case 1:return W();case 10:return X(!0);default:return J()}}return de(),n.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Y()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=S;function w(t,l){const i=R(t),n=[];let a,c=0,o;do switch(o=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:c!==o&&n.push(t.substring(c,o)),l!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,l)),c=i.getPosition();break}while(a!==17);return n.join("")}e.stripComments=w;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(ee[129],te([0,1,43]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(u,p,y){let b,d,E,v,r;if(p){for(v=p.offset,r=v+p.length,E=v;E>0&&!f(u,E-1);)E--;let o=r;for(;o<u.length&&!f(u,o);)o++;d=u.substring(E,o),b=R(d,y)}else d=u,b=0,E=0,v=0,r=u.length;const g=k(y,u);let h=!1,S=0,w;y.insertSpaces?w=A(" ",y.tabSize||4):w="	";const C=(0,I.createScanner)(d,!1);let t=!1;function l(){return g+A(w,b+S)}function i(){let o=C.scan();for(h=!1;o===15||o===14;)h=h||o===14,o=C.scan();return t=o===16||C.getTokenError()!==0,o}const n=[];function a(o,m,D){!t&&m<r&&D>v&&u.substring(m,D)!==o&&n.push({offset:m,length:D-m,content:o})}let c=i();if(c!==17){const o=C.getTokenOffset()+E,m=A(w,b);a(m,E,o)}for(;c!==17;){let o=C.getTokenOffset()+C.getTokenLength()+E,m=i(),D="";for(;!h&&(m===12||m===13);){const T=C.getTokenOffset()+E;a(" ",o,T),o=C.getTokenOffset()+C.getTokenLength()+E,D=m===12?l():"",m=i()}if(m===2)c!==1&&(S--,D=l());else if(m===4)c!==3&&(S--,D=l());else{switch(c){case 3:case 1:S++,D=l();break;case 5:case 12:D=l();break;case 13:h?D=l():D=" ";break;case 6:D=" ";break;case 10:if(m===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?D=" ":m!==5&&m!==17&&(t=!0);break;case 16:t=!0;break}h&&(m===12||m===13)&&(D=l())}const M=C.getTokenOffset()+E;a(D,o,M),c=m}return n}e.format=L;function s(u,p){const y=JSON.stringify(u,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?y.replace(/\r\n|\r|\n/g,p.eol):y}e.toFormattedString=s;function A(u,p){let y="";for(let b=0;b<p;b++)y+=u;return y}function R(u,p){let y=0,b=0;const d=p.tabSize||4;for(;y<u.length;){const E=u.charAt(y);if(E===" ")b++;else if(E==="	")b+=d;else break;y++}return Math.floor(b/d)}function k(u,p){for(let y=0;y<p.length;y++){const b=p.charAt(y);if(b==="\r")return y+1<p.length&&p.charAt(y+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return u&&u.eol||`
`}e.getEOL=k;function f(u,p){return`\r
`.indexOf(u.charAt(p))!==-1}e.isEOL=f}),define(ee[130],te([0,1,43,129]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function s(u,p,y){return A(u,p,void 0,y)}e.removeProperty=s;function A(u,p,y,b,d){const E=p.slice(),v=[],r=(0,I.parseTree)(u,v);let g,h;for(;E.length>0&&(h=E.pop(),g=(0,I.findNodeAtLocation)(r,E),g===void 0&&y!==void 0);)typeof h=="string"?y={[h]:y}:y=[y];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const S=(0,I.findNodeAtLocation)(g,[h]);if(S!==void 0)if(y===void 0){if(!S.parent)throw new Error("Malformed AST");const w=g.children.indexOf(S.parent);let C,t=S.parent.offset+S.parent.length;if(w>0){const l=g.children[w-1];C=l.offset+l.length}else C=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(u,{offset:C,length:t-C,content:""},b)}else return R(u,{offset:S.offset,length:S.length,content:JSON.stringify(y)},b);else{if(y===void 0)return[];const w=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,C=d?d(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(C>0){const l=g.children[C-1];t={offset:l.offset+l.length,length:0,content:","+w}}else g.children.length===0?t={offset:g.offset+1,length:0,content:w}:t={offset:g.offset+1,length:0,content:w+","};return R(u,t,b)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(y!==void 0){const S=`${JSON.stringify(y)}`;let w;if(g.children.length===0||h===0)w={offset:g.offset+1,length:0,content:g.children.length===0?S:S+","};else{const C=h===-1||h>g.children.length?g.children.length:h,t=g.children[C-1];w={offset:t.offset+t.length,length:0,content:","+S}}return R(u,w,b)}else{const S=h,w=g.children[S];let C;if(g.children.length===1)C={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===S){const t=g.children[S-1],l=t.offset+t.length,i=g.offset+g.length;C={offset:l,length:i-2-l,content:""}}else C={offset:w.offset,length:g.children[S+1].offset-w.offset,content:""};return R(u,C,b)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return R(u,{offset:r?r.offset:0,length:r?r.length:0,content:JSON.stringify(y)},b)}}e.setProperty=A;function R(u,p,y){let b=k(u,p),d=p.offset,E=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;d>0&&!(0,L.isEOL)(b,d-1);)d--;for(;E<b.length&&!(0,L.isEOL)(b,E);)E++}const v=(0,L.format)(b,{offset:d,length:E-d},y);for(let g=v.length-1;g>=0;g--){const h=v[g];b=k(b,h),d=Math.min(d,h.offset),E=Math.max(E,h.offset+h.length),E+=h.content.length-h.length}const r=u.length-(b.length-E)-d;return[{offset:d,length:r,content:b.substring(d,E)}]}e.withFormatting=R;function k(u,p){return u.substring(0,p.offset)+p.content+u.substring(p.offset+p.length)}e.applyEdit=k;function f(u,p){const y=p.slice(0).sort((d,E)=>{const v=d.offset-E.offset;return v===0?d.length-E.length:v});let b=u.length;for(let d=y.length-1;d>=0;d--){const E=y[d];if(E.offset+E.length<=b)u=k(u,E);else throw new Error("Overlapping edit");b=E.offset}return u}e.applyEdits=f}),define(ee[131],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=I}),define(ee[2],te([0,1,50,71]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const s=!1;let A=null;function R(c){A=c}if(e.setDisposableTracker=R,s){const c="__is_disposable_tracked__";R(new class{trackDisposable(o){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(m)},3e3)}setParent(o,m){if(o&&o!==h.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==h.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function k(c){return A?.trackDisposable(c),c}function f(c){A?.markAsDisposed(c)}function u(c,o){A?.setParent(c,o)}function p(c,o){if(!!A)for(const m of c)A.setParent(m,o)}function y(c){return A?.markAsSingleton(c),c}e.markAsSingleton=y;function b(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=b;function d(c){if(L.Iterable.is(c)){const o=[];for(const m of c)if(m)try{m.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=d;function E(c){for(const o of c)b(o)&&o.dispose();return[]}e.disposeIfDisposable=E;function v(...c){const o=r(()=>d(c));return p(c,o),o}e.combinedDisposable=v;function r(c){const o=k({dispose:(0,I.once)(()=>{f(o),c()})});return o}e.toDisposable=r;class g{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return u(o,this),this.f?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}g.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=g;class h{constructor(){this.q=new g,k(this),u(this.q,this)}dispose(){f(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class S{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&u(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&u(o,null),o}}e.MutableDisposable=S;class w{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(o){let m=o;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,f(this))},this}}e.SafeDisposable=C;class t{constructor(){this.a=new Map}acquire(o,...m){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...m)},this.a.set(o,D));const{object:M}=D,T=(0,I.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:M,dispose:T}}}e.ReferenceCollection=t;class l{constructor(o){this.a=o}async acquire(o,...m){const D=this.a.acquire(o,...m);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(M){throw D.dispose(),M}}}e.AsyncReferenceCollection=l;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function n(c){const o=new g;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=n;class a{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,m,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,m)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(ee[100],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class L{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const R=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const k=new I(A);if(this.a===I.Undefined)this.a=k,this.b=k;else if(R){const u=this.b;this.b=k,k.prev=u,u.next=k}else{const u=this.a;this.a=k,k.next=u,u.prev=k}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(k))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ee[35],te([0,1]),function(x,e){"use strict";var I,L,s;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,r,g){let h=v.get(r);return h===void 0&&(h=g,v.set(r,h)),h}e.getOrSet=A;function R(v){const r=[];return v.forEach((g,h)=>{r.push(`${h} => ${g}`)}),`Map(${v.size}) {${r.join(", ")}}`}e.mapToString=R;function k(v){const r=[];return v.forEach(g=>{r.push(g)}),`Set(${v.size}) {${r.join(", ")}}`}e.setToString=k;class f{constructor(r,g){this.uri=r,this.value=g}}class u{constructor(r,g){this[I]="ResourceMap",r instanceof u?(this.b=new Map(r.b),this.c=g??u.a):(this.b=new Map,this.c=r??u.a)}set(r,g){return this.b.set(this.c(r),new f(r,g)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,g){typeof g<"u"&&(r=r.bind(g));for(const[h,S]of this.b)r(S.value,S.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}u.a=v=>v.toString(),e.ResourceMap=u;class p{constructor(r,g){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new u(r):(this.a=new u(g),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,g){this.a.forEach((h,S)=>r.call(g,S,S,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var y;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class b{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,g=0){const h=this.a.get(r);if(!!h)return g!==0&&this.j(h,g),h.value}set(r,g,h=0){let S=this.a.get(r);if(S)S.value=g,h!==0&&this.j(S,h);else{switch(S={key:r,value:g,next:void 0,previous:void 0},h){case 0:this.h(S);break;case 1:this.g(S);break;case 2:this.h(S);break;default:this.h(S);break}this.a.set(r,S),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const g=this.a.get(r);if(!!g)return this.a.delete(r),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,g){const h=this.e;let S=this.b;for(;S;){if(g?r.bind(g)(S.value,S.key,this):r(S.value,S.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const r=this,g=this.e;let h=this.b;const S={[Symbol.iterator](){return S},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.key,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return S}values(){const r=this,g=this.e;let h=this.b;const S={[Symbol.iterator](){return S},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.value,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return S}entries(){const r=this,g=this.e;let h=this.b;const S={[Symbol.iterator](){return S},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:[h.key,h.value],done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return S}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let g=this.b,h=this.size;for(;g&&h>r;)this.a.delete(g.key),g=g.next,h--;this.b=g,this.d=h,g&&(g.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const g=r.next,h=r.previous;if(!g||!h)throw new Error("Invalid list");g.previous=h,h.next=g}r.next=void 0,r.previous=void 0,this.e++}j(r,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(r===this.b)return;const h=r.next,S=r.previous;r===this.c?(S.next=void 0,this.c=S):(h.previous=S,S.next=h),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(g===2){if(r===this.c)return;const h=r.next,S=r.previous;r===this.b?(h.previous=void 0,this.b=h):(h.previous=S,S.next=h),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((g,h)=>{r.push([h,g])}),r}fromJSON(r){this.clear();for(const[g,h]of r)this.set(g,h)}}e.LinkedMap=b;class d extends b{constructor(r,g=1){super(),this.k=r,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,g=2){return super.get(r,g)}peek(r){return super.get(r,0)}set(r,g){return super.set(r,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class E{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let g=this.a.get(r)||0;return g===0?!1:(g--,g===0?this.a.delete(r):this.a.set(r,g),!0)}has(r){return this.a.has(r)}}e.CounterSet=E}),define(ee[82],te([0,1,35]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new I.LRUCache(1e4);function s(u){return f(u,"NFC",L)}e.normalizeNFC=s;const A=new I.LRUCache(1e4);function R(u){return f(u,"NFD",A)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function f(u,p,y){if(!u)return u;const b=y.get(u);if(b)return b;let d;return k.test(u)?d=u.normalize(p):d=u,y.set(u,d),d}e.removeAccents=function(){const u=/[\u0300-\u036f]/g;return function(p){return R(p).replace(u,"")}}()}),define(ee[132],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(k,f,u){return Math.min(Math.max(k,f),u)}e.clamp=I;function L(k,f){return(f+k%f)%f}e.rot=L;class s{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=s;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function x(s){const A=[];typeof s=="number"&&A.push("code/timeOrigin",s);function R(f){A.push(f,Date.now())}function k(){const f=[];for(let u=0;u<A.length;u+=2)f.push({name:A[u],startTime:A[u+1]});return f}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(s+R.startTime)});return A}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function I(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:x)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function I(L){if(e[L])return e[L].exports;var s=e[L]={i:L,l:!1,exports:{}};return x[L].call(s.exports,s,s.exports,I),s.l=!0,s.exports}return I.m=x,I.c=e,I.d=function(L,s,A){I.o(L,s)||Object.defineProperty(L,s,{enumerable:!0,get:A})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,s){if(1&s&&(L=I(L)),8&s||4&s&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&s&&typeof L!="string")for(var R in L)I.d(A,R,function(k){return L[k]}.bind(null,R));return A},I.n=function(L){var s=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(s,"a",s),s},I.o=function(L,s){return Object.prototype.hasOwnProperty.call(L,s)},I.p="",I(I.s=0)}([function(x,e,I){(function(L){var s;e=x.exports=_,s=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],f=e.src=[],u=0,p=u++;f[p]="0|[1-9]\\d*";var y=u++;f[y]="[0-9]+";var b=u++;f[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=u++;f[d]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var E=u++;f[E]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var v=u++;f[v]="(?:"+f[p]+"|"+f[b]+")";var r=u++;f[r]="(?:"+f[y]+"|"+f[b]+")";var g=u++;f[g]="(?:-("+f[v]+"(?:\\."+f[v]+")*))";var h=u++;f[h]="(?:-?("+f[r]+"(?:\\."+f[r]+")*))";var S=u++;f[S]="[0-9A-Za-z-]+";var w=u++;f[w]="(?:\\+("+f[S]+"(?:\\."+f[S]+")*))";var C=u++,t="v?"+f[d]+f[g]+"?"+f[w]+"?";f[C]="^"+t+"$";var l="[v=\\s]*"+f[E]+f[h]+"?"+f[w]+"?",i=u++;f[i]="^"+l+"$";var n=u++;f[n]="((?:<|>)?=?)";var a=u++;f[a]=f[y]+"|x|X|\\*";var c=u++;f[c]=f[p]+"|x|X|\\*";var o=u++;f[o]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[g]+")?"+f[w]+"?)?)?";var m=u++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[h]+")?"+f[w]+"?)?)?";var D=u++;f[D]="^"+f[n]+"\\s*"+f[o]+"$";var M=u++;f[M]="^"+f[n]+"\\s*"+f[m]+"$";var T=u++;f[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=u++;f[N]="(?:~>?)";var $=u++;f[$]="(\\s*)"+f[N]+"\\s+",k[$]=new RegExp(f[$],"g");var q=u++;f[q]="^"+f[N]+f[o]+"$";var ie=u++;f[ie]="^"+f[N]+f[m]+"$";var oe=u++;f[oe]="(?:\\^)";var ae=u++;f[ae]="(\\s*)"+f[oe]+"\\s+",k[ae]=new RegExp(f[ae],"g");var de=u++;f[de]="^"+f[oe]+f[o]+"$";var ce=u++;f[ce]="^"+f[oe]+f[m]+"$";var X=u++;f[X]="^"+f[n]+"\\s*("+l+")$|^$";var J=u++;f[J]="^"+f[n]+"\\s*("+t+")$|^$";var H=u++;f[H]="(\\s*)"+f[n]+"\\s*("+l+"|"+f[o]+")",k[H]=new RegExp(f[H],"g");var W=u++;f[W]="^\\s*("+f[o]+")\\s+-\\s+("+f[o]+")\\s*$";var V=u++;f[V]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var Y=u++;f[Y]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)s(ne,f[ne]),k[ne]||(k[ne]=new RegExp(f[ne]));function se(Z,ue){if(Z instanceof _)return Z;if(typeof Z!="string"||Z.length>A||!(ue?k[i]:k[C]).test(Z))return null;try{return new _(Z,ue)}catch{return null}}function _(Z,ue){if(Z instanceof _){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof _))return new _(Z,ue);s("SemVer",Z,ue),this.loose=ue;var fe=Z.trim().match(ue?k[i]:k[C]);if(!fe)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ae=+Ee;if(Ae>=0&&Ae<R)return Ae}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=se,e.valid=function(Z,ue){var fe=se(Z,ue);return fe?fe.version:null},e.clean=function(Z,ue){var fe=se(Z.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(Z){return s("SemVer.compare",this.version,this.loose,Z),Z instanceof _||(Z=new _(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},_.prototype.compareMain=function(Z){return Z instanceof _||(Z=new _(Z,this.loose)),P(this.major,Z.major)||P(this.minor,Z.minor)||P(this.patch,Z.patch)},_.prototype.comparePre=function(Z){if(Z instanceof _||(Z=new _(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],Ee=Z.prerelease[ue];if(s("prerelease compare",ue,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return P(fe,Ee)}while(++ue)},_.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new _(Z,fe).inc(ue,Ee).version}catch{return null}},e.diff=function(Z,ue){if(B(Z,ue))return null;var fe=se(Z),Ee=se(ue);if(fe.prerelease.length||Ee.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==Ee[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==Ee[Ae])return Ae},e.compareIdentifiers=P;var O=/^[0-9]+$/;function P(Z,ue){var fe=O.test(Z),Ee=O.test(ue);return fe&&Ee&&(Z=+Z,ue=+ue),fe&&!Ee?-1:Ee&&!fe?1:Z<ue?-1:Z>ue?1:0}function F(Z,ue,fe){return new _(Z,fe).compare(new _(ue,fe))}function U(Z,ue,fe){return F(Z,ue,fe)>0}function j(Z,ue,fe){return F(Z,ue,fe)<0}function B(Z,ue,fe){return F(Z,ue,fe)===0}function z(Z,ue,fe){return F(Z,ue,fe)!==0}function G(Z,ue,fe){return F(Z,ue,fe)>=0}function re(Z,ue,fe){return F(Z,ue,fe)<=0}function he(Z,ue,fe,Ee){var Ae;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Ae=Z===fe;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Ae=Z!==fe;break;case"":case"=":case"==":Ae=B(Z,fe,Ee);break;case"!=":Ae=z(Z,fe,Ee);break;case">":Ae=U(Z,fe,Ee);break;case">=":Ae=G(Z,fe,Ee);break;case"<":Ae=j(Z,fe,Ee);break;case"<=":Ae=re(Z,fe,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Ae}function be(Z,ue){if(Z instanceof be){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof be))return new be(Z,ue);s("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Z,ue){return P(ue,Z)},e.major=function(Z,ue){return new _(Z,ue).major},e.minor=function(Z,ue){return new _(Z,ue).minor},e.patch=function(Z,ue){return new _(Z,ue).patch},e.compare=F,e.compareLoose=function(Z,ue){return F(Z,ue,!0)},e.rcompare=function(Z,ue,fe){return F(ue,Z,fe)},e.sort=function(Z,ue){return Z.sort(function(fe,Ee){return e.compare(fe,Ee,ue)})},e.rsort=function(Z,ue){return Z.sort(function(fe,Ee){return e.rcompare(fe,Ee,ue)})},e.gt=U,e.lt=j,e.eq=B,e.neq=z,e.gte=G,e.lte=re,e.cmp=he,e.Comparator=be;var ke={};function Le(Z,ue){if(Z instanceof Le)return Z.loose===ue?Z:new Le(Z.raw,ue);if(Z instanceof be)return new Le(Z.value,ue);if(!(this instanceof Le))return new Le(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Oe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Fe(Z,ue,fe,Ee,Ae,Te,We,qe,Ne,Be,Ve,K,le){return((ue=Oe(fe)?"":Oe(Ee)?">="+fe+".0.0":Oe(Ae)?">="+fe+"."+Ee+".0":">="+ue)+" "+(qe=Oe(Ne)?"":Oe(Be)?"<"+(+Ne+1)+".0.0":Oe(Ve)?"<"+Ne+"."+(+Be+1)+".0":K?"<="+Ne+"."+Be+"."+Ve+"-"+K:"<="+qe)).trim()}function me(Z,ue){for(var fe=0;fe<Z.length;fe++)if(!Z[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<Z.length;fe++)if(s(Z[fe].semver),Z[fe].semver!==ke&&Z[fe].semver.prerelease.length>0){var Ee=Z[fe].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function pe(Z,ue,fe){try{ue=new Le(ue,fe)}catch{return!1}return ue.test(Z)}function Ce(Z,ue,fe,Ee){var Ae,Te,We,qe,Ne;switch(Z=new _(Z,Ee),ue=new Le(ue,Ee),fe){case">":Ae=U,Te=re,We=j,qe=">",Ne=">=";break;case"<":Ae=j,Te=G,We=U,qe="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Z,ue,Ee))return!1;for(var Be=0;Be<ue.set.length;++Be){var Ve=ue.set[Be],K=null,le=null;if(Ve.forEach(function(ge){ge.semver===ke&&(ge=new be(">=0.0.0")),K=K||ge,le=le||ge,Ae(ge.semver,K.semver,Ee)?K=ge:We(ge.semver,le.semver,Ee)&&(le=ge)}),K.operator===qe||K.operator===Ne||(!le.operator||le.operator===qe)&&Te(Z,le.semver)||le.operator===Ne&&We(Z,le.semver))return!1}return!0}be.prototype.parse=function(Z){var ue=this.loose?k[X]:k[J],fe=Z.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+Z);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new _(fe[2],this.loose):this.semver=ke},be.prototype.toString=function(){return this.value},be.prototype.test=function(Z){return s("Comparator.test",Z,this.loose),this.semver===ke||(typeof Z=="string"&&(Z=new _(Z,this.loose)),he(Z,this.operator,this.semver,this.loose))},be.prototype.intersects=function(Z,ue){if(!(Z instanceof be))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Le(Z.value,ue),pe(this.value,fe,ue);if(Z.operator==="")return fe=new Le(this.value,ue),pe(Z.semver,fe,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Te=this.semver.version===Z.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),qe=he(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ne=he(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ee||Ae||Te&&We||qe||Ne},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),s("range",Z,ue);var fe=ue?k[V]:k[W];Z=Z.replace(fe,Fe),s("hyphen replace",Z),Z=Z.replace(k[H],"$1$2$3"),s("comparator trim",Z,k[H]),Z=(Z=(Z=Z.replace(k[$],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var Ee=ue?k[X]:k[J],Ae=Z.split(" ").map(function(Te){return function(We,qe){return s("comp",We),We=function(Ne,Be){return Ne.trim().split(/\s+/).map(function(Ve){return function(K,le){s("caret",K,le);var ge=le?k[ce]:k[de];return K.replace(ge,function(ve,we,Me,Ue,He){var Ge;return s("caret",K,ve,we,Me,Ue,He),Oe(we)?Ge="":Oe(Me)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=we==="0"?">="+we+"."+Me+".0 <"+we+"."+(+Me+1)+".0":">="+we+"."+Me+".0 <"+(+we+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=we==="0"?Me==="0"?">="+we+"."+Me+"."+Ue+He+" <"+we+"."+Me+"."+(+Ue+1):">="+we+"."+Me+"."+Ue+He+" <"+we+"."+(+Me+1)+".0":">="+we+"."+Me+"."+Ue+He+" <"+(+we+1)+".0.0"):(s("no pr"),Ge=we==="0"?Me==="0"?">="+we+"."+Me+"."+Ue+" <"+we+"."+Me+"."+(+Ue+1):">="+we+"."+Me+"."+Ue+" <"+we+"."+(+Me+1)+".0":">="+we+"."+Me+"."+Ue+" <"+(+we+1)+".0.0"),s("caret return",Ge),Ge})}(Ve,Be)}).join(" ")}(We,qe),s("caret",We),We=function(Ne,Be){return Ne.trim().split(/\s+/).map(function(Ve){return function(K,le){var ge=le?k[ie]:k[q];return K.replace(ge,function(ve,we,Me,Ue,He){var Ge;return s("tilde",K,ve,we,Me,Ue,He),Oe(we)?Ge="":Oe(Me)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=">="+we+"."+Me+".0 <"+we+"."+(+Me+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=">="+we+"."+Me+"."+Ue+He+" <"+we+"."+(+Me+1)+".0"):Ge=">="+we+"."+Me+"."+Ue+" <"+we+"."+(+Me+1)+".0",s("tilde return",Ge),Ge})}(Ve,Be)}).join(" ")}(We,qe),s("tildes",We),We=function(Ne,Be){return s("replaceXRanges",Ne,Be),Ne.split(/\s+/).map(function(Ve){return function(K,le){K=K.trim();var ge=le?k[M]:k[D];return K.replace(ge,function(ve,we,Me,Ue,He,Ge){s("xRange",K,ve,we,Me,Ue,He,Ge);var Ke=Oe(Me),Ye=Ke||Oe(Ue),Ze=Ye||Oe(He);return we==="="&&Ze&&(we=""),Ke?ve=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ue=0),Ze&&(He=0),we===">"?(we=">=",Ye?(Me=+Me+1,Ue=0,He=0):Ze&&(Ue=+Ue+1,He=0)):we==="<="&&(we="<",Ye?Me=+Me+1:Ue=+Ue+1),ve=we+Me+"."+Ue+"."+He):Ye?ve=">="+Me+".0.0 <"+(+Me+1)+".0.0":Ze&&(ve=">="+Me+"."+Ue+".0 <"+Me+"."+(+Ue+1)+".0"),s("xRange return",ve),ve})}(Ve,Be)}).join(" ")}(We,qe),s("xrange",We),We=function(Ne,Be){return s("replaceStars",Ne,Be),Ne.trim().replace(k[Y],"")}(We,qe),s("stars",We),We}(Te,ue)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Te){return!!Te.match(Ee)})),Ae=Ae.map(function(Te){return new be(Te,ue)})},Le.prototype.intersects=function(Z,ue){if(!(Z instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return Z.set.some(function(Ae){return Ae.every(function(Te){return Ee.intersects(Te,ue)})})})})},e.toComparators=function(Z,ue){return new Le(Z,ue).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new _(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(me(this.set[ue],Z))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Z,ue,fe){var Ee=null,Ae=null;try{var Te=new Le(ue,fe)}catch{return null}return Z.forEach(function(We){Te.test(We)&&(Ee&&Ae.compare(We)!==-1||(Ae=new _(Ee=We,fe)))}),Ee},e.minSatisfying=function(Z,ue,fe){var Ee=null,Ae=null;try{var Te=new Le(ue,fe)}catch{return null}return Z.forEach(function(We){Te.test(We)&&(Ee&&Ae.compare(We)!==1||(Ae=new _(Ee=We,fe)))}),Ee},e.validRange=function(Z,ue){try{return new Le(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,fe){return Ce(Z,ue,"<",fe)},e.gtr=function(Z,ue,fe){return Ce(Z,ue,">",fe)},e.outside=Ce,e.prerelease=function(Z,ue){var fe=se(Z,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Z,ue,fe){return Z=new Le(Z,fe),ue=new Le(ue,fe),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof _)return Z;if(typeof Z!="string")return null;var ue=Z.match(k[T]);return ue==null?null:se((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,I(1))},function(x,e){var I,L,s=x.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function k(r){if(I===setTimeout)return setTimeout(r,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(r,0);try{return I(r,0)}catch{try{return I.call(null,r,0)}catch{return I.call(this,r,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var f,u=[],p=!1,y=-1;function b(){p&&f&&(p=!1,f.length?u=f.concat(u):y=-1,u.length&&d())}function d(){if(!p){var r=k(b);p=!0;for(var g=u.length;g;){for(f=u,u=[];++y<g;)f&&f[y].run();y=-1,g=u.length}f=null,p=!1,function(h){if(L===clearTimeout)return clearTimeout(h);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(h);try{L(h)}catch{try{return L.call(null,h)}catch{return L.call(this,h)}}}(r)}}function E(r,g){this.fun=r,this.array=g}function v(){}s.nextTick=function(r){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];u.push(new E(r,g)),u.length!==1||p||k(d)},E.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=v,s.addListener=v,s.once=v,s.off=v,s.removeListener=v,s.removeAllListeners=v,s.emit=v,s.prependListener=v,s.prependOnceListener=v,s.listeners=function(r){return[]},s.binding=function(r){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(r){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ee[133],te([0,1]),function(x,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(k,f,u){this.level=k,this.key=f,this.value=u,this.forward=[]}}const s=void 0;class A{constructor(k,f=2**16){this.comparator=k,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new L(this.c,s,s)}get size(){return this.f}clear(){this.e=new L(this.c,s,s)}has(k){return Boolean(A.g(this,k,this.comparator))}get(k){return A.g(this,k,this.comparator)?.value}set(k,f){return A.h(this,k,f,this.comparator)&&(this.f+=1),this}delete(k){const f=A.k(this,k,this.comparator);return f&&(this.f-=1),f}forEach(k,f){let u=this.e.forward[0];for(;u;)k.call(f,u.value,u.key,this),u=u.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",f=this.e.forward[0];for(;f;)k+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return k}static g(k,f,u){let p=k.e;for(let y=k.d-1;y>=0;y--)for(;p.forward[y]&&u(p.forward[y].key,f)<0;)p=p.forward[y];if(p=p.forward[0],p&&u(p.key,f)===0)return p}static h(k,f,u,p){const y=[];let b=k.e;for(let d=k.d-1;d>=0;d--){for(;b.forward[d]&&p(b.forward[d].key,f)<0;)b=b.forward[d];y[d]=b}if(b=b.forward[0],b&&p(b.key,f)===0)return b.value=u,!1;{const d=A.j(k);if(d>k.d){for(let E=k.d;E<d;E++)y[E]=k.e;k.d=d}b=new L(d,f,u);for(let E=0;E<d;E++)b.forward[E]=y[E].forward[E],y[E].forward[E]=b;return!0}}static j(k,f=.5){let u=1;for(;Math.random()<f&&u<k.c;)u+=1;return u}static k(k,f,u){const p=[];let y=k.e;for(let b=k.d-1;b>=0;b--){for(;y.forward[b]&&u(y.forward[b].key,f)<0;)y=y.forward[b];p[b]=y}if(y=y.forward[0],!y||u(y.key,f)!==0)return!1;for(let b=0;b<k.d&&p[b].forward[b]===y;b++)p[b].forward[b]=y.forward[b];for(;k.d>0&&k.e.forward[k.d-1]===s;)k.d-=1;return!0}}e.SkipList=A}),define(ee[60],te([0,1,13,2]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function s(w){const C=w;return C?typeof C.read=="function":!1}e.isReadable=s;function A(w){const C=w;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function R(w){const C=w;return C?A(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=R;function k(w,C){return new f(w,C)}e.newWriteableStream=k;class f{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,I.onUnexpectedError)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let l;switch(C){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const i=l.indexOf(t);i>=0&&l.splice(i,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(w,C){const t=[];let l;for(;(l=w.read())!==null;)t.push(l);return C(t)}e.consumeReadable=u;function p(w,C,t){const l=[];let i;for(;(i=w.read())!==null&&l.length<t;)l.push(i);return i===null&&l.length>0?C(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return w.read()}}}e.peekReadable=p;function y(w,C){return new Promise((t,l)=>{const i=[];b(w,{onData:n=>{C&&i.push(n)},onError:n=>{C?l(n):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=y;function b(w,C){let t=!1;return w.on("error",l=>{t||C.onError(l)}),w.on("end",()=>{t||C.onEnd()}),w.on("data",l=>{t||C.onData(l)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=b;function d(w,C){return new Promise((t,l)=>{const i=new L.DisposableStore,n=[],a=m=>{if(n.push(m),n.length>C)return i.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},c=m=>l(m),o=()=>t({stream:w,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>w.removeListener("error",c))),w.on("error",c),i.add((0,L.toDisposable)(()=>w.removeListener("end",o))),w.on("end",o),i.add((0,L.toDisposable)(()=>w.removeListener("data",a))),w.on("data",a)})}e.peekStream=d;function E(w,C){const t=k(C);return t.end(w),t}e.toStream=E;function v(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=v;function r(w){let C=!1;return{read:()=>C?null:(C=!0,w)}}e.toReadable=r;function g(w,C,t){const l=k(t);return b(w,{onData:i=>l.write(C.data(i)),onError:i=>l.error(C.error?C.error(i):i),onEnd:()=>l.end()}),l}e.transform=g;function h(w,C,t){let l=!1;return{read:()=>{const i=C.read();return l?i:(l=!0,i!==null?t([w,i]):w)}}}e.prefixedReadable=h;function S(w,C,t){let l=!1;const i=k(t);return b(C,{onData:n=>l?i.write(n):(l=!0,i.write(t([w,n]))),onError:n=>i.error(n),onEnd:()=>{l||(l=!0,i.write(w)),i.end()}}),i}e.prefixedStream=S}),define(ee[17],te([0,1,60]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let s,A;class R{static alloc(m){return L?new R(Buffer.allocUnsafe(m)):new R(new Uint8Array(m))}static wrap(m){return L&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new R(m)}static fromString(m,D){return!(D?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(m)):(s||(s=new TextEncoder),new R(s.encode(m)))}static fromByteArray(m){const D=R.alloc(m.length);for(let M=0,T=m.length;M<T;M++)D.buffer[M]=m[M];return D}static concat(m,D){if(typeof D>"u"){D=0;for(let N=0,$=m.length;N<$;N++)D+=m[N].byteLength}const M=R.alloc(D);let T=0;for(let N=0,$=m.length;N<$;N++){const q=m[N];M.set(q,T),T+=q.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=R.alloc(this.byteLength);return m.set(this),m}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(m,D){return new R(this.buffer.subarray(m,D))}set(m,D){if(m instanceof R)this.buffer.set(m.buffer,D);else if(m instanceof Uint8Array)this.buffer.set(m,D);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),D);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,D){p(this.buffer,m,D)}readUInt32LE(m){return y(this.buffer,m)}writeUInt32LE(m,D){b(this.buffer,m,D)}readUInt8(m){return d(this.buffer,m)}writeUInt8(m,D){E(this.buffer,m,D)}}e.VSBuffer=R;function k(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0}e.readUInt16LE=k;function f(o,m,D){o[D+0]=m&255,m=m>>>8,o[D+1]=m&255}e.writeUInt16LE=f;function u(o,m){return o[m]*2**24+o[m+1]*2**16+o[m+2]*2**8+o[m+3]}e.readUInt32BE=u;function p(o,m,D){o[D+3]=m,m=m>>>8,o[D+2]=m,m=m>>>8,o[D+1]=m,m=m>>>8,o[D]=m}e.writeUInt32BE=p;function y(o,m){return o[m+0]<<0>>>0|o[m+1]<<8>>>0|o[m+2]<<16>>>0|o[m+3]<<24>>>0}e.readUInt32LE=y;function b(o,m,D){o[D+0]=m&255,m=m>>>8,o[D+1]=m&255,m=m>>>8,o[D+2]=m&255,m=m>>>8,o[D+3]=m&255}e.writeUInt32LE=b;function d(o,m){return o[m]}e.readUInt8=d;function E(o,m,D){o[D]=m}e.writeUInt8=E;function v(o){return I.consumeReadable(o,m=>R.concat(m))}e.readableToBuffer=v;function r(o){return I.toReadable(o)}e.bufferToReadable=r;function g(o){return I.consumeStream(o,m=>R.concat(m))}e.streamToBuffer=g;async function h(o){return o.ended?R.concat(o.buffer):R.concat([...o.buffer,await g(o.stream)])}e.bufferedStreamToBuffer=h;function S(o){return I.toStream(o,m=>R.concat(m))}e.bufferToStream=S;function w(o){return I.transform(o,{data:m=>typeof m=="string"?R.fromString(m):R.wrap(m)},m=>R.concat(m))}e.streamToBufferReadableStream=w;function C(o){return I.newWriteableStream(m=>R.concat(m),o)}e.newWriteableBufferStream=C;function t(o,m){return I.prefixedReadable(o,m,D=>R.concat(D))}e.prefixedBufferReadable=t;function l(o,m){return I.prefixedStream(o,m,D=>R.concat(D))}e.prefixedBufferStream=l;function i(o){let m=0,D=0,M=0;const T=new Uint8Array(Math.floor(o.length/4*3)),N=q=>{switch(D){case 3:T[M++]=m|q,D=0;break;case 2:T[M++]=m|q>>>2,m=q<<6,D=3;break;case 1:T[M++]=m|q>>>4,m=q<<4,D=2;break;default:m=q<<2,D=1}};for(let q=0;q<o.length;q++){const ie=o.charCodeAt(q);if(ie>=65&&ie<=90)N(ie-65);else if(ie>=97&&ie<=122)N(ie-97+26);else if(ie>=48&&ie<=57)N(ie-48+52);else if(ie===43||ie===45)N(62);else if(ie===47||ie===95)N(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[q]}`)}}const $=M;for(;D>0;)N(0);return R.wrap(T).slice(0,$)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},m=!0,D=!1){const M=D?a:n;let T="";const N=o.byteLength%3;let $=0;for(;$<o.byteLength-N;$+=3){const q=o[$+0],ie=o[$+1],oe=o[$+2];T+=M[q>>>2],T+=M[(q<<4|ie>>>4)&63],T+=M[(ie<<2|oe>>>6)&63],T+=M[oe&63]}if(N===1){const q=o[$+0];T+=M[q>>>2],T+=M[q<<4&63],m&&(T+="==")}else if(N===2){const q=o[$+0],ie=o[$+1];T+=M[q>>>2],T+=M[(q<<4|ie>>>4)&63],T+=M[ie<<2&63],m&&(T+="=")}return T}e.encodeBase64=c}),define(ee[134],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[11],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(l){return typeof l=="string"}e.isString=I;function L(l){return Array.isArray(l)&&l.every(i=>I(i))}e.isStringArray=L;function s(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=s;function A(l){const i=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof i}e.isTypedArray=A;function R(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=R;function k(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=k;function f(l){return l===!0||l===!1}e.isBoolean=f;function u(l){return typeof l>"u"}e.isUndefined=u;function p(l){return!y(l)}e.isDefined=p;function y(l){return u(l)||l===null}e.isUndefinedOrNull=y;function b(l,i){if(!l)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function d(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=d;function E(...l){const i=[];for(let n=0;n<l.length;n++){const a=l[n];if(y(a))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(a)}return i}e.assertAllDefined=E;const v=Object.prototype.hasOwnProperty;function r(l){if(!s(l))return!1;for(const i in l)if(v.call(l,i))return!1;return!0}e.isEmptyObject=r;function g(l){return typeof l=="function"}e.isFunction=g;function h(...l){return l.length>0&&l.every(g)}e.areFunctions=h;function S(l,i){const n=Math.min(l.length,i.length);for(let a=0;a<n;a++)w(l[a],i[a])}e.validateConstraints=S;function w(l,i){if(I(i)){if(typeof l!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(l instanceof i)return}catch{}if(!y(l)&&l.constructor===i||i.length===1&&i.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function C(l){return l===null?void 0:l}e.withNullAsUndefined=C;function t(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=t}),define(ee[135],te([0,1,11]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function s(k,f){if((0,I.isString)(f)){const u=L[f];if(u===void 0)throw new Error(`${k} references an unknown codicon: ${f}`);f=u}return L[k]=f,{id:k}}function A(){return L}e.getCodiconFontCharacters=A;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([S,w])=>{h[S]=w&&typeof w=="object"?L(w):w}),h}e.deepClone=L;function s(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const S=h.shift();Object.freeze(S);for(const w in S)if(A.call(S,w)){const C=S[w];typeof C=="object"&&!Object.isFrozen(C)&&!(0,I.isTypedArray)(C)&&h.push(C)}}return g}e.deepFreeze=s;const A=Object.prototype.hasOwnProperty;function R(g,h){return k(g,h,new Set)}e.cloneAndChange=R;function k(g,h,S){if((0,I.isUndefinedOrNull)(g))return g;const w=h(g);if(typeof w<"u")return w;if(Array.isArray(g)){const C=[];for(const t of g)C.push(k(t,h,S));return C}if((0,I.isObject)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const C={};for(const t in g)A.call(g,t)&&(C[t]=k(g[t],h,S));return S.delete(g),C}return g}function f(g,h,S=!0){return(0,I.isObject)(g)?((0,I.isObject)(h)&&Object.keys(h).forEach(w=>{w in g?S&&((0,I.isObject)(g[w])&&(0,I.isObject)(h[w])?f(g[w],h[w],S):g[w]=h[w]):g[w]=h[w]}),g):h}e.mixin=f;function u(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let S,w;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(S=0;S<g.length;S++)if(!u(g[S],h[S]))return!1}else{const C=[];for(w in g)C.push(w);C.sort();const t=[];for(w in h)t.push(w);if(t.sort(),!u(C,t))return!1;for(S=0;S<C.length;S++)if(!u(g[C[S]],h[C[S]]))return!1}return!0}e.equals=u;function p(g){const h=new Set;return JSON.stringify(g,(S,w)=>{if((0,I.isObject)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.safeStringify=p;function y(g,h){const S=Object.create(null);return!g||!h||Object.keys(h).forEach(C=>{const t=g[C],l=h[C];u(t,l)||(S[C]=l)}),S}e.distinct=y;function b(g,h){const S=h.toLowerCase(),w=Object.keys(g).find(C=>C.toLowerCase()===S);return w?g[w]:g[h]}e.getCaseInsensitive=b;function d(g,h){const S=Object.create(null);for(const[w,C]of Object.entries(g))h(w,C)&&(S[w]=C);return S}e.filter=d;function E(g){let h=[],S=Object.getPrototypeOf(g);for(;Object.prototype!==S;)h=h.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return h}e.getAllPropertyNames=E;function v(g){const h=[];for(const S of E(g))typeof g[S]=="function"&&h.push(S);return h}e.getAllMethodNames=v;function r(g,h){const S=C=>function(){const t=Array.prototype.slice.call(arguments,0);return h(C,t)},w={};for(const C of g)w[C]=S(C);return w}e.createProxyObject=r}),define(ee[136],te([0,1,135]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function k(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=k})(L=e.ThemeColor||(e.ThemeColor={}));function s(R){return{id:R}}e.themeColorFromId=s;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(h){const S=k.exec(h.id);if(!S)return f(I.Codicon.error);const[,w,C]=S,t=["codicon","codicon-"+w];return C&&t.push("codicon-modifier-"+C.substring(1)),t}R.asClassNameArray=f;function u(h){return f(h).join(" ")}R.asClassName=u;function p(h){return"."+f(h).join(".")}R.asCSSSelector=p;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||L.isThemeColor(h.color))}R.isThemeIcon=y;const b=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function d(h){const S=b.exec(h);if(!S)return;const[,w]=S;return{id:w}}R.fromString=d;function E(h){return{id:h}}R.fromId=E;function v(h,S){let w=h.id;const C=w.lastIndexOf("~");return C!==-1&&(w=w.substring(0,C)),S&&(w=`${w}~${S}`),{id:w}}R.modify=v;function r(h){const S=h.id.lastIndexOf("~");if(S!==-1)return h.id.substring(S+1)}R.getModifier=r;function g(h,S){return h.id===S.id&&h.color?.id===S.color?.id}R.isEqual=g})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(s){return I.test(s)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(k){for(let f=0;f<k.length;f++)k[f]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),R=[];for(let k=0;k<256;k++)R.push(k.toString(16).padStart(2,"0"));return function(){s(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,u="";return u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u}}()}),define(ee[137],te([0,1,83,41,50]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(R,k){if(await new Promise((p,y)=>{const b=L.createReadStream(R),d=I.createHash("sha1");b.pipe(d);const E=(0,s.once)((v,r)=>{b.removeAllListeners(),d.removeAllListeners(),v?y(v):p(r)});b.once("error",E),b.once("end",E),d.once("error",E),d.once("data",v=>E(void 0,v.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[138],te([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(R){const k=R.replace(/\-/g,":").toLowerCase();return!L.has(k)}function A(){const R=(0,I.networkInterfaces)();for(const k in R){const f=R[k];if(f){for(const{mac:u}of f)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[101],te([0,1,84]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(k,f,u,p=1){let y=!1;return new Promise(b=>{const d=setTimeout(()=>{if(!y)return y=!0,b(0)},u);s(k,f,p,E=>{if(!y)return y=!0,clearTimeout(d),b(E)})})}e.findFreePort=L;function s(k,f,u,p){if(f===0)return p(0);const y=new I.Socket;y.once("connect",()=>(R(y),s(k+u,f-1,u,p))),y.once("data",()=>{}),y.once("error",b=>(R(y),b.code!=="ECONNREFUSED"?s(k+u,f-1,u,p):p(k))),y.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,f,u,p="127.0.0.1"){let y=!1,b,d=1;const E=I.createServer({pauseOnConnect:!0});function v(r,g){y||(y=!0,E.removeAllListeners(),E.close(),b&&clearTimeout(b),g(r))}return new Promise(r=>{b=setTimeout(()=>{v(0,r)},u),E.on("listening",()=>{v(k,r)}),E.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&d<f?(k++,d++,E.listen(k,p)):v(0,r)}),E.on("close",()=>{v(0,r)}),E.listen(k,p)})}e.findFreePortFaster=A;function R(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(f){console.error(f)}}}),define(ee[139],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[140],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(s,A){this.a=s,this.onMessage=A}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[42],te([0,1,14,13]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class s{constructor(){this.a=new WeakMap}on(R,k){const f=(u,...p)=>{this.b(R,u)&&k(u,...p)};return this.a.set(k,f),I.ipcMain.on(R,f),this}once(R,k){return I.ipcMain.once(R,(f,...u)=>{this.b(R,f)&&k(f,...u)}),this}handle(R,k){return I.ipcMain.handle(R,(f,...u)=>this.b(R,f)?k(f,...u):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return I.ipcMain.removeHandler(R),this}removeListener(R,k){const f=this.a.get(k);return f&&(I.ipcMain.removeListener(R,f),this.a.delete(k)),this}b(R,k){if(!R||!R.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const f=k.senderFrame,u=f.url;if(!u)return!0;let p="unknown";try{p=new URL(u).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${u}'.`),!1}return p!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${p}'.`),!1):f.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new s}),define(ee[141],te([0,1,14,42,11,139]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(f,u,p,y,b)=>{const d=k(f,y,p);d.popup({window:(0,s.withNullAsUndefined)(I.BrowserWindow.fromWebContents(f.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{d&&f.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,u)}})})}e.registerContextMenuListener=R;function k(f,u,p){const y=new I.Menu;return p.forEach(b=>{let d;b.type==="separator"?d=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?d=new I.MenuItem({submenu:k(f,u,b.submenu),label:b.label}):d=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(E,v,r)=>f.sender.send(u,b.id,r)}),y.append(d)}),y}}),define(ee[72],te([0,1,14]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=I.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[142],te([12,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(ee[143],te([0,1,142]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,s=L*60,A=s*24,R=A*7,k=A*30,f=A*365;function u(y,b,d,E){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,I.localize)(0,null,u(new Date().getTime()+v*1e3,!1));if(!E&&v<30)return(0,I.localize)(1,null);let r;return v<L?(r=v,b?r===1?d?(0,I.localize)(2,null,r):(0,I.localize)(3,null,r):d?(0,I.localize)(4,null,r):(0,I.localize)(5,null,r):r===1?d?(0,I.localize)(6,null,r):(0,I.localize)(7,null,r):d?(0,I.localize)(8,null,r):(0,I.localize)(9,null,r)):v<s?(r=Math.floor(v/L),b?r===1?d?(0,I.localize)(10,null,r):(0,I.localize)(11,null,r):d?(0,I.localize)(12,null,r):(0,I.localize)(13,null,r):r===1?d?(0,I.localize)(14,null,r):(0,I.localize)(15,null,r):d?(0,I.localize)(16,null,r):(0,I.localize)(17,null,r)):v<A?(r=Math.floor(v/s),b?r===1?d?(0,I.localize)(18,null,r):(0,I.localize)(19,null,r):d?(0,I.localize)(20,null,r):(0,I.localize)(21,null,r):r===1?d?(0,I.localize)(22,null,r):(0,I.localize)(23,null,r):d?(0,I.localize)(24,null,r):(0,I.localize)(25,null,r)):v<R?(r=Math.floor(v/A),b?r===1?(0,I.localize)(26,null,r):(0,I.localize)(27,null,r):r===1?(0,I.localize)(28,null,r):(0,I.localize)(29,null,r)):v<k?(r=Math.floor(v/R),b?r===1?d?(0,I.localize)(30,null,r):(0,I.localize)(31,null,r):d?(0,I.localize)(32,null,r):(0,I.localize)(33,null,r):r===1?d?(0,I.localize)(34,null,r):(0,I.localize)(35,null,r):d?(0,I.localize)(36,null,r):(0,I.localize)(37,null,r)):v<f?(r=Math.floor(v/k),b?r===1?d?(0,I.localize)(38,null,r):(0,I.localize)(39,null,r):d?(0,I.localize)(40,null,r):(0,I.localize)(41,null,r):r===1?d?(0,I.localize)(42,null,r):(0,I.localize)(43,null,r):d?(0,I.localize)(44,null,r):(0,I.localize)(45,null,r)):(r=Math.floor(v/f),b?r===1?d?(0,I.localize)(46,null,r):(0,I.localize)(47,null,r):d?(0,I.localize)(48,null,r):(0,I.localize)(49,null,r):r===1?d?(0,I.localize)(50,null,r):(0,I.localize)(51,null,r):d?(0,I.localize)(52,null,r):(0,I.localize)(53,null,r))}e.fromNow=u;function p(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ee[144],te([12,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,22,11,144]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(y,b){return b&&(y.stack||y.stacktrace)?s.localize(0,null,k(y),R(y.stack)||R(y.stacktrace)):k(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?s.localize(1,null,y.message):y.message||s.localize(2,null)}function f(y=null,b=!1){if(!y)return s.localize(3,null);if(Array.isArray(y)){const d=I.coalesce(y),E=f(d[0],b);return d.length>1?s.localize(4,null,E,d.length):E}if(L.isString(y))return y;if(y.detail){const d=y.detail;if(d.error)return A(d.error,b);if(d.exception)return A(d.exception,b)}return y.stack?A(y,b):y.message?y.message:s.localize(5,null)}e.toErrorMessage=f;function u(y){const b=y;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=u;function p(y,b){let d;return typeof y=="string"?d=new Error(y):d=y,d.actions=b,d}e.createErrorWithActions=p}),define(ee[145],te([12,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(ee[146],te([0,1,145]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(s){switch(s){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[147],te([12,10]),function(x,e){return x.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,147]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,s=!1,A=!1,R=!1,k=!1,f=!1,u=!1,p=!1,y=!1,b=!1,d,E=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,r,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const S=typeof h?.versions?.electron=="string",w=S&&h?.type==="renderer";if(typeof navigator=="object"&&!w)g=navigator.userAgent,L=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,b=g?.indexOf("Mobi")>=0,f=!0,d=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,E=d,v=navigator.language;else if(typeof h=="object"){L=h.platform==="win32",s=h.platform==="darwin",A=h.platform==="linux",R=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,u=S,y=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const m=h.env.VSCODE_NLS_CONFIG;if(m)try{const D=JSON.parse(m),M=D.availableLanguages["*"];d=D.locale,v=D.osLocale,E=M||e.LANGUAGE_DEFAULT,r=D._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var C;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function t(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let l=0;s?l=1:L?l=3:A&&(l=2),e.isWindows=L,e.isMacintosh=s,e.isLinux=A,e.isLinuxSnap=R,e.isNative=k,e.isElectron=u,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=b,e.isCI=y,e.platform=l,e.userAgent=g,e.language=E;var i;(function(m){function D(){return e.language}m.value=D;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}m.isDefaultVariant=M;function T(){return e.language==="en"}m.isDefault=T})(i=e.Language||(e.Language={})),e.locale=d,e.platformLocale=v,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const m=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,N=m.length;T<N;T++){const $=m[T];if($.id===M.data.vscodeScheduleAsyncWork){m.splice(T,1),$.callback();return}}});let D=0;return M=>{const T=++D;m.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return m=>setTimeout(m)})();var n;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=s||p?2:L?1:3;let a=!0,c=!1;function o(){if(!c){c=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,a=new Uint16Array(m.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const s=I.globals.vscode.process;L={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,36]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,s=97,A=90,R=122,k=46,f=47,u=92,p=58,y=63;class b extends Error{constructor(l,i,n){let a;typeof i=="string"&&i.indexOf("not ")===0?(a="must not be",i=i.replace(/^not /,"")):a="must be";const c=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${c} ${a} of type ${i}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,l){if(t===null||typeof t!="object")throw new b(l,"Object",t)}function E(t,l){if(typeof t!="string")throw new b(l,"string",t)}const v=I.platform==="win32";function r(t){return t===f||t===u}function g(t){return t===f}function h(t){return t>=L&&t<=A||t>=s&&t<=R}function S(t,l,i,n){let a="",c=0,o=-1,m=0,D=0;for(let M=0;M<=t.length;++M){if(M<t.length)D=t.charCodeAt(M);else{if(n(D))break;D=f}if(n(D)){if(!(o===M-1||m===1))if(m===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==k||a.charCodeAt(a.length-2)!==k){if(a.length>2){const T=a.lastIndexOf(i);T===-1?(a="",c=0):(a=a.slice(0,T),c=a.length-1-a.lastIndexOf(i)),o=M,m=0;continue}else if(a.length!==0){a="",c=0,o=M,m=0;continue}}l&&(a+=a.length>0?`${i}..`:"..",c=2)}else a.length>0?a+=`${i}${t.slice(o+1,M)}`:a=t.slice(o+1,M),c=M-o-1;o=M,m=0}else D===k&&m!==-1?++m:m=-1}return a}function w(t,l){d(l,"pathObject");const i=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return i?i===l.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let l="",i="",n=!1;for(let a=t.length-1;a>=-1;a--){let c;if(a>=0){if(c=t[a],E(c,"path"),c.length===0)continue}else l.length===0?c=I.cwd():(c=I.env[`=${l}`]||I.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==l.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${l}\\`));const o=c.length;let m=0,D="",M=!1;const T=c.charCodeAt(0);if(o===1)r(T)&&(m=1,M=!0);else if(r(T))if(M=!0,r(c.charCodeAt(1))){let N=2,$=N;for(;N<o&&!r(c.charCodeAt(N));)N++;if(N<o&&N!==$){const q=c.slice($,N);for($=N;N<o&&r(c.charCodeAt(N));)N++;if(N<o&&N!==$){for($=N;N<o&&!r(c.charCodeAt(N));)N++;(N===o||N!==$)&&(D=`\\\\${q}\\${c.slice($,N)}`,m=N)}}}else m=1;else h(T)&&c.charCodeAt(1)===p&&(D=c.slice(0,2),m=2,o>2&&r(c.charCodeAt(2))&&(M=!0,m=3));if(D.length>0)if(l.length>0){if(D.toLowerCase()!==l.toLowerCase())continue}else l=D;if(n){if(l.length>0)break}else if(i=`${c.slice(m)}\\${i}`,n=M,M&&l.length>0)break}return i=S(i,!n,"\\",r),n?`${l}\\${i}`:`${l}${i}`||"."},normalize(t){E(t,"path");const l=t.length;if(l===0)return".";let i=0,n,a=!1;const c=t.charCodeAt(0);if(l===1)return g(c)?"\\":t;if(r(c))if(a=!0,r(t.charCodeAt(1))){let m=2,D=m;for(;m<l&&!r(t.charCodeAt(m));)m++;if(m<l&&m!==D){const M=t.slice(D,m);for(D=m;m<l&&r(t.charCodeAt(m));)m++;if(m<l&&m!==D){for(D=m;m<l&&!r(t.charCodeAt(m));)m++;if(m===l)return`\\\\${M}\\${t.slice(D)}\\`;m!==D&&(n=`\\\\${M}\\${t.slice(D,m)}`,i=m)}}}else i=1;else h(c)&&t.charCodeAt(1)===p&&(n=t.slice(0,2),i=2,l>2&&r(t.charCodeAt(2))&&(a=!0,i=3));let o=i<l?S(t.slice(i),!a,"\\",r):"";return o.length===0&&!a&&(o="."),o.length>0&&r(t.charCodeAt(l-1))&&(o+="\\"),n===void 0?a?`\\${o}`:o:a?`${n}\\${o}`:`${n}${o}`},isAbsolute(t){E(t,"path");const l=t.length;if(l===0)return!1;const i=t.charCodeAt(0);return r(i)||l>2&&h(i)&&t.charCodeAt(1)===p&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,i;for(let c=0;c<t.length;++c){const o=t[c];E(o,"path"),o.length>0&&(l===void 0?l=i=o:l+=`\\${o}`)}if(l===void 0)return".";let n=!0,a=0;if(typeof i=="string"&&r(i.charCodeAt(0))){++a;const c=i.length;c>1&&r(i.charCodeAt(1))&&(++a,c>2&&(r(i.charCodeAt(2))?++a:n=!1))}if(n){for(;a<l.length&&r(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l)return"";const i=e.win32.resolve(t),n=e.win32.resolve(l);if(i===n||(t=i.toLowerCase(),l=n.toLowerCase(),t===l))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===u;)a++;let c=t.length;for(;c-1>a&&t.charCodeAt(c-1)===u;)c--;const o=c-a;let m=0;for(;m<l.length&&l.charCodeAt(m)===u;)m++;let D=l.length;for(;D-1>m&&l.charCodeAt(D-1)===u;)D--;const M=D-m,T=o<M?o:M;let N=-1,$=0;for(;$<T;$++){const ie=t.charCodeAt(a+$);if(ie!==l.charCodeAt(m+$))break;ie===u&&(N=$)}if($!==T){if(N===-1)return n}else{if(M>T){if(l.charCodeAt(m+$)===u)return n.slice(m+$+1);if($===2)return n.slice(m+$)}o>T&&(t.charCodeAt(a+$)===u?N=$:$===2&&(N=3)),N===-1&&(N=0)}let q="";for($=a+N+1;$<=c;++$)($===c||t.charCodeAt($)===u)&&(q+=q.length===0?"..":"\\..");return m+=N,q.length>0?`${q}${n.slice(m,D)}`:(n.charCodeAt(m)===u&&++m,n.slice(m,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const i=l.charCodeAt(2);if(i!==y&&i!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===p&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return t},dirname(t){E(t,"path");const l=t.length;if(l===0)return".";let i=-1,n=0;const a=t.charCodeAt(0);if(l===1)return r(a)?t:".";if(r(a)){if(i=n=1,r(t.charCodeAt(1))){let m=2,D=m;for(;m<l&&!r(t.charCodeAt(m));)m++;if(m<l&&m!==D){for(D=m;m<l&&r(t.charCodeAt(m));)m++;if(m<l&&m!==D){for(D=m;m<l&&!r(t.charCodeAt(m));)m++;if(m===l)return t;m!==D&&(i=n=m+1)}}}}else h(a)&&t.charCodeAt(1)===p&&(i=l>2&&r(t.charCodeAt(2))?3:2,n=i);let c=-1,o=!0;for(let m=l-1;m>=n;--m)if(r(t.charCodeAt(m))){if(!o){c=m;break}}else o=!1;if(c===-1){if(i===-1)return".";c=i}return t.slice(0,c)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let i=0,n=-1,a=!0,c;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(i=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let o=l.length-1,m=-1;for(c=t.length-1;c>=i;--c){const D=t.charCodeAt(c);if(r(D)){if(!a){i=c+1;break}}else m===-1&&(a=!1,m=c+1),o>=0&&(D===l.charCodeAt(o)?--o===-1&&(n=c):(o=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(c=t.length-1;c>=i;--c)if(r(t.charCodeAt(c))){if(!a){i=c+1;break}}else n===-1&&(a=!1,n=c+1);return n===-1?"":t.slice(i,n)},extname(t){E(t,"path");let l=0,i=-1,n=0,a=-1,c=!0,o=0;t.length>=2&&t.charCodeAt(1)===p&&h(t.charCodeAt(0))&&(l=n=2);for(let m=t.length-1;m>=l;--m){const D=t.charCodeAt(m);if(r(D)){if(!c){n=m+1;break}continue}a===-1&&(c=!1,a=m+1),D===k?i===-1?i=m:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||a===-1||o===0||o===1&&i===a-1&&i===n+1?"":t.slice(i,a)},format:w.bind(null,"\\"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const i=t.length;let n=0,a=t.charCodeAt(0);if(i===1)return r(a)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(r(a)){if(n=1,r(t.charCodeAt(1))){let N=2,$=N;for(;N<i&&!r(t.charCodeAt(N));)N++;if(N<i&&N!==$){for($=N;N<i&&r(t.charCodeAt(N));)N++;if(N<i&&N!==$){for($=N;N<i&&!r(t.charCodeAt(N));)N++;N===i?n=N:N!==$&&(n=N+1)}}}}else if(h(a)&&t.charCodeAt(1)===p){if(i<=2)return l.root=l.dir=t,l;if(n=2,r(t.charCodeAt(2))){if(i===3)return l.root=l.dir=t,l;n=3}}n>0&&(l.root=t.slice(0,n));let c=-1,o=n,m=-1,D=!0,M=t.length-1,T=0;for(;M>=n;--M){if(a=t.charCodeAt(M),r(a)){if(!D){o=M+1;break}continue}m===-1&&(D=!1,m=M+1),a===k?c===-1?c=M:T!==1&&(T=1):c!==-1&&(T=-1)}return m!==-1&&(c===-1||T===0||T===1&&c===m-1&&c===o+1?l.base=l.name=t.slice(o,m):(l.name=t.slice(o,c),l.base=t.slice(o,m),l.ext=t.slice(c,m))),o>0&&o!==n?l.dir=t.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(v){const t=/\\/g;return()=>{const l=I.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let l="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const a=n>=0?t[n]:C();E(a,"path"),a.length!==0&&(l=`${a}/${l}`,i=a.charCodeAt(0)===f)}return l=S(l,!i,"/",g),i?`/${l}`:l.length>0?l:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=S(t,!l,"/",g),t.length===0?l?"/":i?"./":".":(i&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let i=0;i<t.length;++i){const n=t[i];E(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const i=1,n=t.length,a=n-i,c=1,o=l.length-c,m=a<o?a:o;let D=-1,M=0;for(;M<m;M++){const N=t.charCodeAt(i+M);if(N!==l.charCodeAt(c+M))break;N===f&&(D=M)}if(M===m)if(o>m){if(l.charCodeAt(c+M)===f)return l.slice(c+M+1);if(M===0)return l.slice(c+M)}else a>m&&(t.charCodeAt(i+M)===f?D=M:M===0&&(D=0));let T="";for(M=i+D+1;M<=n;++M)(M===n||t.charCodeAt(M)===f)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(c+D)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let i=-1,n=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===f){if(!n){i=a;break}}else n=!1;return i===-1?l?"/":".":l&&i===1?"//":t.slice(0,i)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let i=0,n=-1,a=!0,c;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let o=l.length-1,m=-1;for(c=t.length-1;c>=0;--c){const D=t.charCodeAt(c);if(D===f){if(!a){i=c+1;break}}else m===-1&&(a=!1,m=c+1),o>=0&&(D===l.charCodeAt(o)?--o===-1&&(n=c):(o=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===f){if(!a){i=c+1;break}}else n===-1&&(a=!1,n=c+1);return n===-1?"":t.slice(i,n)},extname(t){E(t,"path");let l=-1,i=0,n=-1,a=!0,c=0;for(let o=t.length-1;o>=0;--o){const m=t.charCodeAt(o);if(m===f){if(!a){i=o+1;break}continue}n===-1&&(a=!1,n=o+1),m===k?l===-1?l=o:c!==1&&(c=1):l!==-1&&(c=-1)}return l===-1||n===-1||c===0||c===1&&l===n-1&&l===i+1?"":t.slice(l,n)},format:w.bind(null,"/"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const i=t.charCodeAt(0)===f;let n;i?(l.root="/",n=1):n=0;let a=-1,c=0,o=-1,m=!0,D=t.length-1,M=0;for(;D>=n;--D){const T=t.charCodeAt(D);if(T===f){if(!m){c=D+1;break}continue}o===-1&&(m=!1,o=D+1),T===k?a===-1?a=D:M!==1&&(M=1):a!==-1&&(M=-1)}if(o!==-1){const T=c===0&&i?1:c;a===-1||M===0||M===1&&a===o-1&&a===c+1?l.base=l.name=t.slice(T,o):(l.name=t.slice(T,a),l.base=t.slice(T,o),l.ext=t.slice(a,o))}return c>0?l.dir=t.slice(0,c-1):i&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[73],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var s;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(s=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...f){const u=f.reduce((b,d)=>(b[d]=!0,b),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(b=>!u[b]).forEach(b=>{for(let d=0;d<p.length;d++)if(b.search(p[d])!==-1){delete k[b];break}})}e.sanitizeProcessEnvironment=A;function R(k){!k||(delete k.DEBUG,I.isMacintosh&&delete k.DYLD_LIBRARY_PATH,I.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ee[74],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=I.globals.performance&&typeof I.globals.performance.now=="function";class s{static create(R=!0){return new s(R)}constructor(R){this.a=L&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=s}),define(ee[3],te([0,1,13,50,2,100,74]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,f=!1;var u;(function(c){c.None=()=>s.Disposable.None;function o(F){if(f){const{onDidAddListener:U}=F,j=E.create();let B=0;F.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),U?.()}}}function m(F,U){return ae(F,()=>{},0,void 0,!0,void 0,U)}c.defer=m;function D(F){return(U,j=null,B)=>{let z=!1,G;return G=F(re=>{if(!z)return G?G.dispose():z=!0,U.call(j,re)},null,B),z&&G.dispose(),G}}c.once=D;function M(F,U,j){return oe((B,z=null,G)=>F(re=>B.call(z,U(re)),null,G),j)}c.map=M;function T(F,U,j){return oe((B,z=null,G)=>F(re=>{U(re),B.call(z,re)},null,G),j)}c.forEach=T;function N(F,U,j){return oe((B,z=null,G)=>F(re=>U(re)&&B.call(z,re),null,G),j)}c.filter=N;function $(F){return F}c.signal=$;function q(...F){return(U,j=null,B)=>(0,s.combinedDisposable)(...F.map(z=>z(G=>U.call(j,G),null,B)))}c.any=q;function ie(F,U,j,B){let z=j;return M(F,G=>(z=U(z,G),z),B)}c.reduce=ie;function oe(F,U){let j;const B={onWillAddFirstListener(){j=F(z.fire,z)},onDidRemoveLastListener(){j?.dispose()}};U||o(B);const z=new r(B);return U?.add(z),z.event}function ae(F,U,j=100,B=!1,z=!1,G,re){let he,be,ke,Le=0,Oe;const Fe={leakWarningThreshold:G,onWillAddFirstListener(){he=F(pe=>{Le++,be=U(be,pe),B&&!ke&&(me.fire(be),be=void 0),Oe=()=>{const Ce=be;be=void 0,ke=void 0,(!B||Le>1)&&me.fire(Ce),Le=0},typeof j=="number"?(clearTimeout(ke),ke=setTimeout(Oe,j)):ke===void 0&&(ke=0,queueMicrotask(Oe))})},onWillRemoveListener(){z&&Le>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,he.dispose()}};re||o(Fe);const me=new r(Fe);return re?.add(me),me.event}c.debounce=ae;function de(F,U=0,j){return c.debounce(F,(B,z)=>B?(B.push(z),B):[z],U,void 0,!0,void 0,j)}c.accumulate=de;function ce(F,U=(B,z)=>B===z,j){let B=!0,z;return N(F,G=>{const re=B||!U(G,z);return B=!1,z=G,re},j)}c.latch=ce;function X(F,U,j){return[c.filter(F,U,j),c.filter(F,B=>!U(B),j)]}c.split=X;function J(F,U=!1,j=[]){let B=j.slice(),z=F(he=>{B?B.push(he):re.fire(he)});const G=()=>{B?.forEach(he=>re.fire(he)),B=null},re=new r({onWillAddFirstListener(){z||(z=F(he=>re.fire(he)))},onDidAddFirstListener(){B&&(U?setTimeout(G):G())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return re.event}c.buffer=J;class H{constructor(U){this.event=U,this.c=new s.DisposableStore}map(U){return new H(M(this.event,U,this.c))}forEach(U){return new H(T(this.event,U,this.c))}filter(U){return new H(N(this.event,U,this.c))}reduce(U,j){return new H(ie(this.event,U,j,this.c))}latch(){return new H(ce(this.event,void 0,this.c))}debounce(U,j=100,B=!1,z=!1,G){return new H(ae(this.event,U,j,B,z,G,this.c))}on(U,j,B){return this.event(U,j,B)}once(U,j,B){return D(this.event)(U,j,B)}dispose(){this.c.dispose()}}function W(F){return new H(F)}c.chain=W;function V(F,U,j=B=>B){const B=(...he)=>re.fire(j(...he)),z=()=>F.on(U,B),G=()=>F.removeListener(U,B),re=new r({onWillAddFirstListener:z,onDidRemoveLastListener:G});return re.event}c.fromNodeEventEmitter=V;function Y(F,U,j=B=>B){const B=(...he)=>re.fire(j(...he)),z=()=>F.addEventListener(U,B),G=()=>F.removeEventListener(U,B),re=new r({onWillAddFirstListener:z,onDidRemoveLastListener:G});return re.event}c.fromDOMEventEmitter=Y;function ne(F){return new Promise(U=>D(F)(U))}c.toPromise=ne;function se(F,U){return U(void 0),F(j=>U(j))}c.runAndSubscribe=se;function _(F,U){let j=null;function B(G){j?.dispose(),j=new s.DisposableStore,U(G,j)}B(void 0);const z=F(G=>B(G));return(0,s.toDisposable)(()=>{z.dispose(),j?.dispose()})}c.runAndSubscribeWithStore=_;class O{constructor(U,j){this.obs=U,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};j||o(B),this.emitter=new r(B),j&&j.add(this.emitter)}beginUpdate(U){this.c++}handleChange(U,j){this.d=!0}endUpdate(U){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function P(F,U){return new O(F,U).emitter.event}c.fromObservable=P})(u=e.Event||(e.Event={}));class p{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${p.c++}`,p.all.add(this)}start(o){this.d=new R.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}p.all=new Set,p.c=0,e.EventProfiling=p;let y=-1;function b(c){const o=y;return y=c,{dispose(){y=o}}}e.setGlobalLeakWarningThreshold=b;class d{constructor(o,m=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=m,this.d=0}dispose(){this.c?.clear()}check(o,m){const D=this.threshold;if(D<=0||m<D)return;this.c||(this.c=new Map);const M=this.c.get(o.value)||0;if(this.c.set(o.value,M+1),this.d-=1,this.d<=0){this.d=D*.5;let T,N=0;for(const[$,q]of this.c)(!T||N<q)&&(T=$,N=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(o.value)||0;this.c.set(o.value,T-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(o,m,D){this.callback=o,this.callbackThis=m,this.stack=D,this.subscription=new s.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class r{constructor(o){this.j=!1,this.d=o,this.f=y>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const o=Array.from(this.q);queueMicrotask(()=>{for(const m of o)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,m,D)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=E.create(),T=this.f.check(N,this.q.size+1)),k&&(N=N??E.create());const $=new v(o,m,N),q=this.q.push($);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,m);const ie=$.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof s.DisposableStore?D.add(ie):Array.isArray(D)&&D.push(ie),ie}),this.l}fire(o){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const m of this.q)this.m.push(this,m,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class g{constructor(o=I.onUnexpectedError){this.d=o,this.c=new A.LinkedList}get size(){return this.c.size}push(o,m,D){this.c.push(new S(o,m,D))}clear(o){const m=new A.LinkedList;for(const D of this.c)D.emitter!==o&&m.push(D);this.c=m}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(m){this.d(m)}}}}e.EventDeliveryQueue=g;class h extends g{clear(o){this.c.clear()}}class S{constructor(o,m,D){this.emitter=o,this.listener=m,this.event=D}}class w extends r{async fireAsync(o,m,D){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const M of this.q)this.c.push([M,o]);for(;this.c.size>0&&!m.isCancellationRequested;){const[M,T]=this.c.shift(),N=[],$={...T,token:m,waitUntil:q=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");D&&(q=D(q,M.callback)),N.push(q)}};try{M.invoke($)}catch(q){(0,I.onUnexpectedError)(q);continue}Object.freeze(N),await Promise.allSettled(N).then(q=>{for(const ie of q)ie.status==="rejected"&&(0,I.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=w;class C extends r{constructor(o){super(o),this.h=0,this.s=new A.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=C;class t extends C{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=t;class l extends r{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(m=>super.fire(m)),this.c=[]}))}}e.MicrotaskEmitter=l;class i{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const m={event:o,listener:null};this.f.push(m),this.d&&this.j(m);const D=()=>{this.d&&this.k(m);const M=this.f.indexOf(m);this.f.splice(M,1)};return(0,s.toDisposable)((0,L.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(m=>this.c.fire(m))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(o){return(m,D,M)=>o(T=>{const N=this.c[this.c.length-1];N?N.push(()=>m.call(D,T)):m.call(D,T)},void 0,M)}bufferEvents(o){const m=[];this.c.push(m);const D=o();return this.c.pop(),m.forEach(M=>M()),D}}e.EventBufferer=n;class a{constructor(){this.c=!1,this.d=u.None,this.f=s.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(ee[23],te([0,1,3]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,f){const u=setTimeout(k.bind(f),0);return{dispose(){clearTimeout(u)}}});var s;(function(k){function f(u){return u===k.None||u===k.Cancelled||u instanceof A?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}k.isCancellationToken=f,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(s=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=s.None}}e.CancellationTokenSource=R}),define(ee[148],te([0,1,23]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.CancellationTokenSource,f=this.b(k.token);return this.a={promise:f,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=L;class s{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const f=JSON.stringify(k);return this.b!==f&&(this.b=f,this.a=this.c(k)),this.a}}e.LRUCachedFunction=s;class A{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const f=this.b(k);return this.a.set(k,f),f}}e.CachedFunction=A}),define(ee[26],te([0,1,148,131]),function(x,e,I,L){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=A;const R=/{(\d+)}/g;function k(K,...le){return le.length===0?K:K.replace(R,function(ge,ve){const we=parseInt(ve,10);return isNaN(we)||we<0||we>=le.length?ge:le[we]})}e.format=k;const f=/{([^}]+)}/g;function u(K,le){return K.replace(f,(ge,ve)=>le[ve]??ge)}e.format2=u;function p(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=p;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function b(K,le){let ge=0;const ve=le.charCodeAt(0);for(let we=K.length-1;we>=0;we--)K.charCodeAt(we)===ve&&ge++;return ge}e.count=b;function d(K,le,ge="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${ge}`}e.truncate=d;function E(K,le=" "){const ge=v(K,le);return r(ge,le)}e.trim=E;function v(K,le){if(!K||!le)return K;const ge=le.length;if(ge===0||K.length===0)return K;let ve=0;for(;K.indexOf(le,ve)===ve;)ve=ve+ge;return K.substring(ve)}e.ltrim=v;function r(K,le){if(!K||!le)return K;const ge=le.length,ve=K.length;if(ge===0||ve===0)return K;let we=ve,Me=-1;for(;Me=K.lastIndexOf(le,we-1),!(Me===-1||Me+ge!==we);){if(Me===0)return"";we=Me}return K.substring(0,we)}e.rtrim=r;function g(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function h(K){return K.replace(/\*/g,"")}e.stripWildcards=h;function S(K,le,ge={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=y(K)),ge.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ve="";return ge.global&&(ve+="g"),ge.matchCase||(ve+="i"),ge.multiline&&(ve+="m"),ge.unicode&&(ve+="u"),new RegExp(K,ve)}e.createRegExp=S;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function C(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=t;function l(K){return K.split(/\r\n|\r|\n/)}e.splitLines=l;function i(K){for(let le=0,ge=K.length;le<ge;le++){const ve=K.charCodeAt(le);if(ve!==32&&ve!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function n(K,le=0,ge=K.length){for(let ve=le;ve<ge;ve++){const we=K.charCodeAt(ve);if(we!==32&&we!==9)return K.substring(le,ve)}return K.substring(le,ge)}e.getLeadingWhitespace=n;function a(K,le=K.length-1){for(let ge=le;ge>=0;ge--){const ve=K.charCodeAt(ge);if(ve!==32&&ve!==9)return ge}return-1}e.lastNonWhitespaceIndex=a;function c(K,le,ge){const ve=[];let we=0;for(const Me of K.matchAll(le)){if(ve.push(K.slice(we,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");we=Me.index+Me[0].length,ve.push(ge(Me[0],...Me.slice(1),Me.index,K,Me.groups))}return ve.push(K.slice(we)),Promise.all(ve).then(Me=>Me.join(""))}e.replaceAsync=c;function o(K,le){return K<le?-1:K>le?1:0}e.compare=o;function m(K,le,ge=0,ve=K.length,we=0,Me=le.length){for(;ge<ve&&we<Me;ge++,we++){const Ge=K.charCodeAt(ge),Ke=le.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ue=ve-ge,He=Me-we;return Ue<He?-1:Ue>He?1:0}e.compareSubstring=m;function D(K,le){return M(K,le,0,K.length,0,le.length)}e.compareIgnoreCase=D;function M(K,le,ge=0,ve=K.length,we=0,Me=le.length){for(;ge<ve&&we<Me;ge++,we++){let Ge=K.charCodeAt(ge),Ke=le.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return m(K.toLowerCase(),le.toLowerCase(),ge,ve,we,Me);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ue=ve-ge,He=Me-we;return Ue<He?-1:Ue>He?1:0}e.compareSubstringIgnoreCase=M;function T(K){return K>=48&&K<=57}e.isAsciiDigit=T;function N(K){return K>=97&&K<=122}e.isLowerAsciiLetter=N;function $(K){return K>=65&&K<=90}e.isUpperAsciiLetter=$;function q(K,le){return K.length===le.length&&M(K,le)===0}e.equalsIgnoreCase=q;function ie(K,le){const ge=le.length;return le.length>K.length?!1:M(K,le,0,ge)===0}e.startsWithIgnoreCase=ie;function oe(K,le){const ge=Math.min(K.length,le.length);let ve;for(ve=0;ve<ge;ve++)if(K.charCodeAt(ve)!==le.charCodeAt(ve))return ve;return ge}e.commonPrefixLength=oe;function ae(K,le){const ge=Math.min(K.length,le.length);let ve;const we=K.length-1,Me=le.length-1;for(ve=0;ve<ge;ve++)if(K.charCodeAt(we-ve)!==le.charCodeAt(Me-ve))return ve;return ge}e.commonSuffixLength=ae;function de(K){return 55296<=K&&K<=56319}e.isHighSurrogate=de;function ce(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ce;function X(K,le){return(K-55296<<10)+(le-56320)+65536}e.computeCodePoint=X;function J(K,le,ge){const ve=K.charCodeAt(ge);if(de(ve)&&ge+1<le){const we=K.charCodeAt(ge+1);if(ce(we))return X(ve,we)}return ve}e.getNextCodePoint=J;function H(K,le){const ge=K.charCodeAt(le-1);if(ce(ge)&&le>1){const ve=K.charCodeAt(le-2);if(de(ve))return X(ve,ge)}return ge}class W{get offset(){return this.e}constructor(le,ge=0){this.c=le,this.d=le.length,this.e=ge}setOffset(le){this.e=le}prevCodePoint(){const le=H(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=J(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=W;class V{get offset(){return this.c.offset}constructor(le,ge=0){this.c=new W(le,ge)}nextGraphemeLength(){const le=Ee.getInstance(),ge=this.c,ve=ge.offset;let we=le.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Me=ge.offset,Ue=le.getGraphemeBreakType(ge.nextCodePoint());if(ue(we,Ue)){ge.setOffset(Me);break}we=Ue}return ge.offset-ve}prevGraphemeLength(){const le=Ee.getInstance(),ge=this.c,ve=ge.offset;let we=le.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Me=ge.offset,Ue=le.getGraphemeBreakType(ge.prevCodePoint());if(ue(Ue,we)){ge.setOffset(Me);break}we=Ue}return ve-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=V;function Y(K,le){return new V(K,le).nextGraphemeLength()}e.nextCharLength=Y;function ne(K,le){return new V(K,le).prevGraphemeLength()}e.prevCharLength=ne;function se(K,le){le>0&&ce(K.charCodeAt(le))&&le--;const ge=le+Y(K,le);return[ge-ne(K,ge),ge]}e.getCharContainingOffset=se;function _(K){const le=new V(K);let ge=0;for(;!le.eol();)ge++,le.nextGraphemeLength();return ge}e.charCount=_;let O;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(K){return O||(O=P()),O.test(K)}e.containsRTL=F;const U=/^[\t\n\r\x20-\x7E]*$/;function j(K){return U.test(K)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=B;function z(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=z;function G(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=G;function re(K,le){if(K.length<le)return K;const ge=/\b/g;let ve=0;for(;ge.test(K)&&!(K.length-ge.lastIndex<le);)ve=ge.lastIndex,ge.lastIndex+=1;return K.substring(ve).replace(/^\s/,"")}e.lcut=re;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function be(K){return K&&(K=K.replace(he,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Le(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Le;function Oe(K,le){if(!K||!le||K.length<le.length)return!1;const ge=le.length,ve=K.toLowerCase();let we=0,Me=-1;for(;we<ge;){const Ue=ve.indexOf(le[we],Me+1);if(Ue<0)return!1;Me=Ue,we++}return!0}e.fuzzyContains=Oe;function Fe(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Fe;function me(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=me;function pe(K,le=1){if(le===0)return"";let ge=-1;do ge=K.indexOf(`
`,ge+1),le--;while(le>0&&ge>=0);return ge===-1?K:(K[ge-1]==="\r"&&ge--,K.substr(0,ge))}e.getNLines=pe;function Ce(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=Ce;function Z(K){return Ee.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Z;function ue(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var fe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Ae()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ge=this.d,ve=ge.length/3;let we=1;for(;we<=ve;)if(le<ge[3*we])we=2*we;else if(le>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}Ee.c=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(K,le){if(K===0)return 0;const ge=We(K,le);if(ge!==void 0)return ge;const ve=new W(le,K);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Te;function We(K,le){const ge=new W(le,K);let ve=ge.prevCodePoint();for(;qe(ve)||ve===65039||ve===8419;){if(ge.offset===0)return;ve=ge.prevCodePoint()}if(!G(ve))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function qe(K){return 127995<=K&&K<=127999}var Ne;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.d.get(Array.from(le))}static getLocales(){return Be.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}s=Be,Be.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new I.LRUCachedFunction(K=>{function le(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function ge(Ke,Ye){const Ze=new Map(Ke);for(const[rt,ct]of Ye)Ze.set(rt,ct);return Ze}function ve(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[rt,ct]of Ke)Ye.has(rt)&&Ze.set(rt,ct);return Ze}const we=s.c.value;let Me=K.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Me.length===0&&(Me=["_default"]);let Ue;for(const Ke of Me){const Ye=le(we[Ke]);Ue=ve(Ue,Ye)}const He=le(we._common),Ge=ge(He,Ue);return new Be(Ge)}),Be.e=new L.Lazy(()=>Object.keys(Be.c.value).filter(K=>!K.startsWith("_"))),e.AmbiguousCharacters=Be;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(le){return Ve.e().has(le)}static get codePoints(){return Ve.e()}}Ve.d=void 0,e.InvisibleCharacters=Ve}),define(ee[32],te([0,1,9,4,26,11]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(c){return c===47||c===92}e.isPathSeparator=R;function k(c){return c.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=k;function f(c){return c.indexOf("/")===-1&&(c=k(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function u(c,o=I.posix.sep){if(!c)return"";const m=c.length,D=c.charCodeAt(0);if(R(D)){if(R(c.charCodeAt(1))&&!R(c.charCodeAt(2))){let T=3;const N=T;for(;T<m&&!R(c.charCodeAt(T));T++);if(N!==T&&!R(c.charCodeAt(T+1))){for(T+=1;T<m;T++)if(R(c.charCodeAt(T)))return c.slice(0,T+1).replace(/[\\/]/g,o)}}return o}else if(g(D)&&c.charCodeAt(1)===58)return R(c.charCodeAt(2))?c.slice(0,2)+o:c.slice(0,2);let M=c.indexOf("://");if(M!==-1){for(M+=3;M<m;M++)if(R(c.charCodeAt(M)))return c.slice(0,M+1)}return""}e.getRoot=u;function p(c){if(!L.isWindows||!c||c.length<5)return!1;let o=c.charCodeAt(0);if(o!==92||(o=c.charCodeAt(1),o!==92))return!1;let m=2;const D=m;for(;m<c.length&&(o=c.charCodeAt(m),o!==92);m++);return!(D===m||(o=c.charCodeAt(m+1),isNaN(o)||o===92))}e.isUNC=p;const y=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(c,o=L.isWindows){const m=o?y:b;return!(!c||c.length===0||/^\s+$/.test(c)||(m.lastIndex=0,m.test(c))||o&&d.test(c)||c==="."||c===".."||o&&c[c.length-1]==="."||o&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=E;function v(c,o,m){const D=c===o;return!m||D?D:!c||!o?!1:(0,s.equalsIgnoreCase)(c,o)}e.isEqual=v;function r(c,o,m,D=I.sep){if(c===o)return!0;if(!c||!o||o.length>c.length)return!1;if(m){if(!(0,s.startsWithIgnoreCase)(c,o))return!1;if(o.length===c.length)return!0;let T=o.length;return o.charAt(o.length-1)===D&&T--,c.charAt(T)===D}return o.charAt(o.length-1)!==D&&(o+=D),c.indexOf(o)===0}e.isEqualOrParent=r;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function h(c,o){return L.isWindows&&c.endsWith(":")&&(c+=I.sep),(0,I.isAbsolute)(c)||(c=(0,I.join)(o,c)),c=(0,I.normalize)(c),L.isWindows?(c=(0,s.rtrim)(c,I.sep),c.endsWith(":")&&(c+=I.sep)):(c=(0,s.rtrim)(c,I.sep),c||(c=I.sep)),c}e.sanitizeFilePath=h;function S(c){const o=(0,I.normalize)(c);return L.isWindows?c.length>3?!1:w(o)&&(c.length===2||o.charCodeAt(2)===92):o===I.posix.sep}e.isRootOrDriveLetter=S;function w(c,o=L.isWindows){return o?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function C(c){return w(c)?c[0]:void 0}e.getDriveLetter=C;function t(c,o,m){return o.length>c.length?-1:c===o?0:(m&&(c=c.toLowerCase(),o=o.toLowerCase()),c.indexOf(o))}e.indexOfPath=t;function l(c){const o=c.split(":");let m,D,M;for(const T of o){const N=Number(T);(0,A.isNumber)(N)?D===void 0?D=N:M===void 0&&(M=N):m=m?[m,T].join(":"):T}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:D!==void 0?D:void 0,column:M!==void 0?M:D!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(c,o,m=8){let D="";for(let T=0;T<m;T++){let N;T===0&&L.isWindows&&!o&&(m===3||m===4)?N=n:N=i,D+=N.charAt(Math.floor(Math.random()*N.length))}let M;return o?M=`${o}-${D}`:M=D,c?(0,I.join)(c,M):M}e.randomPath=a}),define(ee[56],te([0,1,26]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return s(g,0)}e.hash=L;function s(g,h){switch(typeof g){case"object":return g===null?A(349,h):Array.isArray(g)?f(g,h):u(g,h);case"string":return k(g,h);case"boolean":return R(g,h);case"number":return A(g,h);case"undefined":return A(937,h);default:return A(617,h)}}e.doHash=s;function A(g,h){return(h<<5)-h+g|0}e.numberHash=A;function R(g,h){return A(g?433:863,h)}function k(g,h){h=A(149417,h);for(let S=0,w=g.length;S<w;S++)h=A(g.charCodeAt(S),h);return h}e.stringHash=k;function f(g,h){return h=A(104579,h),g.reduce((S,w)=>s(w,S),h)}function u(g,h){return h=A(181387,h),Object.keys(g).sort().reduce((S,w)=>(S=k(w,S),s(g[w],S)),h)}class p{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.Hasher=p;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function b(g,h,S=32){const w=S-h,C=~((1<<w)-1);return(g<<h|(C&g)>>>w)>>>0}function d(g,h=0,S=g.byteLength,w=0){for(let C=0;C<S;C++)g[h+C]=w}function E(g,h,S="0"){for(;g.length<h;)g=S+g;return g}function v(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(S=>S.toString(16).padStart(2,"0")).join(""):E((g>>>0).toString(16),h/4)}e.toHexString=v;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const S=h.length;if(S===0)return;const w=this.p;let C=this.r,t=this.u,l,i;for(t!==0?(l=t,i=-1,t=0):(l=h.charCodeAt(0),i=0);;){let n=l;if(I.isHighSurrogate(l))if(i+1<S){const a=h.charCodeAt(i+1);I.isLowSurrogate(a)?(i++,n=I.computeCodePoint(l,a)):n=65533}else{t=l;break}else I.isLowSurrogate(l)&&(n=65533);if(C=this.w(w,C,n),i++,i<S)l=h.charCodeAt(i);else break}this.r=C,this.u=t}w(h,S,w){return w<128?h[S++]=w:w<2048?(h[S++]=192|(w&1984)>>>6,h[S++]=128|(w&63)>>>0):w<65536?(h[S++]=224|(w&61440)>>>12,h[S++]=128|(w&4032)>>>6,h[S++]=128|(w&63)>>>0):(h[S++]=240|(w&1835008)>>>18,h[S++]=128|(w&258048)>>>12,h[S++]=128|(w&4032)>>>6,h[S++]=128|(w&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=r.g,S=this.q;for(let o=0;o<64;o+=4)h.setUint32(o,S.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)h.setUint32(o,b(h.getUint32(o-12,!1)^h.getUint32(o-32,!1)^h.getUint32(o-56,!1)^h.getUint32(o-64,!1),1),!1);let w=this.h,C=this.l,t=this.m,l=this.n,i=this.o,n,a,c;for(let o=0;o<80;o++)o<20?(n=C&t|~C&l,a=1518500249):o<40?(n=C^t^l,a=1859775393):o<60?(n=C&t|C&l|t&l,a=2400959708):(n=C^t^l,a=3395469782),c=b(w,5)+n+i+a+h.getUint32(o*4,!1)&4294967295,i=l,l=t,t=b(C,30),C=w,w=c;this.h=this.h+w&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+i&4294967295}}r.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=r}),define(ee[75],te([0,1,26]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(L||(L={})),function(s){const A="error",R="warning",k="warn",f="info",u="ignore";function p(b){return b?I.equalsIgnoreCase(A,b)?s.Error:I.equalsIgnoreCase(R,b)||I.equalsIgnoreCase(k,b)?s.Warning:I.equalsIgnoreCase(f,b)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function y(b){switch(b){case s.Error:return A;case s.Warning:return R;case s.Info:return f;default:return u}}s.toString=y}(L||(L={})),e.default=L}),define(ee[61],te([0,1,22,26]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const E=d.charCodeAt(0),v=this.b.charCodeAt(this.c);return E-v}value(){return this.b[this.c]}}e.StringIterator=s;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,L.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class R{constructor(d=!0,E=!0){this.f=d,this.g=E}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let E=d.length-1;E>=0;E--,this.c--){const v=this.b.charCodeAt(E);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,L.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var k;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(d,E){this.f=d,this.g=E,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,L.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(p||(p={}));class y{static forUris(d=()=>!1,E=()=>!1){return new y(new f(d,E))}static forPaths(d=!1){return new y(new R(void 0,!d))}static forStrings(){return new y(new s)}static forConfigKeys(){return new y(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,E){if(E){const v=E.slice(0);(0,I.shuffle)(v);for(const r of v)this.set(r,d)}else{const v=d.slice(0);(0,I.shuffle)(v);for(const r of v)this.set(r[0],r[1])}}set(d,E){const v=this.b.reset(d);let r;this.c||(this.c=new u,this.c.segment=v.value());const g=[];for(r=this.c;;){const S=v.cmp(r.segment);if(S>0)r.left||(r.left=new u,r.left.segment=v.value()),g.push([-1,r]),r=r.left;else if(S<0)r.right||(r.right=new u,r.right.segment=v.value()),g.push([1,r]),r=r.right;else if(v.hasNext())v.next(),r.mid||(r.mid=new u,r.mid.segment=v.value()),g.push([0,r]),r=r.mid;else break}const h=r.value;r.value=E,r.key=d;for(let S=g.length-1;S>=0;S--){const w=g[S][1];w.updateHeight();const C=w.balanceFactor();if(C<-1||C>1){const t=g[S][0],l=g[S+1][0];if(t===1&&l===1)g[S][1]=w.rotateLeft();else if(t===-1&&l===-1)g[S][1]=w.rotateRight();else if(t===1&&l===-1)w.right=g[S+1][1]=g[S+1][1].rotateRight(),g[S][1]=w.rotateLeft();else if(t===-1&&l===1)w.left=g[S+1][1]=g[S+1][1].rotateLeft(),g[S][1]=w.rotateRight();else throw new Error;if(S>0)switch(g[S-1][0]){case-1:g[S-1][1].left=g[S][1];break;case 1:g[S-1][1].right=g[S][1];break;case 0:g[S-1][1].mid=g[S][1];break}else this.c=g[0][1]}}return h}get(d){return this.d(d)?.value}d(d){const E=this.b.reset(d);let v=this.c;for(;v;){const r=E.cmp(v.segment);if(r>0)v=v.left;else if(r<0)v=v.right;else if(E.hasNext())E.next(),v=v.mid;else break}return v}has(d){const E=this.d(d);return!(E?.value===void 0&&E?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,E){const v=this.b.reset(d),r=[];let g=this.c;for(;g;){const h=v.cmp(g.segment);if(h>0)r.push([-1,g]),g=g.left;else if(h<0)r.push([1,g]),g=g.right;else if(v.hasNext())v.next(),r.push([0,g]),g=g.mid;else break}if(!!g){if(E?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this.f(g.right);if(h.key){const{key:S,value:w,segment:C}=h;this.e(h.key,!1),g.key=S,g.value=w,g.segment=C}}else{const h=g.left??g.right;if(r.length>0){const[S,w]=r[r.length-1];switch(S){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this.c=h}for(let h=r.length-1;h>=0;h--){const S=r[h][1];S.updateHeight();const w=S.balanceFactor();if(w>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),r[h][1]=S.rotateLeft()):w<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),r[h][1]=S.rotateRight()),h>0)switch(r[h-1][0]){case-1:r[h-1][1].left=r[h][1];break;case 1:r[h-1][1].right=r[h][1];break;case 0:r[h-1][1].mid=r[h][1];break}else this.c=r[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const E=this.b.reset(d);let v=this.c,r;for(;v;){const g=E.cmp(v.segment);if(g>0)v=v.left;else if(g<0)v=v.right;else if(E.hasNext())E.next(),r=v.value||r,v=v.mid;else break}return v&&v.value||r}findSuperstr(d){return this.g(d,!1)}g(d,E){const v=this.b.reset(d);let r=this.c;for(;r;){const g=v.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(v.hasNext())v.next(),r=r.mid;else return r.mid?this.h(r.mid):E?r.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[E,v]of this)d(v,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const E=[];return this.j(d,E),E[Symbol.iterator]()}j(d,E){!d||(d.left&&this.j(d.left,E),d.value&&E.push([d.key,d.value]),d.mid&&this.j(d.mid,E),d.right&&this.j(d.right,E))}_isBalanced(){const d=E=>{if(!E)return!0;const v=E.balanceFactor();return v<-1||v>1?!1:d(E.left)&&d(E.right)};return d(this.c)}}e.TernarySearchTree=y}),define(ee[8],te([0,1,9,4]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function u(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==y&&(n=y+n):n=y;break}return n}const p="",y="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,c,o,m,D=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=f(n,D),this.authority=a||p,this.path=u(this.scheme,c||p),this.query=o||p,this.fragment=m||p,k(this,D))}get fsPath(){return S(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:c,path:o,query:m,fragment:D}=n;return a===void 0?a=this.scheme:a===null&&(a=p),c===void 0?c=this.authority:c===null&&(c=p),o===void 0?o=this.path:o===null&&(o=p),m===void 0?m=this.query:m===null&&(m=p),D===void 0?D=this.fragment:D===null&&(D=p),a===this.scheme&&c===this.authority&&o===this.path&&m===this.query&&D===this.fragment?this:new v(a,c,o,m,D)}static parse(n,a=!1){const c=b.exec(n);return c?new v(c[2]||p,l(c[4]||p),l(c[5]||p),l(c[7]||p),l(c[9]||p),a):new v(p,p,p,p,p)}static file(n){let a=p;if(L.isWindows&&(n=n.replace(/\\/g,y)),n[0]===y&&n[1]===y){const c=n.indexOf(y,2);c===-1?(a=n.substring(2),n=y):(a=n.substring(2,c),n=n.substring(c)||y)}return new v("file",a,n,p,p)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return k(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&n.scheme==="file"?c=d.file(I.win32.join(S(n,!0),...a)).path:c=I.posix.join(n.path,...a),n.with({path:c})}toString(n=!1){return w(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===E?n.fsPath:null,a}}else return n}}e.URI=d;const E=L.isWindows?1:void 0;class v extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(n=!1){return n?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=E),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,n,a){let c,o=-1;for(let m=0;m<i.length;m++){const D=i.charCodeAt(m);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||n&&D===47||a&&D===91||a&&D===93||a&&D===58)o!==-1&&(c+=encodeURIComponent(i.substring(o,m)),o=-1),c!==void 0&&(c+=i.charAt(m));else{c===void 0&&(c=i.substr(0,m));const M=r[D];M!==void 0?(o!==-1&&(c+=encodeURIComponent(i.substring(o,m)),o=-1),c+=M):o===-1&&(o=m)}}return o!==-1&&(c+=encodeURIComponent(i.substring(o))),c!==void 0?c:i}function h(i){let n;for(let a=0;a<i.length;a++){const c=i.charCodeAt(a);c===35||c===63?(n===void 0&&(n=i.substr(0,a)),n+=r[c]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function S(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=S;function w(i,n){const a=n?h:g;let c="",{scheme:o,authority:m,path:D,query:M,fragment:T}=i;if(o&&(c+=o,c+=":"),(m||o==="file")&&(c+=y,c+=y),m){let N=m.indexOf("@");if(N!==-1){const $=m.substr(0,N);m=m.substr(N+1),N=$.lastIndexOf(":"),N===-1?c+=a($,!1,!1):(c+=a($.substr(0,N),!1,!1),c+=":",c+=a($.substr(N+1),!1,!0)),c+="@"}m=m.toLowerCase(),N=m.lastIndexOf(":"),N===-1?c+=a(m,!1,!0):(c+=a(m.substr(0,N),!1,!0),c+=m.substr(N))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const N=D.charCodeAt(1);N>=65&&N<=90&&(D=`/${String.fromCharCode(N+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const N=D.charCodeAt(0);N>=65&&N<=90&&(D=`${String.fromCharCode(N+32)}:${D.substr(2)}`)}c+=a(D,!0,!1)}return M&&(c+="?",c+=a(M,!1,!1)),T&&(c+="#",c+=n?T:g(T,!1,!1)),c}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(t)?i.replace(t,n=>C(n)):i}}),define(ee[149],te([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(u){const p=u;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=L;function s(u){const p=[];let y;try{const b=JSON.parse(u.arguments),d=b[b.length-1];d&&d.__$stack&&(b.pop(),y=d.__$stack),p.push(...b)}catch{p.push("Unable to log remote console arguments",u.arguments)}return{args:p,stack:y}}e.parse=s;function A(u){if(typeof u!="string")return A(s(u).stack);const p=u;if(p){const y=R(p),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=A;function R(u){if(!u)return u;const p=u.indexOf(`
`);return p===-1?u:u.substring(0,p)}function k(u,p){const{args:y,stack:b}=s(u),d=typeof y[0]=="string"&&y.length===1;let E=R(b);E&&(E=`(${E.trim()})`);let v=[];if(typeof y[0]=="string"?E&&d?v=[`%c[${p}] %c${y[0]} %c${E}`,f("blue"),f(""),f("grey")]:v=[`%c[${p}] %c${y[0]}`,f("blue"),f(""),...y.slice(1)]:v=[`%c[${p}]%`,f("blue"),...y],E&&!d&&v.push(E),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,v)}e.log=k;function f(u){return`color: ${u}`}}),define(ee[85],te([0,1,17,26,8]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(u){return JSON.stringify(u,k)}e.stringify=A;function R(u){let p=JSON.parse(u);return p=f(p),p}e.parse=R;function k(u,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,L.regExpFlags)(p)}:p}function f(u,p=0){if(!u||p>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return s.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof I.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=f(u[y],p+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=f(u[y],p+1))}return u}e.revive=f}),define(ee[15],te([0,1,13,4,8]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${A.vscodeRemoteResource}`}set(p,y,b){this.a[p]=y,this.b[p]=b}setConnectionToken(p,y){this.c[p]=y}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(r){return I.onUnexpectedError(r),p}const y=p.authority;let b=this.a[y];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const d=this.b[y],E=this.c[y];let v=`path=${encodeURIComponent(p.path)}`;return typeof E=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),s.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${b}:${d}`,path:this.f,query:v})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(p){const y=this.b(p,x);return this.uriToBrowserUri(y)}uriToBrowserUri(p){return p.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${k.a}`)?p.with({scheme:A.vscodeFileResource,authority:p.authority||k.a,query:null,fragment:null}):p}asFileUri(p){const y=this.b(p,x);return this.uriToFileUri(y)}uriToFileUri(p){return p.scheme===A.vscodeFileResource?p.with({scheme:A.file,authority:p.authority!==k.a?p.authority:null,query:null,fragment:null}):p}b(p,y){return s.URI.isUri(p)?p:s.URI.parse(y.toUrl(p))}}k.a="vscode-app",e.FileAccess=new k;var f;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const y="vscode-coi";function b(E){let v;typeof E=="string"?v=new URL(E).searchParams:E instanceof URL?v=E.searchParams:s.URI.isUri(E)&&(v=new URL(E.toString(!0)).searchParams);const r=v?.get(y);if(!!r)return p.get(r)}u.getHeadersFromQuery=b;function d(E,v,r){if(!globalThis.crossOriginIsolated)return;const g=v&&r?"3":r?"2":"1";E instanceof URLSearchParams?E.set(y,g):E[y]=g}u.addSearchParam=d})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,15,9,4,26,8]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(d){return(0,k.uriToFsPath)(d,!0)}e.originalFSPath=f;class u{constructor(E){this.a=E}compare(E,v,r=!1){return E===v?0:(0,R.compare)(this.getComparisonKey(E,r),this.getComparisonKey(v,r))}isEqual(E,v,r=!1){return E===v?!0:!E||!v?!1:this.getComparisonKey(E,r)===this.getComparisonKey(v,r)}getComparisonKey(E,v=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,v,r=!1){if(E.scheme===v.scheme){if(E.scheme===L.Schemas.file)return I.isEqualOrParent(f(E),f(v),this.a(E))&&E.query===v.query&&(r||E.fragment===v.fragment);if((0,e.isEqualAuthority)(E.authority,v.authority))return I.isEqualOrParent(E.path,v.path,this.a(E),"/")&&E.query===v.query&&(r||E.fragment===v.fragment)}return!1}joinPath(E,...v){return k.URI.joinPath(E,...v)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return s.posix.basename(E.path)}extname(E){return s.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let v;return E.scheme===L.Schemas.file?v=k.URI.file(s.dirname(f(E))).path:(v=s.posix.dirname(E.path),E.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),v="/")),E.with({path:v})}normalizePath(E){if(!E.path.length)return E;let v;return E.scheme===L.Schemas.file?v=k.URI.file(s.normalize(f(E))).path:v=s.posix.normalize(E.path),E.with({path:v})}relativePath(E,v){if(E.scheme!==v.scheme||!(0,e.isEqualAuthority)(E.authority,v.authority))return;if(E.scheme===L.Schemas.file){const h=s.relative(f(E),f(v));return A.isWindows?I.toSlashes(h):h}let r=E.path||"/";const g=v.path||"/";if(this.a(E)){let h=0;for(const S=Math.min(r.length,g.length);h<S&&!(r.charCodeAt(h)!==g.charCodeAt(h)&&r.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);r=g.substr(0,h)+r.substr(h)}return s.posix.relative(r,g)}resolvePath(E,v){if(E.scheme===L.Schemas.file){const r=k.URI.file(s.resolve(f(E),v));return E.with({authority:r.authority,path:r.path})}return v=I.toPosixPath(v),E.with({path:s.posix.resolve(E.path,v)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,v){return E===v||E!==void 0&&v!==void 0&&(0,R.equalsIgnoreCase)(E,v)}hasTrailingPathSeparator(E,v=s.sep){if(E.scheme===L.Schemas.file){const r=f(E);return r.length>I.getRoot(r).length&&r[r.length-1]===v}else{const r=E.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,v=s.sep){return(0,e.hasTrailingPathSeparator)(E,v)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,v=s.sep){let r=!1;if(E.scheme===L.Schemas.file){const g=f(E);r=g!==void 0&&g.length===I.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=E.path;r=g.length===1&&g.charCodeAt(g.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(E,v)?E.with({path:E.path+"/"}):E}}e.ExtUri=u,e.extUri=new u(()=>!1),e.extUriBiasedIgnorePathCase=new u(d=>d.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new u(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(d,E){const v=[];for(let r=0;r<d.length;r++){const g=E(d[r]);d.some((h,S)=>S===r?!1:(0,e.isEqualOrParent)(g,E(h)))||v.push(d[r])}return v}e.distinctParents=p;var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function E(v){const r=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(S=>{const[w,C]=S.split(":");w&&C&&r.set(w,C)});const h=v.path.substring(0,v.path.indexOf(";"));return h&&r.set(d.META_DATA_MIME,h),r}d.parseMetaData=E})(y=e.DataUri||(e.DataUri={}));function b(d,E,v){if(E){let r=d.path;return r&&r[0]!==s.posix.sep&&(r=s.posix.sep+r),d.with({scheme:v,authority:E,path:r})}return d.with({scheme:v})}e.toLocalResource=b}),define(ee[7],te([0,1,23,13,3,2,18,4,134]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u(_){return!!_&&typeof _.then=="function"}e.isThenable=u;function p(_){const O=new I.CancellationTokenSource,P=_(O.token),F=new Promise((U,j)=>{const B=O.token.onCancellationRequested(()=>{B.dispose(),O.dispose(),j(new L.CancellationError)});Promise.resolve(P).then(z=>{B.dispose(),O.dispose(),U(z)},z=>{B.dispose(),O.dispose(),j(z)})});return new class{cancel(){O.cancel()}then(U,j){return F.then(U,j)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=p;function y(_,O,P){return new Promise((F,U)=>{const j=O.onCancellationRequested(()=>{j.dispose(),F(P)});_.then(F,U).finally(()=>j.dispose())})}e.raceCancellation=y;function b(_,O){return new Promise((P,F)=>{const U=O.onCancellationRequested(()=>{U.dispose(),F(new L.CancellationError)});_.then(P,F).finally(()=>U.dispose())})}e.raceCancellationError=b;async function d(_){let O=-1;const P=_.map((U,j)=>U.then(B=>(O=j,B))),F=await Promise.race(P);return _.forEach((U,j)=>{j!==O&&U.cancel()}),F}e.raceCancellablePromises=d;function E(_,O,P){let F;const U=setTimeout(()=>{F?.(void 0),P?.()},O);return Promise.race([_.finally(()=>clearTimeout(U)),new Promise(j=>F=j)])}e.raceTimeout=E;function v(_){return new Promise((O,P)=>{const F=_();u(F)?F.then(O,P):O(F)})}e.asPromise=v;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(O){if(this.a){if(this.d=O,!this.b){const P=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(P,P).then(F)})}return new Promise((P,F)=>{this.b.then(P,F)})}return this.a=O(),new Promise((P,F)=>{this.a.then(U=>{this.a=null,P(U)},U=>{this.a=null,F(U)})})}}e.Throttler=r;class g{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.Sequencer=g;class h{constructor(){this.a=new Map}queue(O,P){const U=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.a.get(O)===U&&this.a.delete(O)});return this.a.set(O,U),U}}e.SequencerByKey=h;const S=(_,O)=>{let P=!0;const F=setTimeout(()=>{P=!1,O()},_);return{isTriggered:()=>P,dispose:()=>{clearTimeout(F),P=!1}}},w=_=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,_())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class C{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,P=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((U,j)=>{this.d=U,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=P===f.MicrotaskDelay?w(F):S(P,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(O){this.a=new C(O),this.b=new r}trigger(O,P){return this.a.trigger(()=>this.b.queue(O),P)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class l{constructor(){this.a=!1,this.b=new Promise((O,P)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=l;class i extends l{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(_,O){return O?new Promise((P,F)=>{const U=setTimeout(()=>{j.dispose(),P()},_),j=O.onCancellationRequested(()=>{clearTimeout(U),j.dispose(),F(new L.CancellationError)})}):p(P=>n(_,P))}e.timeout=n;function a(_,O=0){const P=setTimeout(_,O);return(0,A.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=a;function c(_){const O=[];let P=0;const F=_.length;function U(){return P<F?_[P++]():null}function j(B){B!=null&&O.push(B);const z=U();return z?z.then(j):Promise.resolve(O)}return Promise.resolve(null).then(j)}e.sequence=c;function o(_,O=F=>!!F,P=null){let F=0;const U=_.length,j=()=>{if(F>=U)return Promise.resolve(P);const B=_[F++];return Promise.resolve(B()).then(G=>O(G)?Promise.resolve(G):j())};return j()}e.first=o;function m(_,O=F=>!!F,P=null){if(_.length===0)return Promise.resolve(P);let F=_.length;const U=()=>{F=-1;for(const j of _)j.cancel?.()};return new Promise((j,B)=>{for(const z of _)z.then(G=>{--F>=0&&O(G)?(U(),j(G)):F===0&&j(P)}).catch(G=>{--F>=0&&(U(),B(G))})})}e.firstParallel=m;class D{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new s.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((P,F)=>{this.f.push({factory:O,c:P,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const P=O.factory();P.then(O.c,O.e),P.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=D;class M extends D{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const O=new H;return this.b.add(O),O.p}d(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,P=R.extUri){const F=P.getComparisonKey(O);let U=this.a.get(F);return U||(U=new M,s.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,U)),U}f(){!this.d()||this.g()}g(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class N{constructor(O,P){this.a=-1,typeof O=="function"&&typeof P=="number"&&this.setIfNotSet(O,P)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,P){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},P)}setIfNotSet(O,P){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},P))}}e.TimeoutTimer=N;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(O,P){this.cancel(),this.a=setInterval(()=>{O()},P)}}e.IntervalTimer=$;class q{constructor(O,P){this.b=-1,this.a=O,this.d=P,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class ie{constructor(O,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.a=O,this.b=P,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class oe extends q{constructor(O,P){super(O,P),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=oe;class ae extends A.Disposable{constructor(O,P){super(),this.g=O,this.h=P,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const P of O)this.a.push(P);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=_=>{(0,k.setTimeout0)(()=>{if(O)return;const P=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(_,O)=>{const P=requestIdleCallback(_,typeof O=="number"?{timeout:O}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(P))}}}}();class de{constructor(O){this.d=!1,this.a=()=>{try{this.f=O()}catch(P){this.g=P}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=de;async function ce(_,O,P){let F;for(let U=0;U<P;U++)try{return await _()}catch(j){F=j,await n(O)}throw F}e.retry=ce;class X{hasPending(O){return this.a?typeof O=="number"?this.a.taskId===O:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(O,P,F){return this.a={taskId:O,cancel:()=>F?.(),promise:P},P.then(()=>this.d(O),()=>this.d(O)),P}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this.b)this.b.run=O;else{let P,F;const U=new Promise((j,B)=>{P=j,F=B});this.b={run:O,promise:U,promiseResolve:P,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class J{constructor(O,P=()=>Date.now()){this.d=O,this.f=P,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.IntervalCounter=J;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((O,P)=>{this.a=O,this.b=P})}complete(O){return new Promise(P=>{this.a(O),this.f=!0,P()})}error(O){return new Promise(P=>{this.b(O),this.d=!0,P()})}cancel(){new Promise(O=>{this.b(new L.CancellationError),this.d=!0,O()})}}e.DeferredPromise=H;var W;(function(_){async function O(F){let U;const j=await Promise.all(F.map(B=>B.then(z=>z,z=>{U||(U=z)})));if(typeof U<"u")throw U;return j}_.settled=O;function P(F){return new Promise(async(U,j)=>{try{await F(U,j)}catch(B){j(B)}})}_.withAsyncBody=P})(W=e.Promises||(e.Promises={}));var V;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(V||(V={}));class Y{static fromArray(O){return new Y(P=>{P.emitMany(O)})}static fromPromise(O){return new Y(async P=>{P.emitMany(await O)})}static fromPromises(O){return new Y(async P=>{await Promise.all(O.map(async F=>P.emitOne(await F)))})}static merge(O){return new Y(async P=>{await Promise.all(O.map(async F=>{for await(const U of F)P.emitOne(U)}))})}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new s.Emitter,queueMicrotask(async()=>{const P={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(O(P)),this.j()}catch(F){this.k(F)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(O,P){return new Y(async F=>{for await(const U of O)F.emitOne(P(U))})}map(O){return Y.map(this,O)}static filter(O,P){return new Y(async F=>{for await(const U of O)P(U)&&F.emitOne(U)})}filter(O){return Y.filter(this,O)}static coalesce(O){return Y.filter(O,P=>!!P)}coalesce(){return Y.coalesce(this)}static async toPromise(O){const P=[];for await(const F of O)P.push(F);return P}toPromise(){return Y.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}Y.EMPTY=Y.fromArray([]),e.AsyncIterableObject=Y;class ne extends Y{constructor(O,P){super(P),this.l=O}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function se(_){const O=new I.CancellationTokenSource,P=_(O.token);return new ne(O,async F=>{const U=O.token.onCancellationRequested(()=>{U.dispose(),O.dispose(),F.reject(new L.CancellationError)});try{for await(const j of P){if(O.token.isCancellationRequested)return;F.emitOne(j)}U.dispose(),O.dispose()}catch(j){U.dispose(),O.dispose(),F.reject(j)}})}e.createCancelableAsyncIterable=se}),define(ee[102],te([0,1,22,7,32,35,9,4,26]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function u(){return Object.create(null)}e.getEmptyExpression=u,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",y="[^/\\\\]",b=/\//g;function d(J,H){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${p}|${y}+${p}${H?`|${p}${y}+`:""})*?`}}function E(J,H){if(!J)return[];const W=[];let V=!1,Y=!1,ne="";for(const se of J){switch(se){case H:if(!V&&!Y){W.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}ne+=se}return ne&&W.push(ne),W}e.splitGlobAware=E;function v(J){if(!J)return"";let H="";const W=E(J,e.GLOB_SPLIT);if(W.every(V=>V===e.GLOBSTAR))H=".*";else{let V=!1;W.forEach((Y,ne)=>{if(Y===e.GLOBSTAR){if(V)return;H+=d(2,ne===W.length-1)}else{let se=!1,_="",O=!1,P="";for(const F of Y){if(F!=="}"&&se){_+=F;continue}if(O&&(F!=="]"||!P)){let U;F==="-"?U=F:(F==="^"||F==="!")&&!P?U="^":F===e.GLOB_SPLIT?U="":U=(0,f.escapeRegExpCharacters)(F),P+=U;continue}switch(F){case"{":se=!0;continue;case"[":O=!0;continue;case"}":{H+=`(?:${E(_,",").map(B=>v(B)).join("|")})`,se=!1,_="";break}case"]":{H+="["+P+"]",O=!1,P="";break}case"?":H+=y;continue;case"*":H+=d(1);continue;default:H+=(0,f.escapeRegExpCharacters)(F)}}ne<W.length-1&&(W[ne+1]!==e.GLOBSTAR||ne+2<W.length)&&(H+=p)}V=Y===e.GLOBSTAR})}return H}const r=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),l=function(){return!1},i=function(){return null};function n(J,H){if(!J)return i;let W;typeof J!="string"?W=J.pattern:W=J,W=W.trim();const V=`${W}_${!!H.trimForExclusions}`;let Y=t.get(V);if(Y)return a(Y,J);let ne;return r.test(W)?Y=o(W.substr(4),W):(ne=g.exec(c(W,H)))?Y=m(ne[1],W):(H.trimForExclusions?S:h).test(W)?Y=D(W,H):(ne=w.exec(c(W,H)))?Y=M(ne[1].substr(1),W,!0):(ne=C.exec(c(W,H)))?Y=M(ne[1],W,!1):Y=T(W),t.set(V,Y),a(Y,J)}function a(J,H){if(typeof H=="string")return J;const W=function(V,Y){return(0,s.isEqualOrParent)(V,H.base,!k.isLinux)?J((0,f.ltrim)(V.substr(H.base.length),R.sep),Y):null};return W.allBasenames=J.allBasenames,W.allPaths=J.allPaths,W.basenames=J.basenames,W.patterns=J.patterns,W}function c(J,H){return H.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function o(J,H){return function(W,V){return typeof W=="string"&&W.endsWith(J)?H:null}}function m(J,H){const W=`/${J}`,V=`\\${J}`,Y=function(se,_){return typeof se!="string"?null:_?_===J?H:null:se===J||se.endsWith(W)||se.endsWith(V)?H:null},ne=[J];return Y.basenames=ne,Y.patterns=[H],Y.allBasenames=ne,Y}function D(J,H){const W=ce(J.slice(1,-1).split(",").map(_=>n(_,H)).filter(_=>_!==i),J),V=W.length;if(!V)return i;if(V===1)return W[0];const Y=function(_,O){for(let P=0,F=W.length;P<F;P++)if(W[P](_,O))return J;return null},ne=W.find(_=>!!_.allBasenames);ne&&(Y.allBasenames=ne.allBasenames);const se=W.reduce((_,O)=>O.allPaths?_.concat(O.allPaths):_,[]);return se.length&&(Y.allPaths=se),Y}function M(J,H,W){const V=R.sep===R.posix.sep,Y=V?J:J.replace(b,R.sep),ne=R.sep+Y,se=R.posix.sep+J;let _;return W?_=function(O,P){return typeof O=="string"&&(O===Y||O.endsWith(ne)||!V&&(O===J||O.endsWith(se)))?H:null}:_=function(O,P){return typeof O=="string"&&(O===Y||!V&&O===J)?H:null},_.allPaths=[(W?"*/":"./")+J],_}function T(J){try{const H=new RegExp(`^${v(J)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?J:null}}catch{return i}}function N(J,H,W){return!J||typeof H!="string"?!1:$(J)(H,void 0,W)}e.match=N;function $(J,H={}){if(!J)return l;if(typeof J=="string"||q(J)){const W=n(J,H);if(W===i)return l;const V=function(Y,ne){return!!W(Y,ne)};return W.allBasenames&&(V.allBasenames=W.allBasenames),W.allPaths&&(V.allPaths=W.allPaths),V}return ae(J,H)}e.parse=$;function q(J){const H=J;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=q;function ie(J){return J.allBasenames||[]}e.getBasenameTerms=ie;function oe(J){return J.allPaths||[]}e.getPathTerms=oe;function ae(J,H){const W=ce(Object.getOwnPropertyNames(J).map(_=>de(_,J[_],H)).filter(_=>_!==i)),V=W.length;if(!V)return i;if(!W.some(_=>!!_.requiresSiblings)){if(V===1)return W[0];const _=function(F,U){let j;for(let B=0,z=W.length;B<z;B++){const G=W[B](F,U);if(typeof G=="string")return G;(0,L.isThenable)(G)&&(j||(j=[]),j.push(G))}return j?(async()=>{for(const B of j){const z=await B;if(typeof z=="string")return z}return null})():null},O=W.find(F=>!!F.allBasenames);O&&(_.allBasenames=O.allBasenames);const P=W.reduce((F,U)=>U.allPaths?F.concat(U.allPaths):F,[]);return P.length&&(_.allPaths=P),_}const Y=function(_,O,P){let F,U;for(let j=0,B=W.length;j<B;j++){const z=W[j];z.requiresSiblings&&P&&(O||(O=(0,R.basename)(_)),F||(F=O.substr(0,O.length-(0,R.extname)(_).length)));const G=z(_,O,F,P);if(typeof G=="string")return G;(0,L.isThenable)(G)&&(U||(U=[]),U.push(G))}return U?(async()=>{for(const j of U){const B=await j;if(typeof B=="string")return B}return null})():null},ne=W.find(_=>!!_.allBasenames);ne&&(Y.allBasenames=ne.allBasenames);const se=W.reduce((_,O)=>O.allPaths?_.concat(O.allPaths):_,[]);return se.length&&(Y.allPaths=se),Y}function de(J,H,W){if(H===!1)return i;const V=n(J,W);if(V===i)return i;if(typeof H=="boolean")return V;if(H){const Y=H.when;if(typeof Y=="string"){const ne=(se,_,O,P)=>{if(!P||!V(se,_))return null;const F=Y.replace("$(basename)",()=>O),U=P(F);return(0,L.isThenable)(U)?U.then(j=>j?J:null):U?J:null};return ne.requiresSiblings=!0,ne}}return V}function ce(J,H){const W=J.filter(_=>!!_.basenames);if(W.length<2)return J;const V=W.reduce((_,O)=>{const P=O.basenames;return P?_.concat(P):_},[]);let Y;if(H){Y=[];for(let _=0,O=V.length;_<O;_++)Y.push(H)}else Y=W.reduce((_,O)=>{const P=O.patterns;return P?_.concat(P):_},[]);const ne=function(_,O){if(typeof _!="string")return null;if(!O){let F;for(F=_.length;F>0;F--){const U=_.charCodeAt(F-1);if(U===47||U===92)break}O=_.substr(F)}const P=V.indexOf(O);return P!==-1?Y[P]:null};ne.basenames=V,ne.patterns=Y,ne.allBasenames=V;const se=J.filter(_=>!_.basenames);return se.push(ne),se}function X(J,H){return(0,I.equals)(J,H,(W,V)=>typeof W=="string"&&typeof V=="string"?W===V:typeof W!="string"&&typeof V!="string"?W.base===V.base&&W.pattern===V.pattern:!1)}e.patternsEquals=X}),define(ee[45],te([0,1,22,32,9,4,18,26]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,n){const{os:a,tildify:c,relative:o}=n;if(o){const M=u(i,o,a);if(typeof M=="string")return M}let m=i.fsPath;if(a===1&&!A.isWindows?m=m.replace(/\//g,"\\"):a!==1&&A.isWindows&&(m=m.replace(/\\/g,"/")),a!==1&&c?.userHome){const M=c.userHome.fsPath;let T;i.scheme!==c.userHome.scheme&&i.path.startsWith(s.posix.sep)?T=c.userHome.with({path:i.path}).fsPath:T=i.fsPath,m=b(T,M,a)}return(a===1?s.win32:s.posix).normalize(p(m,a===1))}e.getPathLabel=f;function u(i,n,a){const c=a===1?s.win32:s.posix,o=a===3?R.extUri:R.extUriIgnorePathCase,m=n.getWorkspace(),D=(0,I.firstOrDefault)(m.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(s.posix.sep)&&(i=D.uri.with({path:i.path}));const M=n.getWorkspaceFolder(i);if(!M)return;let T;if(o.isEqual(M.uri,i)?T="":T=o.relativePath(M.uri,i)??"",T&&(T=c.normalize(T)),m.folders.length>1&&!n.noPrefix){const N=M.name?M.name:o.basenameOrAuthority(M.uri);T=T?`${N} \u2022 ${T}`:N}return T}function p(i,n=A.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let y=Object.create(null);function b(i,n,a=A.OS){if(a===1||!i||!n)return i;let c=y.original===n?y.normalized:void 0;c||(c=n,A.isWindows&&(c=(0,L.toSlashes)(c)),c=`${(0,k.rtrim)(c,s.posix.sep)}${s.posix.sep}`,y={original:n,normalized:c});let o=i;return A.isWindows&&(o=(0,L.toSlashes)(o)),(a===3?o.startsWith(c):(0,k.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:i}e.tildify=b;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=d;const E="\u2026",v="\\\\",r="~";function g(i,n=s.sep){const a=new Array(i.length);let c=!1;for(let o=0;o<i.length;o++){const m=i[o];if(m===""){a[o]=`.${n}`;continue}if(!m){a[o]=m;continue}c=!0;let D="",M=m;M.indexOf(v)===0?(D=M.substr(0,M.indexOf(v)+v.length),M=M.substr(M.indexOf(v)+v.length)):M.indexOf(n)===0?(D=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(r)===0&&(D=M.substr(0,M.indexOf(r)+r.length),M=M.substr(M.indexOf(r)+r.length));const T=M.split(n);for(let N=1;c&&N<=T.length;N++)for(let $=T.length-N;c&&$>=0;$--){c=!1;let q=T.slice($,$+N).join(n);for(let ie=0;!c&&ie<i.length;ie++)if(ie!==o&&i[ie]&&i[ie].indexOf(q)>-1){const oe=$+N===T.length,ae=$>0&&i[ie].indexOf(n)>-1?n+q:q,de=i[ie].endsWith(ae);c=!oe||de}if(!c){let ie="";(T[0].endsWith(":")||D!=="")&&($===1&&($=0,N++,q=T[0]+n+q),$>0&&(ie=T[0]+n),ie=D+ie),$>0&&(ie=ie+E+n),ie=ie+q,$+N<T.length&&(ie=ie+n+E),a[o]=ie}}c&&(a[o]=m)}return a}e.shorten=g;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function S(i,n=Object.create(null)){const a=[];let c=!1,o="";for(const m of i)if(m==="$"||c&&m==="{")o&&a.push({value:o,type:h.TEXT}),o="",c=!0;else if(m==="}"&&c){const D=n[o];if(typeof D=="string")D.length&&a.push({value:D,type:h.VARIABLE});else if(D){const M=a[a.length-1];(!M||M.type!==h.SEPARATOR)&&a.push({value:D.label,type:h.SEPARATOR})}o="",c=!1}else o+=m;return o&&!c&&a.push({value:o,type:h.TEXT}),a.filter((m,D)=>{if(m.type===h.SEPARATOR){const M=a[D-1],T=a[D+1];return[M,T].every(N=>N&&(N.type===h.VARIABLE||N.type===h.TEXT)&&N.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=S;function w(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function C(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){const n=i.indexOf("/")!==-1?s.posix:s.win32,a=n.basename(i),c=n.dirname(i);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=l}),define(ee[150],te([0,1,17,8]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function s(y){return y.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const d=this.a.transformIncoming(b);return d===b?b:s(L.URI.from(d))}transformOutgoing(b){const d=this.a.transformOutgoing(b);return d===b?b:s(L.URI.from(d))}transformOutgoingURI(b){const d=this.a.transformOutgoing(b);return d===b?b:L.URI.from(d)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function R(y,b,d){if(!y||d>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return b.transformOutgoing(y);for(const E in y)if(Object.hasOwnProperty.call(y,E)){const v=R(y[E],b,d+1);v!==null&&(y[E]=v)}}return null}function k(y,b){const d=R(y,b,0);return d===null?y:d}e.transformOutgoingURIs=k;function f(y,b,d,E){if(!y||E>200)return null;if(typeof y=="object"){if(y.$mid===1)return d?L.URI.revive(b.transformIncoming(y)):b.transformIncoming(y);if(y instanceof I.VSBuffer)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const r=f(y[v],b,d,E+1);r!==null&&(y[v]=r)}}return null}function u(y,b){const d=f(y,b,!1,0);return d===null?y:d}e.transformIncomingURIs=u;function p(y,b){const d=f(y,b,!0,0);return d===null?y:d}e.transformAndReviveIncomingURIs=p}),define(ee[86],te([0,1,27,61,31,138]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(u){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(u)}value(){if(this.b===void 0){let u=0,p=0;const y=(0,I.networkInterfaces)();for(const b in y){const d=y[b];if(d)for(const{mac:E,internal:v}of d)v||(p+=1,this.c(E.toUpperCase())&&(u+=1))}this.b=p>0?u/p:0}return this.b}};let R;async function k(u){return R||(R=(async()=>await f(u)||s.generateUuid())()),R}e.getMachineId=k;async function f(u){try{const p=await new Promise((b,d)=>{x(["crypto"],b,d)}),y=(0,A.getMac)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){u(p);return}}}),define(ee[24],te([0,1,41,27,151,7,32,82,9,4,18,8]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function d(ae,de=b.UNLINK){if((0,R.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return de===b.UNLINK?v(ae):E(ae)}async function E(ae){try{const de=(0,R.randomPath)((0,L.tmpdir)());try{await I.promises.rename(ae,de)}catch(ce){return ce.code==="ENOENT"?void 0:v(ae)}v(de).catch(ce=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function v(ae){return(0,s.promisify)(I.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function r(ae){if((0,R.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function g(ae,de){return w(await(de?h(ae):(0,s.promisify)(I.readdir)(ae)))}async function h(ae){try{return await(0,s.promisify)(I.readdir)(ae,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const de=[],ce=await g(ae);for(const X of ce){let J=!1,H=!1,W=!1;try{const V=await e.Promises.lstat((0,f.join)(ae,X));J=V.isFile(),H=V.isDirectory(),W=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}de.push({name:X,isFile:()=>J,isDirectory:()=>H,isSymbolicLink:()=>W})}return de}function S(ae){return w(I.readdirSync(ae))}e.readdirSync=S;function w(ae){return ae.map(de=>typeof de=="string"?u.isMacintosh?(0,k.normalizeNFC)(de):de:(de.name=u.isMacintosh?(0,k.normalizeNFC)(de.name):de.name,de))}async function C(ae){const de=await g(ae),ce=[];for(const X of de)await l.existsDirectory((0,f.join)(ae,X))&&ce.push(X);return ce}function t(ae,de=1e3){return new Promise(ce=>{let X=!1;const J=setInterval(()=>{X||(X=!0,I.access(ae,H=>{X=!1,H&&(clearInterval(J),ce(void 0))}))},de)})}e.whenDeleted=t;var l;(function(ae){async function de(J){let H;try{if(H=await e.Promises.lstat(J),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(u.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw V}throw W}}ae.stat=de;async function ce(J){try{const{stat:H,symbolicLink:W}=await ae.stat(J);return H.isFile()&&W?.dangling!==!0}catch{}return!1}ae.existsFile=ce;async function X(J){try{const{stat:H,symbolicLink:W}=await ae.stat(J);return H.isDirectory()&&W?.dangling!==!0}catch{}return!1}ae.existsDirectory=X})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function n(ae,de,ce){return i.queueFor(y.URI.file(ae),p.extUriBiasedIgnorePathCase).queue(()=>{const X=D(ce);return new Promise((J,H)=>o(ae,de,X,W=>W?H(W):J()))})}let a=!0;function c(ae){a=ae}e.configureFlushOnWrite=c;function o(ae,de,ce,X){if(!a)return I.writeFile(ae,de,{mode:ce.mode,flag:ce.flag},X);I.open(ae,ce.flag,ce.mode,(J,H)=>{if(J)return X(J);I.writeFile(H,de,W=>{if(W)return I.close(H,()=>X(W));I.fdatasync(H,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),c(!1)),I.close(H,Y=>X(Y))))})})}function m(ae,de,ce){const X=D(ce);if(!a)return I.writeFileSync(ae,de,{mode:X.mode,flag:X.flag});const J=I.openSync(ae,X.flag,X.mode);try{I.writeFileSync(J,de);try{I.fdatasyncSync(J)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),c(!1)}}finally{I.closeSync(J)}}e.writeFileSync=m;function D(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function M(ae,de){if(ae!==de)try{await e.Promises.rename(ae,de)}catch(ce){if(ae.toLowerCase()!==de.toLowerCase()&&ce.code==="EXDEV"||ae.endsWith("."))await T(ae,de,{preserveSymlinks:!1}),await d(ae,b.MOVE);else throw ce}}async function T(ae,de,ce){return $(ae,de,{root:{source:ae,target:de},options:ce,handledSourcePaths:new Set})}const N=511;async function $(ae,de,ce){if(ce.handledSourcePaths.has(ae))return;ce.handledSourcePaths.add(ae);const{stat:X,symbolicLink:J}=await l.stat(ae);if(J){if(ce.options.preserveSymlinks)try{return await oe(ae,de,ce)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(J.dangling)return}return X.isDirectory()?q(ae,de,X.mode&N,ce):ie(ae,de,X.mode&N)}async function q(ae,de,ce,X){await e.Promises.mkdir(de,{recursive:!0,mode:ce});const J=await g(ae);for(const H of J)await $((0,f.join)(ae,H),(0,f.join)(de,H),X)}async function ie(ae,de,ce){await e.Promises.copyFile(ae,de),await e.Promises.chmod(de,ce)}async function oe(ae,de,ce){let X=await e.Promises.readlink(ae);(0,R.isEqualOrParent)(X,ce.root.source,!u.isLinux)&&(X=(0,f.join)(ce.root.target,X.substr(ce.root.source.length+1))),await e.Promises.symlink(X,de)}e.Promises=new class{get access(){return(0,s.promisify)(I.access)}get stat(){return(0,s.promisify)(I.stat)}get lstat(){return(0,s.promisify)(I.lstat)}get utimes(){return(0,s.promisify)(I.utimes)}get read(){return(ae,de,ce,X,J)=>new Promise((H,W)=>{I.read(ae,de,ce,X,J,(V,Y,ne)=>V?W(V):H({bytesRead:Y,buffer:ne}))})}get readFile(){return(0,s.promisify)(I.readFile)}get write(){return(ae,de,ce,X,J)=>new Promise((H,W)=>{I.write(ae,de,ce,X,J,(V,Y,ne)=>V?W(V):H({bytesWritten:Y,buffer:ne}))})}get appendFile(){return(0,s.promisify)(I.appendFile)}get fdatasync(){return(0,s.promisify)(I.fdatasync)}get truncate(){return(0,s.promisify)(I.truncate)}get rename(){return(0,s.promisify)(I.rename)}get copyFile(){return(0,s.promisify)(I.copyFile)}get open(){return(0,s.promisify)(I.open)}get close(){return(0,s.promisify)(I.close)}get symlink(){return(0,s.promisify)(I.symlink)}get readlink(){return(0,s.promisify)(I.readlink)}get chmod(){return(0,s.promisify)(I.chmod)}get mkdir(){return(0,s.promisify)(I.mkdir)}get unlink(){return(0,s.promisify)(I.unlink)}get rmdir(){return(0,s.promisify)(I.rmdir)}get realpath(){return(0,s.promisify)(I.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return C}get writeFile(){return n}get rm(){return d}get move(){return M}get copy(){return T}}}),define(ee[103],te([0,1,41,9,4,26,24]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(b){if(s.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const E=((0,L.basename)(b)||b).toLowerCase();try{const r=(0,R.readdirSync)(d).filter(g=>g.toLowerCase()===E);if(r.length===1){const g=k(d);if(g)return(0,L.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(E);if(g>=0){const h=k(d);if(h)return(0,L.join)(h,r[g])}}}catch{}return null}e.realcaseSync=k;async function f(b){if(s.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const E=((0,L.basename)(b)||b).toLowerCase();try{const r=(await R.Promises.readdir(d)).filter(g=>g.toLowerCase()===E);if(r.length===1){const g=await f(d);if(g)return(0,L.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(E);if(g>=0){const h=await f(d);if(h)return(0,L.join)(h,r[g])}}}catch{}return null}e.realcase=f;async function u(b){try{return await R.Promises.realpath(b)}catch{const E=y(b);return await R.Promises.access(E,I.constants.R_OK),E}}e.realpath=u;function p(b){try{return I.realpathSync(b)}catch{const E=y(b);return I.accessSync(E,I.constants.R_OK),E}}e.realpathSync=p;function y(b){return(0,A.rtrim)((0,L.normalize)(b),L.sep)}}),define(ee[152],te([0,1,27,9,24]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var f;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(C,t,l){this.exePath=C,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:w=!1}={}){return w?u===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:w=!1,findPreview:C=!1}={}){const t=b({useAlternateBitness:w});if(!t)return null;const l=L.join(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let i=-1,n=null;for(const o of await s.Promises.readdir(l)){let m=-1;if(C){const M=o.indexOf("-");if(M<0)continue;const T=o.substring(0,M);if(!A.test(T)||o.substring(M+1)!=="preview")continue;m=parseInt(T,10)}else{if(!A.test(o))continue;m=parseInt(o,10)}if(m<=i)continue;const D=L.join(l,o,"pwsh.exe");!await s.SymlinkSupport.existsFile(D)||(n=D,i=m)}if(!n)return null;const a=t.includes("x86")?" (x86)":"",c=C?" Preview":"";return new y(n,`PowerShell${c}${a}`,!0)}async function E({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const C=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=w?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await s.Promises.readdir(C))if(t.test(i)){const n=L.join(C,i,"pwsh.exe");return new y(n,l)}return null}function v(){const w=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new y(w,".NET Core PowerShell Global Tool")}function r(){const w=L.join(process.env.windir,u===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(w,"Windows PowerShell",!0)}async function*g(){let w=await d();w&&(yield w),w=await d({useAlternateBitness:!0}),w&&(yield w),w=await E(),w&&(yield w),w=v(),w&&(yield w),w=await d({findPreview:!0}),w&&(yield w),w=await E({findPreview:!0}),w&&(yield w),w=await d({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=r(),w&&(yield w)}async function*h(){for await(const w of g())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=h;async function S(){for await(const w of h())return w;return null}e.getFirstAvailablePowerShellInstallation=S}),define(ee[87],te([0,1,9,4,36,73,11,24]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(y=s.env){return y.comspec||"cmd.exe"}e.getWindowsShell=f;function u(y){let b=[],d=!1;const E=function(v){if(d){b.push(v);return}(!y.send(v,g=>{if(g&&console.error(g),d=!1,b.length>0){const h=b.slice(0);b=[],h.forEach(S=>E(S))}})||L.isWindows)&&(d=!0)};return{send:E}}e.createQueuedSender=u;var p;(function(y){async function b(d,E,v){if(I.isAbsolute(d))return d;if(E===void 0&&(E=s.cwd()),I.dirname(d)!=="."||(v===void 0&&R.isString(s.env.PATH)&&(v=s.env.PATH.split(I.delimiter)),v===void 0||v.length===0))return I.join(E,d);async function g(h){if(await k.Promises.exists(h)){let S;try{S=await k.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(S=await k.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(const h of v){let S;if(I.isAbsolute(h)?S=I.join(h,d):S=I.join(E,h,d),await g(S))return S;let w=S+".com";if(await g(w)||(w=S+".exe",await g(w)))return w}return I.join(E,d)}y.findExecutable=b})(p=e.win32||(e.win32={}))}),define(ee[104],te([0,1,46,15]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function s(R){return new Promise((k,f)=>{let u;const p=new Map;function y(d,E,v,r,g){const h=p.get(E);if(d===R||h){const S={name:b(v),cmd:v,pid:d,ppid:E,load:r,mem:g};p.set(d,S),d===R&&(u=S),h&&(h.children||(h.children=[]),h.children.push(S),h.children.length>1&&(h.children=h.children.sort((w,C)=>w.pid-C.pid)))}}function b(d){const E=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,h=/conhost\.exe/i,S=/--type=([a-zA-Z-]+)/;if(r.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-process";if(h.exec(d))return"console-window-host (Windows internal process)";let w=S.exec(d);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?E.exec(d)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const C=/[a-zA-Z-]+\.js/g;let t="";do w=C.exec(d),w&&(t+=w+" ");while(w);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=E=>E.indexOf("\\\\?\\")===0||E.indexOf("\\??\\")===0?E.substr(4):E.indexOf('"\\\\?\\')===0||E.indexOf('"\\??\\')===0?'"'+E.substr(5):E;new Promise((E,v)=>{x(["windows-process-tree"],E,v)}).then(E=>{E.getProcessList(R,v=>{if(!v){f(new Error(`Root process ${R} not found`));return}E.getProcessCpuUsage(v,r=>{const g=new Map;r.forEach(h=>{const S=d(h.commandLine||"");g.set(h.pid,{name:b(S),cmd:S,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),u=g.get(R),u?(g.forEach(h=>{const S=g.get(h.ppid);S&&(S.children||(S.children=[]),S.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((S,w)=>S.pid-w.pid))}),k(u)):f(new Error(`Root process ${R} not found`))})},E.ProcessDataFlag.CommandLine|E.ProcessDataFlag.Memory)})}else{let d=function(){let E=[u];const v=[];for(;E.length;){const g=E.shift();g&&(v.push(g.pid),g.children&&(E=E.concat(g.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+v.join(" "),(0,I.exec)(r,{},(g,h,S)=>{if(g||S)f(g||new Error(S.toString()));else{const w=h.toString().split(`
`);for(let C=0;C<v.length;C++){const t=p.get(v[C]);t.load=parseFloat(w[C])}if(!u){f(new Error(`Root process ${R} not found`));return}k(u)}})};(0,I.exec)("which ps",{},(E,v,r)=>{if(E||r)if(process.platform!=="linux")f(E||new Error(r.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(g,{},(h,S,w)=>{h||w?f(h||new Error(w.toString())):(A(S,y),d())})}else{const g=v.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,w,C)=>{S||C&&!C.includes("screen size is bogus")?f(S||new Error(C.toString())):(A(w,y),process.platform==="linux"?d():u?k(u):f(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=s;function A(R,k){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=R.toString().split(`
`);for(const p of u){const y=f.exec(p.trim());y&&y.length===6&&k(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ee[153],te([0,1,27,4,152,87]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(y,b){return y===1?L.isWindows?p():A.getWindowsShell(b):f(y,b)}e.getSystemShell=R;let k=null;function f(y,b){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!k){let d;if(L.isWindows)d="/bin/bash";else{if(d=b.SHELL,!d)try{d=(0,I.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}k=d}return k}let u=null;async function p(){return u||(u=(await(0,s.getFirstAvailablePowerShellInstallation)()).exePath),u}});var ye=this&&this.__decorate||function(x,e,I,L){var s=arguments.length,A=s<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(x,e,I,L);else for(var k=x.length-1;k>=0;k--)(R=x[k])&&(A=(s<3?R(A):s>3?R(e,I,A):R(e,I))||A);return s>3&&A&&Object.defineProperty(e,I,A),A};define(ee[47],te([0,1,22,7,17,23,55,13,3,2,85,26,11]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(d||(d={}));function E(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(v||(v={}));function r(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(g||(g={}));function h(H){let W=0;for(let V=0;;V+=7){const Y=H.read(1);if(W|=(Y.buffer[0]&127)<<V,!(Y.buffer[0]&128))return W}}const S=i(0);function w(H,W){if(W===0){H.write(S);return}let V=0;for(let ne=W;ne!==0;ne=ne>>>7)V++;const Y=s.VSBuffer.alloc(V);for(let ne=0;W!==0;ne++)Y.buffer[ne]=W&127,W=W>>>7,W>0&&(Y.buffer[ne]|=128);H.write(Y)}class C{constructor(W){this.b=W,this.a=0}read(W){const V=this.b.slice(this.a,this.a+W);return this.a+=V.byteLength,V}}e.BufferReader=C;class t{constructor(){this.a=[]}get buffer(){return s.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=t;var l;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(l||(l={}));function i(H){const W=s.VSBuffer.alloc(1);return W.writeUInt8(H,0),W}const n={Undefined:i(l.Undefined),String:i(l.String),Buffer:i(l.Buffer),VSBuffer:i(l.VSBuffer),Array:i(l.Array),Object:i(l.Object),Uint:i(l.Int)},a=typeof Buffer<"u";function c(H,W){if(typeof W>"u")H.write(n.Undefined);else if(typeof W=="string"){const V=s.VSBuffer.fromString(W);H.write(n.String),w(H,V.byteLength),H.write(V)}else if(a&&Buffer.isBuffer(W)){const V=s.VSBuffer.wrap(W);H.write(n.Buffer),w(H,V.byteLength),H.write(V)}else if(W instanceof s.VSBuffer)H.write(n.VSBuffer),w(H,W.byteLength),H.write(W);else if(Array.isArray(W)){H.write(n.Array),w(H,W.length);for(const V of W)c(H,V)}else if(typeof W=="number"&&(W|0)===W)H.write(n.Uint),w(H,W);else{const V=s.VSBuffer.fromString(JSON.stringify(W));H.write(n.Object),w(H,V.byteLength),H.write(V)}}e.serialize=c;function o(H){switch(H.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return H.read(h(H)).toString();case l.Buffer:return H.read(h(H)).buffer;case l.VSBuffer:return H.read(h(H));case l.Array:{const V=h(H),Y=[];for(let ne=0;ne<V;ne++)Y.push(o(H));return Y}case l.Object:return JSON.parse(H.read(h(H)).toString());case l.Int:return h(H)}}e.deserialize=o;class m{constructor(W,V,Y=null,ne=1e3){this.h=W,this.j=V,this.k=Y,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,V){this.b.set(W,V),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const V=this.o([W.type]);this.k?.logOutgoing(V,0,1,r(W.type));return}case 201:case 202:case 204:case 203:{const V=this.o([W.type,W.id],W.data);this.k?.logOutgoing(V,W.id,1,r(W.type),W.data);return}}}o(W,V=void 0){const Y=new t;return c(Y,W),c(Y,V),this.p(Y.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const V=new C(W),Y=o(V),ne=o(V),se=Y[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,Y[1],1,`${E(se)}: ${Y[2]}.${Y[3]}`,ne),this.s({type:se,id:Y[1],channelName:Y[2],name:Y[3],arg:ne});case 102:return this.k?.logIncoming(W.byteLength,Y[1],1,`${E(se)}: ${Y[2]}.${Y[3]}`,ne),this.t({type:se,id:Y[1],channelName:Y[2],name:Y[3],arg:ne});case 101:return this.k?.logIncoming(W.byteLength,Y[1],1,`${E(se)}`),this.u({type:se,id:Y[1]});case 103:return this.k?.logIncoming(W.byteLength,Y[1],1,`${E(se)}`),this.u({type:se,id:Y[1]})}}s(W){const V=this.b.get(W.channelName);if(!V){this.v(W);return}const Y=new A.CancellationTokenSource;let ne;try{ne=V.call(this.j,W.name,W.arg,Y.token)}catch(O){ne=Promise.reject(O)}const se=W.id;ne.then(O=>{this.m({id:se,data:O,type:201}),this.d.delete(W.id)},O=>{O instanceof Error?this.m({id:se,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:se,data:O,type:203}),this.d.delete(W.id)});const _=(0,u.toDisposable)(()=>Y.cancel());this.d.set(W.id,_)}t(W){const V=this.b.get(W.channelName);if(!V){this.v(W);return}const Y=W.id,se=V.listen(this.j,W.name,W.arg)(_=>this.m({id:Y,data:_,type:204}));this.d.set(W.id,se)}u(W){const V=this.d.get(W.id);V&&(V.dispose(),this.d.delete(W.id))}v(W){let V=this.g.get(W.channelName);V||(V=[],this.g.set(W.channelName,V));const Y=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:W,timeoutTimer:Y})}w(W){const V=this.g.get(W);if(V){for(const Y of V)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=m;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(W,V=null){this.l=W,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=V}getChannel(W){const V=this;return{call(Y,ne,se){return V.a?Promise.reject(new k.CancellationError):V.m(W,Y,ne,se)},listen(Y,ne){return V.a?f.Event.None:V.o(W,Y,ne)}}}m(W,V,Y,ne=A.CancellationToken.None){const se=this.g++,O={id:se,type:100,channelName:W,name:V,arg:Y};if(ne.isCancellationRequested)return Promise.reject(new k.CancellationError);let P;return new Promise((U,j)=>{if(ne.isCancellationRequested)return j(new k.CancellationError);const B=()=>{const he=be=>{switch(be.type){case 201:this.f.delete(se),U(be.data);break;case 202:{this.f.delete(se);const ke=new Error(be.data.message);ke.stack=Array.isArray(be.data.stack)?be.data.stack.join(`
`):be.data.stack,ke.name=be.data.name,j(ke);break}case 203:this.f.delete(se),j(be.data);break}};this.f.set(se,he),this.p(O)};let z=null;this.b===g.Idle?B():(z=(0,L.createCancelablePromise)(he=>this.u()),z.then(()=>{z=null,B()}));const G=()=>{z?(z.cancel(),z=null):this.p({id:se,type:101}),j(new k.CancellationError)},re=ne.onCancellationRequested(G);P=(0,u.combinedDisposable)((0,u.toDisposable)(G),re),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(W,V,Y){const ne=this.g++,_={id:ne,type:102,channelName:W,name:V,arg:Y};let O=null;const P=new f.Emitter({onWillAddFirstListener:()=>{O=(0,L.createCancelablePromise)(U=>this.u()),O.then(()=>{O=null,this.d.add(P),this.p(_)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(P),this.p({id:ne,type:103}))}}),F=U=>P.fire(U.data);return this.f.set(ne,F),P.event}p(W){switch(W.type){case 100:case 102:{const V=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(V,W.id,0,`${E(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const V=this.q([W.type,W.id]);this.j?.logOutgoing(V,W.id,0,E(W.type));return}}}q(W,V=void 0){const Y=new t;return c(Y,W),c(Y,V),this.r(Y.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const V=new C(W),Y=o(V),ne=o(V),se=Y[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,r(se)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,Y[1],0,r(se),ne),this.t({type:Y[0],id:Y[1],data:ne})}}t(W){if(W.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}ye([R.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const W=[];return this.f.forEach(V=>W.push(V)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:V,onDidClientDisconnect:Y})=>{f.Event.once(V.onMessage)(se=>{const _=new C(se),O=o(_),P=new m(V,O),F=new M(V);this.a.forEach((j,B)=>P.registerChannel(B,j));const U={channelServer:P,channelClient:F,ctx:O};this.f.add(U),this.g.fire(U),Y(()=>{P.dispose(),F.dispose(),this.f.delete(U),this.h.fire(U)})})})}getChannel(W,V){const Y=this;return{call(ne,se,_){let O;if((0,b.isFunction)(V)){const F=(0,I.getRandomElement)(Y.connections.filter(V));O=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(Y.onDidAddConnection,V))}else O=V.routeCall(Y,ne,se);const P=O.then(F=>F.channelClient.getChannel(W));return $(P).call(ne,se,_)},listen(ne,se){if((0,b.isFunction)(V))return Y.j(W,V,ne,se);const _=V.routeEvent(Y,ne,se).then(O=>O.channelClient.getChannel(W));return $(_).listen(ne,se)}}}j(W,V,Y,ne){const se=this;let _=new u.DisposableStore;const O=new f.Emitter({onWillAddFirstListener:()=>{_=new u.DisposableStore;const P=new f.EventMultiplexer,F=new Map,U=B=>{const G=B.channelClient.getChannel(W).listen(Y,ne),re=P.add(G);F.set(B,re)},j=B=>{const z=F.get(B);!z||(z.dispose(),F.delete(B))};se.connections.filter(V).forEach(U),f.Event.filter(se.onDidAddConnection,V)(U,void 0,_),se.onDidRemoveConnection(j,void 0,_),P.event(O.fire,O,_),_.add(P)},onDidRemoveLastListener:()=>{_.dispose()}});return O.event}registerChannel(W,V){this.a.set(W,V),this.f.forEach(Y=>{Y.channelServer.registerChannel(W,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(W,V,Y=null){const ne=new t;c(ne,V),W.send(ne.buffer),this.a=new M(W,Y),this.d=new m(W,V,Y)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,V){this.d.registerChannel(W,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function $(H){return{call(W,V,Y){return H.then(ne=>ne.call(W,V,Y))},listen(W,V){const Y=new f.Relay;return H.then(ne=>Y.input=ne.listen(W,V)),Y.event}}}e.getDelayedChannel=$;function q(H){let W=!1;return{call(V,Y,ne){return W?H.call(V,Y,ne):(0,L.timeout)(0).then(()=>W=!0).then(()=>H.call(V,Y,ne))},listen(V,Y){if(W)return H.listen(V,Y);const ne=new f.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>ne.input=H.listen(V,Y)),ne.event}}}e.getNextTickChannel=q;class ie{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const V of W.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=ie;var oe;(function(H){function W(se,_){const O=se,P=_&&_.disableMarshalling,F=new Map;for(const U in O)Y(U)&&F.set(U,f.Event.buffer(O[U],!0));return new class{listen(U,j,B){const z=F.get(j);if(z)return z;if(ne(j)){const G=O[j];if(typeof G=="function")return G.call(O,B)}throw new Error(`Event not found: ${j}`)}call(U,j,B){const z=O[j];if(typeof z=="function"){if(!P&&Array.isArray(B))for(let G=0;G<B.length;G++)B[G]=(0,p.revive)(B[G]);return z.apply(O,B)}throw new Error(`Method not found: ${j}`)}}}H.fromService=W;function V(se,_){const O=_&&_.disableMarshalling;return new Proxy({},{get(P,F){if(typeof F=="string")return _?.properties?.has(F)?_.properties.get(F):ne(F)?function(U){return se.listen(F,U)}:Y(F)?se.listen(F):async function(...U){let j;_&&!(0,b.isUndefinedOrNull)(_.context)?j=[_.context,...U]:j=U;const B=await se.call(F,j);return O?B:(0,p.revive)(B)};throw new Error(`Property not found: ${String(F)}`)}})}H.toService=V;function Y(se){return se[0]==="o"&&se[1]==="n"&&y.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&y.isUpperAsciiLetter(se.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const W=H.toString();if(W!=="[object Object]")return W}return H}function ce(H){return Array.isArray(H)?H.map(de):de(H)}function X(H,W,V,Y,ne,se,_){_=ce(_);const O=ae[ne],P=O[Y%O.length];let F=[`%c[${H}]%c[${String(W).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(se)?(F=F.concat(_),F.push(")")):F.push(_),console.log.apply(console,F)}class J{constructor(W,V){this.d=W,this.f=V,this.a=0,this.b=0}logOutgoing(W,V,Y,ne,se){this.b+=W,X(this.d,this.b,W,V,Y,ne,se)}logIncoming(W,V,Y,ne,se){this.a+=W,X(this.f,this.a,W,V,Y,ne,se)}}e.IPCLogger=J}),define(ee[154],te([0,1,17,3,47]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(f){this.a=f,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",u=>I.VSBuffer.wrap(u.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class R extends s.IPCClient{constructor(f,u){const p=new A(f);super(p,u),this.b=p}dispose(){this.b.disconnect()}}e.Client=R}),define(ee[105],te([0,1,7,17,3,2,47]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(M){M.enableDiagnostics=!1,M.records=[];const T=new WeakMap;let N=0;function $(ie,oe){if(!T.has(ie)){const ae=String(++N);T.set(ie,ae)}return T.get(ie)}function q(ie,oe,ae,de){if(!M.enableDiagnostics)return;const ce=$(ie,oe);if(de instanceof L.VSBuffer||de instanceof Uint8Array||de instanceof ArrayBuffer||ArrayBuffer.isView(de)){const X=L.VSBuffer.alloc(de.byteLength);X.set(de),M.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,buff:X})}else M.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,data:de})}M.traceSocketEvent=q})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function y(){return p||(p=L.VSBuffer.alloc(0)),p}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return y();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const oe=this.a[0];return N&&(this.a.shift(),this.b-=T),oe}if(this.a[0].byteLength>T){const oe=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),oe}const $=L.VSBuffer.alloc(T);let q=0,ie=0;for(;T>0;){const oe=this.a[ie];if(oe.byteLength>T){const ae=oe.slice(0,T);$.set(ae,q),q+=T,N&&(this.a[ie]=oe.slice(T),this.b-=T),T-=T}else $.set(oe,q),q+=oe.byteLength,N?(this.a.shift(),this.b-=oe.byteLength):ie++,T-=oe.byteLength}return $}}e.ChunkStream=b;var d;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function E(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class r{constructor(T,N,$,q){this.type=T,this.id=N,this.ack=$,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(T){super(),this.f=this.B(new s.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new b,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,q=this.g.id,ie=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new r($,q,ie,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const $=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,$}h(){const T=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class S extends A.Disposable{constructor(T){super(),this.f=new s.Emitter,this.onMessage=this.f.event,this.g=new s.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new h(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new r(1,0,0,T))}}e.Protocol=S;class w extends R.IPCClient{static fromSocket(T,N){return new w(new S(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,$=null){super(T,N,$),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=w;class C{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new s.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=C;class t{constructor(T){this.data=T,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,$=this.a;for(;$;)T[N++]=$.data,$=$.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new t(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<i.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+i.a)*1e3;let $=0;for(let q=0;q<i.a;q++)T-this.c[q]<=N&&$++;return 1-$/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function a(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class o{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=o;class m{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new C,this.onControlMessage=this.x.event,this.y=new C,this.onMessage=this.y.event,this.z=new C,this.onDidDispose=this.z.event,this.A=new C,this.onSocketClose=this.A.event,this.B=new C,this.onSocketTimeout=this.B.event,this.C=new C,this.onHighRoundTripTime=this.C.event,this.D=new C,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=T.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new r(5,0,0,y());this.p.write(T),this.p.flush()}sendPause(){const T=new r(7,0,0,y());this.p.write(T)}sendResume(){const T=new r(8,0,0,y());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new r(3,0,this.h,y());this.p.write(T);const N=this.b.toArray();for(let $=0,q=N.length;$<q;$++)this.p.write(N[$]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new r(6,0,0,y())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let $=0,q=N.length;$<q;$++)this.p.write(N[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const $=new r(1,N,this.h,T);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(T){const N=new r(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,$=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(N>=2e4&&$>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:$});return}const ie=Math.max(2e4-N,2e4-$,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},ie)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new r(3,0,this.h,y());this.p.write(T)}I(){this.h=this.g;const T=new r(9,0,this.h,y());this.p.write(T)}J(T){this.h=this.g;const N=new r(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new r(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=m;class D extends A.Disposable{constructor(){super(),this.a=this.B(new s.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new s.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new s.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new I.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const $=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=$;const ie=this.l,oe=this.j.filter(ae=>ae>=1e3).length;this.l=oe>=3?1:0,$>1e3&&this.b.fire(new o($,oe)),ie!==this.l&&this.c.fire(this.l)}}}),define(ee[155],te([0,1,42,17,3,2,47,140]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(p,y){const b=s.Event.fromNodeEventEmitter(I.validatedIpcMain,y,(E,v)=>({event:E,message:v})),d=s.Event.filter(b,({event:E})=>E.sender.id===p);return s.Event.map(d,({message:E})=>E&&L.VSBuffer.wrap(E))}class u extends R.IPCServer{static d(){const y=s.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:b})=>b);return s.Event.map(y,b=>{const d=b.id;u.b.get(d)?.dispose();const v=new s.Emitter;u.b.set(d,(0,A.toDisposable)(()=>v.fire()));const r=f(d,"vscode:message"),g=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),v.event);return{protocol:new k.Protocol(b,r),onDidClientDisconnect:g}})}constructor(){super(u.d())}}u.b=new Map,e.Server=u}),define(ee[106],te([0,1,42,3,31,154]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends A.Client{constructor(u,p){super({addEventListener:(y,b)=>u.addListener(y,b),removeEventListener:(y,b)=>u.removeListener(y,b),postMessage:y=>u.postMessage(y),start:()=>u.start(),close:()=>u.close()},p)}}e.Client=R;async function k(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.generateUuid)();f.webContents.send("vscode:createMessageChannel",u);const p=L.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(b,d)=>({nonce:d,port:b.ports[0]})),{port:y}=await L.Event.toPromise(L.Event.once(L.Event.filter(p,b=>b.nonce===u)));return y}e.connect=k}),define(ee[156],te([0,1,46,7,17,23,149,13,3,2,37,87,73,47]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends d.ChannelServer{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.VSBuffer.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=E;class v{constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const S=h&&h.timeout?h.timeout:6e4;this.b=new L.Delayer(S),this.d=null,this.f=null}getChannel(g){const h=this;return{call(S,w,C){return h.k(g,S,w,C)},listen(S,w){return h.l(g,S,w)}}}k(g,h,S,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const C=this.n(g),t=(0,L.createCancelablePromise)(n=>C.call(h,S,n)),l=w.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{l.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,h,S){if(!this.b)return f.Event.None;this.b.cancel();let w;const C=new f.Emitter({onWillAddFirstListener:()=>{w=this.n(g).listen(h,S)(C.fire,C),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(h.env),this.d=(0,I.fork)(this.i,g,h);const S=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.isRemoteConsoleLog)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}S.fire(s.VSBuffer.wrap(Buffer.from(a,"base64")))});const C=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=a=>this.d&&this.d.connected&&C.send(a.buffer.toString("base64")),l=S.event,i={send:t,onMessage:l};this.f=new d.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,c)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,u.dispose)(o)),this.c.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:c})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(ee[88],te([0,1,17,13,3,2,9,4,31,47,105]),function(x,e,I,L,s,A,R,k,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(o,m){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,m)}constructor(o,m=""){this.f=!0,this.debugLabel=m,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,L.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const m=D=>{this.traceSocketEvent("read",D),o(I.VSBuffer.wrap(D))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(o){const m=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(o){const m=()=>{o()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,L.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,L.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=b;var d;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize",c[c.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var E;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(E||(E={}));class v extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,m){this.socket.traceSocketEvent(o,m)}constructor(o,m,D,M){super(),this.f=this.B(new s.Emitter),this.g=this.B(new s.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:D?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new r(this,m,D,M,this.f,(T,N)=>this.k(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,L.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new p.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await s.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){let m=0;for(;m<o.byteLength;)this.a.writeMessage(o.slice(m,Math.min(m+262144,o.byteLength))),m+=262144}k(o,m){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const M=I.VSBuffer.alloc(D);if(m?M.writeUInt8(194,0):M.writeUInt8(130,0),o.byteLength<126)M.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){M.writeUInt8(126,1);let T=1;M.writeUInt8(o.byteLength>>>8&255,++T),M.writeUInt8(o.byteLength>>>0&255,++T)}else{M.writeUInt8(127,1);let T=1;M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(o.byteLength>>>24&255,++T),M.writeUInt8(o.byteLength>>>16&255,++T),M.writeUInt8(o.byteLength>>>8&255,++T),M.writeUInt8(o.byteLength>>>0&255,++T)}this.socket.write(I.VSBuffer.concat([M,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),D=m.readUInt8(0),M=(D&128)>>>7,T=(D&64)>>>6,N=m.readUInt8(1),$=(N&128)>>>7,q=N&127;this.j.state=2,this.j.readLen=2+($?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),D=m.readUInt8(1),M=(D&128)>>>7;let T=D&127,N=1;T===126?T=m.readUInt8(++N)*2**8+m.readUInt8(++N):T===127&&(T=m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*2**24+m.readUInt8(++N)*2**16+m.readUInt8(++N)*2**8+m.readUInt8(++N));let $=0;M&&($=m.readUInt8(++N)*2**24+m.readUInt8(++N)*2**16+m.readUInt8(++N)*2**8+m.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),S(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(m,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await s.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class r extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,m,D,M,T,N){super(),this.l=o,this.m=T,this.n=N,this.a=this.B(new s.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new s.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new s.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,m?(this.b=this.B(new g(this.l,M,D,{windowBits:15})),this.f=this.B(new h(this.l,{windowBits:15})),this.B(this.b.onError($=>this.a.fire($))),this.B(this.f.onError($=>this.a.fire($)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const m=await this.s(this.f,o);this.n(m,!0)}else this.n(o,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(o,m){return new Promise((D,M)=>{o.write(m),o.flush(T=>D(T))})}acceptFrame(o,m,D){this.h.push({data:o,isCompressed:m,isLastFrameOfMessage:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const m=await this.w(this.b,o.data,o.isLastFrameOfMessage);this.m.fire(m)}else this.m.fire(o.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(o,m,D){return new Promise((M,T)=>{o.write(m),D&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>M(N))})}}class g extends A.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(o,m,D,M){super(),this.h=o,this.j=m,this.a=this.B(new s.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=y().zlib.createInflateRaw(M),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(I.VSBuffer.wrap(T))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=I.VSBuffer.concat(this.g);this.g.length=0,o(m)})}}class h extends A.Disposable{constructor(o,m){super(),this.g=o,this.a=this.B(new s.Emitter),this.onError=this.a.event,this.f=[],this.b=y().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(I.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=I.VSBuffer.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),o(m)})}}function S(c,o){if(o===0)return;const m=c.byteLength>>>2;for(let q=0;q<m;q++){const ie=c.readUInt32BE(q*4);c.writeUInt32BE(ie^o,q*4)}const D=m*4,M=c.byteLength-D,T=o>>>24&255,N=o>>>16&255,$=o>>>8&255;M>=1&&c.writeUInt8(c.readUInt8(D)^T,D),M>=2&&c.writeUInt8(c.readUInt8(D+1)^N,D+1),M>=3&&c.writeUInt8(c.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const w={[2]:107,[1]:103};function C(){const c=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;const o=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:y().os.tmpdir(),m=(0,R.join)(o,`vscode-ipc-${c}.sock`);return l(m),m}e.createRandomIPCHandle=C;function t(c,o,m){const D=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${m}-${o}-sock`;const M=m.substr(0,4),T=o.substr(0,6),N=D.substr(0,8);let $;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?$=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${M}-${T}.sock`):$=(0,R.join)(c,`${M}-${T}.sock`),l($),$}e.createStaticIPCHandle=t;function l(c){const o=w[k.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends u.IPCServer{static b(o){const m=s.Event.fromNodeEventEmitter(o,"connection");return s.Event.map(m,D=>({protocol:new p.Protocol(new b(D,"ipc-server-connection")),onDidClientDisconnect:s.Event.once(s.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(i.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(c){return new Promise((o,m)=>{const D=y().net.createServer();D.on("error",m),D.listen(c,()=>{D.removeListener("error",m),o(new i(D))})})}e.serve=n;function a(c,o){return new Promise((m,D)=>{const M=y().net.createConnection(c,()=>{M.removeListener("error",D),m(p.Client.fromSocket(new b(M,`ipc-client${o}`),o))});M.once("error",D)})}e.connect=a}),define(ee[107],te([0,1,7,3,2,11]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R=e.StorageHint||(e.StorageHint={}));function k(y){const b=y;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var f;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class u extends s.Disposable{constructor(b,d=Object.create(null)){super(),this.m=b,this.n=d,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new I.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((d,E)=>this.s(E,d)),b.deleted?.forEach(d=>this.s(d,void 0))}s(b,d){if(this.c===f.Closed)return;let E=!1;(0,A.isUndefinedOrNull)(d)?E=this.f.delete(b):this.f.get(b)!==d&&(this.f.set(b,d),E=!0),E&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,d){const E=this.f.get(b);return(0,A.isUndefinedOrNull)(E)?d:E}getBoolean(b,d){const E=this.get(b);return(0,A.isUndefinedOrNull)(E)?d:E==="true"}getNumber(b,d){const E=this.get(b);return(0,A.isUndefinedOrNull)(E)?d:parseInt(E,10)}async set(b,d){if(this.c===f.Closed)return;if((0,A.isUndefinedOrNull)(d))return this.delete(b);const E=String(d);if(this.f.get(b)!==E)return this.f.set(b,E),this.j.set(b,E),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===f.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}u.a=100,e.Storage=u;class p{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((d,E)=>this.a.set(E,d)),b.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=p}),define(ee[157],te([0,1,7,3,35,9,24]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return L.Event.None}constructor(p,y=Object.create(null)){this.g=p,this.h=y,this.c=(0,A.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,y=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(d=>y.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(p){const y=await this.f;return this.j(y,p)}j(p,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,s.mapToString)(y.insert):"0"}), delete(${y.delete?(0,s.setToString)(y.delete):"0"})`),this.t(p,()=>{const b=y.insert,d=y.delete;if(b&&b.size>0){const E=[];E.push([]);let v=0;b.forEach((r,g)=>{let h=E[v];h.length>k.b&&(v++,h=[],E.push(h)),h.push(g,r)}),E.forEach(r=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(r.length/2).fill("(?,?)").join(",")}`,g=>g.run(r),()=>{const g=[];let h=0;return b.forEach((S,w)=>{g.push(w),h+=S.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(d&&d.size){const E=[];E.push([]);let v=0;d.forEach(r=>{let g=E[v];g.length>k.b&&(v++,g=[],E.push(g)),g.push(r)}),E.forEach(r=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(r.length).fill("?").join(",")})`,g=>g.run(r),()=>{const g=[];return d.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,p)}k(p,y){return new Promise((b,d)=>{p.db.close(E=>(E&&this.o(p,`[storage ${this.c}] close(): ${E}`),this.g===k.IN_MEMORY_PATH?b():!p.isErroneous&&!p.isInMemory?this.l().then(b,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),b())):typeof y=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const r=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>r(),g=>(r(),Promise.reject(g)))})).then(b,d):d(E||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return R.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const y=await this.f,b=await this.r(y,p?"PRAGMA integrity_check":"PRAGMA quick_check"),d=p?b.integrity_check:b.quick_check;return y.isErroneous?`${d} (last error: ${y.lastError})`:y.isInMemory?`${d} (in-memory!)`:d}async n(p,y=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${y})`);try{return await this.p(p)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&y)return await(0,I.timeout)(k.a),this.n(p,!1);try{await R.Promises.unlink(p);try{await R.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(k.IN_MEMORY_PATH)}}}o(p,y){p.isErroneous=!0,p.lastError=y,this.d.error(y)}p(p){return new Promise((y,b)=>{new Promise((d,E)=>{x(["@vscode/sqlite3"],d,E)}).then(d=>{const E={db:new(this.d.isTracing?d.verbose().Database:d.Database)(p,v=>v?E.db&&v.code!=="SQLITE_CANTOPEN"?E.db.close(()=>b(v)):b(v):this.q(E,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(E),r=>E.db.close(()=>b(r)))),isInMemory:p===k.IN_MEMORY_PATH};E.db.on("error",v=>this.o(E,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&E.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},b)})}q(p,y){return new Promise((b,d)=>{p.db.exec(y,E=>E?(this.o(p,`[storage ${this.c}] exec(): ${E}`),d(E)):b())})}r(p,y){return new Promise((b,d)=>{p.db.get(y,(E,v)=>E?(this.o(p,`[storage ${this.c}] get(): ${E}`),d(E)):b(v))})}s(p,y){return new Promise((b,d)=>{p.db.all(y,(E,v)=>E?(this.o(p,`[storage ${this.c}] all(): ${E}`),d(E)):b(v))})}t(p,y){return new Promise((b,d)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),y(),p.db.run("END TRANSACTION",E=>E?(this.o(p,`[storage ${this.c}] transaction(): ${E}`),d(E)):b())})})}u(p,y,b,d){const E=p.db.prepare(y),v=r=>{this.o(p,`[storage ${this.c}] prepare(): ${r} (${y}). Details: ${d()}`)};E.on("error",v),b(E),E.finalize(r=>{r&&v(r),E.removeListener("error",v)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class f{constructor(p){p&&typeof p.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[158],te([12,10]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(ee[159],te([12,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[160],te([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[161],te([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(ee[162],te([12,10]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[163],te([12,10]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[164],te([12,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(ee[165],te([12,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(ee[166],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[167],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[168],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[169],te([12,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[170],te([12,10]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[171],te([12,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(ee[172],te([12,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(ee[173],te([12,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(ee[174],te([12,10]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[175],te([12,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[176],te([12,10]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[177],te([12,10]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[178],te([12,10]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[179],te([12,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(ee[180],te([12,10]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(ee[181],te([12,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[182],te([12,10]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[183],te([12,10]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[184],te([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[185],te([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[186],te([12,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(ee[187],te([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[188],te([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[189],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(s){return s&&s.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function L(s){return s&&s.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[190],te([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function s(R){let k=[];try{Array.isArray(R.workspaces)&&(k=R.workspaces.map(f=>({workspace:{id:f.id,configPath:I.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=s;function A(R){let k=[];try{Array.isArray(R.folders)&&(k=R.folders.map(f=>({folderUri:I.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=A}),define(ee[191],te([0,1,13,161]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s=e.TokenType||(e.TokenType={}));function A(...u){switch(u.length){case 1:return(0,L.localize)(0,null,u[0]);case 2:return(0,L.localize)(1,null,u[0],u[1]);case 3:return(0,L.localize)(2,null,u[0],u[1],u[2]);default:return}}const R=(0,L.localize)(3,null),k=(0,L.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const y=this.d,b=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:b};this.g.push({offset:y,lexeme:b,additionalInfo:p}),this.f.push(d)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const y=this.c.substring(this.d,this.e),b=f.b.get(y);b?this.k(b):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,y=!1,b=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(k);return}const E=this.c.charCodeAt(p);if(y)y=!1;else if(E===47&&!b){p++;break}else E===91?b=!0:E===92?y=!0:E===93&&(b=!1);p++}for(;p<this.c.length&&f.a.has(this.c.charCodeAt(p));)p++;this.e=p;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}f.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=f}),define(ee[192],te([0,1,3,2]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class s{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(k,f,u){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(k,f,u){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}s.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=s;class A extends L.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,f,u){this.b.call("attach",[k,f,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,f){this.b.call("terminate",[k,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,f){return this.b.call("openExtensionDevelopmentHostWindow",[k,f])}}e.ExtensionHostDebugChannelClient=A}),define(ee[193],te([0,1,143,55,15,9,36,18,8]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,A.dirname)(s.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(s.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,A.resolve)(d)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const E=R.env.VSCODE_EXTENSIONS;if(E)return E;const v=R.env.VSCODE_PORTABLE;return v?(0,A.join)(v,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(E=>/^[^:/?#]+?:\/\//.test(E)?f.URI.parse(E):f.URI.file((0,A.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const E of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=R.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,E,v){this.a=d,this.b=E,this.c=v,this.editSessionId=this.args.editSessionId}}ye([L.memoize],u.prototype,"appRoot",null),ye([L.memoize],u.prototype,"userHome",null),ye([L.memoize],u.prototype,"userDataPath",null),ye([L.memoize],u.prototype,"appSettingsHome",null),ye([L.memoize],u.prototype,"tmpDir",null),ye([L.memoize],u.prototype,"cacheHome",null),ye([L.memoize],u.prototype,"stateResource",null),ye([L.memoize],u.prototype,"userRoamingDataHome",null),ye([L.memoize],u.prototype,"userDataSyncHome",null),ye([L.memoize],u.prototype,"sync",null),ye([L.memoize],u.prototype,"machineSettingsResource",null),ye([L.memoize],u.prototype,"workspaceStorageHome",null),ye([L.memoize],u.prototype,"localHistoryHome",null),ye([L.memoize],u.prototype,"keyboardLayoutResource",null),ye([L.memoize],u.prototype,"argvResource",null),ye([L.memoize],u.prototype,"isExtensionDevelopment",null),ye([L.memoize],u.prototype,"untitledWorkspacesHome",null),ye([L.memoize],u.prototype,"builtinExtensionsPath",null),ye([L.memoize],u.prototype,"extensionsPath",null),ye([L.memoize],u.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],u.prototype,"extensionDevelopmentKind",null),ye([L.memoize],u.prototype,"extensionTestsLocationURI",null),ye([L.memoize],u.prototype,"debugExtensionHost",null),ye([L.memoize],u.prototype,"logLevel",null),ye([L.memoize],u.prototype,"extensionLogLevel",null),ye([L.memoize],u.prototype,"serviceMachineIdResource",null),ye([L.memoize],u.prototype,"disableTelemetry",null),ye([L.memoize],u.prototype,"disableWorkspaceTrust",null),ye([L.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function p(b,d){return y(b["inspect-extensions"],b["inspect-brk-extensions"],5870,d,b.debugId,b.extensionEnvironment)}e.parseExtensionHostDebugPort=p;function y(b,d,E,v,r,g){const S=Number(d||b)||(v?null:E),w=S?Boolean(!!d):!1;let C;if(g)try{C=JSON.parse(g)}catch{}return{port:S,break:w,debugId:r,env:C}}e.parseDebugParams=y}),define(ee[108],te([0,1,291,4,164]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},category:{type:"string",cat:"e",description:(0,s.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,s.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(v,r,g=R){const h=v.find(c=>c.length>0&&c[0]!=="-"),S={},w=["_"],C=[],t={};let l;for(const c in r){const o=r[c];o.type==="subcommand"?c===h&&(l=o):(o.alias&&(S[c]=o.alias),o.type==="string"||o.type==="string[]"?(w.push(c),o.deprecates&&w.push(...o.deprecates)):o.type==="boolean"&&(C.push(c),o.deprecates&&C.push(...o.deprecates)),o.global&&(t[c]=o))}if(l&&h){const c=t;for(const M in l.options)c[M]=l.options[M];const o=v.filter(M=>M!==h),m=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,D=k(o,c,m);return{[h]:D,_:[]}}const i=I(v,{string:w,boolean:C,alias:S}),n={},a=i;n._=i._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in r){const o=r[c];if(o.type==="subcommand")continue;o.alias&&delete a[o.alias];let m=a[c];if(o.deprecates)for(const D of o.deprecates)a.hasOwnProperty(D)&&(m||(m=a[D],m&&g.onDeprecatedOption(D,o.deprecationMessage||(0,s.localize)(36,null,c))),delete a[D]);if(typeof m<"u"){if(o.type==="string[]"){if(Array.isArray(m)||(m=[m]),!o.allowEmptyValue){const D=m.filter(M=>M.length>0);D.length!==m.length&&(g.onEmptyValue(c),m=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(m)?(m=m.pop(),g.onMultipleValues(c,m)):!m&&!o.allowEmptyValue&&(g.onEmptyValue(c),m=void 0));n[c]=m,o.deprecationMessage&&g.onDeprecatedOption(c,o.deprecationMessage)}delete a[c]}for(const c in a)g.onUnknownOption(c);return n}e.parseArgs=k;function f(v,r){let g="";return r.args&&(Array.isArray(r.args)?g=` <${r.args.join("> <")}>`:g=` <${r.args}>`),r.alias?`-${r.alias} --${v}${g}`:`--${v}${g}`}function u(v,r){const g=[];for(const h in v){const S=v[h],w=f(h,S);g.push([w,S.description])}return p(g,r)}e.formatOptions=u;function p(v,r){const h=v.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(r-h<25)return v.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const S=r-h-1,w=[];for(const C of v){const t=C[0],l=b(C[1],S),i=y(h-t.length-2);w.push("  "+t+i+l[0]);for(let n=1;n<l.length;n++)w.push(y(h)+l[n])}return w}function y(v){return" ".repeat(v)}function b(v,r){const g=[];for(;v.length;){const h=v.length<r?v.length:v.lastIndexOf(" ",r),S=v.slice(0,h).trim();v=v.slice(h),g.push(S)}return g}function d(v,r,g,h,S){const w=process.stdout.isTTY&&process.stdout.columns||80,C=S?.noInputFiles!==!0?`[${(0,s.localize)(37,null)}...]`:"",t=[`${v} ${g}`];t.push(""),t.push(`${(0,s.localize)(38,null)}: ${r} [${(0,s.localize)(39,null)}]${C}`),t.push(""),S?.noPipe!==!0&&(L.isWindows?t.push((0,s.localize)(40,null,r)):t.push((0,s.localize)(41,null,r)),t.push(""));const l={},i=[];for(const n in h){const a=h[n];if(a.type==="subcommand")a.description&&i.push({command:n,description:a.description});else if(a.description&&a.cat){let c=l[a.cat];c||(l[a.cat]=c={}),c[n]=a}}for(const n in l){const a=n,c=l[a];c&&(t.push(A[a]),t.push(...u(c,w)),t.push(""))}return i.length&&(t.push((0,s.localize)(42,null)),t.push(...p(i.map(n=>[n.command,n.description]),w)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function E(v,r){return`${v||(0,s.localize)(43,null)}
${r||(0,s.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=E}),define(ee[194],te([0,1,84,192,108]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,f,u){return f==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(k,f,u)}async g(k,f){const u=(0,s.parseArgs)(k,s.OPTIONS);u.debugRenderer=f;const p=u.extensionDevelopmentPath;if(!p)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const b=y.win;if(!b)return{success:!0};const d=b.webContents.debugger;let E=d.isAttached()?1/0:0;const v=(0,I.createServer)(r=>{E++===0&&d.attach();let g=!1;const h=C=>{g||r.write(JSON.stringify(C)+"\0")},S=(C,t,l,i)=>h({method:t,params:l,sessionId:i});b.on("close",()=>{d.removeListener("message",S),r.end(),g=!0}),d.addListener("message",S);let w=Buffer.alloc(0);r.on("data",C=>{w=Buffer.concat([w,C]);for(let t=w.indexOf(0);t!==-1;t=w.indexOf(0)){let l;try{const i=w.slice(0,t).toString("utf8");w=w.slice(t+1),l=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}d.sendCommand(l.method,l.params,l.sessionId).then(i=>h({id:l.id,sessionId:l.sessionId,result:i})).catch(i=>h({id:l.id,sessionId:l.sessionId,error:{code:0,message:i.message}}))}}),r.on("error",C=>{console.error("error on cdp pipe:",C)}),r.on("close",()=>{g=!0,--E===0&&d.detach()})});return await new Promise(r=>v.listen(0,r)),b.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[62],te([0,1,292,165,108]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function R(b,d){const E=(w,C)=>{console.warn((0,L.localize)(0,null,w,C))},v=w=>{console.warn((0,L.localize)(1,null,w))},r=(w,C)=>{console.warn((0,L.localize)(2,null,w,C))},g=w=>({onUnknownOption:C=>{w!=="tunnel"&&console.warn((0,L.localize)(3,null,C,w))},onMultipleValues:E,onEmptyValue:v,onDeprecatedOption:r,getSubcommandReporter:w!=="tunnel"?g:void 0}),h={onUnknownOption:w=>{console.warn((0,L.localize)(4,null,w))},onMultipleValues:E,onEmptyValue:v,onDeprecatedOption:r,getSubcommandReporter:g},S=(0,s.parseArgs)(b,s.OPTIONS,d?h:void 0);return S.goto&&S._.forEach(w=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,L.localize)(5,null))),S["max-memory"]&&I(parseInt(S["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),S}function k(b){const d=b.findIndex(E=>!/^-/.test(E));if(d>-1)return[...b.slice(0,d),...b.slice(d+1)]}function f(b){let[,...d]=b;process.env.VSCODE_DEV&&(d=k(d)||[]);const E=!y(process.env);return R(d,E)}e.parseMainProcessArgv=f;function u(b){let[,,...d]=b;return process.env.VSCODE_DEV&&(d=k(d)||[]),R(d,!0)}e.parseCLIProcessArgv=u;function p(b,...d){const E=b.indexOf("--");return E===-1?b.push(...d):b.splice(E,0,...d),b}e.addArg=p;function y(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function x(e,I,L){function s(R,k){const f=A(R,k),u=[f];return e.isAbsolute(f)||u.unshift(L),e.resolve(...u)}function A(R,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,k);const p=R["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(I.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,k)}return{getUserDataPath:s}}if(typeof define=="function")define(ee[195],te([196,27,36]),function(e,I,L){return x(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=x(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[109],te([0,1,27,193,195]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(u,p){super(u,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,p.nameShort)},p)}}e.NativeEnvironmentService=A;function R(f,u){return(0,L.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.parsePtyHostDebugPort=R;function k(f,u){return(0,L.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(ee[197],te([0,1,41,27,32]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(R){const k=(0,s.randomPath)((0,L.tmpdir)());try{return(0,I.writeFileSync)(k,""),R&&console.log(`Marker file for --wait created: ${k}`),k}catch(f){R&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=A}),define(ee[198],te([0,1,11,167]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function s(R,k,f){try{A(R,k,f)}catch(u){console.error(u?.message??u)}return R}e.localizeManifest=s;function A(R,k,f){const u=(p,y,b)=>{const d=p[y];if((0,I.isString)(d)){const E=d,v=E.length;if(v>1&&E[0]==="%"&&E[v-1]==="%"){const r=E.substr(1,v-2);let g=k[r];g===void 0&&f&&(g=f[r]);const h=typeof g=="string"?g:g?.message,S=f?.[r],w=typeof S=="string"?S:S?.message;if(!h){w||console.warn(`[${R.name}]: ${(0,L.localize)(0,null,r)}`);return}if(b&&(y==="title"||y==="category")&&w&&w!==h){const C={value:h,original:w};p[y]=C}else p[y]=h}}else if((0,I.isObject)(d))for(const E in d)d.hasOwnProperty(E)&&(E==="commands"?u(d,E,!0):u(d,E,b));else if(Array.isArray(d))for(let E=0;E<d.length;E++)u(d,E,b)};for(const p in R)R.hasOwnProperty(p)&&u(R,p)}}),define(ee[199],te([0,1,18,75,169,200]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=f;function u(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=u;function p(g){if(!g)return null;const h=g.majorBase,S=g.majorMustEqual,w=g.minorBase;let C=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(h===0||(C=!1),l=!1);let i=0;if(g.preRelease){const n=k.exec(g.preRelease);if(n){const[,a,c,o]=n;i=Date.UTC(Number(a),Number(c)-1,Number(o))}}return{majorBase:h,majorMustEqual:S,minorBase:w,minorMustEqual:C,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function y(g,h,S){let w;typeof g=="string"?w=p(u(g)):w=g;let C;h instanceof Date?C=h.getTime():typeof h=="string"&&(C=new Date(h).getTime());let t;if(typeof S=="string"?t=p(u(S)):t=S,!w||!t)return!1;const l=w.majorBase,i=w.minorBase,n=w.patchBase;let a=t.majorBase,c=t.minorBase,o=t.patchBase;const m=t.notBefore;let D=t.majorMustEqual,M=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?l>a?!0:l<a?!1:i>c?!0:i<c||C&&C<m?!1:n>=o:(l===1&&a===0&&(!D||!M||!T)&&(a=1,c=0,o=0,D=!0,M=!1,T=!1),l<a?!1:l>a?!D:i<c?!1:i>c?!M:n<o?!1:n>o?!T:!(C&&C<m))}e.isValidVersion=y;function b(g,h,S,w,C){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([L.default.Error,s.localize(0,null)]),t;if(typeof w.name!="string")return t.push([L.default.Error,s.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([L.default.Error,s.localize(2,null,"version")]),t;if(!w.engines)return t.push([L.default.Error,s.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([L.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!r(w.extensionDependencies))return t.push([L.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!r(w.activationEvents))return t.push([L.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([L.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([L.default.Warning,s.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([L.default.Error,s.localize(9,null,"main")]),t;{const n=(0,I.joinPath)(S,w.main);(0,I.isEqualOrParent)(n,S)||t.push([L.default.Warning,s.localize(10,null,n.path,S.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([L.default.Error,s.localize(11,null,"browser")]),t;{const n=(0,I.joinPath)(S,w.browser);(0,I.isEqualOrParent)(n,S)||t.push([L.default.Warning,s.localize(12,null,n.path,S.path)])}}if(!A.valid(w.version))return t.push([L.default.Error,s.localize(13,null)]),t;const l=[];if(!d(g,h,w,C,l))for(const n of l)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=b;function d(g,h,S,w,C){return w||typeof S.main>"u"&&typeof S.browser>"u"?!0:v(g,h,S.engines.vscode,C)}e.isValidExtensionVersion=d;function E(g,h,S){return g==="*"||v(h,S,g)}e.isEngineValid=E;function v(g,h,S,w=[]){const C=p(u(S));if(!C)return w.push(s.localize(14,null,S)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return w.push(s.localize(15,null,S)),!1}else if(!C.majorMustEqual)return w.push(s.localize(16,null,S)),!1;return y(g,h,C)?!0:(w.push(s.localize(17,null,g,S)),!1)}function r(g){if(!Array.isArray(g))return!1;for(let h=0,S=g.length;h<S;h++)if(typeof g[h]!="string")return!1;return!0}}),define(ee[201],te([0,1,17,31]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function s(A,R,k){let f=k&&k.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const p=(await R.readFile(A.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(p)?p:null}catch{f=null}if(!f){f=(0,L.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,I.VSBuffer.fromString(f))}catch{}}return k?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=s}),define(ee[76],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(s,A=[],R=!1){this.ctor=s,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=I}),define(ee[202],te([0,1,76]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var s;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(s=e.InstantiationType||(e.InstantiationType={}));function A(k,f,u){f instanceof I.SyncDescriptor||(f=new I.SyncDescriptor(f,[],Boolean(u))),L.push([k,f])}e.registerSingleton=A;function R(){return L}e.getSingletonServiceDescriptors=R}),define(ee[203],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const k=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(R);k.outgoing.set(f.key,f),f.incoming.set(k.key,k)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const k of this.a.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let k=this.a.get(R);return k||(k=new I(R,A),this.a.set(R,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,k]of this.a)A.push(`${R}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const k=new Set([A]),f=this.c(R,k);if(f)return f}}c(A,R){for(const[k,f]of A.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const u=this.c(f,R);if(u)return u;R.delete(k)}}}e.Graph=L}),define(ee[6],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function k(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=k})(I=e._util||(e._util={})),e.IInstantiationService=s("instantiationService");function L(R,k,f){k[I.DI_TARGET]===k?k[I.DI_DEPENDENCIES].push({id:R,index:f}):(k[I.DI_DEPENDENCIES]=[{id:R,index:f}],k[I.DI_TARGET]=k)}function s(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const k=function(f,u,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,f,p)};return k.toString=()=>R,I.serviceIds.set(R,k),k}e.createDecorator=s;function A(R){return R}e.refineServiceDecorator=A}),define(ee[63],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[19],te([0,1,11,8,6]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,s.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var k;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function u(r,g){const h=Object.create(null);for(const S in r)p(h,S,r[S],g);return h}e.toValuesTree=u;function p(r,g,h,S){const w=g.split("."),C=w.pop();let t=r;for(let l=0;l<w.length;l++){const i=w[l];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:S(`Ignoring ${g} as ${w.slice(0,l+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[C]=h}catch{S(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=p;function y(r,g){const h=g.split(".");b(r,h)}e.removeFromValueTree=y;function b(r,g){const h=g.shift();if(g.length===0){delete r[h];return}if(Object.keys(r).indexOf(h)!==-1){const S=r[h];typeof S=="object"&&!Array.isArray(S)&&(b(S,g),Object.keys(S).length===0&&delete r[h])}}function d(r,g,h){function S(t,l){let i=t;for(const n of l){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=g.split("."),C=S(r,w);return typeof C>"u"?h:C}e.getConfigurationValue=d;function E(r,g,h){Object.keys(g).forEach(S=>{S!=="__proto__"&&(S in r?I.isObject(r[S])&&I.isObject(g[S])?E(r[S],g[S],h):h&&(r[S]=g[S]):r[S]=g[S])})}e.merge=E;function v(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(ee[204],te([0,1,4,26,191,6,160,13]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",I.isMacintosh),f.set("isLinux",I.isLinux),f.set("isWindows",I.isWindows),f.set("isWeb",I.isWeb),f.set("isMacNative",I.isMacintosh&&!I.isWeb),f.set("isEdge",I.isEdge),f.set("isFirefox",I.isFirefox),f.set("isChrome",I.isChrome),f.set("isSafari",I.isSafari);function u(O,P){if(f.get(O)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(O,P)}e.setConstant=u;const p=Object.prototype.hasOwnProperty;var y;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));const b={regexParsingWithErrorRecovery:!0},d=(0,R.localize)(0,null),E=(0,R.localize)(1,null),v=(0,R.localize)(2,null),r=(0,R.localize)(3,null),g=(0,R.localize)(4,null),h=(0,R.localize)(5,null),S=(0,R.localize)(6,null),w=(0,R.localize)(7,null);class C{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new s.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const U=this.D(),j=U.type===17?h:void 0;throw this.h.push({message:g,offset:U.offset,lexeme:s.Scanner.getLexeme(U),additionalInfo:j}),C.c}return F}catch(F){if(F!==C.c)throw F;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const F=this.o();P.push(F)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const F=this.s();P.push(F)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,r),F?.negate()}case 17:return this.z(),N.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,r),F}case 17:{const F=P.lexeme;if(this.z(),this.y(9)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==10)throw this.B("REGEX",j);const B=j.lexeme,z=B.lastIndexOf("/"),G=z===B.length-1?void 0:this.w(B.substring(z+1));let re;try{re=new RegExp(B.substring(1,z),G)}catch{throw this.B("REGEX",j)}return de.create(F,re)}switch(j.type){case 10:case 19:{const B=[j.lexeme];this.z();let z=this.D(),G=0;for(let Le=0;Le<j.lexeme.length;Le++)j.lexeme.charCodeAt(Le)===40?G++:j.lexeme.charCodeAt(Le)===41&&G--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:G++;break;case 1:G--;break;case 10:case 18:for(let Le=0;Le<z.lexeme.length;Le++)z.lexeme.charCodeAt(Le)===40?G++:j.lexeme.charCodeAt(Le)===41&&G--}if(G<0)break;B.push(s.Scanner.getLexeme(z)),this.z(),z=this.D()}const re=B.join(""),he=re.lastIndexOf("/"),be=he===re.length-1?void 0:this.w(re.substring(he+1));let ke;try{ke=new RegExp(re.substring(1,he),be)}catch{throw this.B("REGEX",j)}return t.regex(F,ke)}case 18:{const B=j.lexeme;this.z();let z=null;if(!(0,L.isFalsyOrWhitespace)(B)){const G=B.indexOf("/"),re=B.lastIndexOf("/");if(G!==re&&G>=0){const he=B.slice(G+1,re),be=B[re+1]==="i"?"i":"";try{z=new RegExp(he,be)}catch{throw this.B("REGEX",j)}}}if(z===null)throw this.B("REGEX",j);return de.create(F,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const j=this.u();return t.notIn(F,j)}switch(this.D().type){case 3:{this.z();const j=this.u();if(this.x().type===18)return t.equals(F,j);switch(j){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,j)}}case 4:{this.z();const j=this.u();if(this.x().type===18)return t.notEquals(F,j);switch(j){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,j)}}case 5:return this.z(),oe.create(F,this.u());case 6:return this.z(),ae.create(F,this.u());case 7:return this.z(),q.create(F,this.u());case 8:return this.z(),ie.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:S,offset:P.offset,lexeme:"",additionalInfo:w}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,F){if(this.C(P))return this.z();throw this.B(F,this.D())}B(P,F,U){const j=(0,R.localize)(8,null,P,s.Scanner.getLexeme(F)),B=F.offset,z=s.Scanner.getLexeme(F);return this.h.push({message:j,offset:B,lexeme:z,additionalInfo:U}),C.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}C.c=new Error,e.Parser=C;class t{static false(){return a.INSTANCE}static true(){return c.INSTANCE}static has(P){return o.create(P)}static equals(P,F){return m.create(P,F)}static notEquals(P,F){return T.create(P,F)}static regex(P,F){return de.create(P,F)}static in(P,F){return D.create(P,F)}static notIn(P,F){return M.create(P,F)}static not(P){return N.create(P)}static and(...P){return J.create(P,null,!0)}static or(...P){return H.create(P,null,!0)}static greater(P,F){return q.create(P,F)}static greaterEquals(P,F){return ie.create(P,F)}static smaller(P,F){return oe.create(P,F)}static smallerEquals(P,F){return ae.create(P,F)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}t.c=new C({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function l(O){const P=new C({regexParsingWithErrorRecovery:!1});return O.map(F=>(P.parse(F),P.lexingErrors.length>0?P.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,R.localize)(9,null,U.additionalInfo):(0,R.localize)(10,null),offset:U.offset,length:U.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.validateWhenClauses=l;function i(O,P){const F=O?O.substituteConstants():void 0,U=P?P.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}e.expressionsAreEqualWithConstantSubstitution=i;function n(O,P){return O.cmp(P)}class a{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return c.INSTANCE}}a.INSTANCE=new a,e.ContextKeyFalseExpr=a;class c{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return a.INSTANCE}}c.INSTANCE=new c,e.ContextKeyTrueExpr=c;class o{static create(P,F=null){const U=f.get(P);return typeof U=="boolean"?U?c.INSTANCE:a.INSTANCE:new o(P,F)}constructor(P,F){this.key=P,this.c=F,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:V(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=f.get(this.key);return typeof P=="boolean"?P?c.INSTANCE:a.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=o;class m{static create(P,F,U=null){if(typeof F=="boolean")return F?o.create(P,U):N.create(P,U);const j=f.get(P);return typeof j=="boolean"?F===(j?"true":"false")?c.INSTANCE:a.INSTANCE:new m(P,F,U)}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=f.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?c.INSTANCE:a.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class D{static create(P,F){return new D(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.f),U=P.getValue(this.d);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?p.call(F,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=M.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=D;class M{static create(P,F){return new M(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=11,this.c=D.create(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=M;class T{static create(P,F,U=null){if(typeof F=="boolean")return F?N.create(P,U):o.create(P,U);const j=f.get(P);return typeof j=="boolean"?F===(j?"true":"false")?a.INSTANCE:c.INSTANCE:new T(P,F,U)}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=f.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?a.INSTANCE:c.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=T;class N{static create(P,F=null){const U=f.get(P);return typeof U=="boolean"?U?a.INSTANCE:c.INSTANCE:new N(P,F)}constructor(P,F){this.c=P,this.d=F,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=f.get(this.c);return typeof P=="boolean"?P?a.INSTANCE:c.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.ContextKeyNotExpr=N;function $(O,P){if(typeof O=="string"){const F=parseFloat(O);isNaN(F)||(O=F)}return typeof O=="string"||typeof O=="number"?P(O):a.INSTANCE}class q{static create(P,F,U=null){return $(F,j=>new q(P,j,U))}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=q;class ie{static create(P,F,U=null){return $(F,j=>new ie(P,j,U))}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=ie;class oe{static create(P,F,U=null){return $(F,j=>new oe(P,j,U))}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=oe;class ae{static create(P,F,U=null){return $(F,j=>new ae(P,j,U))}constructor(P,F,U){this.c=P,this.d=F,this.f=U,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:Y(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ae;class de{static create(P,F){return new de(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const F=this.f?this.f.source:"",U=P.f?P.f.source:"";return F<U?-1:F>U?1:0}equals(P){if(P.type===this.type){const F=this.f?this.f.source:"",U=P.f?P.f.source:"";return this.d===P.d&&F===U}return!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.ContextKeyRegexExpr=de;class ce{static create(P){return new ce(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new ce(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ce;function X(O){let P=null;for(let F=0,U=O.length;F<U;F++){const j=O[F].substituteConstants();if(O[F]!==j&&P===null){P=[];for(let B=0;B<F;B++)P[B]=O[B]}P!==null&&(P[F]=j)}return P===null?O:P}class J{static create(P,F,U){return J.d(P,F,U)}constructor(P,F){this.expr=P,this.c=F,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const j=n(this.expr[F],P.expr[F]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=X(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(P))return!1;return!0}static d(P,F,U){const j=[];let B=!1;for(const z of P)if(!!z){if(z.type===1){B=!0;continue}if(z.type===0)return a.INSTANCE;if(z.type===6){j.push(...z.expr);continue}j.push(z)}if(j.length===0&&B)return c.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(n);for(let z=1;z<j.length;z++)j[z-1].equals(j[z])&&(j.splice(z,1),z--);if(j.length===1)return j[0];for(;j.length>1;){const z=j[j.length-1];if(z.type!==9)break;j.pop();const G=j.pop(),re=j.length===0,he=H.create(z.expr.map(be=>J.create([be,G],null,U)),null,re);he&&(j.push(he),j.sort(n))}if(j.length===1)return j[0];if(U){for(let z=0;z<j.length;z++)for(let G=z+1;G<j.length;G++)if(j[z].negate().equals(j[G]))return a.INSTANCE;if(j.length===1)return j[0]}return new J(j,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new J(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());this.c=H.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=J;class H{static create(P,F,U){return H.d(P,F,U)}constructor(P,F){this.expr=P,this.c=F,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const j=n(this.expr[F],P.expr[F]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=X(this.expr);return P===this.expr?this:H.create(P,this.c,!1)}evaluate(P){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(P))return!0;return!1}static d(P,F,U){let j=[],B=!1;if(P){for(let z=0,G=P.length;z<G;z++){const re=P[z];if(!!re){if(re.type===0){B=!0;continue}if(re.type===1)return c.INSTANCE;if(re.type===9){j=j.concat(re.expr);continue}j.push(re)}}if(j.length===0&&B)return a.INSTANCE;j.sort(n)}if(j.length!==0){if(j.length===1)return j[0];for(let z=1;z<j.length;z++)j[z-1].equals(j[z])&&(j.splice(z,1),z--);if(j.length===1)return j[0];if(U){for(let z=0;z<j.length;z++)for(let G=z+1;G<j.length;G++)if(j[z].negate().equals(j[G]))return c.INSTANCE;if(j.length===1)return j[0]}return new H(j,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new H(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());for(;P.length>1;){const F=P.shift(),U=P.shift(),j=[];for(const B of _(F))for(const z of _(U))j.push(J.create([B,z],null,!1));P.unshift(H.create(j,null,!1))}this.c=H.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=H;class W extends o{static all(){return W.d.values()}constructor(P,F,U){super(P,null),this.f=F,typeof U=="object"?W.d.push({...U,key:P}):U!==!0&&W.d.push({key:P,description:U,type:F!=null?typeof F:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return m.create(this.key,P)}notEqualsTo(P){return T.create(this.key,P)}}W.d=[],e.RawContextKey=W,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function V(O,P){return O<P?-1:O>P?1:0}function Y(O,P,F,U){return O<F?-1:O>F?1:P<U?-1:P>U?1:0}function ne(O,P){if(O.type===0||P.type===1)return!0;if(O.type===9)return P.type===9?se(O.expr,P.expr):!1;if(P.type===9){for(const F of P.expr)if(ne(O,F))return!0;return!1}if(O.type===6){if(P.type===6)return se(P.expr,O.expr);for(const F of O.expr)if(ne(F,P))return!0;return!1}return O.equals(P)}e.implies=ne;function se(O,P){let F=0,U=0;for(;F<O.length&&U<P.length;){const j=O[F].cmp(P[U]);if(j<0)return!1;j===0&&F++,U++}return F===O.length}function _(O){return O.type===9?O.expr:[O]}}),define(ee[77],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,R){return this.a[A]?.[R]??null}async setPassword(A,R,k){this.a[A]=this.a[A]??{},this.a[A][R]=k}async deletePassword(A,R){return this.a[A]?.[R]?(delete this.a[A][R],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const R=[];for(const k of Object.keys(this.a[A]||{}))R.push({account:k,password:this.a[A][k]});return R}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(ee[89],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class s{async getPerformanceInfo(R,k){return{}}async getSystemInfo(R,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,k){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=s}),define(ee[90],te([0,1,18,75,162,6,45,4,37]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var u;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(u||(u={}));class p{a(r){return this.d(r,u.Confirmation)}b(r){return this.d(r,u.Prompt)}c(r){return this.d(r,u.Input)}d(r,g){const h=[];switch(g){case u.Confirmation:{const S=r;S.primaryButton?h.push(S.primaryButton):h.push((0,s.localize)(0,null)),S.cancelButton?h.push(S.cancelButton):h.push((0,s.localize)(1,null));break}case u.Prompt:{const S=r;Array.isArray(S.buttons)&&S.buttons.length>0&&h.push(...S.buttons.map(w=>w.label)),S.cancelButton&&(S.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof S.cancelButton=="string"?h.push(S.cancelButton):S.cancelButton.label?h.push(S.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case u.Input:{const S=r;S.primaryButton?h.push(S.primaryButton):h.push((0,s.localize)(5,null)),S.cancelButton?h.push(S.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===L.default.Info?"info":r===L.default.Error?"error":r===L.default.Warning?"warning":"none"}async f(r,g,h){const S=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&S.push(r.cancelButton),{result:await S[g]?.run({checkboxChecked:h}),checkboxChecked:h}}}e.AbstractDialogHandler=p,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y=e.ConfirmResult||(e.ConfirmResult={}));const b=10;function d(v){const r=[];return r.push(...v.slice(0,b).map(g=>typeof g=="string"?g:(0,I.basename)(g))),v.length>b&&(v.length-b===1?r.push((0,s.localize)(7,null)):r.push((0,s.localize)(8,null,v.length-b))),r.push(""),r.join(`
`)}e.getFileNamesMessage=d;function E(v,r){const g=(0,f.deepClone)(v);let h=(g.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),S=(v.buttons||[]).map((t,l)=>l),w=0,C=g.cancelId??h.length-1;if(h.length>1){const t=typeof C=="number"?h[C]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&h.length>1&&C!==1){h.splice(C,1),h.splice(1,0,t);const l=S[C];S.splice(C,1),S.splice(1,0,l),C=1}k.isLinux&&h.length>1&&(h=h.reverse(),S=S.reverse(),w=h.length-1,typeof t=="string"&&(C=w-1))}else if(k.isWindows&&typeof t=="string"&&h.length>1&&C!==h.length-1){h.splice(C,1),h.push(t);const l=S[C];S.splice(C,1),S.push(l),C=h.length-1}}return g.buttons=h,g.defaultId=w,g.cancelId=C,g.noLink=!0,g.title=g.title||r.nameLong,{options:g,buttonIndeces:S}}e.massageMessageBoxOptions=E}),define(ee[110],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,88,34,109,6]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(A.IEnvironmentService);class f extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,s.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ye([I.memoize],f.prototype,"cachedLanguagesPath",null),ye([I.memoize],f.prototype,"backupHome",null),ye([I.memoize],f.prototype,"mainIPCHandle",null),ye([I.memoize],f.prototype,"mainLockfile",null),ye([I.memoize],f.prototype,"disableUpdates",null),ye([I.memoize],f.prototype,"disableKeytar",null),ye([I.memoize],f.prototype,"crossOriginIsolated",null),ye([I.memoize],f.prototype,"codeCachePath",null),ye([I.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[111],te([0,1,166,6]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=s;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(h,S){switch(h){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function k(h,S){return S==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function f(h,S,w){return k(S,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:u(w).includes(h)}e.isTargetPlatformCompatible=f;function u(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function p(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=p;var y;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var b;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var E;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var v;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var r;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class g extends Error{constructor(S,w){super(S),this.code=w,this.name=w}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ee[205],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[206],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[112],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[207],te([0,1,46,15,9,4,73,24,87,170,112]),function(x,e,I,L,s,A,R,k,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=u.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends b{openTerminal(w,C){return this.spawnTerminal(I,w,f.getWindowsShell(),C)}spawnTerminal(w,C,t,l){const i=C.windowsExec||d.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=s.basename(i,".exe").toLowerCase();if(n==="cmder")return w.spawn(i,l?[l]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((c,o)=>{const m=r(process),D=w.spawn(t,a,{cwd:l,env:m});D.on("error",o),D.on("exit",()=>c())})}runInTerminal(w,C,t,l,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows();return new Promise((a,c)=>{const o=`"${C} - ${y}"`,m=`""${t.join('" "')}" & pause"`,D=Object.assign({},r(process),l);Object.keys(D).filter(q=>D[q]===null).forEach(q=>delete D[q]);const M={cwd:C,env:D,windowsVerbatimArguments:!0};let T,N;s.basename(n,".exe")==="wt"?(T=n,N=["-d",".",d.b,"/c",m]):(T=d.b,N=["/c","start",o,"/wait",n,"/c",m]),I.spawn(T,N,M).on("error",q=>{c(g(q))}),a(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const w=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${w?"Sysnative":"System32"}\\cmd.exe`}return d.d}}d.b="cmd.exe",e.WindowsExternalTerminalService=d;class E extends b{openTerminal(w,C){return this.spawnTerminal(I,w,C)}runInTerminal(w,C,t,l,i){const n=i.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((a,c)=>{if(n===p.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const o=n===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",w||y,"-w",C];for(const N of t)D.push("-a"),D.push(N);if(l){const N=Object.assign({},r(process),l);for(const $ in N){const q=N[$];q===null?(D.push("-u"),D.push($)):(D.push("-e"),D.push(`${$}=${q}`))}}let M="";const T=I.spawn(E.b,D);T.on("error",N=>{c(g(N))}),T.stderr.on("data",N=>{M+=N.toString()}),T.on("exit",N=>{if(N===0)a(void 0);else if(M){const $=M.split(`
`,1);c(new Error($[0]))}else c(new Error(u.localize(1,null,o,N)))})}else c(new Error(u.localize(2,null,n)))})}spawnTerminal(w,C,t){const l=C.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const a=["-a",l];t&&a.push(t);const c=r(process),o=w.spawn("/usr/bin/open",a,{cwd:t,env:c});o.on("error",n),o.on("exit",()=>i())})}}E.b="/usr/bin/osascript",e.MacExternalTerminalService=E;class v extends b{openTerminal(w,C){return this.spawnTerminal(I,w,C)}runInTerminal(w,C,t,l,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,c)=>{const o=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${h(t)}; echo; read -p "${v.b}" -n1;`;o.push(`''${D}''`);const M=Object.assign({},r(process),l);Object.keys(M).filter(q=>M[q]===null).forEach(q=>delete M[q]);const T={cwd:C,env:M};let N="";const $=I.spawn(m,o,T);$.on("error",q=>{c(g(q))}),$.stderr.on("data",q=>{N+=q.toString()}),$.on("exit",q=>{if(q===0)a(void 0);else if(N){const ie=N.split(`
`,1);c(new Error(ie[0]))}else c(new Error(u.localize(4,null,m,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!A.isLinux)v.d=Promise.resolve("xterm");else{const w=await k.Promises.exists("/etc/debian_version");v.d=new Promise(C=>{w?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return v.d}spawnTerminal(w,C,t){const l=C.linuxExec?Promise.resolve(C.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{l.then(a=>{const c=r(process),o=w.spawn(a,[],{cwd:t,env:c});o.on("error",n),o.on("exit",()=>i())})})}}v.b=u.localize(3,null),e.LinuxExternalTerminalService=v;function r(S){const w={...S.env};return(0,R.sanitizeProcessEnvironment)(w),w}function g(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(u.localize(5,null,S.path)):S}function h(S){let w="";for(const C of S)C.indexOf(" ")>=0?w+='"'+C+'"':w+=C,w+=" ";return w}}),define(ee[16],te([0,1,61,9,26,11,8,172,6,4,15]),function(x,e,I,L,s,A,R,k,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function y(W){return W.create===!0}e.isFileOpenForWriteOptions=y;var b;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var d;(function(W){W[W.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var E;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=v;function r(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=r;function g(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=g;function h(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=S;function w(W){return v(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var C;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(V,Y){const ne=new t(V.toString(),Y);return n(ne,Y),ne}constructor(V,Y){super(V),this.code=Y}}e.FileSystemProviderError=t;function l(W,V){return t.create(W,V)}e.createFileSystemProviderError=l;function i(W){return W||l((0,k.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(W,V){return W.name=V?`${V} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=n;function a(W){if(!W)return C.Unknown;if(W instanceof t)return W.code;const V=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!V)return C.Unknown;switch(V[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=a;function c(W){if(W instanceof N)return W.fileOperationResult;switch(a(W)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class m{constructor(V,Y,ne){this.resource=V,this.operation=Y,this.target=ne}isOperation(V){return this.operation===V}}e.FileOperationEvent=m;var D;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(D=e.FileChangeType||(e.FileChangeType={}));class M{constructor(V,Y){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const se of V){const _=ne.get(se.type);switch(_?_.push([se.resource,se]):ne.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,_]of ne)switch(se){case 1:this.a=I.TernarySearchTree.forUris(()=>Y),this.a.fill(_);break;case 0:this.b=I.TernarySearchTree.forUris(()=>Y),this.b.fill(_);break;case 2:this.c=I.TernarySearchTree.forUris(()=>Y),this.c.fill(_);break}}contains(V,...Y){return this.d(V,{includeChildren:!1},...Y)}affects(V,...Y){return this.d(V,{includeChildren:!0},...Y)}d(V,Y,...ne){if(!V)return!1;const se=ne.length>0;return!!((!se||ne.includes(1))&&(this.a?.get(V)||Y.includeChildren&&this.a?.findSuperstr(V))||(!se||ne.includes(0))&&(this.b?.get(V)||Y.includeChildren&&this.b?.findSuperstr(V))||(!se||ne.includes(2))&&(this.c?.findSubstr(V)||Y.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=M;function T(W,V,Y){return!W||!V||W===V||V.length>W.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),Y?(0,s.startsWithIgnoreCase)(W,V):W.indexOf(V)===0)}e.isParent=T;class N extends Error{constructor(V,Y,ne){super(V),this.fileOperationResult=Y,this.options=ne}}e.FileOperationError=N;class $ extends N{constructor(V,Y,ne,se){super(V,Y,se),this.fileOperationResult=Y,this.size=ne}}e.TooLargeFileOperationError=$;class q extends N{constructor(V,Y,ne){super(V,2,ne),this.stat=Y}}e.NotModifiedSinceFileOperationError=q;var ie;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var oe;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=ae;async function de(W,V){if(!V.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(Y=>{const ne=V.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===W.scheme&&se.added&&(ne.dispose(),Y())})})}e.whenProviderRegistered=de,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<ce.KB?(0,k.localize)(1,null,V.toFixed(0)):V<ce.MB?(0,k.localize)(2,null,(V/ce.KB).toFixed(2)):V<ce.GB?(0,k.localize)(3,null,(V/ce.MB).toFixed(2)):V<ce.TB?(0,k.localize)(4,null,(V/ce.GB).toFixed(2)):(0,k.localize)(5,null,(V/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var X;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function J(W){return{maxFileSize:W===0?300*ce.MB:16*ce.GB,maxHeapSize:W===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=J;function H(W){const V=typeof W=="string"||W?.scheme===p.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===p.Schemas.file?1024*ce.MB:V?10*ce.MB:u.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=H}),define(ee[208],te([0,1,17,44,13,3,2,60,8,31,16]),function(x,e,I,L,s,A,R,k,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends R.Disposable{constructor(d,E){super(),this.a=d,this.b=E,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,u.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,E){const{buffer:v}=await this.a.call("readFile",[d,E]);return v}readFileStream(d,E,v){const r=(0,k.newWriteableStream)(h=>I.VSBuffer.concat(h.map(S=>I.VSBuffer.wrap(S))).buffer),g=this.a.listen("readFileStream",[d,E])(h=>{if(h instanceof I.VSBuffer)r.write(h.buffer);else{if(h==="end")r.end();else{let S;if(h instanceof Error)S=h;else{const w=h;S=(0,p.createFileSystemProviderError)(w.message??(0,L.toErrorMessage)(w),w.code??p.FileSystemProviderErrorCode.Unknown)}r.error(S),r.end()}g.dispose()}});return v.onCancellationRequested(()=>{r.error((0,s.canceled)()),r.end(),g.dispose()}),r}writeFile(d,E,v){return this.a.call("writeFile",[d,I.VSBuffer.wrap(E),v])}open(d,E){return this.a.call("open",[d,E])}close(d){return this.a.call("close",[d])}async read(d,E,v,r,g){const[h,S]=await this.a.call("read",[d,E,g]);return v.set(h.buffer.slice(0,S),r),S}write(d,E,v,r,g){return this.a.call("write",[d,E,I.VSBuffer.wrap(v),r,g])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,E){return this.a.call("delete",[d,E])}rename(d,E,v){return this.a.call("rename",[d,E,v])}copy(d,E,v){return this.a.call("copy",[d,E,v])}cloneFile(d,E){return this.a.call("cloneFile",[d,E])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const E=d;this.f.fire(E.map(v=>({resource:f.URI.revive(v.resource),type:v.type})))}else{const E=d;this.g.fire(E)}}))}watch(d,E){const v=(0,u.generateUuid)();return this.a.call("watch",[this.h,v,d,E]),(0,R.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=y}),define(ee[113],te([0,1,17,13,173,16]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(p,y,b,d,E,v){let r;try{await k(p,y,b,d,E,v)}catch(g){r=g}finally{r&&E.errorTransformer&&(r=E.errorTransformer(r)),typeof r<"u"&&b.error(r),b.end()}}e.readFileIntoStream=R;async function k(p,y,b,d,E,v){f(v);const r=await p.open(y,{create:!1});try{f(v);let g=0,h=0,S=E&&typeof E.length=="number"?E.length:void 0,w=I.VSBuffer.alloc(Math.min(E.bufferSize,typeof S=="number"?S:E.bufferSize)),C=E&&typeof E.position=="number"?E.position:0,t=0;do h=await p.read(r,C,w.buffer,t,w.byteLength-t),C+=h,t+=h,g+=h,typeof S=="number"&&(S-=h),t===w.byteLength&&(await b.write(d(w)),w=I.VSBuffer.alloc(Math.min(E.bufferSize,typeof S=="number"?S:E.bufferSize)),t=0);while(h>0&&(typeof S!="number"||S>0)&&f(v)&&u(g,E));if(t>0){let l=t;typeof S=="number"&&(l=Math.min(t,S)),b.write(d(w.slice(0,l)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await p.close(r)}}function f(p){if(p.isCancellationRequested)throw(0,L.canceled)();return!0}function u(p,y){if(y?.limits){if(typeof y.limits.memory=="number"&&p>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,s.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&p>y.limits.size)throw(0,A.createFileSystemProviderError)((0,s.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[78],te([0,1,102,2,9,4,8,16]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(g){return g.recursive===!0}e.isRecursiveWatchRequest=f;class u extends L.Disposable{constructor(h,S,w,C){super(),this.h=h,this.i=S,this.j=w,this.k=C,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const h=new L.DisposableStore;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(S=>this.h(S))),h.add(this.b.onDidLogMessage(S=>this.i(S))),h.add(this.b.onDidError(S=>this.n(S)))}n(h){this.k.restartOnError?this.g<u.a&&this.f?(this.r(`restarting watcher after error: ${h}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${h}`):this.r(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}r(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}s(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}u.a=5,e.AbstractWatcherClient=u;class p extends u{constructor(h,S,w){super(h,S,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class y extends u{constructor(h,S,w){super(h,S,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function b(g){return g.map(h=>({type:h.type,resource:R.URI.file(h.path)}))}e.toFileChanges=b;function d(g){const h=new r;for(const S of g)h.processEvent(S);return h.coalesce()}e.coalesceEvents=d;function E(g,h){return typeof h=="string"&&!h.startsWith(I.GLOBSTAR)&&!(0,s.isAbsolute)(h)?{base:g,pattern:h}:h}e.normalizeWatcherPattern=E;function v(g,h){const S=[];for(const w of h)S.push((0,I.parse)(E(g,w)));return S}e.parseWatcherPatterns=v;class r{constructor(){this.a=new Set,this.b=new Map}c(h){return A.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const S=this.b.get(this.c(h));let w=!1;if(S){const C=S.type,t=h.type;S.path!==h.path&&(h.type===2||h.type===1)?w=!0:C===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(S)):C===2&&t===1?S.type=0:C===1&&t===0||(S.type=t)}else w=!0;w&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],S=[];return Array.from(this.a).filter(w=>w.type!==2?(h.push(w),!1):!0).sort((w,C)=>w.path.length-C.path.length).filter(w=>S.some(C=>(0,k.isParent)(w.path,C,!A.isLinux))?!1:(S.push(w.path),!0)).concat(h)}}}),define(ee[209],te([0,1,41,7,23,32,2,82,9,4,103,24,78]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends R.Disposable{constructor(r,g,h,S){super(),this.j=r,this.k=g,this.l=h,this.m=S,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new L.RunOnceWorker(w=>this.u(w),d.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new s.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await y.Promises.stat(r);this.B(await this.s(r,g.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let g=r.path;try{g=await y.Promises.realpath(r.path),r.path===g&&(g=await(0,p.realcase)(r.path)??r.path),r.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${g})`)}catch{}return g}async s(r,g){if(u.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const h=new s.CancellationTokenSource(this.i.token),S=new R.DisposableStore;try{const w=(0,f.basename)(r),C=(0,I.watch)(r);S.add((0,R.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(g)try{for(const i of await y.Promises.readdir(r))t.add(i)}catch(i){this.w(i)}const l=new Map;S.add((0,R.toDisposable)(()=>{for(const[,i]of l)i.dispose();l.clear()})),C.on("error",(i,n)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),C.on("change",(i,n)=>{if(h.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let a="";if(n&&(a=n.toString(),u.isMacintosh&&(a=(0,k.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){l.get(a)?.dispose();const c=setTimeout(async()=>{if(l.delete(a),a===w&&!await y.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,f.join)(r,a));if(h.token.isCancellationRequested)return;let m;o?t.has(a)?m=0:(m=1,t.add(a)):(t.delete(a),m=2),this.t({path:(0,f.join)(this.j.path,a),type:m})},d.a);l.set(a,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(a)?c=0:(c=1,t.add(a)),this.t({path:(0,f.join)(this.j.path,a),type:c})}else if(i==="rename"||a!==w){const c=setTimeout(async()=>{const o=await y.Promises.exists(r);h.token.isCancellationRequested||(o?(this.t({path:this.j.path,type:0},!0),S.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await y.Promises.exists(r)&&!h.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${w.toString()})`)}return(0,R.toDisposable)(()=>{h.dispose(!0),S.dispose()})}t(r,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!g&&this.g.some(h=>h(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(h=>h(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const g=(0,b.coalesceEvents)(r);if(g.length>0){if(this.m)for(const S of g)this.z(`>> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(u.isLinux)return y.Promises.exists(r);try{const g=(0,f.basename)(r);return(await y.Promises.readdir((0,f.dirname)(r))).some(S=>S===g)}catch(g){return this.z(g),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function E(v,r,g,h,S=512){const w=await y.Promises.open(v,"r"),C=Buffer.allocUnsafe(S),t=new s.CancellationTokenSource(h);let l,i=!1;const n={path:v,excludes:[],recursive:!1},a=new d(n,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:m}=await y.Promises.read(w,C,0,S,null);if(!m||t.token.isCancellationRequested)break;r(C.slice(0,m))}}catch(m){l=new Error(m),t.dispose(!0)}finally{i=!1}}})()});return await a.ready,g(),new Promise((c,o)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(w)}catch(m){l=new Error(m)}l?o(l):c()})})}e.watchFileContents=E}),define(ee[210],te([0,1,3,102,2,4,209]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends s.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(u){const p=this.i(u),y=p.filter(d=>{const E=this.c.get(d.path);return E?!(0,L.patternsEquals)(E.request.excludes,d.excludes)||!(0,L.patternsEquals)(E.request.includes,d.includes):!0}),b=Array.from(this.c.values()).filter(({request:d})=>!p.find(E=>E.path===d.path&&(0,L.patternsEquals)(E.excludes,d.excludes)&&(0,L.patternsEquals)(E.includes,d.includes))).map(({request:d})=>d.path);y.length&&this.j(`Request to start watching: ${y.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const d of b)this.h(d);for(const d of y)this.g(d)}g(u){const p=new R.NodeJSFileWatcherLibrary(u,b=>this.a.fire(b),b=>this.b.fire(b),this.f),y={request:u,instance:p};this.c.set(u.path,y)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const p=this.c.get(u);p&&(this.c.delete(u),p.instance.dispose())}i(u){const p=new Map;for(const y of u){const b=A.isLinux?y.path:y.path.toLowerCase();p.set(b,y)}return Array.from(p.values())}async setVerboseLogging(u){this.f=u;for(const[,p]of this.c)p.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,p){return p?`[File Watcher (node.js)] ${u} (path: ${p.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=k}),define(ee[211],te([0,1,78,210]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class s extends I.AbstractNonRecursiveWatcherClient{constructor(R,k,f){super(R,k,f),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=s}),define(ee[212],te([0,1,15,47,156,78]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(f,u,p){super(f,u,p),this.m()}l(f){const u=f.add(new s.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:p,signal:y})=>this.n(`terminated by itself with code ${p}, signal: ${y}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ee[91],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...s){this.a=new Map;for(const[A,R]of s)this.set(A,R)}set(s,A){const R=this.a.get(s);return this.a.set(s,A),R}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.ServiceCollection=I}),define(ee[213],te([0,1,7,13,2,76,203,6,91,100]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class y extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class b{constructor(r=new f.ServiceCollection,g=!1,h,S=p){this.f=r,this.g=g,this.h=h,this.i=S,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=S?h?._globalGraph??new R.Graph(w=>w):void 0}createChild(r){return new b(r,this.g,this,this.i)}invokeFunction(r,...g){const h=E.traceInvocation(this.i,r);let S=!1;try{return r({get:C=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(C,h);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...g)}finally{S=!0,h.stop()}}createInstance(r,...g){let h,S;return r instanceof A.SyncDescriptor?(h=E.traceCreation(this.i,r.ctor),S=this.j(r.ctor,r.staticArguments.concat(g),h)):(h=E.traceCreation(this.i,r),S=this.j(r,g,h)),h.stop(),S}j(r,g=[],h){const S=k._util.getServiceDependencies(r).sort((t,l)=>t.index-l.index),w=[];for(const t of S){const l=this.m(t.id,h);l||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(l)}const C=S.length>0?S[0].index:g.length;if(g.length!==C){console.trace(`[createInstance] First service dependency of ${r.name} at position ${C+1} conflicts with ${g.length} static arguments`);const t=C-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,C)}return Reflect.construct(r,g.concat(w))}k(r,g){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,g);else if(this.h)this.h.k(r,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const g=this.f.get(r);return!g&&this.h?this.h.l(r):g}m(r,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const h=this.l(r);return h instanceof A.SyncDescriptor?this.q(r,h,g.branch(r,!0)):(g.branch(r,!1),h)}q(r,g,h){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,g,h)}finally{this.o.delete(r)}}r(r,g,h){const S=new R.Graph(t=>t.id.toString());let w=0;const C=[{id:r,desc:g,_trace:h}];for(;C.length;){const t=C.pop();if(S.lookupOrInsertNode(t),w++>1e3)throw new y(S);for(const l of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(l.id);if(i||this.u(`[createInstance] ${r} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),i instanceof A.SyncDescriptor){const n={id:l.id,desc:i,_trace:t._trace.branch(l.id,!0)};S.insertEdge(t,n),C.push(n)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new y(S);break}for(const{data:l}of t){if(this.l(l.id)instanceof A.SyncDescriptor){const n=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,n)}S.removeNode(l)}}return this.l(r)}s(r,g,h=[],S,w){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,g,h,S,w);if(this.h)return this.h.s(r,g,h,S,w);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(r,g,h=[],S,w){if(S){const C=new b(void 0,this.g,this,this.i);C.c=String(r);const t=new Map,l=new I.IdleValue(()=>{const i=C.j(g,h,w);for(const[n,a]of t){const c=i[n];if(typeof c=="function")for(const o of a)c.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!l.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new u.LinkedList,t.set(n,o)),(D,M,T)=>{const N=o.push([D,M,T]);return(0,s.toDisposable)(N)}}if(n in i)return i[n];const a=l.value;let c=a[n];return typeof c!="function"||(c=c.bind(a),i[n]=c),c},set(i,n,a){return l.value[n]=a,!0},getPrototypeOf(i){return g.prototype}})}else return this.j(g,h,w)}u(r,g){if(g&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=b;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class E{static traceInvocation(r,g){return r?new E(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(r,g){return r?new E(1,g.name):E.c}constructor(r,g){this.type=r,this.name=g,this.g=Date.now(),this.h=[]}branch(r,g){const h=new E(3,r.toString());return this.h.push([r,g,h]),h}stop(){const r=Date.now()-this.g;E.f+=r;let g=!1;function h(w,C){const t=[],l=new Array(w+1).join("	");for(const[i,n,a]of C.h)if(n&&a){g=!0,t.push(`${l}CREATES -> ${i}`);const c=h(w+1,a);c&&t.push(c)}else t.push(`${l}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(r>2||g)&&E.all.add(S.join(`
`))}}E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0,e.Trace=E}),define(ee[5],te([0,1,44,3,56,2,35,4,18,11,8,204,6]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function d(){return new Date().toISOString()}function E(D){return(0,u.isNumber)(D)}e.isLogLevel=E;var v;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function r(D,M,T){switch(M){case v.Trace:D.trace(T);break;case v.Debug:D.debug(T);break;case v.Info:D.info(T);break;case v.Warning:D.warn(T);break;case v.Error:D.error(T);break;case v.Off:break;default:throw new Error(`Invalid log level ${M}`)}}e.log=r;function g(D,M=!1){let T="";for(let N=0;N<D.length;N++){let $=D[N];if($ instanceof Error&&($=(0,I.toErrorMessage)($,M)),typeof $=="object")try{$=JSON.stringify($)}catch{}T+=(N>0?" ":"")+$}return T}class h extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==v.Off&&this.b<=M}}e.AbstractLogger=h;class S extends h{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...T){this.f(v.Trace)&&this.g(v.Trace,g([M,...T],!0))}debug(M,...T){this.f(v.Debug)&&this.g(v.Debug,g([M,...T]))}info(M,...T){this.f(v.Info)&&this.g(v.Info,g([M,...T]))}warn(M,...T){this.f(v.Warning)&&this.g(v.Warning,g([M,...T]))}error(M,...T){if(this.f(v.Error))if(M instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=M.stack,this.g(v.Error,g(N))}else this.g(v.Error,g([M,...T]))}flush(){}}e.AbstractMessageLogger=S;class w extends h{constructor(M=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(M),this.g=!k.isWindows}trace(M,...T){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}debug(M,...T){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}info(M,...T){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}warn(M,...T){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,M,...T):console.warn(`[main ${d()}]`,M,...T))}error(M,...T){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,M,...T):console.error(`[main ${d()}]`,M,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class C extends h{constructor(M=e.DEFAULT_LOG_LEVEL,T=!0){super(),this.g=T,this.setLevel(M)}trace(M,...T){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...T):console.log(M,...T))}debug(M,...T){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...T):console.log(M,...T))}info(M,...T){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...T):console.log(M,...T))}warn(M,...T){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...T):console.log(M,...T))}error(M,...T){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...T):console.error(M,...T))}dispose(){}flush(){}}e.ConsoleLogger=C;class t extends h{constructor(M,T=e.DEFAULT_LOG_LEVEL){super(),this.g=M,this.setLevel(T)}trace(M,...T){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(M),...T])}debug(M,...T){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(M),...T])}info(M,...T){this.f(v.Info)&&this.g.log(v.Info,[this.h(M),...T])}warn(M,...T){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(M),...T])}error(M,...T){this.f(v.Error)&&this.g.log(v.Error,[this.h(M),...T])}h(M){return typeof M=="string"?M:(0,I.toErrorMessage)(M,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class l extends h{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const T of this.g)T.setLevel(M);super.setLevel(M)}trace(M,...T){for(const N of this.g)N.trace(M,...T)}debug(M,...T){for(const N of this.g)N.debug(M,...T)}info(M,...T){for(const N of this.g)N.info(M,...T)}warn(M,...T){for(const N of this.g)N.warn(M,...T)}error(M,...T){for(const N of this.g)N.error(M,...T)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose()}}e.MultiplexLogger=l;class i extends A.Disposable{constructor(M,T,N){if(super(),this.h=M,this.j=T,this.b=new R.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,N)for(const $ of N)this.b.set($.resource,{logger:void 0,info:$})}k(M){return(0,u.isString)(M)?[...this.b.values()].find(T=>T.info.id===M):this.b.get(M)}getLogger(M){return this.k(M)?.logger}createLogger(M,T){const N=this.l(M),$=(0,u.isString)(M)?M:T?.id??(0,s.hash)(N.toString()).toString(16);let q=this.b.get(N)?.logger;const ie=T?.logLevel==="always"?v.Trace:T?.logLevel;q||(q=this.m(N,ie??this.getLogLevel(N)??this.h,{...T,id:$}));const oe={logger:q,info:{resource:N,id:$,logLevel:ie,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(oe.info),this.b.set(N,oe),q}l(M){return(0,u.isString)(M)?(0,f.joinPath)(this.j,`${M}.log`):M}setLogLevel(M,T){if(p.URI.isUri(M)){const N=M,$=T,q=this.b.get(N);q&&$!==q.info.logLevel&&(q.info.logLevel=$===this.h?void 0:$,q.logger?.setLevel($),this.b.set(q.info.resource,q),this.f.fire([N,$]))}else{this.h=M;for(const[N,$]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&$.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,T){const N=this.k(M);N&&T!==!N.info.hidden&&(N.info.hidden=!T,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,T]))}getLogLevel(M){let T;return M&&(T=this.b.get(M)?.info.logLevel),T??this.h}registerLogger(M){const T=this.b.get(M.resource);T?T.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const T=this.b.get(M);T&&(T.logger&&T.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(M){}getLevel(){return v.Info}trace(M,...T){}debug(M,...T){}info(M,...T){}warn(M,...T){}error(M,...T){}critical(M,...T){}dispose(){}flush(){}}e.NullLogger=n;class a extends n{}e.NullLogService=a;function c(D){if(D.verbose)return v.Trace;if(typeof D.logLevel=="string"){const M=m(D.logLevel.toLowerCase());if(M!==void 0)return M}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function o(D){switch(D){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=o;function m(D){switch(D){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",o(v.Info))});var Q=this&&this.__param||function(x,e){return function(I,L){e(I,L,x)}};define(ee[214],te([0,1,77,3,2,5,4,7]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class ht extends s.Disposable{constructor(p){super(),this.h=p,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new k.SequencerByKey}async getPassword(p,y){this.h.trace("Getting password from keytar:",p,y);let b;try{b=await this.i()}catch{return null}return await this.g.queue(p+y,()=>this.k(b,p,y))}async k(p,y,b){const d=await(0,k.retry)(()=>p.getPassword(y,b),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",b),d;let E,v;try{const r=JSON.parse(d);E=r.content,v=r.hasNextChunk}catch{}if(!E||!v)return this.h.trace("Got password from keytar for account:",b),d;try{let r=1;for(;v;){const g=await(0,k.retry)(()=>p.getPassword(y,`${b}-${r}`),50,3),h=JSON.parse(g);E+=h.content,v=h.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,b),E}catch(r){return this.h.error(r),d}}async setPassword(p,y,b){this.h.trace("Setting password using keytar:",p,y);let d;try{d=await this.i()}catch(E){throw this.j?.(E),E}await this.g.queue(p+y,()=>this.l(d,p,y,b)),this.c.fire({service:p,account:y})}async l(p,y,b,d){if(!R.isWindows){await(0,k.retry)(()=>p.setPassword(y,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}if(await this.m(p,y,b),d.length<=ht.b){await(0,k.retry)(()=>p.setPassword(y,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}let E=0,v=0,r=!0;const g=[];for(;r;){const h=d.substring(E,E+ht.b);E+=ht.b,r=d.length-E>0;const S={content:h,hasNextChunk:r};g.push((0,k.retry)(()=>p.setPassword(y,v?`${b}-${v}`:b,JSON.stringify(S)),50,3)),v++}await Promise.all(g),this.h.trace(`Set${v?` ${v}-chunked`:""} password from keytar for account:`,b)}async deletePassword(p,y){this.h.trace("Deleting password using keytar:",p,y);let b;try{b=await this.i()}catch(E){throw this.j?.(E),E}const d=await this.g.queue(p+y,()=>this.m(b,p,y));return d&&this.c.fire({service:p,account:y}),d}async m(p,y,b){const d=await p.getPassword(y,b);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",b),!1;let E,v;try{const g=JSON.parse(d);E=g.content,v=g.hasNextChunk}catch{}let r=0;if(E&&v)try{for(r++;v;){const g=`${b}-${r}`,h=await p.getPassword(y,g);await p.deletePassword(y,g),v=JSON.parse(h).hasNextChunk,r++}}catch(g){this.h.error(g)}return await p.deletePassword(y,b)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,b),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,b),!1)}async findPassword(p){let y;try{y=await this.i()}catch{return null}return await y.findPassword(p)}async findCredentials(p){let y;try{y=await this.i()}catch{return[]}return await y.findCredentials(p)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,f=ye([Q(0,A.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[215],te([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=class{constructor(A,R){this.a=A,this.b=R}c(){return new Promise((A,R)=>x(["vscode-encrypt"],A,R))}async encrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.encrypt(this.a,A)}catch(k){return this.b.error(k),A}}async decrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.decrypt(this.a,A)}catch(k){return this.b.error(k),A}}};L=ye([Q(1,I.ILogService)],L),e.EncryptionMainService=L}),define(ee[216],te([0,1,22,7,13,3,2,9,78,5]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends R.Disposable{constructor(b,d){super(),this.a=b,this.b=d,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(b,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(b,d):this.u(b,d)}l(b,d){const E={path:this.C(b),excludes:d.excludes,includes:d.includes,recursive:d.recursive},v=(0,I.insert)(this.j,E);return this.m(),(0,R.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,s.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,f.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&b.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,d){const E={path:this.C(b),excludes:d.excludes,includes:d.includes,recursive:!1},v=(0,I.insert)(this.s,E);return this.v(),(0,R.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,s.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,f.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,k.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(ee[217],te([0,1,22,7,17,23,3,56,71,2,61,15,64,18,60,171,16,113,5,13]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends u.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new R.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new R.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),i.add(l.onDidChangeFile(n=>this.R.fire(new r.FileChangesEvent(n,!this.O(l))))),typeof l.onDidWatchError=="function"&&i.add(l.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(i){l.push(i)}}),!this.h.has(t)&&await L.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new r.FileOperationError((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const i=new S.ErrorNoTelemetry;throw i.message=(0,v.localize)(1,null,t.toString()),i}return l}async k(t){const l=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(l)||(0,r.hasReadWriteCapability)(l)||(0,r.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const l=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(l)||(0,r.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.n(t,l)}catch(i){throw(0,r.toFileSystemProviderErrorCode)(i)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,v.localize)(2,null,this.nb(t)),1):(0,r.ensureFileSystemProviderError)(i)}}async n(t,l){const i=await this.j(t),n=this.O(i),a=l?.resolveTo,c=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,m=await i.stat(t);let D;return this.p(i,t,m,void 0,!!o,(M,T)=>(D||(D=p.TernarySearchTree.forUris(()=>!n),D.set(t,!0),a&&D.fill(!0,a)),D.get(M.resource)||D.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&c?T===1:!1))}async p(t,l,i,n,a,c){const{providerExtUri:o}=this.N(t),m={resource:l,name:o.basename(l),isFile:(i.type&r.FileType.File)!==0,isDirectory:(i.type&r.FileType.Directory)!==0,isSymbolicLink:(i.type&r.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&r.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,r.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&c(m,n)){try{const D=await t.readdir(l),M=await L.Promises.settled(D.map(async([T,N])=>{try{const $=o.joinPath(l,T),q=a?await t.stat($):{type:N};return await this.p(t,$,q,D.length,a,c)}catch($){return this.b.trace($),null}}));m.children=(0,I.coalesce)(M)}catch(D){this.b.trace(D),m.children=[]}return m}return m}async resolveAll(t){return L.Promises.settled(t.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),i=await l.stat(t);return this.p(l,t,i,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.r(t,l)}catch(i){return i}return!0}async r(t,l){if(!l?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,v.localize)(3,null,this.nb(t)),3,l)}async createFile(t,l=s.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,l);return this.m.fire(new r.FileOperationEvent(t,0,n)),n}async writeFile(t,l,i){const n=this.lb(await this.l(t),t),{providerExtUri:a}=this.N(n);try{await this.s(n,t,i)||await this.P(n,a.dirname(t));let o;if((0,r.hasReadWriteCapability)(n)&&!(l instanceof s.VSBuffer))if((0,E.isReadableStream)(l)){const m=await(0,E.peekStream)(l,3);m.ended?o=s.VSBuffer.concat(m.buffer):o=m}else o=(0,E.peekReadable)(l,m=>s.VSBuffer.concat(m),3);else o=l;!(0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n)&&o instanceof s.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof s.VSBuffer?(0,s.bufferToReadable)(o):o),this.m.fire(new r.FileOperationEvent(t,4))}catch(c){throw new r.FileOperationError((0,v.localize)(4,null,this.nb(t),(0,r.ensureFileSystemProviderError)(c).toString()),(0,r.toFileOperationResult)(c),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,l,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(l)));let a;try{a=await t.stat(l)}catch{return}if((a.type&r.FileType.Directory)!==0)throw new r.FileOperationError((0,v.localize)(6,null,this.nb(l)),0,i);if(this.mb(l,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==r.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,r.etag)({mtime:i.mtime,size:a.size}))throw new r.FileOperationError((0,v.localize)(7,null),3,i);return a}async readFile(t,l,i){const n=await this.k(t);return l?.atomic?this.t(n,t,l,i):this.u(n,t,l,i)}async t(t,l,i,n){return new Promise((a,c)=>{this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,l,i,n);a(o)}catch(o){c(o)}})})}async u(t,l,i,n){const a=await this.v(t,l,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.streamToBuffer)(a.value)}}async readFileStream(t,l,i){const n=await this.k(t);return this.v(n,t,l,i)}async v(t,l,i,n){const a=new A.CancellationTokenSource(n),c=this.F(l,i).then(m=>m,m=>{throw a.cancel(),m});let o;try{return typeof i?.etag=="string"&&i.etag!==r.ETAG_DISABLED&&await c,i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,l,i):(0,r.hasFileReadStreamCapability)(t)?o=this.z(t,l,a.token,i):o=this.C(t,l,a.token,i),{...await c,value:o}}catch(m){throw o&&await(0,E.consumeStream)(o),this.w(m,l,i)}}w(t,l,i){const n=(0,v.localize)(8,null,this.nb(l),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new r.FileOperationError(n,(0,r.toFileOperationResult)(t),i)}z(t,l,i,n=Object.create(null)){const a=t.readFileStream(l,n,i);return(0,E.transform)(a,{data:c=>c instanceof s.VSBuffer?c:s.VSBuffer.wrap(c),error:c=>this.w(c,l,n)},c=>s.VSBuffer.concat(c))}C(t,l,i,n=Object.create(null)){const a=(0,s.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,l,a,c=>c,{...n,bufferSize:this.a,errorTransformer:c=>this.w(c,l,n)},i),a}D(t,l,i){const n=(0,E.newWriteableStream)(a=>s.VSBuffer.concat(a));return(async()=>{try{let a;i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?a=await t.readFile(l,{atomic:!0}):a=await t.readFile(l),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.G(l,a.byteLength,i),n.end(s.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async F(t,l){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError((0,v.localize)(9,null,this.nb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==r.ETAG_DISABLED&&l.etag===i.etag)throw new r.NotModifiedSinceFileOperationError((0,v.localize)(10,null),i,l);return this.G(t,i.size,l),i}G(t,l,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&l>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&l>i.limits.size&&(n=7),typeof n=="number")throw new r.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(t)),n,l,i)}}async canMove(t,l,i){return this.H(t,l,"move",i)}async canCopy(t,l,i){return this.H(t,l,"copy",i)}async H(t,l,i,n){if(t.toString()!==l.toString())try{const a=i==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(l),l);await this.M(a,t,c,l,i,n)}catch(a){return a}return!0}async move(t,l,i){const n=this.lb(await this.l(t),t),a=this.lb(await this.l(l),l),c=await this.I(n,t,a,l,"move",!!i),o=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,c==="move"?2:3,o)),o}async copy(t,l,i){const n=await this.k(t),a=this.lb(await this.l(l),l),c=await this.I(n,t,a,l,"copy",!!i),o=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,c==="copy"?3:2,o)),o}async I(t,l,i,n,a,c){if(l.toString()===n.toString())return a;const{exists:o,isSameResourceWithDifferentPathCase:m}=await this.M(t,l,i,n,a,c);if(o&&!m&&c&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),a==="copy"){if(t===i&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(l,n,{overwrite:c});else{const D=await this.resolve(l);D.isDirectory?await this.L(t,D,i,n):await this.J(t,l,i,n)}return a}else return t===i?(await t.rename(l,n,{overwrite:c}),a):(await this.I(t,l,i,n,"copy",c),await this.del(l,{recursive:!0}),"copy")}async J(t,l,i,n){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.eb(t,l,i,n);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.kb(t,l,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.ib(t,l,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.gb(t,l,i,n)}async L(t,l,i,n){await i.mkdir(n),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async a=>{const c=this.N(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.L(t,await this.resolve(a.resource),i,c):this.J(t,a.resource,i,c)}))}async M(t,l,i,n,a,c){let o=!1;if(t===i){const{providerExtUri:D,isPathCaseSensitive:M}=this.N(t);if(M||(o=D.isEqual(l,n)),o&&a==="copy")throw new Error((0,v.localize)(12,null,this.nb(l),this.nb(n)));if(!o&&D.isEqualOrParent(n,l))throw new Error((0,v.localize)(13,null,this.nb(l),this.nb(n)))}const m=await this.exists(n);if(m&&!o){if(!c)throw new r.FileOperationError((0,v.localize)(14,null,this.nb(l),this.nb(n)),4);if(t===i){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(l,n))throw new Error((0,v.localize)(15,null,this.nb(l),this.nb(n)))}}return{exists:m,isSameResourceWithDifferentPathCase:o}}N(t){const l=this.O(t);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.lb(await this.j(t),t);await this.P(l,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async P(t,l){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(l,n.dirname(l));)try{if(((await t.stat(l)).type&r.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(l)));break}catch(a){if((0,r.toFileSystemProviderErrorCode)(a)!==r.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(l)),l=n.dirname(l)}for(let a=i.length-1;a>=0;a--){l=n.joinPath(l,i[a]);try{await t.mkdir(l)}catch(c){if((0,r.toFileSystemProviderErrorCode)(c)!==r.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,l){try{await this.Q(t,l)}catch(i){return i}return!0}async Q(t,l){const i=this.lb(await this.j(t),t);if(!!l?.useTrash&&!(i.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(t)));let a;try{a=await i.stat(t)}catch{}if(a)this.mb(t,a);else throw new r.FileOperationError((0,v.localize)(18,null,this.nb(t)),1);if(!!!l?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(t)))}return i}async del(t,l){const i=await this.Q(t,l),n=!!l?.useTrash,a=!!l?.recursive;await i.delete(t,{recursive:a,useTrash:n}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,l){const i=await this.j(t),n=this.lb(await this.l(l),l);if(i===n&&this.N(i).providerExtUri.isEqual(t,l))return;if(i===n&&(0,r.hasFileCloneCapability)(i))return i.cloneFile(t,l);await this.P(n,this.N(n).providerExtUri.dirname(l));const a=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,r.hasFileFolderCopyCapability)(i)?a.queue(()=>i.copy(t,l,{overwrite:!0})):a.queue(()=>this.J(i,t,n,l))}watch(t,l={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,a=()=>{n=!0};return i.add((0,u.toDisposable)(()=>a())),(async()=>{try{const c=await this.W(t,l);n?(0,u.dispose)(c):a=()=>(0,u.dispose)(c)}catch(c){this.b.error(c)}})(),i}async W(t,l){const i=await this.j(t),n=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),l]);let a=this.U.get(n);return a||(a={count:0,disposable:i.watch(t,l)},this.U.set(n,a)),a.count+=1,(0,u.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,u.dispose)(a.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.dispose)(t.disposable);this.U.clear()}async Y(t,l,i,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{const a=await t.open(l,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,a,n):await this.ab(t,a,n)}catch(c){throw(0,r.ensureFileSystemProviderError)(c)}finally{await t.close(a)}})}async Z(t,l,i){let n=0,a;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const c=s.VSBuffer.concat(i.buffer);await this.bb(t,l,c,c.byteLength,n,0),n+=c.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((c,o)=>{(0,E.listenStream)(a,{onData:async m=>{a.pause();try{await this.bb(t,l,m,m.byteLength,n,0)}catch(D){return o(D)}n+=m.byteLength,setTimeout(()=>a.resume())},onError:m=>o(m),onEnd:()=>c()})})}async ab(t,l,i){let n=0,a;for(;(a=i.read())!==null;)await this.bb(t,l,a,a.byteLength,n,0),n+=a.byteLength}async bb(t,l,i,n,a,c){let o=0;for(;o<n;)o+=await t.write(l,a+o,i.buffer,c+o,n-o)}async cb(t,l,i,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(()=>this.db(t,l,i,n))}async db(t,l,i,n){let a;n instanceof s.VSBuffer?a=n:(0,E.isReadableStream)(n)?a=await(0,s.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?a=await(0,s.bufferedStreamToBuffer)(n):a=(0,s.readableToBuffer)(n),await t.writeFile(l,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,l,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,l,i,n))}async fb(t,l,i,n){let a,c;try{a=await t.open(l,{create:!1}),c=await i.open(n,{create:!0,unlock:!1});const o=s.VSBuffer.alloc(this.a);let m=0,D=0,M=0;do M=await t.read(a,m,o.buffer,D,o.byteLength-D),await this.bb(i,c,o,M,m,D),m+=M,D+=M,D===o.byteLength&&(D=0);while(M>0)}catch(o){throw(0,r.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof c=="number"?i.close(c):Promise.resolve()])}}async gb(t,l,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,l,i,n))}async hb(t,l,i,n){return i.writeFile(n,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async ib(t,l,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,l,i,n))}async jb(t,l,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const c=await t.readFile(l);await this.bb(i,a,s.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,r.ensureFileSystemProviderError)(c)}finally{await i.close(a)}}async kb(t,l,i,n){const a=await(0,s.streamToBuffer)(this.C(t,l,A.CancellationToken.None));await this.cb(i,n,void 0,a)}lb(t,l){if(t.capabilities&2048)throw new r.FileOperationError((0,v.localize)(20,null,this.nb(l)),6);return t}mb(t,l){if((l.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,v.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};w=ye([Q(0,h.ILogService)],w),e.FileService=w}),define(ee[92],te([0,1,41,293,7,35,17,3,32,2,9,4,18,60,24,175,16,113,216,44,212,211]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(l){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(l)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=k.Event.None,this.H=new A.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:a}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,a),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),a=[];return await Promise.all(n.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,b.joinPath)(i,c.name))).type:o=this.G(c),a.push([c.name,o])}catch(o){this.a.trace(o)}})),a}catch(n){throw this.Y(n)}}G(i,n){let a;return n?.dangling?a=r.FileType.Unknown:i.isFile()?a=r.FileType.File:i.isDirectory()?a=r.FileType.Directory:a=r.FileType.Unknown,n&&(a|=r.FileType.SymbolicLink),a}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let a;for(;a=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await a.wait();const c=new s.Barrier;return this.H.set(i,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(i,n){let a;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),a=await this.I(i));const c=this.C(i);return await E.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{a?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,a){const c=(0,d.newWriteableStream)(o=>R.VSBuffer.concat(o.map(m=>R.VSBuffer.wrap(m))).buffer);return(0,g.readFileIntoStream)(this,i,c,o=>o.buffer,{...n,bufferSize:256*1024},a),c}async writeFile(i,n,a){let c;try{const o=this.C(i);if(!a.create||!a.overwrite){if(await E.Promises.exists(o)){if(!a.overwrite)throw(0,r.createFileSystemProviderError)((0,v.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,r.createFileSystemProviderError)((0,v.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const a=this.C(i);let c;(0,r.isFileOpenForWriteOptions)(n)&&(c=await this.I(i));let o;try{if((0,r.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:D}=await E.SymlinkSupport.stat(a);D.mode&128||await E.Promises.chmod(a,D.mode|128)}catch(D){this.a.trace(D)}let m;if((0,r.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await E.Promises.truncate(a,0),m="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}m||(m="w")}else m="r";o=await E.Promises.open(a,m)}catch(m){throw c?.dispose(),(0,r.isFileOpenForWriteOptions)(n)?await this.Z(i,m):this.Y(m)}if(this.L.set(o,0),(0,r.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),c){const m=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.M.set(o,c),m&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),m.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await E.Promises.close(i)}catch(a){throw this.Y(a)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,a,c,o){const m=this.P(i,n);let D=null;try{D=(await E.Promises.read(i,a,c,o,m)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,m,D)}return D}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,a){const c=this.L.get(i);typeof c=="number"&&(typeof n=="number"||(typeof a=="number"?this.L.set(i,c+a):this.L.delete(i)))}async write(i,n,a,c,o){return(0,s.retry)(()=>this.R(i,n,a,c,o),100,3)}async R(i,n,a,c,o){const m=this.P(i,n);let D=null;try{D=(await E.Promises.write(i,a,c,o,m)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,m,D)}return D}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const a=this.C(i);n.recursive?await E.Promises.rm(a,E.RimRafMode.MOVE):await E.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(i,n,a){const c=this.C(i),o=this.C(n);if(c!==o)try{await this.S(i,n,"move",a.overwrite),await E.Promises.move(c,o)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,v.localize)(2,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(o)),m.toString()))),this.Y(m)}}async copy(i,n,a){const c=this.C(i),o=this.C(n);if(c!==o)try{await this.S(i,n,"copy",a.overwrite),await E.Promises.copy(c,o,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,v.localize)(3,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(o)),m.toString()))),this.Y(m)}}async S(i,n,a,c){const o=this.C(i),m=this.C(n);let D=!1;if(!!(this.capabilities&1024)||(D=(0,f.isEqual)(o,m,!0)),D&&a==="copy")throw(0,r.createFileSystemProviderError)((0,v.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(!D&&await E.Promises.exists(m)){if(!c)throw(0,r.createFileSystemProviderError)((0,v.localize)(5,null),r.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,a){const c=this.C(i),o=this.C(n),m=!!(this.capabilities&1024);if((0,f.isEqual)(c,o,!m))return;const D=new u.DisposableStore;try{const[M,T]=await Promise.all([this.I(i),this.I(n)]);D.add(M),D.add(T),a&&await E.Promises.mkdir((0,p.dirname)(o),{recursive:!0}),await E.Promises.copyFile(c,o)}catch(M){if(M.code==="ENOENT"&&!a)return this.U(i,n,!0);throw this.Y(M)}finally{D.dispose()}}p(i,n,a){return new w.UniversalWatcherClient(c=>i(c),c=>n(c),a)}y(i,n,a){return new C.NodeJSWatcherClient(c=>i(c),c=>n(c),a)}Y(i){if(i instanceof r.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=r.FileSystemProviderErrorCode.NoPermissions;break;default:n=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,n)}async Z(i,n){let a=this.Y(n);if(i&&a.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await E.SymlinkSupport.stat(this.C(i));c.mode&128||(a=(0,r.createFileSystemProviderError)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return a}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ee[218],te([0,1,3,92,2,17,60,23]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends s.Disposable{constructor(y,b){super(),this.a=y,this.b=b,this.w=new Map,this.y=new Map}call(y,b,d){const E=this.c(y);switch(b){case"stat":return this.g(E,d[0]);case"readdir":return this.h(E,d[0]);case"open":return this.l(E,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(E,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(E,d[0],d[1],d[2]);case"rename":return this.t(E,d[0],d[1],d[2]);case"copy":return this.u(E,d[0],d[1],d[2]);case"cloneFile":return this.v(E,d[0],d[1]);case"mkdir":return this.r(E,d[0]);case"delete":return this.s(E,d[0],d[1]);case"watch":return this.C(E,d[0],d[1],d[2],d[3]);case"unwatch":return this.D(d[0],d[1])}throw new Error(`IPC Command ${b} not found`)}listen(y,b,d){const E=this.c(y);switch(b){case"fileChange":return this.z(E,d[0]);case"readFileStream":return this.j(E,d[0],d[1])}throw new Error(`Unknown event ${b}`)}g(y,b){const d=this.f(y,b,!0);return this.a.stat(d)}h(y,b){const d=this.f(y,b);return this.a.readdir(d)}async i(y,b,d){const E=this.f(y,b,!0),v=await this.a.readFile(E,d);return A.VSBuffer.wrap(v)}j(y,b,d){const E=this.f(y,b,!0),v=new k.CancellationTokenSource,r=new I.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),g=this.a.readFileStream(E,d,v.token);return(0,R.listenStream)(g,{onData:h=>r.fire(A.VSBuffer.wrap(h)),onError:h=>r.fire(h),onEnd:()=>{r.fire("end"),r.dispose(),v.dispose()}}),r.event}k(y,b,d,E){const v=this.f(y,b);return this.a.writeFile(v,d.buffer,E)}l(y,b,d){const E=this.f(y,b,!0);return this.a.open(E,d)}m(y){return this.a.close(y)}async n(y,b,d){const E=A.VSBuffer.alloc(d),v=0,r=await this.a.read(y,b,E.buffer,v,d);return[E,r]}p(y,b,d,E,v){return this.a.write(y,b,d.buffer,E,v)}r(y,b){const d=this.f(y,b);return this.a.mkdir(d)}s(y,b,d){const E=this.f(y,b);return this.a.delete(E,d)}t(y,b,d,E){const v=this.f(y,b),r=this.f(y,d);return this.a.rename(v,r,E)}u(y,b,d,E){const v=this.f(y,b),r=this.f(y,d);return this.a.copy(v,r,E)}v(y,b,d){const E=this.f(y,b),v=this.f(y,d);return this.a.cloneFile(E,v)}z(y,b){const d=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(y,d))},onDidRemoveLastListener:()=>{(0,s.dispose)(this.w.get(b)),this.w.delete(b)}});return d.event}async C(y,b,d,E,v){const r=this.w.get(b);if(r){const g=this.f(y,E),h=r.watch(d,g,v);this.y.set(b+d,h)}}async D(y,b){const d=y+b,E=this.y.get(d);E&&((0,s.dispose)(E),this.y.delete(d))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class u extends s.Disposable{constructor(y,b,d,E){super(),this.c=y,this.f=d,this.g=E,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(y){const b=this.B(new I.Emitter);this.B(b.event(d=>{y.fire(d.map(E=>({resource:this.c.transformOutgoingURI(E.resource),type:E.type})))})),this.B(this.b.onDidChangeFile(d=>b.fire(d))),this.B(this.b.onDidWatchError(d=>y.fire(d)))}i(y){}j(y){}watch(y,b,d){const E=this.j(this.g);return Array.isArray(E)&&(d.excludes=[...d.excludes,...E]),this.a.set(y,this.b.watch(b,d)),(0,s.toDisposable)(()=>{(0,s.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=u}),define(ee[219],te([0,1,14,174,4,8,16,9,218,150]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends f.AbstractDiskFileSystemProviderChannel{constructor(d,E,v){super(d,E),this.G=v}c(d){return u.DefaultURITransformer}f(d,E){return A.URI.revive(E)}async s(d,E,v){if(!v.useTrash)return super.s(d,E,v);const r=this.f(d,E),g=(0,k.normalize)(r.fsPath);try{await I.shell.trashItem(g)}catch{throw(0,R.createFileSystemProviderError)(s.isWindows?(0,L.localize)(0,null,(0,k.basename)(g)):(0,L.localize)(1,null,(0,k.basename)(g)),R.FileSystemProviderErrorCode.Unknown)}}F(d,E){return new y(d,E,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class y extends f.AbstractSessionFileWatcher{watch(d,E,v){if(v.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(d,E,v)}}}),define(ee[220],te([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends I.AbstractMessageLogger{constructor(A=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(A){this.l=A;for(const{level:R,message:k}of this.k)(0,I.log)(A,R,k);this.k=[]}g(A,R){this.l?(0,I.log)(this.l,A,R):this.getLevel()<=A&&this.k.push({level:A,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=L}),define(ee[221],te([0,1,2,5]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class s extends I.Disposable{constructor(R,k=[]){super(),this.a=new L.MultiplexLogger([R,...k]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...k){this.a.trace(R,...k)}debug(R,...k){this.a.debug(R,...k)}info(R,...k){this.a.info(R,...k)}warn(R,...k){this.a.warn(R,...k)}error(R,...k){this.a.error(R,...k)}flush(){this.a.flush()}}e.LogService=s}),define(ee[222],te([0,1,35,8,5]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(k){this.b=k,this.a=new I.ResourceMap}listen(k,f,u){switch(f){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(k,f,u){switch(f){case"createLogger":this.c(L.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.isLogLevel)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(L.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(L.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:L.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(L.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}c(k,f,u){this.a.set(k,this.b.createLogger(k,f,u))}d(k,f){let u=console.log;switch(k){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...f)}e(k,f){const u=this.a.get(k);if(!u)throw new Error("Create the logger before logging");for(const[p,y]of f)(0,s.log)(u,p,y)}}e.LoggerChannel=A}),define(ee[223],te([0,1,16,5]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function A(u,p,y,b,d){try{const E=await new Promise((r,g)=>{x(["spdlog"],r,g)});E.setFlushOn(s.Trace);const v=await E.createAsyncRotatingLogger(u,p,y,b);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(E){console.error(E)}return null}function R(u,p,y){switch(p){case L.LogLevel.Trace:u.trace(y);break;case L.LogLevel.Debug:u.debug(y);break;case L.LogLevel.Info:u.info(y);break;case L.LogLevel.Warning:u.warn(y);break;case L.LogLevel.Error:u.error(y);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function k(u,p){switch(p){case L.LogLevel.Trace:u.setLevel(s.Trace);break;case L.LogLevel.Debug:u.setLevel(s.Debug);break;case L.LogLevel.Info:u.setLevel(s.Info);break;case L.LogLevel.Warning:u.setLevel(s.Warning);break;case L.LogLevel.Error:u.setLevel(s.Error);break;case L.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class f extends L.AbstractMessageLogger{constructor(p,y,b,d,E){super(),this.k=[],this.setLevel(E),this.l=this.n(p,y,b,d),this.B(this.onDidChangeLogLevel(v=>{this.m&&k(this.m,v)}))}async n(p,y,b,d){const E=b?6:1,v=30/E*I.ByteSize.MB,r=await A(p,y,v,E,d);if(r){this.m=r,k(this.m,this.getLevel());for(const{level:g,message:h}of this.k)R(this.m,g,h);this.k=[]}}g(p,y){this.m?R(this.m,p,y):this.getLevel()<=p&&this.k.push({level:p,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ee[224],te([0,1,31,5,223]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(k,f,u){return new s.SpdLogLogger((0,I.generateUuid)(),k.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.LoggerService=A}),define(ee[65],te([0,1,35,3,6,5,224]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,s.refineServiceDecorator)(A.ILoggerService);class k extends R.LoggerService{constructor(){super(...arguments),this.p=new I.ResourceMap}createLogger(u,p,y){y!==void 0&&this.p.set(this.l(u),y);try{return super.createLogger(u,p)}catch(b){throw this.p.delete(this.l(u)),b}}registerLogger(u,p){p!==void 0&&this.p.set(u.resource,p),super.registerLogger(u)}deregisterLogger(u){this.p.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const p=[];for(const y of super.getRegisteredLoggers())u===this.p.get(y.resource)&&p.push(y);return p}getOnDidChangeLogLevelEvent(u){return L.Event.filter(this.onDidChangeLogLevel,p=>(0,A.isLogLevel)(p)||this.s(p[0],u))}getOnDidChangeVisibilityEvent(u){return L.Event.filter(this.onDidChangeVisibility,([p])=>this.s(p,u))}getOnDidChangeLoggersEvent(u){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(b=>this.s(b.resource,u)),removed:[...p.removed].filter(b=>this.s(b.resource,u))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(u){for(const[p,y]of this.p)y===u&&this.deregisterLogger(p)}s(u,p){const y=this.p.get(u);return y===void 0||y===p}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=k}),define(ee[225],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function s(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=s;function A(R){return!I(R)&&!L(R)&&!s(R)}e.isMenubarMenuItemAction=A}),define(ee[38],te([0,1,3,71,2,6]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class R extends s.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const p=Object.keys(this.f).length;return this.f={...u,...this.f},p!==Object.keys(this.f).length&&await this.i(u),L.Iterable.reduce(this.g.entries(),(y,[b,d])=>({...y,[b]:d}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(u,[p,y])=>({...u,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=R;class k{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[226],te([0,1,7,3,71,11,16,5,38]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(y,b){const d=[];for(const E of new Set(s.Iterable.concat(y.keys(),b.keys())))y.get(E)!==b.get(E)&&d.push(E);return d}let p=class extends f.AbstractPolicyService{constructor(b,d,E){super(),this.j=b,this.k=d,this.l=E,this.c=this.B(new I.ThrottledDelayer(500));const v=L.Event.filter(d.onDidFilesChange,r=>r.affects(b));this.B(d.watch(b)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const d=await this.k.readFile(this.j),E=JSON.parse(d.value.toString());if(!(0,A.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(E))this.f[v]&&b.set(v,E[v])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return b}async p(){const b=await this.n(),d=u(this.g,b);this.g=b,d.length>0&&this.h.fire(d)}};p=ye([Q(1,R.IFileService),Q(2,k.ILogService)],p),e.FilePolicyService=p}),define(ee[227],te([0,1,3,2,38]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(f){this.b=f,this.a=new L.DisposableStore}listen(f,u){switch(u){case"onDidChange":return I.Event.map(this.b.onDidChange,p=>p.reduce((y,b)=>({...y,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(f,u,p){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class R extends s.AbstractPolicyService{constructor(f,u){super(),this.a=u;for(const p in f){const{definition:y,value:b}=f[p];this.f[p]=y,b!==void 0&&this.g.set(p,b)}this.a.listen("onDidChange")(p=>{for(const y in p){const b=p[y];b===null?this.g.delete(y):this.g.set(y,b)}this.h.fire(Object.keys(p))})}async i(f){const u=await this.a.call("updatePolicyDefinitions",f);for(const p in u)this.g.set(p,u[p])}}e.PolicyChannelClient=R}),define(ee[228],te([0,1,38,7,294,2,5]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends I.AbstractPolicyService{constructor(u,p){super(),this.j=u,this.k=p,this.a=new L.Throttler,this.b=this.B(new A.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=(0,s.createWatcher)(this.k,u,b=>{this.m(b),p()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),y(b)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const p in u){const y=u[p];y===void 0?this.g.delete(p):this.g.set(p,y)}this.h.fire(Object.keys(u))}};k=ye([Q(0,R.ILogService)],k),e.NativePolicyService=k}),define(ee[66],te([0,1,4,36]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const A=I.globals.vscode.context.configuration();if(A)s=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:A.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ee[21],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[229],te([0,1,83,5,21]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=class{constructor(k,f){this.b=k,this.c=f,this.a=new Map}async isExtensionUrlTrusted(k,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,p,y]=u;let b=this.a.get(k);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[k],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...b])}const d=Buffer.from(decodeURIComponent(y),"base64");if(d.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const E=d.slice(0,6),v=d.readUIntBE(0,6),r=Date.now()-v;if(r<0||r>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const g=d.slice(6),h=I.createVerify("SHA256");h.write(E),h.write(Buffer.from(p)),h.end();for(let S=0;S<b.length;S++){let w=b[S];if(w!==null){if(typeof w=="string")try{w=I.createPublicKey({key:Buffer.from(w,"base64"),format:"der",type:"spki"}),b[S]=w}catch(C){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${S+1} for ${k}:`,C),b[S]=null;continue}if(h.verify(w,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};A=ye([Q(0,s.IProductService),Q(1,L.ILogService)],A),e.ExtensionUrlTrustService=A}),define(ee[230],te([0,1,7,5]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let s=class{constructor(R,k,f){this.a=R,this.b=k,this.c=f}async inspect(R){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(R);const f=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};s=ye([Q(2,L.ILogService)],s),e.WindowProfiler=s}),define(ee[67],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,128,11]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class s{constructor(){this.a=new Map}add(R,k){I.ok(L.isString(R)),I.ok(L.isObject(k)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,k)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new s}),define(ee[231],te([0,1,3,51]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function s(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[s(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;L.Registry.add(e.Extensions.JSONContribution,R)}),define(ee[68],te([0,1,22,3,11,159,19,231,51]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=f.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const i=new Set;this.n(t,l,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const l=new Set;this.o(t,l),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const i=new Set;this.o(l,i),this.n(t,!1,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const i=[];for(const{overrides:n,source:a}of t)for(const c in n)if(l.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),m=o?.valuesSources??new Map;if(a)for(const N of Object.keys(n[c]))m.set(N,a);const D={...o?.value||{},...n[c]};this.a.set(c,{source:a,value:D,valuesSources:m});const M=(0,R.getLanguageTagSettingPlainKey)(c),T={type:"object",default:D,description:A.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:s.isString(a)?void 0:a,defaultValueSource:a};i.push(...v(c)),this.d[c]=T,this.b.properties[c]=T}else{this.a.set(c,{value:n[c],source:a});const o=this.d[c];o&&(this.w(c,o),this.r(c,o))}this.m(i)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:i,source:n}of t)for(const a in i){const c=this.a.get(a),o=s.isString(n)?n:n?.id,m=s.isString(c?.source)?c?.source:c?.source?.id;if(o===m)if(l.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const D=this.d[a];D&&(this.w(a,D),this.r(a,D))}}this.u()}deltaConfiguration(t){let l=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,i){t.forEach(n=>{this.p(n,l,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,l){const i=n=>{if(n.properties)for(const a in n.properties){l.add(a);const c=this.d[a];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[a],this.s(a,n.properties[a])}n.allOf?.forEach(a=>i(a))};for(const n of t){i(n);const a=this.c.indexOf(n);a!==-1&&this.c.splice(a,1)}}p(t,l=!0,i,n,a=3,c){a=s.isUndefinedOrNull(t.scope)?a:t.scope;const o=t.properties;if(o)for(const D in o){const M=o[D];if(l&&S(D,M)){delete o[D];continue}if(M.source=i,M.defaultDefaultValue=o[D].default,this.w(D,M),e.OVERRIDE_PROPERTY_REGEX.test(D)?M.scope=void 0:(M.scope=s.isUndefinedOrNull(M.scope)?a:M.scope,M.restricted=s.isUndefinedOrNull(M.restricted)?!!n?.includes(D):M.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),c.add(D)}const m=t.allOf;if(m)for(const D of m)this.p(D,l,i,n,a,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=i=>{const n=i.properties;if(n)for(const c in n)this.r(c,n[c]);i.allOf?.forEach(l)};l(t)}r(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,l){const i=this.a.get(t);let n=i?.value,a=i?.source;s.isUndefined(n)&&(n=l.defaultDefaultValue,a=void 0),s.isUndefined(n)&&(n=g(l.type)),l.default=n,l.defaultValueSource=a}}const d="\\[([^\\]]+)\\]",E=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let l=E.exec(C);for(;l?.length;){const i=l[1].trim();i&&t.push(i),l=E.exec(C)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=v;function r(C){return C.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=r;function g(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const h=new b;f.Registry.add(e.Extensions.Configuration,h);function S(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?A.localize(7,null,C):h.getConfigurationProperties()[C]!==void 0?A.localize(8,null,C):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,C,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=S;function w(){const C=[],t=h.getConfigurationProperties();for(const l of Object.keys(t))C.push([l,t[l].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=w}),define(ee[114],te([0,1,22,3,43,2,35,37,11,8,19,68,51]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(l){return Object.isFrozen(l)?l:k.deepFreeze(l)}class E{constructor(i={},n=[],a=[],c){this.b=i,this.c=n,this.d=a,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const a=new v("");return a.parseRaw(n),a.configurationModel});this.f=i.reduce((n,a)=>a===n?a:n.merge(a),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,p.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const a=this.rawConfiguration.getValue(i),c=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):a;return{value:a,override:c,merged:o}}getOverrideValue(i,n){const a=this.i(n);return a?i?(0,p.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const a of this.overrides)a.identifiers.includes(i)&&n.push(...a.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return I.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),a=k.deepClone(this.overrides),c=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const m of i)if(o.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.h(n,m.contents);for(const D of m.overrides){const[M]=a.filter(T=>I.equals(T.identifiers,D.identifiers));M?(this.h(M.contents,D.contents),M.keys.push(...D.keys),M.keys=I.distinct(M.keys)):a.push(k.deepClone(D))}for(const D of m.keys)c.indexOf(D)===-1&&c.push(D)}return new E(n,c,a,o.every(m=>m instanceof E)?void 0:o)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const c of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[c];const m=n[c];m&&(typeof o=="object"&&typeof m=="object"?(o=k.deepClone(o),this.h(o,m)):o=m),a[c]=o}return new E(a,this.keys,this.overrides)}h(i,n){for(const a of Object.keys(n)){if(a in i&&f.isObject(i[a])&&f.isObject(n[a])){this.h(i[a],n[a]);continue}i[a]=k.deepClone(n[a])}}i(i){let n=null,a=null;const c=o=>{o&&(a?this.h(a,o):a=k.deepClone(o))};for(const o of this.overrides)I.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&c(o.contents);return c(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,p.removeFromValueTree)(this.contents,i),y.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(a=>I.equals(a.identifiers,(0,y.overrideIdentifiersFromKey)(i))),1))}j(i,n,a){(0,p.addToValueTree)(this.contents,i,n,c=>console.error(c)),a=a||this.keys.indexOf(i)===-1,a&&this.keys.push(i),y.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,p.toValuesTree)(this.contents[i],c=>console.error(c))})}}e.ConfigurationModel=E;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!f.isUndefinedOrNull(i)){const a=this.g(i);this.parseRaw(a,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:a,keys:c,overrides:o,restricted:m,hasExcludedProperties:D}=this.h(i,n);this.b=new E(a,c,o,D?[i]:void 0),this.c=m||[]}g(i){let n={},a=null,c=[];const o=[],m=[];function D(T){Array.isArray(c)?c.push(T):a!==null&&(c[a]=T)}const M={onObjectBegin:()=>{const T={};D(T),o.push(c),c=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{const T=[];D(T),o.push(c),c=T,a=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:D,onError:(T,N,$)=>{m.push({error:T,offset:N,length:$})}};if(i)try{s.visit(i,M),n=c[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}h(i,n){const a=b.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),c=this.i(i,a,!0,n);i=c.raw;const o=(0,p.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),m=Object.keys(i),D=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:o,keys:m,overrides:D,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(i,n,a,c){let o=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const m={},D=[];for(const M in i)if(y.OVERRIDE_PROPERTY_REGEX.test(M)&&a){const T=this.i(i[M],n,!1,c);m[M]=T.raw,o=o||T.hasExcludedProperties,D.push(...T.restricted)}else{const T=n[M],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&D.push(M),(N===void 0||c.scopes===void 0||c.scopes.includes(N))&&!(c.skipRestricted&&T?.restricted)?m[M]=i[M]:o=!0}return{raw:m,restricted:D,hasExcludedProperties:o}}j(i,n){const a=[];for(const c of Object.keys(i))if(y.OVERRIDE_PROPERTY_REGEX.test(c)){const o={};for(const m in i[c])o[m]=i[c][m];a.push({identifiers:(0,y.overrideIdentifiersFromKey)(c),keys:Object.keys(o),contents:(0,p.toValuesTree)(o,n)})}return a}}e.ConfigurationModelParser=v;class r extends A.Disposable{constructor(i,n,a,c){super(),this.f=i,this.g=n,this.h=c,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&a.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class g{constructor(i,n,a,c,o,m,D,M,T,N,$,q,ie){this.a=i,this.b=n,this.c=a,this.overrideIdentifiers=c,this.d=o,this.f=m,this.g=D,this.h=M,this.i=T,this.j=N,this.k=$,this.l=q,this.m=ie}get value(){return d(this.c)}n(i,n,a){const c=i.inspect(n,a);return{get value(){return d(c.value)},get override(){return d(c.override)},get merged(){return d(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(i,n,a,c,o=new E,m=new E,D=new R.ResourceMap,M=new E,T=new R.ResourceMap){this.c=i,this.d=n,this.f=a,this.g=c,this.h=o,this.i=m,this.j=D,this.l=M,this.m=T,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(i,n,a){return this.q(i,n,a).getValue(i)}updateValue(i,n,a={}){let c;a.resource?(c=this.m.get(a.resource),c||(c=new E,this.m.set(a.resource,c))):c=this.l,n===void 0?c.removeValue(i):c.setValue(i,n),a.resource||(this.a=null)}inspect(i,n,a){const c=this.q(i,n,a),o=this.u(n.resource,a),m=n.resource?this.m.get(n.resource)||this.l:this.l,D=new Set;for(const M of c.overrides)for(const T of M.identifiers)c.getOverrideValue(i,T)!==void 0&&D.add(T);return new g(i,n,c.getValue(i),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,o||void 0,m)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const a=[];if(!n){const{added:c,updated:o,removed:m}=C(this.c,i);n=[...c,...o,...m]}for(const c of n)for(const o of(0,y.overrideIdentifiersFromKey)(c)){const m=this.c.getKeysForOverrideIdentifier(o),D=i.getKeysForOverrideIdentifier(o),M=[...D.filter(T=>m.indexOf(T)===-1),...m.filter(T=>D.indexOf(T)===-1),...m.filter(T=>!k.equals(this.c.override(o).getValue(T),i.override(o).getValue(T)))];a.push([o,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:a,removed:c}=C(this.d,i),o=[...n,...a,...c];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=C(this.applicationConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateApplicationConfiguration(i),{keys:m,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=C(this.localUserConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=C(this.remoteUserConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:a,removed:c,overrides:o}=C(this.workspaceConfiguration,i),m=[...n,...a,...c];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const a=this.p.get(i),{added:c,updated:o,removed:m,overrides:D}=C(a,n),M=[...c,...o,...m];return(M.length||!a)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:D}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:c,removed:o,overrides:m}=C(n,void 0);return{keys:[...a,...c,...o],overrides:m}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,a){let c=this.r(n,a);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(c=c.merge(this.d)),c}r({resource:i},n){let a=this.s();if(n&&i){const c=n.getFolder(i);c&&(a=this.t(c.uri)||a);const o=this.m.get(i);o&&(a=a.merge(o))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const a=this.s(),c=this.j.get(i);c?(n=a.merge(c),this.b.set(i,n)):n=a}return n}u(i,n){if(n&&i){const a=n.getFolder(i);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:a,overrides:c,keys:o}=this.j.get(n);return i.push([n,{contents:a,overrides:c,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(a=>i.add(a))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(a=>i.add(a))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this.i.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(c=>n.add(c))),[...n.values()]}static parse(i){const n=this.x(i.defaults),a=this.x(i.policy),c=this.x(i.application),o=this.x(i.user),m=this.x(i.workspace),D=i.folders.reduce((M,T)=>(M.set(u.URI.revive(T[0]),this.x(T[1])),M),new R.ResourceMap);return new h(n,a,c,o,new E,m,D,new E,new R.ResourceMap)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=h;function S(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,n=new Map;for(const c of l)c.keys.forEach(o=>i.add(o)),c.overrides.forEach(([o,m])=>{const D=(0,R.getOrSet)(n,o,new Set);m.forEach(M=>D.add(M))});const a=[];return n.forEach((c,o)=>a.push([o,[...c.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=S;class w{constructor(i,n,a,c){this.change=i,this.f=n,this.g=a,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const m of o)this.affectedKeys.add(m);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(i,n){const a=this.a+i,c=this.d.indexOf(a);if(c<0)return!1;const o=c+a.length;if(o>=this.d.length)return!1;const m=this.d.charCodeAt(o);if(m!==this.b&&m!==this.c)return!1;if(n){const D=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,M=this.g.getValue(i,n,this.h);return!k.equals(D,M)}return!0}}e.ConfigurationChangeEvent=w;function C(l,i){const{added:n,removed:a,updated:c}=t(i?.rawConfiguration,l?.rawConfiguration),o=[],m=l?.getAllOverrideIdentifiers()||[],D=i?.getAllOverrideIdentifiers()||[];if(i){const M=D.filter(T=>!m.includes(T));for(const T of M)o.push([T,i.getKeysForOverrideIdentifier(T)])}if(l){const M=m.filter(T=>!D.includes(T));for(const T of M)o.push([T,l.getKeysForOverrideIdentifier(T)])}if(i&&l){for(const M of m)if(D.includes(M)){const T=t({contents:l.getOverrideValue(void 0,M)||{},keys:l.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});o.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:a,updated:c,overrides:o}}function t(l,i){const n=l?i?l.keys.filter(o=>i.keys.indexOf(o)===-1):[...l.keys]:[],a=i?l?i.keys.filter(o=>l.keys.indexOf(o)===-1):[...i.keys]:[],c=[];if(l&&i){for(const o of i.keys)if(l.keys.indexOf(o)!==-1){const m=(0,p.getConfigurationValue)(i.contents,o),D=(0,p.getConfigurationValue)(l.contents,o);k.equals(m,D)||c.push(o)}}return{added:n,removed:a,updated:c}}}),define(ee[232],te([0,1,22,3,2,37,11,114,68,5,38,51]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends s.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:g})=>this.c(Array.from(r),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,g){this.h(r,y.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new k.ConfigurationModel;const r=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,g){const h=this.f();for(const S of r){const w=h[S],C=g[S];w!==void 0?this.b.addValue(S,w):C?this.b.addValue(S,C.default):this.b.removeValue(S)}}}e.DefaultConfiguration=b;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let E=class extends s.Disposable{get configurationModel(){return this.b}constructor(r,g,h){super(),this.c=r,this.f=g,this.g=h,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(r=>this.i(r))),this.B(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const g={},h=[],S=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const w of r){const C=S[w];if(!C){h.push(w);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}h.push(w),g[C.policy.name]={type:C.type}}}return(0,R.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),h}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const g=y.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),h=(0,I.coalesce)(r.map(S=>g.get(S)));this.j(h,!0)}j(r,g){this.g.trace("PolicyConfiguration#update",r);const h=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),S=[],w=this.b.isEmpty();for(const C of r){const t=h[C]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(w?l!==void 0:!(0,A.equals)(this.b.getValue(C),l))&&S.push([C,l])}else this.b.getValue(C)!==void 0&&S.push([C,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const C=this.b;this.b=new k.ConfigurationModel;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,l]of S)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);g&&this.a.fire(this.b)}}};E=ye([Q(1,p.IPolicyService),Q(2,u.ILogService)],E),e.PolicyConfiguration=E}),define(ee[233],te([0,1,7,3,2,18,19,114,232,38]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends s.Disposable{constructor(b,d,E,v){super(),this.i=b,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=E instanceof u.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,E,v)),this.f=this.B(new k.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,d)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:g})=>this.k(r,g))),this.B(this.c.onDidChangeConfiguration(r=>this.l(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,d,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(b,d,new k.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(b,d){const E=typeof b=="string"?b:void 0,v=(0,R.isConfigurationOverrides)(b)?b:(0,R.isConfigurationOverrides)(d)?d:{};return this.a.getValue(E,v,void 0)}updateValue(b,d,E,v){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const d=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(E,d,2)}k(b,d){const E=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(b,d);this.m(v,E,7)}l(b){const d=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(b);this.m(E,d,7)}m(b,d,E){const v=new k.ConfigurationChangeEvent(b,{data:d},this.a);v.source=E,v.sourceConfig=this.n(E),this.h.fire(v)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(ee[234],te([0,1,13,6]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var s;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(s=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends I.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof A&&f._code===s.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof A&&f._code===s.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof A&&f._code===s.NoResolverFound}static isHandled(f){return f instanceof A&&f.isHandled}constructor(f,u=s.Unknown,p){super(f),this._message=f,this._code=u,this._detail=p,this.isHandled=u===s.NotAvailable&&p===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function R(k){const f=k.indexOf("+");return f===-1?k:k.substring(0,f)}e.getRemoteAuthorityPrefix=R}),define(ee[57],te([0,1,15]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(u){return u.scheme===I.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=L;function s(u){if(!u)return;const p=u.indexOf("+");return p<0?u:u.substr(0,p)}e.getRemoteName=s;function A(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=A;function R(u){const{host:p,port:y}=f(u);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:y}}e.parseAuthorityWithPort=R;function k(u,p){let{host:y,port:b}=f(u);return typeof b>"u"&&(b=p),{host:y,port:b}}e.parseAuthorityWithOptionalPort=k;function f(u){const p=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const b=u.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:u,port:void 0}}}),define(ee[115],te([0,1,26,6,57]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var k;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,g){if(typeof r>"u"||r===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof r=="string"||typeof g=="string"){const h=typeof r=="string"?r:r.value,S=typeof g=="string"?g:g.value;return I.equalsIgnoreCase(h,S)}return r.c===g.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=f;class u{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const g of r)this.add(g)}add(r){this.c.add(f.toKey(r))}delete(r){return this.c.delete(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}}e.ExtensionIdentifierSet=u;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(f.toKey(r))}get(r){return this.c.get(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}set(r,g){this.c.set(f.toKey(r),g)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=p;function y(v){return b(v)}e.isApplicationScopedExtension=y;function b(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function E(v,r){if(r){const g=`onResolveRemoteAuthority:${(0,s.getRemoteName)(r)}`;return!!v.activationEvents?.includes(g)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[235],te([0,1,7,17,23,13,3,2,64,74,31,105,234,57]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var v;(function(P){P[P.Management=1]="Management",P[P.ExtensionHost=2]="ExtensionHost",P[P.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function r(P){switch(P){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(P){const F=new s.CancellationTokenSource;return setTimeout(()=>F.cancel(),P),F.token}function h(P,F){if(P.isCancellationRequested||F.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.CancellationTokenSource;return P.onCancellationRequested(()=>U.cancel()),F.onCancellationRequested(()=>U.cancel()),U.token}class S{get didTimeout(){return this.c==="timedout"}constructor(F){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((U,j)=>{this.f=U,this.g=j}),F.isCancellationRequested?this.h():this.d.add(F.onCancellationRequested(()=>this.h()))}registerDisposable(F){this.c==="pending"?this.d.add(F):F.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(F))}reject(F){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(F))}}function w(P,F){const U=new S(F);return U.registerDisposable(P.onControlMessage(j=>{const B=JSON.parse(j.toString()),z=V(B);z?U.reject(z):U.resolve(B)})),U.promise}function C(P,F,U,j,B,z,G,re,he){const be=new S(he),ke=u.StopWatch.create(!1);return P.info(`Creating a socket (${re})...`),f.mark(`code/willCreateSocket/${G}`),F.connect(U,j,B,z,re,(Le,Oe)=>{be.didTimeout?(f.mark(`code/didCreateSocketError/${G}`),P.info(`Creating a socket (${re}) finished after ${ke.elapsed()} ms, but this is too late and has timed out already.`),Le&&P.error(Le),Oe?.dispose()):Le||!Oe?(f.mark(`code/didCreateSocketError/${G}`),P.info(`Creating a socket (${re}) returned an error after ${ke.elapsed()} ms.`),be.reject(Le)):(f.mark(`code/didCreateSocketOK/${G}`),P.info(`Creating a socket (${re}) was successful after ${ke.elapsed()} ms.`),be.resolve(Oe))}),be.promise}function t(P,F){const U=new S(F);return P.then(j=>{U.didTimeout||U.resolve(j)},j=>{U.didTimeout||U.reject(j)}),U.promise}async function l(P,F,U,j){const B=_(P,F);P.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let z;try{z=await C(P.logService,P.socketFactory,P.host,P.port,(0,d.getRemoteServerRootPath)(P),`reconnectionToken=${P.reconnectionToken}&reconnection=${P.reconnectionProtocol?"true":"false"}`,r(F),`renderer-${r(F)}-${P.reconnectionToken}`,j)}catch(ke){throw P.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),P.logService.error(ke),ke}P.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let G,re;P.reconnectionProtocol?(P.reconnectionProtocol.beginAcceptReconnection(z,null),G=P.reconnectionProtocol,re=!1):(G=new y.PersistentProtocol({socket:z,measureRoundTripTime:!0}),re=!0),P.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const he=await t(P.signService.createNewMessage((0,p.generateUuid)()),j),be={type:"auth",auth:P.connectionToken||"00000000000000000000",data:he.data};G.sendControl(L.VSBuffer.fromString(JSON.stringify(be)));try{const ke=await w(G,h(j,g(1e4)));if(ke.type!=="sign"||typeof ke.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(P.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(P.signService.validate(he,ke.signedData),j)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const Oe=await t(P.signService.sign(ke.data),j),Fe={type:"connectionType",commit:P.commit,signedData:Oe,desiredConnectionType:F};return U&&(Fe.args=U),P.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.VSBuffer.fromString(JSON.stringify(Fe))),{protocol:G,ownsProtocol:re}}catch(ke){throw ke&&ke.code==="ETIMEDOUT"&&(P.logService.error(`${B} the handshake timed out. Error:`),P.logService.error(ke)),ke&&ke.code==="VSCODE_CONNECTION_ERROR"&&(P.logService.error(`${B} received error control message when negotiating connection. Error:`),P.logService.error(ke)),re&&W(G),ke}}async function i(P,F,U,j){const B=Date.now(),z=_(P,F),{protocol:G,ownsProtocol:re}=await l(P,F,U,j),he=new S(j);return he.registerDisposable(G.onControlMessage(be=>{const ke=JSON.parse(be.toString()),Le=V(ke);Le?(P.logService.error(`${z} received error control message when negotiating connection. Error:`),P.logService.error(Le),re&&W(G),he.reject(Le)):(P.reconnectionProtocol?.endAcceptReconnection(),P.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${O(B)}!`),he.resolve({protocol:G,firstMessage:ke}))})),he.promise}async function n(P,F){const{protocol:U}=await i(P,1,void 0,F);return{protocol:U}}async function a(P,F,U){const{protocol:j,firstMessage:B}=await i(P,2,F,U),z=B&&B.debugPort;return{protocol:j,debugPort:z}}async function c(P,F,U){const j=Date.now(),B=_(P,3),{protocol:z}=await l(P,3,F,U);return P.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${O(j)}!`),z}async function o(P,F,U){const{host:j,port:B,connectionToken:z}=await P.addressProvider.getAddress();return{commit:P.commit,quality:P.quality,host:j,port:B,connectionToken:z,reconnectionToken:F,reconnectionProtocol:U,socketFactory:P.socketFactory,signService:P.signService,logService:P.logService}}async function m(P,F,U){return M(P,async j=>{const{protocol:B}=await n(j,s.CancellationToken.None);return new J(P,F,U,j.reconnectionToken,B)})}e.connectRemoteAgentManagement=m;async function D(P,F){return M(P,async U=>{const{protocol:j,debugPort:B}=await a(U,F,s.CancellationToken.None);return new H(P,F,U.reconnectionToken,j,B)})}e.connectRemoteAgentExtensionHost=D;async function M(P,F){for(let j=1;;j++)try{const B=(0,p.generateUuid)(),z=await o(P,B,null);return await F(z)}catch(B){if(j<5)P.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),P.logService.error(B);else throw P.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),P.logService.error(B),X.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(B)),B}}async function T(P,F,U){const j=await o(P,(0,p.generateUuid)(),null);return await c(j,{host:F,port:U},s.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(P){return(0,I.createCancelablePromise)(F=>new Promise((U,j)=>{const B=setTimeout(U,P*1e3);F.onCancellationRequested(()=>{clearTimeout(B),U()})}))}var $;(function(P){P[P.ConnectionLost=0]="ConnectionLost",P[P.ReconnectionWait=1]="ReconnectionWait",P[P.ReconnectionRunning=2]="ReconnectionRunning",P[P.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",P[P.ConnectionGain=4]="ConnectionGain",P[P.ConnectionHealthChanged=5]="ConnectionHealthChanged"})($=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class q{constructor(F,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=q;class ie{constructor(F,U,j,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.durationSeconds=j,this.c=B,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ie;class oe{constructor(F,U,j){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=oe;class ae{constructor(F,U,j){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=j,this.type=4}}e.ConnectionGainEvent=ae;class de{constructor(F,U){this.reconnectionToken=F,this.connectionHealth=U,this.type=5}}e.ConnectionHealthChangedEvent=de;class ce{constructor(F,U,j,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=j,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class X extends k.Disposable{static triggerPermanentFailure(F,U,j){this._permanentFailure=!0,this.f=F,this.g=U,this.h=j,this.i.forEach(B=>B.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(F=>F.s())}static debugPauseSocketWriting(){this.i.forEach(F=>F.w())}get k(){return this.c||X._permanentFailure}constructor(F,U,j,B,z){super(),this.n=F,this.p=U,this.reconnectionToken=j,this.protocol=B,this.r=z,this.j=this.B(new R.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ae(this.reconnectionToken,0,0)),this.B(B.onSocketClose(G=>{const re=se(this.n,this.reconnectionToken,!0);G?G.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${G.hadError}).`),G.error&&this.p.logService.error(G.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.p.logService.error(G.event)):this.p.logService.info(`${re} received socket close event.`),this.s()})),this.B(B.onSocketTimeout(G=>{const re=se(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(B.onHighRoundTripTime(G=>{const re=ne(this.n,this.reconnectionToken);this.p.logService.info(`${re} high roundtrip time: ${G.roundTripTime}ms (${G.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(B.onDidChangeConnectionHealth(G=>{this.j.fire(new de(this.reconnectionToken,G))})),X.i.push(this),this.B((0,k.toDisposable)(()=>{const G=X.i.indexOf(this);G>=0&&X.i.splice(G,1)})),this.k&&this.v(X.f,X.g,X.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const F=se(this.n,this.reconnectionToken,!0);this.p.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const B=j<U.length?U[j]:U[U.length-1];try{if(B>0){const G=N(B);this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,G)),this.p.logService.info(`${F} waiting for ${B} seconds before reconnecting...`);try{await G}catch{}}if(this.k){this.p.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this.p.logService.info(`${F} resolving connection...`);const z=await o(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${F} connecting to ${z.host}:${z.port}...`),await this.y(z,g(E)),this.p.logService.info(`${F} reconnected!`),this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this.p.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this.p.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.p.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((0,A.isCancellationError)(z)){this.p.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if(z instanceof b.RemoteAuthorityResolverError){this.p.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,b.RemoteAuthorityResolverError.isHandled(z));break}this.p.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this.k&&!this.m)}u(F,U,j){this.r?X.triggerPermanentFailure(F,U,j):this.v(F,U,j)}v(F,U,j){this.j.fire(new ce(this.reconnectionToken,F,U,j)),W(this.protocol)}w(){this.protocol.pauseSocketWriting()}}X._permanentFailure=!1,X.f=0,X.g=0,X.h=!1,X.i=[],e.PersistentConnection=X;class J extends X{constructor(F,U,j,B,z){super(1,F,B,z,!0),this.client=this.B(new y.Client(z,{remoteAuthority:U,clientId:j},F.ipcLogger))}async y(F,U){await n(F,U)}}e.ManagementPersistentConnection=J;class H extends X{constructor(F,U,j,B,z){super(2,F,j,B,!1),this.z=U,this.debugPort=z}async y(F,U){await a(F,this.z,U)}}e.ExtensionHostPersistentConnection=H;function W(P){try{P.acceptDisconnect();const F=P.getSocket();P.dispose(),F.dispose()}catch(F){(0,A.onUnexpectedError)(F)}}function V(P){if(P&&P.type==="error"){const F=new Error(`Connection error: ${P.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function Y(P,F){for(;P.length<F;)P+=" ";return P}function ne(P,F){return`[remote-connection][${Y(r(P),13)}][${F.substr(0,5)}\u2026]`}function se(P,F,U){return`${ne(P,F)}[${U?"reconnect":"initial"}]`}function _(P,F){return`${se(F,P.reconnectionToken,!!P.reconnectionProtocol)}[${P.host}:${P.port}]`}function O(P){return`${Date.now()-P} ms`}}),define(ee[236],te([0,1,84,88]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(s,A,R,k,f,u){const p=b=>u(b,void 0),y=I.createConnection({host:s,port:A},()=>{y.removeListener("error",p);const b=Buffer.alloc(16);for(let r=0;r<16;r++)b[r]=Math.round(Math.random()*256);const d=b.toString("base64"),E=[`GET ws://${/:/.test(s)?`[${s}]`:s}:${A}${R}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];y.write(E.join(`\r
`)+`\r
\r
`);const v=r=>{r.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",v),u(void 0,new L.NodeSocket(y,f)))};y.on("data",v)});y.setNoDelay(!0),y.once("error",p)}}}),define(ee[237],te([0,1,27,46,41,196]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function k(d=!1){return(R===void 0||d)&&(R=f()),R}e.hasWSLFeatureInstalled=k;async function f(){const d=u();if(d===void 0)return!1;if(d>=22e3){const E=y();if(E)return new Promise(v=>{L.execFile(E,["--status"],r=>v(!r))})}else{const E=b();if(E)try{if((await s.promises.stat(E)).isFile())return!0}catch{}}return!1}function u(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(d)return parseInt(d[3])}function p(d){const E=process.env.SystemRoot;if(E){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(E,v?"Sysnative":"System32",d)}}function y(){return p("wsl.exe")}function b(){return p("lxss\\LxssManager.dll")}}),define(ee[52],te([0,1,17,13,2,179,68,6,5,51]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class p{constructor(C){this.b=C}toJSON(){if(!this.a){const C=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.b[t];this.a=C}return this.a}}class y extends s.Disposable{constructor(C,t){super(),this.b=0,this.a=t.createLogger(C?"remotenetwork":"network",{name:C?(0,A.localize)(0,null):(0,A.localize)(1,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async c(C,t,l){const i=`${C} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new p(t.headers??{}));try{const n=await l();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,L.getErrorMessage)(n)),n}}}e.AbstractRequestService=y;function b(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=b;function d(w){return w.res.statusCode===204}async function E(w){return d(w)?null:(await(0,I.streamToBuffer)(w.stream)).toString()}e.asText=E;async function v(w){if(!b(w))throw new Error("Server returned "+w.res.statusCode);return E(w)}e.asTextOrError=v;async function r(w){if(!b(w))throw new Error("Server returned "+w.res.statusCode);if(d(w))return null;const t=(await(0,I.streamToBuffer)(w.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.asJson=r;function g(w){S(w)}e.updateProxyConfigurationsScope=g;let h;function S(w){const C=u.Registry.as(R.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[h],remove:t?[t]:[]})}S(1)}),define(ee[238],te([0,1,17,23]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class s{constructor(k){this.a=k}listen(k,f){throw new Error("Invalid listen")}call(k,f,u,p=L.CancellationToken.None){switch(f){case"request":return this.a.request(u[0],p).then(async({res:y,stream:b})=>{const d=await(0,I.streamToBuffer)(b);return[{statusCode:y.statusCode,headers:y.headers},d]});case"resolveProxy":return this.a.resolveProxy(u[0])}throw new Error("Invalid call")}}e.RequestChannel=s;class A{constructor(k){this.a=k}async request(k,f){const[u,p]=await this.a.call("request",[k],f);return{res:u,stream:(0,I.bufferToStream)(p)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(ee[239],te([0,1,240,11]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function s(R,k){return R.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:R.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(R,k,f={}){const u=(0,I.parse)(R),p=f.proxyUrl||s(u,k);if(!p)return null;const y=(0,I.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const b={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((d,E)=>{x(["http-proxy-agent"],d,E)}))(b):new(await new Promise((d,E)=>{x(["https-proxy-agent"],d,E)}))(b)}e.getProxyAgent=A}),define(ee[116],te([0,1,46,9,180,23,44,13,4,31,153,62,7,132]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function v(g,h,S,w){return S["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(w)&&!S["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(w)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=b.Promises.withAsyncBody(async(C,t)=>{const l=new A.CancellationTokenSource;let i=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.clamp)(n,1,120)*1e3);const a=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},i);try{C(await r(h,l.token))}catch(c){!(0,k.isCancellationError)(c)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,R.toErrorMessage)(c)))):C({})}finally{clearTimeout(a),l.dispose()}})),E)}e.getResolvedShellEnv=v;async function r(g,h){const S=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",S);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",w);const C=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const i=await(0,p.getSystemShell)(f.OS,l);return g.trace("getUnixShellEnvironment#shell",i),new Promise((n,a)=>{if(h.isCancellationRequested)return a(new k.CancellationError);const c=(0,L.basename)(i);let o,m;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${D} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,m=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,c==="tcsh"||c==="csh"?m=["-ic"]:m=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),o);const M=(0,I.spawn)(i,[...m,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});h.onCancellationRequested(()=>(M.kill(),a(new k.CancellationError))),M.on("error",$=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)($)),a($)});const T=[];M.stdout.on("data",$=>T.push($));const N=[];M.stderr.on("data",$=>N.push($)),M.on("close",($,q)=>{const ie=Buffer.concat(T).toString("utf8");g.trace("getUnixShellEnvironment#raw",ie);const oe=Buffer.concat(N).toString("utf8");if(oe.trim()&&g.trace("getUnixShellEnvironment#stderr",oe),$||q)return a(new Error((0,s.localize)(2,null,$,q)));const ae=t.exec(ie),de=ae?ae[1]:"{}";try{const ce=JSON.parse(de);S?ce.ELECTRON_RUN_AS_NODE=S:delete ce.ELECTRON_RUN_AS_NODE,w?ce.ELECTRON_NO_ATTACH_CONSOLE=w:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ce)),a(ce)}})})}}),define(ee[93],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[241],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((s,A)=>x(["vsda"],s,A))}async createNewMessage(s){try{const A=await this.c(),R=new A.validator;if(R){const k=String(I.a++);return this.b.set(k,R),{id:k,data:R.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,A){if(!s.id)return!0;const R=this.b.get(s.id);if(!R)return!1;this.b.delete(s.id);try{return R.validate(A)==="ok"}catch{return!1}}async sign(s){try{const A=await this.c(),R=new A.signer;if(R)return R.sign(s)}catch{}return s}}I.a=1,e.SignService=I}),define(ee[33],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[20],te([0,1,14,42,7,3,2,4,36,11,6,5,33,28]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var E;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(E=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let r=class dt extends R.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(h,S,w){super(),this.v=h,this.w=S,this.y=w,this.c=this.B(new A.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new A.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(dt.b),this.j&&this.w.removeItem(dt.b)}C(){const h=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",h);const S=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",S),I.app.once("will-quit",w=>{this.L("Lifecycle#app.on(will-quit) - begin"),w.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),I.app.removeListener("before-quit",h),I.app.removeListener("window-all-closed",S),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}D(h){if(this.s)return this.s;const S=this.v;this.L("Lifecycle#onWillShutdown.fire()");const w=[];return this.f.fire({reason:h,join(C,t){S.trace(`Lifecycle#onWillShutdown - begin '${C}'`),w.push(t.finally(()=>{S.trace(`Lifecycle#onWillShutdown - end '${C}'`)}))}}),this.s=(async()=>{try{await s.Promises.settled(w)}catch(C){this.v.error(C)}try{await this.w.close()}catch(C){this.v.error(C)}})(),this.s}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===h)return;this.L(`lifecycle (main): phase changed (value: ${h})`),this.k=h;const S=this.u.get(this.k);S&&(S.open(),this.u.delete(this.k))}async when(h){if(h<=this.k)return;let S=this.u.get(h);S||(S=new s.Barrier,this.u.set(h,S)),await S.wait()}registerWindow(h){const S=new R.DisposableStore;this.n++,S.add(h.onWillLoad(C=>this.g.fire({window:h,workspace:C.workspace,reason:C.reason})));const w=(0,u.assertIsDefined)(h.win);w.on("close",C=>{const t=h.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${h.id}`),C.preventDefault(),this.unload(h,1).then(l=>{if(l){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(h),h.close()})}),w.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.n--,S.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(h,S){await this.unload(h,3)||h.reload(S)}unload(h,S){const w=this.t.get(h.id);if(w)return w;const C=this.F(h,S).finally(()=>{this.t.delete(h.id)});return this.t.set(h.id,C),C}async F(h,S){if(!h.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${h.id}`);const w=this.i?2:S,C=await this.I(h,w);return C?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.G(C)):(await this.J(h,w),!1)}G(h){return h?(this.H(!0),this.i=!1,!0):!1}H(h){this.r&&(this.r(h),this.r=void 0,this.p=void 0)}I(h,S){return new Promise(w=>{const C=this.m++,t=`vscode:ok${C}`,l=`vscode:cancel${C}`;L.validatedIpcMain.once(t,()=>{w(!1)}),L.validatedIpcMain.once(l,()=>{w(!0)}),h.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:l,reason:S})})}J(h,S){return new Promise(w=>{const t=`vscode:reply${this.m++}`;L.validatedIpcMain.once(t,()=>w()),h.send("vscode:onWillUnload",{replyChannel:t,reason:S})})}quit(h){return this.L(`Lifecycle#quit() - begin (willRestart: ${h})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(h&&this.w.setItem(dt.b,!0),this.p=new Promise(S=>{this.r=S,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(h){this.y.args["enable-smoke-test-driver"]?this.v.info(h):this.v.trace(h)}async relaunch(h){this.L("Lifecycle#relaunch()");const S=process.argv.slice(1);if(h?.addArgs&&S.push(...h.addArgs),h?.removeArgs)for(const t of h.removeArgs){const l=S.indexOf(t);l>=0&&S.splice(l,1)}const w=()=>{try{if(k.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:S})};I.app.once("quit",w),await this.quit(!0)&&I.app.removeListener("quit",w)}async kill(h){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,s.timeout)(1e3),(async()=>{for(const S of I.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let w;S.webContents&&!S.webContents.isDestroyed()?w=new Promise(C=>S.once("closed",C)):w=Promise.resolve(),S.destroy(),await w}})()]),I.app.exit(h)}};r.b="lifecycle.quitAndRestart",r=ye([Q(0,y.ILogService),Q(1,b.IStateService),Q(2,d.IEnvironmentMainService)],r),e.LifecycleMainService=r}),define(ee[242],te([0,1,4,3,2,6,20]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let k=class extends s.Disposable{constructor(p){super(),this.a=this.B(new L.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((y,b)=>{x(["native-keymap"],y,b)});this.c=f(p),I.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=f(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ye([Q(0,R.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function f(u){const p=u.getKeyMap(),y=u.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:y}}}),define(ee[117],te([0,1,7,17,11,34,16,5]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(f=e.SaveStrategy||(e.SaveStrategy={}));class u{constructor(d,E,v,r){this.f=d,this.g=v,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=E===0?void 0:new I.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,E){const v=this.a[d];return(0,s.isUndefinedOrNull)(v)?E:v}setItem(d,E){this.setItems([{key:d,data:E}])}setItems(d){let E=!1;for(const{key:v,data:r}of d)this.a[v]!==r&&((0,s.isUndefinedOrNull)(r)?(0,s.isUndefined)(this.a[v])||(this.a[v]=void 0,E=!0):(this.a[v]=r,E=!0));E&&this.j()}removeItem(d){(0,s.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(d)),this.b=d}catch(E){this.g.error(E)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=u;let p=class{constructor(d,E,v,r){this.a=new u(E.stateResource,d,v,r)}async init(){await this.a.init()}getItem(d,E){return this.a.getItem(d,E)}};p=ye([Q(1,A.IEnvironmentService),Q(2,k.ILogService),Q(3,R.IFileService)],p),e.StateReadonlyService=p;class y extends p{setItem(d,E){this.a.setItem(d,E)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=y}),define(ee[94],te([0,1,4,36,31]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(f){if(I.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,u,p,y,b,d,E,v){const r=Object.create(null);r["common.machineId"]=d,r.sessionID=(0,s.generateUuid)()+Date.now(),r.commitHash=y,r.version=b,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,I.PlatformToString)(I.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=p,r["common.product"]=v||"desktop",E&&(r["common.msftInternal"]=E);let g=0;const h=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),I.isLinuxSnap&&(r["common.snap"]="true");const S=A(u);return S&&(r["common.platformDetail"]=S),r}e.resolveCommonProperties=R;function k(f){const u=L.env.USERDNSDOMAIN;if(!u)return!1;const p=u.toLowerCase();return f.some(y=>p===y)}e.verifyMicrosoftInternalDomain=k}),define(ee[25],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var s;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(s=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[243],te([0,1,27,7,43,15,9,4,8,86,24,104,89,16,21,25]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function g(t,l){const i=`${t}::${l.join(":")}`,n=r.get(i);if(n)return n;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,m=2e4;function D(T,N,$,q){const ie=N.substring(T.length+1);return L.Promises.withAsyncBody(async oe=>{let ae;try{ae=await p.Promises.readdir(N,{withFileTypes:!0})}catch{oe();return}if(q.count>=m){q.count+=ae.length,q.maxReached=!0,oe();return}let de=ae.length;if(de===0){oe();return}let ce=ae;q.count+ae.length>m&&(q.maxReached=!0,de=m-q.count,ce=ae.slice(0,de)),q.count+=ae.length;for(const X of ce)if(X.isDirectory()){if($.includes(X.name)||await D(T,(0,R.join)(N,X.name),$,q),--de===0){oe();return}}else{const J=X.name.lastIndexOf(".");if(J>=0){const H=X.name.substring(J+1);H&&c.set(H,(c.get(H)??0)+1)}for(const H of a)H.relativePathPattern?.test(ie)!==!1&&H.filePattern.test(X.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--de===0){oe();return}}})}const M=L.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await D(t,t,l,N);const $=await w(t);T({configFiles:h(o),fileTypes:h(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:$})});return r.set(i,M),M}e.collectWorkspaceStats=g;function h(t){return Array.from(t.entries(),([l,i])=>({name:l,count:i})).sort((l,i)=>i.count-l.count)}function S(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},l=I.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.getMachineInfo=S;async function w(t){try{const l=new Map,i=(0,R.join)(t,".vscode","launch.json"),n=await p.Promises.readFile(i),a=[],c=(0,s.parse)(n.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,s.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const m=o.type;m&&(l.has(m)?l.set(m,l.get(m)+1):l.set(m,1))}return h(l)}catch{return[]}}e.collectLaunchConfigs=w;let C=class{constructor(l,i){this.c=l,this.d=i}f(l){const i=[];return i.push(`OS Version:       ${l.os}`),i.push(`CPUs:             ${l.cpus}`),i.push(`Memory (System):  ${l.memory}`),i.push(`VM:               ${l.vmHint}`),i.join(`
`)}g(l){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const n=I.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${I.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${l.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(l,i){return Promise.all([(0,y.listProcesses)(l.mainPID),this.k(l)]).then(async n=>{let[a,c]=n,o=this.m(l,a);return i.forEach(m=>{if((0,b.isRemoteDiagnosticError)(m))o+=`
${m.errorMessage}`,c+=`
${m.errorMessage}`;else if(o+=`

Remote: ${m.hostName}`,m.processes&&(o+=`
${this.m(l,m.processes)}`),m.workspaceMetadata){c+=`
|  Remote: ${m.hostName}`;for(const D of Object.keys(m.workspaceMetadata)){const M=m.workspaceMetadata[D];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${D}): ${T}`,c+=this.h(M)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(l,i){const{memory:n,vmHint:a,os:c,cpus:o}=S(),m={os:c,memory:n,cpus:o,vmHint:a,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(m.load=`${I.loadavg().map(D=>Math.round(D)).join(", ")}`),k.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(l,i){const n=[];return(0,y.listProcesses)(l.mainPID).then(async a=>(n.push(""),n.push(this.g(l)),n.push(""),n.push(this.m(l,a)),l.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(l))),i.forEach(c=>{if((0,b.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.f(c.machineInfo)),c.processes&&n.push(this.m(l,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const m=c.workspaceMetadata[o];let D=`${m.fileCount} files`;m.maxFilesReached&&(D=`more than ${D}`),n.push(`Folder (${o}): ${D}`),n.push(this.h(m))}}),n.push(""),n.push(""),n.join(`
`)))}h(l){const i=[];let a=0;const c=(M,T)=>{const N=` ${M}(${T})`;a+N.length>60?(i.push(o),o="|                 ",a=o.length):a+=N.length,o+=N};let o="|      File types:";const m=10,D=l.fileTypes.length>m?m:l.fileTypes.length;for(let M=0;M<D;M++){const T=l.fileTypes[M];c(T.name,T.count)}if(i.push(o),l.configFiles.length>=0&&(o="|      Conf files:",a=0,l.configFiles.forEach(M=>{c(M.name,M.count)}),i.push(o)),l.launchConfigFiles.length>0){let M="|      Launch Configs:";l.launchConfigFiles.forEach(T=>{M+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(M)}return i.join(`
`)}j(l){const i=Math.max(...Object.keys(l).map(n=>n.length));return Object.keys(l).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${l[n]}`).join(`
                  `)}k(l){const i=[],n=[];return l.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const o=f.URI.revive(c);if(o.scheme===A.Schemas.file){const m=o.fsPath;n.push(g(m,["node_modules",".git"]).then(D=>{let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,R.basename)(m)}): ${M}`),i.push(this.h(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${D.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(l,i){const n=new Map;l.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),l.pidToNames.forEach(({pid:c,name:o})=>n.set(c,o));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.n(l.mainPID,n,a,i,0),a.join(`
`)}n(l,i,n,a,c){const o=c===0;let m;o?m=a.pid===l?`${this.d.applicationName} main`:"remote agent":i.has(a.pid)?m=i.get(a.pid):m=`${"  ".repeat(c)} ${a.name}`;const D=process.platform==="win32"?a.mem:I.totalmem()*(a.mem/100);n.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(a.children)&&a.children.forEach(M=>this.n(l,i,n,M,c+1))}async getWorkspaceFileExtensions(l){const i=new Set;for(const{uri:n}of l.folders){const a=f.URI.revive(n);if(a.scheme!==A.Schemas.file)continue;const c=a.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(m=>i.add(m.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(l){for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==A.Schemas.file)continue;const a=n.fsPath;try{const c=await g(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};C=ye([Q(0,v.ITelemetryService),Q(1,E.IProductService)],C),e.DiagnosticsService=C}),define(ee[244],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(A){this.b=A}listen(A,R){throw new Error(`Event not found: ${R}`)}call(A,R,{eventName:k,data:f}){return this.b.forEach(u=>u.log(k,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class L{constructor(A){this.b=A}log(A,R){return this.b.call("log",{eventName:A,data:R}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[48],te([0,1,37,11,3,19,57,94,25]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(a){this.value=a}}e.TelemetryTrustedValue=u;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class y{async publicLog(a,c,o){}async publicLogError(a,c,o){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(n,a){return s.Event.debounce(a.onDidChangeConfiguration,(o,m)=>{const D=o?new Set([...o.affectedKeys,...m.affectedKeys]):m.affectedKeys;return{...m,affectedKeys:D}},1e3,!0)(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.configurationTelemetry=b;function d(n,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!n.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=d;function E(n,a){return!(a.isBuilt||a.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=E;function v(n){const a=n.getValue(f.TELEMETRY_SETTING_ID),c=n.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function r(n){const a={},c={},o={};S(n,o);for(let m in o){m=m.length>150?m.substr(m.length-149):m;const D=o[m];typeof D=="number"?c[m]=D:typeof D=="boolean"?c[m]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${D.length}`),a[m]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(a[m]=D)}return{properties:a,measurements:c}}e.validateTelemetryData=r;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(n){if(!n)return"none";const a=(0,R.getRemoteName)(n);return g.has(a)?a:"other"}e.cleanRemoteAuthority=h;function S(n,a,c=0,o){if(!!n)for(const m of Object.getOwnPropertyNames(n)){const D=n[m],M=o?o+m:m;Array.isArray(D)?a[M]=(0,I.safeStringify)(D):D instanceof Date?a[M]=D.toISOString():(0,L.isObject)(D)?c<2?S(D,a,c+1,M+"."):a[M]=(0,I.safeStringify)(D):a[M]=D}}function w(n,a){const c=n.msftInternalDomains||[],o=a.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(c)||o}e.isInternalTelemetry=w;function C(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=C;function t(n,a){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let c=n;const o=[];for(const T of a)for(;;){const N=T.exec(n);if(!N)break;o.push([N.index,T.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(c="";;){const T=D.exec(n);if(!T)break;const N=o.some(([$,q])=>T.index<q&&$<D.lastIndex);!m.test(T[0])&&!N&&(c+=n.substring(M,T.index)+"<REDACTED: user-file-path>",M=D.lastIndex)}return M<n.length&&(c+=n.substr(M)),c}function l(n){if(!n)return n;const a=n.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of c)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return n}function i(n,a){return(0,I.cloneAndChange)(n,c=>{if(c instanceof u)return c.value;if(typeof c=="string"){let o=c.replaceAll("%20"," ");o=t(o,a);for(const m of a)o=o.replace(m,"");return o=l(o),o}})}e.cleanData=i}),define(ee[118],te([0,1,26,111,115,4,8,13,36,48]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,I.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=p;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const a=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,a,c)}static parse(n){const a=y.exec(n);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=b;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=d.exec(i);return n&&n[1]?[r(n[1]),n[2]]:[r(i),void 0]}e.getIdAndVersion=E;function v(i,n){return`${i}.${n}`}e.getExtensionId=v;function r(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function g(i,n){return r(v(i??s.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=g;function h(i,n){const a=[],c=o=>{for(const m of a)if(m.some(D=>p(n(D),n(o))))return m;return null};for(const o of i){const m=c(o);m?m.push(o):a.push([o])}return a}e.groupByExtension=h;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new s.ExtensionIdentifier("pprice.better-merge");function C(i,n){const a=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const o=c.shift();if(o&&a.every(m=>!p(m.identifier,{id:o}))){const m=i.filter(D=>p(D.identifier,{id:o}));m.length===1&&(a.push(m[0]),c.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=C;async function t(i,n){if(!A.isLinux)return!1;let a;try{a=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(o))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(i,n){const a=await t(i,n),c=(0,L.getTargetPlatform)(a?"alpine":A.platform,f.arch);return n.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=l}),define(ee[245],te([0,1,201,48]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function s(A,R,k,f,u,p,y){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,k)&&(0,L.getTelemetryLevel)(f)===3){const d=await(0,I.getServiceMachineId)(k,u,p);b["X-Market-User-Id"]=d,b["VSCode-SessionId"]=y.machineId||d}return b}e.resolveMarketplaceHeaders=s}),define(ee[246],te([0,1,13,37,48]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function k(u,p,y){const b=await new Promise((g,h)=>{x(["@microsoft/1ds-core-js"],g,h)}),d=await new Promise((g,h)=>{x(["@microsoft/1ds-post-js"],g,h)}),E=new b.AppInsightsCore,v=new d.PostChannel,r={instrumentationKey:u,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(y){r.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:y};r.extensionConfig[v.identifier]=g}return E.initialize(r,[]),E.addTelemetryInitializer(g=>{p&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),E}class f{constructor(p,y,b,d,E){this.e=p,this.f=y,this.g=b,this.h=E,this.c=A,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(y=>{p(y)},y=>{(0,I.onUnexpectedError)(y),console.error(y)})}}log(p,y){if(!this.a)return;y=(0,L.mixin)(y,this.g),y=(0,s.validateTelemetryData)(y);const b=this.f+"/"+p;try{this.i(d=>{d.pluginVersionString=y?.properties.version??"Unknown",d.track({name:b,baseData:{name:b,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[119],te([0,1,2,37,4,26,181,19,68,66,21,51,25,48]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,h,S){this.k=h,this.l=S,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(b.TELEMETRY_SETTING_ID)||w.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||w.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,d.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const S=h.usage?3:h.error?2:0;g=Math.min(g,S)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,S){this.g<h||(S=(0,L.mixin)(S,this.d),S=(0,d.cleanData)(S,this.j),S=(0,L.mixin)(S,this.c),this.b.forEach(w=>w.log(g,S)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){!this.h||this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ye([Q(1,k.IConfigurationService),Q(2,p.IProductService)],E),e.TelemetryService=E;function v(){const r=(0,R.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.isWeb?"":(0,R.localize)(3,null),S=(0,R.localize)(4,null),w=(0,R.localize)(5,null),C=(0,R.localize)(6,null),t=(0,R.localize)(7,null),l=`
|       | ${S} | ${w} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${r} ${g} ${h}

&nbsp;

${t}
${l}

&nbsp;

${i}
`}y.Registry.as(f.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(f.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,R.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,R.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[247],te([0,1,295,246]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class s extends L.AbstractOneDataSystemAppender{constructor(R,k,f,u){const p={sendPOST:(y,b)=>{const d={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const E=I.request(y.urlString,d,v=>{v.on("data",function(r){b(v.statusCode??200,v.headers,r.toString())}),v.on("error",function(r){b(0,{})})});E.write(y.data),E.end()}catch{b(0,{})}}};super(R,k,f,u,p)}}e.OneDataSystemAppender=s}),define(ee[248],te([0,1,4,86,25]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(R,k){let f=R.getItem(s.machineIdKey);return(typeof f!="string"||I.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,L.getMachineId)(k.error.bind(k))),f}e.resolveMachineId=A}),define(ee[120],te([0,1,25,248]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function s(A,R){const k=await(0,L.resolveMachineId)(A,R);return A.setItem(I.machineIdKey,k),k}e.resolveMachineId=s}),define(ee[69],te([0,1,14,3,2,4,19,6,33]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const u="#FFFFFF",p="#1E1E1E",y="#000000",b="#FFFFFF",d="theme",E="themeBackground",v="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let r=class extends s.Disposable{constructor(h,S){super(),this.b=h,this.c=S,this.a=this.B(new L.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?y:b;let S=this.b.getItem(E,null);if(!S)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":S=u;break;case"hc-black":S=y;break;case"hc-light":S=b;break;default:S=p}return A.isMacintosh&&S.toUpperCase()===p&&(S="#171717"),S}saveWindowSplash(h,S){this.b.setItems([{key:d,data:S.baseTheme},{key:E,data:S.colorInfo.background},{key:v,data:S}]),typeof h=="number"&&this.f(h,S)}f(h,S){for(const w of I.BrowserWindow.getAllWindows())if(w.id===h){w.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};r=ye([Q(0,f.IStateService),Q(1,R.IConfigurationService)],r),e.ThemeMainService=r}),define(ee[121],te([0,1,3,19,6,5]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,s.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,s.createDecorator)("sharedTunnelsService");var R;(function(v){v.Http="http",v.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function u(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=u,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=y;function b(v,r,g,h){if(g===1)return!1;if(g===2&&y(r)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(S?.length===4&&parseInt(S[1])>=18)return!1}return v<1024}e.isPortPrivileged=b;class d{constructor(r,g,h){this.remoteAddress=r,this.localAddress=g,this.b=h,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let E=class{constructor(r,g){this.i=r,this.j=g,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],g=Array.from(this.d.values());for(const h of g){const S=Array.from(h.values());for(const w of S){const C=await w.value;C&&r.push(C)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:g}of r.values())await g.then(h=>h?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,g,h,S,w){this.o(r,g,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:g,localAddress:h,privacy:S,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,g){(y(r)||p(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const h=this.q(r,g);if(h)return++h.refcount,h.value}openTunnel(r,g,h,S,w,C=!1,t,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${h} on local port ${w}.`),!r)return;if(g||(g="localhost"),S||(S=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(r,g,h,S,w,C,t,l);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(g,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(n);return(n.tunnelRemoteHost!==g||n.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const g=this.d.get(r.tunnelRemoteHost);if(g){const h=g.get(r.tunnelRemotePort);h&&(h.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,h))}}}}async n(r,g,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${g}.`);const S=h.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(g),S}}async closeTunnel(r,g){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${g} `);const h=this.d.get(r);if(h&&h.has(g)){const S=h.get(g);S.refcount=0,await this.n(r,g,S)}}o(r,g,h){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(g,{refcount:1,value:h})}async p(r,g){const h=this.d.get(r);h&&(await h.get(g)||h.delete(g),h.size===0&&this.d.delete(r))}q(r,g){const h=[r];p(r)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):y(r)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const S=h.map(w=>this.d.get(w));for(const w of S){const C=w?.get(g);if(C)return C}}canTunnel(r){return!!u(r)}s(r,g,h,S,w,C,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${h} on local port ${S}.`);const l=h;this.h.add(l);const i=S===void 0?h:S,n={elevationRequired:w?this.isPortPrivileged(i):!1},a={remoteAddress:{host:g,port:h},localAddressPort:S,privacy:C,public:C?C!==k.Private:void 0,protocol:t},c=r.forwardPort(a,n);return c?(this.o(g,h,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),c}};E=ye([Q(0,A.ILogService),Q(1,L.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ee[249],te([0,1,84,27,101,236,7,2,19,5,21,235,121,93,4]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(w,C,t,l,i){let n;for(let a=3;a&&(n?.dispose(),n=await new r(w,C,t,l,i).waitForReady(),!(i&&s.BROWSER_RESTRICTED_PORTS[i]||!s.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));a--);return n}class r extends k.Disposable{constructor(C,t,l,i,n){super(),this.j=t,this.k=n,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=I.createServer(),this.c=new R.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let l=await(0,s.findFreePortFaster)(C,2,1e3,t),i=null;return this.b.listen(l,this.j),await this.c.wait(),i=this.b.address(),i||(l=0,this.b.listen(l,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(C){C.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,y.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&C.write(n.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),i.end()})}}let g=class extends b.AbstractTunnelService{constructor(C,t,l,i,n){super(t,n),this.t=C,this.u=l,this.v=i}isPortPrivileged(C){return(0,b.isPortPrivileged)(C,this.k,E.OS,L.release())}r(C,t,l,i,n,a,c,o){const m=this.q(t,l);if(m)return++m.refcount,m.value;if(this.e)return this.s(this.e,t,l,n,a,c,o);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${l} on local port ${n}.`);const D={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:C,signService:this.u,logService:this.i,ipcLogger:null},M=v(D,i,t,l,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,l,M),M}}};g=ye([Q(1,u.ILogService),Q(2,d.ISignService),Q(3,p.IProductService),Q(4,f.IConfigurationService)],g),e.BaseTunnelService=g;let h=class extends g{constructor(C,t,l,i){super(A.nodeSocketFactory,C,t,l,i)}};h=ye([Q(0,u.ILogService),Q(1,d.ISignService),Q(2,p.IProductService),Q(3,f.IConfigurationService)],h),e.TunnelService=h;let S=class extends k.Disposable{constructor(C,t,l,i){super(),this.b=C,this.c=t,this.f=l,this.g=i,this.a=new Map}async openTunnel(C,t,l,i,n,a,c,o,m){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${a}.`),!this.a.has(C)){const D=new h(this.b,this.f,this.c,this.g);this.B(D),this.a.set(C,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,l,i,n,a,c,o,m)}};S=ye([Q(0,u.ILogService),Q(1,p.IProductService),Q(2,d.ISignService),Q(3,f.IConfigurationService)],S),e.SharedTunnelsService=S}),define(ee[49],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L=e.StateType||(e.StateType={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,R)=>({type:"idle",updateType:A,error:R}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[250],te([0,1,4,182,68,51]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(s.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[251],te([0,1,3,49]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class s{constructor(k){this.a=k}listen(k,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=s;class A{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=L.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=A}),define(ee[95],te([0,1,7,23,3,19,28,20,5,21,52,49]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(E,v,r){return`${r.updateUrl}/api/update/${E}/${v}/${r.commit}`}e.createUpdateURL=b;let d=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,r,g,h,S,w){this.f=v,this.g=r,this.h=g,this.i=h,this.j=S,this.k=w,this.b=y.State.Uninitialized,this.c=new s.Emitter,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),r=this.m(v);if(!r){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(r),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(y.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,I.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},L.CancellationToken.None)).res.statusCode===204}catch(r){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(r);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};d=ye([Q(0,k.ILifecycleMainService),Q(1,A.IConfigurationService),Q(2,R.IEnvironmentMainService),Q(3,p.IRequestService),Q(4,f.ILogService),Q(5,u.IProductService)],d),e.AbstractUpdateService=d}),define(ee[252],te([0,1,14,55,3,2,19,28,20,5,21,52,25,49,95]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends E.AbstractUpdateService{get v(){return s.Event.fromNodeEventEmitter(I.autoUpdater,"error",(g,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(g,h,S)=>({url:h,version:S,productVersion:S}))}get y(){return s.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(g,h,S,w)=>({releaseNotes:h,version:S,productVersion:S,date:w}))}constructor(g,h,S,w,C,t,l){super(g,h,w,C,t,l),this.z=S,this.u=new A.DisposableStore}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const S=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.d(d.State.Idle(1,S))}s(g){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,E.createUpdateURL)(h,g,this.k);try{I.autoUpdater.setFeedURL({url:S})}catch(w){this.j.error("Failed to set update feed URL",w);return}return S}t(g){this.d(d.State.CheckingForUpdates(g)),I.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(d.State.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(d.State.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};ye([L.memoize],v.prototype,"v",null),ye([L.memoize],v.prototype,"w",null),ye([L.memoize],v.prototype,"x",null),ye([L.memoize],v.prototype,"y",null),v=ye([Q(0,f.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,b.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,y.IRequestService),Q(5,u.ILogService),Q(6,p.IProductService)],v),e.DarwinUpdateService=v}),define(ee[253],te([0,1,46,41,7,3,9,28,20,5,25,49]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,r,g){if(this.f=v,this.g=g,this.a=y.State.Uninitialized,this.b=new A.Emitter,this.onStateChange=this.b.event,r.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.State.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(v=60*60*1e3){return(0,s.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};b=ye([Q(0,f.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,u.ILogService)],b);let d=class extends b{constructor(v,r,g,h,S,w){super(g,h,S),this.o=v,this.p=r,this.q=w;const C=(0,L.watch)(R.dirname(this.o)),t=A.Event.fromNodeEventEmitter(C,"change",(a,c)=>c),l=A.Event.filter(t,a=>a==="current"),n=A.Event.debounce(l,(a,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),C.close()})}m(){this.d(y.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((g,h)=>(0,L.realpath)(`${R.dirname(this.o)}/current`,(S,w)=>S?h(S):g(w))),r=R.basename(v);return this.p!==r}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=ye([Q(2,f.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,u.ILogService),Q(5,p.ITelemetryService)],d),e.SnapUpdateService=d}),define(ee[39],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[254],te([0,1,39,202,16,18,133,3,2]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(b){this.uri=b,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let p=class{constructor(b){this.g=b,this.c=new f.DisposableStore,this.f=2**16;const d=new Map,E=v=>{let r=d.get(v.scheme);return r===void 0&&(r=b.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,r)),r};this.c.add(k.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new A.ExtUri(E),this.d=new R.SkipList((v,r)=>this.extUri.compare(v,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.normalizePath)(b));const d=this.d.get(b);return d?d.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new u(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((E,v)=>E[1].time<v[1].time?1:E[1].time>v[1].time?-1:0);u._clock=0,this.d.clear();const d=this.f*.5;for(let E=0;E<d;E++)this.d.set(b[E][0],b[E][1].touch())}};p=ye([Q(0,s.IFileService)],p),e.UriIdentityService=p,(0,L.registerSingleton)(I.IUriIdentityService,p,1)}),define(ee[122],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[255],te([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(k){this.a=k}listen(k,f){throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"handleURL":return this.a.handleURL(I.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class s{constructor(k){this.a=k}handleURL(k,f){return this.a.call("handleURL",[k.toJSON(),f])}}e.URLHandlerChannelClient=s;class A{constructor(k,f){this.a=k,this.b=f}async routeCall(k,f,u,p){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const y=I.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const b=/\bwindowId=(\d+)/.exec(y.query);if(b){const d=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,y.toString(!0));const E=new RegExp(`window:${d}`),v=k.connections.find(r=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",r.ctx),E.test(r.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,f,u,p)}routeEvent(k,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=A}),define(ee[256],te([0,1,7,2,8,21]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.a=new Set}open(u,p){const y=[...this.a.values()];return(0,I.first)(y.map(b=>()=>b.handleURL(u,p)),void 0,!1).then(b=>b||!1)}registerHandler(u){return this.a.add(u),(0,L.toDisposable)(()=>this.a.delete(u))}}e.AbstractURLService=R;let k=class extends R{constructor(u){super(),this.b=u}create(u){let{authority:p,path:y,query:b,fragment:d}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&y&&y.indexOf("/")!==0&&(y=`/${y}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:y,query:b,fragment:d})}};k=ye([Q(0,A.IProductService)],k),e.NativeURLService=k}),define(ee[257],te([0,1,14,7,3,2,4,8]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(p,y,b,d,E,v){if(this.f=y,this.g=v,this.a=[],this.b=0,this.c=A.Disposable.None,this.d=new A.DisposableStore,p&&(v.trace("ElectronURLListener initialUrisToHandle:",p.map(h=>h.originalUrl)),this.a=p),R.isWindows){const h=d.isBuilt?[]:[`"${d.appRoot}"`];h.push("--open-url","--"),I.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,h)}const r=s.Event.map(s.Event.fromNodeEventEmitter(I.app,"open-url",(h,S)=>({event:h,url:S})),({event:h,url:S})=>(h.preventDefault(),S));this.d.add(r(h=>{const S=this.h(h);!S||this.f.open(S,{originalUrl:h})})),b.getWindows().filter(h=>h.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(p){try{return k.URI.parse(p)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),p.push(y));p.length!==0&&(this.a=p,this.c=(0,L.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(ee[258],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[259],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[260],te([0,1,14,2,15,8]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{constructor(){super();const f=this.b.bind(this);I.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,u){try{const p=A.URI.parse(f.url),y=R.a.get(p.path);if(typeof y=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${y}`,d=s.FileAccess.asFileUri(b);return u({path:decodeURIComponent(d.fsPath),headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}R.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=R}),define(ee[79],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(p){return!!p.workspaceUri}e.isWorkspaceToOpen=L;function s(p){return!!p.folderUri}e.isFolderToOpen=s;function A(p){return!!p.fileUri}e.isFileToOpen=A;function R(p){const y=k(p),b=p.getValue("window.menuBarVisibility");return b==="default"||y==="native"&&b==="compact"||I.isMacintosh&&I.isNative?"classic":b}e.getMenuBarVisibility=R;function k(p){if(I.isWeb)return"custom";const y=p.getValue("window");if(y){if(I.isMacintosh&&y.nativeTabs===!0||I.isMacintosh&&y.nativeFullScreen===!1)return"native";const E=y.titleBarStyle;if(E==="native"||E==="custom")return E}return I.isLinux?"native":"custom"}e.getTitleBarStyle=k;function f(p){if(!I.isWindows||I.isWeb||k(p)==="native")return!1;const y=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!0}e.useWindowControlsOverlay=f;function u(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=u}),define(ee[123],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var L;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(L=e.UnloadReason||(e.UnloadReason={}));const s=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=s;var A;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(A=e.WindowMode||(e.WindowMode={}));var R;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(R=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var L;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}))}),define(ee[261],te([0,1,14,23,3,56,2,31,77,110,5,21,30]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let E=class extends R.Disposable{constructor(r,g,h,S,w){super(),this.g=r,this.h=g,this.i=h,this.j=S,this.k=w,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=d.Initial,this.f=void 0,this.l()}l(){const r=s.Event.fromNodeEventEmitter(I.app,"login",(g,h,S,w,C)=>({event:g,webContents:h,req:S,authInfo:w,callback:C}));this.B(r(this.m,this))}async m({event:r,authInfo:g,req:h,callback:S}){if(!g.isProxy)return;if(!this.b&&this.c===d.LoginDialogShown&&h.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}r.preventDefault();let w;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(g);try{w=await this.b}finally{this.b=void 0}}S(w?.username,w?.password)}async n(r){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.p(r);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(r){this.g.trace("auth#doResolveProxyCredentials - enter",r);const g=String((0,A.hash)({scheme:r.scheme,host:r.host,port:r.port}));let h,S;try{const l=await this.i.getPassword(this.a,g);if(l){const i=JSON.parse(await this.j.decrypt(l));h=i.username,S=i.password}}catch(l){this.g.error(l)}if(this.c!==d.StoredCredentialsUsed&&typeof h=="string"&&typeof S=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=d.StoredCredentialsUsed,{username:h,password:S};const w=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!w){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const C={authInfo:r,username:this.f?.username??h,password:this.f?.password??S,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,C),this.c=d.LoginDialogShown;const t=await new Promise(l=>{const i=async(n,a,c)=>{if(a===C.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",i),c){const o={username:c.username,password:c.password};try{if(c.remember){const m=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,g,m)}else await this.i.deletePassword(this.a,g)}catch(m){this.g.error(m)}l({username:o.username,password:o.password})}else l(void 0)};w.win?.webContents.on("ipc-message",i)});return this.f=t,t}};E=ye([Q(0,p.ILogService),Q(1,b.IWindowsMainService),Q(2,f.ICredentialsMainService),Q(3,u.IEncryptionMainService),Q(4,y.IProductService)],E),e.ProxyAuthHandler=E}),define(ee[262],te([0,1,77,5,34,21,30,214]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends k.BaseCredentialsMainService{constructor(p,y,b,d){super(p),this.n=y,this.p=b,this.r=d,this.j=E=>{this.r.sendToFocused("vscode:showCredentialsError",E.message??E)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const p=await new Promise((y,b)=>{x(["keytar"],y,b)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};f=ye([Q(0,L.ILogService),Q(1,s.INativeEnvironmentService),Q(2,A.IProductService),Q(3,R.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[263],te([0,1,14,22,4,8,24,19,62,6,5,122,30]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,u.createDecorator)(e.ID);let d=class{constructor(v,r,g,h){this.a=v,this.b=r,this.c=g,this.d=h}async start(v,r){this.a.trace("Received data from other instance: ",v,r),s.isMacintosh&&I.app.focus({steal:!0});const g=this.e(v);if(g.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const S=(0,L.firstOrDefault)(await this.b.openEmptyWindow({context:4}));S&&(h=S.ready())}h.then(()=>{for(const{uri:S,originalUrl:w}of g)this.c.open(S,{originalUrl:w})})}else return this.f(v,r)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,L.coalesce)(v._urls.map(r=>{try{return{uri:A.URI.parse(r),originalUrl:r}}catch{return null}})):[]}async f(v,r){const g=(0,f.isLaunchedFromCli)(r)?0:4;let h=[];const S=v.wait&&v.waitMarkerFilePath?A.URI.file(v.waitMarkerFilePath):void 0,w=v.remote||void 0,C={context:g,cli:v,userEnv:r,waitMarkerFileURI:S,remoteAuthority:w,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,C);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||C.forceProfile||C.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.isMacintosh}if(t)h=await this.b.open({...C,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,C),h=[l]):h=await this.b.open({...C,forceEmpty:!0})}}else h=await this.b.open({...C,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(S&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,R.whenDeleted)(S.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};d=ye([Q(0,p.ILogService),Q(1,b.IWindowsMainService),Q(2,y.IURLService),Q(3,k.IConfigurationService)],d),e.LaunchMainService=d}),define(ee[70],te([0,1,14,2,3,5,264,7,15,72,30,75,25,20,73,37]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function r(S){return typeof S.responseWindowId=="number"}let g=class ut extends L.Disposable{static getAll(){return Array.from(ut.b.values())}constructor(w,C,t){super(),this.n=w,this.p=C,this.r=t,this.c=String(++ut.a),this.f=this.B(new s.Emitter),this.onStdout=this.f.event,this.g=this.B(new s.Emitter),this.onStderr=this.g.event,this.h=this.B(new s.Emitter),this.onMessage=this.h.event,this.i=this.B(new s.Emitter),this.onExit=this.i.event,this.j=this.B(new s.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(w,C){let t;switch(this.m?.correlationId?t=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`:t=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`,C){case y.default.Error:this.n.error(t);break;case y.default.Warning:this.n.warn(t);break;case y.default.Info:this.n.info(t);break}}t(){if(!u.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");return this.k?(this.s("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(w){const C=this.u(w,!1);return C&&w.payload&&this.postMessage(w.payload),C}u(w,C){if(!this.t())return!1;this.m=w;const t=`${this.m.type}-${this.c}`,l=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.m.args??[],n=this.m.execArgv??[],a=this.m.allowLoadingUnsignedLibraries,c="pipe",o=this.v(w,C);return this.s("creating new...",y.default.Info),this.k=u.UtilityProcess.fork(l,i,{serviceName:t,env:o,execArgv:n,allowLoadingUnsignedLibraries:a,stdio:c}),this.w(this.k,this.m,t,C),!0}v(w,C){const t=w.env?{...w.env}:{...(0,v.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),C&&(t.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,(0,E.removeDangerousEnvVariables)(t);for(const l of Object.keys(t))t[l]=String(t[l]);return t}w(w,C,t,l){if(w.stdout){const i=new R.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(w.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(w.stderr){const i=new R.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(w.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(w,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.l=w.pid,typeof w.pid=="number"&&ut.b.set(w.pid,{pid:w.pid,name:r(C)?`${C.type} [${C.responseWindowId}]`:C.type}),this.s("successfully created",y.default.Info)})),this.B(s.Event.fromNodeEventEmitter(w,"exit")(i=>{this.s(`received exit event with code ${i}`,y.default.Info),this.i.fire({pid:this.l,code:i,signal:"unknown"}),this.y()})),this.B(s.Event.fromNodeEventEmitter(I.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===t&&(this.s(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.p.publicLog2("utilityprocesscrash",{type:C.type,reason:i.reason,code:i.exitCode,sandboxed:l?"1":"0"}),this.j.fire({pid:this.l,code:i.exitCode,reason:i.reason}),this.y())}))}once(w,C){const t=this.B(this.h.event(l=>{l===w&&(t.dispose(),C())}))}postMessage(w,C){!this.k||this.k.postMessage(w,C)}connect(w){const{port1:C,port2:t}=new I.MessageChannelMain;return this.postMessage(w,[t]),C}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",y.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",y.default.Info),this.k.kill()?(this.s("successfully killed the process",y.default.Info),this.y()):this.s("unable to kill the process",y.default.Warning)}y(){typeof this.l=="number"&&ut.b.delete(this.l),this.k=void 0}async waitForExit(w){!this.k||(this.s("waiting to exit...",y.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,k.timeout)(w)]),this.k&&(this.s(`did not exit within ${w}ms, will kill it now...`,y.default.Info),this.kill()))}};g.a=0,g.b=new Map,g=ye([Q(0,A.ILogService),Q(1,b.ITelemetryService),Q(2,d.ILifecycleMainService)],g),e.UtilityProcess=g;let h=class extends g{constructor(w,C,t,l){super(w,t,l),this.z=C}start(w){const C=this.z.getWindowById(w.responseWindowId);if(!C?.win||C.win.isDestroyed()||C.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.u(w,C.isSandboxed))return!1;this.C(C.win,w);const l=this.connect(w.payload);return C.win.webContents.postMessage(w.responseChannel,w.responseNonce,[l]),!0}C(w,C){C.windowLifecycleBound&&(this.B(s.Event.filter(this.r.onWillLoadWindow,t=>t.window.win===w)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};h=ye([Q(0,A.ILogService),Q(1,p.IWindowsMainService),Q(2,b.ITelemetryService),Q(3,d.ILifecycleMainService)],h),e.WindowUtilityProcess=h}),define(ee[265],te([0,1,13,2,3,5,20,74,46,264,7,15,37,4,36,72,70,30,25]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let S=class kt{constructor(t,l,i,n){this.d=t,this.f=l,this.g=i,this.h=n,this.c=!1,this.b=new Map,this.f.onWillShutdown(a=>{this.c=!0,a.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(t){const l=this.b.get(t);if(!l)throw new Error("Unknown extension host!");return l}onDynamicStdout(t){return this.i(t).onStdout}onDynamicStderr(t){return this.i(t).onStderr}onDynamicMessage(t){return this.i(t).onMessage}onDynamicError(t){const l=this.i(t);return l instanceof r.WindowUtilityProcess?s.Event.None:l.onError}onDynamicExit(t){return this.i(t).onExit}async canUseUtilityProcess(){return v.canUseUtilityProcess}async createExtensionHost(t){if(this.c)throw(0,I.canceled)();const l=String(++kt.a);let i;if(t){if(!v.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new r.WindowUtilityProcess(this.d,this.g,this.h,this.f)}else i=new w(l,this.d);return this.b.set(l,i),i.onExit(({pid:n,code:a,signal:c})=>{this.d.info(`Extension host with pid ${n} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{i.dispose(),this.b.delete(l)})}),{id:l}}async start(t,l){if(this.c)throw(0,I.canceled)();this.i(t).start({...l,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:l.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this.c)throw(0,I.canceled)();const l=this.b.get(t);return l?l.enableInspectPort():!1}async kill(t){if(this.c)throw(0,I.canceled)();const l=this.b.get(t);!l||l.kill()}async _killAllNow(){for(const[,t]of this.b)t.kill()}async _waitForAllExit(t){const l=[];for(const[,i]of this.b)l.push(i.waitForExit(t));return p.Promises.settled(l).then(()=>{})}};S.a=0,S=ye([Q(0,A.ILogService),Q(1,R.ILifecycleMainService),Q(2,g.IWindowsMainService),Q(3,h.ITelemetryService)],S),e.ExtensionHostStarter=S;let w=class extends L.Disposable{constructor(t,l){super(),this.id=t,this.c=l,this._onStdout=this.B(new s.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new s.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new s.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new s.Emitter),this.onError=this._onError.event,this._onExit=this.B(new s.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(t){d.isCI&&this.c.info("Calling fork to start extension host...");const l=k.StopWatch.create(!1);this.a=(0,f.fork)(y.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,E.cwd)()},t));const i=l.elapsed(),n=this.a.pid;this.c.info(`Starting extension host with pid ${n} (fork() took ${i} ms).`);const a=new u.StringDecoder("utf-8");this.a.stdout?.on("data",o=>{const m=typeof o=="string"?o:a.write(o);this._onStdout.fire(m)});const c=new u.StringDecoder("utf-8");this.a.stderr?.on("data",o=>{const m=typeof o=="string"?o:c.write(o);this._onStderr.fire(m)}),this.a.on("message",o=>{this._onMessage.fire(o)}),this.a.on("error",o=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(o)})}),this.a.on("exit",(o,m)=>{this.b=!0,this._onExit.fire({pid:n,code:o,signal:m})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):d.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(t){if(!this.a)return;const l=this.a.pid;this.c.info(`Waiting for extension host with pid ${l} to exit.`),await Promise.race([s.Event.toPromise(this.onExit),(0,p.timeout)(t)]),this.b||(this.c.info(`Extension host with pid ${l} did not exit within ${t}ms.`),this.a.kill())}};w=ye([Q(1,A.ILogService)],w)}),define(ee[266],te([0,1,2,6,5,30,70,25,56,3,7,20]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let b=class extends I.Disposable{constructor(v,r,g,h){super(),this.b=v,this.c=r,this.f=g,this.g=h,this.a=new Map}async createWorker(v){const r=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${r})`);const g=this.h(v);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${r})`),this.disposeWorker(v));const h=new d(this.b,this.c,this.f,this.g,v);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,h);const S=new p.DeferredPromise;return u.Event.once(h.onDidTerminate)(w=>{w.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${w.code}, signal: ${w.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${w.code}, signal: ${w.signal}`),this.a.delete(g),S.complete({reason:w})}),S.p}h(v){return(0,f.hash)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const r=this.h(v),g=this.a.get(r);!g||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g.kill(),this.a.delete(r))}};b=ye([Q(0,s.ILogService),Q(1,A.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,y.ILifecycleMainService)],b),e.UtilityProcessWorkerMainService=b;let d=class extends I.Disposable{constructor(v,r,g,h,S){super(),this.c=v,this.f=r,this.g=g,this.h=h,this.i=S,this.a=this.B(new u.Emitter),this.onDidTerminate=this.a.event,this.b=new R.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const r=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:r,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};d=ye([Q(0,s.ILogService),Q(1,A.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,y.ILifecycleMainService)],d)}),define(ee[267],te([0,1,14,3,2,260,30]),function(x,e,I,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends s.Disposable{constructor(u){super(),this.b=u,this.a=this.B(new L.Emitter),this.onFoundInFrame=this.a.event,this.B(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(u,p){let y;if(typeof u.windowId=="number"){const{windowId:b}=u,d=this.b.getWindowById(b);if(!d?.win)throw new Error(`Invalid windowId: ${b}`);y=d.win.webContents}else{const{webContentsId:b}=u;if(y=I.webContents.fromId(b),!y)throw new Error(`Invalid webContentsId: ${b}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(p)}async findInFrame(u,p,y,b){const E=this.c(u,p);if(typeof E.findInFrame=="function"){E.findInFrame(y,{findNext:b.findNext,forward:b.forward});const v=(r,g)=>{g.finalUpdate&&(this.a.fire(g),E.removeListener("found-in-frame",v))};E.on("found-in-frame",v)}}async stopFindInFrame(u,p,y){const d=this.c(u,p);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(u,p){const y=this.b.getWindowById(u.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${u}`);const b=y.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===p);if(!b)throw new Error(`Unknown frame: ${p}`);return b}};k=ye([Q(0,R.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[268],te([0,1,7,3,2]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends s.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.a=this.B(new s.DisposableStore),L.Event.latch(L.Event.any(k,f))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>u()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ee[29],te([0,1,186,9,61,18,8,6,15]),function(x,e,I,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function u(n){const a=n;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=u;function p(n){return typeof n?.id=="string"&&!u(n)&&!b(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=y;function b(n){const a=n;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=b;function d(n){const a=n;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:R.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=d;var E;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=v;function r(n){const a=n;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=r;class g{constructor(a,c,o,m,D){this.h=a,this.j=o,this.k=m,this.l=D,this.c=s.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=s.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class h{constructor(a,c){this.raw=c,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function S(n){return new h({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,a){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,a.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function C(n){let a;return R.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function l(n,a){return!w(n,a)&&!C(n)}e.isSavedWorkspace=l;function i(n){return(typeof n=="string"?(0,L.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[58],te([0,1,14,7,56,45,2,82,4,11,24,163,90,6,5,21,29]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let g=class{constructor(S,w){this.d=S,this.e=w,this.a=new Map,this.b=new Map,this.c=new L.Queue}pickFileFolder(S,w){return this.f({...S,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},w)}pickFolder(S,w){return this.f({...S,pickFolders:!0,title:(0,y.localize)(1,null)},w)}pickFile(S,w){return this.f({...S,pickFiles:!0,title:(0,y.localize)(2,null)},w)}pickWorkspace(S,w){const C=(0,y.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,y.localize)(4,null)),l=r.WORKSPACE_FILTER;return this.f({...S,pickFiles:!0,title:C,filters:l,buttonLabel:t},w)}async f(S,w){const C={title:S.title,buttonLabel:S.buttonLabel,filters:S.filters,defaultPath:S.defaultPath};(typeof S.pickFiles=="boolean"||typeof S.pickFolders=="boolean")&&(C.properties=void 0,S.pickFiles&&S.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",S.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&C.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(C,(0,u.withNullAsUndefined)(w||I.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(S){if(S){let w=this.b.get(S.id);return w||(w=new L.Queue,this.b.set(S.id,w)),w}else return this.c}showMessageBox(S,w){return this.g(w).queue(async()=>{const{options:C,buttonIndeces:t}=(0,b.massageMessageBoxOptions)(S,this.e);let l;return w?l=await I.dialog.showMessageBox(w,C):l=await I.dialog.showMessageBox(C),{response:t[l.response],checkboxChecked:l.checkboxChecked}})}async showSaveDialog(S,w){const C=this.j(S,w);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(w).queue(async()=>{let t;return w?t=await I.dialog.showSaveDialog(w,S):t=await I.dialog.showSaveDialog(S),t.filePath=this.h(t.filePath),t})}finally{(0,R.dispose)(C)}}h(S){return S&&f.isMacintosh&&(S=(0,k.normalizeNFC)(S)),S}i(S){return S.map(w=>this.h(w))}async showOpenDialog(S,w){S.defaultPath&&(await p.Promises.exists(S.defaultPath)||(S.defaultPath=void 0));const C=this.j(S,w);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(w).queue(async()=>{let t;return w?t=await I.dialog.showOpenDialog(w,S):t=await I.dialog.showOpenDialog(S),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.dispose)(C)}}j(S,w){if(!w)return R.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",S);let C=this.a.get(w.id);C||(C=new Set,this.a.set(w.id,C));const t=(0,s.hash)(S);if(!C.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",S),C.add(t),(0,R.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",S),C?.delete(t),C?.size===0&&this.a.delete(w.id)})}};g=ye([Q(0,E.ILogService),Q(1,v.IProductService)],g),e.DialogMainService=g}),define(ee[269],te([0,1,3,2,85,29]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{constructor(f,u){super(),this.f=f,this.g=u,this.b=this.B(new I.Emitter),this.c=new Map,this.h(u.applicationStorage,this.b)}h(f,u){this.B(I.Event.debounce(f.onDidChangeStorage,(p,y)=>(p?p.push(y):p=[y],p),R.a)(p=>{p.length&&u.fire(this.i(p,f))}))}i(f,u){const p=new Map,y=new Set;return f.forEach(b=>{const d=u.get(b.key);typeof d=="string"?p.set(b.key,d):y.add(b.key)}),{changed:Array.from(p.entries()),deleted:Array.from(y.values())}}listen(f,u,p){switch(u){case"onDidChangeStorage":{const y=p.profile?(0,s.revive)(p.profile):void 0;if(!y)return this.b.event;let b=this.c.get(y.id);return b||(b=this.B(new I.Emitter),this.h(this.g.profileStorage(y),b),this.c.set(y.id,b)),b.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,p){const y=p.profile?(0,s.revive)(p.profile):void 0,b=(0,A.reviveIdentifier)(p.workspace),d=await this.j(y,b);switch(u){case"getItems":return Array.from(d.items.entries());case"updateItems":{const E=p;if(E.insert)for(const[v,r]of E.insert)d.set(v,r);E.delete?.forEach(v=>d.delete(v));break}case"isUsed":{const E=p.payload;if(typeof E=="string")return this.g.isUsed(E)}default:throw new Error(`Call not found: ${u}`)}}async j(f,u){let p;u?p=this.g.workspaceStorage(u):f?p=this.g.profileStorage(f):p=this.g.applicationStorage;try{await p.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${y}`)}return p}}R.a=100,e.StorageDatabaseChannel=R}),define(ee[40],te([0,1,56,3,2,18,8,183,34,16,6,5,29,35,39,7,31,26,11]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=S,e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function w(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:n}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=w;function C(i,n,a,c,o){return{id:i,name:n,location:a,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),cacheHome:(0,A.joinPath)(c,i),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=C;let t=class extends s.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,a,c,o){super(),this.n=n,this.r=a,this.s=c,this.t=o,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=[];if(this.f)try{for(const m of this.J()){if(!m.name||!(0,h.isString)(m.name)||!m.location){this.t.warn("Skipping the invalid stored profile",m.location||m.name);continue}n.push(C((0,A.basename)(m.location),m.name,m.location,this.g,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}))}}catch(m){this.t.error(m)}const a=new d.ResourceMap,c=new Map,o=this.w();if(n.unshift({...o,extensionsResource:this.O()??o.extensionsResource,isDefault:!0}),n.length)try{const m=this.M();if(m.workspaces)for(const[D,M]of Object.entries(m.workspaces)){const T=R.URI.parse(D),N=n.find($=>$.id===M);N&&a.set(T,N)}if(m.emptyWindows)for(const[D,M]of Object.entries(m.emptyWindows)){const T=n.find(N=>N.id===M);T&&c.set(D,T)}}catch(m){this.t.error(m)}this.u={profiles:n,workspaces:a,emptyWindows:c}}return this.u}w(){return C("__default__profile__",(0,k.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(n){const a="Temp",c=new RegExp(`${(0,g.escapeRegExpCharacters)(a)}\\s(\\d+)`);let o=0;for(const D of this.profiles){const M=c.exec(D.name),T=M?parseInt(M[1]):0;o=T>o?T:o}const m=`${a} ${o+1}`;return this.createProfile((0,I.hash)((0,r.generateUuid)()).toString(16),m,{transient:!0},n)}async createNamedProfile(n,a,c){return this.createProfile((0,I.hash)((0,r.generateUuid)()).toString(16),n,a,c)}async createProfile(n,a,c,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.y(n,a,c);return o&&await this.setProfileForWorkspace(o,m),m}async y(n,a,c){if(!(0,h.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.l.get(a);return o||(o=(async()=>{try{const m=this.profiles.find(T=>T.name===a||T.id===n);if(m)return m;const D=C(n,a,(0,A.joinPath)(this.profilesHome,n),this.g,c);await this.r.createFolder(D.location);const M=[];return this.i.fire({profile:D,join(T){M.push(T)}}),await v.Promises.settled(M),this.D([D],[],[]),D}finally{this.l.delete(a)}})(),this.l.set(a,o)),o}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(o=>o.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=C(c.id,a.name??c.name,c.location,this.g,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.D([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.j.fire({profile:a,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.t.error(o)}for(const o of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(o)?.id&&this.v.emptyWindows.delete(o);for(const o of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(o)?.id&&this.v.workspaces.delete(o);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(o){(0,u.toFileOperationResult)(o)!==1&&this.t.error(o)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(a.location,{recursive:!0})}catch(o){this.t.error(o)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.G(n,c)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(!!this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.z(n);return R.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(n){return(0,b.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,b.isWorkspaceIdentifier)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,n.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,n.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,n.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,n.location)))}D(n,a,c){const o=[...this.profiles,...n],m=[];this.m.profiles=[];for(let D of o)D.isDefault||a.some(M=>D.id===M.id)||(D=c.find(M=>D.id===M.id)??D,D.isTransient?this.m.profiles.push(D):m.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.L(m),this.u=void 0,this.F(n,a,c)}F(n,a,c){this.h.fire({added:n,removed:a,updated:c,all:this.profiles})}G(n,a,c){c=a?.isTransient?!0:c,c||this.G(n,void 0,!0);const o=this.z(n),m=c?this.m:this.v;R.URI.isUri(o)?(m.workspaces.delete(o),a&&m.workspaces.set(o,a)):(m.emptyWindows.delete(o),a&&m.emptyWindows.set(o,a)),c||this.H()}H(){const n={};for(const[c,o]of this.v.workspaces.entries())n[c.toString()]=o.id;const a={};for(const[c,o]of this.v.emptyWindows.entries())a[c.toString()]=o.id;this.N({workspaces:n,emptyWindows:a}),this.u=void 0}I(n){const a={},c=this.w();if(n.workspaces)for(const[m,D]of Object.entries(n.workspaces)){const M=R.URI.parse(D);a[m]=this.s.extUri.isEqual(M,c.location)?c.id:this.s.extUri.basename(M)}const o={};if(n.emptyWindows)for(const[m,D]of Object.entries(n.emptyWindows)){const M=R.URI.parse(D);o[m]=this.s.extUri.isEqual(M,c.location)?c.id:this.s.extUri.basename(M)}return{workspaces:a,emptyWindows:o}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([Q(0,f.IEnvironmentService),Q(1,u.IFileService),Q(2,E.IUriIdentityService),Q(3,y.ILogService)],t),e.UserDataProfilesService=t;class l extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.InMemoryUserDataProfilesService=l}),define(ee[80],te([0,1,7,17,2,3,35,8,111,118,16,6,5,40,39,11,13,25]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class S extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let w=class extends s.Disposable{constructor(i,n,a,c,o,m){super(),this.i=i,this.j=n,this.k=a,this.l=c,this.m=o,this.n=m,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new R.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const a=[],c=[];try{return await this.p(n,o=>{const m=[];for(const D of o)i.some(([M])=>(0,u.areSameExtensions)(M.identifier,D.identifier)&&M.manifest.version!==D.version)?a.push(D):m.push(D);for(const[D,M]of i)if(!m.some(T=>(0,u.areSameExtensions)(T.identifier,D.identifier)&&T.version===D.manifest.version)){const T={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:M};c.push(T),m.push(T)}return c.length&&this.b.fire({extensions:c,profileLocation:n}),a.length&&this.f.fire({extensions:a,profileLocation:n}),m}),c.length&&this.c.fire({extensions:c,profileLocation:n}),a.length&&this.g.fire({extensions:a,profileLocation:n}),c}catch(o){throw c.length&&this.c.fire({extensions:c,error:o,profileLocation:n}),a.length&&this.g.fire({extensions:a,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const a=[];return await this.p(n,c=>{const o=[];for(const m of c){const D=i.find(([M])=>(0,u.areSameExtensions)(M.identifier,m.identifier)&&M.manifest.version===m.version);D&&(m.metadata={...m.metadata,...D[1]},a.push(m)),o.push(m)}return o}),a}async removeExtensionFromProfile(i,n){const a=[];this.f.fire({extensions:a,profileLocation:n});try{await this.p(n,c=>{const o=[];for(const m of c)(0,u.areSameExtensions)(m.identifier,i.identifier)?a.push(m):o.push(m);return a.length&&this.f.fire({extensions:a,profileLocation:n}),o}),a.length&&this.g.fire({extensions:a,profileLocation:n})}catch(c){throw a.length&&this.g.fire({extensions:a,error:c,profileLocation:n}),c}}async p(i,n,a){return this.w(i).queue(async()=>{let c=[],o;try{const m=await this.j.readFile(i);o=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,p.toFileOperationResult)(m)!==1)throw m;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(o=await this.v()),!o&&a?.bailOutWhenFileNotFound)throw new S((0,r.getErrorMessage)(m),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.r(i);let m=!1;for(const D of o){C(D)||this.r(i);let M;if((0,v.isString)(D.relativeLocation)&&D.relativeLocation)M=this.t(D.relativeLocation);else if((0,v.isString)(D.location))M=this.t(D.location),m=!0,D.relativeLocation=D.location,D.location=M.toJSON();else{M=k.URI.revive(D.location);const T=this.s(M);T&&(m=!0,D.relativeLocation=T)}c.push({identifier:D.identifier,location:M,version:D.version,metadata:D.metadata})}m&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(o)))}if(n){c=n(c);const m=c.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.s(D.location),metadata:D.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(m)))}return c})}r(i){const n=new S(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let a;try{a=(await this.j.readFile(i)).value.toString()}catch(o){if((0,p.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",i.toString());let c;try{const o=JSON.parse(a);Array.isArray(o)&&o.every(m=>C(m))?c=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(c)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,p.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(i)}catch(o){(0,p.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(n)}catch(o){(0,p.toFileOperationResult)(o)!==1&&this.n.error(o)}return c})()),this.u}w(i){let n=this.h.get(i);return n||(n=new I.Queue,this.h.set(i,n)),n}};w=ye([Q(1,p.IFileService),Q(2,d.IUserDataProfilesService),Q(3,E.IUriIdentityService),Q(4,g.ITelemetryService),Q(5,b.ILogService)],w),e.AbstractExtensionsProfileScannerService=w;function C(l){return(0,v.isObject)(l)&&(0,f.isIExtensionIdentifier)(l.identifier)&&(t(l.location)||(0,v.isString)(l.location)&&l.location)&&((0,v.isUndefined)(l.relativeLocation)||(0,v.isString)(l.relativeLocation))&&l.version&&(0,v.isString)(l.version)}function t(l){return l?(0,v.isString)(l.path)&&(0,v.isString)(l.scheme):!1}}),define(ee[124],te([0,1,22,7,37,17,13,43,146,2,15,9,4,18,200,75,11,8,168,34,118,115,199,16,6,5,21,3,85,80,40,39,198]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function(ce){function X(J,H){if(J===H)return!0;const W=Object.keys(J),V=new Set;for(const Y of Object.keys(H))V.add(Y);if(W.length!==V.size)return!1;for(const Y of W){if(J[Y]!==H[Y])return!1;V.delete(Y)}return V.size===0}ce.equals=X})(N=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=class extends u.Disposable{constructor(X,J,H,W,V,Y,ne,se,_,O,P,F){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=J,this.l=H,this.m=W,this.n=V,this.r=Y,this.s=ne,this.t=se,this.u=_,this.v=O,this.w=P,this.y=F,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(oe,this.m,this.h)),this.j=this.B(this.y.createInstance(oe,this.m,this.h)),this.k=this.B(this.y.createInstance(ie,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,w.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(X,J,H){const[W,V]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(J)]),Y=H?await this.scanExtensionsUnderDevelopment(X,[...W,...V]):[];return this.G(W,V,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const J=[];J.push(this.H(!!X.useCache,X.language)),J.push(this.I(X.language,!!X.checkControlFile));const[H,W]=await Promise.all(J);return this.F([...H,...W],0,X,!1)}async scanUserExtensions(X){const J=X.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",J);const H=this.w.extUri.isEqual(X.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.L(J,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,H),V=X.useCache&&!W.devMode&&W.excludeObsolete?this.j:this.k;let Y;try{Y=await V.scanExtensions(W)}catch(ne){if(ne instanceof m.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),Y=await V.scanExtensions(W);else throw ne}return Y=await this.F(Y,1,X,!0),this.t.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(X,J){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const H=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(W=>W.scheme===p.Schemas.file).map(async W=>{const V=await this.L(W,!1,1,!0,X.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(V)).map(ne=>(ne.type=J.find(se=>(0,w.areSameExtensions)(se.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,V)))}))).flat();return this.F(H,"development",X,!0)}return[]}async scanExistingExtension(X,J,H){const W=await this.L(X,!1,J,!0,H.language,!0,void 0),V=await this.k.scanExtension(W);return!V||!H.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(X,J,H){const W=await this.L(X,!1,J,!0,H.language,!0,void 0),V=await this.k.scanOneOrMultipleExtensions(W);return this.F(V,J,H,!0)}async scanMetadata(X){const J=(0,d.joinPath)(X,"package.json"),H=(await this.s.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(X,J){const H=(0,d.joinPath)(X,"package.json"),W=(await this.s.readFile(H)).value.toString(),V=JSON.parse(W);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,V.__metadata={...V.__metadata,...J},await this.s.writeFile((0,d.joinPath)(X,"package.json"),A.VSBuffer.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof m.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw X}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.r.addExtensionsToProfile(X.map(J=>[J,J.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(J){(0,l.toFileOperationResult)(J)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(J))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.t.error(X)}finally{this.C=void 0}})()),this.C}async F(X,J,H,W){return H.includeAllVersions||(X=this.G(J===0?X:void 0,J===1?X:void 0,J==="development"?X:void 0,await this.getTargetPlatform(),W)),H.includeInvalid||(X=X.filter(V=>V.isValid)),X.sort((V,Y)=>{const ne=y.basename(V.location.fsPath),se=y.basename(Y.location.fsPath);return ne<se?-1:ne>se?1:0})}G(X,J,H,W,V){const Y=(se,_,O)=>{if(se.isValid&&!_.isValid)return!1;if(se.isValid===_.isValid){if(V&&E.gt(se.manifest.version,_.manifest.version))return this.t.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(E.eq(se.manifest.version,_.manifest.version)){if(se.type===0)return this.t.debug(`Skipping extension ${_.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===W)return this.t.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return O?this.t.warn(`Overwriting user extension ${se.location.path} with ${_.location.path}.`):this.t.debug(`Overwriting user extension ${se.location.path} with ${_.location.path}.`),!0},ne=new C.ExtensionIdentifierMap;return X?.forEach(se=>{const _=ne.get(se.identifier.id);(!_||Y(_,se,!1))&&ne.set(se.identifier.id,se)}),J?.forEach(se=>{const _=ne.get(se.identifier.id);if(!_&&X&&se.type===0){this.t.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!_||Y(_,se,!1))&&ne.set(se.identifier.id,se)}),H?.forEach(se=>{const _=ne.get(se.identifier.id);(!_||Y(_,se,!0))&&ne.set(se.identifier.id,se),ne.set(se.identifier.id,se)}),[...ne.values()]}async H(X,J){this.t.trace("Started scanning system extensions");const H=await this.L(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),V=await(X&&!H.devMode?this.i:this.k).scanExtensions(H);return this.t.trace("Scanned system extensions:",V.length),V}async I(X,J){const H=this.u.isBuilt?[]:this.v.builtInExtensions;if(!H?.length)return[];this.t.trace("Started scanning dev system extensions");const W=J?await this.J():{},V=[],Y=g.URI.file(y.normalize(y.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of H){const _=W[se.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":V.push((0,d.joinPath)(Y,se.name));break;default:V.push(g.URI.file(_));break}}const ne=await Promise.all(V.map(async se=>this.k.scanExtension(await this.L(se,!1,0,!0,X,!0,void 0))));return this.t.trace("Scanned dev system extensions:",ne.length),(0,I.coalesce)(ne)}async J(){try{const X=await this.s.readFile(this.l);return JSON.parse(X.value.toString())}catch{return{}}}async L(X,J,H,W,V,Y,ne){const se=await this.f(V??b.language),_=await this.M(X),O=J&&!this.w.extUri.isEqual(X,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=O?await this.M(O):void 0;return new q(X,_,O,P,J,ne,H,W,Y,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,V,se)}async M(X){try{const J=await this.s.stat(X);if(typeof J.mtime=="number")return J.mtime}catch{}}};$=ye([Q(4,D.IUserDataProfilesService),Q(5,m.IExtensionsProfileScannerService),Q(6,l.IFileService),Q(7,n.ILogService),Q(8,S.IEnvironmentService),Q(9,a.IProductService),Q(10,M.IUriIdentityService),Q(11,i.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class q{constructor(X,J,H,W,V,Y,ne,se,_,O,P,F,U,j,B){this.location=X,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=W,this.profile=V,this.profileScanOptions=Y,this.type=ne,this.excludeObsolete=se,this.validate=_,this.productVersion=O,this.productDate=P,this.productCommit=F,this.devMode=U,this.language=j,this.translations=B}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,J){return(0,d.isEqual)(X.location,J.location)&&X.mtime===J.mtime&&(0,d.isEqual)(X.applicationExtensionslocation,J.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&X.profile===J.profile&&s.equals(X.profileScanOptions,J.profileScanOptions)&&X.type===J.type&&X.excludeObsolete===J.excludeObsolete&&X.validate===J.validate&&X.productVersion===J.productVersion&&X.productDate===J.productDate&&X.productCommit===J.productCommit&&X.devMode===J.devMode&&X.language===J.language&&N.equals(X.translations,J.translations)}}e.ExtensionScannerInput=q;let ie=class extends u.Disposable{constructor(X,J,H,W,V){super(),this.f=X,this.g=J,this.h=H,this.i=W,this.j=V}async scanExtensions(X){const J=X.profile?await this.l(X):await this.k(X);let H={};if(X.excludeObsolete&&X.type===1)try{const W=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(W)}catch{}return(0,r.isEmptyObject)(H)?J:J.filter(W=>!H[w.ExtensionKey.create(W).toString()])}async k(X){const J=await this.i.resolve(X.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async W=>{if(!W.isDirectory||X.type===1&&(0,d.basename)(W.resource).indexOf(".")===0)return null;const V=new q(W.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(V)}));return(0,I.coalesce)(H).sort((W,V)=>W.location.path<V.location.path?-1:1)}async l(X){let J=await this.m(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){J=J.filter(W=>!W.metadata?.isApplicationScoped);const H=await this.m(X.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,X);J.push(...H)}return J}async m(X,J,H){const W=await this.g.scanProfileExtensions(X,H.profileScanOptions);if(!W.length)return[];const V=await Promise.all(W.map(async Y=>{if(J(Y)){const ne=new q(Y.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,Y.metadata)}return null}));return(0,I.coalesce)(V)}async scanOneOrMultipleExtensions(X){try{if(await this.i.exists((0,d.joinPath)(X.location,"package.json"))){const J=await this.scanExtension(X);return J?[J]:[]}else return await this.scanExtensions(X)}catch(J){return this.j.error(`Error scanning extensions at ${X.location.path}:`,(0,R.getErrorMessage)(J)),[]}}async scanExtension(X,J){try{let H=await this.scanExtensionManifest(X.location);if(H){H.publisher||(H.publisher=C.UNDEFINED_PUBLISHER),J=J??H.__metadata,delete H.__metadata;const W=(0,w.getGalleryExtensionId)(H.publisher,H.name),V=J?.id?{id:W,uuid:J.id}:{id:W},Y=J?.isSystem?0:X.type,ne=Y===0||!!J?.isBuiltin;H=await this.n(X.location,H,q.createNlsConfiguration(X));const se={type:Y,identifier:V,manifest:H,location:X.location,isBuiltin:ne,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return X.validate?this.validate(se,X):se}}catch(H){X.type!==0&&this.j.error(H)}return null}validate(X,J){let H=!0;const W=(0,t.validateExtensionManifest)(J.productVersion,J.productDate,J.location,X.manifest,X.isBuiltin);for(const[V,Y]of W)V===v.default.Error&&(H=!1,this.j.error(this.u(J.location,Y)));return X.isValid=H,X.validations=W,X}async scanExtensionManifest(X){const J=(0,d.joinPath)(X,"package.json");let H;try{H=(await this.i.readFile(J)).value.toString()}catch(V){return(0,l.toFileOperationResult)(V)!==1&&this.j.error(this.u(X,(0,h.localize)(0,null,J.path,V.message))),null}let W;try{W=JSON.parse(H)}catch{const Y=[];(0,k.parse)(H,Y);for(const ne of Y)this.j.error(this.u(X,(0,h.localize)(1,null,J.path,ne.offset,ne.length,(0,f.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(W)!=="object"?(this.j.error(this.u(X,(0,h.localize)(2,null,J.path))),null):W}async n(X,J,H){const W=await this.r(X,J,H);if(W)try{const V=[],Y=await this.s(W.default,V);if(V.length>0)return V.forEach(se=>{this.j.error(this.u(X,(0,h.localize)(3,null,W.default?.path,(0,f.getParseErrorMessage)(se.error))))}),J;if((0,k.getNodeType)(W)!=="object")return this.j.error(this.u(X,(0,h.localize)(4,null,W.default?.path))),J;const ne=W.values||Object.create(null);return(0,T.localizeManifest)(J,ne,Y)}catch{}return J}async r(X,J,H){const W=(0,d.joinPath)(X,"package.nls.json"),V=(_,O)=>{O.forEach(P=>{this.j.error(this.u(X,(0,h.localize)(5,null,_?.path,(0,f.getParseErrorMessage)(P.error))))})},Y=_=>{this.j.error(this.u(X,(0,h.localize)(6,null,_?.path)))},ne=`${J.publisher}.${J.name}`,se=H.translations[ne];if(se)try{const _=g.URI.file(se),O=(await this.i.readFile(_)).value.toString(),P=[],F=(0,k.parse)(O,P);return P.length>0?(V(_,P),{values:void 0,default:W}):(0,k.getNodeType)(F)!=="object"?(Y(_),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.i.exists(W))return;let O;try{O=await this.t(X,H)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const P=(await this.i.readFile(O.localized)).value.toString(),F=[],U=(0,k.parse)(P,F);return F.length>0?(V(O.localized,F),{values:void 0,default:O.original}):(0,k.getNodeType)(U)!=="object"?(Y(O.localized),{values:void 0,default:O.original}):{values:U,default:O.original}}catch{return{values:void 0,default:O.original}}}}async s(X,J){if(X)try{const H=(await this.i.readFile(X)).value.toString();return(0,k.parse)(H,J)}catch{}}t(X,J){return new Promise((H,W)=>{const V=Y=>{const ne=(0,d.joinPath)(X,`package.nls.${Y}.json`);this.i.exists(ne).then(se=>{se&&H({localized:ne,original:(0,d.joinPath)(X,"package.nls.json")});const _=Y.lastIndexOf("-");_===-1?H({localized:(0,d.joinPath)(X,"package.nls.json"),original:null}):(Y=Y.substring(0,_),V(Y))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,d.joinPath)(X,"package.nls.json"),original:null});V(J.language)})}u(X,J){return`[${X.path}]: ${J}`}};ie=ye([Q(1,m.IExtensionsProfileScannerService),Q(2,M.IUriIdentityService),Q(3,l.IFileService),Q(4,n.ILogService)],ie);let oe=class extends ie{constructor(X,J,H,W,V,Y,ne){super(J,W,V,Y,ne),this.z=X,this.C=H,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new c.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(X){const J=this.H(X),H=await this.D(J);if(this.v=X,H&&H.input&&q.equals(H.input,this.v))return this.j.debug("Using cached extensions scan result",X.location.toString()),this.w.trigger(()=>this.G()),H.result.map(V=>(V.location=g.URI.revive(V.location),V));const W=await super.scanExtensions(X);return await this.F(J,{input:X,result:W}),W}async D(X){try{const J=await this.i.readFile(X),H=JSON.parse(J.value.toString());return{result:H.result,input:(0,o.revive)(H.input)}}catch(J){this.j.debug("Error while reading the extension cache file:",X.path,(0,R.getErrorMessage)(J))}return null}async F(X,J){try{await this.i.writeFile(X,A.VSBuffer.fromString(JSON.stringify(J)))}catch(H){this.j.debug("Error while writing the extension cache file:",X.path,(0,R.getErrorMessage)(H))}}async G(){if(!this.v)return;const X=this.H(this.v),J=await this.D(X);if(!J)return;const H=J.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!s.equals(W,H))try{this.j.info("Invalidating Cache",H,W),await this.i.del(X),this.y.fire()}catch(V){this.j.error(V)}}H(X){const J=this.I(X);return this.h.extUri.joinPath(J.cacheHome,X.type===0?C.BUILTIN_MANIFEST_CACHE_FILE:C.USER_MANIFEST_CACHE_FILE)}I(X){return X.type===0?this.C.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.z.extensionsResource)?this.z:this.C.profiles.find(J=>this.h.extUri.isEqual(X.location,J.extensionsResource))??this.z:this.C.defaultProfile}};oe=ye([Q(2,D.IUserDataProfilesService),Q(3,m.IExtensionsProfileScannerService),Q(4,M.IUriIdentityService),Q(5,l.IFileService),Q(6,n.ILogService)],oe);function ae(ce,X){const J=(0,w.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:J,identifier:new C.ExtensionIdentifier(J),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:X,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=ae;class de extends ${constructor(X,J,H,W,V,Y,ne,se,_,O,P,F){super(X,J,(0,d.joinPath)(H,".vscode-oss-dev","extensions","control.json"),W,V,Y,ne,se,_,O,P,F),this.N=(async()=>{if(b.translationsConfigFile)try{const U=await this.s.readFile(g.URI.file(b.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(X){return this.N}}e.NativeExtensionsScannerService=de}),define(ee[270],te([0,1,5,40,39,25,80,16,34,8]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends R.AbstractExtensionsProfileScannerService{constructor(b,d,E,v,r,g){super(u.URI.file(b.extensionsPath),d,E,v,r,g)}};p=ye([Q(0,f.INativeEnvironmentService),Q(1,k.IFileService),Q(2,L.IUserDataProfilesService),Q(3,s.IUriIdentityService),Q(4,A.ITelemetryService),Q(5,I.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(ee[271],te([0,1,8,34,80,124,16,6,5,21,39,40]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends A.NativeExtensionsScannerService{constructor(E,v,r,g,h,S,w,C){super(I.URI.file(h.builtinExtensionsPath),I.URI.file(h.extensionsPath),h.userHome,E.defaultProfile,E,v,r,g,h,S,w,C)}};b=ye([Q(0,y.IUserDataProfilesService),Q(1,s.IExtensionsProfileScannerService),Q(2,R.IFileService),Q(3,f.ILogService),Q(4,L.INativeEnvironmentService),Q(5,u.IProductService),Q(6,p.IUriIdentityService),Q(7,k.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ee[272],te([0,1,14,2,15,9,4,61,8,31,42,34,5,40]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends L.Disposable{constructor(r,g,h){super(),this.c=r,this.f=h,this.a=k.TernarySearchTree.forPaths(!R.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(r.appRoot),this.addValidFileRoot(r.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(r.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:r}=I.session;r.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,h)=>this.i(g,h)),r.protocol.interceptFileProtocol(s.Schemas.file,(g,h)=>this.h(g,h)),this.B((0,L.toDisposable)(()=>{r.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),r.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(r){const g=(0,A.normalize)(r);return this.a.get(g)?L.Disposable.None:(this.a.set(g,!0),(0,L.toDisposable)(()=>this.a.delete(g)))}h(r,g){const h=f.URI.parse(r.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${r.url})`),g({error:-3})}i(r,g){const h=this.j(r);let S;return this.c.crossOriginIsolated&&((0,A.basename)(h)==="workbench.html"||(0,A.basename)(h)==="workbench-dev.html"?S=s.COI.CoopAndCoep:S=s.COI.getHeadersFromQuery(r.url)),this.a.findSubstr(h)?g({path:h,headers:S}):this.b.has((0,A.extname)(h).toLowerCase())?g({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${r.url})`),g({error:-3}))}j(r){const g=f.URI.parse(r.url),h=s.FileAccess.uriToFileUri(g);return(0,A.normalize)(h.fsPath)}createIPCObjectUrl(){let r;const g=f.URI.from({scheme:"vscode",path:(0,u.generateUuid)()}),h=g.toString(),S=async()=>r;return p.validatedIpcMain.handle(h,S),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:w=>r=w,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),p.validatedIpcMain.removeHandler(h)}}}};E=ye([Q(0,y.INativeEnvironmentService),Q(1,d.IUserDataProfilesService),Q(2,b.ILogService)],E),e.ProtocolMainService=E}),define(ee[273],te([0,1,14,42,7,3,2,15,11,106,28,20,5,66,67,69,44,40,38,65,70,19,48,72,109]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let n=class extends R.Disposable{constructor(c,o,m,D,M,T,N,$,q,ie,oe){super(),this.i=c,this.j=o,this.k=m,this.l=D,this.m=M,this.n=T,this.r=N,this.s=$,this.t=q,this.u=ie,this.v=oe,this.a=this.B(new A.Emitter),this.onDidError=A.Event.buffer(this.a.event),this.b=new s.Barrier,this.c=void 0,this.f=void 0,this.g=void 0,this.h=(()=>{let ae=!1;if(l.canUseUtilityProcess){const de=this.v.getValue("window.experimental.sharedProcessUseUtilityProcess");typeof de=="boolean"?ae=de:ae=typeof d.default.quality=="string"}return ae})(),this.F=void 0,this.G=void 0,this.w(),this.h&&this.n.info("[SharedProcess] using utility process")}w(){L.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,o)=>this.y(c,o)),L.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,o)=>this.z(c,o)),this.B(this.m.onWillShutdown(()=>this.C()))}async y(c,o){this.n.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.b.isOpen()||this.b.open(),await this.whenReady();const m=await this.connect();if(c.sender.isDestroyed())return m.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[m])}z(c,o){this.n.trace("[SharedProcess] onWorkerConnection",o);const m=new R.DisposableStore,D=T=>{!this.O()||(this.n.trace(`[SharedProcess] disposing worker (reason: '${T}')`,o),m.dispose(),this.D("vscode:electron-main->shared-process=disposeWorker",o))},M=I.BrowserWindow.fromId(o.reply.windowId);if(!M||M.isDestroyed()||M.webContents.isDestroyed()||!o.reply.channel){D("unavailable");return}m.add(A.Event.filter(this.m.onWillLoadWindow,T=>T.window.win===M)(()=>D("load"))),m.add(A.Event.fromNodeEventEmitter(M,"closed")(()=>D("closed"))),M.webContents.postMessage(o.reply.channel,o.reply.nonce,c.ports)}C(){if(this.n.trace("[SharedProcess] onWillShutdown"),this.g)this.g.postMessage("vscode:electron-main->shared-process=exit"),this.g=void 0;else{const c=this.c;if(!c)return;this.D("vscode:electron-main->shared-process=exit"),this.f&&(c.removeListener("close",this.f),this.f=void 0),setTimeout(()=>{try{this.n.trace("[SharedProcess] onWillShutdown window.close()"),c.close()}catch(o){this.n.trace(`[SharedProcess] onWillShutdown window.close() error: ${o}`)}this.c=void 0},0)}}D(c,...o){if(!this.O()){this.n.warn(`Sending IPC message to channel '${c}' for shared process that is destroyed`);return}try{this.c?.webContents.send(c,...o)}catch(m){this.n.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,r.toErrorMessage)(m)}`)}}whenReady(){return this.F||(this.F=(async()=>{await this.H;const c=new s.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=init-done",()=>c.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>c.complete()),await c.p,this.n.trace("[SharedProcess] Overall ready")})()),this.F}get H(){return this.G||(this.G=(async()=>{await this.b.wait(),this.I();const c=new s.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=ipc-ready",()=>c.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>c.complete()),await c.p,this.n.trace("[SharedProcess] IPC ready")})()),this.G}I(){this.h?this.J():this.L(),this.N()}J(){this.g=this.B(new w.UtilityProcess(this.n,t.NullTelemetryService,this.m));const c=(0,i.parseSharedProcessDebugPort)(this.k.args,this.k.isBuilt);let o;c.port&&(o=["--nolazy"],c.break?o.push(`--inspect-brk=${c.port}`):o.push(`--inspect=${c.port}`)),this.g.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.M(),execArgv:o})}L(){const c=this.B(this.u.createIPCObjectUrl());this.c=new I.BrowserWindow({show:!1,backgroundColor:this.t.getBackgroundColor(),title:"shared-process",webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:this.k.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update(this.M()),this.c.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.k.isBuilt?"":"-dev"}.html`).toString(!0))}M(){return{machineId:this.i,windowId:this.c?.id??-1,appRoot:this.k.appRoot,codeCachePath:this.k.codeCachePath,profiles:{home:this.l.profilesHome,all:this.l.profiles},userEnv:this.j,args:this.k.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),product:d.default,policiesData:this.s.serialize()}}N(){this.c?(this.f=c=>{this.n.trace("SharedProcess#close prevented"),c.preventDefault(),this.c?.isVisible()&&this.c.hide()},this.c.on("close",this.f),this.c.webContents.on("render-process-gone",(c,o)=>this.a.fire({type:2,details:o})),this.c.on("unresponsive",()=>this.a.fire({type:1})),this.c.webContents.on("did-fail-load",(c,o,m)=>this.a.fire({type:3,details:{reason:m,exitCode:o}}))):this.g&&this.B(this.g.onCrash(c=>this.a.fire({type:2,details:{reason:c.reason,exitCode:c.code}})))}async connect(){return await this.H,this.g?this.g.connect():(0,u.connect)((0,f.assertIsDefined)(this.c))}async toggle(){await this.H,this.c&&(this.c.isVisible()?(this.c.webContents.closeDevTools(),this.c.hide()):(this.c.show(),this.c.webContents.openDevTools()))}isVisible(){return this.c?.isVisible()??!1}usingUtilityProcess(){return!!this.g}O(){const c=this.c;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};n=ye([Q(2,p.IEnvironmentMainService),Q(3,g.IUserDataProfilesService),Q(4,y.ILifecycleMainService),Q(5,b.ILogService),Q(6,S.ILoggerMainService),Q(7,h.IPolicyService),Q(8,v.IThemeMainService),Q(9,E.IProtocolMainService),Q(10,C.IConfigurationService)],n),e.SharedProcess=n}),define(ee[96],te([0,1,7,3,2,64,11,107,6,40]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var p;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var b;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function d(h){const S=h.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=d;class E extends s.Disposable{constructor(S={flushInterval:E.a}){super(),this.j=S,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new s.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,s.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(S,w){if(w===e.TARGET_KEY){switch(S){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:w,target:this.F(S)[w]})}r(S){this.f.fire({reason:S})}get(S,w,C){return this.L(w)?.get(S,C)}getBoolean(S,w,C){return this.L(w)?.getBoolean(S,C)}getNumber(S,w,C){return this.L(w)?.getNumber(S,C)}store(S,w,C,t){if((0,R.isUndefinedOrNull)(w)){this.remove(S,C);return}this.t(()=>{this.u(S,C,t),this.L(C)?.set(S,w)})}remove(S,w){this.t(()=>{this.u(S,w,void 0),this.L(w)?.delete(S)})}t(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,w){const C=[],t=this.F(S);for(const l of Object.keys(t))t[l]===w&&C.push(l);return C}u(S,w,C){const t=this.F(w);typeof C=="number"?t[S]!==C&&(t[S]=C,this.L(w)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.L(w)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(S){switch(S){case-1:return this.D;case 0:return this.z;default:return this.w}}G(S){const w=this.L(S);return w?d(w):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=p.NONE){this.f.fire({reason:S});const w=this.L(-1),C=this.L(0),t=this.L(1);switch(S){case p.NONE:await I.Promises.settled([w?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await I.Promises.settled([w?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return g(S,w,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(S,w){return this.r(p.NONE),(0,u.isUserDataProfile)(S)?this.N(S,w):this.O(S,w)}H(S,w){return!(S.id===w.id||v(w)&&v(S))}I(S,w,C,t){this.t(()=>{if(t)for(const[l,i]of S)w.set(l,i);else{const l=new Set;for(const[i,n]of S)l.add(i),w.get(i)!==n&&this.n(C,i);for(const[i]of w.items)l.has(i)||this.n(C,i)}})}}E.a=60*1e3,e.AbstractStorageService=E;function v(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class r extends E{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(S=>this.n(1,S))),this.B(this.P.onDidChangeStorage(S=>this.n(0,S))),this.B(this.p.onDidChangeStorage(S=>this.n(-1,S)))}L(S){switch(S){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(S){return!1}}e.InMemoryStorageService=r;async function g(h,S,w,C,t,l){const i=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,a=new Map;h.forEach((N,$)=>{n.set($,N),a.set($,i(N))});const c=new Map,o=new Map;S.forEach((N,$)=>{c.set($,N),o.set($,i(N))});const m=new Map,D=new Map;w.forEach((N,$)=>{m.set($,N),D.set($,i(N))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const M=[];if(n.forEach((N,$)=>{M.push({key:$,value:N})}),console.table(M),console.groupEnd(),console.log(a),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];c.forEach(($,q)=>{N.push({key:q,value:$})}),console.table(N),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${l})`);const T=[];m.forEach((N,$)=>{T.push({key:$,value:N})}),console.table(T),console.groupEnd(),console.log(D)}e.logStorage=g}),define(ee[274],te([0,1,22,7,3,2,9,74,8,24,107,157,5,96,25,29]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class r extends A.Disposable{get storage(){return this.f}constructor(l,i){super(),this.j=l,this.k=i,this.b=this.B(new s.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new L.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const l=await this.n();this.f.dispose(),this.f=l,this.B(l.onDidChangeStorage(n=>this.b.fire({key:n}))),await this.m(l);const i=l.getBoolean(d.IS_NEW_KEY);i===void 0?l.set(d.IS_NEW_KEY,!0):i&&l.set(d.IS_NEW_KEY,!1)}catch(l){this.j.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?l=>this.j.trace(l):void 0,logError:l=>this.j.error(l)}}m(l){return l.init()}get items(){return this.f.items}get(l,i){return this.f.get(l,i)}set(l,i){return this.f.set(l,i)}delete(l){return this.f.delete(l)}async close(){const l=new k.StopWatch(!1);await this.s(),l.stop(),l.elapsed()>r.a&&await this.r(l),this.c.fire()}async r(l){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([a,c])=>({key:a,length:c.length})),(a,c)=>c.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}r.a=2e3;class g extends r{get path(){if(!this.v.useInMemoryStorage)return(0,R.join)(this.u.globalStorageHome.fsPath,g.t)}constructor(l,i,n,a){super(n,a),this.u=l,this.v=i}async n(){return new p.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}g.t="state.vscdb";class h extends g{constructor(l,i,n,a){super(l,i,n,a)}}e.ProfileStorageMain=h;class S extends g{constructor(l,i,n,a){super(i.defaultProfile,l,n,a)}async m(l){await super.m(l),this.z(l)}z(l){l.get(E.firstSessionDateStorageKey,void 0)===void 0&&l.set(E.firstSessionDateStorageKey,new Date().toUTCString());const n=l.get(E.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();l.set(E.lastSessionDateStorageKey,typeof n>"u"?null:n),l.set(E.currentSessionDateStorageKey,a)}}e.ApplicationStorageMain=S;class w extends r{get path(){if(!this.w.useInMemoryStorage)return(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id,w.t)}constructor(l,i,n,a,c){super(n,c),this.v=l,this.w=i,this.y=a}async n(){const{storageFilePath:l,wasCreated:i}=await this.C();return new p.Storage(new y.SQLiteStorageDatabase(l,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,R.join)(l,w.t);return await u.Promises.exists(l)?{storageFilePath:i,wasCreated:!1}:(await u.Promises.mkdir(l,{recursive:!0}),this.D(l),{storageFilePath:i,wasCreated:!0})}async D(l){let i;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const n=(0,R.join)(l,w.u);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}w.t="state.vscdb",w.u="workspace.json",e.WorkspaceStorageMain=w;class C extends r{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=C}),define(ee[275],te([0,1,3,2,96]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(k,f,u){super(),this.b=k,this.c=f,this.f=u;const p=this.B(new L.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new L.DisposableStore;return k.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.h(f))),k.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let p=f.get(u.profile.id);return p||f.set(u.profile.id,p={profile:u.profile,keys:[],storage:u.storage}),p.keys.push(u.key),f},100)(f=>this.i(f))),k}h(k){const f=k.includes(s.TARGET_KEY)?[this.c.defaultProfile]:[],u=[];if(k=k.filter(p=>p!==s.TARGET_KEY),k.length){const p=(0,s.loadKeyTargets)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:k.map(y=>({key:y,scope:0,target:p[y]}))})}this.j(f,u)}i(k){const f=[],u=new Map;for(const[p,y]of k.entries()){y.keys.includes(s.TARGET_KEY)&&f.push(y.profile);const b=y.keys.filter(d=>d!==s.TARGET_KEY);if(b.length){const d=(0,s.loadKeyTargets)(y.storage.storage);u.set(p,{profile:y.profile,changes:b.map(E=>({key:E,scope:0,target:d[E]}))})}}this.j(f,[...u.values()])}j(k,f){(k.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:k})}listen(k,f,u){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(k,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[276],te([0,1,8,34,16,5,33,39,40,11,117]),function(x,e,I,L,s,A,R,k,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=class ft extends f.UserDataProfilesService{constructor(v,r,g,h,S){super(g,h,r,S),this.P=v,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(r=>({...r,location:(0,u.isString)(r.location)?this.s.extUri.joinPath(this.profilesHome,r.location):I.URI.revive(r.location)}))}M(){const v=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?v:this.I(v)}O(){return this.s.extUri.joinPath(I.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.a="profileAssociationsMigration",y=ye([Q(0,R.IStateReadService),Q(1,k.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,s.IFileService),Q(4,A.ILogService)],y),e.UserDataProfilesReadonlyService=y;let b=class st extends y{constructor(v,r,g,h,S){super(v,r,g,h,S),this.W=v}L(v){v.length?this.W.setItem(st.b,v.map(r=>({...r,location:this.s.extUri.basename(r.location)}))):this.W.removeItem(st.b)}J(){const v=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(v),this.W.setItem("userDataProfilesMigration",!0)),v}N(v){v.emptyWindows||v.workspaces?this.W.setItem(st.c,v):this.W.removeItem(st.c)}M(){const v="workspaceAndProfileInfo",r=this.W.getItem(v,void 0);if(r){this.W.removeItem(v);const h=r.reduce((S,{workspace:w,profile:C})=>(S[I.URI.revive(w).toString()]=I.URI.revive(C).toString(),S),{});this.W.setItem(st.c,{workspaces:h})}const g=super.M();return this.W.getItem(st.a,!1)||(this.N(g),this.W.setItem(st.a,!0)),g}};b=ye([Q(0,R.IStateService),Q(1,k.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,s.IFileService),Q(4,A.ILogService)],b),e.UserDataProfilesService=b;let d=class extends b{constructor(v,r,g,h){super(new p.StateService(0,r,h,g),v,r,g,h)}async init(){return await this.W.init(),super.init()}};d=ye([Q(0,k.IUriIdentityService),Q(1,L.INativeEnvironmentService),Q(2,s.IFileService),Q(3,A.ILogService)],d),e.ServerUserDataProfilesService=d}),define(ee[53],te([0,1,34,16,6,5,39,40,276,33]),function(x,e,I,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,s.refineServiceDecorator)(k.IUserDataProfilesService);let p=class extends f.UserDataProfilesService{constructor(b,d,E,v,r){super(b,d,E,v,r)}getAssociatedEmptyWindows(){const b=[];for(const d of this.v.emptyWindows.keys())b.push({id:d});return b}};p=ye([Q(0,u.IStateService),Q(1,R.IUriIdentityService),Q(2,I.INativeEnvironmentService),Q(3,L.IFileService),Q(4,A.ILogService)],p),e.UserDataProfilesMainService=p}),define(ee[97],te([0,1,8,50,3,2,34,16,6,20,5,96,274,40,53,39]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let r=class extends A.Disposable{constructor(S,w,C,t,l,i){super(),this.c=S,this.f=w,this.g=C,this.h=t,this.i=l,this.j=i,this.a=void 0,this.b=this.B(new s.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(S=>{S.window.profile&&this.profileStorage(S.window.profile).init(),S.workspace&&this.workspaceStorage(S.workspace).init()})),this.B(this.h.onWillShutdown(S=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=S.reason,S.join("applicationStorage",this.applicationStorage.close());for(const[,w]of this.n)S.join("profileStorage",w.close());for(const[,w]of this.r)S.join("workspaceStorage",w.close())})),this.B(this.g.onWillCreateProfile(S=>{S.join((async()=>{await this.i.exists(S.profile.globalStorageHome)||await this.i.createFolder(S.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(S=>{const w=this.n.get(S.profile.id);w&&S.join(w.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const S=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,L.once)(S.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),S}profileStorage(S){if((0,y.isProfileUsingDefaultStorage)(S))return this.applicationStorage;let w=this.n.get(S.id);if(!w){this.c.trace(`StorageMainService: creating profile storage (${S.name})`),w=this.p(S),this.n.set(S.id,w);const C=this.B(w.onDidChangeStorage(t=>this.b.fire({...t,storage:w,profile:S})));(0,L.once)(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${S.name})`),this.n.delete(S.id),C.dispose()})}return w}p(S){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(S,this.k(),this.c,this.i)}workspaceStorage(S){let w=this.r.get(S.id);return w||(this.c.trace(`StorageMainService: creating workspace storage (${S.id})`),w=this.s(S),this.r.set(S.id,w),(0,L.once)(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${S.id})`),this.r.delete(S.id)})),w}s(S){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(S,this.k(),this.c,this.f,this.i)}isUsed(S){const w=I.URI.file(S);for(const C of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!C.path&&this.j.extUri.isEqualOrParent(I.URI.file(C.path),w))return!0;return!1}};r=ye([Q(0,p.ILogService),Q(1,R.IEnvironmentService),Q(2,E.IUserDataProfilesMainService),Q(3,u.ILifecycleMainService),Q(4,k.IFileService),Q(5,v.IUriIdentityService)],r),e.StorageMainService=r,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let g=class extends y.AbstractStorageService{constructor(S,w){super(),this.p=S,this.s=w,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(S){if(S===-1)return this.s.applicationStorage.storage}M(S){if(S===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};g=ye([Q(0,d.IUserDataProfilesService),Q(1,e.IStorageMainService)],g),e.ApplicationStorageMainService=g}),define(ee[277],te([0,1,2,20,53,29,7,30]),function(x,e,I,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends I.Disposable{constructor(p,y,b){super(),this.a=y,this.b=b,this.B(p.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(p.onBeforeCloseWindow(d=>this.c(d))),this.B(new R.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const y=this.f(p),b=this.a.getProfileForWorkspace(y);b?.isTransient&&(this.a.unsetWorkspace(y,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,A.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const y=this.b.getWindows().map(b=>this.f(b));for(const b of p)y.some(d=>d.id===b.id)||this.a.unsetWorkspace(b,!1)}};f=ye([Q(0,L.ILifecycleMainService),Q(1,s.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[125],te([0,1,18,8,29]),function(x,e,I,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(f,u,p){for(const b of f){const d=b.openedWorkspace;if((0,s.isWorkspaceIdentifier)(d)){const E=await p(d);if(E){if(E.folders.some(v=>I.extUriBiasedIgnorePathCase.isEqualOrParent(u,v.uri)))return b}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(u,d.configPath))return b}}const y=f.filter(b=>(0,s.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(u,b.openedWorkspace.uri));if(y.length)return y.sort((b,d)=>-(b.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function R(f,u){for(const p of f)if((0,s.isWorkspaceIdentifier)(p.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,u)||(0,s.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,u))return p}e.findWindowOnWorkspaceOrFolder=R;function k(f,u){const p=y=>u.some(b=>I.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(y)));for(const y of f)if(y.config?.extensionDevelopmentPath?.some(b=>p(b)))return y}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[278],te([0,1,14,2,4,18,8,19,20,5,33,30,123,29]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let E=class yt extends L.Disposable{get state(){return this.b}constructor(w,C,t,l,i){super(),this.g=w,this.h=C,this.i=t,this.j=l,this.k=i,this.b=v(this.h.getItem(yt.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(w=>this.p(w)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(w=>{w.newCount-w.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(w=>this.p(w))}m(){this.f=!0,this.n()}n(){const w=new Set,C={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!C.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(C.lastActiveWindow=this.r(i),C.lastActiveWindow.uiState.mode===3&&w.add(C.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(C.lastPluginDevelopmentHostWindow=this.r(t),C.lastPluginDevelopmentHostWindow.uiState.mode===3&&(w.has(C.lastPluginDevelopmentHostWindow.uiState.display)?s.isMacintosh&&!t.win?.isSimpleFullScreen()&&(C.lastPluginDevelopmentHostWindow.uiState.mode=1):w.add(C.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(C.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.r(i);return n.uiState.mode===3&&(w.has(n.uiState.display)?s.isMacintosh&&n.windowId!==C.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):w.add(n.uiState.display)),n}));const l=g(C);this.h.setItem(yt.a,l),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",l)}p(w){if(this.i.quitRequested)return;const C=this.r(w);w.isExtensionDevelopmentHost&&!w.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=C:!w.isExtensionDevelopmentHost&&w.openedWorkspace&&this.b.openedWindows.forEach(t=>{const l=(0,d.isWorkspaceIdentifier)(w.openedWorkspace)&&t.workspace?.id===w.openedWorkspace.id,i=(0,d.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,w.openedWorkspace.uri);(l||i)&&(t.uiState=C.uiState)}),this.g.getWindowCount()===1&&(this.c=C)}r(w){return{windowId:w.id,workspace:(0,d.isWorkspaceIdentifier)(w.openedWorkspace)?w.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)?w.openedWorkspace.uri:void 0,backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.serializeWindowState()}}getNewWindowState(w){const C=this.s(w),t=this.k.getValue("window");if(C.mode===3){let l;C.hasDefaultState?l=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):l=!!(this.i.wasRestarted||t?.restoreFullscreen),l||(C.mode=1)}return C}s(w){const C=this.g.getLastActiveWindow();if(!w.extensionTestsPath){if(!!w.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=w.workspace;if((0,d.isWorkspaceIdentifier)(c)){const m=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(m.length)return m[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(c)){const m=this.state.openedWindows.filter(D=>D.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(m.length)return m[0]}else if(w.backupPath){const m=this.state.openedWindows.filter(D=>D.backupPath===w.backupPath).map(D=>D.uiState);if(m.length)return m[0]}const o=this.c||this.state.lastActiveWindow;if(!C&&o)return o.uiState}let t;const l=I.screen.getAllDisplays();if(l.length===1)t=l[0];else{if(s.isMacintosh){const c=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(c)}!t&&C&&(t=I.screen.getDisplayMatching(C.getBounds())),t||(t=I.screen.getPrimaryDisplay()||l[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.k.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&C){const c=C.serializeWindowState();c.mode===3?i.mode=3:i=c,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.t(i)),i.hasDefaultState=!0,i}t(w){if(this.g.getWindows().length===0)return w;w.x=typeof w.x=="number"?w.x:0,w.y=typeof w.y=="number"?w.y:0;const C=this.g.getWindows().map(t=>t.getBounds());for(;C.some(t=>t.x===w.x||t.y===w.y);)w.x+=30,w.y+=30;return w}};E.a="windowsState",E=ye([Q(0,y.IWindowsMainService),Q(1,p.IStateService),Q(2,f.ILifecycleMainService),Q(3,u.ILogService),Q(4,k.IConfigurationService)],E),e.WindowsStateHandler=E;function v(S){const w={openedWindows:[]},C=S||{openedWindows:[]};return C.lastActiveWindow&&(w.lastActiveWindow=r(C.lastActiveWindow)),C.lastPluginDevelopmentHostWindow&&(w.lastPluginDevelopmentHostWindow=r(C.lastPluginDevelopmentHostWindow)),Array.isArray(C.openedWindows)&&(w.openedWindows=C.openedWindows.map(t=>r(t))),w}e.restoreWindowsState=v;function r(S){const w={uiState:S.uiState};return S.backupPath&&(w.backupPath=S.backupPath),S.remoteAuthority&&(w.remoteAuthority=S.remoteAuthority),S.folder&&(w.folderUri=R.URI.parse(S.folder)),S.workspaceIdentifier&&(w.workspace={id:S.workspaceIdentifier.id,configPath:R.URI.parse(S.workspaceIdentifier.configURIPath)}),w}function g(S){return{lastActiveWindow:S.lastActiveWindow&&h(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&h(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(w=>h(w))}}e.getWindowsStateStoreData=g;function h(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(ee[98],te([0,1,32,43,130,45,15,9,4,18,8,6,57,29]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function E(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function v(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=v;function r(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=r;function g(D){return h(D)||S(D)}e.isStoredWorkspaceFolder=g;function h(D){const M=D;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function S(D){const M=D;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function w(D,M,T,N,$){if(D.scheme!==N.scheme)return{name:T,uri:D.toString(!0)};let q=M?void 0:$.relativePath(N,D);if(q!==void 0)q.length===0?q=".":f.isWindows&&(q=C(q));else if(D.scheme===R.Schemas.file)q=D.fsPath,f.isWindows&&(q=C(q));else if($.isEqualAuthority(D.authority,N.authority))q=D.path;else return{name:T,uri:D.toString(!0)};return{name:T,path:q}}e.getStoredWorkspaceFolder=w;function C(D){return D=(0,A.normalizeDriveLetter)(D),(0,I.isUNC)(D)||(D=(0,I.toSlashes)(D)),D}function t(D,M,T){const N=[],$=new Set,q=T.dirname(M);for(const ie of D){let oe;if(h(ie))ie.path&&(oe=T.resolvePath(q,ie.path));else if(S(ie))try{oe=p.URI.parse(ie.uri),oe.path[0]!==k.posix.sep&&(oe=oe.with({path:k.posix.sep+oe.path}))}catch(ae){console.warn(ae)}if(oe){const ae=T.getComparisonKey(oe);if(!$.has(ae)){$.add(ae);const de=ie.name||T.basenameOrAuthority(oe);N.push(new d.WorkspaceFolder({uri:oe,name:de,index:N.length},ie))}}}return N}e.toWorkspaceFolders=t;function l(D,M,T,N,$){const q=i(M,D),ie=$.dirname(M),oe=$.dirname(N),ae=[];for(const J of q.folders){const H=h(J)?$.resolvePath(ie,J.path):p.URI.parse(J.uri);let W;T?W=!1:W=!h(J)||(0,k.isAbsolute)(J.path),ae.push(w(H,W,J.name,oe,$))}const de={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ce=s.setProperty(D,["folders"],ae,de);let X=s.applyEdits(D,ce);return(0,u.isEqualAuthority)(q.remoteAuthority,(0,b.getRemoteAuthority)(N))&&(X=s.applyEdits(X,s.removeProperty(X,["remoteAuthority"],de))),X}e.rewriteWorkspaceFileForNewLocation=l;function i(D,M){const T=L.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>g(N));else throw new Error(`${D} looks like an invalid workspace file.`);return T}function n(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function o(D,M){const T={workspaces:[],files:[]};if(D){const N=function(q,ie){for(let oe=0;oe<q.length;oe++)try{ie(q[oe],oe)}catch(ae){M.warn(`Error restoring recent entry ${JSON.stringify(q[oe])}: ${ae.toString()}. Skip entry.`)}},$=D;Array.isArray($.entries)&&N($.entries,q=>{const ie=q.label,oe=q.remoteAuthority;n(q)?T.workspaces.push({label:ie,remoteAuthority:oe,workspace:{id:q.workspace.id,configPath:p.URI.parse(q.workspace.configPath)}}):a(q)?T.workspaces.push({label:ie,remoteAuthority:oe,folderUri:p.URI.parse(q.folderUri)}):c(q)&&T.files.push({label:ie,remoteAuthority:oe,fileUri:p.URI.parse(q.fileUri)})})}return T}e.restoreRecentlyOpened=o;function m(D){const M={entries:[]};for(const T of D.workspaces)v(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of D.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}e.toStoreData=m}),define(ee[99],te([0,1,83,15,4,18]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(u){function p(){let y=u.scheme===L.Schemas.file?(0,A.originalFSPath)(u):u.toString();return s.isLinux||(y=y.toLowerCase()),(0,I.createHash)("md5").update(y).digest("hex")}return{id:p(),configPath:u}}e.getWorkspaceIdentifier=R;function k(u,p){function y(){if(u.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(u.toString()).digest("hex");if(!p)return;let d;return s.isLinux?d=p.ino:s.isMacintosh?d=p.birthtime.getTime():s.isWindows&&(typeof p.birthtimeMs=="number"?d=Math.floor(p.birthtimeMs):d=p.birthtime.getTime()),(0,I.createHash)("md5").update(u.fsPath).update(d?String(d):"").digest("hex")}const b=y();if(typeof b=="string")return{id:b,uri:u}}e.getSingleFolderWorkspaceIdentifier=k;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[279],te([0,1,83,32,15,9,4,18,24,190,19,28,33,16,5,189,29,99]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let h=class vt{constructor(w,C,t,l){this.j=w,this.k=C,this.l=t,this.m=l,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,n)=>(0,L.isEqual)(i,n,!R.isLinux)}}async initialize(){const w=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(w.emptyWindows),this.d=await this.u((0,u.deserializeWorkspaceInfos)(w)),this.e=await this.v((0,u.deserializeFolderInfos)(w)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.HotExitConfiguration.OFF}q(){return this.s()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(w,C){this.d.some(l=>w.workspace.id===l.workspace.id)||(this.d.push(w),this.C());const t=(0,A.join)(this.c,w.workspace.id);return C?this.t(t,C).then(()=>t):t}async t(w,C){if(await f.Promises.exists(w)&&await this.z(w),await f.Promises.exists(C))try{await f.Promises.rename(C,w)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(w){return this.e.some(C=>this.h.isEqual(w.folderUri,C.folderUri))||(this.e.push(w),this.C()),(0,A.join)(this.c,this.D(w))}registerEmptyWindowBackup(w){return this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,w.backupFolder))||(this.g.push(w),this.C()),(0,A.join)(this.c,w.backupFolder)}async u(w){if(!Array.isArray(w))return[];const C=new Set,t=[];for(const l of w){const i=l.workspace;if(!(0,r.isWorkspaceIdentifier)(i))return[];if(!C.has(i.id)){C.add(i.id);const n=(0,A.join)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(l):await this.z(n):await this.x(n)}}return t}async v(w){if(!Array.isArray(w))return[];const C=[],t=new Set;for(const l of w){const i=l.folderUri,n=this.h.getComparisonKey(i);if(!t.has(n)){t.add(n);const a=(0,A.join)(this.c,this.D(l));await this.B(a)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?C.push(l):await this.z(a):await this.x(a)}}return C}async w(w){if(!Array.isArray(w))return[];const C=[],t=new Set;for(const l of w){const i=l.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,A.join)(this.c,i);await this.B(n)?C.push(l):await this.x(n)}}return C}async x(w){try{await f.Promises.rm(w,f.RimRafMode.MOVE)}catch(C){this.l.error(`Backup: Could not delete stale backup: ${C.toString()}`)}}y(){let w=(0,g.createEmptyWorkspaceIdentifier)();for(;this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,w.id));)w=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:w.id}}async z(w){const C=this.y(),t=(0,A.join)(this.c,C.backupFolder);try{await f.Promises.rename(w,t)}catch(l){return this.l.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.g.push(C),!0}async getDirtyWorkspaces(){const w=[];for(const C of this.d)await this.A(C)&&w.push(C);for(const C of this.e)await this.A(C)&&w.push(C);return w}A(w){let C;return(0,u.isEmptyWindowBackupInfo)(w)?C=(0,A.join)(this.c,w.backupFolder):(0,v.isFolderBackupInfo)(w)?C=(0,A.join)(this.c,this.D(w)):C=(0,A.join)(this.c,w.workspace.id),this.B(C)}async B(w){try{const C=await f.Promises.readdir(w);for(const t of C)try{if((await f.Promises.readdir((0,A.join)(w,t))).length>0)return!0}catch{}}catch{}return!1}C(){const w={workspaces:this.d.map(({workspace:C,remoteAuthority:t})=>{const l={id:C.id,configURIPath:C.configPath.toString()};return t&&(l.remoteAuthority=t),l}),folders:this.e.map(({folderUri:C,remoteAuthority:t})=>{const l={folderUri:C.toString()};return t&&(l.remoteAuthority=t),l}),emptyWindows:this.g.map(({backupFolder:C,remoteAuthority:t})=>{const l={backupFolder:C};return t&&(l.remoteAuthority=t),l})};this.m.setItem(vt.a,w)}D(w){const C=w.folderUri;let t;return C.scheme===s.Schemas.file?t=R.isLinux?C.fsPath:C.fsPath.toLowerCase():t=C.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};h.a="backupWorkspaces",h=ye([Q(0,y.IEnvironmentMainService),Q(1,p.IConfigurationService),Q(2,E.ILogService),Q(3,b.IStateService)],h),e.BackupMainService=h}),define(ee[54],te([0,1,14,3,43,2,15,9,18,11,24,188,63,58,28,6,5,53,125,29,98,99]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,v.createDecorator)("workspacesManagementMainService");let t=class extends A.Disposable{constructor(i,n,a,c,o){super(),this.g=i,this.h=n,this.i=a,this.j=c,this.k=o,this.a=this.B(new L.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new L.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await p.Promises.readdir(this.c.fsPath)).map(n=>(0,f.joinPath)(this.c,n,S.UNTITLED_WORKSPACE_NAME));for(const n of i){const a=(0,C.getWorkspaceIdentifier)(n),c=await this.resolveLocalWorkspace(n);c?this.f.push({workspace:a,remoteAuthority:c.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,n=>p.Promises.readFile(n,"utf8"))}l(i,n){if(!!this.m(i)&&i.scheme===R.Schemas.file)try{const a=n(i.fsPath);return a instanceof Promise?a.then(c=>this.n(i,c),c=>{}):this.n(i,a)}catch{return}}m(i){return(0,S.isUntitledWorkspace)(i,this.g)||(0,S.hasWorkspaceFileExtension)(i)}n(i,n){try{const a=this.p(i,n),c=(0,C.getWorkspaceIdentifier)(i);return{id:c.id,configPath:c.configPath,folders:(0,w.toWorkspaceFolders)(a.folders,c.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}p(i,n){const a=(0,s.parse)(n);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(c=>(0,w.isStoredWorkspaceFolder)(c));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(i,n){const{workspace:a,storedWorkspace:c}=this.r(i,n),o=a.configPath.fsPath;return await p.Promises.mkdir((0,k.dirname)(o),{recursive:!0}),await p.Promises.writeFile(o,JSON.stringify(c,null,"	")),this.f.push({workspace:a,remoteAuthority:n}),a}r(i=[],n){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),c=(0,f.joinPath)(this.c,a),o=(0,f.joinPath)(c,S.UNTITLED_WORKSPACE_NAME),m=[];for(const D of i)m.push((0,w.getStoredWorkspaceFolder)(D.uri,!0,D.name,c,f.extUriBiasedIgnorePathCase));return{workspace:(0,C.getWorkspaceIdentifier)(o),storedWorkspace:{folders:m,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,C.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,S.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const n=(0,f.originalFSPath)(i.configPath);try{await p.Promises.rm((0,k.dirname)(n));const a=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await p.Promises.exists(a)&&await p.Promises.writeFile((0,k.join)(a,"obsolete"),""),this.f=this.f.filter(c=>c.workspace.id!==i.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${n} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,n,a){if(!i||!i.win||!i.isReady||!await this.t(i,n,a))return;const o=await this.u(i,(0,C.getWorkspaceIdentifier)(a));if(!!o)return this.b.fire({window:i,workspace:o.workspace}),o}async t(i,n,a){return a?(0,S.isWorkspaceIdentifier)(i.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,a)?!1:(0,h.findWindowOnWorkspaceOrFolder)(n,a)?(await this.k.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,f.basename)(a)),detail:(0,y.localize)(2,null)},(0,u.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,n){if(!i.config)return;i.focus();let a;return i.config.extensionDevelopmentPath||(i.config.backupPath?a=await this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):a=this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,S.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=a,{workspace:n,backupPath:a}}};t=ye([Q(0,E.IEnvironmentMainService),Q(1,r.ILogService),Q(2,g.IUserDataProfilesMainService),Q(3,b.IBackupMainService),Q(4,d.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(ee[126],te([0,1,14,42,23,6,30,29,54,11,5,70]),function(x,e,I,L,s,A,R,k,f,u,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let b=class{constructor(E,v,r){this.a=E,this.b=v,this.c=r}async getRemoteDiagnostics(E){const v=this.a.getWindows();return(await Promise.all(v.map(async g=>{const h=g.remoteAuthority;if(!h)return;const S=`vscode:getDiagnosticInfoResponse${g.id}`,w={includeProcesses:E.includeProcesses,folders:E.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(C=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:S,args:w}),L.validatedIpcMain.once(S,(t,l)=>{l||C({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),C(l)}),setTimeout(()=>{C({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const E=[];for(const r of I.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(r.id);g?E.push(await this.d(g)):E.push(this.e(r))}const v=[];for(const{pid:r,name:g}of y.UtilityProcess.getAll())v.push({pid:r,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:E,pidToNames:v,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(E){const v=await this.f(E),r=(0,u.assertIsDefined)(E.win);return this.e(r,v,E.remoteAuthority)}e(E,v=[],r){return{id:E.id,pid:E.webContents.getOSProcessId(),title:E.getTitle(),folderURIs:v,remoteAuthority:r}}async f(E){const v=[],r=E.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(r))v.push(r.uri);else if((0,k.isWorkspaceIdentifier)(r)){const g=await this.b.resolveLocalWorkspace(r.configPath);g&&g.folders.forEach(S=>{v.push(S.uri)})}return v}};b=ye([Q(0,R.IWindowsMainService),Q(1,f.IWorkspacesManagementMainService),Q(2,p.ILogService)],b),e.DiagnosticsMainService=b}),define(ee[59],te([0,1,46,14,27,151,55,3,2,15,9,4,8,103,86,24,101,178,58,28,6,20,5,21,69,30,29,54,17,237,230,33]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,w.createDecorator)("nativeHostMainService");let T=class extends f.Disposable{constructor($,q,ie,oe,ae,de,ce,X,J,H){super(),this.a=$,this.b=q,this.c=ie,this.f=oe,this.g=ae,this.h=de,this.i=ce,this.j=X,this.k=J,this.l=H,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,W=>W.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:W,x:V,y:Y})=>({windowId:W.id,x:V,y:Y})),({windowId:W})=>!!this.b.getWindowById(W)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(W,V)=>V.id),W=>!!this.b.getWindowById(W)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(W,V)=>V.id),W=>!!this.b.getWindowById(W)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,V)=>V.id),W=>!!this.b.getWindowById(W)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),W=>!!W),W=>W.id),k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,V)=>V.id),W=>!!this.b.getWindowById(W))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(W,V,Y)=>Y),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),k.Event.fromNodeEventEmitter(L.screen,"display-added"),k.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(q=>({id:q.id,workspace:q.openedWorkspace??(0,a.toWorkspaceIdentifier)(q.backupPath,q.isExtensionDevelopmentHost),title:q.win?.getTitle()??"",filename:q.getRepresentedFilename(),dirty:q.isDocumentEdited()}))}async getWindowCount($){return this.b.getWindowCount()}async getActiveWindowId($){const q=L.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(q)return q.id}openWindow($,q,ie){return Array.isArray(q)?this.n($,q,ie):this.p($,q)}async n($,q,ie=Object.create(null)){q.length>0&&await this.b.open({context:5,contextWindowId:$,urisToOpen:q,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p($,q){await this.b.openEmptyWindow({context:5,contextWindowId:$},q)}async toggleFullScreen($){this.w($)?.toggleFullScreen()}async handleTitleDoubleClick($){this.w($)?.handleTitleDoubleClick()}async isMaximized($){const q=this.w($);return q?.win?q.win.isMaximized():!1}async maximizeWindow($){const q=this.w($);q?.win&&q.win.maximize()}async unmaximizeWindow($){const q=this.w($);q?.win&&q.win.unmaximize()}async minimizeWindow($){const q=this.w($);q?.win&&q.win.minimize()}async updateWindowControls($,q){const ie=this.w($);ie&&ie.updateWindowControls(q)}async focusWindow($,q){q&&typeof q.windowId=="number"&&($=q.windowId),this.w($)?.focus({force:q?.force??!1})}async setMinimumSize($,q,ie){const oe=this.w($);if(oe?.win){const[ae,de]=oe.win.getSize(),[ce,X]=oe.win.getMinimumSize(),[J,H]=[q??ce,ie??X],[W,V]=[Math.max(ae,J),Math.max(de,H)];(ce!==J||X!==H)&&oe.win.setMinimumSize(J,H),(ae!==W||de!==V)&&oe.win.setSize(W,V)}}async saveWindowSplash($,q){this.j.saveWindowSplash($,q)}async installShellCommand($){const{source:q,target:ie}=await this.r();try{const{symbolicLink:oe}=await v.SymlinkSupport.stat(q);if(oe&&!oe.dangling){const ae=await(0,d.realpath)(q);if(ie===ae)return}await v.Promises.unlink(q)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await v.Promises.symlink(ie,q)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ae}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ae===0)try{const de=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${q}'\\" with administrator privileges"`;await(0,A.promisify)(I.exec)(de)}catch{throw new Error((0,g.localize)(3,null,q))}}}async uninstallShellCommand($){const{source:q}=await this.r();try{await v.Promises.unlink(q)}catch(ie){switch(ie.code){case"EACCES":{const{response:oe}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(oe===0)try{const ae=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,A.promisify)(I.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,q))}break}case"ENOENT":break;default:throw ie}}}async r(){const $=(0,p.resolve)(this.g.appRoot,"bin","code"),q=`/usr/local/bin/${this.i.applicationName}`;if(!await v.Promises.exists($))throw new Error((0,g.localize)(8,null,$));return{source:q,target:$}}async showMessageBox($,q){return this.c.showMessageBox(q,this.s($))}async showSaveDialog($,q){return this.c.showSaveDialog(q,this.s($))}async showOpenDialog($,q){return this.c.showOpenDialog(q,this.s($))}s($){const q=this.w($);if(q?.win)return q.win}async pickFileFolderAndOpen($,q){const ie=await this.c.pickFileFolder(q);ie&&await this.t(await Promise.all(ie.map(async oe=>await v.SymlinkSupport.existsDirectory(oe)?{folderUri:b.URI.file(oe)}:{fileUri:b.URI.file(oe)})),q,$)}async pickFolderAndOpen($,q){const ie=await this.c.pickFolder(q);ie&&await this.t(ie.map(oe=>({folderUri:b.URI.file(oe)})),q,$)}async pickFileAndOpen($,q){const ie=await this.c.pickFile(q);ie&&await this.t(ie.map(oe=>({fileUri:b.URI.file(oe)})),q,$)}async pickWorkspaceAndOpen($,q){const ie=await this.c.pickWorkspace(q);ie&&await this.t(ie.map(oe=>({workspaceUri:b.URI.file(oe)})),q,$)}async t($,q,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:$,forceNewWindow:q.forceNewWindow})}async showItemInFolder($,q){L.shell.showItemInFolder(q)}async setRepresentedFilename($,q){this.w($)?.setRepresentedFilename(q)}async setDocumentEdited($,q){this.w($)?.setDocumentEdited(q)}async openExternal($,q){return y.isLinuxSnap?this.u(q):L.shell.openExternal(q),!0}u($){const q=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR,oe=process.env.GTK_IM_MODULE_FILE,ae=process.env.GDK_BACKEND,de=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,L.shell.openExternal($),process.env.GDK_PIXBUF_MODULE_FILE=q,process.env.GDK_PIXBUF_MODULEDIR=ie,process.env.GTK_IM_MODULE_FILE=oe,process.env.GDK_BACKEND=ae,process.env.GIO_MODULE_DIR=de,process.env.GTK_EXE_PREFIX=ce}moveItemToTrash($,q){return L.shell.trashItem(q)}async isAdmin(){let $;return y.isWindows?$=(await new Promise((q,ie)=>{x(["native-is-elevated"],q,ie)}))():$=process.getuid()===0,$}async writeElevated($,q,ie,oe){const ae=await new Promise((de,ce)=>{x(["@vscode/sudo-prompt"],de,ce)});return new Promise((de,ce)=>{const X=[`"${this.v}"`];oe?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${q.fsPath}"`,`"${ie.fsPath}"`);const J={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,p.join)((0,p.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(X.join(" "),J,(H,W,V)=>{W&&this.h.trace(`[sudo-prompt] received stdout: ${W}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),H?ce(H):de(void 0)})})}get v(){return y.isWindows?this.g.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,p.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,p.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.join)(this.g.appRoot,"bin","code"):(0,p.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,m.hasWSLFeatureInstalled)()}async killProcess($,q,ie){process.kill(q,ie)}async readClipboardText($,q){return L.clipboard.readText(q)}async writeClipboardText($,q,ie){return L.clipboard.writeText(q,ie)}async readClipboardFindText($){return L.clipboard.readFindText()}async writeClipboardFindText($,q){return L.clipboard.writeFindText(q)}async writeClipboardBuffer($,q,ie,oe){return L.clipboard.writeBuffer(q,Buffer.from(ie.buffer),oe)}async readClipboardBuffer($,q){return o.VSBuffer.wrap(L.clipboard.readBuffer(q))}async hasClipboard($,q,ie){return L.clipboard.has(q,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar($,q){this.w($)?.updateTouchBar(q)}async notifyReady($){this.w($)?.setReady()}async relaunch($,q){return this.f.relaunch(q)}async reload($,q){const ie=this.w($);if(ie){if((0,a.isWorkspaceIdentifier)(ie.openedWorkspace)){const oe=ie.openedWorkspace.configPath;if(oe.scheme===u.Schemas.file&&(await this.l.resolveLocalWorkspace(oe))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow($){this.closeWindowById($,$)}async closeWindowById($,q){const ie=this.w(q);if(ie?.win)return ie.win.close()}async quit($){const q=this.b.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&q.win?q.win.close():this.f.quit()}async exit($,q){await this.f.kill(q)}async resolveProxy($,q){return this.w($)?.win?.webContents?.session?.resolveProxy(q)}findFreePort($,q,ie,oe,ae=1){return(0,r.findFreePort)(q,ie,oe,ae)}async openDevTools($,q){const ie=this.w($);ie?.win&&ie.win.webContents.openDevTools(q)}async toggleDevTools($){const q=this.w($);q?.win&&q.win.webContents.toggleDevTools()}async sendInputEvent($,q){const ie=this.w($);ie?.win&&(q.type==="mouseDown"||q.type==="mouseUp")&&ie.win.webContents.sendInputEvent(q)}async enableSandbox($,q){q?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer($,q,ie){const oe=this.w($);if(!oe||!oe.win)throw new Error;return await new D.WindowProfiler(oe.win,q,this.h).inspect(ie)}async windowsGetStringRegKey($,q,ie,oe){if(!y.isWindows)return;const ae=await new Promise((de,ce)=>{x(["@vscode/windows-registry"],de,ce)});try{return ae.GetStringRegKey(q,ie,oe)}catch{return}}w($){if(typeof $=="number")return this.b.getWindowById($)}};ye([R.memoize],T.prototype,"v",null),T=ye([Q(1,n.IWindowsMainService),Q(2,h.IDialogMainService),Q(3,C.ILifecycleMainService),Q(4,S.IEnvironmentMainService),Q(5,t.ILogService),Q(6,l.IProductService),Q(7,i.IThemeMainService),Q(8,M.IStateService),Q(9,c.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(ee[280],te([0,1,14,42,27,2,15,4,104,176,89,126,58,28,6,5,59,66,21,67,79,32,11,33,70]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");const n="issue.processExplorerWindowState";let a=class Dt{constructor(m,D,M,T,N,$,q,ie,oe,ae){this.g=m,this.h=D,this.i=M,this.j=T,this.k=N,this.l=$,this.m=q,this.n=ie,this.o=oe,this.p=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){L.validatedIpcMain.on("vscode:issueSystemInfoRequest",async m=>{const[D,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(D,M);this.r(m,"vscode:issueSystemInfoResponse",T)}),L.validatedIpcMain.on("vscode:listProcesses",async m=>{const D=[];try{D.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,p.isRemoteDiagnosticError)(T)?D.push({name:T.hostName,rootProcess:T}):T.processes&&D.push({name:T.hostName,rootProcess:T.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.r(m,"vscode:listProcessesResponse",D)}),L.validatedIpcMain.on("vscode:issueReporterClipboard",async m=>{if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(1,null),buttons:[(0,u.localize)(2,null),(0,u.localize)(3,null)]},this.b);this.r(m,"vscode:issueReporterClipboardResponse",D===0)}}),L.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async m=>{const D=await this.v();this.r(m,"vscode:issuePerformanceInfoResponse",D)}),L.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:m}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(4,null),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]},this.b);m===0&&this.b&&(this.b.destroy(),this.b=null)}}),L.validatedIpcMain.on("vscode:workbenchCommand",(m,D)=>{const{id:M,from:T,args:N}=D;let $;switch(T){case"issueReporter":$=this.c;break;case"processExplorer":$=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}$?.webContents.send("vscode:runAction",{id:M,from:T,args:N})}),L.validatedIpcMain.on("vscode:openExternal",(m,D)=>{this.m.openExternal(void 0,D)}),L.validatedIpcMain.on("vscode:closeIssueReporter",m=>{this.b?.close()}),L.validatedIpcMain.on("vscode:closeProcessExplorer",m=>{this.d?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async m=>{const D=await this.k.getMainDiagnostics(),M=[];for(const T of D.windows)M.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:N}of i.UtilityProcess.getAll())M.push([T,N]);this.r(m,"vscode:pidToNameResponse",M)})}r(m,D,...M){m.sender.isDestroyed()||m.sender.send(D,...M)}async openReporter(m){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const D=new A.DisposableStore,M=D.add(this.n.createIPCObjectUrl()),T=this.u(this.c,700,800);this.b=this.t(T,M,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(7,null),zoomLevel:m.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:m,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:g.default}),this.b.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,D.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,D.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(m){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const D=new A.DisposableStore,M=D.add(this.n.createIPCObjectUrl()),T=this.p.getItem(n,void 0),N=c(T)?T:this.u(this.f,800,500);this.d=this.t(N,M,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(8,null),zoomLevel:m.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:m,product:g.default}),this.d.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,D.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,D.dispose())});const $=()=>{if(!this.d)return;const q=this.d.getSize(),ie=this.d.getPosition();if(!q||!ie)return;const oe={width:q[0],height:q[1],x:ie[0],y:ie[1]};this.p.setItem(n,oe)};this.d.on("moved",$),this.d.on("resized",$)}this.d&&this.s(this.d)}s(m){m.isMinimized()&&m.restore(),m.focus()}t(m,D,M,T){const N=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:m.width,height:m.height,minWidth:300,minHeight:200,x:m.x,y:m.y,title:M.title,backgroundColor:M.backgroundColor||Dt.a,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,w.zoomLevelToZoomFactor)(M.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return N.setMenuBarVisibility(!1),N}async getSystemStatus(){const[m,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(m,D)}u(m,D,M){let T;const N=I.screen.getAllDisplays();if(N.length===1)T=N[0];else{if(k.isMacintosh){const ie=I.screen.getCursorScreenPoint();T=I.screen.getDisplayNearestPoint(ie)}!T&&m&&(T=I.screen.getDisplayMatching(m.getBounds())),T||(T=I.screen.getPrimaryDisplay()||N[0])}const $=T.bounds,q={width:D,height:M,x:$.x+$.width/2-D/2,y:$.y+$.height/2-M/2};return $.width>0&&$.height>0&&(q.x<$.x&&(q.x=$.x),q.y<$.y&&(q.y=$.y),q.x>$.x+$.width&&(q.x=$.x),q.y>$.y+$.height&&(q.y=$.y),q.width>$.width&&(q.width=$.width),q.height>$.height&&(q.height=$.height)),q}async v(){try{const[m,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(m,D)}catch(m){throw this.i.warn("issueService#getPerformanceInfo ",m.message),m}}async stopTracing(){if(!this.h.args.trace)return;const m=await I.contentTracing.stopRecording(`${(0,C.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(9,null),detail:(0,u.localize)(10,null,m),buttons:[(0,u.localize)(11,null)]},(0,t.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,m)}};a.a="#1E1E1E",a=ye([Q(1,d.IEnvironmentMainService),Q(2,v.ILogService),Q(3,p.IDiagnosticsService),Q(4,y.IDiagnosticsMainService),Q(5,b.IDialogMainService),Q(6,r.INativeHostMainService),Q(7,S.IProtocolMainService),Q(8,h.IProductService),Q(9,l.IStateService)],a),e.IssueMainService=a;function c(o){return typeof o!="object"||o===null?!1:"x"in o&&"y"in o&&"width"in o&&"height"in o}}),define(ee[281],te([0,1,23,19,28,20,5,59,21,52,25,49,95]),function(x,e,I,L,s,A,R,k,f,u,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends b.AbstractUpdateService{constructor(v,r,g,h,S,w,C,t){super(v,r,h,S,w,t),this.e=g,this.u=C}s(v){return(0,b.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(y.State.CheckingForUpdates(v)),this.i.request({url:this.a},I.CancellationToken.None).then(u.asJson).then(r=>{!r||!r.url||!r.version||!r.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.State.Idle(1))):this.d(y.State.AvailableForDownload(r))}).then(void 0,r=>{this.j.error(r),this.e.publicLog2("update:notAvailable",{explicit:!!v});const g=v?r.message||r:void 0;this.d(y.State.Idle(1,g))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.State.Idle(1))}};d=ye([Q(0,A.ILifecycleMainService),Q(1,L.IConfigurationService),Q(2,p.ITelemetryService),Q(3,s.IEnvironmentMainService),Q(4,u.IRequestService),Q(5,R.ILogService),Q(6,k.INativeHostMainService),Q(7,f.IProductService)],d),e.LinuxUpdateService=d}),define(ee[282],te([0,1,46,41,27,7,23,55,9,8,137,24,19,28,16,20,5,59,21,52,25,49,95]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(c,o=1e3){for(;!c();)await(0,A.timeout)(o)}let i;function n(){return typeof i>"u"&&(i=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let a=class extends t.AbstractUpdateService{get cachePath(){const o=f.join((0,s.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return y.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,m,D,M,T,N,$,q,ie){super(o,m,M,T,N,ie),this.u=D,this.v=$,this.w=q}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(o){let m="win32";return process.arch!=="ia32"&&(m+=`-${process.arch}`),n()===1?m+="-archive":this.k.target==="user"&&(m+="-user"),(0,t.createUpdateURL)(m,o,this.k)}t(o){!this.a||(this.d(C.State.CheckingForUpdates(o)),this.i.request({url:this.a},R.CancellationToken.None).then(S.asJson).then(m=>{const D=n();return!m||!m.url||!m.version||!m.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(C.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(C.State.AvailableForDownload(m)),Promise.resolve(null)):(this.d(C.State.Downloading(m)),this.C(m.version).then(()=>this.B(m.version).then(M=>y.Promises.exists(M).then(T=>{if(T)return Promise.resolve(M);const N=m.url,$=m.hash,q=`${M}.tmp`;return this.i.request({url:N},R.CancellationToken.None).then(ie=>this.v.writeFile(u.URI.file(q),ie.stream)).then($?()=>(0,p.checksum)(q,m.hash):()=>{}).then(()=>y.Promises.rename(q,M)).then(()=>M)})).then(M=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},T&&m.supportsFastUpdate?this.k.target==="user"?this.p():this.d(C.State.Downloaded(m)):this.d(C.State.Ready(m))})))}).then(void 0,m=>{this.j.error(m),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?m.message||m:void 0;this.d(C.State.Idle(n(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(C.State.Idle(n()))}async B(o){const m=await this.cachePath;return f.join(m,`CodeSetup-${this.k.quality}-${o}.exe`)}async C(o=null){const m=o?N=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(N):()=>!0,D=await this.cachePath,T=(await y.Promises.readdir(D)).filter(m).map(async N=>{try{await y.Promises.unlink(f.join(D,N))}catch{}});await Promise.all(T)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(C.State.Updating(o));const m=await this.cachePath;this.e.updateFilePath=f.join(m,`CodeSetup-${this.k.quality}-${o.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(C.State.Idle(n()))});const M=`${this.k.win32MutexName}-ready`,T=await new Promise((N,$)=>{x(["windows-mutex"],N,$)});l(()=>T.isActive(M)).then(()=>this.d(C.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?L.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const m=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!m};this.d(C.State.Downloading(D)),this.e={packagePath:o},m?this.k.target==="user"?this.p():this.d(C.State.Downloaded(D)):this.d(C.State.Ready(D))}};ye([k.memoize],a.prototype,"cachePath",null),a=ye([Q(0,v.ILifecycleMainService),Q(1,b.IConfigurationService),Q(2,w.ITelemetryService),Q(3,d.IEnvironmentMainService),Q(4,S.IRequestService),Q(5,r.ILogService),Q(6,E.IFileService),Q(7,g.INativeHostMainService),Q(8,h.IProductService)],a),e.Win32UpdateService=a}),define(ee[283],te([0,1,14,7,23,44,3,2,15,9,64,4,8,184,63,19,58,28,62,16,20,5,21,67,245,97,25,136,69,79,30,29,54,123,127,38,33,53,59,247,119,48,94,27,120,65,22]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M,T,N,$,q,ie,oe,ae,de,ce,X,J,H,W,V,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(ne||(ne={}));let se=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const O=this.Q.profiles.find(P=>P.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&O?O:this.Q.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(O,P,F,U,j,B,z,G,re,he,be,ke,Le,Oe,Fe,me,pe,Ce,Z,ue,fe){super(),this.M=P,this.N=F,this.O=U,this.P=j,this.Q=B,this.R=z,this.S=G,this.U=re,this.W=he,this.X=be,this.Y=ke,this.Z=Le,this.ab=Oe,this.bb=Fe,this.db=me,this.eb=pe,this.fb=Ce,this.gb=Z,this.hb=ue,this.ib=fe,this.c=this.B(new R.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new R.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new R.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new R.Emitter),this.onDidClose=this.h.event,this.j=this.B(new R.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let Ee=!1;{const[Ae,Te]=this.ub(O.state);this.s=Ae,this.M.trace("window#ctor: using window state",Ae);const We=this.s.mode===0||this.s.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const qe=this.W.getValue("window");typeof qe?.experimental?.useSandbox=="boolean"?Ee=qe.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?Ee=!0:Ee=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=Ee;const Ne={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:m.WindowMinimumSize.WIDTH,minHeight:m.WindowMinimumSize.HEIGHT,show:!We,title:this.eb.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(qe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ee?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Ne.icon=(0,u.join)(this.O.appRoot,"resources/linux/code.png"):y.isWindows&&!this.O.isBuilt&&(Ne.icon=(0,u.join)(this.O.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.Bb()&&(Ne.fullscreenable=!1),y.isMacintosh&&(Ne.acceptFirstMouse=!0,qe?.clickThroughInactive===!1&&(Ne.acceptFirstMouse=!1));const Be=y.isMacintosh&&qe?.nativeTabs===!0;Be&&(Ne.tabbingIdentifier=this.eb.nameShort);const Ve=(0,m.getTitleBarStyle)(this.W)==="custom";if(Ve&&(Ne.titleBarStyle="hidden",y.isMacintosh||(Ne.frame=!1),(0,m.useWindowControlsOverlay)(this.W))){const K=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),le=$.Color.fromHex(K).isDarker()?"#FFFFFF":"#000000";Ne.titleBarOverlay={height:29,color:K,symbolColor:le},this.C=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Ne),(0,p.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ve&&this.l.setSheetOffset(22),Ve&&(y.isWindows&&(0,m.useWindowControlsOverlay)(this.W)||y.isMacintosh)){const K=this.hb.getItem(ot.a);K&&this.updateWindowControls({height:K})}y.isWindows&&Ve&&this.l.hookWindowMessage(278,()=>{const[le,ge]=this.l.getPosition(),ve=I.screen.getCursorScreenPoint(),we=ve.x-le,Me=ve.y-ge;return(()=>!(we>30&&Me>=0&&Me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:we,y:Me})),0}),(y.isMacintosh||y.isWindows)&&Te&&(!Be||I.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(K=>typeof K=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),We&&((0,p.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(Ee)}setRepresentedFilename(O){y.isMacintosh?this.l.setRepresentedFilename(O):this.w=O}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(O){y.isMacintosh&&this.l.setDocumentEdited(O),this.z=O}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(O){y.isMacintosh&&O?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.D.push(O)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(O=>{function P(){F.dispose(),U.dispose(),O()}const F=this.onDidClose(()=>P()),U=this.onWillLoad(()=>P())})}kb(O){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:O})),this.l.webContents.on("render-process-gone",(F,U)=>this.nb(2,{...U,sandboxed:O})),this.l.webContents.on("did-fail-load",(F,U,j)=>this.nb(3,{reason:j,exitCode:U,sandboxed:O})),this.l.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",F=>{this.r&&(this.r.maximized=!0),I.app.emit("browser-window-maximize",F,this.l)}),this.l.on("unmaximize",F=>{this.r&&(this.r.maximized=!1),I.app.emit("browser-window-unmaximize",F,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(F=>this.rb(F))),this.B(this.Y.onDidDeleteUntitledWorkspace(F=>this.qb(F)));const P=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:P},async(F,U)=>{const j=await this.mb();U({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,j)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(O,P){switch(O){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:O,reason:P?.reason,code:P?.exitCode,sandboxed:P?.sandboxed?"1":"0"}),O){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:F,checkboxChecked:U}=await this.bb.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this.r?.workspace?(0,d.localize)(5,null):void 0},this.l);if(F!==2){const j=F===0;await this.pb(j,U)}}else if(O===2)if(y.isWindows&&P?.reason==="launch-failed"&&P.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(P);else{let F;P?F=(0,d.localize)(7,null,P.reason,P.exitCode??"<unknown>"):F=(0,d.localize)(6,null);const{response:U,checkboxChecked:j}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:F,detail:this.r?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this.r?.workspace?(0,d.localize)(13,null):void 0},this.l),B=U===0;await this.pb(B,j)}break}}async ob(O){const P=[],F=(0,X.isInternalTelemetry)(this.eb,this.W);if((0,X.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&P.push(new de.OneDataSystemAppender(F,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const j=await(0,W.resolveMachineId)(this.hb,this.M),B={appenders:P,sendErrorTelemetry:!1,commonProperties:(0,J.resolveCommonProperties)((0,H.release)(),(0,H.hostname)(),process.arch,this.eb.commit,this.eb.version,j,F),piiPaths:(0,X.getPiiPathsFromEnvironment)(this.O)};await new ce.TelemetryService(B,this.W,this.eb).publicLog2("windowadminerror",{reason:O.reason,code:O.exitCode})}const{response:U}=await this.bb.showMessageBox({type:"error",buttons:[(0,d.localize)(14,null),(0,d.localize)(15,null)],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.eb.nameLong)},this.l);U===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(P.map(j=>j.flush())),await this.pb(!1,!1)}async pb(O,P){const F=this.r?.workspace;if(P&&F)try{const U=this.U.workspaceStorage(F);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.M.error(U)}if(this.j.fire(),this.l?.destroy(),O&&this.r){let U,j;(0,M.isSingleFolderWorkspaceIdentifier)(F)?U={folderUri:F.uri}:(0,M.isWorkspaceIdentifier)(F)?U={workspaceUri:F.configPath}:j=!0,(0,Y.firstOrDefault)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}qb(O){this.r?.workspace?.id===O.id&&(this.r.workspace=void 0)}rb(O){if(!O||O.affectsConfiguration("window.menuBarVisibility")){const P=this.Cb();P!==this.t&&(this.t=P,this.Db(P))}if(!O||O.affectsConfiguration("http.proxy")){let P=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;P?.endsWith("/")&&(P=P.substr(0,P.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((P||"").indexOf("@")===-1&&(P!==this.G||F!==this.H)){this.G=P,this.H=F;const U=P||"",j=F?`${F},<local>`:"<local>";this.M.trace(`Setting proxy to '${U}', bypassing '${j}'`),this.l.webContents.session.setProxy({proxyRules:U,proxyBypassRules:j,pacScript:""})}}}addTabbedWindow(O){y.isMacintosh&&O.win&&this.l.addTabbedWindow(O.win)}load(O,P=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!P.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),P.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(O,P),this.jb===0?this.r=O:this.J=O,this.jb=1,this.l.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new L.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:O.workspace,reason:P.isReload?3:F?2:1})}sb(O,P){const F=(this.r??this.J)?.userEnv;if(F){const U=(0,h.isLaunchedFromCli)(F)&&!(0,h.isLaunchedFromCli)(O.userEnv),j=this.isExtensionDevelopmentHost;(U||j)&&(O.userEnv={...F,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),P.disableExtensions!==void 0&&(O["disable-extensions"]=P.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this.l.isMaximized(),O.partsSplash=this.X.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),O.perfMarks=(0,p.getMarks)(),this.I.update(O)}async reload(O){const P=Object.assign({},this.r);P.workspace=await this.tb(P),delete P.filesToOpenOrCreate,delete P.filesToDiff,delete P.filesToMerge,delete P.filesToWait,this.isExtensionDevelopmentHost&&O&&(P.verbose=O.verbose,P.debugId=O.debugId,P.extensionEnvironment=O.extensionEnvironment,P["inspect-extensions"]=O["inspect-extensions"],P["inspect-brk-extensions"]=O["inspect-brk-extensions"],P["extensions-dir"]=O["extensions-dir"]),P.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),P.isInitialStartup=!1,P.policiesData=this.P.serialize(),P.continueOn=this.O.continueOn,P.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},P.logLevel=this.N.getLogLevel(),P.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(P,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async tb(O){if((0,M.isWorkspaceIdentifier)(O.workspace)){const P=O.workspace.configPath;if(P.scheme===f.Schemas.file&&!await this.R.exists(P))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(O.workspace)){const P=O.workspace.uri;if(P.scheme===f.Schemas.file&&!await this.R.exists(P))return}return O.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let F;try{F=I.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,N.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.s.width||U.width,height:this.s.height||U.height,x:this.s.x||0,y:this.s.y||0}}const O=Object.create(null);let P;if(!y.isMacintosh&&this.l.isMaximized()?P=0:P=1,P===0?O.mode=0:O.mode=1,P===1||P===0){let F;P===1?F=this.getBounds():F=this.l.getNormalBounds(),O.x=F.x,O.y=F.y,O.width=F.width,O.height=F.height}return O}updateWindowControls(O){if(O.height&&this.hb.setItem(ot.a,O.height),y.isWindows&&this.C)this.l.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0});else if(y.isMacintosh&&O.height!==void 0){const P=(O.height-15)/2;this.l.setTrafficLightPosition({x:P,y:P})}}ub(O){(0,p.mark)("code/willRestoreCodeWindowState");let P=!1;if(O)try{const F=I.screen.getAllDisplays();P=F.length>1,O=this.vb(O,F)}catch(F){this.M.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[O||(0,N.defaultWindowState)(),P]}vb(O,P){if(this.M.trace(`window#validateWindowState: validating window state on ${P.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(P.length===1){const j=this.wb(P[0]);if(j){let B=function(){!O||typeof O.x!="number"||typeof O.y!="number"||!j||(O.x<j.x&&(O.x=j.x),O.y<j.y&&(O.y=j.y))};this.M.trace("window#validateWindowState: 1 monitor working area",j),B(),O.width>j.width&&(O.width=j.width),O.height>j.height&&(O.height=j.height),O.x>j.x+j.width-128&&(O.x=j.x+j.width-O.width),O.y>j.y+j.height-128&&(O.y=j.y+j.height-O.height),B()}return O}if(O.display&&O.mode===3){const j=P.find(B=>B.id===O.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,N.defaultWindowState)(3);return B.x=j.bounds.x,B.y=j.bounds.y,B}}let F,U;try{F=I.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),U=this.wb(F)}catch{}if(F&&U&&O.x+O.width>U.x&&O.y+O.height>U.y&&O.x<U.x+U.width&&O.y<U.y+U.height)return this.M.trace("window#validateWindowState: multi-monitor working area",U),O}wb(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,P]=this.l.getPosition(),[F,U]=this.l.getSize();return{x:O,y:P,width:F,height:U}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(O){this.Bb()?this.yb(O):this.Ab(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(O){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(O)}zb(O){y.isMacintosh&&(this.u=O,this.v=new L.DeferredPromise,Promise.race([this.v.p,(0,L.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(O)}Ab(O){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(O),this.l.webContents.focus()}Bb(){const O=this.W.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let O=(0,m.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}Db(O,P=!0){y.isMacintosh||(O==="toggle"&&P&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),O==="hidden"?setTimeout(()=>{this.Eb(O)}):this.Eb(O))}Eb(O){const P=this.isFullScreen;switch(O){case"classic":this.l.setMenuBarVisibility(!P),this.l.autoHideMenuBar=P;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(O,P,...F){this.isReady?this.send(O,...F):this.ready().then(()=>{P.isCancellationRequested||this.send(O,...F)})}send(O,...P){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this.l.webContents.send(O,...P)}catch(F){this.M.warn(`Error sending IPC message to channel '${O}' of window ${this.k}: ${(0,A.toErrorMessage)(F)}`)}}}updateTouchBar(O){!y.isMacintosh||this.F.forEach((P,F)=>{const U=O[F];P.segments=this.Hb(U)})}Fb(){if(!!y.isMacintosh){for(let O=0;O<10;O++){const P=this.Gb();this.F.push(P)}this.l.setTouchBar(new I.TouchBar({items:this.F}))}}Gb(O=[]){const P=this.Hb(O),F=new I.TouchBar.TouchBarSegmentedControl({segments:P,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:F.segments[U].id,from:"touchbar"})}});return F}Hb(O=[]){return O.map(F=>{let U;F.icon&&!c.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===f.Schemas.file&&(U=I.nativeImage.createFromPath(b.URI.revive(F.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let j;return typeof F.title=="string"?j=F.title:j=F.title.value,{id:F.id,label:U?void 0:j,icon:U}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};se.a="windowControlHeight",se.b=void 0,se=ye([Q(1,C.ILogService),Q(2,V.ILoggerMainService),Q(3,g.IEnvironmentMainService),Q(4,q.IPolicyService),Q(5,oe.IUserDataProfilesMainService),Q(6,S.IFileService),Q(7,n.IApplicationStorageMainService),Q(8,n.IStorageMainService),Q(9,v.IConfigurationService),Q(10,o.IThemeMainService),Q(11,T.IWorkspacesManagementMainService),Q(12,E.IBackupMainService),Q(13,a.ITelemetryService),Q(14,r.IDialogMainService),Q(15,w.ILifecycleMainService),Q(16,t.IProductService),Q(17,l.IProtocolMainService),Q(18,D.IWindowsMainService),Q(19,ie.IStateService),Q(20,ae.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[81],te([0,1,14,22,7,3,45,2,15,4,18,8,24,187,6,20,5,97,98,29,54,35]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,E.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,n,a,c){super(),this.f=i,this.g=n,this.h=a,this.j=c,this.c=this.B(new A.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new s.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],a=[];for(const o of i)if((0,h.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(n,o.workspace)&&n.push(o);else if((0,h.isRecentFolder)(o))this.s(n,o.folderUri)||n.push(o);else{const m=this.t(a,o.fileUri),D=o.fileUri.scheme===f.Schemas.file&&tt.y.indexOf((0,p.basename)(o.fileUri))>=0;!m&&!D&&(a.push(o),u.isWindows&&o.fileUri.scheme===f.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.l({workspaces:n,files:a});n=c.workspaces,a=c.files,n.length>tt.a&&(n.length=tt.a),a.length>tt.a&&(a.length=tt.a),await this.n({workspaces:n,files:a}),this.c.fire(),u.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=m=>{const D=this.p(m);for(const M of i)if(p.extUriBiasedIgnorePathCase.isEqual(M,D))return!1;return!0},a=await this.getRecentlyOpened(),c=a.workspaces.filter(n),o=a.files.filter(n);(c.length!==a.workspaces.length||o.length!==a.files.length)&&(await this.n({files:o,workspaces:c}),this.c.fire(),u.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new C.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)n.set(this.p(o),o);const a=new C.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)a.set(this.p(o),o);const c=await this.m();for(const o of c.workspaces){const m=n.get(this.p(o));m?m.label=m.label??o.label:n.set(this.p(o),o)}for(const o of c.files){const m=a.get(this.p(o));m?m.label=m.label??o.label:a.set(this.p(o),o)}return{workspaces:[...n.values()],files:[...a.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(tt.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,h.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,h.toStoreData)(i)),-1,1)}p(i){return(0,h.isRecentFolder)(i)?i.folderUri:(0,h.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,n){return!!i.find(a=>(0,h.isRecentWorkspace)(a)&&a.workspace.id===n.id)}s(i,n){return!!i.find(a=>(0,h.isRecentFolder)(a)&&p.extUriBiasedIgnorePathCase.isEqual(a.folderUri,n))}t(i,n){return!!i.find(a=>p.extUriBiasedIgnorePathCase.isEqual(a.fileUri,n))}async C(){!u.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!u.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const o of I.app.getJumpListSettings().removedItems){const m=o.args;if(m){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);D&&n.push(y.URI.parse(D[2]))}}await this.removeRecentlyOpened(n);let a=!1;const c=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.w).map(o=>{const m=(0,h.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:M}=this.F(m,o.label);let T;return y.URI.isUri(m)?T=`--folder-uri "${m.toString()}"`:(a=!0,T=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&i.push({type:"custom",name:a?(0,d.localize)(2,null):(0,d.localize)(3,null),items:c})}i.push({type:"recent"});try{const n=I.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,R.splitName)(n).name,description:n};if(y.URI.isUri(i))return{title:(0,p.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let a=(0,p.basename)(i.configPath);return a.endsWith(S.WORKSPACE_EXTENSION)&&(a=a.substr(0,a.length-S.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,a),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,R.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!u.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let a=0;for(let o=0;o<i.workspaces.length&&a<tt.u;o++){const m=this.p(i.workspaces[o]);if(m.scheme===f.Schemas.file){const D=(0,p.originalFSPath)(m);await b.Promises.exists(D)&&(n.push(D),a++)}}const c=[];for(let o=0;o<i.files.length&&a<tt.v;o++){const m=this.p(i.files[o]);if(m.scheme===f.Schemas.file){const D=(0,p.originalFSPath)(m);if(tt.y.includes((0,p.basename)(m))||n.includes(D))continue;await b.Promises.exists(D)&&(c.push(D),a++)}}c.reverse().forEach(o=>I.app.addRecentDocument(o)),n.reverse().forEach(o=>I.app.addRecentDocument(o))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ye([Q(0,r.ILogService),Q(1,w.IWorkspacesManagementMainService),Q(2,v.ILifecycleMainService),Q(3,g.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[284],te([0,1,14,7,23,45,4,8,177,19,28,20,5,225,59,21,33,25,49,79,30,81]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let l=class bt{constructor(a,c,o,m,D,M,T,N,$,q,ie){this.n=a,this.o=c,this.p=o,this.q=m,this.r=D,this.s=M,this.t=T,this.u=N,this.v=$,this.w=q,this.x=ie,this.m=Object.create(null),this.g=new L.RunOnceScheduler(()=>this.E(),0),this.h=new L.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.isMacintosh||(0,S.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(bt.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(M,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(M,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(M,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(M,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.twitterUrl;a&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(a,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const m=this.x.licenseUrl;m&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.language){const M=m.indexOf("?")>0?"&":"?";this.Z(`${m}${M}lang=${R.language}`,"openLicenseUrl")}else this.Z(m,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&m&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!R.isMacintosh)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,c){this.k=a.menus,this.l=a.keybindings,this.t.setItem(bt.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){!R.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){!R.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=I.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(R.isMacintosh?new I.Menu:null);return}const c=new I.Menu;let o;if(R.isMacintosh){const D=new I.Menu;o=new I.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),c.append(o)}if(R.isMacintosh&&!this.c){this.c=!0;const D=new I.Menu;D.append(new I.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(D)}if(this.K("File")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(1,null)),submenu:D});this.M(D,"File"),c.append(M)}if(this.K("Edit")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(2,null)),submenu:D});this.M(D,"Edit"),c.append(M)}if(this.K("Selection")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(3,null)),submenu:D});this.M(D,"Selection"),c.append(M)}if(this.K("View")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(4,null)),submenu:D});this.M(D,"View"),c.append(M)}if(this.K("Go")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(5,null)),submenu:D});this.M(D,"Go"),c.append(M)}if(this.K("Run")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(6,null)),submenu:D});this.M(D,"Run"),c.append(M)}if(this.K("Terminal")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(7,null)),submenu:D});this.M(D,"Terminal"),c.append(M)}let m;if(this.K("Window")){const D=new I.Menu;m=new I.MenuItem({label:this.bb(f.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(m&&c.append(m),this.K("Help")){const D=new I.Menu,M=new I.MenuItem({label:this.bb(f.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),c.append(M)}c.items&&c.items.length>0?I.Menu.setApplicationMenu(c):I.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const c=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let m;if(this.K("Preferences")){const oe=new I.Menu;this.M(oe,"Preferences"),m=new I.MenuItem({label:this.bb(f.localize(11,null)),submenu:oe})}const D=new I.Menu,M=new I.MenuItem({label:f.localize(12,null),role:"services",submenu:D}),T=new I.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new I.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new I.MenuItem({label:f.localize(15,null),role:"unhide"}),q=new I.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(oe,ae,de)=>{const ce=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.J(de)&&this.w.quit(void 0)}})),ie=[c];ie.push(...o),m&&ie.push(i(),m),ie.push(i(),M,i(),T,N,$,i(),q),ie.forEach(oe=>a.append(oe))}async J(a){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(a)){const{response:o}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return o===0}return!0}K(a){if(!R.isMacintosh&&(0,S.getTitleBarStyle)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,c){c.forEach(o=>{if((0,d.isMenubarMenuItemSeparator)(o))a.append(i());else if((0,d.isMenubarMenuItemSubmenu)(o)){const m=new I.Menu,D=new I.MenuItem({label:this.bb(o.label),submenu:m});this.L(m,o.submenu.items),a.append(D)}else(0,d.isMenubarMenuItemRecentAction)(o)?a.append(this.O(o)):(0,d.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(a),R.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?a.append(new I.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):a.append(this.U(o.label,o.id,!1,o.checked)):a.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):a.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(a,c){this.k&&this.k[c]&&this.L(a,this.k[c].items)}N(a){const c=this.T();c.length&&(c.forEach(o=>a.append(o)),a.append(i()))}O(a){const c=k.URI.revive(a.uri),o=a.id,m=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new I.MenuItem(this.Y(o,{label:a.label,click:async(D,M,T)=>{const N=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[m],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(a){return!!(a&&(!R.isMacintosh&&(a.ctrlKey||a.shiftKey)||R.isMacintosh&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,c,o){const m={label:this.bb(a),role:o,enabled:!0};return new I.MenuItem(this.X(c,m))}S(a){const c=new I.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new I.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),m=new I.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(f.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(i()),M.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,i(),D,...M,i(),m].forEach(T=>a.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(a,c,o,m){const D=this.bb(a),M=typeof c=="function"?c:(ie,oe,ae)=>{const de=ie?ie.userSettingsLabel:null;let ce=c;Array.isArray(c)&&(ce=this.P(ae)?c[1]:c[0]),de&&ae.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:de}):this.W({type:"commandId",commandId:ce})},T=typeof o=="boolean"?o:this.p.getWindowCount()>0,N=typeof m=="boolean"?m:!1,$={label:D,click:M,enabled:T};N&&($.type="checkbox",$.checked=N);let q;return typeof c=="string"?q=c:Array.isArray(c)&&(q=c[0]),R.isMacintosh&&(q==="editor.action.clipboardCutAction"?$.role="cut":q==="editor.action.clipboardCopyAction"?$.role="copy":q==="editor.action.clipboardPasteAction"&&($.role="paste"),q==="undo"?$.click=this.V(M,{inDevTools:ie=>ie.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?$.click=this.V(M,{inDevTools:ie=>ie.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&($.click=this.V(M,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(q,$))}V(a,c){return(o,m,D)=>{const M=I.BrowserWindow.getFocusedWindow();if(!M)return c.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return c.inDevTools(M.webContents.devToolsWebContents);a(o,m||M,D)}}W(a){let c=I.BrowserWindow.getFocusedWindow();if(!c){const m=this.p.getLastActiveWindow();m?.isMinimized()&&(c=m.win)}const o=c?this.p.getWindowById(c.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",a),R.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const m={id:a.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",s.CancellationToken.None,m)}else{const m={userSettingsLabel:a.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,m)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,c){const o=typeof a=="string"?this.l[a]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const m=c.label.indexOf("[");m>=0?c.label=`${c.label.substr(0,m)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}Y(a,c,o=!c.accelerator){o&&(c=this.X(a,c));const m=c.click;return c.click=(D,M,T)=>{this.ab(a),m?.(D,M,T)},c}Z(a,c){this.w.openExternal(void 0,a),this.ab(c)}ab(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:t})}bb(a){return(0,A.mnemonicMenuLabel)(a,!this.B)}};l.a="lastKnownMenubarData",l=ye([Q(0,h.IUpdateService),Q(1,u.IConfigurationService),Q(2,w.IWindowsMainService),Q(3,p.IEnvironmentMainService),Q(4,g.ITelemetryService),Q(5,C.IWorkspacesHistoryMainService),Q(6,r.IStateService),Q(7,y.ILifecycleMainService),Q(8,b.ILogService),Q(9,E.INativeHostMainService),Q(10,v.IProductService)],l),e.Menubar=l;function i(){return new I.MenuItem({type:"separator"})}}),define(ee[285],te([0,1,6,20,5,284]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let R=class{constructor(f,u,p){this.b=f,this.c=u,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.Menubar)}async updateMenubar(f,u){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(u,f)}};R=ye([Q(0,I.IInstantiationService),Q(1,L.ILifecycleMainService),Q(2,s.ILogService)],R),e.MenubarMainService=R}),define(ee[286],te([0,1,14,24,27,22,23,3,32,50,45,2,15,9,64,4,36,18,11,8,185,63,19,58,28,16,6,20,5,66,67,57,33,79,283,125,278,29,99,81,54,69,38,53,65,72]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M,T,N,$,q,ie,oe,ae,de,ce,X,J,H,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Y(_){return(0,oe.isWorkspaceIdentifier)(_?.workspace)}function ne(_){return(0,oe.isSingleFolderWorkspaceIdentifier)(_?.workspace)}let se=class at extends y.Disposable{constructor(O,P,F,U,j,B,z,G,re,he,be,ke,Le,Oe,Fe,me,pe,Ce){super(),this.k=O,this.l=P,this.m=F,this.n=U,this.r=j,this.s=B,this.t=z,this.u=G,this.v=re,this.w=he,this.z=be,this.C=ke,this.D=Le,this.F=Oe,this.G=Fe,this.H=me,this.I=pe,this.J=Ce,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(O=>this.c.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const P=new y.DisposableStore;if(P.add(k.Event.any(O.onDidClose,O.onDidDestroy)(()=>P.dispose())),O.config.extensionDevelopmentPath)for(const F of O.config.extensionDevelopmentPath)P.add(this.I.addValidFileRoot(F));O.config.extensionTestsPath&&P.add(this.I.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,P){const F=this.t.args,U=P?.remoteAuthority||void 0,j=!0,B=P?.forceReuseWindow,z=!B;return this.open({...O,cli:F,forceEmpty:j,forceNewWindow:z,forceReuseWindow:B,remoteAuthority:U})}openExistingWindow(O,P){O.focus(),this.M(P,[O])}async open(O){this.m.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const P=[],F=[],U=[],j=[],B=[];let z,G=0;const re=await this.S(O);this.m.trace("windowsManager#open pathsToOpen",re);for(const Oe of re)ne(Oe)?O.addMode?P.push(Oe):F.push(Oe):Y(Oe)?U.push(Oe):Oe.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Oe.remoteAuthority}),z.filesToOpenOrCreate.push(Oe)):Oe.backupPath?B.push({backupFolder:(0,d.basename)(Oe.backupPath),remoteAuthority:Oe.remoteAuthority}):G++;O.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),O.mergeMode&&z&&z.filesToOpenOrCreate.length===4&&(z.filesToMerge=z.filesToOpenOrCreate.slice(0,4),z.filesToOpenOrCreate=[],z.filesToDiff=[]),z&&O.waitMarkerFileURI&&(z.filesToWait={paths:(0,A.coalesce)([...z.filesToDiff,z.filesToMerge[3],...z.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(j.push(...this.D.getUntitledWorkspaces()),U.push(...j),B.push(...this.w.getEmptyWindowBackups())):B.length=0;const{windows:he,filesOpenedInWindow:be}=await this.N(O,U,F,B,G,z,P);if(this.m.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${F.length}, emptyToRestore: ${B.length}, emptyToOpen: ${G})`),he.length>1)if(be)be.focus();else{const Oe=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Fe=!0,me=!0;if(Oe){const pe=he.filter(Ce=>this.j.state.lastActiveWindow&&Ce.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Fe=!1,me=!1)}if(Fe)for(let pe=he.length-1;pe>=0;pe--){const Ce=he[pe];if(!(Ce.openedWorkspace&&j.some(Z=>Ce.openedWorkspace&&Z.workspace.id===Ce.openedWorkspace.id)||Ce.backupPath&&B.some(Z=>Ce.backupPath&&Z.backupFolder===(0,d.basename)(Ce.backupPath)))){Ce.focus(),me=!1;break}}me&&he[he.length-1].focus()}const ke=z&&z.filesToDiff.length>0,Le=z&&z.filesToMerge.length>0;if(!he.some(Oe=>Oe.isExtensionDevelopmentHost)&&!ke&&!Le&&!O.noRecentEntry){const Oe=[];for(const Fe of re)Y(Fe)&&!Fe.transient?Oe.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):ne(Fe)?Oe.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Oe.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.C.addRecentlyOpened(Oe)}return this.M(O,he),he}M(O,P){const F=O.waitMarkerFileURI;O.context===0&&F&&P.length===1&&P[0]&&(async()=>{await P[0].whenClosedOrLoaded;try{await this.H.del(F)}catch{}})()}async N(O,P,F,U,j,B,z){const G=[];let re;function he(pe,Ce){G.push(pe),Ce&&(re=pe,B=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:ke}=this.fb(O);if(!O.initialStartup&&z.length>0){const pe=z[0].remoteAuthority,Ce=this.kb(pe);Ce&&he(this.P(Ce,z.map(Z=>Z.workspace.uri)))}const Le=F.length+P.length+U.length;if(B&&Le===0){const pe=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],Ce=this.getWindows().filter(ue=>B&&(0,g.isEqualAuthority)(ue.remoteAuthority,B.remoteAuthority));let Z;pe?.fileUri&&!ke&&((O.context===4||O.context===0||O.context===1)&&(Z=await(0,q.findWindowOnFile)(Ce,pe.fileUri,async ue=>ue.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(ue.configPath):void 0)),Z||(Z=this.lb(Ce))),Z?(0,oe.isWorkspaceIdentifier)(Z.openedWorkspace)?P.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?F.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):he(this.O(O,Z,B),!0):he(await this.gb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Oe=(0,A.distinct)(P,pe=>pe.workspace.id);if(Oe.length>0){const pe=(0,A.coalesce)(Oe.map(Ce=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ce.workspace.configPath)));if(pe.length>0){const Ce=pe[0],Z=(0,g.isEqualAuthority)(B?.remoteAuthority,Ce.remoteAuthority)?B:void 0;he(this.O(O,Ce,Z),!!Z),be=!0}for(const Ce of Oe){if(pe.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Ce.workspace.id))continue;const Z=Ce.remoteAuthority,ue=(0,g.isEqualAuthority)(B?.remoteAuthority,Z)?B:void 0;he(await this.R(O,Ce,be,ue),!!ue),be=!0}}const Fe=(0,A.distinct)(F,pe=>g.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Fe.length>0){const pe=(0,A.coalesce)(Fe.map(Ce=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ce.workspace.uri)));if(pe.length>0){const Ce=pe[0],Z=(0,g.isEqualAuthority)(B?.remoteAuthority,Ce.remoteAuthority)?B:void 0;he(this.O(O,Ce,Z),!!Z),be=!0}for(const Ce of Fe){if(pe.some(fe=>(0,oe.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Ce.workspace.uri)))continue;const Z=Ce.remoteAuthority,ue=(0,g.isEqualAuthority)(B?.remoteAuthority,Z)?B:void 0;he(await this.R(O,Ce,be,ue),!!ue),be=!0}}const me=(0,A.distinct)(U,pe=>pe.backupFolder);if(me.length>0)for(const pe of me){const Ce=pe.remoteAuthority,Z=(0,g.isEqualAuthority)(B?.remoteAuthority,Ce)?B:void 0;he(await this.Q(O,!0,Ce,Z,pe),!!Z),be=!0}if(G.length===0||B){B&&!j&&j++;const pe=B?B.remoteAuthority:O.remoteAuthority;for(let Ce=0;Ce<j;Ce++)he(await this.Q(O,be,pe,B),!!B),be=!0}return{windows:(0,A.distinct)(G),filesOpenedInWindow:re}}O(O,P,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),P.focus();const U={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return P.sendWhenReady("vscode:openFiles",R.CancellationToken.None,U),P}P(O,P){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:P}),O.focus();const F={foldersToAdd:P};return O.sendWhenReady("vscode:addFolders",R.CancellationToken.None,F),O}Q(O,P,F,U,j){this.m.trace("windowsManager#doOpenEmpty",{restore:!!j,remoteAuthority:F,filesToOpen:U,forceNewWindow:P});let B;return!P&&typeof O.contextWindowId=="number"&&(B=this.getWindowById(O.contextWindowId)),this.gb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F,forceNewWindow:P,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:U,windowToUse:B,emptyWindowBackupInfo:j,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}R(O,P,F,U,j){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:P,filesToOpen:U}),!F&&!j&&typeof O.contextWindowId=="number"&&(j=this.getWindowById(O.contextWindowId)),this.gb({workspace:P.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:P.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:U,windowToUse:j,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async S(O){let P,F=!1,U=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(P=await this.U(O),F=!0):O.forceEmpty?P=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(P=await this.W(O.cli),P.length===0&&P.push(Object.create(null)),F=!0):(P=await this.Y(),P.length===0&&P.push(Object.create(null)),U=!0),!O.addMode&&F){const j=P.filter(B=>ne(B));if(j.length>1){const B=j[0].remoteAuthority;if(j.every(z=>(0,g.isEqualAuthority)(z.remoteAuthority,B))){const z=await this.D.createUntitledWorkspace(j.map(G=>({uri:G.workspace.uri})));P.push({workspace:z,remoteAuthority:B}),P=P.filter(G=>!ne(G))}}}if(O.initialStartup&&!U&&this.z.getValue("window")?.restoreWindows==="preserve"){const j=await this.Y();P.unshift(...j.filter(B=>Y(B)||ne(B)||B.backupPath))}return P}async U(O){const P={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},F=await Promise.all((0,A.coalesce)(O.urisToOpen||[]).map(async U=>{const j=await this.ab(U,P);if(j)return j.label=U.label,j;const B=this.cb(U);this.G.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:B.scheme===b.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:B.scheme===b.Schemas.file?(0,w.localize)(3,null,(0,p.getPathLabel)(B,{os:v.OS,tildify:this.t})):(0,w.localize)(4,null,B.toString(!0))},(0,h.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,A.coalesce)(F)}async W(O){const P=[],F={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},U=O["folder-uri"];if(U){const z=await Promise.all(U.map(G=>{const re=this.X(G);if(!!re)return this.ab({folderUri:re},F)}));P.push(...(0,A.coalesce)(z))}const j=O["file-uri"];if(j){const z=await Promise.all(j.map(G=>{const re=this.X(G);if(!!re)return this.ab((0,oe.hasWorkspaceFileExtension)(G)?{workspaceUri:re}:{fileUri:re},F)}));P.push(...(0,A.coalesce)(z))}const B=await Promise.all(O._.map(z=>F.remoteAuthority?this.eb(z,F):this.db(z,F)));return P.push(...(0,A.coalesce)(B)),P}X(O){try{const P=S.URI.parse(O);if(!P.scheme){this.m.error(`Invalid URI input string, scheme missing: ${O}`);return}return P}catch(P){this.m.error(`Invalid URI input string: ${O}, ${P.message}`)}}async Y(){const O=this.Z();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const P=[];O!=="one"&&P.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&P.push(this.j.state.lastActiveWindow);const F=await Promise.all(P.map(async U=>{if(U.workspace){const j=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(Y(j))return j}else if(U.folderUri){const j=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(ne(j))return j}else if(O!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,A.coalesce)(F)}}}Z(){let O;return this.v.wasRestarted?O="all":(O=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ab(O,P=Object.create(null)){const F=this.cb(O);return F.scheme===b.Schemas.file?((0,N.isFileToOpen)(O)&&(P={...P,forceOpenWorkspaceAsFile:!0}),this.db(F.fsPath,P)):this.bb(O,P)}bb(O,P){let F=this.cb(O);const U=(0,M.getRemoteAuthority)(F)||P.remoteAuthority;if(F=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(F)),(0,N.isFileToOpen)(O)){if(P.gotoLineMode){const{path:j,line:B,column:z}=(0,f.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:j}),options:{selection:B?{startLineNumber:B,startColumn:z||1}:void 0},remoteAuthority:U}}return{fileUri:F,remoteAuthority:U}}else if((0,N.isWorkspaceToOpen)(O))return{workspace:(0,ae.getWorkspaceIdentifier)(F),remoteAuthority:U};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:U}}cb(O){return(0,N.isWorkspaceToOpen)(O)?O.workspaceUri:(0,N.isFolderToOpen)(O)?O.folderUri:O.fileUri}async db(O,P){let F,U;P.gotoLineMode&&({path:O,line:F,column:U}=(0,f.parseLineAndColumnAware)(O)),O=(0,f.sanitizeFilePath)((0,d.normalize)(O),(0,r.cwd)());try{const j=await L.Promises.stat(O);if(j.isFile()){if(!P.forceOpenWorkspaceAsFile){const B=await this.D.resolveLocalWorkspace(S.URI.file(O));if(B)return B.transient&&P.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:n.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:S.URI.file(O),type:n.FileType.File,exists:!0,options:{selection:F?{startLineNumber:F,startColumn:U||1}:void 0}}}else{if(j.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(S.URI.file(O),j),type:n.FileType.Directory,exists:!0};if(!v.isWindows&&O==="/dev/null")return{fileUri:S.URI.file(O),type:n.FileType.File,exists:!0}}}catch{const B=S.URI.file(O);if(this.C.removeRecentlyOpened([B]),P.ignoreFileNotFound)return{fileUri:B,type:n.FileType.File,exists:!1}}}eb(O,P){const F=O.charCodeAt(0),U=P.remoteAuthority;let j,B;P.gotoLineMode&&({path:O,line:j,column:B}=(0,f.parseLineAndColumnAware)(O)),F!==47&&((0,f.isWindowsDriveLetter)(F)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,f.toSlashes)(O)),O=`/${O}`);const z=S.URI.from({scheme:b.Schemas.vscodeRemote,authority:U,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(O))return P.forceOpenWorkspaceAsFile?{fileUri:z,options:{selection:j?{startLineNumber:j,startColumn:B||1}:void 0},remoteAuthority:P.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(z),remoteAuthority:U};if(P.gotoLineMode||d.posix.basename(O).indexOf(".")!==-1)return{fileUri:z,options:{selection:j?{startLineNumber:j,startColumn:B||1}:void 0},remoteAuthority:U}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:U}}fb(O){const P=this.z.getValue("window"),F=P?.openFoldersInNewWindow||"default",U=P?.openFilesInNewWindow||"off";let j=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(F==="on"||F==="off")&&(j=F==="on");let B=!1;return O.forceNewWindow||O.forceReuseWindow?B=!!O.forceNewWindow&&!O.forceReuseWindow:(v.isMacintosh?O.context===1&&(B=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!O.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(B=U==="on")),{openFolderInNewWindow:!!j,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(O,P){const F=(0,q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(F)return this.v.reload(F,P.cli),F.focus(),[F];let U=P.cli["folder-uri"]||[],j=P.cli["file-uri"]||[],B=P.cli._;if(!B.length&&!U.length&&!j.length&&!P.cli.extensionTestsPath){const re=this.j.state.lastPluginDevelopmentHostWindow,he=re?.workspace??re?.folderUri;he&&(S.URI.isUri(he)?he.scheme===b.Schemas.file?B=[he.fsPath]:U=[he.toString()]:he.configPath.scheme===b.Schemas.file?B=[(0,g.originalFSPath)(he.configPath)]:j=[he.configPath.toString()])}let z=P.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=S.URI.parse(re),be=(0,M.getRemoteAuthority)(he);be&&(z?(0,g.isEqualAuthority)(be,z)||this.m.error("more than one extension development path authority"):z=be)}B=B.filter(re=>{const he=S.URI.file(re);return(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:(0,g.isEqualAuthority)((0,M.getRemoteAuthority)(he),z)}),U=U.filter(re=>{const he=this.X(re);return he&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,g.isEqualAuthority)((0,M.getRemoteAuthority)(he),z):!1}),j=j.filter(re=>{const he=this.X(re);return he&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,g.isEqualAuthority)((0,M.getRemoteAuthority)(he),z):!1}),P.cli._=B,P.cli["folder-uri"]=U,P.cli["file-uri"]=j;const G={context:P.context,cli:P.cli,forceNewWindow:!0,forceEmpty:!B.length&&!U.length&&!j.length,userEnv:P.userEnv,noRecentEntry:!0,waitMarkerFileURI:P.waitMarkerFileURI,remoteAuthority:z,forceProfile:P.forceProfile,forceTempProfile:P.forceTempProfile};return this.open(G)}async gb(O){const P=this.z.getValue("window"),F=this.getLastActiveWindow(),U=F?.profile??this.u.defaultProfile;let j;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(j=O.windowToUse||F,j&&j.focus());let B=!1;V.canUseUtilityProcess&&(typeof P?.experimental?.sharedProcessUseUtilityProcess=="boolean"?B=P.experimental.sharedProcessUseUtilityProcess:B=typeof m.default.quality=="string");const z={...this.t.args,...O.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,d.join)(this.t.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:U},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.l,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:m.default,isInitialStartup:O.initialStartup,perfMarks:(0,E.getMarks)(),os:{release:(0,s.release)(),hostname:(0,s.hostname)()},zoomLevel:typeof P?.zoomLevel=="number"?P.zoomLevel:void 0,autoDetectHighContrast:P?.autoDetectHighContrast??!0,autoDetectColorScheme:P?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn,preferUtilityProcess:B};if(j){const G=j.config;!z.extensionDevelopmentPath&&G?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=G.extensionDevelopmentPath,z.extensionDevelopmentKind=G.extensionDevelopmentKind,z["enable-proposed-api"]=G["enable-proposed-api"],z.verbose=G.verbose,z["inspect-extensions"]=G["inspect-extensions"],z["inspect-brk-extensions"]=G["inspect-brk-extensions"],z.debugId=G.debugId,z.extensionEnvironment=G.extensionEnvironment,z["extensions-dir"]=G["extensions-dir"],z["disable-extensions"]=G["disable-extensions"]),z.loggers={global:z.loggers.global,window:G?.loggers.window??z.loggers.window}}else{const G=this.j.getNewWindowState(z);(0,E.mark)("code/willCreateCodeWindow");const re=j=this.F.createInstance($.CodeWindow,{state:G,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,E.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),at.a.push(re),this.b.fire(re),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,u.once)(re.onDidSignalReady)(()=>this.c.fire(re)),(0,u.once)(re.onDidClose)(()=>this.jb(re)),(0,u.once)(re.onDidDestroy)(()=>this.f.fire(re)),re.onDidTriggerSystemContextMenu(({x:be,y:ke})=>this.h.fire({window:re,x:be,y:ke}));const he=(0,h.assertIsDefined)(re.win?.webContents);he.removeAllListeners("devtools-reload-page"),he.on("devtools-reload-page",()=>this.v.reload(re)),this.v.registerWindow(re)}return z.windowId=j.id,j.isReady?this.v.unload(j,4).then(async G=>{G||await this.hb(j,z,O,U)}):await this.hb(j,z,O,U),j}async hb(O,P,F,U){if(P.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(P.workspace)?P.backupPath=this.w.registerWorkspaceBackup({workspace:P.workspace,remoteAuthority:P.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(P.workspace)?P.backupPath=this.w.registerFolderBackup({folderUri:P.workspace.uri,remoteAuthority:P.remoteAuthority}):P.backupPath=this.w.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:P.remoteAuthority})),this.u.isEnabled()){const j=P.workspace??(0,oe.toWorkspaceIdentifier)(P.backupPath,!1),B=this.ib(F,j,U),z=B instanceof Promise?await B:B;P.profiles.profile=z,P.extensionDevelopmentPath||await this.u.setProfileForWorkspace(j,z)}O.load(P)}ib(O,P,F){return O.forceProfile?this.u.profiles.find(U=>U.name===O.forceProfile)??this.u.createNamedProfile(O.forceProfile):O.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(P)??F}jb(O){const P=at.a.indexOf(O);at.a.splice(P,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=I.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(O){return this.lb(this.getWindows().filter(P=>(0,g.isEqualAuthority)(P.remoteAuthority,O)))}lb(O){const P=Math.max.apply(Math,O.map(F=>F.lastFocusTime));return O.find(F=>F.lastFocusTime===P)}sendToFocused(O,...P){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,R.CancellationToken.None,...P)}sendToAll(O,P,F){for(const U of this.getWindows())F&&F.indexOf(U.id)>=0||U.sendWhenReady(O,R.CancellationToken.None,P)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(O){const P=this.getWindows().filter(F=>F.id===O);return(0,A.firstOrDefault)(P)}getWindowByWebContents(O){const P=I.BrowserWindow.fromWebContents(O);if(!!P)return this.getWindowById(P.id)}};se.a=[],se=ye([Q(2,o.ILogService),Q(3,W.ILoggerMainService),Q(4,T.IStateService),Q(5,J.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,H.IUserDataProfilesMainService),Q(8,c.ILifecycleMainService),Q(9,C.IBackupMainService),Q(10,t.IConfigurationService),Q(11,de.IWorkspacesHistoryMainService),Q(12,ce.IWorkspacesManagementMainService),Q(13,a.IInstantiationService),Q(14,l.IDialogMainService),Q(15,n.IFileService),Q(16,D.IProtocolMainService),Q(17,X.IThemeMainService)],se),e.WindowsMainService=se}),define(ee[287],te([0,1,63,30,81,54]),function(x,e,I,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=class{constructor(f,u,p,y){this.a=f,this.b=u,this.c=p,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const p=this.b.getWindowById(f);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),u)}createUntitledWorkspace(f,u,p){return this.a.createUntitledWorkspace(u,p)}deleteUntitledWorkspace(f,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};R=ye([Q(0,A.IWorkspacesManagementMainService),Q(1,L.IWindowsMainService),Q(2,s.IWorkspacesHistoryMainService),Q(3,I.IBackupMainService)],R),e.WorkspacesMainService=R}),define(ee[288],te([0,1,14,42,27,17,44,13,32,50,43,45,2,15,9,4,11,8,31,141,47,155,106,261,158,63,279,19,77,194,89,126,58,110,215,28,62,116,205,229,206,265,112,207,208,16,219,92,76,6,91,280,242,263,20,5,285,59,21,57,273,93,33,269,97,94,25,244,119,48,49,251,252,281,253,282,122,255,256,257,259,267,30,286,268,29,98,81,287,54,262,38,227,53,238,52,80,124,271,277,275,7,120,270,222,65,90,266,258,22]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M,T,N,$,q,ie,oe,ae,de,ce,X,J,H,W,V,Y,ne,se,_,O,P,F,U,j,B,z,G,re,he,be,ke,Le,Oe,Fe,me,pe,Ce,Z,ue,fe,Ee,Ae,Te,We,qe,Ne,Be,Ve,K,le,ge,ve,we,Me,Ue,He,Ge,Ke,Ye,Ze,rt,ct,gt,Ct,Rt,Mt,At,Lt,Ot,Tt,mt,Ft,Wt,Ut,Nt,Bt,pt,jt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let wt=class extends b.Disposable{constructor(De,Ie,Se,Pe,Re,$e,Xe,Qe,ze,je,xe){super(),this.c=De,this.f=Ie,this.g=Se,this.h=Pe,this.i=Re,this.j=$e,this.k=Xe,this.l=Qe,this.m=ze,this.n=je,this.p=xe,this.r(),this.s()}r(){const De=ze=>ze?.startsWith(`${d.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((ze,je,xe,Je)=>De(Je.requestingUrl)?xe(Ie.has(je)):xe(!1)),I.session.defaultSession.setPermissionCheckHandler((ze,je,xe,Je)=>De(Je.requestingUrl)?Ie.has(je):!1);const Se=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Pe=ze=>{for(let je=ze;je;je=je.parent)if(je.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Re=ze=>ze.resourceType==="xhr"||Pe(ze.frame),$e=ze=>{const je=ze.frame;if(!je||!this.a)return!1;const xe=I.BrowserWindow.getAllWindows();for(const Je of xe)if(je.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(ze,je)=>{if(ze.path!=="/index.html")return!0;const xe=je.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((ze,je)=>{const xe=g.URI.parse(ze.url);return xe.scheme===d.Schemas.vscodeWebview&&!Xe(xe,ze)?(this.h.error("Blocked vscode-webview request",ze.url),je({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!$e(ze)?(this.h.error("Blocked vscode-file request",ze.url),je({cancel:!0})):xe.path.endsWith(".svg")&&!Se.has(xe.scheme)?je({cancel:!Re(ze)}):je({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((ze,je)=>{const xe=ze.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=g.URI.parse(ze.url);if(_e.path.endsWith(".svg")&&Se.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return je({cancel:!Re(ze)})}return je({cancel:!1})});const Qe=I.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,E.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(Se=>this.u(Se)),process.on("uncaughtException",Se=>(0,k.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,k.onUnexpectedError)(Se)),this.j.onWillShutdown(()=>this.dispose()),(0,S.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Se,Pe)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),I.app.on("activate",async(Se,Pe)=>{this.h.trace("app#activate"),Pe||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Se,Pe)=>{Pe.on("will-navigate",Re=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Pe.setWindowOpenHandler(({url:Re})=>(this.b?.openExternal(void 0,Re),{action:"deny"}))});let De=[],Ie;I.app.on("open-file",(Se,Pe)=>{this.h.trace("app#open-file: ",Pe),Se.preventDefault(),De.push((0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:g.URI.file(Pe)}:{fileUri:g.URI.file(Pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),L.validatedIpcMain.handle("vscode:fetchShellEnv",Se=>{const Pe=this.a?.getWindowByWebContents(Se.sender);let Re,$e;return Pe?.config?(Re=Pe.config,$e={...process.env,...Pe.config.userEnv}):(Re=this.i.args,$e=process.env),this.M(Re,$e,!1)}),L.validatedIpcMain.handle("vscode:writeNlsFile",(Se,Pe,Re)=>{const $e=this.t([Pe]);if(!$e||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile($e,A.VSBuffer.fromString(Re))}),L.validatedIpcMain.handle("vscode:readNlsFile",async(Se,...Pe)=>{const Re=this.t(Pe);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Re)).value.toString()}),L.validatedIpcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),L.validatedIpcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),L.validatedIpcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}t(De){let Ie;for(const Se of De)typeof Se=="string"&&(typeof Ie!="string"?Ie=Se:Ie=(0,E.join)(Ie,Se));if(!(typeof Ie!="string"||!(0,E.isAbsolute)(Ie)||!(0,f.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!v.isLinux)))return g.URI.file(Ie)}u(De){if(De){const Ie={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${De}`),De.stack&&this.h.error(De.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const De=this.n.win32AppUserModelId;v.isWindows&&De&&I.app.setAppUserModelId(De);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(je){this.h.error(je)}const Ie=new C.Server;this.j.onWillShutdown(je=>{je.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const Se=await(0,Ft.resolveMachineId)(this.l,this.h);this.h.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:Pe,sharedProcessReady:Re,sharedProcessClient:$e}=this.D(Se),Xe=await this.F(Se,Pe,Re);this.B(Xe.createInstance(l.ProxyAuthHandler)),this.B(Xe.createInstance(Ot.UserDataProfilesHandler)),Xe.invokeFunction(je=>this.G(je,Ie,$e));const Qe=Xe.invokeFunction(je=>this.v(je,Ie));this.j.phase=2,await Xe.invokeFunction(je=>this.H(je,Qe)),this.j.phase=3,Xe.invokeFunction(je=>this.I(je,Pe)),this.B(new mt.RunOnceScheduler(()=>{this.B((0,mt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(De,Ie){const Se=this.a=De.get(ve.IWindowsMainService),Pe=De.get(Ne.IURLService),Re=this.b=De.get(G.INativeHostMainService),$e=this;Pe.registerHandler({async handleURL(Je,_e){return $e.C(Se,Pe,Je,_e)}});const Xe=this.B(new Me.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Qe=new w.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),ze=new Be.URLHandlerRouter(Qe,this.h),je=Ie.getChannel("urlHandler",ze);Pe.registerHandler(new Be.URLHandlerChannelClient(je));const xe=this.w();return this.B(new K.ElectronURLListener(xe?.urls,Pe,Se,this.i,this.n,this.h)),xe}w(){const De=this.i.args["open-url"]?this.i.args._urls||[]:[];De.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),De.length+Ie.length===0)return;const Se=[];return{urls:[...De,...Ie].map(Re=>{try{return{uri:g.URI.parse(Re),originalUrl:Re}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.y(Re.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const $e=this.z(Re.uri);return $e?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),$e),Se.push($e),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:Se}}y(De){if(De.authority===d.Schemas.file&&v.isWindows){const{options:Ie,buttonIndeces:Se}=(0,Bt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,y.getPathLabel)(De,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(Se[I.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}z(De){if(!!De.path){if(De.authority===d.Schemas.file){const Ie=g.URI.file(De.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(De.authority===d.Schemas.vscodeRemote){const Ie=De.path.indexOf(E.posix.sep,1);if(Ie!==-1){const Se=De.path.substring(1,Ie),Pe=De.path.substring(Ie),Re=g.URI.from({scheme:d.Schemas.vscodeRemote,authority:Se,path:Pe,query:De.query,fragment:De.fragment});return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Re}:/:[\d]+$/.test(Pe)?{fileUri:Re}:{folderUri:Re}}}}}async C(De,Ie,Se,Pe){if(this.h.trace("app#handleProtocolUrl():",Se.toString(!0),Pe),Se.scheme===this.n.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:g.URI.parse(Se.query).path,query:""})),this.y(Se))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let Re=!1;const $e=new URLSearchParams(Se.query);$e.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),$e.delete("windowId"),Se=Se.with({query:$e.toString()}),Re=!0):v.isMacintosh&&De.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Re=!0);const Xe=$e.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),$e.delete("continueOn"),Se=Se.with({query:$e.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.z(Se);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,Se.toString(!0)),(0,St.firstOrDefault)(await De.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:Re,gotoLineMode:!0}))?.focus(),!0):Re?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,St.firstOrDefault)(await De.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.getRemoteAuthority)(Se)}))?.ready(),Ie.open(Se,Pe)):(this.h.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Pe),!1)}D(De){const Ie=this.B(this.g.createInstance(be.SharedProcess,De,this.f)),Se=(async()=>{this.h.trace("Main->SharedProcess#connect");const Re=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(Re,"main")})(),Pe=(async()=>(await Ie.whenReady(),Se))();return{sharedProcess:Ie,sharedProcessReady:Pe,sharedProcessClient:Se}}async F(De,Ie,Se){const Pe=new O.ServiceCollection;switch(process.platform){case"win32":Pe.set(fe.IUpdateService,new se.SyncDescriptor(qe.Win32UpdateService));break;case"linux":v.isLinuxSnap?Pe.set(fe.IUpdateService,new se.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(fe.IUpdateService,new se.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Pe.set(fe.IUpdateService,new se.SyncDescriptor(Ae.DarwinUpdateService));break}Pe.set(ve.IWindowsMainService,new se.SyncDescriptor(we.WindowsMainService,[De,this.f],!1));const Re=new T.DialogMainService(this.h,this.n);Pe.set(T.IDialogMainService,Re),Pe.set(U.ILaunchMainService,new se.SyncDescriptor(U.LaunchMainService,void 0,!1)),Pe.set(M.IDiagnosticsMainService,new se.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),Pe.set(D.IDiagnosticsService,w.ProxyChannel.toService((0,w.getDelayedChannel)(Se.then(Qe=>Qe.getChannel("diagnostics"))))),Pe.set(P.IIssueMainService,new se.SyncDescriptor(P.IssueMainService,[this.f])),Pe.set(N.IEncryptionMainService,new se.SyncDescriptor($.EncryptionMainService,[De])),Pe.set(F.IKeyboardLayoutMainService,new se.SyncDescriptor(F.KeyboardLayoutMainService)),Pe.set(G.INativeHostMainService,new se.SyncDescriptor(G.NativeHostMainService,[Ie],!1)),Pe.set(o.ICredentialsMainService,new se.SyncDescriptor(Ze.CredentialsNativeMainService)),Pe.set(le.IWebviewManagerService,new se.SyncDescriptor(ge.WebviewMainService)),Pe.set(z.IMenubarMainService,new se.SyncDescriptor(z.MenubarMainService)),Pe.set(ae.IExtensionUrlTrustService,new se.SyncDescriptor(de.ExtensionUrlTrustService)),Pe.set(ce.IExtensionHostStarter,new se.SyncDescriptor(X.ExtensionHostStarter)),Pe.set(Fe.IStorageMainService,new se.SyncDescriptor(Fe.StorageMainService)),Pe.set(Fe.IApplicationStorageMainService,new se.SyncDescriptor(Fe.ApplicationStorageMainService)),v.isWindows?Pe.set(J.IExternalTerminalMainService,new se.SyncDescriptor(H.WindowsExternalTerminalService)):v.isMacintosh?Pe.set(J.IExternalTerminalMainService,new se.SyncDescriptor(H.MacExternalTerminalService)):v.isLinux&&Pe.set(J.IExternalTerminalMainService,new se.SyncDescriptor(H.LinuxExternalTerminalService));const $e=new a.BackupMainService(this.i,this.k,this.h,this.l);Pe.set(n.IBackupMainService,$e);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,$e,Re);if(Pe.set(Ye.IWorkspacesManagementMainService,Xe),Pe.set(He.IWorkspacesService,new se.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Pe.set(Ge.IWorkspacesHistoryMainService,new se.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Pe.set(Ne.IURLService,new se.SyncDescriptor(Ve.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.n,this.i)){const Qe=(0,ue.isInternalTelemetry)(this.n,this.k),ze=(0,w.getDelayedChannel)(Se.then(nt=>nt.getChannel("telemetryAppender"))),je=new Ce.TelemetryAppenderClient(ze),xe=(0,me.resolveCommonProperties)((0,s.release)(),(0,s.hostname)(),process.arch,this.n.commit,this.n.version,De,Qe),Je=(0,ue.getPiiPathsFromEnvironment)(this.i),_e={appenders:[je],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Pe.set(pe.ITelemetryService,new se.SyncDescriptor(Z.TelemetryService,[_e],!1))}else Pe.set(pe.ITelemetryService,ue.NullTelemetryService);return Pe.set(Mt.IExtensionsProfileScannerService,new se.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Pe.set(At.IExtensionsScannerService,new se.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),Pe.set(pt.IUtilityProcessWorkerMainService,new se.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([$e.initialize(),Xe.initialize()]),this.g.createChild(Pe)}G(De,Ie,Se){const Pe=w.ProxyChannel.fromService(De.get(U.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Pe);const Re=w.ProxyChannel.fromService(De.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Re);const $e=new ct.PolicyChannel(De.get(rt.IPolicyService));Ie.registerChannel("policy",$e),Se.then(et=>et.registerChannel("policy",$e));const Xe=this.m.getProvider(d.Schemas.file);(0,r.assertType)(Xe instanceof ne.DiskFileSystemProvider);const Qe=new Y.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),Se.then(et=>et.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const ze=w.ProxyChannel.fromService(De.get(gt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",ze),Se.then(et=>et.registerChannel("userDataProfiles",ze));const je=new Ct.RequestChannel(De.get(Rt.IRequestService));Se.then(et=>et.registerChannel("request",je));const xe=new Ee.UpdateChannel(De.get(fe.IUpdateService));Ie.registerChannel("update",xe);const Je=w.ProxyChannel.fromService(De.get(P.IIssueMainService));Ie.registerChannel("issue",Je);const _e=w.ProxyChannel.fromService(De.get(N.IEncryptionMainService));Ie.registerChannel("encryption",_e);const nt=w.ProxyChannel.fromService(De.get(o.ICredentialsMainService));Ie.registerChannel("credentials",nt);const it=w.ProxyChannel.fromService(De.get(ke.ISignService));Ie.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(De.get(F.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",lt),this.b=De.get(G.INativeHostMainService);const Et=w.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",Et),Se.then(et=>et.registerChannel("nativeHost",Et));const $t=w.ProxyChannel.fromService(De.get(He.IWorkspacesService));Ie.registerChannel("workspaces",$t);const zt=w.ProxyChannel.fromService(De.get(z.IMenubarMainService));Ie.registerChannel("menubar",zt);const qt=w.ProxyChannel.fromService(De.get(Ne.IURLService));Ie.registerChannel("url",qt);const Ht=w.ProxyChannel.fromService(De.get(ae.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",Ht);const Vt=w.ProxyChannel.fromService(De.get(le.IWebviewManagerService));Ie.registerChannel("webview",Vt);const It=this.B(new Oe.StorageDatabaseChannel(this.h,De.get(Fe.IStorageMainService)));Ie.registerChannel("storage",It),Se.then(et=>et.registerChannel("storage",It));const xt=this.B(new Tt.ProfileStorageChangesListenerChannel(De.get(Fe.IStorageMainService),De.get(gt.IUserDataProfilesMainService),this.h));Se.then(et=>et.registerChannel("profileStorageListener",xt));const Gt=w.ProxyChannel.fromService(De.get(J.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Gt);const Pt=new Ut.LoggerChannel(De.get(Nt.ILoggerMainService));Ie.registerChannel("logger",Pt),Se.then(et=>et.registerChannel("logger",Pt));const Kt=new m.ElectronExtensionHostDebugBroadcastChannel(De.get(ve.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Kt);const Xt=w.ProxyChannel.fromService(De.get(ce.IExtensionHostStarter));Ie.registerChannel(ce.ipcExtensionHostStarterChannelName,Xt);const Jt=w.ProxyChannel.fromService(De.get(pt.IUtilityProcessWorkerMainService));Ie.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Jt)}async H(De,Ie){const Se=this.a=De.get(ve.IWindowsMainService),Pe=(0,ie.isLaunchedFromCli)(process.env)?0:4,Re=this.i.args;if(Ie){if(Ie.openables.length>0)return Se.open({context:Pe,cli:Re,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const it of Ie.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),Se.open({context:Pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Xe=Re._.length,Qe=!!Re["folder-uri"],ze=!!Re["file-uri"],je=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?g.URI.file(Re.waitMarkerFilePath):void 0,Je=Re.remote||void 0,_e=Re.profile,nt=Re["profile-temp"];if(!Xe&&!Qe&&!ze){if(Re["new-window"]||_e||nt)return Se.open({context:Pe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if($e.length)return Se.open({context:1,cli:Re,urisToOpen:$e.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:g.URI.file(it)}:{fileUri:g.URI.file(it)}),noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0})}return Se.open({context:Pe,cli:Re,forceNewWindow:Re["new-window"]||!Xe&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:je,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(De,Ie){const Se=De.get(pe.ITelemetryService);this.L(Se,Ie),this.J(),I.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Pe,Re)=>{Re({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.M(this.i.args,process.env,!0),this.N()}async J(){const De=this.n.win32MutexName;if(v.isWindows&&De)try{const Ie=await new Promise((Pe,Re)=>{x(["windows-mutex"],Pe,Re)}),Se=new Ie.Mutex(De);(0,u.once)(this.j.onWillShutdown)(()=>Se.release())}catch(Ie){this.h.error(Ie)}}L(De,Ie){let Se=!1;(0,u.once)(this.j.onWillShutdown)(()=>Se=!0),this.B(Ie.onDidError(({type:Pe,details:Re})=>{switch(Pe){case 2:this.h.error(`[SharedProcess] renderer process gone (reason: ${Re?.reason||"<unknown>"}, code: ${Re?.exitCode||"<unknown>"})`);break;case 1:this.h.error("[SharedProcess]  detected unresponsive");break;case 3:this.h.error(`[SharedProcess]  failed to load (reason: ${Re?.reason||"<unknown>"}, code: ${Re?.exitCode||"<unknown>"})`);break}De.publicLog2("sharedprocesserror",{type:Pe,reason:Re?.reason,code:Re?.exitCode,visible:Ie.isVisible(),utilityprocess:Ie.usingUtilityProcess()?"1":"0",shuttingdown:Se})}))}async M(De,Ie,Se){try{return await(0,oe.getResolvedShellEnv)(this.k,this.h,De,Ie)}catch(Pe){const Re=(0,R.toErrorMessage)(Pe);Se?this.a?.sendToFocused("vscode:showResolveShellEnvError",Re):this.h.error(Re)}return{}}async N(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),Se=JSON.parse((0,p.stripComments)(Ie)),Re=(0,ue.getTelemetryLevel)(this.k)>=1;if(Se["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],Xe=Ie.substring(0,Ie.length-2).concat(`,
`,$e.join(`
`));await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(Xe))}else{const $e=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);$e!==Ie&&await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString($e))}}catch(De){this.h.error(De)}}};wt=ye([Q(2,_.IInstantiationService),Q(3,B.ILogService),Q(4,q.IEnvironmentMainService),Q(5,j.ILifecycleMainService),Q(6,c.IConfigurationService),Q(7,Le.IStateService),Q(8,V.IFileService),Q(9,re.IProductService),Q(10,gt.IUserDataProfilesMainService)],wt),e.CodeApplication=wt}),define(ee[289],te([0,1,240,7,17,13,11,19,34,116,5,52,239,296]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let E=class extends y.AbstractRequestService{constructor(h,S,w,C){super(!!S.isRemoteServer,C),this.j=h,this.k=S,this.l=w,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,S){const{f:w,g:C}=this;let t;try{t=await(0,u.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(n)))}const l={...process.env,...t},i=h.agent?h.agent:await(0,b.getProxyAgent)(h.url||"",l,{proxyUrl:w,strictSSL:C});return h.agent=i,h.strictSSL=C,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>r(h,S))}async resolveProxy(h){}};E=ye([Q(0,k.IConfigurationService),Q(1,f.INativeEnvironmentService),Q(2,p.ILogService),Q(3,p.ILoggerService)],E),e.RequestService=E;async function v(g){return((0,I.parse)(g.url).protocol==="https:"?await new Promise((w,C)=>{x(["https"],w,C)}):await new Promise((w,C)=>{x(["http"],w,C)})).request}async function r(g,h){return L.Promises.withAsyncBody(async(S,w)=>{const C=(0,I.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await v(g),l={hostname:C.hostname,port:C.port?parseInt(C.port):C.protocol==="https:"?443:80,protocol:C.protocol,path:C.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const i=t(l,n=>{const a=(0,R.isNumber)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)r({...g,url:n.headers.location,followRedirects:a-1},h).then(S,w);else{let c=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,d.createGunzip)())),S({res:n,stream:(0,s.streamToBufferReadableStream)(c)})}});i.on("error",w),g.timeout&&i.setTimeout(g.timeout),g.isChromiumNetwork&&i.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&i.write(g.data),i.end(),h.onCancellationRequested(()=>{i.abort(),w(new A.CancellationError)})})}e.nodeRequest=r}),define(ee[290],te([0,1,14,289]),function(x,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function s(R){return I.net.request}class A extends L.RequestService{request(k,f){return super.request({...k||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.RequestMainService=A}),define(ee[297],te([0,1,14,41,8,22,7,44,13,32,50,45,15,9,64,4,36,26,24,47,88,288,10,19,233,243,28,62,197,16,217,92,76,213,91,20,220,5,66,21,67,272,121,249,52,290,93,241,33,48,69,53,38,228,226,2,39,254,65,221,90,117,250]),function(x,e,I,L,s,A,R,k,f,u,p,y,b,d,E,v,r,g,h,S,w,C,t,l,i,n,a,c,o,m,D,M,T,N,$,q,ie,oe,ae,de,ce,X,J,H,W,V,Y,ne,se,_,O,P,F,U,j,B,z,G,re,he,be,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Le{main(){try{this.a()}catch(me){console.error(me.message),I.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,pe,Ce,Z,ue,fe,Ee,Ae]=this.b();try{try{await this.d(Ce,Ae,Z,ue,Ee)}catch(Te){throw this.f(Ce,Ee,Te),Te}await me.invokeFunction(async Te=>{const We=Te.get(oe.ILogService),qe=Te.get(q.ILifecycleMainService),Ne=Te.get(m.IFileService),Be=Te.get(oe.ILoggerService),Ve=await this.e(We,Ce,qe,me,Ee,!0);return h.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(K=>{We.warn(`app#startup(): Error writing main lockfile: ${K.stack}`)}),fe.logger=Be.createLogger("main",{name:(0,t.localize)(0,null)}),(0,p.once)(qe.onWillShutdown)(K=>{Ne.dispose(),Z.dispose(),K.join("instanceLockfile",h.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),me.createInstance(C.CodeApplication,Ve,pe).startup()})}catch(Te){me.invokeFunction(this.i,Te)}}b(){const me=new $.ServiceCollection,pe=new B.DisposableStore;process.once("exit",()=>pe.dispose());const Ce={_serviceBrand:void 0,...ae.default};me.set(de.IProductService,Ce);const Z=new a.EnvironmentMainService(this.j(),Ce),ue=this.c(Z);me.set(a.IEnvironmentMainService,Z);const fe=new re.LoggerMainService((0,oe.getLogLevel)(Z),Z.logsHome);me.set(re.ILoggerMainService,fe);const Ee=new ie.BufferLogger(fe.getLogLevel()),Ae=pe.add(new he.LogService(Ee,[new oe.ConsoleMainLogger(fe.getLogLevel())]));me.set(oe.ILogService,Ae);const Te=new D.FileService(Ae);me.set(m.IFileService,Te);const We=new M.DiskFileSystemProvider(Ae);Te.registerProvider(b.Schemas.file,We);const qe=new G.UriIdentityService(Te);me.set(z.IUriIdentityService,qe);const Ne=new ke.StateService(1,Z,Ae,Te);me.set(se.IStateReadService,Ne),me.set(se.IStateService,Ne);const Be=new P.UserDataProfilesMainService(Ne,qe,Z,Te,Ae);me.set(P.IUserDataProfilesMainService,Be);const Ve=v.isWindows&&Ce.win32RegValueName?pe.add(new U.NativePolicyService(Ae,Ce.win32RegValueName)):Z.policyFile?pe.add(new j.FilePolicyService(Z.policyFile,Te,Ae)):new F.NullPolicyService;me.set(F.IPolicyService,Ve);const K=new i.ConfigurationService(Be.defaultProfile.settingsResource,Te,Ve,Ae);return me.set(l.IConfigurationService,K),me.set(q.ILifecycleMainService,new T.SyncDescriptor(q.LifecycleMainService,void 0,!1)),me.set(W.IRequestService,new T.SyncDescriptor(V.RequestMainService,void 0,!0)),me.set(O.IThemeMainService,new T.SyncDescriptor(O.ThemeMainService)),me.set(Y.ISignService,new T.SyncDescriptor(ne.SignService,void 0,!1)),me.set(J.ITunnelService,new T.SyncDescriptor(H.TunnelService)),me.set(ce.IProtocolMainService,new X.ProtocolMainService(Z,Be,Ae)),[new N.InstantiationService(me,!0),ue,Z,K,Ne,Ee,Ce,Be]}c(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const Z=process.env[Ce];typeof Z=="string"&&(pe[Ce]=Z)}),Object.assign(process.env,pe),pe}async d(me,pe,Ce,Z,ue){await R.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.fsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?h.Promises.mkdir(fe,{recursive:!0}):void 0)),Z.init(),Ce.initialize()]),pe.init()}async e(me,pe,Ce,Z,ue,fe){let Ee;try{(0,E.mark)("code/willStartMainServer"),Ee=await(0,w.serve)(pe.mainIPCHandle),(0,E.mark)("code/didStartMainServer"),(0,p.once)(Ce.onWillShutdown)(()=>Ee.dispose())}catch(Ae){if(Ae.code!=="EADDRINUSE")throw this.f(pe,ue,Ae),Ae;let Te;try{Te=await(0,w.connect)(pe.mainIPCHandle,"main")}catch(Be){if(!fe||v.isWindows||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.g((0,t.localize)(1,null,ue.nameShort),(0,t.localize)(2,null),ue),Be;try{(0,L.unlinkSync)(pe.mainIPCHandle)}catch(Ve){throw me.warn("Could not delete obsolete instance handle",Ve),Ve}return this.e(me,pe,Ce,Z,ue,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${ue.nameShort} is running.`;throw me.error(Be),Te.dispose(),new Error(Be)}let We;!pe.args.wait&&!pe.args.status&&(We=setTimeout(()=>{this.g((0,t.localize)(3,null,ue.nameShort),(0,t.localize)(4,null),ue)},1e4));const qe=S.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Ne=S.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return Z.invokeFunction(async()=>{const Be=new n.DiagnosticsService(_.NullTelemetryService,ue),Ve=await Ne.getMainDiagnostics(),K=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),le=await Be.getDiagnostics(Ve,K);throw console.log(le),new f.ExpectedError});throw v.isWindows&&await this.h(qe,me),me.trace("Sending env to running instance..."),await qe.start(pe.args,process.env),Te.dispose(),We&&clearTimeout(We),new f.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn("Warning: The --status argument can only be used if {0} is already running. Please run it again after {0} has started.",ue.nameShort),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ee}f(me,pe,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const Z=(0,A.coalesce)([me.userDataPath,me.extensionsPath,w.XDG_RUNTIME_DIR]).map(ue=>(0,y.getPathLabel)(s.URI.file(ue),{os:v.OS,tildify:me}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Ce),Z.join(`
`)),pe)}}g(me,pe,Ce){I.dialog.showMessageBoxSync((0,be.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:me,detail:pe},Ce).options)}async h(me,pe){if(v.isWindows){const Ce=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((Z,ue)=>{x(["windows-foreground-love"],Z,ue)})).allowSetForegroundWindow(Ce)}catch(Z){pe.error(Z)}}}i(me,pe){const Ce=me.get(oe.ILogService),Z=me.get(q.ILifecycleMainService);let ue=0;pe&&(pe.isExpected?pe.message&&Ce.trace(pe.message):(ue=1,pe.stack?Ce.error(pe.stack):Ce.error(`Startup error: ${pe.toString()}`))),Z.kill(ue)}j(){const me=this.k((0,c.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,o.createWaitMarkerFileSync)(me.verbose);pe&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.l(me._,me.goto);me._=pe}return me}l(me,pe){const Ce=(0,r.cwd)(),Z=me.map(Ee=>{let Ae=String(Ee),Te;pe&&(Te=(0,u.parseLineAndColumnAware)(Ae),Ae=Te.path),Ae&&(Ae=this.m(Ce,Ae));const We=(0,u.sanitizeFilePath)(Ae,Ce),qe=(0,d.basename)(We);return qe&&!(0,u.isValidBasename)(qe)?null:pe&&Te?(Te.path=We,this.n(Te)):We}),ue=v.isWindows||v.isMacintosh,fe=(0,A.distinct)(Z,Ee=>Ee&&ue?Ee.toLowerCase():Ee||"");return(0,A.coalesce)(fe)}m(me,pe){return v.isWindows&&(pe=(0,g.rtrim)(pe,'"')),pe=(0,g.trim)((0,g.trim)(pe," "),"	"),v.isWindows&&(pe=(0,d.resolve)(me,pe),pe=(0,g.rtrim)(pe,".")),pe}n(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Le().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-main/main.js.map
