/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(ee){for(var t=[],E=0,M=ee.length;E<M;E++)t[E]=ge[ee[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Vt=Object.isFrozen,qt=Object.getPrototypeOf,Kt=Object.getOwnPropertyDescriptor,it=Object.freeze,at=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,At=It.construct;vt||(vt=function(t,E,M){return t.apply(E,M)}),it||(it=function(t){return t}),at||(at=function(t){return t}),At||(At=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat(_t(E))))});var Yt=st(Array.prototype.forEach),Mt=st(Array.prototype.pop),gt=st(Array.prototype.push),ht=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),lt=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(ee){return function(t){for(var E=arguments.length,M=Array(E>1?E-1:0),i=1;i<E;i++)M[i-1]=arguments[i];return vt(ee,t,M)}}function Qt(ee){return function(){for(var t=arguments.length,E=Array(t),M=0;M<t;M++)E[M]=arguments[M];return At(ee,E)}}function ze(ee,t){Nt&&Nt(ee,null);for(var E=t.length;E--;){var M=t[E];if(typeof M=="string"){var i=ht(M);i!==M&&(Vt(t)||(t[E]=i),M=i)}ee[M]=!0}return ee}function ct(ee){var t=Gt(null),E=void 0;for(E in ee)vt(jt,ee,[E])&&(t[E]=ee[E]);return t}function wt(ee,t){for(;ee!==null;){var E=Kt(ee,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}ee=qt(ee)}function M(i){return console.warn("fallback value for",i),null}return M}var Ot=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ft=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=it(["#text"]),zt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=at(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=at(/<%[\s\S]*|[\s\S]*%>/gm),ni=at(/^data-[\-\w.\u00B7-\uFFFF]/),si=at(/^aria-[\-\w]+$/),ri=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=at(/^(?:\w+script|data):/i),ai=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(ee){return typeof ee}:function(ee){return ee&&typeof Symbol=="function"&&ee.constructor===Symbol&&ee!==Symbol.prototype?"symbol":typeof ee};function ot(ee){if(Array.isArray(ee)){for(var t=0,E=Array(ee.length);t<ee.length;t++)E[t]=ee[t];return E}else return Array.from(ee)}var li=function(){return typeof window>"u"?null:window},ui=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var M=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(M=E.currentScript.getAttribute(i));var W="dompurify"+(M?"#"+M:"");try{return t.createPolicy(W,{createHTML:function(A){return A}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ut(){var ee=arguments.length>0&&arguments[0]!==void 0?arguments[0]:li(),t=function(ce){return Ut(ce)};if(t.version="2.3.1",t.removed=[],!ee||!ee.document||ee.document.nodeType!==9)return t.isSupported=!1,t;var E=ee.document,M=ee.document,i=ee.DocumentFragment,W=ee.HTMLTemplateElement,v=ee.Node,A=ee.Element,h=ee.NodeFilter,a=ee.NamedNodeMap,c=a===void 0?ee.NamedNodeMap||ee.MozNamedAttrMap:a,P=ee.Text,r=ee.Comment,l=ee.DOMParser,e=ee.trustedTypes,o=A.prototype,n=wt(o,"cloneNode"),u=wt(o,"nextSibling"),s=wt(o,"childNodes"),w=wt(o,"parentNode");if(typeof W=="function"){var D=M.createElement("template");D.content&&D.content.ownerDocument&&(M=D.content.ownerDocument)}var S=ui(e,E),f=S&&Y?S.createHTML(""):"",p=M,L=p.implementation,I=p.createNodeIterator,y=p.createDocumentFragment,d=p.getElementsByTagName,m=E.importNode,b={};try{b=ct(M).documentMode?M.documentMode:{}}catch{}var O={};t.isSupported=typeof w=="function"&&L&&typeof L.createHTMLDocument<"u"&&b!==9;var q=ti,Z=ii,se=ni,ae=si,fe=oi,ue=ai,Q=ri,J=null,ve=ze({},[].concat(ot(Ot),ot(St),ot(Ct),ot(Ft),ot(Bt))),pe=null,Me=ze({},[].concat(ot(zt),ot(kt),ot(Ht),ot(Dt))),Re=null,le=null,x=!0,ne=!0,te=!1,ie=!1,T=!1,_=!1,R=!1,g=!1,C=!1,$=!0,Y=!1,F=!0,N=!0,B=!1,k={},H=null,z=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),U=null,j=ze({},["audio","video","img","source","image","track"]),G=null,re=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),he="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Le=ye,Ce=!1,we=null,Pe=M.createElement("form"),Ie=function(ce){we&&we===ce||((!ce||(typeof ce>"u"?"undefined":mt(ce))!=="object")&&(ce={}),ce=ct(ce),J="ALLOWED_TAGS"in ce?ze({},ce.ALLOWED_TAGS):ve,pe="ALLOWED_ATTR"in ce?ze({},ce.ALLOWED_ATTR):Me,G="ADD_URI_SAFE_ATTR"in ce?ze(ct(re),ce.ADD_URI_SAFE_ATTR):re,U="ADD_DATA_URI_TAGS"in ce?ze(ct(j),ce.ADD_DATA_URI_TAGS):j,H="FORBID_CONTENTS"in ce?ze({},ce.FORBID_CONTENTS):z,Re="FORBID_TAGS"in ce?ze({},ce.FORBID_TAGS):{},le="FORBID_ATTR"in ce?ze({},ce.FORBID_ATTR):{},k="USE_PROFILES"in ce?ce.USE_PROFILES:!1,x=ce.ALLOW_ARIA_ATTR!==!1,ne=ce.ALLOW_DATA_ATTR!==!1,te=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,ie=ce.SAFE_FOR_TEMPLATES||!1,T=ce.WHOLE_DOCUMENT||!1,g=ce.RETURN_DOM||!1,C=ce.RETURN_DOM_FRAGMENT||!1,$=ce.RETURN_DOM_IMPORT!==!1,Y=ce.RETURN_TRUSTED_TYPE||!1,R=ce.FORCE_BODY||!1,F=ce.SANITIZE_DOM!==!1,N=ce.KEEP_CONTENT!==!1,B=ce.IN_PLACE||!1,Q=ce.ALLOWED_URI_REGEXP||Q,Le=ce.NAMESPACE||ye,ie&&(ne=!1),C&&(g=!0),k&&(J=ze({},[].concat(ot(Bt))),pe=[],k.html===!0&&(ze(J,Ot),ze(pe,zt)),k.svg===!0&&(ze(J,St),ze(pe,kt),ze(pe,Dt)),k.svgFilters===!0&&(ze(J,Ct),ze(pe,kt),ze(pe,Dt)),k.mathMl===!0&&(ze(J,Ft),ze(pe,Ht),ze(pe,Dt))),ce.ADD_TAGS&&(J===ve&&(J=ct(J)),ze(J,ce.ADD_TAGS)),ce.ADD_ATTR&&(pe===Me&&(pe=ct(pe)),ze(pe,ce.ADD_ATTR)),ce.ADD_URI_SAFE_ATTR&&ze(G,ce.ADD_URI_SAFE_ATTR),ce.FORBID_CONTENTS&&(H===z&&(H=ct(H)),ze(H,ce.FORBID_CONTENTS)),N&&(J["#text"]=!0),T&&ze(J,["html","head","body"]),J.table&&(ze(J,["tbody"]),delete Re.tbody),it&&it(ce),we=ce)},Ve=ze({},["mi","mo","mn","ms","mtext"]),He=ze({},["foreignobject","desc","title","annotation-xml"]),Ue=ze({},St);ze(Ue,Ct),ze(Ue,Jt);var Ze=ze({},Ft);ze(Ze,ei);var Ge=function(ce){var Ae=w(ce);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:ye,tagName:"template"});var Ne=ht(ce.tagName),$e=ht(Ae.tagName);if(ce.namespaceURI===De)return Ae.namespaceURI===ye?Ne==="svg":Ae.namespaceURI===he?Ne==="svg"&&($e==="annotation-xml"||Ve[$e]):Boolean(Ue[Ne]);if(ce.namespaceURI===he)return Ae.namespaceURI===ye?Ne==="math":Ae.namespaceURI===De?Ne==="math"&&He[$e]:Boolean(Ze[Ne]);if(ce.namespaceURI===ye){if(Ae.namespaceURI===De&&!He[$e]||Ae.namespaceURI===he&&!Ve[$e])return!1;var Qe=ze({},["title","style","font","a","script"]);return!Ze[Ne]&&(Qe[Ne]||!Ue[Ne])}return!1},Be=function(ce){gt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{try{ce.outerHTML=f}catch{ce.remove()}}},V=function(ce,Ae){try{gt(t.removed,{attribute:Ae.getAttributeNode(ce),from:Ae})}catch{gt(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(ce),ce==="is"&&!pe[ce])if(g||C)try{Be(Ae)}catch{}else try{Ae.setAttribute(ce,"")}catch{}},oe=function(ce){var Ae=void 0,Ne=void 0;if(R)ce="<remove></remove>"+ce;else{var $e=Pt(ce,/^[\r\n\t ]+/);Ne=$e&&$e[0]}var Qe=S?S.createHTML(ce):ce;if(Le===ye)try{Ae=new l().parseFromString(Qe,"text/html")}catch{}if(!Ae||!Ae.documentElement){Ae=L.createDocument(Le,"template",null);try{Ae.documentElement.innerHTML=Ce?"":Qe}catch{}}var Je=Ae.body||Ae.documentElement;return ce&&Ne&&Je.insertBefore(M.createTextNode(Ne),Je.childNodes[0]||null),Le===ye?d.call(Ae,T?"html":"body")[0]:T?Ae.documentElement:Je},be=function(ce){return I.call(ce.ownerDocument||ce,ce,h.SHOW_ELEMENT|h.SHOW_COMMENT|h.SHOW_TEXT,null,!1)},Ee=function(ce){return ce instanceof P||ce instanceof r?!1:typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof c)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"},Se=function(ce){return(typeof v>"u"?"undefined":mt(v))==="object"?ce instanceof v:ce&&(typeof ce>"u"?"undefined":mt(ce))==="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},Oe=function(ce,Ae,Ne){!O[ce]||Yt(O[ce],function($e){$e.call(t,Ae,Ne,we)})},We=function(ce){var Ae=void 0;if(Oe("beforeSanitizeElements",ce,null),Ee(ce)||Pt(ce.nodeName,/[\u0080-\uFFFF]/))return Be(ce),!0;var Ne=ht(ce.nodeName);if(Oe("uponSanitizeElement",ce,{tagName:Ne,allowedTags:J}),!Se(ce.firstElementChild)&&(!Se(ce.content)||!Se(ce.content.firstElementChild))&&lt(/<[/\w]/g,ce.innerHTML)&&lt(/<[/\w]/g,ce.textContent)||Ne==="select"&&lt(/<template/i,ce.innerHTML))return Be(ce),!0;if(!J[Ne]||Re[Ne]){if(N&&!H[Ne]){var $e=w(ce)||ce.parentNode,Qe=s(ce)||ce.childNodes;if(Qe&&$e)for(var Je=Qe.length,et=Je-1;et>=0;--et)$e.insertBefore(n(Qe[et],!0),u(ce))}return Be(ce),!0}return ce instanceof A&&!Ge(ce)||(Ne==="noscript"||Ne==="noembed")&&lt(/<\/no(script|embed)/i,ce.innerHTML)?(Be(ce),!0):(ie&&ce.nodeType===3&&(Ae=ce.textContent,Ae=ut(Ae,q," "),Ae=ut(Ae,Z," "),ce.textContent!==Ae&&(gt(t.removed,{element:ce.cloneNode()}),ce.textContent=Ae)),Oe("afterSanitizeElements",ce,null),!1)},tt=function(ce,Ae,Ne){if(F&&(Ae==="id"||Ae==="name")&&(Ne in M||Ne in Pe))return!1;if(!(ne&&!le[Ae]&&lt(se,Ae))){if(!(x&&lt(ae,Ae))){if(!pe[Ae]||le[Ae])return!1;if(!G[Ae]){if(!lt(Q,ut(Ne,ue,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&ce!=="script"&&Xt(Ne,"data:")===0&&U[ce])){if(!(te&&!lt(fe,ut(Ne,ue,"")))){if(Ne)return!1}}}}}}return!0},Ke=function(ce){var Ae=void 0,Ne=void 0,$e=void 0,Qe=void 0;Oe("beforeSanitizeAttributes",ce,null);var Je=ce.attributes;if(!!Je){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:pe};for(Qe=Je.length;Qe--;){Ae=Je[Qe];var rt=Ae,dt=rt.name,bt=rt.namespaceURI;if(Ne=Zt(Ae.value),$e=ht(dt),et.attrName=$e,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Oe("uponSanitizeAttribute",ce,et),Ne=et.attrValue,!et.forceKeepAttr&&(V(dt,ce),!!et.keepAttr)){if(lt(/\/>/i,Ne)){V(dt,ce);continue}ie&&(Ne=ut(Ne,q," "),Ne=ut(Ne,Z," "));var Tt=ce.nodeName.toLowerCase();if(!!tt(Tt,$e,Ne))try{bt?ce.setAttributeNS(bt,dt,Ne):ce.setAttribute(dt,Ne),Mt(t.removed)}catch{}}}Oe("afterSanitizeAttributes",ce,null)}},_e=function Te(ce){var Ae=void 0,Ne=be(ce);for(Oe("beforeSanitizeShadowDOM",ce,null);Ae=Ne.nextNode();)Oe("uponSanitizeShadowNode",Ae,null),!We(Ae)&&(Ae.content instanceof i&&Te(Ae.content),Ke(Ae));Oe("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Te,ce){var Ae=void 0,Ne=void 0,$e=void 0,Qe=void 0,Je=void 0;if(Ce=!Te,Ce&&(Te="<!-->"),typeof Te!="string"&&!Se(Te)){if(typeof Te.toString!="function")throw Rt("toString is not a function");if(Te=Te.toString(),typeof Te!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(ee.toStaticHTML)==="object"||typeof ee.toStaticHTML=="function"){if(typeof Te=="string")return ee.toStaticHTML(Te);if(Se(Te))return ee.toStaticHTML(Te.outerHTML)}return Te}if(_||Ie(ce),t.removed=[],typeof Te=="string"&&(B=!1),!B)if(Te instanceof v)Ae=oe("<!---->"),Ne=Ae.ownerDocument.importNode(Te,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Ae=Ne:Ae.appendChild(Ne);else{if(!g&&!ie&&!T&&Te.indexOf("<")===-1)return S&&Y?S.createHTML(Te):Te;if(Ae=oe(Te),!Ae)return g?null:f}Ae&&R&&Be(Ae.firstChild);for(var et=be(B?Te:Ae);$e=et.nextNode();)$e.nodeType===3&&$e===Qe||We($e)||($e.content instanceof i&&_e($e.content),Ke($e),Qe=$e);if(Qe=null,B)return Te;if(g){if(C)for(Je=y.call(Ae.ownerDocument);Ae.firstChild;)Je.appendChild(Ae.firstChild);else Je=Ae;return $&&(Je=m.call(E,Je,!0)),Je}var rt=T?Ae.outerHTML:Ae.innerHTML;return ie&&(rt=ut(rt,q," "),rt=ut(rt,Z," ")),S&&Y?S.createHTML(rt):rt},t.setConfig=function(Te){Ie(Te),_=!0},t.clearConfig=function(){we=null,_=!1},t.isValidAttribute=function(Te,ce,Ae){we||Ie({});var Ne=ht(Te),$e=ht(ce);return tt(Ne,$e,Ae)},t.addHook=function(Te,ce){typeof ce=="function"&&(O[Te]=O[Te]||[],gt(O[Te],ce))},t.removeHook=function(Te){O[Te]&&Mt(O[Te])},t.removeHooks=function(Te){O[Te]&&(O[Te]=[])},t.removeAllHooks=function(){O={}},t}var hi=Ut();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(ge[38],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(v){this.domNode=v,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(v){const A=M(v);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(v){const A=M(v);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(v){const A=M(v);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(v){const A=M(v);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(v){const A=M(v);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(v){const A=M(v);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(v){const A=M(v);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(v){const A=M(v);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(v){const A=M(v);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(v){const A=M(v);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(v){const A=M(v);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(v){this.l!==v&&(this.l=v,this.domNode.style.fontFamily=this.l)}setFontWeight(v){this.m!==v&&(this.m=v,this.domNode.style.fontWeight=this.m)}setFontSize(v){const A=M(v);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(v){this.o!==v&&(this.o=v,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(v){this.p!==v&&(this.p=v,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(v){this.q!==v&&(this.q=v,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(v){this.r!==v&&(this.r=v,this.domNode.style.textDecoration=this.r)}setLineHeight(v){const A=M(v);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(v){const A=M(v);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(v){this.u!==v&&(this.u=v,this.domNode.className=this.u)}toggleClassName(v,A){this.domNode.classList.toggle(v,A),this.u=this.domNode.className}setDisplay(v){this.v!==v&&(this.v=v,this.domNode.style.display=this.v)}setPosition(v){this.w!==v&&(this.w=v,this.domNode.style.position=this.w)}setVisibility(v){this.x!==v&&(this.x=v,this.domNode.style.visibility=this.x)}setColor(v){this.y!==v&&(this.y=v,this.domNode.style.color=this.y)}setBackgroundColor(v){this.z!==v&&(this.z=v,this.domNode.style.backgroundColor=this.z)}setLayerHinting(v){this.A!==v&&(this.A=v,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(v){this.C!==v&&(this.C=v,this.domNode.style.boxShadow=v)}setContain(v){this.B!==v&&(this.B=v,this.domNode.style.contain=this.B)}setAttribute(v,A){this.domNode.setAttribute(v,A)}removeAttribute(v){this.domNode.removeAttribute(v)}appendChild(v){this.domNode.appendChild(v.domNode)}removeChild(v){this.domNode.removeChild(v.domNode)}}t.FastDomNode=E;function M(W){return typeof W=="number"?`${W}px`:W}function i(W){return new E(W)}t.createFastDomNode=i}),define(ge[66],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,M=null;function i(v){if(!v.parent||v.parent===v)return null;try{const A=v.location,h=v.parent.location;if(A.origin!=="null"&&h.origin!=="null"&&A.origin!==h.origin)return E=!0,null}catch{return E=!0,null}return v.parent}class W{static getSameOriginWindowChain(){if(!M){M=[];let A=window,h;do h=i(A),h?M.push({window:A,iframeElement:A.frameElement||null}):M.push({window:A,iframeElement:null}),A=h;while(A)}return M.slice(0)}static hasDifferentOriginAncestor(){return M||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(A,h){if(!h||A===h)return{top:0,left:0};let a=0,c=0;const P=this.getSameOriginWindowChain();for(const r of P){if(a+=r.window.scrollY,c+=r.window.scrollX,r.window===h||!r.iframeElement)break;const l=r.iframeElement.getBoundingClientRect();a+=l.top,c+=l.left}return{top:a,left:c}}}t.IframeUtils=W}),define(ge[67],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class M extends Error{constructor(v,A){super(`ListError [${v}] ${A}`)}}t.ListError=M;class i{constructor(){this.c=new WeakMap}getHeight(v){return this.c.get(v)??this.d(v)}setDynamicHeight(v,A){A>0&&this.c.set(v,A)}}t.CachedListVirtualDelegate=i}),define(ge[68],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.a=i}splice(i,W,v){this.a.forEach(A=>A.splice(i,W,v))}}t.CombinedSpliceable=E}),define(ge[39],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class M{constructor(W,v,A,h,a,c){this.a=Math.round(v),this.b=Math.round(A),this.c=Math.round(W),this.d=h,this.e=a,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new M(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const v=Math.round(W);return this.d!==v?(this.d=v,this.m(),!0):!1}setScrollSize(W){const v=Math.round(W);return this.e!==v?(this.e=v,this.m(),!0):!1}setScrollPosition(W){const v=Math.round(W);return this.f!==v?(this.f=v,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,v,A,h,a){const c=Math.max(0,A-W),P=Math.max(0,c-2*v),r=h>0&&h>A;if(!r)return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(E,Math.floor(A*P/h))),e=(P-l)/(h-A),o=a*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(o)}}m(){const W=M.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const v=W-this.c-this.i/2;return Math.round(v/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const v=W-this.c;let A=this.f;return v<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const v=this.k+W;return Math.round(v/this.j)}}t.ScrollbarState=M}),define(ge[24],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var M;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(M=t.ObjectTreeElementCollapseState||(t.ObjectTreeElementCollapseState={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var W;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(W=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class v extends Error{constructor(a,c){super(`TreeError [${a}] ${c}`)}}t.TreeError=v;class A{constructor(a){this.a=a,this.b=new WeakMap}map(a){let c=this.b.get(a);return c||(c=this.a(a),this.b.set(a,c)),c}}t.WeakMapper=A}),define(ge[69],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(v,A){const h=Object.create(null);for(const a of v){const c=A(a);let P=h[c];P||(P=h[c]=[]),P.push(a)}return h}t.groupBy=E;function M(v,A){const h=[],a=[];for(const c of v)A.has(c)||h.push(c);for(const c of A)v.has(c)||a.push(c);return{removed:h,added:a}}t.diffSets=M;function i(v,A){const h=[],a=[];for(const[c,P]of v)A.has(c)||h.push(P);for(const[c,P]of A)v.has(c)||a.push(P);return{removed:h,added:a}}t.diffMaps=i;class W{constructor(){this.a=new Map}add(A,h){let a=this.a.get(A);a||(a=new Set,this.a.set(A,a)),a.add(h)}delete(A,h){const a=this.a.get(A);!a||(a.delete(h),a.size===0&&this.a.delete(A))}forEach(A,h){const a=this.a.get(A);!a||a.forEach(h)}}t.SetMap=W}),define(ge[70],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(A,h){const a=Math.pow(10,h);return Math.round(A*a)/a}class M{constructor(h,a,c,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.r===a.r&&h.g===a.g&&h.b===a.b&&h.a===a.a}}t.RGBA=M;class i{constructor(h,a,c,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,a),0),3),this.l=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.l===a.l&&h.a===a.a}static fromRGBA(h){const a=h.r/255,c=h.g/255,P=h.b/255,r=h.a,l=Math.max(a,c,P),e=Math.min(a,c,P);let o=0,n=0;const u=(e+l)/2,s=l-e;if(s>0){switch(n=Math.min(u<=.5?s/(2*u):s/(2-2*u),1),l){case a:o=(c-P)/s+(c<P?6:0);break;case c:o=(P-a)/s+2;break;case P:o=(a-c)/s+4;break}o*=60,o=Math.round(o)}return new i(o,n,u,r)}static i(h,a,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?h+(a-h)*6*c:c<1/2?a:c<2/3?h+(a-h)*(2/3-c)*6:h}static toRGBA(h){const a=h.h/360,{s:c,l:P,a:r}=h;let l,e,o;if(c===0)l=e=o=P;else{const n=P<.5?P*(1+c):P+c-P*c,u=2*P-n;l=i.i(u,n,a+1/3),e=i.i(u,n,a),o=i.i(u,n,a-1/3)}return new M(Math.round(l*255),Math.round(e*255),Math.round(o*255),r)}}t.HSLA=i;class W{constructor(h,a,c,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,a),0),3),this.v=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.v===a.v&&h.a===a.a}static fromRGBA(h){const a=h.r/255,c=h.g/255,P=h.b/255,r=Math.max(a,c,P),l=Math.min(a,c,P),e=r-l,o=r===0?0:e/r;let n;return e===0?n=0:r===a?n=((c-P)/e%6+6)%6:r===c?n=(P-a)/e+2:n=(a-c)/e+4,new W(Math.round(n*60),o,r,h.a)}static toRGBA(h){const{h:a,s:c,v:P,a:r}=h,l=P*c,e=l*(1-Math.abs(a/60%2-1)),o=P-l;let[n,u,s]=[0,0,0];return a<60?(n=l,u=e):a<120?(n=e,u=l):a<180?(u=l,s=e):a<240?(u=e,s=l):a<300?(n=e,s=l):a<=360&&(n=l,s=e),n=Math.round((n+o)*255),u=Math.round((u+o)*255),s=Math.round((s+o)*255),new M(n,u,s,r)}}t.HSVA=W;class v{static fromHex(h){return v.Format.CSS.parseHex(h)||v.red}static equals(h,a){return!h&&!a?!0:!h||!a?!1:h.equals(a)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof M)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof W)this.j=h,this.rgba=W.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&M.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&W.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=v.k(this.rgba.r),a=v.k(this.rgba.g),c=v.k(this.rgba.b),P=.2126*h+.7152*a+.0722*c;return E(P,4)}static k(h){const a=h/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a>c?(a+.05)/(c+.05):(c+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a>c}isDarkerThan(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a<c}lighten(h){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:a,g:c,b:P,a:r}=this.rgba;return new v(new M(a,c,P,r*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const a=h.rgba,c=this.rgba.a,P=a.a,r=c+P*(1-c);if(r<1e-6)return v.transparent;const l=this.rgba.r*c/r+a.r*P*(1-c)/r,e=this.rgba.g*c/r+a.g*P*(1-c)/r,o=this.rgba.b*c/r+a.b*P*(1-c)/r;return new v(new M(l,e,o,r))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:a,g:c,b:P,a:r}=this.rgba;return new v(new M(h.rgba.r-r*(h.rgba.r-a),h.rgba.g-r*(h.rgba.g-c),h.rgba.b-r*(h.rgba.b-P),1))}flatten(...h){const a=h.reduceRight((c,P)=>v.o(P,c));return v.o(this,a)}static o(h,a){const c=1-h.rgba.a;return new v(new M(c*a.rgba.r+h.rgba.a*h.rgba.r,c*a.rgba.g+h.rgba.a*h.rgba.g,c*a.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(h,a,c){if(h.isLighterThan(a))return h;c=c||.5;const P=h.getRelativeLuminance(),r=a.getRelativeLuminance();return c=c*(r-P)/r,h.lighten(c)}static getDarkerColor(h,a,c){if(h.isDarkerThan(a))return h;c=c||.5;const P=h.getRelativeLuminance(),r=a.getRelativeLuminance();return c=c*(P-r)/P,h.darken(c)}}v.white=new v(new M(255,255,255,1)),v.black=new v(new M(0,0,0,1)),v.red=new v(new M(255,0,0,1)),v.blue=new v(new M(0,0,255,1)),v.green=new v(new M(0,255,0,1)),v.cyan=new v(new M(0,255,255,1)),v.lightgrey=new v(new M(211,211,211,1)),v.transparent=new v(new M(0,0,0,0)),t.Color=v,function(A){let h;(function(a){let c;(function(P){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:A.Format.CSS.formatRGBA(f)}P.formatRGB=r;function l(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}P.formatRGBA=l;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(f)}P.formatHSL=e;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}P.formatHSLA=o;function n(f){const p=f.toString(16);return p.length!==2?"0"+p:p}function u(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}P.formatHex=u;function s(f,p=!1){return p&&f.rgba.a===1?A.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}P.formatHexA=s;function w(f){return f.isOpaque()?A.Format.CSS.formatHex(f):A.Format.CSS.formatRGBA(f)}P.format=w;function D(f){const p=f.length;if(p===0||f.charCodeAt(0)!==35)return null;if(p===7){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),I=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),y=16*S(f.charCodeAt(5))+S(f.charCodeAt(6));return new A(new M(L,I,y,1))}if(p===9){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),I=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),y=16*S(f.charCodeAt(5))+S(f.charCodeAt(6)),d=16*S(f.charCodeAt(7))+S(f.charCodeAt(8));return new A(new M(L,I,y,d/255))}if(p===4){const L=S(f.charCodeAt(1)),I=S(f.charCodeAt(2)),y=S(f.charCodeAt(3));return new A(new M(16*L+L,16*I+I,16*y+y))}if(p===5){const L=S(f.charCodeAt(1)),I=S(f.charCodeAt(2)),y=S(f.charCodeAt(3)),d=S(f.charCodeAt(4));return new A(new M(16*L+L,16*I+I,16*y+y,(16*d+d)/255))}return null}P.parseHex=D;function S(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=a.CSS||(a.CSS={}))})(h=A.Format||(A.Format={}))}(v=t.Color||(t.Color={})),t.Color=v}),define(ge[25],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(v){return(A,h,a)=>{let c=null,P=null;if(typeof a.value=="function"?(c="value",P=a.value):typeof a.get=="function"&&(c="get",P=a.get),!P)throw new Error("not supported");a[c]=v(P,h)}}function M(v,A,h){let a=null,c=null;if(typeof h.value=="function"?(a="value",c=h.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",c=h.get),!c)throw new Error("not supported");const P=`$memoize$${A}`;h[a]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,r)}),this[P]}}t.memoize=M;function i(v,A,h){return E((a,c)=>{const P=`$debounce$${c}`,r=`$debounce$result$${c}`;return function(...l){this[r]||(this[r]=h?h():void 0),clearTimeout(this[P]),A&&(this[r]=A(this[r],...l),l=[this[r]]),this[P]=setTimeout(()=>{a.apply(this,l),this[r]=h?h():void 0},v)}})}t.debounce=i;function W(v,A,h){return E((a,c)=>{const P=`$throttle$timer$${c}`,r=`$throttle$result$${c}`,l=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...o){if(this[r]||(this[r]=h?h():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),A&&(this[r]=A(this[r],...o)),this[e])return;const n=this[l]+v;n<=Date.now()?(this[l]=Date.now(),a.apply(this,[this[r]]),this[r]=h?h():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),a.apply(this,[this[r]]),this[r]=h?h():void 0},n-Date.now()))}})}t.throttle=W}),define(ge[71],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,W,v,A){this.originalStart=i,this.originalLength=W,this.modifiedStart=v,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(p){setTimeout(()=>{throw p.stack?D.isErrorNoTelemetry(p)?new D(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}addListener(p){return this.b.push(p),()=>{this.d(p)}}c(p){this.b.forEach(L=>{L(p)})}d(p){this.b.splice(this.b.indexOf(p),1)}setUnexpectedErrorHandler(p){this.a=p}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(p){this.a(p),this.c(p)}onUnexpectedExternalError(p){this.a(p)}}t.ErrorHandler=E,t.errorHandler=new E;function M(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=M;function i(f){if(!f||typeof f!="object")return!1;const p=f;return p.code==="EPIPE"&&p.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(f){a(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=W;function v(f){a(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=v;function A(f){if(f instanceof Error){const{name:p,message:L}=f,I=f.stacktrace||f.stack;return{$isError:!0,name:p,message:L,stack:I,noTelemetry:D.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=A;const h="Canceled";function a(f){return f instanceof c?!0:f instanceof Error&&f.name===h&&f.message===h}t.isCancellationError=a;class c extends Error{constructor(){super(h),this.name=this.message}}t.CancellationError=c;function P(){const f=new Error(h);return f.name=f.message,f}t.canceled=P;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=l;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function o(f){const p=new Error(`${f} has been disposed`);return p.name="DISPOSED",p}t.disposed=o;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class u extends Error{constructor(p){super("NotImplemented"),p&&(this.message=p)}}t.NotImplementedError=u;class s extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}t.NotSupportedError=s;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=w;class D extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof D)return p;const L=new D;return L.message=p.message,L.stack=p.stack,L}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}t.ErrorNoTelemetry=D;class S extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(ge[13],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function M(F,N=0){return F[F.length-(1+N)]}t.tail=M;function i(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}t.tail2=i;function W(F,N,B=(k,H)=>k===H){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let k=0,H=F.length;k<H;k++)if(!B(F[k],N[k]))return!1;return!0}t.equals=W;function v(F,N){const B=F.length-1;N<B&&(F[N]=F[B]),F.pop()}t.removeFastWithoutKeepingOrder=v;function A(F,N,B){return h(F.length,k=>B(F[k],N))}t.binarySearch=A;function h(F,N){let B=0,k=F-1;for(;B<=k;){const H=(B+k)/2|0,z=N(H);if(z<0)B=H+1;else if(z>0)k=H-1;else return H}return-(B+1)}t.binarySearch2=h;function a(F,N){let B=0,k=F.length;if(k===0)return 0;for(;B<k;){const H=Math.floor((B+k)/2);N(F[H])?k=H:B=H+1}return B}t.findFirstInSorted=a;function c(F,N,B){if(F=F|0,F>=N.length)throw new TypeError("invalid index");const k=N[Math.floor(N.length*Math.random())],H=[],z=[],U=[];for(const j of N){const G=B(j,k);G<0?H.push(j):G>0?z.push(j):U.push(j)}return F<H.length?c(F,H,B):F<H.length+U.length?U[0]:c(F-(H.length+U.length),z,B)}t.quickSelect=c;function P(F,N){const B=[];let k;for(const H of F.slice(0).sort(N))!k||N(k[0],H)!==0?(k=[H],B.push(k)):k.push(H);return B}t.groupBy=P;function r(F,N,B){const k=[];function H(j,G,re){if(G===0&&re.length===0)return;const he=k[k.length-1];he&&he.start+he.deleteCount===j?(he.deleteCount+=G,he.toInsert.push(...re)):k.push({start:j,deleteCount:G,toInsert:re})}let z=0,U=0;for(;;){if(z===F.length){H(z,0,N.slice(U));break}if(U===N.length){H(z,F.length-z,[]);break}const j=F[z],G=N[U],re=B(j,G);re===0?(z+=1,U+=1):re<0?(H(z,1,[]),z+=1):re>0&&(H(z,0,[G]),U+=1)}return k}t.sortedDiff=r;function l(F,N,B){const k=r(F,N,B),H=[],z=[];for(const U of k)H.push(...F.slice(U.start,U.start+U.deleteCount)),z.push(...U.toInsert);return{removed:H,added:z}}t.delta=l;function e(F,N,B){if(B===0)return[];const k=F.slice(0,B).sort(N);return n(F,N,k,B,F.length),k}t.top=e;function o(F,N,B,k,H){return B===0?Promise.resolve([]):new Promise((z,U)=>{(async()=>{const j=F.length,G=F.slice(0,B).sort(N);for(let re=B,he=Math.min(B+k,j);re<j;re=he,he=Math.min(he+k,j)){if(re>B&&await new Promise(De=>setTimeout(De)),H&&H.isCancellationRequested)throw new E.CancellationError;n(F,N,G,re,he)}return G})().then(z,U)})}t.topAsync=o;function n(F,N,B,k,H){for(const z=B.length;k<H;k++){const U=F[k];if(N(U,B[z-1])<0){B.pop();const j=a(B,G=>N(U,G)<0);B.splice(j,0,U)}}}function u(F){return F.filter(N=>!!N)}t.coalesce=u;function s(F){let N=0;for(let B=0;B<F.length;B++)F[B]&&(F[N]=F[B],N+=1);F.length=N}t.coalesceInPlace=s;function w(F,N,B){F.splice(B,0,F.splice(N,1)[0])}t.move=w;function D(F){return!Array.isArray(F)||F.length===0}t.isFalsyOrEmpty=D;function S(F){return Array.isArray(F)&&F.length>0}t.isNonEmptyArray=S;function f(F,N=B=>B){const B=new Set;return F.filter(k=>{const H=N(k);return B.has(H)?!1:(B.add(H),!0)})}t.distinct=f;function p(F){const N=new Set;return B=>{const k=F(B);return N.has(k)?!1:(N.add(k),!0)}}t.uniqueFilter=p;function L(F,N){const B=I(F,N);if(B!==-1)return F[B]}t.findLast=L;function I(F,N){for(let B=F.length-1;B>=0;B--){const k=F[B];if(N(k))return B}return-1}t.lastIndex=I;function y(F,N){return F.length>0?F[0]:N}t.firstOrDefault=y;function d(F,N){return F.length>0?F[F.length-1]:N}t.lastOrDefault=d;function m(F,N,B=(k,H)=>k===H){let k=0;for(let H=0,z=Math.min(F.length,N.length);H<z&&B(F[H],N[H]);H++)k++;return k}t.commonPrefixLength=m;function b(F){return[].concat(...F)}t.flatten=b;function O(F,N){let B=typeof N=="number"?F:0;typeof N=="number"?B=F:(B=0,N=F);const k=[];if(B<=N)for(let H=B;H<N;H++)k.push(H);else for(let H=B;H>N;H--)k.push(H);return k}t.range=O;function q(F,N,B){return F.reduce((k,H)=>(k[N(H)]=B?B(H):H,k),Object.create(null))}t.index=q;function Z(F,N){return F.push(N),()=>se(F,N)}t.insert=Z;function se(F,N){const B=F.indexOf(N);if(B>-1)return F.splice(B,1),N}t.remove=se;function ae(F,N,B){const k=F.slice(0,N),H=F.slice(N);return k.concat(B,H)}t.arrayInsert=ae;function fe(F,N){let B;if(typeof N=="number"){let k=N;B=()=>{const H=Math.sin(k++)*179426549;return H-Math.floor(H)}}else B=Math.random;for(let k=F.length-1;k>0;k-=1){const H=Math.floor(B()*(k+1)),z=F[k];F[k]=F[H],F[H]=z}}t.shuffle=fe;function ue(F,N){const B=F.indexOf(N);B>-1&&(F.splice(B,1),F.unshift(N))}t.pushToStart=ue;function Q(F,N){const B=F.indexOf(N);B>-1&&(F.splice(B,1),F.push(N))}t.pushToEnd=Q;function J(F,N){for(const B of N)F.push(B)}t.pushMany=J;function ve(F,N){return Array.isArray(F)?F.map(N):N(F)}t.mapArrayOrNot=ve;function pe(F){return Array.isArray(F)?F:[F]}t.asArray=pe;function Me(F){return F[Math.floor(Math.random()*F.length)]}t.getRandomElement=Me;function Re(F,N){for(const B of F){const k=N(B);if(k!==void 0)return k}}t.mapFind=Re;function le(F,N,B){const k=ne(F,N),H=F.length,z=B.length;F.length=H+z;for(let U=H-1;U>=k;U--)F[U+z]=F[U];for(let U=0;U<z;U++)F[U+k]=B[U]}t.insertInto=le;function x(F,N,B,k){const H=ne(F,N),z=F.splice(H,B);return le(F,H,k),z}t.splice=x;function ne(F,N){return N<0?Math.max(N+F.length,0):Math.min(N,F.length)}var te;(function(F){function N(H){return H<0}F.isLessThan=N;function B(H){return H>0}F.isGreaterThan=B;function k(H){return H===0}F.isNeitherLessOrGreaterThan=k,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(te=t.CompareResult||(t.CompareResult={}));function ie(F,N){return(B,k)=>N(F(B),F(k))}t.compareBy=ie;function T(...F){return(N,B)=>{for(const k of F){const H=k(N,B);if(!te.isNeitherLessOrGreaterThan(H))return H}return te.neitherLessOrGreaterThan}}t.tieBreakComparators=T;const _=(F,N)=>F-N;t.numberComparator=_;function R(F,N){if(F.length===0)return;let B=F[0];for(let k=1;k<F.length;k++){const H=F[k];N(H,B)>0&&(B=H)}return B}t.findMaxBy=R;function g(F,N){if(F.length===0)return;let B=F[0];for(let k=1;k<F.length;k++){const H=F[k];N(H,B)>=0&&(B=H)}return B}t.findLastMaxBy=g;function C(F,N){return R(F,(B,k)=>-N(B,k))}t.findMinBy=C;class ${constructor(N){this.f=N,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(N){let B=this.c;for(;B<this.f.length&&N(this.f[B]);)B++;const k=B===this.c?null:this.f.slice(this.c,B);return this.c=B,k}takeFromEndWhile(N){let B=this.d;for(;B>=0&&N(this.f[B]);)B--;const k=B===this.d?null:this.f.slice(B+1,this.d+1);return this.d=B,k}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const N=this.f[this.c];return this.c++,N}removeLast(){const N=this.f[this.d];return this.d--,N}takeCount(N){const B=this.f.slice(this.c,this.c+N);return this.c+=N,B}}t.ArrayQueue=$;class Y{constructor(N){this.iterate=N}forEach(N){this.iterate(B=>(N(B),!0))}toArray(){const N=[];return this.iterate(B=>(N.push(B),!0)),N}filter(N){return new Y(B=>this.iterate(k=>N(k)?B(k):!0))}map(N){return new Y(B=>this.iterate(k=>B(N(k))))}some(N){let B=!1;return this.iterate(k=>(B=N(k),!B)),B}findFirst(N){let B;return this.iterate(k=>N(k)?(B=k,!1):!0),B}findLast(N){let B;return this.iterate(k=>(N(k)&&(B=k),!0)),B}findLastMaxBy(N){let B,k=!0;return this.iterate(H=>((k||te.isGreaterThan(N(H,B)))&&(k=!1,B=H),!0)),B}}Y.empty=new Y(F=>{}),t.CallbackIterable=Y}),define(ge[72],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function M(h,a){if(!h)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}t.ok=M;function i(h,a="Unreachable"){throw new Error(a)}t.assertNever=i;function W(h){if(!h)throw new E.BugIndicatingError("Assertion Failed")}t.assert=W;function v(h){if(!h()){debugger;h(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=v;function A(h,a){let c=0;for(;c<h.length-1;){const P=h[c],r=h[c+1];if(!a(P,r))return!1;c++}return!0}t.checkAdjacentItems=A}),define(ge[40],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(M){const i=this;let W=!1,v;return function(){return W||(W=!0,v=M.apply(i,arguments)),v}}t.once=E}),define(ge[73],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(M){function i(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}M.is=i;const W=Object.freeze([]);function v(){return W}M.empty=v;function*A(D){yield D}M.single=A;function h(D){return i(D)?D:A(D)}M.wrap=h;function a(D){return D||W}M.from=a;function c(D){return!D||D[Symbol.iterator]().next().done===!0}M.isEmpty=c;function P(D){return D[Symbol.iterator]().next().value}M.first=P;function r(D,S){for(const f of D)if(S(f))return!0;return!1}M.some=r;function l(D,S){for(const f of D)if(S(f))return f}M.find=l;function*e(D,S){for(const f of D)S(f)&&(yield f)}M.filter=e;function*o(D,S){let f=0;for(const p of D)yield S(p,f++)}M.map=o;function*n(...D){for(const S of D)for(const f of S)yield f}M.concat=n;function u(D,S,f){let p=f;for(const L of D)p=S(p,L);return p}M.reduce=u;function*s(D,S,f=D.length){for(S<0&&(S+=D.length),f<0?f+=D.length:f>D.length&&(f=D.length);S<f;S++)yield D[S]}M.slice=s;function w(D,S=Number.POSITIVE_INFINITY){const f=[];if(S===0)return[f,D];const p=D[Symbol.iterator]();for(let L=0;L<S;L++){const I=p.next();if(I.done)return[f,M.empty()];f.push(I.value)}return[f,{[Symbol.iterator](){return p}}]}M.consume=w})(E=t.Iterable||(t.Iterable={}))}),define(ge[41],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(M=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,n){this._keyCodeToStr[o]=n,this._strToKeyCode[n.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const W=new i,v=new i,A=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],a=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>a[e]||0,toString:e=>h[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",o=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],u=[];for(const s of o){const[w,D,S,f,p,L,I,y,d,m]=s;if(u[S]||(u[S]=!0,h[S]=f,a[f]=S,c[f.toLowerCase()]=S,D&&(t.IMMUTABLE_CODE_TO_KEY_CODE[S]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[p]=S))),!n[p]){if(n[p]=!0,!L)throw new Error(`String representation missing for key code ${p} around scan code ${f}`);W.define(p,L),v.define(p,d||L),A.define(p,m||d||L)}I&&(t.EVENT_KEY_CODE_MAP[I]=p),y&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[y]=p)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function o(S){return W.keyCodeToStr(S)}e.toString=o;function n(S){return W.strToKeyCode(S)}e.fromString=n;function u(S){return v.keyCodeToStr(S)}e.toUserSettingsUS=u;function s(S){return A.keyCodeToStr(S)}e.toUserSettingsGeneral=s;function w(S){return v.strToKeyCode(S)||A.strToKeyCode(S)}e.fromUserSettings=w;function D(S){if(S>=93&&S<=108)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(S)}e.toElectronAccelerator=D})(P=t.KeyCodeUtils||(t.KeyCodeUtils={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r=t.KeyMod||(t.KeyMod={}));function l(e,o){const n=(o&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=l}),define(ge[74],me([1,0,7]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var M;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(M||(M={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const l=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new h([W(l,r),W(e,r)]):new h([W(l,r)])}else{const l=[];for(let e=0;e<P.length;e++)l.push(W(P[e],r));return new h(l)}}t.decodeKeybinding=i;function W(P,r){const l=!!(P&2048),e=!!(P&256),o=r===2?e:l,n=!!(P&1024),u=!!(P&512),s=r===2?l:e,w=P&255;return new v(o,n,u,s,w)}t.createSimpleKeybinding=W;class v{constructor(r,l,e,o,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.keyCode=n}equals(r){return r instanceof v&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`K${r}${l}${e}${o}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=v;class A{constructor(r,l,e,o,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.scanCode=n}equals(r){return r instanceof A&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`S${r}${l}${e}${o}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=A;class h{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.Keybinding=h;class a{constructor(r,l,e,o,n,u){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.keyLabel=n,this.keyAriaLabel=u}}t.ResolvedChord=a;class c{}t.ResolvedKeybinding=c}),define(ge[42],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=E}),define(ge[2],me([1,0,40,26]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function v(d){W=d}if(t.setDisposableTracker=v,i){const d="__is_disposable_tracked__";v(new class{trackDisposable(m){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[d]||console.log(b)},3e3)}setParent(m,b){if(m&&m!==s.None)try{m[d]=!0}catch{}}markAsDisposed(m){if(m&&m!==s.None)try{m[d]=!0}catch{}}markAsSingleton(m){}})}function A(d){return W?.trackDisposable(d),d}function h(d){W?.markAsDisposed(d)}function a(d,m){W?.setParent(d,m)}function c(d,m){if(!!W)for(const b of d)W.setParent(b,m)}function P(d){return W?.markAsSingleton(d),d}t.markAsSingleton=P;function r(d){return typeof d.dispose=="function"&&d.dispose.length===0}t.isDisposable=r;function l(d){if(M.Iterable.is(d)){const m=[];for(const b of d)if(b)try{b.dispose()}catch(O){m.push(O)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}t.dispose=l;function e(d){for(const m of d)r(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function o(...d){const m=n(()=>l(d));return c(d,m),m}t.combinedDisposable=o;function n(d){const m=A({dispose:(0,E.once)(()=>{h(m),d()})});return m}t.toDisposable=n;class u{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(h(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{l(this.c)}finally{this.c.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return a(m,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(m),m}}u.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=u;class s{constructor(){this.q=new u,A(this),a(this.q,this)}dispose(){h(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}s.None=Object.freeze({dispose(){}}),t.Disposable=s;class w{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&a(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&a(m,null),m}}t.MutableDisposable=w;class D{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=D;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(m){let b=m;return this.unset=()=>b=void 0,this.isset=()=>b!==void 0,this.dispose=()=>{b&&(b(),b=void 0,h(this))},this}}t.SafeDisposable=S;class f{constructor(){this.a=new Map}acquire(m,...b){let O=this.a.get(m);O||(O={counter:0,object:this.b(m,...b)},this.a.set(m,O));const{object:q}=O,Z=(0,E.once)(()=>{--O.counter===0&&(this.c(m,O.object),this.a.delete(m))});return O.counter++,{object:q,dispose:Z}}}t.ReferenceCollection=f;class p{constructor(m){this.a=m}async acquire(m,...b){const O=this.a.acquire(m,...b);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(q){throw O.dispose(),q}}}t.AsyncReferenceCollection=p;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function I(d){const m=new u;try{d(m)}finally{m.dispose()}}t.disposeOnReturn=I;class y{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,b,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(m)?.dispose(),this.a.set(m,b)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=y}),define(ge[43],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(W){this.element=W,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let W=this.a;for(;W!==E.Undefined;){const v=W.next;W.prev=E.Undefined,W.next=E.Undefined,W=v}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,v){const A=new E(W);if(this.a===E.Undefined)this.a=A,this.b=A;else if(v){const a=this.b;this.b=A,A.prev=a,a.next=A}else{const a=this.a;this.a=A,A.next=a,a.prev=A}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(A))}}shift(){if(this.a!==E.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==E.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==E.Undefined&&W.next!==E.Undefined){const v=W.prev;v.next=W.next,W.next.prev=v}else W.prev===E.Undefined&&W.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):W.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):W.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==E.Undefined;)yield W.element,W=W.next}}t.LinkedList=M}),define(ge[75],me([1,0]),function(ee,t){"use strict";var E,M,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(o,n,u){let s=o.get(n);return s===void 0&&(s=u,o.set(n,s)),s}t.getOrSet=W;function v(o){const n=[];return o.forEach((u,s)=>{n.push(`${s} => ${u}`)}),`Map(${o.size}) {${n.join(", ")}}`}t.mapToString=v;function A(o){const n=[];return o.forEach(u=>{n.push(u)}),`Set(${o.size}) {${n.join(", ")}}`}t.setToString=A;class h{constructor(n,u){this.uri=n,this.value=u}}class a{constructor(n,u){this[E]="ResourceMap",n instanceof a?(this.b=new Map(n.b),this.c=u??a.a):(this.b=new Map,this.c=n??a.a)}set(n,u){return this.b.set(this.c(n),new h(n,u)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,u){typeof u<"u"&&(n=n.bind(u));for(const[s,w]of this.b)n(w.value,w.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}a.a=o=>o.toString(),t.ResourceMap=a;class c{constructor(n,u){this[M]="ResourceSet",!n||typeof n=="function"?this.a=new a(n):(this.a=new a(u),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,u){this.a.forEach((s,w)=>n.call(u,w,w,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=c;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P=t.Touch||(t.Touch={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,u=0){const s=this.a.get(n);if(!!s)return u!==0&&this.j(s,u),s.value}set(n,u,s=0){let w=this.a.get(n);if(w)w.value=u,s!==0&&this.j(w,s);else{switch(w={key:n,value:u,next:void 0,previous:void 0},s){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(n,w),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this.a.get(n);if(!!u)return this.a.delete(n),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,u){const s=this.e;let w=this.b;for(;w;){if(u?n.bind(u)(w.value,w.key,this):n(w.value,w.key,this),this.e!==s)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.key,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}values(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.value,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}entries(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:[s.key,s.value],done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this.b,s=this.size;for(;u&&s>n;)this.a.delete(u.key),u=u.next,s--;this.b=u,this.d=s,u&&(u.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const u=n.next,s=n.previous;if(!u||!s)throw new Error("Invalid list");u.previous=s,s.next=u}n.next=void 0,n.previous=void 0,this.e++}j(n,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this.b)return;const s=n.next,w=n.previous;n===this.c?(w.next=void 0,this.c=w):(s.previous=w,w.next=s),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(u===2){if(n===this.c)return;const s=n.next,w=n.previous;n===this.b?(s.previous=void 0,this.b=s):(s.previous=w,w.next=s),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((u,s)=>{n.push([s,u])}),n}fromJSON(n){this.clear();for(const[u,s]of n)this.set(u,s)}}t.LinkedMap=r;class l extends r{constructor(n,u=1){super(),this.k=n,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=l;class e{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let u=this.a.get(n)||0;return u===0?!1:(u--,u===0?this.a.delete(n):this.a.set(n,u),!0)}has(n){return this.a.has(n)}}t.CounterSet=e}),function(ee,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(ge[76],me([0]),t):(ee=typeof globalThis<"u"?globalThis:ee||self,t(ee.marked={}))}(this,function(ee){"use strict";function t(F,N){for(var B=0;B<N.length;B++){var k=N[B];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(F,k.key,k)}}function E(F,N,B){return N&&t(F.prototype,N),B&&t(F,B),Object.defineProperty(F,"prototype",{writable:!1}),F}function M(F,N){if(!!F){if(typeof F=="string")return i(F,N);var B=Object.prototype.toString.call(F).slice(8,-1);if(B==="Object"&&F.constructor&&(B=F.constructor.name),B==="Map"||B==="Set")return Array.from(F);if(B==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(B))return i(F,N)}}function i(F,N){(N==null||N>F.length)&&(N=F.length);for(var B=0,k=new Array(N);B<N;B++)k[B]=F[B];return k}function W(F,N){var B=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(B)return(B=B.call(F)).next.bind(B);if(Array.isArray(F)||(B=M(F))||N&&F&&typeof F.length=="number"){B&&(F=B);var k=0;return function(){return k>=F.length?{done:!0}:{done:!1,value:F[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function v(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=v();function A(F){ee.defaults=F}var h=/[&<>"']/,a=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(N){return r[N]};function e(F,N){if(N){if(h.test(F))return F.replace(a,l)}else if(c.test(F))return F.replace(P,l);return F}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(F){return F.replace(o,function(N,B){return B=B.toLowerCase(),B==="colon"?":":B.charAt(0)==="#"?B.charAt(1)==="x"?String.fromCharCode(parseInt(B.substring(2),16)):String.fromCharCode(+B.substring(1)):""})}var u=/(^|[^\[])\^/g;function s(F,N){F=typeof F=="string"?F:F.source,N=N||"";var B={replace:function(H,z){return z=z.source||z,z=z.replace(u,"$1"),F=F.replace(H,z),B},getRegex:function(){return new RegExp(F,N)}};return B}var w=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(F,N,B){if(F){var k;try{k=decodeURIComponent(n(B)).replace(w,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}N&&!D.test(B)&&(B=y(N,B));try{B=encodeURI(B).replace(/%25/g,"%")}catch{return null}return B}var f={},p=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(F,N){f[" "+F]||(p.test(F)?f[" "+F]=F+"/":f[" "+F]=O(F,"/",!0)),F=f[" "+F];var B=F.indexOf(":")===-1;return N.substring(0,2)==="//"?B?N:F.replace(L,"$1")+N:N.charAt(0)==="/"?B?N:F.replace(I,"$1")+N:F+N}var d={exec:function(){}};function m(F){for(var N=1,B,k;N<arguments.length;N++){B=arguments[N];for(k in B)Object.prototype.hasOwnProperty.call(B,k)&&(F[k]=B[k])}return F}function b(F,N){var B=F.replace(/\|/g,function(z,U,j){for(var G=!1,re=U;--re>=0&&j[re]==="\\";)G=!G;return G?"|":" |"}),k=B.split(/ \|/),H=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>N)k.splice(N);else for(;k.length<N;)k.push("");for(;H<k.length;H++)k[H]=k[H].trim().replace(/\\\|/g,"|");return k}function O(F,N,B){var k=F.length;if(k===0)return"";for(var H=0;H<k;){var z=F.charAt(k-H-1);if(z===N&&!B)H++;else if(z!==N&&B)H++;else break}return F.slice(0,k-H)}function q(F,N){if(F.indexOf(N[1])===-1)return-1;for(var B=F.length,k=0,H=0;H<B;H++)if(F[H]==="\\")H++;else if(F[H]===N[0])k++;else if(F[H]===N[1]&&(k--,k<0))return H;return-1}function Z(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function se(F,N){if(N<1)return"";for(var B="";N>1;)N&1&&(B+=F),N>>=1,F+=F;return B+F}function ae(F,N,B,k){var H=N.href,z=N.title?e(N.title):null,U=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){k.state.inLink=!0;var j={type:"link",raw:B,href:H,title:z,text:U,tokens:k.inlineTokens(U)};return k.state.inLink=!1,j}return{type:"image",raw:B,href:H,title:z,text:e(U)}}function fe(F,N){var B=F.match(/^(\s+)(?:```)/);if(B===null)return N;var k=B[1];return N.split(`
`).map(function(H){var z=H.match(/^\s+/);if(z===null)return H;var U=z[0];return U.length>=k.length?H.slice(k.length):H}).join(`
`)}var ue=function(){function F(B){this.options=B||ee.defaults}var N=F.prototype;return N.space=function(k){var H=this.rules.block.newline.exec(k);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},N.code=function(k){var H=this.rules.block.code.exec(k);if(H){var z=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?z:O(z,`
`)}}},N.fences=function(k){var H=this.rules.block.fences.exec(k);if(H){var z=H[0],U=fe(z,H[3]||"");return{type:"code",raw:z,lang:H[2]?H[2].trim():H[2],text:U}}},N.heading=function(k){var H=this.rules.block.heading.exec(k);if(H){var z=H[2].trim();if(/#$/.test(z)){var U=O(z,"#");(this.options.pedantic||!U||/ $/.test(U))&&(z=U.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:z,tokens:this.lexer.inline(z)}}},N.hr=function(k){var H=this.rules.block.hr.exec(k);if(H)return{type:"hr",raw:H[0]}},N.blockquote=function(k){var H=this.rules.block.blockquote.exec(k);if(H){var z=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(z,[]),text:z}}},N.list=function(k){var H=this.rules.block.list.exec(k);if(H){var z,U,j,G,re,he,De,ye,Le,Ce,we,Pe,Ie=H[1].trim(),Ve=Ie.length>1,He={type:"list",raw:"",ordered:Ve,start:Ve?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=Ve?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=Ve?Ie:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Pe=!1,!(!(H=Ue.exec(k))||this.rules.block.hr.test(k)));){if(z=H[0],k=k.substring(z.length),ye=H[2].split(`
`,1)[0],Le=k.split(`
`,1)[0],this.options.pedantic?(G=2,we=ye.trimLeft()):(G=H[2].search(/[^ ]/),G=G>4?1:G,we=ye.slice(G),G+=H[1].length),he=!1,!ye&&/^ *$/.test(Le)&&(z+=Le+`
`,k=k.substring(Le.length+1),Pe=!0),!Pe)for(var Ze=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ge=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),V=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");k&&(Ce=k.split(`
`,1)[0],ye=Ce,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(ye)||V.test(ye)||Ze.test(ye)||Ge.test(k)));){if(ye.search(/[^ ]/)>=G||!ye.trim())we+=`
`+ye.slice(G);else if(!he)we+=`
`+ye;else break;!he&&!ye.trim()&&(he=!0),z+=Ce+`
`,k=k.substring(Ce.length+1)}He.loose||(De?He.loose=!0:/\n *\n *$/.test(z)&&(De=!0)),this.options.gfm&&(U=/^\[[ xX]\] /.exec(we),U&&(j=U[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:z,task:!!U,checked:j,loose:!1,text:we}),He.raw+=z}He.items[He.items.length-1].raw=z.trimRight(),He.items[He.items.length-1].text=we.trimRight(),He.raw=He.raw.trimRight();var oe=He.items.length;for(re=0;re<oe;re++){this.lexer.state.top=!1,He.items[re].tokens=this.lexer.blockTokens(He.items[re].text,[]);var be=He.items[re].tokens.filter(function(Se){return Se.type==="space"}),Ee=be.every(function(Se){for(var Oe=Se.raw.split(""),We=0,tt=W(Oe),Ke;!(Ke=tt()).done;){var _e=Ke.value;if(_e===`
`&&(We+=1),We>1)return!0}return!1});!He.loose&&be.length&&Ee&&(He.loose=!0,He.items[re].loose=!0)}return He}},N.html=function(k){var H=this.rules.block.html.exec(k);if(H){var z={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var U=this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]);z.type="paragraph",z.text=U,z.tokens=this.lexer.inline(U)}return z}},N.def=function(k){var H=this.rules.block.def.exec(k);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var z=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:z,raw:H[0],href:H[2],title:H[3]}}},N.table=function(k){var H=this.rules.block.table.exec(k);if(H){var z={type:"table",header:b(H[1]).map(function(De){return{text:De}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=H[0];var U=z.align.length,j,G,re,he;for(j=0;j<U;j++)/^ *-+: *$/.test(z.align[j])?z.align[j]="right":/^ *:-+: *$/.test(z.align[j])?z.align[j]="center":/^ *:-+ *$/.test(z.align[j])?z.align[j]="left":z.align[j]=null;for(U=z.rows.length,j=0;j<U;j++)z.rows[j]=b(z.rows[j],z.header.length).map(function(De){return{text:De}});for(U=z.header.length,G=0;G<U;G++)z.header[G].tokens=this.lexer.inline(z.header[G].text);for(U=z.rows.length,G=0;G<U;G++)for(he=z.rows[G],re=0;re<he.length;re++)he[re].tokens=this.lexer.inline(he[re].text);return z}}},N.lheading=function(k){var H=this.rules.block.lheading.exec(k);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},N.paragraph=function(k){var H=this.rules.block.paragraph.exec(k);if(H){var z=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:z,tokens:this.lexer.inline(z)}}},N.text=function(k){var H=this.rules.block.text.exec(k);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},N.escape=function(k){var H=this.rules.inline.escape.exec(k);if(H)return{type:"escape",raw:H[0],text:e(H[1])}},N.tag=function(k){var H=this.rules.inline.tag.exec(k);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]}},N.link=function(k){var H=this.rules.inline.link.exec(k);if(H){var z=H[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var U=O(z.slice(0,-1),"\\");if((z.length-U.length)%2===0)return}else{var j=q(H[2],"()");if(j>-1){var G=H[0].indexOf("!")===0?5:4,re=G+H[1].length+j;H[2]=H[2].substring(0,j),H[0]=H[0].substring(0,re).trim(),H[3]=""}}var he=H[2],De="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);ye&&(he=ye[1],De=ye[3])}else De=H[3]?H[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(z)?he=he.slice(1):he=he.slice(1,-1)),ae(H,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},N.reflink=function(k,H){var z;if((z=this.rules.inline.reflink.exec(k))||(z=this.rules.inline.nolink.exec(k))){var U=(z[2]||z[1]).replace(/\s+/g," ");if(U=H[U.toLowerCase()],!U||!U.href){var j=z[0].charAt(0);return{type:"text",raw:j,text:j}}return ae(z,U,z[0],this.lexer)}},N.emStrong=function(k,H,z){z===void 0&&(z="");var U=this.rules.inline.emStrong.lDelim.exec(k);if(!!U&&!(U[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=U[1]||U[2]||"";if(!j||j&&(z===""||this.rules.inline.punctuation.exec(z))){var G=U[0].length-1,re,he,De=G,ye=0,Le=U[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,H=H.slice(-1*k.length+G);(U=Le.exec(H))!=null;)if(re=U[1]||U[2]||U[3]||U[4]||U[5]||U[6],!!re){if(he=re.length,U[3]||U[4]){De+=he;continue}else if((U[5]||U[6])&&G%3&&!((G+he)%3)){ye+=he;continue}if(De-=he,!(De>0)){if(he=Math.min(he,he+De+ye),Math.min(G,he)%2){var Ce=k.slice(1,G+U.index+he);return{type:"em",raw:k.slice(0,G+U.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var we=k.slice(2,G+U.index+he-1);return{type:"strong",raw:k.slice(0,G+U.index+he+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},N.codespan=function(k){var H=this.rules.inline.code.exec(k);if(H){var z=H[2].replace(/\n/g," "),U=/[^ ]/.test(z),j=/^ /.test(z)&&/ $/.test(z);return U&&j&&(z=z.substring(1,z.length-1)),z=e(z,!0),{type:"codespan",raw:H[0],text:z}}},N.br=function(k){var H=this.rules.inline.br.exec(k);if(H)return{type:"br",raw:H[0]}},N.del=function(k){var H=this.rules.inline.del.exec(k);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},N.autolink=function(k,H){var z=this.rules.inline.autolink.exec(k);if(z){var U,j;return z[2]==="@"?(U=e(this.options.mangle?H(z[1]):z[1]),j="mailto:"+U):(U=e(z[1]),j=U),{type:"link",raw:z[0],text:U,href:j,tokens:[{type:"text",raw:U,text:U}]}}},N.url=function(k,H){var z;if(z=this.rules.inline.url.exec(k)){var U,j;if(z[2]==="@")U=e(this.options.mangle?H(z[0]):z[0]),j="mailto:"+U;else{var G;do G=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(G!==z[0]);U=e(z[0]),z[1]==="www."?j="http://"+U:j=U}return{type:"link",raw:z[0],text:U,href:j,tokens:[{type:"text",raw:U,text:U}]}}},N.inlineText=function(k,H){var z=this.rules.inline.text.exec(k);if(z){var U;return this.lexer.state.inRawBlock?U=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]:U=e(this.options.smartypants?H(z[0]):z[0]),{type:"text",raw:z[0],text:U}}},F}(),Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=s(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=s(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=s(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=s(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=s(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=s(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=m({},Q),Q.gfm=m({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=s(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.gfm.paragraph=s(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=m({},Q.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:s(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=s(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=s(Q._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=s(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=s(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=s(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=s(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=s(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=s(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=s(J.reflink).replace("label",J._label).replace("ref",Q._label).getRegex(),J.nolink=s(J.nolink).replace("ref",Q._label).getRegex(),J.reflinkSearch=s(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=m({},J),J.pedantic=m({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=m({},J.normal,{escape:s(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=s(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=m({},J.gfm,{br:s(J.br).replace("{2,}","*").getRegex(),text:s(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ve(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function pe(F){var N="",B,k,H=F.length;for(B=0;B<H;B++)k=F.charCodeAt(B),Math.random()>.5&&(k="x"+k.toString(16)),N+="&#"+k+";";return N}var Me=function(){function F(B){this.tokens=[],this.tokens.links=Object.create(null),this.options=B||ee.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:Q.normal,inline:J.normal};this.options.pedantic?(k.block=Q.pedantic,k.inline=J.pedantic):this.options.gfm&&(k.block=Q.gfm,this.options.breaks?k.inline=J.breaks:k.inline=J.gfm),this.tokenizer.rules=k}F.lex=function(k,H){var z=new F(H);return z.lex(k)},F.lexInline=function(k,H){var z=new F(H);return z.inlineTokens(k)};var N=F.prototype;return N.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},N.blockTokens=function(k,H){var z=this;H===void 0&&(H=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(De,ye,Le){return ye+"    ".repeat(Le.length)});for(var U,j,G,re;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(U=De.call({lexer:z},k,H))?(k=k.substring(U.raw.length),H.push(U),!0):!1}))){if(U=this.tokenizer.space(k)){k=k.substring(U.raw.length),U.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(U);continue}if(U=this.tokenizer.code(k)){k=k.substring(U.raw.length),j=H[H.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+U.raw,j.text+=`
`+U.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):H.push(U);continue}if(U=this.tokenizer.fences(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.heading(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.hr(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.blockquote(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.list(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.html(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.def(k)){k=k.substring(U.raw.length),j=H[H.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+U.raw,j.text+=`
`+U.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[U.tag]||(this.tokens.links[U.tag]={href:U.href,title:U.title});continue}if(U=this.tokenizer.table(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.lheading(k)){k=k.substring(U.raw.length),H.push(U);continue}if(G=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,ye=k.slice(1),Le=void 0;z.options.extensions.startBlock.forEach(function(Ce){Le=Ce.call({lexer:this},ye),typeof Le=="number"&&Le>=0&&(De=Math.min(De,Le))}),De<1/0&&De>=0&&(G=k.substring(0,De+1))}(),this.state.top&&(U=this.tokenizer.paragraph(G))){j=H[H.length-1],re&&j.type==="paragraph"?(j.raw+=`
`+U.raw,j.text+=`
`+U.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):H.push(U),re=G.length!==k.length,k=k.substring(U.raw.length);continue}if(U=this.tokenizer.text(k)){k=k.substring(U.raw.length),j=H[H.length-1],j&&j.type==="text"?(j.raw+=`
`+U.raw,j.text+=`
`+U.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):H.push(U);continue}if(k){var he="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,H},N.inline=function(k,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:k,tokens:H}),H},N.inlineTokens=function(k,H){var z=this;H===void 0&&(H=[]);var U,j,G,re=k,he,De,ye;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(re))!=null;)Le.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(re=re.slice(0,he.index)+"["+se("a",he[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(re))!=null;)re=re.slice(0,he.index)+"["+se("a",he[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(re))!=null;)re=re.slice(0,he.index)+"++"+re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(De||(ye=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(U=we.call({lexer:z},k,H))?(k=k.substring(U.raw.length),H.push(U),!0):!1}))){if(U=this.tokenizer.escape(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.tag(k)){k=k.substring(U.raw.length),j=H[H.length-1],j&&U.type==="text"&&j.type==="text"?(j.raw+=U.raw,j.text+=U.text):H.push(U);continue}if(U=this.tokenizer.link(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(U.raw.length),j=H[H.length-1],j&&U.type==="text"&&j.type==="text"?(j.raw+=U.raw,j.text+=U.text):H.push(U);continue}if(U=this.tokenizer.emStrong(k,re,ye)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.codespan(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.br(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.del(k)){k=k.substring(U.raw.length),H.push(U);continue}if(U=this.tokenizer.autolink(k,pe)){k=k.substring(U.raw.length),H.push(U);continue}if(!this.state.inLink&&(U=this.tokenizer.url(k,pe))){k=k.substring(U.raw.length),H.push(U);continue}if(G=k,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Pe=k.slice(1),Ie=void 0;z.options.extensions.startInline.forEach(function(Ve){Ie=Ve.call({lexer:this},Pe),typeof Ie=="number"&&Ie>=0&&(we=Math.min(we,Ie))}),we<1/0&&we>=0&&(G=k.substring(0,we+1))}(),U=this.tokenizer.inlineText(G,ve)){k=k.substring(U.raw.length),U.raw.slice(-1)!=="_"&&(ye=U.raw.slice(-1)),De=!0,j=H[H.length-1],j&&j.type==="text"?(j.raw+=U.raw,j.text+=U.text):H.push(U);continue}if(k){var Ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return H},E(F,null,[{key:"rules",get:function(){return{block:Q,inline:J}}}]),F}(),Re=function(){function F(B){this.options=B||ee.defaults}var N=F.prototype;return N.code=function(k,H,z){var U=(H||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(k,U);j!=null&&j!==k&&(z=!0,k=j)}return k=k.replace(/\n$/,"")+`
`,U?'<pre><code class="'+this.options.langPrefix+e(U,!0)+'">'+(z?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(z?k:e(k,!0))+`</code></pre>
`},N.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},N.html=function(k){return k},N.heading=function(k,H,z,U){if(this.options.headerIds){var j=this.options.headerPrefix+U.slug(z);return"<h"+H+' id="'+j+'">'+k+"</h"+H+`>
`}return"<h"+H+">"+k+"</h"+H+`>
`},N.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},N.list=function(k,H,z){var U=H?"ol":"ul",j=H&&z!==1?' start="'+z+'"':"";return"<"+U+j+`>
`+k+"</"+U+`>
`},N.listitem=function(k){return"<li>"+k+`</li>
`},N.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},N.paragraph=function(k){return"<p>"+k+`</p>
`},N.table=function(k,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+H+`</table>
`},N.tablerow=function(k){return`<tr>
`+k+`</tr>
`},N.tablecell=function(k,H){var z=H.header?"th":"td",U=H.align?"<"+z+' align="'+H.align+'">':"<"+z+">";return U+k+("</"+z+`>
`)},N.strong=function(k){return"<strong>"+k+"</strong>"},N.em=function(k){return"<em>"+k+"</em>"},N.codespan=function(k){return"<code>"+k+"</code>"},N.br=function(){return this.options.xhtml?"<br/>":"<br>"},N.del=function(k){return"<del>"+k+"</del>"},N.link=function(k,H,z){if(k=S(this.options.sanitize,this.options.baseUrl,k),k===null)return z;var U='<a href="'+e(k)+'"';return H&&(U+=' title="'+H+'"'),U+=">"+z+"</a>",U},N.image=function(k,H,z){if(k=S(this.options.sanitize,this.options.baseUrl,k),k===null)return z;var U='<img src="'+k+'" alt="'+z+'"';return H&&(U+=' title="'+H+'"'),U+=this.options.xhtml?"/>":">",U},N.text=function(k){return k},F}(),le=function(){function F(){}var N=F.prototype;return N.strong=function(k){return k},N.em=function(k){return k},N.codespan=function(k){return k},N.del=function(k){return k},N.html=function(k){return k},N.text=function(k){return k},N.link=function(k,H,z){return""+z},N.image=function(k,H,z){return""+z},N.br=function(){return""},F}(),x=function(){function F(){this.seen={}}var N=F.prototype;return N.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},N.getNextSafeSlug=function(k,H){var z=k,U=0;if(this.seen.hasOwnProperty(z)){U=this.seen[k];do U++,z=k+"-"+U;while(this.seen.hasOwnProperty(z))}return H||(this.seen[k]=U,this.seen[z]=0),z},N.slug=function(k,H){H===void 0&&(H={});var z=this.serialize(k);return this.getNextSafeSlug(z,H.dryrun)},F}(),ne=function(){function F(B){this.options=B||ee.defaults,this.options.renderer=this.options.renderer||new Re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new x}F.parse=function(k,H){var z=new F(H);return z.parse(k)},F.parseInline=function(k,H){var z=new F(H);return z.parseInline(k)};var N=F.prototype;return N.parse=function(k,H){H===void 0&&(H=!0);var z="",U,j,G,re,he,De,ye,Le,Ce,we,Pe,Ie,Ve,He,Ue,Ze,Ge,Be,V,oe=k.length;for(U=0;U<oe;U++){if(we=k[U],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(V=this.options.extensions.renderers[we.type].call({parser:this},we),V!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){z+=V||"";continue}switch(we.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(we.tokens),we.depth,n(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(Le="",ye="",re=we.header.length,j=0;j<re;j++)ye+=this.renderer.tablecell(this.parseInline(we.header[j].tokens),{header:!0,align:we.align[j]});for(Le+=this.renderer.tablerow(ye),Ce="",re=we.rows.length,j=0;j<re;j++){for(De=we.rows[j],ye="",he=De.length,G=0;G<he;G++)ye+=this.renderer.tablecell(this.parseInline(De[G].tokens),{header:!1,align:we.align[G]});Ce+=this.renderer.tablerow(ye)}z+=this.renderer.table(Le,Ce);continue}case"blockquote":{Ce=this.parse(we.tokens),z+=this.renderer.blockquote(Ce);continue}case"list":{for(Pe=we.ordered,Ie=we.start,Ve=we.loose,re=we.items.length,Ce="",j=0;j<re;j++)Ue=we.items[j],Ze=Ue.checked,Ge=Ue.task,He="",Ue.task&&(Be=this.renderer.checkbox(Ze),Ve?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Be+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Be+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Be}):He+=Be),He+=this.parse(Ue.tokens,Ve),Ce+=this.renderer.listitem(He,Ge,Ze);z+=this.renderer.list(Ce,Pe,Ie);continue}case"html":{z+=this.renderer.html(we.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Ce=we.tokens?this.parseInline(we.tokens):we.text;U+1<oe&&k[U+1].type==="text";)we=k[++U],Ce+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);z+=H?this.renderer.paragraph(Ce):Ce;continue}default:{var be='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return z},N.parseInline=function(k,H){H=H||this.renderer;var z="",U,j,G,re=k.length;for(U=0;U<re;U++){if(j=k[U],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(G=this.options.extensions.renderers[j.type].call({parser:this},j),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){z+=G||"";continue}switch(j.type){case"escape":{z+=H.text(j.text);break}case"html":{z+=H.html(j.text);break}case"link":{z+=H.link(j.href,j.title,this.parseInline(j.tokens,H));break}case"image":{z+=H.image(j.href,j.title,j.text);break}case"strong":{z+=H.strong(this.parseInline(j.tokens,H));break}case"em":{z+=H.em(this.parseInline(j.tokens,H));break}case"codespan":{z+=H.codespan(j.text);break}case"br":{z+=H.br();break}case"del":{z+=H.del(this.parseInline(j.tokens,H));break}case"text":{z+=H.text(j.text);break}default:{var he='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return z},F}();function te(F,N,B){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof N=="function"&&(B=N,N=null),N=m({},te.defaults,N||{}),Z(N),B){var k=N.highlight,H;try{H=Me.lex(F,N)}catch(re){return B(re)}var z=function(he){var De;if(!he)try{N.walkTokens&&te.walkTokens(H,N.walkTokens),De=ne.parse(H,N)}catch(ye){he=ye}return N.highlight=k,he?B(he):B(null,De)};if(!k||k.length<3||(delete N.highlight,!H.length))return z();var U=0;te.walkTokens(H,function(re){re.type==="code"&&(U++,setTimeout(function(){k(re.text,re.lang,function(he,De){if(he)return z(he);De!=null&&De!==re.text&&(re.text=De,re.escaped=!0),U--,U===0&&z()})},0))}),U===0&&z();return}function j(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,N.silent)return"<p>An error occurred:</p><pre>"+e(re.message+"",!0)+"</pre>";throw re}try{var G=Me.lex(F,N);if(N.walkTokens){if(N.async)return Promise.all(te.walkTokens(G,N.walkTokens)).then(function(){return ne.parse(G,N)}).catch(j);te.walkTokens(G,N.walkTokens)}return ne.parse(G,N)}catch(re){j(re)}}te.options=te.setOptions=function(F){return m(te.defaults,F),A(te.defaults),te},te.getDefaults=v,te.defaults=ee.defaults,te.use=function(){for(var F=arguments.length,N=new Array(F),B=0;B<F;B++)N[B]=arguments[B];var k=m.apply(void 0,[{}].concat(N)),H=te.defaults.extensions||{renderers:{},childTokens:{}},z;N.forEach(function(U){if(U.extensions&&(z=!0,U.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var re=H.renderers?H.renderers[G.name]:null;re?H.renderers[G.name]=function(){for(var he=arguments.length,De=new Array(he),ye=0;ye<he;ye++)De[ye]=arguments[ye];var Le=G.renderer.apply(this,De);return Le===!1&&(Le=re.apply(this,De)),Le}:H.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[G.level]?H[G.level].unshift(G.tokenizer):H[G.level]=[G.tokenizer],G.start&&(G.level==="block"?H.startBlock?H.startBlock.push(G.start):H.startBlock=[G.start]:G.level==="inline"&&(H.startInline?H.startInline.push(G.start):H.startInline=[G.start]))}G.childTokens&&(H.childTokens[G.name]=G.childTokens)})),U.renderer&&function(){var G=te.defaults.renderer||new Re,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,we=new Array(Ce),Pe=0;Pe<Ce;Pe++)we[Pe]=arguments[Pe];var Ie=U.renderer[ye].apply(G,we);return Ie===!1&&(Ie=Le.apply(G,we)),Ie}};for(var he in U.renderer)re(he);k.renderer=G}(),U.tokenizer&&function(){var G=te.defaults.tokenizer||new ue,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,we=new Array(Ce),Pe=0;Pe<Ce;Pe++)we[Pe]=arguments[Pe];var Ie=U.tokenizer[ye].apply(G,we);return Ie===!1&&(Ie=Le.apply(G,we)),Ie}};for(var he in U.tokenizer)re(he);k.tokenizer=G}(),U.walkTokens){var j=te.defaults.walkTokens;k.walkTokens=function(G){var re=[];return re.push(U.walkTokens.call(this,G)),j&&(re=re.concat(j.call(this,G))),re}}z&&(k.extensions=H),te.setOptions(k)})},te.walkTokens=function(F,N){for(var B=[],k=function(){var j=z.value;switch(B=B.concat(N.call(te,j)),j.type){case"table":{for(var G=W(j.header),re;!(re=G()).done;){var he=re.value;B=B.concat(te.walkTokens(he.tokens,N))}for(var De=W(j.rows),ye;!(ye=De()).done;)for(var Le=ye.value,Ce=W(Le),we;!(we=Ce()).done;){var Pe=we.value;B=B.concat(te.walkTokens(Pe.tokens,N))}break}case"list":{B=B.concat(te.walkTokens(j.items,N));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[j.type]?te.defaults.extensions.childTokens[j.type].forEach(function(Ie){B=B.concat(te.walkTokens(j[Ie],N))}):j.tokens&&(B=B.concat(te.walkTokens(j.tokens,N)))}},H=W(F),z;!(z=H()).done;)k();return B},te.parseInline=function(F,N){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");N=m({},te.defaults,N||{}),Z(N);try{var B=Me.lexInline(F,N);return N.walkTokens&&te.walkTokens(B,N.walkTokens),ne.parseInline(B,N)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,N.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},te.Parser=ne,te.parser=ne.parse,te.Renderer=Re,te.TextRenderer=le,te.Lexer=Me,te.lexer=Me.lex,te.Tokenizer=ue,te.Slugger=x,te.parse=te;var ie=te.options,T=te.setOptions,_=te.use,R=te.walkTokens,g=te.parseInline,C=te,$=ne.parse,Y=Me.lex;ee.Lexer=Me,ee.Parser=ne,ee.Renderer=Re,ee.Slugger=x,ee.TextRenderer=le,ee.Tokenizer=ue,ee.getDefaults=v,ee.lexer=Y,ee.marked=te,ee.options=ie,ee.parse=C,ee.parseInline=g,ee.parser=$,ee.setOptions=T,ee.use=_,ee.walkTokens=R,Object.defineProperty(ee,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,W=0,v=i.length,A=W-1){this.a=i,this.b=W,this.c=v,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class M{constructor(v=[],A=10){this.h(v),this.b=A,this.d()}getHistory(){return this.j}add(v){this.a.delete(v),this.a.add(v),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()===this.j.length-1}isNowhere(){return this.c.current()===null}has(v){return this.a.has(v)}clear(){this.h([]),this.d()}d(){this.f();const v=this.j;this.c=new E.ArrayNavigator(v,0,v.length,v.length)}f(){const v=this.j;v.length>this.b&&this.h(v.slice(v.length-this.b))}g(){const v=this.c.current();return v?this.j.indexOf(v):-1}h(v){this.a=new Set;for(const A of v)this.a.add(A)}get j(){const v=[];return this.a.forEach(A=>v.push(A)),v}}t.HistoryNavigator=M;class i{constructor(v,A=10){if(this.f=A,v.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:v[0],previous:void 0,next:void 0};for(let h=1;h<v.length;h++)this.add(v[h])}add(v){const A={value:v,previous:this.b,next:void 0};for(this.b.next=A,this.b=A,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(v){const A=this.b.value;return this.b.value=v,A}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(v){let A=this.a;for(;A;){if(A.value===v)return!0;A=A.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let v=this.a;for(;v;)yield v.value,v=v.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(A,h,a){return Math.min(Math.max(A,h),a)}t.clamp=E;function M(A,h){return(h+A%h)%h}t.rot=M;class i{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=i;class W{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=W;class v{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const a=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=v}),define(ge[45],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(M){function i(h,a){if(h.start>=a.end||a.start>=h.end)return{start:0,end:0};const c=Math.max(h.start,a.start),P=Math.min(h.end,a.end);return P-c<=0?{start:0,end:0}:{start:c,end:P}}M.intersect=i;function W(h){return h.end-h.start<=0}M.isEmpty=W;function v(h,a){return!W(i(h,a))}M.intersects=v;function A(h,a){const c=[],P={start:h.start,end:Math.min(a.start,h.end)},r={start:Math.max(a.end,h.start),end:h.end};return W(P)||c.push(P),W(r)||c.push(r),c}M.relativeComplement=A})(E=t.Range||(t.Range={}))}),define(ge[79],me([1,0,45]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function M(h,a){const c=[];for(const P of a){if(h.start>=P.range.end)continue;if(h.end<P.range.start)break;const r=E.Range.intersect(h,P.range);E.Range.isEmpty(r)||c.push({range:r,size:P.size})}return c}t.groupIntersect=M;function i({start:h,end:a},c){return{start:h+c,end:a+c}}t.shift=i;function W(h){const a=[];let c=null;for(const P of h){const r=P.range.start,l=P.range.end,e=P.size;if(c&&e===c.size){c.range.end=l;continue}c={range:{start:r,end:l},size:e},a.push(c)}return a}t.consolidate=W;function v(...h){return W(h.reduce((a,c)=>a.concat(c),[]))}class A{constructor(){this.a=[],this.b=0}splice(a,c,P=[]){const r=P.length-c,l=M({start:0,end:a},this.a),e=M({start:a+c,end:Number.POSITIVE_INFINITY},this.a).map(n=>({range:i(n.range,r),size:n.size})),o=P.map((n,u)=>({range:{start:a+u,end:a+u+1},size:n.size}));this.a=v(l,o,e),this.b=this.a.reduce((n,u)=>n+u.size*(u.range.end-u.range.start),0)}get count(){const a=this.a.length;return a?this.a[a-1].range.end:0}get size(){return this.b}indexAt(a){if(a<0)return-1;let c=0,P=0;for(const r of this.a){const l=r.range.end-r.range.start,e=P+l*r.size;if(a<e)return c+Math.floor((a-P)/r.size);c+=l,P=e}return c}indexAfter(a){return Math.min(this.indexAt(a)+1,this.count)}positionAt(a){if(a<0)return-1;let c=0,P=0;for(const r of this.a){const l=r.range.end-r.range.start,e=P+l;if(a<e)return c+(a-P)*r.size;c+=l*r.size,P=e}return-1}}t.RangeMap=A}),define(ge[80],me([1,0,7,2]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(D){const S=D;return S?typeof S.read=="function":!1}t.isReadable=i;function W(D){const S=D;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=W;function v(D){const S=D;return S?W(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=v;function A(D,S){return new h(D,S)}t.newWriteableStream=A;class h{constructor(S,f){this.e=S,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(f=>f(S))}h(S){this.c.error.length===0?(0,E.onUnexpectedError)(S):this.c.error.slice(0).forEach(f=>f(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,f){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(S,f){if(this.a.destroyed)return;let p;switch(S){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const L=p.indexOf(f);L>=0&&p.splice(L,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(D,S){const f=[];let p;for(;(p=D.read())!==null;)f.push(p);return S(f)}t.consumeReadable=a;function c(D,S,f){const p=[];let L;for(;(L=D.read())!==null&&p.length<f;)p.push(L);return L===null&&p.length>0?S(p):{read:()=>{if(p.length>0)return p.shift();if(typeof L<"u"){const I=L;return L=void 0,I}return D.read()}}}t.peekReadable=c;function P(D,S){return new Promise((f,p)=>{const L=[];r(D,{onData:I=>{S&&L.push(I)},onError:I=>{S?p(I):f(void 0)},onEnd:()=>{f(S?S(L):void 0)}})})}t.consumeStream=P;function r(D,S){let f=!1;return D.on("error",p=>{f||S.onError(p)}),D.on("end",()=>{f||S.onEnd()}),D.on("data",p=>{f||S.onData(p)}),(0,M.toDisposable)(()=>f=!0)}t.listenStream=r;function l(D,S){return new Promise((f,p)=>{const L=new M.DisposableStore,I=[],y=b=>{if(I.push(b),I.length>S)return L.dispose(),D.pause(),f({stream:D,buffer:I,ended:!1})},d=b=>p(b),m=()=>f({stream:D,buffer:I,ended:!0});L.add((0,M.toDisposable)(()=>D.removeListener("error",d))),D.on("error",d),L.add((0,M.toDisposable)(()=>D.removeListener("end",m))),D.on("end",m),L.add((0,M.toDisposable)(()=>D.removeListener("data",y))),D.on("data",y)})}t.peekStream=l;function e(D,S){const f=A(S);return f.end(D),f}t.toStream=e;function o(){const D=A(()=>{throw new Error("not supported")});return D.end(),D}t.emptyStream=o;function n(D){let S=!1;return{read:()=>S?null:(S=!0,D)}}t.toReadable=n;function u(D,S,f){const p=A(f);return r(D,{onData:L=>p.write(S.data(L)),onError:L=>p.error(S.error?S.error(L):L),onEnd:()=>p.end()}),p}t.transform=u;function s(D,S,f){let p=!1;return{read:()=>{const L=S.read();return p?L:(p=!0,L!==null?f([D,L]):D)}}}t.prefixedReadable=s;function w(D,S,f){let p=!1;const L=A(f);return r(S,{onData:I=>p?L.write(I):(p=!0,L.write(f([D,I]))),onError:I=>L.error(I),onEnd:()=>{p||(p=!0,L.write(D)),L.end()}}),L}t.prefixedStream=w}),define(ge[30],me([1,0,80]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const M=typeof Buffer<"u";let i,W;class v{static alloc(b){return M?new v(Buffer.allocUnsafe(b)):new v(new Uint8Array(b))}static wrap(b){return M&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new v(b)}static fromString(b,O){return!(O?.dontUseNodeBuffer||!1)&&M?new v(Buffer.from(b)):(i||(i=new TextEncoder),new v(i.encode(b)))}static fromByteArray(b){const O=v.alloc(b.length);for(let q=0,Z=b.length;q<Z;q++)O.buffer[q]=b[q];return O}static concat(b,O){if(typeof O>"u"){O=0;for(let se=0,ae=b.length;se<ae;se++)O+=b[se].byteLength}const q=v.alloc(O);let Z=0;for(let se=0,ae=b.length;se<ae;se++){const fe=b[se];q.set(fe,Z),Z+=fe.byteLength}return q}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=v.alloc(this.byteLength);return b.set(this),b}toString(){return M?this.buffer.toString():(W||(W=new TextDecoder),W.decode(this.buffer))}slice(b,O){return new v(this.buffer.subarray(b,O))}set(b,O){if(b instanceof v)this.buffer.set(b.buffer,O);else if(b instanceof Uint8Array)this.buffer.set(b,O);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),O);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return a(this.buffer,b)}writeUInt32BE(b,O){c(this.buffer,b,O)}readUInt32LE(b){return P(this.buffer,b)}writeUInt32LE(b,O){r(this.buffer,b,O)}readUInt8(b){return l(this.buffer,b)}writeUInt8(b,O){e(this.buffer,b,O)}}t.VSBuffer=v;function A(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0}t.readUInt16LE=A;function h(m,b,O){m[O+0]=b&255,b=b>>>8,m[O+1]=b&255}t.writeUInt16LE=h;function a(m,b){return m[b]*2**24+m[b+1]*2**16+m[b+2]*2**8+m[b+3]}t.readUInt32BE=a;function c(m,b,O){m[O+3]=b,b=b>>>8,m[O+2]=b,b=b>>>8,m[O+1]=b,b=b>>>8,m[O]=b}t.writeUInt32BE=c;function P(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0|m[b+2]<<16>>>0|m[b+3]<<24>>>0}t.readUInt32LE=P;function r(m,b,O){m[O+0]=b&255,b=b>>>8,m[O+1]=b&255,b=b>>>8,m[O+2]=b&255,b=b>>>8,m[O+3]=b&255}t.writeUInt32LE=r;function l(m,b){return m[b]}t.readUInt8=l;function e(m,b,O){m[O]=b}t.writeUInt8=e;function o(m){return E.consumeReadable(m,b=>v.concat(b))}t.readableToBuffer=o;function n(m){return E.toReadable(m)}t.bufferToReadable=n;function u(m){return E.consumeStream(m,b=>v.concat(b))}t.streamToBuffer=u;async function s(m){return m.ended?v.concat(m.buffer):v.concat([...m.buffer,await u(m.stream)])}t.bufferedStreamToBuffer=s;function w(m){return E.toStream(m,b=>v.concat(b))}t.bufferToStream=w;function D(m){return E.transform(m,{data:b=>typeof b=="string"?v.fromString(b):v.wrap(b)},b=>v.concat(b))}t.streamToBufferReadableStream=D;function S(m){return E.newWriteableStream(b=>v.concat(b),m)}t.newWriteableBufferStream=S;function f(m,b){return E.prefixedReadable(m,b,O=>v.concat(O))}t.prefixedBufferReadable=f;function p(m,b){return E.prefixedStream(m,b,O=>v.concat(O))}t.prefixedBufferStream=p;function L(m){let b=0,O=0,q=0;const Z=new Uint8Array(Math.floor(m.length/4*3)),se=fe=>{switch(O){case 3:Z[q++]=b|fe,O=0;break;case 2:Z[q++]=b|fe>>>2,b=fe<<6,O=3;break;case 1:Z[q++]=b|fe>>>4,b=fe<<4,O=2;break;default:b=fe<<2,O=1}};for(let fe=0;fe<m.length;fe++){const ue=m.charCodeAt(fe);if(ue>=65&&ue<=90)se(ue-65);else if(ue>=97&&ue<=122)se(ue-97+26);else if(ue>=48&&ue<=57)se(ue-48+52);else if(ue===43||ue===45)se(62);else if(ue===47||ue===95)se(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${m[fe]}`)}}const ae=q;for(;O>0;)se(0);return v.wrap(Z).slice(0,ae)}t.decodeBase64=L;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:m},b=!0,O=!1){const q=O?y:I;let Z="";const se=m.byteLength%3;let ae=0;for(;ae<m.byteLength-se;ae+=3){const fe=m[ae+0],ue=m[ae+1],Q=m[ae+2];Z+=q[fe>>>2],Z+=q[(fe<<4|ue>>>4)&63],Z+=q[(ue<<2|Q>>>6)&63],Z+=q[Q&63]}if(se===1){const fe=m[ae+0];Z+=q[fe>>>2],Z+=q[fe<<4&63],b&&(Z+="==")}else if(se===2){const fe=m[ae+0],ue=m[ae+1];Z+=q[fe>>>2],Z+=q[(fe<<4|ue>>>4)&63],Z+=q[ue<<2&63],b&&(Z+="=")}return Z}t.encodeBase64=d}),define(ge[46],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[6],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(p){return typeof p=="string"}t.isString=E;function M(p){return Array.isArray(p)&&p.every(L=>E(L))}t.isStringArray=M;function i(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}t.isObject=i;function W(p){const L=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof L}t.isTypedArray=W;function v(p){return typeof p=="number"&&!isNaN(p)}t.isNumber=v;function A(p){return!!p&&typeof p[Symbol.iterator]=="function"}t.isIterable=A;function h(p){return p===!0||p===!1}t.isBoolean=h;function a(p){return typeof p>"u"}t.isUndefined=a;function c(p){return!P(p)}t.isDefined=c;function P(p){return a(p)||p===null}t.isUndefinedOrNull=P;function r(p,L){if(!p)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=r;function l(p){if(P(p))throw new Error("Assertion Failed: argument is undefined or null");return p}t.assertIsDefined=l;function e(...p){const L=[];for(let I=0;I<p.length;I++){const y=p[I];if(P(y))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);L.push(y)}return L}t.assertAllDefined=e;const o=Object.prototype.hasOwnProperty;function n(p){if(!i(p))return!1;for(const L in p)if(o.call(p,L))return!1;return!0}t.isEmptyObject=n;function u(p){return typeof p=="function"}t.isFunction=u;function s(...p){return p.length>0&&p.every(u)}t.areFunctions=s;function w(p,L){const I=Math.min(p.length,L.length);for(let y=0;y<I;y++)D(p[y],L[y])}t.validateConstraints=w;function D(p,L){if(E(L)){if(typeof p!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(u(L)){try{if(p instanceof L)return}catch{}if(!P(p)&&p.constructor===L||L.length===1&&L.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=D;function S(p){return p===null?void 0:p}t.withNullAsUndefined=S;function f(p){return typeof p>"u"?null:p}t.withUndefinedAsNull=f}),define(ge[16],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(A,h){if((0,E.isString)(h)){const a=M[h];if(a===void 0)throw new Error(`${A} references an unknown codicon: ${h}`);h=a}return M[A]=h,{id:A}}function W(){return M}t.getCodiconFontCharacters=W;function v(){return Object.values(t.Codicon)}t.getAllCodicons=v,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[47],me([1,0,6]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const s=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([w,D])=>{s[w]=D&&typeof D=="object"?M(D):D}),s}t.deepClone=M;function i(u){if(!u||typeof u!="object")return u;const s=[u];for(;s.length>0;){const w=s.shift();Object.freeze(w);for(const D in w)if(W.call(w,D)){const S=w[D];typeof S=="object"&&!Object.isFrozen(S)&&!(0,E.isTypedArray)(S)&&s.push(S)}}return u}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function v(u,s){return A(u,s,new Set)}t.cloneAndChange=v;function A(u,s,w){if((0,E.isUndefinedOrNull)(u))return u;const D=s(u);if(typeof D<"u")return D;if(Array.isArray(u)){const S=[];for(const f of u)S.push(A(f,s,w));return S}if((0,E.isObject)(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const S={};for(const f in u)W.call(u,f)&&(S[f]=A(u[f],s,w));return w.delete(u),S}return u}function h(u,s,w=!0){return(0,E.isObject)(u)?((0,E.isObject)(s)&&Object.keys(s).forEach(D=>{D in u?w&&((0,E.isObject)(u[D])&&(0,E.isObject)(s[D])?h(u[D],s[D],w):u[D]=s[D]):u[D]=s[D]}),u):s}t.mixin=h;function a(u,s){if(u===s)return!0;if(u==null||s===null||s===void 0||typeof u!=typeof s||typeof u!="object"||Array.isArray(u)!==Array.isArray(s))return!1;let w,D;if(Array.isArray(u)){if(u.length!==s.length)return!1;for(w=0;w<u.length;w++)if(!a(u[w],s[w]))return!1}else{const S=[];for(D in u)S.push(D);S.sort();const f=[];for(D in s)f.push(D);if(f.sort(),!a(S,f))return!1;for(w=0;w<S.length;w++)if(!a(u[S[w]],s[S[w]]))return!1}return!0}t.equals=a;function c(u){const s=new Set;return JSON.stringify(u,(w,D)=>{if((0,E.isObject)(D)||Array.isArray(D)){if(s.has(D))return"[Circular]";s.add(D)}return D})}t.safeStringify=c;function P(u,s){const w=Object.create(null);return!u||!s||Object.keys(s).forEach(S=>{const f=u[S],p=s[S];a(f,p)||(w[S]=p)}),w}t.distinct=P;function r(u,s){const w=s.toLowerCase(),D=Object.keys(u).find(S=>S.toLowerCase()===w);return D?u[D]:u[s]}t.getCaseInsensitive=r;function l(u,s){const w=Object.create(null);for(const[D,S]of Object.entries(u))s(D,S)&&(w[D]=S);return w}t.filter=l;function e(u){let s=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)s=s.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return s}t.getAllPropertyNames=e;function o(u){const s=[];for(const w of e(u))typeof u[w]=="function"&&s.push(w);return s}t.getAllMethodNames=o;function n(u,s){const w=S=>function(){const f=Array.prototype.slice.call(arguments,0);return s(S,f)},D={};for(const S of u)D[S]=w(S);return D}t.createProxyObject=n}),define(ge[17],me([1,0,16]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var M;(function(v){function A(h){return h&&typeof h=="object"&&typeof h.id=="string"}v.isThemeColor=A})(M=t.ThemeColor||(t.ThemeColor={}));function i(v){return{id:v}}t.themeColorFromId=i;var W;(function(v){v.iconNameSegment="[A-Za-z0-9]+",v.iconNameExpression="[A-Za-z0-9-]+",v.iconModifierExpression="~[A-Za-z]+",v.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${v.iconNameExpression})(${v.iconModifierExpression})?$`);function h(s){const w=A.exec(s.id);if(!w)return h(E.Codicon.error);const[,D,S]=w,f=["codicon","codicon-"+D];return S&&f.push("codicon-modifier-"+S.substring(1)),f}v.asClassNameArray=h;function a(s){return h(s).join(" ")}v.asClassName=a;function c(s){return"."+h(s).join(".")}v.asCSSSelector=c;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||M.isThemeColor(s.color))}v.isThemeIcon=P;const r=new RegExp(`^\\$\\((${v.iconNameExpression}(?:${v.iconModifierExpression})?)\\)$`);function l(s){const w=r.exec(s);if(!w)return;const[,D]=w;return{id:D}}v.fromString=l;function e(s){return{id:s}}v.fromId=e;function o(s,w){let D=s.id;const S=D.lastIndexOf("~");return S!==-1&&(D=D.substring(0,S)),w&&(D=`${D}~${w}`),{id:D}}v.modify=o;function n(s){const w=s.id.lastIndexOf("~");if(w!==-1)return s.id.substring(w+1)}v.getModifier=n;function u(s,w){return s.id===w.id&&s.color?.id===w.color?.id}v.isEqual=u})(W=t.ThemeIcon||(t.ThemeIcon={}))}),define(ge[81],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,W){this.a=i,this.onMessage=W}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(ee,t){return ee.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(ee,t){return ee.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(ee,t){return ee.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let M=!1,i=!1,W=!1,v=!1,A=!1,h=!1,a=!1,c=!1,P=!1,r=!1,l,e=t.LANGUAGE_DEFAULT,o=t.LANGUAGE_DEFAULT,n,u;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const w=typeof s?.versions?.electron=="string",D=w&&s?.type==="renderer";if(typeof navigator=="object"&&!D)u=navigator.userAgent,M=u.indexOf("Windows")>=0,i=u.indexOf("Macintosh")>=0,c=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=u.indexOf("Linux")>=0,r=u?.indexOf("Mobi")>=0,h=!0,l=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=l,o=navigator.language;else if(typeof s=="object"){M=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",v=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,a=w,P=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const b=s.env.VSCODE_NLS_CONFIG;if(b)try{const O=JSON.parse(b),q=O.availableLanguages["*"];l=O.locale,o=O.osLocale,e=q||t.LANGUAGE_DEFAULT,n=O._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var S;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(S=t.Platform||(t.Platform={}));function f(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let p=0;i?p=1:M?p=3:W&&(p=2),t.isWindows=M,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=v,t.isNative=A,t.isElectron=a,t.isWeb=h,t.isWebWorker=h&&typeof t.globals.importScripts=="function",t.isIOS=c,t.isMobile=r,t.isCI=P,t.platform=p,t.userAgent=u,t.language=e;var L;(function(b){function O(){return t.language}b.value=O;function q(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}b.isDefaultVariant=q;function Z(){return t.language==="en"}b.isDefault=Z})(L=t.Language||(t.Language={})),t.locale=l,t.platformLocale=o,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const b=[];t.globals.addEventListener("message",q=>{if(q.data&&q.data.vscodeScheduleAsyncWork)for(let Z=0,se=b.length;Z<se;Z++){const ae=b[Z];if(ae.id===q.data.vscodeScheduleAsyncWork){b.splice(Z,1),ae.callback();return}}});let O=0;return q=>{const Z=++O;b.push({id:Z,callback:q}),t.globals.postMessage({vscodeScheduleAsyncWork:Z},"*")}}return b=>setTimeout(b)})();var I;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(I=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||c?2:M?1:3;let y=!0,d=!1;function m(){if(!d){d=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,y=new Uint16Array(b.buffer)[0]===(2<<8)+1}return y}t.isLittleEndian=m,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=M.cwd,t.env=M.env,t.platform=M.platform,t.arch=M.arch}),define(ge[22],me([1,0,105]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const M=65,i=97,W=90,v=122,A=46,h=47,a=92,c=58,P=63;class r extends Error{constructor(p,L,I){let y;typeof L=="string"&&L.indexOf("not ")===0?(y="must not be",L=L.replace(/^not /,"")):y="must be";const d=p.indexOf(".")!==-1?"property":"argument";let m=`The "${p}" ${d} ${y} of type ${L}`;m+=`. Received type ${typeof I}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function l(f,p){if(f===null||typeof f!="object")throw new r(p,"Object",f)}function e(f,p){if(typeof f!="string")throw new r(p,"string",f)}const o=E.platform==="win32";function n(f){return f===h||f===a}function u(f){return f===h}function s(f){return f>=M&&f<=W||f>=i&&f<=v}function w(f,p,L,I){let y="",d=0,m=-1,b=0,O=0;for(let q=0;q<=f.length;++q){if(q<f.length)O=f.charCodeAt(q);else{if(I(O))break;O=h}if(I(O)){if(!(m===q-1||b===1))if(b===2){if(y.length<2||d!==2||y.charCodeAt(y.length-1)!==A||y.charCodeAt(y.length-2)!==A){if(y.length>2){const Z=y.lastIndexOf(L);Z===-1?(y="",d=0):(y=y.slice(0,Z),d=y.length-1-y.lastIndexOf(L)),m=q,b=0;continue}else if(y.length!==0){y="",d=0,m=q,b=0;continue}}p&&(y+=y.length>0?`${L}..`:"..",d=2)}else y.length>0?y+=`${L}${f.slice(m+1,q)}`:y=f.slice(m+1,q),d=q-m-1;m=q,b=0}else O===A&&b!==-1?++b:b=-1}return y}function D(f,p){l(p,"pathObject");const L=p.dir||p.root,I=p.base||`${p.name||""}${p.ext||""}`;return L?L===p.root?`${L}${I}`:`${L}${f}${I}`:I}t.win32={resolve(...f){let p="",L="",I=!1;for(let y=f.length-1;y>=-1;y--){let d;if(y>=0){if(d=f[y],e(d,"path"),d.length===0)continue}else p.length===0?d=E.cwd():(d=E.env[`=${p}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==p.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${p}\\`));const m=d.length;let b=0,O="",q=!1;const Z=d.charCodeAt(0);if(m===1)n(Z)&&(b=1,q=!0);else if(n(Z))if(q=!0,n(d.charCodeAt(1))){let se=2,ae=se;for(;se<m&&!n(d.charCodeAt(se));)se++;if(se<m&&se!==ae){const fe=d.slice(ae,se);for(ae=se;se<m&&n(d.charCodeAt(se));)se++;if(se<m&&se!==ae){for(ae=se;se<m&&!n(d.charCodeAt(se));)se++;(se===m||se!==ae)&&(O=`\\\\${fe}\\${d.slice(ae,se)}`,b=se)}}}else b=1;else s(Z)&&d.charCodeAt(1)===c&&(O=d.slice(0,2),b=2,m>2&&n(d.charCodeAt(2))&&(q=!0,b=3));if(O.length>0)if(p.length>0){if(O.toLowerCase()!==p.toLowerCase())continue}else p=O;if(I){if(p.length>0)break}else if(L=`${d.slice(b)}\\${L}`,I=q,q&&p.length>0)break}return L=w(L,!I,"\\",n),I?`${p}\\${L}`:`${p}${L}`||"."},normalize(f){e(f,"path");const p=f.length;if(p===0)return".";let L=0,I,y=!1;const d=f.charCodeAt(0);if(p===1)return u(d)?"\\":f;if(n(d))if(y=!0,n(f.charCodeAt(1))){let b=2,O=b;for(;b<p&&!n(f.charCodeAt(b));)b++;if(b<p&&b!==O){const q=f.slice(O,b);for(O=b;b<p&&n(f.charCodeAt(b));)b++;if(b<p&&b!==O){for(O=b;b<p&&!n(f.charCodeAt(b));)b++;if(b===p)return`\\\\${q}\\${f.slice(O)}\\`;b!==O&&(I=`\\\\${q}\\${f.slice(O,b)}`,L=b)}}}else L=1;else s(d)&&f.charCodeAt(1)===c&&(I=f.slice(0,2),L=2,p>2&&n(f.charCodeAt(2))&&(y=!0,L=3));let m=L<p?w(f.slice(L),!y,"\\",n):"";return m.length===0&&!y&&(m="."),m.length>0&&n(f.charCodeAt(p-1))&&(m+="\\"),I===void 0?y?`\\${m}`:m:y?`${I}\\${m}`:`${I}${m}`},isAbsolute(f){e(f,"path");const p=f.length;if(p===0)return!1;const L=f.charCodeAt(0);return n(L)||p>2&&s(L)&&f.charCodeAt(1)===c&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let p,L;for(let d=0;d<f.length;++d){const m=f[d];e(m,"path"),m.length>0&&(p===void 0?p=L=m:p+=`\\${m}`)}if(p===void 0)return".";let I=!0,y=0;if(typeof L=="string"&&n(L.charCodeAt(0))){++y;const d=L.length;d>1&&n(L.charCodeAt(1))&&(++y,d>2&&(n(L.charCodeAt(2))?++y:I=!1))}if(I){for(;y<p.length&&n(p.charCodeAt(y));)y++;y>=2&&(p=`\\${p.slice(y)}`)}return t.win32.normalize(p)},relative(f,p){if(e(f,"from"),e(p,"to"),f===p)return"";const L=t.win32.resolve(f),I=t.win32.resolve(p);if(L===I||(f=L.toLowerCase(),p=I.toLowerCase(),f===p))return"";let y=0;for(;y<f.length&&f.charCodeAt(y)===a;)y++;let d=f.length;for(;d-1>y&&f.charCodeAt(d-1)===a;)d--;const m=d-y;let b=0;for(;b<p.length&&p.charCodeAt(b)===a;)b++;let O=p.length;for(;O-1>b&&p.charCodeAt(O-1)===a;)O--;const q=O-b,Z=m<q?m:q;let se=-1,ae=0;for(;ae<Z;ae++){const ue=f.charCodeAt(y+ae);if(ue!==p.charCodeAt(b+ae))break;ue===a&&(se=ae)}if(ae!==Z){if(se===-1)return I}else{if(q>Z){if(p.charCodeAt(b+ae)===a)return I.slice(b+ae+1);if(ae===2)return I.slice(b+ae)}m>Z&&(f.charCodeAt(y+ae)===a?se=ae:ae===2&&(se=3)),se===-1&&(se=0)}let fe="";for(ae=y+se+1;ae<=d;++ae)(ae===d||f.charCodeAt(ae)===a)&&(fe+=fe.length===0?"..":"\\..");return b+=se,fe.length>0?`${fe}${I.slice(b,O)}`:(I.charCodeAt(b)===a&&++b,I.slice(b,O))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const p=t.win32.resolve(f);if(p.length<=2)return f;if(p.charCodeAt(0)===a){if(p.charCodeAt(1)===a){const L=p.charCodeAt(2);if(L!==P&&L!==A)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(s(p.charCodeAt(0))&&p.charCodeAt(1)===c&&p.charCodeAt(2)===a)return`\\\\?\\${p}`;return f},dirname(f){e(f,"path");const p=f.length;if(p===0)return".";let L=-1,I=0;const y=f.charCodeAt(0);if(p===1)return n(y)?f:".";if(n(y)){if(L=I=1,n(f.charCodeAt(1))){let b=2,O=b;for(;b<p&&!n(f.charCodeAt(b));)b++;if(b<p&&b!==O){for(O=b;b<p&&n(f.charCodeAt(b));)b++;if(b<p&&b!==O){for(O=b;b<p&&!n(f.charCodeAt(b));)b++;if(b===p)return f;b!==O&&(L=I=b+1)}}}}else s(y)&&f.charCodeAt(1)===c&&(L=p>2&&n(f.charCodeAt(2))?3:2,I=L);let d=-1,m=!0;for(let b=p-1;b>=I;--b)if(n(f.charCodeAt(b))){if(!m){d=b;break}}else m=!1;if(d===-1){if(L===-1)return".";d=L}return f.slice(0,d)},basename(f,p){p!==void 0&&e(p,"ext"),e(f,"path");let L=0,I=-1,y=!0,d;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===c&&(L=2),p!==void 0&&p.length>0&&p.length<=f.length){if(p===f)return"";let m=p.length-1,b=-1;for(d=f.length-1;d>=L;--d){const O=f.charCodeAt(d);if(n(O)){if(!y){L=d+1;break}}else b===-1&&(y=!1,b=d+1),m>=0&&(O===p.charCodeAt(m)?--m===-1&&(I=d):(m=-1,I=b))}return L===I?I=b:I===-1&&(I=f.length),f.slice(L,I)}for(d=f.length-1;d>=L;--d)if(n(f.charCodeAt(d))){if(!y){L=d+1;break}}else I===-1&&(y=!1,I=d+1);return I===-1?"":f.slice(L,I)},extname(f){e(f,"path");let p=0,L=-1,I=0,y=-1,d=!0,m=0;f.length>=2&&f.charCodeAt(1)===c&&s(f.charCodeAt(0))&&(p=I=2);for(let b=f.length-1;b>=p;--b){const O=f.charCodeAt(b);if(n(O)){if(!d){I=b+1;break}continue}y===-1&&(d=!1,y=b+1),O===A?L===-1?L=b:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||y===-1||m===0||m===1&&L===y-1&&L===I+1?"":f.slice(L,y)},format:D.bind(null,"\\"),parse(f){e(f,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return p;const L=f.length;let I=0,y=f.charCodeAt(0);if(L===1)return n(y)?(p.root=p.dir=f,p):(p.base=p.name=f,p);if(n(y)){if(I=1,n(f.charCodeAt(1))){let se=2,ae=se;for(;se<L&&!n(f.charCodeAt(se));)se++;if(se<L&&se!==ae){for(ae=se;se<L&&n(f.charCodeAt(se));)se++;if(se<L&&se!==ae){for(ae=se;se<L&&!n(f.charCodeAt(se));)se++;se===L?I=se:se!==ae&&(I=se+1)}}}}else if(s(y)&&f.charCodeAt(1)===c){if(L<=2)return p.root=p.dir=f,p;if(I=2,n(f.charCodeAt(2))){if(L===3)return p.root=p.dir=f,p;I=3}}I>0&&(p.root=f.slice(0,I));let d=-1,m=I,b=-1,O=!0,q=f.length-1,Z=0;for(;q>=I;--q){if(y=f.charCodeAt(q),n(y)){if(!O){m=q+1;break}continue}b===-1&&(O=!1,b=q+1),y===A?d===-1?d=q:Z!==1&&(Z=1):d!==-1&&(Z=-1)}return b!==-1&&(d===-1||Z===0||Z===1&&d===b-1&&d===m+1?p.base=p.name=f.slice(m,b):(p.name=f.slice(m,d),p.base=f.slice(m,b),p.ext=f.slice(d,b))),m>0&&m!==I?p.dir=f.slice(0,m-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(o){const f=/\\/g;return()=>{const p=E.cwd().replace(f,"/");return p.slice(p.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...f){let p="",L=!1;for(let I=f.length-1;I>=-1&&!L;I--){const y=I>=0?f[I]:S();e(y,"path"),y.length!==0&&(p=`${y}/${p}`,L=y.charCodeAt(0)===h)}return p=w(p,!L,"/",u),L?`/${p}`:p.length>0?p:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const p=f.charCodeAt(0)===h,L=f.charCodeAt(f.length-1)===h;return f=w(f,!p,"/",u),f.length===0?p?"/":L?"./":".":(L&&(f+="/"),p?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let p;for(let L=0;L<f.length;++L){const I=f[L];e(I,"path"),I.length>0&&(p===void 0?p=I:p+=`/${I}`)}return p===void 0?".":t.posix.normalize(p)},relative(f,p){if(e(f,"from"),e(p,"to"),f===p||(f=t.posix.resolve(f),p=t.posix.resolve(p),f===p))return"";const L=1,I=f.length,y=I-L,d=1,m=p.length-d,b=y<m?y:m;let O=-1,q=0;for(;q<b;q++){const se=f.charCodeAt(L+q);if(se!==p.charCodeAt(d+q))break;se===h&&(O=q)}if(q===b)if(m>b){if(p.charCodeAt(d+q)===h)return p.slice(d+q+1);if(q===0)return p.slice(d+q)}else y>b&&(f.charCodeAt(L+q)===h?O=q:q===0&&(O=0));let Z="";for(q=L+O+1;q<=I;++q)(q===I||f.charCodeAt(q)===h)&&(Z+=Z.length===0?"..":"/..");return`${Z}${p.slice(d+O)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const p=f.charCodeAt(0)===h;let L=-1,I=!0;for(let y=f.length-1;y>=1;--y)if(f.charCodeAt(y)===h){if(!I){L=y;break}}else I=!1;return L===-1?p?"/":".":p&&L===1?"//":f.slice(0,L)},basename(f,p){p!==void 0&&e(p,"ext"),e(f,"path");let L=0,I=-1,y=!0,d;if(p!==void 0&&p.length>0&&p.length<=f.length){if(p===f)return"";let m=p.length-1,b=-1;for(d=f.length-1;d>=0;--d){const O=f.charCodeAt(d);if(O===h){if(!y){L=d+1;break}}else b===-1&&(y=!1,b=d+1),m>=0&&(O===p.charCodeAt(m)?--m===-1&&(I=d):(m=-1,I=b))}return L===I?I=b:I===-1&&(I=f.length),f.slice(L,I)}for(d=f.length-1;d>=0;--d)if(f.charCodeAt(d)===h){if(!y){L=d+1;break}}else I===-1&&(y=!1,I=d+1);return I===-1?"":f.slice(L,I)},extname(f){e(f,"path");let p=-1,L=0,I=-1,y=!0,d=0;for(let m=f.length-1;m>=0;--m){const b=f.charCodeAt(m);if(b===h){if(!y){L=m+1;break}continue}I===-1&&(y=!1,I=m+1),b===A?p===-1?p=m:d!==1&&(d=1):p!==-1&&(d=-1)}return p===-1||I===-1||d===0||d===1&&p===I-1&&p===L+1?"":f.slice(p,I)},format:D.bind(null,"/"),parse(f){e(f,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return p;const L=f.charCodeAt(0)===h;let I;L?(p.root="/",I=1):I=0;let y=-1,d=0,m=-1,b=!0,O=f.length-1,q=0;for(;O>=I;--O){const Z=f.charCodeAt(O);if(Z===h){if(!b){d=O+1;break}continue}m===-1&&(b=!1,m=O+1),Z===A?y===-1?y=O:q!==1&&(q=1):y!==-1&&(q=-1)}if(m!==-1){const Z=d===0&&L?1:d;y===-1||q===0||q===1&&y===m-1&&y===d+1?p.base=p.name=f.slice(Z,m):(p.name=f.slice(Z,y),p.base=f.slice(Z,m),p.ext=f.slice(y,m))}return d>0?p.dir=f.slice(0,d-1):L&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=o?t.win32.normalize:t.posix.normalize,t.isAbsolute=o?t.win32.isAbsolute:t.posix.isAbsolute,t.join=o?t.win32.join:t.posix.join,t.resolve=o?t.win32.resolve:t.posix.resolve,t.relative=o?t.win32.relative:t.posix.relative,t.dirname=o?t.win32.dirname:t.posix.dirname,t.basename=o?t.win32.basename:t.posix.basename,t.extname=o?t.win32.extname:t.posix.extname,t.format=o?t.win32.format:t.posix.format,t.parse=o?t.win32.parse:t.posix.parse,t.toNamespacedPath=o?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=o?t.win32.sep:t.posix.sep,t.delimiter=o?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(c){const P=(0,E.extname)(c),r=M[P.toLowerCase()];return r!==void 0?r:v(c)}t.getMediaOrTextMime=W;function v(c){const P=(0,E.extname)(c);return i[P.toLowerCase()]}t.getMediaMime=v;function A(c){for(const P in i)if(i[P]===c)return P}t.getExtensionForMimeType=A;const h=/^(.+)\/(.+?)(;.+)?$/;function a(c,P){const r=h.exec(c);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:c}t.normalizeMimeType=a}),define(ge[107],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(v=!0){return new i(v)}constructor(v){this.a=M&&v,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}t.StopWatch=i}),define(ge[3],me([1,0,7,40,2,43,107]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const A=!1,h=!1;var a;(function(d){d.None=()=>i.Disposable.None;function m(C){if(h){const{onDidAddListener:$}=C,Y=e.create();let F=0;C.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function b(C,$){return J(C,()=>{},0,void 0,!0,void 0,$)}d.defer=b;function O(C){return($,Y=null,F)=>{let N=!1,B;return B=C(k=>{if(!N)return B?B.dispose():N=!0,$.call(Y,k)},null,F),N&&B.dispose(),B}}d.once=O;function q(C,$,Y){return Q((F,N=null,B)=>C(k=>F.call(N,$(k)),null,B),Y)}d.map=q;function Z(C,$,Y){return Q((F,N=null,B)=>C(k=>{$(k),F.call(N,k)},null,B),Y)}d.forEach=Z;function se(C,$,Y){return Q((F,N=null,B)=>C(k=>$(k)&&F.call(N,k),null,B),Y)}d.filter=se;function ae(C){return C}d.signal=ae;function fe(...C){return($,Y=null,F)=>(0,i.combinedDisposable)(...C.map(N=>N(B=>$.call(Y,B),null,F)))}d.any=fe;function ue(C,$,Y,F){let N=Y;return q(C,B=>(N=$(N,B),N),F)}d.reduce=ue;function Q(C,$){let Y;const F={onWillAddFirstListener(){Y=C(N.fire,N)},onDidRemoveLastListener(){Y?.dispose()}};$||m(F);const N=new n(F);return $?.add(N),N.event}function J(C,$,Y=100,F=!1,N=!1,B,k){let H,z,U,j=0,G;const re={leakWarningThreshold:B,onWillAddFirstListener(){H=C(De=>{j++,z=$(z,De),F&&!U&&(he.fire(z),z=void 0),G=()=>{const ye=z;z=void 0,U=void 0,(!F||j>1)&&he.fire(ye),j=0},typeof Y=="number"?(clearTimeout(U),U=setTimeout(G,Y)):U===void 0&&(U=0,queueMicrotask(G))})},onWillRemoveListener(){N&&j>0&&G?.()},onDidRemoveLastListener(){G=void 0,H.dispose()}};k||m(re);const he=new n(re);return k?.add(he),he.event}d.debounce=J;function ve(C,$=0,Y){return d.debounce(C,(F,N)=>F?(F.push(N),F):[N],$,void 0,!0,void 0,Y)}d.accumulate=ve;function pe(C,$=(F,N)=>F===N,Y){let F=!0,N;return se(C,B=>{const k=F||!$(B,N);return F=!1,N=B,k},Y)}d.latch=pe;function Me(C,$,Y){return[d.filter(C,$,Y),d.filter(C,F=>!$(F),Y)]}d.split=Me;function Re(C,$=!1,Y=[]){let F=Y.slice(),N=C(H=>{F?F.push(H):k.fire(H)});const B=()=>{F?.forEach(H=>k.fire(H)),F=null},k=new n({onWillAddFirstListener(){N||(N=C(H=>k.fire(H)))},onDidAddFirstListener(){F&&($?setTimeout(B):B())},onDidRemoveLastListener(){N&&N.dispose(),N=null}});return k.event}d.buffer=Re;class le{constructor($){this.event=$,this.c=new i.DisposableStore}map($){return new le(q(this.event,$,this.c))}forEach($){return new le(Z(this.event,$,this.c))}filter($){return new le(se(this.event,$,this.c))}reduce($,Y){return new le(ue(this.event,$,Y,this.c))}latch(){return new le(pe(this.event,void 0,this.c))}debounce($,Y=100,F=!1,N=!1,B){return new le(J(this.event,$,Y,F,N,B,this.c))}on($,Y,F){return this.event($,Y,F)}once($,Y,F){return O(this.event)($,Y,F)}dispose(){this.c.dispose()}}function x(C){return new le(C)}d.chain=x;function ne(C,$,Y=F=>F){const F=(...H)=>k.fire(Y(...H)),N=()=>C.on($,F),B=()=>C.removeListener($,F),k=new n({onWillAddFirstListener:N,onDidRemoveLastListener:B});return k.event}d.fromNodeEventEmitter=ne;function te(C,$,Y=F=>F){const F=(...H)=>k.fire(Y(...H)),N=()=>C.addEventListener($,F),B=()=>C.removeEventListener($,F),k=new n({onWillAddFirstListener:N,onDidRemoveLastListener:B});return k.event}d.fromDOMEventEmitter=te;function ie(C){return new Promise($=>O(C)($))}d.toPromise=ie;function T(C,$){return $(void 0),C(Y=>$(Y))}d.runAndSubscribe=T;function _(C,$){let Y=null;function F(B){Y?.dispose(),Y=new i.DisposableStore,$(B,Y)}F(void 0);const N=C(B=>F(B));return(0,i.toDisposable)(()=>{N.dispose(),Y?.dispose()})}d.runAndSubscribeWithStore=_;class R{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const F={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||m(F),this.emitter=new n(F),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function g(C,$){return new R(C,$).emitter.event}d.fromObservable=g})(a=t.Event||(t.Event={}));class c{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${c.c++}`,c.all.add(this)}start(m){this.d=new v.StopWatch(!0),this.listenerCount=m}stop(){if(this.d){const m=this.d.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.d=void 0}}}c.all=new Set,c.c=0,t.EventProfiling=c;let P=-1;function r(d){const m=P;return P=d,{dispose(){P=m}}}t.setGlobalLeakWarningThreshold=r;class l{constructor(m,b=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=b,this.d=0}dispose(){this.c?.clear()}check(m,b){const O=this.threshold;if(O<=0||b<O)return;this.c||(this.c=new Map);const q=this.c.get(m.value)||0;if(this.c.set(m.value,q+1),this.d-=1,this.d<=0){this.d=O*.5;let Z,se=0;for(const[ae,fe]of this.c)(!Z||se<fe)&&(Z=ae,se=fe);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${se}):`),console.warn(Z)}return()=>{const Z=this.c.get(m.value)||0;this.c.set(m.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o{constructor(m,b,O){this.callback=m,this.callbackThis=b,this.stack=O,this.subscription=new i.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class n{constructor(m){this.j=!1,this.d=m,this.f=P>0||this.d?.leakWarningThreshold?new l(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new c(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const m=Array.from(this.q);queueMicrotask(()=>{for(const b of m)b.subscription.isset()&&(b.subscription.unset(),b.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(m,b,O)=>{if(this.q||(this.q=new W.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const q=this.q.isEmpty();q&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let Z,se;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(se=e.create(),Z=this.f.check(se,this.q.size+1)),A&&(se=se??e.create());const ae=new o(m,b,se),fe=this.q.push(ae);q&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,m,b);const ue=ae.subscription.set(()=>{Z?.(),this.j||(this.d?.onWillRemoveListener?.(this),fe(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return O instanceof i.DisposableStore?O.add(ue):Array.isArray(O)&&O.push(ue),ue}),this.l}fire(m){if(this.q){this.m||(this.m=new s(this.d?.onListenerError));for(const b of this.q)this.m.push(this,b,m);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=n;class u{constructor(m=E.onUnexpectedError){this.d=m,this.c=new W.LinkedList}get size(){return this.c.size}push(m,b,O){this.c.push(new w(m,b,O))}clear(m){const b=new W.LinkedList;for(const O of this.c)O.emitter!==m&&b.push(O);this.c=b}deliver(){for(;this.c.size>0;){const m=this.c.shift();try{m.listener.invoke(m.event)}catch(b){this.d(b)}}}}t.EventDeliveryQueue=u;class s extends u{clear(m){this.c.clear()}}class w{constructor(m,b,O){this.emitter=m,this.listener=b,this.event=O}}class D extends n{async fireAsync(m,b,O){if(!!this.q){this.c||(this.c=new W.LinkedList);for(const q of this.q)this.c.push([q,m]);for(;this.c.size>0&&!b.isCancellationRequested;){const[q,Z]=this.c.shift(),se=[],ae={...Z,token:b,waitUntil:fe=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");O&&(fe=O(fe,q.callback)),se.push(fe)}};try{q.invoke(ae)}catch(fe){(0,E.onUnexpectedError)(fe);continue}Object.freeze(se),await Promise.allSettled(se).then(fe=>{for(const ue of fe)ue.status==="rejected"&&(0,E.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=D;class S extends n{constructor(m){super(m),this.h=0,this.s=new W.LinkedList,this.t=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.t(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.q&&(this.h!==0?this.s.push(m):super.fire(m))}}t.PauseableEmitter=S;class f extends S{constructor(m){super(m),this.c=m.delay??100}fire(m){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(m)}}t.DebounceEmitter=f;class p extends n{constructor(m){super(m),this.c=[],this.h=m?.merge}fire(m){!this.hasListeners()||(this.c.push(m),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(b=>super.fire(b)),this.c=[]}))}}t.MicrotaskEmitter=p;class L{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(m){const b={event:m,listener:null};this.f.push(b),this.d&&this.j(b);const O=()=>{this.d&&this.k(b);const q=this.f.indexOf(b);this.f.splice(q,1)};return(0,i.toDisposable)((0,M.once)(O))}g(){this.d=!0,this.f.forEach(m=>this.j(m))}h(){this.d=!1,this.f.forEach(m=>this.k(m))}j(m){m.listener=m.event(b=>this.c.fire(b))}k(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class I{constructor(){this.c=[]}wrapEvent(m){return(b,O,q)=>m(Z=>{const se=this.c[this.c.length-1];se?se.push(()=>b.call(O,Z)):b.call(O,Z)},void 0,q)}bufferEvents(m){const b=[];this.c.push(b);const O=m();return this.c.pop(),b.forEach(q=>q()),O}}t.EventBufferer=I;class y{constructor(){this.c=!1,this.d=a.None,this.f=i.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(m){this.d=m,this.c&&(this.f.dispose(),this.f=m(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=y}),define(ge[18],me([1,0,3,2]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new E.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(D,S){this.a!==D&&(this.a=D)}getZoomFactor(){return this.b}setZoomFactor(D){this.b=D}setFullscreen(D){this.c!==D&&(this.c=D,this.d.fire())}isFullscreen(){return this.c}}i.INSTANCE=new i;class W extends M.Disposable{constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(D){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),D&&this.a.fire()}}class v extends M.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=this.c();const D=this.B(new W);this.B(D.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const D=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,f=D.webkitBackingStorePixelRatio||D.mozBackingStorePixelRatio||D.msBackingStorePixelRatio||D.oBackingStorePixelRatio||D.backingStorePixelRatio||1;return S/f}}class A{constructor(){this.a=null}b(){return this.a||(this.a=(0,M.markAsSingleton)(new v)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(w,D){typeof w=="string"&&(w=window.matchMedia(w)),w.addEventListener("change",D)}t.addMatchMediaChangeListener=h,t.PixelRatio=new A;function a(w,D){i.INSTANCE.setZoomLevel(w,D)}t.setZoomLevel=a;function c(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=c;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(w){i.INSTANCE.setZoomFactor(w)}t.setZoomFactor=r;function l(w){i.INSTANCE.setFullscreen(w)}t.setFullscreen=l;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const o=navigator.userAgent;t.isFirefox=o.indexOf("Firefox")>=0,t.isWebKit=o.indexOf("AppleWebKit")>=0,t.isChrome=o.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&o.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=o.indexOf("Electron/")>=0,t.isAndroid=o.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const w=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),D=window.matchMedia("(display-mode: fullscreen)");n=w.matches,h(w,({matches:S})=>{n&&D.matches||(n=S)})}function u(){return n}t.isStandalone=u;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(ge[108],me([1,0,18,5]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:M.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:M.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>M.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class M{get event(){return this.a.event}constructor(W,v,A){const h=a=>this.a.fire(a);this.a=new E.Emitter({onWillAddFirstListener:()=>W.addEventListener(v,h,A),onDidRemoveLastListener:()=>W.removeEventListener(v,h,A)})}dispose(){this.a.dispose()}}t.DomEmitter=M}),define(ge[14],me([1,0,18,41,74,5]),function(ee,t,E,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function v(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return M.KeyCodeUtils.fromString(n)}const o=e.keyCode;if(o===3)return 7;if(E.isFirefox){if(o===59)return 80;if(o===107)return 81;if(o===109)return 83;if(W.isMacintosh&&o===224)return 57}else if(E.isWebKit){if(o===91)return 57;if(W.isMacintosh&&o===93)return 57;if(!W.isMacintosh&&o===92)return 57}return M.EVENT_KEY_CODE_MAP[o]||0}const A=W.isMacintosh?256:2048,h=512,a=1024,c=W.isMacintosh?2048:256;function P(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${M.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class l{constructor(o){this._standardKeyboardEventBrand=!0;const n=o;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=v(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(o){return this.a===o}c(){let o=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode);let n=0;return this.ctrlKey&&(n|=A),this.altKey&&(n|=h),this.shiftKey&&(n|=a),this.metaKey&&(n|=c),n|=o,n}d(){let o=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,o)}}t.StandardKeyboardEvent=l}),define(ge[21],me([1,0,18,66,5]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(a){this.timestamp=Date.now(),this.browserEvent=a,this.leftButton=a.button===0,this.middleButton=a.button===1,this.rightButton=a.button===2,this.buttons=a.buttons,this.target=a.target,this.detail=a.detail||1,a.type==="dblclick"&&(this.detail=2),this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,typeof a.pageX=="number"?(this.posx=a.pageX,this.posy=a.pageY):(this.posx=a.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=a.clientY+document.body.scrollTop+document.documentElement.scrollTop);const c=M.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,a.view);this.posx-=c.left,this.posy-=c.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class v extends W{constructor(a){super(a),this.dataTransfer=a.dataTransfer}}t.DragMouseEvent=v;class A{constructor(a,c=0,P=0){if(this.browserEvent=a||null,this.target=a?a.target||a.targetNode||a.srcElement:null,this.deltaY=P,this.deltaX=c,a){const r=a,l=a;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-a.deltaY/3:this.deltaY=-a.deltaY:this.deltaY=-a.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-a.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-a.deltaX/3:this.deltaX=-a.deltaX:this.deltaX=-a.deltaX/40}this.deltaY===0&&this.deltaX===0&&a.wheelDelta&&(this.deltaY=a.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=A}),define(ge[31],me([1,0,3,2,103]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends M.Disposable{constructor(r,l="",e="",o=!0,n){super(),this.j=this.B(new E.Emitter),this.onDidChange=this.j.event,this.z=!0,this.m=r,this.n=l,this.w=e,this.z=o,this.D=n}get id(){return this.m}get label(){return this.n}set label(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.j.fire({label:r}))}get tooltip(){return this.u||""}set tooltip(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.j.fire({tooltip:r}))}get class(){return this.w}set class(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.j.fire({class:r}))}get enabled(){return this.z}set enabled(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.j.fire({enabled:r}))}get checked(){return this.C}set checked(r){this.J(r)}J(r){this.C!==r&&(this.C=r,this.j.fire({checked:r}))}async run(r,l){this.D&&await this.D(r)}}t.Action=W;class v extends M.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(r,l){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.k(r,l)}catch(o){e=o}this.h.fire({action:r,error:e})}async k(r,l){await r.run(l)}}t.ActionRunner=v;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new A,...e]:l=e);return l}async run(){}}A.ID="vs.actions.separator",t.Separator=A;class h{get actions(){return this.a}constructor(r,l,e,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=o,this.a=e}async run(){}}t.SubmenuAction=h;class a extends W{constructor(){super(a.ID,i.localize(0,null),void 0,!1)}}a.ID="vs.actions.empty",t.EmptySubmenuAction=a;function c(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=c}),define(ge[27],me([1,0,3]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const M=Object.freeze(function(A,h){const a=setTimeout(A.bind(h),0);return{dispose(){clearTimeout(a)}}});var i;(function(A){function h(a){return a===A.None||a===A.Cancelled||a instanceof W?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}A.isCancellationToken=h,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i=t.CancellationToken||(t.CancellationToken={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(h){this.a=void 0,this.b=void 0,this.b=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new W),this.a}cancel(){this.a?this.a instanceof W&&this.a.cancel():this.a=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof W&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=v}),define(ge[109],me([1,0,27]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class M{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new E.CancellationTokenSource,h=this.b(A.token);return this.a={promise:h,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.Cache=M;class i{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const h=JSON.stringify(A);return this.b!==h&&(this.b=h,this.a=this.c(A)),this.a}}t.LRUCachedFunction=i;class W{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const h=this.b(A);return this.a.set(A,h),h}}t.CachedFunction=W}),define(ge[49],me([1,0,3,2]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(i=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class W{constructor(e,o,n,u,s,w,D){this.c=e,this._scrollStateBrand=void 0,this.c&&(o=o|0,n=n|0,u=u|0,s=s|0,w=w|0,D=D|0),this.rawScrollLeft=u,this.rawScrollTop=D,o<0&&(o=0),u+o>n&&(u=n-o),u<0&&(u=0),s<0&&(s=0),D+s>w&&(D=w-s),D<0&&(D=0),this.width=o,this.scrollWidth=n,this.scrollLeft=u,this.height=s,this.scrollHeight=w,this.scrollTop=D}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,o){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,o){const n=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,w=this.height!==e.height,D=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:o,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:u,scrollLeftChanged:s,heightChanged:w,scrollHeightChanged:D,scrollTopChanged:S}}}t.ScrollState=W;class v extends M.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new E.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,o){const n=this.g.withScrollDimensions(e,o);this.k(n,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const o=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(o,!1)}setScrollPositionSmooth(e,o){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const n=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===n.scrollLeft&&this.h.to.scrollTop===n.scrollTop)return;let u;o?u=new c(this.h.from,n,this.h.startTime,this.h.duration):u=this.h.combine(this.g,n,this.c),this.h.dispose(),this.h=u}else{const n=this.g.withScrollPosition(e);this.h=c.start(this.g,n,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),o=this.g.withScrollPosition(e);if(this.k(o,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,o){const n=this.g;n.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(n,o)))}}t.Scrollable=v;class A{constructor(e,o,n){this.scrollLeft=e,this.scrollTop=o,this.isDone=n}}t.SmoothScrollingUpdate=A;function h(l,e){const o=e-l;return function(n){return l+o*r(n)}}function a(l,e,o){return function(n){return n<o?l(n/o):e((n-o)/(1-o))}}class c{constructor(e,o,n,u){this.from=e,this.to=o,this.duration=u,this.startTime=n,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,o,n){if(Math.abs(e-o)>2.5*n){let s,w;return e<o?(s=e+.75*n,w=o-.75*n):(s=e-.75*n,w=o+.75*n),a(h(e,s),h(w,o),.33)}return h(e,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const o=(e-this.startTime)/this.duration;if(o<1){const n=this.c(o),u=this.d(o);return new A(n,u,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,o,n){return c.start(e,o,n)}static start(e,o,n){n=n+10;const u=Date.now()-10;return new c(e,o,u,n)}}t.SmoothScrollingOperation=c;function P(l){return Math.pow(l,3)}function r(l){return 1-P(1-l)}}),define(ge[11],me([1,0,109,42]),function(ee,t,E,M){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(V){return!V||typeof V!="string"?!0:V.trim().length===0}t.isFalsyOrWhitespace=W;const v=/{(\d+)}/g;function A(V,...oe){return oe.length===0?V:V.replace(v,function(be,Ee){const Se=parseInt(Ee,10);return isNaN(Se)||Se<0||Se>=oe.length?be:oe[Se]})}t.format=A;const h=/{([^}]+)}/g;function a(V,oe){return V.replace(h,(be,Ee)=>oe[Ee]??be)}t.format2=a;function c(V){return V.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=c;function P(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(V,oe){let be=0;const Ee=oe.charCodeAt(0);for(let Se=V.length-1;Se>=0;Se--)V.charCodeAt(Se)===Ee&&be++;return be}t.count=r;function l(V,oe,be="\u2026"){return V.length<=oe?V:`${V.substr(0,oe)}${be}`}t.truncate=l;function e(V,oe=" "){const be=o(V,oe);return n(be,oe)}t.trim=e;function o(V,oe){if(!V||!oe)return V;const be=oe.length;if(be===0||V.length===0)return V;let Ee=0;for(;V.indexOf(oe,Ee)===Ee;)Ee=Ee+be;return V.substring(Ee)}t.ltrim=o;function n(V,oe){if(!V||!oe)return V;const be=oe.length,Ee=V.length;if(be===0||Ee===0)return V;let Se=Ee,Oe=-1;for(;Oe=V.lastIndexOf(oe,Se-1),!(Oe===-1||Oe+be!==Se);){if(Oe===0)return"";Se=Oe}return V.substring(0,Se)}t.rtrim=n;function u(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function s(V){return V.replace(/\*/g,"")}t.stripWildcards=s;function w(V,oe,be={}){if(!V)throw new Error("Cannot create regex from empty string");oe||(V=P(V)),be.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let Ee="";return be.global&&(Ee+="g"),be.matchCase||(Ee+="i"),be.multiline&&(Ee+="m"),be.unicode&&(Ee+="u"),new RegExp(V,Ee)}t.createRegExp=w;function D(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}t.regExpLeadsToEndlessLoop=D;function S(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function f(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}t.regExpFlags=f;function p(V){return V.split(/\r\n|\r|\n/)}t.splitLines=p;function L(V){for(let oe=0,be=V.length;oe<be;oe++){const Ee=V.charCodeAt(oe);if(Ee!==32&&Ee!==9)return oe}return-1}t.firstNonWhitespaceIndex=L;function I(V,oe=0,be=V.length){for(let Ee=oe;Ee<be;Ee++){const Se=V.charCodeAt(Ee);if(Se!==32&&Se!==9)return V.substring(oe,Ee)}return V.substring(oe,be)}t.getLeadingWhitespace=I;function y(V,oe=V.length-1){for(let be=oe;be>=0;be--){const Ee=V.charCodeAt(be);if(Ee!==32&&Ee!==9)return be}return-1}t.lastNonWhitespaceIndex=y;function d(V,oe,be){const Ee=[];let Se=0;for(const Oe of V.matchAll(oe)){if(Ee.push(V.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,Ee.push(be(Oe[0],...Oe.slice(1),Oe.index,V,Oe.groups))}return Ee.push(V.slice(Se)),Promise.all(Ee).then(Oe=>Oe.join(""))}t.replaceAsync=d;function m(V,oe){return V<oe?-1:V>oe?1:0}t.compare=m;function b(V,oe,be=0,Ee=V.length,Se=0,Oe=oe.length){for(;be<Ee&&Se<Oe;be++,Se++){const Ke=V.charCodeAt(be),_e=oe.charCodeAt(Se);if(Ke<_e)return-1;if(Ke>_e)return 1}const We=Ee-be,tt=Oe-Se;return We<tt?-1:We>tt?1:0}t.compareSubstring=b;function O(V,oe){return q(V,oe,0,V.length,0,oe.length)}t.compareIgnoreCase=O;function q(V,oe,be=0,Ee=V.length,Se=0,Oe=oe.length){for(;be<Ee&&Se<Oe;be++,Se++){let Ke=V.charCodeAt(be),_e=oe.charCodeAt(Se);if(Ke===_e)continue;if(Ke>=128||_e>=128)return b(V.toLowerCase(),oe.toLowerCase(),be,Ee,Se,Oe);se(Ke)&&(Ke-=32),se(_e)&&(_e-=32);const Te=Ke-_e;if(Te!==0)return Te}const We=Ee-be,tt=Oe-Se;return We<tt?-1:We>tt?1:0}t.compareSubstringIgnoreCase=q;function Z(V){return V>=48&&V<=57}t.isAsciiDigit=Z;function se(V){return V>=97&&V<=122}t.isLowerAsciiLetter=se;function ae(V){return V>=65&&V<=90}t.isUpperAsciiLetter=ae;function fe(V,oe){return V.length===oe.length&&q(V,oe)===0}t.equalsIgnoreCase=fe;function ue(V,oe){const be=oe.length;return oe.length>V.length?!1:q(V,oe,0,be)===0}t.startsWithIgnoreCase=ue;function Q(V,oe){const be=Math.min(V.length,oe.length);let Ee;for(Ee=0;Ee<be;Ee++)if(V.charCodeAt(Ee)!==oe.charCodeAt(Ee))return Ee;return be}t.commonPrefixLength=Q;function J(V,oe){const be=Math.min(V.length,oe.length);let Ee;const Se=V.length-1,Oe=oe.length-1;for(Ee=0;Ee<be;Ee++)if(V.charCodeAt(Se-Ee)!==oe.charCodeAt(Oe-Ee))return Ee;return be}t.commonSuffixLength=J;function ve(V){return 55296<=V&&V<=56319}t.isHighSurrogate=ve;function pe(V){return 56320<=V&&V<=57343}t.isLowSurrogate=pe;function Me(V,oe){return(V-55296<<10)+(oe-56320)+65536}t.computeCodePoint=Me;function Re(V,oe,be){const Ee=V.charCodeAt(be);if(ve(Ee)&&be+1<oe){const Se=V.charCodeAt(be+1);if(pe(Se))return Me(Ee,Se)}return Ee}t.getNextCodePoint=Re;function le(V,oe){const be=V.charCodeAt(oe-1);if(pe(be)&&oe>1){const Ee=V.charCodeAt(oe-2);if(ve(Ee))return Me(Ee,be)}return be}class x{get offset(){return this.e}constructor(oe,be=0){this.c=oe,this.d=oe.length,this.e=be}setOffset(oe){this.e=oe}prevCodePoint(){const oe=le(this.c,this.e);return this.e-=oe>=65536?2:1,oe}nextCodePoint(){const oe=Re(this.c,this.d,this.e);return this.e+=oe>=65536?2:1,oe}eol(){return this.e>=this.d}}t.CodePointIterator=x;class ne{get offset(){return this.c.offset}constructor(oe,be=0){this.c=new x(oe,be)}nextGraphemeLength(){const oe=Pe.getInstance(),be=this.c,Ee=be.offset;let Se=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Oe=be.offset,We=oe.getGraphemeBreakType(be.nextCodePoint());if(Ce(Se,We)){be.setOffset(Oe);break}Se=We}return be.offset-Ee}prevGraphemeLength(){const oe=Pe.getInstance(),be=this.c,Ee=be.offset;let Se=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Oe=be.offset,We=oe.getGraphemeBreakType(be.prevCodePoint());if(Ce(We,Se)){be.setOffset(Oe);break}Se=We}return Ee-be.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ne;function te(V,oe){return new ne(V,oe).nextGraphemeLength()}t.nextCharLength=te;function ie(V,oe){return new ne(V,oe).prevGraphemeLength()}t.prevCharLength=ie;function T(V,oe){oe>0&&pe(V.charCodeAt(oe))&&oe--;const be=oe+te(V,oe);return[be-ie(V,be),be]}t.getCharContainingOffset=T;function _(V){const oe=new ne(V);let be=0;for(;!oe.eol();)be++,oe.nextGraphemeLength();return be}t.charCount=_;let R;function g(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(V){return R||(R=g()),R.test(V)}t.containsRTL=C;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(V){return $.test(V)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(V){return t.UNUSUAL_LINE_TERMINATORS.test(V)}t.containsUnusualLineTerminators=F;function N(V){return V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}t.isFullWidthCharacter=N;function B(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129008||V>=129280&&V<=129535||V>=129648&&V<=129782}t.isEmojiImprecise=B;function k(V,oe){if(V.length<oe)return V;const be=/\b/g;let Ee=0;for(;be.test(V)&&!(V.length-be.lastIndex<oe);)Ee=be.lastIndex,be.lastIndex+=1;return V.substring(Ee).replace(/^\s/,"")}t.lcut=k;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function z(V){return V&&(V=V.replace(H,"")),V}t.removeAnsiEscapeCodes=z,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function U(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}t.startsWithUTF8BOM=U;function j(V){return U(V)?V.substr(1):V}t.stripUTF8BOM=j;function G(V,oe){if(!V||!oe||V.length<oe.length)return!1;const be=oe.length,Ee=V.toLowerCase();let Se=0,Oe=-1;for(;Se<be;){const We=Ee.indexOf(oe[Se],Oe+1);if(We<0)return!1;Oe=We,Se++}return!0}t.fuzzyContains=G;function re(V,oe=!1){return V?(oe&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}t.containsUppercaseCharacter=re;function he(V){return V.charAt(0).toUpperCase()+V.slice(1)}t.uppercaseFirstLetter=he;function De(V,oe=1){if(oe===0)return"";let be=-1;do be=V.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?V:(V[be-1]==="\r"&&be--,V.substr(0,be))}t.getNLines=De;function ye(V){return V=V%(2*26),V<26?String.fromCharCode(97+V):String.fromCharCode(65+V-26)}t.singleLetterHash=ye;function Le(V){return Pe.getInstance().getGraphemeBreakType(V)}t.getGraphemeBreakType=Le;function Ce(V,oe){return V===0?oe!==5&&oe!==7:V===2&&oe===3?!1:V===4||V===2||V===3||oe===4||oe===2||oe===3?!0:!(V===8&&(oe===8||oe===9||oe===11||oe===12)||(V===11||V===9)&&(oe===9||oe===10)||(V===12||V===10)&&oe===10||oe===5||oe===13||oe===7||V===1||V===13&&oe===14||V===6&&oe===6)}var we;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(we=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Ie()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this.d,Ee=be.length/3;let Se=1;for(;Se<=Ee;)if(oe<be[3*Se])Se=2*Se;else if(oe>be[3*Se+1])Se=2*Se+1;else return be[3*Se+2];return 0}}Pe.c=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(V,oe){if(V===0)return 0;const be=He(V,oe);if(be!==void 0)return be;const Ee=new x(oe,V);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=Ve;function He(V,oe){const be=new x(oe,V);let Ee=be.prevCodePoint();for(;Ue(Ee)||Ee===65039||Ee===8419;){if(be.offset===0)return;Ee=be.prevCodePoint()}if(!B(Ee))return;let Se=be.offset;return Se>0&&be.prevCodePoint()===8205&&(Se=be.offset),Se}function Ue(V){return 127995<=V&&V<=127999}var Ze;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.noBreakWhitespace="\xA0";class Ge{static getInstance(oe){return Ge.d.get(Array.from(oe))}static getLocales(){return Ge.e.value}constructor(oe){this.f=oe}isAmbiguous(oe){return this.f.has(oe)}getPrimaryConfusable(oe){return this.f.get(oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=Ge,Ge.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new E.LRUCachedFunction(V=>{function oe(_e){const Te=new Map;for(let ce=0;ce<_e.length;ce+=2)Te.set(_e[ce],_e[ce+1]);return Te}function be(_e,Te){const ce=new Map(_e);for(const[Ae,Ne]of Te)ce.set(Ae,Ne);return ce}function Ee(_e,Te){if(!_e)return Te;const ce=new Map;for(const[Ae,Ne]of _e)Te.has(Ae)&&ce.set(Ae,Ne);return ce}const Se=i.c.value;let Oe=V.filter(_e=>!_e.startsWith("_")&&_e in Se);Oe.length===0&&(Oe=["_default"]);let We;for(const _e of Oe){const Te=oe(Se[_e]);We=Ee(We,Te)}const tt=oe(Se._common),Ke=be(tt,We);return new Ge(Ke)}),Ge.e=new M.Lazy(()=>Object.keys(Ge.c.value).filter(V=>!V.startsWith("_"))),t.AmbiguousCharacters=Ge;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(oe){return Be.e().has(oe)}static get codePoints(){return Be.e()}}Be.d=void 0,t.InvisibleCharacters=Be}),define(ge[110],me([1,0,22,5,11,6]),function(ee,t,E,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function v(d){return d===47||d===92}t.isPathSeparator=v;function A(d){return d.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=A;function h(d){return d.indexOf("/")===-1&&(d=A(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}t.toPosixPath=h;function a(d,m=E.posix.sep){if(!d)return"";const b=d.length,O=d.charCodeAt(0);if(v(O)){if(v(d.charCodeAt(1))&&!v(d.charCodeAt(2))){let Z=3;const se=Z;for(;Z<b&&!v(d.charCodeAt(Z));Z++);if(se!==Z&&!v(d.charCodeAt(Z+1))){for(Z+=1;Z<b;Z++)if(v(d.charCodeAt(Z)))return d.slice(0,Z+1).replace(/[\\/]/g,m)}}return m}else if(u(O)&&d.charCodeAt(1)===58)return v(d.charCodeAt(2))?d.slice(0,2)+m:d.slice(0,2);let q=d.indexOf("://");if(q!==-1){for(q+=3;q<b;q++)if(v(d.charCodeAt(q)))return d.slice(0,q+1)}return""}t.getRoot=a;function c(d){if(!M.isWindows||!d||d.length<5)return!1;let m=d.charCodeAt(0);if(m!==92||(m=d.charCodeAt(1),m!==92))return!1;let b=2;const O=b;for(;b<d.length&&(m=d.charCodeAt(b),m!==92);b++);return!(O===b||(m=d.charCodeAt(b+1),isNaN(m)||m===92))}t.isUNC=c;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(d,m=M.isWindows){const b=m?P:r;return!(!d||d.length===0||/^\s+$/.test(d)||(b.lastIndex=0,b.test(d))||m&&l.test(d)||d==="."||d===".."||m&&d[d.length-1]==="."||m&&d.length!==d.trim().length||d.length>255)}t.isValidBasename=e;function o(d,m,b){const O=d===m;return!b||O?O:!d||!m?!1:(0,i.equalsIgnoreCase)(d,m)}t.isEqual=o;function n(d,m,b,O=E.sep){if(d===m)return!0;if(!d||!m||m.length>d.length)return!1;if(b){if(!(0,i.startsWithIgnoreCase)(d,m))return!1;if(m.length===d.length)return!0;let Z=m.length;return m.charAt(m.length-1)===O&&Z--,d.charAt(Z)===O}return m.charAt(m.length-1)!==O&&(m+=O),d.indexOf(m)===0}t.isEqualOrParent=n;function u(d){return d>=65&&d<=90||d>=97&&d<=122}t.isWindowsDriveLetter=u;function s(d,m){return M.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(m,d)),d=(0,E.normalize)(d),M.isWindows?(d=(0,i.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,i.rtrim)(d,E.sep),d||(d=E.sep)),d}t.sanitizeFilePath=s;function w(d){const m=(0,E.normalize)(d);return M.isWindows?d.length>3?!1:D(m)&&(d.length===2||m.charCodeAt(2)===92):m===E.posix.sep}t.isRootOrDriveLetter=w;function D(d,m=M.isWindows){return m?u(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}t.hasDriveLetter=D;function S(d){return D(d)?d[0]:void 0}t.getDriveLetter=S;function f(d,m,b){return m.length>d.length?-1:d===m?0:(b&&(d=d.toLowerCase(),m=m.toLowerCase()),d.indexOf(m))}t.indexOfPath=f;function p(d){const m=d.split(":");let b,O,q;for(const Z of m){const se=Number(Z);(0,W.isNumber)(se)?O===void 0?O=se:q===void 0&&(q=se):b=b?[b,Z].join(":"):Z}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:O!==void 0?O:void 0,column:q!==void 0?q:O!==void 0?1:void 0}}t.parseLineAndColumnAware=p;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,m,b=8){let O="";for(let Z=0;Z<b;Z++){let se;Z===0&&M.isWindows&&!m&&(b===3||b===4)?se=I:se=L,O+=se.charAt(Math.floor(Math.random()*se.length))}let q;return m?q=`${m}-${O}`:q=O,d?(0,E.join)(d,q):q}t.randomPath=y}),define(ge[32],me([1,0,75,11]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...z){return function(U,j){for(let G=0,re=z.length;G<re;G++){const he=z[G](U,j);if(he)return he}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(z,U,j){if(!j||j.length<U.length)return null;let G;return z?G=M.startsWithIgnoreCase(j,U):G=j.indexOf(U)===0,G?U.length>0?[{start:0,end:U.length}]:[]:null}function v(z,U){const j=U.toLowerCase().indexOf(z.toLowerCase());return j===-1?null:[{start:j,end:j+z.length}]}t.matchesContiguousSubString=v;function A(z,U){return h(z.toLowerCase(),U.toLowerCase(),0,0)}t.matchesSubString=A;function h(z,U,j,G){if(j===z.length)return[];if(G===U.length)return null;if(z[j]===U[G]){let re=null;return(re=h(z,U,j+1,G+1))?u({start:G,end:G+1},re):null}return h(z,U,j,G+1)}function a(z){return 97<=z&&z<=122}function c(z){return 65<=z&&z<=90}t.isUpper=c;function P(z){return 48<=z&&z<=57}function r(z){return z===32||z===9||z===10||z===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>l.add(z.charCodeAt(0)));function e(z){return r(z)||l.has(z)}function o(z,U){return z===U||e(z)&&e(U)}function n(z){return a(z)||c(z)||P(z)}function u(z,U){return U.length===0?U=[z]:z.end===U[0].start?U[0].start=z.start:U.unshift(z),U}function s(z,U){for(let j=U;j<z.length;j++){const G=z.charCodeAt(j);if(c(G)||P(G)||j>0&&!n(z.charCodeAt(j-1)))return j}return z.length}function w(z,U,j,G){if(j===z.length)return[];if(G===U.length)return null;if(z[j]!==U[G].toLowerCase())return null;{let re=null,he=G+1;for(re=w(z,U,j+1,G+1);!re&&(he=s(U,he))<U.length;)re=w(z,U,j+1,he),he++;return re===null?null:u({start:G,end:G+1},re)}}function D(z){let U=0,j=0,G=0,re=0,he=0;for(let we=0;we<z.length;we++)he=z.charCodeAt(we),c(he)&&U++,a(he)&&j++,n(he)&&G++,P(he)&&re++;const De=U/z.length,ye=j/z.length,Le=G/z.length,Ce=re/z.length;return{upperPercent:De,lowerPercent:ye,alphaPercent:Le,numericPercent:Ce}}function S(z){const{upperPercent:U,lowerPercent:j}=z;return j===0&&U>.6}function f(z){const{upperPercent:U,lowerPercent:j,alphaPercent:G,numericPercent:re}=z;return j>.2&&U<.8&&G>.6&&re<.2}function p(z){let U=0,j=0,G=0,re=0;for(let he=0;he<z.length;he++)G=z.charCodeAt(he),c(G)&&U++,a(G)&&j++,r(G)&&re++;return(U===0||j===0)&&re===0?z.length<=30:U<=5}function L(z,U){if(!U||(U=U.trim(),U.length===0)||!p(z)||U.length>60)return null;const j=D(U);if(!f(j)){if(!S(j))return null;U=U.toLowerCase()}let G=null,re=0;for(z=z.toLowerCase();re<U.length&&(G=w(z,U,0,re))===null;)re=s(U,re+1);return G}t.matchesCamelCase=L;function I(z,U,j=!1){if(!U||U.length===0)return null;let G=null,re=0;for(z=z.toLowerCase(),U=U.toLowerCase();re<U.length&&(G=y(z,U,0,re,j))===null;)re=d(U,re+1);return G}t.matchesWords=I;function y(z,U,j,G,re){if(j===z.length)return[];if(G===U.length)return null;if(o(z.charCodeAt(j),U.charCodeAt(G))){let he=null,De=G+1;if(he=y(z,U,j+1,G+1,re),!re)for(;!he&&(De=d(U,De))<U.length;)he=y(z,U,j+1,De,re),De++;return he?z.charCodeAt(j)!==U.charCodeAt(G)?he:u({start:G,end:G+1},he):null}else return null}function d(z,U){for(let j=U;j<z.length;j++)if(e(z.charCodeAt(j))||j>0&&e(z.charCodeAt(j-1)))return j;return z.length}const m=i(t.matchesPrefix,L,v),b=i(t.matchesPrefix,L,A),O=new E.LRUCache(1e4);function q(z,U,j=!1){if(typeof z!="string"||typeof U!="string")return null;let G=O.get(z);G||(G=new RegExp(M.convertSimple2RegExpPattern(z),"i"),O.set(z,G));const re=G.exec(U);return re?[{start:re.index,end:re.index+re[0].length}]:j?b(z,U):m(z,U)}t.matchesFuzzy=q;function Z(z,U){const j=$(z,z.toLowerCase(),0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ae(j):null}t.matchesFuzzy2=Z;function se(z,U,j,G,re,he){const De=Math.min(13,z.length);for(;j<De;j++){const ye=$(z,U,j,G,re,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,he]}t.anyScore=se;function ae(z){if(typeof z>"u")return[];const U=[],j=z[1];for(let G=z.length-1;G>1;G--){const re=z[G]+j,he=U[U.length-1];he&&he.end===re?he.end=re+1:U.push({start:re,end:re+1})}return U}t.createMatches=ae;const fe=128;function ue(){const z=[],U=[];for(let j=0;j<=fe;j++)U[j]=0;for(let j=0;j<=fe;j++)z.push(U.slice(0));return z}function Q(z){const U=[];for(let j=0;j<=z;j++)U[j]=0;return U}const J=Q(2*fe),ve=Q(2*fe),pe=ue(),Me=ue(),Re=ue(),le=!1;function x(z,U,j,G,re){function he(ye,Le,Ce=" "){for(;ye.length<Le;)ye=Ce+ye;return ye}let De=` |   |${G.split("").map(ye=>he(ye,3)).join("|")}
`;for(let ye=0;ye<=j;ye++)ye===0?De+=" |":De+=`${U[ye-1]}|`,De+=z[ye].slice(0,re+1).map(Le=>he(Le.toString(),3)).join("|")+`
`;return De}function ne(z,U,j,G){z=z.substr(U),j=j.substr(G),console.log(x(Me,z,z.length,j,j.length)),console.log(x(Re,z,z.length,j,j.length)),console.log(x(pe,z,z.length,j,j.length))}function te(z,U){if(U<0||U>=z.length)return!1;const j=z.codePointAt(U);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(j)}}function ie(z,U){if(U<0||U>=z.length)return!1;switch(z.charCodeAt(U)){case 32:case 9:return!0;default:return!1}}function T(z,U,j){return U[z]!==j[z]}function _(z,U,j,G,re,he,De=!1){for(;U<j&&re<he;)z[U]===G[re]&&(De&&(J[U]=re),U+=1),re+=1;return U===j}t.isPatternInWord=_;var R;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(R||(R={}));var g;(function(z){z.Default=[-100,0];function U(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}z.isDefault=U})(g=t.FuzzyScore||(t.FuzzyScore={}));class C{constructor(U,j){this.firstMatchCanBeWeak=U,this.boostFullMatch=j}}C.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},t.FuzzyScoreOptions=C;function $(z,U,j,G,re,he,De=C.default){const ye=z.length>fe?fe:z.length,Le=G.length>fe?fe:G.length;if(j>=ye||he>=Le||ye-j>Le-he||!_(U,j,ye,re,he,Le,!0))return;Y(ye,Le,j,he,U,re);let Ce=1,we=1,Pe=j,Ie=he;const Ve=[!1];for(Ce=1,Pe=j;Pe<ye;Ce++,Pe++){const Be=J[Pe],V=ve[Pe],oe=Pe+1<ye?ve[Pe+1]:Le;for(we=Be-he+1,Ie=Be;Ie<oe;we++,Ie++){let be=Number.MIN_SAFE_INTEGER,Ee=!1;Ie<=V&&(be=F(z,U,Pe,j,G,re,Ie,Le,he,pe[Ce-1][we-1]===0,Ve));let Se=0;be!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Se=be+Me[Ce-1][we-1]);const Oe=Ie>Be,We=Oe?Me[Ce][we-1]+(pe[Ce][we-1]>0?-5:0):0,tt=Ie>Be+1&&pe[Ce][we-1]>0,Ke=tt?Me[Ce][we-2]+(pe[Ce][we-2]>0?-5:0):0;if(tt&&(!Oe||Ke>=We)&&(!Ee||Ke>=Se))Me[Ce][we]=Ke,Re[Ce][we]=3,pe[Ce][we]=0;else if(Oe&&(!Ee||We>=Se))Me[Ce][we]=We,Re[Ce][we]=2,pe[Ce][we]=0;else if(Ee)Me[Ce][we]=Se,Re[Ce][we]=1,pe[Ce][we]=pe[Ce-1][we-1]+1;else throw new Error("not possible")}}if(le&&ne(z,j,G,he),!Ve[0]&&!De.firstMatchCanBeWeak)return;Ce--,we--;const He=[Me[Ce][we],he];let Ue=0,Ze=0;for(;Ce>=1;){let Be=we;do{const V=Re[Ce][Be];if(V===3)Be=Be-2;else if(V===2)Be=Be-1;else break}while(Be>=1);Ue>1&&U[j+Ce-1]===re[he+we-1]&&!T(Be+he-1,G,re)&&Ue+1>pe[Ce][Be]&&(Be=we),Be===we?Ue++:Ue=1,Ze||(Ze=Be),Ce--,we=Be-1,He.push(we)}Le===ye&&De.boostFullMatch&&(He[0]+=2);const Ge=Ze-ye;return He[0]-=Ge,He}t.fuzzyScore=$;function Y(z,U,j,G,re,he){let De=z-1,ye=U-1;for(;De>=j&&ye>=G;)re[De]===he[ye]&&(ve[De]=ye,De--),ye--}function F(z,U,j,G,re,he,De,ye,Le,Ce,we){if(U[j]!==he[De])return Number.MIN_SAFE_INTEGER;let Pe=1,Ie=!1;return De===j-G?Pe=z[j]===re[De]?7:5:T(De,re,he)&&(De===0||!T(De-1,re,he))?(Pe=z[j]===re[De]?7:5,Ie=!0):te(he,De)&&(De===0||!te(he,De-1))?Pe=5:(te(he,De-1)||ie(he,De-1))&&(Pe=5,Ie=!0),Pe>1&&j===G&&(we[0]=!0),Ie||(Ie=T(De,re,he)||te(he,De-1)||ie(he,De-1)),j===G?De>Le&&(Pe-=Ie?3:5):Ce?Pe+=Ie?2:0:Pe+=Ie?0:1,De+1===ye&&(Pe-=Ie?3:5),Pe}function N(z,U,j,G,re,he,De){return k(z,U,j,G,re,he,!0,De)}t.fuzzyScoreGracefulAggressive=N;function B(z,U,j,G,re,he,De){return k(z,U,j,G,re,he,!1,De)}t.fuzzyScoreGraceful=B;function k(z,U,j,G,re,he,De,ye){let Le=$(z,U,j,G,re,he,ye);if(Le&&!De)return Le;if(z.length>=3){const Ce=Math.min(7,z.length-1);for(let we=j+1;we<Ce;we++){const Pe=H(z,we);if(Pe){const Ie=$(Pe,Pe.toLowerCase(),j,G,re,he,ye);Ie&&(Ie[0]-=3,(!Le||Ie[0]>Le[0])&&(Le=Ie))}}}return Le}function H(z,U){if(U+1>=z.length)return;const j=z[U],G=z[U+1];if(j!==G)return z.slice(0,U)+G+j+z.slice(U+2)}}),define(ge[111],me([1,0,11]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function M(u){return i(u,0)}t.hash=M;function i(u,s){switch(typeof u){case"object":return u===null?W(349,s):Array.isArray(u)?h(u,s):a(u,s);case"string":return A(u,s);case"boolean":return v(u,s);case"number":return W(u,s);case"undefined":return W(937,s);default:return W(617,s)}}t.doHash=i;function W(u,s){return(s<<5)-s+u|0}t.numberHash=W;function v(u,s){return W(u?433:863,s)}function A(u,s){s=W(149417,s);for(let w=0,D=u.length;w<D;w++)s=W(u.charCodeAt(w),s);return s}t.stringHash=A;function h(u,s){return s=W(104579,s),u.reduce((w,D)=>i(D,w),s)}function a(u,s){return s=W(181387,s),Object.keys(u).sort().reduce((w,D)=>(w=A(D,w),i(u[D],w)),s)}class c{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.Hasher=c;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(u,s,w=32){const D=w-s,S=~((1<<D)-1);return(u<<s|(S&u)>>>D)>>>0}function l(u,s=0,w=u.byteLength,D=0){for(let S=0;S<w;S++)u[s+S]=D}function e(u,s,w="0"){for(;u.length<s;)u=w+u;return u}function o(u,s=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),s/4)}t.toHexString=o;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const w=s.length;if(w===0)return;const D=this.p;let S=this.r,f=this.u,p,L;for(f!==0?(p=f,L=-1,f=0):(p=s.charCodeAt(0),L=0);;){let I=p;if(E.isHighSurrogate(p))if(L+1<w){const y=s.charCodeAt(L+1);E.isLowSurrogate(y)?(L++,I=E.computeCodePoint(p,y)):I=65533}else{f=p;break}else E.isLowSurrogate(p)&&(I=65533);if(S=this.w(D,S,I),L++,L<w)p=s.charCodeAt(L);else break}this.r=S,this.u=f}w(s,w,D){return D<128?s[w++]=D:D<2048?(s[w++]=192|(D&1984)>>>6,s[w++]=128|(D&63)>>>0):D<65536?(s[w++]=224|(D&61440)>>>12,s[w++]=128|(D&4032)>>>6,s[w++]=128|(D&63)>>>0):(s[w++]=240|(D&1835008)>>>18,s[w++]=128|(D&258048)>>>12,s[w++]=128|(D&4032)>>>6,s[w++]=128|(D&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),o(this.h)+o(this.l)+o(this.m)+o(this.n)+o(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=n.g,w=this.q;for(let m=0;m<64;m+=4)s.setUint32(m,w.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)s.setUint32(m,r(s.getUint32(m-12,!1)^s.getUint32(m-32,!1)^s.getUint32(m-56,!1)^s.getUint32(m-64,!1),1),!1);let D=this.h,S=this.l,f=this.m,p=this.n,L=this.o,I,y,d;for(let m=0;m<80;m++)m<20?(I=S&f|~S&p,y=1518500249):m<40?(I=S^f^p,y=1859775393):m<60?(I=S&f|S&p|f&p,y=2400959708):(I=S^f^p,y=3395469782),d=r(D,5)+I+L+y+s.getUint32(m*4,!1)&4294967295,L=p,p=f,f=r(S,30),S=D,D=d;this.h=this.h+D&4294967295,this.l=this.l+S&4294967295,this.m=this.m+f&4294967295,this.n=this.n+p&4294967295,this.o=this.o+L&4294967295}}n.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=n}),define(ge[112],me([1,0,71,111]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,l=new Int32Array(r.length);for(let e=0,o=r.length;e<o;e++)l[e]=r.charCodeAt(e);return l}}t.StringDiffSequence=i;function W(P,r,l){return new c(new i(P),new i(r)).ComputeDiff(l).changes}t.stringDiff=W;class v{static Assert(r,l){if(!r)throw new Error(l)}}class A{static Copy(r,l,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[l+u]}static Copy2(r,l,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[l+u]}}var h;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class a{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(r,l,e=null){this.a=e,this.b=r,this.c=l;const[o,n,u]=c.o(r),[s,w,D]=c.o(l);this.d=u&&D,this.e=o,this.f=n,this.g=s,this.h=w,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const l=r.getElements();if(c.n(l)){const e=new Int32Array(l.length);for(let o=0,n=l.length;o<n;o++)e[o]=(0,M.stringHash)(l[o],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(r,l){return this.f[r]!==this.h[l]?!1:this.d?this.e[r]===this.g[l]:!0}q(r,l){if(!this.p(r,l))return!1;const e=c.r(this.b,r),o=c.r(this.c,l);return e===o}static r(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}s(r,l){return this.f[r]!==this.f[l]?!1:this.d?this.e[r]===this.e[l]:!0}u(r,l){return this.h[r]!==this.h[l]?!1:this.d?this.g[r]===this.g[l]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,l,e,o,n){const u=[!1];let s=this.w(r,l,e,o,u);return n&&(s=this.z(s)),{quitEarly:u[0],changes:s}}w(r,l,e,o,n){for(n[0]=!1;r<=l&&e<=o&&this.p(r,e);)r++,e++;for(;l>=r&&o>=e&&this.p(l,o);)l--,o--;if(r>l||e>o){let f;return e<=o?(v.Assert(r===l+1,"originalStart should only be one more than originalEnd"),f=[new E.DiffChange(r,0,e,o-e+1)]):r<=l?(v.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new E.DiffChange(r,l-r+1,e,0)]):(v.Assert(r===l+1,"originalStart should only be one more than originalEnd"),v.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const u=[0],s=[0],w=this.y(r,l,e,o,u,s,n),D=u[0],S=s[0];if(w!==null)return w;if(!n[0]){const f=this.w(r,D,e,S,n);let p=[];return n[0]?p=[new E.DiffChange(D+1,l-(D+1)+1,S+1,o-(S+1)+1)]:p=this.w(D+1,l,S+1,o,n),this.H(f,p)}return[new E.DiffChange(r,l-r+1,e,o-e+1)]}x(r,l,e,o,n,u,s,w,D,S,f,p,L,I,y,d,m,b){let O=null,q=null,Z=new a,se=l,ae=e,fe=L[0]-d[0]-o,ue=-1073741824,Q=this.k.length-1;do{const J=fe+r;J===se||J<ae&&D[J-1]<D[J+1]?(f=D[J+1],I=f-fe-o,f<ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,I),fe=J+1-r):(f=D[J-1]+1,I=f-fe-o,f<ue&&Z.MarkNextChange(),ue=f-1,Z.AddOriginalElement(f,I+1),fe=J-1-r),Q>=0&&(D=this.k[Q],r=D[0],se=1,ae=D.length-1)}while(--Q>=-1);if(O=Z.getReverseChanges(),b[0]){let J=L[0]+1,ve=d[0]+1;if(O!==null&&O.length>0){const pe=O[O.length-1];J=Math.max(J,pe.getOriginalEnd()),ve=Math.max(ve,pe.getModifiedEnd())}q=[new E.DiffChange(J,p-J+1,ve,y-ve+1)]}else{Z=new a,se=u,ae=s,fe=L[0]-d[0]-w,ue=1073741824,Q=m?this.m.length-1:this.m.length-2;do{const J=fe+n;J===se||J<ae&&S[J-1]>=S[J+1]?(f=S[J+1]-1,I=f-fe-w,f>ue&&Z.MarkNextChange(),ue=f+1,Z.AddOriginalElement(f+1,I+1),fe=J+1-n):(f=S[J-1],I=f-fe-w,f>ue&&Z.MarkNextChange(),ue=f,Z.AddModifiedElement(f+1,I+1),fe=J-1-n),Q>=0&&(S=this.m[Q],n=S[0],se=1,ae=S.length-1)}while(--Q>=-1);q=Z.getChanges()}return this.H(O,q)}y(r,l,e,o,n,u,s){let w=0,D=0,S=0,f=0,p=0,L=0;r--,e--,n[0]=0,u[0]=0,this.k=[],this.m=[];const I=l-r+(o-e),y=I+1,d=new Int32Array(y),m=new Int32Array(y),b=o-e,O=l-r,q=r-e,Z=l-o,ae=(O-b)%2===0;d[b]=r,m[O]=l,s[0]=!1;for(let fe=1;fe<=I/2+1;fe++){let ue=0,Q=0;S=this.J(b-fe,fe,b,y),f=this.J(b+fe,fe,b,y);for(let ve=S;ve<=f;ve+=2){ve===S||ve<f&&d[ve-1]<d[ve+1]?w=d[ve+1]:w=d[ve-1]+1,D=w-(ve-b)-q;const pe=w;for(;w<l&&D<o&&this.p(w+1,D+1);)w++,D++;if(d[ve]=w,w+D>ue+Q&&(ue=w,Q=D),!ae&&Math.abs(ve-O)<=fe-1&&w>=m[ve])return n[0]=w,u[0]=D,pe<=m[ve]&&1447>0&&fe<=1447+1?this.x(b,S,f,q,O,p,L,Z,d,m,w,l,n,D,o,u,ae,s):null}const J=(ue-r+(Q-e)-fe)/2;if(this.a!==null&&!this.a(ue,J))return s[0]=!0,n[0]=ue,u[0]=Q,J>0&&1447>0&&fe<=1447+1?this.x(b,S,f,q,O,p,L,Z,d,m,w,l,n,D,o,u,ae,s):(r++,e++,[new E.DiffChange(r,l-r+1,e,o-e+1)]);p=this.J(O-fe,fe,O,y),L=this.J(O+fe,fe,O,y);for(let ve=p;ve<=L;ve+=2){ve===p||ve<L&&m[ve-1]>=m[ve+1]?w=m[ve+1]-1:w=m[ve-1],D=w-(ve-O)-Z;const pe=w;for(;w>r&&D>e&&this.p(w,D);)w--,D--;if(m[ve]=w,ae&&Math.abs(ve-b)<=fe&&w<=d[ve])return n[0]=w,u[0]=D,pe>=d[ve]&&1447>0&&fe<=1447+1?this.x(b,S,f,q,O,p,L,Z,d,m,w,l,n,D,o,u,ae,s):null}if(fe<=1447){let ve=new Int32Array(f-S+2);ve[0]=b-S+1,A.Copy2(d,S,ve,1,f-S+1),this.k.push(ve),ve=new Int32Array(L-p+2),ve[0]=O-p+1,A.Copy2(m,p,ve,1,L-p+1),this.m.push(ve)}}return this.x(b,S,f,q,O,p,L,Z,d,m,w,l,n,D,o,u,ae,s)}z(r){for(let l=0;l<r.length;l++){const e=r[l],o=l<r.length-1?r[l+1].originalStart:this.f.length,n=l<r.length-1?r[l+1].modifiedStart:this.h.length,u=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<o&&e.modifiedStart+e.modifiedLength<n&&(!u||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const D=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!D)break;e.originalStart++,e.modifiedStart++}const w=[null];if(l<r.length-1&&this.I(r[l],r[l+1],w)){r[l]=w[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let o=0,n=0;if(l>0){const f=r[l-1];o=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const u=e.originalLength>0,s=e.modifiedLength>0;let w=0,D=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const p=e.originalStart-f,L=e.modifiedStart-f;if(p<o||L<n||u&&!this.s(p,p+e.originalLength)||s&&!this.u(L,L+e.modifiedLength))break;const y=(p===o&&L===n?5:0)+this.G(p,e.originalLength,L,e.modifiedLength);y>D&&(D=y,w=f)}e.originalStart-=w,e.modifiedStart-=w;const S=[null];if(l>0&&this.I(r[l-1],r[l],S)){r[l-1]=S[0],r.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=r.length;l<e;l++){const o=r[l-1],n=r[l],u=n.originalStart-o.originalStart-o.originalLength,s=o.originalStart,w=n.originalStart+n.originalLength,D=w-s,S=o.modifiedStart,f=n.modifiedStart+n.modifiedLength,p=f-S;if(u<5&&D<20&&p<20){const L=this.A(s,D,S,p,u);if(L){const[I,y]=L;(I!==o.originalStart+o.originalLength||y!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=I-o.originalStart,o.modifiedLength=y-o.modifiedStart,n.originalStart=I+u,n.modifiedStart=y+u,n.originalLength=w-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}A(r,l,e,o,n){if(l<n||o<n)return null;const u=r+l-n+1,s=e+o-n+1;let w=0,D=0,S=0;for(let f=r;f<u;f++)for(let p=e;p<s;p++){const L=this.B(f,p,n);L>0&&L>w&&(w=L,D=f,S=p)}return w>0?[D,S]:null}B(r,l,e){let o=0;for(let n=0;n<e;n++){if(!this.p(r+n,l+n))return 0;o+=this.e[r+n].length}return o}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,l){if(this.C(r)||this.C(r-1))return!0;if(l>0){const e=r+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,l){if(this.E(r)||this.E(r-1))return!0;if(l>0){const e=r+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,l,e,o){const n=this.D(r,l)?1:0,u=this.F(e,o)?1:0;return n+u}H(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.I(r[r.length-1],l[0],e)){const o=new Array(r.length+l.length-1);return A.Copy(r,0,o,0,r.length-1),o[r.length-1]=e[0],A.Copy(l,1,o,r.length,l.length-1),o}else{const o=new Array(r.length+l.length);return A.Copy(r,0,o,0,r.length),A.Copy(l,0,o,r.length,l.length),o}}I(r,l,e){if(v.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),v.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const o=r.originalStart;let n=r.originalLength;const u=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(n=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(s=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(o,n,u,s),!0}else return e[0]=null,!1}J(r,l,e,o){if(r>=0&&r<o)return r;const n=e,u=o-e-1,s=l%2===0;if(r<0){const w=n%2===0;return s===w?0:1}else{const w=u%2===0;return s===w?o-1:o-2}}}t.LcsDiff=c}),define(ge[33],me([1,0,32,11,17]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",v=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${v.source}`,"g");function h(u){return u.replace(A,(s,w)=>w?s:`\\${s}`)}t.escapeIcons=h;const a=new RegExp(`\\\\${v.source}`,"g");function c(u){return u.replace(a,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=c;const P=new RegExp(`(\\s)?(\\\\)?${v.source}(\\s)?`,"g");function r(u){return u.indexOf(W)===-1?u:u.replace(P,(s,w,D,S)=>D?s:w||S||"")}t.stripIcons=r;function l(u){return u?u.replace(/\$\((.*?)\)/g,(s,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=l;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(u){e.lastIndex=0;let s="";const w=[];let D=0;for(;;){const S=e.lastIndex,f=e.exec(u),p=u.substring(S,f?.index);if(p.length>0){s+=p;for(let L=0;L<p.length;L++)w.push(D)}if(!f)break;D+=f[0].length}return{text:s,iconOffsets:w}}t.parseLabelWithIcons=o;function n(u,s,w=!1){const{text:D,iconOffsets:S}=s;if(!S||S.length===0)return(0,E.matchesFuzzy)(u,D,w);const f=(0,M.ltrim)(D," "),p=D.length-f.length,L=(0,E.matchesFuzzy)(u,f,w);if(L)for(const I of L){const y=S[I.start+p]+p;I.start+=y,I.end+=y}return L}t.matchesFuzzyIconAware=n}),define(ge[113],me([1,0,13,11]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),o=this.b.charCodeAt(this.c);return e-o}value(){return this.b[this.c]}}t.StringIterator=i;class W{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,M.compareSubstring)(l,this.b,0,l.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=W;class v{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const o=this.b.charCodeAt(e);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,M.compareSubstring)(l,this.b,0,l.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=v;var A;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(A||(A={}));class h{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new v(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(l,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,M.compare)(l,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=h;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class P{static forUris(l=()=>!1,e=()=>!1){return new P(new h(l,e))}static forPaths(l=!1){return new P(new v(void 0,!l))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new W)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const o=e.slice(0);(0,E.shuffle)(o);for(const n of o)this.set(n,l)}else{const o=l.slice(0);(0,E.shuffle)(o);for(const n of o)this.set(n[0],n[1])}}set(l,e){const o=this.b.reset(l);let n;this.c||(this.c=new a,this.c.segment=o.value());const u=[];for(n=this.c;;){const w=o.cmp(n.segment);if(w>0)n.left||(n.left=new a,n.left.segment=o.value()),u.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new a,n.right.segment=o.value()),u.push([1,n]),n=n.right;else if(o.hasNext())o.next(),n.mid||(n.mid=new a,n.mid.segment=o.value()),u.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=l;for(let w=u.length-1;w>=0;w--){const D=u[w][1];D.updateHeight();const S=D.balanceFactor();if(S<-1||S>1){const f=u[w][0],p=u[w+1][0];if(f===1&&p===1)u[w][1]=D.rotateLeft();else if(f===-1&&p===-1)u[w][1]=D.rotateRight();else if(f===1&&p===-1)D.right=u[w+1][1]=u[w+1][1].rotateRight(),u[w][1]=D.rotateLeft();else if(f===-1&&p===1)D.left=u[w+1][1]=u[w+1][1].rotateLeft(),u[w][1]=D.rotateRight();else throw new Error;if(w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this.c=u[0][1]}}return s}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let o=this.c;for(;o;){const n=e.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(e.hasNext())e.next(),o=o.mid;else break}return o}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const o=this.b.reset(l),n=[];let u=this.c;for(;u;){const s=o.cmp(u.segment);if(s>0)n.push([-1,u]),u=u.left;else if(s<0)n.push([1,u]),u=u.right;else if(o.hasNext())o.next(),n.push([0,u]),u=u.mid;else break}if(!!u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const s=this.f(u.right);if(s.key){const{key:w,value:D,segment:S}=s;this.e(s.key,!1),u.key=w,u.value=D,u.segment=S}}else{const s=u.left??u.right;if(n.length>0){const[w,D]=n[n.length-1];switch(w){case-1:D.left=s;break;case 0:D.mid=s;break;case 1:D.right=s;break}}else this.c=s}for(let s=n.length-1;s>=0;s--){const w=n[s][1];w.updateHeight();const D=w.balanceFactor();if(D>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[s][1]=w.rotateLeft()):D<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[s][1]=w.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this.c=n[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let o=this.c,n;for(;o;){const u=e.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(e.hasNext())e.next(),n=o.value||n,o=o.mid;else break}return o&&o.value||n}findSuperstr(l){return this.g(l,!1)}g(l,e){const o=this.b.reset(l);let n=this.c;for(;n;){const u=o.cmp(n.segment);if(u>0)n=n.left;else if(u<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this.h(n.mid):e?n.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,o]of this)l(o,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){!l||(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const o=e.balanceFactor();return o<-1||o>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.TernarySearchTree=P}),define(ge[15],me([1,0,22,5]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,v=/^\/\//;function A(L,I){if(!L.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!W.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(L,I){return!L&&!I?"file":L}function a(L,I){switch(L){case"https":case"http":case"file":I?I[0]!==P&&(I=P+I):I=P;break}return I}const c="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(I){return I instanceof l?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,y,d,m,b,O=!1){typeof I=="object"?(this.scheme=I.scheme||c,this.authority=I.authority||c,this.path=I.path||c,this.query=I.query||c,this.fragment=I.fragment||c):(this.scheme=h(I,O),this.authority=y||c,this.path=a(this.scheme,d||c),this.query=m||c,this.fragment=b||c,A(this,O))}get fsPath(){return w(this,!1)}with(I){if(!I)return this;let{scheme:y,authority:d,path:m,query:b,fragment:O}=I;return y===void 0?y=this.scheme:y===null&&(y=c),d===void 0?d=this.authority:d===null&&(d=c),m===void 0?m=this.path:m===null&&(m=c),b===void 0?b=this.query:b===null&&(b=c),O===void 0?O=this.fragment:O===null&&(O=c),y===this.scheme&&d===this.authority&&m===this.path&&b===this.query&&O===this.fragment?this:new o(y,d,m,b,O)}static parse(I,y=!1){const d=r.exec(I);return d?new o(d[2]||c,p(d[4]||c),p(d[5]||c),p(d[7]||c),p(d[9]||c),y):new o(c,c,c,c,c)}static file(I){let y=c;if(M.isWindows&&(I=I.replace(/\\/g,P)),I[0]===P&&I[1]===P){const d=I.indexOf(P,2);d===-1?(y=I.substring(2),I=P):(y=I.substring(2,d),I=I.substring(d)||P)}return new o("file",y,I,c,c)}static from(I){const y=new o(I.scheme,I.authority,I.path,I.query,I.fragment);return A(y,!0),y}static joinPath(I,...y){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return M.isWindows&&I.scheme==="file"?d=l.file(E.win32.join(w(I,!0),...y)).path:d=E.posix.join(I.path,...y),I.with({path:d})}toString(I=!1){return D(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof l)return I;{const y=new o(I);return y._formatted=I.external,y._fsPath=I._sep===e?I.fsPath:null,y}}else return I}}t.URI=l;const e=M.isWindows?1:void 0;class o extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(I=!1){return I?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=e),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(L,I,y){let d,m=-1;for(let b=0;b<L.length;b++){const O=L.charCodeAt(b);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||I&&O===47||y&&O===91||y&&O===93||y&&O===58)m!==-1&&(d+=encodeURIComponent(L.substring(m,b)),m=-1),d!==void 0&&(d+=L.charAt(b));else{d===void 0&&(d=L.substr(0,b));const q=n[O];q!==void 0?(m!==-1&&(d+=encodeURIComponent(L.substring(m,b)),m=-1),d+=q):m===-1&&(m=b)}}return m!==-1&&(d+=encodeURIComponent(L.substring(m))),d!==void 0?d:L}function s(L){let I;for(let y=0;y<L.length;y++){const d=L.charCodeAt(y);d===35||d===63?(I===void 0&&(I=L.substr(0,y)),I+=n[d]):I!==void 0&&(I+=L[y])}return I!==void 0?I:L}function w(L,I){let y;return L.authority&&L.path.length>1&&L.scheme==="file"?y=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?I?y=L.path.substr(1):y=L.path[1].toLowerCase()+L.path.substr(2):y=L.path,M.isWindows&&(y=y.replace(/\//g,"\\")),y}t.uriToFsPath=w;function D(L,I){const y=I?s:u;let d="",{scheme:m,authority:b,path:O,query:q,fragment:Z}=L;if(m&&(d+=m,d+=":"),(b||m==="file")&&(d+=P,d+=P),b){let se=b.indexOf("@");if(se!==-1){const ae=b.substr(0,se);b=b.substr(se+1),se=ae.lastIndexOf(":"),se===-1?d+=y(ae,!1,!1):(d+=y(ae.substr(0,se),!1,!1),d+=":",d+=y(ae.substr(se+1),!1,!0)),d+="@"}b=b.toLowerCase(),se=b.lastIndexOf(":"),se===-1?d+=y(b,!1,!0):(d+=y(b.substr(0,se),!1,!0),d+=b.substr(se))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const se=O.charCodeAt(1);se>=65&&se<=90&&(O=`/${String.fromCharCode(se+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const se=O.charCodeAt(0);se>=65&&se<=90&&(O=`${String.fromCharCode(se+32)}:${O.substr(2)}`)}d+=y(O,!0,!1)}return q&&(d+="?",d+=y(q,!1,!1)),Z&&(d+="#",d+=I?Z:u(Z,!1,!1)),d}function S(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+S(L.substr(3)):L}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(L){return L.match(f)?L.replace(f,I=>S(I)):L}}),define(ge[50],me([1,0,30,11,15]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(a){return JSON.stringify(a,A)}t.stringify=W;function v(a){let c=JSON.parse(a);return c=h(c),c}t.parse=v;function A(a,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:(0,M.regExpFlags)(c)}:c}function h(a,c=0){if(!a||c>200)return a;if(typeof a=="object"){switch(a.$mid){case 1:return i.URI.revive(a);case 2:return new RegExp(a.source,a.flags);case 16:return new Date(a.source)}if(a instanceof E.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let P=0;P<a.length;++P)a[P]=h(a[P],c+1);else for(const P in a)Object.hasOwnProperty.call(a,P)&&(a[P]=h(a[P],c+1))}return a}t.revive=h}),define(ge[28],me([1,0,7,5,15]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractive="vscode-interactive",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(W=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${W.vscodeRemoteResource}`}set(c,P,r){this.a[c]=P,this.b[c]=r}setConnectionToken(c,P){this.c[c]=P}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(n){return E.onUnexpectedError(n),c}const P=c.authority;let r=this.a[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const l=this.b[P],e=this.c[P];let o=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(o+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:M.isWeb?this.d:W.vscodeRemoteResource,authority:`${r}:${l}`,path:this.f,query:o})}}t.RemoteAuthorities=new v,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(c){const P=this.b(c,ee);return this.uriToBrowserUri(P)}uriToBrowserUri(c){return c.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(c):c.scheme===W.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${W.vscodeFileResource}://${A.a}`)?c.with({scheme:W.vscodeFileResource,authority:c.authority||A.a,query:null,fragment:null}):c}asFileUri(c){const P=this.b(c,ee);return this.uriToFileUri(P)}uriToFileUri(c){return c.scheme===W.vscodeFileResource?c.with({scheme:W.file,authority:c.authority!==A.a?c.authority:null,query:null,fragment:null}):c}b(c,P){return i.URI.isUri(c)?c:i.URI.parse(P.toUrl(c))}}A.a="vscode-app",t.FileAccess=new A;var h;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const P="vscode-coi";function r(e){let o;typeof e=="string"?o=new URL(e).searchParams:e instanceof URL?o=e.searchParams:i.URI.isUri(e)&&(o=new URL(e.toString(!0)).searchParams);const n=o?.get(P);if(!!n)return c.get(n)}a.getHeadersFromQuery=r;function l(e,o,n){if(!globalThis.crossOriginIsolated)return;const u=o&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(P,u):e[P]=u}a.addSearchParam=l})(h=t.COI||(t.COI={}))}),define(ge[34],me([1,0,110,28,22,5,11,15]),function(ee,t,E,M,i,W,v,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function h(l){return(0,A.uriToFsPath)(l,!0)}t.originalFSPath=h;class a{constructor(e){this.a=e}compare(e,o,n=!1){return e===o?0:(0,v.compare)(this.getComparisonKey(e,n),this.getComparisonKey(o,n))}isEqual(e,o,n=!1){return e===o?!0:!e||!o?!1:this.getComparisonKey(e,n)===this.getComparisonKey(o,n)}getComparisonKey(e,o=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,o,n=!1){if(e.scheme===o.scheme){if(e.scheme===M.Schemas.file)return E.isEqualOrParent(h(e),h(o),this.a(e))&&e.query===o.query&&(n||e.fragment===o.fragment);if((0,t.isEqualAuthority)(e.authority,o.authority))return E.isEqualOrParent(e.path,o.path,this.a(e),"/")&&e.query===o.query&&(n||e.fragment===o.fragment)}return!1}joinPath(e,...o){return A.URI.joinPath(e,...o)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let o;return e.scheme===M.Schemas.file?o=A.URI.file(i.dirname(h(e))).path:(o=i.posix.dirname(e.path),e.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),o="/")),e.with({path:o})}normalizePath(e){if(!e.path.length)return e;let o;return e.scheme===M.Schemas.file?o=A.URI.file(i.normalize(h(e))).path:o=i.posix.normalize(e.path),e.with({path:o})}relativePath(e,o){if(e.scheme!==o.scheme||!(0,t.isEqualAuthority)(e.authority,o.authority))return;if(e.scheme===M.Schemas.file){const s=i.relative(h(e),h(o));return W.isWindows?E.toSlashes(s):s}let n=e.path||"/";const u=o.path||"/";if(this.a(e)){let s=0;for(const w=Math.min(n.length,u.length);s<w&&!(n.charCodeAt(s)!==u.charCodeAt(s)&&n.charAt(s).toLowerCase()!==u.charAt(s).toLowerCase());s++);n=u.substr(0,s)+n.substr(s)}return i.posix.relative(n,u)}resolvePath(e,o){if(e.scheme===M.Schemas.file){const n=A.URI.file(i.resolve(h(e),o));return e.with({authority:n.authority,path:n.path})}return o=E.toPosixPath(o),e.with({path:i.posix.resolve(e.path,o)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,o){return e===o||e!==void 0&&o!==void 0&&(0,v.equalsIgnoreCase)(e,o)}hasTrailingPathSeparator(e,o=i.sep){if(e.scheme===M.Schemas.file){const n=h(e);return n.length>E.getRoot(n).length&&n[n.length-1]===o}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,o=i.sep){return(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,o=i.sep){let n=!1;if(e.scheme===M.Schemas.file){const u=h(e);n=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===o}else{o="/";const u=e.path;n=u.length===1&&u.charCodeAt(u.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path+"/"}):e}}t.ExtUri=a,t.extUri=new a(()=>!1),t.extUriBiasedIgnorePathCase=new a(l=>l.scheme===M.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new a(l=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function c(l,e){const o=[];for(let n=0;n<l.length;n++){const u=e(l[n]);l.some((s,w)=>w===n?!1:(0,t.isEqualOrParent)(u,e(s)))||o.push(l[n])}return o}t.distinctParents=c;var P;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(o){const n=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(w=>{const[D,S]=w.split(":");D&&S&&n.set(D,S)});const s=o.path.substring(0,o.path.indexOf(";"));return s&&n.set(l.META_DATA_MIME,s),n}l.parseMetaData=e})(P=t.DataUri||(t.DataUri={}));function r(l,e,o){if(e){let n=l.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),l.with({scheme:o,authority:e,path:n})}return l.with({scheme:o})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,34,5,46]),function(ee,t,E,M,i,W,v,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function a(_){return!!_&&typeof _.then=="function"}t.isThenable=a;function c(_){const R=new E.CancellationTokenSource,g=_(R.token),C=new Promise(($,Y)=>{const F=R.token.onCancellationRequested(()=>{F.dispose(),R.dispose(),Y(new M.CancellationError)});Promise.resolve(g).then(N=>{F.dispose(),R.dispose(),$(N)},N=>{F.dispose(),R.dispose(),Y(N)})});return new class{cancel(){R.cancel()}then($,Y){return C.then($,Y)}catch($){return this.then(void 0,$)}finally($){return C.finally($)}}}t.createCancelablePromise=c;function P(_,R,g){return new Promise((C,$)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),C(g)});_.then(C,$).finally(()=>Y.dispose())})}t.raceCancellation=P;function r(_,R){return new Promise((g,C)=>{const $=R.onCancellationRequested(()=>{$.dispose(),C(new M.CancellationError)});_.then(g,C).finally(()=>$.dispose())})}t.raceCancellationError=r;async function l(_){let R=-1;const g=_.map(($,Y)=>$.then(F=>(R=Y,F))),C=await Promise.race(g);return _.forEach(($,Y)=>{Y!==R&&$.cancel()}),C}t.raceCancellablePromises=l;function e(_,R,g){let C;const $=setTimeout(()=>{C?.(void 0),g?.()},R);return Promise.race([_.finally(()=>clearTimeout($)),new Promise(Y=>C=Y)])}t.raceTimeout=e;function o(_){return new Promise((R,g)=>{const C=_();a(C)?C.then(R,g):R(C)})}t.asPromise=o;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const g=()=>{this.b=null;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(g,g).then(C)})}return new Promise((g,C)=>{this.b.then(g,C)})}return this.a=R(),new Promise((g,C)=>{this.a.then($=>{this.a=null,g($)},$=>{this.a=null,C($)})})}}t.Throttler=n;class u{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}t.Sequencer=u;class s{constructor(){this.a=new Map}queue(R,g){const $=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(R)===$&&this.a.delete(R)});return this.a.set(R,$),$}}t.SequencerByKey=s;const w=(_,R)=>{let g=!0;const C=setTimeout(()=>{g=!1,R()},_);return{isTriggered:()=>g,dispose:()=>{clearTimeout(C),g=!1}}},D=_=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,_())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class S{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,g=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise(($,Y)=>{this.d=$,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=g===h.MicrotaskDelay?D(C):w(g,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=S;class f{constructor(R){this.a=new S(R),this.b=new n}trigger(R,g){return this.a.trigger(()=>this.b.queue(R),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=f;class p{constructor(){this.a=!1,this.b=new Promise((R,g)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=p;class L extends p{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=L;function I(_,R){return R?new Promise((g,C)=>{const $=setTimeout(()=>{Y.dispose(),g()},_),Y=R.onCancellationRequested(()=>{clearTimeout($),Y.dispose(),C(new M.CancellationError)})}):c(g=>I(_,g))}t.timeout=I;function y(_,R=0){const g=setTimeout(_,R);return(0,W.toDisposable)(()=>clearTimeout(g))}t.disposableTimeout=y;function d(_){const R=[];let g=0;const C=_.length;function $(){return g<C?_[g++]():null}function Y(F){F!=null&&R.push(F);const N=$();return N?N.then(Y):Promise.resolve(R)}return Promise.resolve(null).then(Y)}t.sequence=d;function m(_,R=C=>!!C,g=null){let C=0;const $=_.length,Y=()=>{if(C>=$)return Promise.resolve(g);const F=_[C++];return Promise.resolve(F()).then(B=>R(B)?Promise.resolve(B):Y())};return Y()}t.first=m;function b(_,R=C=>!!C,g=null){if(_.length===0)return Promise.resolve(g);let C=_.length;const $=()=>{C=-1;for(const Y of _)Y.cancel?.()};return new Promise((Y,F)=>{for(const N of _)N.then(B=>{--C>=0&&R(B)?($(),Y(B)):C===0&&Y(g)}).catch(B=>{--C>=0&&($(),F(B))})})}t.firstParallel=b;class O{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new i.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((g,C)=>{this.f.push({factory:R,c:g,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const g=R.factory();g.then(R.c,R.e),g.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=O;class q extends O{constructor(){super(1)}}t.Queue=q;class Z{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new le;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,g=v.extUri){const C=g.getComparisonKey(R);let $=this.a.get(C);return $||($=new q,i.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(C),this.f()}),this.a.set(C,$)),$}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}t.ResourceQueue=Z;class se{constructor(R,g){this.a=-1,typeof R=="function"&&typeof g=="number"&&this.setIfNotSet(R,g)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,g){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},g)}setIfNotSet(R,g){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},g))}}t.TimeoutTimer=se;class ae{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,g){this.cancel(),this.a=setInterval(()=>{R()},g)}}t.IntervalTimer=ae;class fe{constructor(R,g){this.b=-1,this.a=R,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=fe;class ue{constructor(R,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=R,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=ue;class Q extends fe{constructor(R,g){super(R,g),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=Q;class J extends W.Disposable{constructor(R,g){super(),this.g=R,this.h=g,this.a=[],this.b=this.B(new W.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of R)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new fe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=_=>{(0,A.setTimeout0)(()=>{if(R)return;const g=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:t.runWhenIdle=(_,R)=>{const g=requestIdleCallback(_,typeof R=="number"?{timeout:R}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(g))}}}}();class ve{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(g){this.g=g}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=ve;async function pe(_,R,g){let C;for(let $=0;$<g;$++)try{return await _()}catch(Y){C=Y,await I(R)}throw C}t.retry=pe;class Me{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,g,C){return this.a={taskId:R,cancel:()=>C?.(),promise:g},g.then(()=>this.d(R),()=>this.d(R)),g}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let g,C;const $=new Promise((Y,F)=>{g=Y,C=F});this.b={run:R,promise:$,promiseResolve:g,promiseReject:C}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Me;class Re{constructor(R,g=()=>Date.now()){this.d=R,this.f=g,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}t.IntervalCounter=Re;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,g)=>{this.a=R,this.b=g})}complete(R){return new Promise(g=>{this.a(R),this.f=!0,g()})}error(R){return new Promise(g=>{this.b(R),this.d=!0,g()})}cancel(){new Promise(R=>{this.b(new M.CancellationError),this.d=!0,R()})}}t.DeferredPromise=le;var x;(function(_){async function R(C){let $;const Y=await Promise.all(C.map(F=>F.then(N=>N,N=>{$||($=N)})));if(typeof $<"u")throw $;return Y}_.settled=R;function g(C){return new Promise(async($,Y)=>{try{await C($,Y)}catch(F){Y(F)}})}_.withAsyncBody=g})(x=t.Promises||(t.Promises={}));var ne;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(ne||(ne={}));class te{static fromArray(R){return new te(g=>{g.emitMany(R)})}static fromPromise(R){return new te(async g=>{g.emitMany(await R)})}static fromPromises(R){return new te(async g=>{await Promise.all(R.map(async C=>g.emitOne(await C)))})}static merge(R){return new te(async g=>{await Promise.all(R.map(async C=>{for await(const $ of C)g.emitOne($)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new i.Emitter,queueMicrotask(async()=>{const g={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(R(g)),this.j()}catch(C){this.k(C)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(R,g){return new te(async C=>{for await(const $ of R)C.emitOne(g($))})}map(R){return te.map(this,R)}static filter(R,g){return new te(async C=>{for await(const $ of R)g($)&&C.emitOne($)})}filter(R){return te.filter(this,R)}static coalesce(R){return te.filter(R,g=>!!g)}coalesce(){return te.coalesce(this)}static async toPromise(R){const g=[];for await(const C of R)g.push(C);return g}toPromise(){return te.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}te.EMPTY=te.fromArray([]),t.AsyncIterableObject=te;class ie extends te{constructor(R,g){super(g),this.l=R}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=ie;function T(_){const R=new E.CancellationTokenSource,g=_(R.token);return new ie(R,async C=>{const $=R.token.onCancellationRequested(()=>{$.dispose(),R.dispose(),C.reject(new M.CancellationError)});try{for await(const Y of g){if(R.token.isCancellationRequested)return;C.emitOne(Y)}$.dispose(),R.dispose()}catch(Y){$.dispose(),R.dispose(),C.reject(Y)}})}t.createCancelableAsyncIterable=T}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function o(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=o;function n(X){return X?.isConnected??!1}t.isInDOM=n;class u{constructor(K,de,Fe,ke){this.f=K,this.g=de,this.d=Fe,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(X,K,de,Fe){return new u(X,K,de,Fe)}t.addDisposableListener=s;function w(X){return function(K){return X(new W.StandardMouseEvent(K))}}function D(X){return function(K){return X(new i.StandardKeyboardEvent(K))}}const S=function(K,de,Fe,ke){let je=Fe;return de==="click"||de==="mousedown"?je=w(Fe):(de==="keydown"||de==="keypress"||de==="keyup")&&(je=D(Fe)),s(K,de,je,ke)};t.addStandardDisposableListener=S;const f=function(K,de,Fe){const ke=w(de);return L(K,ke,Fe)};t.addStandardDisposableGenericMouseDownListener=f;const p=function(K,de,Fe){const ke=w(de);return y(K,ke,Fe)};t.addStandardDisposableGenericMouseUpListener=p;function L(X,K,de){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,K,de)}t.addDisposableGenericMouseDownListener=L;function I(X,K,de){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,K,de)}t.addDisposableGenericMouseMoveListener=I;function y(X,K,de){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,K,de)}t.addDisposableGenericMouseUpListener=y;class d{constructor(K,de=0){this.d=K,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,A.onUnexpectedError)(K)}}static sort(K,de){return de.priority-K.priority}}(function(){let X=[],K=null,de=!1,Fe=!1;const ke=()=>{for(de=!1,K=X,X=[],Fe=!0;K.length>0;)K.sort(d.sort),K.shift().execute();Fe=!1};t.scheduleAtNextAnimationFrame=(je,xe=0)=>{const Xe=new d(je,xe);return X.push(Xe),de||(de=!0,requestAnimationFrame(ke)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(je,xe)=>{if(Fe){const Xe=new d(je,xe);return K.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(je,xe)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function b(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=b;const O=8,q=function(X,K){return K};class Z extends c.Disposable{constructor(K,de,Fe,ke=q,je=O){super();let xe=null,Xe=0;const nt=this.B(new v.TimeoutTimer),Ye=()=>{Xe=new Date().getTime(),Fe(xe),xe=null};this.B(s(K,de,pt=>{xe=ke(xe,pt);const Et=new Date().getTime()-Xe;Et>=je?(nt.cancel(),Ye()):nt.setIfNotSet(Ye,je-Et)}))}}function se(X,K,de,Fe,ke){return new Z(X,K,de,Fe,ke)}t.addDisposableThrottledListener=se;function ae(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=ae;function fe(X){if(X!==document.body)return new Q(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new Q(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new Q(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new Q(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new Q(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=fe;class ue{static d(K,de){return parseFloat(de)||0}static f(K,de,Fe){const ke=ae(K),je=ke?ke.getPropertyValue(de):"0";return ue.d(K,je)}static getBorderLeftWidth(K){return ue.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return ue.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return ue.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return ue.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return ue.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return ue.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return ue.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return ue.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return ue.f(K,"margin-left","marginLeft")}static getMarginTop(K){return ue.f(K,"margin-top","marginTop")}static getMarginRight(K){return ue.f(K,"margin-right","marginRight")}static getMarginBottom(K){return ue.f(K,"margin-bottom","marginBottom")}}class Q{constructor(K,de){this.width=K,this.height=de}with(K=this.width,de=this.height){return K!==this.width||de!==this.height?new Q(K,de):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof Q?K:new Q(K.width,K.height)}static equals(K,de){return K===de?!0:!K||!de?!1:K.width===de.width&&K.height===de.height}}Q.None=new Q(0,0),t.Dimension=Q;function J(X){let K=X.offsetParent,de=X.offsetTop,Fe=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){de-=X.scrollTop;const ke=B(X)?null:ae(X);ke&&(Fe-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===K&&(Fe+=ue.getBorderLeftWidth(X),de+=ue.getBorderTopWidth(X),de+=X.offsetTop,Fe+=X.offsetLeft,K=X.offsetParent)}return{left:Fe,top:de}}t.getTopLeftOffset=J;function ve(X,K,de){typeof K=="number"&&(X.style.width=`${K}px`),typeof de=="number"&&(X.style.height=`${de}px`)}t.size=ve;function pe(X,K,de,Fe,ke,je="absolute"){typeof K=="number"&&(X.style.top=`${K}px`),typeof de=="number"&&(X.style.right=`${de}px`),typeof Fe=="number"&&(X.style.bottom=`${Fe}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=je}t.position=pe;function Me(X){const K=X.getBoundingClientRect();return{left:K.left+window.scrollX,top:K.top+window.scrollY,width:K.width,height:K.height}}t.getDomNodePagePosition=Me;function Re(X){let K=X,de=1;do{const Fe=ae(K).zoom;Fe!=null&&Fe!=="1"&&(de*=Fe),K=K.parentElement}while(K!==null&&K!==document.documentElement);return de}t.getDomNodeZoomLevel=Re;function le(X){const K=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.offsetWidth+K}t.getTotalWidth=le;function x(X){const K=ue.getBorderLeftWidth(X)+ue.getBorderRightWidth(X),de=ue.getPaddingLeft(X)+ue.getPaddingRight(X);return X.offsetWidth-K-de}t.getContentWidth=x;function ne(X){const K=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.scrollWidth+K}t.getTotalScrollWidth=ne;function te(X){const K=ue.getBorderTopWidth(X)+ue.getBorderBottomWidth(X),de=ue.getPaddingTop(X)+ue.getPaddingBottom(X);return X.offsetHeight-K-de}t.getContentHeight=te;function ie(X){const K=ue.getMarginTop(X)+ue.getMarginBottom(X);return X.offsetHeight+K}t.getTotalHeight=ie;function T(X,K){if(X===null)return 0;const de=J(X),Fe=J(K);return de.left-Fe.left}function _(X,K){const de=K.map(ke=>Math.max(ne(ke),le(ke))+T(ke,X)||0);return Math.max(...de)}t.getLargestChildWidth=_;function R(X,K){for(;X;){if(X===K)return!0;X=X.parentNode}return!1}t.isAncestor=R;const g="parentFlowToElementId";function C(X,K){X.dataset[g]=K.id}t.setParentFlowTo=C;function $(X){const K=X.dataset[g];return typeof K=="string"?document.getElementById(K):null}function Y(X,K){let de=X;for(;de;){if(de===K)return!0;if(de instanceof HTMLElement){const Fe=$(de);if(Fe){de=Fe;continue}}de=de.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function F(X,K,de){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(K))return X;if(de){if(typeof de=="string"){if(X.classList.contains(de))return null}else if(X===de)return null}X=X.parentNode}return null}t.findParentWithClass=F;function N(X,K,de){return!!F(X,K,de)}t.hasParentWithClass=N;function B(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=B;function k(X){return!!H(X)}t.isInShadowDOM=k;function H(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return B(X)?X:null}t.getShadowRoot=H;function z(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=z;function U(X=document.getElementsByTagName("head")[0],K){const de=document.createElement("style");return de.type="text/css",de.media="screen",K?.(de),X.appendChild(de),de}t.createStyleSheet=U;function j(X=document.getElementsByTagName("head")[0]){const K=document.createElement("meta");return X.appendChild(K),K}t.createMetaElement=j;let G=null;function re(){return G||(G=U()),G}function he(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function De(X,K,de=re()){!de||!K||de.sheet.insertRule(X+"{"+K+"}",0)}t.createCSSRule=De;function ye(X,K=re()){if(!K)return;const de=he(K),Fe=[];for(let ke=0;ke<de.length;ke++)de[ke].selectorText.indexOf(X)!==-1&&Fe.push(ke);for(let ke=Fe.length-1;ke>=0;ke--)K.sheet.deleteRule(Fe[ke])}t.removeCSSRulesContainingSelector=ye;function Le(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ce(X){const K=X;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.isEventLike=Ce,t.EventHelper={stop:(X,K)=>(X.preventDefault(),K&&X.stopPropagation(),X)};function we(X){const K=[];for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)K[de]=X.scrollTop,X=X.parentNode;return K}t.saveParentsScrollTop=we;function Pe(X,K){for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)X.scrollTop!==K[de]&&(X.scrollTop=K[de]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ie extends c.Disposable{static l(K){const de=H(K),Fe=de?de.activeElement:document.activeElement;return R(Fe,K)}constructor(K){super(),this.f=this.B(new h.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new h.Emitter),this.onDidBlur=this.g.event;let de=Ie.l(K),Fe=!1;const ke=()=>{Fe=!1,de||(de=!0,this.f.fire())},je=()=>{de&&(Fe=!0,window.setTimeout(()=>{Fe&&(Fe=!1,de=!1,this.g.fire())},0))};this.j=()=>{Ie.l(K)!==de&&(de?je():ke())},this.B(s(K,t.EventType.FOCUS,ke,!0)),this.B(s(K,t.EventType.BLUR,je,!0)),this.B(s(K,t.EventType.FOCUS_IN,()=>this.j())),this.B(s(K,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Ve(X){return new Ie(X)}t.trackFocus=Ve;function He(X,K){return X.after(K),K}t.after=He;function Ue(X,...K){if(X.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}t.append=Ue;function Ze(X,K){return X.insertBefore(K,X.firstChild),K}t.prepend=Ze;function Ge(X,...K){X.innerText="",Ue(X,...K)}t.reset=Ge;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var V;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(V=t.Namespace||(t.Namespace={}));function oe(X,K,de,...Fe){const ke=Be.exec(K);if(!ke)throw new Error("Bad use of emmet");const je=ke[1]||"div";let xe;return X!==V.HTML?xe=document.createElementNS(X,je):xe=document.createElement(je),ke[3]&&(xe.id=ke[3]),ke[4]&&(xe.className=ke[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Xe,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Xe)?xe[Xe]=nt:Xe==="selected"?nt&&xe.setAttribute(Xe,"true"):xe.setAttribute(Xe,nt))}),xe.append(...Fe),xe}function be(X,K,...de){return oe(V.HTML,X,K,...de)}t.$=be,be.SVG=function(X,K,...de){return oe(V.SVG,X,K,...de)};function Ee(X,K){const de=[];return X.forEach((Fe,ke)=>{ke>0&&(K instanceof Node?de.push(K.cloneNode()):de.push(document.createTextNode(K))),de.push(Fe)}),de}t.join=Ee;function Se(X,...K){X?Oe(...K):We(...K)}t.setVisibility=Se;function Oe(...X){for(const K of X)K.style.display="",K.removeAttribute("aria-hidden")}t.show=Oe;function We(...X){for(const K of X)K.style.display="none",K.setAttribute("aria-hidden","true")}t.hide=We;function tt(X,K){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(K))return X;X=X.parentNode}return null}function Ke(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&tt(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ke;function _e(X){return K=>{K.preventDefault(),K.stopPropagation(),X(K)}}t.finalHandler=_e;function Te(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=Te;function ce(X){const K=window.devicePixelRatio*X;return Math.max(1,Math.floor(K))/window.devicePixelRatio}t.computeScreenAwareSize=ce;function Ae(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=Ae;const Ne=780,$e=640;function Qe(X){const K=Math.floor(window.screenLeft+window.innerWidth/2-Ne/2),de=Math.floor(window.screenTop+window.innerHeight/2-$e/2);window.open(X,"_blank",`width=${Ne},height=${$e},top=${de},left=${K}`)}t.windowOpenPopup=Qe;function Je(X,K=!0){const de=window.open();return de?(K&&(de.opener=null),de.location.href=X,!0):!1}t.windowOpenWithSuccess=Je;function et(X){const K=()=>{X(),de=(0,t.scheduleAtNextAnimationFrame)(K)};let de=(0,t.scheduleAtNextAnimationFrame)(K);return(0,c.toDisposable)(()=>de.dispose())}t.animate=et,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(X){return X?`url('${P.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function bt(X,K){if(X!==void 0){const de=X.match(/^\s*var\((.+)\)$/);if(de){const Fe=de[1].split(",",2);return Fe.length===2&&(K=bt(Fe[1].trim(),K)),`var(${Fe[0]}, ${K})`}return X}return K}t.asCssValueWithDefault=bt;function Tt(X,K){let de;if(e.URI.isUri(X))de=X.toString(!0);else{const ke=new Blob([X]);de=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(de))}const Fe=document.createElement("a");document.body.appendChild(Fe),Fe.download=K,Fe.href=de,Fe.click(),setTimeout(()=>document.body.removeChild(Fe))}t.triggerDownload=Tt;function Wt(){return new Promise(X=>{const K=document.createElement("input");document.body.appendChild(K),K.type="file",K.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(K,"input"))(()=>{X((0,l.withNullAsUndefined)(K.files))}),K.click(),setTimeout(()=>document.body.removeChild(K))})}t.triggerUpload=Wt;var yt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(yt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function $t(X,K=!1){const de=document.createElement("a");return a.addHook("afterSanitizeAttributes",Fe=>{for(const ke of["href","src"])if(Fe.hasAttribute(ke)){const je=Fe.getAttribute(ke);if(ke==="href"&&je.startsWith("#"))continue;if(de.href=je,!X.includes(de.protocol.replace(/:$/,""))){if(K&&ke==="src"&&de.href.startsWith("data:"))continue;Fe.removeAttribute(ke)}}}),(0,c.toDisposable)(()=>{a.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=$t;const fi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(X,K){const de=$t(fi);try{const Fe=a.sanitize(K,gi);X.innerHTML=Fe}finally{de.dispose()}}t.safeInnerHtml=mi;function bi(X){const K=new Uint16Array(X.length);for(let ke=0;ke<K.length;ke++)K[ke]=X.charCodeAt(ke);let de="";const Fe=new Uint8Array(K.buffer);for(let ke=0;ke<Fe.length;ke++)de+=String.fromCharCode(Fe[ke]);return de}function pi(X){return btoa(bi(X))}t.multibyteAwareBtoa=pi;class ft extends h.Emitter{constructor(){super(),this.s=new c.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(s(window,"keydown",K=>{if(K.defaultPrevented)return;const de=new i.StandardKeyboardEvent(K);if(!(de.keyCode===6&&K.repeat)){if(K.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(K.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(K.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(K.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(de.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyPressed&&(this.t.event=K,this.fire(this.t))}},!0)),this.s.add(s(window,"keyup",K=>{K.defaultPrevented||(!K.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!K.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!K.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!K.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyReleased&&(this.t.event=K,this.fire(this.t)))},!0)),this.s.add(s(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mousemove",K=>{K.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function vi(X){const K=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}t.getCookieValue=vi;class wi extends c.Disposable{constructor(K,de){super(),this.j=K,this.l=de,this.f=0,this.g=0,this.m()}m(){this.B(s(this.j,t.EventType.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.l.onDragEnter(K)})),this.B(s(this.j,t.EventType.DRAG_OVER,K=>{K.preventDefault(),this.l.onDragOver?.(K,K.timeStamp-this.g)})),this.B(s(this.j,t.EventType.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(K))})),this.B(s(this.j,t.EventType.DRAG_END,K=>{this.f=0,this.g=0,this.l.onDragEnd(K)})),this.B(s(this.j,t.EventType.DROP,K=>{this.f=0,this.g=0,this.l.onDrop(K)}))}}t.DragAndDropObserver=wi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(X,...K){let de,Fe;Array.isArray(K[0])?(de={},Fe=K[0]):(de=K[0]||{},Fe=K[1]);const ke=Di.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const je=ke.groups.tag||"div",xe=document.createElement(je);ke.groups.id&&(xe.id=ke.groups.id);const Xe=[];if(ke.groups.class)for(const Ye of ke.groups.class.split("."))Ye!==""&&Xe.push(Ye);if(de.className!==void 0)for(const Ye of de.className.split("."))Ye!==""&&Xe.push(Ye);Xe.length>0&&(xe.className=Xe.join(" "));const nt={};if(ke.groups.name&&(nt[ke.groups.name]=xe),Fe)for(const Ye of Fe)Ye instanceof HTMLElement?xe.appendChild(Ye):typeof Ye=="string"?xe.append(Ye):(Object.assign(nt,Ye),xe.appendChild(Ye.root));for(const[Ye,pt]of Object.entries(de))if(Ye!=="className")if(Ye==="style")for(const[Et,Lt]of Object.entries(pt))xe.style.setProperty(xt(Et),typeof Lt=="number"?Lt+"px":""+Lt);else Ye==="tabIndex"?xe.tabIndex=pt:xe.setAttribute(xt(Ye),pt.toString());return nt.root=xe,nt}t.h=yi;function xt(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends M.Disposable{constructor(h,a){super(),this.B((0,E.addDisposableListener)(h,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{a(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.B((0,E.addDisposableListener)(h,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text};function v(A,h,a,c,P){const r=document.createElement("div");r.className=a,r.textContent=h,P&&(r.style.color=P),c&&(r.style.background=c),A.dataTransfer&&(document.body.appendChild(r),A.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=v}),define(ge[52],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function M(r,l={}){const e=W(l);return e.textContent=r,e}t.renderText=M;function i(r,l={}){const e=W(l);return h(e,a(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.createElement=W;class v{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(A||(A={}));function h(r,l,e,o){let n;if(l.type===2)n=document.createTextNode(l.content||"");else if(l.type===3)n=document.createElement("b");else if(l.type===4)n=document.createElement("i");else if(l.type===7&&o)n=document.createElement("code");else if(l.type===5&&e){const u=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(u,"click",s=>{e.callback(String(l.index),s)})),n=u}else l.type===8?n=document.createElement("br"):l.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(l.children)&&l.children.forEach(u=>{h(n,u,e,o)})}function a(r,l){const e={type:1,children:[]};let o=0,n=e;const u=[],s=new v(r);for(;!s.eos();){let w=s.next();const D=w==="\\"&&P(s.peek(),l)!==0;if(D&&(w=s.next()),!D&&c(w,l)&&w===s.peek()){s.advance(),n.type===2&&(n=u.pop());const S=P(w,l);if(n.type===S||n.type===5&&S===6)n=u.pop();else{const f={type:S,children:[]};S===5&&(f.index=o,o++),n.children.push(f),u.push(n),n=f}}else if(w===`
`)n.type===2&&(n=u.pop()),n.children.push({type:8});else if(n.type!==2){const S={type:2,content:w};n.children.push(S),u.push(n),n=S}else n.content+=w}return n.type===2&&(n=u.pop()),u.length,e}function c(r,l){return P(r,l)!==0}function P(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this.a=new M.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(v,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,v&&h&&h(A)}isMonitoring(){return!!this.b}startMonitoring(v,A,h,a,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=a,this.c=c;let P=v;try{v.setPointerCapture(A),this.a.add((0,M.toDisposable)(()=>{try{v.releasePointerCapture(A)}catch{}}))}catch{P=window}this.a.add(E.addDisposableListener(P,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==h){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(E.addDisposableListener(P,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(ee,t,E,M){var i=arguments.length,W=i<3?t:M===null?M=Object.getOwnPropertyDescriptor(t,E):M,v;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(ee,t,E,M);else for(var A=ee.length-1;A>=0;A--)(v=ee[A])&&(W=(i<3?v(W):i>3?v(t,E,W):v(t,E))||W);return i>3&&W&&Object.defineProperty(t,E,W),W};define(ge[23],me([1,0,4,13,25,2,43]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var A;(function(a){a.Tap="-monaco-gesturetap",a.Change="-monaco-gesturechange",a.Start="-monaco-gesturestart",a.End="-monaco-gesturesend",a.Contextmenu="-monaco-gesturecontextmenu"})(A=t.EventType||(t.EventType={}));class h extends W.Disposable{constructor(){super(),this.f=!1,this.g=new v.LinkedList,this.h=new v.LinkedList,this.k={},this.j=null,this.l=0,this.B(E.addDisposableListener(document,"touchstart",c=>this.n(c),{passive:!1})),this.B(E.addDisposableListener(document,"touchend",c=>this.p(c))),this.B(E.addDisposableListener(document,"touchmove",c=>this.v(c),{passive:!1}))}static addTarget(c){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const P=h.b.g.push(c);return(0,W.toDisposable)(P)}static ignoreTarget(c){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const P=h.b.h.push(c);return(0,W.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(c){const P=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,l=c.targetTouches.length;r<l;r++){const e=c.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const o=this.r(A.Start,e.target);o.pageX=e.pageX,o.pageY=e.pageY,this.s(o)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}p(c){const P=Date.now(),r=Object.keys(this.k).length;for(let l=0,e=c.changedTouches.length;l<e;l++){const o=c.changedTouches.item(l);if(!this.k.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const n=this.k[o.identifier],u=Date.now()-n.initialTimeStamp;if(u<h.c&&Math.abs(n.initialPageX-M.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-M.tail(n.rollingPageY))<30){const s=this.r(A.Tap,n.initialTarget);s.pageX=M.tail(n.rollingPageX),s.pageY=M.tail(n.rollingPageY),this.s(s)}else if(u>=h.c&&Math.abs(n.initialPageX-M.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-M.tail(n.rollingPageY))<30){const s=this.r(A.Contextmenu,n.initialTarget);s.pageX=M.tail(n.rollingPageX),s.pageY=M.tail(n.rollingPageY),this.s(s)}else if(r===1){const s=M.tail(n.rollingPageX),w=M.tail(n.rollingPageY),D=M.tail(n.rollingTimestamps)-n.rollingTimestamps[0],S=s-n.rollingPageX[0],f=w-n.rollingPageY[0],p=[...this.g].filter(L=>n.initialTarget instanceof Node&&L.contains(n.initialTarget));this.u(p,P,Math.abs(S)/D,S>0?1:-1,s,Math.abs(f)/D,f>0?1:-1,w)}this.s(this.r(A.End,n.initialTarget)),delete this.k[o.identifier]}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}r(c,P){const r=document.createEvent("CustomEvent");return r.initEvent(c,!1,!0),r.initialTarget=P,r.tapCount=0,r}s(c){if(c.type===A.Tap){const P=new Date().getTime();let r=0;P-this.l>h.m?r=1:r=2,this.l=P,c.tapCount=r}else(c.type===A.Change||c.type===A.Contextmenu)&&(this.l=0);if(c.initialTarget instanceof Node){for(const P of this.h)if(P.contains(c.initialTarget))return;for(const P of this.g)P.contains(c.initialTarget)&&(P.dispatchEvent(c),this.f=!0)}}u(c,P,r,l,e,o,n,u){this.j=E.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),w=s-P;let D=0,S=0,f=!0;r+=h.a*w,o+=h.a*w,r>0&&(f=!1,D=l*r*w),o>0&&(f=!1,S=n*o*w);const p=this.r(A.Change);p.translationX=D,p.translationY=S,c.forEach(L=>L.dispatchEvent(p)),f||this.u(c,s,r,l,e+D,o,n,u+S)})}v(c){const P=Date.now();for(let r=0,l=c.changedTouches.length;r<l;r++){const e=c.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const o=this.k[e.identifier],n=this.r(A.Change,o.initialTarget);n.translationX=e.pageX-M.tail(o.rollingPageX),n.translationY=e.pageY-M.tail(o.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.s(n),o.rollingPageX.length>3&&(o.rollingPageX.shift(),o.rollingPageY.shift(),o.rollingTimestamps.shift()),o.rollingPageX.push(e.pageX),o.rollingPageY.push(e.pageY),o.rollingTimestamps.push(P)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}h.a=-.005,h.c=700,h.m=400,qe([i.memoize],h,"isTouchDevice",null),t.Gesture=h}),define(ge[54],me([1,0,4,5,83]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let W,v,A,h,a;function c(e){W=document.createElement("div"),W.className="monaco-aria-container";const o=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),W.appendChild(u),u};v=o(),A=o();const n=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("role","complementary"),u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),W.appendChild(u),u};h=n(),a=n(),e.appendChild(W)}t.setARIAContainer=c;function P(e){!W||(v.textContent!==e?(E.clearNode(A),l(v,e)):(E.clearNode(v),l(A,e)))}t.alert=P;function r(e){!W||(M.isMacintosh?P(e):h.textContent!==e?(E.clearNode(a),l(h,e)):(E.clearNode(h),l(a,e)))}t.status=r;function l(e,o){E.clearNode(e),o.length>i&&(o=o.substr(0,i)),e.textContent=o,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(A){const h=new Array;let a,c=0,P=0;for(;(a=i.exec(A))!==null;){P=a.index||0,c<P&&h.push(A.substring(c,P)),c=(a.index||0)+a[0].length;const[,r,l]=a;h.push(r?`$(${l})`:v({id:l}))}return c<A.length&&h.push(A.substring(c)),h}t.renderLabelWithIcons=W;function v(A){const h=E.$("span");return h.classList.add(...M.ThemeIcon.asClassNameArray(A)),h}t.renderIcon=v}),define(ge[116],me([1,0,4]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function M(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(v){this.d=v,this.a=new Map,this.b=new Set,this.c=!1}alloc(v){let A=this.h(v).pop(),h=!1;if(A)h=this.b.has(A.domNode),h&&this.b.delete(A.domNode);else{const a=(0,E.$)(".monaco-list-row"),P=this.i(v).renderTemplate(a);A={domNode:a,templateId:v,templateData:P}}return{row:A,isReusingConnectedDomNode:h}}release(v){!v||this.f(v)}transact(v){if(this.c)throw new Error("Already in transaction");this.c=!0;try{v()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(v){const{domNode:A,templateId:h}=v;A&&(this.c?this.b.add(A):this.g(A)),this.h(h).push(v)}g(v){v.classList.remove("scrolling"),M(v)}h(v){let A=this.a.get(v);return A||(A=[],this.a.set(v,A)),A}dispose(){this.a.forEach((v,A)=>{for(const h of v)this.i(A).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(v){const A=this.d.get(v);if(!A)throw new Error(`No renderer found for ${v}`);return A}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends M.Disposable{constructor(v,A,h){super(),this.a=v,this.b=A,this.c=h,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new E.TimeoutTimer)}setVisibility(v){this.a!==v&&(this.a=v,this.m())}setShouldBeVisible(v){this.g=v,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const v=this.l();this.h!==v&&(this.h=v,this.ensureVisibility())}setIsNeeded(v){this.i!==v&&(this.i=v,this.ensureVisibility())}setDomNode(v){this.f=v,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(v){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(v?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(ee,t,E,M,i,W,v,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class h extends v.Disposable{constructor(c,P,r,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.Emitter),this.h=r,this.i(),this.setOptions(c,P)}i(){this.B(M.Gesture.addTarget(this.a)),[M.EventType.Tap].forEach(c=>{this.B(E.addDisposableListener(this.a,c,P=>{this.a.focus()}))}),this.B(E.addStandardDisposableListener(this.a,"click",c=>{E.EventHelper.stop(c,!0)})),this.B(E.addStandardDisposableListener(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.B(E.addStandardDisposableListener(this.a,"keydown",c=>{let P=!1;A.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(P=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(P=!0),P&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,P){(!this.c||!i.equals(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((r,l)=>{this.a.add(this.j(r.text,l,r.isDisabled))})),P!==void 0&&this.select(P)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(c,P,r){const l=document.createElement("option");return l.value=c,l.text=c,l.disabled=!!r,l}}t.SelectBoxNative=h}),define(ge[55],me([1,0,24,13,9,46,112,3,26]),function(ee,t,E,M,i,W,v,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function a(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=a;function c(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=c;function P(l){return typeof l.collapsible=="boolean"}class r{constructor(e,o,n,u={}){this.o=e,this.p=o,this.rootRef=[],this.d=new A.EventBufferer,this.f=new A.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.Emitter,this.onDidSplice=this.l.event,this.m=new i.Delayer(W.MicrotaskDelay),this.h=typeof u.collapseByDefault>"u"?!1:u.collapseByDefault,this.j=u.filter,this.k=typeof u.autoExpandSingleChildren>"u"?!1:u.autoExpandSingleChildren,this.c={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,o,n=h.Iterable.empty(),u={}){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");u.diffIdentityProvider?this.q(u.diffIdentityProvider,e,o,n,u):this.s(e,o,n,u)}q(e,o,n,u=h.Iterable.empty(),s,w=s.diffDepth??0){const{parentNode:D}=this.G(o);if(!D.lastDiffIds)return this.s(o,n,u,s);const S=[...u],f=o[o.length-1],p=new v.LcsDiff({getElements:()=>D.lastDiffIds},{getElements:()=>[...D.children.slice(0,f),...S,...D.children.slice(f+n)].map(m=>e.getId(m.element).toString())}).ComputeDiff(!1);if(p.quitEarly)return D.lastDiffIds=void 0,this.s(o,n,S,s);const L=o.slice(0,-1),I=(m,b,O)=>{if(w>0)for(let q=0;q<O;q++)m--,b--,this.q(e,[...L,m,0],Number.MAX_SAFE_INTEGER,S[b].children,s,w-1)};let y=Math.min(D.children.length,f+n),d=S.length;for(const m of p.changes.sort((b,O)=>O.originalStart-b.originalStart))I(y,d,y-(m.originalStart+m.originalLength)),y=m.originalStart,d=m.modifiedStart-f,this.s([...L,y],m.originalLength,h.Iterable.slice(S,d,d+m.modifiedLength),s);I(y,d,y)}s(e,o,n=h.Iterable.empty(),{onDidCreateNode:u,onDidDeleteNode:s,diffIdentityProvider:w}){const{parentNode:D,listIndex:S,revealed:f,visible:p}=this.G(e),L=[],I=h.Iterable.map(n,ue=>this.w(ue,D,D.visible?1:0,f,L,u)),y=e[e.length-1],d=D.children.length>0;let m=0;for(let ue=y;ue>=0&&ue<D.children.length;ue--){const Q=D.children[ue];if(Q.visible){m=Q.visibleChildIndex;break}}const b=[];let O=0,q=0;for(const ue of I)b.push(ue),q+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=m+O++);const Z=(0,M.splice)(D.children,y,o,b);w?D.lastDiffIds?(0,M.splice)(D.lastDiffIds,y,o,b.map(ue=>w.getId(ue.element).toString())):D.lastDiffIds=D.children.map(ue=>w.getId(ue.element).toString()):D.lastDiffIds=void 0;let se=0;for(const ue of Z)ue.visible&&se++;if(se!==0)for(let ue=y+b.length;ue<D.children.length;ue++){const Q=D.children[ue];Q.visible&&(Q.visibleChildIndex-=se)}if(D.visibleChildrenCount+=O-se,f&&p){const ue=Z.reduce((Q,J)=>Q+(J.visible?J.renderNodeCount:0),0);this.B(D,q-ue),this.p.splice(S,ue,L)}if(Z.length>0&&s){const ue=Q=>{s(Q),Q.children.forEach(ue)};Z.forEach(ue)}this.l.fire({insertedNodes:b,deletedNodes:Z});const ae=D.children.length>0;d!==ae&&this.setCollapsible(e.slice(0,-1),ae);let fe=D;for(;fe;){if(fe.visibility===2){this.m.trigger(()=>this.refilter());break}fe=fe.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{node:o,listIndex:n,revealed:u}=this.F(e);o.visible&&u&&this.p.splice(n,1,[o])}updateElementHeight(e,o){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{listIndex:n}=this.F(e);this.p.updateElementHeight(n,o)}has(e){return this.D(e)}getListIndex(e){const{listIndex:o,visible:n,revealed:u}=this.F(e);return n&&u?o:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,o){const n=this.E(e);typeof o>"u"&&(o=!n.collapsible);const u={collapsible:o};return this.d.bufferEvents(()=>this.t(e,u))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,o,n){const u=this.E(e);typeof o>"u"&&(o=!u.collapsed);const s={collapsed:o,recursive:n||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,o){const{node:n,listIndex:u,revealed:s}=this.F(e),w=this.u(n,u,s,o);if(n!==this.c&&this.k&&w&&!P(o)&&n.collapsible&&!n.collapsed&&!o.recursive){let D=-1;for(let S=0;S<n.children.length;S++)if(n.children[S].visible)if(D>-1){D=-1;break}else D=S;D>-1&&this.t([...e,D],o)}return w}u(e,o,n,u){const s=this.v(e,u,!1);if(!n||!e.visible||!s)return s;const w=e.renderNodeCount,D=this.x(e),S=w-(o===-1?0:1);return this.p.splice(o+1,S,D.slice(1)),s}v(e,o,n){let u;if(e===this.c?u=!1:(P(o)?(u=e.collapsible!==o.collapsible,e.collapsible=o.collapsible):e.collapsible?(u=e.collapsed!==o.collapsed,e.collapsed=o.collapsed):u=!1,u&&this.f.fire({node:e,deep:n})),!P(o)&&o.recursive)for(const s of e.children)u=this.v(s,o,!0)||u;return u}expandTo(e){this.d.bufferEvents(()=>{let o=this.E(e);for(;o.parent;)o=o.parent,e=e.slice(0,e.length-1),o.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,o=this.z(this.c);this.p.splice(0,e,o),this.m.cancel()}w(e,o,n,u,s,w){const D={parent:o,element:e.element,children:[],depth:o.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this.C(D,n);D.visibility=S,u&&s.push(D);const f=e.children||h.Iterable.empty(),p=u&&S!==0&&!D.collapsed;let L=0,I=1;for(const y of f){const d=this.w(y,D,S,p,s,w);D.children.push(d),I+=d.renderNodeCount,d.visible&&(d.visibleChildIndex=L++)}return D.collapsible=D.collapsible||D.children.length>0,D.visibleChildrenCount=L,D.visible=S===2?L>0:S===1,D.visible?D.collapsed||(D.renderNodeCount=I):(D.renderNodeCount=0,u&&s.pop()),w?.(D),D}x(e){const o=e.renderNodeCount,n=[];return this.y(e,n),this.B(e.parent,n.length-o),n}y(e,o){if(e.visible===!1)return 0;if(o.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this.y(n,o);return this.g.fire(e),e.renderNodeCount}z(e){const o=e.renderNodeCount,n=[];return this.A(e,e.visible?1:0,n),this.B(e.parent,n.length-o),n}A(e,o,n,u=!0){let s;if(e!==this.c){if(s=this.C(e,o),s===0)return e.visible=!1,e.renderNodeCount=0,!1;u&&n.push(e)}const w=n.length;e.renderNodeCount=e===this.c?0:1;let D=!1;if(!e.collapsed||s!==0){let S=0;for(const f of e.children)D=this.A(f,s,n,u&&!e.collapsed)||D,f.visible&&(f.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?D:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-w):(e.renderNodeCount=0,u&&n.pop()),this.g.fire(e),e.visible}B(e,o){if(o!==0)for(;e;)e.renderNodeCount+=o,this.g.fire(e),e=e.parent}C(e,o){const n=this.j?this.j.filter(e.element,o):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):a(n)?(e.filterData=n.data,c(n.visibility)):(e.filterData=void 0,c(n))}D(e,o=this.c){if(!e||e.length===0)return!0;const[n,...u]=e;return n<0||n>o.children.length?!1:this.D(u,o.children[n])}E(e,o=this.c){if(!e||e.length===0)return o;const[n,...u]=e;if(n<0||n>o.children.length)throw new E.TreeError(this.o,"Invalid tree location");return this.E(u,o.children[n])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:o,listIndex:n,revealed:u,visible:s}=this.G(e),w=e[e.length-1];if(w<0||w>o.children.length)throw new E.TreeError(this.o,"Invalid tree location");const D=o.children[w];return{node:D,listIndex:n,revealed:u,visible:s&&D.visible}}G(e,o=this.c,n=0,u=!0,s=!0){const[w,...D]=e;if(w<0||w>o.children.length)throw new E.TreeError(this.o,"Invalid tree location");for(let S=0;S<w;S++)n+=o.children[S].renderNodeCount;return u=u&&!o.collapsed,s=s&&o.visible,D.length===0?{parentNode:o,listIndex:n,revealed:u,visible:s}:this.G(D,o.children[w],n+1,u,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const o=[];let n=e;for(;n.parent;)o.push(n.parent.children.indexOf(n)),n=n.parent;return o.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,M.tail2)(e)[0]}getFirstElementChild(e){const o=this.E(e);if(o.children.length!==0)return o.children[0].element}getLastElementAncestor(e=[]){const o=this.E(e);if(o.children.length!==0)return this.H(o)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,55,24,26]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.d.size}constructor(A,h,a={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.IndexTreeModel(A,h,null,a),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,a.sorter&&(this.j={compare(c,P){return a.sorter.compare(c.element,P.element)}}),this.h=a.identityProvider}setChildren(A,h=i.Iterable.empty(),a={}){const c=this.o(A);this.l(c,this.m(h),a)}l(A,h=i.Iterable.empty(),a){const c=new Set,P=new Set,r=e=>{if(e.element===null)return;const o=e;if(c.add(o.element),this.d.set(o.element,o),this.h){const n=this.h.getId(o.element).toString();P.add(n),this.f.set(n,o)}a.onDidCreateNode?.(o)},l=e=>{if(e.element===null)return;const o=e;if(c.has(o.element)||this.d.delete(o.element),this.h){const n=this.h.getId(o.element).toString();P.has(n)||this.f.delete(n)}a.onDidDeleteNode?.(o)};this.c.splice([...A,0],Number.MAX_VALUE,h,{...a,onDidCreateNode:r,onDidDeleteNode:l})}m(A=i.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),i.Iterable.map(A,h=>{let a=this.d.get(h.element);if(!a&&this.h){const r=this.h.getId(h.element).toString();a=this.f.get(r)}if(!a){let r;return typeof h.collapsed>"u"?r=void 0:h.collapsed===M.ObjectTreeElementCollapseState.Collapsed||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:h.collapsed===M.ObjectTreeElementCollapseState.Expanded||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=Boolean(h.collapsed),{...h,children:this.m(h.children),collapsed:r}}const c=typeof h.collapsible=="boolean"?h.collapsible:a.collapsible;let P;return typeof h.collapsed>"u"||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrExpanded?P=a.collapsed:h.collapsed===M.ObjectTreeElementCollapseState.Collapsed?P=!0:h.collapsed===M.ObjectTreeElementCollapseState.Expanded?P=!1:P=Boolean(h.collapsed),{...h,collapsible:c,collapsed:P,children:this.m(h.children)}})}rerender(A){const h=this.o(A);this.c.rerender(h)}updateElementHeight(A,h){const a=this.o(A);this.c.updateElementHeight(a,h)}resort(A=null,h=!0){if(!this.j)return;const a=this.o(A),c=this.c.getNode(a);this.l(a,this.n(c,h),{})}n(A,h,a=!0){let c=[...A.children];return(h||a)&&(c=c.sort(this.j.compare.bind(this.j))),i.Iterable.map(c,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,h,!1)}))}getFirstElementChild(A=null){const h=this.o(A);return this.c.getFirstElementChild(h)}getLastElementAncestor(A=null){const h=this.o(A);return this.c.getLastElementAncestor(h)}has(A){return this.d.has(A)}getListIndex(A){const h=this.o(A);return this.c.getListIndex(h)}getListRenderCount(A){const h=this.o(A);return this.c.getListRenderCount(h)}isCollapsible(A){const h=this.o(A);return this.c.isCollapsible(h)}setCollapsible(A,h){const a=this.o(A);return this.c.setCollapsible(a,h)}isCollapsed(A){const h=this.o(A);return this.c.isCollapsed(h)}setCollapsed(A,h,a){const c=this.o(A);return this.c.setCollapsed(c,h,a)}expandTo(A){const h=this.o(A);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);return h}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new M.TreeError(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);const a=this.c.getNodeLocation(h),c=this.c.getParentNodeLocation(a);return this.c.getNode(c).element}o(A){if(A===null)return[];const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(h)}}t.ObjectTreeModel=W}),define(ge[19],me([1,0,4,14,21,23,2]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class A extends v.Disposable{f(a,c){this.B(E.addDisposableListener(a,E.EventType.CLICK,P=>c(new i.StandardMouseEvent(P))))}j(a,c){this.B(E.addDisposableListener(a,E.EventType.MOUSE_DOWN,P=>c(new i.StandardMouseEvent(P))))}k(a,c){this.B(E.addDisposableListener(a,E.EventType.MOUSE_OVER,P=>c(new i.StandardMouseEvent(P))))}m(a,c){this.B(E.addDisposableListener(a,E.EventType.MOUSE_LEAVE,P=>c(new i.StandardMouseEvent(P))))}p(a,c){this.B(E.addDisposableListener(a,E.EventType.KEY_DOWN,P=>c(new M.StandardKeyboardEvent(P))))}u(a,c){this.B(E.addDisposableListener(a,E.EventType.KEY_UP,P=>c(new M.StandardKeyboardEvent(P))))}z(a,c){this.B(E.addDisposableListener(a,E.EventType.INPUT,c))}C(a,c){this.B(E.addDisposableListener(a,E.EventType.BLUR,c))}D(a,c){this.B(E.addDisposableListener(a,E.EventType.FOCUS,c))}F(a,c){this.B(E.addDisposableListener(a,E.EventType.CHANGE,c))}G(a){return W.Gesture.ignoreTarget(a)}}t.Widget=A}),define(ge[35],me([1,0,53,19,9,17,4]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class A extends M.Widget{constructor(a){super(),this.a=a.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=a.bgWidth+"px",this.bgDomNode.style.height=a.bgHeight+"px",typeof a.top<"u"&&(this.bgDomNode.style.top="0px"),typeof a.left<"u"&&(this.bgDomNode.style.left="0px"),typeof a.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof a.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=a.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(a.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof a.top<"u"&&(this.domNode.style.top=a.top+"px"),typeof a.left<"u"&&(this.domNode.style.left=a.left+"px"),typeof a.bottom<"u"&&(this.domNode.style.bottom=a.bottom+"px"),typeof a.right<"u"&&(this.domNode.style.right=a.right+"px"),this.g=this.B(new E.GlobalPointerMoveMonitor),this.B(v.addStandardDisposableListener(this.bgDomNode,v.EventType.POINTER_DOWN,c=>this.h(c))),this.B(v.addStandardDisposableListener(this.domNode,v.EventType.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new i.IntervalTimer),this.c=this.B(new i.TimeoutTimer)}h(a){if(!a.target||!(a.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(a.target,a.pointerId,a.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),a.preventDefault()}}t.ScrollbarArrow=A}),define(ge[56],me([1,0,4,38,53,35,117,19,5]),function(ee,t,E,M,i,W,v,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const a=140;class c extends A.Widget{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new v.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new i.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,M.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,l=>this.y(l)))}r(r){const l=this.B(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}s(r,l,e,o){this.slider=(0,M.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof o=="number"&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this.I(n))})),this.f(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),o=l+this.h.getSliderPosition()+this.h.getSliderSize(),n=this.O(r);e<=n&&n<=o?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);l=r.pageX-n.left,e=r.pageY-n.top}const o=this.N(l,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(o):this.h.getDesiredScrollPositionFromOffset(o)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const l=this.O(r),e=this.P(r),o=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const u=this.P(n),s=Math.abs(u-e);if(h.isWindows&&s>a){this.J(o.getScrollPosition());return}const D=this.O(n)-l;this.J(o.getDesiredScrollPositionFromDelta(D))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const l={};this.writeScrollPosition(l,r),this.b.setScrollPositionNow(l)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=c}),define(ge[120],me([1,0,21,56,35,39,16]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class A extends M.AbstractScrollbar{constructor(a,c,P){const r=a.getScrollDimensions(),l=a.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:a,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,o=(c.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:v.Codicon.scrollbarButtonLeft,top:o,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:v.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}M(a,c){this.slider.setWidth(a),this.slider.setLeft(c)}L(a,c){this.domNode.setWidth(a),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(a){return this.n=this.v(a.scrollWidth)||this.n,this.n=this.w(a.scrollLeft)||this.n,this.n=this.t(a.width)||this.n,this.n}N(a,c){return a}O(a){return a.pageX}P(a){return a.pageY}Q(a){this.slider.setHeight(a)}writeScrollPosition(a,c){a.scrollLeft=c}updateOptions(a){this.updateScrollbarSize(a.horizontal===2?0:a.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this.i.setVisibility(a.horizontal),this.c=a.scrollByPage}}t.HorizontalScrollbar=A}),define(ge[121],me([1,0,21,56,35,39,16]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class A extends M.AbstractScrollbar{constructor(a,c,P){const r=a.getScrollDimensions(),l=a.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:a,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,o=(c.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:v.Codicon.scrollbarButtonUp,top:e,left:o,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:v.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}M(a,c){this.slider.setHeight(a),this.slider.setTop(c)}L(a,c){this.domNode.setWidth(c),this.domNode.setHeight(a),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(a){return this.n=this.v(a.scrollHeight)||this.n,this.n=this.w(a.scrollTop)||this.n,this.n=this.t(a.height)||this.n,this.n}N(a,c){return c}O(a){return a.pageY}P(a){return a.pageX}Q(a){this.slider.setWidth(a)}writeScrollPosition(a,c){a.scrollTop=c}updateOptions(a){this.updateScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(a.vertical),this.c=a.scrollByPage}}t.VerticalScrollbar=A}),define(ge[57],me([1,0,18,4,38,21,120,121,19,9,3,2,5,49,90]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,o=50,n=!0;class u{constructor(I,y,d){this.timestamp=I,this.deltaX=y,this.deltaY=d,this.score=0}}class s{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,y=0,d=1,m=this.d;do{const b=m===this.c?I:Math.pow(2,-d);if(I-=b,y+=this.b[m].score*b,m===this.c)break;m=(this.a+m-1)%this.a,d++}while(!0);return y<=.5}acceptStandardWheelEvent(I){const y=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),I.deltaX/y,I.deltaY/y):this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,y,d){const m=new u(I,y,d);m.score=this.f(m),this.c===-1&&this.d===-1?(this.b[0]=m,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=m)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let y=.5;const d=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(y+=.25),Math.min(Math.max(y,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}s.INSTANCE=new s,t.MouseWheelClassifier=s;class w extends h.Widget{get options(){return this.a}constructor(I,y,d){super(),this.I=this.B(new c.Emitter),this.onScroll=this.I.event,this.J=this.B(new c.Emitter),this.onWillScroll=this.J.event,I.style.overflow="hidden",this.a=p(y),this.b=d,this.B(this.b.onScroll(b=>{this.J.fire(b),this.N(b),this.I.fire(b)}));const m={onMouseWheel:b=>this.M(b),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new A.VerticalScrollbar(this.b,this.a,m)),this.g=this.B(new v.HorizontalScrollbar(this.b,this.a,m)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,b=>this.S(b)),this.m(this.r,b=>this.R(b)),this.w=this.B(new a.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,P.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,r.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(I){this.H=I}delegateScrollFromMouseWheelEvent(I){this.M(new W.StandardWheelEvent(I))}L(I){if(this.s.length>0!==I&&(this.s=(0,P.dispose)(this.s),I)){const d=m=>{this.M(new W.StandardWheelEvent(m))};this.s.push(M.addDisposableListener(this.r,M.EventType.MOUSE_WHEEL,d,{passive:!1}))}}M(I){const y=s.INSTANCE;n&&y.acceptStandardWheelEvent(I);let d=!1;if(I.deltaY||I.deltaX){let b=I.deltaY*this.a.mouseWheelScrollSensitivity,O=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(b)>=Math.abs(O)?O=0:b=0),this.a.flipAxes&&([b,O]=[O,b]);const q=!r.isMacintosh&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||q)&&!O&&(O=b,b=0),I.browserEvent&&I.browserEvent.altKey&&(O=O*this.a.fastScrollSensitivity,b=b*this.a.fastScrollSensitivity);const Z=this.b.getFutureScrollPosition();let se={};if(b){const ae=o*b,fe=Z.scrollTop-(ae<0?Math.floor(ae):Math.ceil(ae));this.c.writeScrollPosition(se,fe)}if(O){const ae=o*O,fe=Z.scrollLeft-(ae<0?Math.floor(ae):Math.ceil(ae));this.g.writeScrollPosition(se,fe)}se=this.b.validateScrollPosition(se),(Z.scrollLeft!==se.scrollLeft||Z.scrollTop!==se.scrollTop)&&(n&&this.a.mouseWheelSmoothScroll&&y.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(se):this.b.setScrollPositionNow(se),d=!0)}let m=d;!m&&this.a.alwaysConsumeMouseWheel&&(m=!0),!m&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(m=!0),m&&(I.preventDefault(),I.stopPropagation())}N(I){this.y=this.g.onDidScroll(I)||this.y,this.y=this.c.onDidScroll(I)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),y=I.scrollTop>0,d=I.scrollLeft>0,m=d?" left":"",b=y?" top":"",O=d||y?" top-left-corner":"";this.i.setClassName(`shadow${m}`),this.l.setClassName(`shadow${b}`),this.n.setClassName(`shadow${O}${b}${m}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(I){this.v=!1,this.W()}S(I){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=w;class D extends w{constructor(I,y){y=y||{},y.mouseWheelSmoothScroll=!1;const d=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>M.scheduleAtNextAnimationFrame(m)});super(I,y,d),this.B(d)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=D;class S extends w{constructor(I,y,d){super(I,y,d)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class f extends w{constructor(I,y){y=y||{},y.mouseWheelSmoothScroll=!1;const d=new l.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>M.scheduleAtNextAnimationFrame(m)});super(I,y,d),this.B(d),this.Y=I,this.onScroll(m=>{m.scrollTopChanged&&(this.Y.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this.Y.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=f;function p(L){const I={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return I.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:I.verticalScrollbarSize,r.isMacintosh&&(I.className+=" mac"),I}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const u={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(I){return[I]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class w{get context(){return this.d}set context(y){this.d=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=w;class D{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=D;class S{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let d=0;d<y.files.length;d++){const m=y.files.item(d);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function f(I,y){return Array.isArray(I)&&Array.isArray(y)?(0,A.equals)(I,y):I===y}class p{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(d,m,b)=>b,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(d,m)=>m+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=d=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=d=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(y){if(y!==this.N){if(y&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=y,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const d of this.d)this.X(d);this.U(),this.q.setScrollDimensions({width:(0,M.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(y,d,m,b=s){if(this.P=d,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.Delayer(50),this.v=!1,this.x=P.Disposable.None,this.y=0,this.G=!1,this.J=P.Disposable.None,this.K=P.Disposable.None,this.L=new P.DisposableStore,this.M=new c.Emitter,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.N=!1,b.horizontalScrolling&&b.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const q of m)this.j.set(q.templateId,q);this.h=this.L.add(new o.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof b.mouseSupport=="boolean"?b.mouseSupport:!0),this.N=b.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof b.additionalScrollHeight>"u"?0:b.additionalScrollHeight,this.D=new p(b.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(b.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(W.Gesture.addTarget(this.o)),this.p=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:b.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:q=>(0,M.scheduleAtNextAnimationFrame)(q)}),this.q=this.L.add(new v.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:b.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:b.verticalScrollMode??s.verticalScrollMode,useShadows:b.useShadows??s.useShadows,mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity,fastScrollSensitivity:b.fastScrollSensitivity,scrollByPage:b.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),y.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,M.addDisposableListener)(this.o,W.EventType.Change,q=>this.gb(q))),this.L.add((0,M.addDisposableListener)(this.q.getDomNode(),"scroll",q=>q.target.scrollTop=0)),this.L.add((0,M.addDisposableListener)(this.domNode,"dragover",q=>this.ib(this.eb(q)))),this.L.add((0,M.addDisposableListener)(this.domNode,"drop",q=>this.kb(this.eb(q)))),this.L.add((0,M.addDisposableListener)(this.domNode,"dragleave",q=>this.jb(this.eb(q)))),this.L.add((0,M.addDisposableListener)(this.domNode,"dragend",q=>this.lb(q))),this.z=b.setRowLineHeight??s.setRowLineHeight,this.A=b.setRowHeight??s.setRowHeight,this.B=b.supportDynamicHeights??s.supportDynamicHeights,this.F=b.dnd??s.dnd,this.layout(b.initialSize?.height,b.initialSize?.width)}updateOptions(y){y.additionalScrollHeight!==void 0&&(this.C=y.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.O=y.horizontalScrolling);let d;y.scrollByPage!==void 0&&(d={...d??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(d={...d??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(d={...d??{},fastScrollSensitivity:y.fastScrollSensitivity}),d&&this.q.updateOptions(d)}delegateScrollFromMouseWheelEvent(y){this.q.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.q.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,d,m){if(y<0||y>=this.d.length)return;const b=this.d[y].size;if(typeof d>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[y].lastDynamicHeightWidth=void 0,d=b+this.tb(y)}if(b===d)return;const O=this.rb(this.k,this.m);let q=0;y<O.start||m!==null&&m>y&&m<=O.end?q=d-b:q=0,this.g.splice(y,1,[{size:d}]),this.d[y].size=d,this.V(O,Math.max(0,this.k+q),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(y,d,m=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(y,d,m)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(y,d,m=[]){const b=this.rb(this.k,this.m),O={start:y,end:y+d},q=r.Range.intersect(b,O),Z=new Map;for(let ie=q.end-1;ie>=q.start;ie--){const T=this.d[ie];if(T.dragStartDisposable.dispose(),T.checkedDisposable.dispose(),T.row){let _=Z.get(T.templateId);_||(_=[],Z.set(T.templateId,_));const R=this.j.get(T.templateId);R&&R.disposeElement&&R.disposeElement(T.element,ie,T.row.templateData,T.size),_.push(T.row)}T.row=null}const se={start:y+d,end:this.d.length},ae=r.Range.intersect(se,b),fe=r.Range.relativeComplement(se,b),ue=m.map(ie=>({id:String(this.f++),element:ie,templateId:this.P.getTemplateId(ie),size:this.P.getHeight(ie),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ie),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let Q;y===0&&d>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ue),Q=this.d,this.d=ue):(this.g.splice(y,d,ue),Q=this.d.splice(y,d,...ue));const J=m.length-d,ve=this.rb(this.k,this.m),pe=(0,e.shift)(ae,J),Me=r.Range.intersect(ve,pe);for(let ie=Me.start;ie<Me.end;ie++)this.Y(this.d[ie],ie);const Re=r.Range.relativeComplement(pe,ve);for(const ie of Re)for(let T=ie.start;T<ie.end;T++)this.Z(T);const le=fe.map(ie=>(0,e.shift)(ie,J)),ne=[{start:y,end:y+m.length},...le].map(ie=>r.Range.intersect(ve,ie)),te=this.ub(ne);for(const ie of ne)for(let T=ie.start;T<ie.end;T++){const _=this.d[T],g=Z.get(_.templateId)?.pop();this.W(T,te,g)}for(const ie of Z.values())for(const T of ie)this.h.release(T);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),Q.map(ie=>ie.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,M.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let y=0;for(const d of this.d)typeof d.width<"u"&&(y=Math.max(y,d.width));this.E=y,this.q.setScrollDimensions({scrollWidth:y===0?0:y+10})}updateWidth(y){if(!this.O||typeof this.E>"u")return;const d=this.d[y];this.X(d),typeof d.width<"u"&&d.width>this.E&&(this.E=d.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const y of this.d)y.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const y=this.rb(this.k,this.m),d=this.g.positionAt(y.start),m=this.g.positionAt(y.start+1);return m!==-1&&(m-d)/2+d<this.scrollTop?y.start+1:y.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(y){return this.d[y].element}indexOf(y){return this.d.findIndex(d=>d.element===y)}domElement(y){const d=this.d[y].row;return d&&d.domNode}elementHeight(y){return this.d[y].size}elementTop(y){return this.g.positionAt(y)}indexAt(y){return this.g.indexAt(y)}indexAfter(y){return this.g.indexAfter(y)}layout(y,d){const m={height:typeof y=="number"?y:(0,M.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,m.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(m),typeof d<"u"&&(this.n=d,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof d=="number"?d:(0,M.getContentWidth)(this.domNode)})}V(y,d,m,b,O,q=!1){const Z=this.rb(d,m),se=r.Range.relativeComplement(Z,y),ae=r.Range.relativeComplement(y,Z),fe=this.ub(se);if(q){const ue=r.Range.intersect(y,Z);for(let Q=ue.start;Q<ue.end;Q++)this.Y(this.d[Q],Q)}this.h.transact(()=>{for(const ue of ae)for(let Q=ue.start;Q<ue.end;Q++)this.Z(Q);for(const ue of se)for(let Q=ue.start;Q<ue.end;Q++)this.W(Q,fe)}),b!==void 0&&(this.o.style.left=`-${b}px`),this.o.style.top=`-${d}px`,this.O&&O!==void 0&&(this.o.style.width=`${Math.max(O,this.n)}px`),this.k=d,this.m=m}W(y,d,m){const b=this.d[y];let O=!1;if(!b.row)if(m)b.row=m;else{const fe=this.h.alloc(b.templateId);b.row=fe.row,O=fe.isReusingConnectedDomNode}const q=this.D.getRole(b.element)||"listitem";b.row.domNode.setAttribute("role",q);const Z=this.D.isChecked(b.element);if(typeof Z=="boolean")b.row.domNode.setAttribute("aria-checked",String(!!Z));else if(Z){const fe=ue=>b.row.domNode.setAttribute("aria-checked",String(!!ue));fe(Z.value),b.checkedDisposable=Z.onDidChange(fe)}(O||!b.row.domNode.parentElement)&&(d?this.o.insertBefore(b.row.domNode,d):this.o.appendChild(b.row.domNode)),this.Y(b,y);const se=this.j.get(b.templateId);if(!se)throw new Error(`No renderer found for template id ${b.templateId}`);se?.renderElement(b.element,y,b.row.templateData,b.size);const ae=this.F.getDragURI(b.element);b.dragStartDisposable.dispose(),b.row.domNode.draggable=!!ae,ae&&(b.dragStartDisposable=(0,M.addDisposableListener)(b.row.domNode,"dragstart",fe=>this.hb(b.element,ae,fe))),this.O&&(this.X(b),this.S())}X(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,M.getContentWidth)(y.row.domNode);const d=window.getComputedStyle(y.row.domNode);d.paddingLeft&&(y.width+=parseFloat(d.paddingLeft)),d.paddingRight&&(y.width+=parseFloat(d.paddingRight)),y.row.domNode.style.width=""}Y(y,d){y.row.domNode.style.top=`${this.elementTop(d)}px`,this.A&&(y.row.domNode.style.height=`${y.size}px`),this.z&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${d}`),y.row.domNode.setAttribute("data-last-element",d===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",d%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(y.element,d,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(y.element,d))),y.row.domNode.setAttribute("id",this.getElementDomId(d)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}Z(y){const d=this.d[y];if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const m=this.j.get(d.templateId);m&&m.disposeElement&&m.disposeElement(d.element,y,d.row.templateData,d.size),this.h.release(d.row),d.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(y,d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:y,reuseAnimation:d})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"click")).event,y=>this.ab(y),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"dblclick")).event,y=>this.ab(y),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"auxclick")).event,y=>this.ab(y),this.L),y=>y.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseup")).event,y=>this.ab(y),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousedown")).event,y=>this.ab(y),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseover")).event,y=>this.ab(y),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousemove")).event,y=>this.ab(y),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseout")).event,y=>this.ab(y),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"contextmenu")).event,y=>this.ab(y),this.L),c.Event.map(this.L.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,y=>this.db(y),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"touchstart")).event,y=>this.bb(y),this.L)}get onTap(){return c.Event.map(this.L.add(new i.DomEmitter(this.o,W.EventType.Tap)).event,y=>this.db(y),this.L)}ab(y){const d=this.qb(y.target||null),m=typeof d>"u"?void 0:this.d[d],b=m&&m.element;return{browserEvent:y,index:d,element:b}}bb(y){const d=this.qb(y.target||null),m=typeof d>"u"?void 0:this.d[d],b=m&&m.element;return{browserEvent:y,index:d,element:b}}db(y){const d=this.qb(y.initialTarget||null),m=typeof d>"u"?void 0:this.d[d],b=m&&m.element;return{browserEvent:y,index:d,element:b}}eb(y){const d=this.qb(y.target||null),m=typeof d>"u"?void 0:this.d[d],b=m&&m.element;return{browserEvent:y,index:d,element:b}}fb(y){try{const d=this.rb(this.k,this.m);this.V(d,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.B&&this.sb(y.scrollTop,y.height,y.inSmoothScrolling)}catch(d){throw console.error("Got bad scroll event:",y),d}}gb(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}hb(y,d,m){if(!m.dataTransfer)return;const b=this.F.getDragElements(y);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(E.DataTransfers.TEXT,d),m.dataTransfer.setDragImage){let O;this.F.getDragLabel&&(O=this.F.getDragLabel(b,m)),typeof O>"u"&&(O=String(b.length));const q=(0,M.$)(".monaco-drag-image");q.textContent=O;const se=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||document.body})(this.domNode);se.appendChild(q),m.dataTransfer.setDragImage(q,-10,-10),setTimeout(()=>se.removeChild(q),0)}this.domNode.classList.add("dragging"),this.H=new w(b),u.CurrentDragAndDropData=new D(b),this.F.onDragStart?.(this.H,m)}ib(y){if(y.browserEvent.preventDefault(),this.K.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.H)if(u.CurrentDragAndDropData)this.H=u.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.H=new S}const d=this.F.onDragOver(this.H,y.element,y.index,y.browserEvent);if(this.G=typeof d=="boolean"?d:d.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof d!="boolean"&&d.effect===0?"copy":"move";let m;if(typeof d!="boolean"&&d.feedback?m=d.feedback:typeof y.index>"u"?m=[-1]:m=[y.index],m=(0,A.distinct)(m).filter(b=>b>=-1&&b<this.length).sort((b,O)=>b-O),m=m[0]===-1?[-1]:m,f(this.I,m))return!0;if(this.I=m,this.J.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const b of m){const O=this.d[b];O.dropTarget=!0,O.row?.domNode.classList.add("drop-target")}this.J=(0,P.toDisposable)(()=>{for(const b of m){const O=this.d[b];O.dropTarget=!1,O.row?.domNode.classList.remove("drop-target")}})}return!0}jb(y){this.K.dispose(),this.K=(0,h.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,y.element,y.index,y.browserEvent)}kb(y){if(!this.G)return;const d=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,!(!d||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),d.update(y.browserEvent.dataTransfer),this.F.drop(d,y.element,y.index,y.browserEvent))}lb(y){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(y)}mb(){this.I=void 0,this.J.dispose(),this.J=P.Disposable.None}nb(y){if(!this.w){const d=(0,M.getTopLeftOffset)(this.domNode).top;this.w=(0,M.animate)(this.ob.bind(this,d))}this.x.dispose(),this.x=(0,h.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=y.pageY}ob(y){if(this.y===void 0)return;const d=this.y-y,m=this.renderHeight-35;d<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(d-35))):d>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(d-m))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(y){const d=this.q.getDomNode();let m=y;for(;m instanceof HTMLElement&&m!==this.o&&d.contains(m);){const b=m.getAttribute("data-index");if(b){const O=Number(b);if(!isNaN(O))return O}m=m.parentElement}}rb(y,d){return{start:this.g.indexAt(y),end:this.g.indexAfter(y+d-1)}}sb(y,d,m){const b=this.rb(y,d);let O,q;y===this.elementTop(b.start)?(O=b.start,q=0):b.end-b.start>1&&(O=b.start+1,q=this.elementTop(O)-y);let Z=0;for(;;){const se=this.rb(y,d);let ae=!1;for(let fe=se.start;fe<se.end;fe++){const ue=this.tb(fe);ue!==0&&this.g.splice(fe,1,[this.d[fe]]),Z+=ue,ae=ae||ue!==0}if(!ae){Z!==0&&this.R();const fe=r.Range.relativeComplement(b,se);for(const Q of fe)for(let J=Q.start;J<Q.end;J++)this.d[J].row&&this.Z(J);const ue=r.Range.relativeComplement(se,b);for(const Q of ue)for(let J=Q.start;J<Q.end;J++){const ve=J+1,pe=ve<this.d.length?this.d[ve].row:null,Me=pe?pe.domNode:null;this.W(J,Me)}for(let Q=se.start;Q<se.end;Q++)this.d[Q].row&&this.Y(this.d[Q],Q);if(typeof O=="number"){const Q=this.p.getFutureScrollPosition().scrollTop-y,J=this.elementTop(O)-q+Q;this.setScrollTop(J,m)}this.M.fire(this.contentHeight);return}}}tb(y){const d=this.d[y];if(this.P.getDynamicHeight){const q=this.P.getDynamicHeight(d.element);if(q!==null){const Z=d.size;return d.size=q,d.lastDynamicHeightWidth=this.n,q-Z}}if(!d.hasDynamicHeight||d.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(d.element))return 0;const m=d.size;if(d.row)return d.row.domNode.style.height="",d.size=d.row.domNode.offsetHeight,d.lastDynamicHeightWidth=this.n,d.size-m;const{row:b}=this.h.alloc(d.templateId);b.domNode.style.height="",this.o.appendChild(b.domNode);const O=this.j.get(d.templateId);if(!O)throw new n.BugIndicatingError("Missing renderer for templateId: "+d.templateId);return O.renderElement(d.element,y,b.templateData,void 0),d.size=b.domNode.offsetHeight,O.disposeElement?.(d.element,y,b.templateData,void 0),this.P.setDynamicHeight?.(d.element,d.size),d.lastDynamicHeightWidth=this.n,this.o.removeChild(b.domNode),this.h.release(b),d.size-m}ub(y){const d=y[y.length-1];if(!d)return null;const m=this.d[d.end];return!m||!m.row?null:m.row.domNode}getElementDomId(y){return`${this.domId}_${y}`}dispose(){if(this.d){for(const y of this.d)if(y.row){const d=this.j.get(y.row.templateId);d&&(d.disposeElement?.(y.element,-1,y.row.templateData,void 0),d.disposeTemplate(y.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.L)}}L.c=0,qe([a.memoize],L.prototype,"onMouseClick",null),qe([a.memoize],L.prototype,"onMouseDblClick",null),qe([a.memoize],L.prototype,"onMouseMiddleClick",null),qe([a.memoize],L.prototype,"onMouseUp",null),qe([a.memoize],L.prototype,"onMouseDown",null),qe([a.memoize],L.prototype,"onMouseOver",null),qe([a.memoize],L.prototype,"onMouseMove",null),qe([a.memoize],L.prototype,"onMouseOut",null),qe([a.memoize],L.prototype,"onContextMenu",null),qe([a.memoize],L.prototype,"onTouchStart",null),qe([a.memoize],L.prototype,"onTap",null),t.ListView=L}),define(ge[36],me([1,0,4,20,14,23,54,68,13,9,70,25,3,32,2,44,5,6,67,58,89]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e,o,n,u,s,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class D{constructor(T){this.d=T,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(T){return T}renderElement(T,_,R){const g=this.c.findIndex(C=>C.templateData===R);if(g>=0){const C=this.c[g];this.d.unrender(R),C.index=_}else{const C={index:_,templateData:R};this.c.push(C)}this.d.renderIndex(_,R)}splice(T,_,R){const g=[];for(const C of this.c)C.index<T?g.push(C):C.index>=T+_&&g.push({index:C.index+R-_,templateData:C.templateData});this.c=g}renderIndexes(T){for(const{index:_,templateData:R}of this.c)T.indexOf(_)>-1&&this.d.renderIndex(_,R)}disposeTemplate(T){const _=this.c.findIndex(R=>R.templateData===T);_<0||this.c.splice(_,1)}}class S{get name(){return this.h}get renderer(){return new D(this)}constructor(T){this.h=T,this.c=0,this.d=[],this.f=[],this.g=new r.Emitter,this.onChange=this.g.event}splice(T,_,R){_=Math.max(0,Math.min(_,this.c-T));const g=R.length-_,C=T+_,$=[...this.f.filter(F=>F<T),...R.map((F,N)=>F?N+T:-1).filter(F=>F!==-1),...this.f.filter(F=>F>=C).map(F=>F+g)],Y=this.c+g;if(this.f.length>0&&$.length===0&&Y>0){const F=this.f.find(N=>N>=T)??Y-1;$.push(Math.min(F,Y-1))}this.renderer.splice(T,_,R.length),this.k($,$),this.c=Y}renderIndex(T,_){_.classList.toggle(this.h,this.contains(T))}unrender(T){T.classList.remove(this.h)}set(T,_){return this.k(T,[...T].sort(Re),_)}k(T,_,R){const g=this.d,C=this.f;this.d=T,this.f=_;const $=pe(C,T);return this.renderer.renderIndexes($),this.g.fire({indexes:T,browserEvent:R}),g}get(){return this.d}contains(T){return(0,h.binarySearch)(this.f,T,Re)>=0}dispose(){(0,e.dispose)(this.g)}}qe([P.memoize],S.prototype,"renderer",null);class f extends S{constructor(T){super("selected"),this.l=T}renderIndex(T,_){super.renderIndex(T,_),this.l&&(this.contains(T)?_.setAttribute("aria-selected","true"):_.setAttribute("aria-selected","false"))}}class p{constructor(T,_,R){this.c=T,this.d=_,this.f=R}splice(T,_,R){if(!this.f)return this.c.splice(T,_,R.map(()=>!1));const g=this.c.get().map($=>this.f.getId(this.d.element($)).toString()),C=R.map($=>g.indexOf(this.f.getId($).toString())>-1);this.c.splice(T,_,C)}}function L(ie){return ie.tagName==="INPUT"||ie.tagName==="TEXTAREA"}t.isInputElement=L;function I(ie){return ie.classList.contains("monaco-editor")?!0:ie.classList.contains("monaco-list")||!ie.parentElement?!1:I(ie.parentElement)}t.isMonacoEditor=I;function y(ie){return ie.tagName==="A"&&ie.classList.contains("monaco-button")||ie.tagName==="DIV"&&ie.classList.contains("monaco-button-dropdown")?!0:ie.classList.contains("monaco-list")||!ie.parentElement?!1:y(ie.parentElement)}t.isButton=y;class d{get f(){return this.c.add(r.Event.chain(this.c.add(new M.DomEmitter(this.h.domNode,"keydown")).event).filter(T=>!L(T.target)).map(T=>new i.StandardKeyboardEvent(T)))}constructor(T,_,R){this.g=T,this.h=_,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(g=>g.keyCode===3).on(this.k,this,this.c),this.f.filter(g=>g.keyCode===16).on(this.l,this,this.c),this.f.filter(g=>g.keyCode===18).on(this.o,this,this.c),this.f.filter(g=>g.keyCode===11).on(this.p,this,this.c),this.f.filter(g=>g.keyCode===12).on(this.q,this,this.c),this.f.filter(g=>g.keyCode===9).on(this.t,this,this.c),R.multipleSelectionSupport!==!1&&this.f.filter(g=>(n.isMacintosh?g.metaKey:g.ctrlKey)&&g.keyCode===31).on(this.s,this,this.d)}updateOptions(T){T.multipleSelectionSupport!==void 0&&(this.d.clear(),T.multipleSelectionSupport&&this.f.filter(_=>(n.isMacintosh?_.metaKey:_.ctrlKey)&&_.keyCode===31).on(this.s,this,this.d))}k(T){T.preventDefault(),T.stopPropagation(),this.g.setSelection(this.g.getFocus(),T.browserEvent)}l(T){T.preventDefault(),T.stopPropagation(),this.g.focusPrevious(1,!1,T.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}o(T){T.preventDefault(),T.stopPropagation(),this.g.focusNext(1,!1,T.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}p(T){T.preventDefault(),T.stopPropagation(),this.g.focusPreviousPage(T.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}q(T){T.preventDefault(),T.stopPropagation(),this.g.focusNextPage(T.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}s(T){T.preventDefault(),T.stopPropagation(),this.g.setSelection((0,h.range)(this.g.length),T.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(T){this.g.getSelection().length&&(T.preventDefault(),T.stopPropagation(),this.g.setSelection([],T.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([P.memoize],d.prototype,"f",null);var m;(function(ie){ie[ie.Automatic=0]="Automatic",ie[ie.Trigger=1]="Trigger"})(m=t.TypeNavigationMode||(t.TypeNavigationMode={}));var b;(function(ie){ie[ie.Idle=0]="Idle",ie[ie.Typing=1]="Typing"})(b||(b={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(ie){return ie.ctrlKey||ie.metaKey||ie.altKey?!1:ie.keyCode>=31&&ie.keyCode<=56||ie.keyCode>=21&&ie.keyCode<=30||ie.keyCode>=93&&ie.keyCode<=102||ie.keyCode>=80&&ie.keyCode<=90}};class O{constructor(T,_,R,g,C){this.o=T,this.p=_,this.q=R,this.s=g,this.t=C,this.c=!1,this.d=b.Idle,this.f=m.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(T.options)}updateOptions(T){T.typeNavigationEnabled??!0?this.u():this.v(),this.f=T.typeNavigationMode??m.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let T=!1;const _=this.k.add(r.Event.chain(this.k.add(new M.DomEmitter(this.p.domNode,"keydown")).event)).filter(C=>!L(C.target)).filter(()=>this.f===m.Automatic||this.g).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>T||this.s(C)).filter(C=>this.t.mightProducePrintableCharacter(C)).forEach(C=>E.EventHelper.stop(C,!0)).map(C=>C.browserEvent.key).event,R=r.Event.debounce(_,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(_,R),(C,$)=>$===null?null:(C||"")+$,void 0,this.k)(this.z,this,this.k),R(this.w,this,this.k),_(()=>T=!0,void 0,this.k),R(()=>T=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const T=this.o.getFocus();if(T.length>0&&T[0]===this.h){const _=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(T[0]));_&&(0,v.alert)(_)}this.h=-1}z(T){if(!T){this.d=b.Idle,this.g=!1;return}const _=this.o.getFocus(),R=_.length>0?_[0]:0,g=this.d===b.Idle?1:0;this.d=b.Typing;for(let C=0;C<this.o.length;C++){const $=(R+C+g)%this.o.length,Y=this.q.getKeyboardNavigationLabel(this.p.element($)),F=Y&&Y.toString();if(typeof F>"u"||(0,l.matchesPrefix)(T,F)){this.h=R,this.o.setFocus([$]),this.o.reveal($);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class q{constructor(T,_){this.d=T,this.f=_,this.c=new e.DisposableStore,this.c.add(r.Event.chain(this.c.add(new M.DomEmitter(_.domNode,"keydown")).event)).filter(g=>!L(g.target)).map(g=>new i.StandardKeyboardEvent(g)).filter(g=>g.keyCode===2&&!g.ctrlKey&&!g.metaKey&&!g.shiftKey&&!g.altKey).on(this.g,this,this.c)}g(T){if(T.target!==this.f.domNode)return;const _=this.d.getFocus();if(_.length===0)return;const R=this.f.domElement(_[0]);if(!R)return;const g=R.querySelector("[tabIndex]");if(!g||!(g instanceof HTMLElement)||g.tabIndex===-1)return;const C=window.getComputedStyle(g);C.visibility==="hidden"||C.display==="none"||(T.preventDefault(),T.stopPropagation(),g.focus())}dispose(){this.c.dispose()}}function Z(ie){return n.isMacintosh?ie.browserEvent.metaKey:ie.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function se(ie){return ie.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=se;function ae(ie){return ie instanceof MouseEvent&&ie.button===2}const fe={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:se};class ue{constructor(T){this.k=T,this.f=new e.DisposableStore,this.g=new r.Emitter,this.onPointer=this.g.event,T.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof T.options.mouseSupport>"u"||!!T.options.mouseSupport,this.d&&(T.onMouseDown(this.s,this,this.f),T.onContextMenu(this.t,this,this.f),T.onMouseDblClick(this.v,this,this.f),T.onTouchStart(this.s,this,this.f),this.f.add(W.Gesture.addTarget(T.getHTMLElement()))),r.Event.any(T.onMouseClick,T.onMouseMiddleClick,T.onTap)(this.u,this,this.f)}updateOptions(T){T.multipleSelectionSupport!==void 0&&(this.c=void 0,T.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(T){return this.c?this.c.isSelectionSingleChangeEvent(T):!1}p(T){return this.c?this.c.isSelectionRangeChangeEvent(T):!1}q(T){return this.o(T)||this.p(T)}s(T){I(T.browserEvent.target)||document.activeElement!==T.browserEvent.target&&this.k.domFocus()}t(T){if(L(T.browserEvent.target)||I(T.browserEvent.target))return;const _=typeof T.index>"u"?[]:[T.index];this.k.setFocus(_,T.browserEvent)}u(T){if(!this.d||L(T.browserEvent.target)||I(T.browserEvent.target))return;const _=T.index;if(typeof _>"u"){this.k.setFocus([],T.browserEvent),this.k.setSelection([],T.browserEvent),this.k.setAnchor(void 0);return}if(this.p(T))return this.w(T);if(this.q(T))return this.w(T);this.k.setFocus([_],T.browserEvent),this.k.setAnchor(_),ae(T.browserEvent)||this.k.setSelection([_],T.browserEvent),this.g.fire(T)}v(T){if(L(T.browserEvent.target)||I(T.browserEvent.target)||this.q(T))return;const _=this.k.getFocus();this.k.setSelection(_,T.browserEvent)}w(T){const _=T.index;let R=this.k.getAnchor();if(this.p(T)){typeof R>"u"&&(R=this.k.getFocus()[0]??_,this.k.setAnchor(R));const g=Math.min(R,_),C=Math.max(R,_),$=(0,h.range)(g,C+1),Y=this.k.getSelection(),F=ve(pe(Y,[R]),R);if(F.length===0)return;const N=pe($,Me(Y,F));this.k.setSelection(N,T.browserEvent),this.k.setFocus([_],T.browserEvent)}else if(this.o(T)){const g=this.k.getSelection(),C=g.filter($=>$!==_);this.k.setFocus([_]),this.k.setAnchor(_),g.length===C.length?this.k.setSelection([...C,_],T.browserEvent):this.k.setSelection(C,T.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ue;class Q{constructor(T,_){this.c=T,this.d=_}style(T){const _=this.d&&`.${this.d}`,R=[];T.listBackground&&R.push(`.monaco-list${_} .monaco-list-rows { background: ${T.listBackground}; }`),T.listFocusBackground&&(R.push(`.monaco-list${_}:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),R.push(`.monaco-list${_}:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&R.push(`.monaco-list${_}:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(R.push(`.monaco-list${_}:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),R.push(`.monaco-list${_}:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&R.push(`.monaco-list${_}:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listActiveSelectionIconForeground&&R.push(`.monaco-list${_}:focus .monaco-list-row.selected .codicon { color: ${T.listActiveSelectionIconForeground}; }`),T.listFocusAndSelectionBackground&&R.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { background-color: ${T.listFocusAndSelectionBackground}; }
			`),T.listFocusAndSelectionForeground&&R.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { color: ${T.listFocusAndSelectionForeground}; }
			`),T.listInactiveFocusForeground&&(R.push(`.monaco-list${_} .monaco-list-row.focused { color:  ${T.listInactiveFocusForeground}; }`),R.push(`.monaco-list${_} .monaco-list-row.focused:hover { color:  ${T.listInactiveFocusForeground}; }`)),T.listInactiveSelectionIconForeground&&R.push(`.monaco-list${_} .monaco-list-row.focused .codicon { color:  ${T.listInactiveSelectionIconForeground}; }`),T.listInactiveFocusBackground&&(R.push(`.monaco-list${_} .monaco-list-row.focused { background-color:  ${T.listInactiveFocusBackground}; }`),R.push(`.monaco-list${_} .monaco-list-row.focused:hover { background-color:  ${T.listInactiveFocusBackground}; }`)),T.listInactiveSelectionBackground&&(R.push(`.monaco-list${_} .monaco-list-row.selected { background-color:  ${T.listInactiveSelectionBackground}; }`),R.push(`.monaco-list${_} .monaco-list-row.selected:hover { background-color:  ${T.listInactiveSelectionBackground}; }`)),T.listInactiveSelectionForeground&&R.push(`.monaco-list${_} .monaco-list-row.selected { color: ${T.listInactiveSelectionForeground}; }`),T.listHoverBackground&&R.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&R.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${T.listHoverForeground}; }`);const g=(0,E.asCssValueWithDefault)(T.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(T.listSelectionOutline,T.listFocusOutline??""));g&&R.push(`.monaco-list${_}:focus .monaco-list-row.focused.selected { outline: 1px solid ${g}; outline-offset: -1px;}`),T.listFocusOutline&&R.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${_}.last-focused .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }
			`);const C=(0,E.asCssValueWithDefault)(T.listSelectionOutline,T.listInactiveFocusOutline??"");C&&R.push(`.monaco-list${_} .monaco-list-row.focused.selected { outline: 1px dotted ${C}; outline-offset: -1px; }`),T.listSelectionOutline&&R.push(`.monaco-list${_} .monaco-list-row.selected { outline: 1px dotted ${T.listSelectionOutline}; outline-offset: -1px; }`),T.listInactiveFocusOutline&&R.push(`.monaco-list${_} .monaco-list-row.focused { outline: 1px dotted ${T.listInactiveFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&R.push(`.monaco-list${_} .monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.listDropBackground&&R.push(`
				.monaco-list${_}.drop-target,
				.monaco-list${_} .monaco-list-rows.drop-target,
				.monaco-list${_} .monaco-list-row.drop-target { background-color: ${T.listDropBackground} !important; color: inherit !important; }
			`),T.tableColumnsBorder&&R.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${T.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),T.tableOddRowsBackgroundColor&&R.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${T.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=R.join(`
`)}}t.DefaultStyleController=Q,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:c.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:c.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:c.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ve(ie,T){const _=ie.indexOf(T);if(_===-1)return[];const R=[];let g=_-1;for(;g>=0&&ie[g]===T-(_-g);)R.push(ie[g--]);for(R.reverse(),g=_;g<ie.length&&ie[g]===T+(g-_);)R.push(ie[g++]);return R}function pe(ie,T){const _=[];let R=0,g=0;for(;R<ie.length||g<T.length;)if(R>=ie.length)_.push(T[g++]);else if(g>=T.length)_.push(ie[R++]);else if(ie[R]===T[g]){_.push(ie[R]),R++,g++;continue}else ie[R]<T[g]?_.push(ie[R++]):_.push(T[g++]);return _}function Me(ie,T){const _=[];let R=0,g=0;for(;R<ie.length||g<T.length;)if(R>=ie.length)_.push(T[g++]);else if(g>=T.length)_.push(ie[R++]);else if(ie[R]===T[g]){R++,g++;continue}else ie[R]<T[g]?_.push(ie[R++]):g++;return _}const Re=(ie,T)=>ie-T;class le{constructor(T,_){this.c=T,this.d=_}get templateId(){return this.c}renderTemplate(T){return this.d.map(_=>_.renderTemplate(T))}renderElement(T,_,R,g){let C=0;for(const $ of this.d)$.renderElement(T,_,R[C++],g)}disposeElement(T,_,R,g){let C=0;for(const $ of this.d)$.disposeElement?.(T,_,R[C],g),C+=1}disposeTemplate(T){let _=0;for(const R of this.d)R.disposeTemplate(T[_++])}}class x{constructor(T){this.c=T,this.templateId="a18n"}renderTemplate(T){return T}renderElement(T,_,R){const g=this.c.getAriaLabel(T);g?R.setAttribute("aria-label",g):R.removeAttribute("aria-label");const C=this.c.getAriaLevel&&this.c.getAriaLevel(T);typeof C=="number"?R.setAttribute("aria-level",`${C}`):R.removeAttribute("aria-level")}disposeTemplate(T){}}class ne{constructor(T,_){this.c=T,this.d=_}getDragElements(T){const _=this.c.getSelectedElements();return _.indexOf(T)>-1?_:[T]}getDragURI(T){return this.d.getDragURI(T)}getDragLabel(T,_){if(this.d.getDragLabel)return this.d.getDragLabel(T,_)}onDragStart(T,_){this.d.onDragStart?.(T,_)}onDragOver(T,_,R,g){return this.d.onDragOver(T,_,R,g)}onDragLeave(T,_,R,g){this.d.onDragLeave?.(T,_,R,g)}onDragEnd(T){this.d.onDragEnd?.(T)}drop(T,_,R,g){this.d.drop(T,_,R,g)}}class te{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),T=>this.I(T),this.A)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),T=>this.I(T),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let T=!1;const _=this.A.add(r.Event.chain(this.A.add(new M.DomEmitter(this.k.domNode,"keydown")).event)).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>T=C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).filter(()=>!1).event,R=this.A.add(r.Event.chain(this.A.add(new M.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>T=!1).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).map(({browserEvent:C})=>{const $=this.getFocus(),Y=$.length?$[0]:void 0,F=typeof Y<"u"?this.k.element(Y):void 0,N=typeof Y<"u"?this.k.domElement(Y):this.k.domNode;return{index:Y,element:F,anchor:N,browserEvent:C}}).event,g=this.A.add(r.Event.chain(this.k.onContextMenu)).filter(C=>!T).map(({element:C,index:$,browserEvent:Y})=>({element:C,index:$,anchor:{x:Y.pageX+1,y:Y.pageY},browserEvent:Y})).event;return r.Event.any(_,R,g)}get onKeyDown(){return this.A.add(new M.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new M.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new M.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.A.add(new M.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.A.add(new M.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(T,_,R,g,C=J){this.C=T,this.D=C,this.c=new S("focused"),this.f=new S("anchor"),this.g=new r.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new r.Emitter,this.onDidDispose=this.B.event;const $=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new f($!=="listbox");const Y=[this.c.renderer,this.d.renderer];this.u=C.accessibilityProvider,this.u&&(Y.push(new x(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.A)),g=g.map(N=>new le(N.templateId,[...Y,N]));const F={...C,dnd:C.dnd&&new ne(this,C.dnd)};if(this.k=this.E(_,R,g,F),this.k.domNode.setAttribute("role",$),C.styleController)this.q=C.styleController(this.k.domId);else{const N=(0,E.createStyleSheet)(this.k.domNode);this.q=new Q(N,this.k.domId)}if(this.o=new A.CombinedSpliceable([new p(this.c,this.k,C.identityProvider),new p(this.d,this.k,C.identityProvider),new p(this.f,this.k,C.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new q(this,this.k)),(typeof C.keyboardSupport!="boolean"||C.keyboardSupport)&&(this.v=new d(this,this.k,C),this.A.add(this.v)),C.keyboardNavigationLabelProvider){const N=C.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new O(this,this.k,C.keyboardNavigationLabelProvider,C.keyboardNavigationEventFilter??(()=>!0),N),this.A.add(this.t)}this.w=this.F(C),this.A.add(this.w),this.onDidChangeFocus(this.J,this,this.A),this.onDidChangeSelection(this.L,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(T,_,R,g){return new w.ListView(T,_,R,g)}F(T){return new ue(this)}updateOptions(T={}){this.D={...this.D,...T},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(T),this.v?.updateOptions(T),this.k.updateOptions(T)}get options(){return this.D}splice(T,_,R=[]){if(T<0||T>this.k.length)throw new s.ListError(this.C,`Invalid start index: ${T}`);if(_<0)throw new s.ListError(this.C,`Invalid delete count: ${_}`);_===0&&R.length===0||this.g.bufferEvents(()=>this.o.splice(T,_,R))}updateWidth(T){this.k.updateWidth(T)}updateElementHeight(T,_){this.k.updateElementHeight(T,_,null)}rerender(){this.k.rerender()}element(T){return this.k.element(T)}indexOf(T){return this.k.indexOf(T)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(T){this.k.setScrollTop(T)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(T){this.k.setScrollLeft(T)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(T){this.z=T,this.k.domNode.setAttribute("aria-label",T)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(T,_){this.k.layout(T,_)}triggerTypeNavigation(){this.t?.trigger()}setSelection(T,_){for(const R of T)if(R<0||R>=this.length)throw new s.ListError(this.C,`Invalid index ${R}`);this.d.set(T,_)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(T=>this.k.element(T))}setAnchor(T){if(typeof T>"u"){this.f.set([]);return}if(T<0||T>=this.length)throw new s.ListError(this.C,`Invalid index ${T}`);this.f.set([T])}getAnchor(){return(0,h.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const T=this.getAnchor();return typeof T>"u"?void 0:this.element(T)}setFocus(T,_){for(const R of T)if(R<0||R>=this.length)throw new s.ListError(this.C,`Invalid index ${R}`);this.c.set(T,_)}focusNext(T=1,_=!1,R,g){if(this.length===0)return;const C=this.c.get(),$=this.G(C.length>0?C[0]+T:0,_,g);$>-1&&this.setFocus([$],R)}focusPrevious(T=1,_=!1,R,g){if(this.length===0)return;const C=this.c.get(),$=this.H(C.length>0?C[0]-T:0,_,g);$>-1&&this.setFocus([$],R)}async focusNextPage(T,_){let R=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);R=R===0?0:R-1;const g=this.getFocus()[0];if(g!==R&&(g===void 0||R>g)){const C=this.H(R,!1,_);C>-1&&g!==C?this.setFocus([C],T):this.setFocus([R],T)}else{const C=this.k.getScrollTop();let $=C+this.k.renderHeight;R>g&&($-=this.k.elementHeight(R)),this.k.setScrollTop($),this.k.getScrollTop()!==C&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusNextPage(T,_))}}async focusPreviousPage(T,_){let R;const g=this.k.getScrollTop();g===0?R=this.k.indexAt(g):R=this.k.indexAfter(g-1);const C=this.getFocus()[0];if(C!==R&&(C===void 0||C>=R)){const $=this.G(R,!1,_);$>-1&&C!==$?this.setFocus([$],T):this.setFocus([R],T)}else{const $=g;this.k.setScrollTop(g-this.k.renderHeight),this.k.getScrollTop()!==$&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusPreviousPage(T,_))}}focusLast(T,_){if(this.length===0)return;const R=this.H(this.length-1,!1,_);R>-1&&this.setFocus([R],T)}focusFirst(T,_){this.focusNth(0,T,_)}focusNth(T,_,R){if(this.length===0)return;const g=this.G(T,!1,R);g>-1&&this.setFocus([g],_)}G(T,_=!1,R){for(let g=0;g<this.length;g++){if(T>=this.length&&!_)return-1;if(T=T%this.length,!R||R(this.element(T)))return T;T++}return-1}H(T,_=!1,R){for(let g=0;g<this.length;g++){if(T<0&&!_)return-1;if(T=(this.length+T%this.length)%this.length,!R||R(this.element(T)))return T;T--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(T=>this.k.element(T))}reveal(T,_){if(T<0||T>=this.length)throw new s.ListError(this.C,`Invalid index ${T}`);const R=this.k.getScrollTop(),g=this.k.elementTop(T),C=this.k.elementHeight(T);if((0,u.isNumber)(_)){const $=C-this.k.renderHeight;this.k.setScrollTop($*(0,o.clamp)(_,0,1)+g)}else{const $=g+C,Y=R+this.k.renderHeight;g<R&&$>=Y||(g<R||$>=Y&&C>=this.k.renderHeight?this.k.setScrollTop(g):$>=Y&&this.k.setScrollTop($-this.k.renderHeight))}}getRelativeTop(T){if(T<0||T>=this.length)throw new s.ListError(this.C,`Invalid index ${T}`);const _=this.k.getScrollTop(),R=this.k.elementTop(T),g=this.k.elementHeight(T);if(R<_||R+g>_+this.k.renderHeight)return null;const C=g-this.k.renderHeight;return Math.abs((_-R)/C)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(T){return this.k.getElementDomId(T)}style(T){this.q.style(T)}I({indexes:T,browserEvent:_}){return{indexes:T,elements:T.map(R=>this.k.element(R)),browserEvent:_}}J(){const T=this.c.get();this.k.domNode.classList.toggle("element-focused",T.length>0),this.K()}K(){const T=this.c.get();if(T.length>0){let _;this.u?.getActiveDescendantId&&(_=this.u.getActiveDescendantId(this.k.element(T[0]))),this.k.domNode.setAttribute("aria-activedescendant",_||this.k.getElementDomId(T[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const T=this.d.get();this.k.domNode.classList.toggle("selection-none",T.length===0),this.k.domNode.classList.toggle("selection-single",T.length===1),this.k.domNode.classList.toggle("selection-multiple",T.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}qe([P.memoize],te.prototype,"onDidChangeFocus",null),qe([P.memoize],te.prototype,"onDidChangeSelection",null),qe([P.memoize],te.prototype,"onContextMenu",null),qe([P.memoize],te.prototype,"onKeyDown",null),qe([P.memoize],te.prototype,"onKeyUp",null),qe([P.memoize],te.prototype,"onKeyPress",null),qe([P.memoize],te.prototype,"onDidFocus",null),qe([P.memoize],te.prototype,"onDidBlur",null),t.List=te}),define(ge[59],me([1,0,7,33,34,11,15]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class h{constructor(u="",s=!1){if(this.value=u,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(u,s=0){return this.value+=r(this.supportThemeIcons?(0,M.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,s){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(u,s,w){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(u),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(u,s){const w=new RegExp((0,W.escapeRegExpCharacters)(s),"g");return u.replace(w,(D,S)=>u.charAt(S-1)!=="\\"?`\\${D}`:D)}}t.MarkdownString=h;function a(n){return c(n)?!n.value:Array.isArray(n)?n.every(a):!0}t.isEmptyMarkdownString=a;function c(n){return n instanceof h?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=c;function P(n,u){return n===u?!0:!n||!u?!1:n.value===u.value&&n.isTrusted===u.isTrusted&&n.supportThemeIcons===u.supportThemeIcons&&n.supportHtml===u.supportHtml&&(n.baseUri===u.baseUri||!!n.baseUri&&!!u.baseUri&&(0,i.isEqual)(v.URI.from(n.baseUri),v.URI.from(u.baseUri)))}t.markdownStringEqual=P;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function l(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=l;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function o(n){const u=[],s=n.split("|").map(D=>D.trim());n=s[0];const w=s[1];if(w){const D=/height=(\d+)/.exec(w),S=/width=(\d+)/.exec(w),f=D?D[1]:"",p=S?S[1]:"",L=isFinite(parseInt(p)),I=isFinite(parseInt(f));L&&u.push(`width="${p}"`),I&&u.push(`height="${f}"`)}return{href:n,dimensions:u}}t.parseHrefAndDimensions=o}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,59,33,73,42,2,76,50,28,47,34,11,15]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e,o,n,u,s,w,D,S,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const p=Object.freeze({image:(Q,J,ve)=>{let pe=[],Me=[];return Q&&({href:Q,dimensions:pe}=(0,P.parseHrefAndDimensions)(Q),Me.push(`src="${(0,P.escapeDoubleQuotes)(Q)}"`)),ve&&Me.push(`alt="${(0,P.escapeDoubleQuotes)(ve)}"`),J&&Me.push(`title="${(0,P.escapeDoubleQuotes)(J)}"`),pe.length&&(Me=Me.concat(pe)),"<img "+Me.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,J,ve)=>typeof Q!="string"?"":(Q===ve&&(ve=(0,P.removeMarkdownEscapes)(ve)),J=typeof J=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(J)):"",Q=(0,P.removeMarkdownEscapes)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${J||Q}">${ve}</a>`)});function L(Q,J={},ve={}){const pe=new o.DisposableStore;let Me=!1;const Re=(0,W.createElement)(J),le=function(C){let $;try{$=(0,u.parse)(decodeURIComponent(C))}catch{}return $?($=(0,w.cloneAndChange)($,Y=>{if(Q.uris&&Q.uris[Y])return f.URI.revive(Q.uris[Y])}),encodeURIComponent(JSON.stringify($))):C},x=function(C,$){const Y=Q.uris&&Q.uris[C];let F=f.URI.revive(Y);return $?C.startsWith(s.Schemas.data+":")?C:(F||(F=f.URI.parse(C)),s.FileAccess.uriToBrowserUri(F).toString(!0)):!F||f.URI.parse(C).toString()===F.toString()?C:(F.query&&(F=F.with({query:le(F.query)})),F.toString())},ne=new n.marked.Renderer;ne.image=p.image,ne.link=p.link,ne.paragraph=p.paragraph;const te=[],ie=[];if(J.codeBlockRendererSync?ne.code=(C,$)=>{const Y=l.defaultGenerator.nextId(),F=J.codeBlockRendererSync(I($),C);return ie.push([Y,F]),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}:J.codeBlockRenderer&&(ne.code=(C,$)=>{const Y=l.defaultGenerator.nextId(),F=J.codeBlockRenderer(I($),C);return te.push(F.then(N=>[Y,N])),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}),J.actionHandler){const C=function(F){let N=F.target;if(!(N.tagName!=="A"&&(N=N.parentElement,!N||N.tagName!=="A")))try{let B=N.dataset.href;B&&(Q.baseUri&&(B=y(f.URI.from(Q.baseUri),B)),J.actionHandler.callback(B,F))}catch(B){(0,a.onUnexpectedError)(B)}finally{F.preventDefault()}},$=J.actionHandler.disposables.add(new i.DomEmitter(Re,"click")),Y=J.actionHandler.disposables.add(new i.DomEmitter(Re,"auxclick"));J.actionHandler.disposables.add(c.Event.any($.event,Y.event)(F=>{const N=new A.StandardMouseEvent(F);!N.leftButton&&!N.middleButton||C(N)})),J.actionHandler.disposables.add(E.addDisposableListener(Re,"keydown",F=>{const N=new v.StandardKeyboardEvent(F);!N.equals(10)&&!N.equals(3)||C(N)}))}Q.supportHtml||(ve.sanitizer=C=>(Q.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",ve.sanitize=!0,ve.silent=!0),ve.renderer=ne;let T=Q.value??"";T.length>1e5&&(T=`${T.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(T=(0,r.markdownEscapeEscapedIcons)(T));let _;if(J.fillInIncompleteTokens){const C={...n.marked.defaults,...ve},$=n.marked.lexer(T,C),Y=ae($);_=n.marked.parser(Y,C)}else _=n.marked.parse(T,ve);Q.supportThemeIcons&&(_=(0,h.renderLabelWithIcons)(_).map($=>typeof $=="string"?$:$.outerHTML).join(""));const g=new DOMParser().parseFromString(d(Q,_),"text/html");if(g.body.querySelectorAll("img").forEach(C=>{const $=C.getAttribute("src");if($){let Y=$;try{Q.baseUri&&(Y=y(f.URI.from(Q.baseUri),Y))}catch{}C.src=x(Y,!0)}}),g.body.querySelectorAll("a").forEach(C=>{const $=C.getAttribute("href");if(C.setAttribute("href",""),!$||/^data:|javascript:/i.test($)||/^command:/i.test($)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test($))C.replaceWith(...C.childNodes);else{let Y=x($,!1);Q.baseUri&&(Y=y(f.URI.from(Q.baseUri),$)),C.dataset.href=Y}}),Re.innerHTML=d(Q,g.body.innerHTML),te.length>0)Promise.all(te).then(C=>{if(Me)return;const $=new Map(C),Y=Re.querySelectorAll("div[data-code]");for(const F of Y){const N=$.get(F.dataset.code??"");N&&E.reset(F,N)}J.asyncRenderCallback?.()});else if(ie.length>0){const C=new Map(ie),$=Re.querySelectorAll("div[data-code]");for(const Y of $){const F=C.get(Y.dataset.code??"");F&&E.reset(Y,F)}}if(J.asyncRenderCallback)for(const C of Re.getElementsByTagName("img")){const $=pe.add(E.addDisposableListener(C,"load",()=>{$.dispose(),J.asyncRenderCallback()}))}return{element:Re,dispose:()=>{Me=!0,pe.dispose()}}}t.renderMarkdown=L;function I(Q){if(!Q)return"";const J=Q.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:Q}function y(Q,J){return/^\w[\w\d+.-]*:/.test(J)?J:Q.path.endsWith("/")?(0,D.resolvePath)(Q,J).toString():(0,D.resolvePath)((0,D.dirname)(Q),J).toString()}function d(Q,J){const{config:ve,allowedSchemes:pe}=m(Q);M.addHook("uponSanitizeAttribute",(Re,le)=>{if(le.attrName==="style"||le.attrName==="class"){if(Re.tagName==="SPAN"){if(le.attrName==="style"){le.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(le.attrValue);return}else if(le.attrName==="class"){le.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(le.attrValue);return}}le.keepAttr=!1;return}});const Me=E.hookDomPurifyHrefAndSrcSanitizer(pe);try{return M.sanitize(J,{...ve,RETURN_TRUSTED_TYPE:!0})}finally{M.removeHook("uponSanitizeAttribute"),Me.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function m(Q){const J=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return Q.isTrusted&&J.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function b(Q){return typeof Q=="string"?Q:O(Q)}t.renderStringAsPlaintext=b;function O(Q){let J=Q.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const ve=n.marked.parse(J,{renderer:Z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,pe=>q.get(pe)??pe);return d({isTrusted:!1},ve).toString()}t.renderMarkdownAsPlaintext=O;const q=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),Z=new e.Lazy(()=>{const Q=new n.marked.Renderer;return Q.code=J=>J,Q.blockquote=J=>J,Q.html=J=>"",Q.heading=(J,ve,pe)=>J+`
`,Q.hr=()=>"",Q.list=(J,ve)=>J,Q.listitem=J=>J+`
`,Q.paragraph=J=>J+`
`,Q.table=(J,ve)=>J+ve+`
`,Q.tablerow=J=>J,Q.tablecell=(J,ve)=>J+" ",Q.strong=J=>J,Q.em=J=>J,Q.codespan=J=>J,Q.br=()=>`
`,Q.del=J=>J,Q.image=(J,ve,pe)=>"",Q.text=J=>J,Q.link=(J,ve,pe)=>pe,Q});function se(Q){let J="";return Q.forEach(ve=>{J+=ve.raw}),J}function ae(Q){let J,ve;for(J=0;J<Q.length;J++){const pe=Q[J];if(pe.type==="paragraph"&&pe.raw.match(/(\n|^)```/)){ve=fe(Q.slice(J));break}if(pe.type==="paragraph"&&pe.raw.match(/(\n|^)\|/)){ve=ue(Q.slice(J));break}}if(ve){const pe=[...Q.slice(0,J),...ve];return pe.links=Q.links,pe}return Q}t.fillInIncompleteTokens=ae;function fe(Q){const J=se(Q);return n.marked.lexer(J+"\n```")}function ue(Q){const J=se(Q),ve=J.split(`
`);let pe,Me=!1;for(let Re=0;Re<ve.length;Re++){const le=ve[Re].trim();if(typeof pe>"u"&&le.match(/^\s*\|/)){const x=le.match(/(\|[^\|]+)(?=\||$)/g);x&&(pe=x.length)}else if(typeof pe=="number")if(le.match(/^\s*\|/)){if(Re!==ve.length-1)return Q;Me=!0}else return Q}if(typeof pe=="number"&&pe>0){const Re=Me?ve.slice(0,-1).join(`
`):J,le=!!Re.match(/\|\s*$/),x=Re+(le?"":"|")+`
|${" --- |".repeat(pe)}`;return n.marked.lexer(x)}return Q}}),define(ge[123],me([1,0,4,9,27,59,33,2,6,99]),function(ee,t,E,M,i,W,v,A,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function c(l,e){(0,h.isString)(e)?l.title=(0,v.stripIcons)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.setupNativeHover=c;class P{constructor(e,o,n){this.c=e,this.d=o,this.f=n}async update(e,o,n){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let u;if(e===void 0||(0,h.isString)(e)||e instanceof HTMLElement)u=e;else if(!(0,h.isFunction)(e.markdown))u=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,a.localize)(0,null),o),this.b=new i.CancellationTokenSource;const s=this.b.token;if(u=await e.markdown(s),u===void 0&&(u=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g(u,o,n)}g(e,o,n){const u=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!u,...n};this.a=this.c.showHover(s,o)}u?.dispose()}h(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(l,e,o,n){let u,s;const w=(L,I)=>{const y=s!==void 0;L&&(s?.dispose(),s=void 0),I&&(u?.dispose(),u=void 0),y&&l.onDidHideHover?.()},D=(L,I,y)=>new M.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new P(l,y||e,L>0),await s.update(o,I,n))},L),S=()=>{if(u)return;const L=new A.DisposableStore,I=m=>w(!1,m.fromElement===e);L.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,I,!0));const y=()=>w(!0,!0);L.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,y,!0));const d={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const m=b=>{d.x=b.x+10,b.target instanceof HTMLElement&&b.target.classList.contains("action-label")&&w(!0,!0)};L.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,m,!0))}L.add(D(l.delay,!1,d)),u=L},f=E.addDisposableListener(e,E.EventType.MOUSE_OVER,S,!0);return{show:L=>{w(!1,!0),D(0,L)},hide:()=>{w(!0,!0)},update:async(L,I)=>{o=L,await s?.update(o,void 0,I)},dispose:()=>{f.dispose(),w(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,36,13,3,41,2,5,101,92]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const l=E.$,e="selectOption.entry.template";class o{get templateId(){return e}renderTemplate(s){const w=Object.create(null);return w.root=s,w.text=E.append(s,l(".option-text")),w.detail=E.append(s,l(".option-detail")),w.decoratorRight=E.append(s,l(".option-decorator-right")),w}renderElement(s,w,D){const S=D,f=s.text,p=s.detail,L=s.decoratorRight,I=s.isDisabled;S.text.textContent=f,S.detail.textContent=p||"",S.decoratorRight.innerText=L||"",I?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends c.Disposable{constructor(s,w,D,S,f){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.H=!1,this.f=!1,this.n=S,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=n.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new h.Emitter,this.B(this.m),this.J(),this.I(D),this.l=w||0,s&&this.setOptions(s,w),this.M()}getHeight(){return 22}getTemplateId(){return e}I(s){this.r=s,this.s=E.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=E.append(this.s,l(".select-box-details-pane"));const w=E.append(this.s,l(".select-box-dropdown-container-width-control")),D=E.append(w,l(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",E.append(D,this.w),this.z=0,this.t=E.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(E.addDisposableListener(this.s,E.EventType.DRAG_START,S=>{E.EventHelper.stop(S,!0)}))}J(){this.B(E.addStandardDisposableListener(this.h,"change",w=>{this.l=w.target.selectedIndex,this.m.fire({index:w.target.selectedIndex,selected:w.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(E.addDisposableListener(this.h,E.EventType.CLICK,w=>{E.EventHelper.stop(w),this.f?this.R(!0):this.Q()})),this.B(E.addDisposableListener(this.h,E.EventType.MOUSE_DOWN,w=>{E.EventHelper.stop(w)}));let s;this.B(E.addDisposableListener(this.h,"touchstart",w=>{s=this.f})),this.B(E.addDisposableListener(this.h,"touchend",w=>{E.EventHelper.stop(w),s?this.R(!0):this.Q()})),this.B(E.addDisposableListener(this.h,E.EventType.KEY_DOWN,w=>{const D=new i.StandardKeyboardEvent(w);let S=!1;P.isMacintosh?(D.keyCode===18||D.keyCode===16||D.keyCode===10||D.keyCode===3)&&(S=!0):(D.keyCode===18&&D.altKey||D.keyCode===16&&D.altKey||D.keyCode===10||D.keyCode===3)&&(S=!0),S&&(this.Q(),E.EventHelper.stop(w,!0))}))}get onDidSelect(){return this.m.event}setOptions(s,w){A.equals(this.k,s)||(this.k=s,this.h.options.length=0,this.C=!1,this.G=void 0,this.k.forEach((D,S)=>{this.h.add(this.P(D.text,S,D.isDisabled)),typeof D.description=="string"&&(this.C=!0)})),w!==void 0&&(this.select(w),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(s){s>=0&&s<this.k.length?this.l=s:s>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.N()}M(){const s=[];this.n.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=s.join(`
`)}N(){const s=this.n.selectBackground??"",w=this.n.selectForeground??"",D=this.n.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=w,this.h.style.borderColor=D}O(){const s=this.n.selectBackground??"",w=E.asCssValueWithDefault(this.n.selectListBackground,s);this.v.style.backgroundColor=w,this.D.style.backgroundColor=w;const D=this.n.focusBorder??"";this.s.style.outlineColor=D,this.s.style.outlineOffset="-1px",this.u.style(this.n)}P(s,w,D){const S=document.createElement("option");return S.value=s,S.text=s,S.disabled=!!D,S}Q(){this.D.innerText="",!(!this.r||this.f)&&(this.Y(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s,!0),layout:()=>{this.W()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s),layout:()=>this.W(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(s){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.r.hideContextView())}S(s,w){return s.appendChild(this.s),this.W(w),{dispose:()=>{try{s.removeChild(this.s)}catch{}}}}U(){let s=0;return this.k.forEach((w,D)=>{this.db(D),this.D.offsetHeight>s&&(s=this.D.offsetHeight)}),s}W(s){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const w=E.getDomNodePagePosition(this.h),D=getComputedStyle(this.h),S=parseFloat(D.getPropertyValue("--dropdown-padding-top"))+parseFloat(D.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-w.top-w.height-(this.g.minBottomMargin||0),p=w.top-n.b,L=this.h.offsetWidth,I=this.X(this.w),y=Math.max(I,Math.round(L)).toString()+"px";this.s.style.width=y,this.u.getHTMLElement().style.height="",this.u.layout();let d=this.u.contentHeight;this.C&&this.G===void 0&&(this.G=this.U());const m=this.C?this.G:0,b=d+S+m,O=Math.floor((f-S-m)/this.getHeight()),q=Math.floor((p-S-m)/this.getHeight());if(s)return w.top+w.height>window.innerHeight-22||w.top<n.b||O<1&&q<1?!1:(O<n.c&&q>O&&this.k.length>O?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(w.top+w.height>window.innerHeight-22||w.top<n.b||this.z===0&&O<1||this.z===1&&q<1)return this.R(!0),!1;if(this.z===0){if(this.f&&O+q<1)return this.R(!0),!1;b>f&&(d=O*this.getHeight())}else b>p&&(d=q*this.getHeight());return this.u.layout(d),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=d+S+"px",this.s.style.height=""):this.s.style.height=d+S+"px",this.db(this.l),this.s.style.width=y,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}X(s){let w=0;if(s){let D=0,S=0;this.k.forEach((f,p)=>{const L=f.detail?f.detail.length:0,I=f.decoratorRight?f.decoratorRight.length:0,y=f.text.length+L+I;y>S&&(D=p,S=y)}),s.textContent=this.k[D].text+(this.k[D].decoratorRight?this.k[D].decoratorRight+" ":""),w=E.getTotalWidth(s)}return w}Y(s){if(this.u)return;this.v=E.append(s,l(".select-box-dropdown-list-container")),this.p=new o,this.u=new v.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let f=S.text;return S.detail&&(f+=`. ${S.detail}`),S.decoratorRight&&(f+=`. ${S.decoratorRight}`),S.description&&(f+=`. ${S.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const w=this.B(new M.DomEmitter(this.v,"keydown")),D=h.Event.chain(w.event).filter(()=>this.u.length>0).map(S=>new i.StandardKeyboardEvent(S));this.B(D.filter(S=>S.keyCode===3).on(S=>this.fb(S),this)),this.B(D.filter(S=>S.keyCode===2).on(S=>this.fb(S),this)),this.B(D.filter(S=>S.keyCode===9).on(S=>this.eb(S),this)),this.B(D.filter(S=>S.keyCode===16).on(S=>this.hb(S),this)),this.B(D.filter(S=>S.keyCode===18).on(S=>this.gb(S),this)),this.B(D.filter(S=>S.keyCode===12).on(this.jb,this)),this.B(D.filter(S=>S.keyCode===11).on(this.ib,this)),this.B(D.filter(S=>S.keyCode===14).on(this.kb,this)),this.B(D.filter(S=>S.keyCode===13).on(this.lb,this)),this.B(D.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=80&&S.keyCode<=108).on(this.mb,this)),this.B(E.addDisposableListener(this.u.getHTMLElement(),E.EventType.POINTER_UP,S=>this.Z(S))),this.B(this.u.onMouseOver(S=>typeof S.index<"u"&&this.u.setFocus([S.index]))),this.B(this.u.onDidChangeFocus(S=>this.cb(S))),this.B(E.addDisposableListener(this.s,E.EventType.FOCUS_OUT,S=>{!this.f||E.isAncestor(S.relatedTarget,this.s)||this.ab()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(s){if(!this.u.length)return;E.EventHelper.stop(s);const w=s.target;if(!w||w.classList.contains("slider"))return;const D=w.closest(".monaco-list-row");if(!D)return;const S=Number(D.getAttribute("data-index")),f=D.classList.contains("option-disabled");S>=0&&S<this.k.length&&!f&&(this.l=S,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.y&&this.select(this.y),this.R(!1))}bb(s,w){const D=f=>{for(let p=0;p<f.childNodes.length;p++){const L=f.childNodes.item(p);(L.tagName&&L.tagName.toLowerCase())==="img"?f.removeChild(L):D(L)}},S=(0,W.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:w});return S.element.classList.add("select-box-description-markdown"),D(S.element),S.element}cb(s){!this.f||!this.C||this.db(s.indexes[0])}db(s){this.D.innerText="";const w=this.k[s],D=w?.description??"",S=w?.descriptionIsMarkdown??!1;if(D){if(S){const f=w.descriptionMarkdownActionHandler;this.D.appendChild(this.bb(D,f))}else this.D.innerText=D;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}eb(s){E.EventHelper.stop(s),this.select(this.y),this.R(!0)}fb(s){E.EventHelper.stop(s),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(s){if(this.l<this.k.length-1){E.EventHelper.stop(s,!0);const w=this.k[this.l+1].isDisabled;if(w&&this.k.length>this.l+2)this.l+=2;else{if(w)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}hb(s){this.l>0&&(E.EventHelper.stop(s,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}ib(s){E.EventHelper.stop(s),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(s){E.EventHelper.stop(s),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}kb(s){E.EventHelper.stop(s),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(s){E.EventHelper.stop(s),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}mb(s){const w=a.KeyCodeUtils.toString(s.keyCode);let D=-1;for(let S=0;S<this.k.length-1;S++)if(D=(S+this.l+1)%this.k.length,this.k[D].text.charAt(0).toUpperCase()===w&&!this.k[D].isDisabled){this.select(D),this.u.setFocus([D]),this.u.reveal(this.u.getFocus()[0]),E.EventHelper.stop(s);break}}dispose(){this.R(!1),super.dispose()}}n.a=32,n.b=2,n.c=3,t.SelectBoxList=n}),define(ge[125],me([1,0,36,124,118,19,5,91]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends W.Widget{constructor(a,c,P,r,l){super(),v.isMacintosh&&!l?.useCustomDrawn?this.a=new i.SelectBoxNative(a,c,r,l):this.a=new M.SelectBoxList(a,c,P,r,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(a,c){this.a.setOptions(a,c)}select(a){this.a.select(a)}setAriaLabel(a){this.a.setAriaLabel(a)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(a){this.a.setFocusable(a)}render(a){this.a.render(a)}}t.SelectBox=A}),define(ge[60],me([1,0,18,51,4,23,123,125,31,2,5,6,96,48]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class l extends a.Disposable{get action(){return this._action}constructor(u,s,w={}){super(),this.m=w,this._context=u||this,this._action=s,s instanceof h.Action&&this.B(s.onDidChange(D=>{!this.element||this.t(D)}))}t(u){u.enabled!==void 0&&this.u(),u.checked!==void 0&&this.G(),u.class!==void 0&&this.F(),u.label!==void 0&&(this.w(),this.C()),u.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.ActionRunner)),this.j}set actionRunner(u){this.j=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const s=this.element=u;this.B(W.Gesture.addTarget(u));const w=this.m&&this.m.draggable;w&&(u.draggable=!0,E.isFirefox&&this.B((0,i.addDisposableListener)(u,i.EventType.DRAG_START,D=>D.dataTransfer?.setData(M.DataTransfers.TEXT,this._action.label)))),this.B((0,i.addDisposableListener)(s,W.EventType.Tap,D=>this.onClick(D,!0))),this.B((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,D=>{w||i.EventHelper.stop(D,!0),this._action.enabled&&D.button===0&&s.classList.add("active")})),c.isMacintosh&&this.B((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,D=>{D.button===0&&D.ctrlKey===!0&&this.onClick(D)})),this.B((0,i.addDisposableListener)(s,i.EventType.CLICK,D=>{i.EventHelper.stop(D,!0),this.m&&this.m.isMenu||this.onClick(D)})),this.B((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,D=>{i.EventHelper.stop(D,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(D=>{this.B((0,i.addDisposableListener)(s,D,S=>{i.EventHelper.stop(S),s.classList.remove("active")}))})}onClick(u,s=!1){i.EventHelper.stop(u,!0);const w=P.isUndefinedOrNull(this._context)?this.m?.useEventAsContext?u:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,w)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const u=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(u):(this.f=(0,v.setupCustomHover)(this.m.hoverDelegate,this.element,u),this.q.add(this.f))):this.element.title=u}D(){if(this.element){const u=this.z()??"";this.element.setAttribute("aria-label",u)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=l;class e extends l{constructor(u,s,w){super(u,s,w),this.m=w,this.m.icon=w.icon!==void 0?w.icon:!1,this.m.label=w.label!==void 0?w.label:!0,this.I=""}render(u){super.render(u),this.element&&(this.p=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.p&&(this._action.id===h.Separator.ID?this.p.setAttribute("role","presentation"):this.m.isMenu?this.p.setAttribute("role","menuitem"):this.p.setAttribute("role","button")),this.m.label&&this.m.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(u){this.p&&(this.p.tabIndex=u?0:-1)}w(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}z(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(u=this.action.label,this.m.keybinding&&(u=r.localize(0,null,u,this.m.keybinding))),u??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.u()):this.p?.classList.remove("codicon")}u(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.p){const u=this.z()??"";this.p.setAttribute("aria-label",u)}}G(){this.p&&(this.action.checked?this.p.classList.add("checked"):this.p.classList.remove("checked"))}}t.ActionViewItem=e;class o extends l{constructor(u,s,w,D,S,f,p){super(u,s),this.b=new A.SelectBox(w,D,S,f,p),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(u,s){this.b.setOptions(u,s)}select(u){this.b.select(u)}g(){this.B(this.b.onDidSelect(u=>this.k(u.selected,u.index)))}k(u,s){this.actionRunner.run(this._action,this.n(u,s))}n(u,s){return u}setFocusable(u){this.b.setFocusable(u)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(u){this.b.render(u)}}t.SelectActionViewItem=o}),define(ge[61],me([1,0,4,14,60,31,3,2,6,48]),function(ee,t,E,M,i,W,v,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var a;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(a=t.ActionsOrientation||(t.ActionsOrientation={}));class c extends A.Disposable{constructor(l,e={}){super(),this.g=this.B(new A.DisposableStore),this.n=this.B(new A.DisposableMap),this.t=!1,this.u=!0,this.w=this.B(new v.Emitter),this.onDidBlur=this.w.event,this.y=this.B(new v.Emitter({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new v.Emitter),this.onDidRun=this.C.event,this.D=this.B(new v.Emitter),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new W.ActionRunner,this.g.add(this.f)),this.g.add(this.f.onDidRun(u=>this.C.fire(u))),this.g.add(this.f.onWillRun(u=>this.D.fire(u))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let o,n;switch(this.l){case 0:o=[15],n=[17];break;case 1:o=[16],n=[18],this.domNode.className+=" vertical";break}this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,u=>{const s=new M.StandardKeyboardEvent(u);let w=!0;const D=typeof this.r=="number"?this.viewItems[this.r]:void 0;o&&(s.equals(o[0])||s.equals(o[1]))?w=this.M():n&&(s.equals(n[0])||s.equals(n[1]))?w=this.L():s.equals(9)&&this.z?this.y.fire():s.equals(14)?w=this.I():s.equals(13)?w=this.J():s.equals(2)&&D instanceof i.BaseActionViewItem&&D.trapsArrowNavigation?w=this.L():this.G(s)?this.m.keyDown?this.O(s):this.t=!0:w=!1,w&&(s.preventDefault(),s.stopPropagation())})),this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,u=>{const s=new M.StandardKeyboardEvent(u);this.G(s)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.H()})),this.s=this.B(E.trackFocus(this.domNode)),this.B(this.s.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this.w.fire(),this.r=void 0,this.p=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),l.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(l){l?this.v.setAttribute("aria-label",l):this.v.removeAttribute("aria-label")}setFocusable(l){if(this.u=l,this.u){const e=this.viewItems.find(o=>o instanceof i.BaseActionViewItem&&o.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}G(l){let e=!1;return this.m.keys.forEach(o=>{e=e||l.equals(o)}),e}H(){for(let l=0;l<this.v.children.length;l++){const e=this.v.children[l];if(E.isAncestor(E.getActiveElement(),e)){this.r=l;break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.v;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const o=Array.isArray(l)?l:[l];let n=h.isNumber(e.index)?e.index:null;o.forEach(u=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let w;const D={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(w=this.b.actionViewItemProvider(u,D)),w||(w=new i.ActionViewItem(this.context,u,D)),this.b.allowContextMenu||this.n.set(w,E.addDisposableListener(s,E.EventType.CONTEXT_MENU,S=>{E.EventHelper.stop(S,!0)})),w.actionRunner=this.f,w.setActionContext(this.context),w.render(s),this.u&&w instanceof i.BaseActionViewItem&&this.viewItems.length===0&&w.setFocusable(!0),n===null||n<0||n>=this.v.children.length?(this.v.appendChild(s),this.viewItems.push(w)):(this.v.insertBefore(s,this.v.children[n]),this.viewItems.splice(n,0,w),n++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[l]),this.n.deleteAndDispose(this.viewItems[l]),(0,A.dispose)(this.viewItems.splice(l,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,A.dispose)(this.viewItems),this.n.clearAndDisposeAll(),E.clearNode(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,o;if(l===void 0?e=!0:typeof l=="number"?o=l:typeof l=="boolean"&&(e=l),e&&typeof this.r>"u"){const n=this.viewItems.findIndex(u=>u.isEnabled());this.r=n===-1?void 0:n,this.N(void 0,void 0,!0)}else o!==void 0&&(this.r=o),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(l){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let o;do{if(!l&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,o=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===W.Separator.ID));return this.N(),!0}M(l){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let o;do{if(this.r=this.r-1,this.r<0){if(!l&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}o=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===W.Separator.ID));return this.N(!0),!0}N(l,e,o=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const n=this.r!==void 0&&this.viewItems[this.r];if(n){let u=!0;h.isFunction(n.focus)||(u=!1),this.b.focusOnlyEnabledItems&&h.isFunction(n.isEnabled)&&!n.isEnabled()&&(u=!1),n.action.id===W.Separator.ID&&(u=!1),u?(o||this.p!==this.r)&&(n.focus(l),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(l){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof i.BaseActionViewItem){const o=e._context===null||e._context===void 0?l:e._context;this.run(e._action,o)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,A.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=c;function P(r){if(!r.length)return r;let l=-1;for(let o=0;o<r.length;o++)if(r[o].id!==W.Separator.ID){l=o;break}if(l===-1)return[];r=r.slice(l);for(let o=r.length-1;o>=0&&r[o].id===W.Separator.ID;o--)r.splice(o,1);let e=!1;for(let o=r.length-1;o>=0;o--){const n=r[o].id===W.Separator.ID;n&&!e?r.splice(o,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=P}),define(ge[62],me([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const l=E.$;var e;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(e=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class o extends h.Widget{constructor(s,w,D){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new a.Emitter),this.onDidChange=this.I.event,this.J=this.B(new a.Emitter),this.onDidHeightChange=this.J.event,this.a=w,this.g=D,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=E.append(s,l(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",f=E.append(this.element,l(".ibwrapper"));if(this.b=E.append(f,l(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=E.append(f,l("div.mirror")),this.t.innerText="\xA0",this.H=new A.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),E.append(s,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(I=>this.b.scrollTop=I.scrollTop));const p=this.B(new M.DomEmitter(document,"selectionchange")),L=a.Event.filter(p.event,()=>document.getSelection()?.anchorNode===f);this.B(L(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new W.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(s){this.i=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.l=s,this.b.title=s}setAriaLabel(s){this.n=s,s?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.R())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.v=="number"?this.v:E.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let w=0;if(this.t){const D=parseFloat(this.t.style.paddingLeft||"")||0,S=parseFloat(this.t.style.paddingRight||"")||0;w=D+S}this.b.style.width=s-w+"px"}else this.b.style.width=s+"px";this.t&&(this.t.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.t&&(this.t.style.paddingRight=s+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const s=this.w,w=this.v,D=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:s,height:w}),this.H.setScrollPosition({scrollTop:D})}showMessage(s,w){if(this.s==="open"&&(0,P.equals)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(s.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||w)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let s=null;return this.r&&(s=this.r(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const w=this.g.inputBoxStyles;switch(s){case 1:return{border:w.inputValidationInfoBorder,background:w.inputValidationInfoBackground,foreground:w.inputValidationInfoForeground};case 2:return{border:w.inputValidationWarningBorder,background:w.inputValidationWarningBackground,foreground:w.inputValidationWarningForeground};default:return{border:w.inputValidationErrorBorder,background:w.inputValidationErrorBackground,foreground:w.inputValidationErrorForeground}}}O(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let s;const w=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.h)return null;s=E.append(S,l(".monaco-inputbox-container")),w();const f={inline:!0,className:"monaco-inputbox-message"},p=this.h.formatContent?(0,i.renderFormattedText)(this.h.content,f):(0,i.renderText)(this.h.content,f);p.classList.add(this.O(this.h.type));const L=this.stylesForType(this.h.type);return p.style.backgroundColor=L.background??"",p.style.color=L.foreground??"",p.style.border=L.border?`1px solid ${L.border}`:"",E.append(s,p),null},onHide:()=>{this.s="closed"},layout:w});let D;this.h.type===3?D=r.localize(0,null,this.h.content):this.h.type===2?D=r.localize(1,null,this.h.content):D=r.localize(2,null,this.h.content),v.alert(D),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const s=this.value,D=s.charCodeAt(s.length-1)===10?" ":"";(s+D).replace(/\u000c/g,"")?this.t.textContent=s+D:this.t.innerText="\xA0",this.layout()}U(){const s=this.g.inputBoxStyles,w=s.inputBackground??"",D=s.inputForeground??"",S=s.inputBorder??"";this.element.style.backgroundColor=w,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${E.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.t)return;const s=this.w;this.w=E.getTotalHeight(this.t),s!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(s){const w=this.inputElement,D=w.selectionStart,S=w.selectionEnd,f=w.value;D!==null&&S!==null&&(this.value=f.substr(0,D)+s+f.substr(S),w.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=o;class n extends o{constructor(s,w,D){const S=r.localize(3,null),f=` or \u21C5 ${S}`,p=` (\u21C5 ${S})`;super(s,w,D),this.Y=this.B(new a.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new a.Emitter),this.onDidBlur=this.Z.event,this.W=new c.HistoryNavigator(D.history,100);const L=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.i.endsWith(f)&&!this.i.endsWith(p)&&this.W.getHistory().length){const I=this.i.endsWith(")")?f:p,y=this.i+I;D.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=y:this.setPlaceHolder(y)}};this.X=new MutationObserver((I,y)=>{I.forEach(d=>{d.target.textContent||L()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>L()),this.C(this.b,()=>{const I=y=>{if(this.i.endsWith(y)){const d=this.i.slice(0,this.i.length-y.length);return D.showPlaceholderOnFocus?this.i=d:this.setPlaceHolder(d),!0}else return!1};I(p)||I(f)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(s){this.value&&(s||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let s=this.eb();s&&(s=s===this.value?this.eb():s),s&&(this.value=s,v.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let s=this.db();s&&(s=s===this.value?this.db():s),s&&(this.value=s,v.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let s=this.W.current();return s||(s=this.W.last(),this.W.next()),s}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=n}),define(ge[63],me([1,0,60,19,16,17,3,93]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class A extends E.BaseActionViewItem{constructor(P,r,l){super(P,r,l),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(P){this.element=P,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(P){this.a.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=A;class h extends M.Widget{constructor(P){super(),this.a=this.B(new v.Emitter),this.onChange=this.a.event,this.b=this.B(new v.Emitter),this.onKeyDown=this.b.event,this.c=P,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(P){this.s=P,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(P){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=P,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=h;class a extends M.Widget{constructor(P,r,l){super(),this.c=P,this.g=r,this.a=new h({title:this.c,isChecked:this.g,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=l,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(P){this.a.checked=P,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=a}),define(ge[126],me([1,0,63,16,98]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),v=i.localize(1,null),A=i.localize(2,null);class h extends E.Toggle{constructor(r){super({icon:M.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=h;class a extends E.Toggle{constructor(r){super({icon:M.Codicon.wholeWord,title:v+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=a;class c extends E.Toggle{constructor(r){super({icon:M.Codicon.regex,title:A+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=c}),define(ge[127],me([1,0,4,126,62,19,3,97,2,87]),function(ee,t,E,M,i,W,v,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const a=A.localize(0,null);class c extends W.Widget{constructor(r,l,e){super(),this.i=!0,this.l=!1,this.n=new h.DisposableStore,this.H=[],this.I=this.B(new v.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new v.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new v.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new v.Emitter),this.onInput=this.M.event,this.N=this.B(new v.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new v.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new v.Emitter),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||a,this.h=!!e.showCommonFindToggles;const o=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",u=e.appendRegexLabel||"",s=e.history||[],w=!!e.flexibleHeight,D=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.HistoryInputBox(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:w,flexibleWidth:D,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new M.RegexToggle({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(p=>{this.P.fire(p)})),this.w=this.B(new M.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new M.CaseSensitiveToggle({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(p=>{this.O.fire(p)}));const f=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,p=>{if(p.equals(15)||p.equals(17)||p.equals(9)){const L=f.indexOf(document.activeElement);if(L>=0){let I=-1;p.equals(17)?I=(L+1)%f.length:p.equals(15)&&(L===0?I=f.length-1:I=L-1),p.equals(9)?(f[L].blur(),this.inputBox.focus()):I>=0&&f[I].focus(),E.EventHelper.stop(p,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.l=!0})),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,f=>this.J.fire(f)),this.u(this.inputBox.inputElement,f=>this.N.fire(f)),this.z(this.inputBox.inputElement,f=>this.M.fire()),this.j(this.inputBox.inputElement,f=>this.L.fire(f))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.H)l.domNode.remove();this.H=[],this.n.dispose(),this.n=new h.DisposableStore;for(const l of r??[])this.n.add(l),this.s.appendChild(l.domNode),this.n.add(l.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(l);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((l,e)=>l+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}c.OPTION_CHANGE="optionChange",t.FindInput=c}),define(ge[128],me([1,0,4,20,14,61,127,62,58,36,63,55,24,31,13,9,16,17,69,3,32,2,44,6,102,94]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e,o,n,u,s,w,D,S,f,p,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class I extends h.ElementsDragAndDropData{set context(g){this.c.context=g}get context(){return this.c.context}constructor(g){super(g.elements.map(C=>C.element)),this.c=g}}function y(R){return R instanceof h.ElementsDragAndDropData?new I(R):R}class d{constructor(g,C){this.c=g,this.d=C,this.b=S.Disposable.None}getDragURI(g){return this.d.getDragURI(g.element)}getDragLabel(g,C){if(this.d.getDragLabel)return this.d.getDragLabel(g.map($=>$.element),C)}onDragStart(g,C){this.d.onDragStart?.(y(g),C)}onDragOver(g,C,$,Y,F=!0){const N=this.d.onDragOver(y(g),C&&C.element,$,Y),B=this.a!==C;if(B&&(this.b.dispose(),this.a=C),typeof C>"u")return N;if(B&&typeof N!="boolean"&&N.autoExpand&&(this.b=(0,o.disposableTimeout)(()=>{const j=this.c(),G=j.getNodeLocation(C);j.isCollapsed(G)&&j.setCollapsed(G,!1),this.a=void 0},500)),typeof N=="boolean"||!N.accept||typeof N.bubble>"u"||N.feedback){if(!F){const j=typeof N=="boolean"?N:N.accept,G=typeof N=="boolean"?void 0:N.effect;return{accept:j,effect:G,feedback:[$]}}return N}if(N.bubble===1){const j=this.c(),G=j.getNodeLocation(C),re=j.getParentNodeLocation(G),he=j.getNode(re),De=re&&j.getListIndex(re);return this.onDragOver(g,he,De,Y,!1)}const k=this.c(),H=k.getNodeLocation(C),z=k.getListIndex(H),U=k.getListRenderCount(H);return{...N,feedback:(0,e.range)(z,z+U)}}drop(g,C,$,Y){this.b.dispose(),this.a=void 0,this.d.drop(y(g),C&&C.element,$,Y)}onDragEnd(g){this.d.onDragEnd?.(g)}}function m(R,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(C){return g.identityProvider.getId(C.element)}},dnd:g.dnd&&new d(R,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(C){return g.multipleSelectionController.isSelectionSingleChangeEvent({...C,element:C.element})},isSelectionRangeChangeEvent(C){return g.multipleSelectionController.isSelectionRangeChangeEvent({...C,element:C.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(C){const $=R(),Y=$.getNodeLocation(C),F=$.getParentNodeLocation(Y);return $.getNode(F).visibleChildrenCount},getPosInSet(C){return C.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?C=>g.accessibilityProvider.isChecked(C.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?C=>g.accessibilityProvider.getRole(C.element):()=>"treeitem",getAriaLabel(C){return g.accessibilityProvider.getAriaLabel(C.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?C=>g.accessibilityProvider.getAriaLevel(C.element):C=>C.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(C=>g.accessibilityProvider.getActiveDescendantId(C.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(C){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(C.element)}}}}class b{constructor(g){this.a=g}getHeight(g){return this.a.getHeight(g.element)}getTemplateId(g){return this.a.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(g.element)}setDynamicHeight(g,C){this.a.setDynamicHeight?.(g.element,C)}}t.ComposedTreeDelegate=b;class O{static lift(g){return g instanceof O?g:new O(g)}static empty(g=0){return new O({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const C of g.expanded)this.expanded[C]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=O;var q;(function(R){R.None="none",R.OnHover="onHover",R.Always="always"})(q=t.RenderIndentGuides||(t.RenderIndentGuides={}));class Z{get elements(){return this.b}constructor(g,C=[]){this.b=C,this.a=new S.DisposableStore,this.onDidChange=w.Event.forEach(g,$=>this.b=$,this.a)}dispose(){this.a.dispose()}}class se{constructor(g,C,$,Y,F,N={}){this.o=g,this.p=C,this.q=Y,this.s=F,this.b=new Map,this.c=new Map,this.d=se.a,this.f=!1,this.g=!1,this.j=new Set,this.k=S.Disposable.None,this.m=new S.DisposableStore,this.templateId=g.templateId,this.updateOptions(N),w.Event.map($,B=>B.node)(this.u,this,this.m),g.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(g={}){if(typeof g.indent<"u"){const C=(0,f.clamp)(g.indent,0,40);if(C!==this.d){this.d=C;for(const[$,Y]of this.c)this.v($,Y)}}if(typeof g.renderIndentGuides<"u"){const C=g.renderIndentGuides!==q.None;if(C!==this.g){this.g=C;for(const[$,Y]of this.c)this.w($,Y);if(this.k.dispose(),C){const $=new S.DisposableStore;this.q.onDidChange(this.x,this,$),this.k=$,this.x(this.q.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.f=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const C=(0,E.append)(g,(0,E.$)(".monaco-tl-row")),$=(0,E.append)(C,(0,E.$)(".monaco-tl-indent")),Y=(0,E.append)(C,(0,E.$)(".monaco-tl-twistie")),F=(0,E.append)(C,(0,E.$)(".monaco-tl-contents")),N=this.o.renderTemplate(F);return{container:g,indent:$,twistie:Y,indentGuidesDisposable:S.Disposable.None,templateData:N}}renderElement(g,C,$,Y){this.c.set(g,$),this.b.set(g.element,g),this.v(g,$),this.o.renderElement(g,C,$.templateData,Y)}disposeElement(g,C,$,Y){$.indentGuidesDisposable.dispose(),this.o.disposeElement?.(g,C,$.templateData,Y),typeof Y=="number"&&(this.c.delete(g),this.b.delete(g.element))}disposeTemplate(g){this.o.disposeTemplate(g.templateData)}t(g){const C=this.b.get(g);!C||this.u(C)}u(g){const C=this.c.get(g);!C||(this.x(this.q.elements),this.v(g,C))}v(g,C){const $=se.a+(g.depth-1)*this.d;C.twistie.style.paddingLeft=`${$}px`,C.indent.style.width=`${$+this.d-16}px`,g.collapsible?C.container.setAttribute("aria-expanded",String(!g.collapsed)):C.container.removeAttribute("aria-expanded"),C.twistie.classList.remove(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Y=!1;this.o.renderTwistie&&(Y=this.o.renderTwistie(g.element,C.twistie)),g.collapsible&&(!this.f||g.visibleChildrenCount>0)?(Y||C.twistie.classList.add(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),C.twistie.classList.add("collapsible"),C.twistie.classList.toggle("collapsed",g.collapsed)):C.twistie.classList.remove("collapsible","collapsed"),this.w(g,C)}w(g,C){if((0,E.clearNode)(C.indent),C.indentGuidesDisposable.dispose(),!this.g)return;const $=new S.DisposableStore,Y=this.p();for(;;){const F=Y.getNodeLocation(g),N=Y.getParentNodeLocation(F);if(!N)break;const B=Y.getNode(N),k=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(B)&&k.classList.add("active"),C.indent.childElementCount===0?C.indent.appendChild(k):C.indent.insertBefore(k,C.indent.firstElementChild),this.s.add(B,k),$.add((0,S.toDisposable)(()=>this.s.delete(B,k))),g=B}C.indentGuidesDisposable=$}x(g){if(!this.g)return;const C=new Set,$=this.p();g.forEach(Y=>{const F=$.getNodeLocation(Y);try{const N=$.getParentNodeLocation(F);Y.collapsible&&Y.children.length>0&&!Y.collapsed?C.add(Y):N&&C.add($.getNode(N))}catch{}}),this.j.forEach(Y=>{C.has(Y)||this.s.forEach(Y,F=>F.classList.remove("active"))}),C.forEach(Y=>{this.j.has(Y)||this.s.forEach(Y,F=>F.classList.add("active"))}),this.j=C}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,S.dispose)(this.m)}}se.a=8;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(g){this.c=g,this.d=g.toLowerCase()}constructor(g,C,$){this.g=g,this.j=C,this.k=$,this.a=0,this.b=0,this.c="",this.d="",this.f=new S.DisposableStore,g.onWillRefilter(this.m,this,this.f)}filter(g,C){let $=1;if(this.k){const N=this.k.filter(g,C);if(typeof N=="boolean"?$=N?1:0:(0,P.isFilterResult)(N)?$=(0,P.getVisibleState)(N.visibility):$=N,$===0)return!1}if(this.a++,!this.c)return this.b++,{data:D.FuzzyScore.Default,visibility:$};const Y=this.j.getKeyboardNavigationLabel(g),F=Array.isArray(Y)?Y:[Y];for(const N of F){const B=N&&N.toString();if(typeof B>"u")return{data:D.FuzzyScore.Default,visibility:$};let k;if(this.g.findMatchType===ve.Contiguous){const H=B.toLowerCase().indexOf(this.d);if(H>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let z=this.d.length;z>0;z--)k.push(H+z-1)}}else k=(0,D.fuzzyScore)(this.c,this.d,0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,F.length===1?{data:k,visibility:$}:{data:{label:B,score:k},visibility:$}}return this.g.findMode===J.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(g):2:{data:D.FuzzyScore.Default,visibility:$}}m(){this.a=0,this.b=0}dispose(){(0,S.dispose)(this.f)}}class fe extends c.Toggle{constructor(g){super({icon:n.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.ModeToggle=fe;class ue extends c.Toggle{constructor(g){super({icon:n.Codicon.searchFuzzy,title:(0,L.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const Q={inputBoxStyles:A.unthemedInboxStyles,toggleStyles:c.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var J;(function(R){R[R.Highlight=0]="Highlight",R[R.Filter=1]="Filter"})(J=t.TreeFindMode||(t.TreeFindMode={}));var ve;(function(R){R[R.Fuzzy=0]="Fuzzy",R[R.Contiguous=1]="Contiguous"})(ve=t.TreeFindMatchType||(t.TreeFindMatchType={}));class pe extends S.Disposable{set mode(g){this.b.checked=g===J.Filter,this.f.inputBox.setPlaceHolder(g===J.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(g){this.c.checked=g===ve.Fuzzy}get value(){return this.f.inputBox.value}set value(g){this.f.inputBox.value=g}constructor(g,C,$,Y,F,N){super(),this.p=C,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new w.Emitter,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.a.root),this.B((0,S.toDisposable)(()=>g.removeChild(this.a.root)));const B=N?.styles??Q;B.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=B.listFilterWidgetBackground),B.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${B.listFilterWidgetShadow}`),this.b=this.B(new fe({...B.toggleStyles,isChecked:Y===J.Filter})),this.c=this.B(new ue({...B.toggleStyles,isChecked:F===ve.Fuzzy})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?J.Filter:J.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?ve.Fuzzy:ve.Contiguous,this.q),this.f=this.B(new v.FindInput(this.a.findInput,$,{label:(0,L.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:B.inputBoxStyles,toggleStyles:B.toggleStyles,history:N?.history})),this.g=this.B(new W.ActionBar(this.a.actionbar)),this.mode=Y;const k=this.B(new M.DomEmitter(this.f.inputBox.inputElement,"keydown")),H=this.B(w.Event.chain(k.event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.B(H(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const z=this.B(new l.Action("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(z,{icon:!0,label:!1});const U=this.B(new M.DomEmitter(this.a.grab,"mousedown"));this.B(U.event(G=>{const re=new S.DisposableStore,he=re.add(new M.DomEmitter(window,"mousemove")),De=re.add(new M.DomEmitter(window,"mouseup")),ye=this.k,Le=G.pageX,Ce=this.m,we=G.pageY;this.a.grab.classList.add("grabbing");const Pe=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=Ve=>{const He=Ve.pageX-Le;this.k=ye-He;const Ue=Ve.pageY-we;this.m=Ce+Ue,this.layout()};re.add(he.event(Ie)),re.add(De.event(Ve=>{Ie(Ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Pe,re.dispose()}))}));const j=this.B(w.Event.chain(this.B(new M.DomEmitter(this.a.grab,"keydown")).event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.B(j(G=>{let re,he;if(G.keyCode===15?re=Number.POSITIVE_INFINITY:G.keyCode===17?re=0:G.keyCode===10&&(re=this.k===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?he=0:G.keyCode===18&&(he=Number.POSITIVE_INFINITY),re!==void 0&&(G.preventDefault(),G.stopPropagation(),this.k=re,this.layout()),he!==void 0){G.preventDefault(),G.stopPropagation(),this.m=he;const De=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=De},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(g=this.j){this.j=g,this.k=(0,f.clamp)(this.k,0,Math.max(0,g-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,f.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(g){this.f.showMessage(g)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,o.timeout)(300),super.dispose()}}class Me{get pattern(){return this.b}get mode(){return this.d}set mode(g){g!==this.d&&(this.d=g,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(g))}get matchType(){return this.f}set matchType(g){g!==this.f&&(this.f=g,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(g))}constructor(g,C,$,Y,F,N={}){this.t=g,this.u=$,this.v=Y,this.w=F,this.x=N,this.b="",this.c="",this.j=0,this.k=new w.Emitter,this.onDidChangeMode=this.k.event,this.m=new w.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new w.Emitter,this.onDidChangePattern=this.o.event,this.p=new w.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new S.DisposableStore,this.s=new S.DisposableStore,this.d=g.options.defaultFindMode??J.Highlight,this.f=g.options.defaultFindMatchType??ve.Fuzzy,C.onDidSplice(this.z,this,this.s)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(g=>this.mode=g,void 0,this.q),this.g.onDidChangeMatchType(g=>this.matchType=g,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){!this.g||(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new S.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(g){this.b=g,this.o.fire(g),this.v.pattern=g,this.t.refilter(),g&&this.t.focusNext(0,!0,void 0,$=>!D.FuzzyScore.isDefault($.filterData));const C=this.t.getFocus();if(C.length>0){const $=C[0];this.t.getRelativeTop($)===null&&this.t.reveal($,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const g=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&g?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(g){return!this.g||!this.pattern||this.d===J.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!D.FuzzyScore.isDefault(g.filterData)}layout(g){this.j=g,this.g?.layout(g)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Re(R){let g=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(R.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=r.TreeMouseEventTarget.Filter),{browserEvent:R.browserEvent,element:R.element?R.element.element:null,target:g}}function le(R){return{element:R.element?R.element.element:null,browserEvent:R.browserEvent,anchor:R.anchor}}function x(R,g){g(R),R.children.forEach(C=>x(C,g))}class ne{get f(){return this.d||(this.d=this.m()),this.d}constructor(g,C){this.g=g,this.j=C,this.a=[],this.c=new w.Emitter,this.onDidChange=this.c.event}set(g,C){!C?.__forceEvent&&(0,e.equals)(this.a,g)||this.k(g,!1,C)}k(g,C,$){if(this.a=[...g],this.b=void 0,this.d=void 0,!C){const Y=this;this.c.fire({get elements(){return Y.get()},browserEvent:$})}}get(){return this.b||(this.b=this.a.map(g=>g.element)),[...this.b]}getNodes(){return this.a}has(g){return this.f.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:C}){if(!this.j){const k=this.m(),H=z=>k.delete(z);C.forEach(z=>x(z,H)),this.set([...k.values()]);return}const $=new Set,Y=k=>$.add(this.j.getId(k.element).toString());C.forEach(k=>x(k,Y));const F=new Map,N=k=>F.set(this.j.getId(k.element).toString(),k);g.forEach(k=>x(k,N));const B=[];for(const k of this.a){const H=this.j.getId(k.element).toString();if(!$.has(H))B.push(k);else{const U=F.get(H);U&&B.push(U)}}if(this.a.length>0&&B.length===0){const k=this.g();k&&B.push(k)}this.k(B,!0)}m(){const g=new Set;for(const C of this.a)g.add(C);return g}}class te extends a.MouseController{constructor(g,C){super(g),this.z=C}u(g){if((0,a.isButton)(g.browserEvent.target)||(0,a.isInputElement)(g.browserEvent.target)||(0,a.isMonacoEditor)(g.browserEvent.target))return;const C=g.element;if(!C)return super.u(g);if(this.p(g)||this.o(g))return super.u(g);const $=g.browserEvent.target,Y=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let F=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?F=this.z.expandOnlyOnTwistieClick(C.element):F=!!this.z.expandOnlyOnTwistieClick,F&&!Y&&g.browserEvent.detail!==2)return super.u(g);if(!this.z.expandOnDoubleClick&&g.browserEvent.detail===2)return super.u(g);if(C.collapsible){const N=this.z.getNodeLocation(C),B=g.browserEvent.altKey;if(this.z.setFocus([N]),this.z.toggleCollapsed(N,B),F&&Y)return}super.u(g)}v(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(g)}}class ie extends a.List{constructor(g,C,$,Y,F,N,B,k){super(g,C,$,Y,k),this.p=F,this.s=N,this.M=B}F(g){return new te(this,g.tree)}splice(g,C,$=[]){if(super.splice(g,C,$),$.length===0)return;const Y=[],F=[];let N;$.forEach((B,k)=>{this.p.has(B)&&Y.push(g+k),this.s.has(B)&&F.push(g+k),this.M.has(B)&&(N=g+k)}),Y.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Y])),F.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...F])),typeof N=="number"&&super.setAnchor(N)}setFocus(g,C,$=!1){super.setFocus(g,C),$||this.p.set(g.map(Y=>this.element(Y)),C)}setSelection(g,C,$=!1){super.setSelection(g,C),$||this.s.set(g.map(Y=>this.element(Y)),C)}setAnchor(g,C=!1){super.setAnchor(g),C||(typeof g>"u"?this.M.set([]):this.M.set([this.element(g)]))}}class T{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,Re),g=>g.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.map(this.j.onContextMenu,le)}get onTap(){return w.Event.map(this.j.onTap,Re)}get onPointer(){return w.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??J.Highlight}set findMode(g){this.x&&(this.x.mode=g)}get findMatchType(){return this.x?.matchType??ve.Fuzzy}set findMatchType(g){this.x&&(this.x.matchType=g)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(g,C,$,Y,F={}){this.D=g,this.E=F,this.w=new w.EventBufferer,this.onDidChangeFindOpenState=w.Event.None,this.A=new S.DisposableStore,this.B=new w.Emitter,this.onWillRefilter=this.B.event,this.C=new w.Emitter,this.onDidUpdateOptions=this.C.event;const N=new b($),B=new w.Relay,k=new w.Relay,H=this.A.add(new Z(k.event)),z=new s.SetMap;this.k=Y.map(G=>new se(G,()=>this.o,B.event,H,z,F));for(const G of this.k)this.A.add(G);let U;F.keyboardNavigationLabelProvider&&(U=new ae(this,F.keyboardNavigationLabelProvider,F.filter),F={...F,filter:U},this.A.add(U)),this.p=new ne(()=>this.j.getFocusedElements()[0],F.identityProvider),this.q=new ne(()=>this.j.getSelectedElements()[0],F.identityProvider),this.u=new ne(()=>this.j.getAnchorElement(),F.identityProvider),this.j=new ie(g,C,N,this.k,this.p,this.q,this.u,{...m(()=>this.o,F),tree:this}),this.o=this.I(g,this.j,F),B.input=this.o.onDidChangeCollapseState;const j=w.Event.forEach(this.o.onDidSplice,G=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(G),this.q.onDidModelSplice(G)})},this.A);if(j(()=>null,null,this.A),k.input=w.Event.chain(w.Event.any(j,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const G=new Set;for(const re of this.p.getNodes())G.add(re);for(const re of this.q.getNodes())G.add(re);return[...G.values()]}).event,F.keyboardSupport!==!1){const G=w.Event.chain(this.j.onKeyDown).filter(re=>!(0,a.isInputElement)(re.target)).map(re=>new i.StandardKeyboardEvent(re));G.filter(re=>re.keyCode===15).on(this.F,this,this.A),G.filter(re=>re.keyCode===17).on(this.G,this,this.A),G.filter(re=>re.keyCode===10).on(this.H,this,this.A)}if((F.findWidgetEnabled??!0)&&F.keyboardNavigationLabelProvider&&F.contextViewProvider){const G=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Me(this,this.o,this.j,U,F.contextViewProvider,G),this.y=re=>this.x.shouldAllowFocus(re),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;this.z=(0,E.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===q.Always)}updateOptions(g={}){this.E={...this.E,...g};for(const C of this.k)C.updateOptions(g);this.j.updateOptions(this.E),this.x?.updateOptions(g),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===q.Always)}get options(){return this.E}updateWidth(g){const C=this.o.getListIndex(g);C!==-1&&this.j.updateWidth(C)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(g){this.j.scrollTop=g}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(g){this.j.scrollLeft=g}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const g=this.j.firstVisibleIndex;return g<0||g>=this.j.length?void 0:this.j.element(g).element}get lastVisibleElement(){const g=this.j.lastVisibleIndex;return this.j.element(g).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(g){this.j.ariaLabel=g}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,C){this.j.layout(g,C),(0,p.isNumber)(C)&&this.x?.layout(C)}style(g){const C=`.${this.j.domId}`,$=[];g.treeIndentGuidesStroke&&($.push(`.monaco-list${C}:hover .monaco-tl-indent > .indent-guide, .monaco-list${C}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${C} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.z.textContent=$.join(`
`),this.j.style(g)}getParentElement(g){const C=this.o.getParentNodeLocation(g);return this.o.getNode(C).element}getFirstElementChild(g){return this.o.getFirstElementChild(g)}getNode(g){return this.o.getNode(g)}getNodeLocation(g){return this.o.getNodeLocation(g)}collapse(g,C=!1){return this.o.setCollapsed(g,!0,C)}expand(g,C=!1){return this.o.setCollapsed(g,!1,C)}toggleCollapsed(g,C=!1){return this.o.setCollapsed(g,void 0,C)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(g){return this.o.isCollapsible(g)}setCollapsible(g,C){return this.o.setCollapsible(g,C)}isCollapsed(g){return this.o.isCollapsed(g)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(g){if(typeof g>"u")return this.j.setAnchor(void 0);const C=this.o.getNode(g);this.u.set([C]);const $=this.o.getListIndex(g);$>-1&&this.j.setAnchor($,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(g,C){const $=g.map(F=>this.o.getNode(F));this.q.set($,C);const Y=g.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setSelection(Y,C,!0)}getSelection(){return this.q.get()}setFocus(g,C){const $=g.map(F=>this.o.getNode(F));this.p.set($,C);const Y=g.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setFocus(Y,C,!0)}focusNext(g=1,C=!1,$,Y=this.y){this.j.focusNext(g,C,$,Y)}focusPrevious(g=1,C=!1,$,Y=this.y){this.j.focusPrevious(g,C,$,Y)}focusNextPage(g,C=this.y){return this.j.focusNextPage(g,C)}focusPreviousPage(g,C=this.y){return this.j.focusPreviousPage(g,C)}focusLast(g,C=this.y){this.j.focusLast(g,C)}focusFirst(g,C=this.y){this.j.focusFirst(g,C)}getFocus(){return this.p.get()}reveal(g,C){this.o.expandTo(g);const $=this.o.getListIndex(g);$!==-1&&this.j.reveal($,C)}getRelativeTop(g){const C=this.o.getListIndex(g);return C===-1?null:this.j.getRelativeTop(C)}getViewState(g=this.options.identityProvider){if(!g)throw new r.TreeError(this.D,"Can't get tree view state without an identity provider");const C=N=>g.getId(N).toString(),$=O.empty(this.scrollTop);for(const N of this.getFocus())$.focus.add(C(N));for(const N of this.getSelection())$.selection.add(C(N));const Y=this.o.getNode(),F=[Y];for(;F.length>0;){const N=F.shift();N!==Y&&N.collapsible&&($.expanded[C(N.element)]=N.collapsed?0:1),F.push(...N.children)}return $}F(g){g.preventDefault(),g.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($);if(!this.o.setCollapsed(Y,!0)){const N=this.o.getParentNodeLocation(Y);if(!N)return;const B=this.o.getListIndex(N);this.j.reveal(B),this.j.setFocus([B])}}G(g){g.preventDefault(),g.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($);if(!this.o.setCollapsed(Y,!1)){if(!$.children.some(k=>k.visible))return;const[N]=this.j.getFocus(),B=N+1;this.j.reveal(B),this.j.setFocus([B])}}H(g){g.preventDefault(),g.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($),F=g.browserEvent.altKey;this.o.setCollapsed(Y,void 0,F)}navigate(g){return new _(this.j,this.o,g)}dispose(){(0,S.dispose)(this.A),this.j.dispose()}}t.AbstractTree=T;class _{constructor(g,C,$){this.b=g,this.c=C,$?this.a=this.c.getListIndex($):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(ee,t,E,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class v extends E.AbstractTree{constructor(h,a,c,P,r,l={}){super(h,a,c,P,l),this.f=h,this.g=r,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(h,a){if(a&&!this.c)throw new i.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!a){this.m(h);return}const c=[],P=[],r=e=>{const o=this.c.getId(e).toString();return!a.expanded[o]},l=e=>{const o=this.c.getId(e.element).toString();a.focus.has(o)&&c.push(e.element),a.selection.has(o)&&P.push(e.element)};this.m(h,r,l),this.setFocus(c),this.setSelection(P),a&&typeof a.scrollTop=="number"&&(this.scrollTop=a.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.TreeError(this.f,"Tree input not set");let a;this.c&&(a=c=>{const P=this.c.getId(c).toString(),r=this.d.get(P);if(!!r)return r.collapsed}),this.m(h,a)}resort(h=this.b,a=!0){this.o.resort(h===this.b?null:h,a)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,a,c){let P;if(this.c){const r=new Set,l=c;c=e=>{const o=this.c.getId(e.element).toString();r.add(o),this.d.set(o,e),l?.(e)},P=e=>{const o=this.c.getId(e.element).toString();r.has(o)||this.d.delete(o)}}this.o.setChildren(h===this.b?null:h,this.s(h,a).elements,{onDidCreateNode:c,onDidDeleteNode:P})}s(h,a){const c=[...this.g.getChildren(h)];return{elements:W.Iterable.map(c,r=>{const{elements:l,size:e}=this.s(r,a),o=this.g.hasChildren?this.g.hasChildren(r):void 0,n=e===0?void 0:a&&a(r);return{element:r,children:l,collapsible:o,collapsed:n}}),size:c.length}}I(h,a,c){return new M.ObjectTreeModel(h,a,c)}}t.DataTree=v}),define(ge[64],me([1,0,13,9,30,27,25,7,3,2,50,11,6]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var l;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(l||(l={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(o||(o={}));function n(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(u||(u={}));function s(le){let x=0;for(let ne=0;;ne+=7){const te=le.read(1);if(x|=(te.buffer[0]&127)<<ne,!(te.buffer[0]&128))return x}}const w=L(0);function D(le,x){if(x===0){le.write(w);return}let ne=0;for(let ie=x;ie!==0;ie=ie>>>7)ne++;const te=i.VSBuffer.alloc(ne);for(let ie=0;x!==0;ie++)te.buffer[ie]=x&127,x=x>>>7,x>0&&(te.buffer[ie]|=128);le.write(te)}class S{constructor(x){this.b=x,this.a=0}read(x){const ne=this.b.slice(this.a,this.a+x);return this.a+=ne.byteLength,ne}}t.BufferReader=S;class f{constructor(){this.a=[]}get buffer(){return i.VSBuffer.concat(this.a)}write(x){this.a.push(x)}}t.BufferWriter=f;var p;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(p||(p={}));function L(le){const x=i.VSBuffer.alloc(1);return x.writeUInt8(le,0),x}const I={Undefined:L(p.Undefined),String:L(p.String),Buffer:L(p.Buffer),VSBuffer:L(p.VSBuffer),Array:L(p.Array),Object:L(p.Object),Uint:L(p.Int)},y=typeof Buffer<"u";function d(le,x){if(typeof x>"u")le.write(I.Undefined);else if(typeof x=="string"){const ne=i.VSBuffer.fromString(x);le.write(I.String),D(le,ne.byteLength),le.write(ne)}else if(y&&Buffer.isBuffer(x)){const ne=i.VSBuffer.wrap(x);le.write(I.Buffer),D(le,ne.byteLength),le.write(ne)}else if(x instanceof i.VSBuffer)le.write(I.VSBuffer),D(le,x.byteLength),le.write(x);else if(Array.isArray(x)){le.write(I.Array),D(le,x.length);for(const ne of x)d(le,ne)}else if(typeof x=="number"&&(x|0)===x)le.write(I.Uint),D(le,x);else{const ne=i.VSBuffer.fromString(JSON.stringify(x));le.write(I.Object),D(le,ne.byteLength),le.write(ne)}}t.serialize=d;function m(le){switch(le.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return le.read(s(le)).toString();case p.Buffer:return le.read(s(le)).buffer;case p.VSBuffer:return le.read(s(le));case p.Array:{const ne=s(le),te=[];for(let ie=0;ie<ne;ie++)te.push(m(le));return te}case p.Object:return JSON.parse(le.read(s(le)).toString());case p.Int:return s(le)}}t.deserialize=m;class b{constructor(x,ne,te=null,ie=1e3){this.h=x,this.j=ne,this.k=te,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(T=>this.q(T)),this.m({type:200})}registerChannel(x,ne){this.b.set(x,ne),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const ne=this.o([x.type]);this.k?.logOutgoing(ne,0,1,n(x.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([x.type,x.id],x.data);this.k?.logOutgoing(ne,x.id,1,n(x.type),x.data);return}}}o(x,ne=void 0){const te=new f;return d(te,x),d(te,ne),this.p(te.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const ne=new S(x),te=m(ne),ie=m(ne),T=te[0];switch(T){case 100:return this.k?.logIncoming(x.byteLength,te[1],1,`${e(T)}: ${te[2]}.${te[3]}`,ie),this.s({type:T,id:te[1],channelName:te[2],name:te[3],arg:ie});case 102:return this.k?.logIncoming(x.byteLength,te[1],1,`${e(T)}: ${te[2]}.${te[3]}`,ie),this.t({type:T,id:te[1],channelName:te[2],name:te[3],arg:ie});case 101:return this.k?.logIncoming(x.byteLength,te[1],1,`${e(T)}`),this.u({type:T,id:te[1]});case 103:return this.k?.logIncoming(x.byteLength,te[1],1,`${e(T)}`),this.u({type:T,id:te[1]})}}s(x){const ne=this.b.get(x.channelName);if(!ne){this.v(x);return}const te=new W.CancellationTokenSource;let ie;try{ie=ne.call(this.j,x.name,x.arg,te.token)}catch(R){ie=Promise.reject(R)}const T=x.id;ie.then(R=>{this.m({id:T,data:R,type:201}),this.d.delete(x.id)},R=>{R instanceof Error?this.m({id:T,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:T,data:R,type:203}),this.d.delete(x.id)});const _=(0,a.toDisposable)(()=>te.cancel());this.d.set(x.id,_)}t(x){const ne=this.b.get(x.channelName);if(!ne){this.v(x);return}const te=x.id,T=ne.listen(this.j,x.name,x.arg)(_=>this.m({id:te,data:_,type:204}));this.d.set(x.id,T)}u(x){const ne=this.d.get(x.id);ne&&(ne.dispose(),this.d.delete(x.id))}v(x){let ne=this.g.get(x.channelName);ne||(ne=[],this.g.set(x.channelName,ne));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:x,timeoutTimer:te})}w(x){const ne=this.g.get(x);if(ne){for(const te of ne)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=b;var O;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class q{constructor(x,ne=null){this.l=x,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=ne}getChannel(x){const ne=this;return{call(te,ie,T){return ne.a?Promise.reject(new A.CancellationError):ne.m(x,te,ie,T)},listen(te,ie){return ne.a?h.Event.None:ne.o(x,te,ie)}}}m(x,ne,te,ie=W.CancellationToken.None){const T=this.g++,R={id:T,type:100,channelName:x,name:ne,arg:te};if(ie.isCancellationRequested)return Promise.reject(new A.CancellationError);let g;return new Promise(($,Y)=>{if(ie.isCancellationRequested)return Y(new A.CancellationError);const F=()=>{const H=z=>{switch(z.type){case 201:this.f.delete(T),$(z.data);break;case 202:{this.f.delete(T);const U=new Error(z.data.message);U.stack=Array.isArray(z.data.stack)?z.data.stack.join(`
`):z.data.stack,U.name=z.data.name,Y(U);break}case 203:this.f.delete(T),Y(z.data);break}};this.f.set(T,H),this.p(R)};let N=null;this.b===u.Idle?F():(N=(0,M.createCancelablePromise)(H=>this.u()),N.then(()=>{N=null,F()}));const B=()=>{N?(N.cancel(),N=null):this.p({id:T,type:101}),Y(new A.CancellationError)},k=ie.onCancellationRequested(B);g=(0,a.combinedDisposable)((0,a.toDisposable)(B),k),this.d.add(g)}).finally(()=>{this.d.delete(g)})}o(x,ne,te){const ie=this.g++,_={id:ie,type:102,channelName:x,name:ne,arg:te};let R=null;const g=new h.Emitter({onWillAddFirstListener:()=>{R=(0,M.createCancelablePromise)($=>this.u()),R.then(()=>{R=null,this.d.add(g),this.p(_)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(g),this.p({id:ie,type:103}))}}),C=$=>g.fire($.data);return this.f.set(ie,C),g.event}p(x){switch(x.type){case 100:case 102:{const ne=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(ne,x.id,0,`${e(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const ne=this.q([x.type,x.id]);this.j?.logOutgoing(ne,x.id,0,e(x.type));return}}}q(x,ne=void 0){const te=new f;return d(te,x),d(te,ne),this.r(te.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const ne=new S(x),te=m(ne),ie=m(ne),T=te[0];switch(T){case 200:return this.j?.logIncoming(x.byteLength,0,0,n(T)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,te[1],0,n(T),ie),this.t({type:te[0],id:te[1],data:ie})}}t(x){if(x.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.dispose)(this.d.values()),this.d.clear()}}qe([v.memoize],q.prototype,"onDidInitializePromise",null),t.ChannelClient=q;class Z{get connections(){const x=[];return this.f.forEach(ne=>x.push(ne)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,x(({protocol:ne,onDidClientDisconnect:te})=>{h.Event.once(ne.onMessage)(T=>{const _=new S(T),R=m(_),g=new b(ne,R),C=new q(ne);this.a.forEach((Y,F)=>g.registerChannel(F,Y));const $={channelServer:g,channelClient:C,ctx:R};this.f.add($),this.g.fire($),te(()=>{g.dispose(),C.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(x,ne){const te=this;return{call(ie,T,_){let R;if((0,r.isFunction)(ne)){const C=(0,E.getRandomElement)(te.connections.filter(ne));R=C?Promise.resolve(C):h.Event.toPromise(h.Event.filter(te.onDidAddConnection,ne))}else R=ne.routeCall(te,ie,T);const g=R.then(C=>C.channelClient.getChannel(x));return ae(g).call(ie,T,_)},listen(ie,T){if((0,r.isFunction)(ne))return te.j(x,ne,ie,T);const _=ne.routeEvent(te,ie,T).then(R=>R.channelClient.getChannel(x));return ae(_).listen(ie,T)}}}j(x,ne,te,ie){const T=this;let _=new a.DisposableStore;const R=new h.Emitter({onWillAddFirstListener:()=>{_=new a.DisposableStore;const g=new h.EventMultiplexer,C=new Map,$=F=>{const B=F.channelClient.getChannel(x).listen(te,ie),k=g.add(B);C.set(F,k)},Y=F=>{const N=C.get(F);!N||(N.dispose(),C.delete(F))};T.connections.filter(ne).forEach($),h.Event.filter(T.onDidAddConnection,ne)($,void 0,_),T.onDidRemoveConnection(Y,void 0,_),g.event(R.fire,R,_),_.add(g)},onDidRemoveLastListener:()=>{_.dispose()}});return R.event}registerChannel(x,ne){this.a.set(x,ne),this.f.forEach(te=>{te.channelServer.registerChannel(x,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=Z;class se{constructor(x,ne,te=null){const ie=new f;d(ie,ne),x.send(ie.buffer),this.a=new q(x,te),this.d=new b(x,ne,te)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,ne){this.d.registerChannel(x,ne)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=se;function ae(le){return{call(x,ne,te){return le.then(ie=>ie.call(x,ne,te))},listen(x,ne){const te=new h.Relay;return le.then(ie=>te.input=ie.listen(x,ne)),te.event}}}t.getDelayedChannel=ae;function fe(le){let x=!1;return{call(ne,te,ie){return x?le.call(ne,te,ie):(0,M.timeout)(0).then(()=>x=!0).then(()=>le.call(ne,te,ie))},listen(ne,te){if(x)return le.listen(ne,te);const ie=new h.Relay;return(0,M.timeout)(0).then(()=>x=!0).then(()=>ie.input=le.listen(ne,te)),ie.event}}}t.getNextTickChannel=fe;class ue{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const ne of x.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await h.Event.toPromise(x.onDidAddConnection),await this.b(x)}}t.StaticRouter=ue;var Q;(function(le){function x(T,_){const R=T,g=_&&_.disableMarshalling,C=new Map;for(const $ in R)te($)&&C.set($,h.Event.buffer(R[$],!0));return new class{listen($,Y,F){const N=C.get(Y);if(N)return N;if(ie(Y)){const B=R[Y];if(typeof B=="function")return B.call(R,F)}throw new Error(`Event not found: ${Y}`)}call($,Y,F){const N=R[Y];if(typeof N=="function"){if(!g&&Array.isArray(F))for(let B=0;B<F.length;B++)F[B]=(0,c.revive)(F[B]);return N.apply(R,F)}throw new Error(`Method not found: ${Y}`)}}}le.fromService=x;function ne(T,_){const R=_&&_.disableMarshalling;return new Proxy({},{get(g,C){if(typeof C=="string")return _?.properties?.has(C)?_.properties.get(C):ie(C)?function($){return T.listen(C,$)}:te(C)?T.listen(C):async function(...$){let Y;_&&!(0,r.isUndefinedOrNull)(_.context)?Y=[_.context,...$]:Y=$;const F=await T.call(C,Y);return R?F:(0,c.revive)(F)};throw new Error(`Property not found: ${String(C)}`)}})}le.toService=ne;function te(T){return T[0]==="o"&&T[1]==="n"&&P.isUpperAsciiLetter(T.charCodeAt(2))}function ie(T){return/^onDynamic/.test(T)&&P.isUpperAsciiLetter(T.charCodeAt(9))}})(Q=t.ProxyChannel||(t.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ve(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const x=le.toString();if(x!=="[object Object]")return x}return le}function pe(le){return Array.isArray(le)?le.map(ve):ve(le)}function Me(le,x,ne,te,ie,T,_){_=pe(_);const R=J[ie],g=R[te%R.length];let C=[`%c[${le}]%c[${String(x).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(T)?(C=C.concat(_),C.push(")")):C.push(_),console.log.apply(console,C)}class Re{constructor(x,ne){this.d=x,this.f=ne,this.a=0,this.b=0}logOutgoing(x,ne,te,ie,T){this.b+=x,Me(this.d,this.b,x,ne,te,ie,T)}logIncoming(x,ne,te,ie,T){this.a+=x,Me(this.f,this.a,x,ne,te,ie,T)}}t.IPCLogger=Re}),define(ge[29],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,29]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(A,h,a){const c=[],P=i++,r=`vscode:onContextMenu${P}`,l=(e,o,n)=>{c[o].click?.(n)};M.ipcRenderer.once(r,l),M.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,o)=>{o===P&&(M.ipcRenderer.removeListener(r,l),a?.())}),M.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,P,A.map(e=>v(e,c)),r,h)}t.popup=W;function v(A,h){const a={id:h.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return h.push(A),Array.isArray(A.submenu)&&(a.submenu=A.submenu.map(c=>v(c,h))),a}}),define(ge[131],me([1,0,30,3,64,82,29]),function(ee,t,E,M,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class A extends i.IPCClient{static f(){const a=M.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:message",(c,P)=>E.VSBuffer.wrap(P));return v.ipcRenderer.send("vscode:hello"),new W.Protocol(v.ipcRenderer,a)}constructor(a){const c=A.f();super(c,a),this.b=c}dispose(){this.b.disconnect()}}t.Client=A}),define(ge[132],me([12,10]),function(ee,t){return ee.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(ee,t){return ee.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[37],me([1,0]),function(ee,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(v){v.serviceIds=new Map,v.DI_TARGET="$di$target",v.DI_DEPENDENCIES="$di$dependencies";function A(h){return h[v.DI_DEPENDENCIES]||[]}v.getServiceDependencies=A})(E=t._util||(t._util={})),t.IInstantiationService=i("instantiationService");function M(v,A,h){A[E.DI_TARGET]===A?A[E.DI_DEPENDENCIES].push({id:v,index:h}):(A[E.DI_DEPENDENCIES]=[{id:v,index:h}],A[E.DI_TARGET]=A)}function i(v){if(E.serviceIds.has(v))return E.serviceIds.get(v);const A=function(h,a,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(A,h,c)};return A.toString=()=>v,E.serviceIds.set(v,A),A}t.createDecorator=i;function W(v){return v}t.refineServiceDecorator=W}),define(ge[134],me([1,0,37]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function M(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=M;class i{async getPerformanceInfo(v,A){return{}}async getSystemInfo(v,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(v,A){return""}async getWorkspaceFileExtensions(v){return{extensions:[]}}async reportWorkspaceStats(v){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,113,22,11,6,15,132,37,5,28]),function(ee,t,E,M,i,W,v,A,h,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.getPlatformFileLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,h.createDecorator)("fileService");function P(x){return x.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(r=t.FileType||(t.FileType={}));var l;(function(x){x[x.Readonly=1]="Readonly"})(l=t.FilePermission||(t.FilePermission={}));var e;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(e=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function o(x){return!!(x.capabilities&2)}t.hasReadWriteCapability=o;function n(x){return!!(x.capabilities&8)}t.hasFileFolderCopyCapability=n;function u(x){return!!(x.capabilities&32768)}t.hasFileCloneCapability=u;function s(x){return!!(x.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function w(x){return!!(x.capabilities&16)}t.hasFileReadStreamCapability=w;function D(x){return o(x)?!!(x.capabilities&16384):!1}t.hasFileAtomicReadCapability=D;var S;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(S=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class f extends Error{static create(ne,te){const ie=new f(ne.toString(),te);return I(ie,te),ie}constructor(ne,te){super(ne),this.code=te}}t.FileSystemProviderError=f;function p(x,ne){return f.create(x,ne)}t.createFileSystemProviderError=p;function L(x){return x||p((0,A.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=L;function I(x,ne){return x.name=ne?`${ne} (FileSystemError)`:"FileSystemError",x}t.markAsFileSystemProviderError=I;function y(x){if(!x)return S.Unknown;if(x instanceof f)return x.code;const ne=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ne)return S.Unknown;switch(ne[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=y;function d(x){if(x instanceof se)return x.fileOperationResult;switch(y(x)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=d;var m;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(m=t.FileOperation||(t.FileOperation={}));class b{constructor(ne,te,ie){this.resource=ne,this.operation=te,this.target=ie}isOperation(ne){return this.operation===ne}}t.FileOperationEvent=b;var O;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(O=t.FileChangeType||(t.FileChangeType={}));class q{constructor(ne,te){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const T of ne){const _=ie.get(T.type);switch(_?_.push([T.resource,T]):ie.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,_]of ie)switch(T){case 1:this.a=E.TernarySearchTree.forUris(()=>te),this.a.fill(_);break;case 0:this.b=E.TernarySearchTree.forUris(()=>te),this.b.fill(_);break;case 2:this.c=E.TernarySearchTree.forUris(()=>te),this.c.fill(_);break}}contains(ne,...te){return this.d(ne,{includeChildren:!1},...te)}affects(ne,...te){return this.d(ne,{includeChildren:!0},...te)}d(ne,te,...ie){if(!ne)return!1;const T=ie.length>0;return!!((!T||ie.includes(1))&&(this.a?.get(ne)||te.includeChildren&&this.a?.findSuperstr(ne))||(!T||ie.includes(0))&&(this.b?.get(ne)||te.includeChildren&&this.b?.findSuperstr(ne))||(!T||ie.includes(2))&&(this.c?.findSubstr(ne)||te.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=q;function Z(x,ne,te){return!x||!ne||x===ne||ne.length>x.length?!1:(ne.charAt(ne.length-1)!==M.sep&&(ne+=M.sep),te?(0,i.startsWithIgnoreCase)(x,ne):x.indexOf(ne)===0)}t.isParent=Z;class se extends Error{constructor(ne,te,ie){super(ne),this.fileOperationResult=te,this.options=ie}}t.FileOperationError=se;class ae extends se{constructor(ne,te,ie,T){super(ne,te,T),this.fileOperationResult=te,this.size=ie}}t.TooLargeFileOperationError=ae;class fe extends se{constructor(ne,te,ie){super(ne,2,ie),this.stat=te}}t.NotModifiedSinceFileOperationError=fe;var ue;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ue=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var Q;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function J(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}t.etag=J;async function ve(x,ne){if(!ne.hasProvider(v.URI.from({scheme:x.scheme})))return new Promise(te=>{const ie=ne.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===x.scheme&&T.added&&(ie.dispose(),te())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class pe{static formatSize(ne){return(0,W.isNumber)(ne)||(ne=0),ne<pe.KB?(0,A.localize)(1,null,ne.toFixed(0)):ne<pe.MB?(0,A.localize)(2,null,(ne/pe.KB).toFixed(2)):ne<pe.GB?(0,A.localize)(3,null,(ne/pe.MB).toFixed(2)):ne<pe.TB?(0,A.localize)(4,null,(ne/pe.GB).toFixed(2)):(0,A.localize)(5,null,(ne/pe.TB).toFixed(2))}}pe.KB=1024,pe.MB=pe.KB*pe.KB,pe.GB=pe.MB*pe.KB,pe.TB=pe.GB*pe.KB,t.ByteSize=pe;var Me;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(Me=t.Arch||(t.Arch={}));function Re(x){return{maxFileSize:x===0?300*pe.MB:16*pe.GB,maxHeapSize:x===0?700*pe.MB:2*700*pe.MB}}t.getPlatformFileLimits=Re;function le(x){const ne=typeof x=="string"||x?.scheme===c.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===c.Schemas.file?1024*pe.MB:ne?10*pe.MB:a.isWeb?50*pe.MB:1024*pe.MB}t.getLargeFileConfirmationLimit=le}),define(ge[136],me([1,0,37]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class M{constructor(W,v){this.a=W,this.b=v}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,v){this.a.registerChannel(W,v)}}t.MainProcessService=M}),define(ge[137],me([1,0,2,131]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(v){super(),this.a=this.B(new M.Client(`window:${v}`))}getChannel(v){return this.a.getChannel(v)}registerChannel(v,A){this.a.registerChannel(v,A)}}t.ElectronIPCMainProcessService=i});var ci=this&&this.__param||function(ee,t){return function(E,M){t(E,M,ee)}};define(ge[138],me([1,0,64,136]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=class{constructor(v,A){return this.windowId=v,E.ProxyChannel.toService(A.getChannel("nativeHost"),{context:v,properties:(()=>{const h=new Map;return h.set("windowId",v),h})()})}};i=qe([ci(1,M.IMainProcessService)],i),t.NativeHostService=i}),define(ge[65],me([1,0,72,6]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.a=new Map}add(v,A){E.ok(M.isString(v)),E.ok(M.isObject(A)),E.ok(!this.a.has(v),"There is already an extension with this id"),this.a.set(v,A)}knows(v){return this.a.has(v)}as(v){return this.a.get(v)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,65]),function(ee,t,E,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class W{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,a){this.a[i(h)]=a,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const v=new W;M.Registry.add(t.Extensions.JSONContribution,v)}),define(ge[140],me([1,0,9,16,17,3,6,15,133,139,65]),function(ee,t,E,M,i,W,v,A,h,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(D){function S(f,p){let L=f.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const I=e.getIcon(L.id);if(!I)return;L=I.defaults}return L}D.getDefinition=S})(P=t.IconContribution||(t.IconContribution={}));var r;(function(D){function S(p){return{weight:p.weight,style:p.style,src:p.src.map(L=>({format:L.format,location:L.location.toString()}))}}D.toJSONObject=S;function f(p){const L=I=>(0,v.isString)(I)?I:void 0;if(p&&Array.isArray(p.src)&&p.src.every(I=>(0,v.isString)(I.format)&&(0,v.isString)(I.location)))return{weight:L(p.weight),style:L(p.style),src:p.src.map(I=>({format:I.format,location:A.URI.parse(I.location)}))}}D.fromJSONObject=f})(r=t.IconFontDefinition||(t.IconFontDefinition={}));class l{constructor(){this.a=new W.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(S,f,p,L){const I=this.b[S];if(I){if(p&&!I.description){I.description=p,this.d.properties[S].markdownDescription=`${p} $(${S})`;const m=this.e.enum.indexOf(S);m!==-1&&(this.e.enumDescriptions[m]=p),this.a.fire()}return I}const y={id:S,description:p,defaults:f,deprecationMessage:L};this.b[S]=y;const d={$ref:"#/definitions/icons"};return L&&(d.deprecationMessage=L),p&&(d.markdownDescription=`${p}: $(${S})`),this.d.properties[S]=d,this.e.enum.push(S),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:S}}deregisterIcon(S){delete this.b[S],delete this.d.properties[S];const f=this.e.enum.indexOf(S);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(S=>this.b[S])}getIcon(S){return this.b[S]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(S,f){const p=this.f[S];return p||(this.f[S]=f,this.a.fire(),f)}deregisterIconFont(S){delete this.f[S]}getIconFont(S){return this.f[S]}toString(){const S=(I,y)=>I.id.localeCompare(y.id),f=I=>{for(;i.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(I=>this.b[I]);for(const I of L.filter(y=>!!y.description).sort(S))p.push(`|<i class="${f(I)}"></i>|${I.id}|${i.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const I of L.filter(y=>!i.ThemeIcon.isThemeIcon(y.defaults)).sort(S))p.push(`|<i class="${f(I)}"></i>|${I.id}|`);return p.join(`
`)}}const e=new l;c.Registry.add(t.Extensions.IconContribution,e);function o(D,S,f,p){return e.registerIcon(D,S,f,p)}t.registerIcon=o;function n(){return e}t.getIconRegistry=n;function u(){const D=(0,M.getCodiconFontCharacters)();for(const S in D){const f="\\"+D[S].toString(16);e.registerIcon(S,{fontCharacter:f})}}u(),t.iconsSchemaId="vscode://schemas/icons";const s=c.Registry.as(a.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const w=new E.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{w.isScheduled()||w.schedule()}),t.widgetClose=o("widget-close",M.Codicon.close,(0,h.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",M.Codicon.arrowUp,(0,h.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",M.Codicon.arrowDown,(0,h.localize)(4,null)),t.syncing=i.ThemeIcon.modify(M.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(M.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,17,140]),function(ee,t,E,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function v(h){const a=new M.Emitter,c=(0,W.getIconRegistry)();return c.onDidChange(()=>a.fire()),h?.onDidProductIconThemeChange(()=>a.fire()),{onDidChange:a.event,getCSS(){const P=h?h.getProductIconTheme():new A,r={},l=o=>{const n=P.getIcon(o);if(!n)return;const u=n.font;return u?(r[u.id]=u.definition,`.codicon-${o.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(u.id)}; }`):`.codicon-${o.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const o of c.getIcons()){const n=l(o);n&&e.push(n)}for(const o in r){const n=r[o],u=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",w=n.src.map(D=>`${(0,E.asCSSUrl)(D.location)} format('${D.format}')`).join(", ");e.push(`@font-face { src: ${w}; font-family: ${(0,E.asCSSPropertyValue)(o)};${u}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=v;class A{getIcon(a){const c=(0,W.getIconRegistry)();let P=a.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=c.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=A}),define(ge[142],me([1,0,5]),function(ee,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(c){return!!c.workspaceUri}t.isWorkspaceToOpen=M;function i(c){return!!c.folderUri}t.isFolderToOpen=i;function W(c){return!!c.fileUri}t.isFileToOpen=W;function v(c){const P=A(c),r=c.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=v;function A(c){if(E.isWeb)return"custom";const P=c.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=A;function h(c){if(!E.isWindows||E.isWeb||A(c)==="native")return!1;const P=c.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=h;function a(c=0){return Math.pow(1.2,c)}t.zoomLevelToZoomFactor=a}),define(ge[143],me([1,0,18,29,142]),function(ee,t,E,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(h){M.webFrame.setZoomLevel(h),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(h)),(0,E.setZoomLevel)(h,!1)}t.applyZoom=W;function v(){W((0,E.getZoomLevel)()+1)}t.zoomIn=v;function A(){W((0,E.getZoomLevel)()-1)}t.zoomOut=A}),define(ge[144],me([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(ee,t,E,M,i,W,v,A,h,a,c,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(O){return 22}getTemplateId(O){return I(O)?"process":p(O)?"machine":(0,h.isRemoteDiagnosticError)(O)?"error":L(O)?"header":""}}class s{hasChildren(O){return(0,h.isRemoteDiagnosticError)(O)?!1:I(O)?!!O.children?.length:!0}getChildren(O){return I(O)?O.children?O.children:[]:(0,h.isRemoteDiagnosticError)(O)?[]:L(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:p(O)?[O.rootProcess]:[O.processes]}}class w{constructor(){this.templateId="header"}renderTemplate(O){const q=(0,M.append)(O,(0,M.$)(".row")),Z=(0,M.append)(q,(0,M.$)(".nameLabel")),se=(0,M.append)(q,(0,M.$)(".cpu")),ae=(0,M.append)(q,(0,M.$)(".memory")),fe=(0,M.append)(q,(0,M.$)(".pid"));return{name:Z,CPU:se,memory:ae,PID:fe}}renderElement(O,q,Z,se){Z.name.textContent=(0,E.localize)(0,null),Z.CPU.textContent=(0,E.localize)(1,null),Z.PID.textContent=(0,E.localize)(2,null),Z.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(O){}}class D{constructor(){this.templateId="machine"}renderTemplate(O){const q=Object.create(null),Z=(0,M.append)(O,(0,M.$)(".row"));return q.name=(0,M.append)(Z,(0,M.$)(".nameLabel")),q}renderElement(O,q,Z,se){Z.name.textContent=O.element.name}disposeTemplate(O){}}class S{constructor(){this.templateId="error"}renderTemplate(O){const q=Object.create(null),Z=(0,M.append)(O,(0,M.$)(".row"));return q.name=(0,M.append)(Z,(0,M.$)(".nameLabel")),q}renderElement(O,q,Z,se){Z.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class f{constructor(O,q,Z){this.a=O,this.b=q,this.c=Z,this.templateId="process"}renderTemplate(O){const q=(0,M.append)(O,(0,M.$)(".row")),Z=(0,M.append)(q,(0,M.$)(".nameLabel")),se=(0,M.append)(q,(0,M.$)(".cpu")),ae=(0,M.append)(q,(0,M.$)(".memory")),fe=(0,M.append)(q,(0,M.$)(".pid"));return{name:Z,CPU:se,PID:fe,memory:ae}}renderElement(O,q,Z,se){const{element:ae}=O,fe=ae.pid.toFixed(0);let ue=ae.name;this.c.has(ae.pid)&&(ue=this.c.get(ae.pid)),Z.name.textContent=ue,Z.name.title=ae.cmd,Z.CPU.textContent=ae.load.toFixed(0),Z.PID.textContent=fe,Z.PID.parentElement.id=`pid-${fe}`;const Q=this.a==="win32"?ae.mem:this.b*(ae.mem/100);Z.memory.textContent=(Q/a.ByteSize.MB).toFixed(0)}disposeTemplate(O){}}function p(b){return!!b.name&&!!b.rootProcess}function L(b){return!!b.processRoots}function I(b){return!!b.pid}class y{constructor(O,q){this.f=q,this.b=new Map;const Z=new c.ElectronIPCMainProcessService(O);this.c=new P.NativeHostService(O,Z),this.k(q.styles),this.g(q),A.ipcRenderer.on("vscode:pidToNameResponse",(se,ae)=>{this.b=new Map;for(const[fe,ue]of ae)this.b.set(fe,ue)}),A.ipcRenderer.on("vscode:listProcessesResponse",async(se,ae)=>{ae.forEach((fe,ue)=>{I(fe.rootProcess)&&(fe.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ae}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ae),this.m(0)}),this.a=Date.now(),A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")}g(O){document.onkeydown=q=>{const Z=O.platform==="darwin"?q.metaKey:q.ctrlKey;Z&&q.keyCode===87&&(q.stopPropagation(),q.preventDefault(),A.ipcRenderer.send("vscode:closeProcessExplorer")),Z&&q.keyCode===187&&(0,l.zoomIn)(),Z&&q.keyCode===189&&(0,l.zoomOut)()}}async h(O){const q=document.getElementById("process-list");if(!q)return;const{totalmem:Z}=await this.c.getOSStatistics(),se=[new f(this.f.platform,Z,this.b),new w,new D,new S];this.d=new i.DataTree("processExplorer",q,new u,se,new s,{identityProvider:{getId:ae=>I(ae)?ae.pid.toString():(0,h.isRemoteDiagnosticError)(ae)?ae.hostName:L(ae)?"processes":p(ae)?ae.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ae=>{const fe=new e.StandardKeyboardEvent(ae);if(fe.keyCode===35&&fe.altKey){const ue=this.n();Promise.all(ue.map(Q=>this.c.killProcess(Q,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ae=>{I(ae.element)&&this.l(ae.element,!0)}),q.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{q.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(O){const q=o.exec(O);return q&&q.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const q={type:"node",request:"attach",name:`process ${O.pid}`};let Z=o.exec(O.cmd);Z?q.port=Number(Z.groups.port):q.processId=String(O.pid),Z=n.exec(O.cmd),Z&&(q.port=Number(Z.groups.port)),A.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[q]})}k(O){const q=(0,M.createStyleSheet)(),Z=[];O.listFocusBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&Z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&Z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&Z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&Z.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&Z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),q.textContent=Z.join(`
`),O.color&&(document.body.style.color=O.color)}l(O,q){const Z=[],se=Number(O.pid);q&&(Z.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(se,"SIGTERM")}}),Z.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(se,"SIGKILL")}}),Z.push({type:"separator"})),Z.push({label:(0,E.localize)(6,null),click:()=>{const ae=this.n();ae?.includes(se)||(ae.length=0,ae.push(se));const fe=ae?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(fe){const ue=fe.map(Q=>Q.innerText).filter(Q=>!!Q);this.c.writeClipboardText(ue.join(`
`))}}}),Z.push({label:(0,E.localize)(7,null),click:()=>{const ae=document.getElementById("process-list");ae&&this.c.writeClipboardText(ae.innerText)}}),O&&q&&this.i(O.cmd)&&(Z.push({type:"separator"}),Z.push({label:(0,E.localize)(8,null),click:()=>{this.j(O)}})),(0,v.popup)(Z)}m(O){setTimeout(()=>{const q=Date.now(),Z=O+q-this.a;this.a=q,Z>1e3?(A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")):this.m(Z)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function d(){const b=(0,M.createStyleSheet)();b.id="codiconStyles";const O=(0,r.getIconsStyleSheet)(void 0);function q(){b.textContent=O.getCSS()}const Z=new W.RunOnceScheduler(q,0);O.onDidChange(()=>Z.schedule()),Z.schedule()}function m(b){const O=b.data.platform==="win32"?"windows":b.data.platform==="linux"?"linux":"mac";document.body.classList.add(O),d(),(0,l.applyZoom)(b.data.zoomLevel),new y(b.windowId,b.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
