/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],T=0,A=G.length;T<A;T++)e[T]=ie[G[T]];return e};define(ie[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(L){return(b,f,c)=>{let P=null,E=null;if(typeof c.value=="function"?(P="value",E=c.value):typeof c.get=="function"&&(P="get",E=c.get),!E)throw new Error("not supported");c[P]=L(E,f)}}function A(L,b,f){let c=null,P=null;if(typeof f.value=="function"?(c="value",P=f.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",P=f.get),!P)throw new Error("not supported");const E=`$memoize$${b}`;f[c]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[E]}}e.memoize=A;function D(L,b,f){return T((c,P)=>{const E=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...v){this[m]||(this[m]=f?f():void 0),clearTimeout(this[E]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[E]=setTimeout(()=>{c.apply(this,v),this[m]=f?f():void 0},L)}})}e.debounce=D;function C(L,b,f){return T((c,P)=>{const E=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,N=`$throttle$pending$${P}`;return function(...R){if(this[m]||(this[m]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...R)),this[N])return;const u=this[v]+L;u<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[m]]),this[m]=f?f():void 0):(this[N]=!0,this[E]=setTimeout(()=>{this[N]=!1,this[v]=Date.now(),c.apply(this,[this[m]]),this[m]=f?f():void 0},u-Date.now()))}})}e.throttle=C}),define(ie[70],ne([0,1,9]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(f,c){if(!f)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function D(f,c="Unreachable"){throw new Error(c)}e.assertNever=D;function C(f){if(!f)throw new T.BugIndicatingError("Assertion Failed")}e.assert=C;function L(f){if(!f()){debugger;f(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function b(f,c){let P=0;for(;P<f.length-1;){const E=f[P],m=f[P+1];if(!c(E,m))return!1;P++}return!0}e.checkAdjacentItems=b}),define(ie[51],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function L(t,a=!1){let n=0;const i=t.length;let r="",o=0,l=16,d=0;function w(re){let he=0,ce=0;for(;he<re;){const se=t.charCodeAt(n);if(se>=48&&se<=57)ce=ce*16+se-48;else if(se>=65&&se<=70)ce=ce*16+se-65+10;else if(se>=97&&se<=102)ce=ce*16+se-97+10;else break;n++,he++}return he<re&&(ce=-1),ce}function O(re){n=re,r="",o=0,l=16,d=0}function j(){const re=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return d=3,t.substring(re,n);let he=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;he=n}else d=3;return t.substring(re,he)}function Y(){let re="",he=n;for(;;){if(n>=i){re+=t.substring(he,n),d=2;break}const ce=t.charCodeAt(n);if(ce===34){re+=t.substring(he,n),n++;break}if(ce===92){if(re+=t.substring(he,n),n++,n>=i){d=2;break}switch(t.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const $=w(4);$>=0?re+=String.fromCharCode($):d=4;break}default:d=5}he=n;continue}if(ce>=0&&ce<=31)if(f(ce)){re+=t.substring(he,n),d=2;break}else d=6;n++}return re}function J(){if(r="",d=0,o=n,n>=i)return o=i,l=17;let re=t.charCodeAt(n);if(b(re)){do n++,r+=String.fromCharCode(re),re=t.charCodeAt(n);while(b(re));return l=15}if(f(re))return n++,r+=String.fromCharCode(re),re===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),l=14;switch(re){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=Y(),l=10;case 47:{const he=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!f(t.charCodeAt(n));)n++;return r=t.substring(he,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const ce=i-1;let se=!1;for(;n<ce;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,se=!0;break}n++}return se||(n++,d=1),r=t.substring(he,n),l=13}return r+=String.fromCharCode(re),n++,l=16}case 45:if(r+=String.fromCharCode(re),n++,n===i||!c(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=j(),l=11;default:for(;n<i&&ee(re);)n++,re=t.charCodeAt(n);if(o!==n){switch(r=t.substring(o,n),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(re),n++,l=16}}function ee(re){if(b(re)||f(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let re;do re=J();while(re>=12&&re<=15);return re}return{setPosition:O,getPosition:()=>n,scan:a?le:J,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>d}}e.createScanner=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,a){const n=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(w,O,j,Y){o.value=w,o.offset=O,o.length=j,o.type=Y,o.colonOffset=void 0,r=o}try{y(t,{onObjectBegin:(w,O)=>{if(a<=w)throw i;r=void 0,l=a>w,n.push("")},onObjectProperty:(w,O,j)=>{if(a<O||(d(w,O,j,"property"),n[n.length-1]=w,a<=O+j))throw i},onObjectEnd:(w,O)=>{if(a<=w)throw i;r=void 0,n.pop()},onArrayBegin:(w,O)=>{if(a<=w)throw i;r=void 0,n.push(0)},onArrayEnd:(w,O)=>{if(a<=w)throw i;r=void 0,n.pop()},onLiteralValue:(w,O,j)=>{if(a<O||(d(w,O,j,I(w)),a<=O+j))throw i},onSeparator:(w,O,j)=>{if(a<=O)throw i;if(w===":"&&r&&r.type==="property")r.colonOffset=O,l=!1,r=void 0;else if(w===","){const Y=n[n.length-1];typeof Y=="number"?n[n.length-1]=Y+1:(l=!0,n[n.length-1]=""),r=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:r,isAtPropertyKey:l,matches:w=>{let O=0;for(let j=0;O<w.length&&j<n.length;j++)if(w[O]===n[j]||w[O]==="*")O++;else if(w[O]!=="**")return!1;return O===w.length}}}e.getLocation=E;function m(t,a=[],n=C.DEFAULT){let i=null,r=[];const o=[];function l(w){Array.isArray(r)?r.push(w):i!==null&&(r[i]=w)}return y(t,{onObjectBegin:()=>{const w={};l(w),o.push(r),r=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const w=[];l(w),o.push(r),r=w,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(w,O,j)=>{a.push({error:w,offset:O,length:j})}},n),r[0]}e.parse=m;function v(t,a=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function o(w){return i.children.push(w),w}y(t,{onObjectBegin:w=>{i=o({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,O,j)=>{i=o({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:O,length:j,parent:i})},onObjectEnd:(w,O)=>{i.length=w+O-i.offset,i=i.parent,r(w+O)},onArrayBegin:(w,O)=>{i=o({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,O)=>{i.length=w+O-i.offset,i=i.parent,r(w+O)},onLiteralValue:(w,O,j)=>{o({type:I(w),offset:O,length:j,parent:i,value:w}),r(O+j)},onSeparator:(w,O,j)=>{i.type==="property"&&(w===":"?i.colonOffset=O:w===","&&r(O))},onError:(w,O,j)=>{a.push({error:w,offset:O,length:j})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=v;function N(t,a){if(!t)return;let n=t;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===i){n=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=N;function R(t){if(!t.parent||!t.parent.children)return[];const a=R(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=R;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const a=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(a[n.children[0].value]=u(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function g(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=g;function h(t,a,n=!1){if(g(t,a,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const o=h(i[r],a,n);if(o)return o}return t}}e.findNodeAtOffset=h;function y(t,a,n=C.DEFAULT){const i=L(t,!1);function r(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(X){return X?M=>X(M,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(a.onObjectBegin),d=o(a.onObjectProperty),w=r(a.onObjectEnd),O=r(a.onArrayBegin),j=r(a.onArrayEnd),Y=o(a.onLiteralValue),J=o(a.onSeparator),ee=r(a.onComment),le=o(a.onError),re=n&&n.disallowComments,he=n&&n.allowTrailingComma;function ce(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:re||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(X){case 12:case 13:re?se(10):ee();break;case 16:se(1);break;case 15:case 14:break;default:return X}}}function se(X,M=[],U=[]){if(le(X),M.length+U.length>0){let k=i.getToken();for(;k!==17;){if(M.indexOf(k)!==-1){ce();break}else if(U.indexOf(k)!==-1)break;k=ce()}}}function $(X){const M=i.getTokenValue();return X?Y(M):d(M),ce(),!0}function q(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(se(2),X=0)}catch{se(2)}Y(X);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ce(),!0}function x(){return i.getToken()!==10?(se(3,[],[2,5]),!1):($(!1),i.getToken()===6?(J(":"),ce(),H()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function F(){l(),ce();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||se(4,[],[]),J(","),ce(),i.getToken()===2&&he)break}else X&&se(6,[],[]);x()||se(4,[],[2,5]),X=!0}return w(),i.getToken()!==2?se(7,[2],[]):ce(),!0}function W(){O(),ce();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||se(4,[],[]),J(","),ce(),i.getToken()===4&&he)break}else X&&se(6,[],[]);H()||se(4,[],[4,5]),X=!0}return j(),i.getToken()!==4?se(8,[4],[]):ce(),!0}function H(){switch(i.getToken()){case 3:return W();case 1:return F();case 10:return $(!0);default:return q()}}return ce(),i.getToken()===17?n.allowEmptyContent?!0:(se(4,[],[]),!1):H()?(i.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=y;function p(t,a){const n=L(t),i=[];let r,o=0,l;do switch(l=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:o!==l&&i.push(t.substring(o,l)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=p;function I(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(ie[71],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(b,f,c){return Math.min(Math.max(b,f),c)}e.clamp=T;function A(b,f){return(f+b%f)%f}e.rot=A;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class C{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class L{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const c=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=L}),function(){function G(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function L(f){C.push(f,Date.now())}function b(){const f=[];for(let c=0;c<C.length;c+=2)f.push({name:C[c],startTime:C[c+1]});return f}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))C.push({name:L.name,startTime:Math.round(D+L.startTime)});return C}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function T(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=T(A))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var A in T)(typeof exports=="object"?exports:G)[A]=T[A]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function T(A){if(e[A])return e[A].exports;var D=e[A]={i:A,l:!1,exports:{}};return G[A].call(D.exports,D,D.exports,T),D.l=!0,D.exports}return T.m=G,T.c=e,T.d=function(A,D,C){T.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:C})},T.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},T.t=function(A,D){if(1&D&&(A=T(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var C=Object.create(null);if(T.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var L in A)T.d(C,L,function(b){return A[b]}.bind(null,L));return C},T.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return T.d(D,"a",D),D},T.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},T.p="",T(T.s=0)}([function(G,e,T){(function(A){var D;e=G.exports=U,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],f=e.src=[],c=0,P=c++;f[P]="0|[1-9]\\d*";var E=c++;f[E]="[0-9]+";var m=c++;f[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;f[v]="("+f[P]+")\\.("+f[P]+")\\.("+f[P]+")";var N=c++;f[N]="("+f[E]+")\\.("+f[E]+")\\.("+f[E]+")";var R=c++;f[R]="(?:"+f[P]+"|"+f[m]+")";var u=c++;f[u]="(?:"+f[E]+"|"+f[m]+")";var g=c++;f[g]="(?:-("+f[R]+"(?:\\."+f[R]+")*))";var h=c++;f[h]="(?:-?("+f[u]+"(?:\\."+f[u]+")*))";var y=c++;f[y]="[0-9A-Za-z-]+";var p=c++;f[p]="(?:\\+("+f[y]+"(?:\\."+f[y]+")*))";var I=c++,t="v?"+f[v]+f[g]+"?"+f[p]+"?";f[I]="^"+t+"$";var a="[v=\\s]*"+f[N]+f[h]+"?"+f[p]+"?",n=c++;f[n]="^"+a+"$";var i=c++;f[i]="((?:<|>)?=?)";var r=c++;f[r]=f[E]+"|x|X|\\*";var o=c++;f[o]=f[P]+"|x|X|\\*";var l=c++;f[l]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[g]+")?"+f[p]+"?)?)?";var d=c++;f[d]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[h]+")?"+f[p]+"?)?)?";var w=c++;f[w]="^"+f[i]+"\\s*"+f[l]+"$";var O=c++;f[O]="^"+f[i]+"\\s*"+f[d]+"$";var j=c++;f[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;f[Y]="(?:~>?)";var J=c++;f[J]="(\\s*)"+f[Y]+"\\s+",b[J]=new RegExp(f[J],"g");var ee=c++;f[ee]="^"+f[Y]+f[l]+"$";var le=c++;f[le]="^"+f[Y]+f[d]+"$";var re=c++;f[re]="(?:\\^)";var he=c++;f[he]="(\\s*)"+f[re]+"\\s+",b[he]=new RegExp(f[he],"g");var ce=c++;f[ce]="^"+f[re]+f[l]+"$";var se=c++;f[se]="^"+f[re]+f[d]+"$";var $=c++;f[$]="^"+f[i]+"\\s*("+a+")$|^$";var q=c++;f[q]="^"+f[i]+"\\s*("+t+")$|^$";var x=c++;f[x]="(\\s*)"+f[i]+"\\s*("+a+"|"+f[l]+")",b[x]=new RegExp(f[x],"g");var F=c++;f[F]="^\\s*("+f[l]+")\\s+-\\s+("+f[l]+")\\s*$";var W=c++;f[W]="^\\s*("+f[d]+")\\s+-\\s+("+f[d]+")\\s*$";var H=c++;f[H]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)D(X,f[X]),b[X]||(b[X]=new RegExp(f[X]));function M(V,Z){if(V instanceof U)return V;if(typeof V!="string"||V.length>C||!(Z?b[n]:b[I]).test(V))return null;try{return new U(V,Z)}catch{return null}}function U(V,Z){if(V instanceof U){if(V.loose===Z)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof U))return new U(V,Z);D("SemVer",V,Z),this.loose=Z;var _=V.trim().match(Z?b[n]:b[I]);if(!_)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<L)return ye}return me}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=M,e.valid=function(V,Z){var _=M(V,Z);return _?_.version:null},e.clean=function(V,Z){var _=M(V.trim().replace(/^[=v]+/,""),Z);return _?_.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return D("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),s(this.major,V.major)||s(this.minor,V.minor)||s(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Z=0;do{var _=this.prerelease[Z],me=V.prerelease[Z];if(D("prerelease compare",Z,_,me),_===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(_===void 0)return-1;if(_!==me)return s(_,me)}while(++Z)},U.prototype.inc=function(V,Z){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Z,_,me){typeof _=="string"&&(me=_,_=void 0);try{return new U(V,_).inc(Z,me).version}catch{return null}},e.diff=function(V,Z){if(K(V,Z))return null;var _=M(V),me=M(Z);if(_.prerelease.length||me.prerelease.length){for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return ye},e.compareIdentifiers=s;var k=/^[0-9]+$/;function s(V,Z){var _=k.test(V),me=k.test(Z);return _&&me&&(V=+V,Z=+Z),_&&!me?-1:me&&!_?1:V<Z?-1:V>Z?1:0}function S(V,Z,_){return new U(V,_).compare(new U(Z,_))}function z(V,Z,_){return S(V,Z,_)>0}function B(V,Z,_){return S(V,Z,_)<0}function K(V,Z,_){return S(V,Z,_)===0}function Q(V,Z,_){return S(V,Z,_)!==0}function oe(V,Z,_){return S(V,Z,_)>=0}function de(V,Z,_){return S(V,Z,_)<=0}function pe(V,Z,_,me){var ye;switch(Z){case"===":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ye=V===_;break;case"!==":typeof V=="object"&&(V=V.version),typeof _=="object"&&(_=_.version),ye=V!==_;break;case"":case"=":case"==":ye=K(V,_,me);break;case"!=":ye=Q(V,_,me);break;case">":ye=z(V,_,me);break;case">=":ye=oe(V,_,me);break;case"<":ye=B(V,_,me);break;case"<=":ye=de(V,_,me);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function ue(V,Z){if(V instanceof ue){if(V.loose===Z)return V;V=V.value}if(!(this instanceof ue))return new ue(V,Z);D("comparator",V,Z),this.loose=Z,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(V,Z){return s(Z,V)},e.major=function(V,Z){return new U(V,Z).major},e.minor=function(V,Z){return new U(V,Z).minor},e.patch=function(V,Z){return new U(V,Z).patch},e.compare=S,e.compareLoose=function(V,Z){return S(V,Z,!0)},e.rcompare=function(V,Z,_){return S(Z,V,_)},e.sort=function(V,Z){return V.sort(function(_,me){return e.compare(_,me,Z)})},e.rsort=function(V,Z){return V.sort(function(_,me){return e.rcompare(_,me,Z)})},e.gt=z,e.lt=B,e.eq=K,e.neq=Q,e.gte=oe,e.lte=de,e.cmp=pe,e.Comparator=ue;var ge={};function ae(V,Z){if(V instanceof ae)return V.loose===Z?V:new ae(V.raw,Z);if(V instanceof ue)return new ae(V.value,Z);if(!(this instanceof ae))return new ae(V,Z);if(this.loose=Z,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Z,_,me,ye,Oe,be,Le,De,Ne,je,Ie,Te){return((Z=fe(_)?"":fe(me)?">="+_+".0.0":fe(ye)?">="+_+"."+me+".0":">="+Z)+" "+(Le=fe(De)?"":fe(Ne)?"<"+(+De+1)+".0.0":fe(je)?"<"+De+"."+(+Ne+1)+".0":Ie?"<="+De+"."+Ne+"."+je+"-"+Ie:"<="+Le)).trim()}function Re(V,Z){for(var _=0;_<V.length;_++)if(!V[_].test(Z))return!1;if(Z.prerelease.length){for(_=0;_<V.length;_++)if(D(V[_].semver),V[_].semver!==ge&&V[_].semver.prerelease.length>0){var me=V[_].semver;if(me.major===Z.major&&me.minor===Z.minor&&me.patch===Z.patch)return!0}return!1}return!0}function Ce(V,Z,_){try{Z=new ae(Z,_)}catch{return!1}return Z.test(V)}function Fe(V,Z,_,me){var ye,Oe,be,Le,De;switch(V=new U(V,me),Z=new ae(Z,me),_){case">":ye=z,Oe=de,be=B,Le=">",De=">=";break;case"<":ye=B,Oe=oe,be=z,Le="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(V,Z,me))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var je=Z.set[Ne],Ie=null,Te=null;if(je.forEach(function(Me){Me.semver===ge&&(Me=new ue(">=0.0.0")),Ie=Ie||Me,Te=Te||Me,ye(Me.semver,Ie.semver,me)?Ie=Me:be(Me.semver,Te.semver,me)&&(Te=Me)}),Ie.operator===Le||Ie.operator===De||(!Te.operator||Te.operator===Le)&&Oe(V,Te.semver)||Te.operator===De&&be(V,Te.semver))return!1}return!0}ue.prototype.parse=function(V){var Z=this.loose?b[$]:b[q],_=V.match(Z);if(!_)throw new TypeError("Invalid comparator: "+V);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new U(_[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(V){return D("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new U(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(V,Z){if(!(V instanceof ue))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new ae(V.value,Z),Ce(this.value,_,Z);if(V.operator==="")return _=new ae(this.value,Z),Ce(V.semver,_,Z);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Oe=this.semver.version===V.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Z)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),De=pe(this.semver,">",V.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||Oe&&be||Le||De},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(V){var Z=this.loose;V=V.trim(),D("range",V,Z);var _=Z?b[W]:b[F];V=V.replace(_,we),D("hyphen replace",V),V=V.replace(b[x],"$1$2$3"),D("comparator trim",V,b[x]),V=(V=(V=V.replace(b[J],"$1~")).replace(b[he],"$1^")).split(/\s+/).join(" ");var me=Z?b[$]:b[q],ye=V.split(" ").map(function(Oe){return function(be,Le){return D("comp",be),be=function(De,Ne){return De.trim().split(/\s+/).map(function(je){return function(Ie,Te){D("caret",Ie,Te);var Me=Te?b[se]:b[ce];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke){var Ae;return D("caret",Ie,Ue,Ee,Se,Pe,ke),fe(Ee)?Ae="":fe(Se)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(Pe)?Ae=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":ke?(D("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+ke+" <"+(+Ee+1)+".0.0"):(D("no pr"),Ae=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+Se+"."+(+Pe+1):">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Pe+" <"+(+Ee+1)+".0.0"),D("caret return",Ae),Ae})}(je,Ne)}).join(" ")}(be,Le),D("caret",be),be=function(De,Ne){return De.trim().split(/\s+/).map(function(je){return function(Ie,Te){var Me=Te?b[le]:b[ee];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke){var Ae;return D("tilde",Ie,Ue,Ee,Se,Pe,ke),fe(Ee)?Ae="":fe(Se)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(Pe)?Ae=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":ke?(D("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+Ee+"."+Se+"."+Pe+ke+" <"+Ee+"."+(+Se+1)+".0"):Ae=">="+Ee+"."+Se+"."+Pe+" <"+Ee+"."+(+Se+1)+".0",D("tilde return",Ae),Ae})}(je,Ne)}).join(" ")}(be,Le),D("tildes",be),be=function(De,Ne){return D("replaceXRanges",De,Ne),De.split(/\s+/).map(function(je){return function(Ie,Te){Ie=Ie.trim();var Me=Te?b[O]:b[w];return Ie.replace(Me,function(Ue,Ee,Se,Pe,ke,Ae){D("xRange",Ie,Ue,Ee,Se,Pe,ke,Ae);var We=fe(Se),xe=We||fe(Pe),Be=xe||fe(ke);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(xe&&(Pe=0),Be&&(ke=0),Ee===">"?(Ee=">=",xe?(Se=+Se+1,Pe=0,ke=0):Be&&(Pe=+Pe+1,ke=0)):Ee==="<="&&(Ee="<",xe?Se=+Se+1:Pe=+Pe+1),Ue=Ee+Se+"."+Pe+"."+ke):xe?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":Be&&(Ue=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0"),D("xRange return",Ue),Ue})}(je,Ne)}).join(" ")}(be,Le),D("xrange",be),be=function(De,Ne){return D("replaceStars",De,Ne),De.trim().replace(b[H],"")}(be,Le),D("stars",be),be}(Oe,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match(me)})),ye=ye.map(function(Oe){return new ue(Oe,Z)})},ae.prototype.intersects=function(V,Z){if(!(V instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(me){return V.set.some(function(ye){return ye.every(function(Oe){return me.intersects(Oe,Z)})})})})},e.toComparators=function(V,Z){return new ae(V,Z).set.map(function(_){return _.map(function(me){return me.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var Z=0;Z<this.set.length;Z++)if(Re(this.set[Z],V))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(V,Z,_){var me=null,ye=null;try{var Oe=new ae(Z,_)}catch{return null}return V.forEach(function(be){Oe.test(be)&&(me&&ye.compare(be)!==-1||(ye=new U(me=be,_)))}),me},e.minSatisfying=function(V,Z,_){var me=null,ye=null;try{var Oe=new ae(Z,_)}catch{return null}return V.forEach(function(be){Oe.test(be)&&(me&&ye.compare(be)!==1||(ye=new U(me=be,_)))}),me},e.validRange=function(V,Z){try{return new ae(V,Z).range||"*"}catch{return null}},e.ltr=function(V,Z,_){return Fe(V,Z,"<",_)},e.gtr=function(V,Z,_){return Fe(V,Z,">",_)},e.outside=Fe,e.prerelease=function(V,Z){var _=M(V,Z);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(V,Z,_){return V=new ae(V,_),Z=new ae(Z,_),V.intersects(Z)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var Z=V.match(b[j]);return Z==null?null:M((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,T(1))},function(G,e){var T,A,D=G.exports={};function C(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(u){if(T===setTimeout)return setTimeout(u,0);if((T===C||!T)&&setTimeout)return T=setTimeout,setTimeout(u,0);try{return T(u,0)}catch{try{return T.call(null,u,0)}catch{return T.call(this,u,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:C}catch{T=C}try{A=typeof clearTimeout=="function"?clearTimeout:L}catch{A=L}})();var f,c=[],P=!1,E=-1;function m(){P&&f&&(P=!1,f.length?c=f.concat(c):E=-1,c.length&&v())}function v(){if(!P){var u=b(m);P=!0;for(var g=c.length;g;){for(f=c,c=[];++E<g;)f&&f[E].run();E=-1,g=c.length}f=null,P=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===L||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}(u)}}function N(u,g){this.fun=u,this.array=g}function R(){}D.nextTick=function(u){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];c.push(new N(u,g)),c.length!==1||P||b(v)},N.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=R,D.addListener=R,D.once=R,D.off=R,D.removeListener=R,D.removeAllListeners=R,D.emit=R,D.prependListener=R,D.prependOnceListener=R,D.listeners=function(u){return[]},D.binding=function(u){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(u){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ie[72],ne([0,1]),function(G,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(b,f,c){this.level=b,this.key=f,this.value=c,this.forward=[]}}const D=void 0;class C{constructor(b,f=2**16){this.comparator=b,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new A(this.c,D,D)}get size(){return this.f}clear(){this.e=new A(this.c,D,D)}has(b){return Boolean(C.g(this,b,this.comparator))}get(b){return C.g(this,b,this.comparator)?.value}set(b,f){return C.h(this,b,f,this.comparator)&&(this.f+=1),this}delete(b){const f=C.k(this,b,this.comparator);return f&&(this.f-=1),f}forEach(b,f){let c=this.e.forward[0];for(;c;)b.call(f,c.value,c.key,this),c=c.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",f=this.e.forward[0];for(;f;)b+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return b}static g(b,f,c){let P=b.e;for(let E=b.d-1;E>=0;E--)for(;P.forward[E]&&c(P.forward[E].key,f)<0;)P=P.forward[E];if(P=P.forward[0],P&&c(P.key,f)===0)return P}static h(b,f,c,P){const E=[];let m=b.e;for(let v=b.d-1;v>=0;v--){for(;m.forward[v]&&P(m.forward[v].key,f)<0;)m=m.forward[v];E[v]=m}if(m=m.forward[0],m&&P(m.key,f)===0)return m.value=c,!1;{const v=C.j(b);if(v>b.d){for(let N=b.d;N<v;N++)E[N]=b.e;b.d=v}m=new A(v,f,c);for(let N=0;N<v;N++)m.forward[N]=E[N].forward[N],E[N].forward[N]=m;return!0}}static j(b,f=.5){let c=1;for(;Math.random()<f&&c<b.c;)c+=1;return c}static k(b,f,c){const P=[];let E=b.e;for(let m=b.d-1;m>=0;m--){for(;E.forward[m]&&c(E.forward[m].key,f)<0;)E=E.forward[m];P[m]=E}if(E=E.forward[0],!E||c(E.key,f)!==0)return!1;for(let m=0;m<b.d&&P[m].forward[m]===E;m++)P[m].forward[m]=E.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===D;)b.d-=1;return!0}}e.SkipList=C}),define(ie[44],ne([0,1,9,2]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(p){const I=p;return I?typeof I.read=="function":!1}e.isReadable=D;function C(p){const I=p;return I?[I.on,I.pause,I.resume,I.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function L(p){const I=p;return I?C(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=L;function b(p,I){return new f(p,I)}e.newWriteableStream=b;class f{constructor(I,t){this.e=I,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(t=>t(I))}h(I){this.c.error.length===0?(0,T.onUnexpectedError)(I):this.c.error.slice(0).forEach(t=>t(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,t){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(I,t){if(this.a.destroyed)return;let a;switch(I){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(t);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,I){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return I(t)}e.consumeReadable=c;function P(p,I,t){const a=[];let n;for(;(n=p.read())!==null&&a.length<t;)a.push(n);return n===null&&a.length>0?I(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return p.read()}}}e.peekReadable=P;function E(p,I){return new Promise((t,a)=>{const n=[];m(p,{onData:i=>{I&&n.push(i)},onError:i=>{I?a(i):t(void 0)},onEnd:()=>{t(I?I(n):void 0)}})})}e.consumeStream=E;function m(p,I){let t=!1;return p.on("error",a=>{t||I.onError(a)}),p.on("end",()=>{t||I.onEnd()}),p.on("data",a=>{t||I.onData(a)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=m;function v(p,I){return new Promise((t,a)=>{const n=new A.DisposableStore,i=[],r=d=>{if(i.push(d),i.length>I)return n.dispose(),p.pause(),t({stream:p,buffer:i,ended:!1})},o=d=>a(d),l=()=>t({stream:p,buffer:i,ended:!0});n.add((0,A.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),n.add((0,A.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),n.add((0,A.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=v;function N(p,I){const t=b(I);return t.end(p),t}e.toStream=N;function R(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=R;function u(p){let I=!1;return{read:()=>I?null:(I=!0,p)}}e.toReadable=u;function g(p,I,t){const a=b(t);return m(p,{onData:n=>a.write(I.data(n)),onError:n=>a.error(I.error?I.error(n):n),onEnd:()=>a.end()}),a}e.transform=g;function h(p,I,t){let a=!1;return{read:()=>{const n=I.read();return a?n:(a=!0,n!==null?t([p,n]):p)}}}e.prefixedReadable=h;function y(p,I,t){let a=!1;const n=b(t);return m(I,{onData:i=>a?n.write(i):(a=!0,n.write(t([p,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(p)),n.end()}}),n}e.prefixedStream=y}),define(ie[14],ne([0,1,44]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let D,C;class L{static alloc(d){return A?new L(Buffer.allocUnsafe(d)):new L(new Uint8Array(d))}static wrap(d){return A&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new L(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&A?new L(Buffer.from(d)):(D||(D=new TextEncoder),new L(D.encode(d)))}static fromByteArray(d){const w=L.alloc(d.length);for(let O=0,j=d.length;O<j;O++)w.buffer[O]=d[O];return w}static concat(d,w){if(typeof w>"u"){w=0;for(let Y=0,J=d.length;Y<J;Y++)w+=d[Y].byteLength}const O=L.alloc(w);let j=0;for(let Y=0,J=d.length;Y<J;Y++){const ee=d[Y];O.set(ee,j),j+=ee.byteLength}return O}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=L.alloc(this.byteLength);return d.set(this),d}toString(){return A?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,w){return new L(this.buffer.subarray(d,w))}set(d,w){if(d instanceof L)this.buffer.set(d.buffer,w);else if(d instanceof Uint8Array)this.buffer.set(d,w);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),w);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return c(this.buffer,d)}writeUInt32BE(d,w){P(this.buffer,d,w)}readUInt32LE(d){return E(this.buffer,d)}writeUInt32LE(d,w){m(this.buffer,d,w)}readUInt8(d){return v(this.buffer,d)}writeUInt8(d,w){N(this.buffer,d,w)}}e.VSBuffer=L;function b(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0}e.readUInt16LE=b;function f(l,d,w){l[w+0]=d&255,d=d>>>8,l[w+1]=d&255}e.writeUInt16LE=f;function c(l,d){return l[d]*2**24+l[d+1]*2**16+l[d+2]*2**8+l[d+3]}e.readUInt32BE=c;function P(l,d,w){l[w+3]=d,d=d>>>8,l[w+2]=d,d=d>>>8,l[w+1]=d,d=d>>>8,l[w]=d}e.writeUInt32BE=P;function E(l,d){return l[d+0]<<0>>>0|l[d+1]<<8>>>0|l[d+2]<<16>>>0|l[d+3]<<24>>>0}e.readUInt32LE=E;function m(l,d,w){l[w+0]=d&255,d=d>>>8,l[w+1]=d&255,d=d>>>8,l[w+2]=d&255,d=d>>>8,l[w+3]=d&255}e.writeUInt32LE=m;function v(l,d){return l[d]}e.readUInt8=v;function N(l,d,w){l[w]=d}e.writeUInt8=N;function R(l){return T.consumeReadable(l,d=>L.concat(d))}e.readableToBuffer=R;function u(l){return T.toReadable(l)}e.bufferToReadable=u;function g(l){return T.consumeStream(l,d=>L.concat(d))}e.streamToBuffer=g;async function h(l){return l.ended?L.concat(l.buffer):L.concat([...l.buffer,await g(l.stream)])}e.bufferedStreamToBuffer=h;function y(l){return T.toStream(l,d=>L.concat(d))}e.bufferToStream=y;function p(l){return T.transform(l,{data:d=>typeof d=="string"?L.fromString(d):L.wrap(d)},d=>L.concat(d))}e.streamToBufferReadableStream=p;function I(l){return T.newWriteableStream(d=>L.concat(d),l)}e.newWriteableBufferStream=I;function t(l,d){return T.prefixedReadable(l,d,w=>L.concat(w))}e.prefixedBufferReadable=t;function a(l,d){return T.prefixedStream(l,d,w=>L.concat(w))}e.prefixedBufferStream=a;function n(l){let d=0,w=0,O=0;const j=new Uint8Array(Math.floor(l.length/4*3)),Y=ee=>{switch(w){case 3:j[O++]=d|ee,w=0;break;case 2:j[O++]=d|ee>>>2,d=ee<<6,w=3;break;case 1:j[O++]=d|ee>>>4,d=ee<<4,w=2;break;default:d=ee<<2,w=1}};for(let ee=0;ee<l.length;ee++){const le=l.charCodeAt(ee);if(le>=65&&le<=90)Y(le-65);else if(le>=97&&le<=122)Y(le-97+26);else if(le>=48&&le<=57)Y(le-48+52);else if(le===43||le===45)Y(62);else if(le===47||le===95)Y(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const J=O;for(;w>0;)Y(0);return L.wrap(j).slice(0,J)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},d=!0,w=!1){const O=w?r:i;let j="";const Y=l.byteLength%3;let J=0;for(;J<l.byteLength-Y;J+=3){const ee=l[J+0],le=l[J+1],re=l[J+2];j+=O[ee>>>2],j+=O[(ee<<4|le>>>4)&63],j+=O[(le<<2|re>>>6)&63],j+=O[re&63]}if(Y===1){const ee=l[J+0];j+=O[ee>>>2],j+=O[ee<<4&63],d&&(j+="==")}else if(Y===2){const ee=l[J+0],le=l[J+1];j+=O[ee>>>2],j+=O[(ee<<4|le>>>4)&63],j+=O[le<<2&63],d&&(j+="=")}return j}e.encodeBase64=o}),define(ie[30],ne([0,1,3]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([y,p])=>{h[y]=p&&typeof p=="object"?A(p):p}),h}e.deepClone=A;function D(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const y=h.shift();Object.freeze(y);for(const p in y)if(C.call(y,p)){const I=y[p];typeof I=="object"&&!Object.isFrozen(I)&&!(0,T.isTypedArray)(I)&&h.push(I)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function L(g,h){return b(g,h,new Set)}e.cloneAndChange=L;function b(g,h,y){if((0,T.isUndefinedOrNull)(g))return g;const p=h(g);if(typeof p<"u")return p;if(Array.isArray(g)){const I=[];for(const t of g)I.push(b(t,h,y));return I}if((0,T.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const I={};for(const t in g)C.call(g,t)&&(I[t]=b(g[t],h,y));return y.delete(g),I}return g}function f(g,h,y=!0){return(0,T.isObject)(g)?((0,T.isObject)(h)&&Object.keys(h).forEach(p=>{p in g?y&&((0,T.isObject)(g[p])&&(0,T.isObject)(h[p])?f(g[p],h[p],y):g[p]=h[p]):g[p]=h[p]}),g):h}e.mixin=f;function c(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let y,p;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(y=0;y<g.length;y++)if(!c(g[y],h[y]))return!1}else{const I=[];for(p in g)I.push(p);I.sort();const t=[];for(p in h)t.push(p);if(t.sort(),!c(I,t))return!1;for(y=0;y<I.length;y++)if(!c(g[I[y]],h[I[y]]))return!1}return!0}e.equals=c;function P(g){const h=new Set;return JSON.stringify(g,(y,p)=>{if((0,T.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=P;function E(g,h){const y=Object.create(null);return!g||!h||Object.keys(h).forEach(I=>{const t=g[I],a=h[I];c(t,a)||(y[I]=a)}),y}e.distinct=E;function m(g,h){const y=h.toLowerCase(),p=Object.keys(g).find(I=>I.toLowerCase()===y);return p?g[p]:g[h]}e.getCaseInsensitive=m;function v(g,h){const y=Object.create(null);for(const[p,I]of Object.entries(g))h(p,I)&&(y[p]=I);return y}e.filter=v;function N(g){let h=[],y=Object.getPrototypeOf(g);for(;Object.prototype!==y;)h=h.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return h}e.getAllPropertyNames=N;function R(g){const h=[];for(const y of N(g))typeof g[y]=="function"&&h.push(y);return h}e.getAllMethodNames=R;function u(g,h){const y=I=>function(){const t=Array.prototype.slice.call(arguments,0);return h(I,t)},p={};for(const I of g)p[I]=y(I);return p}e.createProxyObject=u}),define(ie[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(D){return T.test(D)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let f=0;f<b.length;f++)b[f]=Math.floor(Math.random()*256);return b};const C=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){D(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let f=0,c="";return c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c+="-",c+=L[C[f++]],c+=L[C[f++]],c+="-",c+=L[C[f++]],c+=L[C[f++]],c+="-",c+=L[C[f++]],c+=L[C[f++]],c+="-",c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c+=L[C[f++]],c}}()}),define(ie[73],ne([0,1,32]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(L){const b=L.replace(/\-/g,":").toLowerCase();return!A.has(b)}function C(){const L=(0,T.networkInterfaces)();for(const b in L){const f=L[b];if(f){for(const{mac:c}of f)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ie[74],ne([7,4]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[75],ne([0,1,74]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,D=A*60,C=D*24,L=C*7,b=C*30,f=C*365;function c(E,m,v,N){typeof E!="number"&&(E=E.getTime());const R=Math.round((new Date().getTime()-E)/1e3);if(R<-30)return(0,T.localize)(0,null,c(new Date().getTime()+R*1e3,!1));if(!N&&R<30)return(0,T.localize)(1,null);let u;return R<A?(u=R,m?u===1?v?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):v?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u):u===1?v?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):v?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):R<D?(u=Math.floor(R/A),m?u===1?v?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):v?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u):u===1?v?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):v?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):R<C?(u=Math.floor(R/D),m?u===1?v?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):v?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u):u===1?v?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):v?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):R<L?(u=Math.floor(R/C),m?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u)):R<b?(u=Math.floor(R/L),m?u===1?v?(0,T.localize)(30,null,u):(0,T.localize)(31,null,u):v?(0,T.localize)(32,null,u):(0,T.localize)(33,null,u):u===1?v?(0,T.localize)(34,null,u):(0,T.localize)(35,null,u):v?(0,T.localize)(36,null,u):(0,T.localize)(37,null,u)):R<f?(u=Math.floor(R/b),m?u===1?v?(0,T.localize)(38,null,u):(0,T.localize)(39,null,u):v?(0,T.localize)(40,null,u):(0,T.localize)(41,null,u):u===1?v?(0,T.localize)(42,null,u):(0,T.localize)(43,null,u):v?(0,T.localize)(44,null,u):(0,T.localize)(45,null,u)):(u=Math.floor(R/f),m?u===1?v?(0,T.localize)(46,null,u):(0,T.localize)(47,null,u):v?(0,T.localize)(48,null,u):(0,T.localize)(49,null,u):u===1?v?(0,T.localize)(50,null,u):(0,T.localize)(51,null,u):v?(0,T.localize)(52,null,u):(0,T.localize)(53,null,u))}e.fromNow=c;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ie[76],ne([7,4]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[33],ne([0,1,19,3,76]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(E,m){return m&&(E.stack||E.stacktrace)?D.localize(0,null,b(E),L(E.stack)||L(E.stacktrace)):b(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function b(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function f(E=null,m=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const v=T.coalesce(E),N=f(v[0],m);return v.length>1?D.localize(4,null,N,v.length):N}if(A.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return C(v.error,m);if(v.exception)return C(v.exception,m)}return E.stack?C(E,m):E.message?E.message:D.localize(5,null)}e.toErrorMessage=f;function c(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=c;function P(E,m){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=m,v}e.createErrorWithActions=P}),define(ie[77],ne([7,4]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[78],ne([0,1,77]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(D){switch(D){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ie[52],ne([0,1,12]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(b,...f){const c=f.reduce((m,v)=>(m[v]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!c[m]).forEach(m=>{for(let v=0;v<P.length;v++)if(m.search(P[v])!==-1){delete b[m];break}})}e.sanitizeProcessEnvironment=C;function L(b){!b||(delete b.DEBUG,T.isMacintosh&&delete b.DYLD_LIBRARY_PATH,T.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(ie[45],ne([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(g){return D(g,0)}e.hash=A;function D(g,h){switch(typeof g){case"object":return g===null?C(349,h):Array.isArray(g)?f(g,h):c(g,h);case"string":return b(g,h);case"boolean":return L(g,h);case"number":return C(g,h);case"undefined":return C(937,h);default:return C(617,h)}}e.doHash=D;function C(g,h){return(h<<5)-h+g|0}e.numberHash=C;function L(g,h){return C(g?433:863,h)}function b(g,h){h=C(149417,h);for(let y=0,p=g.length;y<p;y++)h=C(g.charCodeAt(y),h);return h}e.stringHash=b;function f(g,h){return h=C(104579,h),g.reduce((y,p)=>D(p,y),h)}function c(g,h){return h=C(181387,h),Object.keys(g).sort().reduce((y,p)=>(y=b(p,y),D(g[p],y)),h)}class P{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=D(h,this.g),this.g}}e.Hasher=P;var E;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(g,h,y=32){const p=y-h,I=~((1<<p)-1);return(g<<h|(I&g)>>>p)>>>0}function v(g,h=0,y=g.byteLength,p=0){for(let I=0;I<y;I++)g[h+I]=p}function N(g,h,y="0"){for(;g.length<h;)g=y+g;return g}function R(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(y=>y.toString(16).padStart(2,"0")).join(""):N((g>>>0).toString(16),h/4)}e.toHexString=R;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const y=h.length;if(y===0)return;const p=this.p;let I=this.r,t=this.u,a,n;for(t!==0?(a=t,n=-1,t=0):(a=h.charCodeAt(0),n=0);;){let i=a;if(T.isHighSurrogate(a))if(n+1<y){const r=h.charCodeAt(n+1);T.isLowSurrogate(r)?(n++,i=T.computeCodePoint(a,r)):i=65533}else{t=a;break}else T.isLowSurrogate(a)&&(i=65533);if(I=this.w(p,I,i),n++,n<y)a=h.charCodeAt(n);else break}this.r=I,this.u=t}w(h,y,p){return p<128?h[y++]=p:p<2048?(h[y++]=192|(p&1984)>>>6,h[y++]=128|(p&63)>>>0):p<65536?(h[y++]=224|(p&61440)>>>12,h[y++]=128|(p&4032)>>>6,h[y++]=128|(p&63)>>>0):(h[y++]=240|(p&1835008)>>>18,h[y++]=128|(p&258048)>>>12,h[y++]=128|(p&4032)>>>6,h[y++]=128|(p&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=u.g,y=this.q;for(let l=0;l<64;l+=4)h.setUint32(l,y.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)h.setUint32(l,m(h.getUint32(l-12,!1)^h.getUint32(l-32,!1)^h.getUint32(l-56,!1)^h.getUint32(l-64,!1),1),!1);let p=this.h,I=this.l,t=this.m,a=this.n,n=this.o,i,r,o;for(let l=0;l<80;l++)l<20?(i=I&t|~I&a,r=1518500249):l<40?(i=I^t^a,r=1859775393):l<60?(i=I&t|I&a|t&a,r=2400959708):(i=I^t^a,r=3395469782),o=m(p,5)+i+n+r+h.getUint32(l*4,!1)&4294967295,n=a,a=t,t=m(I,30),I=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+I&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(ie[53],ne([0,1,29]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(A||(A={})),function(D){const C="error",L="warning",b="warn",f="info",c="ignore";function P(m){return m?T.equalsIgnoreCase(C,m)?D.Error:T.equalsIgnoreCase(L,m)||T.equalsIgnoreCase(b,m)?D.Warning:T.equalsIgnoreCase(f,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=P;function E(m){switch(m){case D.Error:return C;case D.Warning:return L;case D.Info:return f;default:return c}}D.toString=E}(A||(A={})),e.default=A}),define(ie[79],ne([0,1,11]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=A;function D(c){const P=[];let E;try{const m=JSON.parse(c.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),E=v.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:E}}e.parse=D;function C(c){if(typeof c!="string")return C(D(c).stack);const P=c;if(P){const E=L(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:T.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=C;function L(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function b(c,P){const{args:E,stack:m}=D(c),v=typeof E[0]=="string"&&E.length===1;let N=L(m);N&&(N=`(${N.trim()})`);let R=[];if(typeof E[0]=="string"?N&&v?R=[`%c[${P}] %c${E[0]} %c${N}`,f("blue"),f(""),f("grey")]:R=[`%c[${P}] %c${E[0]}`,f("blue"),f(""),...E.slice(1)]:R=[`%c[${P}]%`,f("blue"),...E],N&&!v&&R.push(N),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,R)}e.log=b;function f(c){return`color: ${c}`}}),define(ie[54],ne([0,1,14,29,11]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(c){return JSON.stringify(c,b)}e.stringify=C;function L(c){let P=JSON.parse(c);return P=f(P),P}e.parse=L;function b(c,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,A.regExpFlags)(P)}:P}function f(c,P=0){if(!c||P>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return D.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof T.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=f(c[E],P+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=f(c[E],P+1))}return c}e.revive=f}),define(ie[80],ne([0,1,32,55,28,73]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(c){return this.a||(this.a=A.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,P=0;const E=(0,T.networkInterfaces)();for(const m in E){const v=E[m];if(v)for(const{mac:N,internal:R}of v)R||(P+=1,this.c(N.toUpperCase())&&(c+=1))}this.b=P>0?c/P:0}return this.b}};let L;async function b(c){return L||(L=(async()=>await f(c)||D.generateUuid())()),L}e.getMachineId=b;async function f(c){try{const P=await new Promise((m,v)=>{G(["crypto"],m,v)}),E=(0,C.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){c(P);return}}}),define(ie[81],ne([0,1,32,15,22]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,L=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var f;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(I,t,a){this.exePath=I,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:p=!1,findPreview:I=!1}={}){const t=m({useAlternateBitness:p});if(!t)return null;const a=A.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let n=-1,i=null;for(const l of await D.Promises.readdir(a)){let d=-1;if(I){const O=l.indexOf("-");if(O<0)continue;const j=l.substring(0,O);if(!C.test(j)||l.substring(O+1)!=="preview")continue;d=parseInt(j,10)}else{if(!C.test(l))continue;d=parseInt(l,10)}if(d<=n)continue;const w=A.join(a,l,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(i=w,n=d)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",o=I?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function N({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const I=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(I))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(I))if(t.test(n)){const i=A.join(I,n,"pwsh.exe");return new E(i,a)}return null}function R(){const p=A.join(T.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function u(){const p=A.join(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*g(){let p=await v();p&&(yield p),p=await v({useAlternateBitness:!0}),p&&(yield p),p=await N(),p&&(yield p),p=R(),p&&(yield p),p=await v({findPreview:!0}),p&&(yield p),p=await N({findPreview:!0}),p&&(yield p),p=await v({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=u(),p&&(yield p)}async function*h(){for await(const p of g())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=h;async function y(){for await(const p of h())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ie[56],ne([0,1,15,12,34,52,3,22]),function(G,e,T,A,D,C,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function f(E=D.env){return E.comspec||"cmd.exe"}e.getWindowsShell=f;function c(E){let m=[],v=!1;const N=function(R){if(v){m.push(R);return}(!E.send(R,g=>{if(g&&console.error(g),v=!1,m.length>0){const h=m.slice(0);m=[],h.forEach(y=>N(y))}})||A.isWindows)&&(v=!0)};return{send:N}}e.createQueuedSender=c;var P;(function(E){async function m(v,N,R){if(T.isAbsolute(v))return v;if(N===void 0&&(N=D.cwd()),T.dirname(v)!=="."||(R===void 0&&L.isString(D.env.PATH)&&(R=D.env.PATH.split(T.delimiter)),R===void 0||R.length===0))return T.join(N,v);async function g(h){if(await b.Promises.exists(h)){let y;try{y=await b.Promises.stat(h)}catch(p){p.message.startsWith("EACCES")&&(y=await b.Promises.lstat(h))}return y?!y.isDirectory():!1}return!1}for(const h of R){let y;if(T.isAbsolute(h)?y=T.join(h,v):y=T.join(N,h,v),await g(y))return y;let p=y+".com";if(await g(p)||(p=y+".exe",await g(p)))return p}return T.join(N,v)}E.findExecutable=m})(P=e.win32||(e.win32={}))}),define(ie[82],ne([0,1,32,12,81,56]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function L(E,m){return E===1?A.isWindows?P():C.getWindowsShell(m):f(E,m)}e.getSystemShell=L;let b=null;function f(E,m){if(A.isLinux&&E===2||A.isMacintosh&&E===3)return"/bin/bash";if(!b){let v;if(A.isWindows)v="/bin/bash";else{if(v=m.SHELL,!v)try{v=(0,T.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}b=v}return b}let c=null;async function P(){return c||(c=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ve=this&&this.__decorate||function(G,e,T,A){var D=arguments.length,C=D<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,T):A,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(G,e,T,A);else for(var b=G.length-1;b>=0;b--)(L=G[b])&&(C=(D<3?L(C):D>3?L(e,T,C):L(e,T))||C);return D>3&&C&&Object.defineProperty(e,T,C),C};define(ie[57],ne([0,1,19,8,14,23,50,9,5,2,54,29,3]),function(G,e,T,A,D,C,L,b,f,c,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var v;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(v||(v={}));function N(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(R||(R={}));function u(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));function h(x){let F=0;for(let W=0;;W+=7){const H=x.read(1);if(F|=(H.buffer[0]&127)<<W,!(H.buffer[0]&128))return F}}const y=n(0);function p(x,F){if(F===0){x.write(y);return}let W=0;for(let X=F;X!==0;X=X>>>7)W++;const H=D.VSBuffer.alloc(W);for(let X=0;F!==0;X++)H.buffer[X]=F&127,F=F>>>7,F>0&&(H.buffer[X]|=128);x.write(H)}class I{constructor(F){this.b=F,this.a=0}read(F){const W=this.b.slice(this.a,this.a+F);return this.a+=W.byteLength,W}}e.BufferReader=I;class t{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(a||(a={}));function n(x){const F=D.VSBuffer.alloc(1);return F.writeUInt8(x,0),F}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},r=typeof Buffer<"u";function o(x,F){if(typeof F>"u")x.write(i.Undefined);else if(typeof F=="string"){const W=D.VSBuffer.fromString(F);x.write(i.String),p(x,W.byteLength),x.write(W)}else if(r&&Buffer.isBuffer(F)){const W=D.VSBuffer.wrap(F);x.write(i.Buffer),p(x,W.byteLength),x.write(W)}else if(F instanceof D.VSBuffer)x.write(i.VSBuffer),p(x,F.byteLength),x.write(F);else if(Array.isArray(F)){x.write(i.Array),p(x,F.length);for(const W of F)o(x,W)}else if(typeof F=="number"&&(F|0)===F)x.write(i.Uint),p(x,F);else{const W=D.VSBuffer.fromString(JSON.stringify(F));x.write(i.Object),p(x,W.byteLength),x.write(W)}}e.serialize=o;function l(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(h(x)).toString();case a.Buffer:return x.read(h(x)).buffer;case a.VSBuffer:return x.read(h(x));case a.Array:{const W=h(x),H=[];for(let X=0;X<W;X++)H.push(l(x));return H}case a.Object:return JSON.parse(x.read(h(x)).toString());case a.Int:return h(x)}}e.deserialize=l;class d{constructor(F,W,H=null,X=1e3){this.h=F,this.j=W,this.k=H,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(M=>this.q(M)),this.m({type:200})}registerChannel(F,W){this.b.set(F,W),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const W=this.o([F.type]);this.k?.logOutgoing(W,0,1,u(F.type));return}case 201:case 202:case 204:case 203:{const W=this.o([F.type,F.id],F.data);this.k?.logOutgoing(W,F.id,1,u(F.type),F.data);return}}}o(F,W=void 0){const H=new t;return o(H,F),o(H,W),this.p(H.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const W=new I(F),H=l(W),X=l(W),M=H[0];switch(M){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(M)}: ${H[2]}.${H[3]}`,X),this.s({type:M,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(M)}: ${H[2]}.${H[3]}`,X),this.t({type:M,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(M)}`),this.u({type:M,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${N(M)}`),this.u({type:M,id:H[1]})}}s(F){const W=this.b.get(F.channelName);if(!W){this.v(F);return}const H=new C.CancellationTokenSource;let X;try{X=W.call(this.j,F.name,F.arg,H.token)}catch(k){X=Promise.reject(k)}const M=F.id;X.then(k=>{this.m({id:M,data:k,type:201}),this.d.delete(F.id)},k=>{k instanceof Error?this.m({id:M,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.m({id:M,data:k,type:203}),this.d.delete(F.id)});const U=(0,c.toDisposable)(()=>H.cancel());this.d.set(F.id,U)}t(F){const W=this.b.get(F.channelName);if(!W){this.v(F);return}const H=F.id,M=W.listen(this.j,F.name,F.arg)(U=>this.m({id:H,data:U,type:204}));this.d.set(F.id,M)}u(F){const W=this.d.get(F.id);W&&(W.dispose(),this.d.delete(F.id))}v(F){let W=this.g.get(F.channelName);W||(W=[],this.g.set(F.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:F,timeoutTimer:H})}w(F){const W=this.g.get(F);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=d;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class O{constructor(F,W=null){this.l=F,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=W}getChannel(F){const W=this;return{call(H,X,M){return W.a?Promise.reject(new b.CancellationError):W.m(F,H,X,M)},listen(H,X){return W.a?f.Event.None:W.o(F,H,X)}}}m(F,W,H,X=C.CancellationToken.None){const M=this.g++,k={id:M,type:100,channelName:F,name:W,arg:H};if(X.isCancellationRequested)return Promise.reject(new b.CancellationError);let s;return new Promise((z,B)=>{if(X.isCancellationRequested)return B(new b.CancellationError);const K=()=>{const pe=ue=>{switch(ue.type){case 201:this.f.delete(M),z(ue.data);break;case 202:{this.f.delete(M);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,B(ge);break}case 203:this.f.delete(M),B(ue.data);break}};this.f.set(M,pe),this.p(k)};let Q=null;this.b===g.Idle?K():(Q=(0,A.createCancelablePromise)(pe=>this.u()),Q.then(()=>{Q=null,K()}));const oe=()=>{Q?(Q.cancel(),Q=null):this.p({id:M,type:101}),B(new b.CancellationError)},de=X.onCancellationRequested(oe);s=(0,c.combinedDisposable)((0,c.toDisposable)(oe),de),this.d.add(s)}).finally(()=>{this.d.delete(s)})}o(F,W,H){const X=this.g++,U={id:X,type:102,channelName:F,name:W,arg:H};let k=null;const s=new f.Emitter({onWillAddFirstListener:()=>{k=(0,A.createCancelablePromise)(z=>this.u()),k.then(()=>{k=null,this.d.add(s),this.p(U)})},onDidRemoveLastListener:()=>{k?(k.cancel(),k=null):(this.d.delete(s),this.p({id:X,type:103}))}}),S=z=>s.fire(z.data);return this.f.set(X,S),s.event}p(F){switch(F.type){case 100:case 102:{const W=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(W,F.id,0,`${N(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.q([F.type,F.id]);this.j?.logOutgoing(W,F.id,0,N(F.type));return}}}q(F,W=void 0){const H=new t;return o(H,F),o(H,W),this.r(H.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const W=new I(F),H=l(W),X=l(W),M=H[0];switch(M){case 200:return this.j?.logIncoming(F.byteLength,0,0,u(M)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,u(M),X),this.t({type:H[0],id:H[1],data:X})}}t(F){if(F.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}ve([L.memoize],O.prototype,"onDidInitializePromise",null),e.ChannelClient=O;class j{get connections(){const F=[];return this.f.forEach(W=>F.push(W)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:W,onDidClientDisconnect:H})=>{f.Event.once(W.onMessage)(M=>{const U=new I(M),k=l(U),s=new d(W,k),S=new O(W);this.a.forEach((B,K)=>s.registerChannel(K,B));const z={channelServer:s,channelClient:S,ctx:k};this.f.add(z),this.g.fire(z),H(()=>{s.dispose(),S.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(F,W){const H=this;return{call(X,M,U){let k;if((0,m.isFunction)(W)){const S=(0,T.getRandomElement)(H.connections.filter(W));k=S?Promise.resolve(S):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,W))}else k=W.routeCall(H,X,M);const s=k.then(S=>S.channelClient.getChannel(F));return J(s).call(X,M,U)},listen(X,M){if((0,m.isFunction)(W))return H.j(F,W,X,M);const U=W.routeEvent(H,X,M).then(k=>k.channelClient.getChannel(F));return J(U).listen(X,M)}}}j(F,W,H,X){const M=this;let U=new c.DisposableStore;const k=new f.Emitter({onWillAddFirstListener:()=>{U=new c.DisposableStore;const s=new f.EventMultiplexer,S=new Map,z=K=>{const oe=K.channelClient.getChannel(F).listen(H,X),de=s.add(oe);S.set(K,de)},B=K=>{const Q=S.get(K);!Q||(Q.dispose(),S.delete(K))};M.connections.filter(W).forEach(z),f.Event.filter(M.onDidAddConnection,W)(z,void 0,U),M.onDidRemoveConnection(B,void 0,U),s.event(k.fire,k,U),U.add(s)},onDidRemoveLastListener:()=>{U.dispose()}});return k.event}registerChannel(F,W){this.a.set(F,W),this.f.forEach(H=>{H.channelServer.registerChannel(F,W)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class Y{constructor(F,W,H=null){const X=new t;o(X,W),F.send(X.buffer),this.a=new O(F,H),this.d=new d(F,W,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,W){this.d.registerChannel(F,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function J(x){return{call(F,W,H){return x.then(X=>X.call(F,W,H))},listen(F,W){const H=new f.Relay;return x.then(X=>H.input=X.listen(F,W)),H.event}}}e.getDelayedChannel=J;function ee(x){let F=!1;return{call(W,H,X){return F?x.call(W,H,X):(0,A.timeout)(0).then(()=>F=!0).then(()=>x.call(W,H,X))},listen(W,H){if(F)return x.listen(W,H);const X=new f.Relay;return(0,A.timeout)(0).then(()=>F=!0).then(()=>X.input=x.listen(W,H)),X.event}}}e.getNextTickChannel=ee;class le{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const W of F.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=le;var re;(function(x){function F(M,U){const k=M,s=U&&U.disableMarshalling,S=new Map;for(const z in k)H(z)&&S.set(z,f.Event.buffer(k[z],!0));return new class{listen(z,B,K){const Q=S.get(B);if(Q)return Q;if(X(B)){const oe=k[B];if(typeof oe=="function")return oe.call(k,K)}throw new Error(`Event not found: ${B}`)}call(z,B,K){const Q=k[B];if(typeof Q=="function"){if(!s&&Array.isArray(K))for(let oe=0;oe<K.length;oe++)K[oe]=(0,P.revive)(K[oe]);return Q.apply(k,K)}throw new Error(`Method not found: ${B}`)}}}x.fromService=F;function W(M,U){const k=U&&U.disableMarshalling;return new Proxy({},{get(s,S){if(typeof S=="string")return U?.properties?.has(S)?U.properties.get(S):X(S)?function(z){return M.listen(S,z)}:H(S)?M.listen(S):async function(...z){let B;U&&!(0,m.isUndefinedOrNull)(U.context)?B=[U.context,...z]:B=z;const K=await M.call(S,B);return k?K:(0,P.revive)(K)};throw new Error(`Property not found: ${String(S)}`)}})}x.toService=W;function H(M){return M[0]==="o"&&M[1]==="n"&&E.isUpperAsciiLetter(M.charCodeAt(2))}function X(M){return/^onDynamic/.test(M)&&E.isUpperAsciiLetter(M.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const F=x.toString();if(F!=="[object Object]")return F}return x}function se(x){return Array.isArray(x)?x.map(ce):ce(x)}function $(x,F,W,H,X,M,U){U=se(U);const k=he[X],s=k[H%k.length];let S=[`%c[${x}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${s}`];/\($/.test(M)?(S=S.concat(U),S.push(")")):S.push(U),console.log.apply(console,S)}class q{constructor(F,W){this.d=F,this.f=W,this.a=0,this.b=0}logOutgoing(F,W,H,X,M){this.b+=F,$(this.d,this.b,F,W,H,X,M)}logIncoming(F,W,H,X,M){this.a+=F,$(this.f,this.a,F,W,H,X,M)}}e.IPCLogger=q}),define(ie[83],ne([0,1,58,8,14,23,79,9,5,2,30,56,52,57]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class N extends v.ChannelServer{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>D.VSBuffer.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=N;class R{constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const y=h&&h.timeout?h.timeout:6e4;this.b=new A.Delayer(y),this.d=null,this.f=null}getChannel(g){const h=this;return{call(y,p,I){return h.k(g,y,p,I)},listen(y,p){return h.l(g,y,p)}}}k(g,h,y,p=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.canceled());this.b.cancel();const I=this.n(g),t=(0,A.createCancelablePromise)(i=>I.call(h,y,i)),a=p.onCancellationRequested(()=>t.cancel()),n=(0,c.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,h,y){if(!this.b)return f.Event.None;this.b.cancel();let p;const I=new f.Emitter({onWillAddFirstListener:()=>{p=this.n(g).listen(h,y)(I.fire,I),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(h.env),this.d=(0,T.fork)(this.i,g,h);const y=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,L.isRemoteConsoleLog)(r)){(0,L.log)(r,`IPC Library: ${this.j.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const I=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&I.send(r.buffer.toString("base64")),a=y.event,n={send:t,onMessage:a};this.f=new v.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.dispose)(l)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=R}),define(ie[84],ne([0,1,8,5,2,3]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L=e.StorageHint||(e.StorageHint={}));function b(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var f;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class c extends D.Disposable{constructor(m,v=Object.create(null)){super(),this.m=m,this.n=v,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new T.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((v,N)=>this.s(N,v)),m.deleted?.forEach(v=>this.s(v,void 0))}s(m,v){if(this.c===f.Closed)return;let N=!1;(0,C.isUndefinedOrNull)(v)?N=this.f.delete(m):this.f.get(m)!==v&&(this.f.set(m,v),N=!0),N&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,v){const N=this.f.get(m);return(0,C.isUndefinedOrNull)(N)?v:N}getBoolean(m,v){const N=this.get(m);return(0,C.isUndefinedOrNull)(N)?v:N==="true"}getNumber(m,v){const N=this.get(m);return(0,C.isUndefinedOrNull)(N)?v:parseInt(N,10)}async set(m,v){if(this.c===f.Closed)return;if((0,C.isUndefinedOrNull)(v))return this.delete(m);const N=String(v);if(this.f.get(m)!==N)return this.f.set(m,N),this.j.set(m,N),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===f.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===L.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class P{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((v,N)=>this.a.set(N,v)),m.delete?.forEach(v=>this.a.delete(v))}async close(){}}e.InMemoryStorageDatabase=P}),define(ie[85],ne([7,4]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ie[86],ne([7,4]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[87],ne([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[88],ne([7,4]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ie[89],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[90],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[91],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[92],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[93],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[94],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[95],ne([7,4]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[96],ne([7,4]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[97],ne([7,4]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[98],ne([7,4]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[99],ne([7,4]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[100],ne([7,4]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[101],ne([7,4]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[102],ne([7,4]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[103],ne([7,4]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[104],ne([7,4]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[105],ne([7,4]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[106],ne([0,1,9,88]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D=e.TokenType||(e.TokenType={}));function C(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const L=(0,A.localize)(3,null),b=(0,A.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,T.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(C("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(C("&&"));break;case 124:this.h(124)?this.k(16):this.l(C("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:E,lexeme:m,additionalInfo:P}),this.f.push(v)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),m=f.b.get(E);m?this.k(m):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,m=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(b);return}const N=this.c.charCodeAt(P);if(E)E=!1;else if(N===47&&!m){P++;break}else N===91?m=!0:N===92?E=!0:N===93&&(m=!1);P++}for(;P<this.c.length&&f.a.has(this.c.charCodeAt(P));)P++;this.e=P;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}f.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=f}),define(ie[107],ne([0,1,75,50,16,15,34,17,11]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",v)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=L.env.VSCODE_PORTABLE;return v?f.URI.file((0,C.join)(v,"argv.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,C.resolve)(v):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?f.URI.file((0,C.resolve)(v)):f.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,C.resolve)(v);const N=L.env.VSCODE_EXTENSIONS;if(N)return N;const R=L.env.VSCODE_PORTABLE;return R?(0,C.join)(R,"extensions"):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(N=>/^[^:/?#]+?:\/\//.test(N)?f.URI.parse(N):f.URI.file((0,C.normalize)(N)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,C.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const N of this.args.log||[]){const R=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(N);R&&R[1]&&R[2]&&v.push([R[1],R[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=L.env.VSCODE_PORTABLE;return v?f.URI.file((0,C.join)(v,"policy.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,N,R){this.a=v,this.b=N,this.c=R,this.editSessionId=this.args.editSessionId}}ve([A.memoize],c.prototype,"appRoot",null),ve([A.memoize],c.prototype,"userHome",null),ve([A.memoize],c.prototype,"userDataPath",null),ve([A.memoize],c.prototype,"appSettingsHome",null),ve([A.memoize],c.prototype,"tmpDir",null),ve([A.memoize],c.prototype,"cacheHome",null),ve([A.memoize],c.prototype,"stateResource",null),ve([A.memoize],c.prototype,"userRoamingDataHome",null),ve([A.memoize],c.prototype,"userDataSyncHome",null),ve([A.memoize],c.prototype,"sync",null),ve([A.memoize],c.prototype,"machineSettingsResource",null),ve([A.memoize],c.prototype,"workspaceStorageHome",null),ve([A.memoize],c.prototype,"localHistoryHome",null),ve([A.memoize],c.prototype,"keyboardLayoutResource",null),ve([A.memoize],c.prototype,"argvResource",null),ve([A.memoize],c.prototype,"isExtensionDevelopment",null),ve([A.memoize],c.prototype,"untitledWorkspacesHome",null),ve([A.memoize],c.prototype,"builtinExtensionsPath",null),ve([A.memoize],c.prototype,"extensionsPath",null),ve([A.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ve([A.memoize],c.prototype,"extensionDevelopmentKind",null),ve([A.memoize],c.prototype,"extensionTestsLocationURI",null),ve([A.memoize],c.prototype,"debugExtensionHost",null),ve([A.memoize],c.prototype,"logLevel",null),ve([A.memoize],c.prototype,"extensionLogLevel",null),ve([A.memoize],c.prototype,"serviceMachineIdResource",null),ve([A.memoize],c.prototype,"disableTelemetry",null),ve([A.memoize],c.prototype,"disableWorkspaceTrust",null),ve([A.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function P(m,v){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,v,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function E(m,v,N,R,u,g){const y=Number(v||m)||(R?null:N),p=y?Boolean(!!v):!1;let I;if(g)try{I=JSON.parse(g)}catch{}return{port:y,break:p,debugId:u,env:I}}e.parseDebugParams=E}),function(){"use strict";function G(e,T,A){function D(L,b){const f=C(L,b),c=[f];return e.isAbsolute(f)||c.unshift(A),e.resolve(...c)}function C(L,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(E,"AppData","Roaming")}break;case"darwin":c=e.join(T.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:D}}if(typeof define=="function")define(ie[108],ne([161,32,34]),function(e,T,A){return G(e,T,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=G(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[109],ne([0,1,32,107,108]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class C extends A.AbstractNativeEnvironmentService{constructor(c,P){super(c,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,P.nameShort)},P)}}e.NativeEnvironmentService=C;function L(f,c){return(0,A.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,c,f.extensionEnvironment)}e.parsePtyHostDebugPort=L;function b(f,c){return(0,A.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,c,f.extensionEnvironment)}e.parseSharedProcessDebugPort=b}),define(ie[110],ne([0,1,3,92]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(L,b,f){try{C(L,b,f)}catch(c){console.error(c?.message??c)}return L}e.localizeManifest=D;function C(L,b,f){const c=(P,E,m)=>{const v=P[E];if((0,T.isString)(v)){const N=v,R=N.length;if(R>1&&N[0]==="%"&&N[R-1]==="%"){const u=N.substr(1,R-2);let g=b[u];g===void 0&&f&&(g=f[u]);const h=typeof g=="string"?g:g?.message,y=f?.[u],p=typeof y=="string"?y:y?.message;if(!h){p||console.warn(`[${L.name}]: ${(0,A.localize)(0,null,u)}`);return}if(m&&(E==="title"||E==="category")&&p&&p!==h){const I={value:h,original:p};P[E]=I}else P[E]=h}}else if((0,T.isObject)(v))for(const N in v)v.hasOwnProperty(N)&&(N==="commands"?c(v,N,!0):c(v,N,m));else if(Array.isArray(v))for(let N=0;N<v.length;N++)c(v,N,m)};for(const P in L)L.hasOwnProperty(P)&&c(L,P)}}),define(ie[46],ne([0,1,17,53,96,41]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=f;function c(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=c;function P(g){if(!g)return null;const h=g.majorBase,y=g.majorMustEqual,p=g.minorBase;let I=g.minorMustEqual;const t=g.patchBase;let a=g.patchMustEqual;g.hasCaret&&(h===0||(I=!1),a=!1);let n=0;if(g.preRelease){const i=b.exec(g.preRelease);if(i){const[,r,o,l]=i;n=Date.UTC(Number(r),Number(o)-1,Number(l))}}return{majorBase:h,majorMustEqual:y,minorBase:p,minorMustEqual:I,patchBase:t,patchMustEqual:a,isMinimum:g.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function E(g,h,y){let p;typeof g=="string"?p=P(c(g)):p=g;let I;h instanceof Date?I=h.getTime():typeof h=="string"&&(I=new Date(h).getTime());let t;if(typeof y=="string"?t=P(c(y)):t=y,!p||!t)return!1;const a=p.majorBase,n=p.minorBase,i=p.patchBase;let r=t.majorBase,o=t.minorBase,l=t.patchBase;const d=t.notBefore;let w=t.majorMustEqual,O=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:n>o?!0:n<o||I&&I<d?!1:i>=l:(a===1&&r===0&&(!w||!O||!j)&&(r=1,o=0,l=0,w=!0,O=!1,j=!1),a<r?!1:a>r?!w:n<o?!1:n>o?!O:i<l?!1:i>l?!j:!(I&&I<d))}e.isValidVersion=E;function m(g,h,y,p,I){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([A.default.Error,D.localize(0,null)]),t;if(typeof p.name!="string")return t.push([A.default.Error,D.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([A.default.Error,D.localize(2,null,"version")]),t;if(!p.engines)return t.push([A.default.Error,D.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([A.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!u(p.extensionDependencies))return t.push([A.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!u(p.activationEvents))return t.push([A.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([A.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([A.default.Warning,D.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([A.default.Error,D.localize(9,null,"main")]),t;{const i=(0,T.joinPath)(y,p.main);(0,T.isEqualOrParent)(i,y)||t.push([A.default.Warning,D.localize(10,null,i.path,y.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([A.default.Error,D.localize(11,null,"browser")]),t;{const i=(0,T.joinPath)(y,p.browser);(0,T.isEqualOrParent)(i,y)||t.push([A.default.Warning,D.localize(12,null,i.path,y.path)])}}if(!C.valid(p.version))return t.push([A.default.Error,D.localize(13,null)]),t;const a=[];if(!v(g,h,p,I,a))for(const i of a)t.push([A.default.Error,i]);return t}e.validateExtensionManifest=m;function v(g,h,y,p,I){return p||typeof y.main>"u"&&typeof y.browser>"u"?!0:R(g,h,y.engines.vscode,I)}e.isValidExtensionVersion=v;function N(g,h,y){return g==="*"||R(h,y,g)}e.isEngineValid=N;function R(g,h,y,p=[]){const I=P(c(y));if(!I)return p.push(D.localize(14,null,y)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return p.push(D.localize(15,null,y)),!1}else if(!I.majorMustEqual)return p.push(D.localize(16,null,y)),!1;return E(g,h,I)?!0:(p.push(D.localize(17,null,g,y)),!1)}function u(g){if(!Array.isArray(g))return!1;for(let h=0,y=g.length;h<y;h++)if(typeof g[h]!="string")return!1;return!0}}),define(ie[111],ne([0,1,14,28]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,L,b){let f=b&&b.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const P=(await L.readFile(C.serviceMachineIdResource)).value.toString();f=(0,A.isUUID)(P)?P:null}catch{f=null}if(!f){f=(0,A.generateUuid)();try{await L.writeFile(C.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch{}}return b?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=D}),define(ie[47],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(D,C=[],L=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=T}),define(ie[112],ne([0,1,47]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var D;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function C(b,f,c){f instanceof T.SyncDescriptor||(f=new T.SyncDescriptor(f,[],Boolean(c))),A.push([b,f])}e.registerSingleton=C;function L(){return A}e.getSingletonServiceDescriptors=L}),define(ie[113],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(C,L){this.key=C,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class A{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const L of this.a.values())L.outgoing.size===0&&C.push(L);return C}insertEdge(C,L){const b=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(L);b.outgoing.set(f.key,f),f.incoming.set(b.key,b)}removeNode(C){const L=this.b(C);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(C){const L=this.b(C);let b=this.a.get(L);return b||(b=new T(L,C),this.a.set(L,b)),b}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[L,b]of this.a)C.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,L]of this.a){const b=new Set([C]),f=this.c(L,b);if(f)return f}}c(C,L){for(const[b,f]of C.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const c=this.c(f,L);if(c)return c;L.delete(b)}}}e.Graph=A}),define(ie[24],ne([0,1,3,11,10]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationOverrides=C;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=L;var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function c(u,g){const h=Object.create(null);for(const y in u)P(h,y,u[y],g);return h}e.toValuesTree=c;function P(u,g,h,y){const p=g.split("."),I=p.pop();let t=u;for(let a=0;a<p.length;a++){const n=p[a];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:y(`Ignoring ${g} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[I]=h}catch{y(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=P;function E(u,g){const h=g.split(".");m(u,h)}e.removeFromValueTree=E;function m(u,g){const h=g.shift();if(g.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const y=u[h];typeof y=="object"&&!Array.isArray(y)&&(m(y,g),Object.keys(y).length===0&&delete u[h])}}function v(u,g,h){function y(t,a){let n=t;for(const i of a){if(typeof n!="object"||n===null)return;n=n[i]}return n}const p=g.split("."),I=y(u,p);return typeof I>"u"?h:I}e.getConfigurationValue=v;function N(u,g,h){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in u?T.isObject(u[y])&&T.isObject(g[y])?N(u[y],g[y],h):h&&(u[y]=g[y]):u[y]=g[y])})}e.merge=N;function R(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=R}),define(ie[114],ne([0,1,12,29,106,10,87,9]),function(G,e,T,A,D,C,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",T.isMacintosh),f.set("isLinux",T.isLinux),f.set("isWindows",T.isWindows),f.set("isWeb",T.isWeb),f.set("isMacNative",T.isMacintosh&&!T.isWeb),f.set("isEdge",T.isEdge),f.set("isFirefox",T.isFirefox),f.set("isChrome",T.isChrome),f.set("isSafari",T.isSafari);function c(k,s){if(f.get(k)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(k,s)}e.setConstant=c;const P=Object.prototype.hasOwnProperty;var E;(function(k){k[k.False=0]="False",k[k.True=1]="True",k[k.Defined=2]="Defined",k[k.Not=3]="Not",k[k.Equals=4]="Equals",k[k.NotEquals=5]="NotEquals",k[k.And=6]="And",k[k.Regex=7]="Regex",k[k.NotRegex=8]="NotRegex",k[k.Or=9]="Or",k[k.In=10]="In",k[k.NotIn=11]="NotIn",k[k.Greater=12]="Greater",k[k.GreaterEquals=13]="GreaterEquals",k[k.Smaller=14]="Smaller",k[k.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));const m={regexParsingWithErrorRecovery:!0},v=(0,L.localize)(0,null),N=(0,L.localize)(1,null),R=(0,L.localize)(2,null),u=(0,L.localize)(3,null),g=(0,L.localize)(4,null),h=(0,L.localize)(5,null),y=(0,L.localize)(6,null),p=(0,L.localize)(7,null);class I{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(s=m){this.k=s,this.d=new D.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(s){if(s===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:N});return}this.f=this.d.reset(s).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const z=this.D(),B=z.type===17?h:void 0;throw this.h.push({message:g,offset:z.offset,lexeme:D.Scanner.getLexeme(z),additionalInfo:B}),I.c}return S}catch(S){if(S!==I.c)throw S;return}}l(){return this.m()}m(){const s=[this.o()];for(;this.y(16);){const S=this.o();s.push(S)}return s.length===1?s[0]:t.or(...s)}o(){const s=[this.s()];for(;this.y(15);){const S=this.s();s.push(S)}return s.length===1?s[0]:t.and(...s)}s(){if(this.y(2)){const s=this.D();switch(s.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,u),S?.negate()}case 17:return this.z(),Y.create(s.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",s)}}return this.t()}t(){const s=this.D();switch(s.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const S=this.l();return this.A(1,u),S}case 17:{const S=s.lexeme;if(this.z(),this.y(9)){const B=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),B.type!==10)throw this.B("REGEX",B);const K=B.lexeme,Q=K.lastIndexOf("/"),oe=Q===K.length-1?void 0:this.w(K.substring(Q+1));let de;try{de=new RegExp(K.substring(1,Q),oe)}catch{throw this.B("REGEX",B)}return ce.create(S,de)}switch(B.type){case 10:case 19:{const K=[B.lexeme];this.z();let Q=this.D(),oe=0;for(let ae=0;ae<B.lexeme.length;ae++)B.lexeme.charCodeAt(ae)===40?oe++:B.lexeme.charCodeAt(ae)===41&&oe--;for(;!this.E()&&Q.type!==15&&Q.type!==16;){switch(Q.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let ae=0;ae<Q.lexeme.length;ae++)Q.lexeme.charCodeAt(ae)===40?oe++:B.lexeme.charCodeAt(ae)===41&&oe--}if(oe<0)break;K.push(D.Scanner.getLexeme(Q)),this.z(),Q=this.D()}const de=K.join(""),pe=de.lastIndexOf("/"),ue=pe===de.length-1?void 0:this.w(de.substring(pe+1));let ge;try{ge=new RegExp(de.substring(1,pe),ue)}catch{throw this.B("REGEX",B)}return t.regex(S,ge)}case 18:{const K=B.lexeme;this.z();let Q=null;if(!(0,A.isFalsyOrWhitespace)(K)){const oe=K.indexOf("/"),de=K.lastIndexOf("/");if(oe!==de&&oe>=0){const pe=K.slice(oe+1,de),ue=K[de+1]==="i"?"i":"";try{Q=new RegExp(pe,ue)}catch{throw this.B("REGEX",B)}}}if(Q===null)throw this.B("REGEX",B);return ce.create(S,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const B=this.u();return t.notIn(S,B)}switch(this.D().type){case 3:{this.z();const B=this.u();if(this.x().type===18)return t.equals(S,B);switch(B){case"true":return t.has(S);case"false":return t.not(S);default:return t.equals(S,B)}}case 4:{this.z();const B=this.u();if(this.x().type===18)return t.notEquals(S,B);switch(B){case"true":return t.not(S);case"false":return t.has(S);default:return t.notEquals(S,B)}}case 5:return this.z(),re.create(S,this.u());case 6:return this.z(),he.create(S,this.u());case 7:return this.z(),ee.create(S,this.u());case 8:return this.z(),le.create(S,this.u());case 13:return this.z(),t.in(S,this.u());default:return t.has(S)}}case 20:throw this.h.push({message:y,offset:s.offset,lexeme:"",additionalInfo:p}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const s=this.D();switch(s.type){case 17:case 18:return this.z(),s.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(s){return s.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(s){return this.C(s)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(s,S){if(this.C(s))return this.z();throw this.B(S,this.D())}B(s,S,z){const B=(0,L.localize)(8,null,s,D.Scanner.getLexeme(S)),K=S.offset,Q=D.Scanner.getLexeme(S);return this.h.push({message:B,offset:K,lexeme:Q,additionalInfo:z}),I.c}C(s){return this.D().type===s}D(){return this.f[this.g]}E(){return this.D().type===20}}I.c=new Error,e.Parser=I;class t{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(s){return l.create(s)}static equals(s,S){return d.create(s,S)}static notEquals(s,S){return j.create(s,S)}static regex(s,S){return ce.create(s,S)}static in(s,S){return w.create(s,S)}static notIn(s,S){return O.create(s,S)}static not(s){return Y.create(s)}static and(...s){return q.create(s,null,!0)}static or(...s){return x.create(s,null,!0)}static greater(s,S){return ee.create(s,S)}static greaterEquals(s,S){return le.create(s,S)}static smaller(s,S){return re.create(s,S)}static smallerEquals(s,S){return he.create(s,S)}static deserialize(s){return s==null?void 0:this.c.parse(s)}}t.c=new I({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function a(k){const s=new I({regexParsingWithErrorRecovery:!1});return k.map(S=>(s.parse(S),s.lexingErrors.length>0?s.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,L.localize)(9,null,z.additionalInfo):(0,L.localize)(10,null),offset:z.offset,length:z.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=a;function n(k,s){const S=k?k.substituteConstants():void 0,z=s?s.substituteConstants():void 0;return!S&&!z?!0:!S||!z?!1:S.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function i(k,s){return k.cmp(s)}class r{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return o.INSTANCE}}r.INSTANCE=new r,e.ContextKeyFalseExpr=r;class o{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}o.INSTANCE=new o,e.ContextKeyTrueExpr=o;class l{static create(s,S=null){const z=f.get(s);return typeof z=="boolean"?z?o.INSTANCE:r.INSTANCE:new l(s,S)}constructor(s,S){this.key=s,this.c=S,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:W(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=f.get(this.key);return typeof s=="boolean"?s?o.INSTANCE:r.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.c||(this.c=Y.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class d{static create(s,S,z=null){if(typeof S=="boolean")return S?l.create(s,z):Y.create(s,z);const B=f.get(s);return typeof B=="boolean"?S===(B?"true":"false")?o.INSTANCE:r.INSTANCE:new d(s,S,z)}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=f.get(this.c);if(typeof s=="boolean"){const S=s?"true":"false";return this.d===S?o.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(s){return s.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class w{static create(s,S){return new w(s,S)}constructor(s,S){this.d=s,this.f=S,this.type=10,this.c=null}cmp(s){return s.type!==this.type?this.type-s.type:H(this.d,this.f,s.d,s.f)}equals(s){return s.type===this.type?this.d===s.d&&this.f===s.f:!1}substituteConstants(){return this}evaluate(s){const S=s.getValue(this.f),z=s.getValue(this.d);return Array.isArray(S)?S.includes(z):typeof z=="string"&&typeof S=="object"&&S!==null?P.call(S,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(s){return s.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=w;class O{static create(s,S){return new O(s,S)}constructor(s,S){this.d=s,this.f=S,this.type=11,this.c=w.create(s,S)}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(s){return s.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=O;class j{static create(s,S,z=null){if(typeof S=="boolean")return S?Y.create(s,z):l.create(s,z);const B=f.get(s);return typeof B=="boolean"?S===(B?"true":"false")?r.INSTANCE:o.INSTANCE:new j(s,S,z)}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=f.get(this.c);if(typeof s=="boolean"){const S=s?"true":"false";return this.d===S?r.INSTANCE:o.INSTANCE}return this}evaluate(s){return s.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(s){return s.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=j;class Y{static create(s,S=null){const z=f.get(s);return typeof z=="boolean"?z?r.INSTANCE:o.INSTANCE:new Y(s,S)}constructor(s,S){this.c=s,this.d=S,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:W(this.c,s.c)}equals(s){return s.type===this.type?this.c===s.c:!1}substituteConstants(){const s=f.get(this.c);return typeof s=="boolean"?s?r.INSTANCE:o.INSTANCE:this}evaluate(s){return!s.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(s){return s.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=Y;function J(k,s){if(typeof k=="string"){const S=parseFloat(k);isNaN(S)||(k=S)}return typeof k=="string"||typeof k=="number"?s(k):r.INSTANCE}class ee{static create(s,S,z=null){return J(S,B=>new ee(s,B,z))}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=ee;class le{static create(s,S,z=null){return J(S,B=>new le(s,B,z))}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=le;class re{static create(s,S,z=null){return J(S,B=>new re(s,B,z))}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=re;class he{static create(s,S,z=null){return J(S,B=>new he(s,B,z))}constructor(s,S,z){this.c=s,this.d=S,this.f=z,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:H(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=he;class ce{static create(s,S){return new ce(s,S)}constructor(s,S){this.d=s,this.f=S,this.type=7,this.c=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.d<s.d)return-1;if(this.d>s.d)return 1;const S=this.f?this.f.source:"",z=s.f?s.f.source:"";return S<z?-1:S>z?1:0}equals(s){if(s.type===this.type){const S=this.f?this.f.source:"",z=s.f?s.f.source:"";return this.d===s.d&&S===z}return!1}substituteConstants(){return this}evaluate(s){const S=s.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const s=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${s}`}keys(){return[this.d]}map(s){return s.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.ContextKeyRegexExpr=ce;class se{static create(s){return new se(s)}constructor(s){this.c=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(s){return new se(this.c.map(s))}negate(){return this.c}}e.ContextKeyNotRegexExpr=se;function $(k){let s=null;for(let S=0,z=k.length;S<z;S++){const B=k[S].substituteConstants();if(k[S]!==B&&s===null){s=[];for(let K=0;K<S;K++)s[K]=k[K]}s!==null&&(s[S]=B)}return s===null?k:s}class q{static create(s,S,z){return q.d(s,S,z)}constructor(s,S){this.expr=s,this.c=S,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const B=i(this.expr[S],s.expr[S]);if(B!==0)return B}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(s.expr[S]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:q.create(s,this.c,!1)}evaluate(s){for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].evaluate(s))return!1;return!0}static d(s,S,z){const B=[];let K=!1;for(const Q of s)if(!!Q){if(Q.type===1){K=!0;continue}if(Q.type===0)return r.INSTANCE;if(Q.type===6){B.push(...Q.expr);continue}B.push(Q)}if(B.length===0&&K)return o.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let Q=1;Q<B.length;Q++)B[Q-1].equals(B[Q])&&(B.splice(Q,1),Q--);if(B.length===1)return B[0];for(;B.length>1;){const Q=B[B.length-1];if(Q.type!==9)break;B.pop();const oe=B.pop(),de=B.length===0,pe=x.create(Q.expr.map(ue=>q.create([ue,oe],null,z)),null,de);pe&&(B.push(pe),B.sort(i))}if(B.length===1)return B[0];if(z){for(let Q=0;Q<B.length;Q++)for(let oe=Q+1;oe<B.length;oe++)if(B[Q].negate().equals(B[oe]))return r.INSTANCE;if(B.length===1)return B[0]}return new q(B,S)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const S of this.expr)s.push(...S.keys());return s}map(s){return new q(this.expr.map(S=>S.map(s)),null)}negate(){if(!this.c){const s=[];for(const S of this.expr)s.push(S.negate());this.c=x.create(s,this,!0)}return this.c}}e.ContextKeyAndExpr=q;class x{static create(s,S,z){return x.d(s,S,z)}constructor(s,S){this.expr=s,this.c=S,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const B=i(this.expr[S],s.expr[S]);if(B!==0)return B}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(s.expr[S]))return!1;return!0}return!1}substituteConstants(){const s=$(this.expr);return s===this.expr?this:x.create(s,this.c,!1)}evaluate(s){for(let S=0,z=this.expr.length;S<z;S++)if(this.expr[S].evaluate(s))return!0;return!1}static d(s,S,z){let B=[],K=!1;if(s){for(let Q=0,oe=s.length;Q<oe;Q++){const de=s[Q];if(!!de){if(de.type===0){K=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){B=B.concat(de.expr);continue}B.push(de)}}if(B.length===0&&K)return r.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let Q=1;Q<B.length;Q++)B[Q-1].equals(B[Q])&&(B.splice(Q,1),Q--);if(B.length===1)return B[0];if(z){for(let Q=0;Q<B.length;Q++)for(let oe=Q+1;oe<B.length;oe++)if(B[Q].negate().equals(B[oe]))return o.INSTANCE;if(B.length===1)return B[0]}return new x(B,S)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const S of this.expr)s.push(...S.keys());return s}map(s){return new x(this.expr.map(S=>S.map(s)),null)}negate(){if(!this.c){const s=[];for(const S of this.expr)s.push(S.negate());for(;s.length>1;){const S=s.shift(),z=s.shift(),B=[];for(const K of U(S))for(const Q of U(z))B.push(q.create([K,Q],null,!1));s.unshift(x.create(B,null,!1))}this.c=x.create(s,this,!0)}return this.c}}e.ContextKeyOrExpr=x;class F extends l{static all(){return F.d.values()}constructor(s,S,z){super(s,null),this.f=S,typeof z=="object"?F.d.push({...z,key:s}):z!==!0&&F.d.push({key:s,description:z,type:S!=null?typeof S:void 0})}bindTo(s){return s.createKey(this.key,this.f)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return d.create(this.key,s)}notEqualsTo(s){return j.create(this.key,s)}}F.d=[],e.RawContextKey=F,e.IContextKeyService=(0,C.createDecorator)("contextKeyService");function W(k,s){return k<s?-1:k>s?1:0}function H(k,s,S,z){return k<S?-1:k>S?1:s<z?-1:s>z?1:0}function X(k,s){if(k.type===0||s.type===1)return!0;if(k.type===9)return s.type===9?M(k.expr,s.expr):!1;if(s.type===9){for(const S of s.expr)if(X(k,S))return!0;return!1}if(k.type===6){if(s.type===6)return M(s.expr,k.expr);for(const S of k.expr)if(X(S,s))return!0;return!1}return k.equals(s)}e.implies=X;function M(k,s){let S=0,z=0;for(;S<k.length&&z<s.length;){const B=k[S].cmp(s[z]);if(B<0)return!1;B===0&&S++,z++}return S===k.length}function U(k){return k.type===9?k.expr:[k]}}),define(ie[59],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ie[18],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[20],ne([0,1,90,10]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function L(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function b(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function f(h,y,p){return b(y,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:c(p).includes(h)}e.isTargetPlatformCompatible=f;function c(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function P(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=P;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(h){h.Install="install",h.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var N;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(N=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var R;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(R=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var u;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class g extends Error{constructor(y,p){super(y),this.code=p,this.name=p}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,T.localize)(1,null),original:"Preferences"}}),define(ie[60],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((C,L)=>G(["node-vsce-sign"],async b=>C(b),L))),this.a}async verify(C,L,b){let f;try{f=await this.b()}catch{return!1}return f.verify(C,L,b)}}e.ExtensionSignatureVerificationService=A}),define(ie[61],ne([0,1,14,9,98,13]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,E,m,v,N,R){let u;try{await b(P,E,m,v,N,R)}catch(g){u=g}finally{u&&N.errorTransformer&&(u=N.errorTransformer(u)),typeof u<"u"&&m.error(u),m.end()}}e.readFileIntoStream=L;async function b(P,E,m,v,N,R){f(R);const u=await P.open(E,{create:!1});try{f(R);let g=0,h=0,y=N&&typeof N.length=="number"?N.length:void 0,p=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof y=="number"?y:N.bufferSize)),I=N&&typeof N.position=="number"?N.position:0,t=0;do h=await P.read(u,I,p.buffer,t,p.byteLength-t),I+=h,t+=h,g+=h,typeof y=="number"&&(y-=h),t===p.byteLength&&(await m.write(v(p)),p=T.VSBuffer.alloc(Math.min(N.bufferSize,typeof y=="number"?y:N.bufferSize)),t=0);while(h>0&&(typeof y!="number"||y>0)&&f(R)&&c(g,N));if(t>0){let a=t;typeof y=="number"&&(a=Math.min(t,y)),m.write(v(p.slice(0,a)))}}catch(g){throw(0,C.ensureFileSystemProviderError)(g)}finally{await P.close(u)}}function f(P){if(P.isCancellationRequested)throw(0,A.canceled)();return!0}function c(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[115],ne([0,1,5,162,2,12,163]),function(G,e,T,A,D,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.i(c),E=P.filter(v=>{const N=this.c.get(v.path);return N?!(0,A.patternsEquals)(N.request.excludes,v.excludes)||!(0,A.patternsEquals)(N.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!P.find(N=>N.path===v.path&&(0,A.patternsEquals)(N.excludes,v.excludes)&&(0,A.patternsEquals)(N.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.j(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of E)this.g(v)}g(c){const P=new L.NodeJSFileWatcherLibrary(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),E={request:c,instance:P};this.c.set(c.path,E)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}i(c){const P=new Map;for(const E of c){const m=C.isLinux?E.path:E.path.toLowerCase();P.set(m,E)}return Array.from(P.values())}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=b}),define(ie[116],ne([0,1,62,115]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends T.AbstractNonRecursiveWatcherClient{constructor(L,b,f){super(L,b,f),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ie[117],ne([0,1,16,57,83,62]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends C.AbstractUniversalWatcherClient{constructor(f,c,P){super(f,c,P),this.m()}l(f){const c=f.add(new D.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(c.onDidProcessExit(({code:P,signal:E})=>this.n(`terminated by itself with code ${P}, signal: ${E}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(ie[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...D){this.a=new Map;for(const[C,L]of D)this.set(C,L)}set(D,C){const L=this.a.get(D);return this.a.set(D,C),L}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=T}),define(ie[118],ne([0,1,8,9,2,47,113,10,63,164]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class E extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class m{constructor(u=new f.ServiceCollection,g=!1,h,y=P){this.f=u,this.g=g,this.h=h,this.i=y,this.o=new Set,this.f.set(b.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new L.Graph(p=>p):void 0}createChild(u){return new m(u,this.g,this,this.i)}invokeFunction(u,...g){const h=N.traceInvocation(this.i,u);let y=!1;try{return u({get:I=>{if(y)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(I,h);if(!t)throw new Error(`[invokeFunction] unknown service '${I}'`);return t}},...g)}finally{y=!0,h.stop()}}createInstance(u,...g){let h,y;return u instanceof C.SyncDescriptor?(h=N.traceCreation(this.i,u.ctor),y=this.j(u.ctor,u.staticArguments.concat(g),h)):(h=N.traceCreation(this.i,u),y=this.j(u,g,h)),h.stop(),y}j(u,g=[],h){const y=b._util.getServiceDependencies(u).sort((t,a)=>t.index-a.index),p=[];for(const t of y){const a=this.m(t.id,h);a||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const I=y.length>0?y[0].index:g.length;if(g.length!==I){console.trace(`[createInstance] First service dependency of ${u.name} at position ${I+1} conflicts with ${g.length} static arguments`);const t=I-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,I)}return Reflect.construct(u,g.concat(p))}k(u,g){if(this.f.get(u)instanceof C.SyncDescriptor)this.f.set(u,g);else if(this.h)this.h.k(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const g=this.f.get(u);return!g&&this.h?this.h.l(u):g}m(u,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const h=this.l(u);return h instanceof C.SyncDescriptor?this.q(u,h,g.branch(u,!0)):(g.branch(u,!1),h)}q(u,g,h){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,g,h)}finally{this.o.delete(u)}}r(u,g,h){const y=new L.Graph(t=>t.id.toString());let p=0;const I=[{id:u,desc:g,_trace:h}];for(;I.length;){const t=I.pop();if(y.lookupOrInsertNode(t),p++>1e3)throw new E(y);for(const a of b._util.getServiceDependencies(t.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),n instanceof C.SyncDescriptor){const i={id:a.id,desc:n,_trace:t._trace.branch(a.id,!0)};y.insertEdge(t,i),I.push(i)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new E(y);break}for(const{data:a}of t){if(this.l(a.id)instanceof C.SyncDescriptor){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}y.removeNode(a)}}return this.l(u)}s(u,g,h=[],y,p){if(this.f.get(u)instanceof C.SyncDescriptor)return this.t(u,g,h,y,p);if(this.h)return this.h.s(u,g,h,y,p);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(u,g,h=[],y,p){if(y){const I=new m(void 0,this.g,this,this.i);I.c=String(u);const t=new Map,a=new T.IdleValue(()=>{const n=I.j(g,h,p);for(const[i,r]of t){const o=n[i];if(typeof o=="function")for(const l of r)o.apply(n,l)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=t.get(i);return l||(l=new c.LinkedList,t.set(i,l)),(w,O,j)=>{const Y=l.push([w,O,j]);return(0,D.toDisposable)(Y)}}if(i in n)return n[i];const r=a.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),n[i]=o),o},set(n,i,r){return a.value[i]=r,!0},getPrototypeOf(n){return g.prototype}})}else return this.j(g,h,p)}u(u,g){if(g&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=m;var v;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(v||(v={}));class N{static traceInvocation(u,g){return u?new N(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):N.c}static traceCreation(u,g){return u?new N(1,g.name):N.c}constructor(u,g){this.type=u,this.name=g,this.g=Date.now(),this.h=[]}branch(u,g){const h=new N(3,u.toString());return this.h.push([u,g,h]),h}stop(){const u=Date.now()-this.g;N.f+=u;let g=!1;function h(p,I){const t=[],a=new Array(p+1).join("	");for(const[n,i,r]of I.h)if(i&&r){g=!0,t.push(`${a}CREATES -> ${n}`);const o=h(p+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${n}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${N.f.toFixed(2)}ms)`];(u>2||g)&&N.all.add(y.join(`
`))}}N.all=new Set,N.c=new class extends N{constructor(){super(0,null)}stop(){}branch(){return this}},N.f=0,e.Trace=N});var te=this&&this.__param||function(G,e){return function(T,A){e(T,A,G)}};define(ie[64],ne([0,1,23,2,12,100,20,10]),function(G,e,T,A,D,C,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let c=class extends A.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new T.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const N=m.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(u=>u.startsWith("lp-"))).map(R=>{const u=R.properties.localizedLanguages?.[0],g=f(R);return{...this.f(g,u,R),extensionId:R.identifier.id,galleryExtension:R}});return N.push(this.f("en","English")),N}f(E,m,v){const N=m??E;let R;if(N!==E&&(R=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(R??="",R+=(0,C.localize)(0,null)),v?.installCount){R??="";const u=v.installCount;let g;u>1e6?g=`${Math.floor(u/1e5)/10}M`:u>1e3?g=`${Math.floor(u/1e3)}K`:g=String(u),R+=` $(cloud-download) ${g}`}return{id:E,label:N,description:R}}};c=ve([te(0,L.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(ie[6],ne([0,1,33,5,45,2,35,12,17,3,11,114,10]),function(G,e,T,A,D,C,L,b,f,c,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function v(){return new Date().toISOString()}function N(w){return(0,c.isNumber)(w)}e.isLogLevel=N;var R;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function u(w,O,j){switch(O){case R.Trace:w.trace(j);break;case R.Debug:w.debug(j);break;case R.Info:w.info(j);break;case R.Warning:w.warn(j);break;case R.Error:w.error(j);break;case R.Off:break;default:throw new Error(`Invalid log level ${O}`)}}e.log=u;function g(w,O=!1){let j="";for(let Y=0;Y<w.length;Y++){let J=w[Y];if(J instanceof Error&&(J=(0,T.toErrorMessage)(J,O)),typeof J=="object")try{J=JSON.stringify(J)}catch{}j+=(Y>0?" ":"")+J}return j}class h extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==R.Off&&this.b<=O}}e.AbstractLogger=h;class y extends h{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...j){this.f(R.Trace)&&this.g(R.Trace,g([O,...j],!0))}debug(O,...j){this.f(R.Debug)&&this.g(R.Debug,g([O,...j]))}info(O,...j){this.f(R.Info)&&this.g(R.Info,g([O,...j]))}warn(O,...j){this.f(R.Warning)&&this.g(R.Warning,g([O,...j]))}error(O,...j){if(this.f(R.Error))if(O instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=O.stack,this.g(R.Error,g(Y))}else this.g(R.Error,g([O,...j]))}flush(){}}e.AbstractMessageLogger=y;class p extends h{constructor(O=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(O),this.g=!b.isWindows}trace(O,...j){this.f(R.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,O,...j):console.log(`[main ${v()}]`,O,...j))}debug(O,...j){this.f(R.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,O,...j):console.log(`[main ${v()}]`,O,...j))}info(O,...j){this.f(R.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,O,...j):console.log(`[main ${v()}]`,O,...j))}warn(O,...j){this.f(R.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,O,...j):console.warn(`[main ${v()}]`,O,...j))}error(O,...j){this.f(R.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,O,...j):console.error(`[main ${v()}]`,O,...j))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class I extends h{constructor(O=e.DEFAULT_LOG_LEVEL,j=!0){super(),this.g=j,this.setLevel(O)}trace(O,...j){this.f(R.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...j):console.log(O,...j))}debug(O,...j){this.f(R.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...j):console.log(O,...j))}info(O,...j){this.f(R.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...j):console.log(O,...j))}warn(O,...j){this.f(R.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...j):console.log(O,...j))}error(O,...j){this.f(R.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...j):console.error(O,...j))}dispose(){}flush(){}}e.ConsoleLogger=I;class t extends h{constructor(O,j=e.DEFAULT_LOG_LEVEL){super(),this.g=O,this.setLevel(j)}trace(O,...j){this.f(R.Trace)&&this.g.log(R.Trace,[this.h(O),...j])}debug(O,...j){this.f(R.Debug)&&this.g.log(R.Debug,[this.h(O),...j])}info(O,...j){this.f(R.Info)&&this.g.log(R.Info,[this.h(O),...j])}warn(O,...j){this.f(R.Warning)&&this.g.log(R.Warning,[this.h(O),...j])}error(O,...j){this.f(R.Error)&&this.g.log(R.Error,[this.h(O),...j])}h(O){return typeof O=="string"?O:(0,T.toErrorMessage)(O,this.f(R.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends h{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const j of this.g)j.setLevel(O);super.setLevel(O)}trace(O,...j){for(const Y of this.g)Y.trace(O,...j)}debug(O,...j){for(const Y of this.g)Y.debug(O,...j)}info(O,...j){for(const Y of this.g)Y.info(O,...j)}warn(O,...j){for(const Y of this.g)Y.warn(O,...j)}error(O,...j){for(const Y of this.g)Y.error(O,...j)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose()}}e.MultiplexLogger=a;class n extends C.Disposable{constructor(O,j,Y){if(super(),this.h=O,this.j=j,this.b=new L.ResourceMap,this.c=this.B(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeVisibility=this.g.event,Y)for(const J of Y)this.b.set(J.resource,{logger:void 0,info:J})}k(O){return(0,c.isString)(O)?[...this.b.values()].find(j=>j.info.id===O):this.b.get(O)}getLogger(O){return this.k(O)?.logger}createLogger(O,j){const Y=this.l(O),J=(0,c.isString)(O)?O:j?.id??(0,D.hash)(Y.toString()).toString(16);let ee=this.b.get(Y)?.logger;const le=j?.logLevel==="always"?R.Trace:j?.logLevel;ee||(ee=this.m(Y,le??this.getLogLevel(Y)??this.h,{...j,id:J}));const re={logger:ee,info:{resource:Y,id:J,logLevel:le,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(Y,re),ee}l(O){return(0,c.isString)(O)?(0,f.joinPath)(this.j,`${O}.log`):O}setLogLevel(O,j){if(P.URI.isUri(O)){const Y=O,J=j,ee=this.b.get(Y);ee&&J!==ee.info.logLevel&&(ee.info.logLevel=J===this.h?void 0:J,ee.logger?.setLevel(J),this.b.set(ee.info.resource,ee),this.f.fire([Y,J]))}else{this.h=O;for(const[Y,J]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,j){const Y=this.k(O);Y&&j!==!Y.info.hidden&&(Y.info.hidden=!j,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,j]))}getLogLevel(O){let j;return O&&(j=this.b.get(O)?.info.logLevel),j??this.h}registerLogger(O){const j=this.b.get(O.resource);j?j.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const j=this.b.get(O);j&&(j.logger&&j.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(O){}getLevel(){return R.Info}trace(O,...j){}debug(O,...j){}info(O,...j){}warn(O,...j){}error(O,...j){}critical(O,...j){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(w){if(w.verbose)return R.Trace;if(typeof w.logLevel=="string"){const O=d(w.logLevel.toLowerCase());if(O!==void 0)return O}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(w){switch(w){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=l;function d(w){switch(w){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=d,e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",l(R.Info))}),define(ie[119],ne([0,1,19,8,9,5,2,15,62,6]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends L.Disposable{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.l(m,v):this.u(m,v)}l(m,v){const N={path:this.C(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},R=(0,T.insert)(this.j,N);return this.m(),(0,L.toDisposable)(()=>{R(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(v=>this.c.fire((0,f.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,f.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,f.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,v){const N={path:this.C(m),excludes:v.excludes,includes:v.includes,recursive:!1},R=(0,T.insert)(this.s,N);return this.v(),(0,L.toDisposable)(()=>{R(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,f.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ie[120],ne([0,1,19,8,14,23,5,45,65,2,55,16,121,17,44,97,13,61,6,9]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new L.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new L.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),n.add(a.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(a))))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(n){a.push(n)}}),!this.h.has(t)&&await A.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,v.isAbsolutePath)(t))throw new u.FileOperationError((0,R.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const n=new y.ErrorNoTelemetry;throw n.message=(0,R.localize)(1,null,t.toString()),n}return a}async k(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a)||(0,u.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,R.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,a){const n=await this.j(t),i=this.O(n),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,d=await n.stat(t);let w;return this.p(n,t,d,void 0,!!l,(O,j)=>(w||(w=P.TernarySearchTree.forUris(()=>!i),w.set(t,!0),r&&w.fill(!0,r)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&o?j===1:!1))}async p(t,a,n,i,r,o){const{providerExtUri:l}=this.N(t),d={resource:a,name:l.basename(a),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(d.isDirectory&&o(d,i)){try{const w=await t.readdir(a),O=await A.Promises.settled(w.map(async([j,Y])=>{try{const J=l.joinPath(a,j),ee=r?await t.stat(J):{type:Y};return await this.p(t,J,ee,w.length,r,o)}catch(J){return this.b.trace(J),null}}));d.children=(0,T.coalesce)(O)}catch(w){this.b.trace(w),d.children=[]}return d}return d}async resolveAll(t){return A.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),n=await a.stat(t);return this.p(a,t,n,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(n){return n}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,R.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=D.VSBuffer.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,a);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,a,n){const i=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(i);try{await this.s(i,t,n)||await this.P(i,r.dirname(t));let l;if((0,u.hasReadWriteCapability)(i)&&!(a instanceof D.VSBuffer))if((0,N.isReadableStream)(a)){const d=await(0,N.peekStream)(a,3);d.ended?l=D.VSBuffer.concat(d.buffer):l=d}else l=(0,N.peekReadable)(a,d=>D.VSBuffer.concat(d),3);else l=a;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&l instanceof D.VSBuffer?await this.cb(i,t,n,l):await this.Y(i,t,n,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l),this.m.fire(new u.FileOperationEvent(t,4))}catch(o){throw new u.FileOperationError((0,R.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,R.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,R.localize)(6,null,this.nb(a)),0,n);if(this.mb(a,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:r.size}))throw new u.FileOperationError((0,R.localize)(7,null),3,n);return r}async readFile(t,a,n){const i=await this.k(t);return a?.atomic?this.t(i,t,a,n):this.u(i,t,a,n)}async t(t,a,n,i){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.u(t,a,n,i);r(l)}catch(l){o(l)}})})}async u(t,a,n,i){const r=await this.v(t,a,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(t,a,n){const i=await this.k(t);return this.v(i,t,a,n)}async v(t,a,n,i){const r=new C.CancellationTokenSource(i),o=this.F(a,n).then(d=>d,d=>{throw r.cancel(),d});let l;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await o,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?l=this.D(t,a,n):(0,u.hasFileReadStreamCapability)(t)?l=this.z(t,a,r.token,n):l=this.C(t,a,r.token,n),{...await o,value:l}}catch(d){throw l&&await(0,N.consumeStream)(l),this.w(d,a,n)}}w(t,a,n){const i=(0,R.localize)(8,null,this.nb(a),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}z(t,a,n,i=Object.create(null)){const r=t.readFileStream(a,i,n);return(0,N.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>this.w(o,a,i)},o=>D.VSBuffer.concat(o))}C(t,a,n,i=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,a,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,a,i)},n),r}D(t,a,n){const i=(0,N.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(a,r.byteLength,n),i.end(D.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async F(t,a){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,R.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==u.ETAG_DISABLED&&a.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,R.localize)(10,null),n,a);return this.G(t,n.size,a),n}G(t,a,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&a>n.limits.size&&(i=7),typeof i=="number")throw new u.TooLargeFileOperationError((0,R.localize)(11,null,this.nb(t)),i,a,n)}}async canMove(t,a,n){return this.H(t,a,"move",n)}async canCopy(t,a,n){return this.H(t,a,"copy",n)}async H(t,a,n,i){if(t.toString()!==a.toString())try{const r=n==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,n,i)}catch(r){return r}return!0}async move(t,a,n){const i=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"move",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="move"?2:3,l)),l}async copy(t,a,n){const i=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"copy",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="copy"?3:2,l)),l}async I(t,a,n,i,r,o){if(a.toString()===i.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.M(t,a,n,i,r,o);if(l&&!d&&o&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(a,i,{overwrite:o});else{const w=await this.resolve(a);w.isDirectory?await this.L(t,w,n,i):await this.J(t,a,n,i)}return r}else return t===n?(await t.rename(a,i,{overwrite:o}),r):(await this.I(t,a,n,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.eb(t,a,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.kb(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.ib(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.gb(t,a,n,i)}async L(t,a,n,i){await n.mkdir(i),Array.isArray(a.children)&&await A.Promises.settled(a.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),n,o):this.J(t,r.resource,n,o)}))}async M(t,a,n,i,r,o){let l=!1;if(t===n){const{providerExtUri:w,isPathCaseSensitive:O}=this.N(t);if(O||(l=w.isEqual(a,i)),l&&r==="copy")throw new Error((0,R.localize)(12,null,this.nb(a),this.nb(i)));if(!l&&w.isEqualOrParent(i,a))throw new Error((0,R.localize)(13,null,this.nb(a),this.nb(i)))}const d=await this.exists(i);if(d&&!l){if(!o)throw new u.FileOperationError((0,R.localize)(14,null,this.nb(a),this.nb(i)),4);if(t===n){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(a,i))throw new Error((0,R.localize)(15,null,this.nb(a),this.nb(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,a){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(a,i.dirname(a));)try{if(((await t.stat(a)).type&u.FileType.Directory)===0)throw new Error((0,R.localize)(16,null,this.nb(a)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(a)),a=i.dirname(a)}for(let r=n.length-1;r>=0;r--){a=i.joinPath(a,n[r]);try{await t.mkdir(a)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(n){return n}return!0}async Q(t,a){const n=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,R.localize)(17,null,this.nb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,R.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,R.localize)(19,null,this.nb(t)))}return n}async del(t,a){const n=await this.Q(t,a),i=!!a?.useTrash,r=!!a?.recursive;await n.delete(t,{recursive:r,useTrash:i}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,a){const n=await this.j(t),i=this.lb(await this.l(a),a);if(n===i&&this.N(n).providerExtUri.isEqual(t,a))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,a);await this.P(i,this.N(i).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(n,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);i?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(t,a){const n=await this.j(t),i=(0,b.hash)([this.N(n).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(i);return r||(r={count:0,disposable:n.watch(t,a)},this.U.set(i,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,N.isReadableStream)(i)||(0,N.isReadableBufferedStream)(i)?await this.Z(t,r,i):await this.ab(t,r,i)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,n){let i=0,r;if((0,N.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=D.VSBuffer.concat(n.buffer);await this.bb(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,l)=>{(0,N.listenStream)(r,{onData:async d=>{r.pause();try{await this.bb(t,a,d,d.byteLength,i,0)}catch(w){return l(w)}i+=d.byteLength,setTimeout(()=>r.resume())},onError:d=>l(d),onEnd:()=>o()})})}async ab(t,a,n){let i=0,r;for(;(r=n.read())!==null;)await this.bb(t,a,r,r.byteLength,i,0),i+=r.byteLength}async bb(t,a,n,i,r,o){let l=0;for(;l<i;)l+=await t.write(a,r+l,n.buffer,o+l,i-l)}async cb(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,n,i))}async db(t,a,n,i){let r;i instanceof D.VSBuffer?r=i:(0,N.isReadableStream)(i)?r=await(0,D.streamToBuffer)(i):(0,N.isReadableBufferedStream)(i)?r=await(0,D.bufferedStreamToBuffer)(i):r=(0,D.readableToBuffer)(i),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,a,n,i))}async fb(t,a,n,i){let r,o;try{r=await t.open(a,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.a);let d=0,w=0,O=0;do O=await t.read(r,d,l.buffer,w,l.byteLength-w),await this.bb(n,o,l,O,d,w),d+=O,w+=O,w===l.byteLength&&(w=0);while(O>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await A.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async gb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,a,n,i))}async hb(t,a,n,i){return n.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,a,n,i))}async jb(t,a,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(n,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async kb(t,a,n,i){const r=await(0,D.streamToBuffer)(this.C(t,a,C.CancellationToken.None));await this.cb(n,i,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new u.FileOperationError((0,R.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,R.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};p=ve([te(0,h.ILogService)],p),e.FileService=p}),define(ie[122],ne([0,1,123,165,8,35,14,5,166,2,15,12,17,44,22,99,13,61,119,33,117,116]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(T)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=b.Event.None,this.H=new C.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:r}=await N.SymlinkSupport.stat(this.C(n));return{type:this.G(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(n){try{const i=await N.Promises.readdir(this.C(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,m.joinPath)(n,o.name))).type:l=this.G(o),r.push([o.name,l])}catch(l){this.a.trace(l)}})),r}catch(i){throw this.Y(i)}}G(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async I(n){const i=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new D.Barrier;return this.H.set(n,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(n)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),r=await this.I(n));const o=this.C(n);return await N.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(n){t.D&&this.a.trace(n)}readFileStream(n,i,r){const o=(0,v.newWriteableStream)(l=>L.VSBuffer.concat(l.map(d=>L.VSBuffer.wrap(d))).buffer);return(0,g.readFileIntoStream)(this,n,o,l=>l.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(n,i,r){let o;try{const l=this.C(n);if(!r.create||!r.overwrite){if(await N.Promises.exists(l)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,R.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,R.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.Z(n,l)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(n){t.O=n}async open(n,i){const r=this.C(n);let o;(0,u.isFileOpenForWriteOptions)(i)&&(o=await this.I(n));let l;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:w}=await N.SymlinkSupport.stat(r);w.mode&128||await N.Promises.chmod(r,w.mode|128)}catch(w){this.a.trace(w)}let d;if((0,u.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await N.Promises.truncate(r,0),d="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}d||(d="w")}else d="r";l=await N.Promises.open(r,d)}catch(d){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.Z(n,d):this.Y(d)}if(this.L.set(l,0),(0,u.isFileOpenForWriteOptions)(i)&&this.N.set(l,n),o){const d=this.M.get(l);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.M.set(l,o),d&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),d.dispose())}return l}async close(n){const i=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&t.O)try{await N.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await N.Promises.close(n)}catch(r){throw this.Y(r)}finally{i&&(this.M.get(n)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,o,l){const d=this.P(n,i);let w=null;try{w=(await N.Promises.read(n,r,o,l,d)).bytesRead}catch(O){throw this.Y(O)}finally{this.Q(n,d,w)}return w}P(n,i){return i===this.L.get(n)?null:i}Q(n,i,r){const o=this.L.get(n);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.L.set(n,o+r):this.L.delete(n)))}async write(n,i,r,o,l){return(0,D.retry)(()=>this.R(n,i,r,o,l),100,3)}async R(n,i,r,o,l){const d=this.P(n,i);let w=null;try{w=(await N.Promises.write(n,r,o,l,d)).bytesWritten}catch(O){throw await this.Z(this.N.get(n),O)}finally{this.Q(n,d,w)}return w}async mkdir(n){try{await N.Promises.mkdir(this.C(n))}catch(i){throw this.Y(i)}}async delete(n,i){try{const r=this.C(n);i.recursive?await N.Promises.rm(r,N.RimRafMode.MOVE):await N.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(n,i,r){const o=this.C(n),l=this.C(i);if(o!==l)try{await this.S(n,i,"move",r.overwrite),await N.Promises.move(o,l)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,R.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),d.toString()))),this.Y(d)}}async copy(n,i,r){const o=this.C(n),l=this.C(i);if(o!==l)try{await this.S(n,i,"copy",r.overwrite),await N.Promises.copy(o,l,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,R.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),d.toString()))),this.Y(d)}}async S(n,i,r,o){const l=this.C(n),d=this.C(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,f.isEqual)(l,d,!0)),w&&r==="copy")throw(0,u.createFileSystemProviderError)((0,R.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!w&&await N.Promises.exists(d)){if(!o)throw(0,u.createFileSystemProviderError)((0,R.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.U(n,i,!1)}async U(n,i,r){const o=this.C(n),l=this.C(i),d=!!(this.capabilities&1024);if((0,f.isEqual)(o,l,!d))return;const w=new c.DisposableStore;try{const[O,j]=await Promise.all([this.I(n),this.I(i)]);w.add(O),w.add(j),r&&await N.Promises.mkdir((0,P.dirname)(l),{recursive:!0}),await N.Promises.copyFile(o,l)}catch(O){if(O.code==="ENOENT"&&!r)return this.U(n,i,!0);throw this.Y(O)}finally{w.dispose()}}p(n,i,r){return new p.UniversalWatcherClient(o=>n(o),o=>i(o),r)}y(n,i,r){return new I.NodeJSWatcherClient(o=>n(o),o=>i(o),r)}Y(n){if(n instanceof u.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,i)}async Z(n,i){let r=this.Y(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await N.SymlinkSupport.stat(this.C(n));o.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ie[124],ne([0,1,2,6]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends T.Disposable{constructor(L,b=[]){super(),this.a=new A.MultiplexLogger([L,...b]),this.B(L.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.LogService=D}),define(ie[125],ne([0,1,13,6]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function C(c,P,E,m,v){try{const N=await new Promise((u,g)=>{G(["spdlog"],u,g)});N.setFlushOn(D.Trace);const R=await N.createAsyncRotatingLogger(c,P,E,m);return v?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(N){console.error(N)}return null}function L(c,P,E){switch(P){case A.LogLevel.Trace:c.trace(E);break;case A.LogLevel.Debug:c.debug(E);break;case A.LogLevel.Info:c.info(E);break;case A.LogLevel.Warning:c.warn(E);break;case A.LogLevel.Error:c.error(E);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function b(c,P){switch(P){case A.LogLevel.Trace:c.setLevel(D.Trace);break;case A.LogLevel.Debug:c.setLevel(D.Debug);break;case A.LogLevel.Info:c.setLevel(D.Info);break;case A.LogLevel.Warning:c.setLevel(D.Warning);break;case A.LogLevel.Error:c.setLevel(D.Error);break;case A.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class f extends A.AbstractMessageLogger{constructor(P,E,m,v,N){super(),this.k=[],this.setLevel(N),this.l=this.n(P,E,m,v),this.B(this.onDidChangeLogLevel(R=>{this.m&&b(this.m,R)}))}async n(P,E,m,v){const N=m?6:1,R=30/N*T.ByteSize.MB,u=await C(P,E,R,N,v);if(u){this.m=u,b(this.m,this.getLevel());for(const{level:g,message:h}of this.k)L(this.m,g,h);this.k=[]}}g(P,E){this.m?L(this.m,P,E):this.getLevel()<=P&&this.k.push({level:P,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ie[126],ne([0,1,28,6,125]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends A.AbstractLoggerService{m(b,f,c){return new D.SpdLogLogger((0,T.generateUuid)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,f)}}e.LoggerService=C}),define(ie[38],ne([0,1,5,65,2,10]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class L extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.i(c),A.Iterable.reduce(this.g.entries(),(E,[m,v])=>({...E,[m]:v}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[P,E])=>({...c,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=L;class b{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ie[127],ne([0,1,8,5,65,3,13,6,38]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(E,m){const v=[];for(const N of new Set(D.Iterable.concat(E.keys(),m.keys())))E.get(N)!==m.get(N)&&v.push(N);return v}let P=class extends f.AbstractPolicyService{constructor(m,v,N){super(),this.j=m,this.k=v,this.l=N,this.c=this.B(new T.ThrottledDelayer(500));const R=A.Event.filter(v.onDidFilesChange,u=>u.affects(m));this.B(v.watch(m)),this.B(R(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const v=await this.k.readFile(this.j),N=JSON.parse(v.value.toString());if(!(0,C.isObject)(N))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(N))this.f[R]&&m.set(R,N[R])}catch(v){v.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",v)}return m}async p(){const m=await this.n(),v=c(this.g,m);this.g=m,v.length>0&&this.h.fire(v)}};P=ve([te(1,L.IFileService),te(2,b.ILogService)],P),e.FilePolicyService=P}),define(ie[128],ne([0,1,38,8,167,2,6]),function(G,e,T,A,D,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let b=class extends T.AbstractPolicyService{constructor(c,P){super(),this.j=c,this.k=P,this.a=new A.Throttler,this.b=this.B(new C.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((P,E)=>{try{this.b.value=(0,D.createWatcher)(this.k,c,m=>{this.m(m),P()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),E(m)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const P in c){const E=c[P];E===void 0?this.g.delete(P):this.g.set(P,E)}this.h.fire(Object.keys(c))}};b=ve([te(0,L.ILogService)],b),e.NativePolicyService=b}),define(ie[31],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,70,3]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(L,b){T.ok(A.isString(L)),T.ok(A.isObject(b)),T.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new D}),define(ie[129],ne([0,1,5,36]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class C{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,c){this.a[D(f)]=c,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const L=new C;A.Registry.add(e.Extensions.JSONContribution,L)}),define(ie[42],ne([0,1,19,5,3,86,24,129,36]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=f.Registry.as(b.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const n=new Set;this.n(t,a,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const a=new Set;this.o(t,a),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const n=new Set;this.o(a,n),this.n(t,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const n=[];for(const{overrides:i,source:r}of t)for(const o in i)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.a.get(o),d=l?.valuesSources??new Map;if(r)for(const Y of Object.keys(i[o]))d.set(Y,r);const w={...l?.value||{},...i[o]};this.a.set(o,{source:r,value:w,valuesSources:d});const O=(0,L.getLanguageTagSettingPlainKey)(o),j={type:"object",default:w,description:C.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:D.isString(r)?void 0:r,defaultValueSource:r};n.push(...R(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:i[o],source:r});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(n)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:n,source:i}of t)for(const r in n){const o=this.a.get(r),l=D.isString(i)?i:i?.id,d=D.isString(o?.source)?o?.source:o?.source?.id;if(l===d)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const w=this.d[r];w&&(this.w(r,w),this.r(r,w))}}this.u()}deltaConfiguration(t){let a=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,n){t.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,a){const n=i=>{if(i.properties)for(const r in i.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.c.indexOf(i);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,n,i,r=3,o){r=D.isUndefinedOrNull(t.scope)?r:t.scope;const l=t.properties;if(l)for(const w in l){const O=l[w];if(a&&y(w,O)){delete l[w];continue}if(O.source=n,O.defaultDefaultValue=l[w].default,this.w(w,O),e.OVERRIDE_PROPERTY_REGEX.test(w)?O.scope=void 0:(O.scope=D.isUndefinedOrNull(O.scope)?r:O.scope,O.restricted=D.isUndefinedOrNull(O.restricted)?!!i?.includes(w):O.restricted),l[w].hasOwnProperty("included")&&!l[w].included){this.f[w]=l[w],delete l[w];continue}else this.d[w]=l[w],l[w].policy?.name&&this.e.set(l[w].policy.name,w);!l[w].deprecationMessage&&l[w].markdownDeprecationMessage&&(l[w].deprecationMessage=l[w].markdownDeprecationMessage),o.add(w)}const d=t.allOf;if(d)for(const w of d)this.p(w,a,n,i,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=n=>{const i=n.properties;if(i)for(const o in i)this.r(o,i[o]);n.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const n=this.a.get(t);let i=n?.value,r=n?.source;D.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),D.isUndefined(i)&&(i=g(a.type)),a.default=i,a.defaultValueSource=r}}const v="\\[([^\\]]+)\\]",N=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function R(I){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let a=N.exec(I);for(;a?.length;){const n=a[1].trim();n&&t.push(n),a=N.exec(I)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=R;function u(I){return I.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=u;function g(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const h=new m;f.Registry.add(e.Extensions.Configuration,h);function y(I,t){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?C.localize(7,null,I):h.getConfigurationProperties()[I]!==void 0?C.localize(8,null,I):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,I,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=y;function p(){const I=[],t=h.getConfigurationProperties();for(const a of Object.keys(t))I.push([a,t[a].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=p}),define(ie[66],ne([0,1,19,5,51,2,35,30,3,11,24,42,36]),function(G,e,T,A,D,C,L,b,f,c,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(a){return Object.isFrozen(a)?a:b.deepFreeze(a)}class N{constructor(n={},i=[],r=[],o){this.b=n,this.c=i,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof N)return i;const r=new R("");return r.parseRaw(i),r.configurationModel});this.f=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:l}}getOverrideValue(n,i){const r=this.i(i);return r?n?(0,P.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=b.deepClone(this.contents),r=b.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const d of n)if(l.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(i,d.contents);for(const w of d.overrides){const[O]=r.filter(j=>T.equals(j.identifiers,w.identifiers));O?(this.h(O.contents,w.contents),O.keys.push(...w.keys),O.keys=T.distinct(O.keys)):r.push(b.deepClone(w))}for(const w of d.keys)o.indexOf(w)===-1&&o.push(w)}return new N(i,o,r,l.every(d=>d instanceof N)?void 0:l)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const d=i[o];d&&(typeof l=="object"&&typeof d=="object"?(l=b.deepClone(l),this.h(l,d)):l=d),r[o]=l}return new N(r,this.keys,this.overrides)}h(n,i){for(const r of Object.keys(i)){if(r in n&&f.isObject(n[r])&&f.isObject(i[r])){this.h(n[r],i[r]);continue}n[r]=b.deepClone(i[r])}}i(n){let i=null,r=null;const o=l=>{l&&(r?this.h(r,l):r=b.deepClone(l))};for(const l of this.overrides)T.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&o(l.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}j(n,i,r){(0,P.addToValueTree)(this.contents,n,i,o=>console.error(o)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],o=>console.error(o))})}}e.ConfigurationModel=N;class R{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new N}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!f.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:l,restricted:d,hasExcludedProperties:w}=this.h(n,i);this.b=new N(r,o,l,w?[n]:void 0),this.c=d||[]}g(n){let i={},r=null,o=[];const l=[],d=[];function w(j){Array.isArray(o)?o.push(j):r!==null&&(o[r]=j)}const O={onObjectBegin:()=>{const j={};w(j),l.push(o),o=j,r=null},onObjectProperty:j=>{r=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];w(j),l.push(o),o=j,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:w,onError:(j,Y,J)=>{d.push({error:j,offset:Y,length:J})}};if(n)try{D.visit(n,O),i=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}h(n,i){const r=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.i(n,r,!0,i);n=o.raw;const l=(0,P.toValuesTree)(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`)),d=Object.keys(n),w=this.j(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:l,keys:d,overrides:w,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(n,i,r,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const d={},w=[];for(const O in n)if(E.OVERRIDE_PROPERTY_REGEX.test(O)&&r){const j=this.i(n[O],i,!1,o);d[O]=j.raw,l=l||j.hasExcludedProperties,w.push(...j.restricted)}else{const j=i[O],Y=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&w.push(O),(Y===void 0||o.scopes===void 0||o.scopes.includes(Y))&&!(o.skipRestricted&&j?.restricted)?d[O]=n[O]:l=!0}return{raw:d,restricted:w,hasExcludedProperties:l}}j(n,i){const r=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const d in n[o])l[d]=n[o][d];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=R;class u extends C.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new R(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new N}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class g{constructor(n,i,r,o,l,d,w,O,j,Y,J,ee,le){this.a=n,this.b=i,this.c=r,this.overrideIdentifiers=o,this.d=l,this.f=d,this.g=w,this.h=O,this.i=j,this.j=Y,this.k=J,this.l=ee,this.m=le}get value(){return v(this.c)}n(n,i,r){const o=n.inspect(i,r);return{get value(){return v(o.value)},get override(){return v(o.override)},get merged(){return v(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(n,i,r,o,l=new N,d=new N,w=new L.ResourceMap,O=new N,j=new L.ResourceMap){this.c=n,this.d=i,this.f=r,this.g=o,this.h=l,this.i=d,this.j=w,this.l=O,this.m=j,this.a=null,this.b=new L.ResourceMap,this.n=null}getValue(n,i,r){return this.q(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new N,this.m.set(r.resource,o))):o=this.l,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.q(n,i,r),l=this.u(i.resource,r),d=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const O of o.overrides)for(const j of O.identifiers)o.getOverrideValue(n,j)!==void 0&&w.add(j);return new g(n,i,o.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,l||void 0,d)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:l,removed:d}=I(this.c,n);i=[...o,...l,...d]}for(const o of i)for(const l of(0,E.overrideIdentifiersFromKey)(o)){const d=this.c.getKeysForOverrideIdentifier(l),w=n.getKeysForOverrideIdentifier(l),O=[...w.filter(j=>d.indexOf(j)===-1),...d.filter(j=>w.indexOf(j)===-1),...d.filter(j=>!b.equals(this.c.override(l).getValue(j),n.override(l).getValue(j)))];r.push([l,O])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=I(this.d,n),l=[...i,...r,...o];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=I(this.applicationConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=I(this.localUserConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=I(this.remoteUserConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=I(this.workspaceConfiguration,n),d=[...i,...r,...o];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const r=this.p.get(n),{added:o,updated:l,removed:d,overrides:w}=I(r,i),O=[...o,...l,...d];return(O.length||!r)&&this.updateFolderConfiguration(n,i),{keys:O,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:l,overrides:d}=I(i,void 0);return{keys:[...r,...o,...l],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,r){let o=this.r(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}r({resource:n},i){let r=this.s();if(i&&n){const o=i.getFolder(n);o&&(r=this.t(o.uri)||r);const l=this.m.get(n);l&&(r=r.merge(l))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const r=this.s(),o=this.j.get(n);o?(i=r.merge(o),this.b.set(n,i)):i=r}return i}u(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:l}=this.j.get(i);return n.push([i,{contents:r,overrides:o,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.i.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.x(n.defaults),r=this.x(n.policy),o=this.x(n.application),l=this.x(n.user),d=this.x(n.workspace),w=n.folders.reduce((O,j)=>(O.set(c.URI.revive(j[0]),this.x(j[1])),O),new L.ResourceMap);return new h(i,r,o,l,new N,d,w,new N,new L.ResourceMap)}static x(n){return new N(n.contents,n.keys,n.overrides)}}e.Configuration=h;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const o of a)o.keys.forEach(l=>n.add(l)),o.overrides.forEach(([l,d])=>{const w=(0,L.getOrSet)(i,l,new Set);d.forEach(O=>w.add(O))});const r=[];return i.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=y;class p{constructor(n,i,r,o){this.change=n,this.f=i,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const d of l)this.affectedKeys.add(d);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(n,i){const r=this.a+n,o=this.d.indexOf(r);if(o<0)return!1;const l=o+r.length;if(l>=this.d.length)return!1;const d=this.d.charCodeAt(l);if(d!==this.b&&d!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,O=this.g.getValue(n,i,this.h);return!b.equals(w,O)}return!0}}e.ConfigurationChangeEvent=p;function I(a,n){const{added:i,removed:r,updated:o}=t(n?.rawConfiguration,a?.rawConfiguration),l=[],d=a?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const O=w.filter(j=>!d.includes(j));for(const j of O)l.push([j,n.getKeysForOverrideIdentifier(j)])}if(a){const O=d.filter(j=>!w.includes(j));for(const j of O)l.push([j,a.getKeysForOverrideIdentifier(j)])}if(n&&a){for(const O of d)if(w.includes(O)){const j=t({contents:a.getOverrideValue(void 0,O)||{},keys:a.getKeysForOverrideIdentifier(O)},{contents:n.getOverrideValue(void 0,O)||{},keys:n.getKeysForOverrideIdentifier(O)});l.push([O,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:r,updated:o,overrides:l}}function t(a,n){const i=a?n?a.keys.filter(l=>n.keys.indexOf(l)===-1):[...a.keys]:[],r=n?a?n.keys.filter(l=>a.keys.indexOf(l)===-1):[...n.keys]:[],o=[];if(a&&n){for(const l of n.keys)if(a.keys.indexOf(l)!==-1){const d=(0,P.getConfigurationValue)(n.contents,l),w=(0,P.getConfigurationValue)(a.contents,l);b.equals(d,w)||o.push(l)}}return{added:i,removed:r,updated:o}}}),define(ie[130],ne([0,1,19,5,2,30,3,66,42,6,38,36]),function(G,e,T,A,D,C,L,b,f,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new b.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.c(Array.from(u),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,g){this.h(u,E.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new b.ConfigurationModel;const u=E.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,g){const h=this.f();for(const y of u){const p=h[y],I=g[y];p!==void 0?this.b.addValue(y,p):I?this.b.addValue(y,I.default):this.b.removeValue(y)}}}e.DefaultConfiguration=m;class v{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let N=class extends D.Disposable{get configurationModel(){return this.b}constructor(u,g,h){super(),this.c=u,this.f=g,this.g=h,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new b.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const g={},h=[],y=E.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const p of u){const I=y[p];if(!I){h.push(p);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}h.push(p),g[I.policy.name]={type:I.type}}}return(0,L.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),h}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const g=E.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),h=(0,T.coalesce)(u.map(y=>g.get(y)));this.j(h,!0)}j(u,g){this.g.trace("PolicyConfiguration#update",u);const h=E.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),y=[],p=this.b.isEmpty();for(const I of u){const t=h[I]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,C.equals)(this.b.getValue(I),a))&&y.push([I,a])}else this.b.getValue(I)!==void 0&&y.push([I,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const I=this.b;this.b=new b.ConfigurationModel;for(const t of I.keys)this.b.setValue(t,I.getValue(t));for(const[t,a]of y)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);g&&this.a.fire(this.b)}}};N=ve([te(1,P.IPolicyService),te(2,c.ILogService)],N),e.PolicyConfiguration=N}),define(ie[131],ne([0,1,8,5,2,17,24,66,130,38]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends D.Disposable{constructor(m,v,N,R){super(),this.i=m,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=N instanceof c.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,N,R)),this.f=this.B(new b.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,v)),this.a=new b.Configuration(this.b.configurationModel,this.c.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:g})=>this.k(u,g))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,v,N]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.Configuration(m,v,new b.ConfigurationModel,N)}getConfigurationData(){return this.a.toData()}getValue(m,v){const N=typeof m=="string"?m:void 0,R=(0,L.isConfigurationOverrides)(m)?m:(0,L.isConfigurationOverrides)(v)?v:{};return this.a.getValue(N,R,void 0)}updateValue(m,v,N,R){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const v=this.a.toData(),N=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(N,v,2)}k(m,v){const N=this.a.toData(),R=this.a.compareAndUpdateDefaultConfiguration(m,v);this.m(R,N,7)}l(m){const v=this.a.toData(),N=this.a.compareAndUpdatePolicyConfiguration(m);this.m(N,v,7)}m(m,v,N){const R=new b.ConfigurationChangeEvent(m,{data:v},this.a);R.source=N,R.sourceConfig=this.n(N),this.h.fire(R)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ie[67],ne([0,1,16]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(c){return c.scheme===T.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=A;function D(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.getRemoteName=D;function C(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=C;function L(c){const{host:P,port:E}=f(c);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.parseAuthorityWithPort=L;function b(c,P){let{host:E,port:m}=f(c);return typeof m>"u"&&(m=P),{host:E,port:m}}e.parseAuthorityWithOptionalPort=b;function f(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=c.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ie[37],ne([0,1,29,10,67]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.getWorkspaceSupportTypeMessage=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));var b;(function(R){R.WIN32_X64="win32-x64",R.WIN32_IA32="win32-ia32",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(u){this.value=u,this.c=u.toLowerCase()}static equals(u,g){if(typeof u>"u"||u===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof u=="string"||typeof g=="string"){const h=typeof u=="string"?u:u.value,y=typeof g=="string"?g:g.value;return T.equalsIgnoreCase(h,y)}return u.c===g.c}static toKey(u){return typeof u=="string"?u.toLowerCase():u.c}}e.ExtensionIdentifier=f;class c{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const g of u)this.add(g)}add(u){this.c.add(f.toKey(u))}delete(u){return this.c.delete(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}}e.ExtensionIdentifierSet=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(f.toKey(u))}get(u){return this.c.get(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}set(u,g){this.c.set(f.toKey(u),g)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function E(R){return m(R)}e.isApplicationScopedExtension=E;function m(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function v(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function N(R,u){if(u){const g=`onResolveRemoteAuthority:${(0,D.getRemoteName)(u)}`;return!!R.activationEvents?.includes(g)}return!1}e.isResolverExtension=N,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[132],ne([0,1,2,37,13]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends T.Disposable{constructor(b,f,c,P,E){super(),this.a=b,this.b=f,this.c=c,this.f=E,this.B(P.onDidInstallExtensions(m=>this.g(m))),this.B(P.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const f of b)f.local&&this.invalidate(f.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const f of this.a.profiles)this.c.extUri.isEqual(f.extensionsResource,b)&&await this.i(f);else await this.i(this.a.defaultProfile)}async i(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,A.USER_MANIFEST_CACHE_FILE))}catch(f){(0,D.toFileOperationResult)(f)!==1&&this.f.error(f)}}}e.ExtensionsManifestCache=C}),define(ie[43],ne([0,1,14,9,2,101,42,10,6,36]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,b.createDecorator)("requestService");class P{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?I[t]="*****":I[t]=this.b[t];this.a=I}return this.a}}class E extends D.Disposable{constructor(I,t){super(),this.b=0,this.a=t.createLogger(I?"remotenetwork":"network",{name:I?(0,C.localize)(0,null):(0,C.localize)(1,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async c(I,t,a){const n=`${I} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new P(t.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,A.getErrorMessage)(i)),i}}}e.AbstractRequestService=E;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=m;function v(p){return p.res.statusCode===204}async function N(p){return v(p)?null:(await(0,T.streamToBuffer)(p.stream)).toString()}e.asText=N;async function R(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return N(p)}e.asTextOrError=R;async function u(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(v(p))return null;const t=(await(0,T.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=u;function g(p){y(p)}e.updateProxyConfigurationsScope=g;let h;function y(p){const I=c.Registry.as(L.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,C.localize)(2,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(6,null),(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null)],default:"override",description:(0,C.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(11,null),restricted:!0}}},I.updateConfigurations({add:[h],remove:t?[t]:[]})}y(1)}),define(ie[133],ne([0,1,23,16,13,43]),function(G,e,T,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(f,c){this.a=f,this.b=c}async download(f,c,P=T.CancellationToken.None){if(f.scheme===A.Schemas.file||f.scheme===A.Schemas.vscodeRemote){await this.b.copy(f,c);return}const E={type:"GET",url:f.toString(!0)},m=await this.a.request(E,P);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const v=await(0,C.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};L=ve([te(0,C.IRequestService),te(1,D.IFileService)],L),e.DownloadService=L}),define(ie[134],ne([0,1,135,3]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(L,b){return L.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:L.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function C(L,b,f={}){const c=(0,T.parse)(L),P=f.proxyUrl||D(c,b);if(!P)return null;const E=(0,T.parse)(P);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,A.isBoolean)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((v,N)=>{G(["http-proxy-agent"],v,N)}))(m):new(await new Promise((v,N)=>{G(["https-proxy-agent"],v,N)}))(m)}e.getProxyAgent=C}),define(ie[136],ne([0,1,58,15,102,23,33,9,12,28,82,168,8,71]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let N;async function R(g,h,y,p){return y["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(p)&&!y["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(p)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),N||(N=m.Promises.withAsyncBody(async(I,t)=>{const a=new C.CancellationTokenSource;let n=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,v.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,D.localize)(0,null)))},n);try{I(await u(h,a.token))}catch(o){!(0,b.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,D.localize)(1,null,(0,L.toErrorMessage)(o)))):I({})}finally{clearTimeout(r),a.dispose()}})),N)}e.getResolvedShellEnv=R;async function u(g,h){const y=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",p);const I=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(I+"({.*})"+I),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",a);const n=await(0,P.getSystemShell)(f.OS,a);return g.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(h.isCancellationRequested)return r(new b.CancellationError);const o=(0,A.basename)(n);let l,d;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${w} -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' ${w} -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,o==="tcsh"||o==="csh"?d=["-ic"]:d=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const O=(0,T.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});h.onCancellationRequested(()=>(O.kill(),r(new b.CancellationError))),O.on("error",J=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),r(J)});const j=[];O.stdout.on("data",J=>j.push(J));const Y=[];O.stderr.on("data",J=>Y.push(J)),O.on("close",(J,ee)=>{const le=Buffer.concat(j).toString("utf8");g.trace("getUnixShellEnvironment#raw",le);const re=Buffer.concat(Y).toString("utf8");if(re.trim()&&g.trace("getUnixShellEnvironment#stderr",re),J||ee)return r(new Error((0,D.localize)(2,null,J,ee)));const he=t.exec(le),ce=he?he[1]:"{}";try{const se=JSON.parse(ce);y?se.ELECTRON_RUN_AS_NODE=y:delete se.ELECTRON_RUN_AS_NODE,p?se.ELECTRON_NO_ATTACH_CONSOLE=p:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",se),i(se)}catch(se){g.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(se)),r(se)}})})}}),define(ie[137],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,T.createDecorator)("stateReadService"),e.IStateService=(0,T.createDecorator)("stateService")}),define(ie[68],ne([0,1,8,14,3,18,13,6]),function(G,e,T,A,D,C,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(f=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(v,N,R,u){this.f=v,this.g=R,this.h=u,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=N===0?void 0:new T.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,N){const R=this.a[v];return(0,D.isUndefinedOrNull)(R)?N:R}setItem(v,N){this.setItems([{key:v,data:N}])}setItems(v){let N=!1;for(const{key:R,data:u}of v)this.a[R]!==u&&((0,D.isUndefinedOrNull)(u)?(0,D.isUndefined)(this.a[R])||(this.a[R]=void 0,N=!0):(this.a[R]=u,N=!0));N&&this.j()}removeItem(v){(0,D.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(v)),this.b=v}catch(N){this.g.error(N)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let P=class{constructor(v,N,R,u){this.a=new c(N.stateResource,v,R,u)}async init(){await this.a.init()}getItem(v,N){return this.a.getItem(v,N)}};P=ve([te(1,C.IEnvironmentService),te(2,b.ILogService),te(3,L.IFileService)],P),e.StateReadonlyService=P;class E extends P{setItem(v,N){this.a.setItem(v,N)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.StateService=E}),define(ie[69],ne([0,1,12,34,28]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(f){if(T.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function L(f,c,P,E,m,v,N,R){const u=Object.create(null);u["common.machineId"]=v,u.sessionID=(0,D.generateUuid)()+Date.now(),u.commitHash=E,u.version=m,u["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,T.PlatformToString)(T.platform),u["common.nodePlatform"]=A.platform,u["common.nodeArch"]=P,u["common.product"]=R||"desktop",N&&(u["common.msftInternal"]=N);let g=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),T.isLinuxSnap&&(u["common.snap"]="true");const y=C(c);return y&&(u["common.platformDetail"]=y),u}e.resolveCommonProperties=L;function b(f){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return f.some(E=>P===E)}e.verifyMicrosoftInternalDomain=b}),define(ie[25],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[39],ne([0,1,30,3,5,24,67,69,25]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(r){this.value=r}}e.TelemetryTrustedValue=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(r,o,l){}async publicLogError(r,o,l){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,r){return D.Event.debounce(r.onDidChangeConfiguration,(l,d)=>{const w=l?new Set([...l.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:w}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=m;function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=v;function N(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=N;function R(i){const r=i.getValue(f.TELEMETRY_SETTING_ID),o=i.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function u(i){const r={},o={},l={};y(i,l);for(let d in l){d=d.length>150?d.substr(d.length-149):d;const w=l[d];typeof w=="number"?o[d]=w:typeof w=="boolean"?o[d]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${w.length}`),r[d]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(r[d]=w)}return{properties:r,measurements:o}}e.validateTelemetryData=u;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const r=(0,L.getRemoteName)(i);return g.has(r)?r:"other"}e.cleanRemoteAuthority=h;function y(i,r,o=0,l){if(!!i)for(const d of Object.getOwnPropertyNames(i)){const w=i[d],O=l?l+d:d;Array.isArray(w)?r[O]=(0,T.safeStringify)(w):w instanceof Date?r[O]=w.toISOString():(0,A.isObject)(w)?o<2?y(w,r,o+1,O+"."):r[O]=(0,T.safeStringify)(w):r[O]=w}}function p(i,r){const o=i.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,b.verifyMicrosoftInternalDomain)(o)||l}e.isInternalTelemetry=p;function I(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=I;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const j of r)for(;;){const Y=j.exec(i);if(!Y)break;l.push([Y.index,j.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(o="";;){const j=w.exec(i);if(!j)break;const Y=l.some(([J,ee])=>j.index<ee&&J<w.lastIndex);!d.test(j[0])&&!Y&&(o+=i.substring(O,j.index)+"<REDACTED: user-file-path>",O=w.lastIndex)}return O<i.length&&(o+=i.substr(O)),o}function a(i){if(!i)return i;const r=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of o)if(l.regex.test(r))return`<REDACTED: ${l.label}>`;return i}function n(i,r){return(0,T.cloneAndChange)(i,o=>{if(o instanceof c)return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=t(l,r);for(const d of r)l=l.replace(d,"");return l=a(l),l}})}e.cleanData=n}),define(ie[26],ne([0,1,29,20,37,12,11,9,34,39]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,r,o)}static parse(i){const r=E.exec(i);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function N(n){const i=v.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=N;function R(n,i){return`${n}.${i}`}e.getExtensionId=R;function u(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function g(n,i){return u(R(n??D.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=g;function h(n,i){const r=[],o=l=>{for(const d of r)if(d.some(w=>P(i(w),i(l))))return d;return null};for(const l of n){const d=o(l);d?d.push(l):r.push([l])}return r}e.groupByExtension=h;function y(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function p(n){return{id:new c.TelemetryTrustedValue(n.identifier.id),name:new c.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function I(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&r.every(d=>!P(d.identifier,{id:l}))){const d=n.filter(w=>P(w.identifier,{id:l}));d.length===1&&(r.push(d[0]),o.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=I;async function t(n,i){if(!C.isLinux)return!1;let r;try{r=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const r=await t(n,i),o=(0,A.getTargetPlatform)(r?"alpine":C.platform,f.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ie[138],ne([0,1,23,9,16,17,41,11,91,20,26,37]),function(G,e,T,A,D,C,L,b,f,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=u=>(0,f.localize)(0,null,u),v=(0,f.localize)(1,null,"ms-dotnettools.csharp");function N(u,g){return g?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let R=class{constructor(g,h,y){this.a=g,this.b=h,this.d=y}get f(){}async listExtensions(g,h,y){let p=await this.b.getInstalled(1,y);const I=E.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(h&&h!==""){if(I.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),I.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,f.localize)(2,null,this.f)),p=p.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(N(a.manifest,g)))}async installExtensions(g,h,y,p){const I=[],t=[];g.length&&this.a.info(this.f?(0,f.localize)(3,null,this.f):(0,f.localize)(4,null));const a=[];let n=[];const i=(o,l,d)=>{n.push({id:o,version:l!=="prerelease"?l:void 0,installOptions:{...y,isBuiltin:d,installPreReleaseVersion:l==="prerelease"||y.installPreReleaseVersion}})};for(const o of g)if(o instanceof b.URI)a.push({vsix:o,installOptions:y});else{const[l,d]=(0,P.getIdAndVersion)(o);i(l,d,!1)}for(const o of h)if(o instanceof b.URI)a.push({vsix:o,installOptions:{...y,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,d]=(0,P.getIdAndVersion)(o);i(l,d,!0)}const r=await this.b.getInstalled(1,y.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:o,installOptions:l})=>{try{const d=await this.g(o,l,p,r);d&&t.push(d)}catch(d){this.a.error(d),I.push(o.toString())}})),n.length&&(n=n.filter(({id:o,version:l})=>{const d=r.find(w=>(0,P.areSameExtensions)(w.identifier,{id:o}));if(d){if(!p&&(!l||l==="prerelease"&&d.preRelease))return this.a.info((0,f.localize)(5,null,o,d.manifest.version,o)),!1;if(l&&d.manifest.version===l)return this.a.info((0,f.localize)(6,null,`${o}@${l}`)),!1}return!0}),n.length)){const o=await this.h(n);await Promise.all(n.map(async l=>{const d=o.get(l.id.toLowerCase());if(d)try{const w=await this.j(l,d,r);w&&t.push(w)}catch(w){this.a.error(w.message||w.stack||w),I.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${v}`),I.push(l.id)}))}if(I.length)throw new Error((0,f.localize)(7,null,I.join(", ")))}async g(g,h,y,p){const I=await this.b.getManifest(g);if(!I)throw new Error("Invalid vsix");if(await this.l(I,y,h.profileLocation,p))try{return await this.b.install(g,h),this.a.info((0,f.localize)(8,null,(0,C.basename)(g))),I}catch(a){if((0,A.isCancellationError)(a))return this.a.info((0,f.localize)(9,null,(0,C.basename)(g))),null;throw a}return null}async h(g){const h=new Map,y=g.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),I=await this.d.getExtensions(g.map(t=>({...t,preRelease:y})),{targetPlatform:p},T.CancellationToken.None);for(const t of I)h.set(t.identifier.id.toLowerCase(),t);return h}async j({id:g,version:h,installOptions:y},p,I){const t=await this.d.getManifest(p,T.CancellationToken.None);if(t&&!this.k(t))return null;const a=I.find(n=>(0,P.areSameExtensions)(n.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,f.localize)(10,null,h?`${g}@${h}`:g)),null;this.a.info((0,f.localize)(11,null,g,p.version))}try{y.isBuiltin?this.a.info(h?(0,f.localize)(12,null,g,h):(0,f.localize)(13,null,g)):this.a.info(h?(0,f.localize)(14,null,g,h):(0,f.localize)(15,null,g));const n=await this.b.installFromGallery(p,{...y,installGivenVersion:!!h});return this.a.info((0,f.localize)(16,null,g,n.manifest.version)),t}catch(n){if((0,A.isCancellationError)(n))return this.a.info((0,f.localize)(17,null,g)),null;throw n}}k(g){return!0}async l(g,h,y,p){if(!h){const I={id:(0,P.getGalleryExtensionId)(g.publisher,g.name)},t=p.find(a=>(0,P.areSameExtensions)(I,a.identifier)&&(0,L.gt)(a.manifest.version,g.version));if(t)return this.a.info((0,f.localize)(18,null,t.identifier.id,t.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,h,y){const p=async t=>{if(t instanceof b.URI){const a=await this.b.getManifest(t);return N(a)}return t},I=[];for(const t of g){const a=await p(t),i=(await this.b.getInstalled(void 0,y)).filter(r=>(0,P.areSameExtensions)(r.identifier,{id:a}));if(!i.length)throw new Error(`${this.m(a)}
${v}`);if(i.some(r=>r.type===0)){this.a.info((0,f.localize)(19,null,a));return}if(!h&&i.some(r=>r.isBuiltin)){this.a.info((0,f.localize)(20,null,a));return}this.a.info((0,f.localize)(21,null,a));for(const r of i)await this.b.uninstall(r,{profileLocation:y}),I.push(r);this.f?this.a.info((0,f.localize)(22,null,a,this.f)):this.a.info((0,f.localize)(23,null,a))}}async locateExtension(g){const h=await this.b.getInstalled();g.forEach(y=>{h.forEach(p=>{if(p.identifier.id===y&&p.location.scheme===D.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(g){return this.f?(0,f.localize)(24,null,g,this.f):(0,f.localize)(25,null,g)}};R=ve([te(1,c.IExtensionManagementService),te(2,c.IExtensionGalleryService)],R),e.ExtensionManagementCLI=R}),define(ie[139],ne([0,1,5,2,35,26,37]),function(G,e,T,A,D,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends A.Disposable{constructor(c,P,E,m,v,N,R){super(),this.f=c,this.g=P,this.h=E,this.i=m,this.j=v,this.k=N,this.l=R,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.DisposableMap),this.m().then(null,u=>R.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,P){try{await Promise.all(P.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,A.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(c){for(const P of c.extensions)this.D(this.G(P.identifier,P.version),c.profileLocation)}async s(c){for(const P of c.extensions){const E=this.G(P.identifier,P.version);c.error?this.F(E,c.profileLocation):this.D(E,c.profileLocation)}}async t(c){for(const P of c.extensions)this.F(this.G(P.identifier,P.version),c.profileLocation)}async u(c){const P=[],E=[];for(const m of c.extensions){const v=this.G(m.identifier,m.version);c.error?this.D(v,c.profileLocation):(this.F(v,c.profileLocation),this.b.has(v)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.f.scanInstalledExtensionAtLocation(m.location).then(N=>{N?P.push(N):this.l.info("Extension not found at the location",m.location.toString())},N=>this.l.error(N)))))}try{await Promise.all(E),P.length&&await this.C(P)}catch(m){this.l.error(m)}}v(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(c){const P=[],E=[],m=await this.i.scanProfileExtensions(c),v=new Set,N=new Set;for(const[R,u]of this.b)u.has(c)&&N.add(R);for(const R of m){const u=this.G(R.identifier,R.version);v.add(u),N.has(u)||(P.push(R.identifier),this.D(u,c))}for(const R of N)if(!v.has(R)){const u=this.H(R);u&&(E.push(u.identifier),this.F(R,c))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:E.length?{extensions:E,profileLocation:c}:void 0})}async y(c){const P=await this.i.scanProfileExtensions(c);for(const E of P)this.D(this.G(E.identifier,E.version),c)}async z(c){for(const P of[...this.b.keys()])this.F(P,c);await this.C()}async C(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}D(c,P){let E=this.b.get(c);E||this.b.set(c,E=new D.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),E.add(P)}F(c,P){const E=this.b.get(c);E&&E.delete(P),E?.size||this.b.delete(c)}G(c,P){return`${L.ExtensionIdentifier.toKey(c.id)}@${P}`}H(c){const[P,E]=(0,C.getIdAndVersion)(c);return E?{identifier:{id:P},version:E}:void 0}}e.ExtensionsWatcher=b}),define(ie[140],ne([0,1,111,39]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,L,b,f,c,P,E){const m={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${L.nameShort})`};if((0,A.supportsTelemetry)(L,b)&&(0,A.getTelemetryLevel)(f)===3){const v=await(0,T.getServiceMachineId)(b,c,P);m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=E.machineId||v}return m}e.resolveMarketplaceHeaders=D}),define(ie[141],ne([0,1,169,19,8,2,16,15,22,18,20,26,6,64,11]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let R=class extends v.LanguagePackBaseService{constructor(y,p,I,t){super(I),this.h=y,this.i=t,this.g=this.B(new u(p,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(y,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const a=t.translations[y];return a?N.URI.file(a):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),p=Object.keys(y).map(I=>{const t=y[I];return{...this.f(I,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((I,t)=>I.label.localeCompare(t.label)),p}async j(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",y.identifier.id),await this.update())}async k(y){const p=await this.g.getLanguagePacks();Object.keys(p).some(I=>p[I]&&p[I].extensions.some(t=>(0,E.areSameExtensions)(t.extensionIdentifier,y.identifier)))&&(this.i.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(p);return!(0,A.equals)(Object.keys(y),Object.keys(I))}};R=ve([te(0,P.IExtensionManagementService),te(1,c.INativeEnvironmentService),te(2,P.IExtensionGalleryService),te(3,m.ILogService)],R),e.NativeLanguagePackService=R;let u=class extends C.Disposable{constructor(y,p){super(),this.i=p,this.c={},this.f=(0,b.join)(y.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.m(p=>{Object.keys(p).forEach(I=>delete p[I]),this.j(p,...y)}).then(()=>this.c)}j(y,...p){for(const I of p)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.k(y,I);Object.keys(y).forEach(I=>this.l(y[I]))}k(y,p){const I=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===L.Schemas.file&&g(a)){let n=y[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},y[a.languageId]=n);const i=n.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,I))[0];i?i.version=p.manifest.version:n.extensions.push({extensionIdentifier:I,version:p.manifest.version});for(const r of a.translations)n.translations[r.id]=(0,b.join)(p.location.fsPath,r.path)}}l(y){if(y){const p=(0,T.createHash)("md5");for(const I of y.extensions)p.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);y.hash=p.digest("hex")}}m(y=()=>null){return this.g.queue(()=>{let p=null;return f.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(p=y(I),I)).then(I=>{for(const a of Object.keys(I))I[a]||delete I[a];this.c=I,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),f.Promises.writeFile(this.f,t)}).then(()=>p,I=>this.i.error(I))})}};u=ve([te(0,c.INativeEnvironmentService),te(1,m.ILogService)],u);function g(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const y of h.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ie[142],ne([0,1,9,30,39]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://0.0.0.0/OneCollector/1.0",L="https://0.0.0.0/ping";async function b(c,P,E){const m=await new Promise((g,h)=>{G(["@microsoft/1ds-core-js"],g,h)}),v=await new Promise((g,h)=>{G(["@microsoft/1ds-post-js"],g,h)}),N=new m.AppInsightsCore,R=new v.PostChannel,u={instrumentationKey:c,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[R]]};if(E){u.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:E};u.extensionConfig[R.identifier]=g}return N.initialize(u,[]),N.addTelemetryInitializer(g=>{P&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),N}class f{constructor(P,E,m,v,N){this.e=P,this.f=E,this.g=m,this.h=N,this.c=C,this.d=L,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(E=>{P(E)},E=>{(0,T.onUnexpectedError)(E),console.error(E)})}}log(P,E){if(!this.a)return;E=(0,A.mixin)(E,this.g),E=(0,D.validateTelemetryData)(E);const m=this.f+"/"+P;try{this.i(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:m,baseData:{name:m,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ie[143],ne([0,1,2,30,12,29,103,24,42,144,31,36,25,39]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let N=class{constructor(g,h,y){this.k=h,this.l=y,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.TELEMETRY_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,v.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const y=h.usage?3:h.error?2:0;g=Math.min(g,y)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,y){this.g<h||(y=(0,A.mixin)(y,this.d),y=(0,v.cleanData)(y,this.j),y=(0,A.mixin)(y,this.c),this.b.forEach(p=>p.log(g,y)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){!this.h||this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};N.IDLE_START_EVENT_NAME="UserIdleStart",N.IDLE_STOP_EVENT_NAME="UserIdleStop",N=ve([te(1,b.IConfigurationService),te(2,P.IProductService)],N),e.TelemetryService=N;function R(){const u=(0,L.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=D.isWeb?"":(0,L.localize)(3,null),y=(0,L.localize)(4,null),p=(0,L.localize)(5,null),I=(0,L.localize)(6,null),t=(0,L.localize)(7,null),a=`
|       | ${y} | ${p} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${u} ${g} ${h}

&nbsp;

${t}
${a}

&nbsp;

${n}
`}E.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(f.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[145],ne([0,1,170,142]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends A.AbstractOneDataSystemAppender{constructor(L,b,f,c){const P={sendPOST:(E,m)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const N=T.request(E.urlString,v,R=>{R.on("data",function(u){m(R.statusCode??200,R.headers,u.toString())}),R.on("error",function(u){m(0,{})})});N.write(E.data),N.end()}catch{m(0,{})}}};super(L,b,f,c,P)}}e.OneDataSystemAppender=D}),define(ie[146],ne([0,1,15,22]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function D(C,L){const b=Object.create(null),f=(P,E)=>{const m=JSON.parse(P);b[E]=m};if(L){const P=[],E=await A.Promises.readdir(L);for(const v of E)try{(await A.Promises.stat((0,T.join)(L,v))).isDirectory()&&P.push(v)}catch{}const m=[];for(const v of P)(await A.Promises.readdir((0,T.join)(L,v))).filter(R=>R==="telemetry.json").length===1&&m.push(v);for(const v of m){const N=(await A.Promises.readFile((0,T.join)(L,v,"telemetry.json"))).toString();f(N,v)}}let c=(await A.Promises.readFile((0,T.join)(C,"telemetry-core.json"))).toString();return f(c,"vscode-core"),c=(await A.Promises.readFile((0,T.join)(C,"telemetry-extensions.json"))).toString(),f(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=D}),define(ie[147],ne([0,1,12,80,25]),function(G,e,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(L,b){let f=L.getItem(D.machineIdKey);return(typeof f!="string"||T.isMacintosh&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,A.getMachineId)(b.error.bind(b))),f}e.resolveMachineId=C}),define(ie[27],ne([0,1,10]),function(G,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(ie[148],ne([0,1,27,112,13,17,72,5,2]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let P=class{constructor(m){this.g=m,this.c=new f.DisposableStore,this.f=2**16;const v=new Map,N=R=>{let u=v.get(R.scheme);return u===void 0&&(u=m.hasProvider(R)&&!this.g.hasCapability(R,1024),v.set(R.scheme,u)),u};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(R=>{v.delete(R.scheme)})),this.extUri=new C.ExtUri(N),this.d=new L.SkipList((R,u)=>this.extUri.compare(R,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,C.normalizePath)(m));const v=this.d.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((N,R)=>N[1].time<R[1].time?1:N[1].time>R[1].time?-1:0);c._clock=0,this.d.clear();const v=this.f*.5;for(let N=0;N<v;N++)this.d.set(m[N][0],m[N][1].touch())}};P=ve([te(0,D.IFileService)],P),e.UriIdentityService=P,(0,A.registerSingleton)(T.IUriIdentityService,P,1)}),define(ie[149],ne([0,1,105,15,55,17,11,10,16]),function(G,e,T,A,D,C,L,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function c(i){const r=i;return typeof r?.id=="string"&&L.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=E;function m(i){const r=i;return typeof r?.id=="string"&&L.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=m;function v(i){const r=i;if(r?.uri)return{id:r.id,uri:L.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=v;var N;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(N=e.WorkbenchState||(e.WorkbenchState={}));function R(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=R;function u(i){const r=i;return!!(r&&typeof r=="object"&&L.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class g{constructor(r,o,l,d,w){this.h=r,this.j=l,this.k=d,this.l=w,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class h{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,C.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function y(i){return new h({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,r){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function I(i){let r;return L.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=I,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(i,r){return!p(i,r)&&!I(i)}e.isSavedWorkspace=a;function n(i){return(typeof i=="string"?(0,A.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ie[21],ne([0,1,45,5,2,17,11,104,18,13,10,6,149,35,27,8,28,29,3]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&L.URI.isUri(i.location)&&L.URI.isUri(i.globalStorageHome)&&L.URI.isUri(i.settingsResource)&&L.URI.isUri(i.keybindingsResource)&&L.URI.isUri(i.tasksResource)&&L.URI.isUri(i.snippetsHome)&&L.URI.isUri(i.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function p(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:L.URI.revive(n.location).with({scheme:i}),globalStorageHome:L.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:L.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:L.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:L.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:L.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:L.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:L.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=p;function I(n,i,r,o,l){return{id:n,name:i,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,C.joinPath)(r,"globalStorage"),settingsResource:(0,C.joinPath)(r,"settings.json"),keybindingsResource:(0,C.joinPath)(r,"keybindings.json"),tasksResource:(0,C.joinPath)(r,"tasks.json"),snippetsHome:(0,C.joinPath)(r,"snippets"),extensionsResource:(0,C.joinPath)(r,"extensions.json"),cacheHome:(0,C.joinPath)(o,n),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=I;let t=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,o,l){super(),this.n=i,this.r=r,this.s=o,this.t=l,this.f=!0,this.h=this.B(new A.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new A.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new A.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new A.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,C.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const d of this.J()){if(!d.name||!(0,h.isString)(d.name)||!d.location){this.t.warn("Skipping the invalid stored profile",d.location||d.name);continue}i.push(I((0,C.basename)(d.location),d.name,d.location,this.g,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}}catch(d){this.t.error(d)}const r=new v.ResourceMap,o=new Map,l=this.w();if(i.unshift({...l,extensionsResource:this.O()??l.extensionsResource,isDefault:!0}),i.length)try{const d=this.M();if(d.workspaces)for(const[w,O]of Object.entries(d.workspaces)){const j=L.URI.parse(w),Y=i.find(J=>J.id===O);Y&&r.set(j,Y)}if(d.emptyWindows)for(const[w,O]of Object.entries(d.emptyWindows)){const j=i.find(Y=>Y.id===O);j&&o.set(w,j)}}catch(d){this.t.error(d)}this.u={profiles:i,workspaces:r,emptyWindows:o}}return this.u}w(){return I("__default__profile__",(0,b.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const w of this.profiles){const O=o.exec(w.name),j=O?parseInt(O[1]):0;l=j>l?j:l}const d=`${r} ${l+1}`;return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),d,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,T.hash)((0,u.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=await this.y(i,r,o);return l&&await this.setProfileForWorkspace(l,d),d}async y(i,r,o){if(!(0,h.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.l.get(r);return l||(l=(async()=>{try{const d=this.profiles.find(j=>j.name===r||j.id===i);if(d)return d;const w=I(i,r,(0,C.joinPath)(this.profilesHome,i),this.g,o);await this.r.createFolder(w.location);const O=[];return this.i.fire({profile:w,join(j){O.push(j)}}),await R.Promises.settled(O),this.D([w],[],[]),w}finally{this.l.delete(r)}})(),this.l.set(r,l)),l}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=I(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.j.fire({profile:r,join(l){o.push(l)}});try{await Promise.allSettled(o)}catch(l){this.t.error(l)}for(const l of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(l)?.id&&this.v.emptyWindows.delete(l);for(const l of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(l)?.id&&this.v.workspaces.delete(l);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(l){(0,c.toFileOperationResult)(l)!==1&&this.t.error(l)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(r.location,{recursive:!0})}catch(l){this.t.error(l)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(l=>l.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(!!this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.s.extUri.isEqual(o.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return L.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,m.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,m.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,o){const l=[...this.profiles,...i],d=[];this.m.profiles=[];for(let w of l)w.isDefault||r.some(O=>w.id===O.id)||(w=o.find(O=>w.id===O.id)??w,w.isTransient?this.m.profiles.push(w):d.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.L(d),this.u=void 0,this.F(i,r,o)}F(i,r,o){this.h.fire({added:i,removed:r,updated:o,all:this.profiles})}G(i,r,o){o=r?.isTransient?!0:o,o||this.G(i,void 0,!0);const l=this.z(i),d=o?this.m:this.v;L.URI.isUri(l)?(d.workspaces.delete(l),r&&d.workspaces.set(l,r)):(d.emptyWindows.delete(l),r&&d.emptyWindows.set(l,r)),o||this.H()}H(){const i={};for(const[o,l]of this.v.workspaces.entries())i[o.toString()]=l.id;const r={};for(const[o,l]of this.v.emptyWindows.entries())r[o.toString()]=l.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},o=this.w();if(i.workspaces)for(const[d,w]of Object.entries(i.workspaces)){const O=L.URI.parse(w);r[d]=this.s.extUri.isEqual(O,o.location)?o.id:this.s.extUri.basename(O)}const l={};if(i.emptyWindows)for(const[d,w]of Object.entries(i.emptyWindows)){const O=L.URI.parse(w);l[d]=this.s.extUri.isEqual(O,o.location)?o.id:this.s.extUri.basename(O)}return{workspaces:r,emptyWindows:l}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([te(0,f.IEnvironmentService),te(1,c.IFileService),te(2,N.IUriIdentityService),te(3,E.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=a}),define(ie[150],ne([0,1,19,8,23,9,5,2,12,3,11,89,20,26,37,6,31,25,21]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends b.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,l,d){super(),this.t=i,this.u=r,this.v=o,this.w=l,this.y=d,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,b.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,m.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.t.isEnabled())throw new m.ExtensionManagementError(E.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),I(o)}}async uninstall(i,r={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,r,o){const l=o.isApplicationScoped||o.isBuiltin||(0,N.isApplicationScopedExtension)(i),d={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:l,profileLocation:l?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},w=le=>`${v.ExtensionKey.create(le).toString()}${d.profileLocation?`-${d.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const le=this.j.get(w(r));if(le)return this.v.info("Extensions is already requested to install",r.identifier.id),le.task.waitUntilTaskIsFinished()}const O=[],j=[],Y=[],J=this.Q(i,r,d);P.URI.isUri(r)||this.j.set(w(r),{task:J,waitingTasks:[]}),this.l.fire({identifier:J.identifier,source:r,profileLocation:d.profileLocation}),this.v.info("Installing extension:",J.identifier.id),O.push({task:J,manifest:i});let ee=!1;try{if(d.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",J.identifier.id);else try{const re=await this.F(J.identifier,i,!!d.installOnlyNewlyAddedFromExtensionPack,!!d.installPreReleaseVersion,d.profileLocation),he=await this.getInstalled(void 0,d.profileLocation);for(const{gallery:ce,manifest:se}of(0,T.distinct)(re,({gallery:$})=>$.identifier.id)){ee=ee||!!se.extensionDependencies?.some(x=>(0,v.areSameExtensions)({id:x},J.identifier));const $=w(ce),q=this.j.get($);if(q){if(this.C(J,q.task)){const x=q.task.identifier;this.v.info("Waiting for already requested installing extension",x.id,J.identifier.id),q.waitingTasks.push(J),j.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,F=>F.some(W=>(0,v.areSameExtensions)(W.identifier,x)))).then(F=>{if(this.v.info("Finished waiting for already requested installing extension",x.id,J.identifier.id),!F.find(H=>(0,v.areSameExtensions)(H.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!he.some(({identifier:x})=>(0,v.areSameExtensions)(x,ce.identifier))){const x=this.Q(se,ce,{...d,donotIncludePackAndDependencies:!0});this.j.set($,{task:x,waitingTasks:[J]}),this.l.fire({identifier:x.identifier,source:ce,profileLocation:d.profileLocation}),this.v.info("Installing extension:",x.identifier.id,J.identifier.id),O.push({task:x,manifest:se})}}}catch(re){if(P.URI.isUri(J.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",J.identifier.id,re.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",J.identifier.id,re.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",J.identifier.id),re}const le=O.reduce((re,{task:he,manifest:ce})=>(re.set(he.identifier.id.toLowerCase(),{task:he,manifest:ce}),re),new Map);for(;le.size;){let re;const he=[...le.values()].filter(({manifest:ce})=>!ce.extensionDependencies?.some(se=>le.has(se.toLowerCase())));he.length?re=le.size===1?he:he.filter(({task:ce})=>!(ce===J&&!ee)):(this.v.info("Found extensions with circular dependencies",he.map(({task:ce})=>ce.identifier.id)),re=[...le.values()]),await this.D(re.map(async({task:ce})=>{const se=new Date().getTime();try{const $=await ce.run();if(await this.D(this.s.map(q=>q.postInstall($,ce.source,d,D.CancellationToken.None))),!P.URI.isUri(ce.source)){const q=ce.operation===3,x=q?void 0:(new Date().getTime()-ce.source.lastUpdated)/1e3;if(t(this.u,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-se,durationSinceUpdate:x}),f.isWeb&&ce.operation!==3)try{await this.t.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}Y.push({local:$,identifier:ce.identifier,operation:ce.operation,source:ce.source,context:d.context,profileLocation:ce.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw P.URI.isUri(ce.source)||t(this.u,ce.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-se,error:$}),this.v.error("Error while installing the extension:",ce.identifier.id),$}finally{le.delete(ce.identifier.id.toLowerCase())}}))}return j.length&&await this.D(j),Y.forEach(({identifier:re})=>this.v.info("Extension installed successfully:",re.id)),this.m.fire(Y),Y.filter(({identifier:re})=>(0,v.areSameExtensions)(re,J.identifier))[0].local}catch(le){if(O.forEach(({task:re})=>re.cancel()),Y.length)try{const re=await Promise.allSettled(Y.map(({local:he})=>this.R(he,{versionOnly:!0,profileLocation:d.profileLocation}).run()));for(let he=0;he<re.length;he++){const ce=re[he],{identifier:se}=Y[he];ce.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",se.id):this.v.warn("Rollback: Error while uninstalling extension",se.id,(0,C.getErrorMessage)(ce.reason))}}catch(re){this.v.warn("Error while rolling back extensions",(0,C.getErrorMessage)(re),Y.map(({identifier:he})=>he.id))}throw this.m.fire(O.map(({task:re})=>({identifier:re.identifier,operation:2,source:re.source,context:d.context,profileLocation:d.profileLocation}))),le}finally{for(const{task:le}of O)le.source&&!P.URI.isUri(le.source)&&this.j.delete(w(le.source))}}C(i,r){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(r)||l.some(d=>this.C(d,r)))||o===r&&l[0]&&!this.C(i,l[0]))return!1;return!0}async D(i){const r=[],o=[],l=await Promise.allSettled(i);for(const d of l)d.status==="fulfilled"?r.push(d.value):o.push(d.reason);if(o.length)throw p(o);return r}async F(i,r,o,l,d){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,d),O=[],j=[],Y=async(J,ee)=>{O.push(J);const le=ee.extensionDependencies||[],re=[...le];if(ee.extensionPack){const he=o?w.find(ce=>(0,v.areSameExtensions)(ce.identifier,J)):void 0;for(const ce of ee.extensionPack)he&&he.manifest.extensionPack&&he.manifest.extensionPack.some(se=>(0,v.areSameExtensions)({id:se},{id:ce}))||re.every(se=>!(0,v.areSameExtensions)({id:se},{id:ce}))&&re.push(ce)}if(re.length){const he=re.filter(ce=>O.every(se=>!(0,v.areSameExtensions)(se,{id:ce})));if(he.length){const ce=await this.t.getExtensions(he.map(se=>({id:se,preRelease:l})),D.CancellationToken.None);for(const se of ce){if(O.find(x=>(0,v.areSameExtensions)(x,se.identifier)))continue;const $=le.some(x=>(0,v.areSameExtensions)({id:x},se.identifier));let q;try{q=await this.G(se,!1,l)}catch(x){if(x instanceof m.ExtensionManagementError&&x.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw x}j.push({gallery:q.extension,manifest:q.manifest}),await Y(q.extension.identifier,q.manifest)}}}};return await Y(i,r),j}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(O=>(0,v.areSameExtensions)(i.identifier,O)))throw new m.ExtensionManagementError(E.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const O=await this.getTargetPlatform();throw new m.ExtensionManagementError(E.localize(2,null,i.identifier.id,this.w.nameLong,(0,m.TargetPlatformToString)(O)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const d=await this.H(i,r,o);if(d){if(o&&!r&&i.hasPreReleaseVersion&&!d.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(E.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],D.CancellationToken.None))[0]?new m.ExtensionManagementError(E.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(E.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",d.identifier.id);const w=await this.t.getManifest(d,D.CancellationToken.None);if(w===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(w.version!==d.version)throw new m.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:d,manifest:w}}async H(i,r,o){const l=await this.getTargetPlatform();let d=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(d=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},D.CancellationToken.None))[0]||null),!d&&await this.t.isExtensionCompatible(i,o,l)&&(d=i),d||(r?d=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},D.CancellationToken.None))[0]||null:d=await this.t.getCompatibleExtension(i,o,l)),d}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},l=J=>`${J.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,d=this.k.get(l(i.identifier));if(d)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),d.waitUntilTaskIsFinished();const w=J=>{const ee=this.R(J,o);return this.k.set(l(ee.extension.identifier),ee),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.n.fire({identifier:J.identifier,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped}),ee},O=(J,ee)=>{ee?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,ee.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(J),error:ee}),this.p.fire({identifier:J.identifier,error:ee?.code,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped})},j=[],Y=[];try{j.push(w(i));const J=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.M(i,J);for(const le of ee)this.k.has(l(le.identifier))?this.v.info("Extensions is already requested to uninstall",le.identifier.id):j.push(w(le))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(j.map(ee=>ee.extension),J,i),await this.D(j.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(le=>le.postUninstall(ee.extension,o,D.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}O(ee.extension)}catch(le){const re=le instanceof m.ExtensionManagementError?le:new m.ExtensionManagementError((0,C.getErrorMessage)(le),m.ExtensionManagementErrorCode.Internal);throw O(ee.extension,re),re}finally{Y.push(ee)}}))}catch(J){const ee=J instanceof m.ExtensionManagementError?J:new m.ExtensionManagementError((0,C.getErrorMessage)(J),m.ExtensionManagementErrorCode.Internal);for(const le of j){try{le.cancel()}catch{}Y.includes(le)||O(le.extension,ee)}throw ee}finally{for(const J of j)this.k.delete(l(J.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}J(i,r,o){for(const l of i){const d=this.N(l,r);if(d.length){const w=d.filter(O=>!i.some(j=>(0,v.areSameExtensions)(j.identifier,O.identifier)));if(w.length)throw new Error(this.L(l,w,o))}}}L(i,r,o){return o===i?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const d=r.filter(O=>!O.isBuiltin&&l.some(j=>(0,v.areSameExtensions)({id:j},O.identifier))),w=[];for(const O of d)w.push(...this.M(O,r,o));return[...d,...w]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,v.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};y=ve([te(0,m.IExtensionGalleryService),te(1,g.ITelemetryService),te(2,R.ILogService),te(3,u.IProductService),te(4,h.IUserDataProfilesService)],y),e.AbstractExtensionManagementService=y;function p(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=p;function I(n){if(n instanceof m.ExtensionManagementError)return n;const i=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:o,duration:l,error:d,durationSinceUpdate:w}){let O,j;(0,c.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(O=m.ExtensionManagementErrorCode.Signature,j=o),o="Unverified")),d&&(d instanceof m.ExtensionManagementError?(O=d.code,d.code===m.ExtensionManagementErrorCode.Signature&&(j=d.message)):O=m.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!d,duration:l,errorcode:O,errorcodeDetail:j,durationSinceUpdate:w})}class a{constructor(){this.d=new A.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.createCancelablePromise)(i=>new Promise((r,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new C.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(ie[40],ne([0,1,8,14,2,5,35,11,20,26,13,10,6,21,27,3,9,25]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class y extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let p=class extends D.Disposable{constructor(n,i,r,o,l,d){super(),this.i=n,this.j=i,this.k=r,this.l=o,this.m=l,this.n=d,this.b=this.B(new C.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new C.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new C.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new C.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new L.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],o=[];try{return await this.p(i,l=>{const d=[];for(const w of l)n.some(([O])=>(0,c.areSameExtensions)(O.identifier,w.identifier)&&O.manifest.version!==w.version)?r.push(w):d.push(w);for(const[w,O]of n)if(!d.some(j=>(0,c.areSameExtensions)(j.identifier,w.identifier)&&j.version===w.manifest.version)){const j={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:O};o.push(j),d.push(j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),d}),o.length&&this.c.fire({extensions:o,profileLocation:i}),r.length&&this.g.fire({extensions:r,profileLocation:i}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:i}),r.length&&this.g.fire({extensions:r,error:l,profileLocation:i}),l}}async updateMetadata(n,i){const r=[];return await this.p(i,o=>{const l=[];for(const d of o){const w=n.find(([O])=>(0,c.areSameExtensions)(O.identifier,d.identifier)&&O.manifest.version===d.version);w&&(d.metadata={...d.metadata,...w[1]},r.push(d)),l.push(d)}return l}),r}async removeExtensionFromProfile(n,i){const r=[];this.f.fire({extensions:r,profileLocation:i});try{await this.p(i,o=>{const l=[];for(const d of o)(0,c.areSameExtensions)(d.identifier,n.identifier)?r.push(d):l.push(d);return r.length&&this.f.fire({extensions:r,profileLocation:i}),l}),r.length&&this.g.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:i}),o}}async p(n,i,r){return this.w(n).queue(async()=>{let o=[],l;try{const d=await this.j.readFile(n);l=JSON.parse(d.value.toString().trim()||"[]")}catch(d){if((0,P.toFileOperationResult)(d)!==1)throw d;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&r?.bailOutWhenFileNotFound)throw new y((0,u.getErrorMessage)(d),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(n);let d=!1;for(const w of l){I(w)||this.r(n);let O;if((0,R.isString)(w.relativeLocation)&&w.relativeLocation)O=this.t(w.relativeLocation);else if((0,R.isString)(w.location))O=this.t(w.location),d=!0,w.relativeLocation=w.location,w.location=O.toJSON();else{O=b.URI.revive(w.location);const j=this.s(O);j&&(d=!0,w.relativeLocation=j)}o.push({identifier:w.identifier,location:O,version:w.version,metadata:w.metadata})}d&&await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const d=o.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(n,A.VSBuffer.fromString(JSON.stringify(d)))}return o})}r(n){const i=new y(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(n)).value.toString()}catch(l){if((0,P.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(d=>I(d))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(n)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(i)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}return o})()),this.u}w(n){let i=this.h.get(n);return i||(i=new T.Queue,this.h.set(n,i)),i}};p=ve([te(1,P.IFileService),te(2,v.IUserDataProfilesService),te(3,N.IUriIdentityService),te(4,g.ITelemetryService),te(5,m.ILogService)],p),e.AbstractExtensionsProfileScannerService=p;function I(a){return(0,R.isObject)(a)&&(0,f.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,R.isString)(a.location)&&a.location)&&((0,R.isUndefined)(a.relativeLocation)||(0,R.isString)(a.relativeLocation))&&a.version&&(0,R.isString)(a.version)}function t(a){return a?(0,R.isString)(a.path)&&(0,R.isString)(a.scheme):!1}}),define(ie[48],ne([0,1,19,8,30,14,9,51,78,2,16,15,12,17,41,53,3,11,93,18,26,37,46,13,10,6,31,5,54,40,21,27,110]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y,p,I,t,a,n,i,r,o,l,d,w,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(se){function $(q,x){if(q===x)return!0;const F=Object.keys(q),W=new Set;for(const H of Object.keys(x))W.add(H);if(F.length!==W.size)return!1;for(const H of F){if(q[H]!==x[H])return!1;W.delete(H)}return W.size===0}se.equals=$})(Y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let J=class extends c.Disposable{constructor($,q,x,F,W,H,X,M,U,k,s,S){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=q,this.l=x,this.m=F,this.n=W,this.r=H,this.s=X,this.t=M,this.u=U,this.v=k,this.w=s,this.y=S,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(re,this.m,this.h)),this.j=this.B(this.y.createInstance(re,this.m,this.h)),this.k=this.B(this.y.createInstance(le,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions($,q,x){const[F,W]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(q)]),H=x?await this.scanExtensionsUnderDevelopment($,[...F,...W]):[];return this.G(F,W,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const q=[];q.push(this.H(!!$.useCache,$.language)),q.push(this.I($.language,!!$.checkControlFile));const[x,F]=await Promise.all(q);return this.F([...x,...F],0,$,!1)}async scanUserExtensions($){const q=$.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",q);const x=this.w.extUri.isEqual($.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.L(q,!!$.profileLocation,1,!$.includeUninstalled,$.language,!0,x),W=$.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let H;try{H=await W.scanExtensions(F)}catch(X){if(X instanceof d.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),H=await W.scanExtensions(F);else throw X}return H=await this.F(H,1,$,!0),this.t.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment($,q){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const x=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(F=>F.scheme===P.Schemas.file).map(async F=>{const W=await this.L(F,!1,1,!0,$.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(X=>(X.type=q.find(M=>(0,p.areSameExtensions)(M.identifier,X.identifier))?.type??X.type,this.k.validate(X,W)))}))).flat();return this.F(x,"development",$,!0)}return[]}async scanExistingExtension($,q,x){const F=await this.L($,!1,q,!0,x.language,!0,void 0),W=await this.k.scanExtension(F);return!W||!x.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions($,q,x){const F=await this.L($,!1,q,!0,x.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(F);return this.F(W,q,x,!0)}async scanMetadata($){const q=(0,v.joinPath)($,"package.json"),x=(await this.s.readFile(q)).value.toString();return JSON.parse(x).__metadata}async updateMetadata($,q){const x=(0,v.joinPath)($,"package.json"),F=(await this.s.readFile(x)).value.toString(),W=JSON.parse(F);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,W.__metadata={...W.__metadata,...q},await this.s.writeFile((0,v.joinPath)($,"package.json"),C.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch($){if($ instanceof d.ExtensionsProfileScanningError&&$.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw $}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});if($.length)await this.r.addExtensionsToProfile($.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,a.toFileOperationResult)(q)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(q))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch($){this.t.error($)}finally{this.C=void 0}})()),this.C}async F($,q,x,F){return x.includeAllVersions||($=this.G(q===0?$:void 0,q===1?$:void 0,q==="development"?$:void 0,await this.getTargetPlatform(),F)),x.includeInvalid||($=$.filter(W=>W.isValid)),$.sort((W,H)=>{const X=E.basename(W.location.fsPath),M=E.basename(H.location.fsPath);return X<M?-1:X>M?1:0})}G($,q,x,F,W){const H=(M,U,k)=>{if(M.isValid&&!U.isValid)return!1;if(M.isValid===U.isValid){if(W&&N.gt(M.manifest.version,U.manifest.version))return this.t.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${M.location.path} with version ${M.manifest.version}`),!1;if(N.eq(M.manifest.version,U.manifest.version)){if(M.type===0)return this.t.debug(`Skipping extension ${U.location.path} in favour of system extension ${M.location.path} with same version`),!1;if(M.targetPlatform===F)return this.t.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return k?this.t.warn(`Overwriting user extension ${M.location.path} with ${U.location.path}.`):this.t.debug(`Overwriting user extension ${M.location.path} with ${U.location.path}.`),!0},X=new I.ExtensionIdentifierMap;return $?.forEach(M=>{const U=X.get(M.identifier.id);(!U||H(U,M,!1))&&X.set(M.identifier.id,M)}),q?.forEach(M=>{const U=X.get(M.identifier.id);if(!U&&$&&M.type===0){this.t.debug(`Skipping obsolete system extension ${M.location.path}.`);return}(!U||H(U,M,!1))&&X.set(M.identifier.id,M)}),x?.forEach(M=>{const U=X.get(M.identifier.id);(!U||H(U,M,!0))&&X.set(M.identifier.id,M),X.set(M.identifier.id,M)}),[...X.values()]}async H($,q){this.t.trace("Started scanning system extensions");const x=await this.L(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),W=await($&&!x.devMode?this.i:this.k).scanExtensions(x);return this.t.trace("Scanned system extensions:",W.length),W}async I($,q){const x=this.u.isBuilt?[]:this.v.builtInExtensions;if(!x?.length)return[];this.t.trace("Started scanning dev system extensions");const F=q?await this.J():{},W=[],H=g.URI.file(E.normalize(E.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const M of x){const U=F[M.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":W.push((0,v.joinPath)(H,M.name));break;default:W.push(g.URI.file(U));break}}const X=await Promise.all(W.map(async M=>this.k.scanExtension(await this.L(M,!1,0,!0,$,!0,void 0))));return this.t.trace("Scanned dev system extensions:",X.length),(0,T.coalesce)(X)}async J(){try{const $=await this.s.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async L($,q,x,F,W,H,X){const M=await this.f(W??m.language),U=await this.M($),k=q&&!this.w.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,s=k?await this.M(k):void 0;return new ee($,U,k,s,q,X,x,F,H,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,W,M)}async M($){try{const q=await this.s.stat($);if(typeof q.mtime=="number")return q.mtime}catch{}}};J=ve([te(4,w.IUserDataProfilesService),te(5,d.IExtensionsProfileScannerService),te(6,a.IFileService),te(7,i.ILogService),te(8,y.IEnvironmentService),te(9,r.IProductService),te(10,O.IUriIdentityService),te(11,n.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class ee{constructor($,q,x,F,W,H,X,M,U,k,s,S,z,B,K){this.location=$,this.mtime=q,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=F,this.profile=W,this.profileScanOptions=H,this.type=X,this.excludeObsolete=M,this.validate=U,this.productVersion=k,this.productDate=s,this.productCommit=S,this.devMode=z,this.language=B,this.translations=K}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,q){return(0,v.isEqual)($.location,q.location)&&$.mtime===q.mtime&&(0,v.isEqual)($.applicationExtensionslocation,q.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&$.profile===q.profile&&D.equals($.profileScanOptions,q.profileScanOptions)&&$.type===q.type&&$.excludeObsolete===q.excludeObsolete&&$.validate===q.validate&&$.productVersion===q.productVersion&&$.productDate===q.productDate&&$.productCommit===q.productCommit&&$.devMode===q.devMode&&$.language===q.language&&Y.equals($.translations,q.translations)}}e.ExtensionScannerInput=ee;let le=class extends c.Disposable{constructor($,q,x,F,W){super(),this.f=$,this.g=q,this.h=x,this.i=F,this.j=W}async scanExtensions($){const q=$.profile?await this.l($):await this.k($);let x={};if($.excludeObsolete&&$.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();x=JSON.parse(F)}catch{}return(0,u.isEmptyObject)(x)?q:q.filter(F=>!x[p.ExtensionKey.create(F).toString()])}async k($){const q=await this.i.resolve($.location);if(!q.children?.length)return[];const x=await Promise.all(q.children.map(async F=>{if(!F.isDirectory||$.type===1&&(0,v.basename)(F.resource).indexOf(".")===0)return null;const W=new ee(F.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(W)}));return(0,T.coalesce)(x).sort((F,W)=>F.location.path<W.location.path?-1:1)}async l($){let q=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){q=q.filter(F=>!F.metadata?.isApplicationScoped);const x=await this.m($.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,$);q.push(...x)}return q}async m($,q,x){const F=await this.g.scanProfileExtensions($,x.profileScanOptions);if(!F.length)return[];const W=await Promise.all(F.map(async H=>{if(q(H)){const X=new ee(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(X,H.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,v.joinPath)($.location,"package.json"))){const q=await this.scanExtension($);return q?[q]:[]}else return await this.scanExtensions($)}catch(q){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,L.getErrorMessage)(q)),[]}}async scanExtension($,q){try{let x=await this.scanExtensionManifest($.location);if(x){x.publisher||(x.publisher=I.UNDEFINED_PUBLISHER),q=q??x.__metadata,delete x.__metadata;const F=(0,p.getGalleryExtensionId)(x.publisher,x.name),W=q?.id?{id:F,uuid:q.id}:{id:F},H=q?.isSystem?0:$.type,X=H===0||!!q?.isBuiltin;x=await this.n($.location,x,ee.createNlsConfiguration($));const M={type:H,identifier:W,manifest:x,location:$.location,isBuiltin:X,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return $.validate?this.validate(M,$):M}}catch(x){$.type!==0&&this.j.error(x)}return null}validate($,q){let x=!0;const F=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,$.manifest,$.isBuiltin);for(const[W,H]of F)W===R.default.Error&&(x=!1,this.j.error(this.u(q.location,H)));return $.isValid=x,$.validations=F,$}async scanExtensionManifest($){const q=(0,v.joinPath)($,"package.json");let x;try{x=(await this.i.readFile(q)).value.toString()}catch(W){return(0,a.toFileOperationResult)(W)!==1&&this.j.error(this.u($,(0,h.localize)(0,null,q.path,W.message))),null}let F;try{F=JSON.parse(x)}catch{const H=[];(0,b.parse)(x,H);for(const X of H)this.j.error(this.u($,(0,h.localize)(1,null,q.path,X.offset,X.length,(0,f.getParseErrorMessage)(X.error))));return null}return(0,b.getNodeType)(F)!=="object"?(this.j.error(this.u($,(0,h.localize)(2,null,q.path))),null):F}async n($,q,x){const F=await this.r($,q,x);if(F)try{const W=[],H=await this.s(F.default,W);if(W.length>0)return W.forEach(M=>{this.j.error(this.u($,(0,h.localize)(3,null,F.default?.path,(0,f.getParseErrorMessage)(M.error))))}),q;if((0,b.getNodeType)(F)!=="object")return this.j.error(this.u($,(0,h.localize)(4,null,F.default?.path))),q;const X=F.values||Object.create(null);return(0,j.localizeManifest)(q,X,H)}catch{}return q}async r($,q,x){const F=(0,v.joinPath)($,"package.nls.json"),W=(U,k)=>{k.forEach(s=>{this.j.error(this.u($,(0,h.localize)(5,null,U?.path,(0,f.getParseErrorMessage)(s.error))))})},H=U=>{this.j.error(this.u($,(0,h.localize)(6,null,U?.path)))},X=`${q.publisher}.${q.name}`,M=x.translations[X];if(M)try{const U=g.URI.file(M),k=(await this.i.readFile(U)).value.toString(),s=[],S=(0,b.parse)(k,s);return s.length>0?(W(U,s),{values:void 0,default:F}):(0,b.getNodeType)(S)!=="object"?(H(U),{values:void 0,default:F}):{values:S.contents?S.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let k;try{k=await this.t($,x)}catch{return}if(!k.localized)return{values:void 0,default:k.original};try{const s=(await this.i.readFile(k.localized)).value.toString(),S=[],z=(0,b.parse)(s,S);return S.length>0?(W(k.localized,S),{values:void 0,default:k.original}):(0,b.getNodeType)(z)!=="object"?(H(k.localized),{values:void 0,default:k.original}):{values:z,default:k.original}}catch{return{values:void 0,default:k.original}}}}async s($,q){if($)try{const x=(await this.i.readFile($)).value.toString();return(0,b.parse)(x,q)}catch{}}t($,q){return new Promise((x,F)=>{const W=H=>{const X=(0,v.joinPath)($,`package.nls.${H}.json`);this.i.exists(X).then(M=>{M&&x({localized:X,original:(0,v.joinPath)($,"package.nls.json")});const U=H.lastIndexOf("-");U===-1?x({localized:(0,v.joinPath)($,"package.nls.json"),original:null}):(H=H.substring(0,U),W(H))})};if(q.devMode||q.pseudo||!q.language)return x({localized:(0,v.joinPath)($,"package.nls.json"),original:null});W(q.language)})}u($,q){return`[${$.path}]: ${q}`}};le=ve([te(1,d.IExtensionsProfileScannerService),te(2,O.IUriIdentityService),te(3,a.IFileService),te(4,i.ILogService)],le);let re=class extends le{constructor($,q,x,F,W,H,X){super(q,F,W,H,X),this.z=$,this.C=x,this.w=this.B(new A.ThrottledDelayer(3e3)),this.y=this.B(new o.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions($){const q=this.H($),x=await this.D(q);if(this.v=$,x&&x.input&&ee.equals(x.input,this.v))return this.j.debug("Using cached extensions scan result",$.location.toString()),this.w.trigger(()=>this.G()),x.result.map(W=>(W.location=g.URI.revive(W.location),W));const F=await super.scanExtensions($);return await this.F(q,{input:$,result:F}),F}async D($){try{const q=await this.i.readFile($),x=JSON.parse(q.value.toString());return{result:x.result,input:(0,l.revive)(x.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",$.path,(0,L.getErrorMessage)(q))}return null}async F($,q){try{await this.i.writeFile($,C.VSBuffer.fromString(JSON.stringify(q)))}catch(x){this.j.debug("Error while writing the extension cache file:",$.path,(0,L.getErrorMessage)(x))}}async G(){if(!this.v)return;const $=this.H(this.v),q=await this.D($);if(!q)return;const x=q.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!D.equals(F,x))try{this.j.info("Invalidating Cache",x,F),await this.i.del($),this.y.fire()}catch(W){this.j.error(W)}}H($){const q=this.I($);return this.h.extUri.joinPath(q.cacheHome,$.type===0?I.BUILTIN_MANIFEST_CACHE_FILE:I.USER_MANIFEST_CACHE_FILE)}I($){return $.type===0?this.C.defaultProfile:$.profile?this.h.extUri.isEqual($.location,this.z.extensionsResource)?this.z:this.C.profiles.find(q=>this.h.extUri.isEqual($.location,q.extensionsResource))??this.z:this.C.defaultProfile}};re=ve([te(2,w.IUserDataProfilesService),te(3,d.IExtensionsProfileScannerService),te(4,O.IUriIdentityService),te(5,a.IFileService),te(6,i.ILogService)],re);function he(se,$){const q=(0,p.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:q,identifier:new I.ExtensionIdentifier(q),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:$,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=he;class ce extends J{constructor($,q,x,F,W,H,X,M,U,k,s,S){super($,q,(0,v.joinPath)(x,".vscode-oss-dev","extensions","control.json"),F,W,H,X,M,U,k,s,S),this.N=(async()=>{if(m.translationsConfigFile)try{const z=await this.s.readFile(g.URI.file(m.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f($){return this.N}}e.NativeExtensionsScannerService=ce}),define(ie[151],ne([0,1,58,8,33,5,2,16,15,22,6,21]),function(G,e,T,A,D,C,L,b,f,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends L.Disposable{constructor(N,R){super(),this.b=N,this.f=R,this.a=new A.Limiter(5)}async postUninstall(N){const R=this.g(N,"uninstall");R&&(this.f.info(N.identifier.id,N.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,N),this.f.info("Finished running post uninstall script",N.identifier.id,N.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",N.identifier.id,N.manifest.version),this.f.error(u)}}));try{await c.Promises.rm(this.j(N))}catch(u){this.f.error("Error while removing extension storage path",N.identifier.id),this.f.error(u)}}g(N,R){const u=`vscode:${R}`;if(N.location.scheme===b.Schemas.file&&N.manifest&&N.manifest.scripts&&typeof N.manifest.scripts[u]=="string"){const g=N.manifest.scripts[u].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(N.identifier.id,N.manifest.version,`${u} should be a node script`),null):{script:(0,f.join)(N.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(N,R,u,g,h){return new Promise((y,p)=>{const I=this.i(N,R,u,h);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?p(n):y(void 0)};I.on("error",n=>{a((0,D.toErrorMessage)(n)||"Unknown")}),I.on("exit",(n,i)=>{a(n?`post-${R} process exited with code ${n}`:void 0)}),g&&(t=setTimeout(()=>{t=null,I.kill(),p("timed out")},5e3))})}i(N,R,u,g){const h={silent:!0,execArgv:void 0},y=(0,T.fork)(N,[`--type=extension-post-${R}`,...u],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=C.Event.fromNodeEventEmitter(y.stdout,"data"),I=C.Event.fromNodeEventEmitter(y.stderr,"data");p(n=>this.f.info(g.identifier.id,g.manifest.version,`post-${R}`,n)),I(n=>this.f.error(g.identifier.id,g.manifest.version,`post-${R}`,n));const t=C.Event.any(C.Event.map(p,n=>({data:`%c${n}`,format:[""]})),C.Event.map(I,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),y}j(N){return(0,f.join)(this.b.defaultProfile.globalStorageHome.fsPath,N.identifier.id.toLowerCase())}};m=ve([te(0,E.IUserDataProfilesService),te(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(ie[152],ne([0,1,6,21,27,25,40,13,18,11]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends L.AbstractExtensionsProfileScannerService{constructor(m,v,N,R,u,g){super(c.URI.file(m.extensionsPath),v,N,R,u,g)}};P=ve([te(0,f.INativeEnvironmentService),te(1,b.IFileService),te(2,A.IUserDataProfilesService),te(3,D.IUriIdentityService),te(4,C.ITelemetryService),te(5,T.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(ie[153],ne([0,1,11,18,40,48,13,10,6,31,27,21]),function(G,e,T,A,D,C,L,b,f,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends C.NativeExtensionsScannerService{constructor(N,R,u,g,h,y,p,I){super(T.URI.file(h.builtinExtensionsPath),T.URI.file(h.extensionsPath),h.userHome,N.defaultProfile,N,R,u,g,h,y,p,I)}};m=ve([te(0,E.IUserDataProfilesService),te(1,D.IExtensionsProfileScannerService),te(2,L.IFileService),te(3,f.ILogService),te(4,A.INativeEnvironmentService),te(5,c.IProductService),te(6,P.IUriIdentityService),te(7,b.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(ie[154],ne([0,1,8,5,2,121,3,84,10,21]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function v(h){const y=h.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=v;class N extends D.Disposable{constructor(y={flushInterval:N.a}){super(),this.j=y,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(y,p){if(p===e.TARGET_KEY){switch(y){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:y})}else this.b.fire({scope:y,key:p,target:this.F(y)[p]})}r(y){this.f.fire({reason:y})}get(y,p,I){return this.L(p)?.get(y,I)}getBoolean(y,p,I){return this.L(p)?.getBoolean(y,I)}getNumber(y,p,I){return this.L(p)?.getNumber(y,I)}store(y,p,I,t){if((0,L.isUndefinedOrNull)(p)){this.remove(y,I);return}this.t(()=>{this.u(y,I,t),this.L(I)?.set(y,p)})}remove(y,p){this.t(()=>{this.u(y,p,void 0),this.L(p)?.delete(y)})}t(y){this.b.pause(),this.c.pause();try{y()}finally{this.b.resume(),this.c.resume()}}keys(y,p){const I=[],t=this.F(y);for(const a of Object.keys(t))t[a]===p&&I.push(a);return I}u(y,p,I){const t=this.F(p);typeof I=="number"?t[y]!==I&&(t[y]=I,this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(y){switch(y){case-1:return this.D;case 0:return this.z;default:return this.w}}G(y){const p=this.L(y);return p?v(p):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=P.NONE){this.f.fire({reason:y});const p=this.L(-1),I=this.L(0),t=this.L(1);switch(y){case P.NONE:await T.Promises.settled([p?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await T.Promises.settled([p?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return g(y,p,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(y,p){return this.r(P.NONE),(0,c.isUserDataProfile)(y)?this.N(y,p):this.O(y,p)}H(y,p){return!(y.id===p.id||R(p)&&R(y))}I(y,p,I,t){this.t(()=>{if(t)for(const[a,n]of y)p.set(a,n);else{const a=new Set;for(const[n,i]of y)a.add(n),p.get(n)!==i&&this.n(I,n);for(const[n]of p.items)a.has(n)||this.n(I,n)}})}}N.a=60*1e3,e.AbstractStorageService=N;function R(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=R;class u extends N{constructor(){super(),this.p=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(y=>this.n(1,y))),this.B(this.P.onDidChangeStorage(y=>this.n(0,y))),this.B(this.p.onDidChangeStorage(y=>this.n(-1,y)))}L(y){switch(y){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(y){return!1}}e.InMemoryStorageService=u;async function g(h,y,p,I,t,a){const n=Y=>{try{return JSON.parse(Y)}catch{return Y}},i=new Map,r=new Map;h.forEach((Y,J)=>{i.set(J,Y),r.set(J,n(Y))});const o=new Map,l=new Map;y.forEach((Y,J)=>{o.set(J,Y),l.set(J,n(Y))});const d=new Map,w=new Map;p.forEach((Y,J)=>{d.set(J,Y),w.set(J,n(Y))}),console.group(I!==t?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const O=[];if(i.forEach((Y,J)=>{O.push({key:J,value:Y})}),console.table(O),console.groupEnd(),console.log(r),I!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];o.forEach((J,ee)=>{Y.push({key:ee,value:J})}),console.table(Y),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const j=[];d.forEach((Y,J)=>{j.push({key:J,value:Y})}),console.table(j),console.groupEnd(),console.log(w)}e.logStorage=g}),define(ie[155],ne([0,1,19,23,9,12,34,3,11,24,18,20,26,46,13,6,31,43,140,154,25]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const I=C.isWeb?"web":(0,E.getTargetPlatform)(C.platform,L.arch),t="X-Market-Search-Activity-Id";var a;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function n(...k){return String(k.reduce((s,S)=>s|S,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class w{constructor(s=d){this.d=s}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(s,S=this.d.pageSize){return new w({...this.d,pageNumber:s,pageSize:S})}withFilter(s,...S){const z=[...this.d.criteria,...S.length?S.map(B=>({filterType:s,value:B})):[{filterType:s}]];return new w({...this.d,criteria:z})}withSortBy(s){return new w({...this.d,sortBy:s})}withSortOrder(s){return new w({...this.d,sortOrder:s})}withFlags(...s){return new w({...this.d,flags:s.reduce((S,z)=>S|z,0)})}withAssetTypes(...s){return new w({...this.d,assetTypes:s})}withSource(s){return new w({...this.d,source:s})}get raw(){const{criteria:s,pageNumber:S,pageSize:z,sortBy:B,sortOrder:K,flags:Q,assetTypes:oe}=this.d;return{filters:[{criteria:s,pageNumber:S,pageSize:z,sortBy:B,sortOrder:K}],assetTypes:oe,flags:Q}}get searchText(){const s=this.d.criteria.filter(S=>S.filterType===i.SearchText)[0];return s&&s.value?s.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(s=>String(s.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(k,s){const S=(k||[]).filter(z=>z.statisticName===s)[0];return S?S.value:0}function j(k){const s="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(z=>z.assetType.indexOf(s)===0).reduce((z,B)=>{const K=ee(k,B.assetType);return K&&z.push([B.assetType.substring(s.length),K]),z},[])}function Y(k){if(k.properties){const s=k.properties.filter(B=>B.key===r.Repository),S=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=s.filter(B=>S.test(B.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return ee(k,r.Repository)}function J(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ee(k,s){return k.files.filter(z=>z.assetType===s)[0]?{uri:`${k.assetUri}/${s}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${s}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function le(k,s){const S=k.properties?k.properties.filter(B=>B.key===s):[],z=S.length>0&&S[0].value;return z?z.split(",").map(B=>(0,m.adoptToGalleryExtensionId)(B)):[]}function re(k){const s=k.properties?k.properties.filter(S=>S.key===o.Engine):[];return s.length>0&&s[0].value||""}function he(k){const s=k.properties?k.properties.filter(S=>S.key===o.PreRelease):[];return s.length>0&&s[0].value==="true"}function ce(k){const s=k.properties?k.properties.filter(z=>z.key===o.LocalizedLanguages):[],S=s.length>0&&s[0].value||"";return S?S.split(","):[]}function se(k){return k.properties?.find(s=>s.key===o.SponsorLink)?.value}function $(k){return k.indexOf("preview")!==-1}function q(k){return k.targetPlatform?(0,E.toTargetPlatform)(k.targetPlatform):"undefined"}function x(k){const s=(0,T.distinct)(k.versions.map(q)),S=!!k.tags?.includes(E.WEB_EXTENSION_TAG),z=s.indexOf("web");return S?z===-1&&s.push("web"):z!==-1&&s.splice(z,1),s}function F(k,s){const S=(0,E.getFallbackTargetPlarforms)(s);for(let z=0;z<k.length;z++){const B=k[z];if(B.version===k[z-1]?.version){let K=z;const Q=q(B);if(Q===s)for(;K>0&&k[K-1].version===B.version;)K--;else if(S.includes(Q))for(;K>0&&k[K-1].version===B.version&&q(k[K-1])!==s;)K--;K!==z&&(k.splice(z,1),k.splice(K,0,B))}}return k}e.sortExtensionVersions=F;function W(k,s,S){k.telemetryData={index:s,querySource:S,queryActivityId:k.queryContext?.[t]}}function H(k,s,S,z){const B=k.versions[0],K={manifest:ee(s,r.Manifest),readme:ee(s,r.Details),changelog:ee(s,r.Changelog),license:ee(s,r.License),repository:Y(s),download:J(s),icon:ee(s,r.Icon),signature:ee(s,r.Signature),coreTranslations:j(s)};return{identifier:{id:(0,m.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:s.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(B),description:k.shortDescription||"",installCount:O(k.statistics,"install"),rating:O(k.statistics,"averagerating"),ratingCount:O(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:S,assets:K,properties:{dependencies:le(s,o.Dependency),extensionPack:le(s,o.ExtensionPack),engine:re(s),localizedLanguages:ce(s),targetPlatform:q(s),isPreReleaseVersion:he(s)},hasPreReleaseVersion:he(B),hasReleaseVersion:!0,preview:$(k.flags),isSigned:!!K.signature,queryContext:z}}let X=class{constructor(s,S,z,B,K,Q,oe,de){this.k=S,this.l=z,this.n=B,this.o=K,this.q=Q,this.u=oe,this.w=de;const pe=oe.extensionsGallery,ue=pe?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.d=ue?pe.servicePPEUrl:pe?.serviceUrl,this.g=ue?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,s,this.o)}x(s=""){return`${this.d}${s}`}isEnabled(){return!!this.d}async getExtensions(s,S,z){const B=A.CancellationToken.isCancellationToken(S)?{}:S,K=A.CancellationToken.isCancellationToken(S)?S:z,Q=[],oe=[],de=[],pe=[];let ue=!0;for(const fe of s){fe.uuid?oe.push(fe.uuid):Q.push(fe.id);const we=!!(fe.version||fe.preRelease);de.push({id:fe.id,uuid:fe.uuid,includePreRelease:we}),fe.version&&pe.push({id:fe.id,uuid:fe.uuid,version:fe.version}),ue=ue&&!!fe.hasPreRelease&&!we}if(!oe.length&&!Q.length)return[];let ge=new w().withPage(1,s.length);oe.length&&(ge=ge.withFilter(i.ExtensionId,...oe)),Q.length&&(ge=ge.withFilter(i.ExtensionName,...Q)),(B.queryAllVersions||ue)&&(ge=ge.withFlags(ge.flags,a.IncludeVersions)),B.source&&(ge=ge.withSource(B.source));const{extensions:ae}=await this.z(ge,{targetPlatform:B.targetPlatform??I,includePreRelease:de,versions:pe,compatible:!!B.compatible},K);return B.source&&ae.forEach((fe,we)=>W(fe,we,B.source)),ae}async getCompatibleExtension(s,S,z){if((0,E.isNotWebExtensionInWebTargetPlatform)(s.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(s,S,z))return s;const B=new w().withFlags(a.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,s.identifier.uuid),{extensions:K}=await this.z(B,{targetPlatform:z,compatible:!0,includePreRelease:S},A.CancellationToken.None);return K[0]||null}async isExtensionCompatible(s,S,z){if(!(0,E.isTargetPlatformCompatible)(s.properties.targetPlatform,s.allTargetPlatforms,z)||!S&&s.properties.isPreReleaseVersion)return!1;let B=s.properties.engine;if(!B){const K=await this.getManifest(s,A.CancellationToken.None);if(!K)throw new Error("Manifest was not found");B=K.engines.vscode}return(0,v.isEngineValid)(B,this.u.version,this.u.date)}async y(s,S,z,B,K){if(!(0,E.isTargetPlatformCompatible)(q(s),B,K)||S!=="any"&&he(s)!==(S==="prerelease"))return!1;if(z)try{const Q=await this.E(s);if(!(0,v.isEngineValid)(Q,this.u.version,this.u.date))return!1}catch(Q){return this.l.error(`Error while getting the engine for the version ${s.version}.`,(0,D.getErrorMessage)(Q)),!1}return!0}async query(s,S){let z=s.text||"";const B=s.pageSize??50;let K=new w().withPage(1,B);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,ae)=>(K=K.withFilter(i.Category,ae||ge),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,ae)=>(K=K.withFilter(i.Tag,ae||ge),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(i.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),K=K.withFilter(i.SearchText,z)),K=K.withSortBy(0)):s.ids?K=K.withFilter(i.ExtensionId,...s.ids):s.names?K=K.withFilter(i.ExtensionName,...s.names):K=K.withSortBy(4),typeof s.sortBy=="number"&&(K=K.withSortBy(s.sortBy)),typeof s.sortOrder=="number"&&(K=K.withSortOrder(s.sortOrder)),s.source&&(K=K.withSource(s.source));const Q=async(ue,ge)=>{const{extensions:ae,total:fe}=await this.z(ue,{targetPlatform:I,compatible:!1,includePreRelease:!!s.includePreRelease},ge);return ae.forEach((we,Re)=>W(we,(ue.pageNumber-1)*ue.pageSize+Re,s.source)),{extensions:ae,total:fe}},{extensions:oe,total:de}=await Q(K,S),pe=async(ue,ge)=>{if(ge.isCancellationRequested)throw new D.CancellationError;const{extensions:ae}=await Q(K.withPage(ue+1),ge);return ae};return{firstPage:oe,total:de,pageSize:K.pageSize,getPage:pe}}async z(s,S,z){const B=s.flags;!!(s.flags&a.IncludeLatestVersionOnly)&&!!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(s.flags&a.IncludeLatestVersionOnly)&&!(s.flags&a.IncludeVersions)&&(s=s.withFlags(s.flags,a.IncludeLatestVersionOnly)),S.versions?.length&&(s=s.withFlags(s.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),s=s.withFlags(s.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:K,total:Q,context:oe}=await this.B(s,z);if(!(s.flags&a.IncludeLatestVersionOnly)){const ge=[];for(const ae of K){const fe=await this.A(ae,S,oe);fe&&ge.push(fe)}return{extensions:ge,total:Q}}const pe=[],ue=new Map;for(let ge=0;ge<K.length;ge++){const ae=K[ge],fe={id:(0,m.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},we=(0,b.isBoolean)(S.includePreRelease)?S.includePreRelease:!!S.includePreRelease.find(Ce=>(0,m.areSameExtensions)(Ce,fe))?.includePreRelease;if(S.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(x(ae),S.targetPlatform))continue;const Re=await this.A(ae,S,oe);!Re||Re.properties.isPreReleaseVersion&&(!we||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==S.targetPlatform&&Re.hasPreReleaseVersion?ue.set(ae.extensionId,ge):pe.push([ge,Re])}if(ue.size){const ge=new Date().getTime(),ae=new w().withFlags(B&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:fe}=await this.z(ae,S,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ue.size});for(const we of fe){const Re=ue.get(we.identifier.uuid);pe.push([Re,we])}}return{extensions:pe.sort((ge,ae)=>ge[0]-ae[0]).map(([,ge])=>ge),total:Q}}async A(s,S,z){const B={id:(0,m.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},K=S.versions?.find(pe=>(0,m.areSameExtensions)(pe,B))?.version,Q=(0,b.isBoolean)(S.includePreRelease)?S.includePreRelease:!!S.includePreRelease.find(pe=>(0,m.areSameExtensions)(pe,B))?.includePreRelease,oe=x(s),de=F(s.versions,S.targetPlatform);if(S.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(oe,S.targetPlatform))return null;for(let pe=0;pe<de.length;pe++){const ue=de[pe];if(!(K&&ue.version!==K)){if(await this.y(ue,Q?"any":"release",S.compatible,oe,S.targetPlatform))return H(s,ue,oe,z);if(K&&ue.version===K)return null}}return K||S.compatible?null:H(s,s.versions[0],oe)}async B(s,S){if(!this.isEnabled())throw new Error("No extension gallery service configured.");s=s.withFlags(s.flags,a.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(a.Unpublished));const z=await this.j,B=JSON.stringify(s.raw),K={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},Q=new Date().getTime();let oe,de,pe=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&s.criteria.some(ge=>ge.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:K},S),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:pe};const ue=await(0,g.asJson)(oe);if(ue){const ge=ue.results[0],ae=ge.extensions,fe=ge.resultMetadata&&ge.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return pe=fe&&fe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:pe,context:{[t]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(ue){throw de=ue,ue}finally{this.o.publicLog2("galleryService:query",{...s.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-Q,success:!!oe&&(0,g.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:de?(0,D.isCancellationError)(de)?"canceled":(0,D.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(s,S,z,B){if(!this.isEnabled())return;const K=C.isWeb?this.x(`/itemName/${s}.${S}/version/${z}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${s}/extensions/${S}/${z}/stats?statType=${B}`),Q=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:K,headers:de},A.CancellationToken.None)}catch{}}async download(s,S,z){this.l.trace("ExtensionGalleryService#download",s.identifier.id);const B=(0,m.getGalleryExtensionTelemetryData)(s),K=new Date().getTime(),Q=ge=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ge}),oe=z===2?"install":z===3?"update":"",de=oe?{uri:`${s.assets.download.uri}${f.URI.parse(s.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${s.assets.download.fallbackUri}${f.URI.parse(s.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:s.assets.download,pe=s.queryContext?.[t]?{[t]:s.queryContext[t]}:void 0,ue=await this.D(de,pe?{headers:pe}:void 0);await this.q.writeFile(S,ue.stream),Q(new Date().getTime()-K)}async downloadSignatureArchive(s,S){if(!s.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",s.identifier.id);const z=await this.D(s.assets.signature);await this.q.writeFile(S,z.stream)}async getReadme(s,S){if(s.assets.readme){const z=await this.D(s.assets.readme,{},S);return await(0,g.asTextOrError)(z)||""}return""}async getManifest(s,S){if(s.assets.manifest){const z=await this.D(s.assets.manifest,{},S),B=await(0,g.asTextOrError)(z);return B?JSON.parse(B):null}return null}async C(s,S){const z=ee(s,r.Manifest);if(!z)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},K=await this.D(z,{headers:B});return await(0,g.asJson)(K)}async getCoreTranslation(s,S){const z=s.assets.coreTranslations.filter(B=>B[0]===S.toUpperCase())[0];if(z){const B=await this.D(z[1]),K=await(0,g.asTextOrError)(B);return K?JSON.parse(K):null}return null}async getChangelog(s,S){if(s.assets.changelog){const z=await this.D(s.assets.changelog,{},S);return await(0,g.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(s,S,z){let B=new w().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);s.identifier.uuid?B=B.withFilter(i.ExtensionId,s.identifier.uuid):B=B.withFilter(i.ExtensionName,s.identifier.id);const{galleryExtensions:K}=await this.B(B,A.CancellationToken.None);if(!K.length)return[];const Q=x(K[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(Q,z))return[];const oe=[];await Promise.all(K[0].versions.map(async ue=>{try{await this.y(ue,S?"any":"release",!0,Q,z)&&oe.push(ue)}catch{}}));const de=[],pe=new Set;for(const ue of F(oe,z))pe.has(ue.version)||(pe.add(ue.version),de.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:he(ue)}));return de}async D(s,S={},z=A.CancellationToken.None){const B=await this.j,K={type:"GET"},Q={...B,...S.headers||{}};S={...S,...K,headers:Q};const oe=s.uri,de=s.fallbackUri,pe={...S,url:oe};try{const ue=await this.k.request(pe,z);if(ue.res.statusCode===200)return ue;const ge=await(0,g.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ge}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const ge=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ge});const ae={...S,url:de};return this.k.request(ae,z)}}async E(s){let S=re(s);if(!S){const z=await this.C(s,A.CancellationToken.None);if(!z)throw new Error("Manifest was not found");S=z.engines.vscode}return S}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const s=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,g.asJson)(s),z=[],B={};if(S){for(const K of S.malicious)z.push({id:K});if(S.migrateToPreRelease)for(const[K,Q]of Object.entries(S.migrateToPreRelease))(!Q.engine||(0,v.isEngineValid)(Q.engine,this.u.version,this.u.date))&&(B[K.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(S.deprecated)for(const[K,Q]of Object.entries(S.deprecated))Q&&(B[K.toLowerCase()]=(0,b.isBoolean)(Q)?{}:Q)}return{malicious:z,deprecated:B}}};X=ve([te(1,g.IRequestService),te(2,R.ILogService),te(3,P.IEnvironmentService),te(4,p.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],X);let M=class extends X{constructor(s,S,z,B,K,Q,oe,de){super(s,S,z,B,K,Q,oe,de)}};M=ve([te(0,y.IStorageService),te(1,g.IRequestService),te(2,R.ILogService),te(3,P.IEnvironmentService),te(4,p.ITelemetryService),te(5,N.IFileService),te(6,u.IProductService),te(7,c.IConfigurationService)],M),e.ExtensionGalleryService=M;let U=class extends X{constructor(s,S,z,B,K,Q,oe){super(void 0,s,S,z,B,K,Q,oe)}};U=ve([te(0,g.IRequestService),te(1,R.ILogService),te(2,P.IEnvironmentService),te(3,p.ITelemetryService),te(4,N.IFileService),te(5,u.IProductService),te(6,c.IConfigurationService)],U),e.ExtensionGalleryServiceWithNoStorageService=U}),define(ie[156],ne([0,1,11,18,13,6,137,27,21,3,68]),function(G,e,T,A,D,C,L,b,f,c,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=class Ve extends f.UserDataProfilesService{constructor(R,u,g,h,y){super(g,h,u,y),this.P=R,this.Q=g}J(){return this.P.getItem(Ve.b,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.s.extUri.joinPath(this.profilesHome,u.location):T.URI.revive(u.location)}))}M(){const R=this.P.getItem(Ve.c,{});return this.P.getItem(Ve.a,!1)?R:this.I(R)}O(){return this.s.extUri.joinPath(T.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};E.a="profileAssociationsMigration",E=ve([te(0,L.IStateReadService),te(1,b.IUriIdentityService),te(2,A.INativeEnvironmentService),te(3,D.IFileService),te(4,C.ILogService)],E),e.UserDataProfilesReadonlyService=E;let m=class ze extends E{constructor(R,u,g,h,y){super(R,u,g,h,y),this.W=R}L(R){R.length?this.W.setItem(ze.b,R.map(u=>({...u,location:this.s.extUri.basename(u.location)}))):this.W.removeItem(ze.b)}J(){const R=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(R),this.W.setItem("userDataProfilesMigration",!0)),R}N(R){R.emptyWindows||R.workspaces?this.W.setItem(ze.c,R):this.W.removeItem(ze.c)}M(){const R="workspaceAndProfileInfo",u=this.W.getItem(R,void 0);if(u){this.W.removeItem(R);const h=u.reduce((y,{workspace:p,profile:I})=>(y[T.URI.revive(p).toString()]=T.URI.revive(I).toString(),y),{});this.W.setItem(ze.c,{workspaces:h})}const g=super.M();return this.W.getItem(ze.a,!1)||(this.N(g),this.W.setItem(ze.a,!0)),g}};m=ve([te(0,L.IStateService),te(1,b.IUriIdentityService),te(2,A.INativeEnvironmentService),te(3,D.IFileService),te(4,C.ILogService)],m),e.UserDataProfilesService=m;let v=class extends m{constructor(R,u,g,h){super(new P.StateService(0,u,h,g),R,u,g,h)}async init(){return await this.W.init(),super.init()}};v=ve([te(0,b.IUriIdentityService),te(1,A.INativeEnvironmentService),te(2,D.IFileService),te(3,C.ILogService)],v),e.ServerUserDataProfilesService=v}),define(ie[49],ne([0,1,123,8,15,3,22,85,171,172]),function(G,e,T,A,D,C,L,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.ExtractError=E;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function v(t){if(t instanceof E)return t;let a;return P.test(t.message)&&(a="CorruptZip"),new E(a,t)}function N(t,a,n,i,r,o){const l=D.dirname(a),d=D.join(i,l);if(!d.startsWith(i))return Promise.reject(new Error(b.localize(0,null,a)));const w=D.join(i,a);let O;return o.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(L.Promises.mkdir(d,{recursive:!0})).then(()=>new Promise((j,Y)=>{if(!o.isCancellationRequested)try{O=(0,T.createWriteStream)(w,{mode:n}),O.once("close",()=>j()),O.once("error",Y),t.once("error",Y),t.pipe(O)}catch(J){Y(J)}}))}function R(t,a,n,i){let r=(0,A.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((l,d)=>{const w=new A.Sequencer,O=j=>{j.isCancellationRequested||(o++,t.readEntry())};t.once("error",d),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===o?l():d(new E("Incomplete",new Error(b.localize(1,null,o,t.entryCount))))},d)),t.readEntry(),t.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){O(i);return}const Y=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(Y)){const le=D.join(a,Y);r=(0,A.createCancelablePromise)(re=>L.Promises.mkdir(le,{recursive:!0}).then(()=>O(re)).then(void 0,d));return}const J=g(t,j),ee=m(j);r=(0,A.createCancelablePromise)(le=>w.queue(()=>J.then(re=>N(re,Y,ee,a,n,le).then(()=>O(le)))).then(null,d))})})}function u(t,a=!1){return new Promise((n,i)=>{(0,f.open)(t,a?{lazyEntries:!0}:void 0,(r,o)=>{r?i(v(r)):n((0,C.assertIsDefined)(o))})})}function g(t,a){return new Promise((n,i)=>{t.openReadStream(a,(r,o)=>{r?i(v(r)):n((0,C.assertIsDefined)(o))})})}function h(t,a){return new Promise((n,i)=>{const r=new c.ZipFile;a.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const o=(0,T.createWriteStream)(t);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(t))})}e.zip=h;function y(t,a,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=u(t,!0);return n.overwrite&&(o=o.then(l=>L.Promises.rm(a).then(()=>l))),o.then(l=>R(l,a,{sourcePathRegex:r},i))}e.extract=y;function p(t,a){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===a&&g(n,o).then(l=>i(l),l=>r(l))}),n.once("close",()=>r(new Error(b.localize(2,null,a))))}))}function I(t,a){return p(t,a).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",l=>o.push(l)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=I}),define(ie[157],ne([0,1,8,9,2,16,12,17,41,3,28,22,49,24,18,20,26,60,13,6]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class $e extends D.Disposable{constructor(t,a,n,i,r,o){super(),this.h=a,this.i=n,this.j=i,this.k=r,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,a,n){await this.g;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,o=>this.i.download(t,o,a))}catch(o){throw new R.ExtensionManagementError(o.message,R.ExtensionManagementErrorCode.Download)}let r=!1;if(n&&this.m(t)){const o=await this.n(t);try{r=await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===y.LogLevel.Trace)}catch(l){const d=l;if(r=d.code,d.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${d.output}`),r===R.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===R.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new R.ExtensionManagementError(m.CorruptZipMessage,R.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(l){this.l.error(l)}}}return r===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):r===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${r}': ${t.identifier.id}`),{location:i,verificationStatus:r}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(a)?a:!0}async n(t){await this.g;const a=(0,b.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${$e.c}`);return await this.r(t,a,n=>this.i.downloadSignatureArchive(t,n)),a}async r(t,a,n){if(await this.h.exists(a))return;if(a.scheme!==C.Schemas.file){await n(a);return}const i=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await n(i);try{await this.t(i,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(i)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,A.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.g,await this.h.del(t)}async t(t,a,n){try{await E.Promises.rename(t.fsPath,a.fsPath)}catch(i){if(L.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.t(t,a,n);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],n=[],i=[];for(const l of t.children)if(l.name.endsWith($e.c))i.push(l.resource);else{const d=u.ExtensionKey.parse(l.name);d&&n.push([d,l])}const r=(0,u.groupByExtension)(n,([l])=>l),o=[];for(const l of r)l.sort((d,w)=>f.rcompare(d[0].version,w[0].version)),a.push(...l.slice(1).map(d=>d[1].resource)),o.push(l[0][1]);o.sort((l,d)=>l.mtime-d.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),a.push(...i),await T.Promises.settled(a.map(l=>(this.l.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.l.error(t)}}v(t){return this.f?u.ExtensionKey.create(t).toString().toLowerCase():(0,P.generateUuid)()}};p.c=".sigzip",p=ve([te(0,N.INativeEnvironmentService),te(1,h.IFileService),te(2,R.IExtensionGalleryService),te(3,v.IConfigurationService),te(4,g.IExtensionSignatureVerificationService),te(5,y.ILogService)],p),e.ExtensionsDownloader=p}),define(ie[158],ne([0,1,49,95]),function(G,e,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(C){return(0,T.buffer)(C,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.getManifest=D}),define(ie[159],ne([0,1,8,14,23,33,9,5,2,35,16,15,12,17,41,3,11,28,22,49,94,59,18,150,20,26,40,48,157,151,158,132,139,46,13,10,6,31,25,27,21]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y,p,I,t,a,n,i,r,o,l,d,w,O,j,Y,J,ee,le,re,he,ce,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(n.IExtensionManagementService);let $=class extends a.AbstractExtensionManagementService{constructor(M,U,k,s,S,z,B,K,Q,oe,de,pe){super(M,U,k,oe,pe),this.Z=S,this.ab=z,this.bb=B,this.cb=Q,this.db=de,this.X=this.B(new b.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const ue=this.B(K.createInstance(d.ExtensionsLifecycle));this.S=this.B(K.createInstance(q,ae=>ue.postUninstall(ae))),this.U=this.B(new O.ExtensionsManifestCache(pe,Q,de,this,this.v)),this.W=this.B(K.createInstance(l.ExtensionsDownloader));const ge=this.B(new j.ExtensionsWatcher(this,this.Z,pe,z,de,Q,k));this.B(ge.onDidChangeExtensionsByAnotherSource(ae=>this.kb(ae))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(M){this.v.trace("ExtensionManagementService#zip",M.identifier.id);const U=await this.jb(M),k=await(0,y.zip)((0,v.joinPath)(this.W.extensionsDownloadDir,(0,g.generateUuid)()).fsPath,U);return u.URI.file(k)}async unzip(M){return this.v.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:U,cleanup:k}=await this.fb(M),s=E.resolve(U.fsPath);try{return await(0,w.getManifest)(s)}finally{await k()}}getInstalled(M,U=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(M??null,U)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.S.scanUserExtensionAtLocation(M)}async install(M,U={}){this.v.trace("ExtensionManagementService#install",M.toString());const{location:k,cleanup:s}=await this.fb(M);try{const S=await(0,w.getManifest)(E.resolve(k.fsPath));if(S.engines&&S.engines.vscode&&!(0,Y.isEngineValid)(S.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,i.getGalleryExtensionId)(S.publisher,S.name),this.w.version));return await this.z(S,k,U)}finally{await s()}}async installFromLocation(M,U){this.v.trace("ExtensionManagementService#installFromLocation",M.toString());const k=await this.S.scanUserExtensionAtLocation(M);if(!k)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.ob([[k,void 0]],U),this.v.info("Successfully installed extension",k.identifier.id,U.toString()),k}async installExtensionsFromProfile(M,U,k){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",M,U.toString(),k.toString());const s=(await this.S.scanExtensions(1,U)).filter(S=>M.some(z=>(0,i.areSameExtensions)(z,S.identifier)));if(s.length){const S=await Promise.all(s.map(z=>this.S.scanMetadata(z,U)));await this.ob(s.map((z,B)=>[z,S[B]]),k),this.v.info("Successfully installed extensions",s.map(z=>z.identifier.id),k.toString())}return s}async updateMetadata(M,U,k=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",M.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.pinned=U.pinned||void 0,M=await this.S.updateMetadata(M,U,k),this.U.invalidate(k),this.X.fire(M),M}async reinstallFromGallery(M){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const U=await this.getTargetPlatform(),[k]=await this.t.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:U,compatible:!0},D.CancellationToken.None);if(!k)throw new Error(p.localize(2,null));await this.S.setUninstalled(M);try{await this.S.removeUninstalledExtension(M)}catch(s){throw new Error(p.localize(3,null,(0,C.toErrorMessage)(s)))}return this.installFromGallery(k)}copyExtensions(M,U){return this.S.copyExtensions(M,U)}markAsUninstalled(...M){return this.S.setUninstalled(...M)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(M){this.v.error(M)}}async download(M,U,k){const{location:s}=await this.W.download(M,U,!k);return s}async fb(M){if(M.scheme===P.Schemas.file)return{location:M,async cleanup(){}};this.v.trace("Downloading extension from",M.toString());const U=(0,v.joinPath)(this.W.extensionsDownloadDir,(0,g.generateUuid)());return await this.bb.download(M,U),this.v.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.cb.del(U)}catch(s){this.v.error(s)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(M,U,k){if(u.URI.isUri(U))return new W(M,U,k,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const s=i.ExtensionKey.create(U).toString();let S=this.Y.get(s);return S||(this.Y.set(s,S=new F(M,U,k,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),S.waitUntilTaskIsFinished().finally(()=>this.Y.delete(s))),S}R(M,U){return new H(M,U.profileLocation,this.ab)}async jb(M){const U=async s=>{let S=await h.Promises.readdir(s);S=S.map(K=>E.join(s,K));const z=await Promise.all(S.map(K=>h.Promises.stat(K)));let B=Promise.resolve([]);return z.forEach((K,Q)=>{const oe=S[Q];K.isFile()&&(B=B.then(de=>[...de,oe])),K.isDirectory()&&(B=B.then(de=>U(oe).then(pe=>[...de,...pe])))}),B};return(await U(M.location.fsPath)).map(s=>({path:`extension/${E.relative(M.location.fsPath,s)}`,localPath:s}))}async kb({added:M,removed:U}){if(U)for(const k of U.extensions)this.v.info("Extensions removed from another source",k.id,U.profileLocation.toString()),this.p.fire({identifier:k,profileLocation:U.profileLocation});if(M){const s=(await this.S.scanExtensions(1,M.profileLocation)).filter(S=>M.extensions.some(z=>(0,i.areSameExtensions)(z,S.identifier)));this.m.fire(s.map(S=>(this.v.info("Extensions added from another source",S.identifier.id,M.profileLocation.toString()),{identifier:S.identifier,local:S,profileLocation:M.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(U=>this.lb.add(U)));const M=await this.cb.resolve(this.Z.userExtensionsLocation);for(const U of M.children??[])U.isDirectory&&this.lb.add(U.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(U=>this.nb(U)))}async nb(M){if(!M.affects(this.Z.userExtensionsLocation,1))return;const U=[];for(const k of M.rawAdded){if(this.lb.has(k)||!this.db.extUri.isEqual(this.db.extUri.dirname(k),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(k,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(k).startsWith(".")||!(await this.cb.stat(k)).isDirectory)continue;const s=await this.S.scanUserExtensionAtLocation(k);s&&s.installedTimestamp===void 0&&(this.lb.add(k),U.push(s))}U.length&&(await this.ob(U.map(k=>[k,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",U.map(k=>k.identifier.id)))}async ob(M,U){const k=M.map(s=>s[0]);await this.pb(k),await this.ab.addExtensionsToProfile(M,U),this.m.fire(k.map(s=>({local:s,identifier:s.identifier,operation:1,profileLocation:U})))}async pb(M){const U=await this.S.getUninstalledExtensions();for(const k of M){const s=i.ExtensionKey.create(k);!U[s.toString()]||(this.v.trace("Removing the extension from uninstalled list:",s.id),await this.S.setInstalled(s),this.v.info("Removed the extension from uninstalled list:",s.id))}}};$=ve([te(0,n.IExtensionGalleryService),te(1,he.ITelemetryService),te(2,le.ILogService),te(3,t.INativeEnvironmentService),te(4,o.IExtensionsScannerService),te(5,r.IExtensionsProfileScannerService),te(6,I.IDownloadService),te(7,ee.IInstantiationService),te(8,J.IFileService),te(9,re.IProductService),te(10,ce.IUriIdentityService),te(11,se.IUserDataProfilesService)],$),e.ExtensionManagementService=$;let q=class extends f.Disposable{constructor(M,U,k,s,S,z){super(),this.k=M,this.l=U,this.m=k,this.n=s,this.p=S,this.s=z,this.h=this.B(new b.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,v.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new T.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(M,U){const k={includeInvalid:!0,profileLocation:U};let s=[];return M===null||M===0?s.push(...await this.m.scanAllExtensions({includeInvalid:!0},k,!1)):M===1&&s.push(...await this.m.scanUserExtensions(k)),s=M!==null?s.filter(S=>S.type===M):s,Promise.all(s.map(S=>this.y(S)))}async scanAllUserExtensions(M){const U=await this.m.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(U.map(k=>this.y(k)))}async scanUserExtensionAtLocation(M){try{const U=await this.m.scanExistingExtension(M,1,{includeInvalid:!0});if(U)return await this.y(U)}catch(U){this.s.error(U)}return null}async extractUserExtension(M,U,k,s){await this.j.catch(()=>{});const S=M.toString(),z=E.join(this.m.userExtensionsLocation.fsPath,`.${(0,g.generateUuid)()}`),B=E.join(this.m.userExtensionsLocation.fsPath,S);try{await h.Promises.rm(B)}catch{throw new n.ExtensionManagementError(p.localize(4,null,B,M.id),n.ExtensionManagementErrorCode.Delete)}await this.u(M,U,z,s),await this.m.updateMetadata(u.URI.file(z),k);try{this.h.fire(u.URI.file(B)),await this.v(M,z,B,Date.now()+2*60*1e3),this.s.info("Renamed to",B)}catch(K){try{await h.Promises.rm(z)}catch{}if(K.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.s.info(`Rename failed because of ${(0,L.getErrorMessage)(K)}. Deleted from extracted location`,z),K}return this.w(u.URI.file(B),1)}async scanMetadata(M,U){return U?(await this.n.scanProfileExtensions(U)).find(s=>(0,i.areSameExtensions)(s.identifier,M.identifier))?.metadata:this.m.scanMetadata(M.location)}async updateMetadata(M,U,k){return k?await this.n.updateMetadata([[M,U]],k):await this.m.updateMetadata(M.location,U),this.w(M.location,M.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...M){const U=M.map(k=>i.ExtensionKey.create(k));await this.t(k=>U.forEach(s=>{k[s.toString()]=!0,this.s.info("Marked extension as uninstalled",s.toString())}))}async setInstalled(M){await this.t(U=>delete U[M.toString()])}async removeExtension(M,U){this.s.trace(`Deleting ${U} extension from disk`,M.identifier.id,M.location.fsPath);const k=this.p.extUri.joinPath(this.p.extUri.dirname(M.location),`.${(0,g.generateUuid)()}`);await this.v(M.identifier,M.location.fsPath,k.fsPath,Date.now()+2*60*1e3),await this.l.del(k,{recursive:!0}),this.s.info("Deleted from disk",M.identifier.id,M.location.fsPath)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.t(U=>delete U[i.ExtensionKey.create(M).toString()])}async copyExtensions(M,U){const k=await this.scanExtensions(1,M),s=await Promise.all(k.filter(S=>!S.isApplicationScoped).map(async S=>[S,await this.scanMetadata(S,M)]));await this.n.addExtensionsToProfile(s,U)}async t(M){return this.g.queue(async()=>{let U;try{U=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(s){if((0,J.toFileOperationResult)(s)!==1)throw s}let k={};if(U)try{k=JSON.parse(U)}catch{}return M&&(M(k),Object.keys(k).length?await this.l.writeFile(this.c,A.VSBuffer.fromString(JSON.stringify(k))):await this.l.del(this.c)),k})}async u(M,U,k,s){this.s.trace(`Started extracting the extension from ${U} to ${k}`);try{await h.Promises.rm(k)}catch(S){throw new n.ExtensionManagementError(this.D(S).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(U,k,{sourcePath:"extension",overwrite:!0},s),this.s.info(`Extracted extension to ${k}:`,M.id)}catch(S){try{await h.Promises.rm(k)}catch{}let z=n.ExtensionManagementErrorCode.Extract;throw S instanceof y.ExtractError&&(S.type==="CorruptZip"?z=n.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(z=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(S.message,z)}}async v(M,U,k,s){try{await h.Promises.rename(U,k)}catch(S){if(m.isWindows&&S&&S.code==="EPERM"&&Date.now()<s)return this.s.info(`Failed renaming ${U} to ${k} with 'EPERM' error. Trying again...`,M.id),this.v(M,U,k,s);throw new n.ExtensionManagementError(S.message||p.localize(5,null,U,k),S.code||n.ExtensionManagementErrorCode.Rename)}}async w(M,U){const k=await this.m.scanExistingExtension(M,U,{includeInvalid:!0});if(k)return this.y(k);throw new Error(p.localize(6,null,M.path))}async y(M){const U=await this.l.resolve(M.location);let k,s;return U.children&&(k=U.children.find(({name:S})=>/^readme(\.txt|\.md|)$/i.test(S))?.resource,s=U.children.find(({name:S})=>/^changelog(\.txt|\.md|)$/i.test(S))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:k,changelogUrl:s,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async z(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(M));const U=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const S of U)M[i.ExtensionKey.create(S).toString()]||k.add(S.identifier.id.toLowerCase());try{const S=(0,i.groupByExtension)(U,z=>z.identifier);await T.Promises.settled(S.map(async z=>{const B=z.sort((K,Q)=>N.rcompare(K.manifest.version,Q.manifest.version))[0];k.has(B.identifier.id.toLowerCase())||await this.k(await this.y(B))}))}catch(S){this.s.error(S)}const s=U.filter(S=>S.metadata&&M[i.ExtensionKey.create(S).toString()]);await Promise.allSettled(s.map(S=>this.removeUninstalledExtension(S)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const M=[];let U;try{U=await this.l.resolve(this.m.userExtensionsLocation)}catch(k){(0,J.toFileOperationResult)(k)!==1&&this.s.error(k)}for(const k of U?.children??[])k.isDirectory&&k.name.startsWith(".")&&(0,g.isUUID)(k.name.substring(1))&&M.push((async()=>{this.s.trace("Deleting the generated extension folder",k.resource.toString());try{await this.l.del(k.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",k.resource.toString())}catch(s){this.s.error(s)}})());await Promise.allSettled(M)}D(M){const U=Array.isArray(M)?M:[M];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((k,s)=>new Error(`${k.message}${k.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}};q=ve([te(1,J.IFileService),te(2,o.IExtensionsScannerService),te(3,r.IExtensionsProfileScannerService),te(4,ce.IUriIdentityService),te(5,le.ILogService)],q),e.ExtensionsScanner=q;class x extends a.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(M,U,k,s,S,z,B,K,Q){super(),this.identifier=M,this.source=U,this.m=k,this.n=s,this.o=S,this.p=z,this.q=B,this.s=K,this.t=Q,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(M){const[U,k]=await this.y(M);return this.j=U.isBuiltin||U.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[U,k]],this.j),U}async v({zipPath:M,key:U,metadata:k},s){let S=await this.w(U);return S||(this.t.trace("Extracting extension...",U.id),S=await this.n.extractUserExtension(U,M,k,s),this.t.info("Extracting extension completed.",U.id)),S}async w(M){return await this.x(M)?(this.t.trace("Removing the extension from uninstalled list:",M.id),await this.n.setInstalled(M),this.t.info("Removed the extension from uninstalled list:",M.id),(await this.n.scanAllUserExtensions(!0)).find(s=>i.ExtensionKey.create(s).equals(M))):void 0}async x(M){return!!(await this.n.getUninstalledExtensions())[M.toString()]}}class F extends x{constructor(M,U,k,s,S,z,B,K,Q,oe){super(U.identifier,U,k,S,z,B,K,Q,oe),this.z=U,this.A=s}async y(M){const k=(await this.n.scanExtensions(null,this.m.profileLocation)).find(B=>(0,i.areSameExtensions)(B.identifier,this.z.identifier));k&&(this.l=3);const s={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||k?.isMachineScoped,isBuiltin:this.m.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,R.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.z.version)return[await this.n.updateMetadata(k,s),s];const{location:S,verificationStatus:z}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=z,this.C(S.fsPath),[await this.v({zipPath:S.fsPath,key:i.ExtensionKey.create(this.z),metadata:s},M),s]}catch(B){try{await this.A.delete(S)}catch(K){this.t.warn("Error while deleting the downloaded file",S.toString(),(0,L.getErrorMessage)(K))}throw B}}async C(M){try{await(0,w.getManifest)(M)}catch(U){throw new n.ExtensionManagementError((0,a.joinErrors)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=F;class W extends x{constructor(M,U,k,s,S,z,B,K,Q,oe){super({id:(0,i.getGalleryExtensionId)(M.publisher,M.name)},U,k,S,z,B,K,Q,oe),this.z=M,this.A=U,this.B=s}async h(M){const U=await super.h(M);return this.E(U,M),U}async y(M){const U=new i.ExtensionKey(this.identifier,this.z.version),s=(await this.n.scanExtensions(1,this.m.profileLocation)).find(B=>(0,i.areSameExtensions)(this.identifier,B.identifier)),S={isApplicationScoped:this.m.isApplicationScoped||s?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||s?.isMachineScoped,isBuiltin:this.m.isBuiltin||s?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(s)if(this.l=3,U.equals(new i.ExtensionKey(s.identifier,s.manifest.version)))try{await this.n.removeExtension(s,"existing")}catch{throw new Error(p.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&N.gt(s.manifest.version,this.z.version)&&await this.n.setUninstalled(s);else{const B=await this.w(U);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(p.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:E.resolve(this.A.fsPath),key:U,metadata:S},M),S]}async E(M,U){try{let[k]=await this.B.getExtensions([{id:M.identifier.id,version:M.manifest.version}],U);if(k||([k]=await this.B.getExtensions([{id:M.identifier.id}],U)),k){const s={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(M,s,this.m.profileLocation)}}catch{}}}class H extends a.AbstractExtensionTask{constructor(M,U,k){super(),this.extension=M,this.j=U,this.k=k}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,135,8,14,9,3,24,18,136,6,43,134,173]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let N=class extends E.AbstractRequestService{constructor(h,y,p,I){super(!!y.isRemoteServer,I),this.j=h,this.k=y,this.l=p,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,y){const{f:p,g:I}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,C.getErrorMessage)(i)))}const a={...process.env,...t},n=h.agent?h.agent:await(0,m.getProxyAgent)(h.url||"",a,{proxyUrl:p,strictSSL:I});return h.agent=n,h.strictSSL=I,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>u(h,y))}async resolveProxy(h){}};N=ve([te(0,b.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,P.ILogService),te(3,P.ILoggerService)],N),e.RequestService=N;async function R(g){return((0,T.parse)(g.url).protocol==="https:"?await new Promise((p,I)=>{G(["https"],p,I)}):await new Promise((p,I)=>{G(["http"],p,I)})).request}async function u(g,h){return A.Promises.withAsyncBody(async(y,p)=>{const I=(0,T.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await R(g),a={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,L.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password);const n=t(a,i=>{const r=(0,L.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)u({...g,url:i.headers.location,followRedirects:r-1},h).then(y,p);else{let o=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,v.createGunzip)())),y({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});n.on("error",p),g.timeout&&n.setTimeout(g.timeout),g.isChromiumNetwork&&n.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&n.write(g.data),n.end(),h.onCancellationRequested(()=>{n.abort(),p(new C.CancellationError)})})}e.nodeRequest=u}),define(ie[174],ne([0,1,32,8,33,9,2,16,15,12,34,11,22,24,131,59,133,18,109,155,20,60,138,40,48,159,153,13,120,122,47,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,21,156,147,152,124,126,4]),function(G,e,T,A,D,C,L,b,f,c,P,E,m,v,N,R,u,g,h,y,p,I,t,a,n,i,r,o,l,d,w,O,j,Y,J,ee,le,re,he,ce,se,$,q,x,F,W,H,X,M,U,k,s,S,z,B,K,Q,oe,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends L.Disposable{constructor(ae){super(),this.b=ae,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ae,fe]=await this.f();return ae.invokeFunction(async we=>{const Re=we.get(ee.ILogService),Ce=we.get(o.IFileService),Fe=we.get(g.INativeEnvironmentService),V=we.get(S.IUserDataProfilesService);Re.info("CLI main",this.b),this.g(Re),await this.h(Fe,Ce,V,ae),await Promise.all(fe.map(Z=>{(0,A.raceTimeout)(Z.flush(),1e3)}))})}async f(){const ae=new j.ServiceCollection,fe={_serviceBrand:void 0,...ce.default};ae.set(se.IProductService,fe);const we=new h.NativeEnvironmentService(this.b,fe);ae.set(g.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(Ie=>Ie?m.Promises.mkdir(Ie,{recursive:!0}):void 0));const Re=new oe.LoggerService((0,ee.getLogLevel)(we),we.logsHome);ae.set(ee.ILoggerService,Re);const Ce=this.B(Re.createLogger("cli",{name:(0,de.localize)(0,null)})),Fe=[];Re.getLogLevel()===ee.LogLevel.Trace&&Fe.push(new ee.ConsoleLogger(Re.getLogLevel()));const V=this.B(new Q.LogService(Ce,Fe));ae.set(ee.ILogService,V);const Z=this.B(new l.FileService(V));ae.set(o.IFileService,Z);const _=this.B(new d.DiskFileSystemProvider(V));Z.registerProvider(b.Schemas.file,_);const me=new s.UriIdentityService(Z);ae.set(k.IUriIdentityService,me);const ye=new x.StateReadonlyService(1,we,V,Z),Oe=new z.UserDataProfilesReadonlyService(ye,me,we,Z,V);ae.set(S.IUserDataProfilesService,Oe);const be=c.isWindows&&fe.win32RegValueName?this.B(new he.NativePolicyService(V,fe.win32RegValueName)):we.policyFile?this.B(new le.FilePolicyService(we.policyFile,Z,V)):new re.NullPolicyService;ae.set(re.IPolicyService,be);const Le=this.B(new N.ConfigurationService(Oe.defaultProfile.settingsResource,Z,be,V));ae.set(v.IConfigurationService,Le),await Promise.all([ye.init(),Le.initialize()]);let De;try{De=await(0,B.resolveMachineId)(ye,V)}catch(Ie){Ie.code!=="ENOENT"&&V.error(Ie)}Oe.init(),ae.set(k.IUriIdentityService,new s.UriIdentityService(Z)),ae.set($.IRequestService,new w.SyncDescriptor(q.RequestService,void 0,!0)),ae.set(R.IDownloadService,new w.SyncDescriptor(u.DownloadService,void 0,!0)),ae.set(a.IExtensionsProfileScannerService,new w.SyncDescriptor(K.ExtensionsProfileScannerService,void 0,!0)),ae.set(n.IExtensionsScannerService,new w.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),ae.set(I.IExtensionSignatureVerificationService,new w.SyncDescriptor(I.ExtensionSignatureVerificationService,void 0,!0)),ae.set(i.INativeServerExtensionManagementService,new w.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),ae.set(p.IExtensionGalleryService,new w.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ae.set(Y.ILanguagePackService,new w.SyncDescriptor(J.NativeLanguagePackService,void 0,!1));const Ne=[],je=(0,X.isInternalTelemetry)(fe,Le);if((0,X.supportsTelemetry)(fe,we)){fe.aiConfig&&fe.aiConfig.ariaKey&&Ne.push(new M.OneDataSystemAppender(je,"monacoworkbench",null,fe.aiConfig.ariaKey));const Ie={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)((0,T.release)(),(0,T.hostname)(),process.arch,fe.commit,fe.version,De,je),piiPaths:(0,X.getPiiPathsFromEnvironment)(we)};ae.set(W.ITelemetryService,new w.SyncDescriptor(H.TelemetryService,[Ie],!1))}else ae.set(W.ITelemetryService,X.NullTelemetryService);return[new O.InstantiationService(ae),Ne]}g(ae){(0,C.setUnexpectedErrorHandler)(fe=>{const we=(0,D.toErrorMessage)(fe,!0);!we||ae.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",fe=>{(0,C.isSigPipeError)(fe)||(0,C.onUnexpectedError)(fe)}),process.on("unhandledRejection",fe=>(0,C.onUnexpectedError)(fe))}async h(ae,fe,we,Re){let Ce;if(ae.args.profile&&(Ce=we.profiles.find(V=>V.name===ae.args.profile),!Ce))throw new Error(`Profile '${ae.args.profile}' not found.`);const Fe=(Ce??we.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Re.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const V={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Re.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),V,!!this.b.force)}else{if(this.b["uninstall-extension"])return Re.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Re.createInstance(t.ExtensionManagementCLI,new ee.ConsoleLogger(ee.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.buildTelemetryMessage)(ae.appRoot,ae.extensionsPath))}}i(ae){return ae.map(fe=>/\.vsix$/i.test(fe)?E.URI.file((0,f.isAbsolute)(fe)?fe:(0,f.join)((0,P.cwd)(),fe)):fe)}}async function ue(ge){const ae=new pe(ge);try{await ae.run()}finally{ae.dispose()}}e.main=ue})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/node/cliProcessMain.js.map
