/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","path","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ie){for(var e=[],L=0,N=ie.length;L<N;L++)e[L]=oe[ie[L]];return e};define(oe[62],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(T){return(D,I,S)=>{let P=null,b=null;if(typeof S.value=="function"?(P="value",b=S.value):typeof S.get=="function"&&(P="get",b=S.get),!b)throw new Error("not supported");S[P]=T(b,I)}}function N(T,D,I){let S=null,P=null;if(typeof I.value=="function"?(S="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",P=I.get),!P)throw new Error("not supported");const b=`$memoize$${D}`;I[S]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[b]}}e.memoize=N;function c(T,D,I){return L((S,P)=>{const b=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...d){this[m]||(this[m]=I?I():void 0),clearTimeout(this[b]),D&&(this[m]=D(this[m],...d),d=[this[m]]),this[b]=setTimeout(()=>{S.apply(this,d),this[m]=I?I():void 0},T)}})}e.debounce=c;function O(T,D,I){return L((S,P)=>{const b=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...E){if(this[m]||(this[m]=I?I():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),D&&(this[m]=D(this[m],...E)),this[p])return;const l=this[d]+T;l<=Date.now()?(this[d]=Date.now(),S.apply(this,[this[m]]),this[m]=I?I():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[d]=Date.now(),S.apply(this,[this[m]]),this[m]=I?I():void 0},l-Date.now()))}})}e.throttle=O}),define(oe[10],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(n=>{n(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=L,e.errorHandler=new L;function N(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=N;function c(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=c;function O(i){S(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=O;function T(i){S(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=T;function D(i){if(i instanceof Error){const{name:o,message:n}=i,t=i.stacktrace||i.stack;return{$isError:!0,name:o,message:n,stack:t,noTelemetry:y.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=D;const I="Canceled";function S(i){return i instanceof P?!0:i instanceof Error&&i.name===I&&i.message===I}e.isCancellationError=S;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function b(){const i=new Error(I);return i.name=i.message,i}e.canceled=b;function m(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=m;function d(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=d;function p(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function E(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function l(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=l;class f extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=f;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const n=new y;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class k extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}e.BugIndicatingError=k}),define(oe[21],ae([0,1,10]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function N(B,_=0){return B[B.length-(1+_)]}e.tail=N;function c(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=c;function O(B,_,te=(ce,he)=>ce===he){if(B===_)return!0;if(!B||!_||B.length!==_.length)return!1;for(let ce=0,he=B.length;ce<he;ce++)if(!te(B[ce],_[ce]))return!1;return!0}e.equals=O;function T(B,_){const te=B.length-1;_<te&&(B[_]=B[te]),B.pop()}e.removeFastWithoutKeepingOrder=T;function D(B,_,te){return I(B.length,ce=>te(B[ce],_))}e.binarySearch=D;function I(B,_){let te=0,ce=B-1;for(;te<=ce;){const he=(te+ce)/2|0,pe=_(he);if(pe<0)te=he+1;else if(pe>0)ce=he-1;else return he}return-(te+1)}e.binarySearch2=I;function S(B,_){let te=0,ce=B.length;if(ce===0)return 0;for(;te<ce;){const he=Math.floor((te+ce)/2);_(B[he])?ce=he:te=he+1}return te}e.findFirstInSorted=S;function P(B,_,te){if(B=B|0,B>=_.length)throw new TypeError("invalid index");const ce=_[Math.floor(_.length*Math.random())],he=[],pe=[],de=[];for(const Se of _){const Ce=te(Se,ce);Ce<0?he.push(Se):Ce>0?pe.push(Se):de.push(Se)}return B<he.length?P(B,he,te):B<he.length+de.length?de[0]:P(B-(he.length+de.length),pe,te)}e.quickSelect=P;function b(B,_){const te=[];let ce;for(const he of B.slice(0).sort(_))!ce||_(ce[0],he)!==0?(ce=[he],te.push(ce)):ce.push(he);return te}e.groupBy=b;function m(B,_,te){const ce=[];function he(Se,Ce,De){if(Ce===0&&De.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===Se?(ke.deleteCount+=Ce,ke.toInsert.push(...De)):ce.push({start:Se,deleteCount:Ce,toInsert:De})}let pe=0,de=0;for(;;){if(pe===B.length){he(pe,0,_.slice(de));break}if(de===_.length){he(pe,B.length-pe,[]);break}const Se=B[pe],Ce=_[de],De=te(Se,Ce);De===0?(pe+=1,de+=1):De<0?(he(pe,1,[]),pe+=1):De>0&&(he(pe,0,[Ce]),de+=1)}return ce}e.sortedDiff=m;function d(B,_,te){const ce=m(B,_,te),he=[],pe=[];for(const de of ce)he.push(...B.slice(de.start,de.start+de.deleteCount)),pe.push(...de.toInsert);return{removed:he,added:pe}}e.delta=d;function p(B,_,te){if(te===0)return[];const ce=B.slice(0,te).sort(_);return l(B,_,ce,te,B.length),ce}e.top=p;function E(B,_,te,ce,he){return te===0?Promise.resolve([]):new Promise((pe,de)=>{(async()=>{const Se=B.length,Ce=B.slice(0,te).sort(_);for(let De=te,ke=Math.min(te+ce,Se);De<Se;De=ke,ke=Math.min(ke+ce,Se)){if(De>te&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new L.CancellationError;l(B,_,Ce,De,ke)}return Ce})().then(pe,de)})}e.topAsync=E;function l(B,_,te,ce,he){for(const pe=te.length;ce<he;ce++){const de=B[ce];if(_(de,te[pe-1])<0){te.pop();const Se=S(te,Ce=>_(de,Ce)<0);te.splice(Se,0,de)}}}function f(B){return B.filter(_=>!!_)}e.coalesce=f;function u(B){let _=0;for(let te=0;te<B.length;te++)B[te]&&(B[_]=B[te],_+=1);B.length=_}e.coalesceInPlace=u;function g(B,_,te){B.splice(te,0,B.splice(_,1)[0])}e.move=g;function y(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=y;function k(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=k;function i(B,_=te=>te){const te=new Set;return B.filter(ce=>{const he=_(ce);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=i;function o(B){const _=new Set;return te=>{const ce=B(te);return _.has(ce)?!1:(_.add(ce),!0)}}e.uniqueFilter=o;function n(B,_){const te=t(B,_);if(te!==-1)return B[te]}e.findLast=n;function t(B,_){for(let te=B.length-1;te>=0;te--){const ce=B[te];if(_(ce))return te}return-1}e.lastIndex=t;function s(B,_){return B.length>0?B[0]:_}e.firstOrDefault=s;function r(B,_){return B.length>0?B[B.length-1]:_}e.lastOrDefault=r;function a(B,_,te=(ce,he)=>ce===he){let ce=0;for(let he=0,pe=Math.min(B.length,_.length);he<pe&&te(B[he],_[he]);he++)ce++;return ce}e.commonPrefixLength=a;function h(B){return[].concat(...B)}e.flatten=h;function w(B,_){let te=typeof _=="number"?B:0;typeof _=="number"?te=B:(te=0,_=B);const ce=[];if(te<=_)for(let he=te;he<_;he++)ce.push(he);else for(let he=te;he>_;he--)ce.push(he);return ce}e.range=w;function v(B,_,te){return B.reduce((ce,he)=>(ce[_(he)]=te?te(he):he,ce),Object.create(null))}e.index=v;function R(B,_){return B.push(_),()=>A(B,_)}e.insert=R;function A(B,_){const te=B.indexOf(_);if(te>-1)return B.splice(te,1),_}e.remove=A;function M(B,_,te){const ce=B.slice(0,_),he=B.slice(_);return ce.concat(te,he)}e.arrayInsert=M;function $(B,_){let te;if(typeof _=="number"){let ce=_;te=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let ce=B.length-1;ce>0;ce-=1){const he=Math.floor(te()*(ce+1)),pe=B[ce];B[ce]=B[he],B[he]=pe}}e.shuffle=$;function V(B,_){const te=B.indexOf(_);te>-1&&(B.splice(te,1),B.unshift(_))}e.pushToStart=V;function q(B,_){const te=B.indexOf(_);te>-1&&(B.splice(te,1),B.push(_))}e.pushToEnd=q;function W(B,_){for(const te of _)B.push(te)}e.pushMany=W;function X(B,_){return Array.isArray(B)?B.map(_):_(B)}e.mapArrayOrNot=X;function Q(B){return Array.isArray(B)?B:[B]}e.asArray=Q;function Y(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Y;function Z(B,_){for(const te of B){const ce=_(te);if(ce!==void 0)return ce}}e.mapFind=Z;function x(B,_,te){const ce=ee(B,_),he=B.length,pe=te.length;B.length=he+pe;for(let de=he-1;de>=ce;de--)B[de+pe]=B[de];for(let de=0;de<pe;de++)B[de+ce]=te[de]}e.insertInto=x;function j(B,_,te,ce){const he=ee(B,_),pe=B.splice(he,te);return x(B,he,ce),pe}e.splice=j;function ee(B,_){return _<0?Math.max(_+B.length,0):Math.min(_,B.length)}var ne;(function(B){function _(he){return he<0}B.isLessThan=_;function te(he){return he>0}B.isGreaterThan=te;function ce(he){return he===0}B.isNeitherLessOrGreaterThan=ce,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function re(B,_){return(te,ce)=>_(B(te),B(ce))}e.compareBy=re;function G(...B){return(_,te)=>{for(const ce of B){const he=ce(_,te);if(!ne.isNeitherLessOrGreaterThan(he))return he}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=G;const H=(B,_)=>B-_;e.numberComparator=H;function F(B,_){if(B.length===0)return;let te=B[0];for(let ce=1;ce<B.length;ce++){const he=B[ce];_(he,te)>0&&(te=he)}return te}e.findMaxBy=F;function C(B,_){if(B.length===0)return;let te=B[0];for(let ce=1;ce<B.length;ce++){const he=B[ce];_(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=C;function U(B,_){return F(B,(te,ce)=>-_(te,ce))}e.findMinBy=U;class z{constructor(_){this.f=_,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(_){let te=this.c;for(;te<this.f.length&&_(this.f[te]);)te++;const ce=te===this.c?null:this.f.slice(this.c,te);return this.c=te,ce}takeFromEndWhile(_){let te=this.d;for(;te>=0&&_(this.f[te]);)te--;const ce=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,ce}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const _=this.f[this.c];return this.c++,_}removeLast(){const _=this.f[this.d];return this.d--,_}takeCount(_){const te=this.f.slice(this.c,this.c+_);return this.c+=_,te}}e.ArrayQueue=z;class K{constructor(_){this.iterate=_}forEach(_){this.iterate(te=>(_(te),!0))}toArray(){const _=[];return this.iterate(te=>(_.push(te),!0)),_}filter(_){return new K(te=>this.iterate(ce=>_(ce)?te(ce):!0))}map(_){return new K(te=>this.iterate(ce=>te(_(ce))))}some(_){let te=!1;return this.iterate(ce=>(te=_(ce),!te)),te}findFirst(_){let te;return this.iterate(ce=>_(ce)?(te=ce,!1):!0),te}findLast(_){let te;return this.iterate(ce=>(_(ce)&&(te=ce),!0)),te}findLastMaxBy(_){let te,ce=!0;return this.iterate(he=>((ce||ne.isGreaterThan(_(he,te)))&&(ce=!1,te=he),!0)),te}}K.empty=new K(B=>{}),e.CallbackIterable=K}),define(oe[129],ae([0,1,10]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function N(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=N;function c(I,S="Unreachable"){throw new Error(S)}e.assertNever=c;function O(I){if(!I)throw new L.BugIndicatingError("Assertion Failed")}e.assert=O;function T(I){if(!I()){debugger;I(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function D(I,S){let P=0;for(;P<I.length-1;){const b=I[P],m=I[P+1];if(!S(b,m))return!1;P++}return!0}e.checkAdjacentItems=D}),define(oe[82],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(N){const c=this;let O=!1,T;return function(){return O||(O=!0,T=N.apply(c,arguments)),T}}e.once=L}),define(oe[63],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(N){function c(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}N.is=c;const O=Object.freeze([]);function T(){return O}N.empty=T;function*D(y){yield y}N.single=D;function I(y){return c(y)?y:D(y)}N.wrap=I;function S(y){return y||O}N.from=S;function P(y){return!y||y[Symbol.iterator]().next().done===!0}N.isEmpty=P;function b(y){return y[Symbol.iterator]().next().value}N.first=b;function m(y,k){for(const i of y)if(k(i))return!0;return!1}N.some=m;function d(y,k){for(const i of y)if(k(i))return i}N.find=d;function*p(y,k){for(const i of y)k(i)&&(yield i)}N.filter=p;function*E(y,k){let i=0;for(const o of y)yield k(o,i++)}N.map=E;function*l(...y){for(const k of y)for(const i of k)yield i}N.concat=l;function f(y,k,i){let o=i;for(const n of y)o=k(o,n);return o}N.reduce=f;function*u(y,k,i=y.length){for(k<0&&(k+=y.length),i<0?i+=y.length:i>y.length&&(i=y.length);k<i;k++)yield y[k]}N.slice=u;function g(y,k=Number.POSITIVE_INFINITY){const i=[];if(k===0)return[i,y];const o=y[Symbol.iterator]();for(let n=0;n<k;n++){const t=o.next();if(t.done)return[i,N.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}N.consume=g})(L=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N=e.SyntaxKind||(e.SyntaxKind={}));var c;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(c=e.ParseErrorCode||(e.ParseErrorCode={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O=e.ParseOptions||(e.ParseOptions={}));function T(i,o=!1){let n=0;const t=i.length;let s="",r=0,a=16,h=0;function w(q){let W=0,X=0;for(;W<q;){const Q=i.charCodeAt(n);if(Q>=48&&Q<=57)X=X*16+Q-48;else if(Q>=65&&Q<=70)X=X*16+Q-65+10;else if(Q>=97&&Q<=102)X=X*16+Q-97+10;else break;n++,W++}return W<q&&(X=-1),X}function v(q){n=q,s="",r=0,a=16,h=0}function R(){const q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&S(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&S(i.charCodeAt(n)))for(n++;n<i.length&&S(i.charCodeAt(n));)n++;else return h=3,i.substring(q,n);let W=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&S(i.charCodeAt(n))){for(n++;n<i.length&&S(i.charCodeAt(n));)n++;W=n}else h=3;return i.substring(q,W)}function A(){let q="",W=n;for(;;){if(n>=t){q+=i.substring(W,n),h=2;break}const X=i.charCodeAt(n);if(X===34){q+=i.substring(W,n),n++;break}if(X===92){if(q+=i.substring(W,n),n++,n>=t){h=2;break}switch(i.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const Y=w(4);Y>=0?q+=String.fromCharCode(Y):h=4;break}default:h=5}W=n;continue}if(X>=0&&X<=31)if(I(X)){q+=i.substring(W,n),h=2;break}else h=6;n++}return q}function M(){if(s="",h=0,r=n,n>=t)return r=t,a=17;let q=i.charCodeAt(n);if(D(q)){do n++,s+=String.fromCharCode(q),q=i.charCodeAt(n);while(D(q));return a=15}if(I(q))return n++,s+=String.fromCharCode(q),q===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,s=A(),a=10;case 47:{const W=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<t&&!I(i.charCodeAt(n));)n++;return s=i.substring(W,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const X=t-1;let Q=!1;for(;n<X;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,h=1),s=i.substring(W,n),a=13}return s+=String.fromCharCode(q),n++,a=16}case 45:if(s+=String.fromCharCode(q),n++,n===t||!S(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),a=11;default:for(;n<t&&$(q);)n++,q=i.charCodeAt(n);if(r!==n){switch(s=i.substring(r,n),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(q),n++,a=16}}function $(q){if(D(q)||I(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:o?V:M,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>h}}e.createScanner=T;function D(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function S(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function b(i,o){const n=[],t=new Object;let s;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(w,v,R,A){r.value=w,r.offset=v,r.length=R,r.type=A,r.colonOffset=void 0,s=r}try{g(i,{onObjectBegin:(w,v)=>{if(o<=w)throw t;s=void 0,a=o>w,n.push("")},onObjectProperty:(w,v,R)=>{if(o<v||(h(w,v,R,"property"),n[n.length-1]=w,o<=v+R))throw t},onObjectEnd:(w,v)=>{if(o<=w)throw t;s=void 0,n.pop()},onArrayBegin:(w,v)=>{if(o<=w)throw t;s=void 0,n.push(0)},onArrayEnd:(w,v)=>{if(o<=w)throw t;s=void 0,n.pop()},onLiteralValue:(w,v,R)=>{if(o<v||(h(w,v,R,k(w)),o<=v+R))throw t},onSeparator:(w,v,R)=>{if(o<=v)throw t;if(w===":"&&s&&s.type==="property")s.colonOffset=v,a=!1,s=void 0;else if(w===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(a=!0,n[n.length-1]=""),s=void 0}}})}catch(w){if(w!==t)throw w}return{path:n,previousNode:s,isAtPropertyKey:a,matches:w=>{let v=0;for(let R=0;v<w.length&&R<n.length;R++)if(w[v]===n[R]||w[v]==="*")v++;else if(w[v]!=="**")return!1;return v===w.length}}}e.getLocation=b;function m(i,o=[],n=O.DEFAULT){let t=null,s=[];const r=[];function a(w){Array.isArray(s)?s.push(w):t!==null&&(s[t]=w)}return g(i,{onObjectBegin:()=>{const w={};a(w),r.push(s),s=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{s=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(s),s=w,t=null},onArrayEnd:()=>{s=r.pop()},onLiteralValue:a,onError:(w,v,R)=>{o.push({error:w,offset:v,length:R})}},n),s[0]}e.parse=m;function d(i,o=[],n=O.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){t.type==="property"&&(t.length=w-t.offset,t=t.parent)}function r(w){return t.children.push(w),w}g(i,{onObjectBegin:w=>{t=r({type:"object",offset:w,length:-1,parent:t,children:[]})},onObjectProperty:(w,v,R)=>{t=r({type:"property",offset:v,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:w,offset:v,length:R,parent:t})},onObjectEnd:(w,v)=>{t.length=w+v-t.offset,t=t.parent,s(w+v)},onArrayBegin:(w,v)=>{t=r({type:"array",offset:w,length:-1,parent:t,children:[]})},onArrayEnd:(w,v)=>{t.length=w+v-t.offset,t=t.parent,s(w+v)},onLiteralValue:(w,v,R)=>{r({type:k(w),offset:v,length:R,parent:t,value:w}),s(v+R)},onSeparator:(w,v,R)=>{t.type==="property"&&(w===":"?t.colonOffset=v:w===","&&s(v))},onError:(w,v,R)=>{o.push({error:w,offset:v,length:R})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=d;function p(i,o){if(!i)return;let n=i;for(const t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===t){n=r.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=p;function E(i){if(!i.parent||!i.parent.children)return[];const o=E(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=E;function l(i){switch(i.type){case"array":return i.children.map(l);case"object":{const o=Object.create(null);for(const n of i.children){const t=n.children[1];t&&(o[n.children[0].value]=l(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=l;function f(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=f;function u(i,o,n=!1){if(f(i,o,n)){const t=i.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=o;s++){const r=u(t[s],o,n);if(r)return r}return i}}e.findNodeAtOffset=u;function g(i,o,n=O.DEFAULT){const t=T(i,!1);function s(re){return re?()=>re(t.getTokenOffset(),t.getTokenLength()):()=>!0}function r(re){return re?G=>re(G,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),h=r(o.onObjectProperty),w=s(o.onObjectEnd),v=s(o.onArrayBegin),R=s(o.onArrayEnd),A=r(o.onLiteralValue),M=r(o.onSeparator),$=s(o.onComment),V=r(o.onError),q=n&&n.disallowComments,W=n&&n.allowTrailingComma;function X(){for(;;){const re=t.scan();switch(t.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:q||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(re){case 12:case 13:q?Q(10):$();break;case 16:Q(1);break;case 15:case 14:break;default:return re}}}function Q(re,G=[],H=[]){if(V(re),G.length+H.length>0){let F=t.getToken();for(;F!==17;){if(G.indexOf(F)!==-1){X();break}else if(H.indexOf(F)!==-1)break;F=X()}}}function Y(re){const G=t.getTokenValue();return re?A(G):h(G),X(),!0}function Z(){switch(t.getToken()){case 11:{let re=0;try{re=JSON.parse(t.getTokenValue()),typeof re!="number"&&(Q(2),re=0)}catch{Q(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return X(),!0}function x(){return t.getToken()!==10?(Q(3,[],[2,5]),!1):(Y(!1),t.getToken()===6?(M(":"),X(),ne()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function j(){a(),X();let re=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(re||Q(4,[],[]),M(","),X(),t.getToken()===2&&W)break}else re&&Q(6,[],[]);x()||Q(4,[],[2,5]),re=!0}return w(),t.getToken()!==2?Q(7,[2],[]):X(),!0}function ee(){v(),X();let re=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(re||Q(4,[],[]),M(","),X(),t.getToken()===4&&W)break}else re&&Q(6,[],[]);ne()||Q(4,[],[4,5]),re=!0}return R(),t.getToken()!==4?Q(8,[4],[]):X(),!0}function ne(){switch(t.getToken()){case 3:return ee();case 1:return j();case 10:return Y(!0);default:return Z()}}return X(),t.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):ne()?(t.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=g;function y(i,o){const n=T(i),t=[];let s,r=0,a;do switch(a=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:r!==a&&t.push(i.substring(r,a)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=y;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(oe[42],ae([0,1,35]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function N(S,P,b){let m,d,p,E,l;if(P){for(E=P.offset,l=E+P.length,p=E;p>0&&!I(S,p-1);)p--;let a=l;for(;a<S.length&&!I(S,a);)a++;d=S.substring(p,a),m=T(d,b)}else d=S,m=0,p=0,E=0,l=S.length;const f=D(b,S);let u=!1,g=0,y;b.insertSpaces?y=O(" ",b.tabSize||4):y="	";const k=(0,L.createScanner)(d,!1);let i=!1;function o(){return f+O(y,m+g)}function n(){let a=k.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=k.scan();return i=a===16||k.getTokenError()!==0,a}const t=[];function s(a,h,w){!i&&h<l&&w>E&&S.substring(h,w)!==a&&t.push({offset:h,length:w-h,content:a})}let r=n();if(r!==17){const a=k.getTokenOffset()+p,h=O(y,m);s(h,p,a)}for(;r!==17;){let a=k.getTokenOffset()+k.getTokenLength()+p,h=n(),w="";for(;!u&&(h===12||h===13);){const R=k.getTokenOffset()+p;s(" ",a,R),a=k.getTokenOffset()+k.getTokenLength()+p,w=h===12?o():"",h=n()}if(h===2)r!==1&&(g--,w=o());else if(h===4)r!==3&&(g--,w=o());else{switch(r){case 3:case 1:g++,w=o();break;case 5:case 12:w=o();break;case 13:u?w=o():w=" ";break;case 6:w=" ";break;case 10:if(h===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?w=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}u&&(h===12||h===13)&&(w=o())}const v=k.getTokenOffset()+p;s(w,a,v),r=h}return t}e.format=N;function c(S,P){const b=JSON.stringify(S,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=c;function O(S,P){let b="";for(let m=0;m<P;m++)b+=S;return b}function T(S,P){let b=0,m=0;const d=P.tabSize||4;for(;b<S.length;){const p=S.charAt(b);if(p===" ")m++;else if(p==="	")m+=d;else break;b++}return Math.floor(m/d)}function D(S,P){for(let b=0;b<P.length;b++){const m=P.charAt(b);if(m==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=D;function I(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,35,42]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function c(S,P,b){return O(S,P,void 0,b)}e.removeProperty=c;function O(S,P,b,m,d){const p=P.slice(),E=[],l=(0,L.parseTree)(S,E);let f,u;for(;p.length>0&&(u=p.pop(),f=(0,L.findNodeAtLocation)(l,p),f===void 0&&b!==void 0);)typeof u=="string"?b={[u]:b}:b=[b];if(f)if(f.type==="object"&&typeof u=="string"&&Array.isArray(f.children)){const g=(0,L.findNodeAtLocation)(f,[u]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const y=f.children.indexOf(g.parent);let k,i=g.parent.offset+g.parent.length;if(y>0){const o=f.children[y-1];k=o.offset+o.length}else k=f.offset+1,f.children.length>1&&(i=f.children[1].offset);return T(S,{offset:k,length:i-k,content:""},m)}else return T(S,{offset:g.offset,length:g.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const y=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,k=d?d(f.children.map(o=>o.children[0].value)):f.children.length;let i;if(k>0){const o=f.children[k-1];i={offset:o.offset+o.length,length:0,content:","+y}}else f.children.length===0?i={offset:f.offset+1,length:0,content:y}:i={offset:f.offset+1,length:0,content:y+","};return T(S,i,m)}}else if(f.type==="array"&&typeof u=="number"&&Array.isArray(f.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let y;if(f.children.length===0||u===0)y={offset:f.offset+1,length:0,content:f.children.length===0?g:g+","};else{const k=u===-1||u>f.children.length?f.children.length:u,i=f.children[k-1];y={offset:i.offset+i.length,length:0,content:","+g}}return T(S,y,m)}else{const g=u,y=f.children[g];let k;if(f.children.length===1)k={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===g){const i=f.children[g-1],o=i.offset+i.length,n=f.offset+f.length;k={offset:o,length:n-2-o,content:""}}else k={offset:y.offset,length:f.children[g+1].offset-y.offset,content:""};return T(S,k,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${f.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(S,{offset:l?l.offset:0,length:l?l.length:0,content:JSON.stringify(b)},m)}}e.setProperty=O;function T(S,P,b){let m=D(S,P),d=P.offset,p=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,N.isEOL)(m,d-1);)d--;for(;p<m.length&&!(0,N.isEOL)(m,p);)p++}const E=(0,N.format)(m,{offset:d,length:p-d},b);for(let f=E.length-1;f>=0;f--){const u=E[f];m=D(m,u),d=Math.min(d,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const l=S.length-(m.length-p)-d;return[{offset:d,length:l,content:m.substring(d,p)}]}e.withFormatting=T;function D(S,P){return S.substring(0,P.offset)+P.content+S.substring(P.offset+P.length)}e.applyEdit=D;function I(S,P){const b=P.slice(0).sort((d,p)=>{const E=d.offset-p.offset;return E===0?d.length-p.length:E});let m=S.length;for(let d=b.length-1;d>=0;d--){const p=b[d];if(p.offset+p.length<=m)S=D(S,p);else throw new Error("Overlapping edit");m=p.offset}return S}e.applyEdits=I}),define(oe[130],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(c){this.d=c,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(c){this.c=c}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(oe[2],ae([0,1,82,63]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const c=!1;let O=null;function T(r){O=r}if(e.setDisposableTracker=T,c){const r="__is_disposable_tracked__";T(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function D(r){return O?.trackDisposable(r),r}function I(r){O?.markAsDisposed(r)}function S(r,a){O?.setParent(r,a)}function P(r,a){if(!!O)for(const h of r)O.setParent(h,a)}function b(r){return O?.markAsSingleton(r),r}e.markAsSingleton=b;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function d(r){if(N.Iterable.is(r)){const a=[];for(const h of r)if(h)try{h.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function p(r){for(const a of r)m(a)&&a.dispose();return[]}e.disposeIfDisposable=p;function E(...r){const a=l(()=>d(r));return P(r,a),a}e.combinedDisposable=E;function l(r){const a=D({dispose:(0,L.once)(()=>{I(a),r()})});return a}e.toDisposable=l;class f{constructor(){this.c=new Set,this.f=!1,D(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}f.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=f;class u{constructor(){this.q=new f,D(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}u.None=Object.freeze({dispose(){}}),e.Disposable=u;class g{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&S(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&S(a,null),a}}e.MutableDisposable=g;class y{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(a){let h=a;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,I(this))},this}}e.SafeDisposable=k;class i{constructor(){this.a=new Map}acquire(a,...h){let w=this.a.get(a);w||(w={counter:0,object:this.b(a,...h)},this.a.set(a,w));const{object:v}=w,R=(0,L.once)(()=>{--w.counter===0&&(this.c(a,w.object),this.a.delete(a))});return w.counter++,{object:v,dispose:R}}}e.ReferenceCollection=i;class o{constructor(a){this.a=a}async acquire(a,...h){const w=this.a.acquire(a,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(v){throw w.dispose(),v}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function t(r){const a=new f;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=t;class s{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,h,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(a)?.dispose(),this.a.set(a,h)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[84],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(O){this.element=O,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class N{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let O=this.a;for(;O!==L.Undefined;){const T=O.next;O.prev=L.Undefined,O.next=L.Undefined,O=T}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const D=new L(O);if(this.a===L.Undefined)this.a=D,this.b=D;else if(T){const S=this.b;this.b=D,D.prev=S,S.next=D}else{const S=this.a;this.a=D,D.next=S,S.prev=D}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(D))}}shift(){if(this.a!==L.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==L.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==L.Undefined&&O.next!==L.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===L.Undefined&&O.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):O.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):O.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==L.Undefined;)yield O.element,O=O.next}}e.LinkedList=N}),define(oe[37],ae([0,1]),function(ie,e){"use strict";var L,N,c;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(E,l,f){let u=E.get(l);return u===void 0&&(u=f,E.set(l,u)),u}e.getOrSet=O;function T(E){const l=[];return E.forEach((f,u)=>{l.push(`${u} => ${f}`)}),`Map(${E.size}) {${l.join(", ")}}`}e.mapToString=T;function D(E){const l=[];return E.forEach(f=>{l.push(f)}),`Set(${E.size}) {${l.join(", ")}}`}e.setToString=D;class I{constructor(l,f){this.uri=l,this.value=f}}class S{constructor(l,f){this[L]="ResourceMap",l instanceof S?(this.b=new Map(l.b),this.c=f??S.a):(this.b=new Map,this.c=l??S.a)}set(l,f){return this.b.set(this.c(l),new I(l,f)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,f){typeof f<"u"&&(l=l.bind(f));for(const[u,g]of this.b)l(g.value,g.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}S.a=E=>E.toString(),e.ResourceMap=S;class P{constructor(l,f){this[N]="ResourceSet",!l||typeof l=="function"?this.a=new S(l):(this.a=new S(f),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,f){this.a.forEach((u,g)=>l.call(f,g,g,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var b;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class m{constructor(){this[c]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,f=0){const u=this.a.get(l);if(!!u)return f!==0&&this.j(u,f),u.value}set(l,f,u=0){let g=this.a.get(l);if(g)g.value=f,u!==0&&this.j(g,u);else{switch(g={key:l,value:f,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(l,g),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const f=this.a.get(l);if(!!f)return this.a.delete(l),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,f){const u=this.e;let g=this.b;for(;g;){if(f?l.bind(f)(g.value,g.key,this):l(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const l=this,f=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(l.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.key,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}values(){const l=this,f=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(l.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.value,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}entries(){const l=this,f=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(l.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:[u.key,u.value],done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return g}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let f=this.b,u=this.size;for(;f&&u>l;)this.a.delete(f.key),f=f.next,u--;this.b=f,this.d=u,f&&(f.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const f=l.next,u=l.previous;if(!f||!u)throw new Error("Invalid list");f.previous=u,u.next=f}l.next=void 0,l.previous=void 0,this.e++}j(l,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(l===this.b)return;const u=l.next,g=l.previous;l===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(f===2){if(l===this.c)return;const u=l.next,g=l.previous;l===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((f,u)=>{l.push([u,f])}),l}fromJSON(l){this.clear();for(const[f,u]of l)this.set(f,u)}}e.LinkedMap=m;class d extends m{constructor(l,f=1){super(),this.k=l,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,f=2){return super.get(l,f)}peek(l){return super.get(l,0)}set(l,f){return super.set(l,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class p{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let f=this.a.get(l)||0;return f===0?!1:(f--,f===0?this.a.delete(l):this.a.set(l,f),!0)}has(l){return this.a.has(l)}}e.CounterSet=p}),define(oe[85],ae([0,1,37]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const N=new L.LRUCache(1e4);function c(S){return I(S,"NFC",N)}e.normalizeNFC=c;const O=new L.LRUCache(1e4);function T(S){return I(S,"NFD",O)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function I(S,P,b){if(!S)return S;const m=b.get(S);if(m)return m;let d;return D.test(S)?d=S.normalize(P):d=S,b.set(S,d),d}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(P){return T(P).replace(S,"")}}()}),define(oe[131],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(D,I,S){return Math.min(Math.max(D,I),S)}e.clamp=L;function N(D,I){return(I+D%I)%I}e.rot=N;class c{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=c;class O{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class T{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const S=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function ie(c){const O=[];typeof c=="number"&&O.push("code/timeOrigin",c);function T(I){O.push(I,Date.now())}function D(){const I=[];for(let S=0;S<O.length;S+=2)I.push({name:O[S],startTime:O[S+1]});return I}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(c){performance.mark(c)},getMarks(){let c=performance.timeOrigin;typeof c!="number"&&(c=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(c)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(c+T.startTime)});return O}};if(typeof process=="object"){const c=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(c)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function L(c){return c.MonacoPerformanceMarks||(c.MonacoPerformanceMarks=e()),c.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:ie)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function L(N){if(e[N])return e[N].exports;var c=e[N]={i:N,l:!1,exports:{}};return ie[N].call(c.exports,c,c.exports,L),c.l=!0,c.exports}return L.m=ie,L.c=e,L.d=function(N,c,O){L.o(N,c)||Object.defineProperty(N,c,{enumerable:!0,get:O})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,c){if(1&c&&(N=L(N)),8&c||4&c&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(L.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&c&&typeof N!="string")for(var T in N)L.d(O,T,function(D){return N[D]}.bind(null,T));return O},L.n=function(N){var c=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(c,"a",c),c},L.o=function(N,c){return Object.prototype.hasOwnProperty.call(N,c)},L.p="",L(L.s=0)}([function(ie,e,L){(function(N){var c;e=ie.exports=H,c=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],I=e.src=[],S=0,P=S++;I[P]="0|[1-9]\\d*";var b=S++;I[b]="[0-9]+";var m=S++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=S++;I[d]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var p=S++;I[p]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var E=S++;I[E]="(?:"+I[P]+"|"+I[m]+")";var l=S++;I[l]="(?:"+I[b]+"|"+I[m]+")";var f=S++;I[f]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var u=S++;I[u]="(?:-?("+I[l]+"(?:\\."+I[l]+")*))";var g=S++;I[g]="[0-9A-Za-z-]+";var y=S++;I[y]="(?:\\+("+I[g]+"(?:\\."+I[g]+")*))";var k=S++,i="v?"+I[d]+I[f]+"?"+I[y]+"?";I[k]="^"+i+"$";var o="[v=\\s]*"+I[p]+I[u]+"?"+I[y]+"?",n=S++;I[n]="^"+o+"$";var t=S++;I[t]="((?:<|>)?=?)";var s=S++;I[s]=I[b]+"|x|X|\\*";var r=S++;I[r]=I[P]+"|x|X|\\*";var a=S++;I[a]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[f]+")?"+I[y]+"?)?)?";var h=S++;I[h]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[u]+")?"+I[y]+"?)?)?";var w=S++;I[w]="^"+I[t]+"\\s*"+I[a]+"$";var v=S++;I[v]="^"+I[t]+"\\s*"+I[h]+"$";var R=S++;I[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=S++;I[A]="(?:~>?)";var M=S++;I[M]="(\\s*)"+I[A]+"\\s+",D[M]=new RegExp(I[M],"g");var $=S++;I[$]="^"+I[A]+I[a]+"$";var V=S++;I[V]="^"+I[A]+I[h]+"$";var q=S++;I[q]="(?:\\^)";var W=S++;I[W]="(\\s*)"+I[q]+"\\s+",D[W]=new RegExp(I[W],"g");var X=S++;I[X]="^"+I[q]+I[a]+"$";var Q=S++;I[Q]="^"+I[q]+I[h]+"$";var Y=S++;I[Y]="^"+I[t]+"\\s*("+o+")$|^$";var Z=S++;I[Z]="^"+I[t]+"\\s*("+i+")$|^$";var x=S++;I[x]="(\\s*)"+I[t]+"\\s*("+o+"|"+I[a]+")",D[x]=new RegExp(I[x],"g");var j=S++;I[j]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var ee=S++;I[ee]="^\\s*("+I[h]+")\\s+-\\s+("+I[h]+")\\s*$";var ne=S++;I[ne]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)c(re,I[re]),D[re]||(D[re]=new RegExp(I[re]));function G(le,fe){if(le instanceof H)return le;if(typeof le!="string"||le.length>O||!(fe?D[n]:D[k]).test(le))return null;try{return new H(le,fe)}catch{return null}}function H(le,fe){if(le instanceof H){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof H))return new H(le,fe);c("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?D[n]:D[k]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<T)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(le,fe){var ge=G(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=G(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(le){return c("SemVer.compare",this.version,this.loose,le),le instanceof H||(le=new H(le,this.loose)),this.compareMain(le)||this.comparePre(le)},H.prototype.compareMain=function(le){return le instanceof H||(le=new H(le,this.loose)),C(this.major,le.major)||C(this.minor,le.minor)||C(this.patch,le.patch)},H.prototype.comparePre=function(le){if(le instanceof H||(le=new H(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=le.prerelease[fe];if(c("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return C(ge,Ie)}while(++fe)},H.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new H(le,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(le,fe){if(B(le,fe))return null;var ge=G(le),Ie=G(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=C;var F=/^[0-9]+$/;function C(le,fe){var ge=F.test(le),Ie=F.test(fe);return ge&&Ie&&(le=+le,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:le<fe?-1:le>fe?1:0}function U(le,fe,ge){return new H(le,ge).compare(new H(fe,ge))}function z(le,fe,ge){return U(le,fe,ge)>0}function K(le,fe,ge){return U(le,fe,ge)<0}function B(le,fe,ge){return U(le,fe,ge)===0}function _(le,fe,ge){return U(le,fe,ge)!==0}function te(le,fe,ge){return U(le,fe,ge)>=0}function ce(le,fe,ge){return U(le,fe,ge)<=0}function he(le,fe,ge,Ie){var Pe;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le!==ge;break;case"":case"=":case"==":Pe=B(le,ge,Ie);break;case"!=":Pe=_(le,ge,Ie);break;case">":Pe=z(le,ge,Ie);break;case">=":Pe=te(le,ge,Ie);break;case"<":Pe=K(le,ge,Ie);break;case"<=":Pe=ce(le,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function pe(le,fe){if(le instanceof pe){if(le.loose===fe)return le;le=le.value}if(!(this instanceof pe))return new pe(le,fe);c("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===de?this.value="":this.value=this.operator+this.semver.version,c("comp",this)}e.rcompareIdentifiers=function(le,fe){return C(fe,le)},e.major=function(le,fe){return new H(le,fe).major},e.minor=function(le,fe){return new H(le,fe).minor},e.patch=function(le,fe){return new H(le,fe).patch},e.compare=U,e.compareLoose=function(le,fe){return U(le,fe,!0)},e.rcompare=function(le,fe,ge){return U(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=z,e.lt=K,e.eq=B,e.neq=_,e.gte=te,e.lte=ce,e.cmp=he,e.Comparator=pe;var de={};function Se(le,fe){if(le instanceof Se)return le.loose===fe?le:new Se(le.raw,fe);if(le instanceof pe)return new Se(le.value,fe);if(!(this instanceof Se))return new Se(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ce(le){return!le||le.toLowerCase()==="x"||le==="*"}function De(le,fe,ge,Ie,Pe,Fe,Le,Be,Me,Ne,je,se,ue){return((fe=Ce(ge)?"":Ce(Ie)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Be=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(je)?"<"+Me+"."+(+Ne+1)+".0":se?"<="+Me+"."+Ne+"."+je+"-"+se:"<="+Be)).trim()}function ke(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(c(le[ge].semver),le[ge].semver!==de&&le[ge].semver.prerelease.length>0){var Ie=le[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(le,fe,ge){try{fe=new Se(fe,ge)}catch{return!1}return fe.test(le)}function Ye(le,fe,ge,Ie){var Pe,Fe,Le,Be,Me;switch(le=new H(le,Ie),fe=new Se(fe,Ie),ge){case">":Pe=z,Fe=ce,Le=K,Be=">",Me=">=";break;case"<":Pe=K,Fe=te,Le=z,Be="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(le,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var je=fe.set[Ne],se=null,ue=null;if(je.forEach(function(me){me.semver===de&&(me=new pe(">=0.0.0")),se=se||me,ue=ue||me,Pe(me.semver,se.semver,Ie)?se=me:Le(me.semver,ue.semver,Ie)&&(ue=me)}),se.operator===Be||se.operator===Me||(!ue.operator||ue.operator===Be)&&Fe(le,ue.semver)||ue.operator===Me&&Le(le,ue.semver))return!1}return!0}pe.prototype.parse=function(le){var fe=this.loose?D[Y]:D[Z],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new H(ge[2],this.loose):this.semver=de},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(le){return c("Comparator.test",le,this.loose),this.semver===de||(typeof le=="string"&&(le=new H(le,this.loose)),he(le,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(le,fe){if(!(le instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Se(le.value,fe),We(this.value,ge,fe);if(le.operator==="")return ge=new Se(this.value,fe),We(le.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Fe=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Be=he(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=he(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ie||Pe||Fe&&Le||Be||Me},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),c("range",le,fe);var ge=fe?D[ee]:D[j];le=le.replace(ge,De),c("hyphen replace",le),le=le.replace(D[x],"$1$2$3"),c("comparator trim",le,D[x]),le=(le=(le=le.replace(D[M],"$1~")).replace(D[W],"$1^")).split(/\s+/).join(" ");var Ie=fe?D[Y]:D[Z],Pe=le.split(" ").map(function(Fe){return function(Le,Be){return c("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(se,ue){c("caret",se,ue);var me=ue?D[Q]:D[X];return se.replace(me,function(we,ve,Ee,Re,Ae){var Te;return c("caret",se,we,ve,Ee,Re,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ae?(c("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+Ae+" <"+(+ve+1)+".0.0"):(c("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+" <"+(+ve+1)+".0.0"),c("caret return",Te),Te})}(je,Ne)}).join(" ")}(Le,Be),c("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(se,ue){var me=ue?D[V]:D[$];return se.replace(me,function(we,ve,Ee,Re,Ae){var Te;return c("tilde",se,we,ve,Ee,Re,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ae?(c("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0",c("tilde return",Te),Te})}(je,Ne)}).join(" ")}(Le,Be),c("tildes",Le),Le=function(Me,Ne){return c("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(je){return function(se,ue){se=se.trim();var me=ue?D[v]:D[w];return se.replace(me,function(we,ve,Ee,Re,Ae,Te){c("xRange",se,we,ve,Ee,Re,Ae,Te);var Ue=Ce(Ee),$e=Ue||Ce(Re),ze=$e||Ce(Ae);return ve==="="&&ze&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(Re=0),ze&&(Ae=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,Re=0,Ae=0):ze&&(Re=+Re+1,Ae=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:Re=+Re+1),we=ve+Ee+"."+Re+"."+Ae):$e?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(we=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),c("xRange return",we),we})}(je,Ne)}).join(" ")}(Le,Be),c("xrange",Le),Le=function(Me,Ne){return c("replaceStars",Me,Ne),Me.trim().replace(D[ne],"")}(Le,Be),c("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new pe(Fe,fe)})},Se.prototype.intersects=function(le,fe){if(!(le instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return le.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(le,fe){return new Se(le,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new H(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],le))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new Se(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new H(Ie=Le,ge)))}),Ie},e.minSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new Se(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new H(Ie=Le,ge)))}),Ie},e.validRange=function(le,fe){try{return new Se(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Ye(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Ye(le,fe,">",ge)},e.outside=Ye,e.prerelease=function(le,fe){var ge=G(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new Se(le,ge),fe=new Se(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof H)return le;if(typeof le!="string")return null;var fe=le.match(D[R]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(ie,e){var L,N,c=ie.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(l){if(L===setTimeout)return setTimeout(l,0);if((L===O||!L)&&setTimeout)return L=setTimeout,setTimeout(l,0);try{return L(l,0)}catch{try{return L.call(null,l,0)}catch{return L.call(this,l,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:O}catch{L=O}try{N=typeof clearTimeout=="function"?clearTimeout:T}catch{N=T}})();var I,S=[],P=!1,b=-1;function m(){P&&I&&(P=!1,I.length?S=I.concat(S):b=-1,S.length&&d())}function d(){if(!P){var l=D(m);P=!0;for(var f=S.length;f;){for(I=S,S=[];++b<f;)I&&I[b].run();b=-1,f=S.length}I=null,P=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===T||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(l)}}function p(l,f){this.fun=l,this.array=f}function E(){}c.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)f[u-1]=arguments[u];S.push(new p(l,f)),S.length!==1||P||D(d)},p.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=E,c.addListener=E,c.once=E,c.off=E,c.removeListener=E,c.removeAllListeners=E,c.emit=E,c.prependListener=E,c.prependOnceListener=E,c.listeners=function(l){return[]},c.binding=function(l){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(l){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}}])}),define(oe[132],ae([0,1]),function(ie,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class N{constructor(D,I,S){this.level=D,this.key=I,this.value=S,this.forward=[]}}const c=void 0;class O{constructor(D,I=2**16){this.comparator=D,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new N(this.c,c,c)}get size(){return this.f}clear(){this.e=new N(this.c,c,c)}has(D){return Boolean(O.g(this,D,this.comparator))}get(D){return O.g(this,D,this.comparator)?.value}set(D,I){return O.h(this,D,I,this.comparator)&&(this.f+=1),this}delete(D){const I=O.k(this,D,this.comparator);return I&&(this.f-=1),I}forEach(D,I){let S=this.e.forward[0];for(;S;)D.call(I,S.value,S.key,this),S=S.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this.e.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this.e.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this.e.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",I=this.e.forward[0];for(;I;)D+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return D}static g(D,I,S){let P=D.e;for(let b=D.d-1;b>=0;b--)for(;P.forward[b]&&S(P.forward[b].key,I)<0;)P=P.forward[b];if(P=P.forward[0],P&&S(P.key,I)===0)return P}static h(D,I,S,P){const b=[];let m=D.e;for(let d=D.d-1;d>=0;d--){for(;m.forward[d]&&P(m.forward[d].key,I)<0;)m=m.forward[d];b[d]=m}if(m=m.forward[0],m&&P(m.key,I)===0)return m.value=S,!1;{const d=O.j(D);if(d>D.d){for(let p=D.d;p<d;p++)b[p]=D.e;D.d=d}m=new N(d,I,S);for(let p=0;p<d;p++)m.forward[p]=b[p].forward[p],b[p].forward[p]=m;return!0}}static j(D,I=.5){let S=1;for(;Math.random()<I&&S<D.c;)S+=1;return S}static k(D,I,S){const P=[];let b=D.e;for(let m=D.d-1;m>=0;m--){for(;b.forward[m]&&S(b.forward[m].key,I)<0;)b=b.forward[m];P[m]=b}if(b=b.forward[0],!b||S(b.key,I)!==0)return!1;for(let m=0;m<D.d&&P[m].forward[m]===b;m++)P[m].forward[m]=b.forward[m];for(;D.d>0&&D.e.forward[D.d-1]===c;)D.d-=1;return!0}}e.SkipList=O}),define(oe[43],ae([0,1,10,2]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function c(y){const k=y;return k?typeof k.read=="function":!1}e.isReadable=c;function O(y){const k=y;return k?[k.on,k.pause,k.resume,k.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=O;function T(y){const k=y;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.isReadableBufferedStream=T;function D(y,k){return new I(y,k)}e.newWriteableStream=D;class I{constructor(k,i){this.e=k,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(i=>i(k))}h(k){this.c.error.length===0?(0,L.onUnexpectedError)(k):this.c.error.slice(0).forEach(i=>i(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,i){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(k,i){if(this.a.destroyed)return;let o;switch(k){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(y,k){const i=[];let o;for(;(o=y.read())!==null;)i.push(o);return k(i)}e.consumeReadable=S;function P(y,k,i){const o=[];let n;for(;(n=y.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?k(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return y.read()}}}e.peekReadable=P;function b(y,k){return new Promise((i,o)=>{const n=[];m(y,{onData:t=>{k&&n.push(t)},onError:t=>{k?o(t):i(void 0)},onEnd:()=>{i(k?k(n):void 0)}})})}e.consumeStream=b;function m(y,k){let i=!1;return y.on("error",o=>{i||k.onError(o)}),y.on("end",()=>{i||k.onEnd()}),y.on("data",o=>{i||k.onData(o)}),(0,N.toDisposable)(()=>i=!0)}e.listenStream=m;function d(y,k){return new Promise((i,o)=>{const n=new N.DisposableStore,t=[],s=h=>{if(t.push(h),t.length>k)return n.dispose(),y.pause(),i({stream:y,buffer:t,ended:!1})},r=h=>o(h),a=()=>i({stream:y,buffer:t,ended:!0});n.add((0,N.toDisposable)(()=>y.removeListener("error",r))),y.on("error",r),n.add((0,N.toDisposable)(()=>y.removeListener("end",a))),y.on("end",a),n.add((0,N.toDisposable)(()=>y.removeListener("data",s))),y.on("data",s)})}e.peekStream=d;function p(y,k){const i=D(k);return i.end(y),i}e.toStream=p;function E(){const y=D(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=E;function l(y){let k=!1;return{read:()=>k?null:(k=!0,y)}}e.toReadable=l;function f(y,k,i){const o=D(i);return m(y,{onData:n=>o.write(k.data(n)),onError:n=>o.error(k.error?k.error(n):n),onEnd:()=>o.end()}),o}e.transform=f;function u(y,k,i){let o=!1;return{read:()=>{const n=k.read();return o?n:(o=!0,n!==null?i([y,n]):y)}}}e.prefixedReadable=u;function g(y,k,i){let o=!1;const n=D(i);return m(k,{onData:t=>o?n.write(t):(o=!0,n.write(i([y,t]))),onError:t=>n.error(t),onEnd:()=>{o||(o=!0,n.write(y)),n.end()}}),n}e.prefixedStream=g}),define(oe[16],ae([0,1,43]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const N=typeof Buffer<"u";let c,O;class T{static alloc(h){return N?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return N&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,w){return!(w?.dontUseNodeBuffer||!1)&&N?new T(Buffer.from(h)):(c||(c=new TextEncoder),new T(c.encode(h)))}static fromByteArray(h){const w=T.alloc(h.length);for(let v=0,R=h.length;v<R;v++)w.buffer[v]=h[v];return w}static concat(h,w){if(typeof w>"u"){w=0;for(let A=0,M=h.length;A<M;A++)w+=h[A].byteLength}const v=T.alloc(w);let R=0;for(let A=0,M=h.length;A<M;A++){const $=h[A];v.set($,R),R+=$.byteLength}return v}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return N?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(h,w){return new T(this.buffer.subarray(h,w))}set(h,w){if(h instanceof T)this.buffer.set(h.buffer,w);else if(h instanceof Uint8Array)this.buffer.set(h,w);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),w);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return S(this.buffer,h)}writeUInt32BE(h,w){P(this.buffer,h,w)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,w){m(this.buffer,h,w)}readUInt8(h){return d(this.buffer,h)}writeUInt8(h,w){p(this.buffer,h,w)}}e.VSBuffer=T;function D(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=D;function I(a,h,w){a[w+0]=h&255,h=h>>>8,a[w+1]=h&255}e.writeUInt16LE=I;function S(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=S;function P(a,h,w){a[w+3]=h,h=h>>>8,a[w+2]=h,h=h>>>8,a[w+1]=h,h=h>>>8,a[w]=h}e.writeUInt32BE=P;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=b;function m(a,h,w){a[w+0]=h&255,h=h>>>8,a[w+1]=h&255,h=h>>>8,a[w+2]=h&255,h=h>>>8,a[w+3]=h&255}e.writeUInt32LE=m;function d(a,h){return a[h]}e.readUInt8=d;function p(a,h,w){a[w]=h}e.writeUInt8=p;function E(a){return L.consumeReadable(a,h=>T.concat(h))}e.readableToBuffer=E;function l(a){return L.toReadable(a)}e.bufferToReadable=l;function f(a){return L.consumeStream(a,h=>T.concat(h))}e.streamToBuffer=f;async function u(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await f(a.stream)])}e.bufferedStreamToBuffer=u;function g(a){return L.toStream(a,h=>T.concat(h))}e.bufferToStream=g;function y(a){return L.transform(a,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=y;function k(a){return L.newWriteableStream(h=>T.concat(h),a)}e.newWriteableBufferStream=k;function i(a,h){return L.prefixedReadable(a,h,w=>T.concat(w))}e.prefixedBufferReadable=i;function o(a,h){return L.prefixedStream(a,h,w=>T.concat(w))}e.prefixedBufferStream=o;function n(a){let h=0,w=0,v=0;const R=new Uint8Array(Math.floor(a.length/4*3)),A=$=>{switch(w){case 3:R[v++]=h|$,w=0;break;case 2:R[v++]=h|$>>>2,h=$<<6,w=3;break;case 1:R[v++]=h|$>>>4,h=$<<4,w=2;break;default:h=$<<2,w=1}};for(let $=0;$<a.length;$++){const V=a.charCodeAt($);if(V>=65&&V<=90)A(V-65);else if(V>=97&&V<=122)A(V-97+26);else if(V>=48&&V<=57)A(V-48+52);else if(V===43||V===45)A(62);else if(V===47||V===95)A(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${a[$]}`)}}const M=v;for(;w>0;)A(0);return T.wrap(R).slice(0,M)}e.decodeBase64=n;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:a},h=!0,w=!1){const v=w?s:t;let R="";const A=a.byteLength%3;let M=0;for(;M<a.byteLength-A;M+=3){const $=a[M+0],V=a[M+1],q=a[M+2];R+=v[$>>>2],R+=v[($<<4|V>>>4)&63],R+=v[(V<<2|q>>>6)&63],R+=v[q&63]}if(A===1){const $=a[M+0];R+=v[$>>>2],R+=v[$<<4&63],h&&(R+="==")}else if(A===2){const $=a[M+0],V=a[M+1];R+=v[$>>>2],R+=v[($<<4|V>>>4)&63],R+=v[V<<2&63],h&&(R+="=")}return R}e.encodeBase64=r}),define(oe[133],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[11],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function N(o){return Array.isArray(o)&&o.every(n=>L(n))}e.isStringArray=N;function c(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=c;function O(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=O;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function D(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=D;function I(o){return o===!0||o===!1}e.isBoolean=I;function S(o){return typeof o>"u"}e.isUndefined=S;function P(o){return!b(o)}e.isDefined=P;function b(o){return S(o)||o===null}e.isUndefinedOrNull=b;function m(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=m;function d(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function p(...o){const n=[];for(let t=0;t<o.length;t++){const s=o[t];if(b(s))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);n.push(s)}return n}e.assertAllDefined=p;const E=Object.prototype.hasOwnProperty;function l(o){if(!c(o))return!1;for(const n in o)if(E.call(o,n))return!1;return!0}e.isEmptyObject=l;function f(o){return typeof o=="function"}e.isFunction=f;function u(...o){return o.length>0&&o.every(f)}e.areFunctions=u;function g(o,n){const t=Math.min(o.length,n.length);for(let s=0;s<t;s++)y(o[s],n[s])}e.validateConstraints=g;function y(o,n){if(L(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(f(n)){try{if(o instanceof n)return}catch{}if(!b(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function k(o){return o===null?void 0:o}e.withNullAsUndefined=k;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(oe[52],ae([0,1,11]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const N=Object.create(null);function c(D,I){if((0,L.isString)(I)){const S=N[I];if(S===void 0)throw new Error(`${D} references an unknown codicon: ${I}`);I=S}return N[D]=I,{id:D}}function O(){return N}e.getCodiconFontCharacters=O;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),bracket:c("bracket",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),send:c("send",60431),sparkle:c("sparkle",60432),insert:c("insert",60433),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(oe[32],ae([0,1,11]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function N(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const u=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([g,y])=>{u[g]=y&&typeof y=="object"?N(y):y}),u}e.deepClone=N;function c(f){if(!f||typeof f!="object")return f;const u=[f];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const y in g)if(O.call(g,y)){const k=g[y];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.isTypedArray)(k)&&u.push(k)}}return f}e.deepFreeze=c;const O=Object.prototype.hasOwnProperty;function T(f,u){return D(f,u,new Set)}e.cloneAndChange=T;function D(f,u,g){if((0,L.isUndefinedOrNull)(f))return f;const y=u(f);if(typeof y<"u")return y;if(Array.isArray(f)){const k=[];for(const i of f)k.push(D(i,u,g));return k}if((0,L.isObject)(f)){if(g.has(f))throw new Error("Cannot clone recursive data-structure");g.add(f);const k={};for(const i in f)O.call(f,i)&&(k[i]=D(f[i],u,g));return g.delete(f),k}return f}function I(f,u,g=!0){return(0,L.isObject)(f)?((0,L.isObject)(u)&&Object.keys(u).forEach(y=>{y in f?g&&((0,L.isObject)(f[y])&&(0,L.isObject)(u[y])?I(f[y],u[y],g):f[y]=u[y]):f[y]=u[y]}),f):u}e.mixin=I;function S(f,u){if(f===u)return!0;if(f==null||u===null||u===void 0||typeof f!=typeof u||typeof f!="object"||Array.isArray(f)!==Array.isArray(u))return!1;let g,y;if(Array.isArray(f)){if(f.length!==u.length)return!1;for(g=0;g<f.length;g++)if(!S(f[g],u[g]))return!1}else{const k=[];for(y in f)k.push(y);k.sort();const i=[];for(y in u)i.push(y);if(i.sort(),!S(k,i))return!1;for(g=0;g<k.length;g++)if(!S(f[k[g]],u[k[g]]))return!1}return!0}e.equals=S;function P(f){const u=new Set;return JSON.stringify(f,(g,y)=>{if((0,L.isObject)(y)||Array.isArray(y)){if(u.has(y))return"[Circular]";u.add(y)}return y})}e.safeStringify=P;function b(f,u){const g=Object.create(null);return!f||!u||Object.keys(u).forEach(k=>{const i=f[k],o=u[k];S(i,o)||(g[k]=o)}),g}e.distinct=b;function m(f,u){const g=u.toLowerCase(),y=Object.keys(f).find(k=>k.toLowerCase()===g);return y?f[y]:f[u]}e.getCaseInsensitive=m;function d(f,u){const g=Object.create(null);for(const[y,k]of Object.entries(f))u(y,k)&&(g[y]=k);return g}e.filter=d;function p(f){let u=[],g=Object.getPrototypeOf(f);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.getAllPropertyNames=p;function E(f){const u=[];for(const g of p(f))typeof f[g]=="function"&&u.push(g);return u}e.getAllMethodNames=E;function l(f,u){const g=k=>function(){const i=Array.prototype.slice.call(arguments,0);return u(k,i)},y={};for(const k of f)y[k]=g(k);return y}e.createProxyObject=l}),define(oe[134],ae([0,1,52]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var N;(function(T){function D(I){return I&&typeof I=="object"&&typeof I.id=="string"}T.isThemeColor=D})(N=e.ThemeColor||(e.ThemeColor={}));function c(T){return{id:T}}e.themeColorFromId=c;var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function I(u){const g=D.exec(u.id);if(!g)return I(L.Codicon.error);const[,y,k]=g,i=["codicon","codicon-"+y];return k&&i.push("codicon-modifier-"+k.substring(1)),i}T.asClassNameArray=I;function S(u){return I(u).join(" ")}T.asClassName=S;function P(u){return"."+I(u).join(".")}T.asCSSSelector=P;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||N.isThemeColor(u.color))}T.isThemeIcon=b;const m=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function d(u){const g=m.exec(u);if(!g)return;const[,y]=g;return{id:y}}T.fromString=d;function p(u){return{id:u}}T.fromId=p;function E(u,g){let y=u.id;const k=y.lastIndexOf("~");return k!==-1&&(y=y.substring(0,k)),g&&(y=`${y}~${g}`),{id:y}}T.modify=E;function l(u){const g=u.id.lastIndexOf("~");if(g!==-1)return u.id.substring(g+1)}T.getModifier=l;function f(u,g){return u.id===g.id&&u.color?.id===g.color?.id}T.isEqual=f})(O=e.ThemeIcon||(e.ThemeIcon={}))}),define(oe[31],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(c){return L.test(c)}e.isUUID=N,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let c;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?c=crypto.getRandomValues.bind(crypto):c=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};const O=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));return function(){c(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let I=0,S="";return S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S+="-",S+=T[O[I++]],S+=T[O[I++]],S+="-",S+=T[O[I++]],S+=T[O[I++]],S+="-",S+=T[O[I++]],S+=T[O[I++]],S+="-",S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S+=T[O[I++]],S}}()}),define(oe[135],ae([0,1,34]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function c(T){const D=T.replace(/\-/g,":").toLowerCase();return!N.has(D)}function O(){const T=(0,L.networkInterfaces)();for(const D in T){const I=T[D];if(I){for(const{mac:S}of I)if(c(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(oe[136],ae([0,1,86]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function N(D,I,S,P=1){let b=!1;return new Promise(m=>{const d=setTimeout(()=>{if(!b)return b=!0,m(0)},S);c(D,I,P,p=>{if(!b)return b=!0,clearTimeout(d),m(p)})})}e.findFreePort=N;function c(D,I,S,P){if(I===0)return P(0);const b=new L.Socket;b.once("connect",()=>(T(b),c(D+S,I-1,S,P))),b.once("data",()=>{}),b.once("error",m=>(T(b),m.code!=="ECONNREFUSED"?c(D+S,I-1,S,P):P(D))),b.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(D,I,S,P="127.0.0.1"){let b=!1,m,d=1;const p=L.createServer({pauseOnConnect:!0});function E(l,f){b||(b=!0,p.removeAllListeners(),p.close(),m&&clearTimeout(m),f(l))}return new Promise(l=>{m=setTimeout(()=>{E(0,l)},S),p.on("listening",()=>{E(D,l)}),p.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&d<I?(D++,d++,p.listen(D,P)):E(0,l)}),p.on("close",()=>{E(0,l)}),p.listen(D,P)})}e.findFreePortFaster=O;function T(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(I){console.error(I)}}}),define(oe[87],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(N){return!!N.parentPort}e.isUtilityProcess=L}),define(oe[137],ae([8,7]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(oe[64],ae([0,1,137]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const N=60,c=N*60,O=c*24,T=O*7,D=O*30,I=O*365;function S(b,m,d,p){typeof b!="number"&&(b=b.getTime());const E=Math.round((new Date().getTime()-b)/1e3);if(E<-30)return(0,L.localize)(0,null,S(new Date().getTime()+E*1e3,!1));if(!p&&E<30)return(0,L.localize)(1,null);let l;return E<N?(l=E,m?l===1?d?(0,L.localize)(2,null,l):(0,L.localize)(3,null,l):d?(0,L.localize)(4,null,l):(0,L.localize)(5,null,l):l===1?d?(0,L.localize)(6,null,l):(0,L.localize)(7,null,l):d?(0,L.localize)(8,null,l):(0,L.localize)(9,null,l)):E<c?(l=Math.floor(E/N),m?l===1?d?(0,L.localize)(10,null,l):(0,L.localize)(11,null,l):d?(0,L.localize)(12,null,l):(0,L.localize)(13,null,l):l===1?d?(0,L.localize)(14,null,l):(0,L.localize)(15,null,l):d?(0,L.localize)(16,null,l):(0,L.localize)(17,null,l)):E<O?(l=Math.floor(E/c),m?l===1?d?(0,L.localize)(18,null,l):(0,L.localize)(19,null,l):d?(0,L.localize)(20,null,l):(0,L.localize)(21,null,l):l===1?d?(0,L.localize)(22,null,l):(0,L.localize)(23,null,l):d?(0,L.localize)(24,null,l):(0,L.localize)(25,null,l)):E<T?(l=Math.floor(E/O),m?l===1?(0,L.localize)(26,null,l):(0,L.localize)(27,null,l):l===1?(0,L.localize)(28,null,l):(0,L.localize)(29,null,l)):E<D?(l=Math.floor(E/T),m?l===1?d?(0,L.localize)(30,null,l):(0,L.localize)(31,null,l):d?(0,L.localize)(32,null,l):(0,L.localize)(33,null,l):l===1?d?(0,L.localize)(34,null,l):(0,L.localize)(35,null,l):d?(0,L.localize)(36,null,l):(0,L.localize)(37,null,l)):E<I?(l=Math.floor(E/D),m?l===1?d?(0,L.localize)(38,null,l):(0,L.localize)(39,null,l):d?(0,L.localize)(40,null,l):(0,L.localize)(41,null,l):l===1?d?(0,L.localize)(42,null,l):(0,L.localize)(43,null,l):d?(0,L.localize)(44,null,l):(0,L.localize)(45,null,l)):(l=Math.floor(E/I),m?l===1?d?(0,L.localize)(46,null,l):(0,L.localize)(47,null,l):d?(0,L.localize)(48,null,l):(0,L.localize)(49,null,l):l===1?d?(0,L.localize)(50,null,l):(0,L.localize)(51,null,l):d?(0,L.localize)(52,null,l):(0,L.localize)(53,null,l))}e.fromNow=S;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(oe[138],ae([8,7]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,138]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,m){return m&&(b.stack||b.stacktrace)?c.localize(0,null,D(b),T(b.stack)||T(b.stacktrace)):D(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function D(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?c.localize(1,null,b.message):b.message||c.localize(2,null)}function I(b=null,m=!1){if(!b)return c.localize(3,null);if(Array.isArray(b)){const d=L.coalesce(b),p=I(d[0],m);return d.length>1?c.localize(4,null,p,d.length):p}if(N.isString(b))return b;if(b.detail){const d=b.detail;if(d.error)return O(d.error,m);if(d.exception)return O(d.exception,m)}return b.stack?O(b,m):b.message?b.message:c.localize(5,null)}e.toErrorMessage=I;function S(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=S;function P(b,m){let d;return typeof b=="string"?d=new Error(b):d=b,d.actions=m,d}e.createErrorWithActions=P}),define(oe[139],ae([8,7]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(oe[140],ae([0,1,139]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function N(c){switch(c){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=N}),define(oe[141],ae([8,7]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,141]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let N=!1,c=!1,O=!1,T=!1,D=!1,I=!1,S=!1,P=!1,b=!1,m=!1,d,p=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,l,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",y=g&&u?.type==="renderer";if(typeof navigator=="object"&&!y)f=navigator.userAgent,N=f.indexOf("Windows")>=0,c=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,m=f?.indexOf("Mobi")>=0,I=!0,d=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,p=d,E=navigator.language;else if(typeof u=="object"){N=u.platform==="win32",c=u.platform==="darwin",O=u.platform==="linux",T=O&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=g,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const h=u.env.VSCODE_NLS_CONFIG;if(h)try{const w=JSON.parse(h),v=w.availableLanguages["*"];d=w.locale,E=w.osLocale,p=v||e.LANGUAGE_DEFAULT,l=w._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var k;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(k=e.Platform||(e.Platform={}));function i(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let o=0;c?o=1:N?o=3:O&&(o=2),e.isWindows=N,e.isMacintosh=c,e.isLinux=O,e.isLinuxSnap=T,e.isNative=D,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=m,e.isCI=b,e.platform=o,e.userAgent=f,e.language=p;var n;(function(h){function w(){return e.language}h.value=w;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=v;function R(){return e.language==="en"}h.isDefault=R})(n=e.Language||(e.Language={})),e.locale=d,e.platformLocale=E,e.translationsConfigFile=l,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let R=0,A=h.length;R<A;R++){const M=h[R];if(M.id===v.data.vscodeScheduleAsyncWork){h.splice(R,1),M.callback();return}}});let w=0;return v=>{const R=++w;h.push({id:R,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return h=>setTimeout(h)})();var t;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=c||P?2:N?1:3;let s=!0,r=!1;function a(){if(!r){r=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,s=new Uint16Array(h.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let N;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const c=L.globals.vscode.process;N={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.platform=N.platform,e.arch=N.arch}),define(oe[14],ae([0,1,36]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const N=65,c=97,O=90,T=122,D=46,I=47,S=92,P=58,b=63;class m extends Error{constructor(o,n,t){let s;typeof n=="string"&&n.indexOf("not ")===0?(s="must not be",n=n.replace(/^not /,"")):s="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${s} of type ${n}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function p(i,o){if(typeof i!="string")throw new m(o,"string",i)}const E=L.platform==="win32";function l(i){return i===I||i===S}function f(i){return i===I}function u(i){return i>=N&&i<=O||i>=c&&i<=T}function g(i,o,n,t){let s="",r=0,a=-1,h=0,w=0;for(let v=0;v<=i.length;++v){if(v<i.length)w=i.charCodeAt(v);else{if(t(w))break;w=I}if(t(w)){if(!(a===v-1||h===1))if(h===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==D||s.charCodeAt(s.length-2)!==D){if(s.length>2){const R=s.lastIndexOf(n);R===-1?(s="",r=0):(s=s.slice(0,R),r=s.length-1-s.lastIndexOf(n)),a=v,h=0;continue}else if(s.length!==0){s="",r=0,a=v,h=0;continue}}o&&(s+=s.length>0?`${n}..`:"..",r=2)}else s.length>0?s+=`${n}${i.slice(a+1,v)}`:s=i.slice(a+1,v),r=v-a-1;a=v,h=0}else w===D&&h!==-1?++h:h=-1}return s}function y(i,o){d(o,"pathObject");const n=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${t}`:`${n}${i}${t}`:t}e.win32={resolve(...i){let o="",n="",t=!1;for(let s=i.length-1;s>=-1;s--){let r;if(s>=0){if(r=i[s],p(r,"path"),r.length===0)continue}else o.length===0?r=L.cwd():(r=L.env[`=${o}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===S)&&(r=`${o}\\`));const a=r.length;let h=0,w="",v=!1;const R=r.charCodeAt(0);if(a===1)l(R)&&(h=1,v=!0);else if(l(R))if(v=!0,l(r.charCodeAt(1))){let A=2,M=A;for(;A<a&&!l(r.charCodeAt(A));)A++;if(A<a&&A!==M){const $=r.slice(M,A);for(M=A;A<a&&l(r.charCodeAt(A));)A++;if(A<a&&A!==M){for(M=A;A<a&&!l(r.charCodeAt(A));)A++;(A===a||A!==M)&&(w=`\\\\${$}\\${r.slice(M,A)}`,h=A)}}}else h=1;else u(R)&&r.charCodeAt(1)===P&&(w=r.slice(0,2),h=2,a>2&&l(r.charCodeAt(2))&&(v=!0,h=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(t){if(o.length>0)break}else if(n=`${r.slice(h)}\\${n}`,t=v,v&&o.length>0)break}return n=g(n,!t,"\\",l),t?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){p(i,"path");const o=i.length;if(o===0)return".";let n=0,t,s=!1;const r=i.charCodeAt(0);if(o===1)return f(r)?"\\":i;if(l(r))if(s=!0,l(i.charCodeAt(1))){let h=2,w=h;for(;h<o&&!l(i.charCodeAt(h));)h++;if(h<o&&h!==w){const v=i.slice(w,h);for(w=h;h<o&&l(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!l(i.charCodeAt(h));)h++;if(h===o)return`\\\\${v}\\${i.slice(w)}\\`;h!==w&&(t=`\\\\${v}\\${i.slice(w,h)}`,n=h)}}}else n=1;else u(r)&&i.charCodeAt(1)===P&&(t=i.slice(0,2),n=2,o>2&&l(i.charCodeAt(2))&&(s=!0,n=3));let a=n<o?g(i.slice(n),!s,"\\",l):"";return a.length===0&&!s&&(a="."),a.length>0&&l(i.charCodeAt(o-1))&&(a+="\\"),t===void 0?s?`\\${a}`:a:s?`${t}\\${a}`:`${t}${a}`},isAbsolute(i){p(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return l(n)||o>2&&u(n)&&i.charCodeAt(1)===P&&l(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];p(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof n=="string"&&l(n.charCodeAt(0))){++s;const r=n.length;r>1&&l(n.charCodeAt(1))&&(++s,r>2&&(l(n.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&l(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(i,o){if(p(i,"from"),p(o,"to"),i===o)return"";const n=e.win32.resolve(i),t=e.win32.resolve(o);if(n===t||(i=n.toLowerCase(),o=t.toLowerCase(),i===o))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===S;)s++;let r=i.length;for(;r-1>s&&i.charCodeAt(r-1)===S;)r--;const a=r-s;let h=0;for(;h<o.length&&o.charCodeAt(h)===S;)h++;let w=o.length;for(;w-1>h&&o.charCodeAt(w-1)===S;)w--;const v=w-h,R=a<v?a:v;let A=-1,M=0;for(;M<R;M++){const V=i.charCodeAt(s+M);if(V!==o.charCodeAt(h+M))break;V===S&&(A=M)}if(M!==R){if(A===-1)return t}else{if(v>R){if(o.charCodeAt(h+M)===S)return t.slice(h+M+1);if(M===2)return t.slice(h+M)}a>R&&(i.charCodeAt(s+M)===S?A=M:M===2&&(A=3)),A===-1&&(A=0)}let $="";for(M=s+A+1;M<=r;++M)(M===r||i.charCodeAt(M)===S)&&($+=$.length===0?"..":"\\..");return h+=A,$.length>0?`${$}${t.slice(h,w)}`:(t.charCodeAt(h)===S&&++h,t.slice(h,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const n=o.charCodeAt(2);if(n!==b&&n!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return i},dirname(i){p(i,"path");const o=i.length;if(o===0)return".";let n=-1,t=0;const s=i.charCodeAt(0);if(o===1)return l(s)?i:".";if(l(s)){if(n=t=1,l(i.charCodeAt(1))){let h=2,w=h;for(;h<o&&!l(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&l(i.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!l(i.charCodeAt(h));)h++;if(h===o)return i;h!==w&&(n=t=h+1)}}}}else u(s)&&i.charCodeAt(1)===P&&(n=o>2&&l(i.charCodeAt(2))?3:2,t=n);let r=-1,a=!0;for(let h=o-1;h>=t;--h)if(l(i.charCodeAt(h))){if(!a){r=h;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&p(o,"ext"),p(i,"path");let n=0,t=-1,s=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,h=-1;for(r=i.length-1;r>=n;--r){const w=i.charCodeAt(r);if(l(w)){if(!s){n=r+1;break}}else h===-1&&(s=!1,h=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(t=r):(a=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(r=i.length-1;r>=n;--r)if(l(i.charCodeAt(r))){if(!s){n=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":i.slice(n,t)},extname(i){p(i,"path");let o=0,n=-1,t=0,s=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&u(i.charCodeAt(0))&&(o=t=2);for(let h=i.length-1;h>=o;--h){const w=i.charCodeAt(h);if(l(w)){if(!r){t=h+1;break}continue}s===-1&&(r=!1,s=h+1),w===D?n===-1?n=h:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||s===-1||a===0||a===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:y.bind(null,"\\"),parse(i){p(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let t=0,s=i.charCodeAt(0);if(n===1)return l(s)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(l(s)){if(t=1,l(i.charCodeAt(1))){let A=2,M=A;for(;A<n&&!l(i.charCodeAt(A));)A++;if(A<n&&A!==M){for(M=A;A<n&&l(i.charCodeAt(A));)A++;if(A<n&&A!==M){for(M=A;A<n&&!l(i.charCodeAt(A));)A++;A===n?t=A:A!==M&&(t=A+1)}}}}else if(u(s)&&i.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=i,o;if(t=2,l(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let r=-1,a=t,h=-1,w=!0,v=i.length-1,R=0;for(;v>=t;--v){if(s=i.charCodeAt(v),l(s)){if(!w){a=v+1;break}continue}h===-1&&(w=!1,h=v+1),s===D?r===-1?r=v:R!==1&&(R=1):r!==-1&&(R=-1)}return h!==-1&&(r===-1||R===0||R===1&&r===h-1&&r===a+1?o.base=o.name=i.slice(a,h):(o.name=i.slice(a,r),o.base=i.slice(a,h),o.ext=i.slice(r,h))),a>0&&a!==t?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(E){const i=/\\/g;return()=>{const o=L.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let o="",n=!1;for(let t=i.length-1;t>=-1&&!n;t--){const s=t>=0?i[t]:k();p(s,"path"),s.length!==0&&(o=`${s}/${o}`,n=s.charCodeAt(0)===I)}return o=g(o,!n,"/",f),n?`/${o}`:o.length>0?o:"."},normalize(i){if(p(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I,n=i.charCodeAt(i.length-1)===I;return i=g(i,!o,"/",f),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return p(i,"path"),i.length>0&&i.charCodeAt(0)===I},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const t=i[n];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(p(i,"from"),p(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const n=1,t=i.length,s=t-n,r=1,a=o.length-r,h=s<a?s:a;let w=-1,v=0;for(;v<h;v++){const A=i.charCodeAt(n+v);if(A!==o.charCodeAt(r+v))break;A===I&&(w=v)}if(v===h)if(a>h){if(o.charCodeAt(r+v)===I)return o.slice(r+v+1);if(v===0)return o.slice(r+v)}else s>h&&(i.charCodeAt(n+v)===I?w=v:v===0&&(w=0));let R="";for(v=n+w+1;v<=t;++v)(v===t||i.charCodeAt(v)===I)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(r+w)}`},toNamespacedPath(i){return i},dirname(i){if(p(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===I;let n=-1,t=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===I){if(!t){n=s;break}}else t=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&p(o,"ext"),p(i,"path");let n=0,t=-1,s=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,h=-1;for(r=i.length-1;r>=0;--r){const w=i.charCodeAt(r);if(w===I){if(!s){n=r+1;break}}else h===-1&&(s=!1,h=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(t=r):(a=-1,t=h))}return n===t?t=h:t===-1&&(t=i.length),i.slice(n,t)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===I){if(!s){n=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":i.slice(n,t)},extname(i){p(i,"path");let o=-1,n=0,t=-1,s=!0,r=0;for(let a=i.length-1;a>=0;--a){const h=i.charCodeAt(a);if(h===I){if(!s){n=a+1;break}continue}t===-1&&(s=!1,t=a+1),h===D?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===n+1?"":i.slice(o,t)},format:y.bind(null,"/"),parse(i){p(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===I;let t;n?(o.root="/",t=1):t=0;let s=-1,r=0,a=-1,h=!0,w=i.length-1,v=0;for(;w>=t;--w){const R=i.charCodeAt(w);if(R===I){if(!h){r=w+1;break}continue}a===-1&&(h=!1,a=w+1),R===D?s===-1?s=w:v!==1&&(v=1):s!==-1&&(v=-1)}if(a!==-1){const R=r===0&&n?1:r;s===-1||v===0||v===1&&s===a-1&&s===r+1?o.base=o.name=i.slice(R,a):(o.name=i.slice(R,s),o.base=i.slice(R,a),o.ext=i.slice(s,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(oe[142],ae([0,1,14]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(P){const b=(0,L.extname)(P),m=N[b.toLowerCase()];return m!==void 0?m:T(P)}e.getMediaOrTextMime=O;function T(P){const b=(0,L.extname)(P);return c[b.toLowerCase()]}e.getMediaMime=T;function D(P){for(const b in c)if(c[b]===P)return b}e.getExtensionForMimeType=D;const I=/^(.+)\/(.+?)(;.+)?$/;function S(P,b){const m=I.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:P}e.normalizeMimeType=S}),define(oe[88],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var N;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(N=e.Source||(e.Source={}));var c;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(c=e.TerminateResponseCode||(e.TerminateResponseCode={}));function O(D,...I){const S=I.reduce((m,d)=>(m[d]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(m=>!S[m]).forEach(m=>{for(let d=0;d<P.length;d++)if(m.search(P[d])!==-1){delete D[m];break}})}e.sanitizeProcessEnvironment=O;function T(D){!D||(delete D.DEBUG,L.isMacintosh&&delete D.DYLD_LIBRARY_PATH,L.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[89],ae([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const N=L.globals.performance&&typeof L.globals.performance.now=="function";class c{static create(T=!0){return new c(T)}constructor(T){this.a=N&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=c}),define(oe[3],ae([0,1,10,82,2,84,89]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const D=!1,I=!1;var S;(function(r){r.None=()=>c.Disposable.None;function a(U){if(I){const{onDidAddListener:z}=U,K=p.create();let B=0;U.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),z?.()}}}function h(U,z){return W(U,()=>{},0,void 0,!0,void 0,z)}r.defer=h;function w(U){return(z,K=null,B)=>{let _=!1,te;return te=U(ce=>{if(!_)return te?te.dispose():_=!0,z.call(K,ce)},null,B),_&&te.dispose(),te}}r.once=w;function v(U,z,K){return q((B,_=null,te)=>U(ce=>B.call(_,z(ce)),null,te),K)}r.map=v;function R(U,z,K){return q((B,_=null,te)=>U(ce=>{z(ce),B.call(_,ce)},null,te),K)}r.forEach=R;function A(U,z,K){return q((B,_=null,te)=>U(ce=>z(ce)&&B.call(_,ce),null,te),K)}r.filter=A;function M(U){return U}r.signal=M;function $(...U){return(z,K=null,B)=>(0,c.combinedDisposable)(...U.map(_=>_(te=>z.call(K,te),null,B)))}r.any=$;function V(U,z,K,B){let _=K;return v(U,te=>(_=z(_,te),_),B)}r.reduce=V;function q(U,z){let K;const B={onWillAddFirstListener(){K=U(_.fire,_)},onDidRemoveLastListener(){K?.dispose()}};z||a(B);const _=new l(B);return z?.add(_),_.event}function W(U,z,K=100,B=!1,_=!1,te,ce){let he,pe,de,Se=0,Ce;const De={leakWarningThreshold:te,onWillAddFirstListener(){he=U(We=>{Se++,pe=z(pe,We),B&&!de&&(ke.fire(pe),pe=void 0),Ce=()=>{const Ye=pe;pe=void 0,de=void 0,(!B||Se>1)&&ke.fire(Ye),Se=0},typeof K=="number"?(clearTimeout(de),de=setTimeout(Ce,K)):de===void 0&&(de=0,queueMicrotask(Ce))})},onWillRemoveListener(){_&&Se>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};ce||a(De);const ke=new l(De);return ce?.add(ke),ke.event}r.debounce=W;function X(U,z=0,K){return r.debounce(U,(B,_)=>B?(B.push(_),B):[_],z,void 0,!0,void 0,K)}r.accumulate=X;function Q(U,z=(B,_)=>B===_,K){let B=!0,_;return A(U,te=>{const ce=B||!z(te,_);return B=!1,_=te,ce},K)}r.latch=Q;function Y(U,z,K){return[r.filter(U,z,K),r.filter(U,B=>!z(B),K)]}r.split=Y;function Z(U,z=!1,K=[]){let B=K.slice(),_=U(he=>{B?B.push(he):ce.fire(he)});const te=()=>{B?.forEach(he=>ce.fire(he)),B=null},ce=new l({onWillAddFirstListener(){_||(_=U(he=>ce.fire(he)))},onDidAddFirstListener(){B&&(z?setTimeout(te):te())},onDidRemoveLastListener(){_&&_.dispose(),_=null}});return ce.event}r.buffer=Z;class x{constructor(z){this.event=z,this.c=new c.DisposableStore}map(z){return new x(v(this.event,z,this.c))}forEach(z){return new x(R(this.event,z,this.c))}filter(z){return new x(A(this.event,z,this.c))}reduce(z,K){return new x(V(this.event,z,K,this.c))}latch(){return new x(Q(this.event,void 0,this.c))}debounce(z,K=100,B=!1,_=!1,te){return new x(W(this.event,z,K,B,_,te,this.c))}on(z,K,B){return this.event(z,K,B)}once(z,K,B){return w(this.event)(z,K,B)}dispose(){this.c.dispose()}}function j(U){return new x(U)}r.chain=j;function ee(U,z,K=B=>B){const B=(...he)=>ce.fire(K(...he)),_=()=>U.on(z,B),te=()=>U.removeListener(z,B),ce=new l({onWillAddFirstListener:_,onDidRemoveLastListener:te});return ce.event}r.fromNodeEventEmitter=ee;function ne(U,z,K=B=>B){const B=(...he)=>ce.fire(K(...he)),_=()=>U.addEventListener(z,B),te=()=>U.removeEventListener(z,B),ce=new l({onWillAddFirstListener:_,onDidRemoveLastListener:te});return ce.event}r.fromDOMEventEmitter=ne;function re(U){return new Promise(z=>w(U)(z))}r.toPromise=re;function G(U,z){return z(void 0),U(K=>z(K))}r.runAndSubscribe=G;function H(U,z){let K=null;function B(te){K?.dispose(),K=new c.DisposableStore,z(te,K)}B(void 0);const _=U(te=>B(te));return(0,c.toDisposable)(()=>{_.dispose(),K?.dispose()})}r.runAndSubscribeWithStore=H;class F{constructor(z,K){this.obs=z,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};K||a(B),this.emitter=new l(B),K&&K.add(this.emitter)}beginUpdate(z){this.c++}handleChange(z,K){this.d=!0}endUpdate(z){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function C(U,z){return new F(U,z).emitter.event}r.fromObservable=C})(S=e.Event||(e.Event={}));class P{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${P.c++}`,P.all.add(this)}start(a){this.d=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let b=-1;function m(r){const a=b;return b=r,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=m;class d{constructor(a,h=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=h,this.d=0}dispose(){this.c?.clear()}check(a,h){const w=this.threshold;if(w<=0||h<w)return;this.c||(this.c=new Map);const v=this.c.get(a.value)||0;if(this.c.set(a.value,v+1),this.d-=1,this.d<=0){this.d=w*.5;let R,A=0;for(const[M,$]of this.c)(!R||A<$)&&(R=M,A=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${A}):`),console.warn(R)}return()=>{const R=this.c.get(a.value)||0;this.c.set(a.value,R-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(a,h,w){this.callback=a,this.callbackThis=h,this.stack=w,this.subscription=new c.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class l{constructor(a){this.j=!1,this.d=a,this.f=b>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(D){const a=Array.from(this.q);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,h,w)=>{if(this.q||(this.q=new O.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),c.Disposable.None;const v=this.q.isEmpty();v&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let R,A;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(A=p.create(),R=this.f.check(A,this.q.size+1)),D&&(A=A??p.create());const M=new E(a,h,A),$=this.q.push(M);v&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,h);const V=M.subscription.set(()=>{R?.(),this.j||(this.d?.onWillRemoveListener?.(this),$(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof c.DisposableStore?w.add(V):Array.isArray(w)&&w.push(V),V}),this.l}fire(a){if(this.q){this.m||(this.m=new u(this.d?.onListenerError));for(const h of this.q)this.m.push(this,h,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=l;class f{constructor(a=L.onUnexpectedError){this.d=a,this.c=new O.LinkedList}get size(){return this.c.size}push(a,h,w){this.c.push(new g(a,h,w))}clear(a){const h=new O.LinkedList;for(const w of this.c)w.emitter!==a&&h.push(w);this.c=h}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(h){this.d(h)}}}}e.EventDeliveryQueue=f;class u extends f{clear(a){this.c.clear()}}class g{constructor(a,h,w){this.emitter=a,this.listener=h,this.event=w}}class y extends l{async fireAsync(a,h,w){if(!!this.q){this.c||(this.c=new O.LinkedList);for(const v of this.q)this.c.push([v,a]);for(;this.c.size>0&&!h.isCancellationRequested;){const[v,R]=this.c.shift(),A=[],M={...R,token:h,waitUntil:$=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");w&&($=w($,v.callback)),A.push($)}};try{v.invoke(M)}catch($){(0,L.onUnexpectedError)($);continue}Object.freeze(A),await Promise.allSettled(A).then($=>{for(const V of $)V.status==="rejected"&&(0,L.onUnexpectedError)(V.reason)})}}}}e.AsyncEmitter=y;class k extends l{constructor(a){super(a),this.h=0,this.s=new O.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=k;class i extends k{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=i;class o extends l{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.d=!1,this.f=[],this.c=new l({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const h={event:a,listener:null};this.f.push(h),this.d&&this.j(h);const w=()=>{this.d&&this.k(h);const v=this.f.indexOf(h);this.f.splice(v,1)};return(0,c.toDisposable)((0,N.once)(w))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(h=>this.c.fire(h))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class t{constructor(){this.c=[]}wrapEvent(a){return(h,w,v)=>a(R=>{const A=this.c[this.c.length-1];A?A.push(()=>h.call(w,R)):h.call(w,R)},void 0,v)}bufferEvents(a){const h=[];this.c.push(h);const w=a();return this.c.pop(),h.forEach(v=>v()),w}}e.EventBufferer=t;class s{constructor(){this.c=!1,this.d=S.None,this.f=c.Disposable.None,this.g=new l({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[25],ae([0,1,3]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const N=Object.freeze(function(D,I){const S=setTimeout(D.bind(I),0);return{dispose(){clearTimeout(S)}}});var c;(function(D){function I(S){return S===D.None||S===D.Cancelled||S instanceof O?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}D.isCancellationToken=I,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(c=e.CancellationToken||(e.CancellationToken={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=c.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=c.None}}e.CancellationTokenSource=T}),define(oe[143],ae([0,1,25]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class N{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new L.CancellationTokenSource,I=this.b(D.token);return this.a={promise:I,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}e.Cache=N;class c{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const I=JSON.stringify(D);return this.b!==I&&(this.b=I,this.a=this.c(D)),this.a}}e.LRUCachedFunction=c;class O{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const I=this.b(D);return this.a.set(D,I),I}}e.CachedFunction=O}),define(oe[27],ae([0,1,143,130]),function(ie,e,L,N){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function O(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=O;const T=/{(\d+)}/g;function D(se,...ue){return ue.length===0?se:se.replace(T,function(me,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?me:ue[ve]})}e.format=D;const I=/{([^}]+)}/g;function S(se,ue){return se.replace(I,(me,we)=>ue[we]??me)}e.format2=S;function P(se){return se.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function b(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function m(se,ue){let me=0;const we=ue.charCodeAt(0);for(let ve=se.length-1;ve>=0;ve--)se.charCodeAt(ve)===we&&me++;return me}e.count=m;function d(se,ue,me="\u2026"){return se.length<=ue?se:`${se.substr(0,ue)}${me}`}e.truncate=d;function p(se,ue=" "){const me=E(se,ue);return l(me,ue)}e.trim=p;function E(se,ue){if(!se||!ue)return se;const me=ue.length;if(me===0||se.length===0)return se;let we=0;for(;se.indexOf(ue,we)===we;)we=we+me;return se.substring(we)}e.ltrim=E;function l(se,ue){if(!se||!ue)return se;const me=ue.length,we=se.length;if(me===0||we===0)return se;let ve=we,Ee=-1;for(;Ee=se.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+me!==ve);){if(Ee===0)return"";ve=Ee}return se.substring(0,ve)}e.rtrim=l;function f(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function u(se){return se.replace(/\*/g,"")}e.stripWildcards=u;function g(se,ue,me={}){if(!se)throw new Error("Cannot create regex from empty string");ue||(se=b(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let we="";return me.global&&(we+="g"),me.matchCase||(we+="i"),me.multiline&&(we+="m"),me.unicode&&(we+="u"),new RegExp(se,we)}e.createRegExp=g;function y(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function k(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function i(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.regExpFlags=i;function o(se){return se.split(/\r\n|\r|\n/)}e.splitLines=o;function n(se){for(let ue=0,me=se.length;ue<me;ue++){const we=se.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=n;function t(se,ue=0,me=se.length){for(let we=ue;we<me;we++){const ve=se.charCodeAt(we);if(ve!==32&&ve!==9)return se.substring(ue,we)}return se.substring(ue,me)}e.getLeadingWhitespace=t;function s(se,ue=se.length-1){for(let me=ue;me>=0;me--){const we=se.charCodeAt(me);if(we!==32&&we!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function r(se,ue,me){const we=[];let ve=0;for(const Ee of se.matchAll(ue)){if(we.push(se.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,we.push(me(Ee[0],...Ee.slice(1),Ee.index,se,Ee.groups))}return we.push(se.slice(ve)),Promise.all(we).then(Ee=>Ee.join(""))}e.replaceAsync=r;function a(se,ue){return se<ue?-1:se>ue?1:0}e.compare=a;function h(se,ue,me=0,we=se.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){const Te=se.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=we-me,Ae=Ee-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=h;function w(se,ue){return v(se,ue,0,se.length,0,ue.length)}e.compareIgnoreCase=w;function v(se,ue,me=0,we=se.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){let Te=se.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return h(se.toLowerCase(),ue.toLowerCase(),me,we,ve,Ee);A(Te)&&(Te-=32),A(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const Re=we-me,Ae=Ee-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=v;function R(se){return se>=48&&se<=57}e.isAsciiDigit=R;function A(se){return se>=97&&se<=122}e.isLowerAsciiLetter=A;function M(se){return se>=65&&se<=90}e.isUpperAsciiLetter=M;function $(se,ue){return se.length===ue.length&&v(se,ue)===0}e.equalsIgnoreCase=$;function V(se,ue){const me=ue.length;return ue.length>se.length?!1:v(se,ue,0,me)===0}e.startsWithIgnoreCase=V;function q(se,ue){const me=Math.min(se.length,ue.length);let we;for(we=0;we<me;we++)if(se.charCodeAt(we)!==ue.charCodeAt(we))return we;return me}e.commonPrefixLength=q;function W(se,ue){const me=Math.min(se.length,ue.length);let we;const ve=se.length-1,Ee=ue.length-1;for(we=0;we<me;we++)if(se.charCodeAt(ve-we)!==ue.charCodeAt(Ee-we))return we;return me}e.commonSuffixLength=W;function X(se){return 55296<=se&&se<=56319}e.isHighSurrogate=X;function Q(se){return 56320<=se&&se<=57343}e.isLowSurrogate=Q;function Y(se,ue){return(se-55296<<10)+(ue-56320)+65536}e.computeCodePoint=Y;function Z(se,ue,me){const we=se.charCodeAt(me);if(X(we)&&me+1<ue){const ve=se.charCodeAt(me+1);if(Q(ve))return Y(we,ve)}return we}e.getNextCodePoint=Z;function x(se,ue){const me=se.charCodeAt(ue-1);if(Q(me)&&ue>1){const we=se.charCodeAt(ue-2);if(X(we))return Y(we,me)}return me}class j{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=x(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Z(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=j;class ee{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new j(ue,me)}nextGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ee=me.offset,Re=ue.getGraphemeBreakType(me.nextCodePoint());if(fe(ve,Re)){me.setOffset(Ee);break}ve=Re}return me.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ee=me.offset,Re=ue.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,ve)){me.setOffset(Ee);break}ve=Re}return we-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function ne(se,ue){return new ee(se,ue).nextGraphemeLength()}e.nextCharLength=ne;function re(se,ue){return new ee(se,ue).prevGraphemeLength()}e.prevCharLength=re;function G(se,ue){ue>0&&Q(se.charCodeAt(ue))&&ue--;const me=ue+ne(se,ue);return[me-re(se,me),me]}e.getCharContainingOffset=G;function H(se){const ue=new ee(se);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.charCount=H;let F;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(se){return F||(F=C()),F.test(se)}e.containsRTL=U;const z=/^[\t\n\r\x20-\x7E]*$/;function K(se){return z.test(se)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=B;function _(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=_;function te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=te;function ce(se,ue){if(se.length<ue)return se;const me=/\b/g;let we=0;for(;me.test(se)&&!(se.length-me.lastIndex<ue);)we=me.lastIndex,me.lastIndex+=1;return se.substring(we).replace(/^\s/,"")}e.lcut=ce;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function pe(se){return se&&(se=se.replace(he,"")),se}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function Se(se){return de(se)?se.substr(1):se}e.stripUTF8BOM=Se;function Ce(se,ue){if(!se||!ue||se.length<ue.length)return!1;const me=ue.length,we=se.toLowerCase();let ve=0,Ee=-1;for(;ve<me;){const Re=we.indexOf(ue[ve],Ee+1);if(Re<0)return!1;Ee=Re,ve++}return!0}e.fuzzyContains=Ce;function De(se,ue=!1){return se?(ue&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=De;function ke(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=ke;function We(se,ue=1){if(ue===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.getNLines=We;function Ye(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.singleLetterHash=Ye;function le(se){return Ie.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=le;function fe(se,ue){return se===0?ue!==5&&ue!==7:se===2&&ue===3?!1:se===4||se===2||se===3||ue===4||ue===2||ue===3?!0:!(se===8&&(ue===8||ue===9||ue===11||ue===12)||(se===11||se===9)&&(ue===9||ue===10)||(se===12||se===10)&&ue===10||ue===5||ue===13||ue===7||se===1||se===13&&ue===14||se===6&&ue===6)}var ge;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,we=me.length/3;let ve=1;for(;ve<=we;)if(ue<me[3*ve])ve=2*ve;else if(ue>me[3*ve+1])ve=2*ve+1;else return me[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(se,ue){if(se===0)return 0;const me=Le(se,ue);if(me!==void 0)return me;const we=new j(ue,se);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Le(se,ue){const me=new j(ue,se);let we=me.prevCodePoint();for(;Be(we)||we===65039||we===8419;){if(me.offset===0)return;we=me.prevCodePoint()}if(!te(we))return;let ve=me.offset;return ve>0&&me.prevCodePoint()===8205&&(ve=me.offset),ve}function Be(se){return 127995<=se&&se<=127999}var Me;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}c=Ne,Ne.c=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new L.LRUCachedFunction(se=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function me(Ue,$e){const ze=new Map(Ue);for(const[et,nt]of $e)ze.set(et,nt);return ze}function we(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,nt]of Ue)$e.has(et)&&ze.set(et,nt);return ze}const ve=c.c.value;let Ee=se.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let Re;for(const Ue of Ee){const $e=ue(ve[Ue]);Re=we(Re,$e)}const Ae=ue(ve._common),Te=me(Ae,Re);return new Ne(Te)}),Ne.e=new N.Lazy(()=>Object.keys(Ne.c.value).filter(se=>!se.startsWith("_"))),e.AmbiguousCharacters=Ne;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ue){return je.e().has(ue)}static get codePoints(){return je.e()}}je.d=void 0,e.InvisibleCharacters=je}),define(oe[47],ae([0,1,14,4,27,11]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function D(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function I(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function S(r,a=L.posix.sep){if(!r)return"";const h=r.length,w=r.charCodeAt(0);if(T(w)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let R=3;const A=R;for(;R<h&&!T(r.charCodeAt(R));R++);if(A!==R&&!T(r.charCodeAt(R+1))){for(R+=1;R<h;R++)if(T(r.charCodeAt(R)))return r.slice(0,R+1).replace(/[\\/]/g,a)}}return a}else if(f(w)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let v=r.indexOf("://");if(v!==-1){for(v+=3;v<h;v++)if(T(r.charCodeAt(v)))return r.slice(0,v+1)}return""}e.getRoot=S;function P(r){if(!N.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const w=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(w===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,a=N.isWindows){const h=a?b:m;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&d.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function E(r,a,h){const w=r===a;return!h||w?w:!r||!a?!1:(0,c.equalsIgnoreCase)(r,a)}e.isEqual=E;function l(r,a,h,w=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,c.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let R=a.length;return a.charAt(a.length-1)===w&&R--,r.charAt(R)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.isEqualOrParent=l;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function u(r,a){return N.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),N.isWindows?(r=(0,c.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,c.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=u;function g(r){const a=(0,L.normalize)(r);return N.isWindows?r.length>3?!1:y(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function y(r,a=N.isWindows){return a?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function k(r){return y(r)?r[0]:void 0}e.getDriveLetter=k;function i(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function o(r){const a=r.split(":");let h,w,v;for(const R of a){const A=Number(R);(0,O.isNumber)(A)?w===void 0?w=A:v===void 0&&(v=A):h=h?[h,R].join(":"):R}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:w!==void 0?w:void 0,column:v!==void 0?v:w!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(r,a,h=8){let w="";for(let R=0;R<h;R++){let A;R===0&&N.isWindows&&!a&&(h===3||h===4)?A=t:A=n,w+=A.charAt(Math.floor(Math.random()*A.length))}let v;return a?v=`${a}-${w}`:v=w,r?(0,L.join)(r,v):v}e.randomPath=s}),define(oe[53],ae([0,1,27]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function N(f){return c(f,0)}e.hash=N;function c(f,u){switch(typeof f){case"object":return f===null?O(349,u):Array.isArray(f)?I(f,u):S(f,u);case"string":return D(f,u);case"boolean":return T(f,u);case"number":return O(f,u);case"undefined":return O(937,u);default:return O(617,u)}}e.doHash=c;function O(f,u){return(u<<5)-u+f|0}e.numberHash=O;function T(f,u){return O(f?433:863,u)}function D(f,u){u=O(149417,u);for(let g=0,y=f.length;g<y;g++)u=O(f.charCodeAt(g),u);return u}e.stringHash=D;function I(f,u){return u=O(104579,u),f.reduce((g,y)=>c(y,g),u)}function S(f,u){return u=O(181387,u),Object.keys(f).sort().reduce((g,y)=>(g=D(y,g),c(f[y],g)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=c(u,this.g),this.g}}e.Hasher=P;var b;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(f,u,g=32){const y=g-u,k=~((1<<y)-1);return(f<<u|(k&f)>>>y)>>>0}function d(f,u=0,g=f.byteLength,y=0){for(let k=0;k<g;k++)f[u+k]=y}function p(f,u,g="0"){for(;f.length<u;)f=g+f;return f}function E(f,u=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(g=>g.toString(16).padStart(2,"0")).join(""):p((f>>>0).toString(16),u/4)}e.toHexString=E;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const g=u.length;if(g===0)return;const y=this.p;let k=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=u.charCodeAt(0),n=0);;){let t=o;if(L.isHighSurrogate(o))if(n+1<g){const s=u.charCodeAt(n+1);L.isLowSurrogate(s)?(n++,t=L.computeCodePoint(o,s)):t=65533}else{i=o;break}else L.isLowSurrogate(o)&&(t=65533);if(k=this.w(y,k,t),n++,n<g)o=u.charCodeAt(n);else break}this.r=k,this.u=i}w(u,g,y){return y<128?u[g++]=y:y<2048?(u[g++]=192|(y&1984)>>>6,u[g++]=128|(y&63)>>>0):y<65536?(u[g++]=224|(y&61440)>>>12,u[g++]=128|(y&4032)>>>6,u[g++]=128|(y&63)>>>0):(u[g++]=240|(y&1835008)>>>18,u[g++]=128|(y&258048)>>>12,u[g++]=128|(y&4032)>>>6,u[g++]=128|(y&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=l.g,g=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let y=this.h,k=this.l,i=this.m,o=this.n,n=this.o,t,s,r;for(let a=0;a<80;a++)a<20?(t=k&i|~k&o,s=1518500249):a<40?(t=k^i^o,s=1859775393):a<60?(t=k&i|k&o|i&o,s=2400959708):(t=k^i^o,s=3395469782),r=m(y,5)+t+n+s+u.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(k,30),k=y,y=r;this.h=this.h+y&4294967295,this.l=this.l+k&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}l.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=l}),define(oe[90],ae([0,1,27]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(c){c[c.Ignore=0]="Ignore",c[c.Info=1]="Info",c[c.Warning=2]="Warning",c[c.Error=3]="Error"})(N||(N={})),function(c){const O="error",T="warning",D="warn",I="info",S="ignore";function P(m){return m?L.equalsIgnoreCase(O,m)?c.Error:L.equalsIgnoreCase(T,m)||L.equalsIgnoreCase(D,m)?c.Warning:L.equalsIgnoreCase(I,m)?c.Info:c.Ignore:c.Ignore}c.fromValue=P;function b(m){switch(m){case c.Error:return O;case c.Warning:return T;case c.Info:return I;default:return S}}c.toString=b}(N||(N={})),e.default=N}),define(oe[48],ae([0,1,21,27]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class c{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const p=d.charCodeAt(0),E=this.b.charCodeAt(this.c);return p-E}value(){return this.b[this.c]}}e.StringIterator=c;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,N.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,N.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=O;class T{constructor(d=!0,p=!0){this.f=d,this.g=p}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let p=d.length-1;p>=0;p--,this.c--){const E=this.b.charCodeAt(p);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,N.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,N.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var D;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(D||(D={}));class I{constructor(d,p){this.f=d,this.g=p,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,N.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,N.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,N.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,N.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(P||(P={}));class b{static forUris(d=()=>!1,p=()=>!1){return new b(new I(d,p))}static forPaths(d=!1){return new b(new T(void 0,!d))}static forStrings(){return new b(new c)}static forConfigKeys(){return new b(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,p){if(p){const E=p.slice(0);(0,L.shuffle)(E);for(const l of E)this.set(l,d)}else{const E=d.slice(0);(0,L.shuffle)(E);for(const l of E)this.set(l[0],l[1])}}set(d,p){const E=this.b.reset(d);let l;this.c||(this.c=new S,this.c.segment=E.value());const f=[];for(l=this.c;;){const g=E.cmp(l.segment);if(g>0)l.left||(l.left=new S,l.left.segment=E.value()),f.push([-1,l]),l=l.left;else if(g<0)l.right||(l.right=new S,l.right.segment=E.value()),f.push([1,l]),l=l.right;else if(E.hasNext())E.next(),l.mid||(l.mid=new S,l.mid.segment=E.value()),f.push([0,l]),l=l.mid;else break}const u=l.value;l.value=p,l.key=d;for(let g=f.length-1;g>=0;g--){const y=f[g][1];y.updateHeight();const k=y.balanceFactor();if(k<-1||k>1){const i=f[g][0],o=f[g+1][0];if(i===1&&o===1)f[g][1]=y.rotateLeft();else if(i===-1&&o===-1)f[g][1]=y.rotateRight();else if(i===1&&o===-1)y.right=f[g+1][1]=f[g+1][1].rotateRight(),f[g][1]=y.rotateLeft();else if(i===-1&&o===1)y.left=f[g+1][1]=f[g+1][1].rotateLeft(),f[g][1]=y.rotateRight();else throw new Error;if(g>0)switch(f[g-1][0]){case-1:f[g-1][1].left=f[g][1];break;case 1:f[g-1][1].right=f[g][1];break;case 0:f[g-1][1].mid=f[g][1];break}else this.c=f[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const p=this.b.reset(d);let E=this.c;for(;E;){const l=p.cmp(E.segment);if(l>0)E=E.left;else if(l<0)E=E.right;else if(p.hasNext())p.next(),E=E.mid;else break}return E}has(d){const p=this.d(d);return!(p?.value===void 0&&p?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,p){const E=this.b.reset(d),l=[];let f=this.c;for(;f;){const u=E.cmp(f.segment);if(u>0)l.push([-1,f]),f=f.left;else if(u<0)l.push([1,f]),f=f.right;else if(E.hasNext())E.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(p?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this.f(f.right);if(u.key){const{key:g,value:y,segment:k}=u;this.e(u.key,!1),f.key=g,f.value=y,f.segment=k}}else{const u=f.left??f.right;if(l.length>0){const[g,y]=l[l.length-1];switch(g){case-1:y.left=u;break;case 0:y.mid=u;break;case 1:y.right=u;break}}else this.c=u}for(let u=l.length-1;u>=0;u--){const g=l[u][1];g.updateHeight();const y=g.balanceFactor();if(y>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),l[u][1]=g.rotateLeft()):y<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),l[u][1]=g.rotateRight()),u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const p=this.b.reset(d);let E=this.c,l;for(;E;){const f=p.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(p.hasNext())p.next(),l=E.value||l,E=E.mid;else break}return E&&E.value||l}findSuperstr(d){return this.g(d,!1)}g(d,p){const E=this.b.reset(d);let l=this.c;for(;l;){const f=E.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(E.hasNext())E.next(),l=l.mid;else return l.mid?this.h(l.mid):p?l.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[p,E]of this)d(E,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const p=[];return this.j(d,p),p[Symbol.iterator]()}j(d,p){!d||(d.left&&this.j(d.left,p),d.value&&p.push([d.key,d.value]),d.mid&&this.j(d.mid,p),d.right&&this.j(d.right,p))}_isBalanced(){const d=p=>{if(!p)return!0;const E=p.balanceFactor();return E<-1||E>1?!1:d(p.left)&&d(p.right)};return d(this.c)}}e.TernarySearchTree=b}),define(oe[12],ae([0,1,14,4]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const c=/^\w[\w\d+.-]*$/,O=/^\//,T=/^\/\//;function D(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!c.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!O.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(n,t){return!n&&!t?"file":n}function S(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(t){return t instanceof d?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,s,r,a,h,w=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=I(t,w),this.authority=s||P,this.path=S(this.scheme,r||P),this.query=a||P,this.fragment=h||P,D(this,w))}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:r,path:a,query:h,fragment:w}=t;return s===void 0?s=this.scheme:s===null&&(s=P),r===void 0?r=this.authority:r===null&&(r=P),a===void 0?a=this.path:a===null&&(a=P),h===void 0?h=this.query:h===null&&(h=P),w===void 0?w=this.fragment:w===null&&(w=P),s===this.scheme&&r===this.authority&&a===this.path&&h===this.query&&w===this.fragment?this:new E(s,r,a,h,w)}static parse(t,s=!1){const r=m.exec(t);return r?new E(r[2]||P,o(r[4]||P),o(r[5]||P),o(r[7]||P),o(r[9]||P),s):new E(P,P,P,P,P)}static file(t){let s=P;if(N.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const r=t.indexOf(b,2);r===-1?(s=t.substring(2),t=b):(s=t.substring(2,r),t=t.substring(r)||b)}return new E("file",s,t,P,P)}static from(t){const s=new E(t.scheme,t.authority,t.path,t.query,t.fragment);return D(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let r;return N.isWindows&&t.scheme==="file"?r=d.file(L.win32.join(g(t,!0),...s)).path:r=L.posix.join(t.path,...s),t.with({path:r})}toString(t=!1){return y(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof d)return t;{const s=new E(t);return s._formatted=t.external,s._fsPath=t._sep===p?t.fsPath:null,s}}else return t}}e.URI=d;const p=N.isWindows?1:void 0;class E extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(n,t,s){let r,a=-1;for(let h=0;h<n.length;h++){const w=n.charCodeAt(h);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||t&&w===47||s&&w===91||s&&w===93||s&&w===58)a!==-1&&(r+=encodeURIComponent(n.substring(a,h)),a=-1),r!==void 0&&(r+=n.charAt(h));else{r===void 0&&(r=n.substr(0,h));const v=l[w];v!==void 0?(a!==-1&&(r+=encodeURIComponent(n.substring(a,h)),a=-1),r+=v):a===-1&&(a=h)}}return a!==-1&&(r+=encodeURIComponent(n.substring(a))),r!==void 0?r:n}function u(n){let t;for(let s=0;s<n.length;s++){const r=n.charCodeAt(s);r===35||r===63?(t===void 0&&(t=n.substr(0,s)),t+=l[r]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,N.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function y(n,t){const s=t?u:f;let r="",{scheme:a,authority:h,path:w,query:v,fragment:R}=n;if(a&&(r+=a,r+=":"),(h||a==="file")&&(r+=b,r+=b),h){let A=h.indexOf("@");if(A!==-1){const M=h.substr(0,A);h=h.substr(A+1),A=M.lastIndexOf(":"),A===-1?r+=s(M,!1,!1):(r+=s(M.substr(0,A),!1,!1),r+=":",r+=s(M.substr(A+1),!1,!0)),r+="@"}h=h.toLowerCase(),A=h.lastIndexOf(":"),A===-1?r+=s(h,!1,!0):(r+=s(h.substr(0,A),!1,!0),r+=h.substr(A))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const A=w.charCodeAt(1);A>=65&&A<=90&&(w=`/${String.fromCharCode(A+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const A=w.charCodeAt(0);A>=65&&A<=90&&(w=`${String.fromCharCode(A+32)}:${w.substr(2)}`)}r+=s(w,!0,!1)}return v&&(r+="?",r+=s(v,!1,!1)),R&&(r+="#",r+=t?R:f(R,!1,!1)),r}function k(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+k(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,t=>k(t)):n}}),define(oe[144],ae([0,1,12]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function N(S){const P=S;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=N;function c(S){const P=[];let b;try{const m=JSON.parse(S.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),b=d.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",S.arguments)}return{args:P,stack:b}}e.parse=c;function O(S){if(typeof S!="string")return O(c(S).stack);const P=S;if(P){const b=T(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=O;function T(S){if(!S)return S;const P=S.indexOf(`
`);return P===-1?S:S.substring(0,P)}function D(S,P){const{args:b,stack:m}=c(S),d=typeof b[0]=="string"&&b.length===1;let p=T(m);p&&(p=`(${p.trim()})`);let E=[];if(typeof b[0]=="string"?p&&d?E=[`%c[${P}] %c${b[0]} %c${p}`,I("blue"),I(""),I("grey")]:E=[`%c[${P}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:E=[`%c[${P}]%`,I("blue"),...b],p&&!d&&E.push(p),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,E)}e.log=D;function I(S){return`color: ${S}`}}),define(oe[91],ae([0,1,16,27,12]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(S){return JSON.stringify(S,D)}e.stringify=O;function T(S){let P=JSON.parse(S);return P=I(P),P}e.parse=T;function D(S,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,N.regExpFlags)(P)}:P}function I(S,P=0){if(!S||P>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return c.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof L.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let b=0;b<S.length;++b)S[b]=I(S[b],P+1);else for(const b in S)Object.hasOwnProperty.call(S,b)&&(S[b]=I(S[b],P+1))}return S}e.revive=I}),define(oe[22],ae([0,1,10,4,12]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(O=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${O.vscodeRemoteResource}`}set(P,b,m){this.a[P]=b,this.b[P]=m}setConnectionToken(P,b){this.c[P]=b}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(l){return L.onUnexpectedError(l),P}const b=P.authority;let m=this.a[b];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const d=this.b[b],p=this.c[b];let E=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),c.URI.from({scheme:N.isWeb?this.d:O.vscodeRemoteResource,authority:`${m}:${d}`,path:this.f,query:E})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(P){const b=this.b(P,ie);return this.uriToBrowserUri(b)}uriToBrowserUri(P){return P.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===O.file&&(N.isNative||N.isWebWorker&&N.globals.origin===`${O.vscodeFileResource}://${D.a}`)?P.with({scheme:O.vscodeFileResource,authority:P.authority||D.a,query:null,fragment:null}):P}asFileUri(P){const b=this.b(P,ie);return this.uriToFileUri(b)}uriToFileUri(P){return P.scheme===O.vscodeFileResource?P.with({scheme:O.file,authority:P.authority!==D.a?P.authority:null,query:null,fragment:null}):P}b(P,b){return c.URI.isUri(P)?P:c.URI.parse(b.toUrl(P))}}D.a="vscode-app",e.FileAccess=new D;var I;(function(S){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(P.get("3"));const b="vscode-coi";function m(p){let E;typeof p=="string"?E=new URL(p).searchParams:p instanceof URL?E=p.searchParams:c.URI.isUri(p)&&(E=new URL(p.toString(!0)).searchParams);const l=E?.get(b);if(!!l)return P.get(l)}S.getHeadersFromQuery=m;function d(p,E,l){if(!globalThis.crossOriginIsolated)return;const f=E&&l?"3":l?"2":"1";p instanceof URLSearchParams?p.set(b,f):p[b]=f}S.addSearchParam=d})(I=e.COI||(e.COI={}))}),define(oe[23],ae([0,1,47,22,14,4,27,12]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(d){return(0,D.uriToFsPath)(d,!0)}e.originalFSPath=I;class S{constructor(p){this.a=p}compare(p,E,l=!1){return p===E?0:(0,T.compare)(this.getComparisonKey(p,l),this.getComparisonKey(E,l))}isEqual(p,E,l=!1){return p===E?!0:!p||!E?!1:this.getComparisonKey(p,l)===this.getComparisonKey(E,l)}getComparisonKey(p,E=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,E,l=!1){if(p.scheme===E.scheme){if(p.scheme===N.Schemas.file)return L.isEqualOrParent(I(p),I(E),this.a(p))&&p.query===E.query&&(l||p.fragment===E.fragment);if((0,e.isEqualAuthority)(p.authority,E.authority))return L.isEqualOrParent(p.path,E.path,this.a(p),"/")&&p.query===E.query&&(l||p.fragment===E.fragment)}return!1}joinPath(p,...E){return D.URI.joinPath(p,...E)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return c.posix.basename(p.path)}extname(p){return c.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let E;return p.scheme===N.Schemas.file?E=D.URI.file(c.dirname(I(p))).path:(E=c.posix.dirname(p.path),p.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),E="/")),p.with({path:E})}normalizePath(p){if(!p.path.length)return p;let E;return p.scheme===N.Schemas.file?E=D.URI.file(c.normalize(I(p))).path:E=c.posix.normalize(p.path),p.with({path:E})}relativePath(p,E){if(p.scheme!==E.scheme||!(0,e.isEqualAuthority)(p.authority,E.authority))return;if(p.scheme===N.Schemas.file){const u=c.relative(I(p),I(E));return O.isWindows?L.toSlashes(u):u}let l=p.path||"/";const f=E.path||"/";if(this.a(p)){let u=0;for(const g=Math.min(l.length,f.length);u<g&&!(l.charCodeAt(u)!==f.charCodeAt(u)&&l.charAt(u).toLowerCase()!==f.charAt(u).toLowerCase());u++);l=f.substr(0,u)+l.substr(u)}return c.posix.relative(l,f)}resolvePath(p,E){if(p.scheme===N.Schemas.file){const l=D.URI.file(c.resolve(I(p),E));return p.with({authority:l.authority,path:l.path})}return E=L.toPosixPath(E),p.with({path:c.posix.resolve(p.path,E)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,E){return p===E||p!==void 0&&E!==void 0&&(0,T.equalsIgnoreCase)(p,E)}hasTrailingPathSeparator(p,E=c.sep){if(p.scheme===N.Schemas.file){const l=I(p);return l.length>L.getRoot(l).length&&l[l.length-1]===E}else{const l=p.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,E=c.sep){return(0,e.hasTrailingPathSeparator)(p,E)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,E=c.sep){let l=!1;if(p.scheme===N.Schemas.file){const f=I(p);l=f!==void 0&&f.length===L.getRoot(f).length&&f[f.length-1]===E}else{E="/";const f=p.path;l=f.length===1&&f.charCodeAt(f.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(p,E)?p.with({path:p.path+"/"}):p}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(d=>d.scheme===N.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new S(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,p){const E=[];for(let l=0;l<d.length;l++){const f=p(d[l]);d.some((u,g)=>g===l?!1:(0,e.isEqualOrParent)(f,p(u)))||E.push(d[l])}return E}e.distinctParents=P;var b;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function p(E){const l=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[y,k]=g.split(":");y&&k&&l.set(y,k)});const u=E.path.substring(0,E.path.indexOf(";"));return u&&l.set(d.META_DATA_MIME,u),l}d.parseMetaData=p})(b=e.DataUri||(e.DataUri={}));function m(d,p,E){if(p){let l=d.path;return l&&l[0]!==c.posix.sep&&(l=c.posix.sep+l),d.with({scheme:E,authority:p,path:l})}return d.with({scheme:E})}e.toLocalResource=m}),define(oe[6],ae([0,1,25,10,3,2,23,4,133]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function P(H){const F=new L.CancellationTokenSource,C=H(F.token),U=new Promise((z,K)=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),K(new N.CancellationError)});Promise.resolve(C).then(_=>{B.dispose(),F.dispose(),z(_)},_=>{B.dispose(),F.dispose(),K(_)})});return new class{cancel(){F.cancel()}then(z,K){return U.then(z,K)}catch(z){return this.then(void 0,z)}finally(z){return U.finally(z)}}}e.createCancelablePromise=P;function b(H,F,C){return new Promise((U,z)=>{const K=F.onCancellationRequested(()=>{K.dispose(),U(C)});H.then(U,z).finally(()=>K.dispose())})}e.raceCancellation=b;function m(H,F){return new Promise((C,U)=>{const z=F.onCancellationRequested(()=>{z.dispose(),U(new N.CancellationError)});H.then(C,U).finally(()=>z.dispose())})}e.raceCancellationError=m;async function d(H){let F=-1;const C=H.map((z,K)=>z.then(B=>(F=K,B))),U=await Promise.race(C);return H.forEach((z,K)=>{K!==F&&z.cancel()}),U}e.raceCancellablePromises=d;function p(H,F,C){let U;const z=setTimeout(()=>{U?.(void 0),C?.()},F);return Promise.race([H.finally(()=>clearTimeout(z)),new Promise(K=>U=K)])}e.raceTimeout=p;function E(H){return new Promise((F,C)=>{const U=H();S(U)?U.then(F,C):F(U)})}e.asPromise=E;class l{constructor(){this.a=null,this.b=null,this.d=null}queue(F){if(this.a){if(this.d=F,!this.b){const C=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(C,C).then(U)})}return new Promise((C,U)=>{this.b.then(C,U)})}return this.a=F(),new Promise((C,U)=>{this.a.then(z=>{this.a=null,C(z)},z=>{this.a=null,U(z)})})}}e.Throttler=l;class f{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.Sequencer=f;class u{constructor(){this.a=new Map}queue(F,C){const z=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.a.get(F)===z&&this.a.delete(F)});return this.a.set(F,z),z}}e.SequencerByKey=u;const g=(H,F)=>{let C=!0;const U=setTimeout(()=>{C=!1,F()},H);return{isTriggered:()=>C,dispose:()=>{clearTimeout(U),C=!1}}},y=H=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,H())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class k{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,C=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((z,K)=>{this.d=z,this.f=K}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=C===I.MicrotaskDelay?y(U):g(C,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=k;class i{constructor(F){this.a=new k(F),this.b=new l}trigger(F,C){return this.a.trigger(()=>this.b.queue(F),C)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((F,C)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class n extends o{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function t(H,F){return F?new Promise((C,U)=>{const z=setTimeout(()=>{K.dispose(),C()},H),K=F.onCancellationRequested(()=>{clearTimeout(z),K.dispose(),U(new N.CancellationError)})}):P(C=>t(H,C))}e.timeout=t;function s(H,F=0){const C=setTimeout(H,F);return(0,O.toDisposable)(()=>clearTimeout(C))}e.disposableTimeout=s;function r(H){const F=[];let C=0;const U=H.length;function z(){return C<U?H[C++]():null}function K(B){B!=null&&F.push(B);const _=z();return _?_.then(K):Promise.resolve(F)}return Promise.resolve(null).then(K)}e.sequence=r;function a(H,F=U=>!!U,C=null){let U=0;const z=H.length,K=()=>{if(U>=z)return Promise.resolve(C);const B=H[U++];return Promise.resolve(B()).then(te=>F(te)?Promise.resolve(te):K())};return K()}e.first=a;function h(H,F=U=>!!U,C=null){if(H.length===0)return Promise.resolve(C);let U=H.length;const z=()=>{U=-1;for(const K of H)K.cancel?.()};return new Promise((K,B)=>{for(const _ of H)_.then(te=>{--U>=0&&F(te)?(z(),K(te)):U===0&&K(C)}).catch(te=>{--U>=0&&(z(),B(te))})})}e.firstParallel=h;class w{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new c.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((C,U)=>{this.f.push({factory:F,c:C,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const C=F.factory();C.then(F.c,F.e),C.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=w;class v extends w{constructor(){super(1)}}e.Queue=v;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new x;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,C=T.extUri){const U=C.getComparisonKey(F);let z=this.a.get(U);return z||(z=new v,c.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,z)),z}f(){!this.d()||this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.ResourceQueue=R;class A{constructor(F,C){this.a=-1,typeof F=="function"&&typeof C=="number"&&this.setIfNotSet(F,C)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,C){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},C)}setIfNotSet(F,C){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},C))}}e.TimeoutTimer=A;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,C){this.cancel(),this.a=setInterval(()=>{F()},C)}}e.IntervalTimer=M;class ${constructor(F,C){this.b=-1,this.a=F,this.d=C,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class V{constructor(F,C){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.a=F,this.b=C,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class q extends ${constructor(F,C){super(F,C),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=q;class W extends O.Disposable{constructor(F,C){super(),this.g=F,this.h=C,this.a=[],this.b=this.B(new O.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const C of F)this.a.push(C);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,D.setTimeout0)(()=>{if(F)return;const C=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(H,F)=>{const C=requestIdleCallback(H,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(C))}}}}();class X{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(C){this.g=C}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=X;async function Q(H,F,C){let U;for(let z=0;z<C;z++)try{return await H()}catch(K){U=K,await t(F)}throw U}e.retry=Q;class Y{hasPending(F){return this.a?typeof F=="number"?this.a.taskId===F:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(F,C,U){return this.a={taskId:F,cancel:()=>U?.(),promise:C},C.then(()=>this.d(F),()=>this.d(F)),C}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this.b)this.b.run=F;else{let C,U;const z=new Promise((K,B)=>{C=K,U=B});this.b={run:F,promise:z,promiseResolve:C,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Y;class Z{constructor(F,C=()=>Date.now()){this.d=F,this.f=C,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((F,C)=>{this.a=F,this.b=C})}complete(F){return new Promise(C=>{this.a(F),this.f=!0,C()})}error(F){return new Promise(C=>{this.b(F),this.d=!0,C()})}cancel(){new Promise(F=>{this.b(new N.CancellationError),this.d=!0,F()})}}e.DeferredPromise=x;var j;(function(H){async function F(U){let z;const K=await Promise.all(U.map(B=>B.then(_=>_,_=>{z||(z=_)})));if(typeof z<"u")throw z;return K}H.settled=F;function C(U){return new Promise(async(z,K)=>{try{await U(z,K)}catch(B){K(B)}})}H.withAsyncBody=C})(j=e.Promises||(e.Promises={}));var ee;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(ee||(ee={}));class ne{static fromArray(F){return new ne(C=>{C.emitMany(F)})}static fromPromise(F){return new ne(async C=>{C.emitMany(await F)})}static fromPromises(F){return new ne(async C=>{await Promise.all(F.map(async U=>C.emitOne(await U)))})}static merge(F){return new ne(async C=>{await Promise.all(F.map(async U=>{for await(const z of U)C.emitOne(z)}))})}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new c.Emitter,queueMicrotask(async()=>{const C={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(F(C)),this.j()}catch(U){this.k(U)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await c.Event.toPromise(this.f.event)}while(!0)}}}static map(F,C){return new ne(async U=>{for await(const z of F)U.emitOne(C(z))})}map(F){return ne.map(this,F)}static filter(F,C){return new ne(async U=>{for await(const z of F)C(z)&&U.emitOne(z)})}filter(F){return ne.filter(this,F)}static coalesce(F){return ne.filter(F,C=>!!C)}coalesce(){return ne.coalesce(this)}static async toPromise(F){const C=[];for await(const U of F)C.push(U);return C}toPromise(){return ne.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}ne.EMPTY=ne.fromArray([]),e.AsyncIterableObject=ne;class re extends ne{constructor(F,C){super(C),this.l=F}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function G(H){const F=new L.CancellationTokenSource,C=H(F.token);return new re(F,async U=>{const z=F.token.onCancellationRequested(()=>{z.dispose(),F.dispose(),U.reject(new N.CancellationError)});try{for await(const K of C){if(F.token.isCancellationRequested)return;U.emitOne(K)}z.dispose(),F.dispose()}catch(K){z.dispose(),F.dispose(),U.reject(K)}})}e.createCancelableAsyncIterable=G}),define(oe[92],ae([0,1,21,6,47,37,14,4,27]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",b="[^/\\\\]",m=/\//g;function d(Z,x){switch(Z){case 0:return"";case 1:return`${b}*?`;default:return`(?:${P}|${b}+${P}${x?`|${P}${b}+`:""})*?`}}function p(Z,x){if(!Z)return[];const j=[];let ee=!1,ne=!1,re="";for(const G of Z){switch(G){case x:if(!ee&&!ne){j.push(re),re="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}re+=G}return re&&j.push(re),j}e.splitGlobAware=p;function E(Z){if(!Z)return"";let x="";const j=p(Z,e.GLOB_SPLIT);if(j.every(ee=>ee===e.GLOBSTAR))x=".*";else{let ee=!1;j.forEach((ne,re)=>{if(ne===e.GLOBSTAR){if(ee)return;x+=d(2,re===j.length-1)}else{let G=!1,H="",F=!1,C="";for(const U of ne){if(U!=="}"&&G){H+=U;continue}if(F&&(U!=="]"||!C)){let z;U==="-"?z=U:(U==="^"||U==="!")&&!C?z="^":U===e.GLOB_SPLIT?z="":z=(0,I.escapeRegExpCharacters)(U),C+=z;continue}switch(U){case"{":G=!0;continue;case"[":F=!0;continue;case"}":{x+=`(?:${p(H,",").map(B=>E(B)).join("|")})`,G=!1,H="";break}case"]":{x+="["+C+"]",F=!1,C="";break}case"?":x+=b;continue;case"*":x+=d(1);continue;default:x+=(0,I.escapeRegExpCharacters)(U)}}re<j.length-1&&(j[re+1]!==e.GLOBSTAR||re+2<j.length)&&(x+=P)}ee=ne===e.GLOBSTAR})}return x}const l=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.LRUCache(1e4),o=function(){return!1},n=function(){return null};function t(Z,x){if(!Z)return n;let j;typeof Z!="string"?j=Z.pattern:j=Z,j=j.trim();const ee=`${j}_${!!x.trimForExclusions}`;let ne=i.get(ee);if(ne)return s(ne,Z);let re;return l.test(j)?ne=a(j.substr(4),j):(re=f.exec(r(j,x)))?ne=h(re[1],j):(x.trimForExclusions?g:u).test(j)?ne=w(j,x):(re=y.exec(r(j,x)))?ne=v(re[1].substr(1),j,!0):(re=k.exec(r(j,x)))?ne=v(re[1],j,!1):ne=R(j),i.set(ee,ne),s(ne,Z)}function s(Z,x){if(typeof x=="string")return Z;const j=function(ee,ne){return(0,c.isEqualOrParent)(ee,x.base,!D.isLinux)?Z((0,I.ltrim)(ee.substr(x.base.length),T.sep),ne):null};return j.allBasenames=Z.allBasenames,j.allPaths=Z.allPaths,j.basenames=Z.basenames,j.patterns=Z.patterns,j}function r(Z,x){return x.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function a(Z,x){return function(j,ee){return typeof j=="string"&&j.endsWith(Z)?x:null}}function h(Z,x){const j=`/${Z}`,ee=`\\${Z}`,ne=function(G,H){return typeof G!="string"?null:H?H===Z?x:null:G===Z||G.endsWith(j)||G.endsWith(ee)?x:null},re=[Z];return ne.basenames=re,ne.patterns=[x],ne.allBasenames=re,ne}function w(Z,x){const j=Q(Z.slice(1,-1).split(",").map(H=>t(H,x)).filter(H=>H!==n),Z),ee=j.length;if(!ee)return n;if(ee===1)return j[0];const ne=function(H,F){for(let C=0,U=j.length;C<U;C++)if(j[C](H,F))return Z;return null},re=j.find(H=>!!H.allBasenames);re&&(ne.allBasenames=re.allBasenames);const G=j.reduce((H,F)=>F.allPaths?H.concat(F.allPaths):H,[]);return G.length&&(ne.allPaths=G),ne}function v(Z,x,j){const ee=T.sep===T.posix.sep,ne=ee?Z:Z.replace(m,T.sep),re=T.sep+ne,G=T.posix.sep+Z;let H;return j?H=function(F,C){return typeof F=="string"&&(F===ne||F.endsWith(re)||!ee&&(F===Z||F.endsWith(G)))?x:null}:H=function(F,C){return typeof F=="string"&&(F===ne||!ee&&F===Z)?x:null},H.allPaths=[(j?"*/":"./")+Z],H}function R(Z){try{const x=new RegExp(`^${E(Z)}$`);return function(j){return x.lastIndex=0,typeof j=="string"&&x.test(j)?Z:null}}catch{return n}}function A(Z,x,j){return!Z||typeof x!="string"?!1:M(Z)(x,void 0,j)}e.match=A;function M(Z,x={}){if(!Z)return o;if(typeof Z=="string"||$(Z)){const j=t(Z,x);if(j===n)return o;const ee=function(ne,re){return!!j(ne,re)};return j.allBasenames&&(ee.allBasenames=j.allBasenames),j.allPaths&&(ee.allPaths=j.allPaths),ee}return W(Z,x)}e.parse=M;function $(Z){const x=Z;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=$;function V(Z){return Z.allBasenames||[]}e.getBasenameTerms=V;function q(Z){return Z.allPaths||[]}e.getPathTerms=q;function W(Z,x){const j=Q(Object.getOwnPropertyNames(Z).map(H=>X(H,Z[H],x)).filter(H=>H!==n)),ee=j.length;if(!ee)return n;if(!j.some(H=>!!H.requiresSiblings)){if(ee===1)return j[0];const H=function(U,z){let K;for(let B=0,_=j.length;B<_;B++){const te=j[B](U,z);if(typeof te=="string")return te;(0,N.isThenable)(te)&&(K||(K=[]),K.push(te))}return K?(async()=>{for(const B of K){const _=await B;if(typeof _=="string")return _}return null})():null},F=j.find(U=>!!U.allBasenames);F&&(H.allBasenames=F.allBasenames);const C=j.reduce((U,z)=>z.allPaths?U.concat(z.allPaths):U,[]);return C.length&&(H.allPaths=C),H}const ne=function(H,F,C){let U,z;for(let K=0,B=j.length;K<B;K++){const _=j[K];_.requiresSiblings&&C&&(F||(F=(0,T.basename)(H)),U||(U=F.substr(0,F.length-(0,T.extname)(H).length)));const te=_(H,F,U,C);if(typeof te=="string")return te;(0,N.isThenable)(te)&&(z||(z=[]),z.push(te))}return z?(async()=>{for(const K of z){const B=await K;if(typeof B=="string")return B}return null})():null},re=j.find(H=>!!H.allBasenames);re&&(ne.allBasenames=re.allBasenames);const G=j.reduce((H,F)=>F.allPaths?H.concat(F.allPaths):H,[]);return G.length&&(ne.allPaths=G),ne}function X(Z,x,j){if(x===!1)return n;const ee=t(Z,j);if(ee===n)return n;if(typeof x=="boolean")return ee;if(x){const ne=x.when;if(typeof ne=="string"){const re=(G,H,F,C)=>{if(!C||!ee(G,H))return null;const U=ne.replace("$(basename)",()=>F),z=C(U);return(0,N.isThenable)(z)?z.then(K=>K?Z:null):z?Z:null};return re.requiresSiblings=!0,re}}return ee}function Q(Z,x){const j=Z.filter(H=>!!H.basenames);if(j.length<2)return Z;const ee=j.reduce((H,F)=>{const C=F.basenames;return C?H.concat(C):H},[]);let ne;if(x){ne=[];for(let H=0,F=ee.length;H<F;H++)ne.push(x)}else ne=j.reduce((H,F)=>{const C=F.patterns;return C?H.concat(C):H},[]);const re=function(H,F){if(typeof H!="string")return null;if(!F){let U;for(U=H.length;U>0;U--){const z=H.charCodeAt(U-1);if(z===47||z===92)break}F=H.substr(U)}const C=ee.indexOf(F);return C!==-1?ne[C]:null};re.basenames=ee,re.patterns=ne,re.allBasenames=ee;const G=Z.filter(H=>!H.basenames);return G.push(re),G}function Y(Z,x){return(0,L.equals)(Z,x,(j,ee)=>typeof j=="string"&&typeof ee=="string"?j===ee:typeof j!="string"&&typeof ee!="string"?j.base===ee.base&&j.pattern===ee.pattern:!1)}e.patternsEquals=Y}),define(oe[93],ae([0,1,16,12]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function c(b){return b.toJSON()}class O{constructor(m){this.a=m}transformIncoming(m){const d=this.a.transformIncoming(m);return d===m?m:c(N.URI.from(d))}transformOutgoing(m){const d=this.a.transformOutgoing(m);return d===m?m:c(N.URI.from(d))}transformOutgoingURI(m){const d=this.a.transformOutgoing(m);return d===m?m:N.URI.from(d)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function T(b,m,d){if(!b||d>200)return null;if(typeof b=="object"){if(b instanceof N.URI)return m.transformOutgoing(b);for(const p in b)if(Object.hasOwnProperty.call(b,p)){const E=T(b[p],m,d+1);E!==null&&(b[p]=E)}}return null}function D(b,m){const d=T(b,m,0);return d===null?b:d}e.transformOutgoingURIs=D;function I(b,m,d,p){if(!b||p>200)return null;if(typeof b=="object"){if(b.$mid===1)return d?N.URI.revive(m.transformIncoming(b)):m.transformIncoming(b);if(b instanceof L.VSBuffer)return null;for(const E in b)if(Object.hasOwnProperty.call(b,E)){const l=I(b[E],m,d,p+1);l!==null&&(b[E]=l)}}return null}function S(b,m){const d=I(b,m,!1,0);return d===null?b:d}e.transformIncomingURIs=S;function P(b,m){const d=I(b,m,!0,0);return d===null?b:d}e.transformAndReviveIncomingURIs=P}),define(oe[145],ae([0,1,34,48,31,135]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=N.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,P=0;const b=(0,L.networkInterfaces)();for(const m in b){const d=b[m];if(d)for(const{mac:p,internal:E}of d)E||(P+=1,this.c(p.toUpperCase())&&(S+=1))}this.b=P>0?S/P:0}return this.b}};let T;async function D(S){return T||(T=(async()=>await I(S)||c.generateUuid())()),T}e.getMachineId=D;async function I(S){try{const P=await new Promise((m,d)=>{ie(["crypto"],m,d)}),b=(0,O.getMac)();return P.createHash("sha256").update(b,"utf8").digest("hex")}catch(P){S(P);return}}}),define(oe[28],ae([0,1,54,34,291,6,47,85,14,4,23,12]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function d(W,X=m.UNLINK){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return X===m.UNLINK?E(W):p(W)}async function p(W){try{const X=(0,T.randomPath)((0,N.tmpdir)());try{await L.promises.rename(W,X)}catch(Q){return Q.code==="ENOENT"?void 0:E(W)}E(X).catch(Q=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function E(W){return(0,c.promisify)(L.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function l(W){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function f(W,X){return y(await(X?u(W):(0,c.promisify)(L.readdir)(W)))}async function u(W){try{return await(0,c.promisify)(L.readdir)(W,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const X=[],Q=await f(W);for(const Y of Q){let Z=!1,x=!1,j=!1;try{const ee=await e.Promises.lstat((0,I.join)(W,Y));Z=ee.isFile(),x=ee.isDirectory(),j=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}X.push({name:Y,isFile:()=>Z,isDirectory:()=>x,isSymbolicLink:()=>j})}return X}function g(W){return y(L.readdirSync(W))}e.readdirSync=g;function y(W){return W.map(X=>typeof X=="string"?S.isMacintosh?(0,D.normalizeNFC)(X):X:(X.name=S.isMacintosh?(0,D.normalizeNFC)(X.name):X.name,X))}async function k(W){const X=await f(W),Q=[];for(const Y of X)await o.existsDirectory((0,I.join)(W,Y))&&Q.push(Y);return Q}function i(W,X=1e3){return new Promise(Q=>{let Y=!1;const Z=setInterval(()=>{Y||(Y=!0,L.access(W,x=>{Y=!1,x&&(clearInterval(Z),Q(void 0))}))},X)})}e.whenDeleted=i;var o;(function(W){async function X(Z){let x;try{if(x=await e.Promises.lstat(Z),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(S.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ee}throw j}}W.stat=X;async function Q(Z){try{const{stat:x,symbolicLink:j}=await W.stat(Z);return x.isFile()&&j?.dangling!==!0}catch{}return!1}W.existsFile=Q;async function Y(Z){try{const{stat:x,symbolicLink:j}=await W.stat(Z);return x.isDirectory()&&j?.dangling!==!0}catch{}return!1}W.existsDirectory=Y})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new O.ResourceQueue;function t(W,X,Q){return n.queueFor(b.URI.file(W),P.extUriBiasedIgnorePathCase).queue(()=>{const Y=w(Q);return new Promise((Z,x)=>a(W,X,Y,j=>j?x(j):Z()))})}let s=!0;function r(W){s=W}e.configureFlushOnWrite=r;function a(W,X,Q,Y){if(!s)return L.writeFile(W,X,{mode:Q.mode,flag:Q.flag},Y);L.open(W,Q.flag,Q.mode,(Z,x)=>{if(Z)return Y(Z);L.writeFile(x,X,j=>{if(j)return L.close(x,()=>Y(j));L.fdatasync(x,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),L.close(x,ne=>Y(ne))))})})}function h(W,X,Q){const Y=w(Q);if(!s)return L.writeFileSync(W,X,{mode:Y.mode,flag:Y.flag});const Z=L.openSync(W,Y.flag,Y.mode);try{L.writeFileSync(Z,X);try{L.fdatasyncSync(Z)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),r(!1)}}finally{L.closeSync(Z)}}e.writeFileSync=h;function w(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function v(W,X){if(W!==X)try{await e.Promises.rename(W,X)}catch(Q){if(W.toLowerCase()!==X.toLowerCase()&&Q.code==="EXDEV"||W.endsWith("."))await R(W,X,{preserveSymlinks:!1}),await d(W,m.MOVE);else throw Q}}async function R(W,X,Q){return M(W,X,{root:{source:W,target:X},options:Q,handledSourcePaths:new Set})}const A=511;async function M(W,X,Q){if(Q.handledSourcePaths.has(W))return;Q.handledSourcePaths.add(W);const{stat:Y,symbolicLink:Z}=await o.stat(W);if(Z){if(Q.options.preserveSymlinks)try{return await q(W,X,Q)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(Z.dangling)return}return Y.isDirectory()?$(W,X,Y.mode&A,Q):V(W,X,Y.mode&A)}async function $(W,X,Q,Y){await e.Promises.mkdir(X,{recursive:!0,mode:Q});const Z=await f(W);for(const x of Z)await M((0,I.join)(W,x),(0,I.join)(X,x),Y)}async function V(W,X,Q){await e.Promises.copyFile(W,X),await e.Promises.chmod(X,Q)}async function q(W,X,Q){let Y=await e.Promises.readlink(W);(0,T.isEqualOrParent)(Y,Q.root.source,!S.isLinux)&&(Y=(0,I.join)(Q.root.target,Y.substr(Q.root.source.length+1))),await e.Promises.symlink(Y,X)}e.Promises=new class{get access(){return(0,c.promisify)(L.access)}get stat(){return(0,c.promisify)(L.stat)}get lstat(){return(0,c.promisify)(L.lstat)}get utimes(){return(0,c.promisify)(L.utimes)}get read(){return(W,X,Q,Y,Z)=>new Promise((x,j)=>{L.read(W,X,Q,Y,Z,(ee,ne,re)=>ee?j(ee):x({bytesRead:ne,buffer:re}))})}get readFile(){return(0,c.promisify)(L.readFile)}get write(){return(W,X,Q,Y,Z)=>new Promise((x,j)=>{L.write(W,X,Q,Y,Z,(ee,ne,re)=>ee?j(ee):x({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,c.promisify)(L.appendFile)}get fdatasync(){return(0,c.promisify)(L.fdatasync)}get truncate(){return(0,c.promisify)(L.truncate)}get rename(){return(0,c.promisify)(L.rename)}get copyFile(){return(0,c.promisify)(L.copyFile)}get open(){return(0,c.promisify)(L.open)}get close(){return(0,c.promisify)(L.close)}get symlink(){return(0,c.promisify)(L.symlink)}get readlink(){return(0,c.promisify)(L.readlink)}get chmod(){return(0,c.promisify)(L.chmod)}get mkdir(){return(0,c.promisify)(L.mkdir)}get unlink(){return(0,c.promisify)(L.unlink)}get rmdir(){return(0,c.promisify)(L.rmdir)}get realpath(){return(0,c.promisify)(L.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return k}get writeFile(){return t}get rm(){return d}get move(){return v}get copy(){return R}}}),define(oe[146],ae([0,1,54,14,4,27,28]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(m){if(c.isLinux)return m;const d=(0,N.dirname)(m);if(m===d)return m;const p=((0,N.basename)(m)||m).toLowerCase();try{const l=(0,T.readdirSync)(d).filter(f=>f.toLowerCase()===p);if(l.length===1){const f=D(d);if(f)return(0,N.join)(f,l[0])}else if(l.length>1){const f=l.indexOf(p);if(f>=0){const u=D(d);if(u)return(0,N.join)(u,l[f])}}}catch{}return null}e.realcaseSync=D;async function I(m){if(c.isLinux)return m;const d=(0,N.dirname)(m);if(m===d)return m;const p=((0,N.basename)(m)||m).toLowerCase();try{const l=(await T.Promises.readdir(d)).filter(f=>f.toLowerCase()===p);if(l.length===1){const f=await I(d);if(f)return(0,N.join)(f,l[0])}else if(l.length>1){const f=l.indexOf(p);if(f>=0){const u=await I(d);if(u)return(0,N.join)(u,l[f])}}}catch{}return null}e.realcase=I;async function S(m){try{return await T.Promises.realpath(m)}catch{const p=b(m);return await T.Promises.access(p,L.constants.R_OK),p}}e.realpath=S;function P(m){try{return L.realpathSync(m)}catch{const p=b(m);return L.accessSync(p,L.constants.R_OK),p}}e.realpathSync=P;function b(m){return(0,O.rtrim)((0,N.normalize)(m),N.sep)}}),define(oe[94],ae([0,1,34,14,28]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,T=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var I;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(k,i,o){this.exePath=k,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await c.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:y=!1}={}){return y?S===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:y=!1,findPreview:k=!1}={}){const i=m({useAlternateBitness:y});if(!i)return null;const o=N.join(i,"PowerShell");if(!await c.SymlinkSupport.existsDirectory(o))return null;let n=-1,t=null;for(const a of await c.Promises.readdir(o)){let h=-1;if(k){const v=a.indexOf("-");if(v<0)continue;const R=a.substring(0,v);if(!O.test(R)||a.substring(v+1)!=="preview")continue;h=parseInt(R,10)}else{if(!O.test(a))continue;h=parseInt(a,10)}if(h<=n)continue;const w=N.join(o,a,"pwsh.exe");!await c.SymlinkSupport.existsFile(w)||(t=w,n=h)}if(!t)return null;const s=i.includes("x86")?" (x86)":"",r=k?" Preview":"";return new b(t,`PowerShell${r}${s}`,!0)}async function p({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const k=N.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await c.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=y?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await c.Promises.readdir(k))if(i.test(n)){const t=N.join(k,n,"pwsh.exe");return new b(t,o)}return null}function E(){const y=N.join(L.homedir(),".dotnet","tools","pwsh.exe");return new b(y,".NET Core PowerShell Global Tool")}function l(){const y=N.join(process.env.windir,S===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(y,"Windows PowerShell",!0)}async function*f(){let y=await d();y&&(yield y),y=await d({useAlternateBitness:!0}),y&&(yield y),y=await p(),y&&(yield y),y=E(),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await d({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=l(),y&&(yield y)}async function*u(){for await(const y of f())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=u;async function g(){for await(const y of u())return y;return null}e.getFirstAvailablePowerShellInstallation=g}),define(oe[95],ae([0,1,14,4,36,88,11,28]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function I(b=c.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function S(b){let m=[],d=!1;const p=function(E){if(d){m.push(E);return}(!b.send(E,f=>{if(f&&console.error(f),d=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(g=>p(g))}})||N.isWindows)&&(d=!0)};return{send:p}}e.createQueuedSender=S;var P;(function(b){async function m(d,p,E){if(L.isAbsolute(d))return d;if(p===void 0&&(p=c.cwd()),L.dirname(d)!=="."||(E===void 0&&T.isString(c.env.PATH)&&(E=c.env.PATH.split(L.delimiter)),E===void 0||E.length===0))return L.join(p,d);async function f(u){if(await D.Promises.exists(u)){let g;try{g=await D.Promises.stat(u)}catch(y){y.message.startsWith("EACCES")&&(g=await D.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of E){let g;if(L.isAbsolute(u)?g=L.join(u,d):g=L.join(p,u,d),await f(g))return g;let y=g+".com";if(await f(y)||(y=g+".exe",await f(y)))return y}return L.join(p,d)}b.findExecutable=m})(P=e.win32||(e.win32={}))}),define(oe[147],ae([0,1,49,22]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function c(T){return new Promise((D,I)=>{let S;const P=new Map;function b(d,p,E,l,f){const u=P.get(p);if(d===T||u){const g={name:m(E),cmd:E,pid:d,ppid:p,load:l,mem:f};P.set(d,g),d===T&&(S=g),u&&(u.children||(u.children=[]),u.children.push(g),u.children.length>1&&(u.children=u.children.sort((y,k)=>y.pid-k.pid)))}}function m(d){const p=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,l=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,g=/--type=([a-zA-Z-]+)/;if(l.exec(d))return"electron-crash-reporter";if(f.exec(d))return"winpty-process";if(u.exec(d))return"console-window-host (Windows internal process)";let y=g.exec(d);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?p.exec(d)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const k=/[a-zA-Z-]+\.js/g;let i="";do y=k.exec(d),y&&(i+=y+" ");while(y);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${i})`:E.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,E)=>{ie(["windows-process-tree"],p,E)}).then(p=>{p.getProcessList(T,E=>{if(!E){I(new Error(`Root process ${T} not found`));return}p.getProcessCpuUsage(E,l=>{const f=new Map;l.forEach(u=>{const g=d(u.commandLine||"");f.set(u.pid,{name:m(g),cmd:g,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),S=f.get(T),S?(f.forEach(u=>{const g=f.get(u.ppid);g&&(g.children||(g.children=[]),g.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((g,y)=>g.pid-y.pid))}),D(S)):I(new Error(`Root process ${T} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let d=function(){let p=[S];const E=[];for(;p.length;){const f=p.shift();f&&(E.push(f.pid),f.children&&(p=p.concat(f.children)))}let l=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);l+=" "+E.join(" "),(0,L.exec)(l,{},(f,u,g)=>{if(f||g)I(f||new Error(g.toString()));else{const y=u.toString().split(`
`);for(let k=0;k<E.length;k++){const i=P.get(E[k]);i.load=parseFloat(y[k])}if(!S){I(new Error(`Root process ${T} not found`));return}D(S)}})};(0,L.exec)("which ps",{},(p,E,l)=>{if(p||l)if(process.platform!=="linux")I(p||new Error(l.toString()));else{const f=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(f,{},(u,g,y)=>{u||y?I(u||new Error(y.toString())):(O(g,b),d())})}else{const f=E.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${f} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,y,k)=>{g||k&&!k.includes("screen size is bogus")?I(g||new Error(k.toString())):(O(y,b),process.platform==="linux"?d():S?D(S):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=c;function O(T,D){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=T.toString().split(`
`);for(const P of S){const b=I.exec(P.trim());b&&b.length===6&&D(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(oe[148],ae([0,1,34,4,94,95]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(b,m){return b===1?N.isWindows?P():O.getWindowsShell(m):I(b,m)}e.getSystemShell=T;let D=null;function I(b,m){if(N.isLinux&&b===2||N.isMacintosh&&b===3)return"/bin/bash";if(!D){let d;if(N.isWindows)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}D=d}return D}let S=null;async function P(){return S||(S=(await(0,c.getFirstAvailablePowerShellInstallation)()).exePath),S}});var ye=this&&this.__decorate||function(ie,e,L,N){var c=arguments.length,O=c<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ie,e,L,N);else for(var D=ie.length-1;D>=0;D--)(T=ie[D])&&(O=(c<3?T(O):c>3?T(e,L,O):T(e,L))||O);return c>3&&O&&Object.defineProperty(e,L,O),O};define(oe[39],ae([0,1,21,6,16,25,62,10,3,2,91,27,11]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(d||(d={}));function p(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(E||(E={}));function l(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(f||(f={}));function u(x){let j=0;for(let ee=0;;ee+=7){const ne=x.read(1);if(j|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return j}}const g=n(0);function y(x,j){if(j===0){x.write(g);return}let ee=0;for(let re=j;re!==0;re=re>>>7)ee++;const ne=c.VSBuffer.alloc(ee);for(let re=0;j!==0;re++)ne.buffer[re]=j&127,j=j>>>7,j>0&&(ne.buffer[re]|=128);x.write(ne)}class k{constructor(j){this.b=j,this.a=0}read(j){const ee=this.b.slice(this.a,this.a+j);return this.a+=ee.byteLength,ee}}e.BufferReader=k;class i{constructor(){this.a=[]}get buffer(){return c.VSBuffer.concat(this.a)}write(j){this.a.push(j)}}e.BufferWriter=i;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function n(x){const j=c.VSBuffer.alloc(1);return j.writeUInt8(x,0),j}const t={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},s=typeof Buffer<"u";function r(x,j){if(typeof j>"u")x.write(t.Undefined);else if(typeof j=="string"){const ee=c.VSBuffer.fromString(j);x.write(t.String),y(x,ee.byteLength),x.write(ee)}else if(s&&Buffer.isBuffer(j)){const ee=c.VSBuffer.wrap(j);x.write(t.Buffer),y(x,ee.byteLength),x.write(ee)}else if(j instanceof c.VSBuffer)x.write(t.VSBuffer),y(x,j.byteLength),x.write(j);else if(Array.isArray(j)){x.write(t.Array),y(x,j.length);for(const ee of j)r(x,ee)}else if(typeof j=="number"&&(j|0)===j)x.write(t.Uint),y(x,j);else{const ee=c.VSBuffer.fromString(JSON.stringify(j));x.write(t.Object),y(x,ee.byteLength),x.write(ee)}}e.serialize=r;function a(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(u(x)).toString();case o.Buffer:return x.read(u(x)).buffer;case o.VSBuffer:return x.read(u(x));case o.Array:{const ee=u(x),ne=[];for(let re=0;re<ee;re++)ne.push(a(x));return ne}case o.Object:return JSON.parse(x.read(u(x)).toString());case o.Int:return u(x)}}e.deserialize=a;class h{constructor(j,ee,ne=null,re=1e3){this.h=j,this.j=ee,this.k=ne,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(j,ee){this.b.set(j,ee),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case 200:{const ee=this.o([j.type]);this.k?.logOutgoing(ee,0,1,l(j.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([j.type,j.id],j.data);this.k?.logOutgoing(ee,j.id,1,l(j.type),j.data);return}}}o(j,ee=void 0){const ne=new i;return r(ne,j),r(ne,ee),this.p(ne.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const ee=new k(j),ne=a(ee),re=a(ee),G=ne[0];switch(G){case 100:return this.k?.logIncoming(j.byteLength,ne[1],1,`${p(G)}: ${ne[2]}.${ne[3]}`,re),this.s({type:G,id:ne[1],channelName:ne[2],name:ne[3],arg:re});case 102:return this.k?.logIncoming(j.byteLength,ne[1],1,`${p(G)}: ${ne[2]}.${ne[3]}`,re),this.t({type:G,id:ne[1],channelName:ne[2],name:ne[3],arg:re});case 101:return this.k?.logIncoming(j.byteLength,ne[1],1,`${p(G)}`),this.u({type:G,id:ne[1]});case 103:return this.k?.logIncoming(j.byteLength,ne[1],1,`${p(G)}`),this.u({type:G,id:ne[1]})}}s(j){const ee=this.b.get(j.channelName);if(!ee){this.v(j);return}const ne=new O.CancellationTokenSource;let re;try{re=ee.call(this.j,j.name,j.arg,ne.token)}catch(F){re=Promise.reject(F)}const G=j.id;re.then(F=>{this.m({id:G,data:F,type:201}),this.d.delete(j.id)},F=>{F instanceof Error?this.m({id:G,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:G,data:F,type:203}),this.d.delete(j.id)});const H=(0,S.toDisposable)(()=>ne.cancel());this.d.set(j.id,H)}t(j){const ee=this.b.get(j.channelName);if(!ee){this.v(j);return}const ne=j.id,G=ee.listen(this.j,j.name,j.arg)(H=>this.m({id:ne,data:H,type:204}));this.d.set(j.id,G)}u(j){const ee=this.d.get(j.id);ee&&(ee.dispose(),this.d.delete(j.id))}v(j){let ee=this.g.get(j.channelName);ee||(ee=[],this.g.set(j.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:j,timeoutTimer:ne})}w(j){const ee=this.g.get(j);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(j,ee=null){this.l=j,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(j){const ee=this;return{call(ne,re,G){return ee.a?Promise.reject(new D.CancellationError):ee.m(j,ne,re,G)},listen(ne,re){return ee.a?I.Event.None:ee.o(j,ne,re)}}}m(j,ee,ne,re=O.CancellationToken.None){const G=this.g++,F={id:G,type:100,channelName:j,name:ee,arg:ne};if(re.isCancellationRequested)return Promise.reject(new D.CancellationError);let C;return new Promise((z,K)=>{if(re.isCancellationRequested)return K(new D.CancellationError);const B=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(G),z(pe.data);break;case 202:{this.f.delete(G);const de=new Error(pe.data.message);de.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,de.name=pe.data.name,K(de);break}case 203:this.f.delete(G),K(pe.data);break}};this.f.set(G,he),this.p(F)};let _=null;this.b===f.Idle?B():(_=(0,N.createCancelablePromise)(he=>this.u()),_.then(()=>{_=null,B()}));const te=()=>{_?(_.cancel(),_=null):this.p({id:G,type:101}),K(new D.CancellationError)},ce=re.onCancellationRequested(te);C=(0,S.combinedDisposable)((0,S.toDisposable)(te),ce),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(j,ee,ne){const re=this.g++,H={id:re,type:102,channelName:j,name:ee,arg:ne};let F=null;const C=new I.Emitter({onWillAddFirstListener:()=>{F=(0,N.createCancelablePromise)(z=>this.u()),F.then(()=>{F=null,this.d.add(C),this.p(H)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(C),this.p({id:re,type:103}))}}),U=z=>C.fire(z.data);return this.f.set(re,U),C.event}p(j){switch(j.type){case 100:case 102:{const ee=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(ee,j.id,0,`${p(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const ee=this.q([j.type,j.id]);this.j?.logOutgoing(ee,j.id,0,p(j.type));return}}}q(j,ee=void 0){const ne=new i;return r(ne,j),r(ne,ee),this.r(ne.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const ee=new k(j),ne=a(ee),re=a(ee),G=ne[0];switch(G){case 200:return this.j?.logIncoming(j.byteLength,0,0,l(G)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(j.byteLength,ne[1],0,l(G),re),this.t({type:ne[0],id:ne[1],data:re})}}t(j){if(j.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([T.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class R{get connections(){const j=[];return this.f.forEach(ee=>j.push(ee)),j}constructor(j){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,j(({protocol:ee,onDidClientDisconnect:ne})=>{I.Event.once(ee.onMessage)(G=>{const H=new k(G),F=a(H),C=new h(ee,F),U=new v(ee);this.a.forEach((K,B)=>C.registerChannel(B,K));const z={channelServer:C,channelClient:U,ctx:F};this.f.add(z),this.g.fire(z),ne(()=>{C.dispose(),U.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(j,ee){const ne=this;return{call(re,G,H){let F;if((0,m.isFunction)(ee)){const U=(0,L.getRandomElement)(ne.connections.filter(ee));F=U?Promise.resolve(U):I.Event.toPromise(I.Event.filter(ne.onDidAddConnection,ee))}else F=ee.routeCall(ne,re,G);const C=F.then(U=>U.channelClient.getChannel(j));return M(C).call(re,G,H)},listen(re,G){if((0,m.isFunction)(ee))return ne.j(j,ee,re,G);const H=ee.routeEvent(ne,re,G).then(F=>F.channelClient.getChannel(j));return M(H).listen(re,G)}}}j(j,ee,ne,re){const G=this;let H=new S.DisposableStore;const F=new I.Emitter({onWillAddFirstListener:()=>{H=new S.DisposableStore;const C=new I.EventMultiplexer,U=new Map,z=B=>{const te=B.channelClient.getChannel(j).listen(ne,re),ce=C.add(te);U.set(B,ce)},K=B=>{const _=U.get(B);!_||(_.dispose(),U.delete(B))};G.connections.filter(ee).forEach(z),I.Event.filter(G.onDidAddConnection,ee)(z,void 0,H),G.onDidRemoveConnection(K,void 0,H),C.event(F.fire,F,H),H.add(C)},onDidRemoveLastListener:()=>{H.dispose()}});return F.event}registerChannel(j,ee){this.a.set(j,ee),this.f.forEach(ne=>{ne.channelServer.registerChannel(j,ee)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=R;class A{constructor(j,ee,ne=null){const re=new i;r(re,ee),j.send(re.buffer),this.a=new v(j,ne),this.d=new h(j,ee,ne)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,ee){this.d.registerChannel(j,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=A;function M(x){return{call(j,ee,ne){return x.then(re=>re.call(j,ee,ne))},listen(j,ee){const ne=new I.Relay;return x.then(re=>ne.input=re.listen(j,ee)),ne.event}}}e.getDelayedChannel=M;function $(x){let j=!1;return{call(ee,ne,re){return j?x.call(ee,ne,re):(0,N.timeout)(0).then(()=>j=!0).then(()=>x.call(ee,ne,re))},listen(ee,ne){if(j)return x.listen(ee,ne);const re=new I.Relay;return(0,N.timeout)(0).then(()=>j=!0).then(()=>re.input=x.listen(ee,ne)),re.event}}}e.getNextTickChannel=$;class V{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const ee of j.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await I.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.StaticRouter=V;var q;(function(x){function j(G,H){const F=G,C=H&&H.disableMarshalling,U=new Map;for(const z in F)ne(z)&&U.set(z,I.Event.buffer(F[z],!0));return new class{listen(z,K,B){const _=U.get(K);if(_)return _;if(re(K)){const te=F[K];if(typeof te=="function")return te.call(F,B)}throw new Error(`Event not found: ${K}`)}call(z,K,B){const _=F[K];if(typeof _=="function"){if(!C&&Array.isArray(B))for(let te=0;te<B.length;te++)B[te]=(0,P.revive)(B[te]);return _.apply(F,B)}throw new Error(`Method not found: ${K}`)}}}x.fromService=j;function ee(G,H){const F=H&&H.disableMarshalling;return new Proxy({},{get(C,U){if(typeof U=="string")return H?.properties?.has(U)?H.properties.get(U):re(U)?function(z){return G.listen(U,z)}:ne(U)?G.listen(U):async function(...z){let K;H&&!(0,m.isUndefinedOrNull)(H.context)?K=[H.context,...z]:K=z;const B=await G.call(U,K);return F?B:(0,P.revive)(B)};throw new Error(`Property not found: ${String(U)}`)}})}x.toService=ee;function ne(G){return G[0]==="o"&&G[1]==="n"&&b.isUpperAsciiLetter(G.charCodeAt(2))}function re(G){return/^onDynamic/.test(G)&&b.isUpperAsciiLetter(G.charCodeAt(9))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const j=x.toString();if(j!=="[object Object]")return j}return x}function Q(x){return Array.isArray(x)?x.map(X):X(x)}function Y(x,j,ee,ne,re,G,H){H=Q(H);const F=W[re],C=F[ne%F.length];let U=[`%c[${x}]%c[${String(j).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(G)?(U=U.concat(H),U.push(")")):U.push(H),console.log.apply(console,U)}class Z{constructor(j,ee){this.d=j,this.f=ee,this.a=0,this.b=0}logOutgoing(j,ee,ne,re,G){this.b+=j,Y(this.d,this.b,j,ee,ne,re,G)}logIncoming(j,ee,ne,re,G){this.a+=j,Y(this.f,this.a,j,ee,ne,re,G)}}e.IPCLogger=Z}),define(oe[149],ae([0,1,16,3,39]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(I){this.a=I,this.onMessage=N.Event.fromDOMEventEmitter(this.a,"message",S=>L.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=O;class T extends c.IPCClient{constructor(I,S){const P=new O(I);super(P,S),this.b=P}dispose(){this.b.disconnect()}}e.Client=T}),define(oe[96],ae([0,1,6,16,3,2,39]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(v){v.Created="created",v.Read="read",v.Write="write",v.Open="open",v.Error="error",v.Close="close",v.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",v.NodeEndReceived="nodeEndReceived",v.NodeEndSent="nodeEndSent",v.NodeDrainBegin="nodeDrainBegin",v.NodeDrainEnd="nodeDrainEnd",v.zlibInflateError="zlibInflateError",v.zlibInflateData="zlibInflateData",v.zlibInflateInitialWrite="zlibInflateInitialWrite",v.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",v.zlibInflateWrite="zlibInflateWrite",v.zlibInflateFlushFired="zlibInflateFlushFired",v.zlibDeflateError="zlibDeflateError",v.zlibDeflateData="zlibDeflateData",v.zlibDeflateWrite="zlibDeflateWrite",v.zlibDeflateFlushFired="zlibDeflateFlushFired",v.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",v.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",v.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",v.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",v.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",v.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",v.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",v.ProtocolHeaderRead="protocolHeaderRead",v.ProtocolMessageRead="protocolMessageRead",v.ProtocolHeaderWrite="protocolHeaderWrite",v.ProtocolMessageWrite="protocolMessageWrite",v.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(v){v.enableDiagnostics=!1,v.records=[];const R=new WeakMap;let A=0;function M(V,q){if(!R.has(V)){const W=String(++A);R.set(V,W)}return R.get(V)}function $(V,q,W,X){if(!v.enableDiagnostics)return;const Q=M(V,q);if(X instanceof N.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const Y=N.VSBuffer.alloc(X.byteLength);Y.set(X),v.records.push({timestamp:Date.now(),id:Q,label:q,type:W,buff:Y})}else v.records.push({timestamp:Date.now(),id:Q,label:q,type:W,data:X})}v.traceSocketEvent=$})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(v){v[v.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",v[v.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function b(){return P||(P=N.VSBuffer.alloc(0)),P}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(R){this.a.push(R),this.b+=R.byteLength}read(R){return this.c(R,!0)}peek(R){return this.c(R,!1)}c(R,A){if(R===0)return b();if(R>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===R){const q=this.a[0];return A&&(this.a.shift(),this.b-=R),q}if(this.a[0].byteLength>R){const q=this.a[0].slice(0,R);return A&&(this.a[0]=this.a[0].slice(R),this.b-=R),q}const M=N.VSBuffer.alloc(R);let $=0,V=0;for(;R>0;){const q=this.a[V];if(q.byteLength>R){const W=q.slice(0,R);M.set(W,$),$+=R,A&&(this.a[V]=q.slice(R),this.b-=R),R-=R}else M.set(q,$),$+=q.byteLength,A?(this.a.shift(),this.b-=q.byteLength):V++,R-=q.byteLength}return M}}e.ChunkStream=m;var d;(function(v){v[v.None=0]="None",v[v.Regular=1]="Regular",v[v.Control=2]="Control",v[v.Ack=3]="Ack",v[v.Disconnect=5]="Disconnect",v[v.ReplayRequest=6]="ReplayRequest",v[v.Pause=7]="Pause",v[v.Resume=8]="Resume",v[v.KeepAlive=9]="KeepAlive",v[v.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",v[v.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function p(v){switch(v){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(v){v[v.HeaderLength=13]="HeaderLength",v[v.AcknowledgeTime=2e3]="AcknowledgeTime",v[v.TimeoutTime=2e4]="TimeoutTime",v[v.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",v[v.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",v[v.KeepAliveSendTime=5e3]="KeepAliveSendTime",v[v.LatencySampleTime=6e4]="LatencySampleTime",v[v.LatencySampleCount=5]="LatencySampleCount",v[v.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",v[v.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(R,A,M,$){this.type=R,this.id=A,this.ack=M,this.data=$,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends O.Disposable{constructor(R){super(),this.f=this.B(new c.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=R,this.b=!1,this.c=new m,this.B(this.a.onData(A=>this.acceptChunk(A))),this.lastReadTime=Date.now()}acceptChunk(R){if(!(!R||R.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(R);this.c.byteLength>=this.g.readLen;){const A=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=A.readUInt32BE(9),this.g.messageType=A.readUInt8(0),this.g.id=A.readUInt32BE(1),this.g.ack=A.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,$=this.g.id,V=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",A),this.f.fire(new l(M,$,V,A)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(R){this.k=null,this.a=!1,this.b=!1,this.c=R,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(R){if(this.a)return;R.writtenTime=Date.now(),this.lastWriteTime=Date.now();const A=N.VSBuffer.alloc(13);A.writeUInt8(R.type,0),A.writeUInt32BE(R.id,1),A.writeUInt32BE(R.ack,5),A.writeUInt32BE(R.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(R.type),id:R.id,ack:R.ack,messageSize:R.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",R.data),this.j(A,R.data)}g(R,A){const M=this.f===0;return this.d.push(R,A),this.f+=R.byteLength+A.byteLength,M}h(){const R=N.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,R}j(R,A){this.g(R,A)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const R=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:R.byteLength}),this.c.write(R)}}class g extends O.Disposable{constructor(R){super(),this.f=new c.Emitter,this.onMessage=this.f.event,this.g=new c.Emitter,this.onDidDispose=this.g.event,this.a=R,this.b=this.B(new u(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(A=>{A.type===1&&this.f.fire(A.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(R){this.b.write(new l(1,0,0,R))}}e.Protocol=g;class y extends T.IPCClient{static fromSocket(R,A){return new y(new g(R),A)}get onDidDispose(){return this.b.onDidDispose}constructor(R,A,M=null){super(R,A,M),this.b=R}dispose(){super.dispose();const R=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),R.end()}}e.Client=y;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(R){this.b?this.d.length>0?this.d.push(R):this.a.fire(R):this.d.push(R)}flushBuffer(){this.d=[]}}e.BufferedEmitter=k;class i{constructor(R){this.data=R,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let R=0,A=this.a;for(;A;)A=A.next,R++;return R}peek(){return this.a?this.a.data:null}toArray(){const R=[];let A=0,M=this.a;for(;M;)R[A++]=M.data,M=M.next;return R}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(R){const A=new i(R);if(!this.a){this.a=A,this.b=A;return}this.b.next=A,this.b=A}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const R=Date.now();for(let A=0;A<n.a;A++)this.c[A]=R-1e3*A;setInterval(()=>{for(let A=n.a;A>=1;A--)this.c[A]=this.c[A-1];this.c[0]=Date.now()},1e3)}d(){const R=Date.now(),A=(1+n.a)*1e3;let M=0;for(let $=0;$<n.a;$++)R-this.c[$]<=A&&M++;return 1-M/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var t;(function(v){v[v.Good=0]="Good",v[v.Poor=1]="Poor"})(t=e.ConnectionHealth||(e.ConnectionHealth={}));function s(v){switch(v){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class r{constructor(R){this.connectionHealth=R}}e.ConnectionHealthChangedEvent=r;class a{constructor(R,A){this.roundTripTime=R,this.recentHighRoundTripCount=A}}e.HighRoundTripTimeEvent=a;class h{get unacknowledgedCount(){return this.c-this.d}constructor(R){this.x=new k,this.onControlMessage=this.x.event,this.y=new k,this.onMessage=this.y.event,this.z=new k,this.onDidDispose=this.z.event,this.A=new k,this.onSocketClose=this.A.event,this.B=new k,this.onSocketTimeout=this.B.event,this.C=new k,this.onHighRoundTripTime=this.C.event,this.D=new k,this.onDidChangeConnectionHealth=this.D.event,this.u=R.loadEstimator??n.getInstance(),this.v=R.measureRoundTripTime??!1,this.w=R.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new O.DisposableStore,this.o=R.socket,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(A=>this.E(A))),this.t.add(this.o.onClose(A=>this.A.fire(A))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(A=>this.J(A))),this.t.add(this.r.onHighRoundTripTime(A=>this.C.fire(A))),this.t.add(this.r.onDidChangeConnectionHealth(A=>this.D.fire(A))),this.v&&this.r.start(),R.initialChunk&&this.q.acceptChunk(R.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const R=new l(5,0,0,b());this.p.write(R),this.p.flush()}sendPause(){const R=new l(7,0,0,b());this.p.write(R)}sendResume(){const R=new l(8,0,0,b());this.p.write(R)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(R,A){this.a=!0,this.t.dispose(),this.t=new O.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=R,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(A)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const R=new l(3,0,this.h,b());this.p.write(R);const A=this.b.toArray();for(let M=0,$=A.length;M<$;M++)this.p.write(A[M]);this.G()}acceptDisconnect(){this.z.fire()}E(R){if(R.ack>this.d){this.d=R.ack;do{const A=this.b.peek();if(A&&A.id<=R.ack)this.b.pop();else break}while(!0)}switch(R.type){case 0:break;case 1:{if(R.id>this.g)if(R.id!==this.g+1){const A=Date.now();A-this.m>1e4&&(this.m=A,this.p.write(new l(6,0,0,b())))}else this.g=R.id,this.j=Date.now(),this.F(),this.y.fire(R.data);break}case 2:{this.x.fire(R.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const A=this.b.toArray();for(let M=0,$=A.length;M<$;M++)this.p.write(A[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(R.data);break}case 11:{this.r.handleResponse(R.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(R){const A=++this.c;this.h=this.g;const M=new l(1,A,this.h,R);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(R){const A=new l(2,0,0,R);this.p.write(A)}F(){if(this.g<=this.h||this.k)return;const R=Date.now()-this.j;if(R>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-R+5)}G(){if(this.c<=this.d||this.f||this.a)return;const R=this.b.peek(),A=Date.now()-R.writtenTime,M=Date.now()-this.q.lastReadTime,$=Date.now()-this.n;if(A>=2e4&&M>=2e4&&$>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:A,timeSinceLastReceivedSomeData:M});return}const V=Math.max(2e4-A,2e4-M,2e4-$,500);this.f=setTimeout(()=>{this.f=null,this.G()},V)}H(){if(this.g<=this.h)return;this.h=this.g;const R=new l(3,0,this.h,b());this.p.write(R)}I(){this.h=this.g;const R=new l(9,0,this.h,b());this.p.write(R)}J(R){this.h=this.g;const A=new l(10,0,this.h,R);this.p.write(A)}K(R){this.h=this.g;const A=new l(11,0,this.h,R);this.p.write(A)}}e.PersistentProtocol=h;class w extends O.Disposable{constructor(){super(),this.a=this.B(new c.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new c.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new c.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},R=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const R=++this.h,A=N.VSBuffer.alloc(4);A.writeUInt32BE(R,0),this.a.fire(A)},6e4)}handleResponse(R){if(R.byteLength!==4)return;const A=R.readUInt32BE(0);if(this.g<=0||A!==this.h)return;const M=Date.now()-this.g,$=this.k++;this.j[$%this.j.length]=M;const V=this.l,q=this.j.filter(W=>W>=1e3).length;this.l=q>=3?1:0,M>1e3&&this.b.fire(new a(M,q)),V!==this.l&&this.c.fire(this.l)}}}),define(oe[150],ae([0,1,151,3,39,149]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends c.IPCServer{static b(){const I=N.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(S,P)=>P);return N.Event.map(I,S=>{const{port1:P,port2:b}=new MessageChannel,d={protocol:new O.Protocol(P),onDidClientDisconnect:N.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[b]),d})}constructor(){super(T.b())}}e.Server=T}),define(oe[65],ae([0,1,49,6,16,25,144,10,3,2,32,95,88,39]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(f){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",u=>c.VSBuffer.wrap(Buffer.from(u,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=p;class E{constructor(f,u){this.i=f,this.j=u,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const g=u&&u.timeout?u.timeout:6e4;this.b=new N.Delayer(g),this.d=null,this.f=null}getChannel(f){const u=this;return{call(g,y,k){return u.k(f,g,y,k)},listen(g,y){return u.l(f,g,y)}}}k(f,u,g,y=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(D.canceled());this.b.cancel();const k=this.n(f),i=(0,N.createCancelablePromise)(t=>k.call(u,g,t)),o=y.onCancellationRequested(()=>i.cancel()),n=(0,S.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(f,u,g){if(!this.b)return I.Event.None;this.b.cancel();let y;const k=new I.Emitter({onWillAddFirstListener:()=>{y=this.n(f).listen(u,g)(k.fire,k),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(u.env),this.d=(0,L.fork)(this.i,f,u);const g=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.j.serverName}`);return}g.fire(c.VSBuffer.wrap(Buffer.from(s,"base64")))});const k=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&k.send(s.buffer.toString("base64")),o=g.event,n={send:i,onMessage:o};this.f=new d.ChannelClient(n);const t=()=>this.o();process.once("exit",t),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,r)=>{process.removeListener("exit",t),this.c.forEach(a=>(0,S.dispose)(a)),this.c.clear(),s!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:r})})}return this.f}n(f){let u=this.g.get(f);return u||(u=this.m.getChannel(f),this.g.set(f,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=E}),define(oe[152],ae([0,1,87,16,39,3,11,21]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(m){this.a=m,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",d=>N.VSBuffer.wrap(d.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class S extends c.IPCServer{static b(){(0,T.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const m=new O.Emitter;return process.parentPort.on("message",d=>{const p=(0,D.firstOrDefault)(d.ports);p&&m.fire(p)}),O.Event.map(m.event,d=>({protocol:new I(d),onDidClientDisconnect:O.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(S.b())}}e.Server=S;function P(b,m,d){const p=E=>{E.data===m&&(b.removeListener("message",p),d())};b.on("message",p)}e.once=P}),define(oe[153],ae([0,1,16,10,3,2,14,4,31,39,96]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(a,h){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}constructor(a,h=""){this.f=!0,this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,N.onUnexpectedError)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const h=w=>{this.traceSocketEvent("read",w),a(L.VSBuffer.wrap(w))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,N.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,N.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var d;(function(r){r[r.MinHeaderByteSize=2]="MinHeaderByteSize",r[r.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var p;(function(r){r[r.PeekHeader=1]="PeekHeader",r[r.ReadHeader=2]="ReadHeader",r[r.ReadBody=3]="ReadBody",r[r.Fin=4]="Fin"})(p||(p={}));class E extends O.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}constructor(a,h,w,v){super(),this.f=this.B(new c.Emitter),this.g=this.B(new c.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:w?.byteLength||0,recordInflateBytes:v}),this.a=this.B(new l(this,h,w,v,this.f,(R,A)=>this.k(R,A))),this.B(this.a.onError(R=>{console.error(R),(0,N.onUnexpectedError)(R),this.g.fire({type:0,hadError:!0,error:R})})),this.b=new P.ChunkStream,this.B(this.socket.onData(R=>this.l(R))),this.B(this.socket.onClose(async R=>{this.a.isProcessingReadQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(R)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let h=0;for(;h<a.byteLength;)this.a.writeMessage(a.slice(h,Math.min(h+262144,a.byteLength))),h+=262144}k(a,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const v=L.VSBuffer.alloc(w);if(h?v.writeUInt8(194,0):v.writeUInt8(130,0),a.byteLength<126)v.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(a.byteLength>>>8&255,++R),v.writeUInt8(a.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(a.byteLength>>>24&255,++R),v.writeUInt8(a.byteLength>>>16&255,++R),v.writeUInt8(a.byteLength>>>8&255,++R),v.writeUInt8(a.byteLength>>>0&255,++R)}this.socket.write(L.VSBuffer.concat([v,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),w=h.readUInt8(0),v=(w&128)>>>7,R=(w&64)>>>6,A=h.readUInt8(1),M=(A&128)>>>7,$=A&127;this.j.state=2,this.j.readLen=2+(M?4:0)+($===126?2:0)+($===127?8:0),this.j.fin=v,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(R)),this.j.firstFrameOfMessage=Boolean(v),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),w=h.readUInt8(1),v=(w&128)>>>7;let R=w&127,A=1;R===126?R=h.readUInt8(++A)*2**8+h.readUInt8(++A):R===127&&(R=h.readUInt8(++A)*0+h.readUInt8(++A)*0+h.readUInt8(++A)*0+h.readUInt8(++A)*0+h.readUInt8(++A)*2**24+h.readUInt8(++A)*2**16+h.readUInt8(++A)*2**8+h.readUInt8(++A));let M=0;v&&(M=h.readUInt8(++A)*2**24+h.readUInt8(++A)*2**16+h.readUInt8(++A)*2**8+h.readUInt8(++A)),this.j.state=3,this.j.readLen=R,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),g(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class l extends O.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(a,h,w,v,R,A){super(),this.l=a,this.m=R,this.n=A,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new c.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new c.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,h?(this.b=this.B(new f(this.l,v,w,{windowBits:15})),this.f=this.B(new u(this.l,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const h=await this.s(this.f,a);this.n(h,!0)}else this.n(a,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(a,h){return new Promise((w,v)=>{a.write(h),a.flush(R=>w(R))})}acceptFrame(a,h,w){this.h.push({data:a,isCompressed:h,isLastFrameOfMessage:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const h=await this.w(this.b,a.data,a.isLastFrameOfMessage);this.m.fire(h)}else this.m.fire(a.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(a,h,w){return new Promise((v,R)=>{a.write(h),w&&a.write(L.VSBuffer.fromByteArray([0,0,255,255])),a.flush(A=>v(A))})}}class f extends O.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(a,h,w,v){super(),this.h=a,this.j=h,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(v),this.b.on("error",R=>{this.h.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.h.traceSocketEvent("zlibInflateData",R),this.g.push(L.VSBuffer.wrap(R))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=L.VSBuffer.concat(this.g);this.g.length=0,a(h)})}}class u extends O.Disposable{constructor(a,h){super(),this.g=a,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(L.VSBuffer.wrap(w))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=L.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function g(r,a){if(a===0)return;const h=r.byteLength>>>2;for(let $=0;$<h;$++){const V=r.readUInt32BE($*4);r.writeUInt32BE(V^a,$*4)}const w=h*4,v=r.byteLength-w,R=a>>>24&255,A=a>>>16&255,M=a>>>8&255;v>=1&&r.writeUInt8(r.readUInt8(w)^R,w),v>=2&&r.writeUInt8(r.readUInt8(w+1)^A,w+1),v>=3&&r.writeUInt8(r.readUInt8(w+2)^M,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function k(){const r=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${r}-sock`;const a=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:b().os.tmpdir(),h=(0,T.join)(a,`vscode-ipc-${r}.sock`);return o(h),h}e.createRandomIPCHandle=k;function i(r,a,h){const w=b().crypto.createHash("md5").update(r).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${h}-${a}-sock`;const v=h.substr(0,4),R=a.substr(0,6),A=w.substr(0,8);let M;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${A}-${v}-${R}.sock`):M=(0,T.join)(r,`${v}-${R}.sock`),o(M),M}e.createStaticIPCHandle=i;function o(r){const a=y[D.platform];typeof a=="number"&&r.length>=a&&console.warn(`WARNING: IPC handle "${r}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends S.IPCServer{static b(a){const h=c.Event.fromNodeEventEmitter(a,"connection");return c.Event.map(h,w=>({protocol:new P.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:c.Event.once(c.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(n.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function t(r){return new Promise((a,h)=>{const w=b().net.createServer();w.on("error",h),w.listen(r,()=>{w.removeListener("error",h),a(new n(w))})})}e.serve=t;function s(r,a){return new Promise((h,w)=>{const v=b().net.createConnection(r,()=>{v.removeListener("error",w),h(P.Client.fromSocket(new m(v,`ipc-client${a}`),a))});v.once("error",w)})}e.connect=s}),define(oe[66],ae([0,1,6,3,2,11]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T=e.StorageHint||(e.StorageHint={}));function D(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends c.Disposable{constructor(m,d=Object.create(null)){super(),this.m=m,this.n=d,this.b=this.B(new N.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new L.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((d,p)=>this.s(p,d)),m.deleted?.forEach(d=>this.s(d,void 0))}s(m,d){if(this.c===I.Closed)return;let p=!1;(0,O.isUndefinedOrNull)(d)?p=this.f.delete(m):this.f.get(m)!==d&&(this.f.set(m,d),p=!0),p&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,d){const p=this.f.get(m);return(0,O.isUndefinedOrNull)(p)?d:p}getBoolean(m,d){const p=this.get(m);return(0,O.isUndefinedOrNull)(p)?d:p==="true"}getNumber(m,d){const p=this.get(m);return(0,O.isUndefinedOrNull)(p)?d:parseInt(p,10)}async set(m,d){if(this.c===I.Closed)return;if((0,O.isUndefinedOrNull)(d))return this.delete(m);const p=String(d);if(this.f.get(m)!==p)return this.f.set(m,p),this.j.set(m,p),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===I.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}S.a=100,e.Storage=S;class P{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((d,p)=>this.a.set(p,d)),m.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=P}),define(oe[154],ae([8,7]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(oe[155],ae([8,7]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[156],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[157],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(oe[158],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(oe[159],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(oe[160],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[161],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[162],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[163],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(oe[164],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[165],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[166],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[167],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[168],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(oe[169],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(oe[170],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(oe[171],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[172],ae([8,7]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[173],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[174],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[175],ae([8,7]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(oe[176],ae([8,7]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(oe[177],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[178],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[179],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[180],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[181],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[182],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[183],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[184],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[185],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[186],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[187],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[188],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[189],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[190],ae([8,7]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(oe[191],ae([0,1,10,157]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var c;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(c=e.TokenType||(e.TokenType={}));function O(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const T=(0,N.localize)(3,null),D=(0,N.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const b=this.d,m=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:m};this.g.push({offset:b,lexeme:m,additionalInfo:P}),this.f.push(d)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const b=this.c.substring(this.d,this.e),m=I.b.get(b);m?this.k(m):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,b=!1,m=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(D);return}const p=this.c.charCodeAt(P);if(b)b=!1;else if(p===47&&!m){P++;break}else p===91?m=!0:p===92?b=!0:p===93&&(m=!1);P++}for(;P<this.c.length&&I.a.has(this.c.charCodeAt(P));)P++;this.e=P;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(oe[192],ae([0,1,64,62,22,14,36,23,12]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,O.dirname)(c.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",d)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(I.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?I.URI.file((0,O.join)(d,"argv.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,O.resolve)(d):(0,O.normalize)((0,O.join)(c.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?I.URI.file((0,O.resolve)(d)):I.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,O.resolve)(d);const p=T.env.VSCODE_EXTENSIONS;if(p)return p;const E=T.env.VSCODE_PORTABLE;return E?(0,O.join)(E,"extensions"):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?I.URI.parse(p):I.URI.file((0,O.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?I.URI.parse(d):I.URI.file((0,O.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);E&&E[1]&&E[2]&&d.push([E[1],E[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,D.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?I.URI.file((0,O.join)(d,"policy.json")):(0,D.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,p,E){this.a=d,this.b=p,this.c=E,this.editSessionId=this.args.editSessionId}}ye([N.memoize],S.prototype,"appRoot",null),ye([N.memoize],S.prototype,"userHome",null),ye([N.memoize],S.prototype,"userDataPath",null),ye([N.memoize],S.prototype,"appSettingsHome",null),ye([N.memoize],S.prototype,"tmpDir",null),ye([N.memoize],S.prototype,"cacheHome",null),ye([N.memoize],S.prototype,"stateResource",null),ye([N.memoize],S.prototype,"userRoamingDataHome",null),ye([N.memoize],S.prototype,"userDataSyncHome",null),ye([N.memoize],S.prototype,"sync",null),ye([N.memoize],S.prototype,"machineSettingsResource",null),ye([N.memoize],S.prototype,"workspaceStorageHome",null),ye([N.memoize],S.prototype,"localHistoryHome",null),ye([N.memoize],S.prototype,"keyboardLayoutResource",null),ye([N.memoize],S.prototype,"argvResource",null),ye([N.memoize],S.prototype,"isExtensionDevelopment",null),ye([N.memoize],S.prototype,"untitledWorkspacesHome",null),ye([N.memoize],S.prototype,"builtinExtensionsPath",null),ye([N.memoize],S.prototype,"extensionsPath",null),ye([N.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([N.memoize],S.prototype,"extensionDevelopmentKind",null),ye([N.memoize],S.prototype,"extensionTestsLocationURI",null),ye([N.memoize],S.prototype,"debugExtensionHost",null),ye([N.memoize],S.prototype,"logLevel",null),ye([N.memoize],S.prototype,"extensionLogLevel",null),ye([N.memoize],S.prototype,"serviceMachineIdResource",null),ye([N.memoize],S.prototype,"disableTelemetry",null),ye([N.memoize],S.prototype,"disableWorkspaceTrust",null),ye([N.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function P(m,d){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function b(m,d,p,E,l,f){const g=Number(d||m)||(E?null:p),y=g?Boolean(!!d):!1;let k;if(f)try{k=JSON.parse(f)}catch{}return{port:g,break:y,debugId:l,env:k}}e.parseDebugParams=b}),define(oe[193],ae([0,1,292,4,158]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const O={o:(0,c.localize)(0,null),e:(0,c.localize)(1,null),t:(0,c.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,c.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,c.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,c.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,c.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,c.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,c.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,c.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,c.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,c.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,c.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,c.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,c.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,c.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,c.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,c.localize)(17,null)},category:{type:"string",cat:"e",description:(0,c.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,c.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,c.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,c.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,c.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,c.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,c.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,c.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,c.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,c.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,c.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,c.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,c.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,c.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,c.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,c.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,c.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,c.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function D(E,l,f=T){const u=E.find(r=>r.length>0&&r[0]!=="-"),g={},y=["_"],k=[],i={};let o;for(const r in l){const a=l[r];a.type==="subcommand"?r===u&&(o=a):(a.alias&&(g[r]=a.alias),a.type==="string"||a.type==="string[]"?(y.push(r),a.deprecates&&y.push(...a.deprecates)):a.type==="boolean"&&(k.push(r),a.deprecates&&k.push(...a.deprecates)),a.global&&(i[r]=a))}if(o&&u){const r=i;for(const v in o.options)r[v]=o.options[v];const a=E.filter(v=>v!==u),h=f.getSubcommandReporter?f.getSubcommandReporter(u):void 0,w=D(a,r,h);return{[u]:w,_:[]}}const n=L(E,{string:y,boolean:k,alias:g}),t={},s=n;t._=n._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in l){const a=l[r];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let h=s[r];if(a.deprecates)for(const w of a.deprecates)s.hasOwnProperty(w)&&(h||(h=s[w],h&&f.onDeprecatedOption(w,a.deprecationMessage||(0,c.localize)(36,null,r))),delete s[w]);if(typeof h<"u"){if(a.type==="string[]"){if(Array.isArray(h)||(h=[h]),!a.allowEmptyValue){const w=h.filter(v=>v.length>0);w.length!==h.length&&(f.onEmptyValue(r),h=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(h)?(h=h.pop(),f.onMultipleValues(r,h)):!h&&!a.allowEmptyValue&&(f.onEmptyValue(r),h=void 0));t[r]=h,a.deprecationMessage&&f.onDeprecatedOption(r,a.deprecationMessage)}delete s[r]}for(const r in s)f.onUnknownOption(r);return t}e.parseArgs=D;function I(E,l){let f="";return l.args&&(Array.isArray(l.args)?f=` <${l.args.join("> <")}>`:f=` <${l.args}>`),l.alias?`-${l.alias} --${E}${f}`:`--${E}${f}`}function S(E,l){const f=[];for(const u in E){const g=E[u],y=I(u,g);f.push([y,g.description])}return P(f,l)}e.formatOptions=S;function P(E,l){const u=E.reduce((k,i)=>Math.max(k,i[0].length),12)+2+1;if(l-u<25)return E.reduce((k,i)=>k.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const g=l-u-1,y=[];for(const k of E){const i=k[0],o=m(k[1],g),n=b(u-i.length-2);y.push("  "+i+n+o[0]);for(let t=1;t<o.length;t++)y.push(b(u)+o[t])}return y}function b(E){return" ".repeat(E)}function m(E,l){const f=[];for(;E.length;){const u=E.length<l?E.length:E.lastIndexOf(" ",l),g=E.slice(0,u).trim();E=E.slice(u),f.push(g)}return f}function d(E,l,f,u,g){const y=process.stdout.isTTY&&process.stdout.columns||80,k=g?.noInputFiles!==!0?`[${(0,c.localize)(37,null)}...]`:"",i=[`${E} ${f}`];i.push(""),i.push(`${(0,c.localize)(38,null)}: ${l} [${(0,c.localize)(39,null)}]${k}`),i.push(""),g?.noPipe!==!0&&(N.isWindows?i.push((0,c.localize)(40,null,l)):i.push((0,c.localize)(41,null,l)),i.push(""));const o={},n=[];for(const t in u){const s=u[t];if(s.type==="subcommand")s.description&&n.push({command:t,description:s.description});else if(s.description&&s.cat){let r=o[s.cat];r||(o[s.cat]=r={}),r[t]=s}}for(const t in o){const s=t,r=o[s];r&&(i.push(O[s]),i.push(...S(r,y)),i.push(""))}return n.length&&(i.push((0,c.localize)(42,null)),i.push(...P(n.map(t=>[t.command,t.description]),y)),i.push("")),i.join(`
`)}e.buildHelpMessage=d;function p(E,l){return`${E||(0,c.localize)(43,null)}
${l||(0,c.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(oe[194],ae([0,1,293,159,193]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const O=2048;function T(m,d){const p=(y,k)=>{console.warn((0,N.localize)(0,null,y,k))},E=y=>{console.warn((0,N.localize)(1,null,y))},l=(y,k)=>{console.warn((0,N.localize)(2,null,y,k))},f=y=>({onUnknownOption:k=>{y!=="tunnel"&&console.warn((0,N.localize)(3,null,k,y))},onMultipleValues:p,onEmptyValue:E,onDeprecatedOption:l,getSubcommandReporter:y!=="tunnel"?f:void 0}),u={onUnknownOption:y=>{console.warn((0,N.localize)(4,null,y))},onMultipleValues:p,onEmptyValue:E,onDeprecatedOption:l,getSubcommandReporter:f},g=(0,c.parseArgs)(m,c.OPTIONS,d?u:void 0);return g.goto&&g._.forEach(y=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,N.localize)(5,null))),g["max-memory"]&&L(parseInt(g["max-memory"])>=O,`The max-memory argument cannot be specified lower than ${O} MB.`),g}function D(m){const d=m.findIndex(p=>!/^-/.test(p));if(d>-1)return[...m.slice(0,d),...m.slice(d+1)]}function I(m){let[,...d]=m;process.env.VSCODE_DEV&&(d=D(d)||[]);const p=!b(process.env);return T(d,p)}e.parseMainProcessArgv=I;function S(m){let[,,...d]=m;return process.env.VSCODE_DEV&&(d=D(d)||[]),T(d,!0)}e.parseCLIProcessArgv=S;function P(m,...d){const p=m.indexOf("--");return p===-1?m.push(...d):m.splice(p,0,...d),m}e.addArg=P;function b(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function ie(e,L,N){function c(T,D){const I=O(T,D),S=[I];return e.isAbsolute(I)||S.unshift(N),e.resolve(...S)}function O(T,D){process.env.VSCODE_DEV&&(D="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,D);const P=T["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(L.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,D)}return{getUserDataPath:c}}if(typeof define=="function")define(oe[195],ae([196,34,36]),function(e,L,N){return ie(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=ie(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[97],ae([0,1,34,192,195]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends N.AbstractNativeEnvironmentService{constructor(S,P){super(S,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,c.getUserDataPath)(S,P.nameShort)},P)}}e.NativeEnvironmentService=O;function T(I,S){return(0,N.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,S,I.extensionEnvironment)}e.parsePtyHostDebugPort=T;function D(I,S){return(0,N.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,S,I.extensionEnvironment)}e.parseSharedProcessDebugPort=D}),define(oe[197],ae([0,1,11,162]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function c(T,D,I){try{O(T,D,I)}catch(S){console.error(S?.message??S)}return T}e.localizeManifest=c;function O(T,D,I){const S=(P,b,m)=>{const d=P[b];if((0,L.isString)(d)){const p=d,E=p.length;if(E>1&&p[0]==="%"&&p[E-1]==="%"){const l=p.substr(1,E-2);let f=D[l];f===void 0&&I&&(f=I[l]);const u=typeof f=="string"?f:f?.message,g=I?.[l],y=typeof g=="string"?g:g?.message;if(!u){y||console.warn(`[${T.name}]: ${(0,N.localize)(0,null,l)}`);return}if(m&&(b==="title"||b==="category")&&y&&y!==u){const k={value:u,original:y};P[b]=k}else P[b]=u}}else if((0,L.isObject)(d))for(const p in d)d.hasOwnProperty(p)&&(p==="commands"?S(d,p,!0):S(d,p,m));else if(Array.isArray(d))for(let p=0;p<d.length;p++)S(d,p,m)};for(const P in T)T.hasOwnProperty(P)&&S(T,P)}}),define(oe[198],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O,T,D,I){return this.a.call("promptImportantExtensionsInstallNotification",[O,T,D,I])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class N{constructor(O){this.a=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,D){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=N}),define(oe[67],ae([0,1,23,90,167,55]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function I(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=I;function S(f){if(!I(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=f.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=S;function P(f){if(!f)return null;const u=f.majorBase,g=f.majorMustEqual,y=f.minorBase;let k=f.minorMustEqual;const i=f.patchBase;let o=f.patchMustEqual;f.hasCaret&&(u===0||(k=!1),o=!1);let n=0;if(f.preRelease){const t=D.exec(f.preRelease);if(t){const[,s,r,a]=t;n=Date.UTC(Number(s),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:g,minorBase:y,minorMustEqual:k,patchBase:i,patchMustEqual:o,isMinimum:f.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function b(f,u,g){let y;typeof f=="string"?y=P(S(f)):y=f;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let i;if(typeof g=="string"?i=P(S(g)):i=g,!y||!i)return!1;const o=y.majorBase,n=y.minorBase,t=y.patchBase;let s=i.majorBase,r=i.minorBase,a=i.patchBase;const h=i.notBefore;let w=i.majorMustEqual,v=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:n>r?!0:n<r||k&&k<h?!1:t>=a:(o===1&&s===0&&(!w||!v||!R)&&(s=1,r=0,a=0,w=!0,v=!1,R=!1),o<s?!1:o>s?!w:n<r?!1:n>r?!v:t<a?!1:t>a?!R:!(k&&k<h))}e.isValidVersion=b;function m(f,u,g,y,k){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([N.default.Error,c.localize(0,null)]),i;if(typeof y.name!="string")return i.push([N.default.Error,c.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([N.default.Error,c.localize(2,null,"version")]),i;if(!y.engines)return i.push([N.default.Error,c.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([N.default.Error,c.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!l(y.extensionDependencies))return i.push([N.default.Error,c.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!l(y.activationEvents))return i.push([N.default.Error,c.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([N.default.Error,c.localize(7,null,"activationEvents","main","browser")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([N.default.Warning,c.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([N.default.Error,c.localize(9,null,"main")]),i;{const t=(0,L.joinPath)(g,y.main);(0,L.isEqualOrParent)(t,g)||i.push([N.default.Warning,c.localize(10,null,t.path,g.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([N.default.Error,c.localize(11,null,"browser")]),i;{const t=(0,L.joinPath)(g,y.browser);(0,L.isEqualOrParent)(t,g)||i.push([N.default.Warning,c.localize(12,null,t.path,g.path)])}}if(!O.valid(y.version))return i.push([N.default.Error,c.localize(13,null)]),i;const o=[];if(!d(f,u,y,k,o))for(const t of o)i.push([N.default.Error,t]);return i}e.validateExtensionManifest=m;function d(f,u,g,y,k){return y||typeof g.main>"u"&&typeof g.browser>"u"?!0:E(f,u,g.engines.vscode,k)}e.isValidExtensionVersion=d;function p(f,u,g){return f==="*"||E(u,g,f)}e.isEngineValid=p;function E(f,u,g,y=[]){const k=P(S(g));if(!k)return y.push(c.localize(14,null,g)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return y.push(c.localize(15,null,g)),!1}else if(!k.majorMustEqual)return y.push(c.localize(16,null,g)),!1;return b(f,u,k)?!0:(y.push(c.localize(17,null,f,g)),!1)}function l(f){if(!Array.isArray(f))return!1;for(let u=0,g=f.length;u<g;u++)if(typeof f[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,31]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function c(O,T,D){let I=D&&D.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await T.readFile(O.serviceMachineIdResource)).value.toString();I=(0,N.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,N.generateUuid)();try{await T.writeFile(O.serviceMachineIdResource,L.VSBuffer.fromString(I))}catch{}}return D?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=c}),define(oe[68],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(c,O=[],T=!1){this.ctor=c,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=L}),define(oe[199],ae([0,1,68]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const N=[];var c;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(c=e.InstantiationType||(e.InstantiationType={}));function O(D,I,S){I instanceof L.SyncDescriptor||(I=new L.SyncDescriptor(I,[],Boolean(S))),N.push([D,I])}e.registerSingleton=O;function T(){return N}e.getSingletonServiceDescriptors=T}),define(oe[200],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const D=this.lookupOrInsertNode(O),I=this.lookupOrInsertNode(T);D.outgoing.set(I.key,I),I.incoming.set(D.key,D)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const D of this.a.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let D=this.a.get(T);return D||(D=new L(T,O),this.a.set(T,D)),D}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,D]of this.a)O.push(`${T}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const D=new Set([O]),I=this.c(T,D);if(I)return I}}c(O,T){for(const[D,I]of O.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const S=this.c(I,T);if(S)return S;T.delete(D)}}}e.Graph=N}),define(oe[5],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=D})(L=e._util||(e._util={})),e.IInstantiationService=c("instantiationService");function N(T,D,I){D[L.DI_TARGET]===D?D[L.DI_DEPENDENCIES].push({id:T,index:I}):(D[L.DI_DEPENDENCIES]=[{id:T,index:I}],D[L.DI_TARGET]=D)}function c(T){if(L.serviceIds.has(T))return L.serviceIds.get(T);const D=function(I,S,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,I,P)};return D.toString=()=>T,L.serviceIds.set(T,D),D}e.createDecorator=c;function O(T){return T}e.refineServiceDecorator=O}),define(oe[201],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(oe[17],ae([0,1,11,12,5]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,c.createDecorator)("configurationService");function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}e.isConfigurationOverrides=O;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}e.isConfigurationUpdateOverrides=T;var D;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(l,f){const u=Object.create(null);for(const g in l)P(u,g,l[g],f);return u}e.toValuesTree=S;function P(l,f,u,g){const y=f.split("."),k=y.pop();let i=l;for(let o=0;o<y.length;o++){const n=y[o];let t=i[n];switch(typeof t){case"undefined":t=i[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${f} as ${y.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[k]=u}catch{g(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(i)}`)}else g(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function b(l,f){const u=f.split(".");m(l,u)}e.removeFromValueTree=b;function m(l,f){const u=f.shift();if(f.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const g=l[u];typeof g=="object"&&!Array.isArray(g)&&(m(g,f),Object.keys(g).length===0&&delete l[u])}}function d(l,f,u){function g(i,o){let n=i;for(const t of o){if(typeof n!="object"||n===null)return;n=n[t]}return n}const y=f.split("."),k=g(l,y);return typeof k>"u"?u:k}e.getConfigurationValue=d;function p(l,f,u){Object.keys(f).forEach(g=>{g!=="__proto__"&&(g in l?L.isObject(l[g])&&L.isObject(f[g])?p(l[g],f[g],u):u&&(l[g]=f[g]):l[g]=f[g])})}e.merge=p;function E(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(oe[69],ae([0,1,4,27,191,5,156,10]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",L.isMacintosh),I.set("isLinux",L.isLinux),I.set("isWindows",L.isWindows),I.set("isWeb",L.isWeb),I.set("isMacNative",L.isMacintosh&&!L.isWeb),I.set("isEdge",L.isEdge),I.set("isFirefox",L.isFirefox),I.set("isChrome",L.isChrome),I.set("isSafari",L.isSafari);function S(F,C){if(I.get(F)!==void 0)throw(0,D.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(F,C)}e.setConstant=S;const P=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));const m={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(0,null),p=(0,T.localize)(1,null),E=(0,T.localize)(2,null),l=(0,T.localize)(3,null),f=(0,T.localize)(4,null),u=(0,T.localize)(5,null),g=(0,T.localize)(6,null),y=(0,T.localize)(7,null);class k{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=m){this.k=C,this.d=new c.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const z=this.D(),K=z.type===17?u:void 0;throw this.h.push({message:f,offset:z.offset,lexeme:c.Scanner.getLexeme(z),additionalInfo:K}),k.c}return U}catch(U){if(U!==k.c)throw U;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const U=this.o();C.push(U)}return C.length===1?C[0]:i.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const U=this.s();C.push(U)}return C.length===1?C[0]:i.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,l),U?.negate()}case 17:return this.z(),A.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const U=this.l();return this.A(1,l),U}case 17:{const U=C.lexeme;if(this.z(),this.y(9)){const K=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),K.type!==10)throw this.B("REGEX",K);const B=K.lexeme,_=B.lastIndexOf("/"),te=_===B.length-1?void 0:this.w(B.substring(_+1));let ce;try{ce=new RegExp(B.substring(1,_),te)}catch{throw this.B("REGEX",K)}return X.create(U,ce)}switch(K.type){case 10:case 19:{const B=[K.lexeme];this.z();let _=this.D(),te=0;for(let Se=0;Se<K.lexeme.length;Se++)K.lexeme.charCodeAt(Se)===40?te++:K.lexeme.charCodeAt(Se)===41&&te--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Se=0;Se<_.lexeme.length;Se++)_.lexeme.charCodeAt(Se)===40?te++:K.lexeme.charCodeAt(Se)===41&&te--}if(te<0)break;B.push(c.Scanner.getLexeme(_)),this.z(),_=this.D()}const ce=B.join(""),he=ce.lastIndexOf("/"),pe=he===ce.length-1?void 0:this.w(ce.substring(he+1));let de;try{de=new RegExp(ce.substring(1,he),pe)}catch{throw this.B("REGEX",K)}return i.regex(U,de)}case 18:{const B=K.lexeme;this.z();let _=null;if(!(0,N.isFalsyOrWhitespace)(B)){const te=B.indexOf("/"),ce=B.lastIndexOf("/");if(te!==ce&&te>=0){const he=B.slice(te+1,ce),pe=B[ce+1]==="i"?"i":"";try{_=new RegExp(he,pe)}catch{throw this.B("REGEX",K)}}}if(_===null)throw this.B("REGEX",K);return X.create(U,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const K=this.u();return i.notIn(U,K)}switch(this.D().type){case 3:{this.z();const K=this.u();if(this.x().type===18)return i.equals(U,K);switch(K){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,K)}}case 4:{this.z();const K=this.u();if(this.x().type===18)return i.notEquals(U,K);switch(K){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,K)}}case 5:return this.z(),q.create(U,this.u());case 6:return this.z(),W.create(U,this.u());case 7:return this.z(),$.create(U,this.u());case 8:return this.z(),V.create(U,this.u());case 13:return this.z(),i.in(U,this.u());default:return i.has(U)}}case 20:throw this.h.push({message:g,offset:C.offset,lexeme:"",additionalInfo:y}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,U){if(this.C(C))return this.z();throw this.B(U,this.D())}B(C,U,z){const K=(0,T.localize)(8,null,C,c.Scanner.getLexeme(U)),B=U.offset,_=c.Scanner.getLexeme(U);return this.h.push({message:K,offset:B,lexeme:_,additionalInfo:z}),k.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}k.c=new Error,e.Parser=k;class i{static false(){return s.INSTANCE}static true(){return r.INSTANCE}static has(C){return a.create(C)}static equals(C,U){return h.create(C,U)}static notEquals(C,U){return R.create(C,U)}static regex(C,U){return X.create(C,U)}static in(C,U){return w.create(C,U)}static notIn(C,U){return v.create(C,U)}static not(C){return A.create(C)}static and(...C){return Z.create(C,null,!0)}static or(...C){return x.create(C,null,!0)}static greater(C,U){return $.create(C,U)}static greaterEquals(C,U){return V.create(C,U)}static smaller(C,U){return q.create(C,U)}static smallerEquals(C,U){return W.create(C,U)}static deserialize(C){return C==null?void 0:this.c.parse(C)}}i.c=new k({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=i;function o(F){const C=new k({regexParsingWithErrorRecovery:!1});return F.map(U=>(C.parse(U),C.lexingErrors.length>0?C.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,T.localize)(9,null,z.additionalInfo):(0,T.localize)(10,null),offset:z.offset,length:z.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.validateWhenClauses=o;function n(F,C){const U=F?F.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function t(F,C){return F.cmp(C)}class s{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return r.INSTANCE}}s.INSTANCE=new s,e.ContextKeyFalseExpr=s;class r{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}r.INSTANCE=new r,e.ContextKeyTrueExpr=r;class a{static create(C,U=null){const z=I.get(C);return typeof z=="boolean"?z?r.INSTANCE:s.INSTANCE:new a(C,U)}constructor(C,U){this.key=C,this.c=U,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=I.get(this.key);return typeof C=="boolean"?C?r.INSTANCE:s.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=a;class h{static create(C,U,z=null){if(typeof U=="boolean")return U?a.create(C,z):A.create(C,z);const K=I.get(C);return typeof K=="boolean"?U===(K?"true":"false")?r.INSTANCE:s.INSTANCE:new h(C,U,z)}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=I.get(this.c);if(typeof C=="boolean"){const U=C?"true":"false";return this.d===U?r.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class w{static create(C,U){return new w(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.f),z=C.getValue(this.d);return Array.isArray(U)?U.includes(z):typeof z=="string"&&typeof U=="object"&&U!==null?P.call(U,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=w;class v{static create(C,U){return new v(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=11,this.c=w.create(C,U)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=v;class R{static create(C,U,z=null){if(typeof U=="boolean")return U?A.create(C,z):a.create(C,z);const K=I.get(C);return typeof K=="boolean"?U===(K?"true":"false")?s.INSTANCE:r.INSTANCE:new R(C,U,z)}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=I.get(this.c);if(typeof C=="boolean"){const U=C?"true":"false";return this.d===U?s.INSTANCE:r.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=R;class A{static create(C,U=null){const z=I.get(C);return typeof z=="boolean"?z?s.INSTANCE:r.INSTANCE:new A(C,U)}constructor(C,U){this.c=C,this.d=U,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=I.get(this.c);return typeof C=="boolean"?C?s.INSTANCE:r.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.ContextKeyNotExpr=A;function M(F,C){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?C(F):s.INSTANCE}class ${static create(C,U,z=null){return M(U,K=>new $(C,K,z))}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=$;class V{static create(C,U,z=null){return M(U,K=>new V(C,K,z))}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=V;class q{static create(C,U,z=null){return M(U,K=>new q(C,K,z))}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=q;class W{static create(C,U,z=null){return M(U,K=>new W(C,K,z))}constructor(C,U,z){this.c=C,this.d=U,this.f=z,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=W;class X{static create(C,U){return new X(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const U=this.f?this.f.source:"",z=C.f?C.f.source:"";return U<z?-1:U>z?1:0}equals(C){if(C.type===this.type){const U=this.f?this.f.source:"",z=C.f?C.f.source:"";return this.d===C.d&&U===z}return!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.ContextKeyRegexExpr=X;class Q{static create(C){return new Q(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(C){return new Q(this.c.map(C))}negate(){return this.c}}e.ContextKeyNotRegexExpr=Q;function Y(F){let C=null;for(let U=0,z=F.length;U<z;U++){const K=F[U].substituteConstants();if(F[U]!==K&&C===null){C=[];for(let B=0;B<U;B++)C[B]=F[B]}C!==null&&(C[U]=K)}return C===null?F:C}class Z{static create(C,U,z){return Z.d(C,U,z)}constructor(C,U){this.expr=C,this.c=U,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const K=t(this.expr[U],C.expr[U]);if(K!==0)return K}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=Y(this.expr);return C===this.expr?this:Z.create(C,this.c,!1)}evaluate(C){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(C))return!1;return!0}static d(C,U,z){const K=[];let B=!1;for(const _ of C)if(!!_){if(_.type===1){B=!0;continue}if(_.type===0)return s.INSTANCE;if(_.type===6){K.push(..._.expr);continue}K.push(_)}if(K.length===0&&B)return r.INSTANCE;if(K.length!==0){if(K.length===1)return K[0];K.sort(t);for(let _=1;_<K.length;_++)K[_-1].equals(K[_])&&(K.splice(_,1),_--);if(K.length===1)return K[0];for(;K.length>1;){const _=K[K.length-1];if(_.type!==9)break;K.pop();const te=K.pop(),ce=K.length===0,he=x.create(_.expr.map(pe=>Z.create([pe,te],null,z)),null,ce);he&&(K.push(he),K.sort(t))}if(K.length===1)return K[0];if(z){for(let _=0;_<K.length;_++)for(let te=_+1;te<K.length;te++)if(K[_].negate().equals(K[te]))return s.INSTANCE;if(K.length===1)return K[0]}return new Z(K,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new Z(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.c){const C=[];for(const U of this.expr)C.push(U.negate());this.c=x.create(C,this,!0)}return this.c}}e.ContextKeyAndExpr=Z;class x{static create(C,U,z){return x.d(C,U,z)}constructor(C,U){this.expr=C,this.c=U,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const K=t(this.expr[U],C.expr[U]);if(K!==0)return K}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=Y(this.expr);return C===this.expr?this:x.create(C,this.c,!1)}evaluate(C){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(C))return!0;return!1}static d(C,U,z){let K=[],B=!1;if(C){for(let _=0,te=C.length;_<te;_++){const ce=C[_];if(!!ce){if(ce.type===0){B=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){K=K.concat(ce.expr);continue}K.push(ce)}}if(K.length===0&&B)return s.INSTANCE;K.sort(t)}if(K.length!==0){if(K.length===1)return K[0];for(let _=1;_<K.length;_++)K[_-1].equals(K[_])&&(K.splice(_,1),_--);if(K.length===1)return K[0];if(z){for(let _=0;_<K.length;_++)for(let te=_+1;te<K.length;te++)if(K[_].negate().equals(K[te]))return r.INSTANCE;if(K.length===1)return K[0]}return new x(K,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new x(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.c){const C=[];for(const U of this.expr)C.push(U.negate());for(;C.length>1;){const U=C.shift(),z=C.shift(),K=[];for(const B of H(U))for(const _ of H(z))K.push(Z.create([B,_],null,!1));C.unshift(x.create(K,null,!1))}this.c=x.create(C,this,!0)}return this.c}}e.ContextKeyOrExpr=x;class j extends a{static all(){return j.d.values()}constructor(C,U,z){super(C,null),this.f=U,typeof z=="object"?j.d.push({...z,key:C}):z!==!0&&j.d.push({key:C,description:z,type:U!=null?typeof U:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return h.create(this.key,C)}notEqualsTo(C){return R.create(this.key,C)}}j.d=[],e.RawContextKey=j,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function ee(F,C){return F<C?-1:F>C?1:0}function ne(F,C,U,z){return F<U?-1:F>U?1:C<z?-1:C>z?1:0}function re(F,C){if(F.type===0||C.type===1)return!0;if(F.type===9)return C.type===9?G(F.expr,C.expr):!1;if(C.type===9){for(const U of C.expr)if(re(F,U))return!0;return!1}if(F.type===6){if(C.type===6)return G(C.expr,F.expr);for(const U of F.expr)if(re(U,C))return!0;return!1}return F.equals(C)}e.implies=re;function G(F,C){let U=0,z=0;for(;U<F.length&&z<C.length;){const K=F[U].cmp(C[z]);if(K<0)return!1;K===0&&U++,z++}return U===F.length}function H(F){return F.type===9?F.expr:[F]}}),define(oe[98],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function N(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=N;class c{async getPerformanceInfo(T,D){return{}}async getSystemInfo(T,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,D){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=c}),define(oe[99],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,161,5]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function c(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=c;function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function T(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function D(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function I(u,g,y){return D(g,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:S(y).includes(u)}e.isTargetPlatformCompatible=I;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,N.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var l;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class f extends Error{constructor(g,y){super(g),this.code=y,this.name=y}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,N.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,N.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,N.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(oe[202],ae([0,1,3,2,32,12,93,29]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(l,f){return l?O.URI.revive(f?f.transformIncoming(l):l):void 0}function S(l,f){return f?f.transformOutgoingURI(l):l}function P(l,f){f=f||T.DefaultURITransformer;const u=l.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...l,manifest:void 0},f),manifest:u}}function b(l,f){return l?.profileLocation?(0,T.transformAndReviveIncomingURIs)(l,f??T.DefaultURITransformer):l}function m(l,f){return f?(0,c.cloneAndChange)(l,u=>u instanceof O.URI?f.transformOutgoingURI(u):void 0):l}class d{constructor(f,u){this.a=f,this.b=u,this.onInstallExtension=L.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,u){const g=this.b(f);switch(u){case"onInstallExtension":return L.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,y=>y.map(k=>({...k,local:k.local?m(k.local,g):k.local,profileLocation:k.profileLocation?S(k.profileLocation,g):k.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?S(y.profileLocation,g):y.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,y=>m(y,g))}throw new Error("Invalid listen")}async call(f,u,g){const y=this.b(f);switch(u){case"zip":{const k=P(g[0],y),i=await this.a.zip(k);return S(i,y)}case"unzip":return this.a.unzip(I(g[0],y));case"install":return this.a.install(I(g[0],y),b(g[1],y));case"installFromLocation":return this.a.installFromLocation(I(g[0],y),I(g[1],y));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],I(g[1],y),I(g[2],y));case"getManifest":return this.a.getManifest(I(g[0],y));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],b(g[1],y));case"uninstall":return this.a.uninstall(P(g[0],y),b(g[1],y));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(g[0],y));case"getInstalled":return(await this.a.getInstalled(g[0],I(g[1],y))).map(i=>m(i,y));case"copyExtensions":return this.a.copyExtensions(I(g[0],y),I(g[1],y));case"updateMetadata":{const k=await this.a.updateMetadata(P(g[0],y),g[1],I(g[2],y));return m(k,y)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1],g[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends N.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.k=f,this.c=this.B(new L.Emitter),this.f=this.B(new L.Emitter),this.g=this.B(new L.Emitter),this.h=this.B(new L.Emitter),this.j=this.B(new L.Emitter),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?O.URI.revive(u.source):u.source,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.m(g.source)?O.URI.revive(g.source):g.source,profileLocation:O.URI.revive(g.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}l(f,u){f.fire(u)}m(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(f){const u=await this.getTargetPlatform();return f.allTargetPlatforms.some(g=>(0,D.isTargetPlatformCompatible)(g,f.allTargetPlatforms,u))}zip(f){return Promise.resolve(this.k.call("zip",[f]).then(u=>O.URI.revive(u)))}unzip(f){return Promise.resolve(this.k.call("unzip",[f]))}install(f,u){return Promise.resolve(this.k.call("install",[f,u])).then(g=>P(g,null))}installFromLocation(f,u){return Promise.resolve(this.k.call("installFromLocation",[f,u])).then(g=>P(g,null))}async installExtensionsFromProfile(f,u,g){return(await this.k.call("installExtensionsFromProfile",[f,u,g])).map(k=>P(k,null))}getManifest(f){return Promise.resolve(this.k.call("getManifest",[f]))}installFromGallery(f,u){return Promise.resolve(this.k.call("installFromGallery",[f,u])).then(g=>P(g,null))}uninstall(f,u){return Promise.resolve(this.k.call("uninstall",[f,u]))}reinstallFromGallery(f){return Promise.resolve(this.k.call("reinstallFromGallery",[f])).then(u=>P(u,null))}getInstalled(f=null,u){return Promise.resolve(this.k.call("getInstalled",[f,u])).then(g=>g.map(y=>P(y,null)))}updateMetadata(f,u,g){return Promise.resolve(this.k.call("updateMetadata",[f,u,g])).then(y=>P(y,null))}copyExtensions(f,u){return this.k.call("copyExtensions",[f,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(f,u,g){const y=await this.k.call("download",[f,u,g]);return O.URI.revive(y)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class E{constructor(f){this.a=f}listen(f,u){throw new Error("Invalid listen")}call(f,u,g){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(oe[100],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((O,T)=>ie(["node-vsce-sign"],async D=>O(D),T))),this.a}async verify(O,T,D){let I;try{I=await this.b()}catch{return!1}return I.verify(O,T,D)}}e.ExtensionSignatureVerificationService=N}),define(oe[101],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var N;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(N=e.RecommendationSource||(e.RecommendationSource={}));function c(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=c;var O;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(O=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,48,14,27,11,12,169,5,4,22]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function b(j){return j.create===!0}e.isFileOpenForWriteOptions=b;var m;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var d;(function(j){j[j.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var p;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=E;function l(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=l;function f(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=f;function u(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=g;function y(j){return E(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var k;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(ee,ne){const re=new i(ee.toString(),ne);return t(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.FileSystemProviderError=i;function o(j,ee){return i.create(j,ee)}e.createFileSystemProviderError=o;function n(j){return j||o((0,D.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=n;function t(j,ee){return j.name=ee?`${ee} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=t;function s(j){if(!j)return k.Unknown;if(j instanceof i)return j.code;const ee=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!ee)return k.Unknown;switch(ee[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=s;function r(j){if(j instanceof A)return j.fileOperationResult;switch(s(j)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var a;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class h{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=h;var w;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class v{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const G of ee){const H=re.get(G.type);switch(H?H.push([G.resource,G]):re.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,H]of re)switch(G){case 1:this.a=L.TernarySearchTree.forUris(()=>ne),this.a.fill(H);break;case 0:this.b=L.TernarySearchTree.forUris(()=>ne),this.b.fill(H);break;case 2:this.c=L.TernarySearchTree.forUris(()=>ne),this.c.fill(H);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...re){if(!ee)return!1;const G=re.length>0;return!!((!G||re.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!G||re.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!G||re.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=v;function R(j,ee,ne){return!j||!ee||j===ee||ee.length>j.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,c.startsWithIgnoreCase)(j,ee):j.indexOf(ee)===0)}e.isParent=R;class A extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.FileOperationError=A;class M extends A{constructor(ee,ne,re,G){super(ee,ne,G),this.fileOperationResult=ne,this.size=re}}e.TooLargeFileOperationError=M;class $ extends A{constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.NotModifiedSinceFileOperationError=$;var V;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=W;async function X(j,ee){if(!ee.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===j.scheme&&G.added&&(re.dispose(),ne())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(ee){return(0,O.isNumber)(ee)||(ee=0),ee<Q.KB?(0,D.localize)(1,null,ee.toFixed(0)):ee<Q.MB?(0,D.localize)(2,null,(ee/Q.KB).toFixed(2)):ee<Q.GB?(0,D.localize)(3,null,(ee/Q.MB).toFixed(2)):ee<Q.TB?(0,D.localize)(4,null,(ee/Q.GB).toFixed(2)):(0,D.localize)(5,null,(ee/Q.TB).toFixed(2))}}Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB,e.ByteSize=Q;var Y;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Z(j){return{maxFileSize:j===0?300*Q.MB:16*Q.GB,maxHeapSize:j===0?700*Q.MB:2*700*Q.MB}}e.getPlatformFileLimits=Z;function x(j){const ee=typeof j=="string"||j?.scheme===P.Schemas.vscodeRemote;return typeof j!="string"&&j?.scheme===P.Schemas.file?1024*Q.MB:ee?10*Q.MB:S.isWeb?50*Q.MB:1024*Q.MB}e.getLargeFileConfirmationLimit=x});var J=this&&this.__param||function(ie,e){return function(L,N){e(L,N,ie)}};define(oe[203],ae([0,1,102,43,13]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let O=class{constructor(D){this.a=D}async checksum(D){const I=(await this.a.readFileStream(D)).value;return new Promise((S,P)=>{const b=(0,L.createHash)("md5");(0,N.listenStream)(I,{onData:m=>b.update(m.buffer),onError:m=>P(m),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};O=ye([J(0,c.IFileService)],O),e.ChecksumService=O}),define(oe[204],ae([0,1,16,38,10,3,2,43,12,31,13]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(d,p){super(),this.a=d,this.b=p,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,p){const{buffer:E}=await this.a.call("readFile",[d,p]);return E}readFileStream(d,p,E){const l=(0,D.newWriteableStream)(u=>L.VSBuffer.concat(u.map(g=>L.VSBuffer.wrap(g))).buffer),f=this.a.listen("readFileStream",[d,p])(u=>{if(u instanceof L.VSBuffer)l.write(u.buffer);else{if(u==="end")l.end();else{let g;if(u instanceof Error)g=u;else{const y=u;g=(0,P.createFileSystemProviderError)(y.message??(0,N.toErrorMessage)(y),y.code??P.FileSystemProviderErrorCode.Unknown)}l.error(g),l.end()}f.dispose()}});return E.onCancellationRequested(()=>{l.error((0,c.canceled)()),l.end(),f.dispose()}),l}writeFile(d,p,E){return this.a.call("writeFile",[d,L.VSBuffer.wrap(p),E])}open(d,p){return this.a.call("open",[d,p])}close(d){return this.a.call("close",[d])}async read(d,p,E,l,f){const[u,g]=await this.a.call("read",[d,p,f]);return E.set(u.buffer.slice(0,g),l),g}write(d,p,E,l,f){return this.a.call("write",[d,p,L.VSBuffer.wrap(E),l,f])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,p){return this.a.call("delete",[d,p])}rename(d,p,E){return this.a.call("rename",[d,p,E])}copy(d,p,E){return this.a.call("copy",[d,p,E])}cloneFile(d,p){return this.a.call("cloneFile",[d,p])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const p=d;this.f.fire(p.map(E=>({resource:I.URI.revive(E.resource),type:E.type})))}else{const p=d;this.g.fire(p)}}))}watch(d,p){const E=(0,S.generateUuid)();return this.a.call("watch",[this.h,E,d,p]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,E]))}}e.DiskFileSystemProviderClient=b}),define(oe[103],ae([0,1,16,10,170,13]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,b,m,d,p,E){let l;try{await D(P,b,m,d,p,E)}catch(f){l=f}finally{l&&p.errorTransformer&&(l=p.errorTransformer(l)),typeof l<"u"&&m.error(l),m.end()}}e.readFileIntoStream=T;async function D(P,b,m,d,p,E){I(E);const l=await P.open(b,{create:!1});try{I(E);let f=0,u=0,g=p&&typeof p.length=="number"?p.length:void 0,y=L.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),k=p&&typeof p.position=="number"?p.position:0,i=0;do u=await P.read(l,k,y.buffer,i,y.byteLength-i),k+=u,i+=u,f+=u,typeof g=="number"&&(g-=u),i===y.byteLength&&(await m.write(d(y)),y=L.VSBuffer.alloc(Math.min(p.bufferSize,typeof g=="number"?g:p.bufferSize)),i=0);while(u>0&&(typeof g!="number"||g>0)&&I(E)&&S(f,p));if(i>0){let o=i;typeof g=="number"&&(o=Math.min(i,g)),m.write(d(y.slice(0,o)))}}catch(f){throw(0,O.ensureFileSystemProviderError)(f)}finally{await P.close(l)}}function I(P){if(P.isCancellationRequested)throw(0,N.canceled)();return!0}function S(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,O.createFileSystemProviderError)((0,c.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,O.createFileSystemProviderError)((0,c.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,92,2,14,4,12,13]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(f){return f.recursive===!0}e.isRecursiveWatchRequest=I;class S extends N.Disposable{constructor(u,g,y,k){super(),this.h=u,this.i=g,this.j=y,this.k=k,this.c=this.B(new N.MutableDisposable),this.f=void 0,this.g=0}m(){const u=new N.DisposableStore;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(g=>this.h(g))),u.add(this.b.onDidLogMessage(g=>this.i(g))),u.add(this.b.onDidError(g=>this.n(g)))}n(u){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}S.a=5,e.AbstractWatcherClient=S;class P extends S{constructor(u,g,y){super(u,g,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class b extends S{constructor(u,g,y){super(u,g,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function m(f){return f.map(u=>({type:u.type,resource:T.URI.file(u.path)}))}e.toFileChanges=m;function d(f){const u=new l;for(const g of f)u.processEvent(g);return u.coalesce()}e.coalesceEvents=d;function p(f,u){return typeof u=="string"&&!u.startsWith(L.GLOBSTAR)&&!(0,c.isAbsolute)(u)?{base:f,pattern:u}:u}e.normalizeWatcherPattern=p;function E(f,u){const g=[];for(const y of u)g.push((0,L.parse)(p(f,y)));return g}e.parseWatcherPatterns=E;class l{constructor(){this.a=new Set,this.b=new Map}c(u){return O.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const g=this.b.get(this.c(u));let y=!1;if(g){const k=g.type,i=u.type;g.path!==u.path&&(u.type===2||u.type===1)?y=!0:k===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(g)):k===2&&i===1?g.type=0:k===1&&i===0||(g.type=i)}else y=!0;y&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],g=[];return Array.from(this.a).filter(y=>y.type!==2?(u.push(y),!1):!0).sort((y,k)=>y.path.length-k.path.length).filter(y=>g.some(k=>(0,D.isParent)(y.path,k,!O.isLinux))?!1:(g.push(y.path),!0)).concat(u)}}}),define(oe[205],ae([0,1,54,6,25,47,2,85,14,4,146,28,56]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends T.Disposable{constructor(l,f,u,g){super(),this.j=l,this.k=f,this.l=u,this.m=g,this.c=this.B(new N.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.B(new N.RunOnceWorker(y=>this.u(y),d.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new c.CancellationTokenSource,this.ready=this.n()}async n(){try{const l=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const f=await b.Promises.stat(l);this.B(await this.s(l,f.isDirectory()))}catch(l){l.code!=="ENOENT"?this.w(l):this.z(l)}}async r(l){let f=l.path;try{f=await b.Promises.realpath(l.path),l.path===f&&(f=await(0,P.realcase)(l.path)??l.path),l.path!==f&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${f})`)}catch{}return f}async s(l,f){if(S.isMacintosh&&(0,O.isEqualOrParent)(l,"/Volumes/",!0))return this.w(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const u=new c.CancellationTokenSource(this.i.token),g=new T.DisposableStore;try{const y=(0,I.basename)(l),k=(0,L.watch)(l);g.add((0,T.toDisposable)(()=>{k.removeAllListeners(),k.close()})),this.z(`Started watching: '${l}'`);const i=new Set;if(f)try{for(const n of await b.Promises.readdir(l))i.add(n)}catch(n){this.w(n)}const o=new Map;g.add((0,T.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),k.on("error",(n,t)=>{this.w(`Failed to watch ${l} for changes using fs.watch() (${n}, ${t})`),this.dispose()}),k.on("change",(n,t)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${t}`);let s="";if(t&&(s=t.toString(),S.isMacintosh&&(s=(0,D.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(f)if(n==="rename"){o.get(s)?.dispose();const r=setTimeout(async()=>{if(o.delete(s),s===y&&!await b.Promises.exists(l)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,I.join)(l,s));if(u.token.isCancellationRequested)return;let h;a?i.has(s)?h=0:(h=1,i.add(s)):(i.delete(s),h=2),this.t({path:(0,I.join)(this.j.path,s),type:h})},d.a);o.set(s,(0,T.toDisposable)(()=>clearTimeout(r)))}else{let r;i.has(s)?r=0:(r=1,i.add(s)),this.t({path:(0,I.join)(this.j.path,s),type:r})}else if(n==="rename"||s!==y){const r=setTimeout(async()=>{const a=await b.Promises.exists(l);u.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),g.add(await this.s(l,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);g.clear(),g.add((0,T.toDisposable)(()=>clearTimeout(r)))}else this.t({path:this.j.path,type:0},!0)})}catch(y){await b.Promises.exists(l)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${l} for changes using fs.watch() (${y.toString()})`)}return(0,T.toDisposable)(()=>{u.dispose(!0),g.dispose()})}t(l,f=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!f&&this.g.some(u=>u(l.path))?this.m&&this.z(` >> ignored (excluded) ${l.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(u=>u(l.path))?this.m&&this.z(` >> ignored (not included) ${l.path}`):this.f.work(l))}u(l){const f=(0,m.coalesceEvents)(l);if(f.length>0){if(this.m)for(const g of f)this.z(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(f)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(l){if(S.isLinux)return b.Promises.exists(l);try{const f=(0,I.basename)(l);return(await b.Promises.readdir((0,I.dirname)(l))).some(g=>g===f)}catch(f){return this.z(f),!1}}setVerboseLogging(l){this.m=l}w(l){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}y(l){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}z(l){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function p(E,l,f,u,g=512){const y=await b.Promises.open(E,"r"),k=Buffer.allocUnsafe(g),i=new c.CancellationTokenSource(u);let o,n=!1;const t={path:E,excludes:[],recursive:!1},s=new d(t,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await b.Promises.read(y,k,0,g,null);if(!h||i.token.isCancellationRequested)break;l(k.slice(0,h))}}catch(h){o=new Error(h),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,f(),new Promise((r,a)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(y)}catch(h){o=new Error(h)}o?a(o):r()})})}e.watchFileContents=p}),define(oe[206],ae([0,1,3,92,2,4,205]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends c.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(S){const P=this.i(S),b=P.filter(d=>{const p=this.c.get(d.path);return p?!(0,N.patternsEquals)(p.request.excludes,d.excludes)||!(0,N.patternsEquals)(p.request.includes,d.includes):!0}),m=Array.from(this.c.values()).filter(({request:d})=>!P.find(p=>p.path===d.path&&(0,N.patternsEquals)(p.excludes,d.excludes)&&(0,N.patternsEquals)(p.includes,d.includes))).map(({request:d})=>d.path);b.length&&this.j(`Request to start watching: ${b.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.h(d);for(const d of b)this.g(d)}g(S){const P=new T.NodeJSFileWatcherLibrary(S,m=>this.a.fire(m),m=>this.b.fire(m),this.f),b={request:S,instance:P};this.c.set(S.path,b)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const P=this.c.get(S);P&&(this.c.delete(S),P.instance.dispose())}i(S){const P=new Map;for(const b of S){const m=O.isLinux?b.path:b.path.toLowerCase();P.set(m,b)}return Array.from(P.values())}async setVerboseLogging(S){this.f=S;for(const[,P]of this.c)P.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,P){return P?`[File Watcher (node.js)] ${S} (path: ${P.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=D}),define(oe[207],ae([0,1,56,206]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class c extends L.AbstractNonRecursiveWatcherClient{constructor(T,D,I){super(T,D,I),this.m()}l(){return new N.NodeJSWatcher}}e.NodeJSWatcherClient=c}),define(oe[208],ae([0,1,22,39,65,56]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends O.AbstractUniversalWatcherClient{constructor(I,S,P){super(I,S,P),this.m()}l(I){const S=I.add(new c.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:P,signal:b})=>this.n(`terminated by itself with code ${P}, signal: ${b}`))),N.ProxyChannel.toService((0,N.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[70],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...c){this.a=new Map;for(const[O,T]of c)this.set(O,T)}set(c,O){const T=this.a.get(c);return this.a.set(c,O),T}has(c){return this.a.has(c)}get(c){return this.a.get(c)}}e.ServiceCollection=L}),define(oe[209],ae([0,1,6,10,2,68,200,5,70,84]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class b extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class m{constructor(l=new I.ServiceCollection,f=!1,u,g=P){this.f=l,this.g=f,this.h=u,this.i=g,this.o=new Set,this.f.set(D.IInstantiationService,this),this._globalGraph=g?u?._globalGraph??new T.Graph(y=>y):void 0}createChild(l){return new m(l,this.g,this,this.i)}invokeFunction(l,...f){const u=p.traceInvocation(this.i,l);let g=!1;try{return l({get:k=>{if(g)throw(0,N.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(k,u);if(!i)throw new Error(`[invokeFunction] unknown service '${k}'`);return i}},...f)}finally{g=!0,u.stop()}}createInstance(l,...f){let u,g;return l instanceof O.SyncDescriptor?(u=p.traceCreation(this.i,l.ctor),g=this.j(l.ctor,l.staticArguments.concat(f),u)):(u=p.traceCreation(this.i,l),g=this.j(l,f,u)),u.stop(),g}j(l,f=[],u){const g=D._util.getServiceDependencies(l).sort((i,o)=>i.index-o.index),y=[];for(const i of g){const o=this.m(i.id,u);o||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(o)}const k=g.length>0?g[0].index:f.length;if(f.length!==k){console.trace(`[createInstance] First service dependency of ${l.name} at position ${k+1} conflicts with ${f.length} static arguments`);const i=k-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,k)}return Reflect.construct(l,f.concat(y))}k(l,f){if(this.f.get(l)instanceof O.SyncDescriptor)this.f.set(l,f);else if(this.h)this.h.k(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const f=this.f.get(l);return!f&&this.h?this.h.l(l):f}m(l,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const u=this.l(l);return u instanceof O.SyncDescriptor?this.q(l,u,f.branch(l,!0)):(f.branch(l,!1),u)}q(l,f,u){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,f,u)}finally{this.o.delete(l)}}r(l,f,u){const g=new T.Graph(i=>i.id.toString());let y=0;const k=[{id:l,desc:f,_trace:u}];for(;k.length;){const i=k.pop();if(g.lookupOrInsertNode(i),y++>1e3)throw new b(g);for(const o of D._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${l} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof O.SyncDescriptor){const t={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};g.insertEdge(i,t),k.push(t)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new b(g);break}for(const{data:o}of i){if(this.l(o.id)instanceof O.SyncDescriptor){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}g.removeNode(o)}}return this.l(l)}s(l,f,u=[],g,y){if(this.f.get(l)instanceof O.SyncDescriptor)return this.t(l,f,u,g,y);if(this.h)return this.h.s(l,f,u,g,y);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(l,f,u=[],g,y){if(g){const k=new m(void 0,this.g,this,this.i);k.c=String(l);const i=new Map,o=new L.IdleValue(()=>{const n=k.j(f,u,y);for(const[t,s]of i){const r=n[t];if(typeof r=="function")for(const a of s)r.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let a=i.get(t);return a||(a=new S.LinkedList,i.set(t,a)),(w,v,R)=>{const A=a.push([w,v,R]);return(0,c.toDisposable)(A)}}if(t in n)return n[t];const s=o.value;let r=s[t];return typeof r!="function"||(r=r.bind(s),n[t]=r),r},set(n,t,s){return o.value[t]=s,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,u,y)}u(l,f){if(f&&console.warn(l),this.g)throw new Error(l)}}e.InstantiationService=m;var d;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(d||(d={}));class p{static traceInvocation(l,f){return l?new p(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(l,f){return l?new p(1,f.name):p.c}constructor(l,f){this.type=l,this.name=f,this.g=Date.now(),this.h=[]}branch(l,f){const u=new p(3,l.toString());return this.h.push([l,f,u]),u}stop(){const l=Date.now()-this.g;p.f+=l;let f=!1;function u(y,k){const i=[],o=new Array(y+1).join("	");for(const[n,t,s]of k.h)if(t&&s){f=!0,i.push(`${o}CREATES -> ${n}`);const r=u(y+1,s);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(l>2||f)&&p.all.add(g.join(`
`))}}p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0,e.Trace=p}),define(oe[71],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class N{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}e.MainProcessService=N}),define(oe[72],ae([0,1,25,2,4,172,29,5]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,D.createDecorator)("languagePackService");let S=class extends N.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new L.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const p=m.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(l=>l.startsWith("lp-"))).map(E=>{const l=E.properties.localizedLanguages?.[0],f=I(E);return{...this.f(f,l,E),extensionId:E.identifier.id,galleryExtension:E}});return p.push(this.f("en","English")),p}f(b,m,d){const p=m??b;let E;if(p!==b&&(E=`(${b})`),b.toLowerCase()===c.language.toLowerCase()&&(E??="",E+=(0,O.localize)(0,null)),d?.installCount){E??="";const l=d.installCount;let f;l>1e6?f=`${Math.floor(l/1e5)/10}M`:l>1e3?f=`${Math.floor(l/1e3)}K`:f=String(l),E+=` $(cloud-download) ${f}`}return{id:b,label:p,description:E}}};S=ye([J(0,T.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(oe[210],ae([0,1,2,72]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let c=class extends L.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};c=ye([J(0,N.ILanguagePackService)],c),e.LocalizationsUpdater=c}),define(oe[9],ae([0,1,38,3,53,2,37,4,23,11,12,69,5]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function d(){return new Date().toISOString()}function p(w){return(0,S.isNumber)(w)}e.isLogLevel=p;var E;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function l(w,v,R){switch(v){case E.Trace:w.trace(R);break;case E.Debug:w.debug(R);break;case E.Info:w.info(R);break;case E.Warning:w.warn(R);break;case E.Error:w.error(R);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=l;function f(w,v=!1){let R="";for(let A=0;A<w.length;A++){let M=w[A];if(M instanceof Error&&(M=(0,L.toErrorMessage)(M,v)),typeof M=="object")try{M=JSON.stringify(M)}catch{}R+=(A>0?" ":"")+M}return R}class u extends O.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new N.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.AbstractLogger=u;class g extends u{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...R){this.f(E.Trace)&&this.g(E.Trace,f([v,...R],!0))}debug(v,...R){this.f(E.Debug)&&this.g(E.Debug,f([v,...R]))}info(v,...R){this.f(E.Info)&&this.g(E.Info,f([v,...R]))}warn(v,...R){this.f(E.Warning)&&this.g(E.Warning,f([v,...R]))}error(v,...R){if(this.f(E.Error))if(v instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=v.stack,this.g(E.Error,f(A))}else this.g(E.Error,f([v,...R]))}flush(){}}e.AbstractMessageLogger=g;class y extends u{constructor(v=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(v),this.g=!D.isWindows}trace(v,...R){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...R):console.log(`[main ${d()}]`,v,...R))}debug(v,...R){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...R):console.log(`[main ${d()}]`,v,...R))}info(v,...R){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,v,...R):console.log(`[main ${d()}]`,v,...R))}warn(v,...R){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,v,...R):console.warn(`[main ${d()}]`,v,...R))}error(v,...R){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,v,...R):console.error(`[main ${d()}]`,v,...R))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class k extends u{constructor(v=e.DEFAULT_LOG_LEVEL,R=!0){super(),this.g=R,this.setLevel(v)}trace(v,...R){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...R):console.log(v,...R))}debug(v,...R){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...R):console.log(v,...R))}info(v,...R){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...R):console.log(v,...R))}warn(v,...R){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...R):console.log(v,...R))}error(v,...R){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...R):console.error(v,...R))}dispose(){}flush(){}}e.ConsoleLogger=k;class i extends u{constructor(v,R=e.DEFAULT_LOG_LEVEL){super(),this.g=v,this.setLevel(R)}trace(v,...R){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...R])}debug(v,...R){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...R])}info(v,...R){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...R])}warn(v,...R){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...R])}error(v,...R){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...R])}h(v){return typeof v=="string"?v:(0,L.toErrorMessage)(v,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class o extends u{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const R of this.g)R.setLevel(v);super.setLevel(v)}trace(v,...R){for(const A of this.g)A.trace(v,...R)}debug(v,...R){for(const A of this.g)A.debug(v,...R)}info(v,...R){for(const A of this.g)A.info(v,...R)}warn(v,...R){for(const A of this.g)A.warn(v,...R)}error(v,...R){for(const A of this.g)A.error(v,...R)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose()}}e.MultiplexLogger=o;class n extends O.Disposable{constructor(v,R,A){if(super(),this.h=v,this.j=R,this.b=new T.ResourceMap,this.c=this.B(new N.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeVisibility=this.g.event,A)for(const M of A)this.b.set(M.resource,{logger:void 0,info:M})}k(v){return(0,S.isString)(v)?[...this.b.values()].find(R=>R.info.id===v):this.b.get(v)}getLogger(v){return this.k(v)?.logger}createLogger(v,R){const A=this.l(v),M=(0,S.isString)(v)?v:R?.id??(0,c.hash)(A.toString()).toString(16);let $=this.b.get(A)?.logger;const V=R?.logLevel==="always"?E.Trace:R?.logLevel;$||($=this.m(A,V??this.getLogLevel(A)??this.h,{...R,id:M}));const q={logger:$,info:{resource:A,id:M,logLevel:V,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(q.info),this.b.set(A,q),$}l(v){return(0,S.isString)(v)?(0,I.joinPath)(this.j,`${v}.log`):v}setLogLevel(v,R){if(P.URI.isUri(v)){const A=v,M=R,$=this.b.get(A);$&&M!==$.info.logLevel&&($.info.logLevel=M===this.h?void 0:M,$.logger?.setLevel(M),this.b.set($.info.resource,$),this.f.fire([A,M]))}else{this.h=v;for(const[A,M]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,R){const A=this.k(v);A&&R!==!A.info.hidden&&(A.info.hidden=!R,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,R]))}getLogLevel(v){let R;return v&&(R=this.b.get(v)?.info.logLevel),R??this.h}registerLogger(v){const R=this.b.get(v.resource);R?R.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const R=this.b.get(v);R&&(R.logger&&R.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class t{constructor(){this.onDidChangeLogLevel=new N.Emitter().event}setLevel(v){}getLevel(){return E.Info}trace(v,...R){}debug(v,...R){}info(v,...R){}warn(v,...R){}error(v,...R){}critical(v,...R){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;function r(w){if(w.verbose)return E.Trace;if(typeof w.logLevel=="string"){const v=h(w.logLevel.toLowerCase());if(v!==void 0)return v}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(w){switch(w){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=a;function h(w){switch(w){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=h,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",a(E.Info))}),define(oe[211],ae([0,1,6,10,2,23,28,15,9]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends c.Disposable{constructor(b,m){super(),this.a=b,this.b=m,this.B(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,O.basename)(this.a.logsHome),m=(0,O.dirname)(this.a.logsHome),E=(await T.Promises.readdir(m.fsPath)).filter(f=>/^\d{8}T\d{6}$/.test(f)).sort().filter(f=>f!==b),l=E.slice(0,Math.max(0,E.length-9));l.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map(f=>T.Promises.rm((0,O.joinPath)(m,f).fsPath))))}catch(b){(0,N.onUnexpectedError)(b)}}};S=ye([J(0,D.IEnvironmentService),J(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(oe[212],ae([0,1,21,6,10,3,2,14,56,9]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.ThrottledDelayer(0)),this.s=[],this.t=this.B(new N.ThrottledDelayer(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(m,d):this.u(m,d)}l(m,d){const p={path:this.C(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive},E=(0,L.insert)(this.j,p);return this.m(),(0,T.toDisposable)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,c.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,I.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,d){const p={path:this.C(m),excludes:d.excludes,includes:d.includes,recursive:!1},E=(0,L.insert)(this.s,p);return this.v(),(0,T.toDisposable)(()=>{E(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,c.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,D.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(oe[213],ae([0,1,21,6,16,25,3,53,63,2,48,22,104,23,43,168,13,103,9,10]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends S.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.ResourceQueue)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const n=new S.DisposableStore;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),n.add(o.onDidChangeFile(t=>this.R.fire(new l.FileChangesEvent(t,!this.O(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(t=>this.S.fire(new Error(t)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,S.dispose)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(n){o.push(n)}}),!this.h.has(i)&&await N.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return I.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,d.isAbsolutePath)(i))throw new l.FileOperationError((0,E.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const n=new g.ErrorNoTelemetry;throw n.message=(0,E.localize)(1,null,i.toString()),n}return o}async k(i){const o=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasReadWriteCapability)(o)||(0,l.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const o=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.n(i,o)}catch(n){throw(0,l.toFileSystemProviderErrorCode)(n)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,E.localize)(2,null,this.nb(i)),1):(0,l.ensureFileSystemProviderError)(n)}}async n(i,o){const n=await this.j(i),t=this.O(n),s=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await n.stat(i);let w;return this.p(n,i,h,void 0,!!a,(v,R)=>(w||(w=P.TernarySearchTree.forUris(()=>!t),w.set(i,!0),s&&w.fill(!0,s)),w.get(v.resource)||w.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&r?R===1:!1))}async p(i,o,n,t,s,r){const{providerExtUri:a}=this.N(i),h={resource:o,name:a.basename(o),isFile:(n.type&l.FileType.File)!==0,isDirectory:(n.type&l.FileType.Directory)!==0,isSymbolicLink:(n.type&l.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&l.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,l.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(h.isDirectory&&r(h,t)){try{const w=await i.readdir(o),v=await N.Promises.settled(w.map(async([R,A])=>{try{const M=a.joinPath(o,R),$=s?await i.stat(M):{type:A};return await this.p(i,M,$,w.length,s,r)}catch(M){return this.b.trace(M),null}}));h.children=(0,L.coalesce)(v)}catch(w){this.b.trace(w),h.children=[]}return h}return h}async resolveAll(i){return N.Promises.settled(i.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),n=await o.stat(i);return this.p(o,i,n,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.r(i,o)}catch(n){return n}return!0}async r(i,o){if(!o?.overwrite&&await this.exists(i))throw new l.FileOperationError((0,E.localize)(3,null,this.nb(i)),3,o)}async createFile(i,o=c.VSBuffer.fromString(""),n){await this.r(i,n);const t=await this.writeFile(i,o);return this.m.fire(new l.FileOperationEvent(i,0,t)),t}async writeFile(i,o,n){const t=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(t);try{await this.s(t,i,n)||await this.P(t,s.dirname(i));let a;if((0,l.hasReadWriteCapability)(t)&&!(o instanceof c.VSBuffer))if((0,p.isReadableStream)(o)){const h=await(0,p.peekStream)(o,3);h.ended?a=c.VSBuffer.concat(h.buffer):a=h}else a=(0,p.peekReadable)(o,h=>c.VSBuffer.concat(h),3);else a=o;!(0,l.hasOpenReadWriteCloseCapability)(t)||(0,l.hasReadWriteCapability)(t)&&a instanceof c.VSBuffer?await this.cb(t,i,n,a):await this.Y(t,i,n,a instanceof c.VSBuffer?(0,c.bufferToReadable)(a):a),this.m.fire(new l.FileOperationEvent(i,4))}catch(r){throw new l.FileOperationError((0,E.localize)(4,null,this.nb(i),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),n)}return this.resolve(i,{resolveMetadata:!0})}async s(i,o,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,E.localize)(5,null,this.nb(o)));let s;try{s=await i.stat(o)}catch{return}if((s.type&l.FileType.Directory)!==0)throw new l.FileOperationError((0,E.localize)(6,null,this.nb(o)),0,n);if(this.mb(o,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==l.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,l.etag)({mtime:n.mtime,size:s.size}))throw new l.FileOperationError((0,E.localize)(7,null),3,n);return s}async readFile(i,o,n){const t=await this.k(i);return o?.atomic?this.t(t,i,o,n):this.u(t,i,o,n)}async t(i,o,n,t){return new Promise((s,r)=>{this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{try{const a=await this.u(i,o,n,t);s(a)}catch(a){r(a)}})})}async u(i,o,n,t){const s=await this.v(i,o,{...n,preferUnbuffered:!0},t);return{...s,value:await(0,c.streamToBuffer)(s.value)}}async readFileStream(i,o,n){const t=await this.k(i);return this.v(t,i,o,n)}async v(i,o,n,t){const s=new O.CancellationTokenSource(t),r=this.F(o,n).then(h=>h,h=>{throw s.cancel(),h});let a;try{return typeof n?.etag=="string"&&n.etag!==l.ETAG_DISABLED&&await r,n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)||!((0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasFileReadStreamCapability)(i))||(0,l.hasReadWriteCapability)(i)&&n?.preferUnbuffered?a=this.D(i,o,n):(0,l.hasFileReadStreamCapability)(i)?a=this.z(i,o,s.token,n):a=this.C(i,o,s.token,n),{...await r,value:a}}catch(h){throw a&&await(0,p.consumeStream)(a),this.w(h,o,n)}}w(i,o,n){const t=(0,E.localize)(8,null,this.nb(o),(0,l.ensureFileSystemProviderError)(i).toString());return i instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(t,i.stat,n):i instanceof l.TooLargeFileOperationError?new l.TooLargeFileOperationError(t,i.fileOperationResult,i.size,i.options):new l.FileOperationError(t,(0,l.toFileOperationResult)(i),n)}z(i,o,n,t=Object.create(null)){const s=i.readFileStream(o,t,n);return(0,p.transform)(s,{data:r=>r instanceof c.VSBuffer?r:c.VSBuffer.wrap(r),error:r=>this.w(r,o,t)},r=>c.VSBuffer.concat(r))}C(i,o,n,t=Object.create(null)){const s=(0,c.newWriteableBufferStream)();return(0,f.readFileIntoStream)(i,o,s,r=>r,{...t,bufferSize:this.a,errorTransformer:r=>this.w(r,o,t)},n),s}D(i,o,n){const t=(0,p.newWriteableStream)(s=>c.VSBuffer.concat(s));return(async()=>{try{let s;n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)?s=await i.readFile(o,{atomic:!0}):s=await i.readFile(o),typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.G(o,s.byteLength,n),t.end(c.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async F(i,o){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new l.FileOperationError((0,E.localize)(9,null,this.nb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==l.ETAG_DISABLED&&o.etag===n.etag)throw new l.NotModifiedSinceFileOperationError((0,E.localize)(10,null),n,o);return this.G(i,n.size,o),n}G(i,o,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&o>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&o>n.limits.size&&(t=7),typeof t=="number")throw new l.TooLargeFileOperationError((0,E.localize)(11,null,this.nb(i)),t,o,n)}}async canMove(i,o,n){return this.H(i,o,"move",n)}async canCopy(i,o,n){return this.H(i,o,"copy",n)}async H(i,o,n,t){if(i.toString()!==o.toString())try{const s=n==="move"?this.lb(await this.l(i),i):await this.k(i),r=this.lb(await this.l(o),o);await this.M(s,i,r,o,n,t)}catch(s){return s}return!0}async move(i,o,n){const t=this.lb(await this.l(i),i),s=this.lb(await this.l(o),o),r=await this.I(t,i,s,o,"move",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,r==="move"?2:3,a)),a}async copy(i,o,n){const t=await this.k(i),s=this.lb(await this.l(o),o),r=await this.I(t,i,s,o,"copy",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,r==="copy"?3:2,a)),a}async I(i,o,n,t,s,r){if(o.toString()===t.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.M(i,o,n,t,s,r);if(a&&!h&&r&&await this.del(t,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(t)),s==="copy"){if(i===n&&(0,l.hasFileFolderCopyCapability)(i))await i.copy(o,t,{overwrite:r});else{const w=await this.resolve(o);w.isDirectory?await this.L(i,w,n,t):await this.J(i,o,n,t)}return s}else return i===n?(await i.rename(o,t,{overwrite:r}),s):(await this.I(i,o,n,t,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(i,o,n,t){if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.eb(i,o,n,t);if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.kb(i,o,n,t);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.ib(i,o,n,t);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.gb(i,o,n,t)}async L(i,o,n,t){await n.mkdir(t),Array.isArray(o.children)&&await N.Promises.settled(o.children.map(async s=>{const r=this.N(n).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),n,r):this.J(i,s.resource,n,r)}))}async M(i,o,n,t,s,r){let a=!1;if(i===n){const{providerExtUri:w,isPathCaseSensitive:v}=this.N(i);if(v||(a=w.isEqual(o,t)),a&&s==="copy")throw new Error((0,E.localize)(12,null,this.nb(o),this.nb(t)));if(!a&&w.isEqualOrParent(t,o))throw new Error((0,E.localize)(13,null,this.nb(o),this.nb(t)))}const h=await this.exists(t);if(h&&!a){if(!r)throw new l.FileOperationError((0,E.localize)(14,null,this.nb(o),this.nb(t)),4);if(i===n){const{providerExtUri:w}=this.N(i);if(w.isEqualOrParent(o,t))throw new Error((0,E.localize)(15,null,this.nb(o),this.nb(t)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}N(i){const o=this.O(i);return{providerExtUri:o?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:o}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.lb(await this.j(i),i);await this.P(o,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,0,n)),n}async P(i,o){const n=[],{providerExtUri:t}=this.N(i);for(;!t.isEqual(o,t.dirname(o));)try{if(((await i.stat(o)).type&l.FileType.Directory)===0)throw new Error((0,E.localize)(16,null,this.nb(o)));break}catch(s){if((0,l.toFileSystemProviderErrorCode)(s)!==l.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(t.basename(o)),o=t.dirname(o)}for(let s=n.length-1;s>=0;s--){o=t.joinPath(o,n[s]);try{await i.mkdir(o)}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(i,o){try{await this.Q(i,o)}catch(n){return n}return!0}async Q(i,o){const n=this.lb(await this.j(i),i);if(!!o?.useTrash&&!(n.capabilities&4096))throw new Error((0,E.localize)(17,null,this.nb(i)));let s;try{s=await n.stat(i)}catch{}if(s)this.mb(i,s);else throw new l.FileOperationError((0,E.localize)(18,null,this.nb(i)),1);if(!!!o?.recursive){const a=await this.resolve(i);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,E.localize)(19,null,this.nb(i)))}return n}async del(i,o){const n=await this.Q(i,o),t=!!o?.useTrash,s=!!o?.recursive;await n.delete(i,{recursive:s,useTrash:t}),this.m.fire(new l.FileOperationEvent(i,1))}async cloneFile(i,o){const n=await this.j(i),t=this.lb(await this.l(o),o);if(n===t&&this.N(n).providerExtUri.isEqual(i,o))return;if(n===t&&(0,l.hasFileCloneCapability)(n))return n.cloneFile(i,o);await this.P(t,this.N(t).providerExtUri.dirname(o));const s=this.X.queueFor(i,this.N(n).providerExtUri);return n===t&&(0,l.hasFileFolderCopyCapability)(n)?s.queue(()=>n.copy(i,o,{overwrite:!0})):s.queue(()=>this.J(n,i,t,o))}watch(i,o={recursive:!1,excludes:[]}){const n=new S.DisposableStore;let t=!1,s=()=>{t=!0};return n.add((0,S.toDisposable)(()=>s())),(async()=>{try{const r=await this.W(i,o);t?(0,S.dispose)(r):s=()=>(0,S.dispose)(r)}catch(r){this.b.error(r)}})(),n}async W(i,o){const n=await this.j(i),t=(0,D.hash)([this.N(n).providerExtUri.getComparisonKey(i),o]);let s=this.U.get(t);return s||(s={count:0,disposable:n.watch(i,o)},this.U.set(t,s)),s.count+=1,(0,S.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,S.dispose)(s.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,S.dispose)(i.disposable);this.U.clear()}async Y(i,o,n,t){return this.X.queueFor(o,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(t)||(0,p.isReadableBufferedStream)(t)?await this.Z(i,s,t):await this.ab(i,s,t)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await i.close(s)}})}async Z(i,o,n){let t=0,s;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=c.VSBuffer.concat(n.buffer);await this.bb(i,o,r,r.byteLength,t,0),t+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,a)=>{(0,p.listenStream)(s,{onData:async h=>{s.pause();try{await this.bb(i,o,h,h.byteLength,t,0)}catch(w){return a(w)}t+=h.byteLength,setTimeout(()=>s.resume())},onError:h=>a(h),onEnd:()=>r()})})}async ab(i,o,n){let t=0,s;for(;(s=n.read())!==null;)await this.bb(i,o,s,s.byteLength,t,0),t+=s.byteLength}async bb(i,o,n,t,s,r){let a=0;for(;a<t;)a+=await i.write(o,s+a,n.buffer,r+a,t-a)}async cb(i,o,n,t){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.db(i,o,n,t))}async db(i,o,n,t){let s;t instanceof c.VSBuffer?s=t:(0,p.isReadableStream)(t)?s=await(0,c.streamToBuffer)(t):(0,p.isReadableBufferedStream)(t)?s=await(0,c.bufferedStreamToBuffer)(t):s=(0,c.readableToBuffer)(t),await i.writeFile(o,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(i,o,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.fb(i,o,n,t))}async fb(i,o,n,t){let s,r;try{s=await i.open(o,{create:!1}),r=await n.open(t,{create:!0,unlock:!1});const a=c.VSBuffer.alloc(this.a);let h=0,w=0,v=0;do v=await i.read(s,h,a.buffer,w,a.byteLength-w),await this.bb(n,r,a,v,h,w),h+=v,w+=v,w===a.byteLength&&(w=0);while(v>0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await N.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async gb(i,o,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.hb(i,o,n,t))}async hb(i,o,n,t){return n.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async ib(i,o,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.jb(i,o,n,t))}async jb(i,o,n,t){const s=await n.open(t,{create:!0,unlock:!1});try{const r=await i.readFile(o);await this.bb(n,s,c.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async kb(i,o,n,t){const s=await(0,c.streamToBuffer)(this.C(i,o,O.CancellationToken.None));await this.cb(n,t,void 0,s)}lb(i,o){if(i.capabilities&2048)throw new l.FileOperationError((0,E.localize)(20,null,this.nb(o)),6);return i}mb(i,o){if((o.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,E.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}};y=ye([J(0,u.ILogService)],y),e.FileService=y}),define(oe[214],ae([0,1,54,294,6,37,16,3,47,2,14,4,23,43,28,171,13,103,212,38,208,207]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(o)}`)}})();class i extends u.AbstractDiskFileSystemProvider{constructor(n,t){super(n,t),this.onDidChangeCapabilities=D.Event.None,this.H=new O.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:t,symbolicLink:s}=await p.SymlinkSupport.stat(this.C(n));return{type:this.G(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.Y(t)}}async readdir(n){try{const t=await p.Promises.readdir(this.C(n),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(n,r.name))).type:a=this.G(r),s.push([r.name,a])}catch(a){this.a.trace(a)}})),s}catch(t){throw this.Y(t)}}G(n,t){let s;return t?.dangling?s=l.FileType.Unknown:n.isFile()?s=l.FileType.File:n.isDirectory()?s=l.FileType.Directory:s=l.FileType.Unknown,t&&(s|=l.FileType.SymbolicLink),s}async I(n){const t=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const r=new c.Barrier;return this.H.set(n,r),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.H.get(n)===r&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(n,t){let s;try{t?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),s=await this.I(n));const r=this.C(n);return await p.Promises.readFile(r)}catch(r){throw this.Y(r)}finally{s?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,t,s){const r=(0,d.newWriteableStream)(a=>T.VSBuffer.concat(a.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,n,r,a=>a.buffer,{...t,bufferSize:256*1024},s),r}async writeFile(n,t,s){let r;try{const a=this.C(n);if(!s.create||!s.overwrite){if(await p.Promises.exists(a)){if(!s.overwrite)throw(0,l.createFileSystemProviderError)((0,E.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,l.createFileSystemProviderError)((0,E.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(r,0,t,0,t.byteLength)}catch(a){throw await this.Z(n,a)}finally{typeof r=="number"&&await this.close(r)}}static configureFlushOnWrite(n){i.O=n}async open(n,t){const s=this.C(n);let r;(0,l.isFileOpenForWriteOptions)(t)&&(r=await this.I(n));let a;try{if((0,l.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(s);w.mode&128||await p.Promises.chmod(s,w.mode|128)}catch(w){this.a.trace(w)}let h;if((0,l.isFileOpenForWriteOptions)(t)){if(b.isWindows)try{await p.Promises.truncate(s,0),h="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}h||(h="w")}else h="r";a=await p.Promises.open(s,h)}catch(h){throw r?.dispose(),(0,l.isFileOpenForWriteOptions)(t)?await this.Z(n,h):this.Y(h)}if(this.L.set(a,0),(0,l.isFileOpenForWriteOptions)(t)&&this.N.set(a,n),r){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.M.set(a,r),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),h.dispose())}return a}async close(n){const t=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await p.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(n)}catch(s){throw this.Y(s)}finally{t&&(this.M.get(n)===t&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),t.dispose())}}async read(n,t,s,r,a){const h=this.P(n,t);let w=null;try{w=(await p.Promises.read(n,s,r,a,h)).bytesRead}catch(v){throw this.Y(v)}finally{this.Q(n,h,w)}return w}P(n,t){return t===this.L.get(n)?null:t}Q(n,t,s){const r=this.L.get(n);typeof r=="number"&&(typeof t=="number"||(typeof s=="number"?this.L.set(n,r+s):this.L.delete(n)))}async write(n,t,s,r,a){return(0,c.retry)(()=>this.R(n,t,s,r,a),100,3)}async R(n,t,s,r,a){const h=this.P(n,t);let w=null;try{w=(await p.Promises.write(n,s,r,a,h)).bytesWritten}catch(v){throw await this.Z(this.N.get(n),v)}finally{this.Q(n,h,w)}return w}async mkdir(n){try{await p.Promises.mkdir(this.C(n))}catch(t){throw this.Y(t)}}async delete(n,t){try{const s=this.C(n);t.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(n,t,s){const r=this.C(n),a=this.C(t);if(r!==a)try{await this.S(n,t,"move",s.overwrite),await p.Promises.move(r,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(2,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.Y(h)}}async copy(n,t,s){const r=this.C(n),a=this.C(t);if(r!==a)try{await this.S(n,t,"copy",s.overwrite),await p.Promises.copy(r,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(3,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.Y(h)}}async S(n,t,s,r){const a=this.C(n),h=this.C(t);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(a,h,!0)),w&&s==="copy")throw(0,l.createFileSystemProviderError)((0,E.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!w&&await p.Promises.exists(h)){if(!r)throw(0,l.createFileSystemProviderError)((0,E.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(n,t){return this.U(n,t,!1)}async U(n,t,s){const r=this.C(n),a=this.C(t),h=!!(this.capabilities&1024);if((0,I.isEqual)(r,a,!h))return;const w=new S.DisposableStore;try{const[v,R]=await Promise.all([this.I(n),this.I(t)]);w.add(v),w.add(R),s&&await p.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await p.Promises.copyFile(r,a)}catch(v){if(v.code==="ENOENT"&&!s)return this.U(n,t,!0);throw this.Y(v)}finally{w.dispose()}}p(n,t,s){return new y.UniversalWatcherClient(r=>n(r),r=>t(r),s)}y(n,t,s){return new k.NodeJSWatcherClient(r=>n(r),r=>t(r),s)}Y(n){if(n instanceof l.FileSystemProviderError)return n;let t;switch(n.code){case"ENOENT":t=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=l.FileSystemProviderErrorCode.NoPermissions;break;default:t=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(n,t)}async Z(n,t){let s=this.Y(t);if(n&&s.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await p.SymlinkSupport.stat(this.C(n));r.mode&128||(s=(0,l.createFileSystemProviderError)(t,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}i.D=!1,i.O=!0,e.DiskFileSystemProvider=i}),define(oe[105],ae([0,1,3,2,5,9]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,c.createDecorator)("sharedProcessLifecycleService");let T=class extends N.Disposable{constructor(I){super(),this.b=I,this.a=this.B(new L.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};T=ye([J(0,O.ILogService)],T),e.SharedProcessLifecycleService=T}),define(oe[106],ae([0,1,12,3,9,2]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends c.AbstractLoggerService{constructor(b,m,d,p,E){super(m,d,p),this.n=b,this.p=E,this.B(E.listen("onDidChangeLogLevel",b)(l=>{(0,c.isLogLevel)(l)?super.setLogLevel(l):super.setLogLevel(L.URI.revive(l[0]),l[1])})),this.B(E.listen("onDidChangeVisibility",b)(([l,f])=>super.setVisibility(L.URI.revive(l),f))),this.B(E.listen("onDidChangeLoggers",b)(({added:l,removed:f})=>{for(const u of l)super.registerLogger({...u,resource:L.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new c.AdapterLogger({log:(b,m)=>{this.p.call("consoleLog",[b,m])}})}registerLogger(b){super.registerLogger(b),this.p.call("registerLogger",[b,this.n])}deregisterLogger(b){super.deregisterLogger(b),this.p.call("deregisterLogger",[b,this.n])}setLogLevel(b,m){super.setLogLevel(b,m),this.p.call("setLogLevel",[b,m])}setVisibility(b,m){super.setVisibility(b,m),this.p.call("setVisibility",[this.l(b),m])}m(b,m,d){return new D(this.p,b,m,d,this.n)}static setLogLevel(b,m,d){return b.call("setLogLevel",[m,d])}}e.LoggerChannelClient=T;class D extends c.AbstractMessageLogger{constructor(b,m,d,p,E){super(p?.logLevel==="always"),this.m=b,this.n=m,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[m,p,E]).then(()=>{this.r(this.l),this.k=!0})}g(b,m){const d=[[b,m]];this.k?this.r(d):this.l.push(...d)}r(b){this.m.call("log",[this.n,b])}}class I{constructor(b,m){this.a=b,this.b=m}listen(b,m){const d=this.b(b);switch(m){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(E=>this.c(E,d)),removed:[...p.removed].map(E=>this.c(E,d))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,p=>[d.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,p=>(0,c.isLogLevel)(p)?p:[d.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${m}`)}async call(b,m,d){const p=this.b(b);switch(m){case"setLogLevel":return(0,c.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(L.URI.revive(p.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(E=>this.c(E,p)))}throw new Error(`Call not found: ${m}`)}c(b,m){return{...b,resource:m.transformOutgoingURI(b.resource)}}}e.LoggerChannel=I;class S extends O.Disposable{constructor(b,m){super(),m.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(d=>m.call("setLogLevel",[d]))),m.call("getRegisteredLoggers").then(d=>{for(const p of d)b.registerLogger({...p,resource:L.URI.revive(p.resource)})}),this.B(m.listen("onDidChangeVisibility")(([d,p])=>b.setVisibility(L.URI.revive(d),p))),this.B(m.listen("onDidChangeLoggers")(({added:d,removed:p})=>{for(const E of d)b.registerLogger({...E,resource:L.URI.revive(E.resource)});for(const E of p)b.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=S}),define(oe[215],ae([0,1,2,9]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class c extends L.Disposable{constructor(T,D=[]){super(),this.a=new N.MultiplexLogger([T,...D]),this.B(T.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...D){this.a.trace(T,...D)}debug(T,...D){this.a.debug(T,...D)}info(T,...D){this.a.info(T,...D)}warn(T,...D){this.a.warn(T,...D)}error(T,...D){this.a.error(T,...D)}flush(){this.a.flush()}}e.LogService=c}),define(oe[57],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(oe[58],ae([0,1,3,63,2,5]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class T extends c.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const P=Object.keys(this.f).length;return this.f={...S,...this.f},P!==Object.keys(this.f).length&&await this.i(S),N.Iterable.reduce(this.g.entries(),(b,[m,d])=>({...b,[m]:d}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(S,[P,b])=>({...S,[P]:{definition:b,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=T;class D{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=D}),define(oe[216],ae([0,1,3,2,58]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(I){this.b=I,this.a=new N.DisposableStore}listen(I,S){switch(S){case"onDidChange":return L.Event.map(this.b.onDidChange,P=>P.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,P){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=O;class T extends c.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const P in I){const{definition:b,value:m}=I[P];this.f[P]=b,m!==void 0&&this.g.set(P,m)}this.a.listen("onDidChange")(P=>{for(const b in P){const m=P[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(P))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const P in S)this.g.set(P,S[P])}}e.PolicyChannelClient=T}),define(oe[107],ae([0,1,4,36]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const O=L.globals.vscode.context.configuration();if(O)c=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:O.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(oe[26],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[217],ae([0,1,6,10,2,14,28,9,26]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends c.Disposable{constructor(b,m,d){super(),this.b=m,this.c=d,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new L.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),d=(0,O.dirname)(b),p=(0,O.basename)(b),E=await T.Promises.readdir(d);await Promise.all(E.map(async l=>{if(l===p)return;const f=(0,O.join)(d,l),u=await T.Promises.stat(f);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${l}.`),T.Promises.rm(f)}))}catch(m){(0,N.onUnexpectedError)(m)}}};S=ye([J(1,I.IProductService),J(2,D.ILogService)],S),e.CodeCacheCleaner=S}),define(oe[218],ae([0,1,6,10,2,14,28,15,9,26]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends c.Disposable{constructor(m,d,p){super(),this.b=m,this.c=d,this.f=p,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),d=JSON.parse(await T.Promises.readFile((0,O.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(d)){const g=d[u];m[`${g.hash}.${u}`]=!0}const p=(0,O.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(p))return;const l=await T.Promises.readdir(p);for(const u of l){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await T.Promises.rm((0,O.join)(p,u))}const f=Date.now();for(const u of Object.keys(m)){const g=(0,O.join)(p,u),y=await T.Promises.readdir(g);for(const k of y){if(k==="tcf.json")continue;const i=(0,O.join)(g,k),o=await T.Promises.stat(i);o.isDirectory()&&f-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.join)(u,k)}`),await T.Promises.rm(i))}}}catch(m){(0,N.onUnexpectedError)(m)}}};P=ye([J(0,D.INativeEnvironmentService),J(1,I.ILogService),J(2,S.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(oe[219],ae([0,1,14,5]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,N.createDecorator)("IV8InspectProfilingService");var c;(function(O){function T(I){return Boolean(I.samples&&I.timeDeltas)}O.isValidProfile=T;function D(I,S="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(S,(0,L.basename)(P.callFrame.url)));return I}O.rewriteAbsolutePaths=D})(c=e.Utils||(e.Utils={}))}),define(oe[220],ae([0,1,31]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class N{constructor(){this.a=new Map}async startProfiling(O){const D=await(await new Promise((S,P)=>{ie(["v8-inspect-profiler"],S,P)})).startProfiling({port:O.port,checkForPaused:!0}),I=(0,L.generateUuid)();return this.a.set(I,D),I}async stopProfiling(O){const T=this.a.get(O);if(!T)throw new Error(`UNKNOWN session '${O}'`);const D=await T.stop();return this.a.delete(O),D.profile}}e.InspectProfilingService=N}),define(oe[40],ae([0,1,129,11]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class c{constructor(){this.a=new Map}add(T,D){L.ok(N.isString(T)),L.ok(N.isObject(D)),L.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,D)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new c}),define(oe[108],ae([0,1,3,40]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function c(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class O{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[c(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;N.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[45],ae([0,1,21,3,11,155,17,108,40]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(D.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.Emitter,this.onDidSchemaChange=this.i.event,this.j=new N.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:t,source:s}of i)for(const r in t)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.a.get(r),h=a?.valuesSources??new Map;if(s)for(const A of Object.keys(t[r]))h.set(A,s);const w={...a?.value||{},...t[r]};this.a.set(r,{source:s,value:w,valuesSources:h});const v=(0,T.getLanguageTagSettingPlainKey)(r),R={type:"object",default:w,description:O.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:c.isString(s)?void 0:s,defaultValueSource:s};n.push(...E(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:t[r],source:s});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:t}of i)for(const s in n){const r=this.a.get(s),a=c.isString(t)?t:t?.id,h=c.isString(r?.source)?r?.source:r?.source?.id;if(a===h)if(o.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const w=this.d[s];w&&(this.w(s,w),this.r(s,w))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,n),this.c.push(t),this.q(t)})}o(i,o){const n=t=>{if(t.properties)for(const s in t.properties){o.add(s);const r=this.d[s];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[s],this.s(s,t.properties[s])}t.allOf?.forEach(s=>n(s))};for(const t of i){n(t);const s=this.c.indexOf(t);s!==-1&&this.c.splice(s,1)}}p(i,o=!0,n,t,s=3,r){s=c.isUndefinedOrNull(i.scope)?s:i.scope;const a=i.properties;if(a)for(const w in a){const v=a[w];if(o&&g(w,v)){delete a[w];continue}if(v.source=n,v.defaultDefaultValue=a[w].default,this.w(w,v),e.OVERRIDE_PROPERTY_REGEX.test(w)?v.scope=void 0:(v.scope=c.isUndefinedOrNull(v.scope)?s:v.scope,v.restricted=c.isUndefinedOrNull(v.restricted)?!!t?.includes(w):v.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const h=i.allOf;if(h)for(const w of h)this.p(w,o,n,t,s,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const t=n.properties;if(t)for(const r in t)this.r(r,t[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let t=n?.value,s=n?.source;c.isUndefined(t)&&(t=o.defaultDefaultValue,s=void 0),c.isUndefined(t)&&(t=f(o.type)),o.default=t,o.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(k){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(k)){let o=p.exec(k);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=p.exec(k)}}return(0,L.distinct)(i)}e.overrideIdentifiersFromKey=E;function l(k){return k.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=l;function f(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const u=new m;I.Registry.add(e.Extensions.Configuration,u);function g(k,i){return k.trim()?e.OVERRIDE_PROPERTY_REGEX.test(k)?O.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?O.localize(8,null,k):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,k,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}e.validateProperty=g;function y(){const k=[],i=u.getConfigurationProperties();for(const o of Object.keys(i))k.push([o,i[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=y}),define(oe[73],ae([0,1,21,3,35,2,37,32,11,12,17,45,40]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(o){return Object.isFrozen(o)?o:D.deepFreeze(o)}class p{constructor(n={},t=[],s=[],r){this.b=n,this.c=t,this.d=s,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof p)return t;const s=new E("");return s.parseRaw(t),s.configurationModel});this.f=n.reduce((t,s)=>s===t?s:t.merge(s),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const s=this.rawConfiguration.getValue(n),r=t?this.rawConfiguration.getOverrideValue(n,t):void 0,a=t?this.rawConfiguration.override(t).getValue(n):s;return{value:s,override:r,merged:a}}getOverrideValue(n,t){const s=this.i(t);return s?n?(0,P.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return L.distinct(n)}override(n){let t=this.a.get(n);return t||(t=this.g(n),this.a.set(n,t)),t}merge(...n){const t=D.deepClone(this.contents),s=D.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const h of n)if(a.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(t,h.contents);for(const w of h.overrides){const[v]=s.filter(R=>L.equals(R.identifiers,w.identifiers));v?(this.h(v.contents,w.contents),v.keys.push(...w.keys),v.keys=L.distinct(v.keys)):s.push(D.deepClone(w))}for(const w of h.keys)r.indexOf(w)===-1&&r.push(w)}return new p(t,r,s,a.every(h=>h instanceof p)?void 0:a)}g(n){const t=this.i(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const r of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[r];const h=t[r];h&&(typeof a=="object"&&typeof h=="object"?(a=D.deepClone(a),this.h(a,h)):a=h),s[r]=a}return new p(s,this.keys,this.overrides)}h(n,t){for(const s of Object.keys(t)){if(s in n&&I.isObject(n[s])&&I.isObject(t[s])){this.h(n[s],t[s]);continue}n[s]=D.deepClone(t[s])}}i(n){let t=null,s=null;const r=a=>{a&&(s?this.h(s,a):s=D.deepClone(a))};for(const a of this.overrides)L.equals(a.identifiers,[n])?t=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,t){this.j(n,t,!0)}setValue(n,t){this.j(n,t,!1)}removeValue(n){const t=this.keys.indexOf(n);t!==-1&&(this.keys.splice(t,1),(0,P.removeFromValueTree)(this.contents,n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,b.overrideIdentifiersFromKey)(n))),1))}j(n,t,s){(0,P.addToValueTree)(this.contents,n,t,r=>console.error(r)),s=s||this.keys.indexOf(n)===-1,s&&this.keys.push(n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=p;class E{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!I.isUndefinedOrNull(n)){const s=this.g(n);this.parseRaw(s,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:s,keys:r,overrides:a,restricted:h,hasExcludedProperties:w}=this.h(n,t);this.b=new p(s,r,a,w?[n]:void 0),this.c=h||[]}g(n){let t={},s=null,r=[];const a=[],h=[];function w(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}const v={onObjectBegin:()=>{const R={};w(R),a.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const R=[];w(R),a.push(r),r=R,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(R,A,M)=>{h.push({error:R,offset:A,length:M})}};if(n)try{c.visit(n,v),t=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return t}h(n,t){const s=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.i(n,s,!0,t);n=r.raw;const a=(0,P.toValuesTree)(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),h=Object.keys(n),w=this.j(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:h,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,t,s,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:a};const h={},w=[];for(const v in n)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const R=this.i(n[v],t,!1,r);h[v]=R.raw,a=a||R.hasExcludedProperties,w.push(...R.restricted)}else{const R=t[v],A=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&w.push(v),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&!(r.skipRestricted&&R?.restricted)?h[v]=n[v]:a=!0}return{raw:h,restricted:w,hasExcludedProperties:a}}j(n,t){const s=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const h in n[r])a[h]=n[r][h];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,t)})}return s}}e.ConfigurationModelParser=E;class l extends O.Disposable{constructor(n,t,s,r){super(),this.f=n,this.g=t,this.h=r,this.c=this.B(new N.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(N.Event.any(N.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),N.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=l;class f{constructor(n,t,s,r,a,h,w,v,R,A,M,$,V){this.a=n,this.b=t,this.c=s,this.overrideIdentifiers=r,this.d=a,this.f=h,this.g=w,this.h=v,this.i=R,this.j=A,this.k=M,this.l=$,this.m=V}get value(){return d(this.c)}n(n,t,s){const r=n.inspect(t,s);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,t,s,r,a=new p,h=new p,w=new T.ResourceMap,v=new p,R=new T.ResourceMap){this.c=n,this.d=t,this.f=s,this.g=r,this.h=a,this.i=h,this.j=w,this.l=v,this.m=R,this.a=null,this.b=new T.ResourceMap,this.n=null}getValue(n,t,s){return this.q(n,t,s).getValue(n)}updateValue(n,t,s={}){let r;s.resource?(r=this.m.get(s.resource),r||(r=new p,this.m.set(s.resource,r))):r=this.l,t===void 0?r.removeValue(n):r.setValue(n,t),s.resource||(this.a=null)}inspect(n,t,s){const r=this.q(n,t,s),a=this.u(t.resource,s),h=t.resource?this.m.get(t.resource)||this.l:this.l,w=new Set;for(const v of r.overrides)for(const R of v.identifiers)r.getOverrideValue(n,R)!==void 0&&w.add(R);return new f(n,t,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,a||void 0,h)}keys(n){const t=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.j.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:r,updated:a,removed:h}=k(this.c,n);t=[...r,...a,...h]}for(const r of t)for(const a of(0,b.overrideIdentifiersFromKey)(r)){const h=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),v=[...w.filter(R=>h.indexOf(R)===-1),...h.filter(R=>w.indexOf(R)===-1),...h.filter(R=>!D.equals(this.c.override(a).getValue(R),n.override(a).getValue(R)))];s.push([a,v])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:s,removed:r}=k(this.d,n),a=[...t,...s,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:s,removed:r,overrides:a}=k(this.applicationConfiguration,n),h=[...t,...s,...r];return h.length&&this.updateApplicationConfiguration(n),{keys:h,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:r,overrides:a}=k(this.localUserConfiguration,n),h=[...t,...s,...r];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:r,overrides:a}=k(this.remoteUserConfiguration,n),h=[...t,...s,...r];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:r,overrides:a}=k(this.workspaceConfiguration,n),h=[...t,...s,...r];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(n,t){const s=this.p.get(n),{added:r,updated:a,removed:h,overrides:w}=k(s,t),v=[...r,...a,...h];return(v.length||!s)&&this.updateFolderConfiguration(n,t),{keys:v,overrides:w}}compareAndDeleteFolderConfiguration(n){const t=this.p.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:a,overrides:h}=k(t,void 0);return{keys:[...s,...r,...a],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,t,s){let r=this.r(t,s);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},t){let s=this.s();if(t&&n){const r=t.getFolder(n);r&&(s=this.t(r.uri)||s);const a=this.m.get(n);a&&(s=s.merge(a))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let t=this.b.get(n);if(!t){const s=this.s(),r=this.j.get(n);r?(t=s.merge(r),this.b.set(n,t)):t=s}return t}u(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,t)=>{const{contents:s,overrides:r,keys:a}=this.j.get(t);return n.push([t,{contents:s,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(t=>n.add(t)),this.userConfiguration.keys.forEach(t=>n.add(t)),this.i.keys.forEach(t=>n.add(t)),this.j.forEach(t=>t.keys.forEach(s=>n.add(s))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}w(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.i.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r))),[...t.values()]}static parse(n){const t=this.x(n.defaults),s=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),h=this.x(n.workspace),w=n.folders.reduce((v,R)=>(v.set(S.URI.revive(R[0]),this.x(R[1])),v),new T.ResourceMap);return new u(t,s,r,a,new p,h,w,new p,new T.ResourceMap)}static x(n){return new p(n.contents,n.keys,n.overrides)}}e.Configuration=u;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,h])=>{const w=(0,T.getOrSet)(t,a,new Set);h.forEach(v=>w.add(v))});const s=[];return t.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=g;class y{constructor(n,t,s,r){this.change=n,this.f=t,this.g=s,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const h of a)this.affectedKeys.add(h);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,t){const s=this.a+n,r=this.d.indexOf(s);if(r<0)return!1;const a=r+s.length;if(a>=this.d.length)return!1;const h=this.d.charCodeAt(a);if(h!==this.b&&h!==this.c)return!1;if(t){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.f?.workspace):void 0,v=this.g.getValue(n,t,this.h);return!D.equals(w,v)}return!0}}e.ConfigurationChangeEvent=y;function k(o,n){const{added:t,removed:s,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],h=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const v=w.filter(R=>!h.includes(R));for(const R of v)a.push([R,n.getKeysForOverrideIdentifier(R)])}if(o){const v=h.filter(R=>!w.includes(R));for(const R of v)a.push([R,o.getKeysForOverrideIdentifier(R)])}if(n&&o){for(const v of h)if(w.includes(v)){const R=i({contents:o.getOverrideValue(void 0,v)||{},keys:o.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:s,updated:r,overrides:a}}function i(o,n){const t=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],s=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const h=(0,P.getConfigurationValue)(n.contents,a),w=(0,P.getConfigurationValue)(o.contents,a);D.equals(h,w)||r.push(a)}}return{added:t,removed:s,updated:r}}}),define(oe[221],ae([0,1,21,3,2,32,11,73,45,9,58,40]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends c.Disposable{constructor(){super(...arguments),this.a=this.B(new N.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:l,defaultsOverrides:f})=>this.c(Array.from(l),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(l,f){this.h(l,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:l})}f(){return{}}g(){this.b=new D.ConfigurationModel;const l=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(l),l)}h(l,f){const u=this.f();for(const g of l){const y=u[g],k=f[g];y!==void 0?this.b.addValue(g,y):k?this.b.addValue(g,k.default):this.b.removeValue(g)}}}e.DefaultConfiguration=m;class d{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new D.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let p=class extends c.Disposable{get configurationModel(){return this.b}constructor(l,f,u){super(),this.c=l,this.f=f,this.g=u,this.a=this.B(new N.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new D.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(l=>this.i(l))),this.B(this.c.onDidChangeConfiguration(async({properties:l})=>this.j(await this.h(l),!0))),this.b}async h(l){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",l);const f={},u=[],g=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const y of l){const k=g[y];if(!k){u.push(y);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(y),f[k.policy.name]={type:k.type}}}return(0,T.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),u}i(l){this.g.trace("PolicyConfiguration#onDidChangePolicies",l);const f=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),u=(0,L.coalesce)(l.map(g=>f.get(g)));this.j(u,!0)}j(l,f){this.g.trace("PolicyConfiguration#update",l);const u=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),g=[],y=this.b.isEmpty();for(const k of l){const i=u[k]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(y?o!==void 0:!(0,O.equals)(this.b.getValue(k),o))&&g.push([k,o])}else this.b.getValue(k)!==void 0&&g.push([k,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const k=this.b;this.b=new D.ConfigurationModel;for(const i of k.keys)this.b.setValue(i,k.getValue(i));for(const[i,o]of g)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);f&&this.a.fire(this.b)}}};p=ye([J(1,P.IPolicyService),J(2,S.ILogService)],p),e.PolicyConfiguration=p}),define(oe[222],ae([0,1,6,3,2,23,17,73,221,58]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends c.Disposable{constructor(m,d,p,E){super(),this.i=m,this.h=this.B(new N.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=p instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,p,E)),this.f=this.B(new D.UserSettings(this.i,void 0,O.extUriBiasedIgnorePathCase,d)),this.a=new D.Configuration(this.b.configurationModel,this.c.configurationModel,new D.ConfigurationModel,new D.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:f})=>this.k(l,f))),this.B(this.c.onDidChangeConfiguration(l=>this.l(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,d,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new D.Configuration(m,d,new D.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(m,d){const p=typeof m=="string"?m:void 0,E=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(d)?d:{};return this.a.getValue(p,E,void 0)}updateValue(m,d,p,E){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const d=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(p,d,2)}k(m,d){const p=this.a.toData(),E=this.a.compareAndUpdateDefaultConfiguration(m,d);this.m(E,p,7)}l(m){const d=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(m);this.m(p,d,7)}m(m,d,p){const E=new D.ConfigurationChangeEvent(m,{data:d},this.a);E.source=p,E.sourceConfig=this.n(p),this.h.fire(E)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(oe[223],ae([0,1,10,5]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,N.createDecorator)("remoteAuthorityResolverService");var c;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(c=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class O extends L.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof O&&I._code===c.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof O&&I._code===c.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof O&&I._code===c.NoResolverFound}static isHandled(I){return I instanceof O&&I.isHandled}constructor(I,S=c.Unknown,P){super(I),this._message=I,this._code=S,this._detail=P,this.isHandled=S===c.NotAvailable&&P===!0,Object.setPrototypeOf(this,O.prototype)}}e.RemoteAuthorityResolverError=O;function T(D){const I=D.indexOf("+");return I===-1?D:D.substring(0,I)}e.getRemoteAuthorityPrefix=T}),define(oe[74],ae([0,1,22]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function N(S){return S.scheme===L.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=N;function c(S){if(!S)return;const P=S.indexOf("+");return P<0?S:S.substr(0,P)}e.getRemoteName=c;function O(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=O;function T(S){const{host:P,port:b}=I(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:b}}e.parseAuthorityWithPort=T;function D(S,P){let{host:b,port:m}=I(S);return typeof m>"u"&&(m=P),{host:b,port:m}}e.parseAuthorityWithOptionalPort=D;function I(S){const P=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=S.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:S,port:void 0}}}),define(oe[50],ae([0,1,27,5,74]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var D;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(l){this.value=l,this.c=l.toLowerCase()}static equals(l,f){if(typeof l>"u"||l===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof l=="string"||typeof f=="string"){const u=typeof l=="string"?l:l.value,g=typeof f=="string"?f:f.value;return L.equalsIgnoreCase(u,g)}return l.c===f.c}static toKey(l){return typeof l=="string"?l.toLowerCase():l.c}}e.ExtensionIdentifier=I;class S{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const f of l)this.add(f)}add(l){this.c.add(I.toKey(l))}delete(l){return this.c.delete(I.toKey(l))}has(l){return this.c.has(I.toKey(l))}}e.ExtensionIdentifierSet=S;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(I.toKey(l))}get(l){return this.c.get(I.toKey(l))}has(l){return this.c.has(I.toKey(l))}set(l,f){this.c.set(I.toKey(l),f)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function b(E){return m(E)}e.isApplicationScopedExtension=b;function m(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function d(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function p(E,l){if(l){const f=`onResolveRemoteAuthority:${(0,c.getRemoteName)(l)}`;return!!E.activationEvents?.includes(f)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,N.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[224],ae([0,1,2,50,13]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends L.Disposable{constructor(D,I,S,P,b){super(),this.a=D,this.b=I,this.c=S,this.f=b,this.B(P.onDidInstallExtensions(m=>this.g(m))),this.B(P.onDidUninstallExtension(m=>this.h(m)))}g(D){for(const I of D)I.local&&this.invalidate(I.profileLocation)}h(D){D.error||this.invalidate(D.profileLocation)}async invalidate(D){if(D)for(const I of this.a.profiles)this.c.extUri.isEqual(I.extensionsResource,D)&&await this.i(I);else await this.i(this.a.defaultProfile)}async i(D){try{await this.b.del(this.c.extUri.joinPath(D.cacheHome,N.USER_MANIFEST_CACHE_FILE))}catch(I){(0,c.toFileOperationResult)(I)!==1&&this.f.error(I)}}}e.ExtensionsManifestCache=O}),define(oe[225],ae([0,1,6,16,25,10,3,2,104,89,31,96,223,74]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var E;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function l(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(C){const U=new c.CancellationTokenSource;return setTimeout(()=>U.cancel(),C),U.token}function u(C,U){if(C.isCancellationRequested||U.isCancellationRequested)return c.CancellationToken.Cancelled;const z=new c.CancellationTokenSource;return C.onCancellationRequested(()=>z.cancel()),U.onCancellationRequested(()=>z.cancel()),z.token}class g{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new D.DisposableStore,this.promise=new Promise((z,K)=>{this.f=z,this.g=K}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function y(C,U){const z=new g(U);return z.registerDisposable(C.onControlMessage(K=>{const B=JSON.parse(K.toString()),_=ee(B);_?z.reject(_):z.resolve(B)})),z.promise}function k(C,U,z,K,B,_,te,ce,he){const pe=new g(he),de=S.StopWatch.create(!1);return C.info(`Creating a socket (${ce})...`),I.mark(`code/willCreateSocket/${te}`),U.connect(z,K,B,_,ce,(Se,Ce)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${te}`),C.info(`Creating a socket (${ce}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),Se&&C.error(Se),Ce?.dispose()):Se||!Ce?(I.mark(`code/didCreateSocketError/${te}`),C.info(`Creating a socket (${ce}) returned an error after ${de.elapsed()} ms.`),pe.reject(Se)):(I.mark(`code/didCreateSocketOK/${te}`),C.info(`Creating a socket (${ce}) was successful after ${de.elapsed()} ms.`),pe.resolve(Ce))}),pe.promise}function i(C,U){const z=new g(U);return C.then(K=>{z.didTimeout||z.resolve(K)},K=>{z.didTimeout||z.reject(K)}),z.promise}async function o(C,U,z,K){const B=H(C,U);C.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let _;try{_=await k(C.logService,C.socketFactory,C.host,C.port,(0,d.getRemoteServerRootPath)(C),`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,l(U),`renderer-${l(U)}-${C.reconnectionToken}`,K)}catch(de){throw C.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),C.logService.error(de),de}C.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let te,ce;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection(_,null),te=C.reconnectionProtocol,ce=!1):(te=new b.PersistentProtocol({socket:_,measureRoundTripTime:!0}),ce=!0),C.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const he=await i(C.signService.createNewMessage((0,P.generateUuid)()),K),pe={type:"auth",auth:C.connectionToken||"00000000000000000000",data:he.data};te.sendControl(N.VSBuffer.fromString(JSON.stringify(pe)));try{const de=await y(te,u(K,f(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(C.logService.trace(`${B} 4/6. received SignRequest control message.`),!await i(C.signService.validate(he,de.signedData),K)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await i(C.signService.sign(de.data),K),De={type:"connectionType",commit:C.commit,signedData:Ce,desiredConnectionType:U};return z&&(De.args=z),C.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(N.VSBuffer.fromString(JSON.stringify(De))),{protocol:te,ownsProtocol:ce}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(C.logService.error(`${B} the handshake timed out. Error:`),C.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${B} received error control message when negotiating connection. Error:`),C.logService.error(de)),ce&&j(te),de}}async function n(C,U,z,K){const B=Date.now(),_=H(C,U),{protocol:te,ownsProtocol:ce}=await o(C,U,z,K),he=new g(K);return he.registerDisposable(te.onControlMessage(pe=>{const de=JSON.parse(pe.toString()),Se=ee(de);Se?(C.logService.error(`${_} received error control message when negotiating connection. Error:`),C.logService.error(Se),ce&&j(te),he.reject(Se)):(C.reconnectionProtocol?.endAcceptReconnection(),C.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${F(B)}!`),he.resolve({protocol:te,firstMessage:de}))})),he.promise}async function t(C,U){const{protocol:z}=await n(C,1,void 0,U);return{protocol:z}}async function s(C,U,z){const{protocol:K,firstMessage:B}=await n(C,2,U,z),_=B&&B.debugPort;return{protocol:K,debugPort:_}}async function r(C,U,z){const K=Date.now(),B=H(C,3),{protocol:_}=await o(C,3,U,z);return C.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${F(K)}!`),_}async function a(C,U,z){const{host:K,port:B,connectionToken:_}=await C.addressProvider.getAddress();return{commit:C.commit,quality:C.quality,host:K,port:B,connectionToken:_,reconnectionToken:U,reconnectionProtocol:z,socketFactory:C.socketFactory,signService:C.signService,logService:C.logService}}async function h(C,U,z){return v(C,async K=>{const{protocol:B}=await t(K,c.CancellationToken.None);return new Z(C,U,z,K.reconnectionToken,B)})}e.connectRemoteAgentManagement=h;async function w(C,U){return v(C,async z=>{const{protocol:K,debugPort:B}=await s(z,U,c.CancellationToken.None);return new x(C,U,z.reconnectionToken,K,B)})}e.connectRemoteAgentExtensionHost=w;async function v(C,U){for(let K=1;;K++)try{const B=(0,P.generateUuid)(),_=await a(C,B,null);return await U(_)}catch(B){if(K<5)C.logService.error(`[remote-connection][attempt ${K}] An error occurred in initial connection! Will retry... Error:`),C.logService.error(B);else throw C.logService.error(`[remote-connection][attempt ${K}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),C.logService.error(B),Y.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(B)),B}}async function R(C,U,z){const K=await a(C,(0,P.generateUuid)(),null);return await r(K,{host:U,port:z},c.CancellationToken.None)}e.connectRemoteAgentTunnel=R;function A(C){return(0,L.createCancelablePromise)(U=>new Promise((z,K)=>{const B=setTimeout(z,C*1e3);U.onCancellationRequested(()=>{clearTimeout(B),z()})}))}var M;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain",C[C.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class ${constructor(U,z){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=$;class V{constructor(U,z,K,B){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.durationSeconds=K,this.c=B,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=V;class q{constructor(U,z,K){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=q;class W{constructor(U,z,K){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=4}}e.ConnectionGainEvent=W;class X{constructor(U,z){this.reconnectionToken=U,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=X;class Q{constructor(U,z,K,B){this.reconnectionToken=U,this.millisSinceLastIncomingData=z,this.attempt=K,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class Y extends D.Disposable{static triggerPermanentFailure(U,z,K){this._permanentFailure=!0,this.f=U,this.g=z,this.h=K,this.i.forEach(B=>B.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.s())}static debugPauseSocketWriting(){this.i.forEach(U=>U.w())}get k(){return this.c||Y._permanentFailure}constructor(U,z,K,B,_){super(),this.n=U,this.p=z,this.reconnectionToken=K,this.protocol=B,this.r=_,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.B(B.onSocketClose(te=>{const ce=G(this.n,this.reconnectionToken,!0);te?te.type===0?(this.p.logService.info(`${ce} received socket close event (hadError: ${te.hadError}).`),te.error&&this.p.logService.error(te.error)):(this.p.logService.info(`${ce} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.p.logService.error(te.event)):this.p.logService.info(`${ce} received socket close event.`),this.s()})),this.B(B.onSocketTimeout(te=>{const ce=G(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(B.onHighRoundTripTime(te=>{const ce=re(this.n,this.reconnectionToken);this.p.logService.info(`${ce} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(B.onDidChangeConnectionHealth(te=>{this.j.fire(new X(this.reconnectionToken,te))})),Y.i.push(this),this.B((0,D.toDisposable)(()=>{const te=Y.i.indexOf(this);te>=0&&Y.i.splice(te,1)})),this.k&&this.v(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const U=G(this.n,this.reconnectionToken,!0);this.p.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let K=-1;do{K++;const B=K<z.length?z[K]:z[z.length-1];try{if(B>0){const te=A(B);this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,te)),this.p.logService.info(`${U} waiting for ${B} seconds before reconnecting...`);try{await te}catch{}}if(this.k){this.p.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1)),this.p.logService.info(`${U} resolving connection...`);const _=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${U} connecting to ${_.host}:${_.port}...`),await this.y(_,f(p)),this.p.logService.info(`${U} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(K>360){this.p.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(_)){this.p.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.p.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if((0,O.isCancellationError)(_)){this.p.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(_);continue}if(_ instanceof m.RemoteAuthorityResolverError){this.p.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),K+1,m.RemoteAuthorityResolverError.isHandled(_));break}this.p.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(_),this.u(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}}while(!this.k&&!this.m)}u(U,z,K){this.r?Y.triggerPermanentFailure(U,z,K):this.v(U,z,K)}v(U,z,K){this.j.fire(new Q(this.reconnectionToken,U,z,K)),j(this.protocol)}w(){this.protocol.pauseSocketWriting()}}Y._permanentFailure=!1,Y.f=0,Y.g=0,Y.h=!1,Y.i=[],e.PersistentConnection=Y;class Z extends Y{constructor(U,z,K,B,_){super(1,U,B,_,!0),this.client=this.B(new b.Client(_,{remoteAuthority:z,clientId:K},U.ipcLogger))}async y(U,z){await t(U,z)}}e.ManagementPersistentConnection=Z;class x extends Y{constructor(U,z,K,B,_){super(2,U,K,B,!1),this.z=z,this.debugPort=_}async y(U,z){await s(U,this.z,z)}}e.ExtensionHostPersistentConnection=x;function j(C){try{C.acceptDisconnect();const U=C.getSocket();C.dispose(),U.dispose()}catch(U){(0,O.onUnexpectedError)(U)}}function ee(C){if(C&&C.type==="error"){const U=new Error(`Connection error: ${C.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function ne(C,U){for(;C.length<U;)C+=" ";return C}function re(C,U){return`[remote-connection][${ne(l(C),13)}][${U.substr(0,5)}\u2026]`}function G(C,U,z){return`${re(C,U)}[${z?"reconnect":"initial"}]`}function H(C,U){return`${G(U,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.host}:${C.port}]`}function F(C){return`${Date.now()-C} ms`}}),define(oe[226],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[227],ae([0,1,86,153]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(c,O,T,D,I,S){const P=m=>S(m,void 0),b=L.createConnection({host:c,port:O},()=>{b.removeListener("error",P);const m=Buffer.alloc(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const d=m.toString("base64"),p=[`GET ws://${/:/.test(c)?`[${c}]`:c}:${O}${T}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];b.write(p.join(`\r
`)+`\r
\r
`);const E=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),S(void 0,new N.NodeSocket(b,I)))};b.on("data",E)});b.setNoDelay(!0),b.once("error",P)}}}),define(oe[109],ae([0,1,5,173]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var c;(function(O){O.disconnected={type:"disconnected"},O.uninitialized={type:"uninitialized"},O.connected=T=>({type:"connected",info:T}),O.connecting=T=>({type:"connecting",progress:T})})(c=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,N.localize)(0,null)}),define(oe[59],ae([0,1,16,10,2,175,45,5,9,40]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");class P{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?k[i]="*****":k[i]=this.b[i];this.a=k}return this.a}}class b extends c.Disposable{constructor(k,i){super(),this.b=0,this.a=i.createLogger(k?"remotenetwork":"network",{name:k?(0,O.localize)(0,null):(0,O.localize)(1,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async c(k,i,o){const n=`${k} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new P(i.headers??{}));try{const t=await o();return this.a.trace(`${n} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,i.type,(0,N.getErrorMessage)(t)),t}}}e.AbstractRequestService=b;function m(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=m;function d(y){return y.res.statusCode===204}async function p(y){return d(y)?null:(await(0,L.streamToBuffer)(y.stream)).toString()}e.asText=p;async function E(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);return p(y)}e.asTextOrError=E;async function l(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const i=(await(0,L.streamToBuffer)(y.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=l;function f(y){g(y)}e.updateProxyConfigurationsScope=f;let u;function g(y){const k=S.Registry.as(T.Extensions.Configuration),i=u;u={id:"http",order:15,title:(0,O.localize)(2,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:i?[i]:[]})}g(1)}),define(oe[228],ae([0,1,25,22,13,59]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,P=L.CancellationToken.None){if(I.scheme===N.Schemas.file||I.scheme===N.Schemas.vscodeRemote){await this.b.copy(I,S);return}const b={type:"GET",url:I.toString(!0)},m=await this.a.request(b,P);if(m.res.statusCode===200)await this.b.writeFile(S,m.stream);else{const d=await(0,O.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};T=ye([J(0,O.IRequestService),J(1,c.IFileService)],T),e.DownloadService=T}),define(oe[229],ae([0,1,16,25]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class c{constructor(D){this.a=D}listen(D,I){throw new Error("Invalid listen")}call(D,I,S,P=N.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],P).then(async({res:b,stream:m})=>{const d=await(0,L.streamToBuffer)(m);return[{statusCode:b.statusCode,headers:b.headers},d]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=c;class O{constructor(D){this.a=D}async request(D,I){const[S,P]=await this.a.call("request",[D],I);return{res:S,stream:(0,L.bufferToStream)(P)}}async resolveProxy(D){return this.a.call("resolveProxy",[D])}}e.RequestChannelClient=O}),define(oe[110],ae([0,1,53,5]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function c(O){return(0,L.hash)({moduleId:O.process.moduleId,windowId:O.reply.windowId})}e.hash=c,e.ISharedProcessWorkerService=(0,N.createDecorator)("sharedProcessWorkerService")}),define(oe[230],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(N){N.Spawn="vscode:shared-process->shared-process-worker=spawn",N.Terminate="vscode:shared-process->shared-process-worker=terminate",N.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",N.Ready="vscode:shared-process-worker->shared-process=ready",N.Ack="vscode:shared-process-worker->shared-process=ack",N.Trace="vscode:shared-process-worker->shared-process=trace",N.Info="vscode:shared-process-worker->shared-process=info",N.Warn="vscode:shared-process-worker->shared-process=warn",N.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[231],ae([0,1,151,6,25,3,2,22,31,9,110,230]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(E){this.d=E,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(E){const l=`window: ${E.reply.windowId}, moduleId: ${E.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${l})`);const f=(0,P.hash)(E);this.b.has(f)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${l})`),this.f(E));const u=new c.CancellationTokenSource;let g,y,k;this.b.set(f,t=>{u.dispose(!0),g?.terminate(E,c.CancellationToken.None),y?.close(),k?.close(),this.b.delete(f);const s=this.c.get(f);s&&(this.c.delete(f),s({reason:t}))}),g=await this.e(E);const i=new Promise(t=>{this.c.set(f,t)});if(u.token.isCancellationRequested)return i;const{port1:o,port2:n}=new MessageChannel;return y=o,k=n,await g.spawn(E,k,u.token),u.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${l})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",E,[y])),i}e(E){let l=this.a.get(E.process.moduleId);if(!l){this.d.trace(`SharedProcess: creating new web worker (${E.process.moduleId})`);const f=new d(E.process.type,this.d);l=f.init(),f.onDidProcessSelfTerminate(({configuration:u,reason:g})=>{this.f(u,g)}),this.a.set(E.process.moduleId,l)}return l}async disposeWorker(E){return this.f(E)}f(E,l){const f=this.b.get((0,P.hash)(E));f&&(this.d.trace(`SharedProcess: disposeWorker (window: ${E.reply.windowId}, moduleId: ${E.process.moduleId})`),f(l))}};m=ye([J(0,S.ILogService)],m),e.SharedProcessWorkerService=m;class d extends T.Disposable{constructor(E,l){super(),this.f=E,this.g=l,this.a=this.B(new O.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const E=new N.DeferredPromise,l=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return l.onerror=f=>{this.g.error(`SharedProcess: worker error (${this.f})`,f.message)},l.onmessageerror=f=>{this.g.error(`SharedProcess: worker message error (${this.f})`,f)},l.onmessage=f=>{const{id:u,message:g,configuration:y,nonce:k}=f.data;switch(u){case b.SharedProcessWorkerMessages.Ready:E.complete(l);break;case b.SharedProcessWorkerMessages.Ack:if(k){const i=this.c.get(k);i&&(this.c.delete(k),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:y&&g&&this.a.fire({configuration:y,reason:JSON.parse(g)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,g);break;case b.SharedProcessWorkerMessages.Info:g&&this.g.info(g);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,g);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,g);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,f)}},l.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),E.p}async i(E,l,f){const u=await this.b;if(!l.isCancellationRequested)return new Promise(g=>{const y=(0,I.generateUuid)();this.c.set(y,g);const k={...E,nonce:y};f?u.postMessage(k,[f]):u.postMessage(k),l.onCancellationRequested(()=>{this.c.delete(y)&&g()})})}spawn(E,l,f){const u={id:b.SharedProcessWorkerMessages.Spawn,configuration:E,environment:{bootstrapPath:D.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(u,f,l)}terminate(E,l){const f={id:b.SharedProcessWorkerMessages.Terminate,configuration:E};return this.i(f,l)}}}),define(oe[232],ae([0,1,62,22,97]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class O extends c.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}}ye([L.memoize],O.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=O}),define(oe[233],ae([0,1,49,14,176,25,38,10,4,31,148,194,6,131]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function E(f,u,g,y){return g["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(y)&&!g["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(k,i)=>{const o=new O.CancellationTokenSource;let n=1e4;const t=f.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(n=(0,d.clamp)(t,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),i(new Error((0,c.localize)(0,null)))},n);try{k(await l(u,o.token))}catch(r){!(0,D.isCancellationError)(r)&&!o.token.isCancellationRequested?i(new Error((0,c.localize)(1,null,(0,T.toErrorMessage)(r)))):k({})}finally{clearTimeout(s),o.dispose()}})),p)}e.getResolvedShellEnv=E;async function l(f,u){const g=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",g);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",y);const k=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(k+"({.*})"+k),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",o);const n=await(0,P.getSystemShell)(I.OS,o);return f.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(u.isCancellationRequested)return s(new D.CancellationError);const r=(0,N.basename)(n);let a,h;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(a=`& '${process.execPath}' ${w} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,r==="tcsh"||r==="csh"?h=["-ic"]:h=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const v=(0,L.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.onCancellationRequested(()=>(v.kill(),s(new D.CancellationError))),v.on("error",M=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),s(M)});const R=[];v.stdout.on("data",M=>R.push(M));const A=[];v.stderr.on("data",M=>A.push(M)),v.on("close",(M,$)=>{const V=Buffer.concat(R).toString("utf8");f.trace("getUnixShellEnvironment#raw",V);const q=Buffer.concat(A).toString("utf8");if(q.trim()&&f.trace("getUnixShellEnvironment#stderr",q),M||$)return s(new Error((0,c.localize)(2,null,M,$)));const W=i.exec(V),X=W?W[1]:"{}";try{const Q=JSON.parse(X);g?Q.ELECTRON_RUN_AS_NODE=g:delete Q.ELECTRON_RUN_AS_NODE,y?Q.ELECTRON_NO_ATTACH_CONSOLE=y:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",Q),t(Q)}catch(Q){f.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(Q)),s(Q)}})})}}),define(oe[111],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[234],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((c,O)=>ie(["vsda"],c,O))}async createNewMessage(c){try{const O=await this.c(),T=new O.validator;if(T){const D=String(L.a++);return this.b.set(D,T),{id:D,data:T.createNewMessage(c)}}}catch{}return{id:"",data:c}}async validate(c,O){if(!c.id)return!0;const T=this.b.get(c.id);if(!T)return!1;this.b.delete(c.id);try{return T.validate(O)==="ok"}catch{return!1}}async sign(c){try{const O=await this.c(),T=new O.signer;if(T)return T.sign(c)}catch{}return c}}L.a=1,e.SignService=L}),define(oe[75],ae([0,1,3,2]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class c extends N.Disposable{constructor(b,m,d){super(),this.a=b,this.b=m,this.c=d}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}}class O extends c{constructor(b,m){super(b,m,void 0),this.f=this.B(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends O{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class D extends O{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=D;class I extends c{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=S}),define(oe[112],ae([0,1,4,36,31]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(I){if(L.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function T(I,S,P,b,m,d,p,E){const l=Object.create(null);l["common.machineId"]=d,l.sessionID=(0,c.generateUuid)()+Date.now(),l.commitHash=b,l.version=m,l["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,L.PlatformToString)(L.platform),l["common.nodePlatform"]=N.platform,l["common.nodeArch"]=P,l["common.product"]=E||"desktop",p&&(l["common.msftInternal"]=p);let f=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),L.isLinuxSnap&&(l["common.snap"]="true");const g=O(S);return g&&(l["common.platformDetail"]=g),l}e.resolveCommonProperties=T;function D(I){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const P=S.toLowerCase();return I.some(b=>P===b)}e.verifyMicrosoftInternalDomain=D}),define(oe[19],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N=e.TelemetryLevel||(e.TelemetryLevel={}));var c;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(c=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[235],ae([0,1,34,6,35,22,14,4,12,145,28,147,98,13,26,19]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const l=new Map;async function f(i,o){const n=`${i}::${o.join(":")}`,t=l.get(n);if(t)return t;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,h=2e4;function w(R,A,M,$){const V=A.substring(R.length+1);return N.Promises.withAsyncBody(async q=>{let W;try{W=await P.Promises.readdir(A,{withFileTypes:!0})}catch{q();return}if($.count>=h){$.count+=W.length,$.maxReached=!0,q();return}let X=W.length;if(X===0){q();return}let Q=W;$.count+W.length>h&&($.maxReached=!0,X=h-$.count,Q=W.slice(0,X)),$.count+=W.length;for(const Y of Q)if(Y.isDirectory()){if(M.includes(Y.name)||await w(R,(0,T.join)(A,Y.name),M,$),--X===0){q();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const x=Y.name.substring(Z+1);x&&r.set(x,(r.get(x)??0)+1)}for(const x of s)x.relativePathPattern?.test(V)!==!1&&x.filePattern.test(Y.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--X===0){q();return}}})}const v=N.Promises.withAsyncBody(async R=>{const A={count:0,maxReached:!1};await w(i,i,o,A);const M=await y(i);R({configFiles:u(a),fileTypes:u(r),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:M})});return l.set(n,v),v}e.collectWorkspaceStats=f;function u(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function g(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=g;async function y(i){try{const o=new Map,n=(0,T.join)(i,".vscode","launch.json"),t=await P.Promises.readFile(n),s=[],r=(0,c.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,c.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const h=a.type;h&&(o.has(h)?o.set(h,o.get(h)+1):o.set(h,1))}return u(o)}catch{return[]}}e.collectLaunchConfigs=y;let k=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||n.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.listProcesses)(o.mainPID),this.k(o)]).then(async t=>{let[s,r]=t,a=this.m(o,s);return n.forEach(h=>{if((0,m.isRemoteDiagnosticError)(h))a+=`
${h.errorMessage}`,r+=`
${h.errorMessage}`;else if(a+=`

Remote: ${h.hostName}`,h.processes&&(a+=`
${this.m(o,h.processes)}`),h.workspaceMetadata){r+=`
|  Remote: ${h.hostName}`;for(const w of Object.keys(h.workspaceMetadata)){const v=h.workspaceMetadata[w];let R=`${v.fileCount} files`;v.maxFilesReached&&(R=`more than ${R}`),r+=`|    Folder (${w}): ${R}`,r+=this.h(v)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:t,vmHint:s,os:r,cpus:a}=g(),h={os:r,memory:t,cpus:a,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return D.isWindows||(h.load=`${L.loadavg().map(w=>Math.round(w)).join(", ")}`),D.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(o,n){const t=[];return(0,b.listProcesses)(o.mainPID).then(async s=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,s)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),n.forEach(r=>{if((0,m.isRemoteDiagnosticError)(r))t.push(`
${r.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${r.hostName}`),t.push(this.f(r.machineInfo)),r.processes&&t.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const h=r.workspaceMetadata[a];let w=`${h.fileCount} files`;h.maxFilesReached&&(w=`more than ${w}`),t.push(`Folder (${a}): ${w}`),t.push(this.h(h))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const n=[];let s=0;const r=(v,R)=>{const A=` ${v}(${R})`;s+A.length>60?(n.push(a),a="|                 ",s=a.length):s+=A.length,a+=A};let a="|      File types:";const h=10,w=o.fileTypes.length>h?h:o.fileTypes.length;for(let v=0;v<w;v++){const R=o.fileTypes[v];r(R.name,R.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",s=0,o.configFiles.forEach(v=>{r(v.name,v.count)}),n.push(a)),o.launchConfigFiles.length>0){let v="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{v+=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`}),n.push(v)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const n=[],t=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(r=>{const a=I.URI.revive(r);if(a.scheme===O.Schemas.file){const h=a.fsPath;t.push(f(h,["node_modules",".git"]).then(w=>{let v=`${w.fileCount} files`;w.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,T.basename)(h)}): ${v}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${h} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,n){const t=new Map;o.windows.forEach(r=>t.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>t.set(r,a));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,t,s,n,0),s.join(`
`)}n(o,n,t,s,r){const a=r===0;let h;a?h=s.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(s.pid)?h=n.get(s.pid):h=`${"  ".repeat(r)} ${s.name}`;const w=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(w/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(v=>this.n(o,n,t,v,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:t}of o.folders){const s=I.URI.revive(t);if(s.scheme!==O.Schemas.file)continue;const r=s.fsPath;try{(await f(r,["node_modules",".git"])).fileTypes.forEach(h=>n.add(h.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const t=I.URI.revive(n);if(t.scheme!==O.Schemas.file)continue;const s=t.fsPath;try{const r=await f(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};k=ye([J(0,E.ITelemetryService),J(1,p.IProductService)],k),e.DiagnosticsService=k}),define(oe[236],ae([0,1,109,3,19,15,2,9,14,49,26,4,6,105,17,174,34]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const f=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let u=class extends T.Disposable{constructor(y,k,i,o,n,t){super(),this.r=y,this.s=k,this.t=i,this.u=t,this.b=new N.Emitter,this.onDidTokenFailed=this.b.event,this.f=new N.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new N.Emitter,this.onDidChangeAccount=this.g.event,this.k=L.TunnelStates.disconnected,this.h=this.B(o.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this.n=new m.Delayer(100),this.B(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,D.LogLevelToString)(s)))),this.B(n.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(t.onDidChangeConfiguration(s=>{f.some(r=>s.affectsConfiguration(r))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(y){if(y&&this.i?y.token!==this.i.token||y.providerId!==this.i.providerId:y!==this.i){this.i=y,this.g.fire(y),y?this.h.info(`Account updated: ${y.accountLabel} (${y.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!y});try{await this.n.trigger(()=>this.w())}catch(k){this.h.error(k)}}return this.k}v(){if(!this.p){let y;b.isMacintosh?y=this.t.appRoot:y=(0,I.dirname)((0,I.dirname)(this.t.appRoot)),this.p=(0,I.join)(y,"bin",`${this.s.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(L.TunnelStates.disconnected);return}const{token:y,providerId:k,accountLabel:i}=this.i;this.y(L.TunnelStates.connecting((0,E.localize)(0,null,i,k)));const o=(a,h)=>{a=a.replaceAll(y,"*".repeat(4)),h?this.h.error(a):this.h.info(a),!this.t.isBuilt&&a.startsWith("   Compiling")&&this.y(L.TunnelStates.connecting((0,E.localize)(1,null)))},n=this.z("login",["user","login","--provider",k,"--access-token",y,"--log",(0,D.LogLevelToString)(this.h.getLevel())],o);this.j=n;try{if(await n,this.j!==n)return}catch(a){this.h.error(a),this.j=void 0,this.b.fire(!0),this.y(L.TunnelStates.disconnected);return}const t=this.D();t?this.y(L.TunnelStates.connecting((0,E.localize)(2,null,t))):this.y(L.TunnelStates.connecting((0,E.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,D.LogLevelToString)(this.h.getLevel())];t?s.push("--name",t):s.push("--random-name"),this.C()&&s.push("--no-sleep");const r=this.z("tunnel",s,(a,h)=>{h?this.h.error(a):this.h.info(a);const w=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(w){const v={link:w[1],domain:w[2],hostName:w[4]};this.y(L.TunnelStates.connected(v))}else a.match(/error refreshing token/)&&(r.cancel(),this.b.fire(!0),this.y(L.TunnelStates.disconnected))});this.j=r,r.finally(()=>{r===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(y){this.k=y,this.f.fire(y)}z(y,k,i=()=>{}){return(0,m.createCancelablePromise)(o=>new Promise((n,t)=>{o.isCancellationRequested&&n();let s;if(o.onCancellationRequested(()=>{s&&(this.h.info(`${y} terminating(${s.pid})`),s.kill())}),!this.t.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${y} Spawning: cargo run -- tunnel ${k.join(" ")}`,!1),s=(0,S.spawn)("cargo",["run","--","tunnel",...k],{cwd:(0,I.join)(this.t.appRoot,"cli")});else{i("Running tunnel CLI",!1);const r=this.v();i(`${y} Spawning: ${r} tunnel ${k.join(" ")}`,!1),s=(0,S.spawn)(r,["tunnel",...k],{cwd:(0,l.homedir)()})}s.stdout.on("data",r=>{if(s){const a=r.toString();i(a,!1)}}),s.stderr.on("data",r=>{if(s){const a=r.toString();i(a,!0)}}),s.on("exit",r=>{s&&(i(`${y} exit(${s.pid}): + ${r} `,!1),s=void 0,r===0?n():t())}),s.on("error",r=>{s&&(i(`${y} error(${s.pid}): + ${r} `,!0),s=void 0,t())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let y=this.u.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,l.hostname)();return y=y.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),y||void 0}};u=ye([J(0,c.ITelemetryService),J(1,P.IProductService),J(2,O.INativeEnvironmentService),J(3,D.ILoggerService),J(4,d.ISharedProcessLifecycleService),J(5,p.IConfigurationService)],u),e.RemoteTunnelService=u}),define(oe[113],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(O){this.b=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,{eventName:D,data:I}){return this.b.forEach(S=>S.log(D,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class N{constructor(O){this.b=O}log(O,T){return this.b.call("log",{eventName:O,data:T}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=N}),define(oe[46],ae([0,1,32,11,3,17,74,112,19]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(s){this.value=s}}e.TelemetryTrustedValue=S;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class b{async publicLog(s,r,a){}async publicLogError(s,r,a){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(t,s){return c.Event.debounce(s.onDidChangeConfiguration,(a,h)=>{const w=a?new Set([...a.affectedKeys,...h.affectedKeys]):h.affectedKeys;return{...h,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=m;function d(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function p(t,s){return!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=p;function E(t){const s=t.getValue(I.TELEMETRY_SETTING_ID),r=t.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function l(t){const s={},r={},a={};g(t,a);for(let h in a){h=h.length>150?h.substr(h.length-149):h;const w=a[h];typeof w=="number"?r[h]=w:typeof w=="boolean"?r[h]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${w.length}`),s[h]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(s[h]=w)}return{properties:s,measurements:r}}e.validateTelemetryData=l;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const s=(0,T.getRemoteName)(t);return f.has(s)?s:"other"}e.cleanRemoteAuthority=u;function g(t,s,r=0,a){if(!!t)for(const h of Object.getOwnPropertyNames(t)){const w=t[h],v=a?a+h:h;Array.isArray(w)?s[v]=(0,L.safeStringify)(w):w instanceof Date?s[v]=w.toISOString():(0,N.isObject)(w)?r<2?g(w,s,r+1,v+"."):s[v]=(0,L.safeStringify)(w):s[v]=w}}function y(t,s){const r=t.msftInternalDomains||[],a=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||a}e.isInternalTelemetry=y;function k(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=k;function i(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const a=[];for(const R of s)for(;;){const A=R.exec(t);if(!A)break;a.push([A.index,R.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(r="";;){const R=w.exec(t);if(!R)break;const A=a.some(([M,$])=>R.index<$&&M<w.lastIndex);!h.test(R[0])&&!A&&(r+=t.substring(v,R.index)+"<REDACTED: user-file-path>",v=w.lastIndex)}return v<t.length&&(r+=t.substr(v)),r}function o(t){if(!t)return t;const s=t.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of r)if(a.regex.test(s))return`<REDACTED: ${a.label}>`;return t}function n(t,s){return(0,L.cloneAndChange)(t,r=>{if(r instanceof S)return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,s);for(const h of s)a=a.replace(h,"");return a=o(a),a}})}e.cleanData=n}),define(oe[33],ae([0,1,27,29,50,4,12,10,36,46]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,L.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=P;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,s,r)}static parse(t){const s=b.exec(t);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r="undefined"){this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const t=d.exec(n);return t&&t[1]?[l(t[1]),t[2]]:[l(n),void 0]}e.getIdAndVersion=p;function E(n,t){return`${n}.${t}`}e.getExtensionId=E;function l(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function f(n,t){return l(E(n??c.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=f;function u(n,t){const s=[],r=a=>{for(const h of s)if(h.some(w=>P(t(w),t(a))))return h;return null};for(const a of n){const h=r(a);h?h.push(a):s.push([a])}return s}e.groupByExtension=u;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function y(n){return{id:new S.TelemetryTrustedValue(n.identifier.id),name:new S.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new c.ExtensionIdentifier("pprice.better-merge");function k(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&s.every(h=>!P(h.identifier,{id:a}))){const h=n.filter(w=>P(w.identifier,{id:a}));h.length===1&&(s.push(h[0]),r.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=k;async function i(n,t){if(!O.isLinux)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,t){const s=await i(n,t),r=(0,N.getTargetPlatform)(s?"alpine":O.platform,I.arch);return t.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(oe[237],ae([0,1,21,2,23,12,13,26,6,3,14,4,36,163,33]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let E=class extends N.Disposable{constructor(y,k){super(),this.b=y,this.c=k,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,i])=>this.a.set(i.configPath,i))}getConfigBasedTips(y){return this.f(y)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(y){const k=[];for(const[i,o]of this.a)if(!(o.configScheme&&o.configScheme!==y.scheme))try{const n=(await this.b.readFile((0,c.joinPath)(y,i))).value.toString();for(const[t,s]of Object.entries(o.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(n))&&k.push({extensionId:t,extensionName:s.name,configName:o.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return k}};E=ye([J(0,T.IFileService),J(1,D.IProductService)],E),e.ExtensionTipsService=E;const l="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";class u extends E{constructor(y,k,i,o,n,t,s,r){super(s,r),this.m=y,this.n=k,this.p=i,this.r=o,this.s=n,this.t=t,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,r.exeBasedExtensionTips&&Object.entries(r.exeBasedExtensionTips).forEach(([a,h])=>{const w=[],v=[],R=[];Object.entries(h.recommendations).forEach(([A,M])=>{M.important?h.important?w.push({extensionId:A,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):v.push({extensionId:A,extensionName:M.name,isExtensionPack:!!M.isExtensionPack}):R.push({extensionId:A,extensionName:M.name,isExtensionPack:!!M.isExtensionPack})}),w.length&&this.g.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:w}),v.length&&this.h.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:v}),R.length&&this.j.set(a,{exeFriendlyName:h.friendlyName,windowsPath:h.windowsPath,recommendations:R})}),(0,I.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.z()})}async getImportantExecutableBasedTips(){const y=await this.J(this.g),k=await this.J(this.h);return[...y,...k]}getOtherExecutableBasedTips(){return this.J(this.j)}async u(){const y=await this.J(this.g),k=await this.J(this.h),i=await this.r.getInstalled();this.k=this.v(y,i),this.l=this.v(k,i)}v(y,k){const i=new Map;y.forEach(r=>i.set(r.extensionId.toLowerCase(),r));const{installed:o,uninstalled:n}=this.I([...i.keys()],k);for(const r of o){const a=i.get(r);a&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:r,exeName:a.exeName})}for(const r of n){const a=i.get(r);a&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:r,exeName:a.exeName})}const t=this.G(),s=new Map;for(const r of n){const a=i.get(r);if(a&&(!t[a.exeName]||!t[a.exeName].includes(a.extensionId))){let h=s.get(a.exeName);h||(h=[],s.set(a.exeName,h)),h.push(a)}}return s}w(){if(this.k.size===0)return;const[y,k]=[...this.k.entries()][0];this.C(k).then(i=>{switch(i){case"reacted":this.H(k[0].exeName,k);break;case"ignored":this.k.delete(y);break;case"incompatibleWindow":{const o=S.Event.once(S.Event.latch(S.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(o(()=>this.w()));break}case"toomany":{const o=this.B((0,I.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}z(){if(this.l.size===0)return;const y=this.D(),k=Date.now()-y,i=7*24*60*60*1e3;if(k<i){const t=this.B((0,I.disposableTimeout)(()=>{t.dispose(),this.z()},i-k));return}const[o,n]=[...this.l.entries()][0];this.C(n).then(t=>{switch(t){case"reacted":{this.F(Date.now()),this.l.delete(o),this.H(n[0].exeName,n);const s=this.B((0,I.disposableTimeout)(()=>{s.dispose(),this.z()},i));break}case"ignored":this.l.delete(o),this.z();break;case"incompatibleWindow":{const s=S.Event.once(S.Event.latch(S.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(s(()=>this.z()));break}case"toomany":{const s=this.B((0,I.disposableTimeout)(()=>{s.dispose(),this.z()},36e5));break}}})}async C(y){const k=await this.r.getInstalled(1),i=y.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(t=>k.every(s=>!(0,p.areSameExtensions)(s.identifier,{id:t})))).map(({extensionId:n})=>n.toLowerCase()),o=(0,d.localize)(0,null,y[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(i,o,`@exe:"${y[0].exeName}"`,3)}D(){let y=this.s.getNumber(f,-1);return y||(y=Date.now(),this.F(y)),y}F(y){this.s.store(f,y,-1,1)}G(){return JSON.parse(this.s.get(l,-1,"{}"))}H(y,k){const i=this.G();i[y]=k.map(({extensionId:o})=>o.toLowerCase()),this.s.store(l,JSON.stringify(i),-1,0)}I(y,k){const i=[],o=[],n=k.reduce((t,s)=>(t.add(s.identifier.id.toLowerCase()),t),new Set);return y.forEach(t=>{n.has(t.toLowerCase())?i.push(t):o.push(t)}),{installed:i,uninstalled:o}}async J(y){const k=[],i=new Map;for(const o of y.keys()){const n=y.get(o);if(!n||!(0,L.isNonEmptyArray)(n.recommendations))continue;const t=[];b.isWindows?n.windowsPath&&t.push(n.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(t.push((0,P.join)("/usr/local/bin",o)),t.push((0,P.join)("/usr/bin",o)),t.push((0,P.join)(this.m.fsPath,o)));for(const s of t){let r=i.get(s);if(r===void 0&&(r=await this.b.exists(O.URI.file(s)),i.set(s,r)),r)for(const{extensionId:a,extensionName:h,isExtensionPack:w,whenNotInstalled:v}of n.recommendations)k.push({extensionId:a,extensionName:h,isExtensionPack:w,exeName:o,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:v})}}return k}}e.AbstractNativeExtensionTipsService=u}),define(oe[238],ae([0,1,25,33]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function c(O,T,D,I,S){try{const P=await O.getExtensionsControlManifest();if(!P.deprecated)return;const b=await O.getInstalled(1);for(const[m,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:p,autoMigrate:E,preRelease:l}=d.extension;if(!E)continue;const f=b.find(g=>(0,N.areSameExtensions)(g.identifier,{id:m}));if(!f)continue;const u=(await T.getExtensions([{id:p,preRelease:l}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!u){S.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{S.info(`Migrating '${f.identifier.id}' extension to '${p}' extension...`);const g=!I.getDisabledExtensions().some(k=>(0,N.areSameExtensions)(k,f.identifier));await O.uninstall(f),S.info(`Uninstalled the unsupported extension '${f.identifier.id}'`);let y=b.find(k=>(0,N.areSameExtensions)(k.identifier,{id:p}));(!y||!y.isPreReleaseVersion&&g)&&(y=await O.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${y.identifier.id}'`),g||(await I.disableExtension(y.identifier),S.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${f.identifier.id}' is disabled`)),E.storage&&(D.addToMigrationList((0,N.getExtensionId)(f.manifest.publisher,f.manifest.name),(0,N.getExtensionId)(y.manifest.publisher,y.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${f.identifier.id}' extension to '${p}' extension.`)}catch(g){S.error(g)}}}catch(P){S.error(P)}}e.migrateUnsupportedExtensions=c}),define(oe[239],ae([0,1,3,2,37,33,50]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class D extends N.Disposable{constructor(S,P,b,m,d,p,E){super(),this.f=S,this.g=P,this.h=b,this.i=m,this.j=d,this.k=p,this.l=E,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.DisposableMap),this.m().then(null,l=>E.error(l))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,P){try{await Promise.all(P.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource)))),S.length&&await Promise.all(S.map(b=>(this.c.set(b.id,(0,N.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){throw this.l.error(b),b}}async r(S){for(const P of S.extensions)this.D(this.G(P.identifier,P.version),S.profileLocation)}async s(S){for(const P of S.extensions){const b=this.G(P.identifier,P.version);S.error?this.F(b,S.profileLocation):this.D(b,S.profileLocation)}}async t(S){for(const P of S.extensions)this.F(this.G(P.identifier,P.version),S.profileLocation)}async u(S){const P=[],b=[];for(const m of S.extensions){const d=this.G(m.identifier,m.version);S.error?this.D(d,S.profileLocation):(this.F(d,S.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),b.push(this.f.scanInstalledExtensionAtLocation(m.location).then(p=>{p?P.push(p):this.l.info("Extension not found at the location",m.location.toString())},p=>this.l.error(p)))))}try{await Promise.all(b),P.length&&await this.C(P)}catch(m){this.l.error(m)}}v(S){for(const P of this.h.profiles)S.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(S){const P=[],b=[],m=await this.i.scanProfileExtensions(S),d=new Set,p=new Set;for(const[E,l]of this.b)l.has(S)&&p.add(E);for(const E of m){const l=this.G(E.identifier,E.version);d.add(l),p.has(l)||(P.push(E.identifier),this.D(l,S))}for(const E of p)if(!d.has(E)){const l=this.H(E);l&&(b.push(l.identifier),this.F(E,S))}(P.length||b.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async y(S){const P=await this.i.scanProfileExtensions(S);for(const b of P)this.D(this.G(b.identifier,b.version),S)}async z(S){for(const P of[...this.b.keys()])this.F(P,S);await this.C()}async C(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.G(b.identifier,b.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}D(S,P){let b=this.b.get(S);b||this.b.set(S,b=new c.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),b.add(P)}F(S,P){const b=this.b.get(S);b&&b.delete(P),b?.size||this.b.delete(S)}G(S,P){return`${T.ExtensionIdentifier.toKey(S.id)}@${P}`}H(S){const[P,b]=(0,O.getIdAndVersion)(S);return b?{identifier:{id:P},version:b}:void 0}}e.ExtensionsWatcher=D}),define(oe[240],ae([0,1,44,46]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function c(O,T,D,I,S,P,b){const m={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${T.nameShort})`};if((0,N.supportsTelemetry)(T,D)&&(0,N.getTelemetryLevel)(I)===3){const d=await(0,L.getServiceMachineId)(D,S,P);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=b.machineId||d}return m}e.resolveMarketplaceHeaders=c}),define(oe[241],ae([0,1,102,21,6,2,22,14,28,15,29,33,9,72,12]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends d.LanguagePackBaseService{constructor(g,y,k,i){super(k),this.h=g,this.i=i,this.g=this.B(new l(y,i)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(g,y){const i=(await this.g.getLanguagePacks())[y];if(!i){this.i.warn(`No language pack found for ${y}`);return}const o=i.translations[g];return o?p.URI.file(o):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),y=Object.keys(g).map(k=>{const i=g[k];return{...this.f(k,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((k,i)=>k.label.localeCompare(i.label)),y}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const y=await this.g.getLanguagePacks();Object.keys(y).some(k=>y[k]&&y[k].extensions.some(i=>(0,b.areSameExtensions)(i.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(y);return!(0,N.equals)(Object.keys(g),Object.keys(k))}};E=ye([J(0,P.IExtensionManagementService),J(1,S.INativeEnvironmentService),J(2,P.IExtensionGalleryService),J(3,m.ILogService)],E),e.NativeLanguagePackService=E;let l=class extends O.Disposable{constructor(g,y){super(),this.i=y,this.c={},this.f=(0,D.join)(g.userDataPath,"languagepacks.json"),this.g=new c.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(y=>{Object.keys(y).forEach(k=>delete y[k]),this.j(y,...g)}).then(()=>this.c)}j(g,...y){for(const k of y)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.k(g,k);Object.keys(g).forEach(k=>this.l(g[k]))}k(g,y){const k=y.identifier,i=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const o of i)if(y.location.scheme===T.Schemas.file&&f(o)){let n=g[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},g[o.languageId]=n);const t=n.extensions.filter(s=>(0,b.areSameExtensions)(s.extensionIdentifier,k))[0];t?t.version=y.manifest.version:n.extensions.push({extensionIdentifier:k,version:y.manifest.version});for(const s of o.translations)n.translations[s.id]=(0,D.join)(y.location.fsPath,s.path)}}l(g){if(g){const y=(0,L.createHash)("md5");for(const k of g.extensions)y.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);g.hash=y.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let y=null;return I.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(y=g(k),k)).then(k=>{for(const o of Object.keys(k))k[o]||delete k[o];this.c=k,this.h=!0;const i=JSON.stringify(this.c);return this.i.debug("Writing language packs",i),I.Promises.writeFile(this.f,i)}).then(()=>y,k=>this.i.error(k))})}};l=ye([J(0,S.INativeEnvironmentService),J(1,m.ILogService)],l);function f(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const g of u.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[242],ae([0,1,10,32,46]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const O="https://0.0.0.0/OneCollector/1.0",T="https://0.0.0.0/ping";async function D(S,P,b){const m=await new Promise((f,u)=>{ie(["@microsoft/1ds-core-js"],f,u)}),d=await new Promise((f,u)=>{ie(["@microsoft/1ds-post-js"],f,u)}),p=new m.AppInsightsCore,E=new d.PostChannel,l={instrumentationKey:S,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(b){l.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:b};l.extensionConfig[E.identifier]=f}return p.initialize(l,[]),p.addTelemetryInitializer(f=>{P&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),p}class I{constructor(P,b,m,d,p){this.e=P,this.f=b,this.g=m,this.h=p,this.c=O,this.d=T,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=D(this.a,this.e,this.h)),this.b.then(b=>{P(b)},b=>{(0,L.onUnexpectedError)(b),console.error(b)})}}log(P,b){if(!this.a)return;b=(0,N.mixin)(b,this.g),b=(0,c.validateTelemetryData)(b);const m=this.f+"/"+P;try{this.i(d=>{d.pluginVersionString=b?.properties.version??"Unknown",d.track({name:m,baseData:{name:m,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[114],ae([0,1,2,177,15,9,26,46]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends L.Disposable{constructor(P,b,m,d,p=""){super(),this.b=p;const E=b.getLogger(D.telemetryLogId);if(E)this.a=this.B(E);else{const f=(0,D.isLoggingOnly)(d,m)?" (Not Sent)":"",u=()=>(0,D.supportsTelemetry)(d,m)&&P.getLevel()===O.LogLevel.Trace;this.a=this.B(b.createLogger(D.telemetryLogId,{name:(0,N.localize)(0,null,f),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>b.setVisibility(D.telemetryLogId,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,b){this.a.trace(`${this.b}telemetry/${P}`,(0,D.validateTelemetryData)(b))}};I=ye([J(0,O.ILogService),J(1,O.ILoggerService),J(2,c.IEnvironmentService),J(3,T.IProductService)],I),e.TelemetryLogAppender=I}),define(oe[115],ae([0,1,2,32,4,27,178,17,45,107,26,40,19,46]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(f,u,g){this.k=u,this.l=g,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,O.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(m.TELEMETRY_SETTING_ID)||y.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,u){this.d[f]=u}m(){let f=(0,d.getTelemetryLevel)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const g=u.usage?3:u.error?2:0;f=Math.min(f,g)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,u,g){this.g<u||(g=(0,N.mixin)(g,this.d),g=(0,d.cleanData)(g,this.j),g=(0,N.mixin)(g,this.c),this.b.forEach(y=>y.log(f,g)))}publicLog(f,u){this.n(f,3,u)}publicLog2(f,u){this.publicLog(f,u)}publicLogError(f,u){!this.h||this.n(f,2,u)}publicLogError2(f,u){this.publicLogError(f,u)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ye([J(1,D.IConfigurationService),J(2,P.IProductService)],p),e.TelemetryService=p;function E(){const l=(0,T.localize)(0,null,S.default.nameLong),f=S.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=c.isWeb?"":(0,T.localize)(3,null),g=(0,T.localize)(4,null),y=(0,T.localize)(5,null),k=(0,T.localize)(6,null),i=(0,T.localize)(7,null),o=`
|       | ${g} | ${y} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(8,null);return`
${l} ${f} ${u}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,T.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,T.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[243],ae([0,1,295,242]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class c extends N.AbstractOneDataSystemAppender{constructor(T,D,I,S){const P={sendPOST:(b,m)=>{const d={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const p=L.request(b.urlString,d,E=>{E.on("data",function(l){m(E.statusCode??200,E.headers,l.toString())}),E.on("error",function(l){m(0,{})})});p.write(b.data),p.end()}catch{m(0,{})}}};super(T,D,I,S,P)}}e.OneDataSystemAppender=c}),define(oe[244],ae([0,1,22,65,17,15,9,26,19,113,114,115]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(p,E,l,f,u,g){this.b=p,this.c=E,this.d=l,this.e=f,this.f=u,this.g=g,this.a=new Map}h(p){if(!this.a.has(p.id)){const E=Object.create(null);E["common.vscodemachineid"]=this.c.machineId,E["common.vscodesessionid"]=this.c.sessionId;const l=[p.id,JSON.stringify(E),p.aiKey],u=new N.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:l,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),g=[new S.TelemetryAppenderClient(u),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${p.id}] `)];this.a.set(p.id,new b.TelemetryService({appenders:g,sendErrorTelemetry:p.sendErrorTelemetry},this.b,this.g))}return this.a.get(p.id)}publicLog(p,E,l){this.h(p).publicLog(E,l)}publicLogError(p,E,l){this.h(p).publicLogError(E,l)}};m=ye([J(0,c.IConfigurationService),J(1,I.ITelemetryService),J(2,T.ILogService),J(3,T.ILoggerService),J(4,O.IEnvironmentService),J(5,D.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(oe[116],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(oe[245],ae([0,1,4,116]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class c{constructor(I){this.collections=I,this.map=new Map,I.forEach((S,P)=>{const b=S.map.entries();let m=b.next();for(;!m.done;){const d=m.value[0];let p=this.map.get(d);if(p||(p=[],this.map.set(d,p)),p.length>0&&p[0].type===N.EnvironmentVariableMutatorType.Replace){m=b.next();continue}const E=m.value[1];p.unshift({extensionIdentifier:P,value:E.value,type:E.type}),m=b.next()}})}async applyToProcessEnvironment(I,S){let P;L.isWindows&&(P={},Object.keys(I).forEach(b=>P[b.toLowerCase()]=b));for(const[b,m]of this.map){const d=L.isWindows&&P[b.toLowerCase()]||b;for(const p of m){const E=S?await S(p.value):p.value;switch(p.type){case N.EnvironmentVariableMutatorType.Append:I[d]=(I[d]||"")+E;break;case N.EnvironmentVariableMutatorType.Prepend:I[d]=E+(I[d]||"");break;case N.EnvironmentVariableMutatorType.Replace:I[d]=E;break}}}}diff(I){const S=new Map,P=new Map,b=new Map;if(I.map.forEach((m,d)=>{const p=this.map.get(d),E=O(m,p);E&&S.set(d,E)}),this.map.forEach((m,d)=>{const p=I.map.get(d),E=O(m,p);E&&b.set(d,E)}),this.map.forEach((m,d)=>{const p=I.map.get(d),E=T(m,p);E&&P.set(d,E)}),!(S.size===0&&P.size===0&&b.size===0))return{added:S,changed:P,removed:b}}}e.MergedEnvironmentVariableCollection=c;function O(D,I){if(!I)return D;const S=new Set;I.forEach(b=>S.add(b.extensionIdentifier));const P=[];return D.forEach(b=>{S.has(b.extensionIdentifier)||P.push(b)}),P.length===0?void 0:P}function T(D,I){if(!I)return;const S=new Map;I.forEach(b=>S.set(b.extensionIdentifier,b));const P=[];return D.forEach(b=>{const m=S.get(b.extensionIdentifier);m&&(b.type!==m.type||b.value!==m.value)&&P.push(m)}),P.length===0?void 0:P}}),define(oe[246],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=L;function N(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=N;function c(T){return Array.from(T.entries()).map(D=>[D[0],L(D[1].map)])}e.serializeEnvironmentVariableCollections=c;function O(T){return new Map(T.map(D=>[D[0],{map:N(D[1])}]))}e.deserializeEnvironmentVariableCollections=O}),define(oe[247],ae([0,1,6,25,3,2,9]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends O.Disposable{constructor(S,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new c.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((P,b)=>{const m=++this.a;this.c.set(m,P),this.g.fire({requestId:m,...S});const d=new N.CancellationTokenSource;(0,L.timeout)(this.b,d.token).then(()=>b(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,O.toDisposable)(()=>d.cancel())])})}acceptReply(S,P){const b=this.c.get(S);b?(this.c.delete(S),(0,O.dispose)(this.f.get(S)||[]),this.f.delete(S),b(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};D=ye([J(1,T.ILogService)],D),e.RequestStore=D}),define(oe[117],ae([0,1,5,69]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new N.RawContextKey("terminalTabFocusMode",!1,!0);var c;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(c=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var O;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(O=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var D;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(D=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Logger="logger",g.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var P;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var d;(function(g){g.TerminalView="view",g.Editor="editor"})(d=e.TerminalLocationString||(e.TerminalLocationString={}));var p;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var E;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(E=e.FlowControlConstants||(e.FlowControlConstants={}));var l;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(l=e.ProfileSource||(e.ProfileSource={}));var f;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(f=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var u;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(u=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[248],ae([0,1,52,12,180,134]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(m,d){const p=[{name:null,description:(0,c.localize)(0,null)}];return p.push(...m.map(E=>({name:E.profileName,description:D(E)}))),d&&p.push(...d.map(E=>({name:E.title,description:I(E)}))),{values:p.map(E=>E.name),markdownDescriptions:p.map(E=>E.description)}}e.createProfileSchemaEnums=T;function D(m){let d=`$(${O.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?d+=`
- args: "${m.args}"`:d+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(d+=`
- overrideName: ${m.overrideName}`),m.color&&(d+=`
- color: ${m.color}`),m.env&&(d+=`
- env: ${JSON.stringify(m.env)}`),d}function I(m){return`$(${O.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:L.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function S(m,d){if(!m&&!d)return!0;if(typeof m=="string"&&typeof d=="string")return m===d;if(Array.isArray(m)&&Array.isArray(d)){if(m.length!==d.length)return!1;for(let p=0;p<m.length;p++)if(m[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function P(m,d){if(!m&&!d)return!0;if(!m||!d)return!1;if(O.ThemeIcon.isThemeIcon(m)&&O.ThemeIcon.isThemeIcon(d))return m.id===d.id&&m.color===d.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof d=="object"&&"light"in d&&"dark"in d){const p=m,E=d;if((N.URI.isUri(p.light)||b(p.light))&&(N.URI.isUri(p.dark)||b(p.dark))&&(N.URI.isUri(E.light)||b(E.light))&&(N.URI.isUri(E.dark)||b(E.dark)))return p.light.path===E.light.path&&p.dark.path===E.dark.path}if(N.URI.isUri(m)&&N.URI.isUri(d)||b(m)||b(d)){const p=m,E=d;return p.path===E.path&&p.scheme===E.scheme}return!1}e.terminalIconsEqual=P;function b(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=b}),define(oe[249],ae([0,1,52,179,45,40,248]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),y=>y.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),y=>`$(${y.id})`)};const D={args:{description:(0,N.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,N.localize)(1,null),type:"boolean"},icon:{description:(0,N.localize)(2,null),...e.terminalIconSchema},color:{description:(0,N.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,N.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,N.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},S={type:"object",required:["path"],properties:{path:{description:(0,N.localize)(6,null),type:["string"],items:{type:"string"}},...D}},P=(0,N.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,N.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,N.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,N.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,N.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,N.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),l={id:"terminal",order:100,title:(0,N.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,N.localize)(26,null)}},{type:"string",markdownDescription:(0,N.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,N.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(30,null),type:"string"},id:{description:(0,N.localize)(31,null),type:"string"},title:{description:(0,N.localize)(32,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(34,null),type:"string"},id:{description:(0,N.localize)(35,null),type:"string"},title:{description:(0,N.localize)(36,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(38,null),type:"string"},id:{description:(0,N.localize)(39,null),type:"string"},title:{description:(0,N.localize)(40,null),type:"string"},...D}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,N.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,N.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,N.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,N.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,N.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){O.Registry.as(c.Extensions.Configuration).registerConfiguration(l),g()}e.registerTerminalPlatformConfiguration=f;let u;function g(y,k){const i=O.Registry.as(c.Extensions.Configuration);let o;y&&(o=(0,T.createProfileSchemaEnums)(y?.profiles,k));const n=u;u={id:"terminal",order:100,title:(0,N.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:y?.os===3?o?.values:void 0,markdownEnumDescriptions:y?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:y?.os===2?o?.values:void 0,markdownEnumDescriptions:y?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:y?.os===1?o?.values:void 0,markdownEnumDescriptions:y?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[u],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(oe[250],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(oe[251],ae([0,1,34,22,32,14,4,36,27,11,28,116,246,245]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let s=0;return t&&t.length===4&&(s=parseInt(t[3])),s}e.getWindowsBuildNumber=p;async function E(t,s,r,a=D.env,h=P.Promises.exists){if(O.isAbsolute(t))return await h(t)?t:void 0;if(s===void 0&&(s=D.cwd()),O.dirname(t)!=="."){const A=O.join(s,t);return await h(A)?A:void 0}const v=(0,c.getCaseInsensitive)(a,"PATH");if(r===void 0&&(0,S.isString)(v)&&(r=v.split(O.delimiter)),r===void 0||r.length===0){const A=O.join(s,t);return await h(A)?A:void 0}for(const A of r){let M;if(O.isAbsolute(A)?M=O.join(A,t):M=O.join(s,A,t),await h(M))return M;if(T.isWindows){let $=M+".com";if(await h($)||($=M+".exe",await h($)))return $}}const R=O.join(s,t);return await h(R)?R:void 0}e.findExecutable=E;function l(t,s,r,a,h){const w=T.isWindows&&(!s.windowsEnableConpty||p()<18309);if(!s.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||w)return;const v=t.args,R=D.platform==="win32"?O.basename(t.executable).toLowerCase():O.basename(t.executable),A=O.dirname(N.FileAccess.asFileUri("").fsPath);let M;const $={VSCODE_INJECTION:"1"};if(T.isWindows){if(R==="pwsh.exe"||R==="powershell.exe")return!v||o(v)?M=g.get(u.WindowsPwsh):i(v)&&(M=g.get(u.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],A,""),s.shellIntegration.suggestEnabled&&($.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:$}):void 0;a.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(R){case"bash":return!v||v.length===0?M=g.get(u.Bash):n(v)&&($.VSCODE_SHELL_LOGIN="1",f(s,$),M=g.get(u.Bash)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],A),{newArgs:M,envMixin:$}):void 0;case"fish":{const V=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",q=O.join(A,"out/vs/workbench/contrib/xdg_data");return $.XDG_DATA_DIRS=`${V}:${q}`,f(s,$),{newArgs:void 0,envMixin:$}}case"pwsh":return!v||o(v)?M=g.get(u.Pwsh):i(v)&&(M=g.get(u.PwshLogin)),M?(s.shellIntegration.suggestEnabled&&($.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],A,""),{newArgs:M,envMixin:$}):void 0;case"zsh":{if(!v||v.length===0?M=g.get(u.Zsh):n(v)?(M=g.get(u.ZshLogin),f(s,$)):(v===g.get(u.Zsh)||v===g.get(u.ZshLogin))&&(M=v),!M)return;M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],A);let V;try{V=L.userInfo().username}catch{V="unknown"}const q=O.join(L.tmpdir(),`${V}-${h.applicationName}-zsh`);$.ZDOTDIR=q;const W=r?.ZDOTDIR??L.homedir()??"~";$.USER_ZDOTDIR=W;const X=[];return X.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(q,".zshrc")}),X.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(q,".zprofile")}),X.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(q,".zshenv")}),X.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(q,".zlogin")}),{newArgs:M,envMixin:$,filesToCopy:X}}}a.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.getShellIntegrationInjection=l;function f(t,s){if(T.isMacintosh&&t.environmentVariableCollections){const r=(0,m.deserializeEnvironmentVariableCollections)(t.environmentVariableCollections),h=new d.MergedEnvironmentVariableCollection(r).map.get("PATH"),w=[];if(h)for(const v of h)v.type===b.EnvironmentVariableMutatorType.Prepend&&w.push(v.value);w.length>0&&(s.VSCODE_PATH_PREFIX=w.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const g=new Map;g.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(u.Zsh,["-i"]),g.set(u.ZshLogin,["-il"]),g.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],k=["-nol","-nologo"];function i(t){return typeof t=="string"?y.includes(t.toLowerCase()):t.length===1&&y.includes(t[0].toLowerCase())||t.length===2&&(y.includes(t[0].toLowerCase())||y.includes(t[1].toLowerCase()))&&(k.includes(t[0].toLowerCase())||k.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?k.includes(t.toLowerCase()):t.length===0||t?.length===1&&k.includes(t[0].toLowerCase())}function n(t){return t==="string"&&y.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&y.includes(t[0].toLowerCase())}}),define(oe[252],ae([0,1,49,52,14,4,11,28,94,251,196]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,m=!0;function d(t,s,r,a,h=process.env,w,v,R,A){return w=w||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},O.isWindows?p(r,w,h,v,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:a.getValue("terminal.integrated.defaultProfile.windows"),A,R):i(w,v,r,t&&typeof t=="object"?{...t}:a.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:a.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,R,h)}e.detectAvailableProfiles=d;async function p(t,s,r,a,h,w,v,R,A){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let V=!1;(0,S.getWindowsBuildNumber)()>=16299&&(V=!0),await f(R);const q=new Map;if(t){q.set("PowerShell",{source:"PowerShell",icon:N.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:N.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),q.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:N.Codicon.terminalCmd,isAutoDetected:!0}),q.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),q.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:N.Codicon.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;q.set("Cmder",{path:`${$}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}o(w,q);const W=await E(q.entries(),v,s,r,a,A);if(t||h)try{const X=await y(`${$}\\${V?"wsl":"bash"}.exe`,v);for(const Q of X)(!w||!(Q.profileName in w))&&W.push(Q)}catch{m&&(a?.info("WSL is not installed, so could not detect WSL profiles"),m=!1)}return W}async function E(t,s,r,a=process.env,h,w){const v=[];for(const[R,A]of t){if(A===null)continue;let M,$,V;if("source"in A){const Q=b?.get(A.source);if(!Q)continue;M=Q.paths,$=A.args||Q.args,A.icon?V=l(A.icon):Q.icon&&(V=Q.icon)}else M=Array.isArray(A.path)?A.path:[A.path],$=O.isWindows||Array.isArray(A.args)?A.args:void 0,V=l(A.icon);let q;if(w){const Q=M.map(Z=>typeof Z=="string"?Z:Z.path),Y=await w(Q);q=new Array(M.length);for(let Z=0;Z<M.length;Z++)typeof M[Z]=="string"?q[Z]=Y[Z]:q[Z]={path:Y[Z],isUnsafe:!0}}else q=M.slice();let W;if(A.requiresPath){let Q;if((0,T.isString)(A.requiresPath)?Q=A.requiresPath:(Q=A.requiresPath.path,A.requiresPath.isUnsafe&&(W=Q)),!await r.existsFile(Q))continue}const X=await n(R,s,q,r,a,$,A.env,A.overrideName,A.isAutoDetected,W);X?(X.isAutoDetected=A.isAutoDetected,X.icon=V,X.color=A.color,v.push(X)):h?.debug("Terminal profile not validated",R,M)}return h?.debug("Validated terminal profiles",v),v}function l(t){return typeof t=="string"?{id:t}:t}async function f(t){if(b&&!t)return;const[s,r]=await Promise.all([u(),t||g()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:s,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:r,icon:N.Codicon.terminalPowershell})}async function u(){const t=new Set,s=await(0,S.findExecutable)("git.exe");if(s){const h=(0,P.dirname)(s);t.add((0,P.resolve)(h,"../.."))}function r(h,w){w&&h.add(w)}r(t,process.env.ProgramW6432),r(t,process.env.ProgramFiles),r(t,process.env["ProgramFiles(X86)"]),r(t,`${process.env.LocalAppData}\\Program`);const a=[];for(const h of t)a.push(`${h}\\Git\\bin\\bash.exe`,`${h}\\Git\\usr\\bin\\bash.exe`,`${h}\\usr\\bin\\bash.exe`);return a.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),a}async function g(){const t=[];for await(const s of(0,I.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function y(t,s){const r=[],a=await new Promise((v,R)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,M)=>{if(A)return R("Problem occurred when getting wsl distros");v(M)})});if(!a)return[];const h=new RegExp(/[\r?\n]/),w=a.split(h).filter(v=>v.trim().length>0&&v!=="");for(const v of w){if(v===""||v.startsWith("docker-desktop"))continue;const R=`${v} (WSL)`,A={profileName:R,path:t,args:["-d",`${v}`],isDefault:R===s,icon:k(v),isAutoDetected:!1};r.push(A)}return r}function k(t){return t.includes("Ubuntu")?N.Codicon.terminalUbuntu:t.includes("Debian")?N.Codicon.terminalDebian:N.Codicon.terminalLinux}async function i(t,s,r,a,h,w,v,R){const A=new Map;if(r){const M=(await t.readFile("/etc/shells")).toString(),$=w||M.split(`
`).filter(q=>q.trim().includes("#")&&q.trim().length>0),V=new Map;for(const q of $){let W=(0,c.basename)(q),X=V.get(W)||0;X++,X>1&&(W=`${W} (${X})`),V.set(W,X),A.set(W,{path:q,isAutoDetected:!0})}}return o(a,A),await E(A.entries(),h,t,R,s,v)}function o(t,s){if(!!t)for(const[r,a]of Object.entries(t))a===null||typeof a!="object"||!("path"in a)&&!("source"in a)?s.delete(r):(a.icon=a.icon||s.get(r)?.icon,s.set(r,a))}async function n(t,s,r,a,h,w,v,R,A,M){if(r.length===0)return Promise.resolve(void 0);const $=r.shift();if($==="")return n(t,s,r,a,h,w,v,R,A);const V=typeof $!="string"&&$.isUnsafe,q=typeof $=="string"?$:$.path,W={profileName:t,path:q,args:w,env:v,overrideName:R,isAutoDetected:A,isDefault:t===s,isUnsafePath:V,requiresUnsafePath:M};if((0,c.basename)(q)===q){const Q=h.PATH?h.PATH.split(c.delimiter):void 0,Y=await(0,S.findExecutable)(q,void 0,Q,void 0,a.existsFile);return Y?(W.path=Y,W.isFromPath=!0,W):n(t,s,r,a,h,w)}return await a.existsFile((0,c.normalize)(q))?W:n(t,s,r,a,h,w,v,R,A)}}),define(oe[253],ae([0,1,3,2,22,4,39,65,17,15,97,233,9,247,117,249,252,106]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(k){k[k.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let g=0,y=class extends N.Disposable{constructor(i,o,n,t,s,r){super(),this.C=i,this.D=o,this.F=n,this.G=t,this.H=s,this.I=r,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new L.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new L.Emitter),this.onProcessData=this.s.event,this.t=this.B(new L.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new L.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new L.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new L.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new L.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new L.Emitter),this.onProcessExit=this.z.event,(0,E.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,N.toDisposable)(()=>this.O())),this.f=this.B(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(O.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(i){return this.H.error("ptyHost was unable to resolve shell environment",i),{}}}N(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},o=(0,P.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const n=new D.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),T.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(n.onDidProcessExit(r=>{this.l.fire(r.code),this.i||(this.g<=u.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))})),this.B(new f.RemoteLoggerChannelClient(this.I,n.getChannel(p.TerminalIpcChannels.Logger)));const s=T.ProxyChannel.toService(n.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(r=>this.s.fire(r))),this.B(s.onProcessReady(r=>this.t.fire(r))),this.B(s.onProcessExit(r=>this.z.fire(r))),this.B(s.onDidChangeProperty(r=>this.y.fire(r))),this.B(s.onProcessReplay(r=>this.u.fire(r))),this.B(s.onProcessOrphanQuestion(r=>this.v.fire(r))),this.B(s.onDidRequestDetach(r=>this.w.fire(r))),[n,s]}dispose(){this.i=!0,super.dispose()}async createProcess(i,o,n,t,s,r,a,h,w,v,R){const A=setTimeout(()=>this.S(),p.HeartbeatConstants.CreateProcessTimeout),M=await this.b.createProcess(i,o,n,t,s,r,a,h,w,v,R);return clearTimeout(A),g=Math.max(g,M),M}updateTitle(i,o,n){return this.b.updateTitle(i,o,n)}updateIcon(i,o,n,t){return this.b.updateIcon(i,o,n,t)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,o){return this.b.detachFromProcess(i,o)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,o){return this.b.shutdown(i,o)}input(i,o){return this.b.input(i,o)}processBinary(i,o){return this.b.processBinary(i,o)}resize(i,o,n){return this.b.resize(i,o,n)}acknowledgeDataEvent(i,o){return this.b.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this.b.setUnicodeVersion(i,o)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,o){return this.b.installAutoReply(i,o)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,o,n,t=!1){const s=await this.c;return(0,l.detectAvailableProfiles)(o,n,t,this.F,s,void 0,this.H,this.W.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,o){return this.b.getWslPath(i,o)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this.b.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this.b.acceptDetachInstanceReply(i,o)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this.b.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this.b.refreshProperty(i,o)}async updateProperty(i,o,n){return this.b.updateProperty(i,o,n)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(i,o){return this.f.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this.f.acceptReply(i,o)}};y=ye([J(2,I.IConfigurationService),J(3,S.IEnvironmentService),J(4,m.ILogService),J(5,m.ILoggerService)],y),e.PtyHostService=y}),define(oe[76],ae([0,1,3,17,5,9]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,c.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,c.createDecorator)("sharedTunnelsService");var T;(function(E){E.Http="http",E.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=b;function m(E,l,f,u){if(f===1)return!1;if(f===2&&b(l)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(g?.length===4&&parseInt(g[1])>=18)return!1}return E<1024}e.isPortPrivileged=m;class d{constructor(l,f,u){this.remoteAddress=l,this.localAddress=f,this.b=u,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let p=class{constructor(l,f){this.i=l,this.j=f,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const l=this.j.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.e=l,l?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.f=l.elevation,this.g=l.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const l=[],f=Array.from(this.d.values());for(const u of f){const g=Array.from(u.values());for(const y of g){const k=await y.value;k&&l.push(k)}}return l}async dispose(){for(const l of this.d.values()){for(const{value:f}of l.values())await f.then(u=>u?.dispose());l.clear()}this.d.clear()}setEnvironmentTunnel(l,f,u,g,y){this.o(l,f,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:f,localAddress:u,privacy:g,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,f){(b(l)||P(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const u=this.q(l,f);if(u)return++u.refcount,u.value}openTunnel(l,f,u,g,y,k=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${u} on local port ${y}.`),!l)return;if(f||(f="localhost"),g||(g=this.k),this.e&&this.h.has(u)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(l,f,u,g,y,k,i,o);return n?n.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,u);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==f||t.tunnelRemotePort!==u)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const f=this.d.get(l.tunnelRemoteHost);if(f){const u=f.get(l.tunnelRemotePort);u&&(u.refcount--,await this.n(l.tunnelRemoteHost,l.tunnelRemotePort,u))}}}}async n(l,f,u){if(u.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${f}.`);const g=u.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(l)&&this.d.get(l).delete(f),g}}async closeTunnel(l,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${f} `);const u=this.d.get(l);if(u&&u.has(f)){const g=u.get(f);g.refcount=0,await this.n(l,f,g)}}o(l,f,u){this.d.has(l)||this.d.set(l,new Map),this.d.get(l).set(f,{refcount:1,value:u})}async p(l,f){const u=this.d.get(l);u&&(await u.get(f)||u.delete(f),u.size===0&&this.d.delete(l))}q(l,f){const u=[l];P(l)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):b(l)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const g=u.map(y=>this.d.get(y));for(const y of g){const k=y?.get(f);if(k)return k}}canTunnel(l){return!!S(l)}s(l,f,u,g,y,k,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${u} on local port ${g}.`);const o=u;this.h.add(o);const n=g===void 0?u:g,t={elevationRequired:y?this.isPortPrivileged(n):!1},s={remoteAddress:{host:f,port:u},localAddressPort:g,privacy:k,public:k?k!==D.Private:void 0,protocol:i},r=l.forwardPort(s,t);return r?(this.o(f,u,r),r.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),r}};p=ye([J(0,O.ILogService),J(1,N.IConfigurationService)],p),e.AbstractTunnelService=p}),define(oe[254],ae([0,1,9,76,2,10,6]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class D extends c.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let I=class Pt extends c.Disposable{constructor(P,b){super(),this.f=P,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Pt.a)}}async startTunnel(P,b,m,d,p,E,l){const f=new D,u=await Promise.resolve(this.f.openTunnel(P,f,m,d,p,E,l));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${d} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),f.dispose(),await u.dispose(),(0,O.canceled)();return f.setTunnel(u),this.b.set(b,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${m}:${d} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(P,b){const m=this.b.get(P);!m||m.setAddress(b)}async destroyTunnel(P){const b=this.b.get(P);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await b.dispose();return}this.c.add(P)}};I.a=0,I=ye([J(0,N.ISharedTunnelsService),J(1,L.ILogService)],I),e.SharedProcessTunnelService=I}),define(oe[255],ae([0,1,86,34,136,227,6,2,17,9,26,225,76,111,4]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(y,k,i,o,n){let t;for(let s=3;s&&(t?.dispose(),t=await new l(y,k,i,o,n).waitForReady(),!(n&&c.BROWSER_RESTRICTED_PORTS[n]||!c.BROWSER_RESTRICTED_PORTS[t.tunnelLocalPort]));s--);return t}class l extends D.Disposable{constructor(k,i,o,n,t){super(),this.j=i,this.k=t,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=k,this.b=L.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const k=this.k??this.tunnelRemotePort,i=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,c.findFreePortFaster)(k,2,1e3,i),n=null;return this.b.listen(o,this.j),await this.c.wait(),n=this.b.address(),n||(o=0,this.b.listen(o,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(k){k.pause();const i=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,b.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=o.getSocket().socket,t=o.readEntireBuffer();o.dispose(),t.byteLength>0&&k.write(t.buffer),k.on("end",()=>{k.localAddress&&this.i.delete(k.localAddress),n.end()}),k.on("close",()=>n.end()),k.on("error",()=>{k.localAddress&&this.i.delete(k.localAddress),n.destroy()}),n.on("end",()=>k.end()),n.on("close",()=>k.end()),n.on("error",()=>{k.destroy()}),k.pipe(n),n.pipe(k),k.localAddress&&this.i.set(k.localAddress,()=>{k.end(),n.end()})}}let f=class extends m.AbstractTunnelService{constructor(k,i,o,n,t){super(i,t),this.t=k,this.u=o,this.v=n}isPortPrivileged(k){return(0,m.isPortPrivileged)(k,this.k,p.OS,N.release())}r(k,i,o,n,t,s,r,a){const h=this.q(i,o);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,i,o,t,s,r,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${t}.`);const w={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:k,signService:this.u,logService:this.i,ipcLogger:null},v=E(w,n,i,o,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,o,v),v}}};f=ye([J(1,S.ILogService),J(2,d.ISignService),J(3,P.IProductService),J(4,I.IConfigurationService)],f),e.BaseTunnelService=f;let u=class extends f{constructor(k,i,o,n){super(O.nodeSocketFactory,k,i,o,n)}};u=ye([J(0,S.ILogService),J(1,d.ISignService),J(2,P.IProductService),J(3,I.IConfigurationService)],u),e.TunnelService=u;let g=class extends D.Disposable{constructor(k,i,o,n){super(),this.b=k,this.c=i,this.f=o,this.g=n,this.a=new Map}async openTunnel(k,i,o,n,t,s,r,a,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${s}.`),!this.a.has(k)){const w=new u(this.b,this.f,this.c,this.g);this.B(w),this.a.set(k,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(k))})}return this.a.get(k).openTunnel(i,o,n,t,s,r,a,h)}};g=ye([J(0,S.ILogService),J(1,P.IProductService),J(2,d.ISignService),J(3,I.IConfigurationService)],g),e.SharedTunnelsService=g}),define(oe[30],ae([0,1,5]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(oe[256],ae([0,1,30,199,13,23,132,3,2]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(m){this.uri=m,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let P=class{constructor(m){this.g=m,this.c=new I.DisposableStore,this.f=2**16;const d=new Map,p=E=>{let l=d.get(E.scheme);return l===void 0&&(l=m.hasProvider(E)&&!this.g.hasCapability(E,1024),d.set(E.scheme,l)),l};this.c.add(D.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(E=>{d.delete(E.scheme)})),this.extUri=new O.ExtUri(p),this.d=new T.SkipList((E,l)=>this.extUri.compare(E,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,O.normalizePath)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new S(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((p,E)=>p[1].time<E[1].time?1:p[1].time>E[1].time?-1:0);S._clock=0,this.d.clear();const d=this.f*.5;for(let p=0;p<d;p++)this.d.set(m[p][0],m[p][1].touch())}};P=ye([J(0,c.IFileService)],P),e.UriIdentityService=P,(0,N.registerSingleton)(L.IUriIdentityService,P,1)}),define(oe[257],ae([0,1,3,2,13,43,48,16]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends N.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,b,m,d){super(),this.c=P,this.f=b,this.g=m,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(p=>this.i(p)))}watch(P,b){this.b.set(P,P);const m=this.f.watch(this.j(P),b);return(0,N.toDisposable)(()=>{this.b.delete(P),m.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,b,m){return this.f.rename(this.j(P),this.j(b),m)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,b,m){const d=(0,O.newWriteableStream)(p=>D.VSBuffer.concat(p.map(E=>D.VSBuffer.wrap(E))).buffer);return(async()=>{try{const p=await this.readFile(P);d.end(p)}catch(p){d.error(p),d.end()}})(),d}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,b,m){return this.f.writeFile(this.j(P),b,m)}delete(P,b){return this.f.delete(this.j(P),b)}copy(P,b,m){if((0,c.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(b),m);throw new Error("copy not supported")}i(P){const b=[];for(const m of P){if(m.resource.scheme!==this.c)continue;const d=this.k(m.resource);this.b.findSubstr(d)&&b.push({resource:d,type:m.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[60],ae([0,1,83]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function N(T,D,I,S){const P=(0,L.setProperty)(T,D,I,S)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=N;function c(T,D,I){let S=I;for(;S>=0;){if(T.charAt(S)===D.charAt(D.length-1)&&D.length===1)return S+1;if(S--,D.length===2&&S>=0&&T.charAt(S)===D.charAt(0))return S+2}return 0}e.getLineStartOffset=c;function O(T,D,I){let S=I;for(;S>=0;)if(T.charAt(S)===D.charAt(D.length-1)&&D.length===1||(S++,D.length===2&&S>=0&&T.charAt(S)===D.charAt(1)))return S;return T.length-1}e.getLineEndOffset=O}),define(oe[258],ae([0,1,32,55,11]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(d,p,E,l,f,u){const g=[],y=[],k=[];if(!p){const q=d.filter(({identifier:W})=>f.every(X=>X.toLowerCase()!==W.id.toLowerCase()));return{local:{added:g,removed:y,updated:k},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}d=d.map(b),p=p.map(b),E=E?E.map(b):null;const i=new Map,o=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};d.forEach(({identifier:q})=>o(q)),p.forEach(({identifier:q})=>o(q)),E?.forEach(({identifier:q})=>o(q));const n=q=>{const W=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${q.identifier.id.toLowerCase()}`},t=(q,W)=>(q.set(n(W),W),q),s=d.reduce(t,new Map),r=p.reduce(t,new Map),a=p.reduce((q,W)=>t(q,(0,L.deepClone)(W)),new Map),h=E?E.reduce(t,new Map):null,w=l.reduce(t,new Map),v=f.reduce((q,W)=>{const X=i.get(W.toLowerCase());return q.add(X?`uuid:${X}`:`id:${W.toLowerCase()}`)},new Set),R=u?u.reduce((q,{id:W,uuid:X})=>(X=X??i.get(W.toLowerCase()),q.add(X?`uuid:${X}`:`id:${W.toLowerCase()}`)),new Set):null,A=T(s,r,v,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const q=T(h,s,v,!1),W=T(h,r,v,!0),X=(Q,Y,Z,x)=>{let j,ee,ne;return Y.installed?(j=x.pinned,ne=x.preRelease,j&&(ee=x.version)):(j=Z.pinned,ne=Z.preRelease,j&&(ee=Z.version)),j===void 0&&(j=Y.pinned,j&&(ee=Y.version)),ne===void 0&&(ne=Y.preRelease),{...x,installed:Y.installed||Z.installed,pinned:j,preRelease:ne,version:ee??(Z.version&&(!Y.installed||N.gt(Z.version,Y.version))?Z.version:Y.version),state:I(Y,Z,h?.get(Q))}};for(const Q of W.removed.values()){const Y=s.get(Q);if(!Y)continue;const Z=(0,c.assertIsDefined)(h?.get(Q)),x=R&&!R.has(Q)&&Z.installed;Y.installed&&x?y.push(Y.identifier):a.set(Q,Y)}for(const Q of W.added.values()){const Y=(0,c.assertIsDefined)(r.get(Q)),Z=s.get(Q);if(Z){if(A.updated.has(Q)){const x=X(Q,Z,Y,Y);D(Z,Y,!1,!1)||k.push(m(x,Q)),a.set(Q,x)}}else Y.installed&&g.push(m(Y,Q))}for(const Q of W.updated.values()){const Y=(0,c.assertIsDefined)(r.get(Q)),Z=(0,c.assertIsDefined)(h?.get(Q)),x=s.get(Q);if(x)if(R&&!R.has(Q)&&Z.installed&&x.installed&&!Y.installed)y.push(x.identifier);else{const ee=X(Q,x,Y,Y);k.push(m(ee,Q)),a.set(Q,ee)}else Y.installed&&g.push(m(Y,Q))}for(const Q of q.added.values())W.added.has(Q)||a.set(Q,(0,c.assertIsDefined)(s.get(Q)));for(const Q of q.updated.values()){if(W.removed.has(Q)||W.updated.has(Q))continue;const Y=(0,c.assertIsDefined)(s.get(Q)),Z=(0,c.assertIsDefined)(r.get(Q));a.set(Q,X(Q,Y,Z,Y))}for(const Q of q.removed.values())W.updated.has(Q)||W.removed.has(Q)||w.has(Q)||!(0,c.assertIsDefined)(r.get(Q)).installed||!R||R.has(Q)||!(0,c.assertIsDefined)(h?.get(Q)).installed||a.delete(Q)}const M=[],$=T(r,a,new Set,!0),V=$.added.size>0||$.updated.size>0||$.removed.size>0;return V&&a.forEach((q,W)=>M.push(m(q,W))),{local:{added:g,removed:y,updated:k},remote:V?{added:[...$.added].map(q=>a.get(q)),updated:[...$.updated].map(q=>a.get(q)),removed:[...$.removed].map(q=>r.get(q)),all:M}:null}}e.merge=O;function T(d,p,E,l){const f=d?[...d.keys()].filter(i=>!E.has(i)):[],u=[...p.keys()].filter(i=>!E.has(i)),g=u.filter(i=>f.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),y=f.filter(i=>u.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),k=new Set;for(const i of f){if(y.has(i))continue;const o=d.get(i),n=p.get(i);(!n||!D(o,n,l,!0))&&k.add(i)}return{added:g,removed:y,updated:k}}function D(d,p,E,l){return!(d.disabled!==p.disabled||l&&d.installed!==p.installed||d.installed&&p.installed&&(d.preRelease!==p.preRelease||d.pinned!==p.pinned||p.pinned&&d.version!==p.version)||!P(d.state,p.state)||E&&d.version!==p.version)}function I(d,p,E){const l=d.state,f=p.state,u=E?.state;if(!p.version||l&&N.gt(d.version,p.version))return l;if(f&&N.gt(p.version,d.version)||!l)return f;if(!f)return l;const g=(0,L.deepClone)(l),y=u?S(u,f):{added:Object.keys(f).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},k=u?S(u,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...y.added.values(),...y.updated.values()])g[i]=f[i];for(const i of y.removed.values())k.updated.has(i)||delete g[i];return g}function S(d,p){const E=Object.keys(d),l=Object.keys(p),f=l.filter(y=>E.indexOf(y)===-1).reduce((y,k)=>(y.add(k),y),new Set),u=E.filter(y=>l.indexOf(y)===-1).reduce((y,k)=>(y.add(k),y),new Set),g=new Set;for(const y of E){if(u.has(y))continue;const k=d[y],i=p[y];(0,L.equals)(k,i)||g.add(y)}return{added:f,removed:u,updated:g}}function P(d={},p={}){const{added:E,removed:l,updated:f}=S(d,p);return E.size===0&&l.size===0&&f.size===0}function b(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function m(d,p){const E={identifier:{id:d.identifier.id,uuid:p.startsWith("uuid:")?p.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(E.disabled=!0),d.installed&&(E.installed=!0),d.state&&(E.state=d.state),E}}),define(oe[118],ae([0,1,21,17,5]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,c.createDecorator)("IIgnoredExtensionsManagementService");let O=class{constructor(D){this.a=D}hasToNeverSyncExtension(D){return this.b().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.b().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==D&&P!==`-${D}`),I&&S.push(D.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(D,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==D&&P!==`-${D}`),I&&S.push(`-${D.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(D){const I=D.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.b().map(m=>m.toLowerCase()),P=[],b=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?b.push(m.substring(1)):P.push(m);return(0,L.distinct)([...I,...P].filter(m=>b.indexOf(m)===-1))}b(){let D=this.a.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.a.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};O=ye([J(0,N.IConfigurationService)],O),e.IgnoredExtensionsManagementService=O}),define(oe[259],ae([0,1,21,35,32,69,60]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(y){return(0,N.parse)(y)||[]}async function I(y,k,i,o,n){const t=D(y),s=D(k),r=i?D(i):null,a=[...t,...s,...r||[]].map(X=>X.key),h=await n.resolveUserBindings(a),w=P(t,s,r,h);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const v=m(t),R=m(s),A=r?m(r):null,M=p(v,R,h),$=A?p(A,v,h):{added:[...v.keys()].reduce((X,Q)=>(X.add(Q),X),new Set),removed:new Set,updated:new Set},V=A?p(A,R,h):{added:[...R.keys()].reduce((X,Q)=>(X.add(Q),X),new Set),removed:new Set,updated:new Set},q=S(M,$,V);let W=y;for(const X of q.removed.values())q.conflicts.has(X)||(W=u(W,X,o));for(const X of q.added.values()){if(q.conflicts.has(X))continue;const Q=R.get(X);if(Q.some(Y=>Y.command!==`-${X}`&&w.conflicts.has(h[Y.key]))){q.conflicts.add(X);continue}W=f(W,Q,o)}for(const X of q.updated.values()){if(q.conflicts.has(X))continue;const Q=R.get(X);if(Q.some(Y=>Y.command!==`-${X}`&&w.conflicts.has(h[Y.key]))){q.conflicts.add(X);continue}W=g(W,X,Q,o)}return{mergeContent:W,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=I;function S(y,k,i){const o=new Set,n=new Set,t=new Set,s=new Set;for(const r of k.removed.values())i.updated.has(r)&&s.add(r);for(const r of i.removed.values())s.has(r)||(k.updated.has(r)?s.add(r):n.add(r));for(const r of k.added.values())s.has(r)||i.added.has(r)&&y.updated.has(r)&&s.add(r);for(const r of i.added.values())s.has(r)||(k.added.has(r)?y.updated.has(r)&&s.add(r):o.add(r));for(const r of k.updated.values())s.has(r)||i.updated.has(r)&&y.updated.has(r)&&s.add(r);for(const r of i.updated.values())s.has(r)||(k.updated.has(r)?y.updated.has(r)&&s.add(r):t.add(r));return{added:o,removed:n,updated:t,conflicts:s}}function P(y,k,i,o){const n=new Set,t=b(y,o),s=b(k,o),r=i?b(i,o):null,a=d(t,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=r?d(r,t):{added:[...t.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?d(r,s):{added:[...s.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:R,updated:A,conflicts:M}=S(a,h,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:R,updated:A,conflicts:M}}function b(y,k){const i=new Map;for(const o of y){const n=k[o.key];let t=i.get(n);t||(t=[],i.set(n,t)),t.push(o)}return i}function m(y){const k=new Map;for(const i of y){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=k.get(o);n||(n=[],k.set(o,n)),n.push(i)}return k}function d(y,k){const i=[...y.keys()],o=[...k.keys()],n=o.filter(r=>i.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),t=i.filter(r=>o.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),s=new Set;for(const r of i){if(t.has(r))continue;const a=y.get(r).map(w=>({...w,key:r})),h=k.get(r).map(w=>({...w,key:r}));(0,L.equals)(a,h,(w,v)=>l(w,v))||s.add(r)}return{added:n,removed:t,updated:s}}function p(y,k,i){const o=[...y.keys()],n=[...k.keys()],t=n.filter(a=>o.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),s=o.filter(a=>n.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),r=new Set;for(const a of o){if(s.has(a))continue;const h=y.get(a).map(v=>({...v,key:i[v.key]})),w=k.get(a).map(v=>({...v,key:i[v.key]}));E(h,w)||r.add(a)}return{added:t,removed:s,updated:r}}function E(y,k){return!(!(0,L.equals)(y.filter(({command:i})=>i[0]!=="-"),k.filter(({command:i})=>i[0]!=="-"),(i,o)=>l(i,o))||!(0,L.equals)(y.filter(({command:i})=>i[0]==="-"),k.filter(({command:i})=>i[0]==="-"),(i,o)=>l(i,o)))}function l(y,k){if(y.command!==k.command||y.key!==k.key)return!1;const i=O.ContextKeyExpr.deserialize(y.when),o=O.ContextKeyExpr.deserialize(k.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!c.equals(y.args,k.args))}function f(y,k,i){for(const o of k)y=T.edit(y,[-1],o,i);return y}function u(y,k,i){const o=D(y);for(let n=o.length-1;n>=0;n--)(o[n].command===k||o[n].command===`-${k}`)&&(y=T.edit(y,[n],void 0,i));return y}function g(y,k,i,o){const n=D(y),t=n.findIndex(s=>s.command===k||s.command===`-${k}`);for(let s=n.length-1;s>=0;s--)(n[s].command===k||n[s].command===`-${k}`)&&(y=T.edit(y,[s],void 0,o));for(let s=i.length-1;s>=0;s--)y=T.edit(y,[t],i[s],o);return y}}),define(oe[260],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(O,T,D){const I={},S={},P=new Set;if(!T)return{local:{added:I,updated:S,removed:[...P.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const b=N(O,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:S,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=N(D,O),d=N(D,T),p={},E={},l=new Set,f=new Set;for(const u of m.removed.values())d.updated.has(u)?I[u]=T[u]:l.add(u);for(const u of d.removed.values())f.has(u)||(m.updated.has(u)?f.add(u):P.add(u));for(const u of m.updated.values())f.has(u)||(d.updated.has(u)?b.updated.has(u)&&f.add(u):E[u]=O[u]);for(const u of d.updated.values())f.has(u)||(m.updated.has(u)?b.updated.has(u)&&f.add(u):O[u]!==void 0&&(S[u]=T[u]));for(const u of m.added.values())f.has(u)||(d.added.has(u)?b.updated.has(u)&&f.add(u):p[u]=O[u]);for(const u of d.added.values())f.has(u)||(m.added.has(u)?b.updated.has(u)&&f.add(u):I[u]=T[u]);return{local:{added:I,removed:[...P.values()],updated:S},remote:{added:p,removed:[...l.values()],updated:E},conflicts:[...f.values()]}}e.merge=L;function N(O,T){const D=O?Object.keys(O):[],I=T?Object.keys(T):[],S=I.filter(m=>D.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),P=D.filter(m=>I.indexOf(m)===-1).reduce((m,d)=>(m.add(d),m),new Set),b=new Set;for(const m of D){if(P.has(m))continue;const d=O[m],p=T[m];d!==p&&b.add(m)}return{added:S,removed:P,updated:b}}function c(O,T){const{added:D,removed:I,updated:S}=N(O,T);return D.size===0&&I.size===0&&S.size===0}e.areSame=c}),define(oe[261],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(c,O,T,D){const I={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!O){const b=c.filter(({id:m})=>!D.includes(m));return b.length?S.added=b:S=null,{local:I,remote:S}}const P=N(c,O,D);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const b=N(T,c,D),m=N(T,O,D);for(const d of m.removed){const p=c.find(E=>E.id===d);p&&I.removed.push(p)}for(const d of m.added){const p=O.find(E=>E.id===d);b.added.includes(d)?P.updated.includes(d)&&I.updated.push(p):I.added.push(p)}for(const d of m.updated)I.updated.push(O.find(p=>p.id===d));for(const d of b.added)m.added.includes(d)||S.added.push(c.find(p=>p.id===d));for(const d of b.updated)m.removed.includes(d)||m.updated.includes(d)||S.updated.push(c.find(p=>p.id===d));for(const d of b.removed){const p=O.find(E=>E.id===d);p&&S.removed.push(p)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:I,remote:S}}e.merge=L;function N(c,O,T){c=c?c.filter(({id:m})=>!T.includes(m)):[],O=O.filter(({id:m})=>!T.includes(m));const D=c.map(({id:m})=>m),I=O.map(({id:m})=>m),S=I.filter(m=>D.indexOf(m)===-1),P=D.filter(m=>I.indexOf(m)===-1),b=[];for(const{id:m,name:d,shortName:p}of c){if(P.includes(m))continue;const E=O.find(l=>l.id===m);(!E||E.name!==d||E.shortName!==p)&&b.push(m)}return{added:S,removed:P,updated:b}}}),define(oe[24],ae([0,1,21,11,186,45,29,5,108,40]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=S.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(r=>!!s[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function b(){const s=S.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(s).filter(w=>!!s[w].ignoreSync),a=Object.keys(s).filter(w=>s[w].scope===2||s[w].scope===6),h=P();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...r,...a,...h])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const s="vscode://schemas/ignoredSettings",r=S.Registry.as(O.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,c.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,c.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,c.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,c.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,c.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(I.Extensions.JSONContribution),h=()=>{const w=P(),v=b().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),R=Object.keys(O.allSettings.properties).filter($=>v.indexOf($)===-1),A=v.filter($=>w.indexOf($)===-1),M={items:{type:"string",enum:[...R,...A.map($=>`-${$}`)]}};a.registerSchema(s,M)};return r.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=m;function d(s){return s&&(0,N.isObject)(s)&&(0,N.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=d;var p;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...r){return s?[s,...r]:r}e.getPathSegments=E;function l(s,r,a,h){return h.joinPath(a.userDataSyncHome,...E(s,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=l,e.IUserDataSyncStoreManagementService=(0,D.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,D.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,D.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function f(s){const r={};return r[e.HEADER_EXECUTION_ID]=s,r}e.createSyncHeaders=f;var u;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(u=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(r,a,h,w){super(r),this.code=a,this.resource=h,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class y extends g{constructor(r,a,h,w,v){super(r,h,void 0,v),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=y;class k extends g{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=k,function(s){function r(a){if(a instanceof s)return a;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(h&&h[1]){const w=h[2]==="unknown"?void 0:h[2],v=h[3]==="unknown"?void 0:h[3];return new s(a.message,h[1],w,v)}return new s(a.message,"Unknown")}s.toUserDataSyncError=r}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var n;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,D.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,D.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,D.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,D.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,D.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,D.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[262],ae([0,1,32,24]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function c(T,D,I,S,P){if(!D)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const b=O(T,D);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=I?O(I,D):{added:Object.keys(D).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},d=I?O(I,T):{added:Object.keys(T).reduce((u,g)=>(u.add(g),u),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},E=L.deepClone(D),l=!I;for(const u of d.added.values())u!==N.SYNC_SERVICE_URL_TYPE&&l&&m.added.has(u)||(E[u]=T[u]);for(const u of d.updated.values())E[u]=T[u];for(const u of d.removed.values())S.unregistered.includes(u)||delete E[u];for(const u of m.added.values()){const g=D[u];if(S.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(u))continue;const y=T[u];y&&y.value===g.value||u===N.SYNC_SERVICE_URL_TYPE&&l&&d.added.has(u)||(y?p.updated[u]=g:p.added[u]=g)}for(const u of m.updated.values()){const g=D[u];if(S.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(u)||d.removed.has(u))continue;const y=T[u];y&&y.value===g.value||(p.updated[u]=g)}for(const u of m.removed.values()){if(S.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}d.updated.has(u)||d.removed.has(u)||p.removed.push(u)}const f=O(D,E);return{local:p,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:E}}}e.merge=c;function O(T,D){const I=Object.keys(T),S=Object.keys(D),P=S.filter(d=>I.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),b=I.filter(d=>S.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),m=new Set;for(const d of I){if(b.has(d))continue;const p=T[d],E=D[d];L.equals(p,E)||m.add(d)}return{added:P,removed:b,updated:m}}}),define(oe[263],ae([0,1,21,35,83,42,32,60,24]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,h,w){let v=[];w?v=b(w):v=P(h);const R=[],A=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const M of v)M.startsWith("-")?A.push(M.substring(1)):R.push(M);return(0,L.distinct)([...a,...R].filter(M=>A.indexOf(M)===-1))}e.getIgnoredSettings=S;function P(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const h=(0,N.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(a,h){const w=(0,N.parse)(a)||{};let v="{}";for(const R of Object.keys(w)){const A=(0,c.setProperty)(v,[R],w[R],h);v=(0,c.applyEdits)(v,A)}return v}e.removeComments=m;function d(a,h,w,v){if(w.length){const R=r(h),A=(0,N.parse)(h)||{},M=(0,N.parse)(a);if(!M)return a;const $=[];for(const V of w){const q=A[V],W=M[V];q===void 0?a=D.edit(a,[V],void 0,v):W!==void 0?a=D.edit(a,[V],q,v):$.push(i(V,R))}$.sort((V,q)=>V.startOffset-q.startOffset),$.forEach(V=>a=u(V.setting.key,h,a,v))}return a}e.updateIgnoredSettings=d;function p(a,h,w,v,R,A){const M=d(a,h,v,A),$=w!==M,V=w!==h;if(!$&&!V)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!V)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(V&&!$)return{conflictsSettings:[],localContent:d(h,a,v,A),remoteContent:null,hasConflicts:!1};if(w===null&&l(a)){const U=E(a,h,v)?null:d(h,a,v,A);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let q=a,W=h;const X=(0,N.parse)(a),Q=(0,N.parse)(h),Y=w?(0,N.parse)(w):null,Z=v.reduce((U,z)=>(U.add(z),U),new Set),x=f(X,Q,Z),j=f(Y,X,Z),ee=f(Y,Q,Z),ne=new Map,re=new Set,G=U=>{re.add(U);const z=R.filter(({key:K})=>K===U)[0];z?(q=D.edit(q,[U],z.value,A),W=D.edit(W,[U],z.value,A)):ne.set(U,{key:U,localValue:X[U],remoteValue:Q[U]})};for(const U of j.removed.values())ee.updated.has(U)?G(U):W=D.edit(W,[U],void 0,A);for(const U of ee.removed.values())re.has(U)||(j.updated.has(U)?G(U):q=D.edit(q,[U],void 0,A));for(const U of j.updated.values())re.has(U)||(ee.updated.has(U)?x.updated.has(U)&&G(U):W=D.edit(W,[U],X[U],A));for(const U of ee.updated.values())re.has(U)||(j.updated.has(U)?x.updated.has(U)&&G(U):q=D.edit(q,[U],Q[U],A));for(const U of j.added.values())re.has(U)||(ee.added.has(U)?x.updated.has(U)&&G(U):W=u(U,q,W,A));for(const U of ee.added.values())re.has(U)||(j.added.has(U)?x.updated.has(U)&&G(U):q=u(U,W,q,A));const H=ne.size>0||!E(q,W,v),F=H||!E(q,a,[]),C=H||!E(W,h,[]);return{localContent:F?q:null,remoteContent:C?W:null,conflictsSettings:[...ne.values()],hasConflicts:H}}e.merge=p;function E(a,h,w){if(a===h)return!0;const v=(0,N.parse)(a),R=(0,N.parse)(h),A=w.reduce((V,q)=>(V.add(q),V),new Set),M=r(a).filter(V=>!(V.setting&&A.has(V.setting.key))),$=r(h).filter(V=>!(V.setting&&A.has(V.setting.key)));if(M.length!==$.length)return!1;for(let V=0;V<M.length;V++){const q=M[V],W=$[V];if(q.setting&&W.setting){if(q.setting.key!==W.setting.key||!T.equals(v[q.setting.key],R[q.setting.key]))return!1}else if(!q.setting&&!W.setting){if(q.value!==W.value)return!1}else return!1}return!0}function l(a){return a?r(a).length===0:!0}e.isEmpty=l;function f(a,h,w){const v=a?Object.keys(a).filter(V=>!w.has(V)):[],R=Object.keys(h).filter(V=>!w.has(V)),A=R.filter(V=>v.indexOf(V)===-1).reduce((V,q)=>(V.add(q),V),new Set),M=v.filter(V=>R.indexOf(V)===-1).reduce((V,q)=>(V.add(q),V),new Set),$=new Set;if(a)for(const V of v){if(M.has(V))continue;const q=a[V],W=h[V];T.equals(q,W)||$.add(V)}return{added:A,removed:M,updated:$}}function u(a,h,w,v){const R=(0,N.parse)(h),A=r(h),M=r(w),$=g(a,A,M);return y(w,a,R[a],$,M,v)}e.addSetting=u;function g(a,h,w){const v=h.findIndex(A=>A.setting?.key===a),R=h[v-1];if(R){if(R.setting){const M=i(R.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=o(v,h);if(M){const $=i(M.setting.key,w);if($){const V=n(w.indexOf($),w),q=t(h,M,h[v]);if(V){const W=t(w,$,V),X=s(q,W);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.indexOf(V),insertAfter:!1}}else{const W=t(w,$,w[w.length-1]),X=s(q,W);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const A=h[v+1];if(A)if(A.setting){const M=i(A.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=n(v,h);if(M){const $=i(M.setting.key,w);if($){const V=o(w.indexOf($),w),q=t(h,h[v],M);if(V){const W=t(w,V,$),X=s(q.reverse(),W.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:w.indexOf(V),insertAfter:!0}}else{const W=t(w,w[0],$),X=s(q.reverse(),W.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function y(a,h,w,v,R,A){let M;return v.index===-1?M=(0,c.setProperty)(a,[h],w,A):M=k(a,h,w,v,R,A).map($=>(0,c.withFormatting)(a,$,A)[0]),(0,c.applyEdits)(a,M)}function k(a,h,w,v,R,A){const M=`${JSON.stringify(h)}: ${JSON.stringify(w)}`,$=(0,O.getEOL)(A,a),V=R[v.index];if(v.insertAfter){const q=[];if(V.setting)q.push({offset:V.endOffset,length:0,content:","+M});else{const W=n(v.index,R),X=o(v.index,R),Q=X?.setting?.commaOffset;X&&Q===void 0&&q.push({offset:X.endOffset,length:0,content:","});const Y=Q!==void 0&&Q>V.endOffset;q.push({offset:Y?Q+1:V.endOffset,length:0,content:W?$+M+",":$+M})}return q}else{if(V.setting)return[{offset:V.startOffset,length:0,content:M+","}];const q=(R[v.index-1]&&!R[v.index-1].setting?$:"")+M+(n(v.index,R)?",":"")+$;return[{offset:V.startOffset,length:0,content:q}]}}function i(a,h){return h.filter(w=>w.setting?.key===a)[0]}function o(a,h){for(let w=a-1;w>=0;w--)if(h[w].setting)return h[w]}function n(a,h){for(let w=a+1;w<h.length;w++)if(h[w].setting)return h[w]}function t(a,h,w){const v=a.indexOf(h),R=a.indexOf(w);return a.filter((A,M)=>v<M&&M<R)}function s(a,h){if(a.length&&h.length){let w=0;for(;w<h.length&&w<a.length;w++)if(a[w].value!==h[w].value)return h[w-1];return h[w-1]}}function r(a){const h=[];let w=-1,v,R;const A={onObjectBegin:M=>{w++},onObjectProperty:(M,$,V)=>{w===0&&(v=$,R=M)},onObjectEnd:(M,$)=>{w--,w===0&&h.push({startOffset:v,endOffset:M+$,value:a.substring(v,M+$),setting:{key:R,commaOffset:void 0}})},onArrayBegin:(M,$)=>{w++},onArrayEnd:(M,$)=>{w--,w===0&&h.push({startOffset:v,endOffset:M+$,value:a.substring(v,M+$),setting:{key:R,commaOffset:void 0}})},onLiteralValue:(M,$,V)=>{w===0&&h.push({startOffset:v,endOffset:$+V,value:a.substring(v,$+V),setting:{key:R,commaOffset:void 0}})},onSeparator:(M,$,V)=>{if(w===0&&M===","){let q=h.length-1;for(;q>=0&&!h[q].setting;q--);const W=h[q];W&&h.splice(q,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:$}})}},onComment:(M,$)=>{w===0&&h.push({startOffset:M,endOffset:M+$,value:a.substring(M,M+$)})}};return(0,N.visit)(a,A),h}}),define(oe[77],ae([0,1,3,2,5,24]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,c.createDecorator)("IUserDataSyncAccountService");let T=class extends N.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};T=ye([J(0,O.IUserDataSyncStoreService),J(1,O.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(oe[264],ae([0,1,2,12]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class c{constructor(m){this.a=m}listen(m,d){switch(d){case"onError":return this.a.onError}throw new Error(`Event not found: ${d}`)}call(m,d,p){switch(d){case"triggerSync":return this.a.triggerSync(p[0],p[1],p[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(p[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=c;class O{constructor(m){this.a=m}listen(m,d){throw new Error(`Event not found: ${d}`)}call(m,d,p){switch(d){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(p[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(p[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=O;class T{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class D{constructor(m){this.a=m}listen(m,d){switch(d){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${d}`)}async call(m,d,p){switch(d){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(p[0],p[1]);case"setEnablements":return this.a.setEnablements(p)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class I{constructor(m){this.a=m}listen(m,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(m,d,p){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(p)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(m){this.a=m}listen(m,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(m,d,p){switch(d){case"switch":return this.a.switch(p[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class P extends L.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:N.URI.revive(m.url),type:m.type,defaultUrl:N.URI.revive(m.defaultUrl),insidersUrl:N.URI.revive(m.insidersUrl),stableUrl:N.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(oe[265],ae([0,1,187,9,24]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends N.AbstractLogger{constructor(D){super(),this.g=this.B(D.createLogger(c.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(D,...I){this.g.trace(D,...I)}debug(D,...I){this.g.debug(D,...I)}info(D,...I){this.g.info(D,...I)}warn(D,...I){this.g.warn(D,...I)}error(D,...I){this.g.error(D,...I)}flush(){this.g.flush()}};O=ye([J(0,N.ILoggerService)],O),e.UserDataSyncLogService=O}),define(oe[266],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(oe[267],ae([0,1,6,3,2]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends c.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new c.DisposableStore),N.Event.latch(N.Event.any(D,I))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(D){this.b&&(this.b.cancel(),this.b=void 0),this.c=D}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=O}),define(oe[119],ae([0,1,190,14,48,23,12,5,22]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function S(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function P(t){return typeof t?.id=="string"&&!S(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,N.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=b;function m(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=m;function d(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=d;var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function E(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function l(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=l;class f{constructor(s,r,a,h,w){this.h=s,this.j=a,this.k=h,this.l=w,this.c=c.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=c.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class u{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function g(t){return new u({uri:t,index:0,name:(0,O.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(t,s){return O.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function k(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=k,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(t,s){return!y(t,s)&&!k(t)}e.isSavedWorkspace=o;function n(t){return(typeof t=="string"?(0,N.extname)(t):(0,O.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[18],ae([0,1,53,3,2,23,12,181,15,13,5,9,119,37,30,6,31,27,11]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&T.URI.isUri(t.location)&&T.URI.isUri(t.globalStorageHome)&&T.URI.isUri(t.settingsResource)&&T.URI.isUri(t.keybindingsResource)&&T.URI.isUri(t.tasksResource)&&T.URI.isUri(t.snippetsHome)&&T.URI.isUri(t.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function y(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:T.URI.revive(n.location).with({scheme:t}),globalStorageHome:T.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:T.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:T.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:T.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:T.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:T.URI.revive(n.extensionsResource).with({scheme:t}),cacheHome:T.URI.revive(n.cacheHome).with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=y;function k(n,t,s,r,a){return{id:n,name:t,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,O.joinPath)(s,"globalStorage"),settingsResource:(0,O.joinPath)(s,"settings.json"),keybindingsResource:(0,O.joinPath)(s,"keybindings.json"),tasksResource:(0,O.joinPath)(s,"tasks.json"),snippetsHome:(0,O.joinPath)(s,"snippets"),extensionsResource:(0,O.joinPath)(s,"extensions.json"),cacheHome:(0,O.joinPath)(r,n),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=k;let i=class extends c.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(t,s,r,a){super(),this.n=t,this.r=s,this.s=r,this.t=a,this.f=!0,this.h=this.B(new N.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,O.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(t){this.f!==t&&(this.u=void 0,this.f=t)}isEnabled(){return this.f}get v(){if(!this.u){const t=[];if(this.f)try{for(const h of this.J()){if(!h.name||!(0,u.isString)(h.name)||!h.location){this.t.warn("Skipping the invalid stored profile",h.location||h.name);continue}t.push(k((0,O.basename)(h.location),h.name,h.location,this.g,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.t.error(h)}const s=new d.ResourceMap,r=new Map,a=this.w();if(t.unshift({...a,extensionsResource:this.O()??a.extensionsResource,isDefault:!0}),t.length)try{const h=this.M();if(h.workspaces)for(const[w,v]of Object.entries(h.workspaces)){const R=T.URI.parse(w),A=t.find(M=>M.id===v);A&&s.set(R,A)}if(h.emptyWindows)for(const[w,v]of Object.entries(h.emptyWindows)){const R=t.find(A=>A.id===v);R&&r.set(w,R)}}catch(h){this.t.error(h)}this.u={profiles:t,workspaces:s,emptyWindows:r}}return this.u}w(){return k("__default__profile__",(0,D.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(t){const s="Temp",r=new RegExp(`${(0,f.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const v=r.exec(w.name),R=v?parseInt(v[1]):0;a=R>a?R:a}const h=`${s} ${a+1}`;return this.createProfile((0,L.hash)((0,l.generateUuid)()).toString(16),h,{transient:!0},t)}async createNamedProfile(t,s,r){return this.createProfile((0,L.hash)((0,l.generateUuid)()).toString(16),t,s,r)}async createProfile(t,s,r,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.y(t,s,r);return a&&await this.setProfileForWorkspace(a,h),h}async y(t,s,r){if(!(0,u.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.l.get(s);return a||(a=(async()=>{try{const h=this.profiles.find(R=>R.name===s||R.id===t);if(h)return h;const w=k(t,s,(0,O.joinPath)(this.profilesHome,t),this.g,r);await this.r.createFolder(w.location);const v=[];return this.i.fire({profile:w,join(R){v.push(R)}}),await E.Promises.settled(v),this.D([w],[],[]),w}finally{this.l.delete(s)}})(),this.l.set(s,a)),a}async updateProfile(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let r=this.profiles.find(a=>a.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);return r=k(r.id,s.name??r.name,r.location,this.g,{shortName:s.shortName??r.shortName,transient:s.transient??r.isTransient,useDefaultFlags:s.useDefaultFlags??r.useDefaultFlags}),this.D([],[],[r]),r}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);const r=[];this.j.fire({profile:s,join(a){r.push(a)}});try{await Promise.allSettled(r)}catch(a){this.t.error(a)}for(const a of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(a)?.id&&this.v.emptyWindows.delete(a);for(const a of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(a)?.id&&this.v.workspaces.delete(a);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(a){(0,S.toFileOperationResult)(a)!==1&&this.t.error(a)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(s.location,{recursive:!0})}catch(a){this.t.error(a)}}async setProfileForWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const r=this.profiles.find(a=>a.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);this.G(t,r)}unsetWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(t,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(!!this.f&&await this.r.exists(this.profilesHome)){const t=await this.r.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(s=>s.isDirectory&&this.profiles.every(r=>!this.s.extUri.isEqual(r.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(t.map(s=>this.removeProfile(s)))}getProfileForWorkspace(t){const s=this.z(t);return T.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(t){return(0,m.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,m.isWorkspaceIdentifier)(t)?t.configPath:t.id}C(t){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,t.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,t.location)))}D(t,s,r){const a=[...this.profiles,...t],h=[];this.m.profiles=[];for(let w of a)w.isDefault||s.some(v=>w.id===v.id)||(w=r.find(v=>w.id===v.id)??w,w.isTransient?this.m.profiles.push(w):h.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.L(h),this.u=void 0,this.F(t,s,r)}F(t,s,r){this.h.fire({added:t,removed:s,updated:r,all:this.profiles})}G(t,s,r){r=s?.isTransient?!0:r,r||this.G(t,void 0,!0);const a=this.z(t),h=r?this.m:this.v;T.URI.isUri(a)?(h.workspaces.delete(a),s&&h.workspaces.set(a,s)):(h.emptyWindows.delete(a),s&&h.emptyWindows.set(a,s)),r||this.H()}H(){const t={};for(const[r,a]of this.v.workspaces.entries())t[r.toString()]=a.id;const s={};for(const[r,a]of this.v.emptyWindows.entries())s[r.toString()]=a.id;this.N({workspaces:t,emptyWindows:s}),this.u=void 0}I(t){const s={},r=this.w();if(t.workspaces)for(const[h,w]of Object.entries(t.workspaces)){const v=T.URI.parse(w);s[h]=this.s.extUri.isEqual(v,r.location)?r.id:this.s.extUri.basename(v)}const a={};if(t.emptyWindows)for(const[h,w]of Object.entries(t.emptyWindows)){const v=T.URI.parse(w);a[h]=this.s.extUri.isEqual(v,r.location)?r.id:this.s.extUri.basename(v)}return{workspaces:s,emptyWindows:a}}J(){return[]}L(t){throw new Error("not implemented")}M(){return{}}N(t){throw new Error("not implemented")}O(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([J(0,I.IEnvironmentService),J(1,S.IFileService),J(2,p.IUriIdentityService),J(3,b.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(t){this.a=t}M(){return this.R}N(t){this.R=t}}e.InMemoryUserDataProfilesService=o}),define(oe[268],ae([0,1,6,2,18]),function(ie,e,L,N,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let O=class extends N.Disposable{constructor(D){super(),this.B(new L.RunOnceScheduler(()=>{D.cleanUp()},10*1e3)).schedule()}};O=ye([J(0,c.IUserDataProfilesService)],O),e.UserDataProfilesCleaner=O}),define(oe[269],ae([0,1,21,6,25,10,3,2,4,11,12,160,29,33,50,9,26,19,18]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends D.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,s,r,a,h){super(),this.t=t,this.u=s,this.v=r,this.w=a,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,D.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(r=>(0,m.isTargetPlatformCompatible)(r,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.t.isEnabled())throw new m.ExtensionManagementError(b.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=await this.G(t,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(r.manifest,r.extension,s)}catch(r){throw i(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(t),error:r}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(r),k(r)}}async uninstall(t,s={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,s,r){const a=r.isApplicationScoped||r.isBuiltin||(0,p.isApplicationScopedExtension)(t),h={...r,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(s)?r.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:a,profileLocation:a?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},w=V=>`${d.ExtensionKey.create(V).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!P.URI.isUri(s)){const V=this.j.get(w(s));if(V)return this.v.info("Extensions is already requested to install",s.identifier.id),V.task.waitUntilTaskIsFinished()}const v=[],R=[],A=[],M=this.Q(t,s,h);P.URI.isUri(s)||this.j.set(w(s),{task:M,waitingTasks:[]}),this.l.fire({identifier:M.identifier,source:s,profileLocation:h.profileLocation}),this.v.info("Installing extension:",M.identifier.id),v.push({task:M,manifest:t});let $=!1;try{if(h.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const q=await this.F(M.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),W=await this.getInstalled(void 0,h.profileLocation);for(const{gallery:X,manifest:Q}of(0,L.distinct)(q,({gallery:Y})=>Y.identifier.id)){$=$||!!Q.extensionDependencies?.some(x=>(0,d.areSameExtensions)({id:x},M.identifier));const Y=w(X),Z=this.j.get(Y);if(Z){if(this.C(M,Z.task)){const x=Z.task.identifier;this.v.info("Waiting for already requested installing extension",x.id,M.identifier.id),Z.waitingTasks.push(M),R.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,j=>j.some(ee=>(0,d.areSameExtensions)(ee.identifier,x)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",x.id,M.identifier.id),!j.find(ne=>(0,d.areSameExtensions)(ne.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!W.some(({identifier:x})=>(0,d.areSameExtensions)(x,X.identifier))){const x=this.Q(Q,X,{...h,donotIncludePackAndDependencies:!0});this.j.set(Y,{task:x,waitingTasks:[M]}),this.l.fire({identifier:x.identifier,source:X,profileLocation:h.profileLocation}),this.v.info("Installing extension:",x.identifier.id,M.identifier.id),v.push({task:x,manifest:Q})}}}catch(q){if(P.URI.isUri(M.source))(0,L.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",M.identifier.id,q.message),(0,L.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",M.identifier.id,q.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),q}const V=v.reduce((q,{task:W,manifest:X})=>(q.set(W.identifier.id.toLowerCase(),{task:W,manifest:X}),q),new Map);for(;V.size;){let q;const W=[...V.values()].filter(({manifest:X})=>!X.extensionDependencies?.some(Q=>V.has(Q.toLowerCase())));W.length?q=V.size===1?W:W.filter(({task:X})=>!(X===M&&!$)):(this.v.info("Found extensions with circular dependencies",W.map(({task:X})=>X.identifier.id)),q=[...V.values()]),await this.D(q.map(async({task:X})=>{const Q=new Date().getTime();try{const Y=await X.run();if(await this.D(this.s.map(Z=>Z.postInstall(Y,X.source,h,c.CancellationToken.None))),!P.URI.isUri(X.source)){const Z=X.operation===3,x=Z?void 0:(new Date().getTime()-X.source.lastUpdated)/1e3;if(i(this.u,Z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:x}),I.isWeb&&X.operation!==3)try{await this.t.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}A.push({local:Y,identifier:X.identifier,operation:X.operation,source:X.source,context:h.context,profileLocation:X.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw P.URI.isUri(X.source)||i(this.u,X.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-Q,error:Y}),this.v.error("Error while installing the extension:",X.identifier.id),Y}finally{V.delete(X.identifier.id.toLowerCase())}}))}return R.length&&await this.D(R),A.forEach(({identifier:q})=>this.v.info("Extension installed successfully:",q.id)),this.m.fire(A),A.filter(({identifier:q})=>(0,d.areSameExtensions)(q,M.identifier))[0].local}catch(V){if(v.forEach(({task:q})=>q.cancel()),A.length)try{const q=await Promise.allSettled(A.map(({local:W})=>this.R(W,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let W=0;W<q.length;W++){const X=q[W],{identifier:Q}=A[W];X.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",Q.id):this.v.warn("Rollback: Error while uninstalling extension",Q.id,(0,O.getErrorMessage)(X.reason))}}catch(q){this.v.warn("Error while rolling back extensions",(0,O.getErrorMessage)(q),A.map(({identifier:W})=>W.id))}throw this.m.fire(v.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:h.context,profileLocation:h.profileLocation}))),V}finally{for(const{task:V}of v)V.source&&!P.URI.isUri(V.source)&&this.j.delete(w(V.source))}}C(t,s){for(const[,{task:r,waitingTasks:a}]of this.j.entries())if(r===t&&(a.includes(s)||a.some(h=>this.C(h,s)))||r===s&&a[0]&&!this.C(t,a[0]))return!1;return!0}async D(t){const s=[],r=[],a=await Promise.allSettled(t);for(const h of a)h.status==="fulfilled"?s.push(h.value):r.push(h.reason);if(r.length)throw y(r);return s}async F(t,s,r,a,h){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,h),v=[],R=[],A=async(M,$)=>{v.push(M);const V=$.extensionDependencies||[],q=[...V];if($.extensionPack){const W=r?w.find(X=>(0,d.areSameExtensions)(X.identifier,M)):void 0;for(const X of $.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(Q=>(0,d.areSameExtensions)({id:Q},{id:X}))||q.every(Q=>!(0,d.areSameExtensions)({id:Q},{id:X}))&&q.push(X)}if(q.length){const W=q.filter(X=>v.every(Q=>!(0,d.areSameExtensions)(Q,{id:X})));if(W.length){const X=await this.t.getExtensions(W.map(Q=>({id:Q,preRelease:a})),c.CancellationToken.None);for(const Q of X){if(v.find(x=>(0,d.areSameExtensions)(x,Q.identifier)))continue;const Y=V.some(x=>(0,d.areSameExtensions)({id:x},Q.identifier));let Z;try{Z=await this.G(Q,!1,a)}catch(x){if(x instanceof m.ExtensionManagementError&&x.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.v.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw x}R.push({gallery:Z.extension,manifest:Z.manifest}),await A(Z.extension.identifier,Z.manifest)}}}};return await A(t,s),R}async G(t,s,r){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,d.areSameExtensions)(t.identifier,v)))throw new m.ExtensionManagementError(b.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const v=await this.getTargetPlatform();throw new m.ExtensionManagementError(b.localize(2,null,t.identifier.id,this.w.nameLong,(0,m.TargetPlatformToString)(v)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(t,s,r);if(h){if(r&&!s&&t.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!r&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],c.CancellationToken.None))[0]?new m.ExtensionManagementError(b.localize(4,null,t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const w=await this.t.getManifest(h,c.CancellationToken.None);if(w===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(w.version!==h.version)throw new m.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:w}}async H(t,s,r){const a=await this.getTargetPlatform();let h=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==r&&(h=(await this.t.getExtensions([{...t.identifier,preRelease:r}],{targetPlatform:a,compatible:!0},c.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(t,r,a)&&(h=t),h||(s?h=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:a,compatible:!0},c.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(t,r,a)),h}async I(t,s){const r={...s,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},a=M=>`${M.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,h=this.k.get(a(t.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),h.waitUntilTaskIsFinished();const w=M=>{const $=this.R(M,r);return this.k.set(a($.extension.identifier),$),r.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped}),$},v=(M,$)=>{$?r.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString(),$.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,$.message):r.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,r.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(M),error:$}),this.p.fire({identifier:M.identifier,error:$?.code,profileLocation:r.profileLocation,applicationScoped:M.isApplicationScoped})},R=[],A=[];try{R.push(w(t));const M=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const $=this.M(t,M);for(const V of $)this.k.has(a(V.identifier))?this.v.info("Extensions is already requested to uninstall",V.identifier.id):R.push(w(V))}r.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(R.map($=>$.extension),M,t),await this.D(R.map(async $=>{try{if(await $.run(),await this.D(this.s.map(V=>V.postUninstall($.extension,r,c.CancellationToken.None))),$.extension.identifier.uuid)try{await this.t.reportStatistic($.extension.manifest.publisher,$.extension.manifest.name,$.extension.manifest.version,"uninstall")}catch{}v($.extension)}catch(V){const q=V instanceof m.ExtensionManagementError?V:new m.ExtensionManagementError((0,O.getErrorMessage)(V),m.ExtensionManagementErrorCode.Internal);throw v($.extension,q),q}finally{A.push($)}}))}catch(M){const $=M instanceof m.ExtensionManagementError?M:new m.ExtensionManagementError((0,O.getErrorMessage)(M),m.ExtensionManagementErrorCode.Internal);for(const V of R){try{V.cancel()}catch{}A.includes(V)||v(V.extension,$)}throw $}finally{for(const M of R)this.k.delete(a(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(t,s,r){for(const a of t){const h=this.N(a,s);if(h.length){const w=h.filter(v=>!t.some(R=>(0,d.areSameExtensions)(R.identifier,v.identifier)));if(w.length)throw new Error(this.L(a,w,r))}}}L(t,s,r){return r===t?s.length===1?b.localize(6,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(t,s,r=[]){if(r.indexOf(t)!==-1)return[];r.push(t);const a=t.manifest.extensionPack?t.manifest.extensionPack:[];if(a.length){const h=s.filter(v=>!v.isBuiltin&&a.some(R=>(0,d.areSameExtensions)({id:R},v.identifier))),w=[];for(const v of h)w.push(...this.M(v,s,r));return[...h,...w]}return[]}N(t,s){return s.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(a=>(0,d.areSameExtensions)({id:a},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=ye([J(0,m.IExtensionGalleryService),J(1,f.ITelemetryService),J(2,E.ILogService),J(3,l.IProductService),J(4,u.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function y(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,r)=>new Error(`${s.message}${s.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=y;function k(n){if(n instanceof m.ExtensionManagementError)return n;const t=new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function i(n,t,{extensionData:s,verificationStatus:r,duration:a,error:h,durationSinceUpdate:w}){let v,R;(0,S.isDefined)(r)&&(r===!0?r="Verified":(r===!1||(v=m.ExtensionManagementErrorCode.Signature,R=r),r="Unverified")),h&&(h instanceof m.ExtensionManagementError?(v=h.code,h.code===m.ExtensionManagementErrorCode.Signature&&(R=h.message)):v=m.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...s,verificationStatus:r,success:!h,duration:a,errorcode:v,errorcodeDetail:R,durationSinceUpdate:w})}class o{constructor(){this.d=new N.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.createCancelablePromise)(t=>new Promise((s,r)=>{const a=t.onCancellationRequested(()=>{a.dispose(),r(new O.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=o}),define(oe[51],ae([0,1,6,16,2,3,37,12,29,33,13,5,9,18,30,11,10,19]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class g extends Error{constructor(n,t){super(n),this.code=t}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let y=class extends c.Disposable{constructor(n,t,s,r,a,h){super(),this.i=n,this.j=t,this.k=s,this.l=r,this.m=a,this.n=h,this.b=this.B(new O.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new O.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new T.ResourceMap}scanProfileExtensions(n,t){return this.p(n,void 0,t)}async addExtensionsToProfile(n,t){const s=[],r=[];try{return await this.p(t,a=>{const h=[];for(const w of a)n.some(([v])=>(0,S.areSameExtensions)(v.identifier,w.identifier)&&v.manifest.version!==w.version)?s.push(w):h.push(w);for(const[w,v]of n)if(!h.some(R=>(0,S.areSameExtensions)(R.identifier,w.identifier)&&R.version===w.manifest.version)){const R={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:v};r.push(R),h.push(R)}return r.length&&this.b.fire({extensions:r,profileLocation:t}),s.length&&this.f.fire({extensions:s,profileLocation:t}),h}),r.length&&this.c.fire({extensions:r,profileLocation:t}),s.length&&this.g.fire({extensions:s,profileLocation:t}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:t}),s.length&&this.g.fire({extensions:s,error:a,profileLocation:t}),a}}async updateMetadata(n,t){const s=[];return await this.p(t,r=>{const a=[];for(const h of r){const w=n.find(([v])=>(0,S.areSameExtensions)(v.identifier,h.identifier)&&v.manifest.version===h.version);w&&(h.metadata={...h.metadata,...w[1]},s.push(h)),a.push(h)}return a}),s}async removeExtensionFromProfile(n,t){const s=[];this.f.fire({extensions:s,profileLocation:t});try{await this.p(t,r=>{const a=[];for(const h of r)(0,S.areSameExtensions)(h.identifier,n.identifier)?s.push(h):a.push(h);return s.length&&this.f.fire({extensions:s,profileLocation:t}),a}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async p(n,t,s){return this.w(n).queue(async()=>{let r=[],a;try{const h=await this.j.readFile(n);a=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,P.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&s?.bailOutWhenFileNotFound)throw new g((0,l.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(n);let h=!1;for(const w of a){k(w)||this.r(n);let v;if((0,E.isString)(w.relativeLocation)&&w.relativeLocation)v=this.t(w.relativeLocation);else if((0,E.isString)(w.location))v=this.t(w.location),h=!0,w.relativeLocation=w.location,w.location=v.toJSON();else{v=D.URI.revive(w.location);const R=this.s(v);R&&(h=!0,w.relativeLocation=R)}r.push({identifier:w.identifier,location:v,version:w.version,metadata:w.metadata})}h&&await this.j.writeFile(n,N.VSBuffer.fromString(JSON.stringify(a)))}if(t){r=t(r);const h=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(n,N.VSBuffer.fromString(JSON.stringify(h)))}return r})}r(n){const t=new g(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),t=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(n)).value.toString()}catch(a){if((0,P.toFileOperationResult)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(s);Array.isArray(a)&&a.every(h=>k(h))?r=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.toFileOperationResult)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(n)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.n.error(a)}try{await this.j.del(t)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.n.error(a)}return r})()),this.u}w(n){let t=this.h.get(n);return t||(t=new L.Queue,this.h.set(n,t)),t}};y=ye([J(1,P.IFileService),J(2,d.IUserDataProfilesService),J(3,p.IUriIdentityService),J(4,f.ITelemetryService),J(5,m.ILogService)],y),e.AbstractExtensionsProfileScannerService=y;function k(o){return(0,E.isObject)(o)&&(0,I.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function i(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(oe[78],ae([0,1,21,6,32,16,10,35,140,2,22,14,4,23,55,90,11,12,164,15,33,50,67,13,5,9,26,3,91,51,18,30,197]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o,n,t,s,r,a,h,w,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(Q){function Y(Z,x){if(Z===x)return!0;const j=Object.keys(Z),ee=new Set;for(const ne of Object.keys(x))ee.add(ne);if(j.length!==ee.size)return!1;for(const ne of j){if(Z[ne]!==x[ne])return!1;ee.delete(ne)}return ee.size===0}Q.equals=Y})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let M=class extends S.Disposable{constructor(Y,Z,x,j,ee,ne,re,G,H,F,C,U){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.l=x,this.m=j,this.n=ee,this.r=ne,this.s=re,this.t=G,this.u=H,this.v=F,this.w=C,this.y=U,this.g=this.B(new r.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(q,this.m,this.h)),this.j=this.B(this.y.createInstance(q,this.m,this.h)),this.k=this.B(this.y.createInstance(V,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,y.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(Y,Z,x){const[j,ee]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),ne=x?await this.scanExtensionsUnderDevelopment(Y,[...j,...ee]):[];return this.G(j,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.H(!!Y.useCache,Y.language)),Z.push(this.I(Y.language,!!Y.checkControlFile));const[x,j]=await Promise.all(Z);return this.F([...x,...j],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",Z);const x=this.w.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.L(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,x),ee=Y.useCache&&!j.devMode&&j.excludeObsolete?this.j:this.k;let ne;try{ne=await ee.scanExtensions(j)}catch(re){if(re instanceof h.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ne=await ee.scanExtensions(j);else throw re}return ne=await this.F(ne,1,Y,!0),this.t.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(Y,Z){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const x=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(j=>j.scheme===P.Schemas.file).map(async j=>{const ee=await this.L(j,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(re=>(re.type=Z.find(G=>(0,y.areSameExtensions)(G.identifier,re.identifier))?.type??re.type,this.k.validate(re,ee)))}))).flat();return this.F(x,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,x){const j=await this.L(Y,!1,Z,!0,x.language,!0,void 0),ee=await this.k.scanExtension(j);return!ee||!x.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(Y,Z,x){const j=await this.L(Y,!1,Z,!0,x.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(j);return this.F(ee,Z,x,!0)}async scanMetadata(Y){const Z=(0,d.joinPath)(Y,"package.json"),x=(await this.s.readFile(Z)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(Y,Z){const x=(0,d.joinPath)(Y,"package.json"),j=(await this.s.readFile(x)).value.toString(),ee=JSON.parse(j);Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,ee.__metadata={...ee.__metadata,...Z},await this.s.writeFile((0,d.joinPath)(Y,"package.json"),O.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof h.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw Y}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.r.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Z){(0,o.toFileOperationResult)(Z)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(Z))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.t.error(Y)}finally{this.C=void 0}})()),this.C}async F(Y,Z,x,j){return x.includeAllVersions||(Y=this.G(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),j)),x.includeInvalid||(Y=Y.filter(ee=>ee.isValid)),Y.sort((ee,ne)=>{const re=b.basename(ee.location.fsPath),G=b.basename(ne.location.fsPath);return re<G?-1:re>G?1:0})}G(Y,Z,x,j,ee){const ne=(G,H,F)=>{if(G.isValid&&!H.isValid)return!1;if(G.isValid===H.isValid){if(ee&&p.gt(G.manifest.version,H.manifest.version))return this.t.debug(`Skipping extension ${H.location.path} with lower version ${H.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(p.eq(G.manifest.version,H.manifest.version)){if(G.type===0)return this.t.debug(`Skipping extension ${H.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.t.debug(`Skipping extension ${H.location.path} from different target platform ${H.targetPlatform}`),!1}}return F?this.t.warn(`Overwriting user extension ${G.location.path} with ${H.location.path}.`):this.t.debug(`Overwriting user extension ${G.location.path} with ${H.location.path}.`),!0},re=new k.ExtensionIdentifierMap;return Y?.forEach(G=>{const H=re.get(G.identifier.id);(!H||ne(H,G,!1))&&re.set(G.identifier.id,G)}),Z?.forEach(G=>{const H=re.get(G.identifier.id);if(!H&&Y&&G.type===0){this.t.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!H||ne(H,G,!1))&&re.set(G.identifier.id,G)}),x?.forEach(G=>{const H=re.get(G.identifier.id);(!H||ne(H,G,!0))&&re.set(G.identifier.id,G),re.set(G.identifier.id,G)}),[...re.values()]}async H(Y,Z){this.t.trace("Started scanning system extensions");const x=await this.L(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),ee=await(Y&&!x.devMode?this.i:this.k).scanExtensions(x);return this.t.trace("Scanned system extensions:",ee.length),ee}async I(Y,Z){const x=this.u.isBuilt?[]:this.v.builtInExtensions;if(!x?.length)return[];this.t.trace("Started scanning dev system extensions");const j=Z?await this.J():{},ee=[],ne=f.URI.file(b.normalize(b.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of x){const H=j[G.name]||"marketplace";switch(H){case"disabled":break;case"marketplace":ee.push((0,d.joinPath)(ne,G.name));break;default:ee.push(f.URI.file(H));break}}const re=await Promise.all(ee.map(async G=>this.k.scanExtension(await this.L(G,!1,0,!0,Y,!0,void 0))));return this.t.trace("Scanned dev system extensions:",re.length),(0,L.coalesce)(re)}async J(){try{const Y=await this.s.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async L(Y,Z,x,j,ee,ne,re){const G=await this.f(ee??m.language),H=await this.M(Y),F=Z&&!this.w.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,C=F?await this.M(F):void 0;return new $(Y,H,F,C,Z,re,x,j,ne,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,ee,G)}async M(Y){try{const Z=await this.s.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};M=ye([J(4,w.IUserDataProfilesService),J(5,h.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,t.ILogService),J(8,g.IEnvironmentService),J(9,s.IProductService),J(10,v.IUriIdentityService),J(11,n.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class ${constructor(Y,Z,x,j,ee,ne,re,G,H,F,C,U,z,K,B){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=j,this.profile=ee,this.profileScanOptions=ne,this.type=re,this.excludeObsolete=G,this.validate=H,this.productVersion=F,this.productDate=C,this.productCommit=U,this.devMode=z,this.language=K,this.translations=B}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,d.isEqual)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,d.isEqual)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&c.equals(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&A.equals(Y.translations,Z.translations)}}e.ExtensionScannerInput=$;let V=class extends S.Disposable{constructor(Y,Z,x,j,ee){super(),this.f=Y,this.g=Z,this.h=x,this.i=j,this.j=ee}async scanExtensions(Y){const Z=Y.profile?await this.l(Y):await this.k(Y);let x={};if(Y.excludeObsolete&&Y.type===1)try{const j=(await this.i.readFile(this.f)).value.toString();x=JSON.parse(j)}catch{}return(0,l.isEmptyObject)(x)?Z:Z.filter(j=>!x[y.ExtensionKey.create(j).toString()])}async k(Y){const Z=await this.i.resolve(Y.location);if(!Z.children?.length)return[];const x=await Promise.all(Z.children.map(async j=>{if(!j.isDirectory||Y.type===1&&(0,d.basename)(j.resource).indexOf(".")===0)return null;const ee=new $(j.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(ee)}));return(0,L.coalesce)(x).sort((j,ee)=>j.location.path<ee.location.path?-1:1)}async l(Y){let Z=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter(j=>!j.metadata?.isApplicationScoped);const x=await this.m(Y.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,Y);Z.push(...x)}return Z}async m(Y,Z,x){const j=await this.g.scanProfileExtensions(Y,x.profileScanOptions);if(!j.length)return[];const ee=await Promise.all(j.map(async ne=>{if(Z(ne)){const re=new $(ne.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(re,ne.metadata)}return null}));return(0,L.coalesce)(ee)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,d.joinPath)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,T.getErrorMessage)(Z)),[]}}async scanExtension(Y,Z){try{let x=await this.scanExtensionManifest(Y.location);if(x){x.publisher||(x.publisher=k.UNDEFINED_PUBLISHER),Z=Z??x.__metadata,delete x.__metadata;const j=(0,y.getGalleryExtensionId)(x.publisher,x.name),ee=Z?.id?{id:j,uuid:Z.id}:{id:j},ne=Z?.isSystem?0:Y.type,re=ne===0||!!Z?.isBuiltin;x=await this.n(Y.location,x,$.createNlsConfiguration(Y));const G={type:ne,identifier:ee,manifest:x,location:Y.location,isBuiltin:re,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(G,Y):G}}catch(x){Y.type!==0&&this.j.error(x)}return null}validate(Y,Z){let x=!0;const j=(0,i.validateExtensionManifest)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[ee,ne]of j)ee===E.default.Error&&(x=!1,this.j.error(this.u(Z.location,ne)));return Y.isValid=x,Y.validations=j,Y}async scanExtensionManifest(Y){const Z=(0,d.joinPath)(Y,"package.json");let x;try{x=(await this.i.readFile(Z)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.j.error(this.u(Y,(0,u.localize)(0,null,Z.path,ee.message))),null}let j;try{j=JSON.parse(x)}catch{const ne=[];(0,D.parse)(x,ne);for(const re of ne)this.j.error(this.u(Y,(0,u.localize)(1,null,Z.path,re.offset,re.length,(0,I.getParseErrorMessage)(re.error))));return null}return(0,D.getNodeType)(j)!=="object"?(this.j.error(this.u(Y,(0,u.localize)(2,null,Z.path))),null):j}async n(Y,Z,x){const j=await this.r(Y,Z,x);if(j)try{const ee=[],ne=await this.s(j.default,ee);if(ee.length>0)return ee.forEach(G=>{this.j.error(this.u(Y,(0,u.localize)(3,null,j.default?.path,(0,I.getParseErrorMessage)(G.error))))}),Z;if((0,D.getNodeType)(j)!=="object")return this.j.error(this.u(Y,(0,u.localize)(4,null,j.default?.path))),Z;const re=j.values||Object.create(null);return(0,R.localizeManifest)(Z,re,ne)}catch{}return Z}async r(Y,Z,x){const j=(0,d.joinPath)(Y,"package.nls.json"),ee=(H,F)=>{F.forEach(C=>{this.j.error(this.u(Y,(0,u.localize)(5,null,H?.path,(0,I.getParseErrorMessage)(C.error))))})},ne=H=>{this.j.error(this.u(Y,(0,u.localize)(6,null,H?.path)))},re=`${Z.publisher}.${Z.name}`,G=x.translations[re];if(G)try{const H=f.URI.file(G),F=(await this.i.readFile(H)).value.toString(),C=[],U=(0,D.parse)(F,C);return C.length>0?(ee(H,C),{values:void 0,default:j}):(0,D.getNodeType)(U)!=="object"?(ne(H),{values:void 0,default:j}):{values:U.contents?U.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.i.exists(j))return;let F;try{F=await this.t(Y,x)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const C=(await this.i.readFile(F.localized)).value.toString(),U=[],z=(0,D.parse)(C,U);return U.length>0?(ee(F.localized,U),{values:void 0,default:F.original}):(0,D.getNodeType)(z)!=="object"?(ne(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async s(Y,Z){if(Y)try{const x=(await this.i.readFile(Y)).value.toString();return(0,D.parse)(x,Z)}catch{}}t(Y,Z){return new Promise((x,j)=>{const ee=ne=>{const re=(0,d.joinPath)(Y,`package.nls.${ne}.json`);this.i.exists(re).then(G=>{G&&x({localized:re,original:(0,d.joinPath)(Y,"package.nls.json")});const H=ne.lastIndexOf("-");H===-1?x({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null}):(ne=ne.substring(0,H),ee(ne))})};if(Z.devMode||Z.pseudo||!Z.language)return x({localized:(0,d.joinPath)(Y,"package.nls.json"),original:null});ee(Z.language)})}u(Y,Z){return`[${Y.path}]: ${Z}`}};V=ye([J(1,h.IExtensionsProfileScannerService),J(2,v.IUriIdentityService),J(3,o.IFileService),J(4,t.ILogService)],V);let q=class extends V{constructor(Y,Z,x,j,ee,ne,re){super(Z,j,ee,ne,re),this.z=Y,this.C=x,this.w=this.B(new N.ThrottledDelayer(3e3)),this.y=this.B(new r.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(Y){const Z=this.H(Y),x=await this.D(Z);if(this.v=Y,x&&x.input&&$.equals(x.input,this.v))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.w.trigger(()=>this.G()),x.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const j=await super.scanExtensions(Y);return await this.F(Z,{input:Y,result:j}),j}async D(Y){try{const Z=await this.i.readFile(Y),x=JSON.parse(Z.value.toString());return{result:x.result,input:(0,a.revive)(x.input)}}catch(Z){this.j.debug("Error while reading the extension cache file:",Y.path,(0,T.getErrorMessage)(Z))}return null}async F(Y,Z){try{await this.i.writeFile(Y,O.VSBuffer.fromString(JSON.stringify(Z)))}catch(x){this.j.debug("Error while writing the extension cache file:",Y.path,(0,T.getErrorMessage)(x))}}async G(){if(!this.v)return;const Y=this.H(this.v),Z=await this.D(Y);if(!Z)return;const x=Z.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!c.equals(j,x))try{this.j.info("Invalidating Cache",x,j),await this.i.del(Y),this.y.fire()}catch(ee){this.j.error(ee)}}H(Y){const Z=this.I(Y);return this.h.extUri.joinPath(Z.cacheHome,Y.type===0?k.BUILTIN_MANIFEST_CACHE_FILE:k.USER_MANIFEST_CACHE_FILE)}I(Y){return Y.type===0?this.C.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.z.extensionsResource)?this.z:this.C.profiles.find(Z=>this.h.extUri.isEqual(Y.location,Z.extensionsResource))??this.z:this.C.defaultProfile}};q=ye([J(2,w.IUserDataProfilesService),J(3,h.IExtensionsProfileScannerService),J(4,v.IUriIdentityService),J(5,o.IFileService),J(6,t.ILogService)],q);function W(Q,Y){const Z=(0,y.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:Z,identifier:new k.ExtensionIdentifier(Z),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:Y,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=W;class X extends M{constructor(Y,Z,x,j,ee,ne,re,G,H,F,C,U){super(Y,Z,(0,d.joinPath)(x,".vscode-oss-dev","extensions","control.json"),j,ee,ne,re,G,H,F,C,U),this.N=(async()=>{if(m.translationsConfigFile)try{const z=await this.s.readFile(f.URI.file(m.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.N}}e.NativeExtensionsScannerService=X}),define(oe[270],ae([0,1,49,6,38,3,2,22,14,28,9,18]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(p,E){super(),this.b=p,this.f=E,this.a=new N.Limiter(5)}async postUninstall(p){const E=this.g(p,"uninstall");E&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(l){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(l)}}));try{await S.Promises.rm(this.j(p))}catch(l){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(l)}}g(p,E){const l=`vscode:${E}`;if(p.location.scheme===D.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[l]=="string"){const f=p.manifest.scripts[l].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${l} should be a node script`),null):{script:(0,I.join)(p.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(p,E,l,f,u){return new Promise((g,y)=>{const k=this.i(p,E,l,u);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?y(n):g(void 0)};k.on("error",n=>{o((0,c.toErrorMessage)(n)||"Unknown")}),k.on("exit",(n,t)=>{o(n?`post-${E} process exited with code ${n}`:void 0)}),f&&(i=setTimeout(()=>{i=null,k.kill(),y("timed out")},5e3))})}i(p,E,l,f){const u={silent:!0,execArgv:void 0},g=(0,L.fork)(p,[`--type=extension-post-${E}`,...l],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const y=O.Event.fromNodeEventEmitter(g.stdout,"data"),k=O.Event.fromNodeEventEmitter(g.stderr,"data");y(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${E}`,n)),k(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${E}`,n));const i=O.Event.any(O.Event.map(y,n=>({data:`%c${n}`,format:[""]})),O.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return O.Event.debounce(i,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}j(p){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=ye([J(0,b.IUserDataProfilesService),J(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(oe[271],ae([0,1,9,18,30,19,51,13,15,12]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends T.AbstractExtensionsProfileScannerService{constructor(m,d,p,E,l,f){super(S.URI.file(m.extensionsPath),d,p,E,l,f)}};P=ye([J(0,I.INativeEnvironmentService),J(1,D.IFileService),J(2,N.IUserDataProfilesService),J(3,c.IUriIdentityService),J(4,O.ITelemetryService),J(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(oe[272],ae([0,1,12,15,51,78,13,5,9,26,30,18]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends O.NativeExtensionsScannerService{constructor(p,E,l,f,u,g,y,k){super(L.URI.file(u.builtinExtensionsPath),L.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,E,l,f,u,g,y,k)}};m=ye([J(0,b.IUserDataProfilesService),J(1,c.IExtensionsProfileScannerService),J(2,T.IFileService),J(3,I.ILogService),J(4,N.INativeEnvironmentService),J(5,S.IProductService),J(6,P.IUriIdentityService),J(7,D.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(oe[20],ae([0,1,6,3,2,104,11,66,5,18]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function d(u){const g=u.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=d;class p extends c.Disposable{constructor(g={flushInterval:p.a}){super(),this.j=g,this.b=this.B(new N.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new N.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new c.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,c.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,y){if(y===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:y,target:this.F(g)[y]})}r(g){this.f.fire({reason:g})}get(g,y,k){return this.L(y)?.get(g,k)}getBoolean(g,y,k){return this.L(y)?.getBoolean(g,k)}getNumber(g,y,k){return this.L(y)?.getNumber(g,k)}store(g,y,k,i){if((0,T.isUndefinedOrNull)(y)){this.remove(g,k);return}this.t(()=>{this.u(g,k,i),this.L(k)?.set(g,y)})}remove(g,y){this.t(()=>{this.u(g,y,void 0),this.L(y)?.delete(g)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,y){const k=[],i=this.F(g);for(const o of Object.keys(i))i[o]===y&&k.push(o);return k}u(g,y,k){const i=this.F(y);typeof k=="number"?i[g]!==k&&(i[g]=k,this.L(y)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.L(y)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const y=this.L(g);return y?d(y):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this.f.fire({reason:g});const y=this.L(-1),k=this.L(0),i=this.L(1);switch(g){case P.NONE:await L.Promises.settled([y?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([y?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,y=this.L(0)?.items??new Map,k=this.L(1)?.items??new Map;return f(g,y,k,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,y){return this.r(P.NONE),(0,S.isUserDataProfile)(g)?this.N(g,y):this.O(g,y)}H(g,y){return!(g.id===y.id||E(y)&&E(g))}I(g,y,k,i){this.t(()=>{if(i)for(const[o,n]of g)y.set(o,n);else{const o=new Set;for(const[n,t]of g)o.add(n),y.get(n)!==t&&this.n(k,n);for(const[n]of y.items)o.has(n)||this.n(k,n)}})}}p.a=60*1e3,e.AbstractStorageService=p;function E(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class l extends p{constructor(){super(),this.p=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new D.Storage(new D.InMemoryStorageDatabase,{hint:D.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=l;async function f(u,g,y,k,i,o){const n=A=>{try{return JSON.parse(A)}catch{return A}},t=new Map,s=new Map;u.forEach((A,M)=>{t.set(M,A),s.set(M,n(A))});const r=new Map,a=new Map;g.forEach((A,M)=>{r.set(M,A),a.set(M,n(A))});const h=new Map,w=new Map;y.forEach((A,M)=>{h.set(M,A),w.set(M,n(A))}),console.group(k!==i?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const v=[];if(t.forEach((A,M)=>{v.push({key:M,value:A})}),console.table(v),console.groupEnd(),console.log(s),k!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const A=[];r.forEach((M,$)=>{A.push({key:$,value:M})}),console.table(A),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const R=[];h.forEach((A,M)=>{R.push({key:M,value:A})}),console.table(R),console.groupEnd(),console.log(w)}e.logStorage=f}),define(oe[120],ae([0,1,3,2,11,29,33,20]),function(ie,e,L,N,c,O,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends N.Disposable{constructor(b,m){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(b)),this.B(this.b.onDidChange(d=>this.a.fire({extensions:d,source:"storage"}))),this.B(m.onDidInstallExtensions(d=>d.forEach(({local:p,operation:E})=>{p&&E===4&&this.f(p.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(d=>!(0,T.areSameExtensions)(d,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let d=0;d<m.length;d++){const p=m[d];if((0,T.areSameExtensions)(p,b))return m.splice(d,1),this.g(m),!0}return!1}g(b){this.i(O.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,m){this.b.set(b,m,0)}};I=ye([J(0,D.IStorageService),J(1,O.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends N.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new L.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(m=>this.f(m)))}get(b,m){let d;return m===0?((0,c.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,m)),d=this.a[b]):d=this.g(b,m),JSON.parse(d)}set(b,m,d){const p=JSON.stringify(m.map(({id:l,uuid:f})=>({id:l,uuid:f})));this.g(b,d)!==p&&(d===0&&(m.length?this.a[b]=p:delete this.a[b]),this.h(b,m.length?p:void 0,d))}f(b){if(b.scope===0&&!(0,c.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const d=this.get(b.key,b.scope);delete this.a[b.key];const p=this.get(b.key,b.scope),E=d.filter(f=>!p.some(u=>(0,T.areSameExtensions)(f,u))),l=p.filter(f=>!d.some(u=>(0,T.areSameExtensions)(u,f)));(E.length||l.length)&&this.b.fire([...E,...l])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,d){m?this.c.store(b,m,d,1):this.c.remove(b,d)}}e.StorageManager=S}),define(oe[273],ae([0,1,21,25,10,4,36,11,12,17,15,29,33,67,13,9,26,59,240,20,19]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const k=O.isWeb?"web":(0,b.getTargetPlatform)(O.platform,T.arch),i="X-Market-Search-Activity-Id";var o;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...F){return String(F.reduce((C,U)=>C|U,0))}var t;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class w{constructor(C=h){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,U=this.d.pageSize){return new w({...this.d,pageNumber:C,pageSize:U})}withFilter(C,...U){const z=[...this.d.criteria,...U.length?U.map(K=>({filterType:C,value:K})):[{filterType:C}]];return new w({...this.d,criteria:z})}withSortBy(C){return new w({...this.d,sortBy:C})}withSortOrder(C){return new w({...this.d,sortOrder:C})}withFlags(...C){return new w({...this.d,flags:C.reduce((U,z)=>U|z,0)})}withAssetTypes(...C){return new w({...this.d,assetTypes:C})}withSource(C){return new w({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:U,pageSize:z,sortBy:K,sortOrder:B,flags:_,assetTypes:te}=this.d;return{filters:[{criteria:C,pageNumber:U,pageSize:z,sortBy:K,sortOrder:B}],assetTypes:te,flags:_}}get searchText(){const C=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(F,C){const U=(F||[]).filter(z=>z.statisticName===C)[0];return U?U.value:0}function R(F){const C="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(z=>z.assetType.indexOf(C)===0).reduce((z,K)=>{const B=$(F,K.assetType);return B&&z.push([K.assetType.substring(C.length),B]),z},[])}function A(F){if(F.properties){const C=F.properties.filter(K=>K.key===s.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=C.filter(K=>U.test(K.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return $(F,s.Repository)}function M(F){return{uri:`${F.fallbackAssetUri}/${s.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${s.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function $(F,C){return F.files.filter(z=>z.assetType===C)[0]?{uri:`${F.assetUri}/${C}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${C}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function V(F,C){const U=F.properties?F.properties.filter(K=>K.key===C):[],z=U.length>0&&U[0].value;return z?z.split(",").map(K=>(0,m.adoptToGalleryExtensionId)(K)):[]}function q(F){const C=F.properties?F.properties.filter(U=>U.key===r.Engine):[];return C.length>0&&C[0].value||""}function W(F){const C=F.properties?F.properties.filter(U=>U.key===r.PreRelease):[];return C.length>0&&C[0].value==="true"}function X(F){const C=F.properties?F.properties.filter(z=>z.key===r.LocalizedLanguages):[],U=C.length>0&&C[0].value||"";return U?U.split(","):[]}function Q(F){return F.properties?.find(C=>C.key===r.SponsorLink)?.value}function Y(F){return F.indexOf("preview")!==-1}function Z(F){return F.targetPlatform?(0,b.toTargetPlatform)(F.targetPlatform):"undefined"}function x(F){const C=(0,L.distinct)(F.versions.map(Z)),U=!!F.tags?.includes(b.WEB_EXTENSION_TAG),z=C.indexOf("web");return U?z===-1&&C.push("web"):z!==-1&&C.splice(z,1),C}function j(F,C){const U=(0,b.getFallbackTargetPlarforms)(C);for(let z=0;z<F.length;z++){const K=F[z];if(K.version===F[z-1]?.version){let B=z;const _=Z(K);if(_===C)for(;B>0&&F[B-1].version===K.version;)B--;else if(U.includes(_))for(;B>0&&F[B-1].version===K.version&&Z(F[B-1])!==C;)B--;B!==z&&(F.splice(z,1),F.splice(B,0,K))}}return F}e.sortExtensionVersions=j;function ee(F,C,U){F.telemetryData={index:C,querySource:U,queryActivityId:F.queryContext?.[i]}}function ne(F,C,U,z){const K=F.versions[0],B={manifest:$(C,s.Manifest),readme:$(C,s.Details),changelog:$(C,s.Changelog),license:$(C,s.License),repository:A(C),download:M(C),icon:$(C,s.Icon),signature:$(C,s.Signature),coreTranslations:R(C)};return{identifier:{id:(0,m.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:C.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(K),description:F.shortDescription||"",installCount:v(F.statistics,"install"),rating:v(F.statistics,"averagerating"),ratingCount:v(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:U,assets:B,properties:{dependencies:V(C,r.Dependency),extensionPack:V(C,r.ExtensionPack),engine:q(C),localizedLanguages:X(C),targetPlatform:Z(C),isPreReleaseVersion:W(C)},hasPreReleaseVersion:W(K),hasReleaseVersion:!0,preview:Y(F.flags),isSigned:!!B.signature,queryContext:z}}let re=class{constructor(C,U,z,K,B,_,te,ce){this.k=U,this.l=z,this.n=K,this.o=B,this.q=_,this.u=te,this.w=ce;const he=te.extensionsGallery,pe=he?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=pe?he.servicePPEUrl:he?.serviceUrl,this.g=pe?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,C,this.o)}x(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,U,z){const K=N.CancellationToken.isCancellationToken(U)?{}:U,B=N.CancellationToken.isCancellationToken(U)?U:z,_=[],te=[],ce=[],he=[];let pe=!0;for(const Ce of C){Ce.uuid?te.push(Ce.uuid):_.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);ce.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),pe=pe&&!!Ce.hasPreRelease&&!De}if(!te.length&&!_.length)return[];let de=new w().withPage(1,C.length);te.length&&(de=de.withFilter(t.ExtensionId,...te)),_.length&&(de=de.withFilter(t.ExtensionName,..._)),(K.queryAllVersions||pe)&&(de=de.withFlags(de.flags,o.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:Se}=await this.z(de,{targetPlatform:K.targetPlatform??k,includePreRelease:ce,versions:he,compatible:!!K.compatible},B);return K.source&&Se.forEach((Ce,De)=>ee(Ce,De,K.source)),Se}async getCompatibleExtension(C,U,z){if((0,b.isNotWebExtensionInWebTargetPlatform)(C.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(C,U,z))return C;const K=new w().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,C.identifier.uuid),{extensions:B}=await this.z(K,{targetPlatform:z,compatible:!0,includePreRelease:U},N.CancellationToken.None);return B[0]||null}async isExtensionCompatible(C,U,z){if(!(0,b.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,z)||!U&&C.properties.isPreReleaseVersion)return!1;let K=C.properties.engine;if(!K){const B=await this.getManifest(C,N.CancellationToken.None);if(!B)throw new Error("Manifest was not found");K=B.engines.vscode}return(0,d.isEngineValid)(K,this.u.version,this.u.date)}async y(C,U,z,K,B){if(!(0,b.isTargetPlatformCompatible)(Z(C),K,B)||U!=="any"&&W(C)!==(U==="prerelease"))return!1;if(z)try{const _=await this.E(C);if(!(0,d.isEngineValid)(_,this.u.version,this.u.date))return!1}catch(_){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,c.getErrorMessage)(_)),!1}return!0}async query(C,U){let z=C.text||"";const K=C.pageSize??50;let B=new w().withPage(1,K);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,Se)=>(B=B.withFilter(t.Category,Se||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,Se)=>(B=B.withFilter(t.Tag,Se||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(t.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),B=B.withFilter(t.SearchText,z)),B=B.withSortBy(0)):C.ids?B=B.withFilter(t.ExtensionId,...C.ids):C.names?B=B.withFilter(t.ExtensionName,...C.names):B=B.withSortBy(4),typeof C.sortBy=="number"&&(B=B.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(B=B.withSortOrder(C.sortOrder)),C.source&&(B=B.withSource(C.source));const _=async(pe,de)=>{const{extensions:Se,total:Ce}=await this.z(pe,{targetPlatform:k,compatible:!1,includePreRelease:!!C.includePreRelease},de);return Se.forEach((De,ke)=>ee(De,(pe.pageNumber-1)*pe.pageSize+ke,C.source)),{extensions:Se,total:Ce}},{extensions:te,total:ce}=await _(B,U),he=async(pe,de)=>{if(de.isCancellationRequested)throw new c.CancellationError;const{extensions:Se}=await _(B.withPage(pe+1),de);return Se};return{firstPage:te,total:ce,pageSize:B.pageSize,getPage:he}}async z(C,U,z){const K=C.flags;!!(C.flags&o.IncludeLatestVersionOnly)&&!!(C.flags&o.IncludeVersions)&&(C=C.withFlags(C.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(C.flags&o.IncludeLatestVersionOnly)&&!(C.flags&o.IncludeVersions)&&(C=C.withFlags(C.flags,o.IncludeLatestVersionOnly)),U.versions?.length&&(C=C.withFlags(C.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),C=C.withFlags(C.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:B,total:_,context:te}=await this.B(C,z);if(!(C.flags&o.IncludeLatestVersionOnly)){const de=[];for(const Se of B){const Ce=await this.A(Se,U,te);Ce&&de.push(Ce)}return{extensions:de,total:_}}const he=[],pe=new Map;for(let de=0;de<B.length;de++){const Se=B[de],Ce={id:(0,m.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},De=(0,D.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(We=>(0,m.areSameExtensions)(We,Ce))?.includePreRelease;if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(x(Se),U.targetPlatform))continue;const ke=await this.A(Se,U,te);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?pe.set(Se.extensionId,de):he.push([de,ke])}if(pe.size){const de=new Date().getTime(),Se=new w().withFlags(K&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,pe.size).withFilter(t.ExtensionId,...pe.keys()),{extensions:Ce}=await this.z(Se,U,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:pe.size});for(const De of Ce){const ke=pe.get(De.identifier.uuid);he.push([ke,De])}}return{extensions:he.sort((de,Se)=>de[0]-Se[0]).map(([,de])=>de),total:_}}async A(C,U,z){const K={id:(0,m.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},B=U.versions?.find(he=>(0,m.areSameExtensions)(he,K))?.version,_=(0,D.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(he=>(0,m.areSameExtensions)(he,K))?.includePreRelease,te=x(C),ce=j(C.versions,U.targetPlatform);if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(te,U.targetPlatform))return null;for(let he=0;he<ce.length;he++){const pe=ce[he];if(!(B&&pe.version!==B)){if(await this.y(pe,_?"any":"release",U.compatible,te,U.targetPlatform))return ne(C,pe,te,z);if(B&&pe.version===B)return null}}return B||U.compatible?null:ne(C,C.versions[0],te)}async B(C,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(o.Unpublished));const z=await this.j,K=JSON.stringify(C.raw),B={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},_=new Date().getTime();let te,ce,he=0;try{if(te=await this.k.request({type:"POST",url:this.g&&C.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:B},U),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const pe=await(0,f.asJson)(te);if(pe){const de=pe.results[0],Se=de.extensions,Ce=de.resultMetadata&&de.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:he,context:{[i]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(pe){throw ce=pe,pe}finally{this.o.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(K.length),duration:new Date().getTime()-_,success:!!te&&(0,f.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:ce?(0,c.isCancellationError)(ce)?"canceled":(0,c.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(C,U,z,K){if(!this.isEnabled())return;const B=O.isWeb?this.x(`/itemName/${C}.${U}/version/${z}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${C}/extensions/${U}/${z}/stats?statType=${K}`),_=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:B,headers:ce},N.CancellationToken.None)}catch{}}async download(C,U,z){this.l.trace("ExtensionGalleryService#download",C.identifier.id);const K=(0,m.getGalleryExtensionTelemetryData)(C),B=new Date().getTime(),_=de=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:de}),te=z===2?"install":z===3?"update":"",ce=te?{uri:`${C.assets.download.uri}${I.URI.parse(C.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${C.assets.download.fallbackUri}${I.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:C.assets.download,he=C.queryContext?.[i]?{[i]:C.queryContext[i]}:void 0,pe=await this.D(ce,he?{headers:he}:void 0);await this.q.writeFile(U,pe.stream),_(new Date().getTime()-B)}async downloadSignatureArchive(C,U){if(!C.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const z=await this.D(C.assets.signature);await this.q.writeFile(U,z.stream)}async getReadme(C,U){if(C.assets.readme){const z=await this.D(C.assets.readme,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getManifest(C,U){if(C.assets.manifest){const z=await this.D(C.assets.manifest,{},U),K=await(0,f.asTextOrError)(z);return K?JSON.parse(K):null}return null}async C(C,U){const z=$(C,s.Manifest);if(!z)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},B=await this.D(z,{headers:K});return await(0,f.asJson)(B)}async getCoreTranslation(C,U){const z=C.assets.coreTranslations.filter(K=>K[0]===U.toUpperCase())[0];if(z){const K=await this.D(z[1]),B=await(0,f.asTextOrError)(K);return B?JSON.parse(B):null}return null}async getChangelog(C,U){if(C.assets.changelog){const z=await this.D(C.assets.changelog,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(C,U,z){let K=new w().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);C.identifier.uuid?K=K.withFilter(t.ExtensionId,C.identifier.uuid):K=K.withFilter(t.ExtensionName,C.identifier.id);const{galleryExtensions:B}=await this.B(K,N.CancellationToken.None);if(!B.length)return[];const _=x(B[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(_,z))return[];const te=[];await Promise.all(B[0].versions.map(async pe=>{try{await this.y(pe,U?"any":"release",!0,_,z)&&te.push(pe)}catch{}}));const ce=[],he=new Set;for(const pe of j(te,z))he.has(pe.version)||(he.add(pe.version),ce.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:W(pe)}));return ce}async D(C,U={},z=N.CancellationToken.None){const K=await this.j,B={type:"GET"},_={...K,...U.headers||{}};U={...U,...B,headers:_};const te=C.uri,ce=C.fallbackUri,he={...U,url:te};try{const pe=await this.k.request(he,z);if(pe.res.statusCode===200)return pe;const de=await(0,f.asTextOrError)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${de}`)}catch(pe){if((0,c.isCancellationError)(pe))throw pe;const de=(0,c.getErrorMessage)(pe);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:de});const Se={...U,url:ce};return this.k.request(Se,z)}}async E(C){let U=q(C);if(!U){const z=await this.C(C,N.CancellationToken.None);if(!z)throw new Error("Manifest was not found");U=z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const C=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(C),z=[],K={};if(U){for(const B of U.malicious)z.push({id:B});if(U.migrateToPreRelease)for(const[B,_]of Object.entries(U.migrateToPreRelease))(!_.engine||(0,d.isEngineValid)(_.engine,this.u.version,this.u.date))&&(K[B.toLowerCase()]={disallowInstall:!0,extension:{id:_.id,displayName:_.displayName,autoMigrate:{storage:!!_.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[B,_]of Object.entries(U.deprecated))_&&(K[B.toLowerCase()]=(0,D.isBoolean)(_)?{}:_)}return{malicious:z,deprecated:K}}};re=ye([J(1,f.IRequestService),J(2,E.ILogService),J(3,P.IEnvironmentService),J(4,y.ITelemetryService),J(5,p.IFileService),J(6,l.IProductService),J(7,S.IConfigurationService)],re);let G=class extends re{constructor(C,U,z,K,B,_,te,ce){super(C,U,z,K,B,_,te,ce)}};G=ye([J(0,g.IStorageService),J(1,f.IRequestService),J(2,E.ILogService),J(3,P.IEnvironmentService),J(4,y.ITelemetryService),J(5,p.IFileService),J(6,l.IProductService),J(7,S.IConfigurationService)],G),e.ExtensionGalleryService=G;let H=class extends re{constructor(C,U,z,K,B,_,te){super(void 0,C,U,z,K,B,_,te)}};H=ye([J(0,f.IRequestService),J(1,E.ILogService),J(2,P.IEnvironmentService),J(3,y.ITelemetryService),J(4,p.IFileService),J(5,l.IProductService),J(6,S.IConfigurationService)],H),e.ExtensionGalleryServiceWithNoStorageService=H}),define(oe[79],ae([0,1,5,3,2,20,33,26,21,9,11]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Xe extends c.Disposable{static b(p){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static c(p){const E=b.exec(p);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(p,E){const l=await p.getInstalled(),f=[];for(const[u,g]of Xe.f(E)){const y=l.find(k=>(0,T.areSameExtensions)(k.identifier,{id:u}))?.manifest.version;for(const k of g)y!==k&&f.push(Xe.b({id:u,version:k}))}for(const u of f)E.remove(u,0)}static f(p){const E=new Map,l=p.keys(0,1);for(const f of l){const u=Xe.c(f);if(u){let g=E.get(u.id.toLowerCase());g||E.set(u.id.toLowerCase(),g=[]),g.push(u.version)}}return E}constructor(p,E,l){super(),this.i=p,this.j=E,this.k=l,this.g=this.B(new N.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(p),this.B(this.i.onDidChangeValue(f=>this.l(f)))}l(p){if(p.scope!==0)return;if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const E=Xe.c(p.key);if(E){if(this.i.get(p.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let l=this.h.get(E.id.toLowerCase());l||this.h.set(E.id.toLowerCase(),l=[]),l.push(E.version),this.g.fire()}return}}m(p){if((0,P.isString)(p))return p;const E=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,T.getExtensionId)(E,l)}getExtensionState(p,E){const l=this.m(p),f=this.getExtensionStateRaw(p,E);if(f)try{return JSON.parse(f)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${E}): ${u}`)}}getExtensionStateRaw(p,E){const l=this.m(p),f=this.i.get(l,E?0:1);return f&&f?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${E}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(p,E,l){const f=this.m(p);E===void 0?this.i.remove(f,l?0:1):this.i.store(f,JSON.stringify(E),l?0:1,1)}setKeysForSync(p,E){this.i.store(Xe.b(p),JSON.stringify(E),0,1)}getKeysForSync(p){const E=this.j.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.i.get(Xe.b(p),0),f=l?JSON.parse(l):void 0;return f&&E?(0,I.distinct)([...f,...E]):f||E}addToMigrationList(p,E){if(p!==E){const l=this.n.filter(f=>!f.includes(p)&&!f.includes(E));l.push([p,E]),this.n=l}}getSourceExtensionToMigrate(p){const E=this.n.find(([,l])=>p===l);return E?E[0]:void 0}get n(){const p=this.i.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(p);if(Array.isArray(E))return E}catch{}return[]}set n(p){p.length?this.i.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([J(0,O.IStorageService),J(1,D.IProductService),J(2,S.ILogService)],m),e.ExtensionStorageService=m}),define(oe[274],ae([0,1,29,13,26,15,101,57,20,19,237]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends P.AbstractNativeExtensionTipsService{constructor(d,p,E,l,f,u,g,y){super(d.userHome,f,p,E,l,u,g,y)}};b=ye([J(0,O.INativeEnvironmentService),J(1,S.ITelemetryService),J(2,L.IExtensionManagementService),J(3,I.IStorageService),J(4,D.INativeHostService),J(5,T.IExtensionRecommendationNotificationService),J(6,N.IFileService),J(7,c.IProductService)],b),e.ExtensionTipsService=b}),define(oe[275],ae([0,1,6,2,23,66,20,75,18]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class S extends T.AbstractStorageService{constructor(b,m,d,p){super(),this.X=b,this.Y=m,this.Z=d,this.ab=p,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new N.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new N.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new D.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new O.Storage(b));return this.B(m.onDidChangeStorage(d=>this.n(-1,d))),m}cb(b){this.Q.clear(),this.P=b;let m;if((0,T.isProfileUsingDefaultStorage)(b))m=this.s;else{const d=this.Q.add(new D.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.Q.add(new O.Storage(d))}return this.Q.add(m.onDidChangeStorage(d=>this.n(0,d))),m}db(b){this.U.clear(),this.S=b?.id;let m;if(b){const d=this.U.add(new D.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.U.add(new O.Storage(d)),this.U.add(m.onDidChangeStorage(p=>this.n(1,p)))}return m}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,c.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,m){if(!this.H(this.P,b))return;const d=this.R,p=d.items;d!==this.s&&await d.close(),this.R=this.cb(b),await this.R.init(),this.I(p,this.R,0,m)}async O(b,m){const d=this.W,p=d?.items??new Map;await d?.close(),this.W=this.db(b),await this.W.init(),this.I(p,this.W,1,m)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.RemoteStorageService=S}),define(oe[276],ae([0,1,3,2,18,93]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class T{constructor(S,P){this.a=S,this.b=P}listen(S,P){const b=this.b(S);switch(P){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(d=>(0,O.transformOutgoingURIs)({...d},b)),added:m.added.map(d=>(0,O.transformOutgoingURIs)({...d},b)),removed:m.removed.map(d=>(0,O.transformOutgoingURIs)({...d},b)),updated:m.updated.map(d=>(0,O.transformOutgoingURIs)({...d},b))}))}throw new Error(`Invalid listen ${P}`)}async call(S,P,b){const m=this.b(S);switch(P){case"createProfile":{const d=await this.a.createProfile(b[0],b[1],b[2]);return(0,O.transformOutgoingURIs)({...d},m)}case"updateProfile":{let d=(0,c.reviveProfile)((0,O.transformIncomingURIs)(b[0],m),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,b[1]),(0,O.transformOutgoingURIs)({...d},m)}case"removeProfile":{const d=(0,c.reviveProfile)((0,O.transformIncomingURIs)(b[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=T;class D extends N.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(S,P,b){super(),this.profilesHome=P,this.f=b,this.a=[],this.b=this.B(new L.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=S.map(m=>(0,c.reviveProfile)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const d=m.added.map(l=>(0,c.reviveProfile)(l,this.profilesHome.scheme)),p=m.removed.map(l=>(0,c.reviveProfile)(l,this.profilesHome.scheme)),E=m.updated.map(l=>(0,c.reviveProfile)(l,this.profilesHome.scheme));this.a=m.all.map(l=>(0,c.reviveProfile)(l,this.profilesHome.scheme)),this.b.fire({added:d,removed:p,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(S){this.c=S}isEnabled(){return this.c}async createNamedProfile(S,P,b){const m=await this.f.call("createNamedProfile",[S,P,b]);return(0,c.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(S,P,b,m){const d=await this.f.call("createProfile",[S,P,b,m]);return(0,c.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(S){const P=await this.f.call("createTransientProfile",[S]);return(0,c.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(S,P){await this.f.call("setProfileForWorkspace",[S,P])}removeProfile(S){return this.f.call("removeProfile",[S])}async updateProfile(S,P){const b=await this.f.call("updateProfile",[S,P]);return(0,c.reviveProfile)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=D}),define(oe[61],ae([0,1,2,66,5,20,3,75,18]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,c.createDecorator)("IUserDataProfileStorageService");let S=class extends L.Disposable{constructor(d){super(),this.a=d}async readStorageData(d){return this.withProfileScopedStorageService(d,async p=>this.b(p))}async updateStorageData(d,p,E){return this.withProfileScopedStorageService(d,async l=>this.c(l,p,E))}async withProfileScopedStorageService(d,p){if(this.a.hasScope(d))return p(this.a);const E=await this.g(d),l=new b(E);try{await l.initialize();const f=await p(l);return await l.flush(),f}finally{l.dispose(),await this.f(E)}}b(d){const p=new Map,E=l=>{for(const f of d.keys(0,l))p.set(f,{value:d.get(f,0),target:l})};return E(0),E(1),p}c(d,p,E){for(const[l,f]of p)d.store(l,f,0,E)}async f(d){try{await d.close()}finally{(0,L.isDisposable)(d)&&d.dispose()}}};S=ye([J(0,O.IStorageService)],S),e.AbstractUserDataProfileStorageService=S;class P extends S{constructor(d,p,E,l){super(E),this.i=d;const f=d.getChannel("profileStorageListener"),u=this.B(new L.MutableDisposable);this.h=this.B(new T.Emitter({onWillAddFirstListener:()=>{u.value=f.listen("onDidChange")(g=>{l.trace("profile storage changes",g),this.h.fire({targetChanges:g.targetChanges.map(y=>(0,I.reviveProfile)(y,p.profilesHome.scheme)),valueChanges:g.valueChanges.map(y=>({...y,profile:(0,I.reviveProfile)(y.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(d){const p=this.i.getChannel("storage");return(0,O.isProfileUsingDefaultStorage)(d)?new D.ApplicationStorageDatabaseClient(p):new D.ProfileStorageDatabaseClient(p,d)}}e.RemoteUserDataProfileStorageService=P;class b extends O.AbstractStorageService{constructor(d){super({flushInterval:100}),this.p=this.B(new N.Storage(d))}J(){return this.p.init()}L(d){return d===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[277],ae([0,1,20,9,18,71,61]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let D=class extends T.RemoteUserDataProfileStorageService{constructor(S,P,b,m){super(S,P,b,m)}};D=ye([J(0,O.IMainProcessService),J(1,c.IUserDataProfilesService),J(2,L.IStorageService),J(3,N.ILogService)],D),e.NativeUserDataProfileStorageService=D}),define(oe[41],ae([0,1,21,6,16,25,3,35,2,27,11,182,17,15,13,9,44,20,19,30,24,18]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||o(h.syncData)))}e.isRemoteUserData=i;function o(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=o;function n(h,w){return`${(0,S.uppercaseFirstLetter)(h)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=n;let t=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(w,v,R,A,M,$,V,q,W,X,Q,Y){super(),this.syncResource=w,this.collection=v,this.C=R,this.D=A,this.F=M,this.G=$,this.H=V,this.I=q,this.J=W,this.L=X,this.M=Q,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new N.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=n(w.syncResource,w.profile),this.h=Y.extUri,this.f=this.h.joinPath(A.userDataSyncHome,...(0,y.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,y.PREVIEW_DIR_NAME),this.u=(0,y.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,A,this.h),this.j=(0,l.getServiceMachineId)(A,R,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const v=await this.U(w.remoteUserData,w.lastSyncUserData,!0,this.mb());this.P(v)}else{this.L.trace(`${this.y}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.sb(w):!0)&&this.t.fire()}}P(w){this.k!==w&&(this.k=w,this.l.fire(w))}async sync(w,v={}){await this.Q(w,!0,this.mb(),v)}async preview(w,v,R={}){return this.Q(w,!1,v,R)}async apply(w,v={}){try{this.z={...v};const R=await this.Y(w);return this.P(R),this.c}finally{this.z={}}}async Q(w,v,R,A){try{if(this.z={...A},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const $=await this.getLastSyncUserData(),V=await this.S(w,$);return M=await this.U(V,$,v,R),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(w){const v=this.ib(w);if(!v)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const R=await this.getLastSyncUserData(),A=await this.S(null,R),M=await this.R(A),$=await this.ob({ref:A.ref,syncData:v},R,M,this.mb(),O.CancellationToken.None),V=[];for(const q of $){const W=await this.qb(q,q.remoteResource,void 0,O.CancellationToken.None),{remoteChange:X}=await this.qb(q,q.previewResource,q.remoteContent,O.CancellationToken.None);V.push([q,{...W,remoteChange:X!==0?X:2}])}await this.rb(A,R,V,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(w){const v=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===v}async S(w,v){if(v){const R=w?w[this.resource]:void 0;if(v.ref===R||R===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async U(w,v,R,A){if(w.syncData&&w.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new y.UserDataSyncError((0,b.localize)(0,null,this.resource,this.nb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(w,v,R,A)}catch(M){if(M instanceof y.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(w,v,R,A);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.U(w,v,R,A)}throw M}}async W(w,v,R,A){try{const M=await this.R(w),$=!M&&v===null&&this.eb()!==void 0,V=R&&!$;this.c||(this.c=(0,N.createCancelablePromise)(W=>this.cb(w,v,M,V,A,W)));let q=await this.c;if(R&&$){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const W of q.resourcePreviews)q=await this.accept(W.remoteResource)||q}return this.ab(q.resourcePreviews),q.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":R?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(w){return await this.X(w,async v=>{const R=await this.pb(v,O.CancellationToken.None);await this.C.writeFile(v.previewResource,c.VSBuffer.fromString(R?.content||""));const A=R&&!R.hasConflicts?await this.qb(v,v.previewResource,void 0,O.CancellationToken.None):void 0;return v.acceptResult=A,v.mergeState=R.hasConflicts?"conflict":A?"accepted":"preview",v.localChange=A?A.localChange:R.localChange,v.remoteChange=A?A.remoteChange:R.remoteChange,v}),this.c}async accept(w,v){return await this.X(w,async R=>{const A=await this.qb(R,w,v,O.CancellationToken.None);return R.acceptResult=A,R.mergeState="accepted",R.localChange=A.localChange,R.remoteChange=A.remoteChange,R}),this.c}async discard(w){return await this.X(w,async v=>{const R=await this.pb(v,O.CancellationToken.None);return await this.C.writeFile(v.previewResource,c.VSBuffer.fromString(R.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=R.localChange,v.remoteChange=R.remoteChange,v}),this.c}async X(w,v){if(!this.c)return;let R=await this.c;const A=R.resourcePreviews.findIndex(({localResource:M,remoteResource:$,previewResource:V})=>this.h.isEqual(M,w)||this.h.isEqual($,w)||this.h.isEqual(V,w));A!==-1&&(this.c=(0,N.createCancelablePromise)(async M=>{const $=[...R.resourcePreviews];return $[A]=await v($[A]),{...R,resourcePreviews:$}}),R=await this.c,this.ab(R.resourcePreviews),R.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(w){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:R})=>R==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:R})=>R!=="accepted")?"syncing":(await this.rb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(R=>[R,R.acceptResult]),w),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}ab(w){const v=w.filter(({mergeState:R})=>R==="conflict");(0,L.equals)(this.m,v,(R,A)=>this.h.isEqual(R.previewResource,A.previewResource))||(this.m=v,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async bb(w){const v=this.c?await this.c:null;if(v)for(const R of v.resourcePreviews){if(this.h.isEqual(R.acceptedResource,w))return R.acceptResult?R.acceptResult.content:null;if(this.h.isEqual(R.remoteResource,w))return R.remoteContent;if(this.h.isEqual(R.localResource,w))return R.localContent;if(this.h.isEqual(R.baseResource,w))return R.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(w){(0,p.toFileOperationResult)(w)!==1&&this.L.error(w)}}async cb(w,v,R,A,M,$){const V=await this.ob(w,v,R,M,$),q=[];for(const W of V){const X=W.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)q.push({...W,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=A?await this.pb(W,$):void 0;if($.isCancellationRequested)break;await this.C.writeFile(W.previewResource,c.VSBuffer.fromString(Q?.content||""));const Y=Q&&!Q.hasConflicts?await this.qb(W,W.previewResource,void 0,$):void 0;q.push({...W,acceptResult:Y,mergeState:Q?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:Q?Q.localChange:W.localChange,remoteChange:Y?Y.remoteChange:Q?Q.remoteChange:W.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:R}}async getLastSyncUserData(){let w=this.eb();if(w||(w=await this.hb()),!w)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const v=JSON.parse(w),R=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!v.version&&!!R&&v.version!==R,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${R}.`),await this.resetLocal(),null;let A,M=1;for(;A===void 0&&M++<6;)try{const $=await this.fb();$&&($.ref===v.ref?A=$.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch($){if($ instanceof p.FileOperationError&&$.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if($ instanceof y.UserDataSyncError)throw $;this.L.error($,M)}}if(A===void 0)try{const $=await this.G.resolveResourceContent(this.resource,v.ref,this.collection,this.z);A=$===null?null:this.ib($),await this.gb({ref:v.ref,syncData:A})}catch($){if($ instanceof y.UserDataSyncError&&$.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw $}return A===void 0?null:{...v,syncData:A}}async db(w,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const R=this.I.getResourceSyncStateVersion(this.resource),A={ref:w.ref,version:R,...v};this.F.store(this.v,JSON.stringify(A),-1,1),await this.gb(w)}eb(){return this.F.get(this.v,-1)}async fb(){const w=(await this.C.readFile(this.u)).value.toString();try{const v=w?JSON.parse(w):void 0;if(i(v))return v}catch(v){this.L.error(v)}}async gb(w){await this.C.writeFile(this.u,c.VSBuffer.fromString(JSON.stringify(w)))}async hb(){try{const w=await this.C.readFile(this.u),v=JSON.parse(w.value.toString());await this.C.del(this.u),v.ref&&v.content!==void 0?(this.F.store(this.v,JSON.stringify({...v,content:void 0}),-1,1),await this.gb({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,v)}catch(w){w instanceof p.FileOperationError&&w.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(w)}return this.F.get(this.v,-1)}async getRemoteUserData(w){const{ref:v,content:R}=await this.jb(w);let A=null;return R!==null&&(A=this.ib(R)),{ref:v,syncData:A}}ib(w){try{const v=JSON.parse(w);if(o(v))return v}catch(v){this.L.error(v)}throw new y.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(w){const v=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.G.readResource(this.resource,v,this.collection,this.z)}async kb(w,v){const R=await this.j,A={version:this.nb,machineId:R,content:w};try{return v=await this.G.writeResource(this.resource,JSON.stringify(A),v,this.collection,this.z),{ref:v,syncData:A}}catch(M){throw M instanceof y.UserDataSyncError&&M.code==="TooLarge"&&(M=new y.UserDataSyncError(M.message,M.code,this.resource)),M}}async lb(w){const v={version:this.nb,content:w};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ye([J(2,p.IFileService),J(3,d.IEnvironmentService),J(4,f.IStorageService),J(5,y.IUserDataSyncStoreService),J(6,y.IUserDataSyncBackupStoreService),J(7,y.IUserDataSyncEnablementService),J(8,u.ITelemetryService),J(9,y.IUserDataSyncLogService),J(10,m.IConfigurationService),J(11,g.IUriIdentityService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(w,v,R,A,M,$,V,q,W,X,Q,Y,Z){super(v,R,A,M,$,V,q,W,X,Q,Y,Z),this.i=w,this.B(this.C.watch(this.h.dirname(w))),this.B(this.C.onDidFilesChange(x=>this.ub(x)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(w,v,R){try{v?await this.C.writeFile(this.i,c.VSBuffer.fromString(w),R?void 0:v):await this.C.createFile(this.i,c.VSBuffer.fromString(w),{overwrite:R})}catch(A){throw A instanceof p.FileOperationError&&A.fileOperationResult===1||A instanceof p.FileOperationError&&A.fileOperationResult===3?new y.UserDataSyncError(A.message,"LocalPreconditionFailed"):A}}async tb(){try{await this.C.del(this.i)}catch(w){if(!(w instanceof p.FileOperationError&&w.fileOperationResult===1))throw w}}ub(w){!w.contains(this.i)||this.N()}};s=ye([J(3,p.IFileService),J(4,d.IEnvironmentService),J(5,f.IStorageService),J(6,y.IUserDataSyncStoreService),J(7,y.IUserDataSyncBackupStoreService),J(8,y.IUserDataSyncEnablementService),J(9,u.ITelemetryService),J(10,y.IUserDataSyncLogService),J(11,m.IConfigurationService),J(12,g.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(w,v,R,A,M,$,V,q,W,X,Q,Y,Z,x){super(w,v,R,A,M,$,V,q,W,X,Q,Z,x),this.vb=Y,this.xb=void 0}wb(w,v){const R=[],A=(0,D.parse)(w,R,{allowEmptyContent:!0,allowTrailingComma:!0});return R.length>0||!(0,P.isUndefined)(A)&&v!==Array.isArray(A)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};r=ye([J(3,p.IFileService),J(4,d.IEnvironmentService),J(5,f.IStorageService),J(6,y.IUserDataSyncStoreService),J(7,y.IUserDataSyncBackupStoreService),J(8,y.IUserDataSyncEnablementService),J(9,u.ITelemetryService),J(10,y.IUserDataSyncLogService),J(11,y.IUserDataSyncUtilService),J(12,m.IConfigurationService),J(13,g.IUriIdentityService)],r),e.AbstractJsonFileSynchroniser=r;let a=class{constructor(w,v,R,A,M,$,V){this.resource=w,this.g=v,this.h=R,this.j=A,this.k=M,this.l=$,this.d=V.extUri,this.f=(0,y.getLastSyncResourceUri)(void 0,this.resource,R,this.d)}async initialize({ref:w,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const R=this.m(v);if(!!R)try{await this.o({ref:w,syncData:R})}catch(A){this.j.error(A)}}m(w){try{const v=JSON.parse(w);if(o(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const R={ref:w.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(R),-1,1),await this.k.writeFile(this.f,c.VSBuffer.fromString(JSON.stringify(w)))}};a=ye([J(1,k.IUserDataProfilesService),J(2,d.IEnvironmentService),J(3,E.ILogService),J(4,p.IFileService),J(5,f.IStorageService),J(6,g.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[121],ae([0,1,6,25,10,3,42,2,27,17,15,120,29,33,79,13,5,70,9,20,19,30,18,41,258,118,24,61]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o,n,t,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(M,$){const V=JSON.parse(M.content);if(M.version===1||M.version===2){const q=(await $.getInstalled(0)).filter(W=>W.isBuiltin);for(const W of V)M.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),M.version===2&&q.every(X=>!(0,d.areSameExtensions)(X.identifier,W.identifier))&&(W.installed=!0)}return V}function h(M){return JSON.parse(M.content)}e.parseExtensions=h;function w(M,$){return M.sort((V,q)=>!V.identifier.uuid&&q.identifier.uuid?-1:V.identifier.uuid&&!q.identifier.uuid?1:(0,I.compare)(V.identifier.id,q.identifier.id)),$?(0,T.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=w;let v=class extends o.AbstractSynchroniser{constructor($,V,q,W,X,Q,Y,Z,x,j,ee,ne,re,G,H,F,C){super({syncResource:"extensions",profile:$},V,W,q,X,Q,Y,ne,re,j,ee,H),this.zb=Z,this.Ab=x,this.Bb=C,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(R),this.B(O.Event.any(O.Event.filter(this.zb.onDidInstallExtensions,U=>U.some(({local:z})=>!!z)),O.Event.filter(this.zb.onDidUninstallExtension,U=>!U.error),O.Event.filter(F.onDidChange,U=>U.valueChanges.some(({profile:z,changes:K})=>this.syncResource.profile.id===z.id&&K.some(B=>B.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),G.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob($,V){const q=$.syncData?await a($.syncData,this.zb):null,W=V?.skippedExtensions??[],X=V?.builtinExtensions??null,Q=V?.syncData?await a(V.syncData,this.zb):null,{localExtensions:Y,ignoredExtensions:Z}=await this.yb.getLocalExtensions(this.syncResource.profile);q?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:x,remote:j}=(0,n.merge)(Y,q,Q,W,Z,X),ee={local:x,remote:j,content:this.Eb(Y,x.added,x.updated,x.removed),localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:j!==null?2:0},ne=this.Lb(Y,!1);return[{skippedExtensions:W,builtinExtensions:X,baseResource:this.ub,baseContent:Q?this.Lb(Q,!1):ne,localResource:this.vb,localContent:ne,localExtensions:Y,remoteResource:this.wb,remoteExtensions:q,remoteContent:q?this.Lb(q,!1):null,previewResource:this.tb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.xb}]}async sb($){const V=$.syncData?await a($.syncData,this.zb):null,{localExtensions:q,ignoredExtensions:W}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,n.merge)(q,V,V,$.skippedExtensions||[],W,$.builtinExtensions||[]);return X!==null}Eb($,V,q,W){const X=[...V,...q],Q=new Set,Y=Z=>{Q.add(Z.id.toLowerCase()),Z.uuid&&Q.add(Z.uuid)};X.forEach(({identifier:Z})=>Y(Z)),W.forEach(Y);for(const Z of $)Q.has(Z.identifier.id.toLowerCase())||Z.identifier.uuid&&Q.has(Z.identifier.uuid)||X.push(Z);return this.Lb(X,!1)}async pb($,V){return{...$.previewResult,hasConflicts:!1}}async qb($,V,q,W){if(this.h.isEqual(V,this.vb))return this.Hb($);if(this.h.isEqual(V,this.wb))return this.Ib($);if(this.h.isEqual(V,this.tb))return $.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async Hb($){const V=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.Ab.getIgnoredExtensions(V),W=(0,n.merge)($.localExtensions,null,null,$.skippedExtensions,q,$.builtinExtensions),{local:X,remote:Q}=W;return{content:$.localContent,local:X,remote:Q,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:Q!==null?2:0}}async Ib($){const V=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),q=this.Ab.getIgnoredExtensions(V),W=$.remoteContent?JSON.parse($.remoteContent):null;if(W!==null){const X=(0,n.merge)($.localExtensions,W,$.localExtensions,[],q,$.builtinExtensions),{local:Q,remote:Y}=X;return{content:$.remoteContent,local:Q,remote:Y,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:$.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb($,V,q,W){let{skippedExtensions:X,builtinExtensions:Q,localExtensions:Y}=q[0][0];const{local:Z,remote:x,localChange:j,remoteChange:ee}=q[0][1];if(j===0&&ee===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),j!==0&&(await this.lb(JSON.stringify(Y)),X=await this.yb.updateLocalExtensions(Z.added,Z.removed,Z.updated,X,this.syncResource.profile)),x){this.L.trace(`${this.y}: Updating remote extensions...`);const ne=JSON.stringify(x.all);$=await this.kb(ne,W?null:$.ref),this.L.info(`${this.y}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(re=>re.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(re=>re.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(re=>re.identifier.id))}.`:""}`)}V?.ref!==$.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),Q=this.Kb(Y,Q),await this.db($,{skippedExtensions:X,builtinExtensions:Q}),this.L.info(`${this.y}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ne=>ne.identifier.id))}.`:""}`))}Kb($,V){const q=new Set,W=[];for(const X of $)q.add(X.identifier.id.toLowerCase()),X.installed||W.push(X.identifier);if(V)for(const X of V)q.has(X.id.toLowerCase())||W.push(X);return W}async resolveContent($){if(this.h.isEqual(this.wb,$)||this.h.isEqual(this.ub,$)||this.h.isEqual(this.vb,$)||this.h.isEqual(this.xb,$)){const V=await this.bb($);return V&&this.Lb(JSON.parse(V),!0)}return null}Lb($,V){return w($,V)}async hasLocalData(){try{const{localExtensions:$}=await this.yb.getLocalExtensions(this.syncResource.profile);if($.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};v=ye([J(2,P.IEnvironmentService),J(3,E.IFileService),J(4,g.IStorageService),J(5,s.IUserDataSyncStoreService),J(6,s.IUserDataSyncBackupStoreService),J(7,m.IExtensionManagementService),J(8,t.IIgnoredExtensionsManagementService),J(9,s.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,s.IUserDataSyncEnablementService),J(12,y.ITelemetryService),J(13,p.IExtensionStorageService),J(14,k.IUriIdentityService),J(15,r.IUserDataProfileStorageService),J(16,l.IInstantiationService)],v),e.ExtensionsSynchroniser=v;let R=class{constructor($,V,q,W,X,Q){this.a=$,this.b=V,this.c=q,this.d=W,this.f=X,this.g=Q}async getLocalExtensions($){const V=await this.a.getInstalled(void 0,$.extensionsResource),q=this.d.getIgnoredExtensions(V);return{localExtensions:await this.j($,async(X,Q)=>{const Y=X.getDisabledExtensions();return V.map(Z=>{const{identifier:x,isBuiltin:j,manifest:ee,preRelease:ne,pinned:re}=Z,G={identifier:x,preRelease:ne,version:ee.version,pinned:!!re};Y.some(H=>(0,d.areSameExtensions)(H,x))&&(G.disabled=!0),j||(G.installed=!0);try{const H=Q.getKeysForSync({id:x.id,version:ee.version});if(H){const F=Q.getExtensionState(Z,!0)||{};G.state=Object.keys(F).reduce((C,U)=>(H.includes(U)&&(C[U]=F[U]),C),{})}}catch(H){this.g.info(`${(0,o.getSyncResourceLogLabel)("extensions",$)}: Error while parsing extension state`,(0,c.getErrorMessage)(H))}return G})}),ignoredExtensions:q}}async updateLocalExtensions($,V,q,W,X){const Q=(0,o.getSyncResourceLogLabel)("extensions",X),Y=[],Z=[],x=[],j=await this.a.getInstalled(void 0,X.extensionsResource);if(($.length||q.length)&&await this.j(X,async(ne,re)=>{await L.Promises.settled([...$,...q].map(async G=>{const H=j.find(U=>(0,d.areSameExtensions)(U.identifier,G.identifier));if(H&&H.isBuiltin){G.state&&H.manifest.version===G.version&&this.h(G.state,H,H.manifest.version,re),ne.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${Q}: Disabling extension...`,G.identifier.id),await ne.disableExtension(G.identifier),this.g.info(`${Q}: Disabled extension`,G.identifier.id)):(this.g.trace(`${Q}: Enabling extension...`,G.identifier.id),await ne.enableExtension(G.identifier),this.g.info(`${Q}: Enabled extension`,G.identifier.id))),Z.push(G.identifier);return}const F=G.pinned?G.version:void 0,C=(await this.c.getExtensions([{...G.identifier,version:F,preRelease:F?void 0:G.preRelease}],N.CancellationToken.None))[0];if(G.state&&(H?H.manifest.version===G.version:!!C)&&this.h(G.state,H||C,H?.manifest.version,re),C)try{ne.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${Q}: Disabling extension...`,G.identifier.id,C.version),await ne.disableExtension(C.identifier),this.g.info(`${Q}: Disabled extension`,G.identifier.id,C.version)):(this.g.trace(`${Q}: Enabling extension...`,G.identifier.id,C.version),await ne.enableExtension(C.identifier),this.g.info(`${Q}: Enabled extension`,G.identifier.id,C.version))),(!H||H.preRelease!==G.preRelease||H.pinned!==G.pinned||F&&H.manifest.version!==F)&&(await this.a.canInstall(C)?Y.push([G,C]):(this.g.info(`${Q}: Skipped synchronizing extension because it cannot be installed.`,C.displayName||C.identifier.id),x.push(G)))}catch(U){x.push(G),this.g.error(U),this.g.info(`${Q}: Skipped synchronizing extension`,C.displayName||C.identifier.id)}else x.push(G),this.g.info(`${Q}: Skipped synchronizing extension because the extension is not found.`,G.identifier.id)}))}),V.length){const ne=j.filter(({identifier:re,isBuiltin:G})=>!G&&V.some(H=>(0,d.areSameExtensions)(re,H)));await L.Promises.settled(ne.map(async re=>{this.g.trace(`${Q}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${Q}: Uninstalled local extension.`,re.identifier.id),Z.push(re.identifier)}))}for(const[ne,re]of Y)try{this.g.trace(`${Q}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ne.pinned&&!!ne.version,installPreReleaseVersion:ne.preRelease,profileLocation:X.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${Q}: Installed extension.`,re.identifier.id,re.version),Z.push(re.identifier)}catch(G){x.push(ne),G instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(G.code)?this.g.info(`${Q}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(G),this.g.info(`${Q}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const ee=[];for(const ne of W)Z.some(re=>(0,d.areSameExtensions)(re,ne.identifier))||ee.push(ne);for(const ne of x)ee.some(re=>(0,d.areSameExtensions)(re.identifier,ne.identifier))||ee.push(ne);return ee}h($,V,q,W){const X=W.getExtensionState(V,!0)||{},Q=q?W.getKeysForSync({id:V.identifier.id,version:q}):void 0;Q?Q.forEach(Y=>{X[Y]=$[Y]}):Object.keys($).forEach(Y=>X[Y]=$[Y]),W.setExtensionState(V,X,!0)}async j($,V){return this.b.withProfileScopedStorageService($,async q=>{const W=new D.DisposableStore,X=this.f.createChild(new f.ServiceCollection([g.IStorageService,q])),Q=W.add(X.createInstance(b.GlobalExtensionEnablementService)),Y=W.add(X.createInstance(p.ExtensionStorageService));try{return await V(Q,Y)}finally{W.dispose()}})}};R=ye([J(0,m.IExtensionManagementService),J(1,r.IUserDataProfileStorageService),J(2,m.IExtensionGalleryService),J(3,t.IIgnoredExtensionsManagementService),J(4,l.IInstantiationService),J(5,s.IUserDataSyncLogService)],R),e.LocalExtensionsProvider=R;let A=class extends o.AbstractInitializer{constructor($,V,q,W,X,Q,Y,Z){super("extensions",W,X,Q,q,Y,Z),this.p=$,this.q=V}async t($){return $.syncData?await a($.syncData,this.p):null}u($,V){const q=[],W=[],X=[];for(const Q of $){if(this.q.hasToNeverSyncExtension(Q.identifier.id))continue;const Y=V.find(Z=>(0,d.areSameExtensions)(Z.identifier,Q.identifier));Y?(q.push(Y),Q.disabled&&X.push(Q.identifier)):Q.installed&&(W.push({...Q.identifier,preRelease:!!Q.preRelease}),Q.disabled&&X.push(Q.identifier))}return{installedExtensions:q,newExtensions:W,disabledExtensions:X,remoteExtensions:$}}};A=ye([J(0,m.IExtensionManagementService),J(1,t.IIgnoredExtensionsManagementService),J(2,E.IFileService),J(3,i.IUserDataProfilesService),J(4,P.IEnvironmentService),J(5,u.ILogService),J(6,g.IStorageService),J(7,k.IUriIdentityService)],A),e.AbstractExtensionsInitializer=A}),define(oe[122],ae([0,1,16,10,3,35,42,4,31,17,15,13,9,44,20,19,30,41,60,262,24,18,61,5]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",t=["locale"];function s(R,A){const M=R.storage?Object.keys(R.storage).sort():[],$={};return M.forEach(V=>$[V]=R.storage[V]),R.storage=$,A?(0,T.toFormattedString)(R,{}):JSON.stringify(R)}e.stringify=s;const r=1;let a=class extends f.AbstractSynchroniser{constructor(A,M,$,V,q,W,X,Q,Y,Z,x,j,ee,ne){super({syncResource:"globalState",profile:A},M,V,Q,j,q,W,Y,Z,X,x,ee),this.xb=$,this.nb=r,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ne.createInstance(h),this.B(V.watch(this.h.dirname(this.D.argvResource))),this.B(c.Event.any(c.Event.filter(V.onDidFilesChange,re=>re.contains(this.D.argvResource)),c.Event.filter($.onDidChange,re=>!!(re.targetChanges.some(G=>this.syncResource.profile.id===G.id)||re.valueChanges.some(({profile:G,changes:H})=>this.syncResource.profile.id===G.id&&H.some(F=>F.target===0)))))(()=>this.N()))}async ob(A,M,$){const V=A.syncData?JSON.parse(A.syncData.content):null;M=M===null&&$?A:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,W=await this.wb.getLocalGlobalState(this.syncResource.profile);V?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Fb(q),{local:Q,remote:Y}=(0,g.merge)(W.storage,V?V.storage:null,q?q.storage:null,X,this.L),Z={content:null,local:Q,remote:Y,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},x=s(W,!1);return[{baseResource:this.r,baseContent:q?s(q,!1):x,localResource:this.tb,localContent:x,localUserData:W,remoteResource:this.ub,remoteContent:V?s(V,!1):null,previewResource:this.p,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.vb,storageKeys:X}]}async sb(A){const M=A.syncData?JSON.parse(A.syncData.content):null;if(M===null)return!0;const $=await this.wb.getLocalGlobalState(this.syncResource.profile),V=await this.Fb(M),{remote:q}=(0,g.merge)($.storage,M.storage,M.storage,V,this.L);return q.all!==null}async pb(A,M){return{...A.previewResult,hasConflicts:!1}}async qb(A,M,$,V){if(this.h.isEqual(M,this.tb))return this.Cb(A);if(this.h.isEqual(M,this.ub))return this.Db(A);if(this.h.isEqual(M,this.p))return A.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Cb(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(A.localUserData.storage),removed:[],updated:[],all:A.localUserData.storage},localChange:0,remoteChange:2}}async Db(A){if(A.remoteContent!==null){const M=JSON.parse(A.remoteContent),{local:$,remote:V}=(0,g.merge)(A.localUserData.storage,M.storage,null,A.storageKeys,this.L);return{content:A.remoteContent,local:$,remote:V,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(A,M,$,V){const{localUserData:q}=$[0][0],{local:W,remote:X,localChange:Q,remoteChange:Y}=$[0][1];if(Q===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Q!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(q)),await this.wb.writeLocalGlobalState(W,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Y!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const Z=JSON.stringify({storage:X.all});A=await this.kb(Z,V?null:A.ref),this.L.info(`${this.y}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}M?.ref!==A.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.db(A),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(A){if(this.h.isEqual(this.ub,A)||this.h.isEqual(this.r,A)||this.h.isEqual(this.tb,A)||this.h.isEqual(this.vb,A)){const M=await this.bb(A);return M&&s(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:A}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(A).length>1||A[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(A){const M=await this.xb.readStorageData(this.syncResource.profile),$=[],V=[];for(const[X,Q]of M)Q.target===0?$.push(X):Q.target===1&&V.push(X);const q=[...$,...V],W=A?.storage?Object.keys(A.storage).filter(X=>!X.startsWith(n)&&!q.includes(X)&&M.get(X)!==void 0):[];if(!D.isWeb){const X=[...y.ALL_SYNC_RESOURCES.map(Q=>(0,y.getEnablementKey)(Q)),y.SYNC_SERVICE_URL_TYPE];W.push(...X),V.push(...X)}return{user:$,machine:V,unregistered:W}}};a=ye([J(2,i.IUserDataProfileStorageService),J(3,b.IFileService),J(4,y.IUserDataSyncStoreService),J(5,y.IUserDataSyncBackupStoreService),J(6,y.IUserDataSyncLogService),J(7,P.IEnvironmentService),J(8,y.IUserDataSyncEnablementService),J(9,E.ITelemetryService),J(10,S.IConfigurationService),J(11,p.IStorageService),J(12,l.IUriIdentityService),J(13,o.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let h=class{constructor(A,M,$,V){this.a=A,this.b=M,this.c=$,this.d=V}async getLocalGlobalState(A){const M={};if(A.isDefault){const V=await this.f(),q=(0,O.parse)(V);for(const W of t)q[W]!==void 0&&(M[`${n}${W}`]={version:1,value:q[W]})}const $=await this.c.readStorageData(A);for(const[V,q]of $)q.value&&q.target===0&&(M[V]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const A=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),A.value.toString()}catch(A){this.d.debug((0,N.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:M,updated:$},V){const q=(0,f.getSyncResourceLogLabel)("globalState",V),W={},X=new Map,Q=await this.c.readStorageData(V),Y=(Z,x)=>{for(const j of Z){if(j.startsWith(n)){W[j.substring(n.length)]=x?x[j].value:void 0;continue}if(x){const ee=x[j];ee.value!==Q.get(j)?.value&&X.set(j,ee.value)}else Q.get(j)!==void 0&&X.set(j,void 0)}};if(Y(Object.keys(A),A),Y(Object.keys($),$),Y(M),Object.keys(W).length){this.d.trace(`${q}: Updating locale...`);const Z=await this.f();let x=Z;for(const j of Object.keys(W))x=(0,u.edit)(x,[j],W[j],{});Z!==x&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(x)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}X.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(V,X,0),this.d.info(`${q}: Updated global state`,[...X.keys()]))}};h=ye([J(0,b.IFileService),J(1,P.IEnvironmentService),J(2,i.IUserDataProfileStorageService),J(3,y.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let w=class extends f.AbstractInitializer{constructor(A,M,$,V,q,W){super("globalState",$,V,q,M,A,W)}async o(A){const M=A.syncData?JSON.parse(A.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const $={},V={};for(const q of Object.keys(M.storage))q.startsWith(n)?$[q.substring(n.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(V[q]=M.storage[q].value);if(Object.keys($).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const W of Object.keys($))q=(0,u.edit)(q,[W],$[W],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString(q))}if(Object.keys(V).length)for(const q of Object.keys(V))this.l.store(q,V[q],0,0)}};w=ye([J(0,p.IStorageService),J(1,b.IFileService),J(2,k.IUserDataProfilesService),J(3,P.IEnvironmentService),J(4,y.IUserDataSyncLogService),J(5,l.IUriIdentityService)],w),e.GlobalStateInitializer=w;let v=class{constructor(A,M,$,V,q){this.a=A,this.b=M,this.c=$,this.d=V,this.f=q}getSyncStoreType(A){return this.h(A)?.storage[y.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const M=(0,y.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(A,M)}catch($){if($ instanceof y.UserDataSyncError)switch($.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(A,M)}throw $}}async g(A,M){const $=await this.a.readResource("globalState",null,void 0,M),V=this.h($)||{storage:{}};V.storage[y.SYNC_SERVICE_URL_TYPE]={value:A,version:r};const q=await(0,d.getServiceMachineId)(this.c,this.d,this.b),W={version:r,machineId:q,content:s(V,!1)};await this.a.writeResource("globalState",JSON.stringify(W),$.ref,void 0,M)}h({content:A}){if(!A)return null;const M=JSON.parse(A);if((0,f.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};v=ye([J(1,p.IStorageService),J(2,P.IEnvironmentService),J(3,b.IFileService),J(4,m.ILogService)],v),e.UserDataSyncStoreTypeSynchronizer=v}),define(oe[123],ae([0,1,21,16,3,35,4,11,183,17,15,13,20,19,30,18,41,259,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(i,o,n){try{const t=JSON.parse(i);if(!o)return(0,D.isUndefined)(t.all)?null:t.all;switch(T.OS){case 2:return(0,D.isUndefined)(t.mac)?null:t.mac;case 3:return(0,D.isUndefined)(t.linux)?null:t.linux;case 1:return(0,D.isUndefined)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}e.getKeybindingsContentFromSyncContent=g;let y=class extends l.AbstractJsonFileSynchroniser{constructor(o,n,t,s,r,a,h,w,v,R,A,M,$){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,v,R,t,s,h,M,r,A,a,$),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(c.Event.filter(a.onDidChangeConfiguration,V=>V.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(o,n,t,s){const r=o.syncData?g(o.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;n=n===null&&t?o:n;const a=n?this.Kb(n):null,h=await this.p(),w=await this.yb();let v=null,R=!1,A=!1,M=!1;if(r){let q=h?h.value.toString():"[]";if(q=q||"[]",this.wb(q,!0))throw new u.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const W=await(0,f.merge)(q,r,a,w,this.vb);W.hasChanges&&(v=W.mergeContent,M=W.hasConflicts,R=M||W.mergeContent!==q,A=M||W.mergeContent!==r)}}else h&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=h.value.toString(),A=!0);const $={content:M?a:v,localChange:R?h?2:1:0,remoteChange:A?2:0,hasConflicts:M},V=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Bb,baseContent:a,localResource:this.Cb,localContent:V,localChange:$.localChange,remoteResource:this.Db,remoteContent:r,remoteChange:$.remoteChange,previewResource:this.Ab,previewResult:$,acceptedResource:this.Eb}]}async sb(o){const n=this.Kb(o);if(n===null)return!0;const t=await this.p(),s=t?t.value.toString():"",r=await this.yb(),a=await(0,f.merge)(s||"[]",n,n,r,this.vb);return a.hasConflicts||a.mergeContent!==n}async pb(o,n){return o.previewResult}async qb(o,n,t,s){if(this.h.isEqual(n,this.Cb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Db))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Ab))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async rb(o,n,t,s){const{fileContent:r}=t[0][0];let{content:a,localChange:h,remoteChange:w}=t[0][1];if(h===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.wb(a,!0)))throw new u.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),r&&await this.lb(this.Lb(r.value.toString())),await this.r(a||"[]",r,s),this.L.info(`${this.y}: Updated local keybindings`)),w!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const v=this.Lb(a||"[]",o.syncData?.content);o=await this.kb(v,s?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.Ab)}catch{}n?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.db(o,{platformSpecific:this.Mb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const n=(0,O.parse)(o.value.toString());if((0,L.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Db,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Eb,o)?this.bb(o):null}Kb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Mb()?null:g(o.syncData.content,this.Mb(),this.L)}Lb(o,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete t.all:t.all=o,T.OS){case 2:t.mac=o;break;case 3:t.linux=o;break;case 1:t.windows=o;break}return JSON.stringify(t)}Mb(){return!!this.M.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};y=ye([J(2,u.IUserDataSyncStoreService),J(3,u.IUserDataSyncBackupStoreService),J(4,u.IUserDataSyncLogService),J(5,S.IConfigurationService),J(6,u.IUserDataSyncEnablementService),J(7,b.IFileService),J(8,P.IEnvironmentService),J(9,m.IStorageService),J(10,u.IUserDataSyncUtilService),J(11,d.ITelemetryService),J(12,p.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let k=class extends l.AbstractInitializer{constructor(o,n,t,s,r,a){super("keybindings",n,t,s,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.VSBuffer.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,O.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return g(o,!0,this.j)}catch(n){return this.j.error(n),null}}};k=ye([J(0,b.IFileService),J(1,E.IUserDataProfilesService),J(2,P.IEnvironmentService),J(3,u.IUserDataSyncLogService),J(4,m.IStorageService),J(5,p.IUriIdentityService)],k),e.KeybindingsInitializer=k}),define(oe[124],ae([0,1,16,3,184,17,73,15,29,13,20,19,30,18,41,60,263,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function g(i){const o=JSON.parse(i);return u(o)?o:{settings:i}}e.parseSettingsSyncContent=g;let y=class extends p.AbstractJsonFileSynchroniser{constructor(o,n,t,s,r,a,h,w,v,R,A,M,$,V){super(o.settingsResource,{syncResource:"settings",profile:o},n,t,s,r,a,h,A,M,w,v,R,V),this.Ab=$,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(o){const n=await this.getLastSyncUserData(),t=await this.S(o,n),s=this.Hb(t),r=new T.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&r.parse(s.settings),r.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(o,n,t){const s=await this.p(),r=await this.yb(),a=this.Hb(o);n=n===null&&t?o:n;const h=n?this.Hb(n):null,w=await this.Lb();let v=null,R=!1,A=!1,M=!1;if(a){let W=s?s.value.toString().trim():"{}";W=W||"{}",this.Mb(W),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const X=(0,l.merge)(W,a.settings,h?h.settings:null,w,[],r);v=X.localContent||X.remoteContent,R=X.localContent!==null,A=X.remoteContent!==null,M=X.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Mb(v),A=!0);const $=s?s.value.toString():null,V=h?.settings??null,q={content:M?V:v,localChange:R?2:0,remoteChange:A?2:0,hasConflicts:M};return[{fileContent:s,baseResource:this.baseResource,baseContent:V,localResource:this.localResource,localContent:$,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async sb(o){const n=this.Hb(o);if(n===null)return!0;const t=await this.p(),s=t?t.value.toString().trim():"",r=await this.Lb(),a=await this.yb();return(0,l.merge)(s||"{}",n.settings,n.settings,r,[],a).remoteContent!==null}async pb(o,n){const t=await this.yb(),s=await this.Lb();return{...o.previewResult,content:o.previewResult.content?(0,l.updateIgnoredSettings)(o.previewResult.content,"{}",s,t):null}}async qb(o,n,t,s){const r=await this.yb(),a=await this.Lb();if(this.h.isEqual(n,this.localResource))return{content:o.fileContent?(0,l.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,r):null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.remoteResource))return{content:o.remoteContent!==null?(0,l.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,r):null,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.previewResource))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t!==null?(0,l.updateIgnoredSettings)(t,o.fileContent?o.fileContent.value.toString():"{}",a,r):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async rb(o,n,t,s){const{fileContent:r}=t[0][0];let{content:a,localChange:h,remoteChange:w}=t[0][1];if(h===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Mb(a),h!==0&&(this.L.trace(`${this.y}: Updating local settings...`),r&&await this.lb(JSON.stringify(this.Jb(r.value.toString()))),await this.r(a,r,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const v=await this.yb(),R=this.Hb(o),A=await this.Lb(a);a=(0,l.updateIgnoredSettings)(a,R?R.settings:"{}",A,v),this.L.trace(`${this.y}: Updating remote settings...`),o=await this.kb(JSON.stringify(this.Jb(a)),s?null:o.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.db(o),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.p();if(o){const n=await this.yb(),t=(0,E.edit)(o.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,l.isEmpty)(t)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)||this.h.isEqual(this.baseResource,o)?this.bb(o):null}async bb(o){let n=await super.bb(o);if(n){const t=await this.yb(),s=await this.Lb();n=(0,l.updateIgnoredSettings)(n,"{}",s,t)}return n}Hb(o){return o.syncData?this.Ib(o.syncData.content):null}Ib(o){try{return g(o)}catch(n){this.L.error(n)}return null}Jb(o){return{settings:o}}async Lb(o){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const t=N.Event.any(N.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:r})=>!!r)),N.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this.Kb=void 0})}const n=await this.Kb;return(0,l.getIgnoredSettings)(n,this.M,o)}Mb(o){if(this.wb(o,!1))throw new f.UserDataSyncError((0,c.localize)(0,null),"LocalInvalidContent",this.resource)}};y=ye([J(2,S.IFileService),J(3,D.IEnvironmentService),J(4,P.IStorageService),J(5,f.IUserDataSyncStoreService),J(6,f.IUserDataSyncBackupStoreService),J(7,f.IUserDataSyncLogService),J(8,f.IUserDataSyncUtilService),J(9,O.IConfigurationService),J(10,f.IUserDataSyncEnablementService),J(11,b.ITelemetryService),J(12,I.IExtensionManagementService),J(13,m.IUriIdentityService)],y),e.SettingsSynchroniser=y;let k=class extends p.AbstractInitializer{constructor(o,n,t,s,r,a){super("settings",n,t,s,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(n.settings)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,l.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}p(o){try{return g(o)}catch(n){this.j.error(n)}return null}};k=ye([J(0,S.IFileService),J(1,d.IUserDataProfilesService),J(2,D.IEnvironmentService),J(3,f.IUserDataSyncLogService),J(4,P.IStorageService),J(5,m.IUriIdentityService)],k),e.SettingsInitializer=k}),define(oe[125],ae([0,1,16,3,32,17,15,13,20,19,30,18,41,260,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(u){return JSON.parse(u.content)}e.parseSnippets=E;let l=class extends m.AbstractSynchroniser{constructor(g,y,k,i,o,n,t,s,r,a,h,w){super({syncResource:"snippets",profile:g},y,i,k,o,n,t,a,h,s,r,w),this.nb=1,this.p=g.snippetsHome,this.B(this.C.watch(k.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(N.Event.filter(this.C.onDidFilesChange,v=>v.affects(this.p))(()=>this.N()))}async ob(g,y,k){const i=await this.Db(),o=this.Cb(i),n=g.syncData?this.Bb(g.syncData):null;y=y===null&&k?g:y;const t=y&&y.syncData?this.Bb(y.syncData):null;n?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(o,n,t);return this.xb(s,i,n||{},t||{})}async sb(g){const y=g.syncData?this.Bb(g.syncData):null;if(y===null)return!0;const k=await this.Db(),i=this.Cb(k),o=(0,d.merge)(i,y,y);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async pb(g,y){return g.previewResult}async qb(g,y,k,i){if(this.h.isEqualOrParent(y,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(y,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(y,this.g))return k===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:k,localChange:k===null?g.fileContent!==null?3:0:2,remoteChange:k===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async rb(g,y,k,i){const o=k.map(([n,t])=>({...n,acceptResult:t}));o.every(({localChange:n,remoteChange:t})=>n===0&&t===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.yb(o),await this.zb(o,i)),o.some(({remoteChange:n})=>n!==0)&&(g=await this.Ab(o,g,i)),y?.ref!==g.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.db(g),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.C.del(n)}catch{}}xb(g,y,k,i){const o=new Map;for(const n of Object.keys(g.local.added)){const t={content:g.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.local.updated)){const t={content:g.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.added)){const t={content:g.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.updated)){const t={content:g.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.conflicts){const t={content:i[n]??null,hasConflicts:!0,localChange:y[n]?2:1,remoteChange:k[n]?2:1},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(y))if(!o.has(n)){const t={content:y[n]?y[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=y[n]?y[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(g){return this.h.isEqualOrParent(g,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(g,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(g,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(g,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(g):null}async hasLocalData(){try{const g=await this.Db();if(Object.keys(g).length)return!0}catch{}return!1}async yb(g){const y={};for(const k of g)k.fileContent&&(y[this.h.basename(k.localResource)]=k.fileContent);await this.lb(JSON.stringify(this.Cb(y)))}async zb(g,y){for(const{fileContent:k,acceptResult:i,localResource:o,remoteResource:n,localChange:t}of g)if(t!==0){const s=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.p,s);t===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(r)),await this.C.del(r),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(r))):t===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(r)),await this.C.createFile(r,L.VSBuffer.fromString(i.content),{overwrite:y}),this.L.info(`${this.y}: Created snippet`,this.h.basename(r))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(r)),await this.C.writeFile(r,L.VSBuffer.fromString(i.content),y?void 0:k),this.L.info(`${this.y}: Updated snippet`,this.h.basename(r)))}}async Ab(g,y,k){const i=y.syncData?this.Bb(y.syncData):{},o=(0,c.deepClone)(i);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of g)if(r!==0){const a=t?this.h.basename(t):this.h.basename(s);r===3?delete o[a]:o[a]=n.content}return(0,d.areSame)(i,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),y=await this.kb(JSON.stringify(o),k?null:y.ref),this.L.info(`${this.y}: Updated remote snippets`)),y}Bb(g){return E(g)}Cb(g){const y={};for(const k of Object.keys(g))y[k]=g[k].value.toString();return y}async Db(){const g={};let y;try{y=await this.C.resolve(this.p)}catch(k){if(k instanceof D.FileOperationError&&k.fileOperationResult===1)return g;throw k}for(const k of y.children||[]){const i=k.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.p,i),t=await this.C.readFile(i);g[n]=t}}return g}};l=ye([J(2,T.IEnvironmentService),J(3,D.IFileService),J(4,I.IStorageService),J(5,p.IUserDataSyncStoreService),J(6,p.IUserDataSyncBackupStoreService),J(7,p.IUserDataSyncLogService),J(8,O.IConfigurationService),J(9,p.IUserDataSyncEnablementService),J(10,S.ITelemetryService),J(11,P.IUriIdentityService)],l),e.SnippetsSynchroniser=l;let f=class extends m.AbstractInitializer{constructor(g,y,k,i,o,n){super("snippets",y,k,i,g,o,n)}async o(g){const y=g.syncData?JSON.parse(g.syncData.content):null;if(!y){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(y)){const o=y[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,L.VSBuffer.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(g)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};f=ye([J(0,D.IFileService),J(1,b.IUserDataProfilesService),J(2,T.IEnvironmentService),J(3,p.IUserDataSyncLogService),J(4,I.IStorageService),J(5,P.IUriIdentityService)],f),e.SnippetsInitializer=f}),define(oe[126],ae([0,1,16,17,15,13,20,19,30,18,41,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(l,f){try{return JSON.parse(l).tasks??null}catch(u){return f.error(u),null}}e.getTasksContentFromSyncContent=m;let d=class extends P.AbstractFileSynchroniser{constructor(f,u,g,y,k,i,o,n,t,s,r,a){super(f.tasksResource,{syncResource:"tasks",profile:f},u,n,t,s,g,y,o,r,k,i,a),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(f,u,g,y){const k=f.syncData?m(f.syncData.content,this.L):null;u=u===null&&g?f:u;const i=u?.syncData?m(u.syncData.content,this.L):null,o=await this.p();let n=null,t=!1,s=!1,r=!1;if(f.syncData){const w=o?o.value.toString():null;if(!i||i!==w||i!==k){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const v=E(w,k,i);n=v.content,r=v.hasConflicts,t=v.hasLocalChanged,s=v.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),s=!0);const a={content:r?i:n,localChange:t?o?2:1:0,remoteChange:s?2:0,hasConflicts:r},h=o?o.value.toString():null;return[{fileContent:o,baseResource:this.xb,baseContent:i,localResource:this.yb,localContent:h,localChange:a.localChange,remoteResource:this.zb,remoteContent:k,remoteChange:a.remoteChange,previewResource:this.wb,previewResult:a,acceptedResource:this.Ab}]}async sb(f){const u=f?.syncData?m(f.syncData.content,this.L):null;if(u===null)return!0;const g=await this.p(),y=g?g.value.toString():null,k=E(y,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async pb(f,u){return f.previewResult}async qb(f,u,g,y){if(this.h.isEqual(u,this.yb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.zb))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.wb))return g===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async rb(f,u,g,y){const{fileContent:k}=g[0][0],{content:i,localChange:o,remoteChange:n}=g[0][1];if(o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),k&&await this.lb(JSON.stringify(this.Gb(k.value.toString()))),i?await this.r(i,k,y):await this.tb(),this.L.info(`${this.y}: Updated local tasks`)),n!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const t=JSON.stringify(this.Gb(i));f=await this.kb(t,y?null:f.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.wb)}catch{}u?.ref!==f.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.db(f),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(f){return this.h.isEqual(this.zb,f)||this.h.isEqual(this.xb,f)||this.h.isEqual(this.yb,f)||this.h.isEqual(this.Ab,f)?this.bb(f):null}Gb(f){return f?{tasks:f}:{}}};d=ye([J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncBackupStoreService),J(4,b.IUserDataSyncLogService),J(5,N.IConfigurationService),J(6,b.IUserDataSyncEnablementService),J(7,O.IFileService),J(8,c.IEnvironmentService),J(9,T.IStorageService),J(10,D.ITelemetryService),J(11,I.IUriIdentityService)],d),e.TasksSynchroniser=d;let p=class extends P.AbstractInitializer{constructor(f,u,g,y,k,i){super("tasks",u,g,y,f,k,i),this.c=this.g.defaultProfile.tasksResource}async o(f){const u=f.syncData?m(f.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(u)),await this.n(f)}async p(){return this.k.exists(this.c)}};p=ye([J(0,O.IFileService),J(1,S.IUserDataProfilesService),J(2,c.IEnvironmentService),J(3,b.IUserDataSyncLogService),J(4,T.IStorageService),J(5,I.IUriIdentityService)],p),e.TasksInitializer=p;function E(l,f,u){if(l===null&&f===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(l===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=u!==l,y=u!==f;return!g&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!y?{content:l,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!g?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:l,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[127],ae([0,1,42,17,15,13,20,19,30,18,41,261,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=class extends P.AbstractSynchroniser{constructor(f,u,g,y,k,i,o,n,t,s,r,a,h){super({syncResource:"profiles",profile:f},u,y,k,i,o,n,r,a,t,s,h),this.r=g,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?E(f.syncData):null}async getRemoteSyncedProfiles(f){const u=await this.getLastSyncUserData(),g=await this.S(f,u);return g?.syncData?E(g.syncData):null}async ob(f,u,g){if(!this.r.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const y=f.syncData?E(f.syncData):null,k=u?.syncData?E(u.syncData):null,i=this.Ab(),{local:o,remote:n}=(0,b.merge)(i,y,k,[]),t={local:o,remote:n,content:k?this.Bb(k):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},s=p(i,!1);return[{baseResource:this.baseResource,baseContent:k?this.Bb(k):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:y?this.Bb(y):null,remoteProfiles:y,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async sb(f){const u=f?.syncData?E(f.syncData):null,g=this.Ab(),{remote:y}=(0,b.merge)(g,u,u,[]);return!!y?.added.length||!!y?.removed.length||!!y?.updated.length}async pb(f,u){return{...f.previewResult,hasConflicts:!1}}async qb(f,u,g,y){if(this.h.isEqual(u,this.localResource))return this.xb(f);if(this.h.isEqual(u,this.remoteResource))return this.yb(f);if(this.h.isEqual(u,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async xb(f){const u=this.Ab(),g=(0,b.merge)(u,null,null,[]),{local:y,remote:k}=g;return{content:f.localContent,local:y,remote:k,localChange:y.added.length>0||y.removed.length>0||y.updated.length>0?2:0,remoteChange:k!==null?2:0}}async yb(f){const u=f.remoteContent?JSON.parse(f.remoteContent):null,g=[],y=[];for(const k of this.Ab()){const i=u?.find(o=>o.id===k.id);i&&(g.push({id:k.id,name:k.name,collection:i.collection}),y.push(k))}if(u!==null){const k=(0,b.merge)(y,u,g,[]),{local:i,remote:o}=k;return{content:f.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(f,u,g,y){const{local:k,remote:i,localChange:o,remoteChange:n}=g[0][1];o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const t=g[0][0].remoteProfiles||[];if(t.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.lb(p(this.Ab(),!1));const s=[];for(const r of k.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of k.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const a=this.r.profiles.find(h=>h.id===r.id);a?s.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(a,{name:r.name,shortName:r.shortName}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(s)}if(n!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],r=t.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const h=await this.G.createCollection(this.z);s.push(h),t.push({id:a.id,name:a.name,collection:h,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])t.splice(t.findIndex(({id:h})=>a.id===h),1);for(const a of i?.updated||[]){const h=t.find(({id:w})=>a.id===w);h&&t.splice(t.indexOf(h),1,{id:a.id,name:a.name,collection:h.collection,shortName:a.shortName})}try{f=await this.updateRemoteProfiles(t,y?null:f.ref),this.L.info(`${this.y}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.G.deleteCollection(h,this.z)}throw a}for(const a of i?.removed||[])await this.G.deleteCollection(a.collection,this.z)}u?.ref!==f.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.db(f),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,u){return this.kb(this.Bb(f),u)}async hasLocalData(){return this.Ab().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const u=await this.bb(f);return u&&(0,L.toFormattedString)(JSON.parse(u),{})}return null}Ab(){return this.r.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Bb(f){return JSON.stringify([...f].sort((u,g)=>u.name.localeCompare(g.name)))}};d=ye([J(2,S.IUserDataProfilesService),J(3,O.IFileService),J(4,c.IEnvironmentService),J(5,T.IStorageService),J(6,m.IUserDataSyncStoreService),J(7,m.IUserDataSyncBackupStoreService),J(8,m.IUserDataSyncLogService),J(9,N.IConfigurationService),J(10,m.IUserDataSyncEnablementService),J(11,D.ITelemetryService),J(12,I.IUriIdentityService)],d),e.UserDataProfilesManifestSynchroniser=d;function p(l,f){const u=[...l].sort((g,y)=>g.name.localeCompare(y.name)).map(g=>({id:g.id,name:g.name}));return f?(0,L.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=p;function E(l){return JSON.parse(l.content)}e.parseUserDataProfilesManifest=E}),define(oe[278],ae([0,1,6,16,64,2,23,17,15,13,18,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends O.Disposable{constructor(p,E,l,f,u){super(),this.a=p,this.b=E,this.c=l,this.f=f,this.g=u,this.h()}async h(){for(const E of this.g.profiles)for(const l of b.ALL_SYNC_RESOURCES)try{await this.j(this.i(E,l))}catch(f){this.f.error(f)}let p;try{p=await this.b.resolve(this.a.userDataSyncHome)}catch(E){(0,S.toFileOperationResult)(E)!==1&&this.f.error(E);return}if(p.children){for(const E of p.children)if(E.isDirectory&&!this.g.profiles.some(l=>l.id===E.name))try{this.f.info("Deleting non existing profile from backup",E.resource.path),await this.b.del(E.resource,{recursive:!0})}catch(l){this.f.error(l)}}}async getAllRefs(p,E){const l=this.i(p,E);try{const f=await this.b.resolve(l);if(f.children)return f.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.k(g)}))}catch(f){if((0,S.toFileOperationResult)(f)!==1)throw f}return[]}async resolveContent(p,E,l){const f=this.i(p,E),u=(0,T.joinPath)(f,l);try{return(await this.b.readFile(u)).value.toString()}catch(g){return this.f.error(g),null}}async backup(p,E,l){const f=this.i(p,E),u=(0,T.joinPath)(f,`${(0,c.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,N.VSBuffer.fromString(l))}catch(g){this.f.error(g)}try{this.j(f)}catch{}}i(p,E){return(0,T.joinPath)(this.a.userDataSyncHome,...p.isDefault?[E]:[p.id,E])}async j(p){try{try{if(!await this.b.exists(p))return}catch{return}const E=await this.b.resolve(p);if(E.children){const l=E.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=l.filter(y=>Date.now()-this.k(y)>f);const g=l.length-u.length;g<10&&(u=u.slice(10-g)),await L.Promises.settled(u.map(async y=>{this.f.info("Deleting from backup",y.resource.path),await this.b.del(y.resource)}))}}catch(E){this.f.error(E)}}k(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};m=ye([J(0,I.IEnvironmentService),J(1,S.IFileService),J(2,D.IConfigurationService),J(3,b.IUserDataSyncLogService),J(4,P.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(oe[279],ae([0,1,3,2,4,15,20,19,24]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let P=class extends N.Disposable{constructor(m,d,p,E){super(),this.c=m,this.f=d,this.g=p,this.h=E,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(l=>this.j(l)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:m}),this.c.store(S,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,I.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,d){if(this.isResourceEnabled(m)!==d){const p=(0,I.getEnablementKey)(m);this.i(p,d)}}getResourceSyncStateVersion(m){}i(m,d){this.c.store(m,d,-1,c.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(S===m.key){this.a.fire(this.isEnabled());return}const d=I.ALL_SYNC_RESOURCES.filter(p=>(0,I.getEnablementKey)(p)===m.key)[0];if(d){this.b.fire([d,this.isResourceEnabled(d)]);return}}};P=ye([J(0,T.IStorageService),J(1,D.ITelemetryService),J(2,O.IEnvironmentService),J(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(oe[80],ae([0,1,3,2,4,27,188,15,13,5,26,44,20,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",E="Safari",l="Chrome",f="Edge",u="Firefox",g="Android";function y(o){switch(o){case E:case l:case f:case u:case g:case(0,c.PlatformToString)(0):return!0}return!1}e.isWebPlatform=y;function k(){return c.isSafari?E:c.isChrome?l:c.isEdge?f:c.isFirefox?u:c.isAndroid?g:(0,c.PlatformToString)(c.isWeb?0:c.platform)}let i=class it extends N.Disposable{constructor(n,t,s,r,a,h){super(),this.h=s,this.i=r,this.j=a,this.k=h,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(n,t,s)}async getMachines(n){const t=await this.f;return(await this.m(n)).machines.map(r=>({...r,isCurrent:r.id===t}))}async addCurrentMachine(n){const t=await this.f,s=await this.m(n);s.machines.some(({id:r})=>r===t)||(s.machines.push({id:t,name:this.l(s.machines),platform:k()}),await this.n(s))}async removeCurrentMachine(n){const t=await this.f,s=await this.m(n),r=s.machines.filter(({id:a})=>a!==t);r.length!==s.machines.length&&(s.machines=r,await this.n(s))}async renameMachine(n,t,s){const r=await this.m(s),a=r.machines.find(({id:h})=>h===n);if(a){a.name=t,await this.n(r);const h=await this.f;n===h&&this.h.store(p,t,-1,1)}}async setEnablements(n){const t=await this.m();for(const[s,r]of n){const a=t.machines.find(h=>h.id===s);a&&(a.disabled=r?void 0:!0)}await this.n(t)}l(n){const t=this.h.get(p,-1);if(t)return t;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${k()} (${this.k.nameShort})`,r=new RegExp(`${(0,O.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const h of n){const w=r.exec(h.name),v=w?parseInt(w[1]):0;a=v>a?v:a}return`${s} #${a+1}`}async m(n){this.g=await this.p(n);const t=this.r(this.g);if(t.version!==it.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return t}async n(n){const t=JSON.stringify(n),s=await this.i.writeResource(it.b,t,this.g?.ref||null);this.g={ref:s,content:t},this.c.fire()}async p(n){if(this.g){const t=n&&n.latest?n.latest[it.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(t){this.j.error(t)}return{version:it.a,machines:[]}}};i.a=1,i.b="machines",i=ye([J(0,D.IEnvironmentService),J(1,I.IFileService),J(2,m.IStorageService),J(3,d.IUserDataSyncStoreService),J(4,d.IUserDataSyncLogService),J(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(oe[280],ae([0,1,6,64,38,10,3,2,4,23,12,185,26,20,19,24,77,80]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",g="sync.sessionId",y="sync.storeUrl",k="sync.productQuality";let i=class extends D.Disposable{get j(){const t=this.z.get(y,-1);return t?P.URI.parse(t):void 0}set j(t){t?this.z.store(y,t.toString(),-1,1):this.z.remove(y,-1)}get l(){return this.z.get(k,-1)}set l(t){t?this.z.store(k,t,-1,1):this.z.remove(k,-1)}constructor(t,s,r,a,h,w,v,R,A,M){super(),this.n=s,this.p=r,this.r=a,this.s=h,this.u=w,this.v=v,this.w=R,this.y=A,this.z=M,this.a=this.B(new D.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=t.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(v.onDidChangeAccount(()=>this.C())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(h.onDidChangeLocal($=>this.triggerSync([$],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:t,message:s}=this.F();t?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.I(r))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(t,s,r){try{this.v.account&&!r&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(g,-1),t?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),s)this.G(!1);else throw a}}G(t){this.r.isEnabled()!==t&&(this.r.setEnablement(t),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(t){if(!t){this.b=0;return}const s=E.UserDataSyncError.toUserDataSyncError(t);s instanceof E.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(u,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...t),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([J(0,m.IProductService),J(1,E.IUserDataSyncStoreManagementService),J(2,E.IUserDataSyncStoreService),J(3,E.IUserDataSyncEnablementService),J(4,E.IUserDataSyncService),J(5,E.IUserDataSyncLogService),J(6,l.IUserDataSyncAccountService),J(7,p.ITelemetryService),J(8,f.IUserDataSyncMachinesService),J(9,d.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends D.Disposable{constructor(t,s,r,a,h,w,v,R){super(),this.j=t,this.k=s,this.l=r,this.m=a,this.n=h,this.p=w,this.r=v,this.s=R,this.b=this.B(new D.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,D.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}u(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(o.a,!1),this.k)}sync(t,s){const r=(0,L.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(h){if((0,O.isCancellationError)(h))return}return this.y(t,s,a)});return this.i=r,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const t=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!t&&(!(0,S.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,S.isEqual)(s.stableUrl,t.stableUrl))}async y(t,s,r){this.r.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let a;try{await this.z(s,r)}catch(h){if(this.r.error(h),a=h,E.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,r),a=void 0}catch(w){this.r.error(w),a=w}}this.f.fire(a)}async z(t,s){if(this.h=await this.n.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new E.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const r=this.s.get(g,-1);if(r&&this.g&&r!==this.g.session)throw this.v()?await this.w()?new E.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=a.find(w=>w.isCurrent);if(h?.disabled)throw new E.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(w){throw new E.UserDataAutoSyncError((0,c.toErrorMessage)(w),w instanceof E.UserDataSyncError?w.code:"Unknown")}this.g&&this.g.session!==r&&this.s.store(g,this.g.session,-1,1),!s.isCancellationRequested&&(h||await this.p.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}o.a="Interval"}),define(oe[281],ae([0,1,12,189,15,13,44,20,30,24,18,41,125,124,123,17,126,121,122,5,127,42]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class He{constructor(n,t,s,r,a,h,w,v,R,A){this.e=n,this.f=t,this.g=s,this.h=a,this.i=h,this.j=w,this.k=v,this.l=R,this.m=A,this.d=r.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const t=this.K(n.content,"profiles");return(0,y.parseUserDataProfilesManifest)(t)}return[]}async getRemoteSyncResourceHandles(n,t){return(await this.e.getAllResourceRefs(n,t?.collection)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!0,syncResource:n,profile:t?.id??this.k.defaultProfile.id,collection:t?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(n,t){return(await this.f.getAllRefs(t,n)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!1,syncResource:n,profile:t.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const t=this.J(n),s=t?this.k.profiles.find(r=>r.id===t.profile):void 0;return t&&s?{profile:s,syncResource:t?.syncResource}:void 0}async getAssociatedResources({uri:n}){const t=this.J(n);if(!t)return[];const s=this.k.profiles.find(r=>r.id===t.profile);switch(t.syncResource){case"settings":return this.r(n,s);case"keybindings":return this.t(n,s);case"tasks":return this.v(n,s);case"snippets":return this.x(n,s);case"globalState":return this.C(n,s);case"extensions":return this.z(n,s);case"profiles":return this.F(n,s)}}async getMachineId({uri:n}){const t=this.J(n);if(!!t){if(t.remote){if(t.ref){const{content:s}=await this.L(t.syncResource,t.ref,t.collection);if(s)return this.K(s,t.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(n){const t=this.J(n);if(!t||t.node===He.a)return null;if(t.ref){const s=await this.n(t.remote,t.syncResource,t.profile,t.collection,t.ref);return t.node&&s?this.o(t.syncResource,s,t.node):s}return!t.remote&&!t.node?this.q(t.syncResource,t.profile):null}async n(n,t,s,r,a){if(n){const{content:w}=await this.L(t,a,r);return w}const h=this.k.profiles.find(w=>w.id===s);return h?this.f.resolveContent(h,t,a):null}o(n,t,s){const r=this.K(t,n);switch(n){case"settings":return this.s(r,s);case"keybindings":return this.u(r,s);case"tasks":return this.w(r,s);case"snippets":return this.y(r,s);case"globalState":return this.D(r,s);case"extensions":return this.A(r,s);case"profiles":return this.G(r,s)}}async q(n,t){const s=this.k.profiles.find(r=>r.id===t);if(!s)return null;switch(n){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(n,t){const s=this.d.joinPath(n,"settings.json"),r=t?t.settingsResource:this.d.joinPath(n,He.a);return[{resource:s,comparableResource:r}]}s(n,t){switch(t){case"settings.json":return(0,d.parseSettingsSyncContent)(n.content).settings}return null}t(n,t){const s=this.d.joinPath(n,"keybindings.json"),r=t?t.keybindingsResource:this.d.joinPath(n,He.a);return[{resource:s,comparableResource:r}]}u(n,t){switch(t){case"keybindings.json":return(0,p.getKeybindingsContentFromSyncContent)(n.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(n,t){const s=this.d.joinPath(n,"tasks.json"),r=t?t.tasksResource:this.d.joinPath(n,He.a);return[{resource:s,comparableResource:r}]}w(n,t){switch(t){case"tasks.json":return(0,l.getTasksContentFromSyncContent)(n.content,this.g)}return null}async x(n,t){const s=await this.resolveContent(n);if(s){const r=this.K(s,"snippets");if(r){const a=(0,m.parseSnippets)(r),h=[];for(const w of Object.keys(a)){const v=this.d.joinPath(n,w),R=t?this.d.joinPath(t.snippetsHome,w):this.d.joinPath(n,He.a);h.push({resource:v,comparableResource:R})}return h}}return[]}y(n,t){return(0,m.parseSnippets)(n)[t]||null}z(n,t){const s=this.d.joinPath(n,"extensions.json"),r=t?this.I({remote:!1,syncResource:"extensions",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,He.a);return[{resource:s,comparableResource:r}]}A(n,t){switch(t){case"extensions.json":return(0,f.stringify)((0,f.parseExtensions)(n),!0)}return null}async B(n){const{localExtensions:t}=await this.m.createInstance(f.LocalExtensionsProvider).getLocalExtensions(n);return(0,f.stringify)(t,!0)}C(n,t){const s=this.d.joinPath(n,"globalState.json"),r=t?this.I({remote:!1,syncResource:"globalState",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,He.a);return[{resource:s,comparableResource:r}]}D(n,t){switch(t){case"globalState.json":return(0,u.stringify)(JSON.parse(n.content),!0)}return null}async E(n){const t=await this.m.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(n);return(0,u.stringify)(t,!0)}F(n,t){const s=this.d.joinPath(n,"profiles.json"),r=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:r}]}G(n,t){switch(t){case"profiles.json":return(0,k.toFormattedString)(JSON.parse(n.content),{})}return null}async H(n){return(0,y.stringifyLocalProfiles)(this.k.profiles.filter(t=>!t.isDefault&&!t.isTransient),!0)}I(n){const t=n.remote?He.b:He.c,s=[n.syncResource,n.profile];return n.collection&&s.push(`collection:${n.collection}`),n.ref&&s.push(`ref:${n.ref}`),n.node&&s.push(n.node),this.d.joinPath(L.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:t,path:"/"}),...s)}J(n){if(n.scheme!==S.USER_DATA_SYNC_SCHEME||n.authority!==He.c&&n.authority!==He.b)return;const t=[];for(;n.path!=="/";)t.unshift(this.d.basename(n)),n=this.d.dirname(n);if(t.length<2)return;const s=n.authority===He.b,r=t.shift(),a=t.shift();let h,w,v;for(;t.length;){const R=t.shift();R.startsWith("collection:")?h=R.substring(11):R.startsWith("ref:")?w=R.substring(4):v=R}return{remote:s,syncResource:r,profile:a,collection:h,ref:w,node:v}}K(n,t){try{const s=JSON.parse(n);if((0,b.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new S.UserDataSyncError((0,N.localize)(0,null),"IncompatibleRemoteContent",t)}async L(n,t,s){const r=await this.e.resolveResourceContent(n,t,s);return{ref:t,content:r}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncBackupStoreService),J(2,S.IUserDataSyncLogService),J(3,I.IUriIdentityService),J(4,c.IEnvironmentService),J(5,D.IStorageService),J(6,O.IFileService),J(7,P.IUserDataProfilesService),J(8,E.IConfigurationService),J(9,g.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(oe[282],ae([0,1,21,6,25,38,3,2,23,11,31,17,29,5,20,19,18,121,122,123,124,125,126,127,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let s=class extends D.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(v,R,A,M,$,V,q,W,X){super(),this.v=v,this.w=R,this.y=A,this.z=M,this.C=$,this.D=V,this.F=q,this.G=W,this.H=X,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=R.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(t,-1,void 0),this.B((0,D.toDisposable)(()=>this.W()))}async createSyncTask(v,R){this.X(),this.z.info("Sync started.");const A=new Date().getTime(),M=(0,P.generateUuid)();try{const W=(0,n.createSyncHeaders)(M);R&&(W["Cache-Control"]="no-cache"),v=await this.v.manifest(v,W)}catch(W){const X=n.UserDataSyncError.toUserDataSyncError(W);throw h(X,M,this.w,this.C),X}const $=!1,V=this;let q;return{manifest:v,async run(){if($)throw new Error("Can run a task only once");q=(0,N.createCancelablePromise)(W=>V.I(v,!1,M,W)),await q.finally(()=>q=void 0),V.z.info(`Sync done. Took ${new Date().getTime()-A}ms`),V.S()},stop(){return q?.cancel(),V.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new n.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const v=new Date().getTime(),R=(0,P.generateUuid)(),A=(0,n.createSyncHeaders)(R);let M;try{M=await this.v.manifest(null,A)}catch(q){const W=n.UserDataSyncError.toUserDataSyncError(q);throw h(W,R,this.w,this.C),W}await this.resetLocal();const $=this,V=new c.CancellationTokenSource;return{id:R,async merge(){return $.I(M,!0,R,V.token)},async apply(){try{try{await $.L(M,R,V.token)}catch(q){if(n.UserDataSyncError.toUserDataSyncError(q).code==="MethodNotFound")$.z.info("Client is making invalid requests. Cleaning up data..."),await $.cleanUpRemoteData(),$.z.info("Applying manual sync again..."),await $.L(M,R,V.token);else throw q}}catch(q){throw $.z.error(q),q}$.z.info(`Sync done. Took ${new Date().getTime()-v}ms`),$.S()},async stop(){V.cancel(),await $.N(),await $.resetLocal()}}}async I(v,R,A,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M($,v,R,A,M));const V=$.enabled.find(q=>q.resource==="profiles");if(V){const q=await V.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(q,v,R,A,M)}}finally{this.l.fire(this.k)}}async J(v,R,A,M,$){for(const V of v){if($.isCancellationRequested)return;const q=this.G.profiles.find(X=>X.id===V.id);if(!q){this.z.error(`Profile with id:${V.id} and name: ${V.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",V.name);const W=this.getOrCreateActiveProfileSynchronizer(q,V);this.k.push(...await this.M(W,R,A,M,$))}for(const[V,q]of this.u.entries())this.G.profiles.some(W=>W.id===q[0].profile.id)||(q[1].dispose(),this.u.delete(V))}async L(v,R,A){const M=this.U();for(const X of M){if(A.isCancellationRequested)return;await X.apply(R,A)}const $=M.find(X=>X.profile.isDefault);if(!$)return;const V=$.enabled.find(X=>X.resource==="profiles");if(!V)return;const W=(await V.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(X=>M.every(Q=>Q.profile.id!==X.id));W.length&&await this.J(W,v,!1,R,A)}async M(v,R,A,M,$){return(await v.sync(R,A,M,$)).map(([q,W])=>({profile:v.profile,syncResource:q,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(v=>v.stop()))}async resolveContent(v){const R=await this.H.resolveContent(v);if(R)return R;for(const A of this.U())for(const M of A.enabled){const $=await M.resolveContent(v);if($)return $}return null}async replace(v){this.X();const R=this.H.resolveUserDataSyncResource(v);if(!R)return;const A=await this.resolveContent(v.uri);!A||await this.O(R.profile,async M=>{if(R.syncResource===M.resource)return await M.replace(A),!0})}async accept(v,R,A,M){this.X(),await this.O(v.profile,async $=>{if(v.syncResource===$.resource)return await $.accept(R,A),M&&await $.apply((0,S.isBoolean)(M)?!1:M.force,(0,n.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(v,R){return this.H.getRemoteSyncResourceHandles(v,R)}async getLocalSyncResourceHandles(v,R){return this.H.getLocalSyncResourceHandles(v,R??this.G.defaultProfile)}async getAssociatedResources(v){return this.H.getAssociatedResources(v)}async getMachineId(v){return this.H.getMachineId(v)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async R=>{if(R.resource!=="globalState"&&await R.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async R=>{if(await R.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(v){this.z.error(v)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(t,-1);for(const[v]of this.u.values())try{await v.resetLocal()}catch(R){this.z.error(R)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.H.getRemoteSyncedProfiles(),R=v.map(V=>V.collection),A=await this.v.getAllCollections(),M=A.filter(V=>!R.includes(V));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(V=>this.v.deleteCollection(V))),this.z.info("Deleted redundant collections on server"));const $=v.filter(V=>A.includes(V.collection));if($.length!==v.length){this.z.info("Updating remote profiles with invalid collections on server");const V=this.y.createInstance(o.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await V.updateRemoteProfiles($,null),this.z.info("Updated remote profiles on server")}finally{V.dispose()}}}async O(v,R){const A=new D.DisposableStore;try{const M=this.u.get(v.id);if(M){const X=await this.P(M[0],R,A);return(0,S.isUndefined)(X)?null:X}if(v.isDefault){const X=A.add(this.y.createInstance(r,v,void 0)),Q=await this.P(X,R,A);return(0,S.isUndefined)(Q)?null:Q}if(this.G.isEnabled())return null;const $=A.add(this.y.createInstance(o.UserDataProfilesManifestSynchroniser,v,void 0)),V=await this.v.manifest(null),W=(await $.getRemoteSyncedProfiles(V?.latest??null)||[]).find(X=>X.id===v.id);if(W){const X=A.add(this.y.createInstance(r,v,W.collection)),Q=await this.P(X,R,A);return(0,S.isUndefined)(Q)?null:Q}return null}finally{A.dispose()}}async P(v,R,A){const M=[...v.enabled,...v.disabled.map($=>A.add(v.createSynchronizer($)))];for(const $ of M){const V=await R($);if(!(0,S.isUndefined)(V))return V}}Q(v){const R=this.f;this.f!==v&&(this.f=v,this.g.fire(v),R==="hasConflicts"&&this.S())}R(){const v=this.U().map(R=>R.conflicts).flat();(0,L.equals)(this.i,v,(R,A)=>R.profile.id===A.profile.id&&R.syncResource===A.syncResource&&(0,L.equals)(R.conflicts,A.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this.i=v,this.j.fire(v))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(t,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(v,R){let A=this.u.get(v.id);if(A&&A[0].collection!==R?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),A[1].dispose(),A=void 0,this.u.delete(v.id)),!A){const M=new D.DisposableStore,$=M.add(this.y.createInstance(r,v,R?.collection));M.add($.onDidChangeStatus(V=>this.Q(V))),M.add($.onDidChangeConflicts(V=>this.R())),M.add($.onDidChangeLocal(V=>this.h.fire(V))),this.u.set(v.id,A=[$,M])}return A[0]}U(){const v=[];for(const[R]of this.u.values())v.push(R);return v}W(){this.u.forEach(([,v])=>v.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=ye([J(0,n.IUserDataSyncStoreService),J(1,n.IUserDataSyncStoreManagementService),J(2,d.IInstantiationService),J(3,n.IUserDataSyncLogService),J(4,E.ITelemetryService),J(5,p.IStorageService),J(6,n.IUserDataSyncEnablementService),J(7,l.IUserDataProfilesService),J(8,n.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let r=class extends D.Disposable{get enabled(){return this.f.sort((v,R)=>v[1]-R[1]).map(([v])=>v)}get disabled(){return n.ALL_SYNC_RESOURCES.filter(v=>!this.l.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.j}constructor(v,R,A,M,$,V,q,W,X,Q){super(),this.profile=v,this.collection=R,this.l=A,this.m=M,this.n=$,this.r=V,this.t=q,this.u=W,this.v=X,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(A.onDidChangeResourceEnablement(([Y,Z])=>this.y(Y,Z))),this.B((0,D.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of n.ALL_SYNC_RESOURCES)A.isResourceEnabled(Y)&&this.z(Y)}y(v,R){R?this.z(v):this.C(v)}z(v){if(this.f.some(([$])=>$.resource===v))return;if(v==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const R=new D.DisposableStore,A=R.add(this.createSynchronizer(v));R.add(A.onDidChangeStatus(()=>this.G())),R.add(A.onDidChangeConflicts(()=>this.H())),R.add(A.onDidChangeLocal(()=>this.i.fire(v)));const M=this.I(v);this.f.push([A,M,R])}C(v){const R=this.f.findIndex(([A])=>A.resource===v);if(R!==-1){const[[A,,M]]=this.f.splice(R,1);M.dispose(),this.G(),Promise.allSettled([A.stop(),A.resetLocal()]).then(null,$=>this.u.error($))}}createSynchronizer(v){switch(v){case"settings":return this.m.createInstance(y.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(k.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(f.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(v,R,A,M){if(M.isCancellationRequested)return[];const $=this.enabled;if(!$.length)return[];try{const V=[],q=(0,n.createSyncHeaders)(A),W=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,X=R?await this.D(W):{};for(const Q of $){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(R){const Y=await Q.preview(W,X,q);if(Y)for(const Z of Y.resourcePreviews)(Z.localChange!==0||Z.remoteChange!==0)&&Z.mergeState==="preview"&&await Q.merge(Z.previewResource)}else await Q.sync(W,q)}catch(Y){const Z=n.UserDataSyncError.toUserDataSyncError(Y);if(h(Z,A,this.r,this.t),a(Y))throw Z;this.u.error(Y),this.u.error(`${Q.resource}: ${(0,O.toErrorMessage)(Y)}`),V.push([Q.resource,Z])}}return V}finally{this.G()}}async apply(v,R){const A=(0,n.createSyncHeaders)(v);for(const M of this.enabled){if(R.isCancellationRequested)return;try{await M.apply(!1,A)}catch($){const V=n.UserDataSyncError.toUserDataSyncError($);if(h(V,v,this.r,this.t),a($))throw V;this.u.error($),this.u.error(`${M.resource}: ${(0,O.toErrorMessage)($)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(R){this.u.error(R)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(R){this.u.error(`${v.resource}: ${(0,O.toErrorMessage)(R)}`),this.u.error(R)}}async D(v){if(!this.profile.isDefault)return{};const R=this.w.getValue(n.USER_DATA_SYNC_CONFIGURATION_SCOPE),A=this.enabled.find(M=>M instanceof y.SettingsSynchroniser);if(A){const M=await A.getRemoteUserDataSyncConfiguration(v);return{...R,...M}}return R}F(v){this.g!==v&&(this.g=v,this.h.fire(v))}G(){return this.H(),this.enabled.some(v=>v.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const v=this.enabled.filter(R=>R.status==="hasConflicts").filter(R=>R.conflicts.conflicts.length>0).map(R=>R.conflicts);(0,L.equals)(this.j,v,(R,A)=>R.syncResource===A.syncResource&&(0,L.equals)(R.conflicts,A.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this.j=v,this.k.fire(v))}I(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};r=ye([J(2,n.IUserDataSyncEnablementService),J(3,d.IInstantiationService),J(4,m.IExtensionGalleryService),J(5,n.IUserDataSyncStoreManagementService),J(6,E.ITelemetryService),J(7,n.IUserDataSyncLogService),J(8,l.IUserDataProfilesService),J(9,b.IConfigurationService)],r);function a(w){if(w instanceof n.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(w,v,R,A){A.publicLog2("sync/error",{code:w.code,serverCode:w instanceof n.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof n.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:v,service:R.userDataSyncStore.url.toString()})}}),define(oe[283],ae([0,1,3,2,12,18,24]),function(ie,e,L,N,c,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function D(m,d){return{...m,profile:(0,O.reviveProfile)(m.profile,d.profilesHome.scheme)}}function I(m){return{created:m.created,uri:c.URI.revive(m.uri)}}class S{constructor(d,p,E){this.c=d,this.d=p,this.f=E,this.a=new Map,this.b=new L.Emitter}listen(d,p){switch(p){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${p}`)}async call(d,p,E){try{return await this.g(d,p,E)}catch(l){throw this.f.error(l),l}}async g(d,p,E){switch(p){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(c.URI.revive(E[0]));case"accept":return this.c.accept(D(E[0],this.d),c.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(E[0],E[1]?(0,O.reviveProfile)(E[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.c.replace(I(E[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(E[0]));case"getMachineId":return this.c.getMachineId(I(E[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(p.startsWith("manualSync/")){const l=p.substring(11),f=E[0],u=this.h(f);switch(E=E.slice(1),l){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(d){const p=this.a.get(this.j(d));if(!p)throw new Error(`Manual sync taks not found: ${d}`);return p}async i(){const d=await this.c.createManualSyncTask();return this.a.set(this.j(d.id),d),d.id}j(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=S;let P=class extends N.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(d,p){super(),this.k=p,this.b="uninitialized",this.c=this.B(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(E,l,f){return d.call(E,l,f).then(null,u=>{throw T.UserDataSyncError.toUserDataSyncError(u)})},listen(E,l){return d.listen(E,l)}},this.a.call("_getInitialData").then(([E,l,f])=>{this.l(E),this.m(l),f&&this.n(f),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(E=>this.m(E))),this.B(this.a.listen("onSyncErrors")(E=>this.j.fire(E.map(l=>({...l,error:T.UserDataSyncError.toUserDataSyncError(l.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.a.call("createManualSyncTask"),p=this;return new b(d,{async call(l,f,u){return p.a.call(`manualSync/${l}`,[d,...Array.isArray(f)?f:[f]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(d,p,E,l){return this.a.call("accept",[d,p,E,l])}resolveContent(d){return this.a.call("resolveContent",[d])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,p){return(await this.a.call("getLocalSyncResourceHandles",[d,p])).map(({created:l,uri:f})=>({created:l,uri:c.URI.revive(f)}))}async getRemoteSyncResourceHandles(d,p){return(await this.a.call("getRemoteSyncResourceHandles",[d,p])).map(({created:l,uri:f})=>({created:l,uri:c.URI.revive(f)}))}async getAssociatedResources(d){return(await this.a.call("getAssociatedResources",[d])).map(({resource:E,comparableResource:l})=>({resource:c.URI.revive(E),comparableResource:c.URI.revive(l)}))}getMachineId(d){return this.a.call("getMachineId",[d])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(d){return this.a.call("replace",[d])}async l(d){this.b=d,this.c.fire(d)}async m(d){this.f=d.map(p=>({syncResource:p.syncResource,profile:(0,O.reviveProfile)(p.profile,this.k.profilesHome.scheme),conflicts:p.conflicts.map(E=>({...E,baseResource:c.URI.revive(E.baseResource),localResource:c.URI.revive(E.localResource),remoteResource:c.URI.revive(E.remoteResource),previewResource:c.URI.revive(E.previewResource)}))})),this.g.fire(this.f)}n(d){this.h!==d&&(this.h=d,this.i.fire(d))}};P=ye([J(1,O.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class b extends N.Disposable{constructor(d,p){super(),this.id=d,this.a=p}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[284],ae([0,1,6,25,10,3,2,142,4,23,11,12,31,17,15,13,26,59,44,20,24]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const k="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let r=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(y.SYNC_SERVICE_URL_TYPE,-1)}set c(A){this.h.store(y.SYNC_SERVICE_URL_TYPE,A,-1,I.isWeb?0:1)}constructor(A,M,$){super(),this.f=A,this.g=M,this.h=$,this.a=this.B(new O.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(O.Event.filter($.onDidChangeValue,V=>V.key===y.SYNC_SERVICE_URL_TYPE&&V.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[y.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(y.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(A,M){A=I.isWeb&&A?.web?{...A,...A.web}:A;const $={...A||{},...M||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(V=>Array.isArray($.authenticationProviders[V].scopes))){const V=$,q=!!V.canSwitch&&!M?.url,W=V.url===V.insidersUrl?"insiders":"stable",X=(q?this.c:void 0)||W,Q=M?.url||(X==="insiders"?V.insidersUrl:X==="stable"?V.stableUrl:V.url);return{url:b.URI.parse(Q),type:X,defaultType:W,defaultUrl:b.URI.parse(V.url),stableUrl:b.URI.parse(V.stableUrl),insidersUrl:b.URI.parse(V.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(V.authenticationProviders).reduce((Y,Z)=>(Y.push({id:Z,scopes:V.authenticationProviders[Z].scopes}),Y),[])}}}};r=ye([J(0,l.IProductService),J(1,d.IConfigurationService),J(2,g.IStorageService)],r),e.AbstractUserDataSyncStoreManagementService=r;let a=class extends r{constructor(A,M,$){super(A,M,$);const V=this.h.get(k,-1);V&&(this.k=JSON.parse(V));const q=this.f[y.CONFIGURATION_SYNC_STORE_KEY];q?this.h.store(k,JSON.stringify(q),-1,1):this.h.remove(k,-1)}async switch(A){A!==this.c&&(this.c=A,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=ye([J(0,l.IProductService),J(1,d.IConfigurationService),J(2,g.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(A,M,$,V,q,W,X){super(),this.k=$,this.l=V,this.n=X,this.g=this.B(new O.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new O.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new O.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(A),this.c=(0,u.getServiceMachineId)(q,W,X).then(Q=>{const Y={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.f=new v(t,s,this.k,this.l),this.r(),this.B((0,T.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(A,M){this.b={token:A,type:M}}p(A){this.a=A?(0,S.joinPath)(A,"v1"):void 0}r(){const A=this.n.getNumber(i,-1);A&&Date.now()<A&&this.t(new Date(A))}t(A){this.i?.getTime()!==A?.getTime()&&(this.i=A,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.t(void 0))),this.s.then(null,M=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(A={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.a,"collection").toString();A={...A},A["Content-Type"]="application/json";const $=await this.w(M,{type:"GET",headers:A},[],N.CancellationToken.None);return(await(0,f.asJson)($))?.map(({id:V})=>V)||[]}async createCollection(A={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.a,"collection").toString();A={...A},A["Content-Type"]=D.Mimes.text;const $=await this.w(M,{type:"POST",headers:A},[],N.CancellationToken.None),V=await(0,f.asTextOrError)($);if(!V)throw new y.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",$.res.statusCode,$.res.headers[y.HEADER_OPERATION_ID]);return V}async deleteCollection(A,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=A?(0,S.joinPath)(this.a,"collection",A).toString():(0,S.joinPath)(this.a,"collection").toString();M={...M},await this.w($,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(A,M){if(!this.a)throw new Error("No settings sync store url configured.");const $=this.u(this.a,M,A),V={},q=await this.w($.toString(),{type:"GET",headers:V},[],N.CancellationToken.None);return(await(0,f.asJson)(q)||[]).map(({url:X,created:Q})=>({ref:(0,S.relativePath)($,$.with({path:X})),created:Q*1e3}))}async resolveResourceContent(A,M,$,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.u(this.a,$,A),M).toString();V={...V},V["Cache-Control"]="no-cache";const W=await this.w(q,{type:"GET",headers:V},[],N.CancellationToken.None);return await(0,f.asTextOrError)(W)}async deleteResource(A,M,$){if(!this.a)throw new Error("No settings sync store url configured.");const V=M!==null?(0,S.joinPath)(this.u(this.a,$,A),M).toString():this.u(this.a,$,A).toString(),q={};await this.w(V,{type:"DELETE",headers:q},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const A=(0,S.joinPath)(this.a,"resource").toString(),M={"Content-Type":D.Mimes.text};await this.w(A,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(A,M,$,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.u(this.a,$,A),"latest").toString();V={...V},V["Cache-Control"]="no-cache",M&&(V["If-None-Match"]=M.ref);const W=await this.w(q,{type:"GET",headers:V},[304],N.CancellationToken.None);let X=null;if(W.res.statusCode===304&&(X=M),X===null){const Q=W.res.headers.etag;if(!Q)throw new y.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",W.res.statusCode,W.res.headers[y.HEADER_OPERATION_ID]);const Y=await(0,f.asTextOrError)(W);if(!Y&&W.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",q,"EmptyResponse",W.res.statusCode,W.res.headers[y.HEADER_OPERATION_ID]);X={ref:Q,content:Y}}return X}async writeResource(A,M,$,V,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.u(this.a,V,A).toString();q={...q},q["Content-Type"]=D.Mimes.text,$&&(q["If-Match"]=$);const X=await this.w(W,{type:"POST",data:M,headers:q},[],N.CancellationToken.None),Q=X.res.headers.etag;if(!Q)throw new y.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",X.res.statusCode,X.res.headers[y.HEADER_OPERATION_ID]);return Q}async manifest(A,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",A&&(M["If-None-Match"]=A.ref);const V=await this.w($,{type:"GET",headers:M},[304],N.CancellationToken.None);let q=null;if(V.res.statusCode===304&&(q=A),!q){const X=V.res.headers.etag;if(!X)throw new y.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",V.res.statusCode,V.res.headers[y.HEADER_OPERATION_ID]);const Q=await(0,f.asTextOrError)(V);if(!Q&&V.res.statusCode===304)throw new y.UserDataSyncStoreError("Empty response",$,"EmptyResponse",V.res.statusCode,V.res.headers[y.HEADER_OPERATION_ID]);Q&&(q={...JSON.parse(Q),ref:X})}const W=this.n.get(o,-1);return W&&q&&W!==q.session&&this.v(),q===null&&W&&this.v(),q&&this.n.store(o,q.session,-1,1),q}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(A,M,$){return M?(0,S.joinPath)(A,"collection",M,"resource",$):(0,S.joinPath)(A,"resource",$)}v(){this.n.remove(o,-1),this.n.remove(n,-1)}async w(A,M,$,V){if(!this.b)throw new y.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const q=await this.c;M.headers={...M.headers||{},...q,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(M.headers),this.l.trace("Sending request to server",{url:A,type:M.type,headers:{...M.headers,authorization:void 0}});let W;try{W=await this.f.request(A,M,V)}catch(x){if(!(x instanceof y.UserDataSyncStoreError)){let j="RequestFailed";const ee=(0,c.getErrorMessage)(x).toLowerCase();ee.includes("xhr timeout")?j="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?j="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":ee.includes("headers must be an object")?j="RequestHeadersNotObject":(0,c.isCancellationError)(x)&&(j="RequestCanceled"),x=new y.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,j,void 0,void 0)}throw this.l.info("Request failed",A),x}const X=W.res.headers[y.HEADER_OPERATION_ID],Q={url:A,status:W.res.statusCode,"execution-id":M.headers[y.HEADER_EXECUTION_ID],"operation-id":X},Y=(0,f.isSuccess)(W)||W.res.statusCode&&$.indexOf(W.res.statusCode)!==-1;let Z="";if(Y?this.l.trace("Request succeeded",Q):(this.l.info("Request failed",Q),Z=await(0,f.asText)(W)||""),W.res.statusCode===401)throw this.b=void 0,this.g.fire(),new y.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",W.res.statusCode,X);if(this.h.fire(),W.res.statusCode===404)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because the requested resource is not found (404).`,A,"NotFound",W.res.statusCode,X);if(W.res.statusCode===405)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because the requested endpoint is not found (405). ${Z}`,A,"MethodNotFound",W.res.statusCode,X);if(W.res.statusCode===409)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",W.res.statusCode,X);if(W.res.statusCode===410)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",W.res.statusCode,X);if(W.res.statusCode===412)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",W.res.statusCode,X);if(W.res.statusCode===413)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",W.res.statusCode,X);if(W.res.statusCode===426)throw new y.UserDataSyncStoreError(`${M.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",W.res.statusCode,X);if(W.res.statusCode===429){const x=W.res.headers["retry-after"];throw x?(this.t(new Date(Date.now()+parseInt(x)*1e3)),new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",W.res.statusCode,X)):new y.UserDataSyncStoreError(`${M.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",W.res.statusCode,X)}if(!Y)throw new y.UserDataSyncStoreError("Server returned "+W.res.statusCode,A,"Unknown",W.res.statusCode,X);return W}y(A){let M=this.n.get(n,-1);M===void 0&&(M=(0,m.generateUuid)(),this.n.store(n,M,-1,1)),A["X-Machine-Session-Id"]=M;const $=this.n.get(o,-1);$!==void 0&&(A["X-User-Session-Id"]=$)}};h=ye([J(1,l.IProductService),J(2,f.IRequestService),J(3,y.IUserDataSyncLogService),J(4,p.IEnvironmentService),J(5,E.IFileService),J(6,g.IStorageService)],h),e.UserDataSyncStoreClient=h;let w=class extends h{constructor(A,M,$,V,q,W,X){super(A.userDataSyncStore?.url,M,$,V,q,W,X),this.B(A.onDidChangeUserDataSyncStore(()=>this.p(A.userDataSyncStore?.url)))}};w=ye([J(0,y.IUserDataSyncStoreManagementService),J(1,l.IProductService),J(2,f.IRequestService),J(3,y.IUserDataSyncLogService),J(4,p.IEnvironmentService),J(5,E.IFileService),J(6,g.IStorageService)],w),e.UserDataSyncStoreService=w;class v{constructor(A,M,$,V){this.c=A,this.d=M,this.f=$,this.g=V,this.a=[],this.b=void 0}request(A,M,$){if(this.h()&&this.i(),M.url=A,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new y.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(A),this.f.request(M,$)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=v}),define(oe[285],ae([0,1,3,57,26,20,19,280,24,77,80]),function(ie,e,L,N,c,O,T,D,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends D.UserDataAutoSyncService{constructor(d,p,E,l,f,u,g,y,k,i,o){super(d,p,E,l,f,g,y,k,i,o),this.B(L.Event.debounce(L.Event.any(L.Event.map(u.onDidFocusWindow,()=>"windowFocus"),L.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};b=ye([J(0,c.IProductService),J(1,I.IUserDataSyncStoreManagementService),J(2,I.IUserDataSyncStoreService),J(3,I.IUserDataSyncEnablementService),J(4,I.IUserDataSyncService),J(5,N.INativeHostService),J(6,I.IUserDataSyncLogService),J(7,S.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,O.IStorageService)],b),e.UserDataAutoSyncService=b}),define(oe[286],ae([0,1,102,22,4,23]),function(ie,e,L,N,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(S){function P(){let b=S.scheme===N.Schemas.file?(0,O.originalFSPath)(S):S.toString();return c.isLinux||(b=b.toLowerCase()),(0,L.createHash)("md5").update(b).digest("hex")}return{id:P(),configPath:S}}e.getWorkspaceIdentifier=T;function D(S,P){function b(){if(S.scheme!==N.Schemas.file)return(0,L.createHash)("md5").update(S.toString()).digest("hex");if(!P)return;let d;return c.isLinux?d=P.ino:c.isMacintosh?d=P.birthtime.getTime():c.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,L.createHash)("md5").update(S.fsPath).update(d?String(d):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:S}}e.getSingleFolderWorkspaceIdentifier=D;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[287],ae([0,1,6,10,2,14,28,15,9,75,119,286,57,71]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=class extends c.Disposable{constructor(l,f,u,g){super(),this.a=l,this.b=f,this.c=u,this.f=g,this.B(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),f=new S.StorageClient(this.f.getChannel("storage"));await Promise.all(l.map(async u=>{const g=(0,O.join)(this.a.workspaceStorageHome.fsPath,u);u.length===b.NON_EMPTY_WORKSPACE_ID_LENGTH||u===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===u)||await f.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await T.Promises.rm(g))}))}catch(l){(0,N.onUnexpectedError)(l)}}};p=ye([J(0,D.INativeEnvironmentService),J(1,I.ILogService),J(2,m.INativeHostService),J(3,d.IMainProcessService)],p),e.UnusedWorkspaceStorageDataCleaner=p}),define(oe[81],ae([0,1,54,6,14,11,28,154,296,297]),function(ie,e,L,N,c,O,T,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class b extends Error{constructor(o,n){let t=n.message;switch(o){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=o,this.cause=n}}e.ExtractError=b;function m(i){const o=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,t)=>n+t,o&61440)}function d(i){if(i instanceof b)return i;let o;return P.test(i.message)&&(o="CorruptZip"),new b(o,i)}function p(i,o,n,t,s,r){const a=c.dirname(o),h=c.join(t,a);if(!h.startsWith(t))return Promise.reject(new Error(D.localize(0,null,o)));const w=c.join(t,o);let v;return r.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(T.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((R,A)=>{if(!r.isCancellationRequested)try{v=(0,L.createWriteStream)(w,{mode:n}),v.once("close",()=>R()),v.once("error",A),i.once("error",A),i.pipe(v)}catch(M){A(M)}}))}function E(i,o,n,t){let s=(0,N.createCancelablePromise)(()=>Promise.resolve()),r=0;return t.onCancellationRequested(()=>{s.cancel(),i.close()}),new Promise((a,h)=>{const w=new N.Sequencer,v=R=>{R.isCancellationRequested||(r++,i.readEntry())};i.once("error",h),i.once("close",()=>s.then(()=>{t.isCancellationRequested||i.entryCount===r?a():h(new b("Incomplete",new Error(D.localize(1,null,r,i.entryCount))))},h)),i.readEntry(),i.on("entry",R=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(R.fileName)){v(t);return}const A=R.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(A)){const V=c.join(o,A);s=(0,N.createCancelablePromise)(q=>T.Promises.mkdir(V,{recursive:!0}).then(()=>v(q)).then(void 0,h));return}const M=f(i,R),$=m(R);s=(0,N.createCancelablePromise)(V=>w.queue(()=>M.then(q=>p(q,A,$,o,n,V).then(()=>v(V)))).then(null,h))})})}function l(i,o=!1){return new Promise((n,t)=>{(0,I.open)(i,o?{lazyEntries:!0}:void 0,(s,r)=>{s?t(d(s)):n((0,O.assertIsDefined)(r))})})}function f(i,o){return new Promise((n,t)=>{i.openReadStream(o,(s,r)=>{s?t(d(s)):n((0,O.assertIsDefined)(r))})})}function u(i,o){return new Promise((n,t)=>{const s=new S.ZipFile;o.forEach(a=>{a.contents?s.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&s.addFile(a.localPath,a.path)}),s.end();const r=(0,L.createWriteStream)(i);s.outputStream.pipe(r),s.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>n(i))})}e.zip=u;function g(i,o,n={},t){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=l(i,!0);return n.overwrite&&(r=r.then(a=>T.Promises.rm(o).then(()=>a))),r.then(a=>E(a,o,{sourcePathRegex:s},t))}e.extract=g;function y(i,o){return l(i).then(n=>new Promise((t,s)=>{n.on("entry",r=>{r.fileName===o&&f(n,r).then(a=>t(a),a=>s(a))}),n.once("close",()=>s(new Error(D.localize(2,null,o))))}))}function k(i,o){return y(i,o).then(n=>new Promise((t,s)=>{const r=[];n.once("error",s),n.on("data",a=>r.push(a)),n.on("end",()=>t(Buffer.concat(r)))}))}e.buffer=k}),define(oe[288],ae([0,1,6,10,2,22,4,23,55,11,31,28,81,17,15,29,33,100,13,9]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class yt extends c.Disposable{constructor(i,o,n,t,s,r){super(),this.h=o,this.i=n,this.j=t,this.k=s,this.l=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(i,o,n){await this.g;const t=(0,D.joinPath)(this.extensionsDownloadDir,this.v(i));try{await this.r(i,t,r=>this.i.download(i,r,o))}catch(r){throw new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Download)}let s=!1;if(n&&this.m(i)){const r=await this.n(i);try{s=await this.k.verify(t.fsPath,r.fsPath,this.l.getLevel()===g.LogLevel.Trace)}catch(a){const h=a;if(s=h.code,h.output&&this.l.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${h.output}`),s===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.ExtensionManagementError(m.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.l.error(a)}}}return s===!0?this.l.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${i.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:t,verificationStatus:s}}m(i){if(!i.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(o)?o:!0}async n(i){await this.g;const o=(0,D.joinPath)(this.extensionsDownloadDir,`${this.v(i)}${yt.c}`);return await this.r(i,o,n=>this.i.downloadSignatureArchive(i,n)),o}async r(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==O.Schemas.file){await n(o);return}const t=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(t)||await n(t);try{await this.t(t,o,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(t)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,N.getErrorMessage)(s)}. Deleted the file from downloaded location`,t.path),s}}async delete(i){await this.g,await this.h.del(i)}async t(i,o,n){try{await b.Promises.rename(i.fsPath,o.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${i} to ${o} with 'EPERM' error. Trying again...`),this.t(i,o,n);throw t}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],t=[];for(const a of i.children)if(a.name.endsWith(yt.c))t.push(a.resource);else{const h=l.ExtensionKey.parse(a.name);h&&n.push([h,a])}const s=(0,l.groupByExtension)(n,([a])=>a),r=[];for(const a of s)a.sort((h,w)=>I.rcompare(h[0].version,w[0].version)),o.push(...a.slice(1).map(h=>h[1].resource)),r.push(a[0][1]);r.sort((a,h)=>a.mtime-h.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...t),await L.Promises.settled(o.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.l.error(i)}}v(i){return this.f?l.ExtensionKey.create(i).toString().toLowerCase():(0,P.generateUuid)()}};y.c=".sigzip",y=ye([J(0,p.INativeEnvironmentService),J(1,u.IFileService),J(2,E.IExtensionGalleryService),J(3,d.IConfigurationService),J(4,f.IExtensionSignatureVerificationService),J(5,g.ILogService)],y),e.ExtensionsDownloader=y}),define(oe[289],ae([0,1,81,166]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function c(O){return(0,L.buffer)(O,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.getManifest=c}),define(oe[128],ae([0,1,6,16,25,38,10,3,2,37,22,14,4,23,55,11,12,31,28,81,165,99,15,269,29,33,51,78,288,270,289,224,239,67,13,5,9,26,19,30,18]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o,n,t,s,r,a,h,w,v,R,A,M,$,V,q,W,X,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(n.IExtensionManagementService);let Y=class extends o.AbstractExtensionManagementService{constructor(G,H,F,C,U,z,K,B,_,te,ce,he){super(G,H,F,te,he),this.Z=U,this.ab=z,this.bb=K,this.cb=_,this.db=ce,this.X=this.B(new D.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new S.ResourceSet;const pe=this.B(B.createInstance(h.ExtensionsLifecycle));this.S=this.B(B.createInstance(Z,Se=>pe.postUninstall(Se))),this.U=this.B(new v.ExtensionsManifestCache(he,_,ce,this,this.v)),this.W=this.B(B.createInstance(a.ExtensionsDownloader));const de=this.B(new R.ExtensionsWatcher(this,this.Z,he,z,ce,_,F));this.B(de.onDidChangeExtensionsByAnotherSource(Se=>this.kb(Se))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,t.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(G){this.v.trace("ExtensionManagementService#zip",G.identifier.id);const H=await this.jb(G),F=await(0,g.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,H);return l.URI.file(F)}async unzip(G){return this.v.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:H,cleanup:F}=await this.fb(G),C=b.resolve(H.fsPath);try{return await(0,w.getManifest)(C)}finally{await F()}}getInstalled(G,H=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(G??null,H)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.S.scanUserExtensionAtLocation(G)}async install(G,H={}){this.v.trace("ExtensionManagementService#install",G.toString());const{location:F,cleanup:C}=await this.fb(G);try{const U=await(0,w.getManifest)(b.resolve(F.fsPath));if(U.engines&&U.engines.vscode&&!(0,A.isEngineValid)(U.engines.vscode,this.w.version,this.w.date))throw new Error(y.localize(0,null,(0,t.getGalleryExtensionId)(U.publisher,U.name),this.w.version));return await this.z(U,F,H)}finally{await C()}}async installFromLocation(G,H){this.v.trace("ExtensionManagementService#installFromLocation",G.toString());const F=await this.S.scanUserExtensionAtLocation(G);if(!F)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.ob([[F,void 0]],H),this.v.info("Successfully installed extension",F.identifier.id,H.toString()),F}async installExtensionsFromProfile(G,H,F){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",G,H.toString(),F.toString());const C=(await this.S.scanExtensions(1,H)).filter(U=>G.some(z=>(0,t.areSameExtensions)(z,U.identifier)));if(C.length){const U=await Promise.all(C.map(z=>this.S.scanMetadata(z,H)));await this.ob(C.map((z,K)=>[z,U[K]]),F),this.v.info("Successfully installed extensions",C.map(z=>z.identifier.id),F.toString())}return C}async updateMetadata(G,H,F=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",G.identifier.id),H.isPreReleaseVersion&&(H.preRelease=!0),H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,H.pinned=H.pinned||void 0,G=await this.S.updateMetadata(G,H,F),this.U.invalidate(F),this.X.fire(G),G}async reinstallFromGallery(G){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.t.isEnabled())throw new Error(y.localize(1,null));const H=await this.getTargetPlatform(),[F]=await this.t.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:H,compatible:!0},c.CancellationToken.None);if(!F)throw new Error(y.localize(2,null));await this.S.setUninstalled(G);try{await this.S.removeUninstalledExtension(G)}catch(C){throw new Error(y.localize(3,null,(0,O.toErrorMessage)(C)))}return this.installFromGallery(F)}copyExtensions(G,H){return this.S.copyExtensions(G,H)}markAsUninstalled(...G){return this.S.setUninstalled(...G)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(G){this.v.error(G)}}async download(G,H,F){const{location:C}=await this.W.download(G,H,!F);return C}async fb(G){if(G.scheme===P.Schemas.file)return{location:G,async cleanup(){}};this.v.trace("Downloading extension from",G.toString());const H=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(G,H),this.v.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.cb.del(H)}catch(C){this.v.error(C)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(G,H,F){if(l.URI.isUri(H))return new ee(G,H,F,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const C=t.ExtensionKey.create(H).toString();let U=this.Y.get(C);return U||(this.Y.set(C,U=new j(G,H,F,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),U.waitUntilTaskIsFinished().finally(()=>this.Y.delete(C))),U}R(G,H){return new ne(G,H.profileLocation,this.ab)}async jb(G){const H=async C=>{let U=await u.Promises.readdir(C);U=U.map(B=>b.join(C,B));const z=await Promise.all(U.map(B=>u.Promises.stat(B)));let K=Promise.resolve([]);return z.forEach((B,_)=>{const te=U[_];B.isFile()&&(K=K.then(ce=>[...ce,te])),B.isDirectory()&&(K=K.then(ce=>H(te).then(he=>[...ce,...he])))}),K};return(await H(G.location.fsPath)).map(C=>({path:`extension/${b.relative(G.location.fsPath,C)}`,localPath:C}))}async kb({added:G,removed:H}){if(H)for(const F of H.extensions)this.v.info("Extensions removed from another source",F.id,H.profileLocation.toString()),this.p.fire({identifier:F,profileLocation:H.profileLocation});if(G){const C=(await this.S.scanExtensions(1,G.profileLocation)).filter(U=>G.extensions.some(z=>(0,t.areSameExtensions)(z,U.identifier)));this.m.fire(C.map(U=>(this.v.info("Extensions added from another source",U.identifier.id,G.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:G.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(H=>this.lb.add(H)));const G=await this.cb.resolve(this.Z.userExtensionsLocation);for(const H of G.children??[])H.isDirectory&&this.lb.add(H.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(H=>this.nb(H)))}async nb(G){if(!G.affects(this.Z.userExtensionsLocation,1))return;const H=[];for(const F of G.rawAdded){if(this.lb.has(F)||!this.db.extUri.isEqual(this.db.extUri.dirname(F),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(F,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(F).startsWith(".")||!(await this.cb.stat(F)).isDirectory)continue;const C=await this.S.scanUserExtensionAtLocation(F);C&&C.installedTimestamp===void 0&&(this.lb.add(F),H.push(C))}H.length&&(await this.ob(H.map(F=>[F,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",H.map(F=>F.identifier.id)))}async ob(G,H){const F=G.map(C=>C[0]);await this.pb(F),await this.ab.addExtensionsToProfile(G,H),this.m.fire(F.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:H})))}async pb(G){const H=await this.S.getUninstalledExtensions();for(const F of G){const C=t.ExtensionKey.create(F);!H[C.toString()]||(this.v.trace("Removing the extension from uninstalled list:",C.id),await this.S.setInstalled(C),this.v.info("Removed the extension from uninstalled list:",C.id))}}};Y=ye([J(0,n.IExtensionGalleryService),J(1,W.ITelemetryService),J(2,V.ILogService),J(3,i.INativeEnvironmentService),J(4,r.IExtensionsScannerService),J(5,s.IExtensionsProfileScannerService),J(6,k.IDownloadService),J(7,$.IInstantiationService),J(8,M.IFileService),J(9,q.IProductService),J(10,X.IUriIdentityService),J(11,Q.IUserDataProfilesService)],Y),e.ExtensionManagementService=Y;let Z=class extends I.Disposable{constructor(G,H,F,C,U,z){super(),this.k=G,this.l=H,this.m=F,this.n=C,this.p=U,this.s=z,this.h=this.B(new D.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(G,H){const F={includeInvalid:!0,profileLocation:H};let C=[];return G===null||G===0?C.push(...await this.m.scanAllExtensions({includeInvalid:!0},F,!1)):G===1&&C.push(...await this.m.scanUserExtensions(F)),C=G!==null?C.filter(U=>U.type===G):C,Promise.all(C.map(U=>this.y(U)))}async scanAllUserExtensions(G){const H=await this.m.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(H.map(F=>this.y(F)))}async scanUserExtensionAtLocation(G){try{const H=await this.m.scanExistingExtension(G,1,{includeInvalid:!0});if(H)return await this.y(H)}catch(H){this.s.error(H)}return null}async extractUserExtension(G,H,F,C){await this.j.catch(()=>{});const U=G.toString(),z=b.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),K=b.join(this.m.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(K)}catch{throw new n.ExtensionManagementError(y.localize(4,null,K,G.id),n.ExtensionManagementErrorCode.Delete)}await this.u(G,H,z,C),await this.m.updateMetadata(l.URI.file(z),F);try{this.h.fire(l.URI.file(K)),await this.v(G,z,K,Date.now()+2*60*1e3),this.s.info("Renamed to",K)}catch(B){try{await u.Promises.rm(z)}catch{}if(B.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.s.info(`Rename failed because of ${(0,T.getErrorMessage)(B)}. Deleted from extracted location`,z),B}return this.w(l.URI.file(K),1)}async scanMetadata(G,H){return H?(await this.n.scanProfileExtensions(H)).find(C=>(0,t.areSameExtensions)(C.identifier,G.identifier))?.metadata:this.m.scanMetadata(G.location)}async updateMetadata(G,H,F){return F?await this.n.updateMetadata([[G,H]],F):await this.m.updateMetadata(G.location,H),this.w(G.location,G.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...G){const H=G.map(F=>t.ExtensionKey.create(F));await this.t(F=>H.forEach(C=>{F[C.toString()]=!0,this.s.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(G){await this.t(H=>delete H[G.toString()])}async removeExtension(G,H){this.s.trace(`Deleting ${H} extension from disk`,G.identifier.id,G.location.fsPath);const F=this.p.extUri.joinPath(this.p.extUri.dirname(G.location),`.${(0,f.generateUuid)()}`);await this.v(G.identifier,G.location.fsPath,F.fsPath,Date.now()+2*60*1e3),await this.l.del(F,{recursive:!0}),this.s.info("Deleted from disk",G.identifier.id,G.location.fsPath)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.t(H=>delete H[t.ExtensionKey.create(G).toString()])}async copyExtensions(G,H){const F=await this.scanExtensions(1,G),C=await Promise.all(F.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,G)]));await this.n.addExtensionsToProfile(C,H)}async t(G){return this.g.queue(async()=>{let H;try{H=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(C){if((0,M.toFileOperationResult)(C)!==1)throw C}let F={};if(H)try{F=JSON.parse(H)}catch{}return G&&(G(F),Object.keys(F).length?await this.l.writeFile(this.c,N.VSBuffer.fromString(JSON.stringify(F))):await this.l.del(this.c)),F})}async u(G,H,F,C){this.s.trace(`Started extracting the extension from ${H} to ${F}`);try{await u.Promises.rm(F)}catch(U){throw new n.ExtensionManagementError(this.D(U).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(H,F,{sourcePath:"extension",overwrite:!0},C),this.s.info(`Extracted extension to ${F}:`,G.id)}catch(U){try{await u.Promises.rm(F)}catch{}let z=n.ExtensionManagementErrorCode.Extract;throw U instanceof g.ExtractError&&(U.type==="CorruptZip"?z=n.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(z=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(U.message,z)}}async v(G,H,F,C){try{await u.Promises.rename(H,F)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<C)return this.s.info(`Failed renaming ${H} to ${F} with 'EPERM' error. Trying again...`,G.id),this.v(G,H,F,C);throw new n.ExtensionManagementError(U.message||y.localize(5,null,H,F),U.code||n.ExtensionManagementErrorCode.Rename)}}async w(G,H){const F=await this.m.scanExistingExtension(G,H,{includeInvalid:!0});if(F)return this.y(F);throw new Error(y.localize(6,null,G.path))}async y(G){const H=await this.l.resolve(G.location);let F,C;return H.children&&(F=H.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,C=H.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:F,changelogUrl:C,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async z(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(G));const H=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const U of H)G[t.ExtensionKey.create(U).toString()]||F.add(U.identifier.id.toLowerCase());try{const U=(0,t.groupByExtension)(H,z=>z.identifier);await L.Promises.settled(U.map(async z=>{const K=z.sort((B,_)=>p.rcompare(B.manifest.version,_.manifest.version))[0];F.has(K.identifier.id.toLowerCase())||await this.k(await this.y(K))}))}catch(U){this.s.error(U)}const C=H.filter(U=>U.metadata&&G[t.ExtensionKey.create(U).toString()]);await Promise.allSettled(C.map(U=>this.removeUninstalledExtension(U)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const G=[];let H;try{H=await this.l.resolve(this.m.userExtensionsLocation)}catch(F){(0,M.toFileOperationResult)(F)!==1&&this.s.error(F)}for(const F of H?.children??[])F.isDirectory&&F.name.startsWith(".")&&(0,f.isUUID)(F.name.substring(1))&&G.push((async()=>{this.s.trace("Deleting the generated extension folder",F.resource.toString());try{await this.l.del(F.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",F.resource.toString())}catch(C){this.s.error(C)}})());await Promise.allSettled(G)}D(G){const H=Array.isArray(G)?G:[G];return H.length===1?H[0]instanceof Error?H[0]:new Error(H[0]):H.reduce((F,C)=>new Error(`${F.message}${F.message?",":""}${C instanceof Error?C.message:C}`),new Error(""))}};Z=ye([J(1,M.IFileService),J(2,r.IExtensionsScannerService),J(3,s.IExtensionsProfileScannerService),J(4,X.IUriIdentityService),J(5,V.ILogService)],Z),e.ExtensionsScanner=Z;class x extends o.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,E.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(G,H,F,C,U,z,K,B,_){super(),this.identifier=G,this.source=H,this.m=F,this.n=C,this.o=U,this.p=z,this.q=K,this.s=B,this.t=_,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(G){const[H,F]=await this.y(G);return this.j=H.isBuiltin||H.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[H,F]],this.j),H}async v({zipPath:G,key:H,metadata:F},C){let U=await this.w(H);return U||(this.t.trace("Extracting extension...",H.id),U=await this.n.extractUserExtension(H,G,F,C),this.t.info("Extracting extension completed.",H.id)),U}async w(G){return await this.x(G)?(this.t.trace("Removing the extension from uninstalled list:",G.id),await this.n.setInstalled(G),this.t.info("Removed the extension from uninstalled list:",G.id),(await this.n.scanAllUserExtensions(!0)).find(C=>t.ExtensionKey.create(C).equals(G))):void 0}async x(G){return!!(await this.n.getUninstalledExtensions())[G.toString()]}}class j extends x{constructor(G,H,F,C,U,z,K,B,_,te){super(H.identifier,H,F,U,z,K,B,_,te),this.z=H,this.A=C}async y(G){const F=(await this.n.scanExtensions(null,this.m.profileLocation)).find(K=>(0,t.areSameExtensions)(K.identifier,this.z.identifier));F&&(this.l=3);const C={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||F?.isMachineScoped,isBuiltin:this.m.isBuiltin||F?.isBuiltin,isSystem:F?.type===0?!0:void 0,updated:!!F,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,E.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:F?.preRelease)};if(F?.manifest.version===this.z.version)return[await this.n.updateMetadata(F,C),C];const{location:U,verificationStatus:z}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=z,this.C(U.fsPath),[await this.v({zipPath:U.fsPath,key:t.ExtensionKey.create(this.z),metadata:C},G),C]}catch(K){try{await this.A.delete(U)}catch(B){this.t.warn("Error while deleting the downloaded file",U.toString(),(0,T.getErrorMessage)(B))}throw K}}async C(G){try{await(0,w.getManifest)(G)}catch(H){throw new n.ExtensionManagementError((0,o.joinErrors)(H).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class ee extends x{constructor(G,H,F,C,U,z,K,B,_,te){super({id:(0,t.getGalleryExtensionId)(G.publisher,G.name)},H,F,U,z,K,B,_,te),this.z=G,this.A=H,this.B=C}async h(G){const H=await super.h(G);return this.E(H,G),H}async y(G){const H=new t.ExtensionKey(this.identifier,this.z.version),C=(await this.n.scanExtensions(1,this.m.profileLocation)).find(K=>(0,t.areSameExtensions)(this.identifier,K.identifier)),U={isApplicationScoped:this.m.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||C?.isMachineScoped,isBuiltin:this.m.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(C)if(this.l=3,H.equals(new t.ExtensionKey(C.identifier,C.manifest.version)))try{await this.n.removeExtension(C,"existing")}catch{throw new Error(y.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&p.gt(C.manifest.version,this.z.version)&&await this.n.setUninstalled(C);else{const K=await this.w(H);if(K)try{await this.n.removeExtension(K,"existing")}catch{throw new Error(y.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:b.resolve(this.A.fsPath),key:H,metadata:U},G),U]}async E(G,H){try{let[F]=await this.B.getExtensions([{id:G.identifier.id,version:G.manifest.version}],H);if(F||([F]=await this.B.getExtensions([{id:G.identifier.id}],H)),F){const C={id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(G,C,this.m.profileLocation)}}catch{}}}class ne extends o.AbstractExtensionTask{constructor(G,H,F){super(),this.extension=G,this.j=H,this.k=F}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[290],ae([0,1,2,29,79,238,128,9,20]),function(ie,e,L,N,c,O,T,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends L.Disposable{constructor(b,m,d,p,E,l){super(),b.cleanUp(),(0,O.migrateUnsupportedExtensions)(b,m,d,p,l),c.ExtensionStorageService.removeOutdatedExtensionVersions(b,E)}};S=ye([J(0,T.INativeServerExtensionManagementService),J(1,N.IExtensionGalleryService),J(2,c.IExtensionStorageService),J(3,N.IGlobalExtensionEnablementService),J(4,I.IStorageService),J(5,D.ILogService)],S),e.ExtensionsContributions=S}),define(oe[298],ae([0,1,150,231,250,34,38,10,2,22,12,39,152,217,218,210,211,287,201,203,17,222,98,235,99,228,15,232,120,273,29,100,202,128,101,13,213,214,68,5,209,70,72,241,9,106,107,26,59,20,112,19,113,114,115,46,244,117,253,79,118,24,77,278,264,265,80,279,282,283,284,61,277,267,111,234,76,255,226,254,110,30,256,4,257,204,220,219,78,272,18,51,216,58,276,243,268,109,281,290,7,215,266,87,105,236,271,229,198,57,285,274,71,275]),function(ie,e,L,N,c,O,T,D,I,S,P,b,m,d,p,E,l,f,u,g,y,k,i,o,n,t,s,r,a,h,w,v,R,A,M,$,V,q,W,X,Q,Y,Z,x,j,ee,ne,re,G,H,F,C,U,z,K,B,_,te,ce,he,pe,de,Se,Ce,De,ke,We,Ye,le,fe,ge,Ie,Pe,Fe,Le,Be,Me,Ne,je,se,ue,me,we,ve,Ee,Re,Ae,Te,Ue,$e,ze,et,nt,vt,Rt,Dt,kt,St,Lt,At,Ot,Tt,Nt,Ze,wt,Ut,Mt,Ft,jt,$t,zt,Bt,bt,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class qt extends I.Disposable{constructor(be,Oe){super(),this.f=be,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.B(new m.Server):this.a=this.B(new L.Server),this.h()}h(){let be=!1;const Oe=()=>{be||(be=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,m.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",qe=(st,Ve)=>{this.i(Ve)};this.g.on(xe,qe),this.B((0,I.toDisposable)(()=>this.g.removeListener(xe,qe)))}}i(be){this.b?.disposeWorker(be)}async init(){const be=await this.j();(0,de.registerConfiguration)(),be.invokeFunction(Oe=>{const xe=Oe.get(j.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.B((0,I.combinedDisposable)(be.createInstance(d.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(p.LanguagePackCachedDataCleaner),be.createInstance(f.UnusedWorkspaceStorageDataCleaner),be.createInstance(l.LogsDataCleaner),be.createInstance(E.LocalizationsUpdater),be.createInstance(At.ExtensionsContributions),be.createInstance(kt.UserDataProfilesCleaner)))}async j(){const be=new Y.ServiceCollection,Oe={_serviceBrand:void 0,...ne.default};be.set(re.IProductService,Oe);const xe=new b.StaticRouter(Ke=>Ke==="main"),qe=new bt.MainProcessService(this.a,xe);be.set(bt.IMainProcessService,qe);const st=this.f.policiesData?new nt.PolicyChannelClient(this.f.policiesData,qe.getChannel("policy")):new vt.NullPolicyService;be.set(vt.IPolicyService,st);const Ve=new r.SharedProcessEnvironmentService(this.f.args,Oe);be.set(s.INativeEnvironmentService,Ve);const Qe=new ee.LoggerChannelClient(void 0,this.f.logLevel,Ve.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:P.URI.revive(Ke.resource)})),qe.getChannel("logger"));be.set(j.ILoggerService,Qe);const ct=this.B(Qe.createLogger("sharedprocess",{name:(0,Ot.localize)(0,null)})),ft=this.B(new j.ConsoleLogger(ct.getLevel())),Ge=this.B(new Tt.LogService(ct,[ft]));be.set(j.ILogService,Ge),this.c=this.B(new wt.SharedProcessLifecycleService(Ge)),be.set(wt.ISharedProcessLifecycleService,this.c),this.b=new N.SharedProcessWorkerService(Ge),be.set(ue.ISharedProcessWorkerService,this.b);const _e=this.B(new V.FileService(Ge));be.set($.IFileService,_e);const dt=this.B(new q.DiskFileSystemProvider(Ge));_e.registerProvider(S.Schemas.file,dt);const gt=this.B(new Ee.FileUserDataProvider(S.Schemas.file,this.B(new Re.DiskFileSystemProviderClient(qe.getChannel(Re.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ve.isLinux})),S.Schemas.vscodeUserData,Ge));_e.registerProvider(S.Schemas.vscodeUserData,gt);const tt=this.B(new Rt.UserDataProfilesService(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),qe.getChannel("userDataProfiles")));be.set(ze.IUserDataProfilesService,tt);const Je=this.B(new k.ConfigurationService(tt.defaultProfile.settingsResource,_e,st,Ge));be.set(y.IConfigurationService,Je);const rt=new Wt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},qe,Ve);be.set(H.IStorageService,rt),this.B((0,I.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const mt=new we.UriIdentityService(_e);be.set(me.IUriIdentityService,mt),be.set(G.IRequestService,new Ft.RequestChannelClient(qe.getChannel("request"))),be.set(u.IChecksumService,new W.SyncDescriptor(g.ChecksumService,void 0,!1)),be.set(Te.IV8InspectProfilingService,new W.SyncDescriptor(Ae.InspectProfilingService,void 0,!1));const lt=b.ProxyChannel.toService(qe.getChannel("nativeHost"),{context:this.f.windowId});be.set($t.INativeHostService,lt),be.set(n.IDownloadService,new W.SyncDescriptor(t.DownloadService,void 0,!0));const pt=this.B(new Fe.ActiveWindowManager(lt)),xt=new b.StaticRouter(Ke=>pt.getActiveClientId().then(ht=>Ke===ht));be.set(M.IExtensionRecommendationNotificationService,new jt.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",xt)));let ut;const ot=[],Ct=(0,B.isInternalTelemetry)(Oe,Je);if((0,B.supportsTelemetry)(Oe,Ve)){const Ke=new z.TelemetryLogAppender(Ge,Qe,Ve,Oe);if(ot.push(Ke),Oe.aiConfig?.ariaKey){const ht=new Dt.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.B((0,I.toDisposable)(()=>ht.flush())),ot.push(ht)}ut=new K.TelemetryService({appenders:ot,commonProperties:(0,F.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct),sendErrorTelemetry:!0,piiPaths:(0,B.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=B.NullTelemetryService;const Ke=B.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new U.TelemetryAppenderChannel(ot)),be.set(C.ITelemetryService,ut);const Vt=new _.CustomEndpointTelemetryService(Je,ut,Ge,Qe,Ve,Oe);be.set(C.ICustomEndpointTelemetryService,Vt),be.set(et.IExtensionsProfileScannerService,new W.SyncDescriptor(Mt.ExtensionsProfileScannerService,void 0,!0)),be.set(Ue.IExtensionsScannerService,new W.SyncDescriptor($e.ExtensionsScannerService,void 0,!0)),be.set(v.IExtensionSignatureVerificationService,new W.SyncDescriptor(v.ExtensionSignatureVerificationService,void 0,!0)),be.set(A.INativeServerExtensionManagementService,new W.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),be.set(w.IExtensionGalleryService,new W.SyncDescriptor(h.ExtensionGalleryService,void 0,!0)),be.set(w.IExtensionTipsService,new W.SyncDescriptor(Bt.ExtensionTipsService,void 0,!1)),be.set(Z.ILanguagePackService,new W.SyncDescriptor(x.NativeLanguagePackService,void 0,!1)),be.set(i.IDiagnosticsService,new W.SyncDescriptor(o.DiagnosticsService,void 0,!1)),be.set(Se.IUserDataSyncAccountService,new W.SyncDescriptor(Se.UserDataSyncAccountService,void 0,!0)),be.set(de.IUserDataSyncLogService,new W.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),be.set(de.IUserDataSyncUtilService,new De.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),be.set(w.IGlobalExtensionEnablementService,new W.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),be.set(pe.IIgnoredExtensionsManagementService,new W.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),be.set(he.IExtensionStorageService,new W.SyncDescriptor(he.ExtensionStorageService)),be.set(de.IUserDataSyncStoreManagementService,new W.SyncDescriptor(ge.UserDataSyncStoreManagementService,void 0,!0)),be.set(de.IUserDataSyncStoreService,new W.SyncDescriptor(ge.UserDataSyncStoreService,void 0,!0)),be.set(We.IUserDataSyncMachinesService,new W.SyncDescriptor(We.UserDataSyncMachinesService,void 0,!0)),be.set(de.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),be.set(de.IUserDataSyncEnablementService,new W.SyncDescriptor(Ye.UserDataSyncEnablementService,void 0,!0)),be.set(de.IUserDataSyncService,new W.SyncDescriptor(le.UserDataSyncService,void 0,!1)),be.set(Ie.IUserDataProfileStorageService,new W.SyncDescriptor(Pe.NativeUserDataProfileStorageService,void 0,!0)),be.set(de.IUserDataSyncResourceProviderService,new W.SyncDescriptor(Lt.UserDataSyncResourceProviderService,void 0,!0));const It=new ce.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Je,Ve,Ge,Qe);return It.initialize(),be.set(c.ILocalPtyService,this.B(It)),be.set(Le.ISignService,new W.SyncDescriptor(Be.SignService,void 0,!1)),be.set(Me.ISharedTunnelsService,new W.SyncDescriptor(Ne.SharedTunnelsService)),be.set(je.ISharedProcessTunnelService,new W.SyncDescriptor(se.SharedProcessTunnelService)),be.set(St.IRemoteTunnelService,new W.SyncDescriptor(Ut.RemoteTunnelService)),new Q.InstantiationService(be)}k(be){const Oe=new R.ExtensionManagementChannel(be.get(w.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=b.ProxyChannel.fromService(be.get(Z.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const qe=b.ProxyChannel.fromService(be.get(i.IDiagnosticsService));this.a.registerChannel("diagnostics",qe);const st=new R.ExtensionTipsChannel(be.get(w.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=b.ProxyChannel.fromService(be.get(u.IChecksumService));this.a.registerChannel("checksum",Ve);const Qe=b.ProxyChannel.fromService(be.get(Te.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",Qe);const ct=new De.UserDataSyncMachinesServiceChannel(be.get(We.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ft=b.ProxyChannel.fromService(be.get(C.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ft);const Ge=new De.UserDataSyncAccountServiceChannel(be.get(Se.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const _e=new De.UserDataSyncStoreManagementServiceChannel(be.get(de.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",_e);const dt=new fe.UserDataSyncChannel(be.get(de.IUserDataSyncService),be.get(ze.IUserDataProfilesService),be.get(j.ILogService));this.a.registerChannel("userDataSync",dt);const gt=this.B(be.get(X.IInstantiationService).createInstance(zt.UserDataAutoSyncService)),tt=new De.UserDataAutoSyncChannel(gt);this.a.registerChannel("userDataAutoSync",tt);const Je=be.get(c.ILocalPtyService),rt=b.ProxyChannel.fromService(Je);this.a.registerChannel(te.TerminalIpcChannels.LocalPty,rt);const mt=b.ProxyChannel.fromService(be.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,mt);const lt=b.ProxyChannel.fromService(be.get(ue.ISharedProcessWorkerService));this.a.registerChannel(Nt.ipcUtilityProcessWorkerChannelName,lt);const pt=b.ProxyChannel.fromService(be.get(St.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",pt)}l(be){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,D.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,D.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,D.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,D.setUnexpectedErrorHandler)(Oe=>{const xe=(0,T.toErrorMessage)(Oe,!0);!xe||be.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(at){let be;(0,Ze.isUtilityProcess)(process)||(be=(await new Promise((xe,qe)=>{ie(["electron"],xe,qe)})).ipcRenderer);const Oe=new qt(at,be);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):be.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):be.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
