/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","os","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(se){for(var e=[],a=0,A=se.length;a<A;a++)e[a]=Ie[se[a]];return e};define(Ie[61],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(P,T){const D=Object.create(null);for(const v of P){const O=T(v);let k=D[O];k||(k=D[O]=[]),k.push(v)}return D}e.groupBy=a;function A(P,T){const D=[],v=[];for(const O of P)T.has(O)||D.push(O);for(const O of T)P.has(O)||v.push(O);return{removed:D,added:v}}e.diffSets=A;function l(P,T){const D=[],v=[];for(const[O,k]of P)T.has(O)||D.push(k);for(const[O,k]of T)P.has(O)||v.push(k);return{removed:D,added:v}}e.diffMaps=l;class R{constructor(){this.a=new Map}add(T,D){let v=this.a.get(T);v||(v=new Set,this.a.set(T,v)),v.add(D)}delete(T,D){const v=this.a.get(T);!v||(v.delete(D),v.size===0&&this.a.delete(T))}forEach(T,D){const v=this.a.get(T);!v||v.forEach(D)}}e.SetMap=R}),define(Ie[62],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(P){return(T,D,v)=>{let O=null,k=null;if(typeof v.value=="function"?(O="value",k=v.value):typeof v.get=="function"&&(O="get",k=v.get),!k)throw new Error("not supported");v[O]=P(k,D)}}function A(P,T,D){let v=null,O=null;if(typeof D.value=="function"?(v="value",O=D.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(v="get",O=D.get),!O)throw new Error("not supported");const k=`$memoize$${T}`;D[v]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,S)}),this[k]}}e.memoize=A;function l(P,T,D){return a((v,O)=>{const k=`$debounce$${O}`,S=`$debounce$result$${O}`;return function(...C){this[S]||(this[S]=D?D():void 0),clearTimeout(this[k]),T&&(this[S]=T(this[S],...C),C=[this[S]]),this[k]=setTimeout(()=>{v.apply(this,C),this[S]=D?D():void 0},P)}})}e.debounce=l;function R(P,T,D){return a((v,O)=>{const k=`$throttle$timer$${O}`,S=`$throttle$result$${O}`,C=`$throttle$lastRun$${O}`,I=`$throttle$pending$${O}`;return function(...E){if(this[S]||(this[S]=D?D():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),T&&(this[S]=T(this[S],...E)),this[I])return;const n=this[C]+P;n<=Date.now()?(this[C]=Date.now(),v.apply(this,[this[S]]),this[S]=D?D():void 0):(this[I]=!0,this[k]=setTimeout(()=>{this[I]=!1,this[C]=Date.now(),v.apply(this,[this[S]]),this[S]=D?D():void 0},n-Date.now()))}})}e.throttle=R}),define(Ie[8],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(r=>{r(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function l(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(t){v(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function P(t){v(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=P;function T(t){if(t instanceof Error){const{name:o,message:r}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:o,message:r,stack:c,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=T;const D="Canceled";function v(t){return t instanceof O?!0:t instanceof Error&&t.name===D&&t.message===D}e.isCancellationError=v;class O extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=O;function k(){const t=new Error(D);return t.name=t.message,t}e.canceled=k;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function C(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=C;function I(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function E(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class h extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=h;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const r=new y;return r.message=o.message,r.stack=o.stack,r}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(Ie[17],Ce([1,0,8]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(ie,ne=0){return ie[ie.length-(1+ne)]}e.tail=A;function l(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}e.tail2=l;function R(ie,ne,de=(ee,ce)=>ee===ce){if(ie===ne)return!0;if(!ie||!ne||ie.length!==ne.length)return!1;for(let ee=0,ce=ie.length;ee<ce;ee++)if(!de(ie[ee],ne[ee]))return!1;return!0}e.equals=R;function P(ie,ne){const de=ie.length-1;ne<de&&(ie[ne]=ie[de]),ie.pop()}e.removeFastWithoutKeepingOrder=P;function T(ie,ne,de){return D(ie.length,ee=>de(ie[ee],ne))}e.binarySearch=T;function D(ie,ne){let de=0,ee=ie-1;for(;de<=ee;){const ce=(de+ee)/2|0,ae=ne(ce);if(ae<0)de=ce+1;else if(ae>0)ee=ce-1;else return ce}return-(de+1)}e.binarySearch2=D;function v(ie,ne){let de=0,ee=ie.length;if(ee===0)return 0;for(;de<ee;){const ce=Math.floor((de+ee)/2);ne(ie[ce])?ee=ce:de=ce+1}return de}e.findFirstInSorted=v;function O(ie,ne,de){if(ie=ie|0,ie>=ne.length)throw new TypeError("invalid index");const ee=ne[Math.floor(ne.length*Math.random())],ce=[],ae=[],N=[];for(const $ of ne){const X=de($,ee);X<0?ce.push($):X>0?ae.push($):N.push($)}return ie<ce.length?O(ie,ce,de):ie<ce.length+N.length?N[0]:O(ie-(ce.length+N.length),ae,de)}e.quickSelect=O;function k(ie,ne){const de=[];let ee;for(const ce of ie.slice(0).sort(ne))!ee||ne(ee[0],ce)!==0?(ee=[ce],de.push(ee)):ee.push(ce);return de}e.groupBy=k;function S(ie,ne,de){const ee=[];function ce($,X,Z){if(X===0&&Z.length===0)return;const he=ee[ee.length-1];he&&he.start+he.deleteCount===$?(he.deleteCount+=X,he.toInsert.push(...Z)):ee.push({start:$,deleteCount:X,toInsert:Z})}let ae=0,N=0;for(;;){if(ae===ie.length){ce(ae,0,ne.slice(N));break}if(N===ne.length){ce(ae,ie.length-ae,[]);break}const $=ie[ae],X=ne[N],Z=de($,X);Z===0?(ae+=1,N+=1):Z<0?(ce(ae,1,[]),ae+=1):Z>0&&(ce(ae,0,[X]),N+=1)}return ee}e.sortedDiff=S;function C(ie,ne,de){const ee=S(ie,ne,de),ce=[],ae=[];for(const N of ee)ce.push(...ie.slice(N.start,N.start+N.deleteCount)),ae.push(...N.toInsert);return{removed:ce,added:ae}}e.delta=C;function I(ie,ne,de){if(de===0)return[];const ee=ie.slice(0,de).sort(ne);return n(ie,ne,ee,de,ie.length),ee}e.top=I;function E(ie,ne,de,ee,ce){return de===0?Promise.resolve([]):new Promise((ae,N)=>{(async()=>{const $=ie.length,X=ie.slice(0,de).sort(ne);for(let Z=de,he=Math.min(de+ee,$);Z<$;Z=he,he=Math.min(he+ee,$)){if(Z>de&&await new Promise(Se=>setTimeout(Se)),ce&&ce.isCancellationRequested)throw new a.CancellationError;n(ie,ne,X,Z,he)}return X})().then(ae,N)})}e.topAsync=E;function n(ie,ne,de,ee,ce){for(const ae=de.length;ee<ce;ee++){const N=ie[ee];if(ne(N,de[ae-1])<0){de.pop();const $=v(de,X=>ne(N,X)<0);de.splice($,0,N)}}}function d(ie){return ie.filter(ne=>!!ne)}e.coalesce=d;function h(ie){let ne=0;for(let de=0;de<ie.length;de++)ie[de]&&(ie[ne]=ie[de],ne+=1);ie.length=ne}e.coalesceInPlace=h;function w(ie,ne,de){ie.splice(de,0,ie.splice(ne,1)[0])}e.move=w;function y(ie){return!Array.isArray(ie)||ie.length===0}e.isFalsyOrEmpty=y;function p(ie){return Array.isArray(ie)&&ie.length>0}e.isNonEmptyArray=p;function t(ie,ne=de=>de){const de=new Set;return ie.filter(ee=>{const ce=ne(ee);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function o(ie){const ne=new Set;return de=>{const ee=ie(de);return ne.has(ee)?!1:(ne.add(ee),!0)}}e.uniqueFilter=o;function r(ie,ne){const de=c(ie,ne);if(de!==-1)return ie[de]}e.findLast=r;function c(ie,ne){for(let de=ie.length-1;de>=0;de--){const ee=ie[de];if(ne(ee))return de}return-1}e.lastIndex=c;function m(ie,ne){return ie.length>0?ie[0]:ne}e.firstOrDefault=m;function f(ie,ne){return ie.length>0?ie[ie.length-1]:ne}e.lastOrDefault=f;function i(ie,ne,de=(ee,ce)=>ee===ce){let ee=0;for(let ce=0,ae=Math.min(ie.length,ne.length);ce<ae&&de(ie[ce],ne[ce]);ce++)ee++;return ee}e.commonPrefixLength=i;function s(ie){return[].concat(...ie)}e.flatten=s;function u(ie,ne){let de=typeof ne=="number"?ie:0;typeof ne=="number"?de=ie:(de=0,ne=ie);const ee=[];if(de<=ne)for(let ce=de;ce<ne;ce++)ee.push(ce);else for(let ce=de;ce>ne;ce--)ee.push(ce);return ee}e.range=u;function b(ie,ne,de){return ie.reduce((ee,ce)=>(ee[ne(ce)]=de?de(ce):ce,ee),Object.create(null))}e.index=b;function g(ie,ne){return ie.push(ne),()=>L(ie,ne)}e.insert=g;function L(ie,ne){const de=ie.indexOf(ne);if(de>-1)return ie.splice(de,1),ne}e.remove=L;function j(ie,ne,de){const ee=ie.slice(0,ne),ce=ie.slice(ne);return ee.concat(de,ce)}e.arrayInsert=j;function G(ie,ne){let de;if(typeof ne=="number"){let ee=ne;de=()=>{const ce=Math.sin(ee++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let ee=ie.length-1;ee>0;ee-=1){const ce=Math.floor(de()*(ee+1)),ae=ie[ee];ie[ee]=ie[ce],ie[ce]=ae}}e.shuffle=G;function Q(ie,ne){const de=ie.indexOf(ne);de>-1&&(ie.splice(de,1),ie.unshift(ne))}e.pushToStart=Q;function B(ie,ne){const de=ie.indexOf(ne);de>-1&&(ie.splice(de,1),ie.push(ne))}e.pushToEnd=B;function U(ie,ne){for(const de of ne)ie.push(de)}e.pushMany=U;function z(ie,ne){return Array.isArray(ie)?ie.map(ne):ne(ie)}e.mapArrayOrNot=z;function M(ie){return Array.isArray(ie)?ie:[ie]}e.asArray=M;function x(ie){return ie[Math.floor(Math.random()*ie.length)]}e.getRandomElement=x;function fe(ie,ne){for(const de of ie){const ee=ne(de);if(ee!==void 0)return ee}}e.mapFind=fe;function re(ie,ne,de){const ee=_(ie,ne),ce=ie.length,ae=de.length;ie.length=ce+ae;for(let N=ce-1;N>=ee;N--)ie[N+ae]=ie[N];for(let N=0;N<ae;N++)ie[N+ee]=de[N]}e.insertInto=re;function V(ie,ne,de,ee){const ce=_(ie,ne),ae=ie.splice(ce,de);return re(ie,ce,ee),ae}e.splice=V;function _(ie,ne){return ne<0?Math.max(ne+ie.length,0):Math.min(ne,ie.length)}var te;(function(ie){function ne(ce){return ce<0}ie.isLessThan=ne;function de(ce){return ce>0}ie.isGreaterThan=de;function ee(ce){return ce===0}ie.isNeitherLessOrGreaterThan=ee,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function ve(ie,ne){return(de,ee)=>ne(ie(de),ie(ee))}e.compareBy=ve;function le(...ie){return(ne,de)=>{for(const ee of ie){const ce=ee(ne,de);if(!te.isNeitherLessOrGreaterThan(ce))return ce}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const ue=(ie,ne)=>ie-ne;e.numberComparator=ue;function q(ie,ne){if(ie.length===0)return;let de=ie[0];for(let ee=1;ee<ie.length;ee++){const ce=ie[ee];ne(ce,de)>0&&(de=ce)}return de}e.findMaxBy=q;function F(ie,ne){if(ie.length===0)return;let de=ie[0];for(let ee=1;ee<ie.length;ee++){const ce=ie[ee];ne(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=F;function J(ie,ne){return q(ie,(de,ee)=>-ne(de,ee))}e.findMinBy=J;class ge{constructor(ne){this.f=ne,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let de=this.c;for(;de<this.f.length&&ne(this.f[de]);)de++;const ee=de===this.c?null:this.f.slice(this.c,de);return this.c=de,ee}takeFromEndWhile(ne){let de=this.d;for(;de>=0&&ne(this.f[de]);)de--;const ee=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ne=this.f[this.c];return this.c++,ne}removeLast(){const ne=this.f[this.d];return this.d--,ne}takeCount(ne){const de=this.f.slice(this.c,this.c+ne);return this.c+=ne,de}}e.ArrayQueue=ge;class Ee{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(de=>(ne(de),!0))}toArray(){const ne=[];return this.iterate(de=>(ne.push(de),!0)),ne}filter(ne){return new Ee(de=>this.iterate(ee=>ne(ee)?de(ee):!0))}map(ne){return new Ee(de=>this.iterate(ee=>de(ne(ee))))}some(ne){let de=!1;return this.iterate(ee=>(de=ne(ee),!de)),de}findFirst(ne){let de;return this.iterate(ee=>ne(ee)?(de=ee,!1):!0),de}findLast(ne){let de;return this.iterate(ee=>(ne(ee)&&(de=ee),!0)),de}findLastMaxBy(ne){let de,ee=!0;return this.iterate(ce=>((ee||te.isGreaterThan(ne(ce,de)))&&(ee=!1,de=ce),!0)),de}}Ee.empty=new Ee(ie=>{}),e.CallbackIterable=Ee}),define(Ie[51],Ce([1,0,8]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(D,v){if(!D)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=A;function l(D,v="Unreachable"){throw new Error(v)}e.assertNever=l;function R(D){if(!D)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function P(D){if(!D()){debugger;D(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=P;function T(D,v){let O=0;for(;O<D.length-1;){const k=D[O],S=D[O+1];if(!v(k,S))return!1;O++}return!0}e.checkAdjacentItems=T}),define(Ie[63],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(A){const l=this;let R=!1,P;return function(){return R||(R=!0,P=A.apply(l,arguments)),P}}e.once=a}),define(Ie[102],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ie[64],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(A){function l(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}A.is=l;const R=Object.freeze([]);function P(){return R}A.empty=P;function*T(y){yield y}A.single=T;function D(y){return l(y)?y:T(y)}A.wrap=D;function v(y){return y||R}A.from=v;function O(y){return!y||y[Symbol.iterator]().next().done===!0}A.isEmpty=O;function k(y){return y[Symbol.iterator]().next().value}A.first=k;function S(y,p){for(const t of y)if(p(t))return!0;return!1}A.some=S;function C(y,p){for(const t of y)if(p(t))return t}A.find=C;function*I(y,p){for(const t of y)p(t)&&(yield t)}A.filter=I;function*E(y,p){let t=0;for(const o of y)yield p(o,t++)}A.map=E;function*n(...y){for(const p of y)for(const t of p)yield t}A.concat=n;function d(y,p,t){let o=t;for(const r of y)o=p(o,r);return o}A.reduce=d;function*h(y,p,t=y.length){for(p<0&&(p+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);p<t;p++)yield y[p]}A.slice=h;function w(y,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,y];const o=y[Symbol.iterator]();for(let r=0;r<p;r++){const c=o.next();if(c.done)return[t,A.empty()];t.push(c.value)}return[t,{[Symbol.iterator](){return o}}]}A.consume=w})(a=e.Iterable||(e.Iterable={}))}),define(Ie[147],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function P(t,o=!1){let r=0;const c=t.length;let m="",f=0,i=16,s=0;function u(B){let U=0,z=0;for(;U<B;){const M=t.charCodeAt(r);if(M>=48&&M<=57)z=z*16+M-48;else if(M>=65&&M<=70)z=z*16+M-65+10;else if(M>=97&&M<=102)z=z*16+M-97+10;else break;r++,U++}return U<B&&(z=-1),z}function b(B){r=B,m="",f=0,i=16,s=0}function g(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&v(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&v(t.charCodeAt(r)))for(r++;r<t.length&&v(t.charCodeAt(r));)r++;else return s=3,t.substring(B,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&v(t.charCodeAt(r))){for(r++;r<t.length&&v(t.charCodeAt(r));)r++;U=r}else s=3;return t.substring(B,U)}function L(){let B="",U=r;for(;;){if(r>=c){B+=t.substring(U,r),s=2;break}const z=t.charCodeAt(r);if(z===34){B+=t.substring(U,r),r++;break}if(z===92){if(B+=t.substring(U,r),r++,r>=c){s=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const x=u(4);x>=0?B+=String.fromCharCode(x):s=4;break}default:s=5}U=r;continue}if(z>=0&&z<=31)if(D(z)){B+=t.substring(U,r),s=2;break}else s=6;r++}return B}function j(){if(m="",s=0,f=r,r>=c)return f=c,i=17;let B=t.charCodeAt(r);if(T(B)){do r++,m+=String.fromCharCode(B),B=t.charCodeAt(r);while(T(B));return i=15}if(D(B))return r++,m+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,m+=`
`),i=14;switch(B){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,m=L(),i=10;case 47:{const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!D(t.charCodeAt(r));)r++;return m=t.substring(U,r),i=12}if(t.charCodeAt(r+1)===42){r+=2;const z=c-1;let M=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,s=1),m=t.substring(U,r),i=13}return m+=String.fromCharCode(B),r++,i=16}case 45:if(m+=String.fromCharCode(B),r++,r===c||!v(t.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=g(),i=11;default:for(;r<c&&G(B);)r++,B=t.charCodeAt(r);if(f!==r){switch(m=t.substring(f,r),m){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return m+=String.fromCharCode(B),r++,i=16}}function G(B){if(T(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let B;do B=j();while(B>=12&&B<=15);return B}return{setPosition:b,getPosition:()=>r,scan:o?Q:j,getToken:()=>i,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>s}}e.createScanner=P;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function k(t,o){const r=[],c=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function s(u,b,g,L){f.value=u,f.offset=b,f.length=g,f.type=L,f.colonOffset=void 0,m=f}try{w(t,{onObjectBegin:(u,b)=>{if(o<=u)throw c;m=void 0,i=o>u,r.push("")},onObjectProperty:(u,b,g)=>{if(o<b||(s(u,b,g,"property"),r[r.length-1]=u,o<=b+g))throw c},onObjectEnd:(u,b)=>{if(o<=u)throw c;m=void 0,r.pop()},onArrayBegin:(u,b)=>{if(o<=u)throw c;m=void 0,r.push(0)},onArrayEnd:(u,b)=>{if(o<=u)throw c;m=void 0,r.pop()},onLiteralValue:(u,b,g)=>{if(o<b||(s(u,b,g,p(u)),o<=b+g))throw c},onSeparator:(u,b,g)=>{if(o<=b)throw c;if(u===":"&&m&&m.type==="property")m.colonOffset=b,i=!1,m=void 0;else if(u===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(i=!0,r[r.length-1]=""),m=void 0}}})}catch(u){if(u!==c)throw u}return{path:r,previousNode:m,isAtPropertyKey:i,matches:u=>{let b=0;for(let g=0;b<u.length&&g<r.length;g++)if(u[b]===r[g]||u[b]==="*")b++;else if(u[b]!=="**")return!1;return b===u.length}}}e.getLocation=k;function S(t,o=[],r=R.DEFAULT){let c=null,m=[];const f=[];function i(u){Array.isArray(m)?m.push(u):c!==null&&(m[c]=u)}return w(t,{onObjectBegin:()=>{const u={};i(u),f.push(m),m=u,c=null},onObjectProperty:u=>{c=u},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const u=[];i(u),f.push(m),m=u,c=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:i,onError:(u,b,g)=>{o.push({error:u,offset:b,length:g})}},r),m[0]}e.parse=S;function C(t,o=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(u){c.type==="property"&&(c.length=u-c.offset,c=c.parent)}function f(u){return c.children.push(u),u}w(t,{onObjectBegin:u=>{c=f({type:"object",offset:u,length:-1,parent:c,children:[]})},onObjectProperty:(u,b,g)=>{c=f({type:"property",offset:b,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:u,offset:b,length:g,parent:c})},onObjectEnd:(u,b)=>{c.length=u+b-c.offset,c=c.parent,m(u+b)},onArrayBegin:(u,b)=>{c=f({type:"array",offset:u,length:-1,parent:c,children:[]})},onArrayEnd:(u,b)=>{c.length=u+b-c.offset,c=c.parent,m(u+b)},onLiteralValue:(u,b,g)=>{f({type:p(u),offset:b,length:g,parent:c,value:u}),m(b+g)},onSeparator:(u,b,g)=>{c.type==="property"&&(u===":"?c.colonOffset=b:u===","&&m(b))},onError:(u,b,g)=>{o.push({error:u,offset:b,length:g})}},r);const s=c.children[0];return s&&delete s.parent,s}e.parseTree=C;function I(t,o){if(!t)return;let r=t;for(const c of o)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let m=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===c){r=f.children[1],m=!0;break}if(!m)return}else{const m=c;if(r.type!=="array"||m<0||!Array.isArray(r.children)||m>=r.children.length)return;r=r.children[m]}return r}e.findNodeAtLocation=I;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.getNodePath=E;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const o=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(o[r.children[0].value]=n(c))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function d(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.contains=d;function h(t,o,r=!1){if(d(t,o,r)){const c=t.children;if(Array.isArray(c))for(let m=0;m<c.length&&c[m].offset<=o;m++){const f=h(c[m],o,r);if(f)return f}return t}}e.findNodeAtOffset=h;function w(t,o,r=R.DEFAULT){const c=P(t,!1);function m(ve){return ve?()=>ve(c.getTokenOffset(),c.getTokenLength()):()=>!0}function f(ve){return ve?le=>ve(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const i=m(o.onObjectBegin),s=f(o.onObjectProperty),u=m(o.onObjectEnd),b=m(o.onArrayBegin),g=m(o.onArrayEnd),L=f(o.onLiteralValue),j=f(o.onSeparator),G=m(o.onComment),Q=f(o.onError),B=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const ve=c.scan();switch(c.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ve){case 12:case 13:B?M(10):G();break;case 16:M(1);break;case 15:case 14:break;default:return ve}}}function M(ve,le=[],ue=[]){if(Q(ve),le.length+ue.length>0){let q=c.getToken();for(;q!==17;){if(le.indexOf(q)!==-1){z();break}else if(ue.indexOf(q)!==-1)break;q=z()}}}function x(ve){const le=c.getTokenValue();return ve?L(le):s(le),z(),!0}function fe(){switch(c.getToken()){case 11:{let ve=0;try{ve=JSON.parse(c.getTokenValue()),typeof ve!="number"&&(M(2),ve=0)}catch{M(2)}L(ve);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return z(),!0}function re(){return c.getToken()!==10?(M(3,[],[2,5]),!1):(x(!1),c.getToken()===6?(j(":"),z(),te()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function V(){i(),z();let ve=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ve||M(4,[],[]),j(","),z(),c.getToken()===2&&U)break}else ve&&M(6,[],[]);re()||M(4,[],[2,5]),ve=!0}return u(),c.getToken()!==2?M(7,[2],[]):z(),!0}function _(){b(),z();let ve=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ve||M(4,[],[]),j(","),z(),c.getToken()===4&&U)break}else ve&&M(6,[],[]);te()||M(4,[],[4,5]),ve=!0}return g(),c.getToken()!==4?M(8,[4],[]):z(),!0}function te(){switch(c.getToken()){case 3:return _();case 1:return V();case 10:return x(!0);default:return fe()}}return z(),c.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):te()?(c.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=w;function y(t,o){const r=P(t),c=[];let m,f=0,i;do switch(i=r.getPosition(),m=r.scan(),m){case 12:case 13:case 17:f!==i&&c.push(t.substring(f,i)),o!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,o)),f=r.getPosition();break}while(m!==17);return c.join("")}e.stripComments=y;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ie[65],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(Ie[6],Ce([1,0,63,64]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function P(f){R=f}if(e.setDisposableTracker=P,l){const f="__is_disposable_tracked__";P(new class{trackDisposable(i){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[f]||console.log(s)},3e3)}setParent(i,s){if(i&&i!==h.None)try{i[f]=!0}catch{}}markAsDisposed(i){if(i&&i!==h.None)try{i[f]=!0}catch{}}markAsSingleton(i){}})}function T(f){return R?.trackDisposable(f),f}function D(f){R?.markAsDisposed(f)}function v(f,i){R?.setParent(f,i)}function O(f,i){if(!!R)for(const s of f)R.setParent(s,i)}function k(f){return R?.markAsSingleton(f),f}e.markAsSingleton=k;function S(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=S;function C(f){if(A.Iterable.is(f)){const i=[];for(const s of f)if(s)try{s.dispose()}catch(u){i.push(u)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.dispose=C;function I(f){for(const i of f)S(i)&&i.dispose();return[]}e.disposeIfDisposable=I;function E(...f){const i=n(()=>C(f));return O(f,i),i}e.combinedDisposable=E;function n(f){const i=T({dispose:(0,a.once)(()=>{D(i),f()})});return i}e.toDisposable=n;class d{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(D(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return v(i,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class h{constructor(){this.q=new d,T(this),v(this.q,this)}dispose(){D(this),this.q.dispose()}B(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(i)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class w{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&v(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,D(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&v(i,null),i}}e.MutableDisposable=w;class y{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(i){let s=i;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,D(this))},this}}e.SafeDisposable=p;class t{constructor(){this.a=new Map}acquire(i,...s){let u=this.a.get(i);u||(u={counter:0,object:this.b(i,...s)},this.a.set(i,u));const{object:b}=u,g=(0,a.once)(()=>{--u.counter===0&&(this.c(i,u.object),this.a.delete(i))});return u.counter++,{object:b,dispose:g}}}e.ReferenceCollection=t;class o{constructor(i){this.a=i}async acquire(i,...s){const u=this.a.acquire(i,...s);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(b){throw u.dispose(),b}}}e.AsyncReferenceCollection=o;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function c(f){const i=new d;try{f(i)}finally{i.dispose()}}e.disposeOnReturn=c;class m{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){D(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,s,u=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this.a.get(i)?.dispose(),this.a.set(i,s)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=m}),define(Ie[66],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class A{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const P=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=P}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,P){const T=new a(R);if(this.a===a.Undefined)this.a=T,this.b=T;else if(P){const v=this.b;this.b=T,T.prev=v,v.next=T}else{const v=this.a;this.a=T,T.next=v,v.prev=T}this.c+=1;let D=!1;return()=>{D||(D=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(Ie[28],Ce([1,0]),function(se,e){"use strict";var a,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,n,d){let h=E.get(n);return h===void 0&&(h=d,E.set(n,h)),h}e.getOrSet=R;function P(E){const n=[];return E.forEach((d,h)=>{n.push(`${h} => ${d}`)}),`Map(${E.size}) {${n.join(", ")}}`}e.mapToString=P;function T(E){const n=[];return E.forEach(d=>{n.push(d)}),`Set(${E.size}) {${n.join(", ")}}`}e.setToString=T;class D{constructor(n,d){this.uri=n,this.value=d}}class v{constructor(n,d){this[a]="ResourceMap",n instanceof v?(this.b=new Map(n.b),this.c=d??v.a):(this.b=new Map,this.c=n??v.a)}set(n,d){return this.b.set(this.c(n),new D(n,d)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,d){typeof d<"u"&&(n=n.bind(d));for(const[h,w]of this.b)n(w.value,w.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}v.a=E=>E.toString(),e.ResourceMap=v;class O{constructor(n,d){this[A]="ResourceSet",!n||typeof n=="function"?this.a=new v(n):(this.a=new v(d),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,d){this.a.forEach((h,w)=>n.call(d,w,w,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class S{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,d=0){const h=this.a.get(n);if(!!h)return d!==0&&this.j(h,d),h.value}set(n,d,h=0){let w=this.a.get(n);if(w)w.value=d,h!==0&&this.j(w,h);else{switch(w={key:n,value:d,next:void 0,previous:void 0},h){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(n,w),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const d=this.a.get(n);if(!!d)return this.a.delete(n),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,d){const h=this.e;let w=this.b;for(;w;){if(d?n.bind(d)(w.value,w.key,this):n(w.value,w.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,d=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:h.key,done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return w}values(){const n=this,d=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:h.value,done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return w}entries(){const n=this,d=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:[h.key,h.value],done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return w}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>n;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const d=n.next,h=n.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}n.next=void 0,n.previous=void 0,this.e++}j(n,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(n===this.b)return;const h=n.next,w=n.previous;n===this.c?(w.next=void 0,this.c=w):(h.previous=w,w.next=h),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(d===2){if(n===this.c)return;const h=n.next,w=n.previous;n===this.b?(h.previous=void 0,this.b=h):(h.previous=w,w.next=h),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((d,h)=>{n.push([h,d])}),n}fromJSON(n){this.clear();for(const[d,h]of n)this.set(d,h)}}e.LinkedMap=S;class C extends S{constructor(n,d=1){super(),this.k=n,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,d=2){return super.get(n,d)}peek(n){return super.get(n,0)}set(n,d){return super.set(n,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C;class I{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let d=this.a.get(n)||0;return d===0?!1:(d--,d===0?this.a.delete(n):this.a.set(n,d),!0)}has(n){return this.a.has(n)}}e.CounterSet=I}),function(se,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[148],Ce([0]),e):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(ie,ne){for(var de=0;de<ne.length;de++){var ee=ne[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(ie,ee.key,ee)}}function a(ie,ne,de){return ne&&e(ie.prototype,ne),de&&e(ie,de),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function A(ie,ne){if(!!ie){if(typeof ie=="string")return l(ie,ne);var de=Object.prototype.toString.call(ie).slice(8,-1);if(de==="Object"&&ie.constructor&&(de=ie.constructor.name),de==="Map"||de==="Set")return Array.from(ie);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return l(ie,ne)}}function l(ie,ne){(ne==null||ne>ie.length)&&(ne=ie.length);for(var de=0,ee=new Array(ne);de<ne;de++)ee[de]=ie[de];return ee}function R(ie,ne){var de=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(de)return(de=de.call(ie)).next.bind(de);if(Array.isArray(ie)||(de=A(ie))||ne&&ie&&typeof ie.length=="number"){de&&(ie=de);var ee=0;return function(){return ee>=ie.length?{done:!0}:{done:!1,value:ie[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=P();function T(ie){se.defaults=ie}var D=/[&<>"']/,v=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ne){return S[ne]};function I(ie,ne){if(ne){if(D.test(ie))return ie.replace(v,C)}else if(O.test(ie))return ie.replace(k,C);return ie}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(ie){return ie.replace(E,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function h(ie,ne){ie=typeof ie=="string"?ie:ie.source,ne=ne||"";var de={replace:function(ce,ae){return ae=ae.source||ae,ae=ae.replace(d,"$1"),ie=ie.replace(ce,ae),de},getRegex:function(){return new RegExp(ie,ne)}};return de}var w=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ie,ne,de){if(ie){var ee;try{ee=decodeURIComponent(n(de)).replace(w,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ne&&!y.test(de)&&(de=m(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(ie,ne){t[" "+ie]||(o.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=u(ie,"/",!0)),ie=t[" "+ie];var de=ie.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:ie.replace(r,"$1")+ne:ne.charAt(0)==="/"?de?ne:ie.replace(c,"$1")+ne:ie+ne}var f={exec:function(){}};function i(ie){for(var ne=1,de,ee;ne<arguments.length;ne++){de=arguments[ne];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(ie[ee]=de[ee])}return ie}function s(ie,ne){var de=ie.replace(/\|/g,function(ae,N,$){for(var X=!1,Z=N;--Z>=0&&$[Z]==="\\";)X=!X;return X?"|":" |"}),ee=de.split(/ \|/),ce=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ne)ee.splice(ne);else for(;ee.length<ne;)ee.push("");for(;ce<ee.length;ce++)ee[ce]=ee[ce].trim().replace(/\\\|/g,"|");return ee}function u(ie,ne,de){var ee=ie.length;if(ee===0)return"";for(var ce=0;ce<ee;){var ae=ie.charAt(ee-ce-1);if(ae===ne&&!de)ce++;else if(ae!==ne&&de)ce++;else break}return ie.slice(0,ee-ce)}function b(ie,ne){if(ie.indexOf(ne[1])===-1)return-1;for(var de=ie.length,ee=0,ce=0;ce<de;ce++)if(ie[ce]==="\\")ce++;else if(ie[ce]===ne[0])ee++;else if(ie[ce]===ne[1]&&(ee--,ee<0))return ce;return-1}function g(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(ie,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=ie),ne>>=1,ie+=ie;return de+ie}function j(ie,ne,de,ee){var ce=ne.href,ae=ne.title?I(ne.title):null,N=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){ee.state.inLink=!0;var $={type:"link",raw:de,href:ce,title:ae,text:N,tokens:ee.inlineTokens(N)};return ee.state.inLink=!1,$}return{type:"image",raw:de,href:ce,title:ae,text:I(N)}}function G(ie,ne){var de=ie.match(/^(\s+)(?:```)/);if(de===null)return ne;var ee=de[1];return ne.split(`
`).map(function(ce){var ae=ce.match(/^\s+/);if(ae===null)return ce;var N=ae[0];return N.length>=ee.length?ce.slice(ee.length):ce}).join(`
`)}var Q=function(){function ie(de){this.options=de||se.defaults}var ne=ie.prototype;return ne.space=function(ee){var ce=this.rules.block.newline.exec(ee);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(ee){var ce=this.rules.block.code.exec(ee);if(ce){var ae=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:u(ae,`
`)}}},ne.fences=function(ee){var ce=this.rules.block.fences.exec(ee);if(ce){var ae=ce[0],N=G(ae,ce[3]||"");return{type:"code",raw:ae,lang:ce[2]?ce[2].trim():ce[2],text:N}}},ne.heading=function(ee){var ce=this.rules.block.heading.exec(ee);if(ce){var ae=ce[2].trim();if(/#$/.test(ae)){var N=u(ae,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ae=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ae,tokens:this.lexer.inline(ae)}}},ne.hr=function(ee){var ce=this.rules.block.hr.exec(ee);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(ee){var ce=this.rules.block.blockquote.exec(ee);if(ce){var ae=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ae,[]),text:ae}}},ne.list=function(ee){var ce=this.rules.block.list.exec(ee);if(ce){var ae,N,$,X,Z,he,Se,Re,we,Te,ke,je,We=ce[1].trim(),tt=We.length>1,Ye={type:"list",raw:"",ordered:tt,start:tt?+We.slice(0,-1):"",loose:!1,items:[]};We=tt?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=tt?We:"[*+-]");for(var nt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(ce=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ae=ce[0],ee=ee.substring(ae.length),Re=ce[2].split(`
`,1)[0],we=ee.split(`
`,1)[0],this.options.pedantic?(X=2,ke=Re.trimLeft()):(X=ce[2].search(/[^ ]/),X=X>4?1:X,ke=Re.slice(X),X+=ce[1].length),he=!1,!Re&&/^ *$/.test(we)&&(ae+=we+`
`,ee=ee.substring(we.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,X-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:```|~~~)"),W=new RegExp("^ {0,"+Math.min(3,X-1)+"}#");ee&&(Te=ee.split(`
`,1)[0],Re=Te,this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Re)||W.test(Re)||st.test(Re)||Be.test(ee)));){if(Re.search(/[^ ]/)>=X||!Re.trim())ke+=`
`+Re.slice(X);else if(!he)ke+=`
`+Re;else break;!he&&!Re.trim()&&(he=!0),ae+=Te+`
`,ee=ee.substring(Te.length+1)}Ye.loose||(Se?Ye.loose=!0:/\n *\n *$/.test(ae)&&(Se=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&($=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ae,task:!!N,checked:$,loose:!1,text:ke}),Ye.raw+=ae}Ye.items[Ye.items.length-1].raw=ae.trimRight(),Ye.items[Ye.items.length-1].text=ke.trimRight(),Ye.raw=Ye.raw.trimRight();var Y=Ye.items.length;for(Z=0;Z<Y;Z++){this.lexer.state.top=!1,Ye.items[Z].tokens=this.lexer.blockTokens(Ye.items[Z].text,[]);var me=Ye.items[Z].tokens.filter(function(Ne){return Ne.type==="space"}),Le=me.every(function(Ne){for(var xe=Ne.raw.split(""),Qe=0,Xe=R(xe),rt;!(rt=Xe()).done;){var ct=rt.value;if(ct===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ye.loose&&me.length&&Le&&(Ye.loose=!0,Ye.items[Z].loose=!0)}return Ye}},ne.html=function(ee){var ce=this.rules.block.html.exec(ee);if(ce){var ae={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):I(ce[0]);ae.type="paragraph",ae.text=N,ae.tokens=this.lexer.inline(N)}return ae}},ne.def=function(ee){var ce=this.rules.block.def.exec(ee);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ae=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ae,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(ee){var ce=this.rules.block.table.exec(ee);if(ce){var ae={type:"table",header:s(ce[1]).map(function(Se){return{text:Se}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=ce[0];var N=ae.align.length,$,X,Z,he;for($=0;$<N;$++)/^ *-+: *$/.test(ae.align[$])?ae.align[$]="right":/^ *:-+: *$/.test(ae.align[$])?ae.align[$]="center":/^ *:-+ *$/.test(ae.align[$])?ae.align[$]="left":ae.align[$]=null;for(N=ae.rows.length,$=0;$<N;$++)ae.rows[$]=s(ae.rows[$],ae.header.length).map(function(Se){return{text:Se}});for(N=ae.header.length,X=0;X<N;X++)ae.header[X].tokens=this.lexer.inline(ae.header[X].text);for(N=ae.rows.length,X=0;X<N;X++)for(he=ae.rows[X],Z=0;Z<he.length;Z++)he[Z].tokens=this.lexer.inline(he[Z].text);return ae}}},ne.lheading=function(ee){var ce=this.rules.block.lheading.exec(ee);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(ee){var ce=this.rules.block.paragraph.exec(ee);if(ce){var ae=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ae,tokens:this.lexer.inline(ae)}}},ne.text=function(ee){var ce=this.rules.block.text.exec(ee);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(ee){var ce=this.rules.inline.escape.exec(ee);if(ce)return{type:"escape",raw:ce[0],text:I(ce[1])}},ne.tag=function(ee){var ce=this.rules.inline.tag.exec(ee);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):I(ce[0]):ce[0]}},ne.link=function(ee){var ce=this.rules.inline.link.exec(ee);if(ce){var ae=ce[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var N=u(ae.slice(0,-1),"\\");if((ae.length-N.length)%2===0)return}else{var $=b(ce[2],"()");if($>-1){var X=ce[0].indexOf("!")===0?5:4,Z=X+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,Z).trim(),ce[3]=""}}var he=ce[2],Se="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Re&&(he=Re[1],Se=Re[3])}else Se=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ae)?he=he.slice(1):he=he.slice(1,-1)),j(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:Se&&Se.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(ee,ce){var ae;if((ae=this.rules.inline.reflink.exec(ee))||(ae=this.rules.inline.nolink.exec(ee))){var N=(ae[2]||ae[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var $=ae[0].charAt(0);return{type:"text",raw:$,text:$}}return j(ae,N,ae[0],this.lexer)}},ne.emStrong=function(ee,ce,ae){ae===void 0&&(ae="");var N=this.rules.inline.emStrong.lDelim.exec(ee);if(!!N&&!(N[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=N[1]||N[2]||"";if(!$||$&&(ae===""||this.rules.inline.punctuation.exec(ae))){var X=N[0].length-1,Z,he,Se=X,Re=0,we=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(we.lastIndex=0,ce=ce.slice(-1*ee.length+X);(N=we.exec(ce))!=null;)if(Z=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Z){if(he=Z.length,N[3]||N[4]){Se+=he;continue}else if((N[5]||N[6])&&X%3&&!((X+he)%3)){Re+=he;continue}if(Se-=he,!(Se>0)){if(he=Math.min(he,he+Se+Re),Math.min(X,he)%2){var Te=ee.slice(1,X+N.index+he);return{type:"em",raw:ee.slice(0,X+N.index+he+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}var ke=ee.slice(2,X+N.index+he-1);return{type:"strong",raw:ee.slice(0,X+N.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ne.codespan=function(ee){var ce=this.rules.inline.code.exec(ee);if(ce){var ae=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ae),$=/^ /.test(ae)&&/ $/.test(ae);return N&&$&&(ae=ae.substring(1,ae.length-1)),ae=I(ae,!0),{type:"codespan",raw:ce[0],text:ae}}},ne.br=function(ee){var ce=this.rules.inline.br.exec(ee);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(ee){var ce=this.rules.inline.del.exec(ee);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(ee,ce){var ae=this.rules.inline.autolink.exec(ee);if(ae){var N,$;return ae[2]==="@"?(N=I(this.options.mangle?ce(ae[1]):ae[1]),$="mailto:"+N):(N=I(ae[1]),$=N),{type:"link",raw:ae[0],text:N,href:$,tokens:[{type:"text",raw:N,text:N}]}}},ne.url=function(ee,ce){var ae;if(ae=this.rules.inline.url.exec(ee)){var N,$;if(ae[2]==="@")N=I(this.options.mangle?ce(ae[0]):ae[0]),$="mailto:"+N;else{var X;do X=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(X!==ae[0]);N=I(ae[0]),ae[1]==="www."?$="http://"+N:$=N}return{type:"link",raw:ae[0],text:N,href:$,tokens:[{type:"text",raw:N,text:N}]}}},ne.inlineText=function(ee,ce){var ae=this.rules.inline.text.exec(ee);if(ae){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):I(ae[0]):ae[0]:N=I(this.options.smartypants?ce(ae[0]):ae[0]),{type:"text",raw:ae[0],text:N}}},ie}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=h(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=h(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=h(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=h(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=h(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=h(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=i({},B),B.gfm=i({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=h(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=h(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=i({},B.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:h(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=h(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=h(B._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=h(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=h(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=h(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=h(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=h(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=h(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=h(U.reflink).replace("label",U._label).replace("ref",B._label).getRegex(),U.nolink=h(U.nolink).replace("ref",B._label).getRegex(),U.reflinkSearch=h(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=i({},U),U.pedantic=i({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=i({},U.normal,{escape:h(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=h(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=i({},U.gfm,{br:h(U.br).replace("{2,}","*").getRegex(),text:h(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(ie){var ne="",de,ee,ce=ie.length;for(de=0;de<ce;de++)ee=ie.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ne+="&#"+ee+";";return ne}var x=function(){function ie(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||se.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:B.normal,inline:U.normal};this.options.pedantic?(ee.block=B.pedantic,ee.inline=U.pedantic):this.options.gfm&&(ee.block=B.gfm,this.options.breaks?ee.inline=U.breaks:ee.inline=U.gfm),this.tokenizer.rules=ee}ie.lex=function(ee,ce){var ae=new ie(ce);return ae.lex(ee)},ie.lexInline=function(ee,ce){var ae=new ie(ce);return ae.inlineTokens(ee)};var ne=ie.prototype;return ne.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(Se,Re,we){return Re+"    ".repeat(we.length)});for(var N,$,X,Z;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Se){return(N=Se.call({lexer:ae},ee,ce))?(ee=ee.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(ee)){ee=ee.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(ee)){ee=ee.substring(N.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(N);continue}if(N=this.tokenizer.fences(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(ee)){ee=ee.substring(N.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+N.raw,$.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(X=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var Se=1/0,Re=ee.slice(1),we=void 0;ae.options.extensions.startBlock.forEach(function(Te){we=Te.call({lexer:this},Re),typeof we=="number"&&we>=0&&(Se=Math.min(Se,we))}),Se<1/0&&Se>=0&&(X=ee.substring(0,Se+1))}(),this.state.top&&(N=this.tokenizer.paragraph(X))){$=ce[ce.length-1],Z&&$.type==="paragraph"?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(N),Z=X.length!==ee.length,ee=ee.substring(N.raw.length);continue}if(N=this.tokenizer.text(ee)){ee=ee.substring(N.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+N.raw,$.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(N);continue}if(ee){var he="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},ne.inline=function(ee,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ee,tokens:ce}),ce},ne.inlineTokens=function(ee,ce){var ae=this;ce===void 0&&(ce=[]);var N,$,X,Z=ee,he,Se,Re;if(this.tokens.links){var we=Object.keys(this.tokens.links);if(we.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)we.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,he.index)+"["+L("a",he[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,he.index)+"["+L("a",he[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,he.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(Se||(Re=""),Se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ae},ee,ce))?(ee=ee.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(ee)){ee=ee.substring(N.raw.length),$=ce[ce.length-1],$&&N.type==="text"&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(N.raw.length),$=ce[ce.length-1],$&&N.type==="text"&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(ee,Z,Re)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(ee)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(ee,M)){ee=ee.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(ee,M))){ee=ee.substring(N.raw.length),ce.push(N);continue}if(X=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),We=void 0;ae.options.extensions.startInline.forEach(function(tt){We=tt.call({lexer:this},je),typeof We=="number"&&We>=0&&(ke=Math.min(ke,We))}),ke<1/0&&ke>=0&&(X=ee.substring(0,ke+1))}(),N=this.tokenizer.inlineText(X,z)){ee=ee.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Re=N.raw.slice(-1)),Se=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=N.raw,$.text+=N.text):ce.push(N);continue}if(ee){var Te="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return ce},a(ie,null,[{key:"rules",get:function(){return{block:B,inline:U}}}]),ie}(),fe=function(){function ie(de){this.options=de||se.defaults}var ne=ie.prototype;return ne.code=function(ee,ce,ae){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(ee,N);$!=null&&$!==ee&&(ae=!0,ee=$)}return ee=ee.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+I(N,!0)+'">'+(ae?ee:I(ee,!0))+`</code></pre>
`:"<pre><code>"+(ae?ee:I(ee,!0))+`</code></pre>
`},ne.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ne.html=function(ee){return ee},ne.heading=function(ee,ce,ae,N){if(this.options.headerIds){var $=this.options.headerPrefix+N.slug(ae);return"<h"+ce+' id="'+$+'">'+ee+"</h"+ce+`>
`}return"<h"+ce+">"+ee+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(ee,ce,ae){var N=ce?"ol":"ul",$=ce&&ae!==1?' start="'+ae+'"':"";return"<"+N+$+`>
`+ee+"</"+N+`>
`},ne.listitem=function(ee){return"<li>"+ee+`</li>
`},ne.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(ee){return"<p>"+ee+`</p>
`},ne.table=function(ee,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ce+`</table>
`},ne.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ne.tablecell=function(ee,ce){var ae=ce.header?"th":"td",N=ce.align?"<"+ae+' align="'+ce.align+'">':"<"+ae+">";return N+ee+("</"+ae+`>
`)},ne.strong=function(ee){return"<strong>"+ee+"</strong>"},ne.em=function(ee){return"<em>"+ee+"</em>"},ne.codespan=function(ee){return"<code>"+ee+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(ee){return"<del>"+ee+"</del>"},ne.link=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var N='<a href="'+I(ee)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ae+"</a>",N},ne.image=function(ee,ce,ae){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ae;var N='<img src="'+ee+'" alt="'+ae+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},ne.text=function(ee){return ee},ie}(),re=function(){function ie(){}var ne=ie.prototype;return ne.strong=function(ee){return ee},ne.em=function(ee){return ee},ne.codespan=function(ee){return ee},ne.del=function(ee){return ee},ne.html=function(ee){return ee},ne.text=function(ee){return ee},ne.link=function(ee,ce,ae){return""+ae},ne.image=function(ee,ce,ae){return""+ae},ne.br=function(){return""},ie}(),V=function(){function ie(){this.seen={}}var ne=ie.prototype;return ne.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(ee,ce){var ae=ee,N=0;if(this.seen.hasOwnProperty(ae)){N=this.seen[ee];do N++,ae=ee+"-"+N;while(this.seen.hasOwnProperty(ae))}return ce||(this.seen[ee]=N,this.seen[ae]=0),ae},ne.slug=function(ee,ce){ce===void 0&&(ce={});var ae=this.serialize(ee);return this.getNextSafeSlug(ae,ce.dryrun)},ie}(),_=function(){function ie(de){this.options=de||se.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new V}ie.parse=function(ee,ce){var ae=new ie(ce);return ae.parse(ee)},ie.parseInline=function(ee,ce){var ae=new ie(ce);return ae.parseInline(ee)};var ne=ie.prototype;return ne.parse=function(ee,ce){ce===void 0&&(ce=!0);var ae="",N,$,X,Z,he,Se,Re,we,Te,ke,je,We,tt,Ye,nt,st,Be,it,W,Y=ee.length;for(N=0;N<Y;N++){if(ke=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(W=this.options.extensions.renderers[ke.type].call({parser:this},ke),W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ae+=W||"";continue}switch(ke.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,n(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(we="",Re="",Z=ke.header.length,$=0;$<Z;$++)Re+=this.renderer.tablecell(this.parseInline(ke.header[$].tokens),{header:!0,align:ke.align[$]});for(we+=this.renderer.tablerow(Re),Te="",Z=ke.rows.length,$=0;$<Z;$++){for(Se=ke.rows[$],Re="",he=Se.length,X=0;X<he;X++)Re+=this.renderer.tablecell(this.parseInline(Se[X].tokens),{header:!1,align:ke.align[X]});Te+=this.renderer.tablerow(Re)}ae+=this.renderer.table(we,Te);continue}case"blockquote":{Te=this.parse(ke.tokens),ae+=this.renderer.blockquote(Te);continue}case"list":{for(je=ke.ordered,We=ke.start,tt=ke.loose,Z=ke.items.length,Te="",$=0;$<Z;$++)nt=ke.items[$],st=nt.checked,Be=nt.task,Ye="",nt.task&&(it=this.renderer.checkbox(st),tt?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=it+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=it+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:it}):Ye+=it),Ye+=this.parse(nt.tokens,tt),Te+=this.renderer.listitem(Ye,Be,st);ae+=this.renderer.list(Te,je,We);continue}case"html":{ae+=this.renderer.html(ke.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Te=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<Y&&ee[N+1].type==="text";)ke=ee[++N],Te+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ae+=ce?this.renderer.paragraph(Te):Te;continue}default:{var me='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(me);return}else throw new Error(me)}}}return ae},ne.parseInline=function(ee,ce){ce=ce||this.renderer;var ae="",N,$,X,Z=ee.length;for(N=0;N<Z;N++){if($=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(X=this.options.extensions.renderers[$.type].call({parser:this},$),X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){ae+=X||"";continue}switch($.type){case"escape":{ae+=ce.text($.text);break}case"html":{ae+=ce.html($.text);break}case"link":{ae+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{ae+=ce.image($.href,$.title,$.text);break}case"strong":{ae+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{ae+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{ae+=ce.codespan($.text);break}case"br":{ae+=ce.br();break}case"del":{ae+=ce.del(this.parseInline($.tokens,ce));break}case"text":{ae+=ce.text($.text);break}default:{var he='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ae},ie}();function te(ie,ne,de){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=i({},te.defaults,ne||{}),g(ne),de){var ee=ne.highlight,ce;try{ce=x.lex(ie,ne)}catch(Z){return de(Z)}var ae=function(he){var Se;if(!he)try{ne.walkTokens&&te.walkTokens(ce,ne.walkTokens),Se=_.parse(ce,ne)}catch(Re){he=Re}return ne.highlight=ee,he?de(he):de(null,Se)};if(!ee||ee.length<3||(delete ne.highlight,!ce.length))return ae();var N=0;te.walkTokens(ce,function(Z){Z.type==="code"&&(N++,setTimeout(function(){ee(Z.text,Z.lang,function(he,Se){if(he)return ae(he);Se!=null&&Se!==Z.text&&(Z.text=Se,Z.escaped=!0),N--,N===0&&ae()})},0))}),N===0&&ae();return}function $(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+I(Z.message+"",!0)+"</pre>";throw Z}try{var X=x.lex(ie,ne);if(ne.walkTokens){if(ne.async)return Promise.all(te.walkTokens(X,ne.walkTokens)).then(function(){return _.parse(X,ne)}).catch($);te.walkTokens(X,ne.walkTokens)}return _.parse(X,ne)}catch(Z){$(Z)}}te.options=te.setOptions=function(ie){return i(te.defaults,ie),T(te.defaults),te},te.getDefaults=P,te.defaults=se.defaults,te.use=function(){for(var ie=arguments.length,ne=new Array(ie),de=0;de<ie;de++)ne[de]=arguments[de];var ee=i.apply(void 0,[{}].concat(ne)),ce=te.defaults.extensions||{renderers:{},childTokens:{}},ae;ne.forEach(function(N){if(N.extensions&&(ae=!0,N.extensions.forEach(function(X){if(!X.name)throw new Error("extension name required");if(X.renderer){var Z=ce.renderers?ce.renderers[X.name]:null;Z?ce.renderers[X.name]=function(){for(var he=arguments.length,Se=new Array(he),Re=0;Re<he;Re++)Se[Re]=arguments[Re];var we=X.renderer.apply(this,Se);return we===!1&&(we=Z.apply(this,Se)),we}:ce.renderers[X.name]=X.renderer}if(X.tokenizer){if(!X.level||X.level!=="block"&&X.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[X.level]?ce[X.level].unshift(X.tokenizer):ce[X.level]=[X.tokenizer],X.start&&(X.level==="block"?ce.startBlock?ce.startBlock.push(X.start):ce.startBlock=[X.start]:X.level==="inline"&&(ce.startInline?ce.startInline.push(X.start):ce.startInline=[X.start]))}X.childTokens&&(ce.childTokens[X.name]=X.childTokens)})),N.renderer&&function(){var X=te.defaults.renderer||new fe,Z=function(Re){var we=X[Re];X[Re]=function(){for(var Te=arguments.length,ke=new Array(Te),je=0;je<Te;je++)ke[je]=arguments[je];var We=N.renderer[Re].apply(X,ke);return We===!1&&(We=we.apply(X,ke)),We}};for(var he in N.renderer)Z(he);ee.renderer=X}(),N.tokenizer&&function(){var X=te.defaults.tokenizer||new Q,Z=function(Re){var we=X[Re];X[Re]=function(){for(var Te=arguments.length,ke=new Array(Te),je=0;je<Te;je++)ke[je]=arguments[je];var We=N.tokenizer[Re].apply(X,ke);return We===!1&&(We=we.apply(X,ke)),We}};for(var he in N.tokenizer)Z(he);ee.tokenizer=X}(),N.walkTokens){var $=te.defaults.walkTokens;ee.walkTokens=function(X){var Z=[];return Z.push(N.walkTokens.call(this,X)),$&&(Z=Z.concat($.call(this,X))),Z}}ae&&(ee.extensions=ce),te.setOptions(ee)})},te.walkTokens=function(ie,ne){for(var de=[],ee=function(){var $=ae.value;switch(de=de.concat(ne.call(te,$)),$.type){case"table":{for(var X=R($.header),Z;!(Z=X()).done;){var he=Z.value;de=de.concat(te.walkTokens(he.tokens,ne))}for(var Se=R($.rows),Re;!(Re=Se()).done;)for(var we=Re.value,Te=R(we),ke;!(ke=Te()).done;){var je=ke.value;de=de.concat(te.walkTokens(je.tokens,ne))}break}case"list":{de=de.concat(te.walkTokens($.items,ne));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[$.type]?te.defaults.extensions.childTokens[$.type].forEach(function(We){de=de.concat(te.walkTokens($[We],ne))}):$.tokens&&(de=de.concat(te.walkTokens($.tokens,ne)))}},ce=R(ie),ae;!(ae=ce()).done;)ee();return de},te.parseInline=function(ie,ne){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ne=i({},te.defaults,ne||{}),g(ne);try{var de=x.lexInline(ie,ne);return ne.walkTokens&&te.walkTokens(de,ne.walkTokens),_.parseInline(de,ne)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+I(ee.message+"",!0)+"</pre>";throw ee}},te.Parser=_,te.parser=_.parse,te.Renderer=fe,te.TextRenderer=re,te.Lexer=x,te.lexer=x.lex,te.Tokenizer=Q,te.Slugger=V,te.parse=te;var ve=te.options,le=te.setOptions,ue=te.use,q=te.walkTokens,F=te.parseInline,J=te,ge=_.parse,Ee=x.lex;se.Lexer=x,se.Parser=_,se.Renderer=fe,se.Slugger=V,se.TextRenderer=re,se.Tokenizer=Q,se.getDefaults=P,se.lexer=Ee,se.marked=te,se.options=ve,se.parse=J,se.parseInline=F,se.parser=ge,se.setOptions=le,se.use=ue,se.walkTokens=q,Object.defineProperty(se,"__esModule",{value:!0})}),define(Ie[87],Ce([1,0,28]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new a.LRUCache(1e4);function l(v){return D(v,"NFC",A)}e.normalizeNFC=l;const R=new a.LRUCache(1e4);function P(v){return D(v,"NFD",R)}e.normalizeNFD=P;const T=/[^\u0000-\u0080]/;function D(v,O,k){if(!v)return v;const S=k.get(v);if(S)return S;let C;return T.test(v)?C=v.normalize(O):C=v,k.set(v,C),C}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(O){return P(O).replace(v,"")}}()}),define(Ie[103],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,D,v){return Math.min(Math.max(T,D),v)}e.clamp=a;function A(T,D){return(D+T%D)%D}e.rot=A;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class R{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class P{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const v=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=P}),function(){function se(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function P(D){R.push(D,Date.now())}function T(){const D=[];for(let v=0;v<R.length;v+=2)D.push({name:R[v],startTime:R[v+1]});return D}return{mark:P,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const P of performance.getEntriesByType("mark"))R.push({name:P.name,startTime:Math.round(l+P.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function a(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=a(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var A in a)(typeof exports=="object"?exports:se)[A]=a[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function a(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return se[A].call(l.exports,l,l.exports,a),l.l=!0,l.exports}return a.m=se,a.c=e,a.d=function(A,l,R){a.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:R})},a.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},a.t=function(A,l){if(1&l&&(A=a(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var P in A)a.d(R,P,function(T){return A[T]}.bind(null,P));return R},a.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return a.d(l,"a",l),l},a.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},a.p="",a(a.s=0)}([function(se,e,a){(function(A){var l;e=se.exports=ue,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var we=Array.prototype.slice.call(arguments,0);we.unshift("SEMVER"),console.log.apply(console,we)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],D=e.src=[],v=0,O=v++;D[O]="0|[1-9]\\d*";var k=v++;D[k]="[0-9]+";var S=v++;D[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=v++;D[C]="("+D[O]+")\\.("+D[O]+")\\.("+D[O]+")";var I=v++;D[I]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var E=v++;D[E]="(?:"+D[O]+"|"+D[S]+")";var n=v++;D[n]="(?:"+D[k]+"|"+D[S]+")";var d=v++;D[d]="(?:-("+D[E]+"(?:\\."+D[E]+")*))";var h=v++;D[h]="(?:-?("+D[n]+"(?:\\."+D[n]+")*))";var w=v++;D[w]="[0-9A-Za-z-]+";var y=v++;D[y]="(?:\\+("+D[w]+"(?:\\."+D[w]+")*))";var p=v++,t="v?"+D[C]+D[d]+"?"+D[y]+"?";D[p]="^"+t+"$";var o="[v=\\s]*"+D[I]+D[h]+"?"+D[y]+"?",r=v++;D[r]="^"+o+"$";var c=v++;D[c]="((?:<|>)?=?)";var m=v++;D[m]=D[k]+"|x|X|\\*";var f=v++;D[f]=D[O]+"|x|X|\\*";var i=v++;D[i]="[v=\\s]*("+D[f]+")(?:\\.("+D[f]+")(?:\\.("+D[f]+")(?:"+D[d]+")?"+D[y]+"?)?)?";var s=v++;D[s]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[h]+")?"+D[y]+"?)?)?";var u=v++;D[u]="^"+D[c]+"\\s*"+D[i]+"$";var b=v++;D[b]="^"+D[c]+"\\s*"+D[s]+"$";var g=v++;D[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=v++;D[L]="(?:~>?)";var j=v++;D[j]="(\\s*)"+D[L]+"\\s+",T[j]=new RegExp(D[j],"g");var G=v++;D[G]="^"+D[L]+D[i]+"$";var Q=v++;D[Q]="^"+D[L]+D[s]+"$";var B=v++;D[B]="(?:\\^)";var U=v++;D[U]="(\\s*)"+D[B]+"\\s+",T[U]=new RegExp(D[U],"g");var z=v++;D[z]="^"+D[B]+D[i]+"$";var M=v++;D[M]="^"+D[B]+D[s]+"$";var x=v++;D[x]="^"+D[c]+"\\s*("+o+")$|^$";var fe=v++;D[fe]="^"+D[c]+"\\s*("+t+")$|^$";var re=v++;D[re]="(\\s*)"+D[c]+"\\s*("+o+"|"+D[i]+")",T[re]=new RegExp(D[re],"g");var V=v++;D[V]="^\\s*("+D[i]+")\\s+-\\s+("+D[i]+")\\s*$";var _=v++;D[_]="^\\s*("+D[s]+")\\s+-\\s+("+D[s]+")\\s*$";var te=v++;D[te]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)l(ve,D[ve]),T[ve]||(T[ve]=new RegExp(D[ve]));function le(we,Te){if(we instanceof ue)return we;if(typeof we!="string"||we.length>R||!(Te?T[r]:T[p]).test(we))return null;try{return new ue(we,Te)}catch{return null}}function ue(we,Te){if(we instanceof ue){if(we.loose===Te)return we;we=we.version}else if(typeof we!="string")throw new TypeError("Invalid Version: "+we);if(we.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ue))return new ue(we,Te);l("SemVer",we,Te),this.loose=Te;var ke=we.trim().match(Te?T[r]:T[p]);if(!ke)throw new TypeError("Invalid Version: "+we);if(this.raw=we,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<P)return We}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=le,e.valid=function(we,Te){var ke=le(we,Te);return ke?ke.version:null},e.clean=function(we,Te){var ke=le(we.trim().replace(/^[=v]+/,""),Te);return ke?ke.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(we){return l("SemVer.compare",this.version,this.loose,we),we instanceof ue||(we=new ue(we,this.loose)),this.compareMain(we)||this.comparePre(we)},ue.prototype.compareMain=function(we){return we instanceof ue||(we=new ue(we,this.loose)),F(this.major,we.major)||F(this.minor,we.minor)||F(this.patch,we.patch)},ue.prototype.comparePre=function(we){if(we instanceof ue||(we=new ue(we,this.loose)),this.prerelease.length&&!we.prerelease.length)return-1;if(!this.prerelease.length&&we.prerelease.length)return 1;if(!this.prerelease.length&&!we.prerelease.length)return 0;var Te=0;do{var ke=this.prerelease[Te],je=we.prerelease[Te];if(l("prerelease compare",Te,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return F(ke,je)}while(++Te)},ue.prototype.inc=function(we,Te){switch(we){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Te);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Te);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Te),this.inc("pre",Te);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Te),this.inc("pre",Te);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Te&&(this.prerelease[0]===Te?isNaN(this.prerelease[1])&&(this.prerelease=[Te,0]):this.prerelease=[Te,0]);break;default:throw new Error("invalid increment argument: "+we)}return this.format(),this.raw=this.version,this},e.inc=function(we,Te,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new ue(we,ke).inc(Te,je).version}catch{return null}},e.diff=function(we,Te){if(ie(we,Te))return null;var ke=le(we),je=le(Te);if(ke.prerelease.length||je.prerelease.length){for(var We in ke)if((We==="major"||We==="minor"||We==="patch")&&ke[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ke)if((We==="major"||We==="minor"||We==="patch")&&ke[We]!==je[We])return We},e.compareIdentifiers=F;var q=/^[0-9]+$/;function F(we,Te){var ke=q.test(we),je=q.test(Te);return ke&&je&&(we=+we,Te=+Te),ke&&!je?-1:je&&!ke?1:we<Te?-1:we>Te?1:0}function J(we,Te,ke){return new ue(we,ke).compare(new ue(Te,ke))}function ge(we,Te,ke){return J(we,Te,ke)>0}function Ee(we,Te,ke){return J(we,Te,ke)<0}function ie(we,Te,ke){return J(we,Te,ke)===0}function ne(we,Te,ke){return J(we,Te,ke)!==0}function de(we,Te,ke){return J(we,Te,ke)>=0}function ee(we,Te,ke){return J(we,Te,ke)<=0}function ce(we,Te,ke,je){var We;switch(Te){case"===":typeof we=="object"&&(we=we.version),typeof ke=="object"&&(ke=ke.version),We=we===ke;break;case"!==":typeof we=="object"&&(we=we.version),typeof ke=="object"&&(ke=ke.version),We=we!==ke;break;case"":case"=":case"==":We=ie(we,ke,je);break;case"!=":We=ne(we,ke,je);break;case">":We=ge(we,ke,je);break;case">=":We=de(we,ke,je);break;case"<":We=Ee(we,ke,je);break;case"<=":We=ee(we,ke,je);break;default:throw new TypeError("Invalid operator: "+Te)}return We}function ae(we,Te){if(we instanceof ae){if(we.loose===Te)return we;we=we.value}if(!(this instanceof ae))return new ae(we,Te);l("comparator",we,Te),this.loose=Te,this.parse(we),this.semver===N?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(we,Te){return F(Te,we)},e.major=function(we,Te){return new ue(we,Te).major},e.minor=function(we,Te){return new ue(we,Te).minor},e.patch=function(we,Te){return new ue(we,Te).patch},e.compare=J,e.compareLoose=function(we,Te){return J(we,Te,!0)},e.rcompare=function(we,Te,ke){return J(Te,we,ke)},e.sort=function(we,Te){return we.sort(function(ke,je){return e.compare(ke,je,Te)})},e.rsort=function(we,Te){return we.sort(function(ke,je){return e.rcompare(ke,je,Te)})},e.gt=ge,e.lt=Ee,e.eq=ie,e.neq=ne,e.gte=de,e.lte=ee,e.cmp=ce,e.Comparator=ae;var N={};function $(we,Te){if(we instanceof $)return we.loose===Te?we:new $(we.raw,Te);if(we instanceof ae)return new $(we.value,Te);if(!(this instanceof $))return new $(we,Te);if(this.loose=Te,this.raw=we,this.set=we.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+we);this.format()}function X(we){return!we||we.toLowerCase()==="x"||we==="*"}function Z(we,Te,ke,je,We,tt,Ye,nt,st,Be,it,W,Y){return((Te=X(ke)?"":X(je)?">="+ke+".0.0":X(We)?">="+ke+"."+je+".0":">="+Te)+" "+(nt=X(st)?"":X(Be)?"<"+(+st+1)+".0.0":X(it)?"<"+st+"."+(+Be+1)+".0":W?"<="+st+"."+Be+"."+it+"-"+W:"<="+nt)).trim()}function he(we,Te){for(var ke=0;ke<we.length;ke++)if(!we[ke].test(Te))return!1;if(Te.prerelease.length){for(ke=0;ke<we.length;ke++)if(l(we[ke].semver),we[ke].semver!==N&&we[ke].semver.prerelease.length>0){var je=we[ke].semver;if(je.major===Te.major&&je.minor===Te.minor&&je.patch===Te.patch)return!0}return!1}return!0}function Se(we,Te,ke){try{Te=new $(Te,ke)}catch{return!1}return Te.test(we)}function Re(we,Te,ke,je){var We,tt,Ye,nt,st;switch(we=new ue(we,je),Te=new $(Te,je),ke){case">":We=ge,tt=ee,Ye=Ee,nt=">",st=">=";break;case"<":We=Ee,tt=de,Ye=ge,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(we,Te,je))return!1;for(var Be=0;Be<Te.set.length;++Be){var it=Te.set[Be],W=null,Y=null;if(it.forEach(function(me){me.semver===N&&(me=new ae(">=0.0.0")),W=W||me,Y=Y||me,We(me.semver,W.semver,je)?W=me:Ye(me.semver,Y.semver,je)&&(Y=me)}),W.operator===nt||W.operator===st||(!Y.operator||Y.operator===nt)&&tt(we,Y.semver)||Y.operator===st&&Ye(we,Y.semver))return!1}return!0}ae.prototype.parse=function(we){var Te=this.loose?T[x]:T[fe],ke=we.match(Te);if(!ke)throw new TypeError("Invalid comparator: "+we);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new ue(ke[2],this.loose):this.semver=N},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(we){return l("Comparator.test",we,this.loose),this.semver===N||(typeof we=="string"&&(we=new ue(we,this.loose)),ce(we,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(we,Te){if(!(we instanceof ae))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new $(we.value,Te),Se(this.value,ke,Te);if(we.operator==="")return ke=new $(this.value,Te),Se(we.semver,ke,Te);var je=!(this.operator!==">="&&this.operator!==">"||we.operator!==">="&&we.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||we.operator!=="<="&&we.operator!=="<"),tt=this.semver.version===we.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||we.operator!==">="&&we.operator!=="<="),nt=ce(this.semver,"<",we.semver,Te)&&(this.operator===">="||this.operator===">")&&(we.operator==="<="||we.operator==="<"),st=ce(this.semver,">",we.semver,Te)&&(this.operator==="<="||this.operator==="<")&&(we.operator===">="||we.operator===">");return je||We||tt&&Ye||nt||st},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(we){return we.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(we){var Te=this.loose;we=we.trim(),l("range",we,Te);var ke=Te?T[_]:T[V];we=we.replace(ke,Z),l("hyphen replace",we),we=we.replace(T[re],"$1$2$3"),l("comparator trim",we,T[re]),we=(we=(we=we.replace(T[j],"$1~")).replace(T[U],"$1^")).split(/\s+/).join(" ");var je=Te?T[x]:T[fe],We=we.split(" ").map(function(tt){return function(Ye,nt){return l("comp",Ye),Ye=function(st,Be){return st.trim().split(/\s+/).map(function(it){return function(W,Y){l("caret",W,Y);var me=Y?T[M]:T[z];return W.replace(me,function(Le,Ne,xe,Qe,Xe){var rt;return l("caret",W,Le,Ne,xe,Qe,Xe),X(Ne)?rt="":X(xe)?rt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":X(Qe)?rt=Ne==="0"?">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+".0 <"+(+Ne+1)+".0.0":Xe?(l("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),rt=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+Qe+Xe+" <"+Ne+"."+xe+"."+(+Qe+1):">="+Ne+"."+xe+"."+Qe+Xe+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+Qe+Xe+" <"+(+Ne+1)+".0.0"):(l("no pr"),rt=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+Qe+" <"+Ne+"."+xe+"."+(+Qe+1):">="+Ne+"."+xe+"."+Qe+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+Qe+" <"+(+Ne+1)+".0.0"),l("caret return",rt),rt})}(it,Be)}).join(" ")}(Ye,nt),l("caret",Ye),Ye=function(st,Be){return st.trim().split(/\s+/).map(function(it){return function(W,Y){var me=Y?T[Q]:T[G];return W.replace(me,function(Le,Ne,xe,Qe,Xe){var rt;return l("tilde",W,Le,Ne,xe,Qe,Xe),X(Ne)?rt="":X(xe)?rt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":X(Qe)?rt=">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":Xe?(l("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),rt=">="+Ne+"."+xe+"."+Qe+Xe+" <"+Ne+"."+(+xe+1)+".0"):rt=">="+Ne+"."+xe+"."+Qe+" <"+Ne+"."+(+xe+1)+".0",l("tilde return",rt),rt})}(it,Be)}).join(" ")}(Ye,nt),l("tildes",Ye),Ye=function(st,Be){return l("replaceXRanges",st,Be),st.split(/\s+/).map(function(it){return function(W,Y){W=W.trim();var me=Y?T[b]:T[u];return W.replace(me,function(Le,Ne,xe,Qe,Xe,rt){l("xRange",W,Le,Ne,xe,Qe,Xe,rt);var ct=X(xe),vt=ct||X(Qe),mt=vt||X(Xe);return Ne==="="&&mt&&(Ne=""),ct?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&mt?(vt&&(Qe=0),mt&&(Xe=0),Ne===">"?(Ne=">=",vt?(xe=+xe+1,Qe=0,Xe=0):mt&&(Qe=+Qe+1,Xe=0)):Ne==="<="&&(Ne="<",vt?xe=+xe+1:Qe=+Qe+1),Le=Ne+xe+"."+Qe+"."+Xe):vt?Le=">="+xe+".0.0 <"+(+xe+1)+".0.0":mt&&(Le=">="+xe+"."+Qe+".0 <"+xe+"."+(+Qe+1)+".0"),l("xRange return",Le),Le})}(it,Be)}).join(" ")}(Ye,nt),l("xrange",Ye),Ye=function(st,Be){return l("replaceStars",st,Be),st.trim().replace(T[te],"")}(Ye,nt),l("stars",Ye),Ye}(tt,Te)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(tt){return!!tt.match(je)})),We=We.map(function(tt){return new ae(tt,Te)})},$.prototype.intersects=function(we,Te){if(!(we instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return we.set.some(function(We){return We.every(function(tt){return je.intersects(tt,Te)})})})})},e.toComparators=function(we,Te){return new $(we,Te).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},$.prototype.test=function(we){if(!we)return!1;typeof we=="string"&&(we=new ue(we,this.loose));for(var Te=0;Te<this.set.length;Te++)if(he(this.set[Te],we))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(we,Te,ke){var je=null,We=null;try{var tt=new $(Te,ke)}catch{return null}return we.forEach(function(Ye){tt.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new ue(je=Ye,ke)))}),je},e.minSatisfying=function(we,Te,ke){var je=null,We=null;try{var tt=new $(Te,ke)}catch{return null}return we.forEach(function(Ye){tt.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new ue(je=Ye,ke)))}),je},e.validRange=function(we,Te){try{return new $(we,Te).range||"*"}catch{return null}},e.ltr=function(we,Te,ke){return Re(we,Te,"<",ke)},e.gtr=function(we,Te,ke){return Re(we,Te,">",ke)},e.outside=Re,e.prerelease=function(we,Te){var ke=le(we,Te);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(we,Te,ke){return we=new $(we,ke),Te=new $(Te,ke),we.intersects(Te)},e.coerce=function(we){if(we instanceof ue)return we;if(typeof we!="string")return null;var Te=we.match(T[g]);return Te==null?null:le((Te[1]||"0")+"."+(Te[2]||"0")+"."+(Te[3]||"0"))}}).call(this,a(1))},function(se,e){var a,A,l=se.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function T(n){if(a===setTimeout)return setTimeout(n,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(n,0);try{return a(n,0)}catch{try{return a.call(null,n,0)}catch{return a.call(this,n,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{A=typeof clearTimeout=="function"?clearTimeout:P}catch{A=P}})();var D,v=[],O=!1,k=-1;function S(){O&&D&&(O=!1,D.length?v=D.concat(v):k=-1,v.length&&C())}function C(){if(!O){var n=T(S);O=!0;for(var d=v.length;d;){for(D=v,v=[];++k<d;)D&&D[k].run();k=-1,d=v.length}D=null,O=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===P||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}(n)}}function I(n,d){this.fun=n,this.array=d}function E(){}l.nextTick=function(n){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];v.push(new I(n,d)),v.length!==1||O||T(C)},I.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(n){return[]},l.binding=function(n){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(n){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(Ie[104],Ce([1,0,8,6]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(y){const p=y;return p?typeof p.read=="function":!1}e.isReadable=l;function R(y){const p=y;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function P(y){const p=y;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=P;function T(y,p){return new D(y,p)}e.newWriteableStream=T;class D{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,a.onUnexpectedError)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let o;switch(p){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(y,p){const t=[];let o;for(;(o=y.read())!==null;)t.push(o);return p(t)}e.consumeReadable=v;function O(y,p,t){const o=[];let r;for(;(r=y.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return y.read()}}}e.peekReadable=O;function k(y,p){return new Promise((t,o)=>{const r=[];S(y,{onData:c=>{p&&r.push(c)},onError:c=>{p?o(c):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=k;function S(y,p){let t=!1;return y.on("error",o=>{t||p.onError(o)}),y.on("end",()=>{t||p.onEnd()}),y.on("data",o=>{t||p.onData(o)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=S;function C(y,p){return new Promise((t,o)=>{const r=new A.DisposableStore,c=[],m=s=>{if(c.push(s),c.length>p)return r.dispose(),y.pause(),t({stream:y,buffer:c,ended:!1})},f=s=>o(s),i=()=>t({stream:y,buffer:c,ended:!0});r.add((0,A.toDisposable)(()=>y.removeListener("error",f))),y.on("error",f),r.add((0,A.toDisposable)(()=>y.removeListener("end",i))),y.on("end",i),r.add((0,A.toDisposable)(()=>y.removeListener("data",m))),y.on("data",m)})}e.peekStream=C;function I(y,p){const t=T(p);return t.end(y),t}e.toStream=I;function E(){const y=T(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=E;function n(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}e.toReadable=n;function d(y,p,t){const o=T(t);return S(y,{onData:r=>o.write(p.data(r)),onError:r=>o.error(p.error?p.error(r):r),onEnd:()=>o.end()}),o}e.transform=d;function h(y,p,t){let o=!1;return{read:()=>{const r=p.read();return o?r:(o=!0,r!==null?t([y,r]):y)}}}e.prefixedReadable=h;function w(y,p,t){let o=!1;const r=T(t);return S(p,{onData:c=>o?r.write(c):(o=!0,r.write(t([y,c]))),onError:c=>r.error(c),onEnd:()=>{o||(o=!0,r.write(y)),r.end()}}),r}e.prefixedStream=w}),define(Ie[22],Ce([1,0,104]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let l,R;class P{static alloc(s){return A?new P(Buffer.allocUnsafe(s)):new P(new Uint8Array(s))}static wrap(s){return A&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new P(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(s)):(l||(l=new TextEncoder),new P(l.encode(s)))}static fromByteArray(s){const u=P.alloc(s.length);for(let b=0,g=s.length;b<g;b++)u.buffer[b]=s[b];return u}static concat(s,u){if(typeof u>"u"){u=0;for(let L=0,j=s.length;L<j;L++)u+=s[L].byteLength}const b=P.alloc(u);let g=0;for(let L=0,j=s.length;L<j;L++){const G=s[L];b.set(G,g),g+=G.byteLength}return b}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=P.alloc(this.byteLength);return s.set(this),s}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(s,u){return new P(this.buffer.subarray(s,u))}set(s,u){if(s instanceof P)this.buffer.set(s.buffer,u);else if(s instanceof Uint8Array)this.buffer.set(s,u);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),u);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return v(this.buffer,s)}writeUInt32BE(s,u){O(this.buffer,s,u)}readUInt32LE(s){return k(this.buffer,s)}writeUInt32LE(s,u){S(this.buffer,s,u)}readUInt8(s){return C(this.buffer,s)}writeUInt8(s,u){I(this.buffer,s,u)}}e.VSBuffer=P;function T(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0}e.readUInt16LE=T;function D(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255}e.writeUInt16LE=D;function v(i,s){return i[s]*2**24+i[s+1]*2**16+i[s+2]*2**8+i[s+3]}e.readUInt32BE=v;function O(i,s,u){i[u+3]=s,s=s>>>8,i[u+2]=s,s=s>>>8,i[u+1]=s,s=s>>>8,i[u]=s}e.writeUInt32BE=O;function k(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0|i[s+2]<<16>>>0|i[s+3]<<24>>>0}e.readUInt32LE=k;function S(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255,s=s>>>8,i[u+2]=s&255,s=s>>>8,i[u+3]=s&255}e.writeUInt32LE=S;function C(i,s){return i[s]}e.readUInt8=C;function I(i,s,u){i[u]=s}e.writeUInt8=I;function E(i){return a.consumeReadable(i,s=>P.concat(s))}e.readableToBuffer=E;function n(i){return a.toReadable(i)}e.bufferToReadable=n;function d(i){return a.consumeStream(i,s=>P.concat(s))}e.streamToBuffer=d;async function h(i){return i.ended?P.concat(i.buffer):P.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=h;function w(i){return a.toStream(i,s=>P.concat(s))}e.bufferToStream=w;function y(i){return a.transform(i,{data:s=>typeof s=="string"?P.fromString(s):P.wrap(s)},s=>P.concat(s))}e.streamToBufferReadableStream=y;function p(i){return a.newWriteableStream(s=>P.concat(s),i)}e.newWriteableBufferStream=p;function t(i,s){return a.prefixedReadable(i,s,u=>P.concat(u))}e.prefixedBufferReadable=t;function o(i,s){return a.prefixedStream(i,s,u=>P.concat(u))}e.prefixedBufferStream=o;function r(i){let s=0,u=0,b=0;const g=new Uint8Array(Math.floor(i.length/4*3)),L=G=>{switch(u){case 3:g[b++]=s|G,u=0;break;case 2:g[b++]=s|G>>>2,s=G<<6,u=3;break;case 1:g[b++]=s|G>>>4,s=G<<4,u=2;break;default:s=G<<2,u=1}};for(let G=0;G<i.length;G++){const Q=i.charCodeAt(G);if(Q>=65&&Q<=90)L(Q-65);else if(Q>=97&&Q<=122)L(Q-97+26);else if(Q>=48&&Q<=57)L(Q-48+52);else if(Q===43||Q===45)L(62);else if(Q===47||Q===95)L(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${i[G]}`)}}const j=b;for(;u>0;)L(0);return P.wrap(g).slice(0,j)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:i},s=!0,u=!1){const b=u?m:c;let g="";const L=i.byteLength%3;let j=0;for(;j<i.byteLength-L;j+=3){const G=i[j+0],Q=i[j+1],B=i[j+2];g+=b[G>>>2],g+=b[(G<<4|Q>>>4)&63],g+=b[(Q<<2|B>>>6)&63],g+=b[B&63]}if(L===1){const G=i[j+0];g+=b[G>>>2],g+=b[G<<4&63],s&&(g+="==")}else if(L===2){const G=i[j+0],Q=i[j+1];g+=b[G>>>2],g+=b[(G<<4|Q>>>4)&63],g+=b[Q<<2&63],s&&(g+="=")}return g}e.encodeBase64=f}),define(Ie[149],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ie[10],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function A(o){return Array.isArray(o)&&o.every(r=>a(r))}e.isStringArray=A;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function R(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}e.isTypedArray=R;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function D(o){return o===!0||o===!1}e.isBoolean=D;function v(o){return typeof o>"u"}e.isUndefined=v;function O(o){return!k(o)}e.isDefined=O;function k(o){return v(o)||o===null}e.isUndefinedOrNull=k;function S(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=S;function C(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=C;function I(...o){const r=[];for(let c=0;c<o.length;c++){const m=o[c];if(k(m))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);r.push(m)}return r}e.assertAllDefined=I;const E=Object.prototype.hasOwnProperty;function n(o){if(!l(o))return!1;for(const r in o)if(E.call(o,r))return!1;return!0}e.isEmptyObject=n;function d(o){return typeof o=="function"}e.isFunction=d;function h(...o){return o.length>0&&o.every(d)}e.areFunctions=h;function w(o,r){const c=Math.min(o.length,r.length);for(let m=0;m<c;m++)y(o[m],r[m])}e.validateConstraints=w;function y(o,r){if(a(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(o instanceof r)return}catch{}if(!k(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(Ie[67],Ce([1,0,10]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(T,D){if((0,a.isString)(D)){const v=A[D];if(v===void 0)throw new Error(`${T} references an unknown codicon: ${D}`);D=v}return A[T]=D,{id:T}}function R(){return A}e.getCodiconFontCharacters=R;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(Ie[23],Ce([1,0,10]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([w,y])=>{h[w]=y&&typeof y=="object"?A(y):y}),h}e.deepClone=A;function l(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const w=h.shift();Object.freeze(w);for(const y in w)if(R.call(w,y)){const p=w[y];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&h.push(p)}}return d}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function P(d,h){return T(d,h,new Set)}e.cloneAndChange=P;function T(d,h,w){if((0,a.isUndefinedOrNull)(d))return d;const y=h(d);if(typeof y<"u")return y;if(Array.isArray(d)){const p=[];for(const t of d)p.push(T(t,h,w));return p}if((0,a.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const p={};for(const t in d)R.call(d,t)&&(p[t]=T(d[t],h,w));return w.delete(d),p}return d}function D(d,h,w=!0){return(0,a.isObject)(d)?((0,a.isObject)(h)&&Object.keys(h).forEach(y=>{y in d?w&&((0,a.isObject)(d[y])&&(0,a.isObject)(h[y])?D(d[y],h[y],w):d[y]=h[y]):d[y]=h[y]}),d):h}e.mixin=D;function v(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let w,y;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(w=0;w<d.length;w++)if(!v(d[w],h[w]))return!1}else{const p=[];for(y in d)p.push(y);p.sort();const t=[];for(y in h)t.push(y);if(t.sort(),!v(p,t))return!1;for(w=0;w<p.length;w++)if(!v(d[p[w]],h[p[w]]))return!1}return!0}e.equals=v;function O(d){const h=new Set;return JSON.stringify(d,(w,y)=>{if((0,a.isObject)(y)||Array.isArray(y)){if(h.has(y))return"[Circular]";h.add(y)}return y})}e.safeStringify=O;function k(d,h){const w=Object.create(null);return!d||!h||Object.keys(h).forEach(p=>{const t=d[p],o=h[p];v(t,o)||(w[p]=o)}),w}e.distinct=k;function S(d,h){const w=h.toLowerCase(),y=Object.keys(d).find(p=>p.toLowerCase()===w);return y?d[y]:d[h]}e.getCaseInsensitive=S;function C(d,h){const w=Object.create(null);for(const[y,p]of Object.entries(d))h(y,p)&&(w[y]=p);return w}e.filter=C;function I(d){let h=[],w=Object.getPrototypeOf(d);for(;Object.prototype!==w;)h=h.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return h}e.getAllPropertyNames=I;function E(d){const h=[];for(const w of I(d))typeof d[w]=="function"&&h.push(w);return h}e.getAllMethodNames=E;function n(d,h){const w=p=>function(){const t=Array.prototype.slice.call(arguments,0);return h(p,t)},y={};for(const p of d)y[p]=w(p);return y}e.createProxyObject=n}),define(Ie[52],Ce([1,0,67]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(P){function T(D){return D&&typeof D=="object"&&typeof D.id=="string"}P.isThemeColor=T})(A=e.ThemeColor||(e.ThemeColor={}));function l(P){return{id:P}}e.themeColorFromId=l;var R;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function D(h){const w=T.exec(h.id);if(!w)return D(a.Codicon.error);const[,y,p]=w,t=["codicon","codicon-"+y];return p&&t.push("codicon-modifier-"+p.substring(1)),t}P.asClassNameArray=D;function v(h){return D(h).join(" ")}P.asClassName=v;function O(h){return"."+D(h).join(".")}P.asCSSSelector=O;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||A.isThemeColor(h.color))}P.isThemeIcon=k;const S=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function C(h){const w=S.exec(h);if(!w)return;const[,y]=w;return{id:y}}P.fromString=C;function I(h){return{id:h}}P.fromId=I;function E(h,w){let y=h.id;const p=y.lastIndexOf("~");return p!==-1&&(y=y.substring(0,p)),w&&(y=`${y}~${w}`),{id:y}}P.modify=E;function n(h){const w=h.id.lastIndexOf("~");if(w!==-1)return h.id.substring(w+1)}P.getModifier=n;function d(h,w){return h.id===w.id&&h.color?.id===w.color?.id}P.isEqual=d})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ie[105],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(Ie[30],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return a.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(T){for(let D=0;D<T.length;D++)T[D]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),P=[];for(let T=0;T<256;T++)P.push(T.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let D=0,v="";return v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v+="-",v+=P[R[D++]],v+=P[R[D++]],v+="-",v+=P[R[D++]],v+=P[R[D++]],v+="-",v+=P[R[D++]],v+=P[R[D++]],v+="-",v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v+=P[R[D++]],v}}()}),define(Ie[150],Ce([1,0,17,30]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(T){return{id:(0,A.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=l;function R(T,D,v){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:D,data:v}),value:void 0}}e.createFileDataTransferItem=R;class P{constructor(){this.a=new Map}get size(){return this.a.size}has(D){return this.a.has(this.b(D))}get(D){return this.a.get(this.b(D))?.[0]}append(D,v){const O=this.a.get(D);O?O.push(v):this.a.set(this.b(D),[v])}replace(D,v){this.a.set(this.b(D),[v])}delete(D){this.a.delete(this.b(D))}*entries(){for(const[D,v]of this.a.entries())for(const O of v)yield[D,O]}values(){return Array.from(this.a.values()).flat()}forEach(D){for(const[v,O]of this.entries())D(O,v)}b(D){return D.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(D=>D.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(D=>!D.startsWith("#"))})}),define(Ie[106],Ce([1,0,105]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(T){const D=(0,a.toUint8)(T);this.c=D,this.a=A.d(D),this.b=new Map}static d(T){const D=new Uint8Array(256);return D.fill(T),D}set(T,D){const v=(0,a.toUint8)(D);T>=0&&T<256?this.a[T]=v:this.b.set(T,v)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var l;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new A(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(Ie[53],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new a(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return a.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return a.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return a.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const P=l.lineNumber|0,T=R.lineNumber|0;if(P===T){const D=l.column|0,v=R.column|0;return D-v}return P-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new a(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=a}),define(Ie[32],Ce([1,0,53]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,P,T,D){R>T||R===T&&P>D?(this.startLineNumber=T,this.startColumn=D,this.endLineNumber=R,this.endColumn=P):(this.startLineNumber=R,this.startColumn=P,this.endLineNumber=T,this.endColumn=D)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<R.startColumn||P.lineNumber===R.endLineNumber&&P.column>R.endColumn)}static strictContainsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<=R.startColumn||P.lineNumber===R.endLineNumber&&P.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<=R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,P){let T,D,v,O;return P.startLineNumber<R.startLineNumber?(T=P.startLineNumber,D=P.startColumn):P.startLineNumber===R.startLineNumber?(T=P.startLineNumber,D=Math.min(P.startColumn,R.startColumn)):(T=R.startLineNumber,D=R.startColumn),P.endLineNumber>R.endLineNumber?(v=P.endLineNumber,O=P.endColumn):P.endLineNumber===R.endLineNumber?(v=P.endLineNumber,O=Math.max(P.endColumn,R.endColumn)):(v=R.endLineNumber,O=R.endColumn),new A(T,D,v,O)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,P){let T=R.startLineNumber,D=R.startColumn,v=R.endLineNumber,O=R.endColumn;const k=P.startLineNumber,S=P.startColumn,C=P.endLineNumber,I=P.endColumn;return T<k?(T=k,D=S):T===k&&(D=Math.max(D,S)),v>C?(v=C,O=I):v===C&&(O=Math.min(O,I)),T>v||T===v&&D>O?null:new A(T,D,v,O)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,P){return!R&&!P?!0:!!R&&!!P&&R.startLineNumber===P.startLineNumber&&R.startColumn===P.startColumn&&R.endLineNumber===P.endLineNumber&&R.endColumn===P.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,P){return new A(this.startLineNumber,this.startColumn,R,P)}setStartPosition(R,P){return new A(R,P,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,P=R){return new A(R.lineNumber,R.column,P.lineNumber,P.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn)}static areIntersecting(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,P){if(R&&P){const v=R.startLineNumber|0,O=P.startLineNumber|0;if(v===O){const k=R.startColumn|0,S=P.startColumn|0;if(k===S){const C=R.endLineNumber|0,I=P.endLineNumber|0;if(C===I){const E=R.endColumn|0,n=P.endColumn|0;return E-n}return C-I}return k-S}return v-O}return(R?1:0)-(P?1:0)}static compareRangesUsingEnds(R,P){return R.endLineNumber===P.endLineNumber?R.endColumn===P.endColumn?R.startLineNumber===P.startLineNumber?R.startColumn-P.startColumn:R.startLineNumber-P.startLineNumber:R.endColumn-P.endColumn:R.endLineNumber-P.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(Ie[151],Ce([1,0,53,32]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(T,D,v,O){super(T,D,v,O),this.selectionStartLineNumber=T,this.selectionStartColumn=D,this.positionLineNumber=v,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,D){return T.selectionStartLineNumber===D.selectionStartLineNumber&&T.selectionStartColumn===D.selectionStartColumn&&T.positionLineNumber===D.positionLineNumber&&T.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,D){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,T,D):new R(T,D,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,D){return this.getDirection()===0?new R(T,D,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,D)}static fromPositions(T,D=T){return new R(T.lineNumber,T.column,D.lineNumber,D.column)}static fromRange(T,D){return D===0?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,D){if(T&&!D||!T&&D)return!1;if(!T&&!D)return!0;if(T.length!==D.length)return!1;for(let v=0,O=T.length;v<O;v++)if(!this.selectionsEqual(T[v],D[v]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,D,v,O,k){return k===0?new R(T,D,v,O):new R(v,O,T,D)}}e.Selection=R}),define(Ie[152],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[153],Ce([1,0,106]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends a.CharacterClassifier{constructor(T){super(0);for(let D=0,v=T.length;D<v;D++)this.set(T.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(P){const T={};return D=>(T.hasOwnProperty(D)||(T[D]=P(D)),T[D])}e.getMapForWordSeparators=R(P=>new l(P))}),define(Ie[107],Ce([1,0,64,6,66]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)k.indexOf(C)>=0||(S+="\\"+C);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=R();function P(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let C="g";k.ignoreCase&&(C+="i"),k.multiline&&(C+="m"),k.unicode&&(C+="u"),S=new RegExp(k.source,C)}return S.lastIndex=0,S}e.ensureValidWordDefinition=P;const T=new l.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function D(k){const S=T.unshift(k);return(0,A.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=D;function v(k,S,C,I,E){if(E||(E=a.Iterable.first(T)),C.length>E.maxLen){let y=k-E.maxLen/2;return y<0?y=0:I+=y,C=C.substring(y,k+E.maxLen/2),v(k,S,C,I,E)}const n=Date.now(),d=k-1-I;let h=-1,w=null;for(let y=1;!(Date.now()-n>=E.timeBudget);y++){const p=d-E.windowSize*y;S.lastIndex=Math.max(0,p);const t=O(S,C,d,h);if(!t&&w||(w=t,p<=0))break;h=p}if(w){const y={word:w[0],startColumn:I+1+w.index,endColumn:I+1+w.index+w[0].length};return S.lastIndex=0,y}return null}e.getWordAtText=v;function O(k,S,C,I){let E;for(;E=k.exec(S);){const n=E.index||0;if(n<=C&&k.lastIndex>=C)return E;if(I>0&&n>I)return null}return null}}),define(Ie[154],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class A{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let D=0,v=T.notIn.length;D<v;D++)switch(T.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,D){if(T.getTokenCount()===0)return!0;const v=T.findTokenIndexAtOffset(D-2),O=T.getStandardTokenType(v);return this.isOK(O)}g(T,D){for(let v=T;v<=D;v++){const O=String.fromCharCode(v);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class l{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of T)R(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),R(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),R(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),R(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&R(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=l;function R(P,T,D){P.has(T)?P.get(T).push(D):P.set(T,[D])}}),define(Ie[155],Ce([1,0,106]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class l{constructor(I,E,n){const d=new Uint8Array(I*E);for(let h=0,w=I*E;h<w;h++)d[h]=n;this.a=d,this.rows=I,this.cols=E}get(I,E){return this.a[I*this.cols+E]}set(I,E,n){this.a[I*this.cols+E]=n}}class R{constructor(I){let E=0,n=0;for(let h=0,w=I.length;h<w;h++){const[y,p,t]=I[h];p>E&&(E=p),y>n&&(n=y),t>n&&(n=t)}E++,n++;const d=new l(n,E,0);for(let h=0,w=I.length;h<w;h++){const[y,p,t]=I[h];d.set(y,p,t)}this.a=d,this.b=E}nextState(I,E){return E<0||E>=this.b?0:this.a.get(I,E)}}e.StateMachine=R;let P=null;function T(){return P===null&&(P=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var D;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let v=null;function O(){if(v===null){v=new a.CharacterClassifier(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<C.length;E++)v.set(C.charCodeAt(E),1);const I=".,;:";for(let E=0;E<I.length;E++)v.set(I.charCodeAt(E),2)}return v}class k{static a(I,E,n,d,h){let w=h-1;do{const y=E.charCodeAt(w);if(I.get(y)!==2)break;w--}while(w>d);if(d>0){const y=E.charCodeAt(d-1),p=E.charCodeAt(w);(y===40&&p===41||y===91&&p===93||y===123&&p===125)&&w--}return{range:{startLineNumber:n,startColumn:d+1,endLineNumber:n,endColumn:w+2},url:E.substring(d,w+1)}}static computeLinks(I,E=T()){const n=O(),d=[];for(let h=1,w=I.getLineCount();h<=w;h++){const y=I.getLineContent(h),p=y.length;let t=0,o=0,r=0,c=1,m=!1,f=!1,i=!1,s=!1;for(;t<p;){let u=!1;const b=y.charCodeAt(t);if(c===13){let g;switch(b){case 40:m=!0,g=0;break;case 41:g=m?0:1;break;case 91:i=!0,f=!0,g=0;break;case 93:i=!1,g=f?0:1;break;case 123:s=!0,g=0;break;case 125:g=s?0:1;break;case 39:case 34:case 96:r===b?g=1:r===39||r===34||r===96?g=0:g=1;break;case 42:g=r===42?1:0;break;case 124:g=r===124?1:0;break;case 32:g=i?0:1;break;default:g=n.get(b)}g===1&&(d.push(k.a(n,y,h,o,t)),u=!0)}else if(c===12){let g;b===91?(f=!0,g=0):g=n.get(b),g===1?u=!0:c=13}else c=E.nextState(c,b),c===0&&(u=!0);u&&(c=1,m=!1,f=!1,s=!1,o=t+1,r=b),t++}c===13&&d.push(k.a(n,y,h,o,p))}return d}}e.LinkComputer=k;function S(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:k.computeLinks(C)}e.computeLinks=S}),define(Ie[108],Ce([1,0,23]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var P;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class v{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),y.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,y.indentSize|0),this.a=!1),this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.a===y.a&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=v;class O{constructor(y,p){this._findMatchBrand=void 0,this.range=y,this.matches=p}}e.FindMatch=O;var k;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(w){return w&&typeof w.read=="function"}e.isITextSnapshot=S;var C;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class E{constructor(y,p,t,o,r,c){this.identifier=y,this.range=p,this.text=t,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=r,this._isTracked=c}}e.ValidAnnotatedEditOperation=E;class n{constructor(y,p,t){this.regex=y,this.wordSeparators=p,this.simpleSearch=t}}e.SearchData=n;class d{constructor(y,p,t){this.reverseEdits=y,this.changes=p,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function h(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=h}),define(Ie[156],Ce([1,0,17,105]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(D){this.a=D,this.b=new Uint32Array(D.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(D,v){D=(0,A.toUint32)(D);const O=this.a,k=this.b,S=v.length;return S===0?!1:(this.a=new Uint32Array(O.length+S),this.a.set(O.subarray(0,D),0),this.a.set(O.subarray(D),D+S),this.a.set(v,D),D-1<this.c[0]&&(this.c[0]=D-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(D,v){return D=(0,A.toUint32)(D),v=(0,A.toUint32)(v),this.a[D]===v?!1:(this.a[D]=v,D-1<this.c[0]&&(this.c[0]=D-1),!0)}removeValues(D,v){D=(0,A.toUint32)(D),v=(0,A.toUint32)(v);const O=this.a,k=this.b;if(D>=O.length)return!1;const S=O.length-D;return v>=S&&(v=S),v===0?!1:(this.a=new Uint32Array(O.length-v),this.a.set(O.subarray(0,D),0),this.a.set(O.subarray(D+v),D),this.b=new Uint32Array(this.a.length),D-1<this.c[0]&&(this.c[0]=D-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(D){return D<0?0:(D=(0,A.toUint32)(D),this.d(D))}d(D){if(D<=this.c[0])return this.b[D];let v=this.c[0]+1;v===0&&(this.b[0]=this.a[0],v++),D>=this.a.length&&(D=this.a.length-1);for(let O=v;O<=D;O++)this.b[O]=this.b[O-1]+this.a[O];return this.c[0]=Math.max(this.c[0],D),this.b[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let v=0,O=this.a.length-1,k=0,S=0,C=0;for(;v<=O;)if(k=v+(O-v)/2|0,S=this.b[k],C=S-this.a[k],D<C)O=k-1;else if(D>=S)v=k+1;else break;return new P(k,D-C)}}e.PrefixSumComputer=l;class R{constructor(D){this.a=D,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(D){return this.g(),D===0?0:this.d[D-1]}getIndexOf(D){this.g();const v=this.e[D],O=v>0?this.d[v-1]:0;return new P(v,D-O)}removeValues(D,v){this.a.splice(D,v),this.f(D)}insertValues(D,v){this.a=(0,a.arrayInsert)(this.a,D,v),this.f(D)}f(D){this.b=!1,this.c=Math.min(this.c,D-1)}g(){if(!this.b){for(let D=this.c+1,v=this.a.length;D<v;D++){const O=this.a[D],k=D>0?this.d[D-1]:0;this.d[D]=k+O;for(let S=0;S<O;S++)this.e[k+S]=D}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(D,v){this.a[D]!==v&&(this.a[D]=v,this.f(D))}}e.ConstantTimePrefixSumComputer=R;class P{constructor(D,v){this.index=D,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=v}}e.PrefixSumIndexOfResult=P}),define(Ie[157],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDnDService=void 0;class a{constructor(){this.a=new Map}removeDragOperationTransfer(l){if(l&&this.a.has(l)){const R=this.a.get(l);return this.a.delete(l),R}}addDragOperationTransfer(l,R){this.a.set(l,R)}}e.TreeViewsDnDService=a}),define(Ie[158],Ce([12,13]),function(se,e){return se.create("vs/base/common/actions",e)}),define(Ie[159],Ce([12,13]),function(se,e){return se.create("vs/base/common/date",e)}),define(Ie[160],Ce([1,0,159]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,R=l*24,P=R*7,T=R*30,D=R*365;function v(k,S,C,I){typeof k!="number"&&(k=k.getTime());const E=Math.round((new Date().getTime()-k)/1e3);if(E<-30)return(0,a.localize)(0,null,v(new Date().getTime()+E*1e3,!1));if(!I&&E<30)return(0,a.localize)(1,null);let n;return E<A?(n=E,S?n===1?C?(0,a.localize)(2,null,n):(0,a.localize)(3,null,n):C?(0,a.localize)(4,null,n):(0,a.localize)(5,null,n):n===1?C?(0,a.localize)(6,null,n):(0,a.localize)(7,null,n):C?(0,a.localize)(8,null,n):(0,a.localize)(9,null,n)):E<l?(n=Math.floor(E/A),S?n===1?C?(0,a.localize)(10,null,n):(0,a.localize)(11,null,n):C?(0,a.localize)(12,null,n):(0,a.localize)(13,null,n):n===1?C?(0,a.localize)(14,null,n):(0,a.localize)(15,null,n):C?(0,a.localize)(16,null,n):(0,a.localize)(17,null,n)):E<R?(n=Math.floor(E/l),S?n===1?C?(0,a.localize)(18,null,n):(0,a.localize)(19,null,n):C?(0,a.localize)(20,null,n):(0,a.localize)(21,null,n):n===1?C?(0,a.localize)(22,null,n):(0,a.localize)(23,null,n):C?(0,a.localize)(24,null,n):(0,a.localize)(25,null,n)):E<P?(n=Math.floor(E/R),S?n===1?(0,a.localize)(26,null,n):(0,a.localize)(27,null,n):n===1?(0,a.localize)(28,null,n):(0,a.localize)(29,null,n)):E<T?(n=Math.floor(E/P),S?n===1?C?(0,a.localize)(30,null,n):(0,a.localize)(31,null,n):C?(0,a.localize)(32,null,n):(0,a.localize)(33,null,n):n===1?C?(0,a.localize)(34,null,n):(0,a.localize)(35,null,n):C?(0,a.localize)(36,null,n):(0,a.localize)(37,null,n)):E<D?(n=Math.floor(E/T),S?n===1?C?(0,a.localize)(38,null,n):(0,a.localize)(39,null,n):C?(0,a.localize)(40,null,n):(0,a.localize)(41,null,n):n===1?C?(0,a.localize)(42,null,n):(0,a.localize)(43,null,n):C?(0,a.localize)(44,null,n):(0,a.localize)(45,null,n)):(n=Math.floor(E/D),S?n===1?C?(0,a.localize)(46,null,n):(0,a.localize)(47,null,n):C?(0,a.localize)(48,null,n):(0,a.localize)(49,null,n):n===1?C?(0,a.localize)(50,null,n):(0,a.localize)(51,null,n):C?(0,a.localize)(52,null,n):(0,a.localize)(53,null,n))}e.fromNow=v;function O(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[161],Ce([12,13]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(Ie[46],Ce([1,0,17,10,161]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,S){return S&&(k.stack||k.stacktrace)?l.localize(0,null,T(k),P(k.stack)||P(k.stacktrace)):T(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?l.localize(1,null,k.message):k.message||l.localize(2,null)}function D(k=null,S=!1){if(!k)return l.localize(3,null);if(Array.isArray(k)){const C=a.coalesce(k),I=D(C[0],S);return C.length>1?l.localize(4,null,I,C.length):I}if(A.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return R(C.error,S);if(C.exception)return R(C.exception,S)}return k.stack?R(k,S):k.message?k.message:l.localize(5,null)}e.toErrorMessage=D;function v(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=v;function O(k,S){let C;return typeof k=="string"?C=new Error(k):C=k,C.actions=S,C}e.createErrorWithActions=O}),define(Ie[162],Ce([12,13]),function(se,e){return se.create("vs/base/common/platform",e)}),define(Ie[14],Ce([1,0,162]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,l=!1,R=!1,P=!1,T=!1,D=!1,v=!1,O=!1,k=!1,S=!1,C,I=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,n,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const w=typeof h?.versions?.electron=="string",y=w&&h?.type==="renderer";if(typeof navigator=="object"&&!y)d=navigator.userAgent,A=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,O=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,S=d?.indexOf("Mobi")>=0,D=!0,C=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,I=C,E=navigator.language;else if(typeof h=="object"){A=h.platform==="win32",l=h.platform==="darwin",R=h.platform==="linux",P=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,v=w,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,I=e.LANGUAGE_DEFAULT;const s=h.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),b=u.availableLanguages["*"];C=u.locale,E=u.osLocale,I=b||e.LANGUAGE_DEFAULT,n=u._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var p;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function t(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let o=0;l?o=1:A?o=3:R&&(o=2),e.isWindows=A,e.isMacintosh=l,e.isLinux=R,e.isLinuxSnap=P,e.isNative=T,e.isElectron=v,e.isWeb=D,e.isWebWorker=D&&typeof e.globals.importScripts=="function",e.isIOS=O,e.isMobile=S,e.isCI=k,e.platform=o,e.userAgent=d,e.language=I;var r;(function(s){function u(){return e.language}s.value=u;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=b;function g(){return e.language==="en"}s.isDefault=g})(r=e.Language||(e.Language={})),e.locale=C,e.platformLocale=E,e.translationsConfigFile=n,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let g=0,L=s.length;g<L;g++){const j=s[g];if(j.id===b.data.vscodeScheduleAsyncWork){s.splice(g,1),j.callback();return}}});let u=0;return b=>{const g=++u;s.push({id:g,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||O?2:A?1:3;let m=!0,f=!1;function i(){if(!f){f=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,m=new Uint16Array(s.buffer)[0]===(2<<8)+1}return m}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[36],Ce([1,0,14]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const l=a.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(Ie[15],Ce([1,0,36]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,R=90,P=122,T=46,D=47,v=92,O=58,k=63;class S extends Error{constructor(o,r,c){let m;typeof r=="string"&&r.indexOf("not ")===0?(m="must not be",r=r.replace(/^not /,"")):m="must be";const f=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${f} ${m} of type ${r}`;i+=`. Received type ${typeof c}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function C(t,o){if(t===null||typeof t!="object")throw new S(o,"Object",t)}function I(t,o){if(typeof t!="string")throw new S(o,"string",t)}const E=a.platform==="win32";function n(t){return t===D||t===v}function d(t){return t===D}function h(t){return t>=A&&t<=R||t>=l&&t<=P}function w(t,o,r,c){let m="",f=0,i=-1,s=0,u=0;for(let b=0;b<=t.length;++b){if(b<t.length)u=t.charCodeAt(b);else{if(c(u))break;u=D}if(c(u)){if(!(i===b-1||s===1))if(s===2){if(m.length<2||f!==2||m.charCodeAt(m.length-1)!==T||m.charCodeAt(m.length-2)!==T){if(m.length>2){const g=m.lastIndexOf(r);g===-1?(m="",f=0):(m=m.slice(0,g),f=m.length-1-m.lastIndexOf(r)),i=b,s=0;continue}else if(m.length!==0){m="",f=0,i=b,s=0;continue}}o&&(m+=m.length>0?`${r}..`:"..",f=2)}else m.length>0?m+=`${r}${t.slice(i+1,b)}`:m=t.slice(i+1,b),f=b-i-1;i=b,s=0}else u===T&&s!==-1?++s:s=-1}return m}function y(t,o){C(o,"pathObject");const r=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${c}`:`${r}${t}${c}`:c}e.win32={resolve(...t){let o="",r="",c=!1;for(let m=t.length-1;m>=-1;m--){let f;if(m>=0){if(f=t[m],I(f,"path"),f.length===0)continue}else o.length===0?f=a.cwd():(f=a.env[`=${o}`]||a.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==o.toLowerCase()&&f.charCodeAt(2)===v)&&(f=`${o}\\`));const i=f.length;let s=0,u="",b=!1;const g=f.charCodeAt(0);if(i===1)n(g)&&(s=1,b=!0);else if(n(g))if(b=!0,n(f.charCodeAt(1))){let L=2,j=L;for(;L<i&&!n(f.charCodeAt(L));)L++;if(L<i&&L!==j){const G=f.slice(j,L);for(j=L;L<i&&n(f.charCodeAt(L));)L++;if(L<i&&L!==j){for(j=L;L<i&&!n(f.charCodeAt(L));)L++;(L===i||L!==j)&&(u=`\\\\${G}\\${f.slice(j,L)}`,s=L)}}}else s=1;else h(g)&&f.charCodeAt(1)===O&&(u=f.slice(0,2),s=2,i>2&&n(f.charCodeAt(2))&&(b=!0,s=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(c){if(o.length>0)break}else if(r=`${f.slice(s)}\\${r}`,c=b,b&&o.length>0)break}return r=w(r,!c,"\\",n),c?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){I(t,"path");const o=t.length;if(o===0)return".";let r=0,c,m=!1;const f=t.charCodeAt(0);if(o===1)return d(f)?"\\":t;if(n(f))if(m=!0,n(t.charCodeAt(1))){let s=2,u=s;for(;s<o&&!n(t.charCodeAt(s));)s++;if(s<o&&s!==u){const b=t.slice(u,s);for(u=s;s<o&&n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&!n(t.charCodeAt(s));)s++;if(s===o)return`\\\\${b}\\${t.slice(u)}\\`;s!==u&&(c=`\\\\${b}\\${t.slice(u,s)}`,r=s)}}}else r=1;else h(f)&&t.charCodeAt(1)===O&&(c=t.slice(0,2),r=2,o>2&&n(t.charCodeAt(2))&&(m=!0,r=3));let i=r<o?w(t.slice(r),!m,"\\",n):"";return i.length===0&&!m&&(i="."),i.length>0&&n(t.charCodeAt(o-1))&&(i+="\\"),c===void 0?m?`\\${i}`:i:m?`${c}\\${i}`:`${c}${i}`},isAbsolute(t){I(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return n(r)||o>2&&h(r)&&t.charCodeAt(1)===O&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let f=0;f<t.length;++f){const i=t[f];I(i,"path"),i.length>0&&(o===void 0?o=r=i:o+=`\\${i}`)}if(o===void 0)return".";let c=!0,m=0;if(typeof r=="string"&&n(r.charCodeAt(0))){++m;const f=r.length;f>1&&n(r.charCodeAt(1))&&(++m,f>2&&(n(r.charCodeAt(2))?++m:c=!1))}if(c){for(;m<o.length&&n(o.charCodeAt(m));)m++;m>=2&&(o=`\\${o.slice(m)}`)}return e.win32.normalize(o)},relative(t,o){if(I(t,"from"),I(o,"to"),t===o)return"";const r=e.win32.resolve(t),c=e.win32.resolve(o);if(r===c||(t=r.toLowerCase(),o=c.toLowerCase(),t===o))return"";let m=0;for(;m<t.length&&t.charCodeAt(m)===v;)m++;let f=t.length;for(;f-1>m&&t.charCodeAt(f-1)===v;)f--;const i=f-m;let s=0;for(;s<o.length&&o.charCodeAt(s)===v;)s++;let u=o.length;for(;u-1>s&&o.charCodeAt(u-1)===v;)u--;const b=u-s,g=i<b?i:b;let L=-1,j=0;for(;j<g;j++){const Q=t.charCodeAt(m+j);if(Q!==o.charCodeAt(s+j))break;Q===v&&(L=j)}if(j!==g){if(L===-1)return c}else{if(b>g){if(o.charCodeAt(s+j)===v)return c.slice(s+j+1);if(j===2)return c.slice(s+j)}i>g&&(t.charCodeAt(m+j)===v?L=j:j===2&&(L=3)),L===-1&&(L=0)}let G="";for(j=m+L+1;j<=f;++j)(j===f||t.charCodeAt(j)===v)&&(G+=G.length===0?"..":"\\..");return s+=L,G.length>0?`${G}${c.slice(s,u)}`:(c.charCodeAt(s)===v&&++s,c.slice(s,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===v){if(o.charCodeAt(1)===v){const r=o.charCodeAt(2);if(r!==k&&r!==T)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===O&&o.charCodeAt(2)===v)return`\\\\?\\${o}`;return t},dirname(t){I(t,"path");const o=t.length;if(o===0)return".";let r=-1,c=0;const m=t.charCodeAt(0);if(o===1)return n(m)?t:".";if(n(m)){if(r=c=1,n(t.charCodeAt(1))){let s=2,u=s;for(;s<o&&!n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&n(t.charCodeAt(s));)s++;if(s<o&&s!==u){for(u=s;s<o&&!n(t.charCodeAt(s));)s++;if(s===o)return t;s!==u&&(r=c=s+1)}}}}else h(m)&&t.charCodeAt(1)===O&&(r=o>2&&n(t.charCodeAt(2))?3:2,c=r);let f=-1,i=!0;for(let s=o-1;s>=c;--s)if(n(t.charCodeAt(s))){if(!i){f=s;break}}else i=!1;if(f===-1){if(r===-1)return".";f=r}return t.slice(0,f)},basename(t,o){o!==void 0&&I(o,"ext"),I(t,"path");let r=0,c=-1,m=!0,f;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===O&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,s=-1;for(f=t.length-1;f>=r;--f){const u=t.charCodeAt(f);if(n(u)){if(!m){r=f+1;break}}else s===-1&&(m=!1,s=f+1),i>=0&&(u===o.charCodeAt(i)?--i===-1&&(c=f):(i=-1,c=s))}return r===c?c=s:c===-1&&(c=t.length),t.slice(r,c)}for(f=t.length-1;f>=r;--f)if(n(t.charCodeAt(f))){if(!m){r=f+1;break}}else c===-1&&(m=!1,c=f+1);return c===-1?"":t.slice(r,c)},extname(t){I(t,"path");let o=0,r=-1,c=0,m=-1,f=!0,i=0;t.length>=2&&t.charCodeAt(1)===O&&h(t.charCodeAt(0))&&(o=c=2);for(let s=t.length-1;s>=o;--s){const u=t.charCodeAt(s);if(n(u)){if(!f){c=s+1;break}continue}m===-1&&(f=!1,m=s+1),u===T?r===-1?r=s:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||m===-1||i===0||i===1&&r===m-1&&r===c+1?"":t.slice(r,m)},format:y.bind(null,"\\"),parse(t){I(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let c=0,m=t.charCodeAt(0);if(r===1)return n(m)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(n(m)){if(c=1,n(t.charCodeAt(1))){let L=2,j=L;for(;L<r&&!n(t.charCodeAt(L));)L++;if(L<r&&L!==j){for(j=L;L<r&&n(t.charCodeAt(L));)L++;if(L<r&&L!==j){for(j=L;L<r&&!n(t.charCodeAt(L));)L++;L===r?c=L:L!==j&&(c=L+1)}}}}else if(h(m)&&t.charCodeAt(1)===O){if(r<=2)return o.root=o.dir=t,o;if(c=2,n(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let f=-1,i=c,s=-1,u=!0,b=t.length-1,g=0;for(;b>=c;--b){if(m=t.charCodeAt(b),n(m)){if(!u){i=b+1;break}continue}s===-1&&(u=!1,s=b+1),m===T?f===-1?f=b:g!==1&&(g=1):f!==-1&&(g=-1)}return s!==-1&&(f===-1||g===0||g===1&&f===s-1&&f===i+1?o.base=o.name=t.slice(i,s):(o.name=t.slice(i,f),o.base=t.slice(i,s),o.ext=t.slice(f,s))),i>0&&i!==c?o.dir=t.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(E){const t=/\\/g;return()=>{const o=a.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...t){let o="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const m=c>=0?t[c]:p();I(m,"path"),m.length!==0&&(o=`${m}/${o}`,r=m.charCodeAt(0)===D)}return o=w(o,!r,"/",d),r?`/${o}`:o.length>0?o:"."},normalize(t){if(I(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===D,r=t.charCodeAt(t.length-1)===D;return t=w(t,!o,"/",d),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return I(t,"path"),t.length>0&&t.charCodeAt(0)===D},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const c=t[r];I(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(I(t,"from"),I(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const r=1,c=t.length,m=c-r,f=1,i=o.length-f,s=m<i?m:i;let u=-1,b=0;for(;b<s;b++){const L=t.charCodeAt(r+b);if(L!==o.charCodeAt(f+b))break;L===D&&(u=b)}if(b===s)if(i>s){if(o.charCodeAt(f+b)===D)return o.slice(f+b+1);if(b===0)return o.slice(f+b)}else m>s&&(t.charCodeAt(r+b)===D?u=b:b===0&&(u=0));let g="";for(b=r+u+1;b<=c;++b)(b===c||t.charCodeAt(b)===D)&&(g+=g.length===0?"..":"/..");return`${g}${o.slice(f+u)}`},toNamespacedPath(t){return t},dirname(t){if(I(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===D;let r=-1,c=!0;for(let m=t.length-1;m>=1;--m)if(t.charCodeAt(m)===D){if(!c){r=m;break}}else c=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&I(o,"ext"),I(t,"path");let r=0,c=-1,m=!0,f;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,s=-1;for(f=t.length-1;f>=0;--f){const u=t.charCodeAt(f);if(u===D){if(!m){r=f+1;break}}else s===-1&&(m=!1,s=f+1),i>=0&&(u===o.charCodeAt(i)?--i===-1&&(c=f):(i=-1,c=s))}return r===c?c=s:c===-1&&(c=t.length),t.slice(r,c)}for(f=t.length-1;f>=0;--f)if(t.charCodeAt(f)===D){if(!m){r=f+1;break}}else c===-1&&(m=!1,c=f+1);return c===-1?"":t.slice(r,c)},extname(t){I(t,"path");let o=-1,r=0,c=-1,m=!0,f=0;for(let i=t.length-1;i>=0;--i){const s=t.charCodeAt(i);if(s===D){if(!m){r=i+1;break}continue}c===-1&&(m=!1,c=i+1),s===T?o===-1?o=i:f!==1&&(f=1):o!==-1&&(f=-1)}return o===-1||c===-1||f===0||f===1&&o===c-1&&o===r+1?"":t.slice(o,c)},format:y.bind(null,"/"),parse(t){I(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===D;let c;r?(o.root="/",c=1):c=0;let m=-1,f=0,i=-1,s=!0,u=t.length-1,b=0;for(;u>=c;--u){const g=t.charCodeAt(u);if(g===D){if(!s){f=u+1;break}continue}i===-1&&(s=!1,i=u+1),g===T?m===-1?m=u:b!==1&&(b=1):m!==-1&&(b=-1)}if(i!==-1){const g=f===0&&r?1:f;m===-1||b===0||b===1&&m===i-1&&m===f+1?o.base=o.name=t.slice(g,i):(o.name=t.slice(g,m),o.base=t.slice(g,i),o.ext=t.slice(m,i))}return f>0?o.dir=t.slice(0,f-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(Ie[109],Ce([1,0,65,15]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new a.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),R=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(s,u,b=!1){const g=s||"",L=u||"",j=l.value.collator.compare(g,L);return l.value.collatorIsNumeric&&j===0&&g!==L?g<L?-1:1:j}e.compareFileNames=T;function D(s,u){const b=R.value.collator;return s=s||"",u=u||"",y(b,s,u)}e.compareFileNamesDefault=D;function v(s,u){const b=R.value.collator;return s=s||"",u=u||"",r(s,u)||y(b,s,u)}e.compareFileNamesUpper=v;function O(s,u){const b=R.value.collator;return s=s||"",u=u||"",o(s,u)||y(b,s,u)}e.compareFileNamesLower=O;function k(s,u){return s=s||"",u=u||"",s===u?0:s<u?-1:1}e.compareFileNamesUnicode=k;function S(s,u){const[b,g]=h(s),[L,j]=h(u);let G=l.value.collator.compare(g,j);if(G===0){if(l.value.collatorIsNumeric&&g!==j)return g<j?-1:1;if(G=l.value.collator.compare(b,L),l.value.collatorIsNumeric&&G===0&&b!==L)return b<L?-1:1}return G}e.compareFileExtensions=S;function C(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=R.value.collator,j=P.value.collator;return y(j,b,g)||y(L,s,u)}e.compareFileExtensionsDefault=C;function I(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=R.value.collator,j=P.value.collator;return y(j,b,g)||r(s,u)||y(L,s,u)}e.compareFileExtensionsUpper=I;function E(s,u){s=s||"",u=u||"";const b=w(s),g=w(u),L=R.value.collator,j=P.value.collator;return y(j,b,g)||o(s,u)||y(L,s,u)}e.compareFileExtensionsLower=E;function n(s,u){s=s||"",u=u||"";const b=w(s).toLowerCase(),g=w(u).toLowerCase();return b!==g?b<g?-1:1:s!==u?s<u?-1:1:0}e.compareFileExtensionsUnicode=n;const d=/^(.*?)(\.([^.]*))?$/;function h(s,u=!1){const b=s?d.exec(s):[];let g=[b&&b[1]||"",b&&b[3]||""];return u&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function w(s){const u=s?d.exec(s):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function y(s,u,b){const g=s.compare(u,b);return g!==0?g:u.length!==b.length?u.length<b.length?-1:1:0}function p(s){const u=s.charAt(0);return u.toLocaleUpperCase()!==u}function t(s){const u=s.charAt(0);return u.toLocaleLowerCase()!==u}function o(s,u){return p(s)&&t(u)?-1:t(s)&&p(u)?1:0}function r(s,u){return t(s)&&p(u)?-1:p(s)&&t(u)?1:0}function c(s,u,b=!1){return b||(s=s&&s.toLowerCase(),u=u&&u.toLowerCase()),s===u?0:s<u?-1:1}function m(s,u,b=!1){const g=s.split(A.sep),L=u.split(A.sep),j=g.length-1,G=L.length-1;let Q,B;for(let U=0;;U++){if(Q=j===U,B=G===U,Q&&B)return T(g[U],L[U],b);if(Q)return-1;if(B)return 1;const z=c(g[U],L[U],b);if(z!==0)return z}}e.comparePaths=m;function f(s,u,b){const g=s.toLowerCase(),L=u.toLowerCase(),j=i(s,u,b);if(j)return j;const G=g.endsWith(b),Q=L.endsWith(b);if(G!==Q)return G?-1:1;const B=T(g,L);return B!==0?B:g.localeCompare(L)}e.compareAnything=f;function i(s,u,b){const g=s.toLowerCase(),L=u.toLowerCase(),j=g.startsWith(b),G=L.startsWith(b);if(j!==G)return j?-1:1;if(j&&G){if(g.length<L.length)return-1;if(g.length>L.length)return 1}return 0}e.compareByPrefix=i}),define(Ie[88],Ce([1,0,15]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(O){const k=(0,a.extname)(O),S=A[k.toLowerCase()];return S!==void 0?S:P(O)}e.getMediaOrTextMime=R;function P(O){const k=(0,a.extname)(O);return l[k.toLowerCase()]}e.getMediaMime=P;function T(O){for(const k in l)if(l[k]===O)return k}e.getExtensionForMimeType=T;const D=/^(.+)\/(.+?)(;.+)?$/;function v(O,k){const S=D.exec(O);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:O}e.normalizeMimeType=v}),define(Ie[110],Ce([1,0,14]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var l;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...D){const v=D.reduce((S,C)=>(S[C]=!0,S),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(S=>!v[S]).forEach(S=>{for(let C=0;C<O.length;C++)if(S.search(O[C])!==-1){delete T[S];break}})}e.sanitizeProcessEnvironment=R;function P(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=P}),define(Ie[37],Ce([1,0,14]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=a.globals.performance&&typeof a.globals.performance.now=="function";class l{static create(P=!0){return new l(P)}constructor(P){this.a=A&&P,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=l}),define(Ie[3],Ce([1,0,8,63,6,66,37]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,D=!1;var v;(function(f){f.None=()=>l.Disposable.None;function i(J){if(D){const{onDidAddListener:ge}=J,Ee=I.create();let ie=0;J.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),ge?.()}}}function s(J,ge){return U(J,()=>{},0,void 0,!0,void 0,ge)}f.defer=s;function u(J){return(ge,Ee=null,ie)=>{let ne=!1,de;return de=J(ee=>{if(!ne)return de?de.dispose():ne=!0,ge.call(Ee,ee)},null,ie),ne&&de.dispose(),de}}f.once=u;function b(J,ge,Ee){return B((ie,ne=null,de)=>J(ee=>ie.call(ne,ge(ee)),null,de),Ee)}f.map=b;function g(J,ge,Ee){return B((ie,ne=null,de)=>J(ee=>{ge(ee),ie.call(ne,ee)},null,de),Ee)}f.forEach=g;function L(J,ge,Ee){return B((ie,ne=null,de)=>J(ee=>ge(ee)&&ie.call(ne,ee),null,de),Ee)}f.filter=L;function j(J){return J}f.signal=j;function G(...J){return(ge,Ee=null,ie)=>(0,l.combinedDisposable)(...J.map(ne=>ne(de=>ge.call(Ee,de),null,ie)))}f.any=G;function Q(J,ge,Ee,ie){let ne=Ee;return b(J,de=>(ne=ge(ne,de),ne),ie)}f.reduce=Q;function B(J,ge){let Ee;const ie={onWillAddFirstListener(){Ee=J(ne.fire,ne)},onDidRemoveLastListener(){Ee?.dispose()}};ge||i(ie);const ne=new n(ie);return ge?.add(ne),ne.event}function U(J,ge,Ee=100,ie=!1,ne=!1,de,ee){let ce,ae,N,$=0,X;const Z={leakWarningThreshold:de,onWillAddFirstListener(){ce=J(Se=>{$++,ae=ge(ae,Se),ie&&!N&&(he.fire(ae),ae=void 0),X=()=>{const Re=ae;ae=void 0,N=void 0,(!ie||$>1)&&he.fire(Re),$=0},typeof Ee=="number"?(clearTimeout(N),N=setTimeout(X,Ee)):N===void 0&&(N=0,queueMicrotask(X))})},onWillRemoveListener(){ne&&$>0&&X?.()},onDidRemoveLastListener(){X=void 0,ce.dispose()}};ee||i(Z);const he=new n(Z);return ee?.add(he),he.event}f.debounce=U;function z(J,ge=0,Ee){return f.debounce(J,(ie,ne)=>ie?(ie.push(ne),ie):[ne],ge,void 0,!0,void 0,Ee)}f.accumulate=z;function M(J,ge=(ie,ne)=>ie===ne,Ee){let ie=!0,ne;return L(J,de=>{const ee=ie||!ge(de,ne);return ie=!1,ne=de,ee},Ee)}f.latch=M;function x(J,ge,Ee){return[f.filter(J,ge,Ee),f.filter(J,ie=>!ge(ie),Ee)]}f.split=x;function fe(J,ge=!1,Ee=[]){let ie=Ee.slice(),ne=J(ce=>{ie?ie.push(ce):ee.fire(ce)});const de=()=>{ie?.forEach(ce=>ee.fire(ce)),ie=null},ee=new n({onWillAddFirstListener(){ne||(ne=J(ce=>ee.fire(ce)))},onDidAddFirstListener(){ie&&(ge?setTimeout(de):de())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return ee.event}f.buffer=fe;class re{constructor(ge){this.event=ge,this.c=new l.DisposableStore}map(ge){return new re(b(this.event,ge,this.c))}forEach(ge){return new re(g(this.event,ge,this.c))}filter(ge){return new re(L(this.event,ge,this.c))}reduce(ge,Ee){return new re(Q(this.event,ge,Ee,this.c))}latch(){return new re(M(this.event,void 0,this.c))}debounce(ge,Ee=100,ie=!1,ne=!1,de){return new re(U(this.event,ge,Ee,ie,ne,de,this.c))}on(ge,Ee,ie){return this.event(ge,Ee,ie)}once(ge,Ee,ie){return u(this.event)(ge,Ee,ie)}dispose(){this.c.dispose()}}function V(J){return new re(J)}f.chain=V;function _(J,ge,Ee=ie=>ie){const ie=(...ce)=>ee.fire(Ee(...ce)),ne=()=>J.on(ge,ie),de=()=>J.removeListener(ge,ie),ee=new n({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}f.fromNodeEventEmitter=_;function te(J,ge,Ee=ie=>ie){const ie=(...ce)=>ee.fire(Ee(...ce)),ne=()=>J.addEventListener(ge,ie),de=()=>J.removeEventListener(ge,ie),ee=new n({onWillAddFirstListener:ne,onDidRemoveLastListener:de});return ee.event}f.fromDOMEventEmitter=te;function ve(J){return new Promise(ge=>u(J)(ge))}f.toPromise=ve;function le(J,ge){return ge(void 0),J(Ee=>ge(Ee))}f.runAndSubscribe=le;function ue(J,ge){let Ee=null;function ie(de){Ee?.dispose(),Ee=new l.DisposableStore,ge(de,Ee)}ie(void 0);const ne=J(de=>ie(de));return(0,l.toDisposable)(()=>{ne.dispose(),Ee?.dispose()})}f.runAndSubscribeWithStore=ue;class q{constructor(ge,Ee){this.obs=ge,this.c=0,this.d=!1;const ie={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};Ee||i(ie),this.emitter=new n(ie),Ee&&Ee.add(this.emitter)}beginUpdate(ge){this.c++}handleChange(ge,Ee){this.d=!0}endUpdate(ge){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function F(J,ge){return new q(J,ge).emitter.event}f.fromObservable=F})(v=e.Event||(e.Event={}));class O{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${O.c++}`,O.all.add(this)}start(i){this.d=new P.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}O.all=new Set,O.c=0,e.EventProfiling=O;let k=-1;function S(f){const i=k;return k=f,{dispose(){k=i}}}e.setGlobalLeakWarningThreshold=S;class C{constructor(i,s=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=s,this.d=0}dispose(){this.c?.clear()}check(i,s){const u=this.threshold;if(u<=0||s<u)return;this.c||(this.c=new Map);const b=this.c.get(i.value)||0;if(this.c.set(i.value,b+1),this.d-=1,this.d<=0){this.d=u*.5;let g,L=0;for(const[j,G]of this.c)(!g||L<G)&&(g=j,L=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${L}):`),console.warn(g)}return()=>{const g=this.c.get(i.value)||0;this.c.set(i.value,g-1)}}}class I{static create(){return new I(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(i,s,u){this.callback=i,this.callbackThis=s,this.stack=u,this.subscription=new l.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class n{constructor(i){this.j=!1,this.d=i,this.f=k>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new O(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const i=Array.from(this.q);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,s,u)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const b=this.q.isEmpty();b&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let g,L;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(L=I.create(),g=this.f.check(L,this.q.size+1)),T&&(L=L??I.create());const j=new E(i,s,L),G=this.q.push(j);b&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,s);const Q=j.subscription.set(()=>{g?.(),this.j||(this.d?.onWillRemoveListener?.(this),G(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return u instanceof l.DisposableStore?u.add(Q):Array.isArray(u)&&u.push(Q),Q}),this.l}fire(i){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const s of this.q)this.m.push(this,s,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=n;class d{constructor(i=a.onUnexpectedError){this.d=i,this.c=new R.LinkedList}get size(){return this.c.size}push(i,s,u){this.c.push(new w(i,s,u))}clear(i){const s=new R.LinkedList;for(const u of this.c)u.emitter!==i&&s.push(u);this.c=s}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(s){this.d(s)}}}}e.EventDeliveryQueue=d;class h extends d{clear(i){this.c.clear()}}class w{constructor(i,s,u){this.emitter=i,this.listener=s,this.event=u}}class y extends n{async fireAsync(i,s,u){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const b of this.q)this.c.push([b,i]);for(;this.c.size>0&&!s.isCancellationRequested;){const[b,g]=this.c.shift(),L=[],j={...g,token:s,waitUntil:G=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");u&&(G=u(G,b.callback)),L.push(G)}};try{b.invoke(j)}catch(G){(0,a.onUnexpectedError)(G);continue}Object.freeze(L),await Promise.allSettled(L).then(G=>{for(const Q of G)Q.status==="rejected"&&(0,a.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=y;class p extends n{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=p;class t extends p{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=t;class o extends n{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(s=>super.fire(s)),this.c=[]}))}}e.MicrotaskEmitter=o;class r{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const s={event:i,listener:null};this.f.push(s),this.d&&this.j(s);const u=()=>{this.d&&this.k(s);const b=this.f.indexOf(s);this.f.splice(b,1)};return(0,l.toDisposable)((0,A.once)(u))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(s=>this.c.fire(s))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class c{constructor(){this.c=[]}wrapEvent(i){return(s,u,b)=>i(g=>{const L=this.c[this.c.length-1];L?L.push(()=>s.call(u,g)):s.call(u,g)},void 0,b)}bufferEvents(i){const s=[];this.c.push(s);const u=i();return this.c.pop(),s.forEach(b=>b()),u}}e.EventBufferer=c;class m{constructor(){this.c=!1,this.d=v.None,this.f=l.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=m}),define(Ie[163],Ce([1,0,3,6,158]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(S,C="",I="",E=!0,n){super(),this.j=this.B(new a.Emitter),this.onDidChange=this.j.event,this.z=!0,this.m=S,this.n=C,this.w=I,this.z=E,this.D=n}get id(){return this.m}get label(){return this.n}set label(S){this.F(S)}F(S){this.n!==S&&(this.n=S,this.j.fire({label:S}))}get tooltip(){return this.u||""}set tooltip(S){this.G(S)}G(S){this.u!==S&&(this.u=S,this.j.fire({tooltip:S}))}get class(){return this.w}set class(S){this.H(S)}H(S){this.w!==S&&(this.w=S,this.j.fire({class:S}))}get enabled(){return this.z}set enabled(S){this.I(S)}I(S){this.z!==S&&(this.z=S,this.j.fire({enabled:S}))}get checked(){return this.C}set checked(S){this.J(S)}J(S){this.C!==S&&(this.C=S,this.j.fire({checked:S}))}async run(S,C){this.D&&await this.D(S)}}e.Action=R;class P extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(S,C){if(!S.enabled)return;this.f.fire({action:S});let I;try{await this.k(S,C)}catch(E){I=E}this.h.fire({action:S,error:I})}async k(S,C){await S.run(C)}}e.ActionRunner=P;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...S){let C=[];for(const I of S)I.length&&(C.length?C=[...C,new T,...I]:C=I);return C}async run(){}}T.ID="vs.actions.separator",e.Separator=T;class D{get actions(){return this.a}constructor(S,C,I,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=S,this.label=C,this.class=E,this.a=I}async run(){}}e.SubmenuAction=D;class v extends R{constructor(){super(v.ID,l.localize(0,null),void 0,!1)}}v.ID="vs.actions.empty",e.EmptySubmenuAction=v;function O(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=O}),define(Ie[21],Ce([1,0,3]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(T,D){const v=setTimeout(T.bind(D),0);return{dispose(){clearTimeout(v)}}});var l;(function(T){function D(v){return v===T.None||v===T.Cancelled||v instanceof R?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}T.isCancellationToken=D,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(D){this.a=void 0,this.b=void 0,this.b=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=l.Cancelled}dispose(D=!1){D&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=P}),define(Ie[164],Ce([1,0,21]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,D=this.b(T.token);return this.a={promise:D,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=A;class l{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const D=JSON.stringify(T);return this.b!==D&&(this.b=D,this.a=this.c(T)),this.a}}e.LRUCachedFunction=l;class R{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const D=this.b(T);return this.a.set(T,D),D}}e.CachedFunction=R}),define(Ie[9],Ce([1,0,164,65]),function(se,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=R;const P=/{(\d+)}/g;function T(W,...Y){return Y.length===0?W:W.replace(P,function(me,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=Y.length?me:Y[Ne]})}e.format=T;const D=/{([^}]+)}/g;function v(W,Y){return W.replace(D,(me,Le)=>Y[Le]??me)}e.format2=v;function O(W){return W.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=O;function k(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(W,Y){let me=0;const Le=Y.charCodeAt(0);for(let Ne=W.length-1;Ne>=0;Ne--)W.charCodeAt(Ne)===Le&&me++;return me}e.count=S;function C(W,Y,me="\u2026"){return W.length<=Y?W:`${W.substr(0,Y)}${me}`}e.truncate=C;function I(W,Y=" "){const me=E(W,Y);return n(me,Y)}e.trim=I;function E(W,Y){if(!W||!Y)return W;const me=Y.length;if(me===0||W.length===0)return W;let Le=0;for(;W.indexOf(Y,Le)===Le;)Le=Le+me;return W.substring(Le)}e.ltrim=E;function n(W,Y){if(!W||!Y)return W;const me=Y.length,Le=W.length;if(me===0||Le===0)return W;let Ne=Le,xe=-1;for(;xe=W.lastIndexOf(Y,Ne-1),!(xe===-1||xe+me!==Ne);){if(xe===0)return"";Ne=xe}return W.substring(0,Ne)}e.rtrim=n;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function w(W,Y,me={}){if(!W)throw new Error("Cannot create regex from empty string");Y||(W=k(W)),me.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return me.global&&(Le+="g"),me.matchCase||(Le+="i"),me.multiline&&(Le+="m"),me.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=w;function y(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function p(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=t;function o(W){return W.split(/\r\n|\r|\n/)}e.splitLines=o;function r(W){for(let Y=0,me=W.length;Y<me;Y++){const Le=W.charCodeAt(Y);if(Le!==32&&Le!==9)return Y}return-1}e.firstNonWhitespaceIndex=r;function c(W,Y=0,me=W.length){for(let Le=Y;Le<me;Le++){const Ne=W.charCodeAt(Le);if(Ne!==32&&Ne!==9)return W.substring(Y,Le)}return W.substring(Y,me)}e.getLeadingWhitespace=c;function m(W,Y=W.length-1){for(let me=Y;me>=0;me--){const Le=W.charCodeAt(me);if(Le!==32&&Le!==9)return me}return-1}e.lastNonWhitespaceIndex=m;function f(W,Y,me){const Le=[];let Ne=0;for(const xe of W.matchAll(Y)){if(Le.push(W.slice(Ne,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Ne=xe.index+xe[0].length,Le.push(me(xe[0],...xe.slice(1),xe.index,W,xe.groups))}return Le.push(W.slice(Ne)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=f;function i(W,Y){return W<Y?-1:W>Y?1:0}e.compare=i;function s(W,Y,me=0,Le=W.length,Ne=0,xe=Y.length){for(;me<Le&&Ne<xe;me++,Ne++){const rt=W.charCodeAt(me),ct=Y.charCodeAt(Ne);if(rt<ct)return-1;if(rt>ct)return 1}const Qe=Le-me,Xe=xe-Ne;return Qe<Xe?-1:Qe>Xe?1:0}e.compareSubstring=s;function u(W,Y){return b(W,Y,0,W.length,0,Y.length)}e.compareIgnoreCase=u;function b(W,Y,me=0,Le=W.length,Ne=0,xe=Y.length){for(;me<Le&&Ne<xe;me++,Ne++){let rt=W.charCodeAt(me),ct=Y.charCodeAt(Ne);if(rt===ct)continue;if(rt>=128||ct>=128)return s(W.toLowerCase(),Y.toLowerCase(),me,Le,Ne,xe);L(rt)&&(rt-=32),L(ct)&&(ct-=32);const vt=rt-ct;if(vt!==0)return vt}const Qe=Le-me,Xe=xe-Ne;return Qe<Xe?-1:Qe>Xe?1:0}e.compareSubstringIgnoreCase=b;function g(W){return W>=48&&W<=57}e.isAsciiDigit=g;function L(W){return W>=97&&W<=122}e.isLowerAsciiLetter=L;function j(W){return W>=65&&W<=90}e.isUpperAsciiLetter=j;function G(W,Y){return W.length===Y.length&&b(W,Y)===0}e.equalsIgnoreCase=G;function Q(W,Y){const me=Y.length;return Y.length>W.length?!1:b(W,Y,0,me)===0}e.startsWithIgnoreCase=Q;function B(W,Y){const me=Math.min(W.length,Y.length);let Le;for(Le=0;Le<me;Le++)if(W.charCodeAt(Le)!==Y.charCodeAt(Le))return Le;return me}e.commonPrefixLength=B;function U(W,Y){const me=Math.min(W.length,Y.length);let Le;const Ne=W.length-1,xe=Y.length-1;for(Le=0;Le<me;Le++)if(W.charCodeAt(Ne-Le)!==Y.charCodeAt(xe-Le))return Le;return me}e.commonSuffixLength=U;function z(W){return 55296<=W&&W<=56319}e.isHighSurrogate=z;function M(W){return 56320<=W&&W<=57343}e.isLowSurrogate=M;function x(W,Y){return(W-55296<<10)+(Y-56320)+65536}e.computeCodePoint=x;function fe(W,Y,me){const Le=W.charCodeAt(me);if(z(Le)&&me+1<Y){const Ne=W.charCodeAt(me+1);if(M(Ne))return x(Le,Ne)}return Le}e.getNextCodePoint=fe;function re(W,Y){const me=W.charCodeAt(Y-1);if(M(me)&&Y>1){const Le=W.charCodeAt(Y-2);if(z(Le))return x(Le,me)}return me}class V{get offset(){return this.e}constructor(Y,me=0){this.c=Y,this.d=Y.length,this.e=me}setOffset(Y){this.e=Y}prevCodePoint(){const Y=re(this.c,this.e);return this.e-=Y>=65536?2:1,Y}nextCodePoint(){const Y=fe(this.c,this.d,this.e);return this.e+=Y>=65536?2:1,Y}eol(){return this.e>=this.d}}e.CodePointIterator=V;class _{get offset(){return this.c.offset}constructor(Y,me=0){this.c=new V(Y,me)}nextGraphemeLength(){const Y=je.getInstance(),me=this.c,Le=me.offset;let Ne=Y.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const xe=me.offset,Qe=Y.getGraphemeBreakType(me.nextCodePoint());if(Te(Ne,Qe)){me.setOffset(xe);break}Ne=Qe}return me.offset-Le}prevGraphemeLength(){const Y=je.getInstance(),me=this.c,Le=me.offset;let Ne=Y.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const xe=me.offset,Qe=Y.getGraphemeBreakType(me.prevCodePoint());if(Te(Qe,Ne)){me.setOffset(xe);break}Ne=Qe}return Le-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=_;function te(W,Y){return new _(W,Y).nextGraphemeLength()}e.nextCharLength=te;function ve(W,Y){return new _(W,Y).prevGraphemeLength()}e.prevCharLength=ve;function le(W,Y){Y>0&&M(W.charCodeAt(Y))&&Y--;const me=Y+te(W,Y);return[me-ve(W,me),me]}e.getCharContainingOffset=le;function ue(W){const Y=new _(W);let me=0;for(;!Y.eol();)me++,Y.nextGraphemeLength();return me}e.charCount=ue;let q;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function J(W){return q||(q=F()),q.test(W)}e.containsRTL=J;const ge=/^[\t\n\r\x20-\x7E]*$/;function Ee(W){return ge.test(W)}e.isBasicASCII=Ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ie;function ne(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ne;function de(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=de;function ee(W,Y){if(W.length<Y)return W;const me=/\b/g;let Le=0;for(;me.test(W)&&!(W.length-me.lastIndex<Y);)Le=me.lastIndex,me.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ae(W){return W&&(W=W.replace(ce,"")),W}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function $(W){return N(W)?W.substr(1):W}e.stripUTF8BOM=$;function X(W,Y){if(!W||!Y||W.length<Y.length)return!1;const me=Y.length,Le=W.toLowerCase();let Ne=0,xe=-1;for(;Ne<me;){const Qe=Le.indexOf(Y[Ne],xe+1);if(Qe<0)return!1;xe=Qe,Ne++}return!0}e.fuzzyContains=X;function Z(W,Y=!1){return W?(Y&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Z;function he(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=he;function Se(W,Y=1){if(Y===0)return"";let me=-1;do me=W.indexOf(`
`,me+1),Y--;while(Y>0&&me>=0);return me===-1?W:(W[me-1]==="\r"&&me--,W.substr(0,me))}e.getNLines=Se;function Re(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Re;function we(W){return je.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=we;function Te(W,Y){return W===0?Y!==5&&Y!==7:W===2&&Y===3?!1:W===4||W===2||W===3||Y===4||Y===2||Y===3?!0:!(W===8&&(Y===8||Y===9||Y===11||Y===12)||(W===11||W===9)&&(Y===9||Y===10)||(W===12||W===10)&&Y===10||Y===5||Y===13||Y===7||W===1||W===13&&Y===14||W===6&&Y===6)}var ke;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class je{static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=We()}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const me=this.d,Le=me.length/3;let Ne=1;for(;Ne<=Le;)if(Y<me[3*Ne])Ne=2*Ne;else if(Y>me[3*Ne+1])Ne=2*Ne+1;else return me[3*Ne+2];return 0}}je.c=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(W,Y){if(W===0)return 0;const me=Ye(W,Y);if(me!==void 0)return me;const Le=new V(Y,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=tt;function Ye(W,Y){const me=new V(Y,W);let Le=me.prevCodePoint();for(;nt(Le)||Le===65039||Le===8419;){if(me.offset===0)return;Le=me.prevCodePoint()}if(!de(Le))return;let Ne=me.offset;return Ne>0&&me.prevCodePoint()===8205&&(Ne=me.offset),Ne}function nt(W){return 127995<=W&&W<=127999}var st;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(Y){return Be.d.get(Array.from(Y))}static getLocales(){return Be.e.value}constructor(Y){this.f=Y}isAmbiguous(Y){return this.f.has(Y)}getPrimaryConfusable(Y){return this.f.get(Y)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Be,Be.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new a.LRUCachedFunction(W=>{function Y(ct){const vt=new Map;for(let mt=0;mt<ct.length;mt+=2)vt.set(ct[mt],ct[mt+1]);return vt}function me(ct,vt){const mt=new Map(ct);for(const[wt,Ct]of vt)mt.set(wt,Ct);return mt}function Le(ct,vt){if(!ct)return vt;const mt=new Map;for(const[wt,Ct]of ct)vt.has(wt)&&mt.set(wt,Ct);return mt}const Ne=l.c.value;let xe=W.filter(ct=>!ct.startsWith("_")&&ct in Ne);xe.length===0&&(xe=["_default"]);let Qe;for(const ct of xe){const vt=Y(Ne[ct]);Qe=Le(Qe,vt)}const Xe=Y(Ne._common),rt=me(Xe,Qe);return new Be(rt)}),Be.e=new A.Lazy(()=>Object.keys(Be.c.value).filter(W=>!W.startsWith("_"))),e.AmbiguousCharacters=Be;class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(Y){return it.e().has(Y)}static get codePoints(){return it.e()}}it.d=void 0,e.InvisibleCharacters=it}),define(Ie[33],Ce([1,0,15,14,9,10]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(f){return f===47||f===92}e.isPathSeparator=P;function T(f){return f.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function D(f){return f.indexOf("/")===-1&&(f=T(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=D;function v(f,i=a.posix.sep){if(!f)return"";const s=f.length,u=f.charCodeAt(0);if(P(u)){if(P(f.charCodeAt(1))&&!P(f.charCodeAt(2))){let g=3;const L=g;for(;g<s&&!P(f.charCodeAt(g));g++);if(L!==g&&!P(f.charCodeAt(g+1))){for(g+=1;g<s;g++)if(P(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,i)}}return i}else if(d(u)&&f.charCodeAt(1)===58)return P(f.charCodeAt(2))?f.slice(0,2)+i:f.slice(0,2);let b=f.indexOf("://");if(b!==-1){for(b+=3;b<s;b++)if(P(f.charCodeAt(b)))return f.slice(0,b+1)}return""}e.getRoot=v;function O(f){if(!A.isWindows||!f||f.length<5)return!1;let i=f.charCodeAt(0);if(i!==92||(i=f.charCodeAt(1),i!==92))return!1;let s=2;const u=s;for(;s<f.length&&(i=f.charCodeAt(s),i!==92);s++);return!(u===s||(i=f.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=O;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(f,i=A.isWindows){const s=i?k:S;return!(!f||f.length===0||/^\s+$/.test(f)||(s.lastIndex=0,s.test(f))||i&&C.test(f)||f==="."||f===".."||i&&f[f.length-1]==="."||i&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=I;function E(f,i,s){const u=f===i;return!s||u?u:!f||!i?!1:(0,l.equalsIgnoreCase)(f,i)}e.isEqual=E;function n(f,i,s,u=a.sep){if(f===i)return!0;if(!f||!i||i.length>f.length)return!1;if(s){if(!(0,l.startsWithIgnoreCase)(f,i))return!1;if(i.length===f.length)return!0;let g=i.length;return i.charAt(i.length-1)===u&&g--,f.charAt(g)===u}return i.charAt(i.length-1)!==u&&(i+=u),f.indexOf(i)===0}e.isEqualOrParent=n;function d(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=d;function h(f,i){return A.isWindows&&f.endsWith(":")&&(f+=a.sep),(0,a.isAbsolute)(f)||(f=(0,a.join)(i,f)),f=(0,a.normalize)(f),A.isWindows?(f=(0,l.rtrim)(f,a.sep),f.endsWith(":")&&(f+=a.sep)):(f=(0,l.rtrim)(f,a.sep),f||(f=a.sep)),f}e.sanitizeFilePath=h;function w(f){const i=(0,a.normalize)(f);return A.isWindows?f.length>3?!1:y(i)&&(f.length===2||i.charCodeAt(2)===92):i===a.posix.sep}e.isRootOrDriveLetter=w;function y(f,i=A.isWindows){return i?d(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function p(f){return y(f)?f[0]:void 0}e.getDriveLetter=p;function t(f,i,s){return i.length>f.length?-1:f===i?0:(s&&(f=f.toLowerCase(),i=i.toLowerCase()),f.indexOf(i))}e.indexOfPath=t;function o(f){const i=f.split(":");let s,u,b;for(const g of i){const L=Number(g);(0,R.isNumber)(L)?u===void 0?u=L:b===void 0&&(b=L):s=s?[s,g].join(":"):g}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:b!==void 0?b:u!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,i,s=8){let u="";for(let g=0;g<s;g++){let L;g===0&&A.isWindows&&!i&&(s===3||s===4)?L=c:L=r,u+=L.charAt(Math.floor(Math.random()*L.length))}let b;return i?b=`${i}-${u}`:b=u,f?(0,a.join)(f,b):b}e.randomPath=m}),define(Ie[111],Ce([1,0,28,9]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...ae){return function(N,$){for(let X=0,Z=ae.length;X<Z;X++){const he=ae[X](N,$);if(he)return he}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ae,N,$){if(!$||$.length<N.length)return null;let X;return ae?X=A.startsWithIgnoreCase($,N):X=$.indexOf(N)===0,X?N.length>0?[{start:0,end:N.length}]:[]:null}function P(ae,N){const $=N.toLowerCase().indexOf(ae.toLowerCase());return $===-1?null:[{start:$,end:$+ae.length}]}e.matchesContiguousSubString=P;function T(ae,N){return D(ae.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=T;function D(ae,N,$,X){if($===ae.length)return[];if(X===N.length)return null;if(ae[$]===N[X]){let Z=null;return(Z=D(ae,N,$+1,X+1))?d({start:X,end:X+1},Z):null}return D(ae,N,$,X+1)}function v(ae){return 97<=ae&&ae<=122}function O(ae){return 65<=ae&&ae<=90}e.isUpper=O;function k(ae){return 48<=ae&&ae<=57}function S(ae){return ae===32||ae===9||ae===10||ae===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ae=>C.add(ae.charCodeAt(0)));function I(ae){return S(ae)||C.has(ae)}function E(ae,N){return ae===N||I(ae)&&I(N)}function n(ae){return v(ae)||O(ae)||k(ae)}function d(ae,N){return N.length===0?N=[ae]:ae.end===N[0].start?N[0].start=ae.start:N.unshift(ae),N}function h(ae,N){for(let $=N;$<ae.length;$++){const X=ae.charCodeAt($);if(O(X)||k(X)||$>0&&!n(ae.charCodeAt($-1)))return $}return ae.length}function w(ae,N,$,X){if($===ae.length)return[];if(X===N.length)return null;if(ae[$]!==N[X].toLowerCase())return null;{let Z=null,he=X+1;for(Z=w(ae,N,$+1,X+1);!Z&&(he=h(N,he))<N.length;)Z=w(ae,N,$+1,he),he++;return Z===null?null:d({start:X,end:X+1},Z)}}function y(ae){let N=0,$=0,X=0,Z=0,he=0;for(let ke=0;ke<ae.length;ke++)he=ae.charCodeAt(ke),O(he)&&N++,v(he)&&$++,n(he)&&X++,k(he)&&Z++;const Se=N/ae.length,Re=$/ae.length,we=X/ae.length,Te=Z/ae.length;return{upperPercent:Se,lowerPercent:Re,alphaPercent:we,numericPercent:Te}}function p(ae){const{upperPercent:N,lowerPercent:$}=ae;return $===0&&N>.6}function t(ae){const{upperPercent:N,lowerPercent:$,alphaPercent:X,numericPercent:Z}=ae;return $>.2&&N<.8&&X>.6&&Z<.2}function o(ae){let N=0,$=0,X=0,Z=0;for(let he=0;he<ae.length;he++)X=ae.charCodeAt(he),O(X)&&N++,v(X)&&$++,S(X)&&Z++;return(N===0||$===0)&&Z===0?ae.length<=30:N<=5}function r(ae,N){if(!N||(N=N.trim(),N.length===0)||!o(ae)||N.length>60)return null;const $=y(N);if(!t($)){if(!p($))return null;N=N.toLowerCase()}let X=null,Z=0;for(ae=ae.toLowerCase();Z<N.length&&(X=w(ae,N,0,Z))===null;)Z=h(N,Z+1);return X}e.matchesCamelCase=r;function c(ae,N,$=!1){if(!N||N.length===0)return null;let X=null,Z=0;for(ae=ae.toLowerCase(),N=N.toLowerCase();Z<N.length&&(X=m(ae,N,0,Z,$))===null;)Z=f(N,Z+1);return X}e.matchesWords=c;function m(ae,N,$,X,Z){if($===ae.length)return[];if(X===N.length)return null;if(E(ae.charCodeAt($),N.charCodeAt(X))){let he=null,Se=X+1;if(he=m(ae,N,$+1,X+1,Z),!Z)for(;!he&&(Se=f(N,Se))<N.length;)he=m(ae,N,$+1,Se,Z),Se++;return he?ae.charCodeAt($)!==N.charCodeAt(X)?he:d({start:X,end:X+1},he):null}else return null}function f(ae,N){for(let $=N;$<ae.length;$++)if(I(ae.charCodeAt($))||$>0&&I(ae.charCodeAt($-1)))return $;return ae.length}const i=l(e.matchesPrefix,r,P),s=l(e.matchesPrefix,r,T),u=new a.LRUCache(1e4);function b(ae,N,$=!1){if(typeof ae!="string"||typeof N!="string")return null;let X=u.get(ae);X||(X=new RegExp(A.convertSimple2RegExpPattern(ae),"i"),u.set(ae,X));const Z=X.exec(N);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:$?s(ae,N):i(ae,N)}e.matchesFuzzy=b;function g(ae,N){const $=ge(ae,ae.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?j($):null}e.matchesFuzzy2=g;function L(ae,N,$,X,Z,he){const Se=Math.min(13,ae.length);for(;$<Se;$++){const Re=ge(ae,N,$,X,Z,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Re)return Re}return[0,he]}e.anyScore=L;function j(ae){if(typeof ae>"u")return[];const N=[],$=ae[1];for(let X=ae.length-1;X>1;X--){const Z=ae[X]+$,he=N[N.length-1];he&&he.end===Z?he.end=Z+1:N.push({start:Z,end:Z+1})}return N}e.createMatches=j;const G=128;function Q(){const ae=[],N=[];for(let $=0;$<=G;$++)N[$]=0;for(let $=0;$<=G;$++)ae.push(N.slice(0));return ae}function B(ae){const N=[];for(let $=0;$<=ae;$++)N[$]=0;return N}const U=B(2*G),z=B(2*G),M=Q(),x=Q(),fe=Q(),re=!1;function V(ae,N,$,X,Z){function he(Re,we,Te=" "){for(;Re.length<we;)Re=Te+Re;return Re}let Se=` |   |${X.split("").map(Re=>he(Re,3)).join("|")}
`;for(let Re=0;Re<=$;Re++)Re===0?Se+=" |":Se+=`${N[Re-1]}|`,Se+=ae[Re].slice(0,Z+1).map(we=>he(we.toString(),3)).join("|")+`
`;return Se}function _(ae,N,$,X){ae=ae.substr(N),$=$.substr(X),console.log(V(x,ae,ae.length,$,$.length)),console.log(V(fe,ae,ae.length,$,$.length)),console.log(V(M,ae,ae.length,$,$.length))}function te(ae,N){if(N<0||N>=ae.length)return!1;const $=ae.codePointAt(N);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise($)}}function ve(ae,N){if(N<0||N>=ae.length)return!1;switch(ae.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function le(ae,N,$){return N[ae]!==$[ae]}function ue(ae,N,$,X,Z,he,Se=!1){for(;N<$&&Z<he;)ae[N]===X[Z]&&(Se&&(U[N]=Z),N+=1),Z+=1;return N===$}e.isPatternInWord=ue;var q;(function(ae){ae[ae.Diag=1]="Diag",ae[ae.Left=2]="Left",ae[ae.LeftLeft=3]="LeftLeft"})(q||(q={}));var F;(function(ae){ae.Default=[-100,0];function N($){return!$||$.length===2&&$[0]===-100&&$[1]===0}ae.isDefault=N})(F=e.FuzzyScore||(e.FuzzyScore={}));class J{constructor(N,$){this.firstMatchCanBeWeak=N,this.boostFullMatch=$}}J.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=J;function ge(ae,N,$,X,Z,he,Se=J.default){const Re=ae.length>G?G:ae.length,we=X.length>G?G:X.length;if($>=Re||he>=we||Re-$>we-he||!ue(N,$,Re,Z,he,we,!0))return;Ee(Re,we,$,he,N,Z);let Te=1,ke=1,je=$,We=he;const tt=[!1];for(Te=1,je=$;je<Re;Te++,je++){const it=U[je],W=z[je],Y=je+1<Re?z[je+1]:we;for(ke=it-he+1,We=it;We<Y;ke++,We++){let me=Number.MIN_SAFE_INTEGER,Le=!1;We<=W&&(me=ie(ae,N,je,$,X,Z,We,we,he,M[Te-1][ke-1]===0,tt));let Ne=0;me!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=me+x[Te-1][ke-1]);const xe=We>it,Qe=xe?x[Te][ke-1]+(M[Te][ke-1]>0?-5:0):0,Xe=We>it+1&&M[Te][ke-1]>0,rt=Xe?x[Te][ke-2]+(M[Te][ke-2]>0?-5:0):0;if(Xe&&(!xe||rt>=Qe)&&(!Le||rt>=Ne))x[Te][ke]=rt,fe[Te][ke]=3,M[Te][ke]=0;else if(xe&&(!Le||Qe>=Ne))x[Te][ke]=Qe,fe[Te][ke]=2,M[Te][ke]=0;else if(Le)x[Te][ke]=Ne,fe[Te][ke]=1,M[Te][ke]=M[Te-1][ke-1]+1;else throw new Error("not possible")}}if(re&&_(ae,$,X,he),!tt[0]&&!Se.firstMatchCanBeWeak)return;Te--,ke--;const Ye=[x[Te][ke],he];let nt=0,st=0;for(;Te>=1;){let it=ke;do{const W=fe[Te][it];if(W===3)it=it-2;else if(W===2)it=it-1;else break}while(it>=1);nt>1&&N[$+Te-1]===Z[he+ke-1]&&!le(it+he-1,X,Z)&&nt+1>M[Te][it]&&(it=ke),it===ke?nt++:nt=1,st||(st=it),Te--,ke=it-1,Ye.push(ke)}we===Re&&Se.boostFullMatch&&(Ye[0]+=2);const Be=st-Re;return Ye[0]-=Be,Ye}e.fuzzyScore=ge;function Ee(ae,N,$,X,Z,he){let Se=ae-1,Re=N-1;for(;Se>=$&&Re>=X;)Z[Se]===he[Re]&&(z[Se]=Re,Se--),Re--}function ie(ae,N,$,X,Z,he,Se,Re,we,Te,ke){if(N[$]!==he[Se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return Se===$-X?je=ae[$]===Z[Se]?7:5:le(Se,Z,he)&&(Se===0||!le(Se-1,Z,he))?(je=ae[$]===Z[Se]?7:5,We=!0):te(he,Se)&&(Se===0||!te(he,Se-1))?je=5:(te(he,Se-1)||ve(he,Se-1))&&(je=5,We=!0),je>1&&$===X&&(ke[0]=!0),We||(We=le(Se,Z,he)||te(he,Se-1)||ve(he,Se-1)),$===X?Se>we&&(je-=We?3:5):Te?je+=We?2:0:je+=We?0:1,Se+1===Re&&(je-=We?3:5),je}function ne(ae,N,$,X,Z,he,Se){return ee(ae,N,$,X,Z,he,!0,Se)}e.fuzzyScoreGracefulAggressive=ne;function de(ae,N,$,X,Z,he,Se){return ee(ae,N,$,X,Z,he,!1,Se)}e.fuzzyScoreGraceful=de;function ee(ae,N,$,X,Z,he,Se,Re){let we=ge(ae,N,$,X,Z,he,Re);if(we&&!Se)return we;if(ae.length>=3){const Te=Math.min(7,ae.length-1);for(let ke=$+1;ke<Te;ke++){const je=ce(ae,ke);if(je){const We=ge(je,je.toLowerCase(),$,X,Z,he,Re);We&&(We[0]-=3,(!we||We[0]>we[0])&&(we=We))}}}return we}function ce(ae,N){if(N+1>=ae.length)return;const $=ae[N],X=ae[N+1];if($!==X)return ae.slice(0,N)+X+$+ae.slice(N+2)}}),define(Ie[68],Ce([1,0,9]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return l(d,0)}e.hash=A;function l(d,h){switch(typeof d){case"object":return d===null?R(349,h):Array.isArray(d)?D(d,h):v(d,h);case"string":return T(d,h);case"boolean":return P(d,h);case"number":return R(d,h);case"undefined":return R(937,h);default:return R(617,h)}}e.doHash=l;function R(d,h){return(h<<5)-h+d|0}e.numberHash=R;function P(d,h){return R(d?433:863,h)}function T(d,h){h=R(149417,h);for(let w=0,y=d.length;w<y;w++)h=R(d.charCodeAt(w),h);return h}e.stringHash=T;function D(d,h){return h=R(104579,h),d.reduce((w,y)=>l(y,w),h)}function v(d,h){return h=R(181387,h),Object.keys(d).sort().reduce((w,y)=>(w=T(y,w),l(d[y],w)),h)}class O{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=l(h,this.g),this.g}}e.Hasher=O;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(d,h,w=32){const y=w-h,p=~((1<<y)-1);return(d<<h|(p&d)>>>y)>>>0}function C(d,h=0,w=d.byteLength,y=0){for(let p=0;p<w;p++)d[h+p]=y}function I(d,h,w="0"){for(;d.length<h;)d=w+d;return d}function E(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):I((d>>>0).toString(16),h/4)}e.toHexString=E;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const w=h.length;if(w===0)return;const y=this.p;let p=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=h.charCodeAt(0),r=0);;){let c=o;if(a.isHighSurrogate(o))if(r+1<w){const m=h.charCodeAt(r+1);a.isLowSurrogate(m)?(r++,c=a.computeCodePoint(o,m)):c=65533}else{t=o;break}else a.isLowSurrogate(o)&&(c=65533);if(p=this.w(y,p,c),r++,r<w)o=h.charCodeAt(r);else break}this.r=p,this.u=t}w(h,w,y){return y<128?h[w++]=y:y<2048?(h[w++]=192|(y&1984)>>>6,h[w++]=128|(y&63)>>>0):y<65536?(h[w++]=224|(y&61440)>>>12,h[w++]=128|(y&4032)>>>6,h[w++]=128|(y&63)>>>0):(h[w++]=240|(y&1835008)>>>18,h[w++]=128|(y&258048)>>>12,h[w++]=128|(y&4032)>>>6,h[w++]=128|(y&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=n.g,w=this.q;for(let i=0;i<64;i+=4)h.setUint32(i,w.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)h.setUint32(i,S(h.getUint32(i-12,!1)^h.getUint32(i-32,!1)^h.getUint32(i-56,!1)^h.getUint32(i-64,!1),1),!1);let y=this.h,p=this.l,t=this.m,o=this.n,r=this.o,c,m,f;for(let i=0;i<80;i++)i<20?(c=p&t|~p&o,m=1518500249):i<40?(c=p^t^o,m=1859775393):i<60?(c=p&t|p&o|t&o,m=2400959708):(c=p^t^o,m=3395469782),f=S(y,5)+c+r+m+h.getUint32(i*4,!1)&4294967295,r=o,o=t,t=S(p,30),p=y,y=f;this.h=this.h+y&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}n.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=n}),define(Ie[112],Ce([1,0,109,111,68,15,14,9]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,v=[D,[]];function O(M,x,fe,re){if(!M||!x)return v;const V=M.length,_=x.length;if(V<_)return v;const te=M.toLowerCase();return k(x,fe,_,M,te,V,re)}e.scoreFuzzy=O;function k(M,x,fe,re,V,_,te){const ve=[],le=[];for(let J=0;J<fe;J++){const ge=J*_,Ee=ge-_,ie=J>0,ne=M[J],de=x[J];for(let ee=0;ee<_;ee++){const ce=ee>0,ae=ge+ee,N=ae-1,$=Ee+ee-1,X=ce?ve[N]:0,Z=ie&&ce?ve[$]:0,he=ie&&ce?le[$]:0;let Se;!Z&&ie?Se=0:Se=S(ne,de,re,V,ee,he),Se&&Z+Se>=X&&(te||ie||V.startsWith(x,ee))?(le[ae]=he+1,ve[ae]=Z+Se):(le[ae]=D,ve[ae]=X)}}const ue=[];let q=fe-1,F=_-1;for(;q>=0&&F>=0;){const J=q*_+F;le[J]===D||(ue.push(F),q--),F--}return[ve[fe*_-1],ue.reverse()]}function S(M,x,fe,re,V,_){let te=0;if(!C(x,re[V]))return te;if(te+=1,_>0&&(te+=_*5),M===fe[V]&&(te+=1),V===0)te+=8;else{const ve=I(fe.charCodeAt(V-1));ve?te+=ve:(0,A.isUpper)(fe.charCodeAt(V))&&_===0&&(te+=2)}return te}function C(M,x){return M===x?!0:M==="/"||M==="\\"?x==="/"||x==="\\":!1}function I(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function n(M,x,fe=0,re=0){const V=x;return V.values&&V.values.length>1?d(M,V.values,fe,re):h(M,x,fe,re)}e.scoreFuzzy2=n;function d(M,x,fe,re){let V=0;const _=[];for(const te of x){const[ve,le]=h(M,te,fe,re);if(typeof ve!="number")return E;V+=ve,_.push(...le)}return[V,s(_)]}function h(M,x,fe,re){const V=(0,A.fuzzyScore)(x.original,x.originalLowercase,fe,M,M.toLowerCase(),re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,A.createMatches)(V)]:E}const w=Object.freeze({score:0}),y=1<<18,p=1<<17,t=1<<16;function o(M,x,fe,re){const V=re.values?re.values:[re];return(0,l.hash)({[re.normalized]:{values:V.map(te=>({value:te.normalized,expectContiguousMatch:te.expectContiguousMatch})),label:M,description:x,allowNonContiguousMatches:fe}})}function r(M,x,fe,re,V){if(!M||!x.normalized)return w;const _=re.getItemLabel(M);if(!_)return w;const te=re.getItemDescription(M),ve=o(_,te,fe,x),le=V[ve];if(le)return le;const ue=c(_,te,re.getItemPath(M),x,fe);return V[ve]=ue,ue}e.scoreItemFuzzy=r;function c(M,x,fe,re,V){const _=!fe||!re.containsPathSeparator;return fe&&(P.isLinux?re.pathNormalized===fe:(0,T.equalsIgnoreCase)(re.pathNormalized,fe))?{score:y,labelMatch:[{start:0,end:M.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:re.values&&re.values.length>1?m(M,x,fe,re.values,_,V):f(M,x,fe,re,_,V)}function m(M,x,fe,re,V,_){let te=0;const ve=[],le=[];for(const ue of re){const{score:q,labelMatch:F,descriptionMatch:J}=f(M,x,fe,ue,V,_);if(q===D)return w;te+=q,F&&ve.push(...F),J&&le.push(...J)}return{score:te,labelMatch:s(ve),descriptionMatch:s(le)}}function f(M,x,fe,re,V,_){if(V||!x){const[te,ve]=O(M,re.normalized,re.normalizedLowercase,_&&!re.expectContiguousMatch);if(te){const le=(0,A.matchesPrefix)(re.normalized,M);let ue;return le?(ue=p,ue+=Math.round(re.normalized.length/M.length*100)):ue=t,{score:ue+te,labelMatch:le||i(ve)}}}if(x){let te=x;fe&&(te=`${x}${R.sep}`);const ve=te.length,le=`${te}${M}`,[ue,q]=O(le,re.normalized,re.normalizedLowercase,_&&!re.expectContiguousMatch);if(ue){const F=i(q),J=[],ge=[];return F.forEach(Ee=>{Ee.start<ve&&Ee.end>ve?(J.push({start:0,end:Ee.end-ve}),ge.push({start:Ee.start,end:ve})):Ee.start>=ve?J.push({start:Ee.start-ve,end:Ee.end-ve}):ge.push(Ee)}),{score:ue,labelMatch:J,descriptionMatch:ge}}}return w}function i(M){const x=[];if(!M)return x;let fe;for(const re of M)fe&&fe.end===re?fe.end+=1:(fe={start:re,end:re+1},x.push(fe));return x}function s(M){const x=M.sort((V,_)=>V.start-_.start),fe=[];let re;for(const V of x)!re||!u(re,V)?(re=V,fe.push(V)):(re.start=Math.min(re.start,V.start),re.end=Math.max(re.end,V.end));return fe}function u(M,x){return!(M.end<x.start||x.end<M.start)}function b(M,x,fe,re,V,_){const te=r(M,fe,re,V,_),ve=r(x,fe,re,V,_),le=te.score,ue=ve.score;if((le===y||ue===y)&&le!==ue)return le===y?-1:1;if(le>t||ue>t){if(le!==ue)return le>ue?-1:1;if(le<p&&ue<p){const ne=L(te.labelMatch,ve.labelMatch);if(ne!==0)return ne}const Ee=V.getItemLabel(M)||"",ie=V.getItemLabel(x)||"";if(Ee.length!==ie.length)return Ee.length-ie.length}if(le!==ue)return le>ue?-1:1;const q=Array.isArray(te.labelMatch)&&te.labelMatch.length>0,F=Array.isArray(ve.labelMatch)&&ve.labelMatch.length>0;if(q&&!F)return-1;if(F&&!q)return 1;const J=g(M,te,V),ge=g(x,ve,V);return J&&ge&&J!==ge?ge>J?-1:1:j(M,x,fe,V)}e.compareItemsByFuzzyScore=b;function g(M,x,fe){let re=-1,V=-1;if(x.descriptionMatch&&x.descriptionMatch.length?re=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(re=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(V=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const _=fe.getItemDescription(M);_&&(V+=_.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(V=x.descriptionMatch[x.descriptionMatch.length-1].end);return V-re}function L(M,x){if(!M&&!x||(!M||!M.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!M||!M.length)return 1;const fe=M[0].start,V=M[M.length-1].end-fe,_=x[0].start,ve=x[x.length-1].end-_;return V===ve?0:ve<V?1:-1}function j(M,x,fe,re){const V=re.getItemLabel(M)||"",_=re.getItemLabel(x)||"",te=re.getItemDescription(M),ve=re.getItemDescription(x),le=V.length+(te?te.length:0),ue=_.length+(ve?ve.length:0);if(le!==ue)return le-ue;const q=re.getItemPath(M),F=re.getItemPath(x);return q&&F&&q.length!==F.length?q.length-F.length:V!==_?(0,a.compareAnything)(V,_,fe.normalized):te&&ve&&te!==ve?(0,a.compareAnything)(te,ve,fe.normalized):q&&F&&q!==F?(0,a.compareAnything)(q,F,fe.normalized):0}function G(M){return M.startsWith('"')&&M.endsWith('"')}const Q=" ";function B(M){typeof M!="string"&&(M="");const x=M.toLowerCase(),{pathNormalized:fe,normalized:re,normalizedLowercase:V}=U(M),_=fe.indexOf(R.sep)>=0,te=G(M);let ve;const le=M.split(Q);if(le.length>1)for(const ue of le){const q=G(ue),{pathNormalized:F,normalized:J,normalizedLowercase:ge}=U(ue);J&&(ve||(ve=[]),ve.push({original:ue,originalLowercase:ue.toLowerCase(),pathNormalized:F,normalized:J,normalizedLowercase:ge,expectContiguousMatch:q}))}return{original:M,originalLowercase:x,pathNormalized:fe,normalized:re,normalizedLowercase:V,values:ve,containsPathSeparator:_,expectContiguousMatch:te}}e.prepareQuery=B;function U(M){let x;P.isWindows?x=M.replace(/\//g,R.sep):x=M.replace(/\\/g,R.sep);const fe=(0,T.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function z(M){return Array.isArray(M)?B(M.map(x=>x.original).join(Q)):B(M.original)}e.pieceToQuery=z}),define(Ie[165],Ce([1,0,111,9,52]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",P=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${P.source}`,"g");function D(d){return d.replace(T,(h,w)=>w?h:`\\${h}`)}e.escapeIcons=D;const v=new RegExp(`\\\\${P.source}`,"g");function O(d){return d.replace(v,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=O;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(d){return d.indexOf(R)===-1?d:d.replace(k,(h,w,y,p)=>y?h:w||p||"")}e.stripIcons=S;function C(d){return d?d.replace(/\$\((.*?)\)/g,(h,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=C;const I=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(d){I.lastIndex=0;let h="";const w=[];let y=0;for(;;){const p=I.lastIndex,t=I.exec(d),o=d.substring(p,t?.index);if(o.length>0){h+=o;for(let r=0;r<o.length;r++)w.push(y)}if(!t)break;y+=t[0].length}return{text:h,iconOffsets:w}}e.parseLabelWithIcons=E;function n(d,h,w=!1){const{text:y,iconOffsets:p}=h;if(!p||p.length===0)return(0,a.matchesFuzzy)(d,y,w);const t=(0,A.ltrim)(y," "),o=y.length-t.length,r=(0,a.matchesFuzzy)(d,t,w);if(r)for(const c of r){const m=p[c.start+o]+o;c.start+=m,c.end+=m}return r}e.matchesFuzzyIconAware=n}),define(Ie[38],Ce([1,0,9]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const R="error",P="warning",T="warn",D="info",v="ignore";function O(S){return S?a.equalsIgnoreCase(R,S)?l.Error:a.equalsIgnoreCase(P,S)||a.equalsIgnoreCase(T,S)?l.Warning:a.equalsIgnoreCase(D,S)?l.Info:l.Ignore:l.Ignore}l.fromValue=O;function k(S){switch(S){case l.Error:return R;case l.Warning:return P;case l.Info:return D;default:return v}}l.toString=k}(A||(A={})),e.default=A}),define(Ie[69],Ce([1,0,17,9]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const I=C.charCodeAt(0),E=this.b.charCodeAt(this.c);return I-E}value(){return this.b[this.c]}}e.StringIterator=l;class R{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,A.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class P{constructor(C=!0,I=!0){this.f=C,this.g=I}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let I=C.length-1;I>=0;I--,this.c--){const E=this.b.charCodeAt(I);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const I=this.b.charCodeAt(this.e);if(I===47||this.f&&I===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,A.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=P;var T;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(T||(T={}));class D{constructor(C,I){this.f=C,this.g=I,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,A.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=D;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(O||(O={}));class k{static forUris(C=()=>!1,I=()=>!1){return new k(new D(C,I))}static forPaths(C=!1){return new k(new P(void 0,!C))}static forStrings(){return new k(new l)}static forConfigKeys(){return new k(new R)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,I){if(I){const E=I.slice(0);(0,a.shuffle)(E);for(const n of E)this.set(n,C)}else{const E=C.slice(0);(0,a.shuffle)(E);for(const n of E)this.set(n[0],n[1])}}set(C,I){const E=this.b.reset(C);let n;this.c||(this.c=new v,this.c.segment=E.value());const d=[];for(n=this.c;;){const w=E.cmp(n.segment);if(w>0)n.left||(n.left=new v,n.left.segment=E.value()),d.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new v,n.right.segment=E.value()),d.push([1,n]),n=n.right;else if(E.hasNext())E.next(),n.mid||(n.mid=new v,n.mid.segment=E.value()),d.push([0,n]),n=n.mid;else break}const h=n.value;n.value=I,n.key=C;for(let w=d.length-1;w>=0;w--){const y=d[w][1];y.updateHeight();const p=y.balanceFactor();if(p<-1||p>1){const t=d[w][0],o=d[w+1][0];if(t===1&&o===1)d[w][1]=y.rotateLeft();else if(t===-1&&o===-1)d[w][1]=y.rotateRight();else if(t===1&&o===-1)y.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=y.rotateLeft();else if(t===-1&&o===1)y.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=y.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this.c=d[0][1]}}return h}get(C){return this.d(C)?.value}d(C){const I=this.b.reset(C);let E=this.c;for(;E;){const n=I.cmp(E.segment);if(n>0)E=E.left;else if(n<0)E=E.right;else if(I.hasNext())I.next(),E=E.mid;else break}return E}has(C){const I=this.d(C);return!(I?.value===void 0&&I?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,I){const E=this.b.reset(C),n=[];let d=this.c;for(;d;){const h=E.cmp(d.segment);if(h>0)n.push([-1,d]),d=d.left;else if(h<0)n.push([1,d]),d=d.right;else if(E.hasNext())E.next(),n.push([0,d]),d=d.mid;else break}if(!!d){if(I?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:w,value:y,segment:p}=h;this.e(h.key,!1),d.key=w,d.value=y,d.segment=p}}else{const h=d.left??d.right;if(n.length>0){const[w,y]=n[n.length-1];switch(w){case-1:y.left=h;break;case 0:y.mid=h;break;case 1:y.right=h;break}}else this.c=h}for(let h=n.length-1;h>=0;h--){const w=n[h][1];w.updateHeight();const y=w.balanceFactor();if(y>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[h][1]=w.rotateLeft()):y<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[h][1]=w.rotateRight()),h>0)switch(n[h-1][0]){case-1:n[h-1][1].left=n[h][1];break;case 1:n[h-1][1].right=n[h][1];break;case 0:n[h-1][1].mid=n[h][1];break}else this.c=n[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const I=this.b.reset(C);let E=this.c,n;for(;E;){const d=I.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(I.hasNext())I.next(),n=E.value||n,E=E.mid;else break}return E&&E.value||n}findSuperstr(C){return this.g(C,!1)}g(C,I){const E=this.b.reset(C);let n=this.c;for(;n;){const d=E.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(E.hasNext())E.next(),n=n.mid;else return n.mid?this.h(n.mid):I?n.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[I,E]of this)C(E,I)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const I=[];return this.j(C,I),I[Symbol.iterator]()}j(C,I){!C||(C.left&&this.j(C.left,I),C.value&&I.push([C.key,C.value]),C.mid&&this.j(C.mid,I),C.right&&this.j(C.right,I))}_isBalanced(){const C=I=>{if(!I)return!0;const E=I.balanceFactor();return E<-1||E>1?!1:C(I.left)&&C(I.right)};return C(this.c)}}e.TernarySearchTree=k}),define(Ie[2],Ce([1,0,15,14]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function T(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,c){return!r&&!c?"file":r}function v(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==k&&(c=k+c):c=k;break}return c}const O="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(c){return c instanceof C?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,m,f,i,s,u=!1){typeof c=="object"?(this.scheme=c.scheme||O,this.authority=c.authority||O,this.path=c.path||O,this.query=c.query||O,this.fragment=c.fragment||O):(this.scheme=D(c,u),this.authority=m||O,this.path=v(this.scheme,f||O),this.query=i||O,this.fragment=s||O,T(this,u))}get fsPath(){return w(this,!1)}with(c){if(!c)return this;let{scheme:m,authority:f,path:i,query:s,fragment:u}=c;return m===void 0?m=this.scheme:m===null&&(m=O),f===void 0?f=this.authority:f===null&&(f=O),i===void 0?i=this.path:i===null&&(i=O),s===void 0?s=this.query:s===null&&(s=O),u===void 0?u=this.fragment:u===null&&(u=O),m===this.scheme&&f===this.authority&&i===this.path&&s===this.query&&u===this.fragment?this:new E(m,f,i,s,u)}static parse(c,m=!1){const f=S.exec(c);return f?new E(f[2]||O,o(f[4]||O),o(f[5]||O),o(f[7]||O),o(f[9]||O),m):new E(O,O,O,O,O)}static file(c){let m=O;if(A.isWindows&&(c=c.replace(/\\/g,k)),c[0]===k&&c[1]===k){const f=c.indexOf(k,2);f===-1?(m=c.substring(2),c=k):(m=c.substring(2,f),c=c.substring(f)||k)}return new E("file",m,c,O,O)}static from(c){const m=new E(c.scheme,c.authority,c.path,c.query,c.fragment);return T(m,!0),m}static joinPath(c,...m){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return A.isWindows&&c.scheme==="file"?f=C.file(a.win32.join(w(c,!0),...m)).path:f=a.posix.join(c.path,...m),c.with({path:f})}toString(c=!1){return y(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof C)return c;{const m=new E(c);return m._formatted=c.external,m._fsPath=c._sep===I?c.fsPath:null,m}}else return c}}e.URI=C;const I=A.isWindows?1:void 0;class E extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(c=!1){return c?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=I),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,c,m){let f,i=-1;for(let s=0;s<r.length;s++){const u=r.charCodeAt(s);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||c&&u===47||m&&u===91||m&&u===93||m&&u===58)i!==-1&&(f+=encodeURIComponent(r.substring(i,s)),i=-1),f!==void 0&&(f+=r.charAt(s));else{f===void 0&&(f=r.substr(0,s));const b=n[u];b!==void 0?(i!==-1&&(f+=encodeURIComponent(r.substring(i,s)),i=-1),f+=b):i===-1&&(i=s)}}return i!==-1&&(f+=encodeURIComponent(r.substring(i))),f!==void 0?f:r}function h(r){let c;for(let m=0;m<r.length;m++){const f=r.charCodeAt(m);f===35||f===63?(c===void 0&&(c=r.substr(0,m)),c+=n[f]):c!==void 0&&(c+=r[m])}return c!==void 0?c:r}function w(r,c){let m;return r.authority&&r.path.length>1&&r.scheme==="file"?m=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?m=r.path.substr(1):m=r.path[1].toLowerCase()+r.path.substr(2):m=r.path,A.isWindows&&(m=m.replace(/\//g,"\\")),m}e.uriToFsPath=w;function y(r,c){const m=c?h:d;let f="",{scheme:i,authority:s,path:u,query:b,fragment:g}=r;if(i&&(f+=i,f+=":"),(s||i==="file")&&(f+=k,f+=k),s){let L=s.indexOf("@");if(L!==-1){const j=s.substr(0,L);s=s.substr(L+1),L=j.lastIndexOf(":"),L===-1?f+=m(j,!1,!1):(f+=m(j.substr(0,L),!1,!1),f+=":",f+=m(j.substr(L+1),!1,!0)),f+="@"}s=s.toLowerCase(),L=s.lastIndexOf(":"),L===-1?f+=m(s,!1,!0):(f+=m(s.substr(0,L),!1,!0),f+=s.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}f+=m(u,!0,!1)}return b&&(f+="?",f+=m(b,!1,!1)),g&&(f+="#",f+=c?g:d(g,!1,!1)),f}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(t)?r.replace(t,c=>p(c)):r}}),define(Ie[70],Ce([1,0,22,9,2]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(v){return JSON.stringify(v,T)}e.stringify=R;function P(v){let O=JSON.parse(v);return O=D(O),O}e.parse=P;function T(v,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,A.regExpFlags)(O)}:O}function D(v,O=0){if(!v||O>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return l.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof a.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let k=0;k<v.length;++k)v[k]=D(v[k],O+1);else for(const k in v)Object.hasOwnProperty.call(v,k)&&(v[k]=D(v[k],O+1))}return v}e.revive=D}),define(Ie[18],Ce([1,0,8,14,2]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${R.vscodeRemoteResource}`}set(O,k,S){this.a[O]=k,this.b[O]=S}setConnectionToken(O,k){this.c[O]=k}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(n){return a.onUnexpectedError(n),O}const k=O.authority;let S=this.a[k];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const C=this.b[k],I=this.c[k];let E=`path=${encodeURIComponent(O.path)}`;return typeof I=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),l.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${S}:${C}`,path:this.f,query:E})}}e.RemoteAuthorities=new P,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(O){const k=this.b(O,se);return this.uriToBrowserUri(k)}uriToBrowserUri(O){return O.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${T.a}`)?O.with({scheme:R.vscodeFileResource,authority:O.authority||T.a,query:null,fragment:null}):O}asFileUri(O){const k=this.b(O,se);return this.uriToFileUri(k)}uriToFileUri(O){return O.scheme===R.vscodeFileResource?O.with({scheme:R.file,authority:O.authority!==T.a?O.authority:null,query:null,fragment:null}):O}b(O,k){return l.URI.isUri(O)?O:l.URI.parse(k.toUrl(O))}}T.a="vscode-app",e.FileAccess=new T;var D;(function(v){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(O.get("3"));const k="vscode-coi";function S(I){let E;typeof I=="string"?E=new URL(I).searchParams:I instanceof URL?E=I.searchParams:l.URI.isUri(I)&&(E=new URL(I.toString(!0)).searchParams);const n=E?.get(k);if(!!n)return O.get(n)}v.getHeadersFromQuery=S;function C(I,E,n){if(!globalThis.crossOriginIsolated)return;const d=E&&n?"3":n?"2":"1";I instanceof URLSearchParams?I.set(k,d):I[k]=d}v.addSearchParam=C})(D=e.COI||(e.COI={}))}),define(Ie[24],Ce([1,0,33,18,15,14,9,2]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(C){return(0,T.uriToFsPath)(C,!0)}e.originalFSPath=D;class v{constructor(I){this.a=I}compare(I,E,n=!1){return I===E?0:(0,P.compare)(this.getComparisonKey(I,n),this.getComparisonKey(E,n))}isEqual(I,E,n=!1){return I===E?!0:!I||!E?!1:this.getComparisonKey(I,n)===this.getComparisonKey(E,n)}getComparisonKey(I,E=!1){return I.with({path:this.a(I)?I.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(I){return this.a(I)}isEqualOrParent(I,E,n=!1){if(I.scheme===E.scheme){if(I.scheme===A.Schemas.file)return a.isEqualOrParent(D(I),D(E),this.a(I))&&I.query===E.query&&(n||I.fragment===E.fragment);if((0,e.isEqualAuthority)(I.authority,E.authority))return a.isEqualOrParent(I.path,E.path,this.a(I),"/")&&I.query===E.query&&(n||I.fragment===E.fragment)}return!1}joinPath(I,...E){return T.URI.joinPath(I,...E)}basenameOrAuthority(I){return(0,e.basename)(I)||I.authority}basename(I){return l.posix.basename(I.path)}extname(I){return l.posix.extname(I.path)}dirname(I){if(I.path.length===0)return I;let E;return I.scheme===A.Schemas.file?E=T.URI.file(l.dirname(D(I))).path:(E=l.posix.dirname(I.path),I.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${I.toString})) resulted in a relative path`),E="/")),I.with({path:E})}normalizePath(I){if(!I.path.length)return I;let E;return I.scheme===A.Schemas.file?E=T.URI.file(l.normalize(D(I))).path:E=l.posix.normalize(I.path),I.with({path:E})}relativePath(I,E){if(I.scheme!==E.scheme||!(0,e.isEqualAuthority)(I.authority,E.authority))return;if(I.scheme===A.Schemas.file){const h=l.relative(D(I),D(E));return R.isWindows?a.toSlashes(h):h}let n=I.path||"/";const d=E.path||"/";if(this.a(I)){let h=0;for(const w=Math.min(n.length,d.length);h<w&&!(n.charCodeAt(h)!==d.charCodeAt(h)&&n.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);n=d.substr(0,h)+n.substr(h)}return l.posix.relative(n,d)}resolvePath(I,E){if(I.scheme===A.Schemas.file){const n=T.URI.file(l.resolve(D(I),E));return I.with({authority:n.authority,path:n.path})}return E=a.toPosixPath(E),I.with({path:l.posix.resolve(I.path,E)})}isAbsolutePath(I){return!!I.path&&I.path[0]==="/"}isEqualAuthority(I,E){return I===E||I!==void 0&&E!==void 0&&(0,P.equalsIgnoreCase)(I,E)}hasTrailingPathSeparator(I,E=l.sep){if(I.scheme===A.Schemas.file){const n=D(I);return n.length>a.getRoot(n).length&&n[n.length-1]===E}else{const n=I.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(I.fsPath)}}removeTrailingPathSeparator(I,E=l.sep){return(0,e.hasTrailingPathSeparator)(I,E)?I.with({path:I.path.substr(0,I.path.length-1)}):I}addTrailingPathSeparator(I,E=l.sep){let n=!1;if(I.scheme===A.Schemas.file){const d=D(I);n=d!==void 0&&d.length===a.getRoot(d).length&&d[d.length-1]===E}else{E="/";const d=I.path;n=d.length===1&&d.charCodeAt(d.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(I,E)?I.with({path:I.path+"/"}):I}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(C=>C.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new v(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(C,I){const E=[];for(let n=0;n<C.length;n++){const d=I(C[n]);C.some((h,w)=>w===n?!1:(0,e.isEqualOrParent)(d,I(h)))||E.push(C[n])}return E}e.distinctParents=O;var k;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function I(E){const n=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(w=>{const[y,p]=w.split(":");y&&p&&n.set(y,p)});const h=E.path.substring(0,E.path.indexOf(";"));return h&&n.set(C.META_DATA_MIME,h),n}C.parseMetaData=I})(k=e.DataUri||(e.DataUri={}));function S(C,I,E){if(I){let n=C.path;return n&&n[0]!==l.posix.sep&&(n=l.posix.sep+n),C.with({scheme:E,authority:I,path:n})}return C.with({scheme:E})}e.toLocalResource=S}),define(Ie[19],Ce([1,0,21,8,3,6,24,14,149]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=v;function O(ue){const q=new a.CancellationTokenSource,F=ue(q.token),J=new Promise((ge,Ee)=>{const ie=q.token.onCancellationRequested(()=>{ie.dispose(),q.dispose(),Ee(new A.CancellationError)});Promise.resolve(F).then(ne=>{ie.dispose(),q.dispose(),ge(ne)},ne=>{ie.dispose(),q.dispose(),Ee(ne)})});return new class{cancel(){q.cancel()}then(ge,Ee){return J.then(ge,Ee)}catch(ge){return this.then(void 0,ge)}finally(ge){return J.finally(ge)}}}e.createCancelablePromise=O;function k(ue,q,F){return new Promise((J,ge)=>{const Ee=q.onCancellationRequested(()=>{Ee.dispose(),J(F)});ue.then(J,ge).finally(()=>Ee.dispose())})}e.raceCancellation=k;function S(ue,q){return new Promise((F,J)=>{const ge=q.onCancellationRequested(()=>{ge.dispose(),J(new A.CancellationError)});ue.then(F,J).finally(()=>ge.dispose())})}e.raceCancellationError=S;async function C(ue){let q=-1;const F=ue.map((ge,Ee)=>ge.then(ie=>(q=Ee,ie))),J=await Promise.race(F);return ue.forEach((ge,Ee)=>{Ee!==q&&ge.cancel()}),J}e.raceCancellablePromises=C;function I(ue,q,F){let J;const ge=setTimeout(()=>{J?.(void 0),F?.()},q);return Promise.race([ue.finally(()=>clearTimeout(ge)),new Promise(Ee=>J=Ee)])}e.raceTimeout=I;function E(ue){return new Promise((q,F)=>{const J=ue();v(J)?J.then(q,F):q(J)})}e.asPromise=E;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(q){if(this.a){if(this.d=q,!this.b){const F=()=>{this.b=null;const J=this.queue(this.d);return this.d=null,J};this.b=new Promise(J=>{this.a.then(F,F).then(J)})}return new Promise((F,J)=>{this.b.then(F,J)})}return this.a=q(),new Promise((F,J)=>{this.a.then(ge=>{this.a=null,F(ge)},ge=>{this.a=null,J(ge)})})}}e.Throttler=n;class d{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.Sequencer=d;class h{constructor(){this.a=new Map}queue(q,F){const ge=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(q)===ge&&this.a.delete(q)});return this.a.set(q,ge),ge}}e.SequencerByKey=h;const w=(ue,q)=>{let F=!0;const J=setTimeout(()=>{F=!1,q()},ue);return{isTriggered:()=>F,dispose:()=>{clearTimeout(J),F=!1}}},y=ue=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,ue())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class p{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,F=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ge,Ee)=>{this.d=ge,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const J=()=>{this.a=null,this.d?.(null)};return this.a=F===D.MicrotaskDelay?y(J):w(F,J),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(q){this.a=new p(q),this.b=new n}trigger(q,F){return this.a.trigger(()=>this.b.queue(q),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this.a=!1,this.b=new Promise((q,F)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class r extends o{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(ue,q){return q?new Promise((F,J)=>{const ge=setTimeout(()=>{Ee.dispose(),F()},ue),Ee=q.onCancellationRequested(()=>{clearTimeout(ge),Ee.dispose(),J(new A.CancellationError)})}):O(F=>c(ue,F))}e.timeout=c;function m(ue,q=0){const F=setTimeout(ue,q);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=m;function f(ue){const q=[];let F=0;const J=ue.length;function ge(){return F<J?ue[F++]():null}function Ee(ie){ie!=null&&q.push(ie);const ne=ge();return ne?ne.then(Ee):Promise.resolve(q)}return Promise.resolve(null).then(Ee)}e.sequence=f;function i(ue,q=J=>!!J,F=null){let J=0;const ge=ue.length,Ee=()=>{if(J>=ge)return Promise.resolve(F);const ie=ue[J++];return Promise.resolve(ie()).then(de=>q(de)?Promise.resolve(de):Ee())};return Ee()}e.first=i;function s(ue,q=J=>!!J,F=null){if(ue.length===0)return Promise.resolve(F);let J=ue.length;const ge=()=>{J=-1;for(const Ee of ue)Ee.cancel?.()};return new Promise((Ee,ie)=>{for(const ne of ue)ne.then(de=>{--J>=0&&q(de)?(ge(),Ee(de)):J===0&&Ee(F)}).catch(de=>{--J>=0&&(ge(),ie(de))})})}e.firstParallel=s;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((F,J)=>{this.f.push({factory:q,c:F,e:J}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const F=q.factory();F.then(q.c,q.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class b extends u{constructor(){super(1)}}e.Queue=b;class g{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const q=new re;return this.b.add(q),q.p}d(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,F=P.extUri){const J=F.getComparisonKey(q);let ge=this.a.get(J);return ge||(ge=new b,l.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.a.delete(J),this.f()}),this.a.set(J,ge)),ge}f(){!this.d()||this.g()}g(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.g()}}e.ResourceQueue=g;class L{constructor(q,F){this.a=-1,typeof q=="function"&&typeof F=="number"&&this.setIfNotSet(q,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},F)}setIfNotSet(q,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},F))}}e.TimeoutTimer=L;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,F){this.cancel(),this.a=setInterval(()=>{q()},F)}}e.IntervalTimer=j;class G{constructor(q,F){this.b=-1,this.a=q,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class Q{constructor(q,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=q,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Q;class B extends G{constructor(q,F){super(q,F),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class U extends R.Disposable{constructor(q,F){super(),this.g=q,this.h=F,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of q)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,T.setTimeout0)(()=>{if(q)return;const F=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(ue,q)=>{const F=requestIdleCallback(ue,typeof q=="number"?{timeout:q}:void 0);let J=!1;return{dispose(){J||(J=!0,cancelIdleCallback(F))}}}}();class z{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function M(ue,q,F){let J;for(let ge=0;ge<F;ge++)try{return await ue()}catch(Ee){J=Ee,await c(q)}throw J}e.retry=M;class x{hasPending(q){return this.a?typeof q=="number"?this.a.taskId===q:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(q,F,J){return this.a={taskId:q,cancel:()=>J?.(),promise:F},F.then(()=>this.d(q),()=>this.d(q)),F}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this.b)this.b.run=q;else{let F,J;const ge=new Promise((Ee,ie)=>{F=Ee,J=ie});this.b={run:q,promise:ge,promiseResolve:F,promiseReject:J}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=x;class fe{constructor(q,F=()=>Date.now()){this.d=q,this.f=F,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.IntervalCounter=fe;class re{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((q,F)=>{this.a=q,this.b=F})}complete(q){return new Promise(F=>{this.a(q),this.f=!0,F()})}error(q){return new Promise(F=>{this.b(q),this.d=!0,F()})}cancel(){new Promise(q=>{this.b(new A.CancellationError),this.d=!0,q()})}}e.DeferredPromise=re;var V;(function(ue){async function q(J){let ge;const Ee=await Promise.all(J.map(ie=>ie.then(ne=>ne,ne=>{ge||(ge=ne)})));if(typeof ge<"u")throw ge;return Ee}ue.settled=q;function F(J){return new Promise(async(ge,Ee)=>{try{await J(ge,Ee)}catch(ie){Ee(ie)}})}ue.withAsyncBody=F})(V=e.Promises||(e.Promises={}));var _;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(_||(_={}));class te{static fromArray(q){return new te(F=>{F.emitMany(q)})}static fromPromise(q){return new te(async F=>{F.emitMany(await q)})}static fromPromises(q){return new te(async F=>{await Promise.all(q.map(async J=>F.emitOne(await J)))})}static merge(q){return new te(async F=>{await Promise.all(q.map(async J=>{for await(const ge of J)F.emitOne(ge)}))})}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const F={emitOne:J=>this.g(J),emitMany:J=>this.h(J),reject:J=>this.k(J)};try{await Promise.resolve(q(F)),this.j()}catch(J){this.k(J)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(q,F){return new te(async J=>{for await(const ge of q)J.emitOne(F(ge))})}map(q){return te.map(this,q)}static filter(q,F){return new te(async J=>{for await(const ge of q)F(ge)&&J.emitOne(ge)})}filter(q){return te.filter(this,q)}static coalesce(q){return te.filter(q,F=>!!F)}coalesce(){return te.coalesce(this)}static async toPromise(q){const F=[];for await(const J of q)F.push(J);return F}toPromise(){return te.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}te.EMPTY=te.fromArray([]),e.AsyncIterableObject=te;class ve extends te{constructor(q,F){super(F),this.l=q}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ve;function le(ue){const q=new a.CancellationTokenSource,F=ue(q.token);return new ve(q,async J=>{const ge=q.token.onCancellationRequested(()=>{ge.dispose(),q.dispose(),J.reject(new A.CancellationError)});try{for await(const Ee of F){if(q.token.isCancellationRequested)return;J.emitOne(Ee)}ge.dispose(),q.dispose()}catch(Ee){ge.dispose(),q.dispose(),J.reject(Ee)}})}e.createCancelableAsyncIterable=le}),define(Ie[39],Ce([1,0,17,19,33,28,15,14,9]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",k="[^/\\\\]",S=/\//g;function C(fe,re){switch(fe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${O}|${k}+${O}${re?`|${O}${k}+`:""})*?`}}function I(fe,re){if(!fe)return[];const V=[];let _=!1,te=!1,ve="";for(const le of fe){switch(le){case re:if(!_&&!te){V.push(ve),ve="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":te=!0;break;case"]":te=!1;break}ve+=le}return ve&&V.push(ve),V}e.splitGlobAware=I;function E(fe){if(!fe)return"";let re="";const V=I(fe,e.GLOB_SPLIT);if(V.every(_=>_===e.GLOBSTAR))re=".*";else{let _=!1;V.forEach((te,ve)=>{if(te===e.GLOBSTAR){if(_)return;re+=C(2,ve===V.length-1)}else{let le=!1,ue="",q=!1,F="";for(const J of te){if(J!=="}"&&le){ue+=J;continue}if(q&&(J!=="]"||!F)){let ge;J==="-"?ge=J:(J==="^"||J==="!")&&!F?ge="^":J===e.GLOB_SPLIT?ge="":ge=(0,D.escapeRegExpCharacters)(J),F+=ge;continue}switch(J){case"{":le=!0;continue;case"[":q=!0;continue;case"}":{re+=`(?:${I(ue,",").map(ie=>E(ie)).join("|")})`,le=!1,ue="";break}case"]":{re+="["+F+"]",q=!1,F="";break}case"?":re+=k;continue;case"*":re+=C(1);continue;default:re+=(0,D.escapeRegExpCharacters)(J)}}ve<V.length-1&&(V[ve+1]!==e.GLOBSTAR||ve+2<V.length)&&(re+=O)}_=te===e.GLOBSTAR})}return re}const n=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),o=function(){return!1},r=function(){return null};function c(fe,re){if(!fe)return r;let V;typeof fe!="string"?V=fe.pattern:V=fe,V=V.trim();const _=`${V}_${!!re.trimForExclusions}`;let te=t.get(_);if(te)return m(te,fe);let ve;return n.test(V)?te=i(V.substr(4),V):(ve=d.exec(f(V,re)))?te=s(ve[1],V):(re.trimForExclusions?w:h).test(V)?te=u(V,re):(ve=y.exec(f(V,re)))?te=b(ve[1].substr(1),V,!0):(ve=p.exec(f(V,re)))?te=b(ve[1],V,!1):te=g(V),t.set(_,te),m(te,fe)}function m(fe,re){if(typeof re=="string")return fe;const V=function(_,te){return(0,l.isEqualOrParent)(_,re.base,!T.isLinux)?fe((0,D.ltrim)(_.substr(re.base.length),P.sep),te):null};return V.allBasenames=fe.allBasenames,V.allPaths=fe.allPaths,V.basenames=fe.basenames,V.patterns=fe.patterns,V}function f(fe,re){return re.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function i(fe,re){return function(V,_){return typeof V=="string"&&V.endsWith(fe)?re:null}}function s(fe,re){const V=`/${fe}`,_=`\\${fe}`,te=function(le,ue){return typeof le!="string"?null:ue?ue===fe?re:null:le===fe||le.endsWith(V)||le.endsWith(_)?re:null},ve=[fe];return te.basenames=ve,te.patterns=[re],te.allBasenames=ve,te}function u(fe,re){const V=M(fe.slice(1,-1).split(",").map(ue=>c(ue,re)).filter(ue=>ue!==r),fe),_=V.length;if(!_)return r;if(_===1)return V[0];const te=function(ue,q){for(let F=0,J=V.length;F<J;F++)if(V[F](ue,q))return fe;return null},ve=V.find(ue=>!!ue.allBasenames);ve&&(te.allBasenames=ve.allBasenames);const le=V.reduce((ue,q)=>q.allPaths?ue.concat(q.allPaths):ue,[]);return le.length&&(te.allPaths=le),te}function b(fe,re,V){const _=P.sep===P.posix.sep,te=_?fe:fe.replace(S,P.sep),ve=P.sep+te,le=P.posix.sep+fe;let ue;return V?ue=function(q,F){return typeof q=="string"&&(q===te||q.endsWith(ve)||!_&&(q===fe||q.endsWith(le)))?re:null}:ue=function(q,F){return typeof q=="string"&&(q===te||!_&&q===fe)?re:null},ue.allPaths=[(V?"*/":"./")+fe],ue}function g(fe){try{const re=new RegExp(`^${E(fe)}$`);return function(V){return re.lastIndex=0,typeof V=="string"&&re.test(V)?fe:null}}catch{return r}}function L(fe,re,V){return!fe||typeof re!="string"?!1:j(fe)(re,void 0,V)}e.match=L;function j(fe,re={}){if(!fe)return o;if(typeof fe=="string"||G(fe)){const V=c(fe,re);if(V===r)return o;const _=function(te,ve){return!!V(te,ve)};return V.allBasenames&&(_.allBasenames=V.allBasenames),V.allPaths&&(_.allPaths=V.allPaths),_}return U(fe,re)}e.parse=j;function G(fe){const re=fe;return re?typeof re.base=="string"&&typeof re.pattern=="string":!1}e.isRelativePattern=G;function Q(fe){return fe.allBasenames||[]}e.getBasenameTerms=Q;function B(fe){return fe.allPaths||[]}e.getPathTerms=B;function U(fe,re){const V=M(Object.getOwnPropertyNames(fe).map(ue=>z(ue,fe[ue],re)).filter(ue=>ue!==r)),_=V.length;if(!_)return r;if(!V.some(ue=>!!ue.requiresSiblings)){if(_===1)return V[0];const ue=function(J,ge){let Ee;for(let ie=0,ne=V.length;ie<ne;ie++){const de=V[ie](J,ge);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(Ee||(Ee=[]),Ee.push(de))}return Ee?(async()=>{for(const ie of Ee){const ne=await ie;if(typeof ne=="string")return ne}return null})():null},q=V.find(J=>!!J.allBasenames);q&&(ue.allBasenames=q.allBasenames);const F=V.reduce((J,ge)=>ge.allPaths?J.concat(ge.allPaths):J,[]);return F.length&&(ue.allPaths=F),ue}const te=function(ue,q,F){let J,ge;for(let Ee=0,ie=V.length;Ee<ie;Ee++){const ne=V[Ee];ne.requiresSiblings&&F&&(q||(q=(0,P.basename)(ue)),J||(J=q.substr(0,q.length-(0,P.extname)(ue).length)));const de=ne(ue,q,J,F);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(ge||(ge=[]),ge.push(de))}return ge?(async()=>{for(const Ee of ge){const ie=await Ee;if(typeof ie=="string")return ie}return null})():null},ve=V.find(ue=>!!ue.allBasenames);ve&&(te.allBasenames=ve.allBasenames);const le=V.reduce((ue,q)=>q.allPaths?ue.concat(q.allPaths):ue,[]);return le.length&&(te.allPaths=le),te}function z(fe,re,V){if(re===!1)return r;const _=c(fe,V);if(_===r)return r;if(typeof re=="boolean")return _;if(re){const te=re.when;if(typeof te=="string"){const ve=(le,ue,q,F)=>{if(!F||!_(le,ue))return null;const J=te.replace("$(basename)",()=>q),ge=F(J);return(0,A.isThenable)(ge)?ge.then(Ee=>Ee?fe:null):ge?fe:null};return ve.requiresSiblings=!0,ve}}return _}function M(fe,re){const V=fe.filter(ue=>!!ue.basenames);if(V.length<2)return fe;const _=V.reduce((ue,q)=>{const F=q.basenames;return F?ue.concat(F):ue},[]);let te;if(re){te=[];for(let ue=0,q=_.length;ue<q;ue++)te.push(re)}else te=V.reduce((ue,q)=>{const F=q.patterns;return F?ue.concat(F):ue},[]);const ve=function(ue,q){if(typeof ue!="string")return null;if(!q){let J;for(J=ue.length;J>0;J--){const ge=ue.charCodeAt(J-1);if(ge===47||ge===92)break}q=ue.substr(J)}const F=_.indexOf(q);return F!==-1?te[F]:null};ve.basenames=_,ve.patterns=te,ve.allBasenames=_;const le=fe.filter(ue=>!ue.basenames);return le.push(ve),le}function x(fe,re){return(0,a.equals)(fe,re,(V,_)=>typeof V=="string"&&typeof _=="string"?V===_:typeof V!="string"&&typeof _!="string"?V.base===_.base&&V.pattern===_.pattern:!1)}e.patternsEquals=x}),define(Ie[113],Ce([1,0,8,165,24,9,2]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",h=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(d,h=0){return this.value+=S(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,h){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(d,h,w){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(d),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(d,h){const w=new RegExp((0,R.escapeRegExpCharacters)(h),"g");return d.replace(w,(y,p)=>d.charAt(p-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=D;function v(n){return O(n)?!n.value:Array.isArray(n)?n.every(v):!0}e.isEmptyMarkdownString=v;function O(n){return n instanceof D?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function k(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons&&n.supportHtml===d.supportHtml&&(n.baseUri===d.baseUri||!!n.baseUri&&!!d.baseUri&&(0,l.isEqual)(P.URI.from(n.baseUri),P.URI.from(d.baseUri)))}e.markdownStringEqual=k;function S(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function C(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function I(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=I;function E(n){const d=[],h=n.split("|").map(y=>y.trim());n=h[0];const w=h[1];if(w){const y=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),t=y?y[1]:"",o=p?p[1]:"",r=isFinite(parseInt(o)),c=isFinite(parseInt(t));r&&d.push(`width="${o}"`),c&&d.push(`height="${t}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=E}),define(Ie[114],Ce([1,0,17,33,15,14,24,9]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(r,c){const{os:m,tildify:f,relative:i}=c;if(i){const b=v(r,i,m);if(typeof b=="string")return b}let s=r.fsPath;if(m===1&&!R.isWindows?s=s.replace(/\//g,"\\"):m!==1&&R.isWindows&&(s=s.replace(/\\/g,"/")),m!==1&&f?.userHome){const b=f.userHome.fsPath;let g;r.scheme!==f.userHome.scheme&&r.path.startsWith(l.posix.sep)?g=f.userHome.with({path:r.path}).fsPath:g=r.fsPath,s=S(g,b,m)}return(m===1?l.win32:l.posix).normalize(O(s,m===1))}e.getPathLabel=D;function v(r,c,m){const f=m===1?l.win32:l.posix,i=m===3?P.extUri:P.extUriIgnorePathCase,s=c.getWorkspace(),u=(0,a.firstOrDefault)(s.folders);if(!u)return;r.scheme!==u.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=u.uri.with({path:r.path}));const b=c.getWorkspaceFolder(r);if(!b)return;let g;if(i.isEqual(b.uri,r)?g="":g=i.relativePath(b.uri,r)??"",g&&(g=f.normalize(g)),s.folders.length>1&&!c.noPrefix){const L=b.name?b.name:i.basenameOrAuthority(b.uri);g=g?`${L} \u2022 ${g}`:L}return g}function O(r,c=R.isWindows){return(0,A.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let k=Object.create(null);function S(r,c,m=R.OS){if(m===1||!r||!c)return r;let f=k.original===c?k.normalized:void 0;f||(f=c,R.isWindows&&(f=(0,A.toSlashes)(f)),f=`${(0,T.rtrim)(f,l.posix.sep)}${l.posix.sep}`,k={original:c,normalized:f});let i=r;return R.isWindows&&(i=(0,A.toSlashes)(i)),(m===3?i.startsWith(f):(0,T.startsWithIgnoreCase)(i,f))?`~/${i.substr(f.length)}`:r}e.tildify=S;function C(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=C;const I="\u2026",E="\\\\",n="~";function d(r,c=l.sep){const m=new Array(r.length);let f=!1;for(let i=0;i<r.length;i++){const s=r[i];if(s===""){m[i]=`.${c}`;continue}if(!s){m[i]=s;continue}f=!0;let u="",b=s;b.indexOf(E)===0?(u=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(c)===0?(u=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length)):b.indexOf(n)===0&&(u=b.substr(0,b.indexOf(n)+n.length),b=b.substr(b.indexOf(n)+n.length));const g=b.split(c);for(let L=1;f&&L<=g.length;L++)for(let j=g.length-L;f&&j>=0;j--){f=!1;let G=g.slice(j,j+L).join(c);for(let Q=0;!f&&Q<r.length;Q++)if(Q!==i&&r[Q]&&r[Q].indexOf(G)>-1){const B=j+L===g.length,U=j>0&&r[Q].indexOf(c)>-1?c+G:G,z=r[Q].endsWith(U);f=!B||z}if(!f){let Q="";(g[0].endsWith(":")||u!=="")&&(j===1&&(j=0,L++,G=g[0]+c+G),j>0&&(Q=g[0]+c),Q=u+Q),j>0&&(Q=Q+I+c),Q=Q+G,j+L<g.length&&(Q=Q+c+I),m[i]=Q}}f&&(m[i]=s)}return m}e.shorten=d;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function w(r,c=Object.create(null)){const m=[];let f=!1,i="";for(const s of r)if(s==="$"||f&&s==="{")i&&m.push({value:i,type:h.TEXT}),i="",f=!0;else if(s==="}"&&f){const u=c[i];if(typeof u=="string")u.length&&m.push({value:u,type:h.VARIABLE});else if(u){const b=m[m.length-1];(!b||b.type!==h.SEPARATOR)&&m.push({value:u.label,type:h.SEPARATOR})}i="",f=!1}else i+=s;return i&&!f&&m.push({value:i,type:h.TEXT}),m.filter((s,u)=>{if(s.type===h.SEPARATOR){const b=m[u-1],g=m[u+1];return[b,g].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=w;function y(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function p(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(r){const c=r.indexOf("/")!==-1?l.posix:l.win32,m=c.basename(r),f=c.dirname(r);return m.length?{name:m,parentPath:f}:{name:f,parentPath:""}}e.splitName=o}),define(Ie[115],Ce([1,0,22,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(k){return k.toJSON()}class R{constructor(S){this.a=S}transformIncoming(S){const C=this.a.transformIncoming(S);return C===S?S:l(A.URI.from(C))}transformOutgoing(S){const C=this.a.transformOutgoing(S);return C===S?S:l(A.URI.from(C))}transformOutgoingURI(S){const C=this.a.transformOutgoing(S);return C===S?S:A.URI.from(C)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function P(k,S,C){if(!k||C>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return S.transformOutgoing(k);for(const I in k)if(Object.hasOwnProperty.call(k,I)){const E=P(k[I],S,C+1);E!==null&&(k[I]=E)}}return null}function T(k,S){const C=P(k,S,0);return C===null?k:C}e.transformOutgoingURIs=T;function D(k,S,C,I){if(!k||I>200)return null;if(typeof k=="object"){if(k.$mid===1)return C?A.URI.revive(S.transformIncoming(k)):S.transformIncoming(k);if(k instanceof a.VSBuffer)return null;for(const E in k)if(Object.hasOwnProperty.call(k,E)){const n=D(k[E],S,C,I+1);n!==null&&(k[E]=n)}}return null}function v(k,S){const C=D(k,S,!1,0);return C===null?k:C}e.transformIncomingURIs=v;function O(k,S){const C=D(k,S,!0,0);return C===null?k:C}e.transformAndReviveIncomingURIs=O}),define(Ie[29],Ce([1,0,71,89,325,19,33,87,15,14,24,2]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function C(U,z=S.UNLINK){if((0,P.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===S.UNLINK?E(U):I(U)}async function I(U){try{const z=(0,P.randomPath)((0,A.tmpdir)());try{await a.promises.rename(U,z)}catch(M){return M.code==="ENOENT"?void 0:E(U)}E(z).catch(M=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function E(U){return(0,l.promisify)(a.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function n(U){if((0,P.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function d(U,z){return y(await(z?h(U):(0,l.promisify)(a.readdir)(U)))}async function h(U){try{return await(0,l.promisify)(a.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],M=await d(U);for(const x of M){let fe=!1,re=!1,V=!1;try{const _=await e.Promises.lstat((0,D.join)(U,x));fe=_.isFile(),re=_.isDirectory(),V=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}z.push({name:x,isFile:()=>fe,isDirectory:()=>re,isSymbolicLink:()=>V})}return z}function w(U){return y(a.readdirSync(U))}e.readdirSync=w;function y(U){return U.map(z=>typeof z=="string"?v.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=v.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function p(U){const z=await d(U),M=[];for(const x of z)await o.existsDirectory((0,D.join)(U,x))&&M.push(x);return M}function t(U,z=1e3){return new Promise(M=>{let x=!1;const fe=setInterval(()=>{x||(x=!0,a.access(U,re=>{x=!1,re&&(clearInterval(fe),M(void 0))}))},z)})}e.whenDeleted=t;var o;(function(U){async function z(fe){let re;try{if(re=await e.Promises.lstat(fe),!re.isSymbolicLink())return{stat:re}}catch{}try{return{stat:await e.Promises.stat(fe),symbolicLink:re?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&re)return{stat:re,symbolicLink:{dangling:!0}};if(v.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(fe)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&re)return{stat:re,symbolicLink:{dangling:!0}};throw _}throw V}}U.stat=z;async function M(fe){try{const{stat:re,symbolicLink:V}=await U.stat(fe);return re.isFile()&&V?.dangling!==!0}catch{}return!1}U.existsFile=M;async function x(fe){try{const{stat:re,symbolicLink:V}=await U.stat(fe);return re.isDirectory()&&V?.dangling!==!0}catch{}return!1}U.existsDirectory=x})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(U,z,M){return r.queueFor(k.URI.file(U),O.extUriBiasedIgnorePathCase).queue(()=>{const x=u(M);return new Promise((fe,re)=>i(U,z,x,V=>V?re(V):fe()))})}let m=!0;function f(U){m=U}e.configureFlushOnWrite=f;function i(U,z,M,x){if(!m)return a.writeFile(U,z,{mode:M.mode,flag:M.flag},x);a.open(U,M.flag,M.mode,(fe,re)=>{if(fe)return x(fe);a.writeFile(re,z,V=>{if(V)return a.close(re,()=>x(V));a.fdatasync(re,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),f(!1)),a.close(re,te=>x(te))))})})}function s(U,z,M){const x=u(M);if(!m)return a.writeFileSync(U,z,{mode:x.mode,flag:x.flag});const fe=a.openSync(U,x.flag,x.mode);try{a.writeFileSync(fe,z);try{a.fdatasyncSync(fe)}catch(re){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",re),f(!1)}}finally{a.closeSync(fe)}}e.writeFileSync=s;function u(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function b(U,z){if(U!==z)try{await e.Promises.rename(U,z)}catch(M){if(U.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||U.endsWith("."))await g(U,z,{preserveSymlinks:!1}),await C(U,S.MOVE);else throw M}}async function g(U,z,M){return j(U,z,{root:{source:U,target:z},options:M,handledSourcePaths:new Set})}const L=511;async function j(U,z,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:x,symbolicLink:fe}=await o.stat(U);if(fe){if(M.options.preserveSymlinks)try{return await B(U,z,M)}catch(re){console.warn("[node.js fs] copy of symlink failed: ",re)}if(fe.dangling)return}return x.isDirectory()?G(U,z,x.mode&L,M):Q(U,z,x.mode&L)}async function G(U,z,M,x){await e.Promises.mkdir(z,{recursive:!0,mode:M});const fe=await d(U);for(const re of fe)await j((0,D.join)(U,re),(0,D.join)(z,re),x)}async function Q(U,z,M){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,M)}async function B(U,z,M){let x=await e.Promises.readlink(U);(0,P.isEqualOrParent)(x,M.root.source,!v.isLinux)&&(x=(0,D.join)(M.root.target,x.substr(M.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,l.promisify)(a.access)}get stat(){return(0,l.promisify)(a.stat)}get lstat(){return(0,l.promisify)(a.lstat)}get utimes(){return(0,l.promisify)(a.utimes)}get read(){return(U,z,M,x,fe)=>new Promise((re,V)=>{a.read(U,z,M,x,fe,(_,te,ve)=>_?V(_):re({bytesRead:te,buffer:ve}))})}get readFile(){return(0,l.promisify)(a.readFile)}get write(){return(U,z,M,x,fe)=>new Promise((re,V)=>{a.write(U,z,M,x,fe,(_,te,ve)=>_?V(_):re({bytesWritten:te,buffer:ve}))})}get appendFile(){return(0,l.promisify)(a.appendFile)}get fdatasync(){return(0,l.promisify)(a.fdatasync)}get truncate(){return(0,l.promisify)(a.truncate)}get rename(){return(0,l.promisify)(a.rename)}get copyFile(){return(0,l.promisify)(a.copyFile)}get open(){return(0,l.promisify)(a.open)}get close(){return(0,l.promisify)(a.close)}get symlink(){return(0,l.promisify)(a.symlink)}get readlink(){return(0,l.promisify)(a.readlink)}get chmod(){return(0,l.promisify)(a.chmod)}get mkdir(){return(0,l.promisify)(a.mkdir)}get unlink(){return(0,l.promisify)(a.unlink)}get rmdir(){return(0,l.promisify)(a.rmdir)}get realpath(){return(0,l.promisify)(a.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return C}get move(){return b}get copy(){return g}}}),define(Ie[116],Ce([1,0,71,15,14,9,29]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(S){if(l.isLinux)return S;const C=(0,A.dirname)(S);if(S===C)return S;const I=((0,A.basename)(S)||S).toLowerCase();try{const n=(0,P.readdirSync)(C).filter(d=>d.toLowerCase()===I);if(n.length===1){const d=T(C);if(d)return(0,A.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(I);if(d>=0){const h=T(C);if(h)return(0,A.join)(h,n[d])}}}catch{}return null}e.realcaseSync=T;async function D(S){if(l.isLinux)return S;const C=(0,A.dirname)(S);if(S===C)return S;const I=((0,A.basename)(S)||S).toLowerCase();try{const n=(await P.Promises.readdir(C)).filter(d=>d.toLowerCase()===I);if(n.length===1){const d=await D(C);if(d)return(0,A.join)(d,n[0])}else if(n.length>1){const d=n.indexOf(I);if(d>=0){const h=await D(C);if(h)return(0,A.join)(h,n[d])}}}catch{}return null}e.realcase=D;async function v(S){try{return await P.Promises.realpath(S)}catch{const I=k(S);return await P.Promises.access(I,a.constants.R_OK),I}}e.realpath=v;function O(S){try{return a.realpathSync(S)}catch{const I=k(S);return a.accessSync(I,a.constants.R_OK),I}}e.realpathSync=O;function k(S){return(0,R.rtrim)((0,A.normalize)(S),A.sep)}}),define(Ie[117],Ce([1,0,15,14,36,110,10,29]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function D(k=l.env){return k.comspec||"cmd.exe"}e.getWindowsShell=D;function v(k){let S=[],C=!1;const I=function(E){if(C){S.push(E);return}(!k.send(E,d=>{if(d&&console.error(d),C=!1,S.length>0){const h=S.slice(0);S=[],h.forEach(w=>I(w))}})||A.isWindows)&&(C=!0)};return{send:I}}e.createQueuedSender=v;var O;(function(k){async function S(C,I,E){if(a.isAbsolute(C))return C;if(I===void 0&&(I=l.cwd()),a.dirname(C)!=="."||(E===void 0&&P.isString(l.env.PATH)&&(E=l.env.PATH.split(a.delimiter)),E===void 0||E.length===0))return a.join(I,C);async function d(h){if(await T.Promises.exists(h)){let w;try{w=await T.Promises.stat(h)}catch(y){y.message.startsWith("EACCES")&&(w=await T.Promises.lstat(h))}return w?!w.isDirectory():!1}return!1}for(const h of E){let w;if(a.isAbsolute(h)?w=a.join(h,C):w=a.join(I,h,C),await d(w))return w;let y=w+".com";if(await d(y)||(y=w+".exe",await d(y)))return y}return a.join(I,C)}k.findExecutable=S})(O=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(se,e,a,A){var l=arguments.length,R=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,a):A,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(se,e,a,A);else for(var T=se.length-1;T>=0;T--)(P=se[T])&&(R=(l<3?P(R):l>3?P(e,a,R):P(e,a))||R);return l>3&&R&&Object.defineProperty(e,a,R),R};define(Ie[118],Ce([1,0,17,19,22,21,62,8,3,6,70,9,10]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(C||(C={}));function I(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(E||(E={}));function n(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(d||(d={}));function h(re){let V=0;for(let _=0;;_+=7){const te=re.read(1);if(V|=(te.buffer[0]&127)<<_,!(te.buffer[0]&128))return V}}const w=r(0);function y(re,V){if(V===0){re.write(w);return}let _=0;for(let ve=V;ve!==0;ve=ve>>>7)_++;const te=l.VSBuffer.alloc(_);for(let ve=0;V!==0;ve++)te.buffer[ve]=V&127,V=V>>>7,V>0&&(te.buffer[ve]|=128);re.write(te)}class p{constructor(V){this.b=V,this.a=0}read(V){const _=this.b.slice(this.a,this.a+V);return this.a+=_.byteLength,_}}e.BufferReader=p;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=t;var o;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(o||(o={}));function r(re){const V=l.VSBuffer.alloc(1);return V.writeUInt8(re,0),V}const c={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},m=typeof Buffer<"u";function f(re,V){if(typeof V>"u")re.write(c.Undefined);else if(typeof V=="string"){const _=l.VSBuffer.fromString(V);re.write(c.String),y(re,_.byteLength),re.write(_)}else if(m&&Buffer.isBuffer(V)){const _=l.VSBuffer.wrap(V);re.write(c.Buffer),y(re,_.byteLength),re.write(_)}else if(V instanceof l.VSBuffer)re.write(c.VSBuffer),y(re,V.byteLength),re.write(V);else if(Array.isArray(V)){re.write(c.Array),y(re,V.length);for(const _ of V)f(re,_)}else if(typeof V=="number"&&(V|0)===V)re.write(c.Uint),y(re,V);else{const _=l.VSBuffer.fromString(JSON.stringify(V));re.write(c.Object),y(re,_.byteLength),re.write(_)}}e.serialize=f;function i(re){switch(re.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return re.read(h(re)).toString();case o.Buffer:return re.read(h(re)).buffer;case o.VSBuffer:return re.read(h(re));case o.Array:{const _=h(re),te=[];for(let ve=0;ve<_;ve++)te.push(i(re));return te}case o.Object:return JSON.parse(re.read(h(re)).toString());case o.Int:return h(re)}}e.deserialize=i;class s{constructor(V,_,te=null,ve=1e3){this.h=V,this.j=_,this.k=te,this.l=ve,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(V,_){this.b.set(V,_),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const _=this.o([V.type]);this.k?.logOutgoing(_,0,1,n(V.type));return}case 201:case 202:case 204:case 203:{const _=this.o([V.type,V.id],V.data);this.k?.logOutgoing(_,V.id,1,n(V.type),V.data);return}}}o(V,_=void 0){const te=new t;return f(te,V),f(te,_),this.p(te.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const _=new p(V),te=i(_),ve=i(_),le=te[0];switch(le){case 100:return this.k?.logIncoming(V.byteLength,te[1],1,`${I(le)}: ${te[2]}.${te[3]}`,ve),this.s({type:le,id:te[1],channelName:te[2],name:te[3],arg:ve});case 102:return this.k?.logIncoming(V.byteLength,te[1],1,`${I(le)}: ${te[2]}.${te[3]}`,ve),this.t({type:le,id:te[1],channelName:te[2],name:te[3],arg:ve});case 101:return this.k?.logIncoming(V.byteLength,te[1],1,`${I(le)}`),this.u({type:le,id:te[1]});case 103:return this.k?.logIncoming(V.byteLength,te[1],1,`${I(le)}`),this.u({type:le,id:te[1]})}}s(V){const _=this.b.get(V.channelName);if(!_){this.v(V);return}const te=new R.CancellationTokenSource;let ve;try{ve=_.call(this.j,V.name,V.arg,te.token)}catch(q){ve=Promise.reject(q)}const le=V.id;ve.then(q=>{this.m({id:le,data:q,type:201}),this.d.delete(V.id)},q=>{q instanceof Error?this.m({id:le,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:le,data:q,type:203}),this.d.delete(V.id)});const ue=(0,v.toDisposable)(()=>te.cancel());this.d.set(V.id,ue)}t(V){const _=this.b.get(V.channelName);if(!_){this.v(V);return}const te=V.id,le=_.listen(this.j,V.name,V.arg)(ue=>this.m({id:te,data:ue,type:204}));this.d.set(V.id,le)}u(V){const _=this.d.get(V.id);_&&(_.dispose(),this.d.delete(V.id))}v(V){let _=this.g.get(V.channelName);_||(_=[],this.g.set(V.channelName,_));const te=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);_.push({request:V,timeoutTimer:te})}w(V){const _=this.g.get(V);if(_){for(const te of _)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var u;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(V,_=null){this.l=V,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new D.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=_}getChannel(V){const _=this;return{call(te,ve,le){return _.a?Promise.reject(new T.CancellationError):_.m(V,te,ve,le)},listen(te,ve){return _.a?D.Event.None:_.o(V,te,ve)}}}m(V,_,te,ve=R.CancellationToken.None){const le=this.g++,q={id:le,type:100,channelName:V,name:_,arg:te};if(ve.isCancellationRequested)return Promise.reject(new T.CancellationError);let F;return new Promise((ge,Ee)=>{if(ve.isCancellationRequested)return Ee(new T.CancellationError);const ie=()=>{const ce=ae=>{switch(ae.type){case 201:this.f.delete(le),ge(ae.data);break;case 202:{this.f.delete(le);const N=new Error(ae.data.message);N.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,N.name=ae.data.name,Ee(N);break}case 203:this.f.delete(le),Ee(ae.data);break}};this.f.set(le,ce),this.p(q)};let ne=null;this.b===d.Idle?ie():(ne=(0,A.createCancelablePromise)(ce=>this.u()),ne.then(()=>{ne=null,ie()}));const de=()=>{ne?(ne.cancel(),ne=null):this.p({id:le,type:101}),Ee(new T.CancellationError)},ee=ve.onCancellationRequested(de);F=(0,v.combinedDisposable)((0,v.toDisposable)(de),ee),this.d.add(F)}).finally(()=>{this.d.delete(F)})}o(V,_,te){const ve=this.g++,ue={id:ve,type:102,channelName:V,name:_,arg:te};let q=null;const F=new D.Emitter({onWillAddFirstListener:()=>{q=(0,A.createCancelablePromise)(ge=>this.u()),q.then(()=>{q=null,this.d.add(F),this.p(ue)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(F),this.p({id:ve,type:103}))}}),J=ge=>F.fire(ge.data);return this.f.set(ve,J),F.event}p(V){switch(V.type){case 100:case 102:{const _=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(_,V.id,0,`${I(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const _=this.q([V.type,V.id]);this.j?.logOutgoing(_,V.id,0,I(V.type));return}}}q(V,_=void 0){const te=new t;return f(te,V),f(te,_),this.r(te.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const _=new p(V),te=i(_),ve=i(_),le=te[0];switch(le){case 200:return this.j?.logIncoming(V.byteLength,0,0,n(le)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,te[1],0,n(le),ve),this.t({type:te[0],id:te[1],data:ve})}}t(V){if(V.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.dispose)(this.d.values()),this.d.clear()}}Ve([P.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class g{get connections(){const V=[];return this.f.forEach(_=>V.push(_)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new D.Emitter,this.onDidAddConnection=this.g.event,this.h=new D.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:_,onDidClientDisconnect:te})=>{D.Event.once(_.onMessage)(le=>{const ue=new p(le),q=i(ue),F=new s(_,q),J=new b(_);this.a.forEach((Ee,ie)=>F.registerChannel(ie,Ee));const ge={channelServer:F,channelClient:J,ctx:q};this.f.add(ge),this.g.fire(ge),te(()=>{F.dispose(),J.dispose(),this.f.delete(ge),this.h.fire(ge)})})})}getChannel(V,_){const te=this;return{call(ve,le,ue){let q;if((0,S.isFunction)(_)){const J=(0,a.getRandomElement)(te.connections.filter(_));q=J?Promise.resolve(J):D.Event.toPromise(D.Event.filter(te.onDidAddConnection,_))}else q=_.routeCall(te,ve,le);const F=q.then(J=>J.channelClient.getChannel(V));return j(F).call(ve,le,ue)},listen(ve,le){if((0,S.isFunction)(_))return te.j(V,_,ve,le);const ue=_.routeEvent(te,ve,le).then(q=>q.channelClient.getChannel(V));return j(ue).listen(ve,le)}}}j(V,_,te,ve){const le=this;let ue=new v.DisposableStore;const q=new D.Emitter({onWillAddFirstListener:()=>{ue=new v.DisposableStore;const F=new D.EventMultiplexer,J=new Map,ge=ie=>{const de=ie.channelClient.getChannel(V).listen(te,ve),ee=F.add(de);J.set(ie,ee)},Ee=ie=>{const ne=J.get(ie);!ne||(ne.dispose(),J.delete(ie))};le.connections.filter(_).forEach(ge),D.Event.filter(le.onDidAddConnection,_)(ge,void 0,ue),le.onDidRemoveConnection(Ee,void 0,ue),F.event(q.fire,q,ue),ue.add(F)},onDidRemoveLastListener:()=>{ue.dispose()}});return q.event}registerChannel(V,_){this.a.set(V,_),this.f.forEach(te=>{te.channelServer.registerChannel(V,_)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=g;class L{constructor(V,_,te=null){const ve=new t;f(ve,_),V.send(ve.buffer),this.a=new b(V,te),this.d=new s(V,_,te)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,_){this.d.registerChannel(V,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=L;function j(re){return{call(V,_,te){return re.then(ve=>ve.call(V,_,te))},listen(V,_){const te=new D.Relay;return re.then(ve=>te.input=ve.listen(V,_)),te.event}}}e.getDelayedChannel=j;function G(re){let V=!1;return{call(_,te,ve){return V?re.call(_,te,ve):(0,A.timeout)(0).then(()=>V=!0).then(()=>re.call(_,te,ve))},listen(_,te){if(V)return re.listen(_,te);const ve=new D.Relay;return(0,A.timeout)(0).then(()=>V=!0).then(()=>ve.input=re.listen(_,te)),ve.event}}}e.getNextTickChannel=G;class Q{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const _ of V.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await D.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=Q;var B;(function(re){function V(le,ue){const q=le,F=ue&&ue.disableMarshalling,J=new Map;for(const ge in q)te(ge)&&J.set(ge,D.Event.buffer(q[ge],!0));return new class{listen(ge,Ee,ie){const ne=J.get(Ee);if(ne)return ne;if(ve(Ee)){const de=q[Ee];if(typeof de=="function")return de.call(q,ie)}throw new Error(`Event not found: ${Ee}`)}call(ge,Ee,ie){const ne=q[Ee];if(typeof ne=="function"){if(!F&&Array.isArray(ie))for(let de=0;de<ie.length;de++)ie[de]=(0,O.revive)(ie[de]);return ne.apply(q,ie)}throw new Error(`Method not found: ${Ee}`)}}}re.fromService=V;function _(le,ue){const q=ue&&ue.disableMarshalling;return new Proxy({},{get(F,J){if(typeof J=="string")return ue?.properties?.has(J)?ue.properties.get(J):ve(J)?function(ge){return le.listen(J,ge)}:te(J)?le.listen(J):async function(...ge){let Ee;ue&&!(0,S.isUndefinedOrNull)(ue.context)?Ee=[ue.context,...ge]:Ee=ge;const ie=await le.call(J,Ee);return q?ie:(0,O.revive)(ie)};throw new Error(`Property not found: ${String(J)}`)}})}re.toService=_;function te(le){return le[0]==="o"&&le[1]==="n"&&k.isUpperAsciiLetter(le.charCodeAt(2))}function ve(le){return/^onDynamic/.test(le)&&k.isUpperAsciiLetter(le.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const V=re.toString();if(V!=="[object Object]")return V}return re}function M(re){return Array.isArray(re)?re.map(z):z(re)}function x(re,V,_,te,ve,le,ue){ue=M(ue);const q=U[ve],F=q[te%q.length];let J=[`%c[${re}]%c[${String(V).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(le)?(J=J.concat(ue),J.push(")")):J.push(ue),console.log.apply(console,J)}class fe{constructor(V,_){this.d=V,this.f=_,this.a=0,this.b=0}logOutgoing(V,_,te,ve,le){this.b+=V,x(this.d,this.b,V,_,te,ve,le)}logIncoming(V,_,te,ve,le){this.a+=V,x(this.f,this.a,V,_,te,ve,le)}}e.IPCLogger=fe}),define(Ie[119],Ce([1,0,19,22,3,6,118]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(b){b.enableDiagnostics=!1,b.records=[];const g=new WeakMap;let L=0;function j(Q,B){if(!g.has(Q)){const U=String(++L);g.set(Q,U)}return g.get(Q)}function G(Q,B,U,z){if(!b.enableDiagnostics)return;const M=j(Q,B);if(z instanceof A.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const x=A.VSBuffer.alloc(z.byteLength);x.set(z),b.records.push({timestamp:Date.now(),id:M,label:B,type:U,buff:x})}else b.records.push({timestamp:Date.now(),id:M,label:B,type:U,data:z})}b.traceSocketEvent=G})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let O=null;function k(){return O||(O=A.VSBuffer.alloc(0)),O}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,L){if(g===0)return k();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const B=this.a[0];return L&&(this.a.shift(),this.b-=g),B}if(this.a[0].byteLength>g){const B=this.a[0].slice(0,g);return L&&(this.a[0]=this.a[0].slice(g),this.b-=g),B}const j=A.VSBuffer.alloc(g);let G=0,Q=0;for(;g>0;){const B=this.a[Q];if(B.byteLength>g){const U=B.slice(0,g);j.set(U,G),G+=g,L&&(this.a[Q]=B.slice(g),this.b-=g),g-=g}else j.set(B,G),G+=B.byteLength,L?(this.a.shift(),this.b-=B.byteLength):Q++,g-=B.byteLength}return j}}e.ChunkStream=S;var C;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(C||(C={}));function I(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class n{constructor(g,L,j,G){this.type=g,this.id=L,this.ack=j,this.data=G,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(g){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=g,this.b=!1,this.c=new S,this.B(this.a.onData(L=>this.acceptChunk(L))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const L=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=L.readUInt32BE(9),this.g.messageType=L.readUInt8(0),this.g.id=L.readUInt32BE(1),this.g.ack=L.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:I(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,G=this.g.id,Q=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",L),this.f.fire(new n(j,G,Q,L)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const L=A.VSBuffer.alloc(13);L.writeUInt8(g.type,0),L.writeUInt32BE(g.id,1),L.writeUInt32BE(g.ack,5),L.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:I(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",g.data),this.j(L,g.data)}g(g,L){const j=this.f===0;return this.d.push(g,L),this.f+=g.byteLength+L.byteLength,j}h(){const g=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,L){this.g(g,L)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:g.byteLength}),this.c.write(g)}}class w extends R.Disposable{constructor(g){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(L=>{L.type===1&&this.f.fire(L.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new n(1,0,0,g))}}e.Protocol=w;class y extends P.IPCClient{static fromSocket(g,L){return new y(new w(g),L)}get onDidDispose(){return this.b.onDidDispose}constructor(g,L,j=null){super(g,L,j),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.Client=y;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,L=this.a;for(;L;)L=L.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let L=0,j=this.a;for(;j;)g[L++]=j.data,j=j.next;return g}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const L=new t(g);if(!this.a){this.a=L,this.b=L;return}this.b.next=L,this.b=L}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const g=Date.now();for(let L=0;L<r.a;L++)this.c[L]=g-1e3*L;setInterval(()=>{for(let L=r.a;L>=1;L--)this.c[L]=this.c[L-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),L=(1+r.a)*1e3;let j=0;for(let G=0;G<r.a;G++)g-this.c[G]<=L&&j++;return 1-j/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var c;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function m(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=m;class f{constructor(g){this.connectionHealth=g}}e.ConnectionHealthChangedEvent=f;class i{constructor(g,L){this.roundTripTime=g,this.recentHighRoundTripCount=L}}e.HighRoundTripTimeEvent=i;class s{get unacknowledgedCount(){return this.c-this.d}constructor(g){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=g.loadEstimator??r.getInstance(),this.v=g.measureRoundTripTime??!1,this.w=g.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=g.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(L=>this.E(L))),this.t.add(this.o.onClose(L=>this.A.fire(L))),this.r=this.t.add(new u),this.t.add(this.r.onSendLatencyRequest(L=>this.J(L))),this.t.add(this.r.onHighRoundTripTime(L=>this.C.fire(L))),this.t.add(this.r.onDidChangeConnectionHealth(L=>this.D.fire(L))),this.v&&this.r.start(),g.initialChunk&&this.q.acceptChunk(g.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const g=new n(5,0,0,k());this.p.write(g),this.p.flush()}sendPause(){const g=new n(7,0,0,k());this.p.write(g)}sendResume(){const g=new n(8,0,0,k());this.p.write(g)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(g,L){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=g,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new u),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(L)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const g=new n(3,0,this.h,k());this.p.write(g);const L=this.b.toArray();for(let j=0,G=L.length;j<G;j++)this.p.write(L[j]);this.G()}acceptDisconnect(){this.z.fire()}E(g){if(g.ack>this.d){this.d=g.ack;do{const L=this.b.peek();if(L&&L.id<=g.ack)this.b.pop();else break}while(!0)}switch(g.type){case 0:break;case 1:{if(g.id>this.g)if(g.id!==this.g+1){const L=Date.now();L-this.m>1e4&&(this.m=L,this.p.write(new n(6,0,0,k())))}else this.g=g.id,this.j=Date.now(),this.F(),this.y.fire(g.data);break}case 2:{this.x.fire(g.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const L=this.b.toArray();for(let j=0,G=L.length;j<G;j++)this.p.write(L[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(g.data);break}case 11:{this.r.handleResponse(g.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(g){const L=++this.c;this.h=this.g;const j=new n(1,L,this.h,g);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(g){const L=new n(2,0,0,g);this.p.write(L)}F(){if(this.g<=this.h||this.k)return;const g=Date.now()-this.j;if(g>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-g+5)}G(){if(this.c<=this.d||this.f||this.a)return;const g=this.b.peek(),L=Date.now()-g.writtenTime,j=Date.now()-this.q.lastReadTime,G=Date.now()-this.n;if(L>=2e4&&j>=2e4&&G>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:L,timeSinceLastReceivedSomeData:j});return}const Q=Math.max(2e4-L,2e4-j,2e4-G,500);this.f=setTimeout(()=>{this.f=null,this.G()},Q)}H(){if(this.g<=this.h)return;this.h=this.g;const g=new n(3,0,this.h,k());this.p.write(g)}I(){this.h=this.g;const g=new n(9,0,this.h,k());this.p.write(g)}J(g){this.h=this.g;const L=new n(10,0,this.h,g);this.p.write(L)}K(g){this.h=this.g;const L=new n(11,0,this.h,g);this.p.write(L)}}e.PersistentProtocol=s;class u extends R.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},g=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const g=++this.h,L=A.VSBuffer.alloc(4);L.writeUInt32BE(g,0),this.a.fire(L)},6e4)}handleResponse(g){if(g.byteLength!==4)return;const L=g.readUInt32BE(0);if(this.g<=0||L!==this.h)return;const j=Date.now()-this.g,G=this.k++;this.j[G%this.j.length]=j;const Q=this.l,B=this.j.filter(U=>U>=1e3).length;this.l=B>=3?1:0,j>1e3&&this.b.fire(new i(j,B)),Q!==this.l&&this.c.fire(this.l)}}}),define(Ie[120],Ce([1,0,22,8,3,6,15,14,30,118,119]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(i,s){O.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,s)}constructor(i,s=""){this.f=!0,this.debugLabel=s,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=u=>{if(this.traceSocketEvent("error",{code:u?.code,message:u?.message}),u){if(u.code==="EPIPE")return;(0,A.onUnexpectedError)(u)}},this.socket.on("error",this.a),this.b=u=>{this.traceSocketEvent("close",{hadError:u}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const s=u=>{this.traceSocketEvent("read",u),i(a.VSBuffer.wrap(u))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(i){const s=u=>{i({type:0,hadError:u,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(i){const s=()=>{i()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=S;var C;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize",f[f.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(C||(C={}));var I;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(I||(I={}));class E extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,s){this.socket.traceSocketEvent(i,s)}constructor(i,s,u,b){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:u?.byteLength||0,recordInflateBytes:b}),this.a=this.B(new n(this,s,u,b,this.f,(g,L)=>this.k(g,L))),this.B(this.a.onError(g=>{console.error(g),(0,A.onUnexpectedError)(g),this.g.fire({type:0,hadError:!0,error:g})})),this.b=new O.ChunkStream,this.B(this.socket.onData(g=>this.l(g))),this.B(this.socket.onClose(async g=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(g)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let s=0;for(;s<i.byteLength;)this.a.writeMessage(i.slice(s,Math.min(s+262144,i.byteLength))),s+=262144}k(i,s){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let u=2;i.byteLength<126?u+=0:i.byteLength<2**16?u+=2:u+=8;const b=a.VSBuffer.alloc(u);if(s?b.writeUInt8(194,0):b.writeUInt8(130,0),i.byteLength<126)b.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){b.writeUInt8(126,1);let g=1;b.writeUInt8(i.byteLength>>>8&255,++g),b.writeUInt8(i.byteLength>>>0&255,++g)}else{b.writeUInt8(127,1);let g=1;b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(0,++g),b.writeUInt8(i.byteLength>>>24&255,++g),b.writeUInt8(i.byteLength>>>16&255,++g),b.writeUInt8(i.byteLength>>>8&255,++g),b.writeUInt8(i.byteLength>>>0&255,++g)}this.socket.write(a.VSBuffer.concat([b,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const s=this.b.peek(this.j.readLen),u=s.readUInt8(0),b=(u&128)>>>7,g=(u&64)>>>6,L=s.readUInt8(1),j=(L&128)>>>7,G=L&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=b,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(g)),this.j.firstFrameOfMessage=Boolean(b),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const s=this.b.read(this.j.readLen),u=s.readUInt8(1),b=(u&128)>>>7;let g=u&127,L=1;g===126?g=s.readUInt8(++L)*2**8+s.readUInt8(++L):g===127&&(g=s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*0+s.readUInt8(++L)*2**24+s.readUInt8(++L)*2**16+s.readUInt8(++L)*2**8+s.readUInt8(++L));let j=0;b&&(j=s.readUInt8(++L)*2**24+s.readUInt8(++L)*2**16+s.readUInt8(++L)*2**8+s.readUInt8(++L)),this.j.state=3,this.j.readLen=g,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const s=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),w(s,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(s,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class n extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(i,s,u,b,g,L){super(),this.l=i,this.m=g,this.n=L,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,s?(this.b=this.B(new d(this.l,b,u,{windowBits:15})),this.f=this.B(new h(this.l,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const s=await this.s(this.f,i);this.n(s,!0)}else this.n(i,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(i,s){return new Promise((u,b)=>{i.write(s),i.flush(g=>u(g))})}acceptFrame(i,s,u){this.h.push({data:i,isCompressed:s,isLastFrameOfMessage:u}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const s=await this.w(this.b,i.data,i.isLastFrameOfMessage);this.m.fire(s)}else this.m.fire(i.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(i,s,u){return new Promise((b,g)=>{i.write(s),u&&i.write(a.VSBuffer.fromByteArray([0,0,255,255])),i.flush(L=>b(L))})}}class d extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(i,s,u,b){super(),this.h=i,this.j=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(b),this.b.on("error",g=>{this.h.traceSocketEvent("zlibInflateError",{message:g?.message,code:g?.code}),this.a.fire(g)}),this.b.on("data",g=>{this.h.traceSocketEvent("zlibInflateData",g),this.g.push(a.VSBuffer.wrap(g))}),u&&(this.h.traceSocketEvent("zlibInflateInitialWrite",u.buffer),this.b.write(u.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const s=a.VSBuffer.concat(this.g);this.g.length=0,i(s)})}}class h extends R.Disposable{constructor(i,s){super(),this.g=i,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",u=>{this.g.traceSocketEvent("zlibDeflateError",{message:u?.message,code:u?.code}),this.a.fire(u)}),this.b.on("data",u=>{this.g.traceSocketEvent("zlibDeflateData",u),this.f.push(a.VSBuffer.wrap(u))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let s=a.VSBuffer.concat(this.f);this.f.length=0,s=s.slice(0,s.byteLength-4),i(s)})}}function w(f,i){if(i===0)return;const s=f.byteLength>>>2;for(let G=0;G<s;G++){const Q=f.readUInt32BE(G*4);f.writeUInt32BE(Q^i,G*4)}const u=s*4,b=f.byteLength-u,g=i>>>24&255,L=i>>>16&255,j=i>>>8&255;b>=1&&f.writeUInt8(f.readUInt8(u)^g,u),b>=2&&f.writeUInt8(f.readUInt8(u+1)^L,u+1),b>=3&&f.writeUInt8(f.readUInt8(u+2)^j,u+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function p(){const f=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;const i=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:k().os.tmpdir(),s=(0,P.join)(i,`vscode-ipc-${f}.sock`);return o(s),s}e.createRandomIPCHandle=p;function t(f,i,s){const u=k().crypto.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${s}-${i}-sock`;const b=s.substr(0,4),g=i.substr(0,6),L=u.substr(0,8);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${L}-${b}-${g}.sock`):j=(0,P.join)(f,`${b}-${g}.sock`),o(j),j}e.createStaticIPCHandle=t;function o(f){const i=y[T.platform];typeof i=="number"&&f.length>=i&&console.warn(`WARNING: IPC handle "${f}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends v.IPCServer{static b(i){const s=l.Event.fromNodeEventEmitter(i,"connection");return l.Event.map(s,u=>({protocol:new O.Protocol(new S(u,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(u,"close"))}))}constructor(i){super(r.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function c(f){return new Promise((i,s)=>{const u=k().net.createServer();u.on("error",s),u.listen(f,()=>{u.removeListener("error",s),i(new r(u))})})}e.serve=c;function m(f,i){return new Promise((s,u)=>{const b=k().net.createConnection(f,()=>{b.removeListener("error",u),s(O.Client.fromSocket(new S(b,`ipc-client${i}`),i))});b.once("error",u)})}e.connect=m}),define(Ie[166],Ce([1,0,39,15]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,P,T,D,v,O){if(Array.isArray(R)){let k=0;for(const S of R){const C=l(S,P,T,D,v,O);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof R=="string")return D?R==="*"?5:R===T?10:0:0;if(R){const{language:k,pattern:S,scheme:C,hasAccessToAllModels:I,notebookType:E}=R;if(!D&&!I)return 0;E&&v&&(P=v);let n=0;if(C)if(C===P.scheme)n=10;else if(C==="*")n=5;else return 0;if(k)if(k===T)n=10;else if(k==="*")n=Math.max(n,5);else return 0;if(E)if(E===O)n=10;else if(E==="*"&&O!==void 0)n=Math.max(n,5);else return 0;if(S){let d;if(typeof S=="string"?d=S:d={...S,base:(0,A.normalize)(S.base)},d===P.fsPath||(0,a.match)(d,P.fsPath))n=10;else return 0}return n}else return 0}}e.score=l}),define(Ie[167],Ce([1,0,9,53,156]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(T,D,v,O){this.d=T,this.f=D,this.g=v,this.h=O,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const D=T.changes;for(const v of D)this.o(v.range),this.p(new A.Position(v.range.startLineNumber,v.range.startColumn),v.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,D=this.f.length,v=new Uint32Array(D);for(let O=0;O<D;O++)v[O]=this.f[O].length+T;this.j=new l.PrefixSumComputer(v)}}n(T,D){this.f[T]=D,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,D){if(D.length===0)return;const v=(0,a.splitLines)(D);if(v.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+v[0]+this.f[T.lineNumber-1].substring(T.column-1));return}v[v.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+v[0]);const O=new Uint32Array(v.length-1);for(let k=1;k<v.length;k++)this.f.splice(T.lineNumber+k-1,0,v[k]),O[k-1]=v[k].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,O)}}e.MirrorTextModel=R}),define(Ie[168],Ce([1,0,9,153,53,32,108]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class D{constructor(h,w,y,p){this.searchString=h,this.isRegex=w,this.matchCase=y,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=v(this.searchString):h=this.searchString.indexOf(`
`)>=0;let w=null;try{w=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!w)return null;let y=!this.isRegex&&!h;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new P.SearchData(w,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=D;function v(d){if(!d||d.length===0)return!1;for(let h=0,w=d.length;h<w;h++){const y=d.charCodeAt(h);if(y===10)return!0;if(y===92){if(h++,h>=w)break;const p=d.charCodeAt(h);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=v;function O(d,h,w){if(!w)return new P.FindMatch(d,null);const y=[];for(let p=0,t=h.length;p<t;p++)y[p]=h[p];return new P.FindMatch(d,y)}e.createFindMatch=O;class k{constructor(h){const w=[];let y=0;for(let p=0,t=h.length;p<t;p++)h.charCodeAt(p)===10&&(w[y++]=p);this.a=w}findLineFeedCountBeforeOffset(h){const w=this.a;let y=0,p=w.length-1;if(p===-1||h<=w[0])return 0;for(;y<p;){const t=y+((p-y)/2>>0);w[t]>=h?p=t-1:w[t+1]>=h?(y=t,p=t):y=t+1}return y+1}}class S{static findMatches(h,w,y,p,t){const o=w.parseSearchRequest();return o?o.regex.multiline?this.b(h,y,new n(o.wordSeparators,o.regex),p,t):this.c(h,y,o,p,t):[]}static a(h,w,y,p,t,o){let r,c=0;p?(c=p.findLineFeedCountBeforeOffset(t),r=w+t+c):r=w+t;let m;if(p){const u=p.findLineFeedCountBeforeOffset(t+o.length)-c;m=r+o.length+u}else m=r+o.length;const f=h.getPositionAt(r),i=h.getPositionAt(m);return new R.Range(f.lineNumber,f.column,i.lineNumber,i.column)}static b(h,w,y,p,t){const o=h.getOffsetAt(w.getStartPosition()),r=h.getValueInRange(w,1),c=h.getEOL()===`\r
`?new k(r):null,m=[];let f=0,i;for(y.reset(0);i=y.next(r);)if(m[f++]=O(this.a(h,o,r,c,i.index,i[0]),i,p),f>=t)return m;return m}static c(h,w,y,p,t){const o=[];let r=0;if(w.startLineNumber===w.endLineNumber){const m=h.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return r=this.d(y,m,w.startLineNumber,w.startColumn-1,r,o,p,t),o}const c=h.getLineContent(w.startLineNumber).substring(w.startColumn-1);r=this.d(y,c,w.startLineNumber,w.startColumn-1,r,o,p,t);for(let m=w.startLineNumber+1;m<w.endLineNumber&&r<t;m++)r=this.d(y,h.getLineContent(m),m,0,r,o,p,t);if(r<t){const m=h.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);r=this.d(y,m,w.endLineNumber,0,r,o,p,t)}return o}static d(h,w,y,p,t,o,r,c){const m=h.wordSeparators;if(!r&&h.simpleSearch){const s=h.simpleSearch,u=s.length,b=w.length;let g=-u;for(;(g=w.indexOf(s,g+u))!==-1;)if((!m||E(m,w,b,g,u))&&(o[t++]=new P.FindMatch(new R.Range(y,g+1+p,y,g+1+u+p),null),t>=c))return t;return t}const f=new n(h.wordSeparators,h.regex);let i;f.reset(0);do if(i=f.next(w),i&&(o[t++]=O(new R.Range(y,i.index+1+p,y,i.index+1+i[0].length+p),i,r),t>=c))return t;while(i);return t}static findNextMatch(h,w,y,p){const t=w.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.e(h,y,o,p):this.f(h,y,o,p)}static e(h,w,y,p){const t=new l.Position(w.lineNumber,1),o=h.getOffsetAt(t),r=h.getLineCount(),c=h.getValueInRange(new R.Range(t.lineNumber,t.column,r,h.getLineMaxColumn(r)),1),m=h.getEOL()===`\r
`?new k(c):null;y.reset(w.column-1);const f=y.next(c);return f?O(this.a(h,o,c,m,f.index,f[0]),f,p):w.lineNumber!==1||w.column!==1?this.e(h,new l.Position(1,1),y,p):null}static f(h,w,y,p){const t=h.getLineCount(),o=w.lineNumber,r=h.getLineContent(o),c=this.g(y,r,o,w.column,p);if(c)return c;for(let m=1;m<=t;m++){const f=(o+m-1)%t,i=h.getLineContent(f+1),s=this.g(y,i,f+1,1,p);if(s)return s}return null}static g(h,w,y,p,t){h.reset(p-1);const o=h.next(w);return o?O(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,t):null}static findPreviousMatch(h,w,y,p){const t=w.parseSearchRequest();if(!t)return null;const o=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.h(h,y,o,p):this.j(h,y,o,p)}static h(h,w,y,p){const t=this.b(h,new R.Range(1,1,w.lineNumber,w.column),y,p,10*T);if(t.length>0)return t[t.length-1];const o=h.getLineCount();return w.lineNumber!==o||w.column!==h.getLineMaxColumn(o)?this.h(h,new l.Position(o,h.getLineMaxColumn(o)),y,p):null}static j(h,w,y,p){const t=h.getLineCount(),o=w.lineNumber,r=h.getLineContent(o).substring(0,w.column-1),c=this.k(y,r,o,p);if(c)return c;for(let m=1;m<=t;m++){const f=(t+o-m-1)%t,i=h.getLineContent(f+1),s=this.k(y,i,f+1,p);if(s)return s}return null}static k(h,w,y,p){let t=null,o;for(h.reset(0);o=h.next(w);)t=O(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,p);return t}}e.TextModelSearch=S;function C(d,h,w,y,p){if(y===0)return!0;const t=h.charCodeAt(y-1);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=h.charCodeAt(y);if(d.get(o)!==0)return!0}return!1}function I(d,h,w,y,p){if(y+p===w)return!0;const t=h.charCodeAt(y+p);if(d.get(t)!==0||t===13||t===10)return!0;if(p>0){const o=h.charCodeAt(y+p-1);if(d.get(o)!==0)return!0}return!1}function E(d,h,w,y,p){return C(d,h,w,y,p)&&I(d,h,w,y,p)}e.isValidMatch=E;class n{constructor(h,w){this._wordSeparators=h,this.a=w,this.b=-1,this.c=0}reset(h){this.a.lastIndex=h,this.b=-1,this.c=0}next(h){const w=h.length;let y;do{if(this.b+this.c===w||(y=this.a.exec(h),!y))return null;const p=y.index,t=y[0].length;if(p===this.b&&t===this.c){if(t===0){a.getNextCodePoint(h,w,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=t,!this._wordSeparators||E(this._wordSeparators,h,w,p,t))return y}while(y);return null}}e.Searcher=n}),define(Ie[121],Ce([1,0,22,14]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(l||(l={}));function R(k){for(let S=0,C=k.length;S<C;S+=4){const I=k[S+0],E=k[S+1],n=k[S+2],d=k[S+3];k[S+0]=d,k[S+1]=n,k[S+2]=E,k[S+3]=I}}function P(k){const S=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||R(S),a.VSBuffer.wrap(S)}function T(k){const S=k.buffer;if(A.isLittleEndian()||R(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const C=new Uint8Array(S.byteLength);return C.set(S),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function D(k){const S=new Uint32Array(v(k));let C=0;if(S[C++]=k.id,k.type==="full")S[C++]=1,S[C++]=k.data.length,S.set(k.data,C),C+=k.data.length;else{S[C++]=2,S[C++]=k.deltas.length;for(const I of k.deltas)S[C++]=I.start,S[C++]=I.deleteCount,I.data?(S[C++]=I.data.length,S.set(I.data,C),C+=I.data.length):S[C++]=0}return P(S)}e.encodeSemanticTokensDto=D;function v(k){let S=0;if(S+=1+1,k.type==="full")S+=1+k.data.length;else{S+=1,S+=(1+1+1)*k.deltas.length;for(const C of k.deltas)C.data&&(S+=C.data.length)}return S}function O(k){const S=T(k);let C=0;const I=S[C++];if(S[C++]===1){const h=S[C++],w=S.subarray(C,C+h);return C+=h,{id:I,type:"full",data:w}}const n=S[C++],d=[];for(let h=0;h<n;h++){const w=S[C++],y=S[C++],p=S[C++];let t;p>0&&(t=S.subarray(C,C+p),C+=p),d[h]={start:w,deleteCount:y,data:t}}return{id:I,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ie[169],Ce([1,0,3,6]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,D){return this.a.set(T,D),this.handleChange([T]),(0,A.toDisposable)(()=>{this.a.get(T)===D&&(this.a.delete(T),this.handleChange([T]))})}get(T){return this.a.get(T)||null}registerFactory(T,D){this.b.get(T)?.dispose();const v=new R(this,T,D);return this.b.set(T,v),(0,A.toDisposable)(()=>{const O=this.b.get(T);!O||O!==v||(this.b.delete(T),O.dispose())})}async getOrCreate(T){const D=this.get(T);if(D)return D;const v=this.b.get(T);return!v||v.isResolved?null:(await v.resolve(),this.get(T))}isResolved(T){if(this.get(T))return!0;const v=this.b.get(T);return!!(!v||v.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class R extends A.Disposable{get isResolved(){return this.c}constructor(T,D,v){super(),this.f=T,this.g=D,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await this.h.tokenizationSupport;this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Ie[72],Ce([1,0,67,2,32,169]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class P{constructor(b,g,L){this.offset=b,this.type=g,this.language=L,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=P;class T{constructor(b,g){this.tokens=b,this.endState=g,this._tokenizationResultBrand=void 0}}e.TokenizationResult=T;class D{constructor(b,g){this.tokens=b,this.endState=g,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=D;var v;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(v=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(u){const b=new Map;b.set(0,a.Codicon.symbolMethod),b.set(1,a.Codicon.symbolFunction),b.set(2,a.Codicon.symbolConstructor),b.set(3,a.Codicon.symbolField),b.set(4,a.Codicon.symbolVariable),b.set(5,a.Codicon.symbolClass),b.set(6,a.Codicon.symbolStruct),b.set(7,a.Codicon.symbolInterface),b.set(8,a.Codicon.symbolModule),b.set(9,a.Codicon.symbolProperty),b.set(10,a.Codicon.symbolEvent),b.set(11,a.Codicon.symbolOperator),b.set(12,a.Codicon.symbolUnit),b.set(13,a.Codicon.symbolValue),b.set(15,a.Codicon.symbolEnum),b.set(14,a.Codicon.symbolConstant),b.set(15,a.Codicon.symbolEnum),b.set(16,a.Codicon.symbolEnumMember),b.set(17,a.Codicon.symbolKeyword),b.set(27,a.Codicon.symbolSnippet),b.set(18,a.Codicon.symbolText),b.set(19,a.Codicon.symbolColor),b.set(20,a.Codicon.symbolFile),b.set(21,a.Codicon.symbolReference),b.set(22,a.Codicon.symbolCustomColor),b.set(23,a.Codicon.symbolFolder),b.set(24,a.Codicon.symbolTypeParameter),b.set(25,a.Codicon.account),b.set(26,a.Codicon.issues);function g(G){let Q=b.get(G);return Q||(console.info("No codicon found for CompletionItemKind "+G),Q=a.Codicon.symbolProperty),Q}u.toIcon=g;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function j(G,Q){let B=L.get(G);return typeof B>"u"&&!Q&&(B=9),B}u.fromString=j})(O=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(u){u[u.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(u){u[u.None=0]="None",u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var I;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(I=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(u){return u&&A.URI.isUri(u.uri)&&l.Range.isIRange(u.range)&&(l.Range.isIRange(u.originSelectionRange)||l.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=h;var w;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(w=e.SymbolKind||(e.SymbolKind={}));var y;(function(u){u[u.Deprecated=1]="Deprecated"})(y=e.SymbolTag||(e.SymbolTag={}));var p;(function(u){const b=new Map;b.set(0,a.Codicon.symbolFile),b.set(1,a.Codicon.symbolModule),b.set(2,a.Codicon.symbolNamespace),b.set(3,a.Codicon.symbolPackage),b.set(4,a.Codicon.symbolClass),b.set(5,a.Codicon.symbolMethod),b.set(6,a.Codicon.symbolProperty),b.set(7,a.Codicon.symbolField),b.set(8,a.Codicon.symbolConstructor),b.set(9,a.Codicon.symbolEnum),b.set(10,a.Codicon.symbolInterface),b.set(11,a.Codicon.symbolFunction),b.set(12,a.Codicon.symbolVariable),b.set(13,a.Codicon.symbolConstant),b.set(14,a.Codicon.symbolString),b.set(15,a.Codicon.symbolNumber),b.set(16,a.Codicon.symbolBoolean),b.set(17,a.Codicon.symbolArray),b.set(18,a.Codicon.symbolObject),b.set(19,a.Codicon.symbolKey),b.set(20,a.Codicon.symbolNull),b.set(21,a.Codicon.symbolEnumMember),b.set(22,a.Codicon.symbolStruct),b.set(23,a.Codicon.symbolEvent),b.set(24,a.Codicon.symbolOperator),b.set(25,a.Codicon.symbolTypeParameter);function g(L){let j=b.get(L);return j||(console.info("No codicon found for SymbolKind "+L),j=a.Codicon.symbolProperty),j}u.toIcon=g})(p=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(b){switch(b){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(b)}constructor(b){this.value=b}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var o;(function(u){function b(g){return!g||typeof g!="object"?!1:typeof g.id=="string"&&typeof g.title=="string"}u.is=b})(o=e.Command||(e.Command={}));var r;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var m;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var f;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={}));class i{constructor(b){this.b=b,this.a=null}dispose(){this.a&&this.a.then(b=>{b&&b.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=i,e.TokenizationRegistry=new R.TokenizationRegistry;var s;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[170],Ce([12,13]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(Ie[122],Ce([1,0,170,14,107,17,23,152]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=v;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class k{constructor(Y,me,Le,Ne){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=Ne}applyUpdate(Y,me){return C(Y,me)}compute(Y,me,Le){return Le}}class S{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=S;function C(W,Y){if(typeof W!="object"||typeof Y!="object"||!W||!Y)return new S(Y,W!==Y);if(Array.isArray(W)||Array.isArray(Y)){const Le=Array.isArray(W)&&Array.isArray(Y)&&R.equals(W,Y);return new S(Y,!Le)}let me=!1;for(const Le in Y)if(Y.hasOwnProperty(Le)){const Ne=C(W[Le],Y[Le]);Ne.didChange&&(W[Le]=Ne.newValue,me=!0)}return new S(W,me)}class I{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return C(Y,me)}validate(Y){return this.defaultValue}}class E{constructor(Y,me,Le,Ne){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=Ne}applyUpdate(Y,me){return C(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Le){return Le}}function n(W,Y){return typeof W>"u"?Y:W==="false"?!1:Boolean(W)}e.boolean=n;class d extends E{constructor(Y,me,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(Y,me,Le,Ne)}validate(Y){return n(Y,this.defaultValue)}}function h(W,Y,me,Le){if(typeof W>"u")return Y;let Ne=parseInt(W,10);return isNaN(Ne)?Y:(Ne=Math.max(me,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=h;class w extends E{static clampedInt(Y,me,Le,Ne){return h(Y,me,Le,Ne)}constructor(Y,me,Le,Ne,xe,Qe=void 0){typeof Qe<"u"&&(Qe.type="integer",Qe.default=Le,Qe.minimum=Ne,Qe.maximum=xe),super(Y,me,Le,Qe),this.minimum=Ne,this.maximum=xe}validate(Y){return w.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class y extends E{static clamp(Y,me,Le){return Y<me?me:Y>Le?Le:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Le=parseFloat(Y);return isNaN(Le)?me:Le}constructor(Y,me,Le,Ne,xe){typeof xe<"u"&&(xe.type="number",xe.default=Le),super(Y,me,Le,xe),this.validationFn=Ne}validate(Y){return this.validationFn(y.float(Y,this.defaultValue))}}class p extends E{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(Y,me,Le,Ne)}validate(Y){return p.string(Y,this.defaultValue)}}function t(W,Y,me){return typeof W!="string"||me.indexOf(W)===-1?Y:W}e.stringSet=t;class o extends E{constructor(Y,me,Le,Ne,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ne,xe.default=Le),super(Y,me,Le,xe),this.c=Ne}validate(Y){return t(Y,this.defaultValue,this.c)}}class r extends k{constructor(Y,me,Le,Ne,xe,Qe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=xe,Xe.default=Ne),super(Y,me,Le,Xe),this.c=xe,this.d=Qe}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function c(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Le){return Le===0?Y.accessibilitySupport:Le}}class f extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(W){switch(W){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function g(W){switch(W){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class L extends I{constructor(){super(136)}compute(Y,me,Le){const Ne=["monaco-editor"];return me.get(37)&&Ne.push(me.get(37)),Y.extraEditorClassName&&Ne.push(Y.extraEditorClassName),me.get(71)==="default"?Ne.push("mouse-default"):me.get(71)==="copy"&&Ne.push("mouse-copy"),me.get(106)&&Ne.push("showUnused"),me.get(134)&&Ne.push("showDeprecated"),Ne.join(" ")}}class j extends d{constructor(){super(35,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Y,me,Le){return Le&&Y.emptySelectionClipboard}}class G extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:a.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:a.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class Q extends k{constructor(){super(49,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?Q.OFF:Y==="true"?Q.ON:Y:Boolean(Y)?Q.ON:Q.OFF}}Q.OFF='"liga" off, "calt" off',Q.ON='"liga" on, "calt" on',e.EditorFontLigatures=Q;class B extends k{constructor(){super(52,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?B.OFF:Y==="true"?B.TRANSLATE:Y:Boolean(Y)?B.TRANSLATE:B.OFF}compute(Y,me,Le){return Y.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class U extends I{constructor(){super(48)}compute(Y,me,Le){return Y.fontInfo}}class z extends E{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(Y){const me=y.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(me,6,100)}compute(Y,me,Le){return Y.fontInfo.fontSize}}class M extends k{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.d,maximum:M.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(w.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,M.d,M.e))}}M.c=["normal","bold","100","200","300","400","500","600","700","800","900"],M.d=1,M.e=1e3;class x extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Le,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Le,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Le,description:a.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:t(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??t(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??t(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??t(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??t(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??t(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends k{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:a.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:w.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky),above:n(me.above,this.defaultValue.above)}}}var re;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(re=e.RenderMinimap||(e.RenderMinimap={}));class V extends I{constructor(){super(139)}compute(Y,me,Le){return V.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Le=Math.floor(Y.paddingTop/Y.lineHeight);let Ne=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ne=Math.max(Ne,me-1));const xe=(Le+Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),Qe=Math.floor(Y.viewLineCount/xe);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:xe,minimapLineCount:Qe}}static c(Y,me){const Le=Y.outerWidth,Ne=Y.outerHeight,xe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Qe=me.stableMinimapLayoutInput,Xe=Qe&&Y.outerHeight===Qe.outerHeight&&Y.lineHeight===Qe.lineHeight&&Y.typicalHalfwidthCharacterWidth===Qe.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Qe.pixelRatio&&Y.scrollBeyondLastLine===Qe.scrollBeyondLastLine&&Y.paddingTop===Qe.paddingTop&&Y.paddingBottom===Qe.paddingBottom&&Y.minimap.enabled===Qe.minimap.enabled&&Y.minimap.side===Qe.minimap.side&&Y.minimap.size===Qe.minimap.size&&Y.minimap.showSlider===Qe.minimap.showSlider&&Y.minimap.renderCharacters===Qe.minimap.renderCharacters&&Y.minimap.maxColumn===Qe.minimap.maxColumn&&Y.minimap.scale===Qe.minimap.scale&&Y.verticalScrollbarWidth===Qe.verticalScrollbarWidth&&Y.isViewportWrapping===Qe.isViewportWrapping,rt=Y.lineHeight,ct=Y.typicalHalfwidthCharacterWidth,vt=Y.scrollBeyondLastLine,mt=Y.minimap.renderCharacters;let wt=xe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Ct=Y.minimap.maxColumn,Lt=Y.minimap.size,Yt=Y.minimap.side,Kt=Y.verticalScrollbarWidth,ht=Y.viewLineCount,gt=Y.remainingWidth,Ot=Y.isViewportWrapping,Mt=mt?2:3;let Tt=Math.floor(xe*Ne);const pt=Tt/xe;let Dt=!1,zt=!1,kt=Mt*wt,Ke=wt/xe,Vt=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ze,desiredRatio:qe,minimapLineCount:et}=V.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:vt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ne,lineHeight:rt,pixelRatio:xe});if(ht/et>1)Dt=!0,zt=!0,wt=1,kt=1,Ke=wt/xe;else{let ut=!1,It=wt+1;if(Lt==="fit"){const bt=Math.ceil((He+ht+Ze)*kt);Ot&&Xe&&gt<=me.stableFitRemainingWidth?(ut=!0,It=me.stableFitMaxMinimapScale):ut=bt>Tt}if(Lt==="fill"||ut){Dt=!0;const bt=wt;kt=Math.min(rt*xe,Math.max(1,Math.floor(1/qe))),Ot&&Xe&&gt<=me.stableFitRemainingWidth&&(It=me.stableFitMaxMinimapScale),wt=Math.min(It,Math.max(1,Math.floor(kt/Mt))),wt>bt&&(Vt=Math.min(2,wt/bt)),Ke=wt/xe/Vt,Tt=Math.ceil(Math.max(Fe,He+ht+Ze)*kt),Ot?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=gt,me.stableFitMaxMinimapScale=wt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Xt=Math.floor(Ct*Ke),Ut=Math.min(Xt,Math.max(0,Math.floor((gt-Kt-2)*Ke/(ct+Ke)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(xe*Ut);const Oe=Ae/xe;Ae=Math.floor(Ae*Vt);const De=mt?1:2,oe=Yt==="left"?0:Le-Ut-Kt;return{renderMinimap:De,minimapLeft:oe,minimapWidth:Ut,minimapHeightIsEditorHeight:Dt,minimapIsSampling:zt,minimapScale:wt,minimapLineHeight:kt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:pt}}static computeLayout(Y,me){const Le=me.outerWidth|0,Ne=me.outerHeight|0,xe=me.lineHeight|0,Qe=me.lineNumbersDigitCount|0,Xe=me.typicalHalfwidthCharacterWidth,rt=me.maxDigitWidth,ct=me.pixelRatio,vt=me.viewLineCount,mt=Y.get(131),wt=mt==="inherit"?Y.get(130):mt,Ct=wt==="inherit"?Y.get(126):wt,Lt=Y.get(129),Yt=me.isDominatedByLongLines,Kt=Y.get(55),ht=Y.get(65).renderType!==0,gt=Y.get(66),Ot=Y.get(100),Mt=Y.get(81),Tt=Y.get(70),pt=Y.get(98),Dt=pt.verticalScrollbarSize,zt=pt.verticalHasArrows,kt=pt.arrowSize,Ke=pt.horizontalScrollbarSize,Vt=Y.get(41),Xt=Y.get(105)!=="never";let Ut=Y.get(63);Vt&&Xt&&(Ut+=16);let Ae=0;if(ht){const Bt=Math.max(Qe,gt);Ae=Math.round(Bt*rt)}let Oe=0;Kt&&(Oe=xe);let De=0,oe=De+Oe,Fe=oe+Ae,He=Fe+Ut;const Ze=Le-Oe-Ae-Ut;let qe=!1,et=!1,dt=-1;wt==="inherit"&&Yt?(qe=!0,et=!0):Ct==="on"||Ct==="bounded"?et=!0:Ct==="wordWrapColumn"&&(dt=Lt);const ut=V.c({outerWidth:Le,outerHeight:Ne,lineHeight:xe,typicalHalfwidthCharacterWidth:Xe,pixelRatio:ct,scrollBeyondLastLine:Ot,paddingTop:Mt.top,paddingBottom:Mt.bottom,minimap:Tt,verticalScrollbarWidth:Dt,viewLineCount:vt,remainingWidth:Ze,isViewportWrapping:et},me.memory||new O);ut.renderMinimap!==0&&ut.minimapLeft===0&&(De+=ut.minimapWidth,oe+=ut.minimapWidth,Fe+=ut.minimapWidth,He+=ut.minimapWidth);const It=Ze-ut.minimapWidth,bt=Math.max(1,Math.floor((It-Dt-2)/Xe)),Nt=zt?kt:0;return et&&(dt=Math.max(1,bt),Ct==="bounded"&&(dt=Math.min(dt,Lt))),{width:Le,height:Ne,glyphMarginLeft:De,glyphMarginWidth:Oe,lineNumbersLeft:oe,lineNumbersWidth:Ae,decorationsLeft:Fe,decorationsWidth:Ut,contentLeft:He,contentWidth:It,minimap:ut,viewportColumn:bt,isWordWrapMinified:qe,isViewportWrapping:et,wrappingColumn:dt,verticalScrollbarWidth:Dt,horizontalScrollbarHeight:Ke,overviewRuler:{top:Nt,width:Dt,height:Ne-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=V;class _ extends k{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(Y){return t(Y,"simple",["simple","advanced"])}compute(Y,me,Le){return me.get(2)===2?"advanced":Le}}class te extends k{constructor(){const Y={enabled:!0};super(62,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:a.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:n(Y.enabled,this.defaultValue.enabled)}}}class ve extends k{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:a.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:t(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class le extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:a.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(54,null),a.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:a.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:a.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:a.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:t(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(me.fontFamily,this.defaultValue.fontFamily),padding:n(me.padding,this.defaultValue.padding)}}}class ue extends k{constructor(){super(63,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):w.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,me,Le){return Le<0?w.clampedInt(-Le*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class q extends y{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>y.clamp(Y,0,150),{markdownDescription:a.localize(61,null)})}compute(Y,me,Le){return Y.fontInfo.lineHeight}}class F extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:a.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:a.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)],default:Y.size,description:a.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:a.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:a.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:a.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:a.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),autohide:n(me.autohide,this.defaultValue.autohide),size:t(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(me.side,this.defaultValue.side,["right","left"]),showSlider:t(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(me.scale,1,1,3),maxColumn:w.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function J(W){return W==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ge extends k{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:w.clampedInt(me.top,0,0,1e3),bottom:w.clampedInt(me.bottom,0,0,1e3)}}}class Ee extends k{constructor(){const Y={enabled:!0,cycle:!0};super(82,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:a.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:a.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class ie extends I{constructor(){super(137)}compute(Y,me,Le){return Y.pixelRatio}}class ne extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null)]}];super(85,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:a.localize(80,null)},comments:{anyOf:me,default:Y.comments,description:a.localize(81,null)},other:{anyOf:me,default:Y.other,description:a.localize(82,null)}},default:Y,markdownDescription:a.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const ct=Y?"on":"off";return{comments:ct,strings:ct,other:ct}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Le,strings:Ne}=Y,xe=["on","inline","off"];let Qe,Xe,rt;return typeof me=="boolean"?Qe=me?"on":"off":Qe=t(me,this.defaultValue.other,xe),typeof Le=="boolean"?Xe=Le?"on":"off":Xe=t(Le,this.defaultValue.comments,xe),typeof Ne=="boolean"?rt=Ne?"on":"off":rt=t(Ne,this.defaultValue.strings,xe),{other:Qe,comments:Xe,strings:rt}}}var de;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends k{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"on",description:a.localize(88,null)})}validate(Y){let me=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Le=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Le}}}function ce(W){const Y=W.get(93);return Y==="editable"?W.get(87):Y!=="on"}e.filterValidationDecorations=ce;class ae extends k{constructor(){const Y=[],me={type:"number",description:a.localize(89,null)};super(97,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:a.localize(90,null),format:"color-hex"}}}]},default:Y,description:a.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Le of Y)if(typeof Le=="number")me.push({column:w.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;me.push({column:w.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return me.sort((Le,Ne)=>Le.column-Ne.column),me}return this.defaultValue}}function N(W,Y){if(typeof W!="string")return Y;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:"auto",description:a.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:"auto",description:a.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:a.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:a.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Le=w.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=w.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(me.vertical,this.defaultValue.vertical),horizontal:N(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:w.clampedInt(me.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:w.clampedInt(me.verticalSliderSize,Ne,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:a.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:a.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:a.localize(109,null)}})}applyUpdate(Y,me){let Le=!1;me.allowedCharacters&&Y&&(P.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Le=!0)),me.allowedLocales&&Y&&(P.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Le=!0));const Ne=super.applyUpdate(Y,me);return Le?new S(Ne.newValue,!0):Ne}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:Re(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Re(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Re(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,me){if(typeof Y!="object"||!Y)return me;const Le={};for(const[Ne,xe]of Object.entries(Y))xe===!0&&(Le[Ne]=!0);return Le}}class Z extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!0};super(60,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:a.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(111,null),a.localize(112,null)],description:a.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:a.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:t(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(me.suppressSuggestions,this.defaultValue.suppressSuggestions)}}}class he extends k{constructor(){const Y={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:a.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:a.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:n(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Se extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(117,null),a.localize(118,null),a.localize(119,null)],default:Y.bracketPairs,description:a.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],default:Y.bracketPairsHorizontal,description:a.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:a.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:a.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(127,null),a.localize(128,null),a.localize(129,null)],default:Y.highlightActiveIndentation,description:a.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:Re(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Re(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:Re(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Re(W,Y,me){const Le=me.indexOf(W);return Le===-1?Y:me[Le]}class we extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(131,null),a.localize(132,null)],default:Y.insertMode,description:a.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:a.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:a.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:a.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(137,null),a.localize(138,null),a.localize(139,null),a.localize(140,null)],default:Y.selectionMode,markdownDescription:a.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:a.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:a.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:a.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:a.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:a.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:t(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:t(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(179,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class je extends k{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),a.localize(183,null)],description:a.localize(184,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,me,Le){return me.get(2)===2?0:Le}}class We extends I{constructor(){super(140)}compute(Y,me,Le){const Ne=me.get(139);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class tt extends k{constructor(){const Y={enabled:!0};super(34,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:a.localize(185,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:n(Y.enabled,this.defaultValue.enabled)}}}const Ye="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?nt:A.isLinux?st:Ye,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(W){return e.editorOptionsRegistry[W.id]=W,W}var it;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",W[W.autoClosingDelete=7]="autoClosingDelete",W[W.autoClosingOvertype=8]="autoClosingOvertype",W[W.autoClosingQuotes=9]="autoClosingQuotes",W[W.autoIndent=10]="autoIndent",W[W.automaticLayout=11]="automaticLayout",W[W.autoSurround=12]="autoSurround",W[W.bracketPairColorization=13]="bracketPairColorization",W[W.guides=14]="guides",W[W.codeLens=15]="codeLens",W[W.codeLensFontFamily=16]="codeLensFontFamily",W[W.codeLensFontSize=17]="codeLensFontSize",W[W.colorDecorators=18]="colorDecorators",W[W.colorDecoratorsLimit=19]="colorDecoratorsLimit",W[W.columnSelection=20]="columnSelection",W[W.comments=21]="comments",W[W.contextmenu=22]="contextmenu",W[W.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",W[W.cursorBlinking=24]="cursorBlinking",W[W.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",W[W.cursorStyle=26]="cursorStyle",W[W.cursorSurroundingLines=27]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",W[W.cursorWidth=29]="cursorWidth",W[W.disableLayerHinting=30]="disableLayerHinting",W[W.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",W[W.domReadOnly=32]="domReadOnly",W[W.dragAndDrop=33]="dragAndDrop",W[W.dropIntoEditor=34]="dropIntoEditor",W[W.emptySelectionClipboard=35]="emptySelectionClipboard",W[W.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",W[W.extraEditorClassName=37]="extraEditorClassName",W[W.fastScrollSensitivity=38]="fastScrollSensitivity",W[W.find=39]="find",W[W.fixedOverflowWidgets=40]="fixedOverflowWidgets",W[W.folding=41]="folding",W[W.foldingStrategy=42]="foldingStrategy",W[W.foldingHighlight=43]="foldingHighlight",W[W.foldingImportsByDefault=44]="foldingImportsByDefault",W[W.foldingMaximumRegions=45]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=47]="fontFamily",W[W.fontInfo=48]="fontInfo",W[W.fontLigatures=49]="fontLigatures",W[W.fontSize=50]="fontSize",W[W.fontWeight=51]="fontWeight",W[W.fontVariations=52]="fontVariations",W[W.formatOnPaste=53]="formatOnPaste",W[W.formatOnType=54]="formatOnType",W[W.glyphMargin=55]="glyphMargin",W[W.gotoLocation=56]="gotoLocation",W[W.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",W[W.hover=58]="hover",W[W.inDiffEditor=59]="inDiffEditor",W[W.inlineSuggest=60]="inlineSuggest",W[W.letterSpacing=61]="letterSpacing",W[W.lightbulb=62]="lightbulb",W[W.lineDecorationsWidth=63]="lineDecorationsWidth",W[W.lineHeight=64]="lineHeight",W[W.lineNumbers=65]="lineNumbers",W[W.lineNumbersMinChars=66]="lineNumbersMinChars",W[W.linkedEditing=67]="linkedEditing",W[W.links=68]="links",W[W.matchBrackets=69]="matchBrackets",W[W.minimap=70]="minimap",W[W.mouseStyle=71]="mouseStyle",W[W.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=73]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",W[W.multiCursorModifier=75]="multiCursorModifier",W[W.multiCursorPaste=76]="multiCursorPaste",W[W.multiCursorLimit=77]="multiCursorLimit",W[W.occurrencesHighlight=78]="occurrencesHighlight",W[W.overviewRulerBorder=79]="overviewRulerBorder",W[W.overviewRulerLanes=80]="overviewRulerLanes",W[W.padding=81]="padding",W[W.parameterHints=82]="parameterHints",W[W.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",W[W.quickSuggestions=85]="quickSuggestions",W[W.quickSuggestionsDelay=86]="quickSuggestionsDelay",W[W.readOnly=87]="readOnly",W[W.renameOnType=88]="renameOnType",W[W.renderControlCharacters=89]="renderControlCharacters",W[W.renderFinalNewline=90]="renderFinalNewline",W[W.renderLineHighlight=91]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=93]="renderValidationDecorations",W[W.renderWhitespace=94]="renderWhitespace",W[W.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",W[W.roundedSelection=96]="roundedSelection",W[W.rulers=97]="rulers",W[W.scrollbar=98]="scrollbar",W[W.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=100]="scrollBeyondLastLine",W[W.scrollPredominantAxis=101]="scrollPredominantAxis",W[W.selectionClipboard=102]="selectionClipboard",W[W.selectionHighlight=103]="selectionHighlight",W[W.selectOnLineNumbers=104]="selectOnLineNumbers",W[W.showFoldingControls=105]="showFoldingControls",W[W.showUnused=106]="showUnused",W[W.snippetSuggestions=107]="snippetSuggestions",W[W.smartSelect=108]="smartSelect",W[W.smoothScrolling=109]="smoothScrolling",W[W.stickyScroll=110]="stickyScroll",W[W.stickyTabStops=111]="stickyTabStops",W[W.stopRenderingLineAfter=112]="stopRenderingLineAfter",W[W.suggest=113]="suggest",W[W.suggestFontSize=114]="suggestFontSize",W[W.suggestLineHeight=115]="suggestLineHeight",W[W.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",W[W.suggestSelection=117]="suggestSelection",W[W.tabCompletion=118]="tabCompletion",W[W.tabIndex=119]="tabIndex",W[W.unicodeHighlighting=120]="unicodeHighlighting",W[W.unusualLineTerminators=121]="unusualLineTerminators",W[W.useShadowDOM=122]="useShadowDOM",W[W.useTabStops=123]="useTabStops",W[W.wordBreak=124]="wordBreak",W[W.wordSeparators=125]="wordSeparators",W[W.wordWrap=126]="wordWrap",W[W.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=129]="wordWrapColumn",W[W.wordWrapOverride1=130]="wordWrapOverride1",W[W.wordWrapOverride2=131]="wordWrapOverride2",W[W.wrappingIndent=132]="wrappingIndent",W[W.wrappingStrategy=133]="wrappingStrategy",W[W.showDeprecated=134]="showDeprecated",W[W.inlayHints=135]="inlayHints",W[W.editorClassName=136]="editorClassName",W[W.pixelRatio=137]="pixelRatio",W[W.tabFocusMode=138]="tabFocusMode",W[W.layoutInfo=139]="layoutInfo",W[W.wrappingInfo=140]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(186,null)})),acceptSuggestionOnEnter:Be(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(187,null),""],markdownDescription:a.localize(188,null)})),accessibilitySupport:Be(new m),accessibilityPageSize:Be(new w(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(189,null),tags:["accessibility"]})),ariaLabel:Be(new p(4,"ariaLabel",a.localize(190,null))),screenReaderAnnounceInlineSuggestion:Be(new d(6,"screenReaderAnnounceInlineSuggestion",!1,{description:a.localize(191,null),tags:["accessibility"]})),autoClosingBrackets:Be(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(192,null),a.localize(193,null),""],description:a.localize(194,null)})),autoClosingDelete:Be(new o(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(195,null),""],description:a.localize(196,null)})),autoClosingOvertype:Be(new o(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(197,null),""],description:a.localize(198,null)})),autoClosingQuotes:Be(new o(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(199,null),a.localize(200,null),""],description:a.localize(201,null)})),autoIndent:Be(new r(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null),a.localize(206,null)],description:a.localize(207,null)})),automaticLayout:Be(new d(11,"automaticLayout",!1)),autoSurround:Be(new o(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(208,null),a.localize(209,null),a.localize(210,null),""],description:a.localize(211,null)})),bracketPairColorization:Be(new he),bracketPairGuides:Be(new Se),stickyTabStops:Be(new d(111,"stickyTabStops",!1,{description:a.localize(212,null)})),codeLens:Be(new d(15,"codeLens",!0,{description:a.localize(213,null)})),codeLensFontFamily:Be(new p(16,"codeLensFontFamily","",{description:a.localize(214,null)})),codeLensFontSize:Be(new w(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(215,null)})),colorDecorators:Be(new d(18,"colorDecorators",!0,{description:a.localize(216,null)})),colorDecoratorsLimit:Be(new w(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(217,null)})),columnSelection:Be(new d(20,"columnSelection",!1,{description:a.localize(218,null)})),comments:Be(new f),contextmenu:Be(new d(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new d(23,"copyWithSyntaxHighlighting",!0,{description:a.localize(219,null)})),cursorBlinking:Be(new r(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:a.localize(220,null)})),cursorSmoothCaretAnimation:Be(new o(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(221,null),a.localize(222,null),a.localize(223,null)],description:a.localize(224,null)})),cursorStyle:Be(new r(26,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:a.localize(225,null)})),cursorSurroundingLines:Be(new w(27,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(226,null)})),cursorSurroundingLinesStyle:Be(new o(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(227,null),a.localize(228,null)],description:a.localize(229,null)})),cursorWidth:Be(new w(29,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(230,null)})),disableLayerHinting:Be(new d(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new d(31,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new d(32,"domReadOnly",!1)),dragAndDrop:Be(new d(33,"dragAndDrop",!0,{description:a.localize(231,null)})),emptySelectionClipboard:Be(new j),dropIntoEditor:Be(new tt),stickyScroll:Be(new ve),experimentalWhitespaceRendering:Be(new o(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(232,null),a.localize(233,null),a.localize(234,null)],description:a.localize(235,null)})),extraEditorClassName:Be(new p(37,"extraEditorClassName","")),fastScrollSensitivity:Be(new y(38,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:a.localize(236,null)})),find:Be(new G),fixedOverflowWidgets:Be(new d(40,"fixedOverflowWidgets",!1)),folding:Be(new d(41,"folding",!0,{description:a.localize(237,null)})),foldingStrategy:Be(new o(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(238,null),a.localize(239,null)],description:a.localize(240,null)})),foldingHighlight:Be(new d(43,"foldingHighlight",!0,{description:a.localize(241,null)})),foldingImportsByDefault:Be(new d(44,"foldingImportsByDefault",!1,{description:a.localize(242,null)})),foldingMaximumRegions:Be(new w(45,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(243,null)})),unfoldOnClickAfterEndOfLine:Be(new d(46,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(244,null)})),fontFamily:Be(new p(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(245,null)})),fontInfo:Be(new U),fontLigatures2:Be(new Q),fontSize:Be(new z),fontWeight:Be(new M),fontVariations:Be(new B),formatOnPaste:Be(new d(53,"formatOnPaste",!1,{description:a.localize(246,null)})),formatOnType:Be(new d(54,"formatOnType",!1,{description:a.localize(247,null)})),glyphMargin:Be(new d(55,"glyphMargin",!0,{description:a.localize(248,null)})),gotoLocation:Be(new x),hideCursorInOverviewRuler:Be(new d(57,"hideCursorInOverviewRuler",!1,{description:a.localize(249,null)})),hover:Be(new fe),inDiffEditor:Be(new d(59,"inDiffEditor",!1)),letterSpacing:Be(new y(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>y.clamp(W,-5,20),{description:a.localize(250,null)})),lightbulb:Be(new te),lineDecorationsWidth:Be(new ue),lineHeight:Be(new q),lineNumbers:Be(new ee),lineNumbersMinChars:Be(new w(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new d(67,"linkedEditing",!1,{description:a.localize(251,null)})),links:Be(new d(68,"links",!0,{description:a.localize(252,null)})),matchBrackets:Be(new o(69,"matchBrackets","always",["always","near","never"],{description:a.localize(253,null)})),minimap:Be(new F),mouseStyle:Be(new o(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new y(72,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:a.localize(254,null)})),mouseWheelZoom:Be(new d(73,"mouseWheelZoom",!1,{markdownDescription:a.localize(255,null)})),multiCursorMergeOverlapping:Be(new d(74,"multiCursorMergeOverlapping",!0,{description:a.localize(256,null)})),multiCursorModifier:Be(new r(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],J,{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorPaste:Be(new o(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(260,null),a.localize(261,null)],markdownDescription:a.localize(262,null)})),multiCursorLimit:Be(new w(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(263,null)})),occurrencesHighlight:Be(new d(78,"occurrencesHighlight",!0,{description:a.localize(264,null)})),overviewRulerBorder:Be(new d(79,"overviewRulerBorder",!0,{description:a.localize(265,null)})),overviewRulerLanes:Be(new w(80,"overviewRulerLanes",3,0,3)),padding:Be(new ge),parameterHints:Be(new Ee),peekWidgetDefaultFocus:Be(new o(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(266,null),a.localize(267,null)],description:a.localize(268,null)})),definitionLinkOpensInPeek:Be(new d(84,"definitionLinkOpensInPeek",!1,{description:a.localize(269,null)})),quickSuggestions:Be(new ne),quickSuggestionsDelay:Be(new w(86,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(270,null)})),readOnly:Be(new d(87,"readOnly",!1)),renameOnType:Be(new d(88,"renameOnType",!1,{description:a.localize(271,null),markdownDeprecationMessage:a.localize(272,null)})),renderControlCharacters:Be(new d(89,"renderControlCharacters",!0,{description:a.localize(273,null),restricted:!0})),renderFinalNewline:Be(new o(90,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(274,null)})),renderLineHighlight:Be(new o(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(275,null)],description:a.localize(276,null)})),renderLineHighlightOnlyWhenFocus:Be(new d(92,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(277,null)})),renderValidationDecorations:Be(new o(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new o(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(278,null),a.localize(279,null),a.localize(280,null),""],description:a.localize(281,null)})),revealHorizontalRightPadding:Be(new w(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new d(96,"roundedSelection",!0,{description:a.localize(282,null)})),rulers:Be(new ae),scrollbar:Be(new $),scrollBeyondLastColumn:Be(new w(99,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(283,null)})),scrollBeyondLastLine:Be(new d(100,"scrollBeyondLastLine",!0,{description:a.localize(284,null)})),scrollPredominantAxis:Be(new d(101,"scrollPredominantAxis",!0,{description:a.localize(285,null)})),selectionClipboard:Be(new d(102,"selectionClipboard",!0,{description:a.localize(286,null),included:A.isLinux})),selectionHighlight:Be(new d(103,"selectionHighlight",!0,{description:a.localize(287,null)})),selectOnLineNumbers:Be(new d(104,"selectOnLineNumbers",!0)),showFoldingControls:Be(new o(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),showUnused:Be(new d(106,"showUnused",!0,{description:a.localize(292,null)})),showDeprecated:Be(new d(134,"showDeprecated",!0,{description:a.localize(293,null)})),inlayHints:Be(new le),snippetSuggestions:Be(new o(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(294,null),a.localize(295,null),a.localize(296,null),a.localize(297,null)],description:a.localize(298,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new d(109,"smoothScrolling",!1,{description:a.localize(299,null)})),stopRenderingLineAfter:Be(new w(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new we),inlineSuggest:Be(new Z),suggestFontSize:Be(new w(114,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(300,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new w(115,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(301,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new d(116,"suggestOnTriggerCharacters",!0,{description:a.localize(302,null)})),suggestSelection:Be(new o(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(303,null),a.localize(304,null),a.localize(305,null)],description:a.localize(306,null)})),tabCompletion:Be(new o(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(307,null),a.localize(308,null),a.localize(309,null)],description:a.localize(310,null)})),tabIndex:Be(new w(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new X),unusualLineTerminators:Be(new o(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(311,null),a.localize(312,null),a.localize(313,null)],description:a.localize(314,null)})),useShadowDOM:Be(new d(122,"useShadowDOM",!0)),useTabStops:Be(new d(123,"useTabStops",!0,{description:a.localize(315,null)})),wordBreak:Be(new o(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(316,null),a.localize(317,null)],description:a.localize(318,null)})),wordSeparators:Be(new p(125,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:a.localize(319,null)})),wordWrap:Be(new o(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(320,null),a.localize(321,null),a.localize(322,null),a.localize(323,null)],description:a.localize(324,null)})),wordWrapBreakAfterCharacters:Be(new p(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new p(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new w(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(325,null)})),wordWrapOverride1:Be(new o(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new o(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new L),pixelRatio:Be(new ie),tabFocusMode:Be(new d(138,"tabFocusMode",!1,{markdownDescription:a.localize(326,null)})),layoutInfo:Be(new V),wrappingInfo:Be(new We),wrappingIndent:Be(new je),wrappingStrategy:Be(new _)}}),define(Ie[171],Ce([12,13]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[172],Ce([12,13]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[173],Ce([12,13]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[174],Ce([12,13]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[175],Ce([12,13]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[176],Ce([12,13]),function(se,e){return se.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[177],Ce([12,13]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(Ie[178],Ce([12,13]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(Ie[179],Ce([12,13]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[180],Ce([12,13]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(Ie[181],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[182],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[183],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Ie[184],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[185],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[186],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[187],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[188],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[189],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[190],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[191],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[192],Ce([12,13]),function(se,e){return se.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[193],Ce([12,13]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(Ie[194],Ce([12,13]),function(se,e){return se.create("vs/workbench/common/views",e)}),define(Ie[195],Ce([12,13]),function(se,e){return se.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[196],Ce([12,13]),function(se,e){return se.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[197],Ce([12,13]),function(se,e){return se.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[198],Ce([12,13]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[199],Ce([12,13]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[200],Ce([12,13]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[201],Ce([12,13]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[202],Ce([12,13]),function(se,e){return se.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[203],Ce([1,0,8,173]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function R(...v){switch(v.length){case 1:return(0,A.localize)(0,null,v[0]);case 2:return(0,A.localize)(1,null,v[0],v[1]);case 3:return(0,A.localize)(2,null,v[0],v[1],v[2]);default:return}}const P=(0,A.localize)(3,null),T=(0,A.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const k=this.d,S=this.c.substring(this.d,this.e),C={type:19,offset:this.d,lexeme:S};this.g.push({offset:k,lexeme:S,additionalInfo:O}),this.f.push(C)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const k=this.c.substring(this.d,this.e),S=D.b.get(k);S?this.k(S):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,k=!1,S=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(T);return}const I=this.c.charCodeAt(O);if(k)k=!1;else if(I===47&&!S){O++;break}else I===91?S=!0:I===92?k=!0:I===93&&(S=!1);O++}for(;O<this.c.length&&D.a.has(this.c.charCodeAt(O));)O++;this.e=O;const C=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:C,offset:this.d})}r(){return this.e>=this.c.length}}D.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(Ie[204],Ce([1,0,24,38,175,326]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||P.test(d)}e.isValidVersionStr=D;function v(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(P);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=v;function O(d){if(!d)return null;const h=d.majorBase,w=d.majorMustEqual,y=d.minorBase;let p=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(h===0||(p=!1),o=!1);let r=0;if(d.preRelease){const c=T.exec(d.preRelease);if(c){const[,m,f,i]=c;r=Date.UTC(Number(m),Number(f)-1,Number(i))}}return{majorBase:h,majorMustEqual:w,minorBase:y,minorMustEqual:p,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function k(d,h,w){let y;typeof d=="string"?y=O(v(d)):y=d;let p;h instanceof Date?p=h.getTime():typeof h=="string"&&(p=new Date(h).getTime());let t;if(typeof w=="string"?t=O(v(w)):t=w,!y||!t)return!1;const o=y.majorBase,r=y.minorBase,c=y.patchBase;let m=t.majorBase,f=t.minorBase,i=t.patchBase;const s=t.notBefore;let u=t.majorMustEqual,b=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?o>m?!0:o<m?!1:r>f?!0:r<f||p&&p<s?!1:c>=i:(o===1&&m===0&&(!u||!b||!g)&&(m=1,f=0,i=0,u=!0,b=!1,g=!1),o<m?!1:o>m?!u:r<f?!1:r>f?!b:c<i?!1:c>i?!g:!(p&&p<s))}e.isValidVersion=k;function S(d,h,w,y,p){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([A.default.Error,l.localize(0,null)]),t;if(typeof y.name!="string")return t.push([A.default.Error,l.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([A.default.Error,l.localize(2,null,"version")]),t;if(!y.engines)return t.push([A.default.Error,l.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([A.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!n(y.extensionDependencies))return t.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!n(y.activationEvents))return t.push([A.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([A.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([A.default.Error,l.localize(9,null,"main")]),t;{const c=(0,a.joinPath)(w,y.main);(0,a.isEqualOrParent)(c,w)||t.push([A.default.Warning,l.localize(10,null,c.path,w.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([A.default.Error,l.localize(11,null,"browser")]),t;{const c=(0,a.joinPath)(w,y.browser);(0,a.isEqualOrParent)(c,w)||t.push([A.default.Warning,l.localize(12,null,c.path,w.path)])}}if(!R.valid(y.version))return t.push([A.default.Error,l.localize(13,null)]),t;const o=[];if(!C(d,h,y,p,o))for(const c of o)t.push([A.default.Error,c]);return t}e.validateExtensionManifest=S;function C(d,h,w,y,p){return y||typeof w.main>"u"&&typeof w.browser>"u"?!0:E(d,h,w.engines.vscode,p)}e.isValidExtensionVersion=C;function I(d,h,w){return d==="*"||E(h,w,d)}e.isEngineValid=I;function E(d,h,w,y=[]){const p=O(v(w));if(!p)return y.push(l.localize(14,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return y.push(l.localize(15,null,w)),!1}else if(!p.majorMustEqual)return y.push(l.localize(16,null,w)),!1;return k(d,h,p)?!0:(y.push(l.localize(17,null,d,w)),!1)}function n(d){if(!Array.isArray(d))return!1;for(let h=0,w=d.length;h<w;h++)if(typeof d[h]!="string")return!1;return!0}}),define(Ie[90],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(l,R=[],P=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=a}),define(Ie[91],Ce([1,0,90]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function R(T,D,v){D instanceof a.SyncDescriptor||(D=new a.SyncDescriptor(D,[],Boolean(v))),A.push([T,D])}e.registerSingleton=R;function P(){return A}e.getSingletonServiceDescriptors=P}),define(Ie[205],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,P){this.key=R,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const P of this.a.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const T=this.lookupOrInsertNode(R),D=this.lookupOrInsertNode(P);T.outgoing.set(D.key,D),D.incoming.set(T.key,T)}removeNode(R){const P=this.b(R);this.a.delete(P);for(const T of this.a.values())T.outgoing.delete(P),T.incoming.delete(P)}lookupOrInsertNode(R){const P=this.b(R);let T=this.a.get(P);return T||(T=new a(P,R),this.a.set(P,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[P,T]of this.a)R.push(`${P}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,P]of this.a){const T=new Set([R]),D=this.c(P,T);if(D)return D}}c(R,P){for(const[T,D]of R.outgoing){if(P.has(T))return[...P,T].join(" -> ");P.add(T);const v=this.c(D,P);if(v)return v;P.delete(T)}}}e.Graph=A}),define(Ie[4],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function T(D){return D[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function A(P,T,D){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:P,index:D}):(T[a.DI_DEPENDENCIES]=[{id:P,index:D}],T[a.DI_TARGET]=T)}function l(P){if(a.serviceIds.has(P))return a.serviceIds.get(P);const T=function(D,v,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(T,D,O)};return T.toString=()=>P,a.serviceIds.set(P,T),T}e.createDecorator=l;function R(P){return P}e.refineServiceDecorator=R}),define(Ie[54],Ce([1,0,10,2,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=R;function P(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=P;var T;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function v(n,d){const h=Object.create(null);for(const w in n)O(h,w,n[w],d);return h}e.toValuesTree=v;function O(n,d,h,w){const y=d.split("."),p=y.pop();let t=n;for(let o=0;o<y.length;o++){const r=y[o];let c=t[r];switch(typeof c){case"undefined":c=t[r]=Object.create(null);break;case"object":break;default:w(`Ignoring ${d} as ${y.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[p]=h}catch{w(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=O;function k(n,d){const h=d.split(".");S(n,h)}e.removeFromValueTree=k;function S(n,d){const h=d.shift();if(d.length===0){delete n[h];return}if(Object.keys(n).indexOf(h)!==-1){const w=n[h];typeof w=="object"&&!Array.isArray(w)&&(S(w,d),Object.keys(w).length===0&&delete n[h])}}function C(n,d,h){function w(t,o){let r=t;for(const c of o){if(typeof r!="object"||r===null)return;r=r[c]}return r}const y=d.split("."),p=w(n,y);return typeof p>"u"?h:p}e.getConfigurationValue=C;function I(n,d,h){Object.keys(d).forEach(w=>{w!=="__proto__"&&(w in n?a.isObject(n[w])&&a.isObject(d[w])?I(n[w],d[w],h):h&&(n[w]=d[w]):n[w]=d[w])})}e.merge=I;function E(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Ie[44],Ce([1,0,14,9,203,4,172,8]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",a.isMacintosh),D.set("isLinux",a.isLinux),D.set("isWindows",a.isWindows),D.set("isWeb",a.isWeb),D.set("isMacNative",a.isMacintosh&&!a.isWeb),D.set("isEdge",a.isEdge),D.set("isFirefox",a.isFirefox),D.set("isChrome",a.isChrome),D.set("isSafari",a.isSafari);function v(q,F){if(D.get(q)!==void 0)throw(0,T.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(q,F)}e.setConstant=v;const O=Object.prototype.hasOwnProperty;var k;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));const S={regexParsingWithErrorRecovery:!0},C=(0,P.localize)(0,null),I=(0,P.localize)(1,null),E=(0,P.localize)(2,null),n=(0,P.localize)(3,null),d=(0,P.localize)(4,null),h=(0,P.localize)(5,null),w=(0,P.localize)(6,null),y=(0,P.localize)(7,null);class p{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=S){this.k=F,this.d=new l.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:C,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const ge=this.D(),Ee=ge.type===17?h:void 0;throw this.h.push({message:d,offset:ge.offset,lexeme:l.Scanner.getLexeme(ge),additionalInfo:Ee}),p.c}return J}catch(J){if(J!==p.c)throw J;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(16);){const J=this.o();F.push(J)}return F.length===1?F[0]:t.or(...F)}o(){const F=[this.s()];for(;this.y(15);){const J=this.s();F.push(J)}return F.length===1?F[0]:t.and(...F)}s(){if(this.y(2)){const F=this.D();switch(F.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,n),J?.negate()}case 17:return this.z(),L.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const J=this.l();return this.A(1,n),J}case 17:{const J=F.lexeme;if(this.z(),this.y(9)){const Ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ee.type!==10)throw this.B("REGEX",Ee);const ie=Ee.lexeme,ne=ie.lastIndexOf("/"),de=ne===ie.length-1?void 0:this.w(ie.substring(ne+1));let ee;try{ee=new RegExp(ie.substring(1,ne),de)}catch{throw this.B("REGEX",Ee)}return z.create(J,ee)}switch(Ee.type){case 10:case 19:{const ie=[Ee.lexeme];this.z();let ne=this.D(),de=0;for(let $=0;$<Ee.lexeme.length;$++)Ee.lexeme.charCodeAt($)===40?de++:Ee.lexeme.charCodeAt($)===41&&de--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let $=0;$<ne.lexeme.length;$++)ne.lexeme.charCodeAt($)===40?de++:Ee.lexeme.charCodeAt($)===41&&de--}if(de<0)break;ie.push(l.Scanner.getLexeme(ne)),this.z(),ne=this.D()}const ee=ie.join(""),ce=ee.lastIndexOf("/"),ae=ce===ee.length-1?void 0:this.w(ee.substring(ce+1));let N;try{N=new RegExp(ee.substring(1,ce),ae)}catch{throw this.B("REGEX",Ee)}return t.regex(J,N)}case 18:{const ie=Ee.lexeme;this.z();let ne=null;if(!(0,A.isFalsyOrWhitespace)(ie)){const de=ie.indexOf("/"),ee=ie.lastIndexOf("/");if(de!==ee&&de>=0){const ce=ie.slice(de+1,ee),ae=ie[ee+1]==="i"?"i":"";try{ne=new RegExp(ce,ae)}catch{throw this.B("REGEX",Ee)}}}if(ne===null)throw this.B("REGEX",Ee);return z.create(J,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const Ee=this.u();return t.notIn(J,Ee)}switch(this.D().type){case 3:{this.z();const Ee=this.u();if(this.x().type===18)return t.equals(J,Ee);switch(Ee){case"true":return t.has(J);case"false":return t.not(J);default:return t.equals(J,Ee)}}case 4:{this.z();const Ee=this.u();if(this.x().type===18)return t.notEquals(J,Ee);switch(Ee){case"true":return t.not(J);case"false":return t.has(J);default:return t.notEquals(J,Ee)}}case 5:return this.z(),B.create(J,this.u());case 6:return this.z(),U.create(J,this.u());case 7:return this.z(),G.create(J,this.u());case 8:return this.z(),Q.create(J,this.u());case 13:return this.z(),t.in(J,this.u());default:return t.has(J)}}case 20:throw this.h.push({message:w,offset:F.offset,lexeme:"",additionalInfo:y}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case 17:case 18:return this.z(),F.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,J){if(this.C(F))return this.z();throw this.B(J,this.D())}B(F,J,ge){const Ee=(0,P.localize)(8,null,F,l.Scanner.getLexeme(J)),ie=J.offset,ne=l.Scanner.getLexeme(J);return this.h.push({message:Ee,offset:ie,lexeme:ne,additionalInfo:ge}),p.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===20}}p.c=new Error,e.Parser=p;class t{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(F){return i.create(F)}static equals(F,J){return s.create(F,J)}static notEquals(F,J){return g.create(F,J)}static regex(F,J){return z.create(F,J)}static in(F,J){return u.create(F,J)}static notIn(F,J){return b.create(F,J)}static not(F){return L.create(F)}static and(...F){return fe.create(F,null,!0)}static or(...F){return re.create(F,null,!0)}static greater(F,J){return G.create(F,J)}static greaterEquals(F,J){return Q.create(F,J)}static smaller(F,J){return B.create(F,J)}static smallerEquals(F,J){return U.create(F,J)}static deserialize(F){return F==null?void 0:this.c.parse(F)}}t.c=new p({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function o(q){const F=new p({regexParsingWithErrorRecovery:!1});return q.map(J=>(F.parse(J),F.lexingErrors.length>0?F.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,P.localize)(9,null,ge.additionalInfo):(0,P.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.validateWhenClauses=o;function r(q,F){const J=q?q.substituteConstants():void 0,ge=F?F.substituteConstants():void 0;return!J&&!ge?!0:!J||!ge?!1:J.equals(ge)}e.expressionsAreEqualWithConstantSubstitution=r;function c(q,F){return q.cmp(F)}class m{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return f.INSTANCE}}m.INSTANCE=new m,e.ContextKeyFalseExpr=m;class f{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return m.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class i{static create(F,J=null){const ge=D.get(F);return typeof ge=="boolean"?ge?f.INSTANCE:m.INSTANCE:new i(F,J)}constructor(F,J){this.key=F,this.c=J,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=D.get(this.key);return typeof F=="boolean"?F?f.INSTANCE:m.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=i;class s{static create(F,J,ge=null){if(typeof J=="boolean")return J?i.create(F,ge):L.create(F,ge);const Ee=D.get(F);return typeof Ee=="boolean"?J===(Ee?"true":"false")?f.INSTANCE:m.INSTANCE:new s(F,J,ge)}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=D.get(this.c);if(typeof F=="boolean"){const J=F?"true":"false";return this.d===J?f.INSTANCE:m.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=s;class u{static create(F,J){return new u(F,J)}constructor(F,J){this.d=F,this.f=J,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:te(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const J=F.getValue(this.f),ge=F.getValue(this.d);return Array.isArray(J)?J.includes(ge):typeof ge=="string"&&typeof J=="object"&&J!==null?O.call(J,ge):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=u;class b{static create(F,J){return new b(F,J)}constructor(F,J){this.d=F,this.f=J,this.type=11,this.c=u.create(F,J)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class g{static create(F,J,ge=null){if(typeof J=="boolean")return J?L.create(F,ge):i.create(F,ge);const Ee=D.get(F);return typeof Ee=="boolean"?J===(Ee?"true":"false")?m.INSTANCE:f.INSTANCE:new g(F,J,ge)}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=D.get(this.c);if(typeof F=="boolean"){const J=F?"true":"false";return this.d===J?m.INSTANCE:f.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=g;class L{static create(F,J=null){const ge=D.get(F);return typeof ge=="boolean"?ge?m.INSTANCE:f.INSTANCE:new L(F,J)}constructor(F,J){this.c=F,this.d=J,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:_(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=D.get(this.c);return typeof F=="boolean"?F?m.INSTANCE:f.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=i.create(this.c,this)),this.d}}e.ContextKeyNotExpr=L;function j(q,F){if(typeof q=="string"){const J=parseFloat(q);isNaN(J)||(q=J)}return typeof q=="string"||typeof q=="number"?F(q):m.INSTANCE}class G{static create(F,J,ge=null){return j(J,Ee=>new G(F,Ee,ge))}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=G;class Q{static create(F,J,ge=null){return j(J,Ee=>new Q(F,Ee,ge))}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=Q;class B{static create(F,J,ge=null){return j(J,Ee=>new B(F,Ee,ge))}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=B;class U{static create(F,J,ge=null){return j(J,Ee=>new U(F,Ee,ge))}constructor(F,J,ge){this.c=F,this.d=J,this.f=ge,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:te(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=U;class z{static create(F,J){return new z(F,J)}constructor(F,J){this.d=F,this.f=J,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const J=this.f?this.f.source:"",ge=F.f?F.f.source:"";return J<ge?-1:J>ge?1:0}equals(F){if(F.type===this.type){const J=this.f?this.f.source:"",ge=F.f?F.f.source:"";return this.d===F.d&&J===ge}return!1}substituteConstants(){return this}evaluate(F){const J=F.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=M.create(this)),this.c}}e.ContextKeyRegexExpr=z;class M{static create(F){return new M(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new M(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=M;function x(q){let F=null;for(let J=0,ge=q.length;J<ge;J++){const Ee=q[J].substituteConstants();if(q[J]!==Ee&&F===null){F=[];for(let ie=0;ie<J;ie++)F[ie]=q[ie]}F!==null&&(F[J]=Ee)}return F===null?q:F}class fe{static create(F,J,ge){return fe.d(F,J,ge)}constructor(F,J){this.expr=F,this.c=J,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let J=0,ge=this.expr.length;J<ge;J++){const Ee=c(this.expr[J],F.expr[J]);if(Ee!==0)return Ee}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let J=0,ge=this.expr.length;J<ge;J++)if(!this.expr[J].equals(F.expr[J]))return!1;return!0}return!1}substituteConstants(){const F=x(this.expr);return F===this.expr?this:fe.create(F,this.c,!1)}evaluate(F){for(let J=0,ge=this.expr.length;J<ge;J++)if(!this.expr[J].evaluate(F))return!1;return!0}static d(F,J,ge){const Ee=[];let ie=!1;for(const ne of F)if(!!ne){if(ne.type===1){ie=!0;continue}if(ne.type===0)return m.INSTANCE;if(ne.type===6){Ee.push(...ne.expr);continue}Ee.push(ne)}if(Ee.length===0&&ie)return f.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(c);for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const ne=Ee[Ee.length-1];if(ne.type!==9)break;Ee.pop();const de=Ee.pop(),ee=Ee.length===0,ce=re.create(ne.expr.map(ae=>fe.create([ae,de],null,ge)),null,ee);ce&&(Ee.push(ce),Ee.sort(c))}if(Ee.length===1)return Ee[0];if(ge){for(let ne=0;ne<Ee.length;ne++)for(let de=ne+1;de<Ee.length;de++)if(Ee[ne].negate().equals(Ee[de]))return m.INSTANCE;if(Ee.length===1)return Ee[0]}return new fe(Ee,J)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const J of this.expr)F.push(...J.keys());return F}map(F){return new fe(this.expr.map(J=>J.map(F)),null)}negate(){if(!this.c){const F=[];for(const J of this.expr)F.push(J.negate());this.c=re.create(F,this,!0)}return this.c}}e.ContextKeyAndExpr=fe;class re{static create(F,J,ge){return re.d(F,J,ge)}constructor(F,J){this.expr=F,this.c=J,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let J=0,ge=this.expr.length;J<ge;J++){const Ee=c(this.expr[J],F.expr[J]);if(Ee!==0)return Ee}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let J=0,ge=this.expr.length;J<ge;J++)if(!this.expr[J].equals(F.expr[J]))return!1;return!0}return!1}substituteConstants(){const F=x(this.expr);return F===this.expr?this:re.create(F,this.c,!1)}evaluate(F){for(let J=0,ge=this.expr.length;J<ge;J++)if(this.expr[J].evaluate(F))return!0;return!1}static d(F,J,ge){let Ee=[],ie=!1;if(F){for(let ne=0,de=F.length;ne<de;ne++){const ee=F[ne];if(!!ee){if(ee.type===0){ie=!0;continue}if(ee.type===1)return f.INSTANCE;if(ee.type===9){Ee=Ee.concat(ee.expr);continue}Ee.push(ee)}}if(Ee.length===0&&ie)return m.INSTANCE;Ee.sort(c)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let ne=1;ne<Ee.length;ne++)Ee[ne-1].equals(Ee[ne])&&(Ee.splice(ne,1),ne--);if(Ee.length===1)return Ee[0];if(ge){for(let ne=0;ne<Ee.length;ne++)for(let de=ne+1;de<Ee.length;de++)if(Ee[ne].negate().equals(Ee[de]))return f.INSTANCE;if(Ee.length===1)return Ee[0]}return new re(Ee,J)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const J of this.expr)F.push(...J.keys());return F}map(F){return new re(this.expr.map(J=>J.map(F)),null)}negate(){if(!this.c){const F=[];for(const J of this.expr)F.push(J.negate());for(;F.length>1;){const J=F.shift(),ge=F.shift(),Ee=[];for(const ie of ue(J))for(const ne of ue(ge))Ee.push(fe.create([ie,ne],null,!1));F.unshift(re.create(Ee,null,!1))}this.c=re.create(F,this,!0)}return this.c}}e.ContextKeyOrExpr=re;class V extends i{static all(){return V.d.values()}constructor(F,J,ge){super(F,null),this.f=J,typeof ge=="object"?V.d.push({...ge,key:F}):ge!==!0&&V.d.push({key:F,description:ge,type:J!=null?typeof J:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return s.create(this.key,F)}notEqualsTo(F){return g.create(this.key,F)}}V.d=[],e.RawContextKey=V,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function _(q,F){return q<F?-1:q>F?1:0}function te(q,F,J,ge){return q<J?-1:q>J?1:F<ge?-1:F>ge?1:0}function ve(q,F){if(q.type===0||F.type===1)return!0;if(q.type===9)return F.type===9?le(q.expr,F.expr):!1;if(F.type===9){for(const J of F.expr)if(ve(q,J))return!0;return!1}if(q.type===6){if(F.type===6)return le(F.expr,q.expr);for(const J of q.expr)if(ve(J,F))return!0;return!1}return q.equals(F)}e.implies=ve;function le(q,F){let J=0,ge=0;for(;J<q.length&&ge<F.length;){const Ee=q[J].cmp(F[ge]);if(Ee<0)return!1;Ee===0&&J++,ge++}return J===q.length}function ue(q){return q.type===9?q.expr:[q]}}),define(Ie[206],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[123],Ce([1,0,174,4]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function P(h,w){switch(h){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function T(h,w){return w==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function D(h,w,y){return T(w,y)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===y?!0:v(y).includes(h)}e.isTargetPlatformCompatible=D;function v(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var C;(function(h){h.Install="install",h.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var I;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var E;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var n;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class d extends Error{constructor(w,y){super(w),this.code=y,this.name=y}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(Ie[207],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Ie[208],Ce([1,0,47,18,15,14,110,29,117,176,207]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=v.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends S{openTerminal(y,p){return this.spawnTerminal(a,y,D.getWindowsShell(),p)}spawnTerminal(y,p,t,o){const r=p.windowsExec||C.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=l.basename(r,".exe").toLowerCase();if(c==="cmder")return y.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const m=["/c","start","/wait"];return r.indexOf(" ")>=0&&m.push('""'),m.push(r),c==="wt"&&m.push("-d ."),new Promise((f,i)=>{const s=n(process),u=y.spawn(t,m,{cwd:o,env:s});u.on("error",i),u.on("exit",()=>f())})}runInTerminal(y,p,t,o,r){const c="windowsExec"in r&&r.windowsExec?r.windowsExec:C.getDefaultTerminalWindows();return new Promise((m,f)=>{const i=`"${p} - ${k}"`,s=`""${t.join('" "')}" & pause"`,u=Object.assign({},n(process),o);Object.keys(u).filter(G=>u[G]===null).forEach(G=>delete u[G]);const b={cwd:p,env:u,windowsVerbatimArguments:!0};let g,L;l.basename(c,".exe")==="wt"?(g=c,L=["-d",".",C.b,"/c",s]):(g=C.b,L=["/c","start",i,"/wait",c,"/c",s]),a.spawn(g,L,b).on("error",G=>{f(d(G))}),m(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return C.d}}C.b="cmd.exe",e.WindowsExternalTerminalService=C;class I extends S{openTerminal(y,p){return this.spawnTerminal(a,y,p)}runInTerminal(y,p,t,o,r){const c=r.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((m,f)=>{if(c===O.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const i=c===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",y||k,"-w",p];for(const L of t)u.push("-a"),u.push(L);if(o){const L=Object.assign({},n(process),o);for(const j in L){const G=L[j];G===null?(u.push("-u"),u.push(j)):(u.push("-e"),u.push(`${j}=${G}`))}}let b="";const g=a.spawn(I.b,u);g.on("error",L=>{f(d(L))}),g.stderr.on("data",L=>{b+=L.toString()}),g.on("exit",L=>{if(L===0)m(void 0);else if(b){const j=b.split(`
`,1);f(new Error(j[0]))}else f(new Error(v.localize(1,null,i,L)))})}else f(new Error(v.localize(2,null,c)))})}spawnTerminal(y,p,t){const o=p.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{const m=["-a",o];t&&m.push(t);const f=n(process),i=y.spawn("/usr/bin/open",m,{cwd:t,env:f});i.on("error",c),i.on("exit",()=>r())})}}I.b="/usr/bin/osascript",e.MacExternalTerminalService=I;class E extends S{openTerminal(y,p){return this.spawnTerminal(a,y,p)}runInTerminal(y,p,t,o,r){const c=r.linuxExec?Promise.resolve(r.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((m,f)=>{const i=[];c.then(s=>{s.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const u=`${h(t)}; echo; read -p "${E.b}" -n1;`;i.push(`''${u}''`);const b=Object.assign({},n(process),o);Object.keys(b).filter(G=>b[G]===null).forEach(G=>delete b[G]);const g={cwd:p,env:b};let L="";const j=a.spawn(s,i,g);j.on("error",G=>{f(d(G))}),j.stderr.on("data",G=>{L+=G.toString()}),j.on("exit",G=>{if(G===0)m(void 0);else if(L){const Q=L.split(`
`,1);f(new Error(Q[0]))}else f(new Error(v.localize(4,null,s,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!R.isLinux)E.d=Promise.resolve("xterm");else{const y=await T.Promises.exists("/etc/debian_version");E.d=new Promise(p=>{y?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return E.d}spawnTerminal(y,p,t){const o=p.linuxExec?Promise.resolve(p.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{o.then(m=>{const f=n(process),i=y.spawn(m,[],{cwd:t,env:f});i.on("error",c),i.on("exit",()=>r())})})}}E.b=v.localize(3,null),e.LinuxExternalTerminalService=E;function n(w){const y={...w.env};return(0,P.sanitizeProcessEnvironment)(y),y}function d(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(v.localize(5,null,w.path)):w}function h(w){let y="";for(const p of w)p.indexOf(" ")>=0?y+='"'+p+'"':y+=p,y+=" ";return y}}),define(Ie[45],Ce([1,0,69,15,9,10,2,177,4,14,18]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var S;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var I;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function n(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=n;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function h(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function w(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=w;function y(V){return E(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(_,te){const ve=new t(_.toString(),te);return c(ve,te),ve}constructor(_,te){super(_),this.code=te}}e.FileSystemProviderError=t;function o(V,_){return t.create(V,_)}e.createFileSystemProviderError=o;function r(V){return V||o((0,T.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function c(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=c;function m(V){if(!V)return p.Unknown;if(V instanceof t)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return p.Unknown;switch(_[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=m;function f(V){if(V instanceof L)return V.fileOperationResult;switch(m(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(_,te,ve){this.resource=_,this.operation=te,this.target=ve}isOperation(_){return this.operation===_}}e.FileOperationEvent=s;var u;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class b{constructor(_,te){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ve=new Map;for(const le of _){const ue=ve.get(le.type);switch(ue?ue.push([le.resource,le]):ve.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,ue]of ve)switch(le){case 1:this.a=a.TernarySearchTree.forUris(()=>te),this.a.fill(ue);break;case 0:this.b=a.TernarySearchTree.forUris(()=>te),this.b.fill(ue);break;case 2:this.c=a.TernarySearchTree.forUris(()=>te),this.c.fill(ue);break}}contains(_,...te){return this.d(_,{includeChildren:!1},...te)}affects(_,...te){return this.d(_,{includeChildren:!0},...te)}d(_,te,...ve){if(!_)return!1;const le=ve.length>0;return!!((!le||ve.includes(1))&&(this.a?.get(_)||te.includeChildren&&this.a?.findSuperstr(_))||(!le||ve.includes(0))&&(this.b?.get(_)||te.includeChildren&&this.b?.findSuperstr(_))||(!le||ve.includes(2))&&(this.c?.findSubstr(_)||te.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=b;function g(V,_,te){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==A.sep&&(_+=A.sep),te?(0,l.startsWithIgnoreCase)(V,_):V.indexOf(_)===0)}e.isParent=g;class L extends Error{constructor(_,te,ve){super(_),this.fileOperationResult=te,this.options=ve}}e.FileOperationError=L;class j extends L{constructor(_,te,ve,le){super(_,te,le),this.fileOperationResult=te,this.size=ve}}e.TooLargeFileOperationError=j;class G extends L{constructor(_,te,ve){super(_,2,ve),this.stat=te}}e.NotModifiedSinceFileOperationError=G;var Q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=U;async function z(V,_){if(!_.hasProvider(P.URI.from({scheme:V.scheme})))return new Promise(te=>{const ve=_.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===V.scheme&&le.added&&(ve.dispose(),te())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<M.KB?(0,T.localize)(1,null,_.toFixed(0)):_<M.MB?(0,T.localize)(2,null,(_/M.KB).toFixed(2)):_<M.GB?(0,T.localize)(3,null,(_/M.MB).toFixed(2)):_<M.TB?(0,T.localize)(4,null,(_/M.GB).toFixed(2)):(0,T.localize)(5,null,(_/M.TB).toFixed(2))}}M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB,e.ByteSize=M;var x;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function fe(V){return{maxFileSize:V===0?300*M.MB:16*M.GB,maxHeapSize:V===0?700*M.MB:2*700*M.MB}}e.getPlatformFileLimits=fe;function re(V){const _=typeof V=="string"||V?.scheme===O.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===O.Schemas.file?1024*M.MB:_?10*M.MB:v.isWeb?50*M.MB:1024*M.MB}e.getLargeFileConfirmationLimit=re}),define(Ie[92],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...l){this.a=new Map;for(const[R,P]of l)this.set(R,P)}set(l,R){const P=this.a.get(l);return this.a.set(l,R),P}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=a}),define(Ie[209],Ce([1,0,19,8,6,90,205,4,92,66]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class k extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class S{constructor(n=new D.ServiceCollection,d=!1,h,w=O){this.f=n,this.g=d,this.h=h,this.i=w,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=w?h?._globalGraph??new P.Graph(y=>y):void 0}createChild(n){return new S(n,this.g,this,this.i)}invokeFunction(n,...d){const h=I.traceInvocation(this.i,n);let w=!1;try{return n({get:p=>{if(w)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(p,h);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...d)}finally{w=!0,h.stop()}}createInstance(n,...d){let h,w;return n instanceof R.SyncDescriptor?(h=I.traceCreation(this.i,n.ctor),w=this.j(n.ctor,n.staticArguments.concat(d),h)):(h=I.traceCreation(this.i,n),w=this.j(n,d,h)),h.stop(),w}j(n,d=[],h){const w=T._util.getServiceDependencies(n).sort((t,o)=>t.index-o.index),y=[];for(const t of w){const o=this.m(t.id,h);o||this.u(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(o)}const p=w.length>0?w[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${n.name} at position ${p+1} conflicts with ${d.length} static arguments`);const t=p-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,p)}return Reflect.construct(n,d.concat(y))}k(n,d){if(this.f.get(n)instanceof R.SyncDescriptor)this.f.set(n,d);else if(this.h)this.h.k(n,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(n){const d=this.f.get(n);return!d&&this.h?this.h.l(n):d}m(n,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(n));const h=this.l(n);return h instanceof R.SyncDescriptor?this.q(n,h,d.branch(n,!0)):(d.branch(n,!1),h)}q(n,d,h){if(this.o.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this.o.add(n);try{return this.r(n,d,h)}finally{this.o.delete(n)}}r(n,d,h){const w=new P.Graph(t=>t.id.toString());let y=0;const p=[{id:n,desc:d,_trace:h}];for(;p.length;){const t=p.pop();if(w.lookupOrInsertNode(t),y++>1e3)throw new k(w);for(const o of T._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${n} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof R.SyncDescriptor){const c={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};w.insertEdge(t,c),p.push(c)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:o}of t){if(this.l(o.id)instanceof R.SyncDescriptor){const c=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,c)}w.removeNode(o)}}return this.l(n)}s(n,d,h=[],w,y){if(this.f.get(n)instanceof R.SyncDescriptor)return this.t(n,d,h,w,y);if(this.h)return this.h.s(n,d,h,w,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(n,d,h=[],w,y){if(w){const p=new S(void 0,this.g,this,this.i);p.c=String(n);const t=new Map,o=new a.IdleValue(()=>{const r=p.j(d,h,y);for(const[c,m]of t){const f=r[c];if(typeof f=="function")for(const i of m)f.apply(r,i)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let i=t.get(c);return i||(i=new v.LinkedList,t.set(c,i)),(u,b,g)=>{const L=i.push([u,b,g]);return(0,l.toDisposable)(L)}}if(c in r)return r[c];const m=o.value;let f=m[c];return typeof f!="function"||(f=f.bind(m),r[c]=f),f},set(r,c,m){return o.value[c]=m,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,h,y)}u(n,d){if(d&&console.warn(n),this.g)throw new Error(n)}}e.InstantiationService=S;var C;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(C||(C={}));class I{static traceInvocation(n,d){return n?new I(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I.c}static traceCreation(n,d){return n?new I(1,d.name):I.c}constructor(n,d){this.type=n,this.name=d,this.g=Date.now(),this.h=[]}branch(n,d){const h=new I(3,n.toString());return this.h.push([n,d,h]),h}stop(){const n=Date.now()-this.g;I.f+=n;let d=!1;function h(y,p){const t=[],o=new Array(y+1).join("	");for(const[r,c,m]of p.h)if(c&&m){d=!0,t.push(`${o}CREATES -> ${r}`);const f=h(y+1,m);f&&t.push(f)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${I.f.toFixed(2)}ms)`];(n>2||d)&&I.all.add(w.join(`
`))}}I.all=new Set,I.c=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}},I.f=0,e.Trace=I}),define(Ie[16],Ce([1,0,46,3,68,6,28,14,24,10,2,44,4]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}function I(u){return(0,v.isNumber)(u)}e.isLogLevel=I;var E;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function n(u,b,g){switch(b){case E.Trace:u.trace(g);break;case E.Debug:u.debug(g);break;case E.Info:u.info(g);break;case E.Warning:u.warn(g);break;case E.Error:u.error(g);break;case E.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=n;function d(u,b=!1){let g="";for(let L=0;L<u.length;L++){let j=u[L];if(j instanceof Error&&(j=(0,a.toErrorMessage)(j,b)),typeof j=="object")try{j=JSON.stringify(j)}catch{}g+=(L>0?" ":"")+j}return g}class h extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==E.Off&&this.b<=b}}e.AbstractLogger=h;class w extends h{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...g){this.f(E.Trace)&&this.g(E.Trace,d([b,...g],!0))}debug(b,...g){this.f(E.Debug)&&this.g(E.Debug,d([b,...g]))}info(b,...g){this.f(E.Info)&&this.g(E.Info,d([b,...g]))}warn(b,...g){this.f(E.Warning)&&this.g(E.Warning,d([b,...g]))}error(b,...g){if(this.f(E.Error))if(b instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=b.stack,this.g(E.Error,d(L))}else this.g(E.Error,d([b,...g]))}flush(){}}e.AbstractMessageLogger=w;class y extends h{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.g=!T.isWindows}trace(b,...g){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,b,...g):console.log(`[main ${C()}]`,b,...g))}debug(b,...g){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,b,...g):console.log(`[main ${C()}]`,b,...g))}info(b,...g){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,b,...g):console.log(`[main ${C()}]`,b,...g))}warn(b,...g){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,b,...g):console.warn(`[main ${C()}]`,b,...g))}error(b,...g){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,b,...g):console.error(`[main ${C()}]`,b,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class p extends h{constructor(b=e.DEFAULT_LOG_LEVEL,g=!0){super(),this.g=g,this.setLevel(b)}trace(b,...g){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...g):console.log(b,...g))}debug(b,...g){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...g):console.log(b,...g))}info(b,...g){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...g):console.log(b,...g))}warn(b,...g){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...g):console.log(b,...g))}error(b,...g){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...g):console.error(b,...g))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends h{constructor(b,g=e.DEFAULT_LOG_LEVEL){super(),this.g=b,this.setLevel(g)}trace(b,...g){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(b),...g])}debug(b,...g){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(b),...g])}info(b,...g){this.f(E.Info)&&this.g.log(E.Info,[this.h(b),...g])}warn(b,...g){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(b),...g])}error(b,...g){this.f(E.Error)&&this.g.log(E.Error,[this.h(b),...g])}h(b){return typeof b=="string"?b:(0,a.toErrorMessage)(b,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends h{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const g of this.g)g.setLevel(b);super.setLevel(b)}trace(b,...g){for(const L of this.g)L.trace(b,...g)}debug(b,...g){for(const L of this.g)L.debug(b,...g)}info(b,...g){for(const L of this.g)L.info(b,...g)}warn(b,...g){for(const L of this.g)L.warn(b,...g)}error(b,...g){for(const L of this.g)L.error(b,...g)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.MultiplexLogger=o;class r extends R.Disposable{constructor(b,g,L){if(super(),this.h=b,this.j=g,this.b=new P.ResourceMap,this.c=this.B(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeVisibility=this.g.event,L)for(const j of L)this.b.set(j.resource,{logger:void 0,info:j})}k(b){return(0,v.isString)(b)?[...this.b.values()].find(g=>g.info.id===b):this.b.get(b)}getLogger(b){return this.k(b)?.logger}createLogger(b,g){const L=this.l(b),j=(0,v.isString)(b)?b:g?.id??(0,l.hash)(L.toString()).toString(16);let G=this.b.get(L)?.logger;const Q=g?.logLevel==="always"?E.Trace:g?.logLevel;G||(G=this.m(L,Q??this.getLogLevel(L)??this.h,{...g,id:j}));const B={logger:G,info:{resource:L,id:j,logLevel:Q,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(B.info),this.b.set(L,B),G}l(b){return(0,v.isString)(b)?(0,D.joinPath)(this.j,`${b}.log`):b}setLogLevel(b,g){if(O.URI.isUri(b)){const L=b,j=g,G=this.b.get(L);G&&j!==G.info.logLevel&&(G.info.logLevel=j===this.h?void 0:j,G.logger?.setLevel(j),this.b.set(G.info.resource,G),this.f.fire([L,j]))}else{this.h=b;for(const[L,j]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,g){const L=this.k(b);L&&g!==!L.info.hidden&&(L.info.hidden=!g,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,g]))}getLogLevel(b){let g;return b&&(g=this.b.get(b)?.info.logLevel),g??this.h}registerLogger(b){const g=this.b.get(b.resource);g?g.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const g=this.b.get(b);g&&(g.logger&&g.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class c{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(b){}getLevel(){return E.Info}trace(b,...g){}debug(b,...g){}info(b,...g){}warn(b,...g){}error(b,...g){}critical(b,...g){}dispose(){}flush(){}}e.NullLogger=c;class m extends c{}e.NullLogService=m;function f(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const b=s(u.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function i(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=i;function s(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=s,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",i(E.Info))}),define(Ie[210],Ce([1,0,6,16]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends a.Disposable{constructor(P,T=[]){super(),this.a=new A.MultiplexLogger([P,...T]),this.B(P.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...T){this.a.trace(P,...T)}debug(P,...T){this.a.debug(P,...T)}info(P,...T){this.a.info(P,...T)}warn(P,...T){this.a.warn(P,...T)}error(P,...T){this.a.error(P,...T)}flush(){this.a.flush()}}e.LogService=l}),define(Ie[211],Ce([1,0,45,16]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(l||(l={}));async function R(v,O,k,S,C){try{const I=await new Promise((n,d)=>{se(["spdlog"],n,d)});I.setFlushOn(l.Trace);const E=await I.createAsyncRotatingLogger(v,O,k,S);return C?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(I){console.error(I)}return null}function P(v,O,k){switch(O){case A.LogLevel.Trace:v.trace(k);break;case A.LogLevel.Debug:v.debug(k);break;case A.LogLevel.Info:v.info(k);break;case A.LogLevel.Warning:v.warn(k);break;case A.LogLevel.Error:v.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function T(v,O){switch(O){case A.LogLevel.Trace:v.setLevel(l.Trace);break;case A.LogLevel.Debug:v.setLevel(l.Debug);break;case A.LogLevel.Info:v.setLevel(l.Info);break;case A.LogLevel.Warning:v.setLevel(l.Warning);break;case A.LogLevel.Error:v.setLevel(l.Error);break;case A.LogLevel.Off:v.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class D extends A.AbstractMessageLogger{constructor(O,k,S,C,I){super(),this.k=[],this.setLevel(I),this.l=this.n(O,k,S,C),this.B(this.onDidChangeLogLevel(E=>{this.m&&T(this.m,E)}))}async n(O,k,S,C){const I=S?6:1,E=30/I*a.ByteSize.MB,n=await R(O,k,E,I,C);if(n){this.m=n,T(this.m,this.getLevel());for(const{level:d,message:h}of this.k)P(this.m,d,h);this.k=[]}}g(O,k){this.m?P(this.m,O,k):this.getLevel()<=O&&this.k.push({level:O,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=D}),define(Ie[124],Ce([1,0,38,178,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var P;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function v(I,E){return E-I}D.compare=v;const O=Object.create(null);O[D.Error]=(0,A.localize)(0,null),O[D.Warning]=(0,A.localize)(1,null),O[D.Info]=(0,A.localize)(2,null);function k(I){return O[I]||""}D.toString=k;function S(I){switch(I){case a.default.Error:return D.Error;case a.default.Warning:return D.Warning;case a.default.Info:return D.Info;case a.default.Ignore:return D.Hint}}D.fromSeverity=S;function C(I){switch(I){case D.Error:return a.default.Error;case D.Warning:return a.default.Warning;case D.Info:return a.default.Info;case D.Hint:return a.default.Ignore}}D.toSeverity=C}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(D){const v="";function O(S){return k(S,!0)}D.makeKey=O;function k(S,C){const I=[v];return S.source?I.push(S.source.replace("\xA6","\\\xA6")):I.push(v),S.code?typeof S.code=="string"?I.push(S.code.replace("\xA6","\\\xA6")):I.push(S.code.value.replace("\xA6","\\\xA6")):I.push(v),S.severity!==void 0&&S.severity!==null?I.push(P.toString(S.severity)):I.push(v),S.message&&C?I.push(S.message.replace("\xA6","\\\xA6")):I.push(v),S.startLineNumber!==void 0&&S.startLineNumber!==null?I.push(S.startLineNumber.toString()):I.push(v),S.startColumn!==void 0&&S.startColumn!==null?I.push(S.startColumn.toString()):I.push(v),S.endLineNumber!==void 0&&S.endLineNumber!==null?I.push(S.endLineNumber.toString()):I.push(v),S.endColumn!==void 0&&S.endColumn!==null?I.push(S.endColumn.toString()):I.push(v),I.push(v),I.join("\xA6")}D.makeKeyOptionalMessage=k})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(Ie[212],Ce([1,0,3,38,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(O){O[O.DEFAULT=0]="DEFAULT",O[O.SILENT=1]="SILENT",O[O.URGENT=2]="URGENT"})(R=e.NotificationPriority||(e.NotificationPriority={}));var P;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.PROFILE=1]="PROFILE",O[O.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new v,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=D;class v{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=v}),define(Ie[125],Ce([1,0,9,2,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(v,O){return A.URI.isUri(v)?(0,a.equalsIgnoreCase)(v.scheme,O):(0,a.startsWithIgnoreCase)(v,O+":")}e.matchesScheme=R;function P(v,...O){return O.some(k=>R(v,k))}e.matchesSomeScheme=P;function T(v,O){return v.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=T;function D(v){let O;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return k&&(O={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},v=v.with({fragment:""})),{selection:O,uri:v}}e.extractSelection=D}),define(Ie[213],Ce([1,0,14,36]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(Ie[214],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(se,e){return function(a,A){e(a,A,se)}};define(Ie[126],Ce([1,0,19,21,6,4]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var P;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}T.None=Object.freeze({report(){}}),e.Progress=T;let D=class extends l.Disposable{constructor(k,S){super(),this.a=new a.DeferredPromise,S.withProgress(k,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};D=Ve([$e(1,e.IProgressService)],D),e.UnmanagedProgress=D;class v extends l.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new l.DisposableStore)}start(k){this.stop();const S=++this.a,C=new A.CancellationTokenSource;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>C.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:S,token:C.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=v,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(Ie[40],Ce([1,0,51,10]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(P,T){a.ok(A.isString(P)),a.ok(A.isObject(T)),a.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,T)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.Registry=new l}),define(Ie[93],Ce([1,0,3,40]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,v){this.a[l(D)]=v,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const P=new R;A.Registry.add(e.Extensions.JSONContribution,P)}),define(Ie[127],Ce([1,0,17,3,10,171,54,93,40]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=D.Registry.as(T.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:c,source:m}of t)for(const f in c)if(o.add(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const i=this.a.get(f),s=i?.valuesSources??new Map;if(m)for(const L of Object.keys(c[f]))s.set(L,m);const u={...i?.value||{},...c[f]};this.a.set(f,{source:m,value:u,valuesSources:s});const b=(0,P.getLanguageTagSettingPlainKey)(f),g={type:"object",default:u,description:R.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:l.isString(m)?void 0:m,defaultValueSource:m};r.push(...E(f)),this.d[f]=g,this.b.properties[f]=g}else{this.a.set(f,{value:c[f],source:m});const i=this.d[f];i&&(this.w(f,i),this.r(f,i))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:c}of t)for(const m in r){const f=this.a.get(m),i=l.isString(c)?c:c?.id,s=l.isString(f?.source)?f?.source:f?.source?.id;if(i===s)if(o.add(m),this.a.delete(m),e.OVERRIDE_PROPERTY_REGEX.test(m))delete this.d[m],delete this.b.properties[m];else{const u=this.d[m];u&&(this.w(m,u),this.r(m,u))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(c=>{this.p(c,o,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(t,o){const r=c=>{if(c.properties)for(const m in c.properties){o.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,c.properties[m])}c.allOf?.forEach(m=>r(m))};for(const c of t){r(c);const m=this.c.indexOf(c);m!==-1&&this.c.splice(m,1)}}p(t,o=!0,r,c,m=3,f){m=l.isUndefinedOrNull(t.scope)?m:t.scope;const i=t.properties;if(i)for(const u in i){const b=i[u];if(o&&w(u,b)){delete i[u];continue}if(b.source=r,b.defaultDefaultValue=i[u].default,this.w(u,b),e.OVERRIDE_PROPERTY_REGEX.test(u)?b.scope=void 0:(b.scope=l.isUndefinedOrNull(b.scope)?m:b.scope,b.restricted=l.isUndefinedOrNull(b.restricted)?!!c?.includes(u):b.restricted),i[u].hasOwnProperty("included")&&!i[u].included){this.f[u]=i[u],delete i[u];continue}else this.d[u]=i[u],i[u].policy?.name&&this.e.set(i[u].policy.name,u);!i[u].deprecationMessage&&i[u].markdownDeprecationMessage&&(i[u].deprecationMessage=i[u].markdownDeprecationMessage),f.add(u)}const s=t.allOf;if(s)for(const u of s)this.p(u,o,r,c,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const c=r.properties;if(c)for(const f in c)this.r(f,c[f]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,r),e.allSettings.properties[o]=r,e.applicationSettings.properties[o]=r,e.machineSettings.properties[o]=r,e.machineOverridableSettings.properties[o]=r,e.windowSettings.properties[o]=r,e.resourceSettings.properties[o]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let c=r?.value,m=r?.source;l.isUndefined(c)&&(c=o.defaultDefaultValue,m=void 0),l.isUndefined(c)&&(c=d(o.type)),o.default=c,o.defaultValueSource=m}}const C="\\[([^\\]]+)\\]",I=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=I.exec(p);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=I.exec(p)}}return(0,a.distinct)(t)}e.overrideIdentifiersFromKey=E;function n(p){return p.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=n;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new S;D.Registry.add(e.Extensions.Configuration,h);function w(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):h.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,p,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=w;function y(){const p=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))p.push([o,t[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=y}),define(Ie[215],Ce([1,0,17,3,147,6,28,23,10,2,54,127,40]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function C(o){return Object.isFrozen(o)?o:T.deepFreeze(o)}class I{constructor(r={},c=[],m=[],f){this.b=r,this.c=c,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof I)return c;const m=new E("");return m.parseRaw(c),m.configurationModel});this.f=r.reduce((c,m)=>m===c?m:c.merge(m),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const m=this.rawConfiguration.getValue(r),f=c?this.rawConfiguration.getOverrideValue(r,c):void 0,i=c?this.rawConfiguration.override(c).getValue(r):m;return{value:m,override:f,merged:i}}getOverrideValue(r,c){const m=this.i(c);return m?r?(0,O.getConfigurationValue)(m,r):m:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const m of this.overrides)m.identifiers.includes(r)&&c.push(...m.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return a.distinct(r)}override(r){let c=this.a.get(r);return c||(c=this.g(r),this.a.set(r,c)),c}merge(...r){const c=T.deepClone(this.contents),m=T.deepClone(this.overrides),f=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const s of r)if(i.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(c,s.contents);for(const u of s.overrides){const[b]=m.filter(g=>a.equals(g.identifiers,u.identifiers));b?(this.h(b.contents,u.contents),b.keys.push(...u.keys),b.keys=a.distinct(b.keys)):m.push(T.deepClone(u))}for(const u of s.keys)f.indexOf(u)===-1&&f.push(u)}return new I(c,f,m,i.every(s=>s instanceof I)?void 0:i)}g(r){const c=this.i(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const m={};for(const f of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let i=this.contents[f];const s=c[f];s&&(typeof i=="object"&&typeof s=="object"?(i=T.deepClone(i),this.h(i,s)):i=s),m[f]=i}return new I(m,this.keys,this.overrides)}h(r,c){for(const m of Object.keys(c)){if(m in r&&D.isObject(r[m])&&D.isObject(c[m])){this.h(r[m],c[m]);continue}r[m]=T.deepClone(c[m])}}i(r){let c=null,m=null;const f=i=>{i&&(m?this.h(m,i):m=T.deepClone(i))};for(const i of this.overrides)a.equals(i.identifiers,[r])?c=i.contents:i.identifiers.includes(r)&&f(i.contents);return f(c),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.j(r,c,!0)}setValue(r,c){this.j(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,O.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(m=>a.equals(m.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}j(r,c,m){(0,O.addToValueTree)(this.contents,r,c,f=>console.error(f)),m=m||this.keys.indexOf(r)===-1,m&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],f=>console.error(f))})}}e.ConfigurationModel=I;class E{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!D.isUndefinedOrNull(r)){const m=this.g(r);this.parseRaw(m,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:m,keys:f,overrides:i,restricted:s,hasExcludedProperties:u}=this.h(r,c);this.b=new I(m,f,i,u?[r]:void 0),this.c=s||[]}g(r){let c={},m=null,f=[];const i=[],s=[];function u(g){Array.isArray(f)?f.push(g):m!==null&&(f[m]=g)}const b={onObjectBegin:()=>{const g={};u(g),i.push(f),f=g,m=null},onObjectProperty:g=>{m=g},onObjectEnd:()=>{f=i.pop()},onArrayBegin:()=>{const g=[];u(g),i.push(f),f=g,m=null},onArrayEnd:()=>{f=i.pop()},onLiteralValue:u,onError:(g,L,j)=>{s.push({error:g,offset:L,length:j})}};if(r)try{l.visit(r,b),c=f[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return c}h(r,c){const m=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),f=this.i(r,m,!0,c);r=f.raw;const i=(0,O.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),s=Object.keys(r),u=this.j(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:i,keys:s,overrides:u,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(r,c,m,f){let i=!1;if(!f?.scopes&&!f?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const s={},u=[];for(const b in r)if(k.OVERRIDE_PROPERTY_REGEX.test(b)&&m){const g=this.i(r[b],c,!1,f);s[b]=g.raw,i=i||g.hasExcludedProperties,u.push(...g.restricted)}else{const g=c[b],L=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&u.push(b),(L===void 0||f.scopes===void 0||f.scopes.includes(L))&&!(f.skipRestricted&&g?.restricted)?s[b]=r[b]:i=!0}return{raw:s,restricted:u,hasExcludedProperties:i}}j(r,c){const m=[];for(const f of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(f)){const i={};for(const s in r[f])i[s]=r[f][s];m.push({identifiers:(0,k.overrideIdentifiersFromKey)(f),keys:Object.keys(i),contents:(0,O.toValuesTree)(i,c)})}return m}}e.ConfigurationModelParser=E;class n extends R.Disposable{constructor(r,c,m,f){super(),this.f=r,this.g=c,this.h=f,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(m.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&m.isEqual(i.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=n;class d{constructor(r,c,m,f,i,s,u,b,g,L,j,G,Q){this.a=r,this.b=c,this.c=m,this.overrideIdentifiers=f,this.d=i,this.f=s,this.g=u,this.h=b,this.i=g,this.j=L,this.k=j,this.l=G,this.m=Q}get value(){return C(this.c)}n(r,c,m){const f=r.inspect(c,m);return{get value(){return C(f.value)},get override(){return C(f.override)},get merged(){return C(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,c,m,f,i=new I,s=new I,u=new P.ResourceMap,b=new I,g=new P.ResourceMap){this.c=r,this.d=c,this.f=m,this.g=f,this.h=i,this.i=s,this.j=u,this.l=b,this.m=g,this.a=null,this.b=new P.ResourceMap,this.n=null}getValue(r,c,m){return this.q(r,c,m).getValue(r)}updateValue(r,c,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new I,this.m.set(m.resource,f))):f=this.l,c===void 0?f.removeValue(r):f.setValue(r,c),m.resource||(this.a=null)}inspect(r,c,m){const f=this.q(r,c,m),i=this.u(c.resource,m),s=c.resource?this.m.get(c.resource)||this.l:this.l,u=new Set;for(const b of f.overrides)for(const g of b.identifiers)f.getOverrideValue(r,g)!==void 0&&u.add(g);return new d(r,c,f.getValue(r),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,i||void 0,s)}keys(r){const c=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.j.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const m=[];if(!c){const{added:f,updated:i,removed:s}=p(this.c,r);c=[...f,...i,...s]}for(const f of c)for(const i of(0,k.overrideIdentifiersFromKey)(f)){const s=this.c.getKeysForOverrideIdentifier(i),u=r.getKeysForOverrideIdentifier(i),b=[...u.filter(g=>s.indexOf(g)===-1),...s.filter(g=>u.indexOf(g)===-1),...s.filter(g=>!T.equals(this.c.override(i).getValue(g),r.override(i).getValue(g)))];m.push([i,b])}return this.updateDefaultConfiguration(r),{keys:c,overrides:m}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:m,removed:f}=p(this.d,r),i=[...c,...m,...f];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.applicationConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.localUserConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.remoteUserConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:m,removed:f,overrides:i}=p(this.workspaceConfiguration,r),s=[...c,...m,...f];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:i}}compareAndUpdateFolderConfiguration(r,c){const m=this.p.get(r),{added:f,updated:i,removed:s,overrides:u}=p(m,c),b=[...f,...i,...s];return(b.length||!m)&&this.updateFolderConfiguration(r,c),{keys:b,overrides:u}}compareAndDeleteFolderConfiguration(r){const c=this.p.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:m,updated:f,removed:i,overrides:s}=p(c,void 0);return{keys:[...m,...f,...i],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,c,m){let f=this.r(c,m);return c.overrideIdentifier&&(f=f.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(f=f.merge(this.d)),f}r({resource:r},c){let m=this.s();if(c&&r){const f=c.getFolder(r);f&&(m=this.t(f.uri)||m);const i=this.m.get(r);i&&(m=m.merge(i))}return m}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let c=this.b.get(r);if(!c){const m=this.s(),f=this.j.get(r);f?(c=m.merge(f),this.b.set(r,c)):c=m}return c}u(r,c){if(c&&r){const m=c.getFolder(r);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,c)=>{const{contents:m,overrides:f,keys:i}=this.j.get(c);return r.push([c,{contents:m,overrides:f,keys:i}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.i.keys.forEach(c=>r.add(c)),this.j.forEach(c=>c.keys.forEach(m=>r.add(m))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(m=>r.add(m))),[...r.values()]}w(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this.i.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(r).forEach(f=>c.add(f))),[...c.values()]}static parse(r){const c=this.x(r.defaults),m=this.x(r.policy),f=this.x(r.application),i=this.x(r.user),s=this.x(r.workspace),u=r.folders.reduce((b,g)=>(b.set(v.URI.revive(g[0]),this.x(g[1])),b),new P.ResourceMap);return new h(c,m,f,i,new I,s,u,new I,new P.ResourceMap)}static x(r){return new I(r.contents,r.keys,r.overrides)}}e.Configuration=h;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,c=new Map;for(const f of o)f.keys.forEach(i=>r.add(i)),f.overrides.forEach(([i,s])=>{const u=(0,P.getOrSet)(c,i,new Set);s.forEach(b=>u.add(b))});const m=[];return c.forEach((f,i)=>m.push([i,[...f.values()]])),{keys:[...r.values()],overrides:m}}e.mergeChanges=w;class y{constructor(r,c,m,f){this.change=r,this.f=c,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const s of i)this.affectedKeys.add(s);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,c){const m=this.a+r,f=this.d.indexOf(m);if(f<0)return!1;const i=f+m.length;if(i>=this.d.length)return!1;const s=this.d.charCodeAt(i);if(s!==this.b&&s!==this.c)return!1;if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,b=this.g.getValue(r,c,this.h);return!T.equals(u,b)}return!0}}e.ConfigurationChangeEvent=y;function p(o,r){const{added:c,removed:m,updated:f}=t(r?.rawConfiguration,o?.rawConfiguration),i=[],s=o?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const b=u.filter(g=>!s.includes(g));for(const g of b)i.push([g,r.getKeysForOverrideIdentifier(g)])}if(o){const b=s.filter(g=>!u.includes(g));for(const g of b)i.push([g,o.getKeysForOverrideIdentifier(g)])}if(r&&o){for(const b of s)if(u.includes(b)){const g=t({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)});i.push([b,[...g.added,...g.removed,...g.updated]])}}return{added:c,removed:m,updated:f,overrides:i}}function t(o,r){const c=o?r?o.keys.filter(i=>r.keys.indexOf(i)===-1):[...o.keys]:[],m=r?o?r.keys.filter(i=>o.keys.indexOf(i)===-1):[...r.keys]:[],f=[];if(o&&r){for(const i of r.keys)if(o.keys.indexOf(i)!==-1){const s=(0,O.getConfigurationValue)(r.contents,i),u=(0,O.getConfigurationValue)(o.contents,i);T.equals(s,u)||f.push(i)}}return{added:c,removed:m,updated:f}}}),define(Ie[128],Ce([1,0,8,4]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof R&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof R&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof R&&D._code===l.NoResolverFound}static isHandled(D){return D instanceof R&&D.isHandled}constructor(D,v=l.Unknown,O){super(D),this._message=D,this._code=v,this._detail=O,this.isHandled=v===l.NotAvailable&&O===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function P(T){const D=T.indexOf("+");return D===-1?T:T.substring(0,D)}e.getRemoteAuthorityPrefix=P}),define(Ie[73],Ce([1,0,18]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(v){return v.scheme===a.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=A;function l(v){if(!v)return;const O=v.indexOf("+");return O<0?v:v.substr(0,O)}e.getRemoteName=l;function R(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=R;function P(v){const{host:O,port:k}=D(v);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:k}}e.parseAuthorityWithPort=P;function T(v,O){let{host:k,port:S}=D(v);return typeof S>"u"&&(S=O),{host:k,port:S}}e.parseAuthorityWithOptionalPort=T;function D(v){const O=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const k=v.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=v.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:v,port:void 0}}}),define(Ie[25],Ce([1,0,9,4,73]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var T;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(n){this.value=n,this.c=n.toLowerCase()}static equals(n,d){if(typeof n>"u"||n===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof n=="string"||typeof d=="string"){const h=typeof n=="string"?n:n.value,w=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(h,w)}return n.c===d.c}static toKey(n){return typeof n=="string"?n.toLowerCase():n.c}}e.ExtensionIdentifier=D;class v{get size(){return this.c.size}constructor(n){if(this.c=new Set,n)for(const d of n)this.add(d)}add(n){this.c.add(D.toKey(n))}delete(n){return this.c.delete(D.toKey(n))}has(n){return this.c.has(D.toKey(n))}}e.ExtensionIdentifierSet=v;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(n){this.c.delete(D.toKey(n))}get(n){return this.c.get(D.toKey(n))}has(n){return this.c.has(D.toKey(n))}set(n,d){this.c.set(D.toKey(n),d)}values(){return this.c.values()}forEach(n){this.c.forEach(n)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function k(E){return S(E)}e.isApplicationScopedExtension=k;function S(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function C(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function I(E,n){if(n){const d=`onResolveRemoteAuthority:${(0,l.getRemoteName)(n)}`;return!!E.activationEvents?.includes(d)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[129],Ce([1,0,8,25]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class l{constructor(){this.a=new Map,this.b=new WeakMap}register(P,T){this.a.set(P,T)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const T=Object.create(null);for(const D of P){const v=this.readActivationEvents(D);v.length>0&&(T[A.ExtensionIdentifier.toKey(D.identifier)]=v)}return T}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const T=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return T;for(const D in P.contributes){const v=this.a.get(D);if(!v)continue;const O=P.contributes[D],k=Array.isArray(O)?O:[O];try{v(k,T)}catch(S){(0,a.onUnexpectedError)(S)}}return T}}e.ImplicitActivationEventsImpl=l,e.ImplicitActivationEvents=new l}),define(Ie[216],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((l,R)=>se(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.c(),P=new R.validator;if(P){const T=String(a.a++);return this.b.set(T,P),{id:T,data:P.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const P=this.b.get(l.id);if(!P)return!1;this.b.delete(l.id);try{return P.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.c(),P=new R.signer;if(P)return P.sign(l)}catch{}return l}}a.a=1,e.SignService=a}),define(Ie[217],Ce([1,0,14,36,30]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(D){if(a.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function P(D,v,O,k,S,C,I,E){const n=Object.create(null);n["common.machineId"]=C,n.sessionID=(0,l.generateUuid)()+Date.now(),n.commitHash=k,n.version=S,n["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,a.PlatformToString)(a.platform),n["common.nodePlatform"]=A.platform,n["common.nodeArch"]=O,n["common.product"]=E||"desktop",I&&(n["common.msftInternal"]=I);let d=0;const h=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),a.isLinuxSnap&&(n["common.snap"]="true");const w=R(v);return w&&(n["common.platformDetail"]=w),n}e.resolveCommonProperties=P;function T(D){const v=A.env.USERDNSDOMAIN;if(!v)return!1;const O=v.toLowerCase();return D.some(k=>O===k)}e.verifyMicrosoftInternalDomain=T}),define(Ie[218],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[74],Ce([1,0,23,10,3,54,73,217,218]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(m){this.value=m}}e.TelemetryTrustedValue=v;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class k{async publicLog(m,f,i){}async publicLogError(m,f,i){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(c,m){return l.Event.debounce(m.onDidChangeConfiguration,(i,s)=>{const u=i?new Set([...i.affectedKeys,...s.affectedKeys]):s.affectedKeys;return{...s,affectedKeys:u}},1e3,!0)(i=>{i.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=S;function C(c,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!c.enableTelemetry||m.extensionTestsLocationURI)}e.supportsTelemetry=C;function I(c,m){return!(m.isBuilt||m.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=I;function E(c){const m=c.getValue(D.TELEMETRY_SETTING_ID),f=c.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function n(c){const m={},f={},i={};w(c,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const u=i[s];typeof u=="number"?f[s]=u:typeof u=="boolean"?f[s]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${u.length}`),m[s]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(m[s]=u)}return{properties:m,measurements:f}}e.validateTelemetryData=n;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(c){if(!c)return"none";const m=(0,P.getRemoteName)(c);return d.has(m)?m:"other"}e.cleanRemoteAuthority=h;function w(c,m,f=0,i){if(!!c)for(const s of Object.getOwnPropertyNames(c)){const u=c[s],b=i?i+s:s;Array.isArray(u)?m[b]=(0,a.safeStringify)(u):u instanceof Date?m[b]=u.toISOString():(0,A.isObject)(u)?f<2?w(u,m,f+1,b+"."):m[b]=(0,a.safeStringify)(u):m[b]=u}}function y(c,m){const f=c.msftInternalDomains||[],i=m.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(f)||i}e.isInternalTelemetry=y;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(c,m){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let f=c;const i=[];for(const g of m)for(;;){const L=g.exec(c);if(!L)break;i.push([L.index,g.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(f="";;){const g=u.exec(c);if(!g)break;const L=i.some(([j,G])=>g.index<G&&j<u.lastIndex);!s.test(g[0])&&!L&&(f+=c.substring(b,g.index)+"<REDACTED: user-file-path>",b=u.lastIndex)}return b<c.length&&(f+=c.substr(b)),f}function o(c){if(!c)return c;const m=c.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of f)if(i.regex.test(m))return`<REDACTED: ${i.label}>`;return c}function r(c,m){return(0,a.cloneAndChange)(c,f=>{if(f instanceof v)return f.value;if(typeof f=="string"){let i=f.replaceAll("%20"," ");i=t(i,m);for(const s of m)i=i.replace(s,"");return i=o(i),i}})}e.cleanData=r}),define(Ie[219],Ce([1,0,9,123,25,14,2,8,36,74]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,a.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=O;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(c){const m=c.manifest?c.manifest.version:c.version,f=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new S(c.identifier,m,f)}static parse(c){const m=k.exec(c);return m&&m[1]&&m[2]?new S({id:m[1]},m[2],m[4]||void 0):null}constructor(c,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof S?O(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=S;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(r){const c=C.exec(r);return c&&c[1]?[n(c[1]),c[2]]:[n(r),void 0]}e.getIdAndVersion=I;function E(r,c){return`${r}.${c}`}e.getExtensionId=E;function n(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function d(r,c){return n(E(r??l.UNDEFINED_PUBLISHER,c))}e.getGalleryExtensionId=d;function h(r,c){const m=[],f=i=>{for(const s of m)if(s.some(u=>O(c(u),c(i))))return s;return null};for(const i of r){const s=f(i);s?s.push(i):m.push([i])}return m}e.groupByExtension=h;function w(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function y(r){return{id:new v.TelemetryTrustedValue(r.identifier.id),name:new v.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,c){const m=[],f=c.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const i=f.shift();if(i&&m.every(s=>!O(s.identifier,{id:i}))){const s=r.filter(u=>O(u.identifier,{id:i}));s.length===1&&(m.push(s[0]),f.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=p;async function t(r,c){if(!R.isLinux)return!1;let m;try{m=(await r.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await r.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){c.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(i))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,c){const m=await t(r,c),f=(0,A.getTargetPlatform)(m?"alpine":R.platform,D.arch);return c.debug("ComputeTargetPlatform:",f),f}e.computeTargetPlatform=o}),define(Ie[220],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=a;function A(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=A;function l(P){return Array.from(P.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=l;function R(P){return new Map(P.map(T=>[T[0],{map:A(T[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(Ie[221],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,P=5){const T=R(D=>{const v=typeof D=="string"?D:D.data;let O=this.a.get(l);if(O){O.data.push(v);return}const k=setTimeout(()=>this.flushBuffer(l),P);O={data:[v],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(l),T.dispose()}},this.a.set(l,O)});return T}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.TerminalDataBufferer=a}),define(Ie[222],Ce([1,0,19,67,52,3,10,2,179,93,40]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(y){function p(t,o){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const c=I.getIcon(r.id);if(!c)return;r=c.defaults}return r}y.getDefinition=p})(k=e.IconContribution||(e.IconContribution={}));var S;(function(y){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(r=>({format:r.format,location:r.location.toString()}))}}y.toJSONObject=p;function t(o){const r=c=>(0,P.isString)(c)?c:void 0;if(o&&Array.isArray(o.src)&&o.src.every(c=>(0,P.isString)(c.format)&&(0,P.isString)(c.location)))return{weight:r(o.weight),style:r(o.style),src:o.src.map(c=>({format:c.format,location:T.URI.parse(c.location)}))}}y.fromJSONObject=t})(S=e.IconFontDefinition||(e.IconFontDefinition={}));class C{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,t,o,r){const c=this.b[p];if(c){if(o&&!c.description){c.description=o,this.d.properties[p].markdownDescription=`${o} $(${p})`;const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enumDescriptions[i]=o),this.a.fire()}return c}const m={id:p,description:o,defaults:t,deprecationMessage:r};this.b[p]=m;const f={$ref:"#/definitions/icons"};return r&&(f.deprecationMessage=r),o&&(f.markdownDescription=`${o}: $(${p})`),this.d.properties[p]=f,this.e.enum.push(p),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const t=this.e.enum.indexOf(p);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,t){const o=this.f[p];return o||(this.f[p]=t,this.a.fire(),t)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,m)=>c.id.localeCompare(m.id),t=c=>{for(;l.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(c=>this.b[c]);for(const c of r.filter(m=>!!m.description).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|${l.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const c of r.filter(m=>!l.ThemeIcon.isThemeIcon(m.defaults)).sort(p))o.push(`|<i class="${t(c)}"></i>|${c.id}|`);return o.join(`
`)}}const I=new C;O.Registry.add(e.Extensions.IconContribution,I);function E(y,p,t,o){return I.registerIcon(y,p,t,o)}e.registerIcon=E;function n(){return I}e.getIconRegistry=n;function d(){const y=(0,A.getCodiconFontCharacters)();for(const p in y){const t="\\"+y[p].toString(16);I.registerIcon(p,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const h=O.Registry.as(v.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,I.getIconSchema());const w=new a.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);I.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=E("widget-close",A.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",A.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",A.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=l.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(Ie[130],Ce([1,0,3,54,4,16]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var P;(function(E){E.Http="http",E.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=k;function S(E,n,d,h){if(d===1)return!1;if(d===2&&k(n)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(w?.length===4&&parseInt(w[1])>=18)return!1}return E<1024}e.isPortPrivileged=S;class C{constructor(n,d,h){this.remoteAddress=n,this.localAddress=d,this.b=h,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let I=class{constructor(n,d){this.i=n,this.j=d,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const n=this.j.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.e=n,n?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.f=n.elevation,this.g=n.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const n=[],d=Array.from(this.d.values());for(const h of d){const w=Array.from(h.values());for(const y of w){const p=await y.value;p&&n.push(p)}}return n}async dispose(){for(const n of this.d.values()){for(const{value:d}of n.values())await d.then(h=>h?.dispose());n.clear()}this.d.clear()}setEnvironmentTunnel(n,d,h,w,y){this.o(n,d,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:d,localAddress:h,privacy:w,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,d){(k(n)||O(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const h=this.q(n,d);if(h)return++h.refcount,h.value}openTunnel(n,d,h,w,y,p=!1,t,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${y}.`),!n)return;if(d||(d="localhost"),w||(w=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(n,d,h,w,y,p,t,o);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.m(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(m),m}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const d=this.d.get(n.tunnelRemoteHost);if(d){const h=d.get(n.tunnelRemotePort);h&&(h.refcount--,await this.n(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async n(n,d,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${d}.`);const w=h.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(n)&&this.d.get(n).delete(d),w}}async closeTunnel(n,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${d} `);const h=this.d.get(n);if(h&&h.has(d)){const w=h.get(d);w.refcount=0,await this.n(n,d,w)}}o(n,d,h){this.d.has(n)||this.d.set(n,new Map),this.d.get(n).set(d,{refcount:1,value:h})}async p(n,d){const h=this.d.get(n);h&&(await h.get(d)||h.delete(d),h.size===0&&this.d.delete(n))}q(n,d){const h=[n];O(n)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):k(n)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const w=h.map(y=>this.d.get(y));for(const y of w){const p=y?.get(d);if(p)return p}}canTunnel(n){return!!v(n)}s(n,d,h,w,y,p,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${w}.`);const o=h;this.h.add(o);const r=w===void 0?h:w,c={elevationRequired:y?this.isPortPrivileged(r):!1},m={remoteAddress:{host:d,port:h},localAddressPort:w,privacy:p,public:p?p!==T.Private:void 0,protocol:t},f=n.forwardPort(m,c);return f?(this.o(d,h,f),f.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),f}};I=Ve([$e(0,R.ILogService),$e(1,A.IConfigurationService)],I),e.AbstractTunnelService=I}),define(Ie[223],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var A;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[224],Ce([1,0,18]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(D){return D.scheme!==a.Schemas.file&&D.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=A;function l(D){if(D.folders.length)return D.folders.every(v=>A(v.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=l;function R(D){return l(D)?.scheme}e.getVirtualWorkspaceScheme=R;function P(D){return l(D)?.authority}e.getVirtualWorkspaceAuthority=P;function T(D){return l(D)!==void 0}e.isVirtualWorkspace=T}),define(Ie[48],Ce([1,0,180,15,69,24,2,4,18]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function v(c){const m=c;return typeof m?.id=="string"&&P.URI.isUri(m.uri)}e.isSingleFolderWorkspaceIdentifier=v;function O(c){return typeof c?.id=="string"&&!v(c)&&!S(c)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(c,m){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,A.basename)(c)}:m?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const f=c;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.toWorkspaceIdentifier=k;function S(c){const m=c;return typeof m?.id=="string"&&P.URI.isUri(m.configPath)}e.isWorkspaceIdentifier=S;function C(c){const m=c;if(m?.uri)return{id:m.id,uri:P.URI.revive(m.uri)};const f=c;if(f?.configPath)return{id:f.id,configPath:P.URI.revive(f.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=C;var I;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function E(c){const m=c;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=E;function n(c){const m=c;return!!(m&&typeof m=="object"&&P.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=n;class d{constructor(m,f,i,s,u){this.h=m,this.j=i,this.k=s,this.l=u,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,R.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function w(c){return new h({uri:c,index:0,name:(0,R.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(c,m){return R.extUriBiasedIgnorePathCase.isEqualOrParent(c,m.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function p(c){let m;return P.URI.isUri(c)?m=c:m=c.configuration,m?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(c,m){return!y(c,m)&&!p(c)}e.isSavedWorkspace=o;function r(c){return(typeof c=="string"?(0,A.extname)(c):(0,R.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ie[75],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(Ie[49],Ce([1,0,18,24,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(T=>{const D=this.b.get(T.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(T,D){D===null?this.b.delete(T.scheme):this.b.set(T.scheme,D)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ie[225],Ce([1,0,184,16,210,26]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(D,v,O){const k=O.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",S=O.remote.isRemote?(0,a.localize)(0,null):D?(0,a.localize)(1,null):(0,a.localize)(2,null);super(v.createLogger(k,{name:S}))}};P=Ve([$e(1,A.ILoggerService),$e(2,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ie[226],Ce([1,0,19]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(P,T,D){this.h=new Map,this.a=P,this.b=T,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(v=>(this.f=v,this)),this.g=this.c.onDidChangeStorage(v=>{v.shared===this.b&&v.key===this.a&&(this.f=v.value)}),this.i=new a.RunOnceScheduler(()=>{const v=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of v.values())O.complete()}catch(O){for(const k of v.values())k.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,T){let D=this.f[P];return typeof D>"u"&&(D=T),D}update(P,T){this.f[P]=T;const D=this.h.get(P);if(D!==void 0)return D.p;const v=new a.DeferredPromise;return this.h.set(P,v),this.i.isScheduled()||this.i.schedule(),v.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class l extends A{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,T){super(P.identifier.value,!0,T),this.j=P}}e.ExtensionGlobalMemento=l}),define(Ie[227],Ce([1,0,3,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(P){this.c=P,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,T,D,v){const k=this.c.getNotebookDocument(A.URI.revive(P)).acceptModelChanged(T.value,D,v);this.b.fire(k)}$acceptDirtyStateChanged(P,T){this.c.getNotebookDocument(A.URI.revive(P)).acceptDirty(T)}$acceptModelSaved(P){const T=this.c.getNotebookDocument(A.URI.revive(P));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(Ie[20],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[228],Ce([1,0,25,3]),function(se,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(T,D){l.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),_e(this,l,D,"f"),Ue(this,l,"f").onDidChangePassword(v=>{v.extensionId===this.a&&this.b.fire({key:v.key})})}get(T){return Ue(this,l,"f").get(this.a,T)}store(T,D){return Ue(this,l,"f").store(this.a,T,D)}delete(T){return Ue(this,l,"f").delete(this.a,T)}}e.ExtensionSecrets=R,l=new WeakMap}),define(Ie[55],Ce([1,0,4,130,3,20]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var P;(function(D){function v(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:k.protocol}}D.fromApiTunnel=v;function O(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==A.TunnelPrivacyId.ConstantPrivate&&k.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}D.fromServiceTunnel=O})(P=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(v){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(v){return v}async openTunnel(v,O){}async getTunnels(){return[]}async setTunnelFactory(v){return{dispose:()=>{}}}registerPortsAttributesProvider(v,O){return{dispose:()=>{}}}async $providePortAttributes(v,O,k,S,C){return[]}async $forwardPort(v,O){}async $closeTunnel(v){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([$e(0,R.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Ie[56],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=A}),define(Ie[229],Ce([1,0,22]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(D){let v=this.buffers.indexOf(D);return v<0&&(v=this.buffers.length,this.buffers.push(D)),v}}function l(T,D){if(D.serializeBuffersForPostMessage){const v=new A,O=(C,I)=>{if(I instanceof ArrayBuffer){const E=v.add(I);return{$$vscode_array_buffer_reference$$:!0,index:E}}else if(ArrayBuffer.isView(I)){const E=R(I);if(E){const n=v.add(I.buffer);return{$$vscode_array_buffer_reference$$:!0,index:n,view:{type:E,byteLength:I.byteLength,byteOffset:I.byteOffset}}}}return I},k=JSON.stringify(T,O),S=v.buffers.map(C=>{const I=new Uint8Array(C);return a.VSBuffer.wrap(I)});return{message:k,buffers:S}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=l;function R(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(T,D){const v=D.map(S=>{const C=new ArrayBuffer(S.byteLength);return new Uint8Array(C).set(S.buffer),C}),O=D.length?(S,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const I=C,{index:E}=I,n=v[E];if(I.view)switch(I.view.type){case 1:return new Int8Array(n,I.view.byteOffset,I.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,I.view.byteOffset,I.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,I.view.byteOffset,I.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,I.view.byteOffset,I.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,I.view.byteOffset,I.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,I.view.byteOffset,I.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,I.view.byteOffset,I.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,I.view.byteOffset,I.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,I.view.byteOffset,I.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,I.view.byteOffset,I.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,I.view.byteOffset,I.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return C}:void 0;return{message:JSON.parse(T,O),arrayBuffers:v}}e.deserializeWebviewMessage=P}),define(Ie[230],Ce([1,0,115]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:R,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function l(R){return new a.URITransformer(A(R))}e.createURITransformer=l}),define(Ie[131],Ce([1,0,193,10,2,6,4,40,45,18,46,163,38]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var I;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(I=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(le){const ue=le;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.isEditorPaneWithSelection=E;function n(le,ue,q){for(const F of q.visibleEditorPanes)if(F.group.id===ue&&le.matches(F.input))return F.getViewState()}e.findViewStateForEditor=n;function d(le){if(s(le))return!1;const ue=le;return l.URI.isUri(ue?.resource)}e.isResourceEditorInput=d;function h(le){if(s(le))return!1;const ue=le;return ue?.original!==void 0&&ue.modified!==void 0}e.isResourceDiffEditorInput=h;function w(le){if(s(le)||h(le))return!1;const ue=le;return ue?.primary!==void 0&&ue.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function y(le){if(s(le))return!1;const ue=le;return ue?ue.resource===void 0||ue.resource.scheme===v.Schemas.untitled||ue.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;const p=/Untitled-\d+/;function t(le){return le.scheme===v.Schemas.untitled&&le.path.length>1&&!p.test(le.path)}e.isUntitledWithAssociatedResource=t;function o(le){if(s(le))return!1;const ue=le;return l.URI.isUri(ue?.base?.resource)&&l.URI.isUri(ue?.input1?.resource)&&l.URI.isUri(ue?.input2?.resource)&&l.URI.isUri(ue?.result?.resource)}e.isResourceMergeEditorInput=o;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.a=new Map}registerSource(ue,q){let F=this.a.get(ue);return F||(F={source:ue,label:q},this.a.set(ue,F)),F.source}getSourceLabel(ue){return this.a.get(ue)?.label??ue}}e.SaveSourceRegistry=new m;var f;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function s(le){return le instanceof i}e.isEditorInput=s;function u(le){const ue=le;return l.URI.isUri(ue?.preferredResource)}function b(le){const ue=le;return s(ue?.primary)&&s(ue?.secondary)}e.isSideBySideEditorInput=b;function g(le){const ue=le;return s(ue?.modified)&&s(ue?.original)}e.isDiffEditorInput=g;function L(le,ue,q,F,J){return ve(F,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const ge={...q,limits:{size:Number.MAX_VALUE}};le.openEditor(ue,ge)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:S.default.Warning})}e.createTooLargeFileError=L;function j(le){return s(le?.editor)}e.isEditorInputWithOptions=j;function G(le){const ue=le;return j(le)&&ue?.group!==void 0}e.isEditorInputWithOptionsAndGroup=G;function Q(le){const ue=le;return typeof ue?.groupId=="number"&&s(ue.editor)}e.isEditorIdentifier=Q;var B;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var z;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(z=e.SideBySideEditor||(e.SideBySideEditor={}));class M{getOriginalUri(ue,q){if(!ue)return;if(o(ue))return e.EditorResourceAccessor.getOriginalUri(ue.result,q);if(q?.supportSideBySide){const{primary:J,secondary:ge}=this.a(ue);if(J&&ge){if(q?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===z.ANY)return this.getOriginalUri(J,{filterByScheme:q.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:q.filterByScheme});ue=q.supportSideBySide===z.PRIMARY?J:ge}}if(h(ue)||w(ue)||o(ue))return;const F=u(ue)?ue.preferredResource:ue.resource;return!F||!q||!q.filterByScheme?F:this.b(F,q.filterByScheme)}a(ue){return b(ue)||w(ue)?{primary:ue.primary,secondary:ue.secondary}:g(ue)||h(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,q){if(!ue)return;if(o(ue))return e.EditorResourceAccessor.getCanonicalUri(ue.result,q);if(q?.supportSideBySide){const{primary:J,secondary:ge}=this.a(ue);if(J&&ge){if(q?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===z.ANY)return this.getCanonicalUri(J,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:q.filterByScheme});ue=q.supportSideBySide===z.PRIMARY?J:ge}}if(h(ue)||w(ue)||o(ue))return;const F=ue.resource;return!F||!q||!q.filterByScheme?F:this.b(F,q.filterByScheme)}b(ue,q){if(Array.isArray(q)){if(q.some(F=>ue.scheme===F))return ue}else if(q===ue.scheme)return ue}}e.EditorResourceAccessor=new M;var x;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(x=e.CloseDirection||(e.CloseDirection={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ue){const q=this.a=ue.get(P.IInstantiationService);for(const[F,J]of this.c)this.e(F,J,q);this.c.clear()}e(ue,q,F){const J=F.createInstance(q);this.d.set(ue,J)}registerFileEditorFactory(ue){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ue}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(ue,q){if(this.c.has(ue)||this.d.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.a?this.e(ue,q,this.a):this.c.set(ue,q),(0,R.toDisposable)(()=>{this.c.delete(ue),this.d.delete(ue)})}getEditorSerializer(ue){return this.d.get(typeof ue=="string"?ue:ue.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function re(le,ue,q){return!le||!le.length?[]:await Promise.all(le.map(async F=>{const J=l.URI.revive(F.fileUri);if(!J){q.info("Cannot resolve the path because it is not valid.",F);return}if(!await ue.canHandleResource(J)){q.info("Cannot resolve the path because it cannot be handled",F);return}let Ee=F.exists,ie=F.type;if(typeof Ee!="boolean"||typeof ie!="number")try{ie=(await ue.stat(J)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Ee=!0}catch(de){q.error(de),Ee=!1}if(!Ee&&F.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",F);return}if(ie===D.FileType.Directory){q.info("Cannot resolve the path because it is a directory",F);return}const ne={...F.options,pinned:!0};return Ee?{resource:J,options:ne}:{resource:J,options:ne,forceUntitled:!0}}))}e.pathsToEditors=re;var V;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function _(le){const ue=le;if(!ue)return!1;const q=ue;if(q.modified)return _(q.modified);const F=ue;return!!(F.contributionsState&&F.viewState&&Array.isArray(F.cursorState))}e.isTextEditorViewState=_;function te(le){return(0,O.isErrorWithActions)(le)}e.isEditorOpenError=te;function ve(le,ue,q){const F=(0,O.createErrorWithActions)(le,ue);return F.forceMessage=q?.forceMessage,F.forceSeverity=q?.forceSeverity,F.allowDialog=q?.allowDialog,F}e.createEditorOpenError=ve}),define(Ie[231],Ce([1,0,3,194,4,6,28,40,17,61,23,67,222]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,S.registerIcon)("default-view-icon",k.Codicon.window,(0,A.localize)(0,null));var C;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(C=e.Extensions||(e.Extensions={}));var I;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(I=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function E(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class n extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.flatten)([...this.g.values()])}registerViewContainer(c,m,f){const i=this.get(c.id);if(i)return i;const s=c;return s.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,P.getOrSet)(this.g,m,[]).push(s),f?.isDefault&&this.h.push(s),this.c.fire({viewContainer:s,viewContainerLocation:m}),s}deregisterViewContainer(c){for(const m of this.g.keys()){const f=this.g.get(m),i=f?.indexOf(c);if(i!==-1){f?.splice(i,1),f.length===0&&this.g.delete(m),this.f.fire({viewContainer:c,viewContainerLocation:m});return}}}get(c){return this.all.filter(m=>m.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(f=>f?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(m=>this.getViewContainerLocation(m)===c)}}T.Registry.add(C.ViewContainersRegistry,new n);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function h(r,c){const m=r.group??d.More,f=c.group??d.More;return m!==f?m.localeCompare(f):(r.order??5)-(c.order??5)}class w extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new v.SetMap}registerViews(c,m){this.registerViews2([{views:c,viewContainer:m}])}registerViews2(c){c.forEach(({views:m,viewContainer:f})=>this.l(m,f)),this.c.fire(c)}deregisterViews(c,m){const f=this.m(c,m);f.length&&this.f.fire({views:f,viewContainer:m})}moveViews(c,m){for(const f of this.j.keys())if(f!==m){const i=this.m(c,f);i.length&&(this.l(i,m),this.g.fire({views:i,from:f,to:m}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const m of this.i){const f=(this.j.get(m)||[]).filter(i=>i.id===c)[0];if(f)return f}return null}getViewContainer(c){for(const m of this.i)if((this.j.get(m)||[]).filter(i=>i.id===c)[0])return m;return null}registerViewWelcomeContent(c,m){return this.k.add(c,m),this.h.fire(c),(0,R.toDisposable)(()=>{this.k.delete(c,m),this.h.fire(c)})}registerViewWelcomeContent2(c,m){const f=new Map;for(const[i,s]of m)this.k.add(c,s),f.set(i,(0,R.toDisposable)(()=>{this.k.delete(c,s),this.h.fire(c)}));return this.h.fire(c),f}getViewWelcomeContent(c){const m=[];return this.k.forEach(c,f=>m.push(f)),m.sort(h)}l(c,m){let f=this.j.get(m);f||(f=[],this.j.set(m,f),this.i.push(m));for(const i of c){if(this.getView(i.id)!==null)throw new Error((0,A.localize)(1,null,i.id));f.push(i)}}m(c,m){const f=this.j.get(m);if(!f)return[];const i=[],s=[];for(const u of f)c.includes(u)?i.push(u):s.push(u);return i.length&&(s.length?this.j.set(m,s):(this.j.delete(m),this.i.splice(this.i.indexOf(m),1))),i}}T.Registry.add(C.ViewsRegistry,new w),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var y;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(y=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(c,m){this.c=!1,this.d=!1,(0,O.mixin)(this,c),this.d=!!m,this.resolve=async f=>{if(m&&!this.c){const i=await m(f);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class o extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=o}),define(Ie[132],Ce([1,0,3,19,195]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,D,v,O){const k={command:T};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof O=="number"){const S=setTimeout(()=>{clearTimeout(S);const C=this.f.get(k.seq);if(C){this.f.delete(k.seq);const I={type:"response",seq:0,request_seq:k.seq,success:!1,command:T,message:(0,l.localize)(0,null,O,T)};C(I)}},O)}return v&&this.f.set(k.seq,v),k.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,D){return T.type!=="event"||D.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,A.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const D=T,v=this.f.get(D.request_seq);v&&(this.f.delete(D.request_seq),v(D));break}}}}s(T,D){D.type=T,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((D,v)=>T.set(v,D)),await(0,A.timeout)(500),T.forEach((D,v)=>{D({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.f.delete(v)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(Ie[232],Ce([1,0,196,44,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=S=>a.localize(51,null,S);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var P;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(P=e.State||(e.State={}));function T(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var D;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(D=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var v;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(v=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var k;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[233],Ce([1,0,9,2,15,23,18,32,21,17]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function k(i,s,u){return i.replace(O,function(b,g){return s&&g.length>0&&g[0]!=="_"?b:u&&u.hasOwnProperty(g)?u[g]:b})}e.formatPII=k;function S(i){const s={};for(const u of Object.keys(i))u.startsWith("!")||(s[u]=i[u]);return s}e.filterExceptionsFromTelemetry=S;function C(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||C(i.parentSession))}e.isSessionAttach=C;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(s,"extensionhost")||(0,a.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function E(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=E;function n(i,s,u){let b,g=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=L.exec(i);){const G=j.index+1,Q=G+j[0].length;if(G<=s&&Q>=u){b=j[0],g=G;break}}if(b){const G=/\w+/g;let Q=null;for(;(Q=G.exec(b))&&!(Q.index+1+g+Q[0].length>=u););Q&&(b=b.substring(0,G.lastIndex))}return b?{start:g,end:g+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function d(i,s,u,b){if(i.evaluatableExpressionProvider.has(s)){const g=i.evaluatableExpressionProvider.ordered(s),L=(0,v.coalesce)(await Promise.all(g.map(async j=>{try{return await j.provideEvaluatableExpression(s,u,b??D.CancellationToken.None)}catch{return}})));if(L.length>0){let j=L[0].expression;const G=L[0].range;return j||(j=s.getLineContent(u.lineNumber).substring(G.startColumn-1,G.endColumn-1)),{range:G,matchingExpression:j}}}else{const g=s.getLineContent(u.lineNumber),{start:L,end:j}=n(g,u.column,u.column),G=g.substring(L-1,j);return{matchingExpression:G,range:new T.Range(u.lineNumber,L,u.lineNumber,L+G.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(h))}e.isUri=w;function y(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return A.URI.parse(i.path);if((0,l.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const s=A.URI.revive(i.path);if(s)return s.scheme===P.Schemas.file?s.fsPath:s.toString()}return i.path}function t(i,s){const u=s?y:p,b=(0,R.deepClone)(i);return r(b,(g,L)=>{g&&L&&(L.path=u(L))}),b}e.convertToDAPaths=t;function o(i,s){const u=s?y:p,b=(0,R.deepClone)(i);return r(b,(g,L)=>{!g&&L&&(L.path=u(L))}),b}e.convertToVSCPaths=o;function r(i,s){switch(i.type){case"event":{const u=i;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=i;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>s(!1,b));break;default:break}break}case"response":{const u=i;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":u.body.sources.forEach(b=>s(!1,b));break;case"scopes":u.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":u.body.breakpoints.forEach(b=>s(!1,b.source));break;case"disassemble":u.body?.instructions.forEach(g=>s(!1,g.location));break;default:break}break}}}function c(i){return i.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):m(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:m(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=c;function m(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}async function f(i,s){const u=i.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const b=s.activeEditorPane;b&&b.input.resource?.scheme===P.Schemas.untitled&&await s.save({editor:b.input,groupId:b.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(Ie[234],Ce([1,0,47,235,23,15,14,9,29,197,132]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends O.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,h){this.p=h,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",w=>this.w(w))}sendMessage(d){if(this.p){const h=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${k.a}${h}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const h=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(w){this.m.fire(new Error((w.message||w)+`
`+h))}continue}}else{const h=this.r.indexOf(k.a);if(h!==-1){const y=this.r.toString("utf8",0,h).split(k.b);for(const p of y){const t=p.split(k.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(h+k.a.length);continue}}break}}}k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */,e.StreamDebugAdapter=k;class S extends k{startSession(){return new Promise((d,h)=>{let w=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),w=!0}),this.x.on("close",()=>{w?this.m.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.x.on("error",y=>{w?this.m.fire(y):h(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=S;class C extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=C;class I extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=I;class E extends k{constructor(d,h){super(),this.y=d,this.z=h}async startSession(){const d=this.y.command,h=this.y.args,w=this.y.options||{};try{if(d)if(R.isAbsolute(d)){if(!await D.Promises.exists(d))throw new Error(v.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.z));let y=process.env;if(w.env&&Object.keys(w.env).length>0&&(y=l.mixin(l.deepClone(process.env),w.env)),d==="node")if(Array.isArray(h)&&h.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:y,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};w.cwd&&(t.cwd=w.cwd);const o=a.fork(h[0],h.slice(1),t);if(!o.pid)throw new Error(v.localize(2,null,h[0]));this.x=o}else throw new Error(v.localize(3,null));else{const p={env:y};w.cwd&&(p.cwd=w.cwd),this.x=a.spawn(d,h,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,t)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),P.isWindows?new Promise((d,h)=>{const w=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,p,t){if(y)return h(y)});w.on("exit",d),w.on("error",h)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,h){if(!d)return;const w=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?w.runtime=R.join(h,d.runtime):w.runtime=d.runtime),d.runtimeArgs&&(w.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?w.program=d.program:w.program=R.join(h,d.program)),d.args&&(w.args=d.args);const y=d;return y.win&&(w.win=E.A(y.win,h)),y.winx86&&(w.winx86=E.A(y.winx86,h)),y.windows&&(w.windows=E.A(y.windows,h)),y.osx&&(w.osx=E.A(y.osx,h)),y.linux&&(w.linux=E.A(y.linux,h)),w}static platformAdapterExecutable(d,h){let w=Object.create(null);h=h.toLowerCase();for(const c of d)if(c.contributes){const m=c.contributes.debuggers;m&&m.length>0&&m.filter(f=>typeof f.type=="string"&&T.equalsIgnoreCase(f.type,h)).forEach(f=>{const i=E.A(f,c.extensionLocation.fsPath);w=l.mixin(w,i,c.isBuiltin)})}let y;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=w.winx86||w.win||w.windows:P.isWindows?y=w.win||w.windows:P.isMacintosh?y=w.osx:P.isLinux&&(y=w.linux),y=y||w;const p=y.program||w.program,t=y.args||w.args,o=y.runtime||w.runtime,r=y.runtimeArgs||w.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=E}),define(Ie[236],Ce([1,0,47,33,14]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(v,O){return new Promise((k,S)=>{let C="";const I=a.spawn(v,O);I.pid&&I.stdout.on("data",E=>{C+=E.toString()}),I.on("error",E=>{S(E)}),I.on("close",E=>{k(C)})})}async function P(v){if(v)if(l.isWindows){const O=await new Promise((k,S)=>{se(["windows-process-tree"],k,S)});return new Promise(k=>{O.getProcessTree(v,S=>{k(!!S&&S.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(v)]).then(O=>{const k=O.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var T;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(T||(T={}));function D(v,O,k,S,C){v=v.trim().toLowerCase();let I;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?I=1:v.indexOf("cmd.exe")>=0?I=0:v.indexOf("bash")>=0?I=2:l.isWindows?I=0:I=2;let E,n=" ";switch(I){case 1:if(E=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),S){const d=(0,A.getDriveLetter)(S);d&&(n+=`${d}:; `),n+=`cd ${E(S)}; `}if(C)for(const d in C){const h=C[d];h===null?n+=`Remove-Item env:${d}; `:n+=`\${env:${d}}='${h}'; `}if(O.length>0){const d=O.shift(),h=k?d:E(d);n+=h[0]==="'"?`& ${h} `:`${h} `;for(const w of O)n+=w==="<"||w===">"||k?w:E(w),n+=" "}break;case 0:if(E=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(h=>d.includes(h))||d.length===0?`"${d}"`:d),S){const d=(0,A.getDriveLetter)(S);d&&(n+=`${d}: && `),n+=`cd ${E(S)} && `}if(C){n+='cmd /C "';for(const d in C){let h=C[d];h===null?n+=`set "${d}=" && `:(h=h.replace(/[&^|<>]/g,w=>`^${w}`),n+=`set "${d}=${h}" && `)}}for(const d of O)n+=d==="<"||d===">"||k?d:E(d),n+=" ";C&&(n+='"');break;case 2:{E=h=>(h=h.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),h.length===0?'""':h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(S&&(n+=`cd ${E(S)} ; `),C){n+="/usr/bin/env";for(const h in C){const w=C[h];w===null?n+=` -u ${d(h)}`:n+=` ${d(`${h}=${w}`)}`}n+=" "}for(const h of O)n+=h==="<"||h===">"||k?h:E(h),n+=" ";break}}return n}e.prepareCommand=D}),define(Ie[94],Ce([1,0,22,39,64,88,18,15,14,44]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(I=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var E;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(E=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var h;(function(z){z.scheme=P.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${M.join("")}]+`),fe=7;function re(ue,q){const F=q.toString(fe),ge=`${F.length<M.length?M[F.length-1]:"z"}${F}s${(0,a.encodeBase64)(a.VSBuffer.fromString(ue.scheme),!0,!0)}`;return ue.with({scheme:z.scheme,fragment:ge})}z.generate=re;function V(ue){if(ue.scheme!==z.scheme)return;const q=ue.fragment.indexOf("s");if(q<0)return;const F=parseInt(ue.fragment.substring(0,q).replace(x,""),fe),J=(0,a.decodeBase64)(ue.fragment.substring(q+1)).toString();if(!isNaN(F))return{handle:F,notebook:ue.with({scheme:J,fragment:null})}}z.parse=V;function _(ue,q){return ue.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${ue.scheme!==P.Schemas.file?ue.scheme:""}`})}z.generateCellOutputUri=_;function te(ue){if(ue.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!q)return;const F=q[1]&&q[1]!==""?q[1]:void 0,J=q[2];return{outputId:F,notebook:ue.with({scheme:J||P.Schemas.file,fragment:null})}}z.parseCellOutputUri=te;function ve(ue,q,F){return z.generate(ue,q).with({scheme:F})}z.generateCellPropertyUri=ve;function le(ue,q){if(ue.scheme===q)return z.parse(ue.with({scheme:z.scheme}))}z.parseCellPropertyUri=le})(h=e.CellUri||(e.CellUri={}));const w=z=>D.isWindows?z.replace(/\//g,"\\"):z;class y{constructor(M=[],x=e.NOTEBOOK_DISPLAY_ORDER){this.e=x,this.d=[...new Set(M)].map(fe=>({pattern:fe,matches:A.parse(w(fe))}))}sort(M){const x=new Map(l.Iterable.map(M,re=>[re,w(re)]));let fe=[];for(const{matches:re}of this.d)for(const[V,_]of x)if(re(_)){fe.push(V),x.delete(V);break}return x.size&&(fe=fe.concat([...x.keys()].sort((re,V)=>this.e.indexOf(re)-this.e.indexOf(V)))),fe}prioritize(M,x){const fe=this.f(M);if(fe===-1){this.d.unshift({pattern:M,matches:A.parse(w(M))});return}const re=new Set(x.map(_=>this.f(_,fe)));re.delete(-1);const V=Array.from(re).sort();this.d.splice(fe+1,0,...V.map(_=>this.d[_]));for(let _=V.length-1;_>=0;_--)this.d.splice(V[_],1)}toArray(){return this.d.map(M=>M.pattern)}f(M,x=this.d.length){const fe=w(M);for(let re=0;re<x;re++)if(this.d[re].matches(fe))return re;return-1}}e.MimeTypeDisplayOrder=y;function p(z,M,x,fe=(re,V)=>re===V){const re=[];function V(ve,le,ue){if(le===0&&ue.length===0)return;const q=re[re.length-1];q&&q.start+q.deleteCount===ve?(q.deleteCount+=le,q.toInsert.push(...ue)):re.push({start:ve,deleteCount:le,toInsert:ue})}let _=0,te=0;for(;;){if(_===z.length){V(_,0,M.slice(te));break}if(te===M.length){V(_,z.length-_,[]);break}const ve=z[_],le=M[te];if(fe(ve,le)){_+=1,te+=1;continue}x(le)?(V(_,1,[]),_+=1):(V(_,0,[le]),te+=1)}return re}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(z){z.default="default",z.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(z){const M=z;return!!((typeof M.include=="string"||A.isRelativePattern(M.include))&&(typeof M.exclude=="string"||A.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=o;function r(z,M,x){if(Array.isArray(z.viewType)&&z.viewType.indexOf(M)>=0||z.viewType===M)return!0;if(z.filenamePattern){const fe=o(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,re=o(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(A.match(fe,(0,T.basename)(x.fsPath).toLowerCase()))return!(re&&A.match(re,(0,T.basename)(x.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(M){return`${m.d}${M}`}static parse(M){if(M.startsWith(m.d))return M.substring(m.d.length)}}m.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=m;function f(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=f;const i=new TextDecoder;function s(z){const M=[];let x=!1;for(const fe of z)(M.length===0||x)&&(M.push(fe),x=!0);return L(M),U(a.VSBuffer.concat(M.map(fe=>a.VSBuffer.wrap(fe))))}e.compressOutputItemStreams=s;const u=`${String.fromCharCode(27)}[A`,b=u.split("").map(z=>z.charCodeAt(0)),g=10;function L(z){z.forEach((M,x)=>{if(x===0||M.length<u.length)return;const fe=z[x-1],re=M.subarray(0,u.length);if(re[0]===b[0]&&re[1]===b[1]&&re[2]===b[2]){const V=fe.lastIndexOf(g);if(V===-1)return;z[x-1]=fe.subarray(0,V),z[x]=M.subarray(u.length)}})}function j(z){let M=z;do z=M,M=z.replace(/[^\n]\x08/gm,"");while(M.length<z.length);return z}function G(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const M=z.match(/^(.*)\r+/m)[1];let x=z.match(/\r+(.*)$/m)[1];x=x+M.slice(x.length,M.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return z}const Q="\b".charCodeAt(0),B="\r".charCodeAt(0);function U(z){return!z.buffer.includes(Q)&&!z.buffer.includes(B)?z:a.VSBuffer.fromString(G(j(i.decode(z.buffer))))}}),define(Ie[237],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ie[57],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(P,T,D=P.parent){if(P._isRoot)return new l([T]);const v=[P.id];for(let O=D;O&&O.id!==T;O=O.parent)v.push(O.id);return v.push(T),new l(v.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const T=P.indexOf("\0");return T===-1?P:P.slice(0,T)}static fromString(P){return new l(P.split("\0"))}static join(P,T){return new l([...P.path,T])}static joinToString(P,T){return P.toString()+"\0"+T}static parentId(P){const T=P.lastIndexOf("\0");return T===-1?void 0:P.slice(0,T)}static localId(P){const T=P.lastIndexOf("\0");return T===-1?P:P.slice(T+1)}static compare(P,T){return P===T?0:T.startsWith(P+"\0")?2:P.startsWith(T+"\0")?3:1}constructor(P,T=P.length){if(this.path=P,this.d=T,P.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new l(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new l(this.path,P)}compare(P){if(typeof P=="string")return l.compare(this.toString(),P);for(let T=0;T<P.d&&T<this.d;T++)if(P.path[T]!==this.path[T])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.TestId=l}),define(Ie[76],Ce([1,0,2,32,57]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var P;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const T=i=>"runId"in i;e.isStartControllerTests=T;var D;(function(i){i.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),i.deserialize=s=>({range:A.Range.lift(s.range),uri:a.URI.revive(s.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var v;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(v=e.TestMessageType||(e.TestMessageType={}));var O;(function(i){i.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&D.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&D.deserialize(s.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(i,s)=>`${s?"s":"e"}${i}`;e.getMarkId=k;var S;(function(i){i.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&D.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&D.deserialize(s.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var C;(function(i){i.serialize=s=>s.type===0?O.serialize(s):S.serialize(s),i.deserialize=s=>s.type===0?O.deserialize(s):S.deserialize(s)})(C=e.ITestMessage||(e.ITestMessage={}));var I;(function(i){i.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),i.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.serialize)}),i.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",n=(i,s)=>i+E+s;e.namespaceTestTag=n;const d=i=>{const s=i.indexOf(E);return{ctrlId:i.slice(0,s),tagId:i.slice(s+1)}};e.denamespaceTestTag=d;var h;(function(i){i.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),i.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?a.URI.revive(s.uri):void 0,range:s.range?A.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(h=e.ITestItem||(e.ITestItem={}));var w;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(i){i.serialize=s=>({expand:s.expand,item:h.serialize(s.item)}),i.deserialize=s=>({controllerId:l.TestId.root(s.item.extId),expand:s.expand,item:h.deserialize(s.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.uri!==void 0&&(u.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(u.range=s.item.range?.toJSON()),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}},i.deserialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.range!==void 0&&(u.range=s.item.range?A.Range.lift(s.item.range):null),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,s)=>{s.expand!==void 0&&(i.expand=s.expand),s.item!==void 0&&(i.item=i.item?Object.assign(i.item,s.item):s.item)};e.applyTestItemUpdate=t;var o;(function(i){i.serializeWithoutMessages=s=>({...y.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(I.serializeWithoutMessages),retired:s.retired}),i.serialize=s=>({...y.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(I.serialize),retired:s.retired}),i.deserialize=s=>({...y.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(I.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var m;(function(i){i.deserialize=s=>s.op===0?{op:s.op,item:y.deserialize(s.item)}:s.op===1?{op:s.op,item:p.deserialize(s.item)}:s.op===2?{op:s.op,uri:a.URI.revive(s.uri),docv:s.docv}:s,i.serialize=s=>s.op===0?{op:s.op,item:y.serialize(s.item)}:s.op===1?{op:s.op,item:p.serialize(s.item)}:s})(m=e.TestsDiffOp||(e.TestsDiffOp={}));class f{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const u=this.o();for(const b of s)switch(b.op){case 0:this.j(y.deserialize(b.item),u);break;case 1:this.k(p.deserialize(b.item),u);break;case 3:this.l(b.itemId,u);break;case 5:this.m(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.c.set(b.tag.id,b.tag);break;case 7:this.c.delete(b.id);break}u.complete?.()}j(s,u){const b=l.TestId.parentId(s.item.extId)?.toString();let g;if(!b)g=this.p(s),this.f.add(g),this.d.set(s.item.extId,g);else if(this.d.has(b)){const L=this.d.get(b);L.children.add(s.item.extId),g=this.p(s,L),this.d.set(s.item.extId,g)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return u.add?.(g),s.expand===2&&this.g++,g}k(s,u){const b=this.d.get(s.extId);if(!!b)return s.expand!==void 0&&(b.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(b,s),u.update?.(b),b}l(s,u){const b=this.d.get(s);if(!b)return;const g=l.TestId.parentId(b.item.extId)?.toString();g?this.d.get(g).children.delete(b.item.extId):this.f.delete(b);const L=[[s]];for(;L.length;)for(const j of L.pop()){const G=this.d.get(j);G&&(L.push(G.children),this.d.delete(j),u.remove?.(G,G!==b),G.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=f}),define(Ie[95],Ce([1,0,19,3,6,51,76,57]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(D=e.TestItemEventOp||(e.TestItemEventOp={}));const v=(h,w)=>h===w,k=Object.entries({range:(h,w)=>h===w?!0:!h||!w?!1:h.equalsRange(w),busy:v,label:v,description:v,error:v,sortText:v,tags:(h,w)=>!(h.length!==w.length||h.some(y=>!w.includes(y)))}),S=(h,w)=>{let y;for(const[p,t]of k)t(h[p],w[p])||(y?y[p]=w[p]:y={[p]:w[p]});return y};class C extends l.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===w.uri){y.docv=w.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===w.item.extId){(0,P.applyTestItemUpdate)(y.item,w.item);return}if(y.op===0&&y.item.item.extId===w.item.extId){(0,P.applyTestItemUpdate)(y.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,y){const p=this.tree.get(w);if(!!p){if((p.expandLevels===void 0||y>p.expandLevels)&&(p.expandLevels=y),p.expand===1){const t=this.I(p);return t.isOpen()?this.H(p,y-1):t.wait().then(()=>this.H(p,y-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,y-1)):this.H(p,y-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,y){switch(y.op){case 3:this.L(T.TestId.joinToString(w.fullId,y.id));break;case 0:this.u(y.item,w);break;case 5:for(const p of y.ops)this.p(w,p);break;case 1:this.w(y.new,y.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:y.update}});break;case 6:this.s(w.actual.uri);break;default:(0,R.assertNever)(y)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,y){const p=T.TestId.fromExtHostTestItem(w,this.root.id,y?.actual),t=this.m.getApiFor(w);t.parent&&t.parent!==y?.actual&&this.m.getChildren(t.parent).delete(w.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:w,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(w,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(w)}}),this.F(w,o,y);return}if(o.actual===w){this.D(w,o,y);return}if(o.actual.uri?.toString()!==w.uri?.toString())return this.L(p.toString()),this.u(w,y);const r=this.m.getChildren(o.actual),c=o.actual,m=S(this.m.toITestItem(c),this.m.toITestItem(w));this.m.getApiFor(c).listener=void 0,o.actual=w,o.expand=0,m&&(m.hasOwnProperty("tags")&&(this.w(w.tags,c.tags,p.toString()),delete m.tags),this.p(o,{op:4,update:m})),this.F(w,o,y);for(const[f,i]of r)this.m.getChildren(w).get(i.id)||this.L(T.TestId.joinToString(p,i.id));this.s(o.actual.uri)}w(w,y,p){const t=new Set(y.map(o=>o.id));for(const o of w)t.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:p,item:{tags:w.map(o=>(0,P.namespaceTestTag)(this.m.controllerId,o.id))}}}),t.forEach(this.z,this)}y(w){const y=this.j.get(w.id);y?y.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.namespaceTestTag)(this.m.controllerId,w.id)}}))}z(w){const y=this.j.get(w);y&&!--y.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,P.namespaceTestTag)(this.m.controllerId,w)}))}C(w,y){this.m.getApiFor(w).parent=y&&y.actual!==this.root?y.actual:void 0}D(w,y,p){this.C(w,p);const t=this.m.getApiFor(w);t.parent=p?.actual,t.listener=o=>this.p(y,o),this.G(y)}F(w,y,p){this.D(w,y,p);for(const[t,o]of this.m.getChildren(w))this.u(o,y)}G(w){let y;this.h?w.resolveBarrier?y=w.resolveBarrier.isOpen()?3:2:y=w.actual.canResolveChildren?1:0:y=0,y!==w.expand&&(w.expand=y,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:y}}),y===1&&w.expandLevels!==void 0&&this.I(w))}H(w,y){if(y<0)return;const p=[];for(const[t,o]of this.m.getChildren(w.actual)){const r=this.expand(T.TestId.joinToString(w.fullId,o.id),y);(0,a.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const o=new a.Barrier;return o.open(),o}w.expand=2,this.J(w);const y=w.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let t;try{t=this.h(w.actual===this.root?void 0:w.actual)}catch(o){p(o)}return(0,a.isThenable)(t)?t.catch(p).then(()=>{y.open(),this.G(w)}):(y.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const y=this.tree.get(w);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const p=[y];for(;p.length;){const t=p.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.z(o.id);this.tree.delete(t.fullId.toString());for(const[o,r]of this.m.getChildren(t.actual))p.push(this.tree.get(T.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=C;class I extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=I;class E extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class n extends Error{constructor(w,y,p){super(`TestItem with ID "${w}" is from controller "${y}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=n;const d=(h,w,y)=>{let p=new Map;return{get size(){return p.size},forEach(t,o){for(const r of p.values())t.call(o,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const o=new Map,r=new Set(p.keys()),c={op:5,ops:[]};for(const m of t){if(!(m instanceof y))throw new E(m.id);const f=w(m).controllerId;if(f!==h.controllerId)throw new n(m.id,f,h.controllerId);if(o.has(m.id))throw new I(m.id);o.set(m.id,m),r.delete(m.id),c.ops.push({op:0,item:m})}for(const m of r.keys())c.ops.push({op:3,id:m});h.listener?.(c),p=o},add(t){if(!(t instanceof y))throw new E(t.id);p.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){p.delete(t)&&h.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=d}),define(Ie[133],Ce([1,0,95]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(P,T)=>{const D={controllerId:T};return A.set(P,D),D};e.createPrivateApiFor=l;const R=P=>{const T=A.get(P);if(!T)throw new a.InvalidTestItemError(P?.id||"<unknown>");return T};e.getPrivateApiFor=R}),define(Ie[96],Ce([1,0,18,2]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(T,D){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(D&&D.authority&&D.isRemote&&T.scheme===a.Schemas.file&&(T=A.URI.from({scheme:a.Schemas.vscodeRemote,authority:D.authority,path:T.path})),A.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${R(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=l;function R(T){return T.replace(/./g,D=>{const v=D.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?D:"-"+v.toString(16).padStart(4,"0")})}function P(T){return T.replace(/-([0-9a-f]{4})/g,(D,v)=>String.fromCharCode(parseInt(v,16)))}e.decodeAuthority=P}),define(Ie[238],Ce([1,0,3,6,96]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(T,D,v){this.d=T,this.e=D,this.f=v,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const O=D.getVisibleTextEditors();for(const k of this.c.values())O.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,D,v,O,k){let S;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===T){S=w;break}if(!S)throw new Error("not a visible editor");const C=this,I=this.a++,E=new a.Emitter,n=new a.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,l.asWebviewUri)(w,C.f)}get cspSource(){return l.webviewGenericCspSource}set options(w){this.b=w,C.d.$setOptions(I,w)}get options(){return this.b}set html(w){this.a=w,C.d.$setHtml(I,w)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(w){return C.d.$postMessage(I,w)}},h=new class{constructor(){this.editor=T,this.line=D,this.height=v,this.webview=d,this.onDidDispose=n.event}dispose(){C.c.has(I)&&(C.c.delete(I),C.d.$disposeEditorInset(I),n.fire(),n.dispose(),E.dispose())}};return this.d.$createEditorInset(I,S.id,S.value.document.uri,D+1,v,O||{},k.identifier,k.extensionLocation),this.c.set(I,{editor:T,inset:h,onDidReceiveMessage:E}),h}$onDidDispose(T){const D=this.c.get(T);D&&D.inset.dispose()}$onDidReceiveMessage(T,D){this.c.get(T)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=R}),define(Ie[239],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(P,T){super(T),this.variable=P}}e.VariableError=l}),define(Ie[240],Ce([1,0,15,36,10,23,14,114,200,239,9]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,I,E,n){this.g=new Map,this.a=C,this.b=I,this.d=E,n&&(this.c=n.then(d=>this.h(d)))}h(C){if(P.isWindows){const I=Object.create(null);return Object.keys(C).forEach(E=>{I[E.toLowerCase()]=C[E]}),I}return C}resolveWithEnvironment(C,I,E){return this.j({env:this.h(C),userHome:void 0},I?I.uri:void 0,E)}async resolveAsync(C,I){const E={env:await this.c,userHome:await this.d};return this.j(E,C?C.uri:void 0,I)}async i(C,I,E,n){const d=R.deepClone(I);P.isWindows&&d.windows?Object.keys(d.windows).forEach(w=>d[w]=d.windows[w]):P.isMacintosh&&d.osx?Object.keys(d.osx).forEach(w=>d[w]=d.osx[w]):P.isLinux&&d.linux&&Object.keys(d.linux).forEach(w=>d[w]=d.linux[w]),delete d.windows,delete d.osx,delete d.linux;const h={env:await this.c,userHome:await this.d};return this.j(h,C?C.uri:void 0,d,E,n)}async resolveAnyAsync(C,I,E){return this.i(C,I,E)}async resolveAnyMap(C,I,E){const n=new Map;return{newConfig:await this.i(C,I,E,n),resolvedVariables:n}}resolveWithInteractionReplace(C,I,E,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,I,E,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,I){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,I)}async j(C,I,E,n,d){if(l.isString(E))return this.l(C,I,E,n,d);if(Array.isArray(E))return Promise.all(E.map(h=>this.j(C,I,h,n,d)));if(l.isObject(E)){const h=Object.create(null),w=await Promise.all(Object.keys(E).map(async y=>[await this.l(C,I,y,n,d),await this.j(C,I,E[y],n,d)]));for(const[y,p]of w)h[y]=p;return h}return E}l(C,I,E,n,d){return(0,O.replaceAsync)(E,k.VARIABLE_REGEXP,async(h,w)=>{if(w.includes(k.VARIABLE_LHS))return h;let y=await this.n(C,h,w,I,n);return d?.set(w,y),y!==h&&l.isString(y)&&y.match(k.VARIABLE_REGEXP)&&(y=await this.l(C,I,y,n,d)),y})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,I,E,n,d){let h;const w=E.split(":");w.length>1&&(E=w[0],h=w[1]);const y=o=>{const r=this.a.getFilePath();if(r)return(0,T.normalizeDriveLetter)(r);throw new v.VariableError(o,(0,D.localize)(0,null,I))},p=o=>{const r=y(o);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,T.normalizeDriveLetter)(c)}throw new v.VariableError(o,(0,D.localize)(1,null,I,a.basename(r)))},t=o=>{if(h){const r=this.a.getFolderUri(h);if(r)return r;throw new v.VariableError(o,(0,D.localize)(2,null,I,h))}if(n)return n;throw this.a.getWorkspaceFolderCount()>1?new v.VariableError(o,(0,D.localize)(3,null,I)):new v.VariableError(o,(0,D.localize)(4,null,I))};switch(E){case"env":if(h){if(C.env){const o=C.env[P.isWindows?h.toLowerCase():h];if(l.isString(o))return o}return""}throw new v.VariableError(v.VariableKind.Env,(0,D.localize)(5,null,I));case"config":if(h){const o=this.a.getConfigurationValue(n,h);if(l.isUndefinedOrNull(o))throw new v.VariableError(v.VariableKind.Config,(0,D.localize)(6,null,I,h));if(l.isObject(o))throw new v.VariableError(v.VariableKind.Config,(0,D.localize)(7,null,I,h));return o}throw new v.VariableError(v.VariableKind.Config,(0,D.localize)(8,null,I));case"command":return this.o(v.VariableKind.Command,I,h,d,"command");case"input":return this.o(v.VariableKind.Input,I,h,d,"input");case"extensionInstallFolder":if(h){const o=await this.a.getExtension(h);if(!o)throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,I,h));return this.m(o.extensionLocation)}throw new v.VariableError(v.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,I));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(t(v.VariableKind.WorkspaceFolder)));case"cwd":return n||h?(0,T.normalizeDriveLetter)(this.m(t(v.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(a.basename(this.m(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new v.VariableError(v.VariableKind.UserHome,(0,D.localize)(11,null,I))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new v.VariableError(v.VariableKind.LineNumber,(0,D.localize)(12,null,I))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new v.VariableError(v.VariableKind.SelectedText,(0,D.localize)(13,null,I))}case"file":return y(v.VariableKind.File);case"fileWorkspaceFolder":return p(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||h?a.relative(this.m(t(v.VariableKind.RelativeFile)),y(v.VariableKind.RelativeFile)):y(v.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(y(v.VariableKind.RelativeFileDirname));if(n||h){const r=a.relative(this.m(t(v.VariableKind.RelativeFileDirname)),o);return r.length===0?".":r}return o}case"fileDirname":return a.dirname(y(v.VariableKind.FileDirname));case"fileExtname":return a.extname(y(v.VariableKind.FileExtname));case"fileBasename":return a.basename(y(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(y(v.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(y(v.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||I}case"execInstallFolder":{const o=this.a.getAppRoot();return o||I}case"pathSeparator":return a.sep;default:try{const o=h?`${E}:${h}`:E;return this.o(v.VariableKind.Unknown,I,o,d,void 0)}catch{return I}}}}o(C,I,E,n,d){if(E&&n){const h=d===void 0?n[E]:n[d+":"+E];if(typeof h=="string")return h;throw new v.VariableError(C,(0,D.localize)(14,null,I))}return I}}k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=k}),define(Ie[134],Ce([1,0,4,131]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var l;(function(I){I[I.UP=0]="UP",I[I.DOWN=1]="DOWN",I[I.LEFT=2]="LEFT",I[I.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var R;(function(I){I[I.HORIZONTAL=0]="HORIZONTAL",I[I.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(I){I[I.FIRST=0]="FIRST",I[I.LAST=1]="LAST",I[I.NEXT=2]="NEXT",I[I.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var T;(function(I){I[I.MAXIMIZE=0]="MAXIMIZE",I[I.EVEN=1]="EVEN",I[I.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(I){I[I.COPY_EDITORS=0]="COPY_EDITORS",I[I.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function v(I){const E=I;return(0,A.isEditorInput)(E?.editor)&&(0,A.isEditorInput)(E?.replacement)}e.isEditorReplacement=v;var O;(function(I){I[I.CREATION_TIME=0]="CREATION_TIME",I[I.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",I[I.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(I){I[I.NEW_EDITOR=1]="NEW_EDITOR",I[I.MOVE_EDITOR=2]="MOVE_EDITOR",I[I.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(I){const E=I;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=S;function C(I){return I.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(Ie[241],Ce([1,0,4,134]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const P=R;return typeof R=="number"||(0,A.isEditorGroup)(P)}e.isPreferredGroup=l}),define(Ie[242],Ce([1,0,4,206]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(A.IEnvironmentService)}),define(Ie[135],Ce([1,0,25,3,15,6]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=P;class T{static isHostExtension(n,d,h){if(d.getExtensionDescription(n))return!1;const w=h.getExtensionDescription(n);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(n,d){this.h=n,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(C),this.e=new a.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const n of this.d){if(this.e.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.e.set(n.identifier,n),this.f.push(n);const d=this.h.readActivationEvents(n);if(Array.isArray(d))for(let h of d)h==="onUri"&&(h=`onUri:${a.ExtensionIdentifier.toKey(n.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(n)}}set(n){this.d=n,this.j(),this.c.fire(void 0)}deltaExtensions(n,d){this.d=I(this.d,d),this.d=this.d.concat(n);const h=T.k(this.d);return this.d=I(this.d,h.map(w=>w.identifier)),this.j(),this.c.fire(void 0),new P(h)}static k(n){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const r=d.getArcs(t);for(let c=0;c<r.length;c++)if(!o.has(r[c]))return!1;return!0}getNodes(){return this.e}},h=new a.ExtensionIdentifierMap;for(const t of n)if(h.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)d.addArc(a.ExtensionIdentifier.toKey(t.identifier),a.ExtensionIdentifier.toKey(o));const w=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>w.add(t));const y=d.getNodes().filter(t=>!w.has(t));let p;do{p=!1;for(let t=0;t<y.length;t++){const o=y[t];d.hasOnlyGoodArcs(o,w)&&(y.splice(t,1),t--,w.add(o),p=!0)}}while(p);return y.map(t=>h.get(t))}containsActivationEvent(n){return this.g.has(n)}containsExtension(n){return this.e.has(n)}getExtensionDescriptionsForActivationEvent(n){const d=this.g.get(n);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(n){const d=this.e.get(n);return d||void 0}getExtensionDescriptionByUUID(n){for(const d of this.f)if(d.uuid===n)return d}getExtensionDescriptionByIdOrUUID(n,d){return this.getExtensionDescription(n)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=T,e.basicActivationEventsReader={readActivationEvents:E=>E.activationEvents};class D{constructor(n){this.d=new k,this.c=new T(n,[])}async acquireLock(n){const d=await this.d.acquire(n);return new v(this,d)}deltaExtensions(n,d,h){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,h)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,d){return this.c.getExtensionDescriptionByIdOrUUID(n,d)}}e.LockableExtensionDescriptionRegistry=D;class v extends R.Disposable{constructor(n,d){super(),this.f=n,this.c=!1,this.B(d)}isAcquiredFor(n){return!this.c&&this.f===n}}e.ExtensionDescriptionRegistryLock=v;class O{constructor(n){this.name=n,this.promise=new Promise((d,h)=>{this.c=d})}resolve(n){this.c(n)}}class k{constructor(){this.c=[],this.d=!1}async acquire(n){const d=new O(n);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let d=!0;const h=setTimeout(()=>{d&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),w=()=>{!d||(clearTimeout(h),d=!1,this.d=!1,this.e())};n.resolve((0,R.toDisposable)(w))}}var S;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})(S||(S={}));function C(E,n){const d=E.isBuiltin?0:E.isUnderDevelopment?2:1,h=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(d!==h)return d-h;const w=l.posix.basename(E.extensionLocation.path),y=l.posix.basename(n.extensionLocation.path);return w<y?-1:w>y?1:0}function I(E,n){const d=new a.ExtensionIdentifierSet(n);return E.filter(h=>!d.has(h.identifier))}}),define(Ie[243],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(O){O[O.IPC=1]="IPC",O[O.Socket=2]="Socket",O[O.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class l{constructor(){this.type=2}serialize(k){k[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class R{constructor(){this.type=3}serialize(k){k[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function P(O){delete O[A.ENV_KEY],delete O[l.ENV_KEY],delete O[R.ENV_KEY]}function T(O,k){P(k),O.serialize(k)}e.writeExtHostConnection=T;function D(O){if(O[A.ENV_KEY])return v(O,new A(O[A.ENV_KEY]));if(O[l.ENV_KEY])return v(O,new l);if(O[R.ENV_KEY])return v(O,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=D;function v(O,k){return P(O),k}}),define(Ie[97],Ce([1,0,22]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var l;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(v){const O=a.VSBuffer.alloc(1);switch(v){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=P;function T(v,O){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=T;var D;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(D=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[77],Ce([1,0,4,3,16,26,97,73,74,23,2,6,187]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let C=class extends k.Disposable{constructor(d,h){super(),this.m=d,this.n=h,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:D.extensionTelemetryLogChannelId,name:(0,S.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(w=>{(0,l.isLogLevel)(w)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,h,w){const y=this.getTelemetryDetails(),p=new I(h,w,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled});return this.l.set(d.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(d,h,w){this.f=d,this.g=h,this.c=w??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const h=Object.create(null);switch(h["common.extname"]=`${d.publisher}.${d.name}`,h["common.extversion"]=d.version,h["common.vscodemachineid"]=this.m.telemetryInfo.machineId,h["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,h["common.vscodeversion"]=this.m.version,h["common.isnewappinstall"]=E(this.m.telemetryInfo.firstSessionDate),h["common.product"]=this.m.environment.appHost,this.m.uiKind){case P.UIKind.Web:h["common.uikind"]="web";break;case P.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,T.getRemoteName)((0,D.cleanRemoteAuthority)(this.m.remote.authority)),h}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const h=this.getTelemetryDetails();this.l.forEach((w,y)=>{w.isDisposed&&this.l.delete(y)}),this.l.forEach(w=>{w.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,h){const w=this.l.get(d.value);return w&&w.isDisposed?(this.l.delete(d.value),!1):!w||w.ignoreUnhandledExtHostErrors?!1:(w.logError(h),!0)}};C=Ve([$e(0,R.IExtHostInitDataService),$e(1,l.ILoggerService)],C),e.ExtHostTelemetry=C;class I{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,h,w,y,p,t,o){this.g=w,this.h=y,this.i=p,this.j=t,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,h){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let h=d.properties??d;return h=(0,D.cleanData)(h,[]),this.c&&(h=(0,v.mixin)(h,this.c)),this.b||(h=(0,v.mixin)(h,this.j)),d.properties?d.properties=h:d=h,d}k(d,h){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(d,h),this.h.trace(d,h))}logUsage(d,h){!this.d.isUsageEnabled||this.k(d,h)}logError(d,h){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,h):this.f.sendErrorData(d,h))}get apiTelemetryLogger(){if(!this.e){const d=this,h={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=I;function E(n){const d=Date.now()-new Date(n).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ie[27],Ce([1,0,3,2,219,129,25,4]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class D{constructor(p){this.dependency=p}}e.MissingExtensionDependency=D;var v;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(v=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,t){const o=[],r=[],c=[],m=[],f=k(this.c),i=k(p),s=(j,G)=>j.extensionLocation.toString()===G.extensionLocation.toString()||j.isBuiltin===G.isBuiltin||j.isUserBuiltin===G.isUserBuiltin||j.isUnderDevelopment===G.isUnderDevelopment;for(const j of this.c){const G=i.get(j.identifier);if(!G){o.push(j.identifier),f.delete(j.identifier);continue}if(!s(j,G)){o.push(j.identifier),f.delete(j.identifier);continue}}for(const j of p){const G=f.get(j.identifier);if(!G){r.push(j);continue}if(!s(G,j)){o.push(G.identifier),f.delete(G.identifier);continue}}const u=new P.ExtensionIdentifierSet(this.d),b=new P.ExtensionIdentifierSet(t);for(const j of this.d)b.has(j)||c.push(j);for(const j of t)u.has(j)||m.push(j);const g=R.ImplicitActivationEvents.createActivationEventsMap(r),L={toRemove:o,toAdd:r,addActivationEvents:g,myToRemove:c,myToAdd:m};return this.delta(L),L}delta(p){const{toRemove:t,toAdd:o,myToRemove:r,myToAdd:c}=p,m=new P.ExtensionIdentifierSet(t),f=new P.ExtensionIdentifierSet(r);for(let i=0;i<this.c.length;i++)m.has(this.c[i].identifier)&&(this.c.splice(i,1),i--);for(let i=0;i<this.d.length;i++)f.has(this.d[i])&&(this.d.splice(i,1),i--);for(const i of o)this.c.push(i);for(const i of c)this.d.push(i)}containsExtension(p){for(const t of this.d)if(P.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=O;function k(y){const p=new P.ExtensionIdentifierMap;for(const t of y)p.set(t.identifier,t);return p}function S(y,p){return y.enabledApiProposals?y.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=S;function C(y,p){if(!S(y,p))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.checkProposedApiEnabled=C;class I{constructor(p,t,o,r){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=r}}e.ActivationTimes=I;class E{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=E;var n;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,l.getGalleryExtensionId)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function h(y,p){return{identifier:new P.ExtensionIdentifier((0,l.getExtensionId)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!p,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform}}e.toExtensionDescription=h;class w{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=w}),define(Ie[244],Ce([1,0,8,135,25,27,16,19]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(d,h,w,y){this.startup=d,this.codeLoadingTime=h,this.activateCallTime=w,this.activateResolvedTime=y}}D.NONE=new D(!1,-1,-1,-1),e.ExtensionActivationTimes=D;class v{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,h){return d===-1||h===-1?-1:h-d}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=v;class O{constructor(d,h,w,y,p,t){this.activationFailed=d,this.activationFailedError=h,this.activationTimes=w,this.module=y,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=O;class k extends O{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class S extends O{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class C extends O{constructor(d){super(!0,d,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let I=class{constructor(d,h,w,y){this.g=y,this.a=d,this.b=h,this.c=w,this.d=new l.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const d=[];for(const[h,w]of this.d)d.push(w.wait());await Promise.all(d)}isActivated(d){const h=this.d.get(d);return Boolean(h&&h.value)}getActivatedExtension(d){const h=this.d.get(d);if(!h||!h.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return h.value}async activateByEvent(d,h){if(this.f[d])return;const w=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(w.map(y=>({id:y.identifier,reason:{startup:h,extensionId:y.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,h){const w=this.a.getExtensionDescription(d);if(!w)throw new Error(`Extension '${d}' is not known`);return this.h([{id:w.identifier,reason:h}])}async h(d){const h=d.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(h.map(w=>w.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const h=this.a.getExtensionDescription(d.id);if(!h){const p=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new C(p));return this.c.onExtensionActivationError(d.id,p,new R.MissingExtensionDependency(d.id.value)),t}const w=[],y=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const p of y){if(this.m(p))continue;const t=this.d.get(p);if(t){w.push(t);continue}if(this.l(p)){w.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:d.reason}));continue}const o=this.a.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;w.push(this.j({id:o.identifier,reason:d.reason}));continue}const r=h.displayName||h.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),m=this.k(d,h.displayName,[],new C(c));return this.c.onExtensionActivationError(h.identifier,c,new R.MissingExtensionDependency(p)),m}return this.k(d,h.displayName,w,null)}k(d,h,w,y){const p=new E(d.id,h,d.reason,w,y,this.c,this.g);return this.d.set(d.id,p),p}l(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const h=this.b.getExtensionDescription(d);return h?!h.main&&!h.browser:!1}};I=Ve([$e(3,P.ILogService)],I),e.ExtensionsActivator=I;let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,h,w,y,p,t,o){this.c=d,this.d=h,this.f=w,this.g=y,this.h=p,this.j=t,this.k=o,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const h=this.g[d];if(h.value&&!h.value.activationFailed){this.g.splice(d,1),d--;continue}if(h.value&&h.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);w.detail=h.value.activationFailedError,this.h=new C(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const h=new Error;if(d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this.h=new C(h),this.b&&a.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};E=Ve([$e(6,P.ILogService)],E)});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[7],Ce([1,0,17,8,113,28,88,9,10,2,30,45,128,94,27]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I){"use strict";var E,n,d,h,w,y,p,t,o,r,c,m,f,i,s,u,b,g,L,j,G,Q,B,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function M(K){return Object.assign(K,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(K,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[pe,...Pe]=arguments;return Reflect.construct(K,Pe,pe.constructor)}}})}var x;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(x=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var fe;(function(K){K[K.Command=0]="Command",K[K.Opener=1]="Opener"})(fe=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let re=t=class{static from(...H){let pe=H;return new t(function(){if(pe){for(const Pe of pe)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();pe=void 0}})}constructor(H){E.set(this,void 0),_e(this,E,H,"f")}dispose(){typeof Ue(this,E,"f")=="function"&&(Ue(this,E,"f").call(this),_e(this,E,void 0,"f"))}};E=new WeakMap,re=t=Ve([M],re),e.Disposable=re;let V=o=class{static Min(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isBefore(pe)&&(pe=Ge)}return pe}static Max(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isAfter(pe)&&(pe=Ge)}return pe}static isPosition(H){if(!H)return!1;if(H instanceof o)return!0;const{line:pe,character:Pe}=H;return typeof pe=="number"&&typeof Pe=="number"}static of(H){if(H instanceof o)return H;if(this.isPosition(H))return new o(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(pe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=pe}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,pe=0){if(H===null||pe===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,pe=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&pe===0?this:new o(this.line+Pe,this.character+pe)}with(H,pe=this.character){if(H===null||pe===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,pe=typeof H.character=="number"?H.character:this.character),Pe===this.line&&pe===this.character?this:new o(Pe,pe)}toJSON(){return{line:this.line,character:this.character}}};V=o=Ve([M],V),e.Position=V;let _=r=class{static isRange(H){return H instanceof r?!0:H?V.isPosition(H.start)&&V.isPosition(H.end):!1}static of(H){if(H instanceof r)return H;if(this.isRange(H))return new r(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,pe,Pe,Ge){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Je=new V(H,pe),at=new V(Pe,Ge)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this.c=Je,this.e=at):(this.c=at,this.e=Je)}contains(H){return r.isRange(H)?this.contains(H.start)&&this.contains(H.end):V.isPosition(H)?!(V.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const pe=V.Max(H.start,this.c),Pe=V.Min(H.end,this.e);if(!pe.isAfter(Pe))return new r(pe,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const pe=V.Min(H.start,this.c),Pe=V.Max(H.end,this.end);return new r(pe,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,pe=this.end){if(H===null||pe===null)throw(0,A.illegalArgument)();let Pe;return H?V.isPosition(H)?Pe=H:(Pe=H.start||this.start,pe=H.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&pe.isEqual(this.end)?this:new r(Pe,pe)}toJSON(){return[this.start,this.end]}};_=r=Ve([M],_),e.Range=_;let te=c=class extends _{static isSelection(H){return H instanceof c?!0:H?_.isRange(H)&&V.isPosition(H.anchor)&&V.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,pe,Pe,Ge){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Je=new V(H,pe),at=new V(Pe,Ge)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");super(Je,at),this.f=Je,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=c=Ve([M],te),e.Selection=te;class ve{constructor(H,pe,Pe){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,A.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(Pe)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(pe),this.connectionToken=Pe}}e.ResolvedAuthority=ve;class le extends Error{static NotAvailable(H,pe){return new le(H,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(H){return new le(H,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H),this._message=H,this._code=pe,this._detail=Pe,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var ue;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(ue=e.EndOfLine||(e.EndOfLine={}));var q;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let F=m=class{static isTextEdit(H){return H instanceof m?!0:H?_.isRange(H)&&typeof H.newText=="string":!1}static replace(H,pe){return new m(H,pe)}static insert(H,pe){return m.replace(new _(H,H),pe)}static delete(H){return m.replace(H,"")}static setEndOfLine(H){const pe=new m(new _(new V(0,0),new V(0,0)),"");return pe.newEol=H,pe}get range(){return this.c}set range(H){if(H&&!_.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,pe){this.c=H,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};F=m=Ve([M],F),e.TextEdit=F;var J;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(J=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let ge=f=class{static isNotebookCellEdit(H){return H instanceof f?!0:H?Wt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,pe){return new f(H,pe)}static insertCells(H,pe){return new f(new Wt(H,H),pe)}static deleteCells(H){return new f(H,[])}static updateCellMetadata(H,pe){const Pe=new f(new Wt(H,H),[]);return Pe.newCellMetadata=pe,Pe}static updateNotebookMetadata(H){const pe=new f(new Wt(0,0),[]);return pe.newNotebookMetadata=H,pe}constructor(H,pe){this.range=H,this.newCells=pe}};ge=f=Ve([M],ge),e.NotebookEdit=ge;class Ee{static isSnippetTextEdit(H){return H instanceof Ee?!0:H?_.isRange(H.range)&&de.isSnippetString(H.snippet):!1}static replace(H,pe){return new Ee(H,pe)}static insert(H,pe){return Ee.replace(new _(H,H),pe)}constructor(H,pe){this.range=H,this.snippet=pe}}e.SnippetTextEdit=Ee;var ie;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ie=e.FileEditType||(e.FileEditType={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,pe,Pe,Ge){this.c.push({_type:1,from:H,to:pe,options:Pe,metadata:Ge})}createFile(H,pe,Pe){this.c.push({_type:1,from:void 0,to:H,options:pe,metadata:Pe})}deleteFile(H,pe,Pe){this.c.push({_type:1,from:H,to:void 0,options:pe,metadata:Pe})}e(H,pe,Pe){this.c.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(H,pe,Pe,Ge){const Je=pe.start,at=pe.end;(Je!==at||Pe.length>0)&&this.c.push({_type:5,uri:H,index:Je,count:at-Je,cells:Pe,metadata:Ge})}g(H,pe,Pe,Ge){this.c.push({_type:3,metadata:Ge,uri:H,edit:{editType:8,index:pe,metadata:Pe}})}replace(H,pe,Pe,Ge){this.c.push({_type:2,uri:H,edit:new F(pe,Pe),metadata:Ge})}insert(H,pe,Pe,Ge){this.replace(H,new _(pe,pe),Pe,Ge)}delete(H,pe,Pe){this.replace(H,pe,"",Pe)}has(H){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===H.toString())}set(H,pe){if(pe)for(const Pe of pe){if(!Pe)continue;let Ge,Je;Array.isArray(Pe)?(Ge=Pe[0],Je=Pe[1]):Ge=Pe,ge.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(H,Ge.range.start,Ge.newCellMetadata,Je):Ge.newNotebookMetadata?this.e(H,Ge.newNotebookMetadata,Je):this.f(H,Ge.range,Ge.newCells,Je):Ee.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:H,range:Ge.range,edit:Ge.snippet,metadata:Je}):this.c.push({_type:2,uri:H,edit:Ge,metadata:Je})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ge=this.c[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===H.toString()&&(this.c[Pe]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(H){const pe=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===H.toString()&&pe.push(Pe.edit);return pe}entries(){const H=new R.ResourceMap;for(const pe of this.c)if(pe._type===2){let Pe=H.get(pe.uri);Pe||(Pe=[pe.uri,[]],H.set(pe.uri,Pe)),Pe[1].push(pe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ne=Ve([M],ne),e.WorkspaceEdit=ne;let de=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,pe=this.e++){if(typeof H=="function"){const Pe=new i;Pe.e=this.e,H(Pe),this.e=Pe.e,H=Pe.value}else H=i.c(H);return this.value+="${",this.value+=pe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,pe=this.e++){const Pe=H.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,pe){if(typeof pe=="function"){const Pe=new i;Pe.e=this.e,pe(Pe),this.e=Pe.e,pe=Pe.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};de=i=Ve([M],de),e.SnippetString=de;var ee;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ee=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=s=class{static isLocation(H){return H instanceof s?!0:H?_.isRange(H.range)&&v.URI.isUri(H.uri):!1}constructor(H,pe){if(this.uri=H,pe)if(_.isRange(pe))this.range=_.of(pe);else if(V.isPosition(pe))this.range=new _(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=s=Ve([M],ae),e.Location=ae;let N=class{static is(H){return H?typeof H.message=="string"&&H.location&&_.isRange(H.location.range)&&v.URI.isUri(H.location.uri):!1}constructor(H,pe){this.location=H,this.message=pe}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.location.range.isEqual(pe.location.range)&&H.location.uri.toString()===pe.location.uri.toString()}};N=Ve([M],N),e.DiagnosticRelatedInformation=N;let $=class{constructor(H,pe,Pe=ce.Error){if(!_.isRange(H))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=H,this.message=pe,this.severity=Pe}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.severity===pe.severity&&H.code===pe.code&&H.severity===pe.severity&&H.source===pe.source&&H.range.isEqual(pe.range)&&(0,a.equals)(H.tags,pe.tags)&&(0,a.equals)(H.relatedInformation,pe.relatedInformation,N.isEqual)}};$=Ve([M],$),e.Diagnostic=$;let X=class{constructor(H,pe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=pe}};X=Ve([M],X),e.Hover=X;var Z;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let he=class{constructor(H,pe=Z.Text){this.range=H,this.kind=pe}toJSON(){return{range:this.range,kind:Z[this.kind]}}};he=Ve([M],he),e.DocumentHighlight=he;var Se;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Se=e.SymbolKind||(e.SymbolKind={}));var Re;(function(K){K[K.Deprecated=1]="Deprecated"})(Re=e.SymbolTag||(e.SymbolTag={}));let we=u=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,pe,Pe,Ge,Je){this.name=H,this.kind=pe,this.containerName=Je,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof ae?this.location=Ge:Pe instanceof _&&(this.location=new ae(Ge,Pe)),u.validate(this)}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};we=u=Ve([M],we),e.SymbolInformation=we;let Te=b=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(b.validate)}constructor(H,pe,Pe,Ge,Je){this.name=H,this.detail=pe,this.kind=Pe,this.range=Ge,this.selectionRange=Je,this.children=[],b.validate(this)}};Te=b=Ve([M],Te),e.DocumentSymbol=Te;var ke;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(ke=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let je=class{constructor(H,pe){this.title=H,this.kind=pe}};je=Ve([M],je),e.CodeAction=je;let We=g=class{constructor(H){this.value=H}append(H){return new g(this.value?this.value+g.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+g.c)}};We.c=".",We=g=Ve([M],We),e.CodeActionKind=We,We.Empty=new We(""),We.QuickFix=We.Empty.append("quickfix"),We.Refactor=We.Empty.append("refactor"),We.RefactorExtract=We.Refactor.append("extract"),We.RefactorInline=We.Refactor.append("inline"),We.RefactorMove=We.Refactor.append("move"),We.RefactorRewrite=We.Refactor.append("rewrite"),We.Source=We.Empty.append("source"),We.SourceOrganizeImports=We.Source.append("organizeImports"),We.SourceFixAll=We.Source.append("fixAll");let tt=class{constructor(H,pe){if(this.range=H,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};tt=Ve([M],tt),e.SelectionRange=tt;class Ye{constructor(H,pe,Pe,Ge,Je,at){this.kind=H,this.name=pe,this.detail=Pe,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=Ye;class nt{constructor(H,pe){this.fromRanges=pe,this.from=H}}e.CallHierarchyIncomingCall=nt;class st{constructor(H,pe){this.fromRanges=pe,this.to=H}}e.CallHierarchyOutgoingCall=st;var Be;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(H,pe){this.range=H,this.command=pe}get isResolved(){return!!this.command}};it=Ve([M],it),e.CodeLens=it;let W=L=class{static isMarkdownString(H){return H instanceof L?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,pe=!1){n.set(this,void 0),_e(this,n,new l.MarkdownString(H,{supportThemeIcons:pe}),"f")}get value(){return Ue(this,n,"f").value}set value(H){Ue(this,n,"f").value=H}get isTrusted(){return Ue(this,n,"f").isTrusted}set isTrusted(H){Ue(this,n,"f").isTrusted=H}get supportThemeIcons(){return Ue(this,n,"f").supportThemeIcons}set supportThemeIcons(H){Ue(this,n,"f").supportThemeIcons=H}get supportHtml(){return Ue(this,n,"f").supportHtml}set supportHtml(H){Ue(this,n,"f").supportHtml=H}get baseUri(){return Ue(this,n,"f").baseUri}set baseUri(H){Ue(this,n,"f").baseUri=H}appendText(H){return Ue(this,n,"f").appendText(H),this}appendMarkdown(H){return Ue(this,n,"f").appendMarkdown(H),this}appendCodeblock(H,pe){return Ue(this,n,"f").appendCodeblock(pe??"",H),this}};n=new WeakMap,W=L=Ve([M],W),e.MarkdownString=W;let Y=class{constructor(H,pe){this.label=H,this.documentation=pe}};Y=Ve([M],Y),e.ParameterInformation=Y;let me=class{constructor(H,pe){this.label=H,this.documentation=pe,this.parameters=[]}};me=Ve([M],me),e.SignatureInformation=me;let Le=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Le=Ve([M],Le),e.SignatureHelp=Le;var Ne;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(H){this.value=H}};Qe=Ve([M],Qe),e.InlayHintLabelPart=Qe;let Xe=class{constructor(H,pe,Pe){this.position=H,this.label=pe,this.kind=Pe}};Xe=Ve([M],Xe),e.InlayHint=Xe;var rt;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(K){K[K.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let mt=class{constructor(H,pe){this.label=H,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};mt=Ve([M],mt),e.CompletionItem=mt;let wt=class{constructor(H=[],pe=!1){this.items=H,this.isIncomplete=pe}};wt=Ve([M],wt),e.CompletionList=wt;let Ct=class{constructor(H,pe,Pe){this.insertText=H,this.range=pe,this.command=Pe}};Ct=Ve([M],Ct),e.InlineSuggestion=Ct;let Lt=class{constructor(H){this.commands=void 0,this.items=H}};Lt=Ve([M],Lt),e.InlineSuggestionList=Lt;var Yt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Yt=e.ViewColumn||(e.ViewColumn={}));var Kt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Kt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ht;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(ht=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Tt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Tt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function H(pe){switch(pe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=H}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Dt=class{constructor(H,pe){if(pe&&!v.URI.isUri(pe))throw(0,A.illegalArgument)("target");if(!_.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=pe}};Dt=Ve([M],Dt),e.DocumentLink=Dt;let zt=class{constructor(H,pe,Pe,Ge){this.red=H,this.green=pe,this.blue=Pe,this.alpha=Ge}};zt=Ve([M],zt),e.Color=zt;let kt=class{constructor(H,pe){if(pe&&!(pe instanceof zt))throw(0,A.illegalArgument)("color");if(!_.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=pe}};kt=Ve([M],kt),e.ColorInformation=kt;let Ke=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Ke=Ve([M],Ke),e.ColorPresentation=Ke;var Vt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Vt=e.ColorFormat||(e.ColorFormat={}));var Xt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Xt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ut;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Ut=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(H,pe,Pe){if(this.startIndex=H,this.length=pe,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,A.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Oe;class De{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=De;var oe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(oe=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var He;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let qe=j=class{static from(H){switch(H){case"clean":return j.Clean;case"build":return j.Build;case"rebuild":return j.Rebuild;case"test":return j.Test;default:return}}constructor(H,pe){if(this.label=pe,typeof H!="string"||typeof pe!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};qe.Clean=new j("clean","Clean"),qe.Build=new j("build","Build"),qe.Rebuild=new j("rebuild","Rebuild"),qe.Test=new j("test","Test"),qe=j=Ve([M],qe),e.TaskGroup=qe;function et(K){let H="";for(let pe=0;pe<K.length;pe++)H+=K[pe].replace(/,/g,",,")+",";return H}let dt=class{constructor(H,pe,Pe){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Pe):this.f=pe)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)H.push(pe);return et(H)}};dt=Ve([M],dt),e.ProcessExecution=dt;let ut=class{constructor(H,pe,Pe){if(this.f=[],Array.isArray(pe)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=pe,this.g=Pe}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=pe}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)H.push(typeof pe=="string"?pe:pe.value);return et(H)}};ut=Ve([M],ut),e.ShellExecution=ut;var It;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Nt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=Nt;let Bt=G=class{constructor(H,pe,Pe,Ge,Je,at){this.j=!1,this.k=this.definition=H;let ft;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Pe,this.execution=Ge,ft=Je,this.j=!0):pe===bt.Global||pe===bt.Workspace?(this.target=pe,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Je,ft=at):(this.target=pe,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Je,ft=at),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof dt?this.k={type:G.e,id:this.n.computeId()}:this.n instanceof ut?this.k={type:G.f,id:this.n.computeId()}:this.n instanceof Nt?this.k={type:G.c,id:this.n.computeId()}:this.k={type:G.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const pe=this.k.type;(G.g===pe||G.e===pe||G.f===pe||G.c===pe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",Bt=G=Ve([M],Bt),e.Task=Bt;var Li;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Li=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(K){function H(pe){const Pe=pe;return(0,D.isNumber)(Pe.value)?Pe.tooltip&&!(0,D.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}K.isViewBadge=H})(Pt=e.ViewBadge||(e.ViewBadge={}));let wi=Q=class{static isTreeItem(H,pe){const Pe=H;if(Pe.checkboxState!==void 0){(0,I.checkProposedApiEnabled)(pe,"treeItemCheckbox");const Ge=(0,D.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,D.isObject)(Pe.checkboxState)&&(0,D.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Je=!(0,D.isNumber)(Pe.checkboxState)&&(0,D.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==St.Checked&&Ge!==St.Unchecked||Je!==void 0&&!(0,D.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(H instanceof Q)return!0;if(Pe.label!==void 0&&!(0,D.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,D.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,D.isString)(Pe.iconPath)&&!v.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,D.isString)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,D.isString)(Ge.light)&&!v.URI.isUri(Ge.light)&&!(0,D.isString)(Ge.dark)&&!v.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,D.isString)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!v.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,D.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof W)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<ci.None&&Pe.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,D.isString)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(H,pe=ci.None){this.collapsibleState=pe,v.URI.isUri(H)?this.resourceUri=H:this.label=H}};wi=Q=Ve([M],wi),e.TreeItem=wi;var ci;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var St;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(St=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,pe){this.value=H,this.id=pe??(0,O.generateUuid)()}};li=Ve([M],li),e.DataTransferItem=li;let ui=class{constructor(H){d.add(this),h.set(this,new Map);for(const[pe,Pe]of H??[]){const Ge=Ue(this,h,"f").get(Ue(this,d,"m",w).call(this,pe));Ge?Ge.push(Pe):Ue(this,h,"f").set(Ue(this,d,"m",w).call(this,pe),[Pe])}}get(H){return Ue(this,h,"f").get(Ue(this,d,"m",w).call(this,H))?.[0]}set(H,pe){Ue(this,h,"f").set(Ue(this,d,"m",w).call(this,H),[pe])}forEach(H,pe){for(const[Pe,Ge]of Ue(this,h,"f"))for(const Je of Ge)H.call(pe,Je,Pe,this)}*[(h=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[H,pe]of Ue(this,h,"f"))for(const Pe of pe)yield[H,Pe]}};w=function(H){return H.toLowerCase()},ui=Ve([M],ui),e.DataTransfer=ui;let ii=class{constructor(H){this.insertText=H}};ii=Ve([M],ii),e.DocumentDropEdit=ii;let Ei=class{constructor(H){this.insertText=H}};Ei=Ve([M],Ei),e.DocumentPasteEdit=Ei;let xt=class{constructor(H,pe){this.id=H,this.color=pe}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};xt=Ve([M],xt),e.ThemeIcon=xt,xt.File=new xt("file"),xt.Folder=new xt("folder");let At=class{constructor(H){this.id=H}};At=Ve([M],At),e.ThemeColor=At;var Oi;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Si=class{get base(){return this.c}set base(H){this.c=H,this.e=v.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,pe){if(typeof H!="string"&&(!H||!v.URI.isUri(H)&&!v.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof pe!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=v.URI.file(H):v.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Si=Ve([M],Si),e.RelativePattern=Si;const ni=new WeakMap;function di(K,H){ni.set(K,H)}e.setBreakpointId=di;let lt=class{constructor(H,pe,Pe,Ge){this.enabled=typeof H=="boolean"?H:!0,typeof pe=="string"&&(this.condition=pe),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ni.get(this)??(0,O.generateUuid)()),this.c}};lt=Ve([M],lt),e.Breakpoint=lt;let yi=class extends lt{constructor(H,pe,Pe,Ge,Je){if(super(pe,Pe,Ge,Je),H===null)throw(0,A.illegalArgument)("location");this.location=H}};yi=Ve([M],yi),e.SourceBreakpoint=yi;let qt=class extends lt{constructor(H,pe,Pe,Ge,Je){super(pe,Pe,Ge,Je),this.functionName=H}};qt=Ve([M],qt),e.FunctionBreakpoint=qt;let Jt=class extends lt{constructor(H,pe,Pe,Ge,Je,at,ft){if(super(Ge,Je,at,ft),!pe)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=pe,this.canPersist=Pe}};Jt=Ve([M],Jt),e.DataBreakpoint=Jt;let hi=class{constructor(H,pe,Pe){this.command=H,this.args=pe||[],this.options=Pe}};hi=Ve([M],hi),e.DebugAdapterExecutable=hi;let Di=class{constructor(H,pe){this.port=H,this.host=pe}};Di=Ve([M],Di),e.DebugAdapterServer=Di;let Ii=class{constructor(H){this.path=H}};Ii=Ve([M],Ii),e.DebugAdapterNamedPipeServer=Ii;let fi=class{constructor(H){this.implementation=H}};fi=Ve([M],fi),e.DebugAdapterInlineImplementation=fi;let Ci=class{constructor(H,pe){this.range=H,this.expression=pe}};Ci=Ve([M],Ci),e.EvaluatableExpression=Ci;var Ni;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Ni=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let _t=class{constructor(H,pe){this.range=H,this.text=pe}};_t=Ve([M],_t),e.InlineValueText=_t;let ki=class{constructor(H,pe,Pe=!0){this.range=H,this.variableName=pe,this.caseSensitiveLookup=Pe}};ki=Ve([M],ki),e.InlineValueVariableLookup=ki;let ri=class{constructor(H,pe){this.range=H,this.expression=pe}};ri=Ve([M],ri),e.InlineValueEvaluatableExpression=ri;let si=class{constructor(H,pe){this.frameId=H,this.stoppedLocation=pe}};si=Ve([M],si),e.InlineValueContext=si;var $i;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let Ti=B=class extends Error{static FileExists(H){return new B(H,k.FileSystemProviderErrorCode.FileExists,B.FileExists)}static FileNotFound(H){return new B(H,k.FileSystemProviderErrorCode.FileNotFound,B.FileNotFound)}static FileNotADirectory(H){return new B(H,k.FileSystemProviderErrorCode.FileNotADirectory,B.FileNotADirectory)}static FileIsADirectory(H){return new B(H,k.FileSystemProviderErrorCode.FileIsADirectory,B.FileIsADirectory)}static NoPermissions(H){return new B(H,k.FileSystemProviderErrorCode.NoPermissions,B.NoPermissions)}static Unavailable(H){return new B(H,k.FileSystemProviderErrorCode.Unavailable,B.Unavailable)}constructor(H,pe=k.FileSystemProviderErrorCode.Unknown,Pe){super(v.URI.isUri(H)?H.toString(!0):H),this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,B.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};Ti=B=Ve([M],Ti),e.FileSystemError=Ti;let Zt=class{constructor(H,pe,Pe){this.start=H,this.end=pe,this.kind=Pe}};Zt=Ve([M],Zt),e.FoldingRange=Zt;var Wi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ji;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(ji=e.CommentMode||(e.CommentMode={}));var mi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class Vi{constructor(H,pe=[]){this.tokenTypes=H,this.tokenModifiers=pe}}e.SemanticTokensLegend=Vi;function xi(K){return typeof K>"u"||(0,D.isStringArray)(K)}class Pi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let pe=0,Pe=H.tokenTypes.length;pe<Pe;pe++)this.j.set(H.tokenTypes[pe],pe);for(let pe=0,Pe=H.tokenModifiers.length;pe<Pe;pe++)this.k.set(H.tokenModifiers[pe],pe)}}push(H,pe,Pe,Ge,Je){if(typeof H=="number"&&typeof pe=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(H,pe,Pe,Ge,Je);if(_.isRange(H)&&typeof pe=="string"&&xi(Pe))return this.m(H,pe,Pe);throw(0,A.illegalArgument)()}m(H,pe,Pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ge=H.start.line,Je=H.start.character,at=H.end.character-H.start.character,ft=this.j.get(pe);let Ft=0;if(Pe)for(const jt of Pe){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(jt);Ft|=1<<Gt>>>0}this.n(Ge,Je,at,ft,Ft)}n(H,pe,Pe,Ge,Je){if(this.f&&(H<this.c||H===this.c&&pe<this.e)){this.f=!1;const Ft=this.g.length/5|0;let jt=0,Gt=0;for(let Qt=0;Qt<Ft;Qt++){let ei=this.g[5*Qt],Ai=this.g[5*Qt+1];ei===0?(ei=jt,Ai+=Gt):ei+=jt,this.g[5*Qt]=ei,this.g[5*Qt+1]=Ai,jt=ei,Gt=Ai}}let at=H,ft=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ft-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ft,this.g[this.h++]=Pe,this.g[this.h++]=Ge,this.g[this.h++]=Je,this.c=H,this.e=pe}static o(H){const pe=[],Pe=H.length/5|0;for(let ft=0;ft<Pe;ft++)pe[ft]=ft;pe.sort((ft,Ft)=>{const jt=H[5*ft],Gt=H[5*Ft];if(jt===Gt){const Qt=H[5*ft+1],ei=H[5*Ft+1];return Qt-ei}return jt-Gt});const Ge=new Uint32Array(H.length);let Je=0,at=0;for(let ft=0;ft<Pe;ft++){const Ft=5*pe[ft],jt=H[Ft+0],Gt=H[Ft+1],Qt=H[Ft+2],ei=H[Ft+3],Ai=H[Ft+4],dn=jt-Je,Un=dn===0?Gt-at:Gt,Ri=5*ft;Ge[Ri+0]=dn,Ge[Ri+1]=Un,Ge[Ri+2]=Qt,Ge[Ri+3]=ei,Ge[Ri+4]=Ai,Je=jt,at=Gt}return Ge}build(H){return this.f?new oi(new Uint32Array(this.g),H):new oi(Pi.o(this.g),H)}}e.SemanticTokensBuilder=Pi;class oi{constructor(H,pe){this.resultId=pe,this.data=H}}e.SemanticTokens=oi;class Fi{constructor(H,pe,Pe){this.start=H,this.deleteCount=pe,this.data=Pe}}e.SemanticTokensEdit=Fi;class Mi{constructor(H,pe){this.resultId=pe,this.edits=H}}e.SemanticTokensEdits=Mi;var ze;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(ze=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new xt("arrow-left")},$t=Ve([M],$t),e.QuickInputButtons=$t;var Ui;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Et;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Et=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var qi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(qi=e.ExtensionKind||(e.ExtensionKind={}));class Gi{static validate(H){if(typeof H.badge=="string"){let pe=(0,T.nextCharLength)(H.badge,0);if(pe<H.badge.length&&(pe+=(0,T.nextCharLength)(H.badge,pe)),H.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!xt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,pe,Pe){this.badge=H,this.tooltip=pe,this.color=Pe}}e.FileDecoration=Gi;let gi=class{constructor(H){this.kind=H}};gi=Ve([M],gi),e.ColorTheme=gi;var Ki;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{static isNotebookRange(H){return H instanceof Wt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(pe<0)throw(0,A.illegalArgument)("end must be positive");H<=pe?(this.c=H,this.e=pe):(this.c=pe,this.e=H)}with(H){let pe=this.c,Pe=this.e;return H.start!==void 0&&(pe=H.start),H.end!==void 0&&(Pe=H.end),pe===this.c&&Pe===this.e?this:new Wt(pe,Pe)}}e.NotebookRange=Wt;class pi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(pe=>pi.isNotebookCellData(pe))}static isNotebookCellData(H){return!0}constructor(H,pe,Pe,Ge,Je,at,ft){this.kind=H,this.value=pe,this.languageId=Pe,this.mime=Ge,this.outputs=Je??[],this.metadata=at,this.executionSummary=ft,pi.validate(this)}}e.NotebookCellData=pi;class Xi{constructor(H){this.cells=H}}e.NotebookData=Xi;class Ht{static isNotebookCellOutputItem(H){return H instanceof Ht?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const pe={name:H.name,message:H.message,stack:H.stack};return Ht.json(pe,"application/vnd.code.notebook.error")}static stdout(H){return Ht.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Ht.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,pe="application/octet-stream"){return new Ht(H,pe)}static text(H,pe=P.Mimes.text){const Pe=Ue(Ht,y,"f",p).encode(String(H));return new Ht(Pe,pe)}static json(H,pe="text/x-json"){const Pe=JSON.stringify(H,void 0,"	");return Ht.text(Pe,pe)}constructor(H,pe){this.data=H,this.mime=pe;const Pe=(0,P.normalizeMimeType)(pe,!0);if(!Pe)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}y=Ht,p={value:new TextEncoder},e.NotebookCellOutputItem=Ht;class ai{static isNotebookCellOutput(H){return H instanceof ai?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,pe=!1){const Pe=new Set,Ge=new Set;for(let Je=0;Je<H.length;Je++){const at=H[Je],ft=(0,P.normalizeMimeType)(at.mime);if(!Pe.has(ft)||(0,C.isTextStreamMime)(ft)){Pe.add(ft);continue}Ge.add(Je),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?H:H.filter((Je,at)=>!Ge.has(at))}constructor(H,pe,Pe){this.items=ai.ensureUniqueMimeTypes(H,!0),typeof pe=="string"?(this.id=pe,this.metadata=Pe):(this.id=(0,O.generateUuid)(),this.metadata=pe??Pe)}}e.NotebookCellOutput=ai;var Qi;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Qi=e.NotebookCellKind||(e.NotebookCellKind={}));var Yi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ji;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Ji=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Zi{constructor(H,pe){this.text=H,this.alignment=pe}}e.NotebookCellStatusBarItem=Zi;var en;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var tn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(tn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class be{constructor(H,pe=[]){this.uri=H,this.provides=(0,a.asArray)(pe)}}e.NotebookRendererScript=be;class ye{constructor(H){this.label=H}}e.NotebookKernelSourceAction=ye;let Me=class{constructor(H,pe){this.label=H,this.timestamp=pe}};Me=Ve([M],Me),e.TimelineItem=Me;var ot;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(ot=e.ExtensionMode||(e.ExtensionMode={}));var yt;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(yt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Rt=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(H,pe){this.ranges=H,this.wordPattern=pe}}e.LinkedEditingRanges=pn;class bn{constructor(H,pe){this.c=H,this.e=pe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=bn;var vn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(vn=e.TestResultState||(e.TestResultState={}));var wn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(wn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Bi=class{constructor(H=void 0,pe=void 0,Pe=void 0,Ge=!1){this.include=H,this.exclude=pe,this.profile=Pe,this.continuous=Ge}};Bi=Ve([M],Bi),e.TestRunRequest=Bi;let nn=class extends Bi{};nn=Ve([M],nn),e.TestRunRequest2=nn;let rn=U=class{static diff(H,pe,Pe){const Ge=new U(H);return Ge.expectedOutput=pe,Ge.actualOutput=Pe,Ge}constructor(H){this.message=H}};rn=U=Ve([M],rn),e.TestMessage=rn;let sn=class{constructor(H){this.id=H}};sn=Ve([M],sn),e.TestTag=sn;let bi=class{constructor(H,pe){this.covered=H,this.total=pe}};bi=Ve([M],bi),e.CoveredCount=bi;let on=z=class{static fromDetails(H,pe){const Pe=new bi(0,0),Ge=new bi(0,0),Je=new bi(0,0);for(const ft of pe)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Ft of ft.branches)Ge.total+=1,Ge.covered+=Ft.executionCount>0?1:0}else Je.total+=1,Je.covered+=ft.executionCount>0?1:0;const at=new z(H,Pe,Ge.total>0?Ge:void 0,Je.total>0?Je:void 0);return at.detailedCoverage=pe,at}constructor(H,pe,Pe,Ge){this.uri=H,this.statementCoverage=pe,this.branchCoverage=Pe,this.functionCoverage=Ge}};on=z=Ve([M],on),e.FileCoverage=on;let an=class{constructor(H,pe,Pe=[]){this.executionCount=H,this.location=pe,this.branches=Pe}};an=Ve([M],an),e.StatementCoverage=an;let cn=class{constructor(H,pe){this.executionCount=H,this.location=pe}};cn=Ve([M],cn),e.BranchCoverage=cn;let ln=class{constructor(H,pe){this.executionCount=H,this.location=pe}};ln=Ve([M],ln),e.FunctionCoverage=ln;var En;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(En=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Sn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Sn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var yn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Dn{constructor(H,pe,Pe,Ge,Je,at){this.kind=H,this.name=pe,this.detail=Pe,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.TypeHierarchyItem=Dn;class In{constructor(H){this.uri=H}}e.TextTabInput=In;class Cn{constructor(H,pe){this.original=H,this.modified=pe}}e.TextDiffTabInput=Cn;class kn{constructor(H,pe,Pe,Ge){this.base=H,this.input1=pe,this.input2=Pe,this.result=Ge}}e.TextMergeTabInput=kn;class Tn{constructor(H,pe){this.uri=H,this.viewType=pe}}e.CustomEditorTabInput=Tn;class Pn{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=Pn;class An{constructor(H,pe){this.uri=H,this.notebookType=pe}}e.NotebookEditorTabInput=An;class Rn{constructor(H,pe,Pe){this.original=H,this.modified=pe,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Rn;class Ln{constructor(){}}e.TerminalEditorTabInput=Ln;class On{constructor(H,pe){this.uri=H,this.inputBoxUri=pe}}e.InteractiveWindowInput=On;var Nn;(function(K){K[K.Up=1]="Up",K[K.Down=2]="Down"})(Nn=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Fn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Fn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone"})(Mn=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(Ie[136],Ce([1,0,51,18,9,167,107,7,17]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const v=new Map;function O(I,E){E?v.set(I,E):v.delete(I)}e.setWordDefinitionFor=O;function k(I){return v.get(I)}class S extends R.MirrorTextModel{constructor(E,n,d,h,w,y,p,t){super(n,d,h,w),this.c=E,this.m=y,this.q=p,this.notebook=t,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,D.equals)(this.f,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.d},get fileName(){return E.d.fsPath},get isUntitled(){return E.d.scheme===A.Schemas.untitled},get languageId(){return E.m},get version(){return E.h},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(n){return n?E.s(n):E.getText()},get eol(){return E.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return E.f.length},lineAt(n){return E.t(n)},offsetAt(n){return E.u(n)},positionAt(n){return E.v(n)},validateRange(n){return E.w(n)},validatePosition(n){return E.x(n)},getWordRangeAtPosition(n,d){return E.y(n,d)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,a.ok)(!this.b),this.m=E}_acceptIsDirty(E){(0,a.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(E){const n=this.w(E);if(n.isEmpty)return"";if(n.isSingleLine)return this.f[n.start.line].substring(n.start.character,n.end.character);const d=this.g,h=n.start.line,w=n.end.line,y=[];y.push(this.f[h].substring(n.start.character));for(let p=h+1;p<w;p++)y.push(this.f[p]);return y.push(this.f[w].substring(0,n.end.character)),y.join(d)}t(E){let n;if(E instanceof T.Position?n=E.line:typeof E=="number"&&(n=E),typeof n!="number"||n<0||n>=this.f.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new C(n,this.f[n],n===this.f.length-1)}u(E){return E=this.x(E),this.l(),this.j.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.l();const n=this.j.getIndexOf(E),d=this.f[n.index].length;return new T.Position(n.index,Math.min(n.remainder,d))}w(E){if(!(E instanceof T.Range))throw new Error("Invalid argument");const n=this.x(E.start),d=this.x(E.end);return n===E.start&&d===E.end?E:new T.Range(n.line,n.character,d.line,d.character)}x(E){if(!(E instanceof T.Position))throw new Error("Invalid argument");if(this.f.length===0)return E.with(0,0);let{line:n,character:d}=E,h=!1;if(n<0)n=0,d=0,h=!0;else if(n>=this.f.length)n=this.f.length-1,d=this.f[n].length,h=!0;else{const w=this.f[n].length;d<0?(d=0,h=!0):d>w&&(d=w,h=!0)}return h?new T.Position(n,d):E}y(E,n){const d=this.x(E);if(!n)n=k(this.m);else if((0,l.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const h=(0,P.getWordAtText)(d.character+1,(0,P.ensureValidWordDefinition)(n),this.f[d.line],0);if(h)return new T.Range(d.line,h.startColumn-1,d.line,h.endColumn-1)}}e.ExtHostDocumentData=S;class C{constructor(E,n,d){this.a=E,this.b=n,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(Ie[245],Ce([1,0,7,20,3]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let D;switch(T){case"light":D=a.ColorThemeKind.Light;break;case"hcDark":D=a.ColorThemeKind.HighContrast;break;case"hcLight":D=a.ColorThemeKind.HighContrastLight;break;default:D=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=Ve([$e(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(Ie[11],Ce([1,0,17,22,150,63,113,28,148,70,88,23,10,2,32,72,124,133,131,94,57,76,241,7]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ae){function Oe(oe){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:qe}=oe,et=new o.Position(Fe-1,He-1),dt=new o.Position(Ze-1,qe-1);return new o.Selection(et,dt)}Ae.to=Oe;function De(oe){const{anchor:Fe,active:He}=oe;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Ae.from=De})(r=e.Selection||(e.Selection={}));var c;(function(Ae){function Oe(oe){if(!oe)return;const{start:Fe,end:He}=oe;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Ae.from=Oe;function De(oe){if(!oe)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:Ze,endColumn:qe}=oe;return new o.Range(Fe-1,He-1,Ze-1,qe-1)}Ae.to=De})(c=e.Range||(e.Range={}));var m;(function(Ae){function Oe(De){switch(De){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ae.to=Oe})(m=e.TokenType||(e.TokenType={}));var f;(function(Ae){function Oe(oe){return new o.Position(oe.lineNumber-1,oe.column-1)}Ae.to=Oe;function De(oe){return{lineNumber:oe.line+1,column:oe.character+1}}Ae.from=De})(f=e.Position||(e.Position={}));var i;(function(Ae){function Oe(Fe,He){return(0,a.coalesce)((0,a.asArray)(Fe).map(Ze=>De(Ze,He)))}Ae.from=Oe;function De(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:oe(Fe.scheme,He),pattern:me.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function oe(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ae){function Oe(oe){switch(oe){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function De(oe){switch(oe){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ae.to=De})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(Ae){function Oe(oe){let Fe;return oe.code&&((0,S.isString)(oe.code)||(0,S.isNumber)(oe.code)?Fe=String(oe.code):Fe={value:String(oe.code.value),target:oe.code.target}),{...c.from(oe.range),message:oe.message,source:oe.source,code:Fe,severity:g.from(oe.severity),relatedInformation:oe.relatedInformation&&oe.relatedInformation.map(b.from),tags:Array.isArray(oe.tags)?(0,a.coalesce)(oe.tags.map(s.from)):void 0}}Ae.from=Oe;function De(oe){const Fe=new o.Diagnostic(c.to(oe),oe.message,g.to(oe.severity));return Fe.source=oe.source,Fe.code=(0,S.isString)(oe.code)?oe.code:oe.code?.value,Fe.relatedInformation=oe.relatedInformation&&oe.relatedInformation.map(b.to),Fe.tags=oe.tags&&(0,a.coalesce)(oe.tags.map(s.to)),Fe}Ae.to=De})(u=e.Diagnostic||(e.Diagnostic={}));var b;(function(Ae){function Oe(oe){return{...c.from(oe.location.range),message:oe.message,resource:oe.location.uri}}Ae.from=Oe;function De(oe){return new o.DiagnosticRelatedInformation(new o.Location(oe.resource,c.to(oe)),oe.message)}Ae.to=De})(b=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(Ae){function Oe(oe){switch(oe){case o.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ae.from=Oe;function De(oe){switch(oe){case n.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ae.to=De})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var L;(function(Ae){function Oe(oe){return typeof oe=="number"&&oe>=o.ViewColumn.One?oe-1:oe===o.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Ae.from=Oe;function De(oe){if(typeof oe=="number"&&oe>=0)return oe+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=De})(L=e.ViewColumn||(e.ViewColumn={}));function j(Ae){return typeof Ae.range<"u"}function G(Ae){return Ae.length===0?!0:!!j(Ae[0])}e.isDecorationOptionsArr=G;var Q;(function(Ae){function Oe(qe){return qe.map(Ae.from)}Ae.fromMany=Oe;function De(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function oe(qe){let et;if(De(qe)){const{language:bt,value:Nt}=qe;et={value:"```"+bt+`
`+Nt+"\n```\n"}}else o.MarkdownString.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const dt=Object.create(null);et.uris=dt;const ut=bt=>{try{let Nt=C.URI.parse(bt,!0);Nt=Nt.with({query:Fe(Nt.query,dt)}),dt[bt]=Nt}catch{}return""},It=new D.marked.Renderer;return It.link=ut,It.image=bt=>typeof bt=="string"?ut(P.parseHrefAndDimensions(bt).href):"",(0,D.marked)(et.value,{renderer:It}),et}Ae.from=oe;function Fe(qe,et){if(!qe)return qe;let dt;try{dt=(0,v.parse)(qe)}catch{}if(!dt)return qe;let ut=!1;return dt=(0,k.cloneAndChange)(dt,It=>{if(C.URI.isUri(It)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[bt]=It,ut=!0,bt}else return}),ut?JSON.stringify(dt):qe}function He(qe){const et=new o.MarkdownString(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?C.URI.from(qe.baseUri):void 0,et}Ae.to=He;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:Ae.from(qe)}Ae.fromStrict=Ze})(Q=e.MarkdownString||(e.MarkdownString={}));function B(Ae){return G(Ae)?Ae.map(Oe=>({range:c.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?Q.fromMany(Oe.hoverMessage):Oe.hoverMessage?Q.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:c.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function U(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?C.URI.file(Ae):Ae}e.pathOrURIToURI=U;var z;(function(Ae){function Oe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?U(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Ae.from=Oe})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Ae){function Oe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?z.from(De.before):void 0,after:De.after?z.from(De.after):void 0}}Ae.from=Oe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(Ae){function Oe(De){if(typeof De>"u")return De;switch(De){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var fe;(function(Ae){function Oe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?x.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?M.from(De.light):void 0,dark:De.dark?M.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?z.from(De.before):void 0,after:De.after?z.from(De.after):void 0}}Ae.from=Oe})(fe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var re;(function(Ae){function Oe(oe){return{text:oe.newText,eol:oe.newEol&&st.from(oe.newEol),range:c.from(oe.range)}}Ae.from=Oe;function De(oe){const Fe=new o.TextEdit(c.to(oe.range),oe.text);return Fe.newEol=typeof oe.eol>"u"?void 0:st.to(oe.eol),Fe}Ae.to=De})(re=e.TextEdit||(e.TextEdit={}));var V;(function(Ae){function Oe(oe,Fe){const He={edits:[]};if(oe instanceof o.WorkspaceEdit){const Ze=new T.ResourceSet;for(const qe of oe._allEntries())qe._type===1&&C.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of oe._allEntries())qe._type===1?He.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contentsBase64:qe.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(qe.options.contents))},metadata:qe.metadata}):qe._type===2?He.edits.push({resource:qe.uri,textEdit:re.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?He.edits.push({resource:qe.uri,textEdit:{range:c.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?He.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&He.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(vt.from)}})}return He}Ae.from=Oe;function De(oe){const Fe=new o.WorkspaceEdit;for(const He of oe.edits)He.textEdit?Fe.replace(C.URI.revive(He.resource),c.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(C.URI.revive(He.oldResource),C.URI.revive(He.newResource),He.options);return Fe}Ae.to=De})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var _;(function(Ae){const Oe=Object.create(null);Oe[o.SymbolKind.File]=0,Oe[o.SymbolKind.Module]=1,Oe[o.SymbolKind.Namespace]=2,Oe[o.SymbolKind.Package]=3,Oe[o.SymbolKind.Class]=4,Oe[o.SymbolKind.Method]=5,Oe[o.SymbolKind.Property]=6,Oe[o.SymbolKind.Field]=7,Oe[o.SymbolKind.Constructor]=8,Oe[o.SymbolKind.Enum]=9,Oe[o.SymbolKind.Interface]=10,Oe[o.SymbolKind.Function]=11,Oe[o.SymbolKind.Variable]=12,Oe[o.SymbolKind.Constant]=13,Oe[o.SymbolKind.String]=14,Oe[o.SymbolKind.Number]=15,Oe[o.SymbolKind.Boolean]=16,Oe[o.SymbolKind.Array]=17,Oe[o.SymbolKind.Object]=18,Oe[o.SymbolKind.Key]=19,Oe[o.SymbolKind.Null]=20,Oe[o.SymbolKind.EnumMember]=21,Oe[o.SymbolKind.Struct]=22,Oe[o.SymbolKind.Event]=23,Oe[o.SymbolKind.Operator]=24,Oe[o.SymbolKind.TypeParameter]=25;function De(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=De;function oe(Fe){for(const He in Oe)if(Oe[He]===Fe)return Number(He);return o.SymbolKind.Property}Ae.to=oe})(_=e.SymbolKind||(e.SymbolKind={}));var te;(function(Ae){function Oe(oe){switch(oe){case o.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function De(oe){switch(oe){case 1:return o.SymbolTag.Deprecated}}Ae.to=De})(te=e.SymbolTag||(e.SymbolTag={}));var ve;(function(Ae){function Oe(oe){return{name:oe.name,kind:_.from(oe.kind),tags:oe.tags&&oe.tags.map(te.from),containerName:oe.containerName,location:J.from(oe.location)}}Ae.from=Oe;function De(oe){const Fe=new o.SymbolInformation(oe.name,_.to(oe.kind),oe.containerName,J.to(oe.location));return Fe.tags=oe.tags&&oe.tags.map(te.to),Fe}Ae.to=De})(ve=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Ae){function Oe(oe){const Fe={name:oe.name||"!!MISSING: name!!",detail:oe.detail,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),kind:_.from(oe.kind),tags:oe.tags?.map(te.from)??[]};return oe.children&&(Fe.children=oe.children.map(Oe)),Fe}Ae.from=Oe;function De(oe){const Fe=new o.DocumentSymbol(oe.name,oe.detail,_.to(oe.kind),c.to(oe.range),c.to(oe.selectionRange));return(0,a.isNonEmptyArray)(oe.tags)&&(Fe.tags=oe.tags.map(te.to)),oe.children&&(Fe.children=oe.children.map(De)),Fe}Ae.to=De})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(Ae){function Oe(oe){const Fe=new o.CallHierarchyItem(_.to(oe.kind),oe.name,oe.detail||"",C.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Fe._sessionId=oe._sessionId,Fe._itemId=oe._itemId,Fe}Ae.to=Oe;function De(oe,Fe,He){if(Fe=Fe??oe._sessionId,He=He??oe._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:oe.name,detail:oe.detail,kind:_.from(oe.kind),uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(te.from)}}Ae.from=De})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(Ae){function Oe(De){return new o.CallHierarchyIncomingCall(ue.to(De.from),De.fromRanges.map(oe=>c.to(oe)))}Ae.to=Oe})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ae){function Oe(De){return new o.CallHierarchyOutgoingCall(ue.to(De.to),De.fromRanges.map(oe=>c.to(oe)))}Ae.to=Oe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var J;(function(Ae){function Oe(oe){return{range:oe.range&&c.from(oe.range),uri:oe.uri}}Ae.from=Oe;function De(oe){return new o.Location(C.URI.revive(oe.uri),c.to(oe.range))}Ae.to=De})(J=e.location||(e.location={}));var ge;(function(Ae){function Oe(oe){const Fe=oe,He=oe;return{originSelectionRange:Fe.originSelectionRange?c.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:c.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?c.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function De(oe){return{targetUri:C.URI.revive(oe.uri),targetRange:c.to(oe.range),targetSelectionRange:oe.targetSelectionRange?c.to(oe.targetSelectionRange):void 0,originSelectionRange:oe.originSelectionRange?c.to(oe.originSelectionRange):void 0}}Ae.to=De})(ge=e.DefinitionLink||(e.DefinitionLink={}));var Ee;(function(Ae){function Oe(oe){return{range:c.from(oe.range),contents:Q.fromMany(oe.contents)}}Ae.from=Oe;function De(oe){return new o.Hover(oe.contents.map(Q.to),c.to(oe.range))}Ae.to=De})(Ee=e.Hover||(e.Hover={}));var ie;(function(Ae){function Oe(oe){return{range:c.from(oe.range),expression:oe.expression}}Ae.from=Oe;function De(oe){return new o.EvaluatableExpression(c.to(oe.range),oe.expression)}Ae.to=De})(ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ne;(function(Ae){function Oe(oe){if(oe instanceof o.InlineValueText)return{type:"text",range:c.from(oe.range),text:oe.text};if(oe instanceof o.InlineValueVariableLookup)return{type:"variable",range:c.from(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};if(oe instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(oe.range),expression:oe.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function De(oe){switch(oe.type){case"text":return{range:c.to(oe.range),text:oe.text};case"variable":return{range:c.to(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};case"expression":return{range:c.to(oe.range),expression:oe.expression}}}Ae.to=De})(ne=e.InlineValue||(e.InlineValue={}));var de;(function(Ae){function Oe(oe){return{frameId:oe.frameId,stoppedLocation:c.from(oe.stoppedLocation)}}Ae.from=Oe;function De(oe){return new o.InlineValueContext(oe.frameId,c.to(oe.stoppedLocation))}Ae.to=De})(de=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(oe){return{range:c.from(oe.range),kind:oe.kind}}Ae.from=Oe;function De(oe){return new o.DocumentHighlight(c.to(oe.range),oe.kind)}Ae.to=De})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Ae){function Oe(De){switch(De){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ae.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Ae){function Oe(De){return{triggerKind:ce.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Ae.to=Oe})(ae=e.CompletionContext||(e.CompletionContext={}));var N;(function(Ae){function Oe(oe){switch(oe){case o.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function De(oe){switch(oe){case 1:return o.CompletionItemTag.Deprecated}}Ae.to=De})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Ae){const Oe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function De(He){return Oe.get(He)??9}Ae.from=De;const oe=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return oe.get(He)??o.CompletionItemKind.Property}Ae.to=Fe})($=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Ae){function Oe(De,oe){const Fe=new o.CompletionItem(De.label);return Fe.insertText=De.insertText,Fe.kind=$.to(De.kind),Fe.tags=De.tags?.map(N.to),Fe.detail=De.detail,Fe.documentation=P.isMarkdownString(De.documentation)?Q.to(De.documentation):De.documentation,Fe.sortText=De.sortText,Fe.filterText=De.filterText,Fe.preselect=De.preselect,Fe.commitCharacters=De.commitCharacters,I.Range.isIRange(De.range)?Fe.range=c.to(De.range):typeof De.range=="object"&&(Fe.range={inserting:c.to(De.range.insert),replacing:c.to(De.range.replace)}),Fe.keepWhitespace=typeof De.insertTextRules>"u"?!1:Boolean(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Fe.insertText=new o.SnippetString(De.insertText):(Fe.insertText=De.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Fe.additionalTextEdits=De.additionalTextEdits.map(He=>re.to(He))),Fe.command=oe&&De.command?oe.fromInternal(De.command):void 0,Fe}Ae.to=Oe})(X=e.CompletionItem||(e.CompletionItem={}));var Z;(function(Ae){function Oe(oe){if(typeof oe.label!="string"&&!Array.isArray(oe.label))throw new TypeError("Invalid label");return{label:oe.label,documentation:Q.fromStrict(oe.documentation)}}Ae.from=Oe;function De(oe){return{label:oe.label,documentation:P.isMarkdownString(oe.documentation)?Q.to(oe.documentation):oe.documentation}}Ae.to=De})(Z=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Ae){function Oe(oe){return{label:oe.label,documentation:Q.fromStrict(oe.documentation),parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.from):[],activeParameter:oe.activeParameter}}Ae.from=Oe;function De(oe){return{label:oe.label,documentation:P.isMarkdownString(oe.documentation)?Q.to(oe.documentation):oe.documentation,parameters:Array.isArray(oe.parameters)?oe.parameters.map(Z.to):[],activeParameter:oe.activeParameter}}Ae.to=De})(he=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(Ae){function Oe(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(he.from):[]}}Ae.from=Oe;function De(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(he.to):[]}}Ae.to=De})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(Ae){function Oe(De,oe){const Fe=new o.InlayHint(f.to(oe.position),typeof oe.label=="string"?oe.label:oe.label.map(we.to.bind(void 0,De)),oe.kind&&Te.to(oe.kind));return Fe.textEdits=oe.textEdits&&oe.textEdits.map(re.to),Fe.tooltip=P.isMarkdownString(oe.tooltip)?Q.to(oe.tooltip):oe.tooltip,Fe.paddingLeft=oe.paddingLeft,Fe.paddingRight=oe.paddingRight,Fe}Ae.to=Oe})(Re=e.InlayHint||(e.InlayHint={}));var we;(function(Ae){function Oe(De,oe){const Fe=new o.InlayHintLabelPart(oe.label);return Fe.tooltip=P.isMarkdownString(oe.tooltip)?Q.to(oe.tooltip):oe.tooltip,E.Command.is(oe.command)&&(Fe.command=De.fromInternal(oe.command)),oe.location&&(Fe.location=J.to(oe.location)),Fe}Ae.to=Oe})(we=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Te;(function(Ae){function Oe(oe){return oe}Ae.from=Oe;function De(oe){return oe}Ae.to=De})(Te=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(oe){return{range:c.from(oe.range),url:oe.target,tooltip:oe.tooltip}}Ae.from=Oe;function De(oe){let Fe;if(oe.url)try{Fe=typeof oe.url=="string"?C.URI.parse(oe.url,!0):C.URI.revive(oe.url)}catch{}return new o.DocumentLink(c.to(oe.range),Fe)}Ae.to=De})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(oe){const Fe=new o.ColorPresentation(oe.label);return oe.textEdit&&(Fe.textEdit=re.to(oe.textEdit)),oe.additionalTextEdits&&(Fe.additionalTextEdits=oe.additionalTextEdits.map(He=>re.to(He))),Fe}Ae.to=Oe;function De(oe){return{label:oe.label,textEdit:oe.textEdit?re.from(oe.textEdit):void 0,additionalTextEdits:oe.additionalTextEdits?oe.additionalTextEdits.map(Fe=>re.from(Fe)):void 0}}Ae.from=De})(je=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(Ae){function Oe(oe){return new o.Color(oe[0],oe[1],oe[2],oe[3])}Ae.to=Oe;function De(oe){return[oe.red,oe.green,oe.blue,oe.alpha]}Ae.from=De})(We=e.Color||(e.Color={}));var tt;(function(Ae){function Oe(oe){return{range:c.from(oe.range)}}Ae.from=Oe;function De(oe){return new o.SelectionRange(c.to(oe.range))}Ae.to=De})(tt=e.SelectionRange||(e.SelectionRange={}));var Ye;(function(Ae){function Oe(De){switch(De){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(oe){switch(oe){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function De(oe){switch(oe){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ae.to=De})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(oe){if(oe===o.EndOfLine.CRLF)return 1;if(oe===o.EndOfLine.LF)return 0}Ae.from=Oe;function De(oe){if(oe===1)return o.EndOfLine.CRLF;if(oe===0)return o.EndOfLine.LF}Ae.to=De})(st=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Ae){function Oe(De){if(typeof De=="object")return De.viewId;switch(De){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Ae){function Oe(oe){const Fe={start:oe.start+1,end:oe.end+1};return oe.kind&&(Fe.kind=W.from(oe.kind)),Fe}Ae.from=Oe;function De(oe){const Fe={start:oe.start-1,end:oe.end-1};return oe.kind&&(Fe.kind=W.to(oe.kind)),Fe}Ae.to=De})(it=e.FoldingRange||(e.FoldingRange={}));var W;(function(Ae){function Oe(oe){if(oe)switch(oe){case o.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Ae.from=Oe;function De(oe){if(oe)switch(oe.value){case E.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Ae.to=De})(W=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Ae){function Oe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?c.from(De.selection):void 0,override:typeof De.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(Ae){function Oe(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:De(He)||oe(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Ae.from=Oe;function De(He){const Ze=He;return Ze?C.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function oe(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.RelativePattern(C.URI.revive(He.baseUri),He.pattern)}Ae.to=Fe})(me=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Ae){function Oe(De){if(De){if(Array.isArray(De))return De.map(Oe);if(typeof De=="string")return De;{const oe=De;return{language:oe.language,scheme:oe.scheme,pattern:me.from(oe.pattern),exclusive:oe.exclusive,notebookType:oe.notebookType}}}else return}Ae.from=Oe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Ae){function Oe(De){switch(De){case 2:return o.NotebookDocumentSaveReason.AfterDelay;case 1:return o.NotebookDocumentSaveReason.Manual;case 3:case 4:return o.NotebookDocumentSaveReason.FocusOut}}Ae.to=Oe})(Ne=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var xe;(function(Ae){function Oe(oe){return{start:oe.start,end:oe.end}}Ae.from=Oe;function De(oe){return new o.NotebookRange(oe.start,oe.end)}Ae.to=De})(xe=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Ae){function Oe(oe){return{timing:typeof oe.runStartTime=="number"&&typeof oe.runEndTime=="number"?{startTime:oe.runStartTime,endTime:oe.runEndTime}:void 0,executionOrder:oe.executionOrder,success:oe.lastRunSuccess}}Ae.to=Oe;function De(oe){return{lastRunSuccess:oe.success,runStartTime:oe.timing?.startTime,runEndTime:oe.timing?.endTime,executionOrder:oe.executionOrder}}Ae.from=De})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Xe;(function(Ae){function Oe(De){if(De===w.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(De===w.NotebookCellExecutionState.Pending)return;if(De===w.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Ae.to=Oe})(Xe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var rt;(function(Ae){function Oe(oe){switch(oe){case o.NotebookCellKind.Markup:return w.CellKind.Markup;case o.NotebookCellKind.Code:default:return w.CellKind.Code}}Ae.from=Oe;function De(oe){switch(oe){case w.CellKind.Markup:return o.NotebookCellKind.Markup;case w.CellKind.Code:default:return o.NotebookCellKind.Code}}Ae.to=De})(rt=e.NotebookCellKind||(e.NotebookCellKind={}));var ct;(function(Ae){function Oe(oe){const Fe={metadata:oe.metadata??Object.create(null),cells:[]};for(const He of oe.cells)o.NotebookCellData.validate(He),Fe.cells.push(vt.from(He));return Fe}Ae.from=Oe;function De(oe){const Fe=new o.NotebookData(oe.cells.map(vt.to));return(0,S.isEmptyObject)(oe.metadata)||(Fe.metadata=oe.metadata),Fe}Ae.to=De})(ct=e.NotebookData||(e.NotebookData={}));var vt;(function(Ae){function Oe(oe){return{cellKind:rt.from(oe.kind),language:oe.languageId,mime:oe.mime,source:oe.value,metadata:oe.metadata,internalMetadata:Qe.from(oe.executionSummary??{}),outputs:oe.outputs?oe.outputs.map(wt.from):[]}}Ae.from=Oe;function De(oe){return new o.NotebookCellData(rt.to(oe.cellKind),oe.source,oe.language,oe.mime,oe.outputs?oe.outputs.map(wt.to):void 0,oe.metadata,oe.internalMetadata?Qe.to(oe.internalMetadata):void 0)}Ae.to=De})(vt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(oe){return{mime:oe.mime,valueBytes:A.VSBuffer.wrap(oe.data)}}Ae.from=Oe;function De(oe){return new o.NotebookCellOutputItem(oe.valueBytes.buffer,oe.mime)}Ae.to=De})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var wt;(function(Ae){function Oe(oe){return{outputId:oe.id,items:oe.items.map(mt.from),metadata:oe.metadata}}Ae.from=Oe;function De(oe){const Fe=oe.items.map(mt.to);return new o.NotebookCellOutput(Fe,oe.outputId,oe.metadata)}Ae.to=De})(wt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ct;(function(Ae){function Oe(Fe){return oe(Fe)?{include:(0,S.withNullAsUndefined)(me.from(Fe.include)),exclude:(0,S.withNullAsUndefined)(me.from(Fe.exclude))}:(0,S.withNullAsUndefined)(me.from(Fe))}Ae.from=Oe;function De(Fe){return oe(Fe)?{include:me.to(Fe.include),exclude:me.to(Fe.exclude)}:me.to(Fe)}Ae.to=De;function oe(Fe){const He=Fe;return He?!(0,S.isUndefinedOrNull)(He.include)&&!(0,S.isUndefinedOrNull)(He.exclude):!1}})(Ct=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Lt;(function(Ae){function Oe(De,oe,Fe){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:oe.toInternal(He,Fe),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Ae.from=Oe})(Lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Yt;(function(Ae){function Oe(De,oe,Fe){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:oe.toInternal(He,Fe),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Ae.from=Oe})(Yt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Kt;(function(Ae){function Oe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Ae.from=Oe})(Kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ht;(function(Ae){function Oe(oe){return{uri:oe.uri,provides:oe.provides}}Ae.from=Oe;function De(oe){return new o.NotebookRendererScript(C.URI.revive(oe.uri),oe.provides)}Ae.to=De})(ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Ae){function Oe(oe){return{message:Q.fromStrict(oe.message)||"",type:0,expected:oe.expectedOutput,actual:oe.actualOutput,location:oe.location&&{range:c.from(oe.location.range),uri:oe.location.uri}}}Ae.from=Oe;function De(oe){const Fe=new o.TestMessage(typeof oe.message=="string"?oe.message:Q.to(oe.message));return Fe.actualOutput=oe.actual,Fe.expectedOutput=oe.expected,Fe.location=oe.location?J.to(oe.location):void 0,Fe}Ae.to=De})(gt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Ae){Ae.namespace=p.namespaceTestTag,Ae.denamespace=p.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Mt;(function(Ae){function Oe(oe){const Fe=(0,d.getPrivateApiFor)(oe).controllerId;return{extId:y.TestId.fromExtHostTestItem(oe,Fe).toString(),label:oe.label,uri:C.URI.revive(oe.uri),busy:oe.busy,tags:oe.tags.map(He=>Ot.namespace(Fe,He.id)),range:I.Range.lift(c.from(oe.range)),description:oe.description||null,sortText:oe.sortText||null,error:oe.error&&Q.fromStrict(oe.error)||null}}Ae.from=Oe;function De(oe){return{parent:void 0,error:void 0,id:y.TestId.fromString(oe.extId).localId,label:oe.label,uri:C.URI.revive(oe.uri),tags:(oe.tags||[]).map(Fe=>{const{tagId:He}=Ot.denamespace(Fe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(oe.range||void 0),canResolveChildren:!1,busy:oe.busy,description:oe.description||void 0,sortText:oe.sortText||void 0}}Ae.toPlain=De})(Mt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(oe){return{id:oe.id}}Ae.from=Oe;function De(oe){return new o.TestTag(oe.id)}Ae.to=De}(Ot=e.TestTag||(e.TestTag={}));var Tt;(function(Ae){const Oe=(oe,Fe)=>{const He=[];for(const[qe,et]of Fe)y.TestId.compare(et.item.extId,qe)===2&&(Fe.delete(qe),He.push(et));const Ze={...Mt.toPlain(oe.item),parent:void 0,taskStates:oe.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(gt.to)})),children:He.map(qe=>Oe(qe,Fe))};for(const qe of Ze.children)qe.parent=Ze;return Ze};function De(oe){const Fe=[],He=new Map;for(const Ze of oe.items){He.set(Ze.item.extId,Ze);const qe=y.TestId.root(Ze.item.extId);oe.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:oe.completedAt,results:Fe.map(Ze=>Oe(Ze,He))}}Ae.to=De})(Tt=e.TestResults||(e.TestResults={}));var pt;(function(Ae){function Oe(He){return{covered:He.covered,total:He.covered}}function De(He){return"line"in He?f.from(He):c.from(He)}function oe(He){return"branches"in He?{count:He.executionCount,location:De(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&De(Ze.location)})):void 0}:{type:0,count:He.executionCount,location:De(He.location)}}Ae.fromDetailed=oe;function Fe(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(oe)}}Ae.fromFile=Fe})(pt=e.TestCoverage||(e.TestCoverage={}));var Dt;(function(Ae){function Oe(De){switch(De){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Dt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var zt;(function(Ae){function Oe(oe){const Fe=new o.TypeHierarchyItem(_.to(oe.kind),oe.name,oe.detail||"",C.URI.revive(oe.uri),c.to(oe.range),c.to(oe.selectionRange));return Fe._sessionId=oe._sessionId,Fe._itemId=oe._itemId,Fe}Ae.to=Oe;function De(oe,Fe,He){if(Fe=Fe??oe._sessionId,He=He??oe._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:_.from(oe.kind),name:oe.name,detail:oe.detail??"",uri:oe.uri,range:c.from(oe.range),selectionRange:c.from(oe.selectionRange),tags:oe.tags?.map(te.from)}}Ae.from=De})(zt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var kt;(function(Ae){function Oe(De){if(!!De)return{value:De.value,tooltip:De.tooltip}}Ae.from=Oe})(kt=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Ae){function Oe(He,Ze,qe){const et=Ze.fileData;return et?new class extends o.DataTransferItem{asFile(){return{name:et.name,uri:C.URI.revive(et.uri),data:(0,R.once)(()=>qe())}}}("",Ze.id):He===O.Mimes.uriList&&Ze.uriListData?new o.DataTransferItem(Fe(Ze.uriListData)):new o.DataTransferItem(Ze.asString)}Ae.to=Oe;async function De(He,Ze){const qe=await Ze.asString();if(He===O.Mimes.uriList)return{id:Ze.id,asString:qe,fileData:void 0,uriListData:oe(qe)};const et=Ze.asFile();return{id:Ze.id,asString:qe,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ae.from=De;function oe(He){return l.UriList.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return C.URI.parse(Ze)}catch{}return Ze})}function Fe(He){return l.UriList.create(He.map(Ze=>typeof Ze=="string"?Ze:C.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Vt;(function(Ae){function Oe(oe,Fe){const He=oe.items.map(([Ze,qe])=>[Ze,Ke.to(Ze,qe,()=>Fe(qe.id))]);return new o.DataTransfer(He)}Ae.toDataTransfer=Oe;async function De(oe){const Fe={items:[]},He=[];return oe.forEach((Ze,qe)=>{He.push((async()=>{Fe.items.push([qe,await Ke.from(qe,Ze)])})())}),await Promise.all(He),Fe}Ae.toDataTransferDTO=De})(Vt=e.DataTransfer||(e.DataTransfer={}));var Xt;(function(Ae){function Oe(oe){return{message:oe.message,metadata:oe.metadata,title:oe.title,tooltip:oe.tooltip}}Ae.to=Oe;function De(oe){return{kind:"reply",message:oe.message,metadata:oe.metadata,title:oe.title,tooltip:oe.tooltip}}Ae.from=De})(Xt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var Ut;(function(Ae){function Oe(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",args:De.args}:Xt.from(De)}Ae.from=Oe})(Ut=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(Ie[246],Ce([1,0,2,8,7,11,66]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(v,O,k,S={timeout:1500,errors:3}){this.c=v,this.d=O,this.f=k,this.g=S,this.a=new P.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(v){return(O,k,S)=>{const I={dispose:this.a.push([O,k,v])};return Array.isArray(S)&&S.push(I),I}}async $participateInSave(v,O){const k=a.URI.revive(v);let S=!1;const C=setTimeout(()=>S=!0,this.g.timeout),I=[];try{for(const E of[...this.a]){if(S)break;const n=this.d.getDocument(k),d=await this.h(E,{document:n,reason:R.TextDocumentSaveReason.to(O)});I.push(d)}}finally{clearTimeout(C)}return I}h([v,O,k],S){const C=this.b.get(v);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(k,v,O,S).then(()=>!0,I=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(I),!(I instanceof Error)||I.message!=="concurrent_edits"){const E=this.b.get(v);this.b.set(v,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(v,O,k,S){const C=[],I=Date.now(),{document:E,reason:n}=S,{version:d}=E,h=Object.freeze({document:E,reason:n,waitUntil(w){if(Object.isFrozen(C))throw(0,A.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(w))}});try{O.apply(k,[h])}catch(w){return Promise.reject(w)}return Object.freeze(C),new Promise((w,y)=>{const p=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(C).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-I}ms`),clearTimeout(p),w(t)}).catch(t=>{clearTimeout(p),y(t)})}).then(w=>{const y={edits:[]};for(const p of w)if(Array.isArray(p)&&p.every(t=>t instanceof l.TextEdit))for(const{newText:t,newEol:o,range:r}of p)y.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:t,eol:o&&R.EndOfLine.from(o)}});if(y.edits.length!==0)return d===E.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Ie[247],Ce([1,0,18,2,11,7,94]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(k,S,C,I){this.start=k,this.deletedCount=S,this.deletedItems=C,this.items=I}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,S,C){this.notebook=k,this.h=S,this.j=C,this.handle=C.handle,this.uri=A.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(l.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,S=this.h.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:S.document,get mime(){return k.g},set mime(I){k.g=I},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(C)}return this.f}setOutputs(k){this.a=k.map(l.NotebookCellOutput.to)}setOutputItems(k,S,C){const I=C.map(l.NotebookCellOutputItem.to),E=this.a.find(n=>n.id===k);if(E&&(S||(E.items.length=0),E.items.push(...I),E.items.length>1&&E.items.every(n=>P.isTextStreamMime(n.mime)))){const n=new Map,d=[];E.items.forEach(h=>{let w;n.has(h.mime)?w=n.get(h.mime):(w=[],n.set(h.mime,w),d.push(h.mime)),w.push(h.data)}),E.items.length=0,d.forEach(h=>{const w=P.compressOutputItemStreams(n.get(h));E.items.push({mime:h,data:w.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=D;class v{constructor(k,S,C,I,E){this.k=k,this.l=S,this.m=C,this.uri=I,this.handle=v.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,S={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===a.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(C){return C=k.n(C),k.b[C].apiCell},getCells(C){return(C?k.p(C):k.b).map(E=>E.apiCell)},save(){return k.q()}};this.e=Object.freeze(S)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,S,C){this.g=k.versionId,this.h=S,this.acceptDocumentPropertiesChanged({metadata:C});const I={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},E=[];for(const d of k.rawEvents)d.kind===P.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,I.contentChanges):d.kind===P.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,I.contentChanges):d.kind===P.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===P.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),E.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),E.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const n=new Map;for(let d=0;d<E.length;d++){const h=E[d],w=n.get(h.cell);if(w===void 0){const y=I.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});n.set(h.cell,y-1)}else I.cellChanges[w]={...I.cellChanges[w],...h}}return Object.freeze(I),Object.freeze(I.cellChanges),Object.freeze(I.contentChanges),I}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let S=k.start|0,C=k.end|0;return S<0&&(S=0),C>this.b.length&&(C=this.b.length),k.with({start:S,end:C})}p(k){k=this.o(k);const S=[];for(let C=k.start;C<k.end;C++)S.push(this.b[C]);return S}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,S,C){if(this.j)return;const I=[],E=[],n=[];if(k.reverse().forEach(d=>{const w=d[2].map(t=>{const o=new D(this,this.l,t);return S||E.push(D.asModelAddData(this.apiNotebook,t)),o}),y=new T(d[0],d[1],[],w),p=this.b.splice(d[0],d[1],...w);for(const t of p)n.push(t.uri),y.deletedItems.push(t.apiCell);I.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:n}),C)for(const d of I)C.push(d.asApiEvent())}s(k,S,C,I){const E=this.b.splice(k,S);this.b.splice(C,0,...E);const n=[new T(k,S,E.map(d=>d.apiCell),[]),new T(C,0,[],E)];for(const d of n)I.push(d.asApiEvent())}t(k,S){this.b[k].setOutputs(S)}u(k,S,C,I){this.b[k].setOutputItems(S,C,I)}v(k,S){const C=this.b[k];C.apiCell.document.languageId!==S&&this.m.$acceptModelLanguageChanged(C.uri,S)}w(k,S){const C=this.b[k];C.apiCell.mime=S}x(k,S){this.b[k].setMetadata(S)}y(k,S){this.b[k].setInternalMetadata(S)}getCellFromApiCell(k){return this.b.find(S=>S.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(S=>S.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}v.a=0,e.ExtHostNotebookDocument=v}),define(Ie[248],Ce([1,0,3,2,11,7]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class P{constructor(D,v,O,k={timeout:1500,errors:3}){this.b=D,this.c=v,this.d=O,this.f=k,this.a=new a.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(v,O,k)=>{const S=function(I){v.call(O,I)};return S.extension=D,this.a.event(S,void 0,k)}}async $participateInSave(D,v,O){const k=A.URI.revive(D),S=this.c.getNotebookDocument(k);if(!S)throw new Error("Unable to resolve notebook document");const C=[];if(await this.a.fireAsync({document:S.apiNotebook,reason:l.NotebookDocumentSaveReason.to(v)},O,async(E,n)=>{const d=Date.now(),h=await await Promise.resolve(E);if(Date.now()-d>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!O.isCancellationRequested&&h&&Array.isArray(h))for(const w of h)w instanceof R.WorkspaceEdit?C.push(w):this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data")}),O.isCancellationRequested)return!1;if(C.length===0)return!0;const I={edits:[]};for(const E of C){const{edits:n}=l.WorkspaceEdit.from(E);I.edits=I.edits.concat(n)}return this.d.$tryApplyWorkspaceEdit(I)}}e.ExtHostNotebookDocumentSaveParticipant=P}),define(Ie[137],Ce([1,0,8,11,7]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(T,D,v,O,k,S){this.id=T,this.f=D,this.notebookData=v,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=O,this.c=S}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(D){this.selections=[D]},get selections(){return T.a},set selections(D){if(!Array.isArray(D)||!D.every(l.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=D,T.g(D)},get visibleRanges(){return T.b},revealRange(D,v){T.f.$tryRevealRange(T.id,A.NotebookRange.from(D),v??l.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(A.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(Ie[249],Ce([1,0,8,3,16,11]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(D,v){this.c=D,this.d=v,this.a=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.b=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,v){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,v);const O=this.d.getEditorById(D);v.visibleRanges&&O._acceptVisibleRanges(v.visibleRanges.ranges.map(R.NotebookRange.to)),v.selections&&O._acceptSelections(v.selections.selections.map(R.NotebookRange.to)),v.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),v.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const v in D)this.d.getEditorById(v)._acceptViewColumn(R.ViewColumn.to(D[v]))}};P=Ve([$e(0,l.ILogService)],P),e.ExtHostNotebookEditors=P}),define(Ie[250],Ce([1,0,11,126,185,21,62,8]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,C,I){const E=this.b++,{title:n,location:d,cancellable:h}=C,w={label:(0,l.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this.a.$startProgress(E,{location:a.ProgressLocation.from(d),title:n,source:w,cancellable:h},S.isUnderDevelopment?void 0:S.identifier.value).catch(T.onUnexpectedExternalError),this.d(E,I,!!h)}d(S,C,I){let E;I&&(E=new R.CancellationTokenSource,this.c.set(S,E));const n=h=>{this.a.$progressEnd(h),this.c.delete(h),E?.dispose()};let d;try{d=C(new O(this.a,S),I&&E?E.token:R.CancellationToken.None)}catch(h){throw n(S),h}return d.then(h=>n(S),h=>n(S)),d}$acceptProgressCanceled(S){const C=this.c.get(S);C&&(C.cancel(),this.c.delete(S))}}e.ExtHostProgress=D;function v(k,S){return k.message=S.message,typeof S.increment=="number"&&(typeof k.increment=="number"?k.increment+=S.increment:k.increment=S.increment),k}class O extends A.Progress{constructor(S,C){super(I=>this.throttledReport(I)),this.c=S,this.d=C}throttledReport(S){this.c.$progressReport(this.d,S)}}Ve([(0,P.throttle)(100,(k,S)=>v(k,S),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[138],Ce([1,0,32,133,57,95,76,11,2]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const v=(w,y,p,t)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(r){if(!p(o,r)){const c=o;o=r,w.listener?.(t(r,c))}}}},O=(w,y)=>w===y,k={range:(w,y)=>w===y?!0:!w||!y?!1:w.isEqual(y),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(w,y)=>!(w.length!==y.length||w.some(p=>!y.find(t=>p.id===t.id)))},S=w=>y=>({op:4,update:w(y)}),C=(w,y)=>({range:(()=>{let p;const t=S(o=>({range:a.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){w.listener?.({op:6}),k.range(p,o)||(p=o,w.listener?.(t(o)))}}})(),label:v(w,y,k.label,S(p=>({label:p}))),description:v(w,void 0,k.description,S(p=>({description:p}))),sortText:v(w,void 0,k.sortText,S(p=>({sortText:p}))),canResolveChildren:v(w,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:v(w,!1,k.busy,S(p=>({busy:p}))),error:v(w,void 0,k.error,S(p=>({error:T.MarkdownString.fromStrict(p)||null}))),tags:v(w,[],k.tags,(p,t)=>({op:1,new:p.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),I=w=>{const y=l.TestId.fromString(w.extId),p=new n(y.controllerId,y.localId,w.label,D.URI.revive(w.uri)||void 0);return p.range=T.Range.to(w.range||void 0),p.description=w.description||void 0,p.sortText=w.sortText||void 0,p.tags=w.tags.map(t=>T.TestTag.to({id:(0,P.denamespaceTestTag)(t).tagId})),p},E=w=>{let y;for(const p of w.tests){const t=I(p.item);(0,A.getPrivateApiFor)(t).parent=y,y=t}return y};e.toItemFromContext=E;class n{constructor(y,p,t,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,A.createPrivateApiFor)(this,y);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,A.getPrivateApiFor,n),enumerable:!0,writable:!1},...C(r,t)})}}e.TestItemImpl=n;class d extends n{constructor(y,p){super(y,y,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class h extends R.TestItemCollection{constructor(y,p,t){super({controllerId:y,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new d(y,p),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(Ie[139],Ce([1,0,51,8,102,11,7]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(S,C,I){const E=T.c.nextId();S.$registerTextEditorDecorationType(C.identifier,E,R.DecorationRenderOptions.from(I)),this.value=Object.freeze({key:E,dispose(){S.$removeTextEditorDecorationType(E)}})}}T.c=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=T;class D{constructor(S,C){this.g=[],this.h=void 0,this.j=!1,this.c=S,this.d=S.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(S,C){this.k();let I=null;if(S instanceof P.Position)I=new P.Range(S,S);else if(S instanceof P.Range)I=S;else throw new Error("Unrecognized location");this.l(I,C,!1)}insert(S,C){this.k(),this.l(new P.Range(S,S),C,!0)}delete(S){this.k();let C=null;if(S instanceof P.Range)C=S;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(S,C,I){const E=this.c.validateRange(S);this.g.push({range:E,text:C,forceMoveMarkers:I})}setEndOfLine(S){if(this.k(),S!==P.EndOfLine.LF&&S!==P.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=S}}class v{constructor(S,C,I,E){this.c=S,this.d=C,this._accept(I),this.e=E;const n=this;this.value={get tabSize(){return n.f},set tabSize(d){n.m(d)},get indentSize(){return n.g},set indentSize(d){n.o(d)},get insertSpaces(){return n.h},set insertSpaces(d){n.q(d)},get cursorStyle(){return n.j},set cursorStyle(d){n.s(d)},get lineNumbers(){return n.k},set lineNumbers(d){n.t(d)}}}_accept(S){this.f=S.tabSize,this.g=S.indentSize,this.h=S.insertSpaces,this.j=S.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(S.lineNumbers)}l(S){if(S==="auto")return"auto";if(typeof S=="number"){const C=Math.floor(S);return C>0?C:null}if(typeof S=="string"){const C=parseInt(S,10);return isNaN(C)?null:C>0?C:null}return null}m(S){const C=this.l(S);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(S){if(S==="tabSize")return"tabSize";if(typeof S=="number"){const C=Math.floor(S);return C>0?C:null}if(typeof S=="string"){const C=parseInt(S,10);return isNaN(C)?null:C>0?C:null}return null}o(S){const C=this.n(S);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}q(S){const C=this.p(S);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(S){this.j!==S&&(this.j=S,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:S})))}t(S){this.k!==S&&(this.k=S,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(S)})))}assign(S){const C={};let I=!1;if(typeof S.tabSize<"u"){const E=this.l(S.tabSize);E==="auto"?(I=!0,C.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,I=!0,C.tabSize=E)}if(typeof S.indentSize<"u"){const E=this.n(S.indentSize);E==="tabSize"?(I=!0,C.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,I=!0,C.indentSize=E)}if(typeof S.insertSpaces<"u"){const E=this.p(S.insertSpaces);E==="auto"?(I=!0,C.insertSpaces=E):this.h!==E&&(this.h=E,I=!0,C.insertSpaces=E)}typeof S.cursorStyle<"u"&&this.j!==S.cursorStyle&&(this.j=S.cursorStyle,I=!0,C.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this.k!==S.lineNumbers&&(this.k=S.lineNumbers,I=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(S.lineNumbers)),I&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(S,C){C.catch(I=>{this.e.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this.e.warn(I)})}}e.ExtHostTextEditorOptions=v;class O{constructor(S,C,I,E,n,d,h,w){this.id=S,this.j=C,this.k=I,this.g=!1,this.h=new Set,this.c=n,this.d=new v(this.j,this.id,d,I),this.e=h,this.f=w;const y=this;this.value=Object.freeze({get document(){return E.value},set document(p){throw(0,A.readonly)("document")},get selection(){return y.c&&y.c[0]},set selection(p){if(!(p instanceof P.Selection))throw(0,A.illegalArgument)("selection");y.c=[p],y.l()},get selections(){return y.c},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof P.Selection)))throw(0,A.illegalArgument)("selections");y.c=p,y.l()},get visibleRanges(){return y.e},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return y.d.value},set options(p){y.g||y.d.assign(p)},get viewColumn(){return y.f},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new D(E.value,t);return p(o),y.m(o)},insertSnippet(p,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=y.c.map(c=>R.Range.from(c));else if(t instanceof P.Position){const{lineNumber:c,column:m}=R.Position.from(t);r=[{startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:m}]}else if(t instanceof P.Range)r=[R.Range.from(t)];else{r=[];for(const c of t)if(c instanceof P.Range)r.push(R.Range.from(c));else{const{lineNumber:m,column:f}=R.Position.from(c);r.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return C.$tryInsertSnippet(S,E.value.version,p.value,r,o)},setDecorations(p,t){const o=t.length===0;o&&!y.h.has(p.key)||(o?y.h.delete(p.key):y.h.add(p.key),y.n(()=>{if(R.isDecorationOptionsArr(t))return C.$trySetDecorations(S,p.key,R.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let c=0,m=t.length;c<m;c++){const f=t[c];r[4*c]=f.start.line+1,r[4*c+1]=f.start.character+1,r[4*c+2]=f.end.line+1,r[4*c+3]=f.end.character+1}return C.$trySetDecorationsFast(S,p.key,r)}}))},revealRange(p,t){y.n(()=>C.$tryRevealRange(S,R.Range.from(p),t||P.TextEditorRevealType.Default))},show(p){C.$tryShowEditor(S,R.ViewColumn.from(p))},hide(){C.$tryHideEditor(S)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(S){(0,a.ok)(!this.g),this.d._accept(S)}_acceptVisibleRanges(S){(0,a.ok)(!this.g),this.e=S}_acceptViewColumn(S){(0,a.ok)(!this.g),this.f=S}_acceptSelections(S){(0,a.ok)(!this.g),this.c=S}async l(){const S=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,S)),this.value}m(S){const C=S.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const I=C.edits.map(n=>n.range);I.sort((n,d)=>n.end.line===d.end.line?n.end.character===d.end.character?n.start.line===d.start.line?n.start.character-d.start.character:n.start.line-d.start.line:n.end.character-d.end.character:n.end.line-d.end.line);for(let n=0,d=I.length-1;n<d;n++){const h=I[n].end;if(I[n+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=C.edits.map(n=>({range:R.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,E,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(S){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=O}),define(Ie[251],Ce([1,0,189,7,24,2,3,6,231,19,7,10,17,11,21,27,157]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(y,p){if((0,k.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let t;return Array.isArray(y.highlights)&&(t=y.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:y.label,highlights:t}}}class h{constructor(p,t,o){this.d=p,this.e=t,this.f=o,this.a=new Map,this.b=new n.TreeViewsDnDService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(m=>r(m)?this.i(m):m):c})}registerTreeDataProvider(p,t,o){const r=this.createTreeView(p,{treeDataProvider:t},o);return{dispose:()=>r.dispose()}}createTreeView(p,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],m=!!t.dragAndDropController?.handleDrag,f=!!t.dragAndDropController?.handleDrop,i=this.h(p,t,o),s=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:m,hasHandleDrop:f});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,E.checkProposedApiEnabled)(o,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(u){i.message=u},get title(){return i.title},set title(u){i.title=u},get description(){return i.description},set description(u){i.description=u},get badge(){return i.badge},set badge(u){u!==void 0&&O.ViewBadge.isViewBadge(u)?i.badge={value:Math.floor(Math.abs(u.value)),tooltip:u.tooltip}:u===void 0&&(i.badge=void 0)},reveal:(u,b)=>i.reveal(u,b),dispose:async()=>{await s,this.a.delete(p),i.dispose()}}}$getChildren(p,t){const o=this.a.get(p);return o?o.getChildren(t):Promise.reject(new D.NoTreeViewError(p))}async $handleDrop(p,t,o,r,c,m,f,i){const s=this.a.get(p);if(!s)return Promise.reject(new D.NoTreeViewError(p));const u=C.DataTransfer.toDataTransfer(o,async b=>(await this.d.$resolveDropFileData(p,t,b)).buffer);return f===p&&i&&await this.g(u,s,i,c,m),s.onDrop(u,r,c)}async g(p,t,o,r,c){const m=this.b.removeDragOperationTransfer(c);if(m)(await m)?.forEach((f,i)=>{f&&p.set(i,f)});else if(c&&t.handleDrag){const f=t.handleDrag(o,p,r);this.b.addDragOperationTransfer(c,f),await f}return p}async $handleDrag(p,t,o,r){const c=this.a.get(p);if(!c)return Promise.reject(new D.NoTreeViewError(p));const m=await this.g(new A.DataTransfer,c,t,r,o);if(!!m)return C.DataTransfer.toDataTransferDTO(m)}async $hasResolve(p){const t=this.a.get(p);if(!t)throw new D.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,o){const r=this.a.get(p);if(!r)throw new D.NoTreeViewError(p);return r.resolveTreeItem(t,o)}$setExpanded(p,t,o){const r=this.a.get(p);if(!r)throw new D.NoTreeViewError(p);r.setExpanded(t,o)}$setSelection(p,t){const o=this.a.get(p);if(!o)throw new D.NoTreeViewError(p);o.setSelection(t)}$setFocus(p,t){const o=this.a.get(p);if(!o)throw new D.NoTreeViewError(p);o.setFocus(t)}$setVisible(p,t){const o=this.a.get(p);if(!o)throw new D.NoTreeViewError(p);o.setVisible(t)}$changeCheckboxState(p,t){const o=this.a.get(p);if(!o)throw new D.NoTreeViewError(p);o.setCheckboxState(t)}h(p,t,o){const r=new w(p,t,this.d,this.e.converter,this.f,o);return this.a.set(p,r),r}i(p){const t=this.a.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=h;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,k.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,t,o,r,c,m){if(super(),this.C=p,this.D=o,this.F=r,this.G=c,this.H=m,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new P.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new P.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new P.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new P.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new P.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new P.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new I.CancellationTokenSource,m.contributes&&m.contributes.views)for(const s in m.contributes.views)for(const u of m.contributes.views[s])u.id===p&&(this.J=u.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(s=>this.w.fire({message:!1,element:s})));let f,i;this.B(P.Event.debounce(this.w.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(f||(f=new Promise(b=>i=b),this.y=this.y.then(()=>f)),Array.isArray(u.element)?s.elements.push(...u.element):s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.z=this.z.then(()=>{const b=i;return f=null,this.U(u).then(()=>b())})),s&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.Q(p);return o||(o=await this.R(t)),o?o.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const o=(0,k.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,k.isUndefinedOrNull)(t.focus)?!1:t.focus,c=(0,k.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(m=>this.P(p,m[m.length-1]).then(f=>this.D.$reveal(this.C,{item:f.item,parentChain:m.map(i=>i.item)},{select:o,focus:r,expand:c})),m=>this.G.error(m)):this.D.$reveal(this.C,void 0,{select:o,focus:r,expand:c})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=C.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,t){const o=this.getExtensionElement(p);o&&(t?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(p){(0,S.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async o=>{const r=this.getExtensionElement(o.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:o.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,t,o){const r=[];for(const c of p){const m=this.getExtensionElement(c);m&&r.push(m)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,t,o){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,v.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,t){if(!this.f.resolveTreeItem)return;const o=this.i.get(p);if(o){const r=this.j.get(o);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,o,t)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(p){return this.O(p).then(t=>t?this.N(t).then(o=>this.P(t,o[o.length-1]).then(r=>(o.push(r),o))):Promise.resolve([]))}O(p){const t=this.j.get(p);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,v.asPromise)(()=>this.f.getParent(p))}P(p,t){const o=this.j.get(p);return o?Promise.resolve(o):(0,v.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const m=this.j.get(c);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let t;if(typeof p=="string"){const o=this.getExtensionElement(p);t=o?this.j.get(o):void 0}else t=p;return t&&t.children||void 0}return this.h}async R(p){this.nb(p);const t=new I.CancellationTokenSource(this.S.token);try{const o=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,S.coalesce)(r||[]).map(async m=>{const f=await this.f.getTreeItem(m);return f&&!t.token.isCancellationRequested?this.Z(m,f,o):null}));return t.token.isCancellationRequested?void 0:(0,S.coalesce)(c)}finally{t.dispose()}}U(p){if(p.some(o=>!o))return this.S.dispose(!0),this.S=new I.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(p);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(p){const t=new Set,o=p.map(c=>this.j.get(c));for(const c of o)if(c&&!t.has(c.item.handle)){let m=c;for(;m&&m.parent&&o.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.i.get(m.parent.item.handle);m=f?this.j.get(f):void 0}m&&!m.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const m=this.i.get(c);if(m){const f=this.j.get(m);f&&(!f.parent||!t.has(f.parent.item.handle))&&r.push(c)}}),r}X(p){const t={};return Promise.all(p.map(o=>this.Y(o).then(r=>{r&&(t[o]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(p){const t=this.getExtensionElement(p);if(t){const o=this.j.get(t);if(o)return this.nb(t),(0,v.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const c=this.eb(t,r,o.parent);return this.lb(t,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}Z(p,t,o){const r=this.eb(p,t,o);if(t.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.kb(p,r),this.mb(r,o),r}ab(p){return O.MarkdownString.isMarkdownString(p)?C.MarkdownString.from(p):p}bb(p,t){return t?{...this.F.toInternal(t,p),originalId:t.command}:void 0}cb(p){if(!p.checkboxState)return;let t,o;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:t===O.TreeItemCheckboxState.Checked,tooltip:o}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,t,o){this.db(t);const r=new T.DisposableStore,c=this.gb(p,t,o),m=this.hb(t);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:m,iconDark:this.ib(t)||m,themeIcon:this.fb(t),collapsibleState:(0,k.isUndefinedOrNull)(t.collapsibleState)?O.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:t,label:o,resourceUri:r},c,m){if(t)return`${w.b}/${t}`;const f=d(o,this.H),i=c?c.item.handle:w.a;let s=f?f.label:r?(0,l.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.j.has(p)?this.j.get(p).item.handle:void 0,b=this.Q(c)||[];let g,L=0;do{if(g=`${i}/${L}:${s}`,m||!this.i.has(g)||u===g)break;L++}while(L<=b.length);return g}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,t){this.i.set(t.item.handle,p),this.j.set(p,t)}lb(p,t,o,r){this.i.delete(t.item.handle),this.j.delete(p),t.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(p,t);const c=this.Q(r)||[],m=c.filter(f=>f.item.handle===o.item.handle)[0];m&&c.splice(c.indexOf(m),1,t)}mb(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const t=this.j.get(p);if(t){if(t.children)for(const o of t.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(p){const t=this.j.get(p);if(t){if(t.children)for(const o of t.children){const r=this.i.get(o.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Ie[252],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookDocumentWillSave:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDocumentWillSave.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[253],Ce([1,0,201,8,38,123,93,40,25,252,214,129]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=T.Registry.as(P.Extensions.JSONContribution);class C{constructor(p,t,o){this.a=p,this.b=t,this.c=o}d(p,t){this.a({type:p,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(l.default.Error,p)}warn(p){this.d(l.default.Warning,p)}info(p){this.d(l.default.Info,p)}}e.ExtensionMessageCollector=C;class I{static a(p){const t=new D.ExtensionIdentifierSet;for(let o=0,r=p.length;o<r;o++)t.add(p[o].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new I(t,[]);if(!t||!t.length)return new I([],p);const o=this.a(p),r=this.a(t),c=t.filter(f=>!o.has(f.description.identifier)),m=p.filter(f=>!r.has(f.description.identifier));return new I(c,m)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=I;class E{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=I.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=E;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class h{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new E(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,t),p.activationEventsGenerator&&k.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,S.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=h;const w={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(w.ExtensionsRegistry,new h),e.ExtensionsRegistry=T.Registry.as(w.ExtensionsRegistry),S.registerSchema(d,e.schema),S.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(Ie[254],Ce([1,0,198,10,23,253,44,3]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var v;(function(S){function C(I,E,n){if(!I)return;const d=A.isString(I.type)?I.type:void 0;if(!d||d.length===0){n.error(a.localize(3,null));return}const h=[];if(Array.isArray(I.required))for(const w of I.required)A.isString(w)&&h.push(w);return{extensionId:E.value,taskType:d,required:h,properties:I.properties?l.deepClone(I.properties):{},when:I.when?P.ContextKeyExpr.deserialize(I.when):void 0}}S.from=C})(v||(v={}));const O=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(S,C)=>{for(const I of S)I.type&&C.push(`onTaskType:${I.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,I)=>{O.setHandler((E,n)=>{this.c=void 0;try{for(const d of n.removed){const h=d.value;for(const w of h)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const d of n.added){const h=d.value;for(const w of h){const y=v.from(w,d.description.identifier,d.collector);y&&(this.a[y.taskType]=y)}}(n.removed.length>0||n.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const I of this.all()){const E={type:"object",additionalProperties:!1};I.required.length>0&&(E.required=I.required.slice(0)),I.properties!==void 0?E.properties=l.deepClone(I.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[I.taskType]},C.push(E)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new k}),define(Ie[255],Ce([1,0,199,10,24,23,44,254]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new P.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var D;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(D=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function z(M){if(!M)return U.Strong;switch(M.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=z}(D=e.ShellQuoting||(e.ShellQuoting={}));var v;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(v=e.CommandOptions||(e.CommandOptions={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(U){function z(M){switch(M.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=z}(O=e.RevealKind||(e.RevealKind={}));var k;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function z(M){switch(M.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=z}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(U){function z(M){switch(M.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=z}(S=e.PanelKind||(e.PanelKind={}));var C;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:k.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var I;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(I=e.RuntimeType||(e.RuntimeType={})),function(U){function z(x){switch(x.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=z;function M(x){switch(x){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=M}(I=e.RuntimeType||(e.RuntimeType={}));var E;(function(U){function z(M){return A.isString(M)?M:M.value}U.value=z})(E=e.CommandString||(e.CommandString={}));var n;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function z(x){return x===U.Clean._id||x===U.Build._id||x===U.Rebuild._id||x===U.Test._id}U.is=z;function M(x){if(x!==void 0)return A.isString(x)?z(x)?{_id:x,isDefault:!1}:void 0:x}U.from=M})(n=e.TaskGroup||(e.TaskGroup={}));var d;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var h;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function z(M){switch(M){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=z})(h=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(U){U.parallel="parallel",U.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var y;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(y=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class t{constructor(z,M,x,fe,re,V){this._label="",this._id=z,M&&(this._label=M),x&&(this.type=x),this.runOptions=fe,this.configurationProperties=re,this._source=V}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,M=!1){if(z===void 0)return!1;if(A.isString(z))return z===this._label||z===this.configurationProperties.identifier||M&&z===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class o extends t{constructor(z,M,x,fe,re,V,_,te){super(z,x,void 0,_,te,M),this.command={},this._source=M,this.hasDefinedMatchers=V,re&&(this.command=re)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case I.Shell:M="shell";break;case I.Process:M="process";break;case I.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is(z){return z instanceof o}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let M=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(M+=this._source.kind);const x={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:M};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new o(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=o;class r extends t{constructor(z,M,x,fe,re,V,_){super(z,x,fe,V,_,M),this._source=M,this.configures=re}static is(z){return z instanceof r}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let M=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(M+=this._source.kind);const x={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:M};return JSON.stringify(x)}}e.ConfiguringTask=r;class c extends t{constructor(z,M,x,fe,re,V,_,te,ve){super(z,x,fe,te,ve,M),this.defines=re,this.hasDefinedMatchers=_,this.command=V,this.icon=ve.icon,this.hide=ve.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof c}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new c(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=c;class m extends t{constructor(z,M,x,fe,re,V){super(z,x,fe,re,V,M),this._source=M}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new m(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=m;var f;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(z){this.c=new Map;for(let M=0;M<z.length;M++)this.c.set(z[M].uri.toString(),M)}compare(z,M){const x=z.getWorkspaceFolder(),fe=M.getWorkspaceFolder();if(x&&fe){let re=this.c.get(x.uri.toString());re=re===void 0?0:re+1;let V=this.c.get(fe.uri.toString());return V=V===void 0?0:V+1,re===V?z._label.localeCompare(M._label):re-V}else return!x&&fe?-1:x&&!fe?1:0}}e.TaskSorter=s;var u;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(u=e.TaskEventKind||(e.TaskEventKind={}));var b;(function(U){U.SingleRun="singleRun",U.Background="background"})(b=e.TaskRunType||(e.TaskRunType={}));var g;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(g=e.TaskRunSource||(e.TaskRunSource={}));var L;(function(U){function z(M,x,fe,re){if(x){const V={kind:M,taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:x};return M==="start"?V.resolvedVariables=re:M==="processStarted"?V.processId=re:M==="processEnded"&&(V.exitCode=re),Object.freeze(V)}else return Object.freeze({kind:"changed"})}U.create=z})(L=e.TaskEvent||(e.TaskEvent={}));var j;(function(U){function z(x){const fe=Object.keys(x).sort();let re="";for(const V of fe){let _=x[V];_ instanceof Object?_=z(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),re+=V+","+_+","}return re}function M(x){const re={_key:z(x),type:x.taskType};return Object.assign(re,x),re}U.create=M})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var Q;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Q=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(U){function z(M,x){const fe=T.TaskDefinitionRegistry.get(M.type);if(fe===void 0){const te=R.deepClone(M);return delete te._key,j.create(te)}const re=Object.create(null);re.type=fe.taskType;const V=new Set;fe.required.forEach(te=>V.add(te));const _=fe.properties;for(const te of Object.keys(_)){const ve=M[te];if(ve!=null)re[te]=ve;else if(V.has(te)){const le=_[te];if(le.default!==void 0)re[te]=R.deepClone(le.default);else switch(le.type){case"boolean":re[te]=!1;break;case"number":case"integer":re[te]=0;break;case"string":re[te]="";break;default:x.error(a.localize(2,null,JSON.stringify(M,void 0,0),te));return}}}return j.create(re)}U.createTaskIdentifier=z})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[256],Ce([1,0,8]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,T)=>{this.b=P,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,a.onUnexpectedError)(P))}then(P,T){return this.j().then(P,T)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.LazyPromise=A;class l extends A{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=l}),define(Ie[58],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const A=[];function l(T){const D=new a(T);return A[D.nid]=D,D}e.createProxyIdentifier=l;function R(T){return A[T].sid}e.getStringIdentifierForProxy=R;class P{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=P}),define(Ie[5],Ce([1,0,58]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var R;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var v;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(v=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(n){return n._id=k.a++,n}}k.a=0,e.IdObject=k;var S;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var I;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(I=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,a.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,a.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,a.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,a.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[78],Ce([1,0,4,16,5,20]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(D,v){this.c=v,this.a=new Set,this.b=D.getProxy(l.MainContext.MainThreadTelemetry)}report(D,v,O){const k=this.d(D,v);this.a.has(k)||(this.a.add(k),v.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:D}))}d(D,v){return`${D}-${v.identifier.value}`}};P=Ve([$e(0,R.IExtHostRpcService),$e(1,A.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(T,D,v){}})}),define(Ie[257],Ce([1,0,3,5,7,25]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(v){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new T,this.g=new T,this.a=v.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(v){return this.c=v,Promise.resolve()}async getSession(v,O,k,S={}){const C=R.ExtensionIdentifier.toKey(v.identifier),I=[...k].sort().join(" ");return await this.f.getOrCreate(`${C} ${O} ${I}`,async()=>{await this.a.$ensureProvider(O);const E=v.displayName||v.name;return this.a.$getSession(O,k,C,E,S)})}async getSessions(v,O,k){const S=R.ExtensionIdentifier.toKey(v.identifier),C=[...k].sort().join(" ");return await this.g.getOrCreate(`${S} ${C}`,async()=>{await this.a.$ensureProvider(O);const I=v.displayName||v.name;return this.a.$getSessions(O,k,S,I)})}async removeSession(v,O){const k=this.b.get(v);return k?k.provider.removeSession(O):this.a.$removeSession(v,O)}registerAuthenticationProvider(v,O,k,S){if(this.b.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this.b.set(v,{label:O,provider:k,options:S??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===v)||this.c.push({id:v,label:O});const C=k.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(v,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(v,O,S?.supportsMultipleAccounts??!1),new l.Disposable(()=>{C.dispose(),this.b.delete(v);const I=this.c.findIndex(E=>E.id===v);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(v)})}$createSession(v,O){const k=this.b.get(v);if(k)return Promise.resolve(k.provider.createSession(O));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,O){const k=this.b.get(v);if(k)return Promise.resolve(k.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,O){const k=this.b.get(v);if(k)return Promise.resolve(k.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,O){return this.d.fire({provider:{id:v,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=P;class T{constructor(){this.a=new Map}getOrCreate(v,O){const k=this.a.get(v);if(k)return k;const S=O().finally(()=>this.a.delete(v));return this.a.set(v,S),S}}}),define(Ie[258],Ce([1,0,5,20,11]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(T,D){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:v=>D.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,D,v){const O=l.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,v?.isRefactoring??!1)}};R=Ve([$e(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(Ie[259],Ce([1,0,5]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const P=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(T){return P.$writeText(T)}})}}e.ExtHostClipboard=A});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[41],Ce([1,0,10,7,11,23,5,17,16,70,32,53,2,6,4,20,138,22,58,46,37,74,77]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t){"use strict";var o,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(g,L,j){o.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),_e(this,o,g.getProxy(P.MainContext.MainThreadCommands),"f"),this.d=L,_e(this,c,j,"f"),_e(this,r,g.getProxy(P.MainContext.MainThreadTelemetry),"f"),this.converter=new f(this,G=>{const Q=this.c.get(G);return Q?.result===s.Void?Q:void 0},L),this.f=[{processArgument(G){return(0,v.revive)(G)}},{processArgument(G){return(0,R.cloneAndChange)(G,function(Q){if(O.Range.isIRange(Q))return l.Range.to(Q);if(k.Position.isIPosition(Q))return l.Position.to(Q);if(O.Range.isIRange(Q.range)&&S.URI.isUri(Q.uri))return l.location.to(Q);if(Q instanceof d.VSBuffer)return Q.buffer.buffer;if(!Array.isArray(Q))return Q})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const L=this.registerCommand(!1,g.id,async(...j)=>{const G=g.args.map((B,U)=>{if(!B.validate(j[U]))throw new Error(`Invalid argument '${B.name}' when running '${g.id}', received: ${j[U]}`);return B.convert(j[U])}),Q=await this.executeCommand(g.internalId,...G);return g.result.convert(Q,j,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new A.Disposable(()=>{L.dispose(),this.c.delete(g.id)})}registerCommand(g,L,j,G,Q,B){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:j,thisArg:G,description:Q,extension:B}),g&&Ue(this,o,"f").$registerCommand(L),new A.Disposable(()=>{this.b.delete(L)&&g&&Ue(this,o,"f").$unregisterCommand(L)})}executeCommand(g,...L){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,L,!0)}async g(g,L,j){if(this.b.has(g))return Ue(this,o,"f").$fireCommandActivationEvent(g),this.h(g,L,!1);{let G=!1;const Q=(0,R.cloneAndChange)(L,function(B){if(B instanceof A.Position)return l.Position.from(B);if(B instanceof A.Range)return l.Range.from(B);if(B instanceof A.Location)return l.location.from(B);if(A.NotebookRange.isNotebookRange(B))return l.NotebookRange.from(B);if(B instanceof ArrayBuffer)return G=!0,d.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return G=!0,d.VSBuffer.wrap(B);if(B instanceof d.VSBuffer)return G=!0,B;if(!Array.isArray(B))return B});try{const B=await Ue(this,o,"f").$executeCommand(g,G?new h.SerializableObjectWithBuffers(Q):Q,j);return(0,v.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(g,L,!1);throw B}}}async h(g,L,j){const G=this.b.get(g);if(!G)throw new Error("Unknown command");const{callback:Q,thisArg:B,description:U}=G;if(U)for(let M=0;M<U.args.length;M++)try{(0,a.validateConstraint)(L[M],U.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${U.args[M].name}' - ${U.args[M].description}`)}const z=y.StopWatch.create();try{return await Q.apply(B,L)}catch(M){if(g===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...L);x&&(g=x.command)}if(this.d.error(M,g,G.extension?.identifier),!j)throw M;if(G.extension?.identifier){const x=Ue(this,c,"f").onExtensionError(G.extension.identifier,M);this.d.trace("forwarded error to extension?",x,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.toErrorMessage)(M)),this.id=g,this.source=G.extension?.displayName??G.extension?.name}}}finally{this.j(G,g,z.elapsed())}}j(g,L,j){!g.extension||Ue(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new p.TelemetryTrustedValue(L),duration:j})}$executeContributedCommand(g,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const j=this.b.get(g);return j?(L=L.map(G=>this.f.reduce((Q,B)=>B.processArgument(Q,j.extension?.identifier),G)),this.h(g,L,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Ue(this,o,"f").$getCommands().then(L=>(g&&(L=L.filter(j=>j[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[L,j]of this.b){const{description:G}=j;G&&(g[L]=G)}return Promise.resolve(g)}};o=new WeakMap,r=new WeakMap,c=new WeakMap,m=Ve([$e(0,E.IExtHostRpcService),$e(1,D.ILogService),$e(2,t.IExtHostTelemetry)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,I.createDecorator)("IExtHostCommands");class f{constructor(g,L,j){this.d=g,this.f=L,this.g=j,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,L){if(!g)return;const j={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return j;const G=this.f(g.command);if(G)j.id=G.internalId,j.arguments=G.args.map((Q,B)=>Q.convert(g.arguments&&g.arguments[B]));else if((0,T.isNonEmptyArray)(g.arguments)){const Q=`${g.command}/${++this.c}`;this.b.set(Q,g),L.add((0,C.toDisposable)(()=>{this.b.delete(Q),this.g.trace("CommandsConverter#DISPOSE",Q)})),j.$ident=Q,j.id=this.delegatingCommandId,j.arguments=[Q],this.g.trace("CommandsConverter#CREATE",g.command,Q)}return j}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const L=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=f;class i{constructor(g,L,j,G){this.name=g,this.description=L,this.validate=j,this.convert=G}optional(){return new i(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,L){return new i(g??this.name,L??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",b=>S.URI.isUri(b),b=>b),i.Position=new i("position","A position in a text document",b=>A.Position.isPosition(b),l.Position.from),i.Range=new i("range","A range in a text document",b=>A.Range.isRange(b),l.Range.from),i.Selection=new i("selection","A selection in a text document",b=>A.Selection.isSelection(b),l.Selection.from),i.Number=new i("number","",b=>typeof b=="number",b=>b),i.String=new i("string","",b=>typeof b=="string",b=>b),i.CallHierarchyItem=new i("item","A call hierarchy item",b=>b instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",b=>b instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",b=>b instanceof n.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=i;class s{constructor(g,L){this.description=g,this.convert=L}}s.Void=new s("no result",b=>b),e.ApiCommandResult=s;class u{constructor(g,L,j,G,Q){this.id=g,this.internalId=L,this.description=j,this.args=G,this.result=Q}}e.ApiCommand=u}),define(Ie[260],Ce([1,0,17,18,2,72,121,44,125,41,11,7]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(O.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,a.isFalsyOrEmpty)(n))return;class h extends k.SymbolInformation{static to(y){const p=new h(y.name,O.SymbolKind.to(y.kind),y.containerName||"",new k.Location(d[0],O.Range.to(y.range)));return p.detail=y.detail,p.range=p.location.range,p.selectionRange=O.Range.to(y.selectionRange),p.children=y.children?y.children.map(h.to):[],p}}return n.map(h.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new v.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(O.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(O.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>k.Position.isPosition(d)),n=>n.map(O.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let h;for(const w of d.reverse())h=new k.SelectionRange(O.Range.to(w),h);return h}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(O.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(O.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(O.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(O.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:O.Range.to(n.range),placeholder:n.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return O.WorkspaceEdit.to(n)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(O.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new k.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,h)=>{if(!n)return new k.CompletionList([]);const w=n.suggestions.map(y=>O.CompletionItem.to(y,h));return new k.CompletionList(w,n.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return O.SignatureHelp.to(n)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,h)=>I(w=>new k.CodeLens(O.Range.to(w.range),w.command&&h.fromInternal(w.command)))(n))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>k.Range.isRange(n),n=>k.Selection.isSelection(n)?O.Selection.from(n):O.Range.from(n)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,h)=>I(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const y=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(y.edit=O.WorkspaceEdit.to(w.edit)),w.command&&(y.command=h.fromInternal(w.command)),y.isPreferred=w.isPreferred,y}})(n))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new k.ColorInformation(O.Range.to(d.range),O.Color.to(d.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",n=>n instanceof k.Color,O.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:O.Range.from(n.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(O.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,d,h)=>n.map(O.InlayHint.to.bind(void 0,h)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,d)=>{if(n)return n.map(O.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>O.NotebookExclusiveDocumentPattern.to(d))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(O.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>l.URI.isUri(n)||typeof n=="string"&&(0,D.matchesSomeScheme)(n,A.Schemas.http,A.Schemas.https),n=>n),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[O.ViewColumn.from(n),void 0]:[O.ViewColumn.from(n.viewColumn),O.TextEditorOpenOptions.from(n)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[O.ViewColumn.from(n),void 0]:[O.ViewColumn.from(n.viewColumn),O.TextEditorOpenOptions.from(n)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[O.ViewColumn.from(n.viewColumn),O.TextEditorOpenOptions.from(n)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(O.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(O.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(O.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],v.ApiCommandResult.Void)];class C{static register(d){S.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",T.validateWhenClauses)}}e.ExtHostApiCommands=C;function I(n){return d=>{if(Array.isArray(d))return d.map(n)}}function E(n){if(!Array.isArray(n))return;const d=[];for(const h of n)R.isLocationLink(h)?d.push(O.DefinitionLink.to(h)):d.push(O.location.to(h));return d}}),define(Ie[261],Ce([1,0,19,62,3,6,2,72,25,11,7,5,27]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(I,E,n){const d=I.getProxy(k.MainContext.MainThreadComments);class h{constructor(){this.b=new Map,this.c=new D.ExtensionIdentifierMap,E.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const i=this.b.get(f.handle);return i?i.value:f}else if(f&&f.$mid===7){const i=this.b.get(f.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.commentThreadHandle);return s?s.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const i=this.b.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);return s?f.$mid===8?s.value:{thread:s.value,text:f.text}:f}else if(f&&f.$mid===10){const i=this.b.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;const u=f.commentUniqueId,b=s.getCommentByUniqueId(u);return b||f}else if(f&&f.$mid===11){const i=this.b.get(f.thread.commentControlHandle);if(!i)return f;const s=i.getCommentThread(f.thread.commentThreadHandle);if(!s)return f;const u=f.text,b=f.commentUniqueId,g=s.getCommentByUniqueId(b);return g?(typeof g.body=="string"?g.body=u:g.body=new O.MarkdownString(u),g):f}return f}})}createCommentController(f,i,s){const u=h.a++,b=new y(f,u,i,s);this.b.set(b.handle,b);const g=this.c.get(f.identifier)||[];return g.push(b),this.c.set(f.identifier,g),b.value}$createCommentThreadTemplate(f,i,s){const u=this.b.get(f);!u||u.$createCommentThreadTemplate(i,s)}async $updateCommentThreadTemplate(f,i,s){const u=this.b.get(f);!u||u.$updateCommentThreadTemplate(i,s)}$deleteCommentThread(f,i){this.b.get(f)?.$deleteCommentThread(i)}$provideCommentingRanges(f,i,s){const u=this.b.get(f);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const b=n.getDocument(P.URI.revive(i));return(0,a.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(b,s)).then(g=>g?g.map(L=>v.Range.from(L)):void 0)}$toggleReaction(f,i,s,u,b){const g=this.b.get(f);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const L=g.getCommentThread(i);if(L){const j=L.getCommentByUniqueId(u.uniqueIdInThread);if(g!==void 0&&j&&g.reactionHandler)return g.reactionHandler(j,o(b))}return Promise.resolve(void 0)})}dispose(){}}h.a=0;class w{set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,i,s,u,b,g,L,j){this.m=i,this.n=s,this.o=u,this.p=b,this.q=g,this.extensionDescription=L,this.r=j,this.handle=w.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${f}.${this.handle}`),d.$createCommentThread(i,this.handle,this.n,this.o,v.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{d.$deleteCommentThread(i,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(Q){G.range=Q},get comments(){return G.comments},set comments(Q){G.comments=Q},get collapsibleState(){return G.collapsibleState},set collapsibleState(Q){G.collapsibleState=Q},get canReply(){return G.canReply},set canReply(Q){G.canReply=Q},get contextValue(){return G.contextValue},set contextValue(Q){G.contextValue=Q},get label(){return G.label},set label(Q){G.label=Q},get state(){return G.state},set state(Q){G.state=Q},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const f=s=>Object.prototype.hasOwnProperty.call(this.b,s),i={};f("range")&&(i.range=v.Range.from(this.p)),f("label")&&(i.label=this.label),f("contextValue")&&(i.contextValue=this.contextValue??null),f("comments")&&(i.comments=this.q.map(s=>p(this,s,this.k))),f("collapsibleState")&&(i.collapseState=r(this.g)),f("canReply")&&(i.canReply=this.canReply),f("state")&&(i.state=c(this.h)),f("isTemplate")&&(i.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,i)}getCommentByUniqueId(f){for(const i of this.k){const s=i[0],u=i[1];if(f===u)return s}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}w.a=0,Ve([(0,A.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,i,s,u){this.f=f,this.g=i,this.h=s,this.i=u,this.a=new Map,d.$registerCommentController(this.handle,s,u);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(g){b.options=g},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(g){b.commentingRangeProvider=g},get reactionHandler(){return b.reactionHandler},set reactionHandler(g){b.reactionHandler=g},createCommentThread(g,L,j){return b.createCommentThread(g,L,j).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(f,i,s){i===void 0&&(0,S.checkProposedApiEnabled)(this.f,"fileComments");const u=new w(this.id,this.handle,void 0,f,i,s,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(f,i){const s=new w(this.id,this.handle,void 0,P.URI.revive(f),v.Range.to(i),[],this.f,!0);return s.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(s.handle,s),s}$updateCommentThreadTemplate(f,i){const s=this.a.get(f);s&&(s.range=v.Range.to(i))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function p(m,f,i){let s=i.get(f);return s||(s=++m.commentHandle,i.set(f,s)),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:s,body:typeof f.body=="string"?f.body:v.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(u=>t(u)):void 0,timestamp:f.timestamp?.toJSON()}}function t(m){return{label:m.label,iconPath:m.iconPath?v.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function o(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?P.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function r(m){if(m!==void 0)switch(m){case O.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function c(m){if(m!==void 0)switch(m){case O.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new h}e.createExtHostComments=C}),define(Ie[262],Ce([1,0,23,5,26,20]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let P=class{constructor(O,k){this.a=O.getProxy(A.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,k){const S=this,C=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){S.e(O,k,C,arguments)}})}e(O,k,S,C){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(C,this.b)}),this.c&&this.f(O,S,C)}};P=Ve([$e(0,R.IExtHostRpcService),$e(1,l.IExtHostInitDataService)],P),e.AbstractExtHostConsoleForwarder=P;const T=1e5;function D(v,O){const k=[];if(v.length)for(let S=0;S<v.length;S++){let C=v[S];if(typeof C>"u")C="undefined";else if(C instanceof Error){const I=C;I.stack?C=I.stack:C=I.toString()}k.push(C)}if(O){const S=new Error().stack;S&&k.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,a.safeStringify)(k);return S.length>T?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(Ie[140],Ce([1,0,2,5,7,4,20,16,17,9,15,27]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class zi{constructor(I,E){this.h=E,this.f=new Map,this.g=I.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,E){const n=zi.c++;this.f.set(n,{provider:I,extensionDescription:E}),this.g.$registerDecorationProvider(n,E.identifier.value);const d=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(h=>{if(!h){this.g.$onDidChange(n,null);return}const w=(0,D.asArray)(h);if(w.length<=zi.d){this.g.$onDidChange(n,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",E.identifier.value,w.length);const y=w.map(o=>({uri:o,rank:(0,v.count)(o.path,"/")})),p=(0,D.groupBy)(y,(o,r)=>o.rank-r.rank||(0,v.compare)(o.uri.path,r.uri.path)),t=[];e:for(const o of p){let r;for(const c of o){const m=(0,O.dirname)(c.uri.path);if(r!==m&&(r=m,t.push(c.uri)>=zi.d))break e}}this.g.$onDidChange(n,t)});return new l.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(I,E,n){if(!this.f.has(I))return Object.create(null);const d=Object.create(null),{provider:h,extensionDescription:w}=this.f.get(I);return await Promise.all(E.map(async y=>{try{const{uri:p,id:t}=y,o=await Promise.resolve(h.provideFileDecoration(a.URI.revive(p),n));if(!o)return;try{l.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,k.checkProposedApiEnabled)(w,"codiconDecoration"),d[t]=[o.propagate,o.tooltip,o.badge,o.color]}catch(r){this.h.warn(`INVALID decoration from extension '${w}': ${r}`)}}catch(p){this.h.error(p)}})),d}};S.c=0,S.d=250,S=Ve([$e(0,P.IExtHostRpcService),$e(1,T.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[263],Ce([1,0,181,124,2,5,7,11,3,16,28,49]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";var S,C,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{constructor(h,w,y,p,t,o,r){this.d=h,this.e=w,this.f=y,this.g=p,S.set(this,void 0),C.set(this,void 0),I.set(this,void 0),this.c=!1,_e(this,I,new O.ResourceMap(c=>t.getComparisonKey(c)),"f"),_e(this,S,o,"f"),_e(this,C,r,"f")}dispose(){this.c||(Ue(this,C,"f").fire([...Ue(this,I,"f").keys()]),Ue(this,S,"f")?.$clear(this.e),Ue(this,I,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(h,w){if(!h){this.clear();return}this.h();let y=[];if(l.URI.isUri(h)){if(!w){this.delete(h);return}Ue(this,I,"f").set(h,w.slice()),y=[h]}else if(Array.isArray(h)){y=[];let t;h=[...h].sort(E.j);for(const o of h){const[r,c]=o;if((!t||r.toString()!==t.toString())&&(t&&Ue(this,I,"f").get(t).length===0&&Ue(this,I,"f").delete(t),t=r,y.push(r),Ue(this,I,"f").set(r,[])),c)Ue(this,I,"f").get(r)?.push(...c);else{const m=Ue(this,I,"f").get(r);m&&(m.length=0)}}}if(Ue(this,C,"f").fire(y),!Ue(this,S,"f"))return;const p=[];for(const t of y){let o=[];const r=Ue(this,I,"f").get(t);if(r)if(r.length>this.f){o=[];const c=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const f of r)if(f.severity===c[m]&&o.push({...T.Diagnostic.from(f),modelVersionId:this.g(t)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=r.map(c=>({...T.Diagnostic.from(c),modelVersionId:this.g(t)}));p.push([t,o])}Ue(this,S,"f").$changeMany(this.e,p)}delete(h){this.h(),Ue(this,C,"f").fire([h]),Ue(this,I,"f").delete(h),Ue(this,S,"f")?.$changeMany(this.e,[[h,void 0]])}clear(){this.h(),Ue(this,C,"f").fire([...Ue(this,I,"f").keys()]),Ue(this,I,"f").clear(),Ue(this,S,"f")?.$clear(this.e)}forEach(h,w){this.h();for(const[y,p]of this)h.call(w,y,p,this)}*[(S=new WeakMap,C=new WeakMap,I=new WeakMap,Symbol.iterator)](){this.h();for(const h of Ue(this,I,"f").keys())yield[h,this.get(h)]}get(h){this.h();const w=Ue(this,I,"f").get(h);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(h){return this.h(),Array.isArray(Ue(this,I,"f").get(h))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(h,w){return h[0].toString()<w[0].toString()?-1:h[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=E;let n=class vi{static _mapper(h){const w=new O.ResourceMap;for(const y of h)w.set(y,y);return{uris:Object.freeze(Array.from(w.values()))}}constructor(h,w,y,p){this.h=w,this.j=y,this.k=p,this.f=new Map,this.g=new D.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.g.event,vi._mapper),this.e=h.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,w){const{f:y,e:p,g:t,h:o,j:r,k:c}=this,m=new class{$changeMany(s,u){p.$changeMany(s,u),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,s,u.length===0?"CLEARING":u)}$clear(s){p.$clear(s),o.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,s)}dispose(){p.dispose()}};let f;if(!w)w="_generated_diagnostic_collection_name_#"+vi.c++,f=w;else if(!y.has(w))f=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do f=w+vi.c++;while(y.has(f))}return new class extends E{constructor(){super(w,f,vi.d,s=>c.getDocument(s)?.version,r.extUri,m,t),y.set(f,this)}dispose(){super.dispose(),y.delete(f)}}}getDiagnostics(h){if(h)return this.l(h);{const w=new Map,y=[];for(const p of this.f.values())p.forEach((t,o)=>{let r=w.get(t.toString());typeof r>"u"&&(r=y.length,w.set(t.toString(),r),y.push([t,[]])),y[r][1]=y[r][1].concat(...o)});return y}}l(h){let w=[];for(const y of this.f.values())y.has(h)&&(w=w.concat(y.get(h)));return w}$acceptMarkersChange(h){if(!this.m){const w="_generated_mirror",y=new E(w,w,vi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(w,y),this.m=y}for(const[w,y]of h)this.m.set(l.URI.revive(w),y.map(T.Diagnostic.to))}};n.c=0,n.d=1e3,n=Ve([$e(1,v.ILogService),$e(2,k.IExtHostFileSystemInfo)],n),e.ExtHostDiagnostics=n}),define(Ie[264],Ce([1,0,2,5,27]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(T){this.a=T.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(T,D){return D?.allowUIResources&&(0,l.checkProposedApiEnabled)(T,"showLocal"),this.a.$showOpenDialog(D).then(v=>v?v.map(O=>a.URI.revive(O)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(D=>D?a.URI.revive(D):void 0)}}e.ExtHostDialogs=R}),define(Ie[265],Ce([1,0,8,2,7,5,18,21,9]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class v{constructor(k,S,C){this.d=S,this.e=C,this.b=new Map,this.c=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,S){if(Object.keys(P.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const C=v.a++;this.b.set(C,S),this.c.$registerTextContentProvider(C,k);let I;return typeof S.onDidChange=="function"&&(I=S.onDidChange(E=>{if(E.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(C,E).then(n=>{if(!n&&typeof n!="string")return;const d=this.d.getDocument(E);if(!d)return;const h=(0,D.splitLines)(n);if(!d.equalLines(h))return this.c.$onVirtualDocumentChange(E,n)},a.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),I&&(I.dispose(),I=void 0)})}$provideTextDocumentContent(k,S){const C=this.b.get(k);return C?Promise.resolve(C.provideTextDocumentContent(A.URI.revive(S),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}v.a=0,e.ExtHostDocumentContentProvider=v}),define(Ie[266],Ce([1,0,3,6,2,5,136,11,10,23,7]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(C,I){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=C.getProxy(R.MainContext.MainThreadDocuments),this.g=I,this.g.onDidRemoveDocuments(E=>{for(const n of E)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(E=>{for(const n of E)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const I=this.g.getDocument(C);if(I)return I}getDocument(C){const I=this.getDocumentData(C);if(!I?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return I.document}ensureDocumentData(C){const I=this.g.getDocument(C);if(I)return Promise.resolve(I);let E=this.h.get(C.toString());return E||(E=this.f.$tryOpenDocument(C).then(n=>{this.h.delete(C.toString());const d=l.URI.revive(n);return(0,D.assertIsDefined)(this.g.getDocument(d))},n=>(this.h.delete(C.toString()),Promise.reject(n))),this.h.set(C.toString(),E)),E}createDocumentData(C){return this.f.$tryCreateDocument(C).then(I=>l.URI.revive(I))}$acceptModelLanguageChanged(C,I){const E=l.URI.revive(C),n=this.g.getDocument(E);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(I),this.a.fire(n.document)}$acceptModelSaved(C){const I=l.URI.revive(C),E=this.g.getDocument(I);if(!E)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(E.document)}$acceptDirtyStateChanged(C,I){const E=l.URI.revive(C),n=this.g.getDocument(E);if(!n)throw new Error("unknown document");n._acceptIsDirty(I),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,I,E){const n=l.URI.revive(C),d=this.g.getDocument(n);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),d.onEvents(I);let h;I.isUndoing?h=O.TextDocumentChangeReason.Undo:I.isRedoing&&(h=O.TextDocumentChangeReason.Redo),this.c.fire((0,v.deepFreeze)({document:d.document,contentChanges:I.changes.map(w=>({range:T.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:h}))}setWordDefinitionFor(C,I){(0,P.setWordDefinitionFor)(C,I)}}e.ExtHostDocuments=k}),define(Ie[59],Ce([1,0,51,3,6,2,4,5,136,20,139,11,16,28,18,64,65]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(y,p){this.h=y,this.i=p,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const p=[],t=[],o=[];if(y.removedDocuments)for(const r of y.removedDocuments){const c=R.URI.revive(r),m=this.c.get(c);m?.unref()&&(this.c.delete(c),p.push(m.value))}if(y.addedDocuments)for(const r of y.addedDocuments){const c=R.URI.revive(r.uri);let m=this.c.get(c);if(m&&c.scheme!==I.Schemas.vscodeNotebookCell&&c.scheme!==I.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);m||(m=new d(new D.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(c,m),t.push(m.value)),m.ref()}if(y.removedEditors)for(const r of y.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&o.push(c)}if(y.addedEditors)for(const r of y.addedEditors){const c=R.URI.revive(r.documentUri);a.ok(this.c.has(c),`document '${c}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const m=this.c.get(c).value,f=new O.ExtHostTextEditor(r.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new n.Lazy(()=>m.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(i=>k.Range.to(i)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,f)}y.newActiveEditor!==void 0&&(a.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(o),y.removedDocuments&&this.e.fire(p),y.addedDocuments&&this.d.fire(t),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return E.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const p=this.b.get(this.a);return y?p:p?.value}allEditors(){return[...this.b.values()]}};h=Ve([$e(0,v.IExtHostRpcService),$e(1,S.ILogService)],h),e.ExtHostDocumentsAndEditors=h,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[60],Ce([1,0,11,5,2,3,4,7,20,10,61]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");class k{constructor(n,d,h){this.e=h,this.d=d,this.acceptDtoUpdate(n)}get apiObject(){if(!this.a){const n=this,d={get isActive(){return n.b.id===n.e()},get label(){return n.b.label},get input(){return n.c},get isDirty(){return n.b.isDirty},get isPinned(){return n.b.isPinned},get isPreview(){return n.b.isPreview},get group(){return n.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(n){this.b=n,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class S{constructor(n,d){this.c=[],this.d="",this.b=n,this.e=d;for(const h of n.tabs)h.isActive&&(this.d=h.id),this.c.push(new k(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const n=this,d={get isActive(){return n.b.groupId===n.e()},get viewColumn(){return a.ViewColumn.to(n.b.viewColumn)},get activeTab(){return n.c.find(h=>h.tabId===n.d)?.apiObject},get tabs(){return Object.freeze(n.c.map(h=>h.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(n){this.b=n}acceptTabOperation(n){if(n.kind===0){const h=new k(n.tabDto,this,()=>this.activeTabId());return this.c.splice(n.index,0,h),n.tabDto.isActive&&(this.d=h.tabId),h}else if(n.kind===1){const h=this.c.splice(n.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(n.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this.c.splice(n.index,0,h),h}const d=this.c.find(h=>h.tabId===n.tabDto.id);if(!d)throw new Error("INVALID tab");return n.tabDto.isActive?this.d=n.tabDto.id:this.d===n.tabDto.id&&!n.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(n.tabDto),d}activeTabId(){return this.d}}let C=class{constructor(n){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=n.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const n=this,d={onDidChangeTabGroups:n.c.event,onDidChangeTabs:n.b.event,get all(){return Object.freeze(n.e.map(h=>h.apiObject))},get activeTabGroup(){const h=n.d;return(0,v.assertIsDefined)(n.e.find(y=>y.groupId===h)?.apiObject)},close:async(h,w)=>{const y=Array.isArray(h)?h:[h];return y.length?I(y[0])?this.j(y,w):this.i(y,w):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(n){const d=new Set(this.e.map(r=>r.groupId)),h=new Set(n.map(r=>r.groupId)),w=(0,O.diffSets)(d,h),y=this.e.filter(r=>w.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this.e=n.map(r=>{const c=new S(r,()=>this.d);return w.added.includes(c.groupId)?p.push(c.apiObject):t.push(c.apiObject),c});const o=(0,v.assertIsDefined)(n.find(r=>r.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:p,closed:y,changed:t}))}$acceptTabGroupUpdate(n){const d=this.e.find(h=>h.groupId===n.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(n),n.isActive&&(this.d=n.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const d=this.e.find(w=>w.groupId===n.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const h=d.acceptTabOperation(n);switch(n.kind){case 0:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(n){for(const d of this.e)for(const h of d.tabs)if(h.apiObject===n)return h}h(n){return this.e.find(d=>d.apiObject===n)}async i(n,d){const h=[];for(const w of n){const y=this.g(w);if(!y)throw new Error("Tab close: Invalid tab not found!");h.push(y.tabId)}return this.a.$closeTab(h,d)}async j(n,d){const h=[];for(const w of n){const y=this.h(w);if(!y)throw new Error("Group close: Invalid group not found!");h.push(y.groupId)}return this.a.$closeGroup(h,d)}};C=Ve([$e(0,D.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function I(E){return E.tabs!==void 0}}),define(Ie[267],Ce([1,0,2,5,6,7,11,155,9,22,27]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(I){this.b=void 0,this.a.push(I)}delete(I){const E=this.a.indexOf(I);E>=0&&(this.a.splice(E,1),this.b=void 0)}c(){if(!this.b){const I=this.a.sort(),E=[];let n,d,h=14,w=14;for(const y of I){let p=n?(0,D.commonPrefixLength)(n,y):0;for(p===0?d=1:d=w;p<y.length;p++)p+1===y.length?(h=w,w=9):w+=1,E.push([d,y.toUpperCase().charCodeAt(p),w]),E.push([d,y.toLowerCase().charCodeAt(p),w]),d=w;n=y,w=h}E.push([9,58,10]),E.push([10,47,12]),this.b=new T.StateMachine(E)}}provideDocumentLinks(I){this.c();const E=[],n=T.LinkComputer.computeLinks({getLineContent(d){return I.lineAt(d-1).text},getLineCount(){return I.lineCount}},this.b);for(const d of n){const h=P.DocumentLink.to(d);h.target&&E.push(h)}return E}}class S{constructor(I,E){this.i=E,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=I.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(I,E,n,d={}){if(S.j(n),this.d.has(E))throw new Error(`a provider for the scheme '${E}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(I,"*",this.b));const h=this.h++;this.b.add(E),this.d.add(E),this.c.set(h,n);let w=2;d.isCaseSensitive&&(w+=1024),d.isReadonly&&(w+=2048),typeof n.copy=="function"&&(w+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,O.checkProposedApiEnabled)(I,"fsChunks"),w+=4),this.a.$registerFileSystemProvider(h,E,w).catch(p=>{console.error(`FAILED to register filesystem provider of ${I.identifier.value}-extension for the scheme ${E}`),console.error(p)});const y=n.onDidChangeFile(p=>{const t=[];for(const o of p){const{uri:r,type:c}=o;if(r.scheme!==E)continue;let m;switch(c){case R.FileChangeType.Changed:m=0;break;case R.FileChangeType.Created:m=1;break;case R.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:m})}this.a.$onFileSystemChange(h,t)});return(0,l.toDisposable)(()=>{y.dispose(),this.b.delete(E),this.d.delete(E),this.c.delete(h),this.a.$unregisterProvider(h)})}static j(I){if(!I)throw new Error("MISSING provider");if(typeof I.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof I.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof I.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof I.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof I.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof I.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof I.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof I.rename!="function")throw new Error("Provider does NOT implement rename")}static k(I){const{type:E,ctime:n,mtime:d,size:h,permissions:w}=I;return{type:E,ctime:n,mtime:d,size:h,permissions:w}}$stat(I,E){return Promise.resolve(this.l(I).stat(a.URI.revive(E))).then(n=>S.k(n))}$readdir(I,E){return Promise.resolve(this.l(I).readDirectory(a.URI.revive(E)))}$readFile(I,E){return Promise.resolve(this.l(I).readFile(a.URI.revive(E))).then(n=>v.VSBuffer.wrap(n))}$writeFile(I,E,n,d){return Promise.resolve(this.l(I).writeFile(a.URI.revive(E),n.buffer,d))}$delete(I,E,n){return Promise.resolve(this.l(I).delete(a.URI.revive(E),n))}$rename(I,E,n,d){return Promise.resolve(this.l(I).rename(a.URI.revive(E),a.URI.revive(n),d))}$copy(I,E,n,d){const h=this.l(I);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(a.URI.revive(E),a.URI.revive(n),d))}$mkdir(I,E){return Promise.resolve(this.l(I).createDirectory(a.URI.revive(E)))}$watch(I,E,n,d){const h=this.l(I).watch(a.URI.revive(n),d);this.f.set(E,h)}$unwatch(I,E){const n=this.f.get(E);n&&(n.dispose(),this.f.delete(E))}$open(I,E,n){const d=this.l(I);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(a.URI.revive(E),n))}$close(I,E){const n=this.l(I);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(E))}$read(I,E,n,d){const h=this.l(I);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const w=v.VSBuffer.alloc(d);return Promise.resolve(h.read(E,n,w.buffer,0,d)).then(y=>w.slice(0,y))}$write(I,E,n,d){const h=this.l(I);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(E,n,d.buffer,0,d.byteLength))}l(I){const E=this.c.get(I);if(!E){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return E}}e.ExtHostFileSystem=S}),define(Ie[79],Ce([1,0,5,45,7,22,4,20,49,6]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class ti{constructor(S,C){this.b=new Map,this.a=S.getProxy(a.MainContext.MainThreadFileSystem);const I=this;this.value=Object.freeze({async stat(E){try{const n=I.b.get(E.scheme);if(!n)return await I.a.$stat(E);await I.a.$ensureActivation(E.scheme);const d=await n.stat(E);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(n){ti.c(n)}},async readDirectory(E){try{const n=I.b.get(E.scheme);return n?(await I.a.$ensureActivation(E.scheme),(await n.readDirectory(E)).slice()):await I.a.$readdir(E)}catch(n){return ti.c(n)}},async createDirectory(E){try{return await I.a.$mkdir(E)}catch(n){return ti.c(n)}},async readFile(E){try{const n=I.b.get(E.scheme);return n?(await I.a.$ensureActivation(E.scheme),(await n.readFile(E)).slice()):(await I.a.$readFile(E)).buffer}catch(n){return ti.c(n)}},async writeFile(E,n){try{return await I.a.$writeFile(E,R.VSBuffer.wrap(n))}catch(d){return ti.c(d)}},async delete(E,n){try{const d=I.b.get(E.scheme);return d?(await I.a.$ensureActivation(E.scheme),await d.delete(E,{recursive:!1,...n})):await I.a.$delete(E,{recursive:!1,useTrash:!1,...n})}catch(d){return ti.c(d)}},async rename(E,n,d){try{return await I.a.$rename(E,n,{overwrite:!1,...d})}catch(h){return ti.c(h)}},async copy(E,n,d){try{return await I.a.$copy(E,n,{overwrite:!1,...d})}catch(h){return ti.c(h)}},isWritableFileSystem(E){const n=C.getCapabilities(E);if(typeof n=="number")return!(n&2048)}})}static c(S){if(S instanceof l.FileSystemError)throw S;if(!(S instanceof Error))throw new l.FileSystemError(String(S));if(S.name==="ENOPRO"||S.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(S.message);switch(S.name){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(S.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(S.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(S.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(S.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(S.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(S.message);default:throw new l.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,C){return this.b.set(S,C),(0,v.toDisposable)(()=>this.b.delete(S))}};O=Ve([$e(0,T.IExtHostRpcService),$e(1,D.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[268],Ce([1,0,3,39,2,5,11,7]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(k,S,C,I,E,n,d,h){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const w=this.h(k,C,E);this.g=0,n&&(this.g+=1),d&&(this.g+=2),h&&(this.g+=4);const y=(0,A.parse)(E),p=typeof E=="string",t=I(o=>{if(!n)for(const r of o.created){const c=l.URI.revive(r);y(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.a.fire(c)}if(!d)for(const r of o.changed){const c=l.URI.revive(r);y(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.b.fire(c)}if(!h)for(const r of o.deleted){const c=l.URI.revive(r);y(c.fsPath)&&(!p||S.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=T.Disposable.from(w,this.a,this.b,this.c,t)}h(k,S,C){const I=T.Disposable.from();if(typeof C=="string")return I;const E=k.getProxy(R.MainContext.MainThreadFileSystem);let n=!1;(C.pattern.includes(A.GLOBSTAR)||C.pattern.includes(A.GLOB_SPLIT))&&(n=!0);const d=Math.random();return E.$watch(S.identifier.value,d,C.baseUri,{recursive:n,excludes:[]}),T.Disposable.from({dispose:()=>E.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class v{constructor(k,S,C){this.j=k,this.k=S,this.l=C,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,S,C,I,E,n){return new D(this.j,k,S,this.a.event,P.GlobPattern.from(C),I,E,n)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,S){switch(k){case 2:this.b.fire(Object.freeze({files:S.map(C=>({oldUri:l.URI.revive(C.source),newUri:l.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(C=>l.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(C=>l.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,S){return(C,I,E)=>{const n=function(h){C.call(I,h)};return n.extension=k,S.event(n,void 0,E)}}async $onWillRunFileOperation(k,S,C,I){switch(k){case 2:return await this.n(this.g,{files:S.map(E=>({oldUri:l.URI.revive(E.source),newUri:l.URI.revive(E.target)}))},C,I);case 1:return await this.n(this.i,{files:S.map(E=>l.URI.revive(E.target))},C,I);case 0:case 3:return await this.n(this.h,{files:S.map(E=>l.URI.revive(E.target))},C,I)}}async n(k,S,C,I){const E=new Set,n=[];if(await k.fireAsync(S,I,async(h,w)=>{const y=Date.now(),p=await Promise.resolve(h);p instanceof T.WorkspaceEdit&&(n.push([w.extension,p]),E.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-y>C&&this.k.warn("SLOW file-participant",w.extension.identifier)}),I.isCancellationRequested||n.length===0)return;const d={edits:[]};for(const[,h]of n){const{edits:w}=P.WorkspaceEdit.from(h,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(w)}return{edit:d,extensionNames:Array.from(E)}}}e.ExtHostFileSystemEventService=v}),define(Ie[269],Ce([1,0,2,41]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(P,T,D,v,O){this.a=T,this.b=D,this.c=v;const k=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new A.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new A.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new A.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new A.ApiCommandResult("Notebook and input URI",S=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const C=this.a.getEditorById(S.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:a.URI.revive(S.notebookUri),inputUri:a.URI.revive(S.inputUri),notebookEditor:C.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:a.URI.revive(S.notebookUri),inputUri:a.URI.revive(S.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(P,T,D,v){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:D,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=l}),define(Ie[270],Ce([1,0,6,2,5,11,7]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class T{constructor(k,S){this.extension=k,this.provider=S,this.handle=T.a++}}T.a=0;class D{constructor(k){this.session=k,this.responses=[]}}class v{constructor(k,S,C){this.e=S,this.f=C,this.b=new Map,this.c=new Map,this.d=k.getProxy(l.MainContext.MainThreadInteractiveEditor)}registerProvider(k,S){const C=new T(k,S);return this.b.set(C.handle,C),this.d.$registerInteractiveEditorProvider(C.handle,k.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,a.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(C.handle),this.b.delete(C.handle)})}async $prepareInteractiveSession(k,S,C,I){const E=this.b.get(k);if(!E){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.e.getDocument(A.URI.revive(S)),d=R.Selection.to(C),h=await E.provider.prepareInteractiveEditorSession({document:n,selection:d},I);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const w=v.a++;return this.c.set(w,new D(h)),{id:w,placeholder:h.placeholder,slashCommands:h.slashCommands,wholeRange:R.Range.from(h.wholeRange)}}async $provideResponse(k,S,C,I){const E=this.b.get(k);if(!E)return;const n=this.c.get(S.id);if(!n)return;const d=await E.provider.provideInteractiveEditorResponse({session:n.session,prompt:C.prompt,selection:R.Selection.to(C.selection),wholeRange:R.Range.to(C.wholeRange)},I);if(d){const h=n.responses.push(d)-1,w={wholeRange:R.Range.from(d.wholeRange),placeholder:d.placeholder};if(v.g(d))return{...w,id:h,type:"message",message:R.MarkdownString.from(d.contents)};const{edits:y}=d;if(y instanceof P.WorkspaceEdit)return{...w,id:h,type:"bulkEdit",edits:R.WorkspaceEdit.from(y)};if(Array.isArray(y))return{...w,id:h,type:"editorEdit",edits:y.map(R.TextEdit.from)}}}$handleFeedback(k,S,C,I){const E=this.b.get(k),n=this.c.get(S),d=n?.responses[C];if(E&&d){let h;switch(I){case 1:h=P.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:h=P.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:h=P.InteractiveEditorResponseFeedbackKind.Undone;break}E.provider.handleInteractiveEditorResponseFeedback?.(n.session,d,h)}}$releaseSession(k,S){const C=this.c.get(S),I=this.b.get(k);C&&I&&I.provider.releaseInteractiveEditorSession?.(C.session),this.c.delete(S)}static g(k){return typeof k=="object"&&typeof k.contents=="object"}}v.a=0,e.ExtHostInteractiveEditor=v}),define(Ie[271],Ce([1,0,3,6,37,10,183,5,11]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class v{constructor(S,C){this.extension=S,this.provider=C,this.handle=v.a++}}v.a=0;class O{constructor(S,C){this.h=C,this.b=new Map,this.d=new Map,this.e=new a.Emitter,this.onDidPerformUserAction=this.e.event,this.g=S.getProxy(T.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(S,C,I){const E=new v(S,I);return this.b.set(E.handle,E),this.g.$registerInteractiveSessionProvider(E.handle,C,!!I.provideResponseWithProgress),(0,A.toDisposable)(()=>{this.g.$unregisterInteractiveSessionProvider(E.handle),this.b.delete(E.handle)})}addInteractiveSessionRequest(S){this.g.$addInteractiveSessionRequest(S)}sendInteractiveRequestToProvider(S,C){this.g.$sendInteractiveRequestToProvider(S,C)}async $prepareInteractiveSession(S,C,I){const E=this.b.get(S);if(!E)return;const n=await E.provider.prepareSession(C,I);if(!n)return;const d=O.a++;return this.d.set(d,n),{id:d,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveInteractiveRequest(S,C,I,E){const n=this.b.get(S);if(!n)return;const d=this.d.get(C);if(!d||!n.provider.resolveRequest)return;const h=await n.provider.resolveRequest(d,I,E);if(h)return{message:typeof h.message=="string"?h.message:D.InteractiveSessionReplyFollowup.from(h.message)}}async $provideInitialSuggestions(S,C){const I=this.b.get(S);if(!!I&&!!I.provider.provideInitialSuggestions)return(0,R.withNullAsUndefined)(await I.provider.provideInitialSuggestions(C))}async $provideWelcomeMessage(S,C){const I=this.b.get(S);if(!I||!I.provider.provideWelcomeMessage)return;const E=await I.provider.provideWelcomeMessage(C);if(!!E)return E.map(n=>typeof n=="string"?n:n.map(d=>D.InteractiveSessionReplyFollowup.from(d)))}async $provideFollowups(S,C,I){const E=this.b.get(S);if(!E)return;const n=this.d.get(C);return!n||!E.provider.provideFollowups?void 0:(await E.provider.provideFollowups(n,I))?.map(h=>D.InteractiveSessionFollowup.from(h))}async $provideInteractiveReply(S,C,I,E){const n=this.b.get(S);if(!n)return;const d=this.d.get(C);if(!d)return;const h={session:d,message:typeof I.message=="string"?I.message:D.InteractiveSessionReplyFollowup.to(I.message)},w=l.StopWatch.create(!1);let y;const p={report:r=>{E.isCancellationRequested||(typeof y>"u"&&(y=w.elapsed()),this.g.$acceptInteractiveResponseProgress(S,C,r))}};let t;try{t=await n.provider.provideResponseWithProgress(h,p,E),t||(t={errorDetails:{message:(0,P.localize)(0,null)}})}catch(r){t={errorDetails:{message:(0,P.localize)(1,null,r.message),responseIsIncomplete:!0}},this.h.error(r)}try{if(d.saveState&&this.d.has(C)){const r=d.saveState();this.g.$acceptInteractiveSessionState(C,r)}}catch(r){this.h.warn(r)}const o={firstProgress:y??0,totalElapsed:w.elapsed()};return{errorDetails:t.errorDetails,timings:o}}async $provideSlashCommands(S,C,I){const E=this.b.get(S);if(!E)return;const n=this.d.get(C);return!n||!E.provider.provideSlashCommands?void 0:(await E.provider.provideSlashCommands(n,I))?.map(h=>({...h,kind:D.CompletionItemKind.from(h.kind)}))}$releaseSession(S){this.d.delete(S)}async $onDidPerformUserAction(S){this.e.fire(S)}}O.a=0,e.ExtHostInteractiveSession=O}),define(Ie[272],Ce([1,0,6,5]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(P){this.b=0,this.a=P.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,P),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=l}),define(Ie[273],Ce([1,0,2,23,11,7,72,5,9,32,17,10,151,21,6,121,102,75,37,8,19,27]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(N,$){this.d=N,this.e=$}async provideDocumentSymbols(N,$){const X=this.d.getDocument(N),Z=await this.e.provideDocumentSymbols(X,$);if(!(0,O.isFalsyOrEmpty)(Z))return Z[0]instanceof R.DocumentSymbol?Z.map(l.DocumentSymbol.from):t.f(Z)}static f(N){N=N.slice(0).sort((Z,he)=>{let Se=Z.location.range.start.compareTo(he.location.range.start);return Se===0&&(Se=he.location.range.end.compareTo(Z.location.range.end)),Se});const $=[],X=[];for(const Z of N){const he={name:Z.name||"!!MISSING: name!!",kind:l.SymbolKind.from(Z.kind),tags:Z.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:l.Range.from(Z.location.range),selectionRange:l.Range.from(Z.location.range),children:[]};for(;;){if(X.length===0){X.push(he),$.push(he);break}const Se=X[X.length-1];if(v.Range.containsRange(Se.range,he.range)&&!v.Range.equalsRange(Se.range,he.range)){Se.children?.push(he),X.push(he);break}X.pop()}}return $}}class o{constructor(N,$,X){this.g=N,this.h=$,this.j=X,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,$){const X=this.g.getDocument(N),Z=await this.j.provideCodeLenses(X,$);if(!Z||$.isCancellationRequested)return;const he=this.e.add(Z),Se=new I.DisposableStore;this.f.set(he,Se);const Re={cacheId:he,lenses:[]};for(let we=0;we<Z.length;we++)Re.lenses.push({cacheId:[he,we],range:l.Range.from(Z[we].range),command:this.h.toInternal(Z[we].command,Se)});return Re}async resolveCodeLens(N,$){const X=N.cacheId&&this.e.get(...N.cacheId);if(!X)return;let Z;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?Z=X:Z=await this.j.resolveCodeLens(X,$),Z||(Z=X),$.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(Z.command??o.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function r(ae){return Array.isArray(ae)?ae.map(l.DefinitionLink.from):ae?[l.DefinitionLink.from(ae)]:[]}class c{constructor(N,$){this.d=N,this.e=$}async provideDefinition(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideDefinition(Z,he,X);return r(Se)}}class m{constructor(N,$){this.d=N,this.e=$}async provideDeclaration(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideDeclaration(Z,he,X);return r(Se)}}class f{constructor(N,$){this.d=N,this.e=$}async provideImplementation(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideImplementation(Z,he,X);return r(Se)}}class i{constructor(N,$){this.d=N,this.e=$}async provideTypeDefinition(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideTypeDefinition(Z,he,X);return r(Se)}}class s{constructor(N,$){this.d=N,this.e=$}async provideHover(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideHover(Z,he,X);if(!(!Se||(0,O.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=Z.getWordRangeAtPosition(he)),Se.range||(Se.range=new R.Range(he,he)),l.Hover.from(Se)}}class u{constructor(N,$){this.d=N,this.e=$}async provideEvaluatableExpression(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideEvaluatableExpression(Z,he,X);if(Se)return l.EvaluatableExpression.from(Se)}}class b{constructor(N,$){this.d=N,this.e=$}async provideInlineValues(N,$,X,Z){const he=this.d.getDocument(N),Se=await this.e.provideInlineValues(he,l.Range.to($),l.InlineValueContext.to(X),Z);if(Array.isArray(Se))return Se.map(Re=>l.InlineValue.from(Re))}}class g{constructor(N,$){this.d=N,this.e=$}async provideDocumentHighlights(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideDocumentHighlights(Z,he,X);if(Array.isArray(Se))return Se.map(l.DocumentHighlight.from)}}class L{constructor(N,$){this.d=N,this.e=$}async provideLinkedEditingRanges(N,$,X){const Z=this.d.getDocument(N),he=l.Position.to($),Se=await this.e.provideLinkedEditingRanges(Z,he,X);if(Se&&Array.isArray(Se.ranges))return{ranges:(0,O.coalesce)(Se.ranges.map(l.Range.from)),wordPattern:Se.wordPattern}}}class j{constructor(N,$){this.d=N,this.e=$}async provideReferences(N,$,X,Z){const he=this.d.getDocument(N),Se=l.Position.to($),Re=await this.e.provideReferences(he,Se,X,Z);if(Array.isArray(Re))return Re.map(l.location.from)}}class G{constructor(N,$,X,Z,he,Se,Re){this.g=N,this.h=$,this.j=X,this.k=Z,this.l=he,this.m=Se,this.n=Re,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,$,X,Z){const he=this.g.getDocument(N),Se=S.Selection.isISelection($)?l.Selection.to($):l.Range.to($),Re=[];for(const tt of this.j.getDiagnostics(N))if(Se.intersection(tt.range)&&Re.push(tt)>G.d)break;const we={diagnostics:Re,only:X.only?new R.CodeActionKind(X.only):void 0,triggerKind:l.CodeActionTriggerKind.to(X.trigger)},Te=await this.k.provideCodeActions(he,Se,we,Z);if(!(0,O.isNonEmptyArray)(Te)||Z.isCancellationRequested)return;const ke=this.e.add(Te),je=new I.DisposableStore;this.f.set(ke,je);const We=[];for(let tt=0;tt<Te.length;tt++){const Ye=Te[tt];!Ye||(G.o(Ye)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),We.push({_isSynthetic:!0,title:Ye.title,command:this.h.toInternal(Ye,je)})):(we.only&&(Ye.kind?we.only.contains(Ye.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),We.push({cacheId:[ke,tt],title:Ye.title,command:Ye.command&&this.h.toInternal(Ye.command,je),diagnostics:Ye.diagnostics&&Ye.diagnostics.map(l.Diagnostic.from),edit:Ye.edit&&l.WorkspaceEdit.from(Ye.edit,void 0),kind:Ye.kind&&Ye.kind.value,isPreferred:Ye.isPreferred,disabled:Ye.disabled?.reason})))}return{cacheId:ke,actions:We}}async resolveCodeAction(N,$){const[X,Z]=N,he=this.e.get(X,Z);if(!he||G.o(he)||!this.k.resolveCodeAction)return;const Se=await this.k.resolveCodeAction(he,$)??he;return Se?.edit?l.WorkspaceEdit.from(Se.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}G.d=1e3;class Q{constructor(N,$,X,Z){this.d=N,this.e=$,this.f=X,this.g=Z}async prepareDocumentPaste(N,$,X,Z){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),Se=$.map(we=>l.Range.to(we)),Re=l.DataTransfer.toDataTransfer(X,()=>{throw new w.NotImplementedError});return await this.f.prepareDocumentPaste(he,Se,Re,Z),l.DataTransfer.toDataTransferDTO(Re)}async providePasteEdits(N,$,X,Z,he){const Se=this.e.getDocument($),Re=X.map(ke=>l.Range.to(ke)),we=l.DataTransfer.toDataTransfer(Z,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),Te=await this.f.provideDocumentPasteEdits(Se,Re,we,he);if(!!Te)return{insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?l.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class B{constructor(N,$){this.d=N,this.e=$}async provideDocumentFormattingEdits(N,$,X){const Z=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(Z,$,X);if(Array.isArray(he))return he.map(l.TextEdit.from)}}class U{constructor(N,$){this.d=N,this.e=$}async provideDocumentRangeFormattingEdits(N,$,X,Z){const he=this.d.getDocument(N),Se=l.Range.to($),Re=await this.e.provideDocumentRangeFormattingEdits(he,Se,X,Z);if(Array.isArray(Re))return Re.map(l.TextEdit.from)}}class z{constructor(N,$){this.d=N,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,$,X,Z,he){const Se=this.d.getDocument(N),Re=l.Position.to($),we=await this.e.provideOnTypeFormattingEdits(Se,Re,X,Z,he);if(Array.isArray(we))return we.map(l.TextEdit.from)}}class M{constructor(N,$){this.e=N,this.f=$,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,$){const X=await this.e.provideWorkspaceSymbols(N,$);if(!(0,O.isNonEmptyArray)(X))return{symbols:[]};const Z=this.d.add(X),he={cacheId:Z,symbols:[]};for(let Se=0;Se<X.length;Se++){const Re=X[Se];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}he.symbols.push({...l.WorkspaceSymbol.from(Re),cacheId:[Z,Se]})}return he}async resolveWorkspaceSymbol(N,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const X=this.d.get(...N.cacheId);if(X){const Z=await this.e.resolveWorkspaceSymbol(X,$);return Z&&(0,A.mixin)(N,l.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class x{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,$,X){this.d=N,this.e=$,this.f=X}async provideRenameEdits(N,$,X,Z){const he=this.d.getDocument(N),Se=l.Position.to($);try{const Re=await this.e.provideRenameEdits(he,Se,X,Z);return Re?l.WorkspaceEdit.from(Re):void 0}catch(Re){const we=x.g(Re);return we?{rejectReason:we,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(N,$,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(N),he=l.Position.to($);try{const Se=await this.e.prepareRename(Z,he,X);let Re,we;if(R.Range.isRange(Se)?(Re=Se,we=Z.getText(Se)):(0,k.isObject)(Se)&&(Re=Se.range,we=Se.placeholder),!Re||!we)return;if(Re.start.line>he.line||Re.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Re),text:we}}catch(Se){const Re=x.g(Se);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(Se)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class fe{constructor(N,$){this.resultId=N,this.tokens=$}}class re{constructor(N,$){this.f=N,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,$,X){const Z=this.f.getDocument(N),he=$!==0?this.d.get($):null;let Se=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,he.resultId,X):await this.g.provideDocumentSemanticTokens(Z,X);return he&&this.d.delete($),Se?(Se=re.h(Se),this.o(re.n(he,Se),Se)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return re.j(N)?re.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):re.l(N)?re.m(N)?N:new R.SemanticTokensEdits(N.edits.map($=>new R.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const $ of N.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(N,$){if(!re.j($)||!N||!N.tokens)return $;const X=N.tokens,Z=X.length,he=$.data,Se=he.length;let Re=0;const we=Math.min(Z,Se);for(;Re<we&&X[Re]===he[Re];)Re++;if(Re===Z&&Re===Se)return new R.SemanticTokensEdits([],$.resultId);let Te=0;const ke=we-Re;for(;Te<ke&&X[Z-Te-1]===he[Se-Te-1];)Te++;return new R.SemanticTokensEdits([{start:Re,deleteCount:Z-Re-Te,data:he.subarray(Re,Se-Te)}],$.resultId)}o(N,$){if(re.j(N)){const X=this.e++;return this.d.set(X,new fe(N.resultId,N.data)),(0,E.encodeSemanticTokensDto)({id:X,type:"full",data:N.data})}if(re.l(N)){const X=this.e++;return re.j($)?this.d.set(X,new fe($.resultId,$.data)):this.d.set(X,new fe(N.resultId)),(0,E.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(N.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class V{constructor(N,$){this.d=N,this.e=$}async provideDocumentRangeSemanticTokens(N,$,X){const Z=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(Z,l.Range.to($),X);return he?this.f(he):null}f(N){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class _{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,$,X,Z,he){this.f=N,this.g=$,this.h=X,this.j=Z,this.k=he,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,$,X,Z){const he=this.f.getDocument(N),Se=l.Position.to($),Re=he.getWordRangeAtPosition(Se)||new R.Range(Se,Se),we=Re.with({end:Se}),Te=new h.StopWatch(!0),ke=await this.h.provideCompletionItems(he,Se,Z,l.CompletionContext.to(X));if(!ke||Z.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,We=_.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),tt=new I.DisposableStore;this.e.set(We,tt);const Ye=[],nt={x:We,b:Ye,a:{replace:l.Range.from(Re),insert:l.Range.from(we)},c:je.isIncomplete||void 0,d:Te.elapsed()};for(let st=0;st<je.items.length;st++){const Be=je.items[st],it=this.l(Be,[We,st],we,Re);Ye.push(it)}return nt}async resolveCompletionItem(N,$){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...N);if(!X)return;const Z=await this.h.resolveCompletionItem(X,$);if(!!Z)return this.l(Z,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,$,X,Z){const he=this.e.get($[0]);if(!he)throw Error("DisposableStore is missing...");const Se=this.g.toInternal(N.command,he),Re={x:$,a:N.label,b:N.kind!==void 0?l.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(l.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:l.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(l.TextEdit.from),n:Se?.$ident,o:Se?.id,p:Se?.$ident?void 0:Se?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=N.textEdit.newText):typeof N.insertText=="string"?Re.h=N.insertText:N.insertText instanceof R.SnippetString&&(Re.h=N.insertText.value,Re.i|=4);let we;return N.textEdit?we=N.textEdit.range:N.range&&(we=N.range),R.Range.isRange(we)?Re.j=l.Range.from(we):we&&(!X?.isEqual(we.inserting)||!Z?.isEqual(we.replacing))&&(Re.j={insert:l.Range.from(we.inserting),replace:l.Range.from(we.replacing)}),Re}}class te{async provideInlineCompletions(N,$,X,Z){}disposeCompletions(N){}handleDidShowCompletionItem(N,$){}handlePartialAccept(N,$,X){}}class ve extends te{constructor(N,$,X,Z){super(),this.f=N,this.g=$,this.h=X,this.j=Z,this.d=new le,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,$,X,Z){const he=this.g.getDocument(N),Se=l.Position.to($),Re=await this.h.provideInlineCompletionItems(he,Se,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:l.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Z);if(!Re||Z.isCancellationRequested)return;const we=Array.isArray(Re)?Re:Re.items,Te=this.e?Array.isArray(Re)?[]:Re.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:we}),items:we.map((We,tt)=>{let Ye;We.command&&(ke||(ke=new I.DisposableStore),Ye=this.j.toInternal(We.command,ke));const nt=We.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:We.filterText,range:We.range?l.Range.from(We.range):void 0,command:Ye,idx:tt,completeBracketPairs:this.e?We.completeBracketPairs:!1}}),commands:Te.map(We=>(ke||(ke=new I.DisposableStore),this.j.toInternal(We,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,$){const X=this.d.get(N)?.items[$];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X)}handlePartialAccept(N,$,X){const Z=this.d.get(N)?.items[$];Z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Z,X)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const $=this.e++;return this.d.set($,N),$}disposeReferenceId(N){const $=this.d.get(N);return this.d.delete(N),$}get(N){return this.d.get(N)}}class ue{constructor(N,$){this.e=N,this.f=$,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(N,$,X,Z){const he=this.e.getDocument(N),Se=l.Position.to($),Re=this.g(X),we=await this.f.provideSignatureHelp(he,Se,Z,Re);if(we){const Te=this.d.add([we]);return{...l.SignatureHelp.from(we),id:Te}}}g(N){let $;if(N.activeSignatureHelp){const X=l.SignatureHelp.to(N.activeSignatureHelp),Z=this.d.get(N.activeSignatureHelp.id,0);Z?($=Z,$.activeSignature=X.activeSignature,$.activeParameter=X.activeParameter):$=X}return{...N,activeSignatureHelp:$}}releaseSignatureHelp(N){this.d.delete(N)}}class q{constructor(N,$,X,Z,he){this.f=N,this.g=$,this.h=X,this.j=Z,this.k=he,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,$,X){const Z=this.f.getDocument(N),he=l.Range.to($),Se=await this.h.provideInlayHints(Z,he,X);if(!Array.isArray(Se)||Se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(X.isCancellationRequested)return;const Re=this.d.add(Se);this.e.set(Re,new I.DisposableStore);const we={hints:[],cacheId:Re};for(let Te=0;Te<Se.length;Te++)this.l(Se[Te],he)&&we.hints.push(this.m(Se[Te],[Re,Te]));return this.j.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),we}async resolveInlayHint(N,$){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...N);if(!X)return;const Z=await this.h.resolveInlayHint(X,$);if(!!Z&&!!this.l(Z))return this.m(Z,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,$){return N.label.length===0||Array.isArray(N.label)&&N.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!($&&!$.contains(N.position))}m(N,$){const X=this.e.get($[0]);if(!X)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:$,tooltip:l.MarkdownString.fromStrict(N.tooltip),position:l.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(l.TextEdit.from),kind:N.kind&&l.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Z.label=N.label:Z.label=N.label.map(he=>{const Se={label:he.value};return Se.tooltip=l.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(Se.location=l.location.from(he.location)),he.command&&(Se.command=this.g.toInternal(he.command,X)),Se}),Z}}class F{constructor(N,$){this.e=N,this.f=$,this.d=new d.Cache("DocumentLink")}async provideLinks(N,$){const X=this.e.getDocument(N),Z=await this.f.provideDocumentLinks(X,$);if(!(!Array.isArray(Z)||Z.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(F.g).map(l.DocumentLink.from)};{const he=this.d.add(Z),Se={links:[],cacheId:he};for(let Re=0;Re<Z.length;Re++){if(!F.g(Z[Re]))continue;const we=l.DocumentLink.from(Z[Re]);we.cacheId=[he,Re],Se.links.push(we)}return Se}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,$){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...N);if(!X)return;const Z=await this.f.resolveDocumentLink(X,$);if(!(!Z||!F.g(Z)))return l.DocumentLink.from(Z)}releaseLinks(N){this.d.delete(N)}}class J{constructor(N,$){this.d=N,this.e=$}async provideColors(N,$){const X=this.d.getDocument(N),Z=await this.e.provideDocumentColors(X,$);return Array.isArray(Z)?Z.map(Se=>({color:l.Color.from(Se.color),range:l.Range.from(Se.range)})):[]}async provideColorPresentations(N,$,X){const Z=this.d.getDocument(N),he=l.Range.to($.range),Se=l.Color.to($.color),Re=await this.e.provideColorPresentations(Se,{document:Z,range:he},X);if(!!Array.isArray(Re))return Re.map(l.ColorPresentation.from)}}class ge{constructor(N,$){this.d=N,this.e=$}async provideFoldingRanges(N,$,X){const Z=this.d.getDocument(N),he=await this.e.provideFoldingRanges(Z,$,X);if(!!Array.isArray(he))return he.map(l.FoldingRange.from)}}class Ee{constructor(N,$,X){this.d=N,this.e=$,this.f=X}async provideSelectionRanges(N,$,X){const Z=this.d.getDocument(N),he=$.map(l.Position.to),Se=await this.e.provideSelectionRanges(Z,he,X);if(!(0,O.isNonEmptyArray)(Se))return[];if(Se.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let we=0;we<he.length;we++){const Te=[];Re.push(Te);let ke=he[we],je=Se[we];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Te.push(l.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Re}}class ie{constructor(N,$){this.f=N,this.g=$,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(N,$,X){const Z=this.f.getDocument(N),he=l.Position.to($),Se=await this.g.prepareCallHierarchy(Z,he,X);if(!Se)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(Se)?Se.map(we=>this.h(Re,we)):[this.h(Re,Se)]}async provideCallsTo(N,$,X){const Z=this.j(N,$);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Z,X);if(!!he)return he.map(Se=>({from:this.h(N,Se.from),fromRanges:Se.fromRanges.map(Re=>l.Range.from(Re))}))}async provideCallsFrom(N,$,X){const Z=this.j(N,$);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Z,X);if(!!he)return he.map(Se=>({to:this.h(N,Se.to),fromRanges:Se.fromRanges.map(Re=>l.Range.from(Re))}))}releaseSession(N){this.e.delete(N)}h(N,$){const X=this.e.get(N),Z=l.CallHierarchyItem.from($,N,X.size.toString(36));return X.set(Z._itemId,$),Z}j(N,$){return this.e.get(N)?.get($)}}class ne{constructor(N,$){this.f=N,this.g=$,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(N,$,X){const Z=this.f.getDocument(N),he=l.Position.to($),Se=await this.g.prepareTypeHierarchy(Z,he,X);if(!Se)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(Se)?Se.map(we=>this.h(Re,we)):[this.h(Re,Se)]}async provideSupertypes(N,$,X){const Z=this.j(N,$);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Z,X);if(!!he)return he.map(Se=>this.h(N,Se))}async provideSubtypes(N,$,X){const Z=this.j(N,$);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Z,X);if(!!he)return he.map(Se=>this.h(N,Se))}releaseSession(N){this.e.delete(N)}h(N,$){const X=this.e.get(N),Z=l.TypeHierarchyItem.from($,N,X.size.toString(36));return X.set(Z._itemId,$),Z}j(N,$){return this.e.get(N)?.get($)}}class de{constructor(N,$,X,Z){this.d=N,this.e=$,this.f=X,this.g=Z}async provideDocumentOnDropEdits(N,$,X,Z,he){const Se=this.e.getDocument($),Re=l.Position.to(X),we=l.DataTransfer.toDataTransfer(Z,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),Te=await this.f.provideDocumentDropEdits(Se,Re,we,he);if(!!Te)return{insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?l.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class ee{constructor(N,$){this.adapter=N,this.extension=$}}class ce{constructor(N,$,X,Z,he,Se,Re,we){this.g=$,this.h=X,this.j=Z,this.k=he,this.l=Se,this.m=Re,this.n=we,this.f=new Map,this.e=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(N){return l.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,$,X,Z,he,Se=!1){const Re=this.f.get(N);if(!Re||!(Re.adapter instanceof $))return Z;const we=Date.now();Se||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Te=X(Re.adapter,Re.extension);return Promise.resolve(Te).catch(ke=>{(0,w.isCancellationError)(ke)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Re.extension.identifier,ke))}).finally(()=>{Se||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),C.CancellationToken.isCancellationToken(he)?(0,y.raceCancellationError)(Te,he):Te}t(N,$){const X=this.q();return this.f.set(X,new ee(N,$)),X}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,$,X,Z){const he=this.t(new t(this.h,X),N),Se=Z&&Z.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o($),Se),this.p(he)}$provideDocumentSymbols(N,$,X){return this.s(N,t,Z=>Z.provideDocumentSymbols(a.URI.revive($),X),void 0,X)}registerCodeLensProvider(N,$,X){const Z=this.q(),he=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new ee(new o(this.h,this.j.converter,X),N)),this.e.$registerCodeLensSupport(Z,this.o($),he);let Se=this.p(Z);if(he!==void 0){const Re=X.onDidChangeCodeLenses(we=>this.e.$emitCodeLensEvent(he));Se=R.Disposable.from(Se,Re)}return Se}$provideCodeLenses(N,$,X){return this.s(N,o,Z=>Z.provideCodeLenses(a.URI.revive($),X),void 0,X)}$resolveCodeLens(N,$,X){return this.s(N,o,Z=>Z.resolveCodeLens($,X),void 0,void 0)}$releaseCodeLenses(N,$){this.s(N,o,X=>Promise.resolve(X.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(N,$,X){const Z=this.t(new c(this.h,X),N);return this.e.$registerDefinitionSupport(Z,this.o($)),this.p(Z)}$provideDefinition(N,$,X,Z){return this.s(N,c,he=>he.provideDefinition(a.URI.revive($),X,Z),[],Z)}registerDeclarationProvider(N,$,X){const Z=this.t(new m(this.h,X),N);return this.e.$registerDeclarationSupport(Z,this.o($)),this.p(Z)}$provideDeclaration(N,$,X,Z){return this.s(N,m,he=>he.provideDeclaration(a.URI.revive($),X,Z),[],Z)}registerImplementationProvider(N,$,X){const Z=this.t(new f(this.h,X),N);return this.e.$registerImplementationSupport(Z,this.o($)),this.p(Z)}$provideImplementation(N,$,X,Z){return this.s(N,f,he=>he.provideImplementation(a.URI.revive($),X,Z),[],Z)}registerTypeDefinitionProvider(N,$,X){const Z=this.t(new i(this.h,X),N);return this.e.$registerTypeDefinitionSupport(Z,this.o($)),this.p(Z)}$provideTypeDefinition(N,$,X,Z){return this.s(N,i,he=>he.provideTypeDefinition(a.URI.revive($),X,Z),[],Z)}registerHoverProvider(N,$,X,Z){const he=this.t(new s(this.h,X),N);return this.e.$registerHoverProvider(he,this.o($)),this.p(he)}$provideHover(N,$,X,Z){return this.s(N,s,he=>he.provideHover(a.URI.revive($),X,Z),void 0,Z)}registerEvaluatableExpressionProvider(N,$,X,Z){const he=this.t(new u(this.h,X),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o($)),this.p(he)}$provideEvaluatableExpression(N,$,X,Z){return this.s(N,u,he=>he.provideEvaluatableExpression(a.URI.revive($),X,Z),void 0,Z)}registerInlineValuesProvider(N,$,X,Z){const he=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,Se=this.t(new b(this.h,X),N);this.e.$registerInlineValuesProvider(Se,this.o($),he);let Re=this.p(Se);if(he!==void 0){const we=X.onDidChangeInlineValues(Te=>this.e.$emitInlineValuesEvent(he));Re=R.Disposable.from(Re,we)}return Re}$provideInlineValues(N,$,X,Z,he){return this.s(N,b,Se=>Se.provideInlineValues(a.URI.revive($),X,Z,he),void 0,he)}registerDocumentHighlightProvider(N,$,X){const Z=this.t(new g(this.h,X),N);return this.e.$registerDocumentHighlightProvider(Z,this.o($)),this.p(Z)}$provideDocumentHighlights(N,$,X,Z){return this.s(N,g,he=>he.provideDocumentHighlights(a.URI.revive($),X,Z),void 0,Z)}registerLinkedEditingRangeProvider(N,$,X){const Z=this.t(new L(this.h,X),N);return this.e.$registerLinkedEditingRangeProvider(Z,this.o($)),this.p(Z)}$provideLinkedEditingRanges(N,$,X,Z){return this.s(N,L,async he=>{const Se=await he.provideLinkedEditingRanges(a.URI.revive($),X,Z);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?ce.w(Se.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(N,$,X){const Z=this.t(new j(this.h,X),N);return this.e.$registerReferenceSupport(Z,this.o($)),this.p(Z)}$provideReferences(N,$,X,Z,he){return this.s(N,j,Se=>Se.provideReferences(a.URI.revive($),X,Z,he),void 0,he)}registerCodeActionProvider(N,$,X,Z){const he=new I.DisposableStore,Se=this.t(new G(this.h,this.j.converter,this.k,X,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(Se,this.o($),{providedKinds:Z?.providedCodeActionKinds?.map(Re=>Re.value),documentation:Z?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,he)}))},ce.u(N),Boolean(X.resolveCodeAction)),he.add(this.p(Se)),he}$provideCodeActions(N,$,X,Z,he){return this.s(N,G,Se=>Se.provideCodeActions(a.URI.revive($),X,Z,he),void 0,he)}$resolveCodeAction(N,$,X){return this.s(N,G,Z=>Z.resolveCodeAction($,X),void 0,void 0)}$releaseCodeActions(N,$){this.s(N,G,X=>Promise.resolve(X.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(N,$,X){const Z=this.t(new B(this.h,X),N);return this.e.$registerDocumentFormattingSupport(Z,this.o($),N.identifier,N.displayName||N.name),this.p(Z)}$provideDocumentFormattingEdits(N,$,X,Z){return this.s(N,B,he=>he.provideDocumentFormattingEdits(a.URI.revive($),X,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(N,$,X){const Z=this.t(new U(this.h,X),N);return this.e.$registerRangeFormattingSupport(Z,this.o($),N.identifier,N.displayName||N.name),this.p(Z)}$provideDocumentRangeFormattingEdits(N,$,X,Z,he){return this.s(N,U,Se=>Se.provideDocumentRangeFormattingEdits(a.URI.revive($),X,Z,he),void 0,he)}registerOnTypeFormattingEditProvider(N,$,X,Z){const he=this.t(new z(this.h,X),N);return this.e.$registerOnTypeFormattingSupport(he,this.o($),Z,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,$,X,Z,he,Se){return this.s(N,z,Re=>Re.provideOnTypeFormattingEdits(a.URI.revive($),X,Z,he,Se),void 0,Se)}registerWorkspaceSymbolProvider(N,$){const X=this.t(new M($,this.l),N);return this.e.$registerNavigateTypeSupport(X,typeof $.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(N,$,X){return this.s(N,M,Z=>Z.provideWorkspaceSymbols($,X),{symbols:[]},X)}$resolveWorkspaceSymbol(N,$,X){return this.s(N,M,Z=>Z.resolveWorkspaceSymbol($,X),void 0,void 0)}$releaseWorkspaceSymbols(N,$){this.s(N,M,X=>X.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(N,$,X){const Z=this.t(new x(this.h,X,this.l),N);return this.e.$registerRenameSupport(Z,this.o($),x.supportsResolving(X)),this.p(Z)}$provideRenameEdits(N,$,X,Z,he){return this.s(N,x,Se=>Se.provideRenameEdits(a.URI.revive($),X,Z,he),void 0,he)}$resolveRenameLocation(N,$,X,Z){return this.s(N,x,he=>he.resolveRenameLocation(a.URI.revive($),X,Z),void 0,Z)}registerDocumentSemanticTokensProvider(N,$,X,Z){const he=this.t(new re(this.h,X),N),Se=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o($),Z,Se);let Re=this.p(he);if(Se){const we=X.onDidChangeSemanticTokens(Te=>this.e.$emitDocumentSemanticTokensEvent(Se));Re=R.Disposable.from(Re,we)}return Re}$provideDocumentSemanticTokens(N,$,X,Z){return this.s(N,re,he=>he.provideDocumentSemanticTokens(a.URI.revive($),X,Z),null,Z)}$releaseDocumentSemanticTokens(N,$){this.s(N,re,X=>X.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,$,X,Z){const he=this.t(new V(this.h,X),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o($),Z),this.p(he)}$provideDocumentRangeSemanticTokens(N,$,X,Z){return this.s(N,V,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive($),X,Z),null,Z)}registerCompletionItemProvider(N,$,X,Z){const he=this.t(new _(this.h,this.j.converter,X,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o($),Z,_.supportsResolving(X),`${N.identifier.value}(${Z.join("")})`),this.p(he)}$provideCompletionItems(N,$,X,Z,he){return this.s(N,_,Se=>Se.provideCompletionItems(a.URI.revive($),X,Z,he),void 0,he)}$resolveCompletionItem(N,$,X){return this.s(N,_,Z=>Z.resolveCompletionItem($,X),void 0,X)}$releaseCompletionItems(N,$){this.s(N,_,X=>X.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(N,$,X){const Z=new ve(N,this.h,X,this.j.converter),he=this.t(Z,N);return this.e.$registerInlineCompletionsSupport(he,this.o($),Z.supportsHandleEvents),this.p(he)}$provideInlineCompletions(N,$,X,Z,he){return this.s(N,te,Se=>Se.provideInlineCompletions(a.URI.revive($),X,Z,he),void 0,he)}$handleInlineCompletionDidShow(N,$,X){this.s(N,te,async Z=>{Z.handleDidShowCompletionItem($,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,$,X,Z){this.s(N,te,async he=>{he.handlePartialAccept($,X,Z)},void 0,void 0)}$freeInlineCompletionsList(N,$){this.s(N,te,async X=>{X.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(N,$,X,Z){const he=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,Se=this.t(new ue(this.h,X),N);return this.e.$registerSignatureHelpProvider(Se,this.o($),he),this.p(Se)}$provideSignatureHelp(N,$,X,Z,he){return this.s(N,ue,Se=>Se.provideSignatureHelp(a.URI.revive($),X,Z,he),void 0,he)}$releaseSignatureHelp(N,$){this.s(N,ue,X=>X.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(N,$,X){const Z=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new q(this.h,this.j.converter,X,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o($),typeof X.resolveInlayHint=="function",Z,ce.u(N));let Se=this.p(he);if(Z!==void 0){const Re=X.onDidChangeInlayHints(we=>this.e.$emitInlayHintsEvent(Z));Se=R.Disposable.from(Se,Re)}return Se}$provideInlayHints(N,$,X,Z){return this.s(N,q,he=>he.provideInlayHints(a.URI.revive($),X,Z),void 0,Z)}$resolveInlayHint(N,$,X){return this.s(N,q,Z=>Z.resolveInlayHint($,X),void 0,X)}$releaseInlayHints(N,$){this.s(N,q,X=>X.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(N,$,X){const Z=this.t(new F(this.h,X),N);return this.e.$registerDocumentLinkProvider(Z,this.o($),typeof X.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(N,$,X){return this.s(N,F,Z=>Z.provideLinks(a.URI.revive($),X),void 0,X,$.scheme==="output")}$resolveDocumentLink(N,$,X){return this.s(N,F,Z=>Z.resolveLink($,X),void 0,void 0,!0)}$releaseDocumentLinks(N,$){this.s(N,F,X=>X.releaseLinks($),void 0,void 0,!0)}registerColorProvider(N,$,X){const Z=this.t(new J(this.h,X),N);return this.e.$registerDocumentColorProvider(Z,this.o($)),this.p(Z)}$provideDocumentColors(N,$,X){return this.s(N,J,Z=>Z.provideColors(a.URI.revive($),X),[],X)}$provideColorPresentations(N,$,X,Z){return this.s(N,J,he=>he.provideColorPresentations(a.URI.revive($),X,Z),void 0,Z)}registerFoldingRangeProvider(N,$,X){const Z=this.q(),he=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new ee(new ge(this.h,X),N)),this.e.$registerFoldingRangeProvider(Z,this.o($),N.identifier,he);let Se=this.p(Z);if(he!==void 0){const Re=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));Se=R.Disposable.from(Se,Re)}return Se}$provideFoldingRanges(N,$,X,Z){return this.s(N,ge,he=>he.provideFoldingRanges(a.URI.revive($),X,Z),void 0,Z)}registerSelectionRangeProvider(N,$,X){const Z=this.t(new Ee(this.h,X,this.l),N);return this.e.$registerSelectionRangeProvider(Z,this.o($)),this.p(Z)}$provideSelectionRanges(N,$,X,Z){return this.s(N,Ee,he=>he.provideSelectionRanges(a.URI.revive($),X,Z),[],Z)}registerCallHierarchyProvider(N,$,X){const Z=this.t(new ie(this.h,X),N);return this.e.$registerCallHierarchyProvider(Z,this.o($)),this.p(Z)}$prepareCallHierarchy(N,$,X,Z){return this.s(N,ie,he=>Promise.resolve(he.prepareSession(a.URI.revive($),X,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(N,$,X,Z){return this.s(N,ie,he=>he.provideCallsTo($,X,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(N,$,X,Z){return this.s(N,ie,he=>he.provideCallsFrom($,X,Z),void 0,Z)}$releaseCallHierarchy(N,$){this.s(N,ie,X=>Promise.resolve(X.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(N,$,X){const Z=this.t(new ne(this.h,X),N);return this.e.$registerTypeHierarchyProvider(Z,this.o($)),this.p(Z)}$prepareTypeHierarchy(N,$,X,Z){return this.s(N,ne,he=>Promise.resolve(he.prepareSession(a.URI.revive($),X,Z)),void 0,Z)}$provideTypeHierarchySupertypes(N,$,X,Z){return this.s(N,ne,he=>he.provideSupertypes($,X,Z),void 0,Z)}$provideTypeHierarchySubtypes(N,$,X,Z){return this.s(N,ne,he=>he.provideSubtypes($,X,Z),void 0,Z)}$releaseTypeHierarchy(N,$){this.s(N,ne,X=>Promise.resolve(X.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(N,$,X){const Z=this.q();return this.f.set(Z,new ee(new de(this.e,this.h,X,Z),N)),this.e.$registerDocumentOnDropEditProvider(Z,this.o($)),this.p(Z)}$provideDocumentOnDropEdits(N,$,X,Z,he,Se){return this.s(N,de,Re=>Promise.resolve(Re.provideDocumentOnDropEdits($,a.URI.revive(X),Z,he,Se)),void 0,void 0)}registerDocumentPasteEditProvider(N,$,X,Z){const he=this.q();return this.f.set(he,new ee(new Q(this.e,this.h,X,he),N)),this.e.$registerPasteEditProvider(he,this.o($),!!X.prepareDocumentPaste,Z.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,$,X,Z,he){return this.s(N,Q,Se=>Se.prepareDocumentPaste(a.URI.revive($),X,Z,he),void 0,he)}$providePasteEdits(N,$,X,Z,he,Se){return this.s(N,Q,Re=>Re.providePasteEdits($,a.URI.revive(X),Z,he,Se),void 0,Se)}static w(N){return{pattern:N.source,flags:(0,D.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,$,X){const{wordPattern:Z}=X;if(Z&&(0,D.regExpLeadsToEndlessLoop)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor($,Z):this.h.setWordDefinitionFor($,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),Se={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?ce.w(X.wordPattern):void 0,indentationRules:X.indentationRules?ce.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?ce.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this.e.$setLanguageConfiguration(he,$,Se),this.p(he)}$setWordDefinitions(N){for(const $ of N)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(Ie[274],Ce([1,0,5,11,7,38,19,6]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(O,k,S,C){this.c=k,this.d=S,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,k){await this.a.$changeLanguage(O,k);const S=this.c.getDocumentData(O);if(!S)throw new Error(`document '${O.toString()}' NOT found`);return S.document}async tokenAtPosition(O,k){const S=O.version,C=A.Position.from(k),I=await this.a.$tokensAtPosition(O.uri,C),E={type:l.StandardTokenType.Other,range:O.getWordRangeAtPosition(k)??new l.Range(k.line,k.character,k.line,k.character)};if(!I)return E;const n={range:A.Range.to(I.range),type:A.TokenType.to(I.type)};return!n.range.contains(k)||S!==O.version?E:n}createLanguageStatusItem(O,k,S){const C=this.f++,I=this.a,E=this.g,n=`${O.identifier.value}/${k}`;if(E.has(n))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);E.add(n);const d={selector:S,id:k,name:O.displayName??O.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const w=new T.DisposableStore,y=()=>{h?.dispose(),h=(0,P.disposableTimeout)(()=>{w.clear(),this.a.$setLanguageStatus(C,{id:n,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:A.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?R.default.Error:d.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this.d.toInternal(d.command,w),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},p={dispose(){w.dispose(),h?.dispose(),I.$removeLanguageStatus(C),E.delete(n)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,y()},get selector(){return d.selector},set selector(t){d.selector=t,y()},get text(){return d.text},set text(t){d.text=t,y()},get detail(){return d.detail},set detail(t){d.detail=t,y()},get severity(){return d.severity},set severity(t){d.severity=t,y()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,y()},get command(){return d.command},set command(t){d.command=t,y()},get busy(){return d.busy},set busy(t){d.busy=t,y()}};return y(),p}}e.ExtHostLanguages=D}),define(Ie[98],Ce([1,0,14,9,2,4,16,5,26,20]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(S,C,I){this.f=I,this.d=new Map,this.a=C.getProxy(T.MainContext.MainThreadLocalization),this.b=S.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(S,C){const{message:I,args:E,comment:n}=C;if(this.c)return(0,A.format2)(I,E??{});let d=I;n&&n.length>0&&(d+=`/${Array.isArray(n)?n.join(""):n}`);const h=this.d.get(S)?.contents[d];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(h??I,E??{})}getBundle(S){return this.d.get(S)?.contents}getBundleUri(S){return this.d.get(S)?.uri}async initializeLocalizedMessages(S){if(this.c||!S.l10n&&!S.isBuiltin||this.d.has(S.identifier.value))return;let C;const I=await this.g(S);if(!I){this.f.error(`No bundle location found for extension ${S.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(I),n=JSON.parse(E);C=S.isBuiltin?n.contents?.bundle:n}catch(E){this.f.error(`Failed to load translations for ${S.identifier.value} from ${I}: ${E.message}`);return}C&&this.d.set(S.identifier.value,{contents:C,uri:I})}async g(S){if(S.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(S.identifier.value,this.b);return l.URI.revive(C)}return S.l10n?l.URI.joinPath(S.extensionLocation,S.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=Ve([$e(0,D.IExtHostInitDataService),$e(1,v.IExtHostRpcService),$e(2,P.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(Ie[141],Ce([1,0,16,5,26,20,2,70]),function(se,e,a,A,l,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends a.AbstractLoggerService{constructor(k,S){super(S.logLevel,S.logsLocation,S.loggers.map(C=>(0,T.revive)(C))),this.n=k.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(k,S){S?this.setLogLevel(P.URI.revive(S),k):this.setLogLevel(k)}setVisibility(k,S){super.setVisibility(k,S),this.n.$setVisibility(k,S)}m(k,S,C){return new v(this.n,k,S,C)}};D=Ve([$e(0,R.IExtHostRpcService),$e(1,l.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class v extends a.AbstractMessageLogger{constructor(k,S,C,I){super(I?.logLevel==="always"),this.m=k,this.n=S,this.k=!1,this.l=[],this.setLevel(C),this.m.$createLogger(S,I).then(()=>{this.r(this.l),this.k=!0})}g(k,S){const C=[[k,S]];this.k?this.r(C):this.l.push(...C)}r(k){this.m.$log(this.n,k)}flush(){this.m.$flush(this.n)}}}),define(Ie[275],Ce([1,0,5,16,27]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(T){return T&&T.title}let P=class{constructor(D,v){this.b=v,this.a=D.getProxy(a.MainContext.MainThreadMessageService)}showMessage(D,v,O,k,S){const C={source:{identifier:D.identifier,label:D.displayName||D.name}};let I;typeof k=="string"||R(k)?I=[k,...S]:(C.modal=k?.modal,C.useCustom=k?.useCustom,C.detail=k?.detail,I=S),C.useCustom&&(0,l.checkProposedApiEnabled)(D,"resolvers");const E=[];for(let n=0;n<I.length;n++){const d=I[n];if(typeof d=="string")E.push({title:d,handle:n,isCloseAffordance:!1});else if(typeof d=="object"){const{title:h,isCloseAffordance:w}=d;E.push({title:h,isCloseAffordance:!!w,handle:n})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(v,O,C,E).then(n=>{if(typeof n=="number")return I[n]})}};P=Ve([$e(1,A.ILogService)],P),e.ExtHostMessageService=P}),define(Ie[276],Ce([1,0,22,3,6,28,9,10,2,75,5,41,11,7,58,247,137,8]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(y=>y.apiEditor)}constructor(y,p,t,o){this.q=t,this.r=o,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new v.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=y.getProxy(O.MainContext.MainThreadNotebook),this.c=y.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=y.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const c=r.notebookEditor?.notebookUri,m=r.cell.handle,i=this.g.get(c)?.getCell(m);if(i)return i.apiCell}if(r&&r.$mid===14){const c=r.uri,m=this.g.get(c);if(m)return m.apiNotebook}return r}}),h.x(p)}getEditorById(y){const p=this.h.get(y);if(!p)throw new Error(`unknown text editor: ${y}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(y){for(const[p,t]of this.h)if(t.apiEditor===y)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(y,p){const t=this.g.get(y);if(!t&&!p)throw new Error(`NO notebook document for '${y}'`);return t}static s(y,p){if(!p)return;const t=p.filenamePattern.map(o=>S.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(p.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:p.displayName,filenamePattern:t,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(y,p,t){const o=h.a++,r=typeof t.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(o,t),this.b.$registerNotebookCellStatusBarItemProvider(o,r,p);let c;return r!==void 0&&(c=t.onDidChangeCellStatusBarItems(m=>this.b.$emitCellStatusBarEvent(r))),new C.Disposable(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,r),c?.dispose()})}async createNotebookDocument(y){const p=await this.c.$tryCreateNotebook({viewType:y.viewType,content:y.content&&S.NotebookData.from(y.content)});return D.URI.revive(p)}async openNotebookDocument(y){const p=this.g.get(y);if(p)return p.apiNotebook;const t=await this.c.$tryOpenNotebook(y),o=this.g.get(D.URI.revive(t));return(0,T.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(y,p){D.URI.isUri(y)&&(y=await this.openNotebookDocument(y));let t;typeof p=="object"?t={position:S.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(S.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:t={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(y.uri,y.notebookType,t),r=o&&this.h.get(o)?.apiEditor;if(r)return r;throw o?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,p,t,o){const r=this.f.get(y),c=D.URI.revive(p),m=this.g.get(c);if(!m||!r)return;const f=m.getCellFromIndex(t);if(!f)return;const i=await r.provideCellStatusBarItems(f.apiCell,o);if(!i)return;const s=new l.DisposableStore,u=this.p.add([s]),g=(Array.isArray(i)?i:[i]).map(L=>S.NotebookStatusBarItem.from(L,this.i,s));return{cacheId:u,items:g}}$releaseNotebookCellStatusBarItems(y){this.p.delete(y)}registerNotebookSerializer(y,p,t,o,r){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,t),this.b.$registerNotebookSerializer(c,{id:y.identifier,location:y.extensionLocation},p,S.NotebookDocumentContentOptions.from(o),h.s(y,r)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(y,p,t){const o=this.u.get(y);if(!o)throw new Error("NO serializer found");const r=await o.deserializeNotebook(p.buffer,t);return new I.SerializableObjectWithBuffers(S.NotebookData.from(r))}async $notebookToData(y,p,t){const o=this.u.get(y);if(!o)throw new Error("NO serializer found");const r=await o.serializeNotebook(S.NotebookData.to(p.value),t);return a.VSBuffer.wrap(r)}w(y,p,t){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const o=new n.ExtHostNotebookEditor(p,this.d,y,t.visibleRanges.map(S.NotebookRange.to),t.selections.map(S.NotebookRange.to),typeof t.viewColumn=="number"?S.ViewColumn.to(t.viewColumn):void 0);this.h.set(p,o)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const t of y.value.removedDocuments){const o=D.URI.revive(t),r=this.g.get(o);r&&(r.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(r.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===o.toString()&&this.h.delete(c.id)}if(y.value.addedDocuments){const t=[];for(const o of y.value.addedDocuments){const r=D.URI.revive(o.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const c=new E.ExtHostNotebookDocument(this.c,this.q,this.r,r,o);t.push(...o.cells.map(m=>E.ExtHostCell.asModelAddData(c.apiNotebook,m))),this.g.get(r)?.dispose(),this.g.set(r,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(c.apiNotebook)}}if(y.value.addedEditors)for(const t of y.value.addedEditors){if(this.h.has(t.id))return;const o=D.URI.revive(t.documentUri),r=this.g.get(o);r&&this.w(r,t.id,t)}const p=[];if(y.value.removedEditors)for(const t of y.value.removedEditors){const o=this.h.get(t);o&&(this.h.delete(t),this.k?.id===o.id&&(this.k=void 0),p.push(o))}if(y.value.visibleEditors){this.l=y.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const t=new Set;this.l.forEach(o=>t.add(o.id));for(const o of this.h.values()){const r=t.has(o.id);o._acceptVisibility(r)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this.k=void 0:y.value.newActiveEditor&&(this.h.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this.k=this.h.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(y){const p=k.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new k.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>a.VSBuffer.wrap(r))],new k.ApiCommandResult("Notebook Data",r=>S.NotebookData.to(r.value))),o=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new I.SerializableObjectWithBuffers(S.NotebookData.from(r)))],new k.ApiCommandResult("Bytes",r=>r.buffer));y.registerApiCommand(t),y.registerApiCommand(o)}}h.a=0,e.ExtHostNotebookController=h}),define(Ie[277],Ce([1,0,17,19,21,3,6,28,2,25,16,75,5,41,11,7,96,237,27,58]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(m,f,i,s,u){this.k=f,this.l=i,this.m=s,this.n=u,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new k.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=m.getProxy(S.MainContext.MainThreadNotebookKernels);const b=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",g=>!0,g=>{if(g&&"notebookEditor"in g&&"id"in g){const L=this.l.getIdByEditor(g.notebookEditor);return{id:g.id,extension:g.extension,notebookEditorId:L}}else if(g&&"notebookEditor"in g){const L=this.l.getIdByEditor(g.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${g.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return g})],C.ApiCommandResult.Void);this.m.registerApiCommand(b)}createNotebookController(m,f,i,s,u,b){for(const te of this.h.values())if(te.controller.id===f&&v.ExtensionIdentifier.equals(m.identifier,te.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const g=this.i++,L=this;this.n.trace(`NotebookController[${g}], CREATED by ${m.identifier.value}, ${f}`);const j=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${m.identifier}'`);let G=!1;const Q=new P.DisposableStore,B=new R.Emitter,U=new R.Emitter,z={id:r(m.identifier,f),notebookType:i,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:s||m.identifier.value,preloads:b?b.map(I.NotebookRendererScript.from):[]};let M=u??j,x;this.a.$addKernel(g,z).catch(te=>{console.log(te),G=!0});let fe=0;const re=()=>{if(G)return;const te=++fe;Promise.resolve().then(()=>{te===fe&&this.a.$updateKernel(g,z)})},V=new T.ResourceMap,_={get id(){return f},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return z.label},set label(te){z.label=te??m.displayName??m.name,re()},get detail(){return z.detail??""},set detail(te){z.detail=te,re()},get description(){return z.description??""},set description(te){z.description=te,re()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(te){z.supportedLanguages=te,re()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(te){z.supportsExecutionOrder=te,re()},get rendererScripts(){return z.preloads?z.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(te){M=te??j},get interruptHandler(){return x},set interruptHandler(te){x=te,z.supportsInterrupt=Boolean(te),re()},createNotebookCellExecution(te){if(G)throw new Error("notebook controller is DISPOSED");if(!V.has(te.notebook.uri))throw L.n.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return L._createNotebookCellExecution(te,r(m.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${g}], DISPOSED`),G=!0,this.h.delete(g),Q.dispose(),B.dispose(),U.dispose(),this.a.$removeKernel(g))},updateNotebookAffinity(te,ve){ve===E.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(m,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(g,te.uri,ve)},onDidReceiveMessage:U.event,postMessage(te,ve){return(0,h.checkProposedApiEnabled)(m,"notebookMessaging"),L.a.$postMessage(g,ve&&L.l.getIdByEditor(ve),te)},asWebviewUri(te){return(0,h.checkProposedApiEnabled)(m,"notebookMessaging"),(0,n.asWebviewUri)(te,L.k.remote)}};return this.h.set(g,{extensionId:m.identifier,controller:_,onDidReceiveMessage:U,onDidChangeSelection:B,associatedNotebooks:V}),_}getIdByController(m){for(const[f,i]of this.h)if(i.controller===m)return r(i.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,f){const i=this.d++,s=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(i,f);const u={dispose:()=>{this.c.delete(i),s.a.$removeKernelDetectionTask(i)}};return this.c.set(i,u),u}registerKernelSourceActionProvider(m,f,i){const s=this.f++,u=typeof i.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,b=this;this.e.set(s,i),this.n.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(s,s,f);let g;return u!==void 0&&(g=i.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(u))),{dispose:()=>{this.e.delete(s),b.a.$removeKernelSourceActionProvider(s,s),g?.dispose()}}}async $provideKernelSourceActions(m,f){const i=this.e.get(m);if(i){const s=new P.DisposableStore;return this.g.add([s]),(await i.provideNotebookKernelSourceActions(f)??[]).map(b=>I.NotebookKernelSourceAction.from(b,this.m.converter,s))}return[]}$acceptNotebookAssociation(m,f,i){const s=this.h.get(m);if(s){const u=this.l.getNotebookDocument(D.URI.revive(f));i?s.associatedNotebooks.set(u.uri,!0):s.associatedNotebooks.delete(u.uri),this.n.trace(`NotebookController[${m}] ASSOCIATE notebook`,u.uri.toString(),i),s.onDidChangeSelection.fire({selected:i,notebook:u.apiNotebook})}}async $executeCells(m,f,i){const s=this.h.get(m);if(!s)return;const u=this.l.getNotebookDocument(D.URI.revive(f)),b=[];for(const g of i){const L=u.getCell(g);L&&b.push(L.apiCell)}try{this.n.trace(`NotebookController[${m}] EXECUTE cells`,u.uri.toString(),b.length),await s.controller.executeHandler.call(s.controller,b,u.apiNotebook,s.controller)}catch(g){this.n.error(`NotebookController[${m}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(m,f,i){const s=this.h.get(m);if(!s)return;const u=this.l.getNotebookDocument(D.URI.revive(f));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,u.apiNotebook);else for(const b of i){const g=u.getCell(b);g&&this.b.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(m,f,i){const s=this.h.get(m);if(!s)return;const u=this.l.getEditorById(f);s.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:i}))}$cellExecutionChanged(m,f,i){const u=this.l.getNotebookDocument(D.URI.revive(m)).getCell(f);if(u){const b=i?I.NotebookCellExecutionState.to(i):E.NotebookCellExecutionState.Idle;b!==void 0&&this.j.fire({cell:u.apiCell,state:b})}}_createNotebookCellExecution(m,f){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this.l.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!s)throw new Error("invalid cell");if(this.b.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const u=new t(f,s,this.a);this.b.set(s.uri,u);const b=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),b.dispose(),this.b.delete(s.uri))});return u.asApiObject()}};y=Ve([$e(4,O.ILogService)],y),e.ExtHostNotebookKernels=y;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class t extends P.Disposable{get state(){return this.f}constructor(m,f,i){super(),this.j=f,this.k=i,this.b=t.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new o(10,s=>this.m(s)),this.i=f.internalMetadata.executionOrder,this.k.$createExecution(this.b,m,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(m){await this.h.addItem(m)}async m(m){const f=Array.isArray(m)?m:[m];return this.k.$updateExecution(this.b,new w.SerializableObjectWithBuffers(f))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(m){let f=this.j;if(m&&(f=this.j.notebook.getCellFromApiCell(m)),!f)throw new Error("INVALID cell");return f.handle}s(m){return m.map(f=>{const i=E.NotebookCellOutput.ensureUniqueMimeTypes(f.items,!0);return i===f.items?I.NotebookCellOutput.from(f):I.NotebookCellOutput.from({items:i,id:f.id,metadata:f.metadata})})}async t(m,f,i){const s=this.r(f),u=this.s((0,a.asArray)(m));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:s,append:i,outputs:u})}async w(m,f,i){return m=E.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(m),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:m.map(I.NotebookCellOutputItem.from),outputId:f.id,append:i})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.j.apiCell},get executionOrder(){return m.i},set executionOrder(i){m.i=i,m.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:m.i}])},start(i){if(m.f===p.Resolved||m.f===p.Started)throw new Error("Cannot call start again");m.f=p.Started,m.c.fire(),m.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,s){if(m.f===p.Resolved)throw new Error("Cannot call resolve twice");m.f=p.Resolved,m.c.fire(),m.h.flush(),m.k.$completeExecution(m.b,new w.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:i}))},clearOutput(i){return m.n(),m.t([],i,!1)},appendOutput(i,s){return m.n(),m.t(i,s,!0)},replaceOutput(i,s){return m.n(),m.t(i,s,!1)},appendOutputItems(i,s){return m.n(),m.w(i,s,!0)},replaceOutputItems(i,s){return m.n(),m.w(i,s,!1)}})}}t.a=0;class o{constructor(m,f){this.d=m,this.e=f,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const f=this.a;return this.a=[],this.e(f).finally(()=>m.complete())}}function r(c,m){return`${c.value}/${m}`}e.createKernelId=r}),define(Ie[278],Ce([1,0,3,5,137]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(T,D){this.c=D,this.a=new Map,this.b=T.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,D,v){const O=this.c.getEditorById(T);this.a.get(D)?.fire({editor:O.apiEditor,message:v})}createRendererMessaging(T,D){if(!T.contributes?.notebookRenderer?.some(O=>O.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(O,k,S)=>this.d(D).event(O,k,S),postMessage:(O,k)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,k]=[k,O]);const S=k&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(S?.id,D,O)}}}d(T){let D=this.a.get(T);return D||(D=new a.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(T)}}),this.a.set(T,D),D)}}e.ExtHostNotebookRenderers=R}),define(Ie[279],Ce([1,0,6,10,2,27,5]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class T{constructor(v){this.b=new Map,this.a=v.getProxy(P.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,O,k){if((0,R.checkProposedApiEnabled)(v,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,k),this.a.$registerProfileContentHandler(O,k.name,k.description,v.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(v,O,k,S){const C=this.b.get(v);if(!C)throw new Error(`Unknown handler with id: ${v}`);return C.saveProfile(O,k,S)}async $readProfile(v,O,k){const S=this.b.get(v);if(!S)throw new Error(`Unknown handler with id: ${v}`);return S.readProfile((0,A.isString)(O)?O:l.URI.revive(O),k)}}e.ExtHostProfileContentHandlers=T}),define(Ie[280],Ce([1,0,2,5,19,11]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class P{constructor(D,v){this.d=v,this.c=new Map,this.b=D.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(D,v,O){const k=a.URI.revive(v),S=this.c.get(D);return S?(0,l.asPromise)(()=>S.provideOriginalResource(k,O)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(D,v,O,k){const S=P.a++;return this.c.set(S,v),this.b.$registerQuickDiffProvider(S,R.DocumentSelector.from(D,this.d),O,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(S),this.c.delete(S)}}}}P.a=0,e.ExtHostQuickDiff=P}),define(Ie[281],Ce([1,0,21,3,6,5,2,7,8,17,38,52,27,11]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function I(E,n,d){const h=E.getProxy(R.MainContext.MainThreadQuickOpen);class w{constructor(i,s){this.e=new Map,this.f=0,this.a=i,this.b=s}showQuickPick(i,s,u,b=a.CancellationToken.None){this.c=void 0;const g=Promise.resolve(s),L=++this.f,j=h.$show(L,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},b),G={},Q=j.then(()=>G);return Promise.race([Q,g]).then(B=>{if(B===G)return;const U=(0,S.isProposedApiEnabled)(i,"quickPickItemTooltip");return g.then(z=>{const M=[];for(let x=0;x<z.length;x++){const fe=z[x];typeof fe=="string"?M.push({label:fe,handle:x}):fe.kind===T.QuickPickItemKind.Separator?M.push({type:"separator",label:fe.label}):(fe.tooltip&&!U&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),M.push({label:fe.label,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:U?C.MarkdownString.fromStrict(fe.tooltip):void 0,handle:x}))}return u&&typeof u.onDidSelectItem=="function"&&(this.c=x=>{u.onDidSelectItem(z[x])}),h.$setItems(L,M),j.then(x=>{if(typeof x=="number")return z[x];if(Array.isArray(x))return x.map(fe=>z[fe])})})}).then(void 0,B=>{if(!(0,D.isCancellationError)(B))return h.$setError(L,B),Promise.reject(B)})}$onItemSelected(i){this.c?.(i)}showInput(i,s=a.CancellationToken.None){return this.d=i?.validateInput,h.$input(i,typeof this.d=="function",s).then(void 0,u=>{if(!(0,D.isCancellationError)(u))return Promise.reject(u)})}async $validateInput(i){if(!this.d)return;const s=await this.d(i);if(!s||typeof s=="string")return s;let u;switch(s.severity){case T.InputBoxValidationSeverity.Info:u=O.default.Info;break;case T.InputBoxValidationSeverity.Warning:u=O.default.Warning;break;case T.InputBoxValidationSeverity.Error:u=O.default.Error;break;default:u=s.message?O.default.Error:O.default.Ignore;break}return{content:s.message,severity:u}}async showWorkspaceFolderPick(i,s=a.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!u)return;const b=await this.a.getWorkspaceFolders2();if(!!b)return b.find(g=>g.uri.toString()===u.uri.toString())}createQuickPick(i){const s=new c(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}createInputBox(i){const s=new m(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}$onDidChangeValue(i,s){this.e.get(i)?._fireDidChangeValue(s)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,s){const u=this.e.get(i);u instanceof c&&u._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const u=this.e.get(i);u instanceof c&&u._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){this.e.get(i)?._fireDidTriggerButton(s)}$onDidTriggerItemButton(i,s,u){const b=this.e.get(i);b instanceof c&&b._fireDidTriggerItemButton(s,u)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class y{constructor(i,s){this.x=i,this.y=s,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((s,u)=>{const b=s===T.QuickInputButtons.Back?-1:u;this.o.set(b,s)}),this.z({buttons:i.map((s,u)=>({...r(s),tooltip:s.tooltip,handle:s===T.QuickInputButtons.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const s=this.o.get(i);s&&this.r.fire(s)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(i){if(!this.v){for(const s of Object.keys(i)){const u=i[s];this.u[s]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}y.a=1;function p(f){if(f instanceof T.ThemeIcon)return{id:f.id};const i=o(f),s=t(f);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof s=="string"?P.URI.file(s):s}}function t(f){return typeof f=="object"&&"light"in f?f.light:f}function o(f){return typeof f=="object"&&"dark"in f?f.dark:f}function r(f){const i=p(f.iconPath);let s,u;return"id"in i?u=k.ThemeIcon.asClassName(i):s=i,{iconPath:s,iconClass:u}}class c extends y{constructor(i,s){super(i.identifier,s),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((b,g)=>{this.C.set(g,b),this.D.set(b,g)});const s=(0,S.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),u=[];for(let b=0;b<i.length;b++){const g=i[b];g.kind===T.QuickPickItemKind.Separator?u.push({type:"separator",label:g.label}):(g.tooltip&&!s&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),u.push({handle:b,label:g.label,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:s?C.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((L,j)=>({...r(L),tooltip:L.tooltip,handle:j}))}))}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(s=>this.D.has(s)),this.z({activeItems:this.J.map(s=>this.D.get(s))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(s=>this.D.has(s)),this.z({selectedItems:this.L.map(s=>this.D.get(s))})}_fireDidChangeActive(i){const s=(0,v.coalesce)(i.map(u=>this.C.get(u)));this.J=s,this.K.fire(s)}_fireDidChangeSelection(i){const s=(0,v.coalesce)(i.map(u=>this.C.get(u)));this.L=s,this.M.fire(s)}_fireDidTriggerItemButton(i,s){const u=this.C.get(i);if(!u||!u.buttons||!u.buttons.length)return;const b=u.buttons[s];b&&this.N.fire({button:b,item:u})}}class m extends y{constructor(i,s){super(i.identifier,s),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:O.default.Error}):this.z({validationMessage:i.message,severity:i.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new w(n,d)}e.createExtHostQuickOpen=I});var Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)},_e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a};define(Ie[282],Ce([1,0,2,3,62,6,19,5,17,109,16,25,52,11,27]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I){"use strict";var E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(s){if(s)return typeof s.iconPath=="string"?a.URI.file(s.iconPath):a.URI.isUri(s.iconPath)||S.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function h(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const b=typeof s.iconPath=="string"?s.iconPath:a.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,g=typeof u.iconPath=="string"?u.iconPath:a.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,v.comparePaths)(b,g)}function w(s,u){let b=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(b=h(s,u),b!==0)return b;if(s.light&&u.light)b=h(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(b!==0)return b;if(s.dark&&u.dark)b=h(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return b}function y(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let b=0;b<s.arguments.length;b++){const g=s.arguments[b],L=u.arguments[b];if(g!==L)return g<L?-1:1}return 0}function p(s,u){let b=(0,v.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(b!==0)return b;if(s.command&&u.command)b=y(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(b!==0)return b;if(s.decorations&&u.decorations)b=w(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return b}function t(s,u){for(let b=0;b<s.length;b++)if(s[b]!==u[b])return!1;return!0}function o(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?t(s.arguments,u.arguments):s.arguments===u.arguments)}function r(s,u){return(0,D.equals)(s,u,o)}class c{get value(){return this.d}set value(u){u=u??"",Ue(this,E,"f").$setInputBoxValue(this.l,u),this.m(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){Ue(this,E,"f").$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,I.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,I.checkProposedApiEnabled)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,Ue(this,E,"f").$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,Ue(this,E,"f").$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,Ue(this,E,"f").$setInputBoxVisibility(this.l,u))}constructor(u,b,g){this.k=u,this.l=g,E.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,E,b,"f")}showValidationMessage(u,b){(0,I.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,E,"f").$showValidationMessage(this.l,u,b)}$onInputBoxValueChange(u){this.m(u)}m(u){this.d=u,this.e.fire(u)}}e.ExtHostSCMInputBox=c,E=new WeakMap;class m{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,b,g,L,j){this.q=u,this.s=b,this.t=g,this.u=L,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,b){const g=this.h.get(u);return g?(0,P.asPromise)(()=>this.s.executeCommand(g.command,...g.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(p),g=(0,D.sortedDiff)(this.o,u,p).map(G=>{const Q=G.toInsert.map(B=>{const U=this.e++;this.g.set(U,B);const z=B.resourceUri;let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const q=new R.DisposableStore;M=this.s.converter.toInternal(B.command,q),this.j.set(U,q)}else this.h.set(U,B.command);const x=d(B.decorations),fe=B.decorations&&d(B.decorations.light)||x,re=B.decorations&&d(B.decorations.dark)||x,V=[fe,re],_=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,ve=B.decorations&&!!B.decorations.faded,le=B.contextValue||"";return{rawResource:[U,z,V,_,te,ve,le,M],handle:U}});return{start:G.start,deleteCount:G.deleteCount,toInsert:Q}}),L=g.map(({start:G,deleteCount:Q,toInsert:B})=>[G,Q,B.map(U=>U.rawResource)]),j=g.reverse();for(const{start:G,deleteCount:Q,toInsert:B}of j){const U=B.map(M=>M.handle),z=this.n.splice(G,Q,...U);for(const M of z)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=u,L}dispose(){this.l=!0,this.m.fire()}}m.d=0;class f{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,Ue(this,n,"f").$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let b;(0,I.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(b=u?.label),Ue(this,n,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:b})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,Ue(this,n,"f").$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new R.DisposableStore,this.l=u;const b=this.v.converter.toInternal(u,this.k.value);Ue(this,n,"f").$updateSourceControl(this.t,{acceptInputCommand:b})}get actionButton(){return(0,I.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,I.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=u;const b=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(g=>g.map(L=>this.v.converter.toInternal(L,this.m.value))),description:u.description,enabled:u.enabled}:void 0;Ue(this,n,"f").$updateSourceControl(this.t,{actionButton:b??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&r(this.p,u))return;this.o.value=new R.DisposableStore,this.p=u;const b=(u||[]).map(g=>this.v.converter.toInternal(g,this.o.value));Ue(this,n,"f").$updateSourceControl(this.t,{statusBarCommands:b})}get selected(){return this.q}constructor(u,b,g,L,j,G){this.u=u,this.v=g,this.w=L,this.x=j,this.y=G,n.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=f.d++,this.z=new Map,this.A=new Set,_e(this,n,b,"f"),this.f=new c(u,Ue(this,n,"f"),this.t),Ue(this,n,"f").$registerSourceControl(this.t,L,j,G)}createResourceGroup(u,b){const g=new m(Ue(this,n,"f"),this.v,this.t,u,b),L=A.Event.once(g.onDidDispose)(()=>this.z.delete(g));return this.z.set(g,L),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const u=[],b=[];for(const[g,L]of this.z){L.dispose();const j=g.onDidUpdateResourceStates(()=>{this.A.add(g),this.eventuallyUpdateResourceStates()});A.Event.once(g.onDidDispose)(()=>{this.A.delete(g),j.dispose(),this.e.delete(g.handle),Ue(this,n,"f").$unregisterGroup(this.t,g.handle)}),u.push([g.handle,g.id,g.label,g.features]);const G=g._takeResourceStateSnapshot();G.length>0&&b.push([g.handle,G]),this.e.set(g.handle,g)}Ue(this,n,"f").$registerGroups(this.t,u,b),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(b=>{const g=b._takeResourceStateSnapshot();g.length!==0&&u.push([b.handle,g])}),u.length>0&&Ue(this,n,"f").$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),Ue(this,n,"f").$unregisterSourceControl(this.t)}}n=new WeakMap,f.d=0,Ve([(0,l.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),Ve([(0,l.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let i=class hn{get onDidChangeActiveProvider(){return this.j.event}constructor(u,b,g){this.l=b,this.m=g,this.g=new Map,this.h=new k.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=u.getProxy(T.MainContext.MainThreadSCM),this.f=u.getProxy(T.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const j=this.g.get(L.sourceControlHandle);if(!j)return L;const G=j.getResourceGroup(L.groupHandle);return G?G.getResourceState(L.handle):L}else if(L&&L.$mid===4){const j=this.g.get(L.sourceControlHandle);return j?j.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const j=this.g.get(L.handle);return j||L}return L}})}createSourceControl(u,b,g,L){this.m.trace("ExtHostSCM#createSourceControl",u.identifier.value,b,g,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const j=hn.d++,G=new f(u,this.e,this.l,b,g,L);this.g.set(j,G);const Q=this.h.get(u.identifier)||[];return Q.push(G),this.h.set(u.identifier,Q),G}getLastInputBox(u){this.m.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const b=this.h.get(u.identifier),g=b&&b[b.length-1];return g&&g.inputBox}$provideOriginalResource(u,b,g){const L=a.URI.revive(b);this.m.trace("ExtHostSCM#$provideOriginalResource",u,L.toString());const j=this.g.get(u);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(L,g)).then(G=>G||null)}$onInputBoxValueChange(u,b){this.m.trace("ExtHostSCM#$onInputBoxValueChange",u);const g=this.g.get(u);return g&&g.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(u,b,g,L){this.m.trace("ExtHostSCM#$executeResourceCommand",u,b,g);const j=this.g.get(u);if(!j)return Promise.resolve(void 0);const G=j.getResourceGroup(b);return G?G.$executeResourceCommand(g,L):Promise.resolve(void 0)}$validateInput(u,b,g){this.m.trace("ExtHostSCM#$validateInput",u);const L=this.g.get(u);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>L.inputBox.validateInput(b,g)).then(j=>{if(!j)return Promise.resolve(void 0);const G=C.MarkdownString.fromStrict(j.message);return G?Promise.resolve([G,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};i.d=0,i=Ve([$e(2,O.ILogService)],i),e.ExtHostSCM=i}),define(Ie[99],Ce([1,0,5,3,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(T){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,D){return this.a.$getPassword(T,D)}store(T,D,v){return this.a.$setPassword(T,D,v)}delete(T,D){return this.a.$deletePassword(T,D)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[283],Ce([1,0,7,5,186,6,11,10]),function(se,e,a,A,l,R,P,T){"use strict";var D,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(I,E,n,d,h=a.StatusBarAlignment.Left,w){D.set(this,void 0),v.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,D,I,"f"),_e(this,v,E,"f"),this.c=O.a++,this.e=n,this.f=d,this.g=h,this.h=this.u(w)}u(I){if(!!(0,T.isNumber)(I))return I===Number.POSITIVE_INFINITY?Number.MAX_VALUE:I===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:I}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(I){this.k=I,this.v()}set name(I){this.m=I,this.v()}set tooltip(I){this.l=I,this.v()}set color(I){this.n=I,this.v()}set backgroundColor(I){I&&!O.b.has(I.id)&&(I=void 0),this.o=I,this.v()}set command(I){this.r?.fromApi!==I&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof I=="string"?this.r={fromApi:I,internal:Ue(this,v,"f").toInternal({title:"",command:I},this.p)}:I?this.r={fromApi:I,internal:Ue(this,v,"f").toInternal(I,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(I){this.t=I,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,D,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let I;this.e?this.f?I=`${this.e.identifier.value}.${this.f}`:I=this.e.identifier.value:I=this.f;let E;this.m?E=this.m:E=(0,l.localize)(0,null,this.e.displayName||this.e.name);let n=this.n;this.o&&(n=O.b.get(this.o.id));const d=P.MarkdownString.fromStrict(this.l);Ue(this,D,"f").$setEntry(this.c,I,E,this.k,d,this.r?.internal,n,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}D=new WeakMap,v=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class k{constructor(I){this.b=[],this.a=I.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(I){const E={message:I};return this.b.unshift(E),this.c(),new a.Disposable(()=>{const n=this.b.indexOf(E);n>=0&&(this.b.splice(n,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class S{constructor(I,E){this.a=I.getProxy(A.MainContext.MainThreadStatusBar),this.b=E,this.c=new k(this)}createStatusBarEntry(I,E,n,d){return new O(this.a,this.b,I,E,n,d)}setStatusBarMessage(I,E){const n=this.c.setMessage(I);let d;return typeof E=="number"?d=setTimeout(()=>n.dispose(),E):typeof E<"u"&&E.then(()=>n.dispose(),()=>n.dispose()),new a.Disposable(()=>{n.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=S}),define(Ie[100],Ce([1,0,5,3,4]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(T,D){this.c=D,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,D){this.a.$registerExtensionStorageKeysToSync(T,D)}async initializeExtensionStorage(T,D,v){const O=await this.a.$initializeExtensionStorage(T,D);let k;return O&&(k=this.d(T,D,O)),k||v}setValue(T,D,v){return this.a.$setValue(T,D,v)}$acceptValue(T,D,v){const O=this.d(T,D,v);O&&this.b.fire({shared:T,key:D,value:O})}d(T,D,v){try{return JSON.parse(v)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${T}): ${O}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(Ie[80],Ce([1,0,4,26,16,79,2]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(v,O,k){this.d=O,this.f=k,this.a=v.workspace??void 0,this.b=v.environment,this.whenReady=this.h().then(S=>this.c=S)}async g(v){return P.URI.joinPath(this.b.workspaceStorageHome,v)}async h(){if(!this.a)return Promise.resolve(void 0);const v=this.a.id,O=await this.g(v);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(P.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(v){if(this.c)return P.URI.joinPath(this.c,v.identifier.value)}globalValue(v){return P.URI.joinPath(this.b.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([$e(0,A.IExtHostInitDataService),$e(1,l.ILogService),$e(2,R.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Ie[42],Ce([1,0,3,5,4,2,20,6,7,188,8,220,21,30,221,52,10,19,11]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class w{constructor(i,s,u,b){this.k=i,this._id=s,this.l=u,this.m=b,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(L=>this.f=L);const g=this;this.value={get name(){return g.m||""},get processId(){return g.b},get creationOptions(){return g.l},get exitStatus(){return g.h},get state(){return g.j},sendText(L,j=!0){g.o(),g.k.$sendText(g._id,L,j)},show(L){g.o(),g.k.$show(g._id,L)},hide(){g.o(),g.k.$hide(g._id)},dispose(){g.a||(g.a=!0,g.k.$dispose(g._id))},get dimensions(){if(!(g.d===void 0||g.g===void 0))return{columns:g.d,rows:g.g}}}}async create(i,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,n.withNullAsUndefined)(i.shellPath),shellArgs:(0,n.withNullAsUndefined)(i.shellArgs),cwd:(0,n.withNullAsUndefined)(i.cwd),env:(0,n.withNullAsUndefined)(i.env),icon:(0,n.withNullAsUndefined)(c(i.iconPath)),color:E.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,n.withNullAsUndefined)(i.message),strictEnv:(0,n.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,n.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,n.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,n.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this.n(i.location,s?.resolvedExtHostIdentifier),isTransient:(0,n.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,s,u,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:u,color:E.ThemeColor.isThemeColor(b)?b.id:void 0,location:this.n(i,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,s){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in i?{viewColumn:h.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,s){this.h=Object.freeze({code:i,reason:s})}setDimensions(i,s){return i===this.d&&s===this.g||i===0||s===0?!1:(this.d=i,this.g=s,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(s=>{s!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=w;class y{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${s}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,s){this.g.setDimensions?.({columns:i,rows:s})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(s=>this.a.fire(s)),this.g.onDidClose?.((s=void 0)=>{this.f.fire(s===void 0?void 0:s)}),this.g.onDidOverrideDimensions?.(s=>{s&&this.d.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this.g.onDidChangeName?.(s=>{this.d.fire({type:"title",value:s})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let p=1,t=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,s){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=s.getProxy(A.MainContext.MainThreadTerminalService),this.s=new I.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[u,b]of this.g)b.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,s){const u=new w(this.a,(0,C.generateUuid)(),i,i.name),b=new y(i.pty);return u.createExtensionTerminal(i.location,this.L(i,s).resolvedExtHostIdentifier,c(i.iconPath),m(i.color)).then(g=>{const L=this.M(g,b);this.h[g]=L}),this.f.push(u),u.value}L(i,s){if(s=s||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const u=i.location.parentTerminal;if(u){const b=this.f.find(g=>g.value===u);b&&(s.resolvedExtHostIdentifier=b._id)}}else i.location&&typeof i.location!="object"?s.location=i.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(i,s){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const b=new y(s),g=this.M(i,b);this.h[i]=g}async $acceptActiveTerminalChanged(i){const s=this.b;if(i===null){this.b=void 0,s!==this.b&&this.F.fire(this.b);return}const u=this.O(i);u&&(this.b=u,s!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,s){const u=this.O(i);u&&this.I.fire({terminal:u.value,data:s})}async $acceptTerminalDimensions(i,s,u){const b=this.O(i);b&&b.setDimensions(s,u)&&this.G.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(i,s,u){this.g.get(i)?.resize(s,u)}async $acceptTerminalTitleChange(i,s){const u=this.O(i);u&&(u.name=s)}async $acceptTerminalClosed(i,s,u){const b=this.Q(this.f,i);if(b!==null){const g=this.f.splice(b,1)[0];g.setExitStatus(s,u),this.C.fire(g.value)}}$acceptTerminalOpened(i,s,u,b){if(s){const j=this.Q(this.f,s);if(j!==null){this.f[j]._id=i,this.D.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const g={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:R.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},L=new w(this.a,i,g,u);this.f.push(L),this.D.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(i,s){this.O(i)?._setProcessId(s)}async $startExtensionTerminal(i,s){const u=this.O(i);if(!u)return{message:(0,v.localize)(0,null,i)};u.isOpen||await new Promise(g=>{const L=this.onDidOpenTerminal(async j=>{j===u.value&&(L.dispose(),g())})});const b=this.g.get(i);b?b.startSendingEvents(s):this.j[i]={initialDimensions:s}}M(i,s){const u=new T.DisposableStore;u.add(s.onProcessReady(g=>this.a.$sendProcessReady(i,g.pid,g.cwd))),u.add(s.onDidChangeProperty(g=>this.a.$sendProcessProperty(i,g))),this.s.startBuffering(i,s.onProcessData),u.add(s.onProcessExit(g=>this.N(i,g))),this.g.set(i,s);const b=this.j[i];return b&&s instanceof y&&(s.startSendingEvents(b.initialDimensions),delete this.j[i]),u}$acceptProcessAckDataEvent(i,s){this.g.get(i)?.acknowledgeDataEvent(s)}$acceptProcessInput(i,s){this.g.get(i)?.input(s)}$acceptTerminalInteraction(i){const s=this.O(i);s?.setInteractedWith()&&this.H.fire(s.value)}$acceptProcessResize(i,s,u){try{this.g.get(i)?.resize(s,u)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(i,s){this.g.get(i)?.shutdown(s)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(s=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(s=>this.a.$sendProcessProperty(i,{type:"cwd",value:s}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new D.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,s,u){if(this.v.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this.v.set(s,u),this.a.$registerProfileProvider(s,i.identifier.value),new D.Disposable(()=>{this.v.delete(s),this.a.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(i,s,u){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,u),this.a.$registerQuickFixProvider(i,s),new D.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,s){const u=new S.CancellationTokenSource().token;if(u.isCancellationRequested)return;const b=this.w.get(i);if(!b)return;const g=await b.provideTerminalQuickFixes(s,u);if(g!==null)return g}async $createContributedProfileTerminal(i,s){const u=new S.CancellationTokenSource().token;let b=await this.v.get(i)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(b&&!("options"in b)&&(b={options:b}),!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,s);return}this.createTerminalFromOptions(b.options,s)}}async $provideLinks(i,s){const u=this.O(i);if(!u)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const g=new S.CancellationTokenSource;this.z.set(i,g);const L=[],j={terminal:u.value,line:s},G=[];for(const U of this.u)G.push(d.Promises.withAsyncBody(async z=>{g.token.onCancellationRequested(()=>z({provider:U,links:[]}));const M=await U.provideTerminalLinks(j,g.token)||[];g.token.isCancellationRequested||z({provider:U,links:M})}));const Q=await Promise.all(G);if(g.token.isCancellationRequested)return[];const B=new Map;for(const U of Q)U&&U.links.length>0&&L.push(...U.links.map(z=>{const M={id:p++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return B.set(M.id,{provider:U.provider,link:z}),M}));return this.y.set(i,B),L}$activateLink(i,s){const u=this.y.get(i)?.get(s);!u||u.provider.handleTerminalLink(u.link)}N(i,s){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const u=this.h[i];u&&(u.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,s)}O(i){return this.P(this.f,i)}P(i,s){const u=this.Q(i,s);return u!==null?i[u]:null}Q(i,s){let u=null;return i.some((b,g)=>b._id===s?(u=g,!0):!1),u}getEnvironmentVariableCollection(i){let s=this.l.get(i.identifier.value);return s||(s=new o,this.S(i.identifier.value,s)),s}R(i,s){const u=(0,k.serializeEnvironmentVariableCollection)(s.map);this.a.$setEnvironmentVariableCollection(i,s.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(i){i.forEach(s=>{const u=s[0],b=new o(s[1]);this.S(u,b)})}$acceptDefaultProfile(i,s){const u=this.m;this.m=i,this.n=s,u?.path!==i.path&&this.J.fire(i.path)}S(i,s){this.l.set(i,s),s.onDidChangeCollection(()=>{this.R(i,s)})}};t=Ve([$e(1,P.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class o{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,s){this.d(i,{value:s,type:D.EnvironmentVariableMutatorType.Replace})}append(i,s){this.d(i,{value:s,type:D.EnvironmentVariableMutatorType.Append})}prepend(i,s){this.d(i,{value:s,type:D.EnvironmentVariableMutatorType.Prepend})}d(i,s){const u=this.map.get(i);(!u||u.value!==s.value||u.type!==s.type)&&(this.map.set(i,s),this.b.fire())}get(i){return this.map.get(i)}forEach(i,s){this.map.forEach((u,b)=>i.call(s,b,u,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(i){super(!1,i)}createTerminal(i,s,u){throw new O.NotSupportedError}createTerminalFromOptions(i,s){throw new O.NotSupportedError}};r=Ve([$e(0,P.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function m(f){return E.ThemeColor.isThemeColor(f)?f:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)},_e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a};define(Ie[284],Ce([1,0,17,19,22,21,3,63,68,6,23,10,30,5,20,138,11,7,57,95,76]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y){"use strict";var p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(B,U,z){this.j=z,this.c=new P.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=B.getProxy(C.MainContext.MainThreadTesting),this.h=new L(this.f),this.g=new f(this.f),U.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==15)return M;const x=M,fe=x.tests[x.tests.length-1].item.extId;return this.d.get(h.TestId.root(fe))?.collection.tree.get(fe)?.actual??(0,E.toItemFromContext)(M)}})}createTestController(B,U,z,M){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const x=new v.DisposableStore,fe=x.add(new E.ExtHostTestItemCollection(U,z,this.j));fe.root.label=z;const re=new Map,V=this.f,_={items:fe.root.children,get label(){return z},set label(ve){z=ve,fe.root.label=ve,V.$updateController(U,{label:z})},get refreshHandler(){return M},set refreshHandler(ve){M=ve,V.$updateController(U,{canRefresh:!!ve})},get id(){return U},createRunProfile:(ve,le,ue,q,F,J)=>{let ge=(0,D.hash)(ve);for(;re.has(ge);)ge++;return new j(this.f,re,U,ge,ve,le,ue,q,F,J)},createTestItem(ve,le,ue){return new E.TestItemImpl(U,ve,le,ue)},createTestRun:(ve,le,ue=!0)=>this.g.createTestRun(U,fe,ve,le,ue),set resolveHandler(ve){fe.resolveHandler=ve},get resolveHandler(){return fe.resolveHandler},dispose:()=>{x.dispose()}};V.$registerTestController(U,z,!!M),x.add((0,v.toDisposable)(()=>V.$unregisterTestController(U)));const te={controller:_,collection:fe,profiles:re};return this.d.set(U,te),x.add((0,v.toDisposable)(()=>this.d.delete(U))),x.add(fe.onDidGenerateDiff(ve=>V.$publishDiff(U,ve.map(y.TestsDiffOp.serialize)))),_}createTestObserver(){return this.h.checkout()}async runTests(B,U=R.CancellationToken.None){const z=i(B);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.d.get(z.controllerId);if(!M)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(x=>h.TestId.fromExtHostTestItem(x,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:G[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:B.exclude?.map(x=>x.id)},U)}$syncTests(){for(const{collection:B}of this.d.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,U,z){return(0,a.mapFind)(this.g.trackers,x=>x.id===B?x.getCoverage(U):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(B,U,z,M){return(0,a.mapFind)(this.g.trackers,fe=>fe.id===B?fe.getCoverage(U):void 0)?.resolveFileCoverage(z,M)??Promise.resolve([])}$configureRunProfile(B,U){this.d.get(B)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(B,U){await this.d.get(B)?.controller.refreshHandler?.(U)}$publishTestResults(B){this.results=Object.freeze(B.map(U=>(0,O.deepFreeze)(n.TestResults.to(U))).concat(this.results).sort((U,z)=>z.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(B,U){const z=this.d.get(h.TestId.fromString(B).controllerId)?.collection;z&&(await z.expand(B,U<0?1/0:U),z.flushDiff())}$acceptDiff(B){this.h.applyDiff(B.map(y.TestsDiffOp.deserialize))}async $runControllerTests(B,U){return Promise.all(B.map(z=>this.k(z,!1,U)))}async $startContinuousRun(B,U){const z=new R.CancellationTokenSource(U),M=await Promise.all(B.map(x=>this.k(x,!0,z.token)));return!U.isCancellationRequested&&!M.some(x=>x.error)&&await new Promise(x=>U.onCancellationRequested(x)),z.dispose(!0),M}async k(B,U,z){const M=this.d.get(B.controllerId);if(!M)return{};const{collection:x,profiles:fe}=M,re=fe.get(B.profileId);if(!re)return{};const V=B.testIds.map(le=>x.tree.get(le)).filter(k.isDefined),_=B.excludeExtIds.map(le=>M.collection.tree.get(le)).filter(k.isDefined).filter(le=>V.some(ue=>ue.fullId.compare(le.fullId)===2));if(!V.length)return{};const te=new d.TestRunRequest(V.some(le=>le.actual instanceof E.TestItemRootImpl)?void 0:V.map(le=>le.actual),_.map(le=>le.actual),re,U),ve=(0,y.isStartControllerTests)(B)&&this.g.prepareForMainThreadTestRun(te,s.fromInternal(B,M.collection),z);try{return await re.runHandler(te,z),{}}catch(le){return{error:String(le)}}finally{ve&&(ve.hasRunningTasks&&!z.isCancellationRequested&&await P.Event.toPromise(ve.onEnd),ve.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.g.cancelAllRuns():this.g.cancelRunById(B)}};o=Ve([$e(0,I.IExtHostRpcService)],o),e.ExtHostTesting=o;const r=1e4;var c;(function(Q){Q[Q.Running=0]="Running",Q[Q.Cancelling=1]="Cancelling",Q[Q.Ended=2]="Ended"})(c||(c={}));class m extends v.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(B,U,z){super(),this.k=B,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(z));const M=this.B(new A.RunOnceScheduler(()=>this.m(),r));this.B(this.h.token.onCancellationRequested(()=>M.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(B){return this.f.get(B)?.coverage}createRun(B){const U=this.k.id,z=this.k.controllerId,M=(0,S.generateUuid)(),x=new u(this.l,U,M),fe=te=>(ve,...le)=>{if(V){console.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ve)||(this.s(ve),te(ve,...le))},re=(te,ve)=>{const le=ve instanceof Array?ve.map(n.TestMessage.from):[n.TestMessage.from(ve)];if(te.uri&&te.range){const ue={range:n.Range.from(te.range),uri:te.uri};for(const q of le)q.location=q.location||ue}this.l.$appendTestMessagesInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),le)};let V=!1;const _={isPersisted:this.k.isPersisted,token:this.h.token,name:B,get coverageProvider(){return x.coverageProvider},set coverageProvider(te){x.coverageProvider=te},enqueued:fe(te=>{this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),1)}),skipped:fe(te=>{this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),5)}),started:fe(te=>{this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),2)}),errored:fe((te,ve,le)=>{re(te,ve),this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),6,le)}),failed:fe((te,ve,le)=>{re(te,ve),this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,z).toString(),4,le)}),passed:fe((te,ve)=>{this.l.$updateTestStateInRun(U,M,h.TestId.fromExtHostTestItem(te,this.k.controllerId).toString(),3,ve)}),appendOutput:(te,ve,le)=>{V||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(U,M,l.VSBuffer.fromString(te),ve&&n.location.from(ve),le&&h.TestId.fromExtHostTestItem(le,z).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(U,M),this.f.delete(M),this.f.size||this.p())}};return this.f.set(M,{run:_,coverage:x}),this.l.$startedTestRunTask(U,{id:M,name:B,running:!0}),_}m(){for(const{run:B}of this.f.values())B.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(B){if(!(B instanceof E.TestItemImpl))throw new w.InvalidTestItemError(B.id);if(this.g.has(h.TestId.fromExtHostTestItem(B,this.k.controllerId).toString()))return;const U=[],z=this.k.colllection.root;for(;;){const M=n.TestItem.from(B);if(U.unshift(M),this.g.has(M.extId)||(this.g.add(M.extId),B===z))break;B=B.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class f{get trackers(){return this.c.values()}constructor(B){this.d=B,this.c=new Map}prepareForMainThreadTestRun(B,U,z){return this.f(B,U,z)}cancelRunById(B){for(const U of this.c.values())if(U.id===B){U.cancel();return}}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,U,z,M,x){const fe=this.c.get(z);if(fe)return fe.createRun(M);const re=s.fromPublic(B,U,z,x),V=i(z);this.d.$startedExtensionTestRun({controllerId:B,continuous:!!z.continuous,profile:V&&{group:G[V.kind],id:V.profileId},exclude:z.exclude?.map(te=>h.TestId.fromExtHostTestItem(te,U.root.id).toString())??[],id:re.id,include:z.include?.map(te=>h.TestId.fromExtHostTestItem(te,U.root.id).toString())??[U.root.id],persist:x});const _=this.f(z,re);return _.onEnd(()=>{this.d.$finishedExtensionTestRun(re.id),_.dispose()}),_.createRun(M)}f(B,U,z){const M=new m(U,this.d,z);return this.c.set(B,M),M.onEnd(()=>this.c.delete(B)),M}}e.TestRunCoordinator=f;const i=Q=>{if(!!Q.profile){if(!(Q.profile instanceof j))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Q.profile}};class s{static fromPublic(B,U,z,M){return new s(B,(0,S.generateUuid)(),z.include?.map(x=>h.TestId.fromExtHostTestItem(x,B).toString())??[B],z.exclude?.map(x=>h.TestId.fromExtHostTestItem(x,B).toString())??[],M,U)}static fromInternal(B,U){return new s(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,U)}constructor(B,U,z,M,x,fe){this.controllerId=B,this.id=U,this.isPersisted=x,this.colllection=fe,this.c=z.map(re=>re+"\0"),this.d=M.map(re=>re+"\0")}isIncluded(B){const U=h.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const z of this.d)if(U===z||U.startsWith(z))return!1;for(const z of this.c)if(U===z||U.startsWith(z))return!0;return!1}}e.TestRunDto=s;class u{set coverageProvider(B){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this.c=B,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(B,U,z){this.f=B,this.g=U,this.h=z}async provideFileCoverage(B){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(B))());try{return(await this.d)?.map(n.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(B,U){const z=await this.d;let M=z?.[B];return!this.c||!z||!M?[]:(M.detailedCoverage||(M=z[B]=await this.c.resolveFileCoverage?.(M,U)??M),M.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(B){this.h=B,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,n.TestItem.toPlain(B.item)),this.c.has(B)||this.d.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.d.delete(B);const U=h.TestId.parentId(B.item.extId);if(U&&this.g.has(U.toString())){this.g.add(B.item.extId);return}this.f.add(B)}getChangeEvent(){const{c:B,d:U,f:z}=this;return{get added(){return[...B].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...z].map(M=>M.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class g extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new P.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(B){return this.d.get(B)}getMirroredTestDataByReference(B){return this.d.get(B.id)}p(B,U){return{...B,revived:n.TestItem.toPlain(B.item),depth:U?U.depth+1:0,children:new Set}}o(){return new b(this.q)}}class L{constructor(B){this.d=B}checkout(){this.c||(this.c=this.f());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(U=>U.revived)},dispose:(0,T.once)(()=>{--B.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}f(){const B=new g;return this.d.$subscribeToDiffs(),{observers:0,tests:B}}}class j{get label(){return this.d}set label(B){B!==this.d&&(this.d=B,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.f}set isDefault(B){B!==this.f&&(this.f=B,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?n.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,U,z,M,x,fe,re,V=!1,_=void 0,te=!1){this.controllerId=z,this.profileId=M,this.d=x,this.kind=fe,this.runHandler=re,this.f=V,this._tag=_,this.g=te,p.set(this,void 0),t.set(this,void 0),_e(this,p,B,"f"),_e(this,t,U,"f"),U.set(M,this);const ve=G[fe];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${fe}`);Ue(this,p,"f").$publishTestRunProfile({profileId:M,controllerId:z,tag:_?n.TestTag.namespace(this.controllerId,_.id):null,label:x,group:ve,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){Ue(this,t,"f")?.delete(this.profileId)&&(_e(this,t,void 0,"f"),Ue(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=j,p=new WeakMap,t=new WeakMap;const G={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ie[285],Ce([1,0,17,8,3,5,139,11,7]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(k,S){this.i=S,this.a=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.b=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.c=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.d=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.f=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.g=new l.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(R.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(C=>this.g.fire(C)),this.i.onDidChangeActiveTextEditor(C=>this.f.fire(C))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const S=this.i.allEditors();return k?S:S.map(C=>C.value)}async showTextDocument(k,S,C){let I;typeof S=="number"?I={position:T.ViewColumn.from(S),preserveFocus:C}:typeof S=="object"?I={position:T.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?T.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:I={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(k.uri,I),n=E&&this.i.getEditor(E);if(n)return n.value;throw E?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,S){return new P.TextEditorDecorationType(this.h,k,S).value}$acceptEditorPropertiesChanged(k,S){const C=this.i.getEditor(k);if(!C)throw new Error("unknown text editor");if(S.options&&C._acceptOptions(S.options),S.selections){const I=S.selections.selections.map(T.Selection.to);C._acceptSelections(I)}if(S.visibleRanges){const I=a.coalesce(S.visibleRanges.map(T.Range.to));C._acceptVisibleRanges(I)}if(S.options&&this.b.fire({textEditor:C.value,options:{...S.options,lineNumbers:T.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const I=D.TextEditorSelectionChangeKind.fromValue(S.selections.source),E=S.selections.selections.map(T.Selection.to);this.a.fire({textEditor:C.value,selections:E,kind:I})}if(S.visibleRanges){const I=a.coalesce(S.visibleRanges.map(T.Range.to));this.c.fire({textEditor:C.value,visibleRanges:I})}}$acceptEditorPositionData(k){for(const S in k){const C=this.i.getEditor(S);if(!C)throw new Error("Unknown text editor");const I=T.ViewColumn.to(k[S]);C.value.viewColumn!==I&&(C._acceptViewColumn(I),this.d.fire({textEditor:C.value,viewColumn:I}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.ExtHostEditors=v}),define(Ie[286],Ce([1,0,2,4,5,6,7,11,25,10]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class O{constructor(C,I){this.b=new Map,this.c=new Map,this.a=C.getProxy(l.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:(E,n)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&D.ExtensionIdentifier.equals(n,this.b.get(E.source)?.extension)){const d=E.uri===void 0?void 0:a.URI.revive(E.uri);return this.c.get(E.source)?.get(k(d))?.get(E.handle)}else return;return E}})}async $getTimeline(C,I,E,n){return this.b.get(C)?.provider.provideTimeline(a.URI.revive(I),E,n)}registerTimelineProvider(C,I,E,n){const d=new R.DisposableStore,h=this.d(I.id,n,d).bind(this);let w;I.onDidChange&&(w=I.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:I.id}),this));const y=this.c;return this.f({...I,scheme:C,onDidChange:void 0,async provideTimeline(p,t,o){t?.resetCache&&(d.clear(),y.get(I.id)?.clear());const r=await I.provideTimeline(p,t,o);if(r==null)return;const c=h(p,t);return{...r,source:I.id,items:r.items.map(c)}},dispose(){for(const p of y.values())p.get(I.id)?.clear();w?.dispose(),d.dispose()}},E)}d(C,I,E){return(n,d)=>{let h;if(d?.cacheResults){let w=this.c.get(C);w===void 0&&(w=new Map,this.c.set(C,w));const y=k(n);h=w.get(y),h===void 0&&(h=new Map,w.set(y,h))}return w=>{const{iconPath:y,...p}=w,t=`${C}|${w.id??w.timestamp}`;h?.set(t,w);let o,r,c;w.iconPath&&(y instanceof P.ThemeIcon?c={id:y.id,color:y.color}:a.URI.isUri(y)?(o=y,r=y):{light:o,dark:r}=y);let m;return P.MarkdownString.isMarkdownString(p.tooltip)?m=T.MarkdownString.from(p.tooltip):(0,v.isString)(p.tooltip)?m=p.tooltip:P.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=T.MarkdownString.from(p.detail)):(0,v.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=p.detail),{...p,id:p.id??void 0,handle:t,source:C,command:w.command?I.toInternal(w.command,E):void 0,icon:o,iconDark:r,themeIcon:c,tooltip:m,accessibilityInformation:w.accessibilityInformation}}}}f(C,I){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:I}),(0,R.toDisposable)(()=>{for(const n of this.c.values())n.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=O;function k(S){return S?.toString()}}),define(Ie[287],Ce([1,0,6,18,2,5]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(D){this.c=new Map,this.b=D.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,v,O,k){if(this.c.has(v))throw new Error(`Opener with id '${v}' already registered`);const S=k.schemes.find(C=>!P.a.has(C));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this.c.set(v,O),this.b.$registerUriOpener(v,k.schemes,D,k.label),(0,a.toDisposable)(()=>{this.c.delete(v),this.b.$unregisterUriOpener(v)})}async $canOpenUri(D,v,O){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const S=l.URI.revive(v);return k.canOpenExternalUri(S,O)}async $openUri(D,v,O){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(l.URI.revive(v.resolvedUri),{sourceUri:l.URI.revive(v.sourceUri)},O)}}P.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=P}),define(Ie[288],Ce([1,0,5,2,6,8,25]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(v){this.c=new P.ExtensionIdentifierSet,this.d=new Map,this.b=v.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(v,O){if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const k=T.a++;return this.c.add(v),this.d.set(k,O),this.b.$registerUriHandler(k,v),(0,l.toDisposable)(()=>{this.c.delete(v),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(v,O){const k=this.d.get(v);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(O))}catch(S){(0,R.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(v){return A.URI.revive(await this.b.$createAppUri(v))}}T.a=0,e.ExtHostUrls=T});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[81],Ce([1,0,3,18,23,2,204,229,96,5]),function(se,e,a,A,l,R,P,T,D,v){"use strict";var O,k,S,C,I,E,n,d,h,w,y,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(g,L,j,G,Q,B,U){O.set(this,void 0),k.set(this,void 0),S.set(this,void 0),C.set(this,void 0),I.set(this,void 0),E.set(this,void 0),n.set(this,""),d.set(this,void 0),h.set(this,!1),w.set(this,!1),y.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new a.Emitter),this._onDidDispose=Ue(this,t,"f").event,_e(this,O,g,"f"),_e(this,k,L,"f"),_e(this,d,j,"f"),_e(this,C,G,"f"),_e(this,I,Q,"f"),_e(this,E,B,"f"),_e(this,y,r(B),"f"),_e(this,p,c(B),"f"),_e(this,S,U,"f")}dispose(){_e(this,h,!0,"f"),Ue(this,t,"f").fire(),Ue(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return _e(this,w,!0,"f"),(0,D.asWebviewUri)(g,Ue(this,C,"f"))}get cspSource(){const g=Ue(this,E,"f").extensionLocation;if(g.scheme===A.Schemas.https||g.scheme===A.Schemas.http){let L=g.toString();return L.endsWith("/")||(L+="/"),L+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.a(),Ue(this,n,"f")}set html(g){this.a(),Ue(this,n,"f")!==g&&(_e(this,n,g,"f"),Ue(this,p,"f")&&!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(_e(this,w,!0,"f"),Ue(this,S,"f").report("Webview vscode-resource: uris",Ue(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,O,"f"),this.b(g)))}get options(){return this.a(),Ue(this,d,"f")}set options(g){this.a(),l.equals(Ue(this,d,"f"),g)||Ue(this,k,"f").$setOptions(Ue(this,O,"f"),i(Ue(this,E,"f"),Ue(this,I,"f"),g)),_e(this,d,g,"f")}async postMessage(g){if(Ue(this,h,"f"))return!1;const L=(0,T.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Ue(this,y,"f")});return Ue(this,k,"f").$postMessage(Ue(this,O,"f"),L.message,...L.buffers)}a(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}b(g){if(!Ue(this,p,"f"))return g;const L=Ue(this,E,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,j=Ue(this,E,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Ue(this,E,"f").extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,Q,B,U,z,M)=>{const x=R.URI.from({scheme:U||"file",path:decodeURIComponent(z)}),fe=(0,D.asWebviewUri)(x,{isRemote:L,authority:j}).toString();return`${Q}${fe}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,Q,B,U,z,M)=>{const x=R.URI.from({scheme:U||"file",path:decodeURIComponent(z)}),fe=(0,D.asWebviewUri)(x,{isRemote:L,authority:j}).toString();return`${Q}${fe}${M}`})}}e.ExtHostWebview=o,O=new WeakMap,k=new WeakMap,S=new WeakMap,C=new WeakMap,I=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,p=new WeakMap,t=new WeakMap;function r(b){try{const g=(0,P.normalizeVersion)((0,P.parseVersion)(b.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(b){try{const g=(0,P.normalizeVersion)((0,P.parseVersion)(b.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class m{constructor(g,L,j,G,Q){this.c=L,this.d=j,this.e=G,this.f=Q,this.b=new Map,this.a=g.getProxy(v.MainContext.MainThreadWebviews)}$onMessage(g,L,j){const G=this.g(g);if(G){const{message:Q}=(0,T.deserializeWebviewMessage)(L,j.value);G._onMessageEmitter.fire(Q)}}$onMissingCsp(g,L){this.e.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,L,j){const G=new o(g,this.a,s(L),this.c,this.d,j,this.f);return this.b.set(g,G),G._onDidDispose(()=>{this.b.delete(g)}),G}deleteWebview(g){this.b.delete(g)}g(g){return this.b.get(g)}}e.ExtHostWebviews=m;function f(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=f;function i(b,g,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||u(b,g)}}e.serializeWebviewOptions=i;function s(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(g=>R.URI.from(g))}}function u(b,g){return[...(g?.getWorkspaceFolders()||[]).map(L=>L.uri),b.extensionLocation]}}),define(Ie[289],Ce([1,0,21,68,6,18,24,2,11,81,75,5,7]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(o,r){this.document=o,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,r){await this.f(o).undo(),r||this.disposeBackup()}async redo(o,r){await this.f(o).redo(),r||this.disposeBackup()}disposeEdits(o){for(const r of o)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this.a++;return(0,P.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const r=this.c.get(o,0);if(!r)throw new Error("No edit found");return r}}class I{constructor(){this.a=new Map}get(o,r){return this.a.get(this.b(o,r))}add(o,r,c){const m=this.b(o,r.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${o} resource:${r.uri}`);const f=new C(r,c);return this.a.set(m,f),f}delete(o,r){const c=this.b(o,r.uri);this.a.delete(c)}b(o,r){return`${o}@@@${r}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class n{constructor(){this.a=new Map}addTextProvider(o,r,c){return this.b(0,o,r,c)}addCustomProvider(o,r,c){return this.b(1,o,r,c)}get(o){return this.a.get(o)}b(o,r,c,m){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:o,extension:c,provider:m}),new S.Disposable(()=>this.a.delete(r))}}class d{constructor(o,r,c,m,f){this.d=r,this.f=c,this.g=m,this.h=f,this.b=new n,this.c=new I,this.a=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,r,c,m){const f=new l.DisposableStore;return w(c)?(f.add(this.b.addTextProvider(r,o,c)),this.a.$registerTextEditorProvider((0,v.toExtensionData)(o),r,m.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,v.shouldSerializeBuffersForPostMessage)(o))):(f.add(this.b.addCustomProvider(r,o,c)),h(c)&&f.add(c.onDidChangeCustomDocument(i=>{const s=this.i(r,i.document.uri);if(y(i)){const u=s.addEdit(i);this.a.$onDidEdit(i.document.uri,r,u,i.label)}else this.a.$onContentChange(i.document.uri,r)})),this.a.$registerCustomEditorProvider((0,v.toExtensionData)(o),r,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,v.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(f,new S.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(o,r,c,m,f){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=T.URI.revive(o),u=await i.provider.openCustomDocument(s,{backupId:c,untitledDocumentData:m?.buffer},f);let b;return h(i.provider)&&this.f&&(b=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(r,u,b),{editable:h(i.provider)}}async $disposeCustomDocument(o,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const m=T.URI.revive(o),{document:f}=this.i(r,m);this.c.delete(r,f),f.dispose()}async $resolveCustomEditor(o,r,c,m,f,i){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);const u=D.ViewColumn.to(f),b=this.g.createNewWebview(r,m.contentOptions,s.extension),g=this.h.createNewWebviewPanel(r,c,m.title,u,m.options,b,!0),L=T.URI.revive(o);switch(s.type){case 1:{const{document:j}=this.i(c,L);return s.provider.resolveCustomEditor(j,g,i)}case 0:{const j=this.d.getDocument(L);return s.provider.resolveCustomTextEditor(j,g,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,r,c){this.i(r,o).disposeEdits(c)}async $onMoveCustomEditor(o,r,c){const m=this.b.get(c);if(!m)throw new Error(`No provider found for '${c}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const f=this.h.getWebviewPanel(o);if(!f)throw new Error("No webview found");const i=T.URI.revive(r),s=this.d.getDocument(i);await m.provider.moveCustomTextEditor(s,f,a.CancellationToken.None)}async $undo(o,r,c,m){return this.i(r,o).undo(c,m)}async $redo(o,r,c,m){return this.i(r,o).redo(c,m)}async $revert(o,r,c){const m=this.i(r,o);await this.j(r).revertCustomDocument(m.document,c),m.disposeBackup()}async $onSave(o,r,c){const m=this.i(r,o);await this.j(r).saveCustomDocument(m.document,c),m.disposeBackup()}async $onSaveAs(o,r,c,m){const f=this.i(r,o);return this.j(r).saveCustomDocumentAs(f.document,T.URI.revive(c),m)}async $backup(o,r,c){const m=this.i(r,o),i=await this.j(r).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},c);return m.updateBackup(i),i.id}i(o,r){const c=this.c.get(o,T.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(o){const c=this.b.get(o)?.provider;if(!c||!h(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=d;function h(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function y(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const o=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(o)+""}});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[290],Ce([1,0,3,6,2,30,11,81,5,7]),function(se,e,a,A,l,R,P,T,D,v){"use strict";var O,k,S,C,I,E,n,d,h,w,y,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(f,i,s,u){super(),O.set(this,void 0),k.set(this,void 0),S.set(this,void 0),C.set(this,void 0),I.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,void 0),h.set(this,!0),w.set(this,void 0),y.set(this,!1),p.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,p,"f").event,t.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,_e(this,O,f,"f"),_e(this,k,i,"f"),_e(this,C,s,"f"),_e(this,S,u.viewType,"f"),_e(this,I,u.panelOptions,"f"),_e(this,d,u.viewColumn,"f"),_e(this,E,u.title,"f"),_e(this,w,u.active,"f")}dispose(){Ue(this,y,"f")||(_e(this,y,!0,"f"),Ue(this,p,"f").fire(),Ue(this,k,"f").$disposeWebview(Ue(this,O,"f")),Ue(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,C,"f")}get viewType(){return this.c(),Ue(this,S,"f")}get title(){return this.c(),Ue(this,E,"f")}set title(f){this.c(),Ue(this,E,"f")!==f&&(_e(this,E,f,"f"),Ue(this,k,"f").$setTitle(Ue(this,O,"f"),f))}get iconPath(){return this.c(),Ue(this,n,"f")}set iconPath(f){this.c(),Ue(this,n,"f")!==f&&(_e(this,n,f,"f"),Ue(this,k,"f").$setIconPath(Ue(this,O,"f"),l.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,I,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,d,"f")=="number"&&Ue(this,d,"f")<0))return Ue(this,d,"f")}get active(){return this.c(),Ue(this,w,"f")}get visible(){return this.c(),Ue(this,h,"f")}_updateViewState(f){Ue(this,y,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(_e(this,w,f.active,"f"),_e(this,h,f.visible,"f"),_e(this,d,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,i){this.c(),Ue(this,k,"f").$reveal(Ue(this,O,"f"),{viewColumn:typeof f>"u"?void 0:P.ViewColumn.from(f),preserveFocus:!!i})}c(){if(Ue(this,y,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,k=new WeakMap,S=new WeakMap,C=new WeakMap,I=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static c(){return(0,R.generateUuid)()}constructor(f,i,s){this.g=i,this.h=s,this.e=new Map,this.f=new Map,this.d=f.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,i,s,u,b={}){const g=typeof u=="object"?u.viewColumn:u,L={viewColumn:P.ViewColumn.from(g),preserveFocus:typeof u=="object"&&!!u.preserveFocus},j=(0,T.shouldSerializeBuffersForPostMessage)(f),G=r.c();this.d.$createWebviewPanel((0,T.toExtensionData)(f),G,i,{title:s,panelOptions:c(b),webviewOptions:(0,T.serializeWebviewOptions)(f,this.h,b),serializeBuffersForPostMessage:j},L);const Q=this.g.createNewWebview(G,b,f);return this.createNewWebviewPanel(G,i,s,g,b,Q,!0)}$onDidChangeWebviewPanelViewStates(f){const i=Object.keys(f);i.sort((s,u)=>{const b=f[s],g=f[u];return b.active?1:g.active?-1:+b.visible-+g.visible});for(const s of i){const u=this.getWebviewPanel(s);if(!u)continue;const b=f[s];u._updateViewState({active:b.active,visible:b.visible,viewColumn:P.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.e.delete(f),this.g.deleteWebview(f)}registerWebviewPanelSerializer(f,i,s){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:s,extension:f}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(f)}),new v.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(f,i,s,u){const b=this.f.get(i);if(!b)throw new Error(`No serializer found for '${i}'`);const{serializer:g,extension:L}=b,j=this.g.createNewWebview(f,s.webviewOptions,L),G=this.createNewWebviewPanel(f,i,s.title,u,s.panelOptions,j,s.active);await g.deserializeWebviewPanel(G,s.state)}createNewWebviewPanel(f,i,s,u,b,g,L){const j=new o(f,this.d,g,{viewType:i,title:s,viewColumn:u,panelOptions:b,active:L});return this.e.set(f,j),j}getWebviewPanel(f){return this.e.get(f)}}e.ExtHostWebviewPanels=r;function c(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[291],Ce([1,0,3,6,81,11,5,7]),function(se,e,a,A,l,R,P,T){"use strict";var D,v,O,k,S,C,I,E,n,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends A.Disposable{constructor(t,o,r,c,m,f){super(),D.set(this,void 0),v.set(this,void 0),O.set(this,void 0),k.set(this,void 0),S.set(this,!1),C.set(this,void 0),I.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,h.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,h,"f").event,_e(this,O,r,"f"),_e(this,I,c,"f"),_e(this,D,t,"f"),_e(this,v,o,"f"),_e(this,k,m,"f"),_e(this,C,f,"f")}dispose(){Ue(this,S,"f")||(_e(this,S,!0,"f"),Ue(this,h,"f").fire(),Ue(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,I,"f")}set title(t){this.a(),Ue(this,I,"f")!==t&&(_e(this,I,t,"f"),Ue(this,v,"f").$setWebviewViewTitle(Ue(this,D,"f"),t))}get description(){return this.a(),Ue(this,E,"f")}set description(t){this.a(),Ue(this,E,"f")!==t&&(_e(this,E,t,"f"),Ue(this,v,"f").$setWebviewViewDescription(Ue(this,D,"f"),t))}get visible(){return Ue(this,C,"f")}get webview(){return Ue(this,k,"f")}get viewType(){return Ue(this,O,"f")}_setVisible(t){t===Ue(this,C,"f")||Ue(this,S,"f")||(_e(this,C,t,"f"),Ue(this,d,"f").fire())}get badge(){return this.a(),Ue(this,n,"f")}set badge(t){this.a(),!(t?.value===Ue(this,n,"f")?.value&&t?.tooltip===Ue(this,n,"f")?.tooltip)&&(_e(this,n,R.ViewBadge.from(t),"f"),Ue(this,v,"f").$setWebviewViewBadge(Ue(this,D,"f"),t))}show(t){this.a(),Ue(this,v,"f").$show(Ue(this,D,"f"),!!t)}a(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,v=new WeakMap,O=new WeakMap,k=new WeakMap,S=new WeakMap,C=new WeakMap,I=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,h=new WeakMap;class y{constructor(t,o){this.d=o,this.b=new Map,this.c=new Map,this.a=t.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,o,r,c){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(t),o,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(t,o,r,c,m){const f=this.b.get(o);if(!f)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:s}=f,u=this.d.createNewWebview(t,{},s),b=new w(t,this.a,o,r,u,!0);this.c.set(t,b),await i.resolveWebviewView(b,{state:c},m)}async $onDidChangeWebviewViewVisibility(t,o){this.e(t)._setVisible(o)}async $disposeWebviewView(t){const o=this.e(t);this.c.delete(t),o.dispose(),this.d.deleteWebview(t)}e(t){const o=this.c.get(t);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=y}),define(Ie[142],Ce([1,0,3,5,2,18,9,4,20]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let v=class fn{get state(){return this.d}constructor(k){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=fn.a,this.b=k.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,S){let C;if(typeof k=="string"){C=k;try{k=l.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,P.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,C,S)}async asExternalUri(k,S){if((0,P.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(k,S);return l.URI.from(C)}};v.a={focused:!0},v=Ve([$e(0,D.IExtHostRpcService)],v),e.ExtHostWindow=v,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Ie[292],Ce([1,0,120,293,71,41,2,16,48]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class v{constructor(S,C,I){this.b=S,this.c=C,this.f=I,this.a=A.createServer((E,n)=>this.h(E,n)),this.g().catch(E=>(C.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",S=>this.c.error(S))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(S,C){const I=(n,d)=>{C.writeHead(n,{"content-type":"application/json"}),C.end(JSON.stringify(d||null),h=>h&&this.c.error(h))},E=[];S.setEncoding("utf8"),S.on("data",n=>E.push(n)),S.on("end",async()=>{try{const n=JSON.parse(E.join(""));let d;switch(n.type){case"open":d=await this.i(n);break;case"openExternal":d=await this.j(n);break;case"status":d=await this.l(n);break;case"extensionManagement":d=await this.k(n);break;default:I(404,`Unknown message type: ${n.type}`);break}I(200,d)}catch(n){const d=n instanceof Error?n.message:JSON.stringify(n);I(500,d),this.c.error("Error while processing pipe request",n)}})}async i(S){const{fileURIs:C,folderURIs:I,forceNewWindow:E,diffMode:n,mergeMode:d,addMode:h,forceReuseWindow:w,gotoLineMode:y,waitMarkerFilePath:p,remoteAuthority:t}=S,o=[];if(Array.isArray(I))for(const f of I)try{o.push({folderUri:P.URI.parse(f)})}catch{}if(Array.isArray(C))for(const f of C)try{(0,D.hasWorkspaceFileExtension)(f)?o.push({workspaceUri:P.URI.parse(f)}):o.push({fileUri:P.URI.parse(f)})}catch{}const r=p?P.URI.file(p):void 0,m={forceNewWindow:E,diffMode:n,mergeMode:d,addMode:h,gotoLineMode:y,forceReuseWindow:w,preferNewWindow:!w&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",o,m),""}async j(S){for(const C of S.uris){const I=P.URI.parse(C),E=I.scheme==="file"?I:C;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k(S){const C=E=>E?.map(n=>/\.vsix$/i.test(n)?P.URI.parse(n):n),I={list:S.list,install:C(S.install),uninstall:C(S.uninstall),force:S.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",I)}async l(S){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=v;let O=class extends v{constructor(S,C){super(S,C,(0,a.createRandomIPCHandle)())}};O=Ve([$e(0,R.IExtHostCommands),$e(1,T.ILogService)],O),e.CLIServer=O}),define(Ie[294],Ce([1,0,262,26,20]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let P=class extends a.AbstractExtHostConsoleForwarder{constructor(D,v){super(D,v),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(D,v,O){const k=D==="error"||D==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),v.apply(console,O),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(D,v){const O=process[D],k=O.write;let S="";Object.defineProperty(O,"write",{set:()=>{},get:()=>(C,I,E)=>{if(!this.g){S+=C.toString(I);const n=S.length>R?S.length:S.lastIndexOf(`
`);n!==-1&&(console[v](S.slice(0,n)),S=S.slice(n+1))}k.call(O,C,I,E)}})}};P=Ve([$e(0,l.IExtHostRpcService),$e(1,A.IExtHostInitDataService)],P),e.ExtHostConsoleForwarder=P}),define(Ie[295],Ce([1,0,15,89,30,41,6,5,2,20]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=class extends P.Disposable{constructor(S,C){super();const I=S.getProxy(T.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async E=>{const n=D.URI.file((0,a.join)((0,A.tmpdir)(),(0,l.generateUuid)()));return await I.$download(E,n),n})}};O=Ve([$e(0,v.IExtHostRpcService),$e(1,R.IExtHostCommands)],O),e.ExtHostDownloadService=O}),define(Ie[296],Ce([1,0,141,18,211,30]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends a.ExtHostLoggerService{m(D,v,O){return D.scheme===A.Schemas.file?new l.SpdLogLogger(O?.name||(0,R.generateUuid)(),D.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,v):super.m(D,v,O)}registerLogger(D){super.registerLogger(D),this.n.$registerLogger(D)}deregisterLogger(D){super.deregisterLogger(D),this.n.$deregisterLogger(D)}}e.ExtHostLoggerService=P}),define(Ie[297],Ce([1,0,71,15,2,80,6,18,19,29]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==T.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const r=o.fsPath;let c=0;do{let m;c===0?m=r:m=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await k(m);const f=A.join(m,"vscode.lock"),i=await E(this.d,f,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),l.URI.file(m);c++}while(c<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function k(p){try{await v.Promises.stat(p);return}catch{}try{await v.Promises.mkdir(p,{recursive:!0})}catch{}}const S=1e3,C=10*60*1e3;class I extends P.Disposable{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.B(new D.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await n(t,o);(!r||r.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await v.Promises.utimes(o,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${o}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function E(p,t,o){try{const c={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const r=await n(p,t);return!r||r.pid!==process.pid?o?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),w(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new I(p,t))}async function n(p,t){let o;try{o=await v.Promises.readFile(t)}catch(r){return p.error(r),null}try{return JSON.parse(String(o))}catch(r){return p.error(r),null}}async function d(p,t){let o;try{o=await v.Promises.stat(t)}catch(r){return p.error(r),0}return o.mtime.getTime()}function h(p){try{return process.kill(p,0),!0}catch{return!1}}async function w(p,t){const o=await n(p,t);if(!o)return p.info(`Lock '${t}': Could not read pid of lock holder.`),y(p,t);if(o.willReleaseAt){let i=o.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,D.timeout)(Math.min(100,i)),await d(p,t)===0)return y(p,t);i=o.willReleaseAt-Date.now()}return y(p,t)}}if(!h(o.pid))return p.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),y(p,t);const r=await d(p,t),c=Date.now()-r;if(c<=C)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const m=await d(p,t),f=Date.now()-m;return f<=C?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${f} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),y(p,t))}async function y(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return E(p,t,!0)}}),define(Ie[298],Ce([1,0,30,20,42]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends l.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,D,v){return this.createTerminalFromOptions({name:T,shellPath:D,shellArgs:v})}createTerminalFromOptions(T,D){const v=new l.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(v),v.create(T,this.L(T,D)),v.value}};R=Ve([$e(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(Ie[299],Ce([1,0,5,20,192,6,26,2,47,24,29,7,14,55,3,130,103,16]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class h extends E.DisposableTunnel{}function w(i){const s=i.trim().split(`
`),u=[];return s.forEach(g=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(g);L&&L.length>=3&&u.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),u.reduce((g,L)=>(g[L.socket]=L,g),{})}e.getSockets=w;function y(...i){const s=[].concat(...i.map(t));return[...new Map(s.filter(u=>u.st==="0A").map(u=>{const b=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:p(b[0]),port:parseInt(b[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=y;function p(i){let s="";if(i.length===8)for(let u=i.length-2;u>=0;u-=2)s+=parseInt(i.substr(u,2),16),u!==0&&(s+=".");else for(let u=0;u<i.length;u+=8){const b=i.substring(u,u+8);let g="";for(let L=8;L>=2;L-=2)g+=b.substring(L-2,L),(L===6||L===2)&&(g=parseInt(g,16).toString(16),s+=`${g}`,g="",u+L!==i.length-6&&(s+=":"))}return s}e.parseIpAddress=p;function t(i){const s=i.trim().split(`
`),u=s.shift().trim().split(/\s+/).filter(g=>g!=="rx_queue"&&g!=="tm->when");return s.map(g=>g.trim().split(/\s+/).reduce((L,j,G)=>(L[u[G]||G]=j,L),{}))}e.loadConnectionTable=t;function o(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const s=i.trim().split(`
`),u=[];return s.forEach(b=>{const g=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);g&&g.length>=4&&u.push({pid:parseInt(g[1],10),ppid:parseInt(g[2]),cmd:g[3]})}),u}e.getRootProcesses=r;async function c(i,s,u){const b=u.reduce((L,j)=>(L[j.pid]=j,L),{}),g=[];return i.forEach(({socket:L,ip:j,port:G})=>{const Q=s[L]?s[L].pid:void 0,B=Q?b[Q]?.cmd:void 0;Q&&B&&!o(B)&&g.push({host:j,port:G,detail:B,pid:Q})}),g}e.findPorts=c;function m(i,s,u){const b=new Map,g=r(s);for(const L of i){const j=u.get(L.port);if(j){b.set(L.port,j);continue}const G=g.find(Q=>Q.cmd.includes(`${L.port}`));if(G){let Q=G,B;do B=g.find(U=>U.ppid===Q.pid),B&&(Q=B);while(B);b.set(L.port,{host:L.ip,port:L.port,pid:Q.pid,detail:Q.cmd,ppid:Q.ppid})}else b.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=m;let f=class extends R.Disposable{constructor(s,u,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.Emitter,this.onDidChangeTunnels=this.h.event,this.k=!1,this.l=new Map,this.n=void 0,this.p=0,this.r=new Map,this.a=s.getProxy(a.MainContext.MainThreadTunnelService),S.isLinux&&u.remote.isRemote&&u.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.t())}async openTunnel(s,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const b=await this.a.$openTunnel(u,s.displayName);if(b){const g=new h(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(g),g}}async t(){this.n=await this.w(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.n.map(s=>s.port).join(", ")}`)}async getTunnels(){return this.a.$getTunnels()}u(s){return Math.max(s*20,2e3)}v(){return this.p++}registerPortsAttributesProvider(s,u){const b=this.v();return this.r.set(b,{selector:s,provider:u}),this.a.$registerPortsAttributesProvider(s,b),new k.Disposable(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(s,u,b,g,L){const j=[];for(const Q of s){const B=this.r.get(Q);if(!B)return[];j.push(...await Promise.all(u.map(async U=>B.provider.providePortAttributes(U,b,g,L))))}const G=j.filter(Q=>!!Q);return G.length>0?G.map(Q=>({autoForwardAction:Q.autoForwardAction,port:Q.port})):[]}async $registerCandidateFinder(s){if(s&&this.k)return;this.k=s;let u;this.n&&(u=this.n,await this.a.$onFoundNewCandidates(this.n));const b=new n.MovingAverage;let g=0;for(;this.k;){const L=new Date().getTime(),j=(await this.w()).filter(B=>(0,E.isLocalhost)(B.host)||(0,E.isAllInterfaces)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(B=>B.port).join(", ")}`);const G=new Date().getTime()-L;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${G} ms.`),g++>3&&b.update(G),(!u||JSON.stringify(u)!==JSON.stringify(j))&&(u=j,await this.a.$onFoundNewCandidates(u));const Q=this.u(b.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${Q} ms.`),await new Promise(B=>setTimeout(()=>B(),Q))}}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter()),s.tunnelFactory){this.b=s.tunnelFactory;let u=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const b=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:u}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(s,u){if(this.g.has(s.host)){const b=this.g.get(s.host);b.has(s.port)&&(u&&b.get(s.port).disposeListener.dispose(),await b.get(s.port).tunnel.dispose(),b.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(s,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const g=await b;this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const L=this.B(g.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(g.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:g,disposeListener:L}),C.TunnelDtoConverter.fromApiTunnel(g)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const u=await Promise.all(s.map(g=>this.f(g.host,g.port,g.detail??""))),b=s.filter((g,L)=>u[L]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(g=>g.port).join(", ")} to ${b.map(g=>g.port).join(", ")}`),b}async w(){let s="",u="";try{s=await O.Promises.readFile("/proc/net/tcp","utf8"),u=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const b=y(s,u),g=await new Promise(M=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,fe,re)=>{M(fe)})}),L=w(g),j=await O.Promises.readdir("/proc"),G=[];for(const M of j)try{const x=Number(M),fe=v.joinPath(T.URI.file("/proc"),M);if((await O.Promises.stat(fe.fsPath)).isDirectory()&&!isNaN(x)){const V=await O.Promises.readlink(v.joinPath(fe,"cwd").fsPath),_=await O.Promises.readFile(v.joinPath(fe,"cmdline").fsPath,"utf8");G.push({pid:x,cwd:V,cmd:_})}}catch{}const Q=[],B=b.filter(M=>{const x=L[M.socket];return x||Q.push(M),x}),U=c(B,L,G);let z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Q.length}`),Q.length>0){const M=await new Promise(x=>{(0,D.exec)("ps -F -A -l | grep root",(fe,re,V)=>{x(re)})});this.l=m(Q,M,this.l),z=Array.from(this.l.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.map(x=>x.port).join(", ")}`)}return U.then(M=>z?M.concat(z):M)}};f=Ve([$e(0,A.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,d.ILogService)],f),e.ExtHostTunnelService=f}),define(Ie[300],Ce([1,0,19,22,21,8,3,6,115,256,58]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(b,g){try{return JSON.stringify(b,g)}catch{return"null"}}const C="$$ref$$",I={[C]:-1};class E{constructor(g,L){this.jsonString=g,this.referencedBuffers=L}}function n(b,g=null,L=!1){const j=[];return{jsonString:(L?S:JSON.stringify)(b,(Q,B)=>{if(typeof B>"u")return I;if(typeof B=="object"){if(B instanceof A.VSBuffer){const U=j.push(B)-1;return{[C]:U}}if(g)return g(Q,B)}return B}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=n;function d(b,g,L){return JSON.parse(b,(j,G)=>{if(G){const Q=G[C];if(typeof Q=="number")return g[Q];if(L&&G.$mid===1)return L.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=d;function h(b,g){return JSON.stringify(b,g)}function w(b){return b?(g,L)=>L&&L.$mid===1?b.transformOutgoing(L):L:null}var y;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends T.Disposable{constructor(g,L=null,j=null){super(),this[k]=!0,this.b=this.B(new P.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=g,this.f=L,this.g=j,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,Q=O.ProxyIdentifier.count;G<Q;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(g=>{this.s[g].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(g){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(g){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(g){this.t!==g&&(this.t=g,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(g){return this.g?(0,D.transformIncomingURIs)(g,this.g):g}getProxy(g){const{nid:L,sid:j}=g;return this.l[L]||(this.l[L]=this.F(L,j)),this.l[L]}F(g,L){const j={get:(G,Q)=>(typeof Q=="string"&&!G[Q]&&Q.charCodeAt(0)===36&&(G[Q]=(...B)=>this.O(g,Q,B)),Q===r?L:G[Q])};return new Proxy(Object.create(null),j)}set(g,L){return this.k[g.nid]=L,L}assertRegistered(g){for(let L=0,j=g.length;L<j;L++){const G=g[L];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(g){if(this.j)return;const L=g.byteLength,j=m.read(g,0),G=j.readUInt8(),Q=j.readUInt32();switch(G){case 1:case 2:{let{rpcId:B,method:U,args:z}=i.deserializeRequestJSONArgs(j);this.g&&(z=(0,D.transformIncomingURIs)(z,this.g)),this.H(L,Q,B,U,z,G===2);break}case 3:case 4:{let{rpcId:B,method:U,args:z}=i.deserializeRequestMixedArgs(j);this.g&&(z=(0,D.transformIncomingURIs)(z,this.g)),this.H(L,Q,B,U,z,G===4);break}case 5:{this.f?.logIncoming(L,Q,0,"ack"),this.z(Q);break}case 6:{this.I(L,Q);break}case 7:{this.J(L,Q,void 0);break}case 9:{let B=i.deserializeReplyOKJSON(j);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.J(L,Q,B);break}case 10:{const B=i.deserializeReplyOKJSONWithBuffers(j,this.g);this.J(L,Q,B);break}case 8:{const B=i.deserializeReplyOKVSBuffer(j);this.J(L,Q,B);break}case 11:{let B=i.deserializeReplyErrError(j);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.L(L,Q,B);break}case 12:{this.L(L,Q,void 0);break}default:console.error("received unexpected message"),console.error(g)}}H(g,L,j,G,Q,B){this.f?.logIncoming(g,L,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(j)}.${G}(`,Q);const U=String(L);let z,M;if(B){const fe=new l.CancellationTokenSource;Q.push(fe.token),z=this.M(j,G,Q),M=()=>fe.cancel()}else z=this.M(j,G,Q),M=t;this.p[U]=M;const x=i.serializeAcknowledged(L);this.f?.logOutgoing(x.byteLength,L,1,"ack"),this.c.send(x),z.then(fe=>{delete this.p[U];const re=i.serializeReplyOK(L,fe,this.h);this.f?.logOutgoing(re.byteLength,L,1,"reply:",fe),this.c.send(re)},fe=>{delete this.p[U];const re=i.serializeReplyErr(L,fe);this.f?.logOutgoing(re.byteLength,L,1,"replyErr:",fe),this.c.send(re)})}I(g,L){this.f?.logIncoming(g,L,1,"receiveCancel");const j=String(L);this.p[j]?.()}J(g,L,j){this.f?.logIncoming(g,L,0,"receiveReply:",j);const G=String(L);if(!this.s.hasOwnProperty(G))return;const Q=this.s[G];delete this.s[G],Q.resolveOk(j)}L(g,L,j){this.f?.logIncoming(g,L,0,"receiveReplyErr:",j);const G=String(L);if(!this.s.hasOwnProperty(G))return;const Q=this.s[G];delete this.s[G];let B;j&&(j.$isError?(B=new Error,B.name=j.name,B.message=j.message,B.stack=j.stack):B=j),Q.resolveErr(B)}M(g,L,j){try{return Promise.resolve(this.N(g,L,j))}catch(G){return Promise.reject(G)}}N(g,L,j){const G=this.k[g];if(!G)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(g));const Q=G[L];if(typeof Q!="function")throw new Error("Unknown method "+L+" on actor "+(0,O.getStringIdentifierForProxy)(g));return Q.apply(G,j)}O(g,L,j){if(this.j)return new v.CanceledLazyPromise;let G=null;if(j.length>0&&l.CancellationToken.isCancellationToken(j[j.length-1])&&(G=j.pop()),G&&G.isCancellationRequested)return Promise.reject(R.canceled());const Q=i.serializeRequestArguments(j,this.h),B=++this.m,U=String(B),z=new v.LazyPromise;G&&G.onCancellationRequested(()=>{const x=i.serializeCancel(B);this.f?.logOutgoing(x.byteLength,B,0,"cancel"),this.c.send(i.serializeCancel(B))}),this.s[U]=z,this.y(B);const M=i.serializeRequest(B,g,L,Q,!!G);return this.f?.logOutgoing(M.byteLength,B,0,`request: ${(0,O.getStringIdentifierForProxy)(g)}.${L}(`,j),this.c.send(M),z}}k=o,c.a=3*1e3,e.RPCProtocol=c;class m{static alloc(g,L,j){const G=new m(A.VSBuffer.alloc(j+1+4),0);return G.writeUInt8(g),G.writeUInt32(L),G}static read(g,L){return new m(g,L)}get buffer(){return this.a}constructor(g,L){this.a=g,this.b=L}static sizeUInt8(){return 1}writeUInt8(g){this.a.writeUInt8(g,this.b),this.b+=1}readUInt8(){const g=this.a.readUInt8(this.b);return this.b+=1,g}writeUInt32(g){this.a.writeUInt32BE(g,this.b),this.b+=4}readUInt32(){const g=this.a.readUInt32BE(this.b);return this.b+=4,g}static sizeShortString(g){return 1+g.byteLength}writeShortString(g){this.a.writeUInt8(g.byteLength,this.b),this.b+=1,this.a.set(g,this.b),this.b+=g.byteLength}readShortString(){const g=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+g).toString();return this.b+=g,j}static sizeLongString(g){return 4+g.byteLength}writeLongString(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}readLongString(){const g=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+g).toString();return this.b+=g,j}writeBuffer(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}static sizeVSBuffer(g){return 4+g.byteLength}writeVSBuffer(g){this.a.writeUInt32BE(g.byteLength,this.b),this.b+=4,this.a.set(g,this.b),this.b+=g.byteLength}readVSBuffer(){const g=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+g);return this.b+=g,L}static sizeMixedArray(g){let L=0;L+=1;for(let j=0,G=g.length;j<G;j++){const Q=g[j];switch(L+=1,Q.type){case 1:L+=this.sizeLongString(Q.value);break;case 2:L+=this.sizeVSBuffer(Q.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(Q.value);for(let B=0;B<Q.buffers.length;++B)L+=this.sizeVSBuffer(Q.buffers[B]);break;case 4:break}}return L}writeMixedArray(g){this.a.writeUInt8(g.length,this.b),this.b+=1;for(let L=0,j=g.length;L<j;L++){const G=g[L];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let Q=0;Q<G.buffers.length;++Q)this.writeBuffer(G.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const g=this.a.readUInt8(this.b);this.b+=1;const L=new Array(g);for(let j=0;j<g;j++)switch(this.readUInt8()){case 1:L[j]=this.readLongString();break;case 2:L[j]=this.readVSBuffer();break;case 3:{const Q=this.readUInt32(),B=this.readLongString(),U=[];for(let z=0;z<Q;++z)U.push(this.readVSBuffer());L[j]=new O.SerializableObjectWithBuffers(d(B,U,null));break}case 4:L[j]=void 0;break}return L}}m.sizeUInt32=4;var f;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(f||(f={}));class i{static a(g){for(let L=0,j=g.length;L<j;L++)if(g[L]instanceof A.VSBuffer||g[L]instanceof O.SerializableObjectWithBuffers||typeof g[L]>"u")return!0;return!1}static serializeRequestArguments(g,L){if(this.a(g)){const j=[];for(let G=0,Q=g.length;G<Q;G++){const B=g[G];if(B instanceof A.VSBuffer)j[G]={type:2,value:B};else if(typeof B>"u")j[G]={type:4};else if(B instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=n(B.value,L);j[G]={type:3,value:A.VSBuffer.fromString(U),buffers:z}}else j[G]={type:1,value:A.VSBuffer.fromString(h(B,L))}}return{type:1,args:j}}return{type:0,args:h(g,L)}}static serializeRequest(g,L,j,G,Q){switch(G.type){case 0:return this.b(g,L,j,G.args,Q);case 1:return this.c(g,L,j,G.args,Q)}}static b(g,L,j,G,Q){const B=A.VSBuffer.fromString(j),U=A.VSBuffer.fromString(G);let z=0;z+=m.sizeUInt8(),z+=m.sizeShortString(B),z+=m.sizeLongString(U);const M=m.alloc(Q?2:1,g,z);return M.writeUInt8(L),M.writeShortString(B),M.writeLongString(U),M.buffer}static deserializeRequestJSONArgs(g){const L=g.readUInt8(),j=g.readShortString(),G=g.readLongString();return{rpcId:L,method:j,args:JSON.parse(G)}}static c(g,L,j,G,Q){const B=A.VSBuffer.fromString(j);let U=0;U+=m.sizeUInt8(),U+=m.sizeShortString(B),U+=m.sizeMixedArray(G);const z=m.alloc(Q?4:3,g,U);return z.writeUInt8(L),z.writeShortString(B),z.writeMixedArray(G),z.buffer}static deserializeRequestMixedArgs(g){const L=g.readUInt8(),j=g.readShortString(),G=g.readMixedArray(),Q=new Array(G.length);for(let B=0,U=G.length;B<U;B++){const z=G[B];typeof z=="string"?Q[B]=JSON.parse(z):Q[B]=z}return{rpcId:L,method:j,args:Q}}static serializeAcknowledged(g){return m.alloc(5,g,0).buffer}static serializeCancel(g){return m.alloc(6,g,0).buffer}static serializeReplyOK(g,L,j){if(typeof L>"u")return this.d(g);if(L instanceof A.VSBuffer)return this.e(g,L);if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:Q}=n(L.value,j,!0);return this.g(g,G,Q)}else return this.f(g,S(L,j))}static d(g){return m.alloc(7,g,0).buffer}static e(g,L){let j=0;j+=m.sizeVSBuffer(L);const G=m.alloc(8,g,j);return G.writeVSBuffer(L),G.buffer}static deserializeReplyOKVSBuffer(g){return g.readVSBuffer()}static f(g,L){const j=A.VSBuffer.fromString(L);let G=0;G+=m.sizeLongString(j);const Q=m.alloc(9,g,G);return Q.writeLongString(j),Q.buffer}static g(g,L,j){const G=A.VSBuffer.fromString(L);let Q=0;Q+=m.sizeUInt32,Q+=m.sizeLongString(G);for(const U of j)Q+=m.sizeVSBuffer(U);const B=m.alloc(10,g,Q);B.writeUInt32(j.length),B.writeLongString(G);for(const U of j)B.writeBuffer(U);return B.buffer}static deserializeReplyOKJSON(g){const L=g.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(g,L){const j=g.readUInt32(),G=g.readLongString(),Q=[];for(let B=0;B<j;++B)Q.push(g.readVSBuffer());return new O.SerializableObjectWithBuffers(d(G,Q,L))}static serializeReplyErr(g,L){const j=L?S(R.transformErrorForSerialization(L),null):void 0;if(typeof j!="string")return this.h(g);const G=A.VSBuffer.fromString(j);let Q=0;Q+=m.sizeLongString(G);const B=m.alloc(11,g,Q);return B.writeLongString(G),B.buffer}static deserializeReplyErrError(g){const L=g.readLongString();return JSON.parse(L)}static h(g){return m.alloc(12,g,0).buffer}}var s;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var u;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(u||(u={}))}),define(Ie[301],Ce([1,0,3,40,44,4]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var P;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(O=>v.push(O)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}A.Registry.add(e.Extensions.OutputChannels,new T),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(Ie[143],Ce([1,0,5,4,20,25,16,301,79,26,49,160,22,10,45,3,6]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends P.AbstractMessageLogger{get disposed(){return this.l}constructor(p,t,o,r,c){super(),this.id=p,this.name=t,this.m=o,this.n=r,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.k;this.info(p),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(p,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.n.$close(this.id)}g(p,t){this.k+=S.VSBuffer.fromString(t).byteLength,(0,P.log)(this.m,p,t),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class h extends d{appendLine(p){this.append(p)}}let w=class{constructor(p,t,o,r,c,m){this.i=t,this.j=o,this.k=r,this.l=c,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(p,t,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,C.isString)(t)?t:void 0;if((0,C.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([s])=>R.ExtensionIdentifier.equals(o.identifier,s))?.[1];f&&(m=(0,P.parseLogLevel)(f));const i=r?this.o(p,m,o):this.n(p,c,o);return i.then(s=>{this.g.set(s.id,s),s.visible=s.id===this.h}),r?this.r(p,m??this.m.getLevel(),i):this.q(p,i)}async n(p,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(p,c,t,o.identifier.value);return new d(f,p,m,this.a,o)}async o(p,t,o){const r=await this.p(o),c=p.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(r,`${c}.log`),f=`${o.identifier.value}.${c}`,i=this.l.createLogger(m,{id:f,name:p,logLevel:t,extensionId:o.identifier.value});return new h(f,p,i,this.a,o)}p(p){let t=this.d.get(p.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(r){if((0,I.toFileSystemProviderErrorCode)(r)!==I.FileSystemProviderErrorCode.FileExists)throw r}return o})())}return t}q(p,t){let o=!1;const r=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(c){r(),t.then(m=>m.append(c))},appendLine(c){r(),t.then(m=>m.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(m=>m.replace(c))},show(c,m){r(),t.then(f=>f.show(c,m))},hide(){r(),t.then(c=>c.hide())},dispose(){o=!0,t.then(c=>c.dispose())}}}r(p,t,o){const r=new n.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},m=r.add(new E.Emitter);function f(i){t=i,m.fire(i)}return o.then(i=>{r.add(i),i.logLevel!==t&&f(i.logLevel),r.add(i.onDidChangeLogLevel(s=>f(s)))}),{...this.q(p,o),get logLevel(){return t},onDidChangeLogLevel:m.event,trace(i,...s){c(),o.then(u=>u.trace(i,...s))},debug(i,...s){c(),o.then(u=>u.debug(i,...s))},info(i,...s){c(),o.then(u=>u.info(i,...s))},warn(i,...s){c(),o.then(u=>u.warn(i,...s))},error(i,...s){c(),o.then(u=>u.error(i,...s))},dispose(){r.dispose()}}}};w=Ve([$e(0,l.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,D.IExtHostConsumerFileSystem),$e(3,O.IExtHostFileSystemInfo),$e(4,P.ILoggerService),$e(5,P.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Ie[302],Ce([1,0,4]),function(se,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ie[303],Ce([1,0,33,18,15,14,24,2,4,224,48,242,302]),function(se,e,a,A,l,R,P,T,D,v,O,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let C=class mn{constructor(E,n,d,h){this.d=E,this.e=n,this.f=d,this.g=h,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??E})()}hasValidBasename(E,n,d){return typeof n=="string"||typeof n>"u"?this.a.then(h=>this.h(E,h,n)):this.h(E,n,d)}h(E,n,d){return E.scheme===A.Schemas.file||E.scheme===A.Schemas.vscodeRemote?(0,a.isValidBasename)(d??(0,P.basename)(E),n===1):!0}get defaultUriScheme(){return mn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(E,n){if(E.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,v.getVirtualWorkspaceScheme)(n.getWorkspace());if(d)return d;const h=n.getWorkspace().folders[0];if(h)return h.uri.scheme;const w=n.getWorkspace().configuration;return w?w.scheme:A.Schemas.file}userHome(E){return E?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(E=>E===1?l.win32:l.posix)}async fileURI(E){let n="";if(await this.a===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const h=E.indexOf("/",2);h===-1?(n=E.substring(2),E="/"):(n=E.substring(2,h),E=E.substring(h)||"/")}return T.URI.from({scheme:A.Schemas.file,authority:n,path:E,query:"",fragment:""})}};C=Ve([$e(1,S.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(Ie[82],Ce([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(P,T){this.line=P,this.character=T}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,T){return new a(0,0)}with(P){return new a(0,0)}}e.Position=a;class A{constructor(P,T,D,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(P,T),this.end=new a(D,v)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new A(0,0,0,0)}with(P){return new A(0,0,0,0)}}e.Range=A;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],Ce([1,0,17,39,23,33,9,4,15,8,82,19]),function(se,e,a,A,l,R,P,T,D,v,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",C=" characters skipped \u27EB",I=(S.length+C.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var E;(function(_){_[_.file=0]="file",_[_.text=1]="text"})(E=e.SearchProviderType||(e.SearchProviderType={}));var n;(function(_){_[_.File=1]="File",_[_.Text=2]="Text"})(n=e.QueryType||(e.QueryType={}));function d(_){return!!_.preview}e.resultIsMatch=d;function h(_){return!!_.resource}e.isFileMatch=h;function w(_){return!!_.message}e.isProgressMessage=w;var y;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(y=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=p;class t{constructor(te,ve,le){this.ranges=ve;const ue=Array.isArray(ve)?ve:[ve];if(le&&le.matchLines===1&&o(ue)){te=(0,P.getNLines)(te,le.matchLines);let q="",F=0,J=0;const ge=Math.floor(le.charsPerLine/5),Ee=[];for(const ie of ue){const ne=Math.max(ie.startColumn-ge,0),de=ie.startColumn+le.charsPerLine;if(ne>J+ge+I){const ee=S+(ne-J)+C;q+=ee+te.slice(ne,de),F+=ne-(J+ee.length)}else q+=te.slice(J,de);Ee.push(new c(0,ie.startColumn-F,ie.endColumn-F)),J=de}this.preview={text:q,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const q=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:te,matches:(0,a.mapArrayOrNot)(ve,F=>new r(F.startLineNumber-q,F.startColumn,F.endLineNumber-q,F.endColumn))}}}}e.TextSearchMatch=t;function o(_){const te=_[0].startLineNumber;for(const ve of _)if(ve.startLineNumber!==te||ve.endLineNumber!==te)return!1;return!0}class r{constructor(te,ve,le,ue){this.startLineNumber=te,this.startColumn=ve,this.endLineNumber=le,this.endColumn=ue}}e.SearchRange=r;class c extends r{constructor(te,ve,le){super(te,ve,te,le)}}e.OneLineRange=c;var m;(function(_){_.List="list",_.Tree="tree"})(m=e.ViewMode||(e.ViewMode={}));var f;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function i(_,te=!0){const ve=_&&_.files&&_.files.exclude,le=te&&_&&_.search&&_.search.exclude;if(!ve&&!le)return;if(!ve||!le)return ve||le;let ue=Object.create(null);return ue=l.mixin(ue,l.deepClone(ve)),ue=l.mixin(ue,l.deepClone(le),!0),ue}e.getExcludes=i;function s(_,te){return _.excludePattern&&A.match(_.excludePattern,te)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&A.match(_.includePattern,te)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(ve=>{const le=ve.folder.fsPath;if(R.isEqualOrParent(te,le)){const ue=D.relative(le,te);return!ve.includePattern||!!A.match(ve.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var u;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(te,ve){super(te),this.code=ve}}e.SearchError=b;function g(_){const te=_.message;if((0,v.isCancellationError)(_))return new b(te,u.canceled);try{const ve=JSON.parse(te);return new b(ve.message,ve.code)}catch{return new b(te,u.other)}}e.deserializeSearchError=g;function L(_){const te={message:_.message,code:_.code};return new Error(JSON.stringify(te))}e.serializeSearchError=L;function j(_){return _.type==="error"?!0:_.type==="success"}e.isSerializedSearchComplete=j;function G(_){return _.type==="success"}e.isSerializedSearchSuccess=G;function Q(_){return!!_.path}e.isSerializedFileMatch=Q;function B(_,te){const ve=_.searchPath?_.searchPath:_.relativePath;return(0,P.fuzzyContains)(ve,te)}e.isFilePatternMatch=B;class U{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function z(_,te){const ve={..._||{},...te||{}};return Object.keys(ve).filter(le=>{const ue=ve[le];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=z;class M{constructor(te,ve){this.c=null,this.a={...te.excludePattern||{},...ve.excludePattern||{}},this.b=A.parse(this.a);let le=te.includePattern;ve.includePattern&&(le?le={...le,...ve.includePattern}:le=ve.includePattern),le&&(this.c=A.parse(le))}matchesExcludesSync(te,ve,le){return!!(this.b&&this.b(te,ve,le))}includedInQuerySync(te,ve,le){return!(this.b&&this.b(te,ve,le)||this.c&&!this.c(te,ve,le))}includedInQuery(te,ve,le){const ue=this.b(te,ve,le),q=()=>this.c?!!this.c(te,ve,le):!0;return(0,k.isThenable)(ue)?ue.then(F=>F?!1:q()):q()}hasSiblingExcludeClauses(){return x(this.a)}}e.QueryGlobTester=M;function x(_){for(const te in _)if(typeof _[te]!="boolean")return!0;return!1}function fe(_){if(!_)return;let te;return ve=>(te||(te=(_()||Promise.resolve([])).then(le=>le?V(le):{})),te.then(le=>!!le[ve]))}e.hasSiblingPromiseFn=fe;function re(_){if(!_)return;let te;return ve=>{if(!te){const le=_();te=le?V(le):{}}return!!te[ve]}}e.hasSiblingFn=re;function V(_){const te={};for(const ve of _)te[ve]=!0;return te}}),define(Ie[34],Ce([1,0,17,19,21,3,6,69,18,103,24,9,10,2,190,4,16,212,48,49,26,20,11,7,56,31,5]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t,o,r,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(G,Q,B){return new O.ExtUri(U=>b(U,B)).isEqual(G,Q)}function i(G,Q,B){return f(G.uri,Q.uri,B)?0:(0,k.compare)(G.uri.toString(),Q.uri.toString())}function s(G,Q,B){return G.index!==Q.index?G.index<Q.index?-1:1:f(G.uri,Q.uri,B)?(0,k.compare)(G.name,Q.name):(0,k.compare)(G.uri.toString(),Q.uri.toString())}function u(G,Q,B,U){const z=G.slice(0).sort((x,fe)=>B(x,fe,U)),M=Q.slice(0).sort((x,fe)=>B(x,fe,U));return(0,a.delta)(z,M,(x,fe)=>B(x,fe,U))}function b(G,Q){const B=Q.getCapabilities(G.scheme);return!(B&&B&1024)}class g extends h.Workspace{static toExtHostWorkspace(Q,B,U,z){if(!Q)return{workspace:null,added:[],removed:[]};const{id:M,name:x,folders:fe,configuration:re,transient:V,isUntitled:_}=Q,te=[],ve=B;B?fe.forEach((F,J)=>{const ge=C.URI.revive(F.uri),Ee=g.o(U||B,ge,z);Ee?(Ee.name=F.name,Ee.index=F.index,te.push(Ee)):te.push({uri:ge,name:F.name,index:J})}):te.push(...fe.map(({uri:F,name:J,index:ge})=>({uri:C.URI.revive(F),name:J,index:ge}))),te.sort((F,J)=>F.index<J.index?-1:1);const le=new g(M,x,te,!!V,re?C.URI.revive(re):null,!!_,F=>b(F,z)),{added:ue,removed:q}=u(ve?ve.workspaceFolders:[],le.workspaceFolders,i,z);return{workspace:le,added:ue,removed:q}}static o(Q,B,U){for(let z=0;z<Q.folders.length;z++){const M=Q.workspaceFolders[z];if(f(M.uri,B,U))return M}}constructor(Q,B,U,z,M,x,fe){super(Q,U.map(re=>new h.WorkspaceFolder(re)),z,M,fe),this.t=B,this.u=x,this.q=[],this.s=T.TernarySearchTree.forUris(fe),U.forEach(re=>{this.q.push(re),this.s.set(re.uri,re)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Q,B){return B&&this.s.get(Q)&&(Q=(0,O.dirname)(Q)),this.s.findSubstr(Q)}resolveWorkspaceFolder(Q){return this.s.get(Q)}}let L=class{constructor(Q,B,U,z,M){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=z,this.s=U,this.t=M,this.j=new v.Counter,this.k=new A.Barrier,this.o=Q.getProxy(m.MainContext.MainThreadWorkspace),this.q=Q.getProxy(m.MainContext.MainThreadMessageService);const x=B.workspace;this.l=x?new g(x.id,x.name,[],!!x.transient,x.configuration?C.URI.revive(x.configuration):null,!!x.isUntitled,fe=>b(fe,U)):void 0}$initializeWorkspace(Q,B){this.v=B,this.$acceptWorkspaceData(Q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?C.URI.from({scheme:D.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Q,B,U,...z){const M=[];if(Array.isArray(z)&&z.forEach(_=>{C.URI.isUri(_.uri)&&!M.some(te=>f(te.uri,_.uri,this.s))&&M.push({uri:_.uri,name:_.name||(0,O.basenameOrAuthority)(_.uri)})}),this.n||[B,U].some(_=>typeof _!="number"||_<0)||U===0&&M.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(B+U>x.length)return!1;const fe=x.slice(0);fe.splice(B,U,...M.map(_=>({uri:_.uri,name:_.name||(0,O.basenameOrAuthority)(_.uri),index:void 0})));for(let _=0;_<fe.length;_++){const te=fe[_];if(fe.some((ve,le)=>le!==_&&f(te.uri,ve.uri,this.s)))return!1}fe.forEach((_,te)=>_.index=te);const{added:re,removed:V}=u(x,fe,s,this.s);if(re.length===0&&V.length===0)return!1;if(this.o){const _=Q.displayName||Q.name;this.o.$updateWorkspaceFolders(_,B,U,M).then(void 0,te=>{this.n=void 0;const ve={source:{identifier:Q.identifier,label:Q.displayName||Q.name}};this.q.$showMessage(d.Severity.Error,(0,I.localize)(0,null,_,te.toString()),ve,[])})}return this.y(fe),!0}getWorkspaceFolder(Q,B){if(!!this.x)return this.x.getWorkspaceFolder(Q,B)}async getWorkspaceFolder2(Q,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Q,B)}async resolveWorkspaceFolder(Q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Q)}getPath(){if(!this.x)return;const{folders:Q}=this.x;if(Q.length!==0)return Q[0].uri.fsPath}getRelativePath(Q,B){let U,z="";if(typeof Q=="string"?(U=C.URI.file(Q),z=Q):typeof Q<"u"&&(U=Q,z=Q.fsPath),!U)return z;const M=this.getWorkspaceFolder(U,!0);if(!M)return z;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let x=(0,O.relativePath)(M.uri,U);return B&&M.name&&(x=`${M.name}/${x}`),x}y(Q){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Q){const{workspace:B,added:U,removed:z}=g.toExtHostWorkspace(Q,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:z}))}findFiles(Q,B,U,z,M=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let x;if(B===null?x=!1:B&&(typeof B=="string"?x=B:x=B.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:re}=j(t.GlobPattern.from(Q));return this.o.$startFileSearch((0,S.withUndefinedAsNull)(fe),(0,S.withUndefinedAsNull)(re),(0,S.withUndefinedAsNull)(x),(0,S.withUndefinedAsNull)(U),M).then(V=>Array.isArray(V)?V.map(_=>C.URI.revive(_)):[])}async findTextInFiles(Q,B,U,z,M=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),fe=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:re,folder:V}=j(t.GlobPattern.from(B.include)),_=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,te={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:fe,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:re,excludePattern:_},ve=!1;if(this.u[x]=le=>{if(ve)return;const ue=C.URI.revive(le.resource);le.results.forEach(q=>{(0,c.resultIsMatch)(q)?U({uri:ue,preview:{text:q.preview.text,matches:(0,a.mapArrayOrNot)(q.preview.matches,F=>new o.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))},ranges:(0,a.mapArrayOrNot)(q.ranges,F=>new o.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))}):U({uri:ue,text:q.text,lineNumber:q.lineNumber})})},M.isCancellationRequested)return{};try{const le=await this.o.$startTextSearch(Q,(0,S.withUndefinedAsNull)(V),te,x,M);return delete this.u[x],le||{}}catch(le){throw delete this.u[x],le}}$handleTextSearchResult(Q,B){this.u[B]?.(Q)}saveAll(Q){return this.o.$saveAll(Q)}resolveProxy(Q){return this.o.$resolveProxy(Q)}get trusted(){return this.v}requestWorkspaceTrust(Q){return this.o.$requestWorkspaceTrust(Q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Q,B){if(this.w.has(Q))throw new Error(`A provider has already been registered for scheme ${Q}`);this.w.set(Q,B);const U=this.t.transformOutgoingScheme(Q),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,U),(0,P.toDisposable)(()=>{this.w.delete(Q),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(Q,B){this.h.info("Getting edit session identifier for workspaceFolder",Q);const U=await this.resolveWorkspaceFolder(C.URI.revive(Q));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const z=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!z),!z)return;const M=await z.provideEditSessionIdentity(U,B);if(this.h.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(Q,B,U,z){this.h.info("Getting edit session identifier for workspaceFolder",Q);const M=await this.resolveWorkspaceFolder(C.URI.revive(Q));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const x=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!x),!x)return;const fe=await x.provideEditSessionIdentityMatch?.(B,U,z);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(Q){return(B,U,z)=>{const M=function(fe){B.call(U,fe)};return M.extension=Q,this.A.event(M,void 0,z)}}async $onWillCreateEditSessionIdentity(Q,B,U){const z=await this.resolveWorkspaceFolder(C.URI.revive(Q));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},B,async(M,x)=>{const fe=Date.now();await Promise.resolve(M),Date.now()-fe>U&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),B.isCancellationRequested}};L=Ve([$e(0,p.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,w.IExtHostFileSystemInfo),$e(3,n.ILogService),$e(4,r.IURITransformerService)],L),e.ExtHostWorkspace=L,e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function j(G){let Q,B;return G&&(typeof G=="string"?Q=G:(Q=G.pattern,B=C.URI.revive(G.baseUri))),{includePattern:Q,folder:B}}}),define(Ie[35],Ce([1,0,23,3,34,5,7,215,127,10,19,4,20,16,2]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function E(o,r){if(r){const c=r.split(".");let m=o;for(let f=0;m&&f<c.length;f++)m=m[c[f]];return m}}function n(o){return o instanceof I.URI}function d(o){return o&&o.uri instanceof I.URI&&o.languageId&&typeof o.languageId=="string"}function h(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function w(o){return o&&o.uri instanceof I.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(n(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(h(o))return{overrideIdentifier:o.languageId};if(w(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(r,c,m){this.a=r.getProxy(R.MainContext.MainThreadConfiguration),this.c=c,this.b=m,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(r,c))}};p=Ve([$e(0,S.IExtHostRpcService),$e(1,l.IExtHostWorkspace),$e(2,C.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,c,m,f){this.a=new A.Emitter,this.b=r,this.f=f,this.c=c,this.e=T.Configuration.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,m))}getConfiguration(r,c,m){const f=y(c)||{},i=this.g(r?E(this.e.getValue(void 0,f,this.c.workspace),r):this.e.getValue(void 0,f,this.c.workspace));r&&this.h(r,f,m?.identifier);function s(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(b){return typeof E(i,b)<"u"},get:(b,g)=>{this.h(r?`${r}.${b}`:b,f,m?.identifier);let L=E(i,b);if(typeof L>"u")L=g;else{let j;const G=(Q,B)=>{let U;const z=()=>{j=j||(0,a.deepClone)(i),U=U||E(j,B)};return(0,v.isObject)(Q)?new Proxy(Q,{get:(M,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>U;if(j)return U=U||E(j,B),U[x];const fe=M[x];return typeof x=="string"?G(fe,`${B}.${x}`):fe},set:(M,x,fe)=>(z(),U&&(U[x]=fe),!0),deleteProperty:(M,x)=>(z(),U&&delete U[x],!0),defineProperty:(M,x,fe)=>(z(),U&&Object.defineProperty(U,x,fe),!0)}):Q};L=G(L,b)}return L},update:(b,g,L,j)=>{b=r?`${r}.${b}`:b;const G=s(L);return g!==void 0?this.b.$updateConfigurationOption(G,b,g,f,j):this.b.$removeConfigurationOption(G,b,f,j)},inspect:b=>{b=r?`${r}.${b}`:b;const g=this.e.inspect(b,f,this.c.workspace);if(g)return{key:b,defaultValue:(0,a.deepClone)(g.policy?.value??g.default?.value),globalValue:(0,a.deepClone)(g.user?.value??g.application?.value),workspaceValue:(0,a.deepClone)(g.workspace?.value),workspaceFolderValue:(0,a.deepClone)(g.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(g.default?.override),globalLanguageValue:(0,a.deepClone)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,a.deepClone)(g.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(g.workspaceFolder?.override),languageIds:(0,a.deepClone)(g.overrideIdentifiers)}}};return typeof i=="object"&&(0,a.mixin)(u,i,!1),Object.freeze(u)}g(r){const c=m=>(0,v.isObject)(m)?new Proxy(m,{get:(f,i)=>c(f[i]),set:(f,i,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(f,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(f,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return c(r)}h(r,c,m){const f=D.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),i=m?`[${m.value}] `:"";if(f===4){typeof c?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){c?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const m=new T.ConfigurationChangeEvent(r,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,i)=>m.affectsConfiguration(f,y(i))})}k(r){return r.reduce((c,m)=>(c.set(m[0],m[1]),c),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[83],Ce([1,0,2,19,3,5,7,34,59,35,21,42,20,26,4,18,14,16,78,255,8]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(Q){function B(z){if(z!=null)return z}Q.from=B;function U(z){if(z!=null)return z}Q.to=U})(t||(t={}));var o;(function(Q){function B(z){if(z!=null)return z}Q.from=B;function U(z){if(z!=null)return z}Q.to=U})(o||(o={}));var r;(function(Q){function B(z){if(z!=null)return z}Q.from=B;function U(z){if(z!=null)return z}Q.to=U})(r||(r={}));var c;(function(Q){function B(M){if(M){const x=M;return x&&!!x.process}else return!1}Q.is=B;function U(M){if(M==null)return;const x={process:M.process,args:M.args};return M.options&&(x.options=r.from(M.options)),x}Q.from=U;function z(M){if(M!=null)return new P.ProcessExecution(M.process,M.args,M.options)}Q.to=z})(c||(c={}));var m;(function(Q){function B(z){if(z!=null)return z}Q.from=B;function U(z){if(z!=null)return z}Q.to=U})(m||(m={}));var f;(function(Q){function B(M){if(M){const x=M;return x&&(!!x.commandLine||!!x.command)}else return!1}Q.is=B;function U(M){if(M==null)return;const x={};return M.commandLine!==void 0?x.commandLine=M.commandLine:(x.command=M.command,x.args=M.args),M.options&&(x.options=m.from(M.options)),x}Q.from=U;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new P.ShellExecution(M.commandLine,M.options):new P.ShellExecution(M.command,M.args?M.args:[],M.options)}Q.to=z})(f||(f={}));var i;(function(Q){function B(M){if(M){const x=M;return x&&x.customExecution==="customExecution"}else return!1}Q.is=B;function U(M){return{customExecution:"customExecution"}}Q.from=U;function z(M,x){return x.get(M)}Q.to=z})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(Q){function B(U,z){let M;return U.scope!==void 0&&typeof U.scope!="number"?M=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===P.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=w.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:M}}Q.from=B})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(Q){function B(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}Q.from=B})(u||(u={}));var b;(function(Q){function B(M,x){if(M==null)return[];const fe=[];for(const re of M){const V=U(re,x);V&&fe.push(V)}return fe}Q.fromMany=B;function U(M,x){if(M==null)return;let fe;M.execution instanceof P.ProcessExecution?fe=c.from(M.execution):M.execution instanceof P.ShellExecution?fe=f.from(M.execution):M.execution&&M.execution instanceof P.CustomExecution&&(fe=i.from(M.execution));const re=t.from(M.definition);let V;return M.scope?typeof M.scope=="number"?V=M.scope:V=M.scope.uri:V=P.TaskScope.Workspace,!re||!V?void 0:{_id:M._id,definition:re,name:M.name,source:{extensionId:x.identifier.value,label:M.source,scope:V},execution:fe,isBackground:M.isBackground,group:u.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}Q.from=U;async function z(M,x,fe){if(M==null)return;let re;c.is(M.execution)?re=c.to(M.execution):f.is(M.execution)?re=f.to(M.execution):i.is(M.execution)&&(re=i.to(M._id,fe));const V=t.to(M.definition);let _;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?_=M.source.scope:_=await x.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):_=P.TaskScope.Workspace),!V||!_)return;const te=new P.Task(V,_,M.name,M.source.label,re,M.problemMatchers);return M.isBackground!==void 0&&(te.isBackground=M.isBackground),M.group!==void 0&&(te.group=P.TaskGroup.from(M.group._id),te.group&&M.group.isDefault&&(te.group=new P.TaskGroup(te.group.id,te.group.label),M.group.isDefault===!0&&(te.group.isDefault=M.group.isDefault))),M.presentationOptions&&(te.presentationOptions=o.to(M.presentationOptions)),M._id&&(te._id=M._id),M.detail&&(te.detail=M.detail),te}Q.to=z})(b=e.TaskDTO||(e.TaskDTO={}));var g;(function(Q){function B(z){return z}Q.from=B;function U(z){if(!!z)return Object.assign(Object.create(null),z)}Q.to=U})(g||(g={}));class L{constructor(B,U,z){this._id=U,this.a=z,p.set(this,void 0),_e(this,p,B,"f")}get task(){return this.a}terminate(){Ue(this,p,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}p=new WeakMap;let j=class{constructor(B,U,z,M,x,fe,re,V){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=z,this.c=M,this.d=x,this.e=fe,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,U,z){if(!z)return new P.Disposable(()=>{});const M=this.w();return this.j.set(M,{type:U,provider:z,extension:B}),this.a.$registerTaskProvider(M,U),new P.Disposable(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(B,U){this.a.$registerTaskSystem(B,U)}fetchTasks(B){return this.a.$fetchTasks(g.from(B)).then(async U=>{const z=[];for(const M of U){const x=await b.to(M,this.b,this.m);x&&z.push(x)}return z})}get taskExecutions(){const B=[];return this.k.forEach(U=>B.push(U)),B}terminateTask(B){if(!(B instanceof L))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,U,z){const M=this.m.get(B.id);M&&(this.o.set(B.id,M),this.e.attachPtyToTerminal(U,await M.callback(z))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const U=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const U=await this.y(B.id);this.s.fire({execution:U,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const U=await this.y(B.id);this.t.fire({execution:U,exitCode:B.exitCode})}$provideTasks(B,U){const z=this.j.get(B);if(!z)return Promise.reject(new Error("no handler found"));const M=[],x=(0,A.asPromise)(()=>z.provider.provideTasks(O.CancellationToken.None)).then(fe=>this.u(U,M,z,fe));return new Promise(fe=>{x.then(re=>{Promise.all(M).then(()=>{fe(re)})})})}async $resolveTask(B,U){const z=this.j.get(B);if(!z)return Promise.reject(new Error("no handler found"));if(U.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await b.to(U,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const x=await z.provider.resolveTask(M,O.CancellationToken.None);if(!x)return;this.z(x,z);const fe=b.from(x,z.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(fe.execution)&&await this.x(fe,x,!0),await this.v(fe)}w(){return this.h++}async x(B,U,z){const M=await this.a.$createTaskId(B);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,U.execution)),this.m.set(M,U.execution)}async y(B,U){if(typeof B=="string"){const x=this.l.get(B);if(!x)throw new y.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const z=this.l.get(B.id);if(z)return z;const M=new Promise((x,fe)=>{function re(V,_,te){te?x(new L(V,_.id,te)):fe("Unexpected: Task does not exist.")}U?re(this,B,U):b.to(B.task,this.b,this.m).then(V=>re(this,B,V))});return this.l.set(B.id,M),M.then(x=>(this.k.set(B.id,x),x),x=>Promise.reject(x))}z(B,U){B._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};j=Ve([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,d.ILogService),$e(7,h.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let G=class extends j{constructor(B,U,z,M,x,fe,re,V){super(B,U,z,M,x,fe,re,V),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(B,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const z=b.from(U,B);if(z===void 0)throw new Error("Task is not valid");if(i.is(z.execution))await this.x(z,U,!1);else throw new y.NotSupportedError;const M=await this.y(await this.a.$getTaskExecution(z),U);return this.a.$executeTask(z).catch(x=>{throw new Error(x)}),M}u(B,U,z,M){const x=[];if(M)for(const fe of M){this.z(fe,z),(!fe.definition||!B[fe.definition.type])&&this.f.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const re=b.from(fe,z.extension);re&&i.is(re.execution)?(x.push(re),U.push(this.x(re,fe,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:z.extension}}async v(B){if(i.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,U,z){}};G=Ve([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,d.ILogService),$e(7,h.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,I.createDecorator)("IExtHostTask")}),define(Ie[304],Ce([1,0,15,21,46,39,24,37,31]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class v{constructor(S,C,I){this.k=S,this.l=C,this.o=I,this.e=!1,this.f=0,this.g=!1,this.a=S.filePattern,this.b=S.includePattern&&R.parse(S.includePattern),this.c=S.maxResults||void 0,this.d=S.exists,this.h=new Set,this.j=S.excludePattern&&R.parse(S.excludePattern)}cancel(){this.g=!0,this.h.forEach(S=>S.cancel()),this.h=new Set}search(S){const C=this.k.folderQueries||[];return new Promise((I,E)=>{const n=d=>{this.f++,S(d)};if(this.g)return I({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const h=d.toString(),w=a.basename(h);this.j&&this.j(h,w)||this.v(n,{base:d,basename:w})}),Promise.all(C.map(d=>this.p(d,n))).then(d=>{I({limitHit:this.e,stats:d[0]||void 0})},d=>{E(new Error((0,l.toErrorMessage)(d)))})})}async p(S,C){const I=new A.CancellationTokenSource,E=this.q(S),n=this.r(),d=new D.QueryGlobTester(this.k,S),h=!d.hasSiblingExcludeClauses();let w;try{this.h.add(I),w=T.StopWatch.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,I.token),p=w.elapsed(),t=T.StopWatch.create();return this.g&&!this.e||(y&&y.forEach(o=>{const r=a.posix.relative(S.folder.path,o.path);if(h){const c=a.basename(o.path);this.v(C,{base:S.folder,relativePath:r,basename:c});return}this.s(n,S.folder,r,C)}),this.g&&!this.e)?null:(this.u(n,d,C),{providerTime:p,postProcessTime:t.elapsed()})}finally{I.dispose(),this.h.delete(I)}}q(S){const C=(0,D.resolvePatternsForProvider)(this.k.includePattern,S.includePattern),I=(0,D.resolvePatternsForProvider)(this.k.excludePattern,S.excludePattern);return{folder:S.folder,excludes:I,includes:C,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}s({pathToEntries:S},C,I,E){if(I===this.a){const d=a.basename(this.a);this.v(E,{base:C,relativePath:this.a,basename:d})}function n(d){const h=a.basename(d),w=a.dirname(d);let y=S[w];y||(y=S[w]=[],n(w)),y.push({base:C,relativePath:d,basename:h})}n(I)}u({rootEntries:S,pathToEntries:C},I,E){const n=this,d=this.a;function h(w){const y=(0,D.hasSiblingFn)(()=>w.map(p=>p.basename));for(let p=0,t=w.length;p<t;p++){const o=w[p],{relativePath:r,basename:c}=o;if(I.matchesExcludesSync(r,c,d!==c?y:void 0))continue;const m=C[r];if(m)h(m);else{if(r===d)continue;n.v(E,o)}if(n.e)break}}h(S)}v(S,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||S(C))}}class O{constructor(){this.b=new Map}fileSearch(S,C,I,E){const n=this.c(S.cacheKey),d=new v(S,C,n&&n.token);let h=0;const w=y=>{h+=y.length,I(y.map(p=>this.d(p)))};return this.e(d,O.a,w,E).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:y.stats}}))}clearCache(S){this.c(S)?.cancel()}c(S){if(!!S)return this.b.has(S)||this.b.set(S,new A.CancellationTokenSource),this.b.get(S)}d(S){return S.relativePath?{resource:P.joinPath(S.base,S.relativePath)}:{resource:S.base}}e(S,C,I,E){E.onCancellationRequested(()=>{S.cancel()});const n=h=>{h&&(d.push(h),C>0&&d.length>=C&&(I(d),d=[]))};let d=[];return S.search(n).then(h=>(d.length&&I(d),h),h=>(d.length&&I(d),Promise.reject(h)))}}O.a=512,e.FileSearchManager=O}),define(Ie[305],Ce([1,0,17,61,39,114,28,18,15,24,9,10,2,168,202,54,16,48,134,303,31]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(b,g,L,j,G){this.a=b,this.b=g,this.c=L,this.d=j,this.e=G}text(b,g,L={}){b=this.f(b,L);const j=this.a.getValue(),G=g&&g.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(g?.map(d.toWorkspaceFolder),L),type:2,contentPattern:b,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:j.search.usePCRE2||G||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(b,g){const L=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const j={...b,wordSeparators:L.editor.wordSeparators};return this.j(b,g)&&(j.isCaseSensitive=!0),this.k(b)&&(j.isMultiline=!0),j}file(b,g={}){return{...this.h(b,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}g(b,g){return b?(b=Array.isArray(b)?b.map(m):m(b),g?this.parseSearchPaths(b):{pattern:o(...Array.isArray(b)?b:[b])}):{}}h(b=[],g={}){const L=this.g(g.includePattern,g.expandPatterns),j=this.g(g.excludePattern,g.expandPatterns),G=b.length>1,Q=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(z=>this.q(z,g,j)):b.map(z=>this.r(z,g,j,G))).filter(z=>!!z),B={_reason:g._reason,folderQueries:Q,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:j.pattern,includePattern:L.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const z=a.coalesce(a.flatten(this.c.groups.map(fe=>fe.editors.map(re=>re.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const M=z.filter(fe=>(0,y.pathIncludedInQuery)(B,fe.fsPath)),x=this.i(M);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...B,...x}}const U=g.extraFileResources&&g.extraFileResources.filter(z=>(0,y.pathIncludedInQuery)(B,z.fsPath));return B.extraFileResources=U&&U.length?U:void 0,B}i(b){const g=[],L=new P.ResourceMap,j={};let G=!1;return b.forEach(Q=>{if(Q.scheme===T.Schemas.walkThrough)return;if((0,v.isAbsolutePath)(Q)){const U=this.b.getWorkspaceFolder(Q)?.uri??Q.with({path:D.dirname(Q.fsPath)});let z=L.get(U);z||(G=!0,z={folder:U,includePattern:{}},g.push(z),L.set(U,z));const M=D.relative(U.fsPath,Q.fsPath);(0,k.assertIsDefined)(z.includePattern)[M.replace(/\\/g,"/")]=!0}else Q.fsPath&&(G=!0,j[Q.fsPath]=!0)}),{folderQueries:g,includePattern:j,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(b,g){if(g.isSmartCase){if(b.isRegExp){if(O.containsUppercaseCharacter(b.pattern,!0))return!0}else if(O.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,C.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const g=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),j=(Array.isArray(b)?b:r(b)).map(x=>{const fe=this.e.resolvedUserHome;return fe?(0,R.untildify)(x,fe.scheme===T.Schemas.file?fe.fsPath:fe.path):x}),G=A.groupBy(j,x=>g(x)?"searchPaths":"exprSegments"),Q=(G.exprSegments||[]).map(x=>O.rtrim(x,"/")).map(x=>O.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),c(x))),B={},U=this.m(G.searchPaths||[]);U&&U.length&&(B.searchPaths=U);const z=a.flatten(Q),M=o(...z);return M&&(B.pattern=M),B}l(b,g){return g.disregardExcludeSettings?void 0:(0,y.getExcludes)(b,!g.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const g=b.flatMap(j=>{let{pathPortion:G,globPortion:Q}=t(j);return Q&&(Q=f(Q)),this.n(G).flatMap(U=>this.o(U,Q))}),L=new Map;return g.forEach(j=>{const G=j.searchPath.toString(),Q=L.get(G);Q?j.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[j.pattern]=!0):L.set(G,{searchPath:j.searchPath,pattern:j.pattern?o(j.pattern):void 0})}),Array.from(L.values())}n(b){if(D.isAbsolute(b)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==T.Schemas.file?[{searchPath:g[0].uri.with({path:b})}]:[{searchPath:S.URI.file(D.normalize(b))}]}if(this.b.getWorkbenchState()===2){const g=this.b.getWorkspace().folders[0].uri;if(b=m(b),b.startsWith("../")||b===".."){const j=D.posix.resolve(g.path,b);return[{searchPath:g.with({path:j})}]}const L=f(b);return[{searchPath:g,pattern:L}]}else{if(b==="./"||b===".\\")return[];{const g=b.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(G=>{const Q=g.match(new RegExp(`^${O.escapeRegExpCharacters(G.name)}(?:/(.*)|$)`));return Q?{match:Q,folder:G}:null}).filter(k.isDefined);if(j.length)return j.map(G=>{const Q=G.match[1];return{searchPath:G.folder.uri,pattern:Q&&f(Q)}});{const G=b.match(/\.[\/\\](.+)[\/\\]?/),Q=G?G[1]:b,B=I.localize(0,null,Q);throw new Error(B)}}}}o(b,g){const L=b.pattern&&g?`${b.pattern}/${g}`:b.pattern||g,j=[{searchPath:b.searchPath,pattern:L}];return L&&!L.endsWith("**")&&j.push({searchPath:b.searchPath,pattern:L+"/**"}),j}q(b,g,L){const j=this.r((0,d.toWorkspaceFolder)(b.searchPath),g,L,!1);return j?{...j,includePattern:b.pattern}:null}r(b,g,L,j){let G;const Q=S.URI.isUri(b)?b:b.uri;if(L.searchPaths){const x=L.searchPaths.filter(fe=>(0,v.isEqual)(fe.searchPath,Q))[0];if(x&&!x.pattern)return null;x&&(G=x.pattern)}const B=this.a.getValue({resource:Q}),z={...this.l(B,g)||{},...G||{}},M=S.URI.isUri(b)?(0,v.basename)(b):b.name;return{folder:Q,folderName:j?M:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!B.search.followSymlinks}}};p=Ve([$e(0,E.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,h.IEditorGroupsService),$e(3,n.ILogService),$e(4,w.IPathService)],p),e.QueryBuilder=p;function t(u){const b=u.match(/[\*\{\}\(\)\[\]\?]/);if(b){const g=b.index,L=u.substr(0,g).match(/[/|\\][^/\\]*$/);if(L){let j=u.substr(0,L.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:u.substr((L.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((b,g)=>(b[g]=!0,b),Object.create(null)):void 0}function r(u){return l.splitGlobAware(u,",").map(b=>b.trim()).filter(b=>!!b.length)}function c(u){return[`**/${u}/**`,`**/${u}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function m(u){return u.replace(/\\/g,"/")}function f(u){return m(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(u){return u.replace(/([?*[\]])/g,"[$1]")}function s(u,b){u=a.distinct(u,j=>j.toString());const g=[],L=b.getWorkspace();return u&&u.forEach(j=>{let G;if(b.getWorkbenchState()===2)G=(0,v.relativePath)(L.folders[0].uri,j),G&&G!=="."&&(G="./"+G);else{const Q=b.getWorkspaceFolder(j);if(Q){const B=Q.name;if(L.folders.filter(z=>z.name===B).length===1){const z=(0,v.relativePath)(Q.uri,j);z===""?G=`./${Q.name}`:G=`./${Q.name}/${z}`}else G=j.fsPath}}G&&g.push(i(G))}),g}e.resolveResourcesForSearchIncludes=s}),define(Ie[306],Ce([1,0,24,2,21,8,4,305,31,48]),function(se,e,a,A,l,R,P,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function k(E,n){const d=n.activationEvents;if(!d)return Promise.resolve(void 0);const h=[],w=[];for(const c of d)if(/^workspaceContains:/.test(c)){const m=c.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||E.forceUsingSearch?w.push(m):h.push(m)}if(h.length===0&&w.length===0)return Promise.resolve(void 0);let y;const p=new Promise((c,m)=>{y=c}),t=c=>y({activationEvent:c}),o=Promise.all(h.map(c=>S(E,c,t))).then(()=>{}),r=C(E,n.identifier,w,t);return Promise.all([o,r]).then(()=>{y(void 0)}),p}e.checkActivateWorkspaceContainsExtension=k;async function S(E,n,d){for(const h of E.folders)if(await E.exists(a.joinPath(A.URI.revive(h),n))){d(`workspaceContains:${n}`);return}}async function C(E,n,d,h){if(d.length===0)return Promise.resolve(void 0);const w=new l.CancellationTokenSource,y=E.checkExists(E.folders,d,w.token),p=setTimeout(async()=>{w.cancel(),E.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await y}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}w.dispose(),clearTimeout(p),t&&h(`workspaceContains:${d.join(",")}`)}function I(E,n,d,h){const w=E.get(P.IInstantiationService),y=E.get(D.ISearchService),t=w.createInstance(T.QueryBuilder).file(n.map(o=>(0,v.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return y.fileSearch(t,h).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=I});var _e=this&&this.__classPrivateFieldSet||function(se,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!l:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(se,a):l?l.value=a:e.set(se,a),a},Ue=this&&this.__classPrivateFieldGet||function(se,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!A:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(se):A?A.value:e.get(se)};define(Ie[43],Ce([1,0,182,15,84,24,19,6,69,2,16,5,35,244,100,34,27,135,8,25,22,226,7,128,4,26,80,20,92,55,42,3,306,99,228,18,98,37,14]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t,o,r,c,m,f,i,s,u,b,g,L,j,G,Q,B,U){"use strict";var z,M,x;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let fe=class gn extends T.Disposable{constructor(q,F,J,ge,Ee,ie,ne,de,ee,ce,ae){super(),this.a=this.B(new b.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=F,this.g=J,this.f=ne,this.j=ge,this.k=Ee,this.l=ie,this.m=ee,this.p=ce,this.s=ae,this.t=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.w=new P.Barrier,this.y=new P.Barrier,this.z=new P.Barrier,this.C=new P.Barrier,this.D=new le(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const N=new w.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.D,te(this.G,N)),this.H=new I.ExtHostStorage(this.g,this.l),this.I=new L.ExtHostSecretState(this.g),this.J=de,this.h=q.createChild(new i.ServiceCollection([I.IExtHostStorage,this.H],[L.IExtHostSecretState,this.I])),this.L=this.B(new C.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:($,X,Z)=>{this.v.$onExtensionActivationError($,h.transformErrorForSerialization(X),Z)},actualActivateExtension:async($,X)=>{if(d.ExtensionDescriptionRegistry.isHostExtension($,this.F,this.G))return await this.v.$activateExtension($,X),new C.HostExtension;const Z=this.F.getExtensionDescription($);return this.Z(Z,X)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(q){h.onUnexpectedError(q)}}async R(){this.J.onWillDeactivateAll();let q=[];try{q=this.F.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.Y(Ee))}catch{}await Promise.all(q)}terminate(q,F=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${q}`),this.l.flush(),this.p.dispose(),this.L.dispose(),h.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const J=this.R();Promise.race([(0,P.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${F}`):this.l.info(`Extension host exiting with code ${F}`),this.l.flush(),this.l.dispose(),this.c.exit(F)})}isActivated(q){return this.z.isOpen()?this.L.isActivated(q):!1}async getExtension(q){const F=await this.v.$getExtension(q);return F&&{...F,identifier:new w.ExtensionIdentifier(F.identifier.value),extensionLocation:v.URI.revive(F.extensionLocation)}}S(q,F){return this.L.activateByEvent(q,F)}U(q,F){return this.L.activateById(q,F)}activateByIdWithErrors(q,F){return this.U(q,F).then(()=>{const J=this.L.getActivatedExtension(q);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(q=>this.F)}getExtensionExports(q){return this.z.isOpen()?this.L.getActivatedExtension(q).exports:null}async W(q){if(q.scheme!==G.Schemas.file)return q;const F=await this.c.realpath(q.fsPath);return v.URI.file(F)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(q=>new ve(q))),this.M}async X(q){const F=D.TernarySearchTree.forUris(J=>R.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(q.map(async J=>{if(this.qb(J)){const ge=await this.W(J.extensionLocation);F.set(ge,J)}})),F}Y(q){let F=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(q))return F;const J=this.L.getActivatedExtension(q);if(!J)return F;try{typeof J.module.deactivate=="function"&&(F=Promise.resolve(J.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${q.value}':`),this.l.error(ge)}try{(0,T.dispose)(J.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.l.error(ge)}return F}async Z(q,F){return this.f.remote.isRemote?this.v.$onWillActivateExtension(q.identifier):await this.v.$onWillActivateExtension(q.identifier),this.bb(q,F).then(J=>{const ge=J.activationTimes;return this.v.$onDidActivateExtension(q.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,F),this.ab(q,F,"success",ge),J},J=>{throw this.ab(q,F,"failure"),J})}ab(q,F,J,ge){const Ee=V(q,F);this.u.$publicLog2("extensionActivationTimes",{...Ee,...ge||{},outcome:J})}bb(q,F){const J=V(q,F);this.u.$publicLog2("activatePlugin",J);const ge=this.qb(q);if(!ge)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${F.startup}, activationEvent: '${F.activationEvent}'${q.identifier.value!==F.extensionId.value?`, root cause: ${F.extensionId.value}`:""}`),this.l.flush();const Ee=new C.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this.rb(q,(0,R.joinPath)(q.extensionLocation,ge),Ee),this.cb(q)]).then(ie=>(l.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),gn.db(this.l,q.identifier,ie[0],ie[1],Ee))).then(ie=>(l.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),ie))}cb(q){const F=new p.ExtensionGlobalMemento(q,this.H),J=new p.ExtensionMemento(q.identifier.value,!1,this.H),ge=new j.ExtensionSecrets(q,this.I),Ee=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([F.whenReady,J.whenReady,this.J.whenReady]).then(()=>{const ne=this;let de,ee;const ce=(0,n.isProposedApiEnabled)(q,"ipc")?this.f.messagePorts?.get(w.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:F,workspaceState:J,secrets:ge,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(ae){return A.join(q.extensionLocation.fsPath,ae)},get storagePath(){return ne.J.workspaceValue(q)?.fsPath},get globalStoragePath(){return ne.J.globalValue(q).fsPath},get logPath(){return A.join(ne.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return v.URI.joinPath(ne.f.logsLocation,q.identifier.value)},get storageUri(){return ne.J.workspaceValue(q)},get globalStorageUri(){return ne.J.globalValue(q)},get extensionMode(){return Ee},get extension(){return de===void 0&&(de=new _(ne,q.identifier,q,ie,!1)),de},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(q,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.p.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ee){if(!ce)return;const ae=b.Event.buffer(b.Event.fromDOMEventEmitter(ce,"message",N=>N.data));ce.start(),ee={onDidReceiveMessage:ae,postMessage:ce.postMessage.bind(ce)}}return ee}})})}static db(q,F,J,ge,Ee){return J=J||{activate:void 0,deactivate:void 0},this.eb(q,F,J,ge,Ee).then(ie=>new C.ActivatedExtension(!1,null,Ee.build(),J,ie,ge.subscriptions))}static eb(q,F,J,ge,Ee){if(typeof J.activate=="function")try{Ee.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${F.value}`);const ie=typeof global=="object"?global:self,ne=J.activate.apply(ie,[ge]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(ne).then(de=>(Ee.activateResolveStop(),de))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(J)}fb(q,F){this.U(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:F}).then(void 0,J=>{this.l.error(J)})}gb(q,F=0){const ge=Date.now();(0,U.setTimeout0)(()=>{for(let Ee=F;Ee<q.length;Ee+=1){const ie=q[Ee];for(const ne of ie.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-ge>50){this.gb(q,Ee);break}else this.fb(ie,ne)}})}hb(){this.v.$setPerformanceMarks(l.getMarks()),this.k.getConfigProvider().then(q=>{const F=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),J=this.F.getAllExtensionDescriptions();if(F)this.gb(J);else for(const ge of J)if(ge.activationEvents)for(const Ee of ge.activationEvents)Ee==="onStartupFinished"&&this.fb(ge,Ee)})}ib(){const q=this.S("*",!0).then(void 0,ie=>{this.l.error(ie)});this.B(this.j.onDidChangeWorkspace(ie=>this.jb(ie.added)));const F=this.j.workspace?this.j.workspace.folders:[],J=this.jb(F),ge=this.lb(),Ee=Promise.all([ge,q,J]).then(()=>{});return Promise.race([Ee,(0,P.timeout)(1e4)]).then(()=>{this.hb()}),Ee}jb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(F=>this.kb(q,F))).then(()=>{})}async kb(q,F){if(this.isActivated(F.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:q.map(ie=>ie.uri),forceUsingSearch:J,exists:ie=>this.c.exists(ie.fsPath),checkExists:(ie,ne,de)=>this.t.$checkExists(ie,ne,de)},Ee=await(0,g.checkActivateWorkspaceContainsExtension)(ge,F);if(!!Ee)return this.U(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Ee.activationEvent}).then(void 0,ie=>this.l.error(ie))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(q){throw console.error(q),q}}async mb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:F}=this.f.environment;if(!q||!F)throw new Error(a.localize(0,null));const J=await this.rb(null,F,new C.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(a.localize(1,null,F.toString()));return new Promise((ge,Ee)=>{const ie=(ee,ce)=>{ee?Ee(ee):ge(typeof ce=="number"&&ce>0?1:0)},ne=(0,R.originalFSPath)(F),de=J.run(ne,ie);de&&de.then&&de.then(()=>{ge(0)}).catch(ee=>{Ee(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,P.timeout)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,F){return this.N[q]=F,(0,T.toDisposable)(()=>{delete this.N[q]})}async ob(q){const F=q.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const J=q.substr(0,F);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.N[J]}}async $resolveAuthority(q,F){const J=B.StopWatch.create(!1),ge=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(q)},${F})][${J.elapsed()}ms] `,Ee=ce=>this.l.info(`${ge()}${ce}`),ie=(ce,ae=void 0)=>this.l.error(`${ge()}${ce}`,ae);Ee("activating resolver...");const{authorityPrefix:ne,resolver:de}=await this.ob(q);if(!de)return ie("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};const ee=new P.IntervalTimer;try{Ee("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(de)),ee.cancelAndSet(()=>Ee("waiting..."),1e3),Ee("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${ne}`);const ce=await de.resolve(q,{resolveAttempt:F});l.mark(`code/extHost/didResolveAuthorityOK/${ne}`),ee.dispose(),Ee(`returned ${ce.host}:${ce.port}`);const ae={authority:q,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},N={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:N,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(l.mark(`code/extHost/didResolveAuthorityError/${ne}`),ee.dispose(),ie("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(q,F){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(q)})`);const{resolver:J}=await this.ob(q);if(!J)return null;const ge=v.URI.revive(F);if(typeof J.getCanonicalURI>"u")return ge;const Ee=await(0,P.asPromise)(()=>J.getCanonicalURI(ge));return Ee||ge}$startExtensionHost(q){q.toAdd.forEach(ge=>ge.extensionLocation=v.URI.revive(ge.extensionLocation));const{globalRegistry:F,myExtensions:J}=re(this.D,this.G,this.F,q);return this.G.set(F.getAllExtensionDescriptions()),this.F.set(J),this.nb()}$activateByEvent(q,F){return F===1?this.S(q,!1):this.z.wait().then(J=>this.S(q,!1))}async $activate(q,F){return await this.z.wait(),this.F.getExtensionDescription(q)?(await this.U(q,F),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(ie=>ie.extensionLocation=v.URI.revive(ie.extensionLocation));const{globalRegistry:F,myExtensions:J}=re(this.D,this.G,this.F,q),ge=await this.X(J);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.G.set(F.getAllExtensionDescriptions()),this.F.set(J),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const F=y.VSBuffer.alloc(q),J=Math.random()%256;for(let ge=0;ge<q;ge++)F.writeUInt8(J,ge);return F}async $updateRemoteConnectionData(q){this.Q=q,this.a.fire()}};fe=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,E.IExtHostWorkspace),$e(4,S.IExtHostConfiguration),$e(5,O.ILogService),$e(6,c.IExtHostInitDataService),$e(7,m.IExtensionStoragePaths),$e(8,s.IExtHostTunnelService),$e(9,u.IExtHostTerminalService),$e(10,Q.IExtHostLocalizationService)],fe),e.AbstractExtHostExtensionService=fe;function re(ue,q,F,J){ue.addActivationEvents(J.addActivationEvents);const ge=new d.ExtensionDescriptionRegistry(ue,q.getAllExtensionDescriptions());ge.deltaExtensions(J.toAdd,J.toRemove);const Ee=new w.ExtensionIdentifierSet(F.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of J.myToRemove)Ee.delete(ne);for(const ne of J.myToAdd)Ee.add(ne);const ie=te(ge,Ee);return{globalRegistry:ge,myExtensions:ie}}function V(ue,q){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class _{constructor(q,F,J,ge,Ee){z.set(this,void 0),M.set(this,void 0),x.set(this,void 0),_e(this,z,q,"f"),_e(this,M,F,"f"),_e(this,x,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=ge,this.isFromDifferentExtensionHost=Ee}get isActive(){return Ue(this,z,"f").isActivated(Ue(this,x,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,z,"f").getExtensionExports(Ue(this,x,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,z,"f").activateByIdWithErrors(Ue(this,x,"f"),{startup:!1,extensionId:Ue(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,z=new WeakMap,M=new WeakMap,x=new WeakMap;function te(ue,q){return ue.getAllExtensionDescriptions().filter(F=>q.has(F.identifier))}class ve{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.ExtensionPaths=ve;class le{constructor(q){this.a=new w.ExtensionIdentifierMap,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)}addActivationEvents(q){for(const F of Object.keys(q))this.a.set(F,q[F])}}}),define(Ie[307],Ce([1,0,84,2,5,35,27,25,20,26,4,43,36,16,9]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let E=class{constructor(p,t,o,r,c,m,f){this.c=p,this.d=t,this.e=o,this.f=r,this.g=c,this.h=m,this.i=f,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,p,this.i)),this.register(this.e.createInstance(h,t)),this.register(this.e.createInstance(n)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,t,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this.a.set(t,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(t=>p.alternativeModuleName(t))}};E=Ve([$e(2,O.IInstantiationService),$e(3,R.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,v.IExtHostInitDataService),$e(6,C.ILogService)],E),e.RequireInterceptor=E;let n=class un{constructor(p){if(p.environment.appRoot&&un.a.size){const t=(0,I.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",r=`@${o}+\\/${o}+|${o}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const t=this.b.exec(this.c(p));if(!t)return;const[,o,r,c]=t,m=un.a.get(r);if(m!==void 0)return console.warn(`${r} as been renamed to ${m}, please update your imports`),o+m+c}c(p){return p.replace(/\\/g,"/")}};n.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),n=Ve([$e(0,v.IExtHostInitDataService)],n);class d{constructor(p,t,o,r,c){this.c=p,this.d=t,this.e=o,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new T.ExtensionIdentifierMap}load(p,t){const o=this.d.findSubstr(t);if(o){let r=this.a.get(o.identifier);return r||(r=this.c(o,this.e,this.f),this.a.set(o.identifier,r)),r}if(!this.b){let r="";this.d.forEach((c,m)=>r+=`	${m} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(P.nullExtensionDescription,this.e,this.f)}return this.b}}let h=class{constructor(p,t,o){this.d=p,this.nodeModuleName="keytar",this.a=t.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=o,c=t.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let m=r.appRoot.fsPath;S.platform==="win32"&&(m=m.replace(/\\/g,"/")),m[m.length-1]==="/"&&(m=m.substr(0,m.length-1)),this.b=new Set,this.b.add(`${m}/node_modules.asar/keytar`),this.b.add(`${m}/node_modules/keytar`)}this.c={getPassword:(m,f)=>c.$getPassword(m,f),setPassword:(m,f,i)=>c.$setPassword(m,f,i),deletePassword:(m,f)=>c.$deletePassword(m,f),findPassword:m=>c.$findPassword(m),findCredentials(m){return c.$findCredentials(m)}}}load(p,t){const o=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const t=p.length;if(t<=7||!this.b)return;const o=t-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};h=Ve([$e(1,D.IExtHostRpcService),$e(2,v.IExtHostInitDataService)],h);let w=class{constructor(p,t,o){this.e=p,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(l.MainContext.MainThreadTelemetry);const r=o.getProxy(l.MainContext.MainThreadWindow);this.c=(c,m)=>{const f=A.URI.parse(c);return m?this.g(c,m):f.scheme==="http"||f.scheme==="https"?r.$openUri(f,c,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this.f?r.$openUri(f,c,{}):this.g(c,m)}}load(p,t,o){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=o(p),this.c}g(p,t){return this.i(),this.b(p,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=Ve([$e(2,D.IExtHostRpcService)],w)}),define(Ie[50],Ce([1,0,65,6,15,36,4,59,60,43,7,34,240,35]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,P.createDecorator)("IExtHostVariableResolverProvider");class I extends S.AbstractVariableResolverService{constructor(d,h,w,y,p,t,o){function r(){if(w){const c=w.activeEditor();if(c)return c.document.uri;const m=y.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof O.TextDiffTabInput||m.input instanceof O.NotebookDiffEditorTabInput)return m.input.modified;if(m.input instanceof O.TextTabInput||m.input instanceof O.NotebookEditorTabInput||m.input instanceof O.CustomEditorTabInput)return m.input.uri}}}super({getFolderUri:c=>{const m=t.folders.filter(f=>f.name===c);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,m)=>p.getConfiguration(void 0,c).get(m),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return l.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const c=r();if(c){const m=h.getWorkspaceFolder(c);if(m)return l.normalize(m.uri.fsPath)}}},getSelectedText:()=>{if(w){const c=w.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(w){const c=w.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>d.getExtension(c)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let E=class extends A.Disposable{constructor(d,h,w,y,p){super(),this.b=d,this.c=h,this.g=w,this.h=y,this.i=p,this.a=new a.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new I(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};E=Ve([$e(0,v.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,T.IExtHostDocumentsAndEditors),$e(3,C.IExtHostConfiguration),$e(4,D.IExtHostEditorTabs)],E),e.ExtHostVariableResolverProviderService=E}),define(Ie[85],Ce([1,0,19,3,10,2,4,5,60,43,20,7,34,132,233,35,50]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,P.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,m,f,i,s){this.D=c,this.E=m,this.F=f,this.G=i,this.H=s,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=r.getProxy(T.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new w(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(u=>{u.onDidChange(b=>{this.I(u)}),this.I(u)})}asDebugSourceUri(r,c){const m=r;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let f=`debug:${encodeURIComponent(m.path||"")}`,i="?";return c&&(f+=`${i}session=${encodeURIComponent(c.id)}`,i="&"),f+=`${i}ref=${m.sourceReference}`,R.URI.parse(f)}else{if(m.path)return R.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const c=[];for(const m of r.getAllExtensionDescriptions())if(m.contributes){const f=m.contributes.debuggers;if(f&&f.length>0)for(const i of f)(0,I.isDebuggerMainContribution)(i)&&c.push(i.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){this.T();const c=r.filter(i=>{const s=i.id;return this.w.has(s)?!1:(this.w.set(s,i),!0)});this.U(c,[],[]);const m=[],f=new Map;for(const i of c)if(i instanceof k.SourceBreakpoint){let s=f.get(i.location.uri.toString());s||(s={type:"sourceMulti",uri:i.location.uri,lines:[]},f.set(i.location.uri.toString(),s),m.push(s)),s.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof k.FunctionBreakpoint&&m.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(m)}removeBreakpoints(r){this.T();const c=r.filter(s=>this.w.delete(s.id));this.U([],c,[]);const m=c.filter(s=>s instanceof k.SourceBreakpoint).map(s=>s.id),f=c.filter(s=>s instanceof k.FunctionBreakpoint).map(s=>s.id),i=c.filter(s=>s instanceof k.DataBreakpoint).map(s=>s.id);return this.k.$unregisterBreakpoints(m,f,i)}startDebugging(r,c,m){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,m){if(!c)return new k.Disposable(()=>{});const f=this.d++;return this.f.push({type:r,handle:f,provider:c}),this.k.$registerDebugConfigurationProvider(r,m,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,f),new k.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==c),this.k.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(r,c,m){if(!m)return new k.Disposable(()=>{});if(!this.P(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this.g++;return this.h.push({type:c,handle:f,factory:m}),this.k.$registerDebugAdapterDescriptorFactory(c,f),new k.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==m),this.k.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new k.Disposable(()=>{});const m=this.i++;return this.j.push({type:r,handle:m,factory:c}),new k.Disposable(()=>{this.j=this.j.filter(f=>f.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let m;const f=await this.W(r);return f&&(m={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(m,c)}J(r,c){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,c){const m=this,f=await this.V(c);return this.R(this.M(f.type),f).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const s=this.L(i),u=this.J(s,f);if(!u)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const b=u;return this.A.set(r,b),this.Q(f).then(g=>(g&&this.B.set(r,g),b.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const j=L,G={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Q=await this.C.sign(j.arguments.value);G.body={signature:Q},b.sendResponse(G)}else throw new Error("no signer")}catch(Q){G.success=!1,G.message=Q.message,b.sendResponse(G)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(L),L=(0,I.convertToVSCPaths)(L,!0),m.k.$acceptDAMessage(r,L)}),b.onError(L=>{g&&g.onError&&g.onError(L),this.k.$acceptDAError(r,L.name,L.message,L.stack)}),b.onExit(L=>{g&&g.onExit&&g.onExit((0,l.withNullAsUndefined)(L),void 0),this.k.$acceptDAExit(r,(0,l.withNullAsUndefined)(L),void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),b.startSession()))})}$sendDAMessage(r,c){c=(0,I.convertToDAPaths)(c,!1);const m=this.B.get(r);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(c),this.A.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.B.get(r);this.B.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const m=this.A.get(r);return this.A.delete(r),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],m=[],f=[];if(r.added)for(const i of r.added){const s=i.id;if(s&&!this.w.has(s)){let u;if(i.type==="function")u=new k.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")u=new k.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const b=R.URI.revive(i.uri);u=new k.SourceBreakpoint(new k.Location(b,new k.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,k.setBreakpointId)(u,s),this.w.set(s,u),c.push(u)}}if(r.removed)for(const i of r.removed){const s=this.w.get(i);s&&(this.w.delete(i),m.push(s))}if(r.changed){for(const i of r.changed)if(i.id){const s=this.w.get(i.id);if(s){if(s instanceof k.FunctionBreakpoint&&i.type==="function"){const u=s;u.enabled=i.enabled,u.condition=i.condition,u.hitCondition=i.hitCondition,u.logMessage=i.logMessage,u.functionName=i.functionName}else if(s instanceof k.SourceBreakpoint&&i.type==="source"){const u=s;u.enabled=i.enabled,u.condition=i.condition,u.hitCondition=i.hitCondition,u.logMessage=i.logMessage,u.location=new k.Location(R.URI.revive(i.uri),new k.Position(i.line,i.character))}f.push(s)}}}this.U(c,m,f)}$provideDebugConfigurations(r,c,m){return(0,a.asPromise)(async()=>{const f=this.O(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(c);return f.provideDebugConfigurations(i,m)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(r,c,m,f){return(0,a.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.W(c);return i.resolveDebugConfiguration(s,m,f)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,m,f){return(0,a.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.W(c);return i.resolveDebugConfigurationWithSubstitutedVariables(s,m,f)})}async $provideDebugAdapter(r,c){const m=this.N(r);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.V(c);return this.R(m,f).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const f={session:await this.V(r),event:c.event,body:c.body};this.u.fire(f)}L(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const c=this.h.filter(m=>m.type===r);if(c.length>0)return c[0].factory}N(r){const c=this.h.filter(m=>m.handle===r);if(c.length>0)return c[0].factory}O(r){const c=this.f.filter(m=>m.handle===r);if(c.length>0)return c[0].provider}P(r,c){if(r.contributes){const m=r.contributes.debuggers;if(m&&m.length>0){for(const f of m)if(f.label&&f.type&&f.type===c)return!0}}return!1}Q(r){const m=r.configuration.type,f=this.j.filter(i=>i.type===m||i.type==="*").map(i=>(0,a.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(f).then(i=>{const s=i.filter(u=>!!u);if(s.length>0)return new y(s)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(r,c){const m=c.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new k.DebugAdapterServer(m));if(r){const i=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.S(c,i))).then(s=>{if(s)return s})}const f=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,f))}S(r,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,c,m){(r.length>0||c.length>0||m.length>0)&&this.z.fire(Object.freeze({added:r,removed:c,changed:m}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const m=await this.W(r.folderUri),f=r.parent?this.l.get(r.parent):void 0;c=new h(this.k,r.id,r.type,r.name,m,r.configuration,f),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=R.URI.revive(r);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};d=Ve([$e(0,O.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,E.IExtHostConfiguration),$e(4,D.IExtHostEditorTabs),$e(5,n.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class h{constructor(r,c,m,f,i,s,u){this.d=r,this.f=c,this.g=m,this.h=f,this.i=i,this.j=s,this.k=u}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=h;class w{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=w;class y{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(m=>m.onExit?m.onExit(r,c):void 0)}}class p extends C.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(r,c,m,f,i,s){super(r,c,m,f,i,s)}};t=Ve([$e(0,O.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,E.IExtHostConfiguration),$e(4,D.IExtHostEditorTabs),$e(5,n.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ie[308],Ce([1,0,8,84,2,5,300,16,91,92,26,209,20,56,43,77]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class n{static async installEarlyHandler(w){const y=w.get(T.ILogService),t=w.get(S.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{y.error(o);const r=a.transformErrorForSerialization(o);t.$onUnexpectedError(r)})}static async installFullHandler(w){const y=w.get(T.ILogService),p=w.get(S.IExtHostRpcService),t=w.get(I.IExtHostExtensionService),o=w.get(E.IExtHostTelemetry),r=p.getProxy(R.MainContext.MainThreadExtensionService),c=p.getProxy(R.MainContext.MainThreadErrors),m=await t.getExtensionPathIndex(),f=new WeakMap;function i(u,b){let g="",L,j;for(const G of b)g+=`
	at ${G.toString()}`,j=G.getFileName(),!L&&j&&(L=m.findSubstr(l.URI.file(j)));return f.set(u,L?.identifier),`${u.name||"Error"}: ${u.message||""}${g}`}let s=i;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return s},set(u){s=function(b,g){return i(b,g),u.call(Error,b,g)}}}),a.setUnexpectedErrorHandler(u=>{y.error(u);const b=a.transformErrorForSerialization(u),g=f.get(u);if(!g){c.$onUnexpectedError(b);return}r.$onExtensionRuntimeError(g,b);const L=o.onExtensionError(g,u);y.trace("forwarded error to extension?",L,g)})}}Error.stackTraceLimit=100;class d{constructor(w,y,p,t,o){this.a=p,this.b=new P.RPCProtocol(w,null,t),y=d.e(y,this.b);const r=new v.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:o}),r.set(S.IExtHostRpcService,new S.ExtHostRpcService(this.b)),r.set(C.IURITransformerService,new C.URITransformerService(t)),r.set(I.IHostUtils,p);const c=new k.InstantiationService(r,!0);c.invokeFunction(n.installEarlyHandler),this.d=c.invokeFunction(m=>m.get(T.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=c.invokeFunction(m=>m.get(I.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(n.installFullHandler)}async asBrowserUri(w){const y=this.b.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await y.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,y){w.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(y.transformIncomingURIs(t.extensionLocation))}),w.environment.appRoot=l.URI.revive(y.transformIncomingURIs(w.environment.appRoot));const p=w.environment.extensionDevelopmentLocationURI;return p&&(w.environment.extensionDevelopmentLocationURI=p.map(t=>l.URI.revive(y.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=l.URI.revive(y.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=l.URI.revive(y.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=l.URI.revive(y.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=l.URI.revive(y.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=l.URI.revive(y.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=l.URI.revive(y.transformIncomingURIs(w.logsLocation)),w.workspace=y.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=d}),define(Ie[309],Ce([1,0,19,14,191,208,216,85,60,43,20,42,7,50,34,234,236,35]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let h=class extends T.ExtHostDebugServiceBase{constructor(o,r,c,m,f,i,s){super(o,r,c,m,i,s),this.Z=f,this.X=new p}J(o,r){switch(o.type){case"server":return new E.SocketDebugAdapter(o);case"pipeServer":return new E.NamedPipeDebugAdapter(o);case"executable":return new E.ExecutableDebugAdapter(o,r.type)}return super.J(o,r)}S(o,r){const c=E.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),o.type);if(c)return new S.DebugAdapterExecutable(c.command,c.args,c.options)}K(){return new P.SignService}async $runInTerminal(o,r){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Q=>{this.X.onTerminalClosed(Q)}));const c=await this.F.getConfigProvider(),m=this.Z.getDefaultShell(!0),f=this.Z.getDefaultShellArgs(!0),i=o.title||l.localize(0,null),s=JSON.stringify({shell:m,shellArgs:f});let u=await this.X.checkout(s,i),b,g=!1;if(u)b=o.cwd;else{const Q={shellPath:m,shellArgs:f,cwd:o.cwd,name:i,iconPath:new S.ThemeIcon("debug")};g=!0,u=this.Z.createTerminalFromOptions(Q,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,s)}u.show(!0);const L=await u.processId;g?await new Promise(Q=>setTimeout(Q,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0||m.indexOf("cmd.exe")>=0?u.sendText("cls"):m.indexOf("bash")>=0?u.sendText("clear"):A.isWindows?u.sendText("cls"):u.sendText("clear"));const j=(0,n.prepareCommand)(m,o.args,!!o.argsCanBeInterpretedByShell,b,o.env);u.sendText(j);const G=this.onDidTerminateDebugSession(Q=>{Q.id===r&&(this.X.free(u),G.dispose())});return L}else if(o.kind==="external")return y(o,await this.F.getConfigProvider());return super.$runInTerminal(o,r)}};h=Ve([$e(0,O.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,v.IExtHostExtensionService),$e(3,d.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,D.IExtHostEditorTabs),$e(6,C.IExtHostVariableResolverProvider)],h),e.ExtHostDebugService=h;let w;function y(t,o){if(!w)if(A.isWindows)w=new R.WindowsExternalTerminalService;else if(A.isMacintosh)w=new R.MacExternalTerminalService;else if(A.isLinux)w=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=o.getConfiguration("terminal");return w.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class p{constructor(){this.b=new Map}async checkout(o,r){const m=[...this.b.entries()].map(([f,i])=>(0,a.createCancelablePromise)(async s=>{if(f.name!==r||i.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await f.processId))return null;const u=Date.now();return i.lastUsedAt+p.a>u||s.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=u,f)}));return await(0,a.firstParallel)(m,f=>!!f)}insert(o,r){this.b.set(o,{lastUsedAt:Date.now(),config:r})}free(o){const r=this.b.get(o);r&&(r.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}p.a=1e3}),define(Ie[310],Ce([1,0,15,2,117,34,59,35,48,42,20,26,83,18,16,78,24,89,50]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends S.ExtHostTaskBase{constructor(p,t,o,r,c,m,f,i,s){super(p,t,o,r,c,m,f,i),this.B=o,this.C=s,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const r=S.TaskHandleDTO.from(o,this.B),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const m=await this.y(c,t);return this.a.$executeTask(r).catch(()=>{}),m}else{const r=S.TaskDTO.from(t,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const c=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),c}}u(p,t,o,r){const c=[];if(r)for(const m of r){this.z(m,o),(!m.definition||!p[m.definition.type])&&this.f.warn(`The task [${m.source}, ${m.name}] uses an undefined task type. The task will be ignored in the future.`);const f=S.TaskDTO.from(m,o.extension);f&&(c.push(f),S.CustomExecutionDTO.is(f.execution)&&t.push(this.x(f,m,!0)))}return{tasks:c,extension:o.extension}}async v(p){return p}async F(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const o=A.URI.file((0,d.homedir)());t=new D.WorkspaceFolder({uri:o,name:n.basename(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const o=A.URI.revive(p),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(o),m=await this.b.getWorkspaceFolders2()??[],f=await this.C.getResolver(),i=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(m);for(const s of t.variables)r.variables[s]=await f.resolveAsync(i,s);if(t.process!==void 0){let s;if(t.process.path!==void 0){s=t.process.path.split(a.delimiter);for(let u=0;u<s.length;u++)s[u]=await f.resolveAsync(i,s[u])}r.process=await l.win32.findExecutable(await f.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await f.resolveAsync(i,t.process.cwd):void 0,s)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,o){return l.win32.findExecutable(p,t,o)}};w=Ve([$e(0,O.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,P.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,v.IExtHostTerminalService),$e(6,I.ILogService),$e(7,E.IExtHostApiDeprecationService),$e(8,h.IExtHostVariableResolverProvider)],w),e.ExtHostTask=w}),define(Ie[311],Ce([1,0,89,50]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends A.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(Ie[144],Ce([1,0,17,19,21,46,18,15,24,2,31]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(h,w,y,p){this.d=h,this.e=w,this.f=y,this.g=p,this.a=null,this.b=!1,this.c=0}search(h,w){const y=this.d.folderQueries||[],p=new l.CancellationTokenSource;return w.onCancellationRequested(()=>p.cancel()),new Promise((t,o)=>{this.a=new C(h);let r=!1;const c=(m,f)=>{if(!r&&!this.b){const i=this.h(m);E(m)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),m=this.j(m,this.d.maxResults-this.c));const s=this.h(m);this.c+=s,(s>0||!E(m))&&this.a.add(m,f)}};Promise.all(y.map((m,f)=>this.k(m,i=>c(i,f),p.token))).then(m=>{p.dispose(),this.a.flush();const f=m.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||f,messages:(0,a.flatten)(m.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},m=>{p.dispose();const f=(0,R.toErrorMessage)(m);o(new Error(f))})})}h(h){return E(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,w){const y=Array.isArray(h.ranges)?h.ranges:[h.ranges],p=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:y.slice(0,w),preview:{matches:p.slice(0,w),text:h.preview.text},uri:h.uri}}async k(h,w,y){const p=new O.QueryGlobTester(this.d,h),t=[],o={report:m=>{if(!this.l(m))return;const f=h.folder.scheme===P.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(D.dirname(m.uri))):void 0,i=D.relativePath(h.folder,m.uri);if(i){const s=p.includedInQuery(i,T.basename(i),f);(0,A.isThenable)(s)?t.push(s.then(u=>{u&&w(m)})):s&&w(m)}}},r=this.n(h),c=await this.e.provideTextSearchResults(S(this.d.contentPattern),r,o,y);return t.length&&await Promise.all(t),c}l(h){if(E(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const w=(0,O.resolvePatternsForProvider)(this.d.includePattern,h.includePattern),y=(0,O.resolvePatternsForProvider)(this.d.excludePattern,h.excludePattern),p={folder:v.URI.from(h.folder),excludes:y,includes:w,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.f.toCanonicalName(h.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=k;function S(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class C{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new n(512,w=>this.g(w))}add(h,w){this.d&&(this.b!==w||!D.isEqual(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:h.uri,results:[]}),this.d.results.push(I(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.TextSearchResultsCollector=C;function I(d){return E(d)?{preview:{matches:(0,a.mapArrayOrNot)(d.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:d.preview.text},ranges:(0,a.mapArrayOrNot)(d.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function E(d){return!!d.preview}e.extensionResultIsMatch=E;class n{constructor(h,w){this.g=h,this.h=w,this.c=0,this.d=[],this.e=0}addItem(h,w){!h||this.j(h,w)}addItems(h,w){!h||this.k(h,w)}j(h,w){this.d.push(h),this.e+=w,this.l()}k(h,w){this.d=this.d.concat(h),this.e+=w,this.l()}l(){this.c<n.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},n.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}n.a=4e3,n.b=50,e.BatchedCollector=n}),define(Ie[86],Ce([1,0,6,5,4,304,20,56,16,2,144]),function(se,e,a,A,l,R,P,T,D,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let k=class{constructor(E,n,d){this.k=E,this.l=n,this.n=d,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,n){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const d=this.d++;return this.e.set(d,n),this.c.$registerTextSearchProvider(d,this.o(E)),(0,a.toDisposable)(()=>{this.g.delete(E),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(E,n){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const d=this.d++;return this.h.set(d,n),this.c.$registerFileSearchProvider(d,this.o(E)),(0,a.toDisposable)(()=>{this.i.delete(E),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(E,n,d,h){const w=S(d),y=this.h.get(E);if(y)return this.j.fileSearch(w,y,p=>{this.c.$handleFileMatch(E,n,p.map(t=>t.resource))},h);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,n,d,h){const w=this.e.get(E);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const y=S(d);return this.q(y,w).search(t=>this.c.$handleTextMatch(E,n,t),h)}$enableExtensionHostSearch(){}q(E,n){return new O.TextSearchManager(E,n,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};k=Ve([$e(0,P.IExtHostRpcService),$e(1,T.IURITransformerService),$e(2,D.ILogService)],k),e.ExtHostSearch=k;function S(I){return{...I,folderQueries:I.folderQueries&&I.folderQueries.map(C),extraFileResources:I.extraFileResources&&I.extraFileResources.map(E=>v.URI.revive(E))}}e.reviveQuery=S;function C(I){return{...I,folder:v.URI.revive(I.folder)}}}),define(Ie[312],Ce([1,0,21,8,3,38,2,122,108,154,166,45,5,97,260,259,41,261,35,263,264,265,246,266,59,43,267,268,273,274,275,143,250,281,282,283,100,42,285,251,11,7,74,288,81,142,34,25,238,272,73,140,83,85,86,16,56,20,26,276,245,55,78,257,286,80,79,291,289,290,258,49,284,287,99,60,77,277,82,278,18,125,249,227,269,6,27,232,98,223,279,280,271,270,248]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t,o,r,c,m,f,i,s,u,b,g,L,j,G,Q,B,U,z,M,x,fe,re,V,_,te,ve,le,ue,q,F,J,ge,Ee,ie,ne,de,ee,ce,ae,N,$,X,Z,he,Se,Re,we,Te,ke,je,We,tt,Ye,nt,st,Be,it,W,Y,me,Le,Ne,xe,Qe,Xe,rt,ct,vt,mt,wt,Ct,Lt,Yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Kt(ht){const gt=ht.get(ee.IExtHostInitDataService),Ot=ht.get(je.IExtHostFileSystemInfo),Mt=ht.get(Se.IExtHostConsumerFileSystem),Tt=ht.get(c.IExtHostExtensionService),pt=ht.get(te.IExtHostWorkspace),Dt=ht.get(st.IExtHostTelemetry),zt=ht.get(h.IExtHostConfiguration),kt=ht.get(ne.IURITransformerService),Ke=ht.get(de.IExtHostRpcService),Vt=ht.get(Q.IExtHostStorage),Xt=ht.get(he.IExtensionStoragePaths),Ut=ht.get(ie.ILoggerService),Ae=ht.get(ie.ILogService),Oe=ht.get(N.IExtHostTunnelService),De=ht.get($.IExtHostApiDeprecationService),oe=ht.get(_.IExtHostWindow),Fe=ht.get(Ye.IExtHostSecretState),He=ht.get(nt.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ke.set(S.ExtHostContext.ExtHostWorkspace,pt),Ke.set(S.ExtHostContext.ExtHostConfiguration,zt),Ke.set(S.ExtHostContext.ExtHostExtensionService,Tt),Ke.set(S.ExtHostContext.ExtHostStorage,Vt),Ke.set(S.ExtHostContext.ExtHostTunnelService,Oe),Ke.set(S.ExtHostContext.ExtHostWindow,oe),Ke.set(S.ExtHostContext.ExtHostSecretState,Fe),Ke.set(S.ExtHostContext.ExtHostTelemetry,Dt),Ke.set(S.ExtHostContext.ExtHostEditorTabs,He);const Ze=Ke.set(S.ExtHostContext.ExtHostDecorations,ht.get(F.IExtHostDecorations)),qe=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(r.IExtHostDocumentsAndEditors)),et=Ke.set(S.ExtHostContext.ExtHostCommands,ht.get(n.IExtHostCommands)),dt=Ke.set(S.ExtHostContext.ExtHostTerminalService,ht.get(B.IExtHostTerminalService)),ut=Ke.set(S.ExtHostContext.ExtHostDebugService,ht.get(ge.IExtHostDebugService)),It=Ke.set(S.ExtHostContext.ExtHostSearch,ht.get(Ee.IExtHostSearch)),bt=Ke.set(S.ExtHostContext.ExtHostTask,ht.get(J.IExtHostTask)),Nt=Ke.set(S.ExtHostContext.ExtHostOutputService,ht.get(b.IExtHostOutputService)),Bt=Ke.set(S.ExtHostContext.ExtHostLocalization,ht.get(ct.IExtHostLocalizationService)),Li=Ke.set(S.ExtHostContext.ExtHostUrls,new re.ExtHostUrls(Ke)),Pt=Ke.set(S.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ke,qe)),wi=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,qe,Ae)),ci=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ae,Pt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),St=Ke.set(S.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,et,qe,Pt)),li=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(St)),ui=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new Le.ExtHostNotebookEditors(Ae,St)),ii=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new Be.ExtHostNotebookKernels(Ke,gt,St,et,Ae)),Ei=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new W.ExtHostNotebookRenderers(Ke,St)),xt=Ke.set(S.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Yt.ExtHostNotebookDocumentSaveParticipant(Ae,St,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),At=Ke.set(S.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,qe)),Oi=Ke.set(S.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),et,Ae)),Si=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),At,gt.remote)),ni=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ke,Ae,Ot,qe)),di=Ke.set(S.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ke,Pt,et.converter,kt)),lt=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,kt,Pt,et,ni,Ae,De,Dt)),yi=Ke.set(S.ExtHostContext.ExtHostFileSystem,new m.ExtHostFileSystem(Ke,lt)),qt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ke,Ae,qe)),Jt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(Ke,pt,et)),hi=Ke.set(S.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Ke,et,Ae)),Di=Ke.set(S.ExtHostContext.ExtHostQuickDiff,new wt.ExtHostQuickDiff(Ke,kt)),Ii=Ke.set(S.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,et,Pt)),fi=Ke.set(S.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),Ci=Ke.set(S.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ke)),Ni=Ke.set(S.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ke)),_t=Ke.set(S.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(Ke)),ki=Ke.set(S.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline(Ke,et)),ri=Ke.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,gt.remote,pt,Ae,De)),si=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new Te.ExtHostWebviewPanels(Ke,ri,pt)),$i=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ke,Pt,Xt,ri,si)),Ti=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new Re.ExtHostWebviewViews(Ke,ri)),Zt=Ke.set(S.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ke,et,qe)),Wi=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ke)),Hi=Ke.set(S.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new xe.ExtHostInteractive(Ke,St,qe,et,Ae));const ji=Ke.set(S.ExtHostContext.ExtHostInteractiveEditor,new Lt.ExtHostInteractiveEditor(Ke,Pt,Ae)),mi=Ke.set(S.ExtHostContext.ExtHostInteractiveSession,new Ct.ExtHostInteractiveSession(Ke,Ae)),Vi=Object.values(S.ExtHostContext);Ke.assertRegistered(Vi);const xi=new ke.ExtHostBulkEdits(Ke,qe),Pi=new E.ExtHostClipboard(Ke),oi=new u.ExtHostMessageService(Ke,Ae),Fi=new y.ExtHostDialogs(Ke),Mi=new G.ExtHostStatusBar(Ke,et.converter);return I.ExtHostApiCommands.register(et),function(ze,$t,Ui){const Et=function(){let be=!ze.isUnderDevelopment;function ye(){be||(Ae.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")ye();else{const yt=ot;typeof yt.scheme>"u"&&ye(),typeof yt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),qi={getSession(be,ye,Me){return _t.getSession(ze,be,ye,Me)},getSessions(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"getSessions"),_t.getSessions(ze,be,ye)},async hasSession(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"authSession"),!!await _t.getSession(ze,be,ye,{silent:!0})},get onDidChangeSessions(){return _t.onDidChangeSessions},registerAuthenticationProvider(be,ye,Me,ot){return _t.registerAuthenticationProvider(be,ye,Me,ot)}},Gi={registerCommand(be,ye,Me){return et.registerCommand(!0,be,ye,Me,void 0,ze)},registerTextEditorCommand(be,ye,Me){return et.registerCommand(!0,be,(...ot)=>{const yt=At.getActiveTextEditor();if(!yt){Ae.warn("Cannot execute "+be+" because there is no active text editor.");return}return yt.edit(Rt=>{ye.apply(Me,[yt,Rt,...ot])}).then(Rt=>{Rt||Ae.warn("Edits from command "+be+" were not applied.")},Rt=>{Ae.warn("An error occurred while running command "+be,Rt)})},void 0,void 0,ze)},registerDiffInformationCommand:(be,ye,Me)=>((0,Xe.checkProposedApiEnabled)(ze,"diffCommand"),et.registerCommand(!0,be,async(...ot)=>{const yt=qe.activeEditor(!0);if(!yt){Ae.warn("Cannot execute "+be+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(yt.id);ye.apply(Me,[Rt,...ot])},void 0,void 0,ze)),executeCommand(be,...ye){return et.executeCommand(be,...ye)},getCommands(be=!1){return et.getCommands(be)}},gi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)(ze,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(ze,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,st.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,ye){return st.ExtHostTelemetryLogger.validateSender(be),Dt.instantiateLogger(ze,be,ye)},openExternal(be,ye){return oe.openUri(be,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===gt.environment.appUriScheme)return Li.createAppUri(be);try{return await oe.asExternalUri(be,{allowTunneling:!!gt.remote.authority})}catch(ye){if((0,me.matchesScheme)(be,Y.Schemas.http)||(0,me.matchesScheme)(be,Y.Schemas.https))return be;throw ye}},get remoteName(){return(0,q.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(ze,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Ae.getLevel()},get onDidChangeLogLevel(){return Ae.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(gi);const Ki={createTestController(be,ye,Me){return Zt.createTestController(ze,be,ye,Me)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Zt.createTestObserver()},runTests(be){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Zt.runTests(be)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)(ze,"testObserver"),Zt.results}},Wt=gt.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,pi={getExtension(be,ye){(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")||(ye=!1);const Me=$t.mine.getExtensionDescription(be);if(Me)return new c.Extension(Tt,ze.identifier,Me,Wt,!1);if(ye){const ot=$t.all.getExtensionDescription(be);if(ot)return new c.Extension(Tt,ze.identifier,ot,Wt,!0)}},get all(){const be=[];for(const ye of $t.mine.getAllExtensionDescriptions())be.push(new c.Extension(Tt,ze.identifier,ye,Wt,!1));return be},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(ze,"extensionsAny");const be=new ve.ExtensionIdentifierSet($t.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),ye=[];for(const Me of $t.all.getAllExtensionDescriptions()){const ot=!be.has(Me.identifier);ye.push(new c.Extension(Tt,ze.identifier,Me,Wt,ot))}return ye},get onDidChange(){return(0,Xe.isProposedApiEnabled)(ze,"extensionsAny")?l.Event.any($t.mine.onDidChange,$t.all.onDidChange):$t.mine.onDidChange}},Xi={createDiagnosticCollection(be){return ni.createDiagnosticCollection(ze.identifier,be)},get onDidChangeDiagnostics(){return ni.onDidChangeDiagnostics},getDiagnostics:be=>ni.getDiagnostics(be),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(be,ye){return di.changeLanguage(be.uri,ye)},match(be,ye){const Me=Pt.getDocumentData(ye.uri)?.notebook;return(0,O.score)(M.LanguageSelector.from(be),ye.uri,ye.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(be,ye,Me){return lt.registerCodeActionProvider(ze,Et(be),ye,Me)},registerDocumentPasteEditProvider(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,Et(be),ye,Me)},registerCodeLensProvider(be,ye){return lt.registerCodeLensProvider(ze,Et(be),ye)},registerDefinitionProvider(be,ye){return lt.registerDefinitionProvider(ze,Et(be),ye)},registerDeclarationProvider(be,ye){return lt.registerDeclarationProvider(ze,Et(be),ye)},registerImplementationProvider(be,ye){return lt.registerImplementationProvider(ze,Et(be),ye)},registerTypeDefinitionProvider(be,ye){return lt.registerTypeDefinitionProvider(ze,Et(be),ye)},registerHoverProvider(be,ye){return lt.registerHoverProvider(ze,Et(be),ye,ze.identifier)},registerEvaluatableExpressionProvider(be,ye){return lt.registerEvaluatableExpressionProvider(ze,Et(be),ye,ze.identifier)},registerInlineValuesProvider(be,ye){return lt.registerInlineValuesProvider(ze,Et(be),ye,ze.identifier)},registerDocumentHighlightProvider(be,ye){return lt.registerDocumentHighlightProvider(ze,Et(be),ye)},registerLinkedEditingRangeProvider(be,ye){return lt.registerLinkedEditingRangeProvider(ze,Et(be),ye)},registerReferenceProvider(be,ye){return lt.registerReferenceProvider(ze,Et(be),ye)},registerRenameProvider(be,ye){return lt.registerRenameProvider(ze,Et(be),ye)},registerDocumentSymbolProvider(be,ye,Me){return lt.registerDocumentSymbolProvider(ze,Et(be),ye,Me)},registerWorkspaceSymbolProvider(be){return lt.registerWorkspaceSymbolProvider(ze,be)},registerDocumentFormattingEditProvider(be,ye){return lt.registerDocumentFormattingEditProvider(ze,Et(be),ye)},registerDocumentRangeFormattingEditProvider(be,ye){return lt.registerDocumentRangeFormattingEditProvider(ze,Et(be),ye)},registerOnTypeFormattingEditProvider(be,ye,Me,...ot){return lt.registerOnTypeFormattingEditProvider(ze,Et(be),ye,[Me].concat(ot))},registerDocumentSemanticTokensProvider(be,ye,Me){return lt.registerDocumentSemanticTokensProvider(ze,Et(be),ye,Me)},registerDocumentRangeSemanticTokensProvider(be,ye,Me){return lt.registerDocumentRangeSemanticTokensProvider(ze,Et(be),ye,Me)},registerSignatureHelpProvider(be,ye,Me,...ot){return typeof Me=="object"?lt.registerSignatureHelpProvider(ze,Et(be),ye,Me):lt.registerSignatureHelpProvider(ze,Et(be),ye,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(be,ye,...Me){return lt.registerCompletionItemProvider(ze,Et(be),ye,Me)},registerInlineCompletionItemProvider(be,ye){return ye.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,Et(be),ye)},registerDocumentLinkProvider(be,ye){return lt.registerDocumentLinkProvider(ze,Et(be),ye)},registerColorProvider(be,ye){return lt.registerColorProvider(ze,Et(be),ye)},registerFoldingRangeProvider(be,ye){return lt.registerFoldingRangeProvider(ze,Et(be),ye)},registerSelectionRangeProvider(be,ye){return lt.registerSelectionRangeProvider(ze,be,ye)},registerCallHierarchyProvider(be,ye){return lt.registerCallHierarchyProvider(ze,be,ye)},registerTypeHierarchyProvider(be,ye){return lt.registerTypeHierarchyProvider(ze,be,ye)},setLanguageConfiguration:(be,ye)=>lt.setLanguageConfiguration(ze,be,ye),getTokenInformationAtPosition(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"tokenInformation"),di.tokenAtPosition(be,ye)},registerInlayHintsProvider(be,ye){return lt.registerInlayHintsProvider(ze,be,ye)},createLanguageStatusItem(be,ye){return di.createLanguageStatusItem(ze,be,ye)},registerDocumentDropEditProvider(be,ye){return lt.registerDocumentOnDropEditProvider(ze,be,ye)}},Ht={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(be,ye,Me){const ot=await(P.URI.isUri(be)?Promise.resolve(ai.openTextDocument(be)):Promise.resolve(be));return At.showTextDocument(ot,ye,Me)},createTextEditorDecorationType(be){return At.createTextEditorDecorationType(ze,be)},onDidChangeActiveTextEditor(be,ye,Me){return At.onDidChangeActiveTextEditor(be,ye,Me)},onDidChangeVisibleTextEditors(be,ye,Me){return At.onDidChangeVisibleTextEditors(be,ye,Me)},onDidChangeTextEditorSelection(be,ye,Me){return At.onDidChangeTextEditorSelection(be,ye,Me)},onDidChangeTextEditorOptions(be,ye,Me){return At.onDidChangeTextEditorOptions(be,ye,Me)},onDidChangeTextEditorVisibleRanges(be,ye,Me){return At.onDidChangeTextEditorVisibleRanges(be,ye,Me)},onDidChangeTextEditorViewColumn(be,ye,Me){return At.onDidChangeTextEditorViewColumn(be,ye,Me)},onDidCloseTerminal(be,ye,Me){return dt.onDidCloseTerminal(be,ye,Me)},onDidOpenTerminal(be,ye,Me){return dt.onDidOpenTerminal(be,ye,Me)},onDidChangeActiveTerminal(be,ye,Me){return dt.onDidChangeActiveTerminal(be,ye,Me)},onDidChangeTerminalDimensions(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(be,ye,Me)},onDidChangeTerminalState(be,ye,Me){return dt.onDidChangeTerminalState(be,ye,Me)},onDidWriteTerminalData(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(be,ye,Me)},get state(){return oe.state},onDidChangeWindowState(be,ye,Me){return oe.onDidChangeWindowState(be,ye,Me)},showInformationMessage(be,...ye){return oi.showMessage(ze,R.default.Info,be,ye[0],ye.slice(1))},showWarningMessage(be,...ye){return oi.showMessage(ze,R.default.Warning,be,ye[0],ye.slice(1))},showErrorMessage(be,...ye){return oi.showMessage(ze,R.default.Error,be,ye[0],ye.slice(1))},showQuickPick(be,ye,Me){return Jt.showQuickPick(ze,be,ye,Me)},showWorkspaceFolderPick(be){return Jt.showWorkspaceFolderPick(be)},showInputBox(be,ye){return Jt.showInput(be,ye)},showOpenDialog(be){return Fi.showOpenDialog(ze,be)},showSaveDialog(be){return Fi.showSaveDialog(be)},createStatusBarItem(be,ye,Me){let ot,yt,Rt;return typeof be=="string"?(ot=be,yt=ye,Rt=Me):(yt=be,Rt=ye),Mi.createStatusBarEntry(ze,ot,yt,Rt)},setStatusBarMessage(be,ye){return Mi.setStatusBarMessage(be,ye)},withScmProgress(be){return De.report("window.withScmProgress",ze,"Use 'withProgress' instead."),fi.withProgress(ze,{location:x.ProgressLocation.SourceControl},(ye,Me)=>be({report(ot){}}))},withProgress(be,ye){return fi.withProgress(ze,be,ye)},createOutputChannel(be,ye){return Nt.createOutputChannel(be,ye,ze)},createWebviewPanel(be,ye,Me,ot){return si.createWebviewPanel(ze,be,ye,Me,ot)},createWebviewTextEditorInset(be,ye,Me,ot){return(0,Xe.checkProposedApiEnabled)(ze,"editorInsets"),Si.createWebviewEditorInset(be,ye,Me,ot,ze)},createTerminal(be,ye,Me){return typeof be=="object"?"pty"in be?dt.createExtensionTerminal(be):dt.createTerminalFromOptions(be):dt.createTerminal(be,ye,Me)},registerTerminalLinkProvider(be){return dt.registerLinkProvider(be)},registerTerminalProfileProvider(be,ye){return dt.registerProfileProvider(ze,be,ye)},registerTerminalQuickFixProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(be,ze.identifier.value,ye)},registerTreeDataProvider(be,ye){return Oi.registerTreeDataProvider(be,ye,ze)},createTreeView(be,ye){return Oi.createTreeView(be,ye,ze)},registerWebviewPanelSerializer:(be,ye)=>si.registerWebviewPanelSerializer(ze,be,ye),registerCustomEditorProvider:(be,ye,Me={})=>$i.registerCustomEditorProvider(ze,be,ye,Me),registerFileDecorationProvider(be){return Ze.registerFileDecorationProvider(be,ze)},registerUriHandler(be){return Li.registerUriHandler(ze.identifier,be)},createQuickPick(){return Jt.createQuickPick(ze)},createInputBox(){return Jt.createInputBox(ze)},get activeColorTheme(){return Ni.activeColorTheme},onDidChangeActiveColorTheme(be,ye,Me){return Ni.onDidChangeActiveColorTheme(be,ye,Me)},registerWebviewViewProvider(be,ye,Me){return Ti.registerWebviewViewProvider(ze,be,ye,Me?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ye,Me){return St.onDidChangeActiveNotebookEditor(be,ye,Me)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,ye,Me){return ui.onDidChangeNotebookEditorSelection(be,ye,Me)},onDidChangeNotebookEditorVisibleRanges(be,ye,Me){return ui.onDidChangeNotebookEditorVisibleRanges(be,ye,Me)},showNotebookDocument(be,ye){return St.showNotebookDocument(be,ye)},registerExternalUriOpener(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"externalUriOpener"),Wi.registerExternalUriOpener(ze.identifier,be,ye,Me)},registerProfileContentHandler(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"profileContentHandlers"),Hi.registrProfileContentHandler(ze,be,ye)},registerQuickDiffProvider(be,ye,Me,ot){return(0,Xe.checkProposedApiEnabled)(ze,"quickDiffProvider"),Di.registerQuickDiffProvider(Et(be),ye,Me,ot)},get tabGroups(){return He.tabGroups}},ai={get rootPath(){return De.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(be){throw A.readonly()},getWorkspaceFolder(be){return pt.getWorkspaceFolder(be)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(be){throw A.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(be){throw A.readonly()},updateWorkspaceFolders:(be,ye,...Me)=>pt.updateWorkspaceFolders(ze,be,ye||0,...Me),onDidChangeWorkspaceFolders:function(be,ye,Me){return pt.onDidChangeWorkspace(be,ye,Me)},asRelativePath:(be,ye)=>pt.getRelativePath(be,ye),findFiles:(be,ye,Me,ot)=>pt.findFiles(be,ye,Me,ze.identifier,ot),findTextInFiles:(be,ye,Me,ot)=>{(0,Xe.checkProposedApiEnabled)(ze,"findTextInFiles");let yt,Rt;return typeof ye=="object"?(yt=ye,Rt=Me):(yt={},Rt=ye,ot=Me),pt.findTextInFiles(be,yt||{},Rt,ze.identifier,ot)},saveAll:be=>pt.saveAll(be),applyEdit(be,ye){return xi.applyWorkspaceEdit(be,ze,ye)},createFileSystemWatcher:(be,ye,Me,ot)=>qt.createFileSystemWatcher(pt,ze,be,ye,Me,ot),get textDocuments(){return Pt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw A.readonly()},openTextDocument(be){let ye;const Me=be;if(typeof be=="string")ye=Promise.resolve(P.URI.file(be));else if(P.URI.isUri(be))ye=Promise.resolve(be);else if(!Me||typeof Me=="object")ye=Pt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ot=>Pt.ensureDocumentData(ot).then(yt=>yt.document))},onDidOpenTextDocument:(be,ye,Me)=>Pt.onDidAddDocument(be,ye,Me),onDidCloseTextDocument:(be,ye,Me)=>Pt.onDidRemoveDocument(be,ye,Me),onDidChangeTextDocument:(be,ye,Me)=>Pt.onDidChangeDocument(be,ye,Me),onDidSaveTextDocument:(be,ye,Me)=>Pt.onDidSaveDocument(be,ye,Me),onWillSaveTextDocument:(be,ye,Me)=>ci.getOnWillSaveTextDocumentEvent(ze)(be,ye,Me),get notebookDocuments(){return St.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ye){let Me;if(P.URI.isUri(be))Me=be,await St.openNotebookDocument(be);else if(typeof be=="string")Me=P.URI.revive(await St.createNotebookDocument({viewType:be,content:ye}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(be,ye,Me){return li.onDidSaveNotebookDocument(be,ye,Me)},onDidChangeNotebookDocument(be,ye,Me){return li.onDidChangeNotebookDocument(be,ye,Me)},onWillSaveNotebookDocument(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"notebookDocumentWillSave"),xt.getOnWillSaveNotebookDocumentEvent(ze)(be,ye,Me)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(be,ye,Me,ot){return St.registerNotebookSerializer(ze,be,ye,Me,(0,Xe.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(be,ye,Me)=>Ui.onDidChangeConfiguration(be,ye,Me),getConfiguration(be,ye){return ye=arguments.length===1?void 0:ye,Ui.getConfiguration(be,ye,ze)},registerTextDocumentContentProvider(be,ye){return wi.registerTextDocumentContentProvider(be,ye)},registerTaskProvider:(be,ye)=>(De.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(ze,be,ye)),registerFileSystemProvider(be,ye,Me){return(0,Qe.combinedDisposable)(yi.registerFileSystemProvider(ze,be,ye,Me),Mt.addFileSystemProvider(be,ye))},get fs(){return Mt.value},registerFileSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"fileSearchProvider"),It.registerFileSearchProvider(be,ye)),registerTextSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"textSearchProvider"),It.registerTextSearchProvider(be,ye)),registerRemoteAuthorityResolver:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Tt.registerRemoteAuthorityResolver(be,ye)),registerResourceLabelFormatter:be=>((0,Xe.checkProposedApiEnabled)(ze,"resolvers"),Ci.$registerResourceLabelFormatter(be)),onDidCreateFiles:(be,ye,Me)=>qt.onDidCreateFile(be,ye,Me),onDidDeleteFiles:(be,ye,Me)=>qt.onDidDeleteFile(be,ye,Me),onDidRenameFiles:(be,ye,Me)=>qt.onDidRenameFile(be,ye,Me),onWillCreateFiles:(be,ye,Me)=>qt.getOnWillCreateFileEvent(ze)(be,ye,Me),onWillDeleteFiles:(be,ye,Me)=>qt.getOnWillDeleteFileEvent(ze)(be,ye,Me),onWillRenameFiles:(be,ye,Me)=>qt.getOnWillRenameFileEvent(ze)(be,ye,Me),openTunnel:be=>((0,Xe.checkProposedApiEnabled)(ze,"tunnels"),Oe.openTunnel(ze,be).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(ze,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(be,ye,Me)=>((0,Xe.checkProposedApiEnabled)(ze,"tunnels"),Oe.onDidChangeTunnels(be,ye,Me)),registerPortAttributesProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"portsAttributes"),Oe.registerPortsAttributesProvider(be,ye)),registerTimelineProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"timeline"),ki.registerTimelineProvider(be,ye,ze.identifier,et.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:be=>((0,Xe.checkProposedApiEnabled)(ze,"workspaceTrust"),pt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ye,Me)=>pt.onDidGrantWorkspaceTrust(be,ye,Me),registerEditSessionIdentityProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(be,ye)),onWillCreateEditSessionIdentity:(be,ye,Me)=>((0,Xe.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent(ze)(be,ye,Me))},Qi={get inputBox(){return De.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(ze)},createSourceControl(be,ye,Me){return hi.createSourceControl(ze,be,ye,Me)}},Yi={createCommentController(be,ye){return Ii.createCommentController(ze,be,ye)}},Ji={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(be,ye,Me){return ut.onDidStartDebugSession(be,ye,Me)},onDidTerminateDebugSession(be,ye,Me){return ut.onDidTerminateDebugSession(be,ye,Me)},onDidChangeActiveDebugSession(be,ye,Me){return ut.onDidChangeActiveDebugSession(be,ye,Me)},onDidReceiveDebugSessionCustomEvent(be,ye,Me){return ut.onDidReceiveDebugSessionCustomEvent(be,ye,Me)},onDidChangeBreakpoints(be,ye,Me){return ut.onDidChangeBreakpoints(be,ye,Me)},registerDebugConfigurationProvider(be,ye,Me){return ut.registerDebugConfigurationProvider(be,ye,Me||rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ye){return ut.registerDebugAdapterDescriptorFactory(ze,be,ye)},registerDebugAdapterTrackerFactory(be,ye){return ut.registerDebugAdapterTrackerFactory(be,ye)},startDebugging(be,ye,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(be,ye,{parentSession:Me}):ut.startDebugging(be,ye,Me||{})},stopDebugging(be){return ut.stopDebugging(be)},addBreakpoints(be){return ut.addBreakpoints(be)},removeBreakpoints(be){return ut.removeBreakpoints(be)},asDebugSourceUri(be,ye){return ut.asDebugSourceUri(be,ye)}},_i={registerTaskProvider:(be,ye)=>bt.registerTaskProvider(ze,be,ye),fetchTasks:be=>bt.fetchTasks(be),executeTask:be=>bt.executeTask(ze,be),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(be,ye,Me)=>bt.onDidStartTask(be,ye,Me),onDidEndTask:(be,ye,Me)=>bt.onDidEndTask(be,ye,Me),onDidStartTaskProcess:(be,ye,Me)=>bt.onDidStartTaskProcess(be,ye,Me),onDidEndTaskProcess:(be,ye,Me)=>bt.onDidEndTaskProcess(be,ye,Me)},Zi={createNotebookController(be,ye,Me,ot,yt){return ii.createNotebookController(ze,be,ye,Me,ot,(0,Xe.isProposedApiEnabled)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(be,ye)=>St.registerNotebookCellStatusBarItemProvider(ze,be,ye),createRendererMessaging(be){return Ei.createRendererMessaging(ze,be)},createNotebookControllerDetectionTask(be){return(0,Xe.checkProposedApiEnabled)(ze,"notebookKernelSource"),ii.createNotebookControllerDetectionTask(ze,be)},registerKernelSourceActionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"notebookKernelSource"),ii.registerKernelSourceActionProvider(ze,be,ye)},onDidChangeNotebookCellExecutionState(be,ye,Me){return(0,Xe.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(be,ye,Me)}},en={t(...be){if(typeof be[0]=="string"){const ye=be.shift(),Me=!be||typeof be[0]!="object"?be:be[0];return Bt.getMessage(ze.identifier.value,{message:ye,args:Me})}return Bt.getMessage(ze.identifier.value,be[0])},get bundle(){return Bt.getBundle(ze.identifier.value)},get uri(){return Bt.getBundleUri(ze.identifier.value)}},tn={_version:1,registerInteractiveEditorSessionProvider(be){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),ji.registerProvider(ze,be)},registerInteractiveSessionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),mi.registerInteractiveSessionProvider(ze,be,ye)},addInteractiveRequest(be){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),mi.addInteractiveSessionRequest(be)},sendInteractiveRequestToProvider(be,ye){return(0,Xe.checkProposedApiEnabled)(ze,"interactive"),mi.sendInteractiveRequestToProvider(be,ye)},get onDidPerformUserAction(){return mi.onDidPerformUserAction}};return{version:gt.version,authentication:qi,commands:Gi,comments:Yi,debug:Ji,env:gi,extensions:pi,interactive:tn,l10n:en,languages:Xi,notebooks:Zi,scm:Qi,tasks:_i,tests:Ki,window:Ht,workspace:ai,Breakpoint:x.Breakpoint,TerminalOutputAnchor:x.TerminalOutputAnchor,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CommentThreadState:x.CommentThreadState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:x.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileDecoration2:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,InlineCompletionItem:x.InlineSuggestion,InlineCompletionList:x.InlineSuggestionList,Hover:x.Hover,IndentAction:v.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TerminalLink:x.TerminalLink,TerminalQuickFixCommand:x.TerminalQuickFixCommand,TerminalQuickFixOpener:x.TerminalQuickFixOpener,TerminalLocation:x.TerminalLocation,TerminalProfile:x.TerminalProfile,TerminalExitReason:x.TerminalExitReason,TerminalQuickFixType:x.TerminalQuickFixType,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,SnippetTextEdit:x.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,TextDocumentChangeReason:x.TextDocumentChangeReason,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItem2:x.TreeItem,TreeItemCheckboxState:x.TreeItemCheckboxState,TreeItemCollapsibleState:x.TreeItemCollapsibleState,TypeHierarchyItem:x.TypeHierarchyItem,UIKind:C.UIKind,Uri:P.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,DocumentDropEdit:x.DocumentDropEdit,DocumentPasteEdit:x.DocumentPasteEdit,InlayHint:x.InlayHint,InlayHintLabelPart:x.InlayHintLabelPart,InlayHintKind:x.InlayHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookRange:x.NotebookRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookRendererScript:x.NotebookRendererScript,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,NotebookCellStatusBarItem:x.NotebookCellStatusBarItem,NotebookControllerAffinity:x.NotebookControllerAffinity,NotebookControllerAffinity2:x.NotebookControllerAffinity2,NotebookDocumentSaveReason:x.NotebookDocumentSaveReason,NotebookEdit:x.NotebookEdit,NotebookKernelSourceAction:x.NotebookKernelSourceAction,PortAttributes:x.PortAttributes,LinkedEditingRanges:x.LinkedEditingRanges,TestResultState:x.TestResultState,TestRunRequest:x.TestRunRequest,TestRunRequest2:x.TestRunRequest2,TestMessage:x.TestMessage,TestTag:x.TestTag,TestRunProfileKind:x.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:x.DataTransfer,DataTransferItem:x.DataTransferItem,CoveredCount:x.CoveredCount,FileCoverage:x.FileCoverage,StatementCoverage:x.StatementCoverage,BranchCoverage:x.BranchCoverage,FunctionCoverage:x.FunctionCoverage,WorkspaceTrustState:x.WorkspaceTrustState,LanguageStatusSeverity:x.LanguageStatusSeverity,QuickPickItemKind:x.QuickPickItemKind,InputBoxValidationSeverity:x.InputBoxValidationSeverity,TabInputText:x.TextTabInput,TabInputTextDiff:x.TextDiffTabInput,TabInputTextMerge:x.TextMergeTabInput,TabInputCustom:x.CustomEditorTabInput,TabInputNotebook:x.NotebookEditorTabInput,TabInputNotebookDiff:x.NotebookDiffEditorTabInput,TabInputWebview:x.WebviewEditorTabInput,TabInputTerminal:x.TerminalEditorTabInput,TabInputInteractiveWindow:x.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:ie.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:x.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:x.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:x.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Kt}),define(Ie[313],Ce([1,0,91,143,34,140,35,41,59,42,83,85,86,100,55,78,142,79,49,99,77,60,141,16,50,98]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t,o,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,t.ExtHostLoggerService,1),(0,a.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration,0),(0,a.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,a.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,0),(0,a.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,a.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,a.registerSingleton)(v.IExtHostTerminalService,v.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(I.IExtHostTunnelService,I.ExtHostTunnelService,0),(0,a.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,a.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,a.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,a.registerSingleton)(y.IExtHostTelemetry,y.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ie[101],Ce([1,0,17,16,31,82]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=P;function T(k,S,C,I){const E=(0,a.mapArrayOrNot)(C,D),n=new l.TextSearchMatch(S,E,I),d=n.preview.matches;return{ranges:(0,a.mapArrayOrNot)(E,v),uri:k,preview:{text:n.preview.text,matches:(0,a.mapArrayOrNot)(d,v)}}}e.createTextSearchResult=T;function D(k){return new l.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function v(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let O=class{constructor(S,C){this.a=S,this.b=C}appendLine(S){this.b.debug(`${this.a}#search`,S)}};O=Ve([$e(1,A.ILogService)],O),e.OutputChannel=O}),define(Ie[314],Ce([1,0,47,15,87,33,14,9,101]),function(se,e,a,A,l,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const O="/bin/rg".replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(w,y,p,t){const o=S(w,y,p,t),r=y.folder.fsPath;return{cmd:a.spawn(O,o.args,{cwd:r}),rgDiskPath:O,siblingClauses:o.siblingClauses,rgArgs:o,cwd:r}}e.spawnRipgrepCmd=k;function S(w,y,p,t){const o=["--files","--hidden","--case-sensitive"];I([y],p,!1).forEach(c=>{const m=(0,D.anchorGlob)(c);if(o.push("-g",m),P.isMacintosh){const f=(0,l.normalizeNFD)(m);f!==m&&o.push("-g",f)}});const r=C([y],t,void 0,!1);return r.globArgs.forEach(c=>{const m=`!${(0,D.anchorGlob)(c)}`;if(o.push("-g",m),P.isMacintosh){const f=(0,l.normalizeNFD)(m);f!==m&&o.push("-g",f)}}),y.disregardIgnoreFiles!==!1?o.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),y.ignoreSymlinks||o.push("--follow"),w.exists&&o.push("--quiet"),o.push("--no-config"),y.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:r.siblingClauses}}function C(w,y,p,t=!0){const o=[];let r={};return w.forEach(c=>{const m=Object.assign({},c.excludePattern||{},y||{}),f=E(m,t?c.folder.fsPath:void 0,p);o.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:o,siblingClauses:r}}function I(w,y,p=!0){const t=[];return w.forEach(o=>{const r=Object.assign({},y||{},o.includePattern||{}),c=E(r,p?o.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function E(w,y,p){const t=[],o={};return Object.keys(w).forEach(r=>{if(p&&p.has(r)||!r)return;const c=w[r];r=d(y?n(y,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(h(r))):c&&c.when&&(o[r]=c)}),{globArgs:t,siblingClauses:o}}function n(w,y){return A.isAbsolute(y)?y:A.join(w,y)}e.getAbsoluteGlob=n;function d(w){return w=T.rtrim(w,"\\"),T.rtrim(w,"/")}function h(w){return R.getRoot(w).toLowerCase()==="c:/"?w.replace(/^c:[/\\]/i,"/"):w}e.fixDriveC=h}),define(Ie[315],Ce([1,0,47,71,15,316,17,46,39,87,33,14,37,9,10,29,31,314,112]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const w=new Set;process.on("exit",()=>{w.forEach(r=>r())});class y{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&D.parse(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,h.prepareQuery)(this.b).normalizedLowercase),this.u=c.excludePattern&&D.parse(c.excludePattern),this.t=new Map,c.folderQueries.forEach(m=>{const f=Object.assign({},m.excludePattern||{},this.a.excludePattern||{}),i=m.folder.fsPath;c.folderQueries.map(s=>s.folder.fsPath).filter(s=>s!==i).forEach(s=>{(0,O.isEqualOrParent)(s,i)&&(f[l.relative(i,s)]=!0)}),this.t.set(i,new t(f,i))})}cancel(){this.l=!0,w.forEach(c=>c())}walk(c,m,f,i,s){if(this.m=S.StopWatch.create(!1),this.l)return s(null,this.j);m.forEach(u=>{const b=l.basename(u.fsPath);this.u&&this.u(u.fsPath,b)||this.J(f,{relativePath:u.fsPath,searchPath:void 0})}),this.r=S.StopWatch.create(!1),this.w(c,(u,b)=>{this.x(this.y,this,u,f,i,g=>{if(g){const L=(0,T.toErrorMessage)(g);console.error(L),this.q.push(L),b(g,void 0)}else b(null,void 0)})},(u,b)=>{this.m.stop();const g=u?P.coalesce(u)[0]:null;s(g,this.j)})}w(c,m,f){const i=new Array(c.length),s=new Array(c.length);let u=!1,b=0;if(c.length===0)return f(null,[]);c.forEach((g,L)=>{m(g,(j,G)=>{if(j?(u=!0,i[L]=null,s[L]=j):(i[L]=G,s[L]=null),++b===c.length)return f(u?s:null,i)})})}x(c,m,...f){try{c.apply(m,f)}catch(i){f[f.length-1](i)}}y(c,m,f,i){const s=c.folder.fsPath,u=k.isMacintosh,b=()=>Q&&Q.kill();w.add(b);let g=M=>{w.delete(b),g=()=>{},i(M)},L="";const j=this.D(),G=(0,d.spawnRipgrepCmd)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),Q=G.cmd,B=!Object.keys(G.siblingClauses).length,U=G.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let z=`${G.rgDiskPath} ${U}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),f({message:z}),this.s=0,this.z(Q,"utf8",f,(M,x,fe)=>{if(M){g(M);return}if(this.j){g();return}const V=(L+(u?v.normalizeNFC(x||""):x)).split(`
`);if(fe){const _=V.length;V[_-1]=V[_-1].trim(),V[_-1]||V.pop()}else L=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){g(new Error("Splitting up files failed"));return}if(this.s+=V.length,B){for(const _ of V)if(this.J(m,{base:s,relativePath:_,searchPath:this.N(c,_)}),this.j){b();break}(fe||this.j)&&g();return}this.G(c,j,s,V,m),fe&&(this.H(j,s,m),g())})}spawnFindCmd(c){const m=this.t.get(c.folder.fsPath),f=m.getBasenameTerms(),i=m.getPathTerms(),s=["-L","."];if(f.length||i.length){s.push("-not","(","(");for(const u of f)s.push("-name",u),s.push("-o");for(const u of i)s.push("-path",u),s.push("-o");s.pop(),s.push(")","-prune",")")}return s.push("-type","f"),a.spawn("find",s,{cwd:c.folder.fsPath})}readStdout(c,m,f){let i="";this.z(c,m,()=>{},(s,u,b)=>{if(s){f(s);return}i+=u,b&&f(null,i)})}z(c,m,f,i){let s=(g,L,j)=>{(g||j)&&(s=()=>{},this.r?.stop()),i(g,L,j)},u=!1;c.stdout?(this.A(c.stdout,m,s),c.stdout.once("data",()=>u=!0)):f({message:"stdout is null"});let b;c.stderr?b=this.B(c.stderr):f({message:"stderr is null"}),c.on("error",g=>{s(g)}),c.on("close",g=>{let L;!u&&(L=this.C(b,m))&&o(L)?s(new Error(`command failed with error code ${g}: ${this.C(b,m)}`)):(this.g&&g===0&&(this.j=!0),s(null,"",!0))})}A(c,m,f){const i=new R.StringDecoder(m);return c.on("data",s=>{f(null,i.write(s))}),i}B(c){const m=[];return c.on("data",f=>{m.push(f)}),m}C(c,m){const f=new R.StringDecoder(m);return c.map(i=>f.write(i)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:m},f,i,s){i.indexOf(this.b)!==-1&&this.J(s,{base:f,relativePath:this.b,searchPath:this.N(c,this.b)});const u=b=>{const g=l.basename(b),L=l.dirname(b);let j=m[L];j||(j=m[L]=[],u(L)),j.push({base:f,relativePath:b,basename:g,searchPath:this.N(c,b)})};i.forEach(u)}H({rootEntries:c,pathToEntries:m},f,i){const s=this,u=this.t.get(f),b=this.b;function g(L){s.o++;const j=(0,n.hasSiblingFn)(()=>L.map(G=>G.basename));for(let G=0,Q=L.length;G<Q;G++){const B=L[G],{relativePath:U,basename:z}=B;if(u.test(U,z,b!==z?j:void 0))continue;const M=m[U];if(M)g(M);else{if(s.p++,U===b)continue;s.J(i,B)}if(s.j)break}}g(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,m,f,i,s){const u=c.folder,b=(0,n.hasSiblingFn)(()=>f);this.w(f,(g,L)=>{if(this.l||this.j)return L(null);const j=m?[m,g].join(l.sep):g;if(this.t.get(c.folder.fsPath).test(j,g,this.a.filePattern!==g?b:void 0))return L(null);const G=[u.fsPath,j].join(l.sep);A.lstat(G,(Q,B)=>{if(Q||this.l||this.j)return L(null);this.L(G,B,(U,z)=>U||this.l||this.j?L(null):z.isDirectory()?(this.o++,this.M(G,B,(M,x)=>M||this.l||this.j||(x=x||"",this.v[x])?L(null):(this.v[x]=!0,E.Promises.readdir(G).then(fe=>{if(this.l||this.j)return L(null);this.I(c,j,fe,i,re=>L(re||null))},fe=>{L(null)})))):(this.p++,j===this.b||this.h&&I.isNumber(z.size)&&z.size>this.h||this.J(i,{base:u.fsPath,relativePath:j,searchPath:this.N(c,j)}),L(null,void 0)))})},g=>{const L=g&&P.coalesce(g);return s(L&&L.length>0?L[0]:void 0)})}J(c,m){this.K(m)&&(!this.d||this.d(m.relativePath,l.basename(m.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(m))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,n.isFilePatternMatch)(c,this.c)}return!0}L(c,m,f){return m.isSymbolicLink()?A.stat(c,f):f(null,m)}M(c,m,f){return m.isSymbolicLink()?A.realpath(c,(i,s)=>i?f(i):f(null,s)):f(null,c)}N(c,m){return c.folderName?l.join(c.folderName,m):m}}e.FileWalker=y;class p{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new y(c)}search(c,m,f){this.c.walk(this.a,this.b,c,m,(i,s)=>{f(i,{limitHit:s,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class t{constructor(c,m){this.expression=c,this.c=m,this.d(c)}d(c){let m,f;Object.keys(c).filter(i=>c[i]).forEach(i=>{l.isAbsolute(i)?(m=m||D.getEmptyExpression(),m[i]=c[i]):(f=f||D.getEmptyExpression(),f[i]=c[i])}),this.a=m&&D.parse(m,{trimForExclusions:!0}),this.b=f&&D.parse(f,{trimForExclusions:!0})}test(c,m,f){return this.b&&this.b(c,m,f)||this.a&&this.a(l.join(this.c,c),m,f)}getBasenameTerms(){const c=[];return this.a&&c.push(...D.getBasenameTerms(this.a)),this.b&&c.push(...D.getBasenameTerms(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...D.getPathTerms(this.a)),this.b&&c.push(...D.getPathTerms(this.b)),c}}function o(r){const c=r.trim().split(`
`),m=c[0].trim();if(m.startsWith("Error parsing regex"))return m;if(m.startsWith("regex parse error"))return C.uppercaseFirstLetter(c[c.length-1].trim());if(m.startsWith("error parsing glob")||m.startsWith("unsupported encoding"))return m.charAt(0).toUpperCase()+m.substr(1);if(m==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(m.startsWith("Literal "))return m}}),define(Ie[317],Ce([1,0,104,22]),function(se,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,P=512,T=512*8,D=512*128;var v;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(v=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class O extends Error{constructor(c,m){super(c),this.decodeStreamErrorKind=m}}e.DecodeStreamError=O;class k{static async create(c){let m;if(c!==e.UTF8)m=(await new Promise((i,s)=>{se(["@vscode/iconv-lite-umd"],i,s)})).getDecoder(E(c));else{const f=new TextDecoder;m={write(i){return f.decode(i,{stream:!0})},end(){return f.decode()}}}return new k(m)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function S(r,c){const m=c.minBytesRequiredForDetection??c.guessEncoding?T:P;return new Promise((f,i)=>{const s=(0,a.newWriteableStream)(G=>G.join("")),u=[];let b=0,g;const L=async()=>{try{const G=await o({buffer:A.VSBuffer.concat(u),bytesRead:b},c.guessEncoding);if(G.seemsBinary&&c.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);G.encoding=await c.overwriteEncoding(G.encoding),g=await k.create(G.encoding);const Q=g.write(A.VSBuffer.concat(u).buffer);s.write(Q),u.length=0,b=0,f({stream:s,detected:G})}catch(G){j?.dispose(),s.destroy(),i(G)}},j=(0,a.listenStream)(r,{onData:async G=>{g?s.write(g.write(G.buffer)):(u.push(G),b+=G.byteLength,b>=m&&(r.pause(),await L(),setTimeout(()=>r.resume())))},onError:G=>s.error(G),onEnd:async()=>{g||await L(),s.end(g?.end())}})})}e.toDecodeStream=S;async function C(r,c,m){const i=(await new Promise((b,g)=>{se(["@vscode/iconv-lite-umd"],b,g)})).getEncoder(E(c),m);let s=!1,u=!1;return{read(){if(u)return null;const b=r.read();if(typeof b!="string"){if(u=!0,!s&&m?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const g=i.end();return g&&g.length>0?(s=!0,A.VSBuffer.wrap(g)):null}return s=!0,A.VSBuffer.wrap(i.write(b))}}}e.toEncodeReadable=C;async function I(r){return(await new Promise((m,f)=>{se(["@vscode/iconv-lite-umd"],m,f)})).encodingExists(E(r))}e.encodingExists=I;function E(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=E;function n(r,c){if(!r||c<e.UTF16be_BOM.length)return null;const m=r.readUInt8(0),f=r.readUInt8(1);if(m===e.UTF16be_BOM[0]&&f===e.UTF16be_BOM[1])return e.UTF16be;if(m===e.UTF16le_BOM[0]&&f===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return m===e.UTF8_BOM[0]&&f===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=n;const d=["ascii","utf-16","utf-32"];async function h(r){const c=await new Promise((u,b)=>{se(["jschardet"],u,b)}),m=r.slice(0,D),f=p(m.buffer),i=c.detect(f);if(!i||!i.encoding)return null;const s=i.encoding.toLowerCase();return 0<=d.indexOf(s)?null:y(i.encoding)}const w={ibm866:"cp866",big5:"cp950"};function y(r){const c=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[c]||c}function p(r){let c="";for(let m=0;m<r.length;m++)c+=String.fromCharCode(r[m]);return c}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=r.match(/windows(\d+)/);return c?"windows-"+c[1]:r}}}e.toCanonicalName=t;function o({buffer:r,bytesRead:c},m){let f=n(r,c),i=!1;if(f!==e.UTF16be&&f!==e.UTF16le&&r){let s=!0,u=!0,b=!1;for(let g=0;g<c&&g<R;g++){const L=g%2===1,j=r.readUInt8(g)===0;if(j&&(b=!0),s&&(L&&!j||!L&&j)&&(s=!1),u&&(L&&j||!L&&!j)&&(u=!1),j&&!s&&!u)break}b&&(s?f=e.UTF16le:u?f=e.UTF16be:i=!0)}return m&&!i&&!f&&r?h(r.slice(0,c)).then(s=>({seemsBinary:!1,encoding:s})):{seemsBinary:i,encoding:f}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[145],Ce([1,0,317,29,144]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(T,D,v=A,O="searchProcess"){super(T,D,{readdir:k=>v.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,a.toCanonicalName)(k)},O)}}e.NativeTextSearchManager=R}),define(Ie[318],Ce([1,0,293,327,328,2,329]),function(se,e,a,A,l,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(k,S,C,I,E,n){const d=n.environment.useHostProxy,h=typeof d=="boolean"?d:!n.remote.isRemote,w=(0,P.createProxyResolver)({resolveProxy:p=>k.resolveProxy(p),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(p,t,...o)=>{switch(p){case P.LogLevel.Trace:I.trace(t,...o);break;case P.LogLevel.Debug:I.debug(t,...o);break;case P.LogLevel.Info:I.info(t,...o);break;case P.LogLevel.Warning:I.warn(t,...o);break;case P.LogLevel.Error:I.error(t,...o);break;case P.LogLevel.Critical:I.error(t,...o);break;case P.LogLevel.Off:break;default:r(p,t,o);break}function r(c,m,...f){I.error("Unknown log level",c),I.error(m,...f)}},getLogLevel:()=>I.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:h,env:process.env}),y=D(S,w);return O(C,y)}e.connectProxyResolver=T;function D(k,S){const C={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(E=>{C.config=k.getConfiguration("http").get("proxySupport")||"off"});const I={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(E=>{I.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"off"},I,!0)),on:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"on"},I,!0)),override:Object.assign({},a,(0,P.createHttpPatch)(a,S,{config:"override"},I,!0)),onRequest:Object.assign({},a,(0,P.createHttpPatch)(a,S,C,I,!0)),default:Object.assign(a,(0,P.createHttpPatch)(a,S,C,I,!1))},https:{off:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"off"},I,!0)),on:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"on"},I,!0)),override:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"override"},I,!0)),onRequest:Object.assign({},A,(0,P.createHttpPatch)(A,S,C,I,!0)),default:Object.assign(A,(0,P.createHttpPatch)(A,S,C,I,!1))},tls:Object.assign(l,(0,P.createTlsPatch)(l))}}const v=new Map;function O(k,S){return k.getExtensionPathIndex().then(C=>{const I=globalThis._VSCODE_NODE_MODULES.module,E=I._load;I._load=function(d,h,w){if(d==="tls")return S.tls;if(d!=="http"&&d!=="https")return E.apply(this,arguments);const y=S[d],p=C.findSubstr(R.URI.file(h.filename));let t=v.get(p);if(t||v.set(p,t={}),!t[d]){const o=y.default;t[d]={...o}}return t[d]}})}}),define(Ie[319],Ce([1,0,84,312,307,318,43,295,2,18,7,292,116,294]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class I extends l.RequireInterceptor{j(){const d=this,h=globalThis._VSCODE_NODE_MODULES.module,w=h._load;h._load=function(o,r,c){return o=p(o),d.a.has(o)?d.a.get(o).load(o,D.URI.file((0,S.realpathSync)(r.filename)),m=>w.apply(this,[m,r,c])):w.apply(this,arguments)};const y=h._resolveLookupPaths;h._resolveLookupPaths=(t,o)=>y.call(this,p(t),o);const p=t=>{for(const o of d.b){const r=o(t);if(r){t=r;break}}return t}}}class E extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Node}async pb(){this.h.createInstance(C.ExtHostConsoleForwarder);const d=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const y=this.h.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=y.ipcHandlePath}await this.h.createInstance(I,d,{mine:this.F,all:this.G}).install(),a.mark("code/extHost/didInitAPI");const w=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,w,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}qb(d){return d.main}async rb(d,h,w){if(h.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${h}', must be of file-scheme`);let y=null;w.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${h.toString(!0)}`),this.l.flush();const p=d?.identifier.value;d&&await this.s.initializeLocalizedMessages(d);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),y=se.__$__nodeRequire(h.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),w.codeLoadingStop()}return y}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const h in d){const w=d[h];w===null?delete process.env[h]:process.env[h]=w}}}e.ExtHostExtensionService=E}),define(Ie[146],Ce([1,0,47,330,316,17,61,39,15,9,2,31,82,331,101]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n="/bin/rg".replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(g){this.a=g}provideTextSearchResults(g,L,j,G){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((Q,B)=>{G.onCancellationRequested(()=>_());const U=o(g,L),z=L.folder.fsPath,M=U.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${n} ${M}
 - cwd: ${z}`);let x=a.spawn(n,U,{cwd:z});x.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),B((0,k.serializeSearchError)(new k.SearchError(q&&q.message,k.SearchErrorCode.rgProcessError)))});let fe=!1;const re=new y(L.maxResults,z,L.previewOptions);re.on("result",q=>{fe=!0,ve="",j.report(q)});let V=!1;const _=()=>{V=!0,x?.kill(),re?.cancel()};let te=!1;re.on("hitLimit",()=>{te=!0,_()});let ve="";x.stdout.on("data",q=>{re.handleData(q),fe||(ve+=q)});let le=!1;x.stdout.once("data",()=>le=!0);let ue="";x.stderr.on("data",q=>{const F=q.toString();this.a.appendLine(F),ue.length+F.length<1e6&&(ue+=F)}),x.on("close",()=>{if(this.a.appendLine(le?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),ve&&this.a.appendLine(`Got data without result: ${ve}`),this.a.appendLine(""),V)Q({limitHit:te});else{re.flush(),x=null;let q;ue&&!le&&(q=h(ue))?B((0,k.serializeSearchError)(new k.SearchError(q.message,q.code))):Q({limitHit:te})}})})}}e.RipgrepTextSearchEngine=d;function h(b){const g=b.split(`
`),L=g[0].trim();if(g.some(G=>G.startsWith("regex parse error")))return new k.SearchError(w(g),k.SearchErrorCode.regexParseError);const j=L.match(/grep config error: unknown encoding: (.*)/);if(j)return new k.SearchError(`Unknown encoding: ${j[1]}`,k.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new k.SearchError(L.charAt(0).toUpperCase()+L.substr(1),k.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new k.SearchError(L.charAt(0).toUpperCase()+L.substr(1),k.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(L,k.SearchErrorCode.regexParseError)}function w(b){const g=["Regex parse error"],L=b.filter(j=>j.startsWith("PCRE2:"));if(L.length>=1){const j=L[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const G=j.split(":")[1];g.push(":"+G)}}return g.join("")}class y extends A.EventEmitter{constructor(g,L,j){super(),this.g=g,this.h=L,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,L){return super.on(g,L),this}handleData(g){if(this.b)return;const L=typeof g=="string"?g:this.d.write(g);this.k(L)}k(g){let L=g.indexOf(`
`);const j=this.a+g;if(L>=0)L+=this.a.length;else{this.a=j;return}let G=0;for(;L>=0;)this.m(j.substring(G,L).trim()),G=L+1,L=j.indexOf(`
`,G);this.a=j.substring(G)}m(g){if(this.b||!g)return;let L;try{L=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(L.type==="match"){const j=p(L.data.path),G=O.URI.file(D.join(this.h,j)),Q=this.n(L.data,G);this.p(Q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const j=p(L.data.path),G=O.URI.file(D.join(this.h,j));this.o(L.data,G).forEach(B=>this.p(B))}}n(g,L){const j=g.line_number-1,G=p(g.lines),Q=Buffer.from(G);let B=0,U=0,z=j;g.submatches.length===0&&g.submatches.push(G.length?{start:0,end:1,match:{text:G[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.coalesce)(g.submatches.map((x,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=p(x.match),V=Q.slice(B,x.start).toString(),_=t(V),te=_.numLines>0?_.lastLineLength:_.lastLineLength+U,ve=t(re),le=_.numLines+z,ue=ve.numLines+le,q=ve.numLines>0?ve.lastLineLength:ve.lastLineLength+te;return B=x.end,U=q,z=ue,new S.Range(le,te,ue,q)}));return(0,I.createTextSearchResult)(L,G,M,this.j)}o(g,L){const j=p(g.lines),G=g.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((Q,B)=>({text:Q,uri:L,lineNumber:G+B}))}p(g){this.emit("result",g)}}e.RipgrepParser=y;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const g=/\n/g;let L=0,j=-1,G;for(;G=g.exec(b);)L++,j=G.index;const Q=j>=0?b.length-j-1:b.length;return{numLines:L,lastLineLength:Q}}function o(b,g){const L=["--hidden"];L.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:G}=(0,P.groupBy)(g.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(G&&G.length){const B=new Set;G.forEach(U=>{B.add(U)}),L.push("-g","!*"),B.forEach(U=>{r(U).map(I.anchorGlob).forEach(z=>{L.push("-g",z)})})}j&&j.length&&j.forEach(B=>{L.push("-g",B)}),g.excludes.map(I.anchorGlob).forEach(B=>L.push("-g",`!${B}`)),g.maxFileSize&&L.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),g.followSymlinks&&L.push("--follow"),g.encoding&&g.encoding!=="utf8"&&L.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,v.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),g.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),b.isRegExp&&(b.pattern=c(b.pattern),L.push("--engine","auto"));let Q;if(b.isWordMatch){const U=(0,v.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",U)}else if(b.isRegExp){let B=f(b.pattern);B=i(B),L.push("--regexp",B)}else Q=b.pattern,L.push("--fixed-strings");return L.push("--no-config"),g.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),b.isMultiline&&L.push("--multiline"),g.beforeContext&&L.push("--before-context",g.beforeContext+""),g.afterContext&&L.push("--after-context",g.afterContext+""),L.push("--"),Q&&L.push(Q),L.push("."),L}e.getRgArgs=o;function r(b){return u(b).flatMap(L=>{const j=(0,T.splitGlobAware)(L,"/");return j.map((G,Q)=>j.slice(0,Q+1).join("/"))})}function c(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(L);)b=b.replace(L,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=c;const m=b=>b.type==="Assertion"&&b.kind==="lookbehind";function f(b){let g;try{g=new C.RegExpParser().parsePattern(b)}catch{return b}let L="",j=0;const G=(U,z,M)=>{L+=b.slice(j,U)+M,j=z},Q=[];return new C.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const z=Q[0];if(!z)G(U.start,U.end,"\\r?\\n");else if(!Q.some(m))if(z.type==="CharacterClass")if(z.negate){const M=b.slice(z.start+2,U.start)+b.slice(U.end,z.end-1);z.parent?.type==="Quantifier"?G(z.start,z.end,M?`[^${M}]`:"."):G(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=b.slice(z.start+1,U.start)+b.slice(U.end,z.end-1);G(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&G(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){Q.unshift(U)},onQuantifierLeave(){Q.shift()},onCharacterClassRangeEnter(U){Q.unshift(U)},onCharacterClassRangeLeave(){Q.shift()},onCharacterClassEnter(U){Q.unshift(U)},onCharacterClassLeave(){Q.shift()},onAssertionEnter(U){m(U)&&Q.push(U)},onAssertionLeave(U){Q[0]===U&&Q.shift()}}).visit(g),L+=b.slice(j),L}e.fixRegexNewline=f;function i(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function s(b){let g=!1,L=!1,j="",G="";for(let Q=0;Q<b.length;Q++){const B=b[Q];switch(B){case"\\":L?(g?G+="\\"+B:j+="\\"+B,L=!1):L=!0;break;case"{":if(L)g?G+=B:j+=B,L=!1;else{if(g)return{strInBraces:j+"{"+G+"{"+b.substring(Q+1)};g=!0}break;case"}":if(L)g?G+=B:j+=B,L=!1;else{if(g)return{fixedStart:j,strInBraces:G,fixedEnd:b.substring(Q+1)};j+=B}break;default:g?G+=(L?"\\":"")+B:j+=(L?"\\":"")+B,L=!1;break}}return{strInBraces:j+(g?"{"+G:"")}}function u(b){const{fixedStart:g,strInBraces:L,fixedEnd:j}=s(b);if(g===void 0||j===void 0)return[L];let G=(0,T.splitGlobAware)(L,",");G.length||(G=[""]);const Q=u(j);return G.flatMap(B=>{const U=g+B;return Q.map(z=>U+z)})}e.performBraceExpansionForRipgrep=u}),define(Ie[320],Ce([1,0,21,146,126,18]),function(se,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(v){this.b=v,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(v,O,k,S){const C=new A.RipgrepTextSearchEngine(this.b);if(O.folder.scheme===R.Schemas.vscodeUserData){const I={...O,folder:O.folder.with({scheme:R.Schemas.file})},E=new l.Progress(n=>k.report({...n,uri:n.uri.with({scheme:O.folder.scheme})}));return this.c(S,n=>C.provideTextSearchResults(v,I,E,n))}else return this.c(S,I=>C.provideTextSearchResults(v,O,k,I))}async c(v,O){const k=T(v);this.a.add(k);const S=await O(k.token);return this.a.delete(k),S}d(){this.a.forEach(v=>v.cancel())}}e.RipgrepSearchProvider=P;function T(D){const v=new a.CancellationTokenSource;return D.onCancellationRequested(()=>v.cancel()),v}}),define(Ie[321],Ce([1,0,29,146,145]),function(se,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(D){this.a=D}search(D,v,O){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(C){O({message:C})}},S=new l.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(k),a);return new Promise((C,I)=>S.search(E=>{v(E.map(P))},D).then(E=>C({limitHit:E.limitHit,type:"success",stats:E.stats}),I))}}e.TextSearchEngineAdapter=R;function P(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((D,v)=>{if(v.ranges){const O=v;return D+(Array.isArray(O.ranges)?O.ranges.length:1)}else return D+1},0)}}}),define(Ie[322],Ce([1,0,17,19,8,3,112,15,37,2,45,31,315,321]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class I{constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let p;const t=d(y),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.doFileSearchWithEngine(S.Engine,t,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(y){let p;const t=d(y),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.f(t,c=>o.fire(c),r)),p.then(r=>o.fire(r),r=>o.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}f(y,p,t){return y.maxFileSize=(0,O.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(y).search(t,p,p)}doFileSearch(y,p,t){return this.doFileSearchWithEngine(S.Engine,y,p,t)}doFileSearchWithEngine(y,p,t,o,r=I.a){let c=0;const m=i=>{Array.isArray(i)?(c+=i.length,t(i.map(s=>this.g(s)))):i.relativePath?(c++,t(this.g(i))):t(i)};if(p.sortByScore){let i=this.k(p,m,o);if(!i){const s=p.maxResults?Object.assign({},p,{maxResults:null}):p,u=new y(s);i=this.h(u,p,t,m,o)}return new Promise((s,u)=>{i.then(([b,g])=>{const L=g.map(j=>this.g(j));this.n(L,t,r),s(b)},u)})}const f=new y(p);return this.q(f,m,r,o).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}g(y){return{path:y.base?(0,T.join)(y.base,y.relativePath):y.relativePath}}h(y,p,t,o,r){const c=new R.Emitter;let m=(0,A.createCancelablePromise)(i=>{let s=[];const u=b=>{Array.isArray(b)?s=b:(o(b),c.fire(b))};return this.q(y,u,-1,i).then(b=>[b,s])}),f;if(p.cacheKey){f=this.j(p.cacheKey);const i={promise:m,event:c.event,resolved:!1};f.resultsToSearchCache[p.filePattern||""]=i,m.then(()=>{i.resolved=!0},s=>{delete f.resultsToSearchCache[p.filePattern||""]}),m=this.r(m)}return m.then(([i,s])=>{const u=f?f.scorerCache:Object.create(null),b=(typeof p.maxResults!="number"||p.maxResults>0)&&D.StopWatch.create(!1);return this.l(p,s,u,r).then(g=>{const L=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:g.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&s.length>p.maxResults},g]})})}j(y){const p=this.b[y];return p||(this.b[y]=new E)}k(y,p,t){const o=y.cacheKey&&this.b[y.cacheKey];if(!o)return;const r=this.o(o,y.filePattern||"",p,t);if(r)return r.then(([c,m,f])=>{const i=D.StopWatch.create(!1);return this.l(y,m,o.scorerCache,t).then(s=>{const u=i.elapsed(),b={fromCache:!0,detailStats:f,type:this.d,resultCount:m.length,sortingTime:u};return[{type:"success",limitHit:c.limitHit||typeof y.maxResults=="number"&&m.length>y.maxResults,stats:b},s]})})}l(y,p,t,o){const r=(0,P.prepareQuery)(y.filePattern||""),c=(f,i)=>(0,P.compareItemsByFuzzyScore)(f,i,r,!0,n,t),m=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return a.topAsync(p,c,m,1e4,o)}n(y,p,t){if(t&&t>0)for(let o=0;o<y.length;o+=t)p(y.slice(o,o+t));else p(y)}o(y,p,t,o){const r=D.StopWatch.create(!1),c=p.indexOf(T.sep)>=0;let m;for(const u in y.resultsToSearchCache)if(p.startsWith(u)){if(c&&u.indexOf(T.sep)<0&&u!=="")continue;const b=y.resultsToSearchCache[u];m={promise:this.r(b.promise),event:b.event,resolved:b.resolved};break}if(!m)return null;const f=r.elapsed(),i=D.StopWatch.create(!1),s=m.event(t);return o&&o.onCancellationRequested(()=>{s.dispose()}),m.promise.then(([u,b])=>{if(o&&o.isCancellationRequested)throw(0,l.canceled)();const g=[],L=(0,P.prepareQuery)(p).normalizedLowercase;for(const j of b)!(0,k.isFilePatternMatch)(j,L)||g.push(j);return[u,g,{cacheWasResolved:m.resolved,cacheLookupTime:f,cacheFilterTime:i.elapsed(),cacheEntryCount:b.length}]})}q(y,p,t,o){return new Promise((r,c)=>{let m=[];o?.onCancellationRequested(()=>y.cancel()),y.search(f=>{f&&(t?(m.push(f),t>0&&m.length>=t&&(p(m),m=[])):p(f))},f=>{p(f)},(f,i)=>{m.length&&p(m),f?c(f):r(i)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}r(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return y.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return y.finally(p)}}}}I.a=512,e.SearchService=I;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(w){return(0,T.basename)(w.relativePath)}getItemDescription(w){return(0,T.dirname)(w.relativePath)}getItemPath(w){return w.relativePath}};function d(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(h),extraFileResources:w.extraFileResources&&w.extraFileResources.map(y=>v.URI.revive(y))}}function h(w){return{...w,folder:v.URI.revive(w.folder)}}}),define(Ie[323],Ce([1,0,6,18,2,29,16,26,20,86,56,31,322,320,101,145]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=class extends v.ExtHostSearch{constructor(h,w,y,p){super(h,y,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const t=new I.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new C.RipgrepSearchProvider(t)),w.remote.isRemote&&w.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const h=new I.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new C.RipgrepSearchProvider(h)),this.y(A.Schemas.file,new S.SearchService("fileSearchProvider"))}y(h,w){const y=this.d++;return this.v=w,this.t=y,this.c.$registerFileSearchProvider(y,this.o(h)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(h,w,y,p){const t=(0,v.reviveQuery)(y);return h===this.t?this.z(h,w,t,p):super.$provideFileSearchResults(h,w,y,p)}z(h,w,y,p){const t=o=>{if((0,k.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(h,w,o.map(r=>l.URI.file(r.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,t,p)}$clearCache(h){return this.v?.clearCache(h),super.$clearCache(h)}q(h,w){return new E.NativeTextSearchManager(h,w,void 0,"textSearchProvider")}};n=Ve([$e(0,D.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,O.IURITransformerService),$e(3,P.ILogService)],n),e.NativeExtHostSearch=n}),define(Ie[324],Ce([1,0,91,298,310,309,323,319,299,85,43,86,83,42,55,80,297,296,16,311,50,225,90]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d,h,w,y,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(O.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(h.ILoggerService,d.ExtHostLoggerService,1),(0,a.registerSingleton)(h.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,a.registerSingleton)(E.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,a.registerSingleton)(v.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(k.IExtHostSearch,P.NativeExtHostSearch,0),(0,a.registerSingleton)(S.IExtHostTask,l.ExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,a.registerSingleton)(I.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,a.registerSingleton)(y.IExtHostVariableResolverProvider,w.NodeExtHostVariableResolverProviderService,0)}),define(Ie[332],Ce([1,0,235,333,84,8,119,120,213,97,308,22,29,116,19,122,230,243,313,324]),function(se,e,a,A,l,R,P,T,D,v,O,k,S,C,I,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const h=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const m=globalThis._VSCODE_NODE_MODULES.module,f=m._load;m._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const w=process.exit.bind(process);function y(m){process.exit=function(f){if(m)w(f);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(m){w()};function t(){const m=(0,d.readExtHostConnection)(process.env);if(m.type===3)return new Promise((f,i)=>{const s=u=>{const b=u[0],g=new P.BufferedEmitter;b.on("message",L=>g.fire(k.VSBuffer.wrap(L.data))),b.on("close",()=>{p("renderer closed the MessagePort")}),b.start(),f({onMessage:g.event,send:L=>b.postMessage(L.buffer)})};process.parentPort.on("message",u=>s(u.ports))});if(m.type===2)return new Promise((f,i)=>{let s=null;const u=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,g=3e5,L=new I.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),b),j=new I.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),g);process.on("message",(Q,B)=>{if(Q&&Q.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const U=k.VSBuffer.wrap(Buffer.from(Q.initialDataChunk,"base64"));let z;if(Q.skipWebSocketFrames)z=new T.NodeSocket(B,"extHost-socket");else{const M=k.VSBuffer.wrap(Buffer.from(Q.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(B,"extHost-socket"),Q.permessageDeflate,M,!1)}s?(L.cancel(),j.cancel(),s.beginAcceptReconnection(z,U),s.endAcceptReconnection(),s.sendResume()):(clearTimeout(u),s=new P.PersistentProtocol({socket:z,initialChunk:U}),s.sendResume(),s.onDidDispose(()=>p("renderer disconnected")),f(s),s.onSocketClose(()=>{L.schedule()}))}if(Q&&Q.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;L.isScheduled()&&j.schedule()}});const G={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(G)});{const f=m.pipeName;return new Promise((i,s)=>{const u=a.createConnection(f,()=>{u.removeListener("error",s);const b=new P.PersistentProtocol({socket:new T.NodeSocket(u,"extHost-renderer")});b.sendResume(),i(b)});u.once("error",s),u.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const m=await t();return new class{constructor(){this.a=new P.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,m.onMessage(f=>{(0,v.isMessageOfType)(f,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||m.send(f)}async drain(){if(m.drain)return m.drain()}}}function r(m){return new Promise(f=>{const i=m.onMessage(s=>{i.dispose();const u=JSON.parse(s.toString()),b=u.commit,g=D.default.commit;if(b&&g&&b!==g&&w(55),u.parentPid){let L=0;setInterval(function(){try{process.kill(u.parentPid,0),L=0}catch(G){G&&G.code==="EPERM"?(L++,L>=3&&p(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${G.message} (code: ${G.code}) (errno: ${G.errno})`)):p(`parent process ${u.parentPid} does not exist anymore: ${G.message} (code: ${G.code}) (errno: ${G.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(u.parentPid)}catch(G){(0,R.onUnexpectedError)(G)}}m.send((0,v.createMessageOfType)(0)),f({protocol:m,initData:u})});m.send((0,v.createMessageOfType)(1))})}async function c(){const m=[];process.on("unhandledRejection",(L,j)=>{m.push(j),setTimeout(()=>{const G=m.indexOf(j);G>=0&&j.catch(Q=>{m.splice(G,1),(0,R.isCancellationError)(Q)||(console.warn(`rejected promise not handled within 1 second: ${Q}`),Q&&Q.stack&&console.warn(`stack trace: ${Q.stack}`),L&&(0,R.onUnexpectedError)(L))})},1e3)}),process.on("rejectionHandled",L=>{const j=m.indexOf(L);j>=0&&m.splice(j,1)}),process.on("uncaughtException",function(L){(0,R.isSigPipeError)(L)||(0,R.onUnexpectedError)(L)}),l.mark("code/extHost/willConnectToRenderer");const f=await o();l.mark("code/extHost/didConnectToRenderer");const i=await r(f);l.mark("code/extHost/didWaitForInitData");const{initData:s}=i;y(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=h.useHostProxy!==void 0?h.useHostProxy!=="false":void 0,s.environment.skipWorkspaceStorageLock=(0,E.boolean)(h.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(j){w(j)}exists(j){return S.Promises.exists(j)}realpath(j){return(0,C.realpath)(j)}};let b=null;s.remote.authority&&h.transformURIs&&(b=(0,n.createURITransformer)(s.remote.authority));const g=new O.ExtensionHostMain(i.protocol,s,u,b);p=L=>g.terminate(L)}c().catch(m=>console.log(m))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/node/extensionHostProcess.js.map
