/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ee){for(var e=[],n=0,P=ee.length;n<P;n++)e[n]=Ae[ee[n]];return e};define(Ae[64],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(R,A){const I=Object.create(null);for(const m of R){const O=A(m);let y=I[O];y||(y=I[O]=[]),y.push(m)}return I}e.groupBy=n;function P(R,A){const I=[],m=[];for(const O of R)A.has(O)||I.push(O);for(const O of A)R.has(O)||m.push(O);return{removed:I,added:m}}e.diffSets=P;function k(R,A){const I=[],m=[];for(const[O,y]of R)A.has(O)||I.push(y);for(const[O,y]of A)R.has(O)||m.push(y);return{removed:I,added:m}}e.diffMaps=k;class M{constructor(){this.a=new Map}add(A,I){let m=this.a.get(A);m||(m=new Set,this.a.set(A,m)),m.add(I)}delete(A,I){const m=this.a.get(A);!m||(m.delete(I),m.size===0&&this.a.delete(A))}forEach(A,I){const m=this.a.get(A);!m||m.forEach(I)}}e.SetMap=M}),define(Ae[65],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(R){return(A,I,m)=>{let O=null,y=null;if(typeof m.value=="function"?(O="value",y=m.value):typeof m.get=="function"&&(O="get",y=m.get),!y)throw new Error("not supported");m[O]=R(y,I)}}function P(R,A,I){let m=null,O=null;if(typeof I.value=="function"?(m="value",O=I.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(m="get",O=I.get),!O)throw new Error("not supported");const y=`$memoize$${A}`;I[m]=function(...h){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,h)}),this[y]}}e.memoize=P;function k(R,A,I){return n((m,O)=>{const y=`$debounce$${O}`,h=`$debounce$result$${O}`;return function(...E){this[h]||(this[h]=I?I():void 0),clearTimeout(this[y]),A&&(this[h]=A(this[h],...E),E=[this[h]]),this[y]=setTimeout(()=>{m.apply(this,E),this[h]=I?I():void 0},R)}})}e.debounce=k;function M(R,A,I){return n((m,O)=>{const y=`$throttle$timer$${O}`,h=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...l){if(this[h]||(this[h]=I?I():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...l)),this[g])return;const t=this[E]+R;t<=Date.now()?(this[E]=Date.now(),m.apply(this,[this[h]]),this[h]=I?I():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[E]=Date.now(),m.apply(this,[this[h]]),this[h]=I?I():void 0},t-Date.now()))}})}e.throttle=M}),define(Ae[84],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ae[113],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function R(i,u=!1){let s=0;const o=i.length;let f="",b=0,r=16,c=0;function v(U){let B=0,$=0;for(;B<U;){const W=i.charCodeAt(s);if(W>=48&&W<=57)$=$*16+W-48;else if(W>=65&&W<=70)$=$*16+W-65+10;else if(W>=97&&W<=102)$=$*16+W-97+10;else break;s++,B++}return B<U&&($=-1),$}function D(U){s=U,f="",b=0,r=16,c=0}function w(){const U=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&m(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&m(i.charCodeAt(s)))for(s++;s<i.length&&m(i.charCodeAt(s));)s++;else return c=3,i.substring(U,s);let B=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&m(i.charCodeAt(s))){for(s++;s<i.length&&m(i.charCodeAt(s));)s++;B=s}else c=3;return i.substring(U,B)}function H(){let U="",B=s;for(;;){if(s>=o){U+=i.substring(B,s),c=2;break}const $=i.charCodeAt(s);if($===34){U+=i.substring(B,s),s++;break}if($===92){if(U+=i.substring(B,s),s++,s>=o){c=2;break}switch(i.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const x=v(4);x>=0?U+=String.fromCharCode(x):c=4;break}default:c=5}B=s;continue}if($>=0&&$<=31)if(I($)){U+=i.substring(B,s),c=2;break}else c=6;s++}return U}function X(){if(f="",c=0,b=s,s>=o)return b=o,r=17;let U=i.charCodeAt(s);if(A(U)){do s++,f+=String.fromCharCode(U),U=i.charCodeAt(s);while(A(U));return r=15}if(I(U))return s++,f+=String.fromCharCode(U),U===13&&i.charCodeAt(s)===10&&(s++,f+=`
`),r=14;switch(U){case 123:return s++,r=1;case 125:return s++,r=2;case 91:return s++,r=3;case 93:return s++,r=4;case 58:return s++,r=6;case 44:return s++,r=5;case 34:return s++,f=H(),r=10;case 47:{const B=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<o&&!I(i.charCodeAt(s));)s++;return f=i.substring(B,s),r=12}if(i.charCodeAt(s+1)===42){s+=2;const $=o-1;let W=!1;for(;s<$;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,W=!0;break}s++}return W||(s++,c=1),f=i.substring(B,s),r=13}return f+=String.fromCharCode(U),s++,r=16}case 45:if(f+=String.fromCharCode(U),s++,s===o||!m(i.charCodeAt(s)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=w(),r=11;default:for(;s<o&&J(U);)s++,U=i.charCodeAt(s);if(b!==s){switch(f=i.substring(b,s),f){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return f+=String.fromCharCode(U),s++,r=16}}function J(U){if(A(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let U;do U=X();while(U>=12&&U<=15);return U}return{setPosition:D,getPosition:()=>s,scan:u?G:X,getToken:()=>r,getTokenValue:()=>f,getTokenOffset:()=>b,getTokenLength:()=>s-b,getTokenError:()=>c}}e.createScanner=R;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function y(i,u){const s=[],o=new Object;let f;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function c(v,D,w,H){b.value=v,b.offset=D,b.length=w,b.type=H,b.colonOffset=void 0,f=b}try{S(i,{onObjectBegin:(v,D)=>{if(u<=v)throw o;f=void 0,r=u>v,s.push("")},onObjectProperty:(v,D,w)=>{if(u<D||(c(v,D,w,"property"),s[s.length-1]=v,u<=D+w))throw o},onObjectEnd:(v,D)=>{if(u<=v)throw o;f=void 0,s.pop()},onArrayBegin:(v,D)=>{if(u<=v)throw o;f=void 0,s.push(0)},onArrayEnd:(v,D)=>{if(u<=v)throw o;f=void 0,s.pop()},onLiteralValue:(v,D,w)=>{if(u<D||(c(v,D,w,p(v)),u<=D+w))throw o},onSeparator:(v,D,w)=>{if(u<=D)throw o;if(v===":"&&f&&f.type==="property")f.colonOffset=D,r=!1,f=void 0;else if(v===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(r=!0,s[s.length-1]=""),f=void 0}}})}catch(v){if(v!==o)throw v}return{path:s,previousNode:f,isAtPropertyKey:r,matches:v=>{let D=0;for(let w=0;D<v.length&&w<s.length;w++)if(v[D]===s[w]||v[D]==="*")D++;else if(v[D]!=="**")return!1;return D===v.length}}}e.getLocation=y;function h(i,u=[],s=M.DEFAULT){let o=null,f=[];const b=[];function r(v){Array.isArray(f)?f.push(v):o!==null&&(f[o]=v)}return S(i,{onObjectBegin:()=>{const v={};r(v),b.push(f),f=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{f=b.pop()},onArrayBegin:()=>{const v=[];r(v),b.push(f),f=v,o=null},onArrayEnd:()=>{f=b.pop()},onLiteralValue:r,onError:(v,D,w)=>{u.push({error:v,offset:D,length:w})}},s),f[0]}e.parse=h;function E(i,u=[],s=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(v){o.type==="property"&&(o.length=v-o.offset,o=o.parent)}function b(v){return o.children.push(v),v}S(i,{onObjectBegin:v=>{o=b({type:"object",offset:v,length:-1,parent:o,children:[]})},onObjectProperty:(v,D,w)=>{o=b({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:v,offset:D,length:w,parent:o})},onObjectEnd:(v,D)=>{o.length=v+D-o.offset,o=o.parent,f(v+D)},onArrayBegin:(v,D)=>{o=b({type:"array",offset:v,length:-1,parent:o,children:[]})},onArrayEnd:(v,D)=>{o.length=v+D-o.offset,o=o.parent,f(v+D)},onLiteralValue:(v,D,w)=>{b({type:p(v),offset:D,length:w,parent:o,value:v}),f(D+w)},onSeparator:(v,D,w)=>{o.type==="property"&&(v===":"?o.colonOffset=D:v===","&&f(D))},onError:(v,D,w)=>{u.push({error:v,offset:D,length:w})}},s);const c=o.children[0];return c&&delete c.parent,c}e.parseTree=E;function g(i,u){if(!i)return;let s=i;for(const o of u)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let f=!1;for(const b of s.children)if(Array.isArray(b.children)&&b.children[0].value===o){s=b.children[1],f=!0;break}if(!f)return}else{const f=o;if(s.type!=="array"||f<0||!Array.isArray(s.children)||f>=s.children.length)return;s=s.children[f]}return s}e.findNodeAtLocation=g;function l(i){if(!i.parent||!i.parent.children)return[];const u=l(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;u.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&u.push(s)}return u}e.getNodePath=l;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const u=Object.create(null);for(const s of i.children){const o=s.children[1];o&&(u[s.children[0].value]=t(o))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,u,s=!1){return u>=i.offset&&u<i.offset+i.length||s&&u===i.offset+i.length}e.contains=a;function d(i,u,s=!1){if(a(i,u,s)){const o=i.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=u;f++){const b=d(o[f],u,s);if(b)return b}return i}}e.findNodeAtOffset=d;function S(i,u,s=M.DEFAULT){const o=R(i,!1);function f(Te){return Te?()=>Te(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(Te){return Te?de=>Te(de,o.getTokenOffset(),o.getTokenLength()):()=>!0}const r=f(u.onObjectBegin),c=b(u.onObjectProperty),v=f(u.onObjectEnd),D=f(u.onArrayBegin),w=f(u.onArrayEnd),H=b(u.onLiteralValue),X=b(u.onSeparator),J=f(u.onComment),G=b(u.onError),U=s&&s.disallowComments,B=s&&s.allowTrailingComma;function $(){for(;;){const Te=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Te){case 12:case 13:U?W(10):J();break;case 16:W(1);break;case 15:case 14:break;default:return Te}}}function W(Te,de=[],ae=[]){if(G(Te),de.length+ae.length>0){let j=o.getToken();for(;j!==17;){if(de.indexOf(j)!==-1){$();break}else if(ae.indexOf(j)!==-1)break;j=$()}}}function x(Te){const de=o.getTokenValue();return Te?H(de):c(de),$(),!0}function fe(){switch(o.getToken()){case 11:{let Te=0;try{Te=JSON.parse(o.getTokenValue()),typeof Te!="number"&&(W(2),Te=0)}catch{W(2)}H(Te);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return $(),!0}function Se(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),o.getToken()===6?(X(":"),$(),ce()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ie(){r(),$();let Te=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Te||W(4,[],[]),X(","),$(),o.getToken()===2&&B)break}else Te&&W(6,[],[]);Se()||W(4,[],[2,5]),Te=!0}return v(),o.getToken()!==2?W(7,[2],[]):$(),!0}function ue(){D(),$();let Te=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Te||W(4,[],[]),X(","),$(),o.getToken()===4&&B)break}else Te&&W(6,[],[]);ce()||W(4,[],[4,5]),Te=!0}return w(),o.getToken()!==4?W(8,[4],[]):$(),!0}function ce(){switch(o.getToken()){case 3:return ue();case 1:return ie();case 10:return x(!0);default:return fe()}}return $(),o.getToken()===17?s.allowEmptyContent?!0:(W(4,[],[]),!1):ce()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=S;function T(i,u){const s=R(i),o=[];let f,b=0,r;do switch(r=s.getPosition(),f=s.scan(),f){case 12:case 13:case 17:b!==r&&o.push(i.substring(b,r)),u!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,u)),b=s.getPosition();break}while(f!==17);return o.join("")}e.stripComments=T;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ae[28],Re([1,0]),function(ee,e){"use strict";var n,P,k;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(l,t,a){let d=l.get(t);return d===void 0&&(d=a,l.set(t,d)),d}e.getOrSet=M;function R(l){const t=[];return l.forEach((a,d)=>{t.push(`${d} => ${a}`)}),`Map(${l.size}) {${t.join(", ")}}`}e.mapToString=R;function A(l){const t=[];return l.forEach(a=>{t.push(a)}),`Set(${l.size}) {${t.join(", ")}}`}e.setToString=A;class I{constructor(t,a){this.uri=t,this.value=a}}class m{constructor(t,a){this[n]="ResourceMap",t instanceof m?(this.b=new Map(t.b),this.c=a??m.a):(this.b=new Map,this.c=t??m.a)}set(t,a){return this.b.set(this.c(t),new I(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[d,S]of this.b)t(S.value,S.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}m.a=l=>l.toString(),e.ResourceMap=m;class O{constructor(t,a){this[P]="ResourceSet",!t||typeof t=="function"?this.a=new m(t):(this.a=new m(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((d,S)=>t.call(a,S,S,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var y;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class h{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const d=this.a.get(t);if(!!d)return a!==0&&this.j(d,a),d.value}set(t,a,d=0){let S=this.a.get(t);if(S)S.value=a,d!==0&&this.j(S,d);else{switch(S={key:t,value:a,next:void 0,previous:void 0},d){case 0:this.h(S);break;case 1:this.g(S);break;case 2:this.h(S);break;default:this.h(S);break}this.a.set(t,S),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const d=this.e;let S=this.b;for(;S;){if(a?t.bind(a)(S.value,S.key,this):t(S.value,S.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const t=this,a=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:d.key,done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return S}values(){const t=this,a=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:d.value,done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return S}entries(){const t=this,a=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:[d.key,d.value],done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return S}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,d=this.size;for(;a&&d>t;)this.a.delete(a.key),a=a.next,d--;this.b=a,this.d=d,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,d=t.previous;if(!a||!d)throw new Error("Invalid list");a.previous=d,d.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const d=t.next,S=t.previous;t===this.c?(S.next=void 0,this.c=S):(d.previous=S,S.next=d),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const d=t.next,S=t.previous;t===this.b?(d.previous=void 0,this.b=d):(d.previous=S,S.next=d),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,d)=>{t.push([d,a])}),t}fromJSON(t){this.clear();for(const[a,d]of t)this.set(a,d)}}e.LinkedMap=h;class E extends h{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=E;class g{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let a=this.a.get(t)||0;return a===0?!1:(a--,a===0?this.a.delete(t):this.a.set(t,a),!0)}has(t){return this.a.has(t)}}e.CounterSet=g}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ae[114],Re([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Ee,ve){for(var Ce=0;Ce<ve.length;Ce++){var se=ve[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ee,se.key,se)}}function n(Ee,ve,Ce){return ve&&e(Ee.prototype,ve),Ce&&e(Ee,Ce),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function P(Ee,ve){if(!!Ee){if(typeof Ee=="string")return k(Ee,ve);var Ce=Object.prototype.toString.call(Ee).slice(8,-1);if(Ce==="Object"&&Ee.constructor&&(Ce=Ee.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ee);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return k(Ee,ve)}}function k(Ee,ve){(ve==null||ve>Ee.length)&&(ve=Ee.length);for(var Ce=0,se=new Array(ve);Ce<ve;Ce++)se[Ce]=Ee[Ce];return se}function M(Ee,ve){var Ce=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(Ce)return(Ce=Ce.call(Ee)).next.bind(Ce);if(Array.isArray(Ee)||(Ce=P(Ee))||ve&&Ee&&typeof Ee.length=="number"){Ce&&(Ee=Ce);var se=0;return function(){return se>=Ee.length?{done:!0}:{done:!1,value:Ee[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=R();function A(Ee){ee.defaults=Ee}var I=/[&<>"']/,m=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ve){return h[ve]};function g(Ee,ve){if(ve){if(I.test(Ee))return Ee.replace(m,E)}else if(O.test(Ee))return Ee.replace(y,E);return Ee}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Ee){return Ee.replace(l,function(ve,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function d(Ee,ve){Ee=typeof Ee=="string"?Ee:Ee.source,ve=ve||"";var Ce={replace:function(oe,Z){return Z=Z.source||Z,Z=Z.replace(a,"$1"),Ee=Ee.replace(oe,Z),Ce},getRegex:function(){return new RegExp(Ee,ve)}};return Ce}var S=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Ee,ve,Ce){if(Ee){var se;try{se=decodeURIComponent(t(Ce)).replace(S,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!T.test(Ce)&&(Ce=f(ve,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var i={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Ee,ve){i[" "+Ee]||(u.test(Ee)?i[" "+Ee]=Ee+"/":i[" "+Ee]=v(Ee,"/",!0)),Ee=i[" "+Ee];var Ce=Ee.indexOf(":")===-1;return ve.substring(0,2)==="//"?Ce?ve:Ee.replace(s,"$1")+ve:ve.charAt(0)==="/"?Ce?ve:Ee.replace(o,"$1")+ve:Ee+ve}var b={exec:function(){}};function r(Ee){for(var ve=1,Ce,se;ve<arguments.length;ve++){Ce=arguments[ve];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(Ee[se]=Ce[se])}return Ee}function c(Ee,ve){var Ce=Ee.replace(/\|/g,function(Z,C,N){for(var V=!1,q=C;--q>=0&&N[q]==="\\";)V=!V;return V?"|":" |"}),se=Ce.split(/ \|/),oe=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;oe<se.length;oe++)se[oe]=se[oe].trim().replace(/\\\|/g,"|");return se}function v(Ee,ve,Ce){var se=Ee.length;if(se===0)return"";for(var oe=0;oe<se;){var Z=Ee.charAt(se-oe-1);if(Z===ve&&!Ce)oe++;else if(Z!==ve&&Ce)oe++;else break}return Ee.slice(0,se-oe)}function D(Ee,ve){if(Ee.indexOf(ve[1])===-1)return-1;for(var Ce=Ee.length,se=0,oe=0;oe<Ce;oe++)if(Ee[oe]==="\\")oe++;else if(Ee[oe]===ve[0])se++;else if(Ee[oe]===ve[1]&&(se--,se<0))return oe;return-1}function w(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function H(Ee,ve){if(ve<1)return"";for(var Ce="";ve>1;)ve&1&&(Ce+=Ee),ve>>=1,Ee+=Ee;return Ce+Ee}function X(Ee,ve,Ce,se){var oe=ve.href,Z=ve.title?g(ve.title):null,C=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){se.state.inLink=!0;var N={type:"link",raw:Ce,href:oe,title:Z,text:C,tokens:se.inlineTokens(C)};return se.state.inLink=!1,N}return{type:"image",raw:Ce,href:oe,title:Z,text:g(C)}}function J(Ee,ve){var Ce=Ee.match(/^(\s+)(?:```)/);if(Ce===null)return ve;var se=Ce[1];return ve.split(`
`).map(function(oe){var Z=oe.match(/^\s+/);if(Z===null)return oe;var C=Z[0];return C.length>=se.length?oe.slice(se.length):oe}).join(`
`)}var G=function(){function Ee(Ce){this.options=Ce||ee.defaults}var ve=Ee.prototype;return ve.space=function(se){var oe=this.rules.block.newline.exec(se);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ve.code=function(se){var oe=this.rules.block.code.exec(se);if(oe){var Z=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},ve.fences=function(se){var oe=this.rules.block.fences.exec(se);if(oe){var Z=oe[0],C=J(Z,oe[3]||"");return{type:"code",raw:Z,lang:oe[2]?oe[2].trim():oe[2],text:C}}},ve.heading=function(se){var oe=this.rules.block.heading.exec(se);if(oe){var Z=oe[2].trim();if(/#$/.test(Z)){var C=v(Z,"#");(this.options.pedantic||!C||/ $/.test(C))&&(Z=C.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ve.hr=function(se){var oe=this.rules.block.hr.exec(se);if(oe)return{type:"hr",raw:oe[0]}},ve.blockquote=function(se){var oe=this.rules.block.blockquote.exec(se);if(oe){var Z=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ve.list=function(se){var oe=this.rules.block.list.exec(se);if(oe){var Z,C,N,V,q,te,ge,Pe,le,De,we,We,$e=oe[1].trim(),tt=$e.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+$e.slice(0,-1):"",loose:!1,items:[]};$e=tt?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=tt?$e:"[*+-]");for(var it=new RegExp("^( {0,3}"+$e+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(oe=it.exec(se))||this.rules.block.hr.test(se)));){if(Z=oe[0],se=se.substring(Z.length),Pe=oe[2].split(`
`,1)[0],le=se.split(`
`,1)[0],this.options.pedantic?(V=2,we=Pe.trimLeft()):(V=oe[2].search(/[^ ]/),V=V>4?1:V,we=Pe.slice(V),V+=oe[1].length),te=!1,!Pe&&/^ *$/.test(le)&&(Z+=le+`
`,se=se.substring(le.length+1),We=!0),!We)for(var nt=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Me=new RegExp("^ {0,"+Math.min(3,V-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:```|~~~)"),Y=new RegExp("^ {0,"+Math.min(3,V-1)+"}#");se&&(De=se.split(`
`,1)[0],Pe=De,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(Pe)||Y.test(Pe)||nt.test(Pe)||Me.test(se)));){if(Pe.search(/[^ ]/)>=V||!Pe.trim())we+=`
`+Pe.slice(V);else if(!te)we+=`
`+Pe;else break;!te&&!Pe.trim()&&(te=!0),Z+=De+`
`,se=se.substring(De.length+1)}Xe.loose||(ge?Xe.loose=!0:/\n *\n *$/.test(Z)&&(ge=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(we),C&&(N=C[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!C,checked:N,loose:!1,text:we}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=we.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(q=0;q<_;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var be=Xe.items[q].tokens.filter(function(Be){return Be.type==="space"}),He=be.every(function(Be){for(var Qe=Be.raw.split(""),Ye=0,Ge=M(Qe),at;!(at=Ge()).done;){var yt=at.value;if(yt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Xe.loose&&be.length&&He&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},ve.html=function(se){var oe=this.rules.block.html.exec(se);if(oe){var Z={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(oe[0]):g(oe[0]);Z.type="paragraph",Z.text=C,Z.tokens=this.lexer.inline(C)}return Z}},ve.def=function(se){var oe=this.rules.block.def.exec(se);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var Z=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:oe[0],href:oe[2],title:oe[3]}}},ve.table=function(se){var oe=this.rules.block.table.exec(se);if(oe){var Z={type:"table",header:c(oe[1]).map(function(ge){return{text:ge}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=oe[0];var C=Z.align.length,N,V,q,te;for(N=0;N<C;N++)/^ *-+: *$/.test(Z.align[N])?Z.align[N]="right":/^ *:-+: *$/.test(Z.align[N])?Z.align[N]="center":/^ *:-+ *$/.test(Z.align[N])?Z.align[N]="left":Z.align[N]=null;for(C=Z.rows.length,N=0;N<C;N++)Z.rows[N]=c(Z.rows[N],Z.header.length).map(function(ge){return{text:ge}});for(C=Z.header.length,V=0;V<C;V++)Z.header[V].tokens=this.lexer.inline(Z.header[V].text);for(C=Z.rows.length,V=0;V<C;V++)for(te=Z.rows[V],q=0;q<te.length;q++)te[q].tokens=this.lexer.inline(te[q].text);return Z}}},ve.lheading=function(se){var oe=this.rules.block.lheading.exec(se);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ve.paragraph=function(se){var oe=this.rules.block.paragraph.exec(se);if(oe){var Z=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:Z,tokens:this.lexer.inline(Z)}}},ve.text=function(se){var oe=this.rules.block.text.exec(se);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ve.escape=function(se){var oe=this.rules.inline.escape.exec(se);if(oe)return{type:"escape",raw:oe[0],text:g(oe[1])}},ve.tag=function(se){var oe=this.rules.inline.tag.exec(se);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):g(oe[0]):oe[0]}},ve.link=function(se){var oe=this.rules.inline.link.exec(se);if(oe){var Z=oe[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var C=v(Z.slice(0,-1),"\\");if((Z.length-C.length)%2===0)return}else{var N=D(oe[2],"()");if(N>-1){var V=oe[0].indexOf("!")===0?5:4,q=V+oe[1].length+N;oe[2]=oe[2].substring(0,N),oe[0]=oe[0].substring(0,q).trim(),oe[3]=""}}var te=oe[2],ge="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);Pe&&(te=Pe[1],ge=Pe[3])}else ge=oe[3]?oe[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Z)?te=te.slice(1):te=te.slice(1,-1)),X(oe,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ve.reflink=function(se,oe){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var C=(Z[2]||Z[1]).replace(/\s+/g," ");if(C=oe[C.toLowerCase()],!C||!C.href){var N=Z[0].charAt(0);return{type:"text",raw:N,text:N}}return X(Z,C,Z[0],this.lexer)}},ve.emStrong=function(se,oe,Z){Z===void 0&&(Z="");var C=this.rules.inline.emStrong.lDelim.exec(se);if(!!C&&!(C[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=C[1]||C[2]||"";if(!N||N&&(Z===""||this.rules.inline.punctuation.exec(Z))){var V=C[0].length-1,q,te,ge=V,Pe=0,le=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,oe=oe.slice(-1*se.length+V);(C=le.exec(oe))!=null;)if(q=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!q){if(te=q.length,C[3]||C[4]){ge+=te;continue}else if((C[5]||C[6])&&V%3&&!((V+te)%3)){Pe+=te;continue}if(ge-=te,!(ge>0)){if(te=Math.min(te,te+ge+Pe),Math.min(V,te)%2){var De=se.slice(1,V+C.index+te);return{type:"em",raw:se.slice(0,V+C.index+te+1),text:De,tokens:this.lexer.inlineTokens(De)}}var we=se.slice(2,V+C.index+te-1);return{type:"strong",raw:se.slice(0,V+C.index+te+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},ve.codespan=function(se){var oe=this.rules.inline.code.exec(se);if(oe){var Z=oe[2].replace(/\n/g," "),C=/[^ ]/.test(Z),N=/^ /.test(Z)&&/ $/.test(Z);return C&&N&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:oe[0],text:Z}}},ve.br=function(se){var oe=this.rules.inline.br.exec(se);if(oe)return{type:"br",raw:oe[0]}},ve.del=function(se){var oe=this.rules.inline.del.exec(se);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ve.autolink=function(se,oe){var Z=this.rules.inline.autolink.exec(se);if(Z){var C,N;return Z[2]==="@"?(C=g(this.options.mangle?oe(Z[1]):Z[1]),N="mailto:"+C):(C=g(Z[1]),N=C),{type:"link",raw:Z[0],text:C,href:N,tokens:[{type:"text",raw:C,text:C}]}}},ve.url=function(se,oe){var Z;if(Z=this.rules.inline.url.exec(se)){var C,N;if(Z[2]==="@")C=g(this.options.mangle?oe(Z[0]):Z[0]),N="mailto:"+C;else{var V;do V=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(V!==Z[0]);C=g(Z[0]),Z[1]==="www."?N="http://"+C:N=C}return{type:"link",raw:Z[0],text:C,href:N,tokens:[{type:"text",raw:C,text:C}]}}},ve.inlineText=function(se,oe){var Z=this.rules.inline.text.exec(se);if(Z){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:C=g(this.options.smartypants?oe(Z[0]):Z[0]),{type:"text",raw:Z[0],text:C}}},Ee}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=d(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=d(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=d(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=d(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=d(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=d(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=r({},U),U.gfm=r({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=d(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=d(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=r({},U.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:d(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=d(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=d(U._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=d(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=d(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=d(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=d(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=d(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=d(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=d(B.reflink).replace("label",B._label).replace("ref",U._label).getRegex(),B.nolink=d(B.nolink).replace("ref",U._label).getRegex(),B.reflinkSearch=d(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=r({},B),B.pedantic=r({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=r({},B.normal,{escape:d(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=d(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=r({},B.gfm,{br:d(B.br).replace("{2,}","*").getRegex(),text:d(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Ee){var ve="",Ce,se,oe=Ee.length;for(Ce=0;Ce<oe;Ce++)se=Ee.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var x=function(){function Ee(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ee.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:U.normal,inline:B.normal};this.options.pedantic?(se.block=U.pedantic,se.inline=B.pedantic):this.options.gfm&&(se.block=U.gfm,this.options.breaks?se.inline=B.breaks:se.inline=B.gfm),this.tokenizer.rules=se}Ee.lex=function(se,oe){var Z=new Ee(oe);return Z.lex(se)},Ee.lexInline=function(se,oe){var Z=new Ee(oe);return Z.inlineTokens(se)};var ve=Ee.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ve.blockTokens=function(se,oe){var Z=this;oe===void 0&&(oe=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ge,Pe,le){return Pe+"    ".repeat(le.length)});for(var C,N,V,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(C=ge.call({lexer:Z},se,oe))?(se=se.substring(C.raw.length),oe.push(C),!0):!1}))){if(C=this.tokenizer.space(se)){se=se.substring(C.raw.length),C.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(C);continue}if(C=this.tokenizer.code(se)){se=se.substring(C.raw.length),N=oe[oe.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):oe.push(C);continue}if(C=this.tokenizer.fences(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.heading(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.hr(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.blockquote(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.list(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.html(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.def(se)){se=se.substring(C.raw.length),N=oe[oe.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+C.raw,N.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.lheading(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(V=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,Pe=se.slice(1),le=void 0;Z.options.extensions.startBlock.forEach(function(De){le=De.call({lexer:this},Pe),typeof le=="number"&&le>=0&&(ge=Math.min(ge,le))}),ge<1/0&&ge>=0&&(V=se.substring(0,ge+1))}(),this.state.top&&(C=this.tokenizer.paragraph(V))){N=oe[oe.length-1],q&&N.type==="paragraph"?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):oe.push(C),q=V.length!==se.length,se=se.substring(C.raw.length);continue}if(C=this.tokenizer.text(se)){se=se.substring(C.raw.length),N=oe[oe.length-1],N&&N.type==="text"?(N.raw+=`
`+C.raw,N.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):oe.push(C);continue}if(se){var te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,oe},ve.inline=function(se,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:se,tokens:oe}),oe},ve.inlineTokens=function(se,oe){var Z=this;oe===void 0&&(oe=[]);var C,N,V,q=se,te,ge,Pe;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)le.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,te.index)+"["+H("a",te[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,te.index)+"["+H("a",te[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,te.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ge||(Pe=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(C=we.call({lexer:Z},se,oe))?(se=se.substring(C.raw.length),oe.push(C),!0):!1}))){if(C=this.tokenizer.escape(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.tag(se)){se=se.substring(C.raw.length),N=oe[oe.length-1],N&&C.type==="text"&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):oe.push(C);continue}if(C=this.tokenizer.link(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(C.raw.length),N=oe[oe.length-1],N&&C.type==="text"&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):oe.push(C);continue}if(C=this.tokenizer.emStrong(se,q,Pe)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.codespan(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.br(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.del(se)){se=se.substring(C.raw.length),oe.push(C);continue}if(C=this.tokenizer.autolink(se,W)){se=se.substring(C.raw.length),oe.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(se,W))){se=se.substring(C.raw.length),oe.push(C);continue}if(V=se,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,We=se.slice(1),$e=void 0;Z.options.extensions.startInline.forEach(function(tt){$e=tt.call({lexer:this},We),typeof $e=="number"&&$e>=0&&(we=Math.min(we,$e))}),we<1/0&&we>=0&&(V=se.substring(0,we+1))}(),C=this.tokenizer.inlineText(V,$)){se=se.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(Pe=C.raw.slice(-1)),ge=!0,N=oe[oe.length-1],N&&N.type==="text"?(N.raw+=C.raw,N.text+=C.text):oe.push(C);continue}if(se){var De="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return oe},n(Ee,null,[{key:"rules",get:function(){return{block:U,inline:B}}}]),Ee}(),fe=function(){function Ee(Ce){this.options=Ce||ee.defaults}var ve=Ee.prototype;return ve.code=function(se,oe,Z){var C=(oe||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(se,C);N!=null&&N!==se&&(Z=!0,se=N)}return se=se.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+g(C,!0)+'">'+(Z?se:g(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:g(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,oe,Z,C){if(this.options.headerIds){var N=this.options.headerPrefix+C.slug(Z);return"<h"+oe+' id="'+N+'">'+se+"</h"+oe+`>
`}return"<h"+oe+">"+se+"</h"+oe+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,oe,Z){var C=oe?"ol":"ul",N=oe&&Z!==1?' start="'+Z+'"':"";return"<"+C+N+`>
`+se+"</"+C+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+oe+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,oe){var Z=oe.header?"th":"td",C=oe.align?"<"+Z+' align="'+oe.align+'">':"<"+Z+">";return C+se+("</"+Z+`>
`)},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,oe,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var C='<a href="'+g(se)+'"';return oe&&(C+=' title="'+oe+'"'),C+=">"+Z+"</a>",C},ve.image=function(se,oe,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var C='<img src="'+se+'" alt="'+Z+'"';return oe&&(C+=' title="'+oe+'"'),C+=this.options.xhtml?"/>":">",C},ve.text=function(se){return se},Ee}(),Se=function(){function Ee(){}var ve=Ee.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,oe,Z){return""+Z},ve.image=function(se,oe,Z){return""+Z},ve.br=function(){return""},Ee}(),ie=function(){function Ee(){this.seen={}}var ve=Ee.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,oe){var Z=se,C=0;if(this.seen.hasOwnProperty(Z)){C=this.seen[se];do C++,Z=se+"-"+C;while(this.seen.hasOwnProperty(Z))}return oe||(this.seen[se]=C,this.seen[Z]=0),Z},ve.slug=function(se,oe){oe===void 0&&(oe={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,oe.dryrun)},Ee}(),ue=function(){function Ee(Ce){this.options=Ce||ee.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new ie}Ee.parse=function(se,oe){var Z=new Ee(oe);return Z.parse(se)},Ee.parseInline=function(se,oe){var Z=new Ee(oe);return Z.parseInline(se)};var ve=Ee.prototype;return ve.parse=function(se,oe){oe===void 0&&(oe=!0);var Z="",C,N,V,q,te,ge,Pe,le,De,we,We,$e,tt,Xe,it,nt,Me,rt,Y,_=se.length;for(C=0;C<_;C++){if(we=se[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Y=this.options.extensions.renderers[we.type].call({parser:this},we),Y!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){Z+=Y||"";continue}switch(we.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(we.tokens),we.depth,t(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(le="",Pe="",q=we.header.length,N=0;N<q;N++)Pe+=this.renderer.tablecell(this.parseInline(we.header[N].tokens),{header:!0,align:we.align[N]});for(le+=this.renderer.tablerow(Pe),De="",q=we.rows.length,N=0;N<q;N++){for(ge=we.rows[N],Pe="",te=ge.length,V=0;V<te;V++)Pe+=this.renderer.tablecell(this.parseInline(ge[V].tokens),{header:!1,align:we.align[V]});De+=this.renderer.tablerow(Pe)}Z+=this.renderer.table(le,De);continue}case"blockquote":{De=this.parse(we.tokens),Z+=this.renderer.blockquote(De);continue}case"list":{for(We=we.ordered,$e=we.start,tt=we.loose,q=we.items.length,De="",N=0;N<q;N++)it=we.items[N],nt=it.checked,Me=it.task,Xe="",it.task&&(rt=this.renderer.checkbox(nt),tt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=rt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=rt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:rt}):Xe+=rt),Xe+=this.parse(it.tokens,tt),De+=this.renderer.listitem(Xe,Me,nt);Z+=this.renderer.list(De,We,$e);continue}case"html":{Z+=this.renderer.html(we.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(De=we.tokens?this.parseInline(we.tokens):we.text;C+1<_&&se[C+1].type==="text";)we=se[++C],De+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);Z+=oe?this.renderer.paragraph(De):De;continue}default:{var be='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return Z},ve.parseInline=function(se,oe){oe=oe||this.renderer;var Z="",C,N,V,q=se.length;for(C=0;C<q;C++){if(N=se[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(V=this.options.extensions.renderers[N.type].call({parser:this},N),V!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){Z+=V||"";continue}switch(N.type){case"escape":{Z+=oe.text(N.text);break}case"html":{Z+=oe.html(N.text);break}case"link":{Z+=oe.link(N.href,N.title,this.parseInline(N.tokens,oe));break}case"image":{Z+=oe.image(N.href,N.title,N.text);break}case"strong":{Z+=oe.strong(this.parseInline(N.tokens,oe));break}case"em":{Z+=oe.em(this.parseInline(N.tokens,oe));break}case"codespan":{Z+=oe.codespan(N.text);break}case"br":{Z+=oe.br();break}case"del":{Z+=oe.del(this.parseInline(N.tokens,oe));break}case"text":{Z+=oe.text(N.text);break}default:{var te='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Z},Ee}();function ce(Ee,ve,Ce){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof ve=="function"&&(Ce=ve,ve=null),ve=r({},ce.defaults,ve||{}),w(ve),Ce){var se=ve.highlight,oe;try{oe=x.lex(Ee,ve)}catch(q){return Ce(q)}var Z=function(te){var ge;if(!te)try{ve.walkTokens&&ce.walkTokens(oe,ve.walkTokens),ge=ue.parse(oe,ve)}catch(Pe){te=Pe}return ve.highlight=se,te?Ce(te):Ce(null,ge)};if(!se||se.length<3||(delete ve.highlight,!oe.length))return Z();var C=0;ce.walkTokens(oe,function(q){q.type==="code"&&(C++,setTimeout(function(){se(q.text,q.lang,function(te,ge){if(te)return Z(te);ge!=null&&ge!==q.text&&(q.text=ge,q.escaped=!0),C--,C===0&&Z()})},0))}),C===0&&Z();return}function N(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(q.message+"",!0)+"</pre>";throw q}try{var V=x.lex(Ee,ve);if(ve.walkTokens){if(ve.async)return Promise.all(ce.walkTokens(V,ve.walkTokens)).then(function(){return ue.parse(V,ve)}).catch(N);ce.walkTokens(V,ve.walkTokens)}return ue.parse(V,ve)}catch(q){N(q)}}ce.options=ce.setOptions=function(Ee){return r(ce.defaults,Ee),A(ce.defaults),ce},ce.getDefaults=R,ce.defaults=ee.defaults,ce.use=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ce=0;Ce<Ee;Ce++)ve[Ce]=arguments[Ce];var se=r.apply(void 0,[{}].concat(ve)),oe=ce.defaults.extensions||{renderers:{},childTokens:{}},Z;ve.forEach(function(C){if(C.extensions&&(Z=!0,C.extensions.forEach(function(V){if(!V.name)throw new Error("extension name required");if(V.renderer){var q=oe.renderers?oe.renderers[V.name]:null;q?oe.renderers[V.name]=function(){for(var te=arguments.length,ge=new Array(te),Pe=0;Pe<te;Pe++)ge[Pe]=arguments[Pe];var le=V.renderer.apply(this,ge);return le===!1&&(le=q.apply(this,ge)),le}:oe.renderers[V.name]=V.renderer}if(V.tokenizer){if(!V.level||V.level!=="block"&&V.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[V.level]?oe[V.level].unshift(V.tokenizer):oe[V.level]=[V.tokenizer],V.start&&(V.level==="block"?oe.startBlock?oe.startBlock.push(V.start):oe.startBlock=[V.start]:V.level==="inline"&&(oe.startInline?oe.startInline.push(V.start):oe.startInline=[V.start]))}V.childTokens&&(oe.childTokens[V.name]=V.childTokens)})),C.renderer&&function(){var V=ce.defaults.renderer||new fe,q=function(Pe){var le=V[Pe];V[Pe]=function(){for(var De=arguments.length,we=new Array(De),We=0;We<De;We++)we[We]=arguments[We];var $e=C.renderer[Pe].apply(V,we);return $e===!1&&($e=le.apply(V,we)),$e}};for(var te in C.renderer)q(te);se.renderer=V}(),C.tokenizer&&function(){var V=ce.defaults.tokenizer||new G,q=function(Pe){var le=V[Pe];V[Pe]=function(){for(var De=arguments.length,we=new Array(De),We=0;We<De;We++)we[We]=arguments[We];var $e=C.tokenizer[Pe].apply(V,we);return $e===!1&&($e=le.apply(V,we)),$e}};for(var te in C.tokenizer)q(te);se.tokenizer=V}(),C.walkTokens){var N=ce.defaults.walkTokens;se.walkTokens=function(V){var q=[];return q.push(C.walkTokens.call(this,V)),N&&(q=q.concat(N.call(this,V))),q}}Z&&(se.extensions=oe),ce.setOptions(se)})},ce.walkTokens=function(Ee,ve){for(var Ce=[],se=function(){var N=Z.value;switch(Ce=Ce.concat(ve.call(ce,N)),N.type){case"table":{for(var V=M(N.header),q;!(q=V()).done;){var te=q.value;Ce=Ce.concat(ce.walkTokens(te.tokens,ve))}for(var ge=M(N.rows),Pe;!(Pe=ge()).done;)for(var le=Pe.value,De=M(le),we;!(we=De()).done;){var We=we.value;Ce=Ce.concat(ce.walkTokens(We.tokens,ve))}break}case"list":{Ce=Ce.concat(ce.walkTokens(N.items,ve));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[N.type]?ce.defaults.extensions.childTokens[N.type].forEach(function($e){Ce=Ce.concat(ce.walkTokens(N[$e],ve))}):N.tokens&&(Ce=Ce.concat(ce.walkTokens(N.tokens,ve)))}},oe=M(Ee),Z;!(Z=oe()).done;)se();return Ce},ce.parseInline=function(Ee,ve){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");ve=r({},ce.defaults,ve||{}),w(ve);try{var Ce=x.lexInline(Ee,ve);return ve.walkTokens&&ce.walkTokens(Ce,ve.walkTokens),ue.parseInline(Ce,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(se.message+"",!0)+"</pre>";throw se}},ce.Parser=ue,ce.parser=ue.parse,ce.Renderer=fe,ce.TextRenderer=Se,ce.Lexer=x,ce.lexer=x.lex,ce.Tokenizer=G,ce.Slugger=ie,ce.parse=ce;var Te=ce.options,de=ce.setOptions,ae=ce.use,j=ce.walkTokens,F=ce.parseInline,Q=ce,pe=ue.parse,ke=x.lex;ee.Lexer=x,ee.Parser=ue,ee.Renderer=fe,ee.Slugger=ie,ee.TextRenderer=Se,ee.Tokenizer=G,ee.getDefaults=R,ee.lexer=ke,ee.marked=ce,ee.options=Te,ee.parse=Q,ee.parseInline=F,ee.parser=pe,ee.setOptions=de,ee.use=ae,ee.walkTokens=j,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ae[115],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,I,m){return Math.min(Math.max(A,I),m)}e.clamp=n;function P(A,I){return(I+A%I)%I}e.rot=P;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class M{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class R{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const m=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function ee(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function R(I){M.push(I,Date.now())}function A(){const I=[];for(let m=0;m<M.length;m+=2)I.push({name:M[m],startTime:M[m+1]});return I}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(k+R.startTime)});return M}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=n(P))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var P in n)(typeof exports=="object"?exports:ee)[P]=n[P]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function n(P){if(e[P])return e[P].exports;var k=e[P]={i:P,l:!1,exports:{}};return ee[P].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=ee,n.c=e,n.d=function(P,k,M){n.o(P,k)||Object.defineProperty(P,k,{enumerable:!0,get:M})},n.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},n.t=function(P,k){if(1&k&&(P=n(P)),8&k||4&k&&typeof P=="object"&&P&&P.__esModule)return P;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:P}),2&k&&typeof P!="string")for(var R in P)n.d(M,R,function(A){return P[A]}.bind(null,R));return M},n.n=function(P){var k=P&&P.__esModule?function(){return P.default}:function(){return P};return n.d(k,"a",k),k},n.o=function(P,k){return Object.prototype.hasOwnProperty.call(P,k)},n.p="",n(n.s=0)}([function(ee,e,n){(function(P){var k;e=ee.exports=ae,k=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],I=e.src=[],m=0,O=m++;I[O]="0|[1-9]\\d*";var y=m++;I[y]="[0-9]+";var h=m++;I[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=m++;I[E]="("+I[O]+")\\.("+I[O]+")\\.("+I[O]+")";var g=m++;I[g]="("+I[y]+")\\.("+I[y]+")\\.("+I[y]+")";var l=m++;I[l]="(?:"+I[O]+"|"+I[h]+")";var t=m++;I[t]="(?:"+I[y]+"|"+I[h]+")";var a=m++;I[a]="(?:-("+I[l]+"(?:\\."+I[l]+")*))";var d=m++;I[d]="(?:-?("+I[t]+"(?:\\."+I[t]+")*))";var S=m++;I[S]="[0-9A-Za-z-]+";var T=m++;I[T]="(?:\\+("+I[S]+"(?:\\."+I[S]+")*))";var p=m++,i="v?"+I[E]+I[a]+"?"+I[T]+"?";I[p]="^"+i+"$";var u="[v=\\s]*"+I[g]+I[d]+"?"+I[T]+"?",s=m++;I[s]="^"+u+"$";var o=m++;I[o]="((?:<|>)?=?)";var f=m++;I[f]=I[y]+"|x|X|\\*";var b=m++;I[b]=I[O]+"|x|X|\\*";var r=m++;I[r]="[v=\\s]*("+I[b]+")(?:\\.("+I[b]+")(?:\\.("+I[b]+")(?:"+I[a]+")?"+I[T]+"?)?)?";var c=m++;I[c]="[v=\\s]*("+I[f]+")(?:\\.("+I[f]+")(?:\\.("+I[f]+")(?:"+I[d]+")?"+I[T]+"?)?)?";var v=m++;I[v]="^"+I[o]+"\\s*"+I[r]+"$";var D=m++;I[D]="^"+I[o]+"\\s*"+I[c]+"$";var w=m++;I[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=m++;I[H]="(?:~>?)";var X=m++;I[X]="(\\s*)"+I[H]+"\\s+",A[X]=new RegExp(I[X],"g");var J=m++;I[J]="^"+I[H]+I[r]+"$";var G=m++;I[G]="^"+I[H]+I[c]+"$";var U=m++;I[U]="(?:\\^)";var B=m++;I[B]="(\\s*)"+I[U]+"\\s+",A[B]=new RegExp(I[B],"g");var $=m++;I[$]="^"+I[U]+I[r]+"$";var W=m++;I[W]="^"+I[U]+I[c]+"$";var x=m++;I[x]="^"+I[o]+"\\s*("+u+")$|^$";var fe=m++;I[fe]="^"+I[o]+"\\s*("+i+")$|^$";var Se=m++;I[Se]="(\\s*)"+I[o]+"\\s*("+u+"|"+I[r]+")",A[Se]=new RegExp(I[Se],"g");var ie=m++;I[ie]="^\\s*("+I[r]+")\\s+-\\s+("+I[r]+")\\s*$";var ue=m++;I[ue]="^\\s*("+I[c]+")\\s+-\\s+("+I[c]+")\\s*$";var ce=m++;I[ce]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)k(Te,I[Te]),A[Te]||(A[Te]=new RegExp(I[Te]));function de(le,De){if(le instanceof ae)return le;if(typeof le!="string"||le.length>M||!(De?A[s]:A[p]).test(le))return null;try{return new ae(le,De)}catch{return null}}function ae(le,De){if(le instanceof ae){if(le.loose===De)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ae))return new ae(le,De);k("SemVer",le,De),this.loose=De;var we=le.trim().match(De?A[s]:A[p]);if(!we)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var $e=+We;if($e>=0&&$e<R)return $e}return We}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=de,e.valid=function(le,De){var we=de(le,De);return we?we.version:null},e.clean=function(le,De){var we=de(le.trim().replace(/^[=v]+/,""),De);return we?we.version:null},e.SemVer=ae,ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ae.prototype.toString=function(){return this.version},ae.prototype.compare=function(le){return k("SemVer.compare",this.version,this.loose,le),le instanceof ae||(le=new ae(le,this.loose)),this.compareMain(le)||this.comparePre(le)},ae.prototype.compareMain=function(le){return le instanceof ae||(le=new ae(le,this.loose)),F(this.major,le.major)||F(this.minor,le.minor)||F(this.patch,le.patch)},ae.prototype.comparePre=function(le){if(le instanceof ae||(le=new ae(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var De=0;do{var we=this.prerelease[De],We=le.prerelease[De];if(k("prerelease compare",De,we,We),we===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(we===void 0)return-1;if(we!==We)return F(we,We)}while(++De)},ae.prototype.inc=function(le,De){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,De,we,We){typeof we=="string"&&(We=we,we=void 0);try{return new ae(le,we).inc(De,We).version}catch{return null}},e.diff=function(le,De){if(Ee(le,De))return null;var we=de(le),We=de(De);if(we.prerelease.length||We.prerelease.length){for(var $e in we)if(($e==="major"||$e==="minor"||$e==="patch")&&we[$e]!==We[$e])return"pre"+$e;return"prerelease"}for(var $e in we)if(($e==="major"||$e==="minor"||$e==="patch")&&we[$e]!==We[$e])return $e},e.compareIdentifiers=F;var j=/^[0-9]+$/;function F(le,De){var we=j.test(le),We=j.test(De);return we&&We&&(le=+le,De=+De),we&&!We?-1:We&&!we?1:le<De?-1:le>De?1:0}function Q(le,De,we){return new ae(le,we).compare(new ae(De,we))}function pe(le,De,we){return Q(le,De,we)>0}function ke(le,De,we){return Q(le,De,we)<0}function Ee(le,De,we){return Q(le,De,we)===0}function ve(le,De,we){return Q(le,De,we)!==0}function Ce(le,De,we){return Q(le,De,we)>=0}function se(le,De,we){return Q(le,De,we)<=0}function oe(le,De,we,We){var $e;switch(De){case"===":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),$e=le===we;break;case"!==":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),$e=le!==we;break;case"":case"=":case"==":$e=Ee(le,we,We);break;case"!=":$e=ve(le,we,We);break;case">":$e=pe(le,we,We);break;case">=":$e=Ce(le,we,We);break;case"<":$e=ke(le,we,We);break;case"<=":$e=se(le,we,We);break;default:throw new TypeError("Invalid operator: "+De)}return $e}function Z(le,De){if(le instanceof Z){if(le.loose===De)return le;le=le.value}if(!(this instanceof Z))return new Z(le,De);k("comparator",le,De),this.loose=De,this.parse(le),this.semver===C?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(le,De){return F(De,le)},e.major=function(le,De){return new ae(le,De).major},e.minor=function(le,De){return new ae(le,De).minor},e.patch=function(le,De){return new ae(le,De).patch},e.compare=Q,e.compareLoose=function(le,De){return Q(le,De,!0)},e.rcompare=function(le,De,we){return Q(De,le,we)},e.sort=function(le,De){return le.sort(function(we,We){return e.compare(we,We,De)})},e.rsort=function(le,De){return le.sort(function(we,We){return e.rcompare(we,We,De)})},e.gt=pe,e.lt=ke,e.eq=Ee,e.neq=ve,e.gte=Ce,e.lte=se,e.cmp=oe,e.Comparator=Z;var C={};function N(le,De){if(le instanceof N)return le.loose===De?le:new N(le.raw,De);if(le instanceof Z)return new N(le.value,De);if(!(this instanceof N))return new N(le,De);if(this.loose=De,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function V(le){return!le||le.toLowerCase()==="x"||le==="*"}function q(le,De,we,We,$e,tt,Xe,it,nt,Me,rt,Y,_){return((De=V(we)?"":V(We)?">="+we+".0.0":V($e)?">="+we+"."+We+".0":">="+De)+" "+(it=V(nt)?"":V(Me)?"<"+(+nt+1)+".0.0":V(rt)?"<"+nt+"."+(+Me+1)+".0":Y?"<="+nt+"."+Me+"."+rt+"-"+Y:"<="+it)).trim()}function te(le,De){for(var we=0;we<le.length;we++)if(!le[we].test(De))return!1;if(De.prerelease.length){for(we=0;we<le.length;we++)if(k(le[we].semver),le[we].semver!==C&&le[we].semver.prerelease.length>0){var We=le[we].semver;if(We.major===De.major&&We.minor===De.minor&&We.patch===De.patch)return!0}return!1}return!0}function ge(le,De,we){try{De=new N(De,we)}catch{return!1}return De.test(le)}function Pe(le,De,we,We){var $e,tt,Xe,it,nt;switch(le=new ae(le,We),De=new N(De,We),we){case">":$e=pe,tt=se,Xe=ke,it=">",nt=">=";break;case"<":$e=ke,tt=Ce,Xe=pe,it="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ge(le,De,We))return!1;for(var Me=0;Me<De.set.length;++Me){var rt=De.set[Me],Y=null,_=null;if(rt.forEach(function(be){be.semver===C&&(be=new Z(">=0.0.0")),Y=Y||be,_=_||be,$e(be.semver,Y.semver,We)?Y=be:Xe(be.semver,_.semver,We)&&(_=be)}),Y.operator===it||Y.operator===nt||(!_.operator||_.operator===it)&&tt(le,_.semver)||_.operator===nt&&Xe(le,_.semver))return!1}return!0}Z.prototype.parse=function(le){var De=this.loose?A[x]:A[fe],we=le.match(De);if(!we)throw new TypeError("Invalid comparator: "+le);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new ae(we[2],this.loose):this.semver=C},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(le){return k("Comparator.test",le,this.loose),this.semver===C||(typeof le=="string"&&(le=new ae(le,this.loose)),oe(le,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(le,De){if(!(le instanceof Z))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new N(le.value,De),ge(this.value,we,De);if(le.operator==="")return we=new N(this.value,De),ge(le.semver,we,De);var We=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),tt=this.semver.version===le.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),it=oe(this.semver,"<",le.semver,De)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),nt=oe(this.semver,">",le.semver,De)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return We||$e||tt&&Xe||it||nt},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(le){var De=this.loose;le=le.trim(),k("range",le,De);var we=De?A[ue]:A[ie];le=le.replace(we,q),k("hyphen replace",le),le=le.replace(A[Se],"$1$2$3"),k("comparator trim",le,A[Se]),le=(le=(le=le.replace(A[X],"$1~")).replace(A[B],"$1^")).split(/\s+/).join(" ");var We=De?A[x]:A[fe],$e=le.split(" ").map(function(tt){return function(Xe,it){return k("comp",Xe),Xe=function(nt,Me){return nt.trim().split(/\s+/).map(function(rt){return function(Y,_){k("caret",Y,_);var be=_?A[W]:A[$];return Y.replace(be,function(He,Be,Qe,Ye,Ge){var at;return k("caret",Y,He,Be,Qe,Ye,Ge),V(Be)?at="":V(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":V(Ye)?at=Be==="0"?">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+".0 <"+(+Be+1)+".0.0":Ge?(k("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+Qe+"."+(+Ye+1):">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+Ye+Ge+" <"+(+Be+1)+".0.0"):(k("no pr"),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+Qe+"."+(+Ye+1):">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+Ye+" <"+(+Be+1)+".0.0"),k("caret return",at),at})}(rt,Me)}).join(" ")}(Xe,it),k("caret",Xe),Xe=function(nt,Me){return nt.trim().split(/\s+/).map(function(rt){return function(Y,_){var be=_?A[G]:A[J];return Y.replace(be,function(He,Be,Qe,Ye,Ge){var at;return k("tilde",Y,He,Be,Qe,Ye,Ge),V(Be)?at="":V(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":V(Ye)?at=">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":Ge?(k("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+(+Qe+1)+".0"):at=">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+(+Qe+1)+".0",k("tilde return",at),at})}(rt,Me)}).join(" ")}(Xe,it),k("tildes",Xe),Xe=function(nt,Me){return k("replaceXRanges",nt,Me),nt.split(/\s+/).map(function(rt){return function(Y,_){Y=Y.trim();var be=_?A[D]:A[v];return Y.replace(be,function(He,Be,Qe,Ye,Ge,at){k("xRange",Y,He,Be,Qe,Ye,Ge,at);var yt=V(Qe),It=yt||V(Ye),St=It||V(Ge);return Be==="="&&St&&(Be=""),yt?He=Be===">"||Be==="<"?"<0.0.0":"*":Be&&St?(It&&(Ye=0),St&&(Ge=0),Be===">"?(Be=">=",It?(Qe=+Qe+1,Ye=0,Ge=0):St&&(Ye=+Ye+1,Ge=0)):Be==="<="&&(Be="<",It?Qe=+Qe+1:Ye=+Ye+1),He=Be+Qe+"."+Ye+"."+Ge):It?He=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":St&&(He=">="+Qe+"."+Ye+".0 <"+Qe+"."+(+Ye+1)+".0"),k("xRange return",He),He})}(rt,Me)}).join(" ")}(Xe,it),k("xrange",Xe),Xe=function(nt,Me){return k("replaceStars",nt,Me),nt.trim().replace(A[ce],"")}(Xe,it),k("stars",Xe),Xe}(tt,De)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(tt){return!!tt.match(We)})),$e=$e.map(function(tt){return new Z(tt,De)})},N.prototype.intersects=function(le,De){if(!(le instanceof N))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(We){return le.set.some(function($e){return $e.every(function(tt){return We.intersects(tt,De)})})})})},e.toComparators=function(le,De){return new N(le,De).set.map(function(we){return we.map(function(We){return We.value}).join(" ").trim().split(" ")})},N.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new ae(le,this.loose));for(var De=0;De<this.set.length;De++)if(te(this.set[De],le))return!0;return!1},e.satisfies=ge,e.maxSatisfying=function(le,De,we){var We=null,$e=null;try{var tt=new N(De,we)}catch{return null}return le.forEach(function(Xe){tt.test(Xe)&&(We&&$e.compare(Xe)!==-1||($e=new ae(We=Xe,we)))}),We},e.minSatisfying=function(le,De,we){var We=null,$e=null;try{var tt=new N(De,we)}catch{return null}return le.forEach(function(Xe){tt.test(Xe)&&(We&&$e.compare(Xe)!==1||($e=new ae(We=Xe,we)))}),We},e.validRange=function(le,De){try{return new N(le,De).range||"*"}catch{return null}},e.ltr=function(le,De,we){return Pe(le,De,"<",we)},e.gtr=function(le,De,we){return Pe(le,De,">",we)},e.outside=Pe,e.prerelease=function(le,De){var we=de(le,De);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(le,De,we){return le=new N(le,we),De=new N(De,we),le.intersects(De)},e.coerce=function(le){if(le instanceof ae)return le;if(typeof le!="string")return null;var De=le.match(A[w]);return De==null?null:de((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,n(1))},function(ee,e){var n,P,k=ee.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(t){if(n===setTimeout)return setTimeout(t,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{P=typeof clearTimeout=="function"?clearTimeout:R}catch{P=R}})();var I,m=[],O=!1,y=-1;function h(){O&&I&&(O=!1,I.length?m=I.concat(m):y=-1,m.length&&E())}function E(){if(!O){var t=A(h);O=!0;for(var a=m.length;a;){for(I=m,m=[];++y<a;)I&&I[y].run();y=-1,a=m.length}I=null,O=!1,function(d){if(P===clearTimeout)return clearTimeout(d);if((P===R||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(d);try{P(d)}catch{try{return P.call(null,d)}catch{return P.call(this,d)}}}(t)}}function g(t,a){this.fun=t,this.array=a}function l(){}k.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)a[d-1]=arguments[d];m.push(new g(t,a)),m.length!==1||O||A(E)},g.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=l,k.addListener=l,k.once=l,k.off=l,k.removeListener=l,k.removeAllListeners=l,k.emit=l,k.prependListener=l,k.prependOnceListener=l,k.listeners=function(t){return[]},k.binding=function(t){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(t){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Ae[116],Re([1,0,9,6]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(T){const p=T;return p?typeof p.read=="function":!1}e.isReadable=k;function M(T){const p=T;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function R(T){const p=T;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=R;function A(T,p){return new I(T,p)}e.newWriteableStream=A;class I{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,n.onUnexpectedError)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let u;switch(p){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(i);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(T,p){const i=[];let u;for(;(u=T.read())!==null;)i.push(u);return p(i)}e.consumeReadable=m;function O(T,p,i){const u=[];let s;for(;(s=T.read())!==null&&u.length<i;)u.push(s);return s===null&&u.length>0?p(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return T.read()}}}e.peekReadable=O;function y(T,p){return new Promise((i,u)=>{const s=[];h(T,{onData:o=>{p&&s.push(o)},onError:o=>{p?u(o):i(void 0)},onEnd:()=>{i(p?p(s):void 0)}})})}e.consumeStream=y;function h(T,p){let i=!1;return T.on("error",u=>{i||p.onError(u)}),T.on("end",()=>{i||p.onEnd()}),T.on("data",u=>{i||p.onData(u)}),(0,P.toDisposable)(()=>i=!0)}e.listenStream=h;function E(T,p){return new Promise((i,u)=>{const s=new P.DisposableStore,o=[],f=c=>{if(o.push(c),o.length>p)return s.dispose(),T.pause(),i({stream:T,buffer:o,ended:!1})},b=c=>u(c),r=()=>i({stream:T,buffer:o,ended:!0});s.add((0,P.toDisposable)(()=>T.removeListener("error",b))),T.on("error",b),s.add((0,P.toDisposable)(()=>T.removeListener("end",r))),T.on("end",r),s.add((0,P.toDisposable)(()=>T.removeListener("data",f))),T.on("data",f)})}e.peekStream=E;function g(T,p){const i=A(p);return i.end(T),i}e.toStream=g;function l(){const T=A(()=>{throw new Error("not supported")});return T.end(),T}e.emptyStream=l;function t(T){let p=!1;return{read:()=>p?null:(p=!0,T)}}e.toReadable=t;function a(T,p,i){const u=A(i);return h(T,{onData:s=>u.write(p.data(s)),onError:s=>u.error(p.error?p.error(s):s),onEnd:()=>u.end()}),u}e.transform=a;function d(T,p,i){let u=!1;return{read:()=>{const s=p.read();return u?s:(u=!0,s!==null?i([T,s]):T)}}}e.prefixedReadable=d;function S(T,p,i){let u=!1;const s=A(i);return h(p,{onData:o=>u?s.write(o):(u=!0,s.write(i([T,o]))),onError:o=>s.error(o),onEnd:()=>{u||(u=!0,s.write(T)),s.end()}}),s}e.prefixedStream=S}),define(Ae[25],Re([1,0,116]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let k,M;class R{static alloc(c){return P?new R(Buffer.allocUnsafe(c)):new R(new Uint8Array(c))}static wrap(c){return P&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new R(c)}static fromString(c,v){return!(v?.dontUseNodeBuffer||!1)&&P?new R(Buffer.from(c)):(k||(k=new TextEncoder),new R(k.encode(c)))}static fromByteArray(c){const v=R.alloc(c.length);for(let D=0,w=c.length;D<w;D++)v.buffer[D]=c[D];return v}static concat(c,v){if(typeof v>"u"){v=0;for(let H=0,X=c.length;H<X;H++)v+=c[H].byteLength}const D=R.alloc(v);let w=0;for(let H=0,X=c.length;H<X;H++){const J=c[H];D.set(J,w),w+=J.byteLength}return D}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=R.alloc(this.byteLength);return c.set(this),c}toString(){return P?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(c,v){return new R(this.buffer.subarray(c,v))}set(c,v){if(c instanceof R)this.buffer.set(c.buffer,v);else if(c instanceof Uint8Array)this.buffer.set(c,v);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),v);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return m(this.buffer,c)}writeUInt32BE(c,v){O(this.buffer,c,v)}readUInt32LE(c){return y(this.buffer,c)}writeUInt32LE(c,v){h(this.buffer,c,v)}readUInt8(c){return E(this.buffer,c)}writeUInt8(c,v){g(this.buffer,c,v)}}e.VSBuffer=R;function A(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=A;function I(r,c,v){r[v+0]=c&255,c=c>>>8,r[v+1]=c&255}e.writeUInt16LE=I;function m(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=m;function O(r,c,v){r[v+3]=c,c=c>>>8,r[v+2]=c,c=c>>>8,r[v+1]=c,c=c>>>8,r[v]=c}e.writeUInt32BE=O;function y(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=y;function h(r,c,v){r[v+0]=c&255,c=c>>>8,r[v+1]=c&255,c=c>>>8,r[v+2]=c&255,c=c>>>8,r[v+3]=c&255}e.writeUInt32LE=h;function E(r,c){return r[c]}e.readUInt8=E;function g(r,c,v){r[v]=c}e.writeUInt8=g;function l(r){return n.consumeReadable(r,c=>R.concat(c))}e.readableToBuffer=l;function t(r){return n.toReadable(r)}e.bufferToReadable=t;function a(r){return n.consumeStream(r,c=>R.concat(c))}e.streamToBuffer=a;async function d(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await a(r.stream)])}e.bufferedStreamToBuffer=d;function S(r){return n.toStream(r,c=>R.concat(c))}e.bufferToStream=S;function T(r){return n.transform(r,{data:c=>typeof c=="string"?R.fromString(c):R.wrap(c)},c=>R.concat(c))}e.streamToBufferReadableStream=T;function p(r){return n.newWriteableStream(c=>R.concat(c),r)}e.newWriteableBufferStream=p;function i(r,c){return n.prefixedReadable(r,c,v=>R.concat(v))}e.prefixedBufferReadable=i;function u(r,c){return n.prefixedStream(r,c,v=>R.concat(v))}e.prefixedBufferStream=u;function s(r){let c=0,v=0,D=0;const w=new Uint8Array(Math.floor(r.length/4*3)),H=J=>{switch(v){case 3:w[D++]=c|J,v=0;break;case 2:w[D++]=c|J>>>2,c=J<<6,v=3;break;case 1:w[D++]=c|J>>>4,c=J<<4,v=2;break;default:c=J<<2,v=1}};for(let J=0;J<r.length;J++){const G=r.charCodeAt(J);if(G>=65&&G<=90)H(G-65);else if(G>=97&&G<=122)H(G-97+26);else if(G>=48&&G<=57)H(G-48+52);else if(G===43||G===45)H(62);else if(G===47||G===95)H(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${r[J]}`)}}const X=D;for(;v>0;)H(0);return R.wrap(w).slice(0,X)}e.decodeBase64=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:r},c=!0,v=!1){const D=v?f:o;let w="";const H=r.byteLength%3;let X=0;for(;X<r.byteLength-H;X+=3){const J=r[X+0],G=r[X+1],U=r[X+2];w+=D[J>>>2],w+=D[(J<<4|G>>>4)&63],w+=D[(G<<2|U>>>6)&63],w+=D[U&63]}if(H===1){const J=r[X+0];w+=D[J>>>2],w+=D[J<<4&63],c&&(w+="==")}else if(H===2){const J=r[X+0],G=r[X+1];w+=D[J>>>2],w+=D[(J<<4|G>>>4)&63],w+=D[G<<2&63],c&&(w+="=")}return w}e.encodeBase64=b}),define(Ae[117],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[39],Re([1,0,85]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(R){function A(I){return I&&typeof I=="object"&&typeof I.id=="string"}R.isThemeColor=A})(P=e.ThemeColor||(e.ThemeColor={}));function k(R){return{id:R}}e.themeColorFromId=k;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function I(d){const S=A.exec(d.id);if(!S)return I(n.Codicon.error);const[,T,p]=S,i=["codicon","codicon-"+T];return p&&i.push("codicon-modifier-"+p.substring(1)),i}R.asClassNameArray=I;function m(d){return I(d).join(" ")}R.asClassName=m;function O(d){return"."+I(d).join(".")}R.asCSSSelector=O;function y(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||P.isThemeColor(d.color))}R.isThemeIcon=y;const h=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(d){const S=h.exec(d);if(!S)return;const[,T]=S;return{id:T}}R.fromString=E;function g(d){return{id:d}}R.fromId=g;function l(d,S){let T=d.id;const p=T.lastIndexOf("~");return p!==-1&&(T=T.substring(0,p)),S&&(T=`${T}~${S}`),{id:T}}R.modify=l;function t(d){const S=d.id.lastIndexOf("~");if(S!==-1)return d.id.substring(S+1)}R.getModifier=t;function a(d,S){return d.id===S.id&&d.color?.id===S.color?.id}R.isEqual=a})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ae[35],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(k){return n.test(k)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(A){for(let I=0;I<A.length;I++)A[I]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){k(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let I=0,m="";return m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m+="-",m+=R[M[I++]],m+=R[M[I++]],m+="-",m+=R[M[I++]],m+=R[M[I++]],m+="-",m+=R[M[I++]],m+=R[M[I++]],m+="-",m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m+=R[M[I++]],m}}()}),define(Ae[118],Re([1,0,16,35]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(A){return{id:(0,P.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=k;function M(A,I,m){return{id:(0,P.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:I,data:m}),value:void 0}}e.createFileDataTransferItem=M;class R{constructor(){this.a=new Map}get size(){return this.a.size}has(I){return this.a.has(this.b(I))}get(I){return this.a.get(this.b(I))?.[0]}append(I,m){const O=this.a.get(I);O?O.push(m):this.a.set(this.b(I),[m])}replace(I,m){this.a.set(this.b(I),[m])}delete(I){this.a.delete(this.b(I))}*entries(){for(const[I,m]of this.a.entries())for(const O of m)yield[I,O]}values(){return Array.from(this.a.values()).flat()}forEach(I){for(const[m,O]of this.entries())I(O,m)}b(I){return I.toLowerCase()}}e.VSDataTransfer=R,e.UriList=Object.freeze({create:A=>(0,n.distinct)(A.map(I=>I.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(I=>!I.startsWith("#"))})}),define(Ae[119],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[120],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class P{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let I=0,m=A.notIn.length;I<m;I++)switch(A.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,I){if(A.getTokenCount()===0)return!0;const m=A.findTokenIndexAtOffset(I-2),O=A.getStandardTokenType(m);return this.isOK(O)}g(A,I){for(let m=A;m<=I;m++){const O=String.fromCharCode(m);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=P;class k{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of A)M(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),M(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),M(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),M(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&M(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=k;function M(R,A,I){R.has(A)?R.get(A).push(I):R.set(A,[I])}}),define(Ae[121],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDnDService=void 0;class n{constructor(){this.a=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const M=this.a.get(k);return this.a.delete(k),M}}addDragOperationTransfer(k,M){this.a.set(k,M)}}e.TreeViewsDnDService=n}),define(Ae[122],Re([11,12]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ae[123],Re([11,12]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ae[124],Re([1,0,123]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,k=P*60,M=k*24,R=M*7,A=M*30,I=M*365;function m(y,h,E,g){typeof y!="number"&&(y=y.getTime());const l=Math.round((new Date().getTime()-y)/1e3);if(l<-30)return(0,n.localize)(0,null,m(new Date().getTime()+l*1e3,!1));if(!g&&l<30)return(0,n.localize)(1,null);let t;return l<P?(t=l,h?t===1?E?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):E?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?E?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):E?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):l<k?(t=Math.floor(l/P),h?t===1?E?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):E?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?E?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):E?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):l<M?(t=Math.floor(l/k),h?t===1?E?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):E?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?E?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):E?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):l<R?(t=Math.floor(l/M),h?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):l<A?(t=Math.floor(l/R),h?t===1?E?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):E?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?E?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):E?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):l<I?(t=Math.floor(l/A),h?t===1?E?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):E?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?E?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):E?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(l/I),h?t===1?E?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):E?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?E?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):E?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=m;function O(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ae[125],Re([11,12]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ae[40],Re([1,0,16,10,125]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(y,h){return h&&(y.stack||y.stacktrace)?k.localize(0,null,A(y),R(y.stack)||R(y.stacktrace)):A(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function I(y=null,h=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const E=n.coalesce(y),g=I(E[0],h);return E.length>1?k.localize(4,null,g,E.length):g}if(P.isString(y))return y;if(y.detail){const E=y.detail;if(E.error)return M(E.error,h);if(E.exception)return M(E.exception,h)}return y.stack?M(y,h):y.message?y.message:k.localize(5,null)}e.toErrorMessage=I;function m(y){const h=y;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=m;function O(y,h){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=h,E}e.createErrorWithActions=O}),define(Ae[126],Re([1,0,86,19]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new n.Lazy(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(c,v,D=!1){const w=c||"",H=v||"",X=k.value.collator.compare(w,H);return k.value.collatorIsNumeric&&X===0&&w!==H?w<H?-1:1:X}e.compareFileNames=A;function I(c,v){const D=M.value.collator;return c=c||"",v=v||"",T(D,c,v)}e.compareFileNamesDefault=I;function m(c,v){const D=M.value.collator;return c=c||"",v=v||"",s(c,v)||T(D,c,v)}e.compareFileNamesUpper=m;function O(c,v){const D=M.value.collator;return c=c||"",v=v||"",u(c,v)||T(D,c,v)}e.compareFileNamesLower=O;function y(c,v){return c=c||"",v=v||"",c===v?0:c<v?-1:1}e.compareFileNamesUnicode=y;function h(c,v){const[D,w]=d(c),[H,X]=d(v);let J=k.value.collator.compare(w,X);if(J===0){if(k.value.collatorIsNumeric&&w!==X)return w<X?-1:1;if(J=k.value.collator.compare(D,H),k.value.collatorIsNumeric&&J===0&&D!==H)return D<H?-1:1}return J}e.compareFileExtensions=h;function E(c,v){c=c||"",v=v||"";const D=S(c),w=S(v),H=M.value.collator,X=R.value.collator;return T(X,D,w)||T(H,c,v)}e.compareFileExtensionsDefault=E;function g(c,v){c=c||"",v=v||"";const D=S(c),w=S(v),H=M.value.collator,X=R.value.collator;return T(X,D,w)||s(c,v)||T(H,c,v)}e.compareFileExtensionsUpper=g;function l(c,v){c=c||"",v=v||"";const D=S(c),w=S(v),H=M.value.collator,X=R.value.collator;return T(X,D,w)||u(c,v)||T(H,c,v)}e.compareFileExtensionsLower=l;function t(c,v){c=c||"",v=v||"";const D=S(c).toLowerCase(),w=S(v).toLowerCase();return D!==w?D<w?-1:1:c!==v?c<v?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function d(c,v=!1){const D=c?a.exec(c):[];let w=[D&&D[1]||"",D&&D[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function S(c){const v=c?a.exec(c):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function T(c,v,D){const w=c.compare(v,D);return w!==0?w:v.length!==D.length?v.length<D.length?-1:1:0}function p(c){const v=c.charAt(0);return v.toLocaleUpperCase()!==v}function i(c){const v=c.charAt(0);return v.toLocaleLowerCase()!==v}function u(c,v){return p(c)&&i(v)?-1:i(c)&&p(v)?1:0}function s(c,v){return i(c)&&p(v)?-1:p(c)&&i(v)?1:0}function o(c,v,D=!1){return D||(c=c&&c.toLowerCase(),v=v&&v.toLowerCase()),c===v?0:c<v?-1:1}function f(c,v,D=!1){const w=c.split(P.sep),H=v.split(P.sep),X=w.length-1,J=H.length-1;let G,U;for(let B=0;;B++){if(G=X===B,U=J===B,G&&U)return A(w[B],H[B],D);if(G)return-1;if(U)return 1;const $=o(w[B],H[B],D);if($!==0)return $}}e.comparePaths=f;function b(c,v,D){const w=c.toLowerCase(),H=v.toLowerCase(),X=r(c,v,D);if(X)return X;const J=w.endsWith(D),G=H.endsWith(D);if(J!==G)return J?-1:1;const U=A(w,H);return U!==0?U:w.localeCompare(H)}e.compareAnything=b;function r(c,v,D){const w=c.toLowerCase(),H=v.toLowerCase(),X=w.startsWith(D),J=H.startsWith(D);if(X!==J)return X?-1:1;if(X&&J){if(w.length<H.length)return-1;if(w.length>H.length)return 1}return 0}e.compareByPrefix=r}),define(Ae[66],Re([1,0,19]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const y=(0,n.extname)(O),h=P[y.toLowerCase()];return h!==void 0?h:R(O)}e.getMediaOrTextMime=M;function R(O){const y=(0,n.extname)(O);return k[y.toLowerCase()]}e.getMediaMime=R;function A(O){for(const y in k)if(k[y]===O)return y}e.getExtensionForMimeType=A;const I=/^(.+)\/(.+?)(;.+)?$/;function m(O,y){const h=I.exec(O);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:y?void 0:O}e.normalizeMimeType=m}),define(Ae[127],Re([1,0,4,6,122]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends P.Disposable{constructor(h,E="",g="",l=!0,t){super(),this.j=this.B(new n.Emitter),this.onDidChange=this.j.event,this.z=!0,this.m=h,this.n=E,this.w=g,this.z=l,this.D=t}get id(){return this.m}get label(){return this.n}set label(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.j.fire({label:h}))}get tooltip(){return this.u||""}set tooltip(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.j.fire({tooltip:h}))}get class(){return this.w}set class(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.j.fire({class:h}))}get enabled(){return this.z}set enabled(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.j.fire({enabled:h}))}get checked(){return this.C}set checked(h){this.J(h)}J(h){this.C!==h&&(this.C=h,this.j.fire({checked:h}))}async run(h,E){this.D&&await this.D(h)}}e.Action=M;class R extends P.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(h,E){if(!h.enabled)return;this.f.fire({action:h});let g;try{await this.k(h,E)}catch(l){g=l}this.h.fire({action:h,error:g})}async k(h,E){await h.run(E)}}e.ActionRunner=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let E=[];for(const g of h)g.length&&(E.length?E=[...E,new A,...g]:E=g);return E}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class I{get actions(){return this.a}constructor(h,E,g,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=E,this.class=l,this.a=g}async run(){}}e.SubmenuAction=I;class m extends M{constructor(){super(m.ID,k.localize(0,null),void 0,!1)}}m.ID="vs.actions.empty",e.EmptySubmenuAction=m;function O(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=O}),define(Ae[41],Re([1,0,19,20,13,10]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(b){return b===47||b===92}e.isPathSeparator=R;function A(b){return b.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function I(b){return b.indexOf("/")===-1&&(b=A(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.toPosixPath=I;function m(b,r=n.posix.sep){if(!b)return"";const c=b.length,v=b.charCodeAt(0);if(R(v)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let w=3;const H=w;for(;w<c&&!R(b.charCodeAt(w));w++);if(H!==w&&!R(b.charCodeAt(w+1))){for(w+=1;w<c;w++)if(R(b.charCodeAt(w)))return b.slice(0,w+1).replace(/[\\/]/g,r)}}return r}else if(a(v)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+r:b.slice(0,2);let D=b.indexOf("://");if(D!==-1){for(D+=3;D<c;D++)if(R(b.charCodeAt(D)))return b.slice(0,D+1)}return""}e.getRoot=m;function O(b){if(!P.isWindows||!b||b.length<5)return!1;let r=b.charCodeAt(0);if(r!==92||(r=b.charCodeAt(1),r!==92))return!1;let c=2;const v=c;for(;c<b.length&&(r=b.charCodeAt(c),r!==92);c++);return!(v===c||(r=b.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=O;const y=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(b,r=P.isWindows){const c=r?y:h;return!(!b||b.length===0||/^\s+$/.test(b)||(c.lastIndex=0,c.test(b))||r&&E.test(b)||b==="."||b===".."||r&&b[b.length-1]==="."||r&&b.length!==b.trim().length||b.length>255)}e.isValidBasename=g;function l(b,r,c){const v=b===r;return!c||v?v:!b||!r?!1:(0,k.equalsIgnoreCase)(b,r)}e.isEqual=l;function t(b,r,c,v=n.sep){if(b===r)return!0;if(!b||!r||r.length>b.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(b,r))return!1;if(r.length===b.length)return!0;let w=r.length;return r.charAt(r.length-1)===v&&w--,b.charAt(w)===v}return r.charAt(r.length-1)!==v&&(r+=v),b.indexOf(r)===0}e.isEqualOrParent=t;function a(b){return b>=65&&b<=90||b>=97&&b<=122}e.isWindowsDriveLetter=a;function d(b,r){return P.isWindows&&b.endsWith(":")&&(b+=n.sep),(0,n.isAbsolute)(b)||(b=(0,n.join)(r,b)),b=(0,n.normalize)(b),P.isWindows?(b=(0,k.rtrim)(b,n.sep),b.endsWith(":")&&(b+=n.sep)):(b=(0,k.rtrim)(b,n.sep),b||(b=n.sep)),b}e.sanitizeFilePath=d;function S(b){const r=(0,n.normalize)(b);return P.isWindows?b.length>3?!1:T(r)&&(b.length===2||r.charCodeAt(2)===92):r===n.posix.sep}e.isRootOrDriveLetter=S;function T(b,r=P.isWindows){return r?a(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.hasDriveLetter=T;function p(b){return T(b)?b[0]:void 0}e.getDriveLetter=p;function i(b,r,c){return r.length>b.length?-1:b===r?0:(c&&(b=b.toLowerCase(),r=r.toLowerCase()),b.indexOf(r))}e.indexOfPath=i;function u(b){const r=b.split(":");let c,v,D;for(const w of r){const H=Number(w);(0,M.isNumber)(H)?v===void 0?v=H:D===void 0&&(D=H):c=c?[c,w].join(":"):w}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:D!==void 0?D:v!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function f(b,r,c=8){let v="";for(let w=0;w<c;w++){let H;w===0&&P.isWindows&&!r&&(c===3||c===4)?H=o:H=s,v+=H.charAt(Math.floor(Math.random()*H.length))}let D;return r?D=`${r}-${v}`:D=v,b?(0,n.join)(b,D):D}e.randomPath=f}),define(Ae[128],Re([1,0,28,13]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(C,N){for(let V=0,q=Z.length;V<q;V++){const te=Z[V](C,N);if(te)return te}return null}}e.or=k,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,C,N){if(!N||N.length<C.length)return null;let V;return Z?V=P.startsWithIgnoreCase(N,C):V=N.indexOf(C)===0,V?C.length>0?[{start:0,end:C.length}]:[]:null}function R(Z,C){const N=C.toLowerCase().indexOf(Z.toLowerCase());return N===-1?null:[{start:N,end:N+Z.length}]}e.matchesContiguousSubString=R;function A(Z,C){return I(Z.toLowerCase(),C.toLowerCase(),0,0)}e.matchesSubString=A;function I(Z,C,N,V){if(N===Z.length)return[];if(V===C.length)return null;if(Z[N]===C[V]){let q=null;return(q=I(Z,C,N+1,V+1))?a({start:V,end:V+1},q):null}return I(Z,C,N,V+1)}function m(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function y(Z){return 48<=Z&&Z<=57}function h(Z){return Z===32||Z===9||Z===10||Z===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>E.add(Z.charCodeAt(0)));function g(Z){return h(Z)||E.has(Z)}function l(Z,C){return Z===C||g(Z)&&g(C)}function t(Z){return m(Z)||O(Z)||y(Z)}function a(Z,C){return C.length===0?C=[Z]:Z.end===C[0].start?C[0].start=Z.start:C.unshift(Z),C}function d(Z,C){for(let N=C;N<Z.length;N++){const V=Z.charCodeAt(N);if(O(V)||y(V)||N>0&&!t(Z.charCodeAt(N-1)))return N}return Z.length}function S(Z,C,N,V){if(N===Z.length)return[];if(V===C.length)return null;if(Z[N]!==C[V].toLowerCase())return null;{let q=null,te=V+1;for(q=S(Z,C,N+1,V+1);!q&&(te=d(C,te))<C.length;)q=S(Z,C,N+1,te),te++;return q===null?null:a({start:V,end:V+1},q)}}function T(Z){let C=0,N=0,V=0,q=0,te=0;for(let we=0;we<Z.length;we++)te=Z.charCodeAt(we),O(te)&&C++,m(te)&&N++,t(te)&&V++,y(te)&&q++;const ge=C/Z.length,Pe=N/Z.length,le=V/Z.length,De=q/Z.length;return{upperPercent:ge,lowerPercent:Pe,alphaPercent:le,numericPercent:De}}function p(Z){const{upperPercent:C,lowerPercent:N}=Z;return N===0&&C>.6}function i(Z){const{upperPercent:C,lowerPercent:N,alphaPercent:V,numericPercent:q}=Z;return N>.2&&C<.8&&V>.6&&q<.2}function u(Z){let C=0,N=0,V=0,q=0;for(let te=0;te<Z.length;te++)V=Z.charCodeAt(te),O(V)&&C++,m(V)&&N++,h(V)&&q++;return(C===0||N===0)&&q===0?Z.length<=30:C<=5}function s(Z,C){if(!C||(C=C.trim(),C.length===0)||!u(Z)||C.length>60)return null;const N=T(C);if(!i(N)){if(!p(N))return null;C=C.toLowerCase()}let V=null,q=0;for(Z=Z.toLowerCase();q<C.length&&(V=S(Z,C,0,q))===null;)q=d(C,q+1);return V}e.matchesCamelCase=s;function o(Z,C,N=!1){if(!C||C.length===0)return null;let V=null,q=0;for(Z=Z.toLowerCase(),C=C.toLowerCase();q<C.length&&(V=f(Z,C,0,q,N))===null;)q=b(C,q+1);return V}e.matchesWords=o;function f(Z,C,N,V,q){if(N===Z.length)return[];if(V===C.length)return null;if(l(Z.charCodeAt(N),C.charCodeAt(V))){let te=null,ge=V+1;if(te=f(Z,C,N+1,V+1,q),!q)for(;!te&&(ge=b(C,ge))<C.length;)te=f(Z,C,N+1,ge,q),ge++;return te?Z.charCodeAt(N)!==C.charCodeAt(V)?te:a({start:V,end:V+1},te):null}else return null}function b(Z,C){for(let N=C;N<Z.length;N++)if(g(Z.charCodeAt(N))||N>0&&g(Z.charCodeAt(N-1)))return N;return Z.length}const r=k(e.matchesPrefix,s,R),c=k(e.matchesPrefix,s,A),v=new n.LRUCache(1e4);function D(Z,C,N=!1){if(typeof Z!="string"||typeof C!="string")return null;let V=v.get(Z);V||(V=new RegExp(P.convertSimple2RegExpPattern(Z),"i"),v.set(Z,V));const q=V.exec(C);return q?[{start:q.index,end:q.index+q[0].length}]:N?c(Z,C):r(Z,C)}e.matchesFuzzy=D;function w(Z,C){const N=pe(Z,Z.toLowerCase(),0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?X(N):null}e.matchesFuzzy2=w;function H(Z,C,N,V,q,te){const ge=Math.min(13,Z.length);for(;N<ge;N++){const Pe=pe(Z,C,N,V,q,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,te]}e.anyScore=H;function X(Z){if(typeof Z>"u")return[];const C=[],N=Z[1];for(let V=Z.length-1;V>1;V--){const q=Z[V]+N,te=C[C.length-1];te&&te.end===q?te.end=q+1:C.push({start:q,end:q+1})}return C}e.createMatches=X;const J=128;function G(){const Z=[],C=[];for(let N=0;N<=J;N++)C[N]=0;for(let N=0;N<=J;N++)Z.push(C.slice(0));return Z}function U(Z){const C=[];for(let N=0;N<=Z;N++)C[N]=0;return C}const B=U(2*J),$=U(2*J),W=G(),x=G(),fe=G(),Se=!1;function ie(Z,C,N,V,q){function te(Pe,le,De=" "){for(;Pe.length<le;)Pe=De+Pe;return Pe}let ge=` |   |${V.split("").map(Pe=>te(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=N;Pe++)Pe===0?ge+=" |":ge+=`${C[Pe-1]}|`,ge+=Z[Pe].slice(0,q+1).map(le=>te(le.toString(),3)).join("|")+`
`;return ge}function ue(Z,C,N,V){Z=Z.substr(C),N=N.substr(V),console.log(ie(x,Z,Z.length,N,N.length)),console.log(ie(fe,Z,Z.length,N,N.length)),console.log(ie(W,Z,Z.length,N,N.length))}function ce(Z,C){if(C<0||C>=Z.length)return!1;const N=Z.codePointAt(C);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(N)}}function Te(Z,C){if(C<0||C>=Z.length)return!1;switch(Z.charCodeAt(C)){case 32:case 9:return!0;default:return!1}}function de(Z,C,N){return C[Z]!==N[Z]}function ae(Z,C,N,V,q,te,ge=!1){for(;C<N&&q<te;)Z[C]===V[q]&&(ge&&(B[C]=q),C+=1),q+=1;return C===N}e.isPatternInWord=ae;var j;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(j||(j={}));var F;(function(Z){Z.Default=[-100,0];function C(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}Z.isDefault=C})(F=e.FuzzyScore||(e.FuzzyScore={}));class Q{constructor(C,N){this.firstMatchCanBeWeak=C,this.boostFullMatch=N}}Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Q;function pe(Z,C,N,V,q,te,ge=Q.default){const Pe=Z.length>J?J:Z.length,le=V.length>J?J:V.length;if(N>=Pe||te>=le||Pe-N>le-te||!ae(C,N,Pe,q,te,le,!0))return;ke(Pe,le,N,te,C,q);let De=1,we=1,We=N,$e=te;const tt=[!1];for(De=1,We=N;We<Pe;De++,We++){const rt=B[We],Y=$[We],_=We+1<Pe?$[We+1]:le;for(we=rt-te+1,$e=rt;$e<_;we++,$e++){let be=Number.MIN_SAFE_INTEGER,He=!1;$e<=Y&&(be=Ee(Z,C,We,N,V,q,$e,le,te,W[De-1][we-1]===0,tt));let Be=0;be!==Number.MAX_SAFE_INTEGER&&(He=!0,Be=be+x[De-1][we-1]);const Qe=$e>rt,Ye=Qe?x[De][we-1]+(W[De][we-1]>0?-5:0):0,Ge=$e>rt+1&&W[De][we-1]>0,at=Ge?x[De][we-2]+(W[De][we-2]>0?-5:0):0;if(Ge&&(!Qe||at>=Ye)&&(!He||at>=Be))x[De][we]=at,fe[De][we]=3,W[De][we]=0;else if(Qe&&(!He||Ye>=Be))x[De][we]=Ye,fe[De][we]=2,W[De][we]=0;else if(He)x[De][we]=Be,fe[De][we]=1,W[De][we]=W[De-1][we-1]+1;else throw new Error("not possible")}}if(Se&&ue(Z,N,V,te),!tt[0]&&!ge.firstMatchCanBeWeak)return;De--,we--;const Xe=[x[De][we],te];let it=0,nt=0;for(;De>=1;){let rt=we;do{const Y=fe[De][rt];if(Y===3)rt=rt-2;else if(Y===2)rt=rt-1;else break}while(rt>=1);it>1&&C[N+De-1]===q[te+we-1]&&!de(rt+te-1,V,q)&&it+1>W[De][rt]&&(rt=we),rt===we?it++:it=1,nt||(nt=rt),De--,we=rt-1,Xe.push(we)}le===Pe&&ge.boostFullMatch&&(Xe[0]+=2);const Me=nt-Pe;return Xe[0]-=Me,Xe}e.fuzzyScore=pe;function ke(Z,C,N,V,q,te){let ge=Z-1,Pe=C-1;for(;ge>=N&&Pe>=V;)q[ge]===te[Pe]&&($[ge]=Pe,ge--),Pe--}function Ee(Z,C,N,V,q,te,ge,Pe,le,De,we){if(C[N]!==te[ge])return Number.MIN_SAFE_INTEGER;let We=1,$e=!1;return ge===N-V?We=Z[N]===q[ge]?7:5:de(ge,q,te)&&(ge===0||!de(ge-1,q,te))?(We=Z[N]===q[ge]?7:5,$e=!0):ce(te,ge)&&(ge===0||!ce(te,ge-1))?We=5:(ce(te,ge-1)||Te(te,ge-1))&&(We=5,$e=!0),We>1&&N===V&&(we[0]=!0),$e||($e=de(ge,q,te)||ce(te,ge-1)||Te(te,ge-1)),N===V?ge>le&&(We-=$e?3:5):De?We+=$e?2:0:We+=$e?0:1,ge+1===Pe&&(We-=$e?3:5),We}function ve(Z,C,N,V,q,te,ge){return se(Z,C,N,V,q,te,!0,ge)}e.fuzzyScoreGracefulAggressive=ve;function Ce(Z,C,N,V,q,te,ge){return se(Z,C,N,V,q,te,!1,ge)}e.fuzzyScoreGraceful=Ce;function se(Z,C,N,V,q,te,ge,Pe){let le=pe(Z,C,N,V,q,te,Pe);if(le&&!ge)return le;if(Z.length>=3){const De=Math.min(7,Z.length-1);for(let we=N+1;we<De;we++){const We=oe(Z,we);if(We){const $e=pe(We,We.toLowerCase(),N,V,q,te,Pe);$e&&($e[0]-=3,(!le||$e[0]>le[0])&&(le=$e))}}}return le}function oe(Z,C){if(C+1>=Z.length)return;const N=Z[C],V=Z[C+1];if(N!==V)return Z.slice(0,C)+V+N+Z.slice(C+2)}}),define(Ae[129],Re([1,0,128,13,39]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",R=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function I(a){return a.replace(A,(d,S)=>S?d:`\\${d}`)}e.escapeIcons=I;const m=new RegExp(`\\\\${R.source}`,"g");function O(a){return a.replace(m,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const y=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function h(a){return a.indexOf(M)===-1?a:a.replace(y,(d,S,T,p)=>T?d:S||p||"")}e.stripIcons=h;function E(a){return a?a.replace(/\$\((.*?)\)/g,(d,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=E;const g=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(a){g.lastIndex=0;let d="";const S=[];let T=0;for(;;){const p=g.lastIndex,i=g.exec(a),u=a.substring(p,i?.index);if(u.length>0){d+=u;for(let s=0;s<u.length;s++)S.push(T)}if(!i)break;T+=i[0].length}return{text:d,iconOffsets:S}}e.parseLabelWithIcons=l;function t(a,d,S=!1){const{text:T,iconOffsets:p}=d;if(!p||p.length===0)return(0,n.matchesFuzzy)(a,T,S);const i=(0,P.ltrim)(T," "),u=T.length-i.length,s=(0,n.matchesFuzzy)(a,i,S);if(s)for(const o of s){const f=p[o.start+u]+u;o.start+=f,o.end+=f}return s}e.matchesFuzzyIconAware=t}),define(Ae[29],Re([1,0,13]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(P||(P={})),function(k){const M="error",R="warning",A="warn",I="info",m="ignore";function O(h){return h?n.equalsIgnoreCase(M,h)?k.Error:n.equalsIgnoreCase(R,h)||n.equalsIgnoreCase(A,h)?k.Warning:n.equalsIgnoreCase(I,h)?k.Info:k.Ignore:k.Ignore}k.fromValue=O;function y(h){switch(h){case k.Error:return M;case k.Warning:return R;case k.Info:return I;default:return m}}k.toString=y}(P||(P={})),e.default=P}),define(Ae[48],Re([1,0,16,13]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const g=E.charCodeAt(0),l=this.b.charCodeAt(this.c);return g-l}value(){return this.b[this.c]}}e.StringIterator=k;class M{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,P.compareSubstring)(E,this.b,0,E.length,this.c,this.d):(0,P.compareSubstringIgnoreCase)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class R{constructor(E=!0,g=!0){this.f=E,this.g=g}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let g=E.length-1;g>=0;g--,this.c--){const l=this.b.charCodeAt(g);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,P.compareSubstring)(E,this.b,0,E.length,this.d,this.e):(0,P.compareSubstringIgnoreCase)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var A;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(A||(A={}));class I{constructor(E,g){this.f=E,this.g=g,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,P.compareIgnoreCase)(E,this.c.scheme);if(this.d[this.e]===2)return(0,P.compareIgnoreCase)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,P.compare)(E,this.c.query);if(this.d[this.e]===5)return(0,P.compare)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(O||(O={}));class y{static forUris(E=()=>!1,g=()=>!1){return new y(new I(E,g))}static forPaths(E=!1){return new y(new R(void 0,!E))}static forStrings(){return new y(new k)}static forConfigKeys(){return new y(new M)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,g){if(g){const l=g.slice(0);(0,n.shuffle)(l);for(const t of l)this.set(t,E)}else{const l=E.slice(0);(0,n.shuffle)(l);for(const t of l)this.set(t[0],t[1])}}set(E,g){const l=this.b.reset(E);let t;this.c||(this.c=new m,this.c.segment=l.value());const a=[];for(t=this.c;;){const S=l.cmp(t.segment);if(S>0)t.left||(t.left=new m,t.left.segment=l.value()),a.push([-1,t]),t=t.left;else if(S<0)t.right||(t.right=new m,t.right.segment=l.value()),a.push([1,t]),t=t.right;else if(l.hasNext())l.next(),t.mid||(t.mid=new m,t.mid.segment=l.value()),a.push([0,t]),t=t.mid;else break}const d=t.value;t.value=g,t.key=E;for(let S=a.length-1;S>=0;S--){const T=a[S][1];T.updateHeight();const p=T.balanceFactor();if(p<-1||p>1){const i=a[S][0],u=a[S+1][0];if(i===1&&u===1)a[S][1]=T.rotateLeft();else if(i===-1&&u===-1)a[S][1]=T.rotateRight();else if(i===1&&u===-1)T.right=a[S+1][1]=a[S+1][1].rotateRight(),a[S][1]=T.rotateLeft();else if(i===-1&&u===1)T.left=a[S+1][1]=a[S+1][1].rotateLeft(),a[S][1]=T.rotateRight();else throw new Error;if(S>0)switch(a[S-1][0]){case-1:a[S-1][1].left=a[S][1];break;case 1:a[S-1][1].right=a[S][1];break;case 0:a[S-1][1].mid=a[S][1];break}else this.c=a[0][1]}}return d}get(E){return this.d(E)?.value}d(E){const g=this.b.reset(E);let l=this.c;for(;l;){const t=g.cmp(l.segment);if(t>0)l=l.left;else if(t<0)l=l.right;else if(g.hasNext())g.next(),l=l.mid;else break}return l}has(E){const g=this.d(E);return!(g?.value===void 0&&g?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,g){const l=this.b.reset(E),t=[];let a=this.c;for(;a;){const d=l.cmp(a.segment);if(d>0)t.push([-1,a]),a=a.left;else if(d<0)t.push([1,a]),a=a.right;else if(l.hasNext())l.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(g?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const d=this.f(a.right);if(d.key){const{key:S,value:T,segment:p}=d;this.e(d.key,!1),a.key=S,a.value=T,a.segment=p}}else{const d=a.left??a.right;if(t.length>0){const[S,T]=t[t.length-1];switch(S){case-1:T.left=d;break;case 0:T.mid=d;break;case 1:T.right=d;break}}else this.c=d}for(let d=t.length-1;d>=0;d--){const S=t[d][1];S.updateHeight();const T=S.balanceFactor();if(T>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),t[d][1]=S.rotateLeft()):T<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),t[d][1]=S.rotateRight()),d>0)switch(t[d-1][0]){case-1:t[d-1][1].left=t[d][1];break;case 1:t[d-1][1].right=t[d][1];break;case 0:t[d-1][1].mid=t[d][1];break}else this.c=t[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const g=this.b.reset(E);let l=this.c,t;for(;l;){const a=g.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(g.hasNext())g.next(),t=l.value||t,l=l.mid;else break}return l&&l.value||t}findSuperstr(E){return this.g(E,!1)}g(E,g){const l=this.b.reset(E);let t=this.c;for(;t;){const a=l.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(l.hasNext())l.next(),t=t.mid;else return t.mid?this.h(t.mid):g?t.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[g,l]of this)E(l,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const g=[];return this.j(E,g),g[Symbol.iterator]()}j(E,g){!E||(E.left&&this.j(E.left,g),E.value&&g.push([E.key,E.value]),E.mid&&this.j(E.mid,g),E.right&&this.j(E.right,g))}_isBalanced(){const E=g=>{if(!g)return!0;const l=g.balanceFactor();return l<-1||l>1?!1:E(g.left)&&E(g.right)};return E(this.c)}}e.TernarySearchTree=y}),define(Ae[67],Re([1,0,25,13,2]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(m){return JSON.stringify(m,A)}e.stringify=M;function R(m){let O=JSON.parse(m);return O=I(O),O}e.parse=R;function A(m,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,P.regExpFlags)(O)}:O}function I(m,O=0){if(!m||O>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof n.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=I(m[y],O+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=I(m[y],O+1))}return m}e.revive=I}),define(Ae[15],Re([1,0,9,20,2]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${M.vscodeRemoteResource}`}set(O,y,h){this.a[O]=y,this.b[O]=h}setConnectionToken(O,y){this.c[O]=y}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(t){return n.onUnexpectedError(t),O}const y=O.authority;let h=this.a[y];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const E=this.b[y],g=this.c[y];let l=`path=${encodeURIComponent(O.path)}`;return typeof g=="string"&&(l+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),k.URI.from({scheme:P.isWeb?this.d:M.vscodeRemoteResource,authority:`${h}:${E}`,path:this.f,query:l})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const y=this.b(O,ee);return this.uriToBrowserUri(y)}uriToBrowserUri(O){return O.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===M.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${M.vscodeFileResource}://${A.a}`)?O.with({scheme:M.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const y=this.b(O,ee);return this.uriToFileUri(y)}uriToFileUri(O){return O.scheme===M.vscodeFileResource?O.with({scheme:M.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,y){return k.URI.isUri(O)?O:k.URI.parse(y.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var I;(function(m){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(O.get("3"));const y="vscode-coi";function h(g){let l;typeof g=="string"?l=new URL(g).searchParams:g instanceof URL?l=g.searchParams:k.URI.isUri(g)&&(l=new URL(g.toString(!0)).searchParams);const t=l?.get(y);if(!!t)return O.get(t)}m.getHeadersFromQuery=h;function E(g,l,t){if(!globalThis.crossOriginIsolated)return;const a=l&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(y,a):g[y]=a}m.addSearchParam=E})(I=e.COI||(e.COI={}))}),define(Ae[22],Re([1,0,41,15,19,20,13,2]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=I;class m{constructor(g){this.a=g}compare(g,l,t=!1){return g===l?0:(0,R.compare)(this.getComparisonKey(g,t),this.getComparisonKey(l,t))}isEqual(g,l,t=!1){return g===l?!0:!g||!l?!1:this.getComparisonKey(g,t)===this.getComparisonKey(l,t)}getComparisonKey(g,l=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,l,t=!1){if(g.scheme===l.scheme){if(g.scheme===P.Schemas.file)return n.isEqualOrParent(I(g),I(l),this.a(g))&&g.query===l.query&&(t||g.fragment===l.fragment);if((0,e.isEqualAuthority)(g.authority,l.authority))return n.isEqualOrParent(g.path,l.path,this.a(g),"/")&&g.query===l.query&&(t||g.fragment===l.fragment)}return!1}joinPath(g,...l){return A.URI.joinPath(g,...l)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return k.posix.basename(g.path)}extname(g){return k.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let l;return g.scheme===P.Schemas.file?l=A.URI.file(k.dirname(I(g))).path:(l=k.posix.dirname(g.path),g.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),l="/")),g.with({path:l})}normalizePath(g){if(!g.path.length)return g;let l;return g.scheme===P.Schemas.file?l=A.URI.file(k.normalize(I(g))).path:l=k.posix.normalize(g.path),g.with({path:l})}relativePath(g,l){if(g.scheme!==l.scheme||!(0,e.isEqualAuthority)(g.authority,l.authority))return;if(g.scheme===P.Schemas.file){const d=k.relative(I(g),I(l));return M.isWindows?n.toSlashes(d):d}let t=g.path||"/";const a=l.path||"/";if(this.a(g)){let d=0;for(const S=Math.min(t.length,a.length);d<S&&!(t.charCodeAt(d)!==a.charCodeAt(d)&&t.charAt(d).toLowerCase()!==a.charAt(d).toLowerCase());d++);t=a.substr(0,d)+t.substr(d)}return k.posix.relative(t,a)}resolvePath(g,l){if(g.scheme===P.Schemas.file){const t=A.URI.file(k.resolve(I(g),l));return g.with({authority:t.authority,path:t.path})}return l=n.toPosixPath(l),g.with({path:k.posix.resolve(g.path,l)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,l){return g===l||g!==void 0&&l!==void 0&&(0,R.equalsIgnoreCase)(g,l)}hasTrailingPathSeparator(g,l=k.sep){if(g.scheme===P.Schemas.file){const t=I(g);return t.length>n.getRoot(t).length&&t[t.length-1]===l}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,l=k.sep){return(0,e.hasTrailingPathSeparator)(g,l)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,l=k.sep){let t=!1;if(g.scheme===P.Schemas.file){const a=I(g);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===l}else{l="/";const a=g.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,l)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(E=>E.scheme===P.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(E,g){const l=[];for(let t=0;t<E.length;t++){const a=g(E[t]);E.some((d,S)=>S===t?!1:(0,e.isEqualOrParent)(a,g(d)))||l.push(E[t])}return l}e.distinctParents=O;var y;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function g(l){const t=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(S=>{const[T,p]=S.split(":");T&&p&&t.set(T,p)});const d=l.path.substring(0,l.path.indexOf(";"));return d&&t.set(E.META_DATA_MIME,d),t}E.parseMetaData=g})(y=e.DataUri||(e.DataUri={}));function h(E,g,l){if(g){let t=E.path;return t&&t[0]!==k.posix.sep&&(t=k.posix.sep+t),E.with({scheme:l,authority:g,path:t})}return E.with({scheme:l})}e.toLocalResource=h}),define(Ae[17],Re([1,0,21,9,4,6,22,20,117]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=m;function O(ae){const j=new n.CancellationTokenSource,F=ae(j.token),Q=new Promise((pe,ke)=>{const Ee=j.token.onCancellationRequested(()=>{Ee.dispose(),j.dispose(),ke(new P.CancellationError)});Promise.resolve(F).then(ve=>{Ee.dispose(),j.dispose(),pe(ve)},ve=>{Ee.dispose(),j.dispose(),ke(ve)})});return new class{cancel(){j.cancel()}then(pe,ke){return Q.then(pe,ke)}catch(pe){return this.then(void 0,pe)}finally(pe){return Q.finally(pe)}}}e.createCancelablePromise=O;function y(ae,j,F){return new Promise((Q,pe)=>{const ke=j.onCancellationRequested(()=>{ke.dispose(),Q(F)});ae.then(Q,pe).finally(()=>ke.dispose())})}e.raceCancellation=y;function h(ae,j){return new Promise((F,Q)=>{const pe=j.onCancellationRequested(()=>{pe.dispose(),Q(new P.CancellationError)});ae.then(F,Q).finally(()=>pe.dispose())})}e.raceCancellationError=h;async function E(ae){let j=-1;const F=ae.map((pe,ke)=>pe.then(Ee=>(j=ke,Ee))),Q=await Promise.race(F);return ae.forEach((pe,ke)=>{ke!==j&&pe.cancel()}),Q}e.raceCancellablePromises=E;function g(ae,j,F){let Q;const pe=setTimeout(()=>{Q?.(void 0),F?.()},j);return Promise.race([ae.finally(()=>clearTimeout(pe)),new Promise(ke=>Q=ke)])}e.raceTimeout=g;function l(ae){return new Promise((j,F)=>{const Q=ae();m(Q)?Q.then(j,F):j(Q)})}e.asPromise=l;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(j){if(this.a){if(this.d=j,!this.b){const F=()=>{this.b=null;const Q=this.queue(this.d);return this.d=null,Q};this.b=new Promise(Q=>{this.a.then(F,F).then(Q)})}return new Promise((F,Q)=>{this.b.then(F,Q)})}return this.a=j(),new Promise((F,Q)=>{this.a.then(pe=>{this.a=null,F(pe)},pe=>{this.a=null,Q(pe)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.Sequencer=a;class d{constructor(){this.a=new Map}queue(j,F){const pe=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(j)===pe&&this.a.delete(j)});return this.a.set(j,pe),pe}}e.SequencerByKey=d;const S=(ae,j)=>{let F=!0;const Q=setTimeout(()=>{F=!1,j()},ae);return{isTriggered:()=>F,dispose:()=>{clearTimeout(Q),F=!1}}},T=ae=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,ae())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class p{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,F=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((pe,ke)=>{this.d=pe,this.f=ke}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const Q=()=>{this.a=null,this.d?.(null)};return this.a=F===I.MicrotaskDelay?T(Q):S(F,Q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(j){this.a=new p(j),this.b=new t}trigger(j,F){return this.a.trigger(()=>this.b.queue(j),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class u{constructor(){this.a=!1,this.b=new Promise((j,F)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=u;class s extends u{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function o(ae,j){return j?new Promise((F,Q)=>{const pe=setTimeout(()=>{ke.dispose(),F()},ae),ke=j.onCancellationRequested(()=>{clearTimeout(pe),ke.dispose(),Q(new P.CancellationError)})}):O(F=>o(ae,F))}e.timeout=o;function f(ae,j=0){const F=setTimeout(ae,j);return(0,M.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=f;function b(ae){const j=[];let F=0;const Q=ae.length;function pe(){return F<Q?ae[F++]():null}function ke(Ee){Ee!=null&&j.push(Ee);const ve=pe();return ve?ve.then(ke):Promise.resolve(j)}return Promise.resolve(null).then(ke)}e.sequence=b;function r(ae,j=Q=>!!Q,F=null){let Q=0;const pe=ae.length,ke=()=>{if(Q>=pe)return Promise.resolve(F);const Ee=ae[Q++];return Promise.resolve(Ee()).then(Ce=>j(Ce)?Promise.resolve(Ce):ke())};return ke()}e.first=r;function c(ae,j=Q=>!!Q,F=null){if(ae.length===0)return Promise.resolve(F);let Q=ae.length;const pe=()=>{Q=-1;for(const ke of ae)ke.cancel?.()};return new Promise((ke,Ee)=>{for(const ve of ae)ve.then(Ce=>{--Q>=0&&j(Ce)?(pe(),ke(Ce)):Q===0&&ke(F)}).catch(Ce=>{--Q>=0&&(pe(),Ee(Ce))})})}e.firstParallel=c;class v{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((F,Q)=>{this.f.push({factory:j,c:F,e:Q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const F=j.factory();F.then(j.c,j.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=v;class D extends v{constructor(){super(1)}}e.Queue=D;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new Se;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,F=R.extUri){const Q=F.getComparisonKey(j);let pe=this.a.get(Q);return pe||(pe=new D,k.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(Q),this.f()}),this.a.set(Q,pe)),pe}f(){!this.d()||this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class H{constructor(j,F){this.a=-1,typeof j=="function"&&typeof F=="number"&&this.setIfNotSet(j,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},F)}setIfNotSet(j,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},F))}}e.TimeoutTimer=H;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,F){this.cancel(),this.a=setInterval(()=>{j()},F)}}e.IntervalTimer=X;class J{constructor(j,F){this.b=-1,this.a=j,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=J;class G{constructor(j,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=j,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class U extends J{constructor(j,F){super(j,F),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=U;class B extends M.Disposable{constructor(j,F){super(),this.g=j,this.h=F,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of j)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,A.setTimeout0)(()=>{if(j)return;const F=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(ae,j)=>{const F=requestIdleCallback(ae,typeof j=="number"?{timeout:j}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(F))}}}}();class ${constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function W(ae,j,F){let Q;for(let pe=0;pe<F;pe++)try{return await ae()}catch(ke){Q=ke,await o(j)}throw Q}e.retry=W;class x{hasPending(j){return this.a?typeof j=="number"?this.a.taskId===j:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(j,F,Q){return this.a={taskId:j,cancel:()=>Q?.(),promise:F},F.then(()=>this.d(j),()=>this.d(j)),F}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this.b)this.b.run=j;else{let F,Q;const pe=new Promise((ke,Ee)=>{F=ke,Q=Ee});this.b={run:j,promise:pe,promiseResolve:F,promiseReject:Q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=x;class fe{constructor(j,F=()=>Date.now()){this.d=j,this.f=F,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.IntervalCounter=fe;class Se{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((j,F)=>{this.a=j,this.b=F})}complete(j){return new Promise(F=>{this.a(j),this.f=!0,F()})}error(j){return new Promise(F=>{this.b(j),this.d=!0,F()})}cancel(){new Promise(j=>{this.b(new P.CancellationError),this.d=!0,j()})}}e.DeferredPromise=Se;var ie;(function(ae){async function j(Q){let pe;const ke=await Promise.all(Q.map(Ee=>Ee.then(ve=>ve,ve=>{pe||(pe=ve)})));if(typeof pe<"u")throw pe;return ke}ae.settled=j;function F(Q){return new Promise(async(pe,ke)=>{try{await Q(pe,ke)}catch(Ee){ke(Ee)}})}ae.withAsyncBody=F})(ie=e.Promises||(e.Promises={}));var ue;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(ue||(ue={}));class ce{static fromArray(j){return new ce(F=>{F.emitMany(j)})}static fromPromise(j){return new ce(async F=>{F.emitMany(await j)})}static fromPromises(j){return new ce(async F=>{await Promise.all(j.map(async Q=>F.emitOne(await Q)))})}static merge(j){return new ce(async F=>{await Promise.all(j.map(async Q=>{for await(const pe of Q)F.emitOne(pe)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const F={emitOne:Q=>this.g(Q),emitMany:Q=>this.h(Q),reject:Q=>this.k(Q)};try{await Promise.resolve(j(F)),this.j()}catch(Q){this.k(Q)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(j,F){return new ce(async Q=>{for await(const pe of j)Q.emitOne(F(pe))})}map(j){return ce.map(this,j)}static filter(j,F){return new ce(async Q=>{for await(const pe of j)F(pe)&&Q.emitOne(pe)})}filter(j){return ce.filter(this,j)}static coalesce(j){return ce.filter(j,F=>!!F)}coalesce(){return ce.coalesce(this)}static async toPromise(j){const F=[];for await(const Q of j)F.push(Q);return F}toPromise(){return ce.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}ce.EMPTY=ce.fromArray([]),e.AsyncIterableObject=ce;class Te extends ce{constructor(j,F){super(F),this.l=j}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Te;function de(ae){const j=new n.CancellationTokenSource,F=ae(j.token);return new Te(j,async Q=>{const pe=j.token.onCancellationRequested(()=>{pe.dispose(),j.dispose(),Q.reject(new P.CancellationError)});try{for await(const ke of F){if(j.token.isCancellationRequested)return;Q.emitOne(ke)}pe.dispose(),j.dispose()}catch(ke){pe.dispose(),j.dispose(),Q.reject(ke)}})}e.createCancelableAsyncIterable=de}),define(Ae[36],Re([1,0,16,17,41,28,19,20,13]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",y="[^/\\\\]",h=/\//g;function E(fe,Se){switch(fe){case 0:return"";case 1:return`${y}*?`;default:return`(?:${O}|${y}+${O}${Se?`|${O}${y}+`:""})*?`}}function g(fe,Se){if(!fe)return[];const ie=[];let ue=!1,ce=!1,Te="";for(const de of fe){switch(de){case Se:if(!ue&&!ce){ie.push(Te),Te="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}Te+=de}return Te&&ie.push(Te),ie}e.splitGlobAware=g;function l(fe){if(!fe)return"";let Se="";const ie=g(fe,e.GLOB_SPLIT);if(ie.every(ue=>ue===e.GLOBSTAR))Se=".*";else{let ue=!1;ie.forEach((ce,Te)=>{if(ce===e.GLOBSTAR){if(ue)return;Se+=E(2,Te===ie.length-1)}else{let de=!1,ae="",j=!1,F="";for(const Q of ce){if(Q!=="}"&&de){ae+=Q;continue}if(j&&(Q!=="]"||!F)){let pe;Q==="-"?pe=Q:(Q==="^"||Q==="!")&&!F?pe="^":Q===e.GLOB_SPLIT?pe="":pe=(0,I.escapeRegExpCharacters)(Q),F+=pe;continue}switch(Q){case"{":de=!0;continue;case"[":j=!0;continue;case"}":{Se+=`(?:${g(ae,",").map(Ee=>l(Ee)).join("|")})`,de=!1,ae="";break}case"]":{Se+="["+F+"]",j=!1,F="";break}case"?":Se+=y;continue;case"*":Se+=E(1);continue;default:Se+=(0,I.escapeRegExpCharacters)(Q)}}Te<ie.length-1&&(ie[Te+1]!==e.GLOBSTAR||Te+2<ie.length)&&(Se+=O)}ue=ce===e.GLOBSTAR})}return Se}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,T=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),u=function(){return!1},s=function(){return null};function o(fe,Se){if(!fe)return s;let ie;typeof fe!="string"?ie=fe.pattern:ie=fe,ie=ie.trim();const ue=`${ie}_${!!Se.trimForExclusions}`;let ce=i.get(ue);if(ce)return f(ce,fe);let Te;return t.test(ie)?ce=r(ie.substr(4),ie):(Te=a.exec(b(ie,Se)))?ce=c(Te[1],ie):(Se.trimForExclusions?S:d).test(ie)?ce=v(ie,Se):(Te=T.exec(b(ie,Se)))?ce=D(Te[1].substr(1),ie,!0):(Te=p.exec(b(ie,Se)))?ce=D(Te[1],ie,!1):ce=w(ie),i.set(ue,ce),f(ce,fe)}function f(fe,Se){if(typeof Se=="string")return fe;const ie=function(ue,ce){return(0,k.isEqualOrParent)(ue,Se.base,!A.isLinux)?fe((0,I.ltrim)(ue.substr(Se.base.length),R.sep),ce):null};return ie.allBasenames=fe.allBasenames,ie.allPaths=fe.allPaths,ie.basenames=fe.basenames,ie.patterns=fe.patterns,ie}function b(fe,Se){return Se.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function r(fe,Se){return function(ie,ue){return typeof ie=="string"&&ie.endsWith(fe)?Se:null}}function c(fe,Se){const ie=`/${fe}`,ue=`\\${fe}`,ce=function(de,ae){return typeof de!="string"?null:ae?ae===fe?Se:null:de===fe||de.endsWith(ie)||de.endsWith(ue)?Se:null},Te=[fe];return ce.basenames=Te,ce.patterns=[Se],ce.allBasenames=Te,ce}function v(fe,Se){const ie=W(fe.slice(1,-1).split(",").map(ae=>o(ae,Se)).filter(ae=>ae!==s),fe),ue=ie.length;if(!ue)return s;if(ue===1)return ie[0];const ce=function(ae,j){for(let F=0,Q=ie.length;F<Q;F++)if(ie[F](ae,j))return fe;return null},Te=ie.find(ae=>!!ae.allBasenames);Te&&(ce.allBasenames=Te.allBasenames);const de=ie.reduce((ae,j)=>j.allPaths?ae.concat(j.allPaths):ae,[]);return de.length&&(ce.allPaths=de),ce}function D(fe,Se,ie){const ue=R.sep===R.posix.sep,ce=ue?fe:fe.replace(h,R.sep),Te=R.sep+ce,de=R.posix.sep+fe;let ae;return ie?ae=function(j,F){return typeof j=="string"&&(j===ce||j.endsWith(Te)||!ue&&(j===fe||j.endsWith(de)))?Se:null}:ae=function(j,F){return typeof j=="string"&&(j===ce||!ue&&j===fe)?Se:null},ae.allPaths=[(ie?"*/":"./")+fe],ae}function w(fe){try{const Se=new RegExp(`^${l(fe)}$`);return function(ie){return Se.lastIndex=0,typeof ie=="string"&&Se.test(ie)?fe:null}}catch{return s}}function H(fe,Se,ie){return!fe||typeof Se!="string"?!1:X(fe)(Se,void 0,ie)}e.match=H;function X(fe,Se={}){if(!fe)return u;if(typeof fe=="string"||J(fe)){const ie=o(fe,Se);if(ie===s)return u;const ue=function(ce,Te){return!!ie(ce,Te)};return ie.allBasenames&&(ue.allBasenames=ie.allBasenames),ie.allPaths&&(ue.allPaths=ie.allPaths),ue}return B(fe,Se)}e.parse=X;function J(fe){const Se=fe;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}e.isRelativePattern=J;function G(fe){return fe.allBasenames||[]}e.getBasenameTerms=G;function U(fe){return fe.allPaths||[]}e.getPathTerms=U;function B(fe,Se){const ie=W(Object.getOwnPropertyNames(fe).map(ae=>$(ae,fe[ae],Se)).filter(ae=>ae!==s)),ue=ie.length;if(!ue)return s;if(!ie.some(ae=>!!ae.requiresSiblings)){if(ue===1)return ie[0];const ae=function(Q,pe){let ke;for(let Ee=0,ve=ie.length;Ee<ve;Ee++){const Ce=ie[Ee](Q,pe);if(typeof Ce=="string")return Ce;(0,P.isThenable)(Ce)&&(ke||(ke=[]),ke.push(Ce))}return ke?(async()=>{for(const Ee of ke){const ve=await Ee;if(typeof ve=="string")return ve}return null})():null},j=ie.find(Q=>!!Q.allBasenames);j&&(ae.allBasenames=j.allBasenames);const F=ie.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return F.length&&(ae.allPaths=F),ae}const ce=function(ae,j,F){let Q,pe;for(let ke=0,Ee=ie.length;ke<Ee;ke++){const ve=ie[ke];ve.requiresSiblings&&F&&(j||(j=(0,R.basename)(ae)),Q||(Q=j.substr(0,j.length-(0,R.extname)(ae).length)));const Ce=ve(ae,j,Q,F);if(typeof Ce=="string")return Ce;(0,P.isThenable)(Ce)&&(pe||(pe=[]),pe.push(Ce))}return pe?(async()=>{for(const ke of pe){const Ee=await ke;if(typeof Ee=="string")return Ee}return null})():null},Te=ie.find(ae=>!!ae.allBasenames);Te&&(ce.allBasenames=Te.allBasenames);const de=ie.reduce((ae,j)=>j.allPaths?ae.concat(j.allPaths):ae,[]);return de.length&&(ce.allPaths=de),ce}function $(fe,Se,ie){if(Se===!1)return s;const ue=o(fe,ie);if(ue===s)return s;if(typeof Se=="boolean")return ue;if(Se){const ce=Se.when;if(typeof ce=="string"){const Te=(de,ae,j,F)=>{if(!F||!ue(de,ae))return null;const Q=ce.replace("$(basename)",()=>j),pe=F(Q);return(0,P.isThenable)(pe)?pe.then(ke=>ke?fe:null):pe?fe:null};return Te.requiresSiblings=!0,Te}}return ue}function W(fe,Se){const ie=fe.filter(ae=>!!ae.basenames);if(ie.length<2)return fe;const ue=ie.reduce((ae,j)=>{const F=j.basenames;return F?ae.concat(F):ae},[]);let ce;if(Se){ce=[];for(let ae=0,j=ue.length;ae<j;ae++)ce.push(Se)}else ce=ie.reduce((ae,j)=>{const F=j.patterns;return F?ae.concat(F):ae},[]);const Te=function(ae,j){if(typeof ae!="string")return null;if(!j){let Q;for(Q=ae.length;Q>0;Q--){const pe=ae.charCodeAt(Q-1);if(pe===47||pe===92)break}j=ae.substr(Q)}const F=ue.indexOf(j);return F!==-1?ce[F]:null};Te.basenames=ue,Te.patterns=ce,Te.allBasenames=ue;const de=fe.filter(ae=>!ae.basenames);return de.push(Te),de}function x(fe,Se){return(0,n.equals)(fe,Se,(ie,ue)=>typeof ie=="string"&&typeof ue=="string"?ie===ue:typeof ie!="string"&&typeof ue!="string"?ie.base===ue.base&&ie.pattern===ue.pattern:!1)}e.patternsEquals=x}),define(Ae[87],Re([1,0,9,129,22,13,2]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class I{constructor(a="",d=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(a,d=0){return this.value+=h(this.supportThemeIcons?(0,P.escapeIcons)(a):a).replace(/([ \t]+)/g,(S,T)=>"&nbsp;".repeat(T.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,d){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(a,d,S){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(a),")"),S&&(this.value+=` "${this.c(this.c(S,'"'),")")}"`),this.value+=")",this}c(a,d){const S=new RegExp((0,M.escapeRegExpCharacters)(d),"g");return a.replace(S,(T,p)=>a.charAt(p-1)!=="\\"?`\\${T}`:T)}}e.MarkdownString=I;function m(t){return O(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.isEmptyMarkdownString=m;function O(t){return t instanceof I?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function y(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,k.isEqual)(R.URI.from(t.baseUri),R.URI.from(a.baseUri)))}e.markdownStringEqual=y;function h(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function E(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function l(t){const a=[],d=t.split("|").map(T=>T.trim());t=d[0];const S=d[1];if(S){const T=/height=(\d+)/.exec(S),p=/width=(\d+)/.exec(S),i=T?T[1]:"",u=p?p[1]:"",s=isFinite(parseInt(u)),o=isFinite(parseInt(i));s&&a.push(`width="${u}"`),o&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=l}),define(Ae[88],Re([1,0,16,41,19,20,22,13]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function I(s,o){const{os:f,tildify:b,relative:r}=o;if(r){const D=m(s,r,f);if(typeof D=="string")return D}let c=s.fsPath;if(f===1&&!M.isWindows?c=c.replace(/\//g,"\\"):f!==1&&M.isWindows&&(c=c.replace(/\\/g,"/")),f!==1&&b?.userHome){const D=b.userHome.fsPath;let w;s.scheme!==b.userHome.scheme&&s.path.startsWith(k.posix.sep)?w=b.userHome.with({path:s.path}).fsPath:w=s.fsPath,c=h(w,D,f)}return(f===1?k.win32:k.posix).normalize(O(c,f===1))}e.getPathLabel=I;function m(s,o,f){const b=f===1?k.win32:k.posix,r=f===3?R.extUri:R.extUriIgnorePathCase,c=o.getWorkspace(),v=(0,n.firstOrDefault)(c.folders);if(!v)return;s.scheme!==v.uri.scheme&&s.path.startsWith(k.posix.sep)&&(s=v.uri.with({path:s.path}));const D=o.getWorkspaceFolder(s);if(!D)return;let w;if(r.isEqual(D.uri,s)?w="":w=r.relativePath(D.uri,s)??"",w&&(w=b.normalize(w)),c.folders.length>1&&!o.noPrefix){const H=D.name?D.name:r.basenameOrAuthority(D.uri);w=w?`${H} \u2022 ${w}`:H}return w}function O(s,o=M.isWindows){return(0,P.hasDriveLetter)(s,o)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=O;let y=Object.create(null);function h(s,o,f=M.OS){if(f===1||!s||!o)return s;let b=y.original===o?y.normalized:void 0;b||(b=o,M.isWindows&&(b=(0,P.toSlashes)(b)),b=`${(0,A.rtrim)(b,k.posix.sep)}${k.posix.sep}`,y={original:o,normalized:b});let r=s;return M.isWindows&&(r=(0,P.toSlashes)(r)),(f===3?r.startsWith(b):(0,A.startsWithIgnoreCase)(r,b))?`~/${r.substr(b.length)}`:s}e.tildify=h;function E(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=E;const g="\u2026",l="\\\\",t="~";function a(s,o=k.sep){const f=new Array(s.length);let b=!1;for(let r=0;r<s.length;r++){const c=s[r];if(c===""){f[r]=`.${o}`;continue}if(!c){f[r]=c;continue}b=!0;let v="",D=c;D.indexOf(l)===0?(v=D.substr(0,D.indexOf(l)+l.length),D=D.substr(D.indexOf(l)+l.length)):D.indexOf(o)===0?(v=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length)):D.indexOf(t)===0&&(v=D.substr(0,D.indexOf(t)+t.length),D=D.substr(D.indexOf(t)+t.length));const w=D.split(o);for(let H=1;b&&H<=w.length;H++)for(let X=w.length-H;b&&X>=0;X--){b=!1;let J=w.slice(X,X+H).join(o);for(let G=0;!b&&G<s.length;G++)if(G!==r&&s[G]&&s[G].indexOf(J)>-1){const U=X+H===w.length,B=X>0&&s[G].indexOf(o)>-1?o+J:J,$=s[G].endsWith(B);b=!U||$}if(!b){let G="";(w[0].endsWith(":")||v!=="")&&(X===1&&(X=0,H++,J=w[0]+o+J),X>0&&(G=w[0]+o),G=v+G),X>0&&(G=G+g+o),G=G+J,X+H<w.length&&(G=G+o+g),f[r]=G}}b&&(f[r]=c)}return f}e.shorten=a;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function S(s,o=Object.create(null)){const f=[];let b=!1,r="";for(const c of s)if(c==="$"||b&&c==="{")r&&f.push({value:r,type:d.TEXT}),r="",b=!0;else if(c==="}"&&b){const v=o[r];if(typeof v=="string")v.length&&f.push({value:v,type:d.VARIABLE});else if(v){const D=f[f.length-1];(!D||D.type!==d.SEPARATOR)&&f.push({value:v.label,type:d.SEPARATOR})}r="",b=!1}else r+=c;return r&&!b&&f.push({value:r,type:d.TEXT}),f.filter((c,v)=>{if(c.type===d.SEPARATOR){const D=f[v-1],w=f[v+1];return[D,w].every(H=>H&&(H.type===d.VARIABLE||H.type===d.TEXT)&&H.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=S;function T(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=T;function p(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,f=>f==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(s){const o=s.indexOf("/")!==-1?k.posix:k.win32,f=o.basename(s),b=o.dirname(s);return f.length?{name:f,parentPath:b}:{name:b,parentPath:""}}e.splitName=u}),define(Ae[130],Re([1,0,25,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(y){return y.toJSON()}class M{constructor(h){this.a=h}transformIncoming(h){const E=this.a.transformIncoming(h);return E===h?h:k(P.URI.from(E))}transformOutgoing(h){const E=this.a.transformOutgoing(h);return E===h?h:k(P.URI.from(E))}transformOutgoingURI(h){const E=this.a.transformOutgoing(h);return E===h?h:P.URI.from(E)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function R(y,h,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof P.URI)return h.transformOutgoing(y);for(const g in y)if(Object.hasOwnProperty.call(y,g)){const l=R(y[g],h,E+1);l!==null&&(y[g]=l)}}return null}function A(y,h){const E=R(y,h,0);return E===null?y:E}e.transformOutgoingURIs=A;function I(y,h,E,g){if(!y||g>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?P.URI.revive(h.transformIncoming(y)):h.transformIncoming(y);if(y instanceof n.VSBuffer)return null;for(const l in y)if(Object.hasOwnProperty.call(y,l)){const t=I(y[l],h,E,g+1);t!==null&&(y[l]=t)}}return null}function m(y,h){const E=I(y,h,!1,0);return E===null?y:E}e.transformIncomingURIs=m;function O(y,h){const E=I(y,h,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=O}),define(Ae[131],Re([1,0,36,19]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(M,R,A,I,m,O){if(Array.isArray(M)){let y=0;for(const h of M){const E=k(h,R,A,I,m,O);if(E===10)return E;E>y&&(y=E)}return y}else{if(typeof M=="string")return I?M==="*"?5:M===A?10:0:0;if(M){const{language:y,pattern:h,scheme:E,hasAccessToAllModels:g,notebookType:l}=M;if(!I&&!g)return 0;l&&m&&(R=m);let t=0;if(E)if(E===R.scheme)t=10;else if(E==="*")t=5;else return 0;if(y)if(y===A)t=10;else if(y==="*")t=Math.max(t,5);else return 0;if(l)if(l===O)t=10;else if(l==="*"&&O!==void 0)t=Math.max(t,5);else return 0;if(h){let a;if(typeof h=="string"?a=h:a={...h,base:(0,P.normalize)(h.base)},a===R.fsPath||(0,n.match)(a,R.fsPath))t=10;else return 0}return t}else return 0}}e.score=k}),define(Ae[89],Re([1,0,25,20]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function M(y){for(let h=0,E=y.length;h<E;h+=4){const g=y[h+0],l=y[h+1],t=y[h+2],a=y[h+3];y[h+0]=a,y[h+1]=t,y[h+2]=l,y[h+3]=g}}function R(y){const h=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return P.isLittleEndian()||M(h),n.VSBuffer.wrap(h)}function A(y){const h=y.buffer;if(P.isLittleEndian()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const E=new Uint8Array(h.byteLength);return E.set(h),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function I(y){const h=new Uint32Array(m(y));let E=0;if(h[E++]=y.id,y.type==="full")h[E++]=1,h[E++]=y.data.length,h.set(y.data,E),E+=y.data.length;else{h[E++]=2,h[E++]=y.deltas.length;for(const g of y.deltas)h[E++]=g.start,h[E++]=g.deleteCount,g.data?(h[E++]=g.data.length,h.set(g.data,E),E+=g.data.length):h[E++]=0}return R(h)}e.encodeSemanticTokensDto=I;function m(y){let h=0;if(h+=1+1,y.type==="full")h+=1+y.data.length;else{h+=1,h+=(1+1+1)*y.deltas.length;for(const E of y.deltas)E.data&&(h+=E.data.length)}return h}function O(y){const h=A(y);let E=0;const g=h[E++];if(h[E++]===1){const d=h[E++],S=h.subarray(E,E+d);return E+=d,{id:g,type:"full",data:S}}const t=h[E++],a=[];for(let d=0;d<t;d++){const S=h[E++],T=h[E++],p=h[E++];let i;p>0&&(i=h.subarray(E,E+p),E+=p),a[d]={start:S,deleteCount:T,data:i}}return{id:g,type:"delta",deltas:a}}e.decodeSemanticTokensDto=O}),define(Ae[132],Re([11,12]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ae[133],Re([1,0,132,20,134,16,23,119]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=m;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class y{constructor(_,be,He,Be){this.id=_,this.name=be,this.defaultValue=He,this.schema=Be}applyUpdate(_,be){return E(_,be)}compute(_,be,He){return He}}class h{constructor(_,be){this.newValue=_,this.didChange=be}}e.ApplyUpdateResult=h;function E(Y,_){if(typeof Y!="object"||typeof _!="object"||!Y||!_)return new h(_,Y!==_);if(Array.isArray(Y)||Array.isArray(_)){const He=Array.isArray(Y)&&Array.isArray(_)&&M.equals(Y,_);return new h(_,!He)}let be=!1;for(const He in _)if(_.hasOwnProperty(He)){const Be=E(Y[He],_[He]);Be.didChange&&(Y[He]=Be.newValue,be=!0)}return new h(Y,be)}class g{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,be){return E(_,be)}validate(_){return this.defaultValue}}class l{constructor(_,be,He,Be){this.id=_,this.name=be,this.defaultValue=He,this.schema=Be}applyUpdate(_,be){return E(_,be)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,be,He){return He}}function t(Y,_){return typeof Y>"u"?_:Y==="false"?!1:Boolean(Y)}e.boolean=t;class a extends l{constructor(_,be,He,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=He),super(_,be,He,Be)}validate(_){return t(_,this.defaultValue)}}function d(Y,_,be,He){if(typeof Y>"u")return _;let Be=parseInt(Y,10);return isNaN(Be)?_:(Be=Math.max(be,Be),Be=Math.min(He,Be),Be|0)}e.clampedInt=d;class S extends l{static clampedInt(_,be,He,Be){return d(_,be,He,Be)}constructor(_,be,He,Be,Qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=He,Ye.minimum=Be,Ye.maximum=Qe),super(_,be,He,Ye),this.minimum=Be,this.maximum=Qe}validate(_){return S.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class T extends l{static clamp(_,be,He){return _<be?be:_>He?He:_}static float(_,be){if(typeof _=="number")return _;if(typeof _>"u")return be;const He=parseFloat(_);return isNaN(He)?be:He}constructor(_,be,He,Be,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=He),super(_,be,He,Qe),this.validationFn=Be}validate(_){return this.validationFn(T.float(_,this.defaultValue))}}class p extends l{static string(_,be){return typeof _!="string"?be:_}constructor(_,be,He,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=He),super(_,be,He,Be)}validate(_){return p.string(_,this.defaultValue)}}function i(Y,_,be){return typeof Y!="string"||be.indexOf(Y)===-1?_:Y}e.stringSet=i;class u extends l{constructor(_,be,He,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Be,Qe.default=He),super(_,be,He,Qe),this.c=Be}validate(_){return i(_,this.defaultValue,this.c)}}class s extends y{constructor(_,be,He,Be,Qe,Ye,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Qe,Ge.default=Be),super(_,be,He,Ge),this.c=Qe,this.d=Ye}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function o(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,be,He){return He===0?_.accessibilitySupport:He}}class b extends y{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:n.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{insertSpace:t(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function D(Y){switch(Y){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function w(Y){switch(Y){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class H extends g{constructor(){super(136)}compute(_,be,He){const Be=["monaco-editor"];return be.get(37)&&Be.push(be.get(37)),_.extraEditorClassName&&Be.push(_.extraEditorClassName),be.get(71)==="default"?Be.push("mouse-default"):be.get(71)==="copy"&&Be.push("mouse-copy"),be.get(106)&&Be.push("showUnused"),be.get(134)&&Be.push("showDeprecated"),Be.join(" ")}}class X extends a{constructor(){super(35,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(_,be,He){return He&&_.emptySelectionClipboard}}class J extends y{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:n.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:n.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{cursorMoveOnType:t(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":i(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":i(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(be.loop,this.defaultValue.loop)}}}class G extends y{constructor(){super(49,"fontLigatures",G.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?G.OFF:_==="true"?G.ON:_:Boolean(_)?G.ON:G.OFF}}G.OFF='"liga" off, "calt" off',G.ON='"liga" on, "calt" on',e.EditorFontLigatures=G;class U extends y{constructor(){super(52,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?U.OFF:_==="true"?U.TRANSLATE:_:Boolean(_)?U.TRANSLATE:U.OFF}compute(_,be,He){return _.fontInfo.fontVariationSettings}}U.OFF="normal",U.TRANSLATE="translate",e.EditorFontVariations=U;class B extends g{constructor(){super(48)}compute(_,be,He){return _.fontInfo}}class $ extends l{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(_){const be=T.float(_,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:T.clamp(be,6,100)}compute(_,be,He){return _.fontInfo.fontSize}}class W extends y{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(S.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}W.c=["normal","bold","100","200","300","400","500","600","700","800","900"],W.d=1,W.e=1e3;class x extends y{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...be},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...be},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...be},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:He,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:He,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:He,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:He,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:He,description:n.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{multiple:i(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??i(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??i(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??i(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??i(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??i(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends y{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:_.above,description:n.localize(45,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),delay:S.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:t(be.sticky,this.defaultValue.sticky),above:t(be.above,this.defaultValue.above)}}}var Se;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Se=e.RenderMinimap||(e.RenderMinimap={}));class ie extends g{constructor(){super(139)}compute(_,be,He){return ie.computeLayout(be,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const be=_.height/_.lineHeight,He=Math.floor(_.paddingTop/_.lineHeight);let Be=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Be=Math.max(Be,be-1));const Qe=(He+_.viewLineCount+Be)/(_.pixelRatio*_.height),Ye=Math.floor(_.viewLineCount/Qe);return{typicalViewportLineCount:be,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Be,desiredRatio:Qe,minimapLineCount:Ye}}static c(_,be){const He=_.outerWidth,Be=_.outerHeight,Qe=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ye=be.stableMinimapLayoutInput,Ge=Ye&&_.outerHeight===Ye.outerHeight&&_.lineHeight===Ye.lineHeight&&_.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&_.pixelRatio===Ye.pixelRatio&&_.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&_.paddingTop===Ye.paddingTop&&_.paddingBottom===Ye.paddingBottom&&_.minimap.enabled===Ye.minimap.enabled&&_.minimap.side===Ye.minimap.side&&_.minimap.size===Ye.minimap.size&&_.minimap.showSlider===Ye.minimap.showSlider&&_.minimap.renderCharacters===Ye.minimap.renderCharacters&&_.minimap.maxColumn===Ye.minimap.maxColumn&&_.minimap.scale===Ye.minimap.scale&&_.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&_.isViewportWrapping===Ye.isViewportWrapping,at=_.lineHeight,yt=_.typicalHalfwidthCharacterWidth,It=_.scrollBeyondLastLine,St=_.minimap.renderCharacters;let vt=Qe>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Nt=_.minimap.maxColumn,Rt=_.minimap.size,Yt=_.minimap.side,Gt=_.verticalScrollbarWidth,dt=_.viewLineCount,ft=_.remainingWidth,Ot=_.isViewportWrapping,Mt=St?2:3;let kt=Math.floor(Qe*Be);const mt=kt/Qe;let wt=!1,zt=!1,Ct=Mt*vt,Ke=vt/Qe,jt=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:ze,extraLinesBeyondLastLine:Ze,desiredRatio:Ve,minimapLineCount:et}=ie.computeContainedMinimapLineCount({viewLineCount:dt,scrollBeyondLastLine:It,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Be,lineHeight:at,pixelRatio:Qe});if(dt/et>1)wt=!0,zt=!0,vt=1,Ct=1,Ke=vt/Qe;else{let ut=!1,Dt=vt+1;if(Rt==="fit"){const gt=Math.ceil((ze+dt+Ze)*Ct);Ot&&Ge&&ft<=be.stableFitRemainingWidth?(ut=!0,Dt=be.stableFitMaxMinimapScale):ut=gt>kt}if(Rt==="fill"||ut){wt=!0;const gt=vt;Ct=Math.min(at*Qe,Math.max(1,Math.floor(1/Ve))),Ot&&Ge&&ft<=be.stableFitRemainingWidth&&(Dt=be.stableFitMaxMinimapScale),vt=Math.min(Dt,Math.max(1,Math.floor(Ct/Mt))),vt>gt&&(jt=Math.min(2,vt/gt)),Ke=vt/Qe/jt,kt=Math.ceil(Math.max(Fe,ze+dt+Ze)*Ct),Ot?(be.stableMinimapLayoutInput=_,be.stableFitRemainingWidth=ft,be.stableFitMaxMinimapScale=vt):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const Xt=Math.floor(Nt*Ke),Ut=Math.min(Xt,Math.max(0,Math.floor((ft-Gt-2)*Ke/(yt+Ke)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Qe*Ut);const Oe=Ie/Qe;Ie=Math.floor(Ie*jt);const me=St?1:2,K=Yt==="left"?0:He-Ut-Gt;return{renderMinimap:me,minimapLeft:K,minimapWidth:Ut,minimapHeightIsEditorHeight:wt,minimapIsSampling:zt,minimapScale:vt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:kt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:mt}}static computeLayout(_,be){const He=be.outerWidth|0,Be=be.outerHeight|0,Qe=be.lineHeight|0,Ye=be.lineNumbersDigitCount|0,Ge=be.typicalHalfwidthCharacterWidth,at=be.maxDigitWidth,yt=be.pixelRatio,It=be.viewLineCount,St=_.get(131),vt=St==="inherit"?_.get(130):St,Nt=vt==="inherit"?_.get(126):vt,Rt=_.get(129),Yt=be.isDominatedByLongLines,Gt=_.get(55),dt=_.get(65).renderType!==0,ft=_.get(66),Ot=_.get(100),Mt=_.get(81),kt=_.get(70),mt=_.get(98),wt=mt.verticalScrollbarSize,zt=mt.verticalHasArrows,Ct=mt.arrowSize,Ke=mt.horizontalScrollbarSize,jt=_.get(41),Xt=_.get(105)!=="never";let Ut=_.get(63);jt&&Xt&&(Ut+=16);let Ie=0;if(dt){const $t=Math.max(Ye,ft);Ie=Math.round($t*at)}let Oe=0;Gt&&(Oe=Qe);let me=0,K=me+Oe,Fe=K+Ie,ze=Fe+Ut;const Ze=He-Oe-Ie-Ut;let Ve=!1,et=!1,lt=-1;vt==="inherit"&&Yt?(Ve=!0,et=!0):Nt==="on"||Nt==="bounded"?et=!0:Nt==="wordWrapColumn"&&(lt=Rt);const ut=ie.c({outerWidth:He,outerHeight:Be,lineHeight:Qe,typicalHalfwidthCharacterWidth:Ge,pixelRatio:yt,scrollBeyondLastLine:Ot,paddingTop:Mt.top,paddingBottom:Mt.bottom,minimap:kt,verticalScrollbarWidth:wt,viewLineCount:It,remainingWidth:Ze,isViewportWrapping:et},be.memory||new O);ut.renderMinimap!==0&&ut.minimapLeft===0&&(me+=ut.minimapWidth,K+=ut.minimapWidth,Fe+=ut.minimapWidth,ze+=ut.minimapWidth);const Dt=Ze-ut.minimapWidth,gt=Math.max(1,Math.floor((Dt-wt-2)/Ge)),Ft=zt?Ct:0;return et&&(lt=Math.max(1,gt),Nt==="bounded"&&(lt=Math.min(lt,Rt))),{width:He,height:Be,glyphMarginLeft:me,glyphMarginWidth:Oe,lineNumbersLeft:K,lineNumbersWidth:Ie,decorationsLeft:Fe,decorationsWidth:Ut,contentLeft:ze,contentWidth:Dt,minimap:ut,viewportColumn:gt,isWordWrapMinified:Ve,isViewportWrapping:et,wrappingColumn:lt,verticalScrollbarWidth:wt,horizontalScrollbarHeight:Ke,overviewRuler:{top:Ft,width:wt,height:Be-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=ie;class ue extends y{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(_){return i(_,"simple",["simple","advanced"])}compute(_,be,He){return be.get(2)===2?"advanced":He}}class ce extends y{constructor(){const _={enabled:!0};super(62,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:n.localize(49,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}class Te extends y{constructor(){const _={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:n.localize(52,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(be.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(be.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class de extends y{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:n.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(54,null),n.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:n.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:n.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:n.localize(60,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:i(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(be.fontFamily,this.defaultValue.fontFamily),padding:t(be.padding,this.defaultValue.padding)}}}class ae extends y{constructor(){super(63,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):S.clampedInt(_,this.defaultValue,0,1e3)}compute(_,be,He){return He<0?S.clampedInt(-He*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class j extends T{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>T.clamp(_,0,150),{markdownDescription:n.localize(61,null)})}compute(_,be,He){return _.fontInfo.lineHeight}}class F extends y{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:n.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:n.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)],default:_.size,description:n.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:n.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:n.localize(69,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:n.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:n.localize(72,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),autohide:t(be.autohide,this.defaultValue.autohide),size:i(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(be.side,this.defaultValue.side,["right","left"]),showSlider:i(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(be.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(be.scale,1,1,3),maxColumn:S.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(Y){return Y==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends y{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(74,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{top:S.clampedInt(be.top,0,0,1e3),bottom:S.clampedInt(be.bottom,0,0,1e3)}}}class ke extends y{constructor(){const _={enabled:!0,cycle:!0};super(82,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:n.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:n.localize(76,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),cycle:t(be.cycle,this.defaultValue.cycle)}}}class Ee extends g{constructor(){super(137)}compute(_,be,He){return _.pixelRatio}}class ve extends y{constructor(){const _={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(77,null),n.localize(78,null),n.localize(79,null)]}];super(85,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:be,default:_.strings,description:n.localize(80,null)},comments:{anyOf:be,default:_.comments,description:n.localize(81,null)},other:{anyOf:be,default:_.other,description:n.localize(82,null)}},default:_,markdownDescription:n.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const yt=_?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!_||typeof _!="object")return this.defaultValue;const{other:be,comments:He,strings:Be}=_,Qe=["on","inline","off"];let Ye,Ge,at;return typeof be=="boolean"?Ye=be?"on":"off":Ye=i(be,this.defaultValue.other,Qe),typeof He=="boolean"?Ge=He?"on":"off":Ge=i(He,this.defaultValue.comments,Qe),typeof Be=="boolean"?at=Be?"on":"off":at=i(Be,this.defaultValue.strings,Qe),{other:Ye,comments:Ge,strings:at}}}var Ce;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Ce=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends y{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(84,null),n.localize(85,null),n.localize(86,null),n.localize(87,null)],default:"on",description:n.localize(88,null)})}validate(_){let be=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(be=4,He=_):_==="interval"?be=3:_==="relative"?be=2:_==="on"?be=1:be=0),{renderType:be,renderFn:He}}}function oe(Y){const _=Y.get(93);return _==="editable"?Y.get(87):_!=="on"}e.filterValidationDecorations=oe;class Z extends y{constructor(){const _=[],be={type:"number",description:n.localize(89,null)};super(97,"rulers",_,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:n.localize(90,null),format:"color-hex"}}}]},default:_,description:n.localize(91,null)})}validate(_){if(Array.isArray(_)){const be=[];for(const He of _)if(typeof He=="number")be.push({column:S.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Be=He;be.push({column:S.clampedInt(Be.column,0,0,1e4),color:Be.color})}return be.sort((He,Be)=>He.column-Be.column),be}return this.defaultValue}}function C(Y,_){if(typeof Y!="string")return _;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends y{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(92,null),n.localize(93,null),n.localize(94,null)],default:"auto",description:n.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(96,null),n.localize(97,null),n.localize(98,null)],default:"auto",description:n.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:n.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:n.localize(102,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_,He=S.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=S.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(be.vertical,this.defaultValue.vertical),horizontal:C(be.horizontal,this.defaultValue.horizontal),useShadows:t(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:S.clampedInt(be.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:S.clampedInt(be.verticalSliderSize,Be,0,1e3),scrollByPage:t(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends y{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:n.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:n.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:n.localize(109,null)}})}applyUpdate(_,be){let He=!1;be.allowedCharacters&&_&&(R.equals(_.allowedCharacters,be.allowedCharacters)||(_={..._,allowedCharacters:be.allowedCharacters},He=!0)),be.allowedLocales&&_&&(R.equals(_.allowedLocales,be.allowedLocales)||(_={..._,allowedLocales:be.allowedLocales},He=!0));const Be=super.applyUpdate(_,be);return He?new h(Be.newValue,!0):Be}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{nonBasicASCII:Pe(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,be){if(typeof _!="object"||!_)return be;const He={};for(const[Be,Qe]of Object.entries(_))Qe===!0&&(He[Be]=!0);return He}}class q extends y{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!0};super(60,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:n.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(111,null),n.localize(112,null)],description:n.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:n.localize(114,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),mode:i(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(be.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(be.suppressSuggestions,this.defaultValue.suppressSuggestions)}}}class te extends y{constructor(){const _={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:n.localize(116,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ge extends y{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(117,null),n.localize(118,null),n.localize(119,null)],default:_.bracketPairs,description:n.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(121,null),n.localize(122,null),n.localize(123,null)],default:_.bracketPairsHorizontal,description:n.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:n.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:n.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(127,null),n.localize(128,null),n.localize(129,null)],default:_.highlightActiveIndentation,description:n.localize(130,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{bracketPairs:Pe(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(Y,_,be){const He=be.indexOf(Y);return He===-1?_:be[He]}class le extends y{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(131,null),n.localize(132,null)],default:_.insertMode,description:n.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:n.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:n.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:n.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(137,null),n.localize(138,null),n.localize(139,null),n.localize(140,null)],default:_.selectionMode,markdownDescription:n.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:n.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:n.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:n.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:n.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:n.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(178,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{insertMode:i(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(be.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(be.showIcons,this.defaultValue.showIcons),showStatusBar:t(be.showStatusBar,this.defaultValue.showStatusBar),preview:t(be.preview,this.defaultValue.preview),previewMode:i(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(be.showMethods,this.defaultValue.showMethods),showFunctions:t(be.showFunctions,this.defaultValue.showFunctions),showConstructors:t(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(be.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(be.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(be.showFields,this.defaultValue.showFields),showVariables:t(be.showVariables,this.defaultValue.showVariables),showClasses:t(be.showClasses,this.defaultValue.showClasses),showStructs:t(be.showStructs,this.defaultValue.showStructs),showInterfaces:t(be.showInterfaces,this.defaultValue.showInterfaces),showModules:t(be.showModules,this.defaultValue.showModules),showProperties:t(be.showProperties,this.defaultValue.showProperties),showEvents:t(be.showEvents,this.defaultValue.showEvents),showOperators:t(be.showOperators,this.defaultValue.showOperators),showUnits:t(be.showUnits,this.defaultValue.showUnits),showValues:t(be.showValues,this.defaultValue.showValues),showConstants:t(be.showConstants,this.defaultValue.showConstants),showEnums:t(be.showEnums,this.defaultValue.showEnums),showEnumMembers:t(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(be.showKeywords,this.defaultValue.showKeywords),showWords:t(be.showWords,this.defaultValue.showWords),showColors:t(be.showColors,this.defaultValue.showColors),showFiles:t(be.showFiles,this.defaultValue.showFiles),showReferences:t(be.showReferences,this.defaultValue.showReferences),showFolders:t(be.showFolders,this.defaultValue.showFolders),showTypeParameters:t(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(be.showSnippets,this.defaultValue.showSnippets),showUsers:t(be.showUsers,this.defaultValue.showUsers),showIssues:t(be.showIssues,this.defaultValue.showIssues)}}}class De extends y{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(179,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var we;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));class We extends y{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(180,null),n.localize(181,null),n.localize(182,null),n.localize(183,null)],description:n.localize(184,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,be,He){return be.get(2)===2?0:He}}class $e extends g{constructor(){super(140)}compute(_,be,He){const Be=be.get(139);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class tt extends y{constructor(){const _={enabled:!0};super(34,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(185,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?it:P.isLinux?nt:Xe,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var rt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=7]="autoClosingDelete",Y[Y.autoClosingOvertype=8]="autoClosingOvertype",Y[Y.autoClosingQuotes=9]="autoClosingQuotes",Y[Y.autoIndent=10]="autoIndent",Y[Y.automaticLayout=11]="automaticLayout",Y[Y.autoSurround=12]="autoSurround",Y[Y.bracketPairColorization=13]="bracketPairColorization",Y[Y.guides=14]="guides",Y[Y.codeLens=15]="codeLens",Y[Y.codeLensFontFamily=16]="codeLensFontFamily",Y[Y.codeLensFontSize=17]="codeLensFontSize",Y[Y.colorDecorators=18]="colorDecorators",Y[Y.colorDecoratorsLimit=19]="colorDecoratorsLimit",Y[Y.columnSelection=20]="columnSelection",Y[Y.comments=21]="comments",Y[Y.contextmenu=22]="contextmenu",Y[Y.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=24]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=26]="cursorStyle",Y[Y.cursorSurroundingLines=27]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=29]="cursorWidth",Y[Y.disableLayerHinting=30]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Y[Y.domReadOnly=32]="domReadOnly",Y[Y.dragAndDrop=33]="dragAndDrop",Y[Y.dropIntoEditor=34]="dropIntoEditor",Y[Y.emptySelectionClipboard=35]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=37]="extraEditorClassName",Y[Y.fastScrollSensitivity=38]="fastScrollSensitivity",Y[Y.find=39]="find",Y[Y.fixedOverflowWidgets=40]="fixedOverflowWidgets",Y[Y.folding=41]="folding",Y[Y.foldingStrategy=42]="foldingStrategy",Y[Y.foldingHighlight=43]="foldingHighlight",Y[Y.foldingImportsByDefault=44]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=45]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=47]="fontFamily",Y[Y.fontInfo=48]="fontInfo",Y[Y.fontLigatures=49]="fontLigatures",Y[Y.fontSize=50]="fontSize",Y[Y.fontWeight=51]="fontWeight",Y[Y.fontVariations=52]="fontVariations",Y[Y.formatOnPaste=53]="formatOnPaste",Y[Y.formatOnType=54]="formatOnType",Y[Y.glyphMargin=55]="glyphMargin",Y[Y.gotoLocation=56]="gotoLocation",Y[Y.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Y[Y.hover=58]="hover",Y[Y.inDiffEditor=59]="inDiffEditor",Y[Y.inlineSuggest=60]="inlineSuggest",Y[Y.letterSpacing=61]="letterSpacing",Y[Y.lightbulb=62]="lightbulb",Y[Y.lineDecorationsWidth=63]="lineDecorationsWidth",Y[Y.lineHeight=64]="lineHeight",Y[Y.lineNumbers=65]="lineNumbers",Y[Y.lineNumbersMinChars=66]="lineNumbersMinChars",Y[Y.linkedEditing=67]="linkedEditing",Y[Y.links=68]="links",Y[Y.matchBrackets=69]="matchBrackets",Y[Y.minimap=70]="minimap",Y[Y.mouseStyle=71]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=73]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=75]="multiCursorModifier",Y[Y.multiCursorPaste=76]="multiCursorPaste",Y[Y.multiCursorLimit=77]="multiCursorLimit",Y[Y.occurrencesHighlight=78]="occurrencesHighlight",Y[Y.overviewRulerBorder=79]="overviewRulerBorder",Y[Y.overviewRulerLanes=80]="overviewRulerLanes",Y[Y.padding=81]="padding",Y[Y.parameterHints=82]="parameterHints",Y[Y.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=85]="quickSuggestions",Y[Y.quickSuggestionsDelay=86]="quickSuggestionsDelay",Y[Y.readOnly=87]="readOnly",Y[Y.renameOnType=88]="renameOnType",Y[Y.renderControlCharacters=89]="renderControlCharacters",Y[Y.renderFinalNewline=90]="renderFinalNewline",Y[Y.renderLineHighlight=91]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=93]="renderValidationDecorations",Y[Y.renderWhitespace=94]="renderWhitespace",Y[Y.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",Y[Y.roundedSelection=96]="roundedSelection",Y[Y.rulers=97]="rulers",Y[Y.scrollbar=98]="scrollbar",Y[Y.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=100]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=101]="scrollPredominantAxis",Y[Y.selectionClipboard=102]="selectionClipboard",Y[Y.selectionHighlight=103]="selectionHighlight",Y[Y.selectOnLineNumbers=104]="selectOnLineNumbers",Y[Y.showFoldingControls=105]="showFoldingControls",Y[Y.showUnused=106]="showUnused",Y[Y.snippetSuggestions=107]="snippetSuggestions",Y[Y.smartSelect=108]="smartSelect",Y[Y.smoothScrolling=109]="smoothScrolling",Y[Y.stickyScroll=110]="stickyScroll",Y[Y.stickyTabStops=111]="stickyTabStops",Y[Y.stopRenderingLineAfter=112]="stopRenderingLineAfter",Y[Y.suggest=113]="suggest",Y[Y.suggestFontSize=114]="suggestFontSize",Y[Y.suggestLineHeight=115]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",Y[Y.suggestSelection=117]="suggestSelection",Y[Y.tabCompletion=118]="tabCompletion",Y[Y.tabIndex=119]="tabIndex",Y[Y.unicodeHighlighting=120]="unicodeHighlighting",Y[Y.unusualLineTerminators=121]="unusualLineTerminators",Y[Y.useShadowDOM=122]="useShadowDOM",Y[Y.useTabStops=123]="useTabStops",Y[Y.wordBreak=124]="wordBreak",Y[Y.wordSeparators=125]="wordSeparators",Y[Y.wordWrap=126]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=129]="wordWrapColumn",Y[Y.wordWrapOverride1=130]="wordWrapOverride1",Y[Y.wordWrapOverride2=131]="wordWrapOverride2",Y[Y.wrappingIndent=132]="wrappingIndent",Y[Y.wrappingStrategy=133]="wrappingStrategy",Y[Y.showDeprecated=134]="showDeprecated",Y[Y.inlayHints=135]="inlayHints",Y[Y.editorClassName=136]="editorClassName",Y[Y.pixelRatio=137]="pixelRatio",Y[Y.tabFocusMode=138]="tabFocusMode",Y[Y.layoutInfo=139]="layoutInfo",Y[Y.wrappingInfo=140]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(186,null)})),acceptSuggestionOnEnter:Me(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(187,null),""],markdownDescription:n.localize(188,null)})),accessibilitySupport:Me(new f),accessibilityPageSize:Me(new S(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(189,null),tags:["accessibility"]})),ariaLabel:Me(new p(4,"ariaLabel",n.localize(190,null))),screenReaderAnnounceInlineSuggestion:Me(new a(6,"screenReaderAnnounceInlineSuggestion",!1,{description:n.localize(191,null),tags:["accessibility"]})),autoClosingBrackets:Me(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(192,null),n.localize(193,null),""],description:n.localize(194,null)})),autoClosingDelete:Me(new u(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(195,null),""],description:n.localize(196,null)})),autoClosingOvertype:Me(new u(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(197,null),""],description:n.localize(198,null)})),autoClosingQuotes:Me(new u(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(199,null),n.localize(200,null),""],description:n.localize(201,null)})),autoIndent:Me(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[n.localize(202,null),n.localize(203,null),n.localize(204,null),n.localize(205,null),n.localize(206,null)],description:n.localize(207,null)})),automaticLayout:Me(new a(11,"automaticLayout",!1)),autoSurround:Me(new u(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(208,null),n.localize(209,null),n.localize(210,null),""],description:n.localize(211,null)})),bracketPairColorization:Me(new te),bracketPairGuides:Me(new ge),stickyTabStops:Me(new a(111,"stickyTabStops",!1,{description:n.localize(212,null)})),codeLens:Me(new a(15,"codeLens",!0,{description:n.localize(213,null)})),codeLensFontFamily:Me(new p(16,"codeLensFontFamily","",{description:n.localize(214,null)})),codeLensFontSize:Me(new S(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(215,null)})),colorDecorators:Me(new a(18,"colorDecorators",!0,{description:n.localize(216,null)})),colorDecoratorsLimit:Me(new S(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(217,null)})),columnSelection:Me(new a(20,"columnSelection",!1,{description:n.localize(218,null)})),comments:Me(new b),contextmenu:Me(new a(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(23,"copyWithSyntaxHighlighting",!0,{description:n.localize(219,null)})),cursorBlinking:Me(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:n.localize(220,null)})),cursorSmoothCaretAnimation:Me(new u(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(221,null),n.localize(222,null),n.localize(223,null)],description:n.localize(224,null)})),cursorStyle:Me(new s(26,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:n.localize(225,null)})),cursorSurroundingLines:Me(new S(27,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(226,null)})),cursorSurroundingLinesStyle:Me(new u(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(227,null),n.localize(228,null)],description:n.localize(229,null)})),cursorWidth:Me(new S(29,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(230,null)})),disableLayerHinting:Me(new a(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(31,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(32,"domReadOnly",!1)),dragAndDrop:Me(new a(33,"dragAndDrop",!0,{description:n.localize(231,null)})),emptySelectionClipboard:Me(new X),dropIntoEditor:Me(new tt),stickyScroll:Me(new Te),experimentalWhitespaceRendering:Me(new u(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(232,null),n.localize(233,null),n.localize(234,null)],description:n.localize(235,null)})),extraEditorClassName:Me(new p(37,"extraEditorClassName","")),fastScrollSensitivity:Me(new T(38,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:n.localize(236,null)})),find:Me(new J),fixedOverflowWidgets:Me(new a(40,"fixedOverflowWidgets",!1)),folding:Me(new a(41,"folding",!0,{description:n.localize(237,null)})),foldingStrategy:Me(new u(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(238,null),n.localize(239,null)],description:n.localize(240,null)})),foldingHighlight:Me(new a(43,"foldingHighlight",!0,{description:n.localize(241,null)})),foldingImportsByDefault:Me(new a(44,"foldingImportsByDefault",!1,{description:n.localize(242,null)})),foldingMaximumRegions:Me(new S(45,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(243,null)})),unfoldOnClickAfterEndOfLine:Me(new a(46,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(244,null)})),fontFamily:Me(new p(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(245,null)})),fontInfo:Me(new B),fontLigatures2:Me(new G),fontSize:Me(new $),fontWeight:Me(new W),fontVariations:Me(new U),formatOnPaste:Me(new a(53,"formatOnPaste",!1,{description:n.localize(246,null)})),formatOnType:Me(new a(54,"formatOnType",!1,{description:n.localize(247,null)})),glyphMargin:Me(new a(55,"glyphMargin",!0,{description:n.localize(248,null)})),gotoLocation:Me(new x),hideCursorInOverviewRuler:Me(new a(57,"hideCursorInOverviewRuler",!1,{description:n.localize(249,null)})),hover:Me(new fe),inDiffEditor:Me(new a(59,"inDiffEditor",!1)),letterSpacing:Me(new T(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>T.clamp(Y,-5,20),{description:n.localize(250,null)})),lightbulb:Me(new ce),lineDecorationsWidth:Me(new ae),lineHeight:Me(new j),lineNumbers:Me(new se),lineNumbersMinChars:Me(new S(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(67,"linkedEditing",!1,{description:n.localize(251,null)})),links:Me(new a(68,"links",!0,{description:n.localize(252,null)})),matchBrackets:Me(new u(69,"matchBrackets","always",["always","near","never"],{description:n.localize(253,null)})),minimap:Me(new F),mouseStyle:Me(new u(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new T(72,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:n.localize(254,null)})),mouseWheelZoom:Me(new a(73,"mouseWheelZoom",!1,{markdownDescription:n.localize(255,null)})),multiCursorMergeOverlapping:Me(new a(74,"multiCursorMergeOverlapping",!0,{description:n.localize(256,null)})),multiCursorModifier:Me(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorPaste:Me(new u(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(260,null),n.localize(261,null)],markdownDescription:n.localize(262,null)})),multiCursorLimit:Me(new S(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(263,null)})),occurrencesHighlight:Me(new a(78,"occurrencesHighlight",!0,{description:n.localize(264,null)})),overviewRulerBorder:Me(new a(79,"overviewRulerBorder",!0,{description:n.localize(265,null)})),overviewRulerLanes:Me(new S(80,"overviewRulerLanes",3,0,3)),padding:Me(new pe),parameterHints:Me(new ke),peekWidgetDefaultFocus:Me(new u(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(266,null),n.localize(267,null)],description:n.localize(268,null)})),definitionLinkOpensInPeek:Me(new a(84,"definitionLinkOpensInPeek",!1,{description:n.localize(269,null)})),quickSuggestions:Me(new ve),quickSuggestionsDelay:Me(new S(86,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(270,null)})),readOnly:Me(new a(87,"readOnly",!1)),renameOnType:Me(new a(88,"renameOnType",!1,{description:n.localize(271,null),markdownDeprecationMessage:n.localize(272,null)})),renderControlCharacters:Me(new a(89,"renderControlCharacters",!0,{description:n.localize(273,null),restricted:!0})),renderFinalNewline:Me(new u(90,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(274,null)})),renderLineHighlight:Me(new u(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(275,null)],description:n.localize(276,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(92,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(277,null)})),renderValidationDecorations:Me(new u(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new u(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(278,null),n.localize(279,null),n.localize(280,null),""],description:n.localize(281,null)})),revealHorizontalRightPadding:Me(new S(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(96,"roundedSelection",!0,{description:n.localize(282,null)})),rulers:Me(new Z),scrollbar:Me(new N),scrollBeyondLastColumn:Me(new S(99,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(283,null)})),scrollBeyondLastLine:Me(new a(100,"scrollBeyondLastLine",!0,{description:n.localize(284,null)})),scrollPredominantAxis:Me(new a(101,"scrollPredominantAxis",!0,{description:n.localize(285,null)})),selectionClipboard:Me(new a(102,"selectionClipboard",!0,{description:n.localize(286,null),included:P.isLinux})),selectionHighlight:Me(new a(103,"selectionHighlight",!0,{description:n.localize(287,null)})),selectOnLineNumbers:Me(new a(104,"selectOnLineNumbers",!0)),showFoldingControls:Me(new u(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null)],description:n.localize(291,null)})),showUnused:Me(new a(106,"showUnused",!0,{description:n.localize(292,null)})),showDeprecated:Me(new a(134,"showDeprecated",!0,{description:n.localize(293,null)})),inlayHints:Me(new de),snippetSuggestions:Me(new u(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(294,null),n.localize(295,null),n.localize(296,null),n.localize(297,null)],description:n.localize(298,null)})),smartSelect:Me(new De),smoothScrolling:Me(new a(109,"smoothScrolling",!1,{description:n.localize(299,null)})),stopRenderingLineAfter:Me(new S(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new le),inlineSuggest:Me(new q),suggestFontSize:Me(new S(114,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(300,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new S(115,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(301,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(116,"suggestOnTriggerCharacters",!0,{description:n.localize(302,null)})),suggestSelection:Me(new u(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(303,null),n.localize(304,null),n.localize(305,null)],description:n.localize(306,null)})),tabCompletion:Me(new u(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(307,null),n.localize(308,null),n.localize(309,null)],description:n.localize(310,null)})),tabIndex:Me(new S(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new V),unusualLineTerminators:Me(new u(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(311,null),n.localize(312,null),n.localize(313,null)],description:n.localize(314,null)})),useShadowDOM:Me(new a(122,"useShadowDOM",!0)),useTabStops:Me(new a(123,"useTabStops",!0,{description:n.localize(315,null)})),wordBreak:Me(new u(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(316,null),n.localize(317,null)],description:n.localize(318,null)})),wordSeparators:Me(new p(125,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:n.localize(319,null)})),wordWrap:Me(new u(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(320,null),n.localize(321,null),n.localize(322,null),n.localize(323,null)],description:n.localize(324,null)})),wordWrapBreakAfterCharacters:Me(new p(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new p(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new S(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(325,null)})),wordWrapOverride1:Me(new u(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new u(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new H),pixelRatio:Me(new Ee),tabFocusMode:Me(new a(138,"tabFocusMode",!1,{markdownDescription:n.localize(326,null)})),layoutInfo:Me(new ie),wrappingInfo:Me(new $e),wrappingIndent:Me(new We),wrappingStrategy:Me(new ue)}}),define(Ae[135],Re([11,12]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[136],Re([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[137],Re([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[138],Re([11,12]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[139],Re([11,12]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[140],Re([11,12]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ae[141],Re([11,12]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ae[142],Re([11,12]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[143],Re([11,12]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ae[144],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[145],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[146],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Ae[147],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[148],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[149],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[150],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[151],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[152],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[153],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[154],Re([11,12]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ae[155],Re([11,12]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ae[156],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[157],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[158],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[159],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[160],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[161],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[162],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[163],Re([1,0,9,137]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(k=e.TokenType||(e.TokenType={}));function M(...m){switch(m.length){case 1:return(0,P.localize)(0,null,m[0]);case 2:return(0,P.localize)(1,null,m[0],m[1]);case 3:return(0,P.localize)(2,null,m[0],m[1],m[2]);default:return}}const R=(0,P.localize)(3,null),A=(0,P.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const y=this.d,h=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:h};this.g.push({offset:y,lexeme:h,additionalInfo:O}),this.f.push(E)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const y=this.c.substring(this.d,this.e),h=I.b.get(y);h?this.k(h):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,y=!1,h=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(A);return}const g=this.c.charCodeAt(O);if(y)y=!1;else if(g===47&&!h){O++;break}else g===91?h=!0:g===92?y=!0:g===93&&(h=!1);O++}for(;O<this.c.length&&I.a.has(this.c.charCodeAt(O));)O++;this.e=O;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(Ae[164],Re([1,0,22,29,139,265]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function I(a){return a=a.trim(),a==="*"||R.test(a)}e.isValidVersionStr=I;function m(a){if(!I(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=a.match(R);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=m;function O(a){if(!a)return null;const d=a.majorBase,S=a.majorMustEqual,T=a.minorBase;let p=a.minorMustEqual;const i=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(d===0||(p=!1),u=!1);let s=0;if(a.preRelease){const o=A.exec(a.preRelease);if(o){const[,f,b,r]=o;s=Date.UTC(Number(f),Number(b)-1,Number(r))}}return{majorBase:d,majorMustEqual:S,minorBase:T,minorMustEqual:p,patchBase:i,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:s}}e.normalizeVersion=O;function y(a,d,S){let T;typeof a=="string"?T=O(m(a)):T=a;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let i;if(typeof S=="string"?i=O(m(S)):i=S,!T||!i)return!1;const u=T.majorBase,s=T.minorBase,o=T.patchBase;let f=i.majorBase,b=i.minorBase,r=i.patchBase;const c=i.notBefore;let v=i.majorMustEqual,D=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?u>f?!0:u<f?!1:s>b?!0:s<b||p&&p<c?!1:o>=r:(u===1&&f===0&&(!v||!D||!w)&&(f=1,b=0,r=0,v=!0,D=!1,w=!1),u<f?!1:u>f?!v:s<b?!1:s>b?!D:o<r?!1:o>r?!w:!(p&&p<c))}e.isValidVersion=y;function h(a,d,S,T,p){const i=[];if(typeof T.publisher<"u"&&typeof T.publisher!="string")return i.push([P.default.Error,k.localize(0,null)]),i;if(typeof T.name!="string")return i.push([P.default.Error,k.localize(1,null,"name")]),i;if(typeof T.version!="string")return i.push([P.default.Error,k.localize(2,null,"version")]),i;if(!T.engines)return i.push([P.default.Error,k.localize(3,null,"engines")]),i;if(typeof T.engines.vscode!="string")return i.push([P.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof T.extensionDependencies<"u"&&!t(T.extensionDependencies))return i.push([P.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof T.activationEvents<"u"){if(!t(T.activationEvents))return i.push([P.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof T.main>"u"&&typeof T.browser>"u")return i.push([P.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof T.extensionKind<"u"&&typeof T.main>"u"&&i.push([P.default.Warning,k.localize(8,null,"extensionKind")]),typeof T.main<"u"){if(typeof T.main!="string")return i.push([P.default.Error,k.localize(9,null,"main")]),i;{const o=(0,n.joinPath)(S,T.main);(0,n.isEqualOrParent)(o,S)||i.push([P.default.Warning,k.localize(10,null,o.path,S.path)])}}if(typeof T.browser<"u"){if(typeof T.browser!="string")return i.push([P.default.Error,k.localize(11,null,"browser")]),i;{const o=(0,n.joinPath)(S,T.browser);(0,n.isEqualOrParent)(o,S)||i.push([P.default.Warning,k.localize(12,null,o.path,S.path)])}}if(!M.valid(T.version))return i.push([P.default.Error,k.localize(13,null)]),i;const u=[];if(!E(a,d,T,p,u))for(const o of u)i.push([P.default.Error,o]);return i}e.validateExtensionManifest=h;function E(a,d,S,T,p){return T||typeof S.main>"u"&&typeof S.browser>"u"?!0:l(a,d,S.engines.vscode,p)}e.isValidExtensionVersion=E;function g(a,d,S){return a==="*"||l(d,S,a)}e.isEngineValid=g;function l(a,d,S,T=[]){const p=O(m(S));if(!p)return T.push(k.localize(14,null,S)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return T.push(k.localize(15,null,S)),!1}else if(!p.majorMustEqual)return T.push(k.localize(16,null,S)),!1;return y(a,d,p)?!0:(T.push(k.localize(17,null,a,S)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let d=0,S=a.length;d<S;d++)if(typeof a[d]!="string")return!1;return!0}}),define(Ae[68],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(k,M=[],R=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=n}),define(Ae[69],Re([1,0,68]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var k;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function M(A,I,m){I instanceof n.SyncDescriptor||(I=new n.SyncDescriptor(I,[],Boolean(m))),P.push([A,I])}e.registerSingleton=M;function R(){return P}e.getSingletonServiceDescriptors=R}),define(Ae[165],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class P{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const A=this.lookupOrInsertNode(M),I=this.lookupOrInsertNode(R);A.outgoing.set(I.key,I),I.incoming.set(A.key,A)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let A=this.a.get(R);return A||(A=new n(R,M),this.a.set(R,A)),A}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,A]of this.a)M.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const A=new Set([M]),I=this.c(R,A);if(I)return I}}c(M,R){for(const[A,I]of M.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const m=this.c(I,R);if(m)return m;R.delete(A)}}}e.Graph=P}),define(Ae[3],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(I){return I[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function P(R,A,I){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:I}):(A[n.DI_DEPENDENCIES]=[{id:R,index:I}],A[n.DI_TARGET]=A)}function k(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(I,m,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(A,I,O)};return A.toString=()=>R,n.serviceIds.set(R,A),A}e.createDecorator=k;function M(R){return R}e.refineServiceDecorator=M}),define(Ae[42],Re([1,0,10,2,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationOverrides=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=R;var A;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function m(t,a){const d=Object.create(null);for(const S in t)O(d,S,t[S],a);return d}e.toValuesTree=m;function O(t,a,d,S){const T=a.split("."),p=T.pop();let i=t;for(let u=0;u<T.length;u++){const s=T[u];let o=i[s];switch(typeof o){case"undefined":o=i[s]=Object.create(null);break;case"object":break;default:S(`Ignoring ${a} as ${T.slice(0,u+1).join(".")} is ${JSON.stringify(o)}`);return}i=o}if(typeof i=="object"&&i!==null)try{i[p]=d}catch{S(`Ignoring ${a} as ${T.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${a} as ${T.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=O;function y(t,a){const d=a.split(".");h(t,d)}e.removeFromValueTree=y;function h(t,a){const d=a.shift();if(a.length===0){delete t[d];return}if(Object.keys(t).indexOf(d)!==-1){const S=t[d];typeof S=="object"&&!Array.isArray(S)&&(h(S,a),Object.keys(S).length===0&&delete t[d])}}function E(t,a,d){function S(i,u){let s=i;for(const o of u){if(typeof s!="object"||s===null)return;s=s[o]}return s}const T=a.split("."),p=S(t,T);return typeof p>"u"?d:p}e.getConfigurationValue=E;function g(t,a,d){Object.keys(a).forEach(S=>{S!=="__proto__"&&(S in t?n.isObject(t[S])&&n.isObject(a[S])?g(t[S],a[S],d):d&&(t[S]=a[S]):t[S]=a[S])})}e.merge=g;function l(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(Ae[31],Re([1,0,20,13,163,3,136,9]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",n.isMacintosh),I.set("isLinux",n.isLinux),I.set("isWindows",n.isWindows),I.set("isWeb",n.isWeb),I.set("isMacNative",n.isMacintosh&&!n.isWeb),I.set("isEdge",n.isEdge),I.set("isFirefox",n.isFirefox),I.set("isChrome",n.isChrome),I.set("isSafari",n.isSafari);function m(j,F){if(I.get(j)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(j,F)}e.setConstant=m;const O=Object.prototype.hasOwnProperty;var y;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));const h={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),g=(0,R.localize)(1,null),l=(0,R.localize)(2,null),t=(0,R.localize)(3,null),a=(0,R.localize)(4,null),d=(0,R.localize)(5,null),S=(0,R.localize)(6,null),T=(0,R.localize)(7,null);class p{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=h){this.k=F,this.d=new k.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const pe=this.D(),ke=pe.type===17?d:void 0;throw this.h.push({message:a,offset:pe.offset,lexeme:k.Scanner.getLexeme(pe),additionalInfo:ke}),p.c}return Q}catch(Q){if(Q!==p.c)throw Q;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(16);){const Q=this.o();F.push(Q)}return F.length===1?F[0]:i.or(...F)}o(){const F=[this.s()];for(;this.y(15);){const Q=this.s();F.push(Q)}return F.length===1?F[0]:i.and(...F)}s(){if(this.y(2)){const F=this.D();switch(F.type){case 11:return this.z(),f.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const Q=this.l();return this.A(1,t),Q?.negate()}case 17:return this.z(),H.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const Q=this.l();return this.A(1,t),Q}case 17:{const Q=F.lexeme;if(this.z(),this.y(9)){const ke=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ke.type!==10)throw this.B("REGEX",ke);const Ee=ke.lexeme,ve=Ee.lastIndexOf("/"),Ce=ve===Ee.length-1?void 0:this.w(Ee.substring(ve+1));let se;try{se=new RegExp(Ee.substring(1,ve),Ce)}catch{throw this.B("REGEX",ke)}return $.create(Q,se)}switch(ke.type){case 10:case 19:{const Ee=[ke.lexeme];this.z();let ve=this.D(),Ce=0;for(let N=0;N<ke.lexeme.length;N++)ke.lexeme.charCodeAt(N)===40?Ce++:ke.lexeme.charCodeAt(N)===41&&Ce--;for(;!this.E()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:Ce++;break;case 1:Ce--;break;case 10:case 18:for(let N=0;N<ve.lexeme.length;N++)ve.lexeme.charCodeAt(N)===40?Ce++:ke.lexeme.charCodeAt(N)===41&&Ce--}if(Ce<0)break;Ee.push(k.Scanner.getLexeme(ve)),this.z(),ve=this.D()}const se=Ee.join(""),oe=se.lastIndexOf("/"),Z=oe===se.length-1?void 0:this.w(se.substring(oe+1));let C;try{C=new RegExp(se.substring(1,oe),Z)}catch{throw this.B("REGEX",ke)}return i.regex(Q,C)}case 18:{const Ee=ke.lexeme;this.z();let ve=null;if(!(0,P.isFalsyOrWhitespace)(Ee)){const Ce=Ee.indexOf("/"),se=Ee.lastIndexOf("/");if(Ce!==se&&Ce>=0){const oe=Ee.slice(Ce+1,se),Z=Ee[se+1]==="i"?"i":"";try{ve=new RegExp(oe,Z)}catch{throw this.B("REGEX",ke)}}}if(ve===null)throw this.B("REGEX",ke);return $.create(Q,ve)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const ke=this.u();return i.notIn(Q,ke)}switch(this.D().type){case 3:{this.z();const ke=this.u();if(this.x().type===18)return i.equals(Q,ke);switch(ke){case"true":return i.has(Q);case"false":return i.not(Q);default:return i.equals(Q,ke)}}case 4:{this.z();const ke=this.u();if(this.x().type===18)return i.notEquals(Q,ke);switch(ke){case"true":return i.not(Q);case"false":return i.has(Q);default:return i.notEquals(Q,ke)}}case 5:return this.z(),U.create(Q,this.u());case 6:return this.z(),B.create(Q,this.u());case 7:return this.z(),J.create(Q,this.u());case 8:return this.z(),G.create(Q,this.u());case 13:return this.z(),i.in(Q,this.u());default:return i.has(Q)}}case 20:throw this.h.push({message:S,offset:F.offset,lexeme:"",additionalInfo:T}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case 17:case 18:return this.z(),F.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,Q){if(this.C(F))return this.z();throw this.B(Q,this.D())}B(F,Q,pe){const ke=(0,R.localize)(8,null,F,k.Scanner.getLexeme(Q)),Ee=Q.offset,ve=k.Scanner.getLexeme(Q);return this.h.push({message:ke,offset:Ee,lexeme:ve,additionalInfo:pe}),p.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===20}}p.c=new Error,e.Parser=p;class i{static false(){return f.INSTANCE}static true(){return b.INSTANCE}static has(F){return r.create(F)}static equals(F,Q){return c.create(F,Q)}static notEquals(F,Q){return w.create(F,Q)}static regex(F,Q){return $.create(F,Q)}static in(F,Q){return v.create(F,Q)}static notIn(F,Q){return D.create(F,Q)}static not(F){return H.create(F)}static and(...F){return fe.create(F,null,!0)}static or(...F){return Se.create(F,null,!0)}static greater(F,Q){return J.create(F,Q)}static greaterEquals(F,Q){return G.create(F,Q)}static smaller(F,Q){return U.create(F,Q)}static smallerEquals(F,Q){return B.create(F,Q)}static deserialize(F){return F==null?void 0:this.c.parse(F)}}i.c=new p({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=i;function u(j){const F=new p({regexParsingWithErrorRecovery:!1});return j.map(Q=>(F.parse(Q),F.lexingErrors.length>0?F.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,R.localize)(9,null,pe.additionalInfo):(0,R.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.validateWhenClauses=u;function s(j,F){const Q=j?j.substituteConstants():void 0,pe=F?F.substituteConstants():void 0;return!Q&&!pe?!0:!Q||!pe?!1:Q.equals(pe)}e.expressionsAreEqualWithConstantSubstitution=s;function o(j,F){return j.cmp(F)}class f{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}f.INSTANCE=new f,e.ContextKeyFalseExpr=f;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return f.INSTANCE}}b.INSTANCE=new b,e.ContextKeyTrueExpr=b;class r{static create(F,Q=null){const pe=I.get(F);return typeof pe=="boolean"?pe?b.INSTANCE:f.INSTANCE:new r(F,Q)}constructor(F,Q){this.key=F,this.c=Q,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:ue(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=I.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:f.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=r;class c{static create(F,Q,pe=null){if(typeof Q=="boolean")return Q?r.create(F,pe):H.create(F,pe);const ke=I.get(F);return typeof ke=="boolean"?Q===(ke?"true":"false")?b.INSTANCE:f.INSTANCE:new c(F,Q,pe)}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?b.INSTANCE:f.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=c;class v{static create(F,Q){return new v(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.f),pe=F.getValue(this.d);return Array.isArray(Q)?Q.includes(pe):typeof pe=="string"&&typeof Q=="object"&&Q!==null?O.call(Q,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=v;class D{static create(F,Q){return new D(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=11,this.c=v.create(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=D;class w{static create(F,Q,pe=null){if(typeof Q=="boolean")return Q?H.create(F,pe):r.create(F,pe);const ke=I.get(F);return typeof ke=="boolean"?Q===(ke?"true":"false")?f.INSTANCE:b.INSTANCE:new w(F,Q,pe)}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?f.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=w;class H{static create(F,Q=null){const pe=I.get(F);return typeof pe=="boolean"?pe?f.INSTANCE:b.INSTANCE:new H(F,Q)}constructor(F,Q){this.c=F,this.d=Q,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:ue(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=I.get(this.c);return typeof F=="boolean"?F?f.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=r.create(this.c,this)),this.d}}e.ContextKeyNotExpr=H;function X(j,F){if(typeof j=="string"){const Q=parseFloat(j);isNaN(Q)||(j=Q)}return typeof j=="string"||typeof j=="number"?F(j):f.INSTANCE}class J{static create(F,Q,pe=null){return X(Q,ke=>new J(F,ke,pe))}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=J;class G{static create(F,Q,pe=null){return X(Q,ke=>new G(F,ke,pe))}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=G;class U{static create(F,Q,pe=null){return X(Q,ke=>new U(F,ke,pe))}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=U;class B{static create(F,Q,pe=null){return X(Q,ke=>new B(F,ke,pe))}constructor(F,Q,pe){this.c=F,this.d=Q,this.f=pe,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:ce(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=B;class ${static create(F,Q){return new $(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const Q=this.f?this.f.source:"",pe=F.f?F.f.source:"";return Q<pe?-1:Q>pe?1:0}equals(F){if(F.type===this.type){const Q=this.f?this.f.source:"",pe=F.f?F.f.source:"";return this.d===F.d&&Q===pe}return!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.ContextKeyRegexExpr=$;class W{static create(F){return new W(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new W(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=W;function x(j){let F=null;for(let Q=0,pe=j.length;Q<pe;Q++){const ke=j[Q].substituteConstants();if(j[Q]!==ke&&F===null){F=[];for(let Ee=0;Ee<Q;Ee++)F[Ee]=j[Ee]}F!==null&&(F[Q]=ke)}return F===null?j:F}class fe{static create(F,Q,pe){return fe.d(F,Q,pe)}constructor(F,Q){this.expr=F,this.c=Q,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,pe=this.expr.length;Q<pe;Q++){const ke=o(this.expr[Q],F.expr[Q]);if(ke!==0)return ke}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,pe=this.expr.length;Q<pe;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=x(this.expr);return F===this.expr?this:fe.create(F,this.c,!1)}evaluate(F){for(let Q=0,pe=this.expr.length;Q<pe;Q++)if(!this.expr[Q].evaluate(F))return!1;return!0}static d(F,Q,pe){const ke=[];let Ee=!1;for(const ve of F)if(!!ve){if(ve.type===1){Ee=!0;continue}if(ve.type===0)return f.INSTANCE;if(ve.type===6){ke.push(...ve.expr);continue}ke.push(ve)}if(ke.length===0&&Ee)return b.INSTANCE;if(ke.length!==0){if(ke.length===1)return ke[0];ke.sort(o);for(let ve=1;ve<ke.length;ve++)ke[ve-1].equals(ke[ve])&&(ke.splice(ve,1),ve--);if(ke.length===1)return ke[0];for(;ke.length>1;){const ve=ke[ke.length-1];if(ve.type!==9)break;ke.pop();const Ce=ke.pop(),se=ke.length===0,oe=Se.create(ve.expr.map(Z=>fe.create([Z,Ce],null,pe)),null,se);oe&&(ke.push(oe),ke.sort(o))}if(ke.length===1)return ke[0];if(pe){for(let ve=0;ve<ke.length;ve++)for(let Ce=ve+1;Ce<ke.length;Ce++)if(ke[ve].negate().equals(ke[Ce]))return f.INSTANCE;if(ke.length===1)return ke[0]}return new fe(ke,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new fe(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());this.c=Se.create(F,this,!0)}return this.c}}e.ContextKeyAndExpr=fe;class Se{static create(F,Q,pe){return Se.d(F,Q,pe)}constructor(F,Q){this.expr=F,this.c=Q,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,pe=this.expr.length;Q<pe;Q++){const ke=o(this.expr[Q],F.expr[Q]);if(ke!==0)return ke}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,pe=this.expr.length;Q<pe;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=x(this.expr);return F===this.expr?this:Se.create(F,this.c,!1)}evaluate(F){for(let Q=0,pe=this.expr.length;Q<pe;Q++)if(this.expr[Q].evaluate(F))return!0;return!1}static d(F,Q,pe){let ke=[],Ee=!1;if(F){for(let ve=0,Ce=F.length;ve<Ce;ve++){const se=F[ve];if(!!se){if(se.type===0){Ee=!0;continue}if(se.type===1)return b.INSTANCE;if(se.type===9){ke=ke.concat(se.expr);continue}ke.push(se)}}if(ke.length===0&&Ee)return f.INSTANCE;ke.sort(o)}if(ke.length!==0){if(ke.length===1)return ke[0];for(let ve=1;ve<ke.length;ve++)ke[ve-1].equals(ke[ve])&&(ke.splice(ve,1),ve--);if(ke.length===1)return ke[0];if(pe){for(let ve=0;ve<ke.length;ve++)for(let Ce=ve+1;Ce<ke.length;Ce++)if(ke[ve].negate().equals(ke[Ce]))return b.INSTANCE;if(ke.length===1)return ke[0]}return new Se(ke,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new Se(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());for(;F.length>1;){const Q=F.shift(),pe=F.shift(),ke=[];for(const Ee of ae(Q))for(const ve of ae(pe))ke.push(fe.create([Ee,ve],null,!1));F.unshift(Se.create(ke,null,!1))}this.c=Se.create(F,this,!0)}return this.c}}e.ContextKeyOrExpr=Se;class ie extends r{static all(){return ie.d.values()}constructor(F,Q,pe){super(F,null),this.f=Q,typeof pe=="object"?ie.d.push({...pe,key:F}):pe!==!0&&ie.d.push({key:F,description:pe,type:Q!=null?typeof Q:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return c.create(this.key,F)}notEqualsTo(F){return w.create(this.key,F)}}ie.d=[],e.RawContextKey=ie,e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function ue(j,F){return j<F?-1:j>F?1:0}function ce(j,F,Q,pe){return j<Q?-1:j>Q?1:F<pe?-1:F>pe?1:0}function Te(j,F){if(j.type===0||F.type===1)return!0;if(j.type===9)return F.type===9?de(j.expr,F.expr):!1;if(F.type===9){for(const Q of F.expr)if(Te(j,Q))return!0;return!1}if(j.type===6){if(F.type===6)return de(F.expr,j.expr);for(const Q of j.expr)if(Te(Q,F))return!0;return!1}return j.equals(F)}e.implies=Te;function de(j,F){let Q=0,pe=0;for(;Q<j.length&&pe<F.length;){const ke=j[Q].cmp(F[pe]);if(ke<0)return!1;ke===0&&Q++,pe++}return Q===j.length}function ae(j){return j.type===9?j.expr:[j]}}),define(Ae[166],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[90],Re([1,0,138,3]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function R(d,S){switch(d){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function A(d,S){return S==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function I(d,S,T){return A(S,T)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===T?!0:m(T).includes(d)}e.isTargetPlatformCompatible=I;function m(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var y;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var h;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var E;(function(d){d.Install="install",d.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var l;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(l=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var t;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class a extends Error{constructor(S,T){super(S),this.code=T,this.name=T}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Ae[43],Re([1,0,48,19,13,10,2,140,3,20,15]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function y(ie){return ie.create===!0}e.isFileOpenForWriteOptions=y;var h;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var E;(function(ie){ie[ie.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var g;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function l(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=l;function t(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(ie){return!!(ie.capabilities&32768)}e.hasFileCloneCapability=a;function d(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function S(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=S;function T(ie){return l(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=T;var p;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(ue,ce){const Te=new i(ue.toString(),ce);return o(Te,ce),Te}constructor(ue,ce){super(ue),this.code=ce}}e.FileSystemProviderError=i;function u(ie,ue){return i.create(ie,ue)}e.createFileSystemProviderError=u;function s(ie){return ie||u((0,A.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function o(ie,ue){return ie.name=ue?`${ue} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=o;function f(ie){if(!ie)return p.Unknown;if(ie instanceof i)return ie.code;const ue=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ue)return p.Unknown;switch(ue[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=f;function b(ie){if(ie instanceof H)return ie.fileOperationResult;switch(f(ie)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var r;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(ue,ce,Te){this.resource=ue,this.operation=ce,this.target=Te}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=c;var v;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class D{constructor(ue,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Te=new Map;for(const de of ue){const ae=Te.get(de.type);switch(ae?ae.push([de.resource,de]):Te.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,ae]of Te)switch(de){case 1:this.a=n.TernarySearchTree.forUris(()=>ce),this.a.fill(ae);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ce),this.b.fill(ae);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ce),this.c.fill(ae);break}}contains(ue,...ce){return this.d(ue,{includeChildren:!1},...ce)}affects(ue,...ce){return this.d(ue,{includeChildren:!0},...ce)}d(ue,ce,...Te){if(!ue)return!1;const de=Te.length>0;return!!((!de||Te.includes(1))&&(this.a?.get(ue)||ce.includeChildren&&this.a?.findSuperstr(ue))||(!de||Te.includes(0))&&(this.b?.get(ue)||ce.includeChildren&&this.b?.findSuperstr(ue))||(!de||Te.includes(2))&&(this.c?.findSubstr(ue)||ce.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=D;function w(ie,ue,ce){return!ie||!ue||ie===ue||ue.length>ie.length?!1:(ue.charAt(ue.length-1)!==P.sep&&(ue+=P.sep),ce?(0,k.startsWithIgnoreCase)(ie,ue):ie.indexOf(ue)===0)}e.isParent=w;class H extends Error{constructor(ue,ce,Te){super(ue),this.fileOperationResult=ce,this.options=Te}}e.FileOperationError=H;class X extends H{constructor(ue,ce,Te,de){super(ue,ce,de),this.fileOperationResult=ce,this.size=Te}}e.TooLargeFileOperationError=X;class J extends H{constructor(ue,ce,Te){super(ue,2,Te),this.stat=ce}}e.NotModifiedSinceFileOperationError=J;var G;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ie[ie.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=B;async function $(ie,ue){if(!ue.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(ce=>{const Te=ue.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===ie.scheme&&de.added&&(Te.dispose(),ce())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(ue){return(0,M.isNumber)(ue)||(ue=0),ue<W.KB?(0,A.localize)(1,null,ue.toFixed(0)):ue<W.MB?(0,A.localize)(2,null,(ue/W.KB).toFixed(2)):ue<W.GB?(0,A.localize)(3,null,(ue/W.MB).toFixed(2)):ue<W.TB?(0,A.localize)(4,null,(ue/W.GB).toFixed(2)):(0,A.localize)(5,null,(ue/W.TB).toFixed(2))}}W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB,e.ByteSize=W;var x;(function(ie){ie[ie.IA32=0]="IA32",ie[ie.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function fe(ie){return{maxFileSize:ie===0?300*W.MB:16*W.GB,maxHeapSize:ie===0?700*W.MB:2*700*W.MB}}e.getPlatformFileLimits=fe;function Se(ie){const ue=typeof ie=="string"||ie?.scheme===O.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===O.Schemas.file?1024*W.MB:ue?10*W.MB:m.isWeb?50*W.MB:1024*W.MB}e.getLargeFileConfirmationLimit=Se}),define(Ae[70],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...k){this.a=new Map;for(const[M,R]of k)this.set(M,R)}set(k,M){const R=this.a.get(k);return this.a.set(k,M),R}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=n}),define(Ae[167],Re([1,0,17,9,6,68,165,3,70,168]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class y extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class h{constructor(t=new I.ServiceCollection,a=!1,d,S=O){this.f=t,this.g=a,this.h=d,this.i=S,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=S?d?._globalGraph??new R.Graph(T=>T):void 0}createChild(t){return new h(t,this.g,this,this.i)}invokeFunction(t,...a){const d=g.traceInvocation(this.i,t);let S=!1;try{return t({get:p=>{if(S)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(p,d);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...a)}finally{S=!0,d.stop()}}createInstance(t,...a){let d,S;return t instanceof M.SyncDescriptor?(d=g.traceCreation(this.i,t.ctor),S=this.j(t.ctor,t.staticArguments.concat(a),d)):(d=g.traceCreation(this.i,t),S=this.j(t,a,d)),d.stop(),S}j(t,a=[],d){const S=A._util.getServiceDependencies(t).sort((i,u)=>i.index-u.index),T=[];for(const i of S){const u=this.m(i.id,d);u||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),T.push(u)}const p=S.length>0?S[0].index:a.length;if(a.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${a.length} static arguments`);const i=p-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,p)}return Reflect.construct(t,a.concat(T))}k(t,a){if(this.f.get(t)instanceof M.SyncDescriptor)this.f.set(t,a);else if(this.h)this.h.k(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const a=this.f.get(t);return!a&&this.h?this.h.l(t):a}m(t,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const d=this.l(t);return d instanceof M.SyncDescriptor?this.q(t,d,a.branch(t,!0)):(a.branch(t,!1),d)}q(t,a,d){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,a,d)}finally{this.o.delete(t)}}r(t,a,d){const S=new R.Graph(i=>i.id.toString());let T=0;const p=[{id:t,desc:a,_trace:d}];for(;p.length;){const i=p.pop();if(S.lookupOrInsertNode(i),T++>1e3)throw new y(S);for(const u of A._util.getServiceDependencies(i.desc.ctor)){const s=this.l(u.id);if(s||this.u(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(u.id)),s instanceof M.SyncDescriptor){const o={id:u.id,desc:s,_trace:i._trace.branch(u.id,!0)};S.insertEdge(i,o),p.push(o)}}}for(;;){const i=S.roots();if(i.length===0){if(!S.isEmpty())throw new y(S);break}for(const{data:u}of i){if(this.l(u.id)instanceof M.SyncDescriptor){const o=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,o)}S.removeNode(u)}}return this.l(t)}s(t,a,d=[],S,T){if(this.f.get(t)instanceof M.SyncDescriptor)return this.t(t,a,d,S,T);if(this.h)return this.h.s(t,a,d,S,T);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(t,a,d=[],S,T){if(S){const p=new h(void 0,this.g,this,this.i);p.c=String(t);const i=new Map,u=new n.IdleValue(()=>{const s=p.j(a,d,T);for(const[o,f]of i){const b=s[o];if(typeof b=="function")for(const r of f)b.apply(s,r)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!u.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let r=i.get(o);return r||(r=new m.LinkedList,i.set(o,r)),(v,D,w)=>{const H=r.push([v,D,w]);return(0,k.toDisposable)(H)}}if(o in s)return s[o];const f=u.value;let b=f[o];return typeof b!="function"||(b=b.bind(f),s[o]=b),b},set(s,o,f){return u.value[o]=f,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,d,T)}u(t,a){if(a&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=h;var E;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(E||(E={}));class g{static traceInvocation(t,a){return t?new g(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(t,a){return t?new g(1,a.name):g.c}constructor(t,a){this.type=t,this.name=a,this.g=Date.now(),this.h=[]}branch(t,a){const d=new g(3,t.toString());return this.h.push([t,a,d]),d}stop(){const t=Date.now()-this.g;g.f+=t;let a=!1;function d(T,p){const i=[],u=new Array(T+1).join("	");for(const[s,o,f]of p.h)if(o&&f){a=!0,i.push(`${u}CREATES -> ${s}`);const b=d(T+1,f);b&&i.push(b)}else i.push(`${u}uses -> ${s}`);return i.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(t>2||a)&&g.all.add(S.join(`
`))}}g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0,e.Trace=g}),define(Ae[14],Re([1,0,40,4,91,6,28,20,22,10,2,31,3]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function E(){return new Date().toISOString()}function g(v){return(0,m.isNumber)(v)}e.isLogLevel=g;var l;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function t(v,D,w){switch(D){case l.Trace:v.trace(w);break;case l.Debug:v.debug(w);break;case l.Info:v.info(w);break;case l.Warning:v.warn(w);break;case l.Error:v.error(w);break;case l.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=t;function a(v,D=!1){let w="";for(let H=0;H<v.length;H++){let X=v[H];if(X instanceof Error&&(X=(0,n.toErrorMessage)(X,D)),typeof X=="object")try{X=JSON.stringify(X)}catch{}w+=(H>0?" ":"")+X}return w}class d extends M.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new P.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==l.Off&&this.b<=D}}e.AbstractLogger=d;class S extends d{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...w){this.f(l.Trace)&&this.g(l.Trace,a([D,...w],!0))}debug(D,...w){this.f(l.Debug)&&this.g(l.Debug,a([D,...w]))}info(D,...w){this.f(l.Info)&&this.g(l.Info,a([D,...w]))}warn(D,...w){this.f(l.Warning)&&this.g(l.Warning,a([D,...w]))}error(D,...w){if(this.f(l.Error))if(D instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=D.stack,this.g(l.Error,a(H))}else this.g(l.Error,a([D,...w]))}flush(){}}e.AbstractMessageLogger=S;class T extends d{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.g=!A.isWindows}trace(D,...w){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...w):console.log(`[main ${E()}]`,D,...w))}debug(D,...w){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...w):console.log(`[main ${E()}]`,D,...w))}info(D,...w){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,D,...w):console.log(`[main ${E()}]`,D,...w))}warn(D,...w){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,D,...w):console.warn(`[main ${E()}]`,D,...w))}error(D,...w){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,D,...w):console.error(`[main ${E()}]`,D,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class p extends d{constructor(D=e.DEFAULT_LOG_LEVEL,w=!0){super(),this.g=w,this.setLevel(D)}trace(D,...w){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...w):console.log(D,...w))}debug(D,...w){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...w):console.log(D,...w))}info(D,...w){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...w):console.log(D,...w))}warn(D,...w){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...w):console.log(D,...w))}error(D,...w){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...w):console.error(D,...w))}dispose(){}flush(){}}e.ConsoleLogger=p;class i extends d{constructor(D,w=e.DEFAULT_LOG_LEVEL){super(),this.g=D,this.setLevel(w)}trace(D,...w){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(D),...w])}debug(D,...w){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(D),...w])}info(D,...w){this.f(l.Info)&&this.g.log(l.Info,[this.h(D),...w])}warn(D,...w){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(D),...w])}error(D,...w){this.f(l.Error)&&this.g.log(l.Error,[this.h(D),...w])}h(D){return typeof D=="string"?D:(0,n.toErrorMessage)(D,this.f(l.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class u extends d{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const w of this.g)w.setLevel(D);super.setLevel(D)}trace(D,...w){for(const H of this.g)H.trace(D,...w)}debug(D,...w){for(const H of this.g)H.debug(D,...w)}info(D,...w){for(const H of this.g)H.info(D,...w)}warn(D,...w){for(const H of this.g)H.warn(D,...w)}error(D,...w){for(const H of this.g)H.error(D,...w)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.MultiplexLogger=u;class s extends M.Disposable{constructor(D,w,H){if(super(),this.h=D,this.j=w,this.b=new R.ResourceMap,this.c=this.B(new P.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeVisibility=this.g.event,H)for(const X of H)this.b.set(X.resource,{logger:void 0,info:X})}k(D){return(0,m.isString)(D)?[...this.b.values()].find(w=>w.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,w){const H=this.l(D),X=(0,m.isString)(D)?D:w?.id??(0,k.hash)(H.toString()).toString(16);let J=this.b.get(H)?.logger;const G=w?.logLevel==="always"?l.Trace:w?.logLevel;J||(J=this.m(H,G??this.getLogLevel(H)??this.h,{...w,id:X}));const U={logger:J,info:{resource:H,id:X,logLevel:G,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(U.info),this.b.set(H,U),J}l(D){return(0,m.isString)(D)?(0,I.joinPath)(this.j,`${D}.log`):D}setLogLevel(D,w){if(O.URI.isUri(D)){const H=D,X=w,J=this.b.get(H);J&&X!==J.info.logLevel&&(J.info.logLevel=X===this.h?void 0:X,J.logger?.setLevel(X),this.b.set(J.info.resource,J),this.f.fire([H,X]))}else{this.h=D;for(const[H,X]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,w){const H=this.k(D);H&&w!==!H.info.hidden&&(H.info.hidden=!w,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,w]))}getLogLevel(D){let w;return D&&(w=this.b.get(D)?.info.logLevel),w??this.h}registerLogger(D){const w=this.b.get(D.resource);w?w.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const w=this.b.get(D);w&&(w.logger&&w.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class o{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(D){}getLevel(){return l.Info}trace(D,...w){}debug(D,...w){}info(D,...w){}warn(D,...w){}error(D,...w){}critical(D,...w){}dispose(){}flush(){}}e.NullLogger=o;class f extends o{}e.NullLogService=f;function b(v){if(v.verbose)return l.Trace;if(typeof v.logLevel=="string"){const D=c(v.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function r(v){switch(v){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=r;function c(v){switch(v){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=c,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",r(l.Info))}),define(Ae[169],Re([1,0,6,14]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends n.Disposable{constructor(R,A=[]){super(),this.a=new P.MultiplexLogger([R,...A]),this.B(R.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.LogService=k}),define(Ae[92],Re([1,0,29,141,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(I){I[I.Unnecessary=1]="Unnecessary",I[I.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var R;(function(I){I[I.Hint=1]="Hint",I[I.Info=2]="Info",I[I.Warning=4]="Warning",I[I.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(I){function m(g,l){return l-g}I.compare=m;const O=Object.create(null);O[I.Error]=(0,P.localize)(0,null),O[I.Warning]=(0,P.localize)(1,null),O[I.Info]=(0,P.localize)(2,null);function y(g){return O[g]||""}I.toString=y;function h(g){switch(g){case n.default.Error:return I.Error;case n.default.Warning:return I.Warning;case n.default.Info:return I.Info;case n.default.Ignore:return I.Hint}}I.fromSeverity=h;function E(g){switch(g){case I.Error:return n.default.Error;case I.Warning:return n.default.Warning;case I.Info:return n.default.Info;case I.Hint:return n.default.Ignore}}I.toSeverity=E}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(I){const m="";function O(h){return y(h,!0)}I.makeKey=O;function y(h,E){const g=[m];return h.source?g.push(h.source.replace("\xA6","\\\xA6")):g.push(m),h.code?typeof h.code=="string"?g.push(h.code.replace("\xA6","\\\xA6")):g.push(h.code.value.replace("\xA6","\\\xA6")):g.push(m),h.severity!==void 0&&h.severity!==null?g.push(R.toString(h.severity)):g.push(m),h.message&&E?g.push(h.message.replace("\xA6","\\\xA6")):g.push(m),h.startLineNumber!==void 0&&h.startLineNumber!==null?g.push(h.startLineNumber.toString()):g.push(m),h.startColumn!==void 0&&h.startColumn!==null?g.push(h.startColumn.toString()):g.push(m),h.endLineNumber!==void 0&&h.endLineNumber!==null?g.push(h.endLineNumber.toString()):g.push(m),h.endColumn!==void 0&&h.endColumn!==null?g.push(h.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}I.makeKeyOptionalMessage=y})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Ae[170],Re([1,0,4,29,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,k.createDecorator)("notificationService");var M;(function(O){O[O.DEFAULT=0]="DEFAULT",O[O.SILENT=1]="SILENT",O[O.URGENT=2]="URGENT"})(M=e.NotificationPriority||(e.NotificationPriority={}));var R;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.PROFILE=1]="PROFILE",O[O.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new m,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(y){}updateMessage(y){}updateActions(y){}close(){}}e.NoOpNotification=I;class m{infinite(){}done(){}total(y){}worked(y){}}e.NoOpProgress=m}),define(Ae[93],Re([1,0,13,2,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function M(m,O){return P.URI.isUri(m)?(0,n.equalsIgnoreCase)(m.scheme,O):(0,n.startsWithIgnoreCase)(m,O+":")}e.matchesScheme=M;function R(m,...O){return O.some(y=>M(m,y))}e.matchesSomeScheme=R;function A(m,O){return m.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function I(m){let O;const y=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return y&&(O={startLineNumber:parseInt(y[1]),startColumn:y[2]?parseInt(y[2]):1,endLineNumber:y[4]?parseInt(y[4]):void 0,endColumn:y[4]?y[5]?parseInt(y[5]):1:void 0},m=m.with({fragment:""})),{selection:O,uri:m}}e.extractSelection=I}),define(Ae[171],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,n,P){var k=arguments.length,M=k<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,n):P,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ee,e,n,P);else for(var A=ee.length-1;A>=0;A--)(R=ee[A])&&(M=(k<3?R(M):k>3?R(e,n,M):R(e,n))||M);return k>3&&M&&Object.defineProperty(e,n,M),M},je=this&&this.__param||function(ee,e){return function(n,P){e(n,P,ee)}};define(Ae[172],Re([1,0,17,21,6,3]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var R;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(y){this.b=y}report(y){this.a=y,this.b(this.a)}}A.None=Object.freeze({report(){}}),e.Progress=A;let I=class extends k.Disposable{constructor(y,h){super(),this.a=new n.DeferredPromise,h.withProgress(y,E=>(this.b=E,this.c&&E.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(y){this.b?this.b.report(y):this.c=y}};I=qe([je(1,e.IProgressService)],I),e.UnmanagedProgress=I;class m extends k.Disposable{constructor(y){super(),this.g=y,this.a=0,this.b=this.B(new k.DisposableStore)}start(y){this.stop();const h=++this.a,E=new P.CancellationTokenSource;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},y),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>E.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:h,token:E.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(y){this.a===y&&this.b.clear()}}e.LongRunningOperation=m,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,49,10]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(R,A){n.ok(P.isString(R)),n.ok(P.isObject(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new k}),define(Ae[71],Re([1,0,4,30]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,m){this.a[k(I)]=m,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;P.Registry.add(e.Extensions.JSONContribution,R)}),define(Ae[94],Re([1,0,16,4,10,135,42,71,30]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=I.Registry.as(A.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new P.Emitter,this.onDidSchemaChange=this.i.event,this.j=new P.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const s=new Set;this.n(i,u,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const u=new Set;this.o(i,u),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:i,remove:u}){const s=new Set;this.o(u,s),this.n(i,!1,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const u=new Set;this.k(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(i,u){const s=[];for(const{overrides:o,source:f}of i)for(const b in o)if(u.add(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const r=this.a.get(b),c=r?.valuesSources??new Map;if(f)for(const H of Object.keys(o[b]))c.set(H,f);const v={...r?.value||{},...o[b]};this.a.set(b,{source:f,value:v,valuesSources:c});const D=(0,R.getLanguageTagSettingPlainKey)(b),w={type:"object",default:v,description:M.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:k.isString(f)?void 0:f,defaultValueSource:f};s.push(...l(b)),this.d[b]=w,this.b.properties[b]=w}else{this.a.set(b,{value:o[b],source:f});const r=this.d[b];r&&(this.w(b,r),this.r(b,r))}this.m(s)}deregisterDefaultConfigurations(i){const u=new Set;this.l(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(i,u){for(const{overrides:s,source:o}of i)for(const f in s){const b=this.a.get(f),r=k.isString(o)?o:o?.id,c=k.isString(b?.source)?b?.source:b?.source?.id;if(r===c)if(u.add(f),this.a.delete(f),e.OVERRIDE_PROPERTY_REGEX.test(f))delete this.d[f],delete this.b.properties[f];else{const v=this.d[f];v&&(this.w(f,v),this.r(f,v))}}this.u()}deltaConfiguration(i){let u=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),u=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),u=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const u of i)this.h.add(u);this.u()}n(i,u,s){i.forEach(o=>{this.p(o,u,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(i,u){const s=o=>{if(o.properties)for(const f in o.properties){u.add(f);const b=this.d[f];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[f],this.s(f,o.properties[f])}o.allOf?.forEach(f=>s(f))};for(const o of i){s(o);const f=this.c.indexOf(o);f!==-1&&this.c.splice(f,1)}}p(i,u=!0,s,o,f=3,b){f=k.isUndefinedOrNull(i.scope)?f:i.scope;const r=i.properties;if(r)for(const v in r){const D=r[v];if(u&&S(v,D)){delete r[v];continue}if(D.source=s,D.defaultDefaultValue=r[v].default,this.w(v,D),e.OVERRIDE_PROPERTY_REGEX.test(v)?D.scope=void 0:(D.scope=k.isUndefinedOrNull(D.scope)?f:D.scope,D.restricted=k.isUndefinedOrNull(D.restricted)?!!o?.includes(v):D.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.f[v]=r[v],delete r[v];continue}else this.d[v]=r[v],r[v].policy?.name&&this.e.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),b.add(v)}const c=i.allOf;if(c)for(const v of c)this.p(v,u,s,o,f,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const u=s=>{const o=s.properties;if(o)for(const b in o)this.r(b,o[b]);s.allOf?.forEach(u)};u(i)}r(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.g.properties[i]=u;break}}s(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const u=`[${i}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(u,s),e.allSettings.properties[u]=s,e.applicationSettings.properties[u]=s,e.machineSettings.properties[u]=s,e.machineOverridableSettings.properties[u]=s,e.windowSettings.properties[u]=s,e.resourceSettings.properties[u]=s}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,u){const s=this.a.get(i);let o=s?.value,f=s?.source;k.isUndefined(o)&&(o=u.defaultDefaultValue,f=void 0),k.isUndefined(o)&&(o=a(u.type)),u.default=o,u.defaultValueSource=f}}const E="\\[([^\\]]+)\\]",g=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let u=g.exec(p);for(;u?.length;){const s=u[1].trim();s&&i.push(s),u=g.exec(p)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=l;function t(p){return p.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=t;function a(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const d=new h;I.Registry.add(e.Extensions.Configuration,d);function S(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):d.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,p,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=S;function T(){const p=[],i=d.getConfigurationProperties();for(const u of Object.keys(i))p.push([u,i[u].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=T}),define(Ae[173],Re([1,0,16,4,113,6,28,23,10,2,42,94,30]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(u){return Object.isFrozen(u)?u:A.deepFreeze(u)}class g{constructor(s={},o=[],f=[],b){this.b=s,this.c=o,this.d=f,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof g)return o;const f=new l("");return f.parseRaw(o),f.configurationModel});this.f=s.reduce((o,f)=>f===o?f:o.merge(f),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,O.getConfigurationValue)(this.contents,s):this.contents}inspect(s,o){const f=this.rawConfiguration.getValue(s),b=o?this.rawConfiguration.getOverrideValue(s,o):void 0,r=o?this.rawConfiguration.override(o).getValue(s):f;return{value:f,override:b,merged:r}}getOverrideValue(s,o){const f=this.i(o);return f?s?(0,O.getConfigurationValue)(f,s):f:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const f of this.overrides)f.identifiers.includes(s)&&o.push(...f.keys);return n.distinct(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return n.distinct(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=A.deepClone(this.contents),f=A.deepClone(this.overrides),b=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const c of s)if(r.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(o,c.contents);for(const v of c.overrides){const[D]=f.filter(w=>n.equals(w.identifiers,v.identifiers));D?(this.h(D.contents,v.contents),D.keys.push(...v.keys),D.keys=n.distinct(D.keys)):f.push(A.deepClone(v))}for(const v of c.keys)b.indexOf(v)===-1&&b.push(v)}return new g(o,b,f,r.every(c=>c instanceof g)?void 0:r)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const f={};for(const b of n.distinct([...Object.keys(this.contents),...Object.keys(o)])){let r=this.contents[b];const c=o[b];c&&(typeof r=="object"&&typeof c=="object"?(r=A.deepClone(r),this.h(r,c)):r=c),f[b]=r}return new g(f,this.keys,this.overrides)}h(s,o){for(const f of Object.keys(o)){if(f in s&&I.isObject(s[f])&&I.isObject(o[f])){this.h(s[f],o[f]);continue}s[f]=A.deepClone(o[f])}}i(s){let o=null,f=null;const b=r=>{r&&(f?this.h(f,r):f=A.deepClone(r))};for(const r of this.overrides)n.equals(r.identifiers,[s])?o=r.contents:r.identifiers.includes(s)&&b(r.contents);return b(o),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,O.removeFromValueTree)(this.contents,s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(f=>n.equals(f.identifiers,(0,y.overrideIdentifiersFromKey)(s))),1))}j(s,o,f){(0,O.addToValueTree)(this.contents,s,o,b=>console.error(b)),f=f||this.keys.indexOf(s)===-1,f&&this.keys.push(s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,O.toValuesTree)(this.contents[s],b=>console.error(b))})}}e.ConfigurationModel=g;class l{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!I.isUndefinedOrNull(s)){const f=this.g(s);this.parseRaw(f,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:f,keys:b,overrides:r,restricted:c,hasExcludedProperties:v}=this.h(s,o);this.b=new g(f,b,r,v?[s]:void 0),this.c=c||[]}g(s){let o={},f=null,b=[];const r=[],c=[];function v(w){Array.isArray(b)?b.push(w):f!==null&&(b[f]=w)}const D={onObjectBegin:()=>{const w={};v(w),r.push(b),b=w,f=null},onObjectProperty:w=>{f=w},onObjectEnd:()=>{b=r.pop()},onArrayBegin:()=>{const w=[];v(w),r.push(b),b=w,f=null},onArrayEnd:()=>{b=r.pop()},onLiteralValue:v,onError:(w,H,X)=>{c.push({error:w,offset:H,length:X})}};if(s)try{k.visit(s,D),o=b[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return o}h(s,o){const f=h.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),b=this.i(s,f,!0,o);s=b.raw;const r=(0,O.toValuesTree)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),c=Object.keys(s),v=this.j(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:r,keys:c,overrides:v,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(s,o,f,b){let r=!1;if(!b?.scopes&&!b?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:r};const c={},v=[];for(const D in s)if(y.OVERRIDE_PROPERTY_REGEX.test(D)&&f){const w=this.i(s[D],o,!1,b);c[D]=w.raw,r=r||w.hasExcludedProperties,v.push(...w.restricted)}else{const w=o[D],H=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&v.push(D),(H===void 0||b.scopes===void 0||b.scopes.includes(H))&&!(b.skipRestricted&&w?.restricted)?c[D]=s[D]:r=!0}return{raw:c,restricted:v,hasExcludedProperties:r}}j(s,o){const f=[];for(const b of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(b)){const r={};for(const c in s[b])r[c]=s[b][c];f.push({identifiers:(0,y.overrideIdentifiersFromKey)(b),keys:Object.keys(r),contents:(0,O.toValuesTree)(r,o)})}return f}}e.ConfigurationModelParser=l;class t extends M.Disposable{constructor(s,o,f,b){super(),this.f=s,this.g=o,this.h=b,this.c=this.B(new P.Emitter),this.onDidChange=this.c.event,this.a=new l(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(f.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(P.Event.any(P.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),P.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&f.isEqual(r.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(s,o,f,b,r,c,v,D,w,H,X,J,G){this.a=s,this.b=o,this.c=f,this.overrideIdentifiers=b,this.d=r,this.f=c,this.g=v,this.h=D,this.i=w,this.j=H,this.k=X,this.l=J,this.m=G}get value(){return E(this.c)}n(s,o,f){const b=s.inspect(o,f);return{get value(){return E(b.value)},get override(){return E(b.override)},get merged(){return E(b.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(s,o,f,b,r=new g,c=new g,v=new R.ResourceMap,D=new g,w=new R.ResourceMap){this.c=s,this.d=o,this.f=f,this.g=b,this.h=r,this.i=c,this.j=v,this.l=D,this.m=w,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(s,o,f){return this.q(s,o,f).getValue(s)}updateValue(s,o,f={}){let b;f.resource?(b=this.m.get(f.resource),b||(b=new g,this.m.set(f.resource,b))):b=this.l,o===void 0?b.removeValue(s):b.setValue(s,o),f.resource||(this.a=null)}inspect(s,o,f){const b=this.q(s,o,f),r=this.u(o.resource,f),c=o.resource?this.m.get(o.resource)||this.l:this.l,v=new Set;for(const D of b.overrides)for(const w of D.identifiers)b.getOverrideValue(s,w)!==void 0&&v.add(w);return new a(s,o,b.getValue(s),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.i:void 0,r||void 0,c)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const f=[];if(!o){const{added:b,updated:r,removed:c}=p(this.c,s);o=[...b,...r,...c]}for(const b of o)for(const r of(0,y.overrideIdentifiersFromKey)(b)){const c=this.c.getKeysForOverrideIdentifier(r),v=s.getKeysForOverrideIdentifier(r),D=[...v.filter(w=>c.indexOf(w)===-1),...c.filter(w=>v.indexOf(w)===-1),...c.filter(w=>!A.equals(this.c.override(r).getValue(w),s.override(r).getValue(w)))];f.push([r,D])}return this.updateDefaultConfiguration(s),{keys:o,overrides:f}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:f,removed:b}=p(this.d,s),r=[...o,...f,...b];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:f,removed:b,overrides:r}=p(this.applicationConfiguration,s),c=[...o,...f,...b];return c.length&&this.updateApplicationConfiguration(s),{keys:c,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:f,removed:b,overrides:r}=p(this.localUserConfiguration,s),c=[...o,...f,...b];return c.length&&this.updateLocalUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:f,removed:b,overrides:r}=p(this.remoteUserConfiguration,s),c=[...o,...f,...b];return c.length&&this.updateRemoteUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:f,removed:b,overrides:r}=p(this.workspaceConfiguration,s),c=[...o,...f,...b];return c.length&&this.updateWorkspaceConfiguration(s),{keys:c,overrides:r}}compareAndUpdateFolderConfiguration(s,o){const f=this.p.get(s),{added:b,updated:r,removed:c,overrides:v}=p(f,o),D=[...b,...r,...c];return(D.length||!f)&&this.updateFolderConfiguration(s,o),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:f,updated:b,removed:r,overrides:c}=p(o,void 0);return{keys:[...f,...b,...r],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,f){let b=this.r(o,f);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(b=b.merge(this.d)),b}r({resource:s},o){let f=this.s();if(o&&s){const b=o.getFolder(s);b&&(f=this.t(b.uri)||f);const r=this.m.get(s);r&&(f=f.merge(r))}return f}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const f=this.s(),b=this.j.get(s);b?(o=f.merge(b),this.b.set(s,o)):o=f}return o}u(s,o){if(o&&s){const f=o.getFolder(s);if(f)return this.j.get(f.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:f,overrides:b,keys:r}=this.j.get(o);return s.push([o,{contents:f,overrides:b,keys:r}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(f=>s.add(f))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(f=>s.add(f))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this.i.getKeysForOverrideIdentifier(s).forEach(f=>o.add(f)),this.j.forEach(f=>f.getKeysForOverrideIdentifier(s).forEach(b=>o.add(b))),[...o.values()]}static parse(s){const o=this.x(s.defaults),f=this.x(s.policy),b=this.x(s.application),r=this.x(s.user),c=this.x(s.workspace),v=s.folders.reduce((D,w)=>(D.set(m.URI.revive(w[0]),this.x(w[1])),D),new R.ResourceMap);return new d(o,f,b,r,new g,c,v,new g,new R.ResourceMap)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.Configuration=d;function S(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,o=new Map;for(const b of u)b.keys.forEach(r=>s.add(r)),b.overrides.forEach(([r,c])=>{const v=(0,R.getOrSet)(o,r,new Set);c.forEach(D=>v.add(D))});const f=[];return o.forEach((b,r)=>f.push([r,[...b.values()]])),{keys:[...s.values()],overrides:f}}e.mergeChanges=S;class T{constructor(s,o,f,b){this.change=s,this.f=o,this.g=f,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of s.keys)this.affectedKeys.add(r);for(const[,r]of s.overrides)for(const c of r)this.affectedKeys.add(c);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(s,o){const f=this.a+s,b=this.d.indexOf(f);if(b<0)return!1;const r=b+f.length;if(r>=this.d.length)return!1;const c=this.d.charCodeAt(r);if(c!==this.b&&c!==this.c)return!1;if(o){const v=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,D=this.g.getValue(s,o,this.h);return!A.equals(v,D)}return!0}}e.ConfigurationChangeEvent=T;function p(u,s){const{added:o,removed:f,updated:b}=i(s?.rawConfiguration,u?.rawConfiguration),r=[],c=u?.getAllOverrideIdentifiers()||[],v=s?.getAllOverrideIdentifiers()||[];if(s){const D=v.filter(w=>!c.includes(w));for(const w of D)r.push([w,s.getKeysForOverrideIdentifier(w)])}if(u){const D=c.filter(w=>!v.includes(w));for(const w of D)r.push([w,u.getKeysForOverrideIdentifier(w)])}if(s&&u){for(const D of c)if(v.includes(D)){const w=i({contents:u.getOverrideValue(void 0,D)||{},keys:u.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});r.push([D,[...w.added,...w.removed,...w.updated]])}}return{added:o,removed:f,updated:b,overrides:r}}function i(u,s){const o=u?s?u.keys.filter(r=>s.keys.indexOf(r)===-1):[...u.keys]:[],f=s?u?s.keys.filter(r=>u.keys.indexOf(r)===-1):[...s.keys]:[],b=[];if(u&&s){for(const r of s.keys)if(u.keys.indexOf(r)!==-1){const c=(0,O.getConfigurationValue)(s.contents,r),v=(0,O.getConfigurationValue)(u.contents,r);A.equals(c,v)||b.push(r)}}return{added:o,removed:f,updated:b}}}),define(Ae[95],Re([1,0,9,3]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof M&&I._code===k.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof M&&I._code===k.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof M&&I._code===k.NoResolverFound}static isHandled(I){return I instanceof M&&I.isHandled}constructor(I,m=k.Unknown,O){super(I),this._message=I,this._code=m,this._detail=O,this.isHandled=m===k.NotAvailable&&O===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function R(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.getRemoteAuthorityPrefix=R}),define(Ae[50],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(m){return m.scheme===n.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=P;function k(m){if(!m)return;const O=m.indexOf("+");return O<0?m:m.substr(0,O)}e.getRemoteName=k;function M(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=M;function R(m){const{host:O,port:y}=I(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:y}}e.parseAuthorityWithPort=R;function A(m,O){let{host:y,port:h}=I(m);return typeof h>"u"&&(h=O),{host:y,port:h}}e.parseAuthorityWithOptionalPort=A;function I(m){const O=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const h=m.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:m,port:void 0}}}),define(Ae[24],Re([1,0,13,3,50]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var A;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const d=typeof t=="string"?t:t.value,S=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(d,S)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=I;class m{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const a of t)this.add(a)}add(t){this.c.add(I.toKey(t))}delete(t){return this.c.delete(I.toKey(t))}has(t){return this.c.has(I.toKey(t))}}e.ExtensionIdentifierSet=m;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(I.toKey(t))}get(t){return this.c.get(I.toKey(t))}has(t){return this.c.has(I.toKey(t))}set(t,a){this.c.set(I.toKey(t),a)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function y(l){return h(l)}e.isApplicationScopedExtension=y;function h(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=h;function E(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function g(l,t){if(t){const a=`onResolveRemoteAuthority:${(0,k.getRemoteName)(t)}`;return!!l.activationEvents?.includes(a)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[96],Re([1,0,9,24]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const I of R){const m=this.readActivationEvents(I);m.length>0&&(A[P.ExtensionIdentifier.toKey(I.identifier)]=m)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return A;for(const I in R.contributes){const m=this.a.get(I);if(!m)continue;const O=R.contributes[I],y=Array.isArray(O)?O:[O];try{m(y,A)}catch(h){(0,n.onUnexpectedError)(h)}}return A}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(Ae[174],Re([1,0,20,51,35]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(I){if(n.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function R(I,m,O,y,h,E,g,l){const t=Object.create(null);t["common.machineId"]=E,t.sessionID=(0,k.generateUuid)()+Date.now(),t.commitHash=y,t.version=h,t["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,n.PlatformToString)(n.platform),t["common.nodePlatform"]=P.platform,t["common.nodeArch"]=O,t["common.product"]=l||"desktop",g&&(t["common.msftInternal"]=g);let a=0;const d=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),n.isLinuxSnap&&(t["common.snap"]="true");const S=M(m);return S&&(t["common.platformDetail"]=S),t}e.resolveCommonProperties=R;function A(I){const m=P.env.USERDNSDOMAIN;if(!m)return!1;const O=m.toLowerCase();return I.some(y=>O===y)}e.verifyMicrosoftInternalDomain=A}),define(Ae[175],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(P=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ae[52],Re([1,0,23,10,4,42,50,174,175]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(f){this.value=f}}e.TelemetryTrustedValue=m;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class y{async publicLog(f,b,r){}async publicLogError(f,b,r){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(o,f){return k.Event.debounce(f.onDidChangeConfiguration,(r,c)=>{const v=r?new Set([...r.affectedKeys,...c.affectedKeys]):c.affectedKeys;return{...c,affectedKeys:v}},1e3,!0)(r=>{r.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(r.source),configurationKeys:Array.from(r.affectedKeys)})})}e.configurationTelemetry=h;function E(o,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!o.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=E;function g(o,f){return!(f.isBuilt||f.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=g;function l(o){const f=o.getValue(I.TELEMETRY_SETTING_ID),b=o.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=l;function t(o){const f={},b={},r={};S(o,r);for(let c in r){c=c.length>150?c.substr(c.length-149):c;const v=r[c];typeof v=="number"?b[c]=v:typeof v=="boolean"?b[c]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${v.length}`),f[c]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(f[c]=v)}return{properties:f,measurements:b}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(o){if(!o)return"none";const f=(0,R.getRemoteName)(o);return a.has(f)?f:"other"}e.cleanRemoteAuthority=d;function S(o,f,b=0,r){if(!!o)for(const c of Object.getOwnPropertyNames(o)){const v=o[c],D=r?r+c:c;Array.isArray(v)?f[D]=(0,n.safeStringify)(v):v instanceof Date?f[D]=v.toISOString():(0,P.isObject)(v)?b<2?S(v,f,b+1,D+"."):f[D]=(0,n.safeStringify)(v):f[D]=v}}function T(o,f){const b=o.msftInternalDomains||[],r=f.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(b)||r}e.isInternalTelemetry=T;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=p;function i(o,f){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let b=o;const r=[];for(const w of f)for(;;){const H=w.exec(o);if(!H)break;r.push([H.index,w.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(b="";;){const w=v.exec(o);if(!w)break;const H=r.some(([X,J])=>w.index<J&&X<v.lastIndex);!c.test(w[0])&&!H&&(b+=o.substring(D,w.index)+"<REDACTED: user-file-path>",D=v.lastIndex)}return D<o.length&&(b+=o.substr(D)),b}function u(o){if(!o)return o;const f=o.toLowerCase(),b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of b)if(r.regex.test(f))return`<REDACTED: ${r.label}>`;return o}function s(o,f){return(0,n.cloneAndChange)(o,b=>{if(b instanceof m)return b.value;if(typeof b=="string"){let r=b.replaceAll("%20"," ");r=i(r,f);for(const c of f)r=r.replace(c,"");return r=u(r),r}})}e.cleanData=s}),define(Ae[176],Re([1,0,13,90,24,20,2,9,51,52]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,n.compareIgnoreCase)(s.id,o.id)===0}e.areSameExtensions=O;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(o){const f=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new h(o.identifier,f,b)}static parse(o){const f=y.exec(o);return f&&f[1]&&f[2]?new h({id:f[1]},f[2],f[4]||void 0):null}constructor(o,f,b="undefined"){this.version=f,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof h?O(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=h;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const o=E.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.getIdAndVersion=g;function l(s,o){return`${s}.${o}`}e.getExtensionId=l;function t(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(s,o){return t(l(s??k.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=a;function d(s,o){const f=[],b=r=>{for(const c of f)if(c.some(v=>O(o(v),o(r))))return c;return null};for(const r of s){const c=b(r);c?c.push(r):f.push([r])}return f}e.groupByExtension=d;function S(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function T(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function p(s,o){const f=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const r=b.shift();if(r&&f.every(c=>!O(c.identifier,{id:r}))){const c=s.filter(v=>O(v.identifier,{id:r}));c.length===1&&(f.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=p;async function i(s,o){if(!M.isLinux)return!1;let f;try{f=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){o.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(r))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,o){const f=await i(s,o),b=(0,P.getTargetPlatform)(f?"alpine":M.platform,I.arch);return o.debug("ComputeTargetPlatform:",b),b}e.computeTargetPlatform=u}),define(Ae[177],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=n;function P(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=P;function k(R){return Array.from(R.entries()).map(A=>[A[0],n(A[1].map)])}e.serializeEnvironmentVariableCollections=k;function M(R){return new Map(R.map(A=>[A[0],{map:P(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ae[178],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,M,R=5){const A=M(I=>{const m=typeof I=="string"?I:I.data;let O=this.a.get(k);if(O){O.data.push(m);return}const y=setTimeout(()=>this.flushBuffer(k),R);O={data:[m],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),A.dispose()}},this.a.set(k,O)});return A}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const M=this.a.get(k);M&&(this.a.delete(k),this.b(k,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ae[179],Re([1,0,17,85,39,4,10,2,142,71,30]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var y;(function(T){function p(i,u){let s=i.defaults;for(;k.ThemeIcon.isThemeIcon(s);){const o=g.getIcon(s.id);if(!o)return;s=o.defaults}return s}T.getDefinition=p})(y=e.IconContribution||(e.IconContribution={}));var h;(function(T){function p(u){return{weight:u.weight,style:u.style,src:u.src.map(s=>({format:s.format,location:s.location.toString()}))}}T.toJSONObject=p;function i(u){const s=o=>(0,R.isString)(o)?o:void 0;if(u&&Array.isArray(u.src)&&u.src.every(o=>(0,R.isString)(o.format)&&(0,R.isString)(o.location)))return{weight:s(u.weight),style:s(u.style),src:u.src.map(o=>({format:o.format,location:A.URI.parse(o.location)}))}}T.fromJSONObject=i})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class E{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${k.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,i,u,s){const o=this.b[p];if(o){if(u&&!o.description){o.description=u,this.d.properties[p].markdownDescription=`${u} $(${p})`;const r=this.e.enum.indexOf(p);r!==-1&&(this.e.enumDescriptions[r]=u),this.a.fire()}return o}const f={id:p,description:u,defaults:i,deprecationMessage:s};this.b[p]=f;const b={$ref:"#/definitions/icons"};return s&&(b.deprecationMessage=s),u&&(b.markdownDescription=`${u}: $(${p})`),this.d.properties[p]=b,this.e.enum.push(p),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,i){const u=this.f[p];return u||(this.f[p]=i,this.a.fire(),i)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(o,f)=>o.id.localeCompare(f.id),i=o=>{for(;k.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(f=>!!f.description).sort(p))u.push(`|<i class="${i(o)}"></i>|${o.id}|${k.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const o of s.filter(f=>!k.ThemeIcon.isThemeIcon(f.defaults)).sort(p))u.push(`|<i class="${i(o)}"></i>|${o.id}|`);return u.join(`
`)}}const g=new E;O.Registry.add(e.Extensions.IconContribution,g);function l(T,p,i,u){return g.registerIcon(T,p,i,u)}e.registerIcon=l;function t(){return g}e.getIconRegistry=t;function a(){const T=(0,P.getCodiconFontCharacters)();for(const p in T){const i="\\"+T[p].toString(16);g.registerIcon(p,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const d=O.Registry.as(m.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,g.getIconSchema());const S=new n.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{S.isScheduled()||S.schedule()}),e.widgetClose=l("widget-close",P.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=l("goto-previous-location",P.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=l("goto-next-location",P.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=k.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=k.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(Ae[180],Re([1,0,4,42,3,14]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var R;(function(l){l.Http="http",l.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=y;function h(l,t,a,d){if(a===1)return!1;if(a===2&&y(t)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(S?.length===4&&parseInt(S[1])>=18)return!1}return l<1024}e.isPortPrivileged=h;class E{constructor(t,a,d){this.remoteAddress=t,this.localAddress=a,this.b=d,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=E;let g=class{constructor(t,a){this.i=t,this.j=a,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],a=Array.from(this.d.values());for(const d of a){const S=Array.from(d.values());for(const T of S){const p=await T.value;p&&t.push(p)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:a}of t.values())await a.then(d=>d?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,a,d,S,T){this.o(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:d,privacy:S,protocol:T,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(y(t)||O(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const d=this.q(t,a);if(d)return++d.refcount,d.value}openTunnel(t,a,d,S,T,p=!1,i,u){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${d} on local port ${T}.`),!t)return;if(a||(a="localhost"),S||(S=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(t,a,d,S,T,p,i,u);return s?s.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.m(o);return(o.tunnelRemoteHost!==a||o.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(f),f}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.d.get(t.tunnelRemoteHost);if(a){const d=a.get(t.tunnelRemotePort);d&&(d.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,d))}}}}async n(t,a,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const S=d.value.then(async T=>{T&&(await T.dispose(!0),this.b.fire({host:T.tunnelRemoteHost,port:T.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(a),S}}async closeTunnel(t,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const d=this.d.get(t);if(d&&d.has(a)){const S=d.get(a);S.refcount=0,await this.n(t,a,S)}}o(t,a,d){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(a,{refcount:1,value:d})}async p(t,a){const d=this.d.get(t);d&&(await d.get(a)||d.delete(a),d.size===0&&this.d.delete(t))}q(t,a){const d=[t];O(t)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):y(t)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const S=d.map(T=>this.d.get(T));for(const T of S){const p=T?.get(a);if(p)return p}}canTunnel(t){return!!m(t)}s(t,a,d,S,T,p,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${d} on local port ${S}.`);const u=d;this.h.add(u);const s=S===void 0?d:S,o={elevationRequired:T?this.isPortPrivileged(s):!1},f={remoteAddress:{host:a,port:d},localAddressPort:S,privacy:p,public:p?p!==A.Private:void 0,protocol:i},b=t.forwardPort(f,o);return b?(this.o(a,d,b),b.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(u)})):this.h.delete(u),b}};g=qe([je(0,M.ILogService),je(1,P.IConfigurationService)],g),e.AbstractTunnelService=g}),define(Ae[181],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var P;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(P=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ae[182],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(I){return I.scheme!==n.Schemas.file&&I.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=P;function k(I){if(I.folders.length)return I.folders.every(m=>P(m.uri))?I.folders[0].uri:void 0;if(I.configuration&&P(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=k;function M(I){return k(I)?.scheme}e.getVirtualWorkspaceScheme=M;function R(I){return k(I)?.authority}e.getVirtualWorkspaceAuthority=R;function A(I){return k(I)!==void 0}e.isVirtualWorkspace=A}),define(Ae[53],Re([1,0,143,19,48,22,2,3,15]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function m(o){const f=o;return typeof f?.id=="string"&&R.URI.isUri(f.uri)}e.isSingleFolderWorkspaceIdentifier=m;function O(o){return typeof o?.id=="string"&&!m(o)&&!h(o)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(o,f){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,P.basename)(o)}:f?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.toWorkspaceIdentifier=y;function h(o){const f=o;return typeof f?.id=="string"&&R.URI.isUri(f.configPath)}e.isWorkspaceIdentifier=h;function E(o){const f=o;if(f?.uri)return{id:f.id,uri:R.URI.revive(f.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function l(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=l;function t(o){const f=o;return!!(f&&typeof f=="object"&&R.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(f,b,r,c,v){this.h=f,this.j=r,this.k=c,this.l=v,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=b}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class d{constructor(f,b){this.raw=b,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function S(o){return new d({uri:o,index:0,name:(0,M.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function T(o,f){return M.extUriBiasedIgnorePathCase.isEqualOrParent(o,f.untitledWorkspacesHome)}e.isUntitledWorkspace=T;function p(o){let f;return R.URI.isUri(o)?f=o:f=o.configuration,f?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function u(o,f){return!T(o,f)&&!p(o)}e.isSavedWorkspace=u;function s(o){return(typeof o=="string"?(0,P.extname)(o):(0,M.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ae[54],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const M=this.c++;return this.b.set(M,k),this.e(),M}get(k,M){return this.b.has(k)?this.b.get(k)[M]:void 0}delete(k){this.b.delete(k),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Ae[37],Re([1,0,15,22,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new P.ExtUri(A=>{const I=this.b.get(A.scheme);return!(I===void 0||I&1024)})}$acceptProviderInfos(A,I){I===null?this.b.delete(A.scheme):this.b.set(A.scheme,I)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ae[183],Re([1,0,147,14,169,27]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends k.LogService{constructor(I,m,O){const y=O.remote.isRemote?"remoteexthost":I?"workerexthost":"exthost",h=O.remote.isRemote?(0,n.localize)(0,null):I?(0,n.localize)(1,null):(0,n.localize)(2,null);super(m.createLogger(y,{name:h}))}};R=qe([je(1,P.ILoggerService),je(2,M.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(Ae[184],Re([1,0,17]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(R,A,I){this.h=new Map,this.a=R,this.b=A,this.c=I,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new n.RunOnceScheduler(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of m.values())O.complete()}catch(O){for(const y of m.values())y.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,A){let I=this.f[R];return typeof I>"u"&&(I=A),I}update(R,A){this.f[R]=A;const I=this.h.get(R);if(I!==void 0)return I.p;const m=new n.DeferredPromise;return this.h.set(R,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.ExtensionMemento=P;class k extends P{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,A){super(R.identifier.value,!0,A),this.j=R}}e.ExtensionGlobalMemento=k}),define(Ae[185],Re([1,0,4,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(R){this.c=R,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,A,I,m){const y=this.c.getNotebookDocument(P.URI.revive(R)).acceptModelChanged(A.value,I,m);this.b.fire(y)}$acceptDirtyStateChanged(R,A){this.c.getNotebookDocument(P.URI.revive(R)).acceptDirty(A)}$acceptModelSaved(R){const A=this.c.getNotebookDocument(P.URI.revive(R));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Ae[18],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class P{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=P});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[186],Re([1,0,24,4]),function(ee,e,n,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,I){k.set(this,void 0),this.b=new P.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),_e(this,k,I,"f"),Ne(this,k,"f").onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(A){return Ne(this,k,"f").get(this.a,A)}store(A,I){return Ne(this,k,"f").store(this.a,A,I)}delete(A){return Ne(this,k,"f").delete(this.a,A)}}e.ExtensionSecrets=M,k=new WeakMap}),define(Ae[72],Re([1,0,3,180,4,18]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(I){function m(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:y.protocol}}I.fromApiTunnel=m;function O(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==P.TunnelPrivacyId.ConstantPrivate&&y.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}I.fromServiceTunnel=O})(R=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=class{constructor(m){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(m){return m}async openTunnel(m,O){}async getTunnels(){return[]}async setTunnelFactory(m){return{dispose:()=>{}}}registerPortsAttributesProvider(m,O){return{dispose:()=>{}}}async $providePortAttributes(m,O,y,h,E){return[]}async $forwardPort(m,O){}async $closeTunnel(m){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([je(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ae[55],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class P{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=P}),define(Ae[187],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(I){let m=this.buffers.indexOf(I);return m<0&&(m=this.buffers.length,this.buffers.push(I)),m}}function k(A,I){if(I.serializeBuffersForPostMessage){const m=new P,O=(E,g)=>{if(g instanceof ArrayBuffer){const l=m.add(g);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(g)){const l=M(g);if(l){const t=m.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:l,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},y=JSON.stringify(A,O),h=m.buffers.map(E=>{const g=new Uint8Array(E);return n.VSBuffer.wrap(g)});return{message:y,buffers:h}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=k;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(A,I){const m=I.map(h=>{const E=new ArrayBuffer(h.byteLength);return new Uint8Array(E).set(h.buffer),E}),O=I.length?(h,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const g=E,{index:l}=g,t=m[l];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return E}:void 0;return{message:JSON.parse(A,O),arrayBuffers:m}}e.deserializeWebviewMessage=R}),define(Ae[97],Re([1,0,154,10,2,6,3,30,43,15,40,127,29]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(E=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function l(de){const ae=de;return!!ae&&typeof ae.getSelection=="function"&&!!ae.onDidChangeSelection}e.isEditorPaneWithSelection=l;function t(de,ae,j){for(const F of j.visibleEditorPanes)if(F.group.id===ae&&de.matches(F.input))return F.getViewState()}e.findViewStateForEditor=t;function a(de){if(c(de))return!1;const ae=de;return k.URI.isUri(ae?.resource)}e.isResourceEditorInput=a;function d(de){if(c(de))return!1;const ae=de;return ae?.original!==void 0&&ae.modified!==void 0}e.isResourceDiffEditorInput=d;function S(de){if(c(de)||d(de))return!1;const ae=de;return ae?.primary!==void 0&&ae.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function T(de){if(c(de))return!1;const ae=de;return ae?ae.resource===void 0||ae.resource.scheme===m.Schemas.untitled||ae.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=T;const p=/Untitled-\d+/;function i(de){return de.scheme===m.Schemas.untitled&&de.path.length>1&&!p.test(de.path)}e.isUntitledWithAssociatedResource=i;function u(de){if(c(de))return!1;const ae=de;return k.URI.isUri(ae?.base?.resource)&&k.URI.isUri(ae?.input1?.resource)&&k.URI.isUri(ae?.input2?.resource)&&k.URI.isUri(ae?.result?.resource)}e.isResourceMergeEditorInput=u;var s;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var o;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class f{constructor(){this.a=new Map}registerSource(ae,j){let F=this.a.get(ae);return F||(F={source:ae,label:j},this.a.set(ae,F)),F.source}getSourceLabel(ae){return this.a.get(ae)?.label??ae}}e.SaveSourceRegistry=new f;var b;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends M.Disposable{}e.AbstractEditorInput=r;function c(de){return de instanceof r}e.isEditorInput=c;function v(de){const ae=de;return k.URI.isUri(ae?.preferredResource)}function D(de){const ae=de;return c(ae?.primary)&&c(ae?.secondary)}e.isSideBySideEditorInput=D;function w(de){const ae=de;return c(ae?.modified)&&c(ae?.original)}e.isDiffEditorInput=w;function H(de,ae,j,F,Q){return Te(F,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const pe={...j,limits:{size:Number.MAX_VALUE}};de.openEditor(ae,pe)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=H;function X(de){return c(de?.editor)}e.isEditorInputWithOptions=X;function J(de){const ae=de;return X(de)&&ae?.group!==void 0}e.isEditorInputWithOptionsAndGroup=J;function G(de){const ae=de;return typeof ae?.groupId=="number"&&c(ae.editor)}e.isEditorIdentifier=G;var U;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LOCKED=2]="GROUP_LOCKED",de[de.EDITOR_OPEN=3]="EDITOR_OPEN",de[de.EDITOR_CLOSE=4]="EDITOR_CLOSE",de[de.EDITOR_MOVE=5]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=7]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=9]="EDITOR_PIN",de[de.EDITOR_STICKY=10]="EDITOR_STICKY",de[de.EDITOR_DIRTY=11]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class W{getOriginalUri(ae,j){if(!ae)return;if(u(ae))return e.EditorResourceAccessor.getOriginalUri(ae.result,j);if(j?.supportSideBySide){const{primary:Q,secondary:pe}=this.a(ae);if(Q&&pe){if(j?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===$.ANY)return this.getOriginalUri(Q,{filterByScheme:j.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:j.filterByScheme});ae=j.supportSideBySide===$.PRIMARY?Q:pe}}if(d(ae)||S(ae)||u(ae))return;const F=v(ae)?ae.preferredResource:ae.resource;return!F||!j||!j.filterByScheme?F:this.b(F,j.filterByScheme)}a(ae){return D(ae)||S(ae)?{primary:ae.primary,secondary:ae.secondary}:w(ae)||d(ae)?{primary:ae.modified,secondary:ae.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ae,j){if(!ae)return;if(u(ae))return e.EditorResourceAccessor.getCanonicalUri(ae.result,j);if(j?.supportSideBySide){const{primary:Q,secondary:pe}=this.a(ae);if(Q&&pe){if(j?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===$.ANY)return this.getCanonicalUri(Q,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:j.filterByScheme});ae=j.supportSideBySide===$.PRIMARY?Q:pe}}if(d(ae)||S(ae)||u(ae))return;const F=ae.resource;return!F||!j||!j.filterByScheme?F:this.b(F,j.filterByScheme)}b(ae,j){if(Array.isArray(j)){if(j.some(F=>ae.scheme===F))return ae}else if(j===ae.scheme)return ae}}e.EditorResourceAccessor=new W;var x;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(x=e.CloseDirection||(e.CloseDirection={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ae){const j=this.a=ae.get(R.IInstantiationService);for(const[F,Q]of this.c)this.e(F,Q,j);this.c.clear()}e(ae,j,F){const Q=F.createInstance(j);this.d.set(ae,Q)}registerFileEditorFactory(ae){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ae}getFileEditorFactory(){return(0,P.assertIsDefined)(this.b)}registerEditorSerializer(ae,j){if(this.c.has(ae)||this.d.has(ae))throw new Error(`A editor serializer with type ID '${ae}' was already registered.`);return this.a?this.e(ae,j,this.a):this.c.set(ae,j),(0,M.toDisposable)(()=>{this.c.delete(ae),this.d.delete(ae)})}getEditorSerializer(ae){return this.d.get(typeof ae=="string"?ae:ae.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new fe);async function Se(de,ae,j){return!de||!de.length?[]:await Promise.all(de.map(async F=>{const Q=k.URI.revive(F.fileUri);if(!Q){j.info("Cannot resolve the path because it is not valid.",F);return}if(!await ae.canHandleResource(Q)){j.info("Cannot resolve the path because it cannot be handled",F);return}let ke=F.exists,Ee=F.type;if(typeof ke!="boolean"||typeof Ee!="number")try{Ee=(await ae.stat(Q)).isDirectory?I.FileType.Directory:I.FileType.Unknown,ke=!0}catch(Ce){j.error(Ce),ke=!1}if(!ke&&F.openOnlyIfExists){j.info("Cannot resolve the path because it does not exist",F);return}if(Ee===I.FileType.Directory){j.info("Cannot resolve the path because it is a directory",F);return}const ve={...F.options,pinned:!0};return ke?{resource:Q,options:ve}:{resource:Q,options:ve,forceUntitled:!0}}))}e.pathsToEditors=Se;var ie;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(ie=e.EditorsOrder||(e.EditorsOrder={}));function ue(de){const ae=de;if(!ae)return!1;const j=ae;if(j.modified)return ue(j.modified);const F=ae;return!!(F.contributionsState&&F.viewState&&Array.isArray(F.cursorState))}e.isTextEditorViewState=ue;function ce(de){return(0,O.isErrorWithActions)(de)}e.isEditorOpenError=ce;function Te(de,ae,j){const F=(0,O.createErrorWithActions)(de,ae);return F.forceMessage=j?.forceMessage,F.forceSeverity=j?.forceSeverity,F.allowDialog=j?.allowDialog,F}e.createEditorOpenError=Te}),define(Ae[188],Re([1,0,4,155,3,6,28,30,16,64,23,85,179]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",y.Codicon.window,(0,P.localize)(0,null));var E;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(E=e.Extensions||(e.Extensions={}));var g;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function l(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=l;class t extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,I.flatten)([...this.g.values()])}registerViewContainer(o,f,b){const r=this.get(o.id);if(r)return r;const c=o;return c.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:c.openCommandActionDescriptor??{id:c.id},(0,R.getOrSet)(this.g,f,[]).push(c),b?.isDefault&&this.h.push(c),this.c.fire({viewContainer:c,viewContainerLocation:f}),c}deregisterViewContainer(o){for(const f of this.g.keys()){const b=this.g.get(f),r=b?.indexOf(o);if(r!==-1){b?.splice(r,1),b.length===0&&this.g.delete(f),this.f.fire({viewContainer:o,viewContainerLocation:f});return}}}get(o){return this.all.filter(f=>f.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(b=>b?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(f=>this.getViewContainerLocation(f)===o)}}A.Registry.add(E.ViewContainersRegistry,new t);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function d(s,o){const f=s.group??a.More,b=o.group??a.More;return f!==b?f.localeCompare(b):(s.order??5)-(o.order??5)}class S extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new m.SetMap}registerViews(o,f){this.registerViews2([{views:o,viewContainer:f}])}registerViews2(o){o.forEach(({views:f,viewContainer:b})=>this.l(f,b)),this.c.fire(o)}deregisterViews(o,f){const b=this.m(o,f);b.length&&this.f.fire({views:b,viewContainer:f})}moveViews(o,f){for(const b of this.j.keys())if(b!==f){const r=this.m(o,b);r.length&&(this.l(r,f),this.g.fire({views:r,from:b,to:f}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const f of this.i){const b=(this.j.get(f)||[]).filter(r=>r.id===o)[0];if(b)return b}return null}getViewContainer(o){for(const f of this.i)if((this.j.get(f)||[]).filter(r=>r.id===o)[0])return f;return null}registerViewWelcomeContent(o,f){return this.k.add(o,f),this.h.fire(o),(0,M.toDisposable)(()=>{this.k.delete(o,f),this.h.fire(o)})}registerViewWelcomeContent2(o,f){const b=new Map;for(const[r,c]of f)this.k.add(o,c),b.set(r,(0,M.toDisposable)(()=>{this.k.delete(o,c),this.h.fire(o)}));return this.h.fire(o),b}getViewWelcomeContent(o){const f=[];return this.k.forEach(o,b=>f.push(b)),f.sort(d)}l(o,f){let b=this.j.get(f);b||(b=[],this.j.set(f,b),this.i.push(f));for(const r of o){if(this.getView(r.id)!==null)throw new Error((0,P.localize)(1,null,r.id));b.push(r)}}m(o,f){const b=this.j.get(f);if(!b)return[];const r=[],c=[];for(const v of b)o.includes(v)?r.push(v):c.push(v);return r.length&&(c.length?this.j.set(f,c):(this.j.delete(f),this.i.splice(this.i.indexOf(f),1))),r}}A.Registry.add(E.ViewsRegistry,new S),e.IViewsService=(0,k.createDecorator)("viewsService"),e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var T;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(T=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(o,f){this.c=!1,this.d=!1,(0,O.mixin)(this,o),this.d=!!f,this.resolve=async b=>{if(f&&!this.c){const r=await f(b);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class u extends Error{constructor(o){super((0,P.localize)(2,null,o))}}e.NoTreeViewError=u}),define(Ae[189],Re([1,0,4,17,156]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,I,m,O){const y={command:A};if(I&&Object.keys(I).length>0&&(y.arguments=I),this.s("request",y),typeof O=="number"){const h=setTimeout(()=>{clearTimeout(h);const E=this.f.get(y.seq);if(E){this.f.delete(y.seq);const g={type:"response",seq:0,request_seq:y.seq,success:!1,command:A,message:(0,k.localize)(0,null,O,A)};E(g)}},O)}return m&&this.f.set(y.seq,m),y.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,I){return A.type!=="event"||I.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,P.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const I=A,m=this.f.get(I.request_seq);m&&(this.f.delete(I.request_seq),m(I));break}}}}s(A,I){I.type=A,I.seq=this.d++,this.sendMessage(I)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((I,m)=>A.set(m,I)),await(0,P.timeout)(500),A.forEach((I,m)=>{I({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ae[190],Re([1,0,157,31,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=h=>n.localize(51,null,h);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var R;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(R=e.State||(e.State={}));function A(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var I;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(I=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var m;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(m=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var y;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ae[191],Re([1,0,13,2,19,23,15,44,21,16]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function y(r,c,v){return r.replace(O,function(D,w){return c&&w.length>0&&w[0]!=="_"?D:v&&v.hasOwnProperty(w)?v[w]:D})}e.formatPII=y;function h(r){const c={};for(const v of Object.keys(r))v.startsWith("!")||(c[v]=r[v]);return c}e.filterExceptionsFromTelemetry=h;function E(r){return r.configuration.request==="attach"&&!g(r)&&(!r.parentSession||E(r.parentSession))}e.isSessionAttach=E;function g(r){let c=r.configuration.type;if(!!c)return c==="vslsShare"&&(c=r.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?r:r.parentSession?g(r.parentSession):void 0}e.getExtensionHostDebugSession=g;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function t(r,c,v){let D,w=0;const H=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let X=null;for(;X=H.exec(r);){const J=X.index+1,G=J+X[0].length;if(J<=c&&G>=v){D=X[0],w=J;break}}if(D){const J=/\w+/g;let G=null;for(;(G=J.exec(D))&&!(G.index+1+w+G[0].length>=v););G&&(D=D.substring(0,J.lastIndex))}return D?{start:w,end:w+D.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(r,c,v,D){if(r.evaluatableExpressionProvider.has(c)){const w=r.evaluatableExpressionProvider.ordered(c),H=(0,m.coalesce)(await Promise.all(w.map(async X=>{try{return await X.provideEvaluatableExpression(c,v,D??I.CancellationToken.None)}catch{return}})));if(H.length>0){let X=H[0].expression;const J=H[0].range;return X||(X=c.getLineContent(v.lineNumber).substring(J.startColumn-1,J.endColumn-1)),{range:J,matchingExpression:X}}}else{const w=c.getLineContent(v.lineNumber),{start:H,end:X}=t(w,v.column,v.column),J=w.substring(H-1,X);return{matchingExpression:J,range:new A.Range(v.lineNumber,H,v.lineNumber,H+J.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function S(r){return!!(r&&r.match(d))}e.isUri=S;function T(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(S(r.path))return P.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return P.URI.file(r.path)}return r.path}function p(r){if(typeof r.path=="object"){const c=P.URI.revive(r.path);if(c)return c.scheme===R.Schemas.file?c.fsPath:c.toString()}return r.path}function i(r,c){const v=c?T:p,D=(0,M.deepClone)(r);return s(D,(w,H)=>{w&&H&&(H.path=v(H))}),D}e.convertToDAPaths=i;function u(r,c){const v=c?T:p,D=(0,M.deepClone)(r);return s(D,(w,H)=>{!w&&H&&(H.path=v(H))}),D}e.convertToVSCPaths=u;function s(r,c){switch(r.type){case"event":{const v=r;switch(v.event){case"output":c(!1,v.body.source);break;case"loadedSource":c(!1,v.body.source);break;case"breakpoint":c(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=r;switch(v.command){case"setBreakpoints":c(!0,v.arguments.source);break;case"breakpointLocations":c(!0,v.arguments.source);break;case"source":c(!0,v.arguments.source);break;case"gotoTargets":c(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(D=>c(!1,D));break;default:break}break}case"response":{const v=r;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(D=>c(!1,D.source));break;case"loadedSources":v.body.sources.forEach(D=>c(!1,D));break;case"scopes":v.body.scopes.forEach(D=>c(!1,D.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(D=>c(!1,D.source));break;case"setBreakpoints":v.body.breakpoints.forEach(D=>c(!1,D.source));break;case"disassemble":v.body?.instructions.forEach(w=>c(!1,w.location));break;default:break}break}}}function o(r){return r.filter(c=>!c.presentation?.hidden).sort((c,v)=>c.presentation?v.presentation?c.presentation.group?v.presentation.group?c.presentation.group!==v.presentation.group?c.presentation.group.localeCompare(v.presentation.group):f(c.presentation.order,v.presentation.order):-1:v.presentation.group?1:f(c.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=o;function f(r,c){return typeof r!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:r-c}async function b(r,c){const v=r.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(v!=="none"&&(await c.saveAll(),v==="allEditorsInActiveGroup")){const D=c.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await c.save({editor:D.input,groupId:D.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(Ae[73],Re([1,0,25,36,192,66,15,19,20,31]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var h;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var d;(function($){$.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),fe=7;function Se(ae,j){const F=j.toString(fe),pe=`${F.length<W.length?W[F.length-1]:"z"}${F}s${(0,n.encodeBase64)(n.VSBuffer.fromString(ae.scheme),!0,!0)}`;return ae.with({scheme:$.scheme,fragment:pe})}$.generate=Se;function ie(ae){if(ae.scheme!==$.scheme)return;const j=ae.fragment.indexOf("s");if(j<0)return;const F=parseInt(ae.fragment.substring(0,j).replace(x,""),fe),Q=(0,n.decodeBase64)(ae.fragment.substring(j+1)).toString();if(!isNaN(F))return{handle:F,notebook:ae.with({scheme:Q,fragment:null})}}$.parse=ie;function ue(ae,j){return ae.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${j??""},${ae.scheme!==R.Schemas.file?ae.scheme:""}`})}$.generateCellOutputUri=ue;function ce(ae){if(ae.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const j=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ae.fragment);if(!j)return;const F=j[1]&&j[1]!==""?j[1]:void 0,Q=j[2];return{outputId:F,notebook:ae.with({scheme:Q||R.Schemas.file,fragment:null})}}$.parseCellOutputUri=ce;function Te(ae,j,F){return $.generate(ae,j).with({scheme:F})}$.generateCellPropertyUri=Te;function de(ae,j){if(ae.scheme===j)return $.parse(ae.with({scheme:$.scheme}))}$.parseCellPropertyUri=de})(d=e.CellUri||(e.CellUri={}));const S=$=>I.isWindows?$.replace(/\//g,"\\"):$;class T{constructor(W=[],x=e.NOTEBOOK_DISPLAY_ORDER){this.e=x,this.d=[...new Set(W)].map(fe=>({pattern:fe,matches:P.parse(S(fe))}))}sort(W){const x=new Map(k.Iterable.map(W,Se=>[Se,S(Se)]));let fe=[];for(const{matches:Se}of this.d)for(const[ie,ue]of x)if(Se(ue)){fe.push(ie),x.delete(ie);break}return x.size&&(fe=fe.concat([...x.keys()].sort((Se,ie)=>this.e.indexOf(Se)-this.e.indexOf(ie)))),fe}prioritize(W,x){const fe=this.f(W);if(fe===-1){this.d.unshift({pattern:W,matches:P.parse(S(W))});return}const Se=new Set(x.map(ue=>this.f(ue,fe)));Se.delete(-1);const ie=Array.from(Se).sort();this.d.splice(fe+1,0,...ie.map(ue=>this.d[ue]));for(let ue=ie.length-1;ue>=0;ue--)this.d.splice(ie[ue],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const fe=S(W);for(let Se=0;Se<x;Se++)if(this.d[Se].matches(fe))return Se;return-1}}e.MimeTypeDisplayOrder=T;function p($,W,x,fe=(Se,ie)=>Se===ie){const Se=[];function ie(Te,de,ae){if(de===0&&ae.length===0)return;const j=Se[Se.length-1];j&&j.start+j.deleteCount===Te?(j.deleteCount+=de,j.toInsert.push(...ae)):Se.push({start:Te,deleteCount:de,toInsert:ae})}let ue=0,ce=0;for(;;){if(ue===$.length){ie(ue,0,W.slice(ce));break}if(ce===W.length){ie(ue,$.length-ue,[]);break}const Te=$[ue],de=W[ce];if(fe(Te,de)){ue+=1,ce+=1;continue}x(de)?(ie(ue,1,[]),ue+=1):(ie(ue,0,[de]),ce+=1)}return Se}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function($){$.default="default",$.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u($){const W=$;return!!((typeof W.include=="string"||P.isRelativePattern(W.include))&&(typeof W.exclude=="string"||P.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=u;function s($,W,x){if(Array.isArray($.viewType)&&$.viewType.indexOf(W)>=0||$.viewType===W)return!0;if($.filenamePattern){const fe=u($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,Se=u($.filenamePattern)?$.filenamePattern.exclude:void 0;if(P.match(fe,(0,A.basename)(x.fsPath).toLowerCase()))return!(Se&&P.match(Se,(0,A.basename)(x.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var o;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(W){return`${f.d}${W}`}static parse(W){if(W.startsWith(f.d))return W.substring(f.d.length)}}f.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=f;function b($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=b;const r=new TextDecoder;function c($){const W=[];let x=!1;for(const fe of $)(W.length===0||x)&&(W.push(fe),x=!0);return H(W),B(n.VSBuffer.concat(W.map(fe=>n.VSBuffer.wrap(fe))))}e.compressOutputItemStreams=c;const v=`${String.fromCharCode(27)}[A`,D=v.split("").map($=>$.charCodeAt(0)),w=10;function H($){$.forEach((W,x)=>{if(x===0||W.length<v.length)return;const fe=$[x-1],Se=W.subarray(0,v.length);if(Se[0]===D[0]&&Se[1]===D[1]&&Se[2]===D[2]){const ie=fe.lastIndexOf(w);if(ie===-1)return;$[x-1]=fe.subarray(0,ie),$[x]=W.subarray(v.length)}})}function X($){let W=$;do $=W,W=$.replace(/[^\n]\x08/gm,"");while(W.length<$.length);return $}function J($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const W=$.match(/^(.*)\r+/m)[1];let x=$.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return $}const G="\b".charCodeAt(0),U="\r".charCodeAt(0);function B($){return!$.buffer.includes(G)&&!$.buffer.includes(U)?$:n.VSBuffer.fromString(J(X(r.decode($.buffer))))}}),define(Ae[193],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(P=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(R,A,I=R.parent){if(R._isRoot)return new k([A]);const m=[R.id];for(let O=I;O&&O.id!==A;O=O.parent)m.push(O.id);return m.push(A),new k(m.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const A=R.indexOf("\0");return A===-1?R:R.slice(0,A)}static fromString(R){return new k(R.split("\0"))}static join(R,A){return new k([...R.path,A])}static joinToString(R,A){return R.toString()+"\0"+A}static parentId(R){const A=R.lastIndexOf("\0");return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf("\0");return A===-1?R:R.slice(A+1)}static compare(R,A){return R===A?0:A.startsWith(R+"\0")?2:R.startsWith(A+"\0")?3:1}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new k(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new k(this.path,R)}compare(R){if(typeof R=="string")return k.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.TestId=k}),define(Ae[56],Re([1,0,2,44,45]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var R;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=r=>"runId"in r;e.isStartControllerTests=A;var I;(function(r){r.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),r.deserialize=c=>({range:P.Range.lift(c.range),uri:n.URI.revive(c.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var m;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(m=e.TestMessageType||(e.TestMessageType={}));var O;(function(r){r.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&I.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&I.deserialize(c.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const y=(r,c)=>`${c?"s":"e"}${r}`;e.getMarkId=y;var h;(function(r){r.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&I.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&I.deserialize(c.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(r){r.serialize=c=>c.type===0?O.serialize(c):h.serialize(c),r.deserialize=c=>c.type===0?O.deserialize(c):h.deserialize(c)})(E=e.ITestMessage||(e.ITestMessage={}));var g;(function(r){r.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),r.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(E.serialize)}),r.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(E.deserialize)})})(g=e.ITestTaskState||(e.ITestTaskState={}));const l="\0",t=(r,c)=>r+l+c;e.namespaceTestTag=t;const a=r=>{const c=r.indexOf(l);return{ctrlId:r.slice(0,c),tagId:r.slice(c+1)}};e.denamespaceTestTag=a;var d;(function(r){r.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),r.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?n.URI.revive(c.uri):void 0,range:c.range?P.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(d=e.ITestItem||(e.ITestItem={}));var S;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));var T;(function(r){r.serialize=c=>({expand:c.expand,item:d.serialize(c.item)}),r.deserialize=c=>({controllerId:k.TestId.root(c.item.extId),expand:c.expand,item:d.deserialize(c.item)})})(T=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=c=>{let v;return c.item&&(v={},c.item.label!==void 0&&(v.label=c.item.label),c.item.tags!==void 0&&(v.tags=c.item.tags),c.item.busy!==void 0&&(v.busy=c.item.busy),c.item.uri!==void 0&&(v.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(v.range=c.item.range?.toJSON()),c.item.description!==void 0&&(v.description=c.item.description),c.item.error!==void 0&&(v.error=c.item.error),c.item.sortText!==void 0&&(v.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:v}},r.deserialize=c=>{let v;return c.item&&(v={},c.item.label!==void 0&&(v.label=c.item.label),c.item.tags!==void 0&&(v.tags=c.item.tags),c.item.busy!==void 0&&(v.busy=c.item.busy),c.item.range!==void 0&&(v.range=c.item.range?P.Range.lift(c.item.range):null),c.item.description!==void 0&&(v.description=c.item.description),c.item.error!==void 0&&(v.error=c.item.error),c.item.sortText!==void 0&&(v.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:v}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,c)=>{c.expand!==void 0&&(r.expand=c.expand),c.item!==void 0&&(r.item=r.item?Object.assign(r.item,c.item):c.item)};e.applyTestItemUpdate=i;var u;(function(r){r.serializeWithoutMessages=c=>({...T.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.serializeWithoutMessages),retired:c.retired}),r.serialize=c=>({...T.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.serialize),retired:c.retired}),r.deserialize=c=>({...T.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(g.deserialize),retired:!0})})(u=e.TestResultItem||(e.TestResultItem={}));var s;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var o;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var f;(function(r){r.deserialize=c=>c.op===0?{op:c.op,item:T.deserialize(c.item)}:c.op===1?{op:c.op,item:p.deserialize(c.item)}:c.op===2?{op:c.op,uri:n.URI.revive(c.uri),docv:c.docv}:c,r.serialize=c=>c.op===0?{op:c.op,item:T.serialize(c.item)}:c.op===1?{op:c.op,item:p.serialize(c.item)}:c})(f=e.TestsDiffOp||(e.TestsDiffOp={}));class b{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(c){const v=this.o();for(const D of c)switch(D.op){case 0:this.j(T.deserialize(D.item),v);break;case 1:this.k(p.deserialize(D.item),v);break;case 3:this.l(D.itemId,v);break;case 5:this.m(D.itemId);break;case 4:this.updatePendingRoots(D.amount);break;case 6:this.c.set(D.tag.id,D.tag);break;case 7:this.c.delete(D.id);break}v.complete?.()}j(c,v){const D=k.TestId.parentId(c.item.extId)?.toString();let w;if(!D)w=this.p(c),this.f.add(w),this.d.set(c.item.extId,w);else if(this.d.has(D)){const H=this.d.get(D);H.children.add(c.item.extId),w=this.p(c,H),this.d.set(c.item.extId,w)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return v.add?.(w),c.expand===2&&this.g++,w}k(c,v){const D=this.d.get(c.extId);if(!!D)return c.expand!==void 0&&(D.expand===2&&this.g--,c.expand===2&&this.g++),(0,e.applyTestItemUpdate)(D,c),v.update?.(D),D}l(c,v){const D=this.d.get(c);if(!D)return;const w=k.TestId.parentId(D.item.extId)?.toString();w?this.d.get(w).children.delete(D.item.extId):this.f.delete(D);const H=[[c]];for(;H.length;)for(const X of H.pop()){const J=this.d.get(X);J&&(H.push(J.children),this.d.delete(X),v.remove?.(J,J!==D),J.expand===2&&this.g--)}}m(c){}updatePendingRoots(c){this.h+=c}o(){return{}}}e.AbstractIncrementalTestCollection=b}),define(Ae[74],Re([1,0,17,4,6,49,56,45]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var I;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(I=e.TestItemEventOp||(e.TestItemEventOp={}));const m=(d,S)=>d===S,y=Object.entries({range:(d,S)=>d===S?!0:!d||!S?!1:d.equalsRange(S),busy:m,label:m,description:m,error:m,sortText:m,tags:(d,S)=>!(d.length!==S.length||d.some(T=>!S.includes(T)))}),h=(d,S)=>{let T;for(const[p,i]of y)i(d[p],S[p])||(T?T[p]=S[p]:T={[p]:S[p]});return T};class E extends k.Disposable{get root(){return this.m.root}constructor(S){super(),this.m=S,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new P.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(S){this.h=S;for(const T of this.tree.values())this.G(T)}get resolveHandler(){return this.h}collectDiff(){const S=this.k;return this.k=[],S}pushDiff(S){switch(S.op){case 2:{for(const T of this.k)if(T.op===2&&T.uri===S.uri){T.docv=S.docv;return}break}case 1:{const T=this.k[this.k.length-1];if(T){if(T.op===1&&T.item.extId===S.item.extId){(0,R.applyTestItemUpdate)(T.item,S.item);return}if(T.op===0&&T.item.item.extId===S.item.extId){(0,R.applyTestItemUpdate)(T.item,S.item);return}}break}}this.k.push(S),this.f.isScheduled()||this.f.schedule()}expand(S,T){const p=this.tree.get(S);if(!!p){if((p.expandLevels===void 0||T>p.expandLevels)&&(p.expandLevels=T),p.expand===1){const i=this.I(p);return i.isOpen()?this.H(p,T-1):i.wait().then(()=>this.H(p,T-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,T-1)):this.H(p,T-1)}}dispose(){for(const S of this.tree.values())this.m.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(S,T){switch(T.op){case 3:this.L(A.TestId.joinToString(S.fullId,T.id));break;case 0:this.u(T.item,S);break;case 5:for(const p of T.ops)this.p(S,p);break;case 1:this.w(T.new,T.old,S.fullId.toString());break;case 2:this.G(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:T.update}});break;case 6:this.s(S.actual.uri);break;default:(0,M.assertNever)(T)}}s(S){S&&this.pushDiff({op:2,uri:S,docv:this.m.getDocumentVersion(S)})}u(S,T){const p=A.TestId.fromExtHostTestItem(S,this.root.id,T?.actual),i=this.m.getApiFor(S);i.parent&&i.parent!==T?.actual&&this.m.getChildren(i.parent).delete(S.id);let u=this.tree.get(p.toString());if(!u){u={fullId:p,actual:S,expandLevels:T?.expandLevels?T.expandLevels-1:void 0,expand:0},S.tags.forEach(this.y,this),this.tree.set(u.fullId.toString(),u),this.C(S,T),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:u.expand,item:this.m.toITestItem(S)}}),this.F(S,u,T);return}if(u.actual===S){this.D(S,u,T);return}if(u.actual.uri?.toString()!==S.uri?.toString())return this.L(p.toString()),this.u(S,T);const s=this.m.getChildren(u.actual),o=u.actual,f=h(this.m.toITestItem(o),this.m.toITestItem(S));this.m.getApiFor(o).listener=void 0,u.actual=S,u.expand=0,f&&(f.hasOwnProperty("tags")&&(this.w(S.tags,o.tags,p.toString()),delete f.tags),this.p(u,{op:4,update:f})),this.F(S,u,T);for(const[b,r]of s)this.m.getChildren(S).get(r.id)||this.L(A.TestId.joinToString(p,r.id));this.s(u.actual.uri)}w(S,T,p){const i=new Set(T.map(u=>u.id));for(const u of S)i.delete(u.id)||this.y(u);this.pushDiff({op:1,item:{extId:p,item:{tags:S.map(u=>(0,R.namespaceTestTag)(this.m.controllerId,u.id))}}}),i.forEach(this.z,this)}y(S){const T=this.j.get(S.id);T?T.refCount++:(this.j.set(S.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.m.controllerId,S.id)}}))}z(S){const T=this.j.get(S);T&&!--T.refCount&&(this.j.delete(S),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.m.controllerId,S)}))}C(S,T){this.m.getApiFor(S).parent=T&&T.actual!==this.root?T.actual:void 0}D(S,T,p){this.C(S,p);const i=this.m.getApiFor(S);i.parent=p?.actual,i.listener=u=>this.p(T,u),this.G(T)}F(S,T,p){this.D(S,T,p);for(const[i,u]of this.m.getChildren(S))this.u(u,T)}G(S){let T;this.h?S.resolveBarrier?T=S.resolveBarrier.isOpen()?3:2:T=S.actual.canResolveChildren?1:0:T=0,T!==S.expand&&(S.expand=T,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:T}}),T===1&&S.expandLevels!==void 0&&this.I(S))}H(S,T){if(T<0)return;const p=[];for(const[i,u]of this.m.getChildren(S.actual)){const s=this.expand(A.TestId.joinToString(S.fullId,u.id),T);(0,n.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}I(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this.h){const u=new n.Barrier;return u.open(),u}S.expand=2,this.J(S);const T=S.resolveBarrier=new n.Barrier,p=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,u)};let i;try{i=this.h(S.actual===this.root?void 0:S.actual)}catch(u){p(u)}return(0,n.isThenable)(i)?i.catch(p).then(()=>{T.open(),this.G(S)}):(T.open(),this.G(S)),S.resolveBarrier}J(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}L(S){const T=this.tree.get(S);if(!T)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:S});const p=[T];for(;p.length;){const i=p.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const u of i.actual.tags)this.z(u.id);this.tree.delete(i.fullId.toString());for(const[u,s]of this.m.getChildren(i.actual))p.push(this.tree.get(A.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.g.fire(S)}}e.TestItemCollection=E;class g extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=g;class l extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class t extends Error{constructor(S,T,p){super(`TestItem with ID "${S}" is from controller "${T}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const a=(d,S,T)=>{let p=new Map;return{get size(){return p.size},forEach(i,u){for(const s of p.values())i.call(u,s,this)},[Symbol.iterator](){return p.entries()},replace(i){const u=new Map,s=new Set(p.keys()),o={op:5,ops:[]};for(const f of i){if(!(f instanceof T))throw new l(f.id);const b=S(f).controllerId;if(b!==d.controllerId)throw new t(f.id,b,d.controllerId);if(u.has(f.id))throw new g(f.id);u.set(f.id,f),s.delete(f.id),o.ops.push({op:0,item:f})}for(const f of s.keys())o.ops.push({op:3,id:f});d.listener?.(o),p=u},add(i){if(!(i instanceof T))throw new l(i.id);p.set(i.id,i),d.listener?.({op:0,item:i})},delete(i){p.delete(i)&&d.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=a}),define(Ae[98],Re([1,0,74]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,k=(R,A)=>{const I={controllerId:A};return P.set(R,I),I};e.createPrivateApiFor=k;const M=R=>{const A=P.get(R);if(!A)throw new n.InvalidTestItemError(R?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ae[75],Re([1,0,15,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(A,I){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(I&&I.authority&&I.isRemote&&A.scheme===n.Schemas.file&&(A=P.URI.from({scheme:n.Schemas.vscodeRemote,authority:I.authority,path:A.path})),P.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=k;function M(A){return A.replace(/./g,I=>{const m=I.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?I:"-"+m.toString(16).padStart(4,"0")})}function R(A){return A.replace(/-([0-9a-f]{4})/g,(I,m)=>String.fromCharCode(parseInt(m,16)))}e.decodeAuthority=R}),define(Ae[194],Re([1,0,4,6,75]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,I,m){this.d=A,this.e=I,this.f=m,this.a=0,this.b=new P.DisposableStore,this.c=new Map,this.b.add(I.onDidChangeVisibleTextEditors(()=>{const O=I.getVisibleTextEditors();for(const y of this.c.values())O.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,I,m,O,y){let h;for(const S of this.e.getVisibleTextEditors(!0))if(S.value===A){h=S;break}if(!h)throw new Error("not a visible editor");const E=this,g=this.a++,l=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(S){return(0,k.asWebviewUri)(S,E.f)}get cspSource(){return k.webviewGenericCspSource}set options(S){this.b=S,E.d.$setOptions(g,S)}get options(){return this.b}set html(S){this.a=S,E.d.$setHtml(g,S)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(S){return E.d.$postMessage(g,S)}},d=new class{constructor(){this.editor=A,this.line=I,this.height=m,this.webview=a,this.onDidDispose=t.event}dispose(){E.c.has(g)&&(E.c.delete(g),E.d.$disposeEditorInset(g),t.fire(),t.dispose(),l.dispose())}};return this.d.$createEditorInset(g,h.id,h.value.document.uri,I+1,m,O||{},y.identifier,y.extensionLocation),this.c.set(g,{editor:A,inset:d,onDidReceiveMessage:l}),d}$onDidDispose(A){const I=this.c.get(A);I&&I.inset.dispose()}$onDidReceiveMessage(A,I){this.c.get(A)?.onDidReceiveMessage.fire(I)}}e.ExtHostEditorInsets=M}),define(Ae[195],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var P;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(P=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(R,A){super(A),this.variable=R}}e.VariableError=k}),define(Ae[196],Re([1,0,19,51,10,23,20,88,160,195,13]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(E,g,l,t){this.g=new Map,this.a=E,this.b=g,this.d=l,t&&(this.c=t.then(a=>this.h(a)))}h(E){if(R.isWindows){const g=Object.create(null);return Object.keys(E).forEach(l=>{g[l.toLowerCase()]=E[l]}),g}return E}resolveWithEnvironment(E,g,l){return this.j({env:this.h(E),userHome:void 0},g?g.uri:void 0,l)}async resolveAsync(E,g){const l={env:await this.c,userHome:await this.d};return this.j(l,E?E.uri:void 0,g)}async i(E,g,l,t){const a=M.deepClone(g);R.isWindows&&a.windows?Object.keys(a.windows).forEach(S=>a[S]=a.windows[S]):R.isMacintosh&&a.osx?Object.keys(a.osx).forEach(S=>a[S]=a.osx[S]):R.isLinux&&a.linux&&Object.keys(a.linux).forEach(S=>a[S]=a.linux[S]),delete a.windows,delete a.osx,delete a.linux;const d={env:await this.c,userHome:await this.d};return this.j(d,E?E.uri:void 0,a,l,t)}async resolveAnyAsync(E,g,l){return this.i(E,g,l)}async resolveAnyMap(E,g,l){const t=new Map;return{newConfig:await this.i(E,g,l,t),resolvedVariables:t}}resolveWithInteractionReplace(E,g,l,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,g,l,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,g){if(this.g.has(E))throw new Error("Variable "+E+" is contributed twice.");this.g.set(E,g)}async j(E,g,l,t,a){if(k.isString(l))return this.l(E,g,l,t,a);if(Array.isArray(l))return Promise.all(l.map(d=>this.j(E,g,d,t,a)));if(k.isObject(l)){const d=Object.create(null),S=await Promise.all(Object.keys(l).map(async T=>[await this.l(E,g,T,t,a),await this.j(E,g,l[T],t,a)]));for(const[T,p]of S)d[T]=p;return d}return l}l(E,g,l,t,a){return(0,O.replaceAsync)(l,y.VARIABLE_REGEXP,async(d,S)=>{if(S.includes(y.VARIABLE_LHS))return d;let T=await this.n(E,d,S,g,t);return a?.set(S,T),T!==d&&k.isString(T)&&T.match(y.VARIABLE_REGEXP)&&(T=await this.l(E,g,T,t,a)),T})}m(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async n(E,g,l,t,a){let d;const S=l.split(":");S.length>1&&(l=S[0],d=S[1]);const T=u=>{const s=this.a.getFilePath();if(s)return(0,A.normalizeDriveLetter)(s);throw new m.VariableError(u,(0,I.localize)(0,null,g))},p=u=>{const s=T(u);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,A.normalizeDriveLetter)(o)}throw new m.VariableError(u,(0,I.localize)(1,null,g,n.basename(s)))},i=u=>{if(d){const s=this.a.getFolderUri(d);if(s)return s;throw new m.VariableError(u,(0,I.localize)(2,null,g,d))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(u,(0,I.localize)(3,null,g)):new m.VariableError(u,(0,I.localize)(4,null,g))};switch(l){case"env":if(d){if(E.env){const u=E.env[R.isWindows?d.toLowerCase():d];if(k.isString(u))return u}return""}throw new m.VariableError(m.VariableKind.Env,(0,I.localize)(5,null,g));case"config":if(d){const u=this.a.getConfigurationValue(t,d);if(k.isUndefinedOrNull(u))throw new m.VariableError(m.VariableKind.Config,(0,I.localize)(6,null,g,d));if(k.isObject(u))throw new m.VariableError(m.VariableKind.Config,(0,I.localize)(7,null,g,d));return u}throw new m.VariableError(m.VariableKind.Config,(0,I.localize)(8,null,g));case"command":return this.o(m.VariableKind.Command,g,d,a,"command");case"input":return this.o(m.VariableKind.Input,g,d,a,"input");case"extensionInstallFolder":if(d){const u=await this.a.getExtension(d);if(!u)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,I.localize)(9,null,g,d));return this.m(u.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,I.localize)(10,null,g));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(m.VariableKind.WorkspaceFolder)));case"cwd":return t||d?(0,A.normalizeDriveLetter)(this.m(i(m.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.m(i(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,I.localize)(11,null,g))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new m.VariableError(m.VariableKind.LineNumber,(0,I.localize)(12,null,g))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new m.VariableError(m.VariableKind.SelectedText,(0,I.localize)(13,null,g))}case"file":return T(m.VariableKind.File);case"fileWorkspaceFolder":return p(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||d?n.relative(this.m(i(m.VariableKind.RelativeFile)),T(m.VariableKind.RelativeFile)):T(m.VariableKind.RelativeFile);case"relativeFileDirname":{const u=n.dirname(T(m.VariableKind.RelativeFileDirname));if(t||d){const s=n.relative(this.m(i(m.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return n.dirname(T(m.VariableKind.FileDirname));case"fileExtname":return n.extname(T(m.VariableKind.FileExtname));case"fileBasename":return n.basename(T(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=n.basename(T(m.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-n.extname(u).length)}case"fileDirnameBasename":return n.basename(n.dirname(T(m.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||g}case"execInstallFolder":{const u=this.a.getAppRoot();return u||g}case"pathSeparator":return n.sep;default:try{const u=d?`${l}:${d}`:l;return this.o(m.VariableKind.Unknown,g,u,a,void 0)}catch{return g}}}}o(E,g,l,t,a){if(l&&t){const d=a===void 0?t[l]:t[a+":"+l];if(typeof d=="string")return d;throw new m.VariableError(E,(0,I.localize)(14,null,g))}return g}}y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=y}),define(Ae[99],Re([1,0,3,97]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var k;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));function m(g){const l=g;return(0,P.isEditorInput)(l?.editor)&&(0,P.isEditorInput)(l?.replacement)}e.isEditorReplacement=m;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const l=g;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=h;function E(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Ae[197],Re([1,0,3,99]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(M){const R=M;return typeof M=="number"||(0,P.isEditorGroup)(R)}e.isPreferredGroup=k}),define(Ae[198],Re([1,0,3,166]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(P.IEnvironmentService)}),define(Ae[100],Re([1,0,24,4,19,6]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class A{static isHostExtension(t,a,d){if(a.getExtensionDescription(t))return!1;const S=d.getExtensionDescription(t);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(t,a){this.h=t,this.c=new P.Emitter,this.onDidChange=this.c.event,this.d=a,this.j()}j(){this.d.sort(E),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const a=this.h.readActivationEvents(t);if(Array.isArray(a))for(let d of a)d==="onUri"&&(d=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(d)||this.g.set(d,[]),this.g.get(d).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,a){this.d=g(this.d,a),this.d=this.d.concat(t);const d=A.k(this.d);return this.d=g(this.d,d.map(S=>S.identifier)),this.j(),this.c.fire(void 0),new R(d)}static k(t){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,u){this.addNode(i),this.addNode(u),this.c.has(i)?this.c.get(i).push(u):this.c.set(i,[u])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,u){const s=a.getArcs(i);for(let o=0;o<s.length;o++)if(!u.has(s[o]))return!1;return!0}getNodes(){return this.e}},d=new n.ExtensionIdentifierMap;for(const i of t)if(d.set(i.identifier,i),i.extensionDependencies)for(const u of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(u));const S=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>S.add(i));const T=a.getNodes().filter(i=>!S.has(i));let p;do{p=!1;for(let i=0;i<T.length;i++){const u=T[i];a.hasOnlyGoodArcs(u,S)&&(T.splice(i,1),i--,S.add(u),p=!0)}}while(p);return T.map(i=>d.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this.g.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const a=this.e.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this.f)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:l=>l.activationEvents};class I{constructor(t){this.d=new y,this.c=new A(t,[])}async acquireLock(t){const a=await this.d.acquire(t);return new m(this,a)}deltaExtensions(t,a,d){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,d)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this.c.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=I;class m extends M.Disposable{constructor(t,a){super(),this.f=t,this.c=!1,this.B(a)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=m;class O{constructor(t){this.name=t,this.promise=new Promise((a,d)=>{this.c=a})}resolve(t){this.c(t)}}class y{constructor(){this.c=[],this.d=!1}async acquire(t){const a=new O(t);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let a=!0;const d=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),S=()=>{!a||(clearTimeout(d),a=!1,this.d=!1,this.e())};t.resolve((0,M.toDisposable)(S))}}var h;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(h||(h={}));function E(l,t){const a=l.isBuiltin?0:l.isUnderDevelopment?2:1,d=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==d)return a-d;const S=k.posix.basename(l.extensionLocation.path),T=k.posix.basename(t.extensionLocation.path);return S<T?-1:S>T?1:0}function g(l,t){const a=new n.ExtensionIdentifierSet(t);return l.filter(d=>!a.has(d.identifier))}}),define(Ae[76],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var k;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function R(m){const O=n.VSBuffer.alloc(1);switch(m){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=R;function A(m,O){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var I;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(I=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ae[57],Re([1,0,3,4,14,27,76,50,52,23,2,6,150]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends y.Disposable{constructor(a,d){super(),this.m=a,this.n=d,this.a=this.B(new P.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=d.createLogger(this.j,{id:I.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(S=>{(0,k.isLogLevel)(S)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,d,S){const T=this.getTelemetryDetails(),p=new g(d,S,a,this.k,this.i,this.getBuiltInCommonProperties(a),{isUsageEnabled:T.isUsageEnabled,isErrorsEnabled:T.isErrorsEnabled});return this.l.set(a.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(a,d,S){this.f=a,this.g=d,this.c=S??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(a){const d=Object.create(null);switch(d["common.extname"]=`${a.publisher}.${a.name}`,d["common.extversion"]=a.version,d["common.vscodemachineid"]=this.m.telemetryInfo.machineId,d["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,d["common.vscodeversion"]=this.m.version,d["common.isnewappinstall"]=l(this.m.telemetryInfo.firstSessionDate),d["common.product"]=this.m.environment.appHost,this.m.uiKind){case R.UIKind.Web:d["common.uikind"]="web";break;case R.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,I.cleanRemoteAuthority)(this.m.remote.authority)),d}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const d=this.getTelemetryDetails();this.l.forEach((S,T)=>{S.isDisposed&&this.l.delete(T)}),this.l.forEach(S=>{S.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(a,d){const S=this.l.get(a.value);return S&&S.isDisposed?(this.l.delete(a.value),!1):!S||S.ignoreUnhandledExtHostErrors?!1:(S.logError(d),!0)}};E=qe([je(0,M.IExtHostInitDataService),je(1,k.ILoggerService)],E),e.ExtHostTelemetry=E;class g{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,d,S,T,p,i,u){this.g=S,this.h=T,this.i=p,this.j=i,this.a=new P.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(a,d){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let d=a.properties??a;return d=(0,I.cleanData)(d,[]),this.c&&(d=(0,m.mixin)(d,this.c)),this.b||(d=(0,m.mixin)(d,this.j)),a.properties?a.properties=d:a=d,a}k(a,d){!this.f||(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(a,d),this.h.trace(a,d))}logUsage(a,d){!this.d.isUsageEnabled||this.k(a,d)}logError(a,d){!this.d.isErrorsEnabled||!this.f||(typeof a=="string"?this.k(a,d):this.f.sendErrorData(a,d))}get apiTelemetryLogger(){if(!this.e){const a=this,d={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function l(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=l,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,4,2,176,96,24,3]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class I{constructor(p){this.dependency=p}}e.MissingExtensionDependency=I;var m;(function(T){T[T.EagerAutoStart=1]="EagerAutoStart",T[T.EagerManualStart=2]="EagerManualStart",T[T.Lazy=3]="Lazy"})(m=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,i){const u=[],s=[],o=[],f=[],b=y(this.c),r=y(p),c=(X,J)=>X.extensionLocation.toString()===J.extensionLocation.toString()||X.isBuiltin===J.isBuiltin||X.isUserBuiltin===J.isUserBuiltin||X.isUnderDevelopment===J.isUnderDevelopment;for(const X of this.c){const J=r.get(X.identifier);if(!J){u.push(X.identifier),b.delete(X.identifier);continue}if(!c(X,J)){u.push(X.identifier),b.delete(X.identifier);continue}}for(const X of p){const J=b.get(X.identifier);if(!J){s.push(X);continue}if(!c(J,X)){u.push(J.identifier),b.delete(J.identifier);continue}}const v=new R.ExtensionIdentifierSet(this.d),D=new R.ExtensionIdentifierSet(i);for(const X of this.d)D.has(X)||o.push(X);for(const X of i)v.has(X)||f.push(X);const w=M.ImplicitActivationEvents.createActivationEventsMap(s),H={toRemove:u,toAdd:s,addActivationEvents:w,myToRemove:o,myToAdd:f};return this.delta(H),H}delta(p){const{toRemove:i,toAdd:u,myToRemove:s,myToAdd:o}=p,f=new R.ExtensionIdentifierSet(i),b=new R.ExtensionIdentifierSet(s);for(let r=0;r<this.c.length;r++)f.has(this.c[r].identifier)&&(this.c.splice(r,1),r--);for(let r=0;r<this.d.length;r++)b.has(this.d[r])&&(this.d.splice(r,1),r--);for(const r of u)this.c.push(r);for(const r of o)this.d.push(r)}containsExtension(p){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,p))return!0;return!1}}e.ExtensionHostExtensions=O;function y(T){const p=new R.ExtensionIdentifierMap;for(const i of T)p.set(i.identifier,i);return p}function h(T,p){return T.enabledApiProposals?T.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=h;function E(T,p){if(!h(T,p))throw new Error(`Extension '${T.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${T.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${T.identifier.value}`)}e.checkProposedApiEnabled=E;class g{constructor(p,i,u,s){this.codeLoadingTime=p,this.activateCallTime=i,this.activateResolvedTime=u,this.activationReason=s}}e.ActivationTimes=g;class l{constructor(p,i){this.description=p,this.value=i}}e.ExtensionPointContribution=l;var t;(function(T){T[T.Normal=0]="Normal",T[T.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(T){return{type:T.isBuiltin?0:1,isBuiltin:T.isBuiltin||T.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(T.publisher,T.name),uuid:T.uuid},manifest:T,location:T.extensionLocation,targetPlatform:T.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function d(T,p){return{identifier:new R.ExtensionIdentifier((0,k.getExtensionId)(T.manifest.publisher,T.manifest.name)),isBuiltin:T.type===0,isUserBuiltin:T.type===1&&T.isBuiltin,isUnderDevelopment:!!p,extensionLocation:T.location,...T.manifest,uuid:T.identifier.uuid,targetPlatform:T.targetPlatform}}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=S}),define(Ae[199],Re([1,0,9,100,24,26,14,17]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class I{constructor(a,d,S,T){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=S,this.activateResolvedTime=T}}I.NONE=new I(!1,-1,-1,-1),e.ExtensionActivationTimes=I;class m{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,d){return a===-1||d===-1?-1:d-a}build(){return new I(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=m;class O{constructor(a,d,S,T,p,i){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=S,this.module=T,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=O;class y extends O{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=y;class h extends O{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class E extends O{constructor(a){super(!0,a,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(a,d,S,T){this.g=T,this.a=a,this.b=d,this.c=S,this.d=new k.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[a,d]of this.d)d.dispose()}async waitForActivatingExtensions(){const a=[];for(const[d,S]of this.d)a.push(S.wait());await Promise.all(a)}isActivated(a){const d=this.d.get(a);return Boolean(d&&d.value)}getActivatedExtension(a){const d=this.d.get(a);if(!d||!d.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return d.value}async activateByEvent(a,d){if(this.f[a])return;const S=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(S.map(T=>({id:T.identifier,reason:{startup:d,extensionId:T.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,d){const S=this.a.getExtensionDescription(a);if(!S)throw new Error(`Extension '${a}' is not known`);return this.h([{id:S.identifier,reason:d}])}async h(a){const d=a.filter(S=>!this.isActivated(S.id)).map(S=>this.j(S));await Promise.all(d.map(S=>S.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const d=this.a.getExtensionDescription(a.id);if(!d){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new E(p));return this.c.onExtensionActivationError(a.id,p,new M.MissingExtensionDependency(a.id.value)),i}const S=[],T=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const p of T){if(this.m(p))continue;const i=this.d.get(p);if(i){S.push(i);continue}if(this.l(p)){S.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:a.reason}));continue}const u=this.a.getExtensionDescription(p);if(u){if(!u.main&&!u.browser)continue;S.push(this.j({id:u.identifier,reason:a.reason}));continue}const s=d.displayName||d.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),f=this.k(a,d.displayName,[],new E(o));return this.c.onExtensionActivationError(d.identifier,o,new M.MissingExtensionDependency(p)),f}return this.k(a,d.displayName,S,null)}k(a,d,S,T){const p=new l(a.id,d,a.reason,S,T,this.c,this.g);return this.d.set(a.id,p),p}l(a){return P.ExtensionDescriptionRegistry.isHostExtension(a,this.a,this.b)}m(a){const d=this.b.getExtensionDescription(a);return d?!d.main&&!d.browser:!1}};g=qe([je(3,R.ILogService)],g),e.ExtensionsActivator=g;let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,d,S,T,p,i,u){this.c=a,this.d=d,this.f=S,this.g=T,this.h=p,this.j=i,this.k=u,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const d=this.g[a];if(d.value&&!d.value.activationFailed){this.g.splice(a,1),a--;continue}if(d.value&&d.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);S.detail=d.value.activationFailedError,this.h=new E(S),this.j.onExtensionActivationError(this.c,S,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const d=new Error;if(a&&a.name&&(d.name=a.name),a&&a.message?d.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:d.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(d.stack=a.stack),this.h=new E(d),this.b&&n.isCancellationError(a))return;this.j.onExtensionActivationError(this.c,d,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};l=qe([je(6,R.ILogService)],l)});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[7],Re([1,0,16,9,87,28,66,13,10,2,35,43,95,73,26]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g){"use strict";var l,t,a,d,S,T,p,i,u,s,o,f,b,r,c,v,D,w,H,X,J,G,U,B,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function W(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...ye]=arguments;return Reflect.construct(z,ye,ne.constructor)}}})}var x;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(x=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var fe;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(fe=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let Se=i=class{static from(...L){let ne=L;return new i(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}constructor(L){l.set(this,void 0),_e(this,l,L,"f")}dispose(){typeof Ne(this,l,"f")=="function"&&(Ne(this,l,"f").call(this),_e(this,l,void 0,"f"))}};l=new WeakMap,Se=i=qe([W],Se),e.Disposable=Se;let ie=u=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let ye=1;ye<L.length;ye++){const xe=L[ye];xe.isBefore(ne)&&(ne=xe)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let ye=1;ye<L.length;ye++){const xe=L[ye];xe.isAfter(ne)&&(ne=xe)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof u)return!0;const{line:ne,character:ye}=L;return typeof ne=="number"&&typeof ye=="number"}static of(L){if(L instanceof u)return L;if(this.isPosition(L))return new u(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ne){if(L<0)throw(0,P.illegalArgument)("line must be non-negative");if(ne<0)throw(0,P.illegalArgument)("character must be non-negative");this.c=L,this.e=ne}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,P.illegalArgument)();let ye;return typeof L>"u"?ye=0:typeof L=="number"?ye=L:(ye=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),ye===0&&ne===0?this:new u(this.line+ye,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,P.illegalArgument)();let ye;return typeof L>"u"?ye=this.line:typeof L=="number"?ye=L:(ye=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),ye===this.line&&ne===this.character?this:new u(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};ie=u=qe([W],ie),e.Position=ie;let ue=s=class{static isRange(L){return L instanceof s?!0:L?ie.isPosition(L.start)&&ie.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ne,ye,xe){let Je,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof xe=="number"?(Je=new ie(L,ne),ot=new ie(ye,xe)):ie.isPosition(L)&&ie.isPosition(ne)&&(Je=ie.of(L),ot=ie.of(ne)),!Je||!ot)throw new Error("Invalid arguments");Je.isBefore(ot)?(this.c=Je,this.e=ot):(this.c=ot,this.e=Je)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):ie.isPosition(L)?!(ie.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ne=ie.Max(L.start,this.c),ye=ie.Min(L.end,this.e);if(!ne.isAfter(ye))return new s(ne,ye)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=ie.Min(L.start,this.c),ye=ie.Max(L.end,this.end);return new s(ne,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,P.illegalArgument)();let ye;return L?ie.isPosition(L)?ye=L:(ye=L.start||this.start,ne=L.end||this.end):ye=this.start,ye.isEqual(this.c)&&ne.isEqual(this.end)?this:new s(ye,ne)}toJSON(){return[this.start,this.end]}};ue=s=qe([W],ue),e.Range=ue;let ce=o=class extends ue{static isSelection(L){return L instanceof o?!0:L?ue.isRange(L)&&ie.isPosition(L.anchor)&&ie.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ne,ye,xe){let Je,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof xe=="number"?(Je=new ie(L,ne),ot=new ie(ye,xe)):ie.isPosition(L)&&ie.isPosition(ne)&&(Je=ie.of(L),ot=ie.of(ne)),!Je||!ot)throw new Error("Invalid arguments");super(Je,ot),this.f=Je,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ce=o=qe([W],ce),e.Selection=ce;class Te{constructor(L,ne,ye){if(typeof L!="string"||L.length===0)throw(0,P.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,P.illegalArgument)("port");if(typeof ye<"u"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z_\-]+$/.test(ye)))throw(0,P.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=Te;class de extends Error{static NotAvailable(L,ne){return new de(L,h.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new de(L,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=h.RemoteAuthorityResolverErrorCode.Unknown,ye){super(L),this._message=L,this._code=ne,this._detail=ye,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var ae;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ae=e.EndOfLine||(e.EndOfLine={}));var j;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let F=f=class{static isTextEdit(L){return L instanceof f?!0:L?ue.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new f(L,ne)}static insert(L,ne){return f.replace(new ue(L,L),ne)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const ne=new f(new ue(new ie(0,0),new ie(0,0)),"");return ne.newEol=L,ne}get range(){return this.c}set range(L){if(L&&!ue.isRange(L))throw(0,P.illegalArgument)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,P.illegalArgument)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,P.illegalArgument)("newEol");this.f=L}constructor(L,ne){this.c=L,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};F=f=qe([W],F),e.TextEdit=F;var Q;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Q=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let pe=b=class{static isNotebookCellEdit(L){return L instanceof b?!0:L?Wt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new b(L,ne)}static insertCells(L,ne){return new b(new Wt(L,L),ne)}static deleteCells(L){return new b(L,[])}static updateCellMetadata(L,ne){const ye=new b(new Wt(L,L),[]);return ye.newCellMetadata=ne,ye}static updateNotebookMetadata(L){const ne=new b(new Wt(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};pe=b=qe([W],pe),e.NotebookEdit=pe;class ke{static isSnippetTextEdit(L){return L instanceof ke?!0:L?ue.isRange(L.range)&&Ce.isSnippetString(L.snippet):!1}static replace(L,ne){return new ke(L,ne)}static insert(L,ne){return ke.replace(new ue(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=ke;var Ee;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ne,ye,xe){this.c.push({_type:1,from:L,to:ne,options:ye,metadata:xe})}createFile(L,ne,ye){this.c.push({_type:1,from:void 0,to:L,options:ne,metadata:ye})}deleteFile(L,ne,ye){this.c.push({_type:1,from:L,to:void 0,options:ne,metadata:ye})}e(L,ne,ye){this.c.push({_type:3,metadata:ye,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(L,ne,ye,xe){const Je=ne.start,ot=ne.end;(Je!==ot||ye.length>0)&&this.c.push({_type:5,uri:L,index:Je,count:ot-Je,cells:ye,metadata:xe})}g(L,ne,ye,xe){this.c.push({_type:3,metadata:xe,uri:L,edit:{editType:8,index:ne,metadata:ye}})}replace(L,ne,ye,xe){this.c.push({_type:2,uri:L,edit:new F(ne,ye),metadata:xe})}insert(L,ne,ye,xe){this.replace(L,new ue(ne,ne),ye,xe)}delete(L,ne,ye){this.replace(L,ne,"",ye)}has(L){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const ye of ne){if(!ye)continue;let xe,Je;Array.isArray(ye)?(xe=ye[0],Je=ye[1]):xe=ye,pe.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(L,xe.range.start,xe.newCellMetadata,Je):xe.newNotebookMetadata?this.e(L,xe.newNotebookMetadata,Je):this.f(L,xe.range,xe.newCells,Je):ke.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:L,range:xe.range,edit:xe.snippet,metadata:Je}):this.c.push({_type:2,uri:L,edit:xe,metadata:Je})}else{for(let ye=0;ye<this.c.length;ye++){const xe=this.c[ye];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===L.toString()&&(this.c[ye]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(L){const ne=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===L.toString()&&ne.push(ye.edit);return ne}entries(){const L=new M.ResourceMap;for(const ne of this.c)if(ne._type===2){let ye=L.get(ne.uri);ye||(ye=[ne.uri,[]],L.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=qe([W],ve),e.WorkspaceEdit=ve;let Ce=r=class{static isSnippetString(L){return L instanceof r?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=r.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this.e++){if(typeof L=="function"){const ye=new r;ye.e=this.e,L(ye),this.e=ye.e,L=ye.value}else L=r.c(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this.e++){const ye=L.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const ye=new r;ye.e=this.e,ne(ye),this.e=ye.e,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ce=r=qe([W],Ce),e.SnippetString=Ce;var se;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=c=class{static isLocation(L){return L instanceof c?!0:L?ue.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(ue.isRange(ne))this.range=ue.of(ne);else if(ie.isPosition(ne))this.range=new ue(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Z=c=qe([W],Z),e.Location=Z;let C=class{static is(L){return L?typeof L.message=="string"&&L.location&&ue.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};C=qe([W],C),e.DiagnosticRelatedInformation=C;let N=class{constructor(L,ne,ye=oe.Error){if(!ue.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=ye}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,n.equals)(L.tags,ne.tags)&&(0,n.equals)(L.relatedInformation,ne.relatedInformation,C.isEqual)}};N=qe([W],N),e.Diagnostic=N;let V=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};V=qe([W],V),e.Hover=V;var q;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(q=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let te=class{constructor(L,ne=q.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:q[this.kind]}}};te=qe([W],te),e.DocumentHighlight=te;var ge;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ge=e.SymbolKind||(e.SymbolKind={}));var Pe;(function(z){z[z.Deprecated=1]="Deprecated"})(Pe=e.SymbolTag||(e.SymbolTag={}));let le=v=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,ye,xe,Je){this.name=L,this.kind=ne,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),xe instanceof Z?this.location=xe:ye instanceof ue&&(this.location=new Z(xe,ye)),v.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};le=v=qe([W],le),e.SymbolInformation=le;let De=D=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(D.validate)}constructor(L,ne,ye,xe,Je){this.name=L,this.detail=ne,this.kind=ye,this.range=xe,this.selectionRange=Je,this.children=[],D.validate(this)}};De=D=qe([W],De),e.DocumentSymbol=De;var we;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(we=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let We=class{constructor(L,ne){this.title=L,this.kind=ne}};We=qe([W],We),e.CodeAction=We;let $e=w=class{constructor(L){this.value=L}append(L){return new w(this.value?this.value+w.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+w.c)}};$e.c=".",$e=w=qe([W],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let tt=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};tt=qe([W],tt),e.SelectionRange=tt;class Xe{constructor(L,ne,ye,xe,Je,ot){this.kind=L,this.name=ne,this.detail=ye,this.uri=xe,this.range=Je,this.selectionRange=ot}}e.CallHierarchyItem=Xe;class it{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=it;class nt{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=nt;var Me;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Me=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};rt=qe([W],rt),e.CodeLens=rt;let Y=H=class{static isMarkdownString(L){return L instanceof H?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){t.set(this,void 0),_e(this,t,new k.MarkdownString(L,{supportThemeIcons:ne}),"f")}get value(){return Ne(this,t,"f").value}set value(L){Ne(this,t,"f").value=L}get isTrusted(){return Ne(this,t,"f").isTrusted}set isTrusted(L){Ne(this,t,"f").isTrusted=L}get supportThemeIcons(){return Ne(this,t,"f").supportThemeIcons}set supportThemeIcons(L){Ne(this,t,"f").supportThemeIcons=L}get supportHtml(){return Ne(this,t,"f").supportHtml}set supportHtml(L){Ne(this,t,"f").supportHtml=L}get baseUri(){return Ne(this,t,"f").baseUri}set baseUri(L){Ne(this,t,"f").baseUri=L}appendText(L){return Ne(this,t,"f").appendText(L),this}appendMarkdown(L){return Ne(this,t,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return Ne(this,t,"f").appendCodeblock(ne??"",L),this}};t=new WeakMap,Y=H=qe([W],Y),e.MarkdownString=Y;let _=class{constructor(L,ne){this.label=L,this.documentation=ne}};_=qe([W],_),e.ParameterInformation=_;let be=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};be=qe([W],be),e.SignatureInformation=be;let He=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};He=qe([W],He),e.SignatureHelp=He;var Be;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Qe;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Qe=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(L){this.value=L}};Ye=qe([W],Ye),e.InlayHintLabelPart=Ye;let Ge=class{constructor(L,ne,ye){this.position=L,this.label=ne,this.kind=ye}};Ge=qe([W],Ge),e.InlayHint=Ge;var at;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var yt;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(yt=e.CompletionItemKind||(e.CompletionItemKind={}));var It;(function(z){z[z.Deprecated=1]="Deprecated"})(It=e.CompletionItemTag||(e.CompletionItemTag={}));let St=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&yt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};St=qe([W],St),e.CompletionItem=St;let vt=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};vt=qe([W],vt),e.CompletionList=vt;let Nt=class{constructor(L,ne,ye){this.insertText=L,this.range=ne,this.command=ye}};Nt=qe([W],Nt),e.InlineSuggestion=Nt;let Rt=class{constructor(L){this.commands=void 0,this.items=L}};Rt=qe([W],Rt),e.InlineSuggestionList=Rt;var Yt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Yt=e.ViewColumn||(e.ViewColumn={}));var Gt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Gt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var dt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var mt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(mt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function L(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=L}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let wt=class{constructor(L,ne){if(ne&&!m.URI.isUri(ne))throw(0,P.illegalArgument)("target");if(!ue.isRange(L)||L.isEmpty)throw(0,P.illegalArgument)("range");this.range=L,this.target=ne}};wt=qe([W],wt),e.DocumentLink=wt;let zt=class{constructor(L,ne,ye,xe){this.red=L,this.green=ne,this.blue=ye,this.alpha=xe}};zt=qe([W],zt),e.Color=zt;let Ct=class{constructor(L,ne){if(ne&&!(ne instanceof zt))throw(0,P.illegalArgument)("color");if(!ue.isRange(L)||L.isEmpty)throw(0,P.illegalArgument)("range");this.range=L,this.color=ne}};Ct=qe([W],Ct),e.ColorInformation=Ct;let Ke=class{constructor(L){if(!L||typeof L!="string")throw(0,P.illegalArgument)("label");this.label=L}};Ke=qe([W],Ke),e.ColorPresentation=Ke;var jt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(jt=e.ColorFormat||(e.ColorFormat={}));var Xt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Xt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ut;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Ut=e.TerminalExitReason||(e.TerminalExitReason={}));class Ie{constructor(L,ne,ye){if(this.startIndex=L,this.length=ne,this.tooltip=ye,typeof L!="number"||L<0)throw(0,P.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,P.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=Ie;class Oe{constructor(L){this.uri=L}}e.TerminalQuickFixOpener=Oe;class me{constructor(L){this.terminalCommand=L}}e.TerminalQuickFixCommand=me;var K;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(K=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(L){if(this.options=L,typeof L!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Fe;var ze;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(ze=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=X=class{static from(L){switch(L){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,P.illegalArgument)("name");this.c=L}get id(){return this.c}};Ve.Clean=new X("clean","Clean"),Ve.Build=new X("build","Build"),Ve.Rebuild=new X("rebuild","Rebuild"),Ve.Test=new X("test","Test"),Ve=X=qe([W],Ve),e.TaskGroup=Ve;function et(z){let L="";for(let ne=0;ne<z.length;ne++)L+=z[ne].replace(/,/g,",,")+",";return L}let lt=class{constructor(L,ne,ye){if(typeof L!="string")throw(0,P.illegalArgument)("process");this.e=[],this.c=L,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ye):this.f=ne)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,P.illegalArgument)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)L.push(ne);return et(L)}};lt=qe([W],lt),e.ProcessExecution=lt;let ut=class{constructor(L,ne,ye){if(this.f=[],Array.isArray(ne)){if(!L)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,P.illegalArgument)("command");this.e=L,this.f=ne,this.g=ye}else{if(typeof L!="string")throw(0,P.illegalArgument)("commandLine");this.c=L,this.g=ne}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,P.illegalArgument)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,P.illegalArgument)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)L.push(typeof ne=="string"?ne:ne.value);return et(L)}};ut=qe([W],ut),e.ShellExecution=ut;var Dt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Dt=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class Ft{constructor(L){this.c=L}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(L){this.c=L}get callback(){return this.c}}e.CustomExecution=Ft;let $t=J=class{constructor(L,ne,ye,xe,Je,ot){this.j=!1,this.k=this.definition=L;let ht;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ye,this.execution=xe,ht=Je,this.j=!0):ne===gt.Global||ne===gt.Workspace?(this.target=ne,this.m=this.name=ye,this.t=this.source=xe,this.execution=Je,ht=ot):(this.target=ne,this.m=this.name=ye,this.t=this.source=xe,this.execution=Je,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:J.e,id:this.n.computeId()}:this.n instanceof ut?this.k={type:J.f,id:this.n.computeId()}:this.n instanceof Ft?this.k={type:J.c,id:this.n.computeId()}:this.k={type:J.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=L}get scope(){return this.l}set target(L){this.y(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,P.illegalArgument)("name");this.y(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.y(),this.n=L;const ne=this.k.type;(J.g===ne||J.e===ne||J.f===ne||J.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.y(),this.o=L,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.y(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.y(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.y(),this.u=L}get detail(){return this.x}set detail(L){L===null&&(L=void 0),this.x=L}get presentationOptions(){return this.v}set presentationOptions(L){L==null&&(L=Object.create(null)),this.y(),this.v=L}get runOptions(){return this.w}set runOptions(L){L==null&&(L=Object.create(null)),this.y(),this.w=L}};$t.c="customExecution",$t.e="process",$t.f="shell",$t.g="$empty",$t=J=qe([W],$t),e.Task=$t;var Oi;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Oi=e.ProgressLocation||(e.ProgressLocation={}));var Tt;(function(z){function L(ne){const ye=ne;return(0,I.isNumber)(ye.value)?ye.tooltip&&!(0,I.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=L})(Tt=e.ViewBadge||(e.ViewBadge={}));let Ei=G=class{static isTreeItem(L,ne){const ye=L;if(ye.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(ne,"treeItemCheckbox");const xe=(0,I.isNumber)(ye.checkboxState)?ye.checkboxState:(0,I.isObject)(ye.checkboxState)&&(0,I.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,Je=!(0,I.isNumber)(ye.checkboxState)&&(0,I.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(xe===void 0||xe!==bt.Checked&&xe!==bt.Unchecked||Je!==void 0&&!(0,I.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(L instanceof G)return!0;if(ye.label!==void 0&&!(0,I.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,I.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,I.isString)(ye.iconPath)&&!m.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,I.isString)(ye.iconPath.id))){const xe=ye.iconPath;if(!xe||!(0,I.isString)(xe.light)&&!m.URI.isUri(xe.light)&&!(0,I.isString)(xe.dark)&&!m.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,I.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!m.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,I.isString)(ye.tooltip)&&!(ye.tooltip instanceof Y)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<ci.None&&ye.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,I.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(L,ne=ci.None){this.collapsibleState=ne,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};Ei=G=qe([W],Ei),e.TreeItem=Ei;var ci;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var bt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(bt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ui=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L,ne){this.value=L,this.id=ne??(0,O.generateUuid)()}};ui=qe([W],ui),e.DataTransferItem=ui;let li=class{constructor(L){a.add(this),d.set(this,new Map);for(const[ne,ye]of L??[]){const xe=Ne(this,d,"f").get(Ne(this,a,"m",S).call(this,ne));xe?xe.push(ye):Ne(this,d,"f").set(Ne(this,a,"m",S).call(this,ne),[ye])}}get(L){return Ne(this,d,"f").get(Ne(this,a,"m",S).call(this,L))?.[0]}set(L,ne){Ne(this,d,"f").set(Ne(this,a,"m",S).call(this,L),[ne])}forEach(L,ne){for(const[ye,xe]of Ne(this,d,"f"))for(const Je of xe)L.call(ne,Je,ye,this)}*[(d=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[L,ne]of Ne(this,d,"f"))for(const ye of ne)yield[L,ye]}};S=function(L){return L.toLowerCase()},li=qe([W],li),e.DataTransfer=li;let ii=class{constructor(L){this.insertText=L}};ii=qe([W],ii),e.DocumentDropEdit=ii;let wi=class{constructor(L){this.insertText=L}};wi=qe([W],wi),e.DocumentPasteEdit=wi;let qt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};qt=qe([W],qt),e.ThemeIcon=qt,qt.File=new qt("file"),qt.Folder=new qt("folder");let Pt=class{constructor(L){this.id=L}};Pt=qe([W],Pt),e.ThemeColor=Pt;var Fi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Fi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Si=class{get base(){return this.c}set base(L){this.c=L,this.e=m.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,P.illegalArgument)("base");if(typeof ne!="string")throw(0,P.illegalArgument)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Si=qe([W],Si),e.RelativePattern=Si;const ni=new WeakMap;function di(z,L){ni.set(z,L)}e.setBreakpointId=di;let ct=class{constructor(L,ne,ye,xe){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ni.get(this)??(0,O.generateUuid)()),this.c}};ct=qe([W],ct),e.Breakpoint=ct;let yi=class extends ct{constructor(L,ne,ye,xe,Je){if(super(ne,ye,xe,Je),L===null)throw(0,P.illegalArgument)("location");this.location=L}};yi=qe([W],yi),e.SourceBreakpoint=yi;let xt=class extends ct{constructor(L,ne,ye,xe,Je){super(ne,ye,xe,Je),this.functionName=L}};xt=qe([W],xt),e.FunctionBreakpoint=xt;let Jt=class extends ct{constructor(L,ne,ye,xe,Je,ot,ht){if(super(xe,Je,ot,ht),!ne)throw(0,P.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=ye}};Jt=qe([W],Jt),e.DataBreakpoint=Jt;let hi=class{constructor(L,ne,ye){this.command=L,this.args=ne||[],this.options=ye}};hi=qe([W],hi),e.DebugAdapterExecutable=hi;let Di=class{constructor(L,ne){this.port=L,this.host=ne}};Di=qe([W],Di),e.DebugAdapterServer=Di;let Ii=class{constructor(L){this.path=L}};Ii=qe([W],Ii),e.DebugAdapterNamedPipeServer=Ii;let fi=class{constructor(L){this.implementation=L}};fi=qe([W],fi),e.DebugAdapterInlineImplementation=fi;let Ci=class{constructor(L,ne){this.range=L,this.expression=ne}};Ci=qe([W],Ci),e.EvaluatableExpression=Ci;var Li;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let _t=class{constructor(L,ne){this.range=L,this.text=ne}};_t=qe([W],_t),e.InlineValueText=_t;let ki=class{constructor(L,ne,ye=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=ye}};ki=qe([W],ki),e.InlineValueVariableLookup=ki;let ri=class{constructor(L,ne){this.range=L,this.expression=ne}};ri=qe([W],ri),e.InlineValueEvaluatableExpression=ri;let si=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};si=qe([W],si),e.InlineValueContext=si;var Bi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let Ti=U=class extends Error{static FileExists(L){return new U(L,y.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(L){return new U(L,y.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(L){return new U(L,y.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(L){return new U(L,y.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(L){return new U(L,y.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(L){return new U(L,y.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}constructor(L,ne=y.FileSystemProviderErrorCode.Unknown,ye){super(m.URI.isUri(L)?L.toString(!0):L),this.code=ye?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};Ti=U=qe([W],Ti),e.FileSystemError=Ti;let Zt=class{constructor(L,ne,ye){this.start=L,this.end=ne,this.kind=ye}};Zt=qe([W],Zt),e.FoldingRange=Zt;var Wi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Vi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Vi=e.CommentMode||(e.CommentMode={}));var mi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ji{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=ji;function qi(z){return typeof z>"u"||(0,I.isStringArray)(z)}class Pi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let ne=0,ye=L.tokenTypes.length;ne<ye;ne++)this.j.set(L.tokenTypes[ne],ne);for(let ne=0,ye=L.tokenModifiers.length;ne<ye;ne++)this.k.set(L.tokenModifiers[ne],ne)}}push(L,ne,ye,xe,Je){if(typeof L=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof xe=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(L,ne,ye,xe,Je);if(ue.isRange(L)&&typeof ne=="string"&&qi(ye))return this.m(L,ne,ye);throw(0,P.illegalArgument)()}m(L,ne,ye){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const xe=L.start.line,Je=L.start.character,ot=L.end.character-L.start.character,ht=this.j.get(ne);let Lt=0;if(ye)for(const Vt of ye){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Vt);Lt|=1<<Kt>>>0}this.n(xe,Je,ot,ht,Lt)}n(L,ne,ye,xe,Je){if(this.f&&(L<this.c||L===this.c&&ne<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,Kt=0;for(let Qt=0;Qt<Lt;Qt++){let ei=this.g[5*Qt],Ai=this.g[5*Qt+1];ei===0?(ei=Vt,Ai+=Kt):ei+=Vt,this.g[5*Qt]=ei,this.g[5*Qt+1]=Ai,Vt=ei,Kt=Ai}}let ot=L,ht=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=ye,this.g[this.h++]=xe,this.g[this.h++]=Je,this.c=L,this.e=ne}static o(L){const ne=[],ye=L.length/5|0;for(let ht=0;ht<ye;ht++)ne[ht]=ht;ne.sort((ht,Lt)=>{const Vt=L[5*ht],Kt=L[5*Lt];if(Vt===Kt){const Qt=L[5*ht+1],ei=L[5*Lt+1];return Qt-ei}return Vt-Kt});const xe=new Uint32Array(L.length);let Je=0,ot=0;for(let ht=0;ht<ye;ht++){const Lt=5*ne[ht],Vt=L[Lt+0],Kt=L[Lt+1],Qt=L[Lt+2],ei=L[Lt+3],Ai=L[Lt+4],dn=Vt-Je,Un=dn===0?Kt-ot:Kt,Ri=5*ht;xe[Ri+0]=dn,xe[Ri+1]=Un,xe[Ri+2]=Qt,xe[Ri+3]=ei,xe[Ri+4]=Ai,Je=Vt,ot=Kt}return xe}build(L){return this.f?new oi(new Uint32Array(this.g),L):new oi(Pi.o(this.g),L)}}e.SemanticTokensBuilder=Pi;class oi{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=oi;class Ni{constructor(L,ne,ye){this.start=L,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=Ni;class Mi{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=Mi;var Ue;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Ue=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new qt("arrow-left")},Bt=qe([W],Bt),e.QuickInputButtons=Bt;var Ui;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var pt;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(pt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var xi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(xi=e.ExtensionKind||(e.ExtensionKind={}));class Ki{static validate(L){if(typeof L.badge=="string"){let ne=(0,A.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,A.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!qt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,ye){this.badge=L,this.tooltip=ne,this.color=ye}}e.FileDecoration=Ki;let gi=class{constructor(L){this.kind=L}};gi=qe([W],gi),e.ColorTheme=gi;var Gi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{static isNotebookRange(L){return L instanceof Wt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ne){if(L<0)throw(0,P.illegalArgument)("start must be positive");if(ne<0)throw(0,P.illegalArgument)("end must be positive");L<=ne?(this.c=L,this.e=ne):(this.c=ne,this.e=L)}with(L){let ne=this.c,ye=this.e;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(ye=L.end),ne===this.c&&ye===this.e?this:new Wt(ne,ye)}}e.NotebookRange=Wt;class pi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>pi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,ye,xe,Je,ot,ht){this.kind=L,this.value=ne,this.languageId=ye,this.mime=xe,this.outputs=Je??[],this.metadata=ot,this.executionSummary=ht,pi.validate(this)}}e.NotebookCellData=pi;class Xi{constructor(L){this.cells=L}}e.NotebookData=Xi;class Ht{static isNotebookCellOutputItem(L){return L instanceof Ht?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Ht.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Ht.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ht.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Ht(L,ne)}static text(L,ne=R.Mimes.text){const ye=Ne(Ht,T,"f",p).encode(String(L));return new Ht(ye,ne)}static json(L,ne="text/x-json"){const ye=JSON.stringify(L,void 0,"	");return Ht.text(ye,ne)}constructor(L,ne){this.data=L,this.mime=ne;const ye=(0,R.normalizeMimeType)(ne,!0);if(!ye)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}T=Ht,p={value:new TextEncoder},e.NotebookCellOutputItem=Ht;class ai{static isNotebookCellOutput(L){return L instanceof ai?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const ye=new Set,xe=new Set;for(let Je=0;Je<L.length;Je++){const ot=L[Je],ht=(0,R.normalizeMimeType)(ot.mime);if(!ye.has(ht)||(0,E.isTextStreamMime)(ht)){ye.add(ht);continue}xe.add(Je),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return xe.size===0?L:L.filter((Je,ot)=>!xe.has(ot))}constructor(L,ne,ye){this.items=ai.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,O.generateUuid)(),this.metadata=ne??ye)}}e.NotebookCellOutput=ai;var Qi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Qi=e.NotebookCellKind||(e.NotebookCellKind={}));var Yi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ji;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ji=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Zi{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=Zi;var en;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var tn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(tn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class re{constructor(L,ne=[]){this.uri=L,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=re;class he{constructor(L){this.label=L}}e.NotebookKernelSourceAction=he;let Le=class{constructor(L,ne){this.label=L,this.timestamp=ne}};Le=qe([W],Le),e.TimelineItem=Le;var st;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(st=e.ExtensionMode||(e.ExtensionMode={}));var Et;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Et=e.ExtensionRuntime||(e.ExtensionRuntime={}));var At;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(At=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=pn;class vn{constructor(L,ne){this.c=L,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=vn;var bn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var En;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(En=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $i=class{constructor(L=void 0,ne=void 0,ye=void 0,xe=!1){this.include=L,this.exclude=ne,this.profile=ye,this.continuous=xe}};$i=qe([W],$i),e.TestRunRequest=$i;let nn=class extends $i{};nn=qe([W],nn),e.TestRunRequest2=nn;let rn=B=class{static diff(L,ne,ye){const xe=new B(L);return xe.expectedOutput=ne,xe.actualOutput=ye,xe}constructor(L){this.message=L}};rn=B=qe([W],rn),e.TestMessage=rn;let sn=class{constructor(L){this.id=L}};sn=qe([W],sn),e.TestTag=sn;let vi=class{constructor(L,ne){this.covered=L,this.total=ne}};vi=qe([W],vi),e.CoveredCount=vi;let on=$=class{static fromDetails(L,ne){const ye=new vi(0,0),xe=new vi(0,0),Je=new vi(0,0);for(const ht of ne)if("branches"in ht){ye.total+=1,ye.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)xe.total+=1,xe.covered+=Lt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ot=new $(L,ye,xe.total>0?xe:void 0,Je.total>0?Je:void 0);return ot.detailedCoverage=ne,ot}constructor(L,ne,ye,xe){this.uri=L,this.statementCoverage=ne,this.branchCoverage=ye,this.functionCoverage=xe}};on=$=qe([W],on),e.FileCoverage=on;let an=class{constructor(L,ne,ye=[]){this.executionCount=L,this.location=ne,this.branches=ye}};an=qe([W],an),e.StatementCoverage=an;let cn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};cn=qe([W],cn),e.BranchCoverage=cn;let un=class{constructor(L,ne){this.executionCount=L,this.location=ne}};un=qe([W],un),e.FunctionCoverage=un;var wn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Sn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Sn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var yn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Dn{constructor(L,ne,ye,xe,Je,ot){this.kind=L,this.name=ne,this.detail=ye,this.uri=xe,this.range=Je,this.selectionRange=ot}}e.TypeHierarchyItem=Dn;class In{constructor(L){this.uri=L}}e.TextTabInput=In;class Cn{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=Cn;class kn{constructor(L,ne,ye,xe){this.base=L,this.input1=ne,this.input2=ye,this.result=xe}}e.TextMergeTabInput=kn;class Tn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=Tn;class Pn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=Pn;class An{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=An;class Rn{constructor(L,ne,ye){this.original=L,this.modified=ne,this.notebookType=ye}}e.NotebookDiffEditorTabInput=Rn;class On{constructor(){}}e.TerminalEditorTabInput=On;class Fn{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.InteractiveWindowInput=Fn;var Ln;(function(z){z[z.Up=1]="Up",z[z.Down=2]="Down"})(Ln=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Nn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Nn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone"})(Mn=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(Ae[101],Re([1,0,49,15,13,266,134,7,16]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const m=new Map;function O(g,l){l?m.set(g,l):m.delete(g)}e.setWordDefinitionFor=O;function y(g){return m.get(g)}class h extends M.MirrorTextModel{constructor(l,t,a,d,S,T,p,i){super(t,a,d,S),this.c=l,this.m=T,this.q=p,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,I.equals)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===P.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(t){return t?l.s(t):l.getText()},get eol(){return l.g===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(t){return l.t(t)},offsetAt(t){return l.u(t)},positionAt(t){return l.v(t)},validateRange(t){return l.w(t)},validatePosition(t){return l.x(t)},getWordRangeAtPosition(t,a){return l.y(t,a)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,n.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,n.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const t=this.w(l);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const a=this.g,d=t.start.line,S=t.end.line,T=[];T.push(this.f[d].substring(t.start.character));for(let p=d+1;p<S;p++)T.push(this.f[p]);return T.push(this.f[S].substring(0,t.end.character)),T.join(a)}t(l){let t;if(l instanceof A.Position?t=l.line:typeof l=="number"&&(t=l),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new E(t,this.f[t],t===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const t=this.j.getIndexOf(l),a=this.f[t.index].length;return new A.Position(t.index,Math.min(t.remainder,a))}w(l){if(!(l instanceof A.Range))throw new Error("Invalid argument");const t=this.x(l.start),a=this.x(l.end);return t===l.start&&a===l.end?l:new A.Range(t.line,t.character,a.line,a.character)}x(l){if(!(l instanceof A.Position))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:t,character:a}=l,d=!1;if(t<0)t=0,a=0,d=!0;else if(t>=this.f.length)t=this.f.length-1,a=this.f[t].length,d=!0;else{const S=this.f[t].length;a<0?(a=0,d=!0):a>S&&(a=S,d=!0)}return d?new A.Position(t,a):l}y(l,t){const a=this.x(l);if(!t)t=y(this.m);else if((0,k.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const d=(0,R.getWordAtText)(a.character+1,(0,R.ensureValidWordDefinition)(t),this.f[a.line],0);if(d)return new A.Range(a.line,d.startColumn-1,a.line,d.endColumn-1)}}e.ExtHostDocumentData=h;class E{constructor(l,t,a){this.a=l,this.b=t,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=E}),define(Ae[200],Re([1,0,7,18,4]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let I;switch(A){case"light":I=n.ColorThemeKind.Light;break;case"hcDark":I=n.ColorThemeKind.HighContrast;break;case"hcLight":I=n.ColorThemeKind.HighContrastLight;break;default:I=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(I),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([je(0,P.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ae[8],Re([1,0,16,25,118,201,87,28,114,67,66,23,10,2,44,77,92,98,97,73,45,56,197,7]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ie){function Oe(K){const{selectionStartLineNumber:Fe,selectionStartColumn:ze,positionLineNumber:Ze,positionColumn:Ve}=K,et=new u.Position(Fe-1,ze-1),lt=new u.Position(Ze-1,Ve-1);return new u.Selection(et,lt)}Ie.to=Oe;function me(K){const{anchor:Fe,active:ze}=K;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ie.from=me})(s=e.Selection||(e.Selection={}));var o;(function(Ie){function Oe(K){if(!K)return;const{start:Fe,end:ze}=K;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ie.from=Oe;function me(K){if(!K)return;const{startLineNumber:Fe,startColumn:ze,endLineNumber:Ze,endColumn:Ve}=K;return new u.Range(Fe-1,ze-1,Ze-1,Ve-1)}Ie.to=me})(o=e.Range||(e.Range={}));var f;(function(Ie){function Oe(me){switch(me){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ie.to=Oe})(f=e.TokenType||(e.TokenType={}));var b;(function(Ie){function Oe(K){return new u.Position(K.lineNumber-1,K.column-1)}Ie.to=Oe;function me(K){return{lineNumber:K.line+1,column:K.character+1}}Ie.from=me})(b=e.Position||(e.Position={}));var r;(function(Ie){function Oe(Fe,ze){return(0,n.coalesce)((0,n.asArray)(Fe).map(Ze=>me(Ze,ze)))}Ie.from=Oe;function me(Fe,ze){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:K(Fe.scheme,ze),pattern:be.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function K(Fe,ze){return ze&&typeof Fe=="string"?ze.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(Ie){function Oe(K){switch(K){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ie.from=Oe;function me(K){switch(K){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ie.to=me})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Ie){function Oe(K){let Fe;return K.code&&((0,h.isString)(K.code)||(0,h.isNumber)(K.code)?Fe=String(K.code):Fe={value:String(K.code.value),target:K.code.target}),{...o.from(K.range),message:K.message,source:K.source,code:Fe,severity:w.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(D.from),tags:Array.isArray(K.tags)?(0,n.coalesce)(K.tags.map(c.from)):void 0}}Ie.from=Oe;function me(K){const Fe=new u.Diagnostic(o.to(K),K.message,w.to(K.severity));return Fe.source=K.source,Fe.code=(0,h.isString)(K.code)?K.code:K.code?.value,Fe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(D.to),Fe.tags=K.tags&&(0,n.coalesce)(K.tags.map(c.to)),Fe}Ie.to=me})(v=e.Diagnostic||(e.Diagnostic={}));var D;(function(Ie){function Oe(K){return{...o.from(K.location.range),message:K.message,resource:K.location.uri}}Ie.from=Oe;function me(K){return new u.DiagnosticRelatedInformation(new u.Location(K.resource,o.to(K)),K.message)}Ie.to=me})(D=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Ie){function Oe(K){switch(K){case u.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Oe;function me(K){switch(K){case t.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ie.to=me})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var H;(function(Ie){function Oe(K){return typeof K=="number"&&K>=u.ViewColumn.One?K-1:K===u.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Ie.from=Oe;function me(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=me})(H=e.ViewColumn||(e.ViewColumn={}));function X(Ie){return typeof Ie.range<"u"}function J(Ie){return Ie.length===0?!0:!!X(Ie[0])}e.isDecorationOptionsArr=J;var G;(function(Ie){function Oe(Ve){return Ve.map(Ie.from)}Ie.fromMany=Oe;function me(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function K(Ve){let et;if(me(Ve)){const{language:gt,value:Ft}=Ve;et={value:"```"+gt+`
`+Ft+"\n```\n"}}else u.MarkdownString.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const lt=Object.create(null);et.uris=lt;const ut=gt=>{try{let Ft=E.URI.parse(gt,!0);Ft=Ft.with({query:Fe(Ft.query,lt)}),lt[gt]=Ft}catch{}return""},Dt=new I.marked.Renderer;return Dt.link=ut,Dt.image=gt=>typeof gt=="string"?ut(R.parseHrefAndDimensions(gt).href):"",(0,I.marked)(et.value,{renderer:Dt}),et}Ie.from=K;function Fe(Ve,et){if(!Ve)return Ve;let lt;try{lt=(0,m.parse)(Ve)}catch{}if(!lt)return Ve;let ut=!1;return lt=(0,y.cloneAndChange)(lt,Dt=>{if(E.URI.isUri(Dt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[gt]=Dt,ut=!0,gt}else return}),ut?JSON.stringify(lt):Ve}function ze(Ve){const et=new u.MarkdownString(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?E.URI.from(Ve.baseUri):void 0,et}Ie.to=ze;function Ze(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ie.from(Ve)}Ie.fromStrict=Ze})(G=e.MarkdownString||(e.MarkdownString={}));function U(Ie){return J(Ie)?Ie.map(Oe=>({range:o.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?G.fromMany(Oe.hoverMessage):Oe.hoverMessage?G.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ie.map(Oe=>({range:o.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function B(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?E.URI.file(Ie):Ie}e.pathOrURIToURI=B;var $;(function(Ie){function Oe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?B(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ie.from=Oe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var W;(function(Ie){function Oe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?B(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}Ie.from=Oe})(W=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(Ie){function Oe(me){if(typeof me>"u")return me;switch(me){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Oe})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var fe;(function(Ie){function Oe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?x.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?W.from(me.light):void 0,dark:me.dark?W.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?B(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}Ie.from=Oe})(fe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Se;(function(Ie){function Oe(K){return{text:K.newText,eol:K.newEol&&nt.from(K.newEol),range:o.from(K.range)}}Ie.from=Oe;function me(K){const Fe=new u.TextEdit(o.to(K.range),K.text);return Fe.newEol=typeof K.eol>"u"?void 0:nt.to(K.eol),Fe}Ie.to=me})(Se=e.TextEdit||(e.TextEdit={}));var ie;(function(Ie){function Oe(K,Fe){const ze={edits:[]};if(K instanceof u.WorkspaceEdit){const Ze=new A.ResourceSet;for(const Ve of K._allEntries())Ve._type===1&&E.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of K._allEntries())Ve._type===1?ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,P.encodeBase64)(P.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?ze.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?ze.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(It.from)}})}return ze}Ie.from=Oe;function me(K){const Fe=new u.WorkspaceEdit;for(const ze of K.edits)ze.textEdit?Fe.replace(E.URI.revive(ze.resource),o.to(ze.textEdit.range),ze.textEdit.text):Fe.renameFile(E.URI.revive(ze.oldResource),E.URI.revive(ze.newResource),ze.options);return Fe}Ie.to=me})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(Ie){const Oe=Object.create(null);Oe[u.SymbolKind.File]=0,Oe[u.SymbolKind.Module]=1,Oe[u.SymbolKind.Namespace]=2,Oe[u.SymbolKind.Package]=3,Oe[u.SymbolKind.Class]=4,Oe[u.SymbolKind.Method]=5,Oe[u.SymbolKind.Property]=6,Oe[u.SymbolKind.Field]=7,Oe[u.SymbolKind.Constructor]=8,Oe[u.SymbolKind.Enum]=9,Oe[u.SymbolKind.Interface]=10,Oe[u.SymbolKind.Function]=11,Oe[u.SymbolKind.Variable]=12,Oe[u.SymbolKind.Constant]=13,Oe[u.SymbolKind.String]=14,Oe[u.SymbolKind.Number]=15,Oe[u.SymbolKind.Boolean]=16,Oe[u.SymbolKind.Array]=17,Oe[u.SymbolKind.Object]=18,Oe[u.SymbolKind.Key]=19,Oe[u.SymbolKind.Null]=20,Oe[u.SymbolKind.EnumMember]=21,Oe[u.SymbolKind.Struct]=22,Oe[u.SymbolKind.Event]=23,Oe[u.SymbolKind.Operator]=24,Oe[u.SymbolKind.TypeParameter]=25;function me(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ie.from=me;function K(Fe){for(const ze in Oe)if(Oe[ze]===Fe)return Number(ze);return u.SymbolKind.Property}Ie.to=K})(ue=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ie){function Oe(K){switch(K){case u.SymbolTag.Deprecated:return 1}}Ie.from=Oe;function me(K){switch(K){case 1:return u.SymbolTag.Deprecated}}Ie.to=me})(ce=e.SymbolTag||(e.SymbolTag={}));var Te;(function(Ie){function Oe(K){return{name:K.name,kind:ue.from(K.kind),tags:K.tags&&K.tags.map(ce.from),containerName:K.containerName,location:Q.from(K.location)}}Ie.from=Oe;function me(K){const Fe=new u.SymbolInformation(K.name,ue.to(K.kind),K.containerName,Q.to(K.location));return Fe.tags=K.tags&&K.tags.map(ce.to),Fe}Ie.to=me})(Te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Ie){function Oe(K){const Fe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:o.from(K.range),selectionRange:o.from(K.selectionRange),kind:ue.from(K.kind),tags:K.tags?.map(ce.from)??[]};return K.children&&(Fe.children=K.children.map(Oe)),Fe}Ie.from=Oe;function me(K){const Fe=new u.DocumentSymbol(K.name,K.detail,ue.to(K.kind),o.to(K.range),o.to(K.selectionRange));return(0,n.isNonEmptyArray)(K.tags)&&(Fe.tags=K.tags.map(ce.to)),K.children&&(Fe.children=K.children.map(me)),Fe}Ie.to=me})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ae;(function(Ie){function Oe(K){const Fe=new u.CallHierarchyItem(ue.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Fe._sessionId=K._sessionId,Fe._itemId=K._itemId,Fe}Ie.to=Oe;function me(K,Fe,ze){if(Fe=Fe??K._sessionId,ze=ze??K._itemId,Fe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:ze,name:K.name,detail:K.detail,kind:ue.from(K.kind),uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(ce.from)}}Ie.from=me})(ae=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(Ie){function Oe(me){return new u.CallHierarchyIncomingCall(ae.to(me.from),me.fromRanges.map(K=>o.to(K)))}Ie.to=Oe})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ie){function Oe(me){return new u.CallHierarchyOutgoingCall(ae.to(me.to),me.fromRanges.map(K=>o.to(K)))}Ie.to=Oe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(Ie){function Oe(K){return{range:K.range&&o.from(K.range),uri:K.uri}}Ie.from=Oe;function me(K){return new u.Location(E.URI.revive(K.uri),o.to(K.range))}Ie.to=me})(Q=e.location||(e.location={}));var pe;(function(Ie){function Oe(K){const Fe=K,ze=K;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:ze.uri,range:o.from(Fe.targetRange?Fe.targetRange:ze.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ie.from=Oe;function me(K){return{targetUri:E.URI.revive(K.uri),targetRange:o.to(K.range),targetSelectionRange:K.targetSelectionRange?o.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?o.to(K.originSelectionRange):void 0}}Ie.to=me})(pe=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Ie){function Oe(K){return{range:o.from(K.range),contents:G.fromMany(K.contents)}}Ie.from=Oe;function me(K){return new u.Hover(K.contents.map(G.to),o.to(K.range))}Ie.to=me})(ke=e.Hover||(e.Hover={}));var Ee;(function(Ie){function Oe(K){return{range:o.from(K.range),expression:K.expression}}Ie.from=Oe;function me(K){return new u.EvaluatableExpression(o.to(K.range),K.expression)}Ie.to=me})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Ie){function Oe(K){if(K instanceof u.InlineValueText)return{type:"text",range:o.from(K.range),text:K.text};if(K instanceof u.InlineValueVariableLookup)return{type:"variable",range:o.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Oe;function me(K){switch(K.type){case"text":return{range:o.to(K.range),text:K.text};case"variable":return{range:o.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:o.to(K.range),expression:K.expression}}}Ie.to=me})(ve=e.InlineValue||(e.InlineValue={}));var Ce;(function(Ie){function Oe(K){return{frameId:K.frameId,stoppedLocation:o.from(K.stoppedLocation)}}Ie.from=Oe;function me(K){return new u.InlineValueContext(K.frameId,o.to(K.stoppedLocation))}Ie.to=me})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Ie){function Oe(K){return{range:o.from(K.range),kind:K.kind}}Ie.from=Oe;function me(K){return new u.DocumentHighlight(o.to(K.range),K.kind)}Ie.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var oe;(function(Ie){function Oe(me){switch(me){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ie.to=Oe})(oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ie){function Oe(me){return{triggerKind:oe.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ie.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var C;(function(Ie){function Oe(K){switch(K){case u.CompletionItemTag.Deprecated:return 1}}Ie.from=Oe;function me(K){switch(K){case 1:return u.CompletionItemTag.Deprecated}}Ie.to=me})(C=e.CompletionItemTag||(e.CompletionItemTag={}));var N;(function(Ie){const Oe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function me(ze){return Oe.get(ze)??9}Ie.from=me;const K=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(ze){return K.get(ze)??u.CompletionItemKind.Property}Ie.to=Fe})(N=e.CompletionItemKind||(e.CompletionItemKind={}));var V;(function(Ie){function Oe(me,K){const Fe=new u.CompletionItem(me.label);return Fe.insertText=me.insertText,Fe.kind=N.to(me.kind),Fe.tags=me.tags?.map(C.to),Fe.detail=me.detail,Fe.documentation=R.isMarkdownString(me.documentation)?G.to(me.documentation):me.documentation,Fe.sortText=me.sortText,Fe.filterText=me.filterText,Fe.preselect=me.preselect,Fe.commitCharacters=me.commitCharacters,g.Range.isIRange(me.range)?Fe.range=o.to(me.range):typeof me.range=="object"&&(Fe.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Fe.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Fe.insertText=new u.SnippetString(me.insertText):(Fe.insertText=me.insertText,Fe.textEdit=Fe.range instanceof u.Range?new u.TextEdit(Fe.range,Fe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Fe.additionalTextEdits=me.additionalTextEdits.map(ze=>Se.to(ze))),Fe.command=K&&me.command?K.fromInternal(me.command):void 0,Fe}Ie.to=Oe})(V=e.CompletionItem||(e.CompletionItem={}));var q;(function(Ie){function Oe(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:G.fromStrict(K.documentation)}}Ie.from=Oe;function me(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?G.to(K.documentation):K.documentation}}Ie.to=me})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(Ie){function Oe(K){return{label:K.label,documentation:G.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(q.from):[],activeParameter:K.activeParameter}}Ie.from=Oe;function me(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?G.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(q.to):[],activeParameter:K.activeParameter}}Ie.to=me})(te=e.SignatureInformation||(e.SignatureInformation={}));var ge;(function(Ie){function Oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(te.from):[]}}Ie.from=Oe;function me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(te.to):[]}}Ie.to=me})(ge=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ie){function Oe(me,K){const Fe=new u.InlayHint(b.to(K.position),typeof K.label=="string"?K.label:K.label.map(le.to.bind(void 0,me)),K.kind&&De.to(K.kind));return Fe.textEdits=K.textEdits&&K.textEdits.map(Se.to),Fe.tooltip=R.isMarkdownString(K.tooltip)?G.to(K.tooltip):K.tooltip,Fe.paddingLeft=K.paddingLeft,Fe.paddingRight=K.paddingRight,Fe}Ie.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var le;(function(Ie){function Oe(me,K){const Fe=new u.InlayHintLabelPart(K.label);return Fe.tooltip=R.isMarkdownString(K.tooltip)?G.to(K.tooltip):K.tooltip,l.Command.is(K.command)&&(Fe.command=me.fromInternal(K.command)),K.location&&(Fe.location=Q.to(K.location)),Fe}Ie.to=Oe})(le=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Ie){function Oe(K){return K}Ie.from=Oe;function me(K){return K}Ie.to=me})(De=e.InlayHintKind||(e.InlayHintKind={}));var we;(function(Ie){function Oe(K){return{range:o.from(K.range),url:K.target,tooltip:K.tooltip}}Ie.from=Oe;function me(K){let Fe;if(K.url)try{Fe=typeof K.url=="string"?E.URI.parse(K.url,!0):E.URI.revive(K.url)}catch{}return new u.DocumentLink(o.to(K.range),Fe)}Ie.to=me})(we=e.DocumentLink||(e.DocumentLink={}));var We;(function(Ie){function Oe(K){const Fe=new u.ColorPresentation(K.label);return K.textEdit&&(Fe.textEdit=Se.to(K.textEdit)),K.additionalTextEdits&&(Fe.additionalTextEdits=K.additionalTextEdits.map(ze=>Se.to(ze))),Fe}Ie.to=Oe;function me(K){return{label:K.label,textEdit:K.textEdit?Se.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Fe=>Se.from(Fe)):void 0}}Ie.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(Ie){function Oe(K){return new u.Color(K[0],K[1],K[2],K[3])}Ie.to=Oe;function me(K){return[K.red,K.green,K.blue,K.alpha]}Ie.from=me})($e=e.Color||(e.Color={}));var tt;(function(Ie){function Oe(K){return{range:o.from(K.range)}}Ie.from=Oe;function me(K){return new u.SelectionRange(o.to(K.range))}Ie.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ie){function Oe(me){switch(me){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ie.to=Oe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(Ie){function Oe(K){switch(K){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Oe;function me(K){switch(K){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ie.to=me})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(Ie){function Oe(K){if(K===u.EndOfLine.CRLF)return 1;if(K===u.EndOfLine.LF)return 0}Ie.from=Oe;function me(K){if(K===1)return u.EndOfLine.CRLF;if(K===0)return u.EndOfLine.LF}Ie.to=me})(nt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Ie){function Oe(me){if(typeof me=="object")return me.viewId;switch(me){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Oe})(Me=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Ie){function Oe(K){const Fe={start:K.start+1,end:K.end+1};return K.kind&&(Fe.kind=Y.from(K.kind)),Fe}Ie.from=Oe;function me(K){const Fe={start:K.start-1,end:K.end-1};return K.kind&&(Fe.kind=Y.to(K.kind)),Fe}Ie.to=me})(rt=e.FoldingRange||(e.FoldingRange={}));var Y;(function(Ie){function Oe(K){if(K)switch(K){case u.FoldingRangeKind.Comment:return l.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return l.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return l.FoldingRangeKind.Region}}Ie.from=Oe;function me(K){if(K)switch(K.value){case l.FoldingRangeKind.Comment.value:return u.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports.value:return u.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region.value:return u.FoldingRangeKind.Region}}Ie.to=me})(Y=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(Ie){function Oe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ie.from=Oe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var be;(function(Ie){function Oe(ze){return ze instanceof u.RelativePattern?ze.toJSON():typeof ze=="string"?ze:me(ze)||K(ze)?new u.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ie.from=Oe;function me(ze){const Ze=ze;return Ze?E.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(ze){const Ze=ze;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(ze){return typeof ze=="string"?ze:new u.RelativePattern(E.URI.revive(ze.baseUri),ze.pattern)}Ie.to=Fe})(be=e.GlobPattern||(e.GlobPattern={}));var He;(function(Ie){function Oe(me){if(me){if(Array.isArray(me))return me.map(Oe);if(typeof me=="string")return me;{const K=me;return{language:K.language,scheme:K.scheme,pattern:be.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ie.from=Oe})(He=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Ie){function Oe(me){switch(me){case 2:return u.NotebookDocumentSaveReason.AfterDelay;case 1:return u.NotebookDocumentSaveReason.Manual;case 3:case 4:return u.NotebookDocumentSaveReason.FocusOut}}Ie.to=Oe})(Be=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var Qe;(function(Ie){function Oe(K){return{start:K.start,end:K.end}}Ie.from=Oe;function me(K){return new u.NotebookRange(K.start,K.end)}Ie.to=me})(Qe=e.NotebookRange||(e.NotebookRange={}));var Ye;(function(Ie){function Oe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ie.to=Oe;function me(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ie.from=me})(Ye=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ge;(function(Ie){function Oe(me){if(me===S.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(me===S.NotebookCellExecutionState.Pending)return;if(me===S.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ie.to=Oe})(Ge=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var at;(function(Ie){function Oe(K){switch(K){case u.NotebookCellKind.Markup:return S.CellKind.Markup;case u.NotebookCellKind.Code:default:return S.CellKind.Code}}Ie.from=Oe;function me(K){switch(K){case S.CellKind.Markup:return u.NotebookCellKind.Markup;case S.CellKind.Code:default:return u.NotebookCellKind.Code}}Ie.to=me})(at=e.NotebookCellKind||(e.NotebookCellKind={}));var yt;(function(Ie){function Oe(K){const Fe={metadata:K.metadata??Object.create(null),cells:[]};for(const ze of K.cells)u.NotebookCellData.validate(ze),Fe.cells.push(It.from(ze));return Fe}Ie.from=Oe;function me(K){const Fe=new u.NotebookData(K.cells.map(It.to));return(0,h.isEmptyObject)(K.metadata)||(Fe.metadata=K.metadata),Fe}Ie.to=me})(yt=e.NotebookData||(e.NotebookData={}));var It;(function(Ie){function Oe(K){return{cellKind:at.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ye.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(vt.from):[]}}Ie.from=Oe;function me(K){return new u.NotebookCellData(at.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(vt.to):void 0,K.metadata,K.internalMetadata?Ye.to(K.internalMetadata):void 0)}Ie.to=me})(It=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(Ie){function Oe(K){return{mime:K.mime,valueBytes:P.VSBuffer.wrap(K.data)}}Ie.from=Oe;function me(K){return new u.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Ie.to=me})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var vt;(function(Ie){function Oe(K){return{outputId:K.id,items:K.items.map(St.from),metadata:K.metadata}}Ie.from=Oe;function me(K){const Fe=K.items.map(St.to);return new u.NotebookCellOutput(Fe,K.outputId,K.metadata)}Ie.to=me})(vt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Nt;(function(Ie){function Oe(Fe){return K(Fe)?{include:(0,h.withNullAsUndefined)(be.from(Fe.include)),exclude:(0,h.withNullAsUndefined)(be.from(Fe.exclude))}:(0,h.withNullAsUndefined)(be.from(Fe))}Ie.from=Oe;function me(Fe){return K(Fe)?{include:be.to(Fe.include),exclude:be.to(Fe.exclude)}:be.to(Fe)}Ie.to=me;function K(Fe){const ze=Fe;return ze?!(0,h.isUndefinedOrNull)(ze.include)&&!(0,h.isUndefinedOrNull)(ze.exclude):!1}})(Nt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Rt;(function(Ie){function Oe(me,K,Fe){const ze=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(ze,Fe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ie.from=Oe})(Rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Yt;(function(Ie){function Oe(me,K,Fe){const ze=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:K.toInternal(ze,Fe),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ie.from=Oe})(Yt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Gt;(function(Ie){function Oe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ie.from=Oe})(Gt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(Ie){function Oe(K){return{uri:K.uri,provides:K.provides}}Ie.from=Oe;function me(K){return new u.NotebookRendererScript(E.URI.revive(K.uri),K.provides)}Ie.to=me})(dt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Ie){function Oe(K){return{message:G.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:o.from(K.location.range),uri:K.location.uri}}}Ie.from=Oe;function me(K){const Fe=new u.TestMessage(typeof K.message=="string"?K.message:G.to(K.message));return Fe.actualOutput=K.actual,Fe.expectedOutput=K.expected,Fe.location=K.location?Q.to(K.location):void 0,Fe}Ie.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Ot;(function(Ie){Ie.namespace=p.namespaceTestTag,Ie.denamespace=p.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Mt;(function(Ie){function Oe(K){const Fe=(0,a.getPrivateApiFor)(K).controllerId;return{extId:T.TestId.fromExtHostTestItem(K,Fe).toString(),label:K.label,uri:E.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(ze=>Ot.namespace(Fe,ze.id)),range:g.Range.lift(o.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&G.fromStrict(K.error)||null}}Ie.from=Oe;function me(K){return{parent:void 0,error:void 0,id:T.TestId.fromString(K.extId).localId,label:K.label,uri:E.URI.revive(K.uri),tags:(K.tags||[]).map(Fe=>{const{tagId:ze}=Ot.denamespace(Fe);return new u.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ie.toPlain=me})(Mt=e.TestItem||(e.TestItem={})),function(Ie){function Oe(K){return{id:K.id}}Ie.from=Oe;function me(K){return new u.TestTag(K.id)}Ie.to=me}(Ot=e.TestTag||(e.TestTag={}));var kt;(function(Ie){const Oe=(K,Fe)=>{const ze=[];for(const[Ve,et]of Fe)T.TestId.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),ze.push(et));const Ze={...Mt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(ft.to)})),children:ze.map(Ve=>Oe(Ve,Fe))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function me(K){const Fe=[],ze=new Map;for(const Ze of K.items){ze.set(Ze.item.extId,Ze);const Ve=T.TestId.root(Ze.item.extId);K.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:K.completedAt,results:Fe.map(Ze=>Oe(Ze,ze))}}Ie.to=me})(kt=e.TestResults||(e.TestResults={}));var mt;(function(Ie){function Oe(ze){return{covered:ze.covered,total:ze.covered}}function me(ze){return"line"in ze?b.from(ze):o.from(ze)}function K(ze){return"branches"in ze?{count:ze.executionCount,location:me(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&me(Ze.location)})):void 0}:{type:0,count:ze.executionCount,location:me(ze.location)}}Ie.fromDetailed=K;function Fe(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),function:ze.functionCoverage&&Oe(ze.functionCoverage),details:ze.detailedCoverage?.map(K)}}Ie.fromFile=Fe})(mt=e.TestCoverage||(e.TestCoverage={}));var wt;(function(Ie){function Oe(me){switch(me){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ie.to=Oe})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var zt;(function(Ie){function Oe(K){const Fe=new u.TypeHierarchyItem(ue.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),o.to(K.range),o.to(K.selectionRange));return Fe._sessionId=K._sessionId,Fe._itemId=K._itemId,Fe}Ie.to=Oe;function me(K,Fe,ze){if(Fe=Fe??K._sessionId,ze=ze??K._itemId,Fe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:ze,kind:ue.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:o.from(K.range),selectionRange:o.from(K.selectionRange),tags:K.tags?.map(ce.from)}}Ie.from=me})(zt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ct;(function(Ie){function Oe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Ie.from=Oe})(Ct=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Ie){function Oe(ze,Ze,Ve){const et=Ze.fileData;return et?new class extends u.DataTransferItem{asFile(){return{name:et.name,uri:E.URI.revive(et.uri),data:(0,M.once)(()=>Ve())}}}("",Ze.id):ze===O.Mimes.uriList&&Ze.uriListData?new u.DataTransferItem(Fe(Ze.uriListData)):new u.DataTransferItem(Ze.asString)}Ie.to=Oe;async function me(ze,Ze){const Ve=await Ze.asString();if(ze===O.Mimes.uriList)return{id:Ze.id,asString:Ve,fileData:void 0,uriListData:K(Ve)};const et=Ze.asFile();return{id:Ze.id,asString:Ve,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ie.from=me;function K(ze){return k.UriList.split(ze).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return E.URI.parse(Ze)}catch{}return Ze})}function Fe(ze){return k.UriList.create(ze.map(Ze=>typeof Ze=="string"?Ze:E.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var jt;(function(Ie){function Oe(K,Fe){const ze=K.items.map(([Ze,Ve])=>[Ze,Ke.to(Ze,Ve,()=>Fe(Ve.id))]);return new u.DataTransfer(ze)}Ie.toDataTransfer=Oe;async function me(K){const Fe={items:[]},ze=[];return K.forEach((Ze,Ve)=>{ze.push((async()=>{Fe.items.push([Ve,await Ke.from(Ve,Ze)])})())}),await Promise.all(ze),Fe}Ie.toDataTransferDTO=me})(jt=e.DataTransfer||(e.DataTransfer={}));var Xt;(function(Ie){function Oe(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Ie.to=Oe;function me(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Ie.from=me})(Xt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var Ut;(function(Ie){function Oe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",args:me.args}:Xt.from(me)}Ie.from=Oe})(Ut=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(Ae[202],Re([1,0,2,9,7,8,168]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(m,O,y,h={timeout:1500,errors:3}){this.c=m,this.d=O,this.f=y,this.g=h,this.a=new R.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(O,y,h)=>{const g={dispose:this.a.push([O,y,m])};return Array.isArray(h)&&h.push(g),g}}async $participateInSave(m,O){const y=n.URI.revive(m);let h=!1;const E=setTimeout(()=>h=!0,this.g.timeout),g=[];try{for(const l of[...this.a]){if(h)break;const t=this.d.getDocument(y),a=await this.h(l,{document:t,reason:M.TextDocumentSaveReason.to(O)});g.push(a)}}finally{clearTimeout(E)}return g}h([m,O,y],h){const E=this.b.get(m);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(y,m,O,h).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const l=this.b.get(m);this.b.set(m,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,O,y,h){const E=[],g=Date.now(),{document:l,reason:t}=h,{version:a}=l,d=Object.freeze({document:l,reason:t,waitUntil(S){if(Object.isFrozen(E))throw(0,P.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(S))}});try{O.apply(y,[d])}catch(S){return Promise.reject(S)}return Object.freeze(E),new Promise((S,T)=>{const p=setTimeout(()=>T(new Error("timeout")),this.g.timeout);return Promise.all(E).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(p),S(i)}).catch(i=>{clearTimeout(p),T(i)})}).then(S=>{const T={edits:[]};for(const p of S)if(Array.isArray(p)&&p.every(i=>i instanceof k.TextEdit))for(const{newText:i,newEol:u,range:s}of p)T.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:s&&M.Range.from(s),text:i,eol:u&&M.EndOfLine.from(u)}});if(T.edits.length!==0)return a===l.version?this.f.$tryApplyWorkspaceEdit(T):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ae[203],Re([1,0,15,2,8,7,73]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(y,h,E,g){this.start=y,this.deletedCount=h,this.deletedItems=E,this.items=g}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class I{static asModelAddData(y,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:y}}constructor(y,h,E){this.notebook=y,this.h=h,this.j=E,this.handle=E.handle,this.uri=P.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(k.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return y.g},set mime(g){y.g=g},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(E)}return this.f}setOutputs(y){this.a=y.map(k.NotebookCellOutput.to)}setOutputItems(y,h,E){const g=E.map(k.NotebookCellOutputItem.to),l=this.a.find(t=>t.id===y);if(l&&(h||(l.items.length=0),l.items.push(...g),l.items.length>1&&l.items.every(t=>R.isTextStreamMime(t.mime)))){const t=new Map,a=[];l.items.forEach(d=>{let S;t.has(d.mime)?S=t.get(d.mime):(S=[],t.set(d.mime,S),a.push(d.mime)),S.push(d.data)}),l.items.length=0,a.forEach(d=>{const S=R.compressOutputItemStreams(t.get(d));l.items.push({mime:d,data:S.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=I;class m{constructor(y,h,E,g,l){this.k=y,this.l=h,this.m=E,this.uri=g,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const y=this,h={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===n.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(E){return E=y.n(E),y.b[E].apiCell},getCells(E){return(E?y.p(E):y.b).map(l=>l.apiCell)},save(){return y.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,h,E){this.g=y.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:E});const g={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},l=[];for(const a of y.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,g.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,g.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),l.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),l.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),l.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),l.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),l.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<l.length;a++){const d=l[a],S=t.get(d.cell);if(S===void 0){const T=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});t.set(d.cell,T-1)}else g.cellChanges[S]={...g.cellChanges[S],...d}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let h=y.start|0,E=y.end|0;return h<0&&(h=0),E>this.b.length&&(E=this.b.length),y.with({start:h,end:E})}p(y){y=this.o(y);const h=[];for(let E=y.start;E<y.end;E++)h.push(this.b[E]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,h,E){if(this.j)return;const g=[],l=[],t=[];if(y.reverse().forEach(a=>{const S=a[2].map(i=>{const u=new I(this,this.l,i);return h||l.push(I.asModelAddData(this.apiNotebook,i)),u}),T=new A(a[0],a[1],[],S),p=this.b.splice(a[0],a[1],...S);for(const i of p)t.push(i.uri),T.deletedItems.push(i.apiCell);g.push(T)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:t}),E)for(const a of g)E.push(a.asApiEvent())}s(y,h,E,g){const l=this.b.splice(y,h);this.b.splice(E,0,...l);const t=[new A(y,h,l.map(a=>a.apiCell),[]),new A(E,0,[],l)];for(const a of t)g.push(a.asApiEvent())}t(y,h){this.b[y].setOutputs(h)}u(y,h,E,g){this.b[y].setOutputItems(h,E,g)}v(y,h){const E=this.b[y];E.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(E.uri,h)}w(y,h){const E=this.b[y];E.apiCell.mime=h}x(y,h){this.b[y].setMetadata(h)}y(y,h){this.b[y].setInternalMetadata(h)}getCellFromApiCell(y){return this.b.find(h=>h.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(h=>h.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}m.a=0,e.ExtHostNotebookDocument=m}),define(Ae[204],Re([1,0,4,2,8,7]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(I,m,O,y={timeout:1500,errors:3}){this.b=I,this.c=m,this.d=O,this.f=y,this.a=new n.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(I){return(m,O,y)=>{const h=function(g){m.call(O,g)};return h.extension=I,this.a.event(h,void 0,y)}}async $participateInSave(I,m,O){const y=P.URI.revive(I),h=this.c.getNotebookDocument(y);if(!h)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({document:h.apiNotebook,reason:k.NotebookDocumentSaveReason.to(m)},O,async(l,t)=>{const a=Date.now(),d=await await Promise.resolve(l);if(Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!O.isCancellationRequested&&d&&Array.isArray(d))for(const S of d)S instanceof M.WorkspaceEdit?E.push(S):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data")}),O.isCancellationRequested)return!1;if(E.length===0)return!0;const g={edits:[]};for(const l of E){const{edits:t}=k.WorkspaceEdit.from(l);g.edits=g.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Ae[102],Re([1,0,9,8,7]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,I,m,O,y,h){this.id=A,this.f=I,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=O,this.c=h}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(I){this.selections=[I]},get selections(){return A.a},set selections(I){if(!Array.isArray(I)||!I.every(k.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=I,A.g(I)},get visibleRanges(){return A.b},revealRange(I,m){A.f.$tryRevealRange(A.id,P.NotebookRange.from(I),m??k.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(P.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Ae[205],Re([1,0,9,4,14,8]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(I,m){this.c=I,this.d=m,this.a=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.b=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(I,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,m);const O=this.d.getEditorById(I);m.visibleRanges&&O._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&O._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const m in I)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(I[m]))}};R=qe([je(0,k.ILogService)],R),e.ExtHostNotebookEditors=R}),define(Ae[206],Re([1,0,8,172,148,21,65,9]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,E,g){const l=this.b++,{title:t,location:a,cancellable:d}=E,S={label:(0,k.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(l,{location:n.ProgressLocation.from(a),title:t,source:S,cancellable:d},h.isUnderDevelopment?void 0:h.identifier.value).catch(A.onUnexpectedExternalError),this.d(l,g,!!d)}d(h,E,g){let l;g&&(l=new M.CancellationTokenSource,this.c.set(h,l));const t=d=>{this.a.$progressEnd(d),this.c.delete(d),l?.dispose()};let a;try{a=E(new O(this.a,h),g&&l?l.token:M.CancellationToken.None)}catch(d){throw t(h),d}return a.then(d=>t(h),d=>t(h)),a}$acceptProgressCanceled(h){const E=this.c.get(h);E&&(E.cancel(),this.c.delete(h))}}e.ExtHostProgress=I;function m(y,h){return y.message=h.message,typeof h.increment=="number"&&(typeof y.increment=="number"?y.increment+=h.increment:y.increment=h.increment),y}class O extends P.Progress{constructor(h,E){super(g=>this.throttledReport(g)),this.c=h,this.d=E}throttledReport(h){this.c.$progressReport(this.d,h)}}qe([(0,R.throttle)(100,(y,h)=>m(y,h),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ae[103],Re([1,0,44,98,45,74,56,8,2]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(S,T,p,i)=>{let u=T;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!p(u,s)){const o=u;u=s,S.listener?.(i(s,o))}}}},O=(S,T)=>S===T,y={range:(S,T)=>S===T?!0:!S||!T?!1:S.isEqual(T),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(S,T)=>!(S.length!==T.length||S.some(p=>!T.find(i=>p.id===i.id)))},h=S=>T=>({op:4,update:S(T)}),E=(S,T)=>({range:(()=>{let p;const i=h(u=>({range:n.Range.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return p},set(u){S.listener?.({op:6}),y.range(p,u)||(p=u,S.listener?.(i(u)))}}})(),label:m(S,T,y.label,h(p=>({label:p}))),description:m(S,void 0,y.description,h(p=>({description:p}))),sortText:m(S,void 0,y.sortText,h(p=>({sortText:p}))),canResolveChildren:m(S,!1,y.canResolveChildren,p=>({op:2,state:p})),busy:m(S,!1,y.busy,h(p=>({busy:p}))),error:m(S,void 0,y.error,h(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:m(S,[],y.tags,(p,i)=>({op:1,new:p.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),g=S=>{const T=k.TestId.fromString(S.extId),p=new t(T.controllerId,T.localId,S.label,I.URI.revive(S.uri)||void 0);return p.range=A.Range.to(S.range||void 0),p.description=S.description||void 0,p.sortText=S.sortText||void 0,p.tags=S.tags.map(i=>A.TestTag.to({id:(0,R.denamespaceTestTag)(i).tagId})),p},l=S=>{let T;for(const p of S.tests){const i=g(p.item);(0,P.getPrivateApiFor)(i).parent=T,T=i}return T};e.toItemFromContext=l;class t{constructor(T,p,i,u){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,P.createPrivateApiFor)(this,T);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,M.createTestItemChildren)(s,P.getPrivateApiFor,t),enumerable:!0,writable:!1},...E(s,i)})}}e.TestItemImpl=t;class a extends t{constructor(T,p){super(T,T,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class d extends M.TestItemCollection{constructor(T,p,i){super({controllerId:T,getDocumentVersion:u=>u&&i.getDocument(u)?.version,getApiFor:P.getPrivateApiFor,getChildren:u=>u.children,root:new a(T,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Ae[104],Re([1,0,49,9,84,8,7]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(h,E,g){const l=A.c.nextId();h.$registerTextEditorDecorationType(E.identifier,l,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:l,dispose(){h.$removeTextEditorDecorationType(l)}})}}A.c=new k.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class I{constructor(h,E){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,E){this.k();let g=null;if(h instanceof R.Position)g=new R.Range(h,h);else if(h instanceof R.Range)g=h;else throw new Error("Unrecognized location");this.l(g,E,!1)}insert(h,E){this.k(),this.l(new R.Range(h,h),E,!0)}delete(h){this.k();let E=null;if(h instanceof R.Range)E=h;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(h,E,g){const l=this.c.validateRange(h);this.g.push({range:l,text:E,forceMoveMarkers:g})}setEndOfLine(h){if(this.k(),h!==R.EndOfLine.LF&&h!==R.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this.h=h}}class m{constructor(h,E,g,l){this.c=h,this.d=E,this._accept(g),this.e=l;const t=this;this.value={get tabSize(){return t.f},set tabSize(a){t.m(a)},get indentSize(){return t.g},set indentSize(a){t.o(a)},get insertSpaces(){return t.h},set insertSpaces(a){t.q(a)},get cursorStyle(){return t.j},set cursorStyle(a){t.s(a)},get lineNumbers(){return t.k},set lineNumbers(a){t.t(a)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}m(h){const E=this.l(h);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}o(h){const E=this.n(h);if(E!==null){if(typeof E=="number"){if(this.g===E)return;this.g=E}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}p(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}q(h){const E=this.p(h);if(typeof E=="boolean"){if(this.h===E)return;this.h=E}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const E={};let g=!1;if(typeof h.tabSize<"u"){const l=this.l(h.tabSize);l==="auto"?(g=!0,E.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,g=!0,E.tabSize=l)}if(typeof h.indentSize<"u"){const l=this.n(h.indentSize);l==="tabSize"?(g=!0,E.indentSize=l):typeof l=="number"&&this.g!==l&&(this.g=l,g=!0,E.indentSize=l)}if(typeof h.insertSpaces<"u"){const l=this.p(h.insertSpaces);l==="auto"?(g=!0,E.insertSpaces=l):this.h!==l&&(this.h=l,g=!0,E.insertSpaces=l)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,g=!0,E.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,g=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),g&&this.u("setOptions",this.c.$trySetOptions(this.d,E))}u(h,E){E.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(g)})}}e.ExtHostTextEditorOptions=m;class O{constructor(h,E,g,l,t,a,d,S){this.id=h,this.j=E,this.k=g,this.g=!1,this.h=new Set,this.c=t,this.d=new m(this.j,this.id,a,g),this.e=d,this.f=S;const T=this;this.value=Object.freeze({get document(){return l.value},set document(p){throw(0,P.readonly)("document")},get selection(){return T.c&&T.c[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,P.illegalArgument)("selection");T.c=[p],T.l()},get selections(){return T.c},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof R.Selection)))throw(0,P.illegalArgument)("selections");T.c=p,T.l()},get visibleRanges(){return T.e},set visibleRanges(p){throw(0,P.readonly)("visibleRanges")},get options(){return T.d.value},set options(p){T.g||T.d.assign(p)},get viewColumn(){return T.f},set viewColumn(p){throw(0,P.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new I(l.value,i);return p(u),T.m(u)},insertSnippet(p,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=T.c.map(o=>M.Range.from(o));else if(i instanceof R.Position){const{lineNumber:o,column:f}=M.Position.from(i);s=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(i instanceof R.Range)s=[M.Range.from(i)];else{s=[];for(const o of i)if(o instanceof R.Range)s.push(M.Range.from(o));else{const{lineNumber:f,column:b}=M.Position.from(o);s.push({startLineNumber:f,startColumn:b,endLineNumber:f,endColumn:b})}}return E.$tryInsertSnippet(h,l.value.version,p.value,s,u)},setDecorations(p,i){const u=i.length===0;u&&!T.h.has(p.key)||(u?T.h.delete(p.key):T.h.add(p.key),T.n(()=>{if(M.isDecorationOptionsArr(i))return E.$trySetDecorations(h,p.key,M.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let o=0,f=i.length;o<f;o++){const b=i[o];s[4*o]=b.start.line+1,s[4*o+1]=b.start.character+1,s[4*o+2]=b.end.line+1,s[4*o+3]=b.end.character+1}return E.$trySetDecorationsFast(h,p.key,s)}}))},revealRange(p,i){T.n(()=>E.$tryRevealRange(h,M.Range.from(p),i||R.TextEditorRevealType.Default))},show(p){E.$tryShowEditor(h,M.ViewColumn.from(p))},hide(){E.$tryHideEditor(h)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,n.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,n.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,n.ok)(!this.g),this.f=h}_acceptSelections(h){(0,n.ok)(!this.g),this.c=h}async l(){const h=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const E=h.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const g=E.edits.map(t=>t.range);g.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=g.length-1;t<a;t++){const d=g[t].end;if(g[t+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=E.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,l,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.ExtHostTextEditor=O}),define(Ae[207],Re([1,0,152,7,22,2,4,6,188,17,7,10,16,8,21,26,121]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(T,p){if((0,y.isString)(T))return{label:T};if(T&&typeof T=="object"&&typeof T.label=="string"){let i;return Array.isArray(T.highlights)&&(i=T.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),i=i.length?i:void 0),{label:T.label,highlights:i}}}class d{constructor(p,i,u){this.d=p,this.e=i,this.f=u,this.a=new Map,this.b=new t.TreeViewsDnDService;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:o=>s(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(f=>s(f)?this.i(f):f):o})}registerTreeDataProvider(p,i,u){const s=this.createTreeView(p,{treeDataProvider:i},u);return{dispose:()=>s.dispose()}}createTreeView(p,i,u){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],o=i.dragAndDropController?.dragMimeTypes??[],f=!!i.dragAndDropController?.handleDrag,b=!!i.dragAndDropController?.handleDrop,r=this.h(p,i,u),c=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:f,hasHandleDrop:b});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,l.checkProposedApiEnabled)(u,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(v){r.message=v},get title(){return r.title},set title(v){r.title=v},get description(){return r.description},set description(v){r.description=v},get badge(){return r.badge},set badge(v){v!==void 0&&O.ViewBadge.isViewBadge(v)?r.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(r.badge=void 0)},reveal:(v,D)=>r.reveal(v,D),dispose:async()=>{await c,this.a.delete(p),r.dispose()}}}$getChildren(p,i){const u=this.a.get(p);return u?u.getChildren(i):Promise.reject(new I.NoTreeViewError(p))}async $handleDrop(p,i,u,s,o,f,b,r){const c=this.a.get(p);if(!c)return Promise.reject(new I.NoTreeViewError(p));const v=E.DataTransfer.toDataTransfer(u,async D=>(await this.d.$resolveDropFileData(p,i,D)).buffer);return b===p&&r&&await this.g(v,c,r,o,f),c.onDrop(v,s,o)}async g(p,i,u,s,o){const f=this.b.removeDragOperationTransfer(o);if(f)(await f)?.forEach((b,r)=>{b&&p.set(r,b)});else if(o&&i.handleDrag){const b=i.handleDrag(u,p,s);this.b.addDragOperationTransfer(o,b),await b}return p}async $handleDrag(p,i,u,s){const o=this.a.get(p);if(!o)return Promise.reject(new I.NoTreeViewError(p));const f=await this.g(new P.DataTransfer,o,i,s,u);if(!!f)return E.DataTransfer.toDataTransferDTO(f)}async $hasResolve(p){const i=this.a.get(p);if(!i)throw new I.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,u){const s=this.a.get(p);if(!s)throw new I.NoTreeViewError(p);return s.resolveTreeItem(i,u)}$setExpanded(p,i,u){const s=this.a.get(p);if(!s)throw new I.NoTreeViewError(p);s.setExpanded(i,u)}$setSelection(p,i){const u=this.a.get(p);if(!u)throw new I.NoTreeViewError(p);u.setSelection(i)}$setFocus(p,i){const u=this.a.get(p);if(!u)throw new I.NoTreeViewError(p);u.setFocus(i)}$setVisible(p,i){const u=this.a.get(p);if(!u)throw new I.NoTreeViewError(p);u.setVisible(i)}$changeCheckboxState(p,i){const u=this.a.get(p);if(!u)throw new I.NoTreeViewError(p);u.setCheckboxState(i)}h(p,i,u){const s=new S(p,i,this.d,this.e.converter,this.f,u);return this.a.set(p,s),s}i(p){const i=this.a.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=d;class S extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,y.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,i,u,s,o,f){if(super(),this.C=p,this.D=u,this.F=s,this.G=o,this.H=f,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new R.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new R.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new R.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new R.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new R.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new R.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new g.CancellationTokenSource,f.contributes&&f.contributes.views)for(const c in f.contributes.views)for(const v of f.contributes.views[c])v.id===p&&(this.J=v.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.w.fire({message:!1,element:c})));let b,r;this.B(R.Event.debounce(this.w.event,(c,v)=>(c||(c={message:!1,elements:[]}),v.element!==!1&&(b||(b=new Promise(D=>r=D),this.y=this.y.then(()=>b)),Array.isArray(v.element)?c.elements.push(...v.element):c.elements.push(v.element)),v.message&&(c.message=!0),c),200,!0)(({message:c,elements:v})=>{v.length&&(this.z=this.z.then(()=>{const D=r;return b=null,this.U(v).then(()=>D())})),c&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let u=this.Q(p);return u||(u=await this.R(i)),u?u.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const u=(0,y.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,y.isUndefinedOrNull)(i.focus)?!1:i.focus,o=(0,y.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(f=>this.P(p,f[f.length-1]).then(b=>this.D.$reveal(this.C,{item:b.item,parentChain:f.map(r=>r.item)},{select:u,focus:s,expand:o})),f=>this.G.error(f)):this.D.$reveal(this.C,void 0,{select:u,focus:s,expand:o})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=E.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,i){const u=this.getExtensionElement(p);u&&(i?this.r.fire(Object.freeze({element:u})):this.s.fire(Object.freeze({element:u})))}setSelection(p){(0,h.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async u=>{const s=this.getExtensionElement(u.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:u.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);i.forEach(u=>{u.treeItem.checkboxState=u.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(u=>[u.extensionItem,u.newState])})}async handleDrag(p,i,u){const s=[];for(const o of p){const f=this.getExtensionElement(o);f&&s.push(f)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,u),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,i,u){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,m.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,i){if(!this.f.resolveTreeItem)return;const u=this.i.get(p);if(u){const s=this.j.get(u);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,u,i)??s.extensionItem;return this.db(o),s.item.tooltip=this.ab(o.tooltip),s.item.command=this.bb(s.disposableStore,o.command),s.item}}}N(p){return this.O(p).then(i=>i?this.N(i).then(u=>this.P(i,u[u.length-1]).then(s=>(u.push(s),u))):Promise.resolve([]))}O(p){const i=this.j.get(p);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,m.asPromise)(()=>this.f.getParent(p))}P(p,i){const u=this.j.get(p);return u?Promise.resolve(u):(0,m.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const f=this.j.get(o);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let i;if(typeof p=="string"){const u=this.getExtensionElement(p);i=u?this.j.get(u):void 0}else i=p;return i&&i.children||void 0}return this.h}async R(p){this.nb(p);const i=new g.CancellationTokenSource(this.S.token);try{const u=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(i.token.isCancellationRequested)return;const o=await Promise.all((0,h.coalesce)(s||[]).map(async f=>{const b=await this.f.getTreeItem(f);return b&&!i.token.isCancellationRequested?this.Z(f,b,u):null}));return i.token.isCancellationRequested?void 0:(0,h.coalesce)(o)}finally{i.dispose()}}U(p){if(p.some(u=>!u))return this.S.dispose(!0),this.S=new g.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const u=this.W(p);if(u.length)return this.X(u)}return Promise.resolve(void 0)}W(p){const i=new Set,u=p.map(o=>this.j.get(o));for(const o of u)if(o&&!i.has(o.item.handle)){let f=o;for(;f&&f.parent&&u.findIndex(b=>f&&f.parent&&b&&b.item.handle===f.parent.item.handle)===-1;){const b=this.i.get(f.parent.item.handle);f=b?this.j.get(b):void 0}f&&!f.parent&&i.add(o.item.handle)}const s=[];return i.forEach(o=>{const f=this.i.get(o);if(f){const b=this.j.get(f);b&&(!b.parent||!i.has(b.parent.item.handle))&&s.push(o)}}),s}X(p){const i={};return Promise.all(p.map(u=>this.Y(u).then(s=>{s&&(i[u]=s.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(p){const i=this.getExtensionElement(p);if(i){const u=this.j.get(i);if(u)return this.nb(i),(0,m.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const o=this.eb(i,s,u.parent);return this.lb(i,o,u,u.parent),u.dispose(),o}return null})}return Promise.resolve(null)}Z(p,i,u){const s=this.eb(p,i,u);if(i.id&&this.i.has(s.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(p,s),this.mb(s,u),s}ab(p){return O.MarkdownString.isMarkdownString(p)?E.MarkdownString.from(p):p}bb(p,i){return i?{...this.F.toInternal(i,p),originalId:i.command}:void 0}cb(p){if(!p.checkboxState)return;let i,u;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,u=p.checkboxState.tooltip),{isChecked:i===O.TreeItemCheckboxState.Checked,tooltip:u}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,i,u){this.db(i);const s=new A.DisposableStore,o=this.gb(p,i,u),f=this.hb(i);return{item:{handle:o,parentHandle:u?u.item.handle:void 0,label:a(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:f,iconDark:this.ib(i)||f,themeIcon:this.fb(i),collapsibleState:(0,y.isUndefinedOrNull)(i.collapsibleState)?O.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:u,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:i,label:u,resourceUri:s},o,f){if(i)return`${S.b}/${i}`;const b=a(u,this.H),r=o?o.item.handle:S.a;let c=b?b.label:s?(0,k.basename)(s):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const v=this.j.has(p)?this.j.get(p).item.handle:void 0,D=this.Q(o)||[];let w,H=0;do{if(w=`${r}/${H}:${c}`,f||!this.i.has(w)||v===w)break;H++}while(H<=D.length);return w}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return M.URI.isUri(p)?p:M.URI.file(p)}kb(p,i){this.i.set(i.item.handle,p),this.j.set(p,i)}lb(p,i,u,s){this.i.delete(i.item.handle),this.j.delete(p),i.item.handle!==u.item.handle&&this.i.delete(u.item.handle),this.kb(p,i);const o=this.Q(s)||[],f=o.filter(b=>b.item.handle===u.item.handle)[0];f&&o.splice(o.indexOf(f),1,i)}mb(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const i=this.j.get(p);if(i){if(i.children)for(const u of i.children){const s=this.i.get(u.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(p){const i=this.j.get(p);if(i){if(i.children)for(const u of i.children){const s=this.i.get(u.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}S.a="0",S.b="1"}),define(Ae[208],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookDocumentWillSave:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDocumentWillSave.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[209],Re([1,0,161,9,29,90,71,30,24,208,171,96]),function(ee,e,n,P,k,M,R,A,I,m,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=A.Registry.as(R.Extensions.JSONContribution);class E{constructor(p,i,u){this.a=p,this.b=i,this.c=u}d(p,i){this.a({type:p,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(k.default.Error,p)}warn(p){this.d(k.default.Warning,p)}info(p){this.d(k.default.Info,p)}}e.ExtensionMessageCollector=E;class g{static a(p){const i=new I.ExtensionIdentifierSet;for(let u=0,s=p.length;u<s;u++)i.add(p[u].description.identifier);return i}static compute(p,i){if(!p||!p.length)return new g(i,[]);if(!i||!i.length)return new g([],p);const u=this.a(p),s=this.a(i),o=i.filter(b=>!u.has(b.description.identifier)),f=p.filter(b=>!s.has(b.description.identifier));return new g(o,f)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=g;class l{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=g.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,P.onUnexpectedError)(p)}}}e.ExtensionPoint=l;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:I.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class d{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new l(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,i),p.activationEventsGenerator&&y.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,h.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=d;const S={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(S.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(S.ExtensionsRegistry),h.registerSchema(a,e.schema),h.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Ae[210],Re([1,0,158,10,23,209,31,4]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const I={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var m;(function(h){function E(g,l,t){if(!g)return;const a=P.isString(g.type)?g.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const d=[];if(Array.isArray(g.required))for(const S of g.required)P.isString(S)&&d.push(S);return{extensionId:l.value,taskType:a,required:d,properties:g.properties?k.deepClone(g.properties):{},when:g.when?R.ContextKeyExpr.deserialize(g.when):void 0}}h.from=E})(m||(m={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,E)=>{for(const g of h)g.type&&E.push(`onTaskType:${g.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:I}});class y{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,g)=>{O.setHandler((l,t)=>{this.c=void 0;try{for(const a of t.removed){const d=a.value;for(const S of d)this.a&&S.type&&this.a[S.type]&&delete this.a[S.type]}for(const a of t.added){const d=a.value;for(const S of d){const T=m.from(S,a.description.identifier,a.collector);T&&(this.a[T.taskType]=T)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const g of this.all()){const l={type:"object",additionalProperties:!1};g.required.length>0&&(l.required=g.required.slice(0)),g.properties!==void 0?l.properties=k.deepClone(g.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[g.taskType]},E.push(l)}this.c={oneOf:E}}return this.c}}e.TaskDefinitionRegistry=new y}),define(Ae[211],Re([1,0,159,10,22,23,31,210]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var I;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(I=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function $(W){if(!W)return B.Strong;switch(W.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=$}(I=e.ShellQuoting||(e.ShellQuoting={}));var m;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(m=e.CommandOptions||(e.CommandOptions={}));var O;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(B){function $(W){switch(W.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var y;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(B){function $(W){switch(W.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=$}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(B){function $(W){switch(W.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=$}(h=e.PanelKind||(e.PanelKind={}));var E;(function(B){B.defaults={echo:!0,reveal:O.Always,revealProblems:y.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(B){function $(x){switch(x.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=$;function W(x){switch(x){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=W}(g=e.RuntimeType||(e.RuntimeType={}));var l;(function(B){function $(W){return P.isString(W)?W:W.value}B.value=$})(l=e.CommandString||(e.CommandString={}));var t;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function $(x){return x===B.Clean._id||x===B.Build._id||x===B.Rebuild._id||x===B.Test._id}B.is=$;function W(x){if(x!==void 0)return P.isString(x)?$(x)?{_id:x,isDefault:!1}:void 0:x}B.from=W})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var d;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function $(W){switch(W){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=$})(d=e.TaskSourceKind||(e.TaskSourceKind={}));var S;(function(B){B.parallel="parallel",B.sequence="sequence"})(S=e.DependsOrder||(e.DependsOrder={}));var T;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(T=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:T.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor($,W,x,fe,Se,ie){this._label="",this._id=$,W&&(this._label=W),x&&(this.type=x),this.runOptions=fe,this.configurationProperties=Se,this._source=ie}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,W=!1){if($===void 0)return!1;if(P.isString($))return $===this._label||$===this.configurationProperties.identifier||W&&$===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class u extends i{constructor($,W,x,fe,Se,ie,ue,ce){super($,x,void 0,ue,ce,W),this.command={},this._source=W,this.hasDefinedMatchers=ie,Se&&(this.command=Se)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case g.Shell:W="shell";break;case g.Process:W="process";break;case g.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is($){return $ instanceof u}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let W=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(W+=this._source.kind);const x={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new u($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=u;class s extends i{constructor($,W,x,fe,Se,ie,ue){super($,x,fe,ie,ue,W),this._source=W,this.configures=Se}static is($){return $ instanceof s}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let W=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(W+=this._source.kind);const x={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:W};return JSON.stringify(x)}}e.ConfiguringTask=s;class o extends i{constructor($,W,x,fe,Se,ie,ue,ce,Te){super($,x,fe,ce,Te,W),this.defines=Se,this.hasDefinedMatchers=ue,this.command=ie,this.icon=Te.icon,this.hide=Te.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof o}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new o($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=o;class f extends i{constructor($,W,x,fe,Se,ie){super($,x,fe,Se,ie,W),this._source=W}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new f($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=f;var b;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(b=e.ExecutionEngine||(e.ExecutionEngine={})),function(B){B._default=B.Terminal}(b=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor($){this.c=new Map;for(let W=0;W<$.length;W++)this.c.set($[W].uri.toString(),W)}compare($,W){const x=$.getWorkspaceFolder(),fe=W.getWorkspaceFolder();if(x&&fe){let Se=this.c.get(x.uri.toString());Se=Se===void 0?0:Se+1;let ie=this.c.get(fe.uri.toString());return ie=ie===void 0?0:ie+1,Se===ie?$._label.localeCompare(W._label):Se-ie}else return!x&&fe?-1:x&&!fe?1:0}}e.TaskSorter=c;var v;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var D;(function(B){B.SingleRun="singleRun",B.Background="background"})(D=e.TaskRunType||(e.TaskRunType={}));var w;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(w=e.TaskRunSource||(e.TaskRunSource={}));var H;(function(B){function $(W,x,fe,Se){if(x){const ie={kind:W,taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:fe,__task:x};return W==="start"?ie.resolvedVariables=Se:W==="processStarted"?ie.processId=Se:W==="processEnded"&&(ie.exitCode=Se),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}B.create=$})(H=e.TaskEvent||(e.TaskEvent={}));var X;(function(B){function $(x){const fe=Object.keys(x).sort();let Se="";for(const ie of fe){let ue=x[ie];ue instanceof Object?ue=$(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),Se+=ie+","+ue+","}return Se}function W(x){const Se={_key:$(x),type:x.taskType};return Object.assign(Se,x),Se}B.create=W})(X=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var J;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(J=e.TaskSettingId||(e.TaskSettingId={}));var G;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(G=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(B){function $(W,x){const fe=A.TaskDefinitionRegistry.get(W.type);if(fe===void 0){const ce=M.deepClone(W);return delete ce._key,X.create(ce)}const Se=Object.create(null);Se.type=fe.taskType;const ie=new Set;fe.required.forEach(ce=>ie.add(ce));const ue=fe.properties;for(const ce of Object.keys(ue)){const Te=W[ce];if(Te!=null)Se[ce]=Te;else if(ie.has(ce)){const de=ue[ce];if(de.default!==void 0)Se[ce]=M.deepClone(de.default);else switch(de.type){case"boolean":Se[ce]=!1;break;case"number":case"integer":Se[ce]=0;break;case"string":Se[ce]="";break;default:x.error(n.localize(2,null,JSON.stringify(W,void 0,0),ce));return}}}return X.create(Se)}B.createTaskIdentifier=$})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ae[212],Re([1,0,9]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,A)=>{this.b=R,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,n.onUnexpectedError)(R))}then(R,A){return this.j().then(R,A)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.LazyPromise=P;class k extends P{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=k}),define(Ae[46],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(I){this._proxyIdentifierBrand=void 0,this.sid=I,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const P=[];function k(A){const I=new n(A);return P[I.nid]=I,I}e.createProxyIdentifier=k;function M(A){return P[A].sid}e.getStringIdentifierForProxy=M;class R{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=R}),define(Ae[5],Re([1,0,46]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var M;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var m;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(m=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class y{static mixin(t){return t._id=y.a++,t}}y.a=0,e.IdObject=y;var h;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ae[78],Re([1,0,3,14,5,18]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(I,m){this.c=m,this.a=new Set,this.b=I.getProxy(k.MainContext.MainThreadTelemetry)}report(I,m,O){const y=this.d(I,m);this.a.has(y)||(this.a.add(y),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${I}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:I}))}d(I,m){return`${I}-${m.identifier.value}`}};R=qe([je(0,M.IExtHostRpcService),je(1,P.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(A,I,m){}})}),define(Ae[213],Re([1,0,4,5,7,24]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(m){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new A,this.g=new A,this.a=m.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,O,y,h={}){const E=M.ExtensionIdentifier.toKey(m.identifier),g=[...y].sort().join(" ");return await this.f.getOrCreate(`${E} ${O} ${g}`,async()=>{await this.a.$ensureProvider(O);const l=m.displayName||m.name;return this.a.$getSession(O,y,E,l,h)})}async getSessions(m,O,y){const h=M.ExtensionIdentifier.toKey(m.identifier),E=[...y].sort().join(" ");return await this.g.getOrCreate(`${h} ${E}`,async()=>{await this.a.$ensureProvider(O);const g=m.displayName||m.name;return this.a.$getSessions(O,y,h,g)})}async removeSession(m,O){const y=this.b.get(m);return y?y.provider.removeSession(O):this.a.$removeSession(m,O)}registerAuthenticationProvider(m,O,y,h){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:O,provider:y,options:h??{supportsMultipleAccounts:!1}}),this.c.find(g=>g.id===m)||this.c.push({id:m,label:O});const E=y.onDidChangeSessions(g=>{this.a.$sendDidChangeSessions(m,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this.a.$registerAuthenticationProvider(m,O,h?.supportsMultipleAccounts??!1),new k.Disposable(()=>{E.dispose(),this.b.delete(m);const g=this.c.findIndex(l=>l.id===m);g>-1&&this.c.splice(g),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,O){const y=this.b.get(m);if(y)return Promise.resolve(y.provider.createSession(O));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,O){const y=this.b.get(m);if(y)return Promise.resolve(y.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,O){const y=this.b.get(m);if(y)return Promise.resolve(y.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,O){return this.d.fire({provider:{id:m,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=R;class A{constructor(){this.a=new Map}getOrCreate(m,O){const y=this.a.get(m);if(y)return y;const h=O().finally(()=>this.a.delete(m));return this.a.set(m,h),h}}}),define(Ae[214],Re([1,0,5,18,8]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,I){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>I.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,I,m){const O=k.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,m?.isRefactoring??!1)}};M=qe([je(0,P.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ae[215],Re([1,0,5]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(M){const R=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(A){return R.$writeText(A)}})}}e.ExtHostClipboard=P});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[38],Re([1,0,10,7,8,23,5,16,14,67,44,267,2,6,3,18,103,25,46,40,58,52,57]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i){"use strict";var u,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(w,H,X){u.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),o.set(this,void 0),_e(this,u,w.getProxy(R.MainContext.MainThreadCommands),"f"),this.d=H,_e(this,o,X,"f"),_e(this,s,w.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new b(this,J=>{const G=this.c.get(J);return G?.result===c.Void?G:void 0},H),this.f=[{processArgument(J){return(0,m.revive)(J)}},{processArgument(J){return(0,M.cloneAndChange)(J,function(G){if(O.Range.isIRange(G))return k.Range.to(G);if(y.Position.isIPosition(G))return k.Position.to(G);if(O.Range.isIRange(G.range)&&h.URI.isUri(G.uri))return k.location.to(G);if(G instanceof a.VSBuffer)return G.buffer.buffer;if(!Array.isArray(G))return G})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const H=this.registerCommand(!1,w.id,async(...X)=>{const J=w.args.map((U,B)=>{if(!U.validate(X[B]))throw new Error(`Invalid argument '${U.name}' when running '${w.id}', received: ${X[B]}`);return U.convert(X[B])}),G=await this.executeCommand(w.internalId,...J);return w.result.convert(G,X,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new P.Disposable(()=>{H.dispose(),this.c.delete(w.id)})}registerCommand(w,H,X,J,G,U){if(this.d.trace("ExtHostCommands#registerCommand",H),!H.trim().length)throw new Error("invalid id");if(this.b.has(H))throw new Error(`command '${H}' already exists`);return this.b.set(H,{callback:X,thisArg:J,description:G,extension:U}),w&&Ne(this,u,"f").$registerCommand(H),new P.Disposable(()=>{this.b.delete(H)&&w&&Ne(this,u,"f").$unregisterCommand(H)})}executeCommand(w,...H){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,H,!0)}async g(w,H,X){if(this.b.has(w))return Ne(this,u,"f").$fireCommandActivationEvent(w),this.h(w,H,!1);{let J=!1;const G=(0,M.cloneAndChange)(H,function(U){if(U instanceof P.Position)return k.Position.from(U);if(U instanceof P.Range)return k.Range.from(U);if(U instanceof P.Location)return k.location.from(U);if(P.NotebookRange.isNotebookRange(U))return k.NotebookRange.from(U);if(U instanceof ArrayBuffer)return J=!0,a.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return J=!0,a.VSBuffer.wrap(U);if(U instanceof a.VSBuffer)return J=!0,U;if(!Array.isArray(U))return U});try{const U=await Ne(this,u,"f").$executeCommand(w,J?new d.SerializableObjectWithBuffers(G):G,X);return(0,m.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(w,H,!1);throw U}}}async h(w,H,X){const J=this.b.get(w);if(!J)throw new Error("Unknown command");const{callback:G,thisArg:U,description:B}=J;if(B)for(let W=0;W<B.args.length;W++)try{(0,n.validateConstraint)(H[W],B.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${B.args[W].name}' - ${B.args[W].description}`)}const $=T.StopWatch.create();try{return await G.apply(U,H)}catch(W){if(w===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...H);x&&(w=x.command)}if(this.d.error(W,w,J.extension?.identifier),!X)throw W;if(J.extension?.identifier){const x=Ne(this,o,"f").onExtensionError(J.extension.identifier,W);this.d.trace("forwarded error to extension?",x,J.extension?.identifier)}throw new class extends Error{constructor(){super((0,S.toErrorMessage)(W)),this.id=w,this.source=J.extension?.displayName??J.extension?.name}}}finally{this.j(J,w,$.elapsed())}}j(w,H,X){!w.extension||Ne(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new p.TelemetryTrustedValue(H),duration:X})}$executeContributedCommand(w,...H){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const X=this.b.get(w);return X?(H=H.map(J=>this.f.reduce((G,U)=>U.processArgument(G,X.extension?.identifier),J)),this.h(w,H,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),Ne(this,u,"f").$getCommands().then(H=>(w&&(H=H.filter(X=>X[0]!=="_")),H))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[H,X]of this.b){const{description:J}=X;J&&(w[H]=J)}return Promise.resolve(w)}};u=new WeakMap,s=new WeakMap,o=new WeakMap,f=qe([je(0,l.IExtHostRpcService),je(1,I.ILogService),je(2,i.IExtHostTelemetry)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class b{constructor(w,H,X){this.d=w,this.f=H,this.g=X,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,H){if(!w)return;const X={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return X;const J=this.f(w.command);if(J)X.id=J.internalId,X.arguments=J.args.map((G,U)=>G.convert(w.arguments&&w.arguments[U]));else if((0,A.isNonEmptyArray)(w.arguments)){const G=`${w.command}/${++this.c}`;this.b.set(G,w),H.add((0,E.toDisposable)(()=>{this.b.delete(G),this.g.trace("CommandsConverter#DISPOSE",G)})),X.$ident=G,X.id=this.delegatingCommandId,X.arguments=[G],this.g.trace("CommandsConverter#CREATE",w.command,G)}return X}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const H=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],H?H.command:"MISSING"),H?this.d.executeCommand(H.command,...H.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=b;class r{constructor(w,H,X,J){this.name=w,this.description=H,this.validate=X,this.convert=J}optional(){return new r(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,H){return new r(w??this.name,H??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",D=>h.URI.isUri(D),D=>D),r.Position=new r("position","A position in a text document",D=>P.Position.isPosition(D),k.Position.from),r.Range=new r("range","A range in a text document",D=>P.Range.isRange(D),k.Range.from),r.Selection=new r("selection","A selection in a text document",D=>P.Selection.isSelection(D),k.Selection.from),r.Number=new r("number","",D=>typeof D=="number",D=>D),r.String=new r("string","",D=>typeof D=="string",D=>D),r.CallHierarchyItem=new r("item","A call hierarchy item",D=>D instanceof P.CallHierarchyItem,k.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",D=>D instanceof P.TypeHierarchyItem,k.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",D=>D instanceof t.TestItemImpl,k.TestItem.from),e.ApiCommandArgument=r;class c{constructor(w,H){this.description=w,this.convert=H}}c.Void=new c("no result",D=>D),e.ApiCommandResult=c;class v{constructor(w,H,X,J,G){this.id=w,this.internalId=H,this.description=X,this.args=J,this.result=G}}e.ApiCommand=v}),define(Ae[216],Re([1,0,16,15,2,77,89,31,93,38,8,7]),function(ee,e,n,P,k,M,R,A,I,m,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const h=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(O.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,n.isFalsyOrEmpty)(t))return;class d extends y.SymbolInformation{static to(T){const p=new d(T.name,O.SymbolKind.to(T.kind),T.containerName||"",new y.Location(a[0],O.Range.to(T.range)));return p.detail=T.detail,p.range=p.location.range,p.selectionRange=O.Range.to(T.selectionRange),p.children=T.children?T.children.map(d.to):[],p}}return t.map(d.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new m.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(O.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(O.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>y.Position.isPosition(a)),t=>t.map(O.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let d;for(const S of a.reverse())d=new y.SelectionRange(O.Range.to(S),d);return d}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(O.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(O.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(O.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(O.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:O.Range.to(t.range),placeholder:t.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return O.WorkspaceEdit.to(t)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(O.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new y.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new y.SemanticTokens(a.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,d)=>{if(!t)return new y.CompletionList([]);const S=t.suggestions.map(T=>O.CompletionItem.to(T,d));return new y.CompletionList(S,t.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return O.SignatureHelp.to(t)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,d)=>g(S=>new y.CodeLens(O.Range.to(S.range),S.command&&d.fromInternal(S.command)))(t))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?O.Selection.from(t):O.Range.from(t)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,d)=>g(S=>{if(S._isSynthetic){if(!S.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(S.command)}else{const T=new y.CodeAction(S.title,S.kind?new y.CodeActionKind(S.kind):void 0);return S.edit&&(T.edit=O.WorkspaceEdit.to(S.edit)),S.command&&(T.command=d.fromInternal(S.command)),T.isPreferred=S.isPreferred,T}})(t))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new y.ColorInformation(O.Range.to(a.range),O.Color.to(a.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,O.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:O.Range.from(t.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(O.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,d)=>t.map(O.InlayHint.to.bind(void 0,d)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,a)=>{if(t)return t.map(O.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>O.NotebookExclusiveDocumentPattern.to(a))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(O.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>k.URI.isUri(t)||typeof t=="string"&&(0,I.matchesSomeScheme)(t,P.Schemas.http,P.Schemas.https),t=>t),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],m.ApiCommandResult.Void)];class E{static register(a){h.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=E;function g(t){return a=>{if(Array.isArray(a))return a.map(t)}}function l(t){if(!Array.isArray(t))return;const a=[];for(const d of t)M.isLocationLink(d)?a.push(O.DefinitionLink.to(d)):a.push(O.location.to(d));return a}}),define(Ae[217],Re([1,0,17,65,4,6,2,77,24,8,7,5,26]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(g,l,t){const a=g.getProxy(y.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new I.ExtensionIdentifierMap,l.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const r=this.b.get(b.handle);return r?r.value:b}else if(b&&b.$mid===7){const r=this.b.get(b.commentControlHandle);if(!r)return b;const c=r.getCommentThread(b.commentThreadHandle);return c?c.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const r=this.b.get(b.thread.commentControlHandle);if(!r)return b;const c=r.getCommentThread(b.thread.commentThreadHandle);return c?b.$mid===8?c.value:{thread:c.value,text:b.text}:b}else if(b&&b.$mid===10){const r=this.b.get(b.thread.commentControlHandle);if(!r)return b;const c=r.getCommentThread(b.thread.commentThreadHandle);if(!c)return b;const v=b.commentUniqueId,D=c.getCommentByUniqueId(v);return D||b}else if(b&&b.$mid===11){const r=this.b.get(b.thread.commentControlHandle);if(!r)return b;const c=r.getCommentThread(b.thread.commentThreadHandle);if(!c)return b;const v=b.text,D=b.commentUniqueId,w=c.getCommentByUniqueId(D);return w?(typeof w.body=="string"?w.body=v:w.body=new O.MarkdownString(v),w):b}return b}})}createCommentController(b,r,c){const v=d.a++,D=new T(b,v,r,c);this.b.set(D.handle,D);const w=this.c.get(b.identifier)||[];return w.push(D),this.c.set(b.identifier,w),D.value}$createCommentThreadTemplate(b,r,c){const v=this.b.get(b);!v||v.$createCommentThreadTemplate(r,c)}async $updateCommentThreadTemplate(b,r,c){const v=this.b.get(b);!v||v.$updateCommentThreadTemplate(r,c)}$deleteCommentThread(b,r){this.b.get(b)?.$deleteCommentThread(r)}$provideCommentingRanges(b,r,c){const v=this.b.get(b);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const D=t.getDocument(R.URI.revive(r));return(0,n.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(D,c)).then(w=>w?w.map(H=>m.Range.from(H)):void 0)}$toggleReaction(b,r,c,v,D){const w=this.b.get(b);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const H=w.getCommentThread(r);if(H){const X=H.getCommentByUniqueId(v.uniqueIdInThread);if(w!==void 0&&X&&w.reactionHandler)return w.reactionHandler(X,u(D))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class S{set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,r,c,v,D,w,H,X){this.m=r,this.n=c,this.o=v,this.p=D,this.q=w,this.extensionDescription=H,this.r=X,this.handle=S.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${b}.${this.handle}`),a.$createCommentThread(r,this.handle,this.n,this.o,m.Range.from(this.p),H.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{a.$deleteCommentThread(r,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(G){J.range=G},get comments(){return J.comments},set comments(G){J.comments=G},get collapsibleState(){return J.collapsibleState},set collapsibleState(G){J.collapsibleState=G},get canReply(){return J.canReply},set canReply(G){J.canReply=G},get contextValue(){return J.contextValue},set contextValue(G){J.contextValue=G},get label(){return J.label},set label(G){J.label=G},get state(){return J.state},set state(G){J.state=G},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const b=c=>Object.prototype.hasOwnProperty.call(this.b,c),r={};b("range")&&(r.range=m.Range.from(this.p)),b("label")&&(r.label=this.label),b("contextValue")&&(r.contextValue=this.contextValue??null),b("comments")&&(r.comments=this.q.map(c=>p(this,c,this.k))),b("collapsibleState")&&(r.collapseState=s(this.g)),b("canReply")&&(r.canReply=this.canReply),b("state")&&(r.state=o(this.h)),b("isTemplate")&&(r.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,r)}getCommentByUniqueId(b){for(const r of this.k){const c=r[0],v=r[1];if(b===v)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}S.a=0,qe([(0,P.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class T{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(b,r,c,v){this.f=b,this.g=r,this.h=c,this.i=v,this.a=new Map,a.$registerCommentController(this.handle,c,v);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(w){D.options=w},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(w){D.commentingRangeProvider=w},get reactionHandler(){return D.reactionHandler},set reactionHandler(w){D.reactionHandler=w},createCommentThread(w,H,X){return D.createCommentThread(w,H,X).value},dispose:()=>{D.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(b,r,c){r===void 0&&(0,h.checkProposedApiEnabled)(this.f,"fileComments");const v=new S(this.id,this.handle,void 0,b,r,c,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(b,r){const c=new S(this.id,this.handle,void 0,R.URI.revive(b),m.Range.to(r),[],this.f,!0);return c.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(b,r){const c=this.a.get(b);c&&(c.range=m.Range.to(r))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.e.forEach(b=>b.dispose())}}function p(f,b,r){let c=r.get(b);return c||(c=++f.commentHandle,r.set(b,c)),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:c,body:typeof b.body=="string"?b.body:m.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(v=>i(v)):void 0,timestamp:b.timestamp?.toJSON()}}function i(f){return{label:f.label,iconPath:f.iconPath?m.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function u(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?R.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function s(f){if(f!==void 0)switch(f){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function o(f){if(f!==void 0)switch(f){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new d}e.createExtHostComments=E}),define(Ae[218],Re([1,0,23,5,27,18]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(O,y){this.a=O.getProxy(P.MainContext.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,y){const h=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){h.e(O,y,E,arguments)}})}e(O,y,h,E){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:I(E,this.b)}),this.c&&this.f(O,h,E)}};R=qe([je(0,M.IExtHostRpcService),je(1,k.IExtHostInitDataService)],R),e.AbstractExtHostConsoleForwarder=R;const A=1e5;function I(m,O){const y=[];if(m.length)for(let h=0;h<m.length;h++){let E=m[h];if(typeof E>"u")E="undefined";else if(E instanceof Error){const g=E;g.stack?E=g.stack:E=g.toString()}y.push(E)}if(O){const h=new Error().stack;h&&y.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,n.safeStringify)(y);return h.length>A?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Ae[105],Re([1,0,2,5,7,3,18,14,16,13,19,26]),function(ee,e,n,P,k,M,R,A,I,m,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class zi{constructor(g,l){this.h=l,this.f=new Map,this.g=g.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,l){const t=zi.c++;this.f.set(t,{provider:g,extensionDescription:l}),this.g.$registerDecorationProvider(t,l.identifier.value);const a=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(t,null);return}const S=(0,I.asArray)(d);if(S.length<=zi.d){this.g.$onDidChange(t,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,S.length);const T=S.map(u=>({uri:u,rank:(0,m.count)(u.path,"/")})),p=(0,I.groupBy)(T,(u,s)=>u.rank-s.rank||(0,m.compare)(u.uri.path,s.uri.path)),i=[];e:for(const u of p){let s;for(const o of u){const f=(0,O.dirname)(o.uri.path);if(s!==f&&(s=f,i.push(o.uri)>=zi.d))break e}}this.g.$onDidChange(t,i)});return new k.Disposable(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(g,l,t){if(!this.f.has(g))return Object.create(null);const a=Object.create(null),{provider:d,extensionDescription:S}=this.f.get(g);return await Promise.all(l.map(async T=>{try{const{uri:p,id:i}=T,u=await Promise.resolve(d.provideFileDecoration(n.URI.revive(p),t));if(!u)return;try{k.FileDecoration.validate(u),u.badge&&typeof u.badge!="string"&&(0,y.checkProposedApiEnabled)(S,"codiconDecoration"),a[i]=[u.propagate,u.tooltip,u.badge,u.color]}catch(s){this.h.warn(`INVALID decoration from extension '${S}': ${s}`)}}catch(p){this.h.error(p)}})),a}};h.c=0,h.d=250,h=qe([je(0,R.IExtHostRpcService),je(1,A.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[219],Re([1,0,144,92,2,5,7,8,4,14,28,37]),function(ee,e,n,P,k,M,R,A,I,m,O,y){"use strict";var h,E,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(d,S,T,p,i,u,s){this.d=d,this.e=S,this.f=T,this.g=p,h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),this.c=!1,_e(this,g,new O.ResourceMap(o=>i.getComparisonKey(o)),"f"),_e(this,h,u,"f"),_e(this,E,s,"f")}dispose(){this.c||(Ne(this,E,"f").fire([...Ne(this,g,"f").keys()]),Ne(this,h,"f")?.$clear(this.e),Ne(this,g,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(d,S){if(!d){this.clear();return}this.h();let T=[];if(k.URI.isUri(d)){if(!S){this.delete(d);return}Ne(this,g,"f").set(d,S.slice()),T=[d]}else if(Array.isArray(d)){T=[];let i;d=[...d].sort(l.j);for(const u of d){const[s,o]=u;if((!i||s.toString()!==i.toString())&&(i&&Ne(this,g,"f").get(i).length===0&&Ne(this,g,"f").delete(i),i=s,T.push(s),Ne(this,g,"f").set(s,[])),o)Ne(this,g,"f").get(s)?.push(...o);else{const f=Ne(this,g,"f").get(s);f&&(f.length=0)}}}if(Ne(this,E,"f").fire(T),!Ne(this,h,"f"))return;const p=[];for(const i of T){let u=[];const s=Ne(this,g,"f").get(i);if(s)if(s.length>this.f){u=[];const o=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const b of s)if(b.severity===o[f]&&u.push({...A.Diagnostic.from(b),modelVersionId:this.g(i)})===this.f)break e;u.push({severity:P.MarkerSeverity.Info,message:(0,n.localize)(0,null,s.length-this.f),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=s.map(o=>({...A.Diagnostic.from(o),modelVersionId:this.g(i)}));p.push([i,u])}Ne(this,h,"f").$changeMany(this.e,p)}delete(d){this.h(),Ne(this,E,"f").fire([d]),Ne(this,g,"f").delete(d),Ne(this,h,"f")?.$changeMany(this.e,[[d,void 0]])}clear(){this.h(),Ne(this,E,"f").fire([...Ne(this,g,"f").keys()]),Ne(this,g,"f").clear(),Ne(this,h,"f")?.$clear(this.e)}forEach(d,S){this.h();for(const[T,p]of this)d.call(S,T,p,this)}*[(h=new WeakMap,E=new WeakMap,g=new WeakMap,Symbol.iterator)](){this.h();for(const d of Ne(this,g,"f").keys())yield[d,this.get(d)]}get(d){this.h();const S=Ne(this,g,"f").get(d);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(d){return this.h(),Array.isArray(Ne(this,g,"f").get(d))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(d,S){return d[0].toString()<S[0].toString()?-1:d[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=l;let t=class bi{static _mapper(d){const S=new O.ResourceMap;for(const T of d)S.set(T,T);return{uris:Object.freeze(Array.from(S.values()))}}constructor(d,S,T,p){this.h=S,this.j=T,this.k=p,this.f=new Map,this.g=new I.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=I.Event.map(this.g.event,bi._mapper),this.e=d.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,S){const{f:T,e:p,g:i,h:u,j:s,k:o}=this,f=new class{$changeMany(c,v){p.$changeMany(c,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,c,v.length===0?"CLEARING":v)}$clear(c){p.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,c)}dispose(){p.dispose()}};let b;if(!S)S="_generated_diagnostic_collection_name_#"+bi.c++,b=S;else if(!T.has(S))b=S;else{this.h.warn(`DiagnosticCollection with name '${S}' does already exist.`);do b=S+bi.c++;while(T.has(b))}return new class extends l{constructor(){super(S,b,bi.d,c=>o.getDocument(c)?.version,s.extUri,f,i),T.set(b,this)}dispose(){super.dispose(),T.delete(b)}}}getDiagnostics(d){if(d)return this.l(d);{const S=new Map,T=[];for(const p of this.f.values())p.forEach((i,u)=>{let s=S.get(i.toString());typeof s>"u"&&(s=T.length,S.set(i.toString(),s),T.push([i,[]])),T[s][1]=T[s][1].concat(...u)});return T}}l(d){let S=[];for(const T of this.f.values())T.has(d)&&(S=S.concat(T.get(d)));return S}$acceptMarkersChange(d){if(!this.m){const S="_generated_mirror",T=new l(S,S,bi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(S,T),this.m=T}for(const[S,T]of d)this.m.set(k.URI.revive(S),T.map(A.Diagnostic.to))}};t.c=0,t.d=1e3,t=qe([je(1,m.ILogService),je(2,y.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Ae[220],Re([1,0,2,5,26]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(A){this.a=A.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(A,I){return I?.allowUIResources&&(0,k.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(I).then(m=>m?m.map(O=>n.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(I=>I?n.URI.revive(I):void 0)}}e.ExtHostDialogs=M}),define(Ae[221],Re([1,0,9,2,7,5,15,21,13]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class m{constructor(y,h,E){this.d=h,this.e=E,this.b=new Map,this.c=y.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,h){if(Object.keys(R.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=m.a++;this.b.set(E,h),this.c.$registerTextContentProvider(E,y);let g;return typeof h.onDidChange=="function"&&(g=h.onDidChange(l=>{if(l.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this.d.getDocument(l)&&this.$provideTextDocumentContent(E,l).then(t=>{if(!t&&typeof t!="string")return;const a=this.d.getDocument(l);if(!a)return;const d=(0,I.splitLines)(t);if(!a.equalLines(d))return this.c.$onVirtualDocumentChange(l,t)},n.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(y,h){const E=this.b.get(y);return E?Promise.resolve(E.provideTextDocumentContent(P.URI.revive(h),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}m.a=0,e.ExtHostDocumentContentProvider=m}),define(Ae[222],Re([1,0,4,6,2,5,101,8,10,23,7]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(E,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.DisposableStore,this.h=new Map,this.f=E.getProxy(M.MainContext.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(l=>{for(const t of l)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const t of l)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const g=this.g.getDocument(E);if(g)return g}getDocument(E){const g=this.getDocumentData(E);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return g.document}ensureDocumentData(E){const g=this.g.getDocument(E);if(g)return Promise.resolve(g);let l=this.h.get(E.toString());return l||(l=this.f.$tryOpenDocument(E).then(t=>{this.h.delete(E.toString());const a=k.URI.revive(t);return(0,I.assertIsDefined)(this.g.getDocument(a))},t=>(this.h.delete(E.toString()),Promise.reject(t))),this.h.set(E.toString(),l)),l}createDocumentData(E){return this.f.$tryCreateDocument(E).then(g=>k.URI.revive(g))}$acceptModelLanguageChanged(E,g){const l=k.URI.revive(E),t=this.g.getDocument(l);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(g),this.a.fire(t.document)}$acceptModelSaved(E){const g=k.URI.revive(E),l=this.g.getDocument(g);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(E,g){const l=k.URI.revive(E),t=this.g.getDocument(l);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,g,l){const t=k.URI.revive(E),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(l),a.onEvents(g);let d;g.isUndoing?d=O.TextDocumentChangeReason.Undo:g.isRedoing&&(d=O.TextDocumentChangeReason.Redo),this.c.fire((0,m.deepFreeze)({document:a.document,contentChanges:g.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:d}))}setWordDefinitionFor(E,g){(0,R.setWordDefinitionFor)(E,g)}}e.ExtHostDocuments=y}),define(Ae[59],Re([1,0,49,4,6,2,3,5,101,18,104,8,14,28,15,192,86]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(T){this.value=T,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let d=class{constructor(T,p){this.h=T,this.i=p,this.a=null,this.b=new Map,this.c=new E.ResourceMap,this.d=new P.Emitter,this.e=new P.Emitter,this.f=new P.Emitter,this.g=new P.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(T){this.acceptDocumentsAndEditorsDelta(T)}acceptDocumentsAndEditorsDelta(T){const p=[],i=[],u=[];if(T.removedDocuments)for(const s of T.removedDocuments){const o=M.URI.revive(s),f=this.c.get(o);f?.unref()&&(this.c.delete(o),p.push(f.value))}if(T.addedDocuments)for(const s of T.addedDocuments){const o=M.URI.revive(s.uri);let f=this.c.get(o);if(f&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new a(new I.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,f),i.push(f.value)),f.ref()}if(T.removedEditors)for(const s of T.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&u.push(o)}if(T.addedEditors)for(const s of T.addedEditors){const o=M.URI.revive(s.documentUri);n.ok(this.c.has(o),`document '${o}' does not exist`),n.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const f=this.c.get(o).value,b=new O.ExtHostTextEditor(s.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>f.document),s.selections.map(y.Selection.to),s.options,s.visibleRanges.map(r=>y.Range.to(r)),typeof s.editorPosition=="number"?y.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,b)}T.newActiveEditor!==void 0&&(n.ok(T.newActiveEditor===null||this.b.has(T.newActiveEditor),`active editor '${T.newActiveEditor}' does not exist`),this.a=T.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(u),T.removedDocuments&&this.e.fire(p),T.addedDocuments&&this.d.fire(i),(T.removedEditors||T.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),T.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(T){return this.c.get(T)?.value}allDocuments(){return l.Iterable.map(this.c.values(),T=>T.value)}getEditor(T){return this.b.get(T)}activeEditor(T){if(!this.a)return;const p=this.b.get(this.a);return T?p:p?.value}allEditors(){return[...this.b.values()]}};d=qe([je(0,m.IExtHostRpcService),je(1,h.ILogService)],d),e.ExtHostDocumentsAndEditors=d,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,5,2,4,3,7,18,10,64]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class y{constructor(t,a,d){this.e=d,this.d=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(t,a){this.c=[],this.d="",this.b=t,this.e=a;for(const d of t.tabs)d.isActive&&(this.d=d.id),this.c.push(new y(d,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(d=>d.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(d=>d.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const d=new y(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,d),t.tabDto.isActive&&(this.d=d.tabId),d}else if(t.kind===1){const d=this.c.splice(t.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return d.tabId===this.d&&(this.d=""),d}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this.c.splice(t.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,d),d}const a=this.c.find(d=>d.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(t){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=t.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,a={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(d=>d.apiObject))},get activeTabGroup(){const d=t.d;return(0,m.assertIsDefined)(t.e.find(T=>T.groupId===d)?.apiObject)},close:async(d,S)=>{const T=Array.isArray(d)?d:[d];return T.length?g(T[0])?this.j(T,S):this.i(T,S):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(t){const a=new Set(this.e.map(s=>s.groupId)),d=new Set(t.map(s=>s.groupId)),S=(0,O.diffSets)(a,d),T=this.e.filter(s=>S.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],i=[];this.e=t.map(s=>{const o=new h(s,()=>this.d);return S.added.includes(o.groupId)?p.push(o.apiObject):i.push(o.apiObject),o});const u=(0,m.assertIsDefined)(t.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:p,closed:T,changed:i}))}$acceptTabGroupUpdate(t){const a=this.e.find(d=>d.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this.e.find(S=>S.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const d=a.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}g(t){for(const a of this.e)for(const d of a.tabs)if(d.apiObject===t)return d}h(t){return this.e.find(a=>a.apiObject===t)}async i(t,a){const d=[];for(const S of t){const T=this.g(S);if(!T)throw new Error("Tab close: Invalid tab not found!");d.push(T.tabId)}return this.a.$closeTab(d,a)}async j(t,a){const d=[];for(const S of t){const T=this.h(S);if(!T)throw new Error("Group close: Invalid group not found!");d.push(T.groupId)}return this.a.$closeGroup(d,a)}};E=qe([je(0,I.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function g(l){return l.tabs!==void 0}}),define(Ae[223],Re([1,0,2,5,6,7,8,268,13,25,26]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const l=this.a.indexOf(g);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),l=[];let t,a,d=14,S=14;for(const T of g){let p=t?(0,I.commonPrefixLength)(t,T):0;for(p===0?a=1:a=S;p<T.length;p++)p+1===T.length?(d=S,S=9):S+=1,l.push([a,T.toUpperCase().charCodeAt(p),S]),l.push([a,T.toLowerCase().charCodeAt(p),S]),a=S;t=T,S=d}l.push([9,58,10]),l.push([10,47,12]),this.b=new A.StateMachine(l)}}provideDocumentLinks(g){this.c();const l=[],t=A.LinkComputer.computeLinks({getLineContent(a){return g.lineAt(a-1).text},getLineCount(){return g.lineCount}},this.b);for(const a of t){const d=R.DocumentLink.to(a);d.target&&l.push(d)}return l}}class h{constructor(g,l){this.i=l,this.b=new y,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,l,t,a={}){if(h.j(t),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const d=this.h++;this.b.add(l),this.d.add(l),this.c.set(d,t);let S=2;a.isCaseSensitive&&(S+=1024),a.isReadonly&&(S+=2048),typeof t.copy=="function"&&(S+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,O.checkProposedApiEnabled)(g,"fsChunks"),S+=4),this.a.$registerFileSystemProvider(d,l,S).catch(p=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${l}`),console.error(p)});const T=t.onDidChangeFile(p=>{const i=[];for(const u of p){const{uri:s,type:o}=u;if(s.scheme!==l)continue;let f;switch(o){case M.FileChangeType.Changed:f=0;break;case M.FileChangeType.Created:f=1;break;case M.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:f})}this.a.$onFileSystemChange(d,i)});return(0,k.toDisposable)(()=>{T.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:l,ctime:t,mtime:a,size:d,permissions:S}=g;return{type:l,ctime:t,mtime:a,size:d,permissions:S}}$stat(g,l){return Promise.resolve(this.l(g).stat(n.URI.revive(l))).then(t=>h.k(t))}$readdir(g,l){return Promise.resolve(this.l(g).readDirectory(n.URI.revive(l)))}$readFile(g,l){return Promise.resolve(this.l(g).readFile(n.URI.revive(l))).then(t=>m.VSBuffer.wrap(t))}$writeFile(g,l,t,a){return Promise.resolve(this.l(g).writeFile(n.URI.revive(l),t.buffer,a))}$delete(g,l,t){return Promise.resolve(this.l(g).delete(n.URI.revive(l),t))}$rename(g,l,t,a){return Promise.resolve(this.l(g).rename(n.URI.revive(l),n.URI.revive(t),a))}$copy(g,l,t,a){const d=this.l(g);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(n.URI.revive(l),n.URI.revive(t),a))}$mkdir(g,l){return Promise.resolve(this.l(g).createDirectory(n.URI.revive(l)))}$watch(g,l,t,a){const d=this.l(g).watch(n.URI.revive(t),a);this.f.set(l,d)}$unwatch(g,l){const t=this.f.get(l);t&&(t.dispose(),this.f.delete(l))}$open(g,l,t){const a=this.l(g);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(l),t))}$close(g,l){const t=this.l(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(l))}$read(g,l,t,a){const d=this.l(g);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const S=m.VSBuffer.alloc(a);return Promise.resolve(d.read(l,t,S.buffer,0,a)).then(T=>S.slice(0,T))}$write(g,l,t,a){const d=this.l(g);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(l,t,a.buffer,0,a.byteLength))}l(g){const l=this.c.get(g);if(!l){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return l}}e.ExtHostFileSystem=h}),define(Ae[61],Re([1,0,5,43,7,25,3,18,37,6]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class ti{constructor(h,E){this.b=new Map,this.a=h.getProxy(n.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(l){try{const t=g.b.get(l.scheme);if(!t)return await g.a.$stat(l);await g.a.$ensureActivation(l.scheme);const a=await t.stat(l);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){ti.c(t)}},async readDirectory(l){try{const t=g.b.get(l.scheme);return t?(await g.a.$ensureActivation(l.scheme),(await t.readDirectory(l)).slice()):await g.a.$readdir(l)}catch(t){return ti.c(t)}},async createDirectory(l){try{return await g.a.$mkdir(l)}catch(t){return ti.c(t)}},async readFile(l){try{const t=g.b.get(l.scheme);return t?(await g.a.$ensureActivation(l.scheme),(await t.readFile(l)).slice()):(await g.a.$readFile(l)).buffer}catch(t){return ti.c(t)}},async writeFile(l,t){try{return await g.a.$writeFile(l,M.VSBuffer.wrap(t))}catch(a){return ti.c(a)}},async delete(l,t){try{const a=g.b.get(l.scheme);return a?(await g.a.$ensureActivation(l.scheme),await a.delete(l,{recursive:!1,...t})):await g.a.$delete(l,{recursive:!1,useTrash:!1,...t})}catch(a){return ti.c(a)}},async rename(l,t,a){try{return await g.a.$rename(l,t,{overwrite:!1,...a})}catch(d){return ti.c(d)}},async copy(l,t,a){try{return await g.a.$copy(l,t,{overwrite:!1,...a})}catch(d){return ti.c(d)}},isWritableFileSystem(l){const t=E.getCapabilities(l);if(typeof t=="number")return!(t&2048)}})}static c(h){if(h instanceof k.FileSystemError)throw h;if(!(h instanceof Error))throw new k.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw k.FileSystemError.Unavailable(h.message);switch(h.name){case P.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(h.message);case P.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(h.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(h.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(h.message);case P.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(h.message);case P.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(h.message);default:throw new k.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,E){return this.b.set(h,E),(0,m.toDisposable)(()=>this.b.delete(h))}};O=qe([je(0,A.IExtHostRpcService),je(1,I.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[224],Re([1,0,4,36,2,5,8,7]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(y,h,E,g,l,t,a,d){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const S=this.h(y,E,l);this.g=0,t&&(this.g+=1),a&&(this.g+=2),d&&(this.g+=4);const T=(0,P.parse)(l),p=typeof l=="string",i=g(u=>{if(!t)for(const s of u.created){const o=k.URI.revive(s);T(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this.a.fire(o)}if(!a)for(const s of u.changed){const o=k.URI.revive(s);T(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this.b.fire(o)}if(!d)for(const s of u.deleted){const o=k.URI.revive(s);T(o.fsPath)&&(!p||h.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=A.Disposable.from(S,this.a,this.b,this.c,i)}h(y,h,E){const g=A.Disposable.from();if(typeof E=="string")return g;const l=y.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(E.pattern.includes(P.GLOBSTAR)||E.pattern.includes(P.GLOB_SPLIT))&&(t=!0);const a=Math.random();return l.$watch(h.identifier.value,a,E.baseUri,{recursive:t,excludes:[]}),A.Disposable.from({dispose:()=>l.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class m{constructor(y,h,E){this.j=y,this.k=h,this.l=E,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,h,E,g,l,t){return new I(this.j,y,h,this.a.event,R.GlobPattern.from(E),g,l,t)}$onFileEvent(y){this.a.fire(y)}$onDidRunFileOperation(y,h){switch(y){case 2:this.b.fire(Object.freeze({files:h.map(E=>({oldUri:k.URI.revive(E.source),newUri:k.URI.revive(E.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(E=>k.URI.revive(E.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(E=>k.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,h){return(E,g,l)=>{const t=function(d){E.call(g,d)};return t.extension=y,h.event(t,void 0,l)}}async $onWillRunFileOperation(y,h,E,g){switch(y){case 2:return await this.n(this.g,{files:h.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},E,g);case 1:return await this.n(this.i,{files:h.map(l=>k.URI.revive(l.target))},E,g);case 0:case 3:return await this.n(this.h,{files:h.map(l=>k.URI.revive(l.target))},E,g)}}async n(y,h,E,g){const l=new Set,t=[];if(await y.fireAsync(h,g,async(d,S)=>{const T=Date.now(),p=await Promise.resolve(d);p instanceof A.WorkspaceEdit&&(t.push([S.extension,p]),l.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-T>E&&this.k.warn("SLOW file-participant",S.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,d]of t){const{edits:S}=R.WorkspaceEdit.from(d,{getTextDocumentVersion:T=>this.l.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(S)}return{edit:a,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=m}),define(Ae[225],Re([1,0,2,38]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(R,A,I,m,O){this.a=A,this.b=I,this.c=m;const y=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new P.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new P.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new P.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new P.ApiCommandResult("Notebook and input URI",h=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const E=this.a.getEditorById(h.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(R,A,I,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:I,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=k}),define(Ae[226],Re([1,0,6,2,5,8,7]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class A{constructor(y,h){this.extension=y,this.provider=h,this.handle=A.a++}}A.a=0;class I{constructor(y){this.session=y,this.responses=[]}}class m{constructor(y,h,E){this.e=h,this.f=E,this.b=new Map,this.c=new Map,this.d=y.getProxy(k.MainContext.MainThreadInteractiveEditor)}registerProvider(y,h){const E=new A(y,h);return this.b.set(E.handle,E),this.d.$registerInteractiveEditorProvider(E.handle,y.identifier.value,typeof h.handleInteractiveEditorResponseFeedback=="function"),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(E.handle),this.b.delete(E.handle)})}async $prepareInteractiveSession(y,h,E,g){const l=this.b.get(y);if(!l){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.e.getDocument(P.URI.revive(h)),a=M.Selection.to(E),d=await l.provider.prepareInteractiveEditorSession({document:t,selection:a},g);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=m.a++;return this.c.set(S,new I(d)),{id:S,placeholder:d.placeholder,slashCommands:d.slashCommands,wholeRange:M.Range.from(d.wholeRange)}}async $provideResponse(y,h,E,g){const l=this.b.get(y);if(!l)return;const t=this.c.get(h.id);if(!t)return;const a=await l.provider.provideInteractiveEditorResponse({session:t.session,prompt:E.prompt,selection:M.Selection.to(E.selection),wholeRange:M.Range.to(E.wholeRange)},g);if(a){const d=t.responses.push(a)-1,S={wholeRange:M.Range.from(a.wholeRange),placeholder:a.placeholder};if(m.g(a))return{...S,id:d,type:"message",message:M.MarkdownString.from(a.contents)};const{edits:T}=a;if(T instanceof R.WorkspaceEdit)return{...S,id:d,type:"bulkEdit",edits:M.WorkspaceEdit.from(T)};if(Array.isArray(T))return{...S,id:d,type:"editorEdit",edits:T.map(M.TextEdit.from)}}}$handleFeedback(y,h,E,g){const l=this.b.get(y),t=this.c.get(h),a=t?.responses[E];if(l&&a){let d;switch(g){case 1:d=R.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:d=R.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:d=R.InteractiveEditorResponseFeedbackKind.Undone;break}l.provider.handleInteractiveEditorResponseFeedback?.(t.session,a,d)}}$releaseSession(y,h){const E=this.c.get(h),g=this.b.get(y);E&&g&&g.provider.releaseInteractiveEditorSession?.(E.session),this.c.delete(h)}static g(y){return typeof y=="object"&&typeof y.contents=="object"}}m.a=0,e.ExtHostInteractiveEditor=m}),define(Ae[227],Re([1,0,4,6,58,10,146,5,8]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class m{constructor(h,E){this.extension=h,this.provider=E,this.handle=m.a++}}m.a=0;class O{constructor(h,E){this.h=E,this.b=new Map,this.d=new Map,this.e=new n.Emitter,this.onDidPerformUserAction=this.e.event,this.g=h.getProxy(A.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(h,E,g){const l=new m(h,g);return this.b.set(l.handle,l),this.g.$registerInteractiveSessionProvider(l.handle,E,!!g.provideResponseWithProgress),(0,P.toDisposable)(()=>{this.g.$unregisterInteractiveSessionProvider(l.handle),this.b.delete(l.handle)})}addInteractiveSessionRequest(h){this.g.$addInteractiveSessionRequest(h)}sendInteractiveRequestToProvider(h,E){this.g.$sendInteractiveRequestToProvider(h,E)}async $prepareInteractiveSession(h,E,g){const l=this.b.get(h);if(!l)return;const t=await l.provider.prepareSession(E,g);if(!t)return;const a=O.a++;return this.d.set(a,t),{id:a,requesterUsername:t.requester?.name,requesterAvatarIconUri:t.requester?.icon,responderUsername:t.responder?.name,responderAvatarIconUri:t.responder?.icon,inputPlaceholder:t.inputPlaceholder}}async $resolveInteractiveRequest(h,E,g,l){const t=this.b.get(h);if(!t)return;const a=this.d.get(E);if(!a||!t.provider.resolveRequest)return;const d=await t.provider.resolveRequest(a,g,l);if(d)return{message:typeof d.message=="string"?d.message:I.InteractiveSessionReplyFollowup.from(d.message)}}async $provideInitialSuggestions(h,E){const g=this.b.get(h);if(!!g&&!!g.provider.provideInitialSuggestions)return(0,M.withNullAsUndefined)(await g.provider.provideInitialSuggestions(E))}async $provideWelcomeMessage(h,E){const g=this.b.get(h);if(!g||!g.provider.provideWelcomeMessage)return;const l=await g.provider.provideWelcomeMessage(E);if(!!l)return l.map(t=>typeof t=="string"?t:t.map(a=>I.InteractiveSessionReplyFollowup.from(a)))}async $provideFollowups(h,E,g){const l=this.b.get(h);if(!l)return;const t=this.d.get(E);return!t||!l.provider.provideFollowups?void 0:(await l.provider.provideFollowups(t,g))?.map(d=>I.InteractiveSessionFollowup.from(d))}async $provideInteractiveReply(h,E,g,l){const t=this.b.get(h);if(!t)return;const a=this.d.get(E);if(!a)return;const d={session:a,message:typeof g.message=="string"?g.message:I.InteractiveSessionReplyFollowup.to(g.message)},S=k.StopWatch.create(!1);let T;const p={report:s=>{l.isCancellationRequested||(typeof T>"u"&&(T=S.elapsed()),this.g.$acceptInteractiveResponseProgress(h,E,s))}};let i;try{i=await t.provider.provideResponseWithProgress(d,p,l),i||(i={errorDetails:{message:(0,R.localize)(0,null)}})}catch(s){i={errorDetails:{message:(0,R.localize)(1,null,s.message),responseIsIncomplete:!0}},this.h.error(s)}try{if(a.saveState&&this.d.has(E)){const s=a.saveState();this.g.$acceptInteractiveSessionState(E,s)}}catch(s){this.h.warn(s)}const u={firstProgress:T??0,totalElapsed:S.elapsed()};return{errorDetails:i.errorDetails,timings:u}}async $provideSlashCommands(h,E,g){const l=this.b.get(h);if(!l)return;const t=this.d.get(E);return!t||!l.provider.provideSlashCommands?void 0:(await l.provider.provideSlashCommands(t,g))?.map(d=>({...d,kind:I.CompletionItemKind.from(d.kind)}))}$releaseSession(h){this.d.delete(h)}async $onDidPerformUserAction(h){this.e.fire(h)}}O.a=0,e.ExtHostInteractiveSession=O}),define(Ae[228],Re([1,0,6,5]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(R){this.b=0,this.a=R.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,R),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=k}),define(Ae[229],Re([1,0,2,23,8,7,77,5,13,44,16,10,269,21,6,89,84,54,58,9,17,26]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(C,N){this.d=C,this.e=N}async provideDocumentSymbols(C,N){const V=this.d.getDocument(C),q=await this.e.provideDocumentSymbols(V,N);if(!(0,O.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(k.DocumentSymbol.from):i.f(q)}static f(C){C=C.slice(0).sort((q,te)=>{let ge=q.location.range.start.compareTo(te.location.range.start);return ge===0&&(ge=te.location.range.end.compareTo(q.location.range.end)),ge});const N=[],V=[];for(const q of C){const te={name:q.name||"!!MISSING: name!!",kind:k.SymbolKind.from(q.kind),tags:q.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:k.Range.from(q.location.range),selectionRange:k.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(te),N.push(te);break}const ge=V[V.length-1];if(m.Range.containsRange(ge.range,te.range)&&!m.Range.equalsRange(ge.range,te.range)){ge.children?.push(te),V.push(te);break}V.pop()}}return N}}class u{constructor(C,N,V){this.g=C,this.h=N,this.j=V,this.e=new a.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(C,N){const V=this.g.getDocument(C),q=await this.j.provideCodeLenses(V,N);if(!q||N.isCancellationRequested)return;const te=this.e.add(q),ge=new g.DisposableStore;this.f.set(te,ge);const Pe={cacheId:te,lenses:[]};for(let le=0;le<q.length;le++)Pe.lenses.push({cacheId:[te,le],range:k.Range.from(q[le].range),command:this.h.toInternal(q[le].command,ge)});return Pe}async resolveCodeLens(C,N){const V=C.cacheId&&this.e.get(...C.cacheId);if(!V)return;let q;if(typeof this.j.resolveCodeLens!="function"||V.isResolved?q=V:q=await this.j.resolveCodeLens(V,N),q||(q=V),N.isCancellationRequested)return;const te=C.cacheId&&this.f.get(C.cacheId[0]);if(!!te)return C.command=this.h.toInternal(q.command??u.d,te),C}releaseCodeLenses(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}}u.d={command:"missing",title:"!!MISSING: command!!"};function s(Z){return Array.isArray(Z)?Z.map(k.DefinitionLink.from):Z?[k.DefinitionLink.from(Z)]:[]}class o{constructor(C,N){this.d=C,this.e=N}async provideDefinition(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideDefinition(q,te,V);return s(ge)}}class f{constructor(C,N){this.d=C,this.e=N}async provideDeclaration(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideDeclaration(q,te,V);return s(ge)}}class b{constructor(C,N){this.d=C,this.e=N}async provideImplementation(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideImplementation(q,te,V);return s(ge)}}class r{constructor(C,N){this.d=C,this.e=N}async provideTypeDefinition(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideTypeDefinition(q,te,V);return s(ge)}}class c{constructor(C,N){this.d=C,this.e=N}async provideHover(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideHover(q,te,V);if(!(!ge||(0,O.isFalsyOrEmpty)(ge.contents)))return ge.range||(ge.range=q.getWordRangeAtPosition(te)),ge.range||(ge.range=new M.Range(te,te)),k.Hover.from(ge)}}class v{constructor(C,N){this.d=C,this.e=N}async provideEvaluatableExpression(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideEvaluatableExpression(q,te,V);if(ge)return k.EvaluatableExpression.from(ge)}}class D{constructor(C,N){this.d=C,this.e=N}async provideInlineValues(C,N,V,q){const te=this.d.getDocument(C),ge=await this.e.provideInlineValues(te,k.Range.to(N),k.InlineValueContext.to(V),q);if(Array.isArray(ge))return ge.map(Pe=>k.InlineValue.from(Pe))}}class w{constructor(C,N){this.d=C,this.e=N}async provideDocumentHighlights(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideDocumentHighlights(q,te,V);if(Array.isArray(ge))return ge.map(k.DocumentHighlight.from)}}class H{constructor(C,N){this.d=C,this.e=N}async provideLinkedEditingRanges(C,N,V){const q=this.d.getDocument(C),te=k.Position.to(N),ge=await this.e.provideLinkedEditingRanges(q,te,V);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,O.coalesce)(ge.ranges.map(k.Range.from)),wordPattern:ge.wordPattern}}}class X{constructor(C,N){this.d=C,this.e=N}async provideReferences(C,N,V,q){const te=this.d.getDocument(C),ge=k.Position.to(N),Pe=await this.e.provideReferences(te,ge,V,q);if(Array.isArray(Pe))return Pe.map(k.location.from)}}class J{constructor(C,N,V,q,te,ge,Pe){this.g=C,this.h=N,this.j=V,this.k=q,this.l=te,this.m=ge,this.n=Pe,this.e=new a.Cache("CodeAction"),this.f=new Map}async provideCodeActions(C,N,V,q){const te=this.g.getDocument(C),ge=h.Selection.isISelection(N)?k.Selection.to(N):k.Range.to(N),Pe=[];for(const tt of this.j.getDiagnostics(C))if(ge.intersection(tt.range)&&Pe.push(tt)>J.d)break;const le={diagnostics:Pe,only:V.only?new M.CodeActionKind(V.only):void 0,triggerKind:k.CodeActionTriggerKind.to(V.trigger)},De=await this.k.provideCodeActions(te,ge,le,q);if(!(0,O.isNonEmptyArray)(De)||q.isCancellationRequested)return;const we=this.e.add(De),We=new g.DisposableStore;this.f.set(we,We);const $e=[];for(let tt=0;tt<De.length;tt++){const Xe=De[tt];!Xe||(J.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),$e.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(le.only&&(Xe.kind?le.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),$e.push({cacheId:[we,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(k.Diagnostic.from),edit:Xe.edit&&k.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:we,actions:$e}}async resolveCodeAction(C,N){const[V,q]=C,te=this.e.get(V,q);if(!te||J.o(te)||!this.k.resolveCodeAction)return;const ge=await this.k.resolveCodeAction(te,N)??te;return ge?.edit?k.WorkspaceEdit.from(ge.edit,void 0):void 0}releaseCodeActions(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}static o(C){return typeof C.command=="string"&&typeof C.title=="string"}}J.d=1e3;class G{constructor(C,N,V,q){this.d=C,this.e=N,this.f=V,this.g=q}async prepareDocumentPaste(C,N,V,q){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(C),ge=N.map(le=>k.Range.to(le)),Pe=k.DataTransfer.toDataTransfer(V,()=>{throw new S.NotImplementedError});return await this.f.prepareDocumentPaste(te,ge,Pe,q),k.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(C,N,V,q,te){const ge=this.e.getDocument(N),Pe=V.map(we=>k.Range.to(we)),le=k.DataTransfer.toDataTransfer(q,async we=>(await this.d.$resolvePasteFileData(this.g,C,we)).buffer),De=await this.f.provideDocumentPasteEdits(ge,Pe,le,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class U{constructor(C,N){this.d=C,this.e=N}async provideDocumentFormattingEdits(C,N,V){const q=this.d.getDocument(C),te=await this.e.provideDocumentFormattingEdits(q,N,V);if(Array.isArray(te))return te.map(k.TextEdit.from)}}class B{constructor(C,N){this.d=C,this.e=N}async provideDocumentRangeFormattingEdits(C,N,V,q){const te=this.d.getDocument(C),ge=k.Range.to(N),Pe=await this.e.provideDocumentRangeFormattingEdits(te,ge,V,q);if(Array.isArray(Pe))return Pe.map(k.TextEdit.from)}}class ${constructor(C,N){this.d=C,this.e=N,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,N,V,q,te){const ge=this.d.getDocument(C),Pe=k.Position.to(N),le=await this.e.provideOnTypeFormattingEdits(ge,Pe,V,q,te);if(Array.isArray(le))return le.map(k.TextEdit.from)}}class W{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,N){const V=await this.e.provideWorkspaceSymbols(C,N);if(!(0,O.isNonEmptyArray)(V))return{symbols:[]};const q=this.d.add(V),te={cacheId:q,symbols:[]};for(let ge=0;ge<V.length;ge++){const Pe=V[ge];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}te.symbols.push({...k.WorkspaceSymbol.from(Pe),cacheId:[q,ge]})}return te}async resolveWorkspaceSymbol(C,N){if(typeof this.e.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const V=this.d.get(...C.cacheId);if(V){const q=await this.e.resolveWorkspaceSymbol(V,N);return q&&(0,P.mixin)(C,k.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(C){this.d.delete(C)}}class x{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,N,V){this.d=C,this.e=N,this.f=V}async provideRenameEdits(C,N,V,q){const te=this.d.getDocument(C),ge=k.Position.to(N);try{const Pe=await this.e.provideRenameEdits(te,ge,V,q);return Pe?k.WorkspaceEdit.from(Pe):void 0}catch(Pe){const le=x.g(Pe);return le?{rejectReason:le,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(C,N,V){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(C),te=k.Position.to(N);try{const ge=await this.e.prepareRename(q,te,V);let Pe,le;if(M.Range.isRange(ge)?(Pe=ge,le=q.getText(ge)):(0,y.isObject)(ge)&&(Pe=ge.range,le=ge.placeholder),!Pe||!le)return;if(Pe.start.line>te.line||Pe.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Pe),text:le}}catch(ge){const Pe=x.g(ge);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(ge)}}static g(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class fe{constructor(C,N){this.resultId=C,this.tokens=N}}class Se{constructor(C,N){this.f=C,this.g=N,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(C,N,V){const q=this.f.getDocument(C),te=N!==0?this.d.get(N):null;let ge=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,te.resultId,V):await this.g.provideDocumentSemanticTokens(q,V);return te&&this.d.delete(N),ge?(ge=Se.h(ge),this.o(Se.n(te,ge),ge)):null}async releaseDocumentSemanticColoring(C){this.d.delete(C)}static h(C){return Se.j(C)?Se.k(C)?C:new M.SemanticTokens(new Uint32Array(C.data),C.resultId):Se.l(C)?Se.m(C)?C:new M.SemanticTokensEdits(C.edits.map(N=>new M.SemanticTokensEdit(N.start,N.deleteCount,N.data?new Uint32Array(N.data):N.data)),C.resultId):C}static j(C){return C&&!!C.data}static k(C){return C.data instanceof Uint32Array}static l(C){return C&&Array.isArray(C.edits)}static m(C){for(const N of C.edits)if(!(N.data instanceof Uint32Array))return!1;return!0}static n(C,N){if(!Se.j(N)||!C||!C.tokens)return N;const V=C.tokens,q=V.length,te=N.data,ge=te.length;let Pe=0;const le=Math.min(q,ge);for(;Pe<le&&V[Pe]===te[Pe];)Pe++;if(Pe===q&&Pe===ge)return new M.SemanticTokensEdits([],N.resultId);let De=0;const we=le-Pe;for(;De<we&&V[q-De-1]===te[ge-De-1];)De++;return new M.SemanticTokensEdits([{start:Pe,deleteCount:q-Pe-De,data:te.subarray(Pe,ge-De)}],N.resultId)}o(C,N){if(Se.j(C)){const V=this.e++;return this.d.set(V,new fe(C.resultId,C.data)),(0,l.encodeSemanticTokensDto)({id:V,type:"full",data:C.data})}if(Se.l(C)){const V=this.e++;return Se.j(N)?this.d.set(V,new fe(N.resultId,N.data)):this.d.set(V,new fe(C.resultId)),(0,l.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(C.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class ie{constructor(C,N){this.d=C,this.e=N}async provideDocumentRangeSemanticTokens(C,N,V){const q=this.d.getDocument(C),te=await this.e.provideDocumentRangeSemanticTokens(q,k.Range.to(N),V);return te?this.f(te):null}f(C){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class ue{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,N,V,q,te){this.f=C,this.g=N,this.h=V,this.j=q,this.k=te,this.d=new a.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(C,N,V,q){const te=this.f.getDocument(C),ge=k.Position.to(N),Pe=te.getWordRangeAtPosition(ge)||new M.Range(ge,ge),le=Pe.with({end:ge}),De=new d.StopWatch(!0),we=await this.h.provideCompletionItems(te,ge,q,k.CompletionContext.to(V));if(!we||q.isCancellationRequested)return;const We=Array.isArray(we)?new M.CompletionList(we):we,$e=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new g.DisposableStore;this.e.set($e,tt);const Xe=[],it={x:$e,b:Xe,a:{replace:k.Range.from(Pe),insert:k.Range.from(le)},c:We.isIncomplete||void 0,d:De.elapsed()};for(let nt=0;nt<We.items.length;nt++){const Me=We.items[nt],rt=this.l(Me,[$e,nt],le,Pe);Xe.push(rt)}return it}async resolveCompletionItem(C,N){if(typeof this.h.resolveCompletionItem!="function")return;const V=this.d.get(...C);if(!V)return;const q=await this.h.resolveCompletionItem(V,N);if(!!q)return this.l(q,C)}releaseCompletionItems(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,N,V,q){const te=this.e.get(N[0]);if(!te)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(C.command,te),Pe={x:N,a:C.label,b:C.kind!==void 0?k.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(k.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:k.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(k.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};C.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=C.textEdit.newText):typeof C.insertText=="string"?Pe.h=C.insertText:C.insertText instanceof M.SnippetString&&(Pe.h=C.insertText.value,Pe.i|=4);let le;return C.textEdit?le=C.textEdit.range:C.range&&(le=C.range),M.Range.isRange(le)?Pe.j=k.Range.from(le):le&&(!V?.isEqual(le.inserting)||!q?.isEqual(le.replacing))&&(Pe.j={insert:k.Range.from(le.inserting),replace:k.Range.from(le.replacing)}),Pe}}class ce{async provideInlineCompletions(C,N,V,q){}disposeCompletions(C){}handleDidShowCompletionItem(C,N){}handlePartialAccept(C,N,V){}}class Te extends ce{constructor(C,N,V,q){super(),this.f=C,this.g=N,this.h=V,this.j=q,this.d=new de,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,N,V,q){const te=this.g.getDocument(C),ge=k.Position.to(N),Pe=await this.h.provideInlineCompletionItems(te,ge,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:k.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[V.triggerKind]},q);if(!Pe||q.isCancellationRequested)return;const le=Array.isArray(Pe)?Pe:Pe.items,De=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let we;return{pid:this.d.createReferenceId({dispose(){we?.dispose()},items:le}),items:le.map(($e,tt)=>{let Xe;$e.command&&(we||(we=new g.DisposableStore),Xe=this.j.toInternal($e.command,we));const it=$e.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:$e.filterText,range:$e.range?k.Range.from($e.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?$e.completeBracketPairs:!1}}),commands:De.map($e=>(we||(we=new g.DisposableStore),this.j.toInternal($e,we)))}}disposeCompletions(C){this.d.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,N){const V=this.d.get(C)?.items[N];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V)}handlePartialAccept(C,N,V){const q=this.d.get(C)?.items[N];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,V)}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(C){const N=this.e++;return this.d.set(N,C),N}disposeReferenceId(C){const N=this.d.get(C);return this.d.delete(C),N}get(C){return this.d.get(C)}}class ae{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("SignatureHelp")}async provideSignatureHelp(C,N,V,q){const te=this.e.getDocument(C),ge=k.Position.to(N),Pe=this.g(V),le=await this.f.provideSignatureHelp(te,ge,q,Pe);if(le){const De=this.d.add([le]);return{...k.SignatureHelp.from(le),id:De}}}g(C){let N;if(C.activeSignatureHelp){const V=k.SignatureHelp.to(C.activeSignatureHelp),q=this.d.get(C.activeSignatureHelp.id,0);q?(N=q,N.activeSignature=V.activeSignature,N.activeParameter=V.activeParameter):N=V}return{...C,activeSignatureHelp:N}}releaseSignatureHelp(C){this.d.delete(C)}}class j{constructor(C,N,V,q,te){this.f=C,this.g=N,this.h=V,this.j=q,this.k=te,this.d=new a.Cache("InlayHints"),this.e=new Map}async provideInlayHints(C,N,V){const q=this.f.getDocument(C),te=k.Range.to(N),ge=await this.h.provideInlayHints(q,te,V);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${N}`);return}if(V.isCancellationRequested)return;const Pe=this.d.add(ge);this.e.set(Pe,new g.DisposableStore);const le={hints:[],cacheId:Pe};for(let De=0;De<ge.length;De++)this.l(ge[De],te)&&le.hints.push(this.m(ge[De],[Pe,De]));return this.j.trace(`[InlayHints] ${le.hints.length} inlay hints from '${this.k.identifier.value}' for ${N}`),le}async resolveInlayHint(C,N){if(typeof this.h.resolveInlayHint!="function")return;const V=this.d.get(...C);if(!V)return;const q=await this.h.resolveInlayHint(V,N);if(!!q&&!!this.l(q))return this.m(q,C)}releaseHints(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,N){return C.label.length===0||Array.isArray(C.label)&&C.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(N&&!N.contains(C.position))}m(C,N){const V=this.e.get(N[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:N,tooltip:k.MarkdownString.fromStrict(C.tooltip),position:k.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(k.TextEdit.from),kind:C.kind&&k.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?q.label=C.label:q.label=C.label.map(te=>{const ge={label:te.value};return ge.tooltip=k.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(ge.location=k.location.from(te.location)),te.command&&(ge.command=this.g.toInternal(te.command,V)),ge}),q}}class F{constructor(C,N){this.e=C,this.f=N,this.d=new a.Cache("DocumentLink")}async provideLinks(C,N){const V=this.e.getDocument(C),q=await this.f.provideDocumentLinks(V,N);if(!(!Array.isArray(q)||q.length===0)&&!N.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(F.g).map(k.DocumentLink.from)};{const te=this.d.add(q),ge={links:[],cacheId:te};for(let Pe=0;Pe<q.length;Pe++){if(!F.g(q[Pe]))continue;const le=k.DocumentLink.from(q[Pe]);le.cacheId=[te,Pe],ge.links.push(le)}return ge}}}static g(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,N){if(typeof this.f.resolveDocumentLink!="function")return;const V=this.d.get(...C);if(!V)return;const q=await this.f.resolveDocumentLink(V,N);if(!(!q||!F.g(q)))return k.DocumentLink.from(q)}releaseLinks(C){this.d.delete(C)}}class Q{constructor(C,N){this.d=C,this.e=N}async provideColors(C,N){const V=this.d.getDocument(C),q=await this.e.provideDocumentColors(V,N);return Array.isArray(q)?q.map(ge=>({color:k.Color.from(ge.color),range:k.Range.from(ge.range)})):[]}async provideColorPresentations(C,N,V){const q=this.d.getDocument(C),te=k.Range.to(N.range),ge=k.Color.to(N.color),Pe=await this.e.provideColorPresentations(ge,{document:q,range:te},V);if(!!Array.isArray(Pe))return Pe.map(k.ColorPresentation.from)}}class pe{constructor(C,N){this.d=C,this.e=N}async provideFoldingRanges(C,N,V){const q=this.d.getDocument(C),te=await this.e.provideFoldingRanges(q,N,V);if(!!Array.isArray(te))return te.map(k.FoldingRange.from)}}class ke{constructor(C,N,V){this.d=C,this.e=N,this.f=V}async provideSelectionRanges(C,N,V){const q=this.d.getDocument(C),te=N.map(k.Position.to),ge=await this.e.provideSelectionRanges(q,te,V);if(!(0,O.isNonEmptyArray)(ge))return[];if(ge.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let le=0;le<te.length;le++){const De=[];Pe.push(De);let we=te[le],We=ge[le];for(;;){if(!We.range.contains(we))throw new Error("INVALID selection range, must contain the previous range");if(De.push(k.SelectionRange.from(We)),!We.parent)break;we=We.range,We=We.parent}}return Pe}}class Ee{constructor(C,N){this.f=C,this.g=N,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,N,V){const q=this.f.getDocument(C),te=k.Position.to(N),ge=await this.g.prepareCallHierarchy(q,te,V);if(!ge)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(ge)?ge.map(le=>this.h(Pe,le)):[this.h(Pe,ge)]}async provideCallsTo(C,N,V){const q=this.j(C,N);if(!q)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(q,V);if(!!te)return te.map(ge=>({from:this.h(C,ge.from),fromRanges:ge.fromRanges.map(Pe=>k.Range.from(Pe))}))}async provideCallsFrom(C,N,V){const q=this.j(C,N);if(!q)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(q,V);if(!!te)return te.map(ge=>({to:this.h(C,ge.to),fromRanges:ge.fromRanges.map(Pe=>k.Range.from(Pe))}))}releaseSession(C){this.e.delete(C)}h(C,N){const V=this.e.get(C),q=k.CallHierarchyItem.from(N,C,V.size.toString(36));return V.set(q._itemId,N),q}j(C,N){return this.e.get(C)?.get(N)}}class ve{constructor(C,N){this.f=C,this.g=N,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,N,V){const q=this.f.getDocument(C),te=k.Position.to(N),ge=await this.g.prepareTypeHierarchy(q,te,V);if(!ge)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(ge)?ge.map(le=>this.h(Pe,le)):[this.h(Pe,ge)]}async provideSupertypes(C,N,V){const q=this.j(C,N);if(!q)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(q,V);if(!!te)return te.map(ge=>this.h(C,ge))}async provideSubtypes(C,N,V){const q=this.j(C,N);if(!q)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(q,V);if(!!te)return te.map(ge=>this.h(C,ge))}releaseSession(C){this.e.delete(C)}h(C,N){const V=this.e.get(C),q=k.TypeHierarchyItem.from(N,C,V.size.toString(36));return V.set(q._itemId,N),q}j(C,N){return this.e.get(C)?.get(N)}}class Ce{constructor(C,N,V,q){this.d=C,this.e=N,this.f=V,this.g=q}async provideDocumentOnDropEdits(C,N,V,q,te){const ge=this.e.getDocument(N),Pe=k.Position.to(V),le=k.DataTransfer.toDataTransfer(q,async we=>(await this.d.$resolveDocumentOnDropFileData(this.g,C,we)).buffer),De=await this.f.provideDocumentDropEdits(ge,Pe,le,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class se{constructor(C,N){this.adapter=C,this.extension=N}}class oe{constructor(C,N,V,q,te,ge,Pe,le){this.g=N,this.h=V,this.j=q,this.k=te,this.l=ge,this.m=Pe,this.n=le,this.f=new Map,this.e=C.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(C){return k.DocumentSelector.from(C,this.g)}p(C){return new M.Disposable(()=>{this.f.delete(C),this.e.$unregister(C)})}q(){return oe.d++}async s(C,N,V,q,te,ge=!1){const Pe=this.f.get(C);if(!Pe||!(Pe.adapter instanceof N))return q;const le=Date.now();ge||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const De=V(Pe.adapter,Pe.extension);return Promise.resolve(De).catch(we=>{(0,S.isCancellationError)(we)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(we),this.n.onExtensionError(Pe.extension.identifier,we))}).finally(()=>{ge||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-le}ms`)}),E.CancellationToken.isCancellationToken(te)?(0,T.raceCancellationError)(De,te):De}t(C,N){const V=this.q();return this.f.set(V,new se(C,N)),V}static u(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,N,V,q){const te=this.t(new i(this.h,V),C),ge=q&&q.label||oe.u(C);return this.e.$registerDocumentSymbolProvider(te,this.o(N),ge),this.p(te)}$provideDocumentSymbols(C,N,V){return this.s(C,i,q=>q.provideDocumentSymbols(n.URI.revive(N),V),void 0,V)}registerCodeLensProvider(C,N,V){const q=this.q(),te=typeof V.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new se(new u(this.h,this.j.converter,V),C)),this.e.$registerCodeLensSupport(q,this.o(N),te);let ge=this.p(q);if(te!==void 0){const Pe=V.onDidChangeCodeLenses(le=>this.e.$emitCodeLensEvent(te));ge=M.Disposable.from(ge,Pe)}return ge}$provideCodeLenses(C,N,V){return this.s(C,u,q=>q.provideCodeLenses(n.URI.revive(N),V),void 0,V)}$resolveCodeLens(C,N,V){return this.s(C,u,q=>q.resolveCodeLens(N,V),void 0,void 0)}$releaseCodeLenses(C,N){this.s(C,u,V=>Promise.resolve(V.releaseCodeLenses(N)),void 0,void 0)}registerDefinitionProvider(C,N,V){const q=this.t(new o(this.h,V),C);return this.e.$registerDefinitionSupport(q,this.o(N)),this.p(q)}$provideDefinition(C,N,V,q){return this.s(C,o,te=>te.provideDefinition(n.URI.revive(N),V,q),[],q)}registerDeclarationProvider(C,N,V){const q=this.t(new f(this.h,V),C);return this.e.$registerDeclarationSupport(q,this.o(N)),this.p(q)}$provideDeclaration(C,N,V,q){return this.s(C,f,te=>te.provideDeclaration(n.URI.revive(N),V,q),[],q)}registerImplementationProvider(C,N,V){const q=this.t(new b(this.h,V),C);return this.e.$registerImplementationSupport(q,this.o(N)),this.p(q)}$provideImplementation(C,N,V,q){return this.s(C,b,te=>te.provideImplementation(n.URI.revive(N),V,q),[],q)}registerTypeDefinitionProvider(C,N,V){const q=this.t(new r(this.h,V),C);return this.e.$registerTypeDefinitionSupport(q,this.o(N)),this.p(q)}$provideTypeDefinition(C,N,V,q){return this.s(C,r,te=>te.provideTypeDefinition(n.URI.revive(N),V,q),[],q)}registerHoverProvider(C,N,V,q){const te=this.t(new c(this.h,V),C);return this.e.$registerHoverProvider(te,this.o(N)),this.p(te)}$provideHover(C,N,V,q){return this.s(C,c,te=>te.provideHover(n.URI.revive(N),V,q),void 0,q)}registerEvaluatableExpressionProvider(C,N,V,q){const te=this.t(new v(this.h,V),C);return this.e.$registerEvaluatableExpressionProvider(te,this.o(N)),this.p(te)}$provideEvaluatableExpression(C,N,V,q){return this.s(C,v,te=>te.provideEvaluatableExpression(n.URI.revive(N),V,q),void 0,q)}registerInlineValuesProvider(C,N,V,q){const te=typeof V.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new D(this.h,V),C);this.e.$registerInlineValuesProvider(ge,this.o(N),te);let Pe=this.p(ge);if(te!==void 0){const le=V.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(te));Pe=M.Disposable.from(Pe,le)}return Pe}$provideInlineValues(C,N,V,q,te){return this.s(C,D,ge=>ge.provideInlineValues(n.URI.revive(N),V,q,te),void 0,te)}registerDocumentHighlightProvider(C,N,V){const q=this.t(new w(this.h,V),C);return this.e.$registerDocumentHighlightProvider(q,this.o(N)),this.p(q)}$provideDocumentHighlights(C,N,V,q){return this.s(C,w,te=>te.provideDocumentHighlights(n.URI.revive(N),V,q),void 0,q)}registerLinkedEditingRangeProvider(C,N,V){const q=this.t(new H(this.h,V),C);return this.e.$registerLinkedEditingRangeProvider(q,this.o(N)),this.p(q)}$provideLinkedEditingRanges(C,N,V,q){return this.s(C,H,async te=>{const ge=await te.provideLinkedEditingRanges(n.URI.revive(N),V,q);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?oe.w(ge.wordPattern):void 0}},void 0,q)}registerReferenceProvider(C,N,V){const q=this.t(new X(this.h,V),C);return this.e.$registerReferenceSupport(q,this.o(N)),this.p(q)}$provideReferences(C,N,V,q,te){return this.s(C,X,ge=>ge.provideReferences(n.URI.revive(N),V,q,te),void 0,te)}registerCodeActionProvider(C,N,V,q){const te=new g.DisposableStore,ge=this.t(new J(this.h,this.j.converter,this.k,V,this.l,C,this.m),C);return this.e.$registerQuickFixSupport(ge,this.o(N),{providedKinds:q?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:q?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,te)}))},oe.u(C),Boolean(V.resolveCodeAction)),te.add(this.p(ge)),te}$provideCodeActions(C,N,V,q,te){return this.s(C,J,ge=>ge.provideCodeActions(n.URI.revive(N),V,q,te),void 0,te)}$resolveCodeAction(C,N,V){return this.s(C,J,q=>q.resolveCodeAction(N,V),void 0,void 0)}$releaseCodeActions(C,N){this.s(C,J,V=>Promise.resolve(V.releaseCodeActions(N)),void 0,void 0)}registerDocumentFormattingEditProvider(C,N,V){const q=this.t(new U(this.h,V),C);return this.e.$registerDocumentFormattingSupport(q,this.o(N),C.identifier,C.displayName||C.name),this.p(q)}$provideDocumentFormattingEdits(C,N,V,q){return this.s(C,U,te=>te.provideDocumentFormattingEdits(n.URI.revive(N),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(C,N,V){const q=this.t(new B(this.h,V),C);return this.e.$registerRangeFormattingSupport(q,this.o(N),C.identifier,C.displayName||C.name),this.p(q)}$provideDocumentRangeFormattingEdits(C,N,V,q,te){return this.s(C,B,ge=>ge.provideDocumentRangeFormattingEdits(n.URI.revive(N),V,q,te),void 0,te)}registerOnTypeFormattingEditProvider(C,N,V,q){const te=this.t(new $(this.h,V),C);return this.e.$registerOnTypeFormattingSupport(te,this.o(N),q,C.identifier),this.p(te)}$provideOnTypeFormattingEdits(C,N,V,q,te,ge){return this.s(C,$,Pe=>Pe.provideOnTypeFormattingEdits(n.URI.revive(N),V,q,te,ge),void 0,ge)}registerWorkspaceSymbolProvider(C,N){const V=this.t(new W(N,this.l),C);return this.e.$registerNavigateTypeSupport(V,typeof N.resolveWorkspaceSymbol=="function"),this.p(V)}$provideWorkspaceSymbols(C,N,V){return this.s(C,W,q=>q.provideWorkspaceSymbols(N,V),{symbols:[]},V)}$resolveWorkspaceSymbol(C,N,V){return this.s(C,W,q=>q.resolveWorkspaceSymbol(N,V),void 0,void 0)}$releaseWorkspaceSymbols(C,N){this.s(C,W,V=>V.releaseWorkspaceSymbols(N),void 0,void 0)}registerRenameProvider(C,N,V){const q=this.t(new x(this.h,V,this.l),C);return this.e.$registerRenameSupport(q,this.o(N),x.supportsResolving(V)),this.p(q)}$provideRenameEdits(C,N,V,q,te){return this.s(C,x,ge=>ge.provideRenameEdits(n.URI.revive(N),V,q,te),void 0,te)}$resolveRenameLocation(C,N,V,q){return this.s(C,x,te=>te.resolveRenameLocation(n.URI.revive(N),V,q),void 0,q)}registerDocumentSemanticTokensProvider(C,N,V,q){const te=this.t(new Se(this.h,V),C),ge=typeof V.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(N),q,ge);let Pe=this.p(te);if(ge){const le=V.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(ge));Pe=M.Disposable.from(Pe,le)}return Pe}$provideDocumentSemanticTokens(C,N,V,q){return this.s(C,Se,te=>te.provideDocumentSemanticTokens(n.URI.revive(N),V,q),null,q)}$releaseDocumentSemanticTokens(C,N){this.s(C,Se,V=>V.releaseDocumentSemanticColoring(N),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,N,V,q){const te=this.t(new ie(this.h,V),C);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(N),q),this.p(te)}$provideDocumentRangeSemanticTokens(C,N,V,q){return this.s(C,ie,te=>te.provideDocumentRangeSemanticTokens(n.URI.revive(N),V,q),null,q)}registerCompletionItemProvider(C,N,V,q){const te=this.t(new ue(this.h,this.j.converter,V,this.m,C),C);return this.e.$registerCompletionsProvider(te,this.o(N),q,ue.supportsResolving(V),`${C.identifier.value}(${q.join("")})`),this.p(te)}$provideCompletionItems(C,N,V,q,te){return this.s(C,ue,ge=>ge.provideCompletionItems(n.URI.revive(N),V,q,te),void 0,te)}$resolveCompletionItem(C,N,V){return this.s(C,ue,q=>q.resolveCompletionItem(N,V),void 0,V)}$releaseCompletionItems(C,N){this.s(C,ue,V=>V.releaseCompletionItems(N),void 0,void 0)}registerInlineCompletionsProvider(C,N,V){const q=new Te(C,this.h,V,this.j.converter),te=this.t(q,C);return this.e.$registerInlineCompletionsSupport(te,this.o(N),q.supportsHandleEvents),this.p(te)}$provideInlineCompletions(C,N,V,q,te){return this.s(C,ce,ge=>ge.provideInlineCompletions(n.URI.revive(N),V,q,te),void 0,te)}$handleInlineCompletionDidShow(C,N,V){this.s(C,ce,async q=>{q.handleDidShowCompletionItem(N,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,N,V,q){this.s(C,ce,async te=>{te.handlePartialAccept(N,V,q)},void 0,void 0)}$freeInlineCompletionsList(C,N){this.s(C,ce,async V=>{V.disposeCompletions(N)},void 0,void 0)}registerSignatureHelpProvider(C,N,V,q){const te=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ge=this.t(new ae(this.h,V),C);return this.e.$registerSignatureHelpProvider(ge,this.o(N),te),this.p(ge)}$provideSignatureHelp(C,N,V,q,te){return this.s(C,ae,ge=>ge.provideSignatureHelp(n.URI.revive(N),V,q,te),void 0,te)}$releaseSignatureHelp(C,N){this.s(C,ae,V=>V.releaseSignatureHelp(N),void 0,void 0)}registerInlayHintsProvider(C,N,V){const q=typeof V.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new j(this.h,this.j.converter,V,this.l,C),C);this.e.$registerInlayHintsProvider(te,this.o(N),typeof V.resolveInlayHint=="function",q,oe.u(C));let ge=this.p(te);if(q!==void 0){const Pe=V.onDidChangeInlayHints(le=>this.e.$emitInlayHintsEvent(q));ge=M.Disposable.from(ge,Pe)}return ge}$provideInlayHints(C,N,V,q){return this.s(C,j,te=>te.provideInlayHints(n.URI.revive(N),V,q),void 0,q)}$resolveInlayHint(C,N,V){return this.s(C,j,q=>q.resolveInlayHint(N,V),void 0,V)}$releaseInlayHints(C,N){this.s(C,j,V=>V.releaseHints(N),void 0,void 0)}registerDocumentLinkProvider(C,N,V){const q=this.t(new F(this.h,V),C);return this.e.$registerDocumentLinkProvider(q,this.o(N),typeof V.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(C,N,V){return this.s(C,F,q=>q.provideLinks(n.URI.revive(N),V),void 0,V,N.scheme==="output")}$resolveDocumentLink(C,N,V){return this.s(C,F,q=>q.resolveLink(N,V),void 0,void 0,!0)}$releaseDocumentLinks(C,N){this.s(C,F,V=>V.releaseLinks(N),void 0,void 0,!0)}registerColorProvider(C,N,V){const q=this.t(new Q(this.h,V),C);return this.e.$registerDocumentColorProvider(q,this.o(N)),this.p(q)}$provideDocumentColors(C,N,V){return this.s(C,Q,q=>q.provideColors(n.URI.revive(N),V),[],V)}$provideColorPresentations(C,N,V,q){return this.s(C,Q,te=>te.provideColorPresentations(n.URI.revive(N),V,q),void 0,q)}registerFoldingRangeProvider(C,N,V){const q=this.q(),te=typeof V.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new se(new pe(this.h,V),C)),this.e.$registerFoldingRangeProvider(q,this.o(N),C.identifier,te);let ge=this.p(q);if(te!==void 0){const Pe=V.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));ge=M.Disposable.from(ge,Pe)}return ge}$provideFoldingRanges(C,N,V,q){return this.s(C,pe,te=>te.provideFoldingRanges(n.URI.revive(N),V,q),void 0,q)}registerSelectionRangeProvider(C,N,V){const q=this.t(new ke(this.h,V,this.l),C);return this.e.$registerSelectionRangeProvider(q,this.o(N)),this.p(q)}$provideSelectionRanges(C,N,V,q){return this.s(C,ke,te=>te.provideSelectionRanges(n.URI.revive(N),V,q),[],q)}registerCallHierarchyProvider(C,N,V){const q=this.t(new Ee(this.h,V),C);return this.e.$registerCallHierarchyProvider(q,this.o(N)),this.p(q)}$prepareCallHierarchy(C,N,V,q){return this.s(C,Ee,te=>Promise.resolve(te.prepareSession(n.URI.revive(N),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(C,N,V,q){return this.s(C,Ee,te=>te.provideCallsTo(N,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(C,N,V,q){return this.s(C,Ee,te=>te.provideCallsFrom(N,V,q),void 0,q)}$releaseCallHierarchy(C,N){this.s(C,Ee,V=>Promise.resolve(V.releaseSession(N)),void 0,void 0)}registerTypeHierarchyProvider(C,N,V){const q=this.t(new ve(this.h,V),C);return this.e.$registerTypeHierarchyProvider(q,this.o(N)),this.p(q)}$prepareTypeHierarchy(C,N,V,q){return this.s(C,ve,te=>Promise.resolve(te.prepareSession(n.URI.revive(N),V,q)),void 0,q)}$provideTypeHierarchySupertypes(C,N,V,q){return this.s(C,ve,te=>te.provideSupertypes(N,V,q),void 0,q)}$provideTypeHierarchySubtypes(C,N,V,q){return this.s(C,ve,te=>te.provideSubtypes(N,V,q),void 0,q)}$releaseTypeHierarchy(C,N){this.s(C,ve,V=>Promise.resolve(V.releaseSession(N)),void 0,void 0)}registerDocumentOnDropEditProvider(C,N,V){const q=this.q();return this.f.set(q,new se(new Ce(this.e,this.h,V,q),C)),this.e.$registerDocumentOnDropEditProvider(q,this.o(N)),this.p(q)}$provideDocumentOnDropEdits(C,N,V,q,te,ge){return this.s(C,Ce,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(N,n.URI.revive(V),q,te,ge)),void 0,void 0)}registerDocumentPasteEditProvider(C,N,V,q){const te=this.q();return this.f.set(te,new se(new G(this.e,this.h,V,te),C)),this.e.$registerPasteEditProvider(te,this.o(N),!!V.prepareDocumentPaste,q.pasteMimeTypes),this.p(te)}$prepareDocumentPaste(C,N,V,q,te){return this.s(C,G,ge=>ge.prepareDocumentPaste(n.URI.revive(N),V,q,te),void 0,te)}$providePasteEdits(C,N,V,q,te,ge){return this.s(C,G,Pe=>Pe.providePasteEdits(N,n.URI.revive(V),q,te,ge),void 0,ge)}static w(C){return{pattern:C.source,flags:(0,I.regExpFlags)(C)}}static y(C){return{decreaseIndentPattern:oe.w(C.decreaseIndentPattern),increaseIndentPattern:oe.w(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?oe.w(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?oe.w(C.unIndentedLinePattern):void 0}}static z(C){return{beforeText:oe.w(C.beforeText),afterText:C.afterText?oe.w(C.afterText):void 0,previousLineText:C.previousLineText?oe.w(C.previousLineText):void 0,action:C.action}}static B(C){return C.map(oe.z)}setLanguageConfiguration(C,N,V){const{wordPattern:q}=V;if(q&&(0,I.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(N,q):this.h.setWordDefinitionFor(N,void 0),V.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),V.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const te=this.q(),ge={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?oe.w(V.wordPattern):void 0,indentationRules:V.indentationRules?oe.y(V.indentationRules):void 0,onEnterRules:V.onEnterRules?oe.B(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this.e.$setLanguageConfiguration(te,N,ge),this.p(te)}$setWordDefinitions(C){for(const N of C)this.h.setWordDefinitionFor(N.languageId,new RegExp(N.regexSource,N.regexFlags))}}oe.d=0,e.ExtHostLanguageFeatures=oe}),define(Ae[230],Re([1,0,5,8,7,29,17,6]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(O,y,h,E){this.c=y,this.d=h,this.e=E,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,y){await this.a.$changeLanguage(O,y);const h=this.c.getDocumentData(O);if(!h)throw new Error(`document '${O.toString()}' NOT found`);return h.document}async tokenAtPosition(O,y){const h=O.version,E=P.Position.from(y),g=await this.a.$tokensAtPosition(O.uri,E),l={type:k.StandardTokenType.Other,range:O.getWordRangeAtPosition(y)??new k.Range(y.line,y.character,y.line,y.character)};if(!g)return l;const t={range:P.Range.to(g.range),type:P.TokenType.to(g.type)};return!t.range.contains(y)||h!==O.version?l:t}createLanguageStatusItem(O,y,h){const E=this.f++,g=this.a,l=this.g,t=`${O.identifier.value}/${y}`;if(l.has(t))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);l.add(t);const a={selector:h,id:y,name:O.displayName??O.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const S=new A.DisposableStore,T=()=>{d?.dispose(),d=(0,R.disposableTimeout)(()=>{S.clear(),this.a.$setLanguageStatus(E,{id:t,name:a.name??O.displayName??O.name,source:O.displayName??O.name,selector:P.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===k.LanguageStatusSeverity.Error?M.default.Error:a.severity===k.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this.d.toInternal(a.command,S),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},p={dispose(){S.dispose(),d?.dispose(),g.$removeLanguageStatus(E),l.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,T()},get selector(){return a.selector},set selector(i){a.selector=i,T()},get text(){return a.text},set text(i){a.text=i,T()},get detail(){return a.detail},set detail(i){a.detail=i,T()},get severity(){return a.severity},set severity(i){a.severity=i,T()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,T()},get command(){return a.command},set command(i){a.command=i,T()},get busy(){return a.busy},set busy(i){a.busy=i,T()}};return T(),p}}e.ExtHostLanguages=I}),define(Ae[79],Re([1,0,20,13,2,3,14,5,27,18]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(h,E,g){this.f=g,this.d=new Map,this.a=E.getProxy(A.MainContext.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(h,E){const{message:g,args:l,comment:t}=E;if(this.c)return(0,P.format2)(g,l??{});let a=g;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const d=this.d.get(h)?.contents[a];return d||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,P.format2)(d??g,l??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let E;const g=await this.g(h);if(!g){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(g),t=JSON.parse(l);E=h.isBuiltin?t.contents?.bundle:t}catch(l){this.f.error(`Failed to load translations for ${h.identifier.value} from ${g}: ${l.message}`);return}E&&this.d.set(h.identifier.value,{contents:E,uri:g})}async g(h){if(h.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return k.URI.revive(E)}return h.l10n?k.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([je(0,I.IExtHostInitDataService),je(1,m.IExtHostRpcService),je(2,R.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ae[231],Re([1,0,14,5,27,18,2,67]),function(ee,e,n,P,k,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends n.AbstractLoggerService{constructor(y,h){super(h.logLevel,h.logsLocation,h.loggers.map(E=>(0,A.revive)(E))),this.n=y.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(y,h){h?this.setLogLevel(R.URI.revive(h),y):this.setLogLevel(y)}setVisibility(y,h){super.setVisibility(y,h),this.n.$setVisibility(y,h)}m(y,h,E){return new m(this.n,y,h,E)}};I=qe([je(0,M.IExtHostRpcService),je(1,k.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class m extends n.AbstractMessageLogger{constructor(y,h,E,g){super(g?.logLevel==="always"),this.m=y,this.n=h,this.k=!1,this.l=[],this.setLevel(E),this.m.$createLogger(h,g).then(()=>{this.r(this.l),this.k=!0})}g(y,h){const E=[[y,h]];this.k?this.r(E):this.l.push(...E)}r(y){this.m.$log(this.n,y)}flush(){this.m.$flush(this.n)}}}),define(Ae[232],Re([1,0,5,14,26]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let R=class{constructor(I,m){this.b=m,this.a=I.getProxy(n.MainContext.MainThreadMessageService)}showMessage(I,m,O,y,h){const E={source:{identifier:I.identifier,label:I.displayName||I.name}};let g;typeof y=="string"||M(y)?g=[y,...h]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,g=h),E.useCustom&&(0,k.checkProposedApiEnabled)(I,"resolvers");const l=[];for(let t=0;t<g.length;t++){const a=g[t];if(typeof a=="string")l.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:d,isCloseAffordance:S}=a;l.push({title:d,isCloseAffordance:!!S,handle:t})}else this.b.warn("Invalid message item:",a)}return this.a.$showMessage(m,O,E,l).then(t=>{if(typeof t=="number")return g[t]})}};R=qe([je(1,P.ILogService)],R),e.ExtHostMessageService=R}),define(Ae[233],Re([1,0,25,4,6,28,13,10,2,54,5,38,8,7,46,203,102,9]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(T=>T.apiEditor)}constructor(T,p,i,u){this.q=i,this.r=u,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new m.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=T.getProxy(O.MainContext.MainThreadNotebook),this.c=T.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=T.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const o=s.notebookEditor?.notebookUri,f=s.cell.handle,r=this.g.get(o)?.getCell(f);if(r)return r.apiCell}if(s&&s.$mid===14){const o=s.uri,f=this.g.get(o);if(f)return f.apiNotebook}return s}}),d.x(p)}getEditorById(T){const p=this.h.get(T);if(!p)throw new Error(`unknown text editor: ${T}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(T){for(const[p,i]of this.h)if(i.apiEditor===T)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(T,p){const i=this.g.get(T);if(!i&&!p)throw new Error(`NO notebook document for '${T}'`);return i}static s(T,p){if(!p)return;const i=p.filenamePattern.map(u=>h.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(p.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:T.identifier,providerDisplayName:T.displayName||T.name,displayName:p.displayName,filenamePattern:i,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(T,p,i){const u=d.a++,s=typeof i.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(u,i),this.b.$registerNotebookCellStatusBarItemProvider(u,s,p);let o;return s!==void 0&&(o=i.onDidChangeCellStatusBarItems(f=>this.b.$emitCellStatusBarEvent(s))),new E.Disposable(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,s),o?.dispose()})}async createNotebookDocument(T){const p=await this.c.$tryCreateNotebook({viewType:T.viewType,content:T.content&&h.NotebookData.from(T.content)});return I.URI.revive(p)}async openNotebookDocument(T){const p=this.g.get(T);if(p)return p.apiNotebook;const i=await this.c.$tryOpenNotebook(T),u=this.g.get(I.URI.revive(i));return(0,A.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(T,p){I.URI.isUri(T)&&(T=await this.openNotebookDocument(T));let i;typeof p=="object"?i={position:h.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(h.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:i={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(T.uri,T.notebookType,i),s=u&&this.h.get(u)?.apiEditor;if(s)return s;throw u?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(T,p,i,u){const s=this.f.get(T),o=I.URI.revive(p),f=this.g.get(o);if(!f||!s)return;const b=f.getCellFromIndex(i);if(!b)return;const r=await s.provideCellStatusBarItems(b.apiCell,u);if(!r)return;const c=new k.DisposableStore,v=this.p.add([c]),w=(Array.isArray(r)?r:[r]).map(H=>h.NotebookStatusBarItem.from(H,this.i,c));return{cacheId:v,items:w}}$releaseNotebookCellStatusBarItems(T){this.p.delete(T)}registerNotebookSerializer(T,p,i,u,s){if((0,R.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,i),this.b.$registerNotebookSerializer(o,{id:T.identifier,location:T.extensionLocation},p,h.NotebookDocumentContentOptions.from(u),d.s(T,s)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(T,p,i){const u=this.u.get(T);if(!u)throw new Error("NO serializer found");const s=await u.deserializeNotebook(p.buffer,i);return new g.SerializableObjectWithBuffers(h.NotebookData.from(s))}async $notebookToData(T,p,i){const u=this.u.get(T);if(!u)throw new Error("NO serializer found");const s=await u.serializeNotebook(h.NotebookData.to(p.value),i);return n.VSBuffer.wrap(s)}w(T,p,i){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const u=new t.ExtHostNotebookEditor(p,this.d,T,i.visibleRanges.map(h.NotebookRange.to),i.selections.map(h.NotebookRange.to),typeof i.viewColumn=="number"?h.ViewColumn.to(i.viewColumn):void 0);this.h.set(p,u)}$acceptDocumentAndEditorsDelta(T){if(T.value.removedDocuments)for(const i of T.value.removedDocuments){const u=I.URI.revive(i),s=this.g.get(u);s&&(s.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(s.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===u.toString()&&this.h.delete(o.id)}if(T.value.addedDocuments){const i=[];for(const u of T.value.addedDocuments){const s=I.URI.revive(u.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const o=new l.ExtHostNotebookDocument(this.c,this.q,this.r,s,u);i.push(...u.cells.map(f=>l.ExtHostCell.asModelAddData(o.apiNotebook,f))),this.g.get(s)?.dispose(),this.g.set(s,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this.m.fire(o.apiNotebook)}}if(T.value.addedEditors)for(const i of T.value.addedEditors){if(this.h.has(i.id))return;const u=I.URI.revive(i.documentUri),s=this.g.get(u);s&&this.w(s,i.id,i)}const p=[];if(T.value.removedEditors)for(const i of T.value.removedEditors){const u=this.h.get(i);u&&(this.h.delete(i),this.k?.id===u.id&&(this.k=void 0),p.push(u))}if(T.value.visibleEditors){this.l=T.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const i=new Set;this.l.forEach(u=>i.add(u.id));for(const u of this.h.values()){const s=i.has(u.id);u._acceptVisibility(s)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}T.value.newActiveEditor===null?this.k=void 0:T.value.newActiveEditor&&(this.h.get(T.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${T.value.newActiveEditor}`),this.k=this.h.get(T.value.newActiveEditor)),T.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(T){const p=y.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new y.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>n.VSBuffer.wrap(s))],new y.ApiCommandResult("Notebook Data",s=>h.NotebookData.to(s.value))),u=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new g.SerializableObjectWithBuffers(h.NotebookData.from(s)))],new y.ApiCommandResult("Bytes",s=>s.buffer));T.registerApiCommand(i),T.registerApiCommand(u)}}d.a=0,e.ExtHostNotebookController=d}),define(Ae[234],Re([1,0,16,17,21,4,6,28,2,24,14,54,5,38,8,7,75,193,26,46]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let T=class{constructor(f,b,r,c,v){this.k=b,this.l=r,this.m=c,this.n=v,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new y.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=f.getProxy(h.MainContext.MainThreadNotebookKernels);const D=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const H=this.l.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:H}}else if(w&&"notebookEditor"in w){const H=this.l.getIdByEditor(w.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return w})],E.ApiCommandResult.Void);this.m.registerApiCommand(D)}createNotebookController(f,b,r,c,v,D){for(const ce of this.h.values())if(ce.controller.id===b&&m.ExtensionIdentifier.equals(f.identifier,ce.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const w=this.i++,H=this;this.n.trace(`NotebookController[${w}], CREATED by ${f.identifier.value}, ${b}`);const X=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${f.identifier}'`);let J=!1;const G=new R.DisposableStore,U=new M.Emitter,B=new M.Emitter,$={id:s(f.identifier,b),notebookType:r,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:c||f.identifier.value,preloads:D?D.map(g.NotebookRendererScript.from):[]};let W=v??X,x;this.a.$addKernel(w,$).catch(ce=>{console.log(ce),J=!0});let fe=0;const Se=()=>{if(J)return;const ce=++fe;Promise.resolve().then(()=>{ce===fe&&this.a.$updateKernel(w,$)})},ie=new A.ResourceMap,ue={get id(){return b},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return $.label},set label(ce){$.label=ce??f.displayName??f.name,Se()},get detail(){return $.detail??""},set detail(ce){$.detail=ce,Se()},get description(){return $.description??""},set description(ce){$.description=ce,Se()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ce){$.supportedLanguages=ce,Se()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){$.supportsExecutionOrder=ce,Se()},get rendererScripts(){return $.preloads?$.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ce){W=ce??X},get interruptHandler(){return x},set interruptHandler(ce){x=ce,$.supportsInterrupt=Boolean(ce),Se()},createNotebookCellExecution(ce){if(J)throw new Error("notebook controller is DISPOSED");if(!ie.has(ce.notebook.uri))throw H.n.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return H._createNotebookCellExecution(ce,s(f.identifier,this.id))},dispose:()=>{J||(this.n.trace(`NotebookController[${w}], DISPOSED`),J=!0,this.h.delete(w),G.dispose(),U.dispose(),B.dispose(),this.a.$removeKernel(w))},updateNotebookAffinity(ce,Te){Te===l.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(f,"notebookControllerAffinityHidden"),H.a.$updateNotebookPriority(w,ce.uri,Te)},onDidReceiveMessage:B.event,postMessage(ce,Te){return(0,d.checkProposedApiEnabled)(f,"notebookMessaging"),H.a.$postMessage(w,Te&&H.l.getIdByEditor(Te),ce)},asWebviewUri(ce){return(0,d.checkProposedApiEnabled)(f,"notebookMessaging"),(0,t.asWebviewUri)(ce,H.k.remote)}};return this.h.set(w,{extensionId:f.identifier,controller:ue,onDidReceiveMessage:B,onDidChangeSelection:U,associatedNotebooks:ie}),ue}getIdByController(f){for(const[b,r]of this.h)if(r.controller===f)return s(r.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,b){const r=this.d++,c=this;this.n.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(r,b);const v={dispose:()=>{this.c.delete(r),c.a.$removeKernelDetectionTask(r)}};return this.c.set(r,v),v}registerKernelSourceActionProvider(f,b,r){const c=this.f++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,D=this;this.e.set(c,r),this.n.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(c,c,b);let w;return v!==void 0&&(w=r.onDidChangeNotebookKernelSourceActions(H=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.e.delete(c),D.a.$removeKernelSourceActionProvider(c,c),w?.dispose()}}}async $provideKernelSourceActions(f,b){const r=this.e.get(f);if(r){const c=new R.DisposableStore;return this.g.add([c]),(await r.provideNotebookKernelSourceActions(b)??[]).map(D=>g.NotebookKernelSourceAction.from(D,this.m.converter,c))}return[]}$acceptNotebookAssociation(f,b,r){const c=this.h.get(f);if(c){const v=this.l.getNotebookDocument(I.URI.revive(b));r?c.associatedNotebooks.set(v.uri,!0):c.associatedNotebooks.delete(v.uri),this.n.trace(`NotebookController[${f}] ASSOCIATE notebook`,v.uri.toString(),r),c.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(f,b,r){const c=this.h.get(f);if(!c)return;const v=this.l.getNotebookDocument(I.URI.revive(b)),D=[];for(const w of r){const H=v.getCell(w);H&&D.push(H.apiCell)}try{this.n.trace(`NotebookController[${f}] EXECUTE cells`,v.uri.toString(),D.length),await c.controller.executeHandler.call(c.controller,D,v.apiNotebook,c.controller)}catch(w){this.n.error(`NotebookController[${f}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(f,b,r){const c=this.h.get(f);if(!c)return;const v=this.l.getNotebookDocument(I.URI.revive(b));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,v.apiNotebook);else for(const D of r){const w=v.getCell(D);w&&this.b.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(f,b,r){const c=this.h.get(f);if(!c)return;const v=this.l.getEditorById(b);c.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(f,b,r){const v=this.l.getNotebookDocument(I.URI.revive(f)).getCell(b);if(v){const D=r?g.NotebookCellExecutionState.to(r):l.NotebookCellExecutionState.Idle;D!==void 0&&this.j.fire({cell:v.apiCell,state:D})}}_createNotebookCellExecution(f,b){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this.l.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!c)throw new Error("invalid cell");if(this.b.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const v=new i(b,c,this.a);this.b.set(c.uri,v);const D=v.onDidChangeState(()=>{v.state===p.Resolved&&(v.dispose(),D.dispose(),this.b.delete(c.uri))});return v.asApiObject()}};T=qe([je(4,O.ILogService)],T),e.ExtHostNotebookKernels=T;var p;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(p||(p={}));class i extends R.Disposable{get state(){return this.f}constructor(f,b,r){super(),this.j=b,this.k=r,this.b=i.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new u(10,c=>this.m(c)),this.i=b.internalMetadata.executionOrder,this.k.$createExecution(this.b,f,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(f){await this.h.addItem(f)}async m(f){const b=Array.isArray(f)?f:[f];return this.k.$updateExecution(this.b,new S.SerializableObjectWithBuffers(b))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(f){let b=this.j;if(f&&(b=this.j.notebook.getCellFromApiCell(f)),!b)throw new Error("INVALID cell");return b.handle}s(f){return f.map(b=>{const r=l.NotebookCellOutput.ensureUniqueMimeTypes(b.items,!0);return r===b.items?g.NotebookCellOutput.from(b):g.NotebookCellOutput.from({items:r,id:b.id,metadata:b.metadata})})}async t(f,b,r){const c=this.r(b),v=this.s((0,n.asArray)(f));return this.l({editType:a.CellExecutionUpdateType.Output,cellHandle:c,append:r,outputs:v})}async w(f,b,r){return f=l.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(f),!0),this.l({editType:a.CellExecutionUpdateType.OutputItems,items:f.map(g.NotebookCellOutputItem.from),outputId:b.id,append:r})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.j.apiCell},get executionOrder(){return f.i},set executionOrder(r){f.i=r,f.m([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:f.i}])},start(r){if(f.f===p.Resolved||f.f===p.Started)throw new Error("Cannot call start again");f.f=p.Started,f.c.fire(),f.m({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,c){if(f.f===p.Resolved)throw new Error("Cannot call resolve twice");f.f=p.Resolved,f.c.fire(),f.h.flush(),f.k.$completeExecution(f.b,new S.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:r}))},clearOutput(r){return f.n(),f.t([],r,!1)},appendOutput(r,c){return f.n(),f.t(r,c,!0)},replaceOutput(r,c){return f.n(),f.t(r,c,!1)},appendOutputItems(r,c){return f.n(),f.w(r,c,!0)},replaceOutputItems(r,c){return f.n(),f.w(r,c,!1)}})}}i.a=0;class u{constructor(f,b){this.d=f,this.e=b,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new P.DeferredPromise,this.b=Date.now(),(0,P.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const b=this.a;return this.a=[],this.e(b).finally(()=>f.complete())}}function s(o,f){return`${o.value}/${f}`}e.createKernelId=s}),define(Ae[235],Re([1,0,4,5,102]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,I){this.c=I,this.a=new Map,this.b=A.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,I,m){const O=this.c.getEditorById(A);this.a.get(I)?.fire({editor:O.apiEditor,message:m})}createRendererMessaging(A,I){if(!A.contributes?.notebookRenderer?.some(O=>O.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);return{onDidReceiveMessage:(O,y,h)=>this.d(I).event(O,y,h),postMessage:(O,y)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,y]=[y,O]);const h=y&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.b.$postMessage(h?.id,I,O)}}}d(A){let I=this.a.get(A);return I||(I=new n.Emitter({onDidRemoveLastListener:()=>{I?.dispose(),this.a.delete(A)}}),this.a.set(A,I),I)}}e.ExtHostNotebookRenderers=M}),define(Ae[236],Re([1,0,6,10,2,26,5]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(m){this.b=new Map,this.a=m.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,O,y){if((0,M.checkProposedApiEnabled)(m,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,y),this.a.$registerProfileContentHandler(O,y.name,y.description,m.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(m,O,y,h){const E=this.b.get(m);if(!E)throw new Error(`Unknown handler with id: ${m}`);return E.saveProfile(O,y,h)}async $readProfile(m,O,y){const h=this.b.get(m);if(!h)throw new Error(`Unknown handler with id: ${m}`);return h.readProfile((0,P.isString)(O)?O:k.URI.revive(O),y)}}e.ExtHostProfileContentHandlers=A}),define(Ae[237],Re([1,0,2,5,17,8]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(I,m){this.d=m,this.c=new Map,this.b=I.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(I,m,O){const y=n.URI.revive(m),h=this.c.get(I);return h?(0,k.asPromise)(()=>h.provideOriginalResource(y,O)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(I,m,O,y){const h=R.a++;return this.c.set(h,m),this.b.$registerQuickDiffProvider(h,M.DocumentSelector.from(I,this.d),O,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}R.a=0,e.ExtHostQuickDiff=R}),define(Ae[238],Re([1,0,21,4,6,5,2,7,9,16,29,39,26,8]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(l,t,a){const d=l.getProxy(M.MainContext.MainThreadQuickOpen);class S{constructor(r,c){this.e=new Map,this.f=0,this.a=r,this.b=c}showQuickPick(r,c,v,D=n.CancellationToken.None){this.c=void 0;const w=Promise.resolve(c),H=++this.f,X=d.$show(H,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},D),J={},G=X.then(()=>J);return Promise.race([G,w]).then(U=>{if(U===J)return;const B=(0,h.isProposedApiEnabled)(r,"quickPickItemTooltip");return w.then($=>{const W=[];for(let x=0;x<$.length;x++){const fe=$[x];typeof fe=="string"?W.push({label:fe,handle:x}):fe.kind===A.QuickPickItemKind.Separator?W.push({type:"separator",label:fe.label}):(fe.tooltip&&!B&&console.warn(`Extension '${r.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${r.identifier.value}`),W.push({label:fe.label,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:B?E.MarkdownString.fromStrict(fe.tooltip):void 0,handle:x}))}return v&&typeof v.onDidSelectItem=="function"&&(this.c=x=>{v.onDidSelectItem($[x])}),d.$setItems(H,W),X.then(x=>{if(typeof x=="number")return $[x];if(Array.isArray(x))return x.map(fe=>$[fe])})})}).then(void 0,U=>{if(!(0,I.isCancellationError)(U))return d.$setError(H,U),Promise.reject(U)})}$onItemSelected(r){this.c?.(r)}showInput(r,c=n.CancellationToken.None){return this.d=r?.validateInput,d.$input(r,typeof this.d=="function",c).then(void 0,v=>{if(!(0,I.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(r){if(!this.d)return;const c=await this.d(r);if(!c||typeof c=="string")return c;let v;switch(c.severity){case A.InputBoxValidationSeverity.Info:v=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:v=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:v=O.default.Error;break;default:v=c.message?O.default.Error:O.default.Ignore;break}return{content:c.message,severity:v}}async showWorkspaceFolderPick(r,c=n.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!v)return;const D=await this.a.getWorkspaceFolders2();if(!!D)return D.find(w=>w.uri.toString()===v.uri.toString())}createQuickPick(r){const c=new o(r,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}createInputBox(r){const c=new f(r,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}$onDidChangeValue(r,c){this.e.get(r)?._fireDidChangeValue(c)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,c){const v=this.e.get(r);v instanceof o&&v._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const v=this.e.get(r);v instanceof o&&v._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){this.e.get(r)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(r,c,v){const D=this.e.get(r);D instanceof o&&D._fireDidTriggerItemButton(c,v)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class T{constructor(r,c){this.x=r,this.y=c,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.Emitter,this.q=new P.Emitter,this.r=new P.Emitter,this.s=new P.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((c,v)=>{const D=c===A.QuickInputButtons.Back?-1:v;this.o.set(D,c)}),this.z({buttons:r.map((c,v)=>({...s(c),tooltip:c.tooltip,handle:c===A.QuickInputButtons.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const c=this.o.get(r);c&&this.r.fire(c)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(r){if(!this.v){for(const c of Object.keys(r)){const v=r[c];this.u[c]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}T.a=1;function p(b){if(b instanceof A.ThemeIcon)return{id:b.id};const r=u(b),c=i(b);return{dark:typeof r=="string"?R.URI.file(r):r,light:typeof c=="string"?R.URI.file(c):c}}function i(b){return typeof b=="object"&&"light"in b?b.light:b}function u(b){return typeof b=="object"&&"dark"in b?b.dark:b}function s(b){const r=p(b.iconPath);let c,v;return"id"in r?v=y.ThemeIcon.asClassName(r):c=r,{iconPath:c,iconClass:v}}class o extends T{constructor(r,c){super(r.identifier,c),this.O=r,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.Emitter,this.L=[],this.M=new P.Emitter,this.N=new P.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((D,w)=>{this.C.set(w,D),this.D.set(D,w)});const c=(0,h.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),v=[];for(let D=0;D<r.length;D++){const w=r[D];w.kind===A.QuickPickItemKind.Separator?v.push({type:"separator",label:w.label}):(w.tooltip&&!c&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),v.push({handle:D,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:c?E.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((H,X)=>({...s(H),tooltip:H.tooltip,handle:X}))}))}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(c=>this.D.has(c)),this.z({activeItems:this.J.map(c=>this.D.get(c))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(c=>this.D.has(c)),this.z({selectedItems:this.L.map(c=>this.D.get(c))})}_fireDidChangeActive(r){const c=(0,m.coalesce)(r.map(v=>this.C.get(v)));this.J=c,this.K.fire(c)}_fireDidChangeSelection(r){const c=(0,m.coalesce)(r.map(v=>this.C.get(v)));this.L=c,this.M.fire(c)}_fireDidTriggerItemButton(r,c){const v=this.C.get(r);if(!v||!v.buttons||!v.buttons.length)return;const D=v.buttons[c];D&&this.N.fire({button:D,item:v})}}class f extends T{constructor(r,c){super(r.identifier,c),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:O.default.Error}):this.z({validationMessage:r.message,severity:r.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new S(t,a)}e.createExtHostQuickOpen=g});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n};define(Ae[239],Re([1,0,2,4,65,6,17,5,16,126,14,24,39,8,26]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g){"use strict";var l,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(c){if(c)return typeof c.iconPath=="string"?n.URI.file(c.iconPath):n.URI.isUri(c.iconPath)||h.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function d(c,v){if(!c.iconPath&&!v.iconPath)return 0;if(c.iconPath){if(!v.iconPath)return 1}else return-1;const D=typeof c.iconPath=="string"?c.iconPath:n.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,w=typeof v.iconPath=="string"?v.iconPath:n.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,m.comparePaths)(D,w)}function S(c,v){let D=0;if(c.strikeThrough!==v.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==v.faded)return c.faded?1:-1;if(c.tooltip!==v.tooltip)return(c.tooltip||"").localeCompare(v.tooltip||"");if(D=d(c,v),D!==0)return D;if(c.light&&v.light)D=d(c.light,v.light);else{if(c.light)return 1;if(v.light)return-1}if(D!==0)return D;if(c.dark&&v.dark)D=d(c.dark,v.dark);else{if(c.dark)return 1;if(v.dark)return-1}return D}function T(c,v){if(c.command!==v.command)return c.command<v.command?-1:1;if(c.title!==v.title)return c.title<v.title?-1:1;if(c.tooltip!==v.tooltip){if(c.tooltip!==void 0&&v.tooltip!==void 0)return c.tooltip<v.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(c.arguments===v.arguments)return 0;if(c.arguments)if(v.arguments){if(c.arguments.length!==v.arguments.length)return c.arguments.length-v.arguments.length}else return 1;else return-1;for(let D=0;D<c.arguments.length;D++){const w=c.arguments[D],H=v.arguments[D];if(w!==H)return w<H?-1:1}return 0}function p(c,v){let D=(0,m.comparePaths)(c.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(D!==0)return D;if(c.command&&v.command)D=T(c.command,v.command);else{if(c.command)return 1;if(v.command)return-1}if(D!==0)return D;if(c.decorations&&v.decorations)D=S(c.decorations,v.decorations);else{if(c.decorations)return 1;if(v.decorations)return-1}return D}function i(c,v){for(let D=0;D<c.length;D++)if(c[D]!==v[D])return!1;return!0}function u(c,v){return c.command===v.command&&c.title===v.title&&c.tooltip===v.tooltip&&(c.arguments&&v.arguments?i(c.arguments,v.arguments):c.arguments===v.arguments)}function s(c,v){return(0,I.equals)(c,v,u)}class o{get value(){return this.d}set value(v){v=v??"",Ne(this,l,"f").$setInputBoxValue(this.l,v),this.m(v)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(v){Ne(this,l,"f").$setInputBoxPlaceholder(this.l,v),this.f=v}get validateInput(){return(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(v){if((0,g.checkProposedApiEnabled)(this.k,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=v,Ne(this,l,"f").$setValidationProviderIsEnabled(this.l,!!v)}get enabled(){return this.h}set enabled(v){v=!!v,this.h!==v&&(this.h=v,Ne(this,l,"f").$setInputBoxEnablement(this.l,v))}get visible(){return this.j}set visible(v){v=!!v,this.j!==v&&(this.j=v,Ne(this,l,"f").$setInputBoxVisibility(this.l,v))}constructor(v,D,w){this.k=v,this.l=w,l.set(this,void 0),this.d="",this.e=new P.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,l,D,"f")}showValidationMessage(v,D){(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),Ne(this,l,"f").$showValidationMessage(this.l,v,D)}$onInputBoxValueChange(v){this.m(v)}m(v){this.d=v,this.e.fire(v)}}e.ExtHostSCMInputBox=o,l=new WeakMap;class f{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(v){this.v=v,this.q.$updateGroupLabel(this.t,this.handle,v)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(v){this.p=v,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(v){this.f=[...v],this.k.fire()}constructor(v,D,w,H,X){this.q=v,this.s=D,this.t=w,this.u=H,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(v){return this.g.get(v)}$executeResourceCommand(v,D){const w=this.h.get(v);return w?(0,R.asPromise)(()=>this.s.executeCommand(w.command,...w.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this.f].sort(p),w=(0,I.sortedDiff)(this.o,v,p).map(J=>{const G=J.toInsert.map(U=>{const B=this.e++;this.g.set(B,U);const $=U.resourceUri;let W;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const j=new M.DisposableStore;W=this.s.converter.toInternal(U.command,j),this.j.set(B,j)}else this.h.set(B,U.command);const x=a(U.decorations),fe=U.decorations&&a(U.decorations.light)||x,Se=U.decorations&&a(U.decorations.dark)||x,ie=[fe,Se],ue=U.decorations&&U.decorations.tooltip||"",ce=U.decorations&&!!U.decorations.strikeThrough,Te=U.decorations&&!!U.decorations.faded,de=U.contextValue||"";return{rawResource:[B,$,ie,ue,ce,Te,de,W],handle:B}});return{start:J.start,deleteCount:J.deleteCount,toInsert:G}}),H=w.map(({start:J,deleteCount:G,toInsert:U})=>[J,G,U.map(B=>B.rawResource)]),X=w.reverse();for(const{start:J,deleteCount:G,toInsert:U}of X){const B=U.map(W=>W.handle),$=this.n.splice(J,G,...B);for(const W of $)this.g.delete(W),this.h.delete(W),this.j.get(W)?.dispose(),this.j.delete(W)}return this.o=v,H}dispose(){this.l=!0,this.m.fire()}}f.d=0;class b{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(v){this.g!==v&&(this.g=v,Ne(this,t,"f").$updateSourceControl(this.t,{count:v}))}get quickDiffProvider(){return this.h}set quickDiffProvider(v){this.h=v;let D;(0,g.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(D=v?.label),Ne(this,t,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!v,quickDiffLabel:D})}get commitTemplate(){return this.j}set commitTemplate(v){v!==this.j&&(this.j=v,Ne(this,t,"f").$updateSourceControl(this.t,{commitTemplate:v}))}get acceptInputCommand(){return this.l}set acceptInputCommand(v){this.k.value=new M.DisposableStore,this.l=v;const D=this.v.converter.toInternal(v,this.k.value);Ne(this,t,"f").$updateSourceControl(this.t,{acceptInputCommand:D})}get actionButton(){return(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(v){(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=v;const D=v!==void 0?{command:this.v.converter.toInternal(v.command,this.m.value),secondaryCommands:v.secondaryCommands?.map(w=>w.map(H=>this.v.converter.toInternal(H,this.m.value))),description:v.description,enabled:v.enabled}:void 0;Ne(this,t,"f").$updateSourceControl(this.t,{actionButton:D??null})}get statusBarCommands(){return this.p}set statusBarCommands(v){if(this.p&&v&&s(this.p,v))return;this.o.value=new M.DisposableStore,this.p=v;const D=(v||[]).map(w=>this.v.converter.toInternal(w,this.o.value));Ne(this,t,"f").$updateSourceControl(this.t,{statusBarCommands:D})}get selected(){return this.q}constructor(v,D,w,H,X,J){this.u=v,this.v=w,this.w=H,this.x=X,this.y=J,t.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new P.Emitter,this.onDidChangeSelection=this.s.event,this.t=b.d++,this.z=new Map,this.A=new Set,_e(this,t,D,"f"),this.f=new o(v,Ne(this,t,"f"),this.t),Ne(this,t,"f").$registerSourceControl(this.t,H,X,J)}createResourceGroup(v,D){const w=new f(Ne(this,t,"f"),this.v,this.t,v,D),H=P.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,H),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const v=[],D=[];for(const[w,H]of this.z){H.dispose();const X=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});P.Event.once(w.onDidDispose)(()=>{this.A.delete(w),X.dispose(),this.e.delete(w.handle),Ne(this,t,"f").$unregisterGroup(this.t,w.handle)}),v.push([w.handle,w.id,w.label,w.features]);const J=w._takeResourceStateSnapshot();J.length>0&&D.push([w.handle,J]),this.e.set(w.handle,w)}Ne(this,t,"f").$registerGroups(this.t,v,D),this.z.clear()}eventuallyUpdateResourceStates(){const v=[];this.A.forEach(D=>{const w=D._takeResourceStateSnapshot();w.length!==0&&v.push([D.handle,w])}),v.length>0&&Ne(this,t,"f").$spliceResourceStates(this.t,v),this.A.clear()}getResourceGroup(v){return this.e.get(v)}setSelectionState(v){this.q=v,this.s.fire(v)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(v=>v.dispose()),Ne(this,t,"f").$unregisterSourceControl(this.t)}}t=new WeakMap,b.d=0,qe([(0,k.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),qe([(0,k.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let r=class hn{get onDidChangeActiveProvider(){return this.j.event}constructor(v,D,w){this.l=D,this.m=w,this.g=new Map,this.h=new y.ExtensionIdentifierMap,this.j=new P.Emitter,this.e=v.getProxy(A.MainContext.MainThreadSCM),this.f=v.getProxy(A.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:H=>{if(H&&H.$mid===3){const X=this.g.get(H.sourceControlHandle);if(!X)return H;const J=X.getResourceGroup(H.groupHandle);return J?J.getResourceState(H.handle):H}else if(H&&H.$mid===4){const X=this.g.get(H.sourceControlHandle);return X?X.getResourceGroup(H.groupHandle):H}else if(H&&H.$mid===5){const X=this.g.get(H.handle);return X||H}return H}})}createSourceControl(v,D,w,H){this.m.trace("ExtHostSCM#createSourceControl",v.identifier.value,D,w,H),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const X=hn.d++,J=new b(v,this.e,this.l,D,w,H);this.g.set(X,J);const G=this.h.get(v.identifier)||[];return G.push(J),this.h.set(v.identifier,G),J}getLastInputBox(v){this.m.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const D=this.h.get(v.identifier),w=D&&D[D.length-1];return w&&w.inputBox}$provideOriginalResource(v,D,w){const H=n.URI.revive(D);this.m.trace("ExtHostSCM#$provideOriginalResource",v,H.toString());const X=this.g.get(v);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>X.quickDiffProvider.provideOriginalResource(H,w)).then(J=>J||null)}$onInputBoxValueChange(v,D){this.m.trace("ExtHostSCM#$onInputBoxValueChange",v);const w=this.g.get(v);return w&&w.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(v,D,w,H){this.m.trace("ExtHostSCM#$executeResourceCommand",v,D,w);const X=this.g.get(v);if(!X)return Promise.resolve(void 0);const J=X.getResourceGroup(D);return J?J.$executeResourceCommand(w,H):Promise.resolve(void 0)}$validateInput(v,D,w){this.m.trace("ExtHostSCM#$validateInput",v);const H=this.g.get(v);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>H.inputBox.validateInput(D,w)).then(X=>{if(!X)return Promise.resolve(void 0);const J=E.MarkdownString.fromStrict(X.message);return J?Promise.resolve([J,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this.g.get(v)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=v,Promise.resolve(void 0)}};r.d=0,r=qe([je(2,O.ILogService)],r),e.ExtHostSCM=r}),define(Ae[80],Re([1,0,5,4,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this.b=new P.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,I){return this.a.$getPassword(A,I)}store(A,I,m){return this.a.$setPassword(A,I,m)}delete(A,I){return this.a.$deletePassword(A,I)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[240],Re([1,0,7,5,149,6,8,10]),function(ee,e,n,P,k,M,R,A){"use strict";var I,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(g,l,t,a,d=n.StatusBarAlignment.Left,S){I.set(this,void 0),m.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,_e(this,I,g,"f"),_e(this,m,l,"f"),this.c=O.a++,this.e=t,this.f=a,this.g=d,this.h=this.u(S)}u(g){if(!!(0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!O.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof g=="string"?this.r={fromApi:g,internal:Ne(this,m,"f").toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:Ne(this,m,"f").toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,I,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let l;this.m?l=this.m:l=(0,k.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=O.b.get(this.o.id));const a=R.MarkdownString.fromStrict(this.l);Ne(this,I,"f").$setEntry(this.c,g,l,this.k,a,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}I=new WeakMap,m=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class y{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const l={message:g};return this.b.unshift(l),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(l);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(g,l){this.a=g.getProxy(P.MainContext.MainThreadStatusBar),this.b=l,this.c=new y(this)}createStatusBarEntry(g,l,t,a){return new O(this.a,this.b,g,l,t,a)}setStatusBarMessage(g,l){const t=this.c.setMessage(g);let a;return typeof l=="number"?a=setTimeout(()=>t.dispose(),l):typeof l<"u"&&l.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=h}),define(Ae[81],Re([1,0,5,4,3]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,I){this.c=I,this.b=new P.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,I){this.a.$registerExtensionStorageKeysToSync(A,I)}async initializeExtensionStorage(A,I,m){const O=await this.a.$initializeExtensionStorage(A,I);let y;return O&&(y=this.d(A,I,O)),y||m}setValue(A,I,m){return this.a.$setValue(A,I,m)}$acceptValue(A,I,m){const O=this.d(A,I,m);O&&this.b.fire({shared:A,key:I,value:O})}d(A,I,m){try{return JSON.parse(m)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${I}, global: ${A}): ${O}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Ae[82],Re([1,0,3,27,14,61,2]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=class{constructor(m,O,y){this.d=O,this.f=y,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(m){return R.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,O=await this.g(m);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(m){if(this.c)return R.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return R.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([je(0,P.IExtHostInitDataService),je(1,k.ILogService),je(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ae[62],Re([1,0,4,5,3,2,18,6,7,151,9,177,21,35,178,39,10,17,8]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class S{constructor(r,c,v,D){this.k=r,this._id=c,this.l=v,this.m=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(H=>this.f=H);const w=this;this.value={get name(){return w.m||""},get processId(){return w.b},get creationOptions(){return w.l},get exitStatus(){return w.h},get state(){return w.j},sendText(H,X=!0){w.o(),w.k.$sendText(w._id,H,X)},show(H){w.o(),w.k.$show(w._id,H)},hide(){w.o(),w.k.$hide(w._id)},dispose(){w.a||(w.a=!0,w.k.$dispose(w._id))},get dimensions(){if(!(w.d===void 0||w.g===void 0))return{columns:w.d,rows:w.g}}}}async create(r,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:(0,t.withNullAsUndefined)(r.shellPath),shellArgs:(0,t.withNullAsUndefined)(r.shellArgs),cwd:(0,t.withNullAsUndefined)(r.cwd),env:(0,t.withNullAsUndefined)(r.env),icon:(0,t.withNullAsUndefined)(o(r.iconPath)),color:l.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,t.withNullAsUndefined)(r.message),strictEnv:(0,t.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this.n(r.location,c?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,c,v,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:l.ThemeColor.isThemeColor(D)?D.id:void 0,location:this.n(r,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,c){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in r?{viewColumn:d.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,c){this.h=Object.freeze({code:r,reason:c})}setDimensions(r,c){return r===this.d&&c===this.g||r===0||c===0?!1:(this.d=r,this.g=c,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(c=>{c!==r&&(this.b=Promise.resolve(r))})}}e.ExtHostTerminal=S;class T{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${c}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,c){this.g.setDimensions?.({columns:r,rows:c})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this.g.onDidWrite(c=>this.a.fire(c)),this.g.onDidClose?.((c=void 0)=>{this.f.fire(c===void 0?void 0:c)}),this.g.onDidOverrideDimensions?.(c=>{c&&this.d.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this.g.onDidChangeName?.(c=>{this.d.fire({type:"title",value:c})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:""})}}let p=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}get onDidWriteTerminalData(){return this.I.event}constructor(r,c){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=c.getProxy(P.MainContext.MainThreadTerminalService),this.s=new g.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[v,D]of this.g)D.shutdown(!0)}})}getDefaultShell(r){return(r?this.n:this.m)?.path||""}getDefaultShellArgs(r){return(r?this.n:this.m)?.args||[]}createExtensionTerminal(r,c){const v=new S(this.a,(0,E.generateUuid)(),r,r.name),D=new T(r.pty);return v.createExtensionTerminal(r.location,this.L(r,c).resolvedExtHostIdentifier,o(r.iconPath),f(r.color)).then(w=>{const H=this.M(w,D);this.h[w]=H}),this.f.push(v),v.value}L(r,c){if(c=c||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const D=this.f.find(w=>w.value===v);D&&(c.resolvedExtHostIdentifier=D._id)}}else r.location&&typeof r.location!="object"?c.location=r.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(r,c){if(!this.O(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const D=new T(c),w=this.M(r,D);this.h[r]=w}async $acceptActiveTerminalChanged(r){const c=this.b;if(r===null){this.b=void 0,c!==this.b&&this.F.fire(this.b);return}const v=this.O(r);v&&(this.b=v,c!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,c){const v=this.O(r);v&&this.I.fire({terminal:v.value,data:c})}async $acceptTerminalDimensions(r,c,v){const D=this.O(r);D&&D.setDimensions(c,v)&&this.G.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(r,c,v){this.g.get(r)?.resize(c,v)}async $acceptTerminalTitleChange(r,c){const v=this.O(r);v&&(v.name=c)}async $acceptTerminalClosed(r,c,v){const D=this.Q(this.f,r);if(D!==null){const w=this.f.splice(D,1)[0];w.setExitStatus(c,v),this.C.fire(w.value)}}$acceptTerminalOpened(r,c,v,D){if(c){const X=this.Q(this.f,c);if(X!==null){this.f[X]._id=r,this.D.fire(this.terminals[X]),this.f[X].isOpen=!0;return}}const w={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:M.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},H=new S(this.a,r,w,v);this.f.push(H),this.D.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(r,c){this.O(r)?._setProcessId(c)}async $startExtensionTerminal(r,c){const v=this.O(r);if(!v)return{message:(0,m.localize)(0,null,r)};v.isOpen||await new Promise(w=>{const H=this.onDidOpenTerminal(async X=>{X===v.value&&(H.dispose(),w())})});const D=this.g.get(r);D?D.startSendingEvents(c):this.j[r]={initialDimensions:c}}M(r,c){const v=new A.DisposableStore;v.add(c.onProcessReady(w=>this.a.$sendProcessReady(r,w.pid,w.cwd))),v.add(c.onDidChangeProperty(w=>this.a.$sendProcessProperty(r,w))),this.s.startBuffering(r,c.onProcessData),v.add(c.onProcessExit(w=>this.N(r,w))),this.g.set(r,c);const D=this.j[r];return D&&c instanceof T&&(c.startSendingEvents(D.initialDimensions),delete this.j[r]),v}$acceptProcessAckDataEvent(r,c){this.g.get(r)?.acknowledgeDataEvent(c)}$acceptProcessInput(r,c){this.g.get(r)?.input(c)}$acceptTerminalInteraction(r){const c=this.O(r);c?.setInteractedWith()&&this.H.fire(c.value)}$acceptProcessResize(r,c,v){try{this.g.get(r)?.resize(c,v)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(r,c){this.g.get(r)?.shutdown(c)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(c=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(c=>this.a.$sendProcessProperty(r,{type:"cwd",value:c}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.u.add(r),this.u.size===1&&this.a.$startLinkProvider(),new I.Disposable(()=>{this.u.delete(r),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,c,v){if(this.v.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this.v.set(c,v),this.a.$registerProfileProvider(c,r.identifier.value),new I.Disposable(()=>{this.v.delete(c),this.a.$unregisterProfileProvider(c)})}registerTerminalQuickFixProvider(r,c,v){if(this.w.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.w.set(r,v),this.a.$registerQuickFixProvider(r,c),new I.Disposable(()=>{this.w.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,c){const v=new h.CancellationTokenSource().token;if(v.isCancellationRequested)return;const D=this.w.get(r);if(!D)return;const w=await D.provideTerminalQuickFixes(c,v);if(w!==null)return w}async $createContributedProfileTerminal(r,c){const v=new h.CancellationTokenSource().token;let D=await this.v.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,c);return}this.createTerminalFromOptions(D.options,c)}}async $provideLinks(r,c){const v=this.O(r);if(!v)return[];this.y.delete(r),this.z.get(r)?.dispose(!0);const w=new h.CancellationTokenSource;this.z.set(r,w);const H=[],X={terminal:v.value,line:c},J=[];for(const B of this.u)J.push(a.Promises.withAsyncBody(async $=>{w.token.onCancellationRequested(()=>$({provider:B,links:[]}));const W=await B.provideTerminalLinks(X,w.token)||[];w.token.isCancellationRequested||$({provider:B,links:W})}));const G=await Promise.all(J);if(w.token.isCancellationRequested)return[];const U=new Map;for(const B of G)B&&B.links.length>0&&H.push(...B.links.map($=>{const W={id:p++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return U.set(W.id,{provider:B.provider,link:$}),W}));return this.y.set(r,U),H}$activateLink(r,c){const v=this.y.get(r)?.get(c);!v||v.provider.handleTerminalLink(v.link)}N(r,c){this.s.stopBuffering(r),this.g.delete(r),delete this.j[r];const v=this.h[r];v&&(v.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,c)}O(r){return this.P(this.f,r)}P(r,c){const v=this.Q(r,c);return v!==null?r[v]:null}Q(r,c){let v=null;return r.some((D,w)=>D._id===c?(v=w,!0):!1),v}getEnvironmentVariableCollection(r){let c=this.l.get(r.identifier.value);return c||(c=new u,this.S(r.identifier.value,c)),c}R(r,c){const v=(0,y.serializeEnvironmentVariableCollection)(c.map);this.a.$setEnvironmentVariableCollection(r,c.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(r){r.forEach(c=>{const v=c[0],D=new u(c[1]);this.S(v,D)})}$acceptDefaultProfile(r,c){const v=this.m;this.m=r,this.n=c,v?.path!==r.path&&this.J.fire(r.path)}S(r,c){this.l.set(r,c),c.onDidChangeCollection(()=>{this.R(r,c)})}};i=qe([je(1,R.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class u{get persistent(){return this.a}set persistent(r){this.a=r,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(r){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,c){this.d(r,{value:c,type:I.EnvironmentVariableMutatorType.Replace})}append(r,c){this.d(r,{value:c,type:I.EnvironmentVariableMutatorType.Append})}prepend(r,c){this.d(r,{value:c,type:I.EnvironmentVariableMutatorType.Prepend})}d(r,c){const v=this.map.get(r);(!v||v.value!==c.value||v.type!==c.type)&&(this.map.set(r,c),this.b.fire())}get(r){return this.map.get(r)}forEach(r,c){this.map.forEach((v,D)=>r.call(c,D,v,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(r){super(!1,r)}createTerminal(r,c,v){throw new O.NotSupportedError}createTerminalFromOptions(r,c){throw new O.NotSupportedError}};s=qe([je(0,R.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function o(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function f(b){return l.ThemeColor.isThemeColor(b)?b:void 0}});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)},_e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n};define(Ae[241],Re([1,0,16,17,25,21,4,201,91,6,23,10,35,5,18,103,8,7,45,74,56]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T){"use strict";var p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let u=class{constructor(U,B,$){this.j=$,this.c=new R.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(E.MainContext.MainThreadTesting),this.h=new H(this.f),this.g=new b(this.f),B.registerArgumentProcessor({processArgument:W=>{if(W?.$mid!==15)return W;const x=W,fe=x.tests[x.tests.length-1].item.extId;return this.d.get(d.TestId.root(fe))?.collection.tree.get(fe)?.actual??(0,l.toItemFromContext)(W)}})}createTestController(U,B,$,W){if(this.d.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const x=new m.DisposableStore,fe=x.add(new l.ExtHostTestItemCollection(B,$,this.j));fe.root.label=$;const Se=new Map,ie=this.f,ue={items:fe.root.children,get label(){return $},set label(Te){$=Te,fe.root.label=Te,ie.$updateController(B,{label:$})},get refreshHandler(){return W},set refreshHandler(Te){W=Te,ie.$updateController(B,{canRefresh:!!Te})},get id(){return B},createRunProfile:(Te,de,ae,j,F,Q)=>{let pe=(0,I.hash)(Te);for(;Se.has(pe);)pe++;return new X(this.f,Se,B,pe,Te,de,ae,j,F,Q)},createTestItem(Te,de,ae){return new l.TestItemImpl(B,Te,de,ae)},createTestRun:(Te,de,ae=!0)=>this.g.createTestRun(B,fe,Te,de,ae),set resolveHandler(Te){fe.resolveHandler=Te},get resolveHandler(){return fe.resolveHandler},dispose:()=>{x.dispose()}};ie.$registerTestController(B,$,!!W),x.add((0,m.toDisposable)(()=>ie.$unregisterTestController(B)));const ce={controller:ue,collection:fe,profiles:Se};return this.d.set(B,ce),x.add((0,m.toDisposable)(()=>this.d.delete(B))),x.add(fe.onDidGenerateDiff(Te=>ie.$publishDiff(B,Te.map(T.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.h.checkout()}async runTests(U,B=M.CancellationToken.None){const $=r(U);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.d.get($.controllerId);if(!W)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(x=>d.TestId.fromExtHostTestItem(x,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:J[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:U.exclude?.map(x=>x.id)},B)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,$){return(0,n.mapFind)(this.g.trackers,x=>x.id===U?x.getCoverage(B):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(U,B,$,W){return(0,n.mapFind)(this.g.trackers,fe=>fe.id===U?fe.getCoverage(B):void 0)?.resolveFileCoverage($,W)??Promise.resolve([])}$configureRunProfile(U,B){this.d.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.d.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,O.deepFreeze)(t.TestResults.to(B))).concat(this.results).sort((B,$)=>$.completedAt-B.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,B){const $=this.d.get(d.TestId.fromString(U).controllerId)?.collection;$&&(await $.expand(U,B<0?1/0:B),$.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(T.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map($=>this.k($,!1,B)))}async $startContinuousRun(U,B){const $=new M.CancellationTokenSource(B),W=await Promise.all(U.map(x=>this.k(x,!0,$.token)));return!B.isCancellationRequested&&!W.some(x=>x.error)&&await new Promise(x=>B.onCancellationRequested(x)),$.dispose(!0),W}async k(U,B,$){const W=this.d.get(U.controllerId);if(!W)return{};const{collection:x,profiles:fe}=W,Se=fe.get(U.profileId);if(!Se)return{};const ie=U.testIds.map(de=>x.tree.get(de)).filter(y.isDefined),ue=U.excludeExtIds.map(de=>W.collection.tree.get(de)).filter(y.isDefined).filter(de=>ie.some(ae=>ae.fullId.compare(de.fullId)===2));if(!ie.length)return{};const ce=new a.TestRunRequest(ie.some(de=>de.actual instanceof l.TestItemRootImpl)?void 0:ie.map(de=>de.actual),ue.map(de=>de.actual),Se,B),Te=(0,T.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ce,c.fromInternal(U,W.collection),$);try{return await Se.runHandler(ce,$),{}}catch(de){return{error:String(de)}}finally{Te&&(Te.hasRunningTasks&&!$.isCancellationRequested&&await R.Event.toPromise(Te.onEnd),Te.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};u=qe([je(0,g.IExtHostRpcService)],u),e.ExtHostTesting=u;const s=1e4;var o;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(o||(o={}));class f extends m.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,B,$){super(),this.k=U,this.l=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource($));const W=this.B(new P.RunOnceScheduler(()=>this.m(),s));this.B(this.h.token.onCancellationRequested(()=>W.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const B=this.k.id,$=this.k.controllerId,W=(0,h.generateUuid)(),x=new v(this.l,B,W),fe=ce=>(Te,...de)=>{if(ie){console.warn(`Setting the state of test "${Te.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Te)||(this.s(Te),ce(Te,...de))},Se=(ce,Te)=>{const de=Te instanceof Array?Te.map(t.TestMessage.from):[t.TestMessage.from(Te)];if(ce.uri&&ce.range){const ae={range:t.Range.from(ce.range),uri:ce.uri};for(const j of de)j.location=j.location||ae}this.l.$appendTestMessagesInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),de)};let ie=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return x.coverageProvider},set coverageProvider(ce){x.coverageProvider=ce},enqueued:fe(ce=>{this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),1)}),skipped:fe(ce=>{this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),5)}),started:fe(ce=>{this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),2)}),errored:fe((ce,Te,de)=>{Se(ce,Te),this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),6,de)}),failed:fe((ce,Te,de)=>{Se(ce,Te),this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,$).toString(),4,de)}),passed:fe((ce,Te)=>{this.l.$updateTestStateInRun(B,W,d.TestId.fromExtHostTestItem(ce,this.k.controllerId).toString(),3,Te)}),appendOutput:(ce,Te,de)=>{ie||(de&&(this.k.isIncluded(de)?this.s(de):de=void 0),this.l.$appendOutputToRun(B,W,k.VSBuffer.fromString(ce),Te&&t.location.from(Te),de&&d.TestId.fromExtHostTestItem(de,$).toString()))},end:()=>{ie||(ie=!0,this.l.$finishedTestRunTask(B,W),this.f.delete(W),this.f.size||this.p())}};return this.f.set(W,{run:ue,coverage:x}),this.l.$startedTestRunTask(B,{id:W,name:U,running:!0}),ue}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof l.TestItemImpl))throw new S.InvalidTestItemError(U.id);if(this.g.has(d.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const B=[],$=this.k.colllection.root;for(;;){const W=t.TestItem.from(U);if(B.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===$))break;U=U.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,B)}}class b{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,B,$){return this.f(U,B,$)}cancelRunById(U){for(const B of this.c.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,B,$,W,x){const fe=this.c.get($);if(fe)return fe.createRun(W);const Se=c.fromPublic(U,B,$,x),ie=r($);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!$.continuous,profile:ie&&{group:J[ie.kind],id:ie.profileId},exclude:$.exclude?.map(ce=>d.TestId.fromExtHostTestItem(ce,B.root.id).toString())??[],id:Se.id,include:$.include?.map(ce=>d.TestId.fromExtHostTestItem(ce,B.root.id).toString())??[B.root.id],persist:x});const ue=this.f($,Se);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(Se.id),ue.dispose()}),ue.createRun(W)}f(U,B,$){const W=new f(B,this.d,$);return this.c.set(U,W),W.onEnd(()=>this.c.delete(U)),W}}e.TestRunCoordinator=b;const r=G=>{if(!!G.profile){if(!(G.profile instanceof X))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class c{static fromPublic(U,B,$,W){return new c(U,(0,h.generateUuid)(),$.include?.map(x=>d.TestId.fromExtHostTestItem(x,U).toString())??[U],$.exclude?.map(x=>d.TestId.fromExtHostTestItem(x,U).toString())??[],W,B)}static fromInternal(U,B){return new c(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,$,W,x,fe){this.controllerId=U,this.id=B,this.isPersisted=x,this.colllection=fe,this.c=$.map(Se=>Se+"\0"),this.d=W.map(Se=>Se+"\0")}isIncluded(U){const B=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const $ of this.d)if(B===$||B.startsWith($))return!1;for(const $ of this.c)if(B===$||B.startsWith($))return!0;return!1}}e.TestRunDto=c;class v{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,B,$){this.f=U,this.g=B,this.h=$}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.d=void 0,B}}async resolveFileCoverage(U,B){const $=await this.d;let W=$?.[U];return!this.c||!$||!W?[]:(W.detailedCoverage||(W=$[U]=await this.c.resolveFileCoverage?.(W,B)??W),W.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const B=d.TestId.parentId(U.item.extId);if(B&&this.g.has(B.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:B,f:$}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...B].map(W=>W.revived)},get removed(){return[...$].map(W=>W.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends T.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new R.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}o(){return new D(this.q)}}class H{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class X{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ne(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,$,W,x,fe,Se,ie=!1,ue=void 0,ce=!1){this.controllerId=$,this.profileId=W,this.d=x,this.kind=fe,this.runHandler=Se,this.f=ie,this._tag=ue,this.g=ce,p.set(this,void 0),i.set(this,void 0),_e(this,p,U,"f"),_e(this,i,B,"f"),B.set(W,this);const Te=J[fe];if(typeof Te!="number")throw new Error(`Unknown TestRunProfile.group ${fe}`);Ne(this,p,"f").$publishTestRunProfile({profileId:W,controllerId:$,tag:ue?t.TestTag.namespace(this.controllerId,ue.id):null,label:x,group:Te,isDefault:ie,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){Ne(this,i,"f")?.delete(this.profileId)&&(_e(this,i,void 0,"f"),Ne(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=X,p=new WeakMap,i=new WeakMap;const J={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ae[242],Re([1,0,16,9,4,5,104,8,7]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class m{constructor(y,h){this.i=h,this.a=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.b=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.c=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.d=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.f=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.g=new k.Emitter({onListenerError:P.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=y.getProxy(M.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(y){const h=this.i.allEditors();return y?h:h.map(E=>E.value)}async showTextDocument(y,h,E){let g;typeof h=="number"?g={position:A.ViewColumn.from(h),preserveFocus:E}:typeof h=="object"?g={position:A.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?A.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const l=await this.h.$tryShowTextDocument(y.uri,g),t=l&&this.i.getEditor(l);if(t)return t.value;throw l?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,h){return new R.TextEditorDecorationType(this.h,y,h).value}$acceptEditorPropertiesChanged(y,h){const E=this.i.getEditor(y);if(!E)throw new Error("unknown text editor");if(h.options&&E._acceptOptions(h.options),h.selections){const g=h.selections.selections.map(A.Selection.to);E._acceptSelections(g)}if(h.visibleRanges){const g=n.coalesce(h.visibleRanges.map(A.Range.to));E._acceptVisibleRanges(g)}if(h.options&&this.b.fire({textEditor:E.value,options:{...h.options,lineNumbers:A.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const g=I.TextEditorSelectionChangeKind.fromValue(h.selections.source),l=h.selections.selections.map(A.Selection.to);this.a.fire({textEditor:E.value,selections:l,kind:g})}if(h.visibleRanges){const g=n.coalesce(h.visibleRanges.map(A.Range.to));this.c.fire({textEditor:E.value,visibleRanges:g})}}$acceptEditorPositionData(y){for(const h in y){const E=this.i.getEditor(h);if(!E)throw new Error("Unknown text editor");const g=A.ViewColumn.to(y[h]);E.value.viewColumn!==g&&(E._acceptViewColumn(g),this.d.fire({textEditor:E.value,viewColumn:g}))}}getDiffInformation(y){return Promise.resolve(this.h.$getDiffInformation(y))}}e.ExtHostEditors=m}),define(Ae[243],Re([1,0,2,3,5,6,7,8,24,10]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class O{constructor(E,g){this.b=new Map,this.c=new Map,this.a=E.getProxy(k.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(l,t)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&I.ExtensionIdentifier.equals(t,this.b.get(l.source)?.extension)){const a=l.uri===void 0?void 0:n.URI.revive(l.uri);return this.c.get(l.source)?.get(y(a))?.get(l.handle)}else return;return l}})}async $getTimeline(E,g,l,t){return this.b.get(E)?.provider.provideTimeline(n.URI.revive(g),l,t)}registerTimelineProvider(E,g,l,t){const a=new M.DisposableStore,d=this.d(g.id,t,a).bind(this);let S;g.onDidChange&&(S=g.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const T=this.c;return this.f({...g,scheme:E,onDidChange:void 0,async provideTimeline(p,i,u){i?.resetCache&&(a.clear(),T.get(g.id)?.clear());const s=await g.provideTimeline(p,i,u);if(s==null)return;const o=d(p,i);return{...s,source:g.id,items:s.items.map(o)}},dispose(){for(const p of T.values())p.get(g.id)?.clear();S?.dispose(),a.dispose()}},l)}d(E,g,l){return(t,a)=>{let d;if(a?.cacheResults){let S=this.c.get(E);S===void 0&&(S=new Map,this.c.set(E,S));const T=y(t);d=S.get(T),d===void 0&&(d=new Map,S.set(T,d))}return S=>{const{iconPath:T,...p}=S,i=`${E}|${S.id??S.timestamp}`;d?.set(i,S);let u,s,o;S.iconPath&&(T instanceof R.ThemeIcon?o={id:T.id,color:T.color}:n.URI.isUri(T)?(u=T,s=T):{light:u,dark:s}=T);let f;return R.MarkdownString.isMarkdownString(p.tooltip)?f=A.MarkdownString.from(p.tooltip):(0,m.isString)(p.tooltip)?f=p.tooltip:R.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=A.MarkdownString.from(p.detail)):(0,m.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=p.detail),{...p,id:p.id??void 0,handle:i,source:E,command:S.command?g.toInternal(S.command,l):void 0,icon:u,iconDark:s,themeIcon:o,tooltip:f,accessibilityInformation:S.accessibilityInformation}}}}f(E,g){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:g}),(0,M.toDisposable)(()=>{for(const t of this.c.values())t.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=O;function y(h){return h?.toString()}}),define(Ae[244],Re([1,0,6,15,2,5]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(I){this.c=new Map,this.b=I.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(I,m,O,y){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const h=y.schemes.find(E=>!R.a.has(E));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(m,O),this.b.$registerUriOpener(m,y.schemes,I,y.label),(0,n.toDisposable)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(I,m,O){const y=this.c.get(I);if(!y)throw new Error(`Unknown opener with id: ${I}`);const h=k.URI.revive(m);return y.canOpenExternalUri(h,O)}async $openUri(I,m,O){const y=this.c.get(I);if(!y)throw new Error(`Unknown opener id: '${I}'`);return y.openExternalUri(k.URI.revive(m.resolvedUri),{sourceUri:k.URI.revive(m.sourceUri)},O)}}R.a=new Set([P.Schemas.http,P.Schemas.https]),e.ExtHostUriOpeners=R}),define(Ae[245],Re([1,0,5,2,6,9,24]),function(ee,e,n,P,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(m){this.c=new R.ExtensionIdentifierSet,this.d=new Map,this.b=m.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(m,O){if(this.c.has(m))throw new Error(`Protocol handler already registered for extension ${m}`);const y=A.a++;return this.c.add(m),this.d.set(y,O),this.b.$registerUriHandler(y,m),(0,k.toDisposable)(()=>{this.c.delete(m),this.d.delete(y),this.b.$unregisterUriHandler(y)})}$handleExternalUri(m,O){const y=this.d.get(m);if(!y)return Promise.resolve(void 0);try{y.handleUri(P.URI.revive(O))}catch(h){(0,M.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(m){return P.URI.revive(await this.b.$createAppUri(m))}}A.a=0,e.ExtHostUrls=A});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[63],Re([1,0,4,15,23,2,164,187,75,5]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";var O,y,h,E,g,l,t,a,d,S,T,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(w,H,X,J,G,U,B){O.set(this,void 0),y.set(this,void 0),h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),l.set(this,void 0),t.set(this,""),a.set(this,void 0),d.set(this,!1),S.set(this,!1),T.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Ne(this,i,"f").event,_e(this,O,w,"f"),_e(this,y,H,"f"),_e(this,a,X,"f"),_e(this,E,J,"f"),_e(this,g,G,"f"),_e(this,l,U,"f"),_e(this,T,s(U),"f"),_e(this,p,o(U),"f"),_e(this,h,B,"f")}dispose(){_e(this,d,!0,"f"),Ne(this,i,"f").fire(),Ne(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return _e(this,S,!0,"f"),(0,I.asWebviewUri)(w,Ne(this,E,"f"))}get cspSource(){const w=Ne(this,l,"f").extensionLocation;if(w.scheme===P.Schemas.https||w.scheme===P.Schemas.http){let H=w.toString();return H.endsWith("/")||(H+="/"),H+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.a(),Ne(this,t,"f")}set html(w){this.a(),Ne(this,t,"f")!==w&&(_e(this,t,w,"f"),Ne(this,p,"f")&&!Ne(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(_e(this,S,!0,"f"),Ne(this,h,"f").report("Webview vscode-resource: uris",Ne(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,y,"f").$setHtml(Ne(this,O,"f"),this.b(w)))}get options(){return this.a(),Ne(this,a,"f")}set options(w){this.a(),k.equals(Ne(this,a,"f"),w)||Ne(this,y,"f").$setOptions(Ne(this,O,"f"),r(Ne(this,l,"f"),Ne(this,g,"f"),w)),_e(this,a,w,"f")}async postMessage(w){if(Ne(this,d,"f"))return!1;const H=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ne(this,T,"f")});return Ne(this,y,"f").$postMessage(Ne(this,O,"f"),H.message,...H.buffers)}a(){if(Ne(this,d,"f"))throw new Error("Webview is disposed")}b(w){if(!Ne(this,p,"f"))return w;const H=Ne(this,l,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,X=Ne(this,l,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ne(this,l,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,G,U,B,$,W)=>{const x=M.URI.from({scheme:B||"file",path:decodeURIComponent($)}),fe=(0,I.asWebviewUri)(x,{isRemote:H,authority:X}).toString();return`${G}${fe}${W}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,G,U,B,$,W)=>{const x=M.URI.from({scheme:B||"file",path:decodeURIComponent($)}),fe=(0,I.asWebviewUri)(x,{isRemote:H,authority:X}).toString();return`${G}${fe}${W}`})}}e.ExtHostWebview=u,O=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,l=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap,S=new WeakMap,T=new WeakMap,p=new WeakMap,i=new WeakMap;function s(D){try{const w=(0,R.normalizeVersion)((0,R.parseVersion)(D.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function o(D){try{const w=(0,R.normalizeVersion)((0,R.parseVersion)(D.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class f{constructor(w,H,X,J,G){this.c=H,this.d=X,this.e=J,this.f=G,this.b=new Map,this.a=w.getProxy(m.MainContext.MainThreadWebviews)}$onMessage(w,H,X){const J=this.g(w);if(J){const{message:G}=(0,A.deserializeWebviewMessage)(H,X.value);J._onMessageEmitter.fire(G)}}$onMissingCsp(w,H){this.e.warn(`${H} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,H,X){const J=new u(w,this.a,c(H),this.c,this.d,X,this.f);return this.b.set(w,J),J._onDidDispose(()=>{this.b.delete(w)}),J}deleteWebview(w){this.b.delete(w)}g(w){return this.b.get(w)}}e.ExtHostWebviews=f;function b(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=b;function r(D,w,H){return{enableCommandUris:H.enableCommandUris,enableScripts:H.enableScripts,enableForms:H.enableForms,portMapping:H.portMapping,localResourceRoots:H.localResourceRoots||v(D,w)}}e.serializeWebviewOptions=r;function c(D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots?.map(w=>M.URI.from(w))}}function v(D,w){return[...(w?.getWorkspaceFolders()||[]).map(H=>H.uri),D.extensionLocation]}}),define(Ae[246],Re([1,0,21,91,6,15,22,2,8,63,54,5,7]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(u,s){this.document=u,this.b=s,this.a=1,this.c=new O.Cache("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,s){await this.f(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.f(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=p(this.document.uri)+this.a++;return(0,R.joinPath)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const s=this.c.get(u,0);if(!s)throw new Error("No edit found");return s}}class g{constructor(){this.a=new Map}get(u,s){return this.a.get(this.b(u,s))}add(u,s,o){const f=this.b(u,s.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const b=new E(s,o);return this.a.set(f,b),b}delete(u,s){const o=this.b(u,s.uri);this.a.delete(o)}b(u,s){return`${u}@@@${s}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class t{constructor(){this.a=new Map}addTextProvider(u,s,o){return this.b(0,u,s,o)}addCustomProvider(u,s,o){return this.b(1,u,s,o)}get(u){return this.a.get(u)}b(u,s,o,f){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:u,extension:o,provider:f}),new h.Disposable(()=>this.a.delete(s))}}class a{constructor(u,s,o,f,b){this.d=s,this.f=o,this.g=f,this.h=b,this.b=new t,this.c=new g,this.a=u.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,o,f){const b=new k.DisposableStore;return S(o)?(b.add(this.b.addTextProvider(s,u,o)),this.a.$registerTextEditorProvider((0,m.toExtensionData)(u),s,f.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,m.shouldSerializeBuffersForPostMessage)(u))):(b.add(this.b.addCustomProvider(s,u,o)),d(o)&&b.add(o.onDidChangeCustomDocument(r=>{const c=this.i(s,r.document.uri);if(T(r)){const v=c.addEdit(r);this.a.$onDidEdit(r.document.uri,s,v,r.label)}else this.a.$onContentChange(r.document.uri,s)})),this.a.$registerCustomEditorProvider((0,m.toExtensionData)(u),s,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,m.shouldSerializeBuffersForPostMessage)(u))),h.Disposable.from(b,new h.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,o,f,b){const r=this.b.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${s}'`);const c=A.URI.revive(u),v=await r.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:f?.buffer},b);let D;return d(r.provider)&&this.f&&(D=this.f.workspaceValue(r.extension)??this.f.globalValue(r.extension)),this.c.add(s,v,D),{editable:d(r.provider)}}async $disposeCustomDocument(u,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const f=A.URI.revive(u),{document:b}=this.i(s,f);this.c.delete(s,b),b.dispose()}async $resolveCustomEditor(u,s,o,f,b,r){const c=this.b.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const v=I.ViewColumn.to(b),D=this.g.createNewWebview(s,f.contentOptions,c.extension),w=this.h.createNewWebviewPanel(s,o,f.title,v,f.options,D,!0),H=A.URI.revive(u);switch(c.type){case 1:{const{document:X}=this.i(o,H);return c.provider.resolveCustomEditor(X,w,r)}case 0:{const X=this.d.getDocument(H);return c.provider.resolveCustomTextEditor(X,w,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,o){this.i(s,u).disposeEdits(o)}async $onMoveCustomEditor(u,s,o){const f=this.b.get(o);if(!f)throw new Error(`No provider found for '${o}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this.h.getWebviewPanel(u);if(!b)throw new Error("No webview found");const r=A.URI.revive(s),c=this.d.getDocument(r);await f.provider.moveCustomTextEditor(c,b,n.CancellationToken.None)}async $undo(u,s,o,f){return this.i(s,u).undo(o,f)}async $redo(u,s,o,f){return this.i(s,u).redo(o,f)}async $revert(u,s,o){const f=this.i(s,u);await this.j(s).revertCustomDocument(f.document,o),f.disposeBackup()}async $onSave(u,s,o){const f=this.i(s,u);await this.j(s).saveCustomDocument(f.document,o),f.disposeBackup()}async $onSaveAs(u,s,o,f){const b=this.i(s,u);return this.j(s).saveCustomDocumentAs(b.document,A.URI.revive(o),f)}async $backup(u,s,o){const f=this.i(s,u),r=await this.j(s).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},o);return f.updateBackup(r),r.id}i(u,s){const o=this.c.get(u,A.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(u){const o=this.b.get(u)?.provider;if(!o||!d(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=a;function d(i){return!!i.onDidChangeCustomDocument}function S(i){return typeof i.resolveCustomTextEditor=="function"}function T(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const u=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,P.hash)(u)+""}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[247],Re([1,0,4,6,2,35,8,63,5,7]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";var O,y,h,E,g,l,t,a,d,S,T,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends P.Disposable{constructor(b,r,c,v){super(),O.set(this,void 0),y.set(this,void 0),h.set(this,void 0),E.set(this,void 0),g.set(this,void 0),l.set(this,void 0),t.set(this,void 0),a.set(this,void 0),d.set(this,!0),S.set(this,void 0),T.set(this,!1),p.set(this,this.B(new n.Emitter)),this.onDidDispose=Ne(this,p,"f").event,i.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Ne(this,i,"f").event,_e(this,O,b,"f"),_e(this,y,r,"f"),_e(this,E,c,"f"),_e(this,h,v.viewType,"f"),_e(this,g,v.panelOptions,"f"),_e(this,a,v.viewColumn,"f"),_e(this,l,v.title,"f"),_e(this,S,v.active,"f")}dispose(){Ne(this,T,"f")||(_e(this,T,!0,"f"),Ne(this,p,"f").fire(),Ne(this,y,"f").$disposeWebview(Ne(this,O,"f")),Ne(this,E,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,E,"f")}get viewType(){return this.c(),Ne(this,h,"f")}get title(){return this.c(),Ne(this,l,"f")}set title(b){this.c(),Ne(this,l,"f")!==b&&(_e(this,l,b,"f"),Ne(this,y,"f").$setTitle(Ne(this,O,"f"),b))}get iconPath(){return this.c(),Ne(this,t,"f")}set iconPath(b){this.c(),Ne(this,t,"f")!==b&&(_e(this,t,b,"f"),Ne(this,y,"f").$setIconPath(Ne(this,O,"f"),k.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return Ne(this,g,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,a,"f")=="number"&&Ne(this,a,"f")<0))return Ne(this,a,"f")}get active(){return this.c(),Ne(this,S,"f")}get visible(){return this.c(),Ne(this,d,"f")}_updateViewState(b){Ne(this,T,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(_e(this,S,b.active,"f"),_e(this,d,b.visible,"f"),_e(this,a,b.viewColumn,"f"),Ne(this,i,"f").fire({webviewPanel:this}))}reveal(b,r){this.c(),Ne(this,y,"f").$reveal(Ne(this,O,"f"),{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!r})}c(){if(Ne(this,T,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,l=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap,S=new WeakMap,T=new WeakMap,p=new WeakMap,i=new WeakMap;class s{static c(){return(0,M.generateUuid)()}constructor(b,r,c){this.g=r,this.h=c,this.e=new Map,this.f=new Map,this.d=b.getProxy(I.MainContext.MainThreadWebviewPanels)}createWebviewPanel(b,r,c,v,D={}){const w=typeof v=="object"?v.viewColumn:v,H={viewColumn:R.ViewColumn.from(w),preserveFocus:typeof v=="object"&&!!v.preserveFocus},X=(0,A.shouldSerializeBuffersForPostMessage)(b),J=s.c();this.d.$createWebviewPanel((0,A.toExtensionData)(b),J,r,{title:c,panelOptions:o(D),webviewOptions:(0,A.serializeWebviewOptions)(b,this.h,D),serializeBuffersForPostMessage:X},H);const G=this.g.createNewWebview(J,D,b);return this.createNewWebviewPanel(J,r,c,w,D,G,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((c,v)=>{const D=b[c],w=b[v];return D.active?1:w.active?-1:+D.visible-+w.visible});for(const c of r){const v=this.getWebviewPanel(c);if(!v)continue;const D=b[c];v._updateViewState({active:D.active,visible:D.visible,viewColumn:R.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.e.delete(b),this.g.deleteWebview(b)}registerWebviewPanelSerializer(b,r,c){if(this.f.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.f.set(r,{serializer:c,extension:b}),this.d.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(b)}),new m.Disposable(()=>{this.f.delete(r),this.d.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,c,v){const D=this.f.get(r);if(!D)throw new Error(`No serializer found for '${r}'`);const{serializer:w,extension:H}=D,X=this.g.createNewWebview(b,c.webviewOptions,H),J=this.createNewWebviewPanel(b,r,c.title,v,c.panelOptions,X,c.active);await w.deserializeWebviewPanel(J,c.state)}createNewWebviewPanel(b,r,c,v,D,w,H){const X=new u(b,this.d,w,{viewType:r,title:c,viewColumn:v,panelOptions:D,active:H});return this.e.set(b,X),X}getWebviewPanel(b){return this.e.get(b)}}e.ExtHostWebviewPanels=s;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[248],Re([1,0,4,6,63,8,5,7]),function(ee,e,n,P,k,M,R,A){"use strict";var I,m,O,y,h,E,g,l,t,a,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends P.Disposable{constructor(i,u,s,o,f,b){super(),I.set(this,void 0),m.set(this,void 0),O.set(this,void 0),y.set(this,void 0),h.set(this,!1),E.set(this,void 0),g.set(this,void 0),l.set(this,void 0),t.set(this,void 0),a.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Ne(this,a,"f").event,d.set(this,this.B(new n.Emitter)),this.onDidDispose=Ne(this,d,"f").event,_e(this,O,s,"f"),_e(this,g,o,"f"),_e(this,I,i,"f"),_e(this,m,u,"f"),_e(this,y,f,"f"),_e(this,E,b,"f")}dispose(){Ne(this,h,"f")||(_e(this,h,!0,"f"),Ne(this,d,"f").fire(),Ne(this,y,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,g,"f")}set title(i){this.a(),Ne(this,g,"f")!==i&&(_e(this,g,i,"f"),Ne(this,m,"f").$setWebviewViewTitle(Ne(this,I,"f"),i))}get description(){return this.a(),Ne(this,l,"f")}set description(i){this.a(),Ne(this,l,"f")!==i&&(_e(this,l,i,"f"),Ne(this,m,"f").$setWebviewViewDescription(Ne(this,I,"f"),i))}get visible(){return Ne(this,E,"f")}get webview(){return Ne(this,y,"f")}get viewType(){return Ne(this,O,"f")}_setVisible(i){i===Ne(this,E,"f")||Ne(this,h,"f")||(_e(this,E,i,"f"),Ne(this,a,"f").fire())}get badge(){return this.a(),Ne(this,t,"f")}set badge(i){this.a(),!(i?.value===Ne(this,t,"f")?.value&&i?.tooltip===Ne(this,t,"f")?.tooltip)&&(_e(this,t,M.ViewBadge.from(i),"f"),Ne(this,m,"f").$setWebviewViewBadge(Ne(this,I,"f"),i))}show(i){this.a(),Ne(this,m,"f").$show(Ne(this,I,"f"),!!i)}a(){if(Ne(this,h,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,m=new WeakMap,O=new WeakMap,y=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,l=new WeakMap,t=new WeakMap,a=new WeakMap,d=new WeakMap;class T{constructor(i,u){this.d=u,this.b=new Map,this.c=new Map,this.a=i.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,s,o){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(i),u,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,s,o,f){const b=this.b.get(u);if(!b)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:c}=b,v=this.d.createNewWebview(i,{},c),D=new S(i,this.a,u,s,v,!0);this.c.set(i,D),await r.resolveWebviewView(D,{state:o},f)}async $onDidChangeWebviewViewVisibility(i,u){this.e(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.e(i);this.c.delete(i),u.dispose(),this.d.deleteWebview(i)}e(i){const u=this.c.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=T}),define(Ae[106],Re([1,0,4,5,2,15,13,3,18]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let m=class fn{get state(){return this.d}constructor(y){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=fn.a,this.b=y.getProxy(P.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(y){y!==this.d.focused&&(this.d={...this.d,focused:y},this.c.fire(this.d))}openUri(y,h){let E;if(typeof y=="string"){E=y;try{y=k.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,E,h)}async asExternalUri(y,h){if((0,R.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this.b.$asExternalUri(y,h);return k.URI.from(E)}};m.a={focused:!0},m=qe([je(0,I.IExtHostRpcService)],m),e.ExtHostWindow=m,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ae[249],Re([1,0,218,27,18]),function(ee,e,n,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(A,I){super(A,I)}f(A,I,m){I.apply(console,m)}};M=qe([je(0,k.IExtHostRpcService),je(1,P.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ae[250],Re([1,0,17,25,21,9,4,6,130,212,46]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(D,w){try{return JSON.stringify(D,w)}catch{return"null"}}const E="$$ref$$",g={[E]:-1};class l{constructor(w,H){this.jsonString=w,this.referencedBuffers=H}}function t(D,w=null,H=!1){const X=[];return{jsonString:(H?h:JSON.stringify)(D,(G,U)=>{if(typeof U>"u")return g;if(typeof U=="object"){if(U instanceof P.VSBuffer){const B=X.push(U)-1;return{[E]:B}}if(w)return w(G,U)}return U}),referencedBuffers:X}}e.stringifyJsonWithBufferRefs=t;function a(D,w,H){return JSON.parse(D,(X,J)=>{if(J){const G=J[E];if(typeof G=="number")return w[G];if(H&&J.$mid===1)return H.transformIncoming(J)}return J})}e.parseJsonAndRestoreBufferRefs=a;function d(D,w){return JSON.stringify(D,w)}function S(D){return D?(w,H)=>H&&H.$mid===1?D.transformOutgoing(H):H:null}var T;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(T=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends A.Disposable{constructor(w,H=null,X=null){super(),this[y]=!0,this.b=this.B(new R.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=H,this.g=X,this.h=S(this.g),this.j=!1,this.k=[],this.l=[];for(let J=0,G=O.ProxyIdentifier.count;J<G;J++)this.k[J]=null,this.l[J]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(J=>this.G(J))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,I.transformIncomingURIs)(w,this.g):w}getProxy(w){const{nid:H,sid:X}=w;return this.l[H]||(this.l[H]=this.F(H,X)),this.l[H]}F(w,H){const X={get:(J,G)=>(typeof G=="string"&&!J[G]&&G.charCodeAt(0)===36&&(J[G]=(...U)=>this.O(w,G,U)),G===s?H:J[G])};return new Proxy(Object.create(null),X)}set(w,H){return this.k[w.nid]=H,H}assertRegistered(w){for(let H=0,X=w.length;H<X;H++){const J=w[H];if(!this.k[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}G(w){if(this.j)return;const H=w.byteLength,X=f.read(w,0),J=X.readUInt8(),G=X.readUInt32();switch(J){case 1:case 2:{let{rpcId:U,method:B,args:$}=r.deserializeRequestJSONArgs(X);this.g&&($=(0,I.transformIncomingURIs)($,this.g)),this.H(H,G,U,B,$,J===2);break}case 3:case 4:{let{rpcId:U,method:B,args:$}=r.deserializeRequestMixedArgs(X);this.g&&($=(0,I.transformIncomingURIs)($,this.g)),this.H(H,G,U,B,$,J===4);break}case 5:{this.f?.logIncoming(H,G,0,"ack"),this.z(G);break}case 6:{this.I(H,G);break}case 7:{this.J(H,G,void 0);break}case 9:{let U=r.deserializeReplyOKJSON(X);this.g&&(U=(0,I.transformIncomingURIs)(U,this.g)),this.J(H,G,U);break}case 10:{const U=r.deserializeReplyOKJSONWithBuffers(X,this.g);this.J(H,G,U);break}case 8:{const U=r.deserializeReplyOKVSBuffer(X);this.J(H,G,U);break}case 11:{let U=r.deserializeReplyErrError(X);this.g&&(U=(0,I.transformIncomingURIs)(U,this.g)),this.L(H,G,U);break}case 12:{this.L(H,G,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,H,X,J,G,U){this.f?.logIncoming(w,H,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(X)}.${J}(`,G);const B=String(H);let $,W;if(U){const fe=new k.CancellationTokenSource;G.push(fe.token),$=this.M(X,J,G),W=()=>fe.cancel()}else $=this.M(X,J,G),W=i;this.p[B]=W;const x=r.serializeAcknowledged(H);this.f?.logOutgoing(x.byteLength,H,1,"ack"),this.c.send(x),$.then(fe=>{delete this.p[B];const Se=r.serializeReplyOK(H,fe,this.h);this.f?.logOutgoing(Se.byteLength,H,1,"reply:",fe),this.c.send(Se)},fe=>{delete this.p[B];const Se=r.serializeReplyErr(H,fe);this.f?.logOutgoing(Se.byteLength,H,1,"replyErr:",fe),this.c.send(Se)})}I(w,H){this.f?.logIncoming(w,H,1,"receiveCancel");const X=String(H);this.p[X]?.()}J(w,H,X){this.f?.logIncoming(w,H,0,"receiveReply:",X);const J=String(H);if(!this.s.hasOwnProperty(J))return;const G=this.s[J];delete this.s[J],G.resolveOk(X)}L(w,H,X){this.f?.logIncoming(w,H,0,"receiveReplyErr:",X);const J=String(H);if(!this.s.hasOwnProperty(J))return;const G=this.s[J];delete this.s[J];let U;X&&(X.$isError?(U=new Error,U.name=X.name,U.message=X.message,U.stack=X.stack):U=X),G.resolveErr(U)}M(w,H,X){try{return Promise.resolve(this.N(w,H,X))}catch(J){return Promise.reject(J)}}N(w,H,X){const J=this.k[w];if(!J)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(w));const G=J[H];if(typeof G!="function")throw new Error("Unknown method "+H+" on actor "+(0,O.getStringIdentifierForProxy)(w));return G.apply(J,X)}O(w,H,X){if(this.j)return new m.CanceledLazyPromise;let J=null;if(X.length>0&&k.CancellationToken.isCancellationToken(X[X.length-1])&&(J=X.pop()),J&&J.isCancellationRequested)return Promise.reject(M.canceled());const G=r.serializeRequestArguments(X,this.h),U=++this.m,B=String(U),$=new m.LazyPromise;J&&J.onCancellationRequested(()=>{const x=r.serializeCancel(U);this.f?.logOutgoing(x.byteLength,U,0,"cancel"),this.c.send(r.serializeCancel(U))}),this.s[B]=$,this.y(U);const W=r.serializeRequest(U,w,H,G,!!J);return this.f?.logOutgoing(W.byteLength,U,0,`request: ${(0,O.getStringIdentifierForProxy)(w)}.${H}(`,X),this.c.send(W),$}}y=u,o.a=3*1e3,e.RPCProtocol=o;class f{static alloc(w,H,X){const J=new f(P.VSBuffer.alloc(X+1+4),0);return J.writeUInt8(w),J.writeUInt32(H),J}static read(w,H){return new f(w,H)}get buffer(){return this.a}constructor(w,H){this.a=w,this.b=H}static sizeUInt8(){return 1}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+w).toString();return this.b+=w,X}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+w).toString();return this.b+=w,X}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+w);return this.b+=w,H}static sizeMixedArray(w){let H=0;H+=1;for(let X=0,J=w.length;X<J;X++){const G=w[X];switch(H+=1,G.type){case 1:H+=this.sizeLongString(G.value);break;case 2:H+=this.sizeVSBuffer(G.value);break;case 3:H+=this.sizeUInt32,H+=this.sizeLongString(G.value);for(let U=0;U<G.buffers.length;++U)H+=this.sizeVSBuffer(G.buffers[U]);break;case 4:break}}return H}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let H=0,X=w.length;H<X;H++){const J=w[H];switch(J.type){case 1:this.writeUInt8(1),this.writeLongString(J.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(J.value);break;case 3:this.writeUInt8(3),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let G=0;G<J.buffers.length;++G)this.writeBuffer(J.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const H=new Array(w);for(let X=0;X<w;X++)switch(this.readUInt8()){case 1:H[X]=this.readLongString();break;case 2:H[X]=this.readVSBuffer();break;case 3:{const G=this.readUInt32(),U=this.readLongString(),B=[];for(let $=0;$<G;++$)B.push(this.readVSBuffer());H[X]=new O.SerializableObjectWithBuffers(a(U,B,null));break}case 4:H[X]=void 0;break}return H}}f.sizeUInt32=4;var b;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(b||(b={}));class r{static a(w){for(let H=0,X=w.length;H<X;H++)if(w[H]instanceof P.VSBuffer||w[H]instanceof O.SerializableObjectWithBuffers||typeof w[H]>"u")return!0;return!1}static serializeRequestArguments(w,H){if(this.a(w)){const X=[];for(let J=0,G=w.length;J<G;J++){const U=w[J];if(U instanceof P.VSBuffer)X[J]={type:2,value:U};else if(typeof U>"u")X[J]={type:4};else if(U instanceof O.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:$}=t(U.value,H);X[J]={type:3,value:P.VSBuffer.fromString(B),buffers:$}}else X[J]={type:1,value:P.VSBuffer.fromString(d(U,H))}}return{type:1,args:X}}return{type:0,args:d(w,H)}}static serializeRequest(w,H,X,J,G){switch(J.type){case 0:return this.b(w,H,X,J.args,G);case 1:return this.c(w,H,X,J.args,G)}}static b(w,H,X,J,G){const U=P.VSBuffer.fromString(X),B=P.VSBuffer.fromString(J);let $=0;$+=f.sizeUInt8(),$+=f.sizeShortString(U),$+=f.sizeLongString(B);const W=f.alloc(G?2:1,w,$);return W.writeUInt8(H),W.writeShortString(U),W.writeLongString(B),W.buffer}static deserializeRequestJSONArgs(w){const H=w.readUInt8(),X=w.readShortString(),J=w.readLongString();return{rpcId:H,method:X,args:JSON.parse(J)}}static c(w,H,X,J,G){const U=P.VSBuffer.fromString(X);let B=0;B+=f.sizeUInt8(),B+=f.sizeShortString(U),B+=f.sizeMixedArray(J);const $=f.alloc(G?4:3,w,B);return $.writeUInt8(H),$.writeShortString(U),$.writeMixedArray(J),$.buffer}static deserializeRequestMixedArgs(w){const H=w.readUInt8(),X=w.readShortString(),J=w.readMixedArray(),G=new Array(J.length);for(let U=0,B=J.length;U<B;U++){const $=J[U];typeof $=="string"?G[U]=JSON.parse($):G[U]=$}return{rpcId:H,method:X,args:G}}static serializeAcknowledged(w){return f.alloc(5,w,0).buffer}static serializeCancel(w){return f.alloc(6,w,0).buffer}static serializeReplyOK(w,H,X){if(typeof H>"u")return this.d(w);if(H instanceof P.VSBuffer)return this.e(w,H);if(H instanceof O.SerializableObjectWithBuffers){const{jsonString:J,referencedBuffers:G}=t(H.value,X,!0);return this.g(w,J,G)}else return this.f(w,h(H,X))}static d(w){return f.alloc(7,w,0).buffer}static e(w,H){let X=0;X+=f.sizeVSBuffer(H);const J=f.alloc(8,w,X);return J.writeVSBuffer(H),J.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,H){const X=P.VSBuffer.fromString(H);let J=0;J+=f.sizeLongString(X);const G=f.alloc(9,w,J);return G.writeLongString(X),G.buffer}static g(w,H,X){const J=P.VSBuffer.fromString(H);let G=0;G+=f.sizeUInt32,G+=f.sizeLongString(J);for(const B of X)G+=f.sizeVSBuffer(B);const U=f.alloc(10,w,G);U.writeUInt32(X.length),U.writeLongString(J);for(const B of X)U.writeBuffer(B);return U.buffer}static deserializeReplyOKJSON(w){const H=w.readLongString();return JSON.parse(H)}static deserializeReplyOKJSONWithBuffers(w,H){const X=w.readUInt32(),J=w.readLongString(),G=[];for(let U=0;U<X;++U)G.push(w.readVSBuffer());return new O.SerializableObjectWithBuffers(a(J,G,H))}static serializeReplyErr(w,H){const X=H?h(M.transformErrorForSerialization(H),null):void 0;if(typeof X!="string")return this.h(w);const J=P.VSBuffer.fromString(X);let G=0;G+=f.sizeLongString(J);const U=f.alloc(11,w,G);return U.writeLongString(J),U.buffer}static deserializeReplyErrError(w){const H=w.readLongString();return JSON.parse(H)}static h(w){return f.alloc(12,w,0).buffer}}var c;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var v;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(v||(v={}))}),define(Ae[251],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const R=A=>{globalThis.removeEventListener("message",R);const I=A.data;Object.defineProperties(globalThis,{postMessage:{value(m,O){I.postMessage(m,O)}},onmessage:{get(){return I.onmessage},set(m){I.onmessage=m}}}),I.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),I.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class P extends EventTarget{constructor(M,R,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const I=`((${n})('${R}'))`,m=new Blob([I],{type:"application/javascript"}),O=URL.createObjectURL(m),y=new MessageChannel,h=O,E={type:"_newWorker",id:h,port:y.port2,url:O,options:A};M(E,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(O),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(g){y.port1.onmessage=g}},onmessageerror:{get(){return y.port1.onmessageerror},set(g){y.port1.onmessageerror=g}}}),y.port1.addEventListener("messageerror",g=>{const l=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(l)}),y.port1.addEventListener("message",g=>{const l=new MessageEvent("message",{data:g.data});this.dispatchEvent(l)}),y.port1.start()}}e.NestedWorker=P}),define(Ae[252],Re([1,0,4,30,31,3]),function(ee,e,n,P,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var R;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(R=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(O=>m.push(O)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}P.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Ae[107],Re([1,0,5,3,18,24,14,252,61,27,37,124,25,10,43,4,6]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends R.AbstractMessageLogger{get disposed(){return this.l}constructor(p,i,u,s,o){super(),this.id=p,this.name=i,this.m=u,this.n=s,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(p,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.n.$close(this.id)}g(p,i){this.k+=h.VSBuffer.fromString(i).byteLength,(0,R.log)(this.m,p,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class d extends a{appendLine(p){this.append(p)}}let S=class{constructor(p,i,u,s,o,f){this.i=i,this.j=u,this.k=s,this.l=o,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[i,u]of this.g)u.visible=i===this.h}createOutputChannel(p,i,u){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,o=(0,E.isString)(i)?i:void 0;if((0,E.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const b=this.i.environment.extensionLogLevel?.find(([c])=>M.ExtensionIdentifier.equals(u.identifier,c))?.[1];b&&(f=(0,R.parseLogLevel)(b));const r=s?this.o(p,f,u):this.n(p,o,u);return r.then(c=>{this.g.set(c.id,c),c.visible=c.id===this.h}),s?this.r(p,f??this.m.getLevel(),r):this.q(p,r)}async n(p,i,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(p,o,i,u.identifier.value);return new a(b,p,f,this.a,u)}async o(p,i,u){const s=await this.p(u),o=p.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(s,`${o}.log`),b=`${u.identifier.value}.${o}`,r=this.l.createLogger(f,{id:b,name:p,logLevel:i,extensionId:u.identifier.value});return new d(b,p,r,this.a,u)}p(p){let i=this.d.get(p.identifier.value);if(!i){const u=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(u)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}return u})())}return i}q(p,i){let u=!1;const s=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return p},append(o){s(),i.then(f=>f.append(o))},appendLine(o){s(),i.then(f=>f.appendLine(o))},clear(){s(),i.then(o=>o.clear())},replace(o){s(),i.then(f=>f.replace(o))},show(o,f){s(),i.then(b=>b.show(o,f))},hide(){s(),i.then(o=>o.hide())},dispose(){u=!0,i.then(o=>o.dispose())}}}r(p,i,u){const s=new t.DisposableStore,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},f=s.add(new l.Emitter);function b(r){i=r,f.fire(r)}return u.then(r=>{s.add(r),r.logLevel!==i&&b(r.logLevel),s.add(r.onDidChangeLogLevel(c=>b(c)))}),{...this.q(p,u),get logLevel(){return i},onDidChangeLogLevel:f.event,trace(r,...c){o(),u.then(v=>v.trace(r,...c))},debug(r,...c){o(),u.then(v=>v.debug(r,...c))},info(r,...c){o(),u.then(v=>v.info(r,...c))},warn(r,...c){o(),u.then(v=>v.warn(r,...c))},error(r,...c){o(),u.then(v=>v.error(r,...c))},dispose(){s.dispose()}}}};S=qe([je(0,k.IExtHostRpcService),je(1,m.IExtHostInitDataService),je(2,I.IExtHostConsumerFileSystem),je(3,O.IExtHostFileSystemInfo),je(4,R.ILoggerService),je(5,R.ILogService)],S),e.ExtHostOutputService=S,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(Ae[253],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ae[254],Re([1,0,41,15,19,20,22,2,3,182,53,198,253]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,I.createDecorator)("pathService");let E=class mn{constructor(l,t,a,d){this.d=l,this.e=t,this.f=a,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??l})()}hasValidBasename(l,t,a){return typeof t=="string"||typeof t>"u"?this.a.then(d=>this.h(l,d,t)):this.h(l,t,a)}h(l,t,a){return l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,R.basename)(l),t===1):!0}get defaultUriScheme(){return mn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,t){if(l.remoteAuthority)return P.Schemas.vscodeRemote;const a=(0,m.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const d=t.getWorkspace().folders[0];if(d)return d.uri.scheme;const S=t.getWorkspace().configuration;return S?S.scheme:P.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?k.win32:k.posix)}async fileURI(l){let t="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const d=l.indexOf("/",2);d===-1?(t=l.substring(2),l="/"):(t=l.substring(2,d),l=l.substring(d)||"/")}return A.URI.from({scheme:P.Schemas.file,authority:t,path:l,query:"",fragment:""})}};E=qe([je(1,h.IRemoteAgentService),je(2,y.IWorkbenchEnvironmentService),je(3,O.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(Ae[108],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(R,A){this.line=R,this.character=A}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,A){return new n(0,0)}with(R){return new n(0,0)}}e.Position=n;class P{constructor(R,A,I,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(R,A),this.end=new n(I,m)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new P(0,0,0,0)}with(R){return new P(0,0,0,0)}}e.Range=P;var k;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ae[47],Re([1,0,16,36,23,41,13,3,19,9,108,17]),function(ee,e,n,P,k,M,R,A,I,m,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",E=" characters skipped \u27EB",g=(h.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var l;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(ue){return!!ue.preview}e.resultIsMatch=a;function d(ue){return!!ue.resource}e.isFileMatch=d;function S(ue){return!!ue.message}e.isProgressMessage=S;var T;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(T=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=p;class i{constructor(ce,Te,de){this.ranges=Te;const ae=Array.isArray(Te)?Te:[Te];if(de&&de.matchLines===1&&u(ae)){ce=(0,R.getNLines)(ce,de.matchLines);let j="",F=0,Q=0;const pe=Math.floor(de.charsPerLine/5),ke=[];for(const Ee of ae){const ve=Math.max(Ee.startColumn-pe,0),Ce=Ee.startColumn+de.charsPerLine;if(ve>Q+pe+g){const se=h+(ve-Q)+E;j+=se+ce.slice(ve,Ce),F+=ve-(Q+se.length)}else j+=ce.slice(Q,Ce);ke.push(new o(0,Ee.startColumn-F,Ee.endColumn-F)),Q=Ce}this.preview={text:j,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const j=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:ce,matches:(0,n.mapArrayOrNot)(Te,F=>new s(F.startLineNumber-j,F.startColumn,F.endLineNumber-j,F.endColumn))}}}}e.TextSearchMatch=i;function u(ue){const ce=ue[0].startLineNumber;for(const Te of ue)if(Te.startLineNumber!==ce||Te.endLineNumber!==ce)return!1;return!0}class s{constructor(ce,Te,de,ae){this.startLineNumber=ce,this.startColumn=Te,this.endLineNumber=de,this.endColumn=ae}}e.SearchRange=s;class o extends s{constructor(ce,Te,de){super(ce,Te,ce,de)}}e.OneLineRange=o;var f;(function(ue){ue.List="list",ue.Tree="tree"})(f=e.ViewMode||(e.ViewMode={}));var b;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function r(ue,ce=!0){const Te=ue&&ue.files&&ue.files.exclude,de=ce&&ue&&ue.search&&ue.search.exclude;if(!Te&&!de)return;if(!Te||!de)return Te||de;let ae=Object.create(null);return ae=k.mixin(ae,k.deepClone(Te)),ae=k.mixin(ae,k.deepClone(de),!0),ae}e.getExcludes=r;function c(ue,ce){return ue.excludePattern&&P.match(ue.excludePattern,ce)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&P.match(ue.includePattern,ce)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(Te=>{const de=Te.folder.fsPath;if(M.isEqualOrParent(ce,de)){const ae=I.relative(de,ce);return!Te.includePattern||!!P.match(Te.includePattern,ae)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(ce,Te){super(ce),this.code=Te}}e.SearchError=D;function w(ue){const ce=ue.message;if((0,m.isCancellationError)(ue))return new D(ce,v.canceled);try{const Te=JSON.parse(ce);return new D(Te.message,Te.code)}catch{return new D(ce,v.other)}}e.deserializeSearchError=w;function H(ue){const ce={message:ue.message,code:ue.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=H;function X(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=X;function J(ue){return ue.type==="success"}e.isSerializedSearchSuccess=J;function G(ue){return!!ue.path}e.isSerializedFileMatch=G;function U(ue,ce){const Te=ue.searchPath?ue.searchPath:ue.relativePath;return(0,R.fuzzyContains)(Te,ce)}e.isFilePatternMatch=U;class B{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function $(ue,ce){const Te={...ue||{},...ce||{}};return Object.keys(Te).filter(de=>{const ae=Te[de];return typeof ae=="boolean"&&ae})}e.resolvePatternsForProvider=$;class W{constructor(ce,Te){this.c=null,this.a={...ce.excludePattern||{},...Te.excludePattern||{}},this.b=P.parse(this.a);let de=ce.includePattern;Te.includePattern&&(de?de={...de,...Te.includePattern}:de=Te.includePattern),de&&(this.c=P.parse(de))}matchesExcludesSync(ce,Te,de){return!!(this.b&&this.b(ce,Te,de))}includedInQuerySync(ce,Te,de){return!(this.b&&this.b(ce,Te,de)||this.c&&!this.c(ce,Te,de))}includedInQuery(ce,Te,de){const ae=this.b(ce,Te,de),j=()=>this.c?!!this.c(ce,Te,de):!0;return(0,y.isThenable)(ae)?ae.then(F=>F?!1:j()):j()}hasSiblingExcludeClauses(){return x(this.a)}}e.QueryGlobTester=W;function x(ue){for(const ce in ue)if(typeof ue[ce]!="boolean")return!0;return!1}function fe(ue){if(!ue)return;let ce;return Te=>(ce||(ce=(ue()||Promise.resolve([])).then(de=>de?ie(de):{})),ce.then(de=>!!de[Te]))}e.hasSiblingPromiseFn=fe;function Se(ue){if(!ue)return;let ce;return Te=>{if(!ce){const de=ue();ce=de?ie(de):{}}return!!ce[Te]}}e.hasSiblingFn=Se;function ie(ue){const ce={};for(const Te of ue)ce[Te]=!0;return ce}}),define(Ae[32],Re([1,0,16,17,21,4,6,48,15,115,22,13,10,2,153,3,14,170,53,37,27,18,8,7,55,47,5]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i,u,s,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function b(J,G,U){return new O.ExtUri(B=>D(B,U)).isEqual(J,G)}function r(J,G,U){return b(J.uri,G.uri,U)?0:(0,y.compare)(J.uri.toString(),G.uri.toString())}function c(J,G,U){return J.index!==G.index?J.index<G.index?-1:1:b(J.uri,G.uri,U)?(0,y.compare)(J.name,G.name):(0,y.compare)(J.uri.toString(),G.uri.toString())}function v(J,G,U,B){const $=J.slice(0).sort((x,fe)=>U(x,fe,B)),W=G.slice(0).sort((x,fe)=>U(x,fe,B));return(0,n.delta)($,W,(x,fe)=>U(x,fe,B))}function D(J,G){const U=G.getCapabilities(J.scheme);return!(U&&U&1024)}class w extends d.Workspace{static toExtHostWorkspace(G,U,B,$){if(!G)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:fe,configuration:Se,transient:ie,isUntitled:ue}=G,ce=[],Te=U;U?fe.forEach((F,Q)=>{const pe=E.URI.revive(F.uri),ke=w.o(B||U,pe,$);ke?(ke.name=F.name,ke.index=F.index,ce.push(ke)):ce.push({uri:pe,name:F.name,index:Q})}):ce.push(...fe.map(({uri:F,name:Q,index:pe})=>({uri:E.URI.revive(F),name:Q,index:pe}))),ce.sort((F,Q)=>F.index<Q.index?-1:1);const de=new w(W,x,ce,!!ie,Se?E.URI.revive(Se):null,!!ue,F=>D(F,$)),{added:ae,removed:j}=v(Te?Te.workspaceFolders:[],de.workspaceFolders,r,$);return{workspace:de,added:ae,removed:j}}static o(G,U,B){for(let $=0;$<G.folders.length;$++){const W=G.workspaceFolders[$];if(b(W.uri,U,B))return W}}constructor(G,U,B,$,W,x,fe){super(G,B.map(Se=>new d.WorkspaceFolder(Se)),$,W,fe),this.t=U,this.u=x,this.q=[],this.s=A.TernarySearchTree.forUris(fe),B.forEach(Se=>{this.q.push(Se),this.s.set(Se.uri,Se)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,U){return U&&this.s.get(G)&&(G=(0,O.dirname)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let H=class{constructor(G,U,B,$,W){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=$,this.s=B,this.t=W,this.j=new m.Counter,this.k=new P.Barrier,this.o=G.getProxy(f.MainContext.MainThreadWorkspace),this.q=G.getProxy(f.MainContext.MainThreadMessageService);const x=U.workspace;this.l=x?new w(x.id,x.name,[],!!x.transient,x.configuration?E.URI.revive(x.configuration):null,!!x.isUntitled,fe=>D(fe,B)):void 0}$initializeWorkspace(G,U){this.v=U,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?E.URI.from({scheme:I.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,U,B,...$){const W=[];if(Array.isArray($)&&$.forEach(ue=>{E.URI.isUri(ue.uri)&&!W.some(ce=>b(ce.uri,ue.uri,this.s))&&W.push({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri)})}),this.n||[U,B].some(ue=>typeof ue!="number"||ue<0)||B===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(U+B>x.length)return!1;const fe=x.slice(0);fe.splice(U,B,...W.map(ue=>({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<fe.length;ue++){const ce=fe[ue];if(fe.some((Te,de)=>de!==ue&&b(ce.uri,Te.uri,this.s)))return!1}fe.forEach((ue,ce)=>ue.index=ce);const{added:Se,removed:ie}=v(x,fe,c,this.s);if(Se.length===0&&ie.length===0)return!1;if(this.o){const ue=G.displayName||G.name;this.o.$updateWorkspaceFolders(ue,U,B,W).then(void 0,ce=>{this.n=void 0;const Te={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(a.Severity.Error,(0,g.localize)(0,null,ue,ce.toString()),Te,[])})}return this.y(fe),!0}getWorkspaceFolder(G,U){if(!!this.x)return this.x.getWorkspaceFolder(G,U)}async getWorkspaceFolder2(G,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,U)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,U){let B,$="";if(typeof G=="string"?(B=E.URI.file(G),$=G):typeof G<"u"&&(B=G,$=G.fsPath),!B)return $;const W=this.getWorkspaceFolder(B,!0);if(!W)return $;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let x=(0,O.relativePath)(W.uri,B);return U&&W.name&&(x=`${W.name}/${x}`),x}y(G){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:U,added:B,removed:$}=w.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:$}))}findFiles(G,U,B,$,W=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let x;if(U===null?x=!1:U&&(typeof U=="string"?x=U:x=U.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:Se}=X(i.GlobPattern.from(G));return this.o.$startFileSearch((0,h.withUndefinedAsNull)(fe),(0,h.withUndefinedAsNull)(Se),(0,h.withUndefinedAsNull)(x),(0,h.withUndefinedAsNull)(B),W).then(ie=>Array.isArray(ie)?ie.map(ue=>E.URI.revive(ue)):[])}async findTextInFiles(G,U,B,$,W=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),fe=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Se,folder:ie}=X(i.GlobPattern.from(U.include)),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ce={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:fe,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Se,excludePattern:ue},Te=!1;if(this.u[x]=de=>{if(Te)return;const ae=E.URI.revive(de.resource);de.results.forEach(j=>{(0,o.resultIsMatch)(j)?B({uri:ae,preview:{text:j.preview.text,matches:(0,n.mapArrayOrNot)(j.preview.matches,F=>new u.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))},ranges:(0,n.mapArrayOrNot)(j.ranges,F=>new u.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))}):B({uri:ae,text:j.text,lineNumber:j.lineNumber})})},W.isCancellationRequested)return{};try{const de=await this.o.$startTextSearch(G,(0,h.withUndefinedAsNull)(ie),ce,x,W);return delete this.u[x],de||{}}catch(de){throw delete this.u[x],de}}$handleTextSearchResult(G,U){this.u[U]?.(G)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,U){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,U);const B=this.t.transformOutgoingScheme(G),$=this.z++;return this.o.$registerEditSessionIdentityProvider($,B),(0,R.toDisposable)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(G,U){this.h.info("Getting edit session identifier for workspaceFolder",G);const B=await this.resolveWorkspaceFolder(E.URI.revive(G));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const $=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!$),!$)return;const W=await $.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(G,U,B,$){this.h.info("Getting edit session identifier for workspaceFolder",G);const W=await this.resolveWorkspaceFolder(E.URI.revive(G));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const fe=await x.provideEditSessionIdentityMatch?.(U,B,$);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(G){return(U,B,$)=>{const W=function(fe){U.call(B,fe)};return W.extension=G,this.A.event(W,void 0,$)}}async $onWillCreateEditSessionIdentity(G,U,B){const $=await this.resolveWorkspaceFolder(E.URI.revive(G));if($===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:$},U,async(W,x)=>{const fe=Date.now();await Promise.resolve(W),Date.now()-fe>B&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),U.isCancellationRequested}};H=qe([je(0,p.IExtHostRpcService),je(1,T.IExtHostInitDataService),je(2,S.IExtHostFileSystemInfo),je(3,t.ILogService),je(4,s.IURITransformerService)],H),e.ExtHostWorkspace=H,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function X(J){let G,U;return J&&(typeof J=="string"?G=J:(G=J.pattern,U=E.URI.revive(J.baseUri))),{includePattern:G,folder:U}}}),define(Ae[33],Re([1,0,23,4,32,5,7,173,94,10,17,3,18,14,2]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(u,s){if(s){const o=s.split(".");let f=u;for(let b=0;f&&b<o.length;b++)f=f[o[b]];return f}}function t(u){return u instanceof g.URI}function a(u){return u&&u.uri instanceof g.URI&&u.languageId&&typeof u.languageId=="string"}function d(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function S(u){return u&&u.uri instanceof g.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function T(u){if(t(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(d(u))return{overrideIdentifier:u.languageId};if(S(u))return{resource:u.uri};if(u===null)return{resource:null}}let p=class{constructor(s,o,f){this.a=s.getProxy(M.MainContext.MainThreadConfiguration),this.c=o,this.b=f,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(s,o))}};p=qe([je(0,h.IExtHostRpcService),je(1,k.IExtHostWorkspace),je(2,E.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(s,o,f,b){this.a=new P.Emitter,this.b=s,this.f=b,this.c=o,this.e=A.Configuration.parse(f),this.d=this.k(f.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const f={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,f))}getConfiguration(s,o,f){const b=T(o)||{},r=this.g(s?l(this.e.getValue(void 0,b,this.c.workspace),s):this.e.getValue(void 0,b,this.c.workspace));s&&this.h(s,b,f?.identifier);function c(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(D){return typeof l(r,D)<"u"},get:(D,w)=>{this.h(s?`${s}.${D}`:D,b,f?.identifier);let H=l(r,D);if(typeof H>"u")H=w;else{let X;const J=(G,U)=>{let B;const $=()=>{X=X||(0,n.deepClone)(r),B=B||l(X,U)};return(0,m.isObject)(G)?new Proxy(G,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return $(),()=>B;if(X)return B=B||l(X,U),B[x];const fe=W[x];return typeof x=="string"?J(fe,`${U}.${x}`):fe},set:(W,x,fe)=>($(),B&&(B[x]=fe),!0),deleteProperty:(W,x)=>($(),B&&delete B[x],!0),defineProperty:(W,x,fe)=>($(),B&&Object.defineProperty(B,x,fe),!0)}):G};H=J(H,D)}return H},update:(D,w,H,X)=>{D=s?`${s}.${D}`:D;const J=c(H);return w!==void 0?this.b.$updateConfigurationOption(J,D,w,b,X):this.b.$removeConfigurationOption(J,D,b,X)},inspect:D=>{D=s?`${s}.${D}`:D;const w=this.e.inspect(D,b,this.c.workspace);if(w)return{key:D,defaultValue:(0,n.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,n.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,n.deepClone)(w.workspace?.value),workspaceFolderValue:(0,n.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(w.default?.override),globalLanguageValue:(0,n.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,n.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(w.workspaceFolder?.override),languageIds:(0,n.deepClone)(w.overrideIdentifiers)}}};return typeof r=="object"&&(0,n.mixin)(v,r,!1),Object.freeze(v)}g(s){const o=f=>(0,m.isObject)(f)?new Proxy(f,{get:(b,r)=>o(b[r]),set:(b,r,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(b,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(b,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(s)}h(s,o,f){const b=I.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),r=f?`[${f.value}] `:"";if(b===4){typeof o?.resource>"u"&&this.f.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this.f.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const f=new A.ConfigurationChangeEvent(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,r)=>f.affectsConfiguration(b,T(r))})}k(s){return s.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[109],Re([1,0,2,17,4,5,7,32,59,33,21,62,18,27,3,15,20,14,78,211,9]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(G){function U($){if($!=null)return $}G.from=U;function B($){if($!=null)return $}G.to=B})(i||(i={}));var u;(function(G){function U($){if($!=null)return $}G.from=U;function B($){if($!=null)return $}G.to=B})(u||(u={}));var s;(function(G){function U($){if($!=null)return $}G.from=U;function B($){if($!=null)return $}G.to=B})(s||(s={}));var o;(function(G){function U(W){if(W){const x=W;return x&&!!x.process}else return!1}G.is=U;function B(W){if(W==null)return;const x={process:W.process,args:W.args};return W.options&&(x.options=s.from(W.options)),x}G.from=B;function $(W){if(W!=null)return new R.ProcessExecution(W.process,W.args,W.options)}G.to=$})(o||(o={}));var f;(function(G){function U($){if($!=null)return $}G.from=U;function B($){if($!=null)return $}G.to=B})(f||(f={}));var b;(function(G){function U(W){if(W){const x=W;return x&&(!!x.commandLine||!!x.command)}else return!1}G.is=U;function B(W){if(W==null)return;const x={};return W.commandLine!==void 0?x.commandLine=W.commandLine:(x.command=W.command,x.args=W.args),W.options&&(x.options=f.from(W.options)),x}G.from=B;function $(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new R.ShellExecution(W.commandLine,W.options):new R.ShellExecution(W.command,W.args?W.args:[],W.options)}G.to=$})(b||(b={}));var r;(function(G){function U(W){if(W){const x=W;return x&&x.customExecution==="customExecution"}else return!1}G.is=U;function B(W){return{customExecution:"customExecution"}}G.from=B;function $(W,x){return x.get(W)}G.to=$})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(G){function U(B,$){let W;return B.scope!==void 0&&typeof B.scope!="number"?W=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===R.TaskScope.Workspace&&$&&$.workspaceFile?W=$.workspaceFile:W=S.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:W}}G.from=U})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(G){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}G.from=U})(v||(v={}));var D;(function(G){function U(W,x){if(W==null)return[];const fe=[];for(const Se of W){const ie=B(Se,x);ie&&fe.push(ie)}return fe}G.fromMany=U;function B(W,x){if(W==null)return;let fe;W.execution instanceof R.ProcessExecution?fe=o.from(W.execution):W.execution instanceof R.ShellExecution?fe=b.from(W.execution):W.execution&&W.execution instanceof R.CustomExecution&&(fe=r.from(W.execution));const Se=i.from(W.definition);let ie;return W.scope?typeof W.scope=="number"?ie=W.scope:ie=W.scope.uri:ie=R.TaskScope.Workspace,!Se||!ie?void 0:{_id:W._id,definition:Se,name:W.name,source:{extensionId:x.identifier.value,label:W.source,scope:ie},execution:fe,isBackground:W.isBackground,group:v.from(W.group),presentationOptions:u.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}G.from=B;async function $(W,x,fe){if(W==null)return;let Se;o.is(W.execution)?Se=o.to(W.execution):b.is(W.execution)?Se=b.to(W.execution):r.is(W.execution)&&(Se=r.to(W._id,fe));const ie=i.to(W.definition);let ue;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?ue=W.source.scope:ue=await x.resolveWorkspaceFolder(n.URI.revive(W.source.scope)):ue=R.TaskScope.Workspace),!ie||!ue)return;const ce=new R.Task(ie,ue,W.name,W.source.label,Se,W.problemMatchers);return W.isBackground!==void 0&&(ce.isBackground=W.isBackground),W.group!==void 0&&(ce.group=R.TaskGroup.from(W.group._id),ce.group&&W.group.isDefault&&(ce.group=new R.TaskGroup(ce.group.id,ce.group.label),W.group.isDefault===!0&&(ce.group.isDefault=W.group.isDefault))),W.presentationOptions&&(ce.presentationOptions=u.to(W.presentationOptions)),W._id&&(ce._id=W._id),W.detail&&(ce.detail=W.detail),ce}G.to=$})(D=e.TaskDTO||(e.TaskDTO={}));var w;(function(G){function U($){return $}G.from=U;function B($){if(!!$)return Object.assign(Object.create(null),$)}G.to=B})(w||(w={}));class H{constructor(U,B,$){this._id=B,this.a=$,p.set(this,void 0),_e(this,p,U,"f")}get task(){return this.a}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;let X=class{constructor(U,B,$,W,x,fe,Se,ie){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=U.getProxy(M.MainContext.MainThreadTask),this.b=$,this.c=W,this.d=x,this.e=fe,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Se,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,$){if(!$)return new R.Disposable(()=>{});const W=this.w();return this.j.set(W,{type:B,provider:$,extension:U}),this.a.$registerTaskProvider(W,B),new R.Disposable(()=>{this.j.delete(W),this.a.$unregisterTaskProvider(W)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(w.from(U)).then(async B=>{const $=[];for(const W of B){const x=await D.to(W,this.b,this.m);x&&$.push(x)}return $})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof H))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,$){const W=this.m.get(U.id);W&&(this.o.set(U.id,W),this.e.attachPtyToTerminal(B,await W.callback($))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const $=this.j.get(U);if(!$)return Promise.reject(new Error("no handler found"));const W=[],x=(0,P.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(fe=>this.u(B,W,$,fe));return new Promise(fe=>{x.then(Se=>{Promise.all(W).then(()=>{fe(Se)})})})}async $resolveTask(U,B){const $=this.j.get(U);if(!$)return Promise.reject(new Error("no handler found"));if(B.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${$.type}].`);const W=await D.to(B,this.b,this.m);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const x=await $.provider.resolveTask(W,O.CancellationToken.None);if(!x)return;this.z(x,$);const fe=D.from(x,$.extension);if(!fe)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(fe.execution)&&await this.x(fe,x,!0),await this.v(fe)}w(){return this.h++}async x(U,B,$){const W=await this.a.$createTaskId(U);!$&&!this.m.has(W)&&(this.n.add(W),this.o.set(W,B.execution)),this.m.set(W,B.execution)}async y(U,B){if(typeof U=="string"){const x=this.l.get(U);if(!x)throw new T.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const $=this.l.get(U.id);if($)return $;const W=new Promise((x,fe)=>{function Se(ie,ue,ce){ce?x(new H(ie,ue.id,ce)):fe("Unexpected: Task does not exist.")}B?Se(this,U,B):D.to(U.task,this.b,this.m).then(ie=>Se(this,U,ie))});return this.l.set(U.id,W),W.then(x=>(this.k.set(U.id,x),x),x=>Promise.reject(x))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const $=this.n.values();let W=$.next();for(;!W.done;)!this.o.has(W.value)&&this.p!==W.value&&(this.m.delete(W.value),this.n.delete(W.value)),W=$.next()}};X=qe([je(0,h.IExtHostRpcService),je(1,E.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,I.IExtHostDocumentsAndEditors),je(4,m.IExtHostConfiguration),je(5,y.IExtHostTerminalService),je(6,a.ILogService),je(7,d.IExtHostApiDeprecationService)],X),e.ExtHostTaskBase=X;let J=class extends X{constructor(U,B,$,W,x,fe,Se,ie){super(U,B,$,W,x,fe,Se,ie),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const $=D.from(B,U);if($===void 0)throw new Error("Task is not valid");if(r.is($.execution))await this.x($,B,!1);else throw new T.NotSupportedError;const W=await this.y(await this.a.$getTaskExecution($),B);return this.a.$executeTask($).catch(x=>{throw new Error(x)}),W}u(U,B,$,W){const x=[];if(W)for(const fe of W){this.z(fe,$),(!fe.definition||!U[fe.definition.type])&&this.f.warn(`The task [${fe.source}, ${fe.name}] uses an undefined task type. The task will be ignored in the future.`);const Se=D.from(fe,$.extension);Se&&r.is(Se.execution)?(x.push(Se),B.push(this.x(Se,fe,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:$.extension}}async v(U){if(r.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,$){}};J=qe([je(0,h.IExtHostRpcService),je(1,E.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,I.IExtHostDocumentsAndEditors),je(4,m.IExtHostConfiguration),je(5,y.IExtHostTerminalService),je(6,a.ILogService),je(7,d.IExtHostApiDeprecationService)],J),e.WorkerExtHostTask=J,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ae[255],Re([1,0,19,21,40,36,22,58,47]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class m{constructor(h,E,g){this.k=h,this.l=E,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&M.parse(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&M.parse(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const E=this.k.folderQueries||[];return new Promise((g,l)=>{const t=a=>{this.f++,h(a)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const d=a.toString(),S=n.basename(d);this.j&&this.j(d,S)||this.v(t,{base:a,basename:S})}),Promise.all(E.map(a=>this.p(a,t))).then(a=>{g({limitHit:this.e,stats:a[0]||void 0})},a=>{l(new Error((0,k.toErrorMessage)(a)))})})}async p(h,E){const g=new P.CancellationTokenSource,l=this.q(h),t=this.r(),a=new I.QueryGlobTester(this.k,h),d=!a.hasSiblingExcludeClauses();let S;try{this.h.add(g),S=A.StopWatch.create();const T=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,g.token),p=S.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(T&&T.forEach(u=>{const s=n.posix.relative(h.folder.path,u.path);if(d){const o=n.basename(u.path);this.v(E,{base:h.folder,relativePath:s,basename:o});return}this.s(t,h.folder,s,E)}),this.g&&!this.e)?null:(this.u(t,a,E),{providerTime:p,postProcessTime:i.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(h){const E=(0,I.resolvePatternsForProvider)(this.k.includePattern,h.includePattern),g=(0,I.resolvePatternsForProvider)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:g,includes:E,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},E,g,l){if(g===this.a){const a=n.basename(this.a);this.v(l,{base:E,relativePath:this.a,basename:a})}function t(a){const d=n.basename(a),S=n.dirname(a);let T=h[S];T||(T=h[S]=[],t(S)),T.push({base:E,relativePath:a,basename:d})}t(g)}u({rootEntries:h,pathToEntries:E},g,l){const t=this,a=this.a;function d(S){const T=(0,I.hasSiblingFn)(()=>S.map(p=>p.basename));for(let p=0,i=S.length;p<i;p++){const u=S[p],{relativePath:s,basename:o}=u;if(g.matchesExcludesSync(s,o,a!==o?T:void 0))continue;const f=E[s];if(f)d(f);else{if(s===a)continue;t.v(l,u)}if(t.e)break}}d(h)}v(h,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(E))}}class O{constructor(){this.b=new Map}fileSearch(h,E,g,l){const t=this.c(h.cacheKey),a=new m(h,E,t&&t.token);let d=0;const S=T=>{d+=T.length,g(T.map(p=>this.d(p)))};return this.e(a,O.a,S,l).then(T=>({limitHit:T.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:T.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(!!h)return this.b.has(h)||this.b.set(h,new P.CancellationTokenSource),this.b.get(h)}d(h){return h.relativePath?{resource:R.joinPath(h.base,h.relativePath)}:{resource:h.base}}e(h,E,g,l){l.onCancellationRequested(()=>{h.cancel()});const t=d=>{d&&(a.push(d),E>0&&a.length>=E&&(g(a),a=[]))};let a=[];return h.search(t).then(d=>(a.length&&g(a),d),d=>(a.length&&g(a),Promise.reject(d)))}}O.a=512,e.FileSearchManager=O}),define(Ae[256],Re([1,0,16,64,36,88,28,15,19,22,13,10,2,270,162,42,14,53,99,254,47]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(D,w,H,X,J){this.a=D,this.b=w,this.c=H,this.d=X,this.e=J}text(D,w,H={}){D=this.f(D,H);const X=this.a.getValue(),J=w&&w.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(w?.map(a.toWorkspaceFolder),H),type:2,contentPattern:D,previewOptions:H.previewOptions,maxFileSize:H.maxFileSize,usePCRE2:X.search.usePCRE2||J||!1,beforeContext:H.beforeContext,afterContext:H.afterContext,userDisabledExcludesAndIgnoreFiles:H.disregardExcludeSettings&&H.disregardIgnoreFiles}}f(D,w){const H=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const X={...D,wordSeparators:H.editor.wordSeparators};return this.j(D,w)&&(X.isCaseSensitive=!0),this.k(D)&&(X.isMultiline=!0),X}file(D,w={}){return{...this.h(D,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(D,w){return D?(D=Array.isArray(D)?D.map(f):f(D),w?this.parseSearchPaths(D):{pattern:u(...Array.isArray(D)?D:[D])}):{}}h(D=[],w={}){const H=this.g(w.includePattern,w.expandPatterns),X=this.g(w.excludePattern,w.expandPatterns),J=D.length>1,G=(H.searchPaths&&H.searchPaths.length?H.searchPaths.map($=>this.q($,w,X)):D.map($=>this.r($,w,X,J))).filter($=>!!$),U={_reason:w._reason,folderQueries:G,usingSearchPaths:!!(H.searchPaths&&H.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:X.pattern,includePattern:H.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const $=n.coalesce(n.flatten(this.c.groups.map(fe=>fe.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const W=$.filter(fe=>(0,T.pathIncludedInQuery)(U,fe.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...U,...x}}const B=w.extraFileResources&&w.extraFileResources.filter($=>(0,T.pathIncludedInQuery)(U,$.fsPath));return U.extraFileResources=B&&B.length?B:void 0,U}i(D){const w=[],H=new R.ResourceMap,X={};let J=!1;return D.forEach(G=>{if(G.scheme===A.Schemas.walkThrough)return;if((0,m.isAbsolutePath)(G)){const B=this.b.getWorkspaceFolder(G)?.uri??G.with({path:I.dirname(G.fsPath)});let $=H.get(B);$||(J=!0,$={folder:B,includePattern:{}},w.push($),H.set(B,$));const W=I.relative(B.fsPath,G.fsPath);(0,y.assertIsDefined)($.includePattern)[W.replace(/\\/g,"/")]=!0}else G.fsPath&&(J=!0,X[G.fsPath]=!0)}),{folderQueries:w,includePattern:X,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(D,w){if(w.isSmartCase){if(D.isRegExp){if(O.containsUppercaseCharacter(D.pattern,!0))return!0}else if(O.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,E.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const w=x=>I.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),X=(Array.isArray(D)?D:s(D)).map(x=>{const fe=this.e.resolvedUserHome;return fe?(0,M.untildify)(x,fe.scheme===A.Schemas.file?fe.fsPath:fe.path):x}),J=P.groupBy(X,x=>w(x)?"searchPaths":"exprSegments"),G=(J.exprSegments||[]).map(x=>O.rtrim(x,"/")).map(x=>O.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),U={},B=this.m(J.searchPaths||[]);B&&B.length&&(U.searchPaths=B);const $=n.flatten(G),W=u(...$);return W&&(U.pattern=W),U}l(D,w){return w.disregardExcludeSettings?void 0:(0,T.getExcludes)(D,!w.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const w=D.flatMap(X=>{let{pathPortion:J,globPortion:G}=i(X);return G&&(G=b(G)),this.n(J).flatMap(B=>this.o(B,G))}),H=new Map;return w.forEach(X=>{const J=X.searchPath.toString(),G=H.get(J);G?X.pattern&&(G.pattern=G.pattern||{},G.pattern[X.pattern]=!0):H.set(J,{searchPath:X.searchPath,pattern:X.pattern?u(X.pattern):void 0})}),Array.from(H.values())}n(D){if(I.isAbsolute(D)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==A.Schemas.file?[{searchPath:w[0].uri.with({path:D})}]:[{searchPath:h.URI.file(I.normalize(D))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(D=f(D),D.startsWith("../")||D===".."){const X=I.posix.resolve(w.path,D);return[{searchPath:w.with({path:X})}]}const H=b(D);return[{searchPath:w,pattern:H}]}else{if(D==="./"||D===".\\")return[];{const w=D.replace(/^\.[\/\\]/,""),X=this.b.getWorkspace().folders.map(J=>{const G=w.match(new RegExp(`^${O.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return G?{match:G,folder:J}:null}).filter(y.isDefined);if(X.length)return X.map(J=>{const G=J.match[1];return{searchPath:J.folder.uri,pattern:G&&b(G)}});{const J=D.match(/\.[\/\\](.+)[\/\\]?/),G=J?J[1]:D,U=g.localize(0,null,G);throw new Error(U)}}}}o(D,w){const H=D.pattern&&w?`${D.pattern}/${w}`:D.pattern||w,X=[{searchPath:D.searchPath,pattern:H}];return H&&!H.endsWith("**")&&X.push({searchPath:D.searchPath,pattern:H+"/**"}),X}q(D,w,H){const X=this.r((0,a.toWorkspaceFolder)(D.searchPath),w,H,!1);return X?{...X,includePattern:D.pattern}:null}r(D,w,H,X){let J;const G=h.URI.isUri(D)?D:D.uri;if(H.searchPaths){const x=H.searchPaths.filter(fe=>(0,m.isEqual)(fe.searchPath,G))[0];if(x&&!x.pattern)return null;x&&(J=x.pattern)}const U=this.a.getValue({resource:G}),$={...this.l(U,w)||{},...J||{}},W=h.URI.isUri(D)?(0,m.basename)(D):D.name;return{folder:G,folderName:X?W:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};p=qe([je(0,l.IConfigurationService),je(1,a.IWorkspaceContextService),je(2,d.IEditorGroupsService),je(3,t.ILogService),je(4,S.IPathService)],p),e.QueryBuilder=p;function i(v){const D=v.match(/[\*\{\}\(\)\[\]\?]/);if(D){const w=D.index,H=v.substr(0,w).match(/[/|\\][^/\\]*$/);if(H){let X=v.substr(0,H.index);return X.match(/[/\\]/)||(X+="/"),{pathPortion:X,globPortion:v.substr((H.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((D,w)=>(D[w]=!0,D),Object.create(null)):void 0}function s(v){return k.splitGlobAware(v,",").map(D=>D.trim()).filter(D=>!!D.length)}function o(v){return[`**/${v}/**`,`**/${v}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function f(v){return v.replace(/\\/g,"/")}function b(v){return f(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(v){return v.replace(/([?*[\]])/g,"[$1]")}function c(v,D){v=n.distinct(v,X=>X.toString());const w=[],H=D.getWorkspace();return v&&v.forEach(X=>{let J;if(D.getWorkbenchState()===2)J=(0,m.relativePath)(H.folders[0].uri,X),J&&J!=="."&&(J="./"+J);else{const G=D.getWorkspaceFolder(X);if(G){const U=G.name;if(H.folders.filter($=>$.name===U).length===1){const $=(0,m.relativePath)(G.uri,X);$===""?J=`./${G.name}`:J=`./${G.name}/${$}`}else J=X.fsPath}}J&&w.push(r(J))}),w}e.resolveResourcesForSearchIncludes=c}),define(Ae[257],Re([1,0,22,2,21,9,3,256,47,53]),function(ee,e,n,P,k,M,R,A,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function y(l,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const d=[],S=[];for(const o of a)if(/^workspaceContains:/.test(o)){const f=o.substr(18);f.indexOf("*")>=0||f.indexOf("?")>=0||l.forceUsingSearch?S.push(f):d.push(f)}if(d.length===0&&S.length===0)return Promise.resolve(void 0);let T;const p=new Promise((o,f)=>{T=o}),i=o=>T({activationEvent:o}),u=Promise.all(d.map(o=>h(l,o,i))).then(()=>{}),s=E(l,t.identifier,S,i);return Promise.all([u,s]).then(()=>{T(void 0)}),p}e.checkActivateWorkspaceContainsExtension=y;async function h(l,t,a){for(const d of l.folders)if(await l.exists(n.joinPath(P.URI.revive(d),t))){a(`workspaceContains:${t}`);return}}async function E(l,t,a,d){if(a.length===0)return Promise.resolve(void 0);const S=new k.CancellationTokenSource,T=l.checkExists(l.folders,a,S.token),p=setTimeout(async()=>{S.cancel(),l.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},O);let i=!1;try{i=await T}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}S.dispose(),clearTimeout(p),i&&d(`workspaceContains:${a.join(",")}`)}function g(l,t,a,d){const S=l.get(R.IInstantiationService),T=l.get(I.ISearchService),i=S.createInstance(A.QueryBuilder).file(t.map(u=>(0,m.toWorkspaceFolder)(P.URI.revive(u))),{_reason:"checkExists",includePattern:a,exists:!0});return T.fileSearch(i,d).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=g});var _e=this&&this.__classPrivateFieldSet||function(ee,e,n,P,k){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!k:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?k.call(ee,n):k?k.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[34],Re([1,0,145,19,83,22,17,6,48,2,14,5,33,199,81,32,26,100,9,24,25,184,7,95,3,27,82,18,70,72,62,4,257,80,186,15,79,58,20]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i,u,s,o,f,b,r,c,v,D,w,H,X,J,G,U,B){"use strict";var $,W,x;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let fe=class gn extends A.Disposable{constructor(j,F,Q,pe,ke,Ee,ve,Ce,se,oe,Z){super(),this.a=this.B(new D.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=F,this.g=Q,this.f=ve,this.j=pe,this.k=ke,this.l=Ee,this.m=se,this.p=oe,this.s=Z,this.t=this.g.getProxy(y.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(y.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(y.MainContext.MainThreadExtensionService),this.w=new R.Barrier,this.y=new R.Barrier,this.z=new R.Barrier,this.C=new R.Barrier,this.D=new de(this.f.activationEvents),this.G=new a.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const C=new S.ExtensionIdentifierSet(this.f.myExtensions);this.F=new a.ExtensionDescriptionRegistry(this.D,ce(this.G,C)),this.H=new g.ExtHostStorage(this.g,this.l),this.I=new H.ExtHostSecretState(this.g),this.J=Ce,this.h=j.createChild(new r.ServiceCollection([g.IExtHostStorage,this.H],[H.IExtHostSecretState,this.I])),this.L=this.B(new E.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(N,V,q)=>{this.v.$onExtensionActivationError(N,d.transformErrorForSerialization(V),q)},actualActivateExtension:async(N,V)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(N,this.F,this.G))return await this.v.$activateExtension(N,V),new E.HostExtension;const q=this.F.getExtensionDescription(N);return this.Z(q,V)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(j){d.onUnexpectedError(j)}}async R(){this.J.onWillDeactivateAll();let j=[];try{j=this.F.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.Y(ke))}catch{}await Promise.all(j)}terminate(j,F=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${j}`),this.l.flush(),this.p.dispose(),this.L.dispose(),d.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const Q=this.R();Promise.race([(0,R.timeout)(5e3),Q]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${F}`):this.l.info(`Extension host exiting with code ${F}`),this.l.flush(),this.l.dispose(),this.c.exit(F)})}isActivated(j){return this.z.isOpen()?this.L.isActivated(j):!1}async getExtension(j){const F=await this.v.$getExtension(j);return F&&{...F,identifier:new S.ExtensionIdentifier(F.identifier.value),extensionLocation:m.URI.revive(F.extensionLocation)}}S(j,F){return this.L.activateByEvent(j,F)}U(j,F){return this.L.activateById(j,F)}activateByIdWithErrors(j,F){return this.U(j,F).then(()=>{const Q=this.L.getActivatedExtension(j);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(j=>this.F)}getExtensionExports(j){return this.z.isOpen()?this.L.getActivatedExtension(j).exports:null}async W(j){if(j.scheme!==J.Schemas.file)return j;const F=await this.c.realpath(j.fsPath);return m.URI.file(F)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(j=>new Te(j))),this.M}async X(j){const F=I.TernarySearchTree.forUris(Q=>M.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(j.map(async Q=>{if(this.qb(Q)){const pe=await this.W(Q.extensionLocation);F.set(pe,Q)}})),F}Y(j){let F=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(j))return F;const Q=this.L.getActivatedExtension(j);if(!Q)return F;try{typeof Q.module.deactivate=="function"&&(F=Promise.resolve(Q.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${j.value}':`),this.l.error(pe)}try{(0,A.dispose)(Q.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.l.error(pe)}return F}async Z(j,F){return this.f.remote.isRemote?this.v.$onWillActivateExtension(j.identifier):await this.v.$onWillActivateExtension(j.identifier),this.bb(j,F).then(Q=>{const pe=Q.activationTimes;return this.v.$onDidActivateExtension(j.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,F),this.ab(j,F,"success",pe),Q},Q=>{throw this.ab(j,F,"failure"),Q})}ab(j,F,Q,pe){const ke=ie(j,F);this.u.$publicLog2("extensionActivationTimes",{...ke,...pe||{},outcome:Q})}bb(j,F){const Q=ie(j,F);this.u.$publicLog2("activatePlugin",Q);const pe=this.qb(j);if(!pe)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${F.startup}, activationEvent: '${F.activationEvent}'${j.identifier.value!==F.extensionId.value?`, root cause: ${F.extensionId.value}`:""}`),this.l.flush();const ke=new E.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this.rb(j,(0,M.joinPath)(j.extensionLocation,pe),ke),this.cb(j)]).then(Ee=>(k.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),gn.db(this.l,j.identifier,Ee[0],Ee[1],ke))).then(Ee=>(k.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Ee))}cb(j){const F=new p.ExtensionGlobalMemento(j,this.H),Q=new p.ExtensionMemento(j.identifier.value,!1,this.H),pe=new X.ExtensionSecrets(j,this.I),ke=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([F.whenReady,Q.whenReady,this.J.whenReady]).then(()=>{const ve=this;let Ce,se;const oe=(0,t.isProposedApiEnabled)(j,"ipc")?this.f.messagePorts?.get(S.ExtensionIdentifier.toKey(j.identifier)):void 0;return Object.freeze({globalState:F,workspaceState:Q,secrets:pe,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Z){return P.join(j.extensionLocation.fsPath,Z)},get storagePath(){return ve.J.workspaceValue(j)?.fsPath},get globalStoragePath(){return ve.J.globalValue(j).fsPath},get logPath(){return P.join(ve.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return m.URI.joinPath(ve.f.logsLocation,j.identifier.value)},get storageUri(){return ve.J.workspaceValue(j)},get globalStorageUri(){return ve.J.globalValue(j)},get extensionMode(){return ke},get extension(){return Ce===void 0&&(Ce=new ue(ve,j.identifier,j,Ee,!1)),Ce},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(j,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!se){if(!oe)return;const Z=D.Event.buffer(D.Event.fromDOMEventEmitter(oe,"message",C=>C.data));oe.start(),se={onDidReceiveMessage:Z,postMessage:oe.postMessage.bind(oe)}}return se}})})}static db(j,F,Q,pe,ke){return Q=Q||{activate:void 0,deactivate:void 0},this.eb(j,F,Q,pe,ke).then(Ee=>new E.ActivatedExtension(!1,null,ke.build(),Q,Ee,pe.subscriptions))}static eb(j,F,Q,pe,ke){if(typeof Q.activate=="function")try{ke.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${F.value}`);const Ee=typeof global=="object"?global:self,ve=Q.activate.apply(Ee,[pe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(ve).then(Ce=>(ke.activateResolveStop(),Ce))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(Q)}fb(j,F){this.U(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:F}).then(void 0,Q=>{this.l.error(Q)})}gb(j,F=0){const pe=Date.now();(0,B.setTimeout0)(()=>{for(let ke=F;ke<j.length;ke+=1){const Ee=j[ke];for(const ve of Ee.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-pe>50){this.gb(j,ke);break}else this.fb(Ee,ve)}})}hb(){this.v.$setPerformanceMarks(k.getMarks()),this.k.getConfigProvider().then(j=>{const F=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Q=this.F.getAllExtensionDescriptions();if(F)this.gb(Q);else for(const pe of Q)if(pe.activationEvents)for(const ke of pe.activationEvents)ke==="onStartupFinished"&&this.fb(pe,ke)})}ib(){const j=this.S("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const F=this.j.workspace?this.j.workspace.folders:[],Q=this.jb(F),pe=this.lb(),ke=Promise.all([pe,j,Q]).then(()=>{});return Promise.race([ke,(0,R.timeout)(1e4)]).then(()=>{this.hb()}),ke}jb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(F=>this.kb(j,F))).then(()=>{})}async kb(j,F){if(this.isActivated(F.identifier))return;const Q=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:j.map(Ee=>Ee.uri),forceUsingSearch:Q,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,ve,Ce)=>this.t.$checkExists(Ee,ve,Ce)},ke=await(0,w.checkActivateWorkspaceContainsExtension)(pe,F);if(!!ke)return this.U(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:ke.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(j){throw console.error(j),j}}async mb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:F}=this.f.environment;if(!j||!F)throw new Error(n.localize(0,null));const Q=await this.rb(null,F,new E.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(n.localize(1,null,F.toString()));return new Promise((pe,ke)=>{const Ee=(se,oe)=>{se?ke(se):pe(typeof oe=="number"&&oe>0?1:0)},ve=(0,M.originalFSPath)(F),Ce=Q.run(ve,Ee);Ce&&Ce.then&&Ce.then(()=>{pe(0)}).catch(se=>{ke(se instanceof Error&&se.stack?se.stack:String(se))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,F){return this.N[j]=F,(0,A.toDisposable)(()=>{delete this.N[j]})}async ob(j){const F=j.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const Q=j.substr(0,F);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this.N[Q]}}async $resolveAuthority(j,F){const Q=U.StopWatch.create(!1),pe=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(j)},${F})][${Q.elapsed()}ms] `,ke=oe=>this.l.info(`${pe()}${oe}`),Ee=(oe,Z=void 0)=>this.l.error(`${pe()}${oe}`,Z);ke("activating resolver...");const{authorityPrefix:ve,resolver:Ce}=await this.ob(j);if(!Ce)return Ee("no resolver"),{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};const se=new R.IntervalTimer;try{ke("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Ce)),se.cancelAndSet(()=>ke("waiting..."),1e3),ke("invoking resolve()..."),k.mark(`code/extHost/willResolveAuthority/${ve}`);const oe=await Ce.resolve(j,{resolveAttempt:F});k.mark(`code/extHost/didResolveAuthorityOK/${ve}`),se.dispose(),ke(`returned ${oe.host}:${oe.port}`);const Z={authority:j,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},C={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:C,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(k.mark(`code/extHost/didResolveAuthorityError/${ve}`),se.dispose(),Ee("returned an error",oe),oe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(j,F){this.l.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(j)})`);const{resolver:Q}=await this.ob(j);if(!Q)return null;const pe=m.URI.revive(F);if(typeof Q.getCanonicalURI>"u")return pe;const ke=await(0,R.asPromise)(()=>Q.getCanonicalURI(pe));return ke||pe}$startExtensionHost(j){j.toAdd.forEach(pe=>pe.extensionLocation=m.URI.revive(pe.extensionLocation));const{globalRegistry:F,myExtensions:Q}=Se(this.D,this.G,this.F,j);return this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),this.nb()}$activateByEvent(j,F){return F===1?this.S(j,!1):this.z.wait().then(Q=>this.S(j,!1))}async $activate(j,F){return await this.z.wait(),this.F.getExtensionDescription(j)?(await this.U(j,F),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(Ee=>Ee.extensionLocation=m.URI.revive(Ee.extensionLocation));const{globalRegistry:F,myExtensions:Q}=Se(this.D,this.G,this.F,j),pe=await this.X(Q);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const F=T.VSBuffer.alloc(j),Q=Math.random()%256;for(let pe=0;pe<j;pe++)F.writeUInt8(Q,pe);return F}async $updateRemoteConnectionData(j){this.Q=j,this.a.fire()}};fe=qe([je(0,s.IInstantiationService),je(1,e.IHostUtils),je(2,b.IExtHostRpcService),je(3,l.IExtHostWorkspace),je(4,h.IExtHostConfiguration),je(5,O.ILogService),je(6,o.IExtHostInitDataService),je(7,f.IExtensionStoragePaths),je(8,c.IExtHostTunnelService),je(9,v.IExtHostTerminalService),je(10,G.IExtHostLocalizationService)],fe),e.AbstractExtHostExtensionService=fe;function Se(ae,j,F,Q){ae.addActivationEvents(Q.addActivationEvents);const pe=new a.ExtensionDescriptionRegistry(ae,j.getAllExtensionDescriptions());pe.deltaExtensions(Q.toAdd,Q.toRemove);const ke=new S.ExtensionIdentifierSet(F.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of Q.myToRemove)ke.delete(ve);for(const ve of Q.myToAdd)ke.add(ve);const Ee=ce(pe,ke);return{globalRegistry:pe,myExtensions:Ee}}function ie(ae,j){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class ue{constructor(j,F,Q,pe,ke){$.set(this,void 0),W.set(this,void 0),x.set(this,void 0),_e(this,$,j,"f"),_e(this,W,F,"f"),_e(this,x,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=P.normalize((0,M.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=pe,this.isFromDifferentExtensionHost=ke}get isActive(){return Ne(this,$,"f").isActivated(Ne(this,x,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,$,"f").getExtensionExports(Ne(this,x,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,$,"f").activateByIdWithErrors(Ne(this,x,"f"),{startup:!1,extensionId:Ne(this,W,"f"),activationEvent:"api"}),this.exports}}e.Extension=ue,$=new WeakMap,W=new WeakMap,x=new WeakMap;function ce(ae,j){return ae.getAllExtensionDescriptions().filter(F=>j.has(F.identifier))}class Te{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.ExtensionPaths=Te;class de{constructor(j){this.a=new S.ExtensionIdentifierMap,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)}addActivationEvents(j){for(const F of Object.keys(j))this.a.set(F,j[F])}}}),define(Ae[258],Re([1,0,83,2,5,33,26,24,18,27,3,34,51,14,13]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(p,i,u,s,o,f,b){this.c=p,this.d=i,this.e=u,this.f=s,this.g=o,this.h=f,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,p,this.i)),this.register(this.e.createInstance(d,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(S,i,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this.a.set(i,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(i=>p.alternativeModuleName(i))}};l=qe([je(2,O.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,y.IExtHostExtensionService),je(5,m.IExtHostInitDataService),je(6,E.ILogService)],l),e.RequireInterceptor=l;let t=class ln{constructor(p){if(p.environment.appRoot&&ln.a.size){const i=(0,g.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),u="[a-z0-9_.-]",s=`@${u}+\\/${u}+|${u}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${o}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const i=this.b.exec(this.c(p));if(!i)return;const[,u,s,o]=i,f=ln.a.get(s);if(f!==void 0)return console.warn(`${s} as been renamed to ${f}, please update your imports`),u+f+o}c(p){return p.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=qe([je(0,m.IExtHostInitDataService)],t);class a{constructor(p,i,u,s,o){this.c=p,this.d=i,this.e=u,this.f=s,this.g=o,this.nodeModuleName="vscode",this.a=new A.ExtensionIdentifierMap}load(p,i){const u=this.d.findSubstr(i);if(u){let s=this.a.get(u.identifier);return s||(s=this.c(u,this.e,this.f),this.a.set(u.identifier,s)),s}if(!this.b){let s="";this.d.forEach((o,f)=>s+=`	${f} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(R.nullExtensionDescription,this.e,this.f)}return this.b}}let d=class{constructor(p,i,u){this.d=p,this.nodeModuleName="keytar",this.a=i.getProxy(k.MainContext.MainThreadTelemetry);const{environment:s}=u,o=i.getProxy(k.MainContext.MainThreadKeytar);if(s.appRoot){let f=s.appRoot.fsPath;h.platform==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.b=new Set,this.b.add(`${f}/node_modules.asar/keytar`),this.b.add(`${f}/node_modules/keytar`)}this.c={getPassword:(f,b)=>o.$getPassword(f,b),setPassword:(f,b,r)=>o.$setPassword(f,b,r),deletePassword:(f,b)=>o.$deletePassword(f,b),findPassword:f=>o.$findPassword(f),findCredentials(f){return o.$findCredentials(f)}}}load(p,i){const u=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const i=p.length;if(i<=7||!this.b)return;const u=i-7;if((p.charAt(u)==="/"||p.charAt(u)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};d=qe([je(1,I.IExtHostRpcService),je(2,m.IExtHostInitDataService)],d);let S=class{constructor(p,i,u){this.e=p,this.f=i,this.nodeModuleName=["open","opn"],this.d=u.getProxy(k.MainContext.MainThreadTelemetry);const s=u.getProxy(k.MainContext.MainThreadWindow);this.c=(o,f)=>{const b=P.URI.parse(o);return f?this.g(o,f):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,o,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,o,{}):this.g(o,f)}}load(p,i,u){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=u(p),this.c}g(p,i){return this.i(),this.b(p,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};S=qe([je(2,I.IExtHostRpcService)],S)}),define(Ae[110],Re([1,0,86,6,19,51,3,59,60,34,7,32,196,33]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class g extends h.AbstractVariableResolverService{constructor(a,d,S,T,p,i,u){function s(){if(S){const o=S.activeEditor();if(o)return o.document.uri;const f=T.tabGroups.all.find(b=>b.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof O.TextDiffTabInput||f.input instanceof O.NotebookDiffEditorTabInput)return f.input.modified;if(f.input instanceof O.TextTabInput||f.input instanceof O.NotebookEditorTabInput||f.input instanceof O.CustomEditorTabInput)return f.input.uri}}}super({getFolderUri:o=>{const f=i.folders.filter(b=>b.name===o);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,f)=>p.getConfiguration(void 0,o).get(f),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return k.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const o=s();if(o){const f=d.getWorkspaceFolder(o);if(f)return k.normalize(f.uri.fsPath)}}},getSelectedText:()=>{if(S){const o=S.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(S){const o=S.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>a.getExtension(o)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let l=class extends P.Disposable{constructor(a,d,S,T,p){super(),this.b=a,this.c=d,this.g=S,this.h=T,this.i=p,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};l=qe([je(0,m.IExtHostExtensionService),je(1,y.IExtHostWorkspace),je(2,A.IExtHostDocumentsAndEditors),je(3,E.IExtHostConfiguration),je(4,I.IExtHostEditorTabs)],l),e.ExtHostVariableResolverProviderService=l}),define(Ae[111],Re([1,0,17,4,10,2,3,5,60,34,18,7,32,189,191,33,110]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,o,f,b,r,c){this.D=o,this.E=f,this.F=b,this.G=r,this.H=c,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new P.Emitter,this.n=new P.Emitter,this.o=new P.Emitter,this.u=new P.Emitter,this.k=s.getProxy(A.MainContext.MainThreadDebugService),this.z=new P.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new S(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(v=>{v.onDidChange(D=>{this.I(v)}),this.I(v)})}asDebugSourceUri(s,o){const f=s;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let b=`debug:${encodeURIComponent(f.path||"")}`,r="?";return o&&(b+=`${r}session=${encodeURIComponent(o.id)}`,r="&"),b+=`${r}ref=${f.sourceReference}`,M.URI.parse(b)}else{if(f.path)return M.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const o=[];for(const f of s.getAllExtensionDescriptions())if(f.contributes){const b=f.contributes.debuggers;if(b&&b.length>0)for(const r of b)(0,g.isDebuggerMainContribution)(r)&&o.push(r.type)}this.k.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(o=>s.push(o)),s}addBreakpoints(s){this.T();const o=s.filter(r=>{const c=r.id;return this.w.has(c)?!1:(this.w.set(c,r),!0)});this.U(o,[],[]);const f=[],b=new Map;for(const r of o)if(r instanceof y.SourceBreakpoint){let c=b.get(r.location.uri.toString());c||(c={type:"sourceMulti",uri:r.location.uri,lines:[]},b.set(r.location.uri.toString(),c),f.push(c)),c.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof y.FunctionBreakpoint&&f.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this.k.$registerBreakpoints(f)}removeBreakpoints(s){this.T();const o=s.filter(c=>this.w.delete(c.id));this.U([],o,[]);const f=o.filter(c=>c instanceof y.SourceBreakpoint).map(c=>c.id),b=o.filter(c=>c instanceof y.FunctionBreakpoint).map(c=>c.id),r=o.filter(c=>c instanceof y.DataBreakpoint).map(c=>c.id);return this.k.$unregisterBreakpoints(f,b,r)}startDebugging(s,o,f){return this.k.$startDebugging(s?s.uri:void 0,o,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,o,f){if(!o)return new y.Disposable(()=>{});const b=this.d++;return this.f.push({type:s,handle:b,provider:o}),this.k.$registerDebugConfigurationProvider(s,f,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,b),new y.Disposable(()=>{this.f=this.f.filter(r=>r.provider!==o),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,o,f){if(!f)return new y.Disposable(()=>{});if(!this.P(s,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.M(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:o,handle:b,factory:f}),this.k.$registerDebugAdapterDescriptorFactory(o,b),new y.Disposable(()=>{this.h=this.h.filter(r=>r.factory!==f),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,o){if(!o)return new y.Disposable(()=>{});const f=this.i++;return this.j.push({type:s,handle:f,factory:o}),new y.Disposable(()=>{this.j=this.j.filter(b=>b.factory!==o)})}async $runInTerminal(s,o){return Promise.resolve(void 0)}async $substituteVariables(s,o){let f;const b=await this.W(s);return b&&(f={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(f,o)}J(s,o){if(s.type==="implementation")return new p(s.implementation)}K(){}async $startDASession(s,o){const f=this,b=await this.V(o);return this.R(this.M(b.type),b).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const c=this.L(r),v=this.J(c,b);if(!v)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const D=v;return this.A.set(s,D),this.Q(b).then(w=>(w&&this.B.set(s,w),D.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const X=H,J={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const G=await this.C.sign(X.arguments.value);J.body={signature:G},D.sendResponse(J)}else throw new Error("no signer")}catch(G){J.success=!1,J.message=G.message,D.sendResponse(J)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(H),H=(0,g.convertToVSCPaths)(H,!0),f.k.$acceptDAMessage(s,H)}),D.onError(H=>{w&&w.onError&&w.onError(H),this.k.$acceptDAError(s,H.name,H.message,H.stack)}),D.onExit(H=>{w&&w.onExit&&w.onExit((0,k.withNullAsUndefined)(H),void 0),this.k.$acceptDAExit(s,(0,k.withNullAsUndefined)(H),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),D.startSession()))})}$sendDAMessage(s,o){o=(0,g.convertToDAPaths)(o,!1);const f=this.B.get(s);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(o),this.A.get(s)?.sendMessage(o)}$stopDASession(s){const o=this.B.get(s);this.B.delete(s),o&&o.onWillStopSession&&o.onWillStopSession();const f=this.A.get(s);return this.A.delete(s),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const o=[],f=[],b=[];if(s.added)for(const r of s.added){const c=r.id;if(c&&!this.w.has(c)){let v;if(r.type==="function")v=new y.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")v=new y.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const D=M.URI.revive(r.uri);v=new y.SourceBreakpoint(new y.Location(D,new y.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,y.setBreakpointId)(v,c),this.w.set(c,v),o.push(v)}}if(s.removed)for(const r of s.removed){const c=this.w.get(r);c&&(this.w.delete(r),f.push(c))}if(s.changed){for(const r of s.changed)if(r.id){const c=this.w.get(r.id);if(c){if(c instanceof y.FunctionBreakpoint&&r.type==="function"){const v=c;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.functionName=r.functionName}else if(c instanceof y.SourceBreakpoint&&r.type==="source"){const v=c;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.location=new y.Location(M.URI.revive(r.uri),new y.Position(r.line,r.character))}b.push(c)}}}this.U(o,f,b)}$provideDebugConfigurations(s,o,f){return(0,n.asPromise)(async()=>{const b=this.O(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.W(o);return b.provideDebugConfigurations(r,f)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,o,f,b){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.W(o);return r.resolveDebugConfiguration(c,f,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,o,f,b){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.W(o);return r.resolveDebugConfigurationWithSubstitutedVariables(c,f,b)})}async $provideDebugAdapter(s,o){const f=this.N(s);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(o);return this.R(f,b).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.L(r)})}async $acceptDebugSessionStarted(s){const o=await this.V(s);this.m.fire(o)}async $acceptDebugSessionTerminated(s){const o=await this.V(s);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,o){(await this.V(s))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(s,o){const b={session:await this.V(s),event:o.event,body:o.body};this.u.fire(b)}L(s){if(s instanceof y.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof y.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const o=this.h.filter(f=>f.type===s);if(o.length>0)return o[0].factory}N(s){const o=this.h.filter(f=>f.handle===s);if(o.length>0)return o[0].factory}O(s){const o=this.f.filter(f=>f.handle===s);if(o.length>0)return o[0].provider}P(s,o){if(s.contributes){const f=s.contributes.debuggers;if(f&&f.length>0){for(const b of f)if(b.label&&b.type&&b.type===o)return!0}}return!1}Q(s){const f=s.configuration.type,b=this.j.filter(r=>r.type===f||r.type==="*").map(r=>(0,n.asPromise)(()=>r.factory.createDebugAdapterTracker(s)).then(c=>c,c=>null));return Promise.race([Promise.all(b).then(r=>{const c=r.filter(v=>!!v);if(c.length>0)return new T(c)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async R(s,o){const f=o.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.DebugAdapterServer(f));if(s){const r=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>s.createDebugAdapterDescriptor(o,this.S(o,r))).then(c=>{if(c)return c})}const b=await this.E.getExtensionRegistry();return Promise.resolve(this.S(o,b))}S(s,o){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,o,f){(s.length>0||o.length>0||f.length>0)&&this.z.fire(Object.freeze({added:s,removed:o,changed:f}))}async V(s){if(s)if(typeof s=="string"){const o=this.l.get(s);if(o)return o}else{let o=this.l.get(s.id);if(!o){const f=await this.W(s.folderUri),b=s.parent?this.l.get(s.parent):void 0;o=new d(this.k,s.id,s.type,s.name,f,s.configuration,b),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(s){if(s){const o=M.URI.revive(s);return this.D.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};a=qe([je(0,O.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,m.IExtHostExtensionService),je(3,l.IExtHostConfiguration),je(4,I.IExtHostEditorTabs),je(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class d{constructor(s,o,f,b,r,c,v){this.d=s,this.f=o,this.g=f,this.h=b,this.i=r,this.j=c,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,o){return this.d.$customDebugAdapterRequest(this.f,s,o)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=d;class S{constructor(s){this.value=Object.freeze({append(o){s.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=S;class T{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(o=>o.onError?o.onError(s):void 0)}onExit(s,o){this.d.forEach(f=>f.onExit?f.onExit(s,o):void 0)}}class p extends E.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(s,o,f,b,r,c){super(s,o,f,b,r,c)}};i=qe([je(0,O.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,m.IExtHostExtensionService),je(3,l.IExtHostConfiguration),je(4,I.IExtHostEditorTabs),je(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ae[259],Re([1,0,9,83,2,5,250,14,69,70,27,167,18,55,34,57]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(S){const T=S.get(A.ILogService),i=S.get(h.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(u=>{T.error(u);const s=n.transformErrorForSerialization(u);i.$onUnexpectedError(s)})}static async installFullHandler(S){const T=S.get(A.ILogService),p=S.get(h.IExtHostRpcService),i=S.get(g.IExtHostExtensionService),u=S.get(l.IExtHostTelemetry),s=p.getProxy(M.MainContext.MainThreadExtensionService),o=p.getProxy(M.MainContext.MainThreadErrors),f=await i.getExtensionPathIndex(),b=new WeakMap;function r(v,D){let w="",H,X;for(const J of D)w+=`
	at ${J.toString()}`,X=J.getFileName(),!H&&X&&(H=f.findSubstr(k.URI.file(X)));return b.set(v,H?.identifier),`${v.name||"Error"}: ${v.message||""}${w}`}let c=r;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(v){c=function(D,w){return r(D,w),v.call(Error,D,w)}}}),n.setUnexpectedErrorHandler(v=>{T.error(v);const D=n.transformErrorForSerialization(v),w=b.get(v);if(!w){o.$onUnexpectedError(D);return}s.$onExtensionRuntimeError(w,D);const H=u.onExtensionError(w,v);T.trace("forwarded error to extension?",H,w)})}}Error.stackTraceLimit=100;class a{constructor(S,T,p,i,u){this.a=p,this.b=new R.RPCProtocol(S,null,i),T=a.e(T,this.b);const s=new m.ServiceCollection(...(0,I.getSingletonServiceDescriptors)());s.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...T,messagePorts:u}),s.set(h.IExtHostRpcService,new h.ExtHostRpcService(this.b)),s.set(E.IURITransformerService,new E.URITransformerService(i)),s.set(g.IHostUtils,p);const o=new y.InstantiationService(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(f=>f.get(A.ILogService)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",T),this.c=o.invokeFunction(f=>f.get(g.IExtHostExtensionService)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(S){const T=this.b.getProxy(M.MainContext.MainThreadExtensionService);return k.URI.revive(await T.$asBrowserUri(S))}terminate(S){this.c.terminate(S)}static e(S,T){S.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(T.transformIncomingURIs(i.extensionLocation))}),S.environment.appRoot=k.URI.revive(T.transformIncomingURIs(S.environment.appRoot));const p=S.environment.extensionDevelopmentLocationURI;return p&&(S.environment.extensionDevelopmentLocationURI=p.map(i=>k.URI.revive(T.transformIncomingURIs(i)))),S.environment.extensionTestsLocationURI=k.URI.revive(T.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=k.URI.revive(T.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=k.URI.revive(T.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=k.URI.revive(T.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=k.URI.revive(T.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=k.URI.revive(T.transformIncomingURIs(S.logsLocation)),S.workspace=T.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=a}),define(Ae[260],Re([1,0,16,17,21,40,15,19,22,2,47]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(d,S,T,p){this.d=d,this.e=S,this.f=T,this.g=p,this.a=null,this.b=!1,this.c=0}search(d,S){const T=this.d.folderQueries||[],p=new k.CancellationTokenSource;return S.onCancellationRequested(()=>p.cancel()),new Promise((i,u)=>{this.a=new E(d);let s=!1;const o=(f,b)=>{if(!s&&!this.b){const r=this.h(f);l(f)&&typeof this.d.maxResults=="number"&&this.c+r>this.d.maxResults&&(this.b=!0,s=!0,p.cancel(),f=this.j(f,this.d.maxResults-this.c));const c=this.h(f);this.c+=c,(c>0||!l(f))&&this.a.add(f,b)}};Promise.all(T.map((f,b)=>this.k(f,r=>o(r,b),p.token))).then(f=>{p.dispose(),this.a.flush();const b=f.some(r=>!!r&&!!r.limitHit);i({limitHit:this.b||b,messages:(0,n.flatten)(f.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.g}})},f=>{p.dispose();const b=(0,M.toErrorMessage)(f);u(new Error(b))})})}h(d){return l(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}j(d,S){const T=Array.isArray(d.ranges)?d.ranges:[d.ranges],p=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:T.slice(0,S),preview:{matches:p.slice(0,S),text:d.preview.text},uri:d.uri}}async k(d,S,T){const p=new O.QueryGlobTester(this.d,d),i=[],u={report:f=>{if(!this.l(f))return;const b=d.folder.scheme===R.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(I.dirname(f.uri))):void 0,r=I.relativePath(d.folder,f.uri);if(r){const c=p.includedInQuery(r,A.basename(r),b);(0,P.isThenable)(c)?i.push(c.then(v=>{v&&S(f)})):c&&S(f)}}},s=this.n(d),o=await this.e.provideTextSearchResults(h(this.d.contentPattern),s,u,T);return i.length&&await Promise.all(i),o}l(d){if(l(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(d){const S=(0,O.resolvePatternsForProvider)(this.d.includePattern,d.includePattern),T=(0,O.resolvePatternsForProvider)(this.d.excludePattern,d.excludePattern),p={folder:m.URI.from(d.folder),excludes:T,includes:S,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.f.toCanonicalName(d.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=y;function h(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(d){this.e=d,this.b=-1,this.d=null,this.a=new t(512,S=>this.g(S))}add(d,S){this.d&&(this.b!==S||!I.isEqual(this.c,d.uri))&&(this.f(),this.d=null),this.d||(this.b=S,this.d={resource:d.uri,results:[]}),this.d.results.push(g(d))}f(){const d=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,d)}flush(){this.f(),this.a.flush()}g(d){this.e(d)}}e.TextSearchResultsCollector=E;function g(a){return l(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function l(a){return!!a.preview}e.extensionResultIsMatch=l;class t{constructor(d,S){this.g=d,this.h=S,this.c=0,this.d=[],this.e=0}addItem(d,S){!d||this.j(d,S)}addItems(d,S){!d||this.k(d,S)}j(d,S){this.d.push(d),this.e+=S,this.l()}k(d,S){this.d=this.d.concat(d),this.e+=S,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}t.a=4e3,t.b=50,e.BatchedCollector=t}),define(Ae[112],Re([1,0,6,5,3,255,18,55,14,2,260]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let y=class{constructor(l,t,a){this.k=l,this.l=t,this.n=a,this.c=this.k.getProxy(P.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,t){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const a=this.d++;return this.e.set(a,t),this.c.$registerTextSearchProvider(a,this.o(l)),(0,n.toDisposable)(()=>{this.g.delete(l),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(l,t){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const a=this.d++;return this.h.set(a,t),this.c.$registerFileSearchProvider(a,this.o(l)),(0,n.toDisposable)(()=>{this.i.delete(l),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(l,t,a,d){const S=h(a),T=this.h.get(l);if(T)return this.j.fileSearch(S,T,p=>{this.c.$handleFileMatch(l,t,p.map(i=>i.resource))},d);throw new Error("unknown provider: "+l)}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,t,a,d){const S=this.e.get(l);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const T=h(a);return this.q(T,S).search(i=>this.c.$handleTextMatch(l,t,i),d)}$enableExtensionHostSearch(){}q(l,t){return new O.TextSearchManager(l,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};y=qe([je(0,R.IExtHostRpcService),je(1,A.IURITransformerService),je(2,I.ILogService)],y),e.ExtHostSearch=y;function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(E),extraFileResources:g.extraFileResources&&g.extraFileResources.map(l=>m.URI.revive(l))}}e.reviveQuery=h;function E(g){return{...g,folder:m.URI.revive(g.folder)}}}),define(Ae[261],Re([1,0,21,9,4,29,2,133,271,120,131,43,5,76,216,215,38,217,33,219,220,221,202,222,59,34,223,224,229,230,232,107,206,238,239,240,81,62,242,207,8,7,52,245,63,106,32,24,194,228,50,105,109,111,112,14,55,18,27,233,200,72,78,213,243,82,61,248,246,247,214,37,241,244,80,60,57,234,108,235,15,93,205,185,225,6,26,190,79,181,236,237,227,226,204]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i,u,s,o,f,b,r,c,v,D,w,H,X,J,G,U,B,$,W,x,fe,Se,ie,ue,ce,Te,de,ae,j,F,Q,pe,ke,Ee,ve,Ce,se,oe,Z,C,N,V,q,te,ge,Pe,le,De,we,We,$e,tt,Xe,it,nt,Me,rt,Y,_,be,He,Be,Qe,Ye,Ge,at,yt,It,St,vt,Nt,Rt,Yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Gt(dt){const ft=dt.get(se.IExtHostInitDataService),Ot=dt.get(We.IExtHostFileSystemInfo),Mt=dt.get(ge.IExtHostConsumerFileSystem),kt=dt.get(o.IExtHostExtensionService),mt=dt.get(ce.IExtHostWorkspace),wt=dt.get(nt.IExtHostTelemetry),zt=dt.get(d.IExtHostConfiguration),Ct=dt.get(ve.IURITransformerService),Ke=dt.get(Ce.IExtHostRpcService),jt=dt.get(G.IExtHostStorage),Xt=dt.get(te.IExtensionStoragePaths),Ut=dt.get(Ee.ILoggerService),Ie=dt.get(Ee.ILogService),Oe=dt.get(C.IExtHostTunnelService),me=dt.get(N.IExtHostApiDeprecationService),K=dt.get(ue.IExtHostWindow),Fe=dt.get(Xe.IExtHostSecretState),ze=dt.get(it.IExtHostEditorTabs);Ke.set(h.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(h.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ke.set(h.ExtHostContext.ExtHostWorkspace,mt),Ke.set(h.ExtHostContext.ExtHostConfiguration,zt),Ke.set(h.ExtHostContext.ExtHostExtensionService,kt),Ke.set(h.ExtHostContext.ExtHostStorage,jt),Ke.set(h.ExtHostContext.ExtHostTunnelService,Oe),Ke.set(h.ExtHostContext.ExtHostWindow,K),Ke.set(h.ExtHostContext.ExtHostSecretState,Fe),Ke.set(h.ExtHostContext.ExtHostTelemetry,wt),Ke.set(h.ExtHostContext.ExtHostEditorTabs,ze);const Ze=Ke.set(h.ExtHostContext.ExtHostDecorations,dt.get(F.IExtHostDecorations)),Ve=Ke.set(h.ExtHostContext.ExtHostDocumentsAndEditors,dt.get(s.IExtHostDocumentsAndEditors)),et=Ke.set(h.ExtHostContext.ExtHostCommands,dt.get(t.IExtHostCommands)),lt=Ke.set(h.ExtHostContext.ExtHostTerminalService,dt.get(U.IExtHostTerminalService)),ut=Ke.set(h.ExtHostContext.ExtHostDebugService,dt.get(pe.IExtHostDebugService)),Dt=Ke.set(h.ExtHostContext.ExtHostSearch,dt.get(ke.IExtHostSearch)),gt=Ke.set(h.ExtHostContext.ExtHostTask,dt.get(Q.IExtHostTask)),Ft=Ke.set(h.ExtHostContext.ExtHostOutputService,dt.get(D.IExtHostOutputService)),$t=Ke.set(h.ExtHostContext.ExtHostLocalization,dt.get(yt.IExtHostLocalizationService)),Oi=Ke.set(h.ExtHostContext.ExtHostUrls,new Se.ExtHostUrls(Ke)),Tt=Ke.set(h.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ke,Ve)),Ei=Ke.set(h.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,Ve,Ie)),ci=Ke.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(Ie,Tt,Ke.getProxy(h.MainContext.MainThreadBulkEdits))),bt=Ke.set(h.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ke,et,Ve,Tt)),ui=Ke.set(h.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(bt)),li=Ke.set(h.ExtHostContext.ExtHostNotebookEditors,new He.ExtHostNotebookEditors(Ie,bt)),ii=Ke.set(h.ExtHostContext.ExtHostNotebookKernels,new Me.ExtHostNotebookKernels(Ke,ft,bt,et,Ie)),wi=Ke.set(h.ExtHostContext.ExtHostNotebookRenderers,new Y.ExtHostNotebookRenderers(Ke,bt)),qt=Ke.set(h.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Yt.ExtHostNotebookDocumentSaveParticipant(Ie,bt,Ke.getProxy(h.MainContext.MainThreadBulkEdits))),Pt=Ke.set(h.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(Ke,Ve)),Fi=Ke.set(h.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ke.getProxy(h.MainContext.MainThreadTreeViews),et,Ie)),Si=Ke.set(h.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Ke.getProxy(h.MainContext.MainThreadEditorInsets),Pt,ft.remote)),ni=Ke.set(h.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ke,Ie,Ot,Ve)),di=Ke.set(h.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ke,Tt,et.converter,Ct)),ct=Ke.set(h.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Ke,Ct,Tt,et,ni,Ie,me,wt)),yi=Ke.set(h.ExtHostContext.ExtHostFileSystem,new f.ExtHostFileSystem(Ke,ct)),xt=Ke.set(h.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(Ke,Ie,Ve)),Jt=Ke.set(h.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Ke,mt,et)),hi=Ke.set(h.ExtHostContext.ExtHostSCM,new X.ExtHostSCM(Ke,et,Ie)),Di=Ke.set(h.ExtHostContext.ExtHostQuickDiff,new vt.ExtHostQuickDiff(Ke,Ct)),Ii=Ke.set(h.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ke,et,Tt)),fi=Ke.set(h.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Ke.getProxy(h.MainContext.MainThreadProgress))),Ci=Ke.set(h.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(Ke)),Li=Ke.set(h.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ke)),_t=Ke.set(h.ExtHostContext.ExtHostAuthentication,new V.ExtHostAuthentication(Ke)),ki=Ke.set(h.ExtHostContext.ExtHostTimeline,new q.ExtHostTimeline(Ke,et)),ri=Ke.set(h.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ke,ft.remote,mt,Ie,me)),si=Ke.set(h.ExtHostContext.ExtHostWebviewPanels,new De.ExtHostWebviewPanels(Ke,ri,mt)),Bi=Ke.set(h.ExtHostContext.ExtHostCustomEditors,new le.ExtHostCustomEditors(Ke,Tt,Xt,ri,si)),Ti=Ke.set(h.ExtHostContext.ExtHostWebviewViews,new Pe.ExtHostWebviewViews(Ke,ri)),Zt=Ke.set(h.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ke,et,Ve)),Wi=Ke.set(h.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ke)),Hi=Ke.set(h.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ke));Ke.set(h.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(Ke,bt,Ve,et,Ie));const Vi=Ke.set(h.ExtHostContext.ExtHostInteractiveEditor,new Rt.ExtHostInteractiveEditor(Ke,Tt,Ie)),mi=Ke.set(h.ExtHostContext.ExtHostInteractiveSession,new Nt.ExtHostInteractiveSession(Ke,Ie)),ji=Object.values(h.ExtHostContext);Ke.assertRegistered(ji);const qi=new we.ExtHostBulkEdits(Ke,Ve),Pi=new l.ExtHostClipboard(Ke),oi=new v.ExtHostMessageService(Ke,Ie),Ni=new T.ExtHostDialogs(Ke),Mi=new J.ExtHostStatusBar(Ke,et.converter);return g.ExtHostApiCommands.register(et),function(Ue,Bt,Ui){const pt=function(){let re=!Ue.isUnderDevelopment;function he(){re||(Ie.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(st){if(Array.isArray(st))st.forEach(Le);else if(typeof st=="string")he();else{const Et=st;typeof Et.scheme>"u"&&he(),typeof Et.exclusive=="boolean"&&(0,Ge.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(re,he,Le){return _t.getSession(Ue,re,he,Le)},getSessions(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"getSessions"),_t.getSessions(Ue,re,he)},async hasSession(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"authSession"),!!await _t.getSession(Ue,re,he,{silent:!0})},get onDidChangeSessions(){return _t.onDidChangeSessions},registerAuthenticationProvider(re,he,Le,st){return _t.registerAuthenticationProvider(re,he,Le,st)}},Ki={registerCommand(re,he,Le){return et.registerCommand(!0,re,he,Le,void 0,Ue)},registerTextEditorCommand(re,he,Le){return et.registerCommand(!0,re,(...st)=>{const Et=Pt.getActiveTextEditor();if(!Et){Ie.warn("Cannot execute "+re+" because there is no active text editor.");return}return Et.edit(At=>{he.apply(Le,[Et,At,...st])}).then(At=>{At||Ie.warn("Edits from command "+re+" were not applied.")},At=>{Ie.warn("An error occurred while running command "+re,At)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,he,Le)=>((0,Ge.checkProposedApiEnabled)(Ue,"diffCommand"),et.registerCommand(!0,re,async(...st)=>{const Et=Ve.activeEditor(!0);if(!Et){Ie.warn("Cannot execute "+re+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(Et.id);he.apply(Le,[At,...st])},void 0,void 0,Ue)),executeCommand(re,...he){return et.executeCommand(re,...he)},getCommands(re=!1){return et.getCommands(re)}},gi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ge.checkProposedApiEnabled)(Ue,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,he){return nt.ExtHostTelemetryLogger.validateSender(re),wt.instantiateLogger(Ue,re,he)},openExternal(re,he){return K.openUri(re,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ft.environment.appUriScheme)return Oi.createAppUri(re);try{return await K.asExternalUri(re,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,be.matchesScheme)(re,_.Schemas.http)||(0,be.matchesScheme)(re,_.Schemas.https))return re;throw he}},get remoteName(){return(0,j.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ie.getLevel()},get onDidChangeLogLevel(){return Ie.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(gi);const Gi={createTestController(re,he,Le){return Zt.createTestController(Ue,re,he,Le)},createTestObserver(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Zt.createTestObserver()},runTests(re){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Zt.runTests(re)},get onDidChangeTestResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Zt.results}},Wt=ft.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,pi={getExtension(re,he){(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Le=Bt.mine.getExtensionDescription(re);if(Le)return new o.Extension(kt,Ue.identifier,Le,Wt,!1);if(he){const st=Bt.all.getExtensionDescription(re);if(st)return new o.Extension(kt,Ue.identifier,st,Wt,!0)}},get all(){const re=[];for(const he of Bt.mine.getAllExtensionDescriptions())re.push(new o.Extension(kt,Ue.identifier,he,Wt,!1));return re},get allAcrossExtensionHosts(){(0,Ge.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new Te.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),he=[];for(const Le of Bt.all.getAllExtensionDescriptions()){const st=!re.has(Le.identifier);he.push(new o.Extension(kt,Ue.identifier,Le,Wt,st))}return he},get onDidChange(){return(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")?k.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Xi={createDiagnosticCollection(re){return ni.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return ni.onDidChangeDiagnostics},getDiagnostics:re=>ni.getDiagnostics(re),getLanguages(){return di.getLanguages()},setTextDocumentLanguage(re,he){return di.changeLanguage(re.uri,he)},match(re,he){const Le=Tt.getDocumentData(he.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(re),he.uri,he.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,he,Le){return ct.registerCodeActionProvider(Ue,pt(re),he,Le)},registerDocumentPasteEditProvider(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,pt(re),he,Le)},registerCodeLensProvider(re,he){return ct.registerCodeLensProvider(Ue,pt(re),he)},registerDefinitionProvider(re,he){return ct.registerDefinitionProvider(Ue,pt(re),he)},registerDeclarationProvider(re,he){return ct.registerDeclarationProvider(Ue,pt(re),he)},registerImplementationProvider(re,he){return ct.registerImplementationProvider(Ue,pt(re),he)},registerTypeDefinitionProvider(re,he){return ct.registerTypeDefinitionProvider(Ue,pt(re),he)},registerHoverProvider(re,he){return ct.registerHoverProvider(Ue,pt(re),he,Ue.identifier)},registerEvaluatableExpressionProvider(re,he){return ct.registerEvaluatableExpressionProvider(Ue,pt(re),he,Ue.identifier)},registerInlineValuesProvider(re,he){return ct.registerInlineValuesProvider(Ue,pt(re),he,Ue.identifier)},registerDocumentHighlightProvider(re,he){return ct.registerDocumentHighlightProvider(Ue,pt(re),he)},registerLinkedEditingRangeProvider(re,he){return ct.registerLinkedEditingRangeProvider(Ue,pt(re),he)},registerReferenceProvider(re,he){return ct.registerReferenceProvider(Ue,pt(re),he)},registerRenameProvider(re,he){return ct.registerRenameProvider(Ue,pt(re),he)},registerDocumentSymbolProvider(re,he,Le){return ct.registerDocumentSymbolProvider(Ue,pt(re),he,Le)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,he){return ct.registerDocumentFormattingEditProvider(Ue,pt(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,pt(re),he)},registerOnTypeFormattingEditProvider(re,he,Le,...st){return ct.registerOnTypeFormattingEditProvider(Ue,pt(re),he,[Le].concat(st))},registerDocumentSemanticTokensProvider(re,he,Le){return ct.registerDocumentSemanticTokensProvider(Ue,pt(re),he,Le)},registerDocumentRangeSemanticTokensProvider(re,he,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,pt(re),he,Le)},registerSignatureHelpProvider(re,he,Le,...st){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,pt(re),he,Le):ct.registerSignatureHelpProvider(Ue,pt(re),he,typeof Le>"u"?[]:[Le,...st])},registerCompletionItemProvider(re,he,...Le){return ct.registerCompletionItemProvider(Ue,pt(re),he,Le)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,pt(re),he)},registerDocumentLinkProvider(re,he){return ct.registerDocumentLinkProvider(Ue,pt(re),he)},registerColorProvider(re,he){return ct.registerColorProvider(Ue,pt(re),he)},registerFoldingRangeProvider(re,he){return ct.registerFoldingRangeProvider(Ue,pt(re),he)},registerSelectionRangeProvider(re,he){return ct.registerSelectionRangeProvider(Ue,re,he)},registerCallHierarchyProvider(re,he){return ct.registerCallHierarchyProvider(Ue,re,he)},registerTypeHierarchyProvider(re,he){return ct.registerTypeHierarchyProvider(Ue,re,he)},setLanguageConfiguration:(re,he)=>ct.setLanguageConfiguration(Ue,re,he),getTokenInformationAtPosition(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"tokenInformation"),di.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ct.registerInlayHintsProvider(Ue,re,he)},createLanguageStatusItem(re,he){return di.createLanguageStatusItem(Ue,re,he)},registerDocumentDropEditProvider(re,he){return ct.registerDocumentOnDropEditProvider(Ue,re,he)}},Ht={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(re,he,Le){const st=await(R.URI.isUri(re)?Promise.resolve(ai.openTextDocument(re)):Promise.resolve(re));return Pt.showTextDocument(st,he,Le)},createTextEditorDecorationType(re){return Pt.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,he,Le){return Pt.onDidChangeActiveTextEditor(re,he,Le)},onDidChangeVisibleTextEditors(re,he,Le){return Pt.onDidChangeVisibleTextEditors(re,he,Le)},onDidChangeTextEditorSelection(re,he,Le){return Pt.onDidChangeTextEditorSelection(re,he,Le)},onDidChangeTextEditorOptions(re,he,Le){return Pt.onDidChangeTextEditorOptions(re,he,Le)},onDidChangeTextEditorVisibleRanges(re,he,Le){return Pt.onDidChangeTextEditorVisibleRanges(re,he,Le)},onDidChangeTextEditorViewColumn(re,he,Le){return Pt.onDidChangeTextEditorViewColumn(re,he,Le)},onDidCloseTerminal(re,he,Le){return lt.onDidCloseTerminal(re,he,Le)},onDidOpenTerminal(re,he,Le){return lt.onDidOpenTerminal(re,he,Le)},onDidChangeActiveTerminal(re,he,Le){return lt.onDidChangeActiveTerminal(re,he,Le)},onDidChangeTerminalDimensions(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDimensions"),lt.onDidChangeTerminalDimensions(re,he,Le)},onDidChangeTerminalState(re,he,Le){return lt.onDidChangeTerminalState(re,he,Le)},onDidWriteTerminalData(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(re,he,Le)},get state(){return K.state},onDidChangeWindowState(re,he,Le){return K.onDidChangeWindowState(re,he,Le)},showInformationMessage(re,...he){return oi.showMessage(Ue,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return oi.showMessage(Ue,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return oi.showMessage(Ue,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Le){return Jt.showQuickPick(Ue,re,he,Le)},showWorkspaceFolderPick(re){return Jt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Jt.showInput(re,he)},showOpenDialog(re){return Ni.showOpenDialog(Ue,re)},showSaveDialog(re){return Ni.showSaveDialog(re)},createStatusBarItem(re,he,Le){let st,Et,At;return typeof re=="string"?(st=re,Et=he,At=Le):(Et=re,At=he),Mi.createStatusBarEntry(Ue,st,Et,At)},setStatusBarMessage(re,he){return Mi.setStatusBarMessage(re,he)},withScmProgress(re){return me.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:x.ProgressLocation.SourceControl},(he,Le)=>re({report(st){}}))},withProgress(re,he){return fi.withProgress(Ue,re,he)},createOutputChannel(re,he){return Ft.createOutputChannel(re,he,Ue)},createWebviewPanel(re,he,Le,st){return si.createWebviewPanel(Ue,re,he,Le,st)},createWebviewTextEditorInset(re,he,Le,st){return(0,Ge.checkProposedApiEnabled)(Ue,"editorInsets"),Si.createWebviewEditorInset(re,he,Le,st,Ue)},createTerminal(re,he,Le){return typeof re=="object"?"pty"in re?lt.createExtensionTerminal(re):lt.createTerminalFromOptions(re):lt.createTerminal(re,he,Le)},registerTerminalLinkProvider(re){return lt.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return lt.registerProfileProvider(Ue,re,he)},registerTerminalQuickFixProvider(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),lt.registerTerminalQuickFixProvider(re,Ue.identifier.value,he)},registerTreeDataProvider(re,he){return Fi.registerTreeDataProvider(re,he,Ue)},createTreeView(re,he){return Fi.createTreeView(re,he,Ue)},registerWebviewPanelSerializer:(re,he)=>si.registerWebviewPanelSerializer(Ue,re,he),registerCustomEditorProvider:(re,he,Le={})=>Bi.registerCustomEditorProvider(Ue,re,he,Le),registerFileDecorationProvider(re){return Ze.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return Oi.registerUriHandler(Ue.identifier,re)},createQuickPick(){return Jt.createQuickPick(Ue)},createInputBox(){return Jt.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,he,Le){return Li.onDidChangeActiveColorTheme(re,he,Le)},registerWebviewViewProvider(re,he,Le){return Ti.registerWebviewViewProvider(Ue,re,he,Le?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Le){return bt.onDidChangeActiveNotebookEditor(re,he,Le)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Le){return li.onDidChangeNotebookEditorSelection(re,he,Le)},onDidChangeNotebookEditorVisibleRanges(re,he,Le){return li.onDidChangeNotebookEditorVisibleRanges(re,he,Le)},showNotebookDocument(re,he){return bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"externalUriOpener"),Wi.registerExternalUriOpener(Ue.identifier,re,he,Le)},registerProfileContentHandler(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Hi.registrProfileContentHandler(Ue,re,he)},registerQuickDiffProvider(re,he,Le,st){return(0,Ge.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Di.registerQuickDiffProvider(pt(re),he,Le,st)},get tabGroups(){return ze.tabGroups}},ai={get rootPath(){return me.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(re){throw P.readonly()},getWorkspaceFolder(re){return mt.getWorkspaceFolder(re)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(re){throw P.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(re){throw P.readonly()},updateWorkspaceFolders:(re,he,...Le)=>mt.updateWorkspaceFolders(Ue,re,he||0,...Le),onDidChangeWorkspaceFolders:function(re,he,Le){return mt.onDidChangeWorkspace(re,he,Le)},asRelativePath:(re,he)=>mt.getRelativePath(re,he),findFiles:(re,he,Le,st)=>mt.findFiles(re,he,Le,Ue.identifier,st),findTextInFiles:(re,he,Le,st)=>{(0,Ge.checkProposedApiEnabled)(Ue,"findTextInFiles");let Et,At;return typeof he=="object"?(Et=he,At=Le):(Et={},At=he,st=Le),mt.findTextInFiles(re,Et||{},At,Ue.identifier,st)},saveAll:re=>mt.saveAll(re),applyEdit(re,he){return qi.applyWorkspaceEdit(re,Ue,he)},createFileSystemWatcher:(re,he,Le,st)=>xt.createFileSystemWatcher(mt,Ue,re,he,Le,st),get textDocuments(){return Tt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw P.readonly()},openTextDocument(re){let he;const Le=re;if(typeof re=="string")he=Promise.resolve(R.URI.file(re));else if(R.URI.isUri(re))he=Promise.resolve(re);else if(!Le||typeof Le=="object")he=Tt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Tt.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(re,he,Le)=>Tt.onDidAddDocument(re,he,Le),onDidCloseTextDocument:(re,he,Le)=>Tt.onDidRemoveDocument(re,he,Le),onDidChangeTextDocument:(re,he,Le)=>Tt.onDidChangeDocument(re,he,Le),onDidSaveTextDocument:(re,he,Le)=>Tt.onDidSaveDocument(re,he,Le),onWillSaveTextDocument:(re,he,Le)=>ci.getOnWillSaveTextDocumentEvent(Ue)(re,he,Le),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Le;if(R.URI.isUri(re))Le=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Le=R.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,he,Le){return ui.onDidSaveNotebookDocument(re,he,Le)},onDidChangeNotebookDocument(re,he,Le){return ui.onDidChangeNotebookDocument(re,he,Le)},onWillSaveNotebookDocument(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookDocumentWillSave"),qt.getOnWillSaveNotebookDocumentEvent(Ue)(re,he,Le)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Le,st){return bt.registerNotebookSerializer(Ue,re,he,Le,(0,Ge.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,he,Le)=>Ui.onDidChangeConfiguration(re,he,Le),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Ui.getConfiguration(re,he,Ue)},registerTextDocumentContentProvider(re,he){return Ei.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(me.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Ue,re,he)),registerFileSystemProvider(re,he,Le){return(0,Ye.combinedDisposable)(yi.registerFileSystemProvider(Ue,re,he,Le),Mt.addFileSystemProvider(re,he))},get fs(){return Mt.value},registerFileSearchProvider:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Dt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"textSearchProvider"),Dt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),Ci.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Le)=>xt.onDidCreateFile(re,he,Le),onDidDeleteFiles:(re,he,Le)=>xt.onDidDeleteFile(re,he,Le),onDidRenameFiles:(re,he,Le)=>xt.onDidRenameFile(re,he,Le),onWillCreateFiles:(re,he,Le)=>xt.getOnWillCreateFileEvent(Ue)(re,he,Le),onWillDeleteFiles:(re,he,Le)=>xt.getOnWillDeleteFileEvent(Ue)(re,he,Le),onWillRenameFiles:(re,he,Le)=>xt.getOnWillRenameFileEvent(Ue)(re,he,Le),openTunnel:re=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),Oe.openTunnel(Ue,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(re,he,Le)=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),Oe.onDidChangeTunnels(re,he,Le)),registerPortAttributesProvider:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"portsAttributes"),Oe.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"timeline"),ki.registerTimelineProvider(re,he,Ue.identifier,et.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:re=>((0,Ge.checkProposedApiEnabled)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Le)=>mt.onDidGrantWorkspaceTrust(re,he,Le),registerEditSessionIdentityProvider:(re,he)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(re,he)),onWillCreateEditSessionIdentity:(re,he,Le)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(Ue)(re,he,Le))},Qi={get inputBox(){return me.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Ue)},createSourceControl(re,he,Le){return hi.createSourceControl(Ue,re,he,Le)}},Yi={createCommentController(re,he){return Ii.createCommentController(Ue,re,he)}},Ji={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(re,he,Le){return ut.onDidStartDebugSession(re,he,Le)},onDidTerminateDebugSession(re,he,Le){return ut.onDidTerminateDebugSession(re,he,Le)},onDidChangeActiveDebugSession(re,he,Le){return ut.onDidChangeActiveDebugSession(re,he,Le)},onDidReceiveDebugSessionCustomEvent(re,he,Le){return ut.onDidReceiveDebugSessionCustomEvent(re,he,Le)},onDidChangeBreakpoints(re,he,Le){return ut.onDidChangeBreakpoints(re,he,Le)},registerDebugConfigurationProvider(re,he,Le){return ut.registerDebugConfigurationProvider(re,he,Le||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return ut.registerDebugAdapterDescriptorFactory(Ue,re,he)},registerDebugAdapterTrackerFactory(re,he){return ut.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Le){return!Le||typeof Le=="object"&&"configuration"in Le?ut.startDebugging(re,he,{parentSession:Le}):ut.startDebugging(re,he,Le||{})},stopDebugging(re){return ut.stopDebugging(re)},addBreakpoints(re){return ut.addBreakpoints(re)},removeBreakpoints(re){return ut.removeBreakpoints(re)},asDebugSourceUri(re,he){return ut.asDebugSourceUri(re,he)}},_i={registerTaskProvider:(re,he)=>gt.registerTaskProvider(Ue,re,he),fetchTasks:re=>gt.fetchTasks(re),executeTask:re=>gt.executeTask(Ue,re),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(re,he,Le)=>gt.onDidStartTask(re,he,Le),onDidEndTask:(re,he,Le)=>gt.onDidEndTask(re,he,Le),onDidStartTaskProcess:(re,he,Le)=>gt.onDidStartTaskProcess(re,he,Le),onDidEndTaskProcess:(re,he,Le)=>gt.onDidEndTaskProcess(re,he,Le)},Zi={createNotebookController(re,he,Le,st,Et){return ii.createNotebookController(Ue,re,he,Le,st,(0,Ge.isProposedApiEnabled)(Ue,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Ue,re,he),createRendererMessaging(re){return wi.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ii.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ii.registerKernelSourceActionProvider(Ue,re,he)},onDidChangeNotebookCellExecutionState(re,he,Le){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(re,he,Le)}},en={t(...re){if(typeof re[0]=="string"){const he=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return $t.getMessage(Ue.identifier.value,{message:he,args:Le})}return $t.getMessage(Ue.identifier.value,re[0])},get bundle(){return $t.getBundle(Ue.identifier.value)},get uri(){return $t.getBundleUri(Ue.identifier.value)}},tn={_version:1,registerInteractiveEditorSessionProvider(re){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Vi.registerProvider(Ue,re)},registerInteractiveSessionProvider(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),mi.registerInteractiveSessionProvider(Ue,re,he)},addInteractiveRequest(re){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),mi.addInteractiveSessionRequest(re)},sendInteractiveRequestToProvider(re,he){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),mi.sendInteractiveRequestToProvider(re,he)},get onDidPerformUserAction(){return mi.onDidPerformUserAction}};return{version:ft.version,authentication:xi,commands:Ki,comments:Yi,debug:Ji,env:gi,extensions:pi,interactive:tn,l10n:en,languages:Xi,notebooks:Zi,scm:Qi,tasks:_i,tests:Gi,window:Ht,workspace:ai,Breakpoint:x.Breakpoint,TerminalOutputAnchor:x.TerminalOutputAnchor,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CommentThreadState:x.CommentThreadState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:x.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileDecoration2:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,InlineCompletionItem:x.InlineSuggestion,InlineCompletionList:x.InlineSuggestionList,Hover:x.Hover,IndentAction:m.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:I.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TerminalLink:x.TerminalLink,TerminalQuickFixCommand:x.TerminalQuickFixCommand,TerminalQuickFixOpener:x.TerminalQuickFixOpener,TerminalLocation:x.TerminalLocation,TerminalProfile:x.TerminalProfile,TerminalExitReason:x.TerminalExitReason,TerminalQuickFixType:x.TerminalQuickFixType,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,SnippetTextEdit:x.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,TextDocumentChangeReason:x.TextDocumentChangeReason,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItem2:x.TreeItem,TreeItemCheckboxState:x.TreeItemCheckboxState,TreeItemCollapsibleState:x.TreeItemCollapsibleState,TypeHierarchyItem:x.TypeHierarchyItem,UIKind:E.UIKind,Uri:R.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,DocumentDropEdit:x.DocumentDropEdit,DocumentPasteEdit:x.DocumentPasteEdit,InlayHint:x.InlayHint,InlayHintLabelPart:x.InlayHintLabelPart,InlayHintKind:x.InlayHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookRange:x.NotebookRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookRendererScript:x.NotebookRendererScript,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,NotebookCellStatusBarItem:x.NotebookCellStatusBarItem,NotebookControllerAffinity:x.NotebookControllerAffinity,NotebookControllerAffinity2:x.NotebookControllerAffinity2,NotebookDocumentSaveReason:x.NotebookDocumentSaveReason,NotebookEdit:x.NotebookEdit,NotebookKernelSourceAction:x.NotebookKernelSourceAction,PortAttributes:x.PortAttributes,LinkedEditingRanges:x.LinkedEditingRanges,TestResultState:x.TestResultState,TestRunRequest:x.TestRunRequest,TestRunRequest2:x.TestRunRequest2,TestMessage:x.TestMessage,TestTag:x.TestTag,TestRunProfileKind:x.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:x.DataTransfer,DataTransferItem:x.DataTransferItem,CoveredCount:x.CoveredCount,FileCoverage:x.FileCoverage,StatementCoverage:x.StatementCoverage,BranchCoverage:x.BranchCoverage,FunctionCoverage:x.FunctionCoverage,WorkspaceTrustState:x.WorkspaceTrustState,LanguageStatusSeverity:x.LanguageStatusSeverity,QuickPickItemKind:x.QuickPickItemKind,InputBoxValidationSeverity:x.InputBoxValidationSeverity,TabInputText:x.TextTabInput,TabInputTextDiff:x.TextDiffTabInput,TabInputTextMerge:x.TextMergeTabInput,TabInputCustom:x.CustomEditorTabInput,TabInputNotebook:x.NotebookEditorTabInput,TabInputNotebookDiff:x.NotebookDiffEditorTabInput,TabInputWebview:x.WebviewEditorTabInput,TabInputTerminal:x.TerminalEditorTabInput,TabInputInteractiveWindow:x.InteractiveWindowInput,TelemetryTrustedValue:fe.TelemetryTrustedValue,LogLevel:Ee.LogLevel,EditSessionIdentityMatch:It.EditSessionIdentityMatch,InteractiveSessionVoteDirection:x.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:x.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:x.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Gt}),define(Ae[262],Re([1,0,69,107,32,105,33,38,59,62,109,111,112,81,72,78,106,61,37,80,57,60,231,14,110,79]),function(ee,e,n,P,k,M,R,A,I,m,O,y,h,E,g,l,t,a,d,S,T,p,i,u,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,n.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(I.IExtHostDocumentsAndEditors,I.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,n.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,n.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(m.IExtHostTerminalService,m.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,n.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,n.registerSingleton)(T.IExtHostTelemetry,T.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(Ae[263],Re([1,0,261,34,2,258,7,17,249]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class m extends M.RequireInterceptor{j(){}getModule(E,g){for(const l of this.b){const t=l(E);if(t){E=t;break}}if(this.a.has(E))return this.a.get(E).load(E,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(I.ExtHostConsoleForwarder);const E=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(m,E,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(E){return E.browser}async rb(E,g,l){g=g.with({path:y(g.path,".js")});const t=E?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=k.URI.revive(await this.v.$asBrowserUri(g)),d=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),d.status!==200)throw new Error(d.statusText);const S=await d.text(),T=`${g.toString(!0)}#vscode-extension`,p=`${S}
//# sourceURL=${T}`;let i;try{i=new Function("module","exports","require",p)}catch(f){throw console.error(t?`Loading code for extension ${t} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${g.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}E&&await this.s.initializeLocalizedMessages(E);const u={},s={exports:u},o=f=>{const b=this.r.getModule(f,g);if(b===void 0)throw new Error(`Cannot load module '${f}'`);return b};try{return l.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(s,u,o),s.exports!==u?s.exports:u}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}}async $setRemoteEnvironment(E){}async vb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+E;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function y(h,E){return h.endsWith(E)?h:h+E}}),define(Ae[264],Re([1,0,68,69,14,34,183,82,263]),function(ee,e,n,P,k,M,R,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.registerSingleton)(k.ILogService,new n.SyncDescriptor(R.ExtHostLogService,[!0],!0)),(0,P.registerSingleton)(M.IExtHostExtensionService,I.ExtHostExtensionService,0),(0,P.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,0)}),define(Ae[272],Re([1,0,25,4,76,259,251,19,83,15,2,262,264]),function(ee,e,n,P,k,M,R,A,I,m,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(i){return/^(file|vscode-remote):/i.test(i)}const g=fetch.bind(self);function l(i){self.fetch=async function(u,s){return u instanceof Request||E(String(u))&&(u=(await i(O.URI.parse(String(u)))).toString(!0)),g(u,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,s,o,f,b){(async()=>(E(s.toString())&&(s=(await i(O.URI.parse(s.toString()))).toString(!0)),super.open(u,s,o??!0,f,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(u,s){if(/^file:/i.test(u.toString()))u=m.FileAccess.uriToBrowserUri(O.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const f=`(${function(v){function D(X){return typeof X=="string"||X instanceof URL?String(X).replace(/^file:\/\//i,"vscode-file://vscode-app"):X}const w=fetch.bind(self);self.fetch=function(X,J){return X instanceof Request?w(X,J):w(D(X),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(X,J,G,U,B){return super.open(X,D(J),G??!0,U,B)}};const H=importScripts.bind(self);self.importScripts=(...X)=>{H(...X.map(D))},H(v)}.toString()}('${u}'))`;s=s||{},s.name=s.name||A.basename(u.toString());const b=new Blob([f],{type:"application/javascript"}),r=URL.createObjectURL(b);return new i(r,s)}}else self.Worker=class extends R.NestedWorker{constructor(i,u){super(h,i,{name:A.basename(i.toString()),...u})}};const t=new class{constructor(){this.pid=void 0}exit(i){y()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const u=new MessageChannel,s=new P.Emitter;let o=!1;h(u.port2,[u.port2]),u.port1.onmessage=f=>{const{data:b}=f;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const r=n.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,k.isMessageOfType)(r,2)){o=!0,S("received terminate message from renderer");return}s.fire(r)},this.protocol={onMessage:s.event,send:f=>{if(!o){const b=f.buffer.buffer.slice(f.buffer.byteOffset,f.buffer.byteOffset+f.buffer.byteLength);u.port1.postMessage(b,[b])}}}}}function d(i){return new Promise(u=>{const s=i.onMessage(o=>{s.dispose();const f=JSON.parse(o.toString());i.send((0,k.createMessageOfType)(0)),u({protocol:i,initData:f})});i.send((0,k.createMessageOfType)(1))})}let S=i=>y();function T(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function p(){I.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(u){!T(u)||d(i.protocol).then(s=>{I.mark("code/extHost/didWaitForInitData");const o=new M.ExtensionHostMain(s.protocol,s.initData,t,null,u.data);l(f=>o.asBrowserUri(f)),S=f=>o.terminate(f)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/worker/extensionHostWorker.js.map
