/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/platform","vs/base/common/observableImpl/base","vs/base/common/errors","vs/editor/common/core/eolCounter","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/encodedTokenAttributes","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/editor/common/languages","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/arrays","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/editor/common/core/lineRange","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],p=function(F){for(var e=[],E=0,y=F.length;E<y;E++)e[E]=W[F[E]];return e};define(W[3],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let E;function y(u){E=u}e.setLogger=y;function w(){return E}e.getLogger=w;class I{constructor(){this.a=0,this.d=new WeakMap}b(f){return n([h(b("|  ",this.a)),f])}c(f){return f.didChange?[h(" "),r(i(f.oldValue,70),{color:"red",strikeThrough:!0}),h(" "),r(i(f.newValue,60),{color:"green"})]:[h(" (unchanged)")]}handleObservableChanged(f,O){console.log(...this.b([t("observable value changed"),r(f.debugName,{color:"BlueViolet"}),...this.c(O)]))}formatChanges(f){if(f.size!==0)return r(" (changed deps: "+[...f].map(O=>O.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const O=f.handleChange;this.d.set(f,new Set),f.handleChange=(C,z)=>(this.d.get(f).add(C),O.apply(f,[C,z]))}handleDerivedRecomputed(f,O){const C=this.d.get(f);console.log(...this.b([t("derived recomputed"),r(f.debugName,{color:"BlueViolet"}),...this.c(O),this.formatChanges(C)])),C.clear()}handleFromEventObservableTriggered(f,O){console.log(...this.b([t("observable from event triggered"),r(f.debugName,{color:"BlueViolet"}),...this.c(O)]))}handleAutorunCreated(f){const O=f.handleChange;this.d.set(f,new Set),f.handleChange=(C,z)=>(this.d.get(f).add(C),O.apply(f,[C,z]))}handleAutorunTriggered(f){const O=this.d.get(f);console.log(...this.b([t("autorun"),r(f.debugName,{color:"BlueViolet"}),this.formatChanges(O)])),O.clear()}handleBeginTransaction(f){let O=f.getDebugName();O===void 0&&(O=""),console.log(...this.b([t("transaction"),r(O,{color:"BlueViolet"})])),this.a++}handleEndTransaction(){this.a--}}e.ConsoleObservableLogger=I;function n(u){const f=new Array,C={};let z="";function U(m){if("length"in m)for(const v of m)v&&U(v);else"text"in m?(z+=`%c${m.text}`,f.push(m.style),m.data&&Object.assign(C,m.data)):"data"in m&&Object.assign(C,m.data)}U(u);const l=[z,...f];return Object.keys(C).length>0&&l.push(C),l}function h(u){return r(u,{color:"black"})}function t(u){return r(o(`${u}: `,10),{color:"black",bold:!0})}function r(u,f={color:"black"}){function O(z){return Object.entries(z).reduce((U,[l,m])=>`${U}${l}:${m};`,"")}const C={color:f.color};return f.strikeThrough&&(C["text-decoration"]="line-through"),f.bold&&(C["font-weight"]="bold"),{text:u,style:O(C)}}function i(u,f){switch(typeof u){case"number":return""+u;case"string":return u.length+2<=f?`"${u}"`:`"${u.substr(0,f-7)}"+...`;case"boolean":return u?"true":"false";case"undefined":return"undefined";case"object":return u===null?"null":Array.isArray(u)?s(u,f):T(u,f);case"symbol":return u.toString();case"function":return`[[Function${u.name?" "+u.name:""}]]`;default:return""+u}}function s(u,f){let O="[ ",C=!0;for(const z of u){if(C||(O+=", "),O.length-5>f){O+="...";break}C=!1,O+=`${i(z,f-O.length)}`}return O+=" ]",O}function T(u,f){let O="{ ",C=!0;for(const[z,U]of Object.entries(u)){if(C||(O+=", "),O.length-5>f){O+="...";break}C=!1,O+=`${z}: ${i(U,f-O.length)}`}return O+=" }",O}function b(u,f){let O="";for(let C=1;C<=f;C++)O+=u;return O}function o(u,f){for(;u.length<f;)u+=" ";return u}}),define(W[9],p([0,1,2,3]),function(F,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunHandleChanges=e.autorun=void 0;function w(r,i){return new h(r,i,void 0)}e.autorun=w;function I(r,i,s){return new h(r,s,i.handleChange)}e.autorunHandleChanges=I;function n(r,i){const s=new E.DisposableStore,T=w(i,b=>{s.clear(),r(b,s)});return(0,E.toDisposable)(()=>{T.dispose(),s.dispose()})}e.autorunWithStore=n;class h{get dependencies(){return this.c}constructor(i,s,T){this.debugName=i,this.e=s,this.f=T,this.needsToRun=!0,this.a=0,this.b=!1,this.c=new Set,this.d=new Set,(0,y.getLogger)()?.handleAutorunCreated(this),this.g()}subscribeTo(i){this.b||(this.c.add(i),this.d.delete(i)||i.addObserver(this))}handleChange(i,s){const T=this.f?this.f({changedObservable:i,change:s,didChange:b=>b===i}):!0;this.needsToRun=this.needsToRun||T,this.a===0&&this.g()}beginUpdate(){this.a++}endUpdate(){this.a--,this.a===0&&this.g()}g(){if(!this.needsToRun)return;const i=this.d;this.d=this.c,this.c=i,this.needsToRun=!1,(0,y.getLogger)()?.handleAutorunTriggered(this);try{this.e(this)}finally{for(const s of this.d)s.removeObserver(this);this.d.clear()}}dispose(){this.b=!0;for(const i of this.c)i.removeObserver(this);this.c.clear()}toString(){return`Autorun<${this.debugName}>`}}e.AutorunObserver=h,function(r){r.Observer=h}(w=e.autorun||(e.autorun={}));function t(r,i,s){let T;return w(r,b=>{const o=i.read(b),u=T;T=o,s({lastValue:u,newValue:o})})}e.autorunDelta=t}),define(W[5],p([0,1,3]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ObservableValue=e.observableValue=e.TransactionImpl=e.getFunctionName=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let y;function w(T){y=T}e._setDerived=w;class I{get TChange(){return null}read(b){return b.subscribeTo(this),this.get()}map(b){return y(()=>{const o=t(b);return o!==void 0?o:`${this.debugName} (mapped)`},o=>b(this.read(o)))}}e.ConvenientObservable=I;class n extends I{constructor(){super(...arguments),this.a=new Set}addObserver(b){const o=this.a.size;this.a.add(b),o===0&&this.b()}removeObserver(b){this.a.delete(b)&&this.a.size===0&&this.c()}b(){}c(){}}e.BaseObservable=n;function h(T,b){const o=new r(T,b);try{(0,E.getLogger)()?.handleBeginTransaction(o),T(o)}finally{o.finish(),(0,E.getLogger)()?.handleEndTransaction()}}e.transaction=h;function t(T){const b=T.toString(),u=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(u?u[1]:void 0)?.trim()}e.getFunctionName=t;class r{constructor(b,o){this.b=b,this.c=o,this.a=[]}getDebugName(){return this.c?this.c():t(this.b)}updateObserver(b,o){this.a.push({observer:b,observable:o}),b.beginUpdate(o)}finish(){const b=this.a;this.a=null;for(const{observer:o,observable:u}of b)o.endUpdate(u)}}e.TransactionImpl=r;function i(T,b){return new s(T,b)}e.observableValue=i;class s extends n{constructor(b,o){super(),this.debugName=b,this.d=o}get(){return this.d}set(b,o,u){if(this.d===b)return;if(!o){h(O=>{this.set(b,O,u)},()=>`Setting ${this.debugName}`);return}const f=this.d;this.d=b,(0,E.getLogger)()?.handleObservableChanged(this,{oldValue:f,newValue:b,change:u,didChange:!0});for(const O of this.a)o.updateObserver(O,this),O.handleChange(this,u)}toString(){return`${this.debugName}: ${this.d}`}}e.ObservableValue=s}),define(W[10],p([0,1,5,3]),function(F,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derived=void 0;function w(n,h){return new I(n,h)}e.derived=w,(0,E._setDerived)(w);class I extends E.BaseObservable{get dependencies(){return this.i}get debugName(){return typeof this.k=="function"?this.k():this.k}constructor(h,t){super(),this.k=h,this.l=t,this.e=!1,this.f=!1,this.g=void 0,this.h=0,this.i=new Set,this.j=new Set,(0,y.getLogger)()?.handleDerivedCreated(this)}c(){this.f=!1,this.e=!1,this.g=void 0;for(const h of this.i)h.removeObserver(this);this.i.clear()}get(){if(this.a.size===0){const h=this.l(this);return this.c(),h}if(this.h>0&&this.f){for(const h of this.i)if(h.get(),!this.f)break}if(!this.f){const h=this.j;this.j=this.i,this.i=h;const t=this.g;try{this.g=this.l(this)}finally{for(const i of this.j)i.removeObserver(this);this.j.clear()}this.f=!0;const r=this.e&&t!==this.g;if((0,y.getLogger)()?.handleDerivedRecomputed(this,{oldValue:t,newValue:this.g,change:void 0,didChange:r}),r)for(const i of this.a)i.handleChange(this,void 0)}return this.g}beginUpdate(){if(this.h===0)for(const h of this.a)h.beginUpdate(this);this.h++}handleChange(h,t){this.f&&(this.e=!0,this.f=!1),this.h===0&&this.a.size>0&&this.get()}endUpdate(){if(this.h--,this.h===0){this.a.size>0&&this.get();for(const h of this.a)h.endUpdate(this)}}subscribeTo(h){this.i.add(h),this.j.delete(h)||h.addObserver(this)}toString(){return`LazyDerived<${this.debugName}>`}}e.Derived=I}),define(W[20],p([0,1,2,9,5,10,3]),function(F,e,E,y,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function h(v){return new t(v)}e.constObservable=h;class t extends w.ConvenientObservable{constructor(k){super(),this.a=k}get debugName(){return this.toString()}get(){return this.a}addObserver(k){}removeObserver(k){}toString(){return`Const: ${this.a}`}}function r(v){const k=(0,w.observableValue)("promiseValue",{});return v.then(A=>{k.set({value:A},void 0)}),k}e.observableFromPromise=r;function i(v,k){return new Promise(A=>{let M=!1,g=!1;const d=(0,y.autorun)("waitForState",c=>{const P=v.read(c);k(P)&&(M?d.dispose():g=!0,A(P))});M=!0,g&&d.dispose()})}e.waitForState=i;function s(v,k){return new T(v,k)}e.observableFromEvent=s;class T extends w.BaseObservable{constructor(k,A){super(),this.h=k,this.i=A,this.f=!1,this.l=M=>{const g=this.i(M),d=!this.f||this.e!==g;(0,n.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.e,newValue:g,change:void 0,didChange:d}),d&&(this.e=g,this.f&&(0,w.transaction)(c=>{for(const P of this.a)c.updateObserver(P,this),P.handleChange(this,void 0)},()=>{const c=this.j();return"Event fired"+(c?`: ${c}`:"")}),this.f=!0)}}j(){return(0,w.getFunctionName)(this.i)}get debugName(){const k=this.j();return"From Event"+(k?`: ${k}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this.i(void 0)}}e.FromEventObservable=T,function(v){v.Observer=T}(s=e.observableFromEvent||(e.observableFromEvent={}));function b(v,k){return new o(v,k)}e.observableSignalFromEvent=b;class o extends w.BaseObservable{constructor(k,A){super(),this.debugName=k,this.f=A,this.h=()=>{(0,w.transaction)(M=>{for(const g of this.a)M.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function u(v){return new f(v)}e.observableSignal=u;class f extends w.BaseObservable{constructor(k){super(),this.debugName=k}trigger(k){if(!k){(0,w.transaction)(A=>{this.trigger(A)},()=>`Trigger signal ${this.debugName}`);return}for(const A of this.a)k.updateObserver(A,this),A.handleChange(this,void 0)}get(){}}function O(v,k,A){const M=(0,w.observableValue)("debounced",void 0);let g;return A.add((0,y.autorun)("debounce",d=>{const c=v.read(d);g&&clearTimeout(g),g=setTimeout(()=>{(0,w.transaction)(P=>{M.set(c,P)})},k)})),M}e.debouncedObservable=O;function C(v,k,A){const M=(0,w.observableValue)("triggeredRecently",!1);let g;return A.add(v(()=>{M.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{M.set(!1,void 0)},k)})),M}e.wasEventTriggeredRecently=C;function z(v){const k=new U;return v.addObserver(k),(0,E.toDisposable)(()=>{v.removeObserver(k)})}e.keepAlive=z;class U{beginUpdate(k){}handleChange(k,A){}endUpdate(k){}}function l(v,k){let A;return(0,I.derived)(v,g=>(A=k(g,A),A))}e.derivedObservableWithCache=l;function m(v,k){let A;const M=(0,w.observableValue)("derivedObservableWithWritableCache.counter",0),g=(0,I.derived)(v,d=>(M.read(d),A=k(d,A),A));return Object.assign(g,{clearCache:d=>{A=void 0,M.set(M.get()+1,d)}})}e.derivedObservableWithWritableCache=m});var x=this&&this.__createBinding||(Object.create?function(F,e,E,y){y===void 0&&(y=E);var w=Object.getOwnPropertyDescriptor(e,E);(!w||("get"in w?!e.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return e[E]}}),Object.defineProperty(F,y,w)}:function(F,e,E,y){y===void 0&&(y=E),F[y]=e[E]}),ee=this&&this.__exportStar||function(F,e){for(var E in F)E!=="default"&&!Object.prototype.hasOwnProperty.call(e,E)&&x(e,F,E)};define(W[11],p([0,1,5,10,9,20,3]),function(F,e,E,y,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return E.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return E.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return w.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return w.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return w.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return w.autorunWithStore}}),ee(I,e),!1&&(0,n.setLogger)(new n.ConsoleObservableLogger)}),define(W[21],p([0,1,6,2]),function(F,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(U){const l=U;return l?typeof l.read=="function":!1}e.isReadable=w;function I(U){const l=U;return l?[l.on,l.pause,l.resume,l.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=I;function n(U){const l=U;return l?I(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=n;function h(U,l){return new t(U,l)}e.newWriteableStream=h;class t{constructor(l,m){this.e=l,this.f=m,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(m=>this.d.push(m))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(m=>m(l))}h(l){this.c.error.length===0?(0,E.onUnexpectedError)(l):this.c.error.slice(0).forEach(m=>m(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,m){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(m),this.resume();break;case"end":this.c.end.push(m),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(m),this.a.flowing&&this.k();break}}removeListener(l,m){if(this.a.destroyed)return;let v;switch(l){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const k=v.indexOf(m);k>=0&&v.splice(k,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const m=[...this.d];this.d.length=0,m.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(U,l){const m=[];let v;for(;(v=U.read())!==null;)m.push(v);return l(m)}e.consumeReadable=r;function i(U,l,m){const v=[];let k;for(;(k=U.read())!==null&&v.length<m;)v.push(k);return k===null&&v.length>0?l(v):{read:()=>{if(v.length>0)return v.shift();if(typeof k<"u"){const A=k;return k=void 0,A}return U.read()}}}e.peekReadable=i;function s(U,l){return new Promise((m,v)=>{const k=[];T(U,{onData:A=>{l&&k.push(A)},onError:A=>{l?v(A):m(void 0)},onEnd:()=>{m(l?l(k):void 0)}})})}e.consumeStream=s;function T(U,l){let m=!1;return U.on("error",v=>{m||l.onError(v)}),U.on("end",()=>{m||l.onEnd()}),U.on("data",v=>{m||l.onData(v)}),(0,y.toDisposable)(()=>m=!0)}e.listenStream=T;function b(U,l){return new Promise((m,v)=>{const k=new y.DisposableStore,A=[],M=c=>{if(A.push(c),A.length>l)return k.dispose(),U.pause(),m({stream:U,buffer:A,ended:!1})},g=c=>v(c),d=()=>m({stream:U,buffer:A,ended:!0});k.add((0,y.toDisposable)(()=>U.removeListener("error",g))),U.on("error",g),k.add((0,y.toDisposable)(()=>U.removeListener("end",d))),U.on("end",d),k.add((0,y.toDisposable)(()=>U.removeListener("data",M))),U.on("data",M)})}e.peekStream=b;function o(U,l){const m=h(l);return m.end(U),m}e.toStream=o;function u(){const U=h(()=>{throw new Error("not supported")});return U.end(),U}e.emptyStream=u;function f(U){let l=!1;return{read:()=>l?null:(l=!0,U)}}e.toReadable=f;function O(U,l,m){const v=h(m);return T(U,{onData:k=>v.write(l.data(k)),onError:k=>v.error(l.error?l.error(k):k),onEnd:()=>v.end()}),v}e.transform=O;function C(U,l,m){let v=!1;return{read:()=>{const k=l.read();return v?k:(v=!0,k!==null?m([U,k]):U)}}}e.prefixedReadable=C;function z(U,l,m){let v=!1;const k=h(m);return T(l,{onData:A=>v?k.write(A):(v=!0,k.write(m([U,A]))),onError:A=>k.error(A),onEnd:()=>{v||(v=!0,k.write(U)),k.end()}}),k}e.prefixedStream=z}),define(W[12],p([0,1,21]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let w,I;class n{static alloc(c){return y?new n(Buffer.allocUnsafe(c)):new n(new Uint8Array(c))}static wrap(c){return y&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new n(c)}static fromString(c,P){return!(P?.dontUseNodeBuffer||!1)&&y?new n(Buffer.from(c)):(w||(w=new TextEncoder),new n(w.encode(c)))}static fromByteArray(c){const P=n.alloc(c.length);for(let B=0,D=c.length;B<D;B++)P.buffer[B]=c[B];return P}static concat(c,P){if(typeof P>"u"){P=0;for(let q=0,_=c.length;q<_;q++)P+=c[q].byteLength}const B=n.alloc(P);let D=0;for(let q=0,_=c.length;q<_;q++){const K=c[q];B.set(K,D),D+=K.byteLength}return B}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=n.alloc(this.byteLength);return c.set(this),c}toString(){return y?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(c,P){return new n(this.buffer.subarray(c,P))}set(c,P){if(c instanceof n)this.buffer.set(c.buffer,P);else if(c instanceof Uint8Array)this.buffer.set(c,P);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),P);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return r(this.buffer,c)}writeUInt32BE(c,P){i(this.buffer,c,P)}readUInt32LE(c){return s(this.buffer,c)}writeUInt32LE(c,P){T(this.buffer,c,P)}readUInt8(c){return b(this.buffer,c)}writeUInt8(c,P){o(this.buffer,c,P)}}e.VSBuffer=n;function h(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0}e.readUInt16LE=h;function t(d,c,P){d[P+0]=c&255,c=c>>>8,d[P+1]=c&255}e.writeUInt16LE=t;function r(d,c){return d[c]*2**24+d[c+1]*2**16+d[c+2]*2**8+d[c+3]}e.readUInt32BE=r;function i(d,c,P){d[P+3]=c,c=c>>>8,d[P+2]=c,c=c>>>8,d[P+1]=c,c=c>>>8,d[P]=c}e.writeUInt32BE=i;function s(d,c){return d[c+0]<<0>>>0|d[c+1]<<8>>>0|d[c+2]<<16>>>0|d[c+3]<<24>>>0}e.readUInt32LE=s;function T(d,c,P){d[P+0]=c&255,c=c>>>8,d[P+1]=c&255,c=c>>>8,d[P+2]=c&255,c=c>>>8,d[P+3]=c&255}e.writeUInt32LE=T;function b(d,c){return d[c]}e.readUInt8=b;function o(d,c,P){d[P]=c}e.writeUInt8=o;function u(d){return E.consumeReadable(d,c=>n.concat(c))}e.readableToBuffer=u;function f(d){return E.toReadable(d)}e.bufferToReadable=f;function O(d){return E.consumeStream(d,c=>n.concat(c))}e.streamToBuffer=O;async function C(d){return d.ended?n.concat(d.buffer):n.concat([...d.buffer,await O(d.stream)])}e.bufferedStreamToBuffer=C;function z(d){return E.toStream(d,c=>n.concat(c))}e.bufferToStream=z;function U(d){return E.transform(d,{data:c=>typeof c=="string"?n.fromString(c):n.wrap(c)},c=>n.concat(c))}e.streamToBufferReadableStream=U;function l(d){return E.newWriteableStream(c=>n.concat(c),d)}e.newWriteableBufferStream=l;function m(d,c){return E.prefixedReadable(d,c,P=>n.concat(P))}e.prefixedBufferReadable=m;function v(d,c){return E.prefixedStream(d,c,P=>n.concat(P))}e.prefixedBufferStream=v;function k(d){let c=0,P=0,B=0;const D=new Uint8Array(Math.floor(d.length/4*3)),q=K=>{switch(P){case 3:D[B++]=c|K,P=0;break;case 2:D[B++]=c|K>>>2,c=K<<6,P=3;break;case 1:D[B++]=c|K>>>4,c=K<<4,P=2;break;default:c=K<<2,P=1}};for(let K=0;K<d.length;K++){const G=d.charCodeAt(K);if(G>=65&&G<=90)q(G-65);else if(G>=97&&G<=122)q(G-97+26);else if(G>=48&&G<=57)q(G-48+52);else if(G===43||G===45)q(62);else if(G===47||G===95)q(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${d[K]}`)}}const _=B;for(;P>0;)q(0);return n.wrap(D).slice(0,_)}e.decodeBase64=k;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:d},c=!0,P=!1){const B=P?M:A;let D="";const q=d.byteLength%3;let _=0;for(;_<d.byteLength-q;_+=3){const K=d[_+0],G=d[_+1],Q=d[_+2];D+=B[K>>>2],D+=B[(K<<4|G>>>4)&63],D+=B[(G<<2|Q>>>6)&63],D+=B[Q&63]}if(q===1){const K=d[_+0];D+=B[K>>>2],D+=B[K<<4&63],c&&(D+="==")}else if(q===2){const K=d[_+0],G=d[_+1];D+=B[K>>>2],D+=B[(K<<4|G>>>4)&63],D+=B[G<<2&63],c&&(D+="=")}return D}e.encodeBase64=g}),define(W[22],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[7],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var E;(function(w){w[w.Unknown=0]="Unknown",w[w.Invalid=3]="Invalid",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(E=e.StringEOL||(e.StringEOL={}));function y(w){let I=0,n=0,h=0,t=0;for(let r=0,i=w.length;r<i;r++){const s=w.charCodeAt(r);s===13?(I===0&&(n=r),I++,r+1<i&&w.charCodeAt(r+1)===10?(t|=2,r++):t|=3,h=r+1):s===10&&(t|=1,I===0&&(n=r),I++,h=r+1)}return I===0&&(n=w.length),[I,n,w.length-h,t]}e.countEOL=y}),define(W[13],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var E;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(E=e.LanguageId||(e.LanguageId={}));var y;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var w;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(w=e.ColorId||(e.ColorId={}));var I;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){const i=this.getForeground(r);let s="mtk"+i;const T=this.getFontStyle(r);return T&1&&(s+=" mtki"),T&2&&(s+=" mtkb"),T&4&&(s+=" mtku"),T&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(r,i){const s=this.getForeground(r),T=this.getFontStyle(r);let b=`color: ${i[s]};`;T&1&&(b+="font-style: italic;"),T&2&&(b+="font-weight: bold;");let o="";return T&4&&(o+=" underline"),T&8&&(o+=" line-through"),o&&(b+=`text-decoration:${o};`),b}static getPresentationFromMetadata(r){const i=this.getForeground(r),s=this.getFontStyle(r);return{foreground:i,italic:Boolean(s&1),bold:Boolean(s&2),underline:Boolean(s&4),strikethrough:Boolean(s&8)}}}e.TokenMetadata=h}),define(W[8],p([0,1,13]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class y{static createEmpty(n,h){const t=y.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=n.length,r[1]=t,new y(r,n,h)}constructor(n,h,t){this._lineTokensBrand=void 0,this.a=n,this.b=this.a.length>>>1,this.c=h,this.d=t}equals(n){return n instanceof y?this.slicedEquals(n,0,this.b):!1}slicedEquals(n,h,t){if(this.c!==n.c||this.b!==n.b)return!1;const r=h<<1,i=r+(t<<1);for(let s=r;s<i;s++)if(this.a[s]!==n.a[s])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(n){return n>0?this.a[n-1<<1]:0}getMetadata(n){return this.a[(n<<1)+1]}getLanguageId(n){const h=this.a[(n<<1)+1],t=E.TokenMetadata.getLanguageId(h);return this.d.decodeLanguageId(t)}getStandardTokenType(n){const h=this.a[(n<<1)+1];return E.TokenMetadata.getTokenType(h)}getForeground(n){const h=this.a[(n<<1)+1];return E.TokenMetadata.getForeground(h)}getClassName(n){const h=this.a[(n<<1)+1];return E.TokenMetadata.getClassNameFromMetadata(h)}getInlineStyle(n,h){const t=this.a[(n<<1)+1];return E.TokenMetadata.getInlineStyleFromMetadata(t,h)}getPresentation(n){const h=this.a[(n<<1)+1];return E.TokenMetadata.getPresentationFromMetadata(h)}getEndOffset(n){return this.a[n<<1]}findTokenIndexAtOffset(n){return y.findIndexInTokensArray(this.a,n)}inflate(){return this}sliceAndInflate(n,h,t){return new w(this,n,h,t)}static convertToEndOffset(n,h){const r=(n.length>>>1)-1;for(let i=0;i<r;i++)n[i<<1]=n[i+1<<1];n[r<<1]=h}static findIndexInTokensArray(n,h){if(n.length<=2)return 0;let t=0,r=(n.length>>>1)-1;for(;t<r;){const i=t+Math.floor((r-t)/2),s=n[i<<1];if(s===h)return i+1;s<h?t=i+1:s>h&&(r=i)}return t}withInserted(n){if(n.length===0)return this;let h=0,t=0,r="";const i=new Array;let s=0;for(;;){const T=h<this.b?this.a[h<<1]:-1,b=t<n.length?n[t]:null;if(T!==-1&&(b===null||T<=b.offset)){r+=this.c.substring(s,T);const o=this.a[(h<<1)+1];i.push(r.length,o),h++,s=T}else if(b){if(b.offset>s){r+=this.c.substring(s,b.offset);const o=this.a[(h<<1)+1];i.push(r.length,o),s=b.offset}r+=b.text,i.push(r.length,b.tokenMetadata),t++}else break}return new y(new Uint32Array(i),r,this.d)}}y.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0,e.LineTokens=y;class w{constructor(n,h,t,r){this.a=n,this.b=h,this.c=t,this.d=r,this.e=n.findTokenIndexAtOffset(h),this.f=0;for(let i=this.e,s=n.getCount();i<s&&!(n.getStartOffset(i)>=t);i++)this.f++}getMetadata(n){return this.a.getMetadata(this.e+n)}getLanguageId(n){return this.a.getLanguageId(this.e+n)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(n){return n instanceof w?this.b===n.b&&this.c===n.c&&this.d===n.d&&this.a.slicedEquals(n.a,this.e,this.f):!1}getCount(){return this.f}getForeground(n){return this.a.getForeground(this.e+n)}getEndOffset(n){const h=this.a.getEndOffset(this.e+n);return Math.min(this.c,h)-this.b+this.d}getClassName(n){return this.a.getClassName(this.e+n)}getInlineStyle(n,h){return this.a.getInlineStyle(this.e+n,h)}getPresentation(n){return this.a.getPresentation(this.e+n)}findTokenIndexAtOffset(n){return this.a.findTokenIndexAtOffset(n+this.b-this.d)-this.e}}}),define(W[23],p([0,1,8]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class y{static deleteBeginning(n,h){return n===null||n===e.EMPTY_LINE_TOKENS?n:y.delete(n,0,h)}static deleteEnding(n,h){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=w(n),r=t[t.length-2];return y.delete(n,h,r)}static delete(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS||h===t)return n;const r=w(n),i=r.length>>>1;if(h===0&&r[r.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=E.LineTokens.findIndexInTokensArray(r,h),T=s>0?r[s-1<<1]:0,b=r[s<<1];if(t<b){const C=t-h;for(let z=s;z<i;z++)r[z<<1]-=C;return n}let o,u;T!==h?(r[s<<1]=h,o=s+1<<1,u=h):(o=s<<1,u=T);const f=t-h;for(let C=s+1;C<i;C++){const z=r[C<<1]-f;z>u&&(r[o++]=z,r[o++]=r[(C<<1)+1],u=z)}if(o===r.length)return n;const O=new Uint32Array(o);return O.set(r.subarray(0,o),0),O.buffer}static append(n,h){if(h===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return h;if(n===null)return n;if(h===null)return null;const t=w(n),r=w(h),i=r.length>>>1,s=new Uint32Array(t.length+r.length);s.set(t,0);let T=t.length;const b=t[t.length-2];for(let o=0;o<i;o++)s[T++]=r[o<<1]+b,s[T++]=r[(o<<1)+1];return s.buffer}static insert(n,h,t){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const r=w(n),i=r.length>>>1;let s=E.LineTokens.findIndexInTokensArray(r,h);s>0&&r[s-1<<1]===h&&s--;for(let T=s;T<i;T++)r[T<<1]+=t;return n}}e.ContiguousTokensEditing=y;function w(I){return I instanceof Uint32Array?I:new Uint32Array(I)}e.toUint32Array=w}),define(W[24],p([0,1,25,12,37,7,23,38]),function(F,e,E,y,w,I,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(i,s,T){const b=new Uint32Array(i.buffer),o=(0,y.readUInt32BE)(i,s);s+=4;const u=(0,y.readUInt32BE)(i,s);s+=4;const f=[];for(let O=0;O<u;O++){const C=(0,y.readUInt32BE)(i,s);s+=4,f.push(b.subarray(s/4,s/4+C/4)),s+=C}return T.push(new t(o,f)),s}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(i,s){this.a=i,this.b=s}getLineRange(){return new h.LineRange(this.a,this.a+this.b.length)}getLineTokens(i){return this.b[i-this.a]}appendLineTokens(i){this.b.push(i)}serializeSize(){let i=0;i+=4,i+=4;for(let s=0;s<this.b.length;s++){const T=this.b[s];if(!(T instanceof Uint32Array))throw new Error("Not supported!");i+=4,i+=T.byteLength}return i}serialize(i,s){(0,y.writeUInt32BE)(i,this.a,s),s+=4,(0,y.writeUInt32BE)(i,this.b.length,s),s+=4;for(let T=0;T<this.b.length;T++){const b=this.b[T];if(!(b instanceof Uint32Array))throw new Error("Not supported!");(0,y.writeUInt32BE)(i,b.byteLength,s),s+=4,i.set(new Uint8Array(b.buffer),s),s+=b.byteLength}return s}applyEdit(i,s){const[T,b]=(0,I.countEOL)(s);this.c(i),this.d(new w.Position(i.startLineNumber,i.startColumn),T,b)}c(i){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return;const s=i.startLineNumber-this.a,T=i.endLineNumber-this.a;if(T<0){const b=T-s;this.a-=b;return}if(!(s>=this.b.length)){if(s<0&&T>=this.b.length){this.a=0,this.b=[];return}if(s===T){this.b[s]=n.ContiguousTokensEditing.delete(this.b[s],i.startColumn-1,i.endColumn-1);return}if(s>=0)if(this.b[s]=n.ContiguousTokensEditing.deleteEnding(this.b[s],i.startColumn-1),T<this.b.length){const b=n.ContiguousTokensEditing.deleteBeginning(this.b[T],i.endColumn-1);this.b[s]=n.ContiguousTokensEditing.append(this.b[s],b),this.b.splice(s+1,T-s)}else this.b[s]=n.ContiguousTokensEditing.append(this.b[s],null),this.b=this.b.slice(0,s+1);else{const b=-s;this.a-=b,this.b[T]=n.ContiguousTokensEditing.deleteBeginning(this.b[T],i.endColumn-1),this.b=this.b.slice(T)}}}d(i,s,T){if(s===0&&T===0)return;const b=i.lineNumber-this.a;if(b<0){this.a+=s;return}if(!(b>=this.b.length)){if(s===0){this.b[b]=n.ContiguousTokensEditing.insert(this.b[b],i.column-1,T);return}this.b[b]=n.ContiguousTokensEditing.deleteEnding(this.b[b],i.column-1),this.b[b]=n.ContiguousTokensEditing.insert(this.b[b],i.column-1,T),this.e(i.lineNumber,s)}}e(i,s){if(s===0)return;const T=[];for(let b=0;b<s;b++)T[b]=null;this.b=E.arrayInsert(this.b,i,T)}}e.ContiguousMultilineTokens=t}),define(W[14],p([0,1,12,24]),function(F,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class w{static deserialize(n){let h=0;const t=(0,E.readUInt32BE)(n,h);h+=4;const r=[];for(let i=0;i<t;i++)h=y.ContiguousMultilineTokens.deserialize(n,h,r);return r}constructor(){this.a=[]}add(n,h){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(h);return}}this.a.push(new y.ContiguousMultilineTokens(n,[h]))}finalize(){return this.a}serialize(){const n=this.b(),h=new Uint8Array(n);return this.c(h),h}b(){let n=0;n+=4;for(let h=0;h<this.a.length;h++)n+=this.a[h].serializeSize();return n}c(n){let h=0;(0,E.writeUInt32BE)(n,this.a.length,h),h+=4;for(let t=0;t<this.a.length;t++)h=this.a[t].serialize(n,h)}}e.ContiguousMultilineTokensBuilder=w}),define(W[26],p([0,1,27,4,28,39]),function(F,e,E,y,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(g){return g===47||g===92}e.isPathSeparator=n;function h(g){return g.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=h;function t(g){return g.indexOf("/")===-1&&(g=h(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.toPosixPath=t;function r(g,d=E.posix.sep){if(!g)return"";const c=g.length,P=g.charCodeAt(0);if(n(P)){if(n(g.charCodeAt(1))&&!n(g.charCodeAt(2))){let D=3;const q=D;for(;D<c&&!n(g.charCodeAt(D));D++);if(q!==D&&!n(g.charCodeAt(D+1))){for(D+=1;D<c;D++)if(n(g.charCodeAt(D)))return g.slice(0,D+1).replace(/[\\/]/g,d)}}return d}else if(O(P)&&g.charCodeAt(1)===58)return n(g.charCodeAt(2))?g.slice(0,2)+d:g.slice(0,2);let B=g.indexOf("://");if(B!==-1){for(B+=3;B<c;B++)if(n(g.charCodeAt(B)))return g.slice(0,B+1)}return""}e.getRoot=r;function i(g){if(!y.isWindows||!g||g.length<5)return!1;let d=g.charCodeAt(0);if(d!==92||(d=g.charCodeAt(1),d!==92))return!1;let c=2;const P=c;for(;c<g.length&&(d=g.charCodeAt(c),d!==92);c++);return!(P===c||(d=g.charCodeAt(c+1),isNaN(d)||d===92))}e.isUNC=i;const s=/[\\/:\*\?"<>\|]/g,T=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(g,d=y.isWindows){const c=d?s:T;return!(!g||g.length===0||/^\s+$/.test(g)||(c.lastIndex=0,c.test(g))||d&&b.test(g)||g==="."||g===".."||d&&g[g.length-1]==="."||d&&g.length!==g.trim().length||g.length>255)}e.isValidBasename=o;function u(g,d,c){const P=g===d;return!c||P?P:!g||!d?!1:(0,w.equalsIgnoreCase)(g,d)}e.isEqual=u;function f(g,d,c,P=E.sep){if(g===d)return!0;if(!g||!d||d.length>g.length)return!1;if(c){if(!(0,w.startsWithIgnoreCase)(g,d))return!1;if(d.length===g.length)return!0;let D=d.length;return d.charAt(d.length-1)===P&&D--,g.charAt(D)===P}return d.charAt(d.length-1)!==P&&(d+=P),g.indexOf(d)===0}e.isEqualOrParent=f;function O(g){return g>=65&&g<=90||g>=97&&g<=122}e.isWindowsDriveLetter=O;function C(g,d){return y.isWindows&&g.endsWith(":")&&(g+=E.sep),(0,E.isAbsolute)(g)||(g=(0,E.join)(d,g)),g=(0,E.normalize)(g),y.isWindows?(g=(0,w.rtrim)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,w.rtrim)(g,E.sep),g||(g=E.sep)),g}e.sanitizeFilePath=C;function z(g){const d=(0,E.normalize)(g);return y.isWindows?g.length>3?!1:U(d)&&(g.length===2||d.charCodeAt(2)===92):d===E.posix.sep}e.isRootOrDriveLetter=z;function U(g,d=y.isWindows){return d?O(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.hasDriveLetter=U;function l(g){return U(g)?g[0]:void 0}e.getDriveLetter=l;function m(g,d,c){return d.length>g.length?-1:g===d?0:(c&&(g=g.toLowerCase(),d=d.toLowerCase()),g.indexOf(d))}e.indexOfPath=m;function v(g){const d=g.split(":");let c,P,B;for(const D of d){const q=Number(D);(0,I.isNumber)(q)?P===void 0?P=q:B===void 0&&(B=q):c=c?[c,D].join(":"):D}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:P!==void 0?P:void 0,column:B!==void 0?B:P!==void 0?1:void 0}}e.parseLineAndColumnAware=v;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",A="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(g,d,c=8){let P="";for(let D=0;D<c;D++){let q;D===0&&y.isWindows&&!d&&(c===3||c===4)?q=A:q=k,P+=q.charAt(Math.floor(Math.random()*q.length))}let B;return d?B=`${d}-${P}`:B=P,g?(0,E.join)(g,B):B}e.randomPath=M}),define(W[29],p([0,1,6,4,15]),function(F,e,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractive="vscode-interactive",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(i){this.d=i}setDelegate(i){this.e=i}setServerRootPath(i){this.f=`${i}/${I.vscodeRemoteResource}`}set(i,s,T){this.a[i]=s,this.b[i]=T}setConnectionToken(i,s){this.c[i]=s}getPreferredWebSchema(){return this.d}rewrite(i){if(this.e)try{return this.e(i)}catch(f){return E.onUnexpectedError(f),i}const s=i.authority;let T=this.a[s];T&&T.indexOf(":")!==-1&&T.indexOf("[")===-1&&(T=`[${T}]`);const b=this.b[s],o=this.c[s];let u=`path=${encodeURIComponent(i.path)}`;return typeof o=="string"&&(u+=`&${e.connectionTokenQueryName}=${encodeURIComponent(o)}`),w.URI.from({scheme:y.isWeb?this.d:I.vscodeRemoteResource,authority:`${T}:${b}`,path:this.f,query:u})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class h{asBrowserUri(i){const s=this.b(i,F);return this.uriToBrowserUri(s)}uriToBrowserUri(i){return i.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===I.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${I.vscodeFileResource}://${h.a}`)?i.with({scheme:I.vscodeFileResource,authority:i.authority||h.a,query:null,fragment:null}):i}asFileUri(i){const s=this.b(i,F);return this.uriToFileUri(s)}uriToFileUri(i){return i.scheme===I.vscodeFileResource?i.with({scheme:I.file,authority:i.authority!==h.a?i.authority:null,query:null,fragment:null}):i}b(i,s){return w.URI.isUri(i)?i:w.URI.parse(s.toUrl(i))}}h.a="vscode-app",e.FileAccess=new h;var t;(function(r){const i=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(i.get("3"));const s="vscode-coi";function T(o){let u;typeof o=="string"?u=new URL(o).searchParams:o instanceof URL?u=o.searchParams:w.URI.isUri(o)&&(u=new URL(o.toString(!0)).searchParams);const f=u?.get(s);if(!!f)return i.get(f)}r.getHeadersFromQuery=T;function b(o,u,f){if(!globalThis.crossOriginIsolated)return;const O=u&&f?"3":f?"2":"1";o instanceof URLSearchParams?o.set(s,O):o[s]=O}r.addSearchParam=b})(t=e.COI||(e.COI={}))}),define(W[16],p([0,1,26,29,27,4,28,15]),function(F,e,E,y,w,I,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(b){return(0,h.uriToFsPath)(b,!0)}e.originalFSPath=t;class r{constructor(o){this.a=o}compare(o,u,f=!1){return o===u?0:(0,n.compare)(this.getComparisonKey(o,f),this.getComparisonKey(u,f))}isEqual(o,u,f=!1){return o===u?!0:!o||!u?!1:this.getComparisonKey(o,f)===this.getComparisonKey(u,f)}getComparisonKey(o,u=!1){return o.with({path:this.a(o)?o.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(o){return this.a(o)}isEqualOrParent(o,u,f=!1){if(o.scheme===u.scheme){if(o.scheme===y.Schemas.file)return E.isEqualOrParent(t(o),t(u),this.a(o))&&o.query===u.query&&(f||o.fragment===u.fragment);if((0,e.isEqualAuthority)(o.authority,u.authority))return E.isEqualOrParent(o.path,u.path,this.a(o),"/")&&o.query===u.query&&(f||o.fragment===u.fragment)}return!1}joinPath(o,...u){return h.URI.joinPath(o,...u)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let u;return o.scheme===y.Schemas.file?u=h.URI.file(w.dirname(t(o))).path:(u=w.posix.dirname(o.path),o.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),u="/")),o.with({path:u})}normalizePath(o){if(!o.path.length)return o;let u;return o.scheme===y.Schemas.file?u=h.URI.file(w.normalize(t(o))).path:u=w.posix.normalize(o.path),o.with({path:u})}relativePath(o,u){if(o.scheme!==u.scheme||!(0,e.isEqualAuthority)(o.authority,u.authority))return;if(o.scheme===y.Schemas.file){const C=w.relative(t(o),t(u));return I.isWindows?E.toSlashes(C):C}let f=o.path||"/";const O=u.path||"/";if(this.a(o)){let C=0;for(const z=Math.min(f.length,O.length);C<z&&!(f.charCodeAt(C)!==O.charCodeAt(C)&&f.charAt(C).toLowerCase()!==O.charAt(C).toLowerCase());C++);f=O.substr(0,C)+f.substr(C)}return w.posix.relative(f,O)}resolvePath(o,u){if(o.scheme===y.Schemas.file){const f=h.URI.file(w.resolve(t(o),u));return o.with({authority:f.authority,path:f.path})}return u=E.toPosixPath(u),o.with({path:w.posix.resolve(o.path,u)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,u){return o===u||o!==void 0&&u!==void 0&&(0,n.equalsIgnoreCase)(o,u)}hasTrailingPathSeparator(o,u=w.sep){if(o.scheme===y.Schemas.file){const f=t(o);return f.length>E.getRoot(f).length&&f[f.length-1]===u}else{const f=o.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,u=w.sep){return(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,u=w.sep){let f=!1;if(o.scheme===y.Schemas.file){const O=t(o);f=O!==void 0&&O.length===E.getRoot(O).length&&O[O.length-1]===u}else{u="/";const O=o.path;f=O.length===1&&O.charCodeAt(O.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path+"/"}):o}}e.ExtUri=r,e.extUri=new r(()=>!1),e.extUriBiasedIgnorePathCase=new r(b=>b.scheme===y.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new r(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(b,o){const u=[];for(let f=0;f<b.length;f++){const O=o(b[f]);b.some((C,z)=>z===f?!1:(0,e.isEqualOrParent)(O,o(C)))||u.push(b[f])}return u}e.distinctParents=i;var s;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function o(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(z=>{const[U,l]=z.split(":");U&&l&&f.set(U,l)});const C=u.path.substring(0,u.path.indexOf(";"));return C&&f.set(b.META_DATA_MIME,C),f}b.parseMetaData=o})(s=e.DataUri||(e.DataUri={}));function T(b,o,u){if(o){let f=b.path;return f&&f[0]!==w.posix.sep&&(f=w.posix.sep+f),b.with({scheme:u,authority:o,path:f})}return b.with({scheme:u})}e.toLocalResource=T}),define(W[17],p([0,1,40,6,30,2,16,4,22]),function(F,e,E,y,w,I,n,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(N){return!!N&&typeof N.then=="function"}e.isThenable=r;function i(N){const a=new E.CancellationTokenSource,S=N(a.token),L=new Promise((R,j)=>{const $=a.token.onCancellationRequested(()=>{$.dispose(),a.dispose(),j(new y.CancellationError)});Promise.resolve(S).then(H=>{$.dispose(),a.dispose(),R(H)},H=>{$.dispose(),a.dispose(),j(H)})});return new class{cancel(){a.cancel()}then(R,j){return L.then(R,j)}catch(R){return this.then(void 0,R)}finally(R){return L.finally(R)}}}e.createCancelablePromise=i;function s(N,a,S){return new Promise((L,R)=>{const j=a.onCancellationRequested(()=>{j.dispose(),L(S)});N.then(L,R).finally(()=>j.dispose())})}e.raceCancellation=s;function T(N,a){return new Promise((S,L)=>{const R=a.onCancellationRequested(()=>{R.dispose(),L(new y.CancellationError)});N.then(S,L).finally(()=>R.dispose())})}e.raceCancellationError=T;async function b(N){let a=-1;const S=N.map((R,j)=>R.then($=>(a=j,$))),L=await Promise.race(S);return N.forEach((R,j)=>{j!==a&&R.cancel()}),L}e.raceCancellablePromises=b;function o(N,a,S){let L;const R=setTimeout(()=>{L?.(void 0),S?.()},a);return Promise.race([N.finally(()=>clearTimeout(R)),new Promise(j=>L=j)])}e.raceTimeout=o;function u(N){return new Promise((a,S)=>{const L=N();r(L)?L.then(a,S):a(L)})}e.asPromise=u;class f{constructor(){this.a=null,this.b=null,this.d=null}queue(a){if(this.a){if(this.d=a,!this.b){const S=()=>{this.b=null;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(S,S).then(L)})}return new Promise((S,L)=>{this.b.then(S,L)})}return this.a=a(),new Promise((S,L)=>{this.a.then(R=>{this.a=null,S(R)},R=>{this.a=null,L(R)})})}}e.Throttler=f;class O{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}e.Sequencer=O;class C{constructor(){this.a=new Map}queue(a,S){const R=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.a.get(a)===R&&this.a.delete(a)});return this.a.set(a,R),R}}e.SequencerByKey=C;const z=(N,a)=>{let S=!0;const L=setTimeout(()=>{S=!1,a()},N);return{isTriggered:()=>S,dispose:()=>{clearTimeout(L),S=!1}}},U=N=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,N())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class l{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,S=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((R,j)=>{this.d=R,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=S===t.MicrotaskDelay?U(L):z(S,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new y.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=l;class m{constructor(a){this.a=new l(a),this.b=new f}trigger(a,S){return this.a.trigger(()=>this.b.queue(a),S)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=m;class v{constructor(){this.a=!1,this.b=new Promise((a,S)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=v;class k extends v{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=k;function A(N,a){return a?new Promise((S,L)=>{const R=setTimeout(()=>{j.dispose(),S()},N),j=a.onCancellationRequested(()=>{clearTimeout(R),j.dispose(),L(new y.CancellationError)})}):i(S=>A(N,S))}e.timeout=A;function M(N,a=0){const S=setTimeout(N,a);return(0,I.toDisposable)(()=>clearTimeout(S))}e.disposableTimeout=M;function g(N){const a=[];let S=0;const L=N.length;function R(){return S<L?N[S++]():null}function j($){$!=null&&a.push($);const H=R();return H?H.then(j):Promise.resolve(a)}return Promise.resolve(null).then(j)}e.sequence=g;function d(N,a=L=>!!L,S=null){let L=0;const R=N.length,j=()=>{if(L>=R)return Promise.resolve(S);const $=N[L++];return Promise.resolve($()).then(Y=>a(Y)?Promise.resolve(Y):j())};return j()}e.first=d;function c(N,a=L=>!!L,S=null){if(N.length===0)return Promise.resolve(S);let L=N.length;const R=()=>{L=-1;for(const j of N)j.cancel?.()};return new Promise((j,$)=>{for(const H of N)H.then(Y=>{--L>=0&&a(Y)?(R(),j(Y)):L===0&&j(S)}).catch(Y=>{--L>=0&&(R(),$(Y))})})}e.firstParallel=c;class P{constructor(a){this.a=0,this.d=a,this.f=[],this.b=0,this.g=new w.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(a){return this.a++,new Promise((S,L)=>{this.f.push({factory:a,c:S,e:L}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const a=this.f.shift();this.b++;const S=a.factory();S.then(a.c,a.e),S.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=P;class B extends P{constructor(){super(1)}}e.Queue=B;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const a=new Z;return this.b.add(a),a.p}d(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueFor(a,S=n.extUri){const L=S.getComparisonKey(a);let R=this.a.get(L);return R||(R=new B,w.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(L),this.f()}),this.a.set(L,R)),R}f(){!this.d()||this.g()}g(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.g()}}e.ResourceQueue=D;class q{constructor(a,S){this.a=-1,typeof a=="function"&&typeof S=="number"&&this.setIfNotSet(a,S)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,S){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},S)}setIfNotSet(a,S){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},S))}}e.TimeoutTimer=q;class _{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(a,S){this.cancel(),this.a=setInterval(()=>{a()},S)}}e.IntervalTimer=_;class K{constructor(a,S){this.b=-1,this.a=a,this.d=S,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class G{constructor(a,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.a=a,this.b=S,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class Q extends K{constructor(a,S){super(a,S),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Q;class te extends I.Disposable{constructor(a,S){super(),this.g=a,this.h=S,this.a=[],this.b=this.B(new I.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const S of a)this.a.push(S);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=te,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{(0,h.setTimeout0)(()=>{if(a)return;const S=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let a=!1;return{dispose(){a||(a=!0)}}}:e.runWhenIdle=(N,a)=>{const S=requestIdleCallback(N,typeof a=="number"?{timeout:a}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(S))}}}}();class ne{constructor(a){this.d=!1,this.a=()=>{try{this.f=a()}catch(S){this.g=S}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ne;async function ie(N,a,S){let L;for(let R=0;R<S;R++)try{return await N()}catch(j){L=j,await A(a)}throw L}e.retry=ie;class re{hasPending(a){return this.a?typeof a=="number"?this.a.taskId===a:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(a,S,L){return this.a={taskId:a,cancel:()=>L?.(),promise:S},S.then(()=>this.d(a),()=>this.d(a)),S}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}setNext(a){if(this.b)this.b.run=a;else{let S,L;const R=new Promise((j,$)=>{S=j,L=$});this.b={run:a,promise:R,promiseResolve:S,promiseReject:L}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=re;class se{constructor(a,S=()=>Date.now()){this.d=a,this.f=S,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}e.IntervalCounter=se;class Z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((a,S)=>{this.a=a,this.b=S})}complete(a){return new Promise(S=>{this.a(a),this.f=!0,S()})}error(a){return new Promise(S=>{this.b(a),this.d=!0,S()})}cancel(){new Promise(a=>{this.b(new y.CancellationError),this.d=!0,a()})}}e.DeferredPromise=Z;var ae;(function(N){async function a(L){let R;const j=await Promise.all(L.map($=>$.then(H=>H,H=>{R||(R=H)})));if(typeof R<"u")throw R;return j}N.settled=a;function S(L){return new Promise(async(R,j)=>{try{await L(R,j)}catch($){j($)}})}N.withAsyncBody=S})(ae=e.Promises||(e.Promises={}));var X;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(X||(X={}));class V{static fromArray(a){return new V(S=>{S.emitMany(a)})}static fromPromise(a){return new V(async S=>{S.emitMany(await a)})}static fromPromises(a){return new V(async S=>{await Promise.all(a.map(async L=>S.emitOne(await L)))})}static merge(a){return new V(async S=>{await Promise.all(a.map(async L=>{for await(const R of L)S.emitOne(R)}))})}constructor(a){this.a=0,this.b=[],this.d=null,this.f=new w.Emitter,queueMicrotask(async()=>{const S={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(a(S)),this.j()}catch(L){this.k(L)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await w.Event.toPromise(this.f.event)}while(!0)}}}static map(a,S){return new V(async L=>{for await(const R of a)L.emitOne(S(R))})}map(a){return V.map(this,a)}static filter(a,S){return new V(async L=>{for await(const R of a)S(R)&&L.emitOne(R)})}filter(a){return V.filter(this,a)}static coalesce(a){return V.filter(a,S=>!!S)}coalesce(){return V.coalesce(this)}static async toPromise(a){const S=[];for await(const L of a)S.push(L);return S}toPromise(){return V.toPromise(this)}g(a){this.a===0&&(this.b.push(a),this.f.fire())}h(a){this.a===0&&(this.b=this.b.concat(a),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(a){this.a===0&&(this.a=2,this.d=a,this.f.fire())}}V.EMPTY=V.fromArray([]),e.AsyncIterableObject=V;class J extends V{constructor(a,S){super(S),this.l=a}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=J;function oe(N){const a=new E.CancellationTokenSource,S=N(a.token);return new J(a,async L=>{const R=a.token.onCancellationRequested(()=>{R.dispose(),a.dispose(),L.reject(new y.CancellationError)});try{for await(const j of S){if(a.token.isCancellationRequested)return;L.emitOne(j)}R.dispose(),a.dispose()}catch(j){R.dispose(),a.dispose(),L.reject(j)}})}e.createCancelableAsyncIterable=oe}),define(W[18],p([0,1,19]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(I){return this===I}};function y(I,n){return new E.TokenizationResult([new E.Token(0,"",I)],n)}e.nullTokenize=y;function w(I,n){const h=new Uint32Array(2);return h[0]=0,h[1]=(I<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new E.EncodedTokenizationResult(h,n===null?e.NullState:n)}e.nullTokenizeEncoded=w}),define(W[31],p([0,1,25,17,6,2,4,41,7,19,18,14,8]),function(F,e,E,y,w,I,n,h,t,r,i,s,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextModelTokenization=e.TokenizationStateStore=e.ContiguousGrowingArray=void 0;var b;(function(U){U[U.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(b||(b={}));class o{constructor(l){this.c=l,this.a=[]}get(l){return l<this.a.length?this.a[l]:this.c}set(l,m){for(;l>=this.a.length;)this.a[this.a.length]=this.c;this.a[l]=m}delete(l,m){m===0||l>=this.a.length||this.a.splice(l,m)}insert(l,m){if(m===0||l>=this.a.length)return;const v=[];for(let k=0;k<m;k++)v[k]=this.c;this.a=E.arrayInsert(this.a,l,v)}}e.ContiguousGrowingArray=o;class u{get invalidLineStartIndex(){return this.d}constructor(l,m){this.tokenizationSupport=l,this.initialState=m,this.a=new o(null),this.c=new o(!0),this.d=0,this.a.set(0,this.initialState)}markMustBeTokenized(l){this.c.set(l,!0),this.d=Math.min(this.d,l)}getBeginState(l){return this.a.get(l)}setEndState(l,m,v){this.c.set(m,!1),this.d=m+1;const k=this.a.get(m+1);if(k===null||!v.equals(k))return this.a.set(m+1,v),this.markMustBeTokenized(m+1),!0;let A=m+1;for(;A<l&&!this.c.get(A);)A++;return this.d=A,!1}applyEdits(l,m){this.markMustBeTokenized(l.startLineNumber-1),this.a.delete(l.startLineNumber,l.endLineNumber-l.startLineNumber),this.c.delete(l.startLineNumber,l.endLineNumber-l.startLineNumber),this.a.insert(l.startLineNumber,m),this.c.insert(l.startLineNumber,m)}updateTokensUntilLine(l,m,v,k){const A=l.getLanguageId(),M=l.getLineCount(),g=k-1;for(let d=this.invalidLineStartIndex;d<=g;d++){const c=l.getLineContent(d+1),P=this.getBeginState(d),B=C(m,A,this.tokenizationSupport,c,!0,P);v.add(d+1,B.tokens),this.setEndState(M,d,B.endState),d=this.invalidLineStartIndex-1}}isTokenizationComplete(l){return this.invalidLineStartIndex>=l.getLineCount()}}e.TokenizationStateStore=u;class f extends I.Disposable{constructor(l,m,v){super(),this.g=l,this.h=m,this.j=v,this.a=null,this.c=null,this.f=this.B(new I.MutableDisposable),this.B(r.TokenizationRegistry.onDidChange(k=>{const A=this.g.getLanguageId();k.changedLanguages.indexOf(A)!==-1&&(this.k(),this.h.clearTokens())})),this.k()}handleDidChangeContent(l){if(l.isFlush){this.k();return}if(this.a)for(let m=0,v=l.changes.length;m<v;m++){const k=l.changes[m],[A]=(0,t.countEOL)(k.text);this.a.applyEdits(k.range,A)}this.c?.handleChanges()}handleDidChangeAttached(){this.c?.handleChanges()}handleDidChangeLanguage(l){this.k(),this.h.clearTokens()}k(){const[l,m]=O(this.g,this.h);if(l&&m?this.a=new u(l,m):this.a=null,this.f.clear(),this.c=null,this.a){const v={setTokens:k=>{this.h.setTokens(k)},backgroundTokenizationFinished:()=>{this.h.handleBackgroundTokenizationFinished()},setEndState:(k,A)=>{if(!A)throw new w.BugIndicatingError;const M=this.a?.invalidLineStartIndex;M!==void 0&&k-1>=M&&this.a?.setEndState(this.g.getLineCount(),k-1,A)}};l&&l.createBackgroundTokenizer&&(this.f.value=l.createBackgroundTokenizer(this.g,v)),this.f.value||(this.f.value=this.c=new z(this.g,this.a,v,this.j),this.c.handleChanges())}}tokenizeViewport(l,m){const v=new s.ContiguousMultilineTokensBuilder;this.l(v,l,m),this.h.setTokens(v.finalize()),this.c?.checkFinished()}reset(){this.k(),this.h.clearTokens()}forceTokenization(l){const m=new s.ContiguousMultilineTokensBuilder;this.a?.updateTokensUntilLine(this.g,this.j,m,l),this.h.setTokens(m.finalize()),this.c?.checkFinished()}getTokenTypeIfInsertingCharacter(l,m){if(!this.a)return 0;this.forceTokenization(l.lineNumber);const v=this.a.getBeginState(l.lineNumber-1);if(!v)return 0;const k=this.g.getLanguageId(),A=this.g.getLineContent(l.lineNumber),M=A.substring(0,l.column-1)+m+A.substring(l.column-1),g=C(this.j,k,this.a.tokenizationSupport,M,!0,v),d=new T.LineTokens(g.tokens,M,this.j);if(d.getCount()===0)return 0;const c=d.findTokenIndexAtOffset(l.column-1);return d.getStandardTokenType(c)}tokenizeLineWithEdit(l,m,v){const k=l.lineNumber,A=l.column;if(!this.a)return null;this.forceTokenization(k);const M=this.a.getBeginState(k-1);if(!M)return null;const g=this.g.getLineContent(k),d=g.substring(0,A-1)+v+g.substring(A-1+m),c=this.g.getLanguageIdAtPosition(k,0),P=C(this.j,c,this.a.tokenizationSupport,d,!0,M);return new T.LineTokens(P.tokens,d,this.j)}isCheapToTokenize(l){if(!this.a)return!0;const m=this.a.invalidLineStartIndex+1;return l>m?!1:l<m||this.g.getLineLength(l)<2048}l(l,m,v){if(!this.a||v<=this.a.invalidLineStartIndex)return;if(m<=this.a.invalidLineStartIndex){this.a.updateTokensUntilLine(this.g,this.j,l,v);return}let k=this.m(m);const A=this.g.getLanguageId();for(let M=m;M<=v;M++){const g=this.g.getLineContent(M),d=C(this.j,A,this.a.tokenizationSupport,g,!0,k);l.add(M,d.tokens),k=d.endState}this.f.value?.requestTokens(m,v+1)}m(l){let m=this.g.getLineFirstNonWhitespaceColumn(l);const v=[];let k=null;for(let g=l-1;m>1&&g>=1;g--){const d=this.g.getLineFirstNonWhitespaceColumn(g);if(d!==0&&d<m&&(v.push(this.g.getLineContent(g)),m=d,k=this.a.getBeginState(g-1),k))break}k||(k=this.a.initialState),v.reverse();const A=this.g.getLanguageId();let M=k;for(const g of v)M=C(this.j,A,this.a.tokenizationSupport,g,!1,M).endState;return M}}e.TextModelTokenization=f;function O(U,l){if(U.isTooLargeForTokenization())return[null,null];const m=r.TokenizationRegistry.get(l.getLanguageId());if(!m)return[null,null];let v;try{v=m.getInitialState()}catch(k){return(0,w.onUnexpectedError)(k),[null,null]}return[m,v]}function C(U,l,m,v,k,A){let M=null;if(m)try{M=m.tokenizeEncoded(v,k,A.clone())}catch(g){(0,w.onUnexpectedError)(g)}return M||(M=(0,i.nullTokenizeEncoded)(U.encodeLanguageId(l),A)),T.LineTokens.convertToEndOffset(M.tokens,v.length),M}class z{constructor(l,m,v,k){this.c=l,this.d=m,this.f=v,this.g=k,this.a=!1,this.h=!1}dispose(){this.a=!0}handleChanges(){this.j()}j(){this.h||!this.c.isAttachedToEditor()||!this.m()||(this.h=!0,(0,y.runWhenIdle)(l=>{this.h=!1,this.k(l)}))}k(l){const m=Date.now()+l.timeRemaining(),v=()=>{this.a||!this.c.isAttachedToEditor()||!this.m()||(this.l(),Date.now()<m?(0,n.setTimeout0)(v):this.j())};v()}l(){const l=this.c.getLineCount(),m=new s.ContiguousMultilineTokensBuilder,v=h.StopWatch.create(!1);do if(v.elapsed()>1||this.n(m)>=l)break;while(this.m());this.f.setTokens(m.finalize()),this.checkFinished()}m(){return this.d?this.d.invalidLineStartIndex<this.c.getLineCount():!1}n(l){if(!this.d||!this.m())return this.c.getLineCount()+1;const m=this.d.invalidLineStartIndex+1;return this.d.updateTokensUntilLine(this.c,this.g,l,m),m}checkFinished(){this.a||this.d.isTokenizationComplete(this.c)&&this.f.backgroundTokenizationFinished()}requestTokens(l,m){for(let v=l;v<m;v++)this.d.markMustBeTokenized(v-1)}}}),define(W[32],p([0,1,30,2,13,19]),function(F,e,E,y,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class n extends y.Disposable{constructor(t,r,i,s){super(),this.c=t,this.f=r,this.g=i,this.h=s,this.a=[],this.b=this.B(new E.Emitter),this.onDidEncounterLanguage=this.b.event}getInitialState(){return this.f}tokenize(t,r,i){throw new Error("Not supported!")}createBackgroundTokenizer(t,r){if(this.h)return this.h(t,r)}tokenizeEncoded(t,r,i){const s=this.c.tokenizeLine2(t,i,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new I.EncodedTokenizationResult(s.tokens,i);if(this.g){const b=this.a,o=s.tokens;for(let u=0,f=o.length>>>1;u<f;u++){const O=o[(u<<1)+1],C=w.TokenMetadata.getLanguageId(O);b[C]||(b[C]=!0,this.b.fire(C))}}let T;return i.equals(s.ruleStack)?T=i:T=s.ruleStack,new I.EncodedTokenizationResult(s.tokens,T)}}e.TextMateTokenizationSupport=n}),define(W[33],p([0,1,18,2,11]),function(F,e,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class I extends y.Disposable{constructor(h,t,r){super(),this.a=h,this.b=t,this.c=r,this.B((0,w.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(h,t,r){throw new Error("Not supported!")}tokenizeEncoded(h,t,r){return h.length>=this.c.get()?(0,E.nullTokenizeEncoded)(this.a,r):this.b.tokenizeEncoded(h,t,r)}createBackgroundTokenizer(h,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(h,t)}}e.TokenizationSupportWithLineLimit=I}),define(W[34],p([0,1,16]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class y{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(I){if(this.a[I.scopeName]){const n=this.a[I.scopeName];E.isEqual(n.location,I.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${I.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${I.location.toString()}`)}this.a[I.scopeName]=I}getGrammarDefinition(I){return this.a[I]||null}}e.TMScopeRegistry=y}),define(W[35],p([0,1,2,34]),function(F,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class w extends E.Disposable{constructor(n,h,t,r){super(),this.a=n,this.b=t.INITIAL,this.c=new y.TMScopeRegistry,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async i=>{const s=this.c.getGrammarDefinition(i);if(!s)return this.a.logTrace(`No grammar found for scope ${i}`),null;const T=s.location;try{const b=await this.a.readFile(T);return t.parseRawGrammar(b,T.path)}catch(b){return this.a.logError(`Unable to load and parse grammar for scope ${i} from ${T}`,b),null}},getInjections:i=>{const s=i.split(".");let T=[];for(let b=1;b<=s.length;b++){const o=s.slice(0,b).join(".");T=[...T,...this.f[o]||[]]}return T}}));for(const i of h){if(this.c.register(i),i.injectTo){for(const s of i.injectTo){let T=this.f[s];T||(this.f[s]=T=[]),T.push(i.scopeName)}if(i.embeddedLanguages)for(const s of i.injectTo){let T=this.g[s];T||(this.g[s]=T=[]),T.push(i.embeddedLanguages)}}i.language&&this.h.set(i.language,i.scopeName)}}has(n){return this.h.has(n)}setTheme(n,h){this.j.setTheme(n,h)}getColorMap(){return this.j.getColorMap()}async createGrammar(n,h){const t=this.h.get(n);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.missingTMGrammarErrorMessage);const i=r.embeddedLanguages;if(this.g[t]){const b=this.g[t];for(const o of b)for(const u of Object.keys(o))i[u]=o[u]}const s=Object.keys(i).length>0;let T;try{T=await this.j.loadGrammarWithConfiguration(t,h,{embeddedLanguages:i,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(b){throw b.message&&b.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):b}return{languageId:n,grammar:T,initialState:this.b,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=w}),define(W[36],p([0,1,42,31,43,14,7,8,32,17,11,33]),function(F,e,E,y,w,I,n,h,t,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class T extends E.MirrorTextModel{constructor(u,f,O,C,z,U,l,m){super(u,f,O,C),this.s=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.t=new r.RunOnceScheduler(()=>this.v(),10),this.a=null,this.b=z,this.c=U,this.m=l,this.q=!1,this.s.set(m,void 0),this.u()}dispose(){this.q=!0,super.dispose()}onLanguageId(u,f){this.c=u,this.m=f,this.u()}onEvents(u){if(super.onEvents(u),this.a)for(let f=0;f<u.changes.length;f++){const O=u.changes[f],[C]=(0,n.countEOL)(O.text);this.a.applyEdits(O.range,C)}this.t.schedule()}acceptMaxTokenizationLineLength(u){this.s.set(u,void 0)}retokenize(u,f){if(this.a){for(let O=u;O<f;O++)this.a.markMustBeTokenized(O-1);this.t.schedule()}}u(){this.a=null;const u=this.c,f=this.m;this.b.getOrCreateGrammar(u,f).then(O=>{if(!(this.q||u!==this.c||f!==this.m||!O)){if(O.grammar){const C=new s.TokenizationSupportWithLineLimit(this.m,new t.TextMateTokenizationSupport(O.grammar,O.initialState,!1),this.s);this.a=new y.TokenizationStateStore(C,C.getInitialState())}else this.a=null;this.v()}})}v(){if(this.q||!this.a)return;const u=new Date().getTime();for(;;){const f=new I.ContiguousMultilineTokensBuilder,O=this.f.length;let C=0;const z=new b;for(;this.a.invalidLineStartIndex<O;){const m=this.a.invalidLineStartIndex;if(C++,C>200)break;const v=this.f[m],k=this.a.getBeginState(m),A=this.a.tokenizationSupport.tokenizeEncoded(v,!0,k);if(this.a.setEndState(O,m,A.endState)){const g=(0,w.diffStateStacksRefEq)(k,A.endState);z.setState(m+1,g)}else z.setState(m+1,null);if(h.LineTokens.convertToEndOffset(A.tokens,v.length),f.add(m+1,A.tokens),new Date().getTime()-u>20)break}if(C===0)break;const U=z.getStateDeltas();if(this.b.setTokensAndStates(this.d,this.h,f.serialize(),U),new Date().getTime()-u>20){setTimeout(()=>this.v(),3);return}}}}e.TextMateWorkerModel=T;class b{constructor(){this.a=-1,this.b=[]}setState(u,f){u===this.a+1?this.b[this.b.length-1].stateDeltas.push(f):this.b.push({startLineNumber:u,stateDeltas:[f]}),this.a=u}getStateDeltas(){return this.b}}}),define(W[44],p([0,1,15,35,36]),function(F,e,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class I{constructor(t,r){this.f=r,this.b=Object.create(null),this.c=[],this.a=t.host;const i=r.grammarDefinitions.map(s=>({location:E.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this.d=this.g(i)}async g(t){const r=this.f.textmateMainUri,i=await new Promise((u,f)=>{F([r],u,f)}),s=await new Promise((u,f)=>{F([this.f.onigurumaMainUri],u,f)}),b=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(b);const o=Promise.resolve({createOnigScanner:u=>s.createOnigScanner(u),createOnigString:u=>s.createOnigString(u)});return new y.TMGrammarFactory({logTrace:u=>{},logError:(u,f)=>console.error(u,f),readFile:u=>this.a.readFile(u)},t,i,o)}acceptNewModel(t){const r=E.URI.revive(t.uri),i=r.toString();this.b[i]=new w.TextMateWorkerModel(r,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,r){this.b[t].onEvents(r)}retokenize(t,r,i){this.b[t].retokenize(r,i)}acceptModelLanguageChanged(t,r,i){this.b[t].onLanguageId(r,i)}acceptRemovedModel(t){this.b[t]&&(this.b[t].dispose(),delete this.b[t])}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b[t].acceptMaxTokenizationLineLength(r)}async getOrCreateGrammar(t,r){const i=await this.d;return i?(this.c[r]||(this.c[r]=i.createGrammar(t,r)),this.c[r]):Promise.resolve(null)}setTokensAndStates(t,r,i,s){this.a.setTokensAndStates(t,r,i,s)}}e.TextMateTokenizationWorker=I;function n(h,t){return new I(h,t)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
